/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/linesDiffComputer","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/lineRange","vs/editor/common/core/wordHelper","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(q){for(var t=[],P=0,I=q.length;P<I;P++)t[P]=ee[q[P]];return t};const Oe=this,Be=typeof global=="object"?global:{};var he;(function(q){q.global=Oe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=t})(he||(he={}));var he;(function(q){class t{constructor(u,M,_){this.type=u,this.detail=M,this.timestamp=_}}q.LoaderEvent=t;class P{constructor(u){this._events=[new t(1,"",u)]}record(u,M){this._events.push(new t(u,M,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=P;class I{record(u,M){}getEvents(){return[]}}I.INSTANCE=new I,q.NullLoaderEventRecorder=I})(he||(he={}));var he;(function(q){class t{static fileUriToFilePath(I,i){if(i=decodeURI(i).replace(/%23/g,"#"),I){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(I,i){return I.length>=i.length&&I.substr(0,i.length)===i}static endsWith(I,i){return I.length>=i.length&&I.substr(I.length-i.length)===i}static containsQueryString(I){return/^[^\#]*\?/gi.test(I)}static isAbsolutePath(I){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(I)}static forEachProperty(I,i){if(I){let u;for(u in I)I.hasOwnProperty(u)&&i(u,I[u])}}static isEmpty(I){let i=!0;return t.forEachProperty(I,()=>{i=!1}),i}static recursiveClone(I){if(!I||typeof I!="object"||I instanceof RegExp||!Array.isArray(I)&&Object.getPrototypeOf(I)!==Object.prototype)return I;let i=Array.isArray(I)?[]:{};return t.forEachProperty(I,(u,M)=>{M&&typeof M=="object"?i[u]=t.recursiveClone(M):i[u]=M}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(I){return t.startsWith(I,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,q.Utilities=t})(he||(he={}));var he;(function(q){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}q.ensureError=t;class P{static validateConfigurationOptions(u){function M(_){if(_.phase==="loading"){console.error('Loading "'+_.moduleId+'" failed'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}if(_.phase==="factory"){console.error('The factory function of "'+_.moduleId+'" has thrown an exception'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=M),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(q.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const _=t(new Error("INVALID cached data configuration, 'path' MUST be set"));_.phase="configuration",u.onError(_),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,M=null){let _=q.Utilities.recursiveClone(M||{});return q.Utilities.forEachProperty(u,(l,h)=>{l==="ignoreDuplicateModules"&&typeof _.ignoreDuplicateModules<"u"?_.ignoreDuplicateModules=_.ignoreDuplicateModules.concat(h):l==="paths"&&typeof _.paths<"u"?q.Utilities.forEachProperty(h,(p,y)=>_.paths[p]=y):l==="config"&&typeof _.config<"u"?q.Utilities.forEachProperty(h,(p,y)=>_.config[p]=y):_[l]=q.Utilities.recursiveClone(h)}),P.validateConfigurationOptions(_)}}q.ConfigurationOptionsUtil=P;class I{constructor(u,M){if(this._env=u,this.options=P.mergeConfigurationOptions(M),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let _=this.options.nodeRequire.main.filename,l=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(u,M)=>{Array.isArray(M)?this.sortedPathsRules.push({from:u,to:M}):this.sortedPathsRules.push({from:u,to:[M]})}),this.sortedPathsRules.sort((u,M)=>M.from.length-u.from.length)}cloneAndMerge(u){return new I(this._env,P.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let M;for(let _=0,l=this.sortedPathsRules.length;_<l;_++)if(M=this.sortedPathsRules[_],q.Utilities.startsWith(u,M.from)){let h=[];for(let p=0,y=M.to.length;p<y;p++)h.push(M.to[p]+u.substr(M.from.length));return h}return[u]}_addUrlArgsToUrl(u){return q.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let M=0,_=u.length;M<_;M++)u[M]=this._addUrlArgsToUrl(u[M]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let M=u,_;if(!q.Utilities.endsWith(M,".js")&&!q.Utilities.isAbsolutePath(M)){_=this._applyPaths(M);for(let l=0,h=_.length;l<h;l++)this.isBuild()&&_[l]==="empty:"||(q.Utilities.isAbsolutePath(_[l])||(_[l]=this.options.baseUrl+_[l]),!q.Utilities.endsWith(_[l],".js")&&!q.Utilities.containsQueryString(_[l])&&(_[l]=_[l]+".js"))}else!q.Utilities.endsWith(M,".js")&&!q.Utilities.containsQueryString(M)&&(M=M+".js"),_=[M];return this._addUrlArgsIfNecessaryToUrls(_)}requireToUrl(u){let M=u;return q.Utilities.isAbsolutePath(M)||(M=this._applyPaths(M)[0],q.Utilities.isAbsolutePath(M)||(M=this.options.baseUrl+M)),this._addUrlArgsIfNecessaryToUrl(M)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}q.Configuration=I})(he||(he={}));var he;(function(q){class t{constructor(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}load(h,p,y,L){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=h.getConfig().getOptionsLiteral();e?this._scriptLoader=new P:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new P;let m={callback:y,errorback:L};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(m);return}this._callbackMap[p]=[m],this._scriptLoader.load(h,p,()=>this.triggerCallback(p),e=>this.triggerErrorback(p,e))}triggerCallback(h){let p=this._callbackMap[h];delete this._callbackMap[h];for(let y=0;y<p.length;y++)p[y].callback()}triggerErrorback(h,p){let y=this._callbackMap[h];delete this._callbackMap[h];for(let L=0;L<y.length;L++)y[L].errorback(p)}}class P{attachListeners(h,p,y){let L=()=>{h.removeEventListener("load",m),h.removeEventListener("error",e)},m=A=>{L(),p()},e=A=>{L(),y(A)};h.addEventListener("load",m),h.addEventListener("error",e)}load(h,p,y,L){if(/^node\|/.test(p)){let m=h.getConfig().getOptionsLiteral(),e=M(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),A=p.split("|"),D=null;try{D=e(A[1])}catch(R){L(R);return}h.enqueueDefineAnonymousModule([],()=>D),y()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,y,L);const{trustedTypesPolicy:e}=h.getConfig().getOptionsLiteral();e&&(p=e.createScriptURL(p)),m.setAttribute("src",p);const{cspNonce:A}=h.getConfig().getOptionsLiteral();A&&m.setAttribute("nonce",A),document.getElementsByTagName("head")[0].appendChild(m)}}}function I(l){const{trustedTypesPolicy:h}=l.getConfig().getOptionsLiteral();try{return(h?self.eval(h.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=I(h)),this._cachedCanUseEval}load(h,p,y,L){if(/^node\|/.test(p)){const m=h.getConfig().getOptionsLiteral(),e=M(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),A=p.split("|");let D=null;try{D=e(A[1])}catch(R){L(R);return}h.enqueueDefineAnonymousModule([],function(){return D}),y()}else{const{trustedTypesPolicy:m}=h.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(h)){fetch(p).then(A=>{if(A.status!==200)throw new Error(A.statusText);return A.text()}).then(A=>{A=`${A}
//# sourceURL=${p}`,(m?self.eval(m.createScript("",A)):new Function(A)).call(self),y()}).then(void 0,L);return}try{m&&(p=m.createScriptURL(p)),importScripts(p),y()}catch(A){L(A)}}}}class u{constructor(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))}_initNodeRequire(h,p){const{nodeCachedData:y}=p.getConfig().getOptionsLiteral();if(!y||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const L=this,m=h("module");function e(A){const D=A.constructor;let R=function(d){try{return A.require(d)}finally{}};return R.resolve=function(d,N){return D._resolveFilename(d,A,!1,N)},R.resolve.paths=function(d){return D._resolveLookupPaths(d,A)},R.main=process.mainModule,R.extensions=D._extensions,R.cache=D._cache,R}m.prototype._compile=function(A,D){const R=m.wrap(A.replace(/^#!.*/,"")),b=p.getRecorder(),d=L._getCachedDataPath(y,D),N={filename:D};let w;try{const f=L._fs.readFileSync(d);w=f.slice(0,16),N.cachedData=f.slice(16),b.record(60,d)}catch{b.record(61,d)}const r=new L._vm.Script(R,N),s=r.runInThisContext(N),o=L._path.dirname(D),a=e(this),v=[this.exports,a,this,D,o,process,Be,Buffer],c=s.apply(this.exports,v);return L._handleCachedData(r,R,d,!N.cachedData,p),L._verifyCachedData(r,R,d,w,p),c}}load(h,p,y,L){const m=h.getConfig().getOptionsLiteral(),e=M(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),A=m.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,h);let D=h.getRecorder();if(/^node\|/.test(p)){let R=p.split("|"),b=null;try{b=e(R[1])}catch(d){L(d);return}h.enqueueDefineAnonymousModule([],()=>b),y()}else{p=q.Utilities.fileUriToFilePath(this._env.isWindows,p);const R=this._path.normalize(p),b=this._getElectronRendererScriptPathOrUri(R),d=Boolean(m.nodeCachedData),N=d?this._getCachedDataPath(m.nodeCachedData,p):void 0;this._readSourceAndCachedData(R,N,D,(w,r,s,o)=>{if(w){L(w);return}let a;r.charCodeAt(0)===u._BOM?a=u._PREFIX+r.substring(1)+u._SUFFIX:a=u._PREFIX+r+u._SUFFIX,a=A(a,R);const v={filename:b,cachedData:s},c=this._createAndEvalScript(h,a,v,y,L);this._handleCachedData(c,a,N,d&&!s,h),this._verifyCachedData(c,a,N,o,h)})}}_createAndEvalScript(h,p,y,L,m){const e=h.getRecorder();e.record(31,y.filename);const A=new this._vm.Script(p,y),D=A.runInThisContext(y),R=h.getGlobalAMDDefineFunc();let b=!1;const d=function(){return b=!0,R.apply(null,arguments)};return d.amd=R.amd,D.call(q.global,h.getGlobalAMDRequireFunc(),d,y.filename,this._path.dirname(y.filename)),e.record(32,y.filename),b?L():m(new Error(`Didn't receive define call in ${y.filename}!`)),A}_getElectronRendererScriptPathOrUri(h){if(!this._env.isElectronRenderer)return h;let p=h.match(/^([a-z])\:(.*)/i);return p?`file:///${(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/")}`:`file://${h}`}_getCachedDataPath(h,p){const y=this._crypto.createHash("md5").update(p,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),L=this._path.basename(p).replace(/\.js$/,"");return this._path.join(h.path,`${L}-${y}.code`)}_handleCachedData(h,p,y,L,m){h.cachedDataRejected?this._fs.unlink(y,e=>{m.getRecorder().record(62,y),this._createAndWriteCachedData(h,p,y,m),e&&m.getConfig().onError(e)}):L&&this._createAndWriteCachedData(h,p,y,m)}_createAndWriteCachedData(h,p,y,L){let m=Math.ceil(L.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,A=0,D;const R=()=>{setTimeout(()=>{D||(D=this._crypto.createHash("md5").update(p,"utf8").digest());const b=h.createCachedData();if(!(b.length===0||b.length===e||A>=5)){if(b.length<e){R();return}e=b.length,this._fs.writeFile(y,Buffer.concat([D,b]),d=>{d&&L.getConfig().onError(d),L.getRecorder().record(63,y),R()})}},m*Math.pow(4,A++))};R()}_readSourceAndCachedData(h,p,y,L){if(!p)this._fs.readFile(h,{encoding:"utf8"},L);else{let m,e,A,D=2;const R=b=>{b?L(b):--D===0&&L(void 0,m,e,A)};this._fs.readFile(h,{encoding:"utf8"},(b,d)=>{m=d,R(b)}),this._fs.readFile(p,(b,d)=>{!b&&d&&d.length>0?(A=d.slice(0,16),e=d.slice(16),y.record(60,p)):y.record(61,p),R()})}}_verifyCachedData(h,p,y,L,m){!L||h.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(p,"utf8").digest();L.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${y}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(y,A=>{A&&m.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random())))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function M(l,h){if(h.__$__isRecorded)return h;const p=function(L){l.record(33,L);try{return h(L)}finally{l.record(34,L)}};return p.__$__isRecorded=!0,p}q.ensureRecordedNodeRequire=M;function _(l){return new t(l)}q.createScriptLoader=_})(he||(he={}));var he;(function(q){class t{constructor(l){let h=l.lastIndexOf("/");h!==-1?this.fromModulePath=l.substr(0,h+1):this.fromModulePath=""}static _normalizeModuleId(l){let h=l,p;for(p=/\/\.\//;p.test(h);)h=h.replace(p,"/");for(h=h.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(h);)h=h.replace(p,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h}resolveModule(l){let h=l;return q.Utilities.isAbsolutePath(h)||(q.Utilities.startsWith(h,"./")||q.Utilities.startsWith(h,"../"))&&(h=t._normalizeModuleId(this.fromModulePath+h)),h}}t.ROOT=new t(""),q.ModuleIdResolver=t;class P{constructor(l,h,p,y,L,m){this.id=l,this.strId=h,this.dependencies=p,this._callback=y,this._errorback=L,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,h){try{return{returnedValue:l.apply(q.global,h),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}}static _invokeFactory(l,h,p,y){return l.shouldInvokeFactory(h)?l.shouldCatchError()?this._safeInvokeFunction(p,y):{returnedValue:p.apply(q.global,y),producedError:null}:{returnedValue:null,producedError:null}}complete(l,h,p,y){this._isComplete=!0;let L=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=P._invokeFactory(h,this.strId,this._callback,p);L=m.producedError,l.record(22,this.strId),!L&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(L){let m=q.ensureError(L);m.phase="factory",m.moduleId=this.strId,m.neededBy=y(this.id),this.error=m,h.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}q.Module=P;class I{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let h=this._strModuleIdToIntModuleId.get(l);return typeof h>"u"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(l,h),this._intModuleIdToStrModuleId[h]=l),h}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class i{constructor(l){this.id=l}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),q.RegularDependency=i;class u{constructor(l,h,p){this.id=l,this.pluginId=h,this.pluginParam=p}}q.PluginDependency=u;class M{constructor(l,h,p,y,L=0){this._env=l,this._scriptLoader=h,this._loaderAvailableTimestamp=L,this._defineFunc=p,this._requireFunc=y,this._moduleIdProvider=new I,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new M(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,h){let p=m=>m.replace(/\\/g,"/"),y=p(l),L=h.split(/\n/);for(let m=0;m<L.length;m++){let e=L[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let A=e[1],D=e[2],R=e[3],b=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(b),A=p(A),A===y){let d={line:parseInt(D,10),col:parseInt(R,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],h=0;for(let p=0,y=this._modules2.length;p<y;p++){let L=this._modules2[p];if(!L)continue;let m=this._buildInfoPath[L.id]||null,e=this._buildInfoDefineStack[L.id]||null,A=this._buildInfoDependencies[L.id];l[h++]={id:L.strId,path:m,defineLocation:m&&e?M._findRelevantLocationInStack(m,e):null,dependencies:A,shim:null,exports:L.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:l,callback:h}}defineModule(l,h,p,y,L,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let A=new P(e,l,this._normalizeDependencies(h,m),p,y,m);this._modules2[e]=A,this._config.isBuild()&&(this._buildInfoDefineStack[e]=L,this._buildInfoDependencies[e]=(A.dependencies||[]).map(D=>this._moduleIdProvider.getStrModuleId(D.id))),this._resolve(A)}_normalizeDependency(l,h){if(l==="exports")return i.EXPORTS;if(l==="module")return i.MODULE;if(l==="require")return i.REQUIRE;let p=l.indexOf("!");if(p>=0){let y=h.resolveModule(l.substr(0,p)),L=h.resolveModule(l.substr(p+1)),m=this._moduleIdProvider.getModuleId(y+"!"+L),e=this._moduleIdProvider.getModuleId(y);return new u(m,e,L)}return new i(this._moduleIdProvider.getModuleId(h.resolveModule(l)))}_normalizeDependencies(l,h){let p=[],y=0;for(let L=0,m=l.length;L<m;L++)p[y++]=this._normalizeDependency(l[L],h);return p}_relativeRequire(l,h,p,y){if(typeof h=="string")return this.synchronousRequire(h,l);this.defineModule(q.Utilities.generateAnonymousModule(),h,p,y,null,l)}synchronousRequire(l,h=new t(l)){let p=this._normalizeDependency(l,h),y=this._modules2[p.id];if(!y)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!y.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(y.error)throw y.error;return y.exports}configure(l,h){let p=this._config.shouldRecordStats();h?this._config=new q.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!p&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),h.dependencies,h.callback,null,h.stack)}}_createLoadError(l,h){let p=this._moduleIdProvider.getStrModuleId(l),y=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const L=q.ensureError(h);return L.phase="loading",L.moduleId=p,L.neededBy=y,L}_onLoadError(l,h){const p=this._createLoadError(l,h);this._modules2[l]||(this._modules2[l]=new P(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let y=[];for(let e=0,A=this._moduleIdProvider.getMaxModuleId();e<A;e++)y[e]=!1;let L=!1,m=[];for(m.push(l),y[l]=!0;m.length>0;){let e=m.shift(),A=this._modules2[e];A&&(L=A.onDependencyError(p)||L);let D=this._inverseDependencies2[e];if(D)for(let R=0,b=D.length;R<b;R++){let d=D[R];y[d]||(m.push(d),y[d]=!0)}}L||this._config.onError(p)}_hasDependencyPath(l,h){let p=this._modules2[l];if(!p)return!1;let y=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)y[m]=!1;let L=[];for(L.push(p),y[l]=!0;L.length>0;){let e=L.shift().dependencies;if(e)for(let A=0,D=e.length;A<D;A++){let R=e[A];if(R.id===h)return!0;let b=this._modules2[R.id];b&&!y[R.id]&&(y[R.id]=!0,L.push(b))}}return!1}_findCyclePath(l,h,p){if(l===h||p===50)return[l];let y=this._modules2[l];if(!y)return null;let L=y.dependencies;if(L)for(let m=0,e=L.length;m<e;m++){let A=this._findCyclePath(L[m].id,h,p+1);if(A!==null)return A.push(l),A}return null}_createRequire(l){let h=(p,y,L)=>this._relativeRequire(l,p,y,L);return h.toUrl=p=>this._config.requireToUrl(l.resolveModule(p)),h.getStats=()=>this.getLoaderEvents(),h.hasDependencyCycle=()=>this._hasDependencyCycle,h.config=(p,y=!1)=>{this.configure(p,y)},h.__$__nodeRequire=q.global.nodeRequire,h}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let h=this._moduleIdProvider.getStrModuleId(l),p=this._config.moduleIdToPaths(h),y=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(h.indexOf("/")===-1||y.test(h))&&p.push("node|"+h);let L=-1,m=e=>{if(L++,L>=p.length)this._onLoadError(l,e);else{let A=p[L],D=this.getRecorder();if(this._config.isBuild()&&A==="empty:"){this._buildInfoPath[l]=A,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}D.record(10,A),this._scriptLoader.load(this,A,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=A),D.record(11,A),this._onLoad(l)},R=>{D.record(12,A),m(R)})}};m(null)}_loadPluginDependency(l,h){if(this._modules2[h.id]||this._knownModules2[h.id])return;this._knownModules2[h.id]=!0;let p=y=>{this.defineModule(this._moduleIdProvider.getStrModuleId(h.id),[],y,null,null)};p.error=y=>{this._config.onError(this._createLoadError(h.id,y))},l.load(h.pluginParam,this._createRequire(t.ROOT),p,this._config.getOptionsLiteral())}_resolve(l){let h=l.dependencies;if(h)for(let p=0,y=h.length;p<y;p++){let L=h[p];if(L===i.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(L===i.MODULE){l.unresolvedDependenciesCount--;continue}if(L===i.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[L.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(L.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(L.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(L.id,l.id,0)||[];e.reverse(),e.push(L.id),console.warn(e.map(A=>this._moduleIdProvider.getStrModuleId(A)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[L.id]=this._inverseDependencies2[L.id]||[],this._inverseDependencies2[L.id].push(l.id),L instanceof u){let e=this._modules2[L.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,L);continue}let A=this._inversePluginDependencies2.get(L.pluginId);A||(A=[],this._inversePluginDependencies2.set(L.pluginId,A)),A.push(L),this._loadModule(L.pluginId);continue}this._loadModule(L.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let h=this.getRecorder();if(l.isComplete())return;let p=l.dependencies,y=[];if(p)for(let A=0,D=p.length;A<D;A++){let R=p[A];if(R===i.EXPORTS){y[A]=l.exports;continue}if(R===i.MODULE){y[A]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(R===i.REQUIRE){y[A]=this._createRequire(l.moduleIdResolver);continue}let b=this._modules2[R.id];if(b){y[A]=b.exports;continue}y[A]=null}const L=A=>(this._inverseDependencies2[A]||[]).map(D=>this._moduleIdProvider.getStrModuleId(D));l.complete(h,this._config,y,L);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let A=0,D=m.length;A<D;A++){let R=m[A],b=this._modules2[R];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let A=0,D=e.length;A<D;A++)this._loadPluginDependency(l.exports,e[A])}}}q.ModuleManager=M})(he||(he={}));var J,he;(function(q){const t=new q.Environment;let P=null;const I=function(_,l,h){typeof _!="string"&&(h=l,l=_,_=null),(typeof l!="object"||!Array.isArray(l))&&(h=l,l=null),l||(l=["require","exports","module"]),_?P.defineModule(_,l,h,null,null):P.enqueueDefineAnonymousModule(l,h)};I.amd={jQuery:!0};const i=function(_,l=!1){P.configure(_,l)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return P.getConfig().getOptionsLiteral()},u.reset=function(){P=P.reset()},u.getBuildInfo=function(){return P.getBuildInfo()},u.getStats=function(){return P.getLoaderEvents()},u.define=I;function M(){if(typeof q.global.require<"u"||typeof require<"u"){const _=q.global.require||require;if(typeof _=="function"&&typeof _.resolve=="function"){const l=q.ensureRecordedNodeRequire(P.getRecorder(),_);q.global.nodeRequire=l,u.nodeRequire=l,u.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(q.global.define=I),q.global.require=u)}q.init=M,(typeof q.global.define!="function"||!q.global.define.amd)&&(P=new q.ModuleManager(t,q.createScriptLoader(t),I,u,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&u.config(q.global.require),J=function(){return I.apply(null,arguments)},J.amd=I.amd,typeof doNotInitLoader>"u"&&M())})(he||(he={})),J(ee[55],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function P(_,l,h,p){if(p=p||{},(p["vs/css"]||{}).disabled){h({});return}const L=l.toUrl(_+".css");I(_,L,()=>{h({})},m=>{typeof h.error=="function"&&h.error("Could not find "+L+".")})}t.load=P;function I(_,l,h,p){if(i(_,l)){h();return}u(_,l,h,p)}function i(_,l){const h=document.getElementsByTagName("link");for(let p=0,y=h.length;p<y;p++){const L=h[p].getAttribute("data-name"),m=h[p].getAttribute("href");if(L===_||m===l)return!0}return!1}function u(_,l,h,p){const y=document.createElement("link");y.setAttribute("rel","stylesheet"),y.setAttribute("type","text/css"),y.setAttribute("data-name",_),M(_,y,h,p),y.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(y)}function M(_,l,h,p){const y=()=>{l.removeEventListener("load",L),l.removeEventListener("error",m)},L=e=>{y(),h()},m=e=>{y(),p(e)};l.addEventListener("load",L),l.addEventListener("error",m)}}),J("vs/nls",["require","exports"],function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let P=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const I="i-default";function i(e,A){let D;return A.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(R,b)=>{const d=b[0],N=A[d];let w=R;return typeof N=="string"?w=N:(typeof N=="number"||typeof N=="boolean"||N===void 0||N===null)&&(w=String(N)),w}),P&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function u(e,A){let D=e[A];return D||(D=e["*"],D)?D:null}function M(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function _(e,A,D){const R=M(e)+M(A)+"vscode/"+M(D),b=await fetch(R);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function l(e){return function(A,D){const R=Array.prototype.slice.call(arguments,2);return i(e[A],R)}}function h(e,A,...D){return i(A,D)}t.localize=h;function p(e){}t.getConfiguredDefaultLocale=p;function y(e){P=e}t.setPseudoTranslation=y;function L(e,A){return{localize:l(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(D=>{})}}t.create=L;function m(e,A,D,R){const b=R["vs/nls"]??{};if(!e||e.length===0)return D({localize:h,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const d=b.availableLanguages?u(b.availableLanguages,e):null,N=d===null||d===I;let w=".nls";N||(w=w+"."+d);const r=s=>{Array.isArray(s)?s.localize=l(s):s.localize=l(s[e]),s.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],D(s)};typeof b.loadBundle=="function"?b.loadBundle(e,d,(s,o)=>{s?A([e+".nls"],r):r(o)}):b.translationServiceUrl&&!N?(async()=>{try{const s=await _(b.translationServiceUrl,d,e);return r(s)}catch(s){if(!d.includes("-"))return console.error(s),A([e+".nls"],r);try{const o=d.split("-")[0],a=await _(b.translationServiceUrl,o,e);return b.availableLanguages??={},b.availableLanguages["*"]=o,r(a)}catch(o){return console.error(o),A([e+".nls"],r)}}})():A([e+w],r,s=>{if(w===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${d}. Falling back to the default language:`,s),A([e+".nls"],r)})}t.load=m}),function(){const q=globalThis.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:h=>h,createScript:(h,...p)=>{const y=p.slice(0,-1).join(","),L=p.pop().toString();return`(function anonymous(${y}) { ${L}
})`}}):void 0;function I(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((h,p)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const y=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(y)&&y.substring(0,globalThis.origin.length)!==globalThis.origin)&&I()){fetch(y).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${y}`,(P?globalThis.eval(P.createScript("",m)):new Function(m)).call(globalThis),h()}).then(void 0,p);return}P?importScripts(P.createScriptURL(y)):importScripts(y),h()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function M(h){i().then(()=>{u(),require([h],function(p){setTimeout(function(){const y=p.create((L,m)=>{globalThis.postMessage(L,m)},null);for(globalThis.onmessage=L=>y.onmessage(L.data,L.ports);l.length>0;){const L=l.shift();y.onmessage(L.data,L.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&u();let _=!0;const l=[];globalThis.onmessage=h=>{if(!_){l.push(h);return}_=!1,M(h.data)}}(),J(ee[26],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(i,u,M,_){this.originalStart=i,this.originalLength=u,this.modifiedStart=M,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),J(ee[5],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?N.isErrorNoTelemetry(s)?new N(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(o=>{o(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}t.ErrorHandler=P,t.errorHandler=new P;function I(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=I;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){h(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function M(r){h(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=M;function _(r){if(r instanceof Error){const{name:s,message:o}=r,a=r.stacktrace||r.stack;return{$isError:!0,name:s,message:o,stack:a,noTelemetry:N.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=_;const l="Canceled";function h(r){return r instanceof p?!0:r instanceof Error&&r.name===l&&r.message===l}t.isCancellationError=h;class p extends Error{constructor(){super(l),this.name=this.message}}t.CancellationError=p;function y(){const r=new Error(l);return r.name=r.message,r}t.canceled=y;function L(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=L;function m(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=m;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function A(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=A;function D(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=D;class R extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=R;class b extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=b;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=d;class N extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof N)return s;const o=new N;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=N;class w extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype);debugger}}t.BugIndicatingError=w}),J(ee[27],te([0,1,5]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function I(k,T=0){return k[k.length-(1+T)]}t.tail=I;function i(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=i;function u(k,T,U=(V,z)=>V===z){if(k===T)return!0;if(!k||!T||k.length!==T.length)return!1;for(let V=0,z=k.length;V<z;V++)if(!U(k[V],T[V]))return!1;return!0}t.equals=u;function M(k,T){const U=k.length-1;T<U&&(k[T]=k[U]),k.pop()}t.removeFastWithoutKeepingOrder=M;function _(k,T,U){return l(k.length,V=>U(k[V],T))}t.binarySearch=_;function l(k,T){let U=0,V=k-1;for(;U<=V;){const z=(U+V)/2|0,re=T(z);if(re<0)U=z+1;else if(re>0)V=z-1;else return z}return-(U+1)}t.binarySearch2=l;function h(k,T){let U=0,V=k.length;if(V===0)return 0;for(;U<V;){const z=Math.floor((U+V)/2);T(k[z])?V=z:U=z+1}return U}t.findFirstInSorted=h;function p(k,T,U){if(k=k|0,k>=T.length)throw new TypeError("invalid index");const V=T[Math.floor(T.length*Math.random())],z=[],re=[],se=[];for(const oe of T){const ce=U(oe,V);ce<0?z.push(oe):ce>0?re.push(oe):se.push(oe)}return k<z.length?p(k,z,U):k<z.length+se.length?se[0]:p(k-(z.length+se.length),re,U)}t.quickSelect=p;function y(k,T){const U=[];let V;for(const z of k.slice(0).sort(T))!V||T(V[0],z)!==0?(V=[z],U.push(V)):V.push(z);return U}t.groupBy=y;function L(k,T,U){const V=[];function z(oe,ce,ge){if(ce===0&&ge.length===0)return;const me=V[V.length-1];me&&me.start+me.deleteCount===oe?(me.deleteCount+=ce,me.toInsert.push(...ge)):V.push({start:oe,deleteCount:ce,toInsert:ge})}let re=0,se=0;for(;;){if(re===k.length){z(re,0,T.slice(se));break}if(se===T.length){z(re,k.length-re,[]);break}const oe=k[re],ce=T[se],ge=U(oe,ce);ge===0?(re+=1,se+=1):ge<0?(z(re,1,[]),re+=1):ge>0&&(z(re,0,[ce]),se+=1)}return V}t.sortedDiff=L;function m(k,T,U){const V=L(k,T,U),z=[],re=[];for(const se of V)z.push(...k.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:z,added:re}}t.delta=m;function e(k,T,U){if(U===0)return[];const V=k.slice(0,U).sort(T);return D(k,T,V,U,k.length),V}t.top=e;function A(k,T,U,V,z){return U===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const oe=k.length,ce=k.slice(0,U).sort(T);for(let ge=U,me=Math.min(U+V,oe);ge<oe;ge=me,me=Math.min(me+V,oe)){if(ge>U&&await new Promise(Fe=>setTimeout(Fe)),z&&z.isCancellationRequested)throw new P.CancellationError;D(k,T,ce,ge,me)}return ce})().then(re,se)})}t.topAsync=A;function D(k,T,U,V,z){for(const re=U.length;V<z;V++){const se=k[V];if(T(se,U[re-1])<0){U.pop();const oe=h(U,ce=>T(se,ce)<0);U.splice(oe,0,se)}}}function R(k){return k.filter(T=>!!T)}t.coalesce=R;function b(k){let T=0;for(let U=0;U<k.length;U++)k[U]&&(k[T]=k[U],T+=1);k.length=T}t.coalesceInPlace=b;function d(k,T,U){k.splice(U,0,k.splice(T,1)[0])}t.move=d;function N(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=N;function w(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=w;function r(k,T=U=>U){const U=new Set;return k.filter(V=>{const z=T(V);return U.has(z)?!1:(U.add(z),!0)})}t.distinct=r;function s(k){const T=new Set;return U=>{const V=k(U);return T.has(V)?!1:(T.add(V),!0)}}t.uniqueFilter=s;function o(k,T){const U=a(k,T);if(U!==-1)return k[U]}t.findLast=o;function a(k,T){for(let U=k.length-1;U>=0;U--){const V=k[U];if(T(V))return U}return-1}t.lastIndex=a;function v(k,T){return k.length>0?k[0]:T}t.firstOrDefault=v;function c(k,T){return k.length>0?k[k.length-1]:T}t.lastOrDefault=c;function f(k,T,U=(V,z)=>V===z){let V=0;for(let z=0,re=Math.min(k.length,T.length);z<re&&U(k[z],T[z]);z++)V++;return V}t.commonPrefixLength=f;function E(k){return[].concat(...k)}t.flatten=E;function g(k,T){let U=typeof T=="number"?k:0;typeof T=="number"?U=k:(U=0,T=k);const V=[];if(U<=T)for(let z=U;z<T;z++)V.push(z);else for(let z=U;z>T;z--)V.push(z);return V}t.range=g;function F(k,T,U){return k.reduce((V,z)=>(V[T(z)]=U?U(z):z,V),Object.create(null))}t.index=F;function C(k,T){return k.push(T),()=>O(k,T)}t.insert=C;function O(k,T){const U=k.indexOf(T);if(U>-1)return k.splice(U,1),T}t.remove=O;function W(k,T,U){const V=k.slice(0,T),z=k.slice(T);return V.concat(U,z)}t.arrayInsert=W;function x(k,T){let U;if(typeof T=="number"){let V=T;U=()=>{const z=Math.sin(V++)*179426549;return z-Math.floor(z)}}else U=Math.random;for(let V=k.length-1;V>0;V-=1){const z=Math.floor(U()*(V+1)),re=k[V];k[V]=k[z],k[z]=re}}t.shuffle=x;function j(k,T){const U=k.indexOf(T);U>-1&&(k.splice(U,1),k.unshift(T))}t.pushToStart=j;function K(k,T){const U=k.indexOf(T);U>-1&&(k.splice(U,1),k.push(T))}t.pushToEnd=K;function X(k,T){for(const U of T)k.push(U)}t.pushMany=X;function $(k,T){return Array.isArray(k)?k.map(T):T(k)}t.mapArrayOrNot=$;function n(k){return Array.isArray(k)?k:[k]}t.asArray=n;function ue(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=ue;function ae(k,T){for(const U of k){const V=T(U);if(V!==void 0)return V}}t.mapFind=ae;function ie(k,T,U){const V=_e(k,T),z=k.length,re=U.length;k.length=z+re;for(let se=z-1;se>=V;se--)k[se+re]=k[se];for(let se=0;se<re;se++)k[se+V]=U[se]}t.insertInto=ie;function be(k,T,U,V){const z=_e(k,T),re=k.splice(z,U);return ie(k,z,V),re}t.splice=be;function _e(k,T){return T<0?Math.max(T+k.length,0):Math.min(T,k.length)}var Le;(function(k){function T(z){return z<0}k.isLessThan=T;function U(z){return z>0}k.isGreaterThan=U;function V(z){return z===0}k.isNeitherLessOrGreaterThan=V,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Le=t.CompareResult||(t.CompareResult={}));function pe(k,T){return(U,V)=>T(k(U),k(V))}t.compareBy=pe;function we(...k){return(T,U)=>{for(const V of k){const z=V(T,U);if(!Le.isNeitherLessOrGreaterThan(z))return z}return Le.neitherLessOrGreaterThan}}t.tieBreakComparators=we;const ye=(k,T)=>k-T;t.numberComparator=ye;function Ne(k,T){if(k.length===0)return;let U=k[0];for(let V=1;V<k.length;V++){const z=k[V];T(z,U)>0&&(U=z)}return U}t.findMaxBy=Ne;function Se(k,T){if(k.length===0)return;let U=k[0];for(let V=1;V<k.length;V++){const z=k[V];T(z,U)>=0&&(U=z)}return U}t.findLastMaxBy=Se;function ne(k,T){return Ne(k,(U,V)=>-T(U,V))}t.findMinBy=ne;class Q{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let U=this.firstIdx;for(;U<this.items.length&&T(this.items[U]);)U++;const V=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,V}takeFromEndWhile(T){let U=this.lastIdx;for(;U>=0&&T(this.items[U]);)U--;const V=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}removeLast(){const T=this.items[this.lastIdx];return this.lastIdx--,T}takeCount(T){const U=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,U}}t.ArrayQueue=Q;class Z{constructor(T){this.iterate=T}forEach(T){this.iterate(U=>(T(U),!0))}toArray(){const T=[];return this.iterate(U=>(T.push(U),!0)),T}filter(T){return new Z(U=>this.iterate(V=>T(V)?U(V):!0))}map(T){return new Z(U=>this.iterate(V=>U(T(V))))}some(T){let U=!1;return this.iterate(V=>(U=T(V),!U)),U}findFirst(T){let U;return this.iterate(V=>T(V)?(U=V,!1):!0),U}findLast(T){let U;return this.iterate(V=>(T(V)&&(U=V),!0)),U}findLastMaxBy(T){let U,V=!0;return this.iterate(z=>((V||Le.isGreaterThan(T(z,U)))&&(V=!1,U=z),!0)),U}}Z.empty=new Z(k=>{}),t.CallbackIterable=Z}),J(ee[10],te([0,1,5]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function I(l,h){if(!l)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=I;function i(l,h="Unreachable"){throw new Error(h)}t.assertNever=i;function u(l){if(!l)throw new P.BugIndicatingError("Assertion Failed")}t.assert=u;function M(l){if(!l()){debugger;l(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}t.assertFn=M;function _(l,h){let p=0;for(;p<l.length-1;){const y=l[p],L=l[p+1];if(!h(y,L))return!1;p++}return!0}t.checkAdjacentItems=_}),J(ee[14],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(I){const i=this;let u=!1,M;return function(){return u||(u=!0,M=I.apply(i,arguments)),M}}t.once=P}),J(ee[15],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(I){function i(N){return N&&typeof N=="object"&&typeof N[Symbol.iterator]=="function"}I.is=i;const u=Object.freeze([]);function M(){return u}I.empty=M;function*_(N){yield N}I.single=_;function l(N){return i(N)?N:_(N)}I.wrap=l;function h(N){return N||u}I.from=h;function p(N){return!N||N[Symbol.iterator]().next().done===!0}I.isEmpty=p;function y(N){return N[Symbol.iterator]().next().value}I.first=y;function L(N,w){for(const r of N)if(w(r))return!0;return!1}I.some=L;function m(N,w){for(const r of N)if(w(r))return r}I.find=m;function*e(N,w){for(const r of N)w(r)&&(yield r)}I.filter=e;function*A(N,w){let r=0;for(const s of N)yield w(s,r++)}I.map=A;function*D(...N){for(const w of N)for(const r of w)yield r}I.concat=D;function R(N,w,r){let s=r;for(const o of N)s=w(s,o);return s}I.reduce=R;function*b(N,w,r=N.length){for(w<0&&(w+=N.length),r<0?r+=N.length:r>N.length&&(r=N.length);w<r;w++)yield N[w]}I.slice=b;function d(N,w=Number.POSITIVE_INFINITY){const r=[];if(w===0)return[r,N];const s=N[Symbol.iterator]();for(let o=0;o<w;o++){const a=s.next();if(a.done)return[r,I.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return s}}]}I.consume=d})(P=t.Iterable||(t.Iterable={}))}),J(ee[28],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(P=t.KeyCode||(t.KeyCode={}));var I;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(I=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,D){this._keyCodeToStr[A]=D,this._strToKeyCode[D.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const u=new i,M=new i,_=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],h=Object.create(null),p=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>h[e]||0,toString:e=>l[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",A=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],R=[];for(const b of A){const[d,N,w,r,s,o,a,v,c,f]=b;if(R[w]||(R[w]=!0,l[w]=r,h[r]=w,p[r.toLowerCase()]=w,N&&(t.IMMUTABLE_CODE_TO_KEY_CODE[w]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=w))),!D[s]){if(D[s]=!0,!o)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,o),M.define(s,c||o),_.define(s,f||c||o)}a&&(t.EVENT_KEY_CODE_MAP[a]=s),v&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[v]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var y;(function(e){function A(w){return u.keyCodeToStr(w)}e.toString=A;function D(w){return u.strToKeyCode(w)}e.fromString=D;function R(w){return M.keyCodeToStr(w)}e.toUserSettingsUS=R;function b(w){return _.keyCodeToStr(w)}e.toUserSettingsGeneral=b;function d(w){return M.strToKeyCode(w)||_.strToKeyCode(w)}e.fromUserSettings=d;function N(w){if(w>=93&&w<=108)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(w)}e.toElectronAccelerator=N})(y=t.KeyCodeUtils||(t.KeyCodeUtils={}));var L;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(L=t.KeyMod||(t.KeyMod={}));function m(e,A){const D=(A&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=m}),J(ee[29],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class P{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=P}),J(ee[6],te([0,1,14,15]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function M(c){u=c}if(t.setDisposableTracker=M,i){const c="__is_disposable_tracked__";M(new class{trackDisposable(f){const E=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[c]||console.log(E)},3e3)}setParent(f,E){if(f&&f!==b.None)try{f[c]=!0}catch{}}markAsDisposed(f){if(f&&f!==b.None)try{f[c]=!0}catch{}}markAsSingleton(f){}})}function _(c){return u?.trackDisposable(c),c}function l(c){u?.markAsDisposed(c)}function h(c,f){u?.setParent(c,f)}function p(c,f){if(!!u)for(const E of c)u.setParent(E,f)}function y(c){return u?.markAsSingleton(c),c}t.markAsSingleton=y;function L(c){return typeof c.dispose=="function"&&c.dispose.length===0}t.isDisposable=L;function m(c){if(I.Iterable.is(c)){const f=[];for(const E of c)if(E)try{E.dispose()}catch(g){f.push(g)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}t.dispose=m;function e(c){for(const f of c)L(f)&&f.dispose();return[]}t.disposeIfDisposable=e;function A(...c){const f=D(()=>m(c));return p(c,f),f}t.combinedDisposable=A;function D(c){const f=_({dispose:(0,P.once)(()=>{l(f),c()})});return f}t.toDisposable=D;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return h(f,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}}R.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=R;class b{constructor(){this._store=new R,_(this),h(this._store,this)}dispose(){l(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}b.None=Object.freeze({dispose(){}}),t.Disposable=b;class d{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){this._isDisposed||f===this._value||(this._value?.dispose(),f&&h(f,this),this._value=f)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&h(f,null),f}}t.MutableDisposable=d;class N{constructor(f){this._disposable=f,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=N;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(f){let E=f;return this.unset=()=>E=void 0,this.isset=()=>E!==void 0,this.dispose=()=>{E&&(E(),E=void 0,l(this))},this}}t.SafeDisposable=w;class r{constructor(){this.references=new Map}acquire(f,...E){let g=this.references.get(f);g||(g={counter:0,object:this.createReferencedObject(f,...E)},this.references.set(f,g));const{object:F}=g,C=(0,P.once)(()=>{--g.counter===0&&(this.destroyReferencedObject(f,g.object),this.references.delete(f))});return g.counter++,{object:F,dispose:C}}}t.ReferenceCollection=r;class s{constructor(f){this.referenceCollection=f}async acquire(f,...E){const g=this.referenceCollection.acquire(f,...E);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(F){throw g.dispose(),F}}}t.AsyncReferenceCollection=s;class o{constructor(f){this.object=f}dispose(){}}t.ImmortalReference=o;function a(c){const f=new R;try{c(f)}finally{f.dispose()}}t.disposeOnReturn=a;class v{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(f){return this._store.has(f)}get(f){return this._store.get(f)}set(f,E,g=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this._store.get(f)?.dispose(),this._store.set(f,E)}deleteAndDispose(f){this._store.get(f)?.dispose(),this._store.delete(f)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=v}),J(ee[16],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{constructor(u){this.element=u,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class I{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let u=this._first;for(;u!==P.Undefined;){const M=u.next;u.prev=P.Undefined,u.next=P.Undefined,u=M}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,M){const _=new P(u);if(this._first===P.Undefined)this._first=_,this._last=_;else if(M){const h=this._last;this._last=_,_.prev=h,h.next=_}else{const h=this._first;this._first=_,_.next=h,h.prev=_}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(_))}}shift(){if(this._first!==P.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==P.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==P.Undefined&&u.next!==P.Undefined){const M=u.prev;M.next=u.next,u.next.prev=M}else u.prev===P.Undefined&&u.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):u.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):u.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==P.Undefined;)yield u.element,u=u.next}}t.LinkedList=I}),J(ee[17],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function P(s){return typeof s=="string"}t.isString=P;function I(s){return Array.isArray(s)&&s.every(o=>P(o))}t.isStringArray=I;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const o=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof o}t.isTypedArray=u;function M(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=M;function _(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=_;function l(s){return s===!0||s===!1}t.isBoolean=l;function h(s){return typeof s>"u"}t.isUndefined=h;function p(s){return!y(s)}t.isDefined=p;function y(s){return h(s)||s===null}t.isUndefinedOrNull=y;function L(s,o){if(!s)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.assertType=L;function m(s){if(y(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=m;function e(...s){const o=[];for(let a=0;a<s.length;a++){const v=s[a];if(y(v))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);o.push(v)}return o}t.assertAllDefined=e;const A=Object.prototype.hasOwnProperty;function D(s){if(!i(s))return!1;for(const o in s)if(A.call(s,o))return!1;return!0}t.isEmptyObject=D;function R(s){return typeof s=="function"}t.isFunction=R;function b(...s){return s.length>0&&s.every(R)}t.areFunctions=b;function d(s,o){const a=Math.min(s.length,o.length);for(let v=0;v<a;v++)N(s[v],o[v])}t.validateConstraints=d;function N(s,o){if(P(o)){if(typeof s!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(R(o)){try{if(s instanceof o)return}catch{}if(!y(s)&&s.constructor===o||o.length===1&&o.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=N;function w(s){return s===null?void 0:s}t.withNullAsUndefined=w;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),J(ee[30],te([0,1,17]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const I=Object.create(null);function i(_,l){if((0,P.isString)(l)){const h=I[l];if(h===void 0)throw new Error(`${_} references an unknown codicon: ${l}`);l=h}return I[_]=l,{id:_}}function u(){return I}t.getCodiconFontCharacters=u;function M(){return Object.values(t.Codicon)}t.getAllCodicons=M,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(ee[11],te([0,1,17]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(R){if(!R||typeof R!="object"||R instanceof RegExp)return R;const b=Array.isArray(R)?[]:{};return Object.entries(R).forEach(([d,N])=>{b[d]=N&&typeof N=="object"?I(N):N}),b}t.deepClone=I;function i(R){if(!R||typeof R!="object")return R;const b=[R];for(;b.length>0;){const d=b.shift();Object.freeze(d);for(const N in d)if(u.call(d,N)){const w=d[N];typeof w=="object"&&!Object.isFrozen(w)&&!(0,P.isTypedArray)(w)&&b.push(w)}}return R}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function M(R,b){return _(R,b,new Set)}t.cloneAndChange=M;function _(R,b,d){if((0,P.isUndefinedOrNull)(R))return R;const N=b(R);if(typeof N<"u")return N;if(Array.isArray(R)){const w=[];for(const r of R)w.push(_(r,b,d));return w}if((0,P.isObject)(R)){if(d.has(R))throw new Error("Cannot clone recursive data-structure");d.add(R);const w={};for(const r in R)u.call(R,r)&&(w[r]=_(R[r],b,d));return d.delete(R),w}return R}function l(R,b,d=!0){return(0,P.isObject)(R)?((0,P.isObject)(b)&&Object.keys(b).forEach(N=>{N in R?d&&((0,P.isObject)(R[N])&&(0,P.isObject)(b[N])?l(R[N],b[N],d):R[N]=b[N]):R[N]=b[N]}),R):b}t.mixin=l;function h(R,b){if(R===b)return!0;if(R==null||b===null||b===void 0||typeof R!=typeof b||typeof R!="object"||Array.isArray(R)!==Array.isArray(b))return!1;let d,N;if(Array.isArray(R)){if(R.length!==b.length)return!1;for(d=0;d<R.length;d++)if(!h(R[d],b[d]))return!1}else{const w=[];for(N in R)w.push(N);w.sort();const r=[];for(N in b)r.push(N);if(r.sort(),!h(w,r))return!1;for(d=0;d<w.length;d++)if(!h(R[w[d]],b[w[d]]))return!1}return!0}t.equals=h;function p(R){const b=new Set;return JSON.stringify(R,(d,N)=>{if((0,P.isObject)(N)||Array.isArray(N)){if(b.has(N))return"[Circular]";b.add(N)}return N})}t.safeStringify=p;function y(R,b){const d=Object.create(null);return!R||!b||Object.keys(b).forEach(w=>{const r=R[w],s=b[w];h(r,s)||(d[w]=s)}),d}t.distinct=y;function L(R,b){const d=b.toLowerCase(),N=Object.keys(R).find(w=>w.toLowerCase()===d);return N?R[N]:R[b]}t.getCaseInsensitive=L;function m(R,b){const d=Object.create(null);for(const[N,w]of Object.entries(R))b(N,w)&&(d[N]=w);return d}t.filter=m;function e(R){let b=[],d=Object.getPrototypeOf(R);for(;Object.prototype!==d;)b=b.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return b}t.getAllPropertyNames=e;function A(R){const b=[];for(const d of e(R))typeof R[d]=="function"&&b.push(d);return b}t.getAllMethodNames=A;function D(R,b){const d=w=>function(){const r=Array.prototype.slice.call(arguments,0);return b(w,r)},N={};for(const w of R)N[w]=d(w);return N}t.createProxyObject=D}),J(ee[18],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=t.Constants||(t.Constants={}));function I(u){return u<0?0:u>255?255:u|0}t.toUint8=I;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),J(ee[19],te([0,1,18]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class I{constructor(_){const l=(0,P.toUint8)(_);this._defaultValue=l,this._asciiMap=I._createAsciiMap(l),this._map=new Map}static _createAsciiMap(_){const l=new Uint8Array(256);return l.fill(_),l}set(_,l){const h=(0,P.toUint8)(l);_>=0&&_<256?this._asciiMap[_]=h:this._map.set(_,h)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=I;var i;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(i||(i={}));class u{constructor(){this._actual=new I(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}clear(){return this._actual.clear()}}t.CharacterSet=u}),J(ee[20],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class P{constructor(i,u){this.startLineNumber=i,this.endLineNumberExclusive=u}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(i){return new P(this.startLineNumber+i,this.endLineNumberExclusive+i)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(i){return new P(Math.min(this.startLineNumber,i.startLineNumber),Math.max(this.endLineNumberExclusive,i.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=P}),J(ee[3],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new P(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return P.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return P.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return P.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const M=i.lineNumber|0,_=u.lineNumber|0;if(M===_){const l=i.column|0,h=u.column|0;return l-h}return M-_}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new P(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=P}),J(ee[2],te([0,1,3]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class I{constructor(u,M,_,l){u>_||u===_&&M>l?(this.startLineNumber=_,this.startColumn=l,this.endLineNumber=u,this.endColumn=M):(this.startLineNumber=u,this.startColumn=M,this.endLineNumber=_,this.endColumn=l)}isEmpty(){return I.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return I.containsPosition(this,u)}static containsPosition(u,M){return!(M.lineNumber<u.startLineNumber||M.lineNumber>u.endLineNumber||M.lineNumber===u.startLineNumber&&M.column<u.startColumn||M.lineNumber===u.endLineNumber&&M.column>u.endColumn)}static strictContainsPosition(u,M){return!(M.lineNumber<u.startLineNumber||M.lineNumber>u.endLineNumber||M.lineNumber===u.startLineNumber&&M.column<=u.startColumn||M.lineNumber===u.endLineNumber&&M.column>=u.endColumn)}containsRange(u){return I.containsRange(this,u)}static containsRange(u,M){return!(M.startLineNumber<u.startLineNumber||M.endLineNumber<u.startLineNumber||M.startLineNumber>u.endLineNumber||M.endLineNumber>u.endLineNumber||M.startLineNumber===u.startLineNumber&&M.startColumn<u.startColumn||M.endLineNumber===u.endLineNumber&&M.endColumn>u.endColumn)}strictContainsRange(u){return I.strictContainsRange(this,u)}static strictContainsRange(u,M){return!(M.startLineNumber<u.startLineNumber||M.endLineNumber<u.startLineNumber||M.startLineNumber>u.endLineNumber||M.endLineNumber>u.endLineNumber||M.startLineNumber===u.startLineNumber&&M.startColumn<=u.startColumn||M.endLineNumber===u.endLineNumber&&M.endColumn>=u.endColumn)}plusRange(u){return I.plusRange(this,u)}static plusRange(u,M){let _,l,h,p;return M.startLineNumber<u.startLineNumber?(_=M.startLineNumber,l=M.startColumn):M.startLineNumber===u.startLineNumber?(_=M.startLineNumber,l=Math.min(M.startColumn,u.startColumn)):(_=u.startLineNumber,l=u.startColumn),M.endLineNumber>u.endLineNumber?(h=M.endLineNumber,p=M.endColumn):M.endLineNumber===u.endLineNumber?(h=M.endLineNumber,p=Math.max(M.endColumn,u.endColumn)):(h=u.endLineNumber,p=u.endColumn),new I(_,l,h,p)}intersectRanges(u){return I.intersectRanges(this,u)}static intersectRanges(u,M){let _=u.startLineNumber,l=u.startColumn,h=u.endLineNumber,p=u.endColumn;const y=M.startLineNumber,L=M.startColumn,m=M.endLineNumber,e=M.endColumn;return _<y?(_=y,l=L):_===y&&(l=Math.max(l,L)),h>m?(h=m,p=e):h===m&&(p=Math.min(p,e)),_>h||_===h&&l>p?null:new I(_,l,h,p)}equalsRange(u){return I.equalsRange(this,u)}static equalsRange(u,M){return!u&&!M?!0:!!u&&!!M&&u.startLineNumber===M.startLineNumber&&u.startColumn===M.startColumn&&u.endLineNumber===M.endLineNumber&&u.endColumn===M.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(u){return new P.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(u){return new P.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,M){return new I(this.startLineNumber,this.startColumn,u,M)}setStartPosition(u,M){return new I(u,M,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(u){return new I(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return I.collapseToEnd(this)}static collapseToEnd(u){return new I(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new I(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,M=u){return new I(u.lineNumber,u.column,M.lineNumber,M.column)}static lift(u){return u?new I(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,M){return!(u.endLineNumber<M.startLineNumber||u.endLineNumber===M.startLineNumber&&u.endColumn<M.startColumn||M.endLineNumber<u.startLineNumber||M.endLineNumber===u.startLineNumber&&M.endColumn<u.startColumn)}static areIntersecting(u,M){return!(u.endLineNumber<M.startLineNumber||u.endLineNumber===M.startLineNumber&&u.endColumn<=M.startColumn||M.endLineNumber<u.startLineNumber||M.endLineNumber===u.startLineNumber&&M.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,M){if(u&&M){const h=u.startLineNumber|0,p=M.startLineNumber|0;if(h===p){const y=u.startColumn|0,L=M.startColumn|0;if(y===L){const m=u.endLineNumber|0,e=M.endLineNumber|0;if(m===e){const A=u.endColumn|0,D=M.endColumn|0;return A-D}return m-e}return y-L}return h-p}return(u?1:0)-(M?1:0)}static compareRangesUsingEnds(u,M){return u.endLineNumber===M.endLineNumber?u.endColumn===M.endColumn?u.startLineNumber===M.startLineNumber?u.startColumn-M.startColumn:u.startLineNumber-M.startLineNumber:u.endColumn-M.endColumn:u.endLineNumber-M.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=I}),J(ee[31],te([0,1,3,2]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(i=t.SelectionDirection||(t.SelectionDirection={}));class u extends I.Range{constructor(_,l,h,p){super(_,l,h,p),this.selectionStartLineNumber=_,this.selectionStartColumn=l,this.positionLineNumber=h,this.positionColumn=p}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return u.selectionsEqual(this,_)}static selectionsEqual(_,l){return _.selectionStartLineNumber===l.selectionStartLineNumber&&_.selectionStartColumn===l.selectionStartColumn&&_.positionLineNumber===l.positionLineNumber&&_.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,l){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,_,l):new u(_,l,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(_,l){return this.getDirection()===0?new u(_,l,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,_,l)}static fromPositions(_,l=_){return new u(_.lineNumber,_.column,l.lineNumber,l.column)}static fromRange(_,l){return l===0?new u(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):new u(_.endLineNumber,_.endColumn,_.startLineNumber,_.startColumn)}static liftSelection(_){return new u(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,l){if(_&&!l||!_&&l)return!1;if(!_&&!l)return!0;if(_.length!==l.length)return!1;for(let h=0,p=_.length;h<p;h++)if(!this.selectionsEqual(_[h],l[h]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,l,h,p,y){return y===0?new u(_,l,h,p):new u(h,p,_,l)}}t.Selection=u}),J(ee[32],te([0,1,19]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var I;(function(M){M[M.Regular=0]="Regular",M[M.Whitespace=1]="Whitespace",M[M.WordSeparator=2]="WordSeparator"})(I=t.WordCharacterClass||(t.WordCharacterClass={}));class i extends P.CharacterClassifier{constructor(_){super(0);for(let l=0,h=_.length;l<h;l++)this.set(_.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(M){const _={};return l=>(_.hasOwnProperty(l)||(_[l]=M(l)),_[l])}t.getMapForWordSeparators=u(M=>new i(M))}),J(ee[21],te([0,1,15,6,16]),function(q,t,P,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(y=""){let L="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.USUAL_WORD_SEPARATORS)y.indexOf(m)>=0||(L+="\\"+m);return L+="\\s]+)",new RegExp(L,"g")}t.DEFAULT_WORD_REGEXP=u();function M(y){let L=t.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)L=y;else{let m="g";y.ignoreCase&&(m+="i"),y.multiline&&(m+="m"),y.unicode&&(m+="u"),L=new RegExp(y.source,m)}return L.lastIndex=0,L}t.ensureValidWordDefinition=M;const _=new i.LinkedList;_.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(y){const L=_.unshift(y);return(0,I.toDisposable)(L)}t.setDefaultGetWordAtTextConfig=l;function h(y,L,m,e,A){if(A||(A=P.Iterable.first(_)),m.length>A.maxLen){let N=y-A.maxLen/2;return N<0?N=0:e+=N,m=m.substring(N,y+A.maxLen/2),h(y,L,m,e,A)}const D=Date.now(),R=y-1-e;let b=-1,d=null;for(let N=1;!(Date.now()-D>=A.timeBudget);N++){const w=R-A.windowSize*N;L.lastIndex=Math.max(0,w);const r=p(L,m,R,b);if(!r&&d||(d=r,w<=0))break;b=w}if(d){const N={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return L.lastIndex=0,N}return null}t.getWordAtText=h;function p(y,L,m,e){let A;for(;A=y.exec(L);){const D=A.index||0;if(D<=m&&y.lastIndex>=m)return A;if(e>0&&D>e)return null}return null}}),J(ee[7],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class P{constructor(u,M){this.seq1Range=u,this.seq2Range=M}reverse(){return new P(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(u){return new P(this.seq1Range.join(u.seq1Range),this.seq2Range.join(u.seq2Range))}}t.SequenceDiff=P;class I{constructor(u,M){this.start=u,this.endExclusive=M}get isEmpty(){return this.start===this.endExclusive}delta(u){return new I(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new I(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}intersect(u){const M=Math.max(this.start,u.start),_=Math.min(this.endExclusive,u.endExclusive);if(M<=_)return new I(M,_)}}t.OffsetRange=I}),J(ee[33],te([0,1,7]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function I(l,h,p){let y=p;return y=u(l,h,y),y=M(l,h,y),y}t.optimizeSequenceDiffs=I;function i(l,h,p){const y=[];for(const L of p){const m=y[y.length-1];if(!m){y.push(L);continue}L.seq1Range.start-m.seq1Range.endExclusive<=2||L.seq2Range.start-m.seq2Range.endExclusive<=2?y[y.length-1]=new P.SequenceDiff(m.seq1Range.join(L.seq1Range),m.seq2Range.join(L.seq2Range)):y.push(L)}return y}t.smoothenSequenceDiffs=i;function u(l,h,p){const y=[];p.length>0&&y.push(p[0]);for(let L=1;L<p.length;L++){const m=y[y.length-1],e=p[L];if(e.seq1Range.isEmpty){let A=!0;const D=e.seq1Range.start-m.seq1Range.endExclusive;for(let R=1;R<=D;R++)if(h.getElement(e.seq2Range.start-R)!==h.getElement(e.seq2Range.endExclusive-R)){A=!1;break}if(A){y[y.length-1]=new P.SequenceDiff(m.seq1Range,new P.OffsetRange(m.seq2Range.start,e.seq2Range.endExclusive-D));continue}}y.push(e)}return y}t.joinSequenceDiffs=u;function M(l,h,p){if(!l.getBoundaryScore||!h.getBoundaryScore)return p;for(let y=0;y<p.length;y++){const L=p[y];if(L.seq1Range.isEmpty){const m=y>0?p[y-1].seq2Range.endExclusive:-1,e=y+1<p.length?p[y+1].seq2Range.start:h.length;p[y]=_(L,l,h,e,m)}else if(L.seq2Range.isEmpty){const m=y>0?p[y-1].seq1Range.endExclusive:-1,e=y+1<p.length?p[y+1].seq1Range.start:l.length;p[y]=_(L.reverse(),h,l,e,m).reverse()}}return p}t.shiftSequenceDiffs=M;function _(l,h,p,y,L){let e=1;for(;l.seq2Range.start-e>L&&p.getElement(l.seq2Range.start-e)===p.getElement(l.seq2Range.endExclusive-e)&&e<20;)e++;e--;let A=0;for(;l.seq2Range.start+A<y&&p.getElement(l.seq2Range.start+A)===p.getElement(l.seq2Range.endExclusive+A)&&A<20;)A++;if(e===0&&A===0)return l;let D=0,R=-1;for(let b=-e;b<=A;b++){const d=l.seq2Range.start+b,N=l.seq2Range.endExclusive+b,w=l.seq1Range.start+b,r=h.getBoundaryScore(w)+p.getBoundaryScore(d)+p.getBoundaryScore(N);r>R&&(R=r,D=b)}return D!==0?new P.SequenceDiff(l.seq1Range.delta(D),l.seq2Range.delta(D)):l}}),J(ee[34],te([0,1,7]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class I{compute(l,h){if(l.length===0)return[new P.SequenceDiff(new P.OffsetRange(0,0),new P.OffsetRange(0,h.length))];if(h.length===0)return[new P.SequenceDiff(new P.OffsetRange(0,l.length),new P.OffsetRange(0,0))];function p(d,N){for(;d<l.length&&N<h.length&&l.getElement(d)===h.getElement(N);)d++,N++;return d}let y=0;const L=new u;L.set(0,p(0,0));const m=new M;m.set(0,L.get(0)===0?null:new i(null,0,0,L.get(0)));let e=0;e:for(;;)for(y++,e=-y;e<=y;e+=2){const d=e===y?-1:L.get(e+1),N=e===-y?-1:L.get(e-1)+1,w=Math.min(Math.max(d,N),l.length),r=w-e,s=p(w,r);L.set(e,s);const o=w===d?m.get(e+1):m.get(e-1);if(m.set(e,s!==w?new i(o,w,r,s-w):o),L.get(e)===l.length&&L.get(e)-e===h.length)break e}let A=m.get(e);const D=[];let R=l.length,b=h.length;for(;;){const d=A?A.x+A.length:0,N=A?A.y+A.length:0;if((d!==R||N!==b)&&D.push(new P.SequenceDiff(new P.OffsetRange(d,R),new P.OffsetRange(N,b))),!A)break;R=A.x,b=A.y,A=A.prev}return D.reverse(),D}}t.MyersDiffAlgorithm=I;class i{constructor(l,h,p,y){this.prev=l,this.x=h,this.y=p,this.length=y}}class u{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,h){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const p=this.negativeArr;this.negativeArr=new Int32Array(p.length*2),this.negativeArr.set(p)}this.negativeArr[l]=h}else{if(l>=this.positiveArr.length){const p=this.positiveArr;this.positiveArr=new Int32Array(p.length*2),this.positiveArr.set(p)}this.positiveArr[l]=h}}}class M{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,h){l<0?(l=-l-1,this.negativeArr[l]=h):this.positiveArr[l]=h}}}),J(ee[35],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class P{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,M){this.array[i+u*this.width]=M}}t.Array2D=P}),J(ee[36],te([0,1,7,35]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class i{compute(M,_,l){const h=new I.Array2D(M.length,_.length),p=new I.Array2D(M.length,_.length),y=new I.Array2D(M.length,_.length);for(let b=0;b<M.length;b++)for(let d=0;d<_.length;d++){const N=b===0?0:h.get(b-1,d),w=d===0?0:h.get(b,d-1);let r;M.getElement(b)===_.getElement(d)?(b===0||d===0?r=0:r=h.get(b-1,d-1),b>0&&d>0&&p.get(b-1,d-1)===3&&(r+=y.get(b-1,d-1)),r+=l?l(b,d):1):r=-1;const s=Math.max(N,w,r);if(s===r){const o=b>0&&d>0?y.get(b-1,d-1):0;y.set(b,d,o+1),p.set(b,d,3)}else s===N?(y.set(b,d,0),p.set(b,d,1)):s===w&&(y.set(b,d,0),p.set(b,d,2));h.set(b,d,s)}const L=[];let m=M.length,e=_.length;function A(b,d){(b+1!==m||d+1!==e)&&L.push(new P.SequenceDiff(new P.OffsetRange(b+1,m),new P.OffsetRange(d+1,e))),m=b,e=d}let D=M.length-1,R=_.length-1;for(;D>=0&&R>=0;)p.get(D,R)===3?(A(D,R),D--,R--):p.get(D,R)===1?D--:R--;return A(-1,-1),L.reverse(),L}}t.DynamicProgrammingDiffing=i}),J(ee[12],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.LineRangeMapping=void 0;class P{constructor(u,M,_){this.originalRange=u,this.modifiedRange=M,this.innerChanges=_}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=P;class I{constructor(u,M){this.originalRange=u,this.modifiedRange=M}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=I}),J(ee[37],te([0,1,10,20,3,2,7,36,33,34,12]),function(q,t,P,I,i,u,M,_,l,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class y{constructor(){this.dynamicProgrammingDiffing=new _.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new h.MyersDiffAlgorithm}computeDiff(o,a,v){const c=new Map;function f($){let n=c.get($);return n===void 0&&(n=c.size,c.set($,n)),n}const E=o.map($=>f($.trim())),g=a.map($=>f($.trim())),F=new e(E,o),C=new e(g,a);let O=(()=>F.length+C.length<1500?this.dynamicProgrammingDiffing.compute(F,C,($,n)=>o[$]===a[n]?a[n].length===0?.1:1+Math.log(1+a[n].length):.99):this.myersDiffingAlgorithm.compute(F,C))();O=(0,l.optimizeSequenceDiffs)(F,C,O);const W=[],x=$=>{for(let n=0;n<$;n++){const ue=j+n,ae=K+n;if(o[ue]!==a[ae]){const ie=this.refineDiff(o,a,new M.SequenceDiff(new M.OffsetRange(ue,ue+1),new M.OffsetRange(ae,ae+1)));for(const be of ie)W.push(be)}}};let j=0,K=0;for(const $ of O){(0,P.assertFn)(()=>$.seq1Range.start-j===$.seq2Range.start-K);const n=$.seq1Range.start-j;x(n),j=$.seq1Range.endExclusive,K=$.seq2Range.endExclusive;const ue=this.refineDiff(o,a,$);for(const ae of ue)W.push(ae)}x(o.length-j);const X=L(W);return{quitEarly:!1,changes:X}}refineDiff(o,a,v){const c=new D(o,v.seq1Range),f=new D(a,v.seq2Range),E=c.length+f.length<500?this.dynamicProgrammingDiffing.compute(c,f):this.myersDiffingAlgorithm.compute(c,f);function g(W,x){const j=[];for(;W.length>0||x.length>0;){const K=W[0],X=x[0];let $;K&&(!X||K.seq1Range.start<X.seq1Range.start)?$=W.shift():$=x.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=$.seq1Range.start?j[j.length-1]=j[j.length-1].join($):j.push($)}return j}function F(W,x,j){const K=[];let X;function $(){if(!X)return;const ue=X.s1Range.length-X.deleted,ae=X.s2Range.length-X.added;if(ue!==ae){X=void 0;return}Math.max(X.deleted,X.added)+(X.count-1)>ue&&K.push(new M.SequenceDiff(X.s1Range,X.s2Range)),X=void 0}for(const ue of j){let ae=function(pe,we){(!X||!X.s1Range.equals(pe)||!X.s2Range.equals(we))&&(X&&X.s1Range.endExclusive<pe.start&&X.s2Range.endExclusive<we.start&&$(),X={added:0,deleted:0,count:0,s1Range:pe,s2Range:we});const ye=pe.intersect(ue.seq1Range),Ne=we.intersect(ue.seq2Range);X.count++,X.added+=Ne?.length??0,X.deleted+=ye?.length??0};const ie=W.findWordContaining(ue.seq1Range.start-1),be=x.findWordContaining(ue.seq2Range.start-1),_e=W.findWordContaining(ue.seq1Range.endExclusive),Le=x.findWordContaining(ue.seq2Range.endExclusive);ie&&_e&&be&&Le&&ie.equals(_e)&&be.equals(Le)?ae(ie,be):(ie&&be&&ae(ie,be),_e&&Le&&ae(_e,Le))}return $(),g(j,K)}let C=E;return C=F(c,f,C),C=(0,l.optimizeSequenceDiffs)(c,f,C),C=(0,l.smoothenSequenceDiffs)(c,f,C),C.map(W=>new p.RangeMapping(c.translateRange(W.seq1Range).delta(v.seq1Range.start),f.translateRange(W.seq2Range).delta(v.seq2Range.start)))}}t.StandardLinesDiffComputer=y;function L(s){const o=[];for(const a of m(s,(v,c)=>c.originalRange.startLineNumber-(v.originalRange.endLineNumber-(v.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(v.modifiedRange.endLineNumber-(v.modifiedRange.endColumn>1?0:1))<=1)){const v=a[0],c=a[a.length-1];o.push(new p.LineRangeMapping(new I.LineRange(v.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new I.LineRange(v.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),a))}return(0,P.assertFn)(()=>(0,P.checkAdjacentItems)(o,(a,v)=>v.originalRange.startLineNumber-a.originalRange.endLineNumberExclusive===v.modifiedRange.startLineNumber-a.modifiedRange.endLineNumberExclusive&&a.originalRange.endLineNumberExclusive<v.originalRange.startLineNumber&&a.modifiedRange.endLineNumberExclusive<v.modifiedRange.startLineNumber)),o}t.lineRangeMappingFromRangeMappings=L;function*m(s,o){let a,v;for(const c of s)v!==void 0&&o(v,c)?a.push(c):(a&&(yield a),a=[c]),v=c;a&&(yield a)}class e{constructor(o,a){this.trimmedHash=o,this.lines=a}getElement(o){return this.trimmedHash[o]}get length(){return this.trimmedHash.length}getBoundaryScore(o){const a=o===0?0:A(this.lines[o-1]),v=o===this.lines.length?0:A(this.lines[o]);return 1e3-(a+v)}}t.LineSequence=e;function A(s){let o=0;for(;o<s.length&&(s.charCodeAt(o)===32||s.charCodeAt(o)===9);)o++;return o}class D{constructor(o,a){this.lines=o,this.lineRange=a;let v=0;this.firstCharOnLineOffsets=new Int32Array(a.length);for(let f=a.start;f<a.endExclusive;f++)v+=o[f].length,this.firstCharOnLineOffsets[f-a.start]=v+1,v++;this.elements=new Int32Array(v);let c=0;for(let f=a.start;f<a.endExclusive;f++){const E=o[f];for(let g=0;g<E.length;g++)this.elements[c+g]=E.charCodeAt(g);c+=E.length,f<o.length-1&&(this.elements[c]=`
`.charCodeAt(0),c+=1)}}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(o=>String.fromCharCode(o)).join("")}getElement(o){return this.elements[o]}get length(){return this.elements.length}getBoundaryScore(o){const a=w(o>0?this.elements[o-1]:-1),v=w(o<this.elements.length?this.elements[o]:-1);if(a===6&&v===7)return 0;let c=0;return a!==v&&(c+=10,v===1&&(c+=1)),c+=N(a),c+=N(v),c}translateOffset(o){let a=0,v=this.firstCharOnLineOffsets.length;for(;a<v;){const f=Math.floor((a+v)/2);this.firstCharOnLineOffsets[f]>o?v=f:a=f+1}const c=a===0?0:this.firstCharOnLineOffsets[a-1];return new i.Position(a+1,o-c+1)}translateRange(o){return u.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.elements.length||!R(this.elements[o]))return;let a=o;for(;a>0&&R(this.elements[a-1]);)a--;let v=o;for(;v<this.elements.length&&R(this.elements[v]);)v++;return new M.OffsetRange(a,v)}}function R(s){return s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57}var b;(function(s){s[s.WordLower=0]="WordLower",s[s.WordUpper=1]="WordUpper",s[s.WordNumber=2]="WordNumber",s[s.End=3]="End",s[s.Other=4]="Other",s[s.Space=5]="Space",s[s.LineBreakCR=6]="LineBreakCR",s[s.LineBreakLF=7]="LineBreakLF"})(b||(b={}));const d={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function N(s){return d[s]}function w(s){return s===10?7:s===13?6:r(s)?5:s>=97&&s<=122?0:s>=65&&s<=90?1:s>=48&&s<=57?2:s===-1?3:4}function r(s){return s===32||s===9}}),J(ee[38],te([0,1,19]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=t.State||(t.State={}));class i{constructor(e,A,D){const R=new Uint8Array(e*A);for(let b=0,d=e*A;b<d;b++)R[b]=D;this._data=R,this.rows=e,this.cols=A}get(e,A){return this._data[e*this.cols+A]}set(e,A,D){this._data[e*this.cols+A]=D}}class u{constructor(e){let A=0,D=0;for(let b=0,d=e.length;b<d;b++){const[N,w,r]=e[b];w>A&&(A=w),N>D&&(D=N),r>D&&(D=r)}A++,D++;const R=new i(D,A,0);for(let b=0,d=e.length;b<d;b++){const[N,w,r]=e[b];R.set(N,w,r)}this._states=R,this._maxCharCode=A}nextState(e,A){return A<0||A>=this._maxCharCode?0:this._states.get(e,A)}}t.StateMachine=u;let M=null;function _(){return M===null&&(M=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let h=null;function p(){if(h===null){h=new P.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<m.length;A++)h.set(m.charCodeAt(A),1);const e=".,;:";for(let A=0;A<e.length;A++)h.set(e.charCodeAt(A),2)}return h}class y{static _createLink(e,A,D,R,b){let d=b-1;do{const N=A.charCodeAt(d);if(e.get(N)!==2)break;d--}while(d>R);if(R>0){const N=A.charCodeAt(R-1),w=A.charCodeAt(d);(N===40&&w===41||N===91&&w===93||N===123&&w===125)&&d--}return{range:{startLineNumber:D,startColumn:R+1,endLineNumber:D,endColumn:d+2},url:A.substring(R,d+1)}}static computeLinks(e,A=_()){const D=p(),R=[];for(let b=1,d=e.getLineCount();b<=d;b++){const N=e.getLineContent(b),w=N.length;let r=0,s=0,o=0,a=1,v=!1,c=!1,f=!1,E=!1;for(;r<w;){let g=!1;const F=N.charCodeAt(r);if(a===13){let C;switch(F){case 40:v=!0,C=0;break;case 41:C=v?0:1;break;case 91:f=!0,c=!0,C=0;break;case 93:f=!1,C=c?0:1;break;case 123:E=!0,C=0;break;case 125:C=E?0:1;break;case 39:case 34:case 96:o===F?C=1:o===39||o===34||o===96?C=0:C=1;break;case 42:C=o===42?1:0;break;case 124:C=o===124?1:0;break;case 32:C=f?0:1;break;default:C=D.get(F)}C===1&&(R.push(y._createLink(D,N,b,s,r)),g=!0)}else if(a===12){let C;F===91?(c=!0,C=0):C=D.get(F),C===1?g=!0:a=13}else a=A.nextState(a,F),a===0&&(g=!0);g&&(a=1,v=!1,c=!1,E=!1,s=r+1,o=F),r++}a===13&&R.push(y._createLink(D,N,b,s,w))}return R}}t.LinkComputer=y;function L(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:y.computeLinks(m)}t.computeLinks=L}),J(ee[39],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,M,_,l){if(i&&u){const h=this.doNavigateValueSet(u,l);if(h)return{range:i,value:h}}if(M&&_){const h=this.doNavigateValueSet(_,l);if(h)return{range:M,value:h}}return null}doNavigateValueSet(i,u){const M=this.numberReplace(i,u);return M!==null?M:this.textReplace(i,u)}numberReplace(i,u){const M=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let _=Number(i);const l=parseFloat(i);return!isNaN(_)&&!isNaN(l)&&_===l?_===0&&!u?null:(_=Math.floor(_*M),_+=u?M:-M,String(_/M)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,M){let _=null;for(let l=0,h=i.length;_===null&&l<h;l++)_=this.valueSetReplace(i[l],u,M);return _}valueSetReplace(i,u,M){let _=i.indexOf(u);return _>=0?(_+=M?1:-1,_<0?_=i.length-1:_%=i.length,i[_]):null}}P.INSTANCE=new P,t.BasicInplaceReplace=P}),J(ee[40],te([0,1,11]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var I;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(I=t.OverviewRulerLane||(t.OverviewRulerLane={}));var i;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(i=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(u=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var M;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(M=t.EndOfLinePreference||(t.EndOfLinePreference={}));var _;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(_=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var l;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(l=t.EndOfLineSequence||(t.EndOfLineSequence={}));class h{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(N){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,N.tabSize|0),N.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,N.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(N.insertSpaces),this.defaultEOL=N.defaultEOL|0,this.trimAutoWhitespace=Boolean(N.trimAutoWhitespace),this.bracketPairColorizationOptions=N.bracketPairColorizationOptions}equals(N){return this.tabSize===N.tabSize&&this._indentSizeIsTabSize===N._indentSizeIsTabSize&&this.indentSize===N.indentSize&&this.insertSpaces===N.insertSpaces&&this.defaultEOL===N.defaultEOL&&this.trimAutoWhitespace===N.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,N.bracketPairColorizationOptions)}createChangeEvent(N){return{tabSize:this.tabSize!==N.tabSize,indentSize:this.indentSize!==N.indentSize,insertSpaces:this.insertSpaces!==N.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==N.trimAutoWhitespace}}}t.TextModelResolvedOptions=h;class p{constructor(N,w){this._findMatchBrand=void 0,this.range=N,this.matches=w}}t.FindMatch=p;var y;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function L(d){return d&&typeof d.read=="function"}t.isITextSnapshot=L;var m;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(m=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class A{constructor(N,w,r,s,o,a){this.identifier=N,this.range=w,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=a}}t.ValidAnnotatedEditOperation=A;class D{constructor(N,w,r){this.regex=N,this.wordSeparators=w,this.simpleSearch=r}}t.SearchData=D;class R{constructor(N,w,r){this.reverseEdits=N,this.changes=w,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=R;function b(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}t.shouldSynchronizeModel=b}),J(ee[41],te([0,1,27,18]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,h){l=(0,I.toUint32)(l);const p=this.values,y=this.prefixSum,L=h.length;return L===0?!1:(this.values=new Uint32Array(p.length+L),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l),l+L),this.values.set(h,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,h){return l=(0,I.toUint32)(l),h=(0,I.toUint32)(h),this.values[l]===h?!1:(this.values[l]=h,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,h){l=(0,I.toUint32)(l),h=(0,I.toUint32)(h);const p=this.values,y=this.prefixSum;if(l>=p.length)return!1;const L=p.length-l;return h>=L&&(h=L),h===0?!1:(this.values=new Uint32Array(p.length-h),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l+h),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,I.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let h=this.prefixSumValidIndex[0]+1;h===0&&(this.prefixSum[0]=this.values[0],h++),l>=this.values.length&&(l=this.values.length-1);for(let p=h;p<=l;p++)this.prefixSum[p]=this.prefixSum[p-1]+this.values[p];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let h=0,p=this.values.length-1,y=0,L=0,m=0;for(;h<=p;)if(y=h+(p-h)/2|0,L=this.prefixSum[y],m=L-this.values[y],l<m)p=y-1;else if(l>=L)h=y+1;else break;return new M(y,l-m)}}t.PrefixSumComputer=i;class u{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const h=this._indexBySum[l],p=h>0?this._prefixSum[h-1]:0;return new M(h,l-p)}removeValues(l,h){this._values.splice(l,h),this._invalidate(l)}insertValues(l,h){this._values=(0,P.arrayInsert)(this._values,l,h),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,h=this._values.length;l<h;l++){const p=this._values[l],y=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=y+p;for(let L=0;L<p;L++)this._indexBySum[y+L]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,h){this._values[l]!==h&&(this._values[l]=h,this._invalidate(l))}}t.ConstantTimePrefixSumComputer=u;class M{constructor(l,h){this.index=l,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=h}}t.PrefixSumIndexOfResult=M}),J(ee[42],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var P;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(P=t.AccessibilitySupport||(t.AccessibilitySupport={}));var I;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(I=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u=t.CompletionItemKind||(t.CompletionItemKind={}));var M;(function(n){n[n.Deprecated=1]="Deprecated"})(M=t.CompletionItemTag||(t.CompletionItemTag={}));var _;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var h;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(h=t.CursorChangeReason||(t.CursorChangeReason={}));var p;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var y;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(y=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var L;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(L=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.parameterHints=82]="parameterHints",n[n.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",n[n.quickSuggestions=85]="quickSuggestions",n[n.quickSuggestionsDelay=86]="quickSuggestionsDelay",n[n.readOnly=87]="readOnly",n[n.renameOnType=88]="renameOnType",n[n.renderControlCharacters=89]="renderControlCharacters",n[n.renderFinalNewline=90]="renderFinalNewline",n[n.renderLineHighlight=91]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=93]="renderValidationDecorations",n[n.renderWhitespace=94]="renderWhitespace",n[n.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",n[n.roundedSelection=96]="roundedSelection",n[n.rulers=97]="rulers",n[n.scrollbar=98]="scrollbar",n[n.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=100]="scrollBeyondLastLine",n[n.scrollPredominantAxis=101]="scrollPredominantAxis",n[n.selectionClipboard=102]="selectionClipboard",n[n.selectionHighlight=103]="selectionHighlight",n[n.selectOnLineNumbers=104]="selectOnLineNumbers",n[n.showFoldingControls=105]="showFoldingControls",n[n.showUnused=106]="showUnused",n[n.snippetSuggestions=107]="snippetSuggestions",n[n.smartSelect=108]="smartSelect",n[n.smoothScrolling=109]="smoothScrolling",n[n.stickyScroll=110]="stickyScroll",n[n.stickyTabStops=111]="stickyTabStops",n[n.stopRenderingLineAfter=112]="stopRenderingLineAfter",n[n.suggest=113]="suggest",n[n.suggestFontSize=114]="suggestFontSize",n[n.suggestLineHeight=115]="suggestLineHeight",n[n.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",n[n.suggestSelection=117]="suggestSelection",n[n.tabCompletion=118]="tabCompletion",n[n.tabIndex=119]="tabIndex",n[n.unicodeHighlighting=120]="unicodeHighlighting",n[n.unusualLineTerminators=121]="unusualLineTerminators",n[n.useShadowDOM=122]="useShadowDOM",n[n.useTabStops=123]="useTabStops",n[n.wordBreak=124]="wordBreak",n[n.wordSeparators=125]="wordSeparators",n[n.wordWrap=126]="wordWrap",n[n.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=129]="wordWrapColumn",n[n.wordWrapOverride1=130]="wordWrapOverride1",n[n.wordWrapOverride2=131]="wordWrapOverride2",n[n.wrappingIndent=132]="wrappingIndent",n[n.wrappingStrategy=133]="wrappingStrategy",n[n.showDeprecated=134]="showDeprecated",n[n.inlayHints=135]="inlayHints",n[n.editorClassName=136]="editorClassName",n[n.pixelRatio=137]="pixelRatio",n[n.tabFocusMode=138]="tabFocusMode",n[n.layoutInfo=139]="layoutInfo",n[n.wrappingInfo=140]="wrappingInfo"})(m=t.EditorOption||(t.EditorOption={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var A;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(A=t.EndOfLineSequence||(t.EndOfLineSequence={}));var D;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(D=t.IndentAction||(t.IndentAction={}));var R;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(R=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var b;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b=t.InlayHintKind||(t.InlayHintKind={}));var d;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(d=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var N;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(N=t.KeyCode||(t.KeyCode={}));var w;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(w=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var o;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(o=t.MouseTargetType||(t.MouseTargetType={}));var a;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(a=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var v;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(v=t.OverviewRulerLane||(t.OverviewRulerLane={}));var c;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(c=t.PositionAffinity||(t.PositionAffinity={}));var f;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(f=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var E;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(E=t.RenderMinimap||(t.RenderMinimap={}));var g;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(g=t.ScrollType||(t.ScrollType={}));var F;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(F=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var C;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W=t.SymbolKind||(t.SymbolKind={}));var x;(function(n){n[n.Deprecated=1]="Deprecated"})(x=t.SymbolTag||(t.SymbolTag={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var K;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(K=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var X;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(X=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var $;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})($=t.WrappingIndent||(t.WrappingIndent={}))}),J(ee[43],te([56,57]),function(q,t){return q.create("vs/base/common/platform",t)}),J(ee[8],te([0,1,43]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let I=!1,i=!1,u=!1,M=!1,_=!1,l=!1,h=!1,p=!1,y=!1,L=!1,m,e=t.LANGUAGE_DEFAULT,A=t.LANGUAGE_DEFAULT,D,R;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?b=t.globals.vscode.process:typeof process<"u"&&(b=process);const d=typeof b?.versions?.electron=="string",N=d&&b?.type==="renderer";if(typeof navigator=="object"&&!N)R=navigator.userAgent,I=R.indexOf("Windows")>=0,i=R.indexOf("Macintosh")>=0,p=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=R.indexOf("Linux")>=0,L=R?.indexOf("Mobi")>=0,l=!0,m=P.getConfiguredDefaultLocale(P.localize(0,null))||t.LANGUAGE_DEFAULT,e=m,A=navigator.language;else if(typeof b=="object"){I=b.platform==="win32",i=b.platform==="darwin",u=b.platform==="linux",M=u&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,h=d,y=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const E=b.env.VSCODE_NLS_CONFIG;if(E)try{const g=JSON.parse(E),F=g.availableLanguages["*"];m=g.locale,A=g.osLocale,e=F||t.LANGUAGE_DEFAULT,D=g._translationsConfigFile}catch{}_=!0}else console.error("Unable to resolve platform.");var w;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(w=t.Platform||(t.Platform={}));function r(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=r;let s=0;i?s=1:I?s=3:u&&(s=2),t.isWindows=I,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=M,t.isNative=_,t.isElectron=h,t.isWeb=l,t.isWebWorker=l&&typeof t.globals.importScripts=="function",t.isIOS=p,t.isMobile=L,t.isCI=y,t.platform=s,t.userAgent=R,t.language=e;var o;(function(E){function g(){return t.language}E.value=g;function F(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}E.isDefaultVariant=F;function C(){return t.language==="en"}E.isDefault=C})(o=t.Language||(t.Language={})),t.locale=m,t.platformLocale=A,t.translationsConfigFile=D,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const E=[];t.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let C=0,O=E.length;C<O;C++){const W=E[C];if(W.id===F.data.vscodeScheduleAsyncWork){E.splice(C,1),W.callback();return}}});let g=0;return F=>{const C=++g;E.push({id:C,callback:F}),t.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return E=>setTimeout(E)})();var a;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(a=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||p?2:I?1:3;let v=!0,c=!1;function f(){if(!c){c=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,v=new Uint16Array(E.buffer)[0]===(2<<8)+1}return v}t.isLittleEndian=f,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),J(ee[44],te([0,1,8]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let I;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const i=P.globals.vscode.process;I={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?I={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:I={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=I.cwd,t.env=I.env,t.platform=I.platform,t.arch=I.arch}),J(ee[45],te([0,1,44]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const I=65,i=97,u=90,M=122,_=46,l=47,h=92,p=58,y=63;class L extends Error{constructor(s,o,a){let v;typeof o=="string"&&o.indexOf("not ")===0?(v="must not be",o=o.replace(/^not /,"")):v="must be";const c=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${c} ${v} of type ${o}`;f+=`. Received type ${typeof a}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,s){if(r===null||typeof r!="object")throw new L(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new L(s,"string",r)}const A=P.platform==="win32";function D(r){return r===l||r===h}function R(r){return r===l}function b(r){return r>=I&&r<=u||r>=i&&r<=M}function d(r,s,o,a){let v="",c=0,f=-1,E=0,g=0;for(let F=0;F<=r.length;++F){if(F<r.length)g=r.charCodeAt(F);else{if(a(g))break;g=l}if(a(g)){if(!(f===F-1||E===1))if(E===2){if(v.length<2||c!==2||v.charCodeAt(v.length-1)!==_||v.charCodeAt(v.length-2)!==_){if(v.length>2){const C=v.lastIndexOf(o);C===-1?(v="",c=0):(v=v.slice(0,C),c=v.length-1-v.lastIndexOf(o)),f=F,E=0;continue}else if(v.length!==0){v="",c=0,f=F,E=0;continue}}s&&(v+=v.length>0?`${o}..`:"..",c=2)}else v.length>0?v+=`${o}${r.slice(f+1,F)}`:v=r.slice(f+1,F),c=F-f-1;f=F,E=0}else g===_&&E!==-1?++E:E=-1}return v}function N(r,s){m(s,"pathObject");const o=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${a}`:`${o}${r}${a}`:a}t.win32={resolve(...r){let s="",o="",a=!1;for(let v=r.length-1;v>=-1;v--){let c;if(v>=0){if(c=r[v],e(c,"path"),c.length===0)continue}else s.length===0?c=P.cwd():(c=P.env[`=${s}`]||P.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===h)&&(c=`${s}\\`));const f=c.length;let E=0,g="",F=!1;const C=c.charCodeAt(0);if(f===1)D(C)&&(E=1,F=!0);else if(D(C))if(F=!0,D(c.charCodeAt(1))){let O=2,W=O;for(;O<f&&!D(c.charCodeAt(O));)O++;if(O<f&&O!==W){const x=c.slice(W,O);for(W=O;O<f&&D(c.charCodeAt(O));)O++;if(O<f&&O!==W){for(W=O;O<f&&!D(c.charCodeAt(O));)O++;(O===f||O!==W)&&(g=`\\\\${x}\\${c.slice(W,O)}`,E=O)}}}else E=1;else b(C)&&c.charCodeAt(1)===p&&(g=c.slice(0,2),E=2,f>2&&D(c.charCodeAt(2))&&(F=!0,E=3));if(g.length>0)if(s.length>0){if(g.toLowerCase()!==s.toLowerCase())continue}else s=g;if(a){if(s.length>0)break}else if(o=`${c.slice(E)}\\${o}`,a=F,F&&s.length>0)break}return o=d(o,!a,"\\",D),a?`${s}\\${o}`:`${s}${o}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let o=0,a,v=!1;const c=r.charCodeAt(0);if(s===1)return R(c)?"\\":r;if(D(c))if(v=!0,D(r.charCodeAt(1))){let E=2,g=E;for(;E<s&&!D(r.charCodeAt(E));)E++;if(E<s&&E!==g){const F=r.slice(g,E);for(g=E;E<s&&D(r.charCodeAt(E));)E++;if(E<s&&E!==g){for(g=E;E<s&&!D(r.charCodeAt(E));)E++;if(E===s)return`\\\\${F}\\${r.slice(g)}\\`;E!==g&&(a=`\\\\${F}\\${r.slice(g,E)}`,o=E)}}}else o=1;else b(c)&&r.charCodeAt(1)===p&&(a=r.slice(0,2),o=2,s>2&&D(r.charCodeAt(2))&&(v=!0,o=3));let f=o<s?d(r.slice(o),!v,"\\",D):"";return f.length===0&&!v&&(f="."),f.length>0&&D(r.charCodeAt(s-1))&&(f+="\\"),a===void 0?v?`\\${f}`:f:v?`${a}\\${f}`:`${a}${f}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const o=r.charCodeAt(0);return D(o)||s>2&&b(o)&&r.charCodeAt(1)===p&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,o;for(let c=0;c<r.length;++c){const f=r[c];e(f,"path"),f.length>0&&(s===void 0?s=o=f:s+=`\\${f}`)}if(s===void 0)return".";let a=!0,v=0;if(typeof o=="string"&&D(o.charCodeAt(0))){++v;const c=o.length;c>1&&D(o.charCodeAt(1))&&(++v,c>2&&(D(o.charCodeAt(2))?++v:a=!1))}if(a){for(;v<s.length&&D(s.charCodeAt(v));)v++;v>=2&&(s=`\\${s.slice(v)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const o=t.win32.resolve(r),a=t.win32.resolve(s);if(o===a||(r=o.toLowerCase(),s=a.toLowerCase(),r===s))return"";let v=0;for(;v<r.length&&r.charCodeAt(v)===h;)v++;let c=r.length;for(;c-1>v&&r.charCodeAt(c-1)===h;)c--;const f=c-v;let E=0;for(;E<s.length&&s.charCodeAt(E)===h;)E++;let g=s.length;for(;g-1>E&&s.charCodeAt(g-1)===h;)g--;const F=g-E,C=f<F?f:F;let O=-1,W=0;for(;W<C;W++){const j=r.charCodeAt(v+W);if(j!==s.charCodeAt(E+W))break;j===h&&(O=W)}if(W!==C){if(O===-1)return a}else{if(F>C){if(s.charCodeAt(E+W)===h)return a.slice(E+W+1);if(W===2)return a.slice(E+W)}f>C&&(r.charCodeAt(v+W)===h?O=W:W===2&&(O=3)),O===-1&&(O=0)}let x="";for(W=v+O+1;W<=c;++W)(W===c||r.charCodeAt(W)===h)&&(x+=x.length===0?"..":"\\..");return E+=O,x.length>0?`${x}${a.slice(E,g)}`:(a.charCodeAt(E)===h&&++E,a.slice(E,g))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===h){if(s.charCodeAt(1)===h){const o=s.charCodeAt(2);if(o!==y&&o!==_)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(b(s.charCodeAt(0))&&s.charCodeAt(1)===p&&s.charCodeAt(2)===h)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let o=-1,a=0;const v=r.charCodeAt(0);if(s===1)return D(v)?r:".";if(D(v)){if(o=a=1,D(r.charCodeAt(1))){let E=2,g=E;for(;E<s&&!D(r.charCodeAt(E));)E++;if(E<s&&E!==g){for(g=E;E<s&&D(r.charCodeAt(E));)E++;if(E<s&&E!==g){for(g=E;E<s&&!D(r.charCodeAt(E));)E++;if(E===s)return r;E!==g&&(o=a=E+1)}}}}else b(v)&&r.charCodeAt(1)===p&&(o=s>2&&D(r.charCodeAt(2))?3:2,a=o);let c=-1,f=!0;for(let E=s-1;E>=a;--E)if(D(r.charCodeAt(E))){if(!f){c=E;break}}else f=!1;if(c===-1){if(o===-1)return".";c=o}return r.slice(0,c)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let o=0,a=-1,v=!0,c;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===p&&(o=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,E=-1;for(c=r.length-1;c>=o;--c){const g=r.charCodeAt(c);if(D(g)){if(!v){o=c+1;break}}else E===-1&&(v=!1,E=c+1),f>=0&&(g===s.charCodeAt(f)?--f===-1&&(a=c):(f=-1,a=E))}return o===a?a=E:a===-1&&(a=r.length),r.slice(o,a)}for(c=r.length-1;c>=o;--c)if(D(r.charCodeAt(c))){if(!v){o=c+1;break}}else a===-1&&(v=!1,a=c+1);return a===-1?"":r.slice(o,a)},extname(r){e(r,"path");let s=0,o=-1,a=0,v=-1,c=!0,f=0;r.length>=2&&r.charCodeAt(1)===p&&b(r.charCodeAt(0))&&(s=a=2);for(let E=r.length-1;E>=s;--E){const g=r.charCodeAt(E);if(D(g)){if(!c){a=E+1;break}continue}v===-1&&(c=!1,v=E+1),g===_?o===-1?o=E:f!==1&&(f=1):o!==-1&&(f=-1)}return o===-1||v===-1||f===0||f===1&&o===v-1&&o===a+1?"":r.slice(o,v)},format:N.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const o=r.length;let a=0,v=r.charCodeAt(0);if(o===1)return D(v)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(D(v)){if(a=1,D(r.charCodeAt(1))){let O=2,W=O;for(;O<o&&!D(r.charCodeAt(O));)O++;if(O<o&&O!==W){for(W=O;O<o&&D(r.charCodeAt(O));)O++;if(O<o&&O!==W){for(W=O;O<o&&!D(r.charCodeAt(O));)O++;O===o?a=O:O!==W&&(a=O+1)}}}}else if(b(v)&&r.charCodeAt(1)===p){if(o<=2)return s.root=s.dir=r,s;if(a=2,D(r.charCodeAt(2))){if(o===3)return s.root=s.dir=r,s;a=3}}a>0&&(s.root=r.slice(0,a));let c=-1,f=a,E=-1,g=!0,F=r.length-1,C=0;for(;F>=a;--F){if(v=r.charCodeAt(F),D(v)){if(!g){f=F+1;break}continue}E===-1&&(g=!1,E=F+1),v===_?c===-1?c=F:C!==1&&(C=1):c!==-1&&(C=-1)}return E!==-1&&(c===-1||C===0||C===1&&c===E-1&&c===f+1?s.base=s.name=r.slice(f,E):(s.name=r.slice(f,c),s.base=r.slice(f,E),s.ext=r.slice(c,E))),f>0&&f!==a?s.dir=r.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(A){const r=/\\/g;return()=>{const s=P.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>P.cwd()})();t.posix={resolve(...r){let s="",o=!1;for(let a=r.length-1;a>=-1&&!o;a--){const v=a>=0?r[a]:w();e(v,"path"),v.length!==0&&(s=`${v}/${s}`,o=v.charCodeAt(0)===l)}return s=d(s,!o,"/",R),o?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l,o=r.charCodeAt(r.length-1)===l;return r=d(r,!s,"/",R),r.length===0?s?"/":o?"./":".":(o&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let s;for(let o=0;o<r.length;++o){const a=r[o];e(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const o=1,a=r.length,v=a-o,c=1,f=s.length-c,E=v<f?v:f;let g=-1,F=0;for(;F<E;F++){const O=r.charCodeAt(o+F);if(O!==s.charCodeAt(c+F))break;O===l&&(g=F)}if(F===E)if(f>E){if(s.charCodeAt(c+F)===l)return s.slice(c+F+1);if(F===0)return s.slice(c+F)}else v>E&&(r.charCodeAt(o+F)===l?g=F:F===0&&(g=0));let C="";for(F=o+g+1;F<=a;++F)(F===a||r.charCodeAt(F)===l)&&(C+=C.length===0?"..":"/..");return`${C}${s.slice(c+g)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l;let o=-1,a=!0;for(let v=r.length-1;v>=1;--v)if(r.charCodeAt(v)===l){if(!a){o=v;break}}else a=!1;return o===-1?s?"/":".":s&&o===1?"//":r.slice(0,o)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let o=0,a=-1,v=!0,c;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,E=-1;for(c=r.length-1;c>=0;--c){const g=r.charCodeAt(c);if(g===l){if(!v){o=c+1;break}}else E===-1&&(v=!1,E=c+1),f>=0&&(g===s.charCodeAt(f)?--f===-1&&(a=c):(f=-1,a=E))}return o===a?a=E:a===-1&&(a=r.length),r.slice(o,a)}for(c=r.length-1;c>=0;--c)if(r.charCodeAt(c)===l){if(!v){o=c+1;break}}else a===-1&&(v=!1,a=c+1);return a===-1?"":r.slice(o,a)},extname(r){e(r,"path");let s=-1,o=0,a=-1,v=!0,c=0;for(let f=r.length-1;f>=0;--f){const E=r.charCodeAt(f);if(E===l){if(!v){o=f+1;break}continue}a===-1&&(v=!1,a=f+1),E===_?s===-1?s=f:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||a===-1||c===0||c===1&&s===a-1&&s===o+1?"":r.slice(s,a)},format:N.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const o=r.charCodeAt(0)===l;let a;o?(s.root="/",a=1):a=0;let v=-1,c=0,f=-1,E=!0,g=r.length-1,F=0;for(;g>=a;--g){const C=r.charCodeAt(g);if(C===l){if(!E){c=g+1;break}continue}f===-1&&(E=!1,f=g+1),C===_?v===-1?v=g:F!==1&&(F=1):v!==-1&&(F=-1)}if(f!==-1){const C=c===0&&o?1:c;v===-1||F===0||F===1&&v===f-1&&v===c+1?s.base=s.name=r.slice(C,f):(s.name=r.slice(C,v),s.base=r.slice(C,f),s.ext=r.slice(v,f))}return c>0?s.dir=r.slice(0,c-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=A?t.win32.normalize:t.posix.normalize,t.isAbsolute=A?t.win32.isAbsolute:t.posix.isAbsolute,t.join=A?t.win32.join:t.posix.join,t.resolve=A?t.win32.resolve:t.posix.resolve,t.relative=A?t.win32.relative:t.posix.relative,t.dirname=A?t.win32.dirname:t.posix.dirname,t.basename=A?t.win32.basename:t.posix.basename,t.extname=A?t.win32.extname:t.posix.extname,t.format=A?t.win32.format:t.posix.format,t.parse=A?t.win32.parse:t.posix.parse,t.toNamespacedPath=A?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=A?t.win32.sep:t.posix.sep,t.delimiter=A?t.win32.delimiter:t.posix.delimiter}),J(ee[22],te([0,1,8]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const I=P.globals.performance&&typeof P.globals.performance.now=="function";class i{static create(M=!0){return new i(M)}constructor(M){this._highResolution=I&&M,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}t.StopWatch=i}),J(ee[9],te([0,1,5,14,6,16,22]),function(q,t,P,I,i,u,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const _=!1,l=!1;var h;(function(c){c.None=()=>i.Disposable.None;function f(ne){if(l){const{onDidAddListener:Q}=ne,Z=e.create();let k=0;ne.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),Q?.()}}}function E(ne,Q){return X(ne,()=>{},0,void 0,!0,void 0,Q)}c.defer=E;function g(ne){return(Q,Z=null,k)=>{let T=!1,U;return U=ne(V=>{if(!T)return U?U.dispose():T=!0,Q.call(Z,V)},null,k),T&&U.dispose(),U}}c.once=g;function F(ne,Q,Z){return K((k,T=null,U)=>ne(V=>k.call(T,Q(V)),null,U),Z)}c.map=F;function C(ne,Q,Z){return K((k,T=null,U)=>ne(V=>{Q(V),k.call(T,V)},null,U),Z)}c.forEach=C;function O(ne,Q,Z){return K((k,T=null,U)=>ne(V=>Q(V)&&k.call(T,V),null,U),Z)}c.filter=O;function W(ne){return ne}c.signal=W;function x(...ne){return(Q,Z=null,k)=>(0,i.combinedDisposable)(...ne.map(T=>T(U=>Q.call(Z,U),null,k)))}c.any=x;function j(ne,Q,Z,k){let T=Z;return F(ne,U=>(T=Q(T,U),T),k)}c.reduce=j;function K(ne,Q){let Z;const k={onWillAddFirstListener(){Z=ne(T.fire,T)},onDidRemoveLastListener(){Z?.dispose()}};Q||f(k);const T=new D(k);return Q?.add(T),T.event}function X(ne,Q,Z=100,k=!1,T=!1,U,V){let z,re,se,oe=0,ce;const ge={leakWarningThreshold:U,onWillAddFirstListener(){z=ne(Fe=>{oe++,re=Q(re,Fe),k&&!se&&(me.fire(re),re=void 0),ce=()=>{const Ie=re;re=void 0,se=void 0,(!k||oe>1)&&me.fire(Ie),oe=0},typeof Z=="number"?(clearTimeout(se),se=setTimeout(ce,Z)):se===void 0&&(se=0,queueMicrotask(ce))})},onWillRemoveListener(){T&&oe>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,z.dispose()}};V||f(ge);const me=new D(ge);return V?.add(me),me.event}c.debounce=X;function $(ne,Q=0,Z){return c.debounce(ne,(k,T)=>k?(k.push(T),k):[T],Q,void 0,!0,void 0,Z)}c.accumulate=$;function n(ne,Q=(k,T)=>k===T,Z){let k=!0,T;return O(ne,U=>{const V=k||!Q(U,T);return k=!1,T=U,V},Z)}c.latch=n;function ue(ne,Q,Z){return[c.filter(ne,Q,Z),c.filter(ne,k=>!Q(k),Z)]}c.split=ue;function ae(ne,Q=!1,Z=[]){let k=Z.slice(),T=ne(z=>{k?k.push(z):V.fire(z)});const U=()=>{k?.forEach(z=>V.fire(z)),k=null},V=new D({onWillAddFirstListener(){T||(T=ne(z=>V.fire(z)))},onDidAddFirstListener(){k&&(Q?setTimeout(U):U())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return V.event}c.buffer=ae;class ie{constructor(Q){this.event=Q,this.disposables=new i.DisposableStore}map(Q){return new ie(F(this.event,Q,this.disposables))}forEach(Q){return new ie(C(this.event,Q,this.disposables))}filter(Q){return new ie(O(this.event,Q,this.disposables))}reduce(Q,Z){return new ie(j(this.event,Q,Z,this.disposables))}latch(){return new ie(n(this.event,void 0,this.disposables))}debounce(Q,Z=100,k=!1,T=!1,U){return new ie(X(this.event,Q,Z,k,T,U,this.disposables))}on(Q,Z,k){return this.event(Q,Z,k)}once(Q,Z,k){return g(this.event)(Q,Z,k)}dispose(){this.disposables.dispose()}}function be(ne){return new ie(ne)}c.chain=be;function _e(ne,Q,Z=k=>k){const k=(...z)=>V.fire(Z(...z)),T=()=>ne.on(Q,k),U=()=>ne.removeListener(Q,k),V=new D({onWillAddFirstListener:T,onDidRemoveLastListener:U});return V.event}c.fromNodeEventEmitter=_e;function Le(ne,Q,Z=k=>k){const k=(...z)=>V.fire(Z(...z)),T=()=>ne.addEventListener(Q,k),U=()=>ne.removeEventListener(Q,k),V=new D({onWillAddFirstListener:T,onDidRemoveLastListener:U});return V.event}c.fromDOMEventEmitter=Le;function pe(ne){return new Promise(Q=>g(ne)(Q))}c.toPromise=pe;function we(ne,Q){return Q(void 0),ne(Z=>Q(Z))}c.runAndSubscribe=we;function ye(ne,Q){let Z=null;function k(U){Z?.dispose(),Z=new i.DisposableStore,Q(U,Z)}k(void 0);const T=ne(U=>k(U));return(0,i.toDisposable)(()=>{T.dispose(),Z?.dispose()})}c.runAndSubscribeWithStore=ye;class Ne{constructor(Q,Z){this.obs=Q,this._counter=0,this._hasChanged=!1;const k={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};Z||f(k),this.emitter=new D(k),Z&&Z.add(this.emitter)}beginUpdate(Q){this._counter++}handleChange(Q,Z){this._hasChanged=!0}endUpdate(Q){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Se(ne,Q){return new Ne(ne,Q).emitter.event}c.fromObservable=Se})(h=t.Event||(t.Event={}));class p{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${p._idPool++}`,p.all.add(this)}start(f){this._stopWatch=new M.StopWatch(!0),this.listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this._stopWatch=void 0}}}p.all=new Set,p._idPool=0,t.EventProfiling=p;let y=-1;function L(c){const f=y;return y=c,{dispose(){y=f}}}t.setGlobalLeakWarningThreshold=L;class m{constructor(f,E=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=E,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(f,E){const g=this.threshold;if(g<=0||E<g)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(f.value)||0;if(this._stacks.set(f.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let C,O=0;for(const[W,x]of this._stacks)(!C||O<x)&&(C=W,O=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${O}):`),console.warn(C)}return()=>{const C=this._stacks.get(f.value)||0;this._stacks.set(f.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class A{constructor(f,E,g){this.callback=f,this.callbackThis=E,this.stack=g,this.subscription=new i.SafeDisposable}invoke(f){this.callback.call(this.callbackThis,f)}}class D{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=y>0||this._options?.leakWarningThreshold?new m(this._options?.leakWarningThreshold??y):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(_){const f=Array.from(this._listeners);queueMicrotask(()=>{for(const E of f)E.subscription.isset()&&(E.subscription.unset(),E.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(f,E,g)=>{if(this._listeners||(this._listeners=new u.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const F=this._listeners.isEmpty();F&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let C,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=e.create(),C=this._leakageMon.check(O,this._listeners.size+1)),_&&(O=O??e.create());const W=new A(f,E,O),x=this._listeners.push(W);F&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,f,E);const j=W.subscription.set(()=>{C?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),x(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return g instanceof i.DisposableStore?g.add(j):Array.isArray(g)&&g.push(j),j}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b(this._options?.onListenerError));for(const E of this._listeners)this._deliveryQueue.push(this,E,f);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=D;class R{constructor(f=P.onUnexpectedError){this._onListenerError=f,this._queue=new u.LinkedList}get size(){return this._queue.size}push(f,E,g){this._queue.push(new d(f,E,g))}clear(f){const E=new u.LinkedList;for(const g of this._queue)g.emitter!==f&&E.push(g);this._queue=E}deliver(){for(;this._queue.size>0;){const f=this._queue.shift();try{f.listener.invoke(f.event)}catch(E){this._onListenerError(E)}}}}t.EventDeliveryQueue=R;class b extends R{clear(f){this._queue.clear()}}class d{constructor(f,E,g){this.emitter=f,this.listener=E,this.event=g}}class N extends D{async fireAsync(f,E,g){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList);for(const F of this._listeners)this._asyncDeliveryQueue.push([F,f]);for(;this._asyncDeliveryQueue.size>0&&!E.isCancellationRequested;){const[F,C]=this._asyncDeliveryQueue.shift(),O=[],W={...C,token:E,waitUntil:x=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");g&&(x=g(x,F.callback)),O.push(x)}};try{F.invoke(W)}catch(x){(0,P.onUnexpectedError)(x);continue}Object.freeze(O),await Promise.allSettled(O).then(x=>{for(const j of x)j.status==="rejected"&&(0,P.onUnexpectedError)(j.reason)})}}}}t.AsyncEmitter=N;class w extends D{constructor(f){super(f),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}t.PauseableEmitter=w;class r extends w{constructor(f){super(f),this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}t.DebounceEmitter=r;class s extends D{constructor(f){super(f),this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){!this.hasListeners()||(this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=s;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new D({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const E={event:f,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const g=()=>{this.hasListeners&&this.unhook(E);const F=this.events.indexOf(E);this.events.splice(F,1)};return(0,i.toDisposable)((0,I.once)(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(E=>this.emitter.fire(E))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=o;class a{constructor(){this.buffers=[]}wrapEvent(f){return(E,g,F)=>f(C=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>E.call(g,C)):E.call(g,C)},void 0,F)}bufferEvents(f){const E=[];this.buffers.push(E);const g=f();return this.buffers.pop(),E.forEach(F=>F()),g}}t.EventBufferer=a;class v{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=i.Disposable.None,this.emitter=new D({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=v}),J(ee[23],te([0,1,9]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const I=Object.freeze(function(_,l){const h=setTimeout(_.bind(l),0);return{dispose(){clearTimeout(h)}}});var i;(function(_){function l(h){return h===_.None||h===_.Cancelled||h instanceof u?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}_.isCancellationToken=l,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(i=t.CancellationToken||(t.CancellationToken={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=M}),J(ee[46],te([0,1,23]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class I{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new P.CancellationTokenSource,l=this.task(_.token);return this.result={promise:l,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}t.Cache=I;class i{constructor(_){this.fn=_,this.lastCache=void 0,this.lastArgKey=void 0}get(_){const l=JSON.stringify(_);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(_)),this.lastCache}}t.LRUCachedFunction=i;class u{get cachedValues(){return this._map}constructor(_){this.fn=_,this._map=new Map}get(_){if(this._map.has(_))return this._map.get(_);const l=this.fn(_);return this._map.set(_,l),l}}t.CachedFunction=u}),J(ee[4],te([0,1,46,29]),function(q,t,P,I){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.isFalsyOrWhitespace=u;const M=/{(\d+)}/g;function _(S,...B){return B.length===0?S:S.replace(M,function(H,G){const Y=parseInt(G,10);return isNaN(Y)||Y<0||Y>=B.length?H:B[Y]})}t.format=_;const l=/{([^}]+)}/g;function h(S,B){return S.replace(l,(H,G)=>B[G]??H)}t.format2=h;function p(S){return S.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=p;function y(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=y;function L(S,B){let H=0;const G=B.charCodeAt(0);for(let Y=S.length-1;Y>=0;Y--)S.charCodeAt(Y)===G&&H++;return H}t.count=L;function m(S,B,H="\u2026"){return S.length<=B?S:`${S.substr(0,B)}${H}`}t.truncate=m;function e(S,B=" "){const H=A(S,B);return D(H,B)}t.trim=e;function A(S,B){if(!S||!B)return S;const H=B.length;if(H===0||S.length===0)return S;let G=0;for(;S.indexOf(B,G)===G;)G=G+H;return S.substring(G)}t.ltrim=A;function D(S,B){if(!S||!B)return S;const H=B.length,G=S.length;if(H===0||G===0)return S;let Y=G,le=-1;for(;le=S.lastIndexOf(B,Y-1),!(le===-1||le+H!==Y);){if(le===0)return"";Y=le}return S.substring(0,Y)}t.rtrim=D;function R(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=R;function b(S){return S.replace(/\*/g,"")}t.stripWildcards=b;function d(S,B,H={}){if(!S)throw new Error("Cannot create regex from empty string");B||(S=y(S)),H.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let G="";return H.global&&(G+="g"),H.matchCase||(G+="i"),H.multiline&&(G+="m"),H.unicode&&(G+="u"),new RegExp(S,G)}t.createRegExp=d;function N(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.regExpLeadsToEndlessLoop=N;function w(S){return!!S.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=w;function r(S){return(S.global?"g":"")+(S.ignoreCase?"i":"")+(S.multiline?"m":"")+(S.unicode?"u":"")}t.regExpFlags=r;function s(S){return S.split(/\r\n|\r|\n/)}t.splitLines=s;function o(S){for(let B=0,H=S.length;B<H;B++){const G=S.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}t.firstNonWhitespaceIndex=o;function a(S,B=0,H=S.length){for(let G=B;G<H;G++){const Y=S.charCodeAt(G);if(Y!==32&&Y!==9)return S.substring(B,G)}return S.substring(B,H)}t.getLeadingWhitespace=a;function v(S,B=S.length-1){for(let H=B;H>=0;H--){const G=S.charCodeAt(H);if(G!==32&&G!==9)return H}return-1}t.lastNonWhitespaceIndex=v;function c(S,B,H){const G=[];let Y=0;for(const le of S.matchAll(B)){if(G.push(S.slice(Y,le.index)),le.index===void 0)throw new Error("match.index should be defined");Y=le.index+le[0].length,G.push(H(le[0],...le.slice(1),le.index,S,le.groups))}return G.push(S.slice(Y)),Promise.all(G).then(le=>le.join(""))}t.replaceAsync=c;function f(S,B){return S<B?-1:S>B?1:0}t.compare=f;function E(S,B,H=0,G=S.length,Y=0,le=B.length){for(;H<G&&Y<le;H++,Y++){const Ae=S.charCodeAt(H),fe=B.charCodeAt(Y);if(Ae<fe)return-1;if(Ae>fe)return 1}const de=G-H,De=le-Y;return de<De?-1:de>De?1:0}t.compareSubstring=E;function g(S,B){return F(S,B,0,S.length,0,B.length)}t.compareIgnoreCase=g;function F(S,B,H=0,G=S.length,Y=0,le=B.length){for(;H<G&&Y<le;H++,Y++){let Ae=S.charCodeAt(H),fe=B.charCodeAt(Y);if(Ae===fe)continue;if(Ae>=128||fe>=128)return E(S.toLowerCase(),B.toLowerCase(),H,G,Y,le);O(Ae)&&(Ae-=32),O(fe)&&(fe-=32);const ve=Ae-fe;if(ve!==0)return ve}const de=G-H,De=le-Y;return de<De?-1:de>De?1:0}t.compareSubstringIgnoreCase=F;function C(S){return S>=48&&S<=57}t.isAsciiDigit=C;function O(S){return S>=97&&S<=122}t.isLowerAsciiLetter=O;function W(S){return S>=65&&S<=90}t.isUpperAsciiLetter=W;function x(S,B){return S.length===B.length&&F(S,B)===0}t.equalsIgnoreCase=x;function j(S,B){const H=B.length;return B.length>S.length?!1:F(S,B,0,H)===0}t.startsWithIgnoreCase=j;function K(S,B){const H=Math.min(S.length,B.length);let G;for(G=0;G<H;G++)if(S.charCodeAt(G)!==B.charCodeAt(G))return G;return H}t.commonPrefixLength=K;function X(S,B){const H=Math.min(S.length,B.length);let G;const Y=S.length-1,le=B.length-1;for(G=0;G<H;G++)if(S.charCodeAt(Y-G)!==B.charCodeAt(le-G))return G;return H}t.commonSuffixLength=X;function $(S){return 55296<=S&&S<=56319}t.isHighSurrogate=$;function n(S){return 56320<=S&&S<=57343}t.isLowSurrogate=n;function ue(S,B){return(S-55296<<10)+(B-56320)+65536}t.computeCodePoint=ue;function ae(S,B,H){const G=S.charCodeAt(H);if($(G)&&H+1<B){const Y=S.charCodeAt(H+1);if(n(Y))return ue(G,Y)}return G}t.getNextCodePoint=ae;function ie(S,B){const H=S.charCodeAt(B-1);if(n(H)&&B>1){const G=S.charCodeAt(B-2);if($(G))return ue(G,H)}return H}class be{get offset(){return this._offset}constructor(B,H=0){this._str=B,this._len=B.length,this._offset=H}setOffset(B){this._offset=B}prevCodePoint(){const B=ie(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=ae(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}t.CodePointIterator=be;class _e{get offset(){return this._iterator.offset}constructor(B,H=0){this._iterator=new be(B,H)}nextGraphemeLength(){const B=Me.getInstance(),H=this._iterator,G=H.offset;let Y=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const le=H.offset,de=B.getGraphemeBreakType(H.nextCodePoint());if(Ce(Y,de)){H.setOffset(le);break}Y=de}return H.offset-G}prevGraphemeLength(){const B=Me.getInstance(),H=this._iterator,G=H.offset;let Y=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const le=H.offset,de=B.getGraphemeBreakType(H.prevCodePoint());if(Ce(de,Y)){H.setOffset(le);break}Y=de}return G-H.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=_e;function Le(S,B){return new _e(S,B).nextGraphemeLength()}t.nextCharLength=Le;function pe(S,B){return new _e(S,B).prevGraphemeLength()}t.prevCharLength=pe;function we(S,B){B>0&&n(S.charCodeAt(B))&&B--;const H=B+Le(S,B);return[H-pe(S,H),H]}t.getCharContainingOffset=we;function ye(S){const B=new _e(S);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.charCount=ye;let Ne;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(S){return Ne||(Ne=Se()),Ne.test(S)}t.containsRTL=ne;const Q=/^[\t\n\r\x20-\x7E]*$/;function Z(S){return Q.test(S)}t.isBasicASCII=Z,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(S){return t.UNUSUAL_LINE_TERMINATORS.test(S)}t.containsUnusualLineTerminators=k;function T(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.isFullWidthCharacter=T;function U(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.isEmojiImprecise=U;function V(S,B){if(S.length<B)return S;const H=/\b/g;let G=0;for(;H.test(S)&&!(S.length-H.lastIndex<B);)G=H.lastIndex,H.lastIndex+=1;return S.substring(G).replace(/^\s/,"")}t.lcut=V;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function re(S){return S&&(S=S.replace(z,"")),S}t.removeAnsiEscapeCodes=re,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.startsWithUTF8BOM=se;function oe(S){return se(S)?S.substr(1):S}t.stripUTF8BOM=oe;function ce(S,B){if(!S||!B||S.length<B.length)return!1;const H=B.length,G=S.toLowerCase();let Y=0,le=-1;for(;Y<H;){const de=G.indexOf(B[Y],le+1);if(de<0)return!1;le=de,Y++}return!0}t.fuzzyContains=ce;function ge(S,B=!1){return S?(B&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.containsUppercaseCharacter=ge;function me(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.uppercaseFirstLetter=me;function Fe(S,B=1){if(B===0)return"";let H=-1;do H=S.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?S:(S[H-1]==="\r"&&H--,S.substr(0,H))}t.getNLines=Fe;function Ie(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.singleLetterHash=Ie;function qe(S){return Me.getInstance().getGraphemeBreakType(S)}t.getGraphemeBreakType=qe;function Ce(S,B){return S===0?B!==5&&B!==7:S===2&&B===3?!1:S===4||S===2||S===3||B===4||B===2||B===3?!0:!(S===8&&(B===8||B===9||B===11||B===12)||(S===11||S===9)&&(B===9||B===10)||(S===12||S===10)&&B===10||B===5||B===13||B===7||S===1||S===13&&B===14||S===6&&B===6)}var We;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Me{static getInstance(){return Me._INSTANCE||(Me._INSTANCE=new Me),Me._INSTANCE}constructor(){this._data=Ve()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this._data,G=H.length/3;let Y=1;for(;Y<=G;)if(B<H[3*Y])Y=2*Y;else if(B>H[3*Y+1])Y=2*Y+1;else return H[3*Y+2];return 0}}Me._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(S,B){if(S===0)return 0;const H=xe(S,B);if(H!==void 0)return H;const G=new be(B,S);return G.prevCodePoint(),G.offset}t.getLeftDeleteOffset=He;function xe(S,B){const H=new be(B,S);let G=H.prevCodePoint();for(;ze(G)||G===65039||G===8419;){if(H.offset===0)return;G=H.prevCodePoint()}if(!U(G))return;let Y=H.offset;return Y>0&&H.prevCodePoint()===8205&&(Y=H.offset),Y}function ze(S){return 127995<=S&&S<=127999}var Ue;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.noBreakWhitespace="\xA0";class Ee{static getInstance(B){return Ee.cache.get(Array.from(B))}static getLocales(){return Ee._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i=Ee,Ee.ambiguousCharacterData=new I.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new P.LRUCachedFunction(S=>{function B(fe){const ve=new Map;for(let Re=0;Re<fe.length;Re+=2)ve.set(fe[Re],fe[Re+1]);return ve}function H(fe,ve){const Re=new Map(fe);for(const[ke,Te]of ve)Re.set(ke,Te);return Re}function G(fe,ve){if(!fe)return ve;const Re=new Map;for(const[ke,Te]of fe)ve.has(ke)&&Re.set(ke,Te);return Re}const Y=i.ambiguousCharacterData.value;let le=S.filter(fe=>!fe.startsWith("_")&&fe in Y);le.length===0&&(le=["_default"]);let de;for(const fe of le){const ve=B(Y[fe]);de=G(de,ve)}const De=B(Y._common),Ae=H(De,de);return new Ee(Ae)}),Ee._locales=new I.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.value).filter(S=>!S.startsWith("_"))),t.AmbiguousCharacters=Ee;class Pe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Pe.getRawData())),this._data}static isInvisibleCharacter(B){return Pe.getData().has(B)}static get codePoints(){return Pe.getData()}}Pe._data=void 0,t.InvisibleCharacters=Pe}),J(ee[47],te([0,1,4]),function(q,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function I(R){return i(R,0)}t.hash=I;function i(R,b){switch(typeof R){case"object":return R===null?u(349,b):Array.isArray(R)?l(R,b):h(R,b);case"string":return _(R,b);case"boolean":return M(R,b);case"number":return u(R,b);case"undefined":return u(937,b);default:return u(617,b)}}t.doHash=i;function u(R,b){return(b<<5)-b+R|0}t.numberHash=u;function M(R,b){return u(R?433:863,b)}function _(R,b){b=u(149417,b);for(let d=0,N=R.length;d<N;d++)b=u(R.charCodeAt(d),b);return b}t.stringHash=_;function l(R,b){return b=u(104579,b),R.reduce((d,N)=>i(N,d),b)}function h(R,b){return b=u(181387,b),Object.keys(R).sort().reduce((d,N)=>(d=_(N,d),i(R[N],d)),b)}class p{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=i(b,this._value),this._value}}t.Hasher=p;var y;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function L(R,b,d=32){const N=d-b,w=~((1<<N)-1);return(R<<b|(w&R)>>>N)>>>0}function m(R,b=0,d=R.byteLength,N=0){for(let w=0;w<d;w++)R[b+w]=N}function e(R,b,d="0"){for(;R.length<b;)R=d+R;return R}function A(R,b=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),b/4)}t.toHexString=A;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d===0)return;const N=this._buff;let w=this._buffLen,r=this._leftoverHighSurrogate,s,o;for(r!==0?(s=r,o=-1,r=0):(s=b.charCodeAt(0),o=0);;){let a=s;if(P.isHighSurrogate(s))if(o+1<d){const v=b.charCodeAt(o+1);P.isLowSurrogate(v)?(o++,a=P.computeCodePoint(s,v)):a=65533}else{r=s;break}else P.isLowSurrogate(s)&&(a=65533);if(w=this._push(N,w,a),o++,o<d)s=b.charCodeAt(o);else break}this._buffLen=w,this._leftoverHighSurrogate=r}_push(b,d,N){return N<128?b[d++]=N:N<2048?(b[d++]=192|(N&1984)>>>6,b[d++]=128|(N&63)>>>0):N<65536?(b[d++]=224|(N&61440)>>>12,b[d++]=128|(N&4032)>>>6,b[d++]=128|(N&63)>>>0):(b[d++]=240|(N&1835008)>>>18,b[d++]=128|(N&258048)>>>12,b[d++]=128|(N&4032)>>>6,b[d++]=128|(N&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),A(this._h0)+A(this._h1)+A(this._h2)+A(this._h3)+A(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=D._bigBlock32,d=this._buffDV;for(let f=0;f<64;f+=4)b.setUint32(f,d.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)b.setUint32(f,L(b.getUint32(f-12,!1)^b.getUint32(f-32,!1)^b.getUint32(f-56,!1)^b.getUint32(f-64,!1),1),!1);let N=this._h0,w=this._h1,r=this._h2,s=this._h3,o=this._h4,a,v,c;for(let f=0;f<80;f++)f<20?(a=w&r|~w&s,v=1518500249):f<40?(a=w^r^s,v=1859775393):f<60?(a=w&r|w&s|r&s,v=2400959708):(a=w^r^s,v=3395469782),c=L(N,5)+a+o+v+b.getUint32(f*4,!1)&4294967295,o=s,s=r,r=L(w,30),w=N,N=c;this._h0=this._h0+N&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+o&4294967295}}D._bigBlock32=new DataView(new ArrayBuffer(320)),t.StringSHA1=D}),J(ee[24],te([0,1,26,47]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(L){this.source=L}getElements(){const L=this.source,m=new Int32Array(L.length);for(let e=0,A=L.length;e<A;e++)m[e]=L.charCodeAt(e);return m}}t.StringDiffSequence=i;function u(y,L,m){return new p(new i(y),new i(L)).ComputeDiff(m).changes}t.stringDiff=u;class M{static Assert(L,m){if(!L)throw new Error(m)}}class _{static Copy(L,m,e,A,D){for(let R=0;R<D;R++)e[A+R]=L[m+R]}static Copy2(L,m,e,A,D){for(let R=0;R<D;R++)e[A+R]=L[m+R]}}var l;(function(y){y[y.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class h{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(L,m){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(L,m){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class p{constructor(L,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=L,this._modifiedSequence=m;const[A,D,R]=p._getElements(L),[b,d,N]=p._getElements(m);this._hasStrings=R&&N,this._originalStringElements=A,this._originalElementsOrHash=D,this._modifiedStringElements=b,this._modifiedElementsOrHash=d,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(L){return L.length>0&&typeof L[0]=="string"}static _getElements(L){const m=L.getElements();if(p._isStringArray(m)){const e=new Int32Array(m.length);for(let A=0,D=m.length;A<D;A++)e[A]=(0,I.stringHash)(m[A],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(L,m){return this._originalElementsOrHash[L]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[L]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(L,m){if(!this.ElementsAreEqual(L,m))return!1;const e=p._getStrictElement(this._originalSequence,L),A=p._getStrictElement(this._modifiedSequence,m);return e===A}static _getStrictElement(L,m){return typeof L.getStrictElement=="function"?L.getStrictElement(m):null}OriginalElementsAreEqual(L,m){return this._originalElementsOrHash[L]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[L]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(L,m){return this._modifiedElementsOrHash[L]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[L]===this._modifiedStringElements[m]:!0}ComputeDiff(L){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,L)}_ComputeDiff(L,m,e,A,D){const R=[!1];let b=this.ComputeDiffRecursive(L,m,e,A,R);return D&&(b=this.PrettifyChanges(b)),{quitEarly:R[0],changes:b}}ComputeDiffRecursive(L,m,e,A,D){for(D[0]=!1;L<=m&&e<=A&&this.ElementsAreEqual(L,e);)L++,e++;for(;m>=L&&A>=e&&this.ElementsAreEqual(m,A);)m--,A--;if(L>m||e>A){let r;return e<=A?(M.Assert(L===m+1,"originalStart should only be one more than originalEnd"),r=[new P.DiffChange(L,0,e,A-e+1)]):L<=m?(M.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new P.DiffChange(L,m-L+1,e,0)]):(M.Assert(L===m+1,"originalStart should only be one more than originalEnd"),M.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const R=[0],b=[0],d=this.ComputeRecursionPoint(L,m,e,A,R,b,D),N=R[0],w=b[0];if(d!==null)return d;if(!D[0]){const r=this.ComputeDiffRecursive(L,N,e,w,D);let s=[];return D[0]?s=[new P.DiffChange(N+1,m-(N+1)+1,w+1,A-(w+1)+1)]:s=this.ComputeDiffRecursive(N+1,m,w+1,A,D),this.ConcatenateChanges(r,s)}return[new P.DiffChange(L,m-L+1,e,A-e+1)]}WALKTRACE(L,m,e,A,D,R,b,d,N,w,r,s,o,a,v,c,f,E){let g=null,F=null,C=new h,O=m,W=e,x=o[0]-c[0]-A,j=-1073741824,K=this.m_forwardHistory.length-1;do{const X=x+L;X===O||X<W&&N[X-1]<N[X+1]?(r=N[X+1],a=r-x-A,r<j&&C.MarkNextChange(),j=r,C.AddModifiedElement(r+1,a),x=X+1-L):(r=N[X-1]+1,a=r-x-A,r<j&&C.MarkNextChange(),j=r-1,C.AddOriginalElement(r,a+1),x=X-1-L),K>=0&&(N=this.m_forwardHistory[K],L=N[0],O=1,W=N.length-1)}while(--K>=-1);if(g=C.getReverseChanges(),E[0]){let X=o[0]+1,$=c[0]+1;if(g!==null&&g.length>0){const n=g[g.length-1];X=Math.max(X,n.getOriginalEnd()),$=Math.max($,n.getModifiedEnd())}F=[new P.DiffChange(X,s-X+1,$,v-$+1)]}else{C=new h,O=R,W=b,x=o[0]-c[0]-d,j=1073741824,K=f?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const X=x+D;X===O||X<W&&w[X-1]>=w[X+1]?(r=w[X+1]-1,a=r-x-d,r>j&&C.MarkNextChange(),j=r+1,C.AddOriginalElement(r+1,a+1),x=X+1-D):(r=w[X-1],a=r-x-d,r>j&&C.MarkNextChange(),j=r,C.AddModifiedElement(r+1,a+1),x=X-1-D),K>=0&&(w=this.m_reverseHistory[K],D=w[0],O=1,W=w.length-1)}while(--K>=-1);F=C.getChanges()}return this.ConcatenateChanges(g,F)}ComputeRecursionPoint(L,m,e,A,D,R,b){let d=0,N=0,w=0,r=0,s=0,o=0;L--,e--,D[0]=0,R[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=m-L+(A-e),v=a+1,c=new Int32Array(v),f=new Int32Array(v),E=A-e,g=m-L,F=L-e,C=m-A,W=(g-E)%2===0;c[E]=L,f[g]=m,b[0]=!1;for(let x=1;x<=a/2+1;x++){let j=0,K=0;w=this.ClipDiagonalBound(E-x,x,E,v),r=this.ClipDiagonalBound(E+x,x,E,v);for(let $=w;$<=r;$+=2){$===w||$<r&&c[$-1]<c[$+1]?d=c[$+1]:d=c[$-1]+1,N=d-($-E)-F;const n=d;for(;d<m&&N<A&&this.ElementsAreEqual(d+1,N+1);)d++,N++;if(c[$]=d,d+N>j+K&&(j=d,K=N),!W&&Math.abs($-g)<=x-1&&d>=f[$])return D[0]=d,R[0]=N,n<=f[$]&&1447>0&&x<=1447+1?this.WALKTRACE(E,w,r,F,g,s,o,C,c,f,d,m,D,N,A,R,W,b):null}const X=(j-L+(K-e)-x)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(j,X))return b[0]=!0,D[0]=j,R[0]=K,X>0&&1447>0&&x<=1447+1?this.WALKTRACE(E,w,r,F,g,s,o,C,c,f,d,m,D,N,A,R,W,b):(L++,e++,[new P.DiffChange(L,m-L+1,e,A-e+1)]);s=this.ClipDiagonalBound(g-x,x,g,v),o=this.ClipDiagonalBound(g+x,x,g,v);for(let $=s;$<=o;$+=2){$===s||$<o&&f[$-1]>=f[$+1]?d=f[$+1]-1:d=f[$-1],N=d-($-g)-C;const n=d;for(;d>L&&N>e&&this.ElementsAreEqual(d,N);)d--,N--;if(f[$]=d,W&&Math.abs($-E)<=x&&d<=c[$])return D[0]=d,R[0]=N,n>=c[$]&&1447>0&&x<=1447+1?this.WALKTRACE(E,w,r,F,g,s,o,C,c,f,d,m,D,N,A,R,W,b):null}if(x<=1447){let $=new Int32Array(r-w+2);$[0]=E-w+1,_.Copy2(c,w,$,1,r-w+1),this.m_forwardHistory.push($),$=new Int32Array(o-s+2),$[0]=g-s+1,_.Copy2(f,s,$,1,o-s+1),this.m_reverseHistory.push($)}}return this.WALKTRACE(E,w,r,F,g,s,o,C,c,f,d,m,D,N,A,R,W,b)}PrettifyChanges(L){for(let m=0;m<L.length;m++){const e=L[m],A=m<L.length-1?L[m+1].originalStart:this._originalElementsOrHash.length,D=m<L.length-1?L[m+1].modifiedStart:this._modifiedElementsOrHash.length,R=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<D&&(!R||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const N=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!N)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<L.length-1&&this.ChangesOverlap(L[m],L[m+1],d)){L[m]=d[0],L.splice(m+1,1),m--;continue}}for(let m=L.length-1;m>=0;m--){const e=L[m];let A=0,D=0;if(m>0){const r=L[m-1];A=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const R=e.originalLength>0,b=e.modifiedLength>0;let d=0,N=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,o=e.modifiedStart-r;if(s<A||o<D||R&&!this.OriginalElementsAreEqual(s,s+e.originalLength)||b&&!this.ModifiedElementsAreEqual(o,o+e.modifiedLength))break;const v=(s===A&&o===D?5:0)+this._boundaryScore(s,e.originalLength,o,e.modifiedLength);v>N&&(N=v,d=r)}e.originalStart-=d,e.modifiedStart-=d;const w=[null];if(m>0&&this.ChangesOverlap(L[m-1],L[m],w)){L[m-1]=w[0],L.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=L.length;m<e;m++){const A=L[m-1],D=L[m],R=D.originalStart-A.originalStart-A.originalLength,b=A.originalStart,d=D.originalStart+D.originalLength,N=d-b,w=A.modifiedStart,r=D.modifiedStart+D.modifiedLength,s=r-w;if(R<5&&N<20&&s<20){const o=this._findBetterContiguousSequence(b,N,w,s,R);if(o){const[a,v]=o;(a!==A.originalStart+A.originalLength||v!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=a-A.originalStart,A.modifiedLength=v-A.modifiedStart,D.originalStart=a+R,D.modifiedStart=v+R,D.originalLength=d-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return L}_findBetterContiguousSequence(L,m,e,A,D){if(m<D||A<D)return null;const R=L+m-D+1,b=e+A-D+1;let d=0,N=0,w=0;for(let r=L;r<R;r++)for(let s=e;s<b;s++){const o=this._contiguousSequenceScore(r,s,D);o>0&&o>d&&(d=o,N=r,w=s)}return d>0?[N,w]:null}_contiguousSequenceScore(L,m,e){let A=0;for(let D=0;D<e;D++){if(!this.ElementsAreEqual(L+D,m+D))return 0;A+=this._originalStringElements[L+D].length}return A}_OriginalIsBoundary(L){return L<=0||L>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[L])}_OriginalRegionIsBoundary(L,m){if(this._OriginalIsBoundary(L)||this._OriginalIsBoundary(L-1))return!0;if(m>0){const e=L+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(L){return L<=0||L>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[L])}_ModifiedRegionIsBoundary(L,m){if(this._ModifiedIsBoundary(L)||this._ModifiedIsBoundary(L-1))return!0;if(m>0){const e=L+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(L,m,e,A){const D=this._OriginalRegionIsBoundary(L,m)?1:0,R=this._ModifiedRegionIsBoundary(e,A)?1:0;return D+R}ConcatenateChanges(L,m){const e=[];if(L.length===0||m.length===0)return m.length>0?m:L;if(this.ChangesOverlap(L[L.length-1],m[0],e)){const A=new Array(L.length+m.length-1);return _.Copy(L,0,A,0,L.length-1),A[L.length-1]=e[0],_.Copy(m,1,A,L.length,m.length-1),A}else{const A=new Array(L.length+m.length);return _.Copy(L,0,A,0,L.length),_.Copy(m,0,A,L.length,m.length),A}}ChangesOverlap(L,m,e){if(M.Assert(L.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),M.Assert(L.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),L.originalStart+L.originalLength>=m.originalStart||L.modifiedStart+L.modifiedLength>=m.modifiedStart){const A=L.originalStart;let D=L.originalLength;const R=L.modifiedStart;let b=L.modifiedLength;return L.originalStart+L.originalLength>=m.originalStart&&(D=m.originalStart+m.originalLength-L.originalStart),L.modifiedStart+L.modifiedLength>=m.modifiedStart&&(b=m.modifiedStart+m.modifiedLength-L.modifiedStart),e[0]=new P.DiffChange(A,D,R,b),!0}else return e[0]=null,!1}ClipDiagonalBound(L,m,e,A){if(L>=0&&L<A)return L;const D=e,R=A-e-1,b=m%2===0;if(L<0){const d=D%2===0;return b===d?0:1}else{const d=R%2===0;return b===d?A-1:A-2}}}t.LcsDiff=p}),J(ee[13],te([0,1,45,8]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,M=/^\/\//;function _(o,a){if(!o.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!i.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!u.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(o,a){return!o&&!a?"file":o}function h(o,a){switch(o){case"https":case"http":case"file":a?a[0]!==y&&(a=y+a):a=y;break}return a}const p="",y="/",L=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,v,c,f,E,g=!1){typeof a=="object"?(this.scheme=a.scheme||p,this.authority=a.authority||p,this.path=a.path||p,this.query=a.query||p,this.fragment=a.fragment||p):(this.scheme=l(a,g),this.authority=v||p,this.path=h(this.scheme,c||p),this.query=f||p,this.fragment=E||p,_(this,g))}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:v,authority:c,path:f,query:E,fragment:g}=a;return v===void 0?v=this.scheme:v===null&&(v=p),c===void 0?c=this.authority:c===null&&(c=p),f===void 0?f=this.path:f===null&&(f=p),E===void 0?E=this.query:E===null&&(E=p),g===void 0?g=this.fragment:g===null&&(g=p),v===this.scheme&&c===this.authority&&f===this.path&&E===this.query&&g===this.fragment?this:new A(v,c,f,E,g)}static parse(a,v=!1){const c=L.exec(a);return c?new A(c[2]||p,s(c[4]||p),s(c[5]||p),s(c[7]||p),s(c[9]||p),v):new A(p,p,p,p,p)}static file(a){let v=p;if(I.isWindows&&(a=a.replace(/\\/g,y)),a[0]===y&&a[1]===y){const c=a.indexOf(y,2);c===-1?(v=a.substring(2),a=y):(v=a.substring(2,c),a=a.substring(c)||y)}return new A("file",v,a,p,p)}static from(a){const v=new A(a.scheme,a.authority,a.path,a.query,a.fragment);return _(v,!0),v}static joinPath(a,...v){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return I.isWindows&&a.scheme==="file"?c=m.file(P.win32.join(d(a,!0),...v)).path:c=P.posix.join(a.path,...v),a.with({path:c})}toString(a=!1){return N(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const v=new A(a);return v._formatted=a.external,v._fsPath=a._sep===e?a.fsPath:null,v}}else return a}}t.URI=m;const e=I.isWindows?1:void 0;class A extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?N(this,!0):(this._formatted||(this._formatted=N(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=e),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(o,a,v){let c,f=-1;for(let E=0;E<o.length;E++){const g=o.charCodeAt(E);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||v&&g===91||v&&g===93||v&&g===58)f!==-1&&(c+=encodeURIComponent(o.substring(f,E)),f=-1),c!==void 0&&(c+=o.charAt(E));else{c===void 0&&(c=o.substr(0,E));const F=D[g];F!==void 0?(f!==-1&&(c+=encodeURIComponent(o.substring(f,E)),f=-1),c+=F):f===-1&&(f=E)}}return f!==-1&&(c+=encodeURIComponent(o.substring(f))),c!==void 0?c:o}function b(o){let a;for(let v=0;v<o.length;v++){const c=o.charCodeAt(v);c===35||c===63?(a===void 0&&(a=o.substr(0,v)),a+=D[c]):a!==void 0&&(a+=o[v])}return a!==void 0?a:o}function d(o,a){let v;return o.authority&&o.path.length>1&&o.scheme==="file"?v=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?a?v=o.path.substr(1):v=o.path[1].toLowerCase()+o.path.substr(2):v=o.path,I.isWindows&&(v=v.replace(/\//g,"\\")),v}t.uriToFsPath=d;function N(o,a){const v=a?b:R;let c="",{scheme:f,authority:E,path:g,query:F,fragment:C}=o;if(f&&(c+=f,c+=":"),(E||f==="file")&&(c+=y,c+=y),E){let O=E.indexOf("@");if(O!==-1){const W=E.substr(0,O);E=E.substr(O+1),O=W.lastIndexOf(":"),O===-1?c+=v(W,!1,!1):(c+=v(W.substr(0,O),!1,!1),c+=":",c+=v(W.substr(O+1),!1,!0)),c+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?c+=v(E,!1,!0):(c+=v(E.substr(0,O),!1,!0),c+=E.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}c+=v(g,!0,!1)}return F&&(c+="?",c+=v(F,!1,!1)),C&&(c+="#",c+=a?C:R(C,!1,!1)),c}function w(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+w(o.substr(3)):o}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(r)?o.replace(r,a=>w(a)):o}}),J(ee[58],te([0,1,5,9,6,11,8,4]),function(q,t,P,I,i,u,M,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let h=!1;function p(o){!M.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}t.logOnceWebWorkerWarning=p;var y;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})(y||(y={}));class L{constructor(a,v,c,f){this.vsWorker=a,this.req=v,this.method=c,this.args=f,this.type=0}}class m{constructor(a,v,c,f){this.vsWorker=a,this.seq=v,this.res=c,this.err=f,this.type=1}}class e{constructor(a,v,c,f){this.vsWorker=a,this.req=v,this.eventName=c,this.arg=f,this.type=2}}class A{constructor(a,v,c){this.vsWorker=a,this.req=v,this.event=c,this.type=3}}class D{constructor(a,v){this.vsWorker=a,this.req=v,this.type=4}}class R{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,v){const c=String(++this._lastSentReq);return new Promise((f,E)=>{this._pendingReplies[c]={resolve:f,reject:E},this._send(new L(this._workerId,c,a,v))})}listen(a,v){let c=null;const f=new I.Emitter({onWillAddFirstListener:()=>{c=String(++this._lastSentReq),this._pendingEmitters.set(c,f),this._send(new e(this._workerId,c,a,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(c),this._send(new D(this._workerId,c)),c=null}});return f.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let c=a.err;a.err.$isError&&(c=new Error,c.name=a.err.name,c.message=a.err.message,c.stack=a.err.stack),v.reject(c);return}v.resolve(a.res)}_handleRequestMessage(a){const v=a.req;this._handler.handleMessage(a.method,a.args).then(f=>{this._send(new m(this._workerId,v,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,P.transformErrorForSerialization)(f.detail)),this._send(new m(this._workerId,v,void 0,(0,P.transformErrorForSerialization)(f)))})}_handleSubscribeEventMessage(a){const v=a.req,c=this._handler.handleEvent(a.eventName,a.arg)(f=>{this._send(new A(this._workerId,v,f))});this._pendingEvents.set(v,c)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const v=[];if(a.type===0)for(let c=0;c<a.args.length;c++)a.args[c]instanceof ArrayBuffer&&v.push(a.args[c]);else a.type===1&&a.res instanceof ArrayBuffer&&v.push(a.res);this._handler.sendMessage(a,v)}}class b extends i.Disposable{constructor(a,v,c){super();let f=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",W=>{this._protocol.handleMessage(W)},W=>{f?.(W)})),this._protocol=new R({sendMessage:(W,x)=>{this._worker.postMessage(W,x)},handleMessage:(W,x)=>{if(typeof c[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(c[W].apply(c,x))}catch(j){return Promise.reject(j)}},handleEvent:(W,x)=>{if(N(W)){const j=c[W].call(c,x);if(typeof j!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return j}if(d(W)){const j=c[W];if(typeof j!="function")throw new Error(`Missing event ${W} on main thread host.`);return j}throw new Error(`Malformed event name ${W}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;const g=globalThis.require;typeof g<"u"&&typeof g.getConfig=="function"?E=g.getConfig():typeof globalThis.requirejs<"u"&&(E=globalThis.requirejs.s.contexts._.config);const F=(0,u.getAllMethodNames)(c);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(E)),v,F]);const C=(W,x)=>this._request(W,x),O=(W,x)=>this._protocol.listen(W,x);this._lazyProxy=new Promise((W,x)=>{f=x,this._onModuleLoaded.then(j=>{W(w(j,C,O))},j=>{x(j),this._onError("Worker failed to load "+v,j)})})}getProxyObject(){return this._lazyProxy}_request(a,v){return new Promise((c,f)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,v).then(c,f)},f)})}_onError(a,v){console.error(a),console.info(v)}}t.SimpleWorkerClient=b;function d(o){return o[0]==="o"&&o[1]==="n"&&_.isUpperAsciiLetter(o.charCodeAt(2))}function N(o){return/^onDynamic/.test(o)&&_.isUpperAsciiLetter(o.charCodeAt(9))}function w(o,a,v){const c=g=>function(){const F=Array.prototype.slice.call(arguments,0);return a(g,F)},f=g=>function(F){return v(g,F)},E={};for(const g of o){if(N(g)){E[g]=f(g);continue}if(d(g)){E[g]=v(g,void 0);continue}E[g]=c(g)}return E}class r{constructor(a,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new R({sendMessage:(c,f)=>{a(c,f)},handleMessage:(c,f)=>this._handleMessage(c,f),handleEvent:(c,f)=>this._handleEvent(c,f)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,v){if(a===l)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,v))}catch(c){return Promise.reject(c)}}_handleEvent(a,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(a)){const c=this._requestHandler[a].call(this._requestHandler,v);if(typeof c!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return c}if(d(a)){const c=this._requestHandler[a];if(typeof c!="function")throw new Error(`Missing event ${a} on request handler.`);return c}throw new Error(`Malformed event name ${a}`)}initialize(a,v,c,f){this._protocol.setWorkerId(a);const F=w(f,(C,O)=>this._protocol.sendMessage(C,O),(C,O)=>this._protocol.listen(C,O));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(F),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((C,O)=>{(globalThis.require||q)([c],x=>{if(this._requestHandler=x.create(F),!this._requestHandler){O(new Error("No RequestHandler!"));return}C((0,u.getAllMethodNames)(this._requestHandler))},O)}))}}t.SimpleWorkerServer=r;function s(o){return new r(o,null)}t.create=s}),J(ee[25],te([0,1,24,12,4,2,10,20]),function(q,t,P,I,i,u,M,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const l=3;class h{computeDiff(w,r,s){const a=new D(w,r,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),v=[];let c=null;for(const f of a.changes){let E;f.originalEndLineNumber===0?E=new _.LineRange(f.originalStartLineNumber+1,f.originalStartLineNumber+1):E=new _.LineRange(f.originalStartLineNumber,f.originalEndLineNumber+1);let g;f.modifiedEndLineNumber===0?g=new _.LineRange(f.modifiedStartLineNumber+1,f.modifiedStartLineNumber+1):g=new _.LineRange(f.modifiedStartLineNumber,f.modifiedEndLineNumber+1);let F=new I.LineRangeMapping(E,g,f.charChanges?.map(C=>new I.RangeMapping(new u.Range(C.originalStartLineNumber,C.originalStartColumn,C.originalEndLineNumber,C.originalEndColumn),new u.Range(C.modifiedStartLineNumber,C.modifiedStartColumn,C.modifiedEndLineNumber,C.modifiedEndColumn))));c&&(c.modifiedRange.endLineNumberExclusive===F.modifiedRange.startLineNumber||c.originalRange.endLineNumberExclusive===F.originalRange.startLineNumber)&&(F=new I.LineRangeMapping(c.originalRange.join(F.originalRange),c.modifiedRange.join(F.modifiedRange),c.innerChanges&&F.innerChanges?c.innerChanges.concat(F.innerChanges):void 0),v.pop()),v.push(F),c=F}return(0,M.assertFn)(()=>(0,M.checkAdjacentItems)(v,(f,E)=>E.originalRange.startLineNumber-f.originalRange.endLineNumberExclusive===E.modifiedRange.startLineNumber-f.modifiedRange.endLineNumberExclusive&&f.originalRange.endLineNumberExclusive<E.originalRange.startLineNumber&&f.modifiedRange.endLineNumberExclusive<E.modifiedRange.startLineNumber)),{quitEarly:a.quitEarly,changes:v}}}t.SmartLinesDiffComputer=h;function p(N,w,r,s){return new P.LcsDiff(N,w,r).ComputeDiff(s)}class y{constructor(w){const r=[],s=[];for(let o=0,a=w.length;o<a;o++)r[o]=R(w[o],1),s[o]=b(w[o],1);this.lines=w,this._startColumns=r,this._endColumns=s}getElements(){const w=[];for(let r=0,s=this.lines.length;r<s;r++)w[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return w}getStrictElement(w){return this.lines[w]}getStartLineNumber(w){return w+1}getEndLineNumber(w){return w+1}createCharSequence(w,r,s){const o=[],a=[],v=[];let c=0;for(let f=r;f<=s;f++){const E=this.lines[f],g=w?this._startColumns[f]:1,F=w?this._endColumns[f]:E.length+1;for(let C=g;C<F;C++)o[c]=E.charCodeAt(C-1),a[c]=f+1,v[c]=C,c++;!w&&f<s&&(o[c]=10,a[c]=f+1,v[c]=E.length+1,c++)}return new L(o,a,v)}}class L{constructor(w,r,s){this._charCodes=w,this._lineNumbers=r,this._columns=s}toString(){return"["+this._charCodes.map((w,r)=>(w===10?"\\n":String.fromCharCode(w))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(w,r){if(w<0||w>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(w){return w>0&&w===this._lineNumbers.length?this.getEndLineNumber(w-1):(this._assertIndex(w,this._lineNumbers),this._lineNumbers[w])}getEndLineNumber(w){return w===-1?this.getStartLineNumber(w+1):(this._assertIndex(w,this._lineNumbers),this._charCodes[w]===10?this._lineNumbers[w]+1:this._lineNumbers[w])}getStartColumn(w){return w>0&&w===this._columns.length?this.getEndColumn(w-1):(this._assertIndex(w,this._columns),this._columns[w])}getEndColumn(w){return w===-1?this.getStartColumn(w+1):(this._assertIndex(w,this._columns),this._charCodes[w]===10?1:this._columns[w]+1)}}class m{constructor(w,r,s,o,a,v,c,f){this.originalStartLineNumber=w,this.originalStartColumn=r,this.originalEndLineNumber=s,this.originalEndColumn=o,this.modifiedStartLineNumber=a,this.modifiedStartColumn=v,this.modifiedEndLineNumber=c,this.modifiedEndColumn=f}static createFromDiffChange(w,r,s){const o=r.getStartLineNumber(w.originalStart),a=r.getStartColumn(w.originalStart),v=r.getEndLineNumber(w.originalStart+w.originalLength-1),c=r.getEndColumn(w.originalStart+w.originalLength-1),f=s.getStartLineNumber(w.modifiedStart),E=s.getStartColumn(w.modifiedStart),g=s.getEndLineNumber(w.modifiedStart+w.modifiedLength-1),F=s.getEndColumn(w.modifiedStart+w.modifiedLength-1);return new m(o,a,v,c,f,E,g,F)}}function e(N){if(N.length<=1)return N;const w=[N[0]];let r=w[0];for(let s=1,o=N.length;s<o;s++){const a=N[s],v=a.originalStart-(r.originalStart+r.originalLength),c=a.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(v,c)<l?(r.originalLength=a.originalStart+a.originalLength-r.originalStart,r.modifiedLength=a.modifiedStart+a.modifiedLength-r.modifiedStart):(w.push(a),r=a)}return w}class A{constructor(w,r,s,o,a){this.originalStartLineNumber=w,this.originalEndLineNumber=r,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=o,this.charChanges=a}static createFromDiffResult(w,r,s,o,a,v,c){let f,E,g,F,C;if(r.originalLength===0?(f=s.getStartLineNumber(r.originalStart)-1,E=0):(f=s.getStartLineNumber(r.originalStart),E=s.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(g=o.getStartLineNumber(r.modifiedStart)-1,F=0):(g=o.getStartLineNumber(r.modifiedStart),F=o.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),v&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&a()){const O=s.createCharSequence(w,r.originalStart,r.originalStart+r.originalLength-1),W=o.createCharSequence(w,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(O.getElements().length>0&&W.getElements().length>0){let x=p(O,W,a,!0).changes;c&&(x=e(x)),C=[];for(let j=0,K=x.length;j<K;j++)C.push(m.createFromDiffChange(x[j],O,W))}}return new A(f,E,g,F,C)}}class D{constructor(w,r,s){this.shouldComputeCharChanges=s.shouldComputeCharChanges,this.shouldPostProcessCharChanges=s.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=s.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=s.shouldMakePrettyDiff,this.originalLines=w,this.modifiedLines=r,this.original=new y(w),this.modified=new y(r),this.continueLineDiff=d(s.maxComputationTime),this.continueCharDiff=d(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const w=p(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=w.changes,s=w.quitEarly;if(this.shouldIgnoreTrimWhitespace){const c=[];for(let f=0,E=r.length;f<E;f++)c.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[f],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:s,changes:c}}const o=[];let a=0,v=0;for(let c=-1,f=r.length;c<f;c++){const E=c+1<f?r[c+1]:null,g=E?E.originalStart:this.originalLines.length,F=E?E.modifiedStart:this.modifiedLines.length;for(;a<g&&v<F;){const C=this.originalLines[a],O=this.modifiedLines[v];if(C!==O){{let W=R(C,1),x=R(O,1);for(;W>1&&x>1;){const j=C.charCodeAt(W-2),K=O.charCodeAt(x-2);if(j!==K)break;W--,x--}(W>1||x>1)&&this._pushTrimWhitespaceCharChange(o,a+1,1,W,v+1,1,x)}{let W=b(C,1),x=b(O,1);const j=C.length+1,K=O.length+1;for(;W<j&&x<K;){const X=C.charCodeAt(W-1),$=C.charCodeAt(x-1);if(X!==$)break;W++,x++}(W<j||x<K)&&this._pushTrimWhitespaceCharChange(o,a+1,W,j,v+1,x,K)}}a++,v++}E&&(o.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,E,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=E.originalLength,v+=E.modifiedLength)}return{quitEarly:s,changes:o}}_pushTrimWhitespaceCharChange(w,r,s,o,a,v,c){if(this._mergeTrimWhitespaceCharChange(w,r,s,o,a,v,c))return;let f;this.shouldComputeCharChanges&&(f=[new m(r,s,r,o,a,v,a,c)]),w.push(new A(r,r,a,a,f))}_mergeTrimWhitespaceCharChange(w,r,s,o,a,v,c){const f=w.length;if(f===0)return!1;const E=w[f-1];return E.originalEndLineNumber===0||E.modifiedEndLineNumber===0?!1:E.originalEndLineNumber===r&&E.modifiedEndLineNumber===a?(this.shouldComputeCharChanges&&E.charChanges&&E.charChanges.push(new m(r,s,r,o,a,v,a,c)),!0):E.originalEndLineNumber+1===r&&E.modifiedEndLineNumber+1===a?(E.originalEndLineNumber=r,E.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&E.charChanges&&E.charChanges.push(new m(r,s,r,o,a,v,a,c)),!0):!1}}t.DiffComputer=D;function R(N,w){const r=i.firstNonWhitespaceIndex(N);return r===-1?w:r+1}function b(N,w){const r=i.lastNonWhitespaceIndex(N);return r===-1?w:r+2}function d(N){if(N===0)return()=>!0;const w=Date.now();return()=>Date.now()-w<N}}),J(ee[48],te([0,1,25,37]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new P.SmartLinesDiffComputer,experimental:new I.StandardLinesDiffComputer}}),J(ee[49],te([0,1,4,3,41]),function(q,t,P,I,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(_,l,h,p){this._uri=_,this._lines=l,this._eol=h,this._versionId=p,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const l=_.changes;for(const h of l)this._acceptDeleteRange(h.range),this._acceptInsertText(new I.Position(h.range.startLineNumber,h.range.startColumn),h.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,l=this._lines.length,h=new Uint32Array(l);for(let p=0;p<l;p++)h[p]=this._lines[p].length+_;this._lineStarts=new i.PrefixSumComputer(h)}}_setLineText(_,l){this._lines[_]=l,this._lineStarts&&this._lineStarts.setValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,l){if(l.length===0)return;const h=(0,P.splitLines)(l);if(h.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+h[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}h[h.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+h[0]);const p=new Uint32Array(h.length-1);for(let y=1;y<h.length;y++)this._lines.splice(_.lineNumber+y-1,0,h[y]),p[y-1]=h[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,p)}}t.MirrorTextModel=u}),J(ee[50],te([0,1,4,32,3,2,40]),function(q,t,P,I,i,u,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const _=999;class l{constructor(b,d,N,w){this.searchString=b,this.isRegex=d,this.matchCase=N,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=h(this.searchString):b=this.searchString.indexOf(`
`)>=0;let d=null;try{d=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!d)return null;let N=!this.isRegex&&!b;return N&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(N=this.matchCase),new M.SearchData(d,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,N?this.searchString:null)}}t.SearchParams=l;function h(R){if(!R||R.length===0)return!1;for(let b=0,d=R.length;b<d;b++){const N=R.charCodeAt(b);if(N===10)return!0;if(N===92){if(b++,b>=d)break;const w=R.charCodeAt(b);if(w===110||w===114||w===87)return!0}}return!1}t.isMultilineRegexSource=h;function p(R,b,d){if(!d)return new M.FindMatch(R,null);const N=[];for(let w=0,r=b.length;w<r;w++)N[w]=b[w];return new M.FindMatch(R,N)}t.createFindMatch=p;class y{constructor(b){const d=[];let N=0;for(let w=0,r=b.length;w<r;w++)b.charCodeAt(w)===10&&(d[N++]=w);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(b){const d=this._lineFeedsOffsets;let N=0,w=d.length-1;if(w===-1||b<=d[0])return 0;for(;N<w;){const r=N+((w-N)/2>>0);d[r]>=b?w=r-1:d[r+1]>=b?(N=r,w=r):N=r+1}return N+1}}class L{static findMatches(b,d,N,w,r){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(b,N,new D(s.wordSeparators,s.regex),w,r):this._doFindMatchesLineByLine(b,N,s,w,r):[]}static _getMultilineMatchRange(b,d,N,w,r,s){let o,a=0;w?(a=w.findLineFeedCountBeforeOffset(r),o=d+r+a):o=d+r;let v;if(w){const g=w.findLineFeedCountBeforeOffset(r+s.length)-a;v=o+s.length+g}else v=o+s.length;const c=b.getPositionAt(o),f=b.getPositionAt(v);return new u.Range(c.lineNumber,c.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(b,d,N,w,r){const s=b.getOffsetAt(d.getStartPosition()),o=b.getValueInRange(d,1),a=b.getEOL()===`\r
`?new y(o):null,v=[];let c=0,f;for(N.reset(0);f=N.next(o);)if(v[c++]=p(this._getMultilineMatchRange(b,s,o,a,f.index,f[0]),f,w),c>=r)return v;return v}static _doFindMatchesLineByLine(b,d,N,w,r){const s=[];let o=0;if(d.startLineNumber===d.endLineNumber){const v=b.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return o=this._findMatchesInLine(N,v,d.startLineNumber,d.startColumn-1,o,s,w,r),s}const a=b.getLineContent(d.startLineNumber).substring(d.startColumn-1);o=this._findMatchesInLine(N,a,d.startLineNumber,d.startColumn-1,o,s,w,r);for(let v=d.startLineNumber+1;v<d.endLineNumber&&o<r;v++)o=this._findMatchesInLine(N,b.getLineContent(v),v,0,o,s,w,r);if(o<r){const v=b.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);o=this._findMatchesInLine(N,v,d.endLineNumber,0,o,s,w,r)}return s}static _findMatchesInLine(b,d,N,w,r,s,o,a){const v=b.wordSeparators;if(!o&&b.simpleSearch){const E=b.simpleSearch,g=E.length,F=d.length;let C=-g;for(;(C=d.indexOf(E,C+g))!==-1;)if((!v||A(v,d,F,C,g))&&(s[r++]=new M.FindMatch(new u.Range(N,C+1+w,N,C+1+g+w),null),r>=a))return r;return r}const c=new D(b.wordSeparators,b.regex);let f;c.reset(0);do if(f=c.next(d),f&&(s[r++]=p(new u.Range(N,f.index+1+w,N,f.index+1+f[0].length+w),f,o),r>=a))return r;while(f);return r}static findNextMatch(b,d,N,w){const r=d.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(b,N,s,w):this._doFindNextMatchLineByLine(b,N,s,w)}static _doFindNextMatchMultiline(b,d,N,w){const r=new i.Position(d.lineNumber,1),s=b.getOffsetAt(r),o=b.getLineCount(),a=b.getValueInRange(new u.Range(r.lineNumber,r.column,o,b.getLineMaxColumn(o)),1),v=b.getEOL()===`\r
`?new y(a):null;N.reset(d.column-1);const c=N.next(a);return c?p(this._getMultilineMatchRange(b,s,a,v,c.index,c[0]),c,w):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(b,new i.Position(1,1),N,w):null}static _doFindNextMatchLineByLine(b,d,N,w){const r=b.getLineCount(),s=d.lineNumber,o=b.getLineContent(s),a=this._findFirstMatchInLine(N,o,s,d.column,w);if(a)return a;for(let v=1;v<=r;v++){const c=(s+v-1)%r,f=b.getLineContent(c+1),E=this._findFirstMatchInLine(N,f,c+1,1,w);if(E)return E}return null}static _findFirstMatchInLine(b,d,N,w,r){b.reset(w-1);const s=b.next(d);return s?p(new u.Range(N,s.index+1,N,s.index+1+s[0].length),s,r):null}static findPreviousMatch(b,d,N,w){const r=d.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(b,N,s,w):this._doFindPreviousMatchLineByLine(b,N,s,w)}static _doFindPreviousMatchMultiline(b,d,N,w){const r=this._doFindMatchesMultiline(b,new u.Range(1,1,d.lineNumber,d.column),N,w,10*_);if(r.length>0)return r[r.length-1];const s=b.getLineCount();return d.lineNumber!==s||d.column!==b.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(b,new i.Position(s,b.getLineMaxColumn(s)),N,w):null}static _doFindPreviousMatchLineByLine(b,d,N,w){const r=b.getLineCount(),s=d.lineNumber,o=b.getLineContent(s).substring(0,d.column-1),a=this._findLastMatchInLine(N,o,s,w);if(a)return a;for(let v=1;v<=r;v++){const c=(r+s-v-1)%r,f=b.getLineContent(c+1),E=this._findLastMatchInLine(N,f,c+1,w);if(E)return E}return null}static _findLastMatchInLine(b,d,N,w){let r=null,s;for(b.reset(0);s=b.next(d);)r=p(new u.Range(N,s.index+1,N,s.index+1+s[0].length),s,w);return r}}t.TextModelSearch=L;function m(R,b,d,N,w){if(N===0)return!0;const r=b.charCodeAt(N-1);if(R.get(r)!==0||r===13||r===10)return!0;if(w>0){const s=b.charCodeAt(N);if(R.get(s)!==0)return!0}return!1}function e(R,b,d,N,w){if(N+w===d)return!0;const r=b.charCodeAt(N+w);if(R.get(r)!==0||r===13||r===10)return!0;if(w>0){const s=b.charCodeAt(N+w-1);if(R.get(s)!==0)return!0}return!1}function A(R,b,d,N,w){return m(R,b,d,N,w)&&e(R,b,d,N,w)}t.isValidMatch=A;class D{constructor(b,d){this._wordSeparators=b,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const d=b.length;let N;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(N=this._searchRegex.exec(b),!N))return null;const w=N.index,r=N[0].length;if(w===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){P.getNextCodePoint(b,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=w,this._prevMatchLength=r,!this._wordSeparators||A(this._wordSeparators,b,d,w,r))return N}while(N);return null}}t.Searcher=D}),J(ee[51],te([0,1,2,50,4,10,21]),function(q,t,P,I,i,u,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class _{static computeUnicodeHighlights(e,A,D){const R=D?D.startLineNumber:1,b=D?D.endLineNumber:e.getLineCount(),d=new p(A),N=d.getCandidateCodePoints();let w;N==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${l(Array.from(N))}`,"g");const r=new I.Searcher(null,w),s=[];let o=!1,a,v=0,c=0,f=0;e:for(let E=R,g=b;E<=g;E++){const F=e.getLineContent(E),C=F.length;r.reset(0);do if(a=r.next(F),a){let O=a.index,W=a.index+a[0].length;if(O>0){const X=F.charCodeAt(O-1);i.isHighSurrogate(X)&&O--}if(W+1<C){const X=F.charCodeAt(W-1);i.isHighSurrogate(X)&&W++}const x=F.substring(O,W);let j=(0,M.getWordAtText)(O+1,M.DEFAULT_WORD_REGEXP,F,0);j&&j.endColumn<=O+1&&(j=null);const K=d.shouldHighlightNonBasicASCII(x,j?j.word:null);if(K!==0){K===3?v++:K===2?c++:K===1?f++:(0,u.assertNever)(K);const X=1e3;if(s.length>=X){o=!0;break e}s.push(new P.Range(E,O+1,E,W+1))}}while(a)}return{ranges:s,hasMore:o,ambiguousCharacterCount:v,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:f}}static computeUnicodeHighlightReason(e,A){const D=new p(A);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),d=D.ambiguousCharacters.getPrimaryConfusable(b),N=i.AmbiguousCharacters.getLocales().filter(w=>!i.AmbiguousCharacters.getInstance(new Set([...A.allowedLocales,w])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:N}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=_;function l(m,e){return`[${i.escapeRegExpCharacters(m.map(D=>String.fromCodePoint(D)).join(""))}]`}var h;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(h=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class p{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const A of i.InvisibleCharacters.codePoints)y(String.fromCodePoint(A))||e.add(A);if(this.options.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.allowedCodePoints)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const D=e.codePointAt(0);if(this.allowedCodePoints.has(D))return 0;if(this.options.nonBasicASCII)return 1;let R=!1,b=!1;if(A)for(const d of A){const N=d.codePointAt(0),w=i.isBasicASCII(d);R=R||w,!w&&!this.ambiguousCharacters.isAmbiguous(N)&&!i.InvisibleCharacters.isInvisibleCharacter(N)&&(b=!0)}return!R&&b?0:this.options.invisibleCharacters&&!y(e)&&i.InvisibleCharacters.isInvisibleCharacter(D)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function y(m){return m===" "||m===`
`||m==="	"}var L;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(L||(L={}))}),J(ee[52],te([0,1,9,6]),function(q,t,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,l){return this._tokenizationSupports.set(_,l),this.handleChange([_]),(0,I.toDisposable)(()=>{this._tokenizationSupports.get(_)===l&&(this._tokenizationSupports.delete(_),this.handleChange([_]))})}get(_){return this._tokenizationSupports.get(_)||null}registerFactory(_,l){this._factories.get(_)?.dispose();const h=new u(this,_,l);return this._factories.set(_,h),(0,I.toDisposable)(()=>{const p=this._factories.get(_);!p||p!==h||(this._factories.delete(_),p.dispose())})}async getOrCreate(_){const l=this.get(_);if(l)return l;const h=this._factories.get(_);return!h||h.isResolved?null:(await h.resolve(),this.get(_))}isResolved(_){if(this.get(_))return!0;const h=this._factories.get(_);return!!(!h||h.isResolved)}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=i;class u extends I.Disposable{get isResolved(){return this._isResolved}constructor(_,l,h){super(),this._registry=_,this._languageId=l,this._factory=h,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const _=await this._factory.tokenizationSupport;this._isResolved=!0,_&&!this._isDisposed&&this._register(this._registry.register(this._languageId,_))}}}),J(ee[53],te([0,1,30,13,2,52]),function(q,t,P,I,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class M{constructor(F,C,O){this.offset=F,this.type=C,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=M;class _{constructor(F,C){this.tokens=F,this.endState=C,this._tokenizationResultBrand=void 0}}t.TokenizationResult=_;class l{constructor(F,C){this.tokens=F,this.endState=C,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=l;var h;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(h=t.CompletionItemKind||(t.CompletionItemKind={}));var p;(function(g){const F=new Map;F.set(0,P.Codicon.symbolMethod),F.set(1,P.Codicon.symbolFunction),F.set(2,P.Codicon.symbolConstructor),F.set(3,P.Codicon.symbolField),F.set(4,P.Codicon.symbolVariable),F.set(5,P.Codicon.symbolClass),F.set(6,P.Codicon.symbolStruct),F.set(7,P.Codicon.symbolInterface),F.set(8,P.Codicon.symbolModule),F.set(9,P.Codicon.symbolProperty),F.set(10,P.Codicon.symbolEvent),F.set(11,P.Codicon.symbolOperator),F.set(12,P.Codicon.symbolUnit),F.set(13,P.Codicon.symbolValue),F.set(15,P.Codicon.symbolEnum),F.set(14,P.Codicon.symbolConstant),F.set(15,P.Codicon.symbolEnum),F.set(16,P.Codicon.symbolEnumMember),F.set(17,P.Codicon.symbolKeyword),F.set(27,P.Codicon.symbolSnippet),F.set(18,P.Codicon.symbolText),F.set(19,P.Codicon.symbolColor),F.set(20,P.Codicon.symbolFile),F.set(21,P.Codicon.symbolReference),F.set(22,P.Codicon.symbolCustomColor),F.set(23,P.Codicon.symbolFolder),F.set(24,P.Codicon.symbolTypeParameter),F.set(25,P.Codicon.account),F.set(26,P.Codicon.issues);function C(x){let j=F.get(x);return j||(console.info("No codicon found for CompletionItemKind "+x),j=P.Codicon.symbolProperty),j}g.toIcon=C;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(x,j){let K=O.get(x);return typeof K>"u"&&!j&&(K=9),K}g.fromString=W})(p=t.CompletionItemKinds||(t.CompletionItemKinds={}));var y;(function(g){g[g.Deprecated=1]="Deprecated"})(y=t.CompletionItemTag||(t.CompletionItemTag={}));var L;(function(g){g[g.None=0]="None",g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(L=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var A;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(A=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var D;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var R;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(R=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function b(g){return g&&I.URI.isUri(g.uri)&&i.Range.isIRange(g.range)&&(i.Range.isIRange(g.originSelectionRange)||i.Range.isIRange(g.targetSelectionRange))}t.isLocationLink=b;var d;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(d=t.SymbolKind||(t.SymbolKind={}));var N;(function(g){g[g.Deprecated=1]="Deprecated"})(N=t.SymbolTag||(t.SymbolTag={}));var w;(function(g){const F=new Map;F.set(0,P.Codicon.symbolFile),F.set(1,P.Codicon.symbolModule),F.set(2,P.Codicon.symbolNamespace),F.set(3,P.Codicon.symbolPackage),F.set(4,P.Codicon.symbolClass),F.set(5,P.Codicon.symbolMethod),F.set(6,P.Codicon.symbolProperty),F.set(7,P.Codicon.symbolField),F.set(8,P.Codicon.symbolConstructor),F.set(9,P.Codicon.symbolEnum),F.set(10,P.Codicon.symbolInterface),F.set(11,P.Codicon.symbolFunction),F.set(12,P.Codicon.symbolVariable),F.set(13,P.Codicon.symbolConstant),F.set(14,P.Codicon.symbolString),F.set(15,P.Codicon.symbolNumber),F.set(16,P.Codicon.symbolBoolean),F.set(17,P.Codicon.symbolArray),F.set(18,P.Codicon.symbolObject),F.set(19,P.Codicon.symbolKey),F.set(20,P.Codicon.symbolNull),F.set(21,P.Codicon.symbolEnumMember),F.set(22,P.Codicon.symbolStruct),F.set(23,P.Codicon.symbolEvent),F.set(24,P.Codicon.symbolOperator),F.set(25,P.Codicon.symbolTypeParameter);function C(O){let W=F.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=P.Codicon.symbolProperty),W}g.toIcon=C})(w=t.SymbolKinds||(t.SymbolKinds={}));class r{static fromValue(F){switch(F){case"comment":return r.Comment;case"imports":return r.Imports;case"region":return r.Region}return new r(F)}constructor(F){this.value=F}}r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region"),t.FoldingRangeKind=r;var s;(function(g){function F(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}g.is=F})(s=t.Command||(t.Command={}));var o;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(o=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var a;(function(g){g[g.Unresolved=0]="Unresolved",g[g.Resolved=1]="Resolved"})(a=t.CommentThreadState||(t.CommentThreadState={}));var v;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(v=t.CommentMode||(t.CommentMode={}));var c;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(c=t.InlayHintKind||(t.InlayHintKind={}));class f{constructor(F){this.createSupport=F,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=f,t.TokenizationRegistry=new u.TokenizationRegistry;var E;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(E=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),J(ee[54],te([0,1,23,9,28,13,3,2,31,53,42]),function(q,t,P,I,i,u,M,_,l,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class y{static chord(e,A){return(0,i.KeyChord)(e,A)}}y.CtrlCmd=2048,y.Shift=1024,y.Alt=512,y.WinCtrl=256,t.KeyMod=y;function L(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:I.Emitter,KeyCode:p.KeyCode,KeyMod:y,Position:M.Position,Range:_.Range,Selection:l.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:u.URI,Token:h.Token}}t.createMonacoBaseAPI=L}),J(ee[59],te([0,1,24,13,3,2,49,21,38,39,54,22,51,25,12,48,11,5]),function(q,t,P,I,i,u,M,_,l,h,p,y,L,m,e,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends M.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(r){return this._lines[r-1]}getWordAtPosition(r,s){const o=(0,_.getWordAtText)(r.column,(0,_.ensureValidWordDefinition)(s),this._lines[r.lineNumber-1],0);return o?new u.Range(r.lineNumber,o.startColumn,r.lineNumber,o.endColumn):null}getWordUntilPosition(r,s){const o=this.getWordAtPosition(r,s);return o?{word:this._lines[r.lineNumber-1].substring(o.startColumn-1,r.column-1),startColumn:o.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const s=this._lines,o=this._wordenize.bind(this);let a=0,v="",c=0,f=[];return{*[Symbol.iterator](){for(;;)if(c<f.length){const E=v.substring(f[c].start,f[c].end);c+=1,yield E}else if(a<s.length)v=s[a],f=o(v,r),c=0,a+=1;else break}}}getLineWords(r,s){const o=this._lines[r-1],a=this._wordenize(o,s),v=[];for(const c of a)v.push({word:o.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return v}_wordenize(r,s){const o=[];let a;for(s.lastIndex=0;(a=s.exec(r))&&a[0].length!==0;)o.push({start:a.index,end:a.index+a[0].length});return o}getValueInRange(r){if(r=this._validateRange(r),r.startLineNumber===r.endLineNumber)return this._lines[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const s=this._eol,o=r.startLineNumber-1,a=r.endLineNumber-1,v=[];v.push(this._lines[o].substring(r.startColumn-1));for(let c=o+1;c<a;c++)v.push(this._lines[c]);return v.push(this._lines[a].substring(0,r.endColumn-1)),v.join(s)}offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(r),o=this._lines[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,o)}}_validateRange(r){const s=this._validatePosition({lineNumber:r.startLineNumber,column:r.startColumn}),o=this._validatePosition({lineNumber:r.endLineNumber,column:r.endColumn});return s.lineNumber!==r.startLineNumber||s.column!==r.startColumn||o.lineNumber!==r.endLineNumber||o.column!==r.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:o.lineNumber,endColumn:o.column}:r}_validatePosition(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:s,column:o}=r,a=!1;if(s<1)s=1,o=1,a=!0;else if(s>this._lines.length)s=this._lines.length,o=this._lines[s-1].length+1,a=!0;else{const v=this._lines[s-1].length+1;o<1?(o=1,a=!0):o>v&&(o=v,a=!0)}return a?{lineNumber:s,column:o}:r}}class d{constructor(r,s){this._host=r,this._models=Object.create(null),this._foreignModuleFactory=s,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(r){return this._models[r]}_getModels(){const r=[];return Object.keys(this._models).forEach(s=>r.push(this._models[s])),r}acceptNewModel(r){this._models[r.url]=new b(I.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,s){if(!this._models[r])return;this._models[r].onEvents(s)}acceptRemovedModel(r){!this._models[r]||delete this._models[r]}async computeUnicodeHighlights(r,s,o){const a=this._getModel(r);return a?L.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,s,o):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,s,o,a){const v=this._getModel(r),c=this._getModel(s);return!v||!c?null:d.computeDiff(v,c,o,a)}static computeDiff(r,s,o,a){const v=a==="experimental"?A.linesDiffComputers.experimental:A.linesDiffComputers.smart,c=r.getLinesContent(),f=s.getLinesContent(),E=v.computeDiff(c,f,o);return{identical:E.changes.length>0?!1:this._modelsAreIdentical(r,s),quitEarly:E.quitEarly,changes:E.changes.map(F=>[F.originalRange.startLineNumber,F.originalRange.endLineNumberExclusive,F.modifiedRange.startLineNumber,F.modifiedRange.endLineNumberExclusive,F.innerChanges?.map(C=>[C.originalRange.startLineNumber,C.originalRange.startColumn,C.originalRange.endLineNumber,C.originalRange.endColumn,C.modifiedRange.startLineNumber,C.modifiedRange.startColumn,C.modifiedRange.endLineNumber,C.modifiedRange.endColumn])])}}static _modelsAreIdentical(r,s){const o=r.getLineCount(),a=s.getLineCount();if(o!==a)return!1;for(let v=1;v<=o;v++){const c=r.getLineContent(v),f=s.getLineContent(v);if(c!==f)return!1}return!0}async computeDirtyDiff(r,s,o){const a=this._getModel(r),v=this._getModel(s);if(!a||!v)return null;const c=a.getLinesContent(),f=v.getLinesContent();return new m.DiffComputer(c,f,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,s,o){const a=this._getModel(r);if(!a)return s;const v=[];let c;s=s.slice(0).sort((f,E)=>{if(f.range&&E.range)return u.Range.compareRangesUsingStarts(f.range,E.range);const g=f.range?0:1,F=E.range?0:1;return g-F});for(let{range:f,text:E,eol:g}of s){if(typeof g=="number"&&(c=g),u.Range.isEmpty(f)&&!E)continue;const F=a.getValueInRange(f);if(E=E.replace(/\r\n|\n|\r/g,a.eol),F===E)continue;if(Math.max(E.length,F.length)>d._diffLimit){v.push({range:f,text:E});continue}const C=(0,P.stringDiff)(F,E,o),O=a.offsetAt(u.Range.lift(f).getStartPosition());for(const W of C){const x=a.positionAt(O+W.originalStart),j=a.positionAt(O+W.originalStart+W.originalLength),K={text:E.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:x.lineNumber,startColumn:x.column,endLineNumber:j.lineNumber,endColumn:j.column}};a.getValueInRange(K.range)!==K.text&&v.push(K)}}return typeof c=="number"&&v.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeHumanReadableDiff(r,s){const o=this._getModel(r);if(!o)return s;const a=[];let v;s=s.slice(0).sort((c,f)=>{if(c.range&&f.range)return u.Range.compareRangesUsingStarts(c.range,f.range);const E=c.range?0:1,g=f.range?0:1;return E-g});for(let{range:c,text:f,eol:E}of s){let W=function($,n,ue){return $.map(ae=>ae.innerChanges?new e.LineRangeMapping(ae.originalRange,ae.modifiedRange,ae.innerChanges.map(ie=>ie.originalRange.endColumn===1&&ie.originalRange.endLineNumber>n?ie.originalRange.isEmpty()||ie.modifiedRange.isEmpty()?new e.RangeMapping(new u.Range(ie.originalRange.startLineNumber-1,Number.MAX_SAFE_INTEGER,ie.originalRange.endLineNumber-1,Number.MAX_SAFE_INTEGER),new u.Range(ie.modifiedRange.startLineNumber-1,Number.MAX_SAFE_INTEGER,ie.modifiedRange.endLineNumber-1,Number.MAX_SAFE_INTEGER)):new e.RangeMapping(new u.Range(ie.originalRange.startLineNumber,ie.originalRange.startColumn,ie.originalRange.endLineNumber-1,Number.MAX_SAFE_INTEGER),new u.Range(ie.modifiedRange.startLineNumber,ie.modifiedRange.startColumn,ie.modifiedRange.endLineNumber-1,Number.MAX_SAFE_INTEGER)):ie)):ae)},K=function($,n){return new i.Position($.lineNumber+n.lineNumber-1,n.lineNumber===1?$.column+n.column-1:n.column)},X=function($,n){const ue=[];for(let ae=n.startLineNumber;ae<=n.endLineNumber;ae++){const ie=$[ae-1];ae===n.startLineNumber&&ae===n.endLineNumber?ue.push(ie.substring(n.startColumn-1,n.endColumn-1)):ae===n.startLineNumber?ue.push(ie.substring(n.startColumn-1)):ae===n.endLineNumber?ue.push(ie.substring(0,n.endColumn-1)):ue.push(ie)}return ue};if(typeof E=="number"&&(v=E),u.Range.isEmpty(c)&&!f)continue;const g=o.getValueInRange(c);if(f=f.replace(/\r\n|\n|\r/g,o.eol),g===f)continue;if(Math.max(f.length,g.length)>d._diffLimit){a.push({range:c,text:f});continue}const F=g.split(/\r\n|\n|\r/),C=f.split(/\r\n|\n|\r/),O=A.linesDiffComputers.experimental.computeDiff(F,C,{maxComputationTimeMs:1e3,ignoreTrimWhitespace:!1}),x=W(O.changes,F.length,C.length),j=u.Range.lift(c).getStartPosition();for(const $ of x)if($.innerChanges)for(const n of $.innerChanges)a.push({range:u.Range.fromPositions(K(j,n.originalRange.getStartPosition()),K(j,n.originalRange.getEndPosition())),text:X(C,n.modifiedRange).join(o.eol)});else throw new R.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof v=="number"&&a.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a}async computeLinks(r){const s=this._getModel(r);return s?(0,l.computeLinks)(s):null}async textualSuggest(r,s,o,a){const v=new y.StopWatch(!0),c=new RegExp(o,a),f=new Set;e:for(const E of r){const g=this._getModel(E);if(!!g){for(const F of g.words(c))if(!(F===s||!isNaN(Number(F)))&&(f.add(F),f.size>d._suggestionsLimit))break e}}return{words:Array.from(f),duration:v.elapsed()}}async computeWordRanges(r,s,o,a){const v=this._getModel(r);if(!v)return Object.create(null);const c=new RegExp(o,a),f=Object.create(null);for(let E=s.startLineNumber;E<s.endLineNumber;E++){const g=v.getLineWords(E,c);for(const F of g){if(!isNaN(Number(F.word)))continue;let C=f[F.word];C||(C=[],f[F.word]=C),C.push({startLineNumber:E,startColumn:F.startColumn,endLineNumber:E,endColumn:F.endColumn})}}return f}async navigateValueSet(r,s,o,a,v){const c=this._getModel(r);if(!c)return null;const f=new RegExp(a,v);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const E=c.getValueInRange(s),g=c.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},f);if(!g)return null;const F=c.getValueInRange(g);return h.BasicInplaceReplace.INSTANCE.navigateValueSet(s,E,g,F,o)}loadForeignModule(r,s,o){const a=(f,E)=>this._host.fhr(f,E),c={host:(0,D.createProxyObject)(o,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(c,s),Promise.resolve((0,D.getAllMethodNames)(this._foreignModule))):new Promise((f,E)=>{q([r],g=>{this._foreignModule=g.create(c,s),f((0,D.getAllMethodNames)(this._foreignModule))},E)})}fmr(r,s){if(!this._foreignModule||typeof this._foreignModule[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this._foreignModule[r].apply(this._foreignModule,s))}catch(o){return Promise.reject(o)}}}d._diffLimit=1e5,d._suggestionsLimit=1e4,t.EditorSimpleWorker=d;function N(w){return new d(w,null)}t.create=N,typeof importScripts=="function"&&(globalThis.monaco=(0,p.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/base/worker/workerMain.js.map
