/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],te=function(j){for(var e=[],I=0,A=j.length;I<A;I++)e[I]=ee[j[I]];return e};define(ee[128],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(k,f){const u=Math.pow(10,f);return Math.round(k*u)/u}class A{constructor(f,u,v,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=I(Math.max(Math.min(1,p),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.RGBA=A;class r{constructor(f,u,v,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,u),0),3),this.l=I(Math.max(Math.min(1,v),0),3),this.a=I(Math.max(Math.min(1,p),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,v=f.g/255,p=f.b/255,y=f.a,h=Math.max(u,v,p),E=Math.min(u,v,p);let S=0,s=0;const g=(E+h)/2,d=h-E;if(d>0){switch(s=Math.min(g<=.5?d/(2*g):d/(2-2*g),1),h){case u:S=(v-p)/d+(v<p?6:0);break;case v:S=(p-u)/d+2;break;case p:S=(u-v)/d+4;break}S*=60,S=Math.round(S)}return new r(S,s,g,y)}static _hue2rgb(f,u,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?f+(u-f)*6*v:v<1/2?u:v<2/3?f+(u-f)*(2/3-v)*6:f}static toRGBA(f){const u=f.h/360,{s:v,l:p,a:y}=f;let h,E,S;if(v===0)h=E=S=p;else{const s=p<.5?p*(1+v):p+v-p*v,g=2*p-s;h=r._hue2rgb(g,s,u+1/3),E=r._hue2rgb(g,s,u),S=r._hue2rgb(g,s,u-1/3)}return new A(Math.round(h*255),Math.round(E*255),Math.round(S*255),y)}}e.HSLA=r;class L{constructor(f,u,v,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,u),0),3),this.v=I(Math.max(Math.min(1,v),0),3),this.a=I(Math.max(Math.min(1,p),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,v=f.g/255,p=f.b/255,y=Math.max(u,v,p),h=Math.min(u,v,p),E=y-h,S=y===0?0:E/y;let s;return E===0?s=0:y===u?s=((v-p)/E%6+6)%6:y===v?s=(p-u)/E+2:s=(u-v)/E+4,new L(Math.round(s*60),S,y,f.a)}static toRGBA(f){const{h:u,s:v,v:p,a:y}=f,h=p*v,E=h*(1-Math.abs(u/60%2-1)),S=p-h;let[s,g,d]=[0,0,0];return u<60?(s=h,g=E):u<120?(s=E,g=h):u<180?(g=h,d=E):u<240?(g=E,d=h):u<300?(s=E,d=h):u<=360&&(s=h,d=E),s=Math.round((s+S)*255),g=Math.round((g+S)*255),d=Math.round((d+S)*255),new A(s,g,d,y)}}e.HSVA=L;class M{static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:L.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof A)this.rgba=f;else if(f instanceof r)this._hsla=f,this.rgba=r.toRGBA(f);else if(f instanceof L)this._hsva=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&A.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M._relativeLuminanceForComponent(this.rgba.r),u=M._relativeLuminanceForComponent(this.rgba.g),v=M._relativeLuminanceForComponent(this.rgba.b),p=.2126*f+.7152*u+.0722*v;return I(p,4)}static _relativeLuminanceForComponent(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),v=f.getRelativeLuminance();return u>v?(u+.05)/(v+.05):(v+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),v=f.getRelativeLuminance();return u>v}isDarkerThan(f){const u=this.getRelativeLuminance(),v=f.getRelativeLuminance();return u<v}lighten(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:v,b:p,a:y}=this.rgba;return new M(new A(u,v,p,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,v=this.rgba.a,p=u.a,y=v+p*(1-v);if(y<1e-6)return M.transparent;const h=this.rgba.r*v/y+u.r*p*(1-v)/y,E=this.rgba.g*v/y+u.g*p*(1-v)/y,S=this.rgba.b*v/y+u.b*p*(1-v)/y;return new M(new A(h,E,S,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:v,b:p,a:y}=this.rgba;return new M(new A(f.rgba.r-y*(f.rgba.r-u),f.rgba.g-y*(f.rgba.g-v),f.rgba.b-y*(f.rgba.b-p),1))}flatten(...f){const u=f.reduceRight((v,p)=>M._flatten(p,v));return M._flatten(this,u)}static _flatten(f,u){const v=1-f.rgba.a;return new M(new A(v*u.rgba.r+f.rgba.a*f.rgba.r,v*u.rgba.g+f.rgba.a*f.rgba.g,v*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(f,u,v){if(f.isLighterThan(u))return f;v=v||.5;const p=f.getRelativeLuminance(),y=u.getRelativeLuminance();return v=v*(y-p)/y,f.lighten(v)}static getDarkerColor(f,u,v){if(f.isDarkerThan(u))return f;v=v||.5;const p=f.getRelativeLuminance(),y=u.getRelativeLuminance();return v=v*(p-y)/p,f.darken(v)}}M.white=new M(new A(255,255,255,1)),M.black=new M(new A(0,0,0,1)),M.red=new M(new A(255,0,0,1)),M.blue=new M(new A(0,0,255,1)),M.green=new M(new A(0,255,0,1)),M.cyan=new M(new A(0,255,255,1)),M.lightgrey=new M(new A(211,211,211,1)),M.transparent=new M(new A(0,0,0,0)),e.Color=M,function(k){let f;(function(u){let v;(function(p){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}p.formatRGB=y;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}p.formatRGBA=h;function E(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}p.formatHSL=E;function S(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}p.formatHSLA=S;function s(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}`}p.formatHex=g;function d(t,l=!1){return l&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}${s(Math.round(t.rgba.a*255))}`}p.formatHexA=d;function b(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}p.format=b;function w(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),n=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),a=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new A(i,n,a,1))}if(l===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),n=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),a=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),c=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new A(i,n,a,c/255))}if(l===4){const i=D(t.charCodeAt(1)),n=D(t.charCodeAt(2)),a=D(t.charCodeAt(3));return new k(new A(16*i+i,16*n+n,16*a+a))}if(l===5){const i=D(t.charCodeAt(1)),n=D(t.charCodeAt(2)),a=D(t.charCodeAt(3)),c=D(t.charCodeAt(4));return new k(new A(16*i+i,16*n+n,16*a+a,(16*c+c)/255))}return null}p.parseHex=w;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=u.CSS||(u.CSS={}))})(f=k.Format||(k.Format={}))}(M=e.Color||(e.Color={})),e.Color=M}),define(ee[55],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(M){return(k,f,u)=>{let v=null,p=null;if(typeof u.value=="function"?(v="value",p=u.value):typeof u.get=="function"&&(v="get",p=u.get),!p)throw new Error("not supported");u[v]=M(p,f)}}function A(M,k,f){let u=null,v=null;if(typeof f.value=="function"?(u="value",v=f.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",v=f.get),!v)throw new Error("not supported");const p=`$memoize$${k}`;f[u]=function(...y){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,y)}),this[p]}}e.memoize=A;function r(M,k,f){return I((u,v)=>{const p=`$debounce$${v}`,y=`$debounce$result$${v}`;return function(...h){this[y]||(this[y]=f?f():void 0),clearTimeout(this[p]),k&&(this[y]=k(this[y],...h),h=[this[y]]),this[p]=setTimeout(()=>{u.apply(this,h),this[y]=f?f():void 0},M)}})}e.debounce=r;function L(M,k,f){return I((u,v)=>{const p=`$throttle$timer$${v}`,y=`$throttle$result$${v}`,h=`$throttle$lastRun$${v}`,E=`$throttle$pending$${v}`;return function(...S){if(this[y]||(this[y]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[y]=k(this[y],...S)),this[E])return;const s=this[h]+M;s<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0):(this[E]=!0,this[p]=setTimeout(()=>{this[E]=!1,this[h]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0},s-Date.now()))}})}e.throttle=L}),define(ee[13],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?w.isErrorNoTelemetry(l)?new w(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(i=>{i(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=I,e.errorHandler=new I;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function r(t){if(!t||typeof t!="object")return!1;const l=t;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function L(t){u(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=L;function M(t){u(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function k(t){if(t instanceof Error){const{name:l,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:l,message:i,stack:n,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const f="Canceled";function u(t){return t instanceof v?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=u;class v extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=v;function p(){const t=new Error(f);return t.name=t.message,t}e.canceled=p;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=h;function E(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function S(t){const l=new Error(`${t} has been disposed`);return l.name="DISPOSED",l}e.disposed=S;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class g extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}e.NotImplementedError=g;class d extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}e.NotSupportedError=d;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class w extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof w)return l;const i=new w;return i.message=l.message,i.stack=l.stack,i}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class D extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(ee[22],te([0,1,13]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(N,z=0){return N[N.length-(1+z)]}e.tail=A;function r(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=r;function L(N,z,V=(se,de)=>se===de){if(N===z)return!0;if(!N||!z||N.length!==z.length)return!1;for(let se=0,de=N.length;se<de;se++)if(!V(N[se],z[se]))return!1;return!0}e.equals=L;function M(N,z){const V=N.length-1;z<V&&(N[z]=N[V]),N.pop()}e.removeFastWithoutKeepingOrder=M;function k(N,z,V){return f(N.length,se=>V(N[se],z))}e.binarySearch=k;function f(N,z){let V=0,se=N-1;for(;V<=se;){const de=(V+se)/2|0,ye=z(de);if(ye<0)V=de+1;else if(ye>0)se=de-1;else return de}return-(V+1)}e.binarySearch2=f;function u(N,z){let V=0,se=N.length;if(se===0)return 0;for(;V<se;){const de=Math.floor((V+se)/2);z(N[de])?se=de:V=de+1}return V}e.findFirstInSorted=u;function v(N,z,V){if(N=N|0,N>=z.length)throw new TypeError("invalid index");const se=z[Math.floor(z.length*Math.random())],de=[],ye=[],ke=[];for(const Ae of z){const _e=V(Ae,se);_e<0?de.push(Ae):_e>0?ye.push(Ae):ke.push(Ae)}return N<de.length?v(N,de,V):N<de.length+ke.length?ke[0]:v(N-(de.length+ke.length),ye,V)}e.quickSelect=v;function p(N,z){const V=[];let se;for(const de of N.slice(0).sort(z))!se||z(se[0],de)!==0?(se=[de],V.push(se)):se.push(de);return V}e.groupBy=p;function y(N,z,V){const se=[];function de(Ae,_e,Oe){if(_e===0&&Oe.length===0)return;const me=se[se.length-1];me&&me.start+me.deleteCount===Ae?(me.deleteCount+=_e,me.toInsert.push(...Oe)):se.push({start:Ae,deleteCount:_e,toInsert:Oe})}let ye=0,ke=0;for(;;){if(ye===N.length){de(ye,0,z.slice(ke));break}if(ke===z.length){de(ye,N.length-ye,[]);break}const Ae=N[ye],_e=z[ke],Oe=V(Ae,_e);Oe===0?(ye+=1,ke+=1):Oe<0?(de(ye,1,[]),ye+=1):Oe>0&&(de(ye,0,[_e]),ke+=1)}return se}e.sortedDiff=y;function h(N,z,V){const se=y(N,z,V),de=[],ye=[];for(const ke of se)de.push(...N.slice(ke.start,ke.start+ke.deleteCount)),ye.push(...ke.toInsert);return{removed:de,added:ye}}e.delta=h;function E(N,z,V){if(V===0)return[];const se=N.slice(0,V).sort(z);return s(N,z,se,V,N.length),se}e.top=E;function S(N,z,V,se,de){return V===0?Promise.resolve([]):new Promise((ye,ke)=>{(async()=>{const Ae=N.length,_e=N.slice(0,V).sort(z);for(let Oe=V,me=Math.min(V+se,Ae);Oe<Ae;Oe=me,me=Math.min(me+se,Ae)){if(Oe>V&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new I.CancellationError;s(N,z,_e,Oe,me)}return _e})().then(ye,ke)})}e.topAsync=S;function s(N,z,V,se,de){for(const ye=V.length;se<de;se++){const ke=N[se];if(z(ke,V[ye-1])<0){V.pop();const Ae=u(V,_e=>z(ke,_e)<0);V.splice(Ae,0,ke)}}}function g(N){return N.filter(z=>!!z)}e.coalesce=g;function d(N){let z=0;for(let V=0;V<N.length;V++)N[V]&&(N[z]=N[V],z+=1);N.length=z}e.coalesceInPlace=d;function b(N,z,V){N.splice(V,0,N.splice(z,1)[0])}e.move=b;function w(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=w;function D(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=D;function t(N,z=V=>V){const V=new Set;return N.filter(se=>{const de=z(se);return V.has(de)?!1:(V.add(de),!0)})}e.distinct=t;function l(N){const z=new Set;return V=>{const se=N(V);return z.has(se)?!1:(z.add(se),!0)}}e.uniqueFilter=l;function i(N,z){const V=n(N,z);if(V!==-1)return N[V]}e.findLast=i;function n(N,z){for(let V=N.length-1;V>=0;V--){const se=N[V];if(z(se))return V}return-1}e.lastIndex=n;function a(N,z){return N.length>0?N[0]:z}e.firstOrDefault=a;function c(N,z){return N.length>0?N[N.length-1]:z}e.lastOrDefault=c;function o(N,z,V=(se,de)=>se===de){let se=0;for(let de=0,ye=Math.min(N.length,z.length);de<ye&&V(N[de],z[de]);de++)se++;return se}e.commonPrefixLength=o;function m(N){return[].concat(...N)}e.flatten=m;function C(N,z){let V=typeof z=="number"?N:0;typeof z=="number"?V=N:(V=0,z=N);const se=[];if(V<=z)for(let de=V;de<z;de++)se.push(de);else for(let de=V;de>z;de--)se.push(de);return se}e.range=C;function R(N,z,V){return N.reduce((se,de)=>(se[z(de)]=V?V(de):de,se),Object.create(null))}e.index=R;function T(N,z){return N.push(z),()=>U(N,z)}e.insert=T;function U(N,z){const V=N.indexOf(z);if(V>-1)return N.splice(V,1),z}e.remove=U;function $(N,z,V){const se=N.slice(0,z),de=N.slice(z);return se.concat(V,de)}e.arrayInsert=$;function q(N,z){let V;if(typeof z=="number"){let se=z;V=()=>{const de=Math.sin(se++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let se=N.length-1;se>0;se-=1){const de=Math.floor(V()*(se+1)),ye=N[se];N[se]=N[de],N[de]=ye}}e.shuffle=q;function ie(N,z){const V=N.indexOf(z);V>-1&&(N.splice(V,1),N.unshift(z))}e.pushToStart=ie;function oe(N,z){const V=N.indexOf(z);V>-1&&(N.splice(V,1),N.push(z))}e.pushToEnd=oe;function ae(N,z){for(const V of z)N.push(V)}e.pushMany=ae;function he(N,z){return Array.isArray(N)?N.map(z):z(N)}e.mapArrayOrNot=he;function ce(N){return Array.isArray(N)?N:[N]}e.asArray=ce;function K(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=K;function Y(N,z){for(const V of N){const se=z(V);if(se!==void 0)return se}}e.mapFind=Y;function x(N,z,V){const se=H(N,z),de=N.length,ye=V.length;N.length=de+ye;for(let ke=de-1;ke>=se;ke--)N[ke+ye]=N[ke];for(let ke=0;ke<ye;ke++)N[ke+se]=V[ke]}e.insertInto=x;function W(N,z,V,se){const de=H(N,z),ye=N.splice(de,V);return x(N,de,se),ye}e.splice=W;function H(N,z){return z<0?Math.max(z+N.length,0):Math.min(z,N.length)}var Q;(function(N){function z(de){return de<0}N.isLessThan=z;function V(de){return de>0}N.isGreaterThan=V;function se(de){return de===0}N.isNeitherLessOrGreaterThan=se,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function ne(N,z){return(V,se)=>z(N(V),N(se))}e.compareBy=ne;function re(...N){return(z,V)=>{for(const se of N){const de=se(z,V);if(!Q.isNeitherLessOrGreaterThan(de))return de}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const Z=(N,z)=>N-z;e.numberComparator=Z;function _(N,z){if(N.length===0)return;let V=N[0];for(let se=1;se<N.length;se++){const de=N[se];z(de,V)>0&&(V=de)}return V}e.findMaxBy=_;function P(N,z){if(N.length===0)return;let V=N[0];for(let se=1;se<N.length;se++){const de=N[se];z(de,V)>=0&&(V=de)}return V}e.findLastMaxBy=P;function O(N,z){return _(N,(V,se)=>-z(V,se))}e.findMinBy=O;class F{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let V=this.firstIdx;for(;V<this.items.length&&z(this.items[V]);)V++;const se=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,se}takeFromEndWhile(z){let V=this.lastIdx;for(;V>=0&&z(this.items[V]);)V--;const se=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,se}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const V=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,V}}e.ArrayQueue=F;class B{constructor(z){this.iterate=z}forEach(z){this.iterate(V=>(z(V),!0))}toArray(){const z=[];return this.iterate(V=>(z.push(V),!0)),z}filter(z){return new B(V=>this.iterate(se=>z(se)?V(se):!0))}map(z){return new B(V=>this.iterate(se=>V(z(se))))}some(z){let V=!1;return this.iterate(se=>(V=z(se),!V)),V}findFirst(z){let V;return this.iterate(se=>z(se)?(V=se,!1):!0),V}findLast(z){let V;return this.iterate(se=>(z(se)&&(V=se),!0)),V}findLastMaxBy(z){let V,se=!0;return this.iterate(de=>((se||Q.isGreaterThan(z(de,V)))&&(se=!1,V=de),!0)),V}}B.empty=new B(N=>{}),e.CallbackIterable=B}),define(ee[129],te([0,1,13]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=A;function r(f,u="Unreachable"){throw new Error(u)}e.assertNever=r;function L(f){if(!f)throw new I.BugIndicatingError("Assertion Failed")}e.assert=L;function M(f){if(!f()){debugger;f(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function k(f,u){let v=0;for(;v<f.length-1;){const p=f[v],y=f[v+1];if(!u(p,y))return!1;v++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(A){const r=this;let L=!1,M;return function(){return L||(L=!0,M=A.apply(r,arguments)),M}}e.once=I}),define(ee[71],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(A){function r(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}A.is=r;const L=Object.freeze([]);function M(){return L}A.empty=M;function*k(w){yield w}A.single=k;function f(w){return r(w)?w:k(w)}A.wrap=f;function u(w){return w||L}A.from=u;function v(w){return!w||w[Symbol.iterator]().next().done===!0}A.isEmpty=v;function p(w){return w[Symbol.iterator]().next().value}A.first=p;function y(w,D){for(const t of w)if(D(t))return!0;return!1}A.some=y;function h(w,D){for(const t of w)if(D(t))return t}A.find=h;function*E(w,D){for(const t of w)D(t)&&(yield t)}A.filter=E;function*S(w,D){let t=0;for(const l of w)yield D(l,t++)}A.map=S;function*s(...w){for(const D of w)for(const t of D)yield t}A.concat=s;function g(w,D,t){let l=t;for(const i of w)l=D(l,i);return l}A.reduce=g;function*d(w,D,t=w.length){for(D<0&&(D+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);D<t;D++)yield w[D]}A.slice=d;function b(w,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,w];const l=w[Symbol.iterator]();for(let i=0;i<D;i++){const n=l.next();if(n.done)return[t,A.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return l}}]}A.consume=b})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function M(t,l=!1){let i=0;const n=t.length;let a="",c=0,o=16,m=0;function C(oe){let ae=0,he=0;for(;ae<oe;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)he=he*16+ce-48;else if(ce>=65&&ce<=70)he=he*16+ce-65+10;else if(ce>=97&&ce<=102)he=he*16+ce-97+10;else break;i++,ae++}return ae<oe&&(he=-1),he}function R(oe){i=oe,a="",c=0,o=16,m=0}function T(){const oe=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return m=3,t.substring(oe,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else m=3;return t.substring(oe,ae)}function U(){let oe="",ae=i;for(;;){if(i>=n){oe+=t.substring(ae,i),m=2;break}const he=t.charCodeAt(i);if(he===34){oe+=t.substring(ae,i),i++;break}if(he===92){if(oe+=t.substring(ae,i),i++,i>=n){m=2;break}switch(t.charCodeAt(i++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const K=C(4);K>=0?oe+=String.fromCharCode(K):m=4;break}default:m=5}ae=i;continue}if(he>=0&&he<=31)if(f(he)){oe+=t.substring(ae,i),m=2;break}else m=6;i++}return oe}function $(){if(a="",m=0,c=i,i>=n)return c=n,o=17;let oe=t.charCodeAt(i);if(k(oe)){do i++,a+=String.fromCharCode(oe),oe=t.charCodeAt(i);while(k(oe));return o=15}if(f(oe))return i++,a+=String.fromCharCode(oe),oe===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),o=14;switch(oe){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,a=U(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!f(t.charCodeAt(i));)i++;return a=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const he=n-1;let ce=!1;for(;i<he;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,m=1),a=t.substring(ae,i),o=13}return a+=String.fromCharCode(oe),i++,o=16}case 45:if(a+=String.fromCharCode(oe),i++,i===n||!u(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),o=11;default:for(;i<n&&q(oe);)i++,oe=t.charCodeAt(i);if(c!==i){switch(a=t.substring(c,i),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(oe),i++,o=16}}function q(oe){if(k(oe)||f(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let oe;do oe=$();while(oe>=12&&oe<=15);return oe}return{setPosition:R,getPosition:()=>i,scan:l?ie:$,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>m}}e.createScanner=M;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function p(t,l){const i=[],n=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function m(C,R,T,U){c.value=C,c.offset=R,c.length=T,c.type=U,c.colonOffset=void 0,a=c}try{b(t,{onObjectBegin:(C,R)=>{if(l<=C)throw n;a=void 0,o=l>C,i.push("")},onObjectProperty:(C,R,T)=>{if(l<R||(m(C,R,T,"property"),i[i.length-1]=C,l<=R+T))throw n},onObjectEnd:(C,R)=>{if(l<=C)throw n;a=void 0,i.pop()},onArrayBegin:(C,R)=>{if(l<=C)throw n;a=void 0,i.push(0)},onArrayEnd:(C,R)=>{if(l<=C)throw n;a=void 0,i.pop()},onLiteralValue:(C,R,T)=>{if(l<R||(m(C,R,T,D(C)),l<=R+T))throw n},onSeparator:(C,R,T)=>{if(l<=R)throw n;if(C===":"&&a&&a.type==="property")a.colonOffset=R,o=!1,a=void 0;else if(C===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(o=!0,i[i.length-1]=""),a=void 0}}})}catch(C){if(C!==n)throw C}return{path:i,previousNode:a,isAtPropertyKey:o,matches:C=>{let R=0;for(let T=0;R<C.length&&T<i.length;T++)if(C[R]===i[T]||C[R]==="*")R++;else if(C[R]!=="**")return!1;return R===C.length}}}e.getLocation=p;function y(t,l=[],i=L.DEFAULT){let n=null,a=[];const c=[];function o(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}return b(t,{onObjectBegin:()=>{const C={};o(C),c.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const C=[];o(C),c.push(a),a=C,n=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:o,onError:(C,R,T)=>{l.push({error:C,offset:R,length:T})}},i),a[0]}e.parse=y;function h(t,l=[],i=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function c(C){return n.children.push(C),C}b(t,{onObjectBegin:C=>{n=c({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,R,T)=>{n=c({type:"property",offset:R,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:R,length:T,parent:n})},onObjectEnd:(C,R)=>{n.length=C+R-n.offset,n=n.parent,a(C+R)},onArrayBegin:(C,R)=>{n=c({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,R)=>{n.length=C+R-n.offset,n=n.parent,a(C+R)},onLiteralValue:(C,R,T)=>{c({type:D(C),offset:R,length:T,parent:n,value:C}),a(R+T)},onSeparator:(C,R,T)=>{n.type==="property"&&(C===":"?n.colonOffset=R:C===","&&a(R))},onError:(C,R,T)=>{l.push({error:C,offset:R,length:T})}},i);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=h;function E(t,l){if(!t)return;let i=t;for(const n of l)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===n){i=c.children[1],a=!0;break}if(!a)return}else{const a=n;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=E;function S(t){if(!t.parent||!t.parent.children)return[];const l=S(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;l.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&l.push(i)}return l}e.getNodePath=S;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const l=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(l[i.children[0].value]=s(n))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function g(t,l,i=!1){return l>=t.offset&&l<t.offset+t.length||i&&l===t.offset+t.length}e.contains=g;function d(t,l,i=!1){if(g(t,l,i)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=l;a++){const c=d(n[a],l,i);if(c)return c}return t}}e.findNodeAtOffset=d;function b(t,l,i=L.DEFAULT){const n=M(t,!1);function a(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(ne){return ne?re=>ne(re,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=a(l.onObjectBegin),m=c(l.onObjectProperty),C=a(l.onObjectEnd),R=a(l.onArrayBegin),T=a(l.onArrayEnd),U=c(l.onLiteralValue),$=c(l.onSeparator),q=a(l.onComment),ie=c(l.onError),oe=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function he(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:oe||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ne){case 12:case 13:oe?ce(10):q();break;case 16:ce(1);break;case 15:case 14:break;default:return ne}}}function ce(ne,re=[],Z=[]){if(ie(ne),re.length+Z.length>0){let _=n.getToken();for(;_!==17;){if(re.indexOf(_)!==-1){he();break}else if(Z.indexOf(_)!==-1)break;_=he()}}}function K(ne){const re=n.getTokenValue();return ne?U(re):m(re),he(),!0}function Y(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(ce(2),ne=0)}catch{ce(2)}U(ne);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return he(),!0}function x(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(K(!1),n.getToken()===6?($(":"),he(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function W(){o(),he();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),$(","),he(),n.getToken()===2&&ae)break}else ne&&ce(6,[],[]);x()||ce(4,[],[2,5]),ne=!0}return C(),n.getToken()!==2?ce(7,[2],[]):he(),!0}function H(){R(),he();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),$(","),he(),n.getToken()===4&&ae)break}else ne&&ce(6,[],[]);Q()||ce(4,[],[4,5]),ne=!0}return T(),n.getToken()!==4?ce(8,[4],[]):he(),!0}function Q(){switch(n.getToken()){case 3:return H();case 1:return W();case 10:return K(!0);default:return Y()}}return he(),n.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=b;function w(t,l){const i=M(t),n=[];let a,c=0,o;do switch(o=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:c!==o&&n.push(t.substring(c,o)),l!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,l)),c=i.getPosition();break}while(a!==17);return n.join("")}e.stripComments=w;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ee[130],te([0,1,43]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(u,v,p){let y,h,E,S,s;if(v){for(S=v.offset,s=S+v.length,E=S;E>0&&!f(u,E-1);)E--;let o=s;for(;o<u.length&&!f(u,o);)o++;h=u.substring(E,o),y=M(h,p)}else h=u,y=0,E=0,S=0,s=u.length;const g=k(p,u);let d=!1,b=0,w;p.insertSpaces?w=L(" ",p.tabSize||4):w="	";const D=(0,I.createScanner)(h,!1);let t=!1;function l(){return g+L(w,y+b)}function i(){let o=D.scan();for(d=!1;o===15||o===14;)d=d||o===14,o=D.scan();return t=o===16||D.getTokenError()!==0,o}const n=[];function a(o,m,C){!t&&m<s&&C>S&&u.substring(m,C)!==o&&n.push({offset:m,length:C-m,content:o})}let c=i();if(c!==17){const o=D.getTokenOffset()+E,m=L(w,y);a(m,E,o)}for(;c!==17;){let o=D.getTokenOffset()+D.getTokenLength()+E,m=i(),C="";for(;!d&&(m===12||m===13);){const T=D.getTokenOffset()+E;a(" ",o,T),o=D.getTokenOffset()+D.getTokenLength()+E,C=m===12?l():"",m=i()}if(m===2)c!==1&&(b--,C=l());else if(m===4)c!==3&&(b--,C=l());else{switch(c){case 3:case 1:b++,C=l();break;case 5:case 12:C=l();break;case 13:d?C=l():C=" ";break;case 6:C=" ";break;case 10:if(m===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?C=" ":m!==5&&m!==17&&(t=!0);break;case 16:t=!0;break}d&&(m===12||m===13)&&(C=l())}const R=D.getTokenOffset()+E;a(C,o,R),c=m}return n}e.format=A;function r(u,v){const p=JSON.stringify(u,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?p.replace(/\r\n|\r|\n/g,v.eol):p}e.toFormattedString=r;function L(u,v){let p="";for(let y=0;y<v;y++)p+=u;return p}function M(u,v){let p=0,y=0;const h=v.tabSize||4;for(;p<u.length;){const E=u.charAt(p);if(E===" ")y++;else if(E==="	")y+=h;else break;p++}return Math.floor(y/h)}function k(u,v){for(let p=0;p<v.length;p++){const y=v.charAt(p);if(y==="\r")return p+1<v.length&&v.charAt(p+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return u&&u.eol||`
`}e.getEOL=k;function f(u,v){return`\r
`.indexOf(u.charAt(v))!==-1}e.isEOL=f}),define(ee[131],te([0,1,43,130]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(u,v,p){return L(u,v,void 0,p)}e.removeProperty=r;function L(u,v,p,y,h){const E=v.slice(),S=[],s=(0,I.parseTree)(u,S);let g,d;for(;E.length>0&&(d=E.pop(),g=(0,I.findNodeAtLocation)(s,E),g===void 0&&p!==void 0);)typeof d=="string"?p={[d]:p}:p=[p];if(g)if(g.type==="object"&&typeof d=="string"&&Array.isArray(g.children)){const b=(0,I.findNodeAtLocation)(g,[d]);if(b!==void 0)if(p===void 0){if(!b.parent)throw new Error("Malformed AST");const w=g.children.indexOf(b.parent);let D,t=b.parent.offset+b.parent.length;if(w>0){const l=g.children[w-1];D=l.offset+l.length}else D=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return M(u,{offset:D,length:t-D,content:""},y)}else return M(u,{offset:b.offset,length:b.length,content:JSON.stringify(p)},y);else{if(p===void 0)return[];const w=`${JSON.stringify(d)}: ${JSON.stringify(p)}`,D=h?h(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(D>0){const l=g.children[D-1];t={offset:l.offset+l.length,length:0,content:","+w}}else g.children.length===0?t={offset:g.offset+1,length:0,content:w}:t={offset:g.offset+1,length:0,content:w+","};return M(u,t,y)}}else if(g.type==="array"&&typeof d=="number"&&Array.isArray(g.children))if(p!==void 0){const b=`${JSON.stringify(p)}`;let w;if(g.children.length===0||d===0)w={offset:g.offset+1,length:0,content:g.children.length===0?b:b+","};else{const D=d===-1||d>g.children.length?g.children.length:d,t=g.children[D-1];w={offset:t.offset+t.length,length:0,content:","+b}}return M(u,w,y)}else{const b=d,w=g.children[b];let D;if(g.children.length===1)D={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===b){const t=g.children[b-1],l=t.offset+t.length,i=g.offset+g.length;D={offset:l,length:i-2-l,content:""}}else D={offset:w.offset,length:g.children[b+1].offset-w.offset,content:""};return M(u,D,y)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${g.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return M(u,{offset:s?s.offset:0,length:s?s.length:0,content:JSON.stringify(p)},y)}}e.setProperty=L;function M(u,v,p){let y=k(u,v),h=v.offset,E=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;h>0&&!(0,A.isEOL)(y,h-1);)h--;for(;E<y.length&&!(0,A.isEOL)(y,E);)E++}const S=(0,A.format)(y,{offset:h,length:E-h},p);for(let g=S.length-1;g>=0;g--){const d=S[g];y=k(y,d),h=Math.min(h,d.offset),E=Math.max(E,d.offset+d.length),E+=d.content.length-d.length}const s=u.length-(y.length-E)-h;return[{offset:h,length:s,content:y.substring(h,E)}]}e.withFormatting=M;function k(u,v){return u.substring(0,v.offset)+v.content+u.substring(v.offset+v.length)}e.applyEdit=k;function f(u,v){const p=v.slice(0).sort((h,E)=>{const S=h.offset-E.offset;return S===0?h.length-E.length:S});let y=u.length;for(let h=p.length-1;h>=0;h--){const E=p[h];if(E.offset+E.length<=y)u=k(u,E);else throw new Error("Overlapping edit");y=E.offset}return u}e.applyEdits=f}),define(ee[132],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(ee[2],te([0,1,50,71]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const r=!1;let L=null;function M(c){L=c}if(e.setDisposableTracker=M,r){const c="__is_disposable_tracked__";M(new class{trackDisposable(o){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(m)},3e3)}setParent(o,m){if(o&&o!==d.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==d.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function k(c){return L?.trackDisposable(c),c}function f(c){L?.markAsDisposed(c)}function u(c,o){L?.setParent(c,o)}function v(c,o){if(!!L)for(const m of c)L.setParent(m,o)}function p(c){return L?.markAsSingleton(c),c}e.markAsSingleton=p;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function h(c){if(A.Iterable.is(c)){const o=[];for(const m of c)if(m)try{m.dispose()}catch(C){o.push(C)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function E(c){for(const o of c)y(o)&&o.dispose();return[]}e.disposeIfDisposable=E;function S(...c){const o=s(()=>h(c));return v(c,o),o}e.combinedDisposable=S;function s(c){const o=k({dispose:(0,I.once)(()=>{f(o),c()})});return o}e.toDisposable=s;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return u(o,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}g.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=g;class d{constructor(){this._store=new g,k(this),u(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}d.None=Object.freeze({dispose(){}}),e.Disposable=d;class b{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&u(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&u(o,null),o}}e.MutableDisposable=b;class w{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=w;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(o){let m=o;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,f(this))},this}}e.SafeDisposable=D;class t{constructor(){this.references=new Map}acquire(o,...m){let C=this.references.get(o);C||(C={counter:0,object:this.createReferencedObject(o,...m)},this.references.set(o,C));const{object:R}=C,T=(0,I.once)(()=>{--C.counter===0&&(this.destroyReferencedObject(o,C.object),this.references.delete(o))});return C.counter++,{object:R,dispose:T}}}e.ReferenceCollection=t;class l{constructor(o){this.referenceCollection=o}async acquire(o,...m){const C=this.referenceCollection.acquire(o,...m);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(R){throw C.dispose(),R}}}e.AsyncReferenceCollection=l;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function n(c){const o=new g;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=n;class a{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){f(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,m,C=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this._store.get(o)?.dispose(),this._store.set(o,m)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(ee[100],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class A{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let L=this._first;for(;L!==I.Undefined;){const M=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=M}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,M){const k=new I(L);if(this._first===I.Undefined)this._first=k,this._last=k;else if(M){const u=this._last;this._last=k,k.prev=u,u.next=k}else{const u=this._first;this._first=k,k.next=u,u.prev=k}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(k))}}shift(){if(this._first!==I.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==I.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const M=L.prev;M.next=L.next,L.next.prev=M}else L.prev===I.Undefined&&L.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):L.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):L.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.LinkedList=A}),define(ee[35],te([0,1]),function(j,e){"use strict";var I,A,r;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(S,s,g){let d=S.get(s);return d===void 0&&(d=g,S.set(s,d)),d}e.getOrSet=L;function M(S){const s=[];return S.forEach((g,d)=>{s.push(`${d} => ${g}`)}),`Map(${S.size}) {${s.join(", ")}}`}e.mapToString=M;function k(S){const s=[];return S.forEach(g=>{s.push(g)}),`Set(${S.size}) {${s.join(", ")}}`}e.setToString=k;class f{constructor(s,g){this.uri=s,this.value=g}}class u{constructor(s,g){this[I]="ResourceMap",s instanceof u?(this.map=new Map(s.map),this.toKey=g??u.defaultToKey):(this.map=new Map,this.toKey=s??u.defaultToKey)}set(s,g){return this.map.set(this.toKey(s),new f(s,g)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,g){typeof g<"u"&&(s=s.bind(g));for(const[d,b]of this.map)s(b.value,b.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}u.defaultToKey=S=>S.toString(),e.ResourceMap=u;class v{constructor(s,g){this[A]="ResourceSet",!s||typeof s=="function"?this._map=new u(s):(this._map=new u(g),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,g){this._map.forEach((d,b)=>s.call(g,b,b,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=v;var p;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class y{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,g=0){const d=this._map.get(s);if(!!d)return g!==0&&this.touch(d,g),d.value}set(s,g,d=0){let b=this._map.get(s);if(b)b.value=g,d!==0&&this.touch(b,d);else{switch(b={key:s,value:g,next:void 0,previous:void 0},d){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(s,b),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const g=this._map.get(s);if(!!g)return this._map.delete(s),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,g){const d=this._state;let b=this._head;for(;b;){if(g?s.bind(g)(b.value,b.key,this):s(b.value,b.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,g=this._state;let d=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.key,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return b}values(){const s=this,g=this._state;let d=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.value,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return b}entries(){const s=this,g=this._state;let d=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:[d.key,d.value],done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return b}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let g=this._head,d=this.size;for(;g&&d>s;)this._map.delete(g.key),g=g.next,d--;this._head=g,this._size=d,g&&(g.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const g=s.next,d=s.previous;if(!g||!d)throw new Error("Invalid list");g.previous=d,d.next=g}s.next=void 0,s.previous=void 0,this._state++}touch(s,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(s===this._head)return;const d=s.next,b=s.previous;s===this._tail?(b.next=void 0,this._tail=b):(d.previous=b,b.next=d),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(g===2){if(s===this._tail)return;const d=s.next,b=s.previous;s===this._head?(d.previous=void 0,this._head=d):(d.previous=b,b.next=d),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((g,d)=>{s.push([d,g])}),s}fromJSON(s){this.clear();for(const[g,d]of s)this.set(g,d)}}e.LinkedMap=y;class h extends y{constructor(s,g=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,g=2){return super.get(s,g)}peek(s){return super.get(s,0)}set(s,g){return super.set(s,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class E{constructor(){this.map=new Map}add(s){return this.map.set(s,(this.map.get(s)||0)+1),this}delete(s){let g=this.map.get(s)||0;return g===0?!1:(g--,g===0?this.map.delete(s):this.map.set(s,g),!0)}has(s){return this.map.has(s)}}e.CounterSet=E}),define(ee[82],te([0,1,35]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new I.LRUCache(1e4);function r(u){return f(u,"NFC",A)}e.normalizeNFC=r;const L=new I.LRUCache(1e4);function M(u){return f(u,"NFD",L)}e.normalizeNFD=M;const k=/[^\u0000-\u0080]/;function f(u,v,p){if(!u)return u;const y=p.get(u);if(y)return y;let h;return k.test(u)?h=u.normalize(v):h=u,p.set(u,h),h}e.removeAccents=function(){const u=/[\u0300-\u036f]/g;return function(v){return M(v).replace(u,"")}}()}),define(ee[133],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(k,f,u){return Math.min(Math.max(k,f),u)}e.clamp=I;function A(k,f){return(f+k%f)%f}e.rot=A;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class L{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class M{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const u=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=u,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function j(r){const L=[];typeof r=="number"&&L.push("code/timeOrigin",r);function M(f){L.push(f,Date.now())}function k(){const f=[];for(let u=0;u<L.length;u+=2)f.push({name:L[u],startTime:L[u+1]});return f}return{mark:M,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))L.push({name:M.name,startTime:Math.round(r+M.startTime)});return L}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function I(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=I(A))}(),function(j,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var A in I)(typeof exports=="object"?exports:j)[A]=I[A]}}(typeof self<"u"?self:this,function(){return function(j){var e={};function I(A){if(e[A])return e[A].exports;var r=e[A]={i:A,l:!1,exports:{}};return j[A].call(r.exports,r,r.exports,I),r.l=!0,r.exports}return I.m=j,I.c=e,I.d=function(A,r,L){I.o(A,r)||Object.defineProperty(A,r,{enumerable:!0,get:L})},I.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},I.t=function(A,r){if(1&r&&(A=I(A)),8&r||4&r&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&r&&typeof A!="string")for(var M in A)I.d(L,M,function(k){return A[k]}.bind(null,M));return L},I.n=function(A){var r=A&&A.__esModule?function(){return A.default}:function(){return A};return I.d(r,"a",r),r},I.o=function(A,r){return Object.prototype.hasOwnProperty.call(A,r)},I.p="",I(I.s=0)}([function(j,e,I){(function(A){var r;e=j.exports=Z,r=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],f=e.src=[],u=0,v=u++;f[v]="0|[1-9]\\d*";var p=u++;f[p]="[0-9]+";var y=u++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;f[h]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var E=u++;f[E]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var S=u++;f[S]="(?:"+f[v]+"|"+f[y]+")";var s=u++;f[s]="(?:"+f[p]+"|"+f[y]+")";var g=u++;f[g]="(?:-("+f[S]+"(?:\\."+f[S]+")*))";var d=u++;f[d]="(?:-?("+f[s]+"(?:\\."+f[s]+")*))";var b=u++;f[b]="[0-9A-Za-z-]+";var w=u++;f[w]="(?:\\+("+f[b]+"(?:\\."+f[b]+")*))";var D=u++,t="v?"+f[h]+f[g]+"?"+f[w]+"?";f[D]="^"+t+"$";var l="[v=\\s]*"+f[E]+f[d]+"?"+f[w]+"?",i=u++;f[i]="^"+l+"$";var n=u++;f[n]="((?:<|>)?=?)";var a=u++;f[a]=f[p]+"|x|X|\\*";var c=u++;f[c]=f[v]+"|x|X|\\*";var o=u++;f[o]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[g]+")?"+f[w]+"?)?)?";var m=u++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[d]+")?"+f[w]+"?)?)?";var C=u++;f[C]="^"+f[n]+"\\s*"+f[o]+"$";var R=u++;f[R]="^"+f[n]+"\\s*"+f[m]+"$";var T=u++;f[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=u++;f[U]="(?:~>?)";var $=u++;f[$]="(\\s*)"+f[U]+"\\s+",k[$]=new RegExp(f[$],"g");var q=u++;f[q]="^"+f[U]+f[o]+"$";var ie=u++;f[ie]="^"+f[U]+f[m]+"$";var oe=u++;f[oe]="(?:\\^)";var ae=u++;f[ae]="(\\s*)"+f[oe]+"\\s+",k[ae]=new RegExp(f[ae],"g");var he=u++;f[he]="^"+f[oe]+f[o]+"$";var ce=u++;f[ce]="^"+f[oe]+f[m]+"$";var K=u++;f[K]="^"+f[n]+"\\s*("+l+")$|^$";var Y=u++;f[Y]="^"+f[n]+"\\s*("+t+")$|^$";var x=u++;f[x]="(\\s*)"+f[n]+"\\s*("+l+"|"+f[o]+")",k[x]=new RegExp(f[x],"g");var W=u++;f[W]="^\\s*("+f[o]+")\\s+-\\s+("+f[o]+")\\s*$";var H=u++;f[H]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var Q=u++;f[Q]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)r(ne,f[ne]),k[ne]||(k[ne]=new RegExp(f[ne]));function re(J,ue){if(J instanceof Z)return J;if(typeof J!="string"||J.length>L||!(ue?k[i]:k[D]).test(J))return null;try{return new Z(J,ue)}catch{return null}}function Z(J,ue){if(J instanceof Z){if(J.loose===ue)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Z))return new Z(J,ue);r("SemVer",J,ue),this.loose=ue;var fe=J.trim().match(ue?k[i]:k[D]);if(!fe)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Le=+Ee;if(Le>=0&&Le<M)return Le}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=re,e.valid=function(J,ue){var fe=re(J,ue);return fe?fe.version:null},e.clean=function(J,ue){var fe=re(J.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(J){return r("SemVer.compare",this.version,this.loose,J),J instanceof Z||(J=new Z(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Z.prototype.compareMain=function(J){return J instanceof Z||(J=new Z(J,this.loose)),P(this.major,J.major)||P(this.minor,J.minor)||P(this.patch,J.patch)},Z.prototype.comparePre=function(J){if(J instanceof Z||(J=new Z(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],Ee=J.prerelease[ue];if(r("prerelease compare",ue,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return P(fe,Ee)}while(++ue)},Z.prototype.inc=function(J,ue){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ue,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new Z(J,fe).inc(ue,Ee).version}catch{return null}},e.diff=function(J,ue){if(N(J,ue))return null;var fe=re(J),Ee=re(ue);if(fe.prerelease.length||Ee.prerelease.length){for(var Le in fe)if((Le==="major"||Le==="minor"||Le==="patch")&&fe[Le]!==Ee[Le])return"pre"+Le;return"prerelease"}for(var Le in fe)if((Le==="major"||Le==="minor"||Le==="patch")&&fe[Le]!==Ee[Le])return Le},e.compareIdentifiers=P;var _=/^[0-9]+$/;function P(J,ue){var fe=_.test(J),Ee=_.test(ue);return fe&&Ee&&(J=+J,ue=+ue),fe&&!Ee?-1:Ee&&!fe?1:J<ue?-1:J>ue?1:0}function O(J,ue,fe){return new Z(J,fe).compare(new Z(ue,fe))}function F(J,ue,fe){return O(J,ue,fe)>0}function B(J,ue,fe){return O(J,ue,fe)<0}function N(J,ue,fe){return O(J,ue,fe)===0}function z(J,ue,fe){return O(J,ue,fe)!==0}function V(J,ue,fe){return O(J,ue,fe)>=0}function se(J,ue,fe){return O(J,ue,fe)<=0}function de(J,ue,fe,Ee){var Le;switch(ue){case"===":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Le=J===fe;break;case"!==":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Le=J!==fe;break;case"":case"=":case"==":Le=N(J,fe,Ee);break;case"!=":Le=z(J,fe,Ee);break;case">":Le=F(J,fe,Ee);break;case">=":Le=V(J,fe,Ee);break;case"<":Le=B(J,fe,Ee);break;case"<=":Le=se(J,fe,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Le}function ye(J,ue){if(J instanceof ye){if(J.loose===ue)return J;J=J.value}if(!(this instanceof ye))return new ye(J,ue);r("comparator",J,ue),this.loose=ue,this.parse(J),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(J,ue){return P(ue,J)},e.major=function(J,ue){return new Z(J,ue).major},e.minor=function(J,ue){return new Z(J,ue).minor},e.patch=function(J,ue){return new Z(J,ue).patch},e.compare=O,e.compareLoose=function(J,ue){return O(J,ue,!0)},e.rcompare=function(J,ue,fe){return O(ue,J,fe)},e.sort=function(J,ue){return J.sort(function(fe,Ee){return e.compare(fe,Ee,ue)})},e.rsort=function(J,ue){return J.sort(function(fe,Ee){return e.rcompare(fe,Ee,ue)})},e.gt=F,e.lt=B,e.eq=N,e.neq=z,e.gte=V,e.lte=se,e.cmp=de,e.Comparator=ye;var ke={};function Ae(J,ue){if(J instanceof Ae)return J.loose===ue?J:new Ae(J.raw,ue);if(J instanceof ye)return new Ae(J.value,ue);if(!(this instanceof Ae))return new Ae(J,ue);if(this.loose=ue,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function _e(J){return!J||J.toLowerCase()==="x"||J==="*"}function Oe(J,ue,fe,Ee,Le,Te,We,qe,Ue,Ne,He,G,le){return((ue=_e(fe)?"":_e(Ee)?">="+fe+".0.0":_e(Le)?">="+fe+"."+Ee+".0":">="+ue)+" "+(qe=_e(Ue)?"":_e(Ne)?"<"+(+Ue+1)+".0.0":_e(He)?"<"+Ue+"."+(+Ne+1)+".0":G?"<="+Ue+"."+Ne+"."+He+"-"+G:"<="+qe)).trim()}function me(J,ue){for(var fe=0;fe<J.length;fe++)if(!J[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<J.length;fe++)if(r(J[fe].semver),J[fe].semver!==ke&&J[fe].semver.prerelease.length>0){var Ee=J[fe].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function pe(J,ue,fe){try{ue=new Ae(ue,fe)}catch{return!1}return ue.test(J)}function De(J,ue,fe,Ee){var Le,Te,We,qe,Ue;switch(J=new Z(J,Ee),ue=new Ae(ue,Ee),fe){case">":Le=F,Te=se,We=B,qe=">",Ue=">=";break;case"<":Le=B,Te=V,We=F,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(J,ue,Ee))return!1;for(var Ne=0;Ne<ue.set.length;++Ne){var He=ue.set[Ne],G=null,le=null;if(He.forEach(function(ge){ge.semver===ke&&(ge=new ye(">=0.0.0")),G=G||ge,le=le||ge,Le(ge.semver,G.semver,Ee)?G=ge:We(ge.semver,le.semver,Ee)&&(le=ge)}),G.operator===qe||G.operator===Ue||(!le.operator||le.operator===qe)&&Te(J,le.semver)||le.operator===Ue&&We(J,le.semver))return!1}return!0}ye.prototype.parse=function(J){var ue=this.loose?k[K]:k[Y],fe=J.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+J);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new Z(fe[2],this.loose):this.semver=ke},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(J){return r("Comparator.test",J,this.loose),this.semver===ke||(typeof J=="string"&&(J=new Z(J,this.loose)),de(J,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(J,ue){if(!(J instanceof ye))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ae(J.value,ue),pe(this.value,fe,ue);if(J.operator==="")return fe=new Ae(this.value,ue),pe(J.semver,fe,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Te=this.semver.version===J.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),qe=de(this.semver,"<",J.semver,ue)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ue=de(this.semver,">",J.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ee||Le||Te&&We||qe||Ue},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(J){var ue=this.loose;J=J.trim(),r("range",J,ue);var fe=ue?k[H]:k[W];J=J.replace(fe,Oe),r("hyphen replace",J),J=J.replace(k[x],"$1$2$3"),r("comparator trim",J,k[x]),J=(J=(J=J.replace(k[$],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var Ee=ue?k[K]:k[Y],Le=J.split(" ").map(function(Te){return function(We,qe){return r("comp",We),We=function(Ue,Ne){return Ue.trim().split(/\s+/).map(function(He){return function(G,le){r("caret",G,le);var ge=le?k[ce]:k[he];return G.replace(ge,function(Se,ve,Re,Fe,xe){var Ve;return r("caret",G,Se,ve,Re,Fe,xe),_e(ve)?Ve="":_e(Re)?Ve=">="+ve+".0.0 <"+(+ve+1)+".0.0":_e(Fe)?Ve=ve==="0"?">="+ve+"."+Re+".0 <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+".0 <"+(+ve+1)+".0.0":xe?(r("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ve=ve==="0"?Re==="0"?">="+ve+"."+Re+"."+Fe+xe+" <"+ve+"."+Re+"."+(+Fe+1):">="+ve+"."+Re+"."+Fe+xe+" <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+"."+Fe+xe+" <"+(+ve+1)+".0.0"):(r("no pr"),Ve=ve==="0"?Re==="0"?">="+ve+"."+Re+"."+Fe+" <"+ve+"."+Re+"."+(+Fe+1):">="+ve+"."+Re+"."+Fe+" <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+"."+Fe+" <"+(+ve+1)+".0.0"),r("caret return",Ve),Ve})}(He,Ne)}).join(" ")}(We,qe),r("caret",We),We=function(Ue,Ne){return Ue.trim().split(/\s+/).map(function(He){return function(G,le){var ge=le?k[ie]:k[q];return G.replace(ge,function(Se,ve,Re,Fe,xe){var Ve;return r("tilde",G,Se,ve,Re,Fe,xe),_e(ve)?Ve="":_e(Re)?Ve=">="+ve+".0.0 <"+(+ve+1)+".0.0":_e(Fe)?Ve=">="+ve+"."+Re+".0 <"+ve+"."+(+Re+1)+".0":xe?(r("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ve=">="+ve+"."+Re+"."+Fe+xe+" <"+ve+"."+(+Re+1)+".0"):Ve=">="+ve+"."+Re+"."+Fe+" <"+ve+"."+(+Re+1)+".0",r("tilde return",Ve),Ve})}(He,Ne)}).join(" ")}(We,qe),r("tildes",We),We=function(Ue,Ne){return r("replaceXRanges",Ue,Ne),Ue.split(/\s+/).map(function(He){return function(G,le){G=G.trim();var ge=le?k[R]:k[C];return G.replace(ge,function(Se,ve,Re,Fe,xe,Ve){r("xRange",G,Se,ve,Re,Fe,xe,Ve);var Ge=_e(Re),Qe=Ge||_e(Fe),Je=Qe||_e(xe);return ve==="="&&Je&&(ve=""),Ge?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Je?(Qe&&(Fe=0),Je&&(xe=0),ve===">"?(ve=">=",Qe?(Re=+Re+1,Fe=0,xe=0):Je&&(Fe=+Fe+1,xe=0)):ve==="<="&&(ve="<",Qe?Re=+Re+1:Fe=+Fe+1),Se=ve+Re+"."+Fe+"."+xe):Qe?Se=">="+Re+".0.0 <"+(+Re+1)+".0.0":Je&&(Se=">="+Re+"."+Fe+".0 <"+Re+"."+(+Fe+1)+".0"),r("xRange return",Se),Se})}(He,Ne)}).join(" ")}(We,qe),r("xrange",We),We=function(Ue,Ne){return r("replaceStars",Ue,Ne),Ue.trim().replace(k[Q],"")}(We,qe),r("stars",We),We}(Te,ue)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(Te){return!!Te.match(Ee)})),Le=Le.map(function(Te){return new ye(Te,ue)})},Ae.prototype.intersects=function(J,ue){if(!(J instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return J.set.some(function(Le){return Le.every(function(Te){return Ee.intersects(Te,ue)})})})})},e.toComparators=function(J,ue){return new Ae(J,ue).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Z(J,this.loose));for(var ue=0;ue<this.set.length;ue++)if(me(this.set[ue],J))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(J,ue,fe){var Ee=null,Le=null;try{var Te=new Ae(ue,fe)}catch{return null}return J.forEach(function(We){Te.test(We)&&(Ee&&Le.compare(We)!==-1||(Le=new Z(Ee=We,fe)))}),Ee},e.minSatisfying=function(J,ue,fe){var Ee=null,Le=null;try{var Te=new Ae(ue,fe)}catch{return null}return J.forEach(function(We){Te.test(We)&&(Ee&&Le.compare(We)!==1||(Le=new Z(Ee=We,fe)))}),Ee},e.validRange=function(J,ue){try{return new Ae(J,ue).range||"*"}catch{return null}},e.ltr=function(J,ue,fe){return De(J,ue,"<",fe)},e.gtr=function(J,ue,fe){return De(J,ue,">",fe)},e.outside=De,e.prerelease=function(J,ue){var fe=re(J,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(J,ue,fe){return J=new Ae(J,fe),ue=new Ae(ue,fe),J.intersects(ue)},e.coerce=function(J){if(J instanceof Z)return J;if(typeof J!="string")return null;var ue=J.match(k[T]);return ue==null?null:re((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,I(1))},function(j,e){var I,A,r=j.exports={};function L(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function k(s){if(I===setTimeout)return setTimeout(s,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(s,0);try{return I(s,0)}catch{try{return I.call(null,s,0)}catch{return I.call(this,s,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{A=typeof clearTimeout=="function"?clearTimeout:M}catch{A=M}})();var f,u=[],v=!1,p=-1;function y(){v&&f&&(v=!1,f.length?u=f.concat(u):p=-1,u.length&&h())}function h(){if(!v){var s=k(y);v=!0;for(var g=u.length;g;){for(f=u,u=[];++p<g;)f&&f[p].run();p=-1,g=u.length}f=null,v=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===M||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}(s)}}function E(s,g){this.fun=s,this.array=g}function S(){}r.nextTick=function(s){var g=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)g[d-1]=arguments[d];u.push(new E(s,g)),u.length!==1||v||k(h)},E.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=S,r.addListener=S,r.once=S,r.off=S,r.removeListener=S,r.removeAllListeners=S,r.emit=S,r.prependListener=S,r.prependOnceListener=S,r.listeners=function(s){return[]},r.binding=function(s){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(s){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ee[134],te([0,1]),function(j,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(k,f,u){this.level=k,this.key=f,this.value=u,this.forward=[]}}const r=void 0;class L{constructor(k,f=2**16){this.comparator=k,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new A(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new A(this._maxLevel,r,r)}has(k){return Boolean(L._search(this,k,this.comparator))}get(k){return L._search(this,k,this.comparator)?.value}set(k,f){return L._insert(this,k,f,this.comparator)&&(this._size+=1),this}delete(k){const f=L._delete(this,k,this.comparator);return f&&(this._size-=1),f}forEach(k,f){let u=this._header.forward[0];for(;u;)k.call(f,u.value,u.key,this),u=u.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",f=this._header.forward[0];for(;f;)k+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return k}static _search(k,f,u){let v=k._header;for(let p=k._level-1;p>=0;p--)for(;v.forward[p]&&u(v.forward[p].key,f)<0;)v=v.forward[p];if(v=v.forward[0],v&&u(v.key,f)===0)return v}static _insert(k,f,u,v){const p=[];let y=k._header;for(let h=k._level-1;h>=0;h--){for(;y.forward[h]&&v(y.forward[h].key,f)<0;)y=y.forward[h];p[h]=y}if(y=y.forward[0],y&&v(y.key,f)===0)return y.value=u,!1;{const h=L._randomLevel(k);if(h>k._level){for(let E=k._level;E<h;E++)p[E]=k._header;k._level=h}y=new A(h,f,u);for(let E=0;E<h;E++)y.forward[E]=p[E].forward[E],p[E].forward[E]=y;return!0}}static _randomLevel(k,f=.5){let u=1;for(;Math.random()<f&&u<k._maxLevel;)u+=1;return u}static _delete(k,f,u){const v=[];let p=k._header;for(let y=k._level-1;y>=0;y--){for(;p.forward[y]&&u(p.forward[y].key,f)<0;)p=p.forward[y];v[y]=p}if(p=p.forward[0],!p||u(p.key,f)!==0)return!1;for(let y=0;y<k._level&&v[y].forward[y]===p;y++)v[y].forward[y]=p.forward[y];for(;k._level>0&&k._header.forward[k._level-1]===r;)k._level-=1;return!0}}e.SkipList=L}),define(ee[60],te([0,1,13,2]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(w){const D=w;return D?typeof D.read=="function":!1}e.isReadable=r;function L(w){const D=w;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function M(w){const D=w;return D?L(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=M;function k(w,D){return new f(w,D)}e.newWriteableStream=k;class f{constructor(D,t){this.reducer=D,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D<"u"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(t=>t(D))}emitError(D){this.listeners.error.length===0?(0,I.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(t=>t(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,t){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(D,t){if(this.state.destroyed)return;let l;switch(D){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(t);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(w,D){const t=[];let l;for(;(l=w.read())!==null;)t.push(l);return D(t)}e.consumeReadable=u;function v(w,D,t){const l=[];let i;for(;(i=w.read())!==null&&l.length<t;)l.push(i);return i===null&&l.length>0?D(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return w.read()}}}e.peekReadable=v;function p(w,D){return new Promise((t,l)=>{const i=[];y(w,{onData:n=>{D&&i.push(n)},onError:n=>{D?l(n):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=p;function y(w,D){let t=!1;return w.on("error",l=>{t||D.onError(l)}),w.on("end",()=>{t||D.onEnd()}),w.on("data",l=>{t||D.onData(l)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=y;function h(w,D){return new Promise((t,l)=>{const i=new A.DisposableStore,n=[],a=m=>{if(n.push(m),n.length>D)return i.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},c=m=>l(m),o=()=>t({stream:w,buffer:n,ended:!0});i.add((0,A.toDisposable)(()=>w.removeListener("error",c))),w.on("error",c),i.add((0,A.toDisposable)(()=>w.removeListener("end",o))),w.on("end",o),i.add((0,A.toDisposable)(()=>w.removeListener("data",a))),w.on("data",a)})}e.peekStream=h;function E(w,D){const t=k(D);return t.end(w),t}e.toStream=E;function S(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=S;function s(w){let D=!1;return{read:()=>D?null:(D=!0,w)}}e.toReadable=s;function g(w,D,t){const l=k(t);return y(w,{onData:i=>l.write(D.data(i)),onError:i=>l.error(D.error?D.error(i):i),onEnd:()=>l.end()}),l}e.transform=g;function d(w,D,t){let l=!1;return{read:()=>{const i=D.read();return l?i:(l=!0,i!==null?t([w,i]):w)}}}e.prefixedReadable=d;function b(w,D,t){let l=!1;const i=k(t);return y(D,{onData:n=>l?i.write(n):(l=!0,i.write(t([w,n]))),onError:n=>i.error(n),onEnd:()=>{l||(l=!0,i.write(w)),i.end()}}),i}e.prefixedStream=b}),define(ee[17],te([0,1,60]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let r,L;class M{static alloc(m){return A?new M(Buffer.allocUnsafe(m)):new M(new Uint8Array(m))}static wrap(m){return A&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new M(m)}static fromString(m,C){return!(C?.dontUseNodeBuffer||!1)&&A?new M(Buffer.from(m)):(r||(r=new TextEncoder),new M(r.encode(m)))}static fromByteArray(m){const C=M.alloc(m.length);for(let R=0,T=m.length;R<T;R++)C.buffer[R]=m[R];return C}static concat(m,C){if(typeof C>"u"){C=0;for(let U=0,$=m.length;U<$;U++)C+=m[U].byteLength}const R=M.alloc(C);let T=0;for(let U=0,$=m.length;U<$;U++){const q=m[U];R.set(q,T),T+=q.byteLength}return R}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=M.alloc(this.byteLength);return m.set(this),m}toString(){return A?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(m,C){return new M(this.buffer.subarray(m,C))}set(m,C){if(m instanceof M)this.buffer.set(m.buffer,C);else if(m instanceof Uint8Array)this.buffer.set(m,C);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),C);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,C){v(this.buffer,m,C)}readUInt32LE(m){return p(this.buffer,m)}writeUInt32LE(m,C){y(this.buffer,m,C)}readUInt8(m){return h(this.buffer,m)}writeUInt8(m,C){E(this.buffer,m,C)}}e.VSBuffer=M;function k(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0}e.readUInt16LE=k;function f(o,m,C){o[C+0]=m&255,m=m>>>8,o[C+1]=m&255}e.writeUInt16LE=f;function u(o,m){return o[m]*2**24+o[m+1]*2**16+o[m+2]*2**8+o[m+3]}e.readUInt32BE=u;function v(o,m,C){o[C+3]=m,m=m>>>8,o[C+2]=m,m=m>>>8,o[C+1]=m,m=m>>>8,o[C]=m}e.writeUInt32BE=v;function p(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0|o[m+2]<<16>>>0|o[m+3]<<24>>>0}e.readUInt32LE=p;function y(o,m,C){o[C+0]=m&255,m=m>>>8,o[C+1]=m&255,m=m>>>8,o[C+2]=m&255,m=m>>>8,o[C+3]=m&255}e.writeUInt32LE=y;function h(o,m){return o[m]}e.readUInt8=h;function E(o,m,C){o[C]=m}e.writeUInt8=E;function S(o){return I.consumeReadable(o,m=>M.concat(m))}e.readableToBuffer=S;function s(o){return I.toReadable(o)}e.bufferToReadable=s;function g(o){return I.consumeStream(o,m=>M.concat(m))}e.streamToBuffer=g;async function d(o){return o.ended?M.concat(o.buffer):M.concat([...o.buffer,await g(o.stream)])}e.bufferedStreamToBuffer=d;function b(o){return I.toStream(o,m=>M.concat(m))}e.bufferToStream=b;function w(o){return I.transform(o,{data:m=>typeof m=="string"?M.fromString(m):M.wrap(m)},m=>M.concat(m))}e.streamToBufferReadableStream=w;function D(o){return I.newWriteableStream(m=>M.concat(m),o)}e.newWriteableBufferStream=D;function t(o,m){return I.prefixedReadable(o,m,C=>M.concat(C))}e.prefixedBufferReadable=t;function l(o,m){return I.prefixedStream(o,m,C=>M.concat(C))}e.prefixedBufferStream=l;function i(o){let m=0,C=0,R=0;const T=new Uint8Array(Math.floor(o.length/4*3)),U=q=>{switch(C){case 3:T[R++]=m|q,C=0;break;case 2:T[R++]=m|q>>>2,m=q<<6,C=3;break;case 1:T[R++]=m|q>>>4,m=q<<4,C=2;break;default:m=q<<2,C=1}};for(let q=0;q<o.length;q++){const ie=o.charCodeAt(q);if(ie>=65&&ie<=90)U(ie-65);else if(ie>=97&&ie<=122)U(ie-97+26);else if(ie>=48&&ie<=57)U(ie-48+52);else if(ie===43||ie===45)U(62);else if(ie===47||ie===95)U(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[q]}`)}}const $=R;for(;C>0;)U(0);return M.wrap(T).slice(0,$)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},m=!0,C=!1){const R=C?a:n;let T="";const U=o.byteLength%3;let $=0;for(;$<o.byteLength-U;$+=3){const q=o[$+0],ie=o[$+1],oe=o[$+2];T+=R[q>>>2],T+=R[(q<<4|ie>>>4)&63],T+=R[(ie<<2|oe>>>6)&63],T+=R[oe&63]}if(U===1){const q=o[$+0];T+=R[q>>>2],T+=R[q<<4&63],m&&(T+="==")}else if(U===2){const q=o[$+0],ie=o[$+1];T+=R[q>>>2],T+=R[(q<<4|ie>>>4)&63],T+=R[ie<<2&63],m&&(T+="=")}return T}e.encodeBase64=c}),define(ee[135],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[11],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(l){return typeof l=="string"}e.isString=I;function A(l){return Array.isArray(l)&&l.every(i=>I(i))}e.isStringArray=A;function r(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=r;function L(l){const i=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof i}e.isTypedArray=L;function M(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=M;function k(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=k;function f(l){return l===!0||l===!1}e.isBoolean=f;function u(l){return typeof l>"u"}e.isUndefined=u;function v(l){return!p(l)}e.isDefined=v;function p(l){return u(l)||l===null}e.isUndefinedOrNull=p;function y(l,i){if(!l)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function h(l){if(p(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=h;function E(...l){const i=[];for(let n=0;n<l.length;n++){const a=l[n];if(p(a))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(a)}return i}e.assertAllDefined=E;const S=Object.prototype.hasOwnProperty;function s(l){if(!r(l))return!1;for(const i in l)if(S.call(l,i))return!1;return!0}e.isEmptyObject=s;function g(l){return typeof l=="function"}e.isFunction=g;function d(...l){return l.length>0&&l.every(g)}e.areFunctions=d;function b(l,i){const n=Math.min(l.length,i.length);for(let a=0;a<n;a++)w(l[a],i[a])}e.validateConstraints=b;function w(l,i){if(I(i)){if(typeof l!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(l instanceof i)return}catch{}if(!p(l)&&l.constructor===i||i.length===1&&i.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function D(l){return l===null?void 0:l}e.withNullAsUndefined=D;function t(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=t}),define(ee[136],te([0,1,11]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function r(k,f){if((0,I.isString)(f)){const u=A[f];if(u===void 0)throw new Error(`${k} references an unknown codicon: ${f}`);f=u}return A[k]=f,{id:k}}function L(){return A}e.getCodiconFontCharacters=L;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const d=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,w])=>{d[b]=w&&typeof w=="object"?A(w):w}),d}e.deepClone=A;function r(g){if(!g||typeof g!="object")return g;const d=[g];for(;d.length>0;){const b=d.shift();Object.freeze(b);for(const w in b)if(L.call(b,w)){const D=b[w];typeof D=="object"&&!Object.isFrozen(D)&&!(0,I.isTypedArray)(D)&&d.push(D)}}return g}e.deepFreeze=r;const L=Object.prototype.hasOwnProperty;function M(g,d){return k(g,d,new Set)}e.cloneAndChange=M;function k(g,d,b){if((0,I.isUndefinedOrNull)(g))return g;const w=d(g);if(typeof w<"u")return w;if(Array.isArray(g)){const D=[];for(const t of g)D.push(k(t,d,b));return D}if((0,I.isObject)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const D={};for(const t in g)L.call(g,t)&&(D[t]=k(g[t],d,b));return b.delete(g),D}return g}function f(g,d,b=!0){return(0,I.isObject)(g)?((0,I.isObject)(d)&&Object.keys(d).forEach(w=>{w in g?b&&((0,I.isObject)(g[w])&&(0,I.isObject)(d[w])?f(g[w],d[w],b):g[w]=d[w]):g[w]=d[w]}),g):d}e.mixin=f;function u(g,d){if(g===d)return!0;if(g==null||d===null||d===void 0||typeof g!=typeof d||typeof g!="object"||Array.isArray(g)!==Array.isArray(d))return!1;let b,w;if(Array.isArray(g)){if(g.length!==d.length)return!1;for(b=0;b<g.length;b++)if(!u(g[b],d[b]))return!1}else{const D=[];for(w in g)D.push(w);D.sort();const t=[];for(w in d)t.push(w);if(t.sort(),!u(D,t))return!1;for(b=0;b<D.length;b++)if(!u(g[D[b]],d[D[b]]))return!1}return!0}e.equals=u;function v(g){const d=new Set;return JSON.stringify(g,(b,w)=>{if((0,I.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=v;function p(g,d){const b=Object.create(null);return!g||!d||Object.keys(d).forEach(D=>{const t=g[D],l=d[D];u(t,l)||(b[D]=l)}),b}e.distinct=p;function y(g,d){const b=d.toLowerCase(),w=Object.keys(g).find(D=>D.toLowerCase()===b);return w?g[w]:g[d]}e.getCaseInsensitive=y;function h(g,d){const b=Object.create(null);for(const[w,D]of Object.entries(g))d(w,D)&&(b[w]=D);return b}e.filter=h;function E(g){let d=[],b=Object.getPrototypeOf(g);for(;Object.prototype!==b;)d=d.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return d}e.getAllPropertyNames=E;function S(g){const d=[];for(const b of E(g))typeof g[b]=="function"&&d.push(b);return d}e.getAllMethodNames=S;function s(g,d){const b=D=>function(){const t=Array.prototype.slice.call(arguments,0);return d(D,t)},w={};for(const D of g)w[D]=b(D);return w}e.createProxyObject=s}),define(ee[137],te([0,1,136]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(M){function k(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=k})(A=e.ThemeColor||(e.ThemeColor={}));function r(M){return{id:M}}e.themeColorFromId=r;var L;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(d){const b=k.exec(d.id);if(!b)return f(I.Codicon.error);const[,w,D]=b,t=["codicon","codicon-"+w];return D&&t.push("codicon-modifier-"+D.substring(1)),t}M.asClassNameArray=f;function u(d){return f(d).join(" ")}M.asClassName=u;function v(d){return"."+f(d).join(".")}M.asCSSSelector=v;function p(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||A.isThemeColor(d.color))}M.isThemeIcon=p;const y=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function h(d){const b=y.exec(d);if(!b)return;const[,w]=b;return{id:w}}M.fromString=h;function E(d){return{id:d}}M.fromId=E;function S(d,b){let w=d.id;const D=w.lastIndexOf("~");return D!==-1&&(w=w.substring(0,D)),b&&(w=`${w}~${b}`),{id:w}}M.modify=S;function s(d){const b=d.id.lastIndexOf("~");if(b!==-1)return d.id.substring(b+1)}M.getModifier=s;function g(d,b){return d.id===b.id&&d.color?.id===b.color?.id}M.isEqual=g})(L=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(r){return I.test(r)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(k){for(let f=0;f<k.length;f++)k[f]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),M=[];for(let k=0;k<256;k++)M.push(k.toString(16).padStart(2,"0"));return function(){r(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,u="";return u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u+="-",u+=M[L[f++]],u+=M[L[f++]],u+="-",u+=M[L[f++]],u+=M[L[f++]],u+="-",u+=M[L[f++]],u+=M[L[f++]],u+="-",u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u+=M[L[f++]],u}}()}),define(ee[138],te([0,1,83,41,50]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(M,k){if(await new Promise((v,p)=>{const y=A.createReadStream(M),h=I.createHash("sha1");y.pipe(h);const E=(0,r.once)((S,s)=>{y.removeAllListeners(),h.removeAllListeners(),S?p(S):v(s)});y.once("error",E),y.once("end",E),h.once("error",E),h.once("data",S=>E(void 0,S.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=L}),define(ee[139],te([0,1,27]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const k=M.replace(/\-/g,":").toLowerCase();return!A.has(k)}function L(){const M=(0,I.networkInterfaces)();for(const k in M){const f=M[k];if(f){for(const{mac:u}of f)if(r(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ee[101],te([0,1,84]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(k,f,u,v=1){let p=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!p)return p=!0,y(0)},u);r(k,f,v,E=>{if(!p)return p=!0,clearTimeout(h),y(E)})})}e.findFreePort=A;function r(k,f,u,v){if(f===0)return v(0);const p=new I.Socket;p.once("connect",()=>(M(p),r(k+u,f-1,u,v))),p.once("data",()=>{}),p.once("error",y=>(M(p),y.code!=="ECONNREFUSED"?r(k+u,f-1,u,v):v(k))),p.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(k,f,u,v="127.0.0.1"){let p=!1,y,h=1;const E=I.createServer({pauseOnConnect:!0});function S(s,g){p||(p=!0,E.removeAllListeners(),E.close(),y&&clearTimeout(y),g(s))}return new Promise(s=>{y=setTimeout(()=>{S(0,s)},u),E.on("listening",()=>{S(k,s)}),E.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<f?(k++,h++,E.listen(k,v)):S(0,s)}),E.on("close",()=>{S(0,s)}),E.listen(k,v)})}e.findFreePortFaster=L;function M(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(f){console.error(f)}}}),define(ee[140],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[141],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(r,L){this.sender=r,this.onMessage=L}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[42],te([0,1,15,13]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class r{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,k){const f=(u,...v)=>{this.validateEvent(M,u)&&k(u,...v)};return this.mapListenerToWrapper.set(k,f),I.ipcMain.on(M,f),this}once(M,k){return I.ipcMain.once(M,(f,...u)=>{this.validateEvent(M,f)&&k(f,...u)}),this}handle(M,k){return I.ipcMain.handle(M,(f,...u)=>this.validateEvent(M,f)?k(f,...u):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return I.ipcMain.removeHandler(M),this}removeListener(M,k){const f=this.mapListenerToWrapper.get(k);return f&&(I.ipcMain.removeListener(M,f),this.mapListenerToWrapper.delete(k)),this}validateEvent(M,k){if(!M||!M.startsWith("vscode:"))return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const f=k.senderFrame,u=f.url;if(!u)return!0;let v="unknown";try{v=new URL(u).host}catch{return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${u}'.`),!1}return v!=="vscode-app"?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${v}'.`),!1):f.parent!==null?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new r}),define(ee[142],te([0,1,15,42,11,140]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){A.validatedIpcMain.on(L.CONTEXT_MENU_CHANNEL,(f,u,v,p,y)=>{const h=k(f,p,v);h.popup({window:(0,r.withNullAsUndefined)(I.BrowserWindow.fromWebContents(f.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{h&&f.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,u)}})})}e.registerContextMenuListener=M;function k(f,u,v){const p=new I.Menu;return v.forEach(y=>{let h;y.type==="separator"?h=new I.MenuItem({type:y.type}):Array.isArray(y.submenu)?h=new I.MenuItem({submenu:k(f,u,y.submenu),label:y.label}):h=new I.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(E,S,s)=>f.sender.send(u,y.id,s)}),p.append(h)}),p}}),define(ee[72],te([0,1,15]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=I.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[143],te([12,10]),function(j,e){return j.create("vs/base/common/date",e)}),define(ee[144],te([0,1,143]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,r=A*60,L=r*24,M=L*7,k=L*30,f=L*365;function u(p,y,h,E){typeof p!="number"&&(p=p.getTime());const S=Math.round((new Date().getTime()-p)/1e3);if(S<-30)return(0,I.localize)(0,null,u(new Date().getTime()+S*1e3,!1));if(!E&&S<30)return(0,I.localize)(1,null);let s;return S<A?(s=S,y?s===1?h?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):h?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?h?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):h?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):S<r?(s=Math.floor(S/A),y?s===1?h?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):h?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?h?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):h?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):S<L?(s=Math.floor(S/r),y?s===1?h?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):h?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?h?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):h?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):S<M?(s=Math.floor(S/L),y?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):S<k?(s=Math.floor(S/M),y?s===1?h?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):h?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?h?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):h?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):S<f?(s=Math.floor(S/k),y?s===1?h?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):h?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?h?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):h?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(S/f),y?s===1?h?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):h?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?h?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):h?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}e.fromNow=u;function v(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(ee[145],te([12,10]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,22,11,145]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(p,y){return y&&(p.stack||p.stacktrace)?r.localize(0,null,k(p),M(p.stack)||M(p.stacktrace)):k(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function k(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?r.localize(1,null,p.message):p.message||r.localize(2,null)}function f(p=null,y=!1){if(!p)return r.localize(3,null);if(Array.isArray(p)){const h=I.coalesce(p),E=f(h[0],y);return h.length>1?r.localize(4,null,E,h.length):E}if(A.isString(p))return p;if(p.detail){const h=p.detail;if(h.error)return L(h.error,y);if(h.exception)return L(h.exception,y)}return p.stack?L(p,y):p.message?p.message:r.localize(5,null)}e.toErrorMessage=f;function u(p){const y=p;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=u;function v(p,y){let h;return typeof p=="string"?h=new Error(p):h=p,h.actions=y,h}e.createErrorWithActions=v}),define(ee[146],te([12,10]),function(j,e){return j.create("vs/base/common/jsonErrorMessages",e)}),define(ee[147],te([0,1,146]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(r){switch(r){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ee[148],te([12,10]),function(j,e){return j.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,148]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,r=!1,L=!1,M=!1,k=!1,f=!1,u=!1,v=!1,p=!1,y=!1,h,E=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT,s,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const b=typeof d?.versions?.electron=="string",w=b&&d?.type==="renderer";if(typeof navigator=="object"&&!w)g=navigator.userAgent,A=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,v=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=g.indexOf("Linux")>=0,y=g?.indexOf("Mobi")>=0,f=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,E=h,S=navigator.language;else if(typeof d=="object"){A=d.platform==="win32",r=d.platform==="darwin",L=d.platform==="linux",M=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=b,p=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const m=d.env.VSCODE_NLS_CONFIG;if(m)try{const C=JSON.parse(m),R=C.availableLanguages["*"];h=C.locale,S=C.osLocale,E=R||e.LANGUAGE_DEFAULT,s=C._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var D;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function t(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let l=0;r?l=1:A?l=3:L&&(l=2),e.isWindows=A,e.isMacintosh=r,e.isLinux=L,e.isLinuxSnap=M,e.isNative=k,e.isElectron=u,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=v,e.isMobile=y,e.isCI=p,e.platform=l,e.userAgent=g,e.language=E;var i;(function(m){function C(){return e.language}m.value=C;function R(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}m.isDefaultVariant=R;function T(){return e.language==="en"}m.isDefault=T})(i=e.Language||(e.Language={})),e.locale=h,e.platformLocale=S,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const m=[];e.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let T=0,U=m.length;T<U;T++){const $=m[T];if($.id===R.data.vscodeScheduleAsyncWork){m.splice(T,1),$.callback();return}}});let C=0;return R=>{const T=++C;m.push({id:T,callback:R}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return m=>setTimeout(m)})();var n;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=r||v?2:A?1:3;let a=!0,c=!1;function o(){if(!c){c=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,a=new Uint16Array(m.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const r=I.globals.vscode.process;A={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ee[9],te([0,1,36]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,r=97,L=90,M=122,k=46,f=47,u=92,v=58,p=63;class y extends Error{constructor(l,i,n){let a;typeof i=="string"&&i.indexOf("not ")===0?(a="must not be",i=i.replace(/^not /,"")):a="must be";const c=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${c} ${a} of type ${i}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,l){if(t===null||typeof t!="object")throw new y(l,"Object",t)}function E(t,l){if(typeof t!="string")throw new y(l,"string",t)}const S=I.platform==="win32";function s(t){return t===f||t===u}function g(t){return t===f}function d(t){return t>=A&&t<=L||t>=r&&t<=M}function b(t,l,i,n){let a="",c=0,o=-1,m=0,C=0;for(let R=0;R<=t.length;++R){if(R<t.length)C=t.charCodeAt(R);else{if(n(C))break;C=f}if(n(C)){if(!(o===R-1||m===1))if(m===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==k||a.charCodeAt(a.length-2)!==k){if(a.length>2){const T=a.lastIndexOf(i);T===-1?(a="",c=0):(a=a.slice(0,T),c=a.length-1-a.lastIndexOf(i)),o=R,m=0;continue}else if(a.length!==0){a="",c=0,o=R,m=0;continue}}l&&(a+=a.length>0?`${i}..`:"..",c=2)}else a.length>0?a+=`${i}${t.slice(o+1,R)}`:a=t.slice(o+1,R),c=R-o-1;o=R,m=0}else C===k&&m!==-1?++m:m=-1}return a}function w(t,l){h(l,"pathObject");const i=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return i?i===l.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let l="",i="",n=!1;for(let a=t.length-1;a>=-1;a--){let c;if(a>=0){if(c=t[a],E(c,"path"),c.length===0)continue}else l.length===0?c=I.cwd():(c=I.env[`=${l}`]||I.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==l.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${l}\\`));const o=c.length;let m=0,C="",R=!1;const T=c.charCodeAt(0);if(o===1)s(T)&&(m=1,R=!0);else if(s(T))if(R=!0,s(c.charCodeAt(1))){let U=2,$=U;for(;U<o&&!s(c.charCodeAt(U));)U++;if(U<o&&U!==$){const q=c.slice($,U);for($=U;U<o&&s(c.charCodeAt(U));)U++;if(U<o&&U!==$){for($=U;U<o&&!s(c.charCodeAt(U));)U++;(U===o||U!==$)&&(C=`\\\\${q}\\${c.slice($,U)}`,m=U)}}}else m=1;else d(T)&&c.charCodeAt(1)===v&&(C=c.slice(0,2),m=2,o>2&&s(c.charCodeAt(2))&&(R=!0,m=3));if(C.length>0)if(l.length>0){if(C.toLowerCase()!==l.toLowerCase())continue}else l=C;if(n){if(l.length>0)break}else if(i=`${c.slice(m)}\\${i}`,n=R,R&&l.length>0)break}return i=b(i,!n,"\\",s),n?`${l}\\${i}`:`${l}${i}`||"."},normalize(t){E(t,"path");const l=t.length;if(l===0)return".";let i=0,n,a=!1;const c=t.charCodeAt(0);if(l===1)return g(c)?"\\":t;if(s(c))if(a=!0,s(t.charCodeAt(1))){let m=2,C=m;for(;m<l&&!s(t.charCodeAt(m));)m++;if(m<l&&m!==C){const R=t.slice(C,m);for(C=m;m<l&&s(t.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&!s(t.charCodeAt(m));)m++;if(m===l)return`\\\\${R}\\${t.slice(C)}\\`;m!==C&&(n=`\\\\${R}\\${t.slice(C,m)}`,i=m)}}}else i=1;else d(c)&&t.charCodeAt(1)===v&&(n=t.slice(0,2),i=2,l>2&&s(t.charCodeAt(2))&&(a=!0,i=3));let o=i<l?b(t.slice(i),!a,"\\",s):"";return o.length===0&&!a&&(o="."),o.length>0&&s(t.charCodeAt(l-1))&&(o+="\\"),n===void 0?a?`\\${o}`:o:a?`${n}\\${o}`:`${n}${o}`},isAbsolute(t){E(t,"path");const l=t.length;if(l===0)return!1;const i=t.charCodeAt(0);return s(i)||l>2&&d(i)&&t.charCodeAt(1)===v&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,i;for(let c=0;c<t.length;++c){const o=t[c];E(o,"path"),o.length>0&&(l===void 0?l=i=o:l+=`\\${o}`)}if(l===void 0)return".";let n=!0,a=0;if(typeof i=="string"&&s(i.charCodeAt(0))){++a;const c=i.length;c>1&&s(i.charCodeAt(1))&&(++a,c>2&&(s(i.charCodeAt(2))?++a:n=!1))}if(n){for(;a<l.length&&s(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l)return"";const i=e.win32.resolve(t),n=e.win32.resolve(l);if(i===n||(t=i.toLowerCase(),l=n.toLowerCase(),t===l))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===u;)a++;let c=t.length;for(;c-1>a&&t.charCodeAt(c-1)===u;)c--;const o=c-a;let m=0;for(;m<l.length&&l.charCodeAt(m)===u;)m++;let C=l.length;for(;C-1>m&&l.charCodeAt(C-1)===u;)C--;const R=C-m,T=o<R?o:R;let U=-1,$=0;for(;$<T;$++){const ie=t.charCodeAt(a+$);if(ie!==l.charCodeAt(m+$))break;ie===u&&(U=$)}if($!==T){if(U===-1)return n}else{if(R>T){if(l.charCodeAt(m+$)===u)return n.slice(m+$+1);if($===2)return n.slice(m+$)}o>T&&(t.charCodeAt(a+$)===u?U=$:$===2&&(U=3)),U===-1&&(U=0)}let q="";for($=a+U+1;$<=c;++$)($===c||t.charCodeAt($)===u)&&(q+=q.length===0?"..":"\\..");return m+=U,q.length>0?`${q}${n.slice(m,C)}`:(n.charCodeAt(m)===u&&++m,n.slice(m,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const i=l.charCodeAt(2);if(i!==p&&i!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(d(l.charCodeAt(0))&&l.charCodeAt(1)===v&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return t},dirname(t){E(t,"path");const l=t.length;if(l===0)return".";let i=-1,n=0;const a=t.charCodeAt(0);if(l===1)return s(a)?t:".";if(s(a)){if(i=n=1,s(t.charCodeAt(1))){let m=2,C=m;for(;m<l&&!s(t.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&s(t.charCodeAt(m));)m++;if(m<l&&m!==C){for(C=m;m<l&&!s(t.charCodeAt(m));)m++;if(m===l)return t;m!==C&&(i=n=m+1)}}}}else d(a)&&t.charCodeAt(1)===v&&(i=l>2&&s(t.charCodeAt(2))?3:2,n=i);let c=-1,o=!0;for(let m=l-1;m>=n;--m)if(s(t.charCodeAt(m))){if(!o){c=m;break}}else o=!1;if(c===-1){if(i===-1)return".";c=i}return t.slice(0,c)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let i=0,n=-1,a=!0,c;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===v&&(i=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let o=l.length-1,m=-1;for(c=t.length-1;c>=i;--c){const C=t.charCodeAt(c);if(s(C)){if(!a){i=c+1;break}}else m===-1&&(a=!1,m=c+1),o>=0&&(C===l.charCodeAt(o)?--o===-1&&(n=c):(o=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(c=t.length-1;c>=i;--c)if(s(t.charCodeAt(c))){if(!a){i=c+1;break}}else n===-1&&(a=!1,n=c+1);return n===-1?"":t.slice(i,n)},extname(t){E(t,"path");let l=0,i=-1,n=0,a=-1,c=!0,o=0;t.length>=2&&t.charCodeAt(1)===v&&d(t.charCodeAt(0))&&(l=n=2);for(let m=t.length-1;m>=l;--m){const C=t.charCodeAt(m);if(s(C)){if(!c){n=m+1;break}continue}a===-1&&(c=!1,a=m+1),C===k?i===-1?i=m:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||a===-1||o===0||o===1&&i===a-1&&i===n+1?"":t.slice(i,a)},format:w.bind(null,"\\"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const i=t.length;let n=0,a=t.charCodeAt(0);if(i===1)return s(a)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(s(a)){if(n=1,s(t.charCodeAt(1))){let U=2,$=U;for(;U<i&&!s(t.charCodeAt(U));)U++;if(U<i&&U!==$){for($=U;U<i&&s(t.charCodeAt(U));)U++;if(U<i&&U!==$){for($=U;U<i&&!s(t.charCodeAt(U));)U++;U===i?n=U:U!==$&&(n=U+1)}}}}else if(d(a)&&t.charCodeAt(1)===v){if(i<=2)return l.root=l.dir=t,l;if(n=2,s(t.charCodeAt(2))){if(i===3)return l.root=l.dir=t,l;n=3}}n>0&&(l.root=t.slice(0,n));let c=-1,o=n,m=-1,C=!0,R=t.length-1,T=0;for(;R>=n;--R){if(a=t.charCodeAt(R),s(a)){if(!C){o=R+1;break}continue}m===-1&&(C=!1,m=R+1),a===k?c===-1?c=R:T!==1&&(T=1):c!==-1&&(T=-1)}return m!==-1&&(c===-1||T===0||T===1&&c===m-1&&c===o+1?l.base=l.name=t.slice(o,m):(l.name=t.slice(o,c),l.base=t.slice(o,m),l.ext=t.slice(c,m))),o>0&&o!==n?l.dir=t.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(S){const t=/\\/g;return()=>{const l=I.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let l="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const a=n>=0?t[n]:D();E(a,"path"),a.length!==0&&(l=`${a}/${l}`,i=a.charCodeAt(0)===f)}return l=b(l,!i,"/",g),i?`/${l}`:l.length>0?l:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=b(t,!l,"/",g),t.length===0?l?"/":i?"./":".":(i&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let i=0;i<t.length;++i){const n=t[i];E(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const i=1,n=t.length,a=n-i,c=1,o=l.length-c,m=a<o?a:o;let C=-1,R=0;for(;R<m;R++){const U=t.charCodeAt(i+R);if(U!==l.charCodeAt(c+R))break;U===f&&(C=R)}if(R===m)if(o>m){if(l.charCodeAt(c+R)===f)return l.slice(c+R+1);if(R===0)return l.slice(c+R)}else a>m&&(t.charCodeAt(i+R)===f?C=R:R===0&&(C=0));let T="";for(R=i+C+1;R<=n;++R)(R===n||t.charCodeAt(R)===f)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(c+C)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let i=-1,n=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===f){if(!n){i=a;break}}else n=!1;return i===-1?l?"/":".":l&&i===1?"//":t.slice(0,i)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let i=0,n=-1,a=!0,c;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let o=l.length-1,m=-1;for(c=t.length-1;c>=0;--c){const C=t.charCodeAt(c);if(C===f){if(!a){i=c+1;break}}else m===-1&&(a=!1,m=c+1),o>=0&&(C===l.charCodeAt(o)?--o===-1&&(n=c):(o=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===f){if(!a){i=c+1;break}}else n===-1&&(a=!1,n=c+1);return n===-1?"":t.slice(i,n)},extname(t){E(t,"path");let l=-1,i=0,n=-1,a=!0,c=0;for(let o=t.length-1;o>=0;--o){const m=t.charCodeAt(o);if(m===f){if(!a){i=o+1;break}continue}n===-1&&(a=!1,n=o+1),m===k?l===-1?l=o:c!==1&&(c=1):l!==-1&&(c=-1)}return l===-1||n===-1||c===0||c===1&&l===n-1&&l===i+1?"":t.slice(l,n)},format:w.bind(null,"/"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const i=t.charCodeAt(0)===f;let n;i?(l.root="/",n=1):n=0;let a=-1,c=0,o=-1,m=!0,C=t.length-1,R=0;for(;C>=n;--C){const T=t.charCodeAt(C);if(T===f){if(!m){c=C+1;break}continue}o===-1&&(m=!1,o=C+1),T===k?a===-1?a=C:R!==1&&(R=1):a!==-1&&(R=-1)}if(o!==-1){const T=c===0&&i?1:c;a===-1||R===0||R===1&&a===o-1&&a===c+1?l.base=l.name=t.slice(T,o):(l.name=t.slice(T,a),l.base=t.slice(T,o),l.ext=t.slice(a,o))}return c>0?l.dir=t.slice(0,c-1):i&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S?e.win32.normalize:e.posix.normalize,e.isAbsolute=S?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S?e.win32.join:e.posix.join,e.resolve=S?e.win32.resolve:e.posix.resolve,e.relative=S?e.win32.relative:e.posix.relative,e.dirname=S?e.win32.dirname:e.posix.dirname,e.basename=S?e.win32.basename:e.posix.basename,e.extname=S?e.win32.extname:e.posix.extname,e.format=S?e.win32.format:e.posix.format,e.parse=S?e.win32.parse:e.posix.parse,e.toNamespacedPath=S?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S?e.win32.sep:e.posix.sep,e.delimiter=S?e.win32.delimiter:e.posix.delimiter}),define(ee[73],te([0,1,4]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var r;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(r=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(k,...f){const u=f.reduce((y,h)=>(y[h]=!0,y),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!u[y]).forEach(y=>{for(let h=0;h<v.length;h++)if(y.search(v[h])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=L;function M(k){!k||(delete k.DEBUG,I.isMacintosh&&delete k.DYLD_LIBRARY_PATH,I.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[74],te([0,1,4]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=I.globals.performance&&typeof I.globals.performance.now=="function";class r{static create(M=!0){return new r(M)}constructor(M){this._highResolution=A&&M,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=r}),define(ee[3],te([0,1,13,50,2,100,74]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,f=!1;var u;(function(c){c.None=()=>r.Disposable.None;function o(O){if(f){const{onDidAddListener:F}=O,B=E.create();let N=0;O.onDidAddListener=()=>{++N===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),F?.()}}}function m(O,F){return ae(O,()=>{},0,void 0,!0,void 0,F)}c.defer=m;function C(O){return(F,B=null,N)=>{let z=!1,V;return V=O(se=>{if(!z)return V?V.dispose():z=!0,F.call(B,se)},null,N),z&&V.dispose(),V}}c.once=C;function R(O,F,B){return oe((N,z=null,V)=>O(se=>N.call(z,F(se)),null,V),B)}c.map=R;function T(O,F,B){return oe((N,z=null,V)=>O(se=>{F(se),N.call(z,se)},null,V),B)}c.forEach=T;function U(O,F,B){return oe((N,z=null,V)=>O(se=>F(se)&&N.call(z,se),null,V),B)}c.filter=U;function $(O){return O}c.signal=$;function q(...O){return(F,B=null,N)=>(0,r.combinedDisposable)(...O.map(z=>z(V=>F.call(B,V),null,N)))}c.any=q;function ie(O,F,B,N){let z=B;return R(O,V=>(z=F(z,V),z),N)}c.reduce=ie;function oe(O,F){let B;const N={onWillAddFirstListener(){B=O(z.fire,z)},onDidRemoveLastListener(){B?.dispose()}};F||o(N);const z=new s(N);return F?.add(z),z.event}function ae(O,F,B=100,N=!1,z=!1,V,se){let de,ye,ke,Ae=0,_e;const Oe={leakWarningThreshold:V,onWillAddFirstListener(){de=O(pe=>{Ae++,ye=F(ye,pe),N&&!ke&&(me.fire(ye),ye=void 0),_e=()=>{const De=ye;ye=void 0,ke=void 0,(!N||Ae>1)&&me.fire(De),Ae=0},typeof B=="number"?(clearTimeout(ke),ke=setTimeout(_e,B)):ke===void 0&&(ke=0,queueMicrotask(_e))})},onWillRemoveListener(){z&&Ae>0&&_e?.()},onDidRemoveLastListener(){_e=void 0,de.dispose()}};se||o(Oe);const me=new s(Oe);return se?.add(me),me.event}c.debounce=ae;function he(O,F=0,B){return c.debounce(O,(N,z)=>N?(N.push(z),N):[z],F,void 0,!0,void 0,B)}c.accumulate=he;function ce(O,F=(N,z)=>N===z,B){let N=!0,z;return U(O,V=>{const se=N||!F(V,z);return N=!1,z=V,se},B)}c.latch=ce;function K(O,F,B){return[c.filter(O,F,B),c.filter(O,N=>!F(N),B)]}c.split=K;function Y(O,F=!1,B=[]){let N=B.slice(),z=O(de=>{N?N.push(de):se.fire(de)});const V=()=>{N?.forEach(de=>se.fire(de)),N=null},se=new s({onWillAddFirstListener(){z||(z=O(de=>se.fire(de)))},onDidAddFirstListener(){N&&(F?setTimeout(V):V())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return se.event}c.buffer=Y;class x{constructor(F){this.event=F,this.disposables=new r.DisposableStore}map(F){return new x(R(this.event,F,this.disposables))}forEach(F){return new x(T(this.event,F,this.disposables))}filter(F){return new x(U(this.event,F,this.disposables))}reduce(F,B){return new x(ie(this.event,F,B,this.disposables))}latch(){return new x(ce(this.event,void 0,this.disposables))}debounce(F,B=100,N=!1,z=!1,V){return new x(ae(this.event,F,B,N,z,V,this.disposables))}on(F,B,N){return this.event(F,B,N)}once(F,B,N){return C(this.event)(F,B,N)}dispose(){this.disposables.dispose()}}function W(O){return new x(O)}c.chain=W;function H(O,F,B=N=>N){const N=(...de)=>se.fire(B(...de)),z=()=>O.on(F,N),V=()=>O.removeListener(F,N),se=new s({onWillAddFirstListener:z,onDidRemoveLastListener:V});return se.event}c.fromNodeEventEmitter=H;function Q(O,F,B=N=>N){const N=(...de)=>se.fire(B(...de)),z=()=>O.addEventListener(F,N),V=()=>O.removeEventListener(F,N),se=new s({onWillAddFirstListener:z,onDidRemoveLastListener:V});return se.event}c.fromDOMEventEmitter=Q;function ne(O){return new Promise(F=>C(O)(F))}c.toPromise=ne;function re(O,F){return F(void 0),O(B=>F(B))}c.runAndSubscribe=re;function Z(O,F){let B=null;function N(V){B?.dispose(),B=new r.DisposableStore,F(V,B)}N(void 0);const z=O(V=>N(V));return(0,r.toDisposable)(()=>{z.dispose(),B?.dispose()})}c.runAndSubscribeWithStore=Z;class _{constructor(F,B){this.obs=F,this._counter=0,this._hasChanged=!1;const N={onWillAddFirstListener:()=>{F.addObserver(this)},onDidRemoveLastListener:()=>{F.removeObserver(this)}};B||o(N),this.emitter=new s(N),B&&B.add(this.emitter)}beginUpdate(F){this._counter++}handleChange(F,B){this._hasChanged=!0}endUpdate(F){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function P(O,F){return new _(O,F).emitter.event}c.fromObservable=P})(u=e.Event||(e.Event={}));class v{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${v._idPool++}`,v.all.add(this)}start(o){this._stopWatch=new M.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}v.all=new Set,v._idPool=0,e.EventProfiling=v;let p=-1;function y(c){const o=p;return p=c,{dispose(){p=o}}}e.setGlobalLeakWarningThreshold=y;class h{constructor(o,m=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=m,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(o,m){const C=this.threshold;if(C<=0||m<C)return;this._stacks||(this._stacks=new Map);const R=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,R+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let T,U=0;for(const[$,q]of this._stacks)(!T||U<q)&&(T=$,U=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this._stacks.get(o.value)||0;this._stacks.set(o.value,T-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(o,m,C){this.callback=o,this.callbackThis=m,this.stack=C,this.subscription=new r.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class s{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=p>0||this._options?.leakWarningThreshold?new h(this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const m of o)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,m,C)=>{if(this._listeners||(this._listeners=new L.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;const R=this._listeners.isEmpty();R&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let T,U;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(U=E.create(),T=this._leakageMon.check(U,this._listeners.size+1)),k&&(U=U??E.create());const $=new S(o,m,U),q=this._listeners.push($);R&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,o,m);const ie=$.subscription.set(()=>{T?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),q(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return C instanceof r.DisposableStore?C.add(ie):Array.isArray(C)&&C.push(ie),ie}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new d(this._options?.onListenerError));for(const m of this._listeners)this._deliveryQueue.push(this,m,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=s;class g{constructor(o=I.onUnexpectedError){this._onListenerError=o,this._queue=new L.LinkedList}get size(){return this._queue.size}push(o,m,C){this._queue.push(new b(o,m,C))}clear(o){const m=new L.LinkedList;for(const C of this._queue)C.emitter!==o&&m.push(C);this._queue=m}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(m){this._onListenerError(m)}}}}e.EventDeliveryQueue=g;class d extends g{clear(o){this._queue.clear()}}class b{constructor(o,m,C){this.emitter=o,this.listener=m,this.event=C}}class w extends s{async fireAsync(o,m,C){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const R of this._listeners)this._asyncDeliveryQueue.push([R,o]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[R,T]=this._asyncDeliveryQueue.shift(),U=[],$={...T,token:m,waitUntil:q=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");C&&(q=C(q,R.callback)),U.push(q)}};try{R.invoke($)}catch(q){(0,I.onUnexpectedError)(q);continue}Object.freeze(U),await Promise.allSettled(U).then(q=>{for(const ie of q)ie.status==="rejected"&&(0,I.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=w;class D extends s{constructor(o){super(o),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=D;class t extends D{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=t;class l extends s{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=l;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const m={event:o,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const C=()=>{this.hasListeners&&this.unhook(m);const R=this.events.indexOf(m);this.events.splice(R,1)};return(0,r.toDisposable)((0,A.once)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(m=>this.emitter.fire(m))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(o){return(m,C,R)=>o(T=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>m.call(C,T)):m.call(C,T)},void 0,R)}bufferEvents(o){const m=[];this.buffers.push(m);const C=o();return this.buffers.pop(),m.forEach(R=>R()),C}}e.EventBufferer=n;class a{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=r.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(ee[23],te([0,1,3]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(k,f){const u=setTimeout(k.bind(f),0);return{dispose(){clearTimeout(u)}}});var r;(function(k){function f(u){return u===k.None||u===k.Cancelled||u instanceof L?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}k.isCancellationToken=f,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(r=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=r.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=M}),define(ee[149],te([0,1,23]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new I.CancellationTokenSource,f=this.task(k.token);return this.result={promise:f,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=A;class r{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const f=JSON.stringify(k);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=r;class L{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const f=this.fn(k);return this._map.set(k,f),f}}e.CachedFunction=L}),define(ee[26],te([0,1,149,132]),function(j,e,I,A){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=L;const M=/{(\d+)}/g;function k(G,...le){return le.length===0?G:G.replace(M,function(ge,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=le.length?ge:le[ve]})}e.format=k;const f=/{([^}]+)}/g;function u(G,le){return G.replace(f,(ge,Se)=>le[Se]??ge)}e.format2=u;function v(G){return G.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=v;function p(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function y(G,le){let ge=0;const Se=le.charCodeAt(0);for(let ve=G.length-1;ve>=0;ve--)G.charCodeAt(ve)===Se&&ge++;return ge}e.count=y;function h(G,le,ge="\u2026"){return G.length<=le?G:`${G.substr(0,le)}${ge}`}e.truncate=h;function E(G,le=" "){const ge=S(G,le);return s(ge,le)}e.trim=E;function S(G,le){if(!G||!le)return G;const ge=le.length;if(ge===0||G.length===0)return G;let Se=0;for(;G.indexOf(le,Se)===Se;)Se=Se+ge;return G.substring(Se)}e.ltrim=S;function s(G,le){if(!G||!le)return G;const ge=le.length,Se=G.length;if(ge===0||Se===0)return G;let ve=Se,Re=-1;for(;Re=G.lastIndexOf(le,ve-1),!(Re===-1||Re+ge!==ve);){if(Re===0)return"";ve=Re}return G.substring(0,ve)}e.rtrim=s;function g(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function d(G){return G.replace(/\*/g,"")}e.stripWildcards=d;function b(G,le,ge={}){if(!G)throw new Error("Cannot create regex from empty string");le||(G=p(G)),ge.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Se="";return ge.global&&(Se+="g"),ge.matchCase||(Se+="i"),ge.multiline&&(Se+="m"),ge.unicode&&(Se+="u"),new RegExp(G,Se)}e.createRegExp=b;function w(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function D(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=t;function l(G){return G.split(/\r\n|\r|\n/)}e.splitLines=l;function i(G){for(let le=0,ge=G.length;le<ge;le++){const Se=G.charCodeAt(le);if(Se!==32&&Se!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function n(G,le=0,ge=G.length){for(let Se=le;Se<ge;Se++){const ve=G.charCodeAt(Se);if(ve!==32&&ve!==9)return G.substring(le,Se)}return G.substring(le,ge)}e.getLeadingWhitespace=n;function a(G,le=G.length-1){for(let ge=le;ge>=0;ge--){const Se=G.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.lastNonWhitespaceIndex=a;function c(G,le,ge){const Se=[];let ve=0;for(const Re of G.matchAll(le)){if(Se.push(G.slice(ve,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ve=Re.index+Re[0].length,Se.push(ge(Re[0],...Re.slice(1),Re.index,G,Re.groups))}return Se.push(G.slice(ve)),Promise.all(Se).then(Re=>Re.join(""))}e.replaceAsync=c;function o(G,le){return G<le?-1:G>le?1:0}e.compare=o;function m(G,le,ge=0,Se=G.length,ve=0,Re=le.length){for(;ge<Se&&ve<Re;ge++,ve++){const Ve=G.charCodeAt(ge),Ge=le.charCodeAt(ve);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const Fe=Se-ge,xe=Re-ve;return Fe<xe?-1:Fe>xe?1:0}e.compareSubstring=m;function C(G,le){return R(G,le,0,G.length,0,le.length)}e.compareIgnoreCase=C;function R(G,le,ge=0,Se=G.length,ve=0,Re=le.length){for(;ge<Se&&ve<Re;ge++,ve++){let Ve=G.charCodeAt(ge),Ge=le.charCodeAt(ve);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return m(G.toLowerCase(),le.toLowerCase(),ge,Se,ve,Re);U(Ve)&&(Ve-=32),U(Ge)&&(Ge-=32);const Qe=Ve-Ge;if(Qe!==0)return Qe}const Fe=Se-ge,xe=Re-ve;return Fe<xe?-1:Fe>xe?1:0}e.compareSubstringIgnoreCase=R;function T(G){return G>=48&&G<=57}e.isAsciiDigit=T;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function $(G){return G>=65&&G<=90}e.isUpperAsciiLetter=$;function q(G,le){return G.length===le.length&&R(G,le)===0}e.equalsIgnoreCase=q;function ie(G,le){const ge=le.length;return le.length>G.length?!1:R(G,le,0,ge)===0}e.startsWithIgnoreCase=ie;function oe(G,le){const ge=Math.min(G.length,le.length);let Se;for(Se=0;Se<ge;Se++)if(G.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return ge}e.commonPrefixLength=oe;function ae(G,le){const ge=Math.min(G.length,le.length);let Se;const ve=G.length-1,Re=le.length-1;for(Se=0;Se<ge;Se++)if(G.charCodeAt(ve-Se)!==le.charCodeAt(Re-Se))return Se;return ge}e.commonSuffixLength=ae;function he(G){return 55296<=G&&G<=56319}e.isHighSurrogate=he;function ce(G){return 56320<=G&&G<=57343}e.isLowSurrogate=ce;function K(G,le){return(G-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function Y(G,le,ge){const Se=G.charCodeAt(ge);if(he(Se)&&ge+1<le){const ve=G.charCodeAt(ge+1);if(ce(ve))return K(Se,ve)}return Se}e.getNextCodePoint=Y;function x(G,le){const ge=G.charCodeAt(le-1);if(ce(ge)&&le>1){const Se=G.charCodeAt(le-2);if(he(Se))return K(Se,ge)}return ge}class W{get offset(){return this._offset}constructor(le,ge=0){this._str=le,this._len=le.length,this._offset=ge}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=Y(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class H{get offset(){return this._iterator.offset}constructor(le,ge=0){this._iterator=new W(le,ge)}nextGraphemeLength(){const le=Ee.getInstance(),ge=this._iterator,Se=ge.offset;let ve=le.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Re=ge.offset,Fe=le.getGraphemeBreakType(ge.nextCodePoint());if(ue(ve,Fe)){ge.setOffset(Re);break}ve=Fe}return ge.offset-Se}prevGraphemeLength(){const le=Ee.getInstance(),ge=this._iterator,Se=ge.offset;let ve=le.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Re=ge.offset,Fe=le.getGraphemeBreakType(ge.prevCodePoint());if(ue(Fe,ve)){ge.setOffset(Re);break}ve=Fe}return Se-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function Q(G,le){return new H(G,le).nextGraphemeLength()}e.nextCharLength=Q;function ne(G,le){return new H(G,le).prevGraphemeLength()}e.prevCharLength=ne;function re(G,le){le>0&&ce(G.charCodeAt(le))&&le--;const ge=le+Q(G,le);return[ge-ne(G,ge),ge]}e.getCharContainingOffset=re;function Z(G){const le=new H(G);let ge=0;for(;!le.eol();)ge++,le.nextGraphemeLength();return ge}e.charCount=Z;let _;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(G){return _||(_=P()),_.test(G)}e.containsRTL=O;const F=/^[\t\n\r\x20-\x7E]*$/;function B(G){return F.test(G)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=N;function z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=z;function V(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=V;function se(G,le){if(G.length<le)return G;const ge=/\b/g;let Se=0;for(;ge.test(G)&&!(G.length-ge.lastIndex<le);)Se=ge.lastIndex,ge.lastIndex+=1;return G.substring(Se).replace(/^\s/,"")}e.lcut=se;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ye(G){return G&&(G=G.replace(de,"")),G}e.removeAnsiEscapeCodes=ye,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(G){return ke(G)?G.substr(1):G}e.stripUTF8BOM=Ae;function _e(G,le){if(!G||!le||G.length<le.length)return!1;const ge=le.length,Se=G.toLowerCase();let ve=0,Re=-1;for(;ve<ge;){const Fe=Se.indexOf(le[ve],Re+1);if(Fe<0)return!1;Re=Fe,ve++}return!0}e.fuzzyContains=_e;function Oe(G,le=!1){return G?(le&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Oe;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function pe(G,le=1){if(le===0)return"";let ge=-1;do ge=G.indexOf(`
`,ge+1),le--;while(le>0&&ge>=0);return ge===-1?G:(G[ge-1]==="\r"&&ge--,G.substr(0,ge))}e.getNLines=pe;function De(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=De;function J(G){return Ee.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=J;function ue(G,le){return G===0?le!==5&&le!==7:G===2&&le===3?!1:G===4||G===2||G===3||le===4||le===2||le===3?!0:!(G===8&&(le===8||le===9||le===11||le===12)||(G===11||G===9)&&(le===9||le===10)||(G===12||G===10)&&le===10||le===5||le===13||le===7||G===1||G===13&&le===14||G===6&&le===6)}var fe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}constructor(){this._data=Le()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ge=this._data,Se=ge.length/3;let ve=1;for(;ve<=Se;)if(le<ge[3*ve])ve=2*ve;else if(le>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}Ee._INSTANCE=null;function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(G,le){if(G===0)return 0;const ge=We(G,le);if(ge!==void 0)return ge;const Se=new W(le,G);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Te;function We(G,le){const ge=new W(le,G);let Se=ge.prevCodePoint();for(;qe(Se)||Se===65039||Se===8419;){if(ge.offset===0)return;Se=ge.prevCodePoint()}if(!V(Se))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function qe(G){return 127995<=G&&G<=127999}var Ue;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(le){return Ne.cache.get(Array.from(le))}static getLocales(){return Ne._locales.value}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r=Ne,Ne.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.cache=new I.LRUCachedFunction(G=>{function le(Ge){const Qe=new Map;for(let Je=0;Je<Ge.length;Je+=2)Qe.set(Ge[Je],Ge[Je+1]);return Qe}function ge(Ge,Qe){const Je=new Map(Ge);for(const[st,ct]of Qe)Je.set(st,ct);return Je}function Se(Ge,Qe){if(!Ge)return Qe;const Je=new Map;for(const[st,ct]of Ge)Qe.has(st)&&Je.set(st,ct);return Je}const ve=r.ambiguousCharacterData.value;let Re=G.filter(Ge=>!Ge.startsWith("_")&&Ge in ve);Re.length===0&&(Re=["_default"]);let Fe;for(const Ge of Re){const Qe=le(ve[Ge]);Fe=Se(Fe,Qe)}const xe=le(ve._common),Ve=ge(xe,Fe);return new Ne(Ve)}),Ne._locales=new A.Lazy(()=>Object.keys(Ne.ambiguousCharacterData.value).filter(G=>!G.startsWith("_"))),e.AmbiguousCharacters=Ne;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(le){return He.getData().has(le)}static get codePoints(){return He.getData()}}He._data=void 0,e.InvisibleCharacters=He}),define(ee[32],te([0,1,9,4,26,11]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(c){return c===47||c===92}e.isPathSeparator=M;function k(c){return c.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=k;function f(c){return c.indexOf("/")===-1&&(c=k(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function u(c,o=I.posix.sep){if(!c)return"";const m=c.length,C=c.charCodeAt(0);if(M(C)){if(M(c.charCodeAt(1))&&!M(c.charCodeAt(2))){let T=3;const U=T;for(;T<m&&!M(c.charCodeAt(T));T++);if(U!==T&&!M(c.charCodeAt(T+1))){for(T+=1;T<m;T++)if(M(c.charCodeAt(T)))return c.slice(0,T+1).replace(/[\\/]/g,o)}}return o}else if(g(C)&&c.charCodeAt(1)===58)return M(c.charCodeAt(2))?c.slice(0,2)+o:c.slice(0,2);let R=c.indexOf("://");if(R!==-1){for(R+=3;R<m;R++)if(M(c.charCodeAt(R)))return c.slice(0,R+1)}return""}e.getRoot=u;function v(c){if(!A.isWindows||!c||c.length<5)return!1;let o=c.charCodeAt(0);if(o!==92||(o=c.charCodeAt(1),o!==92))return!1;let m=2;const C=m;for(;m<c.length&&(o=c.charCodeAt(m),o!==92);m++);return!(C===m||(o=c.charCodeAt(m+1),isNaN(o)||o===92))}e.isUNC=v;const p=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(c,o=A.isWindows){const m=o?p:y;return!(!c||c.length===0||/^\s+$/.test(c)||(m.lastIndex=0,m.test(c))||o&&h.test(c)||c==="."||c===".."||o&&c[c.length-1]==="."||o&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=E;function S(c,o,m){const C=c===o;return!m||C?C:!c||!o?!1:(0,r.equalsIgnoreCase)(c,o)}e.isEqual=S;function s(c,o,m,C=I.sep){if(c===o)return!0;if(!c||!o||o.length>c.length)return!1;if(m){if(!(0,r.startsWithIgnoreCase)(c,o))return!1;if(o.length===c.length)return!0;let T=o.length;return o.charAt(o.length-1)===C&&T--,c.charAt(T)===C}return o.charAt(o.length-1)!==C&&(o+=C),c.indexOf(o)===0}e.isEqualOrParent=s;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function d(c,o){return A.isWindows&&c.endsWith(":")&&(c+=I.sep),(0,I.isAbsolute)(c)||(c=(0,I.join)(o,c)),c=(0,I.normalize)(c),A.isWindows?(c=(0,r.rtrim)(c,I.sep),c.endsWith(":")&&(c+=I.sep)):(c=(0,r.rtrim)(c,I.sep),c||(c=I.sep)),c}e.sanitizeFilePath=d;function b(c){const o=(0,I.normalize)(c);return A.isWindows?c.length>3?!1:w(o)&&(c.length===2||o.charCodeAt(2)===92):o===I.posix.sep}e.isRootOrDriveLetter=b;function w(c,o=A.isWindows){return o?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function D(c){return w(c)?c[0]:void 0}e.getDriveLetter=D;function t(c,o,m){return o.length>c.length?-1:c===o?0:(m&&(c=c.toLowerCase(),o=o.toLowerCase()),c.indexOf(o))}e.indexOfPath=t;function l(c){const o=c.split(":");let m,C,R;for(const T of o){const U=Number(T);(0,L.isNumber)(U)?C===void 0?C=U:R===void 0&&(R=U):m=m?[m,T].join(":"):T}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:C!==void 0?C:void 0,column:R!==void 0?R:C!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(c,o,m=8){let C="";for(let T=0;T<m;T++){let U;T===0&&A.isWindows&&!o&&(m===3||m===4)?U=n:U=i,C+=U.charAt(Math.floor(Math.random()*U.length))}let R;return o?R=`${o}-${C}`:R=C,c?(0,I.join)(c,R):R}e.randomPath=a}),define(ee[56],te([0,1,26]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(g){return r(g,0)}e.hash=A;function r(g,d){switch(typeof g){case"object":return g===null?L(349,d):Array.isArray(g)?f(g,d):u(g,d);case"string":return k(g,d);case"boolean":return M(g,d);case"number":return L(g,d);case"undefined":return L(937,d);default:return L(617,d)}}e.doHash=r;function L(g,d){return(d<<5)-d+g|0}e.numberHash=L;function M(g,d){return L(g?433:863,d)}function k(g,d){d=L(149417,d);for(let b=0,w=g.length;b<w;b++)d=L(g.charCodeAt(b),d);return d}e.stringHash=k;function f(g,d){return d=L(104579,d),g.reduce((b,w)=>r(w,b),d)}function u(g,d){return d=L(181387,d),Object.keys(g).sort().reduce((b,w)=>(b=k(w,b),r(g[w],b)),d)}class v{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=r(d,this._value),this._value}}e.Hasher=v;var p;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function y(g,d,b=32){const w=b-d,D=~((1<<w)-1);return(g<<d|(D&g)>>>w)>>>0}function h(g,d=0,b=g.byteLength,w=0){for(let D=0;D<b;D++)g[d+D]=w}function E(g,d,b="0"){for(;g.length<d;)g=b+g;return g}function S(g,d=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((g>>>0).toString(16),d/4)}e.toHexString=S;class s{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const b=d.length;if(b===0)return;const w=this._buff;let D=this._buffLen,t=this._leftoverHighSurrogate,l,i;for(t!==0?(l=t,i=-1,t=0):(l=d.charCodeAt(0),i=0);;){let n=l;if(I.isHighSurrogate(l))if(i+1<b){const a=d.charCodeAt(i+1);I.isLowSurrogate(a)?(i++,n=I.computeCodePoint(l,a)):n=65533}else{t=l;break}else I.isLowSurrogate(l)&&(n=65533);if(D=this._push(w,D,n),i++,i<b)l=d.charCodeAt(i);else break}this._buffLen=D,this._leftoverHighSurrogate=t}_push(d,b,w){return w<128?d[b++]=w:w<2048?(d[b++]=192|(w&1984)>>>6,d[b++]=128|(w&63)>>>0):w<65536?(d[b++]=224|(w&61440)>>>12,d[b++]=128|(w&4032)>>>6,d[b++]=128|(w&63)>>>0):(d[b++]=240|(w&1835008)>>>18,d[b++]=128|(w&258048)>>>12,d[b++]=128|(w&4032)>>>6,d[b++]=128|(w&63)>>>0),b>=64&&(this._step(),b-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),b}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=s._bigBlock32,b=this._buffDV;for(let o=0;o<64;o+=4)d.setUint32(o,b.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)d.setUint32(o,y(d.getUint32(o-12,!1)^d.getUint32(o-32,!1)^d.getUint32(o-56,!1)^d.getUint32(o-64,!1),1),!1);let w=this._h0,D=this._h1,t=this._h2,l=this._h3,i=this._h4,n,a,c;for(let o=0;o<80;o++)o<20?(n=D&t|~D&l,a=1518500249):o<40?(n=D^t^l,a=1859775393):o<60?(n=D&t|D&l|t&l,a=2400959708):(n=D^t^l,a=3395469782),c=y(w,5)+n+i+a+d.getUint32(o*4,!1)&4294967295,i=l,l=t,t=y(D,30),D=w,w=c;this._h0=this._h0+w&4294967295,this._h1=this._h1+D&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}s._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=s}),define(ee[75],te([0,1,26]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(A||(A={})),function(r){const L="error",M="warning",k="warn",f="info",u="ignore";function v(y){return y?I.equalsIgnoreCase(L,y)?r.Error:I.equalsIgnoreCase(M,y)||I.equalsIgnoreCase(k,y)?r.Warning:I.equalsIgnoreCase(f,y)?r.Info:r.Ignore:r.Ignore}r.fromValue=v;function p(y){switch(y){case r.Error:return L;case r.Warning:return M;case r.Info:return f;default:return u}}r.toString=p}(A||(A={})),e.default=A}),define(ee[61],te([0,1,22,26]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const E=h.charCodeAt(0),S=this._value.charCodeAt(this._pos);return E-S}value(){return this._value[this._pos]}}e.StringIterator=r;class L{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,A.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class M{constructor(h=!0,E=!0){this._splitOnBackslash=h,this._caseSensitive=E}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let E=h.length-1;E>=0;E--,this._valueLen--){const S=this._value.charCodeAt(E);if(!(S===47||this._splitOnBackslash&&S===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const E=this._value.charCodeAt(this._to);if(E===47||this._splitOnBackslash&&E===92)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,A.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var k;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(h,E){this._ignorePathCasing=h,this._ignoreQueryAndFragment=E,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===4)return(0,A.compare)(h,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(v||(v={}));class p{static forUris(h=()=>!1,E=()=>!1){return new p(new f(h,E))}static forPaths(h=!1){return new p(new M(void 0,!h))}static forStrings(){return new p(new r)}static forConfigKeys(){return new p(new L)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,E){if(E){const S=E.slice(0);(0,I.shuffle)(S);for(const s of S)this.set(s,h)}else{const S=h.slice(0);(0,I.shuffle)(S);for(const s of S)this.set(s[0],s[1])}}set(h,E){const S=this._iter.reset(h);let s;this._root||(this._root=new u,this._root.segment=S.value());const g=[];for(s=this._root;;){const b=S.cmp(s.segment);if(b>0)s.left||(s.left=new u,s.left.segment=S.value()),g.push([-1,s]),s=s.left;else if(b<0)s.right||(s.right=new u,s.right.segment=S.value()),g.push([1,s]),s=s.right;else if(S.hasNext())S.next(),s.mid||(s.mid=new u,s.mid.segment=S.value()),g.push([0,s]),s=s.mid;else break}const d=s.value;s.value=E,s.key=h;for(let b=g.length-1;b>=0;b--){const w=g[b][1];w.updateHeight();const D=w.balanceFactor();if(D<-1||D>1){const t=g[b][0],l=g[b+1][0];if(t===1&&l===1)g[b][1]=w.rotateLeft();else if(t===-1&&l===-1)g[b][1]=w.rotateRight();else if(t===1&&l===-1)w.right=g[b+1][1]=g[b+1][1].rotateRight(),g[b][1]=w.rotateLeft();else if(t===-1&&l===1)w.left=g[b+1][1]=g[b+1][1].rotateLeft(),g[b][1]=w.rotateRight();else throw new Error;if(b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this._root=g[0][1]}}return d}get(h){return this._getNode(h)?.value}_getNode(h){const E=this._iter.reset(h);let S=this._root;for(;S;){const s=E.cmp(S.segment);if(s>0)S=S.left;else if(s<0)S=S.right;else if(E.hasNext())E.next(),S=S.mid;else break}return S}has(h){const E=this._getNode(h);return!(E?.value===void 0&&E?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,E){const S=this._iter.reset(h),s=[];let g=this._root;for(;g;){const d=S.cmp(g.segment);if(d>0)s.push([-1,g]),g=g.left;else if(d<0)s.push([1,g]),g=g.right;else if(S.hasNext())S.next(),s.push([0,g]),g=g.mid;else break}if(!!g){if(E?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const d=this._min(g.right);if(d.key){const{key:b,value:w,segment:D}=d;this._delete(d.key,!1),g.key=b,g.value=w,g.segment=D}}else{const d=g.left??g.right;if(s.length>0){const[b,w]=s[s.length-1];switch(b){case-1:w.left=d;break;case 0:w.mid=d;break;case 1:w.right=d;break}}else this._root=d}for(let d=s.length-1;d>=0;d--){const b=s[d][1];b.updateHeight();const w=b.balanceFactor();if(w>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),s[d][1]=b.rotateLeft()):w<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),s[d][1]=b.rotateRight()),d>0)switch(s[d-1][0]){case-1:s[d-1][1].left=s[d][1];break;case 1:s[d-1][1].right=s[d][1];break;case 0:s[d-1][1].mid=s[d][1];break}else this._root=s[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const E=this._iter.reset(h);let S=this._root,s;for(;S;){const g=E.cmp(S.segment);if(g>0)S=S.left;else if(g<0)S=S.right;else if(E.hasNext())E.next(),s=S.value||s,S=S.mid;else break}return S&&S.value||s}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,E){const S=this._iter.reset(h);let s=this._root;for(;s;){const g=S.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(S.hasNext())S.next(),s=s.mid;else return s.mid?this._entries(s.mid):E?s.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[E,S]of this)h(S,E)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const E=[];return this._dfsEntries(h,E),E[Symbol.iterator]()}_dfsEntries(h,E){!h||(h.left&&this._dfsEntries(h.left,E),h.value&&E.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,E),h.right&&this._dfsEntries(h.right,E))}_isBalanced(){const h=E=>{if(!E)return!0;const S=E.balanceFactor();return S<-1||S>1?!1:h(E.left)&&h(E.right)};return h(this._root)}}e.TernarySearchTree=p}),define(ee[8],te([0,1,9,4]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,L=/^\//,M=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function u(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==p&&(n=p+n):n=p;break}return n}const v="",p="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,c,o,m,C=!1){typeof n=="object"?(this.scheme=n.scheme||v,this.authority=n.authority||v,this.path=n.path||v,this.query=n.query||v,this.fragment=n.fragment||v):(this.scheme=f(n,C),this.authority=a||v,this.path=u(this.scheme,c||v),this.query=o||v,this.fragment=m||v,k(this,C))}get fsPath(){return b(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:c,path:o,query:m,fragment:C}=n;return a===void 0?a=this.scheme:a===null&&(a=v),c===void 0?c=this.authority:c===null&&(c=v),o===void 0?o=this.path:o===null&&(o=v),m===void 0?m=this.query:m===null&&(m=v),C===void 0?C=this.fragment:C===null&&(C=v),a===this.scheme&&c===this.authority&&o===this.path&&m===this.query&&C===this.fragment?this:new S(a,c,o,m,C)}static parse(n,a=!1){const c=y.exec(n);return c?new S(c[2]||v,l(c[4]||v),l(c[5]||v),l(c[7]||v),l(c[9]||v),a):new S(v,v,v,v,v)}static file(n){let a=v;if(A.isWindows&&(n=n.replace(/\\/g,p)),n[0]===p&&n[1]===p){const c=n.indexOf(p,2);c===-1?(a=n.substring(2),n=p):(a=n.substring(2,c),n=n.substring(c)||p)}return new S("file",a,n,v,v)}static from(n){const a=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return k(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return A.isWindows&&n.scheme==="file"?c=h.file(I.win32.join(b(n,!0),...a)).path:c=I.posix.join(n.path,...a),n.with({path:c})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const a=new S(n);return a._formatted=n.external,a._fsPath=n._sep===E?n.fsPath:null,a}}else return n}}e.URI=h;const E=A.isWindows?1:void 0;class S extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=E),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,n,a){let c,o=-1;for(let m=0;m<i.length;m++){const C=i.charCodeAt(m);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47||a&&C===91||a&&C===93||a&&C===58)o!==-1&&(c+=encodeURIComponent(i.substring(o,m)),o=-1),c!==void 0&&(c+=i.charAt(m));else{c===void 0&&(c=i.substr(0,m));const R=s[C];R!==void 0?(o!==-1&&(c+=encodeURIComponent(i.substring(o,m)),o=-1),c+=R):o===-1&&(o=m)}}return o!==-1&&(c+=encodeURIComponent(i.substring(o))),c!==void 0?c:i}function d(i){let n;for(let a=0;a<i.length;a++){const c=i.charCodeAt(a);c===35||c===63?(n===void 0&&(n=i.substr(0,a)),n+=s[c]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function b(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,A.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=b;function w(i,n){const a=n?d:g;let c="",{scheme:o,authority:m,path:C,query:R,fragment:T}=i;if(o&&(c+=o,c+=":"),(m||o==="file")&&(c+=p,c+=p),m){let U=m.indexOf("@");if(U!==-1){const $=m.substr(0,U);m=m.substr(U+1),U=$.lastIndexOf(":"),U===-1?c+=a($,!1,!1):(c+=a($.substr(0,U),!1,!1),c+=":",c+=a($.substr(U+1),!1,!0)),c+="@"}m=m.toLowerCase(),U=m.lastIndexOf(":"),U===-1?c+=a(m,!1,!0):(c+=a(m.substr(0,U),!1,!0),c+=m.substr(U))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const U=C.charCodeAt(1);U>=65&&U<=90&&(C=`/${String.fromCharCode(U+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const U=C.charCodeAt(0);U>=65&&U<=90&&(C=`${String.fromCharCode(U+32)}:${C.substr(2)}`)}c+=a(C,!0,!1)}return R&&(c+="?",c+=a(R,!1,!1)),T&&(c+="#",c+=n?T:g(T,!1,!1)),c}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(t)?i.replace(t,n=>D(n)):i}}),define(ee[150],te([0,1,8]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(u){const v=u;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=A;function r(u){const v=[];let p;try{const y=JSON.parse(u.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),p=h.__$stack),v.push(...y)}catch{v.push("Unable to log remote console arguments",u.arguments)}return{args:v,stack:p}}e.parse=r;function L(u){if(typeof u!="string")return L(r(u).stack);const v=u;if(v){const p=M(v),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(y&&y.length===4)return{uri:I.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=L;function M(u){if(!u)return u;const v=u.indexOf(`
`);return v===-1?u:u.substring(0,v)}function k(u,v){const{args:p,stack:y}=r(u),h=typeof p[0]=="string"&&p.length===1;let E=M(y);E&&(E=`(${E.trim()})`);let S=[];if(typeof p[0]=="string"?E&&h?S=[`%c[${v}] %c${p[0]} %c${E}`,f("blue"),f(""),f("grey")]:S=[`%c[${v}] %c${p[0]}`,f("blue"),f(""),...p.slice(1)]:S=[`%c[${v}]%`,f("blue"),...p],E&&!h&&S.push(E),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,S)}e.log=k;function f(u){return`color: ${u}`}}),define(ee[85],te([0,1,17,26,8]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(u){return JSON.stringify(u,k)}e.stringify=L;function M(u){let v=JSON.parse(u);return v=f(v),v}e.parse=M;function k(u,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,A.regExpFlags)(v)}:v}function f(u,v=0){if(!u||v>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return r.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof I.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let p=0;p<u.length;++p)u[p]=f(u[p],v+1);else for(const p in u)Object.hasOwnProperty.call(u,p)&&(u[p]=f(u[p],v+1))}return u}e.revive=f}),define(ee[14],te([0,1,13,4,8]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v){this._remoteResourcesPath=`${v}/${L.vscodeRemoteResource}`}set(v,p,y){this._hosts[v]=p,this._ports[v]=y}setConnectionToken(v,p){this._connectionTokens[v]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)try{return this._delegate(v)}catch(s){return I.onUnexpectedError(s),v}const p=v.authority;let y=this._hosts[p];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const h=this._ports[p],E=this._connectionTokens[p];let S=`path=${encodeURIComponent(v.path)}`;return typeof E=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),r.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${y}:${h}`,path:this._remoteResourcesPath,query:S})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(v){const p=this.toUri(v,j);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(v):v.scheme===L.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${L.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?v.with({scheme:L.vscodeFileResource,authority:v.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(v){const p=this.toUri(v,j);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===L.vscodeFileResource?v.with({scheme:L.file,authority:v.authority!==k.FALLBACK_AUTHORITY?v.authority:null,query:null,fragment:null}):v}toUri(v,p){return r.URI.isUri(v)?v:r.URI.parse(p.toUrl(v))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k;var f;(function(u){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function y(E){let S;typeof E=="string"?S=new URL(E).searchParams:E instanceof URL?S=E.searchParams:r.URI.isUri(E)&&(S=new URL(E.toString(!0)).searchParams);const s=S?.get(p);if(!!s)return v.get(s)}u.getHeadersFromQuery=y;function h(E,S,s){if(!globalThis.crossOriginIsolated)return;const g=S&&s?"3":s?"2":"1";E instanceof URLSearchParams?E.set(p,g):E[p]=g}u.addSearchParam=h})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,14,9,4,26,8]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=f;class u{constructor(E){this._ignorePathCasing=E}compare(E,S,s=!1){return E===S?0:(0,M.compare)(this.getComparisonKey(E,s),this.getComparisonKey(S,s))}isEqual(E,S,s=!1){return E===S?!0:!E||!S?!1:this.getComparisonKey(E,s)===this.getComparisonKey(S,s)}getComparisonKey(E,S=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,S,s=!1){if(E.scheme===S.scheme){if(E.scheme===A.Schemas.file)return I.isEqualOrParent(f(E),f(S),this._ignorePathCasing(E))&&E.query===S.query&&(s||E.fragment===S.fragment);if((0,e.isEqualAuthority)(E.authority,S.authority))return I.isEqualOrParent(E.path,S.path,this._ignorePathCasing(E),"/")&&E.query===S.query&&(s||E.fragment===S.fragment)}return!1}joinPath(E,...S){return k.URI.joinPath(E,...S)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return r.posix.basename(E.path)}extname(E){return r.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let S;return E.scheme===A.Schemas.file?S=k.URI.file(r.dirname(f(E))).path:(S=r.posix.dirname(E.path),E.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),S="/")),E.with({path:S})}normalizePath(E){if(!E.path.length)return E;let S;return E.scheme===A.Schemas.file?S=k.URI.file(r.normalize(f(E))).path:S=r.posix.normalize(E.path),E.with({path:S})}relativePath(E,S){if(E.scheme!==S.scheme||!(0,e.isEqualAuthority)(E.authority,S.authority))return;if(E.scheme===A.Schemas.file){const d=r.relative(f(E),f(S));return L.isWindows?I.toSlashes(d):d}let s=E.path||"/";const g=S.path||"/";if(this._ignorePathCasing(E)){let d=0;for(const b=Math.min(s.length,g.length);d<b&&!(s.charCodeAt(d)!==g.charCodeAt(d)&&s.charAt(d).toLowerCase()!==g.charAt(d).toLowerCase());d++);s=g.substr(0,d)+s.substr(d)}return r.posix.relative(s,g)}resolvePath(E,S){if(E.scheme===A.Schemas.file){const s=k.URI.file(r.resolve(f(E),S));return E.with({authority:s.authority,path:s.path})}return S=I.toPosixPath(S),E.with({path:r.posix.resolve(E.path,S)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,S){return E===S||E!==void 0&&S!==void 0&&(0,M.equalsIgnoreCase)(E,S)}hasTrailingPathSeparator(E,S=r.sep){if(E.scheme===A.Schemas.file){const s=f(E);return s.length>I.getRoot(s).length&&s[s.length-1]===S}else{const s=E.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,S=r.sep){return(0,e.hasTrailingPathSeparator)(E,S)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,S=r.sep){let s=!1;if(E.scheme===A.Schemas.file){const g=f(E);s=g!==void 0&&g.length===I.getRoot(g).length&&g[g.length-1]===S}else{S="/";const g=E.path;s=g.length===1&&g.charCodeAt(g.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(E,S)?E.with({path:E.path+"/"}):E}}e.ExtUri=u,e.extUri=new u(()=>!1),e.extUriBiasedIgnorePathCase=new u(h=>h.scheme===A.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new u(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(h,E){const S=[];for(let s=0;s<h.length;s++){const g=E(h[s]);h.some((d,b)=>b===s?!1:(0,e.isEqualOrParent)(g,E(d)))||S.push(h[s])}return S}e.distinctParents=v;var p;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function E(S){const s=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(b=>{const[w,D]=b.split(":");w&&D&&s.set(w,D)});const d=S.path.substring(0,S.path.indexOf(";"));return d&&s.set(h.META_DATA_MIME,d),s}h.parseMetaData=E})(p=e.DataUri||(e.DataUri={}));function y(h,E,S){if(E){let s=h.path;return s&&s[0]!==r.posix.sep&&(s=r.posix.sep+s),h.with({scheme:S,authority:E,path:s})}return h.with({scheme:S})}e.toLocalResource=y}),define(ee[7],te([0,1,23,13,3,2,18,4,135]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=u;function v(Z){const _=new I.CancellationTokenSource,P=Z(_.token),O=new Promise((F,B)=>{const N=_.token.onCancellationRequested(()=>{N.dispose(),_.dispose(),B(new A.CancellationError)});Promise.resolve(P).then(z=>{N.dispose(),_.dispose(),F(z)},z=>{N.dispose(),_.dispose(),B(z)})});return new class{cancel(){_.cancel()}then(F,B){return O.then(F,B)}catch(F){return this.then(void 0,F)}finally(F){return O.finally(F)}}}e.createCancelablePromise=v;function p(Z,_,P){return new Promise((O,F)=>{const B=_.onCancellationRequested(()=>{B.dispose(),O(P)});Z.then(O,F).finally(()=>B.dispose())})}e.raceCancellation=p;function y(Z,_){return new Promise((P,O)=>{const F=_.onCancellationRequested(()=>{F.dispose(),O(new A.CancellationError)});Z.then(P,O).finally(()=>F.dispose())})}e.raceCancellationError=y;async function h(Z){let _=-1;const P=Z.map((F,B)=>F.then(N=>(_=B,N))),O=await Promise.race(P);return Z.forEach((F,B)=>{B!==_&&F.cancel()}),O}e.raceCancellablePromises=h;function E(Z,_,P){let O;const F=setTimeout(()=>{O?.(void 0),P?.()},_);return Promise.race([Z.finally(()=>clearTimeout(F)),new Promise(B=>O=B)])}e.raceTimeout=E;function S(Z){return new Promise((_,P)=>{const O=Z();u(O)?O.then(_,P):_(O)})}e.asPromise=S;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const P=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(P,P).then(O)})}return new Promise((P,O)=>{this.queuedPromise.then(P,O)})}return this.activePromise=_(),new Promise((P,O)=>{this.activePromise.then(F=>{this.activePromise=null,P(F)},F=>{this.activePromise=null,O(F)})})}}e.Throttler=s;class g{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=g;class d{constructor(){this.promiseMap=new Map}queue(_,P){const F=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=d;const b=(Z,_)=>{let P=!0;const O=setTimeout(()=>{P=!1,_()},Z);return{isTriggered:()=>P,dispose:()=>{clearTimeout(O),P=!1}}},w=Z=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,Z())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class D{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,P=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,B)=>{this.doResolve=F,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=P===f.MicrotaskDelay?w(O):b(P,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new A.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(_){this.delayer=new D(_),this.throttler=new s}trigger(_,P){return this.delayer.trigger(()=>this.throttler.queue(_),P)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class l{constructor(){this._isOpen=!1,this._promise=new Promise((_,P)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class i extends l{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function n(Z,_){return _?new Promise((P,O)=>{const F=setTimeout(()=>{B.dispose(),P()},Z),B=_.onCancellationRequested(()=>{clearTimeout(F),B.dispose(),O(new A.CancellationError)})}):v(P=>n(Z,P))}e.timeout=n;function a(Z,_=0){const P=setTimeout(Z,_);return(0,L.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=a;function c(Z){const _=[];let P=0;const O=Z.length;function F(){return P<O?Z[P++]():null}function B(N){N!=null&&_.push(N);const z=F();return z?z.then(B):Promise.resolve(_)}return Promise.resolve(null).then(B)}e.sequence=c;function o(Z,_=O=>!!O,P=null){let O=0;const F=Z.length,B=()=>{if(O>=F)return Promise.resolve(P);const N=Z[O++];return Promise.resolve(N()).then(V=>_(V)?Promise.resolve(V):B())};return B()}e.first=o;function m(Z,_=O=>!!O,P=null){if(Z.length===0)return Promise.resolve(P);let O=Z.length;const F=()=>{O=-1;for(const B of Z)B.cancel?.()};return new Promise((B,N)=>{for(const z of Z)z.then(V=>{--O>=0&&_(V)?(F(),B(V)):O===0&&B(P)}).catch(V=>{--O>=0&&(F(),N(V))})})}e.firstParallel=m;class C{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((P,O)=>{this.outstandingPromises.push({factory:_,c:P,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const P=_.factory();P.then(_.c,_.e),P.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=C;class R extends C{constructor(){super(1)}}e.Queue=R;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new x;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,P=M.extUri){const O=P.getComparisonKey(_);let F=this.queues.get(O);return F||(F=new R,r.Event.once(F.onDrained)(()=>{F?.dispose(),this.queues.delete(O),this.onDidQueueDrain()}),this.queues.set(O,F)),F}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(_,P){this._token=-1,typeof _=="function"&&typeof P=="number"&&this.setIfNotSet(_,P)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,P){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},P)}setIfNotSet(_,P){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},P))}}e.TimeoutTimer=U;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,P){this.cancel(),this._token=setInterval(()=>{_()},P)}}e.IntervalTimer=$;class q{constructor(_,P){this.timeoutToken=-1,this.runner=_,this.timeout=P,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class ie{constructor(_,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=P,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ie;class oe extends q{constructor(_,P){super(_,P),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ae extends L.Disposable{constructor(_,P){super(),this.options=_,this.handler=P,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const P of _)this.pendingWork.push(P);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(_)return;const P=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(Z,_)=>{const P=requestIdleCallback(Z,typeof _=="number"?{timeout:_}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(P))}}}}();class he{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(P){this._error=P}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=he;async function ce(Z,_,P){let O;for(let F=0;F<P;F++)try{return await Z()}catch(B){O=B,await n(_)}throw O}e.retry=ce;class K{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,P,O){return this._pending={taskId:_,cancel:()=>O?.(),promise:P},P.then(()=>this.donePending(_),()=>this.donePending(_)),P}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let P,O;const F=new Promise((B,N)=>{P=B,O=N});this._next={run:_,promise:F,promiseResolve:P,promiseReject:O}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class Y{constructor(_,P=()=>Date.now()){this.interval=_,this.nowFn=P,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class x{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,P)=>{this.completeCallback=_,this.errorCallback=P})}complete(_){return new Promise(P=>{this.completeCallback(_),this.resolved=!0,P()})}error(_){return new Promise(P=>{this.errorCallback(_),this.rejected=!0,P()})}cancel(){new Promise(_=>{this.errorCallback(new A.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=x;var W;(function(Z){async function _(O){let F;const B=await Promise.all(O.map(N=>N.then(z=>z,z=>{F||(F=z)})));if(typeof F<"u")throw F;return B}Z.settled=_;function P(O){return new Promise(async(F,B)=>{try{await O(F,B)}catch(N){B(N)}})}Z.withAsyncBody=P})(W=e.Promises||(e.Promises={}));var H;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(H||(H={}));class Q{static fromArray(_){return new Q(P=>{P.emitMany(_)})}static fromPromise(_){return new Q(async P=>{P.emitMany(await _)})}static fromPromises(_){return new Q(async P=>{await Promise.all(_.map(async O=>P.emitOne(await O)))})}static merge(_){return new Q(async P=>{await Promise.all(_.map(async O=>{for await(const F of O)P.emitOne(F)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const P={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(_(P)),this.resolve()}catch(O){this.reject(O)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,P){return new Q(async O=>{for await(const F of _)O.emitOne(P(F))})}map(_){return Q.map(this,_)}static filter(_,P){return new Q(async O=>{for await(const F of _)P(F)&&O.emitOne(F)})}filter(_){return Q.filter(this,_)}static coalesce(_){return Q.filter(_,P=>!!P)}coalesce(){return Q.coalesce(this)}static async toPromise(_){const P=[];for await(const O of _)P.push(O);return P}toPromise(){return Q.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}Q.EMPTY=Q.fromArray([]),e.AsyncIterableObject=Q;class ne extends Q{constructor(_,P){super(P),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function re(Z){const _=new I.CancellationTokenSource,P=Z(_.token);return new ne(_,async O=>{const F=_.token.onCancellationRequested(()=>{F.dispose(),_.dispose(),O.reject(new A.CancellationError)});try{for await(const B of P){if(_.token.isCancellationRequested)return;O.emitOne(B)}F.dispose(),_.dispose()}catch(B){F.dispose(),_.dispose(),O.reject(B)}})}e.createCancelableAsyncIterable=re}),define(ee[102],te([0,1,22,7,32,35,9,4,26]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function u(){return Object.create(null)}e.getEmptyExpression=u,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",p="[^/\\\\]",y=/\//g;function h(Y,x){switch(Y){case 0:return"";case 1:return`${p}*?`;default:return`(?:${v}|${p}+${v}${x?`|${v}${p}+`:""})*?`}}function E(Y,x){if(!Y)return[];const W=[];let H=!1,Q=!1,ne="";for(const re of Y){switch(re){case x:if(!H&&!Q){W.push(ne),ne="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ne+=re}return ne&&W.push(ne),W}e.splitGlobAware=E;function S(Y){if(!Y)return"";let x="";const W=E(Y,e.GLOB_SPLIT);if(W.every(H=>H===e.GLOBSTAR))x=".*";else{let H=!1;W.forEach((Q,ne)=>{if(Q===e.GLOBSTAR){if(H)return;x+=h(2,ne===W.length-1)}else{let re=!1,Z="",_=!1,P="";for(const O of Q){if(O!=="}"&&re){Z+=O;continue}if(_&&(O!=="]"||!P)){let F;O==="-"?F=O:(O==="^"||O==="!")&&!P?F="^":O===e.GLOB_SPLIT?F="":F=(0,f.escapeRegExpCharacters)(O),P+=F;continue}switch(O){case"{":re=!0;continue;case"[":_=!0;continue;case"}":{x+=`(?:${E(Z,",").map(N=>S(N)).join("|")})`,re=!1,Z="";break}case"]":{x+="["+P+"]",_=!1,P="";break}case"?":x+=p;continue;case"*":x+=h(1);continue;default:x+=(0,f.escapeRegExpCharacters)(O)}}ne<W.length-1&&(W[ne+1]!==e.GLOBSTAR||ne+2<W.length)&&(x+=v)}H=Q===e.GLOBSTAR})}return x}const s=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),l=function(){return!1},i=function(){return null};function n(Y,x){if(!Y)return i;let W;typeof Y!="string"?W=Y.pattern:W=Y,W=W.trim();const H=`${W}_${!!x.trimForExclusions}`;let Q=t.get(H);if(Q)return a(Q,Y);let ne;return s.test(W)?Q=o(W.substr(4),W):(ne=g.exec(c(W,x)))?Q=m(ne[1],W):(x.trimForExclusions?b:d).test(W)?Q=C(W,x):(ne=w.exec(c(W,x)))?Q=R(ne[1].substr(1),W,!0):(ne=D.exec(c(W,x)))?Q=R(ne[1],W,!1):Q=T(W),t.set(H,Q),a(Q,Y)}function a(Y,x){if(typeof x=="string")return Y;const W=function(H,Q){return(0,r.isEqualOrParent)(H,x.base,!k.isLinux)?Y((0,f.ltrim)(H.substr(x.base.length),M.sep),Q):null};return W.allBasenames=Y.allBasenames,W.allPaths=Y.allPaths,W.basenames=Y.basenames,W.patterns=Y.patterns,W}function c(Y,x){return x.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function o(Y,x){return function(W,H){return typeof W=="string"&&W.endsWith(Y)?x:null}}function m(Y,x){const W=`/${Y}`,H=`\\${Y}`,Q=function(re,Z){return typeof re!="string"?null:Z?Z===Y?x:null:re===Y||re.endsWith(W)||re.endsWith(H)?x:null},ne=[Y];return Q.basenames=ne,Q.patterns=[x],Q.allBasenames=ne,Q}function C(Y,x){const W=ce(Y.slice(1,-1).split(",").map(Z=>n(Z,x)).filter(Z=>Z!==i),Y),H=W.length;if(!H)return i;if(H===1)return W[0];const Q=function(Z,_){for(let P=0,O=W.length;P<O;P++)if(W[P](Z,_))return Y;return null},ne=W.find(Z=>!!Z.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const re=W.reduce((Z,_)=>_.allPaths?Z.concat(_.allPaths):Z,[]);return re.length&&(Q.allPaths=re),Q}function R(Y,x,W){const H=M.sep===M.posix.sep,Q=H?Y:Y.replace(y,M.sep),ne=M.sep+Q,re=M.posix.sep+Y;let Z;return W?Z=function(_,P){return typeof _=="string"&&(_===Q||_.endsWith(ne)||!H&&(_===Y||_.endsWith(re)))?x:null}:Z=function(_,P){return typeof _=="string"&&(_===Q||!H&&_===Y)?x:null},Z.allPaths=[(W?"*/":"./")+Y],Z}function T(Y){try{const x=new RegExp(`^${S(Y)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?Y:null}}catch{return i}}function U(Y,x,W){return!Y||typeof x!="string"?!1:$(Y)(x,void 0,W)}e.match=U;function $(Y,x={}){if(!Y)return l;if(typeof Y=="string"||q(Y)){const W=n(Y,x);if(W===i)return l;const H=function(Q,ne){return!!W(Q,ne)};return W.allBasenames&&(H.allBasenames=W.allBasenames),W.allPaths&&(H.allPaths=W.allPaths),H}return ae(Y,x)}e.parse=$;function q(Y){const x=Y;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=q;function ie(Y){return Y.allBasenames||[]}e.getBasenameTerms=ie;function oe(Y){return Y.allPaths||[]}e.getPathTerms=oe;function ae(Y,x){const W=ce(Object.getOwnPropertyNames(Y).map(Z=>he(Z,Y[Z],x)).filter(Z=>Z!==i)),H=W.length;if(!H)return i;if(!W.some(Z=>!!Z.requiresSiblings)){if(H===1)return W[0];const Z=function(O,F){let B;for(let N=0,z=W.length;N<z;N++){const V=W[N](O,F);if(typeof V=="string")return V;(0,A.isThenable)(V)&&(B||(B=[]),B.push(V))}return B?(async()=>{for(const N of B){const z=await N;if(typeof z=="string")return z}return null})():null},_=W.find(O=>!!O.allBasenames);_&&(Z.allBasenames=_.allBasenames);const P=W.reduce((O,F)=>F.allPaths?O.concat(F.allPaths):O,[]);return P.length&&(Z.allPaths=P),Z}const Q=function(Z,_,P){let O,F;for(let B=0,N=W.length;B<N;B++){const z=W[B];z.requiresSiblings&&P&&(_||(_=(0,M.basename)(Z)),O||(O=_.substr(0,_.length-(0,M.extname)(Z).length)));const V=z(Z,_,O,P);if(typeof V=="string")return V;(0,A.isThenable)(V)&&(F||(F=[]),F.push(V))}return F?(async()=>{for(const B of F){const N=await B;if(typeof N=="string")return N}return null})():null},ne=W.find(Z=>!!Z.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const re=W.reduce((Z,_)=>_.allPaths?Z.concat(_.allPaths):Z,[]);return re.length&&(Q.allPaths=re),Q}function he(Y,x,W){if(x===!1)return i;const H=n(Y,W);if(H===i)return i;if(typeof x=="boolean")return H;if(x){const Q=x.when;if(typeof Q=="string"){const ne=(re,Z,_,P)=>{if(!P||!H(re,Z))return null;const O=Q.replace("$(basename)",()=>_),F=P(O);return(0,A.isThenable)(F)?F.then(B=>B?Y:null):F?Y:null};return ne.requiresSiblings=!0,ne}}return H}function ce(Y,x){const W=Y.filter(Z=>!!Z.basenames);if(W.length<2)return Y;const H=W.reduce((Z,_)=>{const P=_.basenames;return P?Z.concat(P):Z},[]);let Q;if(x){Q=[];for(let Z=0,_=H.length;Z<_;Z++)Q.push(x)}else Q=W.reduce((Z,_)=>{const P=_.patterns;return P?Z.concat(P):Z},[]);const ne=function(Z,_){if(typeof Z!="string")return null;if(!_){let O;for(O=Z.length;O>0;O--){const F=Z.charCodeAt(O-1);if(F===47||F===92)break}_=Z.substr(O)}const P=H.indexOf(_);return P!==-1?Q[P]:null};ne.basenames=H,ne.patterns=Q,ne.allBasenames=H;const re=Y.filter(Z=>!Z.basenames);return re.push(ne),re}function K(Y,x){return(0,I.equals)(Y,x,(W,H)=>typeof W=="string"&&typeof H=="string"?W===H:typeof W!="string"&&typeof H!="string"?W.base===H.base&&W.pattern===H.pattern:!1)}e.patternsEquals=K}),define(ee[45],te([0,1,22,32,9,4,18,26]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,n){const{os:a,tildify:c,relative:o}=n;if(o){const R=u(i,o,a);if(typeof R=="string")return R}let m=i.fsPath;if(a===1&&!L.isWindows?m=m.replace(/\//g,"\\"):a!==1&&L.isWindows&&(m=m.replace(/\\/g,"/")),a!==1&&c?.userHome){const R=c.userHome.fsPath;let T;i.scheme!==c.userHome.scheme&&i.path.startsWith(r.posix.sep)?T=c.userHome.with({path:i.path}).fsPath:T=i.fsPath,m=y(T,R,a)}return(a===1?r.win32:r.posix).normalize(v(m,a===1))}e.getPathLabel=f;function u(i,n,a){const c=a===1?r.win32:r.posix,o=a===3?M.extUri:M.extUriIgnorePathCase,m=n.getWorkspace(),C=(0,I.firstOrDefault)(m.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path.startsWith(r.posix.sep)&&(i=C.uri.with({path:i.path}));const R=n.getWorkspaceFolder(i);if(!R)return;let T;if(o.isEqual(R.uri,i)?T="":T=o.relativePath(R.uri,i)??"",T&&(T=c.normalize(T)),m.folders.length>1&&!n.noPrefix){const U=R.name?R.name:o.basenameOrAuthority(R.uri);T=T?`${U} \u2022 ${T}`:U}return T}function v(i,n=L.isWindows){return(0,A.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=v;let p=Object.create(null);function y(i,n,a=L.OS){if(a===1||!i||!n)return i;let c=p.original===n?p.normalized:void 0;c||(c=n,L.isWindows&&(c=(0,A.toSlashes)(c)),c=`${(0,k.rtrim)(c,r.posix.sep)}${r.posix.sep}`,p={original:n,normalized:c});let o=i;return L.isWindows&&(o=(0,A.toSlashes)(o)),(a===3?o.startsWith(c):(0,k.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:i}e.tildify=y;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=h;const E="\u2026",S="\\\\",s="~";function g(i,n=r.sep){const a=new Array(i.length);let c=!1;for(let o=0;o<i.length;o++){const m=i[o];if(m===""){a[o]=`.${n}`;continue}if(!m){a[o]=m;continue}c=!0;let C="",R=m;R.indexOf(S)===0?(C=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length)):R.indexOf(n)===0?(C=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(s)===0&&(C=R.substr(0,R.indexOf(s)+s.length),R=R.substr(R.indexOf(s)+s.length));const T=R.split(n);for(let U=1;c&&U<=T.length;U++)for(let $=T.length-U;c&&$>=0;$--){c=!1;let q=T.slice($,$+U).join(n);for(let ie=0;!c&&ie<i.length;ie++)if(ie!==o&&i[ie]&&i[ie].indexOf(q)>-1){const oe=$+U===T.length,ae=$>0&&i[ie].indexOf(n)>-1?n+q:q,he=i[ie].endsWith(ae);c=!oe||he}if(!c){let ie="";(T[0].endsWith(":")||C!=="")&&($===1&&($=0,U++,q=T[0]+n+q),$>0&&(ie=T[0]+n),ie=C+ie),$>0&&(ie=ie+E+n),ie=ie+q,$+U<T.length&&(ie=ie+n+E),a[o]=ie}}c&&(a[o]=m)}return a}e.shorten=g;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function b(i,n=Object.create(null)){const a=[];let c=!1,o="";for(const m of i)if(m==="$"||c&&m==="{")o&&a.push({value:o,type:d.TEXT}),o="",c=!0;else if(m==="}"&&c){const C=n[o];if(typeof C=="string")C.length&&a.push({value:C,type:d.VARIABLE});else if(C){const R=a[a.length-1];(!R||R.type!==d.SEPARATOR)&&a.push({value:C.label,type:d.SEPARATOR})}o="",c=!1}else o+=m;return o&&!c&&a.push({value:o,type:d.TEXT}),a.filter((m,C)=>{if(m.type===d.SEPARATOR){const R=a[C-1],T=a[C+1];return[R,T].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=b;function w(i,n){return L.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function D(i,n){return L.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):L.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,a=n.basename(i),c=n.dirname(i);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=l}),define(ee[151],te([0,1,17,8]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(p){return p.toJSON()}class L{constructor(y){this._uriTransformer=y}transformIncoming(y){const h=this._uriTransformer.transformIncoming(y);return h===y?y:r(A.URI.from(h))}transformOutgoing(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:r(A.URI.from(h))}transformOutgoingURI(y){const h=this._uriTransformer.transformOutgoing(y);return h===y?y:A.URI.from(h)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function M(p,y,h){if(!p||h>200)return null;if(typeof p=="object"){if(p instanceof A.URI)return y.transformOutgoing(p);for(const E in p)if(Object.hasOwnProperty.call(p,E)){const S=M(p[E],y,h+1);S!==null&&(p[E]=S)}}return null}function k(p,y){const h=M(p,y,0);return h===null?p:h}e.transformOutgoingURIs=k;function f(p,y,h,E){if(!p||E>200)return null;if(typeof p=="object"){if(p.$mid===1)return h?A.URI.revive(y.transformIncoming(p)):y.transformIncoming(p);if(p instanceof I.VSBuffer)return null;for(const S in p)if(Object.hasOwnProperty.call(p,S)){const s=f(p[S],y,h,E+1);s!==null&&(p[S]=s)}}return null}function u(p,y){const h=f(p,y,!1,0);return h===null?p:h}e.transformIncomingURIs=u;function v(p,y){const h=f(p,y,!0,0);return h===null?p:h}e.transformAndReviveIncomingURIs=v}),define(ee[86],te([0,1,27,61,31,139]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(u){return this._virtualMachineOUIs||(this._virtualMachineOUIs=A.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(u)}value(){if(this._value===void 0){let u=0,v=0;const p=(0,I.networkInterfaces)();for(const y in p){const h=p[y];if(h)for(const{mac:E,internal:S}of h)S||(v+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(u+=1))}this._value=v>0?u/v:0}return this._value}};let M;async function k(u){return M||(M=(async()=>await f(u)||r.generateUuid())()),M}e.getMachineId=k;async function f(u){try{const v=await new Promise((y,h)=>{j(["crypto"],y,h)}),p=(0,L.getMac)();return v.createHash("sha256").update(p,"utf8").digest("hex")}catch(v){u(v);return}}}),define(ee[24],te([0,1,41,27,152,7,32,82,9,4,18,8]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function h(ae,he=y.UNLINK){if((0,M.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return he===y.UNLINK?S(ae):E(ae)}async function E(ae){try{const he=(0,M.randomPath)((0,A.tmpdir)());try{await I.promises.rename(ae,he)}catch(ce){return ce.code==="ENOENT"?void 0:S(ae)}S(he).catch(ce=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function S(ae){return(0,r.promisify)(I.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function s(ae){if((0,M.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function g(ae,he){return w(await(he?d(ae):(0,r.promisify)(I.readdir)(ae)))}async function d(ae){try{return await(0,r.promisify)(I.readdir)(ae,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const he=[],ce=await g(ae);for(const K of ce){let Y=!1,x=!1,W=!1;try{const H=await e.Promises.lstat((0,f.join)(ae,K));Y=H.isFile(),x=H.isDirectory(),W=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}he.push({name:K,isFile:()=>Y,isDirectory:()=>x,isSymbolicLink:()=>W})}return he}function b(ae){return w(I.readdirSync(ae))}e.readdirSync=b;function w(ae){return ae.map(he=>typeof he=="string"?u.isMacintosh?(0,k.normalizeNFC)(he):he:(he.name=u.isMacintosh?(0,k.normalizeNFC)(he.name):he.name,he))}async function D(ae){const he=await g(ae),ce=[];for(const K of he)await l.existsDirectory((0,f.join)(ae,K))&&ce.push(K);return ce}function t(ae,he=1e3){return new Promise(ce=>{let K=!1;const Y=setInterval(()=>{K||(K=!0,I.access(ae,x=>{K=!1,x&&(clearInterval(Y),ce(void 0))}))},he)})}e.whenDeleted=t;var l;(function(ae){async function he(Y){let x;try{if(x=await e.Promises.lstat(Y),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(u.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw H}throw W}}ae.stat=he;async function ce(Y){try{const{stat:x,symbolicLink:W}=await ae.stat(Y);return x.isFile()&&W?.dangling!==!0}catch{}return!1}ae.existsFile=ce;async function K(Y){try{const{stat:x,symbolicLink:W}=await ae.stat(Y);return x.isDirectory()&&W?.dangling!==!0}catch{}return!1}ae.existsDirectory=K})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function n(ae,he,ce){return i.queueFor(p.URI.file(ae),v.extUriBiasedIgnorePathCase).queue(()=>{const K=C(ce);return new Promise((Y,x)=>o(ae,he,K,W=>W?x(W):Y()))})}let a=!0;function c(ae){a=ae}e.configureFlushOnWrite=c;function o(ae,he,ce,K){if(!a)return I.writeFile(ae,he,{mode:ce.mode,flag:ce.flag},K);I.open(ae,ce.flag,ce.mode,(Y,x)=>{if(Y)return K(Y);I.writeFile(x,he,W=>{if(W)return I.close(x,()=>K(W));I.fdatasync(x,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),I.close(x,Q=>K(Q))))})})}function m(ae,he,ce){const K=C(ce);if(!a)return I.writeFileSync(ae,he,{mode:K.mode,flag:K.flag});const Y=I.openSync(ae,K.flag,K.mode);try{I.writeFileSync(Y,he);try{I.fdatasyncSync(Y)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),c(!1)}}finally{I.closeSync(Y)}}e.writeFileSync=m;function C(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function R(ae,he){if(ae!==he)try{await e.Promises.rename(ae,he)}catch(ce){if(ae.toLowerCase()!==he.toLowerCase()&&ce.code==="EXDEV"||ae.endsWith("."))await T(ae,he,{preserveSymlinks:!1}),await h(ae,y.MOVE);else throw ce}}async function T(ae,he,ce){return $(ae,he,{root:{source:ae,target:he},options:ce,handledSourcePaths:new Set})}const U=511;async function $(ae,he,ce){if(ce.handledSourcePaths.has(ae))return;ce.handledSourcePaths.add(ae);const{stat:K,symbolicLink:Y}=await l.stat(ae);if(Y){if(ce.options.preserveSymlinks)try{return await oe(ae,he,ce)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(Y.dangling)return}return K.isDirectory()?q(ae,he,K.mode&U,ce):ie(ae,he,K.mode&U)}async function q(ae,he,ce,K){await e.Promises.mkdir(he,{recursive:!0,mode:ce});const Y=await g(ae);for(const x of Y)await $((0,f.join)(ae,x),(0,f.join)(he,x),K)}async function ie(ae,he,ce){await e.Promises.copyFile(ae,he),await e.Promises.chmod(he,ce)}async function oe(ae,he,ce){let K=await e.Promises.readlink(ae);(0,M.isEqualOrParent)(K,ce.root.source,!u.isLinux)&&(K=(0,f.join)(ce.root.target,K.substr(ce.root.source.length+1))),await e.Promises.symlink(K,he)}e.Promises=new class{get access(){return(0,r.promisify)(I.access)}get stat(){return(0,r.promisify)(I.stat)}get lstat(){return(0,r.promisify)(I.lstat)}get utimes(){return(0,r.promisify)(I.utimes)}get read(){return(ae,he,ce,K,Y)=>new Promise((x,W)=>{I.read(ae,he,ce,K,Y,(H,Q,ne)=>H?W(H):x({bytesRead:Q,buffer:ne}))})}get readFile(){return(0,r.promisify)(I.readFile)}get write(){return(ae,he,ce,K,Y)=>new Promise((x,W)=>{I.write(ae,he,ce,K,Y,(H,Q,ne)=>H?W(H):x({bytesWritten:Q,buffer:ne}))})}get appendFile(){return(0,r.promisify)(I.appendFile)}get fdatasync(){return(0,r.promisify)(I.fdatasync)}get truncate(){return(0,r.promisify)(I.truncate)}get rename(){return(0,r.promisify)(I.rename)}get copyFile(){return(0,r.promisify)(I.copyFile)}get open(){return(0,r.promisify)(I.open)}get close(){return(0,r.promisify)(I.close)}get symlink(){return(0,r.promisify)(I.symlink)}get readlink(){return(0,r.promisify)(I.readlink)}get chmod(){return(0,r.promisify)(I.chmod)}get mkdir(){return(0,r.promisify)(I.mkdir)}get unlink(){return(0,r.promisify)(I.unlink)}get rmdir(){return(0,r.promisify)(I.rmdir)}get realpath(){return(0,r.promisify)(I.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return D}get writeFile(){return n}get rm(){return h}get move(){return R}get copy(){return T}}}),define(ee[103],te([0,1,41,9,4,26,24]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(y){if(r.isLinux)return y;const h=(0,A.dirname)(y);if(y===h)return y;const E=((0,A.basename)(y)||y).toLowerCase();try{const s=(0,M.readdirSync)(h).filter(g=>g.toLowerCase()===E);if(s.length===1){const g=k(h);if(g)return(0,A.join)(g,s[0])}else if(s.length>1){const g=s.indexOf(E);if(g>=0){const d=k(h);if(d)return(0,A.join)(d,s[g])}}}catch{}return null}e.realcaseSync=k;async function f(y){if(r.isLinux)return y;const h=(0,A.dirname)(y);if(y===h)return y;const E=((0,A.basename)(y)||y).toLowerCase();try{const s=(await M.Promises.readdir(h)).filter(g=>g.toLowerCase()===E);if(s.length===1){const g=await f(h);if(g)return(0,A.join)(g,s[0])}else if(s.length>1){const g=s.indexOf(E);if(g>=0){const d=await f(h);if(d)return(0,A.join)(d,s[g])}}}catch{}return null}e.realcase=f;async function u(y){try{return await M.Promises.realpath(y)}catch{const E=p(y);return await M.Promises.access(E,I.constants.R_OK),E}}e.realpath=u;function v(y){try{return I.realpathSync(y)}catch{const E=p(y);return I.accessSync(E,I.constants.R_OK),E}}e.realpathSync=v;function p(y){return(0,L.rtrim)((0,A.normalize)(y),A.sep)}}),define(ee[153],te([0,1,27,9,24]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,M=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var f;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class p{constructor(D,t,l){this.exePath=D,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:w=!1}={}){return w?u===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:w=!1,findPreview:D=!1}={}){const t=y({useAlternateBitness:w});if(!t)return null;const l=A.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let i=-1,n=null;for(const o of await r.Promises.readdir(l)){let m=-1;if(D){const R=o.indexOf("-");if(R<0)continue;const T=o.substring(0,R);if(!L.test(T)||o.substring(R+1)!=="preview")continue;m=parseInt(T,10)}else{if(!L.test(o))continue;m=parseInt(o,10)}if(m<=i)continue;const C=A.join(l,o,"pwsh.exe");!await r.SymlinkSupport.existsFile(C)||(n=C,i=m)}if(!n)return null;const a=t.includes("x86")?" (x86)":"",c=D?" Preview":"";return new p(n,`PowerShell${c}${a}`,!0)}async function E({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const D=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=w?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await r.Promises.readdir(D))if(t.test(i)){const n=A.join(D,i,"pwsh.exe");return new p(n,l)}return null}function S(){const w=A.join(I.homedir(),".dotnet","tools","pwsh.exe");return new p(w,".NET Core PowerShell Global Tool")}function s(){const w=A.join(process.env.windir,u===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(w,"Windows PowerShell",!0)}async function*g(){let w=await h();w&&(yield w),w=await h({useAlternateBitness:!0}),w&&(yield w),w=await E(),w&&(yield w),w=S(),w&&(yield w),w=await h({findPreview:!0}),w&&(yield w),w=await E({findPreview:!0}),w&&(yield w),w=await h({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=s(),w&&(yield w)}async function*d(){for await(const w of g())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=d;async function b(){for await(const w of d())return w;return null}e.getFirstAvailablePowerShellInstallation=b}),define(ee[87],te([0,1,9,4,36,73,11,24]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function f(p=r.env){return p.comspec||"cmd.exe"}e.getWindowsShell=f;function u(p){let y=[],h=!1;const E=function(S){if(h){y.push(S);return}(!p.send(S,g=>{if(g&&console.error(g),h=!1,y.length>0){const d=y.slice(0);y=[],d.forEach(b=>E(b))}})||A.isWindows)&&(h=!0)};return{send:E}}e.createQueuedSender=u;var v;(function(p){async function y(h,E,S){if(I.isAbsolute(h))return h;if(E===void 0&&(E=r.cwd()),I.dirname(h)!=="."||(S===void 0&&M.isString(r.env.PATH)&&(S=r.env.PATH.split(I.delimiter)),S===void 0||S.length===0))return I.join(E,h);async function g(d){if(await k.Promises.exists(d)){let b;try{b=await k.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(b=await k.Promises.lstat(d))}return b?!b.isDirectory():!1}return!1}for(const d of S){let b;if(I.isAbsolute(d)?b=I.join(d,h):b=I.join(E,d,h),await g(b))return b;let w=b+".com";if(await g(w)||(w=b+".exe",await g(w)))return w}return I.join(E,h)}p.findExecutable=y})(v=e.win32||(e.win32={}))}),define(ee[104],te([0,1,46,14]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((k,f)=>{let u;const v=new Map;function p(h,E,S,s,g){const d=v.get(E);if(h===M||d){const b={name:y(S),cmd:S,pid:h,ppid:E,load:s,mem:g};v.set(h,b),h===M&&(u=b),d&&(d.children||(d.children=[]),d.children.push(b),d.children.length>1&&(d.children=d.children.sort((w,D)=>w.pid-D.pid)))}}function y(h){const E=/--utility-sub-type=network/i,S=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,d=/conhost\.exe/i,b=/--type=([a-zA-Z-]+)/;if(s.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-process";if(d.exec(h))return"console-window-host (Windows internal process)";let w=b.exec(h);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?E.exec(h)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const D=/[a-zA-Z-]+\.js/g;let t="";do w=D.exec(h),w&&(t+=w+" ");while(w);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:S.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=E=>E.indexOf("\\\\?\\")===0||E.indexOf("\\??\\")===0?E.substr(4):E.indexOf('"\\\\?\\')===0||E.indexOf('"\\??\\')===0?'"'+E.substr(5):E;new Promise((E,S)=>{j(["windows-process-tree"],E,S)}).then(E=>{E.getProcessList(M,S=>{if(!S){f(new Error(`Root process ${M} not found`));return}E.getProcessCpuUsage(S,s=>{const g=new Map;s.forEach(d=>{const b=h(d.commandLine||"");g.set(d.pid,{name:y(b),cmd:b,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),u=g.get(M),u?(g.forEach(d=>{const b=g.get(d.ppid);b&&(b.children||(b.children=[]),b.children.push(d))}),g.forEach(d=>{d.children&&(d.children=d.children.sort((b,w)=>b.pid-w.pid))}),k(u)):f(new Error(`Root process ${M} not found`))})},E.ProcessDataFlag.CommandLine|E.ProcessDataFlag.Memory)})}else{let h=function(){let E=[u];const S=[];for(;E.length;){const g=E.shift();g&&(S.push(g.pid),g.children&&(E=E.concat(g.children)))}let s=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+S.join(" "),(0,I.exec)(s,{},(g,d,b)=>{if(g||b)f(g||new Error(b.toString()));else{const w=d.toString().split(`
`);for(let D=0;D<S.length;D++){const t=v.get(S[D]);t.load=parseFloat(w[D])}if(!u){f(new Error(`Root process ${M} not found`));return}k(u)}})};(0,I.exec)("which ps",{},(E,S,s)=>{if(E||s)if(process.platform!=="linux")f(E||new Error(s.toString()));else{const g=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(g,{},(d,b,w)=>{d||w?f(d||new Error(w.toString())):(L(b,p),h())})}else{const g=S.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${g} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,w,D)=>{b||D&&!D.includes("screen size is bogus")?f(b||new Error(D.toString())):(L(w,p),process.platform==="linux"?h():u?k(u):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function L(M,k){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=M.toString().split(`
`);for(const v of u){const p=f.exec(v.trim());p&&p.length===6&&k(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(ee[154],te([0,1,27,4,153,87]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(p,y){return p===1?A.isWindows?v():L.getWindowsShell(y):f(p,y)}e.getSystemShell=M;let k=null;function f(p,y){if(A.isLinux&&p===2||A.isMacintosh&&p===3)return"/bin/bash";if(!k){let h;if(A.isWindows)h="/bin/bash";else{if(h=y.SHELL,!h)try{h=(0,I.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}k=h}return k}let u=null;async function v(){return u||(u=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),u}});var we=this&&this.__decorate||function(j,e,I,A){var r=arguments.length,L=r<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,I):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(j,e,I,A);else for(var k=j.length-1;k>=0;k--)(M=j[k])&&(L=(r<3?M(L):r>3?M(e,I,L):M(e,I))||L);return r>3&&L&&Object.defineProperty(e,I,L),L};define(ee[47],te([0,1,22,7,17,23,55,13,3,2,85,26,11]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(h||(h={}));function E(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S||(S={}));function s(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));function d(x){let W=0;for(let H=0;;H+=7){const Q=x.read(1);if(W|=(Q.buffer[0]&127)<<H,!(Q.buffer[0]&128))return W}}const b=i(0);function w(x,W){if(W===0){x.write(b);return}let H=0;for(let ne=W;ne!==0;ne=ne>>>7)H++;const Q=r.VSBuffer.alloc(H);for(let ne=0;W!==0;ne++)Q.buffer[ne]=W&127,W=W>>>7,W>0&&(Q.buffer[ne]|=128);x.write(Q)}class D{constructor(W){this.buffer=W,this.pos=0}read(W){const H=this.buffer.slice(this.pos,this.pos+W);return this.pos+=H.byteLength,H}}e.BufferReader=D;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(l||(l={}));function i(x){const W=r.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const n={Undefined:i(l.Undefined),String:i(l.String),Buffer:i(l.Buffer),VSBuffer:i(l.VSBuffer),Array:i(l.Array),Object:i(l.Object),Uint:i(l.Int)},a=typeof Buffer<"u";function c(x,W){if(typeof W>"u")x.write(n.Undefined);else if(typeof W=="string"){const H=r.VSBuffer.fromString(W);x.write(n.String),w(x,H.byteLength),x.write(H)}else if(a&&Buffer.isBuffer(W)){const H=r.VSBuffer.wrap(W);x.write(n.Buffer),w(x,H.byteLength),x.write(H)}else if(W instanceof r.VSBuffer)x.write(n.VSBuffer),w(x,W.byteLength),x.write(W);else if(Array.isArray(W)){x.write(n.Array),w(x,W.length);for(const H of W)c(x,H)}else if(typeof W=="number"&&(W|0)===W)x.write(n.Uint),w(x,W);else{const H=r.VSBuffer.fromString(JSON.stringify(W));x.write(n.Object),w(x,H.byteLength),x.write(H)}}e.serialize=c;function o(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(d(x)).toString();case l.Buffer:return x.read(d(x)).buffer;case l.VSBuffer:return x.read(d(x));case l.Array:{const H=d(x),Q=[];for(let ne=0;ne<H;ne++)Q.push(o(x));return Q}case l.Object:return JSON.parse(x.read(d(x)).toString());case l.Int:return d(x)}}e.deserialize=o;class m{constructor(W,H,Q=null,ne=1e3){this.protocol=W,this.ctx=H,this.logger=Q,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(W,H){this.channels.set(W,H),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const H=this.send([W.type]);this.logger?.logOutgoing(H,0,1,s(W.type));return}case 201:case 202:case 204:case 203:{const H=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(H,W.id,1,s(W.type),W.data);return}}}send(W,H=void 0){const Q=new t;return c(Q,W),c(Q,H),this.sendBuffer(Q.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const H=new D(W),Q=o(H),ne=o(H),re=Q[0];switch(re){case 100:return this.logger?.logIncoming(W.byteLength,Q[1],1,`${E(re)}: ${Q[2]}.${Q[3]}`,ne),this.onPromise({type:re,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 102:return this.logger?.logIncoming(W.byteLength,Q[1],1,`${E(re)}: ${Q[2]}.${Q[3]}`,ne),this.onEventListen({type:re,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 101:return this.logger?.logIncoming(W.byteLength,Q[1],1,`${E(re)}`),this.disposeActiveRequest({type:re,id:Q[1]});case 103:return this.logger?.logIncoming(W.byteLength,Q[1],1,`${E(re)}`),this.disposeActiveRequest({type:re,id:Q[1]})}}onPromise(W){const H=this.channels.get(W.channelName);if(!H){this.collectPendingRequest(W);return}const Q=new L.CancellationTokenSource;let ne;try{ne=H.call(this.ctx,W.name,W.arg,Q.token)}catch(_){ne=Promise.reject(_)}const re=W.id;ne.then(_=>{this.sendResponse({id:re,data:_,type:201}),this.activeRequests.delete(W.id)},_=>{_ instanceof Error?this.sendResponse({id:re,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:re,data:_,type:203}),this.activeRequests.delete(W.id)});const Z=(0,u.toDisposable)(()=>Q.cancel());this.activeRequests.set(W.id,Z)}onEventListen(W){const H=this.channels.get(W.channelName);if(!H){this.collectPendingRequest(W);return}const Q=W.id,re=H.listen(this.ctx,W.name,W.arg)(Z=>this.sendResponse({id:Q,data:Z,type:204}));this.activeRequests.set(W.id,re)}disposeActiveRequest(W){const H=this.activeRequests.get(W.id);H&&(H.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let H=this.pendingRequests.get(W.channelName);H||(H=[],this.pendingRequests.set(W.channelName,H));const Q=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:W,timeoutTimer:Q})}flushPendingRequests(W){const H=this.pendingRequests.get(W);if(H){for(const Q of H)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=m;var C;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(W,H=null){this.protocol=W,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=H}getChannel(W){const H=this;return{call(Q,ne,re){return H.isDisposed?Promise.reject(new k.CancellationError):H.requestPromise(W,Q,ne,re)},listen(Q,ne){return H.isDisposed?f.Event.None:H.requestEvent(W,Q,ne)}}}requestPromise(W,H,Q,ne=L.CancellationToken.None){const re=this.lastRequestId++,_={id:re,type:100,channelName:W,name:H,arg:Q};if(ne.isCancellationRequested)return Promise.reject(new k.CancellationError);let P;return new Promise((F,B)=>{if(ne.isCancellationRequested)return B(new k.CancellationError);const N=()=>{const de=ye=>{switch(ye.type){case 201:this.handlers.delete(re),F(ye.data);break;case 202:{this.handlers.delete(re);const ke=new Error(ye.data.message);ke.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,ke.name=ye.data.name,B(ke);break}case 203:this.handlers.delete(re),B(ye.data);break}};this.handlers.set(re,de),this.sendRequest(_)};let z=null;this.state===g.Idle?N():(z=(0,A.createCancelablePromise)(de=>this.whenInitialized()),z.then(()=>{z=null,N()}));const V=()=>{z?(z.cancel(),z=null):this.sendRequest({id:re,type:101}),B(new k.CancellationError)},se=ne.onCancellationRequested(V);P=(0,u.combinedDisposable)((0,u.toDisposable)(V),se),this.activeRequests.add(P)}).finally(()=>{this.activeRequests.delete(P)})}requestEvent(W,H,Q){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:W,name:H,arg:Q};let _=null;const P=new f.Emitter({onWillAddFirstListener:()=>{_=(0,A.createCancelablePromise)(F=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(P),this.sendRequest(Z)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(P),this.sendRequest({id:ne,type:103}))}}),O=F=>P.fire(F.data);return this.handlers.set(ne,O),P.event}sendRequest(W){switch(W.type){case 100:case 102:{const H=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(H,W.id,0,`${E(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const H=this.send([W.type,W.id]);this.logger?.logOutgoing(H,W.id,0,E(W.type));return}}}send(W,H=void 0){const Q=new t;return c(Q,W),c(Q,H),this.sendBuffer(Q.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const H=new D(W),Q=o(H),ne=o(H),re=Q[0];switch(re){case 200:return this.logger?.logIncoming(W.byteLength,0,0,s(re)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,Q[1],0,s(re),ne),this.onResponse({type:Q[0],id:Q[1],data:ne})}}onResponse(W){if(W.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([M.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class T{get connections(){const W=[];return this._connections.forEach(H=>W.push(H)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:H,onDidClientDisconnect:Q})=>{f.Event.once(H.onMessage)(re=>{const Z=new D(re),_=o(Z),P=new m(H,_),O=new R(H);this.channels.forEach((B,N)=>P.registerChannel(N,B));const F={channelServer:P,channelClient:O,ctx:_};this._connections.add(F),this._onDidAddConnection.fire(F),Q(()=>{P.dispose(),O.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)})})})}getChannel(W,H){const Q=this;return{call(ne,re,Z){let _;if((0,y.isFunction)(H)){const O=(0,I.getRandomElement)(Q.connections.filter(H));_=O?Promise.resolve(O):f.Event.toPromise(f.Event.filter(Q.onDidAddConnection,H))}else _=H.routeCall(Q,ne,re);const P=_.then(O=>O.channelClient.getChannel(W));return $(P).call(ne,re,Z)},listen(ne,re){if((0,y.isFunction)(H))return Q.getMulticastEvent(W,H,ne,re);const Z=H.routeEvent(Q,ne,re).then(_=>_.channelClient.getChannel(W));return $(Z).listen(ne,re)}}}getMulticastEvent(W,H,Q,ne){const re=this;let Z=new u.DisposableStore;const _=new f.Emitter({onWillAddFirstListener:()=>{Z=new u.DisposableStore;const P=new f.EventMultiplexer,O=new Map,F=N=>{const V=N.channelClient.getChannel(W).listen(Q,ne),se=P.add(V);O.set(N,se)},B=N=>{const z=O.get(N);!z||(z.dispose(),O.delete(N))};re.connections.filter(H).forEach(F),f.Event.filter(re.onDidAddConnection,H)(F,void 0,Z),re.onDidRemoveConnection(B,void 0,Z),P.event(_.fire,_,Z),Z.add(P)},onDidRemoveLastListener:()=>{Z.dispose()}});return _.event}registerChannel(W,H){this.channels.set(W,H),this._connections.forEach(Q=>{Q.channelServer.registerChannel(W,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(W,H,Q=null){const ne=new t;c(ne,H),W.send(ne.buffer),this.channelClient=new R(W,Q),this.channelServer=new m(W,H,Q)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,H){this.channelServer.registerChannel(W,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function $(x){return{call(W,H,Q){return x.then(ne=>ne.call(W,H,Q))},listen(W,H){const Q=new f.Relay;return x.then(ne=>Q.input=ne.listen(W,H)),Q.event}}}e.getDelayedChannel=$;function q(x){let W=!1;return{call(H,Q,ne){return W?x.call(H,Q,ne):(0,A.timeout)(0).then(()=>W=!0).then(()=>x.call(H,Q,ne))},listen(H,Q){if(W)return x.listen(H,Q);const ne=new f.Relay;return(0,A.timeout)(0).then(()=>W=!0).then(()=>ne.input=x.listen(H,Q)),ne.event}}}e.getNextTickChannel=q;class ie{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const H of W.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await f.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=ie;var oe;(function(x){function W(re,Z){const _=re,P=Z&&Z.disableMarshalling,O=new Map;for(const F in _)Q(F)&&O.set(F,f.Event.buffer(_[F],!0));return new class{listen(F,B,N){const z=O.get(B);if(z)return z;if(ne(B)){const V=_[B];if(typeof V=="function")return V.call(_,N)}throw new Error(`Event not found: ${B}`)}call(F,B,N){const z=_[B];if(typeof z=="function"){if(!P&&Array.isArray(N))for(let V=0;V<N.length;V++)N[V]=(0,v.revive)(N[V]);return z.apply(_,N)}throw new Error(`Method not found: ${B}`)}}}x.fromService=W;function H(re,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(P,O){if(typeof O=="string")return Z?.properties?.has(O)?Z.properties.get(O):ne(O)?function(F){return re.listen(O,F)}:Q(O)?re.listen(O):async function(...F){let B;Z&&!(0,y.isUndefinedOrNull)(Z.context)?B=[Z.context,...F]:B=F;const N=await re.call(O,B);return _?N:(0,v.revive)(N)};throw new Error(`Property not found: ${String(O)}`)}})}x.toService=H;function Q(re){return re[0]==="o"&&re[1]==="n"&&p.isUpperAsciiLetter(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&p.isUpperAsciiLetter(re.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const W=x.toString();if(W!=="[object Object]")return W}return x}function ce(x){return Array.isArray(x)?x.map(he):he(x)}function K(x,W,H,Q,ne,re,Z){Z=ce(Z);const _=ae[ne],P=_[Q%_.length];let O=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(re)?(O=O.concat(Z),O.push(")")):O.push(Z),console.log.apply(console,O)}class Y{constructor(W,H){this._outgoingPrefix=W,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,H,Q,ne,re){this._totalOutgoing+=W,K(this._outgoingPrefix,this._totalOutgoing,W,H,Q,ne,re)}logIncoming(W,H,Q,ne,re){this._totalIncoming+=W,K(this._incomingPrefix,this._totalIncoming,W,H,Q,ne,re)}}e.IPCLogger=Y}),define(ee[155],te([0,1,17,3,47]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(f){this.port=f,this.onMessage=A.Event.fromDOMEventEmitter(this.port,"message",u=>I.VSBuffer.wrap(u.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class M extends r.IPCClient{constructor(f,u){const v=new L(f);super(v,u),this.protocol=v}dispose(){this.protocol.disconnect()}}e.Client=M}),define(ee[105],te([0,1,7,17,3,2,47]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(R){R.Created="created",R.Read="read",R.Write="write",R.Open="open",R.Error="error",R.Close="close",R.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",R.NodeEndReceived="nodeEndReceived",R.NodeEndSent="nodeEndSent",R.NodeDrainBegin="nodeDrainBegin",R.NodeDrainEnd="nodeDrainEnd",R.zlibInflateError="zlibInflateError",R.zlibInflateData="zlibInflateData",R.zlibInflateInitialWrite="zlibInflateInitialWrite",R.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",R.zlibInflateWrite="zlibInflateWrite",R.zlibInflateFlushFired="zlibInflateFlushFired",R.zlibDeflateError="zlibDeflateError",R.zlibDeflateData="zlibDeflateData",R.zlibDeflateWrite="zlibDeflateWrite",R.zlibDeflateFlushFired="zlibDeflateFlushFired",R.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",R.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",R.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",R.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",R.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",R.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",R.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",R.ProtocolHeaderRead="protocolHeaderRead",R.ProtocolMessageRead="protocolMessageRead",R.ProtocolHeaderWrite="protocolHeaderWrite",R.ProtocolMessageWrite="protocolMessageWrite",R.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(R){R.enableDiagnostics=!1,R.records=[];const T=new WeakMap;let U=0;function $(ie,oe){if(!T.has(ie)){const ae=String(++U);T.set(ie,ae)}return T.get(ie)}function q(ie,oe,ae,he){if(!R.enableDiagnostics)return;const ce=$(ie,oe);if(he instanceof A.VSBuffer||he instanceof Uint8Array||he instanceof ArrayBuffer||ArrayBuffer.isView(he)){const K=A.VSBuffer.alloc(he.byteLength);K.set(he),R.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,buff:K})}else R.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,data:he})}R.traceSocketEvent=q})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(R){R[R.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",R[R.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function p(){return v||(v=A.VSBuffer.alloc(0)),v}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(T){this._chunks.push(T),this._totalLength+=T.byteLength}read(T){return this._read(T,!0)}peek(T){return this._read(T,!1)}_read(T,U){if(T===0)return p();if(T>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===T){const oe=this._chunks[0];return U&&(this._chunks.shift(),this._totalLength-=T),oe}if(this._chunks[0].byteLength>T){const oe=this._chunks[0].slice(0,T);return U&&(this._chunks[0]=this._chunks[0].slice(T),this._totalLength-=T),oe}const $=A.VSBuffer.alloc(T);let q=0,ie=0;for(;T>0;){const oe=this._chunks[ie];if(oe.byteLength>T){const ae=oe.slice(0,T);$.set(ae,q),q+=T,U&&(this._chunks[ie]=oe.slice(T),this._totalLength-=T),T-=T}else $.set(oe,q),q+=oe.byteLength,U?(this._chunks.shift(),this._totalLength-=oe.byteLength):ie++,T-=oe.byteLength}return $}}e.ChunkStream=y;var h;(function(R){R[R.None=0]="None",R[R.Regular=1]="Regular",R[R.Control=2]="Control",R[R.Ack=3]="Ack",R[R.Disconnect=5]="Disconnect",R[R.ReplayRequest=6]="ReplayRequest",R[R.Pause=7]="Pause",R[R.Resume=8]="Resume",R[R.KeepAlive=9]="KeepAlive",R[R.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",R[R.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function E(R){switch(R){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var S;(function(R){R[R.HeaderLength=13]="HeaderLength",R[R.AcknowledgeTime=2e3]="AcknowledgeTime",R[R.TimeoutTime=2e4]="TimeoutTime",R[R.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",R[R.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",R[R.KeepAliveSendTime=5e3]="KeepAliveSendTime",R[R.LatencySampleTime=6e4]="LatencySampleTime",R[R.LatencySampleCount=5]="LatencySampleCount",R[R.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",R[R.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class s{constructor(T,U,$,q){this.type=T,this.id=U,this.ack=$,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.Disposable{constructor(T){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=T,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(U=>this.acceptChunk(U))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(T);this._incomingData.byteLength>=this._state.readLen;){const U=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=U.readUInt32BE(9),this._state.messageType=U.readUInt8(0),this._state.id=U.readUInt32BE(1),this._state.ack=U.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const $=this._state.messageType,q=this._state.id,ie=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",U),this._onMessage.fire(new s($,q,ie,U)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(T){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=T,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(T){if(this._isDisposed)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const U=A.VSBuffer.alloc(13);U.writeUInt8(T.type,0),U.writeUInt32BE(T.id,1),U.writeUInt32BE(T.ack,5),U.writeUInt32BE(T.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",T.data),this._writeSoon(U,T.data)}_bufferAdd(T,U){const $=this._totalLength===0;return this._data.push(T,U),this._totalLength+=T.byteLength+U.byteLength,$}_bufferTake(){const T=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,T}_writeSoon(T,U){this._bufferAdd(T,U)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const T=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this._socket.write(T)}}class b extends L.Disposable{constructor(T){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=T,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(U=>{U.type===1&&this._onMessage.fire(U.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(T){this._socketWriter.write(new s(1,0,0,T))}}e.Protocol=b;class w extends M.IPCClient{static fromSocket(T,U){return new w(new b(T),U)}get onDidDispose(){return this.protocol.onDidDispose}constructor(T,U,$=null){super(T,U,$),this.protocol=T}dispose(){super.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end()}}e.Client=w;class D{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(T){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(T):this._emitter.fire(T):this._bufferedMessages.push(T)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=D;class t{constructor(T){this.data=T,this.next=null}}class l{constructor(){this._first=null,this._last=null}length(){let T=0,U=this._first;for(;U;)U=U.next,T++;return T}peek(){return this._first?this._first.data:null}toArray(){const T=[];let U=0,$=this._first;for(;$;)T[U++]=$.data,$=$.next;return T}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(T){const U=new t(T);if(!this._first){this._first=U,this._last=U;return}this._last.next=U,this._last=U}}class i{static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}constructor(){this.lastRuns=[];const T=Date.now();for(let U=0;U<i._HISTORY_LENGTH;U++)this.lastRuns[U]=T-1e3*U;setInterval(()=>{for(let U=i._HISTORY_LENGTH;U>=1;U--)this.lastRuns[U]=this.lastRuns[U-1];this.lastRuns[0]=Date.now()},1e3)}load(){const T=Date.now(),U=(1+i._HISTORY_LENGTH)*1e3;let $=0;for(let q=0;q<i._HISTORY_LENGTH;q++)T-this.lastRuns[q]<=U&&$++;return 1-$/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;var n;(function(R){R[R.Good=0]="Good",R[R.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function a(R){switch(R){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class o{constructor(T,U){this.roundTripTime=T,this.recentHighRoundTripCount=U}}e.HighRoundTripTimeEvent=o;class m{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(T){this._onControlMessage=new D,this.onControlMessage=this._onControlMessage.event,this._onMessage=new D,this.onMessage=this._onMessage.event,this._onDidDispose=new D,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new D,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new D,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new D,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new D,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=T.loadEstimator??i.getInstance(),this._measureRoundTripTime=T.measureRoundTripTime??!1,this._shouldSendKeepAlive=T.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new L.DisposableStore,this._socket=T.socket,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(U=>this._receiveMessage(U))),this._socketDisposables.add(this._socket.onClose(U=>this._onSocketClose.fire(U))),this._socketLatencyMonitor=this._socketDisposables.add(new C),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(U=>this._sendLatencyMeasurementRequest(U))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(U=>this._onHighRoundTripTime.fire(U))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(U=>this._onDidChangeConnectionHealth.fire(U))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),T.initialChunk&&this._socketReader.acceptChunk(T.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const T=new s(5,0,0,p());this._socketWriter.write(T),this._socketWriter.flush()}sendPause(){const T=new s(7,0,0,p());this._socketWriter.write(T)}sendResume(){const T=new s(8,0,0,p());this._socketWriter.write(T)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(T,U){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new L.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=T,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage($=>this._receiveMessage($))),this._socketDisposables.add(this._socket.onClose($=>this._onSocketClose.fire($))),this._socketLatencyMonitor=this._socketDisposables.add(new C),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest($=>this._sendLatencyMeasurementRequest($))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime($=>this._onHighRoundTripTime.fire($))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth($=>this._onDidChangeConnectionHealth.fire($))),this._socketReader.acceptChunk(U)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const T=new s(3,0,this._incomingAckId,p());this._socketWriter.write(T);const U=this._outgoingUnackMsg.toArray();for(let $=0,q=U.length;$<q;$++)this._socketWriter.write(U[$]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(T){if(T.ack>this._outgoingAckId){this._outgoingAckId=T.ack;do{const U=this._outgoingUnackMsg.peek();if(U&&U.id<=T.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this._incomingMsgId)if(T.id!==this._incomingMsgId+1){const U=Date.now();U-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=U,this._socketWriter.write(new s(6,0,0,p())))}else this._incomingMsgId=T.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(T.data);break}case 2:{this._onControlMessage.fire(T.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const U=this._outgoingUnackMsg.toArray();for(let $=0,q=U.length;$<q;$++)this._socketWriter.write(U[$]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(T.data);break}case 11:{this._socketLatencyMonitor.handleResponse(T.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(T){const U=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const $=new s(1,U,this._incomingAckId,T);this._outgoingUnackMsg.push($),this._isReconnecting||(this._socketWriter.write($),this._recvAckCheck())}sendControl(T){const U=new s(2,0,0,T);this._socketWriter.write(U)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const T=Date.now()-this._incomingMsgLastTime;if(T>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-T+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const T=this._outgoingUnackMsg.peek(),U=Date.now()-T.writtenTime,$=Date.now()-this._socketReader.lastReadTime,q=Date.now()-this._lastSocketTimeoutTime;if(U>=2e4&&$>=2e4&&q>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:U,timeSinceLastReceivedSomeData:$});return}const ie=Math.max(2e4-U,2e4-$,2e4-q,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},ie)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const T=new s(3,0,this._incomingAckId,p());this._socketWriter.write(T)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const T=new s(9,0,this._incomingAckId,p());this._socketWriter.write(T)}_sendLatencyMeasurementRequest(T){this._incomingAckId=this._incomingMsgId;const U=new s(10,0,this._incomingAckId,T);this._socketWriter.write(U)}_sendLatencyMeasurementResponse(T){this._incomingAckId=this._incomingMsgId;const U=new s(11,0,this._incomingAckId,T);this._socketWriter.write(U)}}e.PersistentProtocol=m;class C extends L.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new r.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new r.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new r.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new I.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},T=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const T=++this._lastLatencyMeasurementId,U=A.VSBuffer.alloc(4);U.writeUInt32BE(T,0),this._onSendLatencyRequest.fire(U)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const U=T.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||U!==this._lastLatencyMeasurementId)return;const $=Date.now()-this._lastLatencyMeasurementSent,q=this._latencySampleIndex++;this._latencySamples[q%this._latencySamples.length]=$;const ie=this._connectionHealth,oe=this._latencySamples.filter(ae=>ae>=1e3).length;this._connectionHealth=oe>=3?1:0,$>1e3&&this._onHighRoundTripTime.fire(new o($,oe)),ie!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(ee[156],te([0,1,42,17,3,2,47,141]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(v,p){const y=r.Event.fromNodeEventEmitter(I.validatedIpcMain,p,(E,S)=>({event:E,message:S})),h=r.Event.filter(y,({event:E})=>E.sender.id===v);return r.Event.map(h,({message:E})=>E&&A.VSBuffer.wrap(E))}class u extends M.IPCServer{static getOnDidClientConnect(){const p=r.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:y})=>y);return r.Event.map(p,y=>{const h=y.id;u.Clients.get(h)?.dispose();const S=new r.Emitter;u.Clients.set(h,(0,L.toDisposable)(()=>S.fire()));const s=f(h,"vscode:message"),g=r.Event.any(r.Event.signal(f(h,"vscode:disconnect")),S.event);return{protocol:new k.Protocol(y,s),onDidClientDisconnect:g}})}constructor(){super(u.getOnDidClientConnect())}}u.Clients=new Map,e.Server=u}),define(ee[106],te([0,1,42,3,31,155]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends L.Client{constructor(u,v){super({addEventListener:(p,y)=>u.addListener(p,y),removeEventListener:(p,y)=>u.removeListener(p,y),postMessage:p=>u.postMessage(p),start:()=>u.start(),close:()=>u.close()},v)}}e.Client=M;async function k(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,r.generateUuid)();f.webContents.send("vscode:createMessageChannel",u);const v=A.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:p}=await A.Event.toPromise(A.Event.once(A.Event.filter(v,y=>y.nonce===u)));return p}e.connect=k}),define(ee[157],te([0,1,46,7,17,23,150,13,3,2,37,87,73,47]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends h.ChannelServer{constructor(g){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",d=>r.VSBuffer.wrap(Buffer.from(d,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=E;class S{constructor(g,d){this.modulePath=g,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new A.Delayer(b),this.child=null,this._client=null}getChannel(g){const d=this;return{call(b,w,D){return d.requestPromise(g,b,w,D)},listen(b,w){return d.requestEvent(g,b,w)}}}requestPromise(g,d,b,w=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const D=this.getCachedChannel(g),t=(0,A.createCancelablePromise)(n=>D.call(d,b,n)),l=w.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{l.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,d,b){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let w;const D=new f.Emitter({onWillAddFirstListener:()=>{w=this.getCachedChannel(g).listen(d,b)(D.fire,D),this.activeRequests.add(w)},onDidRemoveLastListener:()=>{this.activeRequests.delete(w),w.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return D.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(d.env),this.child=(0,I.fork)(this.modulePath,g,d);const b=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,M.isRemoteConsoleLog)(a)){(0,M.log)(a,`IPC Library: ${this.options.serverName}`);return}b.fire(r.VSBuffer.wrap(Buffer.from(a,"base64")))});const D=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&D.send(a.buffer.toString("base64")),l=b.event,i={send:t,onMessage:l};this._client=new h.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,u.dispose)(o)),this.activeRequests.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:c})})}return this._client}getCachedChannel(g){let d=this.channels.get(g);return d||(d=this.client.getChannel(g),this.channels.set(g,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ee[88],te([0,1,17,13,3,2,9,4,31,47,105]),function(j,e,I,A,r,L,M,k,f,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function p(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(o,m){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,m)}constructor(o,m=""){this._canWrite=!0,this.debugLabel=m,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,A.onUnexpectedError)(C)}},this.socket.on("error",this._errorListener),this._closeListener=C=>{this.traceSocketEvent("close",{hadError:C}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const m=C=>{this.traceSocketEvent("read",C),o(I.VSBuffer.wrap(C))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(o){const m=C=>{o({type:0,hadError:C,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(o){const m=()=>{o()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=y;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize",c[c.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var E;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(E||(E={}));class S extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,m){this.socket.traceSocketEvent(o,m)}constructor(o,m,C,R){super(),this._onData=this._register(new r.Emitter),this._onClose=this._register(new r.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:C?.byteLength||0,recordInflateBytes:R}),this._flowManager=this._register(new s(this,m,C,R,this._onData,(T,U)=>this._write(T,U))),this._register(this._flowManager.onError(T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(async T=>{this._flowManager.isProcessingReadQueue()&&await r.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(T)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){let m=0;for(;m<o.byteLength;)this._flowManager.writeMessage(o.slice(m,Math.min(m+262144,o.byteLength))),m+=262144}_write(o,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let C=2;o.byteLength<126?C+=0:o.byteLength<2**16?C+=2:C+=8;const R=I.VSBuffer.alloc(C);if(m?R.writeUInt8(194,0):R.writeUInt8(130,0),o.byteLength<126)R.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){R.writeUInt8(126,1);let T=1;R.writeUInt8(o.byteLength>>>8&255,++T),R.writeUInt8(o.byteLength>>>0&255,++T)}else{R.writeUInt8(127,1);let T=1;R.writeUInt8(0,++T),R.writeUInt8(0,++T),R.writeUInt8(0,++T),R.writeUInt8(0,++T),R.writeUInt8(o.byteLength>>>24&255,++T),R.writeUInt8(o.byteLength>>>16&255,++T),R.writeUInt8(o.byteLength>>>8&255,++T),R.writeUInt8(o.byteLength>>>0&255,++T)}this.socket.write(I.VSBuffer.concat([R,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),C=m.readUInt8(0),R=(C&128)>>>7,T=(C&64)>>>6,U=m.readUInt8(1),$=(U&128)>>>7,q=U&127;this._state.state=2,this._state.readLen=2+($?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),C=m.readUInt8(1),R=(C&128)>>>7;let T=C&127,U=1;T===126?T=m.readUInt8(++U)*2**8+m.readUInt8(++U):T===127&&(T=m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U));let $=0;R&&($=m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U)),this._state.state=3,this._state.readLen=T,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),b(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await r.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class s extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,m,C,R,T,U){super(),this._tracer=o,this._onData=T,this._writeFn=U,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new r.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new r.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new g(this._tracer,R,C,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(m,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,m){return new Promise((C,R)=>{o.write(m),o.flush(T=>C(T))})}acceptFrame(o,m,C){this._readQueue.push({data:o,isCompressed:m,isLastFrameOfMessage:C}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(o,m,C){return new Promise((R,T)=>{o.write(m),C&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(U=>R(U))})}}class g extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.concat(this._recordedInflateBytes):I.VSBuffer.alloc(0)}constructor(o,m,C,R){super(),this._tracer=o,this._recordInflateBytes=m,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p().zlib.createInflateRaw(R),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(I.VSBuffer.wrap(T))}),C&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this._zlibInflate.write(C.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=I.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(m)})}}class d extends L.Disposable{constructor(o,m){super(),this._tracer=o,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this._onError.fire(C)}),this._zlibDeflate.on("data",C=>{this._tracer.traceSocketEvent("zlibDeflateData",C),this._pendingDeflateData.push(I.VSBuffer.wrap(C))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=I.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),o(m)})}}function b(c,o){if(o===0)return;const m=c.byteLength>>>2;for(let q=0;q<m;q++){const ie=c.readUInt32BE(q*4);c.writeUInt32BE(ie^o,q*4)}const C=m*4,R=c.byteLength-C,T=o>>>24&255,U=o>>>16&255,$=o>>>8&255;R>=1&&c.writeUInt8(c.readUInt8(C)^T,C),R>=2&&c.writeUInt8(c.readUInt8(C+1)^U,C+1),R>=3&&c.writeUInt8(c.readUInt8(C+2)^$,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const w={[2]:107,[1]:103};function D(){const c=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;const o=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:p().os.tmpdir(),m=(0,M.join)(o,`vscode-ipc-${c}.sock`);return l(m),m}e.createRandomIPCHandle=D;function t(c,o,m){const C=p().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${m}-${o}-sock`;const R=m.substr(0,4),T=o.substr(0,6),U=C.substr(0,8);let $;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?$=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${U}-${R}-${T}.sock`):$=(0,M.join)(c,`${R}-${T}.sock`),l($),$}e.createStaticIPCHandle=t;function l(c){const o=w[k.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends u.IPCServer{static toClientConnectionEvent(o){const m=r.Event.fromNodeEventEmitter(o,"connection");return r.Event.map(m,C=>({protocol:new v.Protocol(new y(C,"ipc-server-connection")),onDidClientDisconnect:r.Event.once(r.Event.fromNodeEventEmitter(C,"close"))}))}constructor(o){super(i.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(c){return new Promise((o,m)=>{const C=p().net.createServer();C.on("error",m),C.listen(c,()=>{C.removeListener("error",m),o(new i(C))})})}e.serve=n;function a(c,o){return new Promise((m,C)=>{const R=p().net.createConnection(c,()=>{R.removeListener("error",C),m(v.Client.fromSocket(new y(R,`ipc-client${o}`),o))});R.once("error",C)})}e.connect=a}),define(ee[107],te([0,1,7,3,2,11]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M=e.StorageHint||(e.StorageHint={}));function k(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var f;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class u extends r.Disposable{constructor(y,h=Object.create(null)){super(),this.database=y,this.options=h,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((h,E)=>this.accept(E,h)),y.deleted?.forEach(h=>this.accept(h,void 0))}accept(y,h){if(this.state===f.Closed)return;let E=!1;(0,L.isUndefinedOrNull)(h)?E=this.cache.delete(y):this.cache.get(y)!==h&&(this.cache.set(y,h),E=!0),E&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,h){const E=this.cache.get(y);return(0,L.isUndefinedOrNull)(E)?h:E}getBoolean(y,h){const E=this.get(y);return(0,L.isUndefinedOrNull)(E)?h:E==="true"}getNumber(y,h){const E=this.get(y);return(0,L.isUndefinedOrNull)(E)?h:parseInt(E,10)}async set(y,h){if(this.state===f.Closed)return;if((0,L.isUndefinedOrNull)(h))return this.delete(y);const E=String(h);if(this.cache.get(y)!==E)return this.cache.set(y,E),this.pendingInserts.set(y,E),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===f.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}isInMemory(){return this.options.hint===M.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}u.DEFAULT_FLUSH_DELAY=100,e.Storage=u;class v{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((h,E)=>this.items.set(E,h)),y.delete?.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=v}),define(ee[158],te([0,1,7,3,35,9,24]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return A.Event.None}constructor(v,p=Object.create(null)){this.path=v,this.options=p,this.name=(0,L.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,p=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(h=>p.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${p.size} rows`),p}async updateItems(v){const p=await this.whenConnected;return this.doUpdateItems(p,v)}doUpdateItems(v,p){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${p.insert?(0,r.mapToString)(p.insert):"0"}), delete(${p.delete?(0,r.setToString)(p.delete):"0"})`),this.transaction(v,()=>{const y=p.insert,h=p.delete;if(y&&y.size>0){const E=[];E.push([]);let S=0;y.forEach((s,g)=>{let d=E[S];d.length>k.MAX_HOST_PARAMETERS&&(S++,d=[],E.push(d)),d.push(g,s)}),E.forEach(s=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(s.length/2).fill("(?,?)").join(",")}`,g=>g.run(s),()=>{const g=[];let d=0;return y.forEach((b,w)=>{g.push(w),d+=b.length}),`Keys: ${g.join(", ")} Length: ${d}`})})}if(h&&h.size){const E=[];E.push([]);let S=0;h.forEach(s=>{let g=E[S];g.length>k.MAX_HOST_PARAMETERS&&(S++,g=[],E.push(g)),g.push(s)}),E.forEach(s=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(s.length).fill("?").join(",")})`,g=>g.run(s),()=>{const g=[];return h.forEach(d=>{g.push(d)}),`Keys: ${g.join(", ")}`})})}})}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const p=await this.whenConnected;return this.doClose(p,v)}doClose(v,p){return new Promise((y,h)=>{v.db.close(E=>(E&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${E}`),this.path===k.IN_MEMORY_PATH?y():!v.isErroneous&&!v.isInMemory?this.backup().then(y,S=>(this.logger.error(`[storage ${this.name}] backup(): ${S}`),y())):typeof p=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(S=>{const s=()=>this.doClose(S,void 0);return this.doUpdateItems(S,{insert:p()}).then(()=>s(),g=>(s(),Promise.reject(g)))})).then(y,h):h(E||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return M.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const p=await this.whenConnected,y=await this.get(p,v?"PRAGMA integrity_check":"PRAGMA quick_check"),h=v?y.integrity_check:y.quick_check;return p.isErroneous?`${h} (last error: ${p.lastError})`:p.isInMemory?`${h} (in-memory!)`:h}async connect(v,p=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${p})`);try{return await this.doConnect(v)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&p)return await(0,I.timeout)(k.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await M.Promises.unlink(v);try{await M.Promises.rename(this.toBackupPath(v),v)}catch{}return await this.doConnect(v)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(k.IN_MEMORY_PATH)}}}handleSQLiteError(v,p){v.isErroneous=!0,v.lastError=p,this.logger.error(p)}doConnect(v){return new Promise((p,y)=>{new Promise((h,E)=>{j(["@vscode/sqlite3"],h,E)}).then(h=>{const E={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(v,S=>S?E.db&&S.code!=="SQLITE_CANTOPEN"?E.db.close(()=>y(S)):y(S):this.exec(E,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(E),s=>E.db.close(()=>y(s)))),isInMemory:v===k.IN_MEMORY_PATH};E.db.on("error",S=>this.handleSQLiteError(E,`[storage ${this.name}] Error (event): ${S}`)),this.logger.isTracing&&E.db.on("trace",S=>this.logger.trace(`[storage ${this.name}] Trace (event): ${S}`))},y)})}exec(v,p){return new Promise((y,h)=>{v.db.exec(p,E=>E?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${E}`),h(E)):y())})}get(v,p){return new Promise((y,h)=>{v.db.get(p,(E,S)=>E?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${E}`),h(E)):y(S))})}all(v,p){return new Promise((y,h)=>{v.db.all(p,(E,S)=>E?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${E}`),h(E)):y(S))})}transaction(v,p){return new Promise((y,h)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),p(),v.db.run("END TRANSACTION",E=>E?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${E}`),h(E)):y())})})}prepare(v,p,y,h){const E=v.db.prepare(p),S=s=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${s} (${p}). Details: ${h()}`)};E.on("error",S),y(E),E.finalize(s=>{s&&S(s),E.removeListener("error",S)})}}k.IN_MEMORY_PATH=":memory:",k.BUSY_OPEN_TIMEOUT=2e3,k.MAX_HOST_PARAMETERS=256,e.SQLiteStorageDatabase=k;class f{constructor(v){v&&typeof v.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[159],te([12,10]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(ee[160],te([12,10]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[161],te([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[162],te([12,10]),function(j,e){return j.create("vs/platform/contextkey/common/scanner",e)}),define(ee[163],te([12,10]),function(j,e){return j.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[164],te([12,10]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[165],te([12,10]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(ee[166],te([12,10]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(ee[167],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[168],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[169],te([12,10]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[170],te([12,10]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[171],te([12,10]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[172],te([12,10]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(ee[173],te([12,10]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(ee[174],te([12,10]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(ee[175],te([12,10]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[176],te([12,10]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[177],te([12,10]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[178],te([12,10]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[179],te([12,10]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[180],te([12,10]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(ee[181],te([12,10]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(ee[182],te([12,10]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[183],te([12,10]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[184],te([12,10]),function(j,e){return j.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[185],te([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[186],te([12,10]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[187],te([12,10]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(ee[188],te([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[189],te([12,10]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[190],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function A(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=A}),define(ee[191],te([0,1,8]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function A(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=A;function r(M){let k=[];try{Array.isArray(M.workspaces)&&(k=M.workspaces.map(f=>({workspace:{id:f.id,configPath:I.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=r;function L(M){let k=[];try{Array.isArray(M.folders)&&(k=M.folders.map(f=>({folderUri:I.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=L}),define(ee[192],te([0,1,13,162]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(r=e.TokenType||(e.TokenType={}));function L(...u){switch(u.length){case 1:return(0,A.localize)(0,null,u[0]);case 2:return(0,A.localize)(1,null,u[0],u[1]);case 3:return(0,A.localize)(2,null,u[0],u[1],u[2]);default:return}}const M=(0,A.localize)(3,null),k=(0,A.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(v){return this._input=v,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const p=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:p})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const p=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:p})}else this._match(126)?this._addToken(9):this._error(L("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(L("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(v){return this._isAtEnd()||this._input.charCodeAt(this._current)!==v?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(v){this._tokens.push({type:v,offset:this._start})}_error(v){const p=this._start,y=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:y};this._errors.push({offset:p,lexeme:y,additionalInfo:v}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const v=this.stringRe.exec(this._input);if(v){this._current=this._start+v[0].length;const p=this._input.substring(this._start,this._current),y=f._keywords.get(p);y?this._addToken(y):this._tokens.push({type:17,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let v=this._current,p=!1,y=!1;for(;;){if(v>=this._input.length){this._current=v,this._error(k);return}const E=this._input.charCodeAt(v);if(p)p=!1;else if(E===47&&!y){v++;break}else E===91?y=!0:E===92?p=!0:E===93&&(y=!1);v++}for(;v<this._input.length&&f._regexFlags.has(this._input.charCodeAt(v));)v++;this._current=v;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}f._regexFlags=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0))),f._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=f}),define(ee[193],te([0,1,3,2]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(k,f,u){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(k,f,u){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}r.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=r;class L extends A.Disposable{constructor(k){super(),this.channel=k}reload(k){this.channel.call("reload",[k])}get onReload(){return this.channel.listen("reload")}close(k){this.channel.call("close",[k])}get onClose(){return this.channel.listen("close")}attachSession(k,f,u){this.channel.call("attach",[k,f,u])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(k,f){this.channel.call("terminate",[k,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(k,f){return this.channel.call("openExtensionDevelopmentHostWindow",[k,f])}}e.ExtensionHostDebugChannelClient=L}),define(ee[194],te([0,1,144,55,14,9,36,18,8]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,L.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(f.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?f.URI.file((0,L.join)(h,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.resolve)(h):(0,L.normalize)((0,L.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,L.resolve)(h)):f.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.resolve)(h);const E=M.env.VSCODE_EXTENSIONS;if(E)return E;const S=M.env.VSCODE_PORTABLE;return S?(0,L.join)(S,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(E=>/^[^:/?#]+?:\/\//.test(E)?f.URI.parse(E):f.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,L.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const E of this.args.log||[]){const S=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);S&&S[1]&&S[2]&&h.push([S[1],S[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=M.env.VSCODE_PORTABLE;return h?f.URI.file((0,L.join)(h,"policy.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,E,S){this._args=h,this.paths=E,this.productService=S,this.editSessionId=this.args.editSessionId}}we([A.memoize],u.prototype,"appRoot",null),we([A.memoize],u.prototype,"userHome",null),we([A.memoize],u.prototype,"userDataPath",null),we([A.memoize],u.prototype,"appSettingsHome",null),we([A.memoize],u.prototype,"tmpDir",null),we([A.memoize],u.prototype,"cacheHome",null),we([A.memoize],u.prototype,"stateResource",null),we([A.memoize],u.prototype,"userRoamingDataHome",null),we([A.memoize],u.prototype,"userDataSyncHome",null),we([A.memoize],u.prototype,"sync",null),we([A.memoize],u.prototype,"machineSettingsResource",null),we([A.memoize],u.prototype,"workspaceStorageHome",null),we([A.memoize],u.prototype,"localHistoryHome",null),we([A.memoize],u.prototype,"keyboardLayoutResource",null),we([A.memoize],u.prototype,"argvResource",null),we([A.memoize],u.prototype,"isExtensionDevelopment",null),we([A.memoize],u.prototype,"untitledWorkspacesHome",null),we([A.memoize],u.prototype,"builtinExtensionsPath",null),we([A.memoize],u.prototype,"extensionsPath",null),we([A.memoize],u.prototype,"extensionDevelopmentLocationURI",null),we([A.memoize],u.prototype,"extensionDevelopmentKind",null),we([A.memoize],u.prototype,"extensionTestsLocationURI",null),we([A.memoize],u.prototype,"debugExtensionHost",null),we([A.memoize],u.prototype,"logLevel",null),we([A.memoize],u.prototype,"extensionLogLevel",null),we([A.memoize],u.prototype,"serviceMachineIdResource",null),we([A.memoize],u.prototype,"disableTelemetry",null),we([A.memoize],u.prototype,"disableWorkspaceTrust",null),we([A.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function v(y,h){return p(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=v;function p(y,h,E,S,s,g){const b=Number(h||y)||(S?null:E),w=b?Boolean(!!h):!1;let D;if(g)try{D=JSON.parse(g)}catch{}return{port:b,break:w,debugId:s,env:D}}e.parseDebugParams=p}),define(ee[108],te([0,1,291,4,165]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,r.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(S,s,g=M){const d=S.find(c=>c.length>0&&c[0]!=="-"),b={},w=["_"],D=[],t={};let l;for(const c in s){const o=s[c];o.type==="subcommand"?c===d&&(l=o):(o.alias&&(b[c]=o.alias),o.type==="string"||o.type==="string[]"?(w.push(c),o.deprecates&&w.push(...o.deprecates)):o.type==="boolean"&&(D.push(c),o.deprecates&&D.push(...o.deprecates)),o.global&&(t[c]=o))}if(l&&d){const c=t;for(const R in l.options)c[R]=l.options[R];const o=S.filter(R=>R!==d),m=g.getSubcommandReporter?g.getSubcommandReporter(d):void 0,C=k(o,c,m);return{[d]:C,_:[]}}const i=I(S,{string:w,boolean:D,alias:b}),n={},a=i;n._=i._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in s){const o=s[c];if(o.type==="subcommand")continue;o.alias&&delete a[o.alias];let m=a[c];if(o.deprecates)for(const C of o.deprecates)a.hasOwnProperty(C)&&(m||(m=a[C],m&&g.onDeprecatedOption(C,o.deprecationMessage||(0,r.localize)(36,null,c))),delete a[C]);if(typeof m<"u"){if(o.type==="string[]"){if(Array.isArray(m)||(m=[m]),!o.allowEmptyValue){const C=m.filter(R=>R.length>0);C.length!==m.length&&(g.onEmptyValue(c),m=C.length>0?C:void 0)}}else o.type==="string"&&(Array.isArray(m)?(m=m.pop(),g.onMultipleValues(c,m)):!m&&!o.allowEmptyValue&&(g.onEmptyValue(c),m=void 0));n[c]=m,o.deprecationMessage&&g.onDeprecatedOption(c,o.deprecationMessage)}delete a[c]}for(const c in a)g.onUnknownOption(c);return n}e.parseArgs=k;function f(S,s){let g="";return s.args&&(Array.isArray(s.args)?g=` <${s.args.join("> <")}>`:g=` <${s.args}>`),s.alias?`-${s.alias} --${S}${g}`:`--${S}${g}`}function u(S,s){const g=[];for(const d in S){const b=S[d],w=f(d,b);g.push([w,b.description])}return v(g,s)}e.formatOptions=u;function v(S,s){const d=S.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(s-d<25)return S.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=s-d-1,w=[];for(const D of S){const t=D[0],l=y(D[1],b),i=p(d-t.length-2);w.push("  "+t+i+l[0]);for(let n=1;n<l.length;n++)w.push(p(d)+l[n])}return w}function p(S){return" ".repeat(S)}function y(S,s){const g=[];for(;S.length;){const d=S.length<s?S.length:S.lastIndexOf(" ",s),b=S.slice(0,d).trim();S=S.slice(d),g.push(b)}return g}function h(S,s,g,d,b){const w=process.stdout.isTTY&&process.stdout.columns||80,D=b?.noInputFiles!==!0?`[${(0,r.localize)(37,null)}...]`:"",t=[`${S} ${g}`];t.push(""),t.push(`${(0,r.localize)(38,null)}: ${s} [${(0,r.localize)(39,null)}]${D}`),t.push(""),b?.noPipe!==!0&&(A.isWindows?t.push((0,r.localize)(40,null,s)):t.push((0,r.localize)(41,null,s)),t.push(""));const l={},i=[];for(const n in d){const a=d[n];if(a.type==="subcommand")a.description&&i.push({command:n,description:a.description});else if(a.description&&a.cat){let c=l[a.cat];c||(l[a.cat]=c={}),c[n]=a}}for(const n in l){const a=n,c=l[a];c&&(t.push(L[a]),t.push(...u(c,w)),t.push(""))}return i.length&&(t.push((0,r.localize)(42,null)),t.push(...v(i.map(n=>[n.command,n.description]),w)),t.push("")),t.join(`
`)}e.buildHelpMessage=h;function E(S,s){return`${S||(0,r.localize)(43,null)}
${s||(0,r.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=E}),define(ee[195],te([0,1,84,193,108]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends A.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.windowsMainService=k}call(k,f,u){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(u[0],u[1]):super.call(k,f,u)}async openExtensionDevelopmentHostWindow(k,f){const u=(0,r.parseArgs)(k,r.OPTIONS);u.debugRenderer=f;const v=u.extensionDevelopmentPath;if(!v)return{success:!1};const[p]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const y=p.win;if(!y)return{success:!0};const h=y.webContents.debugger;let E=h.isAttached()?1/0:0;const S=(0,I.createServer)(s=>{E++===0&&h.attach();let g=!1;const d=D=>{g||s.write(JSON.stringify(D)+"\0")},b=(D,t,l,i)=>d({method:t,params:l,sessionId:i});y.on("close",()=>{h.removeListener("message",b),s.end(),g=!0}),h.addListener("message",b);let w=Buffer.alloc(0);s.on("data",D=>{w=Buffer.concat([w,D]);for(let t=w.indexOf(0);t!==-1;t=w.indexOf(0)){let l;try{const i=w.slice(0,t).toString("utf8");w=w.slice(t+1),l=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(l.method,l.params,l.sessionId).then(i=>d({id:l.id,sessionId:l.sessionId,result:i})).catch(i=>d({id:l.id,sessionId:l.sessionId,error:{code:0,message:i.message}}))}}),s.on("error",D=>{console.error("error on cdp pipe:",D)}),s.on("close",()=>{g=!0,--E===0&&h.detach()})});return await new Promise(s=>S.listen(0,s)),y.on("close",()=>S.close()),{rendererDebugPort:S.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(ee[62],te([0,1,292,166,108]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function M(y,h){const E=(w,D)=>{console.warn((0,A.localize)(0,null,w,D))},S=w=>{console.warn((0,A.localize)(1,null,w))},s=(w,D)=>{console.warn((0,A.localize)(2,null,w,D))},g=w=>({onUnknownOption:D=>{w!=="tunnel"&&console.warn((0,A.localize)(3,null,D,w))},onMultipleValues:E,onEmptyValue:S,onDeprecatedOption:s,getSubcommandReporter:w!=="tunnel"?g:void 0}),d={onUnknownOption:w=>{console.warn((0,A.localize)(4,null,w))},onMultipleValues:E,onEmptyValue:S,onDeprecatedOption:s,getSubcommandReporter:g},b=(0,r.parseArgs)(y,r.OPTIONS,h?d:void 0);return b.goto&&b._.forEach(w=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,A.localize)(5,null))),b["max-memory"]&&I(parseInt(b["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),b}function k(y){const h=y.findIndex(E=>!/^-/.test(E));if(h>-1)return[...y.slice(0,h),...y.slice(h+1)]}function f(y){let[,...h]=y;process.env.VSCODE_DEV&&(h=k(h)||[]);const E=!p(process.env);return M(h,E)}e.parseMainProcessArgv=f;function u(y){let[,,...h]=y;return process.env.VSCODE_DEV&&(h=k(h)||[]),M(h,!0)}e.parseCLIProcessArgv=u;function v(y,...h){const E=y.indexOf("--");return E===-1?y.push(...h):y.splice(E,0,...h),y}e.addArg=v;function p(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function j(e,I,A){function r(M,k){const f=L(M,k),u=[f];return e.isAbsolute(f)||u.unshift(A),e.resolve(...u)}function L(M,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,k);const v=M["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(p,"AppData","Roaming")}break;case"darwin":u=e.join(I.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,k)}return{getUserDataPath:r}}if(typeof define=="function")define(ee[109],te([196,27,36]),function(e,I,A){return j(e,I,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=j(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[110],te([0,1,27,194,109]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class L extends A.AbstractNativeEnvironmentService{constructor(u,v){super(u,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,r.getUserDataPath)(u,v.nameShort)},v)}}e.NativeEnvironmentService=L;function M(f,u){return(0,A.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.parsePtyHostDebugPort=M;function k(f,u){return(0,A.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(ee[197],te([0,1,41,27,32]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function L(M){const k=(0,r.randomPath)((0,A.tmpdir)());try{return(0,I.writeFileSync)(k,""),M&&console.log(`Marker file for --wait created: ${k}`),k}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=L}),define(ee[198],te([0,1,11,168]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,k,f){try{L(M,k,f)}catch(u){console.error(u?.message??u)}return M}e.localizeManifest=r;function L(M,k,f){const u=(v,p,y)=>{const h=v[p];if((0,I.isString)(h)){const E=h,S=E.length;if(S>1&&E[0]==="%"&&E[S-1]==="%"){const s=E.substr(1,S-2);let g=k[s];g===void 0&&f&&(g=f[s]);const d=typeof g=="string"?g:g?.message,b=f?.[s],w=typeof b=="string"?b:b?.message;if(!d){w||console.warn(`[${M.name}]: ${(0,A.localize)(0,null,s)}`);return}if(y&&(p==="title"||p==="category")&&w&&w!==d){const D={value:d,original:w};v[p]=D}else v[p]=d}}else if((0,I.isObject)(h))for(const E in h)h.hasOwnProperty(E)&&(E==="commands"?u(h,E,!0):u(h,E,y));else if(Array.isArray(h))for(let E=0;E<h.length;E++)u(h,E,y)};for(const v in M)M.hasOwnProperty(v)&&u(M,v)}}),define(ee[199],te([0,1,18,75,170,200]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||M.test(g)}e.isValidVersionStr=f;function u(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=g.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=u;function v(g){if(!g)return null;const d=g.majorBase,b=g.majorMustEqual,w=g.minorBase;let D=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(d===0||(D=!1),l=!1);let i=0;if(g.preRelease){const n=k.exec(g.preRelease);if(n){const[,a,c,o]=n;i=Date.UTC(Number(a),Number(c)-1,Number(o))}}return{majorBase:d,majorMustEqual:b,minorBase:w,minorMustEqual:D,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=v;function p(g,d,b){let w;typeof g=="string"?w=v(u(g)):w=g;let D;d instanceof Date?D=d.getTime():typeof d=="string"&&(D=new Date(d).getTime());let t;if(typeof b=="string"?t=v(u(b)):t=b,!w||!t)return!1;const l=w.majorBase,i=w.minorBase,n=w.patchBase;let a=t.majorBase,c=t.minorBase,o=t.patchBase;const m=t.notBefore;let C=t.majorMustEqual,R=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?l>a?!0:l<a?!1:i>c?!0:i<c||D&&D<m?!1:n>=o:(l===1&&a===0&&(!C||!R||!T)&&(a=1,c=0,o=0,C=!0,R=!1,T=!1),l<a?!1:l>a?!C:i<c?!1:i>c?!R:n<o?!1:n>o?!T:!(D&&D<m))}e.isValidVersion=p;function y(g,d,b,w,D){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([A.default.Error,r.localize(0,null)]),t;if(typeof w.name!="string")return t.push([A.default.Error,r.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([A.default.Error,r.localize(2,null,"version")]),t;if(!w.engines)return t.push([A.default.Error,r.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([A.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!s(w.extensionDependencies))return t.push([A.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!s(w.activationEvents))return t.push([A.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([A.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([A.default.Warning,r.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([A.default.Error,r.localize(9,null,"main")]),t;{const n=(0,I.joinPath)(b,w.main);(0,I.isEqualOrParent)(n,b)||t.push([A.default.Warning,r.localize(10,null,n.path,b.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([A.default.Error,r.localize(11,null,"browser")]),t;{const n=(0,I.joinPath)(b,w.browser);(0,I.isEqualOrParent)(n,b)||t.push([A.default.Warning,r.localize(12,null,n.path,b.path)])}}if(!L.valid(w.version))return t.push([A.default.Error,r.localize(13,null)]),t;const l=[];if(!h(g,d,w,D,l))for(const n of l)t.push([A.default.Error,n]);return t}e.validateExtensionManifest=y;function h(g,d,b,w,D){return w||typeof b.main>"u"&&typeof b.browser>"u"?!0:S(g,d,b.engines.vscode,D)}e.isValidExtensionVersion=h;function E(g,d,b){return g==="*"||S(d,b,g)}e.isEngineValid=E;function S(g,d,b,w=[]){const D=v(u(b));if(!D)return w.push(r.localize(14,null,b)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return w.push(r.localize(15,null,b)),!1}else if(!D.majorMustEqual)return w.push(r.localize(16,null,b)),!1;return p(g,d,D)?!0:(w.push(r.localize(17,null,g,b)),!1)}function s(g){if(!Array.isArray(g))return!1;for(let d=0,b=g.length;d<b;d++)if(typeof g[d]!="string")return!1;return!0}}),define(ee[201],te([0,1,17,31]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(L,M,k){let f=k&&k.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const v=(await M.readFile(L.serviceMachineIdResource)).value.toString();f=(0,A.isUUID)(v)?v:null}catch{f=null}if(!f){f=(0,A.generateUuid)();try{await M.writeFile(L.serviceMachineIdResource,I.VSBuffer.fromString(f))}catch{}}return k?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=r}),define(ee[76],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(r,L=[],M=!1){this.ctor=r,this.staticArguments=L,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=I}),define(ee[202],te([0,1,76]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var r;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(r=e.InstantiationType||(e.InstantiationType={}));function L(k,f,u){f instanceof I.SyncDescriptor||(f=new I.SyncDescriptor(f,[],Boolean(u))),A.push([k,f])}e.registerSingleton=L;function M(){return A}e.getSingletonServiceDescriptors=M}),define(ee[203],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(L,M){this.key=L,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class A{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const M of this._nodes.values())M.outgoing.size===0&&L.push(M);return L}insertEdge(L,M){const k=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(M);k.outgoing.set(f.key,f),f.incoming.set(k.key,k)}removeNode(L){const M=this._hashFn(L);this._nodes.delete(M);for(const k of this._nodes.values())k.outgoing.delete(M),k.incoming.delete(M)}lookupOrInsertNode(L){const M=this._hashFn(L);let k=this._nodes.get(M);return k||(k=new I(M,L),this._nodes.set(M,k)),k}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[M,k]of this._nodes)L.push(`${M}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,M]of this._nodes){const k=new Set([L]),f=this._findCycle(M,k);if(f)return f}}_findCycle(L,M){for(const[k,f]of L.outgoing){if(M.has(k))return[...M,k].join(" -> ");M.add(k);const u=this._findCycle(f,M);if(u)return u;M.delete(k)}}}e.Graph=A}),define(ee[6],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function k(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=k})(I=e._util||(e._util={})),e.IInstantiationService=r("instantiationService");function A(M,k,f){k[I.DI_TARGET]===k?k[I.DI_DEPENDENCIES].push({id:M,index:f}):(k[I.DI_DEPENDENCIES]=[{id:M,index:f}],k[I.DI_TARGET]=k)}function r(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const k=function(f,u,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,f,v)};return k.toString=()=>M,I.serviceIds.set(M,k),k}e.createDecorator=r;function L(M){return M}e.refineServiceDecorator=L}),define(ee[63],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[19],te([0,1,11,8,6]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationOverrides=L;function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=M;var k;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function u(s,g){const d=Object.create(null);for(const b in s)v(d,b,s[b],g);return d}e.toValuesTree=u;function v(s,g,d,b){const w=g.split("."),D=w.pop();let t=s;for(let l=0;l<w.length;l++){const i=w[l];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${g} as ${w.slice(0,l+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[D]=d}catch{b(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=v;function p(s,g){const d=g.split(".");y(s,d)}e.removeFromValueTree=p;function y(s,g){const d=g.shift();if(g.length===0){delete s[d];return}if(Object.keys(s).indexOf(d)!==-1){const b=s[d];typeof b=="object"&&!Array.isArray(b)&&(y(b,g),Object.keys(b).length===0&&delete s[d])}}function h(s,g,d){function b(t,l){let i=t;for(const n of l){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=g.split("."),D=b(s,w);return typeof D>"u"?d:D}e.getConfigurationValue=h;function E(s,g,d){Object.keys(g).forEach(b=>{b!=="__proto__"&&(b in s?I.isObject(s[b])&&I.isObject(g[b])?E(s[b],g[b],d):d&&(s[b]=g[b]):s[b]=g[b])})}e.merge=E;function S(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(ee[204],te([0,1,4,26,192,6,161,13]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",I.isMacintosh),f.set("isLinux",I.isLinux),f.set("isWindows",I.isWindows),f.set("isWeb",I.isWeb),f.set("isMacNative",I.isMacintosh&&!I.isWeb),f.set("isEdge",I.isEdge),f.set("isFirefox",I.isFirefox),f.set("isChrome",I.isChrome),f.set("isSafari",I.isSafari);function u(_,P){if(f.get(_)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(_,P)}e.setConstant=u;const v=Object.prototype.hasOwnProperty;var p;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));const y={regexParsingWithErrorRecovery:!0},h=(0,M.localize)(0,null),E=(0,M.localize)(1,null),S=(0,M.localize)(2,null),s=(0,M.localize)(3,null),g=(0,M.localize)(4,null),d=(0,M.localize)(5,null),b=(0,M.localize)(6,null),w=(0,M.localize)(7,null);class D{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=y){this._config=P,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:E});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const O=this._expr();if(!this._isAtEnd()){const F=this._peek(),B=F.type===17?d:void 0;throw this._parsingErrors.push({message:g,offset:F.offset,lexeme:r.Scanner.getLexeme(F),additionalInfo:B}),D._parseError}return O}catch(O){if(O!==D._parseError)throw O;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(16);){const O=this._and();P.push(O)}return P.length===1?P[0]:t.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(15);){const O=this._term();P.push(O)}return P.length===1?P[0]:t.and(...P)}_term(){if(this._matchOne(2)){const P=this._peek();switch(P.type){case 11:return this._advance(),a.INSTANCE;case 12:return this._advance(),c.INSTANCE;case 0:{this._advance();const O=this._expr();return this._consume(1,s),O?.negate()}case 17:return this._advance(),U.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const O=this._expr();return this._consume(1,s),O}case 17:{const O=P.lexeme;if(this._advance(),this._matchOne(9)){const B=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),B.type!==10)throw this._errExpectedButGot("REGEX",B);const N=B.lexeme,z=N.lastIndexOf("/"),V=z===N.length-1?void 0:this._removeFlagsGY(N.substring(z+1));let se;try{se=new RegExp(N.substring(1,z),V)}catch{throw this._errExpectedButGot("REGEX",B)}return he.create(O,se)}switch(B.type){case 10:case 19:{const N=[B.lexeme];this._advance();let z=this._peek(),V=0;for(let Ae=0;Ae<B.lexeme.length;Ae++)B.lexeme.charCodeAt(Ae)===40?V++:B.lexeme.charCodeAt(Ae)===41&&V--;for(;!this._isAtEnd()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let Ae=0;Ae<z.lexeme.length;Ae++)z.lexeme.charCodeAt(Ae)===40?V++:B.lexeme.charCodeAt(Ae)===41&&V--}if(V<0)break;N.push(r.Scanner.getLexeme(z)),this._advance(),z=this._peek()}const se=N.join(""),de=se.lastIndexOf("/"),ye=de===se.length-1?void 0:this._removeFlagsGY(se.substring(de+1));let ke;try{ke=new RegExp(se.substring(1,de),ye)}catch{throw this._errExpectedButGot("REGEX",B)}return t.regex(O,ke)}case 18:{const N=B.lexeme;this._advance();let z=null;if(!(0,A.isFalsyOrWhitespace)(N)){const V=N.indexOf("/"),se=N.lastIndexOf("/");if(V!==se&&V>=0){const de=N.slice(V+1,se),ye=N[se+1]==="i"?"i":"";try{z=new RegExp(de,ye)}catch{throw this._errExpectedButGot("REGEX",B)}}}if(z===null)throw this._errExpectedButGot("REGEX",B);return he.create(O,z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,S);const B=this._value();return t.notIn(O,B)}switch(this._peek().type){case 3:{this._advance();const B=this._value();if(this._previous().type===18)return t.equals(O,B);switch(B){case"true":return t.has(O);case"false":return t.not(O);default:return t.equals(O,B)}}case 4:{this._advance();const B=this._value();if(this._previous().type===18)return t.notEquals(O,B);switch(B){case"true":return t.not(O);case"false":return t.has(O);default:return t.notEquals(O,B)}}case 5:return this._advance(),oe.create(O,this._value());case 6:return this._advance(),ae.create(O,this._value());case 7:return this._advance(),q.create(O,this._value());case 8:return this._advance(),ie.create(O,this._value());case 13:return this._advance(),t.in(O,this._value());default:return t.has(O)}}case 20:throw this._parsingErrors.push({message:b,offset:P.offset,lexeme:"",additionalInfo:w}),D._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case 17:case 18:return this._advance(),P.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,O){if(this._check(P))return this._advance();throw this._errExpectedButGot(O,this._peek())}_errExpectedButGot(P,O,F){const B=(0,M.localize)(8,null,P,r.Scanner.getLexeme(O)),N=O.offset,z=r.Scanner.getLexeme(O);return this._parsingErrors.push({message:B,offset:N,lexeme:z,additionalInfo:F}),D._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}D._parseError=new Error,e.Parser=D;class t{static false(){return a.INSTANCE}static true(){return c.INSTANCE}static has(P){return o.create(P)}static equals(P,O){return m.create(P,O)}static notEquals(P,O){return T.create(P,O)}static regex(P,O){return he.create(P,O)}static in(P,O){return C.create(P,O)}static notIn(P,O){return R.create(P,O)}static not(P){return U.create(P)}static and(...P){return Y.create(P,null,!0)}static or(...P){return x.create(P,null,!0)}static greater(P,O){return q.create(P,O)}static greaterEquals(P,O){return ie.create(P,O)}static smaller(P,O){return oe.create(P,O)}static smallerEquals(P,O){return ae.create(P,O)}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}t._parser=new D({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function l(_){const P=new D({regexParsingWithErrorRecovery:!1});return _.map(O=>(P.parse(O),P.lexingErrors.length>0?P.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,M.localize)(9,null,F.additionalInfo):(0,M.localize)(10,null),offset:F.offset,length:F.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.validateWhenClauses=l;function i(_,P){const O=_?_.substituteConstants():void 0,F=P?P.substituteConstants():void 0;return!O&&!F?!0:!O||!F?!1:O.equals(F)}e.expressionsAreEqualWithConstantSubstitution=i;function n(_,P){return _.cmp(P)}class a{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return c.INSTANCE}}a.INSTANCE=new a,e.ContextKeyFalseExpr=a;class c{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return a.INSTANCE}}c.INSTANCE=new c,e.ContextKeyTrueExpr=c;class o{static create(P,O=null){const F=f.get(P);return typeof F=="boolean"?F?c.INSTANCE:a.INSTANCE:new o(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:H(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=f.get(this.key);return typeof P=="boolean"?P?c.INSTANCE:a.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=U.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class m{static create(P,O,F=null){if(typeof O=="boolean")return O?o.create(P,F):U.create(P,F);const B=f.get(P);return typeof B=="boolean"?O===(B?"true":"false")?c.INSTANCE:a.INSTANCE:new m(P,O,F)}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=f.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?c.INSTANCE:a.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class C{static create(P,O){return new C(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.valueKey),F=P.getValue(this.key);return Array.isArray(O)?O.includes(F):typeof F=="string"&&typeof O=="object"&&O!==null?v.call(O,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=R.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=C;class R{static create(P,O){return new R(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=11,this._negated=C.create(P,O)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=R;class T{static create(P,O,F=null){if(typeof O=="boolean")return O?U.create(P,F):o.create(P,F);const B=f.get(P);return typeof B=="boolean"?O===(B?"true":"false")?a.INSTANCE:c.INSTANCE:new T(P,O,F)}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=f.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?a.INSTANCE:c.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=T;class U{static create(P,O=null){const F=f.get(P);return typeof F=="boolean"?F?a.INSTANCE:c.INSTANCE:new U(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:H(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=f.get(this.key);return typeof P=="boolean"?P?a.INSTANCE:c.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=U;function $(_,P){if(typeof _=="string"){const O=parseFloat(_);isNaN(O)||(_=O)}return typeof _=="string"||typeof _=="number"?P(_):a.INSTANCE}class q{static create(P,O,F=null){return $(O,B=>new q(P,B,F))}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ae.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class ie{static create(P,O,F=null){return $(O,B=>new ie(P,B,F))}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=oe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=ie;class oe{static create(P,O,F=null){return $(O,B=>new oe(P,B,F))}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=oe;class ae{static create(P,O,F=null){return $(O,B=>new ae(P,B,F))}constructor(P,O,F){this.key=P,this.value=O,this.negated=F,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:Q(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ae;class he{static create(P,O){return new he(P,O)}constructor(P,O){this.key=P,this.regexp=O,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const O=this.regexp?this.regexp.source:"",F=P.regexp?P.regexp.source:"";return O<F?-1:O>F?1:0}equals(P){if(P.type===this.type){const O=this.regexp?this.regexp.source:"",F=P.regexp?P.regexp.source:"";return this.key===P.key&&O===F}return!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ce.create(this)),this.negated}}e.ContextKeyRegexExpr=he;class ce{static create(P){return new ce(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new ce(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ce;function K(_){let P=null;for(let O=0,F=_.length;O<F;O++){const B=_[O].substituteConstants();if(_[O]!==B&&P===null){P=[];for(let N=0;N<O;N++)P[N]=_[N]}P!==null&&(P[O]=B)}return P===null?_:P}class Y{static create(P,O,F){return Y._normalizeArr(P,O,F)}constructor(P,O){this.expr=P,this.negated=O,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,F=this.expr.length;O<F;O++){const B=n(this.expr[O],P.expr[O]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,F=this.expr.length;O<F;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=K(this.expr);return P===this.expr?this:Y.create(P,this.negated,!1)}evaluate(P){for(let O=0,F=this.expr.length;O<F;O++)if(!this.expr[O].evaluate(P))return!1;return!0}static _normalizeArr(P,O,F){const B=[];let N=!1;for(const z of P)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return a.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&N)return c.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(n);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const V=B.pop(),se=B.length===0,de=x.create(z.expr.map(ye=>Y.create([ye,V],null,F)),null,se);de&&(B.push(de),B.sort(n))}if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let V=z+1;V<B.length;V++)if(B[z].negate().equals(B[V]))return a.INSTANCE;if(B.length===1)return B[0]}return new Y(B,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new Y(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());this.negated=x.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class x{static create(P,O,F){return x._normalizeArr(P,O,F)}constructor(P,O){this.expr=P,this.negated=O,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,F=this.expr.length;O<F;O++){const B=n(this.expr[O],P.expr[O]);if(B!==0)return B}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,F=this.expr.length;O<F;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=K(this.expr);return P===this.expr?this:x.create(P,this.negated,!1)}evaluate(P){for(let O=0,F=this.expr.length;O<F;O++)if(this.expr[O].evaluate(P))return!0;return!1}static _normalizeArr(P,O,F){let B=[],N=!1;if(P){for(let z=0,V=P.length;z<V;z++){const se=P[z];if(!!se){if(se.type===0){N=!0;continue}if(se.type===1)return c.INSTANCE;if(se.type===9){B=B.concat(se.expr);continue}B.push(se)}}if(B.length===0&&N)return a.INSTANCE;B.sort(n)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let V=z+1;V<B.length;V++)if(B[z].negate().equals(B[V]))return c.INSTANCE;if(B.length===1)return B[0]}return new x(B,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new x(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());for(;P.length>1;){const O=P.shift(),F=P.shift(),B=[];for(const N of Z(O))for(const z of Z(F))B.push(Y.create([N,z],null,!1));P.unshift(x.create(B,null,!1))}this.negated=x.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends o{static all(){return W._info.values()}constructor(P,O,F){super(P,null),this._defaultValue=O,typeof F=="object"?W._info.push({...F,key:P}):F!==!0&&W._info.push({key:P,description:F,type:O!=null?typeof O:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return m.create(this.key,P)}notEqualsTo(P){return T.create(this.key,P)}}W._info=[],e.RawContextKey=W,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function H(_,P){return _<P?-1:_>P?1:0}function Q(_,P,O,F){return _<O?-1:_>O?1:P<F?-1:P>F?1:0}function ne(_,P){if(_.type===0||P.type===1)return!0;if(_.type===9)return P.type===9?re(_.expr,P.expr):!1;if(P.type===9){for(const O of P.expr)if(ne(_,O))return!0;return!1}if(_.type===6){if(P.type===6)return re(P.expr,_.expr);for(const O of _.expr)if(ne(O,P))return!0;return!1}return _.equals(P)}e.implies=ne;function re(_,P){let O=0,F=0;for(;O<_.length&&F<P.length;){const B=_[O].cmp(P[F]);if(B<0)return!1;B===0&&O++,F++}return O===_.length}function Z(_){return _.type===9?_.expr:[_]}}),define(ee[77],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class A{constructor(){this.secretVault={}}async getPassword(L,M){return this.secretVault[L]?.[M]??null}async setPassword(L,M,k){this.secretVault[L]=this.secretVault[L]??{},this.secretVault[L][M]=k}async deletePassword(L,M){return this.secretVault[L]?.[M]?(delete this.secretVault[L][M],Object.keys(this.secretVault[L]).length===0&&delete this.secretVault[L],!0):!1}async findPassword(L){return JSON.stringify(this.secretVault[L])??null}async findCredentials(L){const M=[];for(const k of Object.keys(this.secretVault[L]||{}))M.push({account:k,password:this.secretVault[L][k]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=A}),define(ee[89],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=A;class r{async getPerformanceInfo(M,k){return{}}async getSystemInfo(M,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,k){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(ee[90],te([0,1,18,75,163,6,45,4,37]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,L.createDecorator)("dialogService");var u;(function(S){S[S.Confirmation=1]="Confirmation",S[S.Prompt=2]="Prompt",S[S.Input=3]="Input"})(u||(u={}));class v{getConfirmationButtons(s){return this.getButtons(s,u.Confirmation)}getPromptButtons(s){return this.getButtons(s,u.Prompt)}getInputButtons(s){return this.getButtons(s,u.Input)}getButtons(s,g){const d=[];switch(g){case u.Confirmation:{const b=s;b.primaryButton?d.push(b.primaryButton):d.push((0,r.localize)(0,null)),b.cancelButton?d.push(b.cancelButton):d.push((0,r.localize)(1,null));break}case u.Prompt:{const b=s;Array.isArray(b.buttons)&&b.buttons.length>0&&d.push(...b.buttons.map(w=>w.label)),b.cancelButton&&(b.cancelButton===!0?d.push((0,r.localize)(2,null)):typeof b.cancelButton=="string"?d.push(b.cancelButton):b.cancelButton.label?d.push(b.cancelButton.label):d.push((0,r.localize)(3,null))),d.length===0&&d.push((0,r.localize)(4,null));break}case u.Input:{const b=s;b.primaryButton?d.push(b.primaryButton):d.push((0,r.localize)(5,null)),b.cancelButton?d.push(b.cancelButton):d.push((0,r.localize)(6,null));break}}return d}getDialogType(s){if(typeof s=="string")return s;if(typeof s=="number")return s===A.default.Info?"info":s===A.default.Error?"error":s===A.default.Warning?"warning":"none"}async getPromptResult(s,g,d){const b=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&b.push(s.cancelButton),{result:await b[g]?.run({checkboxChecked:d}),checkboxChecked:d}}}e.AbstractDialogHandler=v,e.IFileDialogService=(0,L.createDecorator)("fileDialogService");var p;(function(S){S[S.SAVE=0]="SAVE",S[S.DONT_SAVE=1]="DONT_SAVE",S[S.CANCEL=2]="CANCEL"})(p=e.ConfirmResult||(e.ConfirmResult={}));const y=10;function h(S){const s=[];return s.push(...S.slice(0,y).map(g=>typeof g=="string"?g:(0,I.basename)(g))),S.length>y&&(S.length-y===1?s.push((0,r.localize)(7,null)):s.push((0,r.localize)(8,null,S.length-y))),s.push(""),s.join(`
`)}e.getFileNamesMessage=h;function E(S,s){const g=(0,f.deepClone)(S);let d=(g.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),b=(S.buttons||[]).map((t,l)=>l),w=0,D=g.cancelId??d.length-1;if(d.length>1){const t=typeof D=="number"?d[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&d.length>1&&D!==1){d.splice(D,1),d.splice(1,0,t);const l=b[D];b.splice(D,1),b.splice(1,0,l),D=1}k.isLinux&&d.length>1&&(d=d.reverse(),b=b.reverse(),w=d.length-1,typeof t=="string"&&(D=w-1))}else if(k.isWindows&&typeof t=="string"&&d.length>1&&D!==d.length-1){d.splice(D,1),d.push(t);const l=b[D];b.splice(D,1),b.push(l),D=d.length-1}}return g.buttons=d,g.defaultId=w,g.cancelId=D,g.noLink=!0,g.title=g.title||s.nameLong,{options:g,buttonIndeces:b}}e.massageMessageBoxOptions=E}),define(ee[111],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,88,34,110,6]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(L.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([I.memoize],f.prototype,"cachedLanguagesPath",null),we([I.memoize],f.prototype,"backupHome",null),we([I.memoize],f.prototype,"mainIPCHandle",null),we([I.memoize],f.prototype,"mainLockfile",null),we([I.memoize],f.prototype,"disableUpdates",null),we([I.memoize],f.prototype,"disableKeytar",null),we([I.memoize],f.prototype,"crossOriginIsolated",null),we([I.memoize],f.prototype,"codeCachePath",null),we([I.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[112],te([0,1,167,6]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function r(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function M(d,b){switch(d){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function k(d,b){return b==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function f(d,b,w){return k(b,w)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===w?!0:u(w).includes(d)}e.isTargetPlatformCompatible=f;function u(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function v(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=v;var p;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var y;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var h;(function(d){d.Install="install",d.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var E;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var S;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var s;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class g extends Error{constructor(b,w){super(b),this.code=w,this.name=w}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ee[205],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[206],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[113],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[207],te([0,1,46,14,9,4,73,24,87,171,113]),function(j,e,I,A,r,L,M,k,f,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=u.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await S.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{openTerminal(w,D){return this.spawnTerminal(I,w,f.getWindowsShell(),D)}spawnTerminal(w,D,t,l){const i=D.windowsExec||h.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=r.basename(i,".exe").toLowerCase();if(n==="cmder")return w.spawn(i,l?[l]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((c,o)=>{const m=s(process),C=w.spawn(t,a,{cwd:l,env:m});C.on("error",o),C.on("exit",()=>c())})}runInTerminal(w,D,t,l,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((a,c)=>{const o=`"${D} - ${p}"`,m=`""${t.join('" "')}" & pause"`,C=Object.assign({},s(process),l);Object.keys(C).filter(q=>C[q]===null).forEach(q=>delete C[q]);const R={cwd:D,env:C,windowsVerbatimArguments:!0};let T,U;r.basename(n,".exe")==="wt"?(T=n,U=["-d",".",h.CMD,"/c",m]):(T=h.CMD,U=["/c","start",o,"/wait",n,"/c",m]),I.spawn(T,U,R).on("error",q=>{c(g(q))}),a(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const w=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${w?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}h.CMD="cmd.exe",e.WindowsExternalTerminalService=h;class E extends y{openTerminal(w,D){return this.spawnTerminal(I,w,D)}runInTerminal(w,D,t,l,i){const n=i.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((a,c)=>{if(n===v.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const o=n===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",w||p,"-w",D];for(const U of t)C.push("-a"),C.push(U);if(l){const U=Object.assign({},s(process),l);for(const $ in U){const q=U[$];q===null?(C.push("-u"),C.push($)):(C.push("-e"),C.push(`${$}=${q}`))}}let R="";const T=I.spawn(E.OSASCRIPT,C);T.on("error",U=>{c(g(U))}),T.stderr.on("data",U=>{R+=U.toString()}),T.on("exit",U=>{if(U===0)a(void 0);else if(R){const $=R.split(`
`,1);c(new Error($[0]))}else c(new Error(u.localize(1,null,o,U)))})}else c(new Error(u.localize(2,null,n)))})}spawnTerminal(w,D,t){const l=D.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const a=["-a",l];t&&a.push(t);const c=s(process),o=w.spawn("/usr/bin/open",a,{cwd:t,env:c});o.on("error",n),o.on("exit",()=>i())})}}E.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=E;class S extends y{openTerminal(w,D){return this.spawnTerminal(I,w,D)}runInTerminal(w,D,t,l,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((a,c)=>{const o=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const C=`${d(t)}; echo; read -p "${S.WAIT_MESSAGE}" -n1;`;o.push(`''${C}''`);const R=Object.assign({},s(process),l);Object.keys(R).filter(q=>R[q]===null).forEach(q=>delete R[q]);const T={cwd:D,env:R};let U="";const $=I.spawn(m,o,T);$.on("error",q=>{c(g(q))}),$.stderr.on("data",q=>{U+=q.toString()}),$.on("exit",q=>{if(q===0)a(void 0);else if(U){const ie=U.split(`
`,1);c(new Error(ie[0]))}else c(new Error(u.localize(4,null,m,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!S._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)S._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const w=await k.Promises.exists("/etc/debian_version");S._DEFAULT_TERMINAL_LINUX_READY=new Promise(D=>{w?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return S._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(w,D,t){const l=D.linuxExec?Promise.resolve(D.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{l.then(a=>{const c=s(process),o=w.spawn(a,[],{cwd:t,env:c});o.on("error",n),o.on("exit",()=>i())})})}}S.WAIT_MESSAGE=u.localize(3,null),e.LinuxExternalTerminalService=S;function s(b){const w={...b.env};return(0,M.sanitizeProcessEnvironment)(w),w}function g(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(u.localize(5,null,b.path)):b}function d(b){let w="";for(const D of b)D.indexOf(" ")>=0?w+='"'+D+'"':w+=D,w+=" ";return w}}),define(ee[16],te([0,1,61,9,26,11,8,173,6,4,14]),function(j,e,I,A,r,L,M,k,f,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function p(W){return W.create===!0}e.isFileOpenForWriteOptions=p;var y;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var h;(function(W){W[W.Readonly=1]="Readonly"})(h=e.FilePermission||(e.FilePermission={}));var E;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=S;function s(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=s;function g(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=g;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function b(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=b;function w(W){return S(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var D;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(H,Q){const ne=new t(H.toString(),Q);return n(ne,Q),ne}constructor(H,Q){super(H),this.code=Q}}e.FileSystemProviderError=t;function l(W,H){return t.create(W,H)}e.createFileSystemProviderError=l;function i(W){return W||l((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function n(W,H){return W.name=H?`${H} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=n;function a(W){if(!W)return D.Unknown;if(W instanceof t)return W.code;const H=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!H)return D.Unknown;switch(H[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=a;function c(W){if(W instanceof U)return W.fileOperationResult;switch(a(W)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class m{constructor(H,Q,ne){this.resource=H,this.operation=Q,this.target=ne}isOperation(H){return this.operation===H}}e.FileOperationEvent=m;var C;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(C=e.FileChangeType||(e.FileChangeType={}));class R{constructor(H,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const re of H){const Z=ne.get(re.type);switch(Z?Z.push([re.resource,re]):ne.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,Z]of ne)switch(re){case 1:this.added=I.TernarySearchTree.forUris(()=>Q),this.added.fill(Z);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>Q),this.updated.fill(Z);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>Q),this.deleted.fill(Z);break}}contains(H,...Q){return this.doContains(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.doContains(H,{includeChildren:!0},...Q)}doContains(H,Q,...ne){if(!H)return!1;const re=ne.length>0;return!!((!re||ne.includes(1))&&(this.added?.get(H)||Q.includeChildren&&this.added?.findSuperstr(H))||(!re||ne.includes(0))&&(this.updated?.get(H)||Q.includeChildren&&this.updated?.findSuperstr(H))||(!re||ne.includes(2))&&(this.deleted?.findSubstr(H)||Q.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=R;function T(W,H,Q){return!W||!H||W===H||H.length>W.length?!1:(H.charAt(H.length-1)!==A.sep&&(H+=A.sep),Q?(0,r.startsWithIgnoreCase)(W,H):W.indexOf(H)===0)}e.isParent=T;class U extends Error{constructor(H,Q,ne){super(H),this.fileOperationResult=Q,this.options=ne}}e.FileOperationError=U;class $ extends U{constructor(H,Q,ne,re){super(H,Q,re),this.fileOperationResult=Q,this.size=ne}}e.TooLargeFileOperationError=$;class q extends U{constructor(H,Q,ne){super(H,2,ne),this.stat=Q}}e.NotModifiedSinceFileOperationError=q;var ie;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var oe;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=ae;async function he(W,H){if(!H.hasProvider(M.URI.from({scheme:W.scheme})))return new Promise(Q=>{const ne=H.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===W.scheme&&re.added&&(ne.dispose(),Q())})})}e.whenProviderRegistered=he,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(H){return(0,L.isNumber)(H)||(H=0),H<ce.KB?(0,k.localize)(1,null,H.toFixed(0)):H<ce.MB?(0,k.localize)(2,null,(H/ce.KB).toFixed(2)):H<ce.GB?(0,k.localize)(3,null,(H/ce.MB).toFixed(2)):H<ce.TB?(0,k.localize)(4,null,(H/ce.GB).toFixed(2)):(0,k.localize)(5,null,(H/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var K;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function Y(W){return{maxFileSize:W===0?300*ce.MB:16*ce.GB,maxHeapSize:W===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=Y;function x(W){const H=typeof W=="string"||W?.scheme===v.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===v.Schemas.file?1024*ce.MB:H?10*ce.MB:u.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=x}),define(ee[208],te([0,1,17,44,13,3,2,60,8,31,16]),function(j,e,I,A,r,L,M,k,f,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class p extends M.Disposable{constructor(h,E){super(),this.channel=h,this.extraCapabilities=E,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,u.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,E){const{buffer:S}=await this.channel.call("readFile",[h,E]);return S}readFileStream(h,E,S){const s=(0,k.newWriteableStream)(d=>I.VSBuffer.concat(d.map(b=>I.VSBuffer.wrap(b))).buffer),g=this.channel.listen("readFileStream",[h,E])(d=>{if(d instanceof I.VSBuffer)s.write(d.buffer);else{if(d==="end")s.end();else{let b;if(d instanceof Error)b=d;else{const w=d;b=(0,v.createFileSystemProviderError)(w.message??(0,A.toErrorMessage)(w),w.code??v.FileSystemProviderErrorCode.Unknown)}s.error(b),s.end()}g.dispose()}});return S.onCancellationRequested(()=>{s.error((0,r.canceled)()),s.end(),g.dispose()}),s}writeFile(h,E,S){return this.channel.call("writeFile",[h,I.VSBuffer.wrap(E),S])}open(h,E){return this.channel.call("open",[h,E])}close(h){return this.channel.call("close",[h])}async read(h,E,S,s,g){const[d,b]=await this.channel.call("read",[h,E,g]);return S.set(d.buffer.slice(0,b),s),b}write(h,E,S,s,g){return this.channel.call("write",[h,E,I.VSBuffer.wrap(S),s,g])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,E){return this.channel.call("delete",[h,E])}rename(h,E,S){return this.channel.call("rename",[h,E,S])}copy(h,E,S){return this.channel.call("copy",[h,E,S])}cloneFile(h,E){return this.channel.call("cloneFile",[h,E])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const E=h;this._onDidChange.fire(E.map(S=>({resource:f.URI.revive(S.resource),type:S.type})))}else{const E=h;this._onDidWatchError.fire(E)}}))}watch(h,E){const S=(0,u.generateUuid)();return this.channel.call("watch",[this.sessionId,S,h,E]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=p}),define(ee[114],te([0,1,17,13,174,16]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(v,p,y,h,E,S){let s;try{await k(v,p,y,h,E,S)}catch(g){s=g}finally{s&&E.errorTransformer&&(s=E.errorTransformer(s)),typeof s<"u"&&y.error(s),y.end()}}e.readFileIntoStream=M;async function k(v,p,y,h,E,S){f(S);const s=await v.open(p,{create:!1});try{f(S);let g=0,d=0,b=E&&typeof E.length=="number"?E.length:void 0,w=I.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),D=E&&typeof E.position=="number"?E.position:0,t=0;do d=await v.read(s,D,w.buffer,t,w.byteLength-t),D+=d,t+=d,g+=d,typeof b=="number"&&(b-=d),t===w.byteLength&&(await y.write(h(w)),w=I.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),t=0);while(d>0&&(typeof b!="number"||b>0)&&f(S)&&u(g,E));if(t>0){let l=t;typeof b=="number"&&(l=Math.min(t,b)),y.write(h(w.slice(0,l)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await v.close(s)}}function f(v){if(v.isCancellationRequested)throw(0,A.canceled)();return!0}function u(v,p){if(p?.limits){if(typeof p.limits.memory=="number"&&v>p.limits.memory)throw(0,L.createFileSystemProviderError)((0,r.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&v>p.limits.size)throw(0,L.createFileSystemProviderError)((0,r.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[78],te([0,1,102,2,9,4,8,16]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(g){return g.recursive===!0}e.isRecursiveWatchRequest=f;class u extends A.Disposable{constructor(d,b,w,D){super(),this.onFileChanges=d,this.onLogMessage=b,this.verboseLogging=w,this.options=D,this.watcherDisposables=this._register(new A.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new A.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),d.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),d.add(this.watcher.onDidError(b=>this.onError(b)))}onError(d){this.options.restartOnError?this.restartCounter<u.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}u.MAX_RESTARTS=5,e.AbstractWatcherClient=u;class v extends u{constructor(d,b,w){super(d,b,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class p extends u{constructor(d,b,w){super(d,b,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=p;function y(g){return g.map(d=>({type:d.type,resource:M.URI.file(d.path)}))}e.toFileChanges=y;function h(g){const d=new s;for(const b of g)d.processEvent(b);return d.coalesce()}e.coalesceEvents=h;function E(g,d){return typeof d=="string"&&!d.startsWith(I.GLOBSTAR)&&!(0,r.isAbsolute)(d)?{base:g,pattern:d}:d}e.normalizeWatcherPattern=E;function S(g,d){const b=[];for(const w of d)b.push((0,I.parse)(E(g,w)));return b}e.parseWatcherPatterns=S;class s{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return L.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const b=this.mapPathToChange.get(this.toKey(d));let w=!1;if(b){const D=b.type,t=d.type;b.path!==d.path&&(d.type===2||d.type===1)?w=!0:D===1&&t===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(b)):D===2&&t===1?b.type=0:D===1&&t===0||(b.type=t)}else w=!0;w&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],b=[];return Array.from(this.coalesced).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,D)=>w.path.length-D.path.length).filter(w=>b.some(D=>(0,k.isParent)(w.path,D,!L.isLinux))?!1:(b.push(w.path),!0)).concat(d)}}}),define(ee[209],te([0,1,41,7,23,32,2,82,9,4,103,24,78]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends M.Disposable{constructor(s,g,d,b){super(),this.request=s,this.onDidFilesChange=g,this.onLogMessage=d,this.verboseLogging=b,this.throttledFileChangesEmitter=this._register(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.onDidFilesChange(w))),this.fileChangesAggregator=this._register(new A.RunOnceWorker(w=>this.handleFileChanges(w),h.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const s=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await p.Promises.stat(s);this._register(await this.doWatch(s,g.isDirectory()))}catch(s){s.code!=="ENOENT"?this.error(s):this.trace(s)}}async normalizePath(s){let g=s.path;try{g=await p.Promises.realpath(s.path),s.path===g&&(g=await(0,v.realcase)(s.path)??s.path),s.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${g})`)}catch{}return g}async doWatch(s,g){if(u.isMacintosh&&(0,L.isEqualOrParent)(s,"/Volumes/",!0))return this.error(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const d=new r.CancellationTokenSource(this.cts.token),b=new M.DisposableStore;try{const w=(0,f.basename)(s),D=(0,I.watch)(s);b.add((0,M.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.trace(`Started watching: '${s}'`);const t=new Set;if(g)try{for(const i of await p.Promises.readdir(s))t.add(i)}catch(i){this.error(i)}const l=new Map;b.add((0,M.toDisposable)(()=>{for(const[,i]of l)i.dispose();l.clear()})),D.on("error",(i,n)=>{this.error(`Failed to watch ${s} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),D.on("change",(i,n)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let a="";if(n&&(a=n.toString(),u.isMacintosh&&(a=(0,k.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){l.get(a)?.dispose();const c=setTimeout(async()=>{if(l.delete(a),a===w&&!await p.Promises.exists(s)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,f.join)(s,a));if(d.token.isCancellationRequested)return;let m;o?t.has(a)?m=0:(m=1,t.add(a)):(t.delete(a),m=2),this.onFileChange({path:(0,f.join)(this.request.path,a),type:m})},h.FILE_DELETE_HANDLER_DELAY);l.set(a,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(a)?c=0:(c=1,t.add(a)),this.onFileChange({path:(0,f.join)(this.request.path,a),type:c})}else if(i==="rename"||a!==w){const c=setTimeout(async()=>{const o=await p.Promises.exists(s);d.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),b.add(await this.doWatch(s,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);b.clear(),b.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(w){await p.Promises.exists(s)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${s} for changes using fs.watch() (${w.toString()})`)}return(0,M.toDisposable)(()=>{d.dispose(!0),b.dispose()})}onFileChange(s,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!g&&this.excludes.some(d=>d(s.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${s.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(d=>d(s.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${s.path}`):this.fileChangesAggregator.work(s))}handleFileChanges(s){const g=(0,y.coalesceEvents)(s);if(g.length>0){if(this.verboseLogging)for(const b of g)this.trace(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.throttledFileChangesEmitter.work(g)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(s){if(u.isLinux)return p.Promises.exists(s);try{const g=(0,f.basename)(s);return(await p.Promises.readdir((0,f.dirname)(s))).some(b=>b===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(s){this.verboseLogging=s}error(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}warn(s){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}trace(s){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=h;async function E(S,s,g,d,b=512){const w=await p.Promises.open(S,"r"),D=Buffer.allocUnsafe(b),t=new r.CancellationTokenSource(d);let l,i=!1;const n={path:S,excludes:[],recursive:!1},a=new h(n,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:m}=await p.Promises.read(w,D,0,b,null);if(!m||t.token.isCancellationRequested)break;s(D.slice(0,m))}}catch(m){l=new Error(m),t.dispose(!0)}finally{i=!1}}})()});return await a.ready,g(),new Promise((c,o)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await p.Promises.close(w)}catch(m){l=new Error(m)}l?o(l):c()})})}e.watchFileContents=E}),define(ee[210],te([0,1,3,102,2,4,209]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(u){const v=this.normalizeRequests(u),p=v.filter(h=>{const E=this.watchers.get(h.path);return E?!(0,A.patternsEquals)(E.request.excludes,h.excludes)||!(0,A.patternsEquals)(E.request.includes,h.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:h})=>!v.find(E=>E.path===h.path&&(0,A.patternsEquals)(E.excludes,h.excludes)&&(0,A.patternsEquals)(E.includes,h.includes))).map(({request:h})=>h.path);p.length&&this.trace(`Request to start watching: ${p.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.stopWatching(h);for(const h of p)this.startWatching(h)}startWatching(u){const v=new M.NodeJSFileWatcherLibrary(u,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),p={request:u,instance:v};this.watchers.set(u.path,p)}async stop(){for(const[u]of this.watchers)this.stopWatching(u);this.watchers.clear()}stopWatching(u){const v=this.watchers.get(u);v&&(this.watchers.delete(u),v.instance.dispose())}normalizeRequests(u){const v=new Map;for(const p of u){const y=L.isLinux?p.path:p.path.toLowerCase();v.set(y,p)}return Array.from(v.values())}async setVerboseLogging(u){this.verboseLogging=u;for(const[,v]of this.watchers)v.instance.setVerboseLogging(u)}trace(u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(u)})}toMessage(u,v){return v?`[File Watcher (node.js)] ${u} (path: ${v.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=k}),define(ee[211],te([0,1,78,210]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends I.AbstractNonRecursiveWatcherClient{constructor(M,k,f){super(M,k,f),this.init()}createWatcher(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=r}),define(ee[212],te([0,1,14,47,157,78]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends L.AbstractUniversalWatcherClient{constructor(f,u,v){super(f,u,v),this.init()}createWatcher(f){const u=f.add(new r.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:v,signal:p})=>this.onError(`terminated by itself with code ${v}, signal: ${p}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[91],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...r){this._entries=new Map;for(const[L,M]of r)this.set(L,M)}set(r,L){const M=this._entries.get(r);return this._entries.set(r,L),M}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=I}),define(ee[213],te([0,1,7,13,2,76,203,6,91,100]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class p extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class y{constructor(s=new f.ServiceCollection,g=!1,d,b=v){this._services=s,this._strict=g,this._parent=d,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(k.IInstantiationService,this),this._globalGraph=b?d?._globalGraph??new M.Graph(w=>w):void 0}createChild(s){return new y(s,this._strict,this,this._enableTracing)}invokeFunction(s,...g){const d=E.traceInvocation(this._enableTracing,s);let b=!1;try{return s({get:D=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(D,d);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...g)}finally{b=!0,d.stop()}}createInstance(s,...g){let d,b;return s instanceof L.SyncDescriptor?(d=E.traceCreation(this._enableTracing,s.ctor),b=this._createInstance(s.ctor,s.staticArguments.concat(g),d)):(d=E.traceCreation(this._enableTracing,s),b=this._createInstance(s,g,d)),d.stop(),b}_createInstance(s,g=[],d){const b=k._util.getServiceDependencies(s).sort((t,l)=>t.index-l.index),w=[];for(const t of b){const l=this._getOrCreateServiceInstance(t.id,d);l||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(l)}const D=b.length>0?b[0].index:g.length;if(g.length!==D){console.trace(`[createInstance] First service dependency of ${s.name} at position ${D+1} conflicts with ${g.length} static arguments`);const t=D-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,D)}return Reflect.construct(s,g.concat(w))}_setServiceInstance(s,g){if(this._services.get(s)instanceof L.SyncDescriptor)this._services.set(s,g);else if(this._parent)this._parent._setServiceInstance(s,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const g=this._services.get(s);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):g}_getOrCreateServiceInstance(s,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const d=this._getServiceInstanceOrDescriptor(s);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,d,g.branch(s,!0)):(g.branch(s,!1),d)}_safeCreateAndCacheServiceInstance(s,g,d){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,g,d)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,g,d){const b=new M.Graph(t=>t.id.toString());let w=0;const D=[{id:s,desc:g,_trace:d}];for(;D.length;){const t=D.pop();if(b.lookupOrInsertNode(t),w++>1e3)throw new p(b);for(const l of k._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(l.id);if(i||this._throwIfStrict(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),i instanceof L.SyncDescriptor){const n={id:l.id,desc:i,_trace:t._trace.branch(l.id,!0)};b.insertEdge(t,n),D.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:l}of t){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const n=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,n)}b.removeNode(l)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,g,d=[],b,w){if(this._services.get(s)instanceof L.SyncDescriptor)return this._createServiceInstance(s,g,d,b,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,g,d,b,w);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(s,g,d=[],b,w){if(b){const D=new y(void 0,this._strict,this,this._enableTracing);D._globalGraphImplicitDependency=String(s);const t=new Map,l=new I.IdleValue(()=>{const i=D._createInstance(g,d,w);for(const[n,a]of t){const c=i[n];if(typeof c=="function")for(const o of a)c.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!l.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new u.LinkedList,t.set(n,o)),(C,R,T)=>{const U=o.push([C,R,T]);return(0,r.toDisposable)(U)}}if(n in i)return i[n];const a=l.value;let c=a[n];return typeof c!="function"||(c=c.bind(a),i[n]=c),c},set(i,n,a){return l.value[n]=a,!0},getPrototypeOf(i){return g.prototype}})}else return this._createInstance(g,d,w)}_throwIfStrict(s,g){if(g&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=y;var h;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(h||(h={}));class E{static traceInvocation(s,g){return s?new E(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(s,g){return s?new E(1,g.name):E._None}constructor(s,g){this.type=s,this.name=g,this._start=Date.now(),this._dep=[]}branch(s,g){const d=new E(3,s.toString());return this._dep.push([s,g,d]),d}stop(){const s=Date.now()-this._start;E._totals+=s;let g=!1;function d(w,D){const t=[],l=new Array(w+1).join("	");for(const[i,n,a]of D._dep)if(n&&a){g=!0,t.push(`${l}CREATES -> ${i}`);const c=d(w+1,a);c&&t.push(c)}else t.push(`${l}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(s>2||g)&&E.all.add(b.join(`
`))}}E.all=new Set,E._None=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E._totals=0,e.Trace=E}),define(ee[5],te([0,1,44,3,56,2,35,4,18,11,8,204,6]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function h(){return new Date().toISOString()}function E(C){return(0,u.isNumber)(C)}e.isLogLevel=E;var S;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function s(C,R,T){switch(R){case S.Trace:C.trace(T);break;case S.Debug:C.debug(T);break;case S.Info:C.info(T);break;case S.Warning:C.warn(T);break;case S.Error:C.error(T);break;case S.Off:break;default:throw new Error(`Invalid log level ${R}`)}}e.log=s;function g(C,R=!1){let T="";for(let U=0;U<C.length;U++){let $=C[U];if($ instanceof Error&&($=(0,I.toErrorMessage)($,R)),typeof $=="object")try{$=JSON.stringify($)}catch{}T+=(U>0?" ":"")+$}return T}class d extends L.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(R){this.level!==R&&(this.level=R,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(R){return this.level!==S.Off&&this.level<=R}}e.AbstractLogger=d;class b extends d{constructor(R){super(),this.logAlways=R}checkLogLevel(R){return this.logAlways||super.checkLogLevel(R)}trace(R,...T){this.checkLogLevel(S.Trace)&&this.log(S.Trace,g([R,...T],!0))}debug(R,...T){this.checkLogLevel(S.Debug)&&this.log(S.Debug,g([R,...T]))}info(R,...T){this.checkLogLevel(S.Info)&&this.log(S.Info,g([R,...T]))}warn(R,...T){this.checkLogLevel(S.Warning)&&this.log(S.Warning,g([R,...T]))}error(R,...T){if(this.checkLogLevel(S.Error))if(R instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=R.stack,this.log(S.Error,g(U))}else this.log(S.Error,g([R,...T]))}flush(){}}e.AbstractMessageLogger=b;class w extends d{constructor(R=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(R),this.useColors=!k.isWindows}trace(R,...T){this.checkLogLevel(S.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,R,...T):console.log(`[main ${h()}]`,R,...T))}debug(R,...T){this.checkLogLevel(S.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,R,...T):console.log(`[main ${h()}]`,R,...T))}info(R,...T){this.checkLogLevel(S.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,R,...T):console.log(`[main ${h()}]`,R,...T))}warn(R,...T){this.checkLogLevel(S.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,R,...T):console.warn(`[main ${h()}]`,R,...T))}error(R,...T){this.checkLogLevel(S.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,R,...T):console.error(`[main ${h()}]`,R,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class D extends d{constructor(R=e.DEFAULT_LOG_LEVEL,T=!0){super(),this.useColors=T,this.setLevel(R)}trace(R,...T){this.checkLogLevel(S.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",R,...T):console.log(R,...T))}debug(R,...T){this.checkLogLevel(S.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",R,...T):console.log(R,...T))}info(R,...T){this.checkLogLevel(S.Info)&&(this.useColors?console.log("%c INFO","color: #33f",R,...T):console.log(R,...T))}warn(R,...T){this.checkLogLevel(S.Warning)&&(this.useColors?console.log("%c WARN","color: #993",R,...T):console.log(R,...T))}error(R,...T){this.checkLogLevel(S.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",R,...T):console.error(R,...T))}dispose(){}flush(){}}e.ConsoleLogger=D;class t extends d{constructor(R,T=e.DEFAULT_LOG_LEVEL){super(),this.adapter=R,this.setLevel(T)}trace(R,...T){this.checkLogLevel(S.Trace)&&this.adapter.log(S.Trace,[this.extractMessage(R),...T])}debug(R,...T){this.checkLogLevel(S.Debug)&&this.adapter.log(S.Debug,[this.extractMessage(R),...T])}info(R,...T){this.checkLogLevel(S.Info)&&this.adapter.log(S.Info,[this.extractMessage(R),...T])}warn(R,...T){this.checkLogLevel(S.Warning)&&this.adapter.log(S.Warning,[this.extractMessage(R),...T])}error(R,...T){this.checkLogLevel(S.Error)&&this.adapter.log(S.Error,[this.extractMessage(R),...T])}extractMessage(R){return typeof R=="string"?R:(0,I.toErrorMessage)(R,this.checkLogLevel(S.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class l extends d{constructor(R){super(),this.loggers=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const T of this.loggers)T.setLevel(R);super.setLevel(R)}trace(R,...T){for(const U of this.loggers)U.trace(R,...T)}debug(R,...T){for(const U of this.loggers)U.debug(R,...T)}info(R,...T){for(const U of this.loggers)U.info(R,...T)}warn(R,...T){for(const U of this.loggers)U.warn(R,...T)}error(R,...T){for(const U of this.loggers)U.error(R,...T)}flush(){for(const R of this.loggers)R.flush()}dispose(){for(const R of this.loggers)R.dispose()}}e.MultiplexLogger=l;class i extends L.Disposable{constructor(R,T,U){if(super(),this.logLevel=R,this.logsHome=T,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,U)for(const $ of U)this._loggers.set($.resource,{logger:void 0,info:$})}getLoggerEntry(R){return(0,u.isString)(R)?[...this._loggers.values()].find(T=>T.info.id===R):this._loggers.get(R)}getLogger(R){return this.getLoggerEntry(R)?.logger}createLogger(R,T){const U=this.toResource(R),$=(0,u.isString)(R)?R:T?.id??(0,r.hash)(U.toString()).toString(16);let q=this._loggers.get(U)?.logger;const ie=T?.logLevel==="always"?S.Trace:T?.logLevel;q||(q=this.doCreateLogger(U,ie??this.getLogLevel(U)??this.logLevel,{...T,id:$}));const oe={logger:q,info:{resource:U,id:$,logLevel:ie,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(oe.info),this._loggers.set(U,oe),q}toResource(R){return(0,u.isString)(R)?(0,f.joinPath)(this.logsHome,`${R}.log`):R}setLogLevel(R,T){if(v.URI.isUri(R)){const U=R,$=T,q=this._loggers.get(U);q&&$!==q.info.logLevel&&(q.info.logLevel=$===this.logLevel?void 0:$,q.logger?.setLevel($),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([U,$]))}else{this.logLevel=R;for(const[U,$]of this._loggers.entries())this._loggers.get(U)?.info.logLevel===void 0&&$.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(R,T){const U=this.getLoggerEntry(R);U&&T!==!U.info.hidden&&(U.info.hidden=!T,this._loggers.set(U.info.resource,U),this._onDidChangeVisibility.fire([U.info.resource,T]))}getLogLevel(R){let T;return R&&(T=this._loggers.get(R)?.info.logLevel),T??this.logLevel}registerLogger(R){const T=this._loggers.get(R.resource);T?T.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this._loggers.set(R.resource,{info:R,logger:void 0}),this._onDidChangeLoggers.fire({added:[R],removed:[]}))}deregisterLogger(R){const T=this._loggers.get(R);T&&(T.logger&&T.logger.dispose(),this._loggers.delete(R),this._onDidChangeLoggers.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const R of this._loggers.values())yield R.info}getRegisteredLogger(R){return this._loggers.get(R)?.info}dispose(){this._loggers.forEach(R=>R.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(R){}getLevel(){return S.Info}trace(R,...T){}debug(R,...T){}info(R,...T){}warn(R,...T){}error(R,...T){}critical(R,...T){}dispose(){}flush(){}}e.NullLogger=n;class a extends n{}e.NullLogService=a;function c(C){if(C.verbose)return S.Trace;if(typeof C.logLevel=="string"){const R=m(C.logLevel.toLowerCase());if(R!==void 0)return R}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function o(C){switch(C){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=o;function m(C){switch(C){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=m,e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",o(S.Info))});var X=this&&this.__param||function(j,e){return function(I,A){e(I,A,j)}};define(ee[214],te([0,1,77,3,2,5,4,7]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class dt extends r.Disposable{constructor(v){super(),this.logService=v,this._onDidChangePassword=this._register(new A.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this._sequencer=new k.SequencerByKey}async getPassword(v,p){this.logService.trace("Getting password from keytar:",v,p);let y;try{y=await this.withKeytar()}catch{return null}return await this._sequencer.queue(v+p,()=>this.doGetPassword(y,v,p))}async doGetPassword(v,p,y){const h=await(0,k.retry)(()=>v.getPassword(p,y),50,3);if(!h)return this.logService.trace("Did not get a password from keytar for account:",y),h;let E,S;try{const s=JSON.parse(h);E=s.content,S=s.hasNextChunk}catch{}if(!E||!S)return this.logService.trace("Got password from keytar for account:",y),h;try{let s=1;for(;S;){const g=await(0,k.retry)(()=>v.getPassword(p,`${y}-${s}`),50,3),d=JSON.parse(g);E+=d.content,S=d.hasNextChunk,s++}return this.logService.trace(`Got ${s}-chunked password from keytar for account:`,y),E}catch(s){return this.logService.error(s),h}}async setPassword(v,p,y){this.logService.trace("Setting password using keytar:",v,p);let h;try{h=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}await this._sequencer.queue(v+p,()=>this.doSetPassword(h,v,p,y)),this._onDidChangePassword.fire({service:v,account:p})}async doSetPassword(v,p,y,h){if(!M.isWindows){await(0,k.retry)(()=>v.setPassword(p,y,h),50,3),this.logService.trace("Set password from keytar for account:",y);return}if(await this.doDeletePassword(v,p,y),h.length<=dt.PASSWORD_CHUNK_SIZE){await(0,k.retry)(()=>v.setPassword(p,y,h),50,3),this.logService.trace("Set password from keytar for account:",y);return}let E=0,S=0,s=!0;const g=[];for(;s;){const d=h.substring(E,E+dt.PASSWORD_CHUNK_SIZE);E+=dt.PASSWORD_CHUNK_SIZE,s=h.length-E>0;const b={content:d,hasNextChunk:s};g.push((0,k.retry)(()=>v.setPassword(p,S?`${y}-${S}`:y,JSON.stringify(b)),50,3)),S++}await Promise.all(g),this.logService.trace(`Set${S?` ${S}-chunked`:""} password from keytar for account:`,y)}async deletePassword(v,p){this.logService.trace("Deleting password using keytar:",v,p);let y;try{y=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const h=await this._sequencer.queue(v+p,()=>this.doDeletePassword(y,v,p));return h&&this._onDidChangePassword.fire({service:v,account:p}),h}async doDeletePassword(v,p,y){const h=await v.getPassword(p,y);if(!h)return this.logService.trace("Did not get a password to delete from keytar for account:",y),!1;let E,S;try{const g=JSON.parse(h);E=g.content,S=g.hasNextChunk}catch{}let s=0;if(E&&S)try{for(s++;S;){const g=`${y}-${s}`,d=await v.getPassword(p,g);await v.deletePassword(p,g),S=JSON.parse(d).hasNextChunk,s++}}catch(g){this.logService.error(g)}return await v.deletePassword(p,y)?(this.logService.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,y),!0):(this.logService.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,y),!1)}async findPassword(v){let p;try{p=await this.withKeytar()}catch{return null}return await p.findPassword(v)}async findCredentials(v){let p;try{p=await this.withKeytar()}catch{return[]}return await p.findCredentials(v)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};f.MAX_PASSWORD_LENGTH=2500,f.PASSWORD_CHUNK_SIZE=f.MAX_PASSWORD_LENGTH-100,f=we([X(0,L.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[215],te([0,1,5]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=class{constructor(L,M){this.machineId=L,this.logService=M}encryption(){return new Promise((L,M)=>j(["vscode-encrypt"],L,M))}async encrypt(L){let M;try{M=await this.encryption()}catch{return L}try{return M.encrypt(this.machineId,L)}catch(k){return this.logService.error(k),L}}async decrypt(L){let M;try{M=await this.encryption()}catch{return L}try{return M.decrypt(this.machineId,L)}catch(k){return this.logService.error(k),L}}};A=we([X(1,I.ILogService)],A),e.EncryptionMainService=A}),define(ee[216],te([0,1,22,7,13,3,2,9,78,5]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends M.Disposable{constructor(y,h){super(),this.logService=y,this.options=h,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new A.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}watch(y,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,h):this.watchNonRecursive(y,h)}watchUniversal(y,h){const E={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive},S=(0,I.insert)(this.universalPathsToWatch,E);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,r.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,f.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&y.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,h){const E={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:!1},S=(0,I.insert)(this.nonRecursivePathsToWatch,E);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,r.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,f.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,k.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(ee[217],te([0,1,22,7,17,23,3,56,71,2,61,14,64,18,60,172,16,114,5,13]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends u.Disposable{constructor(t){super(),this.logService=t,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(t,l){if(this.provider.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.provider.set(t,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:t,provider:l}),i.add(l.onDidChangeFile(n=>this._onDidFilesChange.fire(new s.FileChangesEvent(n,!this.isPathCaseSensitive(l))))),typeof l.onDidWatchError=="function"&&i.add(l.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:t}))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:t,provider:l}),this.provider.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.provider.get(t)}async activateProvider(t){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:t,join(i){l.push(i)}}),!this.provider.has(t)&&await A.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.provider.has(t.scheme)}hasCapability(t,l){const i=this.provider.get(t.scheme);return!!(i&&i.capabilities&l)}listCapabilities(){return f.Iterable.map(this.provider,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async withProvider(t){if(!(0,h.isAbsolutePath)(t))throw new s.FileOperationError((0,S.localize)(0,null,this.resourceForError(t)),8);await this.activateProvider(t.scheme);const l=this.provider.get(t.scheme);if(!l){const i=new b.ErrorNoTelemetry;throw i.message=(0,S.localize)(1,null,t.toString()),i}return l}async withReadProvider(t){const l=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(l)||(0,s.hasReadWriteCapability)(l)||(0,s.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(t){const l=await this.withProvider(t);if((0,s.hasOpenReadWriteCloseCapability)(l)||(0,s.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.doResolveFile(t,l)}catch(i){throw(0,s.toFileSystemProviderErrorCode)(i)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,S.localize)(2,null,this.resourceForError(t)),1):(0,s.ensureFileSystemProviderError)(i)}}async doResolveFile(t,l){const i=await this.withProvider(t),n=this.isPathCaseSensitive(i),a=l?.resolveTo,c=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,m=await i.stat(t);let C;return this.toFileStat(i,t,m,void 0,!!o,(R,T)=>(C||(C=v.TernarySearchTree.forUris(()=>!n),C.set(t,!0),a&&C.fill(!0,a)),C.get(R.resource)||C.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?T===1:!1))}async toFileStat(t,l,i,n,a,c){const{providerExtUri:o}=this.getExtUri(t),m={resource:l,name:o.basename(l),isFile:(i.type&s.FileType.File)!==0,isDirectory:(i.type&s.FileType.Directory)!==0,isSymbolicLink:(i.type&s.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&s.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,s.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&c(m,n)){try{const C=await t.readdir(l),R=await A.Promises.settled(C.map(async([T,U])=>{try{const $=o.joinPath(l,T),q=a?await t.stat($):{type:U};return await this.toFileStat(t,$,q,C.length,a,c)}catch($){return this.logService.trace($),null}}));m.children=(0,I.coalesce)(R)}catch(C){this.logService.trace(C),m.children=[]}return m}return m}async resolveAll(t){return A.Promises.settled(t.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.withProvider(t),i=await l.stat(t);return this.toFileStat(l,t,i,void 0,!0,()=>!1)}async exists(t){const l=await this.withProvider(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.doValidateCreateFile(t,l)}catch(i){return i}return!0}async doValidateCreateFile(t,l){if(!l?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,S.localize)(3,null,this.resourceForError(t)),3,l)}async createFile(t,l=r.VSBuffer.fromString(""),i){await this.doValidateCreateFile(t,i);const n=await this.writeFile(t,l);return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,n)),n}async writeFile(t,l,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),{providerExtUri:a}=this.getExtUri(n);try{await this.validateWriteFile(n,t,i)||await this.mkdirp(n,a.dirname(t));let o;if((0,s.hasReadWriteCapability)(n)&&!(l instanceof r.VSBuffer))if((0,E.isReadableStream)(l)){const m=await(0,E.peekStream)(l,3);m.ended?o=r.VSBuffer.concat(m.buffer):o=m}else o=(0,E.peekReadable)(l,m=>r.VSBuffer.concat(m),3);else o=l;!(0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n)&&o instanceof r.VSBuffer?await this.doWriteUnbuffered(n,t,i,o):await this.doWriteBuffered(n,t,i,o instanceof r.VSBuffer?(0,r.bufferToReadable)(o):o),this._onDidRunOperation.fire(new s.FileOperationEvent(t,4))}catch(c){throw new s.FileOperationError((0,S.localize)(4,null,this.resourceForError(t),(0,s.ensureFileSystemProviderError)(c).toString()),(0,s.toFileOperationResult)(c),i)}return this.resolve(t,{resolveMetadata:!0})}async validateWriteFile(t,l,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(l)));let a;try{a=await t.stat(l)}catch{return}if((a.type&s.FileType.Directory)!==0)throw new s.FileOperationError((0,S.localize)(6,null,this.resourceForError(l)),0,i);if(this.throwIfFileIsReadonly(l,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==s.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,s.etag)({mtime:i.mtime,size:a.size}))throw new s.FileOperationError((0,S.localize)(7,null),3,i);return a}async readFile(t,l,i){const n=await this.withReadProvider(t);return l?.atomic?this.doReadFileAtomic(n,t,l,i):this.doReadFile(n,t,l,i)}async doReadFileAtomic(t,l,i,n){return new Promise((a,c)=>{this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(t,l,i,n);a(o)}catch(o){c(o)}})})}async doReadFile(t,l,i,n){const a=await this.doReadFileStream(t,l,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,r.streamToBuffer)(a.value)}}async readFileStream(t,l,i){const n=await this.withReadProvider(t);return this.doReadFileStream(n,t,l,i)}async doReadFileStream(t,l,i,n){const a=new L.CancellationTokenSource(n),c=this.validateReadFile(l,i).then(m=>m,m=>{throw a.cancel(),m});let o;try{return typeof i?.etag=="string"&&i.etag!==s.ETAG_DISABLED&&await c,i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.readFileUnbuffered(t,l,i):(0,s.hasFileReadStreamCapability)(t)?o=this.readFileStreamed(t,l,a.token,i):o=this.readFileBuffered(t,l,a.token,i),{...await c,value:o}}catch(m){throw o&&await(0,E.consumeStream)(o),this.restoreReadError(m,l,i)}}restoreReadError(t,l,i){const n=(0,S.localize)(8,null,this.resourceForError(l),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new s.FileOperationError(n,(0,s.toFileOperationResult)(t),i)}readFileStreamed(t,l,i,n=Object.create(null)){const a=t.readFileStream(l,n,i);return(0,E.transform)(a,{data:c=>c instanceof r.VSBuffer?c:r.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,l,n)},c=>r.VSBuffer.concat(c))}readFileBuffered(t,l,i,n=Object.create(null)){const a=(0,r.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,l,a,c=>c,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,l,n)},i),a}readFileUnbuffered(t,l,i){const n=(0,E.newWriteableStream)(a=>r.VSBuffer.concat(a));return(async()=>{try{let a;i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?a=await t.readFile(l,{atomic:!0}):a=await t.readFile(l),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.validateReadFileLimits(l,a.byteLength,i),n.end(r.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async validateReadFile(t,l){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new s.FileOperationError((0,S.localize)(9,null,this.resourceForError(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==s.ETAG_DISABLED&&l.etag===i.etag)throw new s.NotModifiedSinceFileOperationError((0,S.localize)(10,null),i,l);return this.validateReadFileLimits(t,i.size,l),i}validateReadFileLimits(t,l,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&l>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&l>i.limits.size&&(n=7),typeof n=="number")throw new s.TooLargeFileOperationError((0,S.localize)(11,null,this.resourceForError(t)),n,l,i)}}async canMove(t,l,i){return this.doCanMoveCopy(t,l,"move",i)}async canCopy(t,l,i){return this.doCanMoveCopy(t,l,"copy",i)}async doCanMoveCopy(t,l,i,n){if(t.toString()!==l.toString())try{const a=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t):await this.withReadProvider(t),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(a,t,c,l,i,n)}catch(a){return a}return!0}async move(t,l,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),c=await this.doMoveCopy(n,t,a,l,"move",!!i),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,c==="move"?2:3,o)),o}async copy(t,l,i){const n=await this.withReadProvider(t),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),c=await this.doMoveCopy(n,t,a,l,"copy",!!i),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,c==="copy"?3:2,o)),o}async doMoveCopy(t,l,i,n,a,c){if(l.toString()===n.toString())return a;const{exists:o,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(t,l,i,n,a,c);if(o&&!m&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),a==="copy"){if(t===i&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(l,n,{overwrite:c});else{const C=await this.resolve(l);C.isDirectory?await this.doCopyFolder(t,C,i,n):await this.doCopyFile(t,l,i,n)}return a}else return t===i?(await t.rename(l,n,{overwrite:c}),a):(await this.doMoveCopy(t,l,i,n,"copy",c),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(t,l,i,n){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(t,l,i,n);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(t,l,i,n);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(t,l,i,n);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.doPipeUnbuffered(t,l,i,n)}async doCopyFolder(t,l,i,n){await i.mkdir(n),Array.isArray(l.children)&&await A.Promises.settled(l.children.map(async a=>{const c=this.getExtUri(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.doCopyFolder(t,await this.resolve(a.resource),i,c):this.doCopyFile(t,a.resource,i,c)}))}async doValidateMoveCopy(t,l,i,n,a,c){let o=!1;if(t===i){const{providerExtUri:C,isPathCaseSensitive:R}=this.getExtUri(t);if(R||(o=C.isEqual(l,n)),o&&a==="copy")throw new Error((0,S.localize)(12,null,this.resourceForError(l),this.resourceForError(n)));if(!o&&C.isEqualOrParent(n,l))throw new Error((0,S.localize)(13,null,this.resourceForError(l),this.resourceForError(n)))}const m=await this.exists(n);if(m&&!o){if(!c)throw new s.FileOperationError((0,S.localize)(14,null,this.resourceForError(l),this.resourceForError(n)),4);if(t===i){const{providerExtUri:C}=this.getExtUri(t);if(C.isEqualOrParent(l,n))throw new Error((0,S.localize)(15,null,this.resourceForError(l),this.resourceForError(n)))}}return{exists:m,isSameResourceWithDifferentPathCase:o}}getExtUri(t){const l=this.isPathCaseSensitive(t);return{providerExtUri:l?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);await this.mkdirp(l,t);const i=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new s.FileOperationEvent(t,0,i)),i}async mkdirp(t,l){const i=[],{providerExtUri:n}=this.getExtUri(t);for(;!n.isEqual(l,n.dirname(l));)try{if(((await t.stat(l)).type&s.FileType.Directory)===0)throw new Error((0,S.localize)(16,null,this.resourceForError(l)));break}catch(a){if((0,s.toFileSystemProviderErrorCode)(a)!==s.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(l)),l=n.dirname(l)}for(let a=i.length-1;a>=0;a--){l=n.joinPath(l,i[a]);try{await t.mkdir(l)}catch(c){if((0,s.toFileSystemProviderErrorCode)(c)!==s.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,l){try{await this.doValidateDelete(t,l)}catch(i){return i}return!0}async doValidateDelete(t,l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(t),t);if(!!l?.useTrash&&!(i.capabilities&4096))throw new Error((0,S.localize)(17,null,this.resourceForError(t)));let a;try{a=await i.stat(t)}catch{}if(a)this.throwIfFileIsReadonly(t,a);else throw new s.FileOperationError((0,S.localize)(18,null,this.resourceForError(t)),1);if(!!!l?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,S.localize)(19,null,this.resourceForError(t)))}return i}async del(t,l){const i=await this.doValidateDelete(t,l),n=!!l?.useTrash,a=!!l?.recursive;await i.delete(t,{recursive:a,useTrash:n}),this._onDidRunOperation.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,l){const i=await this.withProvider(t),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(t,l))return;if(i===n&&(0,s.hasFileCloneCapability)(i))return i.cloneFile(t,l);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(l));const a=this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri);return i===n&&(0,s.hasFileFolderCopyCapability)(i)?a.queue(()=>i.copy(t,l,{overwrite:!0})):a.queue(()=>this.doCopyFile(i,t,n,l))}watch(t,l={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,a=()=>{n=!0};return i.add((0,u.toDisposable)(()=>a())),(async()=>{try{const c=await this.doWatch(t,l);n?(0,u.dispose)(c):a=()=>(0,u.dispose)(c)}catch(c){this.logService.error(c)}})(),i}async doWatch(t,l){const i=await this.withProvider(t),n=(0,k.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(t),l]);let a=this.activeWatchers.get(n);return a||(a={count:0,disposable:i.watch(t,l)},this.activeWatchers.set(n,a)),a.count+=1,(0,u.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,u.dispose)(a.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.activeWatchers)(0,u.dispose)(t.disposable);this.activeWatchers.clear()}async doWriteBuffered(t,l,i,n){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(async()=>{const a=await t.open(l,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(t,a,n):await this.doWriteReadableBufferedQueued(t,a,n)}catch(c){throw(0,s.ensureFileSystemProviderError)(c)}finally{await t.close(a)}})}async doWriteStreamBufferedQueued(t,l,i){let n=0,a;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const c=r.VSBuffer.concat(i.buffer);await this.doWriteBuffer(t,l,c,c.byteLength,n,0),n+=c.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((c,o)=>{(0,E.listenStream)(a,{onData:async m=>{a.pause();try{await this.doWriteBuffer(t,l,m,m.byteLength,n,0)}catch(C){return o(C)}n+=m.byteLength,setTimeout(()=>a.resume())},onError:m=>o(m),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(t,l,i){let n=0,a;for(;(a=i.read())!==null;)await this.doWriteBuffer(t,l,a,a.byteLength,n,0),n+=a.byteLength}async doWriteBuffer(t,l,i,n,a,c){let o=0;for(;o<n;)o+=await t.write(l,a+o,i.buffer,c+o,n-o)}async doWriteUnbuffered(t,l,i,n){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(t,l,i,n))}async doWriteUnbufferedQueued(t,l,i,n){let a;n instanceof r.VSBuffer?a=n:(0,E.isReadableStream)(n)?a=await(0,r.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?a=await(0,r.bufferedStreamToBuffer)(n):a=(0,r.readableToBuffer)(n),await t.writeFile(l,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(t,l,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(t,l,i,n))}async doPipeBufferedQueued(t,l,i,n){let a,c;try{a=await t.open(l,{create:!1}),c=await i.open(n,{create:!0,unlock:!1});const o=r.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,C=0,R=0;do R=await t.read(a,m,o.buffer,C,o.byteLength-C),await this.doWriteBuffer(i,c,o,R,m,C),m+=R,C+=R,C===o.byteLength&&(C=0);while(R>0)}catch(o){throw(0,s.ensureFileSystemProviderError)(o)}finally{await A.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof c=="number"?i.close(c):Promise.resolve()])}}async doPipeUnbuffered(t,l,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(t,l,i,n))}async doPipeUnbufferedQueued(t,l,i,n){return i.writeFile(n,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(t,l,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(t,l,i,n))}async doPipeUnbufferedToBufferedQueued(t,l,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const c=await t.readFile(l);await this.doWriteBuffer(i,a,r.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,s.ensureFileSystemProviderError)(c)}finally{await i.close(a)}}async doPipeBufferedToUnbuffered(t,l,i,n){const a=await(0,r.streamToBuffer)(this.readFileBuffered(t,l,L.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,a)}throwIfFileSystemIsReadonly(t,l){if(t.capabilities&2048)throw new s.FileOperationError((0,S.localize)(20,null,this.resourceForError(l)),6);return t}throwIfFileIsReadonly(t,l){if((l.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,S.localize)(21,null,this.resourceForError(t)),6)}resourceForError(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};w=we([X(0,d.ILogService)],w),e.FileService=w}),define(ee[92],te([0,1,41,293,7,35,17,3,32,2,9,4,18,60,24,176,16,114,216,44,212,211]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(I)}catch(l){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(l)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=k.Event.None,this.resourceLocks=new L.ResourceMap(a=>y.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,p.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:a}=await E.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,a),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(n.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,y.joinPath)(i,c.name))).type:o=this.toType(c),a.push([c.name,o])}catch(o){this.logService.trace(o)}})),a}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let a;return n?.dangling?a=s.FileType.Unknown:i.isFile()?a=s.FileType.File:i.isDirectory()?a=s.FileType.Directory:a=s.FileType.Unknown,n&&(a|=s.FileType.SymbolicLink),a}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let a;for(;a=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await a.wait();const c=new r.Barrier;return this.resourceLocks.set(i,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(i,n){let a;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),a=await this.createResourceLock(i));const c=this.toFilePath(i);return await E.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{a?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,a){const c=(0,h.newWriteableStream)(o=>M.VSBuffer.concat(o.map(m=>M.VSBuffer.wrap(m))).buffer);return(0,g.readFileIntoStream)(this,i,c,o=>o.buffer,{...n,bufferSize:256*1024},a),c}async writeFile(i,n,a){let c;try{const o=this.toFilePath(i);if(!a.create||!a.overwrite){if(await E.Promises.exists(o)){if(!a.overwrite)throw(0,s.createFileSystemProviderError)((0,S.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,s.createFileSystemProviderError)((0,S.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(i,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,n){const a=this.toFilePath(i);let c;(0,s.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(i));let o;try{if((0,s.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:C}=await E.SymlinkSupport.stat(a);C.mode&128||await E.Promises.chmod(a,C.mode|128)}catch(C){this.logService.trace(C)}let m;if((0,s.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await E.Promises.truncate(a,0),m="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}m||(m="w")}else m="r";o=await E.Promises.open(a,m)}catch(m){throw c?.dispose(),(0,s.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(o,0),(0,s.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,i),c){const m=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.mapHandleToLock.set(o,c),m&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),m.dispose())}return o}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await E.Promises.fdatasync(i)}catch(a){t.configureFlushOnWrite(!1),this.logService.error(a)}return await E.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,a,c,o){const m=this.normalizePos(i,n);let C=null;try{C=(await E.Promises.read(i,a,c,o,m)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(i,m,C)}return C}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,a){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof n=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,c+a):this.mapHandleToPos.delete(i)))}async write(i,n,a,c,o){return(0,r.retry)(()=>this.doWrite(i,n,a,c,o),100,3)}async doWrite(i,n,a,c,o){const m=this.normalizePos(i,n);let C=null;try{C=(await E.Promises.write(i,a,c,o,m)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),R)}finally{this.updatePos(i,m,C)}return C}async mkdir(i){try{await E.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const a=this.toFilePath(i);n.recursive?await E.Promises.rm(a,E.RimRafMode.MOVE):await E.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(i,n,a){const c=this.toFilePath(i),o=this.toFilePath(n);if(c!==o)try{await this.validateTargetDeleted(i,n,"move",a.overwrite),await E.Promises.move(c,o)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(2,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(i,n,a){const c=this.toFilePath(i),o=this.toFilePath(n);if(c!==o)try{await this.validateTargetDeleted(i,n,"copy",a.overwrite),await E.Promises.copy(c,o,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(3,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(i,n,a,c){const o=this.toFilePath(i),m=this.toFilePath(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,f.isEqual)(o,m,!0)),C&&a==="copy")throw(0,s.createFileSystemProviderError)((0,S.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(!C&&await E.Promises.exists(m)){if(!c)throw(0,s.createFileSystemProviderError)((0,S.localize)(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,a){const c=this.toFilePath(i),o=this.toFilePath(n),m=!!(this.capabilities&1024);if((0,f.isEqual)(c,o,!m))return;const C=new u.DisposableStore;try{const[R,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);C.add(R),C.add(T),a&&await E.Promises.mkdir((0,v.dirname)(o),{recursive:!0}),await E.Promises.copyFile(c,o)}catch(R){if(R.code==="ENOENT"&&!a)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(R)}finally{C.dispose()}}createUniversalWatcher(i,n,a){return new w.UniversalWatcherClient(c=>i(c),c=>n(c),a)}createNonRecursiveWatcher(i,n,a){return new D.NodeJSWatcherClient(c=>i(c),c=>n(c),a)}toFileSystemProviderError(i){if(i instanceof s.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=s.FileSystemProviderErrorCode.NoPermissions;break;default:n=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let a=this.toFileSystemProviderError(n);if(i&&a.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await E.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(a=(0,s.createFileSystemProviderError)(n,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return a}}t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0,e.DiskFileSystemProvider=t}),define(ee[218],te([0,1,3,92,2,17,60,23]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends r.Disposable{constructor(p,y){super(),this.provider=p,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(p,y,h){const E=this.getUriTransformer(p);switch(y){case"stat":return this.stat(E,h[0]);case"readdir":return this.readdir(E,h[0]);case"open":return this.open(E,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(E,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(E,h[0],h[1],h[2]);case"rename":return this.rename(E,h[0],h[1],h[2]);case"copy":return this.copy(E,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(E,h[0],h[1]);case"mkdir":return this.mkdir(E,h[0]);case"delete":return this.delete(E,h[0],h[1]);case"watch":return this.watch(E,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(p,y,h){const E=this.getUriTransformer(p);switch(y){case"fileChange":return this.onFileChange(E,h[0]);case"readFileStream":return this.onReadFileStream(E,h[0],h[1])}throw new Error(`Unknown event ${y}`)}stat(p,y){const h=this.transformIncoming(p,y,!0);return this.provider.stat(h)}readdir(p,y){const h=this.transformIncoming(p,y);return this.provider.readdir(h)}async readFile(p,y,h){const E=this.transformIncoming(p,y,!0),S=await this.provider.readFile(E,h);return L.VSBuffer.wrap(S)}onReadFileStream(p,y,h){const E=this.transformIncoming(p,y,!0),S=new k.CancellationTokenSource,s=new I.Emitter({onDidRemoveLastListener:()=>{S.cancel()}}),g=this.provider.readFileStream(E,h,S.token);return(0,M.listenStream)(g,{onData:d=>s.fire(L.VSBuffer.wrap(d)),onError:d=>s.fire(d),onEnd:()=>{s.fire("end"),s.dispose(),S.dispose()}}),s.event}writeFile(p,y,h,E){const S=this.transformIncoming(p,y);return this.provider.writeFile(S,h.buffer,E)}open(p,y,h){const E=this.transformIncoming(p,y,!0);return this.provider.open(E,h)}close(p){return this.provider.close(p)}async read(p,y,h){const E=L.VSBuffer.alloc(h),S=0,s=await this.provider.read(p,y,E.buffer,S,h);return[E,s]}write(p,y,h,E,S){return this.provider.write(p,y,h.buffer,E,S)}mkdir(p,y){const h=this.transformIncoming(p,y);return this.provider.mkdir(h)}delete(p,y,h){const E=this.transformIncoming(p,y);return this.provider.delete(E,h)}rename(p,y,h,E){const S=this.transformIncoming(p,y),s=this.transformIncoming(p,h);return this.provider.rename(S,s,E)}copy(p,y,h,E){const S=this.transformIncoming(p,y),s=this.transformIncoming(p,h);return this.provider.copy(S,s,E)}cloneFile(p,y,h){const E=this.transformIncoming(p,y),S=this.transformIncoming(p,h);return this.provider.cloneFile(E,S)}onFileChange(p,y){const h=new I.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(p,h))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return h.event}async watch(p,y,h,E,S){const s=this.sessionToWatcher.get(y);if(s){const g=this.transformIncoming(p,E),d=s.watch(h,g,S);this.watchRequests.set(y+h,d)}}async unwatch(p,y){const h=p+y,E=this.watchRequests.get(h);E&&((0,r.dispose)(E),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,p]of this.watchRequests)p.dispose();this.watchRequests.clear();for(const[,p]of this.sessionToWatcher)p.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class u extends r.Disposable{constructor(p,y,h,E){super(),this.uriTransformer=p,this.logService=h,this.environmentService=E,this.watcherRequests=new Map,this.fileWatcher=this._register(new A.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(p){const y=this._register(new I.Emitter);this._register(y.event(h=>{p.fire(h.map(E=>({resource:this.uriTransformer.transformOutgoingURI(E.resource),type:E.type})))})),this._register(this.fileWatcher.onDidChangeFile(h=>y.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>p.fire(h)))}getRecursiveWatcherOptions(p){}getExtraExcludes(p){}watch(p,y,h){const E=this.getExtraExcludes(this.environmentService);return Array.isArray(E)&&(h.excludes=[...h.excludes,...E]),this.watcherRequests.set(p,this.fileWatcher.watch(y,h)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(p)),this.watcherRequests.delete(p)})}dispose(){super.dispose();for(const[,p]of this.watcherRequests)p.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=u}),define(ee[219],te([0,1,15,175,4,8,16,9,218,151]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class v extends f.AbstractDiskFileSystemProviderChannel{constructor(h,E,S){super(h,E),this.environmentService=S}getUriTransformer(h){return u.DefaultURITransformer}transformIncoming(h,E){return L.URI.revive(E)}async delete(h,E,S){if(!S.useTrash)return super.delete(h,E,S);const s=this.transformIncoming(h,E),g=(0,k.normalize)(s.fsPath);try{await I.shell.trashItem(g)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,A.localize)(0,null,(0,k.basename)(g)):(0,A.localize)(1,null,(0,k.basename)(g)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,E){return new p(h,E,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=v;class p extends f.AbstractSessionFileWatcher{watch(h,E,S){if(S.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(h,E,S)}}}),define(ee[220],te([0,1,5]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class A extends I.AbstractMessageLogger{constructor(L=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(L),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(L){this._logger=L;for(const{level:M,message:k}of this.buffer)(0,I.log)(L,M,k);this.buffer=[]}log(L,M){this._logger?(0,I.log)(this._logger,L,M):this.getLevel()<=L&&this.buffer.push({level:L,message:M})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=A}),define(ee[221],te([0,1,2,5]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends I.Disposable{constructor(M,k=[]){super(),this.logger=new A.MultiplexLogger([M,...k]),this._register(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...k){this.logger.trace(M,...k)}debug(M,...k){this.logger.debug(M,...k)}info(M,...k){this.logger.info(M,...k)}warn(M,...k){this.logger.warn(M,...k)}error(M,...k){this.logger.error(M,...k)}flush(){this.logger.flush()}}e.LogService=r}),define(ee[222],te([0,1,35,8,5]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class L{constructor(k){this.loggerService=k,this.loggers=new I.ResourceMap}listen(k,f,u){switch(f){case"onDidChangeLoggers":return u?this.loggerService.getOnDidChangeLoggersEvent(u):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.loggerService.getOnDidChangeLogLevelEvent(u):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.loggerService.getOnDidChangeVisibilityEvent(u):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(k,f,u){switch(f){case"createLogger":this.createLogger(A.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.log(A.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1]);case"setLogLevel":return(0,r.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(A.URI.revive(u[0]),u[1]);case"setVisibility":return this.loggerService.setVisibility(A.URI.revive(u[0]),u[1]);case"registerLogger":return this.loggerService.registerLogger({...u[0],resource:A.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(A.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}createLogger(k,f,u){this.loggers.set(k,this.loggerService.createLogger(k,f,u))}consoleLog(k,f){let u=console.log;switch(k){case r.LogLevel.Error:u=console.error;break;case r.LogLevel.Warning:u=console.warn;break;case r.LogLevel.Info:u=console.info;break}u.call(console,...f)}log(k,f){const u=this.loggers.get(k);if(!u)throw new Error("Create the logger before logging");for(const[v,p]of f)(0,r.log)(u,v,p)}}e.LoggerChannel=L}),define(ee[223],te([0,1,16,5]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(r||(r={}));async function L(u,v,p,y,h){try{const E=await new Promise((s,g)=>{j(["spdlog"],s,g)});E.setFlushOn(r.Trace);const S=await E.createAsyncRotatingLogger(u,v,p,y);return h?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(E){console.error(E)}return null}function M(u,v,p){switch(v){case A.LogLevel.Trace:u.trace(p);break;case A.LogLevel.Debug:u.debug(p);break;case A.LogLevel.Info:u.info(p);break;case A.LogLevel.Warning:u.warn(p);break;case A.LogLevel.Error:u.error(p);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function k(u,v){switch(v){case A.LogLevel.Trace:u.setLevel(r.Trace);break;case A.LogLevel.Debug:u.setLevel(r.Debug);break;case A.LogLevel.Info:u.setLevel(r.Info);break;case A.LogLevel.Warning:u.setLevel(r.Warning);break;case A.LogLevel.Error:u.setLevel(r.Error);break;case A.LogLevel.Off:u.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class f extends A.AbstractMessageLogger{constructor(v,p,y,h,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(v,p,y,h),this._register(this.onDidChangeLogLevel(S=>{this._logger&&k(this._logger,S)}))}async _createSpdLogLogger(v,p,y,h){const E=y?6:1,S=30/E*I.ByteSize.MB,s=await L(v,p,S,E,h);if(s){this._logger=s,k(this._logger,this.getLevel());for(const{level:g,message:d}of this.buffer)M(this._logger,g,d);this.buffer=[]}}log(v,p){this._logger?M(this._logger,v,p):this.getLevel()<=v&&this.buffer.push({level:v,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(ee[224],te([0,1,31,5,223]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class L extends A.AbstractLoggerService{doCreateLogger(k,f,u){return new r.SpdLogLogger((0,I.generateUuid)(),k.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.LoggerService=L}),define(ee[65],te([0,1,35,3,6,5,224]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(L.ILoggerService);class k extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new I.ResourceMap}createLogger(u,v,p){p!==void 0&&this.loggerResourcesByWindow.set(this.toResource(u),p);try{return super.createLogger(u,v)}catch(y){throw this.loggerResourcesByWindow.delete(this.toResource(u)),y}}registerLogger(u,v){v!==void 0&&this.loggerResourcesByWindow.set(u.resource,v),super.registerLogger(u)}deregisterLogger(u){this.loggerResourcesByWindow.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const v=[];for(const p of super.getRegisteredLoggers())u===this.loggerResourcesByWindow.get(p.resource)&&v.push(p);return v}getOnDidChangeLogLevelEvent(u){return A.Event.filter(this.onDidChangeLogLevel,v=>(0,L.isLogLevel)(v)||this.isInterestedLoggerResource(v[0],u))}getOnDidChangeVisibilityEvent(u){return A.Event.filter(this.onDidChangeVisibility,([v])=>this.isInterestedLoggerResource(v,u))}getOnDidChangeLoggersEvent(u){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,v=>({added:[...v.added].filter(y=>this.isInterestedLoggerResource(y.resource,u)),removed:[...v.removed].filter(y=>this.isInterestedLoggerResource(y.resource,u))})),v=>v.added.length>0||v.removed.length>0)}deregisterLoggers(u){for(const[v,p]of this.loggerResourcesByWindow)p===u&&this.deregisterLogger(v)}isInterestedLoggerResource(u,v){const p=this.loggerResourcesByWindow.get(u);return p===void 0||p===v}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=k}),define(ee[225],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function L(M){return!I(M)&&!A(M)&&!r(M)}e.isMenubarMenuItemAction=L}),define(ee[38],te([0,1,3,71,2,6]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(u){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...u,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(u),A.Iterable.reduce(this.policies.entries(),(p,[y,h])=>({...p,[y]:h}),{})}getPolicyValue(u){return this.policies.get(u)}serialize(){return A.Iterable.reduce(Object.entries(this.policyDefinitions),(u,[v,p])=>({...u,[v]:{definition:p,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=M;class k{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[226],te([0,1,7,3,71,11,16,5,38]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(p,y){const h=[];for(const E of new Set(r.Iterable.concat(p.keys(),y.keys())))p.get(E)!==y.get(E)&&h.push(E);return h}let v=class extends f.AbstractPolicyService{constructor(y,h,E){super(),this.file=y,this.fileService=h,this.logService=E,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const S=A.Event.filter(h.onDidFilesChange,s=>s.affects(y));this._register(h.watch(y)),this._register(S(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const y=new Map;try{const h=await this.fileService.readFile(this.file),E=JSON.parse(h.value.toString());if(!(0,L.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(E))this.policyDefinitions[S]&&y.set(S,E[S])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return y}async refresh(){const y=await this.read(),h=u(this.policies,y);this.policies=y,h.length>0&&this._onDidChange.fire(h)}};v=we([X(1,M.IFileService),X(2,k.ILogService)],v),e.FilePolicyService=v}),define(ee[227],te([0,1,3,2,38]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(f){this.service=f,this.disposables=new A.DisposableStore}listen(f,u){switch(u){case"onDidChange":return I.Event.map(this.service.onDidChange,v=>v.reduce((p,y)=>({...p,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${u}`)}call(f,u,v){switch(u){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(v)}throw new Error(`Call not found: ${u}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class M extends r.AbstractPolicyService{constructor(f,u){super(),this.channel=u;for(const v in f){const{definition:p,value:y}=f[v];this.policyDefinitions[v]=p,y!==void 0&&this.policies.set(v,y)}this.channel.listen("onDidChange")(v=>{for(const p in v){const y=v[p];y===null?this.policies.delete(p):this.policies.set(p,y)}this._onDidChange.fire(Object.keys(v))})}async _updatePolicyDefinitions(f){const u=await this.channel.call("updatePolicyDefinitions",f);for(const v in u)this.policies.set(v,u[v])}}e.PolicyChannelClient=M}),define(ee[228],te([0,1,38,7,294,2,5]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends I.AbstractPolicyService{constructor(u,v){super(),this.logService=u,this.productName=v,this.throttler=new A.Throttler,this.watcher=this._register(new L.MutableDisposable)}async _updatePolicyDefinitions(u){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.throttler.queue(()=>new Promise((v,p)=>{try{this.watcher.value=(0,r.createWatcher)(this.productName,u,y=>{this._onDidPolicyChange(y),v()})}catch(y){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),p(y)}}))}_onDidPolicyChange(u){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const v in u){const p=u[v];p===void 0?this.policies.delete(v):this.policies.set(v,p)}this._onDidChange.fire(Object.keys(u))}};k=we([X(0,M.ILogService)],k),e.NativePolicyService=k}),define(ee[66],te([0,1,14,4,36,109]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.context<"u"){const k=A.globals.vscode.context.configuration();if(k)M=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){M=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:f,itemUrl:u,controlUrl:v}=M.extensionsGallery||{};Object.assign(M,{extensionsGallery:{serviceUrl:r.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:r.env.VSCODE_GALLERY_SEARCH_URL||f,itemUrl:r.env.VSCODE_GALLERY_ITEM_URL||u,controlUrl:r.env.VSCODE_GALLERY_CONTROL_URL||v}});try{const p=(...S)=>S.reduce((s,g)=>(Object.keys(g).forEach(d=>{Array.isArray(s[d])&&Array.isArray(g[d])?s[d]=g[d]:typeof s[d]=="object"&&typeof g[d]=="object"?s[d]=p(s[d],g[d]):s[d]=g[d]}),s),{}),y=(0,L.getUserDataPath)({},M.nameShort),h=A.isWindows?`file:///${y}/product.json`:`file://${y}/product.json`,E=j.__$__nodeRequire(I.FileAccess.asFileUri(h).fsPath);M=p(M,E)}catch{}if(r.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),!M.version){const p=globalThis._VSCODE_PACKAGE_JSON;Object.assign(M,{version:p.version,release:p.release})}}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(ee[21],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[229],te([0,1,83,5,21]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=class{constructor(k,f){this.productService=k,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(k,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,v,p]=u;let y=this.trustedExtensionUrlPublicKeys.get(k);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[k],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.trustedExtensionUrlPublicKeys.set(k,[...y])}const h=Buffer.from(decodeURIComponent(p),"base64");if(h.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const E=h.slice(0,6),S=h.readUIntBE(0,6),s=Date.now()-S;if(s<0||s>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const g=h.slice(6),d=I.createVerify("SHA256");d.write(E),d.write(Buffer.from(v)),d.end();for(let b=0;b<y.length;b++){let w=y[b];if(w!==null){if(typeof w=="string")try{w=I.createPublicKey({key:Buffer.from(w,"base64"),format:"der",type:"spki"}),y[b]=w}catch(D){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${k}:`,D),y[b]=null;continue}if(d.verify(w,g))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};L=we([X(0,r.IProductService),X(1,A.ILogService)],L),e.ExtensionUrlTrustService=L}),define(ee[230],te([0,1,7,5]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(M,k,f){this._window=M,this._sessionId=k,this._logService=f}async inspect(M){await this._connect();const k=this._window.webContents.debugger;await k.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(M);const f=await k.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),f.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};r=we([X(2,A.ILogService)],r),e.WindowProfiler=r}),define(ee[67],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,129,11]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(M,k){I.ok(A.isString(M)),I.ok(A.isObject(k)),I.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,k)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new r}),define(ee[231],te([0,1,3,51]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,u){this.schemasById[r(f)]=u,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new L;A.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[68],te([0,1,22,3,11,160,19,231,51]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=f.Registry.as(k.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const i=new Set;this.doRegisterConfigurations(t,l,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const l=new Set;this.doDeregisterConfigurations(t,l),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:t,remove:l}){const i=new Set;this.doDeregisterConfigurations(l,i),this.doRegisterConfigurations(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}registerDefaultConfigurations(t){const l=new Set;this.doRegisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,l){const i=[];for(const{overrides:n,source:a}of t)for(const c in n)if(l.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.configurationDefaultsOverrides.get(c),m=o?.valuesSources??new Map;if(a)for(const U of Object.keys(n[c]))m.set(U,a);const C={...o?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:a,value:C,valuesSources:m});const R=(0,M.getLanguageTagSettingPlainKey)(c),T={type:"object",default:C,description:L.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:r.isString(a)?void 0:a,defaultValueSource:a};i.push(...S(c)),this.configurationProperties[c]=T,this.defaultLanguageConfigurationOverridesNode.properties[c]=T}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:a});const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.doRegisterOverrideIdentifiers(i)}deregisterDefaultConfigurations(t){const l=new Set;this.doDeregisterDefaultConfigurations(t,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,l){for(const{overrides:i,source:n}of t)for(const a in i){const c=this.configurationDefaultsOverrides.get(a),o=r.isString(n)?n:n?.id,m=r.isString(c?.source)?c?.source:c?.source?.id;if(o===m)if(l.add(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const C=this.configurationProperties[a];C&&(this.updatePropertyDefaultValue(a,C),this.updateSchema(a,C))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let l=!1;const i=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,i),l=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,i),l=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,i),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const l of t)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,l,i){t.forEach(n=>{this.validateAndRegisterProperties(n,l,n.extensionInfo,n.restrictedProperties,void 0,i),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(t,l){const i=n=>{if(n.properties)for(const a in n.properties){l.add(a);const c=this.configurationProperties[a];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,n.properties[a])}n.allOf?.forEach(a=>i(a))};for(const n of t){i(n);const a=this.configurationContributors.indexOf(n);a!==-1&&this.configurationContributors.splice(a,1)}}validateAndRegisterProperties(t,l=!0,i,n,a=3,c){a=r.isUndefinedOrNull(t.scope)?a:t.scope;const o=t.properties;if(o)for(const C in o){const R=o[C];if(l&&b(C,R)){delete o[C];continue}if(R.source=i,R.defaultDefaultValue=o[C].default,this.updatePropertyDefaultValue(C,R),e.OVERRIDE_PROPERTY_REGEX.test(C)?R.scope=void 0:(R.scope=r.isUndefinedOrNull(R.scope)?a:R.scope,R.restricted=r.isUndefinedOrNull(R.restricted)?!!n?.includes(C):R.restricted),o[C].hasOwnProperty("included")&&!o[C].included){this.excludedConfigurationProperties[C]=o[C],delete o[C];continue}else this.configurationProperties[C]=o[C],o[C].policy?.name&&this.policyConfigurations.set(o[C].policy.name,C);!o[C].deprecationMessage&&o[C].markdownDeprecationMessage&&(o[C].deprecationMessage=o[C].markdownDeprecationMessage),c.add(C)}const m=t.allOf;if(m)for(const C of m)this.validateAndRegisterProperties(C,l,i,n,a,c)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const l=i=>{const n=i.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);i.allOf?.forEach(l)};l(t)}updateSchema(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.resourceLanguageSettingsSchema.properties[t]=l;break}}removeFromSchema(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const l=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,l){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,a=i?.source;r.isUndefined(n)&&(n=l.defaultDefaultValue,a=void 0),r.isUndefined(n)&&(n=g(l.type)),l.default=n,l.defaultValueSource=a}}const h="\\[([^\\]]+)\\]",E=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let l=E.exec(D);for(;l?.length;){const i=l[1].trim();i&&t.push(i),l=E.exec(D)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=S;function s(D){return D.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=s;function g(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const d=new y;f.Registry.add(e.Extensions.Configuration,d);function b(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?L.localize(7,null,D):d.getConfigurationProperties()[D]!==void 0?L.localize(8,null,D):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,D,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function w(){const D=[],t=d.getConfigurationProperties();for(const l of Object.keys(t))D.push([l,t[l].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=w}),define(ee[115],te([0,1,22,3,43,2,35,37,11,8,19,68,51]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(l){return Object.isFrozen(l)?l:k.deepFreeze(l)}class E{constructor(i={},n=[],a=[],c){this._contents=i,this._keys=n,this._overrides=a,this.raw=c,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const a=new S("");return a.parseRaw(n),a.configurationModel});this._rawConfiguration=i.reduce((n,a)=>a===n?a:n.merge(a),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,v.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const a=this.rawConfiguration.getValue(i),c=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):a;return{value:a,override:c,merged:o}}getOverrideValue(i,n){const a=this.getContentsForOverrideIdentifer(n);return a?i?(0,v.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const a of this.overrides)a.identifiers.includes(i)&&n.push(...a.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return I.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),a=k.deepClone(this.overrides),c=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const m of i)if(o.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.mergeContents(n,m.contents);for(const C of m.overrides){const[R]=a.filter(T=>I.equals(T.identifiers,C.identifiers));R?(this.mergeContents(R.contents,C.contents),R.keys.push(...C.keys),R.keys=I.distinct(R.keys)):a.push(k.deepClone(C))}for(const C of m.keys)c.indexOf(C)===-1&&c.push(C)}return new E(n,c,a,o.every(m=>m instanceof E)?void 0:o)}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const c of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[c];const m=n[c];m&&(typeof o=="object"&&typeof m=="object"?(o=k.deepClone(o),this.mergeContents(o,m)):o=m),a[c]=o}return new E(a,this.keys,this.overrides)}mergeContents(i,n){for(const a of Object.keys(n)){if(a in i&&f.isObject(i[a])&&f.isObject(n[a])){this.mergeContents(i[a],n[a]);continue}i[a]=k.deepClone(n[a])}}getContentsForOverrideIdentifer(i){let n=null,a=null;const c=o=>{o&&(a?this.mergeContents(a,o):a=k.deepClone(o))};for(const o of this.overrides)I.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&c(o.contents);return c(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.updateValue(i,n,!0)}setValue(i,n){this.updateValue(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,v.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(a=>I.equals(a.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}updateValue(i,n,a){(0,v.addToValueTree)(this.contents,i,n,c=>console.error(c)),a=a||this.keys.indexOf(i)===-1,a&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,v.toValuesTree)(this.contents[i],c=>console.error(c))})}}e.ConfigurationModel=E;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!f.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:a,keys:c,overrides:o,restricted:m,hasExcludedProperties:C}=this.doParseRaw(i,n);this._configurationModel=new E(a,c,o,C?[i]:void 0),this._restrictedConfigurations=m||[]}doParseContent(i){let n={},a=null,c=[];const o=[],m=[];function C(T){Array.isArray(c)?c.push(T):a!==null&&(c[a]=T)}const R={onObjectBegin:()=>{const T={};C(T),o.push(c),c=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{const T=[];C(T),o.push(c),c=T,a=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:C,onError:(T,U,$)=>{m.push({error:T,offset:U,length:$})}};if(i)try{r.visit(i,R),n=c[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return n}doParseRaw(i,n){const a=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),c=this.filter(i,a,!0,n);i=c.raw;const o=(0,v.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),m=Object.keys(i),C=this.toOverrides(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:o,keys:m,overrides:C,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}filter(i,n,a,c){let o=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const m={},C=[];for(const R in i)if(p.OVERRIDE_PROPERTY_REGEX.test(R)&&a){const T=this.filter(i[R],n,!1,c);m[R]=T.raw,o=o||T.hasExcludedProperties,C.push(...T.restricted)}else{const T=n[R],U=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&C.push(R),(U===void 0||c.scopes===void 0||c.scopes.includes(U))&&!(c.skipRestricted&&T?.restricted)?m[R]=i[R]:o=!0}return{raw:m,restricted:C,hasExcludedProperties:o}}toOverrides(i,n){const a=[];for(const c of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(c)){const o={};for(const m in i[c])o[m]=i[c][m];a.push({identifiers:(0,p.overrideIdentifiersFromKey)(c),keys:Object.keys(o),contents:(0,v.toValuesTree)(o,n)})}return a}}e.ConfigurationModelParser=S;class s extends L.Disposable{constructor(i,n,a,c){super(),this.userSettingsResource=i,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.any(A.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),A.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&a.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=s;class g{constructor(i,n,a,c,o,m,C,R,T,U,$,q,ie){this.key=i,this.overrides=n,this._value=a,this.overrideIdentifiers=c,this.defaultConfiguration=o,this.policyConfiguration=m,this.applicationConfiguration=C,this.userConfiguration=R,this.localUserConfiguration=T,this.remoteUserConfiguration=U,this.workspaceConfiguration=$,this.folderConfigurationModel=q,this.memoryConfigurationModel=ie}get value(){return h(this._value)}inspect(i,n,a){const c=i.inspect(n,a);return{get value(){return h(c.value)},get override(){return h(c.override)},get merged(){return h(c.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(i,n,a,c,o=new E,m=new E,C=new M.ResourceMap,R=new E,T=new M.ResourceMap){this._defaultConfiguration=i,this._policyConfiguration=n,this._applicationConfiguration=a,this._localUserConfiguration=c,this._remoteUserConfiguration=o,this._workspaceConfiguration=m,this._folderConfigurations=C,this._memoryConfiguration=R,this._memoryConfigurationByResource=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(i,n,a){return this.getConsolidatedConfigurationModel(i,n,a).getValue(i)}updateValue(i,n,a={}){let c;a.resource?(c=this._memoryConfigurationByResource.get(a.resource),c||(c=new E,this._memoryConfigurationByResource.set(a.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(i):c.setValue(i,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,a){const c=this.getConsolidatedConfigurationModel(i,n,a),o=this.getFolderConfigurationModelForResource(n.resource,a),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,C=new Set;for(const R of c.overrides)for(const T of R.identifiers)c.getOverrideValue(i,T)!==void 0&&C.add(T);return new g(i,n,c.getValue(i),C.size?[...C]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this._workspaceConfiguration:void 0,o||void 0,m)}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const a=[];if(!n){const{added:c,updated:o,removed:m}=D(this._defaultConfiguration,i);n=[...c,...o,...m]}for(const c of n)for(const o of(0,p.overrideIdentifiersFromKey)(c)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),C=i.getKeysForOverrideIdentifier(o),R=[...C.filter(T=>m.indexOf(T)===-1),...m.filter(T=>C.indexOf(T)===-1),...m.filter(T=>!k.equals(this._defaultConfiguration.override(o).getValue(T),i.override(o).getValue(T)))];a.push([o,R])}return this.updateDefaultConfiguration(i),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:a,removed:c}=D(this._policyConfiguration,i),o=[...n,...a,...c];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=D(this.applicationConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateApplicationConfiguration(i),{keys:m,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=D(this.localUserConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=D(this.remoteUserConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=D(this.workspaceConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const a=this.folderConfigurations.get(i),{added:c,updated:o,removed:m,overrides:C}=D(a,n),R=[...c,...o,...m];return(R.length||!a)&&this.updateFolderConfiguration(i,n),{keys:R,overrides:C}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:c,removed:o,overrides:m}=D(n,void 0);return{keys:[...a,...c,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,n,a){let c=this.getConsolidatedConfigurationModelForResource(n,a);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:i},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const c=n.getFolder(i);c&&(a=this.getFolderConsolidatedConfiguration(c.uri)||a);const o=this._memoryConfigurationByResource.get(i);o&&(a=a.merge(o))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(i);c?(n=a.merge(c),this._foldersConsolidatedConfigurations.set(i,n)):n=a}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const a=n.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:a,overrides:c,keys:o}=this._folderConfigurations.get(n);return i.push([n,{contents:a,overrides:c,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this._workspaceConfiguration.keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(a=>i.add(a))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(c=>n.add(c))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.policy),c=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),m=this.parseConfigurationModel(i.workspace),C=i.folders.reduce((R,T)=>(R.set(u.URI.revive(T[0]),this.parseConfigurationModel(T[1])),R),new M.ResourceMap);return new d(n,a,c,o,new E,m,C,new E,new M.ResourceMap)}static parseConfigurationModel(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=d;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,n=new Map;for(const c of l)c.keys.forEach(o=>i.add(o)),c.overrides.forEach(([o,m])=>{const C=(0,M.getOrSet)(n,o,new Set);m.forEach(R=>C.add(R))});const a=[];return n.forEach((c,o)=>a.push([o,[...c.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=b;class w{constructor(i,n,a,c){this.change=i,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=c,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const m of o)this.affectedKeys.add(m);this._affectsConfigStr=this._marker;for(const o of this.affectedKeys)this._affectsConfigStr+=o+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){const a=this._marker+i,c=this._affectsConfigStr.indexOf(a);if(c<0)return!1;const o=c+a.length;if(o>=this._affectsConfigStr.length)return!1;const m=this._affectsConfigStr.charCodeAt(o);if(m!==this._markerCode1&&m!==this._markerCode2)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,R=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!k.equals(C,R)}return!0}}e.ConfigurationChangeEvent=w;function D(l,i){const{added:n,removed:a,updated:c}=t(i?.rawConfiguration,l?.rawConfiguration),o=[],m=l?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const R=C.filter(T=>!m.includes(T));for(const T of R)o.push([T,i.getKeysForOverrideIdentifier(T)])}if(l){const R=m.filter(T=>!C.includes(T));for(const T of R)o.push([T,l.getKeysForOverrideIdentifier(T)])}if(i&&l){for(const R of m)if(C.includes(R)){const T=t({contents:l.getOverrideValue(void 0,R)||{},keys:l.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});o.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:a,updated:c,overrides:o}}function t(l,i){const n=l?i?l.keys.filter(o=>i.keys.indexOf(o)===-1):[...l.keys]:[],a=i?l?i.keys.filter(o=>l.keys.indexOf(o)===-1):[...i.keys]:[],c=[];if(l&&i){for(const o of i.keys)if(l.keys.indexOf(o)!==-1){const m=(0,v.getConfigurationValue)(i.contents,o),C=(0,v.getConfigurationValue)(l.contents,o);k.equals(m,C)||c.push(o)}}return{added:n,removed:a,updated:c}}}),define(ee[232],te([0,1,22,3,2,37,11,115,68,5,38,51]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(p.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(s),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(s,g){this.updateConfigurationModel(s,p.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:s})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new k.ConfigurationModel;const s=p.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(s),s)}updateConfigurationModel(s,g){const d=this.getConfigurationDefaultOverrides();for(const b of s){const w=d[b],D=g[b];w!==void 0?this._configurationModel.addValue(b,w):D?this._configurationModel.addValue(b,D.default):this._configurationModel.removeValue(b)}}}e.DefaultConfiguration=y;class h{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let E=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(s,g,d){super(),this.defaultConfiguration=s,this.policyService=g,this.logService=d,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new k.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(s=>this.onDidChangePolicies(s))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:s})=>this.update(await this.updatePolicyDefinitions(s),!0))),this._configurationModel}async updatePolicyDefinitions(s){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",s);const g={},d=[],b=p.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const w of s){const D=b[w];if(!D){d.push(w);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.logService.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}d.push(w),g[D.policy.name]={type:D.type}}}return(0,M.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),d}onDidChangePolicies(s){this.logService.trace("PolicyConfiguration#onDidChangePolicies",s);const g=p.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),d=(0,I.coalesce)(s.map(b=>g.get(b)));this.update(d,!0)}update(s,g){this.logService.trace("PolicyConfiguration#update",s);const d=p.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),b=[],w=this._configurationModel.isEmpty();for(const D of s){const t=d[D]?.policy?.name;if(t){const l=this.policyService.getPolicyValue(t);(w?l!==void 0:!(0,L.equals)(this._configurationModel.getValue(D),l))&&b.push([D,l])}else this._configurationModel.getValue(D)!==void 0&&b.push([D,void 0])}if(b.length){this.logService.trace("PolicyConfiguration#changed",b);const D=this._configurationModel;this._configurationModel=new k.ConfigurationModel;for(const t of D.keys)this._configurationModel.setValue(t,D.getValue(t));for(const[t,l]of b)l===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,l);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=we([X(1,v.IPolicyService),X(2,u.ILogService)],E),e.PolicyConfiguration=E}),define(ee[233],te([0,1,7,3,2,18,19,115,232,38]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends r.Disposable{constructor(y,h,E,S){super(),this.settingsResource=y,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=E instanceof u.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,E,S)),this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,h)),this.configuration=new k.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:g})=>this.onDidDefaultConfigurationChange(s,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,h,E]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new k.Configuration(y,h,new k.ConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(y,h){const E=typeof y=="string"?y:void 0,S=(0,M.isConfigurationOverrides)(y)?y:(0,M.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(E,S,void 0)}updateValue(y,h,E,S){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const h=this.configuration.toData(),E=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(E,h,2)}onDidDefaultConfigurationChange(y,h){const E=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(y,h);this.trigger(S,E,7)}onDidPolicyConfigurationChange(y){const h=this.configuration.toData(),E=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(E,h,7)}trigger(y,h,E){const S=new k.ConfigurationChangeEvent(y,{data:h},this.configuration);S.source=E,S.sourceConfig=this.getTargetConfiguration(E),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(ee[234],te([0,1,13,6]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var r;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(r=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends I.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof L&&f._code===r.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof L&&f._code===r.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof L&&f._code===r.NoResolverFound}static isHandled(f){return f instanceof L&&f.isHandled}constructor(f,u=r.Unknown,v){super(f),this._message=f,this._code=u,this._detail=v,this.isHandled=u===r.NotAvailable&&v===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function M(k){const f=k.indexOf("+");return f===-1?k:k.substring(0,f)}e.getRemoteAuthorityPrefix=M}),define(ee[57],te([0,1,14]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(u){return u.scheme===I.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=A;function r(u){if(!u)return;const v=u.indexOf("+");return v<0?u:u.substr(0,v)}e.getRemoteName=r;function L(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=L;function M(u){const{host:v,port:p}=f(u);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:p}}e.parseAuthorityWithPort=M;function k(u,v){let{host:p,port:y}=f(u);return typeof y>"u"&&(y=v),{host:p,port:y}}e.parseAuthorityWithOptionalPort=k;function f(u){const v=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const p=u.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const y=u.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:u,port:void 0}}}),define(ee[116],te([0,1,26,6,57]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(M=e.ExtensionType||(e.ExtensionType={}));var k;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,g){if(typeof s>"u"||s===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof s=="string"||typeof g=="string"){const d=typeof s=="string"?s:s.value,b=typeof g=="string"?g:g.value;return I.equalsIgnoreCase(d,b)}return s._lower===g._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=f;class u{get size(){return this._set.size}constructor(s){if(this._set=new Set,s)for(const g of s)this.add(g)}add(s){this._set.add(f.toKey(s))}delete(s){return this._set.delete(f.toKey(s))}has(s){return this._set.has(f.toKey(s))}}e.ExtensionIdentifierSet=u;class v{constructor(){this._map=new Map}clear(){this._map.clear()}delete(s){this._map.delete(f.toKey(s))}get(s){return this._map.get(f.toKey(s))}has(s){return this._map.has(f.toKey(s))}set(s,g){this._map.set(f.toKey(s),g)}values(){return this._map.values()}forEach(s){this._map.forEach(s)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=v;function p(S){return y(S)}e.isApplicationScopedExtension=p;function y(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function h(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function E(S,s){if(s){const g=`onResolveRemoteAuthority:${(0,r.getRemoteName)(s)}`;return!!S.activationEvents?.includes(g)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[235],te([0,1,7,17,23,13,3,2,64,74,31,105,234,57]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var S;(function(P){P[P.Management=1]="Management",P[P.ExtensionHost=2]="ExtensionHost",P[P.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function s(P){switch(P){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(P){const O=new r.CancellationTokenSource;return setTimeout(()=>O.cancel(),P),O.token}function d(P,O){if(P.isCancellationRequested||O.isCancellationRequested)return r.CancellationToken.Cancelled;const F=new r.CancellationTokenSource;return P.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class b{get didTimeout(){return this._state==="timedout"}constructor(O){this._state="pending",this._disposables=new k.DisposableStore,this.promise=new Promise((F,B)=>{this._resolvePromise=F,this._rejectPromise=B}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function w(P,O){const F=new b(O);return F.registerDisposable(P.onControlMessage(B=>{const N=JSON.parse(B.toString()),z=H(N);z?F.reject(z):F.resolve(N)})),F.promise}function D(P,O,F,B,N,z,V,se,de){const ye=new b(de),ke=u.StopWatch.create(!1);return P.info(`Creating a socket (${se})...`),f.mark(`code/willCreateSocket/${V}`),O.connect(F,B,N,z,se,(Ae,_e)=>{ye.didTimeout?(f.mark(`code/didCreateSocketError/${V}`),P.info(`Creating a socket (${se}) finished after ${ke.elapsed()} ms, but this is too late and has timed out already.`),Ae&&P.error(Ae),_e?.dispose()):Ae||!_e?(f.mark(`code/didCreateSocketError/${V}`),P.info(`Creating a socket (${se}) returned an error after ${ke.elapsed()} ms.`),ye.reject(Ae)):(f.mark(`code/didCreateSocketOK/${V}`),P.info(`Creating a socket (${se}) was successful after ${ke.elapsed()} ms.`),ye.resolve(_e))}),ye.promise}function t(P,O){const F=new b(O);return P.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function l(P,O,F,B){const N=Z(P,O);P.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let z;try{z=await D(P.logService,P.socketFactory,P.host,P.port,(0,h.getRemoteServerRootPath)(P),`reconnectionToken=${P.reconnectionToken}&reconnection=${P.reconnectionProtocol?"true":"false"}`,s(O),`renderer-${s(O)}-${P.reconnectionToken}`,B)}catch(ke){throw P.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),P.logService.error(ke),ke}P.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let V,se;P.reconnectionProtocol?(P.reconnectionProtocol.beginAcceptReconnection(z,null),V=P.reconnectionProtocol,se=!1):(V=new p.PersistentProtocol({socket:z,measureRoundTripTime:!0}),se=!0),P.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const de=await t(P.signService.createNewMessage((0,v.generateUuid)()),B),ye={type:"auth",auth:P.connectionToken||"00000000000000000000",data:de.data};V.sendControl(A.VSBuffer.fromString(JSON.stringify(ye)));try{const ke=await w(V,d(B,g(1e4)));if(ke.type!=="sign"||typeof ke.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(P.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(P.signService.validate(de,ke.signedData),B)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const _e=await t(P.signService.sign(ke.data),B),Oe={type:"connectionType",commit:P.commit,signedData:_e,desiredConnectionType:O};return F&&(Oe.args=F),P.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(A.VSBuffer.fromString(JSON.stringify(Oe))),{protocol:V,ownsProtocol:se}}catch(ke){throw ke&&ke.code==="ETIMEDOUT"&&(P.logService.error(`${N} the handshake timed out. Error:`),P.logService.error(ke)),ke&&ke.code==="VSCODE_CONNECTION_ERROR"&&(P.logService.error(`${N} received error control message when negotiating connection. Error:`),P.logService.error(ke)),se&&W(V),ke}}async function i(P,O,F,B){const N=Date.now(),z=Z(P,O),{protocol:V,ownsProtocol:se}=await l(P,O,F,B),de=new b(B);return de.registerDisposable(V.onControlMessage(ye=>{const ke=JSON.parse(ye.toString()),Ae=H(ke);Ae?(P.logService.error(`${z} received error control message when negotiating connection. Error:`),P.logService.error(Ae),se&&W(V),de.reject(Ae)):(P.reconnectionProtocol?.endAcceptReconnection(),P.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${_(N)}!`),de.resolve({protocol:V,firstMessage:ke}))})),de.promise}async function n(P,O){const{protocol:F}=await i(P,1,void 0,O);return{protocol:F}}async function a(P,O,F){const{protocol:B,firstMessage:N}=await i(P,2,O,F),z=N&&N.debugPort;return{protocol:B,debugPort:z}}async function c(P,O,F){const B=Date.now(),N=Z(P,3),{protocol:z}=await l(P,3,O,F);return P.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${_(B)}!`),z}async function o(P,O,F){const{host:B,port:N,connectionToken:z}=await P.addressProvider.getAddress();return{commit:P.commit,quality:P.quality,host:B,port:N,connectionToken:z,reconnectionToken:O,reconnectionProtocol:F,socketFactory:P.socketFactory,signService:P.signService,logService:P.logService}}async function m(P,O,F){return R(P,async B=>{const{protocol:N}=await n(B,r.CancellationToken.None);return new Y(P,O,F,B.reconnectionToken,N)})}e.connectRemoteAgentManagement=m;async function C(P,O){return R(P,async F=>{const{protocol:B,debugPort:N}=await a(F,O,r.CancellationToken.None);return new x(P,O,F.reconnectionToken,B,N)})}e.connectRemoteAgentExtensionHost=C;async function R(P,O){for(let B=1;;B++)try{const N=(0,v.generateUuid)(),z=await o(P,N,null);return await O(z)}catch(N){if(B<5)P.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),P.logService.error(N);else throw P.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),P.logService.error(N),K.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(N)),N}}async function T(P,O,F){const B=await o(P,(0,v.generateUuid)(),null);return await c(B,{host:O,port:F},r.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function U(P){return(0,I.createCancelablePromise)(O=>new Promise((F,B)=>{const N=setTimeout(F,P*1e3);O.onCancellationRequested(()=>{clearTimeout(N),F()})}))}var $;(function(P){P[P.ConnectionLost=0]="ConnectionLost",P[P.ReconnectionWait=1]="ReconnectionWait",P[P.ReconnectionRunning=2]="ReconnectionRunning",P[P.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",P[P.ConnectionGain=4]="ConnectionGain",P[P.ConnectionHealthChanged=5]="ConnectionHealthChanged"})($=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class q{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.ConnectionLostEvent=q;class ie{constructor(O,F,B,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ie;class oe{constructor(O,F,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=oe;class ae{constructor(O,F,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.ConnectionGainEvent=ae;class he{constructor(O,F){this.reconnectionToken=O,this.connectionHealth=F,this.type=5}}e.ConnectionHealthChangedEvent=he;class ce{constructor(O,F,B,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class K extends k.Disposable{static triggerPermanentFailure(O,F,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=F,this._permanentFailureHandled=B,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(O=>O._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(O=>O._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(O,F,B,N,z){super(),this._connectionType=O,this._options=F,this.reconnectionToken=B,this.protocol=N,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ae(this.reconnectionToken,0,0)),this._register(N.onSocketClose(V=>{const se=re(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(V=>{const se=re(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(N.onHighRoundTripTime(V=>{const se=ne(this._connectionType,this.reconnectionToken);this._options.logService.info(`${se} high roundtrip time: ${V.roundTripTime}ms (${V.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(N.onDidChangeConnectionHealth(V=>{this._onDidStateChange.fire(new he(this.reconnectionToken,V))})),K._instances.push(this),this._register((0,k.toDisposable)(()=>{const V=K._instances.indexOf(this);V>=0&&K._instances.splice(V,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const O=re(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<F.length?F[B]:F[F.length-1];try{if(N>0){const V=U(N);this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,V)),this._options.logService.info(`${O} waiting for ${N} seconds before reconnecting...`);try{await V}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${O} resolving connection...`);const z=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${z.host}:${z.port}...`),await this._reconnect(z,g(E)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,L.isCancellationError)(z)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,y.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(O,F,B){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(O,F,B):this._gotoPermanentFailure(O,F,B)}_gotoPermanentFailure(O,F,B){this._onDidStateChange.fire(new ce(this.reconnectionToken,O,F,B)),W(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[],e.PersistentConnection=K;class Y extends K{constructor(O,F,B,N,z){super(1,O,N,z,!0),this.client=this._register(new p.Client(z,{remoteAuthority:F,clientId:B},O.ipcLogger))}async _reconnect(O,F){await n(O,F)}}e.ManagementPersistentConnection=Y;class x extends K{constructor(O,F,B,N,z){super(2,O,B,N,!1),this._startArguments=F,this.debugPort=z}async _reconnect(O,F){await a(O,this._startArguments,F)}}e.ExtensionHostPersistentConnection=x;function W(P){try{P.acceptDisconnect();const O=P.getSocket();P.dispose(),O.dispose()}catch(O){(0,L.onUnexpectedError)(O)}}function H(P){if(P&&P.type==="error"){const O=new Error(`Connection error: ${P.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function Q(P,O){for(;P.length<O;)P+=" ";return P}function ne(P,O){return`[remote-connection][${Q(s(P),13)}][${O.substr(0,5)}\u2026]`}function re(P,O,F){return`${ne(P,O)}[${F?"reconnect":"initial"}]`}function Z(P,O){return`${re(O,P.reconnectionToken,!!P.reconnectionProtocol)}[${P.host}:${P.port}]`}function _(P){return`${Date.now()-P} ms`}}),define(ee[236],te([0,1,84,88]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(r,L,M,k,f,u){const v=y=>u(y,void 0),p=I.createConnection({host:r,port:L},()=>{p.removeListener("error",v);const y=Buffer.alloc(16);for(let s=0;s<16;s++)y[s]=Math.round(Math.random()*256);const h=y.toString("base64"),E=[`GET ws://${/:/.test(r)?`[${r}]`:r}:${L}${M}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];p.write(E.join(`\r
`)+`\r
\r
`);const S=s=>{s.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",S),u(void 0,new A.NodeSocket(p,f)))};p.on("data",S)});p.setNoDelay(!0),p.once("error",v)}}}),define(ee[237],te([0,1,27,46,41,196]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function k(h=!1){return(M===void 0||h)&&(M=f()),M}e.hasWSLFeatureInstalled=k;async function f(){const h=u();if(h===void 0)return!1;if(h>=22e3){const E=p();if(E)return new Promise(S=>{A.execFile(E,["--status"],s=>S(!s))})}else{const E=y();if(E)try{if((await r.promises.stat(E)).isFile())return!0}catch{}}return!1}function u(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(h)return parseInt(h[3])}function v(h){const E=process.env.SystemRoot;if(E){const S=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return L.join(E,S?"Sysnative":"System32",h)}}function p(){return v("wsl.exe")}function y(){return v("lxss\\LxssManager.dll")}}),define(ee[52],te([0,1,17,13,2,180,68,6,5,51]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class v{constructor(D){this.original=D}toJSON(){if(!this.headers){const D=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?D[t]="*****":D[t]=this.original[t];this.headers=D}return this.headers}}class p extends r.Disposable{constructor(D,t){super(),this.counter=0,this.logger=t.createLogger(D?"remotenetwork":"network",{name:D?(0,L.localize)(0,null):(0,L.localize)(1,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(D,t,l){const i=`${D} #${++this.counter}: ${t.url}`;this.logger.trace(`${i} - begin`,t.type,new v(t.headers??{}));try{const n=await l();return this.logger.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${i} - error`,t.type,(0,A.getErrorMessage)(n)),n}}}e.AbstractRequestService=p;function y(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=y;function h(w){return w.res.statusCode===204}async function E(w){return h(w)?null:(await(0,I.streamToBuffer)(w.stream)).toString()}e.asText=E;async function S(w){if(!y(w))throw new Error("Server returned "+w.res.statusCode);return E(w)}e.asTextOrError=S;async function s(w){if(!y(w))throw new Error("Server returned "+w.res.statusCode);if(h(w))return null;const t=(await(0,I.streamToBuffer)(w.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.asJson=s;function g(w){b(w)}e.updateProxyConfigurationsScope=g;let d;function b(w){const D=u.Registry.as(M.Extensions.Configuration),t=d;d={id:"http",order:15,title:(0,L.localize)(2,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},D.updateConfigurations({add:[d],remove:t?[t]:[]})}b(1)}),define(ee[238],te([0,1,17,23]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(k){this.service=k}listen(k,f){throw new Error("Invalid listen")}call(k,f,u,v=A.CancellationToken.None){switch(f){case"request":return this.service.request(u[0],v).then(async({res:p,stream:y})=>{const h=await(0,I.streamToBuffer)(y);return[{statusCode:p.statusCode,headers:p.headers},h]});case"resolveProxy":return this.service.resolveProxy(u[0])}throw new Error("Invalid call")}}e.RequestChannel=r;class L{constructor(k){this.channel=k}async request(k,f){const[u,v]=await this.channel.call("request",[k],f);return{res:u,stream:(0,I.bufferToStream)(v)}}async resolveProxy(k){return this.channel.call("resolveProxy",[k])}}e.RequestChannelClient=L}),define(ee[239],te([0,1,240,11]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,k){return M.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:M.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function L(M,k,f={}){const u=(0,I.parse)(M),v=f.proxyUrl||r(u,k);if(!v)return null;const p=(0,I.parse)(v);if(!/^https?:$/.test(p.protocol||""))return null;const y={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,A.isBoolean)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((h,E)=>{j(["http-proxy-agent"],h,E)}))(y):new(await new Promise((h,E)=>{j(["https-proxy-agent"],h,E)}))(y)}e.getProxyAgent=L}),define(ee[117],te([0,1,46,9,181,23,44,13,4,31,154,62,7,133]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function S(g,d,b,w){return b["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(w)&&!b["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(w)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=y.Promises.withAsyncBody(async(D,t)=>{const l=new L.CancellationTokenSource;let i=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,h.clamp)(n,1,120)*1e3);const a=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},i);try{D(await s(d,l.token))}catch(c){!(0,k.isCancellationError)(c)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(c)))):D({})}finally{clearTimeout(a),l.dispose()}})),E)}e.getResolvedShellEnv=S;async function s(g,d){const b=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",b);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",w);const D=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const i=await(0,v.getSystemShell)(f.OS,l);return g.trace("getUnixShellEnvironment#shell",i),new Promise((n,a)=>{if(d.isCancellationRequested)return a(new k.CancellationError);const c=(0,A.basename)(i);let o,m;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${C} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,m=["-Login","-Command"]):(o=`'${process.execPath}' ${C} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,c==="tcsh"||c==="csh"?m=["-ic"]:m=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),o);const R=(0,I.spawn)(i,[...m,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});d.onCancellationRequested(()=>(R.kill(),a(new k.CancellationError))),R.on("error",$=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),a($)});const T=[];R.stdout.on("data",$=>T.push($));const U=[];R.stderr.on("data",$=>U.push($)),R.on("close",($,q)=>{const ie=Buffer.concat(T).toString("utf8");g.trace("getUnixShellEnvironment#raw",ie);const oe=Buffer.concat(U).toString("utf8");if(oe.trim()&&g.trace("getUnixShellEnvironment#stderr",oe),$||q)return a(new Error((0,r.localize)(2,null,$,q)));const ae=t.exec(ie),he=ae?ae[1]:"{}";try{const ce=JSON.parse(he);b?ce.ELECTRON_RUN_AS_NODE=b:delete ce.ELECTRON_RUN_AS_NODE,w?ce.ELECTRON_NO_ATTACH_CONSOLE=w:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ce)),a(ce)}})})}}),define(ee[93],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[241],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.validators=new Map}vsda(){return new Promise((r,L)=>j(["vsda"],r,L))}async createNewMessage(r){try{const L=await this.vsda(),M=new L.validator;if(M){const k=String(I._nextId++);return this.validators.set(k,M),{id:k,data:M.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,L){if(!r.id)return!0;const M=this.validators.get(r.id);if(!M)return!1;this.validators.delete(r.id);try{return M.validate(L)==="ok"}catch{return!1}}async sign(r){try{const L=await this.vsda(),M=new L.signer;if(M)return M.sign(r)}catch{}return r}}I._nextId=1,e.SignService=I}),define(ee[33],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[20],te([0,1,15,42,7,3,2,4,36,11,6,5,33,28]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var E;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(E=e.ShutdownReason||(e.ShutdownReason={}));var S;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let s=class ht extends M.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(d,b,w){super(),this.logService=d,this.stateService=b,this.environmentMainService=w,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(ht.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(ht.QUIT_AND_RESTART_KEY)}registerListeners(){const d=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",d);const b=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",b),I.app.once("will-quit",w=>{this.trace("Lifecycle#app.on(will-quit) - begin"),w.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",d),I.app.removeListener("window-all-closed",b),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}fireOnWillShutdown(d){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const b=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({reason:d,join(D,t){b.trace(`Lifecycle#onWillShutdown - begin '${D}'`),w.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(w)}catch(D){this.logService.error(D)}try{await this.stateService.close()}catch(D){this.logService.error(D)}})(),this.pendingWillShutdownPromise}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===d)return;this.trace(`lifecycle (main): phase changed (value: ${d})`),this._phase=d;const b=this.phaseWhen.get(this._phase);b&&(b.open(),this.phaseWhen.delete(this._phase))}async when(d){if(d<=this._phase)return;let b=this.phaseWhen.get(d);b||(b=new r.Barrier,this.phaseWhen.set(d,b)),await b.wait()}registerWindow(d){const b=new M.DisposableStore;this.windowCounter++,b.add(d.onWillLoad(D=>this._onWillLoadWindow.fire({window:d,workspace:D.workspace,reason:D.reason})));const w=(0,u.assertIsDefined)(d.win);w.on("close",D=>{const t=d.id;if(this.windowToCloseRequest.has(t)){this.windowToCloseRequest.delete(t);return}this.trace(`Lifecycle#window.on('close') - window ID ${d.id}`),D.preventDefault(),this.unload(d,1).then(l=>{if(l){this.windowToCloseRequest.delete(t);return}this.windowToCloseRequest.add(t),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this._onBeforeCloseWindow.fire(d),d.close()})}),w.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.windowCounter--,b.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(d,b){await this.unload(d,3)||d.reload(b)}unload(d,b){const w=this.mapWindowIdToPendingUnload.get(d.id);if(w)return w;const D=this.doUnload(d,b).finally(()=>{this.mapWindowIdToPendingUnload.delete(d.id)});return this.mapWindowIdToPendingUnload.set(d.id,D),D}async doUnload(d,b){if(!d.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${d.id}`);const w=this._quitRequested?2:b,D=await this.onBeforeUnloadWindowInRenderer(d,w);return D?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.handleWindowUnloadVeto(D)):(await this.onWillUnloadWindowInRenderer(d,w),!1)}handleWindowUnloadVeto(d){return d?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(d){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(d),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(d,b){return new Promise(w=>{const D=this.oneTimeListenerTokenGenerator++,t=`vscode:ok${D}`,l=`vscode:cancel${D}`;A.validatedIpcMain.once(t,()=>{w(!1)}),A.validatedIpcMain.once(l,()=>{w(!0)}),d.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:l,reason:b})})}onWillUnloadWindowInRenderer(d,b){return new Promise(w=>{const t=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;A.validatedIpcMain.once(t,()=>w()),d.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(d){return this.trace(`Lifecycle#quit() - begin (willRestart: ${d})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(d&&this.stateService.setItem(ht.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(b=>{this.pendingQuitPromiseResolve=b,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(d){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(d):this.logService.trace(d)}async relaunch(d){this.trace("Lifecycle#relaunch()");const b=process.argv.slice(1);if(d?.addArgs&&b.push(...d.addArgs),d?.removeArgs)for(const t of d.removeArgs){const l=b.indexOf(t);l>=0&&b.splice(l,1)}const w=()=>{try{if(k.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.logService.error(t)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:b})};I.app.once("quit",w),await this.quit(!0)&&I.app.removeListener("quit",w)}async kill(d){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const b of I.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let w;b.webContents&&!b.webContents.isDestroyed()?w=new Promise(D=>b.once("closed",D)):w=Promise.resolve(),b.destroy(),await w}})()]),I.app.exit(d)}};s.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",s=we([X(0,p.ILogService),X(1,y.IStateService),X(2,h.IEnvironmentMainService)],s),e.LifecycleMainService=s}),define(ee[242],te([0,1,4,3,2,6,20]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let k=class extends r.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((p,y)=>{j(["native-keymap"],p,y)});this._keyboardLayoutData=f(v),I.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=f(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=we([X(0,M.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function f(u){const v=u.getKeyMap(),p=u.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:p}}}),define(ee[118],te([0,1,7,17,11,34,16,5]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(f=e.SaveStrategy||(e.SaveStrategy={}));class u{constructor(h,E,S,s){this.storagePath=h,this.logService=S,this.fileService=s,this.storage=Object.create(null),this.lastSavedStorageContents="",this.initializing=void 0,this.closing=void 0,this.flushDelayer=E===0?void 0:new I.ThrottledDelayer(100)}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==1&&this.logService.error(h)}}getItem(h,E){const S=this.storage[h];return(0,r.isUndefinedOrNull)(S)?E:S}setItem(h,E){this.setItems([{key:h,data:E}])}setItems(h){let E=!1;for(const{key:S,data:s}of h)this.storage[S]!==s&&((0,r.isUndefinedOrNull)(s)?(0,r.isUndefined)(this.storage[S])||(this.storage[S]=void 0,E=!0):(this.storage[S]=s,E=!0));E&&this.save()}removeItem(h){(0,r.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave()):this.doSave()}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,A.VSBuffer.fromString(h)),this.lastSavedStorageContents=h}catch(E){this.logService.error(E)}}async close(){return this.closing||(this.closing=this.flushDelayer?this.flushDelayer.trigger(()=>this.doSave(),0):this.doSave()),this.closing}}e.FileStorage=u;let v=class{constructor(h,E,S,s){this.fileStorage=new u(E.stateResource,h,S,s)}async init(){await this.fileStorage.init()}getItem(h,E){return this.fileStorage.getItem(h,E)}};v=we([X(1,L.IEnvironmentService),X(2,k.ILogService),X(3,M.IFileService)],v),e.StateReadonlyService=v;class p extends v{setItem(h,E){this.fileStorage.setItem(h,E)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}}e.StateService=p}),define(ee[94],te([0,1,4,36,31]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(f){if(I.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function M(f,u,v,p,y,h,E,S){const s=Object.create(null);s["common.machineId"]=h,s.sessionID=(0,r.generateUuid)()+Date.now(),s.commitHash=p,s.version=y,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.PlatformToString)(I.platform),s["common.nodePlatform"]=A.platform,s["common.nodeArch"]=v,s["common.product"]=S||"desktop",E&&(s["common.msftInternal"]=E);let g=0;const d=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),I.isLinuxSnap&&(s["common.snap"]="true");const b=L(u);return b&&(s["common.platformDetail"]=b),s}e.resolveCommonProperties=M;function k(f){const u=A.env.USERDNSDOMAIN;if(!u)return!1;const v=u.toLowerCase();return f.some(p=>v===p)}e.verifyMicrosoftInternalDomain=k}),define(ee[25],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var r;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(r=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[243],te([0,1,27,7,43,14,9,4,8,86,24,104,89,16,21,25]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function g(t,l){const i=`${t}::${l.join(":")}`,n=s.get(i);if(n)return n;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,m=2e4;function C(T,U,$,q){const ie=U.substring(T.length+1);return A.Promises.withAsyncBody(async oe=>{let ae;try{ae=await v.Promises.readdir(U,{withFileTypes:!0})}catch{oe();return}if(q.count>=m){q.count+=ae.length,q.maxReached=!0,oe();return}let he=ae.length;if(he===0){oe();return}let ce=ae;q.count+ae.length>m&&(q.maxReached=!0,he=m-q.count,ce=ae.slice(0,he)),q.count+=ae.length;for(const K of ce)if(K.isDirectory()){if($.includes(K.name)||await C(T,(0,M.join)(U,K.name),$,q),--he===0){oe();return}}else{const Y=K.name.lastIndexOf(".");if(Y>=0){const x=K.name.substring(Y+1);x&&c.set(x,(c.get(x)??0)+1)}for(const x of a)x.relativePathPattern?.test(ie)!==!1&&x.filePattern.test(K.name)&&o.set(x.tag,(o.get(x.tag)??0)+1);if(--he===0){oe();return}}})}const R=A.Promises.withAsyncBody(async T=>{const U={count:0,maxReached:!1};await C(t,t,l,U);const $=await w(t);T({configFiles:d(o),fileTypes:d(c),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:$})});return s.set(i,R),R}e.collectWorkspaceStats=g;function d(t){return Array.from(t.entries(),([l,i])=>({name:l,count:i})).sort((l,i)=>i.count-l.count)}function b(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},l=I.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.getMachineInfo=b;async function w(t){try{const l=new Map,i=(0,M.join)(t,".vscode","launch.json"),n=await v.Promises.readFile(i),a=[],c=(0,r.parse)(n.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,r.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const m=o.type;m&&(l.has(m)?l.set(m,l.get(m)+1):l.set(m,1))}return d(l)}catch{return[]}}e.collectLaunchConfigs=w;let D=class{constructor(l,i){this.telemetryService=l,this.productService=i}formatMachineInfo(l){const i=[];return i.push(`OS Version:       ${l.os}`),i.push(`CPUs:             ${l.cpus}`),i.push(`Memory (System):  ${l.memory}`),i.push(`VM:               ${l.vmHint}`),i.join(`
`)}formatEnvironment(l){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const n=I.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${I.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${l.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(l,i){return Promise.all([(0,p.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async n=>{let[a,c]=n,o=this.formatProcessList(l,a);return i.forEach(m=>{if((0,y.isRemoteDiagnosticError)(m))o+=`
${m.errorMessage}`,c+=`
${m.errorMessage}`;else if(o+=`

Remote: ${m.hostName}`,m.processes&&(o+=`
${this.formatProcessList(l,m.processes)}`),m.workspaceMetadata){c+=`
|  Remote: ${m.hostName}`;for(const C of Object.keys(m.workspaceMetadata)){const R=m.workspaceMetadata[C];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${C}): ${T}`,c+=this.formatWorkspaceStats(R)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(l,i){const{memory:n,vmHint:a,os:c,cpus:o}=b(),m={os:c,memory:n,cpus:o,vmHint:a,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(m.load=`${I.loadavg().map(C=>Math.round(C)).join(", ")}`),k.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(l,i){const n=[];return(0,p.listProcesses)(l.mainPID).then(async a=>(n.push(""),n.push(this.formatEnvironment(l)),n.push(""),n.push(this.formatProcessList(l,a)),l.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(l))),i.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.formatMachineInfo(c.machineInfo)),c.processes&&n.push(this.formatProcessList(l,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const m=c.workspaceMetadata[o];let C=`${m.fileCount} files`;m.maxFilesReached&&(C=`more than ${C}`),n.push(`Folder (${o}): ${C}`),n.push(this.formatWorkspaceStats(m))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(l){const i=[];let a=0;const c=(R,T)=>{const U=` ${R}(${T})`;a+U.length>60?(i.push(o),o="|                 ",a=o.length):a+=U.length,o+=U};let o="|      File types:";const m=10,C=l.fileTypes.length>m?m:l.fileTypes.length;for(let R=0;R<C;R++){const T=l.fileTypes[R];c(T.name,T.count)}if(i.push(o),l.configFiles.length>=0&&(o="|      Conf files:",a=0,l.configFiles.forEach(R=>{c(R.name,R.count)}),i.push(o)),l.launchConfigFiles.length>0){let R="|      Launch Configs:";l.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(R)}return i.join(`
`)}expandGPUFeatures(l){const i=Math.max(...Object.keys(l).map(n=>n.length));return Object.keys(l).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${l[n]}`).join(`
                  `)}formatWorkspaceMetadata(l){const i=[],n=[];return l.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const o=f.URI.revive(c);if(o.scheme===L.Schemas.file){const m=o.fsPath;n.push(g(m,["node_modules",".git"]).then(C=>{let R=`${C.fileCount} files`;C.maxFilesReached&&(R=`more than ${R}`),i.push(`|    Folder (${(0,M.basename)(m)}): ${R}`),i.push(this.formatWorkspaceStats(C))}).catch(C=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${C.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(l,i){const n=new Map;l.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),l.pidToNames.forEach(({pid:c,name:o})=>n.set(c,o));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(l.mainPID,n,a,i,0),a.join(`
`)}formatProcessItem(l,i,n,a,c){const o=c===0;let m;o?m=a.pid===l?`${this.productService.applicationName} main`:"remote agent":i.has(a.pid)?m=i.get(a.pid):m=`${"  ".repeat(c)} ${a.name}`;const C=process.platform==="win32"?a.mem:I.totalmem()*(a.mem/100);n.push(`${a.load.toFixed(0).padStart(5," ")}	${(C/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(a.children)&&a.children.forEach(R=>this.formatProcessItem(l,i,n,R,c+1))}async getWorkspaceFileExtensions(l){const i=new Set;for(const{uri:n}of l.folders){const a=f.URI.revive(n);if(a.scheme!==L.Schemas.file)continue;const c=a.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(m=>i.add(m.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(l){for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const a=n.fsPath;try{const c=await g(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),c.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};D=we([X(0,S.ITelemetryService),X(1,E.IProductService)],D),e.DiagnosticsService=D}),define(ee[244],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(L){this.appenders=L}listen(L,M){throw new Error(`Event not found: ${M}`)}call(L,M,{eventName:k,data:f}){return this.appenders.forEach(u=>u.log(k,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class A{constructor(L){this.channel=L}log(L,M){return this.channel.call("log",{eventName:L,data:M}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(ee[48],te([0,1,37,11,3,19,57,94,25]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(a){this.value=a}}e.TelemetryTrustedValue=u;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class p{async publicLog(a,c,o){}async publicLogError(a,c,o){}}e.NullEndpointTelemetryService=p,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(n,a){return r.Event.debounce(a.onDidChangeConfiguration,(o,m)=>{const C=o?new Set([...o.affectedKeys,...m.affectedKeys]):m.affectedKeys;return{...m,affectedKeys:C}},1e3,!0)(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.configurationTelemetry=y;function h(n,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!n.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=h;function E(n,a){return!(a.isBuilt||a.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=E;function S(n){const a=n.getValue(f.TELEMETRY_SETTING_ID),c=n.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function s(n){const a={},c={},o={};b(n,o);for(let m in o){m=m.length>150?m.substr(m.length-149):m;const C=o[m];typeof C=="number"?c[m]=C:typeof C=="boolean"?c[m]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${C.length}`),a[m]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(a[m]=C)}return{properties:a,measurements:c}}e.validateTelemetryData=s;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(n){if(!n)return"none";const a=(0,M.getRemoteName)(n);return g.has(a)?a:"other"}e.cleanRemoteAuthority=d;function b(n,a,c=0,o){if(!!n)for(const m of Object.getOwnPropertyNames(n)){const C=n[m],R=o?o+m:m;Array.isArray(C)?a[R]=(0,I.safeStringify)(C):C instanceof Date?a[R]=C.toISOString():(0,A.isObject)(C)?c<2?b(C,a,c+1,R+"."):a[R]=(0,I.safeStringify)(C):a[R]=C}}function w(n,a){const c=n.msftInternalDomains||[],o=a.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(c)||o}e.isInternalTelemetry=w;function D(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=D;function t(n,a){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let c=n;const o=[];for(const T of a)for(;;){const U=T.exec(n);if(!U)break;o.push([U.index,T.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let R=0;for(c="";;){const T=C.exec(n);if(!T)break;const U=o.some(([$,q])=>T.index<q&&$<C.lastIndex);!m.test(T[0])&&!U&&(c+=n.substring(R,T.index)+"<REDACTED: user-file-path>",R=C.lastIndex)}return R<n.length&&(c+=n.substr(R)),c}function l(n){if(!n)return n;const a=n.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of c)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return n}function i(n,a){return(0,I.cloneAndChange)(n,c=>{if(c instanceof u)return c.value;if(typeof c=="string"){let o=c.replaceAll("%20"," ");o=t(o,a);for(const m of a)o=o.replace(m,"");return o=l(o),o}})}e.cleanData=i}),define(ee[119],te([0,1,26,112,116,4,8,13,36,48]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,I.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=v;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(n){const a=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,a,c)}static parse(n){const a=p.exec(n);return a&&a[1]&&a[2]?new y({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?v(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=h.exec(i);return n&&n[1]?[s(n[1]),n[2]]:[s(i),void 0]}e.getIdAndVersion=E;function S(i,n){return`${i}.${n}`}e.getExtensionId=S;function s(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function g(i,n){return s(S(i??r.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=g;function d(i,n){const a=[],c=o=>{for(const m of a)if(m.some(C=>v(n(C),n(o))))return m;return null};for(const o of i){const m=c(o);m?m.push(o):a.push([o])}return a}e.groupByExtension=d;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function w(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function D(i,n){const a=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const o=c.shift();if(o&&a.every(m=>!v(m.identifier,{id:o}))){const m=i.filter(C=>v(C.identifier,{id:o}));m.length===1&&(a.push(m[0]),c.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=D;async function t(i,n){if(!L.isLinux)return!1;let a;try{a=(await i.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await i.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(o))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(i,n){const a=await t(i,n),c=(0,A.getTargetPlatform)(a?"alpine":L.platform,f.arch);return n.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=l}),define(ee[245],te([0,1,201,48]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(L,M,k,f,u,v,p){const y={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${M.nameShort})`};if((0,A.supportsTelemetry)(M,k)&&(0,A.getTelemetryLevel)(f)===3){const h=await(0,I.getServiceMachineId)(k,u,v);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=p.machineId||h}return y}e.resolveMarketplaceHeaders=r}),define(ee[246],te([0,1,13,37,48]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",M="https://0.0.0.0/ping";async function k(u,v,p){const y=await new Promise((g,d)=>{j(["@microsoft/1ds-core-js"],g,d)}),h=await new Promise((g,d)=>{j(["@microsoft/1ds-post-js"],g,d)}),E=new y.AppInsightsCore,S=new h.PostChannel,s={instrumentationKey:u,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(p){s.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:p};s.extensionConfig[S.identifier]=g}return E.initialize(s,[]),E.addTelemetryInitializer(g=>{v&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),E}class f{constructor(v,p,y,h,E){this._isInternalTelemetry=v,this._eventPrefix=p,this._defaultData=y,this._xhrOverride=E,this.endPointUrl=L,this.endPointHealthUrl=M,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(v){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){v(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(p=>{v(p)},p=>{(0,I.onUnexpectedError)(p),console.error(p)})}}log(v,p){if(!this._aiCoreOrKey)return;p=(0,A.mixin)(p,this._defaultData),p=(0,r.validateTelemetryData)(p);const y=this._eventPrefix+"/"+v;try{this._withAIClient(h=>{h.pluginVersionString=p?.properties.version??"Unknown",h.track({name:y,baseData:{name:y,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(v=>{this._withAIClient(p=>{p.unload(!0,()=>{this._aiCoreOrKey=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[120],te([0,1,2,37,4,26,182,19,68,66,21,51,25,48]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,d,b){this._configurationService=d,this._productService=b,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(w),"gi")),w.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(w.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(w=>{(w.affectsConfiguration(y.TELEMETRY_SETTING_ID)||w.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||w.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,d){this._experimentProperties[g]=d}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const b=d.usage?3:d.error?2:0;g=Math.min(g,b)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,d,b){this._telemetryLevel<d||(b=(0,A.mixin)(b,this._experimentProperties),b=(0,h.cleanData)(b,this._cleanupPatterns),b=(0,A.mixin)(b,this._commonProperties),this._appenders.forEach(w=>w.log(g,b)))}publicLog(g,d){this._log(g,3,d)}publicLog2(g,d){this.publicLog(g,d)}publicLogError(g,d){!this._sendErrorTelemetry||this._log(g,2,d)}publicLogError2(g,d){this.publicLogError(g,d)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=we([X(1,k.IConfigurationService),X(2,v.IProductService)],E),e.TelemetryService=E;function S(){const s=(0,M.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=r.isWeb?"":(0,M.localize)(3,null),b=(0,M.localize)(4,null),w=(0,M.localize)(5,null),D=(0,M.localize)(6,null),t=(0,M.localize)(7,null),l=`
|       | ${b} | ${w} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,M.localize)(8,null);return`
${s} ${g} ${d}

&nbsp;

${t}
${l}

&nbsp;

${i}
`}p.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:S(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,M.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,M.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[247],te([0,1,295,246]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class r extends A.AbstractOneDataSystemAppender{constructor(M,k,f,u){const v={sendPOST:(p,y)=>{const h={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const E=I.request(p.urlString,h,S=>{S.on("data",function(s){y(S.statusCode??200,S.headers,s.toString())}),S.on("error",function(s){y(0,{})})});E.write(p.data),E.end()}catch{y(0,{})}}};super(M,k,f,u,v)}}e.OneDataSystemAppender=r}),define(ee[248],te([0,1,4,86,25]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function L(M,k){let f=M.getItem(r.machineIdKey);return(typeof f!="string"||I.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,A.getMachineId)(k.error.bind(k))),f}e.resolveMachineId=L}),define(ee[121],te([0,1,25,248]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function r(L,M){const k=await(0,A.resolveMachineId)(L,M);return L.setItem(I.machineIdKey,k),k}e.resolveMachineId=r}),define(ee[69],te([0,1,15,3,2,4,19,6,33]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const u="#FFFFFF",v="#1E1E1E",p="#000000",y="#FFFFFF",h="theme",E="themeBackground",S="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let s=class extends r.Disposable{constructor(d,b){super(),this.stateService=d,this.configurationService=b,this._onDidChangeColorScheme=this._register(new A.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,I.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(L.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return d.dark?p:y;let b=this.stateService.getItem(E,null);if(!b)switch(this.stateService.getItem(h,"vs-dark").split(" ")[0]){case"vs":b=u;break;case"hc-black":b=p;break;case"hc-light":b=y;break;default:b=v}return L.isMacintosh&&b.toUpperCase()===v&&(b="#171717"),b}saveWindowSplash(d,b){this.stateService.setItems([{key:h,data:b.baseTheme},{key:E,data:b.colorInfo.background},{key:S,data:b}]),typeof d=="number"&&this.updateBackgroundColor(d,b)}updateBackgroundColor(d,b){for(const w of I.BrowserWindow.getAllWindows())if(w.id===d){w.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(S)}};s=we([X(0,f.IStateService),X(1,M.IConfigurationService)],s),e.ThemeMainService=s}),define(ee[122],te([0,1,3,19,6,5]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(S){S.Http="http",S.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function u(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=u,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=p;function y(S,s,g,d){if(g===1)return!1;if(g===2&&p(s)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(b?.length===4&&parseInt(b[1])>=18)return!1}return S<1024}e.isPortPrivileged=y;class h{constructor(s,g,d){this.remoteAddress=s,this.localAddress=g,this._dispose=d,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=h;let E=class{constructor(s,g){this.logService=s,this.configurationService=g,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],g=Array.from(this._tunnels.values());for(const d of g){const b=Array.from(d.values());for(const w of b){const D=await w.value;D&&s.push(D)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:g}of s.values())await g.then(d=>d?.dispose());s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,g,d,b,w){this.addTunnelToMap(s,g,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:g,localAddress:d,privacy:b,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,g){(p(s)||v(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(s,g);if(d)return++d.refcount,d.value}openTunnel(s,g,d,b,w,D=!1,t,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${d} on local port ${w}.`),!s)return;if(g||(g="localhost"),b||(b=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.retainOrCreateTunnel(s,g,d,b,w,D,t,l);return i?i.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(n);return(n.tunnelRemoteHost!==g||n.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const g=this._tunnels.get(s.tunnelRemoteHost);if(g){const d=g.get(s.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,d))}}}}async tryDisposeTunnel(s,g,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${g}.`);const b=d.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(g),b}}async closeTunnel(s,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${g} `);const d=this._tunnels.get(s);if(d&&d.has(g)){const b=d.get(g);b.refcount=0,await this.tryDisposeTunnel(s,g,b)}}addTunnelToMap(s,g,d){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(g,{refcount:1,value:d})}async removeEmptyTunnelFromMap(s,g){const d=this._tunnels.get(s);d&&(await d.get(g)||d.delete(g),d.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,g){const d=[s];v(s)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):p(s)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const b=d.map(w=>this._tunnels.get(w));for(const w of b){const D=w?.get(g);if(D)return D}}canTunnel(s){return!!u(s)}createWithProvider(s,g,d,b,w,D,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${d} on local port ${b}.`);const l=d;this._factoryInProgress.add(l);const i=b===void 0?d:b,n={elevationRequired:w?this.isPortPrivileged(i):!1},a={remoteAddress:{host:g,port:d},localAddressPort:b,privacy:D,public:D?D!==k.Private:void 0,protocol:t},c=s.forwardPort(a,n);return c?(this.addTunnelToMap(g,d,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),c}};E=we([X(0,L.ILogService),X(1,A.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ee[249],te([0,1,84,27,101,236,7,2,19,5,21,235,122,93,4]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,D,t,l,i){let n;for(let a=3;a&&(n?.dispose(),n=await new s(w,D,t,l,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));a--);return n}class s extends k.Disposable{constructor(D,t,l,i,n){super(),this.defaultTunnelHost=t,this.suggestedLocalPort=n,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=D,this._server=I.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(t=>{t()})}async waitForReady(){const D=this.suggestedLocalPort??this.tunnelRemotePort,t=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let l=await(0,r.findFreePortFaster)(D,2,1e3,t),i=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(D){D.pause();const t=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,p.connectRemoteAgentTunnel)(this._options,t,this.tunnelRemotePort),i=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&D.write(n.buffer),D.on("end",()=>{D.localAddress&&this._socketsDispose.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this._socketsDispose.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this._socketsDispose.set(D.localAddress,()=>{D.end(),i.end()})}}let g=class extends y.AbstractTunnelService{constructor(D,t,l,i,n){super(t,n),this.socketFactory=D,this.signService=l,this.productService=i}isPortPrivileged(D){return(0,y.isPortPrivileged)(D,this.defaultTunnelHost,E.OS,A.release())}retainOrCreateTunnel(D,t,l,i,n,a,c,o){const m=this.getTunnelFromMap(t,l);if(m)return++m.refcount,m.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,t,l,n,a,c,o);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${l} on local port ${n}.`);const C={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:D,signService:this.signService,logService:this.logService,ipcLogger:null},R=S(C,i,t,l,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(t,l,R),R}}};g=we([X(1,u.ILogService),X(2,h.ISignService),X(3,v.IProductService),X(4,f.IConfigurationService)],g),e.BaseTunnelService=g;let d=class extends g{constructor(D,t,l,i){super(L.nodeSocketFactory,D,t,l,i)}};d=we([X(0,u.ILogService),X(1,h.ISignService),X(2,v.IProductService),X(3,f.IConfigurationService)],d),e.TunnelService=d;let b=class extends k.Disposable{constructor(D,t,l,i){super(),this.logService=D,this.productService=t,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(D,t,l,i,n,a,c,o,m){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${a}.`),!this._tunnelServices.has(D)){const C=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(D,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(D))})}return this._tunnelServices.get(D).openTunnel(t,l,i,n,a,c,o,m)}};b=we([X(0,u.ILogService),X(1,v.IProductService),X(2,h.ISignService),X(3,f.IConfigurationService)],b),e.SharedTunnelsService=b}),define(ee[49],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(A=e.StateType||(e.StateType={}));var r;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap",L[L.WindowsInstaller=3]="WindowsInstaller"})(r=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,M)=>({type:"idle",updateType:L,error:M}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[250],te([0,1,4,183,68,51]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[251],te([0,1,3,49]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(k){this.service=k}listen(k,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"checkForUpdates":return this.service.checkForUpdates(u);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=r;class L{get state(){return this._state}set state(k){this._state=k,this._onStateChange.fire(k)}constructor(k){this.channel=k,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(k){return this.channel.call("checkForUpdates",k)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(k){return this.channel.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=L}),define(ee[95],te([0,1,7,23,3,19,28,20,5,21,52,49]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(E,S,s){return`${s.updateUrl}/api/update/${E}/${S}/${s.commit}`}e.createUpdateURL=y;let h=class{get state(){return this._state}setState(S){this.logService.info("update#setState",S.type),this._state=S,this._onStateChange.fire(S)}constructor(S,s,g,d,b,w){this.lifecycleMainService=S,this.configurationService=s,this.environmentMainService=g,this.requestService=d,this.logService=b,this.productService=w,this._state=p.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,S.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const S=this.configurationService.getValue("update.mode"),s=this.getProductQuality(S);if(!s){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(s),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(p.State.Idle(this.getUpdateType())),S==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}S==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(S){return S==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(S=60*60*1e3){return(0,I.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(S){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(S)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(S){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(S=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},A.CancellationToken.None)).res.statusCode===204}catch(s){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(s);return}}async _applySpecificUpdate(S){}getUpdateType(){return 1}doQuitAndInstall(){}};h=we([X(0,k.ILifecycleMainService),X(1,L.IConfigurationService),X(2,M.IEnvironmentMainService),X(3,v.IRequestService),X(4,f.ILogService),X(5,u.IProductService)],h),e.AbstractUpdateService=h}),define(ee[252],te([0,1,15,55,3,2,19,28,20,5,21,52,25,49,95]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let S=class extends E.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"error",(g,d)=>d)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(g,d,b)=>({url:d,version:b,productVersion:b}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(g,d,b,w)=>({releaseNotes:d,version:b,productVersion:b,date:w}))}constructor(g,d,b,w,D,t,l){super(g,d,w,D,t,l),this.telemetryService=b,this.disposables=new L.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(g){this.logService.error("UpdateService error:",g);const b=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.setState(h.State.Idle(1,b))}buildUpdateFeedUrl(g){let d;this.productService.darwinUniversalAssetId?d=this.productService.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,E.createUpdateURL)(d,g,this.productService);try{I.autoUpdater.setFeedURL({url:b})}catch(w){this.logService.error("Failed to set update feed URL",w);return}return b}doCheckForUpdates(g){this.setState(h.State.CheckingForUpdates(g)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(g){this.state.type==="checking for updates"&&this.setState(h.State.Downloading(g))}onUpdateDownloaded(g){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:g.version}),this.setState(h.State.Ready(g)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([A.memoize],S.prototype,"onRawError",null),we([A.memoize],S.prototype,"onRawUpdateNotAvailable",null),we([A.memoize],S.prototype,"onRawUpdateAvailable",null),we([A.memoize],S.prototype,"onRawUpdateDownloaded",null),S=we([X(0,f.ILifecycleMainService),X(1,M.IConfigurationService),X(2,y.ITelemetryService),X(3,k.IEnvironmentMainService),X(4,p.IRequestService),X(5,u.ILogService),X(6,v.IProductService)],S),e.DarwinUpdateService=S}),define(ee[253],te([0,1,46,41,7,3,9,28,20,5,25,49]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this._state}setState(S){this.logService.info("update#setState",S.type),this._state=S,this._onStateChange.fire(S)}constructor(S,s,g){if(this.lifecycleMainService=S,this.logService=g,this._state=p.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event,s.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(p.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}scheduleCheckForUpdates(S=60*60*1e3){return(0,r.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(S){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(S)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(S){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(S=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(S){}};y=we([X(0,f.ILifecycleMainService),X(1,k.IEnvironmentMainService),X(2,u.ILogService)],y);let h=class extends y{constructor(S,s,g,d,b,w){super(g,d,b),this.snap=S,this.snapRevision=s,this.telemetryService=w;const D=(0,A.watch)(M.dirname(this.snap)),t=L.Event.fromNodeEventEmitter(D,"change",(a,c)=>c),l=L.Event.filter(t,a=>a==="current"),n=L.Event.debounce(l,(a,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),D.close()})}doCheckForUpdates(){this.setState(p.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(S=>{S?this.setState(p.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(p.State.Idle(2)))},S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(p.State.Idle(2,S.message||S))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const S=await new Promise((g,d)=>(0,A.realpath)(`${M.dirname(this.snap)}/current`,(b,w)=>b?d(b):g(w))),s=M.basename(S);return this.snapRevision!==s}isLatestVersion(){return this.isUpdateAvailable().then(void 0,S=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=we([X(2,f.ILifecycleMainService),X(3,k.IEnvironmentMainService),X(4,u.ILogService),X(5,v.ITelemetryService)],h),e.SnapUpdateService=h}),define(ee[39],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[254],te([0,1,39,202,16,18,134,3,2]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(y){this.uri=y,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let v=class{constructor(y){this._fileService=y,this._dispooables=new f.DisposableStore,this._limit=2**16;const h=new Map,E=S=>{let s=h.get(S.scheme);return s===void 0&&(s=y.hasProvider(S)&&!this._fileService.hasCapability(S,1024),h.set(S.scheme,s)),s};this._dispooables.add(k.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(S=>{h.delete(S.scheme)})),this.extUri=new L.ExtUri(E),this._canonicalUris=new M.SkipList((S,s)=>this.extUri.compare(S,s,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,L.normalizePath)(y));const h=this._canonicalUris.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new u(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((E,S)=>E[1].time<S[1].time?1:E[1].time>S[1].time?-1:0);u._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let E=0;E<h;E++)this._canonicalUris.set(y[E][0],y[E][1].touch())}};v=we([X(0,r.IFileService)],v),e.UriIdentityService=v,(0,A.registerSingleton)(I.IUriIdentityService,v,1)}),define(ee[123],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[255],te([0,1,8]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(k){this.handler=k}listen(k,f){throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"handleURL":return this.handler.handleURL(I.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=A;class r{constructor(k){this.channel=k}handleURL(k,f){return this.channel.call("handleURL",[k.toJSON(),f])}}e.URLHandlerChannelClient=r;class L{constructor(k,f){this.next=k,this.logService=f}async routeCall(k,f,u,v){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const p=I.URI.revive(u[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const y=/\bwindowId=(\d+)/.exec(p.query);if(y){const h=y[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,p.toString(!0));const E=new RegExp(`window:${h}`),S=k.connections.find(s=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",s.ctx),E.test(s.ctx)));if(S)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),S;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(k,f,u,v)}routeEvent(k,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=L}),define(ee[256],te([0,1,7,2,8,21]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends A.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(u,v){const p=[...this.handlers.values()];return(0,I.first)(p.map(y=>()=>y.handleURL(u,v)),void 0,!1).then(y=>y||!1)}registerHandler(u){return this.handlers.add(u),(0,A.toDisposable)(()=>this.handlers.delete(u))}}e.AbstractURLService=M;let k=class extends M{constructor(u){super(),this.productService=u}create(u){let{authority:v,path:p,query:y,fragment:h}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&p&&p.indexOf("/")!==0&&(p=`/${p}`),r.URI.from({scheme:this.productService.urlProtocol,authority:v,path:p,query:y,fragment:h})}};k=we([X(0,L.IProductService)],k),e.NativeURLService=k}),define(ee[257],te([0,1,15,7,3,2,4,8]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(v,p,y,h,E,S){if(this.urlService=p,this.logService=S,this.uris=[],this.retryCount=0,this.flushDisposable=L.Disposable.None,this.disposables=new L.DisposableStore,v&&(S.trace("ElectronURLListener initialUrisToHandle:",v.map(d=>d.originalUrl)),this.uris=v),M.isWindows){const d=h.isBuilt?[]:[`"${h.appRoot}"`];d.push("--open-url","--"),I.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,d)}const s=r.Event.map(r.Event.fromNodeEventEmitter(I.app,"open-url",(d,b)=>({event:d,url:b})),({event:d,url:b})=>(d.preventDefault(),b));this.disposables.add(s(d=>{const b=this.uriFromRawUrl(d);!b||this.urlService.open(b,{originalUrl:d})})),y.getWindows().filter(d=>d.isReady).length>0?(S.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(S.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables))}uriFromRawUrl(v){try{return k.URI.parse(v)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const v=[];for(const p of this.uris)await this.urlService.open(p.uri,{originalUrl:p.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),v.push(p));v.length!==0&&(this.uris=v,this.flushDisposable=(0,A.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(ee[258],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[259],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[260],te([0,1,15,2,14,8]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends A.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}handleWebviewRequest(f,u){try{const v=L.URI.parse(f.url),p=M.validWebviewFilePaths.get(v.path);if(typeof p=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${p}`,h=r.FileAccess.asFileUri(y);return u({path:decodeURIComponent(h.fsPath),headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=M}),define(ee[79],te([0,1,4]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(v){return!!v.workspaceUri}e.isWorkspaceToOpen=A;function r(v){return!!v.folderUri}e.isFolderToOpen=r;function L(v){return!!v.fileUri}e.isFileToOpen=L;function M(v){const p=k(v),y=v.getValue("window.menuBarVisibility");return y==="default"||p==="native"&&y==="compact"||I.isMacintosh&&I.isNative?"classic":y}e.getMenuBarVisibility=M;function k(v){if(I.isWeb)return"custom";const p=v.getValue("window");if(p){if(I.isMacintosh&&p.nativeTabs===!0||I.isMacintosh&&p.nativeFullScreen===!1)return"native";const E=p.titleBarStyle;if(E==="native"||E==="custom")return E}return I.isLinux?"native":"custom"}e.getTitleBarStyle=k;function f(v){if(!I.isWindows||I.isWeb||k(v)==="native")return!1;const p=v.getValue("window.experimental.windowControlsOverlay.enabled");return typeof p=="boolean"?p:!0}e.useWindowControlsOverlay=f;function u(v=0){return Math.pow(1.2,v)}e.zoomLevelToZoomFactor=u}),define(ee[124],te([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var A;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(A=e.UnloadReason||(e.UnloadReason={}));const r=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=r;var L;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(L=e.WindowMode||(e.WindowMode={}));var M;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(j,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var A;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}))}),define(ee[261],te([0,1,15,23,3,56,2,31,77,111,5,21,30]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(S){S[S.Initial=1]="Initial",S[S.StoredCredentialsUsed=2]="StoredCredentialsUsed",S[S.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let E=class extends M.Disposable{constructor(s,g,d,b,w){super(),this.logService=s,this.windowsMainService=g,this.credentialsService=d,this.encryptionMainService=b,this.productService=w,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=h.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const s=r.Event.fromNodeEventEmitter(I.app,"login",(g,d,b,w,D)=>({event:g,webContents:d,req:b,authInfo:w,callback:D}));this._register(s(this.onLogin,this))}async onLogin({event:s,authInfo:g,req:d,callback:b}){if(!g.isProxy)return;if(!this.pendingProxyResolve&&this.state===h.LoginDialogShown&&d.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}s.preventDefault();let w;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(g);try{w=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}b(w?.username,w?.password)}async resolveProxyCredentials(s){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.doResolveProxyCredentials(s);if(g)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(s){this.logService.trace("auth#doResolveProxyCredentials - enter",s);const g=String((0,L.hash)({scheme:s.scheme,host:s.host,port:s.port}));let d,b;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g);if(l){const i=JSON.parse(await this.encryptionMainService.decrypt(l));d=i.username,b=i.password}}catch(l){this.logService.error(l)}if(this.state!==h.StoredCredentialsUsed&&typeof d=="string"&&typeof b=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=h.StoredCredentialsUsed,{username:d,password:b};const w=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!w){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const D={authInfo:s,username:this.sessionCredentials?.username??d,password:this.sessionCredentials?.password??b,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,D),this.state=h.LoginDialogShown;const t=await new Promise(l=>{const i=async(n,a,c)=>{if(a===D.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",i),c){const o={username:c.username,password:c.password};try{if(c.remember){const m=await this.encryptionMainService.encrypt(JSON.stringify(o));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g,m)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,g)}catch(m){this.logService.error(m)}l({username:o.username,password:o.password})}else l(void 0)};w.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=t,t}};E=we([X(0,v.ILogService),X(1,y.IWindowsMainService),X(2,f.ICredentialsMainService),X(3,u.IEncryptionMainService),X(4,p.IProductService)],E),e.ProxyAuthHandler=E}),define(ee[262],te([0,1,77,5,34,21,30,214]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends k.BaseCredentialsMainService{constructor(v,p,y,h){super(v),this.environmentMainService=p,this.productService=y,this.windowsMainService=h,this.surfaceKeytarLoadError=E=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",E.message??E)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;const v=await new Promise((p,y)=>{j(["keytar"],p,y)});return await v.findCredentials("test-keytar-loads"),this._keytarCache=v,this._keytarCache}};f=we([X(0,A.ILogService),X(1,r.INativeEnvironmentService),X(2,L.IProductService),X(3,M.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[263],te([0,1,15,22,4,8,24,19,62,6,5,123,30]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,u.createDecorator)(e.ID);let h=class{constructor(S,s,g,d){this.logService=S,this.windowsMainService=s,this.urlService=g,this.configurationService=d}async start(S,s){this.logService.trace("Received data from other instance: ",S,s),r.isMacintosh&&I.app.focus({steal:!0});const g=this.parseOpenUrl(S);if(g.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const b=(0,A.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));b&&(d=b.ready())}d.then(()=>{for(const{uri:b,originalUrl:w}of g)this.urlService.open(b,{originalUrl:w})})}else return this.startOpenWindow(S,s)}parseOpenUrl(S){return S["open-url"]&&S._urls&&S._urls.length>0?(0,A.coalesce)(S._urls.map(s=>{try{return{uri:L.URI.parse(s),originalUrl:s}}catch{return null}})):[]}async startOpenWindow(S,s){const g=(0,f.isLaunchedFromCli)(s)?0:4;let d=[];const b=S.wait&&S.waitMarkerFilePath?L.URI.file(S.waitMarkerFilePath):void 0,w=S.remote||void 0,D={context:g,cli:S,userEnv:s,waitMarkerFileURI:b,remoteAuthority:w,forceProfile:S.profile,forceTempProfile:S["profile-temp"]};if(S.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(S.extensionDevelopmentPath,D);else if(!S._.length&&!S["folder-uri"]&&!S["file-uri"]){let t=!1;if(S["new-window"]||S["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(S["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)d=await this.windowsMainService.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,D),d=[l]):d=await this.windowsMainService.open({...D,forceEmpty:!0})}}else d=await this.windowsMainService.open({...D,forceNewWindow:S["new-window"],preferNewWindow:!S["reuse-window"]&&!S.wait,forceReuseWindow:S["reuse-window"],diffMode:S.diff,mergeMode:S.merge,addMode:S.add,noRecentEntry:!!S["skip-add-to-recently-opened"],gotoLineMode:S.goto});if(b&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,M.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};h=we([X(0,v.ILogService),X(1,y.IWindowsMainService),X(2,p.IURLService),X(3,k.IConfigurationService)],h),e.LaunchMainService=h}),define(ee[70],te([0,1,15,2,3,5,264,7,14,72,30,75,25,20,73,37]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function s(b){return typeof b.responseWindowId=="number"}let g=class ut extends A.Disposable{static getAll(){return Array.from(ut.all.values())}constructor(w,D,t){super(),this.logService=w,this.telemetryService=D,this.lifecycleMainService=t,this.id=String(++ut.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(w,D){let t;switch(this.configuration?.correlationId?t=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${w}`:t=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${w}`,D){case p.default.Error:this.logService.error(t);break;case p.default.Warning:this.logService.warn(t);break;case p.default.Info:this.logService.info(t);break}}validateCanStart(){if(!u.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");return this.process?(this.log("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(w){const D=this.doStart(w,!1);return D&&w.payload&&this.postMessage(w.payload),D}doStart(w,D){if(!this.validateCanStart())return!1;this.configuration=w;const t=`${this.configuration.type}-${this.id}`,l=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],n=this.configuration.execArgv??[],a=this.configuration.allowLoadingUnsignedLibraries,c="pipe",o=this.createEnv(w,D);return this.log("creating new...",p.default.Info),this.process=u.UtilityProcess.fork(l,i,{serviceName:t,env:o,execArgv:n,allowLoadingUnsignedLibraries:a,stdio:c}),this.registerListeners(this.process,this.configuration,t,D),!0}createEnv(w,D){const t=w.env?{...w.env}:{...(0,S.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),D&&(t.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,(0,E.removeDangerousEnvVariables)(t);for(const l of Object.keys(t))t[l]=String(t[l]);return t}registerListeners(w,D,t,l){if(w.stdout){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(w.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:i.write(n))))}if(w.stderr){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(w.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:i.write(n))))}this._register(r.Event.fromNodeEventEmitter(w,"message")(i=>this._onMessage.fire(i))),this._register(r.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.processPid=w.pid,typeof w.pid=="number"&&ut.all.set(w.pid,{pid:w.pid,name:s(D)?`${D.type} [${D.responseWindowId}]`:D.type}),this.log("successfully created",p.default.Info)})),this._register(r.Event.fromNodeEventEmitter(w,"exit")(i=>{this.log(`received exit event with code ${i}`,p.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(I.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===t&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:D.type,reason:i.reason,code:i.exitCode,sandboxed:l?"1":"0"}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(w,D){const t=this._register(this._onMessage.event(l=>{l===w&&(t.dispose(),D())}))}postMessage(w,D){!this.process||this.process.postMessage(w,D)}connect(w){const{port1:D,port2:t}=new I.MessageChannelMain;return this.postMessage(w,[t]),D}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",p.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",p.default.Info),this.process.kill()?(this.log("successfully killed the process",p.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",p.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&ut.all.delete(this.processPid),this.process=void 0}async waitForExit(w){!this.process||(this.log("waiting to exit...",p.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,k.timeout)(w)]),this.process&&(this.log(`did not exit within ${w}ms, will kill it now...`,p.default.Info),this.kill()))}};g.ID_COUNTER=0,g.all=new Map,g=we([X(0,L.ILogService),X(1,y.ITelemetryService),X(2,h.ILifecycleMainService)],g),e.UtilityProcess=g;let d=class extends g{constructor(w,D,t,l){super(w,t,l),this.windowsMainService=D}start(w){const D=this.windowsMainService.getWindowById(w.responseWindowId);if(!D?.win||D.win.isDestroyed()||D.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.doStart(w,D.isSandboxed))return!1;this.registerWindowListeners(D.win,w);const l=this.connect(w.payload);return D.win.webContents.postMessage(w.responseChannel,w.responseNonce,[l]),!0}registerWindowListeners(w,D){D.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,t=>t.window.win===w)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};d=we([X(0,L.ILogService),X(1,v.IWindowsMainService),X(2,y.ITelemetryService),X(3,h.ILifecycleMainService)],d),e.WindowUtilityProcess=d}),define(ee[265],te([0,1,13,2,3,5,20,74,46,264,7,14,37,4,36,72,70,30,25]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let b=class kt{constructor(t,l,i,n){this._logService=t,this._lifecycleMainService=l,this._windowsMainService=i,this._telemetryService=n,this._shutdown=!1,this._extHosts=new Map,this._lifecycleMainService.onWillShutdown(a=>{this._shutdown=!0,a.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(t){const l=this._extHosts.get(t);if(!l)throw new Error("Unknown extension host!");return l}onDynamicStdout(t){return this._getExtHost(t).onStdout}onDynamicStderr(t){return this._getExtHost(t).onStderr}onDynamicMessage(t){return this._getExtHost(t).onMessage}onDynamicError(t){const l=this._getExtHost(t);return l instanceof s.WindowUtilityProcess?r.Event.None:l.onError}onDynamicExit(t){return this._getExtHost(t).onExit}async canUseUtilityProcess(){return S.canUseUtilityProcess}async createExtensionHost(t){if(this._shutdown)throw(0,I.canceled)();const l=String(++kt._lastId);let i;if(t){if(!S.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new s.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService)}else i=new w(l,this._logService);return this._extHosts.set(l,i),i.onExit(({pid:n,code:a,signal:c})=>{this._logService.info(`Extension host with pid ${n} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{i.dispose(),this._extHosts.delete(l)})}),{id:l}}async start(t,l){if(this._shutdown)throw(0,I.canceled)();this._getExtHost(t).start({...l,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:l.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this._shutdown)throw(0,I.canceled)();const l=this._extHosts.get(t);return l?l.enableInspectPort():!1}async kill(t){if(this._shutdown)throw(0,I.canceled)();const l=this._extHosts.get(t);!l||l.kill()}async _killAllNow(){for(const[,t]of this._extHosts)t.kill()}async _waitForAllExit(t){const l=[];for(const[,i]of this._extHosts)l.push(i.waitForExit(t));return v.Promises.settled(l).then(()=>{})}};b._lastId=0,b=we([X(0,L.ILogService),X(1,M.ILifecycleMainService),X(2,g.IWindowsMainService),X(3,d.ITelemetryService)],b),e.ExtensionHostStarter=b;let w=class extends A.Disposable{constructor(t,l){super(),this.id=t,this._logService=l,this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(t){h.isCI&&this._logService.info("Calling fork to start extension host...");const l=k.StopWatch.create(!1);this._process=(0,f.fork)(p.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,E.cwd)()},t));const i=l.elapsed(),n=this._process.pid;this._logService.info(`Starting extension host with pid ${n} (fork() took ${i} ms).`);const a=new u.StringDecoder("utf-8");this._process.stdout?.on("data",o=>{const m=typeof o=="string"?o:a.write(o);this._onStdout.fire(m)});const c=new u.StringDecoder("utf-8");this._process.stderr?.on("data",o=>{const m=typeof o=="string"?o:c.write(o);this._onStderr.fire(m)}),this._process.on("message",o=>{this._onMessage.fire(o)}),this._process.on("error",o=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(o)})}),this._process.on("exit",(o,m)=>{this._hasExited=!0,this._onExit.fire({pid:n,code:o,signal:m})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):h.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(t){if(!this._process)return;const l=this._process.pid;this._logService.info(`Waiting for extension host with pid ${l} to exit.`),await Promise.race([r.Event.toPromise(this.onExit),(0,v.timeout)(t)]),this._hasExited||(this._logService.info(`Extension host with pid ${l} did not exit within ${t}ms.`),this._process.kill())}};w=we([X(1,L.ILogService)],w)}),define(ee[266],te([0,1,2,6,5,30,70,25,56,3,7,20]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,A.createDecorator)("utilityProcessWorker");let y=class extends I.Disposable{constructor(S,s,g,d){super(),this.logService=S,this.windowsMainService=s,this.telemetryService=g,this.lifecycleMainService=d,this.workers=new Map}async createWorker(S){const s=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${s})`);const g=this.hash(S);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${s})`),this.disposeWorker(S));const d=new h(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,S);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,d);const b=new v.DeferredPromise;return u.Event.once(d.onDidTerminate)(w=>{w.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${w.code}, signal: ${w.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${w.code}, signal: ${w.signal}`),this.workers.delete(g),b.complete({reason:w})}),b.p}hash(S){return(0,f.hash)({moduleId:S.process.moduleId,windowId:S.reply.windowId})}async disposeWorker(S){const s=this.hash(S),g=this.workers.get(s);!g||(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),g.kill(),this.workers.delete(s))}};y=we([X(0,r.ILogService),X(1,L.IWindowsMainService),X(2,k.ITelemetryService),X(3,p.ILifecycleMainService)],y),e.UtilityProcessWorkerMainService=y;let h=class extends I.Disposable{constructor(S,s,g,d,b){super(),this.logService=S,this.windowsMainService=s,this.telemetryService=g,this.lifecycleMainService=d,this.configuration=b,this._onDidTerminate=this._register(new u.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(S=>this._onDidTerminate.fire({code:S.code,signal:S.signal}))),this._register(this.utilityProcess.onCrash(S=>this._onDidTerminate.fire({code:S.code,signal:"ECRASH"})))}spawn(){const s=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:s,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};h=we([X(0,r.ILogService),X(1,L.IWindowsMainService),X(2,k.ITelemetryService),X(3,p.ILifecycleMainService)],h)}),define(ee[267],te([0,1,15,3,2,260,30]),function(j,e,I,A,r,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends r.Disposable{constructor(u){super(),this.windowsMainService=u,this._onFoundInFrame=this._register(new A.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(u,v){let p;if(typeof u.windowId=="number"){const{windowId:y}=u,h=this.windowsMainService.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);p=h.win.webContents}else{const{webContentsId:y}=u;if(p=I.webContents.fromId(y),!p)throw new Error(`Invalid webContentsId: ${y}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(v)}async findInFrame(u,v,p,y){const E=this.getFrameByName(u,v);if(typeof E.findInFrame=="function"){E.findInFrame(p,{findNext:y.findNext,forward:y.forward});const S=(s,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),E.removeListener("found-in-frame",S))};E.on("found-in-frame",S)}}async stopFindInFrame(u,v,p){const h=this.getFrameByName(u,v);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}getFrameByName(u,v){const p=this.windowsMainService.getWindowById(u.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${u}`);const y=p.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===v);if(!y)throw new Error(`Unknown frame: ${v}`);return y}};k=we([X(0,M.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[268],te([0,1,7,3,2]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends r.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.disposables=this._register(new r.DisposableStore),A.Event.latch(A.Event.any(k,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>u()),(async()=>{try{const p=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:p}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(k){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=k}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ee[29],te([0,1,187,9,61,18,8,6,14]),function(j,e,I,A,r,L,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function u(n){const a=n;return typeof a?.id=="string"&&M.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=u;function v(n){return typeof n?.id=="string"&&!u(n)&&!y(n)}e.isEmptyWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,A.basename)(n)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=p;function y(n){const a=n;return typeof a?.id=="string"&&M.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=y;function h(n){const a=n;if(a?.uri)return{id:a.id,uri:M.URI.revive(a.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:M.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=h;var E;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function S(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=S;function s(n){const a=n;return!!(a&&typeof a=="object"&&M.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=s;class g{constructor(a,c,o,m,C){this._id=a,this._transient=o,this._configuration=m,this._ignorePathCasing=C,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class d{constructor(a,c){this.raw=c,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function b(n){return new d({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,a){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,a.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function D(n){let a;return M.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=D,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function l(n,a){return!w(n,a)&&!D(n)}e.isSavedWorkspace=l;function i(n){return(typeof n=="string"?(0,A.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[58],te([0,1,15,7,56,45,2,82,4,11,24,164,90,6,5,21,29]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,h.createDecorator)("dialogMainService");let g=class{constructor(b,w){this.logService=b,this.productService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(b,w){return this.doPick({...b,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},w)}pickFolder(b,w){return this.doPick({...b,pickFolders:!0,title:(0,p.localize)(1,null)},w)}pickFile(b,w){return this.doPick({...b,pickFiles:!0,title:(0,p.localize)(2,null)},w)}pickWorkspace(b,w){const D=(0,p.localize)(3,null),t=(0,L.mnemonicButtonLabel)((0,p.localize)(4,null)),l=s.WORKSPACE_FILTER;return this.doPick({...b,pickFiles:!0,title:D,filters:l,buttonLabel:t},w)}async doPick(b,w){const D={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(D.properties=void 0,b.pickFiles&&b.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,u.withNullAsUndefined)(w||I.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}getWindowDialogQueue(b){if(b){let w=this.windowDialogQueues.get(b.id);return w||(w=new A.Queue,this.windowDialogQueues.set(b.id,w)),w}else return this.noWindowDialogueQueue}showMessageBox(b,w){return this.getWindowDialogQueue(w).queue(async()=>{const{options:D,buttonIndeces:t}=(0,y.massageMessageBoxOptions)(b,this.productService);let l;return w?l=await I.dialog.showMessageBox(w,D):l=await I.dialog.showMessageBox(D),{response:t[l.response],checkboxChecked:l.checkboxChecked}})}async showSaveDialog(b,w){const D=this.acquireFileDialogLock(b,w);if(!D)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(w).queue(async()=>{let t;return w?t=await I.dialog.showSaveDialog(w,b):t=await I.dialog.showSaveDialog(b),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,M.dispose)(D)}}normalizePath(b){return b&&f.isMacintosh&&(b=(0,k.normalizeNFC)(b)),b}normalizePaths(b){return b.map(w=>this.normalizePath(w))}async showOpenDialog(b,w){b.defaultPath&&(await v.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const D=this.acquireFileDialogLock(b,w);if(!D)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(w).queue(async()=>{let t;return w?t=await I.dialog.showOpenDialog(w,b):t=await I.dialog.showOpenDialog(b),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,M.dispose)(D)}}acquireFileDialogLock(b,w){if(!w)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",b);let D=this.windowFileDialogLocks.get(w.id);D||(D=new Set,this.windowFileDialogLocks.set(w.id,D));const t=(0,r.hash)(b);if(!D.has(t))return this.logService.trace("[DialogMainService]: new file dialog lock created",b),D.add(t),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",b),D?.delete(t),D?.size===0&&this.windowFileDialogLocks.delete(w.id)})}};g=we([X(0,E.ILogService),X(1,S.IProductService)],g),e.DialogMainService=g}),define(ee[269],te([0,1,3,2,85,29]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends A.Disposable{constructor(f,u){super(),this.logService=f,this.storageMainService=u,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(u.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(f,u){this._register(I.Event.debounce(f.onDidChangeStorage,(v,p)=>(v?v.push(p):v=[p],v),M.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&u.fire(this.serializeStorageChangeEvents(v,f))}))}serializeStorageChangeEvents(f,u){const v=new Map,p=new Set;return f.forEach(y=>{const h=u.get(y.key);typeof h=="string"?v.set(y.key,h):p.add(y.key)}),{changed:Array.from(v.entries()),deleted:Array.from(p.values())}}listen(f,u,v){switch(u){case"onDidChangeStorage":{const p=v.profile?(0,r.revive)(v.profile):void 0;if(!p)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(p.id);return y||(y=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(p),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(p.id,y)),y.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,v){const p=v.profile?(0,r.revive)(v.profile):void 0,y=(0,L.reviveIdentifier)(v.workspace),h=await this.withStorageInitialized(p,y);switch(u){case"getItems":return Array.from(h.items.entries());case"updateItems":{const E=v;if(E.insert)for(const[S,s]of E.insert)h.set(S,s);E.delete?.forEach(S=>h.delete(S));break}case"isUsed":{const E=v.payload;if(typeof E=="string")return this.storageMainService.isUsed(E)}default:throw new Error(`Call not found: ${u}`)}}async withStorageInitialized(f,u){let v;u?v=this.storageMainService.workspaceStorage(u):f?v=this.storageMainService.profileStorage(f):v=this.storageMainService.applicationStorage;try{await v.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${p}`)}return v}}M.STORAGE_CHANGE_DEBOUNCE_TIME=100,e.StorageDatabaseChannel=M}),define(ee[40],te([0,1,56,3,2,18,8,184,34,16,6,5,29,35,39,7,31,26,11]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&M.URI.isUri(n.location)&&M.URI.isUri(n.globalStorageHome)&&M.URI.isUri(n.settingsResource)&&M.URI.isUri(n.keybindingsResource)&&M.URI.isUri(n.tasksResource)&&M.URI.isUri(n.snippetsHome)&&M.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function w(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:M.URI.revive(i.location).with({scheme:n}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:M.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:M.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=w;function D(i,n,a,c,o){return{id:i,name:n,location:a,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,L.joinPath)(a,"globalStorage"),settingsResource:(0,L.joinPath)(a,"settings.json"),keybindingsResource:(0,L.joinPath)(a,"keybindings.json"),tasksResource:(0,L.joinPath)(a,"tasks.json"),snippetsHome:(0,L.joinPath)(a,"snippets"),extensionsResource:(0,L.joinPath)(a,"extensions.json"),cacheHome:(0,L.joinPath)(c,i),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=D;let t=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,a,c,o){super(),this.environmentService=n,this.fileService=a,this.uriIdentityService=c,this.logService=o,this.enabled=!0,this._onDidChangeProfiles=this._register(new A.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new A.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new A.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new A.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,L.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=[];if(this.enabled)try{for(const m of this.getStoredProfiles()){if(!m.name||!(0,d.isString)(m.name)||!m.location){this.logService.warn("Skipping the invalid stored profile",m.location||m.name);continue}n.push(D((0,L.basename)(m.location),m.name,m.location,this.profilesCacheHome,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}))}}catch(m){this.logService.error(m)}const a=new h.ResourceMap,c=new Map,o=this.createDefaultProfile();if(n.unshift({...o,extensionsResource:this.getDefaultProfileExtensionsLocation()??o.extensionsResource,isDefault:!0}),n.length)try{const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[C,R]of Object.entries(m.workspaces)){const T=M.URI.parse(C),U=n.find($=>$.id===R);U&&a.set(T,U)}if(m.emptyWindows)for(const[C,R]of Object.entries(m.emptyWindows)){const T=n.find(U=>U.id===R);T&&c.set(C,T)}}catch(m){this.logService.error(m)}this._profilesObject={profiles:n,workspaces:a,emptyWindows:c}}return this._profilesObject}createDefaultProfile(){return D("__default__profile__",(0,k.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(n){const a="Temp",c=new RegExp(`${(0,g.escapeRegExpCharacters)(a)}\\s(\\d+)`);let o=0;for(const C of this.profiles){const R=c.exec(C.name),T=R?parseInt(R[1]):0;o=T>o?T:o}const m=`${a} ${o+1}`;return this.createProfile((0,I.hash)((0,s.generateUuid)()).toString(16),m,{transient:!0},n)}async createNamedProfile(n,a,c){return this.createProfile((0,I.hash)((0,s.generateUuid)()).toString(16),n,a,c)}async createProfile(n,a,c,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const m=await this.doCreateProfile(n,a,c);return o&&await this.setProfileForWorkspace(o,m),m}async doCreateProfile(n,a,c){if(!(0,d.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.profileCreationPromises.get(a);return o||(o=(async()=>{try{const m=this.profiles.find(T=>T.name===a||T.id===n);if(m)return m;const C=D(n,a,(0,L.joinPath)(this.profilesHome,n),this.profilesCacheHome,c);await this.fileService.createFolder(C.location);const R=[];return this._onWillCreateProfile.fire({profile:C,join(T){R.push(T)}}),await S.Promises.settled(R),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(a)}})(),this.profileCreationPromises.set(a,o)),o}async updateProfile(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(o=>o.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=D(c.id,a.name??c.name,c.location,this.profilesCacheHome,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:a,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.logService.error(o)}for(const o of[...this.profilesObject.emptyWindows.keys()])a.id===this.profilesObject.emptyWindows.get(o)?.id&&this.profilesObject.emptyWindows.delete(o);for(const o of[...this.profilesObject.workspaces.keys()])a.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[a],[]);try{await this.fileService.del(a.cacheHome,{recursive:!0})}catch(o){(0,u.toFileOperationResult)(o)!==1&&this.logService.error(o)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(a.location,{recursive:!0})}catch(o){this.logService.error(o)}}async setProfileForWorkspace(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,a)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,a.resource))).map(a=>this.fileService.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(a=>!this.isProfileAssociatedToWorkspace(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.getWorkspace(n);return M.URI.isUri(a)?this.transientProfilesObject.workspaces.get(a)??this.profilesObject.workspaces.get(a):this.transientProfilesObject.emptyWindows.get(a)??this.profilesObject.emptyWindows.get(a)}getWorkspace(n){return(0,y.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,y.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location))||[...this.profilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,n.location)))}updateProfiles(n,a,c){const o=[...this.profiles,...n],m=[];this.transientProfilesObject.profiles=[];for(let C of o)C.isDefault||a.some(R=>C.id===R.id)||(C=c.find(R=>C.id===R.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):m.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(m),this._profilesObject=void 0,this.triggerProfilesChanges(n,a,c)}triggerProfilesChanges(n,a,c){this._onDidChangeProfiles.fire({added:n,removed:a,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,a,c){c=a?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const o=this.getWorkspace(n),m=c?this.transientProfilesObject:this.profilesObject;M.URI.isUri(o)?(m.workspaces.delete(o),a&&m.workspaces.set(o,a)):(m.emptyWindows.delete(o),a&&m.emptyWindows.set(o,a)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,o]of this.profilesObject.workspaces.entries())n[c.toString()]=o.id;const a={};for(const[c,o]of this.profilesObject.emptyWindows.entries())a[c.toString()]=o.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:a}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const a={},c=this.createDefaultProfile();if(n.workspaces)for(const[m,C]of Object.entries(n.workspaces)){const R=M.URI.parse(C);a[m]=this.uriIdentityService.extUri.isEqual(R,c.location)?c.id:this.uriIdentityService.extUri.basename(R)}const o={};if(n.emptyWindows)for(const[m,C]of Object.entries(n.emptyWindows)){const R=M.URI.parse(C);o[m]=this.uriIdentityService.extUri.isEqual(R,c.location)?c.id:this.uriIdentityService.extUri.basename(R)}return{workspaces:a,emptyWindows:o}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=we([X(0,f.IEnvironmentService),X(1,u.IFileService),X(2,E.IUriIdentityService),X(3,p.ILogService)],t),e.UserDataProfilesService=t;class l extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=l}),define(ee[80],te([0,1,7,17,2,3,35,8,112,119,16,6,5,40,39,11,13,25]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let w=class extends r.Disposable{constructor(i,n,a,c,o,m){super(),this.extensionsLocation=i,this.fileService=n,this.userDataProfilesService=a,this.uriIdentityService=c,this.telemetryService=o,this.logService=m,this._onAddExtensions=this._register(new L.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new L.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new L.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new L.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(i,n){return this.withProfileExtensions(i,void 0,n)}async addExtensionsToProfile(i,n){const a=[],c=[];try{return await this.withProfileExtensions(n,o=>{const m=[];for(const C of o)i.some(([R])=>(0,u.areSameExtensions)(R.identifier,C.identifier)&&R.manifest.version!==C.version)?a.push(C):m.push(C);for(const[C,R]of i)if(!m.some(T=>(0,u.areSameExtensions)(T.identifier,C.identifier)&&T.version===C.manifest.version)){const T={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:R};c.push(T),m.push(T)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:n}),a.length&&this._onRemoveExtensions.fire({extensions:a,profileLocation:n}),m}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:n}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,profileLocation:n}),c}catch(o){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:o,profileLocation:n}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const a=[];return await this.withProfileExtensions(n,c=>{const o=[];for(const m of c){const C=i.find(([R])=>(0,u.areSameExtensions)(R.identifier,m.identifier)&&R.manifest.version===m.version);C&&(m.metadata={...m.metadata,...C[1]},a.push(m)),o.push(m)}return o}),a}async removeExtensionFromProfile(i,n){const a=[];this._onRemoveExtensions.fire({extensions:a,profileLocation:n});try{await this.withProfileExtensions(n,c=>{const o=[];for(const m of c)(0,u.areSameExtensions)(m.identifier,i.identifier)?a.push(m):o.push(m);return a.length&&this._onRemoveExtensions.fire({extensions:a,profileLocation:n}),o}),a.length&&this._onDidRemoveExtensions.fire({extensions:a,profileLocation:n})}catch(c){throw a.length&&this._onDidRemoveExtensions.fire({extensions:a,error:c,profileLocation:n}),c}}async withProfileExtensions(i,n,a){return this.getResourceAccessQueue(i).queue(async()=>{let c=[],o;try{const m=await this.fileService.readFile(i);o=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,v.toFileOperationResult)(m)!==1)throw m;if(this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)&&(o=await this.migrateFromOldDefaultProfileExtensionsLocation()),!o&&a?.bailOutWhenFileNotFound)throw new b((0,s.getErrorMessage)(m),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.reportAndThrowInvalidConentError(i);let m=!1;for(const C of o){D(C)||this.reportAndThrowInvalidConentError(i);let R;if((0,S.isString)(C.relativeLocation)&&C.relativeLocation)R=this.resolveExtensionLocation(C.relativeLocation);else if((0,S.isString)(C.location))R=this.resolveExtensionLocation(C.location),m=!0,C.relativeLocation=C.location,C.location=R.toJSON();else{R=k.URI.revive(C.location);const T=this.toRelativePath(R);T&&(m=!0,C.relativeLocation=T)}c.push({identifier:C.identifier,location:R,version:C.version,metadata:C.metadata})}m&&await this.fileService.writeFile(i,A.VSBuffer.fromString(JSON.stringify(o)))}if(n){c=n(c);const m=c.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.toRelativePath(C.location),metadata:C.metadata}));await this.fileService.writeFile(i,A.VSBuffer.fromString(JSON.stringify(m)))}return c})}reportAndThrowInvalidConentError(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(i){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(i),this.extensionsLocation)?this.uriIdentityService.extUri.basename(i):void 0}resolveExtensionLocation(i){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,i)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const i=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let a;try{a=(await this.fileService.readFile(i)).value.toString()}catch(o){if((0,v.toFileOperationResult)(o)===1)return;throw o}this.logService.info("Migrating extensions from old default profile location",i.toString());let c;try{const o=JSON.parse(a);Array.isArray(o)&&o.every(m=>D(m))?c=o:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.logService.error(o)}if(c)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(o){if((0,v.toFileOperationResult)(o)===3)this.logService.info("Migration from old default profile location to new location is done by another window",i.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw o}try{await this.fileService.del(i)}catch(o){(0,v.toFileOperationResult)(o)!==1&&this.logService.error(o)}try{await this.fileService.del(n)}catch(o){(0,v.toFileOperationResult)(o)!==1&&this.logService.error(o)}return c})()),this._migrationPromise}getResourceAccessQueue(i){let n=this.resourcesAccessQueueMap.get(i);return n||(n=new I.Queue,this.resourcesAccessQueueMap.set(i,n)),n}};w=we([X(1,v.IFileService),X(2,h.IUserDataProfilesService),X(3,E.IUriIdentityService),X(4,g.ITelemetryService),X(5,y.ILogService)],w),e.AbstractExtensionsProfileScannerService=w;function D(l){return(0,S.isObject)(l)&&(0,f.isIExtensionIdentifier)(l.identifier)&&(t(l.location)||(0,S.isString)(l.location)&&l.location)&&((0,S.isUndefined)(l.relativeLocation)||(0,S.isString)(l.relativeLocation))&&l.version&&(0,S.isString)(l.version)}function t(l){return l?(0,S.isString)(l.path)&&(0,S.isString)(l.scheme):!1}}),define(ee[125],te([0,1,22,7,37,17,13,43,147,2,14,9,4,18,200,75,11,8,169,34,119,116,199,16,6,5,21,3,85,80,40,39,198]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(ce){function K(Y,x){if(Y===x)return!0;const W=Object.keys(Y),H=new Set;for(const Q of Object.keys(x))H.add(Q);if(W.length!==H.size)return!1;for(const Q of W){if(Y[Q]!==x[Q])return!1;H.delete(Q)}return H.size===0}ce.equals=K})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=class extends u.Disposable{constructor(K,Y,x,W,H,Q,ne,re,Z,_,P,O){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=Y,this.extensionsControlLocation=x,this.currentProfile=W,this.userDataProfilesService=H,this.extensionsProfileScannerService=Q,this.fileService=ne,this.logService=re,this.environmentService=Z,this.productService=_,this.uriIdentityService=P,this.instantiationService=O,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(oe,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(oe,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ie,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,w.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,Y,x){const[W,H]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(Y)]),Q=x?await this.scanExtensionsUnderDevelopment(K,[...W,...H]):[];return this.dedupExtensions(W,H,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),Y.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[x,W]=await Promise.all(Y);return this.applyScanOptions([...x,...W],0,K,!1)}async scanUserExtensions(K){const Y=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const x=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Y,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,x),H=K.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Q;try{Q=await H.scanExtensions(W)}catch(ne){if(ne instanceof m.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),Q=await H.scanExtensions(W);else throw ne}return Q=await this.applyScanOptions(Q,1,K,!0),this.logService.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(K,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===v.Schemas.file).map(async W=>{const H=await this.createExtensionScannerInput(W,!1,1,!0,K.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(H)).map(ne=>(ne.type=Y.find(re=>(0,w.areSameExtensions)(re.identifier,ne.identifier))?.type??ne.type,this.extensionsScanner.validate(ne,H)))}))).flat();return this.applyScanOptions(x,"development",K,!0)}return[]}async scanExistingExtension(K,Y,x){const W=await this.createExtensionScannerInput(K,!1,Y,!0,x.language,!0,void 0),H=await this.extensionsScanner.scanExtension(W);return!H||!x.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(K,Y,x){const W=await this.createExtensionScannerInput(K,!1,Y,!0,x.language,!0,void 0),H=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(H,Y,x,!0)}async scanMetadata(K){const Y=(0,h.joinPath)(K,"package.json"),x=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(K,Y){const x=(0,h.joinPath)(K,"package.json"),W=(await this.fileService.readFile(x)).value.toString(),H=JSON.parse(W);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,H.__metadata={...H.__metadata,...Y},await this.fileService.writeFile((0,h.joinPath)(K,"package.json"),L.VSBuffer.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof m.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,l.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,Y,x,W){return x.includeAllVersions||(K=this.dedupExtensions(Y===0?K:void 0,Y===1?K:void 0,Y==="development"?K:void 0,await this.getTargetPlatform(),W)),x.includeInvalid||(K=K.filter(H=>H.isValid)),K.sort((H,Q)=>{const ne=p.basename(H.location.fsPath),re=p.basename(Q.location.fsPath);return ne<re?-1:ne>re?1:0})}dedupExtensions(K,Y,x,W,H){const Q=(re,Z,_)=>{if(re.isValid&&!Z.isValid)return!1;if(re.isValid===Z.isValid){if(H&&E.gt(re.manifest.version,Z.manifest.version))return this.logService.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(E.eq(re.manifest.version,Z.manifest.version)){if(re.type===0)return this.logService.debug(`Skipping extension ${Z.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===W)return this.logService.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return _?this.logService.warn(`Overwriting user extension ${re.location.path} with ${Z.location.path}.`):this.logService.debug(`Overwriting user extension ${re.location.path} with ${Z.location.path}.`),!0},ne=new D.ExtensionIdentifierMap;return K?.forEach(re=>{const Z=ne.get(re.identifier.id);(!Z||Q(Z,re,!1))&&ne.set(re.identifier.id,re)}),Y?.forEach(re=>{const Z=ne.get(re.identifier.id);if(!Z&&K&&re.type===0){this.logService.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!Z||Q(Z,re,!1))&&ne.set(re.identifier.id,re)}),x?.forEach(re=>{const Z=ne.get(re.identifier.id);(!Z||Q(Z,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async scanDefaultSystemExtensions(K,Y){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),H=await(K&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",H.length),H}async scanDevSystemExtensions(K,Y){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Y?await this.getBuiltInExtensionControl():{},H=[],Q=g.URI.file(p.normalize(p.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of x){const Z=W[re.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":H.push((0,h.joinPath)(Q,re.name));break;default:H.push(g.URI.file(Z));break}}const ne=await Promise.all(H.map(async re=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(re,!1,0,!0,K,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ne.length),(0,I.coalesce)(ne)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,Y,x,W,H,Q,ne){const re=await this.getTranslations(H??y.language),Z=await this.getMtime(K),_=Y&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=_?await this.getMtime(_):void 0;return new q(K,Z,_,P,Y,ne,x,W,Q,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,H,re)}async getMtime(K){try{const Y=await this.fileService.stat(K);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};$=we([X(4,C.IUserDataProfilesService),X(5,m.IExtensionsProfileScannerService),X(6,l.IFileService),X(7,n.ILogService),X(8,b.IEnvironmentService),X(9,a.IProductService),X(10,R.IUriIdentityService),X(11,i.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class q{constructor(K,Y,x,W,H,Q,ne,re,Z,_,P,O,F,B,N){this.location=K,this.mtime=Y,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=W,this.profile=H,this.profileScanOptions=Q,this.type=ne,this.excludeObsolete=re,this.validate=Z,this.productVersion=_,this.productDate=P,this.productCommit=O,this.devMode=F,this.language=B,this.translations=N}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,Y){return(0,h.isEqual)(K.location,Y.location)&&K.mtime===Y.mtime&&(0,h.isEqual)(K.applicationExtensionslocation,Y.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&K.profile===Y.profile&&r.equals(K.profileScanOptions,Y.profileScanOptions)&&K.type===Y.type&&K.excludeObsolete===Y.excludeObsolete&&K.validate===Y.validate&&K.productVersion===Y.productVersion&&K.productDate===Y.productDate&&K.productCommit===Y.productCommit&&K.devMode===Y.devMode&&K.language===Y.language&&U.equals(K.translations,Y.translations)}}e.ExtensionScannerInput=q;let ie=class extends u.Disposable{constructor(K,Y,x,W,H){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=Y,this.uriIdentityService=x,this.fileService=W,this.logService=H}async scanExtensions(K){const Y=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let x={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(W)}catch{}return(0,s.isEmptyObject)(x)?Y:Y.filter(W=>!x[w.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(K){const Y=await this.fileService.resolve(K.location);if(!Y.children?.length)return[];const x=await Promise.all(Y.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,h.basename)(W.resource).indexOf(".")===0)return null;const H=new q(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(H)}));return(0,I.coalesce)(x).sort((W,H)=>W.location.path<H.location.path?-1:1)}async scanExtensionsFromProfile(K){let Y=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){Y=Y.filter(W=>!W.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,K);Y.push(...x)}return Y}async scanExtensionsFromProfileResource(K,Y,x){const W=await this.extensionsProfileScannerService.scanProfileExtensions(K,x.profileScanOptions);if(!W.length)return[];const H=await Promise.all(W.map(async Q=>{if(Y(Q)){const ne=new q(Q.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ne,Q.metadata)}return null}));return(0,I.coalesce)(H)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,h.joinPath)(K.location,"package.json"))){const Y=await this.scanExtension(K);return Y?[Y]:[]}else return await this.scanExtensions(K)}catch(Y){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,M.getErrorMessage)(Y)),[]}}async scanExtension(K,Y){try{let x=await this.scanExtensionManifest(K.location);if(x){x.publisher||(x.publisher=D.UNDEFINED_PUBLISHER),Y=Y??x.__metadata,delete x.__metadata;const W=(0,w.getGalleryExtensionId)(x.publisher,x.name),H=Y?.id?{id:W,uuid:Y.id}:{id:W},Q=Y?.isSystem?0:K.type,ne=Q===0||!!Y?.isBuiltin;x=await this.translateManifest(K.location,x,q.createNlsConfiguration(K));const re={type:Q,identifier:H,manifest:x,location:K.location,isBuiltin:ne,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return K.validate?this.validate(re,K):re}}catch(x){K.type!==0&&this.logService.error(x)}return null}validate(K,Y){let x=!0;const W=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,K.manifest,K.isBuiltin);for(const[H,Q]of W)H===S.default.Error&&(x=!1,this.logService.error(this.formatMessage(Y.location,Q)));return K.isValid=x,K.validations=W,K}async scanExtensionManifest(K){const Y=(0,h.joinPath)(K,"package.json");let x;try{x=(await this.fileService.readFile(Y)).value.toString()}catch(H){return(0,l.toFileOperationResult)(H)!==1&&this.logService.error(this.formatMessage(K,(0,d.localize)(0,null,Y.path,H.message))),null}let W;try{W=JSON.parse(x)}catch{const Q=[];(0,k.parse)(x,Q);for(const ne of Q)this.logService.error(this.formatMessage(K,(0,d.localize)(1,null,Y.path,ne.offset,ne.length,(0,f.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(K,(0,d.localize)(2,null,Y.path))),null):W}async translateManifest(K,Y,x){const W=await this.getLocalizedMessages(K,Y,x);if(W)try{const H=[],Q=await this.resolveOriginalMessageBundle(W.default,H);if(H.length>0)return H.forEach(re=>{this.logService.error(this.formatMessage(K,(0,d.localize)(3,null,W.default?.path,(0,f.getParseErrorMessage)(re.error))))}),Y;if((0,k.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(K,(0,d.localize)(4,null,W.default?.path))),Y;const ne=W.values||Object.create(null);return(0,T.localizeManifest)(Y,ne,Q)}catch{}return Y}async getLocalizedMessages(K,Y,x){const W=(0,h.joinPath)(K,"package.nls.json"),H=(Z,_)=>{_.forEach(P=>{this.logService.error(this.formatMessage(K,(0,d.localize)(5,null,Z?.path,(0,f.getParseErrorMessage)(P.error))))})},Q=Z=>{this.logService.error(this.formatMessage(K,(0,d.localize)(6,null,Z?.path)))},ne=`${Y.publisher}.${Y.name}`,re=x.translations[ne];if(re)try{const Z=g.URI.file(re),_=(await this.fileService.readFile(Z)).value.toString(),P=[],O=(0,k.parse)(_,P);return P.length>0?(H(Z,P),{values:void 0,default:W}):(0,k.getNodeType)(O)!=="object"?(Q(Z),{values:void 0,default:W}):{values:O.contents?O.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let _;try{_=await this.findMessageBundles(K,x)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const P=(await this.fileService.readFile(_.localized)).value.toString(),O=[],F=(0,k.parse)(P,O);return O.length>0?(H(_.localized,O),{values:void 0,default:_.original}):(0,k.getNodeType)(F)!=="object"?(Q(_.localized),{values:void 0,default:_.original}):{values:F,default:_.original}}catch{return{values:void 0,default:_.original}}}}async resolveOriginalMessageBundle(K,Y){if(K)try{const x=(await this.fileService.readFile(K)).value.toString();return(0,k.parse)(x,Y)}catch{}}findMessageBundles(K,Y){return new Promise((x,W)=>{const H=Q=>{const ne=(0,h.joinPath)(K,`package.nls.${Q}.json`);this.fileService.exists(ne).then(re=>{re&&x({localized:ne,original:(0,h.joinPath)(K,"package.nls.json")});const Z=Q.lastIndexOf("-");Z===-1?x({localized:(0,h.joinPath)(K,"package.nls.json"),original:null}):(Q=Q.substring(0,Z),H(Q))})};if(Y.devMode||Y.pseudo||!Y.language)return x({localized:(0,h.joinPath)(K,"package.nls.json"),original:null});H(Y.language)})}formatMessage(K,Y){return`[${K.path}]: ${Y}`}};ie=we([X(1,m.IExtensionsProfileScannerService),X(2,R.IUriIdentityService),X(3,l.IFileService),X(4,n.ILogService)],ie);let oe=class extends ie{constructor(K,Y,x,W,H,Q,ne){super(Y,W,H,Q,ne),this.currentProfile=K,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new A.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const Y=this.getCacheFile(K),x=await this.readExtensionCache(Y);if(this.input=K,x&&x.input&&q.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(H=>(H.location=g.URI.revive(H.location),H));const W=await super.scanExtensions(K);return await this.writeExtensionCache(Y,{input:K,result:W}),W}async readExtensionCache(K){try{const Y=await this.fileService.readFile(K),x=JSON.parse(Y.value.toString());return{result:x.result,input:(0,o.revive)(x.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",K.path,(0,M.getErrorMessage)(Y))}return null}async writeExtensionCache(K,Y){try{await this.fileService.writeFile(K,L.VSBuffer.fromString(JSON.stringify(Y)))}catch(x){this.logService.debug("Error while writing the extension cache file:",K.path,(0,M.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),Y=await this.readExtensionCache(K);if(!Y)return;const x=Y.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,x))try{this.logService.info("Invalidating Cache",x,W),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(H){this.logService.error(H)}}getCacheFile(K){const Y=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,K.type===0?D.BUILTIN_MANIFEST_CACHE_FILE:D.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===0?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(K.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};oe=we([X(2,C.IUserDataProfilesService),X(3,m.IExtensionsProfileScannerService),X(4,R.IUriIdentityService),X(5,l.IFileService),X(6,n.ILogService)],oe);function ae(ce,K){const Y=(0,w.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:Y,identifier:new D.ExtensionIdentifier(Y),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=ae;class he extends ${constructor(K,Y,x,W,H,Q,ne,re,Z,_,P,O){super(K,Y,(0,h.joinPath)(x,".vscode-oss-dev","extensions","control.json"),W,H,Q,ne,re,Z,_,P,O),this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const F=await this.fileService.readFile(g.URI.file(y.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(ee[270],te([0,1,5,40,39,25,80,16,34,8]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let v=class extends M.AbstractExtensionsProfileScannerService{constructor(y,h,E,S,s,g){super(u.URI.file(y.extensionsPath),h,E,S,s,g)}};v=we([X(0,f.INativeEnvironmentService),X(1,k.IFileService),X(2,A.IUserDataProfilesService),X(3,r.IUriIdentityService),X(4,L.ITelemetryService),X(5,I.ILogService)],v),e.ExtensionsProfileScannerService=v}),define(ee[271],te([0,1,8,34,80,125,16,6,5,21,39,40]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends L.NativeExtensionsScannerService{constructor(E,S,s,g,d,b,w,D){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,E.defaultProfile,E,S,s,g,d,b,w,D)}};y=we([X(0,p.IUserDataProfilesService),X(1,r.IExtensionsProfileScannerService),X(2,M.IFileService),X(3,f.ILogService),X(4,A.INativeEnvironmentService),X(5,u.IProductService),X(6,v.IUriIdentityService),X(7,k.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ee[272],te([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends A.Disposable{constructor(s,g,d){super(),this.environmentService=s,this.logService=d,this.validRoots=k.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(s.appRoot),this.addValidFileRoot(s.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(s.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:s}=I.session;s.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,d)=>this.handleResourceRequest(g,d)),s.protocol.interceptFileProtocol(r.Schemas.file,(g,d)=>this.handleFileRequest(g,d)),this._register((0,A.toDisposable)(()=>{s.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),s.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(s){const g=(0,L.normalize)(s);return this.validRoots.get(g)?A.Disposable.None:(this.validRoots.set(g,!0),(0,A.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(s,g){const d=f.URI.parse(s.url);return this.logService.error(`Refused to load resource ${d.fsPath} from ${r.Schemas.file}: protocol (original URL: ${s.url})`),g({error:-3})}handleResourceRequest(s,g){const d=this.requestToNormalizedFilePath(s);let b;return this.environmentService.crossOriginIsolated&&((0,L.basename)(d)==="workbench.html"||(0,L.basename)(d)==="workbench-dev.html"?b=r.COI.CoopAndCoep:b=r.COI.getHeadersFromQuery(s.url)),this.validRoots.findSubstr(d)?g({path:d,headers:b}):this.validExtensions.has((0,L.extname)(d).toLowerCase())?g({path:d}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${s.url})`),g({error:-3}))}requestToNormalizedFilePath(s){const g=f.URI.parse(s.url),d=r.FileAccess.uriToFileUri(g);return(0,L.normalize)(d.fsPath)}createIPCObjectUrl(){let s;const g=f.URI.from({scheme:"vscode",path:(0,u.generateUuid)()}),d=g.toString(),b=async()=>s;return v.validatedIpcMain.handle(d,b),this.logService.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:g,update:w=>s=w,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${d}.`),v.validatedIpcMain.removeHandler(d)}}}};E=we([X(0,p.INativeEnvironmentService),X(1,h.IUserDataProfilesService),X(2,y.ILogService)],E),e.ProtocolMainService=E}),define(ee[273],te([0,1,15,42,7,3,2,14,11,106,28,20,5,66,67,69,44,40,38,65,70,19,48,72,110]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let n=class extends M.Disposable{constructor(c,o,m,C,R,T,U,$,q,ie,oe){super(),this.machineId=c,this.userEnv=o,this.environmentMainService=m,this.userDataProfilesService=C,this.lifecycleMainService=R,this.logService=T,this.loggerMainService=U,this.policyService=$,this.themeMainService=q,this.protocolMainService=ie,this.configurationService=oe,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this.firstWindowConnectionBarrier=new r.Barrier,this.window=void 0,this.windowCloseListener=void 0,this.utilityProcess=void 0,this.useUtilityProcess=(()=>{let ae=!1;if(l.canUseUtilityProcess){const he=this.configurationService.getValue("window.experimental.sharedProcessUseUtilityProcess");typeof he=="boolean"?ae=he:ae=typeof h.default.quality=="string"}return ae})(),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners(),this.useUtilityProcess&&this.logService.info("[SharedProcess] using utility process")}registerListeners(){A.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,o)=>this.onWindowConnection(c,o)),A.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,o)=>this.onWorkerConnection(c,o)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,o){this.logService.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const m=await this.connect();if(c.sender.isDestroyed())return m.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[m])}onWorkerConnection(c,o){this.logService.trace("[SharedProcess] onWorkerConnection",o);const m=new M.DisposableStore,C=T=>{!this.isWindowAlive()||(this.logService.trace(`[SharedProcess] disposing worker (reason: '${T}')`,o),m.dispose(),this.sendToWindow("vscode:electron-main->shared-process=disposeWorker",o))},R=I.BrowserWindow.fromId(o.reply.windowId);if(!R||R.isDestroyed()||R.webContents.isDestroyed()||!o.reply.channel){C("unavailable");return}m.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,T=>T.window.win===R)(()=>C("load"))),m.add(L.Event.fromNodeEventEmitter(R,"closed")(()=>C("closed"))),R.webContents.postMessage(o.reply.channel,o.reply.nonce,c.ports)}onWillShutdown(){if(this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess)this.utilityProcess.postMessage("vscode:electron-main->shared-process=exit"),this.utilityProcess=void 0;else{const c=this.window;if(!c)return;this.sendToWindow("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{this.logService.trace("[SharedProcess] onWillShutdown window.close()"),c.close()}catch(o){this.logService.trace(`[SharedProcess] onWillShutdown window.close() error: ${o}`)}this.window=void 0},0)}}sendToWindow(c,...o){if(!this.isWindowAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process that is destroyed`);return}try{this.window?.webContents.send(c,...o)}catch(m){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,s.toErrorMessage)(m)}`)}}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const c=new r.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=init-done",()=>c.complete()):A.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.spawn();const c=new r.DeferredPromise;this.utilityProcess?this.utilityProcess.once("vscode:shared-process->electron-main=ipc-ready",()=>c.complete()):A.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}spawn(){this.useUtilityProcess?this.createUtilityProcess():this.createWindow(),this.registerSharedProcessListeners()}createUtilityProcess(){this.utilityProcess=this._register(new w.UtilityProcess(this.logService,t.NullTelemetryService,this.lifecycleMainService));const c=(0,i.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let o;c.port&&(o=["--nolazy"],c.break?o.push(`--inspect-brk=${c.port}`):o.push(`--inspect=${c.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:o})}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new I.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),title:"shared-process",webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update(this.createSharedProcessConfiguration()),this.window.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0))}createSharedProcessConfiguration(){return{machineId:this.machineId,windowId:this.window?.id??-1,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),product:h.default,policiesData:this.policyService.serialize()}}registerSharedProcessListeners(){this.window?(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,o,m)=>this._onDidError.fire({type:3,details:{reason:m,exitCode:o}}))):this.utilityProcess&&this._register(this.utilityProcess.onCrash(c=>this._onDidError.fire({type:2,details:{reason:c.reason,exitCode:c.code}})))}async connect(){return await this.whenIpcReady,this.utilityProcess?this.utilityProcess.connect():(0,u.connect)((0,f.assertIsDefined)(this.window))}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}usingUtilityProcess(){return!!this.utilityProcess}isWindowAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};n=we([X(2,v.IEnvironmentMainService),X(3,g.IUserDataProfilesService),X(4,p.ILifecycleMainService),X(5,y.ILogService),X(6,b.ILoggerMainService),X(7,d.IPolicyService),X(8,S.IThemeMainService),X(9,E.IProtocolMainService),X(10,D.IConfigurationService)],n),e.SharedProcess=n}),define(ee[96],te([0,1,7,3,2,64,11,107,6,40]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var v;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var y;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function h(d){const b=d.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=h;class E extends r.Disposable{constructor(b={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super(),this.options=b,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,w){if(w===e.TARGET_KEY){switch(b){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:b})}else this._onDidChangeValue.fire({scope:b,key:w,target:this.getKeyTargets(b)[w]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,w,D){return this.getStorage(w)?.get(b,D)}getBoolean(b,w,D){return this.getStorage(w)?.getBoolean(b,D)}getNumber(b,w,D){return this.getStorage(w)?.getNumber(b,D)}store(b,w,D,t){if((0,M.isUndefinedOrNull)(w)){this.remove(b,D);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,D,t),this.getStorage(D)?.set(b,w)})}remove(b,w){this.withPausedEmitters(()=>{this.updateKeyTarget(b,w,void 0),this.getStorage(w)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,w){const D=[],t=this.getKeyTargets(b);for(const l of Object.keys(t))t[l]===w&&D.push(l);return D}updateKeyTarget(b,w,D){const t=this.getKeyTargets(w);typeof D=="number"?t[b]!==D&&(t[b]=D,this.getStorage(w)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.getStorage(w)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(b){switch(b){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(b){const w=this.getStorage(b);return w?h(w):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=v.NONE){this._onWillSaveState.fire({reason:b});const w=this.getStorage(-1),D=this.getStorage(0),t=this.getStorage(1);switch(b){case v.NONE:await I.Promises.settled([w?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await I.Promises.settled([w?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.getStorage(-1)?.items??new Map,w=this.getStorage(0)?.items??new Map,D=this.getStorage(1)?.items??new Map;return g(b,w,D,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(b,w){return this.emitWillSaveState(v.NONE),(0,u.isUserDataProfile)(b)?this.switchToProfile(b,w):this.switchToWorkspace(b,w)}canSwitchProfile(b,w){return!(b.id===w.id||S(w)&&S(b))}switchData(b,w,D,t){this.withPausedEmitters(()=>{if(t)for(const[l,i]of b)w.set(l,i);else{const l=new Set;for(const[i,n]of b)l.add(i),w.get(i)!==n&&this.emitDidChangeValue(D,i);for(const[i]of w.items)l.has(i)||this.emitDidChangeValue(D,i)}})}}E.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=E;function S(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class s extends E{constructor(){super(),this.applicationStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.profileStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),this._register(this.applicationStorage.onDidChangeStorage(b=>this.emitDidChangeValue(-1,b)))}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(b){return!1}}e.InMemoryStorageService=s;async function g(d,b,w,D,t,l){const i=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,a=new Map;d.forEach((U,$)=>{n.set($,U),a.set($,i(U))});const c=new Map,o=new Map;b.forEach((U,$)=>{c.set($,U),o.set($,i(U))});const m=new Map,C=new Map;w.forEach((U,$)=>{m.set($,U),C.set($,i(U))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const R=[];if(n.forEach((U,$)=>{R.push({key:$,value:U})}),console.table(R),console.groupEnd(),console.log(a),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const U=[];c.forEach(($,q)=>{U.push({key:q,value:$})}),console.table(U),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${l})`);const T=[];m.forEach((U,$)=>{T.push({key:$,value:U})}),console.table(T),console.groupEnd(),console.log(C)}e.logStorage=g}),define(ee[274],te([0,1,22,7,3,2,9,74,8,24,107,158,5,96,25,29]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class s extends L.Disposable{get storage(){return this._storage}constructor(l,i){super(),this.logService=l,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY}),this.initializePromise=void 0,this.whenInitPromise=new A.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const l=await this.doCreate();this._storage.dispose(),this._storage=l,this._register(l.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(l);const i=l.getBoolean(h.IS_NEW_KEY);i===void 0?l.set(h.IS_NEW_KEY,!0):i&&l.set(h.IS_NEW_KEY,!1)}catch(l){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?l=>this.logService.trace(l):void 0,logError:l=>this.logService.error(l)}}doInit(l){return l.init()}get items(){return this._storage.items}get(l,i){return this._storage.get(l,i)}set(l,i){return this._storage.set(l,i)}delete(l){return this._storage.delete(l)}async close(){const l=new k.StopWatch(!1);await this.doClose(),l.stop(),l.elapsed()>s.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(l),this._onDidCloseStorage.fire()}async logSlowClose(l){if(!!this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([a,c])=>({key:a,length:c.length})),(a,c)=>c.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}s.LOG_SLOW_CLOSE_THRESHOLD=2e3;class g extends s{get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,g.STORAGE_NAME)}constructor(l,i,n,a){super(n,a),this.profile=l,this.options=i}async doCreate(){return new v.Storage(new p.SQLiteStorageDatabase(this.path??p.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:v.StorageHint.STORAGE_IN_MEMORY})}}g.STORAGE_NAME="state.vscdb";class d extends g{constructor(l,i,n,a){super(l,i,n,a)}}e.ProfileStorageMain=d;class b extends g{constructor(l,i,n,a){super(i.defaultProfile,l,n,a)}async doInit(l){await super.doInit(l),this.updateTelemetryState(l)}updateTelemetryState(l){l.get(E.firstSessionDateStorageKey,void 0)===void 0&&l.set(E.firstSessionDateStorageKey,new Date().toUTCString());const n=l.get(E.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();l.set(E.lastSessionDateStorageKey,typeof n>"u"?null:n),l.set(E.currentSessionDateStorageKey,a)}}e.ApplicationStorageMain=b;class w extends s{get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,w.WORKSPACE_STORAGE_NAME)}constructor(l,i,n,a,c){super(n,c),this.workspace=l,this.options=i,this.environmentService=a}async doCreate(){const{storageFilePath:l,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new p.SQLiteStorageDatabase(l,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?v.StorageHint.STORAGE_IN_MEMORY:i?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:p.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,M.join)(l,w.WORKSPACE_STORAGE_NAME);return await u.Promises.exists(l)?{storageFilePath:i,wasCreated:!1}:(await u.Promises.mkdir(l,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(l),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(l){let i;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,M.join)(l,w.WORKSPACE_META_NAME);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}w.WORKSPACE_STORAGE_NAME="state.vscdb",w.WORKSPACE_META_NAME="workspace.json",e.WorkspaceStorageMain=w;class D extends s{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(ee[275],te([0,1,3,2,96]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class L extends A.Disposable{constructor(k,f,u){super(),this.storageMainService=k,this.userDataProfilesService=f,this.logService=u;const v=this._register(new A.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onWillAddFirstListener:()=>v.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new A.DisposableStore;return k.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.onDidChangeApplicationStorage(f))),k.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let v=f.get(u.profile.id);return v||f.set(u.profile.id,v={profile:u.profile,keys:[],storage:u.storage}),v.keys.push(u.key),f},100)(f=>this.onDidChangeProfileStorage(f))),k}onDidChangeApplicationStorage(k){const f=k.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],u=[];if(k=k.filter(v=>v!==r.TARGET_KEY),k.length){const v=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);u.push({profile:this.userDataProfilesService.defaultProfile,changes:k.map(p=>({key:p,scope:0,target:v[p]}))})}this.triggerEvents(f,u)}onDidChangeProfileStorage(k){const f=[],u=new Map;for(const[v,p]of k.entries()){p.keys.includes(r.TARGET_KEY)&&f.push(p.profile);const y=p.keys.filter(h=>h!==r.TARGET_KEY);if(y.length){const h=(0,r.loadKeyTargets)(p.storage.storage);u.set(v,{profile:p.profile,changes:y.map(E=>({key:E,scope:0,target:h[E]}))})}}this.triggerEvents(f,[...u.values()])}triggerEvents(k,f){(k.length||f.length)&&this._onDidChange.fire({valueChanges:f,targetChanges:k})}listen(k,f,u){switch(f){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${f}`)}async call(k,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=L}),define(ee[276],te([0,1,8,34,16,5,33,39,40,11,118]),function(j,e,I,A,r,L,M,k,f,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let p=class ft extends f.UserDataProfilesService{constructor(S,s,g,d,b){super(g,d,s,b),this.stateReadonlyService=S,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(ft.PROFILES_KEY,[]).map(s=>({...s,location:(0,u.isString)(s.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,s.location):I.URI.revive(s.location)}))}getStoredProfileAssociations(){const S=this.stateReadonlyService.getItem(ft.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(ft.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?S:this.migrateStoredProfileAssociations(S)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration",p=we([X(0,M.IStateReadService),X(1,k.IUriIdentityService),X(2,A.INativeEnvironmentService),X(3,r.IFileService),X(4,L.ILogService)],p),e.UserDataProfilesReadonlyService=p;let y=class rt extends p{constructor(S,s,g,d,b){super(S,s,g,d,b),this.stateService=S}saveStoredProfiles(S){S.length?this.stateService.setItem(rt.PROFILES_KEY,S.map(s=>({...s,location:this.uriIdentityService.extUri.basename(s.location)}))):this.stateService.removeItem(rt.PROFILES_KEY)}getStoredProfiles(){const S=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(S),this.stateService.setItem("userDataProfilesMigration",!0)),S}saveStoredProfileAssociations(S){S.emptyWindows||S.workspaces?this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,S):this.stateService.removeItem(rt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const S="workspaceAndProfileInfo",s=this.stateService.getItem(S,void 0);if(s){this.stateService.removeItem(S);const d=s.reduce((b,{workspace:w,profile:D})=>(b[I.URI.revive(w).toString()]=I.URI.revive(D).toString(),b),{});this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_KEY,{workspaces:d})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(rt.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};y=we([X(0,M.IStateService),X(1,k.IUriIdentityService),X(2,A.INativeEnvironmentService),X(3,r.IFileService),X(4,L.ILogService)],y),e.UserDataProfilesService=y;let h=class extends y{constructor(S,s,g,d){super(new v.StateService(0,s,d,g),S,s,g,d)}async init(){return await this.stateService.init(),super.init()}};h=we([X(0,k.IUriIdentityService),X(1,A.INativeEnvironmentService),X(2,r.IFileService),X(3,L.ILogService)],h),e.ServerUserDataProfilesService=h}),define(ee[53],te([0,1,34,16,6,5,39,40,276,33]),function(j,e,I,A,r,L,M,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(k.IUserDataProfilesService);let v=class extends f.UserDataProfilesService{constructor(y,h,E,S,s){super(y,h,E,S,s)}getAssociatedEmptyWindows(){const y=[];for(const h of this.profilesObject.emptyWindows.keys())y.push({id:h});return y}};v=we([X(0,u.IStateService),X(1,M.IUriIdentityService),X(2,I.INativeEnvironmentService),X(3,A.IFileService),X(4,L.ILogService)],v),e.UserDataProfilesMainService=v}),define(ee[97],te([0,1,8,50,3,2,34,16,6,20,5,96,274,40,53,39]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let s=class extends L.Disposable{constructor(b,w,D,t,l,i){super(),this.logService=b,this.environmentService=w,this.userDataProfilesService=D,this.lifecycleMainService=t,this.fileService=l,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new r.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,w]of this.mapProfileToStorage)b.join("profileStorage",w.close());for(const[,w]of this.mapWorkspaceToStorage)b.join("workspaceStorage",w.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const w=this.mapProfileToStorage.get(b.profile.id);w&&b.join(w.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new y.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,A.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,p.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let w=this.mapProfileToStorage.get(b.id);if(!w){this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),w=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,w);const D=this._register(w.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:w,profile:b})));(0,A.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id),D.dispose()})}return w}createProfileStorage(b){return this.shutdownReason===2?new y.InMemoryStorageMain(this.logService,this.fileService):new y.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let w=this.mapWorkspaceToStorage.get(b.id);return w||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),w=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,w),(0,A.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),w}createWorkspaceStorage(b){return this.shutdownReason===2?new y.InMemoryStorageMain(this.logService,this.fileService):new y.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(b){const w=I.URI.file(b);for(const D of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!D.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(D.path),w))return!0;return!1}};s=we([X(0,v.ILogService),X(1,M.IEnvironmentService),X(2,E.IUserDataProfilesMainService),X(3,u.ILifecycleMainService),X(4,k.IFileService),X(5,S.IUriIdentityService)],s),e.StorageMainService=s,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let g=class extends p.AbstractStorageService{constructor(b,w){super(),this.userDataProfilesService=b,this.storageMainService=w,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};g=we([X(0,h.IUserDataProfilesService),X(1,e.IStorageMainService)],g),e.ApplicationStorageMainService=g}),define(ee[277],te([0,1,2,20,53,29,7,30]),function(j,e,I,A,r,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends I.Disposable{constructor(v,p,y){super(),this.userDataProfilesService=p,this.windowsMainService=y,this._register(v.onWillLoadWindow(h=>{h.reason===2&&this.unsetProfileForWorkspace(h.window)})),this._register(v.onBeforeCloseWindow(h=>this.unsetProfileForWorkspace(h))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(v){const p=this.getWorkspace(v),y=this.userDataProfilesService.getProfileForWorkspace(p);y?.isTransient&&(this.userDataProfilesService.unsetWorkspace(p,y.isTransient),y.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(v){return v.openedWorkspace??(0,L.toWorkspaceIdentifier)(v.backupPath,v.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const v=this.userDataProfilesService.getAssociatedEmptyWindows();if(v.length===0)return;const p=this.windowsMainService.getWindows().map(y=>this.getWorkspace(y));for(const y of v)p.some(h=>h.id===y.id)||this.userDataProfilesService.unsetWorkspace(y,!1)}};f=we([X(0,A.ILifecycleMainService),X(1,r.IUserDataProfilesMainService),X(2,k.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[126],te([0,1,18,8,29]),function(j,e,I,A,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function L(f,u,v){for(const y of f){const h=y.openedWorkspace;if((0,r.isWorkspaceIdentifier)(h)){const E=await v(h);if(E){if(E.folders.some(S=>I.extUriBiasedIgnorePathCase.isEqualOrParent(u,S.uri)))return y}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(u,h.configPath))return y}}const p=f.filter(y=>(0,r.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(u,y.openedWorkspace.uri));if(p.length)return p.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function M(f,u){for(const v of f)if((0,r.isWorkspaceIdentifier)(v.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,u)||(0,r.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,u))return v}e.findWindowOnWorkspaceOrFolder=M;function k(f,u){const v=p=>u.some(y=>I.extUriBiasedIgnorePathCase.isEqual(A.URI.file(y),A.URI.file(p)));for(const p of f)if(p.config?.extensionDevelopmentPath?.some(y=>v(y)))return p}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[278],te([0,1,15,2,4,18,8,19,20,5,33,30,124,29]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let E=class wt extends A.Disposable{get state(){return this._state}constructor(w,D,t,l,i){super(),this.windowsMainService=w,this.stateService=D,this.lifecycleMainService=t,this.logService=l,this.configurationService=i,this._state=S(this.stateService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(w=>this.onBeforeCloseWindow(w)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(w=>{w.newCount-w.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(w=>this.onBeforeCloseWindow(w))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const w=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!D.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.toWindowState(i),D.lastActiveWindow.uiState.mode===3&&w.add(D.lastActiveWindow.uiState.display))}const t=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.toWindowState(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(w.has(D.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):w.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(D.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(w.has(n.uiState.display)?r.isMacintosh&&n.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):w.add(n.uiState.display)),n}));const l=g(D);this.stateService.setItem(wt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(w){if(this.lifecycleMainService.quitRequested)return;const D=this.toWindowState(w);w.isExtensionDevelopmentHost&&!w.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=D:!w.isExtensionDevelopmentHost&&w.openedWorkspace&&this._state.openedWindows.forEach(t=>{const l=(0,h.isWorkspaceIdentifier)(w.openedWorkspace)&&t.workspace?.id===w.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&t.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(t.folderUri,w.openedWorkspace.uri);(l||i)&&(t.uiState=D.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=D)}toWindowState(w){return{windowId:w.id,workspace:(0,h.isWorkspaceIdentifier)(w.openedWorkspace)?w.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)?w.openedWorkspace.uri:void 0,backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.serializeWindowState()}}getNewWindowState(w){const D=this.doGetNewWindowState(w),t=this.configurationService.getValue("window");if(D.mode===3){let l;D.hasDefaultState?l=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):l=!!(this.lifecycleMainService.wasRestarted||t?.restoreFullscreen),l||(D.mode=1)}return D}doGetNewWindowState(w){const D=this.windowsMainService.getLastActiveWindow();if(!w.extensionTestsPath){if(!!w.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=w.workspace;if((0,h.isWorkspaceIdentifier)(c)){const m=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===c.id).map(C=>C.uiState);if(m.length)return m[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const m=this.state.openedWindows.filter(C=>C.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(C.folderUri,c.uri)).map(C=>C.uiState);if(m.length)return m[0]}else if(w.backupPath){const m=this.state.openedWindows.filter(C=>C.backupPath===w.backupPath).map(C=>C.uiState);if(m.length)return m[0]}const o=this.lastClosedState||this.state.lastActiveWindow;if(!D&&o)return o.uiState}let t;const l=I.screen.getAllDisplays();if(l.length===1)t=l[0];else{if(r.isMacintosh){const c=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(c)}!t&&D&&(t=I.screen.getDisplayMatching(D.getBounds())),t||(t=I.screen.getPrimaryDisplay()||l[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&D){const c=D.serializeWindowState();c.mode===3?i.mode=3:i=c,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(w){if(this.windowsMainService.getWindows().length===0)return w;w.x=typeof w.x=="number"?w.x:0,w.y=typeof w.y=="number"?w.y:0;const D=this.windowsMainService.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===w.x||t.y===w.y);)w.x+=30,w.y+=30;return w}};E.windowsStateStorageKey="windowsState",E=we([X(0,p.IWindowsMainService),X(1,v.IStateService),X(2,f.ILifecycleMainService),X(3,u.ILogService),X(4,k.IConfigurationService)],E),e.WindowsStateHandler=E;function S(b){const w={openedWindows:[]},D=b||{openedWindows:[]};return D.lastActiveWindow&&(w.lastActiveWindow=s(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(w.lastPluginDevelopmentHostWindow=s(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(w.openedWindows=D.openedWindows.map(t=>s(t))),w}e.restoreWindowsState=S;function s(b){const w={uiState:b.uiState};return b.backupPath&&(w.backupPath=b.backupPath),b.remoteAuthority&&(w.remoteAuthority=b.remoteAuthority),b.folder&&(w.folderUri=M.URI.parse(b.folder)),b.workspaceIdentifier&&(w.workspace={id:b.workspaceIdentifier.id,configPath:M.URI.parse(b.workspaceIdentifier.configURIPath)}),w}function g(b){return{lastActiveWindow:b.lastActiveWindow&&d(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&d(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(w=>d(w))}}e.getWindowsStateStoreData=g;function d(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(ee[98],te([0,1,32,43,131,45,14,9,4,18,8,6,57,29]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function E(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function S(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=S;function s(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=s;function g(C){return d(C)||b(C)}e.isStoredWorkspaceFolder=g;function d(C){const R=C;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function b(C){const R=C;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function w(C,R,T,U,$){if(C.scheme!==U.scheme)return{name:T,uri:C.toString(!0)};let q=R?void 0:$.relativePath(U,C);if(q!==void 0)q.length===0?q=".":f.isWindows&&(q=D(q));else if(C.scheme===M.Schemas.file)q=C.fsPath,f.isWindows&&(q=D(q));else if($.isEqualAuthority(C.authority,U.authority))q=C.path;else return{name:T,uri:C.toString(!0)};return{name:T,path:q}}e.getStoredWorkspaceFolder=w;function D(C){return C=(0,L.normalizeDriveLetter)(C),(0,I.isUNC)(C)||(C=(0,I.toSlashes)(C)),C}function t(C,R,T){const U=[],$=new Set,q=T.dirname(R);for(const ie of C){let oe;if(d(ie))ie.path&&(oe=T.resolvePath(q,ie.path));else if(b(ie))try{oe=v.URI.parse(ie.uri),oe.path[0]!==k.posix.sep&&(oe=oe.with({path:k.posix.sep+oe.path}))}catch(ae){console.warn(ae)}if(oe){const ae=T.getComparisonKey(oe);if(!$.has(ae)){$.add(ae);const he=ie.name||T.basenameOrAuthority(oe);U.push(new h.WorkspaceFolder({uri:oe,name:he,index:U.length},ie))}}}return U}e.toWorkspaceFolders=t;function l(C,R,T,U,$){const q=i(R,C),ie=$.dirname(R),oe=$.dirname(U),ae=[];for(const Y of q.folders){const x=d(Y)?$.resolvePath(ie,Y.path):v.URI.parse(Y.uri);let W;T?W=!1:W=!d(Y)||(0,k.isAbsolute)(Y.path),ae.push(w(x,W,Y.name,oe,$))}const he={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ce=r.setProperty(C,["folders"],ae,he);let K=r.applyEdits(C,ce);return(0,u.isEqualAuthority)(q.remoteAuthority,(0,y.getRemoteAuthority)(U))&&(K=r.applyEdits(K,r.removeProperty(K,["remoteAuthority"],he))),K}e.rewriteWorkspaceFileForNewLocation=l;function i(C,R){const T=A.parse(R);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(U=>g(U));else throw new Error(`${C} looks like an invalid workspace file.`);return T}function n(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function a(C){return typeof C.folderUri=="string"}function c(C){return typeof C.fileUri=="string"}function o(C,R){const T={workspaces:[],files:[]};if(C){const U=function(q,ie){for(let oe=0;oe<q.length;oe++)try{ie(q[oe],oe)}catch(ae){R.warn(`Error restoring recent entry ${JSON.stringify(q[oe])}: ${ae.toString()}. Skip entry.`)}},$=C;Array.isArray($.entries)&&U($.entries,q=>{const ie=q.label,oe=q.remoteAuthority;n(q)?T.workspaces.push({label:ie,remoteAuthority:oe,workspace:{id:q.workspace.id,configPath:v.URI.parse(q.workspace.configPath)}}):a(q)?T.workspaces.push({label:ie,remoteAuthority:oe,folderUri:v.URI.parse(q.folderUri)}):c(q)&&T.files.push({label:ie,remoteAuthority:oe,fileUri:v.URI.parse(q.fileUri)})})}return T}e.restoreRecentlyOpened=o;function m(C){const R={entries:[]};for(const T of C.workspaces)S(T)?R.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):R.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of C.files)R.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return R}e.toStoreData=m}),define(ee[99],te([0,1,83,14,4,18]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(u){function v(){let p=u.scheme===A.Schemas.file?(0,L.originalFSPath)(u):u.toString();return r.isLinux||(p=p.toLowerCase()),(0,I.createHash)("md5").update(p).digest("hex")}return{id:v(),configPath:u}}e.getWorkspaceIdentifier=M;function k(u,v){function p(){if(u.scheme!==A.Schemas.file)return(0,I.createHash)("md5").update(u.toString()).digest("hex");if(!v)return;let h;return r.isLinux?h=v.ino:r.isMacintosh?h=v.birthtime.getTime():r.isWindows&&(typeof v.birthtimeMs=="number"?h=Math.floor(v.birthtimeMs):h=v.birthtime.getTime()),(0,I.createHash)("md5").update(u.fsPath).update(h?String(h):"").digest("hex")}const y=p();if(typeof y=="string")return{id:y,uri:u}}e.getSingleFolderWorkspaceIdentifier=k;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[279],te([0,1,83,32,14,9,4,18,24,191,19,28,33,16,5,190,29,99]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let d=class St{constructor(w,D,t,l){this.environmentMainService=w,this.configurationService=D,this.logService=t,this.stateService=l,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=k.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,A.isEqual)(i,n,!M.isLinux)}}async initialize(){const w=this.stateService.getItem(St.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(w.emptyWindows),this.workspaces=await this.validateWorkspaces((0,u.deserializeWorkspaceInfos)(w)),this.folders=await this.validateFolders((0,u.deserializeFolderInfos)(w)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(w,D){this.workspaces.some(l=>w.workspace.id===l.workspace.id)||(this.workspaces.push(w),this.storeWorkspacesMetadata());const t=(0,L.join)(this.backupHome,w.workspace.id);return D?this.moveBackupFolder(t,D).then(()=>t):t}async moveBackupFolder(w,D){if(await f.Promises.exists(w)&&await this.convertToEmptyWindowBackup(w),await f.Promises.exists(D))try{await f.Promises.rename(D,w)}catch(t){this.logService.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(w){return this.folders.some(D=>this.backupUriComparer.isEqual(w.folderUri,D.folderUri))||(this.folders.push(w),this.storeWorkspacesMetadata()),(0,L.join)(this.backupHome,this.getFolderHash(w))}registerEmptyWindowBackup(w){return this.emptyWindows.some(D=>!!D.backupFolder&&this.backupPathComparer.isEqual(D.backupFolder,w.backupFolder))||(this.emptyWindows.push(w),this.storeWorkspacesMetadata()),(0,L.join)(this.backupHome,w.backupFolder)}async validateWorkspaces(w){if(!Array.isArray(w))return[];const D=new Set,t=[];for(const l of w){const i=l.workspace;if(!(0,s.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const n=(0,L.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(l):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return t}async validateFolders(w){if(!Array.isArray(w))return[];const D=[],t=new Set;for(const l of w){const i=l.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!t.has(n)){t.add(n);const a=(0,L.join)(this.backupHome,this.getFolderHash(l));await this.doHasBackups(a)?i.scheme!==r.Schemas.file||await f.Promises.exists(i.fsPath)?D.push(l):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return D}async validateEmptyWorkspaces(w){if(!Array.isArray(w))return[];const D=[],t=new Set;for(const l of w){const i=l.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,L.join)(this.backupHome,i);await this.doHasBackups(n)?D.push(l):await this.deleteStaleBackup(n)}}return D}async deleteStaleBackup(w){try{await f.Promises.rm(w,f.RimRafMode.MOVE)}catch(D){this.logService.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}prepareNewEmptyWindowBackup(){let w=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(D=>!!D.backupFolder&&this.backupPathComparer.isEqual(D.backupFolder,w.id));)w=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:w.id}}async convertToEmptyWindowBackup(w){const D=this.prepareNewEmptyWindowBackup(),t=(0,L.join)(this.backupHome,D.backupFolder);try{await f.Promises.rename(w,t)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push(D),!0}async getDirtyWorkspaces(){const w=[];for(const D of this.workspaces)await this.hasBackups(D)&&w.push(D);for(const D of this.folders)await this.hasBackups(D)&&w.push(D);return w}hasBackups(w){let D;return(0,u.isEmptyWindowBackupInfo)(w)?D=(0,L.join)(this.backupHome,w.backupFolder):(0,S.isFolderBackupInfo)(w)?D=(0,L.join)(this.backupHome,this.getFolderHash(w)):D=(0,L.join)(this.backupHome,w.workspace.id),this.doHasBackups(D)}async doHasBackups(w){try{const D=await f.Promises.readdir(w);for(const t of D)try{if((await f.Promises.readdir((0,L.join)(w,t))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const w={workspaces:this.workspaces.map(({workspace:D,remoteAuthority:t})=>{const l={id:D.id,configURIPath:D.configPath.toString()};return t&&(l.remoteAuthority=t),l}),folders:this.folders.map(({folderUri:D,remoteAuthority:t})=>{const l={folderUri:D.toString()};return t&&(l.remoteAuthority=t),l}),emptyWindows:this.emptyWindows.map(({backupFolder:D,remoteAuthority:t})=>{const l={backupFolder:D};return t&&(l.remoteAuthority=t),l})};this.stateService.setItem(St.backupWorkspacesMetadataStorageKey,w)}getFolderHash(w){const D=w.folderUri;let t;return D.scheme===r.Schemas.file?t=M.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};d.backupWorkspacesMetadataStorageKey="backupWorkspaces",d=we([X(0,p.IEnvironmentMainService),X(1,v.IConfigurationService),X(2,E.ILogService),X(3,y.IStateService)],d),e.BackupMainService=d}),define(ee[54],te([0,1,15,3,43,2,14,9,18,11,24,189,63,58,28,6,5,53,126,29,98,99]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,S.createDecorator)("workspacesManagementMainService");let t=class extends L.Disposable{constructor(i,n,a,c,o){super(),this.environmentMainService=i,this.logService=n,this.userDataProfilesMainService=a,this.backupMainService=c,this.dialogMainService=o,this._onDidDeleteUntitledWorkspace=this._register(new A.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new A.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const i=(await v.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(n=>(0,f.joinPath)(this.untitledWorkspacesHome,n,b.UNTITLED_WORKSPACE_NAME));for(const n of i){const a=(0,D.getWorkspaceIdentifier)(n),c=await this.resolveLocalWorkspace(n);c?this.untitledWorkspaces.push({workspace:a,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(i){i.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${i}).`)}}resolveLocalWorkspace(i){return this.doResolveLocalWorkspace(i,n=>v.Promises.readFile(n,"utf8"))}doResolveLocalWorkspace(i,n){if(!!this.isWorkspacePath(i)&&i.scheme===M.Schemas.file)try{const a=n(i.fsPath);return a instanceof Promise?a.then(c=>this.doResolveWorkspace(i,c),c=>{}):this.doResolveWorkspace(i,a)}catch{return}}isWorkspacePath(i){return(0,b.isUntitledWorkspace)(i,this.environmentMainService)||(0,b.hasWorkspaceFileExtension)(i)}doResolveWorkspace(i,n){try{const a=this.doParseStoredWorkspace(i,n),c=(0,D.getWorkspaceIdentifier)(i);return{id:c.id,configPath:c.configPath,folders:(0,w.toWorkspaceFolders)(a.folders,c.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(i,n){const a=(0,r.parse)(n);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(c=>(0,w.isStoredWorkspaceFolder)(c));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(i,n){const{workspace:a,storedWorkspace:c}=this.newUntitledWorkspace(i,n),o=a.configPath.fsPath;return await v.Promises.mkdir((0,k.dirname)(o),{recursive:!0}),await v.Promises.writeFile(o,JSON.stringify(c,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:n}),a}newUntitledWorkspace(i=[],n){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,f.joinPath)(this.untitledWorkspacesHome,a),o=(0,f.joinPath)(c,b.UNTITLED_WORKSPACE_NAME),m=[];for(const C of i)m.push((0,w.getStoredWorkspaceFolder)(C.uri,!0,C.name,c,f.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(o),storedWorkspace:{folders:m,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,b.isUntitledWorkspace)(i.configPath,this.environmentMainService)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.doDeleteUntitledWorkspace(i),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(i),this._onDidDeleteUntitledWorkspace.fire(i))}async doDeleteUntitledWorkspace(i){const n=(0,f.originalFSPath)(i.configPath);try{await v.Promises.rm((0,k.dirname)(n));const a=(0,k.join)(this.environmentMainService.workspaceStorageHome.fsPath,i.id);await v.Promises.exists(a)&&await v.Promises.writeFile((0,k.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(c=>c.workspace.id!==i.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${n} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(i,n,a){if(!i||!i.win||!i.isReady||!await this.isValidTargetWorkspacePath(i,n,a))return;const o=await this.doEnterWorkspace(i,(0,D.getWorkspaceIdentifier)(a));if(!!o)return this._onDidEnterWorkspace.fire({window:i,workspace:o.workspace}),o}async isValidTargetWorkspacePath(i,n,a){return a?(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,a)?!1:(0,d.findWindowOnWorkspaceOrFolder)(n,a)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,f.basename)(a)),detail:(0,p.localize)(2,null)},(0,u.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1):!0:!0}async doEnterWorkspace(i,n){if(!i.config)return;i.focus();let a;return i.config.extensionDevelopmentPath||(i.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=a,{workspace:n,backupPath:a}}};t=we([X(0,E.IEnvironmentMainService),X(1,s.ILogService),X(2,g.IUserDataProfilesMainService),X(3,y.IBackupMainService),X(4,h.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(ee[127],te([0,1,15,42,23,6,30,29,54,11,5,70]),function(j,e,I,A,r,L,M,k,f,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let y=class{constructor(E,S,s){this.windowsMainService=E,this.workspacesManagementMainService=S,this.logService=s}async getRemoteDiagnostics(E){const S=this.windowsMainService.getWindows();return(await Promise.all(S.map(async g=>{const d=g.remoteAuthority;if(!d)return;const b=`vscode:getDiagnosticInfoResponse${g.id}`,w={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(D=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:b,args:w}),A.validatedIpcMain.once(b,(t,l)=>{l||D({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),D(l)}),setTimeout(()=>{D({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const E=[];for(const s of I.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(s.id);g?E.push(await this.codeWindowToInfo(g)):E.push(this.browserWindowToInfo(s))}const S=[];for(const{pid:s,name:g}of p.UtilityProcess.getAll())S.push({pid:s,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:E,pidToNames:S,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(E){const S=await this.getFolderURIs(E),s=(0,u.assertIsDefined)(E.win);return this.browserWindowToInfo(s,S,E.remoteAuthority)}browserWindowToInfo(E,S=[],s){return{id:E.id,pid:E.webContents.getOSProcessId(),title:E.getTitle(),folderURIs:S,remoteAuthority:s}}async getFolderURIs(E){const S=[],s=E.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(s))S.push(s.uri);else if((0,k.isWorkspaceIdentifier)(s)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(s.configPath);g&&g.folders.forEach(b=>{S.push(b.uri)})}return S}};y=we([X(0,M.IWindowsMainService),X(1,f.IWorkspacesManagementMainService),X(2,v.ILogService)],y),e.DiagnosticsMainService=y}),define(ee[59],te([0,1,46,15,27,152,55,3,2,14,9,4,8,103,86,24,101,179,58,28,6,20,5,21,69,30,29,54,17,237,230,33]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,w.createDecorator)("nativeHostMainService");let T=class extends f.Disposable{constructor($,q,ie,oe,ae,he,ce,K,Y,x){super(),this.sharedProcess=$,this.windowsMainService=q,this.dialogMainService=ie,this.lifecycleMainService=oe,this.environmentMainService=ae,this.logService=he,this.productService=ce,this.themeMainService=K,this.stateService=Y,this.workspacesManagementMainService=x,this.onDidOpenWindow=k.Event.map(this.windowsMainService.onDidOpenWindow,W=>W.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:W,x:H,y:Q})=>({windowId:W.id,x:H,y:Q})),({windowId:W})=>!!this.windowsMainService.getWindowById(W)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(W,H)=>H.id),W=>!!this.windowsMainService.getWindowById(W)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(W,H)=>H.id),W=>!!this.windowsMainService.getWindowById(W)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(W,H)=>H.id),W=>!!this.windowsMainService.getWindowById(W)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),W=>!!W),W=>W.id),k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(W,H)=>H.id),W=>!!this.windowsMainService.getWindowById(W))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new k.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(W,H,Q)=>Q),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),k.Event.fromNodeEventEmitter(A.screen,"display-added"),k.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(q=>({id:q.id,workspace:q.openedWorkspace??(0,a.toWorkspaceIdentifier)(q.backupPath,q.isExtensionDevelopmentHost),title:q.win?.getTitle()??"",filename:q.getRepresentedFilename(),dirty:q.isDocumentEdited()}))}async getWindowCount($){return this.windowsMainService.getWindowCount()}async getActiveWindowId($){const q=A.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(q)return q.id}openWindow($,q,ie){return Array.isArray(q)?this.doOpenWindow($,q,ie):this.doOpenEmptyWindow($,q)}async doOpenWindow($,q,ie=Object.create(null)){q.length>0&&await this.windowsMainService.open({context:5,contextWindowId:$,urisToOpen:q,cli:this.environmentMainService.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async doOpenEmptyWindow($,q){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:$},q)}async toggleFullScreen($){this.windowById($)?.toggleFullScreen()}async handleTitleDoubleClick($){this.windowById($)?.handleTitleDoubleClick()}async isMaximized($){const q=this.windowById($);return q?.win?q.win.isMaximized():!1}async maximizeWindow($){const q=this.windowById($);q?.win&&q.win.maximize()}async unmaximizeWindow($){const q=this.windowById($);q?.win&&q.win.unmaximize()}async minimizeWindow($){const q=this.windowById($);q?.win&&q.win.minimize()}async updateWindowControls($,q){const ie=this.windowById($);ie&&ie.updateWindowControls(q)}async focusWindow($,q){q&&typeof q.windowId=="number"&&($=q.windowId),this.windowById($)?.focus({force:q?.force??!1})}async setMinimumSize($,q,ie){const oe=this.windowById($);if(oe?.win){const[ae,he]=oe.win.getSize(),[ce,K]=oe.win.getMinimumSize(),[Y,x]=[q??ce,ie??K],[W,H]=[Math.max(ae,Y),Math.max(he,x)];(ce!==Y||K!==x)&&oe.win.setMinimumSize(Y,x),(ae!==W||he!==H)&&oe.win.setSize(W,H)}}async saveWindowSplash($,q){this.themeMainService.saveWindowSplash($,q)}async installShellCommand($){const{source:q,target:ie}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await S.SymlinkSupport.stat(q);if(oe&&!oe.dangling){const ae=await(0,h.realpath)(q);if(ie===ae)return}await S.Promises.unlink(q)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await S.Promises.symlink(ie,q)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ae}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ae===0)try{const he=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${q}'\\" with administrator privileges"`;await(0,L.promisify)(I.exec)(he)}catch{throw new Error((0,g.localize)(3,null,q))}}}async uninstallShellCommand($){const{source:q}=await this.getShellCommandLink();try{await S.Promises.unlink(q)}catch(ie){switch(ie.code){case"EACCES":{const{response:oe}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(oe===0)try{const ae=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,L.promisify)(I.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,q))}break}case"ENOENT":break;default:throw ie}}}async getShellCommandLink(){const $=(0,v.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),q=`/usr/local/bin/${this.productService.applicationName}`;if(!await S.Promises.exists($))throw new Error((0,g.localize)(8,null,$));return{source:q,target:$}}async showMessageBox($,q){return this.dialogMainService.showMessageBox(q,this.toBrowserWindow($))}async showSaveDialog($,q){return this.dialogMainService.showSaveDialog(q,this.toBrowserWindow($))}async showOpenDialog($,q){return this.dialogMainService.showOpenDialog(q,this.toBrowserWindow($))}toBrowserWindow($){const q=this.windowById($);if(q?.win)return q.win}async pickFileFolderAndOpen($,q){const ie=await this.dialogMainService.pickFileFolder(q);ie&&await this.doOpenPicked(await Promise.all(ie.map(async oe=>await S.SymlinkSupport.existsDirectory(oe)?{folderUri:y.URI.file(oe)}:{fileUri:y.URI.file(oe)})),q,$)}async pickFolderAndOpen($,q){const ie=await this.dialogMainService.pickFolder(q);ie&&await this.doOpenPicked(ie.map(oe=>({folderUri:y.URI.file(oe)})),q,$)}async pickFileAndOpen($,q){const ie=await this.dialogMainService.pickFile(q);ie&&await this.doOpenPicked(ie.map(oe=>({fileUri:y.URI.file(oe)})),q,$)}async pickWorkspaceAndOpen($,q){const ie=await this.dialogMainService.pickWorkspace(q);ie&&await this.doOpenPicked(ie.map(oe=>({workspaceUri:y.URI.file(oe)})),q,$)}async doOpenPicked($,q,ie){await this.windowsMainService.open({context:3,contextWindowId:ie,cli:this.environmentMainService.args,urisToOpen:$,forceNewWindow:q.forceNewWindow})}async showItemInFolder($,q){A.shell.showItemInFolder(q)}async setRepresentedFilename($,q){this.windowById($)?.setRepresentedFilename(q)}async setDocumentEdited($,q){this.windowById($)?.setDocumentEdited(q)}async openExternal($,q){return p.isLinuxSnap?this.safeSnapOpenExternal(q):A.shell.openExternal(q),!0}safeSnapOpenExternal($){const q=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR,oe=process.env.GTK_IM_MODULE_FILE,ae=process.env.GDK_BACKEND,he=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,K=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,A.shell.openExternal($),process.env.GDK_PIXBUF_MODULE_FILE=q,process.env.GDK_PIXBUF_MODULEDIR=ie,process.env.GTK_IM_MODULE_FILE=oe,process.env.GDK_BACKEND=ae,process.env.GIO_MODULE_DIR=he,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=K}moveItemToTrash($,q){return A.shell.trashItem(q)}async isAdmin(){let $;return p.isWindows?$=(await new Promise((q,ie)=>{j(["native-is-elevated"],q,ie)}))():$=process.getuid()===0,$}async writeElevated($,q,ie,oe){const ae=await new Promise((he,ce)=>{j(["@vscode/sudo-prompt"],he,ce)});return new Promise((he,ce)=>{const K=[`"${this.cliPath}"`];oe?.unlock&&K.push("--file-chmod"),K.push("--file-write",`"${q.fsPath}"`,`"${ie.fsPath}"`);const Y={name:this.productService.nameLong.replace("-",""),icns:p.isMacintosh&&this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ae.exec(K.join(" "),Y,(x,W,H)=>{W&&this.logService.trace(`[sudo-prompt] received stdout: ${W}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),x?ce(x):he(void 0)})})}get cliPath(){return p.isWindows?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):p.isLinux?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,v.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return p.isWindows&&(0,m.hasWSLFeatureInstalled)()}async killProcess($,q,ie){process.kill(q,ie)}async readClipboardText($,q){return A.clipboard.readText(q)}async writeClipboardText($,q,ie){return A.clipboard.writeText(q,ie)}async readClipboardFindText($){return A.clipboard.readFindText()}async writeClipboardFindText($,q){return A.clipboard.writeFindText(q)}async writeClipboardBuffer($,q,ie,oe){return A.clipboard.writeBuffer(q,Buffer.from(ie.buffer),oe)}async readClipboardBuffer($,q){return o.VSBuffer.wrap(A.clipboard.readBuffer(q))}async hasClipboard($,q,ie){return A.clipboard.has(q,ie)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar($,q){this.windowById($)?.updateTouchBar(q)}async notifyReady($){this.windowById($)?.setReady()}async relaunch($,q){return this.lifecycleMainService.relaunch(q)}async reload($,q){const ie=this.windowById($);if(ie){if((0,a.isWorkspaceIdentifier)(ie.openedWorkspace)){const oe=ie.openedWorkspace.configPath;if(oe.scheme===u.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(ie,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow($){this.closeWindowById($,$)}async closeWindowById($,q){const ie=this.windowById(q);if(ie?.win)return ie.win.close()}async quit($){const q=this.windowsMainService.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&q.win?q.win.close():this.lifecycleMainService.quit()}async exit($,q){await this.lifecycleMainService.kill(q)}async resolveProxy($,q){return this.windowById($)?.win?.webContents?.session?.resolveProxy(q)}findFreePort($,q,ie,oe,ae=1){return(0,s.findFreePort)(q,ie,oe,ae)}async openDevTools($,q){const ie=this.windowById($);ie?.win&&ie.win.webContents.openDevTools(q)}async toggleDevTools($){const q=this.windowById($);q?.win&&q.win.webContents.toggleDevTools()}async sendInputEvent($,q){const ie=this.windowById($);ie?.win&&(q.type==="mouseDown"||q.type==="mouseUp")&&ie.win.webContents.sendInputEvent(q)}async enableSandbox($,q){q?this.stateService.setItem("window.experimental.useSandbox",!0):this.stateService.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer($,q,ie){const oe=this.windowById($);if(!oe||!oe.win)throw new Error;return await new C.WindowProfiler(oe.win,q,this.logService).inspect(ie)}async windowsGetStringRegKey($,q,ie,oe){if(!p.isWindows)return;const ae=await new Promise((he,ce)=>{j(["@vscode/windows-registry"],he,ce)});try{return ae.GetStringRegKey(q,ie,oe)}catch{return}}windowById($){if(typeof $=="number")return this.windowsMainService.getWindowById($)}};we([M.memoize],T.prototype,"cliPath",null),T=we([X(1,n.IWindowsMainService),X(2,d.IDialogMainService),X(3,D.ILifecycleMainService),X(4,b.IEnvironmentMainService),X(5,t.ILogService),X(6,l.IProductService),X(7,i.IThemeMainService),X(8,R.IStateService),X(9,c.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(ee[280],te([0,1,15,42,27,2,14,4,104,177,89,127,58,28,6,5,59,66,21,67,79,32,11,33,70]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");const n="issue.processExplorerWindowState";let a=class Ct{constructor(m,C,R,T,U,$,q,ie,oe,ae){this.userEnv=m,this.environmentMainService=C,this.logService=R,this.diagnosticsService=T,this.diagnosticsMainService=U,this.dialogMainService=$,this.nativeHostMainService=q,this.protocolMainService=ie,this.productService=oe,this.stateService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){A.validatedIpcMain.on("vscode:issueSystemInfoRequest",async m=>{const[C,R]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.diagnosticsService.getSystemInfo(C,R);this.safeSend(m,"vscode:issueSystemInfoResponse",T)}),A.validatedIpcMain.on("vscode:listProcesses",async m=>{const C=[];try{C.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,v.isRemoteDiagnosticError)(T)?C.push({name:T.hostName,rootProcess:T}):T.processes&&C.push({name:T.hostName,rootProcess:T.processes})})}catch(R){this.logService.error(`Listing processes failed: ${R}`)}this.safeSend(m,"vscode:listProcessesResponse",C)}),A.validatedIpcMain.on("vscode:issueReporterClipboard",async m=>{if(this.issueReporterWindow){const{response:C}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,u.localize)(1,null),buttons:[(0,u.localize)(2,null),(0,u.localize)(3,null)]},this.issueReporterWindow);this.safeSend(m,"vscode:issueReporterClipboardResponse",C===0)}}),A.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async m=>{const C=await this.getPerformanceInfo();this.safeSend(m,"vscode:issuePerformanceInfoResponse",C)}),A.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.issueReporterWindow){const{response:m}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,u.localize)(4,null),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]},this.issueReporterWindow);m===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}),A.validatedIpcMain.on("vscode:workbenchCommand",(m,C)=>{const{id:R,from:T,args:U}=C;let $;switch(T){case"issueReporter":$=this.issueReporterParentWindow;break;case"processExplorer":$=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${T}`)}$?.webContents.send("vscode:runAction",{id:R,from:T,args:U})}),A.validatedIpcMain.on("vscode:openExternal",(m,C)=>{this.nativeHostMainService.openExternal(void 0,C)}),A.validatedIpcMain.on("vscode:closeIssueReporter",m=>{this.issueReporterWindow?.close()}),A.validatedIpcMain.on("vscode:closeProcessExplorer",m=>{this.processExplorerWindow?.close()}),A.validatedIpcMain.on("vscode:pidToNameRequest",async m=>{const C=await this.diagnosticsMainService.getMainDiagnostics(),R=[];for(const T of C.windows)R.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:U}of i.UtilityProcess.getAll())R.push([T,U]);this.safeSend(m,"vscode:pidToNameResponse",R)})}safeSend(m,C,...R){m.sender.isDestroyed()||m.sender.send(C,...R)}async openReporter(m){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const C=new L.DisposableStore,R=C.add(this.protocolMainService.createIPCObjectUrl()),T=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(T,R,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(7,null),zoomLevel:m.zoomLevel,alwaysOnTop:!1},"issue-reporter"),R.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:m,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,C.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,C.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(m){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const C=new L.DisposableStore,R=C.add(this.protocolMainService.createIPCObjectUrl()),T=this.stateService.getItem(n,void 0),U=c(T)?T:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(U,R,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(8,null),zoomLevel:m.zoomLevel,alwaysOnTop:!0},"process-explorer"),R.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:m,product:g.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,C.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,C.dispose())});const $=()=>{if(!this.processExplorerWindow)return;const q=this.processExplorerWindow.getSize(),ie=this.processExplorerWindow.getPosition();if(!q||!ie)return;const oe={width:q[0],height:q[1],x:ie[0],y:ie[1]};this.stateService.setItem(n,oe)};this.processExplorerWindow.on("moved",$),this.processExplorerWindow.on("resized",$)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(m){m.isMinimized()&&m.restore(),m.focus()}createBrowserWindow(m,C,R,T){const U=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:m.width,height:m.height,minWidth:300,minHeight:200,x:m.x,y:m.y,title:R.title,backgroundColor:R.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,w.zoomLevelToZoomFactor)(R.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:R.alwaysOnTop,experimentalDarkMode:!0});return U.setMenuBarVisibility(!1),U}async getSystemStatus(){const[m,C]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(m,C)}getWindowPosition(m,C,R){let T;const U=I.screen.getAllDisplays();if(U.length===1)T=U[0];else{if(k.isMacintosh){const ie=I.screen.getCursorScreenPoint();T=I.screen.getDisplayNearestPoint(ie)}!T&&m&&(T=I.screen.getDisplayMatching(m.getBounds())),T||(T=I.screen.getPrimaryDisplay()||U[0])}const $=T.bounds,q={width:C,height:R,x:$.x+$.width/2-C/2,y:$.y+$.height/2-R/2};return $.width>0&&$.height>0&&(q.x<$.x&&(q.x=$.x),q.y<$.y&&(q.y=$.y),q.x>$.x+$.width&&(q.x=$.x),q.y>$.y+$.height&&(q.y=$.y),q.width>$.width&&(q.width=$.width),q.height>$.height&&(q.height=$.height)),q}async getPerformanceInfo(){try{const[m,C]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(m,C)}catch(m){throw this.logService.warn("issueService#getPerformanceInfo ",m.message),m}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const m=await I.contentTracing.stopRecording(`${(0,D.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,u.localize)(9,null),detail:(0,u.localize)(10,null,m),buttons:[(0,u.localize)(11,null)]},(0,t.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,m)}};a.DEFAULT_BACKGROUND_COLOR="#1E1E1E",a=we([X(1,h.IEnvironmentMainService),X(2,S.ILogService),X(3,v.IDiagnosticsService),X(4,p.IDiagnosticsMainService),X(5,y.IDialogMainService),X(6,s.INativeHostMainService),X(7,b.IProtocolMainService),X(8,d.IProductService),X(9,l.IStateService)],a),e.IssueMainService=a;function c(o){return typeof o!="object"||o===null?!1:"x"in o&&"y"in o&&"width"in o&&"height"in o}}),define(ee[281],te([0,1,23,19,28,20,5,59,21,52,25,49,95]),function(j,e,I,A,r,L,M,k,f,u,v,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends y.AbstractUpdateService{constructor(S,s,g,d,b,w,D,t){super(S,s,d,b,w,t),this.telemetryService=g,this.nativeHostMainService=D}buildUpdateFeedUrl(S){return(0,y.createUpdateURL)(`linux-${process.arch}`,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(p.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},I.CancellationToken.None).then(u.asJson).then(s=>{!s||!s.url||!s.version||!s.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(p.State.Idle(1))):this.setState(p.State.AvailableForDownload(s))}).then(void 0,s=>{this.logService.error(s),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const g=S?s.message||s:void 0;this.setState(p.State.Idle(1,g))}))}async doDownloadUpdate(S){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(p.State.Idle(1))}};h=we([X(0,L.ILifecycleMainService),X(1,A.IConfigurationService),X(2,v.ITelemetryService),X(3,r.IEnvironmentMainService),X(4,u.IRequestService),X(5,M.ILogService),X(6,k.INativeHostMainService),X(7,f.IProductService)],h),e.LinuxUpdateService=h}),define(ee[282],te([0,1,46,41,27,7,23,55,9,8,138,24,19,28,16,20,5,59,21,52,25,49,95]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(c,o=1e3){for(;!c();)await(0,L.timeout)(o)}let i;function n(){return typeof i>"u"&&(A.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?i=0:f.basename(f.normalize(f.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let a=class extends t.AbstractUpdateService{get cachePath(){const o=f.join((0,r.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return p.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,m,C,R,T,U,$,q,ie){super(o,m,R,T,U,ie),this.telemetryService=C,this.fileService=$,this.nativeHostMainService=q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(o){let m="win32";switch(process.arch!=="ia32"&&(m+=`-${process.arch}`),n()){case 1:m+="-archive";break;case 3:m+="-msi";break;default:this.productService.target==="user"&&(m+="-user")}return(0,t.createUpdateURL)(m,o,this.productService)}doCheckForUpdates(o){!this.url||(this.setState(D.State.CheckingForUpdates(o)),this.requestService.request({url:this.url},M.CancellationToken.None).then(b.asJson).then(m=>{const C=n();return!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o}),this.setState(D.State.Idle(C)),Promise.resolve(null)):C===1?(this.setState(D.State.AvailableForDownload(m)),Promise.resolve(null)):(this.setState(D.State.Downloading(m)),this.cleanup(m.version).then(()=>this.getUpdatePackagePath(m.version).then(R=>p.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const U=m.url,$=m.hash,q=`${R}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(ie=>this.fileService.writeFile(u.URI.file(q),ie.stream)).then($?()=>(0,v.checksum)(q,m.hash):()=>{}).then(()=>p.Promises.rename(q,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&m.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(D.State.Downloaded(m)):this.setState(D.State.Ready(m))})))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o});const C=o?m.message||m:void 0;this.setState(D.State.Idle(n(),C))}))}async doDownloadUpdate(o){o.update.url&&this.nativeHostMainService.openExternal(void 0,o.update.url),this.setState(D.State.Idle(n()))}async getUpdatePackagePath(o){const m=await this.cachePath;return f.join(m,`CodeSetup-${this.productService.quality}-${o}.exe`)}async cleanup(o=null){const m=o?U=>!new RegExp(`${this.productService.quality}-${o}\\.exe$`).test(U):()=>!0,C=await this.cachePath,T=(await p.Promises.readdir(C)).filter(m).map(async U=>{try{await p.Promises.unlink(f.join(C,U))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const o=this.state.update;this.setState(D.State.Updating(o));const m=await this.cachePath;this.availableUpdate.updateFilePath=f.join(m,`CodeSetup-${this.productService.quality}-${o.version}.flag`),await p.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(D.State.Idle(n()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((U,$)=>{j(["windows-mutex"],U,$)});l(()=>T.isActive(R)).then(()=>this.setState(D.State.Ready(o)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?A.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,I.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const m=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!m};this.setState(D.State.Downloading(C)),this.availableUpdate={packagePath:o},m?this.productService.target==="user"?this.doApplyUpdate():this.setState(D.State.Downloaded(C)):this.setState(D.State.Ready(C))}};we([k.memoize],a.prototype,"cachePath",null),a=we([X(0,S.ILifecycleMainService),X(1,y.IConfigurationService),X(2,w.ITelemetryService),X(3,h.IEnvironmentMainService),X(4,b.IRequestService),X(5,s.ILogService),X(6,E.IFileService),X(7,g.INativeHostMainService),X(8,d.IProductService)],a),e.Win32UpdateService=a}),define(ee[283],te([0,1,15,7,23,44,3,2,14,9,64,4,8,185,63,19,58,28,62,16,20,5,21,67,245,97,25,137,69,79,30,29,54,124,128,38,33,53,59,247,120,48,94,27,121,65,22]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R,T,U,$,q,ie,oe,ae,he,ce,K,Y,x,W,H,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(Z){Z[Z.NONE=0]="NONE",Z[Z.NAVIGATING=1]="NAVIGATING",Z[Z.READY=2]="READY"})(ne||(ne={}));let re=class ot extends k.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get isSandboxed(){return this._isSandboxed}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const _=this.userDataProfilesService.profiles.find(P=>P.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&_?_:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,R.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(_,P,O,F,B,N,z,V,se,de,ye,ke,Ae,_e,Oe,me,pe,De,J,ue,fe){super(),this.logService=P,this.loggerMainService=O,this.environmentMainService=F,this.policyService=B,this.userDataProfilesService=N,this.fileService=z,this.applicationStorageMainService=V,this.storageMainService=se,this.configurationService=de,this.themeMainService=ye,this.workspacesManagementMainService=ke,this.backupMainService=Ae,this.telemetryService=_e,this.dialogMainService=Oe,this.lifecycleMainService=me,this.productService=pe,this.protocolMainService=De,this.windowsMainService=J,this.stateService=ue,this.nativeHostMainService=fe,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this._isSandboxed=!1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;let Ee=!1;{const[Le,Te]=this.restoreWindowState(_.state);this.windowState=Le,this.logService.trace("window#ctor: using window state",Le);const We=this.windowState.mode===0||this.windowState.mode===3;typeof ot.sandboxState>"u"&&(ot.sandboxState=this.stateService.getItem("window.experimental.useSandbox",!1));const qe=this.configurationService.getValue("window");typeof qe?.experimental?.useSandbox=="boolean"?Ee=qe.experimental.useSandbox:this.productService.quality==="stable"&&ot.sandboxState?Ee=!0:Ee=typeof this.productService.quality=="string"&&this.productService.quality!=="stable",this._isSandboxed=Ee;const Ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:m.WindowMinimumSize.WIDTH,minHeight:m.WindowMinimumSize.HEIGHT,show:!We,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(qe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ee?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};p.isLinux?Ue.icon=(0,u.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):p.isWindows&&!this.environmentMainService.isBuilt&&(Ue.icon=(0,u.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),p.isMacintosh&&!this.useNativeFullScreen()&&(Ue.fullscreenable=!1),p.isMacintosh&&(Ue.acceptFirstMouse=!0,qe?.clickThroughInactive===!1&&(Ue.acceptFirstMouse=!1));const Ne=p.isMacintosh&&qe?.nativeTabs===!0;Ne&&(Ue.tabbingIdentifier=this.productService.nameShort);const He=(0,m.getTitleBarStyle)(this.configurationService)==="custom";if(He&&(Ue.titleBarStyle="hidden",p.isMacintosh||(Ue.frame=!1),(0,m.useWindowControlsOverlay)(this.configurationService))){const G=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),le=$.Color.fromHex(G).isDarker()?"#FFFFFF":"#000000";Ue.titleBarOverlay={height:29,color:G,symbolColor:le},this.hasWindowControlOverlay=!0}if((0,v.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(Ue),(0,v.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,p.isMacintosh&&He&&this._win.setSheetOffset(22),He&&(p.isWindows&&(0,m.useWindowControlsOverlay)(this.configurationService)||p.isMacintosh)){const G=this.stateService.getItem(ot.windowControlHeightStateStorageKey);G&&this.updateWindowControls({height:G})}p.isWindows&&He&&this._win.hookWindowMessage(278,()=>{const[le,ge]=this._win.getPosition(),Se=I.screen.getCursorScreenPoint(),ve=Se.x-le,Re=Se.y-ge;return(()=>!(ve>30&&Re>=0&&Re<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:ve,y:Re})),0}),(p.isMacintosh||p.isWindows)&&Te&&(!Ne||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(G=>typeof G=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),We&&((0,v.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,v.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners(Ee)}setRepresentedFilename(_){p.isMacintosh?this._win.setRepresentedFilename(_):this.representedFilename=_}getRepresentedFilename(){return p.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(_){p.isMacintosh&&this._win.setDocumentEdited(_),this.documentEdited=_}isDocumentEdited(){return p.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(_){p.isMacintosh&&_?.force&&I.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(_=>{if(this.isReady)return _(this);this.whenReadyCallbacks.push(_)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(_=>{function P(){O.dispose(),F.dispose(),_()}const O=this.onDidClose(()=>P()),F=this.onWillLoad(()=>P())})}registerListeners(_){this._win.on("unresponsive",()=>this.onWindowError(1,{sandboxed:_})),this._win.webContents.on("render-process-gone",(O,F)=>this.onWindowError(2,{...F,sandboxed:_})),this._win.webContents.on("did-fail-load",(O,F,B)=>this.onWindowError(3,{reason:B,exitCode:F,sandboxed:_})),this._win.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",O=>{this._config&&(this._config.maximized=!0),I.app.emit("browser-window-maximize",O,this._win)}),this._win.on("unmaximize",O=>{this._config&&(this._config.maximized=!1),I.app.emit("browser-window-unmaximize",O,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(O=>this.onConfigurationUpdated(O))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(O=>this.onDidDeleteUntitledWorkspace(O)));const P=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:P},async(O,F)=>{const B=await this.getMarketplaceHeaders();F({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,B)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(_,P){switch(_){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:_,reason:P?.reason,code:P?.exitCode,sandboxed:P?.sandboxed?"1":"0"}),_){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(_===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:O,checkboxChecked:F}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this._config?.workspace?(0,h.localize)(5,null):void 0},this._win);if(O!==2){const B=O===0;await this.destroyWindow(B,F)}}else if(_===2)if(p.isWindows&&P?.reason==="launch-failed"&&P.exitCode===18&&await this.nativeHostMainService.isAdmin(void 0))await this.handleWindowsAdminCrash(P);else{let O;P?O=(0,h.localize)(7,null,P.reason,P.exitCode??"<unknown>"):O=(0,h.localize)(6,null);const{response:F,checkboxChecked:B}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:O,detail:this._config?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this._config?.workspace?(0,h.localize)(13,null):void 0},this._win),N=F===0;await this.destroyWindow(N,B)}break}}async handleWindowsAdminCrash(_){const P=[],O=(0,K.isInternalTelemetry)(this.productService,this.configurationService);if((0,K.supportsTelemetry)(this.productService,this.environmentMainService)){this.productService.aiConfig&&this.productService.aiConfig.ariaKey&&P.push(new he.OneDataSystemAppender(O,"monacoworkbench",null,this.productService.aiConfig.ariaKey));const B=await(0,W.resolveMachineId)(this.stateService,this.logService),N={appenders:P,sendErrorTelemetry:!1,commonProperties:(0,Y.resolveCommonProperties)((0,x.release)(),(0,x.hostname)(),process.arch,this.productService.commit,this.productService.version,B,O),piiPaths:(0,K.getPiiPathsFromEnvironment)(this.environmentMainService)};await new ce.TelemetryService(N,this.configurationService,this.productService).publicLog2("windowadminerror",{reason:_.reason,code:_.exitCode})}const{response:F}=await this.dialogMainService.showMessageBox({type:"error",buttons:[(0,h.localize)(14,null),(0,h.localize)(15,null)],message:(0,h.localize)(16,null),detail:(0,h.localize)(17,null,this.productService.nameLong)},this._win);F===0&&await this.nativeHostMainService.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(P.map(B=>B.flush())),await this.destroyWindow(!1,!1)}async destroyWindow(_,P){const O=this._config?.workspace;if(P&&O)try{const F=this.storageMainService.workspaceStorage(O);await F.init(),F.delete("memento/workbench.parts.editor"),await F.close()}catch(F){this.logService.error(F)}if(this._onDidDestroy.fire(),this._win?.destroy(),_&&this._config){let F,B;(0,R.isSingleFolderWorkspaceIdentifier)(O)?F={folderUri:O.uri}:(0,R.isWorkspaceIdentifier)(O)?F={workspaceUri:O.configPath}:B=!0,(0,Q.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:F?[F]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(_){this._config?.workspace?.id===_.id&&(this._config.workspace=void 0)}onConfigurationUpdated(_){if(!_||_.affectsConfiguration("window.menuBarVisibility")){const P=this.getMenuBarVisibility();P!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=P,this.setMenuBarVisibility(P))}if(!_||_.affectsConfiguration("http.proxy")){let P=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;P?.endsWith("/")&&(P=P.substr(0,P.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((P||"").indexOf("@")===-1&&(P!==this.currentHttpProxy||O!==this.currentNoProxy)){this.currentHttpProxy=P,this.currentNoProxy=O;const F=P||"",B=O?`${O},<local>`:"<local>";this.logService.trace(`Setting proxy to '${F}', bypassing '${B}'`),this._win.webContents.session.setProxy({proxyRules:F,proxyBypassRules:B,pacScript:""})}}}addTabbedWindow(_){p.isMacintosh&&_.win&&this._win.addTabbedWindow(_.win)}load(_,P=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!P.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),P.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(_,P),this.readyState===0?this._config=_:this.pendingLoadConfig=_,this.readyState=1,this._win.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const O=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new A.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:_.workspace,reason:P.isReload?3:O?2:1})}updateConfiguration(_,P){const O=(this._config??this.pendingLoadConfig)?.userEnv;if(O){const F=(0,d.isLaunchedFromCli)(O)&&!(0,d.isLaunchedFromCli)(_.userEnv),B=this.isExtensionDevelopmentHost;(F||B)&&(_.userEnv={...O,..._.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(_.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),P.disableExtensions!==void 0&&(_["disable-extensions"]=P.disableExtensions),_.fullscreen=this.isFullScreen,_.maximized=this._win.isMaximized(),_.partsSplash=this.themeMainService.getWindowSplash(),(0,v.mark)("code/willOpenNewWindow"),_.perfMarks=(0,v.getMarks)(),this.configObjectUrl.update(_)}async reload(_){const P=Object.assign({},this._config);P.workspace=await this.validateWorkspaceBeforeReload(P),delete P.filesToOpenOrCreate,delete P.filesToDiff,delete P.filesToMerge,delete P.filesToWait,this.isExtensionDevelopmentHost&&_&&(P.verbose=_.verbose,P.debugId=_.debugId,P.extensionEnvironment=_.extensionEnvironment,P["inspect-extensions"]=_["inspect-extensions"],P["inspect-brk-extensions"]=_["inspect-brk-extensions"],P["extensions-dir"]=_["extensions-dir"]),P.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),P.isInitialStartup=!1,P.policiesData=this.policyService.serialize(),P.continueOn=this.environmentMainService.continueOn,P.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},P.logLevel=this.loggerMainService.getLogLevel(),P.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(P,{isReload:!0,disableExtensions:_?.["disable-extensions"]})}async validateWorkspaceBeforeReload(_){if((0,R.isWorkspaceIdentifier)(_.workspace)){const P=_.workspace.configPath;if(P.scheme===f.Schemas.file&&!await this.fileService.exists(P))return}else if((0,R.isSingleFolderWorkspaceIdentifier)(_.workspace)){const P=_.workspace.uri;if(P.scheme===f.Schemas.file&&!await this.fileService.exists(P))return}return _.workspace}serializeWindowState(){if(!this._win)return(0,U.defaultWindowState)();if(this.isFullScreen){let O;try{O=I.screen.getDisplayMatching(this.getBounds())}catch{}const F=(0,U.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.windowState.width||F.width,height:this.windowState.height||F.height,x:this.windowState.x||0,y:this.windowState.y||0}}const _=Object.create(null);let P;if(!p.isMacintosh&&this._win.isMaximized()?P=0:P=1,P===0?_.mode=0:_.mode=1,P===1||P===0){let O;P===1?O=this.getBounds():O=this._win.getNormalBounds(),_.x=O.x,_.y=O.y,_.width=O.width,_.height=O.height}return _}updateWindowControls(_){if(_.height&&this.stateService.setItem(ot.windowControlHeightStateStorageKey,_.height),p.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:_.backgroundColor?.trim()===""?void 0:_.backgroundColor,symbolColor:_.foregroundColor?.trim()===""?void 0:_.foregroundColor,height:_.height?_.height-1:void 0});else if(p.isMacintosh&&_.height!==void 0){const P=(_.height-15)/2;this._win.setTrafficLightPosition({x:P,y:P})}}restoreWindowState(_){(0,v.mark)("code/willRestoreCodeWindowState");let P=!1;if(_)try{const O=I.screen.getAllDisplays();P=O.length>1,_=this.validateWindowState(_,O)}catch(O){this.logService.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,v.mark)("code/didRestoreCodeWindowState"),[_||(0,U.defaultWindowState)(),P]}validateWindowState(_,P){if(this.logService.trace(`window#validateWindowState: validating window state on ${P.length} display(s)`,_),typeof _.x!="number"||typeof _.y!="number"||typeof _.width!="number"||typeof _.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(_.width<=0||_.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(P.length===1){const B=this.getWorkingArea(P[0]);if(B){let N=function(){!_||typeof _.x!="number"||typeof _.y!="number"||!B||(_.x<B.x&&(_.x=B.x),_.y<B.y&&(_.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),N(),_.width>B.width&&(_.width=B.width),_.height>B.height&&(_.height=B.height),_.x>B.x+B.width-128&&(_.x=B.x+B.width-_.width),_.y>B.y+B.height-128&&(_.y=B.y+B.height-_.height),N()}return _}if(_.display&&_.mode===3){const B=P.find(N=>N.id===_.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,U.defaultWindowState)(3);return N.x=B.bounds.x,N.y=B.bounds.y,N}}let O,F;try{O=I.screen.getDisplayMatching({x:_.x,y:_.y,width:_.width,height:_.height}),F=this.getWorkingArea(O)}catch{}if(O&&F&&_.x+_.width>F.x&&_.y+_.height>F.y&&_.x<F.x+F.width&&_.y<F.y+F.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",F),_}getWorkingArea(_){if(_.workArea.width>0&&_.workArea.height>0)return _.workArea;if(_.bounds.width>0&&_.bounds.height>0)return _.bounds}getBounds(){const[_,P]=this._win.getPosition(),[O,F]=this._win.getSize();return{x:_,y:P,width:O,height:F}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(_){this.useNativeFullScreen()?this.setNativeFullScreen(_):this.setSimpleFullScreen(_),this.sendWhenReady(_?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return p.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(_){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(_)}doSetNativeFullScreen(_){p.isMacintosh&&(this.transientIsNativeFullScreen=_,this.joinNativeFullScreenTransition=new A.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,A.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(_)}setSimpleFullScreen(_){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(_),this._win.webContents.focus()}useNativeFullScreen(){const _=this.configurationService.getValue("window");return!_||typeof _.nativeFullScreen!="boolean"||_.nativeTabs?!0:_.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let _=(0,m.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(_)<0&&(_="classic"),_}setMenuBarVisibility(_,P=!0){p.isMacintosh||(_==="toggle"&&P&&this.send("vscode:showInfoMessage",(0,h.localize)(18,null)),_==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(_)}):this.doSetMenuBarVisibility(_))}doSetMenuBarVisibility(_){const P=this.isFullScreen;switch(_){case"classic":this._win.setMenuBarVisibility(!P),this._win.autoHideMenuBar=P;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(p.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(_,P,...O){this.isReady?this.send(_,...O):this.ready().then(()=>{P.isCancellationRequested||this.send(_,...O)})}send(_,...P){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${_}' for window that is destroyed`);return}try{this._win.webContents.send(_,...P)}catch(O){this.logService.warn(`Error sending IPC message to channel '${_}' of window ${this._id}: ${(0,L.toErrorMessage)(O)}`)}}}updateTouchBar(_){!p.isMacintosh||this.touchBarGroups.forEach((P,O)=>{const F=_[O];P.segments=this.createTouchBarGroupSegments(F)})}createTouchBar(){if(!!p.isMacintosh){for(let _=0;_<10;_++){const P=this.createTouchBarGroup();this.touchBarGroups.push(P)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(_=[]){const P=this.createTouchBarGroupSegments(_),O=new I.TouchBar.TouchBarSegmentedControl({segments:P,mode:"buttons",segmentStyle:"automatic",change:F=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:O.segments[F].id,from:"touchbar"})}});return O}createTouchBarGroupSegments(_=[]){return _.map(O=>{let F;O.icon&&!c.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===f.Schemas.file&&(F=I.nativeImage.createFromPath(y.URI.revive(O.icon.dark).fsPath),F.isEmpty()&&(F=void 0));let B;return typeof O.title=="string"?B=O.title:B=O.title.value,{id:O.id,label:F?void 0:B,icon:F}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id),this._win=null}};re.windowControlHeightStateStorageKey="windowControlHeight",re.sandboxState=void 0,re=we([X(1,D.ILogService),X(2,H.ILoggerMainService),X(3,g.IEnvironmentMainService),X(4,q.IPolicyService),X(5,oe.IUserDataProfilesMainService),X(6,b.IFileService),X(7,n.IApplicationStorageMainService),X(8,n.IStorageMainService),X(9,S.IConfigurationService),X(10,o.IThemeMainService),X(11,T.IWorkspacesManagementMainService),X(12,E.IBackupMainService),X(13,a.ITelemetryService),X(14,s.IDialogMainService),X(15,w.ILifecycleMainService),X(16,t.IProductService),X(17,l.IProtocolMainService),X(18,C.IWindowsMainService),X(19,ie.IStateService),X(20,ae.INativeHostMainService)],re),e.CodeWindow=re}),define(ee[81],te([0,1,15,22,7,3,45,2,14,4,18,8,24,188,6,20,5,97,98,29,54,35]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,E.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,n,a,c){super(),this.logService=i,this.workspacesManagementMainService=n,this.lifecycleMainService=a,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new L.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],a=[];for(const o of i)if((0,d.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&!this.containsWorkspace(n,o.workspace)&&n.push(o);else if((0,d.isRecentFolder)(o))this.containsFolder(n,o.folderUri)||n.push(o);else{const m=this.containsFile(a,o.fileUri),C=o.fileUri.scheme===f.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,v.basename)(o.fileUri))>=0;!m&&!C&&(a.push(o),u.isWindows&&o.fileUri.scheme===f.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:n,files:a});n=c.workspaces,a=c.files,n.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=tt.MAX_TOTAL_RECENT_ENTRIES),a.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(a.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:a}),this._onDidChangeRecentlyOpened.fire(),u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const n=m=>{const C=this.location(m);for(const R of i)if(v.extUriBiasedIgnorePathCase.isEqual(R,C))return!1;return!0},a=await this.getRecentlyOpened(),c=a.workspaces.filter(n),o=a.files.filter(n);(c.length!==a.workspaces.length||o.length!==a.files.length)&&(await this.saveRecentlyOpened({files:o,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const n=new D.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)n.set(this.location(o),o);const a=new D.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)a.set(this.location(o),o);const c=await this.getRecentlyOpenedFromStorage();for(const o of c.workspaces){const m=n.get(this.location(o));m?m.label=m.label??o.label:n.set(this.location(o),o)}for(const o of c.files){const m=a.get(this.location(o));m?m.label=m.label??o.label:a.set(this.location(o),o)}return{workspaces:[...n.values()],files:[...a.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const n=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(a){this.logService.error("Unexpected error parsing opened paths list",a)}return(0,d.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(i)),-1,1)}location(i){return(0,d.isRecentFolder)(i)?i.folderUri:(0,d.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,n){return!!i.find(a=>(0,d.isRecentWorkspace)(a)&&a.workspace.id===n.id)}containsFolder(i,n){return!!i.find(a=>(0,d.isRecentFolder)(a)&&v.extUriBiasedIgnorePathCase.isEqual(a.folderUri,n))}containsFile(i,n){return!!i.find(a=>v.extUriBiasedIgnorePathCase.isEqual(a.fileUri,n))}async handleWindowsJumpList(){!u.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!u.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const o of I.app.getJumpListSettings().removedItems){const m=o.args;if(m){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);C&&n.push(p.URI.parse(C[2]))}}await this.removeRecentlyOpened(n);let a=!1;const c=(0,A.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const m=(0,d.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:C,description:R}=this.getWindowsJumpListLabel(m,o.label);let T;return p.URI.isUri(m)?T=`--folder-uri "${m.toString()}"`:(a=!0,T=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:R.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&i.push({type:"custom",name:a?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(i,n){if(n)return{title:(0,M.splitName)(n).name,description:n};if(p.URI.isUri(i))return{title:(0,v.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let a=(0,v.basename)(i.configPath);return a.endsWith(b.WORKSPACE_EXTENSION)&&(a=a.substr(0,a.length-b.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,a),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,M.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!u.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let a=0;for(let o=0;o<i.workspaces.length&&a<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const m=this.location(i.workspaces[o]);if(m.scheme===f.Schemas.file){const C=(0,v.originalFSPath)(m);await y.Promises.exists(C)&&(n.push(C),a++)}}const c=[];for(let o=0;o<i.files.length&&a<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const m=this.location(i.files[o]);if(m.scheme===f.Schemas.file){const C=(0,v.originalFSPath)(m);if(tt.COMMON_FILES_FILTER.includes((0,v.basename)(m))||n.includes(C))continue;await y.Promises.exists(C)&&(c.push(C),a++)}}c.reverse().forEach(o=>I.app.addRecentDocument(o)),n.reverse().forEach(o=>I.app.addRecentDocument(o))}};t.MAX_TOTAL_RECENT_ENTRIES=500,t.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",t.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,t.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,t.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,t.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],t=we([X(0,s.ILogService),X(1,w.IWorkspacesManagementMainService),X(2,S.ILifecycleMainService),X(3,g.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[284],te([0,1,15,7,23,45,4,8,178,19,28,20,5,225,59,21,33,25,49,79,30,81]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let l=class yt{constructor(a,c,o,m,C,R,T,U,$,q,ie){this.updateService=a,this.configurationService=c,this.windowsMainService=o,this.environmentMainService=m,this.telemetryService=C,this.workspacesHistoryMainService=R,this.stateService=T,this.lifecycleMainService=U,this.logService=$,this.nativeHostMainService=q,this.productService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new A.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new A.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,b.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateService.getItem(yt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(R,T,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const o=this.productService.reportIssueUrl;o&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(o,"openReportIssues"));const m=this.productService.licenseUrl;m&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const R=m.indexOf("?")>0?"&":"?";this.openUrl(`${m}${R}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(m,"openLicenseUrl")});const C=this.productService.privacyStatementUrl;C&&m&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(C,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,c){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateService.setItem(yt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!M.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!I.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=I.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){I.Menu.setApplicationMenu(M.isMacintosh?new I.Menu:null);return}const c=new I.Menu;let o;if(M.isMacintosh){const C=new I.Menu;o=new I.MenuItem({label:this.productService.nameShort,submenu:C}),this.setMacApplicationMenu(C),c.append(o)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new I.Menu;C.append(new I.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(C)}if(this.shouldDrawMenu("File")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:C});this.setMenuById(C,"File"),c.append(R)}if(this.shouldDrawMenu("Edit")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:C});this.setMenuById(C,"Edit"),c.append(R)}if(this.shouldDrawMenu("Selection")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:C});this.setMenuById(C,"Selection"),c.append(R)}if(this.shouldDrawMenu("View")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:C});this.setMenuById(C,"View"),c.append(R)}if(this.shouldDrawMenu("Go")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:C});this.setMenuById(C,"Go"),c.append(R)}if(this.shouldDrawMenu("Run")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),c.append(R)}if(this.shouldDrawMenu("Terminal")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),c.append(R)}let m;if(this.shouldDrawMenu("Window")){const C=new I.Menu;m=new I.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}if(m&&c.append(m),this.shouldDrawMenu("Help")){const C=new I.Menu,R=new I.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:C,role:"help"});this.setMenuById(C,"Help"),c.append(R)}c.items&&c.items.length>0?I.Menu.setApplicationMenu(c):I.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const c=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),o=this.getUpdateMenuItems();let m;if(this.shouldDrawMenu("Preferences")){const oe=new I.Menu;this.setMenuById(oe,"Preferences"),m=new I.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:oe})}const C=new I.Menu,R=new I.MenuItem({label:f.localize(12,null),role:"services",submenu:C}),T=new I.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new I.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new I.MenuItem({label:f.localize(15,null),role:"unhide"}),q=new I.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(oe,ae,he)=>{const ce=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),ie=[c];ie.push(...o),m&&ie.push(i(),m),ie.push(i(),R,i(),T,U,$,i(),q),ie.forEach(oe=>a.append(oe))}async confirmBeforeQuit(a){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(a)){const{response:o}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return o===0}return!0}shouldDrawMenu(a){if(!M.isMacintosh&&(0,b.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,c){c.forEach(o=>{if((0,h.isMenubarMenuItemSeparator)(o))a.append(i());else if((0,h.isMenubarMenuItemSubmenu)(o)){const m=new I.Menu,C=new I.MenuItem({label:this.mnemonicLabel(o.label),submenu:m});this.setMenu(m,o.submenu.items),a.append(C)}else(0,h.isMenubarMenuItemRecentAction)(o)?a.append(this.createOpenRecentMenuItem(o)):(0,h.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[o.id]?a.append(new I.MenuItem(this.likeAction(o.id,{label:this.mnemonicLabel(o.label),click:this.fallbackMenuHandlers[o.id]}))):a.append(this.createMenuItem(o.label,o.id,!1,o.checked)):a.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)):a.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)))})}setMenuById(a,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(a,this.menubarMenus[c].items)}insertCheckForUpdatesItems(a){const c=this.getUpdateMenuItems();c.length&&(c.forEach(o=>a.append(o)),a.append(i()))}createOpenRecentMenuItem(a){const c=k.URI.revive(a.uri),o=a.id,m=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new I.MenuItem(this.likeAction(o,{label:a.label,click:async(C,R,T)=>{const U=this.isOptionClick(T);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[m],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(a){return!!(a&&(!M.isMacintosh&&(a.ctrlKey||a.shiftKey)||M.isMacintosh&&(a.metaKey||a.altKey)))}isKeyboardEvent(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}createRoleMenuItem(a,c,o){const m={label:this.mnemonicLabel(a),role:o,enabled:!0};return new I.MenuItem(this.withKeybinding(c,m))}setMacWindowMenu(a){const c=new I.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),o=new I.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),m=new I.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),C=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(i()),R.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,i(),C,...R,i(),m].forEach(T=>a.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,c,o,m){const C=this.mnemonicLabel(a),R=typeof c=="function"?c:(ie,oe,ae)=>{const he=ie?ie.userSettingsLabel:null;let ce=c;Array.isArray(c)&&(ce=this.isOptionClick(ae)?c[1]:c[0]),he&&ae.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:ce})},T=typeof o=="boolean"?o:this.windowsMainService.getWindowCount()>0,U=typeof m=="boolean"?m:!1,$={label:C,click:R,enabled:T};U&&($.type="checkbox",$.checked=U);let q;return typeof c=="string"?q=c:Array.isArray(c)&&(q=c[0]),M.isMacintosh&&(q==="editor.action.clipboardCutAction"?$.role="cut":q==="editor.action.clipboardCopyAction"?$.role="copy":q==="editor.action.clipboardPasteAction"&&($.role="paste"),q==="undo"?$.click=this.makeContextAwareClickHandler(R,{inDevTools:ie=>ie.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?$.click=this.makeContextAwareClickHandler(R,{inDevTools:ie=>ie.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(R,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(q,$))}makeContextAwareClickHandler(a,c){return(o,m,C)=>{const R=I.BrowserWindow.getFocusedWindow();if(!R)return c.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return c.inDevTools(R.webContents.devToolsWebContents);a(o,m||R,C)}}runActionInRenderer(a){let c=I.BrowserWindow.getFocusedWindow();if(!c){const m=this.windowsMainService.getLastActiveWindow();m?.isMinimized()&&(c=m.win)}const o=c?this.windowsMainService.getWindowById(c.id):void 0;if(o){if(this.logService.trace("menubar#runActionInRenderer",a),M.isMacintosh&&!this.environmentMainService.isBuilt&&!o.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const m={id:a.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",r.CancellationToken.None,m)}else{const m={userSettingsLabel:a.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,m)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,c){const o=typeof a=="string"?this.keybindings[a]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const m=c.label.indexOf("[");m>=0?c.label=`${c.label.substr(0,m)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}likeAction(a,c,o=!c.accelerator){o&&(c=this.withKeybinding(a,c));const m=c.click;return c.click=(C,R,T)=>{this.reportMenuActionTelemetry(a),m?.(C,R,T)},c}openUrl(a,c){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:t})}mnemonicLabel(a){return(0,L.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=we([X(0,d.IUpdateService),X(1,u.IConfigurationService),X(2,w.IWindowsMainService),X(3,v.IEnvironmentMainService),X(4,g.ITelemetryService),X(5,D.IWorkspacesHistoryMainService),X(6,s.IStateService),X(7,p.ILifecycleMainService),X(8,y.ILogService),X(9,E.INativeHostMainService),X(10,S.IProductService)],l),e.Menubar=l;function i(){return new I.MenuItem({type:"separator"})}}),define(ee[285],te([0,1,6,20,5,284]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let M=class{constructor(f,u,v){this.instantiationService=f,this.lifecycleMainService=u,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(L.Menubar)}async updateMenubar(f,u){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(u,f)}};M=we([X(0,I.IInstantiationService),X(1,A.ILifecycleMainService),X(2,r.ILogService)],M),e.MenubarMainService=M}),define(ee[286],te([0,1,15,24,27,22,23,3,32,50,45,2,14,9,64,4,36,18,11,8,186,63,19,58,28,16,6,20,5,66,67,57,33,79,283,126,278,29,99,81,54,69,38,53,65,72]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R,T,U,$,q,ie,oe,ae,he,ce,K,Y,x,W,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Q(Z){return(0,oe.isWorkspaceIdentifier)(Z?.workspace)}function ne(Z){return(0,oe.isSingleFolderWorkspaceIdentifier)(Z?.workspace)}let re=class at extends p.Disposable{constructor(_,P,O,F,B,N,z,V,se,de,ye,ke,Ae,_e,Oe,me,pe,De){super(),this.machineId=_,this.initialUserEnv=P,this.logService=O,this.loggerService=F,this.stateService=B,this.policyService=N,this.environmentMainService=z,this.userDataProfilesMainService=V,this.lifecycleMainService=se,this.backupMainService=de,this.configurationService=ye,this.workspacesHistoryMainService=ke,this.workspacesManagementMainService=Ae,this.instantiationService=_e,this.dialogMainService=Oe,this.fileService=me,this.protocolMainService=pe,this.themeMainService=De,this._onDidOpenWindow=this._register(new k.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new k.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new k.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new k.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new k.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(_=>this._onDidSignalReadyWindow.fire(_.window))),this._register(this.onDidSignalReadyWindow(_=>{if(_.config?.extensionDevelopmentPath||_.config?.extensionTestsPath){const P=new p.DisposableStore;if(P.add(k.Event.any(_.onDidClose,_.onDidDestroy)(()=>P.dispose())),_.config.extensionDevelopmentPath)for(const O of _.config.extensionDevelopmentPath)P.add(this.protocolMainService.addValidFileRoot(O));_.config.extensionTestsPath&&P.add(this.protocolMainService.addValidFileRoot(_.config.extensionTestsPath))}}))}openEmptyWindow(_,P){const O=this.environmentMainService.args,F=P?.remoteAuthority||void 0,B=!0,N=P?.forceReuseWindow,z=!N;return this.open({..._,cli:O,forceEmpty:B,forceNewWindow:z,forceReuseWindow:N,remoteAuthority:F})}openExistingWindow(_,P){_.focus(),this.handleWaitMarkerFile(P,[_])}async open(_){this.logService.trace("windowsManager#open"),_.addMode&&(_.initialStartup||!this.getLastActiveWindow())&&(_.addMode=!1);const P=[],O=[],F=[],B=[],N=[];let z,V=0;const se=await this.getPathsToOpen(_);this.logService.trace("windowsManager#open pathsToOpen",se);for(const _e of se)ne(_e)?_.addMode?P.push(_e):O.push(_e):Q(_e)?F.push(_e):_e.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:_e.remoteAuthority}),z.filesToOpenOrCreate.push(_e)):_e.backupPath?N.push({backupFolder:(0,h.basename)(_e.backupPath),remoteAuthority:_e.remoteAuthority}):V++;_.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),_.mergeMode&&z&&z.filesToOpenOrCreate.length===4&&(z.filesToMerge=z.filesToOpenOrCreate.slice(0,4),z.filesToOpenOrCreate=[],z.filesToDiff=[]),z&&_.waitMarkerFileURI&&(z.filesToWait={paths:(0,L.coalesce)([...z.filesToDiff,z.filesToMerge[3],...z.filesToOpenOrCreate]),waitMarkerFileUri:_.waitMarkerFileURI}),_.initialStartup?(B.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),F.push(...B),N.push(...this.backupMainService.getEmptyWindowBackups())):N.length=0;const{windows:de,filesOpenedInWindow:ye}=await this.doOpen(_,F,O,N,V,z,P);if(this.logService.trace(`windowsManager#open used window count ${de.length} (workspacesToOpen: ${F.length}, foldersToOpen: ${O.length}, emptyToRestore: ${N.length}, emptyToOpen: ${V})`),de.length>1)if(ye)ye.focus();else{const _e=this.windowsStateHandler.state.lastActiveWindow&&!_.forceEmpty&&!_.cli._.length&&!_.cli["file-uri"]&&!_.cli["folder-uri"]&&!(_.urisToOpen&&_.urisToOpen.length);let Oe=!0,me=!0;if(_e){const pe=de.filter(De=>this.windowsStateHandler.state.lastActiveWindow&&De.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Oe=!1,me=!1)}if(Oe)for(let pe=de.length-1;pe>=0;pe--){const De=de[pe];if(!(De.openedWorkspace&&B.some(J=>De.openedWorkspace&&J.workspace.id===De.openedWorkspace.id)||De.backupPath&&N.some(J=>De.backupPath&&J.backupFolder===(0,h.basename)(De.backupPath)))){De.focus(),me=!1;break}}me&&de[de.length-1].focus()}const ke=z&&z.filesToDiff.length>0,Ae=z&&z.filesToMerge.length>0;if(!de.some(_e=>_e.isExtensionDevelopmentHost)&&!ke&&!Ae&&!_.noRecentEntry){const _e=[];for(const Oe of se)Q(Oe)&&!Oe.transient?_e.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):ne(Oe)?_e.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&_e.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(_e)}return this.handleWaitMarkerFile(_,de),de}handleWaitMarkerFile(_,P){const O=_.waitMarkerFileURI;_.context===0&&O&&P.length===1&&P[0]&&(async()=>{await P[0].whenClosedOrLoaded;try{await this.fileService.del(O)}catch{}})()}async doOpen(_,P,O,F,B,N,z){const V=[];let se;function de(pe,De){V.push(pe),De&&(se=pe,N=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(_);if(!_.initialStartup&&z.length>0){const pe=z[0].remoteAuthority,De=this.getLastActiveWindowForAuthority(pe);De&&de(this.doAddFoldersToExistingWindow(De,z.map(J=>J.workspace.uri)))}const Ae=O.length+P.length+F.length;if(N&&Ae===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],De=this.getWindows().filter(ue=>N&&(0,g.isEqualAuthority)(ue.remoteAuthority,N.remoteAuthority));let J;pe?.fileUri&&!ke&&((_.context===4||_.context===0||_.context===1)&&(J=await(0,q.findWindowOnFile)(De,pe.fileUri,async ue=>ue.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(ue.configPath):void 0)),J||(J=this.doGetLastActiveWindow(De))),J?(0,oe.isWorkspaceIdentifier)(J.openedWorkspace)?P.push({workspace:J.openedWorkspace,remoteAuthority:J.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(J.openedWorkspace)?O.push({workspace:J.openedWorkspace,remoteAuthority:J.remoteAuthority}):de(this.doOpenFilesInExistingWindow(_,J,N),!0):de(await this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:_.forceNewTabbedWindow,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile}),!0)}const _e=(0,L.distinct)(P,pe=>pe.workspace.id);if(_e.length>0){const pe=(0,L.coalesce)(_e.map(De=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),De.workspace.configPath)));if(pe.length>0){const De=pe[0],J=(0,g.isEqualAuthority)(N?.remoteAuthority,De.remoteAuthority)?N:void 0;de(this.doOpenFilesInExistingWindow(_,De,J),!!J),ye=!0}for(const De of _e){if(pe.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===De.workspace.id))continue;const J=De.remoteAuthority,ue=(0,g.isEqualAuthority)(N?.remoteAuthority,J)?N:void 0;de(await this.doOpenFolderOrWorkspace(_,De,ye,ue),!!ue),ye=!0}}const Oe=(0,L.distinct)(O,pe=>g.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Oe.length>0){const pe=(0,L.coalesce)(Oe.map(De=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),De.workspace.uri)));if(pe.length>0){const De=pe[0],J=(0,g.isEqualAuthority)(N?.remoteAuthority,De.remoteAuthority)?N:void 0;de(this.doOpenFilesInExistingWindow(_,De,J),!!J),ye=!0}for(const De of Oe){if(pe.some(fe=>(0,oe.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,De.workspace.uri)))continue;const J=De.remoteAuthority,ue=(0,g.isEqualAuthority)(N?.remoteAuthority,J)?N:void 0;de(await this.doOpenFolderOrWorkspace(_,De,ye,ue),!!ue),ye=!0}}const me=(0,L.distinct)(F,pe=>pe.backupFolder);if(me.length>0)for(const pe of me){const De=pe.remoteAuthority,J=(0,g.isEqualAuthority)(N?.remoteAuthority,De)?N:void 0;de(await this.doOpenEmpty(_,!0,De,J,pe),!!J),ye=!0}if(V.length===0||N){N&&!B&&B++;const pe=N?N.remoteAuthority:_.remoteAuthority;for(let De=0;De<B;De++)de(await this.doOpenEmpty(_,ye,pe,N),!!N),ye=!0}return{windows:(0,L.distinct)(V),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(_,P,O){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:O}),P.focus();const F={filesToOpenOrCreate:O?.filesToOpenOrCreate,filesToDiff:O?.filesToDiff,filesToMerge:O?.filesToMerge,filesToWait:O?.filesToWait,termProgram:_?.userEnv?.TERM_PROGRAM};return P.sendWhenReady("vscode:openFiles",M.CancellationToken.None,F),P}doAddFoldersToExistingWindow(_,P){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:P}),_.focus();const O={foldersToAdd:P};return _.sendWhenReady("vscode:addFolders",M.CancellationToken.None,O),_}doOpenEmpty(_,P,O,F,B){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:O,filesToOpen:F,forceNewWindow:P});let N;return!P&&typeof _.contextWindowId=="number"&&(N=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:O,forceNewWindow:P,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:F,windowToUse:N,emptyWindowBackupInfo:B,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}doOpenFolderOrWorkspace(_,P,O,F,B){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:P,filesToOpen:F}),!O&&!B&&typeof _.contextWindowId=="number"&&(B=this.getWindowById(_.contextWindowId)),this.openInBrowserWindow({workspace:P.workspace,userEnv:_.userEnv,cli:_.cli,initialStartup:_.initialStartup,remoteAuthority:P.remoteAuthority,forceNewWindow:O,forceNewTabbedWindow:_.forceNewTabbedWindow,filesToOpen:F,windowToUse:B,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}async getPathsToOpen(_){let P,O=!1,F=!1;if(_.urisToOpen&&_.urisToOpen.length>0?(P=await this.doExtractPathsFromAPI(_),O=!0):_.forceEmpty?P=[Object.create(null)]:_.cli._.length||_.cli["folder-uri"]||_.cli["file-uri"]?(P=await this.doExtractPathsFromCLI(_.cli),P.length===0&&P.push(Object.create(null)),O=!0):(P=await this.doGetPathsFromLastSession(),P.length===0&&P.push(Object.create(null)),F=!0),!_.addMode&&O){const B=P.filter(N=>ne(N));if(B.length>1){const N=B[0].remoteAuthority;if(B.every(z=>(0,g.isEqualAuthority)(z.remoteAuthority,N))){const z=await this.workspacesManagementMainService.createUntitledWorkspace(B.map(V=>({uri:V.workspace.uri})));P.push({workspace:z,remoteAuthority:N}),P=P.filter(V=>!ne(V))}}}if(_.initialStartup&&!F&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const B=await this.doGetPathsFromLastSession();P.unshift(...B.filter(N=>Q(N)||ne(N)||N.backupPath))}return P}async doExtractPathsFromAPI(_){const P={gotoLineMode:_.gotoLineMode,remoteAuthority:_.remoteAuthority},O=await Promise.all((0,L.coalesce)(_.urisToOpen||[]).map(async F=>{const B=await this.resolveOpenable(F,P);if(B)return B.label=F.label,B;const N=this.resourceFromOpenable(F);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:N.scheme===y.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:N.scheme===y.Schemas.file?(0,w.localize)(3,null,(0,v.getPathLabel)(N,{os:S.OS,tildify:this.environmentMainService})):(0,w.localize)(4,null,N.toString(!0))},(0,d.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,L.coalesce)(O)}async doExtractPathsFromCLI(_){const P=[],O={ignoreFileNotFound:!0,gotoLineMode:_.goto,remoteAuthority:_.remote||void 0,forceOpenWorkspaceAsFile:_.diff&&_._.length===2||_.merge&&_._.length===4},F=_["folder-uri"];if(F){const z=await Promise.all(F.map(V=>{const se=this.cliArgToUri(V);if(!!se)return this.resolveOpenable({folderUri:se},O)}));P.push(...(0,L.coalesce)(z))}const B=_["file-uri"];if(B){const z=await Promise.all(B.map(V=>{const se=this.cliArgToUri(V);if(!!se)return this.resolveOpenable((0,oe.hasWorkspaceFileExtension)(V)?{workspaceUri:se}:{fileUri:se},O)}));P.push(...(0,L.coalesce)(z))}const N=await Promise.all(_._.map(z=>O.remoteAuthority?this.doResolveRemotePath(z,O):this.doResolveFilePath(z,O)));return P.push(...(0,L.coalesce)(N)),P}cliArgToUri(_){try{const P=b.URI.parse(_);if(!P.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${_}`);return}return P}catch(P){this.logService.error(`Invalid URI input string: ${_}, ${P.message}`)}}async doGetPathsFromLastSession(){const _=this.getRestoreWindowsSetting();switch(_){case"none":return[];case"one":case"all":case"preserve":case"folders":{const P=[];_!=="one"&&P.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&P.push(this.windowsStateHandler.state.lastActiveWindow);const O=await Promise.all(P.map(async F=>{if(F.workspace){const B=await this.resolveOpenable({workspaceUri:F.workspace.configPath},{remoteAuthority:F.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(B))return B}else if(F.folderUri){const B=await this.resolveOpenable({folderUri:F.folderUri},{remoteAuthority:F.remoteAuthority});if(ne(B))return B}else if(_!=="folders"&&F.backupPath)return{backupPath:F.backupPath,remoteAuthority:F.remoteAuthority}}));return(0,L.coalesce)(O)}}}getRestoreWindowsSetting(){let _;return this.lifecycleMainService.wasRestarted?_="all":(_=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(_)||(_="all")),_}async resolveOpenable(_,P=Object.create(null)){const O=this.resourceFromOpenable(_);return O.scheme===y.Schemas.file?((0,U.isFileToOpen)(_)&&(P={...P,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(O.fsPath,P)):this.doResolveRemoteOpenable(_,P)}doResolveRemoteOpenable(_,P){let O=this.resourceFromOpenable(_);const F=(0,R.getRemoteAuthority)(O)||P.remoteAuthority;if(O=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(O)),(0,U.isFileToOpen)(_)){if(P.gotoLineMode){const{path:B,line:N,column:z}=(0,f.parseLineAndColumnAware)(O.path);return{fileUri:O.with({path:B}),options:{selection:N?{startLineNumber:N,startColumn:z||1}:void 0},remoteAuthority:F}}return{fileUri:O,remoteAuthority:F}}else if((0,U.isWorkspaceToOpen)(_))return{workspace:(0,ae.getWorkspaceIdentifier)(O),remoteAuthority:F};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(O),remoteAuthority:F}}resourceFromOpenable(_){return(0,U.isWorkspaceToOpen)(_)?_.workspaceUri:(0,U.isFolderToOpen)(_)?_.folderUri:_.fileUri}async doResolveFilePath(_,P){let O,F;P.gotoLineMode&&({path:_,line:O,column:F}=(0,f.parseLineAndColumnAware)(_)),_=(0,f.sanitizeFilePath)((0,h.normalize)(_),(0,s.cwd)());try{const B=await A.Promises.stat(_);if(B.isFile()){if(!P.forceOpenWorkspaceAsFile){const N=await this.workspacesManagementMainService.resolveLocalWorkspace(b.URI.file(_));if(N)return N.transient&&P.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:n.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:b.URI.file(_),type:n.FileType.File,exists:!0,options:{selection:O?{startLineNumber:O,startColumn:F||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(b.URI.file(_),B),type:n.FileType.Directory,exists:!0};if(!S.isWindows&&_==="/dev/null")return{fileUri:b.URI.file(_),type:n.FileType.File,exists:!0}}}catch{const N=b.URI.file(_);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),P.ignoreFileNotFound)return{fileUri:N,type:n.FileType.File,exists:!1}}}doResolveRemotePath(_,P){const O=_.charCodeAt(0),F=P.remoteAuthority;let B,N;P.gotoLineMode&&({path:_,line:B,column:N}=(0,f.parseLineAndColumnAware)(_)),O!==47&&((0,f.isWindowsDriveLetter)(O)&&_.charCodeAt(_.charCodeAt(1))===58&&(_=(0,f.toSlashes)(_)),_=`/${_}`);const z=b.URI.from({scheme:y.Schemas.vscodeRemote,authority:F,path:_});if(_.charCodeAt(_.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(_))return P.forceOpenWorkspaceAsFile?{fileUri:z,options:{selection:B?{startLineNumber:B,startColumn:N||1}:void 0},remoteAuthority:P.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(z),remoteAuthority:F};if(P.gotoLineMode||h.posix.basename(_).indexOf(".")!==-1)return{fileUri:z,options:{selection:B?{startLineNumber:B,startColumn:N||1}:void 0},remoteAuthority:F}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:F}}shouldOpenNewWindow(_){const P=this.configurationService.getValue("window"),O=P?.openFoldersInNewWindow||"default",F=P?.openFilesInNewWindow||"off";let B=(_.preferNewWindow||_.forceNewWindow)&&!_.forceReuseWindow;!_.forceNewWindow&&!_.forceReuseWindow&&(O==="on"||O==="off")&&(B=O==="on");let N=!1;return _.forceNewWindow||_.forceReuseWindow?N=!!_.forceNewWindow&&!_.forceReuseWindow:(S.isMacintosh?_.context===1&&(N=!0):_.context!==3&&_.context!==2&&!(_.userEnv&&_.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!_.cli.extensionDevelopmentPath&&(F==="on"||F==="off")&&(N=F==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(_,P){const O=(0,q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),_);if(O)return this.lifecycleMainService.reload(O,P.cli),O.focus(),[O];let F=P.cli["folder-uri"]||[],B=P.cli["file-uri"]||[],N=P.cli._;if(!N.length&&!F.length&&!B.length&&!P.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,de=se?.workspace??se?.folderUri;de&&(b.URI.isUri(de)?de.scheme===y.Schemas.file?N=[de.fsPath]:F=[de.toString()]:de.configPath.scheme===y.Schemas.file?N=[(0,g.originalFSPath)(de.configPath)]:B=[de.configPath.toString()])}let z=P.remoteAuthority;for(const se of _)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const de=b.URI.parse(se),ye=(0,R.getRemoteAuthority)(de);ye&&(z?(0,g.isEqualAuthority)(ye,z)||this.logService.error("more than one extension development path authority"):z=ye)}N=N.filter(se=>{const de=b.URI.file(se);return(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:(0,g.isEqualAuthority)((0,R.getRemoteAuthority)(de),z)}),F=F.filter(se=>{const de=this.cliArgToUri(se);return de&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,g.isEqualAuthority)((0,R.getRemoteAuthority)(de),z):!1}),B=B.filter(se=>{const de=this.cliArgToUri(se);return de&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,g.isEqualAuthority)((0,R.getRemoteAuthority)(de),z):!1}),P.cli._=N,P.cli["folder-uri"]=F,P.cli["file-uri"]=B;const V={context:P.context,cli:P.cli,forceNewWindow:!0,forceEmpty:!N.length&&!F.length&&!B.length,userEnv:P.userEnv,noRecentEntry:!0,waitMarkerFileURI:P.waitMarkerFileURI,remoteAuthority:z,forceProfile:P.forceProfile,forceTempProfile:P.forceTempProfile};return this.open(V)}async openInBrowserWindow(_){const P=this.configurationService.getValue("window"),O=this.getLastActiveWindow(),F=O?.profile??this.userDataProfilesMainService.defaultProfile;let B;!_.forceNewWindow&&!_.forceNewTabbedWindow&&(B=_.windowToUse||O,B&&B.focus());let N=!1;H.canUseUtilityProcess&&(typeof P?.experimental?.sharedProcessUseUtilityProcess=="boolean"?N=P.experimental.sharedProcessUseUtilityProcess:N=typeof m.default.quality=="string");const z={...this.environmentMainService.args,..._.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:_.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,_.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:F},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:_.remoteAuthority,workspace:_.workspace,userEnv:{...this.initialUserEnv,..._.userEnv},filesToOpenOrCreate:_.filesToOpen?.filesToOpenOrCreate,filesToDiff:_.filesToOpen?.filesToDiff,filesToMerge:_.filesToOpen?.filesToMerge,filesToWait:_.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.fsPath,product:m.default,isInitialStartup:_.initialStartup,perfMarks:(0,E.getMarks)(),os:{release:(0,r.release)(),hostname:(0,r.hostname)()},zoomLevel:typeof P?.zoomLevel=="number"?P.zoomLevel:void 0,autoDetectHighContrast:P?.autoDetectHighContrast??!0,autoDetectColorScheme:P?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn,preferUtilityProcess:N};if(B){const V=B.config;!z.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=V.extensionDevelopmentPath,z.extensionDevelopmentKind=V.extensionDevelopmentKind,z["enable-proposed-api"]=V["enable-proposed-api"],z.verbose=V.verbose,z["inspect-extensions"]=V["inspect-extensions"],z["inspect-brk-extensions"]=V["inspect-brk-extensions"],z.debugId=V.debugId,z.extensionEnvironment=V.extensionEnvironment,z["extensions-dir"]=V["extensions-dir"],z["disable-extensions"]=V["disable-extensions"]),z.loggers={global:z.loggers.global,window:V?.loggers.window??z.loggers.window}}else{const V=this.windowsStateHandler.getNewWindowState(z);(0,E.mark)("code/willCreateCodeWindow");const se=B=this.instantiationService.createInstance($.CodeWindow,{state:V,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,E.mark)("code/didCreateCodeWindow"),_.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(se),at.WINDOWS.push(se),this._onDidOpenWindow.fire(se),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,u.once)(se.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(se)),(0,u.once)(se.onDidClose)(()=>this.onWindowClosed(se)),(0,u.once)(se.onDidDestroy)(()=>this._onDidDestroyWindow.fire(se)),se.onDidTriggerSystemContextMenu(({x:ye,y:ke})=>this._onDidTriggerSystemContextMenu.fire({window:se,x:ye,y:ke}));const de=(0,d.assertIsDefined)(se.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.lifecycleMainService.reload(se)),this.lifecycleMainService.registerWindow(se)}return z.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(async V=>{V||await this.doOpenInBrowserWindow(B,z,_,F)}):await this.doOpenInBrowserWindow(B,z,_,F),B}async doOpenInBrowserWindow(_,P,O,F){if(P.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(P.workspace)?P.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:P.workspace,remoteAuthority:P.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(P.workspace)?P.backupPath=this.backupMainService.registerFolderBackup({folderUri:P.workspace.uri,remoteAuthority:P.remoteAuthority}):P.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:O.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:P.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const B=P.workspace??(0,oe.toWorkspaceIdentifier)(P.backupPath,!1),N=this.resolveProfileForBrowserWindow(O,B,F),z=N instanceof Promise?await N:N;P.profiles.profile=z,P.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(B,z)}_.load(P)}resolveProfileForBrowserWindow(_,P,O){return _.forceProfile?this.userDataProfilesMainService.profiles.find(F=>F.name===_.forceProfile)??this.userDataProfilesMainService.createNamedProfile(_.forceProfile):_.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(P)??O}onWindowClosed(_){const P=at.WINDOWS.indexOf(_);at.WINDOWS.splice(P,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const _=I.BrowserWindow.getFocusedWindow();if(_)return this.getWindowById(_.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(_){return this.doGetLastActiveWindow(this.getWindows().filter(P=>(0,g.isEqualAuthority)(P.remoteAuthority,_)))}doGetLastActiveWindow(_){const P=Math.max.apply(Math,_.map(O=>O.lastFocusTime));return _.find(O=>O.lastFocusTime===P)}sendToFocused(_,...P){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(_,M.CancellationToken.None,...P)}sendToAll(_,P,O){for(const F of this.getWindows())O&&O.indexOf(F.id)>=0||F.sendWhenReady(_,M.CancellationToken.None,P)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(_){const P=this.getWindows().filter(O=>O.id===_);return(0,L.firstOrDefault)(P)}getWindowByWebContents(_){const P=I.BrowserWindow.fromWebContents(_);if(!!P)return this.getWindowById(P.id)}};re.WINDOWS=[],re=we([X(2,o.ILogService),X(3,W.ILoggerMainService),X(4,T.IStateService),X(5,Y.IPolicyService),X(6,i.IEnvironmentMainService),X(7,x.IUserDataProfilesMainService),X(8,c.ILifecycleMainService),X(9,D.IBackupMainService),X(10,t.IConfigurationService),X(11,he.IWorkspacesHistoryMainService),X(12,ce.IWorkspacesManagementMainService),X(13,a.IInstantiationService),X(14,l.IDialogMainService),X(15,n.IFileService),X(16,C.IProtocolMainService),X(17,K.IThemeMainService)],re),e.WindowsMainService=re}),define(ee[287],te([0,1,63,30,81,54]),function(j,e,I,A,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,u,v,p){this.workspacesManagementMainService=f,this.windowsMainService=u,this.workspacesHistoryMainService=v,this.backupMainService=p,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const v=this.windowsMainService.getWindowById(f);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),u)}createUntitledWorkspace(f,u,v){return this.workspacesManagementMainService.createUntitledWorkspace(u,v)}deleteUntitledWorkspace(f,u){return this.workspacesManagementMainService.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.workspacesManagementMainService.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(f,u){return this.workspacesHistoryMainService.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.workspacesHistoryMainService.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=we([X(0,L.IWorkspacesManagementMainService),X(1,A.IWindowsMainService),X(2,r.IWorkspacesHistoryMainService),X(3,I.IBackupMainService)],M),e.WorkspacesMainService=M}),define(ee[288],te([0,1,15,42,27,17,44,13,32,50,43,45,2,14,9,4,11,8,31,142,47,156,106,261,159,63,279,19,77,195,89,127,58,111,215,28,62,117,205,229,206,265,113,207,208,16,219,92,76,6,91,280,242,263,20,5,285,59,21,57,273,93,33,269,97,94,25,244,120,48,49,251,252,281,253,282,123,255,256,257,259,267,30,286,268,29,98,81,287,54,262,38,227,53,238,52,80,125,271,277,275,7,121,270,222,65,90,266,258,22]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R,T,U,$,q,ie,oe,ae,he,ce,K,Y,x,W,H,Q,ne,re,Z,_,P,O,F,B,N,z,V,se,de,ye,ke,Ae,_e,Oe,me,pe,De,J,ue,fe,Ee,Le,Te,We,qe,Ue,Ne,He,G,le,ge,Se,ve,Re,Fe,xe,Ve,Ge,Qe,Je,st,ct,gt,Dt,Mt,Rt,Lt,At,_t,Tt,mt,Ot,Wt,Ft,Ut,Nt,pt,Bt,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let vt=class extends y.Disposable{constructor(Ce,Ie,be,Pe,Me,$e,Ke,Xe,ze,Be,je){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=Ie,this.mainInstantiationService=be,this.logService=Pe,this.environmentMainService=Me,this.lifecycleMainService=$e,this.configurationService=Ke,this.stateService=Xe,this.fileService=ze,this.productService=Be,this.userDataProfilesMainService=je,this.configureSession(),this.registerListeners()}configureSession(){const Ce=ze=>ze?.startsWith(`${h.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((ze,Be,je,Ye)=>Ce(Ye.requestingUrl)?je(Ie.has(Be)):je(!1)),I.session.defaultSession.setPermissionCheckHandler((ze,Be,je,Ye)=>Ce(Ye.requestingUrl)?Ie.has(Be):!1);const be=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Pe=ze=>{for(let Be=ze;Be;Be=Be.parent)if(Be.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Me=ze=>ze.resourceType==="xhr"||Pe(ze.frame),$e=ze=>{const Be=ze.frame;if(!Be||!this.windowsMainService)return!1;const je=I.BrowserWindow.getAllWindows();for(const Ye of je)if(Be.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ke=(ze,Be)=>{if(ze.path!=="/index.html")return!0;const je=Be.frame;if(!je||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((ze,Be)=>{const je=g.URI.parse(ze.url);return je.scheme===h.Schemas.vscodeWebview&&!Ke(je,ze)?(this.logService.error("Blocked vscode-webview request",ze.url),Be({cancel:!0})):je.scheme===h.Schemas.vscodeFileResource&&!$e(ze)?(this.logService.error("Blocked vscode-file request",ze.url),Be({cancel:!0})):je.path.endsWith(".svg")&&!be.has(je.scheme)?Be({cancel:!Me(ze)}):Be({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((ze,Be)=>{const je=ze.responseHeaders,Ye=je["content-type"]||je["Content-Type"];if(Ye&&Array.isArray(Ye)){const Ze=g.URI.parse(ze.url);if(Ze.path.endsWith(".svg")&&be.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],Be({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ye.some(nt=>nt.toLowerCase().includes("image/svg")))return Be({cancel:!Me(ze)})}return Be({cancel:!1})});const Xe=I.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Xe.setCodeCachePath((0,E.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,k.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,k.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,k.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,b.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(be,Pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),I.app.on("activate",async(be,Pe)=>{this.logService.trace("app#activate"),Pe||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(be,Pe)=>{Pe.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),Pe.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let Ce=[],Ie;I.app.on("open-file",(be,Pe)=>{this.logService.trace("app#open-file: ",Pe),be.preventDefault(),Ce.push((0,Fe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:g.URI.file(Pe)}:{fileUri:g.URI.file(Pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),A.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const Pe=this.windowsMainService?.getWindowByWebContents(be.sender);let Me,$e;return Pe?.config?(Me=Pe.config,$e={...process.env,...Pe.config.userEnv}):(Me=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Me,$e,!1)}),A.validatedIpcMain.handle("vscode:writeNlsFile",(be,Pe,Me)=>{const $e=this.validateNlsPath([Pe]);if(!$e||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,L.VSBuffer.fromString(Me))}),A.validatedIpcMain.handle("vscode:readNlsFile",async(be,...Pe)=>{const Me=this.validateNlsPath(Pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),A.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),A.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),A.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(Ce){let Ie;for(const be of Ce)typeof be=="string"&&(typeof Ie!="string"?Ie=be:Ie=(0,E.join)(Ie,be));if(!(typeof Ie!="string"||!(0,E.isAbsolute)(Ie)||!(0,f.isEqualOrParent)(Ie,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return g.URI.file(Ie)}onUnexpectedError(Ce){if(Ce){const Ie={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;S.isWindows&&Ce&&I.app.setAppUserModelId(Ce);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.logService.error(Be)}const Ie=new D.Server;this.lifecycleMainService.onWillShutdown(Be=>{Be.reason===2&&Ie.dispose()}),this.logService.trace("Resolving machine identifier...");const be=await(0,Ot.resolveMachineId)(this.stateService,this.logService);this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Pe,sharedProcessReady:Me,sharedProcessClient:$e}=this.setupSharedProcess(be),Ke=await this.initServices(be,Pe,Me);this._register(Ke.createInstance(l.ProxyAuthHandler)),this._register(Ke.createInstance(_t.UserDataProfilesHandler)),Ke.invokeFunction(Be=>this.initChannels(Be,Ie,$e));const Xe=Ke.invokeFunction(Be=>this.setupProtocolUrlHandlers(Be,Ie));this.lifecycleMainService.phase=2,await Ke.invokeFunction(Be=>this.openFirstWindow(Be,Xe)),this.lifecycleMainService.phase=3,Ke.invokeFunction(Be=>this.afterWindowOpen(Be,Pe)),this._register(new mt.RunOnceScheduler(()=>{this._register((0,mt.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setupProtocolUrlHandlers(Ce,Ie){const be=this.windowsMainService=Ce.get(Se.IWindowsMainService),Pe=Ce.get(Ue.IURLService),Me=this.nativeHostMainService=Ce.get(V.INativeHostMainService),$e=this;Pe.registerHandler({async handleURL(Ye,Ze){return $e.handleProtocolUrl(be,Pe,Ye,Ze)}});const Ke=this._register(new Re.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Xe=new w.StaticRouter(Ye=>Ke.getActiveClientId().then(Ze=>Ye===Ze)),ze=new Ne.URLHandlerRouter(Xe,this.logService),Be=Ie.getChannel("urlHandler",ze);Pe.registerHandler(new Ne.URLHandlerChannelClient(Be));const je=this.resolveInitialProtocolUrls();return this._register(new G.ElectronURLListener(je?.urls,Pe,be,this.environmentMainService,this.productService,this.logService)),je}resolveInitialProtocolUrls(){const Ce=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ce.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),Ce.length+Ie.length===0)return;const be=[];return{urls:[...Ce,...Ie].map(Me=>{try{return{uri:g.URI.parse(Me),originalUrl:Me}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Me);return}}).filter(Me=>{if(!Me)return!1;if(this.shouldBlockURI(Me.uri))return this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Me.uri.toString(!0)),!1;const $e=this.getWindowOpenableFromProtocolUrl(Me.uri);return $e?(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Me.uri.toString(!0),$e),be.push($e),!1):(this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Me.uri.toString(!0)),!0)}),openables:be}}shouldBlockURI(Ce){if(Ce.authority===h.Schemas.file&&S.isWindows){const{options:Ie,buttonIndeces:be}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.getPathLabel)(Ce,{os:S.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null)},this.productService);if(be[I.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}getWindowOpenableFromProtocolUrl(Ce){if(!!Ce.path){if(Ce.authority===h.Schemas.file){const Ie=g.URI.file(Ce.fsPath);return(0,Fe.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Ce.authority===h.Schemas.vscodeRemote){const Ie=Ce.path.indexOf(E.posix.sep,1);if(Ie!==-1){const be=Ce.path.substring(1,Ie),Pe=Ce.path.substring(Ie),Me=g.URI.from({scheme:h.Schemas.vscodeRemote,authority:be,path:Pe,query:Ce.query,fragment:Ce.fragment});return(0,Fe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Me}:/:[\d]+$/.test(Pe)?{fileUri:Me}:{folderUri:Me}}}}}async handleProtocolUrl(Ce,Ie,be,Pe){if(this.logService.trace("app#handleProtocolUrl():",be.toString(!0),Pe),be.scheme===this.productService.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:g.URI.parse(be.query).path,query:""})),this.shouldBlockURI(be))return this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let Me=!1;const $e=new URLSearchParams(be.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),$e.delete("windowId"),be=be.with({query:$e.toString()}),Me=!0):S.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),Me=!0);const Ke=$e.get("continueOn");Ke!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),$e.delete("continueOn"),be=be.with({query:$e.toString()}),this.environmentMainService.continueOn=Ke??void 0);const Xe=this.getWindowOpenableFromProtocolUrl(be);return Xe?(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,be.toString(!0)),(0,bt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Xe],forceNewWindow:Me,gotoLineMode:!0}))?.focus(),!0):Me?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,bt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(be)}))?.ready(),Ie.open(be,Pe)):(this.logService.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Pe),!1)}setupSharedProcess(Ce){const Ie=this._register(this.mainInstantiationService.createInstance(ye.SharedProcess,Ce,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Ie.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new t.Client(Me,"main")})(),Pe=(async()=>(await Ie.whenReady(),be))();return{sharedProcess:Ie,sharedProcessReady:Pe,sharedProcessClient:be}}async initServices(Ce,Ie,be){const Pe=new _.ServiceCollection;switch(process.platform){case"win32":Pe.set(fe.IUpdateService,new re.SyncDescriptor(qe.Win32UpdateService));break;case"linux":S.isLinuxSnap?Pe.set(fe.IUpdateService,new re.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(fe.IUpdateService,new re.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Pe.set(fe.IUpdateService,new re.SyncDescriptor(Le.DarwinUpdateService));break}Pe.set(Se.IWindowsMainService,new re.SyncDescriptor(ve.WindowsMainService,[Ce,this.userEnv],!1));const Me=new T.DialogMainService(this.logService,this.productService);Pe.set(T.IDialogMainService,Me),Pe.set(F.ILaunchMainService,new re.SyncDescriptor(F.LaunchMainService,void 0,!1)),Pe.set(R.IDiagnosticsMainService,new re.SyncDescriptor(R.DiagnosticsMainService,void 0,!1)),Pe.set(C.IDiagnosticsService,w.ProxyChannel.toService((0,w.getDelayedChannel)(be.then(Xe=>Xe.getChannel("diagnostics"))))),Pe.set(P.IIssueMainService,new re.SyncDescriptor(P.IssueMainService,[this.userEnv])),Pe.set(U.IEncryptionMainService,new re.SyncDescriptor($.EncryptionMainService,[Ce])),Pe.set(O.IKeyboardLayoutMainService,new re.SyncDescriptor(O.KeyboardLayoutMainService)),Pe.set(V.INativeHostMainService,new re.SyncDescriptor(V.NativeHostMainService,[Ie],!1)),Pe.set(o.ICredentialsMainService,new re.SyncDescriptor(Je.CredentialsNativeMainService)),Pe.set(le.IWebviewManagerService,new re.SyncDescriptor(ge.WebviewMainService)),Pe.set(z.IMenubarMainService,new re.SyncDescriptor(z.MenubarMainService)),Pe.set(ae.IExtensionUrlTrustService,new re.SyncDescriptor(he.ExtensionUrlTrustService)),Pe.set(ce.IExtensionHostStarter,new re.SyncDescriptor(K.ExtensionHostStarter)),Pe.set(Oe.IStorageMainService,new re.SyncDescriptor(Oe.StorageMainService)),Pe.set(Oe.IApplicationStorageMainService,new re.SyncDescriptor(Oe.ApplicationStorageMainService)),S.isWindows?Pe.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(x.WindowsExternalTerminalService)):S.isMacintosh?Pe.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(x.MacExternalTerminalService)):S.isLinux&&Pe.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(x.LinuxExternalTerminalService));const $e=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Pe.set(n.IBackupMainService,$e);const Ke=new Qe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Me);if(Pe.set(Qe.IWorkspacesManagementMainService,Ke),Pe.set(xe.IWorkspacesService,new re.SyncDescriptor(Ge.WorkspacesMainService,void 0,!1)),Pe.set(Ve.IWorkspacesHistoryMainService,new re.SyncDescriptor(Ve.WorkspacesHistoryMainService,void 0,!1)),Pe.set(Ue.IURLService,new re.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.productService,this.environmentMainService)){const Xe=(0,ue.isInternalTelemetry)(this.productService,this.configurationService),ze=(0,w.getDelayedChannel)(be.then(nt=>nt.getChannel("telemetryAppender"))),Be=new De.TelemetryAppenderClient(ze),je=(0,me.resolveCommonProperties)((0,r.release)(),(0,r.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,Xe),Ye=(0,ue.getPiiPathsFromEnvironment)(this.environmentMainService),Ze={appenders:[Be],commonProperties:je,piiPaths:Ye,sendErrorTelemetry:!0};Pe.set(pe.ITelemetryService,new re.SyncDescriptor(J.TelemetryService,[Ze],!1))}else Pe.set(pe.ITelemetryService,ue.NullTelemetryService);return Pe.set(Rt.IExtensionsProfileScannerService,new re.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Pe.set(Lt.IExtensionsScannerService,new re.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Pe.set(pt.IUtilityProcessWorkerMainService,new re.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([$e.initialize(),Ke.initialize()]),this.mainInstantiationService.createChild(Pe)}initChannels(Ce,Ie,be){const Pe=w.ProxyChannel.fromService(Ce.get(F.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const Me=w.ProxyChannel.fromService(Ce.get(R.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const $e=new ct.PolicyChannel(Ce.get(st.IPolicyService));Ie.registerChannel("policy",$e),be.then(et=>et.registerChannel("policy",$e));const Ke=this.fileService.getProvider(h.Schemas.file);(0,s.assertType)(Ke instanceof ne.DiskFileSystemProvider);const Xe=new Q.DiskFileSystemProviderChannel(Ke,this.logService,this.environmentMainService);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe),be.then(et=>et.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Xe));const ze=w.ProxyChannel.fromService(Ce.get(gt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",ze),be.then(et=>et.registerChannel("userDataProfiles",ze));const Be=new Dt.RequestChannel(Ce.get(Mt.IRequestService));be.then(et=>et.registerChannel("request",Be));const je=new Ee.UpdateChannel(Ce.get(fe.IUpdateService));Ie.registerChannel("update",je);const Ye=w.ProxyChannel.fromService(Ce.get(P.IIssueMainService));Ie.registerChannel("issue",Ye);const Ze=w.ProxyChannel.fromService(Ce.get(U.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const nt=w.ProxyChannel.fromService(Ce.get(o.ICredentialsMainService));Ie.registerChannel("credentials",nt);const it=w.ProxyChannel.fromService(Ce.get(ke.ISignService));Ie.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(Ce.get(O.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",lt),this.nativeHostMainService=Ce.get(V.INativeHostMainService);const Et=w.ProxyChannel.fromService(this.nativeHostMainService);Ie.registerChannel("nativeHost",Et),be.then(et=>et.registerChannel("nativeHost",Et));const $t=w.ProxyChannel.fromService(Ce.get(xe.IWorkspacesService));Ie.registerChannel("workspaces",$t);const zt=w.ProxyChannel.fromService(Ce.get(z.IMenubarMainService));Ie.registerChannel("menubar",zt);const qt=w.ProxyChannel.fromService(Ce.get(Ue.IURLService));Ie.registerChannel("url",qt);const xt=w.ProxyChannel.fromService(Ce.get(ae.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",xt);const Ht=w.ProxyChannel.fromService(Ce.get(le.IWebviewManagerService));Ie.registerChannel("webview",Ht);const It=this._register(new _e.StorageDatabaseChannel(this.logService,Ce.get(Oe.IStorageMainService)));Ie.registerChannel("storage",It),be.then(et=>et.registerChannel("storage",It));const jt=this._register(new Tt.ProfileStorageChangesListenerChannel(Ce.get(Oe.IStorageMainService),Ce.get(gt.IUserDataProfilesMainService),this.logService));be.then(et=>et.registerChannel("profileStorageListener",jt));const Vt=w.ProxyChannel.fromService(Ce.get(Y.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Vt);const Pt=new Ft.LoggerChannel(Ce.get(Ut.ILoggerMainService));Ie.registerChannel("logger",Pt),be.then(et=>et.registerChannel("logger",Pt));const Gt=new m.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Se.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Gt);const Kt=w.ProxyChannel.fromService(Ce.get(ce.IExtensionHostStarter));Ie.registerChannel(ce.ipcExtensionHostStarterChannelName,Kt);const Yt=w.ProxyChannel.fromService(Ce.get(pt.IUtilityProcessWorkerMainService));Ie.registerChannel(Bt.ipcUtilityProcessWorkerChannelName,Yt)}async openFirstWindow(Ce,Ie){const be=this.windowsMainService=Ce.get(Se.IWindowsMainService),Pe=(0,ie.isLaunchedFromCli)(process.env)?0:4,Me=this.environmentMainService.args;if(Ie){if(Ie.openables.length>0)return be.open({context:Pe,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const it of Ie.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),be.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Ke=Me._.length,Xe=!!Me["folder-uri"],ze=!!Me["file-uri"],Be=Me["skip-add-to-recently-opened"]===!0,je=Me.wait&&Me.waitMarkerFilePath?g.URI.file(Me.waitMarkerFilePath):void 0,Ye=Me.remote||void 0,Ze=Me.profile,nt=Me["profile-temp"];if(!Ke&&!Xe&&!ze){if(Me["new-window"]||Ze||nt)return be.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Ye,forceProfile:Ze,forceTempProfile:nt});if($e.length)return be.open({context:1,cli:Me,urisToOpen:$e.map(it=>(0,Fe.hasWorkspaceFileExtension)(it)?{workspaceUri:g.URI.file(it)}:{fileUri:g.URI.file(it)}),noRecentEntry:Be,waitMarkerFileURI:je,initialStartup:!0})}return be.open({context:Pe,cli:Me,forceNewWindow:Me["new-window"]||!Ke&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:Be,waitMarkerFileURI:je,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:Ze,forceTempProfile:nt})}afterWindowOpen(Ce,Ie){const be=Ce.get(pe.ITelemetryService);this.handleSharedProcessErrors(be,Ie),this.installMutex(),I.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Pe,Me)=>{Me({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ce=this.productService.win32MutexName;if(S.isWindows&&Ce)try{const Ie=await new Promise((Pe,Me)=>{j(["windows-mutex"],Pe,Me)}),be=new Ie.Mutex(Ce);(0,u.once)(this.lifecycleMainService.onWillShutdown)(()=>be.release())}catch(Ie){this.logService.error(Ie)}}handleSharedProcessErrors(Ce,Ie){let be=!1;(0,u.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0),this._register(Ie.onDidError(({type:Pe,details:Me})=>{switch(Pe){case 2:this.logService.error(`[SharedProcess] renderer process gone (reason: ${Me?.reason||"<unknown>"}, code: ${Me?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("[SharedProcess]  detected unresponsive");break;case 3:this.logService.error(`[SharedProcess]  failed to load (reason: ${Me?.reason||"<unknown>"}, code: ${Me?.exitCode||"<unknown>"})`);break}Ce.publicLog2("sharedprocesserror",{type:Pe,reason:Me?.reason,code:Me?.exitCode,visible:Ie.isVisible(),utilityprocess:Ie.usingUtilityProcess()?"1":"0",shuttingdown:be})}))}async resolveShellEnvironment(Ce,Ie,be){try{return await(0,oe.getResolvedShellEnv)(this.configurationService,this.logService,Ce,Ie)}catch(Pe){const Me=(0,M.toErrorMessage)(Pe);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}async updateCrashReporterEnablement(){try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),be=JSON.parse((0,v.stripComments)(Ie)),Me=(0,ue.getTelemetryLevel)(this.configurationService)>=1;if(be["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],Ke=Ie.substring(0,Ie.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,L.VSBuffer.fromString(Ke))}else{const $e=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);$e!==Ie&&await this.fileService.writeFile(this.environmentMainService.argvResource,L.VSBuffer.fromString($e))}}catch(Ce){this.logService.error(Ce)}}};vt=we([X(2,Z.IInstantiationService),X(3,N.ILogService),X(4,q.IEnvironmentMainService),X(5,B.ILifecycleMainService),X(6,c.IConfigurationService),X(7,Ae.IStateService),X(8,H.IFileService),X(9,se.IProductService),X(10,gt.IUserDataProfilesMainService)],vt),e.CodeApplication=vt}),define(ee[289],te([0,1,240,7,17,13,11,19,34,117,5,52,239,296]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let E=class extends p.AbstractRequestService{constructor(d,b,w,D){super(!!b.isRemoteServer,D),this.configurationService=d,this.environmentService=b,this.logService=w,this.configure(),this._register(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,b){const{proxyUrl:w,strictSSL:D}=this;let t;try{t=await(0,u.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,L.getErrorMessage)(n)))}const l={...process.env,...t},i=d.agent?d.agent:await(0,y.getProxyAgent)(d.url||"",l,{proxyUrl:w,strictSSL:D});return d.agent=i,d.strictSSL=D,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>s(d,b))}async resolveProxy(d){}};E=we([X(0,k.IConfigurationService),X(1,f.INativeEnvironmentService),X(2,v.ILogService),X(3,v.ILoggerService)],E),e.RequestService=E;async function S(g){return((0,I.parse)(g.url).protocol==="https:"?await new Promise((w,D)=>{j(["https"],w,D)}):await new Promise((w,D)=>{j(["http"],w,D)})).request}async function s(g,d){return A.Promises.withAsyncBody(async(b,w)=>{const D=(0,I.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await S(g),l={hostname:D.hostname,port:D.port?parseInt(D.port):D.protocol==="https:"?443:80,protocol:D.protocol,path:D.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const i=t(l,n=>{const a=(0,M.isNumber)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)s({...g,url:n.headers.location,followRedirects:a-1},d).then(b,w);else{let c=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,h.createGunzip)())),b({res:n,stream:(0,r.streamToBufferReadableStream)(c)})}});i.on("error",w),g.timeout&&i.setTimeout(g.timeout),g.isChromiumNetwork&&i.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&i.write(g.data),i.end(),d.onCancellationRequested(()=>{i.abort(),w(new L.CancellationError)})})}e.nodeRequest=s}),define(ee[290],te([0,1,15,289]),function(j,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return I.net.request}class L extends A.RequestService{request(k,f){return super.request({...k||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.RequestMainService=L}),define(ee[297],te([0,1,15,41,8,22,7,44,13,32,50,45,14,9,64,4,36,26,24,47,88,288,10,19,233,243,28,62,197,16,217,92,76,213,91,20,220,5,66,21,67,272,122,249,52,290,93,241,33,48,69,53,38,228,226,2,39,254,65,221,90,118,250]),function(j,e,I,A,r,L,M,k,f,u,v,p,y,h,E,S,s,g,d,b,w,D,t,l,i,n,a,c,o,m,C,R,T,U,$,q,ie,oe,ae,he,ce,K,Y,x,W,H,Q,ne,re,Z,_,P,O,F,B,N,z,V,se,de,ye,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.startup()}catch(me){console.error(me.message),I.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,pe,De,J,ue,fe,Ee,Le]=this.createServices();try{try{await this.initServices(De,Le,J,ue,Ee)}catch(Te){throw this.handleStartupDataDirError(De,Ee,Te),Te}await me.invokeFunction(async Te=>{const We=Te.get(oe.ILogService),qe=Te.get(q.ILifecycleMainService),Ue=Te.get(m.IFileService),Ne=Te.get(oe.ILoggerService),He=await this.claimInstance(We,De,qe,me,Ee,!0);return d.Promises.writeFile(De.mainLockfile,String(process.pid)).catch(G=>{We.warn(`app#startup(): Error writing main lockfile: ${G.stack}`)}),fe.logger=Ne.createLogger("main",{name:(0,t.localize)(0,null)}),(0,v.once)(qe.onWillShutdown)(G=>{Ue.dispose(),J.dispose(),G.join("instanceLockfile",d.Promises.unlink(De.mainLockfile).catch(()=>{}))}),me.createInstance(D.CodeApplication,He,pe).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new $.ServiceCollection,pe=new N.DisposableStore;process.once("exit",()=>pe.dispose());const De={_serviceBrand:void 0,...ae.default};me.set(he.IProductService,De);const J=new a.EnvironmentMainService(this.resolveArgs(),De),ue=this.patchEnvironment(J);me.set(a.IEnvironmentMainService,J);const fe=new se.LoggerMainService((0,oe.getLogLevel)(J),J.logsHome);me.set(se.ILoggerMainService,fe);const Ee=new ie.BufferLogger(fe.getLogLevel()),Le=pe.add(new de.LogService(Ee,[new oe.ConsoleMainLogger(fe.getLogLevel())]));me.set(oe.ILogService,Le);const Te=new C.FileService(Le);me.set(m.IFileService,Te);const We=new R.DiskFileSystemProvider(Le);Te.registerProvider(y.Schemas.file,We);const qe=new V.UriIdentityService(Te);me.set(z.IUriIdentityService,qe);const Ue=new ke.StateService(1,J,Le,Te);me.set(re.IStateReadService,Ue),me.set(re.IStateService,Ue);const Ne=new P.UserDataProfilesMainService(Ue,qe,J,Te,Le);me.set(P.IUserDataProfilesMainService,Ne);const He=S.isWindows&&De.win32RegValueName?pe.add(new F.NativePolicyService(Le,De.win32RegValueName)):J.policyFile?pe.add(new B.FilePolicyService(J.policyFile,Te,Le)):new O.NullPolicyService;me.set(O.IPolicyService,He);const G=new i.ConfigurationService(Ne.defaultProfile.settingsResource,Te,He,Le);return me.set(l.IConfigurationService,G),me.set(q.ILifecycleMainService,new T.SyncDescriptor(q.LifecycleMainService,void 0,!1)),me.set(W.IRequestService,new T.SyncDescriptor(H.RequestMainService,void 0,!0)),me.set(_.IThemeMainService,new T.SyncDescriptor(_.ThemeMainService)),me.set(Q.ISignService,new T.SyncDescriptor(ne.SignService,void 0,!1)),me.set(Y.ITunnelService,new T.SyncDescriptor(x.TunnelService)),me.set(ce.IProtocolMainService,new K.ProtocolMainService(J,Ne,Le)),[new U.InstantiationService(me,!0),ue,J,G,Ue,Ee,De,Ne]}patchEnvironment(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(De=>{const J=process.env[De];typeof J=="string"&&(pe[De]=J)}),Object.assign(process.env,pe),pe}async initServices(me,pe,De,J,ue){await M.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.fsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?d.Promises.mkdir(fe,{recursive:!0}):void 0)),J.init(),De.initialize()]),pe.init()}async claimInstance(me,pe,De,J,ue,fe){let Ee;try{(0,E.mark)("code/willStartMainServer"),Ee=await(0,w.serve)(pe.mainIPCHandle),(0,E.mark)("code/didStartMainServer"),(0,v.once)(De.onWillShutdown)(()=>Ee.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,ue,Le),Le;let Te;try{Te=await(0,w.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!fe||S.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ue.nameShort),(0,t.localize)(2,null),ue),Ne;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch(He){throw me.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(me,pe,De,J,ue,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne=`Running extension tests from the command line is currently only supported if no other instance of ${ue.nameShort} is running.`;throw me.error(Ne),Te.dispose(),new Error(Ne)}let We;!pe.args.wait&&!pe.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ue.nameShort),(0,t.localize)(4,null),ue)},1e4));const qe=b.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Ue=b.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return J.invokeFunction(async()=>{const Ne=new n.DiagnosticsService(Z.NullTelemetryService,ue),He=await Ue.getMainDiagnostics(),G=await Ue.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),le=await Ne.getDiagnostics(He,G);throw console.log(le),new f.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(qe,me),me.trace("Sending env to running instance..."),await qe.start(pe.args,process.env),Te.dispose(),We&&clearTimeout(We),new f.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn("Warning: The --status argument can only be used if {0} is already running. Please run it again after {0} has started.",ue.nameShort),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ee}handleStartupDataDirError(me,pe,De){if(De.code==="EACCES"||De.code==="EPERM"){const J=(0,L.coalesce)([me.userDataPath,me.extensionsPath,w.XDG_RUNTIME_DIR]).map(ue=>(0,p.getPathLabel)(r.URI.file(ue),{os:S.OS,tildify:me}));this.showStartupWarningDialog((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(De),J.join(`
`)),pe)}}showStartupWarningDialog(me,pe,De){I.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:me,detail:pe},De).options)}async windowsAllowSetForegroundWindow(me,pe){if(S.isWindows){const De=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",De);try{(await new Promise((J,ue)=>{j(["windows-foreground-love"],J,ue)})).allowSetForegroundWindow(De)}catch(J){pe.error(J)}}}quit(me,pe){const De=me.get(oe.ILogService),J=me.get(q.ILifecycleMainService);let ue=0;pe&&(pe.isExpected?pe.message&&De.trace(pe.message):(ue=1,pe.stack?De.error(pe.stack):De.error(`Startup error: ${pe.toString()}`))),J.kill(ue)}resolveArgs(){const me=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,o.createWaitMarkerFileSync)(me.verbose);pe&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.doValidatePaths(me._,me.goto);me._=pe}return me}doValidatePaths(me,pe){const De=(0,s.cwd)(),J=me.map(Ee=>{let Le=String(Ee),Te;pe&&(Te=(0,u.parseLineAndColumnAware)(Le),Le=Te.path),Le&&(Le=this.preparePath(De,Le));const We=(0,u.sanitizeFilePath)(Le,De),qe=(0,h.basename)(We);return qe&&!(0,u.isValidBasename)(qe)?null:pe&&Te?(Te.path=We,this.toPath(Te)):We}),ue=S.isWindows||S.isMacintosh,fe=(0,L.distinct)(J,Ee=>Ee&&ue?Ee.toLowerCase():Ee||"");return(0,L.coalesce)(fe)}preparePath(me,pe){return S.isWindows&&(pe=(0,g.rtrim)(pe,'"')),pe=(0,g.trim)((0,g.trim)(pe," "),"	"),S.isWindows&&(pe=(0,h.resolve)(me,pe),pe=(0,g.rtrim)(pe,".")),pe}toPath(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/code/electron-main/main.js.map
