/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(ee){for(var t=[],E=0,k=ee.length;E<k;E++)t[E]=ge[ee[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var Vt=Object.hasOwnProperty,It=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,it=Object.freeze,lt=Object.seal,Gt=Object.create,Nt=typeof Reflect<"u"&&Reflect,vt=Nt.apply,_t=Nt.construct;vt||(vt=function(t,E,k){return t.apply(E,k)}),it||(it=function(t){return t}),lt||(lt=function(t){return t}),_t||(_t=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat($t(E))))});var Yt=st(Array.prototype.forEach),kt=st(Array.prototype.pop),gt=st(Array.prototype.push),ct=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),at=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(ee){return function(t){for(var E=arguments.length,k=Array(E>1?E-1:0),i=1;i<E;i++)k[i-1]=arguments[i];return vt(ee,t,k)}}function Qt(ee){return function(){for(var t=arguments.length,E=Array(t),k=0;k<t;k++)E[k]=arguments[k];return _t(ee,E)}}function Be(ee,t){It&&It(ee,null);for(var E=t.length;E--;){var k=t[E];if(typeof k=="string"){var i=ct(k);i!==k&&(Kt(t)||(t[E]=i),k=i)}ee[k]=!0}return ee}function ht(ee){var t=Gt(null),E=void 0;for(E in ee)vt(Vt,ee,[E])&&(t[E]=ee[E]);return t}function Dt(ee,t){for(;ee!==null;){var E=jt(ee,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}ee=qt(ee)}function k(i){return console.warn("fallback value for",i),null}return k}var Mt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=it(["#text"]),Bt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),xt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),wt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=lt(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=lt(/<%[\s\S]*|[\s\S]*%>/gm),ni=lt(/^data-[\-\w.\u00B7-\uFFFF]/),si=lt(/^aria-[\-\w]+$/),ri=lt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=lt(/^(?:\w+script|data):/i),li=lt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(ee){return typeof ee}:function(ee){return ee&&typeof Symbol=="function"&&ee.constructor===Symbol&&ee!==Symbol.prototype?"symbol":typeof ee};function ot(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var ai=function(){return typeof window>"u"?null:window},ui=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var k=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(k=E.currentScript.getAttribute(i));var z="dompurify"+(k?"#"+k:"");try{return t.createPolicy(z,{createHTML:function(_){return _}})}catch{return console.warn("TrustedTypes policy "+z+" could not be created."),null}};function Ht(){var ee=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(he){return Ht(he)};if(t.version="2.3.1",t.removed=[],!ee||!ee.document||ee.document.nodeType!==9)return t.isSupported=!1,t;var E=ee.document,k=ee.document,i=ee.DocumentFragment,z=ee.HTMLTemplateElement,v=ee.Node,_=ee.Element,c=ee.NodeFilter,l=ee.NamedNodeMap,h=l===void 0?ee.NamedNodeMap||ee.MozNamedAttrMap:l,P=ee.Text,r=ee.Comment,a=ee.DOMParser,e=ee.trustedTypes,o=_.prototype,n=Dt(o,"cloneNode"),u=Dt(o,"nextSibling"),s=Dt(o,"childNodes"),D=Dt(o,"parentNode");if(typeof z=="function"){var w=k.createElement("template");w.content&&w.content.ownerDocument&&(k=w.content.ownerDocument)}var S=ui(e,E),f=S&&Y?S.createHTML(""):"",b=k,L=b.implementation,N=b.createNodeIterator,y=b.createDocumentFragment,d=b.getElementsByTagName,m=E.importNode,p={};try{p=ht(k).documentMode?k.documentMode:{}}catch{}var M={};t.isSupported=typeof D=="function"&&L&&typeof L.createHTMLDocument<"u"&&p!==9;var q=ti,Z=ii,se=ni,le=si,fe=oi,ue=li,Q=ri,J=null,ve=Be({},[].concat(ot(Mt),ot(St),ot(Ct),ot(At),ot(Ot))),be=null,ke=Be({},[].concat(ot(Bt),ot(Tt),ot(xt),ot(wt))),Re=null,ae=null,U=!0,ne=!0,te=!1,ie=!1,F=!1,$=!1,R=!1,g=!1,C=!1,W=!0,Y=!1,A=!0,I=!0,O=!1,T={},x=null,B=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),H=null,V=Be({},["audio","video","img","source","image","track"]),G=null,re=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ce="http://www.w3.org/1998/Math/MathML",we="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Le=ye,Ce=!1,De=null,Pe=k.createElement("form"),Ne=function(he){De&&De===he||((!he||(typeof he>"u"?"undefined":mt(he))!=="object")&&(he={}),he=ht(he),J="ALLOWED_TAGS"in he?Be({},he.ALLOWED_TAGS):ve,be="ALLOWED_ATTR"in he?Be({},he.ALLOWED_ATTR):ke,G="ADD_URI_SAFE_ATTR"in he?Be(ht(re),he.ADD_URI_SAFE_ATTR):re,H="ADD_DATA_URI_TAGS"in he?Be(ht(V),he.ADD_DATA_URI_TAGS):V,x="FORBID_CONTENTS"in he?Be({},he.FORBID_CONTENTS):B,Re="FORBID_TAGS"in he?Be({},he.FORBID_TAGS):{},ae="FORBID_ATTR"in he?Be({},he.FORBID_ATTR):{},T="USE_PROFILES"in he?he.USE_PROFILES:!1,U=he.ALLOW_ARIA_ATTR!==!1,ne=he.ALLOW_DATA_ATTR!==!1,te=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ie=he.SAFE_FOR_TEMPLATES||!1,F=he.WHOLE_DOCUMENT||!1,g=he.RETURN_DOM||!1,C=he.RETURN_DOM_FRAGMENT||!1,W=he.RETURN_DOM_IMPORT!==!1,Y=he.RETURN_TRUSTED_TYPE||!1,R=he.FORCE_BODY||!1,A=he.SANITIZE_DOM!==!1,I=he.KEEP_CONTENT!==!1,O=he.IN_PLACE||!1,Q=he.ALLOWED_URI_REGEXP||Q,Le=he.NAMESPACE||ye,ie&&(ne=!1),C&&(g=!0),T&&(J=Be({},[].concat(ot(Ot))),be=[],T.html===!0&&(Be(J,Mt),Be(be,Bt)),T.svg===!0&&(Be(J,St),Be(be,Tt),Be(be,wt)),T.svgFilters===!0&&(Be(J,Ct),Be(be,Tt),Be(be,wt)),T.mathMl===!0&&(Be(J,At),Be(be,xt),Be(be,wt))),he.ADD_TAGS&&(J===ve&&(J=ht(J)),Be(J,he.ADD_TAGS)),he.ADD_ATTR&&(be===ke&&(be=ht(be)),Be(be,he.ADD_ATTR)),he.ADD_URI_SAFE_ATTR&&Be(G,he.ADD_URI_SAFE_ATTR),he.FORBID_CONTENTS&&(x===B&&(x=ht(x)),Be(x,he.FORBID_CONTENTS)),I&&(J["#text"]=!0),F&&Be(J,["html","head","body"]),J.table&&(Be(J,["tbody"]),delete Re.tbody),it&&it(he),De=he)},Ke=Be({},["mi","mo","mn","ms","mtext"]),xe=Be({},["foreignobject","desc","title","annotation-xml"]),He=Be({},St);Be(He,Ct),Be(He,Jt);var Ze=Be({},At);Be(Ze,ei);var Ge=function(he){var _e=D(he);(!_e||!_e.tagName)&&(_e={namespaceURI:ye,tagName:"template"});var Ie=ct(he.tagName),We=ct(_e.tagName);if(he.namespaceURI===we)return _e.namespaceURI===ye?Ie==="svg":_e.namespaceURI===ce?Ie==="svg"&&(We==="annotation-xml"||Ke[We]):Boolean(He[Ie]);if(he.namespaceURI===ce)return _e.namespaceURI===ye?Ie==="math":_e.namespaceURI===we?Ie==="math"&&xe[We]:Boolean(Ze[Ie]);if(he.namespaceURI===ye){if(_e.namespaceURI===we&&!xe[We]||_e.namespaceURI===ce&&!Ke[We])return!1;var Qe=Be({},["title","style","font","a","script"]);return!Ze[Ie]&&(Qe[Ie]||!He[Ie])}return!1},Oe=function(he){gt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{try{he.outerHTML=f}catch{he.remove()}}},K=function(he,_e){try{gt(t.removed,{attribute:_e.getAttributeNode(he),from:_e})}catch{gt(t.removed,{attribute:null,from:_e})}if(_e.removeAttribute(he),he==="is"&&!be[he])if(g||C)try{Oe(_e)}catch{}else try{_e.setAttribute(he,"")}catch{}},oe=function(he){var _e=void 0,Ie=void 0;if(R)he="<remove></remove>"+he;else{var We=Pt(he,/^[\r\n\t ]+/);Ie=We&&We[0]}var Qe=S?S.createHTML(he):he;if(Le===ye)try{_e=new a().parseFromString(Qe,"text/html")}catch{}if(!_e||!_e.documentElement){_e=L.createDocument(Le,"template",null);try{_e.documentElement.innerHTML=Ce?"":Qe}catch{}}var Je=_e.body||_e.documentElement;return he&&Ie&&Je.insertBefore(k.createTextNode(Ie),Je.childNodes[0]||null),Le===ye?d.call(_e,F?"html":"body")[0]:F?_e.documentElement:Je},pe=function(he){return N.call(he.ownerDocument||he,he,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},Ee=function(he){return he instanceof P||he instanceof r?!1:typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof h)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"},Se=function(he){return(typeof v>"u"?"undefined":mt(v))==="object"?he instanceof v:he&&(typeof he>"u"?"undefined":mt(he))==="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},Me=function(he,_e,Ie){!M[he]||Yt(M[he],function(We){We.call(t,_e,Ie,De)})},ze=function(he){var _e=void 0;if(Me("beforeSanitizeElements",he,null),Ee(he)||Pt(he.nodeName,/[\u0080-\uFFFF]/))return Oe(he),!0;var Ie=ct(he.nodeName);if(Me("uponSanitizeElement",he,{tagName:Ie,allowedTags:J}),!Se(he.firstElementChild)&&(!Se(he.content)||!Se(he.content.firstElementChild))&&at(/<[/\w]/g,he.innerHTML)&&at(/<[/\w]/g,he.textContent)||Ie==="select"&&at(/<template/i,he.innerHTML))return Oe(he),!0;if(!J[Ie]||Re[Ie]){if(I&&!x[Ie]){var We=D(he)||he.parentNode,Qe=s(he)||he.childNodes;if(Qe&&We)for(var Je=Qe.length,et=Je-1;et>=0;--et)We.insertBefore(n(Qe[et],!0),u(he))}return Oe(he),!0}return he instanceof _&&!Ge(he)||(Ie==="noscript"||Ie==="noembed")&&at(/<\/no(script|embed)/i,he.innerHTML)?(Oe(he),!0):(ie&&he.nodeType===3&&(_e=he.textContent,_e=ut(_e,q," "),_e=ut(_e,Z," "),he.textContent!==_e&&(gt(t.removed,{element:he.cloneNode()}),he.textContent=_e)),Me("afterSanitizeElements",he,null),!1)},tt=function(he,_e,Ie){if(A&&(_e==="id"||_e==="name")&&(Ie in k||Ie in Pe))return!1;if(!(ne&&!ae[_e]&&at(se,_e))){if(!(U&&at(le,_e))){if(!be[_e]||ae[_e])return!1;if(!G[_e]){if(!at(Q,ut(Ie,ue,""))){if(!((_e==="src"||_e==="xlink:href"||_e==="href")&&he!=="script"&&Xt(Ie,"data:")===0&&H[he])){if(!(te&&!at(fe,ut(Ie,ue,"")))){if(Ie)return!1}}}}}}return!0},je=function(he){var _e=void 0,Ie=void 0,We=void 0,Qe=void 0;Me("beforeSanitizeAttributes",he,null);var Je=he.attributes;if(!!Je){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:be};for(Qe=Je.length;Qe--;){_e=Je[Qe];var rt=_e,dt=rt.name,pt=rt.namespaceURI;if(Ie=Zt(_e.value),We=ct(dt),et.attrName=We,et.attrValue=Ie,et.keepAttr=!0,et.forceKeepAttr=void 0,Me("uponSanitizeAttribute",he,et),Ie=et.attrValue,!et.forceKeepAttr&&(K(dt,he),!!et.keepAttr)){if(at(/\/>/i,Ie)){K(dt,he);continue}ie&&(Ie=ut(Ie,q," "),Ie=ut(Ie,Z," "));var Ft=he.nodeName.toLowerCase();if(!!tt(Ft,We,Ie))try{pt?he.setAttributeNS(pt,dt,Ie):he.setAttribute(dt,Ie),kt(t.removed)}catch{}}}Me("afterSanitizeAttributes",he,null)}},$e=function Fe(he){var _e=void 0,Ie=pe(he);for(Me("beforeSanitizeShadowDOM",he,null);_e=Ie.nextNode();)Me("uponSanitizeShadowNode",_e,null),!ze(_e)&&(_e.content instanceof i&&Fe(_e.content),je(_e));Me("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Fe,he){var _e=void 0,Ie=void 0,We=void 0,Qe=void 0,Je=void 0;if(Ce=!Fe,Ce&&(Fe="<!-->"),typeof Fe!="string"&&!Se(Fe)){if(typeof Fe.toString!="function")throw Rt("toString is not a function");if(Fe=Fe.toString(),typeof Fe!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(ee.toStaticHTML)==="object"||typeof ee.toStaticHTML=="function"){if(typeof Fe=="string")return ee.toStaticHTML(Fe);if(Se(Fe))return ee.toStaticHTML(Fe.outerHTML)}return Fe}if($||Ne(he),t.removed=[],typeof Fe=="string"&&(O=!1),!O)if(Fe instanceof v)_e=oe("<!---->"),Ie=_e.ownerDocument.importNode(Fe,!0),Ie.nodeType===1&&Ie.nodeName==="BODY"||Ie.nodeName==="HTML"?_e=Ie:_e.appendChild(Ie);else{if(!g&&!ie&&!F&&Fe.indexOf("<")===-1)return S&&Y?S.createHTML(Fe):Fe;if(_e=oe(Fe),!_e)return g?null:f}_e&&R&&Oe(_e.firstChild);for(var et=pe(O?Fe:_e);We=et.nextNode();)We.nodeType===3&&We===Qe||ze(We)||(We.content instanceof i&&$e(We.content),je(We),Qe=We);if(Qe=null,O)return Fe;if(g){if(C)for(Je=y.call(_e.ownerDocument);_e.firstChild;)Je.appendChild(_e.firstChild);else Je=_e;return W&&(Je=m.call(E,Je,!0)),Je}var rt=F?_e.outerHTML:_e.innerHTML;return ie&&(rt=ut(rt,q," "),rt=ut(rt,Z," ")),S&&Y?S.createHTML(rt):rt},t.setConfig=function(Fe){Ne(Fe),$=!0},t.clearConfig=function(){De=null,$=!1},t.isValidAttribute=function(Fe,he,_e){De||Ne({});var Ie=ct(Fe),We=ct(he);return tt(Ie,We,_e)},t.addHook=function(Fe,he){typeof he=="function"&&(M[Fe]=M[Fe]||[],gt(M[Fe],he))},t.removeHook=function(Fe){M[Fe]&&kt(M[Fe])},t.removeHooks=function(Fe){M[Fe]&&(M[Fe]=[])},t.removeAllHooks=function(){M={}},t}var ci=Ht();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(ge[38],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(v){this.domNode=v,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(v){const _=k(v);this._maxWidth!==_&&(this._maxWidth=_,this.domNode.style.maxWidth=this._maxWidth)}setWidth(v){const _=k(v);this._width!==_&&(this._width=_,this.domNode.style.width=this._width)}setHeight(v){const _=k(v);this._height!==_&&(this._height=_,this.domNode.style.height=this._height)}setTop(v){const _=k(v);this._top!==_&&(this._top=_,this.domNode.style.top=this._top)}setLeft(v){const _=k(v);this._left!==_&&(this._left=_,this.domNode.style.left=this._left)}setBottom(v){const _=k(v);this._bottom!==_&&(this._bottom=_,this.domNode.style.bottom=this._bottom)}setRight(v){const _=k(v);this._right!==_&&(this._right=_,this.domNode.style.right=this._right)}setPaddingTop(v){const _=k(v);this._paddingTop!==_&&(this._paddingTop=_,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(v){const _=k(v);this._paddingLeft!==_&&(this._paddingLeft=_,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(v){const _=k(v);this._paddingBottom!==_&&(this._paddingBottom=_,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(v){const _=k(v);this._paddingRight!==_&&(this._paddingRight=_,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(v){this._fontFamily!==v&&(this._fontFamily=v,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(v){this._fontWeight!==v&&(this._fontWeight=v,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(v){const _=k(v);this._fontSize!==_&&(this._fontSize=_,this.domNode.style.fontSize=this._fontSize)}setFontStyle(v){this._fontStyle!==v&&(this._fontStyle=v,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(v){this._fontFeatureSettings!==v&&(this._fontFeatureSettings=v,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(v){this._fontVariationSettings!==v&&(this._fontVariationSettings=v,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(v){this._textDecoration!==v&&(this._textDecoration=v,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(v){const _=k(v);this._lineHeight!==_&&(this._lineHeight=_,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(v){const _=k(v);this._letterSpacing!==_&&(this._letterSpacing=_,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(v){this._className!==v&&(this._className=v,this.domNode.className=this._className)}toggleClassName(v,_){this.domNode.classList.toggle(v,_),this._className=this.domNode.className}setDisplay(v){this._display!==v&&(this._display=v,this.domNode.style.display=this._display)}setPosition(v){this._position!==v&&(this._position=v,this.domNode.style.position=this._position)}setVisibility(v){this._visibility!==v&&(this._visibility=v,this.domNode.style.visibility=this._visibility)}setColor(v){this._color!==v&&(this._color=v,this.domNode.style.color=this._color)}setBackgroundColor(v){this._backgroundColor!==v&&(this._backgroundColor=v,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(v){this._layerHint!==v&&(this._layerHint=v,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(v){this._boxShadow!==v&&(this._boxShadow=v,this.domNode.style.boxShadow=v)}setContain(v){this._contain!==v&&(this._contain=v,this.domNode.style.contain=this._contain)}setAttribute(v,_){this.domNode.setAttribute(v,_)}removeAttribute(v){this.domNode.removeAttribute(v)}appendChild(v){this.domNode.appendChild(v.domNode)}removeChild(v){this.domNode.removeChild(v.domNode)}}t.FastDomNode=E;function k(z){return typeof z=="number"?`${z}px`:z}function i(z){return new E(z)}t.createFastDomNode=i}),define(ge[66],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,k=null;function i(v){if(!v.parent||v.parent===v)return null;try{const _=v.location,c=v.parent.location;if(_.origin!=="null"&&c.origin!=="null"&&_.origin!==c.origin)return E=!0,null}catch{return E=!0,null}return v.parent}class z{static getSameOriginWindowChain(){if(!k){k=[];let _=window,c;do c=i(_),c?k.push({window:_,iframeElement:_.frameElement||null}):k.push({window:_,iframeElement:null}),_=c;while(_)}return k.slice(0)}static hasDifferentOriginAncestor(){return k||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(_,c){if(!c||_===c)return{top:0,left:0};let l=0,h=0;const P=this.getSameOriginWindowChain();for(const r of P){if(l+=r.window.scrollY,h+=r.window.scrollX,r.window===c||!r.iframeElement)break;const a=r.iframeElement.getBoundingClientRect();l+=a.top,h+=a.left}return{top:l,left:h}}}t.IframeUtils=z}),define(ge[67],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(z){z[z.Copy=0]="Copy",z[z.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class k extends Error{constructor(v,_){super(`ListError [${v}] ${_}`)}}t.ListError=k;class i{constructor(){this.cache=new WeakMap}getHeight(v){return this.cache.get(v)??this.estimateHeight(v)}setDynamicHeight(v,_){_>0&&this.cache.set(v,_)}}t.CachedListVirtualDelegate=i}),define(ge[68],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.spliceables=i}splice(i,z,v){this.spliceables.forEach(_=>_.splice(i,z,v))}}t.CombinedSpliceable=E}),define(ge[39],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class k{constructor(z,v,_,c,l,h){this._scrollbarSize=Math.round(v),this._oppositeScrollbarSize=Math.round(_),this._arrowSize=Math.round(z),this._visibleSize=c,this._scrollSize=l,this._scrollPosition=h,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new k(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(z){const v=Math.round(z);return this._visibleSize!==v?(this._visibleSize=v,this._refreshComputedValues(),!0):!1}setScrollSize(z){const v=Math.round(z);return this._scrollSize!==v?(this._scrollSize=v,this._refreshComputedValues(),!0):!1}setScrollPosition(z){const v=Math.round(z);return this._scrollPosition!==v?(this._scrollPosition=v,this._refreshComputedValues(),!0):!1}setScrollbarSize(z){this._scrollbarSize=Math.round(z)}setOppositeScrollbarSize(z){this._oppositeScrollbarSize=Math.round(z)}static _computeValues(z,v,_,c,l){const h=Math.max(0,_-z),P=Math.max(0,h-2*v),r=c>0&&c>_;if(!r)return{computedAvailableSize:Math.round(h),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(E,Math.floor(_*P/c))),e=(P-a)/(c-_),o=l*e;return{computedAvailableSize:Math.round(h),computedIsNeeded:r,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(o)}}_refreshComputedValues(){const z=k._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=z.computedAvailableSize,this._computedIsNeeded=z.computedIsNeeded,this._computedSliderSize=z.computedSliderSize,this._computedSliderRatio=z.computedSliderRatio,this._computedSliderPosition=z.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(z){if(!this._computedIsNeeded)return 0;const v=z-this._arrowSize-this._computedSliderSize/2;return Math.round(v/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(z){if(!this._computedIsNeeded)return 0;const v=z-this._arrowSize;let _=this._scrollPosition;return v<this._computedSliderPosition?_-=this._visibleSize:_+=this._visibleSize,_}getDesiredScrollPositionFromDelta(z){if(!this._computedIsNeeded)return 0;const v=this._computedSliderPosition+z;return Math.round(v/this._computedSliderRatio)}}t.ScrollbarState=k}),define(ge[24],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var k;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(k=t.ObjectTreeElementCollapseState||(t.ObjectTreeElementCollapseState={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var z;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(z=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class v extends Error{constructor(l,h){super(`TreeError [${l}] ${h}`)}}t.TreeError=v;class _{constructor(l){this.fn=l,this._map=new WeakMap}map(l){let h=this._map.get(l);return h||(h=this.fn(l),this._map.set(l,h)),h}}t.WeakMapper=_}),define(ge[69],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(v,_){const c=Object.create(null);for(const l of v){const h=_(l);let P=c[h];P||(P=c[h]=[]),P.push(l)}return c}t.groupBy=E;function k(v,_){const c=[],l=[];for(const h of v)_.has(h)||c.push(h);for(const h of _)v.has(h)||l.push(h);return{removed:c,added:l}}t.diffSets=k;function i(v,_){const c=[],l=[];for(const[h,P]of v)_.has(h)||c.push(P);for(const[h,P]of _)v.has(h)||l.push(P);return{removed:c,added:l}}t.diffMaps=i;class z{constructor(){this.map=new Map}add(_,c){let l=this.map.get(_);l||(l=new Set,this.map.set(_,l)),l.add(c)}delete(_,c){const l=this.map.get(_);!l||(l.delete(c),l.size===0&&this.map.delete(_))}forEach(_,c){const l=this.map.get(_);!l||l.forEach(c)}}t.SetMap=z}),define(ge[70],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(_,c){const l=Math.pow(10,c);return Math.round(_*l)/l}class k{constructor(c,l,h,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.r===l.r&&c.g===l.g&&c.b===l.b&&c.a===l.a}}t.RGBA=k;class i{constructor(c,l,h,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,h),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.h===l.h&&c.s===l.s&&c.l===l.l&&c.a===l.a}static fromRGBA(c){const l=c.r/255,h=c.g/255,P=c.b/255,r=c.a,a=Math.max(l,h,P),e=Math.min(l,h,P);let o=0,n=0;const u=(e+a)/2,s=a-e;if(s>0){switch(n=Math.min(u<=.5?s/(2*u):s/(2-2*u),1),a){case l:o=(h-P)/s+(h<P?6:0);break;case h:o=(P-l)/s+2;break;case P:o=(l-h)/s+4;break}o*=60,o=Math.round(o)}return new i(o,n,u,r)}static _hue2rgb(c,l,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(l-c)*6*h:h<1/2?l:h<2/3?c+(l-c)*(2/3-h)*6:c}static toRGBA(c){const l=c.h/360,{s:h,l:P,a:r}=c;let a,e,o;if(h===0)a=e=o=P;else{const n=P<.5?P*(1+h):P+h-P*h,u=2*P-n;a=i._hue2rgb(u,n,l+1/3),e=i._hue2rgb(u,n,l),o=i._hue2rgb(u,n,l-1/3)}return new k(Math.round(a*255),Math.round(e*255),Math.round(o*255),r)}}t.HSLA=i;class z{constructor(c,l,h,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,h),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(c,l){return c.h===l.h&&c.s===l.s&&c.v===l.v&&c.a===l.a}static fromRGBA(c){const l=c.r/255,h=c.g/255,P=c.b/255,r=Math.max(l,h,P),a=Math.min(l,h,P),e=r-a,o=r===0?0:e/r;let n;return e===0?n=0:r===l?n=((h-P)/e%6+6)%6:r===h?n=(P-l)/e+2:n=(l-h)/e+4,new z(Math.round(n*60),o,r,c.a)}static toRGBA(c){const{h:l,s:h,v:P,a:r}=c,a=P*h,e=a*(1-Math.abs(l/60%2-1)),o=P-a;let[n,u,s]=[0,0,0];return l<60?(n=a,u=e):l<120?(n=e,u=a):l<180?(u=a,s=e):l<240?(u=e,s=a):l<300?(n=e,s=a):l<=360&&(n=a,s=e),n=Math.round((n+o)*255),u=Math.round((u+o)*255),s=Math.round((s+o)*255),new k(n,u,s,r)}}t.HSVA=z;class v{static fromHex(c){return v.Format.CSS.parseHex(c)||v.red}static equals(c,l){return!c&&!l?!0:!c||!l?!1:c.equals(l)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:z.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof k)this.rgba=c;else if(c instanceof i)this._hsla=c,this.rgba=i.toRGBA(c);else if(c instanceof z)this._hsva=c,this.rgba=z.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&k.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&z.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=v._relativeLuminanceForComponent(this.rgba.r),l=v._relativeLuminanceForComponent(this.rgba.g),h=v._relativeLuminanceForComponent(this.rgba.b),P=.2126*c+.7152*l+.0722*h;return E(P,4)}static _relativeLuminanceForComponent(c){const l=c/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l>h?(l+.05)/(h+.05):(h+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l>h}isDarkerThan(c){const l=this.getRelativeLuminance(),h=c.getRelativeLuminance();return l<h}lighten(c){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:l,g:h,b:P,a:r}=this.rgba;return new v(new k(l,h,P,r*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const l=c.rgba,h=this.rgba.a,P=l.a,r=h+P*(1-h);if(r<1e-6)return v.transparent;const a=this.rgba.r*h/r+l.r*P*(1-h)/r,e=this.rgba.g*h/r+l.g*P*(1-h)/r,o=this.rgba.b*h/r+l.b*P*(1-h)/r;return new v(new k(a,e,o,r))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:l,g:h,b:P,a:r}=this.rgba;return new v(new k(c.rgba.r-r*(c.rgba.r-l),c.rgba.g-r*(c.rgba.g-h),c.rgba.b-r*(c.rgba.b-P),1))}flatten(...c){const l=c.reduceRight((h,P)=>v._flatten(P,h));return v._flatten(this,l)}static _flatten(c,l){const h=1-c.rgba.a;return new v(new k(h*l.rgba.r+c.rgba.a*c.rgba.r,h*l.rgba.g+c.rgba.a*c.rgba.g,h*l.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this._toString||(this._toString=v.Format.CSS.format(this)),this._toString}static getLighterColor(c,l,h){if(c.isLighterThan(l))return c;h=h||.5;const P=c.getRelativeLuminance(),r=l.getRelativeLuminance();return h=h*(r-P)/r,c.lighten(h)}static getDarkerColor(c,l,h){if(c.isDarkerThan(l))return c;h=h||.5;const P=c.getRelativeLuminance(),r=l.getRelativeLuminance();return h=h*(P-r)/P,c.darken(h)}}v.white=new v(new k(255,255,255,1)),v.black=new v(new k(0,0,0,1)),v.red=new v(new k(255,0,0,1)),v.blue=new v(new k(0,0,255,1)),v.green=new v(new k(0,255,0,1)),v.cyan=new v(new k(0,255,255,1)),v.lightgrey=new v(new k(211,211,211,1)),v.transparent=new v(new k(0,0,0,0)),t.Color=v,function(_){let c;(function(l){let h;(function(P){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:_.Format.CSS.formatRGBA(f)}P.formatRGB=r;function a(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}P.formatRGBA=a;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(f)}P.formatHSL=e;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}P.formatHSLA=o;function n(f){const b=f.toString(16);return b.length!==2?"0"+b:b}function u(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}P.formatHex=u;function s(f,b=!1){return b&&f.rgba.a===1?_.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}P.formatHexA=s;function D(f){return f.isOpaque()?_.Format.CSS.formatHex(f):_.Format.CSS.formatRGBA(f)}P.format=D;function w(f){const b=f.length;if(b===0||f.charCodeAt(0)!==35)return null;if(b===7){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),N=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),y=16*S(f.charCodeAt(5))+S(f.charCodeAt(6));return new _(new k(L,N,y,1))}if(b===9){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),N=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),y=16*S(f.charCodeAt(5))+S(f.charCodeAt(6)),d=16*S(f.charCodeAt(7))+S(f.charCodeAt(8));return new _(new k(L,N,y,d/255))}if(b===4){const L=S(f.charCodeAt(1)),N=S(f.charCodeAt(2)),y=S(f.charCodeAt(3));return new _(new k(16*L+L,16*N+N,16*y+y))}if(b===5){const L=S(f.charCodeAt(1)),N=S(f.charCodeAt(2)),y=S(f.charCodeAt(3)),d=S(f.charCodeAt(4));return new _(new k(16*L+L,16*N+N,16*y+y,(16*d+d)/255))}return null}P.parseHex=w;function S(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=l.CSS||(l.CSS={}))})(c=_.Format||(_.Format={}))}(v=t.Color||(t.Color={})),t.Color=v}),define(ge[25],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(v){return(_,c,l)=>{let h=null,P=null;if(typeof l.value=="function"?(h="value",P=l.value):typeof l.get=="function"&&(h="get",P=l.get),!P)throw new Error("not supported");l[h]=v(P,c)}}function k(v,_,c){let l=null,h=null;if(typeof c.value=="function"?(l="value",h=c.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(l="get",h=c.get),!h)throw new Error("not supported");const P=`$memoize$${_}`;c[l]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,r)}),this[P]}}t.memoize=k;function i(v,_,c){return E((l,h)=>{const P=`$debounce$${h}`,r=`$debounce$result$${h}`;return function(...a){this[r]||(this[r]=c?c():void 0),clearTimeout(this[P]),_&&(this[r]=_(this[r],...a),a=[this[r]]),this[P]=setTimeout(()=>{l.apply(this,a),this[r]=c?c():void 0},v)}})}t.debounce=i;function z(v,_,c){return E((l,h)=>{const P=`$throttle$timer$${h}`,r=`$throttle$result$${h}`,a=`$throttle$lastRun$${h}`,e=`$throttle$pending$${h}`;return function(...o){if(this[r]||(this[r]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),_&&(this[r]=_(this[r],...o)),this[e])return;const n=this[a]+v;n<=Date.now()?(this[a]=Date.now(),l.apply(this,[this[r]]),this[r]=c?c():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),l.apply(this,[this[r]]),this[r]=c?c():void 0},n-Date.now()))}})}t.throttle=z}),define(ge[71],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,z,v,_){this.originalStart=i,this.originalLength=z,this.modifiedStart=v,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(b){setTimeout(()=>{throw b.stack?w.isErrorNoTelemetry(b)?new w(b.message+`

`+b.stack):new Error(b.message+`

`+b.stack):b},0)}}addListener(b){return this.listeners.push(b),()=>{this._removeListener(b)}}emit(b){this.listeners.forEach(L=>{L(b)})}_removeListener(b){this.listeners.splice(this.listeners.indexOf(b),1)}setUnexpectedErrorHandler(b){this.unexpectedErrorHandler=b}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(b){this.unexpectedErrorHandler(b),this.emit(b)}onUnexpectedExternalError(b){this.unexpectedErrorHandler(b)}}t.ErrorHandler=E,t.errorHandler=new E;function k(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=k;function i(f){if(!f||typeof f!="object")return!1;const b=f;return b.code==="EPIPE"&&b.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function z(f){l(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=z;function v(f){l(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=v;function _(f){if(f instanceof Error){const{name:b,message:L}=f,N=f.stacktrace||f.stack;return{$isError:!0,name:b,message:L,stack:N,noTelemetry:w.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=_;const c="Canceled";function l(f){return f instanceof h?!0:f instanceof Error&&f.name===c&&f.message===c}t.isCancellationError=l;class h extends Error{constructor(){super(c),this.name=this.message}}t.CancellationError=h;function P(){const f=new Error(c);return f.name=f.message,f}t.canceled=P;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=a;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function o(f){const b=new Error(`${f} has been disposed`);return b.name="DISPOSED",b}t.disposed=o;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class u extends Error{constructor(b){super("NotImplemented"),b&&(this.message=b)}}t.NotImplementedError=u;class s extends Error{constructor(b){super("NotSupported"),b&&(this.message=b)}}t.NotSupportedError=s;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=D;class w extends Error{constructor(b){super(b),this.name="CodeExpectedError"}static fromError(b){if(b instanceof w)return b;const L=new w;return L.message=b.message,L.stack=b.stack,L}static isErrorNoTelemetry(b){return b.name==="CodeExpectedError"}}t.ErrorNoTelemetry=w;class S extends Error{constructor(b){super(b||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(ge[13],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function k(A,I=0){return A[A.length-(1+I)]}t.tail=k;function i(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}t.tail2=i;function z(A,I,O=(T,x)=>T===x){if(A===I)return!0;if(!A||!I||A.length!==I.length)return!1;for(let T=0,x=A.length;T<x;T++)if(!O(A[T],I[T]))return!1;return!0}t.equals=z;function v(A,I){const O=A.length-1;I<O&&(A[I]=A[O]),A.pop()}t.removeFastWithoutKeepingOrder=v;function _(A,I,O){return c(A.length,T=>O(A[T],I))}t.binarySearch=_;function c(A,I){let O=0,T=A-1;for(;O<=T;){const x=(O+T)/2|0,B=I(x);if(B<0)O=x+1;else if(B>0)T=x-1;else return x}return-(O+1)}t.binarySearch2=c;function l(A,I){let O=0,T=A.length;if(T===0)return 0;for(;O<T;){const x=Math.floor((O+T)/2);I(A[x])?T=x:O=x+1}return O}t.findFirstInSorted=l;function h(A,I,O){if(A=A|0,A>=I.length)throw new TypeError("invalid index");const T=I[Math.floor(I.length*Math.random())],x=[],B=[],H=[];for(const V of I){const G=O(V,T);G<0?x.push(V):G>0?B.push(V):H.push(V)}return A<x.length?h(A,x,O):A<x.length+H.length?H[0]:h(A-(x.length+H.length),B,O)}t.quickSelect=h;function P(A,I){const O=[];let T;for(const x of A.slice(0).sort(I))!T||I(T[0],x)!==0?(T=[x],O.push(T)):T.push(x);return O}t.groupBy=P;function r(A,I,O){const T=[];function x(V,G,re){if(G===0&&re.length===0)return;const ce=T[T.length-1];ce&&ce.start+ce.deleteCount===V?(ce.deleteCount+=G,ce.toInsert.push(...re)):T.push({start:V,deleteCount:G,toInsert:re})}let B=0,H=0;for(;;){if(B===A.length){x(B,0,I.slice(H));break}if(H===I.length){x(B,A.length-B,[]);break}const V=A[B],G=I[H],re=O(V,G);re===0?(B+=1,H+=1):re<0?(x(B,1,[]),B+=1):re>0&&(x(B,0,[G]),H+=1)}return T}t.sortedDiff=r;function a(A,I,O){const T=r(A,I,O),x=[],B=[];for(const H of T)x.push(...A.slice(H.start,H.start+H.deleteCount)),B.push(...H.toInsert);return{removed:x,added:B}}t.delta=a;function e(A,I,O){if(O===0)return[];const T=A.slice(0,O).sort(I);return n(A,I,T,O,A.length),T}t.top=e;function o(A,I,O,T,x){return O===0?Promise.resolve([]):new Promise((B,H)=>{(async()=>{const V=A.length,G=A.slice(0,O).sort(I);for(let re=O,ce=Math.min(O+T,V);re<V;re=ce,ce=Math.min(ce+T,V)){if(re>O&&await new Promise(we=>setTimeout(we)),x&&x.isCancellationRequested)throw new E.CancellationError;n(A,I,G,re,ce)}return G})().then(B,H)})}t.topAsync=o;function n(A,I,O,T,x){for(const B=O.length;T<x;T++){const H=A[T];if(I(H,O[B-1])<0){O.pop();const V=l(O,G=>I(H,G)<0);O.splice(V,0,H)}}}function u(A){return A.filter(I=>!!I)}t.coalesce=u;function s(A){let I=0;for(let O=0;O<A.length;O++)A[O]&&(A[I]=A[O],I+=1);A.length=I}t.coalesceInPlace=s;function D(A,I,O){A.splice(O,0,A.splice(I,1)[0])}t.move=D;function w(A){return!Array.isArray(A)||A.length===0}t.isFalsyOrEmpty=w;function S(A){return Array.isArray(A)&&A.length>0}t.isNonEmptyArray=S;function f(A,I=O=>O){const O=new Set;return A.filter(T=>{const x=I(T);return O.has(x)?!1:(O.add(x),!0)})}t.distinct=f;function b(A){const I=new Set;return O=>{const T=A(O);return I.has(T)?!1:(I.add(T),!0)}}t.uniqueFilter=b;function L(A,I){const O=N(A,I);if(O!==-1)return A[O]}t.findLast=L;function N(A,I){for(let O=A.length-1;O>=0;O--){const T=A[O];if(I(T))return O}return-1}t.lastIndex=N;function y(A,I){return A.length>0?A[0]:I}t.firstOrDefault=y;function d(A,I){return A.length>0?A[A.length-1]:I}t.lastOrDefault=d;function m(A,I,O=(T,x)=>T===x){let T=0;for(let x=0,B=Math.min(A.length,I.length);x<B&&O(A[x],I[x]);x++)T++;return T}t.commonPrefixLength=m;function p(A){return[].concat(...A)}t.flatten=p;function M(A,I){let O=typeof I=="number"?A:0;typeof I=="number"?O=A:(O=0,I=A);const T=[];if(O<=I)for(let x=O;x<I;x++)T.push(x);else for(let x=O;x>I;x--)T.push(x);return T}t.range=M;function q(A,I,O){return A.reduce((T,x)=>(T[I(x)]=O?O(x):x,T),Object.create(null))}t.index=q;function Z(A,I){return A.push(I),()=>se(A,I)}t.insert=Z;function se(A,I){const O=A.indexOf(I);if(O>-1)return A.splice(O,1),I}t.remove=se;function le(A,I,O){const T=A.slice(0,I),x=A.slice(I);return T.concat(O,x)}t.arrayInsert=le;function fe(A,I){let O;if(typeof I=="number"){let T=I;O=()=>{const x=Math.sin(T++)*179426549;return x-Math.floor(x)}}else O=Math.random;for(let T=A.length-1;T>0;T-=1){const x=Math.floor(O()*(T+1)),B=A[T];A[T]=A[x],A[x]=B}}t.shuffle=fe;function ue(A,I){const O=A.indexOf(I);O>-1&&(A.splice(O,1),A.unshift(I))}t.pushToStart=ue;function Q(A,I){const O=A.indexOf(I);O>-1&&(A.splice(O,1),A.push(I))}t.pushToEnd=Q;function J(A,I){for(const O of I)A.push(O)}t.pushMany=J;function ve(A,I){return Array.isArray(A)?A.map(I):I(A)}t.mapArrayOrNot=ve;function be(A){return Array.isArray(A)?A:[A]}t.asArray=be;function ke(A){return A[Math.floor(Math.random()*A.length)]}t.getRandomElement=ke;function Re(A,I){for(const O of A){const T=I(O);if(T!==void 0)return T}}t.mapFind=Re;function ae(A,I,O){const T=ne(A,I),x=A.length,B=O.length;A.length=x+B;for(let H=x-1;H>=T;H--)A[H+B]=A[H];for(let H=0;H<B;H++)A[H+T]=O[H]}t.insertInto=ae;function U(A,I,O,T){const x=ne(A,I),B=A.splice(x,O);return ae(A,x,T),B}t.splice=U;function ne(A,I){return I<0?Math.max(I+A.length,0):Math.min(I,A.length)}var te;(function(A){function I(x){return x<0}A.isLessThan=I;function O(x){return x>0}A.isGreaterThan=O;function T(x){return x===0}A.isNeitherLessOrGreaterThan=T,A.greaterThan=1,A.lessThan=-1,A.neitherLessOrGreaterThan=0})(te=t.CompareResult||(t.CompareResult={}));function ie(A,I){return(O,T)=>I(A(O),A(T))}t.compareBy=ie;function F(...A){return(I,O)=>{for(const T of A){const x=T(I,O);if(!te.isNeitherLessOrGreaterThan(x))return x}return te.neitherLessOrGreaterThan}}t.tieBreakComparators=F;const $=(A,I)=>A-I;t.numberComparator=$;function R(A,I){if(A.length===0)return;let O=A[0];for(let T=1;T<A.length;T++){const x=A[T];I(x,O)>0&&(O=x)}return O}t.findMaxBy=R;function g(A,I){if(A.length===0)return;let O=A[0];for(let T=1;T<A.length;T++){const x=A[T];I(x,O)>=0&&(O=x)}return O}t.findLastMaxBy=g;function C(A,I){return R(A,(O,T)=>-I(O,T))}t.findMinBy=C;class W{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(I){let O=this.firstIdx;for(;O<this.items.length&&I(this.items[O]);)O++;const T=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,T}takeFromEndWhile(I){let O=this.lastIdx;for(;O>=0&&I(this.items[O]);)O--;const T=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,T}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}removeLast(){const I=this.items[this.lastIdx];return this.lastIdx--,I}takeCount(I){const O=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,O}}t.ArrayQueue=W;class Y{constructor(I){this.iterate=I}forEach(I){this.iterate(O=>(I(O),!0))}toArray(){const I=[];return this.iterate(O=>(I.push(O),!0)),I}filter(I){return new Y(O=>this.iterate(T=>I(T)?O(T):!0))}map(I){return new Y(O=>this.iterate(T=>O(I(T))))}some(I){let O=!1;return this.iterate(T=>(O=I(T),!O)),O}findFirst(I){let O;return this.iterate(T=>I(T)?(O=T,!1):!0),O}findLast(I){let O;return this.iterate(T=>(I(T)&&(O=T),!0)),O}findLastMaxBy(I){let O,T=!0;return this.iterate(x=>((T||te.isGreaterThan(I(x,O)))&&(T=!1,O=x),!0)),O}}Y.empty=new Y(A=>{}),t.CallbackIterable=Y}),define(ge[72],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function k(c,l){if(!c)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=k;function i(c,l="Unreachable"){throw new Error(l)}t.assertNever=i;function z(c){if(!c)throw new E.BugIndicatingError("Assertion Failed")}t.assert=z;function v(c){if(!c()){debugger;c(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=v;function _(c,l){let h=0;for(;h<c.length-1;){const P=c[h],r=c[h+1];if(!l(P,r))return!1;h++}return!0}t.checkAdjacentItems=_}),define(ge[40],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(k){const i=this;let z=!1,v;return function(){return z||(z=!0,v=k.apply(i,arguments)),v}}t.once=E}),define(ge[73],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this._prefix=i,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(k){function i(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}k.is=i;const z=Object.freeze([]);function v(){return z}k.empty=v;function*_(w){yield w}k.single=_;function c(w){return i(w)?w:_(w)}k.wrap=c;function l(w){return w||z}k.from=l;function h(w){return!w||w[Symbol.iterator]().next().done===!0}k.isEmpty=h;function P(w){return w[Symbol.iterator]().next().value}k.first=P;function r(w,S){for(const f of w)if(S(f))return!0;return!1}k.some=r;function a(w,S){for(const f of w)if(S(f))return f}k.find=a;function*e(w,S){for(const f of w)S(f)&&(yield f)}k.filter=e;function*o(w,S){let f=0;for(const b of w)yield S(b,f++)}k.map=o;function*n(...w){for(const S of w)for(const f of S)yield f}k.concat=n;function u(w,S,f){let b=f;for(const L of w)b=S(b,L);return b}k.reduce=u;function*s(w,S,f=w.length){for(S<0&&(S+=w.length),f<0?f+=w.length:f>w.length&&(f=w.length);S<f;S++)yield w[S]}k.slice=s;function D(w,S=Number.POSITIVE_INFINITY){const f=[];if(S===0)return[f,w];const b=w[Symbol.iterator]();for(let L=0;L<S;L++){const N=b.next();if(N.done)return[f,k.empty()];f.push(N.value)}return[f,{[Symbol.iterator](){return b}}]}k.consume=D})(E=t.Iterable||(t.Iterable={}))}),define(ge[41],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,n){this._keyCodeToStr[o]=n,this._strToKeyCode[n.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const z=new i,v=new i,_=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],l=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>l[e]||0,toString:e=>c[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",o=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],u=[];for(const s of o){const[D,w,S,f,b,L,N,y,d,m]=s;if(u[S]||(u[S]=!0,c[S]=f,l[f]=S,h[f.toLowerCase()]=S,w&&(t.IMMUTABLE_CODE_TO_KEY_CODE[S]=b,b!==0&&b!==3&&b!==5&&b!==4&&b!==6&&b!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[b]=S))),!n[b]){if(n[b]=!0,!L)throw new Error(`String representation missing for key code ${b} around scan code ${f}`);z.define(b,L),v.define(b,d||L),_.define(b,m||d||L)}N&&(t.EVENT_KEY_CODE_MAP[N]=b),y&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[y]=b)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function o(S){return z.keyCodeToStr(S)}e.toString=o;function n(S){return z.strToKeyCode(S)}e.fromString=n;function u(S){return v.keyCodeToStr(S)}e.toUserSettingsUS=u;function s(S){return _.keyCodeToStr(S)}e.toUserSettingsGeneral=s;function D(S){return v.strToKeyCode(S)||_.strToKeyCode(S)}e.fromUserSettings=D;function w(S){if(S>=93&&S<=108)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return z.keyCodeToStr(S)}e.toElectronAccelerator=w})(P=t.KeyCodeUtils||(t.KeyCodeUtils={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r=t.KeyMod||(t.KeyMod={}));function a(e,o){const n=(o&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=a}),define(ge[74],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var k;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(k||(k={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const a=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new c([z(a,r),z(e,r)]):new c([z(a,r)])}else{const a=[];for(let e=0;e<P.length;e++)a.push(z(P[e],r));return new c(a)}}t.decodeKeybinding=i;function z(P,r){const a=!!(P&2048),e=!!(P&256),o=r===2?e:a,n=!!(P&1024),u=!!(P&512),s=r===2?a:e,D=P&255;return new v(o,n,u,s,D)}t.createSimpleKeybinding=z;class v{constructor(r,a,e,o,n){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.keyCode=n}equals(r){return r instanceof v&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`K${r}${a}${e}${o}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=v;class _{constructor(r,a,e,o,n){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.scanCode=n}equals(r){return r instanceof _&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`S${r}${a}${e}${o}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=_;class c{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(r+=";"),r+=this.chords[a].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(r.chords[a]))return!1;return!0}}t.Keybinding=c;class l{constructor(r,a,e,o,n,u){this.ctrlKey=r,this.shiftKey=a,this.altKey=e,this.metaKey=o,this.keyLabel=n,this.keyAriaLabel=u}}t.ResolvedChord=l;class h{}t.ResolvedKeybinding=h}),define(ge[42],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=E}),define(ge[2],me([1,0,40,26]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let z=null;function v(d){z=d}if(t.setDisposableTracker=v,i){const d="__is_disposable_tracked__";v(new class{trackDisposable(m){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[d]||console.log(p)},3e3)}setParent(m,p){if(m&&m!==s.None)try{m[d]=!0}catch{}}markAsDisposed(m){if(m&&m!==s.None)try{m[d]=!0}catch{}}markAsSingleton(m){}})}function _(d){return z?.trackDisposable(d),d}function c(d){z?.markAsDisposed(d)}function l(d,m){z?.setParent(d,m)}function h(d,m){if(!!z)for(const p of d)z.setParent(p,m)}function P(d){return z?.markAsSingleton(d),d}t.markAsSingleton=P;function r(d){return typeof d.dispose=="function"&&d.dispose.length===0}t.isDisposable=r;function a(d){if(k.Iterable.is(d)){const m=[];for(const p of d)if(p)try{p.dispose()}catch(M){m.push(M)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}t.dispose=a;function e(d){for(const m of d)r(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function o(...d){const m=n(()=>a(d));return h(d,m),m}t.combinedDisposable=o;function n(d){const m=_({dispose:(0,E.once)(()=>{c(m),d()})});return m}t.toDisposable=n;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{a(this._toDispose)}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return l(m,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}u.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=u;class s{constructor(){this._store=new u,_(this),l(this._store,this)}dispose(){c(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}s.None=Object.freeze({dispose(){}}),t.Disposable=s;class D{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&l(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&l(m,null),m}}t.MutableDisposable=D;class w{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=w;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set(m){let p=m;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,c(this))},this}}t.SafeDisposable=S;class f{constructor(){this.references=new Map}acquire(m,...p){let M=this.references.get(m);M||(M={counter:0,object:this.createReferencedObject(m,...p)},this.references.set(m,M));const{object:q}=M,Z=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(m,M.object),this.references.delete(m))});return M.counter++,{object:q,dispose:Z}}}t.ReferenceCollection=f;class b{constructor(m){this.referenceCollection=m}async acquire(m,...p){const M=this.referenceCollection.acquire(m,...p);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(q){throw M.dispose(),q}}}t.AsyncReferenceCollection=b;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function N(d){const m=new u;try{d(m)}finally{m.dispose()}}t.disposeOnReturn=N;class y{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{a(this._store.values())}finally{this._store.clear()}}has(m){return this._store.has(m)}get(m){return this._store.get(m)}set(m,p,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(m)?.dispose(),this._store.set(m,p)}deleteAndDispose(m){this._store.get(m)?.dispose(),this._store.delete(m)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=y}),define(ge[43],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(z){this.element=z,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class k{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let z=this._first;for(;z!==E.Undefined;){const v=z.next;z.prev=E.Undefined,z.next=E.Undefined,z=v}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(z){return this._insert(z,!1)}push(z){return this._insert(z,!0)}_insert(z,v){const _=new E(z);if(this._first===E.Undefined)this._first=_,this._last=_;else if(v){const l=this._last;this._last=_,_.prev=l,l.next=_}else{const l=this._first;this._first=_,_.next=l,l.prev=_}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(_))}}shift(){if(this._first!==E.Undefined){const z=this._first.element;return this._remove(this._first),z}}pop(){if(this._last!==E.Undefined){const z=this._last.element;return this._remove(this._last),z}}_remove(z){if(z.prev!==E.Undefined&&z.next!==E.Undefined){const v=z.prev;v.next=z.next,z.next.prev=v}else z.prev===E.Undefined&&z.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):z.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):z.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let z=this._first;for(;z!==E.Undefined;)yield z.element,z=z.next}}t.LinkedList=k}),define(ge[75],me([1,0]),function(ee,t){"use strict";var E,k,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function z(o,n,u){let s=o.get(n);return s===void 0&&(s=u,o.set(n,s)),s}t.getOrSet=z;function v(o){const n=[];return o.forEach((u,s)=>{n.push(`${s} => ${u}`)}),`Map(${o.size}) {${n.join(", ")}}`}t.mapToString=v;function _(o){const n=[];return o.forEach(u=>{n.push(u)}),`Set(${o.size}) {${n.join(", ")}}`}t.setToString=_;class c{constructor(n,u){this.uri=n,this.value=u}}class l{constructor(n,u){this[E]="ResourceMap",n instanceof l?(this.map=new Map(n.map),this.toKey=u??l.defaultToKey):(this.map=new Map,this.toKey=n??l.defaultToKey)}set(n,u){return this.map.set(this.toKey(n),new c(n,u)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,u){typeof u<"u"&&(n=n.bind(u));for(const[s,D]of this.map)n(D.value,D.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}l.defaultToKey=o=>o.toString(),t.ResourceMap=l;class h{constructor(n,u){this[k]="ResourceSet",!n||typeof n=="function"?this._map=new l(n):(this._map=new l(u),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,u){this._map.forEach((s,D)=>n.call(u,D,D,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=h;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P=t.Touch||(t.Touch={}));class r{constructor(){this[i]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,u=0){const s=this._map.get(n);if(!!s)return u!==0&&this.touch(s,u),s.value}set(n,u,s=0){let D=this._map.get(n);if(D)D.value=u,s!==0&&this.touch(D,s);else{switch(D={key:n,value:u,next:void 0,previous:void 0},s){case 0:this.addItemLast(D);break;case 1:this.addItemFirst(D);break;case 2:this.addItemLast(D);break;default:this.addItemLast(D);break}this._map.set(n,D),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this._map.get(n);if(!!u)return this._map.delete(n),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,u){const s=this._state;let D=this._head;for(;D;){if(u?n.bind(u)(D.value,D.key,this):n(D.value,D.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");D=D.next}}keys(){const n=this,u=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.key,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return D}values(){const n=this,u=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.value,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return D}entries(){const n=this,u=this._state;let s=this._head;const D={[Symbol.iterator](){return D},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:[s.key,s.value],done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return D}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this._head,s=this.size;for(;u&&s>n;)this._map.delete(u.key),u=u.next,s--;this._head=u,this._size=s,u&&(u.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const u=n.next,s=n.previous;if(!u||!s)throw new Error("Invalid list");u.previous=s,s.next=u}n.next=void 0,n.previous=void 0,this._state++}touch(n,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this._head)return;const s=n.next,D=n.previous;n===this._tail?(D.next=void 0,this._tail=D):(s.previous=D,D.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(u===2){if(n===this._tail)return;const s=n.next,D=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=D,D.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((u,s)=>{n.push([s,u])}),n}fromJSON(n){this.clear();for(const[u,s]of n)this.set(u,s)}}t.LinkedMap=r;class a extends r{constructor(n,u=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=a;class e{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let u=this.map.get(n)||0;return u===0?!1:(u--,u===0?this.map.delete(n):this.map.set(n,u),!0)}has(n){return this.map.has(n)}}t.CounterSet=e}),function(ee,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(ge[76],me([0]),t):(ee=typeof globalThis<"u"?globalThis:ee||self,t(ee.marked={}))}(this,function(ee){"use strict";function t(A,I){for(var O=0;O<I.length;O++){var T=I[O];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(A,T.key,T)}}function E(A,I,O){return I&&t(A.prototype,I),O&&t(A,O),Object.defineProperty(A,"prototype",{writable:!1}),A}function k(A,I){if(!!A){if(typeof A=="string")return i(A,I);var O=Object.prototype.toString.call(A).slice(8,-1);if(O==="Object"&&A.constructor&&(O=A.constructor.name),O==="Map"||O==="Set")return Array.from(A);if(O==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(O))return i(A,I)}}function i(A,I){(I==null||I>A.length)&&(I=A.length);for(var O=0,T=new Array(I);O<I;O++)T[O]=A[O];return T}function z(A,I){var O=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(O)return(O=O.call(A)).next.bind(O);if(Array.isArray(A)||(O=k(A))||I&&A&&typeof A.length=="number"){O&&(A=O);var T=0;return function(){return T>=A.length?{done:!0}:{done:!1,value:A[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function v(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=v();function _(A){ee.defaults=A}var c=/[&<>"']/,l=/[&<>"']/g,h=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(I){return r[I]};function e(A,I){if(I){if(c.test(A))return A.replace(l,a)}else if(h.test(A))return A.replace(P,a);return A}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(A){return A.replace(o,function(I,O){return O=O.toLowerCase(),O==="colon"?":":O.charAt(0)==="#"?O.charAt(1)==="x"?String.fromCharCode(parseInt(O.substring(2),16)):String.fromCharCode(+O.substring(1)):""})}var u=/(^|[^\[])\^/g;function s(A,I){A=typeof A=="string"?A:A.source,I=I||"";var O={replace:function(x,B){return B=B.source||B,B=B.replace(u,"$1"),A=A.replace(x,B),O},getRegex:function(){return new RegExp(A,I)}};return O}var D=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(A,I,O){if(A){var T;try{T=decodeURIComponent(n(O)).replace(D,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}I&&!w.test(O)&&(O=y(I,O));try{O=encodeURI(O).replace(/%25/g,"%")}catch{return null}return O}var f={},b=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,N=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(A,I){f[" "+A]||(b.test(A)?f[" "+A]=A+"/":f[" "+A]=M(A,"/",!0)),A=f[" "+A];var O=A.indexOf(":")===-1;return I.substring(0,2)==="//"?O?I:A.replace(L,"$1")+I:I.charAt(0)==="/"?O?I:A.replace(N,"$1")+I:A+I}var d={exec:function(){}};function m(A){for(var I=1,O,T;I<arguments.length;I++){O=arguments[I];for(T in O)Object.prototype.hasOwnProperty.call(O,T)&&(A[T]=O[T])}return A}function p(A,I){var O=A.replace(/\|/g,function(B,H,V){for(var G=!1,re=H;--re>=0&&V[re]==="\\";)G=!G;return G?"|":" |"}),T=O.split(/ \|/),x=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>I)T.splice(I);else for(;T.length<I;)T.push("");for(;x<T.length;x++)T[x]=T[x].trim().replace(/\\\|/g,"|");return T}function M(A,I,O){var T=A.length;if(T===0)return"";for(var x=0;x<T;){var B=A.charAt(T-x-1);if(B===I&&!O)x++;else if(B!==I&&O)x++;else break}return A.slice(0,T-x)}function q(A,I){if(A.indexOf(I[1])===-1)return-1;for(var O=A.length,T=0,x=0;x<O;x++)if(A[x]==="\\")x++;else if(A[x]===I[0])T++;else if(A[x]===I[1]&&(T--,T<0))return x;return-1}function Z(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function se(A,I){if(I<1)return"";for(var O="";I>1;)I&1&&(O+=A),I>>=1,A+=A;return O+A}function le(A,I,O,T){var x=I.href,B=I.title?e(I.title):null,H=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){T.state.inLink=!0;var V={type:"link",raw:O,href:x,title:B,text:H,tokens:T.inlineTokens(H)};return T.state.inLink=!1,V}return{type:"image",raw:O,href:x,title:B,text:e(H)}}function fe(A,I){var O=A.match(/^(\s+)(?:```)/);if(O===null)return I;var T=O[1];return I.split(`
`).map(function(x){var B=x.match(/^\s+/);if(B===null)return x;var H=B[0];return H.length>=T.length?x.slice(T.length):x}).join(`
`)}var ue=function(){function A(O){this.options=O||ee.defaults}var I=A.prototype;return I.space=function(T){var x=this.rules.block.newline.exec(T);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},I.code=function(T){var x=this.rules.block.code.exec(T);if(x){var B=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?B:M(B,`
`)}}},I.fences=function(T){var x=this.rules.block.fences.exec(T);if(x){var B=x[0],H=fe(B,x[3]||"");return{type:"code",raw:B,lang:x[2]?x[2].trim():x[2],text:H}}},I.heading=function(T){var x=this.rules.block.heading.exec(T);if(x){var B=x[2].trim();if(/#$/.test(B)){var H=M(B,"#");(this.options.pedantic||!H||/ $/.test(H))&&(B=H.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:B,tokens:this.lexer.inline(B)}}},I.hr=function(T){var x=this.rules.block.hr.exec(T);if(x)return{type:"hr",raw:x[0]}},I.blockquote=function(T){var x=this.rules.block.blockquote.exec(T);if(x){var B=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(B,[]),text:B}}},I.list=function(T){var x=this.rules.block.list.exec(T);if(x){var B,H,V,G,re,ce,we,ye,Le,Ce,De,Pe,Ne=x[1].trim(),Ke=Ne.length>1,xe={type:"list",raw:"",ordered:Ke,start:Ke?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Ke?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Ke?Ne:"[*+-]");for(var He=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Pe=!1,!(!(x=He.exec(T))||this.rules.block.hr.test(T)));){if(B=x[0],T=T.substring(B.length),ye=x[2].split(`
`,1)[0],Le=T.split(`
`,1)[0],this.options.pedantic?(G=2,De=ye.trimLeft()):(G=x[2].search(/[^ ]/),G=G>4?1:G,De=ye.slice(G),G+=x[1].length),ce=!1,!ye&&/^ *$/.test(Le)&&(B+=Le+`
`,T=T.substring(Le.length+1),Pe=!0),!Pe)for(var Ze=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ge=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),K=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");T&&(Ce=T.split(`
`,1)[0],ye=Ce,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(ye)||K.test(ye)||Ze.test(ye)||Ge.test(T)));){if(ye.search(/[^ ]/)>=G||!ye.trim())De+=`
`+ye.slice(G);else if(!ce)De+=`
`+ye;else break;!ce&&!ye.trim()&&(ce=!0),B+=Ce+`
`,T=T.substring(Ce.length+1)}xe.loose||(we?xe.loose=!0:/\n *\n *$/.test(B)&&(we=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(De),H&&(V=H[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:B,task:!!H,checked:V,loose:!1,text:De}),xe.raw+=B}xe.items[xe.items.length-1].raw=B.trimRight(),xe.items[xe.items.length-1].text=De.trimRight(),xe.raw=xe.raw.trimRight();var oe=xe.items.length;for(re=0;re<oe;re++){this.lexer.state.top=!1,xe.items[re].tokens=this.lexer.blockTokens(xe.items[re].text,[]);var pe=xe.items[re].tokens.filter(function(Se){return Se.type==="space"}),Ee=pe.every(function(Se){for(var Me=Se.raw.split(""),ze=0,tt=z(Me),je;!(je=tt()).done;){var $e=je.value;if($e===`
`&&(ze+=1),ze>1)return!0}return!1});!xe.loose&&pe.length&&Ee&&(xe.loose=!0,xe.items[re].loose=!0)}return xe}},I.html=function(T){var x=this.rules.block.html.exec(T);if(x){var B={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var H=this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]);B.type="paragraph",B.text=H,B.tokens=this.lexer.inline(H)}return B}},I.def=function(T){var x=this.rules.block.def.exec(T);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var B=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:B,raw:x[0],href:x[2],title:x[3]}}},I.table=function(T){var x=this.rules.block.table.exec(T);if(x){var B={type:"table",header:p(x[1]).map(function(we){return{text:we}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(B.header.length===B.align.length){B.raw=x[0];var H=B.align.length,V,G,re,ce;for(V=0;V<H;V++)/^ *-+: *$/.test(B.align[V])?B.align[V]="right":/^ *:-+: *$/.test(B.align[V])?B.align[V]="center":/^ *:-+ *$/.test(B.align[V])?B.align[V]="left":B.align[V]=null;for(H=B.rows.length,V=0;V<H;V++)B.rows[V]=p(B.rows[V],B.header.length).map(function(we){return{text:we}});for(H=B.header.length,G=0;G<H;G++)B.header[G].tokens=this.lexer.inline(B.header[G].text);for(H=B.rows.length,G=0;G<H;G++)for(ce=B.rows[G],re=0;re<ce.length;re++)ce[re].tokens=this.lexer.inline(ce[re].text);return B}}},I.lheading=function(T){var x=this.rules.block.lheading.exec(T);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},I.paragraph=function(T){var x=this.rules.block.paragraph.exec(T);if(x){var B=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:B,tokens:this.lexer.inline(B)}}},I.text=function(T){var x=this.rules.block.text.exec(T);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},I.escape=function(T){var x=this.rules.inline.escape.exec(T);if(x)return{type:"escape",raw:x[0],text:e(x[1])}},I.tag=function(T){var x=this.rules.inline.tag.exec(T);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):e(x[0]):x[0]}},I.link=function(T){var x=this.rules.inline.link.exec(T);if(x){var B=x[2].trim();if(!this.options.pedantic&&/^</.test(B)){if(!/>$/.test(B))return;var H=M(B.slice(0,-1),"\\");if((B.length-H.length)%2===0)return}else{var V=q(x[2],"()");if(V>-1){var G=x[0].indexOf("!")===0?5:4,re=G+x[1].length+V;x[2]=x[2].substring(0,V),x[0]=x[0].substring(0,re).trim(),x[3]=""}}var ce=x[2],we="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ce);ye&&(ce=ye[1],we=ye[3])}else we=x[3]?x[3].slice(1,-1):"";return ce=ce.trim(),/^</.test(ce)&&(this.options.pedantic&&!/>$/.test(B)?ce=ce.slice(1):ce=ce.slice(1,-1)),le(x,{href:ce&&ce.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},I.reflink=function(T,x){var B;if((B=this.rules.inline.reflink.exec(T))||(B=this.rules.inline.nolink.exec(T))){var H=(B[2]||B[1]).replace(/\s+/g," ");if(H=x[H.toLowerCase()],!H||!H.href){var V=B[0].charAt(0);return{type:"text",raw:V,text:V}}return le(B,H,B[0],this.lexer)}},I.emStrong=function(T,x,B){B===void 0&&(B="");var H=this.rules.inline.emStrong.lDelim.exec(T);if(!!H&&!(H[3]&&B.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var V=H[1]||H[2]||"";if(!V||V&&(B===""||this.rules.inline.punctuation.exec(B))){var G=H[0].length-1,re,ce,we=G,ye=0,Le=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,x=x.slice(-1*T.length+G);(H=Le.exec(x))!=null;)if(re=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!re){if(ce=re.length,H[3]||H[4]){we+=ce;continue}else if((H[5]||H[6])&&G%3&&!((G+ce)%3)){ye+=ce;continue}if(we-=ce,!(we>0)){if(ce=Math.min(ce,ce+we+ye),Math.min(G,ce)%2){var Ce=T.slice(1,G+H.index+ce);return{type:"em",raw:T.slice(0,G+H.index+ce+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var De=T.slice(2,G+H.index+ce-1);return{type:"strong",raw:T.slice(0,G+H.index+ce+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},I.codespan=function(T){var x=this.rules.inline.code.exec(T);if(x){var B=x[2].replace(/\n/g," "),H=/[^ ]/.test(B),V=/^ /.test(B)&&/ $/.test(B);return H&&V&&(B=B.substring(1,B.length-1)),B=e(B,!0),{type:"codespan",raw:x[0],text:B}}},I.br=function(T){var x=this.rules.inline.br.exec(T);if(x)return{type:"br",raw:x[0]}},I.del=function(T){var x=this.rules.inline.del.exec(T);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},I.autolink=function(T,x){var B=this.rules.inline.autolink.exec(T);if(B){var H,V;return B[2]==="@"?(H=e(this.options.mangle?x(B[1]):B[1]),V="mailto:"+H):(H=e(B[1]),V=H),{type:"link",raw:B[0],text:H,href:V,tokens:[{type:"text",raw:H,text:H}]}}},I.url=function(T,x){var B;if(B=this.rules.inline.url.exec(T)){var H,V;if(B[2]==="@")H=e(this.options.mangle?x(B[0]):B[0]),V="mailto:"+H;else{var G;do G=B[0],B[0]=this.rules.inline._backpedal.exec(B[0])[0];while(G!==B[0]);H=e(B[0]),B[1]==="www."?V="http://"+H:V=H}return{type:"link",raw:B[0],text:H,href:V,tokens:[{type:"text",raw:H,text:H}]}}},I.inlineText=function(T,x){var B=this.rules.inline.text.exec(T);if(B){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]:H=e(this.options.smartypants?x(B[0]):B[0]),{type:"text",raw:B[0],text:H}}},A}(),Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=s(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=s(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=s(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=s(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=s(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=s(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=m({},Q),Q.gfm=m({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=s(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.gfm.paragraph=s(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=m({},Q.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:s(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=s(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=s(Q._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=s(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=s(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=s(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=s(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=s(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=s(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=s(J.reflink).replace("label",J._label).replace("ref",Q._label).getRegex(),J.nolink=s(J.nolink).replace("ref",Q._label).getRegex(),J.reflinkSearch=s(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=m({},J),J.pedantic=m({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=m({},J.normal,{escape:s(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=s(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=m({},J.gfm,{br:s(J.br).replace("{2,}","*").getRegex(),text:s(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ve(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function be(A){var I="",O,T,x=A.length;for(O=0;O<x;O++)T=A.charCodeAt(O),Math.random()>.5&&(T="x"+T.toString(16)),I+="&#"+T+";";return I}var ke=function(){function A(O){this.tokens=[],this.tokens.links=Object.create(null),this.options=O||ee.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:Q.normal,inline:J.normal};this.options.pedantic?(T.block=Q.pedantic,T.inline=J.pedantic):this.options.gfm&&(T.block=Q.gfm,this.options.breaks?T.inline=J.breaks:T.inline=J.gfm),this.tokenizer.rules=T}A.lex=function(T,x){var B=new A(x);return B.lex(T)},A.lexInline=function(T,x){var B=new A(x);return B.inlineTokens(T)};var I=A.prototype;return I.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},I.blockTokens=function(T,x){var B=this;x===void 0&&(x=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(we,ye,Le){return ye+"    ".repeat(Le.length)});for(var H,V,G,re;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(H=we.call({lexer:B},T,x))?(T=T.substring(H.raw.length),x.push(H),!0):!1}))){if(H=this.tokenizer.space(T)){T=T.substring(H.raw.length),H.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(H);continue}if(H=this.tokenizer.code(T)){T=T.substring(H.raw.length),V=x[x.length-1],V&&(V.type==="paragraph"||V.type==="text")?(V.raw+=`
`+H.raw,V.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(H);continue}if(H=this.tokenizer.fences(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.heading(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.hr(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.blockquote(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.list(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.html(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.def(T)){T=T.substring(H.raw.length),V=x[x.length-1],V&&(V.type==="paragraph"||V.type==="text")?(V.raw+=`
`+H.raw,V.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=V.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.lheading(T)){T=T.substring(H.raw.length),x.push(H);continue}if(G=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,ye=T.slice(1),Le=void 0;B.options.extensions.startBlock.forEach(function(Ce){Le=Ce.call({lexer:this},ye),typeof Le=="number"&&Le>=0&&(we=Math.min(we,Le))}),we<1/0&&we>=0&&(G=T.substring(0,we+1))}(),this.state.top&&(H=this.tokenizer.paragraph(G))){V=x[x.length-1],re&&V.type==="paragraph"?(V.raw+=`
`+H.raw,V.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(H),re=G.length!==T.length,T=T.substring(H.raw.length);continue}if(H=this.tokenizer.text(T)){T=T.substring(H.raw.length),V=x[x.length-1],V&&V.type==="text"?(V.raw+=`
`+H.raw,V.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=V.text):x.push(H);continue}if(T){var ce="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return this.state.top=!0,x},I.inline=function(T,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:T,tokens:x}),x},I.inlineTokens=function(T,x){var B=this;x===void 0&&(x=[]);var H,V,G,re=T,ce,we,ye;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(ce=this.tokenizer.rules.inline.reflinkSearch.exec(re))!=null;)Le.includes(ce[0].slice(ce[0].lastIndexOf("[")+1,-1))&&(re=re.slice(0,ce.index)+"["+se("a",ce[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ce=this.tokenizer.rules.inline.blockSkip.exec(re))!=null;)re=re.slice(0,ce.index)+"["+se("a",ce[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ce=this.tokenizer.rules.inline.escapedEmSt.exec(re))!=null;)re=re.slice(0,ce.index)+"++"+re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(we||(ye=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(H=De.call({lexer:B},T,x))?(T=T.substring(H.raw.length),x.push(H),!0):!1}))){if(H=this.tokenizer.escape(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.tag(T)){T=T.substring(H.raw.length),V=x[x.length-1],V&&H.type==="text"&&V.type==="text"?(V.raw+=H.raw,V.text+=H.text):x.push(H);continue}if(H=this.tokenizer.link(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(H.raw.length),V=x[x.length-1],V&&H.type==="text"&&V.type==="text"?(V.raw+=H.raw,V.text+=H.text):x.push(H);continue}if(H=this.tokenizer.emStrong(T,re,ye)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.codespan(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.br(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.del(T)){T=T.substring(H.raw.length),x.push(H);continue}if(H=this.tokenizer.autolink(T,be)){T=T.substring(H.raw.length),x.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(T,be))){T=T.substring(H.raw.length),x.push(H);continue}if(G=T,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=T.slice(1),Ne=void 0;B.options.extensions.startInline.forEach(function(Ke){Ne=Ke.call({lexer:this},Pe),typeof Ne=="number"&&Ne>=0&&(De=Math.min(De,Ne))}),De<1/0&&De>=0&&(G=T.substring(0,De+1))}(),H=this.tokenizer.inlineText(G,ve)){T=T.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(ye=H.raw.slice(-1)),we=!0,V=x[x.length-1],V&&V.type==="text"?(V.raw+=H.raw,V.text+=H.text):x.push(H);continue}if(T){var Ce="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return x},E(A,null,[{key:"rules",get:function(){return{block:Q,inline:J}}}]),A}(),Re=function(){function A(O){this.options=O||ee.defaults}var I=A.prototype;return I.code=function(T,x,B){var H=(x||"").match(/\S*/)[0];if(this.options.highlight){var V=this.options.highlight(T,H);V!=null&&V!==T&&(B=!0,T=V)}return T=T.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+e(H,!0)+'">'+(B?T:e(T,!0))+`</code></pre>
`:"<pre><code>"+(B?T:e(T,!0))+`</code></pre>
`},I.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},I.html=function(T){return T},I.heading=function(T,x,B,H){if(this.options.headerIds){var V=this.options.headerPrefix+H.slug(B);return"<h"+x+' id="'+V+'">'+T+"</h"+x+`>
`}return"<h"+x+">"+T+"</h"+x+`>
`},I.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},I.list=function(T,x,B){var H=x?"ol":"ul",V=x&&B!==1?' start="'+B+'"':"";return"<"+H+V+`>
`+T+"</"+H+`>
`},I.listitem=function(T){return"<li>"+T+`</li>
`},I.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},I.paragraph=function(T){return"<p>"+T+`</p>
`},I.table=function(T,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+x+`</table>
`},I.tablerow=function(T){return`<tr>
`+T+`</tr>
`},I.tablecell=function(T,x){var B=x.header?"th":"td",H=x.align?"<"+B+' align="'+x.align+'">':"<"+B+">";return H+T+("</"+B+`>
`)},I.strong=function(T){return"<strong>"+T+"</strong>"},I.em=function(T){return"<em>"+T+"</em>"},I.codespan=function(T){return"<code>"+T+"</code>"},I.br=function(){return this.options.xhtml?"<br/>":"<br>"},I.del=function(T){return"<del>"+T+"</del>"},I.link=function(T,x,B){if(T=S(this.options.sanitize,this.options.baseUrl,T),T===null)return B;var H='<a href="'+e(T)+'"';return x&&(H+=' title="'+x+'"'),H+=">"+B+"</a>",H},I.image=function(T,x,B){if(T=S(this.options.sanitize,this.options.baseUrl,T),T===null)return B;var H='<img src="'+T+'" alt="'+B+'"';return x&&(H+=' title="'+x+'"'),H+=this.options.xhtml?"/>":">",H},I.text=function(T){return T},A}(),ae=function(){function A(){}var I=A.prototype;return I.strong=function(T){return T},I.em=function(T){return T},I.codespan=function(T){return T},I.del=function(T){return T},I.html=function(T){return T},I.text=function(T){return T},I.link=function(T,x,B){return""+B},I.image=function(T,x,B){return""+B},I.br=function(){return""},A}(),U=function(){function A(){this.seen={}}var I=A.prototype;return I.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},I.getNextSafeSlug=function(T,x){var B=T,H=0;if(this.seen.hasOwnProperty(B)){H=this.seen[T];do H++,B=T+"-"+H;while(this.seen.hasOwnProperty(B))}return x||(this.seen[T]=H,this.seen[B]=0),B},I.slug=function(T,x){x===void 0&&(x={});var B=this.serialize(T);return this.getNextSafeSlug(B,x.dryrun)},A}(),ne=function(){function A(O){this.options=O||ee.defaults,this.options.renderer=this.options.renderer||new Re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ae,this.slugger=new U}A.parse=function(T,x){var B=new A(x);return B.parse(T)},A.parseInline=function(T,x){var B=new A(x);return B.parseInline(T)};var I=A.prototype;return I.parse=function(T,x){x===void 0&&(x=!0);var B="",H,V,G,re,ce,we,ye,Le,Ce,De,Pe,Ne,Ke,xe,He,Ze,Ge,Oe,K,oe=T.length;for(H=0;H<oe;H++){if(De=T[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(K=this.options.extensions.renderers[De.type].call({parser:this},De),K!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){B+=K||"";continue}switch(De.type){case"space":continue;case"hr":{B+=this.renderer.hr();continue}case"heading":{B+=this.renderer.heading(this.parseInline(De.tokens),De.depth,n(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{B+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Le="",ye="",re=De.header.length,V=0;V<re;V++)ye+=this.renderer.tablecell(this.parseInline(De.header[V].tokens),{header:!0,align:De.align[V]});for(Le+=this.renderer.tablerow(ye),Ce="",re=De.rows.length,V=0;V<re;V++){for(we=De.rows[V],ye="",ce=we.length,G=0;G<ce;G++)ye+=this.renderer.tablecell(this.parseInline(we[G].tokens),{header:!1,align:De.align[G]});Ce+=this.renderer.tablerow(ye)}B+=this.renderer.table(Le,Ce);continue}case"blockquote":{Ce=this.parse(De.tokens),B+=this.renderer.blockquote(Ce);continue}case"list":{for(Pe=De.ordered,Ne=De.start,Ke=De.loose,re=De.items.length,Ce="",V=0;V<re;V++)He=De.items[V],Ze=He.checked,Ge=He.task,xe="",He.task&&(Oe=this.renderer.checkbox(Ze),Ke?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=Oe+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=Oe+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:Oe}):xe+=Oe),xe+=this.parse(He.tokens,Ke),Ce+=this.renderer.listitem(xe,Ge,Ze);B+=this.renderer.list(Ce,Pe,Ne);continue}case"html":{B+=this.renderer.html(De.text);continue}case"paragraph":{B+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ce=De.tokens?this.parseInline(De.tokens):De.text;H+1<oe&&T[H+1].type==="text";)De=T[++H],Ce+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);B+=x?this.renderer.paragraph(Ce):Ce;continue}default:{var pe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return B},I.parseInline=function(T,x){x=x||this.renderer;var B="",H,V,G,re=T.length;for(H=0;H<re;H++){if(V=T[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(G=this.options.extensions.renderers[V.type].call({parser:this},V),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(V.type))){B+=G||"";continue}switch(V.type){case"escape":{B+=x.text(V.text);break}case"html":{B+=x.html(V.text);break}case"link":{B+=x.link(V.href,V.title,this.parseInline(V.tokens,x));break}case"image":{B+=x.image(V.href,V.title,V.text);break}case"strong":{B+=x.strong(this.parseInline(V.tokens,x));break}case"em":{B+=x.em(this.parseInline(V.tokens,x));break}case"codespan":{B+=x.codespan(V.text);break}case"br":{B+=x.br();break}case"del":{B+=x.del(this.parseInline(V.tokens,x));break}case"text":{B+=x.text(V.text);break}default:{var ce='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return B},A}();function te(A,I,O){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof I=="function"&&(O=I,I=null),I=m({},te.defaults,I||{}),Z(I),O){var T=I.highlight,x;try{x=ke.lex(A,I)}catch(re){return O(re)}var B=function(ce){var we;if(!ce)try{I.walkTokens&&te.walkTokens(x,I.walkTokens),we=ne.parse(x,I)}catch(ye){ce=ye}return I.highlight=T,ce?O(ce):O(null,we)};if(!T||T.length<3||(delete I.highlight,!x.length))return B();var H=0;te.walkTokens(x,function(re){re.type==="code"&&(H++,setTimeout(function(){T(re.text,re.lang,function(ce,we){if(ce)return B(ce);we!=null&&we!==re.text&&(re.text=we,re.escaped=!0),H--,H===0&&B()})},0))}),H===0&&B();return}function V(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(re.message+"",!0)+"</pre>";throw re}try{var G=ke.lex(A,I);if(I.walkTokens){if(I.async)return Promise.all(te.walkTokens(G,I.walkTokens)).then(function(){return ne.parse(G,I)}).catch(V);te.walkTokens(G,I.walkTokens)}return ne.parse(G,I)}catch(re){V(re)}}te.options=te.setOptions=function(A){return m(te.defaults,A),_(te.defaults),te},te.getDefaults=v,te.defaults=ee.defaults,te.use=function(){for(var A=arguments.length,I=new Array(A),O=0;O<A;O++)I[O]=arguments[O];var T=m.apply(void 0,[{}].concat(I)),x=te.defaults.extensions||{renderers:{},childTokens:{}},B;I.forEach(function(H){if(H.extensions&&(B=!0,H.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var re=x.renderers?x.renderers[G.name]:null;re?x.renderers[G.name]=function(){for(var ce=arguments.length,we=new Array(ce),ye=0;ye<ce;ye++)we[ye]=arguments[ye];var Le=G.renderer.apply(this,we);return Le===!1&&(Le=re.apply(this,we)),Le}:x.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[G.level]?x[G.level].unshift(G.tokenizer):x[G.level]=[G.tokenizer],G.start&&(G.level==="block"?x.startBlock?x.startBlock.push(G.start):x.startBlock=[G.start]:G.level==="inline"&&(x.startInline?x.startInline.push(G.start):x.startInline=[G.start]))}G.childTokens&&(x.childTokens[G.name]=G.childTokens)})),H.renderer&&function(){var G=te.defaults.renderer||new Re,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,De=new Array(Ce),Pe=0;Pe<Ce;Pe++)De[Pe]=arguments[Pe];var Ne=H.renderer[ye].apply(G,De);return Ne===!1&&(Ne=Le.apply(G,De)),Ne}};for(var ce in H.renderer)re(ce);T.renderer=G}(),H.tokenizer&&function(){var G=te.defaults.tokenizer||new ue,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,De=new Array(Ce),Pe=0;Pe<Ce;Pe++)De[Pe]=arguments[Pe];var Ne=H.tokenizer[ye].apply(G,De);return Ne===!1&&(Ne=Le.apply(G,De)),Ne}};for(var ce in H.tokenizer)re(ce);T.tokenizer=G}(),H.walkTokens){var V=te.defaults.walkTokens;T.walkTokens=function(G){var re=[];return re.push(H.walkTokens.call(this,G)),V&&(re=re.concat(V.call(this,G))),re}}B&&(T.extensions=x),te.setOptions(T)})},te.walkTokens=function(A,I){for(var O=[],T=function(){var V=B.value;switch(O=O.concat(I.call(te,V)),V.type){case"table":{for(var G=z(V.header),re;!(re=G()).done;){var ce=re.value;O=O.concat(te.walkTokens(ce.tokens,I))}for(var we=z(V.rows),ye;!(ye=we()).done;)for(var Le=ye.value,Ce=z(Le),De;!(De=Ce()).done;){var Pe=De.value;O=O.concat(te.walkTokens(Pe.tokens,I))}break}case"list":{O=O.concat(te.walkTokens(V.items,I));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[V.type]?te.defaults.extensions.childTokens[V.type].forEach(function(Ne){O=O.concat(te.walkTokens(V[Ne],I))}):V.tokens&&(O=O.concat(te.walkTokens(V.tokens,I)))}},x=z(A),B;!(B=x()).done;)T();return O},te.parseInline=function(A,I){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");I=m({},te.defaults,I||{}),Z(I);try{var O=ke.lexInline(A,I);return I.walkTokens&&te.walkTokens(O,I.walkTokens),ne.parseInline(O,I)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}},te.Parser=ne,te.parser=ne.parse,te.Renderer=Re,te.TextRenderer=ae,te.Lexer=ke,te.lexer=ke.lex,te.Tokenizer=ue,te.Slugger=U,te.parse=te;var ie=te.options,F=te.setOptions,$=te.use,R=te.walkTokens,g=te.parseInline,C=te,W=ne.parse,Y=ke.lex;ee.Lexer=ke,ee.Parser=ne,ee.Renderer=Re,ee.Slugger=U,ee.TextRenderer=ae,ee.Tokenizer=ue,ee.getDefaults=v,ee.lexer=Y,ee.marked=te,ee.options=ie,ee.parse=C,ee.parseInline=g,ee.parser=W,ee.setOptions=F,ee.use=$,ee.walkTokens=R,Object.defineProperty(ee,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,z=0,v=i.length,_=z-1){this.items=i,this.start=z,this.end=v,this.index=_}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class k{constructor(v=[],_=10){this._initialize(v),this._limit=_,this._onChange()}getHistory(){return this._elements}add(v){this._history.delete(v),this._history.add(v),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()===this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(v){return this._history.has(v)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const v=this._elements;this._navigator=new E.ArrayNavigator(v,0,v.length,v.length)}_reduceToLimit(){const v=this._elements;v.length>this._limit&&this._initialize(v.slice(v.length-this._limit))}_currentPosition(){const v=this._navigator.current();return v?this._elements.indexOf(v):-1}_initialize(v){this._history=new Set;for(const _ of v)this._history.add(_)}get _elements(){const v=[];return this._history.forEach(_=>v.push(_)),v}}t.HistoryNavigator=k;class i{constructor(v,_=10){if(this.capacity=_,v.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:v[0],previous:void 0,next:void 0};for(let c=1;c<v.length;c++)this.add(v[c])}add(v){const _={value:v,previous:this.tail,next:void 0};for(this.tail.next=_,this.tail=_,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(v){const _=this.tail.value;return this.tail.value=v,_}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(v){let _=this.head;for(;_;){if(_.value===v)return!0;_=_.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let v=this.head;for(;v;)yield v.value,v=v.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(_,c,l){return Math.min(Math.max(_,c),l)}t.clamp=E;function k(_,c){return(c+_%c)%c}t.rot=k;class i{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=i;class z{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=z;class v{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const l=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=v}),define(ge[45],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(k){function i(c,l){if(c.start>=l.end||l.start>=c.end)return{start:0,end:0};const h=Math.max(c.start,l.start),P=Math.min(c.end,l.end);return P-h<=0?{start:0,end:0}:{start:h,end:P}}k.intersect=i;function z(c){return c.end-c.start<=0}k.isEmpty=z;function v(c,l){return!z(i(c,l))}k.intersects=v;function _(c,l){const h=[],P={start:c.start,end:Math.min(l.start,c.end)},r={start:Math.max(l.end,c.start),end:c.end};return z(P)||h.push(P),z(r)||h.push(r),h}k.relativeComplement=_})(E=t.Range||(t.Range={}))}),define(ge[79],me([1,0,45]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function k(c,l){const h=[];for(const P of l){if(c.start>=P.range.end)continue;if(c.end<P.range.start)break;const r=E.Range.intersect(c,P.range);E.Range.isEmpty(r)||h.push({range:r,size:P.size})}return h}t.groupIntersect=k;function i({start:c,end:l},h){return{start:c+h,end:l+h}}t.shift=i;function z(c){const l=[];let h=null;for(const P of c){const r=P.range.start,a=P.range.end,e=P.size;if(h&&e===h.size){h.range.end=a;continue}h={range:{start:r,end:a},size:e},l.push(h)}return l}t.consolidate=z;function v(...c){return z(c.reduce((l,h)=>l.concat(h),[]))}class _{constructor(){this.groups=[],this._size=0}splice(l,h,P=[]){const r=P.length-h,a=k({start:0,end:l},this.groups),e=k({start:l+h,end:Number.POSITIVE_INFINITY},this.groups).map(n=>({range:i(n.range,r),size:n.size})),o=P.map((n,u)=>({range:{start:l+u,end:l+u+1},size:n.size}));this.groups=v(a,o,e),this._size=this.groups.reduce((n,u)=>n+u.size*(u.range.end-u.range.start),0)}get count(){const l=this.groups.length;return l?this.groups[l-1].range.end:0}get size(){return this._size}indexAt(l){if(l<0)return-1;let h=0,P=0;for(const r of this.groups){const a=r.range.end-r.range.start,e=P+a*r.size;if(l<e)return h+Math.floor((l-P)/r.size);h+=a,P=e}return h}indexAfter(l){return Math.min(this.indexAt(l)+1,this.count)}positionAt(l){if(l<0)return-1;let h=0,P=0;for(const r of this.groups){const a=r.range.end-r.range.start,e=P+a;if(l<e)return h+(l-P)*r.size;h+=a*r.size,P=e}return-1}}t.RangeMap=_}),define(ge[80],me([1,0,7,2]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(w){const S=w;return S?typeof S.read=="function":!1}t.isReadable=i;function z(w){const S=w;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=z;function v(w){const S=w;return S?z(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=v;function _(w,S){return new c(w,S)}t.newWriteableStream=_;class c{constructor(S,f){this.reducer=S,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(f=>f(S))}emitError(S){this.listeners.error.length===0?(0,E.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(f=>f(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,f){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(S,f){if(this.state.destroyed)return;let b;switch(S){case"data":b=this.listeners.data;break;case"end":b=this.listeners.end;break;case"error":b=this.listeners.error;break}if(b){const L=b.indexOf(f);L>=0&&b.splice(L,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(b=>b())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(w,S){const f=[];let b;for(;(b=w.read())!==null;)f.push(b);return S(f)}t.consumeReadable=l;function h(w,S,f){const b=[];let L;for(;(L=w.read())!==null&&b.length<f;)b.push(L);return L===null&&b.length>0?S(b):{read:()=>{if(b.length>0)return b.shift();if(typeof L<"u"){const N=L;return L=void 0,N}return w.read()}}}t.peekReadable=h;function P(w,S){return new Promise((f,b)=>{const L=[];r(w,{onData:N=>{S&&L.push(N)},onError:N=>{S?b(N):f(void 0)},onEnd:()=>{f(S?S(L):void 0)}})})}t.consumeStream=P;function r(w,S){let f=!1;return w.on("error",b=>{f||S.onError(b)}),w.on("end",()=>{f||S.onEnd()}),w.on("data",b=>{f||S.onData(b)}),(0,k.toDisposable)(()=>f=!0)}t.listenStream=r;function a(w,S){return new Promise((f,b)=>{const L=new k.DisposableStore,N=[],y=p=>{if(N.push(p),N.length>S)return L.dispose(),w.pause(),f({stream:w,buffer:N,ended:!1})},d=p=>b(p),m=()=>f({stream:w,buffer:N,ended:!0});L.add((0,k.toDisposable)(()=>w.removeListener("error",d))),w.on("error",d),L.add((0,k.toDisposable)(()=>w.removeListener("end",m))),w.on("end",m),L.add((0,k.toDisposable)(()=>w.removeListener("data",y))),w.on("data",y)})}t.peekStream=a;function e(w,S){const f=_(S);return f.end(w),f}t.toStream=e;function o(){const w=_(()=>{throw new Error("not supported")});return w.end(),w}t.emptyStream=o;function n(w){let S=!1;return{read:()=>S?null:(S=!0,w)}}t.toReadable=n;function u(w,S,f){const b=_(f);return r(w,{onData:L=>b.write(S.data(L)),onError:L=>b.error(S.error?S.error(L):L),onEnd:()=>b.end()}),b}t.transform=u;function s(w,S,f){let b=!1;return{read:()=>{const L=S.read();return b?L:(b=!0,L!==null?f([w,L]):w)}}}t.prefixedReadable=s;function D(w,S,f){let b=!1;const L=_(f);return r(S,{onData:N=>b?L.write(N):(b=!0,L.write(f([w,N]))),onError:N=>L.error(N),onEnd:()=>{b||(b=!0,L.write(w)),L.end()}}),L}t.prefixedStream=D}),define(ge[30],me([1,0,80]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const k=typeof Buffer<"u";let i,z;class v{static alloc(p){return k?new v(Buffer.allocUnsafe(p)):new v(new Uint8Array(p))}static wrap(p){return k&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new v(p)}static fromString(p,M){return!(M?.dontUseNodeBuffer||!1)&&k?new v(Buffer.from(p)):(i||(i=new TextEncoder),new v(i.encode(p)))}static fromByteArray(p){const M=v.alloc(p.length);for(let q=0,Z=p.length;q<Z;q++)M.buffer[q]=p[q];return M}static concat(p,M){if(typeof M>"u"){M=0;for(let se=0,le=p.length;se<le;se++)M+=p[se].byteLength}const q=v.alloc(M);let Z=0;for(let se=0,le=p.length;se<le;se++){const fe=p[se];q.set(fe,Z),Z+=fe.byteLength}return q}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=v.alloc(this.byteLength);return p.set(this),p}toString(){return k?this.buffer.toString():(z||(z=new TextDecoder),z.decode(this.buffer))}slice(p,M){return new v(this.buffer.subarray(p,M))}set(p,M){if(p instanceof v)this.buffer.set(p.buffer,M);else if(p instanceof Uint8Array)this.buffer.set(p,M);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),M);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,M){h(this.buffer,p,M)}readUInt32LE(p){return P(this.buffer,p)}writeUInt32LE(p,M){r(this.buffer,p,M)}readUInt8(p){return a(this.buffer,p)}writeUInt8(p,M){e(this.buffer,p,M)}}t.VSBuffer=v;function _(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}t.readUInt16LE=_;function c(m,p,M){m[M+0]=p&255,p=p>>>8,m[M+1]=p&255}t.writeUInt16LE=c;function l(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}t.readUInt32BE=l;function h(m,p,M){m[M+3]=p,p=p>>>8,m[M+2]=p,p=p>>>8,m[M+1]=p,p=p>>>8,m[M]=p}t.writeUInt32BE=h;function P(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}t.readUInt32LE=P;function r(m,p,M){m[M+0]=p&255,p=p>>>8,m[M+1]=p&255,p=p>>>8,m[M+2]=p&255,p=p>>>8,m[M+3]=p&255}t.writeUInt32LE=r;function a(m,p){return m[p]}t.readUInt8=a;function e(m,p,M){m[M]=p}t.writeUInt8=e;function o(m){return E.consumeReadable(m,p=>v.concat(p))}t.readableToBuffer=o;function n(m){return E.toReadable(m)}t.bufferToReadable=n;function u(m){return E.consumeStream(m,p=>v.concat(p))}t.streamToBuffer=u;async function s(m){return m.ended?v.concat(m.buffer):v.concat([...m.buffer,await u(m.stream)])}t.bufferedStreamToBuffer=s;function D(m){return E.toStream(m,p=>v.concat(p))}t.bufferToStream=D;function w(m){return E.transform(m,{data:p=>typeof p=="string"?v.fromString(p):v.wrap(p)},p=>v.concat(p))}t.streamToBufferReadableStream=w;function S(m){return E.newWriteableStream(p=>v.concat(p),m)}t.newWriteableBufferStream=S;function f(m,p){return E.prefixedReadable(m,p,M=>v.concat(M))}t.prefixedBufferReadable=f;function b(m,p){return E.prefixedStream(m,p,M=>v.concat(M))}t.prefixedBufferStream=b;function L(m){let p=0,M=0,q=0;const Z=new Uint8Array(Math.floor(m.length/4*3)),se=fe=>{switch(M){case 3:Z[q++]=p|fe,M=0;break;case 2:Z[q++]=p|fe>>>2,p=fe<<6,M=3;break;case 1:Z[q++]=p|fe>>>4,p=fe<<4,M=2;break;default:p=fe<<2,M=1}};for(let fe=0;fe<m.length;fe++){const ue=m.charCodeAt(fe);if(ue>=65&&ue<=90)se(ue-65);else if(ue>=97&&ue<=122)se(ue-97+26);else if(ue>=48&&ue<=57)se(ue-48+52);else if(ue===43||ue===45)se(62);else if(ue===47||ue===95)se(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${m[fe]}`)}}const le=q;for(;M>0;)se(0);return v.wrap(Z).slice(0,le)}t.decodeBase64=L;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:m},p=!0,M=!1){const q=M?y:N;let Z="";const se=m.byteLength%3;let le=0;for(;le<m.byteLength-se;le+=3){const fe=m[le+0],ue=m[le+1],Q=m[le+2];Z+=q[fe>>>2],Z+=q[(fe<<4|ue>>>4)&63],Z+=q[(ue<<2|Q>>>6)&63],Z+=q[Q&63]}if(se===1){const fe=m[le+0];Z+=q[fe>>>2],Z+=q[fe<<4&63],p&&(Z+="==")}else if(se===2){const fe=m[le+0],ue=m[le+1];Z+=q[fe>>>2],Z+=q[(fe<<4|ue>>>4)&63],Z+=q[ue<<2&63],p&&(Z+="=")}return Z}t.encodeBase64=d}),define(ge[46],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[6],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(b){return typeof b=="string"}t.isString=E;function k(b){return Array.isArray(b)&&b.every(L=>E(L))}t.isStringArray=k;function i(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}t.isObject=i;function z(b){const L=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof L}t.isTypedArray=z;function v(b){return typeof b=="number"&&!isNaN(b)}t.isNumber=v;function _(b){return!!b&&typeof b[Symbol.iterator]=="function"}t.isIterable=_;function c(b){return b===!0||b===!1}t.isBoolean=c;function l(b){return typeof b>"u"}t.isUndefined=l;function h(b){return!P(b)}t.isDefined=h;function P(b){return l(b)||b===null}t.isUndefinedOrNull=P;function r(b,L){if(!b)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=r;function a(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}t.assertIsDefined=a;function e(...b){const L=[];for(let N=0;N<b.length;N++){const y=b[N];if(P(y))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);L.push(y)}return L}t.assertAllDefined=e;const o=Object.prototype.hasOwnProperty;function n(b){if(!i(b))return!1;for(const L in b)if(o.call(b,L))return!1;return!0}t.isEmptyObject=n;function u(b){return typeof b=="function"}t.isFunction=u;function s(...b){return b.length>0&&b.every(u)}t.areFunctions=s;function D(b,L){const N=Math.min(b.length,L.length);for(let y=0;y<N;y++)w(b[y],L[y])}t.validateConstraints=D;function w(b,L){if(E(L)){if(typeof b!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(u(L)){try{if(b instanceof L)return}catch{}if(!P(b)&&b.constructor===L||L.length===1&&L.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=w;function S(b){return b===null?void 0:b}t.withNullAsUndefined=S;function f(b){return typeof b>"u"?null:b}t.withUndefinedAsNull=f}),define(ge[16],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const k=Object.create(null);function i(_,c){if((0,E.isString)(c)){const l=k[c];if(l===void 0)throw new Error(`${_} references an unknown codicon: ${c}`);c=l}return k[_]=c,{id:_}}function z(){return k}t.getCodiconFontCharacters=z;function v(){return Object.values(t.Codicon)}t.getAllCodicons=v,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[47],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function k(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const s=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([D,w])=>{s[D]=w&&typeof w=="object"?k(w):w}),s}t.deepClone=k;function i(u){if(!u||typeof u!="object")return u;const s=[u];for(;s.length>0;){const D=s.shift();Object.freeze(D);for(const w in D)if(z.call(D,w)){const S=D[w];typeof S=="object"&&!Object.isFrozen(S)&&!(0,E.isTypedArray)(S)&&s.push(S)}}return u}t.deepFreeze=i;const z=Object.prototype.hasOwnProperty;function v(u,s){return _(u,s,new Set)}t.cloneAndChange=v;function _(u,s,D){if((0,E.isUndefinedOrNull)(u))return u;const w=s(u);if(typeof w<"u")return w;if(Array.isArray(u)){const S=[];for(const f of u)S.push(_(f,s,D));return S}if((0,E.isObject)(u)){if(D.has(u))throw new Error("Cannot clone recursive data-structure");D.add(u);const S={};for(const f in u)z.call(u,f)&&(S[f]=_(u[f],s,D));return D.delete(u),S}return u}function c(u,s,D=!0){return(0,E.isObject)(u)?((0,E.isObject)(s)&&Object.keys(s).forEach(w=>{w in u?D&&((0,E.isObject)(u[w])&&(0,E.isObject)(s[w])?c(u[w],s[w],D):u[w]=s[w]):u[w]=s[w]}),u):s}t.mixin=c;function l(u,s){if(u===s)return!0;if(u==null||s===null||s===void 0||typeof u!=typeof s||typeof u!="object"||Array.isArray(u)!==Array.isArray(s))return!1;let D,w;if(Array.isArray(u)){if(u.length!==s.length)return!1;for(D=0;D<u.length;D++)if(!l(u[D],s[D]))return!1}else{const S=[];for(w in u)S.push(w);S.sort();const f=[];for(w in s)f.push(w);if(f.sort(),!l(S,f))return!1;for(D=0;D<S.length;D++)if(!l(u[S[D]],s[S[D]]))return!1}return!0}t.equals=l;function h(u){const s=new Set;return JSON.stringify(u,(D,w)=>{if((0,E.isObject)(w)||Array.isArray(w)){if(s.has(w))return"[Circular]";s.add(w)}return w})}t.safeStringify=h;function P(u,s){const D=Object.create(null);return!u||!s||Object.keys(s).forEach(S=>{const f=u[S],b=s[S];l(f,b)||(D[S]=b)}),D}t.distinct=P;function r(u,s){const D=s.toLowerCase(),w=Object.keys(u).find(S=>S.toLowerCase()===D);return w?u[w]:u[s]}t.getCaseInsensitive=r;function a(u,s){const D=Object.create(null);for(const[w,S]of Object.entries(u))s(w,S)&&(D[w]=S);return D}t.filter=a;function e(u){let s=[],D=Object.getPrototypeOf(u);for(;Object.prototype!==D;)s=s.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return s}t.getAllPropertyNames=e;function o(u){const s=[];for(const D of e(u))typeof u[D]=="function"&&s.push(D);return s}t.getAllMethodNames=o;function n(u,s){const D=S=>function(){const f=Array.prototype.slice.call(arguments,0);return s(S,f)},w={};for(const S of u)w[S]=D(S);return w}t.createProxyObject=n}),define(ge[17],me([1,0,16]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var k;(function(v){function _(c){return c&&typeof c=="object"&&typeof c.id=="string"}v.isThemeColor=_})(k=t.ThemeColor||(t.ThemeColor={}));function i(v){return{id:v}}t.themeColorFromId=i;var z;(function(v){v.iconNameSegment="[A-Za-z0-9]+",v.iconNameExpression="[A-Za-z0-9-]+",v.iconModifierExpression="~[A-Za-z]+",v.iconNameCharacter="[A-Za-z0-9~-]";const _=new RegExp(`^(${v.iconNameExpression})(${v.iconModifierExpression})?$`);function c(s){const D=_.exec(s.id);if(!D)return c(E.Codicon.error);const[,w,S]=D,f=["codicon","codicon-"+w];return S&&f.push("codicon-modifier-"+S.substring(1)),f}v.asClassNameArray=c;function l(s){return c(s).join(" ")}v.asClassName=l;function h(s){return"."+c(s).join(".")}v.asCSSSelector=h;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||k.isThemeColor(s.color))}v.isThemeIcon=P;const r=new RegExp(`^\\$\\((${v.iconNameExpression}(?:${v.iconModifierExpression})?)\\)$`);function a(s){const D=r.exec(s);if(!D)return;const[,w]=D;return{id:w}}v.fromString=a;function e(s){return{id:s}}v.fromId=e;function o(s,D){let w=s.id;const S=w.lastIndexOf("~");return S!==-1&&(w=w.substring(0,S)),D&&(w=`${w}~${D}`),{id:w}}v.modify=o;function n(s){const D=s.id.lastIndexOf("~");if(D!==-1)return s.id.substring(D+1)}v.getModifier=n;function u(s,D){return s.id===D.id&&s.color?.id===D.color?.id}v.isEqual=u})(z=t.ThemeIcon||(t.ThemeIcon={}))}),define(ge[81],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,z){this.sender=i,this.onMessage=z}send(i){try{this.sender.send("vscode:message",i.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(ee,t){return ee.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(ee,t){return ee.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let k=!1,i=!1,z=!1,v=!1,_=!1,c=!1,l=!1,h=!1,P=!1,r=!1,a,e=t.LANGUAGE_DEFAULT,o=t.LANGUAGE_DEFAULT,n,u;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const D=typeof s?.versions?.electron=="string",w=D&&s?.type==="renderer";if(typeof navigator=="object"&&!w)u=navigator.userAgent,k=u.indexOf("Windows")>=0,i=u.indexOf("Macintosh")>=0,h=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,z=u.indexOf("Linux")>=0,r=u?.indexOf("Mobi")>=0,c=!0,a=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=a,o=navigator.language;else if(typeof s=="object"){k=s.platform==="win32",i=s.platform==="darwin",z=s.platform==="linux",v=z&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,l=D,P=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=s.env.VSCODE_NLS_CONFIG;if(p)try{const M=JSON.parse(p),q=M.availableLanguages["*"];a=M.locale,o=M.osLocale,e=q||t.LANGUAGE_DEFAULT,n=M._translationsConfigFile}catch{}_=!0}else console.error("Unable to resolve platform.");var S;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(S=t.Platform||(t.Platform={}));function f(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let b=0;i?b=1:k?b=3:z&&(b=2),t.isWindows=k,t.isMacintosh=i,t.isLinux=z,t.isLinuxSnap=v,t.isNative=_,t.isElectron=l,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=h,t.isMobile=r,t.isCI=P,t.platform=b,t.userAgent=u,t.language=e;var L;(function(p){function M(){return t.language}p.value=M;function q(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=q;function Z(){return t.language==="en"}p.isDefault=Z})(L=t.Language||(t.Language={})),t.locale=a,t.platformLocale=o,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",q=>{if(q.data&&q.data.vscodeScheduleAsyncWork)for(let Z=0,se=p.length;Z<se;Z++){const le=p[Z];if(le.id===q.data.vscodeScheduleAsyncWork){p.splice(Z,1),le.callback();return}}});let M=0;return q=>{const Z=++M;p.push({id:Z,callback:q}),t.globals.postMessage({vscodeScheduleAsyncWork:Z},"*")}}return p=>setTimeout(p)})();var N;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(N=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||h?2:k?1:3;let y=!0,d=!1;function m(){if(!d){d=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,y=new Uint16Array(p.buffer)[0]===(2<<8)+1}return y}t.isLittleEndian=m,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let k;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.platform=k.platform,t.arch=k.arch}),define(ge[22],me([1,0,105]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const k=65,i=97,z=90,v=122,_=46,c=47,l=92,h=58,P=63;class r extends Error{constructor(b,L,N){let y;typeof L=="string"&&L.indexOf("not ")===0?(y="must not be",L=L.replace(/^not /,"")):y="must be";const d=b.indexOf(".")!==-1?"property":"argument";let m=`The "${b}" ${d} ${y} of type ${L}`;m+=`. Received type ${typeof N}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function a(f,b){if(f===null||typeof f!="object")throw new r(b,"Object",f)}function e(f,b){if(typeof f!="string")throw new r(b,"string",f)}const o=E.platform==="win32";function n(f){return f===c||f===l}function u(f){return f===c}function s(f){return f>=k&&f<=z||f>=i&&f<=v}function D(f,b,L,N){let y="",d=0,m=-1,p=0,M=0;for(let q=0;q<=f.length;++q){if(q<f.length)M=f.charCodeAt(q);else{if(N(M))break;M=c}if(N(M)){if(!(m===q-1||p===1))if(p===2){if(y.length<2||d!==2||y.charCodeAt(y.length-1)!==_||y.charCodeAt(y.length-2)!==_){if(y.length>2){const Z=y.lastIndexOf(L);Z===-1?(y="",d=0):(y=y.slice(0,Z),d=y.length-1-y.lastIndexOf(L)),m=q,p=0;continue}else if(y.length!==0){y="",d=0,m=q,p=0;continue}}b&&(y+=y.length>0?`${L}..`:"..",d=2)}else y.length>0?y+=`${L}${f.slice(m+1,q)}`:y=f.slice(m+1,q),d=q-m-1;m=q,p=0}else M===_&&p!==-1?++p:p=-1}return y}function w(f,b){a(b,"pathObject");const L=b.dir||b.root,N=b.base||`${b.name||""}${b.ext||""}`;return L?L===b.root?`${L}${N}`:`${L}${f}${N}`:N}t.win32={resolve(...f){let b="",L="",N=!1;for(let y=f.length-1;y>=-1;y--){let d;if(y>=0){if(d=f[y],e(d,"path"),d.length===0)continue}else b.length===0?d=E.cwd():(d=E.env[`=${b}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==b.toLowerCase()&&d.charCodeAt(2)===l)&&(d=`${b}\\`));const m=d.length;let p=0,M="",q=!1;const Z=d.charCodeAt(0);if(m===1)n(Z)&&(p=1,q=!0);else if(n(Z))if(q=!0,n(d.charCodeAt(1))){let se=2,le=se;for(;se<m&&!n(d.charCodeAt(se));)se++;if(se<m&&se!==le){const fe=d.slice(le,se);for(le=se;se<m&&n(d.charCodeAt(se));)se++;if(se<m&&se!==le){for(le=se;se<m&&!n(d.charCodeAt(se));)se++;(se===m||se!==le)&&(M=`\\\\${fe}\\${d.slice(le,se)}`,p=se)}}}else p=1;else s(Z)&&d.charCodeAt(1)===h&&(M=d.slice(0,2),p=2,m>2&&n(d.charCodeAt(2))&&(q=!0,p=3));if(M.length>0)if(b.length>0){if(M.toLowerCase()!==b.toLowerCase())continue}else b=M;if(N){if(b.length>0)break}else if(L=`${d.slice(p)}\\${L}`,N=q,q&&b.length>0)break}return L=D(L,!N,"\\",n),N?`${b}\\${L}`:`${b}${L}`||"."},normalize(f){e(f,"path");const b=f.length;if(b===0)return".";let L=0,N,y=!1;const d=f.charCodeAt(0);if(b===1)return u(d)?"\\":f;if(n(d))if(y=!0,n(f.charCodeAt(1))){let p=2,M=p;for(;p<b&&!n(f.charCodeAt(p));)p++;if(p<b&&p!==M){const q=f.slice(M,p);for(M=p;p<b&&n(f.charCodeAt(p));)p++;if(p<b&&p!==M){for(M=p;p<b&&!n(f.charCodeAt(p));)p++;if(p===b)return`\\\\${q}\\${f.slice(M)}\\`;p!==M&&(N=`\\\\${q}\\${f.slice(M,p)}`,L=p)}}}else L=1;else s(d)&&f.charCodeAt(1)===h&&(N=f.slice(0,2),L=2,b>2&&n(f.charCodeAt(2))&&(y=!0,L=3));let m=L<b?D(f.slice(L),!y,"\\",n):"";return m.length===0&&!y&&(m="."),m.length>0&&n(f.charCodeAt(b-1))&&(m+="\\"),N===void 0?y?`\\${m}`:m:y?`${N}\\${m}`:`${N}${m}`},isAbsolute(f){e(f,"path");const b=f.length;if(b===0)return!1;const L=f.charCodeAt(0);return n(L)||b>2&&s(L)&&f.charCodeAt(1)===h&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let b,L;for(let d=0;d<f.length;++d){const m=f[d];e(m,"path"),m.length>0&&(b===void 0?b=L=m:b+=`\\${m}`)}if(b===void 0)return".";let N=!0,y=0;if(typeof L=="string"&&n(L.charCodeAt(0))){++y;const d=L.length;d>1&&n(L.charCodeAt(1))&&(++y,d>2&&(n(L.charCodeAt(2))?++y:N=!1))}if(N){for(;y<b.length&&n(b.charCodeAt(y));)y++;y>=2&&(b=`\\${b.slice(y)}`)}return t.win32.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b)return"";const L=t.win32.resolve(f),N=t.win32.resolve(b);if(L===N||(f=L.toLowerCase(),b=N.toLowerCase(),f===b))return"";let y=0;for(;y<f.length&&f.charCodeAt(y)===l;)y++;let d=f.length;for(;d-1>y&&f.charCodeAt(d-1)===l;)d--;const m=d-y;let p=0;for(;p<b.length&&b.charCodeAt(p)===l;)p++;let M=b.length;for(;M-1>p&&b.charCodeAt(M-1)===l;)M--;const q=M-p,Z=m<q?m:q;let se=-1,le=0;for(;le<Z;le++){const ue=f.charCodeAt(y+le);if(ue!==b.charCodeAt(p+le))break;ue===l&&(se=le)}if(le!==Z){if(se===-1)return N}else{if(q>Z){if(b.charCodeAt(p+le)===l)return N.slice(p+le+1);if(le===2)return N.slice(p+le)}m>Z&&(f.charCodeAt(y+le)===l?se=le:le===2&&(se=3)),se===-1&&(se=0)}let fe="";for(le=y+se+1;le<=d;++le)(le===d||f.charCodeAt(le)===l)&&(fe+=fe.length===0?"..":"\\..");return p+=se,fe.length>0?`${fe}${N.slice(p,M)}`:(N.charCodeAt(p)===l&&++p,N.slice(p,M))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const b=t.win32.resolve(f);if(b.length<=2)return f;if(b.charCodeAt(0)===l){if(b.charCodeAt(1)===l){const L=b.charCodeAt(2);if(L!==P&&L!==_)return`\\\\?\\UNC\\${b.slice(2)}`}}else if(s(b.charCodeAt(0))&&b.charCodeAt(1)===h&&b.charCodeAt(2)===l)return`\\\\?\\${b}`;return f},dirname(f){e(f,"path");const b=f.length;if(b===0)return".";let L=-1,N=0;const y=f.charCodeAt(0);if(b===1)return n(y)?f:".";if(n(y)){if(L=N=1,n(f.charCodeAt(1))){let p=2,M=p;for(;p<b&&!n(f.charCodeAt(p));)p++;if(p<b&&p!==M){for(M=p;p<b&&n(f.charCodeAt(p));)p++;if(p<b&&p!==M){for(M=p;p<b&&!n(f.charCodeAt(p));)p++;if(p===b)return f;p!==M&&(L=N=p+1)}}}}else s(y)&&f.charCodeAt(1)===h&&(L=b>2&&n(f.charCodeAt(2))?3:2,N=L);let d=-1,m=!0;for(let p=b-1;p>=N;--p)if(n(f.charCodeAt(p))){if(!m){d=p;break}}else m=!1;if(d===-1){if(L===-1)return".";d=L}return f.slice(0,d)},basename(f,b){b!==void 0&&e(b,"ext"),e(f,"path");let L=0,N=-1,y=!0,d;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===h&&(L=2),b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let m=b.length-1,p=-1;for(d=f.length-1;d>=L;--d){const M=f.charCodeAt(d);if(n(M)){if(!y){L=d+1;break}}else p===-1&&(y=!1,p=d+1),m>=0&&(M===b.charCodeAt(m)?--m===-1&&(N=d):(m=-1,N=p))}return L===N?N=p:N===-1&&(N=f.length),f.slice(L,N)}for(d=f.length-1;d>=L;--d)if(n(f.charCodeAt(d))){if(!y){L=d+1;break}}else N===-1&&(y=!1,N=d+1);return N===-1?"":f.slice(L,N)},extname(f){e(f,"path");let b=0,L=-1,N=0,y=-1,d=!0,m=0;f.length>=2&&f.charCodeAt(1)===h&&s(f.charCodeAt(0))&&(b=N=2);for(let p=f.length-1;p>=b;--p){const M=f.charCodeAt(p);if(n(M)){if(!d){N=p+1;break}continue}y===-1&&(d=!1,y=p+1),M===_?L===-1?L=p:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||y===-1||m===0||m===1&&L===y-1&&L===N+1?"":f.slice(L,y)},format:w.bind(null,"\\"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const L=f.length;let N=0,y=f.charCodeAt(0);if(L===1)return n(y)?(b.root=b.dir=f,b):(b.base=b.name=f,b);if(n(y)){if(N=1,n(f.charCodeAt(1))){let se=2,le=se;for(;se<L&&!n(f.charCodeAt(se));)se++;if(se<L&&se!==le){for(le=se;se<L&&n(f.charCodeAt(se));)se++;if(se<L&&se!==le){for(le=se;se<L&&!n(f.charCodeAt(se));)se++;se===L?N=se:se!==le&&(N=se+1)}}}}else if(s(y)&&f.charCodeAt(1)===h){if(L<=2)return b.root=b.dir=f,b;if(N=2,n(f.charCodeAt(2))){if(L===3)return b.root=b.dir=f,b;N=3}}N>0&&(b.root=f.slice(0,N));let d=-1,m=N,p=-1,M=!0,q=f.length-1,Z=0;for(;q>=N;--q){if(y=f.charCodeAt(q),n(y)){if(!M){m=q+1;break}continue}p===-1&&(M=!1,p=q+1),y===_?d===-1?d=q:Z!==1&&(Z=1):d!==-1&&(Z=-1)}return p!==-1&&(d===-1||Z===0||Z===1&&d===p-1&&d===m+1?b.base=b.name=f.slice(m,p):(b.name=f.slice(m,d),b.base=f.slice(m,p),b.ext=f.slice(d,p))),m>0&&m!==N?b.dir=f.slice(0,m-1):b.dir=b.root,b},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(o){const f=/\\/g;return()=>{const b=E.cwd().replace(f,"/");return b.slice(b.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...f){let b="",L=!1;for(let N=f.length-1;N>=-1&&!L;N--){const y=N>=0?f[N]:S();e(y,"path"),y.length!==0&&(b=`${y}/${b}`,L=y.charCodeAt(0)===c)}return b=D(b,!L,"/",u),L?`/${b}`:b.length>0?b:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===c,L=f.charCodeAt(f.length-1)===c;return f=D(f,!b,"/",u),f.length===0?b?"/":L?"./":".":(L&&(f+="/"),b?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===c},join(...f){if(f.length===0)return".";let b;for(let L=0;L<f.length;++L){const N=f[L];e(N,"path"),N.length>0&&(b===void 0?b=N:b+=`/${N}`)}return b===void 0?".":t.posix.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b||(f=t.posix.resolve(f),b=t.posix.resolve(b),f===b))return"";const L=1,N=f.length,y=N-L,d=1,m=b.length-d,p=y<m?y:m;let M=-1,q=0;for(;q<p;q++){const se=f.charCodeAt(L+q);if(se!==b.charCodeAt(d+q))break;se===c&&(M=q)}if(q===p)if(m>p){if(b.charCodeAt(d+q)===c)return b.slice(d+q+1);if(q===0)return b.slice(d+q)}else y>p&&(f.charCodeAt(L+q)===c?M=q:q===0&&(M=0));let Z="";for(q=L+M+1;q<=N;++q)(q===N||f.charCodeAt(q)===c)&&(Z+=Z.length===0?"..":"/..");return`${Z}${b.slice(d+M)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===c;let L=-1,N=!0;for(let y=f.length-1;y>=1;--y)if(f.charCodeAt(y)===c){if(!N){L=y;break}}else N=!1;return L===-1?b?"/":".":b&&L===1?"//":f.slice(0,L)},basename(f,b){b!==void 0&&e(b,"ext"),e(f,"path");let L=0,N=-1,y=!0,d;if(b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let m=b.length-1,p=-1;for(d=f.length-1;d>=0;--d){const M=f.charCodeAt(d);if(M===c){if(!y){L=d+1;break}}else p===-1&&(y=!1,p=d+1),m>=0&&(M===b.charCodeAt(m)?--m===-1&&(N=d):(m=-1,N=p))}return L===N?N=p:N===-1&&(N=f.length),f.slice(L,N)}for(d=f.length-1;d>=0;--d)if(f.charCodeAt(d)===c){if(!y){L=d+1;break}}else N===-1&&(y=!1,N=d+1);return N===-1?"":f.slice(L,N)},extname(f){e(f,"path");let b=-1,L=0,N=-1,y=!0,d=0;for(let m=f.length-1;m>=0;--m){const p=f.charCodeAt(m);if(p===c){if(!y){L=m+1;break}continue}N===-1&&(y=!1,N=m+1),p===_?b===-1?b=m:d!==1&&(d=1):b!==-1&&(d=-1)}return b===-1||N===-1||d===0||d===1&&b===N-1&&b===L+1?"":f.slice(b,N)},format:w.bind(null,"/"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const L=f.charCodeAt(0)===c;let N;L?(b.root="/",N=1):N=0;let y=-1,d=0,m=-1,p=!0,M=f.length-1,q=0;for(;M>=N;--M){const Z=f.charCodeAt(M);if(Z===c){if(!p){d=M+1;break}continue}m===-1&&(p=!1,m=M+1),Z===_?y===-1?y=M:q!==1&&(q=1):y!==-1&&(q=-1)}if(m!==-1){const Z=d===0&&L?1:d;y===-1||q===0||q===1&&y===m-1&&y===d+1?b.base=b.name=f.slice(Z,m):(b.name=f.slice(Z,y),b.base=f.slice(Z,m),b.ext=f.slice(y,m))}return d>0?b.dir=f.slice(0,d-1):L&&(b.dir="/"),b},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=o?t.win32.normalize:t.posix.normalize,t.isAbsolute=o?t.win32.isAbsolute:t.posix.isAbsolute,t.join=o?t.win32.join:t.posix.join,t.resolve=o?t.win32.resolve:t.posix.resolve,t.relative=o?t.win32.relative:t.posix.relative,t.dirname=o?t.win32.dirname:t.posix.dirname,t.basename=o?t.win32.basename:t.posix.basename,t.extname=o?t.win32.extname:t.posix.extname,t.format=o?t.win32.format:t.posix.format,t.parse=o?t.win32.parse:t.posix.parse,t.toNamespacedPath=o?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=o?t.win32.sep:t.posix.sep,t.delimiter=o?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(h){const P=(0,E.extname)(h),r=k[P.toLowerCase()];return r!==void 0?r:v(h)}t.getMediaOrTextMime=z;function v(h){const P=(0,E.extname)(h);return i[P.toLowerCase()]}t.getMediaMime=v;function _(h){for(const P in i)if(i[P]===h)return P}t.getExtensionForMimeType=_;const c=/^(.+)\/(.+?)(;.+)?$/;function l(h,P){const r=c.exec(h);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:h}t.normalizeMimeType=l}),define(ge[107],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const k=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(v=!0){return new i(v)}constructor(v){this._highResolution=k&&v,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=i}),define(ge[3],me([1,0,7,40,2,43,107]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const _=!1,c=!1;var l;(function(d){d.None=()=>i.Disposable.None;function m(C){if(c){const{onDidAddListener:W}=C,Y=e.create();let A=0;C.onDidAddListener=()=>{++A===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),W?.()}}}function p(C,W){return J(C,()=>{},0,void 0,!0,void 0,W)}d.defer=p;function M(C){return(W,Y=null,A)=>{let I=!1,O;return O=C(T=>{if(!I)return O?O.dispose():I=!0,W.call(Y,T)},null,A),I&&O.dispose(),O}}d.once=M;function q(C,W,Y){return Q((A,I=null,O)=>C(T=>A.call(I,W(T)),null,O),Y)}d.map=q;function Z(C,W,Y){return Q((A,I=null,O)=>C(T=>{W(T),A.call(I,T)},null,O),Y)}d.forEach=Z;function se(C,W,Y){return Q((A,I=null,O)=>C(T=>W(T)&&A.call(I,T),null,O),Y)}d.filter=se;function le(C){return C}d.signal=le;function fe(...C){return(W,Y=null,A)=>(0,i.combinedDisposable)(...C.map(I=>I(O=>W.call(Y,O),null,A)))}d.any=fe;function ue(C,W,Y,A){let I=Y;return q(C,O=>(I=W(I,O),I),A)}d.reduce=ue;function Q(C,W){let Y;const A={onWillAddFirstListener(){Y=C(I.fire,I)},onDidRemoveLastListener(){Y?.dispose()}};W||m(A);const I=new n(A);return W?.add(I),I.event}function J(C,W,Y=100,A=!1,I=!1,O,T){let x,B,H,V=0,G;const re={leakWarningThreshold:O,onWillAddFirstListener(){x=C(we=>{V++,B=W(B,we),A&&!H&&(ce.fire(B),B=void 0),G=()=>{const ye=B;B=void 0,H=void 0,(!A||V>1)&&ce.fire(ye),V=0},typeof Y=="number"?(clearTimeout(H),H=setTimeout(G,Y)):H===void 0&&(H=0,queueMicrotask(G))})},onWillRemoveListener(){I&&V>0&&G?.()},onDidRemoveLastListener(){G=void 0,x.dispose()}};T||m(re);const ce=new n(re);return T?.add(ce),ce.event}d.debounce=J;function ve(C,W=0,Y){return d.debounce(C,(A,I)=>A?(A.push(I),A):[I],W,void 0,!0,void 0,Y)}d.accumulate=ve;function be(C,W=(A,I)=>A===I,Y){let A=!0,I;return se(C,O=>{const T=A||!W(O,I);return A=!1,I=O,T},Y)}d.latch=be;function ke(C,W,Y){return[d.filter(C,W,Y),d.filter(C,A=>!W(A),Y)]}d.split=ke;function Re(C,W=!1,Y=[]){let A=Y.slice(),I=C(x=>{A?A.push(x):T.fire(x)});const O=()=>{A?.forEach(x=>T.fire(x)),A=null},T=new n({onWillAddFirstListener(){I||(I=C(x=>T.fire(x)))},onDidAddFirstListener(){A&&(W?setTimeout(O):O())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return T.event}d.buffer=Re;class ae{constructor(W){this.event=W,this.disposables=new i.DisposableStore}map(W){return new ae(q(this.event,W,this.disposables))}forEach(W){return new ae(Z(this.event,W,this.disposables))}filter(W){return new ae(se(this.event,W,this.disposables))}reduce(W,Y){return new ae(ue(this.event,W,Y,this.disposables))}latch(){return new ae(be(this.event,void 0,this.disposables))}debounce(W,Y=100,A=!1,I=!1,O){return new ae(J(this.event,W,Y,A,I,O,this.disposables))}on(W,Y,A){return this.event(W,Y,A)}once(W,Y,A){return M(this.event)(W,Y,A)}dispose(){this.disposables.dispose()}}function U(C){return new ae(C)}d.chain=U;function ne(C,W,Y=A=>A){const A=(...x)=>T.fire(Y(...x)),I=()=>C.on(W,A),O=()=>C.removeListener(W,A),T=new n({onWillAddFirstListener:I,onDidRemoveLastListener:O});return T.event}d.fromNodeEventEmitter=ne;function te(C,W,Y=A=>A){const A=(...x)=>T.fire(Y(...x)),I=()=>C.addEventListener(W,A),O=()=>C.removeEventListener(W,A),T=new n({onWillAddFirstListener:I,onDidRemoveLastListener:O});return T.event}d.fromDOMEventEmitter=te;function ie(C){return new Promise(W=>M(C)(W))}d.toPromise=ie;function F(C,W){return W(void 0),C(Y=>W(Y))}d.runAndSubscribe=F;function $(C,W){let Y=null;function A(O){Y?.dispose(),Y=new i.DisposableStore,W(O,Y)}A(void 0);const I=C(O=>A(O));return(0,i.toDisposable)(()=>{I.dispose(),Y?.dispose()})}d.runAndSubscribeWithStore=$;class R{constructor(W,Y){this.obs=W,this._counter=0,this._hasChanged=!1;const A={onWillAddFirstListener:()=>{W.addObserver(this)},onDidRemoveLastListener:()=>{W.removeObserver(this)}};Y||m(A),this.emitter=new n(A),Y&&Y.add(this.emitter)}beginUpdate(W){this._counter++}handleChange(W,Y){this._hasChanged=!0}endUpdate(W){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function g(C,W){return new R(C,W).emitter.event}d.fromObservable=g})(l=t.Event||(t.Event={}));class h{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${h._idPool++}`,h.all.add(this)}start(m){this._stopWatch=new v.StopWatch(!0),this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}h.all=new Set,h._idPool=0,t.EventProfiling=h;let P=-1;function r(d){const m=P;return P=d,{dispose(){P=m}}}t.setGlobalLeakWarningThreshold=r;class a{constructor(m,p=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=p,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(m,p){const M=this.threshold;if(M<=0||p<M)return;this._stacks||(this._stacks=new Map);const q=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,q+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let Z,se=0;for(const[le,fe]of this._stacks)(!Z||se<fe)&&(Z=le,se=fe);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${se}):`),console.warn(Z)}return()=>{const Z=this._stacks.get(m.value)||0;this._stacks.set(m.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o{constructor(m,p,M){this.callback=m,this.callbackThis=p,this.stack=M,this.subscription=new i.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class n{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=P>0||this._options?.leakWarningThreshold?new a(this._options?.leakWarningThreshold??P):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(_){const m=Array.from(this._listeners);queueMicrotask(()=>{for(const p of m)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(m,p,M)=>{if(this._listeners||(this._listeners=new z.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const q=this._listeners.isEmpty();q&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let Z,se;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(se=e.create(),Z=this._leakageMon.check(se,this._listeners.size+1)),_&&(se=se??e.create());const le=new o(m,p,se),fe=this._listeners.push(le);q&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,m,p);const ue=le.subscription.set(()=>{Z?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),fe(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof i.DisposableStore?M.add(ue):Array.isArray(M)&&M.push(ue),ue}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s(this._options?.onListenerError));for(const p of this._listeners)this._deliveryQueue.push(this,p,m);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=n;class u{constructor(m=E.onUnexpectedError){this._onListenerError=m,this._queue=new z.LinkedList}get size(){return this._queue.size}push(m,p,M){this._queue.push(new D(m,p,M))}clear(m){const p=new z.LinkedList;for(const M of this._queue)M.emitter!==m&&p.push(M);this._queue=p}deliver(){for(;this._queue.size>0;){const m=this._queue.shift();try{m.listener.invoke(m.event)}catch(p){this._onListenerError(p)}}}}t.EventDeliveryQueue=u;class s extends u{clear(m){this._queue.clear()}}class D{constructor(m,p,M){this.emitter=m,this.listener=p,this.event=M}}class w extends n{async fireAsync(m,p,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new z.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,m]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[q,Z]=this._asyncDeliveryQueue.shift(),se=[],le={...Z,token:p,waitUntil:fe=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");M&&(fe=M(fe,q.callback)),se.push(fe)}};try{q.invoke(le)}catch(fe){(0,E.onUnexpectedError)(fe);continue}Object.freeze(se),await Promise.allSettled(se).then(fe=>{for(const ue of fe)ue.status==="rejected"&&(0,E.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=w;class S extends n{constructor(m){super(m),this._isPaused=0,this._eventQueue=new z.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}t.PauseableEmitter=S;class f extends S{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}t.DebounceEmitter=f;class b extends n{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){!this.hasListeners()||(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(p=>super.fire(p)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=b;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const p={event:m,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const M=()=>{this.hasListeners&&this.unhook(p);const q=this.events.indexOf(p);this.events.splice(q,1)};return(0,i.toDisposable)((0,k.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(p=>this.emitter.fire(p))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=L;class N{constructor(){this.buffers=[]}wrapEvent(m){return(p,M,q)=>m(Z=>{const se=this.buffers[this.buffers.length-1];se?se.push(()=>p.call(M,Z)):p.call(M,Z)},void 0,q)}bufferEvents(m){const p=[];this.buffers.push(p);const M=m();return this.buffers.pop(),p.forEach(q=>q()),M}}t.EventBufferer=N;class y{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=i.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=y}),define(ge[18],me([1,0,3,2]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new E.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(w,S){this._zoomLevel!==w&&(this._zoomLevel=w)}getZoomFactor(){return this._zoomFactor}setZoomFactor(w){this._zoomFactor=w}setFullscreen(w){this._fullscreen!==w&&(this._fullscreen=w,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}i.INSTANCE=new i;class z extends k.Disposable{constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(w){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),w&&this._onDidChange.fire()}}class v extends k.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const w=this._register(new z);this._register(w.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const w=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,f=w.webkitBackingStorePixelRatio||w.mozBackingStorePixelRatio||w.msBackingStorePixelRatio||w.oBackingStorePixelRatio||w.backingStorePixelRatio||1;return S/f}}class _{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,k.markAsSingleton)(new v)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function c(D,w){typeof D=="string"&&(D=window.matchMedia(D)),D.addEventListener("change",w)}t.addMatchMediaChangeListener=c,t.PixelRatio=new _;function l(D,w){i.INSTANCE.setZoomLevel(D,w)}t.setZoomLevel=l;function h(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=h;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(D){i.INSTANCE.setZoomFactor(D)}t.setZoomFactor=r;function a(D){i.INSTANCE.setFullscreen(D)}t.setFullscreen=a;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const o=navigator.userAgent;t.isFirefox=o.indexOf("Firefox")>=0,t.isWebKit=o.indexOf("AppleWebKit")>=0,t.isChrome=o.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&o.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=o.indexOf("Electron/")>=0,t.isAndroid=o.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const D=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),w=window.matchMedia("(display-mode: fullscreen)");n=D.matches,c(D,({matches:S})=>{n&&w.matches||(n=S)})}function u(){return n}t.isStandalone=u;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(ge[108],me([1,0,18,5]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(z){z[z.Always=0]="Always",z[z.FullScreen=1]="FullScreen",z[z.None=2]="None"})(i=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:k.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:k.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>k.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class k{get event(){return this.emitter.event}constructor(z,v,_){const c=l=>this.emitter.fire(l);this.emitter=new E.Emitter({onWillAddFirstListener:()=>z.addEventListener(v,c,_),onDidRemoveLastListener:()=>z.removeEventListener(v,c,_)})}dispose(){this.emitter.dispose()}}t.DomEmitter=k}),define(ge[14],me([1,0,18,41,74,5]),function(ee,t,E,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function v(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return k.KeyCodeUtils.fromString(n)}const o=e.keyCode;if(o===3)return 7;if(E.isFirefox){if(o===59)return 80;if(o===107)return 81;if(o===109)return 83;if(z.isMacintosh&&o===224)return 57}else if(E.isWebKit){if(o===91)return 57;if(z.isMacintosh&&o===93)return 57;if(!z.isMacintosh&&o===92)return 57}return k.EVENT_KEY_CODE_MAP[o]||0}const _=z.isMacintosh?256:2048,c=512,l=1024,h=z.isMacintosh?2048:256;function P(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${k.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class a{constructor(o){this._standardKeyboardEventBrand=!0;const n=o;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=v(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(o){return this._asKeybinding===o}_computeKeybinding(){let o=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode);let n=0;return this.ctrlKey&&(n|=_),this.altKey&&(n|=c),this.shiftKey&&(n|=l),this.metaKey&&(n|=h),n|=o,n}_computeKeyCodeChord(){let o=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,o)}}t.StandardKeyboardEvent=a}),define(ge[21],me([1,0,18,66,5]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class z{constructor(l){this.timestamp=Date.now(),this.browserEvent=l,this.leftButton=l.button===0,this.middleButton=l.button===1,this.rightButton=l.button===2,this.buttons=l.buttons,this.target=l.target,this.detail=l.detail||1,l.type==="dblclick"&&(this.detail=2),this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,typeof l.pageX=="number"?(this.posx=l.pageX,this.posy=l.pageY):(this.posx=l.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=l.clientY+document.body.scrollTop+document.documentElement.scrollTop);const h=k.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,l.view);this.posx-=h.left,this.posy-=h.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=z;class v extends z{constructor(l){super(l),this.dataTransfer=l.dataTransfer}}t.DragMouseEvent=v;class _{constructor(l,h=0,P=0){if(this.browserEvent=l||null,this.target=l?l.target||l.targetNode||l.srcElement:null,this.deltaY=P,this.deltaX=h,l){const r=l,a=l;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-l.deltaY/3:this.deltaY=-l.deltaY:this.deltaY=-l.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-l.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-l.deltaX/3:this.deltaX=-l.deltaX:this.deltaX=-l.deltaX/40}this.deltaY===0&&this.deltaX===0&&l.wheelDelta&&(this.deltaY=l.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=_}),define(ge[31],me([1,0,3,2,103]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class z extends k.Disposable{constructor(r,a="",e="",o=!0,n){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=r,this._label=a,this._cssClass=e,this._enabled=o,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(r){this._setLabel(r)}_setLabel(r){this._label!==r&&(this._label=r,this._onDidChange.fire({label:r}))}get tooltip(){return this._tooltip||""}set tooltip(r){this._setTooltip(r)}_setTooltip(r){this._tooltip!==r&&(this._tooltip=r,this._onDidChange.fire({tooltip:r}))}get class(){return this._cssClass}set class(r){this._setClass(r)}_setClass(r){this._cssClass!==r&&(this._cssClass=r,this._onDidChange.fire({class:r}))}get enabled(){return this._enabled}set enabled(r){this._setEnabled(r)}_setEnabled(r){this._enabled!==r&&(this._enabled=r,this._onDidChange.fire({enabled:r}))}get checked(){return this._checked}set checked(r){this._setChecked(r)}_setChecked(r){this._checked!==r&&(this._checked=r,this._onDidChange.fire({checked:r}))}async run(r,a){this._actionCallback&&await this._actionCallback(r)}}t.Action=z;class v extends k.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new E.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event}async run(r,a){if(!r.enabled)return;this._onWillRun.fire({action:r});let e;try{await this.runAction(r,a)}catch(o){e=o}this._onDidRun.fire({action:r,error:e})}async runAction(r,a){await r.run(a)}}t.ActionRunner=v;class _{constructor(){this.id=_.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let a=[];for(const e of r)e.length&&(a.length?a=[...a,new _,...e]:a=e);return a}async run(){}}_.ID="vs.actions.separator",t.Separator=_;class c{get actions(){return this._actions}constructor(r,a,e,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=a,this.class=o,this._actions=e}async run(){}}t.SubmenuAction=c;class l extends z{constructor(){super(l.ID,i.localize(0,null),void 0,!1)}}l.ID="vs.actions.empty",t.EmptySubmenuAction=l;function h(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=h}),define(ge[27],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const k=Object.freeze(function(_,c){const l=setTimeout(_.bind(c),0);return{dispose(){clearTimeout(l)}}});var i;(function(_){function c(l){return l===_.None||l===_.Cancelled||l instanceof z?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}_.isCancellationToken=c,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i=t.CancellationToken||(t.CancellationToken={}));class z{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class v{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new z),this._token}cancel(){this._token?this._token instanceof z&&this._token.cancel():this._token=i.Cancelled}dispose(c=!1){c&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof z&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=v}),define(ge[109],me([1,0,27]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class k{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new E.CancellationTokenSource,c=this.task(_.token);return this.result={promise:c,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}t.Cache=k;class i{constructor(_){this.fn=_,this.lastCache=void 0,this.lastArgKey=void 0}get(_){const c=JSON.stringify(_);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this.fn(_)),this.lastCache}}t.LRUCachedFunction=i;class z{get cachedValues(){return this._map}constructor(_){this.fn=_,this._map=new Map}get(_){if(this._map.has(_))return this._map.get(_);const c=this.fn(_);return this._map.set(_,c),c}}t.CachedFunction=z}),define(ge[49],me([1,0,3,2]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class z{constructor(e,o,n,u,s,D,w){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(o=o|0,n=n|0,u=u|0,s=s|0,D=D|0,w=w|0),this.rawScrollLeft=u,this.rawScrollTop=w,o<0&&(o=0),u+o>n&&(u=n-o),u<0&&(u=0),s<0&&(s=0),w+s>D&&(w=D-s),w<0&&(w=0),this.width=o,this.scrollWidth=n,this.scrollLeft=u,this.height=s,this.scrollHeight=D,this.scrollTop=w}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,o){return new z(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new z(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,o){const n=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,w=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:o,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:u,scrollLeftChanged:s,heightChanged:D,scrollHeightChanged:w,scrollTopChanged:S}}}t.ScrollState=z;class v extends k.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new E.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new z(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,o){const n=this._state.withScrollDimensions(e,o);this._setState(n,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const o=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(o,!1)}setScrollPositionSmooth(e,o){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const n=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===n.scrollLeft&&this._smoothScrolling.to.scrollTop===n.scrollTop)return;let u;o?u=new h(this._smoothScrolling.from,n,this._smoothScrolling.startTime,this._smoothScrolling.duration):u=this._smoothScrolling.combine(this._state,n,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=u}else{const n=this._state.withScrollPosition(e);this._smoothScrolling=h.start(this._state,n,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),o=this._state.withScrollPosition(e);if(this._setState(o,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,o){const n=this._state;n.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(n,o)))}}t.Scrollable=v;class _{constructor(e,o,n){this.scrollLeft=e,this.scrollTop=o,this.isDone=n}}t.SmoothScrollingUpdate=_;function c(a,e){const o=e-a;return function(n){return a+o*r(n)}}function l(a,e,o){return function(n){return n<o?a(n/o):e((n-o)/(1-o))}}class h{constructor(e,o,n,u){this.from=e,this.to=o,this.duration=u,this.startTime=n,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,o,n){if(Math.abs(e-o)>2.5*n){let s,D;return e<o?(s=e+.75*n,D=o-.75*n):(s=e-.75*n,D=o+.75*n),l(c(e,s),c(D,o),.33)}return c(e,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const o=(e-this.startTime)/this.duration;if(o<1){const n=this.scrollLeft(o),u=this.scrollTop(o);return new _(n,u,!1)}return new _(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,o,n){return h.start(e,o,n)}static start(e,o,n){n=n+10;const u=Date.now()-10;return new h(e,o,u,n)}}t.SmoothScrollingOperation=h;function P(a){return Math.pow(a,3)}function r(a){return 1-P(1-a)}}),define(ge[11],me([1,0,109,42]),function(ee,t,E,k){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function z(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=z;const v=/{(\d+)}/g;function _(K,...oe){return oe.length===0?K:K.replace(v,function(pe,Ee){const Se=parseInt(Ee,10);return isNaN(Se)||Se<0||Se>=oe.length?pe:oe[Se]})}t.format=_;const c=/{([^}]+)}/g;function l(K,oe){return K.replace(c,(pe,Ee)=>oe[Ee]??pe)}t.format2=l;function h(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=h;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(K,oe){let pe=0;const Ee=oe.charCodeAt(0);for(let Se=K.length-1;Se>=0;Se--)K.charCodeAt(Se)===Ee&&pe++;return pe}t.count=r;function a(K,oe,pe="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${pe}`}t.truncate=a;function e(K,oe=" "){const pe=o(K,oe);return n(pe,oe)}t.trim=e;function o(K,oe){if(!K||!oe)return K;const pe=oe.length;if(pe===0||K.length===0)return K;let Ee=0;for(;K.indexOf(oe,Ee)===Ee;)Ee=Ee+pe;return K.substring(Ee)}t.ltrim=o;function n(K,oe){if(!K||!oe)return K;const pe=oe.length,Ee=K.length;if(pe===0||Ee===0)return K;let Se=Ee,Me=-1;for(;Me=K.lastIndexOf(oe,Se-1),!(Me===-1||Me+pe!==Se);){if(Me===0)return"";Se=Me}return K.substring(0,Se)}t.rtrim=n;function u(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function s(K){return K.replace(/\*/g,"")}t.stripWildcards=s;function D(K,oe,pe={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=P(K)),pe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(K,Ee)}t.createRegExp=D;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=w;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function f(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=f;function b(K){return K.split(/\r\n|\r|\n/)}t.splitLines=b;function L(K){for(let oe=0,pe=K.length;oe<pe;oe++){const Ee=K.charCodeAt(oe);if(Ee!==32&&Ee!==9)return oe}return-1}t.firstNonWhitespaceIndex=L;function N(K,oe=0,pe=K.length){for(let Ee=oe;Ee<pe;Ee++){const Se=K.charCodeAt(Ee);if(Se!==32&&Se!==9)return K.substring(oe,Ee)}return K.substring(oe,pe)}t.getLeadingWhitespace=N;function y(K,oe=K.length-1){for(let pe=oe;pe>=0;pe--){const Ee=K.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.lastNonWhitespaceIndex=y;function d(K,oe,pe){const Ee=[];let Se=0;for(const Me of K.matchAll(oe)){if(Ee.push(K.slice(Se,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Se=Me.index+Me[0].length,Ee.push(pe(Me[0],...Me.slice(1),Me.index,K,Me.groups))}return Ee.push(K.slice(Se)),Promise.all(Ee).then(Me=>Me.join(""))}t.replaceAsync=d;function m(K,oe){return K<oe?-1:K>oe?1:0}t.compare=m;function p(K,oe,pe=0,Ee=K.length,Se=0,Me=oe.length){for(;pe<Ee&&Se<Me;pe++,Se++){const je=K.charCodeAt(pe),$e=oe.charCodeAt(Se);if(je<$e)return-1;if(je>$e)return 1}const ze=Ee-pe,tt=Me-Se;return ze<tt?-1:ze>tt?1:0}t.compareSubstring=p;function M(K,oe){return q(K,oe,0,K.length,0,oe.length)}t.compareIgnoreCase=M;function q(K,oe,pe=0,Ee=K.length,Se=0,Me=oe.length){for(;pe<Ee&&Se<Me;pe++,Se++){let je=K.charCodeAt(pe),$e=oe.charCodeAt(Se);if(je===$e)continue;if(je>=128||$e>=128)return p(K.toLowerCase(),oe.toLowerCase(),pe,Ee,Se,Me);se(je)&&(je-=32),se($e)&&($e-=32);const Fe=je-$e;if(Fe!==0)return Fe}const ze=Ee-pe,tt=Me-Se;return ze<tt?-1:ze>tt?1:0}t.compareSubstringIgnoreCase=q;function Z(K){return K>=48&&K<=57}t.isAsciiDigit=Z;function se(K){return K>=97&&K<=122}t.isLowerAsciiLetter=se;function le(K){return K>=65&&K<=90}t.isUpperAsciiLetter=le;function fe(K,oe){return K.length===oe.length&&q(K,oe)===0}t.equalsIgnoreCase=fe;function ue(K,oe){const pe=oe.length;return oe.length>K.length?!1:q(K,oe,0,pe)===0}t.startsWithIgnoreCase=ue;function Q(K,oe){const pe=Math.min(K.length,oe.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Ee)!==oe.charCodeAt(Ee))return Ee;return pe}t.commonPrefixLength=Q;function J(K,oe){const pe=Math.min(K.length,oe.length);let Ee;const Se=K.length-1,Me=oe.length-1;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Se-Ee)!==oe.charCodeAt(Me-Ee))return Ee;return pe}t.commonSuffixLength=J;function ve(K){return 55296<=K&&K<=56319}t.isHighSurrogate=ve;function be(K){return 56320<=K&&K<=57343}t.isLowSurrogate=be;function ke(K,oe){return(K-55296<<10)+(oe-56320)+65536}t.computeCodePoint=ke;function Re(K,oe,pe){const Ee=K.charCodeAt(pe);if(ve(Ee)&&pe+1<oe){const Se=K.charCodeAt(pe+1);if(be(Se))return ke(Ee,Se)}return Ee}t.getNextCodePoint=Re;function ae(K,oe){const pe=K.charCodeAt(oe-1);if(be(pe)&&oe>1){const Ee=K.charCodeAt(oe-2);if(ve(Ee))return ke(Ee,pe)}return pe}class U{get offset(){return this._offset}constructor(oe,pe=0){this._str=oe,this._len=oe.length,this._offset=pe}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ae(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=Re(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=U;class ne{get offset(){return this._iterator.offset}constructor(oe,pe=0){this._iterator=new U(oe,pe)}nextGraphemeLength(){const oe=Pe.getInstance(),pe=this._iterator,Ee=pe.offset;let Se=oe.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,ze=oe.getGraphemeBreakType(pe.nextCodePoint());if(Ce(Se,ze)){pe.setOffset(Me);break}Se=ze}return pe.offset-Ee}prevGraphemeLength(){const oe=Pe.getInstance(),pe=this._iterator,Ee=pe.offset;let Se=oe.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,ze=oe.getGraphemeBreakType(pe.prevCodePoint());if(Ce(ze,Se)){pe.setOffset(Me);break}Se=ze}return Ee-pe.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function te(K,oe){return new ne(K,oe).nextGraphemeLength()}t.nextCharLength=te;function ie(K,oe){return new ne(K,oe).prevGraphemeLength()}t.prevCharLength=ie;function F(K,oe){oe>0&&be(K.charCodeAt(oe))&&oe--;const pe=oe+te(K,oe);return[pe-ie(K,pe),pe]}t.getCharContainingOffset=F;function $(K){const oe=new ne(K);let pe=0;for(;!oe.eol();)pe++,oe.nextGraphemeLength();return pe}t.charCount=$;let R;function g(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(K){return R||(R=g()),R.test(K)}t.containsRTL=C;const W=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return W.test(K)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function A(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=A;function I(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=I;function O(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=O;function T(K,oe){if(K.length<oe)return K;const pe=/\b/g;let Ee=0;for(;pe.test(K)&&!(K.length-pe.lastIndex<oe);)Ee=pe.lastIndex,pe.lastIndex+=1;return K.substring(Ee).replace(/^\s/,"")}t.lcut=T;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function B(K){return K&&(K=K.replace(x,"")),K}t.removeAnsiEscapeCodes=B,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function H(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=H;function V(K){return H(K)?K.substr(1):K}t.stripUTF8BOM=V;function G(K,oe){if(!K||!oe||K.length<oe.length)return!1;const pe=oe.length,Ee=K.toLowerCase();let Se=0,Me=-1;for(;Se<pe;){const ze=Ee.indexOf(oe[Se],Me+1);if(ze<0)return!1;Me=ze,Se++}return!0}t.fuzzyContains=G;function re(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=re;function ce(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=ce;function we(K,oe=1){if(oe===0)return"";let pe=-1;do pe=K.indexOf(`
`,pe+1),oe--;while(oe>0&&pe>=0);return pe===-1?K:(K[pe-1]==="\r"&&pe--,K.substr(0,pe))}t.getNLines=we;function ye(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=ye;function Le(K){return Pe.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=Le;function Ce(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}var De;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(De=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const pe=this._data,Ee=pe.length/3;let Se=1;for(;Se<=Ee;)if(oe<pe[3*Se])Se=2*Se;else if(oe>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Pe._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(K,oe){if(K===0)return 0;const pe=xe(K,oe);if(pe!==void 0)return pe;const Ee=new U(oe,K);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=Ke;function xe(K,oe){const pe=new U(oe,K);let Ee=pe.prevCodePoint();for(;He(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!O(Ee))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function He(K){return 127995<=K&&K<=127999}var Ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.noBreakWhitespace="\xA0";class Ge{static getInstance(oe){return Ge.cache.get(Array.from(oe))}static getLocales(){return Ge._locales.value}constructor(oe){this.confusableDictionary=oe}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i=Ge,Ge.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.cache=new E.LRUCachedFunction(K=>{function oe($e){const Fe=new Map;for(let he=0;he<$e.length;he+=2)Fe.set($e[he],$e[he+1]);return Fe}function pe($e,Fe){const he=new Map($e);for(const[_e,Ie]of Fe)he.set(_e,Ie);return he}function Ee($e,Fe){if(!$e)return Fe;const he=new Map;for(const[_e,Ie]of $e)Fe.has(_e)&&he.set(_e,Ie);return he}const Se=i.ambiguousCharacterData.value;let Me=K.filter($e=>!$e.startsWith("_")&&$e in Se);Me.length===0&&(Me=["_default"]);let ze;for(const $e of Me){const Fe=oe(Se[$e]);ze=Ee(ze,Fe)}const tt=oe(Se._common),je=pe(tt,ze);return new Ge(je)}),Ge._locales=new k.Lazy(()=>Object.keys(Ge.ambiguousCharacterData.value).filter(K=>!K.startsWith("_"))),t.AmbiguousCharacters=Ge;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}Oe._data=void 0,t.InvisibleCharacters=Oe}),define(ge[110],me([1,0,22,5,11,6]),function(ee,t,E,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function v(d){return d===47||d===92}t.isPathSeparator=v;function _(d){return d.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=_;function c(d){return d.indexOf("/")===-1&&(d=_(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}t.toPosixPath=c;function l(d,m=E.posix.sep){if(!d)return"";const p=d.length,M=d.charCodeAt(0);if(v(M)){if(v(d.charCodeAt(1))&&!v(d.charCodeAt(2))){let Z=3;const se=Z;for(;Z<p&&!v(d.charCodeAt(Z));Z++);if(se!==Z&&!v(d.charCodeAt(Z+1))){for(Z+=1;Z<p;Z++)if(v(d.charCodeAt(Z)))return d.slice(0,Z+1).replace(/[\\/]/g,m)}}return m}else if(u(M)&&d.charCodeAt(1)===58)return v(d.charCodeAt(2))?d.slice(0,2)+m:d.slice(0,2);let q=d.indexOf("://");if(q!==-1){for(q+=3;q<p;q++)if(v(d.charCodeAt(q)))return d.slice(0,q+1)}return""}t.getRoot=l;function h(d){if(!k.isWindows||!d||d.length<5)return!1;let m=d.charCodeAt(0);if(m!==92||(m=d.charCodeAt(1),m!==92))return!1;let p=2;const M=p;for(;p<d.length&&(m=d.charCodeAt(p),m!==92);p++);return!(M===p||(m=d.charCodeAt(p+1),isNaN(m)||m===92))}t.isUNC=h;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(d,m=k.isWindows){const p=m?P:r;return!(!d||d.length===0||/^\s+$/.test(d)||(p.lastIndex=0,p.test(d))||m&&a.test(d)||d==="."||d===".."||m&&d[d.length-1]==="."||m&&d.length!==d.trim().length||d.length>255)}t.isValidBasename=e;function o(d,m,p){const M=d===m;return!p||M?M:!d||!m?!1:(0,i.equalsIgnoreCase)(d,m)}t.isEqual=o;function n(d,m,p,M=E.sep){if(d===m)return!0;if(!d||!m||m.length>d.length)return!1;if(p){if(!(0,i.startsWithIgnoreCase)(d,m))return!1;if(m.length===d.length)return!0;let Z=m.length;return m.charAt(m.length-1)===M&&Z--,d.charAt(Z)===M}return m.charAt(m.length-1)!==M&&(m+=M),d.indexOf(m)===0}t.isEqualOrParent=n;function u(d){return d>=65&&d<=90||d>=97&&d<=122}t.isWindowsDriveLetter=u;function s(d,m){return k.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(m,d)),d=(0,E.normalize)(d),k.isWindows?(d=(0,i.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,i.rtrim)(d,E.sep),d||(d=E.sep)),d}t.sanitizeFilePath=s;function D(d){const m=(0,E.normalize)(d);return k.isWindows?d.length>3?!1:w(m)&&(d.length===2||m.charCodeAt(2)===92):m===E.posix.sep}t.isRootOrDriveLetter=D;function w(d,m=k.isWindows){return m?u(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}t.hasDriveLetter=w;function S(d){return w(d)?d[0]:void 0}t.getDriveLetter=S;function f(d,m,p){return m.length>d.length?-1:d===m?0:(p&&(d=d.toLowerCase(),m=m.toLowerCase()),d.indexOf(m))}t.indexOfPath=f;function b(d){const m=d.split(":");let p,M,q;for(const Z of m){const se=Number(Z);(0,z.isNumber)(se)?M===void 0?M=se:q===void 0&&(q=se):p=p?[p,Z].join(":"):Z}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:M!==void 0?M:void 0,column:q!==void 0?q:M!==void 0?1:void 0}}t.parseLineAndColumnAware=b;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,m,p=8){let M="";for(let Z=0;Z<p;Z++){let se;Z===0&&k.isWindows&&!m&&(p===3||p===4)?se=N:se=L,M+=se.charAt(Math.floor(Math.random()*se.length))}let q;return m?q=`${m}-${M}`:q=M,d?(0,E.join)(d,q):q}t.randomPath=y}),define(ge[32],me([1,0,75,11]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...B){return function(H,V){for(let G=0,re=B.length;G<re;G++){const ce=B[G](H,V);if(ce)return ce}return null}}t.or=i,t.matchesStrictPrefix=z.bind(void 0,!1),t.matchesPrefix=z.bind(void 0,!0);function z(B,H,V){if(!V||V.length<H.length)return null;let G;return B?G=k.startsWithIgnoreCase(V,H):G=V.indexOf(H)===0,G?H.length>0?[{start:0,end:H.length}]:[]:null}function v(B,H){const V=H.toLowerCase().indexOf(B.toLowerCase());return V===-1?null:[{start:V,end:V+B.length}]}t.matchesContiguousSubString=v;function _(B,H){return c(B.toLowerCase(),H.toLowerCase(),0,0)}t.matchesSubString=_;function c(B,H,V,G){if(V===B.length)return[];if(G===H.length)return null;if(B[V]===H[G]){let re=null;return(re=c(B,H,V+1,G+1))?u({start:G,end:G+1},re):null}return c(B,H,V,G+1)}function l(B){return 97<=B&&B<=122}function h(B){return 65<=B&&B<=90}t.isUpper=h;function P(B){return 48<=B&&B<=57}function r(B){return B===32||B===9||B===10||B===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>a.add(B.charCodeAt(0)));function e(B){return r(B)||a.has(B)}function o(B,H){return B===H||e(B)&&e(H)}function n(B){return l(B)||h(B)||P(B)}function u(B,H){return H.length===0?H=[B]:B.end===H[0].start?H[0].start=B.start:H.unshift(B),H}function s(B,H){for(let V=H;V<B.length;V++){const G=B.charCodeAt(V);if(h(G)||P(G)||V>0&&!n(B.charCodeAt(V-1)))return V}return B.length}function D(B,H,V,G){if(V===B.length)return[];if(G===H.length)return null;if(B[V]!==H[G].toLowerCase())return null;{let re=null,ce=G+1;for(re=D(B,H,V+1,G+1);!re&&(ce=s(H,ce))<H.length;)re=D(B,H,V+1,ce),ce++;return re===null?null:u({start:G,end:G+1},re)}}function w(B){let H=0,V=0,G=0,re=0,ce=0;for(let De=0;De<B.length;De++)ce=B.charCodeAt(De),h(ce)&&H++,l(ce)&&V++,n(ce)&&G++,P(ce)&&re++;const we=H/B.length,ye=V/B.length,Le=G/B.length,Ce=re/B.length;return{upperPercent:we,lowerPercent:ye,alphaPercent:Le,numericPercent:Ce}}function S(B){const{upperPercent:H,lowerPercent:V}=B;return V===0&&H>.6}function f(B){const{upperPercent:H,lowerPercent:V,alphaPercent:G,numericPercent:re}=B;return V>.2&&H<.8&&G>.6&&re<.2}function b(B){let H=0,V=0,G=0,re=0;for(let ce=0;ce<B.length;ce++)G=B.charCodeAt(ce),h(G)&&H++,l(G)&&V++,r(G)&&re++;return(H===0||V===0)&&re===0?B.length<=30:H<=5}function L(B,H){if(!H||(H=H.trim(),H.length===0)||!b(B)||H.length>60)return null;const V=w(H);if(!f(V)){if(!S(V))return null;H=H.toLowerCase()}let G=null,re=0;for(B=B.toLowerCase();re<H.length&&(G=D(B,H,0,re))===null;)re=s(H,re+1);return G}t.matchesCamelCase=L;function N(B,H,V=!1){if(!H||H.length===0)return null;let G=null,re=0;for(B=B.toLowerCase(),H=H.toLowerCase();re<H.length&&(G=y(B,H,0,re,V))===null;)re=d(H,re+1);return G}t.matchesWords=N;function y(B,H,V,G,re){if(V===B.length)return[];if(G===H.length)return null;if(o(B.charCodeAt(V),H.charCodeAt(G))){let ce=null,we=G+1;if(ce=y(B,H,V+1,G+1,re),!re)for(;!ce&&(we=d(H,we))<H.length;)ce=y(B,H,V+1,we,re),we++;return ce?B.charCodeAt(V)!==H.charCodeAt(G)?ce:u({start:G,end:G+1},ce):null}else return null}function d(B,H){for(let V=H;V<B.length;V++)if(e(B.charCodeAt(V))||V>0&&e(B.charCodeAt(V-1)))return V;return B.length}const m=i(t.matchesPrefix,L,v),p=i(t.matchesPrefix,L,_),M=new E.LRUCache(1e4);function q(B,H,V=!1){if(typeof B!="string"||typeof H!="string")return null;let G=M.get(B);G||(G=new RegExp(k.convertSimple2RegExpPattern(B),"i"),M.set(B,G));const re=G.exec(H);return re?[{start:re.index,end:re.index+re[0].length}]:V?p(B,H):m(B,H)}t.matchesFuzzy=q;function Z(B,H){const V=W(B,B.toLowerCase(),0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?le(V):null}t.matchesFuzzy2=Z;function se(B,H,V,G,re,ce){const we=Math.min(13,B.length);for(;V<we;V++){const ye=W(B,H,V,G,re,ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ce]}t.anyScore=se;function le(B){if(typeof B>"u")return[];const H=[],V=B[1];for(let G=B.length-1;G>1;G--){const re=B[G]+V,ce=H[H.length-1];ce&&ce.end===re?ce.end=re+1:H.push({start:re,end:re+1})}return H}t.createMatches=le;const fe=128;function ue(){const B=[],H=[];for(let V=0;V<=fe;V++)H[V]=0;for(let V=0;V<=fe;V++)B.push(H.slice(0));return B}function Q(B){const H=[];for(let V=0;V<=B;V++)H[V]=0;return H}const J=Q(2*fe),ve=Q(2*fe),be=ue(),ke=ue(),Re=ue(),ae=!1;function U(B,H,V,G,re){function ce(ye,Le,Ce=" "){for(;ye.length<Le;)ye=Ce+ye;return ye}let we=` |   |${G.split("").map(ye=>ce(ye,3)).join("|")}
`;for(let ye=0;ye<=V;ye++)ye===0?we+=" |":we+=`${H[ye-1]}|`,we+=B[ye].slice(0,re+1).map(Le=>ce(Le.toString(),3)).join("|")+`
`;return we}function ne(B,H,V,G){B=B.substr(H),V=V.substr(G),console.log(U(ke,B,B.length,V,V.length)),console.log(U(Re,B,B.length,V,V.length)),console.log(U(be,B,B.length,V,V.length))}function te(B,H){if(H<0||H>=B.length)return!1;const V=B.codePointAt(H);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(V)}}function ie(B,H){if(H<0||H>=B.length)return!1;switch(B.charCodeAt(H)){case 32:case 9:return!0;default:return!1}}function F(B,H,V){return H[B]!==V[B]}function $(B,H,V,G,re,ce,we=!1){for(;H<V&&re<ce;)B[H]===G[re]&&(we&&(J[H]=re),H+=1),re+=1;return H===V}t.isPatternInWord=$;var R;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(R||(R={}));var g;(function(B){B.Default=[-100,0];function H(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}B.isDefault=H})(g=t.FuzzyScore||(t.FuzzyScore={}));class C{constructor(H,V){this.firstMatchCanBeWeak=H,this.boostFullMatch=V}}C.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},t.FuzzyScoreOptions=C;function W(B,H,V,G,re,ce,we=C.default){const ye=B.length>fe?fe:B.length,Le=G.length>fe?fe:G.length;if(V>=ye||ce>=Le||ye-V>Le-ce||!$(H,V,ye,re,ce,Le,!0))return;Y(ye,Le,V,ce,H,re);let Ce=1,De=1,Pe=V,Ne=ce;const Ke=[!1];for(Ce=1,Pe=V;Pe<ye;Ce++,Pe++){const Oe=J[Pe],K=ve[Pe],oe=Pe+1<ye?ve[Pe+1]:Le;for(De=Oe-ce+1,Ne=Oe;Ne<oe;De++,Ne++){let pe=Number.MIN_SAFE_INTEGER,Ee=!1;Ne<=K&&(pe=A(B,H,Pe,V,G,re,Ne,Le,ce,be[Ce-1][De-1]===0,Ke));let Se=0;pe!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Se=pe+ke[Ce-1][De-1]);const Me=Ne>Oe,ze=Me?ke[Ce][De-1]+(be[Ce][De-1]>0?-5:0):0,tt=Ne>Oe+1&&be[Ce][De-1]>0,je=tt?ke[Ce][De-2]+(be[Ce][De-2]>0?-5:0):0;if(tt&&(!Me||je>=ze)&&(!Ee||je>=Se))ke[Ce][De]=je,Re[Ce][De]=3,be[Ce][De]=0;else if(Me&&(!Ee||ze>=Se))ke[Ce][De]=ze,Re[Ce][De]=2,be[Ce][De]=0;else if(Ee)ke[Ce][De]=Se,Re[Ce][De]=1,be[Ce][De]=be[Ce-1][De-1]+1;else throw new Error("not possible")}}if(ae&&ne(B,V,G,ce),!Ke[0]&&!we.firstMatchCanBeWeak)return;Ce--,De--;const xe=[ke[Ce][De],ce];let He=0,Ze=0;for(;Ce>=1;){let Oe=De;do{const K=Re[Ce][Oe];if(K===3)Oe=Oe-2;else if(K===2)Oe=Oe-1;else break}while(Oe>=1);He>1&&H[V+Ce-1]===re[ce+De-1]&&!F(Oe+ce-1,G,re)&&He+1>be[Ce][Oe]&&(Oe=De),Oe===De?He++:He=1,Ze||(Ze=Oe),Ce--,De=Oe-1,xe.push(De)}Le===ye&&we.boostFullMatch&&(xe[0]+=2);const Ge=Ze-ye;return xe[0]-=Ge,xe}t.fuzzyScore=W;function Y(B,H,V,G,re,ce){let we=B-1,ye=H-1;for(;we>=V&&ye>=G;)re[we]===ce[ye]&&(ve[we]=ye,we--),ye--}function A(B,H,V,G,re,ce,we,ye,Le,Ce,De){if(H[V]!==ce[we])return Number.MIN_SAFE_INTEGER;let Pe=1,Ne=!1;return we===V-G?Pe=B[V]===re[we]?7:5:F(we,re,ce)&&(we===0||!F(we-1,re,ce))?(Pe=B[V]===re[we]?7:5,Ne=!0):te(ce,we)&&(we===0||!te(ce,we-1))?Pe=5:(te(ce,we-1)||ie(ce,we-1))&&(Pe=5,Ne=!0),Pe>1&&V===G&&(De[0]=!0),Ne||(Ne=F(we,re,ce)||te(ce,we-1)||ie(ce,we-1)),V===G?we>Le&&(Pe-=Ne?3:5):Ce?Pe+=Ne?2:0:Pe+=Ne?0:1,we+1===ye&&(Pe-=Ne?3:5),Pe}function I(B,H,V,G,re,ce,we){return T(B,H,V,G,re,ce,!0,we)}t.fuzzyScoreGracefulAggressive=I;function O(B,H,V,G,re,ce,we){return T(B,H,V,G,re,ce,!1,we)}t.fuzzyScoreGraceful=O;function T(B,H,V,G,re,ce,we,ye){let Le=W(B,H,V,G,re,ce,ye);if(Le&&!we)return Le;if(B.length>=3){const Ce=Math.min(7,B.length-1);for(let De=V+1;De<Ce;De++){const Pe=x(B,De);if(Pe){const Ne=W(Pe,Pe.toLowerCase(),V,G,re,ce,ye);Ne&&(Ne[0]-=3,(!Le||Ne[0]>Le[0])&&(Le=Ne))}}}return Le}function x(B,H){if(H+1>=B.length)return;const V=B[H],G=B[H+1];if(V!==G)return B.slice(0,H)+G+V+B.slice(H+2)}}),define(ge[111],me([1,0,11]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function k(u){return i(u,0)}t.hash=k;function i(u,s){switch(typeof u){case"object":return u===null?z(349,s):Array.isArray(u)?c(u,s):l(u,s);case"string":return _(u,s);case"boolean":return v(u,s);case"number":return z(u,s);case"undefined":return z(937,s);default:return z(617,s)}}t.doHash=i;function z(u,s){return(s<<5)-s+u|0}t.numberHash=z;function v(u,s){return z(u?433:863,s)}function _(u,s){s=z(149417,s);for(let D=0,w=u.length;D<w;D++)s=z(u.charCodeAt(D),s);return s}t.stringHash=_;function c(u,s){return s=z(104579,s),u.reduce((D,w)=>i(w,D),s)}function l(u,s){return s=z(181387,s),Object.keys(u).sort().reduce((D,w)=>(D=_(w,D),i(u[w],D)),s)}class h{constructor(){this._value=0}get value(){return this._value}hash(s){return this._value=i(s,this._value),this._value}}t.Hasher=h;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(u,s,D=32){const w=D-s,S=~((1<<w)-1);return(u<<s|(S&u)>>>w)>>>0}function a(u,s=0,D=u.byteLength,w=0){for(let S=0;S<D;S++)u[s+S]=w}function e(u,s,D="0"){for(;u.length<s;)u=D+u;return u}function o(u,s=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),s/4)}t.toHexString=o;class n{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(s){const D=s.length;if(D===0)return;const w=this._buff;let S=this._buffLen,f=this._leftoverHighSurrogate,b,L;for(f!==0?(b=f,L=-1,f=0):(b=s.charCodeAt(0),L=0);;){let N=b;if(E.isHighSurrogate(b))if(L+1<D){const y=s.charCodeAt(L+1);E.isLowSurrogate(y)?(L++,N=E.computeCodePoint(b,y)):N=65533}else{f=b;break}else E.isLowSurrogate(b)&&(N=65533);if(S=this._push(w,S,N),L++,L<D)b=s.charCodeAt(L);else break}this._buffLen=S,this._leftoverHighSurrogate=f}_push(s,D,w){return w<128?s[D++]=w:w<2048?(s[D++]=192|(w&1984)>>>6,s[D++]=128|(w&63)>>>0):w<65536?(s[D++]=224|(w&61440)>>>12,s[D++]=128|(w&4032)>>>6,s[D++]=128|(w&63)>>>0):(s[D++]=240|(w&1835008)>>>18,s[D++]=128|(w&258048)>>>12,s[D++]=128|(w&4032)>>>6,s[D++]=128|(w&63)>>>0),D>=64&&(this._step(),D-=64,this._totalLen+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,a(this._buff,this._buffLen),this._buffLen>56&&(this._step(),a(this._buff));const s=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(s/4294967296),!1),this._buffDV.setUint32(60,s%4294967296,!1),this._step()}_step(){const s=n._bigBlock32,D=this._buffDV;for(let m=0;m<64;m+=4)s.setUint32(m,D.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)s.setUint32(m,r(s.getUint32(m-12,!1)^s.getUint32(m-32,!1)^s.getUint32(m-56,!1)^s.getUint32(m-64,!1),1),!1);let w=this._h0,S=this._h1,f=this._h2,b=this._h3,L=this._h4,N,y,d;for(let m=0;m<80;m++)m<20?(N=S&f|~S&b,y=1518500249):m<40?(N=S^f^b,y=1859775393):m<60?(N=S&f|S&b|f&b,y=2400959708):(N=S^f^b,y=3395469782),d=r(w,5)+N+L+y+s.getUint32(m*4,!1)&4294967295,L=b,b=f,f=r(S,30),S=w,w=d;this._h0=this._h0+w&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+L&4294967295}}n._bigBlock32=new DataView(new ArrayBuffer(320)),t.StringSHA1=n}),define(ge[112],me([1,0,71,111]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.source=r}getElements(){const r=this.source,a=new Int32Array(r.length);for(let e=0,o=r.length;e<o;e++)a[e]=r.charCodeAt(e);return a}}t.StringDiffSequence=i;function z(P,r,a){return new h(new i(P),new i(r)).ComputeDiff(a).changes}t.stringDiff=z;class v{static Assert(r,a){if(!r)throw new Error(a)}}class _{static Copy(r,a,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[a+u]}static Copy2(r,a,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[a+u]}}var c;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(r,a){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_originalCount++}AddModifiedElement(r,a){this.m_originalStart=Math.min(this.m_originalStart,r),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(r,a,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=r,this._modifiedSequence=a;const[o,n,u]=h._getElements(r),[s,D,w]=h._getElements(a);this._hasStrings=u&&w,this._originalStringElements=o,this._originalElementsOrHash=n,this._modifiedStringElements=s,this._modifiedElementsOrHash=D,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(r){return r.length>0&&typeof r[0]=="string"}static _getElements(r){const a=r.getElements();if(h._isStringArray(a)){const e=new Int32Array(a.length);for(let o=0,n=a.length;o<n;o++)e[o]=(0,k.stringHash)(a[o],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}ElementsAreEqual(r,a){return this._originalElementsOrHash[r]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[r]===this._modifiedStringElements[a]:!0}ElementsAreStrictEqual(r,a){if(!this.ElementsAreEqual(r,a))return!1;const e=h._getStrictElement(this._originalSequence,r),o=h._getStrictElement(this._modifiedSequence,a);return e===o}static _getStrictElement(r,a){return typeof r.getStrictElement=="function"?r.getStrictElement(a):null}OriginalElementsAreEqual(r,a){return this._originalElementsOrHash[r]!==this._originalElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[r]===this._originalStringElements[a]:!0}ModifiedElementsAreEqual(r,a){return this._modifiedElementsOrHash[r]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._modifiedStringElements[r]===this._modifiedStringElements[a]:!0}ComputeDiff(r){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,r)}_ComputeDiff(r,a,e,o,n){const u=[!1];let s=this.ComputeDiffRecursive(r,a,e,o,u);return n&&(s=this.PrettifyChanges(s)),{quitEarly:u[0],changes:s}}ComputeDiffRecursive(r,a,e,o,n){for(n[0]=!1;r<=a&&e<=o&&this.ElementsAreEqual(r,e);)r++,e++;for(;a>=r&&o>=e&&this.ElementsAreEqual(a,o);)a--,o--;if(r>a||e>o){let f;return e<=o?(v.Assert(r===a+1,"originalStart should only be one more than originalEnd"),f=[new E.DiffChange(r,0,e,o-e+1)]):r<=a?(v.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new E.DiffChange(r,a-r+1,e,0)]):(v.Assert(r===a+1,"originalStart should only be one more than originalEnd"),v.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const u=[0],s=[0],D=this.ComputeRecursionPoint(r,a,e,o,u,s,n),w=u[0],S=s[0];if(D!==null)return D;if(!n[0]){const f=this.ComputeDiffRecursive(r,w,e,S,n);let b=[];return n[0]?b=[new E.DiffChange(w+1,a-(w+1)+1,S+1,o-(S+1)+1)]:b=this.ComputeDiffRecursive(w+1,a,S+1,o,n),this.ConcatenateChanges(f,b)}return[new E.DiffChange(r,a-r+1,e,o-e+1)]}WALKTRACE(r,a,e,o,n,u,s,D,w,S,f,b,L,N,y,d,m,p){let M=null,q=null,Z=new l,se=a,le=e,fe=L[0]-d[0]-o,ue=-1073741824,Q=this.m_forwardHistory.length-1;do{const J=fe+r;J===se||J<le&&w[J-1]<w[J+1]?(f=w[J+1],N=f-fe-o,f<ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,N),fe=J+1-r):(f=w[J-1]+1,N=f-fe-o,f<ue&&Z.MarkNextChange(),ue=f-1,Z.AddOriginalElement(f,N+1),fe=J-1-r),Q>=0&&(w=this.m_forwardHistory[Q],r=w[0],se=1,le=w.length-1)}while(--Q>=-1);if(M=Z.getReverseChanges(),p[0]){let J=L[0]+1,ve=d[0]+1;if(M!==null&&M.length>0){const be=M[M.length-1];J=Math.max(J,be.getOriginalEnd()),ve=Math.max(ve,be.getModifiedEnd())}q=[new E.DiffChange(J,b-J+1,ve,y-ve+1)]}else{Z=new l,se=u,le=s,fe=L[0]-d[0]-D,ue=1073741824,Q=m?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const J=fe+n;J===se||J<le&&S[J-1]>=S[J+1]?(f=S[J+1]-1,N=f-fe-D,f>ue&&Z.MarkNextChange(),ue=f+1,Z.AddOriginalElement(f+1,N+1),fe=J+1-n):(f=S[J-1],N=f-fe-D,f>ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,N+1),fe=J-1-n),Q>=0&&(S=this.m_reverseHistory[Q],n=S[0],se=1,le=S.length-1)}while(--Q>=-1);q=Z.getChanges()}return this.ConcatenateChanges(M,q)}ComputeRecursionPoint(r,a,e,o,n,u,s){let D=0,w=0,S=0,f=0,b=0,L=0;r--,e--,n[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const N=a-r+(o-e),y=N+1,d=new Int32Array(y),m=new Int32Array(y),p=o-e,M=a-r,q=r-e,Z=a-o,le=(M-p)%2===0;d[p]=r,m[M]=a,s[0]=!1;for(let fe=1;fe<=N/2+1;fe++){let ue=0,Q=0;S=this.ClipDiagonalBound(p-fe,fe,p,y),f=this.ClipDiagonalBound(p+fe,fe,p,y);for(let ve=S;ve<=f;ve+=2){ve===S||ve<f&&d[ve-1]<d[ve+1]?D=d[ve+1]:D=d[ve-1]+1,w=D-(ve-p)-q;const be=D;for(;D<a&&w<o&&this.ElementsAreEqual(D+1,w+1);)D++,w++;if(d[ve]=D,D+w>ue+Q&&(ue=D,Q=w),!le&&Math.abs(ve-M)<=fe-1&&D>=m[ve])return n[0]=D,u[0]=w,be<=m[ve]&&1447>0&&fe<=1447+1?this.WALKTRACE(p,S,f,q,M,b,L,Z,d,m,D,a,n,w,o,u,le,s):null}const J=(ue-r+(Q-e)-fe)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ue,J))return s[0]=!0,n[0]=ue,u[0]=Q,J>0&&1447>0&&fe<=1447+1?this.WALKTRACE(p,S,f,q,M,b,L,Z,d,m,D,a,n,w,o,u,le,s):(r++,e++,[new E.DiffChange(r,a-r+1,e,o-e+1)]);b=this.ClipDiagonalBound(M-fe,fe,M,y),L=this.ClipDiagonalBound(M+fe,fe,M,y);for(let ve=b;ve<=L;ve+=2){ve===b||ve<L&&m[ve-1]>=m[ve+1]?D=m[ve+1]-1:D=m[ve-1],w=D-(ve-M)-Z;const be=D;for(;D>r&&w>e&&this.ElementsAreEqual(D,w);)D--,w--;if(m[ve]=D,le&&Math.abs(ve-p)<=fe&&D<=d[ve])return n[0]=D,u[0]=w,be>=d[ve]&&1447>0&&fe<=1447+1?this.WALKTRACE(p,S,f,q,M,b,L,Z,d,m,D,a,n,w,o,u,le,s):null}if(fe<=1447){let ve=new Int32Array(f-S+2);ve[0]=p-S+1,_.Copy2(d,S,ve,1,f-S+1),this.m_forwardHistory.push(ve),ve=new Int32Array(L-b+2),ve[0]=M-b+1,_.Copy2(m,b,ve,1,L-b+1),this.m_reverseHistory.push(ve)}}return this.WALKTRACE(p,S,f,q,M,b,L,Z,d,m,D,a,n,w,o,u,le,s)}PrettifyChanges(r){for(let a=0;a<r.length;a++){const e=r[a],o=a<r.length-1?r[a+1].originalStart:this._originalElementsOrHash.length,n=a<r.length-1?r[a+1].modifiedStart:this._modifiedElementsOrHash.length,u=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<o&&e.modifiedStart+e.modifiedLength<n&&(!u||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const w=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!w)break;e.originalStart++,e.modifiedStart++}const D=[null];if(a<r.length-1&&this.ChangesOverlap(r[a],r[a+1],D)){r[a]=D[0],r.splice(a+1,1),a--;continue}}for(let a=r.length-1;a>=0;a--){const e=r[a];let o=0,n=0;if(a>0){const f=r[a-1];o=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const u=e.originalLength>0,s=e.modifiedLength>0;let D=0,w=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const b=e.originalStart-f,L=e.modifiedStart-f;if(b<o||L<n||u&&!this.OriginalElementsAreEqual(b,b+e.originalLength)||s&&!this.ModifiedElementsAreEqual(L,L+e.modifiedLength))break;const y=(b===o&&L===n?5:0)+this._boundaryScore(b,e.originalLength,L,e.modifiedLength);y>w&&(w=y,D=f)}e.originalStart-=D,e.modifiedStart-=D;const S=[null];if(a>0&&this.ChangesOverlap(r[a-1],r[a],S)){r[a-1]=S[0],r.splice(a,1),a++;continue}}if(this._hasStrings)for(let a=1,e=r.length;a<e;a++){const o=r[a-1],n=r[a],u=n.originalStart-o.originalStart-o.originalLength,s=o.originalStart,D=n.originalStart+n.originalLength,w=D-s,S=o.modifiedStart,f=n.modifiedStart+n.modifiedLength,b=f-S;if(u<5&&w<20&&b<20){const L=this._findBetterContiguousSequence(s,w,S,b,u);if(L){const[N,y]=L;(N!==o.originalStart+o.originalLength||y!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=N-o.originalStart,o.modifiedLength=y-o.modifiedStart,n.originalStart=N+u,n.modifiedStart=y+u,n.originalLength=D-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}_findBetterContiguousSequence(r,a,e,o,n){if(a<n||o<n)return null;const u=r+a-n+1,s=e+o-n+1;let D=0,w=0,S=0;for(let f=r;f<u;f++)for(let b=e;b<s;b++){const L=this._contiguousSequenceScore(f,b,n);L>0&&L>D&&(D=L,w=f,S=b)}return D>0?[w,S]:null}_contiguousSequenceScore(r,a,e){let o=0;for(let n=0;n<e;n++){if(!this.ElementsAreEqual(r+n,a+n))return 0;o+=this._originalStringElements[r+n].length}return o}_OriginalIsBoundary(r){return r<=0||r>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[r])}_OriginalRegionIsBoundary(r,a){if(this._OriginalIsBoundary(r)||this._OriginalIsBoundary(r-1))return!0;if(a>0){const e=r+a;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(r){return r<=0||r>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[r])}_ModifiedRegionIsBoundary(r,a){if(this._ModifiedIsBoundary(r)||this._ModifiedIsBoundary(r-1))return!0;if(a>0){const e=r+a;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(r,a,e,o){const n=this._OriginalRegionIsBoundary(r,a)?1:0,u=this._ModifiedRegionIsBoundary(e,o)?1:0;return n+u}ConcatenateChanges(r,a){const e=[];if(r.length===0||a.length===0)return a.length>0?a:r;if(this.ChangesOverlap(r[r.length-1],a[0],e)){const o=new Array(r.length+a.length-1);return _.Copy(r,0,o,0,r.length-1),o[r.length-1]=e[0],_.Copy(a,1,o,r.length,a.length-1),o}else{const o=new Array(r.length+a.length);return _.Copy(r,0,o,0,r.length),_.Copy(a,0,o,r.length,a.length),o}}ChangesOverlap(r,a,e){if(v.Assert(r.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),v.Assert(r.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=a.originalStart||r.modifiedStart+r.modifiedLength>=a.modifiedStart){const o=r.originalStart;let n=r.originalLength;const u=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=a.originalStart&&(n=a.originalStart+a.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=a.modifiedStart&&(s=a.modifiedStart+a.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(o,n,u,s),!0}else return e[0]=null,!1}ClipDiagonalBound(r,a,e,o){if(r>=0&&r<o)return r;const n=e,u=o-e-1,s=a%2===0;if(r<0){const D=n%2===0;return s===D?0:1}else{const D=u%2===0;return s===D?o-1:o-2}}}t.LcsDiff=h}),define(ge[33],me([1,0,32,11,17]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const z="$(",v=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${v.source}`,"g");function c(u){return u.replace(_,(s,D)=>D?s:`\\${s}`)}t.escapeIcons=c;const l=new RegExp(`\\\\${v.source}`,"g");function h(u){return u.replace(l,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=h;const P=new RegExp(`(\\s)?(\\\\)?${v.source}(\\s)?`,"g");function r(u){return u.indexOf(z)===-1?u:u.replace(P,(s,D,w,S)=>w?s:D||S||"")}t.stripIcons=r;function a(u){return u?u.replace(/\$\((.*?)\)/g,(s,D)=>` ${D} `).trim():""}t.getCodiconAriaLabel=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(u){e.lastIndex=0;let s="";const D=[];let w=0;for(;;){const S=e.lastIndex,f=e.exec(u),b=u.substring(S,f?.index);if(b.length>0){s+=b;for(let L=0;L<b.length;L++)D.push(w)}if(!f)break;w+=f[0].length}return{text:s,iconOffsets:D}}t.parseLabelWithIcons=o;function n(u,s,D=!1){const{text:w,iconOffsets:S}=s;if(!S||S.length===0)return(0,E.matchesFuzzy)(u,w,D);const f=(0,k.ltrim)(w," "),b=w.length-f.length,L=(0,E.matchesFuzzy)(u,f,D);if(L)for(const N of L){const y=S[N.start+b]+b;N.start+=y,N.end+=y}return L}t.matchesFuzzyIconAware=n}),define(ge[113],me([1,0,13,11]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const e=a.charCodeAt(0),o=this._value.charCodeAt(this._pos);return e-o}value(){return this._value[this._pos]}}t.StringIterator=i;class z{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,k.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=z;class v{constructor(a=!0,e=!0){this._splitOnBackslash=a,this._caseSensitive=e}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let e=a.length-1;e>=0;e--,this._valueLen--){const o=this._value.charCodeAt(e);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,k.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=v;var _;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(_||(_={}));class c{constructor(a,e){this._ignorePathCasing=a,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,k.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=c;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(h||(h={}));class P{static forUris(a=()=>!1,e=()=>!1){return new P(new c(a,e))}static forPaths(a=!1){return new P(new v(void 0,!a))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new z)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,e){if(e){const o=e.slice(0);(0,E.shuffle)(o);for(const n of o)this.set(n,a)}else{const o=a.slice(0);(0,E.shuffle)(o);for(const n of o)this.set(n[0],n[1])}}set(a,e){const o=this._iter.reset(a);let n;this._root||(this._root=new l,this._root.segment=o.value());const u=[];for(n=this._root;;){const D=o.cmp(n.segment);if(D>0)n.left||(n.left=new l,n.left.segment=o.value()),u.push([-1,n]),n=n.left;else if(D<0)n.right||(n.right=new l,n.right.segment=o.value()),u.push([1,n]),n=n.right;else if(o.hasNext())o.next(),n.mid||(n.mid=new l,n.mid.segment=o.value()),u.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=a;for(let D=u.length-1;D>=0;D--){const w=u[D][1];w.updateHeight();const S=w.balanceFactor();if(S<-1||S>1){const f=u[D][0],b=u[D+1][0];if(f===1&&b===1)u[D][1]=w.rotateLeft();else if(f===-1&&b===-1)u[D][1]=w.rotateRight();else if(f===1&&b===-1)w.right=u[D+1][1]=u[D+1][1].rotateRight(),u[D][1]=w.rotateLeft();else if(f===-1&&b===1)w.left=u[D+1][1]=u[D+1][1].rotateLeft(),u[D][1]=w.rotateRight();else throw new Error;if(D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}return s}get(a){return this._getNode(a)?.value}_getNode(a){const e=this._iter.reset(a);let o=this._root;for(;o;){const n=e.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(e.hasNext())e.next(),o=o.mid;else break}return o}has(a){const e=this._getNode(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,e){const o=this._iter.reset(a),n=[];let u=this._root;for(;u;){const s=o.cmp(u.segment);if(s>0)n.push([-1,u]),u=u.left;else if(s<0)n.push([1,u]),u=u.right;else if(o.hasNext())o.next(),n.push([0,u]),u=u.mid;else break}if(!!u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const s=this._min(u.right);if(s.key){const{key:D,value:w,segment:S}=s;this._delete(s.key,!1),u.key=D,u.value=w,u.segment=S}}else{const s=u.left??u.right;if(n.length>0){const[D,w]=n[n.length-1];switch(D){case-1:w.left=s;break;case 0:w.mid=s;break;case 1:w.right=s;break}}else this._root=s}for(let s=n.length-1;s>=0;s--){const D=n[s][1];D.updateHeight();const w=D.balanceFactor();if(w>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),n[s][1]=D.rotateLeft()):w<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),n[s][1]=D.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this._root=n[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this._iter.reset(a);let o=this._root,n;for(;o;){const u=e.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(e.hasNext())e.next(),n=o.value||n,o=o.mid;else break}return o&&o.value||n}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,e){const o=this._iter.reset(a);let n=this._root;for(;n;){const u=o.cmp(n.segment);if(u>0)n=n.left;else if(u<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this._entries(n.mid):e?n.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[e,o]of this)a(o,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const e=[];return this._dfsEntries(a,e),e[Symbol.iterator]()}_dfsEntries(a,e){!a||(a.left&&this._dfsEntries(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,e),a.right&&this._dfsEntries(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const o=e.balanceFactor();return o<-1||o>1?!1:a(e.left)&&a(e.right)};return a(this._root)}}t.TernarySearchTree=P}),define(ge[15],me([1,0,22,5]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,z=/^\//,v=/^\/\//;function _(L,N){if(!L.scheme&&N)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!z.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(L,N){return!L&&!N?"file":L}function l(L,N){switch(L){case"https":case"http":case"file":N?N[0]!==P&&(N=P+N):N=P;break}return N}const h="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(N){return N instanceof a?!0:N?typeof N.authority=="string"&&typeof N.fragment=="string"&&typeof N.path=="string"&&typeof N.query=="string"&&typeof N.scheme=="string"&&typeof N.fsPath=="string"&&typeof N.with=="function"&&typeof N.toString=="function":!1}constructor(N,y,d,m,p,M=!1){typeof N=="object"?(this.scheme=N.scheme||h,this.authority=N.authority||h,this.path=N.path||h,this.query=N.query||h,this.fragment=N.fragment||h):(this.scheme=c(N,M),this.authority=y||h,this.path=l(this.scheme,d||h),this.query=m||h,this.fragment=p||h,_(this,M))}get fsPath(){return D(this,!1)}with(N){if(!N)return this;let{scheme:y,authority:d,path:m,query:p,fragment:M}=N;return y===void 0?y=this.scheme:y===null&&(y=h),d===void 0?d=this.authority:d===null&&(d=h),m===void 0?m=this.path:m===null&&(m=h),p===void 0?p=this.query:p===null&&(p=h),M===void 0?M=this.fragment:M===null&&(M=h),y===this.scheme&&d===this.authority&&m===this.path&&p===this.query&&M===this.fragment?this:new o(y,d,m,p,M)}static parse(N,y=!1){const d=r.exec(N);return d?new o(d[2]||h,b(d[4]||h),b(d[5]||h),b(d[7]||h),b(d[9]||h),y):new o(h,h,h,h,h)}static file(N){let y=h;if(k.isWindows&&(N=N.replace(/\\/g,P)),N[0]===P&&N[1]===P){const d=N.indexOf(P,2);d===-1?(y=N.substring(2),N=P):(y=N.substring(2,d),N=N.substring(d)||P)}return new o("file",y,N,h,h)}static from(N){const y=new o(N.scheme,N.authority,N.path,N.query,N.fragment);return _(y,!0),y}static joinPath(N,...y){if(!N.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return k.isWindows&&N.scheme==="file"?d=a.file(E.win32.join(D(N,!0),...y)).path:d=E.posix.join(N.path,...y),N.with({path:d})}toString(N=!1){return w(this,N)}toJSON(){return this}static revive(N){if(N){if(N instanceof a)return N;{const y=new o(N);return y._formatted=N.external,y._fsPath=N._sep===e?N.fsPath:null,y}}else return N}}t.URI=a;const e=k.isWindows?1:void 0;class o extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(N=!1){return N?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const N={$mid:1};return this._fsPath&&(N.fsPath=this._fsPath,N._sep=e),this._formatted&&(N.external=this._formatted),this.path&&(N.path=this.path),this.scheme&&(N.scheme=this.scheme),this.authority&&(N.authority=this.authority),this.query&&(N.query=this.query),this.fragment&&(N.fragment=this.fragment),N}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(L,N,y){let d,m=-1;for(let p=0;p<L.length;p++){const M=L.charCodeAt(p);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||N&&M===47||y&&M===91||y&&M===93||y&&M===58)m!==-1&&(d+=encodeURIComponent(L.substring(m,p)),m=-1),d!==void 0&&(d+=L.charAt(p));else{d===void 0&&(d=L.substr(0,p));const q=n[M];q!==void 0?(m!==-1&&(d+=encodeURIComponent(L.substring(m,p)),m=-1),d+=q):m===-1&&(m=p)}}return m!==-1&&(d+=encodeURIComponent(L.substring(m))),d!==void 0?d:L}function s(L){let N;for(let y=0;y<L.length;y++){const d=L.charCodeAt(y);d===35||d===63?(N===void 0&&(N=L.substr(0,y)),N+=n[d]):N!==void 0&&(N+=L[y])}return N!==void 0?N:L}function D(L,N){let y;return L.authority&&L.path.length>1&&L.scheme==="file"?y=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?N?y=L.path.substr(1):y=L.path[1].toLowerCase()+L.path.substr(2):y=L.path,k.isWindows&&(y=y.replace(/\//g,"\\")),y}t.uriToFsPath=D;function w(L,N){const y=N?s:u;let d="",{scheme:m,authority:p,path:M,query:q,fragment:Z}=L;if(m&&(d+=m,d+=":"),(p||m==="file")&&(d+=P,d+=P),p){let se=p.indexOf("@");if(se!==-1){const le=p.substr(0,se);p=p.substr(se+1),se=le.lastIndexOf(":"),se===-1?d+=y(le,!1,!1):(d+=y(le.substr(0,se),!1,!1),d+=":",d+=y(le.substr(se+1),!1,!0)),d+="@"}p=p.toLowerCase(),se=p.lastIndexOf(":"),se===-1?d+=y(p,!1,!0):(d+=y(p.substr(0,se),!1,!0),d+=p.substr(se))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const se=M.charCodeAt(1);se>=65&&se<=90&&(M=`/${String.fromCharCode(se+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const se=M.charCodeAt(0);se>=65&&se<=90&&(M=`${String.fromCharCode(se+32)}:${M.substr(2)}`)}d+=y(M,!0,!1)}return q&&(d+="?",d+=y(q,!1,!1)),Z&&(d+="#",d+=N?Z:u(Z,!1,!1)),d}function S(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+S(L.substr(3)):L}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(L){return L.match(f)?L.replace(f,N=>S(N)):L}}),define(ge[50],me([1,0,30,11,15]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function z(l){return JSON.stringify(l,_)}t.stringify=z;function v(l){let h=JSON.parse(l);return h=c(h),h}t.parse=v;function _(l,h){return h instanceof RegExp?{$mid:2,source:h.source,flags:(0,k.regExpFlags)(h)}:h}function c(l,h=0){if(!l||h>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return i.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let P=0;P<l.length;++P)l[P]=c(l[P],h+1);else for(const P in l)Object.hasOwnProperty.call(l,P)&&(l[P]=c(l[P],h+1))}return l}t.revive=c}),define(ge[28],me([1,0,7,5,15]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var z;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(z=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class v{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${z.vscodeRemoteResource}`}set(h,P,r){this._hosts[h]=P,this._ports[h]=r}setConnectionToken(h,P){this._connectionTokens[h]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(n){return E.onUnexpectedError(n),h}const P=h.authority;let r=this._hosts[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const a=this._ports[P],e=this._connectionTokens[P];let o=`path=${encodeURIComponent(h.path)}`;return typeof e=="string"&&(o+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:k.isWeb?this._preferredWebSchema:z.vscodeRemoteResource,authority:`${r}:${a}`,path:this._remoteResourcesPath,query:o})}}t.RemoteAuthorities=new v,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class _{asBrowserUri(h){const P=this.toUri(h,ee);return this.uriToBrowserUri(P)}uriToBrowserUri(h){return h.scheme===z.vscodeRemote?t.RemoteAuthorities.rewrite(h):h.scheme===z.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${z.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?h.with({scheme:z.vscodeFileResource,authority:h.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const P=this.toUri(h,ee);return this.uriToFileUri(P)}uriToFileUri(h){return h.scheme===z.vscodeFileResource?h.with({scheme:z.file,authority:h.authority!==_.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,P){return i.URI.isUri(h)?h:i.URI.parse(P.toUrl(h))}}_.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new _;var c;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const P="vscode-coi";function r(e){let o;typeof e=="string"?o=new URL(e).searchParams:e instanceof URL?o=e.searchParams:i.URI.isUri(e)&&(o=new URL(e.toString(!0)).searchParams);const n=o?.get(P);if(!!n)return h.get(n)}l.getHeadersFromQuery=r;function a(e,o,n){if(!globalThis.crossOriginIsolated)return;const u=o&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(P,u):e[P]=u}l.addSearchParam=a})(c=t.COI||(t.COI={}))}),define(ge[34],me([1,0,110,28,22,5,11,15]),function(ee,t,E,k,i,z,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function c(a){return(0,_.uriToFsPath)(a,!0)}t.originalFSPath=c;class l{constructor(e){this._ignorePathCasing=e}compare(e,o,n=!1){return e===o?0:(0,v.compare)(this.getComparisonKey(e,n),this.getComparisonKey(o,n))}isEqual(e,o,n=!1){return e===o?!0:!e||!o?!1:this.getComparisonKey(e,n)===this.getComparisonKey(o,n)}getComparisonKey(e,o=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,o,n=!1){if(e.scheme===o.scheme){if(e.scheme===k.Schemas.file)return E.isEqualOrParent(c(e),c(o),this._ignorePathCasing(e))&&e.query===o.query&&(n||e.fragment===o.fragment);if((0,t.isEqualAuthority)(e.authority,o.authority))return E.isEqualOrParent(e.path,o.path,this._ignorePathCasing(e),"/")&&e.query===o.query&&(n||e.fragment===o.fragment)}return!1}joinPath(e,...o){return _.URI.joinPath(e,...o)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let o;return e.scheme===k.Schemas.file?o=_.URI.file(i.dirname(c(e))).path:(o=i.posix.dirname(e.path),e.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),o="/")),e.with({path:o})}normalizePath(e){if(!e.path.length)return e;let o;return e.scheme===k.Schemas.file?o=_.URI.file(i.normalize(c(e))).path:o=i.posix.normalize(e.path),e.with({path:o})}relativePath(e,o){if(e.scheme!==o.scheme||!(0,t.isEqualAuthority)(e.authority,o.authority))return;if(e.scheme===k.Schemas.file){const s=i.relative(c(e),c(o));return z.isWindows?E.toSlashes(s):s}let n=e.path||"/";const u=o.path||"/";if(this._ignorePathCasing(e)){let s=0;for(const D=Math.min(n.length,u.length);s<D&&!(n.charCodeAt(s)!==u.charCodeAt(s)&&n.charAt(s).toLowerCase()!==u.charAt(s).toLowerCase());s++);n=u.substr(0,s)+n.substr(s)}return i.posix.relative(n,u)}resolvePath(e,o){if(e.scheme===k.Schemas.file){const n=_.URI.file(i.resolve(c(e),o));return e.with({authority:n.authority,path:n.path})}return o=E.toPosixPath(o),e.with({path:i.posix.resolve(e.path,o)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,o){return e===o||e!==void 0&&o!==void 0&&(0,v.equalsIgnoreCase)(e,o)}hasTrailingPathSeparator(e,o=i.sep){if(e.scheme===k.Schemas.file){const n=c(e);return n.length>E.getRoot(n).length&&n[n.length-1]===o}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,o=i.sep){return(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,o=i.sep){let n=!1;if(e.scheme===k.Schemas.file){const u=c(e);n=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===o}else{o="/";const u=e.path;n=u.length===1&&u.charCodeAt(u.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path+"/"}):e}}t.ExtUri=l,t.extUri=new l(()=>!1),t.extUriBiasedIgnorePathCase=new l(a=>a.scheme===k.Schemas.file?!z.isLinux:!0),t.extUriIgnorePathCase=new l(a=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function h(a,e){const o=[];for(let n=0;n<a.length;n++){const u=e(a[n]);a.some((s,D)=>D===n?!1:(0,t.isEqualOrParent)(u,e(s)))||o.push(a[n])}return o}t.distinctParents=h;var P;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(o){const n=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(D=>{const[w,S]=D.split(":");w&&S&&n.set(w,S)});const s=o.path.substring(0,o.path.indexOf(";"));return s&&n.set(a.META_DATA_MIME,s),n}a.parseMetaData=e})(P=t.DataUri||(t.DataUri={}));function r(a,e,o){if(e){let n=a.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),a.with({scheme:o,authority:e,path:n})}return a.with({scheme:o})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,34,5,46]),function(ee,t,E,k,i,z,v,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function l($){return!!$&&typeof $.then=="function"}t.isThenable=l;function h($){const R=new E.CancellationTokenSource,g=$(R.token),C=new Promise((W,Y)=>{const A=R.token.onCancellationRequested(()=>{A.dispose(),R.dispose(),Y(new k.CancellationError)});Promise.resolve(g).then(I=>{A.dispose(),R.dispose(),W(I)},I=>{A.dispose(),R.dispose(),Y(I)})});return new class{cancel(){R.cancel()}then(W,Y){return C.then(W,Y)}catch(W){return this.then(void 0,W)}finally(W){return C.finally(W)}}}t.createCancelablePromise=h;function P($,R,g){return new Promise((C,W)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),C(g)});$.then(C,W).finally(()=>Y.dispose())})}t.raceCancellation=P;function r($,R){return new Promise((g,C)=>{const W=R.onCancellationRequested(()=>{W.dispose(),C(new k.CancellationError)});$.then(g,C).finally(()=>W.dispose())})}t.raceCancellationError=r;async function a($){let R=-1;const g=$.map((W,Y)=>W.then(A=>(R=Y,A))),C=await Promise.race(g);return $.forEach((W,Y)=>{Y!==R&&W.cancel()}),C}t.raceCancellablePromises=a;function e($,R,g){let C;const W=setTimeout(()=>{C?.(void 0),g?.()},R);return Promise.race([$.finally(()=>clearTimeout(W)),new Promise(Y=>C=Y)])}t.raceTimeout=e;function o($){return new Promise((R,g)=>{const C=$();l(C)?C.then(R,g):R(C)})}t.asPromise=o;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const g=()=>{this.queuedPromise=null;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(g,g).then(C)})}return new Promise((g,C)=>{this.queuedPromise.then(g,C)})}return this.activePromise=R(),new Promise((g,C)=>{this.activePromise.then(W=>{this.activePromise=null,g(W)},W=>{this.activePromise=null,C(W)})})}}t.Throttler=n;class u{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}t.Sequencer=u;class s{constructor(){this.promiseMap=new Map}queue(R,g){const W=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.promiseMap.get(R)===W&&this.promiseMap.delete(R)});return this.promiseMap.set(R,W),W}}t.SequencerByKey=s;const D=($,R)=>{let g=!0;const C=setTimeout(()=>{g=!1,R()},$);return{isTriggered:()=>g,dispose:()=>{clearTimeout(C),g=!1}}},w=$=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,$())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class S{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,g=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,Y)=>{this.doResolve=W,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=g===c.MicrotaskDelay?w(C):D(g,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=S;class f{constructor(R){this.delayer=new S(R),this.throttler=new n}trigger(R,g){return this.delayer.trigger(()=>this.throttler.queue(R),g)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=f;class b{constructor(){this._isOpen=!1,this._promise=new Promise((R,g)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=b;class L extends b{constructor(R){super(),this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=L;function N($,R){return R?new Promise((g,C)=>{const W=setTimeout(()=>{Y.dispose(),g()},$),Y=R.onCancellationRequested(()=>{clearTimeout(W),Y.dispose(),C(new k.CancellationError)})}):h(g=>N($,g))}t.timeout=N;function y($,R=0){const g=setTimeout($,R);return(0,z.toDisposable)(()=>clearTimeout(g))}t.disposableTimeout=y;function d($){const R=[];let g=0;const C=$.length;function W(){return g<C?$[g++]():null}function Y(A){A!=null&&R.push(A);const I=W();return I?I.then(Y):Promise.resolve(R)}return Promise.resolve(null).then(Y)}t.sequence=d;function m($,R=C=>!!C,g=null){let C=0;const W=$.length,Y=()=>{if(C>=W)return Promise.resolve(g);const A=$[C++];return Promise.resolve(A()).then(O=>R(O)?Promise.resolve(O):Y())};return Y()}t.first=m;function p($,R=C=>!!C,g=null){if($.length===0)return Promise.resolve(g);let C=$.length;const W=()=>{C=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,A)=>{for(const I of $)I.then(O=>{--C>=0&&R(O)?(W(),Y(O)):C===0&&Y(g)}).catch(O=>{--C>=0&&(W(),A(O))})})}t.firstParallel=p;class M{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new i.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){return this._size++,new Promise((g,C)=>{this.outstandingPromises.push({factory:R,c:g,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const g=R.factory();g.then(R.c,R.e),g.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=M;class q extends M{constructor(){super(1)}}t.Queue=q;class Z{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const R=new ae;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueFor(R,g=v.extUri){const C=g.getComparisonKey(R);let W=this.queues.get(C);return W||(W=new q,i.Event.once(W.onDrained)(()=>{W?.dispose(),this.queues.delete(C),this.onDidQueueDrain()}),this.queues.set(C,W)),W}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=Z;class se{constructor(R,g){this._token=-1,typeof R=="function"&&typeof g=="number"&&this.setIfNotSet(R,g)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,g){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},g)}setIfNotSet(R,g){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},g))}}t.TimeoutTimer=se;class le{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,g){this.cancel(),this._token=setInterval(()=>{R()},g)}}t.IntervalTimer=le;class fe{constructor(R,g){this.timeoutToken=-1,this.runner=R,this.timeout=g,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=fe;class ue{constructor(R,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=g,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ue;class Q extends fe{constructor(R,g){super(R,g),this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=Q;class J extends z.Disposable{constructor(R,g){super(),this.options=R,this.handler=g,this.pendingWork=[],this.throttler=this._register(new z.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const g of R)this.pendingWork.push(g);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new fe(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=$=>{(0,_.setTimeout0)(()=>{if(R)return;const g=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:t.runWhenIdle=($,R)=>{const g=requestIdleCallback($,typeof R=="number"?{timeout:R}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(g))}}}}();class ve{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(g){this._error=g}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ve;async function be($,R,g){let C;for(let W=0;W<g;W++)try{return await $()}catch(Y){C=Y,await N(R)}throw C}t.retry=be;class ke{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(R,g,C){return this._pending={taskId:R,cancel:()=>C?.(),promise:g},g.then(()=>this.donePending(R),()=>this.donePending(R)),g}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let g,C;const W=new Promise((Y,A)=>{g=Y,C=A});this._next={run:R,promise:W,promiseResolve:g,promiseReject:C}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=ke;class Re{constructor(R,g=()=>Date.now()){this.interval=R,this.nowFn=g,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}t.IntervalCounter=Re;class ae{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,g)=>{this.completeCallback=R,this.errorCallback=g})}complete(R){return new Promise(g=>{this.completeCallback(R),this.resolved=!0,g()})}error(R){return new Promise(g=>{this.errorCallback(R),this.rejected=!0,g()})}cancel(){new Promise(R=>{this.errorCallback(new k.CancellationError),this.rejected=!0,R()})}}t.DeferredPromise=ae;var U;(function($){async function R(C){let W;const Y=await Promise.all(C.map(A=>A.then(I=>I,I=>{W||(W=I)})));if(typeof W<"u")throw W;return Y}$.settled=R;function g(C){return new Promise(async(W,Y)=>{try{await C(W,Y)}catch(A){Y(A)}})}$.withAsyncBody=g})(U=t.Promises||(t.Promises={}));var ne;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(ne||(ne={}));class te{static fromArray(R){return new te(g=>{g.emitMany(R)})}static fromPromise(R){return new te(async g=>{g.emitMany(await R)})}static fromPromises(R){return new te(async g=>{await Promise.all(R.map(async C=>g.emitOne(await C)))})}static merge(R){return new te(async g=>{await Promise.all(R.map(async C=>{for await(const W of C)g.emitOne(W)}))})}constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new i.Emitter,queueMicrotask(async()=>{const g={emitOne:C=>this.emitOne(C),emitMany:C=>this.emitMany(C),reject:C=>this.reject(C)};try{await Promise.resolve(R(g)),this.resolve()}catch(C){this.reject(C)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await i.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,g){return new te(async C=>{for await(const W of R)C.emitOne(g(W))})}map(R){return te.map(this,R)}static filter(R,g){return new te(async C=>{for await(const W of R)g(W)&&C.emitOne(W)})}filter(R){return te.filter(this,R)}static coalesce(R){return te.filter(R,g=>!!g)}coalesce(){return te.coalesce(this)}static async toPromise(R){const g=[];for await(const C of R)g.push(C);return g}toPromise(){return te.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}te.EMPTY=te.fromArray([]),t.AsyncIterableObject=te;class ie extends te{constructor(R,g){super(g),this._source=R}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=ie;function F($){const R=new E.CancellationTokenSource,g=$(R.token);return new ie(R,async C=>{const W=R.token.onCancellationRequested(()=>{W.dispose(),R.dispose(),C.reject(new k.CancellationError)});try{for await(const Y of g){if(R.token.isCancellationRequested)return;C.emitOne(Y)}W.dispose(),R.dispose()}catch(Y){W.dispose(),R.dispose(),C.reject(Y)}})}t.createCancelableAsyncIterable=F}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function o(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=o;function n(X){return X?.isConnected??!1}t.isInDOM=n;class u{constructor(j,de,Ae,Te){this._node=j,this._type=de,this._handler=Ae,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function s(X,j,de,Ae){return new u(X,j,de,Ae)}t.addDisposableListener=s;function D(X){return function(j){return X(new z.StandardMouseEvent(j))}}function w(X){return function(j){return X(new i.StandardKeyboardEvent(j))}}const S=function(j,de,Ae,Te){let Ve=Ae;return de==="click"||de==="mousedown"?Ve=D(Ae):(de==="keydown"||de==="keypress"||de==="keyup")&&(Ve=w(Ae)),s(j,de,Ve,Te)};t.addStandardDisposableListener=S;const f=function(j,de,Ae){const Te=D(de);return L(j,Te,Ae)};t.addStandardDisposableGenericMouseDownListener=f;const b=function(j,de,Ae){const Te=D(de);return y(j,Te,Ae)};t.addStandardDisposableGenericMouseUpListener=b;function L(X,j,de){return s(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,j,de)}t.addDisposableGenericMouseDownListener=L;function N(X,j,de){return s(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,j,de)}t.addDisposableGenericMouseMoveListener=N;function y(X,j,de){return s(X,r.isIOS&&k.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,j,de)}t.addDisposableGenericMouseUpListener=y;class d{constructor(j,de=0){this._runner=j,this.priority=de,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(j){(0,_.onUnexpectedError)(j)}}static sort(j,de){return de.priority-j.priority}}(function(){let X=[],j=null,de=!1,Ae=!1;const Te=()=>{for(de=!1,j=X,X=[],Ae=!0;j.length>0;)j.sort(d.sort),j.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=(Ve,Ue=0)=>{const Xe=new d(Ve,Ue);return X.push(Xe),de||(de=!0,requestAnimationFrame(Te)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ve,Ue)=>{if(Ae){const Xe=new d(Ve,Ue);return j.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(Ve,Ue)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function p(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=p;const M=8,q=function(X,j){return j};class Z extends h.Disposable{constructor(j,de,Ae,Te=q,Ve=M){super();let Ue=null,Xe=0;const nt=this._register(new v.TimeoutTimer),Ye=()=>{Xe=new Date().getTime(),Ae(Ue),Ue=null};this._register(s(j,de,bt=>{Ue=Te(Ue,bt);const Et=new Date().getTime()-Xe;Et>=Ve?(nt.cancel(),Ye()):nt.setIfNotSet(Ye,Ve-Et)}))}}function se(X,j,de,Ae,Te){return new Z(X,j,de,Ae,Te)}t.addDisposableThrottledListener=se;function le(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=le;function fe(X){if(X!==document.body)return new Q(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new Q(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new Q(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new Q(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new Q(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=fe;class ue{static convertToPixels(j,de){return parseFloat(de)||0}static getDimension(j,de,Ae){const Te=le(j),Ve=Te?Te.getPropertyValue(de):"0";return ue.convertToPixels(j,Ve)}static getBorderLeftWidth(j){return ue.getDimension(j,"border-left-width","borderLeftWidth")}static getBorderRightWidth(j){return ue.getDimension(j,"border-right-width","borderRightWidth")}static getBorderTopWidth(j){return ue.getDimension(j,"border-top-width","borderTopWidth")}static getBorderBottomWidth(j){return ue.getDimension(j,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(j){return ue.getDimension(j,"padding-left","paddingLeft")}static getPaddingRight(j){return ue.getDimension(j,"padding-right","paddingRight")}static getPaddingTop(j){return ue.getDimension(j,"padding-top","paddingTop")}static getPaddingBottom(j){return ue.getDimension(j,"padding-bottom","paddingBottom")}static getMarginLeft(j){return ue.getDimension(j,"margin-left","marginLeft")}static getMarginTop(j){return ue.getDimension(j,"margin-top","marginTop")}static getMarginRight(j){return ue.getDimension(j,"margin-right","marginRight")}static getMarginBottom(j){return ue.getDimension(j,"margin-bottom","marginBottom")}}class Q{constructor(j,de){this.width=j,this.height=de}with(j=this.width,de=this.height){return j!==this.width||de!==this.height?new Q(j,de):this}static is(j){return typeof j=="object"&&typeof j.height=="number"&&typeof j.width=="number"}static lift(j){return j instanceof Q?j:new Q(j.width,j.height)}static equals(j,de){return j===de?!0:!j||!de?!1:j.width===de.width&&j.height===de.height}}Q.None=new Q(0,0),t.Dimension=Q;function J(X){let j=X.offsetParent,de=X.offsetTop,Ae=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){de-=X.scrollTop;const Te=O(X)?null:le(X);Te&&(Ae-=Te.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===j&&(Ae+=ue.getBorderLeftWidth(X),de+=ue.getBorderTopWidth(X),de+=X.offsetTop,Ae+=X.offsetLeft,j=X.offsetParent)}return{left:Ae,top:de}}t.getTopLeftOffset=J;function ve(X,j,de){typeof j=="number"&&(X.style.width=`${j}px`),typeof de=="number"&&(X.style.height=`${de}px`)}t.size=ve;function be(X,j,de,Ae,Te,Ve="absolute"){typeof j=="number"&&(X.style.top=`${j}px`),typeof de=="number"&&(X.style.right=`${de}px`),typeof Ae=="number"&&(X.style.bottom=`${Ae}px`),typeof Te=="number"&&(X.style.left=`${Te}px`),X.style.position=Ve}t.position=be;function ke(X){const j=X.getBoundingClientRect();return{left:j.left+window.scrollX,top:j.top+window.scrollY,width:j.width,height:j.height}}t.getDomNodePagePosition=ke;function Re(X){let j=X,de=1;do{const Ae=le(j).zoom;Ae!=null&&Ae!=="1"&&(de*=Ae),j=j.parentElement}while(j!==null&&j!==document.documentElement);return de}t.getDomNodeZoomLevel=Re;function ae(X){const j=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.offsetWidth+j}t.getTotalWidth=ae;function U(X){const j=ue.getBorderLeftWidth(X)+ue.getBorderRightWidth(X),de=ue.getPaddingLeft(X)+ue.getPaddingRight(X);return X.offsetWidth-j-de}t.getContentWidth=U;function ne(X){const j=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.scrollWidth+j}t.getTotalScrollWidth=ne;function te(X){const j=ue.getBorderTopWidth(X)+ue.getBorderBottomWidth(X),de=ue.getPaddingTop(X)+ue.getPaddingBottom(X);return X.offsetHeight-j-de}t.getContentHeight=te;function ie(X){const j=ue.getMarginTop(X)+ue.getMarginBottom(X);return X.offsetHeight+j}t.getTotalHeight=ie;function F(X,j){if(X===null)return 0;const de=J(X),Ae=J(j);return de.left-Ae.left}function $(X,j){const de=j.map(Te=>Math.max(ne(Te),ae(Te))+F(Te,X)||0);return Math.max(...de)}t.getLargestChildWidth=$;function R(X,j){for(;X;){if(X===j)return!0;X=X.parentNode}return!1}t.isAncestor=R;const g="parentFlowToElementId";function C(X,j){X.dataset[g]=j.id}t.setParentFlowTo=C;function W(X){const j=X.dataset[g];return typeof j=="string"?document.getElementById(j):null}function Y(X,j){let de=X;for(;de;){if(de===j)return!0;if(de instanceof HTMLElement){const Ae=W(de);if(Ae){de=Ae;continue}}de=de.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function A(X,j,de){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(j))return X;if(de){if(typeof de=="string"){if(X.classList.contains(de))return null}else if(X===de)return null}X=X.parentNode}return null}t.findParentWithClass=A;function I(X,j,de){return!!A(X,j,de)}t.hasParentWithClass=I;function O(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=O;function T(X){return!!x(X)}t.isInShadowDOM=T;function x(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return O(X)?X:null}t.getShadowRoot=x;function B(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=B;function H(X=document.getElementsByTagName("head")[0],j){const de=document.createElement("style");return de.type="text/css",de.media="screen",j?.(de),X.appendChild(de),de}t.createStyleSheet=H;function V(X=document.getElementsByTagName("head")[0]){const j=document.createElement("meta");return X.appendChild(j),j}t.createMetaElement=V;let G=null;function re(){return G||(G=H()),G}function ce(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function we(X,j,de=re()){!de||!j||de.sheet.insertRule(X+"{"+j+"}",0)}t.createCSSRule=we;function ye(X,j=re()){if(!j)return;const de=ce(j),Ae=[];for(let Te=0;Te<de.length;Te++)de[Te].selectorText.indexOf(X)!==-1&&Ae.push(Te);for(let Te=Ae.length-1;Te>=0;Te--)j.sheet.deleteRule(Ae[Te])}t.removeCSSRulesContainingSelector=ye;function Le(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ce(X){const j=X;return!!(j&&typeof j.preventDefault=="function"&&typeof j.stopPropagation=="function")}t.isEventLike=Ce,t.EventHelper={stop:(X,j)=>(X.preventDefault(),j&&X.stopPropagation(),X)};function De(X){const j=[];for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)j[de]=X.scrollTop,X=X.parentNode;return j}t.saveParentsScrollTop=De;function Pe(X,j){for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)X.scrollTop!==j[de]&&(X.scrollTop=j[de]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ne extends h.Disposable{static hasFocusWithin(j){const de=x(j),Ae=de?de.activeElement:document.activeElement;return R(Ae,j)}constructor(j){super(),this._onDidFocus=this._register(new c.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new c.Emitter),this.onDidBlur=this._onDidBlur.event;let de=Ne.hasFocusWithin(j),Ae=!1;const Te=()=>{Ae=!1,de||(de=!0,this._onDidFocus.fire())},Ve=()=>{de&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,de=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Ne.hasFocusWithin(j)!==de&&(de?Ve():Te())},this._register(s(j,t.EventType.FOCUS,Te,!0)),this._register(s(j,t.EventType.BLUR,Ve,!0)),this._register(s(j,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(s(j,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Ke(X){return new Ne(X)}t.trackFocus=Ke;function xe(X,j){return X.after(j),j}t.after=xe;function He(X,...j){if(X.append(...j),j.length===1&&typeof j[0]!="string")return j[0]}t.append=He;function Ze(X,j){return X.insertBefore(j,X.firstChild),j}t.prepend=Ze;function Ge(X,...j){X.innerText="",He(X,...j)}t.reset=Ge;const Oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var K;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(K=t.Namespace||(t.Namespace={}));function oe(X,j,de,...Ae){const Te=Oe.exec(j);if(!Te)throw new Error("Bad use of emmet");const Ve=Te[1]||"div";let Ue;return X!==K.HTML?Ue=document.createElementNS(X,Ve):Ue=document.createElement(Ve),Te[3]&&(Ue.id=Te[3]),Te[4]&&(Ue.className=Te[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Xe,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Xe)?Ue[Xe]=nt:Xe==="selected"?nt&&Ue.setAttribute(Xe,"true"):Ue.setAttribute(Xe,nt))}),Ue.append(...Ae),Ue}function pe(X,j,...de){return oe(K.HTML,X,j,...de)}t.$=pe,pe.SVG=function(X,j,...de){return oe(K.SVG,X,j,...de)};function Ee(X,j){const de=[];return X.forEach((Ae,Te)=>{Te>0&&(j instanceof Node?de.push(j.cloneNode()):de.push(document.createTextNode(j))),de.push(Ae)}),de}t.join=Ee;function Se(X,...j){X?Me(...j):ze(...j)}t.setVisibility=Se;function Me(...X){for(const j of X)j.style.display="",j.removeAttribute("aria-hidden")}t.show=Me;function ze(...X){for(const j of X)j.style.display="none",j.setAttribute("aria-hidden","true")}t.hide=ze;function tt(X,j){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(j))return X;X=X.parentNode}return null}function je(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&tt(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=je;function $e(X){return j=>{j.preventDefault(),j.stopPropagation(),X(j)}}t.finalHandler=$e;function Fe(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=Fe;function he(X){const j=window.devicePixelRatio*X;return Math.max(1,Math.floor(j))/window.devicePixelRatio}t.computeScreenAwareSize=he;function _e(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=_e;const Ie=780,We=640;function Qe(X){const j=Math.floor(window.screenLeft+window.innerWidth/2-Ie/2),de=Math.floor(window.screenTop+window.innerHeight/2-We/2);window.open(X,"_blank",`width=${Ie},height=${We},top=${de},left=${j}`)}t.windowOpenPopup=Qe;function Je(X,j=!0){const de=window.open();return de?(j&&(de.opener=null),de.location.href=X,!0):!1}t.windowOpenWithSuccess=Je;function et(X){const j=()=>{X(),de=(0,t.scheduleAtNextAnimationFrame)(j)};let de=(0,t.scheduleAtNextAnimationFrame)(j);return(0,h.toDisposable)(()=>de.dispose())}t.animate=et,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(X){return X?`url('${P.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function pt(X,j){if(X!==void 0){const de=X.match(/^\s*var\((.+)\)$/);if(de){const Ae=de[1].split(",",2);return Ae.length===2&&(j=pt(Ae[1].trim(),j)),`var(${Ae[0]}, ${j})`}return X}return j}t.asCssValueWithDefault=pt;function Ft(X,j){let de;if(e.URI.isUri(X))de=X.toString(!0);else{const Te=new Blob([X]);de=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(de))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=j,Ae.href=de,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=Ft;function zt(){return new Promise(X=>{const j=document.createElement("input");document.body.appendChild(j),j.type="file",j.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(j,"input"))(()=>{X((0,a.withNullAsUndefined)(j.files))}),j.click(),setTimeout(()=>document.body.removeChild(j))})}t.triggerUpload=zt;var yt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(yt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function Wt(X,j=!1){const de=document.createElement("a");return l.addHook("afterSanitizeAttributes",Ae=>{for(const Te of["href","src"])if(Ae.hasAttribute(Te)){const Ve=Ae.getAttribute(Te);if(Te==="href"&&Ve.startsWith("#"))continue;if(de.href=Ve,!X.includes(de.protocol.replace(/:$/,""))){if(j&&Te==="src"&&de.href.startsWith("data:"))continue;Ae.removeAttribute(Te)}}}),(0,h.toDisposable)(()=>{l.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const fi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(X,j){const de=Wt(fi);try{const Ae=l.sanitize(j,gi);X.innerHTML=Ae}finally{de.dispose()}}t.safeInnerHtml=mi;function pi(X){const j=new Uint16Array(X.length);for(let Te=0;Te<j.length;Te++)j[Te]=X.charCodeAt(Te);let de="";const Ae=new Uint8Array(j.buffer);for(let Te=0;Te<Ae.length;Te++)de+=String.fromCharCode(Ae[Te]);return de}function bi(X){return btoa(pi(X))}t.multibyteAwareBtoa=bi;class ft extends c.Emitter{constructor(){super(),this._subscriptions=new h.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(s(window,"keydown",j=>{if(j.defaultPrevented)return;const de=new i.StandardKeyboardEvent(j);if(!(de.keyCode===6&&j.repeat)){if(j.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(j.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(j.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(j.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(de.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=j.altKey,this._keyStatus.ctrlKey=j.ctrlKey,this._keyStatus.metaKey=j.metaKey,this._keyStatus.shiftKey=j.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=j,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(s(window,"keyup",j=>{j.defaultPrevented||(!j.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!j.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!j.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!j.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=j.altKey,this._keyStatus.ctrlKey=j.ctrlKey,this._keyStatus.metaKey=j.metaKey,this._keyStatus.shiftKey=j.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=j,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(s(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(s(document.body,"mousemove",j=>{j.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(X){const j=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return j?j.pop():void 0}t.getCookieValue=vi;class Di extends h.Disposable{constructor(j,de){super(),this.element=j,this.callbacks=de,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(s(this.element,t.EventType.DRAG_ENTER,j=>{this.counter++,this.dragStartTime=j.timeStamp,this.callbacks.onDragEnter(j)})),this._register(s(this.element,t.EventType.DRAG_OVER,j=>{j.preventDefault(),this.callbacks.onDragOver?.(j,j.timeStamp-this.dragStartTime)})),this._register(s(this.element,t.EventType.DRAG_LEAVE,j=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(j))})),this._register(s(this.element,t.EventType.DRAG_END,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(j)})),this._register(s(this.element,t.EventType.DROP,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(j)}))}}t.DragAndDropObserver=Di;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(X,...j){let de,Ae;Array.isArray(j[0])?(de={},Ae=j[0]):(de=j[0]||{},Ae=j[1]);const Te=wi.exec(X);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ve=Te.groups.tag||"div",Ue=document.createElement(Ve);Te.groups.id&&(Ue.id=Te.groups.id);const Xe=[];if(Te.groups.class)for(const Ye of Te.groups.class.split("."))Ye!==""&&Xe.push(Ye);if(de.className!==void 0)for(const Ye of de.className.split("."))Ye!==""&&Xe.push(Ye);Xe.length>0&&(Ue.className=Xe.join(" "));const nt={};if(Te.groups.name&&(nt[Te.groups.name]=Ue),Ae)for(const Ye of Ae)Ye instanceof HTMLElement?Ue.appendChild(Ye):typeof Ye=="string"?Ue.append(Ye):(Object.assign(nt,Ye),Ue.appendChild(Ye.root));for(const[Ye,bt]of Object.entries(de))if(Ye!=="className")if(Ye==="style")for(const[Et,Lt]of Object.entries(bt))Ue.style.setProperty(Ut(Et),typeof Lt=="number"?Lt+"px":""+Lt);else Ye==="tabIndex"?Ue.tabIndex=bt:Ue.setAttribute(Ut(Ye),bt.toString());return nt.root=Ue,nt}t.h=yi;function Ut(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class z extends k.Disposable{constructor(c,l){super(),this._register((0,E.addDisposableListener)(c,"dragover",h=>{h.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{l(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(h=>{this._register((0,E.addDisposableListener)(c,h,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=z,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text};function v(_,c,l,h,P){const r=document.createElement("div");r.className=l,r.textContent=c,P&&(r.style.color=P),h&&(r.style.background=h),_.dataTransfer&&(document.body.appendChild(r),_.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=v}),define(ge[52],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function k(r,a={}){const e=z(a);return e.textContent=r,e}t.renderText=k;function i(r,a={}){const e=z(a);return c(e,l(r,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.renderFormattedText=i;function z(r){const a=r.inline?"span":"div",e=document.createElement(a);return r.className&&(e.className=r.className),e}t.createElement=z;class v{constructor(a){this.source=a,this.index=0}eos(){return this.index>=this.source.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.source[this.index]}advance(){this.index++}}var _;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(_||(_={}));function c(r,a,e,o){let n;if(a.type===2)n=document.createTextNode(a.content||"");else if(a.type===3)n=document.createElement("b");else if(a.type===4)n=document.createElement("i");else if(a.type===7&&o)n=document.createElement("code");else if(a.type===5&&e){const u=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(u,"click",s=>{e.callback(String(a.index),s)})),n=u}else a.type===8?n=document.createElement("br"):a.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(a.children)&&a.children.forEach(u=>{c(n,u,e,o)})}function l(r,a){const e={type:1,children:[]};let o=0,n=e;const u=[],s=new v(r);for(;!s.eos();){let D=s.next();const w=D==="\\"&&P(s.peek(),a)!==0;if(w&&(D=s.next()),!w&&h(D,a)&&D===s.peek()){s.advance(),n.type===2&&(n=u.pop());const S=P(D,a);if(n.type===S||n.type===5&&S===6)n=u.pop();else{const f={type:S,children:[]};S===5&&(f.index=o,o++),n.children.push(f),u.push(n),n=f}}else if(D===`
`)n.type===2&&(n=u.pop()),n.children.push({type:8});else if(n.type!==2){const S={type:2,content:D};n.children.push(S),u.push(n),n=S}else n.content+=D}return n.type===2&&(n=u.pop()),u.length,e}function h(r,a){return P(r,a)!==0}function P(r,a){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this._hooks=new k.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(v,_){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const c=this._onStopCallback;this._onStopCallback=null,v&&c&&c(_)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(v,_,c,l,h){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=l,this._onStopCallback=h;let P=v;try{v.setPointerCapture(_),this._hooks.add((0,k.toDisposable)(()=>{try{v.releasePointerCapture(_)}catch{}}))}catch{P=window}this._hooks.add(E.addDisposableListener(P,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==c){this.stopMonitoring(!0);return}r.preventDefault(),this._pointerMoveCallback(r)})),this._hooks.add(E.addDisposableListener(P,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(ee,t,E,k){var i=arguments.length,z=i<3?t:k===null?k=Object.getOwnPropertyDescriptor(t,E):k,v;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(ee,t,E,k);else for(var _=ee.length-1;_>=0;_--)(v=ee[_])&&(z=(i<3?v(z):i>3?v(t,E,z):v(t,E))||z);return i>3&&z&&Object.defineProperty(t,E,z),z};define(ge[23],me([1,0,4,13,25,2,43]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var _;(function(l){l.Tap="-monaco-gesturetap",l.Change="-monaco-gesturechange",l.Start="-monaco-gesturestart",l.End="-monaco-gesturesend",l.Contextmenu="-monaco-gesturecontextmenu"})(_=t.EventType||(t.EventType={}));class c extends z.Disposable{constructor(){super(),this.dispatched=!1,this.targets=new v.LinkedList,this.ignoreTargets=new v.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(E.addDisposableListener(document,"touchstart",h=>this.onTouchStart(h),{passive:!1})),this._register(E.addDisposableListener(document,"touchend",h=>this.onTouchEnd(h))),this._register(E.addDisposableListener(document,"touchmove",h=>this.onTouchMove(h),{passive:!1}))}static addTarget(h){if(!c.isTouchDevice())return z.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.targets.push(h);return(0,z.toDisposable)(P)}static ignoreTarget(h){if(!c.isTouchDevice())return z.Disposable.None;c.INSTANCE||(c.INSTANCE=new c);const P=c.INSTANCE.ignoreTargets.push(h);return(0,z.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(h){const P=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let r=0,a=h.targetTouches.length;r<a;r++){const e=h.targetTouches.item(r);this.activeTouches[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const o=this.newGestureEvent(_.Start,e.target);o.pageX=e.pageX,o.pageY=e.pageY,this.dispatchEvent(o)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}onTouchEnd(h){const P=Date.now(),r=Object.keys(this.activeTouches).length;for(let a=0,e=h.changedTouches.length;a<e;a++){const o=h.changedTouches.item(a);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const n=this.activeTouches[o.identifier],u=Date.now()-n.initialTimeStamp;if(u<c.HOLD_DELAY&&Math.abs(n.initialPageX-k.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-k.tail(n.rollingPageY))<30){const s=this.newGestureEvent(_.Tap,n.initialTarget);s.pageX=k.tail(n.rollingPageX),s.pageY=k.tail(n.rollingPageY),this.dispatchEvent(s)}else if(u>=c.HOLD_DELAY&&Math.abs(n.initialPageX-k.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-k.tail(n.rollingPageY))<30){const s=this.newGestureEvent(_.Contextmenu,n.initialTarget);s.pageX=k.tail(n.rollingPageX),s.pageY=k.tail(n.rollingPageY),this.dispatchEvent(s)}else if(r===1){const s=k.tail(n.rollingPageX),D=k.tail(n.rollingPageY),w=k.tail(n.rollingTimestamps)-n.rollingTimestamps[0],S=s-n.rollingPageX[0],f=D-n.rollingPageY[0],b=[...this.targets].filter(L=>n.initialTarget instanceof Node&&L.contains(n.initialTarget));this.inertia(b,P,Math.abs(S)/w,S>0?1:-1,s,Math.abs(f)/w,f>0?1:-1,D)}this.dispatchEvent(this.newGestureEvent(_.End,n.initialTarget)),delete this.activeTouches[o.identifier]}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}newGestureEvent(h,P){const r=document.createEvent("CustomEvent");return r.initEvent(h,!1,!0),r.initialTarget=P,r.tapCount=0,r}dispatchEvent(h){if(h.type===_.Tap){const P=new Date().getTime();let r=0;P-this._lastSetTapCountTime>c.CLEAR_TAP_COUNT_TIME?r=1:r=2,this._lastSetTapCountTime=P,h.tapCount=r}else(h.type===_.Change||h.type===_.Contextmenu)&&(this._lastSetTapCountTime=0);if(h.initialTarget instanceof Node){for(const P of this.ignoreTargets)if(P.contains(h.initialTarget))return;for(const P of this.targets)P.contains(h.initialTarget)&&(P.dispatchEvent(h),this.dispatched=!0)}}inertia(h,P,r,a,e,o,n,u){this.handle=E.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),D=s-P;let w=0,S=0,f=!0;r+=c.SCROLL_FRICTION*D,o+=c.SCROLL_FRICTION*D,r>0&&(f=!1,w=a*r*D),o>0&&(f=!1,S=n*o*D);const b=this.newGestureEvent(_.Change);b.translationX=w,b.translationY=S,h.forEach(L=>L.dispatchEvent(b)),f||this.inertia(h,s,r,a,e+w,o,n,u+S)})}onTouchMove(h){const P=Date.now();for(let r=0,a=h.changedTouches.length;r<a;r++){const e=h.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const o=this.activeTouches[e.identifier],n=this.newGestureEvent(_.Change,o.initialTarget);n.translationX=e.pageX-k.tail(o.rollingPageX),n.translationY=e.pageY-k.tail(o.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.dispatchEvent(n),o.rollingPageX.length>3&&(o.rollingPageX.shift(),o.rollingPageY.shift(),o.rollingTimestamps.shift()),o.rollingPageX.push(e.pageX),o.rollingPageY.push(e.pageY),o.rollingTimestamps.push(P)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}}c.SCROLL_FRICTION=-.005,c.HOLD_DELAY=700,c.CLEAR_TAP_COUNT_TIME=400,qe([i.memoize],c,"isTouchDevice",null),t.Gesture=c}),define(ge[54],me([1,0,4,5,83]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let z,v,_,c,l;function h(e){z=document.createElement("div"),z.className="monaco-aria-container";const o=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};v=o(),_=o();const n=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("role","complementary"),u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};c=n(),l=n(),e.appendChild(z)}t.setARIAContainer=h;function P(e){!z||(v.textContent!==e?(E.clearNode(_),a(v,e)):(E.clearNode(v),a(_,e)))}t.alert=P;function r(e){!z||(k.isMacintosh?P(e):c.textContent!==e?(E.clearNode(l),a(c,e)):(E.clearNode(c),a(l,e)))}t.status=r;function a(e,o){E.clearNode(e),o.length>i&&(o=o.substr(0,i)),e.textContent=o,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?)\\)`,"g");function z(_){const c=new Array;let l,h=0,P=0;for(;(l=i.exec(_))!==null;){P=l.index||0,h<P&&c.push(_.substring(h,P)),h=(l.index||0)+l[0].length;const[,r,a]=l;c.push(r?`$(${a})`:v({id:a}))}return h<_.length&&c.push(_.substring(h)),c}t.renderLabelWithIcons=z;function v(_){const c=E.$("span");return c.classList.add(...k.ThemeIcon.asClassNameArray(_)),c}t.renderIcon=v}),define(ge[116],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function k(z){try{z.parentElement?.removeChild(z)}catch{}}class i{constructor(v){this.renderers=v,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(v){let _=this.getTemplateCache(v).pop(),c=!1;if(_)c=this.transactionNodesPendingRemoval.has(_.domNode),c&&this.transactionNodesPendingRemoval.delete(_.domNode);else{const l=(0,E.$)(".monaco-list-row"),P=this.getRenderer(v).renderTemplate(l);_={domNode:l,templateId:v,templateData:P}}return{row:_,isReusingConnectedDomNode:c}}release(v){!v||this.releaseRow(v)}transact(v){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{v()}finally{for(const _ of this.transactionNodesPendingRemoval)this.doRemoveNode(_);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(v){const{domNode:_,templateId:c}=v;_&&(this.inTransaction?this.transactionNodesPendingRemoval.add(_):this.doRemoveNode(_)),this.getTemplateCache(c).push(v)}doRemoveNode(v){v.classList.remove("scrolling"),k(v)}getTemplateCache(v){let _=this.cache.get(v);return _||(_=[],this.cache.set(v,_)),_}dispose(){this.cache.forEach((v,_)=>{for(const c of v)this.getRenderer(_).disposeTemplate(c.templateData),c.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(v){const _=this.renderers.get(v);if(!_)throw new Error(`No renderer found for ${v}`);return _}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends k.Disposable{constructor(v,_,c){super(),this._visibility=v,this._visibleClassName=_,this._invisibleClassName=c,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new E.TimeoutTimer)}setVisibility(v){this._visibility!==v&&(this._visibility=v,this._updateShouldBeVisible())}setShouldBeVisible(v){this._rawShouldBeVisible=v,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const v=this._applyVisibilitySetting();this._shouldBeVisible!==v&&(this._shouldBeVisible=v,this.ensureVisibility())}setIsNeeded(v){this._isNeeded!==v&&(this._isNeeded=v,this.ensureVisibility())}setDomNode(v){this._domNode=v,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(v){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(v?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(ee,t,E,k,i,z,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class c extends v.Disposable{constructor(h,P,r,a){super(),this.selected=0,this.selectBoxOptions=a||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new z.Emitter),this.styles=r,this.registerListeners(),this.setOptions(h,P)}registerListeners(){this._register(k.Gesture.addTarget(this.selectElement)),[k.EventType.Tap].forEach(h=>{this._register(E.addDisposableListener(this.selectElement,h,P=>{this.selectElement.focus()}))}),this._register(E.addStandardDisposableListener(this.selectElement,"click",h=>{E.EventHelper.stop(h,!0)})),this._register(E.addStandardDisposableListener(this.selectElement,"change",h=>{this.selectElement.title=h.target.value,this._onDidSelect.fire({index:h.target.selectedIndex,selected:h.target.value})})),this._register(E.addStandardDisposableListener(this.selectElement,"keydown",h=>{let P=!1;_.isMacintosh?(h.keyCode===18||h.keyCode===16||h.keyCode===10)&&(P=!0):(h.keyCode===18&&h.altKey||h.keyCode===10||h.keyCode===3)&&(P=!0),P&&h.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(h,P){(!this.options||!i.equals(this.options,h))&&(this.options=h,this.selectElement.options.length=0,this.options.forEach((r,a)=>{this.selectElement.add(this.createOption(r.text,a,r.isDisabled))})),P!==void 0&&this.select(P)}select(h){this.options.length===0?this.selected=0:h>=0&&h<this.options.length?this.selected=h:h>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(h){this.selectBoxOptions.ariaLabel=h,this.selectElement.setAttribute("aria-label",h)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(h){this.selectElement.tabIndex=h?0:-1}render(h){h.classList.add("select-container"),h.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(h){this.styles=h,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(h,P,r){const a=document.createElement("option");return a.value=h,a.text=h,a.disabled=!!r,a}}t.SelectBoxNative=c}),define(ge[55],me([1,0,24,13,9,46,112,3,26]),function(ee,t,E,k,i,z,v,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function l(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.isFilterResult=l;function h(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.getVisibleState=h;function P(a){return typeof a.collapsible=="boolean"}class r{constructor(e,o,n,u={}){this.user=e,this.list=o,this.rootRef=[],this.eventBufferer=new _.EventBufferer,this._onDidChangeCollapseState=new _.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new _.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new _.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new i.Delayer(z.MicrotaskDelay),this.collapseByDefault=typeof u.collapseByDefault>"u"?!1:u.collapseByDefault,this.filter=u.filter,this.autoExpandSingleChildren=typeof u.autoExpandSingleChildren>"u"?!1:u.autoExpandSingleChildren,this.root={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,o,n=c.Iterable.empty(),u={}){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");u.diffIdentityProvider?this.spliceSmart(u.diffIdentityProvider,e,o,n,u):this.spliceSimple(e,o,n,u)}spliceSmart(e,o,n,u=c.Iterable.empty(),s,D=s.diffDepth??0){const{parentNode:w}=this.getParentNodeWithListIndex(o);if(!w.lastDiffIds)return this.spliceSimple(o,n,u,s);const S=[...u],f=o[o.length-1],b=new v.LcsDiff({getElements:()=>w.lastDiffIds},{getElements:()=>[...w.children.slice(0,f),...S,...w.children.slice(f+n)].map(m=>e.getId(m.element).toString())}).ComputeDiff(!1);if(b.quitEarly)return w.lastDiffIds=void 0,this.spliceSimple(o,n,S,s);const L=o.slice(0,-1),N=(m,p,M)=>{if(D>0)for(let q=0;q<M;q++)m--,p--,this.spliceSmart(e,[...L,m,0],Number.MAX_SAFE_INTEGER,S[p].children,s,D-1)};let y=Math.min(w.children.length,f+n),d=S.length;for(const m of b.changes.sort((p,M)=>M.originalStart-p.originalStart))N(y,d,y-(m.originalStart+m.originalLength)),y=m.originalStart,d=m.modifiedStart-f,this.spliceSimple([...L,y],m.originalLength,c.Iterable.slice(S,d,d+m.modifiedLength),s);N(y,d,y)}spliceSimple(e,o,n=c.Iterable.empty(),{onDidCreateNode:u,onDidDeleteNode:s,diffIdentityProvider:D}){const{parentNode:w,listIndex:S,revealed:f,visible:b}=this.getParentNodeWithListIndex(e),L=[],N=c.Iterable.map(n,ue=>this.createTreeNode(ue,w,w.visible?1:0,f,L,u)),y=e[e.length-1],d=w.children.length>0;let m=0;for(let ue=y;ue>=0&&ue<w.children.length;ue--){const Q=w.children[ue];if(Q.visible){m=Q.visibleChildIndex;break}}const p=[];let M=0,q=0;for(const ue of N)p.push(ue),q+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=m+M++);const Z=(0,k.splice)(w.children,y,o,p);D?w.lastDiffIds?(0,k.splice)(w.lastDiffIds,y,o,p.map(ue=>D.getId(ue.element).toString())):w.lastDiffIds=w.children.map(ue=>D.getId(ue.element).toString()):w.lastDiffIds=void 0;let se=0;for(const ue of Z)ue.visible&&se++;if(se!==0)for(let ue=y+p.length;ue<w.children.length;ue++){const Q=w.children[ue];Q.visible&&(Q.visibleChildIndex-=se)}if(w.visibleChildrenCount+=M-se,f&&b){const ue=Z.reduce((Q,J)=>Q+(J.visible?J.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(w,q-ue),this.list.splice(S,ue,L)}if(Z.length>0&&s){const ue=Q=>{s(Q),Q.children.forEach(ue)};Z.forEach(ue)}this._onDidSplice.fire({insertedNodes:p,deletedNodes:Z});const le=w.children.length>0;d!==le&&this.setCollapsible(e.slice(0,-1),le);let fe=w;for(;fe;){if(fe.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}fe=fe.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{node:o,listIndex:n,revealed:u}=this.getTreeNodeWithListIndex(e);o.visible&&u&&this.list.splice(n,1,[o])}updateElementHeight(e,o){if(e.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{listIndex:n}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(n,o)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:o,visible:n,revealed:u}=this.getTreeNodeWithListIndex(e);return n&&u?o:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,o){const n=this.getTreeNode(e);typeof o>"u"&&(o=!n.collapsible);const u={collapsible:o};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,u))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,o,n){const u=this.getTreeNode(e);typeof o>"u"&&(o=!u.collapsed);const s={collapsed:o,recursive:n||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,s))}_setCollapseState(e,o){const{node:n,listIndex:u,revealed:s}=this.getTreeNodeWithListIndex(e),D=this._setListNodeCollapseState(n,u,s,o);if(n!==this.root&&this.autoExpandSingleChildren&&D&&!P(o)&&n.collapsible&&!n.collapsed&&!o.recursive){let w=-1;for(let S=0;S<n.children.length;S++)if(n.children[S].visible)if(w>-1){w=-1;break}else w=S;w>-1&&this._setCollapseState([...e,w],o)}return D}_setListNodeCollapseState(e,o,n,u){const s=this._setNodeCollapseState(e,u,!1);if(!n||!e.visible||!s)return s;const D=e.renderNodeCount,w=this.updateNodeAfterCollapseChange(e),S=D-(o===-1?0:1);return this.list.splice(o+1,S,w.slice(1)),s}_setNodeCollapseState(e,o,n){let u;if(e===this.root?u=!1:(P(o)?(u=e.collapsible!==o.collapsible,e.collapsible=o.collapsible):e.collapsible?(u=e.collapsed!==o.collapsed,e.collapsed=o.collapsed):u=!1,u&&this._onDidChangeCollapseState.fire({node:e,deep:n})),!P(o)&&o.recursive)for(const s of e.children)u=this._setNodeCollapseState(s,o,!0)||u;return u}expandTo(e){this.eventBufferer.bufferEvents(()=>{let o=this.getTreeNode(e);for(;o.parent;)o=o.parent,e=e.slice(0,e.length-1),o.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,o=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,o),this.refilterDelayer.cancel()}createTreeNode(e,o,n,u,s,D){const w={parent:o,element:e.element,children:[],depth:o.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this._filterNode(w,n);w.visibility=S,u&&s.push(w);const f=e.children||c.Iterable.empty(),b=u&&S!==0&&!w.collapsed;let L=0,N=1;for(const y of f){const d=this.createTreeNode(y,w,S,b,s,D);w.children.push(d),N+=d.renderNodeCount,d.visible&&(d.visibleChildIndex=L++)}return w.collapsible=w.collapsible||w.children.length>0,w.visibleChildrenCount=L,w.visible=S===2?L>0:S===1,w.visible?w.collapsed||(w.renderNodeCount=N):(w.renderNodeCount=0,u&&s.pop()),D?.(w),w}updateNodeAfterCollapseChange(e){const o=e.renderNodeCount,n=[];return this._updateNodeAfterCollapseChange(e,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-o),n}_updateNodeAfterCollapseChange(e,o){if(e.visible===!1)return 0;if(o.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(n,o);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const o=e.renderNodeCount,n=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,n),this._updateAncestorsRenderNodeCount(e.parent,n.length-o),n}_updateNodeAfterFilterChange(e,o,n,u=!0){let s;if(e!==this.root){if(s=this._filterNode(e,o),s===0)return e.visible=!1,e.renderNodeCount=0,!1;u&&n.push(e)}const D=n.length;e.renderNodeCount=e===this.root?0:1;let w=!1;if(!e.collapsed||s!==0){let S=0;for(const f of e.children)w=this._updateNodeAfterFilterChange(f,s,n,u&&!e.collapsed)||w,f.visible&&(f.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=s===2?w:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-D):(e.renderNodeCount=0,u&&n.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,o){if(o!==0)for(;e;)e.renderNodeCount+=o,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,o){const n=this.filter?this.filter.filter(e.element,o):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):l(n)?(e.filterData=n.data,h(n.visibility)):(e.filterData=void 0,h(n))}hasTreeNode(e,o=this.root){if(!e||e.length===0)return!0;const[n,...u]=e;return n<0||n>o.children.length?!1:this.hasTreeNode(u,o.children[n])}getTreeNode(e,o=this.root){if(!e||e.length===0)return o;const[n,...u]=e;if(n<0||n>o.children.length)throw new E.TreeError(this.user,"Invalid tree location");return this.getTreeNode(u,o.children[n])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:o,listIndex:n,revealed:u,visible:s}=this.getParentNodeWithListIndex(e),D=e[e.length-1];if(D<0||D>o.children.length)throw new E.TreeError(this.user,"Invalid tree location");const w=o.children[D];return{node:w,listIndex:n,revealed:u,visible:s&&w.visible}}getParentNodeWithListIndex(e,o=this.root,n=0,u=!0,s=!0){const[D,...w]=e;if(D<0||D>o.children.length)throw new E.TreeError(this.user,"Invalid tree location");for(let S=0;S<D;S++)n+=o.children[S].renderNodeCount;return u=u&&!o.collapsed,s=s&&o.visible,w.length===0?{parentNode:o,listIndex:n,revealed:u,visible:s}:this.getParentNodeWithListIndex(w,o.children[D],n+1,u,s)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const o=[];let n=e;for(;n.parent;)o.push(n.parent.children.indexOf(n)),n=n.parent;return o.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,k.tail2)(e)[0]}getFirstElementChild(e){const o=this.getTreeNode(e);if(o.children.length!==0)return o.children[0].element}getLastElementAncestor(e=[]){const o=this.getTreeNode(e);if(o.children.length!==0)return this._getLastElementAncestor(o)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,55,24,26]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class z{get size(){return this.nodes.size}constructor(_,c,l={}){this.user=_,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new E.IndexTreeModel(_,c,null,l),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,l.sorter&&(this.sorter={compare(h,P){return l.sorter.compare(h.element,P.element)}}),this.identityProvider=l.identityProvider}setChildren(_,c=i.Iterable.empty(),l={}){const h=this.getElementLocation(_);this._setChildren(h,this.preserveCollapseState(c),l)}_setChildren(_,c=i.Iterable.empty(),l){const h=new Set,P=new Set,r=e=>{if(e.element===null)return;const o=e;if(h.add(o.element),this.nodes.set(o.element,o),this.identityProvider){const n=this.identityProvider.getId(o.element).toString();P.add(n),this.nodesByIdentity.set(n,o)}l.onDidCreateNode?.(o)},a=e=>{if(e.element===null)return;const o=e;if(h.has(o.element)||this.nodes.delete(o.element),this.identityProvider){const n=this.identityProvider.getId(o.element).toString();P.has(n)||this.nodesByIdentity.delete(n)}l.onDidDeleteNode?.(o)};this.model.splice([..._,0],Number.MAX_VALUE,c,{...l,onDidCreateNode:r,onDidDeleteNode:a})}preserveCollapseState(_=i.Iterable.empty()){return this.sorter&&(_=[..._].sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(_,c=>{let l=this.nodes.get(c.element);if(!l&&this.identityProvider){const r=this.identityProvider.getId(c.element).toString();l=this.nodesByIdentity.get(r)}if(!l){let r;return typeof c.collapsed>"u"?r=void 0:c.collapsed===k.ObjectTreeElementCollapseState.Collapsed||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:c.collapsed===k.ObjectTreeElementCollapseState.Expanded||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=Boolean(c.collapsed),{...c,children:this.preserveCollapseState(c.children),collapsed:r}}const h=typeof c.collapsible=="boolean"?c.collapsible:l.collapsible;let P;return typeof c.collapsed>"u"||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===k.ObjectTreeElementCollapseState.PreserveOrExpanded?P=l.collapsed:c.collapsed===k.ObjectTreeElementCollapseState.Collapsed?P=!0:c.collapsed===k.ObjectTreeElementCollapseState.Expanded?P=!1:P=Boolean(c.collapsed),{...c,collapsible:h,collapsed:P,children:this.preserveCollapseState(c.children)}})}rerender(_){const c=this.getElementLocation(_);this.model.rerender(c)}updateElementHeight(_,c){const l=this.getElementLocation(_);this.model.updateElementHeight(l,c)}resort(_=null,c=!0){if(!this.sorter)return;const l=this.getElementLocation(_),h=this.model.getNode(l);this._setChildren(l,this.resortChildren(h,c),{})}resortChildren(_,c,l=!0){let h=[..._.children];return(c||l)&&(h=h.sort(this.sorter.compare.bind(this.sorter))),i.Iterable.map(h,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.resortChildren(P,c,!1)}))}getFirstElementChild(_=null){const c=this.getElementLocation(_);return this.model.getFirstElementChild(c)}getLastElementAncestor(_=null){const c=this.getElementLocation(_);return this.model.getLastElementAncestor(c)}has(_){return this.nodes.has(_)}getListIndex(_){const c=this.getElementLocation(_);return this.model.getListIndex(c)}getListRenderCount(_){const c=this.getElementLocation(_);return this.model.getListRenderCount(c)}isCollapsible(_){const c=this.getElementLocation(_);return this.model.isCollapsible(c)}setCollapsible(_,c){const l=this.getElementLocation(_);return this.model.setCollapsible(l,c)}isCollapsed(_){const c=this.getElementLocation(_);return this.model.isCollapsed(c)}setCollapsed(_,c,l){const h=this.getElementLocation(_);return this.model.setCollapsed(h,c,l)}expandTo(_){const c=this.getElementLocation(_);this.model.expandTo(c)}refilter(){this.model.refilter()}getNode(_=null){if(_===null)return this.model.getNode(this.model.rootRef);const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);return c}getNodeLocation(_){return _.element}getParentNodeLocation(_){if(_===null)throw new k.TreeError(this.user,"Invalid getParentNodeLocation call");const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);const l=this.model.getNodeLocation(c),h=this.model.getParentNodeLocation(l);return this.model.getNode(h).element}getElementLocation(_){if(_===null)return[];const c=this.nodes.get(_);if(!c)throw new k.TreeError(this.user,`Tree element not found: ${_}`);return this.model.getNodeLocation(c)}}t.ObjectTreeModel=z}),define(ge[19],me([1,0,4,14,21,23,2]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class _ extends v.Disposable{onclick(l,h){this._register(E.addDisposableListener(l,E.EventType.CLICK,P=>h(new i.StandardMouseEvent(P))))}onmousedown(l,h){this._register(E.addDisposableListener(l,E.EventType.MOUSE_DOWN,P=>h(new i.StandardMouseEvent(P))))}onmouseover(l,h){this._register(E.addDisposableListener(l,E.EventType.MOUSE_OVER,P=>h(new i.StandardMouseEvent(P))))}onmouseleave(l,h){this._register(E.addDisposableListener(l,E.EventType.MOUSE_LEAVE,P=>h(new i.StandardMouseEvent(P))))}onkeydown(l,h){this._register(E.addDisposableListener(l,E.EventType.KEY_DOWN,P=>h(new k.StandardKeyboardEvent(P))))}onkeyup(l,h){this._register(E.addDisposableListener(l,E.EventType.KEY_UP,P=>h(new k.StandardKeyboardEvent(P))))}oninput(l,h){this._register(E.addDisposableListener(l,E.EventType.INPUT,h))}onblur(l,h){this._register(E.addDisposableListener(l,E.EventType.BLUR,h))}onfocus(l,h){this._register(E.addDisposableListener(l,E.EventType.FOCUS,h))}onchange(l,h){this._register(E.addDisposableListener(l,E.EventType.CHANGE,h))}ignoreGesture(l){return z.Gesture.ignoreTarget(l)}}t.Widget=_}),define(ge[35],me([1,0,53,19,9,17,4]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class _ extends k.Widget{constructor(l){super(),this._onActivate=l.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=l.bgWidth+"px",this.bgDomNode.style.height=l.bgHeight+"px",typeof l.top<"u"&&(this.bgDomNode.style.top="0px"),typeof l.left<"u"&&(this.bgDomNode.style.left="0px"),typeof l.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof l.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=l.className,this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(l.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof l.top<"u"&&(this.domNode.style.top=l.top+"px"),typeof l.left<"u"&&(this.domNode.style.left=l.left+"px"),typeof l.bottom<"u"&&(this.domNode.style.bottom=l.bottom+"px"),typeof l.right<"u"&&(this.domNode.style.right=l.right+"px"),this._pointerMoveMonitor=this._register(new E.GlobalPointerMoveMonitor),this._register(v.addStandardDisposableListener(this.bgDomNode,v.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._register(v.addStandardDisposableListener(this.domNode,v.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._pointerdownRepeatTimer=this._register(new i.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new i.TimeoutTimer)}_arrowPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const h=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(h,200),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,P=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),l.preventDefault()}}t.ScrollbarArrow=_}),define(ge[56],me([1,0,4,38,53,35,117,19,5]),function(ee,t,E,k,i,z,v,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const l=140;class h extends _.Widget{constructor(r){super(),this._lazyRender=r.lazyRender,this._host=r.host,this._scrollable=r.scrollable,this._scrollByPage=r.scrollByPage,this._scrollbarState=r.scrollbarState,this._visibilityController=this._register(new v.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,k.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,a=>this._domNodePointerDown(a)))}_createArrow(r){const a=this._register(new z.ScrollbarArrow(r));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}_createSlider(r,a,e,o){this.slider=(0,k.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof o=="number"&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this._sliderPointerDown(n))})),this.onclick(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}_onElementSize(r){return this._scrollbarState.setVisibleSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(r){return this._scrollbarState.setScrollSize(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(r){return this._scrollbarState.setScrollPosition(r)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(r){r.target===this.domNode.domNode&&this._onPointerDown(r)}delegatePointerDown(r){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this._scrollbarState.getSliderPosition(),o=a+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),n=this._sliderPointerPosition(r);e<=n&&n<=o?r.button===0&&(r.preventDefault(),this._sliderPointerDown(r)):this._onPointerDown(r)}_onPointerDown(r){let a,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")a=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);a=r.pageX-n.left,e=r.pageY-n.top}const o=this._pointerDownRelativePosition(a,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(o):this._scrollbarState.getDesiredScrollPositionFromOffset(o)),r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))}_sliderPointerDown(r){if(!r.target||!(r.target instanceof Element))return;const a=this._sliderPointerPosition(r),e=this._sliderOrthogonalPointerPosition(r),o=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const u=this._sliderOrthogonalPointerPosition(n),s=Math.abs(u-e);if(c.isWindows&&s>l){this._setDesiredScrollPositionNow(o.getScrollPosition());return}const w=this._sliderPointerPosition(n)-a;this._setDesiredScrollPositionNow(o.getDesiredScrollPositionFromDelta(w))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(r){const a={};this.writeScrollPosition(a,r),this._scrollable.setScrollPositionNow(a)}updateScrollbarSize(r){this._updateScrollbarSize(r),this._scrollbarState.setScrollbarSize(r),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=h}),define(ge[120],me([1,0,21,56,35,39,16]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class _ extends k.AbstractScrollbar{constructor(l,h,P){const r=l.getScrollDimensions(),a=l.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:P,scrollbarState:new z.ScrollbarState(h.horizontalHasArrows?h.arrowSize:0,h.horizontal===2?0:h.horizontalScrollbarSize,h.vertical===2?0:h.verticalScrollbarSize,r.width,r.scrollWidth,a.scrollLeft),visibility:h.horizontal,extraScrollbarClassName:"horizontal",scrollable:l,scrollByPage:h.scrollByPage}),h.horizontalHasArrows){const e=(h.arrowSize-i.ARROW_IMG_SIZE)/2,o=(h.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:v.Codicon.scrollbarButtonLeft,top:o,left:e,bottom:void 0,right:void 0,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:v.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:e,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((h.horizontalScrollbarSize-h.horizontalSliderSize)/2),0,void 0,h.horizontalSliderSize)}_updateSlider(l,h){this.slider.setWidth(l),this.slider.setLeft(h)}_renderDomNode(l,h){this.domNode.setWidth(l),this.domNode.setHeight(h),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(l){return this._shouldRender=this._onElementScrollSize(l.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(l.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(l.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(l,h){return l}_sliderPointerPosition(l){return l.pageX}_sliderOrthogonalPointerPosition(l){return l.pageY}_updateScrollbarSize(l){this.slider.setHeight(l)}writeScrollPosition(l,h){l.scrollLeft=h}updateOptions(l){this.updateScrollbarSize(l.horizontal===2?0:l.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this._visibilityController.setVisibility(l.horizontal),this._scrollByPage=l.scrollByPage}}t.HorizontalScrollbar=_}),define(ge[121],me([1,0,21,56,35,39,16]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class _ extends k.AbstractScrollbar{constructor(l,h,P){const r=l.getScrollDimensions(),a=l.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:P,scrollbarState:new z.ScrollbarState(h.verticalHasArrows?h.arrowSize:0,h.vertical===2?0:h.verticalScrollbarSize,0,r.height,r.scrollHeight,a.scrollTop),visibility:h.vertical,extraScrollbarClassName:"vertical",scrollable:l,scrollByPage:h.scrollByPage}),h.verticalHasArrows){const e=(h.arrowSize-i.ARROW_IMG_SIZE)/2,o=(h.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:v.Codicon.scrollbarButtonUp,top:e,left:o,bottom:void 0,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:v.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:e,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((h.verticalScrollbarSize-h.verticalSliderSize)/2),h.verticalSliderSize,void 0)}_updateSlider(l,h){this.slider.setHeight(l),this.slider.setTop(h)}_renderDomNode(l,h){this.domNode.setWidth(h),this.domNode.setHeight(l),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(l){return this._shouldRender=this._onElementScrollSize(l.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(l.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(l.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(l,h){return h}_sliderPointerPosition(l){return l.pageY}_sliderOrthogonalPointerPosition(l){return l.pageX}_updateScrollbarSize(l){this.slider.setWidth(l)}writeScrollPosition(l,h){l.scrollTop=h}updateOptions(l){this.updateScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(l.vertical),this._scrollByPage=l.scrollByPage}}t.VerticalScrollbar=_}),define(ge[57],me([1,0,18,4,38,21,120,121,19,9,3,2,5,49,90]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,o=50,n=!0;class u{constructor(N,y,d){this.timestamp=N,this.deltaX=y,this.deltaY=d,this.score=0}}class s{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let N=1,y=0,d=1,m=this._rear;do{const p=m===this._front?N:Math.pow(2,-d);if(N-=p,y+=this._memory[m].score*p,m===this._front)break;m=(this._capacity+m-1)%this._capacity,d++}while(!0);return y<=.5}acceptStandardWheelEvent(N){const y=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),N.deltaX/y,N.deltaY/y):this.accept(Date.now(),N.deltaX,N.deltaY)}accept(N,y,d){const m=new u(N,y,d);m.score=this._computeScore(m),this._front===-1&&this._rear===-1?(this._memory[0]=m,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=m)}_computeScore(N){if(Math.abs(N.deltaX)>0&&Math.abs(N.deltaY)>0)return 1;let y=.5;const d=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(N.deltaX)||!this._isAlmostInt(N.deltaY))&&(y+=.25),Math.min(Math.max(y,0),1)}_isAlmostInt(N){return Math.abs(Math.round(N)-N)<.01}}s.INSTANCE=new s,t.MouseWheelClassifier=s;class D extends c.Widget{get options(){return this._options}constructor(N,y,d){super(),this._onScroll=this._register(new h.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new h.Emitter),this.onWillScroll=this._onWillScroll.event,N.style.overflow="hidden",this._options=b(y),this._scrollable=d,this._register(this._scrollable.onScroll(p=>{this._onWillScroll.fire(p),this._onDidScroll(p),this._onScroll.fire(p)}));const m={onMouseWheel:p=>this._onMouseWheel(p),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new _.VerticalScrollbar(this._scrollable,this._options,m)),this._horizontalScrollbar=this._register(new v.HorizontalScrollbar(this._scrollable,this._options,m)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(N),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,i.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,p=>this._onMouseOver(p)),this.onmouseleave(this._listenOnDomNode,p=>this._onMouseLeave(p)),this._hideTimeout=this._register(new l.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(N){this._verticalScrollbar.delegatePointerDown(N)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(N){this._scrollable.setScrollDimensions(N,!1)}updateClassName(N){this._options.className=N,r.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(N){typeof N.handleMouseWheel<"u"&&(this._options.handleMouseWheel=N.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof N.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=N.mouseWheelScrollSensitivity),typeof N.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=N.fastScrollSensitivity),typeof N.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=N.scrollPredominantAxis),typeof N.horizontal<"u"&&(this._options.horizontal=N.horizontal),typeof N.vertical<"u"&&(this._options.vertical=N.vertical),typeof N.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=N.horizontalScrollbarSize),typeof N.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=N.verticalScrollbarSize),typeof N.scrollByPage<"u"&&(this._options.scrollByPage=N.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(N){this._revealOnScroll=N}delegateScrollFromMouseWheelEvent(N){this._onMouseWheel(new z.StandardWheelEvent(N))}_setListeningToMouseWheel(N){if(this._mouseWheelToDispose.length>0!==N&&(this._mouseWheelToDispose=(0,P.dispose)(this._mouseWheelToDispose),N)){const d=m=>{this._onMouseWheel(new z.StandardWheelEvent(m))};this._mouseWheelToDispose.push(k.addDisposableListener(this._listenOnDomNode,k.EventType.MOUSE_WHEEL,d,{passive:!1}))}}_onMouseWheel(N){const y=s.INSTANCE;n&&y.acceptStandardWheelEvent(N);let d=!1;if(N.deltaY||N.deltaX){let p=N.deltaY*this._options.mouseWheelScrollSensitivity,M=N.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(p)>=Math.abs(M)?M=0:p=0),this._options.flipAxes&&([p,M]=[M,p]);const q=!r.isMacintosh&&N.browserEvent&&N.browserEvent.shiftKey;(this._options.scrollYToX||q)&&!M&&(M=p,p=0),N.browserEvent&&N.browserEvent.altKey&&(M=M*this._options.fastScrollSensitivity,p=p*this._options.fastScrollSensitivity);const Z=this._scrollable.getFutureScrollPosition();let se={};if(p){const le=o*p,fe=Z.scrollTop-(le<0?Math.floor(le):Math.ceil(le));this._verticalScrollbar.writeScrollPosition(se,fe)}if(M){const le=o*M,fe=Z.scrollLeft-(le<0?Math.floor(le):Math.ceil(le));this._horizontalScrollbar.writeScrollPosition(se,fe)}se=this._scrollable.validateScrollPosition(se),(Z.scrollLeft!==se.scrollLeft||Z.scrollTop!==se.scrollTop)&&(n&&this._options.mouseWheelSmoothScroll&&y.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(se):this._scrollable.setScrollPositionNow(se),d=!0)}let m=d;!m&&this._options.alwaysConsumeMouseWheel&&(m=!0),!m&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(m=!0),m&&(N.preventDefault(),N.stopPropagation())}_onDidScroll(N){this._shouldRender=this._horizontalScrollbar.onDidScroll(N)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(N)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const N=this._scrollable.getCurrentScrollPosition(),y=N.scrollTop>0,d=N.scrollLeft>0,m=d?" left":"",p=y?" top":"",M=d||y?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${m}`),this._topShadowDomNode.setClassName(`shadow${p}`),this._topLeftShadowDomNode.setClassName(`shadow${M}${p}${m}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(N){this._mouseIsOver=!1,this._hide()}_onMouseOver(N){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=D;class w extends D{constructor(N,y){y=y||{},y.mouseWheelSmoothScroll=!1;const d=new a.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>k.scheduleAtNextAnimationFrame(m)});super(N,y,d),this._register(d)}setScrollPosition(N){this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=w;class S extends D{constructor(N,y,d){super(N,y,d)}setScrollPosition(N){N.reuseAnimation?this._scrollable.setScrollPositionSmooth(N,N.reuseAnimation):this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class f extends D{constructor(N,y){y=y||{},y.mouseWheelSmoothScroll=!1;const d=new a.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>k.scheduleAtNextAnimationFrame(m)});super(N,y,d),this._register(d),this._element=N,this.onScroll(m=>{m.scrollTopChanged&&(this._element.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this._element.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(N){this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=f;function b(L){const N={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return N.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:N.horizontalScrollbarSize,N.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:N.verticalScrollbarSize,r.isMacintosh&&(N.className+=" mac"),N}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const u={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(N){return[N]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class D{get context(){return this._context}set context(y){this._context=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=D;class w{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=w;class S{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let d=0;d<y.files.length;d++){const m=y.files.item(d);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function f(N,y){return Array.isArray(N)&&Array.isArray(y)?(0,_.equals)(N,y):N===y}class b{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(d,m,p)=>p,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(d,m)=>m+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=d=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=d=>{}}}class L{get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(y){if(y!==this._horizontalScrolling){if(y&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=y,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const d of this.items)this.measureItemWidth(d);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,k.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(y,d,m,p=s){if(this.virtualDelegate=d,this.domId=`list_id_${++L.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=P.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=P.Disposable.None,this.onDragLeaveTimeout=P.Disposable.None,this.disposables=new P.DisposableStore,this._onDidChangeContentHeight=new h.Emitter,this.onDidChangeContentHeight=h.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,p.horizontalScrolling&&p.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new e.RangeMap;for(const q of m)this.renderers.set(q.templateId,q);this.cache=this.disposables.add(new o.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof p.mouseSupport=="boolean"?p.mouseSupport:!0),this._horizontalScrolling=p.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof p.additionalScrollHeight>"u"?0:p.additionalScrollHeight,this.accessibilityProvider=new b(p.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(p.transformOptimization??s.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(z.Gesture.addTarget(this.rowsContainer)),this.scrollable=new a.Scrollable({forceIntegerValues:!0,smoothScrollDuration:p.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:q=>(0,k.scheduleAtNextAnimationFrame)(q)}),this.scrollableElement=this.disposables.add(new v.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:p.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:p.verticalScrollMode??s.verticalScrollMode,useShadows:p.useShadows??s.useShadows,mouseWheelScrollSensitivity:p.mouseWheelScrollSensitivity,fastScrollSensitivity:p.fastScrollSensitivity,scrollByPage:p.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),y.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,k.addDisposableListener)(this.rowsContainer,z.EventType.Change,q=>this.onTouchChange(q))),this.disposables.add((0,k.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",q=>q.target.scrollTop=0)),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragover",q=>this.onDragOver(this.toDragEvent(q)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"drop",q=>this.onDrop(this.toDragEvent(q)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragleave",q=>this.onDragLeave(this.toDragEvent(q)))),this.disposables.add((0,k.addDisposableListener)(this.domNode,"dragend",q=>this.onDragEnd(q))),this.setRowLineHeight=p.setRowLineHeight??s.setRowLineHeight,this.setRowHeight=p.setRowHeight??s.setRowHeight,this.supportDynamicHeights=p.supportDynamicHeights??s.supportDynamicHeights,this.dnd=p.dnd??s.dnd,this.layout(p.initialSize?.height,p.initialSize?.width)}updateOptions(y){y.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=y.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.horizontalScrolling=y.horizontalScrolling);let d;y.scrollByPage!==void 0&&(d={...d??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(d={...d??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(d={...d??{},fastScrollSensitivity:y.fastScrollSensitivity}),d&&this.scrollableElement.updateOptions(d)}delegateScrollFromMouseWheelEvent(y){this.scrollableElement.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.scrollableElement.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,d,m){if(y<0||y>=this.items.length)return;const p=this.items[y].size;if(typeof d>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[y].lastDynamicHeightWidth=void 0,d=p+this.probeDynamicHeight(y)}if(p===d)return;const M=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let q=0;y<M.start||m!==null&&m>y&&m<=M.end?q=d-p:q=0,this.rangeMap.splice(y,1,[{size:d}]),this.items[y].size=d,this.render(M,Math.max(0,this.lastRenderTop+q),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(y,d,m=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(y,d,m)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(y,d,m=[]){const p=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),M={start:y,end:y+d},q=r.Range.intersect(p,M),Z=new Map;for(let ie=q.end-1;ie>=q.start;ie--){const F=this.items[ie];if(F.dragStartDisposable.dispose(),F.checkedDisposable.dispose(),F.row){let $=Z.get(F.templateId);$||($=[],Z.set(F.templateId,$));const R=this.renderers.get(F.templateId);R&&R.disposeElement&&R.disposeElement(F.element,ie,F.row.templateData,F.size),$.push(F.row)}F.row=null}const se={start:y+d,end:this.items.length},le=r.Range.intersect(se,p),fe=r.Range.relativeComplement(se,p),ue=m.map(ie=>({id:String(this.itemId++),element:ie,templateId:this.virtualDelegate.getTemplateId(ie),size:this.virtualDelegate.getHeight(ie),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(ie),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let Q;y===0&&d>=this.items.length?(this.rangeMap=new e.RangeMap,this.rangeMap.splice(0,0,ue),Q=this.items,this.items=ue):(this.rangeMap.splice(y,d,ue),Q=this.items.splice(y,d,...ue));const J=m.length-d,ve=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),be=(0,e.shift)(le,J),ke=r.Range.intersect(ve,be);for(let ie=ke.start;ie<ke.end;ie++)this.updateItemInDOM(this.items[ie],ie);const Re=r.Range.relativeComplement(be,ve);for(const ie of Re)for(let F=ie.start;F<ie.end;F++)this.removeItemFromDOM(F);const ae=fe.map(ie=>(0,e.shift)(ie,J)),ne=[{start:y,end:y+m.length},...ae].map(ie=>r.Range.intersect(ve,ie)),te=this.getNextToLastElement(ne);for(const ie of ne)for(let F=ie.start;F<ie.end;F++){const $=this.items[F],g=Z.get($.templateId)?.pop();this.insertItemInDOM(F,te,g)}for(const ie of Z.values())for(const F of ie)this.cache.release(F);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),Q.map(ie=>ie.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,k.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let y=0;for(const d of this.items)typeof d.width<"u"&&(y=Math.max(y,d.width));this.scrollWidth=y,this.scrollableElement.setScrollDimensions({scrollWidth:y===0?0:y+10})}updateWidth(y){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const d=this.items[y];this.measureItemWidth(d),typeof d.width<"u"&&d.width>this.scrollWidth&&(this.scrollWidth=d.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const y of this.items)y.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const y=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),d=this.rangeMap.positionAt(y.start),m=this.rangeMap.positionAt(y.start+1);return m!==-1&&(m-d)/2+d<this.scrollTop?y.start+1:y.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(y){return this.items[y].element}indexOf(y){return this.items.findIndex(d=>d.element===y)}domElement(y){const d=this.items[y].row;return d&&d.domNode}elementHeight(y){return this.items[y].size}elementTop(y){return this.rangeMap.positionAt(y)}indexAt(y){return this.rangeMap.indexAt(y)}indexAfter(y){return this.rangeMap.indexAfter(y)}layout(y,d){const m={height:typeof y=="number"?y:(0,k.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,m.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(m),typeof d<"u"&&(this.renderWidth=d,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof d=="number"?d:(0,k.getContentWidth)(this.domNode)})}render(y,d,m,p,M,q=!1){const Z=this.getRenderRange(d,m),se=r.Range.relativeComplement(Z,y),le=r.Range.relativeComplement(y,Z),fe=this.getNextToLastElement(se);if(q){const ue=r.Range.intersect(y,Z);for(let Q=ue.start;Q<ue.end;Q++)this.updateItemInDOM(this.items[Q],Q)}this.cache.transact(()=>{for(const ue of le)for(let Q=ue.start;Q<ue.end;Q++)this.removeItemFromDOM(Q);for(const ue of se)for(let Q=ue.start;Q<ue.end;Q++)this.insertItemInDOM(Q,fe)}),p!==void 0&&(this.rowsContainer.style.left=`-${p}px`),this.rowsContainer.style.top=`-${d}px`,this.horizontalScrolling&&M!==void 0&&(this.rowsContainer.style.width=`${Math.max(M,this.renderWidth)}px`),this.lastRenderTop=d,this.lastRenderHeight=m}insertItemInDOM(y,d,m){const p=this.items[y];let M=!1;if(!p.row)if(m)p.row=m;else{const fe=this.cache.alloc(p.templateId);p.row=fe.row,M=fe.isReusingConnectedDomNode}const q=this.accessibilityProvider.getRole(p.element)||"listitem";p.row.domNode.setAttribute("role",q);const Z=this.accessibilityProvider.isChecked(p.element);if(typeof Z=="boolean")p.row.domNode.setAttribute("aria-checked",String(!!Z));else if(Z){const fe=ue=>p.row.domNode.setAttribute("aria-checked",String(!!ue));fe(Z.value),p.checkedDisposable=Z.onDidChange(fe)}(M||!p.row.domNode.parentElement)&&(d?this.rowsContainer.insertBefore(p.row.domNode,d):this.rowsContainer.appendChild(p.row.domNode)),this.updateItemInDOM(p,y);const se=this.renderers.get(p.templateId);if(!se)throw new Error(`No renderer found for template id ${p.templateId}`);se?.renderElement(p.element,y,p.row.templateData,p.size);const le=this.dnd.getDragURI(p.element);p.dragStartDisposable.dispose(),p.row.domNode.draggable=!!le,le&&(p.dragStartDisposable=(0,k.addDisposableListener)(p.row.domNode,"dragstart",fe=>this.onDragStart(p.element,le,fe))),this.horizontalScrolling&&(this.measureItemWidth(p),this.eventuallyUpdateScrollWidth())}measureItemWidth(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,k.getContentWidth)(y.row.domNode);const d=window.getComputedStyle(y.row.domNode);d.paddingLeft&&(y.width+=parseFloat(d.paddingLeft)),d.paddingRight&&(y.width+=parseFloat(d.paddingRight)),y.row.domNode.style.width=""}updateItemInDOM(y,d){y.row.domNode.style.top=`${this.elementTop(d)}px`,this.setRowHeight&&(y.row.domNode.style.height=`${y.size}px`),this.setRowLineHeight&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${d}`),y.row.domNode.setAttribute("data-last-element",d===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",d%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(y.element,d,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(y.element,d))),y.row.domNode.setAttribute("id",this.getElementDomId(d)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}removeItemFromDOM(y){const d=this.items[y];if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const m=this.renderers.get(d.templateId);m&&m.disposeElement&&m.disposeElement(d.element,y,d.row.templateData,d.size),this.cache.release(d.row),d.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(y,d){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:y,reuseAnimation:d})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(y){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"click")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseDblClick(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"dblclick")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseMiddleClick(){return h.Event.filter(h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"auxclick")).event,y=>this.toMouseEvent(y),this.disposables),y=>y.browserEvent.button===1,this.disposables)}get onMouseUp(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseup")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseDown(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousedown")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseOver(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseover")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseMove(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mousemove")).event,y=>this.toMouseEvent(y),this.disposables)}get onMouseOut(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"mouseout")).event,y=>this.toMouseEvent(y),this.disposables)}get onContextMenu(){return h.Event.any(h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"contextmenu")).event,y=>this.toMouseEvent(y),this.disposables),h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,z.EventType.Contextmenu)).event,y=>this.toGestureEvent(y),this.disposables))}get onTouchStart(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.domNode,"touchstart")).event,y=>this.toTouchEvent(y),this.disposables)}get onTap(){return h.Event.map(this.disposables.add(new i.DomEmitter(this.rowsContainer,z.EventType.Tap)).event,y=>this.toGestureEvent(y),this.disposables)}toMouseEvent(y){const d=this.getItemIndexFromEventTarget(y.target||null),m=typeof d>"u"?void 0:this.items[d],p=m&&m.element;return{browserEvent:y,index:d,element:p}}toTouchEvent(y){const d=this.getItemIndexFromEventTarget(y.target||null),m=typeof d>"u"?void 0:this.items[d],p=m&&m.element;return{browserEvent:y,index:d,element:p}}toGestureEvent(y){const d=this.getItemIndexFromEventTarget(y.initialTarget||null),m=typeof d>"u"?void 0:this.items[d],p=m&&m.element;return{browserEvent:y,index:d,element:p}}toDragEvent(y){const d=this.getItemIndexFromEventTarget(y.target||null),m=typeof d>"u"?void 0:this.items[d],p=m&&m.element;return{browserEvent:y,index:d,element:p}}onScroll(y){try{const d=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(d,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.supportDynamicHeights&&this._rerender(y.scrollTop,y.height,y.inSmoothScrolling)}catch(d){throw console.error("Got bad scroll event:",y),d}}onTouchChange(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}onDragStart(y,d,m){if(!m.dataTransfer)return;const p=this.dnd.getDragElements(y);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(E.DataTransfers.TEXT,d),m.dataTransfer.setDragImage){let M;this.dnd.getDragLabel&&(M=this.dnd.getDragLabel(p,m)),typeof M>"u"&&(M=String(p.length));const q=(0,k.$)(".monaco-drag-image");q.textContent=M;const se=(le=>{for(;le&&!le.classList.contains("monaco-workbench");)le=le.parentElement;return le||document.body})(this.domNode);se.appendChild(q),m.dataTransfer.setDragImage(q,-10,-10),setTimeout(()=>se.removeChild(q),0)}this.domNode.classList.add("dragging"),this.currentDragData=new D(p),u.CurrentDragAndDropData=new w(p),this.dnd.onDragStart?.(this.currentDragData,m)}onDragOver(y){if(y.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(u.CurrentDragAndDropData)this.currentDragData=u.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.currentDragData=new S}const d=this.dnd.onDragOver(this.currentDragData,y.element,y.index,y.browserEvent);if(this.canDrop=typeof d=="boolean"?d:d.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof d!="boolean"&&d.effect===0?"copy":"move";let m;if(typeof d!="boolean"&&d.feedback?m=d.feedback:typeof y.index>"u"?m=[-1]:m=[y.index],m=(0,_.distinct)(m).filter(p=>p>=-1&&p<this.length).sort((p,M)=>p-M),m=m[0]===-1?[-1]:m,f(this.currentDragFeedback,m))return!0;if(this.currentDragFeedback=m,this.currentDragFeedbackDisposable.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const p of m){const M=this.items[p];M.dropTarget=!0,M.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,P.toDisposable)(()=>{for(const p of m){const M=this.items[p];M.dropTarget=!1,M.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(y){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,y.element,y.index,y.browserEvent)}onDrop(y){if(!this.canDrop)return;const d=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,u.CurrentDragAndDropData=void 0,!(!d||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),d.update(y.browserEvent.dataTransfer),this.dnd.drop(d,y.element,y.index,y.browserEvent))}onDragEnd(y){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,u.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(y)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=P.Disposable.None}setupDragAndDropScrollTopAnimation(y){if(!this.dragOverAnimationDisposable){const d=(0,k.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,k.animate)(this.animateDragAndDropScrollTop.bind(this,d))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=y.pageY}animateDragAndDropScrollTop(y){if(this.dragOverMouseY===void 0)return;const d=this.dragOverMouseY-y,m=this.renderHeight-35;d<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(d-35))):d>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(d-m))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(y){const d=this.scrollableElement.getDomNode();let m=y;for(;m instanceof HTMLElement&&m!==this.rowsContainer&&d.contains(m);){const p=m.getAttribute("data-index");if(p){const M=Number(p);if(!isNaN(M))return M}m=m.parentElement}}getRenderRange(y,d){return{start:this.rangeMap.indexAt(y),end:this.rangeMap.indexAfter(y+d-1)}}_rerender(y,d,m){const p=this.getRenderRange(y,d);let M,q;y===this.elementTop(p.start)?(M=p.start,q=0):p.end-p.start>1&&(M=p.start+1,q=this.elementTop(M)-y);let Z=0;for(;;){const se=this.getRenderRange(y,d);let le=!1;for(let fe=se.start;fe<se.end;fe++){const ue=this.probeDynamicHeight(fe);ue!==0&&this.rangeMap.splice(fe,1,[this.items[fe]]),Z+=ue,le=le||ue!==0}if(!le){Z!==0&&this.eventuallyUpdateScrollDimensions();const fe=r.Range.relativeComplement(p,se);for(const Q of fe)for(let J=Q.start;J<Q.end;J++)this.items[J].row&&this.removeItemFromDOM(J);const ue=r.Range.relativeComplement(se,p);for(const Q of ue)for(let J=Q.start;J<Q.end;J++){const ve=J+1,be=ve<this.items.length?this.items[ve].row:null,ke=be?be.domNode:null;this.insertItemInDOM(J,ke)}for(let Q=se.start;Q<se.end;Q++)this.items[Q].row&&this.updateItemInDOM(this.items[Q],Q);if(typeof M=="number"){const Q=this.scrollable.getFutureScrollPosition().scrollTop-y,J=this.elementTop(M)-q+Q;this.setScrollTop(J,m)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(y){const d=this.items[y];if(this.virtualDelegate.getDynamicHeight){const q=this.virtualDelegate.getDynamicHeight(d.element);if(q!==null){const Z=d.size;return d.size=q,d.lastDynamicHeightWidth=this.renderWidth,q-Z}}if(!d.hasDynamicHeight||d.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(d.element))return 0;const m=d.size;if(d.row)return d.row.domNode.style.height="",d.size=d.row.domNode.offsetHeight,d.lastDynamicHeightWidth=this.renderWidth,d.size-m;const{row:p}=this.cache.alloc(d.templateId);p.domNode.style.height="",this.rowsContainer.appendChild(p.domNode);const M=this.renderers.get(d.templateId);if(!M)throw new n.BugIndicatingError("Missing renderer for templateId: "+d.templateId);return M.renderElement(d.element,y,p.templateData,void 0),d.size=p.domNode.offsetHeight,M.disposeElement?.(d.element,y,p.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(d.element,d.size),d.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(p.domNode),this.cache.release(p),d.size-m}getNextToLastElement(y){const d=y[y.length-1];if(!d)return null;const m=this.items[d.end];return!m||!m.row?null:m.row.domNode}getElementDomId(y){return`${this.domId}_${y}`}dispose(){if(this.items){for(const y of this.items)if(y.row){const d=this.renderers.get(y.row.templateId);d&&(d.disposeElement?.(y.element,-1,y.row.templateData,void 0),d.disposeTemplate(y.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.disposables)}}L.InstanceCount=0,qe([l.memoize],L.prototype,"onMouseClick",null),qe([l.memoize],L.prototype,"onMouseDblClick",null),qe([l.memoize],L.prototype,"onMouseMiddleClick",null),qe([l.memoize],L.prototype,"onMouseUp",null),qe([l.memoize],L.prototype,"onMouseDown",null),qe([l.memoize],L.prototype,"onMouseOver",null),qe([l.memoize],L.prototype,"onMouseMove",null),qe([l.memoize],L.prototype,"onMouseOut",null),qe([l.memoize],L.prototype,"onContextMenu",null),qe([l.memoize],L.prototype,"onTouchStart",null),qe([l.memoize],L.prototype,"onTap",null),t.ListView=L}),define(ge[36],me([1,0,4,20,14,23,54,68,13,9,70,25,3,32,2,44,5,6,67,58,89]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e,o,n,u,s,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class w{constructor(F){this.trait=F,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(F){return F}renderElement(F,$,R){const g=this.renderedElements.findIndex(C=>C.templateData===R);if(g>=0){const C=this.renderedElements[g];this.trait.unrender(R),C.index=$}else{const C={index:$,templateData:R};this.renderedElements.push(C)}this.trait.renderIndex($,R)}splice(F,$,R){const g=[];for(const C of this.renderedElements)C.index<F?g.push(C):C.index>=F+$&&g.push({index:C.index+R-$,templateData:C.templateData});this.renderedElements=g}renderIndexes(F){for(const{index:$,templateData:R}of this.renderedElements)F.indexOf($)>-1&&this.trait.renderIndex($,R)}disposeTemplate(F){const $=this.renderedElements.findIndex(R=>R.templateData===F);$<0||this.renderedElements.splice($,1)}}class S{get name(){return this._trait}get renderer(){return new w(this)}constructor(F){this._trait=F,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new r.Emitter,this.onChange=this._onChange.event}splice(F,$,R){$=Math.max(0,Math.min($,this.length-F));const g=R.length-$,C=F+$,W=[...this.sortedIndexes.filter(A=>A<F),...R.map((A,I)=>A?I+F:-1).filter(A=>A!==-1),...this.sortedIndexes.filter(A=>A>=C).map(A=>A+g)],Y=this.length+g;if(this.sortedIndexes.length>0&&W.length===0&&Y>0){const A=this.sortedIndexes.find(I=>I>=F)??Y-1;W.push(Math.min(A,Y-1))}this.renderer.splice(F,$,R.length),this._set(W,W),this.length=Y}renderIndex(F,$){$.classList.toggle(this._trait,this.contains(F))}unrender(F){F.classList.remove(this._trait)}set(F,$){return this._set(F,[...F].sort(Re),$)}_set(F,$,R){const g=this.indexes,C=this.sortedIndexes;this.indexes=F,this.sortedIndexes=$;const W=be(C,F);return this.renderer.renderIndexes(W),this._onChange.fire({indexes:F,browserEvent:R}),g}get(){return this.indexes}contains(F){return(0,c.binarySearch)(this.sortedIndexes,F,Re)>=0}dispose(){(0,e.dispose)(this._onChange)}}qe([P.memoize],S.prototype,"renderer",null);class f extends S{constructor(F){super("selected"),this.setAriaSelected=F}renderIndex(F,$){super.renderIndex(F,$),this.setAriaSelected&&(this.contains(F)?$.setAttribute("aria-selected","true"):$.setAttribute("aria-selected","false"))}}class b{constructor(F,$,R){this.trait=F,this.view=$,this.identityProvider=R}splice(F,$,R){if(!this.identityProvider)return this.trait.splice(F,$,R.map(()=>!1));const g=this.trait.get().map(W=>this.identityProvider.getId(this.view.element(W)).toString()),C=R.map(W=>g.indexOf(this.identityProvider.getId(W).toString())>-1);this.trait.splice(F,$,C)}}function L(ie){return ie.tagName==="INPUT"||ie.tagName==="TEXTAREA"}t.isInputElement=L;function N(ie){return ie.classList.contains("monaco-editor")?!0:ie.classList.contains("monaco-list")||!ie.parentElement?!1:N(ie.parentElement)}t.isMonacoEditor=N;function y(ie){return ie.tagName==="A"&&ie.classList.contains("monaco-button")||ie.tagName==="DIV"&&ie.classList.contains("monaco-button-dropdown")?!0:ie.classList.contains("monaco-list")||!ie.parentElement?!1:y(ie.parentElement)}t.isButton=y;class d{get onKeyDown(){return this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event).filter(F=>!L(F.target)).map(F=>new i.StandardKeyboardEvent(F)))}constructor(F,$,R){this.list=F,this.view=$,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(g=>g.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(g=>g.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(g=>g.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(g=>g.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(g=>g.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(g=>g.keyCode===9).on(this.onEscape,this,this.disposables),R.multipleSelectionSupport!==!1&&this.onKeyDown.filter(g=>(n.isMacintosh?g.metaKey:g.ctrlKey)&&g.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(F){F.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),F.multipleSelectionSupport&&this.onKeyDown.filter($=>(n.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(F){F.preventDefault(),F.stopPropagation(),this.list.setSelection(this.list.getFocus(),F.browserEvent)}onUpArrow(F){F.preventDefault(),F.stopPropagation(),this.list.focusPrevious(1,!1,F.browserEvent);const $=this.list.getFocus()[0];this.list.setAnchor($),this.list.reveal($),this.view.domNode.focus()}onDownArrow(F){F.preventDefault(),F.stopPropagation(),this.list.focusNext(1,!1,F.browserEvent);const $=this.list.getFocus()[0];this.list.setAnchor($),this.list.reveal($),this.view.domNode.focus()}onPageUpArrow(F){F.preventDefault(),F.stopPropagation(),this.list.focusPreviousPage(F.browserEvent);const $=this.list.getFocus()[0];this.list.setAnchor($),this.list.reveal($),this.view.domNode.focus()}onPageDownArrow(F){F.preventDefault(),F.stopPropagation(),this.list.focusNextPage(F.browserEvent);const $=this.list.getFocus()[0];this.list.setAnchor($),this.list.reveal($),this.view.domNode.focus()}onCtrlA(F){F.preventDefault(),F.stopPropagation(),this.list.setSelection((0,c.range)(this.list.length),F.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(F){this.list.getSelection().length&&(F.preventDefault(),F.stopPropagation(),this.list.setSelection([],F.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}qe([P.memoize],d.prototype,"onKeyDown",null);var m;(function(ie){ie[ie.Automatic=0]="Automatic",ie[ie.Trigger=1]="Trigger"})(m=t.TypeNavigationMode||(t.TypeNavigationMode={}));var p;(function(ie){ie[ie.Idle=0]="Idle",ie[ie.Typing=1]="Typing"})(p||(p={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(ie){return ie.ctrlKey||ie.metaKey||ie.altKey?!1:ie.keyCode>=31&&ie.keyCode<=56||ie.keyCode>=21&&ie.keyCode<=30||ie.keyCode>=93&&ie.keyCode<=102||ie.keyCode>=80&&ie.keyCode<=90}};class M{constructor(F,$,R,g,C){this.list=F,this.view=$,this.keyboardNavigationLabelProvider=R,this.keyboardNavigationEventFilter=g,this.delegate=C,this.enabled=!1,this.state=p.Idle,this.mode=m.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(F.options)}updateOptions(F){F.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=F.typeNavigationMode??m.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let F=!1;const $=this.enabledDisposables.add(r.Event.chain(this.enabledDisposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event)).filter(C=>!L(C.target)).filter(()=>this.mode===m.Automatic||this.triggered).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>F||this.keyboardNavigationEventFilter(C)).filter(C=>this.delegate.mightProducePrintableCharacter(C)).forEach(C=>E.EventHelper.stop(C,!0)).map(C=>C.browserEvent.key).event,R=r.Event.debounce($,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);r.Event.reduce(r.Event.any($,R),(C,W)=>W===null?null:(C||"")+W,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),R(this.onClear,this,this.enabledDisposables),$(()=>F=!0,void 0,this.enabledDisposables),R(()=>F=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const F=this.list.getFocus();if(F.length>0&&F[0]===this.previouslyFocused){const $=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(F[0]));$&&(0,v.alert)($)}this.previouslyFocused=-1}onInput(F){if(!F){this.state=p.Idle,this.triggered=!1;return}const $=this.list.getFocus(),R=$.length>0?$[0]:0,g=this.state===p.Idle?1:0;this.state=p.Typing;for(let C=0;C<this.list.length;C++){const W=(R+C+g)%this.list.length,Y=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(W)),A=Y&&Y.toString();if(typeof A>"u"||(0,a.matchesPrefix)(F,A)){this.previouslyFocused=R,this.list.setFocus([W]),this.list.reveal(W);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class q{constructor(F,$){this.list=F,this.view=$,this.disposables=new e.DisposableStore,this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter($.domNode,"keydown")).event)).filter(g=>!L(g.target)).map(g=>new i.StandardKeyboardEvent(g)).filter(g=>g.keyCode===2&&!g.ctrlKey&&!g.metaKey&&!g.shiftKey&&!g.altKey).on(this.onTab,this,this.disposables)}onTab(F){if(F.target!==this.view.domNode)return;const $=this.list.getFocus();if($.length===0)return;const R=this.view.domElement($[0]);if(!R)return;const g=R.querySelector("[tabIndex]");if(!g||!(g instanceof HTMLElement)||g.tabIndex===-1)return;const C=window.getComputedStyle(g);C.visibility==="hidden"||C.display==="none"||(F.preventDefault(),F.stopPropagation(),g.focus())}dispose(){this.disposables.dispose()}}function Z(ie){return n.isMacintosh?ie.browserEvent.metaKey:ie.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function se(ie){return ie.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=se;function le(ie){return ie instanceof MouseEvent&&ie.button===2}const fe={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:se};class ue{constructor(F){this.list=F,this.disposables=new e.DisposableStore,this._onPointer=new r.Emitter,this.onPointer=this._onPointer.event,F.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||fe),this.mouseSupport=typeof F.options.mouseSupport>"u"||!!F.options.mouseSupport,this.mouseSupport&&(F.onMouseDown(this.onMouseDown,this,this.disposables),F.onContextMenu(this.onContextMenu,this,this.disposables),F.onMouseDblClick(this.onDoubleClick,this,this.disposables),F.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(z.Gesture.addTarget(F.getHTMLElement()))),r.Event.any(F.onMouseClick,F.onMouseMiddleClick,F.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(F){F.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,F.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||fe))}isSelectionSingleChangeEvent(F){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(F):!1}isSelectionRangeChangeEvent(F){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(F):!1}isSelectionChangeEvent(F){return this.isSelectionSingleChangeEvent(F)||this.isSelectionRangeChangeEvent(F)}onMouseDown(F){N(F.browserEvent.target)||document.activeElement!==F.browserEvent.target&&this.list.domFocus()}onContextMenu(F){if(L(F.browserEvent.target)||N(F.browserEvent.target))return;const $=typeof F.index>"u"?[]:[F.index];this.list.setFocus($,F.browserEvent)}onViewPointer(F){if(!this.mouseSupport||L(F.browserEvent.target)||N(F.browserEvent.target))return;const $=F.index;if(typeof $>"u"){this.list.setFocus([],F.browserEvent),this.list.setSelection([],F.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(F))return this.changeSelection(F);if(this.isSelectionChangeEvent(F))return this.changeSelection(F);this.list.setFocus([$],F.browserEvent),this.list.setAnchor($),le(F.browserEvent)||this.list.setSelection([$],F.browserEvent),this._onPointer.fire(F)}onDoubleClick(F){if(L(F.browserEvent.target)||N(F.browserEvent.target)||this.isSelectionChangeEvent(F))return;const $=this.list.getFocus();this.list.setSelection($,F.browserEvent)}changeSelection(F){const $=F.index;let R=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(F)){typeof R>"u"&&(R=this.list.getFocus()[0]??$,this.list.setAnchor(R));const g=Math.min(R,$),C=Math.max(R,$),W=(0,c.range)(g,C+1),Y=this.list.getSelection(),A=ve(be(Y,[R]),R);if(A.length===0)return;const I=be(W,ke(Y,A));this.list.setSelection(I,F.browserEvent),this.list.setFocus([$],F.browserEvent)}else if(this.isSelectionSingleChangeEvent(F)){const g=this.list.getSelection(),C=g.filter(W=>W!==$);this.list.setFocus([$]),this.list.setAnchor($),g.length===C.length?this.list.setSelection([...C,$],F.browserEvent):this.list.setSelection(C,F.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ue;class Q{constructor(F,$){this.styleElement=F,this.selectorSuffix=$}style(F){const $=this.selectorSuffix&&`.${this.selectorSuffix}`,R=[];F.listBackground&&R.push(`.monaco-list${$} .monaco-list-rows { background: ${F.listBackground}; }`),F.listFocusBackground&&(R.push(`.monaco-list${$}:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),R.push(`.monaco-list${$}:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&R.push(`.monaco-list${$}:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(R.push(`.monaco-list${$}:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),R.push(`.monaco-list${$}:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&R.push(`.monaco-list${$}:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listActiveSelectionIconForeground&&R.push(`.monaco-list${$}:focus .monaco-list-row.selected .codicon { color: ${F.listActiveSelectionIconForeground}; }`),F.listFocusAndSelectionBackground&&R.push(`
				.monaco-drag-image,
				.monaco-list${$}:focus .monaco-list-row.selected.focused { background-color: ${F.listFocusAndSelectionBackground}; }
			`),F.listFocusAndSelectionForeground&&R.push(`
				.monaco-drag-image,
				.monaco-list${$}:focus .monaco-list-row.selected.focused { color: ${F.listFocusAndSelectionForeground}; }
			`),F.listInactiveFocusForeground&&(R.push(`.monaco-list${$} .monaco-list-row.focused { color:  ${F.listInactiveFocusForeground}; }`),R.push(`.monaco-list${$} .monaco-list-row.focused:hover { color:  ${F.listInactiveFocusForeground}; }`)),F.listInactiveSelectionIconForeground&&R.push(`.monaco-list${$} .monaco-list-row.focused .codicon { color:  ${F.listInactiveSelectionIconForeground}; }`),F.listInactiveFocusBackground&&(R.push(`.monaco-list${$} .monaco-list-row.focused { background-color:  ${F.listInactiveFocusBackground}; }`),R.push(`.monaco-list${$} .monaco-list-row.focused:hover { background-color:  ${F.listInactiveFocusBackground}; }`)),F.listInactiveSelectionBackground&&(R.push(`.monaco-list${$} .monaco-list-row.selected { background-color:  ${F.listInactiveSelectionBackground}; }`),R.push(`.monaco-list${$} .monaco-list-row.selected:hover { background-color:  ${F.listInactiveSelectionBackground}; }`)),F.listInactiveSelectionForeground&&R.push(`.monaco-list${$} .monaco-list-row.selected { color: ${F.listInactiveSelectionForeground}; }`),F.listHoverBackground&&R.push(`.monaco-list${$}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&R.push(`.monaco-list${$}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${F.listHoverForeground}; }`);const g=(0,E.asCssValueWithDefault)(F.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(F.listSelectionOutline,F.listFocusOutline??""));g&&R.push(`.monaco-list${$}:focus .monaco-list-row.focused.selected { outline: 1px solid ${g}; outline-offset: -1px;}`),F.listFocusOutline&&R.push(`
				.monaco-drag-image,
				.monaco-list${$}:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${$}.last-focused .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }
			`);const C=(0,E.asCssValueWithDefault)(F.listSelectionOutline,F.listInactiveFocusOutline??"");C&&R.push(`.monaco-list${$} .monaco-list-row.focused.selected { outline: 1px dotted ${C}; outline-offset: -1px; }`),F.listSelectionOutline&&R.push(`.monaco-list${$} .monaco-list-row.selected { outline: 1px dotted ${F.listSelectionOutline}; outline-offset: -1px; }`),F.listInactiveFocusOutline&&R.push(`.monaco-list${$} .monaco-list-row.focused { outline: 1px dotted ${F.listInactiveFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&R.push(`.monaco-list${$} .monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.listDropBackground&&R.push(`
				.monaco-list${$}.drop-target,
				.monaco-list${$} .monaco-list-rows.drop-target,
				.monaco-list${$} .monaco-list-row.drop-target { background-color: ${F.listDropBackground} !important; color: inherit !important; }
			`),F.tableColumnsBorder&&R.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${F.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),F.tableOddRowsBackgroundColor&&R.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${F.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=R.join(`
`)}}t.DefaultStyleController=Q,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:h.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:h.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:h.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ve(ie,F){const $=ie.indexOf(F);if($===-1)return[];const R=[];let g=$-1;for(;g>=0&&ie[g]===F-($-g);)R.push(ie[g--]);for(R.reverse(),g=$;g<ie.length&&ie[g]===F+(g-$);)R.push(ie[g++]);return R}function be(ie,F){const $=[];let R=0,g=0;for(;R<ie.length||g<F.length;)if(R>=ie.length)$.push(F[g++]);else if(g>=F.length)$.push(ie[R++]);else if(ie[R]===F[g]){$.push(ie[R]),R++,g++;continue}else ie[R]<F[g]?$.push(ie[R++]):$.push(F[g++]);return $}function ke(ie,F){const $=[];let R=0,g=0;for(;R<ie.length||g<F.length;)if(R>=ie.length)$.push(F[g++]);else if(g>=F.length)$.push(ie[R++]);else if(ie[R]===F[g]){R++,g++;continue}else ie[R]<F[g]?$.push(ie[R++]):g++;return $}const Re=(ie,F)=>ie-F;class ae{constructor(F,$){this._templateId=F,this.renderers=$}get templateId(){return this._templateId}renderTemplate(F){return this.renderers.map($=>$.renderTemplate(F))}renderElement(F,$,R,g){let C=0;for(const W of this.renderers)W.renderElement(F,$,R[C++],g)}disposeElement(F,$,R,g){let C=0;for(const W of this.renderers)W.disposeElement?.(F,$,R[C],g),C+=1}disposeTemplate(F){let $=0;for(const R of this.renderers)R.disposeTemplate(F[$++])}}class U{constructor(F){this.accessibilityProvider=F,this.templateId="a18n"}renderTemplate(F){return F}renderElement(F,$,R){const g=this.accessibilityProvider.getAriaLabel(F);g?R.setAttribute("aria-label",g):R.removeAttribute("aria-label");const C=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(F);typeof C=="number"?R.setAttribute("aria-level",`${C}`):R.removeAttribute("aria-level")}disposeTemplate(F){}}class ne{constructor(F,$){this.list=F,this.dnd=$}getDragElements(F){const $=this.list.getSelectedElements();return $.indexOf(F)>-1?$:[F]}getDragURI(F){return this.dnd.getDragURI(F)}getDragLabel(F,$){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(F,$)}onDragStart(F,$){this.dnd.onDragStart?.(F,$)}onDragOver(F,$,R,g){return this.dnd.onDragOver(F,$,R,g)}onDragLeave(F,$,R,g){this.dnd.onDragLeave?.(F,$,R,g)}onDragEnd(F){this.dnd.onDragEnd?.(F)}drop(F,$,R,g){this.dnd.drop(F,$,R,g)}}class te{get onDidChangeFocus(){return r.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),F=>this.toListEvent(F),this.disposables)}get onDidChangeSelection(){return r.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),F=>this.toListEvent(F),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let F=!1;const $=this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event)).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>F=C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).filter(()=>!1).event,R=this.disposables.add(r.Event.chain(this.disposables.add(new k.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>F=!1).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).map(({browserEvent:C})=>{const W=this.getFocus(),Y=W.length?W[0]:void 0,A=typeof Y<"u"?this.view.element(Y):void 0,I=typeof Y<"u"?this.view.domElement(Y):this.view.domNode;return{index:Y,element:A,anchor:I,browserEvent:C}}).event,g=this.disposables.add(r.Event.chain(this.view.onContextMenu)).filter(C=>!F).map(({element:C,index:W,browserEvent:Y})=>({element:C,index:W,anchor:{x:Y.pageX+1,y:Y.pageY},browserEvent:Y})).event;return r.Event.any($,R,g)}get onKeyDown(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new k.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.disposables.add(new k.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.disposables.add(new k.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(F,$,R,g,C=J){this.user=F,this._options=C,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new r.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event;const W=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new f(W!=="listbox");const Y=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=C.accessibilityProvider,this.accessibilityProvider&&(Y.push(new U(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),g=g.map(I=>new ae(I.templateId,[...Y,I]));const A={...C,dnd:C.dnd&&new ne(this,C.dnd)};if(this.view=this.createListView($,R,g,A),this.view.domNode.setAttribute("role",W),C.styleController)this.styleController=C.styleController(this.view.domId);else{const I=(0,E.createStyleSheet)(this.view.domNode);this.styleController=new Q(I,this.view.domId)}if(this.spliceable=new _.CombinedSpliceable([new b(this.focus,this.view,C.identityProvider),new b(this.selection,this.view,C.identityProvider),new b(this.anchor,this.view,C.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new q(this,this.view)),(typeof C.keyboardSupport!="boolean"||C.keyboardSupport)&&(this.keyboardController=new d(this,this.view,C),this.disposables.add(this.keyboardController)),C.keyboardNavigationLabelProvider){const I=C.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new M(this,this.view,C.keyboardNavigationLabelProvider,C.keyboardNavigationEventFilter??(()=>!0),I),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(C),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(F,$,R,g){return new D.ListView(F,$,R,g)}createMouseController(F){return new ue(this)}updateOptions(F={}){this._options={...this._options,...F},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(F),this.keyboardController?.updateOptions(F),this.view.updateOptions(F)}get options(){return this._options}splice(F,$,R=[]){if(F<0||F>this.view.length)throw new s.ListError(this.user,`Invalid start index: ${F}`);if($<0)throw new s.ListError(this.user,`Invalid delete count: ${$}`);$===0&&R.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(F,$,R))}updateWidth(F){this.view.updateWidth(F)}updateElementHeight(F,$){this.view.updateElementHeight(F,$,null)}rerender(){this.view.rerender()}element(F){return this.view.element(F)}indexOf(F){return this.view.indexOf(F)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(F){this.view.setScrollTop(F)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(F){this.view.setScrollLeft(F)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(F){this._ariaLabel=F,this.view.domNode.setAttribute("aria-label",F)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(F,$){this.view.layout(F,$)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(F,$){for(const R of F)if(R<0||R>=this.length)throw new s.ListError(this.user,`Invalid index ${R}`);this.selection.set(F,$)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(F=>this.view.element(F))}setAnchor(F){if(typeof F>"u"){this.anchor.set([]);return}if(F<0||F>=this.length)throw new s.ListError(this.user,`Invalid index ${F}`);this.anchor.set([F])}getAnchor(){return(0,c.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const F=this.getAnchor();return typeof F>"u"?void 0:this.element(F)}setFocus(F,$){for(const R of F)if(R<0||R>=this.length)throw new s.ListError(this.user,`Invalid index ${R}`);this.focus.set(F,$)}focusNext(F=1,$=!1,R,g){if(this.length===0)return;const C=this.focus.get(),W=this.findNextIndex(C.length>0?C[0]+F:0,$,g);W>-1&&this.setFocus([W],R)}focusPrevious(F=1,$=!1,R,g){if(this.length===0)return;const C=this.focus.get(),W=this.findPreviousIndex(C.length>0?C[0]-F:0,$,g);W>-1&&this.setFocus([W],R)}async focusNextPage(F,$){let R=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);R=R===0?0:R-1;const g=this.getFocus()[0];if(g!==R&&(g===void 0||R>g)){const C=this.findPreviousIndex(R,!1,$);C>-1&&g!==C?this.setFocus([C],F):this.setFocus([R],F)}else{const C=this.view.getScrollTop();let W=C+this.view.renderHeight;R>g&&(W-=this.view.elementHeight(R)),this.view.setScrollTop(W),this.view.getScrollTop()!==C&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusNextPage(F,$))}}async focusPreviousPage(F,$){let R;const g=this.view.getScrollTop();g===0?R=this.view.indexAt(g):R=this.view.indexAfter(g-1);const C=this.getFocus()[0];if(C!==R&&(C===void 0||C>=R)){const W=this.findNextIndex(R,!1,$);W>-1&&C!==W?this.setFocus([W],F):this.setFocus([R],F)}else{const W=g;this.view.setScrollTop(g-this.view.renderHeight),this.view.getScrollTop()!==W&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusPreviousPage(F,$))}}focusLast(F,$){if(this.length===0)return;const R=this.findPreviousIndex(this.length-1,!1,$);R>-1&&this.setFocus([R],F)}focusFirst(F,$){this.focusNth(0,F,$)}focusNth(F,$,R){if(this.length===0)return;const g=this.findNextIndex(F,!1,R);g>-1&&this.setFocus([g],$)}findNextIndex(F,$=!1,R){for(let g=0;g<this.length;g++){if(F>=this.length&&!$)return-1;if(F=F%this.length,!R||R(this.element(F)))return F;F++}return-1}findPreviousIndex(F,$=!1,R){for(let g=0;g<this.length;g++){if(F<0&&!$)return-1;if(F=(this.length+F%this.length)%this.length,!R||R(this.element(F)))return F;F--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(F=>this.view.element(F))}reveal(F,$){if(F<0||F>=this.length)throw new s.ListError(this.user,`Invalid index ${F}`);const R=this.view.getScrollTop(),g=this.view.elementTop(F),C=this.view.elementHeight(F);if((0,u.isNumber)($)){const W=C-this.view.renderHeight;this.view.setScrollTop(W*(0,o.clamp)($,0,1)+g)}else{const W=g+C,Y=R+this.view.renderHeight;g<R&&W>=Y||(g<R||W>=Y&&C>=this.view.renderHeight?this.view.setScrollTop(g):W>=Y&&this.view.setScrollTop(W-this.view.renderHeight))}}getRelativeTop(F){if(F<0||F>=this.length)throw new s.ListError(this.user,`Invalid index ${F}`);const $=this.view.getScrollTop(),R=this.view.elementTop(F),g=this.view.elementHeight(F);if(R<$||R+g>$+this.view.renderHeight)return null;const C=g-this.view.renderHeight;return Math.abs(($-R)/C)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(F){return this.view.getElementDomId(F)}style(F){this.styleController.style(F)}toListEvent({indexes:F,browserEvent:$}){return{indexes:F,elements:F.map(R=>this.view.element(R)),browserEvent:$}}_onFocusChange(){const F=this.focus.get();this.view.domNode.classList.toggle("element-focused",F.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const F=this.focus.get();if(F.length>0){let $;this.accessibilityProvider?.getActiveDescendantId&&($=this.accessibilityProvider.getActiveDescendantId(this.view.element(F[0]))),this.view.domNode.setAttribute("aria-activedescendant",$||this.view.getElementDomId(F[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const F=this.selection.get();this.view.domNode.classList.toggle("selection-none",F.length===0),this.view.domNode.classList.toggle("selection-single",F.length===1),this.view.domNode.classList.toggle("selection-multiple",F.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}qe([P.memoize],te.prototype,"onDidChangeFocus",null),qe([P.memoize],te.prototype,"onDidChangeSelection",null),qe([P.memoize],te.prototype,"onContextMenu",null),qe([P.memoize],te.prototype,"onKeyDown",null),qe([P.memoize],te.prototype,"onKeyUp",null),qe([P.memoize],te.prototype,"onKeyPress",null),qe([P.memoize],te.prototype,"onDidFocus",null),qe([P.memoize],te.prototype,"onDidBlur",null),t.List=te}),define(ge[59],me([1,0,7,33,34,11,15]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class c{constructor(u="",s=!1){if(this.value=u,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(u,s=0){return this.value+=r(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(D,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,s){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(u,s,D){return this.value+="[",this.value+=this._escape(s,"]"),this.value+="](",this.value+=this._escape(String(u),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(u,s){const D=new RegExp((0,z.escapeRegExpCharacters)(s),"g");return u.replace(D,(w,S)=>u.charAt(S-1)!=="\\"?`\\${w}`:w)}}t.MarkdownString=c;function l(n){return h(n)?!n.value:Array.isArray(n)?n.every(l):!0}t.isEmptyMarkdownString=l;function h(n){return n instanceof c?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=h;function P(n,u){return n===u?!0:!n||!u?!1:n.value===u.value&&n.isTrusted===u.isTrusted&&n.supportThemeIcons===u.supportThemeIcons&&n.supportHtml===u.supportHtml&&(n.baseUri===u.baseUri||!!n.baseUri&&!!u.baseUri&&(0,i.isEqual)(v.URI.from(n.baseUri),v.URI.from(u.baseUri)))}t.markdownStringEqual=P;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function a(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=a;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function o(n){const u=[],s=n.split("|").map(w=>w.trim());n=s[0];const D=s[1];if(D){const w=/height=(\d+)/.exec(D),S=/width=(\d+)/.exec(D),f=w?w[1]:"",b=S?S[1]:"",L=isFinite(parseInt(b)),N=isFinite(parseInt(f));L&&u.push(`width="${b}"`),N&&u.push(`height="${f}"`)}return{href:n,dimensions:u}}t.parseHrefAndDimensions=o}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,59,33,73,42,2,76,50,28,47,34,11,15]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e,o,n,u,s,D,w,S,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const b=Object.freeze({image:(Q,J,ve)=>{let be=[],ke=[];return Q&&({href:Q,dimensions:be}=(0,P.parseHrefAndDimensions)(Q),ke.push(`src="${(0,P.escapeDoubleQuotes)(Q)}"`)),ve&&ke.push(`alt="${(0,P.escapeDoubleQuotes)(ve)}"`),J&&ke.push(`title="${(0,P.escapeDoubleQuotes)(J)}"`),be.length&&(ke=ke.concat(be)),"<img "+ke.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,J,ve)=>typeof Q!="string"?"":(Q===ve&&(ve=(0,P.removeMarkdownEscapes)(ve)),J=typeof J=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(J)):"",Q=(0,P.removeMarkdownEscapes)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${J||Q}">${ve}</a>`)});function L(Q,J={},ve={}){const be=new o.DisposableStore;let ke=!1;const Re=(0,z.createElement)(J),ae=function(C){let W;try{W=(0,u.parse)(decodeURIComponent(C))}catch{}return W?(W=(0,D.cloneAndChange)(W,Y=>{if(Q.uris&&Q.uris[Y])return f.URI.revive(Q.uris[Y])}),encodeURIComponent(JSON.stringify(W))):C},U=function(C,W){const Y=Q.uris&&Q.uris[C];let A=f.URI.revive(Y);return W?C.startsWith(s.Schemas.data+":")?C:(A||(A=f.URI.parse(C)),s.FileAccess.uriToBrowserUri(A).toString(!0)):!A||f.URI.parse(C).toString()===A.toString()?C:(A.query&&(A=A.with({query:ae(A.query)})),A.toString())},ne=new n.marked.Renderer;ne.image=b.image,ne.link=b.link,ne.paragraph=b.paragraph;const te=[],ie=[];if(J.codeBlockRendererSync?ne.code=(C,W)=>{const Y=a.defaultGenerator.nextId(),A=J.codeBlockRendererSync(N(W),C);return ie.push([Y,A]),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}:J.codeBlockRenderer&&(ne.code=(C,W)=>{const Y=a.defaultGenerator.nextId(),A=J.codeBlockRenderer(N(W),C);return te.push(A.then(I=>[Y,I])),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}),J.actionHandler){const C=function(A){let I=A.target;if(!(I.tagName!=="A"&&(I=I.parentElement,!I||I.tagName!=="A")))try{let O=I.dataset.href;O&&(Q.baseUri&&(O=y(f.URI.from(Q.baseUri),O)),J.actionHandler.callback(O,A))}catch(O){(0,l.onUnexpectedError)(O)}finally{A.preventDefault()}},W=J.actionHandler.disposables.add(new i.DomEmitter(Re,"click")),Y=J.actionHandler.disposables.add(new i.DomEmitter(Re,"auxclick"));J.actionHandler.disposables.add(h.Event.any(W.event,Y.event)(A=>{const I=new _.StandardMouseEvent(A);!I.leftButton&&!I.middleButton||C(I)})),J.actionHandler.disposables.add(E.addDisposableListener(Re,"keydown",A=>{const I=new v.StandardKeyboardEvent(A);!I.equals(10)&&!I.equals(3)||C(I)}))}Q.supportHtml||(ve.sanitizer=C=>(Q.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",ve.sanitize=!0,ve.silent=!0),ve.renderer=ne;let F=Q.value??"";F.length>1e5&&(F=`${F.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(F=(0,r.markdownEscapeEscapedIcons)(F));let $;if(J.fillInIncompleteTokens){const C={...n.marked.defaults,...ve},W=n.marked.lexer(F,C),Y=le(W);$=n.marked.parser(Y,C)}else $=n.marked.parse(F,ve);Q.supportThemeIcons&&($=(0,c.renderLabelWithIcons)($).map(W=>typeof W=="string"?W:W.outerHTML).join(""));const g=new DOMParser().parseFromString(d(Q,$),"text/html");if(g.body.querySelectorAll("img").forEach(C=>{const W=C.getAttribute("src");if(W){let Y=W;try{Q.baseUri&&(Y=y(f.URI.from(Q.baseUri),Y))}catch{}C.src=U(Y,!0)}}),g.body.querySelectorAll("a").forEach(C=>{const W=C.getAttribute("href");if(C.setAttribute("href",""),!W||/^data:|javascript:/i.test(W)||/^command:/i.test(W)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(W))C.replaceWith(...C.childNodes);else{let Y=U(W,!1);Q.baseUri&&(Y=y(f.URI.from(Q.baseUri),W)),C.dataset.href=Y}}),Re.innerHTML=d(Q,g.body.innerHTML),te.length>0)Promise.all(te).then(C=>{if(ke)return;const W=new Map(C),Y=Re.querySelectorAll("div[data-code]");for(const A of Y){const I=W.get(A.dataset.code??"");I&&E.reset(A,I)}J.asyncRenderCallback?.()});else if(ie.length>0){const C=new Map(ie),W=Re.querySelectorAll("div[data-code]");for(const Y of W){const A=C.get(Y.dataset.code??"");A&&E.reset(Y,A)}}if(J.asyncRenderCallback)for(const C of Re.getElementsByTagName("img")){const W=be.add(E.addDisposableListener(C,"load",()=>{W.dispose(),J.asyncRenderCallback()}))}return{element:Re,dispose:()=>{ke=!0,be.dispose()}}}t.renderMarkdown=L;function N(Q){if(!Q)return"";const J=Q.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:Q}function y(Q,J){return/^\w[\w\d+.-]*:/.test(J)?J:Q.path.endsWith("/")?(0,w.resolvePath)(Q,J).toString():(0,w.resolvePath)((0,w.dirname)(Q),J).toString()}function d(Q,J){const{config:ve,allowedSchemes:be}=m(Q);k.addHook("uponSanitizeAttribute",(Re,ae)=>{if(ae.attrName==="style"||ae.attrName==="class"){if(Re.tagName==="SPAN"){if(ae.attrName==="style"){ae.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(ae.attrValue);return}else if(ae.attrName==="class"){ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ae.attrValue);return}}ae.keepAttr=!1;return}});const ke=E.hookDomPurifyHrefAndSrcSanitizer(be);try{return k.sanitize(J,{...ve,RETURN_TRUSTED_TYPE:!0})}finally{k.removeHook("uponSanitizeAttribute"),ke.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function m(Q){const J=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return Q.isTrusted&&J.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function p(Q){return typeof Q=="string"?Q:M(Q)}t.renderStringAsPlaintext=p;function M(Q){let J=Q.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const ve=n.marked.parse(J,{renderer:Z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,be=>q.get(be)??be);return d({isTrusted:!1},ve).toString()}t.renderMarkdownAsPlaintext=M;const q=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),Z=new e.Lazy(()=>{const Q=new n.marked.Renderer;return Q.code=J=>J,Q.blockquote=J=>J,Q.html=J=>"",Q.heading=(J,ve,be)=>J+`
`,Q.hr=()=>"",Q.list=(J,ve)=>J,Q.listitem=J=>J+`
`,Q.paragraph=J=>J+`
`,Q.table=(J,ve)=>J+ve+`
`,Q.tablerow=J=>J,Q.tablecell=(J,ve)=>J+" ",Q.strong=J=>J,Q.em=J=>J,Q.codespan=J=>J,Q.br=()=>`
`,Q.del=J=>J,Q.image=(J,ve,be)=>"",Q.text=J=>J,Q.link=(J,ve,be)=>be,Q});function se(Q){let J="";return Q.forEach(ve=>{J+=ve.raw}),J}function le(Q){let J,ve;for(J=0;J<Q.length;J++){const be=Q[J];if(be.type==="paragraph"&&be.raw.match(/(\n|^)```/)){ve=fe(Q.slice(J));break}if(be.type==="paragraph"&&be.raw.match(/(\n|^)\|/)){ve=ue(Q.slice(J));break}}if(ve){const be=[...Q.slice(0,J),...ve];return be.links=Q.links,be}return Q}t.fillInIncompleteTokens=le;function fe(Q){const J=se(Q);return n.marked.lexer(J+"\n```")}function ue(Q){const J=se(Q),ve=J.split(`
`);let be,ke=!1;for(let Re=0;Re<ve.length;Re++){const ae=ve[Re].trim();if(typeof be>"u"&&ae.match(/^\s*\|/)){const U=ae.match(/(\|[^\|]+)(?=\||$)/g);U&&(be=U.length)}else if(typeof be=="number")if(ae.match(/^\s*\|/)){if(Re!==ve.length-1)return Q;ke=!0}else return Q}if(typeof be=="number"&&be>0){const Re=ke?ve.slice(0,-1).join(`
`):J,ae=!!Re.match(/\|\s*$/),U=Re+(ae?"":"|")+`
|${" --- |".repeat(be)}`;return n.marked.lexer(U)}return Q}}),define(ge[123],me([1,0,4,9,27,59,33,2,6,99]),function(ee,t,E,k,i,z,v,_,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function h(a,e){(0,c.isString)(e)?a.title=(0,v.stripIcons)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.setupNativeHover=h;class P{constructor(e,o,n){this.hoverDelegate=e,this.target=o,this.fadeInAnimation=n}async update(e,o,n){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let u;if(e===void 0||(0,c.isString)(e)||e instanceof HTMLElement)u=e;else if(!(0,c.isFunction)(e.markdown))u=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,l.localize)(0,null),o),this._cancellationTokenSource=new i.CancellationTokenSource;const s=this._cancellationTokenSource.token;if(u=await e.markdown(s),u===void 0&&(u=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.show(u,o,n)}show(e,o,n){const u=this._hoverWidget;if(this.hasContent(e)){const s={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!u,...n};this._hoverWidget=this.hoverDelegate.showHover(s,o)}u?.dispose()}hasContent(e){return e?(0,z.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function r(a,e,o,n){let u,s;const D=(L,N)=>{const y=s!==void 0;L&&(s?.dispose(),s=void 0),N&&(u?.dispose(),u=void 0),y&&a.onDidHideHover?.()},w=(L,N,y)=>new k.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new P(a,y||e,L>0),await s.update(o,N,n))},L),S=()=>{if(u)return;const L=new _.DisposableStore,N=m=>D(!1,m.fromElement===e);L.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,N,!0));const y=()=>D(!0,!0);L.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,y,!0));const d={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const m=p=>{d.x=p.x+10,p.target instanceof HTMLElement&&p.target.classList.contains("action-label")&&D(!0,!0)};L.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,m,!0))}L.add(w(a.delay,!1,d)),u=L},f=E.addDisposableListener(e,E.EventType.MOUSE_OVER,S,!0);return{show:L=>{D(!1,!0),w(0,L)},hide:()=>{D(!0,!0)},update:async(L,N)=>{o=L,await s?.update(o,void 0,N)},dispose:()=>{f.dispose(),D(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,36,13,3,41,2,5,101,92]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const a=E.$,e="selectOption.entry.template";class o{get templateId(){return e}renderTemplate(s){const D=Object.create(null);return D.root=s,D.text=E.append(s,a(".option-text")),D.detail=E.append(s,a(".option-detail")),D.decoratorRight=E.append(s,a(".option-decorator-right")),D}renderElement(s,D,w){const S=w,f=s.text,b=s.detail,L=s.decoratorRight,N=s.isDisabled;S.text.textContent=f,S.detail.textContent=b||"",S.decoratorRight.innerText=L||"",N?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends h.Disposable{constructor(s,D,w,S,f){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=S,this.selectBoxOptions=f||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new c.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(w),this.selected=D||0,s&&this.setOptions(s,D),this.initStyleSheet()}getHeight(){return 22}getTemplateId(){return e}constructSelectDropDown(s){this.contextViewProvider=s,this.selectDropDownContainer=E.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=E.append(this.selectDropDownContainer,a(".select-box-details-pane"));const D=E.append(this.selectDropDownContainer,a(".select-box-dropdown-container-width-control")),w=E.append(D,a(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",E.append(w,this.widthControlElement),this._dropDownPosition=0,this.styleElement=E.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.DRAG_START,S=>{E.EventHelper.stop(S,!0)}))}registerListeners(){this._register(E.addStandardDisposableListener(this.selectElement,"change",D=>{this.selected=D.target.selectedIndex,this._onDidSelect.fire({index:D.target.selectedIndex,selected:D.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(E.addDisposableListener(this.selectElement,E.EventType.CLICK,D=>{E.EventHelper.stop(D),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.MOUSE_DOWN,D=>{E.EventHelper.stop(D)}));let s;this._register(E.addDisposableListener(this.selectElement,"touchstart",D=>{s=this._isVisible})),this._register(E.addDisposableListener(this.selectElement,"touchend",D=>{E.EventHelper.stop(D),s?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.KEY_DOWN,D=>{const w=new i.StandardKeyboardEvent(D);let S=!1;P.isMacintosh?(w.keyCode===18||w.keyCode===16||w.keyCode===10||w.keyCode===3)&&(S=!0):(w.keyCode===18&&w.altKey||w.keyCode===16&&w.altKey||w.keyCode===10||w.keyCode===3)&&(S=!0),S&&(this.showSelectDropDown(),E.EventHelper.stop(D,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(s,D){_.equals(this.options,s)||(this.options=s,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((w,S)=>{this.selectElement.add(this.createOption(w.text,S,w.isDisabled)),typeof w.description=="string"&&(this._hasDetails=!0)})),D!==void 0&&(this.select(D),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(s){s>=0&&s<this.options.length?this.selected=s:s>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(s){this.selectBoxOptions.ariaLabel=s,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(s){this.selectElement.tabIndex=s?0:-1}render(s){this.container=s,s.classList.add("select-container"),s.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const s=[];this.styles.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=s.join(`
`)}styleSelectElement(){const s=this.styles.selectBackground??"",D=this.styles.selectForeground??"",w=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=s,this.selectElement.style.color=D,this.selectElement.style.borderColor=w}styleList(){const s=this.styles.selectBackground??"",D=E.asCssValueWithDefault(this.styles.selectListBackground,s);this.selectDropDownListContainer.style.backgroundColor=D,this.selectionDetailsPane.style.backgroundColor=D;const w=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=w,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(s,D,w){const S=document.createElement("option");return S.value=s,S.text=s,S.disabled=!!w,S}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:s=>this.renderSelectDropDown(s),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(s){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),s&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(s,D){return s.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(D),{dispose:()=>{try{s.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let s=0;return this.options.forEach((D,w)=>{this.updateDetail(w),this.selectionDetailsPane.offsetHeight>s&&(s=this.selectionDetailsPane.offsetHeight)}),s}layoutSelectDropDown(s){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const D=E.getDomNodePagePosition(this.selectElement),w=getComputedStyle(this.selectElement),S=parseFloat(w.getPropertyValue("--dropdown-padding-top"))+parseFloat(w.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-D.top-D.height-(this.selectBoxOptions.minBottomMargin||0),b=D.top-n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,L=this.selectElement.offsetWidth,N=this.setWidthControlElement(this.widthControlElement),y=Math.max(N,Math.round(L)).toString()+"px";this.selectDropDownContainer.style.width=y,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let d=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const m=this._hasDetails?this._cachedMaxDetailsHeight:0,p=d+S+m,M=Math.floor((f-S-m)/this.getHeight()),q=Math.floor((b-S-m)/this.getHeight());if(s)return D.top+D.height>window.innerHeight-22||D.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||M<1&&q<1?!1:(M<n.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&q>M&&this.options.length>M?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(D.top+D.height>window.innerHeight-22||D.top<n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&M<1||this._dropDownPosition===1&&q<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&M+q<1)return this.hideSelectDropDown(!0),!1;p>f&&(d=M*this.getHeight())}else p>b&&(d=q*this.getHeight());return this.selectList.layout(d),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=d+S+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=d+S+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=y,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(s){let D=0;if(s){let w=0,S=0;this.options.forEach((f,b)=>{const L=f.detail?f.detail.length:0,N=f.decoratorRight?f.decoratorRight.length:0,y=f.text.length+L+N;y>S&&(w=b,S=y)}),s.textContent=this.options[w].text+(this.options[w].decoratorRight?this.options[w].decoratorRight+" ":""),D=E.getTotalWidth(s)}return D}createSelectList(s){if(this.selectList)return;this.selectDropDownListContainer=E.append(s,a(".select-box-dropdown-list-container")),this.listRenderer=new o,this.selectList=new v.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let f=S.text;return S.detail&&(f+=`. ${S.detail}`),S.decoratorRight&&(f+=`. ${S.decoratorRight}`),S.description&&(f+=`. ${S.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const D=this._register(new k.DomEmitter(this.selectDropDownListContainer,"keydown")),w=c.Event.chain(D.event).filter(()=>this.selectList.length>0).map(S=>new i.StandardKeyboardEvent(S));this._register(w.filter(S=>S.keyCode===3).on(S=>this.onEnter(S),this)),this._register(w.filter(S=>S.keyCode===2).on(S=>this.onEnter(S),this)),this._register(w.filter(S=>S.keyCode===9).on(S=>this.onEscape(S),this)),this._register(w.filter(S=>S.keyCode===16).on(S=>this.onUpArrow(S),this)),this._register(w.filter(S=>S.keyCode===18).on(S=>this.onDownArrow(S),this)),this._register(w.filter(S=>S.keyCode===12).on(this.onPageDown,this)),this._register(w.filter(S=>S.keyCode===11).on(this.onPageUp,this)),this._register(w.filter(S=>S.keyCode===14).on(this.onHome,this)),this._register(w.filter(S=>S.keyCode===13).on(this.onEnd,this)),this._register(w.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=80&&S.keyCode<=108).on(this.onCharacter,this)),this._register(E.addDisposableListener(this.selectList.getHTMLElement(),E.EventType.POINTER_UP,S=>this.onPointerUp(S))),this._register(this.selectList.onMouseOver(S=>typeof S.index<"u"&&this.selectList.setFocus([S.index]))),this._register(this.selectList.onDidChangeFocus(S=>this.onListFocus(S))),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.FOCUS_OUT,S=>{!this._isVisible||E.isAncestor(S.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(s){if(!this.selectList.length)return;E.EventHelper.stop(s);const D=s.target;if(!D||D.classList.contains("slider"))return;const w=D.closest(".monaco-list-row");if(!w)return;const S=Number(w.getAttribute("data-index")),f=w.classList.contains("option-disabled");S>=0&&S<this.options.length&&!f&&(this.selected=S,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(s,D){const w=f=>{for(let b=0;b<f.childNodes.length;b++){const L=f.childNodes.item(b);(L.tagName&&L.tagName.toLowerCase())==="img"?f.removeChild(L):w(L)}},S=(0,z.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:D});return S.element.classList.add("select-box-description-markdown"),w(S.element),S.element}onListFocus(s){!this._isVisible||!this._hasDetails||this.updateDetail(s.indexes[0])}updateDetail(s){this.selectionDetailsPane.innerText="";const D=this.options[s],w=D?.description??"",S=D?.descriptionIsMarkdown??!1;if(w){if(S){const f=D.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(w,f))}else this.selectionDetailsPane.innerText=w;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(s){E.EventHelper.stop(s),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(s){E.EventHelper.stop(s),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(s){if(this.selected<this.options.length-1){E.EventHelper.stop(s,!0);const D=this.options[this.selected+1].isDisabled;if(D&&this.options.length>this.selected+2)this.selected+=2;else{if(D)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(s){this.selected>0&&(E.EventHelper.stop(s,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(s){E.EventHelper.stop(s),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(s){E.EventHelper.stop(s),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(s){E.EventHelper.stop(s),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(s){const D=l.KeyCodeUtils.toString(s.keyCode);let w=-1;for(let S=0;S<this.options.length-1;S++)if(w=(S+this.selected+1)%this.options.length,this.options[w].text.charAt(0).toUpperCase()===D&&!this.options[w].isDisabled){this.select(w),this.selectList.setFocus([w]),this.selectList.reveal(this.selectList.getFocus()[0]),E.EventHelper.stop(s);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}n.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,n.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,n.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3,t.SelectBoxList=n}),define(ge[125],me([1,0,36,124,118,19,5,91]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class _ extends z.Widget{constructor(l,h,P,r,a){super(),v.isMacintosh&&!a?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(l,h,r,a):this.selectBoxDelegate=new k.SelectBoxList(l,h,P,r,a),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(l,h){this.selectBoxDelegate.setOptions(l,h)}select(l){this.selectBoxDelegate.select(l)}setAriaLabel(l){this.selectBoxDelegate.setAriaLabel(l)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(l){this.selectBoxDelegate.setFocusable(l)}render(l){this.selectBoxDelegate.render(l)}}t.SelectBox=_}),define(ge[60],me([1,0,18,51,4,23,123,125,31,2,5,6,96,48]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class a extends l.Disposable{get action(){return this._action}constructor(u,s,D={}){super(),this.options=D,this._context=u||this,this._action=s,s instanceof c.Action&&this._register(s.onDidChange(w=>{!this.element||this.handleActionChangeEvent(w)}))}handleActionChangeEvent(u){u.enabled!==void 0&&this.updateEnabled(),u.checked!==void 0&&this.updateChecked(),u.class!==void 0&&this.updateClass(),u.label!==void 0&&(this.updateLabel(),this.updateTooltip()),u.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new c.ActionRunner)),this._actionRunner}set actionRunner(u){this._actionRunner=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const s=this.element=u;this._register(z.Gesture.addTarget(u));const D=this.options&&this.options.draggable;D&&(u.draggable=!0,E.isFirefox&&this._register((0,i.addDisposableListener)(u,i.EventType.DRAG_START,w=>w.dataTransfer?.setData(k.DataTransfers.TEXT,this._action.label)))),this._register((0,i.addDisposableListener)(s,z.EventType.Tap,w=>this.onClick(w,!0))),this._register((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,w=>{D||i.EventHelper.stop(w,!0),this._action.enabled&&w.button===0&&s.classList.add("active")})),h.isMacintosh&&this._register((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,w=>{w.button===0&&w.ctrlKey===!0&&this.onClick(w)})),this._register((0,i.addDisposableListener)(s,i.EventType.CLICK,w=>{i.EventHelper.stop(w,!0),this.options&&this.options.isMenu||this.onClick(w)})),this._register((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,w=>{i.EventHelper.stop(w,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(w=>{this._register((0,i.addDisposableListener)(s,w,S=>{i.EventHelper.stop(S),s.classList.remove("active")}))})}onClick(u,s=!1){i.EventHelper.stop(u,!0);const D=P.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?u:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,D)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const u=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(u):(this.customHover=(0,v.setupCustomHover)(this.options.hoverDelegate,this.element,u),this._store.add(this.customHover))):this.element.title=u}updateAriaLabel(){if(this.element){const u=this.getTooltip()??"";this.element.setAttribute("aria-label",u)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=a;class e extends a{constructor(u,s,D){super(u,s,D),this.options=D,this.options.icon=D.icon!==void 0?D.icon:!1,this.options.label=D.label!==void 0?D.label:!0,this.cssClass=""}render(u){super.render(u),this.element&&(this.label=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.label&&(this._action.id===c.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(u){this.label&&(this.label.tabIndex=u?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(u=this.action.label,this.options.keybinding&&(u=r.localize(0,null,u,this.options.keybinding))),u??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const u=this.getTooltip()??"";this.label.setAttribute("aria-label",u)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class o extends a{constructor(u,s,D,w,S,f,b){super(u,s),this.selectBox=new _.SelectBox(D,w,S,f,b),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(u,s){this.selectBox.setOptions(u,s)}select(u){this.selectBox.select(u)}registerListeners(){this._register(this.selectBox.onDidSelect(u=>this.runAction(u.selected,u.index)))}runAction(u,s){this.actionRunner.run(this._action,this.getActionContext(u,s))}getActionContext(u,s){return u}setFocusable(u){this.selectBox.setFocusable(u)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(u){this.selectBox.render(u)}}t.SelectActionViewItem=o}),define(ge[61],me([1,0,4,14,60,31,3,2,6,48]),function(ee,t,E,k,i,z,v,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var l;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(l=t.ActionsOrientation||(t.ActionsOrientation={}));class h extends _.Disposable{constructor(a,e={}){super(),this._actionRunnerDisposables=this._register(new _.DisposableStore),this.viewItemDisposables=this._register(new _.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new v.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new v.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new v.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new v.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new z.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(u=>this._onDidRun.fire(u))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(u=>this._onWillRun.fire(u))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let o,n;switch(this._orientation){case 0:o=[15],n=[17];break;case 1:o=[16],n=[18],this.domNode.className+=" vertical";break}this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,u=>{const s=new k.StandardKeyboardEvent(u);let D=!0;const w=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;o&&(s.equals(o[0])||s.equals(o[1]))?D=this.focusPrevious():n&&(s.equals(n[0])||s.equals(n[1]))?D=this.focusNext():s.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():s.equals(14)?D=this.focusFirst():s.equals(13)?D=this.focusLast():s.equals(2)&&w instanceof i.BaseActionViewItem&&w.trapsArrowNavigation?D=this.focusNext():this.isTriggerKeyEvent(s)?this._triggerKeys.keyDown?this.doTrigger(s):this.triggerKeyDown=!0:D=!1,D&&(s.preventDefault(),s.stopPropagation())})),this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,u=>{const s=new k.StandardKeyboardEvent(u);this.isTriggerKeyEvent(s)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(E.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),a.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(a){a?this.actionsList.setAttribute("aria-label",a):this.actionsList.removeAttribute("aria-label")}setFocusable(a){if(this.focusable=a,this.focusable){const e=this.viewItems.find(o=>o instanceof i.BaseActionViewItem&&o.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(a){let e=!1;return this._triggerKeys.keys.forEach(o=>{e=e||a.equals(o)}),e}updateFocusedItem(){for(let a=0;a<this.actionsList.children.length;a++){const e=this.actionsList.children[a];if(E.isAncestor(E.getActiveElement(),e)){this.focusedItem=a;break}}}get context(){return this._context}set context(a){this._context=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this._actionRunner}set actionRunner(a){this._actionRunner=a,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.actionsList;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const o=Array.isArray(a)?a:[a];let n=c.isNumber(e.index)?e.index:null;o.forEach(u=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let D;const w={hoverDelegate:this.options.hoverDelegate,...e};this.options.actionViewItemProvider&&(D=this.options.actionViewItemProvider(u,w)),D||(D=new i.ActionViewItem(this.context,u,w)),this.options.allowContextMenu||this.viewItemDisposables.set(D,E.addDisposableListener(s,E.EventType.CONTEXT_MENU,S=>{E.EventHelper.stop(S,!0)})),D.actionRunner=this._actionRunner,D.setActionContext(this.context),D.render(s),this.focusable&&D instanceof i.BaseActionViewItem&&this.viewItems.length===0&&D.setFocusable(!0),n===null||n<0||n>=this.actionsList.children.length?(this.actionsList.appendChild(s),this.viewItems.push(D)):(this.actionsList.insertBefore(s,this.actionsList.children[n]),this.viewItems.splice(n,0,D),n++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(a){if(a>=0&&a<this.actionsList.children.length){const e=this.actionsList.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.actionsList.children.length){const e=this.actionsList.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[a]),this.viewItemDisposables.deleteAndDispose(this.viewItems[a]),(0,_.dispose)(this.viewItems.splice(a,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,_.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),E.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,o;if(a===void 0?e=!0:typeof a=="number"?o=a:typeof a=="boolean"&&(e=a),e&&typeof this.focusedItem>"u"){const n=this.viewItems.findIndex(u=>u.isEnabled());this.focusedItem=n===-1?void 0:n,this.updateFocus(void 0,void 0,!0)}else o!==void 0&&(this.focusedItem=o),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(a){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let o;do{if(!a&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,o=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===z.Separator.ID));return this.updateFocus(),!0}focusPrevious(a){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let o;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!a&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}o=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===z.Separator.ID));return this.updateFocus(!0),!0}updateFocus(a,e,o=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const n=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(n){let u=!0;c.isFunction(n.focus)||(u=!1),this.options.focusOnlyEnabledItems&&c.isFunction(n.isEnabled)&&!n.isEnabled()&&(u=!1),n.action.id===z.Separator.ID&&(u=!1),u?(o||this.previouslyFocusedItem!==this.focusedItem)&&(n.focus(a),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(a){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof i.BaseActionViewItem){const o=e._context===null||e._context===void 0?a:e._context;this.run(e._action,o)}}async run(a,e){await this._actionRunner.run(a,e)}dispose(){this._context=void 0,this.viewItems=(0,_.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=h;function P(r){if(!r.length)return r;let a=-1;for(let o=0;o<r.length;o++)if(r[o].id!==z.Separator.ID){a=o;break}if(a===-1)return[];r=r.slice(a);for(let o=r.length-1;o>=0&&r[o].id===z.Separator.ID;o--)r.splice(o,1);let e=!1;for(let o=r.length-1;o>=0;o--){const n=r[o].id===z.Separator.ID;n&&!e?r.splice(o,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=P}),define(ge[62],me([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const a=E.$;var e;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(e=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class o extends c.Widget{constructor(s,D,w){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new l.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=w,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=E.append(s,a(".monaco-inputbox.idle"));const S=this.options.flexibleHeight?"textarea":"input",f=E.append(this.element,a(".ibwrapper"));if(this.input=E.append(f,a(S+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=E.append(f,a("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new _.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),E.append(s,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(N=>this.input.scrollTop=N.scrollTop));const b=this._register(new k.DomEmitter(document,"selectionchange")),L=l.Event.filter(b.event,()=>document.getSelection()?.anchorNode===f);this._register(L(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new z.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(s){this.placeholder=s,this.input.setAttribute("placeholder",s)}setTooltip(s){this.tooltip=s,this.input.title=s}setAriaLabel(s){this.ariaLabel=s,s?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(s){this.input.value!==s&&(this.input.value=s,this.onValueChange())}get step(){return this.input.step}set step(s){this.input.step=s}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:E.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(s=null){this.input.select(),s&&(this.input.setSelectionRange(s.start,s.end),s.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.input)}set width(s){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const w=parseFloat(this.mirror.style.paddingLeft||"")||0,S=parseFloat(this.mirror.style.paddingRight||"")||0;D=w+S}this.input.style.width=s-D+"px"}else this.input.style.width=s+"px";this.mirror&&(this.mirror.style.width=s+"px")}set paddingRight(s){this.input.style.width=`calc(100% - ${s}px)`,this.mirror&&(this.mirror.style.paddingRight=s+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const s=this.cachedContentHeight,D=this.cachedHeight,w=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:s,height:D}),this.scrollableElement.setScrollPosition({scrollTop:w})}showMessage(s,D){if(this.state==="open"&&(0,P.equals)(this.message,s))return;this.message=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(s.type));const w=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(w.border,"transparent")}`,this.message.content&&(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let s=null;return this.validation&&(s=this.validation(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const D=this.options.inputBoxStyles;switch(s){case 1:return{border:D.inputValidationInfoBorder,background:D.inputValidationInfoBackground,foreground:D.inputValidationInfoForeground};case 2:return{border:D.inputValidationWarningBorder,background:D.inputValidationWarningBackground,foreground:D.inputValidationWarningForeground};default:return{border:D.inputValidationErrorBorder,background:D.inputValidationErrorBackground,foreground:D.inputValidationErrorForeground}}}classForType(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let s;const D=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.message)return null;s=E.append(S,a(".monaco-inputbox-container")),D();const f={inline:!0,className:"monaco-inputbox-message"},b=this.message.formatContent?(0,i.renderFormattedText)(this.message.content,f):(0,i.renderText)(this.message.content,f);b.classList.add(this.classForType(this.message.type));const L=this.stylesForType(this.message.type);return b.style.backgroundColor=L.background??"",b.style.color=L.foreground??"",b.style.border=L.border?`1px solid ${L.border}`:"",E.append(s,b),null},onHide:()=>{this.state="closed"},layout:D});let w;this.message.type===3?w=r.localize(0,null,this.message.content):this.message.type===2?w=r.localize(1,null,this.message.content):w=r.localize(2,null,this.message.content),v.alert(w),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const s=this.value,w=s.charCodeAt(s.length-1)===10?" ":"";(s+w).replace(/\u000c/g,"")?this.mirror.textContent=s+w:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const s=this.options.inputBoxStyles,D=s.inputBackground??"",w=s.inputForeground??"",S=s.inputBorder??"";this.element.style.backgroundColor=D,this.element.style.color=w,this.input.style.backgroundColor="inherit",this.input.style.color=w,this.element.style.border=`1px solid ${E.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.mirror)return;const s=this.cachedContentHeight;this.cachedContentHeight=E.getTotalHeight(this.mirror),s!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(s){const D=this.inputElement,w=D.selectionStart,S=D.selectionEnd,f=D.value;w!==null&&S!==null&&(this.value=f.substr(0,w)+s+f.substr(S),D.setSelectionRange(w+1,w+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=o;class n extends o{constructor(s,D,w){const S=r.localize(3,null),f=` or \u21C5 ${S}`,b=` (\u21C5 ${S})`;super(s,D,w),this._onDidFocus=this._register(new l.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new l.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new h.HistoryNavigator(w.history,100);const L=()=>{if(w.showHistoryHint&&w.showHistoryHint()&&!this.placeholder.endsWith(f)&&!this.placeholder.endsWith(b)&&this.history.getHistory().length){const N=this.placeholder.endsWith(")")?f:b,y=this.placeholder+N;w.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=y:this.setPlaceHolder(y)}};this.observer=new MutationObserver((N,y)=>{N.forEach(d=>{d.target.textContent||L()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>L()),this.onblur(this.input,()=>{const N=y=>{if(this.placeholder.endsWith(y)){const d=this.placeholder.slice(0,this.placeholder.length-y.length);return w.showPlaceholderOnFocus?this.placeholder=d:this.setPlaceHolder(d),!0}else return!1};N(b)||N(f)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(s){this.value&&(s||this.value!==this.getCurrentValue())&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let s=this.getNextValue();s&&(s=s===this.value?this.getNextValue():s),s&&(this.value=s,v.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let s=this.getPreviousValue();s&&(s=s===this.value?this.getPreviousValue():s),s&&(this.value=s,v.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let s=this.history.current();return s||(s=this.history.last(),this.history.next()),s}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=n}),define(ge[63],me([1,0,60,19,16,17,3,93]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class _ extends E.BaseActionViewItem{constructor(P,r,a){super(P,r,a),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(P){this.element=P,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(P){this.toggle.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=_;class c extends k.Widget{constructor(P){super(),this._onChange=this._register(new v.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new v.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=P,this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...z.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,a=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),a.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),a.preventDefault(),a.stopPropagation();return}this._onKeyDown.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(P){this._checked=P,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(P){this._icon&&this.domNode.classList.remove(...z.ThemeIcon.asClassNameArray(this._icon)),this._icon=P,this._icon&&this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=c;class l extends k.Widget{constructor(P,r,a){super(),this.title=P,this.isChecked=r,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.checkbox.domNode,this.styles=a,this.applyStyles(),this._register(this.checkbox.onChange(()=>this.applyStyles()))}get checked(){return this.checkbox.checked}set checked(P){this.checkbox.checked=P,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=l}),define(ge[126],me([1,0,63,16,98]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const z=i.localize(0,null),v=i.localize(1,null),_=i.localize(2,null);class c extends E.Toggle{constructor(r){super({icon:k.Codicon.caseSensitive,title:z+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=c;class l extends E.Toggle{constructor(r){super({icon:k.Codicon.wholeWord,title:v+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=l;class h extends E.Toggle{constructor(r){super({icon:k.Codicon.regex,title:_+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=h}),define(ge[127],me([1,0,4,126,62,19,3,97,2,87]),function(ee,t,E,k,i,z,v,_,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const l=_.localize(0,null);class h extends z.Widget{constructor(r,a,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new c.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new v.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new v.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new v.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new v.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new v.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new v.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new v.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||l,this.showCommonFindToggles=!!e.showCommonFindToggles;const o=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",u=e.appendRegexLabel||"",s=e.history||[],D=!!e.flexibleHeight,w=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new i.HistoryInputBox(this.domNode,a,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:D,flexibleWidth:w,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.showCommonFindToggles){this.regex=this._register(new k.RegexToggle({appendTitle:u,isChecked:!1,...e.toggleStyles})),this._register(this.regex.onChange(b=>{this._onDidOptionChange.fire(b),!b&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(b=>{this._onRegexKeyDown.fire(b)})),this.wholeWords=this._register(new k.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this._register(this.wholeWords.onChange(b=>{this._onDidOptionChange.fire(b),!b&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new k.CaseSensitiveToggle({appendTitle:o,isChecked:!1,...e.toggleStyles})),this._register(this.caseSensitive.onChange(b=>{this._onDidOptionChange.fire(b),!b&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(b=>{this._onCaseSensitiveKeyDown.fire(b)}));const f=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,b=>{if(b.equals(15)||b.equals(17)||b.equals(9)){const L=f.indexOf(document.activeElement);if(L>=0){let N=-1;b.equals(17)?N=(L+1)%f.length:b.equals(15)&&(L===0?N=f.length-1:N=L-1),b.equals(9)?(f[L].blur(),this.inputBox.focus()):N>=0&&f[N].focus(),E.EventHelper.stop(b,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(e?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),r?.appendChild(this.domNode),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.imeSessionInProgress=!0})),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,f=>this._onKeyDown.fire(f)),this.onkeyup(this.inputBox.inputElement,f=>this._onKeyUp.fire(f)),this.oninput(this.inputBox.inputElement,f=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,f=>this._onMouseDown.fire(f))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.updateInputBoxPadding(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const r of this.additionalToggles)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const r of this.additionalToggles)r.disable()}setFocusInputOnOptionClick(r){this.fixFocusOnOptionClickEnabled=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const a of this.additionalToggles)a.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new c.DisposableStore;for(const a of r??[])this.additionalTogglesDisposables.add(a),this.controls.appendChild(a.domNode),this.additionalTogglesDisposables.add(a.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(a);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((a,e)=>a+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(r){this.caseSensitive&&(this.caseSensitive.checked=r)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(r){this.wholeWords&&(this.wholeWords.checked=r)}getRegex(){return this.regex?.checked??!1}setRegex(r){this.regex&&(this.regex.checked=r,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}h.OPTION_CHANGE="optionChange",t.FindInput=h}),define(ge[128],me([1,0,4,20,14,61,127,62,58,36,63,55,24,31,13,9,16,17,69,3,32,2,44,6,102,94]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e,o,n,u,s,D,w,S,f,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends c.ElementsDragAndDropData{set context(g){this.data.context=g}get context(){return this.data.context}constructor(g){super(g.elements.map(C=>C.element)),this.data=g}}function y(R){return R instanceof c.ElementsDragAndDropData?new N(R):R}class d{constructor(g,C){this.modelProvider=g,this.dnd=C,this.autoExpandDisposable=S.Disposable.None}getDragURI(g){return this.dnd.getDragURI(g.element)}getDragLabel(g,C){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(g.map(W=>W.element),C)}onDragStart(g,C){this.dnd.onDragStart?.(y(g),C)}onDragOver(g,C,W,Y,A=!0){const I=this.dnd.onDragOver(y(g),C&&C.element,W,Y),O=this.autoExpandNode!==C;if(O&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=C),typeof C>"u")return I;if(O&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,o.disposableTimeout)(()=>{const V=this.modelProvider(),G=V.getNodeLocation(C);V.isCollapsed(G)&&V.setCollapsed(G,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble>"u"||I.feedback){if(!A){const V=typeof I=="boolean"?I:I.accept,G=typeof I=="boolean"?void 0:I.effect;return{accept:V,effect:G,feedback:[W]}}return I}if(I.bubble===1){const V=this.modelProvider(),G=V.getNodeLocation(C),re=V.getParentNodeLocation(G),ce=V.getNode(re),we=re&&V.getListIndex(re);return this.onDragOver(g,ce,we,Y,!1)}const T=this.modelProvider(),x=T.getNodeLocation(C),B=T.getListIndex(x),H=T.getListRenderCount(x);return{...I,feedback:(0,e.range)(B,B+H)}}drop(g,C,W,Y){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(y(g),C&&C.element,W,Y)}onDragEnd(g){this.dnd.onDragEnd?.(g)}}function m(R,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(C){return g.identityProvider.getId(C.element)}},dnd:g.dnd&&new d(R,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(C){return g.multipleSelectionController.isSelectionSingleChangeEvent({...C,element:C.element})},isSelectionRangeChangeEvent(C){return g.multipleSelectionController.isSelectionRangeChangeEvent({...C,element:C.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(C){const W=R(),Y=W.getNodeLocation(C),A=W.getParentNodeLocation(Y);return W.getNode(A).visibleChildrenCount},getPosInSet(C){return C.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?C=>g.accessibilityProvider.isChecked(C.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?C=>g.accessibilityProvider.getRole(C.element):()=>"treeitem",getAriaLabel(C){return g.accessibilityProvider.getAriaLabel(C.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?C=>g.accessibilityProvider.getAriaLevel(C.element):C=>C.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(C=>g.accessibilityProvider.getActiveDescendantId(C.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(C){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(C.element)}}}}class p{constructor(g){this.delegate=g}getHeight(g){return this.delegate.getHeight(g.element)}getTemplateId(g){return this.delegate.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(g.element)}setDynamicHeight(g,C){this.delegate.setDynamicHeight?.(g.element,C)}}t.ComposedTreeDelegate=p;class M{static lift(g){return g instanceof M?g:new M(g)}static empty(g=0){return new M({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const C of g.expanded)this.expanded[C]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=M;var q;(function(R){R.None="none",R.OnHover="onHover",R.Always="always"})(q=t.RenderIndentGuides||(t.RenderIndentGuides={}));class Z{get elements(){return this._elements}constructor(g,C=[]){this._elements=C,this.disposables=new S.DisposableStore,this.onDidChange=D.Event.forEach(g,W=>this._elements=W,this.disposables)}dispose(){this.disposables.dispose()}}class se{constructor(g,C,W,Y,A,I={}){this.renderer=g,this.modelProvider=C,this.activeNodes=Y,this.renderedIndentGuides=A,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=se.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.templateId=g.templateId,this.updateOptions(I),D.Event.map(W,O=>O.node)(this.onDidChangeNodeTwistieState,this,this.disposables),g.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(g={}){if(typeof g.indent<"u"){const C=(0,f.clamp)(g.indent,0,40);if(C!==this.indent){this.indent=C;for(const[W,Y]of this.renderedNodes)this.renderTreeElement(W,Y)}}if(typeof g.renderIndentGuides<"u"){const C=g.renderIndentGuides!==q.None;if(C!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=C;for(const[W,Y]of this.renderedNodes)this._renderIndentGuides(W,Y);if(this.indentGuidesDisposable.dispose(),C){const W=new S.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,W),this.indentGuidesDisposable=W,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const C=(0,E.append)(g,(0,E.$)(".monaco-tl-row")),W=(0,E.append)(C,(0,E.$)(".monaco-tl-indent")),Y=(0,E.append)(C,(0,E.$)(".monaco-tl-twistie")),A=(0,E.append)(C,(0,E.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(A);return{container:g,indent:W,twistie:Y,indentGuidesDisposable:S.Disposable.None,templateData:I}}renderElement(g,C,W,Y){this.renderedNodes.set(g,W),this.renderedElements.set(g.element,g),this.renderTreeElement(g,W),this.renderer.renderElement(g,C,W.templateData,Y)}disposeElement(g,C,W,Y){W.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(g,C,W.templateData,Y),typeof Y=="number"&&(this.renderedNodes.delete(g),this.renderedElements.delete(g.element))}disposeTemplate(g){this.renderer.disposeTemplate(g.templateData)}onDidChangeTwistieState(g){const C=this.renderedElements.get(g);!C||this.onDidChangeNodeTwistieState(C)}onDidChangeNodeTwistieState(g){const C=this.renderedNodes.get(g);!C||(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(g,C))}renderTreeElement(g,C){const W=se.DefaultIndent+(g.depth-1)*this.indent;C.twistie.style.paddingLeft=`${W}px`,C.indent.style.width=`${W+this.indent-16}px`,g.collapsible?C.container.setAttribute("aria-expanded",String(!g.collapsed)):C.container.removeAttribute("aria-expanded"),C.twistie.classList.remove(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Y=!1;this.renderer.renderTwistie&&(Y=this.renderer.renderTwistie(g.element,C.twistie)),g.collapsible&&(!this.hideTwistiesOfChildlessElements||g.visibleChildrenCount>0)?(Y||C.twistie.classList.add(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),C.twistie.classList.add("collapsible"),C.twistie.classList.toggle("collapsed",g.collapsed)):C.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(g,C)}_renderIndentGuides(g,C){if((0,E.clearNode)(C.indent),C.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const W=new S.DisposableStore,Y=this.modelProvider();for(;;){const A=Y.getNodeLocation(g),I=Y.getParentNodeLocation(A);if(!I)break;const O=Y.getNode(I),T=(0,E.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(O)&&T.classList.add("active"),C.indent.childElementCount===0?C.indent.appendChild(T):C.indent.insertBefore(T,C.indent.firstElementChild),this.renderedIndentGuides.add(O,T),W.add((0,S.toDisposable)(()=>this.renderedIndentGuides.delete(O,T))),g=O}C.indentGuidesDisposable=W}_onDidChangeActiveNodes(g){if(!this.shouldRenderIndentGuides)return;const C=new Set,W=this.modelProvider();g.forEach(Y=>{const A=W.getNodeLocation(Y);try{const I=W.getParentNodeLocation(A);Y.collapsible&&Y.children.length>0&&!Y.collapsed?C.add(Y):I&&C.add(W.getNode(I))}catch{}}),this.activeIndentNodes.forEach(Y=>{C.has(Y)||this.renderedIndentGuides.forEach(Y,A=>A.classList.remove("active"))}),C.forEach(Y=>{this.activeIndentNodes.has(Y)||this.renderedIndentGuides.forEach(Y,A=>A.classList.add("active"))}),this.activeIndentNodes=C}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,S.dispose)(this.disposables)}}se.DefaultIndent=8;class le{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(g){this._pattern=g,this._lowercasePattern=g.toLowerCase()}constructor(g,C,W){this.tree=g,this.keyboardNavigationLabelProvider=C,this._filter=W,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new S.DisposableStore,g.onWillRefilter(this.reset,this,this.disposables)}filter(g,C){let W=1;if(this._filter){const I=this._filter.filter(g,C);if(typeof I=="boolean"?W=I?1:0:(0,P.isFilterResult)(I)?W=(0,P.getVisibleState)(I.visibility):W=I,W===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:w.FuzzyScore.Default,visibility:W};const Y=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(g),A=Array.isArray(Y)?Y:[Y];for(const I of A){const O=I&&I.toString();if(typeof O>"u")return{data:w.FuzzyScore.Default,visibility:W};let T;if(this.tree.findMatchType===ve.Contiguous){const x=O.toLowerCase().indexOf(this._lowercasePattern);if(x>-1){T=[Number.MAX_SAFE_INTEGER,0];for(let B=this._lowercasePattern.length;B>0;B--)T.push(x+B-1)}}else T=(0,w.fuzzyScore)(this._pattern,this._lowercasePattern,0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(T)return this._matchCount++,A.length===1?{data:T,visibility:W}:{data:{label:O,score:T},visibility:W}}return this.tree.findMode===J.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(g):2:{data:w.FuzzyScore.Default,visibility:W}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,S.dispose)(this.disposables)}}class fe extends h.Toggle{constructor(g){super({icon:n.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.ModeToggle=fe;class ue extends h.Toggle{constructor(g){super({icon:n.Codicon.searchFuzzy,title:(0,L.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const Q={inputBoxStyles:_.unthemedInboxStyles,toggleStyles:h.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var J;(function(R){R[R.Highlight=0]="Highlight",R[R.Filter=1]="Filter"})(J=t.TreeFindMode||(t.TreeFindMode={}));var ve;(function(R){R[R.Fuzzy=0]="Fuzzy",R[R.Contiguous=1]="Contiguous"})(ve=t.TreeFindMatchType||(t.TreeFindMatchType={}));class be extends S.Disposable{set mode(g){this.modeToggle.checked=g===J.Filter,this.findInput.inputBox.setPlaceHolder(g===J.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(g){this.matchTypeToggle.checked=g===ve.Fuzzy}get value(){return this.findInput.inputBox.value}set value(g){this.findInput.inputBox.value=g}constructor(g,C,W,Y,A,I){super(),this.tree=C,this.elements=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.elements.root),this._register((0,S.toDisposable)(()=>g.removeChild(this.elements.root)));const O=I?.styles??Q;O.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=O.listFilterWidgetBackground),O.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${O.listFilterWidgetShadow}`),this.modeToggle=this._register(new fe({...O.toggleStyles,isChecked:Y===J.Filter})),this.matchTypeToggle=this._register(new ue({...O.toggleStyles,isChecked:A===ve.Fuzzy})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?J.Filter:J.Highlight,this._store),this.onDidChangeMatchType=D.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?ve.Fuzzy:ve.Contiguous,this._store),this.findInput=this._register(new v.FindInput(this.elements.findInput,W,{label:(0,L.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:O.inputBoxStyles,toggleStyles:O.toggleStyles,history:I?.history})),this.actionbar=this._register(new z.ActionBar(this.elements.actionbar)),this.mode=Y;const T=this._register(new k.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),x=this._register(D.Event.chain(T.event)).map(G=>new i.StandardKeyboardEvent(G)).event;this._register(x(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const B=this._register(new a.Action("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(B,{icon:!0,label:!1});const H=this._register(new k.DomEmitter(this.elements.grab,"mousedown"));this._register(H.event(G=>{const re=new S.DisposableStore,ce=re.add(new k.DomEmitter(window,"mousemove")),we=re.add(new k.DomEmitter(window,"mouseup")),ye=this.right,Le=G.pageX,Ce=this.top,De=G.pageY;this.elements.grab.classList.add("grabbing");const Pe=this.elements.root.style.transition;this.elements.root.style.transition="unset";const Ne=Ke=>{const xe=Ke.pageX-Le;this.right=ye-xe;const He=Ke.pageY-De;this.top=Ce+He,this.layout()};re.add(ce.event(Ne)),re.add(we.event(Ke=>{Ne(Ke),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Pe,re.dispose()}))}));const V=this._register(D.Event.chain(this._register(new k.DomEmitter(this.elements.grab,"keydown")).event)).map(G=>new i.StandardKeyboardEvent(G)).event;this._register(V(G=>{let re,ce;if(G.keyCode===15?re=Number.POSITIVE_INFINITY:G.keyCode===17?re=0:G.keyCode===10&&(re=this.right===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?ce=0:G.keyCode===18&&(ce=Number.POSITIVE_INFINITY),re!==void 0&&(G.preventDefault(),G.stopPropagation(),this.right=re,this.layout()),ce!==void 0){G.preventDefault(),G.stopPropagation(),this.top=ce;const we=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=we},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(g=this.width){this.width=g,this.right=(0,f.clamp)(this.right,0,Math.max(0,g-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,f.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(g){this.findInput.showMessage(g)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,o.timeout)(300),super.dispose()}}class ke{get pattern(){return this._pattern}get mode(){return this._mode}set mode(g){g!==this._mode&&(this._mode=g,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(g))}get matchType(){return this._matchType}set matchType(g){g!==this._matchType&&(this._matchType=g,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(g))}constructor(g,C,W,Y,A,I={}){this.tree=g,this.view=W,this.filter=Y,this.contextViewProvider=A,this.options=I,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new D.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new S.DisposableStore,this.disposables=new S.DisposableStore,this._mode=g.options.defaultFindMode??J.Highlight,this._matchType=g.options.defaultFindMatchType??ve.Fuzzy,C.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new be(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(g=>this.mode=g,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(g=>this.matchType=g,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new S.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(g){this._pattern=g,this._onDidChangePattern.fire(g),this.filter.pattern=g,this.tree.refilter(),g&&this.tree.focusNext(0,!0,void 0,W=>!w.FuzzyScore.isDefault(W.filterData));const C=this.tree.getFocus();if(C.length>0){const W=C[0];this.tree.getRelativeTop(W)===null&&this.tree.reveal(W,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const g=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&g?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(g){return!this.widget||!this.pattern||this._mode===J.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!w.FuzzyScore.isDefault(g.filterData)}layout(g){this.width=g,this.widget?.layout(g)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function Re(R){let g=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=r.TreeMouseEventTarget.Filter),{browserEvent:R.browserEvent,element:R.element?R.element.element:null,target:g}}function ae(R){return{element:R.element?R.element.element:null,browserEvent:R.browserEvent,anchor:R.anchor}}function U(R,g){g(R),R.children.forEach(C=>U(C,g))}class ne{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(g,C){this.getFirstViewElementWithTrait=g,this.identityProvider=C,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}set(g,C){!C?.__forceEvent&&(0,e.equals)(this.nodes,g)||this._set(g,!1,C)}_set(g,C,W){if(this.nodes=[...g],this.elements=void 0,this._nodeSet=void 0,!C){const Y=this;this._onDidChange.fire({get elements(){return Y.get()},browserEvent:W})}}get(){return this.elements||(this.elements=this.nodes.map(g=>g.element)),[...this.elements]}getNodes(){return this.nodes}has(g){return this.nodeSet.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:C}){if(!this.identityProvider){const T=this.createNodeSet(),x=B=>T.delete(B);C.forEach(B=>U(B,x)),this.set([...T.values()]);return}const W=new Set,Y=T=>W.add(this.identityProvider.getId(T.element).toString());C.forEach(T=>U(T,Y));const A=new Map,I=T=>A.set(this.identityProvider.getId(T.element).toString(),T);g.forEach(T=>U(T,I));const O=[];for(const T of this.nodes){const x=this.identityProvider.getId(T.element).toString();if(!W.has(x))O.push(T);else{const H=A.get(x);H&&O.push(H)}}if(this.nodes.length>0&&O.length===0){const T=this.getFirstViewElementWithTrait();T&&O.push(T)}this._set(O,!0)}createNodeSet(){const g=new Set;for(const C of this.nodes)g.add(C);return g}}class te extends l.MouseController{constructor(g,C){super(g),this.tree=C}onViewPointer(g){if((0,l.isButton)(g.browserEvent.target)||(0,l.isInputElement)(g.browserEvent.target)||(0,l.isMonacoEditor)(g.browserEvent.target))return;const C=g.element;if(!C)return super.onViewPointer(g);if(this.isSelectionRangeChangeEvent(g)||this.isSelectionSingleChangeEvent(g))return super.onViewPointer(g);const W=g.browserEvent.target,Y=W.classList.contains("monaco-tl-twistie")||W.classList.contains("monaco-icon-label")&&W.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let A=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?A=this.tree.expandOnlyOnTwistieClick(C.element):A=!!this.tree.expandOnlyOnTwistieClick,A&&!Y&&g.browserEvent.detail!==2)return super.onViewPointer(g);if(!this.tree.expandOnDoubleClick&&g.browserEvent.detail===2)return super.onViewPointer(g);if(C.collapsible){const I=this.tree.getNodeLocation(C),O=g.browserEvent.altKey;if(this.tree.setFocus([I]),this.tree.toggleCollapsed(I,O),A&&Y)return}super.onViewPointer(g)}onDoubleClick(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(g)}}class ie extends l.List{constructor(g,C,W,Y,A,I,O,T){super(g,C,W,Y,T),this.focusTrait=A,this.selectionTrait=I,this.anchorTrait=O}createMouseController(g){return new te(this,g.tree)}splice(g,C,W=[]){if(super.splice(g,C,W),W.length===0)return;const Y=[],A=[];let I;W.forEach((O,T)=>{this.focusTrait.has(O)&&Y.push(g+T),this.selectionTrait.has(O)&&A.push(g+T),this.anchorTrait.has(O)&&(I=g+T)}),Y.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Y])),A.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...A])),typeof I=="number"&&super.setAnchor(I)}setFocus(g,C,W=!1){super.setFocus(g,C),W||this.focusTrait.set(g.map(Y=>this.element(Y)),C)}setSelection(g,C,W=!1){super.setSelection(g,C),W||this.selectionTrait.set(g.map(Y=>this.element(Y)),C)}setAnchor(g,C=!1){super.setAnchor(g),C||(typeof g>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(g)]))}}class F{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,Re)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,Re),g=>g.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return D.Event.map(this.view.onContextMenu,ae)}get onTap(){return D.Event.map(this.view.onTap,Re)}get onPointer(){return D.Event.map(this.view.onPointer,Re)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??J.Highlight}set findMode(g){this.findController&&(this.findController.mode=g)}get findMatchType(){return this.findController?.matchType??ve.Fuzzy}set findMatchType(g){this.findController&&(this.findController.matchType=g)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(g,C,W,Y,A={}){this._user=g,this._options=A,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.disposables=new S.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new p(W),O=new D.Relay,T=new D.Relay,x=this.disposables.add(new Z(T.event)),B=new s.SetMap;this.renderers=Y.map(G=>new se(G,()=>this.model,O.event,x,B,A));for(const G of this.renderers)this.disposables.add(G);let H;A.keyboardNavigationLabelProvider&&(H=new le(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:H},this.disposables.add(H)),this.focus=new ne(()=>this.view.getFocusedElements()[0],A.identityProvider),this.selection=new ne(()=>this.view.getSelectedElements()[0],A.identityProvider),this.anchor=new ne(()=>this.view.getAnchorElement(),A.identityProvider),this.view=new ie(g,C,I,this.renderers,this.focus,this.selection,this.anchor,{...m(()=>this.model,A),tree:this}),this.model=this.createModel(g,this.view,A),O.input=this.model.onDidChangeCollapseState;const V=D.Event.forEach(this.model.onDidSplice,G=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(G),this.selection.onDidModelSplice(G)})},this.disposables);if(V(()=>null,null,this.disposables),T.input=D.Event.chain(D.Event.any(V,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const G=new Set;for(const re of this.focus.getNodes())G.add(re);for(const re of this.selection.getNodes())G.add(re);return[...G.values()]}).event,A.keyboardSupport!==!1){const G=D.Event.chain(this.view.onKeyDown).filter(re=>!(0,l.isInputElement)(re.target)).map(re=>new i.StandardKeyboardEvent(re));G.filter(re=>re.keyCode===15).on(this.onLeftArrow,this,this.disposables),G.filter(re=>re.keyCode===17).on(this.onRightArrow,this,this.disposables),G.filter(re=>re.keyCode===10).on(this.onSpace,this,this.disposables)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const G=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new ke(this,this.model,this.view,H,A.contextViewProvider,G),this.focusNavigationFilter=re=>this.findController.shouldAllowFocus(re),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;this.styleElement=(0,E.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===q.Always)}updateOptions(g={}){this._options={...this._options,...g};for(const C of this.renderers)C.updateOptions(g);this.view.updateOptions(this._options),this.findController?.updateOptions(g),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===q.Always)}get options(){return this._options}updateWidth(g){const C=this.model.getListIndex(g);C!==-1&&this.view.updateWidth(C)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(g){this.view.scrollTop=g}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(g){this.view.scrollLeft=g}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const g=this.view.firstVisibleIndex;return g<0||g>=this.view.length?void 0:this.view.element(g).element}get lastVisibleElement(){const g=this.view.lastVisibleIndex;return this.view.element(g).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(g){this.view.ariaLabel=g}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,C){this.view.layout(g,C),(0,b.isNumber)(C)&&this.findController?.layout(C)}style(g){const C=`.${this.view.domId}`,W=[];g.treeIndentGuidesStroke&&(W.push(`.monaco-list${C}:hover .monaco-tl-indent > .indent-guide, .monaco-list${C}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),W.push(`.monaco-list${C} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=W.join(`
`),this.view.style(g)}getParentElement(g){const C=this.model.getParentNodeLocation(g);return this.model.getNode(C).element}getFirstElementChild(g){return this.model.getFirstElementChild(g)}getNode(g){return this.model.getNode(g)}getNodeLocation(g){return this.model.getNodeLocation(g)}collapse(g,C=!1){return this.model.setCollapsed(g,!0,C)}expand(g,C=!1){return this.model.setCollapsed(g,!1,C)}toggleCollapsed(g,C=!1){return this.model.setCollapsed(g,void 0,C)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(g){return this.model.isCollapsible(g)}setCollapsible(g,C){return this.model.setCollapsible(g,C)}isCollapsed(g){return this.model.isCollapsed(g)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(g){if(typeof g>"u")return this.view.setAnchor(void 0);const C=this.model.getNode(g);this.anchor.set([C]);const W=this.model.getListIndex(g);W>-1&&this.view.setAnchor(W,!0)}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(g,C){const W=g.map(A=>this.model.getNode(A));this.selection.set(W,C);const Y=g.map(A=>this.model.getListIndex(A)).filter(A=>A>-1);this.view.setSelection(Y,C,!0)}getSelection(){return this.selection.get()}setFocus(g,C){const W=g.map(A=>this.model.getNode(A));this.focus.set(W,C);const Y=g.map(A=>this.model.getListIndex(A)).filter(A=>A>-1);this.view.setFocus(Y,C,!0)}focusNext(g=1,C=!1,W,Y=this.focusNavigationFilter){this.view.focusNext(g,C,W,Y)}focusPrevious(g=1,C=!1,W,Y=this.focusNavigationFilter){this.view.focusPrevious(g,C,W,Y)}focusNextPage(g,C=this.focusNavigationFilter){return this.view.focusNextPage(g,C)}focusPreviousPage(g,C=this.focusNavigationFilter){return this.view.focusPreviousPage(g,C)}focusLast(g,C=this.focusNavigationFilter){this.view.focusLast(g,C)}focusFirst(g,C=this.focusNavigationFilter){this.view.focusFirst(g,C)}getFocus(){return this.focus.get()}reveal(g,C){this.model.expandTo(g);const W=this.model.getListIndex(g);W!==-1&&this.view.reveal(W,C)}getRelativeTop(g){const C=this.model.getListIndex(g);return C===-1?null:this.view.getRelativeTop(C)}getViewState(g=this.options.identityProvider){if(!g)throw new r.TreeError(this._user,"Can't get tree view state without an identity provider");const C=I=>g.getId(I).toString(),W=M.empty(this.scrollTop);for(const I of this.getFocus())W.focus.add(C(I));for(const I of this.getSelection())W.selection.add(C(I));const Y=this.model.getNode(),A=[Y];for(;A.length>0;){const I=A.shift();I!==Y&&I.collapsible&&(W.expanded[C(I.element)]=I.collapsed?0:1),A.push(...I.children)}return W}onLeftArrow(g){g.preventDefault(),g.stopPropagation();const C=this.view.getFocusedElements();if(C.length===0)return;const W=C[0],Y=this.model.getNodeLocation(W);if(!this.model.setCollapsed(Y,!0)){const I=this.model.getParentNodeLocation(Y);if(!I)return;const O=this.model.getListIndex(I);this.view.reveal(O),this.view.setFocus([O])}}onRightArrow(g){g.preventDefault(),g.stopPropagation();const C=this.view.getFocusedElements();if(C.length===0)return;const W=C[0],Y=this.model.getNodeLocation(W);if(!this.model.setCollapsed(Y,!1)){if(!W.children.some(T=>T.visible))return;const[I]=this.view.getFocus(),O=I+1;this.view.reveal(O),this.view.setFocus([O])}}onSpace(g){g.preventDefault(),g.stopPropagation();const C=this.view.getFocusedElements();if(C.length===0)return;const W=C[0],Y=this.model.getNodeLocation(W),A=g.browserEvent.altKey;this.model.setCollapsed(Y,void 0,A)}navigate(g){return new $(this.view,this.model,g)}dispose(){(0,S.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=F;class ${constructor(g,C,W){this.view=g,this.model=C,W?this.index=this.model.getListIndex(W):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(ee,t,E,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class v extends E.AbstractTree{constructor(c,l,h,P,r,a={}){super(c,l,h,P,a),this.user=c,this.dataSource=r,this.nodesByIdentity=new Map,this.identityProvider=a.identityProvider}getInput(){return this.input}setInput(c,l){if(l&&!this.identityProvider)throw new i.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=c,!c){this.nodesByIdentity.clear(),this.model.setChildren(null,z.Iterable.empty());return}if(!l){this._refresh(c);return}const h=[],P=[],r=e=>{const o=this.identityProvider.getId(e).toString();return!l.expanded[o]},a=e=>{const o=this.identityProvider.getId(e.element).toString();l.focus.has(o)&&h.push(e.element),l.selection.has(o)&&P.push(e.element)};this._refresh(c,r,a),this.setFocus(h),this.setSelection(P),l&&typeof l.scrollTop=="number"&&(this.scrollTop=l.scrollTop)}updateChildren(c=this.input){if(typeof this.input>"u")throw new i.TreeError(this.user,"Tree input not set");let l;this.identityProvider&&(l=h=>{const P=this.identityProvider.getId(h).toString(),r=this.nodesByIdentity.get(P);if(!!r)return r.collapsed}),this._refresh(c,l)}resort(c=this.input,l=!0){this.model.resort(c===this.input?null:c,l)}refresh(c){if(c===void 0){this.view.rerender();return}this.model.rerender(c)}_refresh(c,l,h){let P;if(this.identityProvider){const r=new Set,a=h;h=e=>{const o=this.identityProvider.getId(e.element).toString();r.add(o),this.nodesByIdentity.set(o,e),a?.(e)},P=e=>{const o=this.identityProvider.getId(e.element).toString();r.has(o)||this.nodesByIdentity.delete(o)}}this.model.setChildren(c===this.input?null:c,this.iterate(c,l).elements,{onDidCreateNode:h,onDidDeleteNode:P})}iterate(c,l){const h=[...this.dataSource.getChildren(c)];return{elements:z.Iterable.map(h,r=>{const{elements:a,size:e}=this.iterate(r,l),o=this.dataSource.hasChildren?this.dataSource.hasChildren(r):void 0,n=e===0?void 0:l&&l(r);return{element:r,children:a,collapsible:o,collapsed:n}}),size:h.length}}createModel(c,l,h){return new k.ObjectTreeModel(c,l,h)}}t.DataTree=v}),define(ge[64],me([1,0,13,9,30,27,25,7,3,2,50,11,6]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var a;(function(ae){ae[ae.Promise=100]="Promise",ae[ae.PromiseCancel=101]="PromiseCancel",ae[ae.EventListen=102]="EventListen",ae[ae.EventDispose=103]="EventDispose"})(a||(a={}));function e(ae){switch(ae){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(ae){ae[ae.Initialize=200]="Initialize",ae[ae.PromiseSuccess=201]="PromiseSuccess",ae[ae.PromiseError=202]="PromiseError",ae[ae.PromiseErrorObj=203]="PromiseErrorObj",ae[ae.EventFire=204]="EventFire"})(o||(o={}));function n(ae){switch(ae){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(ae){ae[ae.Uninitialized=0]="Uninitialized",ae[ae.Idle=1]="Idle"})(u||(u={}));function s(ae){let U=0;for(let ne=0;;ne+=7){const te=ae.read(1);if(U|=(te.buffer[0]&127)<<ne,!(te.buffer[0]&128))return U}}const D=L(0);function w(ae,U){if(U===0){ae.write(D);return}let ne=0;for(let ie=U;ie!==0;ie=ie>>>7)ne++;const te=i.VSBuffer.alloc(ne);for(let ie=0;U!==0;ie++)te.buffer[ie]=U&127,U=U>>>7,U>0&&(te.buffer[ie]|=128);ae.write(te)}class S{constructor(U){this.buffer=U,this.pos=0}read(U){const ne=this.buffer.slice(this.pos,this.pos+U);return this.pos+=ne.byteLength,ne}}t.BufferReader=S;class f{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}t.BufferWriter=f;var b;(function(ae){ae[ae.Undefined=0]="Undefined",ae[ae.String=1]="String",ae[ae.Buffer=2]="Buffer",ae[ae.VSBuffer=3]="VSBuffer",ae[ae.Array=4]="Array",ae[ae.Object=5]="Object",ae[ae.Int=6]="Int"})(b||(b={}));function L(ae){const U=i.VSBuffer.alloc(1);return U.writeUInt8(ae,0),U}const N={Undefined:L(b.Undefined),String:L(b.String),Buffer:L(b.Buffer),VSBuffer:L(b.VSBuffer),Array:L(b.Array),Object:L(b.Object),Uint:L(b.Int)},y=typeof Buffer<"u";function d(ae,U){if(typeof U>"u")ae.write(N.Undefined);else if(typeof U=="string"){const ne=i.VSBuffer.fromString(U);ae.write(N.String),w(ae,ne.byteLength),ae.write(ne)}else if(y&&Buffer.isBuffer(U)){const ne=i.VSBuffer.wrap(U);ae.write(N.Buffer),w(ae,ne.byteLength),ae.write(ne)}else if(U instanceof i.VSBuffer)ae.write(N.VSBuffer),w(ae,U.byteLength),ae.write(U);else if(Array.isArray(U)){ae.write(N.Array),w(ae,U.length);for(const ne of U)d(ae,ne)}else if(typeof U=="number"&&(U|0)===U)ae.write(N.Uint),w(ae,U);else{const ne=i.VSBuffer.fromString(JSON.stringify(U));ae.write(N.Object),w(ae,ne.byteLength),ae.write(ne)}}t.serialize=d;function m(ae){switch(ae.read(1).readUInt8(0)){case b.Undefined:return;case b.String:return ae.read(s(ae)).toString();case b.Buffer:return ae.read(s(ae)).buffer;case b.VSBuffer:return ae.read(s(ae));case b.Array:{const ne=s(ae),te=[];for(let ie=0;ie<ne;ie++)te.push(m(ae));return te}case b.Object:return JSON.parse(ae.read(s(ae)).toString());case b.Int:return s(ae)}}t.deserialize=m;class p{constructor(U,ne,te=null,ie=1e3){this.protocol=U,this.ctx=ne,this.logger=te,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(U,ne){this.channels.set(U,ne),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const ne=this.send([U.type]);this.logger?.logOutgoing(ne,0,1,n(U.type));return}case 201:case 202:case 204:case 203:{const ne=this.send([U.type,U.id],U.data);this.logger?.logOutgoing(ne,U.id,1,n(U.type),U.data);return}}}send(U,ne=void 0){const te=new f;return d(te,U),d(te,ne),this.sendBuffer(te.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const ne=new S(U),te=m(ne),ie=m(ne),F=te[0];switch(F){case 100:return this.logger?.logIncoming(U.byteLength,te[1],1,`${e(F)}: ${te[2]}.${te[3]}`,ie),this.onPromise({type:F,id:te[1],channelName:te[2],name:te[3],arg:ie});case 102:return this.logger?.logIncoming(U.byteLength,te[1],1,`${e(F)}: ${te[2]}.${te[3]}`,ie),this.onEventListen({type:F,id:te[1],channelName:te[2],name:te[3],arg:ie});case 101:return this.logger?.logIncoming(U.byteLength,te[1],1,`${e(F)}`),this.disposeActiveRequest({type:F,id:te[1]});case 103:return this.logger?.logIncoming(U.byteLength,te[1],1,`${e(F)}`),this.disposeActiveRequest({type:F,id:te[1]})}}onPromise(U){const ne=this.channels.get(U.channelName);if(!ne){this.collectPendingRequest(U);return}const te=new z.CancellationTokenSource;let ie;try{ie=ne.call(this.ctx,U.name,U.arg,te.token)}catch(R){ie=Promise.reject(R)}const F=U.id;ie.then(R=>{this.sendResponse({id:F,data:R,type:201}),this.activeRequests.delete(U.id)},R=>{R instanceof Error?this.sendResponse({id:F,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:F,data:R,type:203}),this.activeRequests.delete(U.id)});const $=(0,l.toDisposable)(()=>te.cancel());this.activeRequests.set(U.id,$)}onEventListen(U){const ne=this.channels.get(U.channelName);if(!ne){this.collectPendingRequest(U);return}const te=U.id,F=ne.listen(this.ctx,U.name,U.arg)($=>this.sendResponse({id:te,data:$,type:204}));this.activeRequests.set(U.id,F)}disposeActiveRequest(U){const ne=this.activeRequests.get(U.id);ne&&(ne.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let ne=this.pendingRequests.get(U.channelName);ne||(ne=[],this.pendingRequests.set(U.channelName,ne));const te=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ne.push({request:U,timeoutTimer:te})}flushPendingRequests(U){const ne=this.pendingRequests.get(U);if(ne){for(const te of ne)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=p;var M;(function(ae){ae[ae.LocalSide=0]="LocalSide",ae[ae.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class q{constructor(U,ne=null){this.protocol=U,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=ne}getChannel(U){const ne=this;return{call(te,ie,F){return ne.isDisposed?Promise.reject(new _.CancellationError):ne.requestPromise(U,te,ie,F)},listen(te,ie){return ne.isDisposed?c.Event.None:ne.requestEvent(U,te,ie)}}}requestPromise(U,ne,te,ie=z.CancellationToken.None){const F=this.lastRequestId++,R={id:F,type:100,channelName:U,name:ne,arg:te};if(ie.isCancellationRequested)return Promise.reject(new _.CancellationError);let g;return new Promise((W,Y)=>{if(ie.isCancellationRequested)return Y(new _.CancellationError);const A=()=>{const x=B=>{switch(B.type){case 201:this.handlers.delete(F),W(B.data);break;case 202:{this.handlers.delete(F);const H=new Error(B.data.message);H.stack=Array.isArray(B.data.stack)?B.data.stack.join(`
`):B.data.stack,H.name=B.data.name,Y(H);break}case 203:this.handlers.delete(F),Y(B.data);break}};this.handlers.set(F,x),this.sendRequest(R)};let I=null;this.state===u.Idle?A():(I=(0,k.createCancelablePromise)(x=>this.whenInitialized()),I.then(()=>{I=null,A()}));const O=()=>{I?(I.cancel(),I=null):this.sendRequest({id:F,type:101}),Y(new _.CancellationError)},T=ie.onCancellationRequested(O);g=(0,l.combinedDisposable)((0,l.toDisposable)(O),T),this.activeRequests.add(g)}).finally(()=>{this.activeRequests.delete(g)})}requestEvent(U,ne,te){const ie=this.lastRequestId++,$={id:ie,type:102,channelName:U,name:ne,arg:te};let R=null;const g=new c.Emitter({onWillAddFirstListener:()=>{R=(0,k.createCancelablePromise)(W=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(g),this.sendRequest($)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(g),this.sendRequest({id:ie,type:103}))}}),C=W=>g.fire(W.data);return this.handlers.set(ie,C),g.event}sendRequest(U){switch(U.type){case 100:case 102:{const ne=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger?.logOutgoing(ne,U.id,0,`${e(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const ne=this.send([U.type,U.id]);this.logger?.logOutgoing(ne,U.id,0,e(U.type));return}}}send(U,ne=void 0){const te=new f;return d(te,U),d(te,ne),this.sendBuffer(te.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const ne=new S(U),te=m(ne),ie=m(ne),F=te[0];switch(F){case 200:return this.logger?.logIncoming(U.byteLength,0,0,n(F)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(U.byteLength,te[1],0,n(F),ie),this.onResponse({type:te[0],id:te[1],data:ie})}}onResponse(U){if(U.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(U.id)?.(U)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}qe([v.memoize],q.prototype,"onDidInitializePromise",null),t.ChannelClient=q;class Z{get connections(){const U=[];return this._connections.forEach(ne=>U.push(ne)),U}constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:ne,onDidClientDisconnect:te})=>{c.Event.once(ne.onMessage)(F=>{const $=new S(F),R=m($),g=new p(ne,R),C=new q(ne);this.channels.forEach((Y,A)=>g.registerChannel(A,Y));const W={channelServer:g,channelClient:C,ctx:R};this._connections.add(W),this._onDidAddConnection.fire(W),te(()=>{g.dispose(),C.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(U,ne){const te=this;return{call(ie,F,$){let R;if((0,r.isFunction)(ne)){const C=(0,E.getRandomElement)(te.connections.filter(ne));R=C?Promise.resolve(C):c.Event.toPromise(c.Event.filter(te.onDidAddConnection,ne))}else R=ne.routeCall(te,ie,F);const g=R.then(C=>C.channelClient.getChannel(U));return le(g).call(ie,F,$)},listen(ie,F){if((0,r.isFunction)(ne))return te.getMulticastEvent(U,ne,ie,F);const $=ne.routeEvent(te,ie,F).then(R=>R.channelClient.getChannel(U));return le($).listen(ie,F)}}}getMulticastEvent(U,ne,te,ie){const F=this;let $=new l.DisposableStore;const R=new c.Emitter({onWillAddFirstListener:()=>{$=new l.DisposableStore;const g=new c.EventMultiplexer,C=new Map,W=A=>{const O=A.channelClient.getChannel(U).listen(te,ie),T=g.add(O);C.set(A,T)},Y=A=>{const I=C.get(A);!I||(I.dispose(),C.delete(A))};F.connections.filter(ne).forEach(W),c.Event.filter(F.onDidAddConnection,ne)(W,void 0,$),F.onDidRemoveConnection(Y,void 0,$),g.event(R.fire,R,$),$.add(g)},onDidRemoveLastListener:()=>{$.dispose()}});return R.event}registerChannel(U,ne){this.channels.set(U,ne),this._connections.forEach(te=>{te.channelServer.registerChannel(U,ne)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=Z;class se{constructor(U,ne,te=null){const ie=new f;d(ie,ne),U.send(ie.buffer),this.channelClient=new q(U,te),this.channelServer=new p(U,ne,te)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,ne){this.channelServer.registerChannel(U,ne)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=se;function le(ae){return{call(U,ne,te){return ae.then(ie=>ie.call(U,ne,te))},listen(U,ne){const te=new c.Relay;return ae.then(ie=>te.input=ie.listen(U,ne)),te.event}}}t.getDelayedChannel=le;function fe(ae){let U=!1;return{call(ne,te,ie){return U?ae.call(ne,te,ie):(0,k.timeout)(0).then(()=>U=!0).then(()=>ae.call(ne,te,ie))},listen(ne,te){if(U)return ae.listen(ne,te);const ie=new c.Relay;return(0,k.timeout)(0).then(()=>U=!0).then(()=>ie.input=ae.listen(ne,te)),ie.event}}}t.getNextTickChannel=fe;class ue{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const ne of U.connections)if(await Promise.resolve(this.fn(ne.ctx)))return Promise.resolve(ne);return await c.Event.toPromise(U.onDidAddConnection),await this.route(U)}}t.StaticRouter=ue;var Q;(function(ae){function U(F,$){const R=F,g=$&&$.disableMarshalling,C=new Map;for(const W in R)te(W)&&C.set(W,c.Event.buffer(R[W],!0));return new class{listen(W,Y,A){const I=C.get(Y);if(I)return I;if(ie(Y)){const O=R[Y];if(typeof O=="function")return O.call(R,A)}throw new Error(`Event not found: ${Y}`)}call(W,Y,A){const I=R[Y];if(typeof I=="function"){if(!g&&Array.isArray(A))for(let O=0;O<A.length;O++)A[O]=(0,h.revive)(A[O]);return I.apply(R,A)}throw new Error(`Method not found: ${Y}`)}}}ae.fromService=U;function ne(F,$){const R=$&&$.disableMarshalling;return new Proxy({},{get(g,C){if(typeof C=="string")return $?.properties?.has(C)?$.properties.get(C):ie(C)?function(W){return F.listen(C,W)}:te(C)?F.listen(C):async function(...W){let Y;$&&!(0,r.isUndefinedOrNull)($.context)?Y=[$.context,...W]:Y=W;const A=await F.call(C,Y);return R?A:(0,h.revive)(A)};throw new Error(`Property not found: ${String(C)}`)}})}ae.toService=ne;function te(F){return F[0]==="o"&&F[1]==="n"&&P.isUpperAsciiLetter(F.charCodeAt(2))}function ie(F){return/^onDynamic/.test(F)&&P.isUpperAsciiLetter(F.charCodeAt(9))}})(Q=t.ProxyChannel||(t.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ve(ae){if(Array.isArray(ae))return ae;if(ae&&typeof ae=="object"&&typeof ae.toString=="function"){const U=ae.toString();if(U!=="[object Object]")return U}return ae}function be(ae){return Array.isArray(ae)?ae.map(ve):ve(ae)}function ke(ae,U,ne,te,ie,F,$){$=be($);const R=J[ie],g=R[te%R.length];let C=[`%c[${ae}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(F)?(C=C.concat($),C.push(")")):C.push($),console.log.apply(console,C)}class Re{constructor(U,ne){this._outgoingPrefix=U,this._incomingPrefix=ne,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,ne,te,ie,F){this._totalOutgoing+=U,ke(this._outgoingPrefix,this._totalOutgoing,U,ne,te,ie,F)}logIncoming(U,ne,te,ie,F){this._totalIncoming+=U,ke(this._incomingPrefix,this._totalIncoming,U,ne,te,ie,F)}}t.IPCLogger=Re}),define(ge[29],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,29]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function z(_,c,l){const h=[],P=i++,r=`vscode:onContextMenu${P}`,a=(e,o,n)=>{h[o].click?.(n)};k.ipcRenderer.once(r,a),k.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,o)=>{o===P&&(k.ipcRenderer.removeListener(r,a),l?.())}),k.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,P,_.map(e=>v(e,h)),r,c)}t.popup=z;function v(_,c){const l={id:c.length,label:_.label,type:_.type,accelerator:_.accelerator,checked:_.checked,enabled:typeof _.enabled=="boolean"?_.enabled:!0,visible:typeof _.visible=="boolean"?_.visible:!0};return c.push(_),Array.isArray(_.submenu)&&(l.submenu=_.submenu.map(h=>v(h,c))),l}}),define(ge[131],me([1,0,30,3,64,82,29]),function(ee,t,E,k,i,z,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class _ extends i.IPCClient{static createProtocol(){const l=k.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:message",(h,P)=>E.VSBuffer.wrap(P));return v.ipcRenderer.send("vscode:hello"),new z.Protocol(v.ipcRenderer,l)}constructor(l){const h=_.createProtocol();super(h,l),this.protocol=h}dispose(){this.protocol.disconnect()}}t.Client=_}),define(ge[132],me([12,10]),function(ee,t){return ee.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(ee,t){return ee.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[37],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(v){v.serviceIds=new Map,v.DI_TARGET="$di$target",v.DI_DEPENDENCIES="$di$dependencies";function _(c){return c[v.DI_DEPENDENCIES]||[]}v.getServiceDependencies=_})(E=t._util||(t._util={})),t.IInstantiationService=i("instantiationService");function k(v,_,c){_[E.DI_TARGET]===_?_[E.DI_DEPENDENCIES].push({id:v,index:c}):(_[E.DI_DEPENDENCIES]=[{id:v,index:c}],_[E.DI_TARGET]=_)}function i(v){if(E.serviceIds.has(v))return E.serviceIds.get(v);const _=function(c,l,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(_,c,h)};return _.toString=()=>v,E.serviceIds.set(v,_),_}t.createDecorator=i;function z(v){return v}t.refineServiceDecorator=z}),define(ge[134],me([1,0,37]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function k(z){return!!z.hostName&&!!z.errorMessage}t.isRemoteDiagnosticError=k;class i{async getPerformanceInfo(v,_){return{}}async getSystemInfo(v,_){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(v,_){return""}async getWorkspaceFileExtensions(v){return{extensions:[]}}async reportWorkspaceStats(v){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,113,22,11,6,15,132,37,5,28]),function(ee,t,E,k,i,z,v,_,c,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.getPlatformFileLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,c.createDecorator)("fileService");function P(U){return U.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(r=t.FileType||(t.FileType={}));var a;(function(U){U[U.Readonly=1]="Readonly"})(a=t.FilePermission||(t.FilePermission={}));var e;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(e=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function o(U){return!!(U.capabilities&2)}t.hasReadWriteCapability=o;function n(U){return!!(U.capabilities&8)}t.hasFileFolderCopyCapability=n;function u(U){return!!(U.capabilities&32768)}t.hasFileCloneCapability=u;function s(U){return!!(U.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function D(U){return!!(U.capabilities&16)}t.hasFileReadStreamCapability=D;function w(U){return o(U)?!!(U.capabilities&16384):!1}t.hasFileAtomicReadCapability=w;var S;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(S=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class f extends Error{static create(ne,te){const ie=new f(ne.toString(),te);return N(ie,te),ie}constructor(ne,te){super(ne),this.code=te}}t.FileSystemProviderError=f;function b(U,ne){return f.create(U,ne)}t.createFileSystemProviderError=b;function L(U){return U||b((0,_.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=L;function N(U,ne){return U.name=ne?`${ne} (FileSystemError)`:"FileSystemError",U}t.markAsFileSystemProviderError=N;function y(U){if(!U)return S.Unknown;if(U instanceof f)return U.code;const ne=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!ne)return S.Unknown;switch(ne[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=y;function d(U){if(U instanceof se)return U.fileOperationResult;switch(y(U)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=d;var m;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(m=t.FileOperation||(t.FileOperation={}));class p{constructor(ne,te,ie){this.resource=ne,this.operation=te,this.target=ie}isOperation(ne){return this.operation===ne}}t.FileOperationEvent=p;var M;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(M=t.FileChangeType||(t.FileChangeType={}));class q{constructor(ne,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const F of ne){const $=ie.get(F.type);switch($?$.push([F.resource,F]):ie.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,$]of ie)switch(F){case 1:this.added=E.TernarySearchTree.forUris(()=>te),this.added.fill($);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>te),this.updated.fill($);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>te),this.deleted.fill($);break}}contains(ne,...te){return this.doContains(ne,{includeChildren:!1},...te)}affects(ne,...te){return this.doContains(ne,{includeChildren:!0},...te)}doContains(ne,te,...ie){if(!ne)return!1;const F=ie.length>0;return!!((!F||ie.includes(1))&&(this.added?.get(ne)||te.includeChildren&&this.added?.findSuperstr(ne))||(!F||ie.includes(0))&&(this.updated?.get(ne)||te.includeChildren&&this.updated?.findSuperstr(ne))||(!F||ie.includes(2))&&(this.deleted?.findSubstr(ne)||te.includeChildren&&this.deleted?.findSuperstr(ne)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=q;function Z(U,ne,te){return!U||!ne||U===ne||ne.length>U.length?!1:(ne.charAt(ne.length-1)!==k.sep&&(ne+=k.sep),te?(0,i.startsWithIgnoreCase)(U,ne):U.indexOf(ne)===0)}t.isParent=Z;class se extends Error{constructor(ne,te,ie){super(ne),this.fileOperationResult=te,this.options=ie}}t.FileOperationError=se;class le extends se{constructor(ne,te,ie,F){super(ne,te,F),this.fileOperationResult=te,this.size=ie}}t.TooLargeFileOperationError=le;class fe extends se{constructor(ne,te,ie){super(ne,2,ie),this.stat=te}}t.NotModifiedSinceFileOperationError=fe;var ue;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ue=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var Q;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function J(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}t.etag=J;async function ve(U,ne){if(!ne.hasProvider(v.URI.from({scheme:U.scheme})))return new Promise(te=>{const ie=ne.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===U.scheme&&F.added&&(ie.dispose(),te())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class be{static formatSize(ne){return(0,z.isNumber)(ne)||(ne=0),ne<be.KB?(0,_.localize)(1,null,ne.toFixed(0)):ne<be.MB?(0,_.localize)(2,null,(ne/be.KB).toFixed(2)):ne<be.GB?(0,_.localize)(3,null,(ne/be.MB).toFixed(2)):ne<be.TB?(0,_.localize)(4,null,(ne/be.GB).toFixed(2)):(0,_.localize)(5,null,(ne/be.TB).toFixed(2))}}be.KB=1024,be.MB=be.KB*be.KB,be.GB=be.MB*be.KB,be.TB=be.GB*be.KB,t.ByteSize=be;var ke;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ke=t.Arch||(t.Arch={}));function Re(U){return{maxFileSize:U===0?300*be.MB:16*be.GB,maxHeapSize:U===0?700*be.MB:2*700*be.MB}}t.getPlatformFileLimits=Re;function ae(U){const ne=typeof U=="string"||U?.scheme===h.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===h.Schemas.file?1024*be.MB:ne?10*be.MB:l.isWeb?50*be.MB:1024*be.MB}t.getLargeFileConfirmationLimit=ae}),define(ge[136],me([1,0,37]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class k{constructor(z,v){this.server=z,this.router=v}getChannel(z){return this.server.getChannel(z,this.router)}registerChannel(z,v){this.server.registerChannel(z,v)}}t.MainProcessService=k}),define(ge[137],me([1,0,2,131]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(v){super(),this.mainProcessConnection=this._register(new k.Client(`window:${v}`))}getChannel(v){return this.mainProcessConnection.getChannel(v)}registerChannel(v,_){this.mainProcessConnection.registerChannel(v,_)}}t.ElectronIPCMainProcessService=i});var hi=this&&this.__param||function(ee,t){return function(E,k){t(E,k,ee)}};define(ge[138],me([1,0,64,136]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=class{constructor(v,_){return this.windowId=v,E.ProxyChannel.toService(_.getChannel("nativeHost"),{context:v,properties:(()=>{const c=new Map;return c.set("windowId",v),c})()})}};i=qe([hi(1,k.IMainProcessService)],i),t.NativeHostService=i}),define(ge[65],me([1,0,72,6]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.data=new Map}add(v,_){E.ok(k.isString(v)),E.ok(k.isObject(_)),E.ok(!this.data.has(v),"There is already an extension with this id"),this.data.set(v,_)}knows(v){return this.data.has(v)}as(v){return this.data.get(v)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,65]),function(ee,t,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class z{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,l){this.schemasById[i(c)]=l,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const v=new z;k.Registry.add(t.Extensions.JSONContribution,v)}),define(ge[140],me([1,0,9,16,17,3,6,15,133,139,65]),function(ee,t,E,k,i,z,v,_,c,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(w){function S(f,b){let L=f.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const N=e.getIcon(L.id);if(!N)return;L=N.defaults}return L}w.getDefinition=S})(P=t.IconContribution||(t.IconContribution={}));var r;(function(w){function S(b){return{weight:b.weight,style:b.style,src:b.src.map(L=>({format:L.format,location:L.location.toString()}))}}w.toJSONObject=S;function f(b){const L=N=>(0,v.isString)(N)?N:void 0;if(b&&Array.isArray(b.src)&&b.src.every(N=>(0,v.isString)(N.format)&&(0,v.isString)(N.location)))return{weight:L(b.weight),style:L(b.style),src:b.src.map(N=>({format:N.format,location:_.URI.parse(N.location)}))}}w.fromJSONObject=f})(r=t.IconFontDefinition||(t.IconFontDefinition={}));class a{constructor(){this._onDidChange=new z.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,f,b,L){const N=this.iconsById[S];if(N){if(b&&!N.description){N.description=b,this.iconSchema.properties[S].markdownDescription=`${b} $(${S})`;const m=this.iconReferenceSchema.enum.indexOf(S);m!==-1&&(this.iconReferenceSchema.enumDescriptions[m]=b),this._onDidChange.fire()}return N}const y={id:S,description:b,defaults:f,deprecationMessage:L};this.iconsById[S]=y;const d={$ref:"#/definitions/icons"};return L&&(d.deprecationMessage=L),b&&(d.markdownDescription=`${b}: $(${S})`),this.iconSchema.properties[S]=d,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(b||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const f=this.iconReferenceSchema.enum.indexOf(S);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,f){const b=this.iconFontsById[S];return b||(this.iconFontsById[S]=f,this._onDidChange.fire(),f)}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(N,y)=>N.id.localeCompare(y.id),f=N=>{for(;i.ThemeIcon.isThemeIcon(N.defaults);)N=this.iconsById[N.defaults.id];return`codicon codicon-${N?N.id:""}`},b=[];b.push("| preview     | identifier                        | default codicon ID                | description"),b.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.iconsById).map(N=>this.iconsById[N]);for(const N of L.filter(y=>!!y.description).sort(S))b.push(`|<i class="${f(N)}"></i>|${N.id}|${i.ThemeIcon.isThemeIcon(N.defaults)?N.defaults.id:N.id}|${N.description||""}|`);b.push("| preview     | identifier                        "),b.push("| ----------- | --------------------------------- |");for(const N of L.filter(y=>!i.ThemeIcon.isThemeIcon(y.defaults)).sort(S))b.push(`|<i class="${f(N)}"></i>|${N.id}|`);return b.join(`
`)}}const e=new a;h.Registry.add(t.Extensions.IconContribution,e);function o(w,S,f,b){return e.registerIcon(w,S,f,b)}t.registerIcon=o;function n(){return e}t.getIconRegistry=n;function u(){const w=(0,k.getCodiconFontCharacters)();for(const S in w){const f="\\"+w[S].toString(16);e.registerIcon(S,{fontCharacter:f})}}u(),t.iconsSchemaId="vscode://schemas/icons";const s=h.Registry.as(l.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const D=new E.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{D.isScheduled()||D.schedule()}),t.widgetClose=o("widget-close",k.Codicon.close,(0,c.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",k.Codicon.arrowUp,(0,c.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",k.Codicon.arrowDown,(0,c.localize)(4,null)),t.syncing=i.ThemeIcon.modify(k.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,17,140]),function(ee,t,E,k,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function v(c){const l=new k.Emitter,h=(0,z.getIconRegistry)();return h.onDidChange(()=>l.fire()),c?.onDidProductIconThemeChange(()=>l.fire()),{onDidChange:l.event,getCSS(){const P=c?c.getProductIconTheme():new _,r={},a=o=>{const n=P.getIcon(o);if(!n)return;const u=n.font;return u?(r[u.id]=u.definition,`.codicon-${o.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(u.id)}; }`):`.codicon-${o.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const o of h.getIcons()){const n=a(o);n&&e.push(n)}for(const o in r){const n=r[o],u=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",D=n.src.map(w=>`${(0,E.asCSSUrl)(w.location)} format('${w.format}')`).join(", ");e.push(`@font-face { src: ${D}; font-family: ${(0,E.asCSSPropertyValue)(o)};${u}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=v;class _{getIcon(l){const h=(0,z.getIconRegistry)();let P=l.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=h.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=_}),define(ge[142],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function k(h){return!!h.workspaceUri}t.isWorkspaceToOpen=k;function i(h){return!!h.folderUri}t.isFolderToOpen=i;function z(h){return!!h.fileUri}t.isFileToOpen=z;function v(h){const P=_(h),r=h.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=v;function _(h){if(E.isWeb)return"custom";const P=h.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=_;function c(h){if(!E.isWindows||E.isWeb||_(h)==="native")return!1;const P=h.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=c;function l(h=0){return Math.pow(1.2,h)}t.zoomLevelToZoomFactor=l}),define(ge[143],me([1,0,18,29,142]),function(ee,t,E,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function z(c){k.webFrame.setZoomLevel(c),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(c)),(0,E.setZoomLevel)(c,!1)}t.applyZoom=z;function v(){z((0,E.getZoomLevel)()+1)}t.zoomIn=v;function _(){z((0,E.getZoomLevel)()-1)}t.zoomOut=_}),define(ge[144],me([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(ee,t,E,k,i,z,v,_,c,l,h,P,r,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(M){return 22}getTemplateId(M){return N(M)?"process":b(M)?"machine":(0,c.isRemoteDiagnosticError)(M)?"error":L(M)?"header":""}}class s{hasChildren(M){return(0,c.isRemoteDiagnosticError)(M)?!1:N(M)?!!M.children?.length:!0}getChildren(M){return N(M)?M.children?M.children:[]:(0,c.isRemoteDiagnosticError)(M)?[]:L(M)?M.processRoots.length>1?M.processRoots:[M.processRoots[0].rootProcess]:b(M)?[M.rootProcess]:[M.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(M){const q=(0,k.append)(M,(0,k.$)(".row")),Z=(0,k.append)(q,(0,k.$)(".nameLabel")),se=(0,k.append)(q,(0,k.$)(".cpu")),le=(0,k.append)(q,(0,k.$)(".memory")),fe=(0,k.append)(q,(0,k.$)(".pid"));return{name:Z,CPU:se,memory:le,PID:fe}}renderElement(M,q,Z,se){Z.name.textContent=(0,E.localize)(0,null),Z.CPU.textContent=(0,E.localize)(1,null),Z.PID.textContent=(0,E.localize)(2,null),Z.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(M){}}class w{constructor(){this.templateId="machine"}renderTemplate(M){const q=Object.create(null),Z=(0,k.append)(M,(0,k.$)(".row"));return q.name=(0,k.append)(Z,(0,k.$)(".nameLabel")),q}renderElement(M,q,Z,se){Z.name.textContent=M.element.name}disposeTemplate(M){}}class S{constructor(){this.templateId="error"}renderTemplate(M){const q=Object.create(null),Z=(0,k.append)(M,(0,k.$)(".row"));return q.name=(0,k.append)(Z,(0,k.$)(".nameLabel")),q}renderElement(M,q,Z,se){Z.name.textContent=M.element.errorMessage}disposeTemplate(M){}}class f{constructor(M,q,Z){this.platform=M,this.totalMem=q,this.mapPidToName=Z,this.templateId="process"}renderTemplate(M){const q=(0,k.append)(M,(0,k.$)(".row")),Z=(0,k.append)(q,(0,k.$)(".nameLabel")),se=(0,k.append)(q,(0,k.$)(".cpu")),le=(0,k.append)(q,(0,k.$)(".memory")),fe=(0,k.append)(q,(0,k.$)(".pid"));return{name:Z,CPU:se,PID:fe,memory:le}}renderElement(M,q,Z,se){const{element:le}=M,fe=le.pid.toFixed(0);let ue=le.name;this.mapPidToName.has(le.pid)&&(ue=this.mapPidToName.get(le.pid)),Z.name.textContent=ue,Z.name.title=le.cmd,Z.CPU.textContent=le.load.toFixed(0),Z.PID.textContent=fe,Z.PID.parentElement.id=`pid-${fe}`;const Q=this.platform==="win32"?le.mem:this.totalMem*(le.mem/100);Z.memory.textContent=(Q/l.ByteSize.MB).toFixed(0)}disposeTemplate(M){}}function b(p){return!!p.name&&!!p.rootProcess}function L(p){return!!p.processRoots}function N(p){return!!p.pid}class y{constructor(M,q){this.data=q,this.mapPidToName=new Map;const Z=new h.ElectronIPCMainProcessService(M);this.nativeHostService=new P.NativeHostService(M,Z),this.applyStyles(q.styles),this.setEventHandlers(q),_.ipcRenderer.on("vscode:pidToNameResponse",(se,le)=>{this.mapPidToName=new Map;for(const[fe,ue]of le)this.mapPidToName.set(fe,ue)}),_.ipcRenderer.on("vscode:listProcessesResponse",async(se,le)=>{le.forEach((fe,ue)=>{N(fe.rootProcess)&&(fe.rootProcess.name=ue===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:le}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(le),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),_.ipcRenderer.send("vscode:pidToNameRequest"),_.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(M){document.onkeydown=q=>{const Z=M.platform==="darwin"?q.metaKey:q.ctrlKey;Z&&q.keyCode===87&&(q.stopPropagation(),q.preventDefault(),_.ipcRenderer.send("vscode:closeProcessExplorer")),Z&&q.keyCode===187&&(0,a.zoomIn)(),Z&&q.keyCode===189&&(0,a.zoomOut)()}}async createProcessTree(M){const q=document.getElementById("process-list");if(!q)return;const{totalmem:Z}=await this.nativeHostService.getOSStatistics(),se=[new f(this.data.platform,Z,this.mapPidToName),new D,new w,new S];this.tree=new i.DataTree("processExplorer",q,new u,se,new s,{identityProvider:{getId:le=>N(le)?le.pid.toString():(0,c.isRemoteDiagnosticError)(le)?le.hostName:L(le)?"processes":b(le)?le.name:"header"}}),this.tree.setInput({processes:{processRoots:M}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onKeyDown(le=>{const fe=new e.StandardKeyboardEvent(le);if(fe.keyCode===35&&fe.altKey){const ue=this.getSelectedPids();Promise.all(ue.map(Q=>this.nativeHostService.killProcess(Q,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(le=>{N(le.element)&&this.showContextMenu(le.element,!0)}),q.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{q.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(M){const q=o.exec(M);return q&&q.groups.port!=="0"||M.indexOf("node ")>=0||M.indexOf("node.exe")>=0}attachTo(M){const q={type:"node",request:"attach",name:`process ${M.pid}`};let Z=o.exec(M.cmd);Z?q.port=Number(Z.groups.port):q.processId=String(M.pid),Z=n.exec(M.cmd),Z&&(q.port=Number(Z.groups.port)),_.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[q]})}applyStyles(M){const q=(0,k.createStyleSheet)(),Z=[];M.listFocusBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${M.listFocusBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${M.listFocusBackground}; }`)),M.listFocusForeground&&Z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${M.listFocusForeground}; }`),M.listActiveSelectionBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${M.listActiveSelectionBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${M.listActiveSelectionBackground}; }`)),M.listActiveSelectionForeground&&Z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${M.listActiveSelectionForeground}; }`),M.listHoverBackground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${M.listHoverBackground}; }`),M.listHoverForeground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${M.listHoverForeground}; }`),M.listFocusOutline&&Z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${M.listFocusOutline}; outline-offset: -1px; }`),M.listHoverOutline&&Z.push(`.monaco-list-row:hover { outline: 1px dashed ${M.listHoverOutline}; outline-offset: -1px; }`),M.scrollbarShadowColor&&Z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${M.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),M.scrollbarSliderBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${M.scrollbarSliderBackgroundColor};
				}
			`),M.scrollbarSliderHoverBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${M.scrollbarSliderHoverBackgroundColor};
				}
			`),M.scrollbarSliderActiveBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${M.scrollbarSliderActiveBackgroundColor};
				}
			`),q.textContent=Z.join(`
`),M.color&&(document.body.style.color=M.color)}showContextMenu(M,q){const Z=[],se=Number(M.pid);q&&(Z.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.nativeHostService.killProcess(se,"SIGTERM")}}),Z.push({label:(0,E.localize)(5,null),click:()=>{this.nativeHostService.killProcess(se,"SIGKILL")}}),Z.push({type:"separator"})),Z.push({label:(0,E.localize)(6,null),click:()=>{const le=this.getSelectedPids();le?.includes(se)||(le.length=0,le.push(se));const fe=le?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(fe){const ue=fe.map(Q=>Q.innerText).filter(Q=>!!Q);this.nativeHostService.writeClipboardText(ue.join(`
`))}}}),Z.push({label:(0,E.localize)(7,null),click:()=>{const le=document.getElementById("process-list");le&&this.nativeHostService.writeClipboardText(le.innerText)}}),M&&q&&this.isDebuggable(M.cmd)&&(Z.push({type:"separator"}),Z.push({label:(0,E.localize)(8,null),click:()=>{this.attachTo(M)}})),(0,v.popup)(Z)}requestProcessList(M){setTimeout(()=>{const q=Date.now(),Z=M+q-this.lastRequestTime;this.lastRequestTime=q,Z>1e3?(_.ipcRenderer.send("vscode:pidToNameRequest"),_.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(Z)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(M=>{if(!(!M||!("pid"in M)))return M.pid}).filter(M=>!!M)}}function d(){const p=(0,k.createStyleSheet)();p.id="codiconStyles";const M=(0,r.getIconsStyleSheet)(void 0);function q(){p.textContent=M.getCSS()}const Z=new z.RunOnceScheduler(q,0);M.onDidChange(()=>Z.schedule()),Z.schedule()}function m(p){const M=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(M),d(),(0,a.applyZoom)(p.data.zoomLevel),new y(p.windowId,p.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
