/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","path","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ie){for(var e=[],L=0,O=ie.length;L<O;L++)e[L]=oe[ie[L]];return e};define(oe[62],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(_){return(R,P,y)=>{let I=null,E=null;if(typeof y.value=="function"?(I="value",E=y.value):typeof y.get=="function"&&(I="get",E=y.get),!E)throw new Error("not supported");y[I]=_(E,P)}}function O(_,R,P){let y=null,I=null;if(typeof P.value=="function"?(y="value",I=P.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(y="get",I=P.get),!I)throw new Error("not supported");const E=`$memoize$${R}`;P[y]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,m)}),this[E]}}e.memoize=O;function l(_,R,P){return L((y,I)=>{const E=`$debounce$${I}`,m=`$debounce$result$${I}`;return function(...f){this[m]||(this[m]=P?P():void 0),clearTimeout(this[E]),R&&(this[m]=R(this[m],...f),f=[this[m]]),this[E]=setTimeout(()=>{y.apply(this,f),this[m]=P?P():void 0},_)}})}e.debounce=l;function A(_,R,P){return L((y,I)=>{const E=`$throttle$timer$${I}`,m=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...b){if(this[m]||(this[m]=P?P():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...b)),this[p])return;const c=this[f]+_;c<=Date.now()?(this[f]=Date.now(),y.apply(this,[this[m]]),this[m]=P?P():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),y.apply(this,[this[m]]),this[m]=P?P():void 0},c-Date.now()))}})}e.throttle=A}),define(oe[10],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?v.isErrorNoTelemetry(o)?new v(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(n=>{n(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=L,e.errorHandler=new L;function O(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=O;function l(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(i){y(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=A;function _(i){y(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=_;function R(i){if(i instanceof Error){const{name:o,message:n}=i,t=i.stacktrace||i.stack;return{$isError:!0,name:o,message:n,stack:t,noTelemetry:v.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=R;const P="Canceled";function y(i){return i instanceof I?!0:i instanceof Error&&i.name===P&&i.message===P}e.isCancellationError=y;class I extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=I;function E(){const i=new Error(P);return i.name=i.message,i}e.canceled=E;function m(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=m;function f(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=f;function p(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function b(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=b;function c(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=c;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class v extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof v)return o;const n=new v;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class k extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}e.BugIndicatingError=k}),define(oe[21],ae([0,1,10]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(W,Z=0){return W[W.length-(1+Z)]}e.tail=O;function l(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=l;function A(W,Z,te=(ce,he)=>ce===he){if(W===Z)return!0;if(!W||!Z||W.length!==Z.length)return!1;for(let ce=0,he=W.length;ce<he;ce++)if(!te(W[ce],Z[ce]))return!1;return!0}e.equals=A;function _(W,Z){const te=W.length-1;Z<te&&(W[Z]=W[te]),W.pop()}e.removeFastWithoutKeepingOrder=_;function R(W,Z,te){return P(W.length,ce=>te(W[ce],Z))}e.binarySearch=R;function P(W,Z){let te=0,ce=W-1;for(;te<=ce;){const he=(te+ce)/2|0,pe=Z(he);if(pe<0)te=he+1;else if(pe>0)ce=he-1;else return he}return-(te+1)}e.binarySearch2=P;function y(W,Z){let te=0,ce=W.length;if(ce===0)return 0;for(;te<ce;){const he=Math.floor((te+ce)/2);Z(W[he])?ce=he:te=he+1}return te}e.findFirstInSorted=y;function I(W,Z,te){if(W=W|0,W>=Z.length)throw new TypeError("invalid index");const ce=Z[Math.floor(Z.length*Math.random())],he=[],pe=[],fe=[];for(const ye of Z){const Ce=te(ye,ce);Ce<0?he.push(ye):Ce>0?pe.push(ye):fe.push(ye)}return W<he.length?I(W,he,te):W<he.length+fe.length?fe[0]:I(W-(he.length+fe.length),pe,te)}e.quickSelect=I;function E(W,Z){const te=[];let ce;for(const he of W.slice(0).sort(Z))!ce||Z(ce[0],he)!==0?(ce=[he],te.push(ce)):ce.push(he);return te}e.groupBy=E;function m(W,Z,te){const ce=[];function he(ye,Ce,Re){if(Ce===0&&Re.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===ye?(ke.deleteCount+=Ce,ke.toInsert.push(...Re)):ce.push({start:ye,deleteCount:Ce,toInsert:Re})}let pe=0,fe=0;for(;;){if(pe===W.length){he(pe,0,Z.slice(fe));break}if(fe===Z.length){he(pe,W.length-pe,[]);break}const ye=W[pe],Ce=Z[fe],Re=te(ye,Ce);Re===0?(pe+=1,fe+=1):Re<0?(he(pe,1,[]),pe+=1):Re>0&&(he(pe,0,[Ce]),fe+=1)}return ce}e.sortedDiff=m;function f(W,Z,te){const ce=m(W,Z,te),he=[],pe=[];for(const fe of ce)he.push(...W.slice(fe.start,fe.start+fe.deleteCount)),pe.push(...fe.toInsert);return{removed:he,added:pe}}e.delta=f;function p(W,Z,te){if(te===0)return[];const ce=W.slice(0,te).sort(Z);return c(W,Z,ce,te,W.length),ce}e.top=p;function b(W,Z,te,ce,he){return te===0?Promise.resolve([]):new Promise((pe,fe)=>{(async()=>{const ye=W.length,Ce=W.slice(0,te).sort(Z);for(let Re=te,ke=Math.min(te+ce,ye);Re<ye;Re=ke,ke=Math.min(ke+ce,ye)){if(Re>te&&await new Promise(ze=>setTimeout(ze)),he&&he.isCancellationRequested)throw new L.CancellationError;c(W,Z,Ce,Re,ke)}return Ce})().then(pe,fe)})}e.topAsync=b;function c(W,Z,te,ce,he){for(const pe=te.length;ce<he;ce++){const fe=W[ce];if(Z(fe,te[pe-1])<0){te.pop();const ye=y(te,Ce=>Z(fe,Ce)<0);te.splice(ye,0,fe)}}}function d(W){return W.filter(Z=>!!Z)}e.coalesce=d;function u(W){let Z=0;for(let te=0;te<W.length;te++)W[te]&&(W[Z]=W[te],Z+=1);W.length=Z}e.coalesceInPlace=u;function g(W,Z,te){W.splice(te,0,W.splice(Z,1)[0])}e.move=g;function v(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=v;function k(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=k;function i(W,Z=te=>te){const te=new Set;return W.filter(ce=>{const he=Z(ce);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=i;function o(W){const Z=new Set;return te=>{const ce=W(te);return Z.has(ce)?!1:(Z.add(ce),!0)}}e.uniqueFilter=o;function n(W,Z){const te=t(W,Z);if(te!==-1)return W[te]}e.findLast=n;function t(W,Z){for(let te=W.length-1;te>=0;te--){const ce=W[te];if(Z(ce))return te}return-1}e.lastIndex=t;function r(W,Z){return W.length>0?W[0]:Z}e.firstOrDefault=r;function s(W,Z){return W.length>0?W[W.length-1]:Z}e.lastOrDefault=s;function a(W,Z,te=(ce,he)=>ce===he){let ce=0;for(let he=0,pe=Math.min(W.length,Z.length);he<pe&&te(W[he],Z[he]);he++)ce++;return ce}e.commonPrefixLength=a;function h(W){return[].concat(...W)}e.flatten=h;function w(W,Z){let te=typeof Z=="number"?W:0;typeof Z=="number"?te=W:(te=0,Z=W);const ce=[];if(te<=Z)for(let he=te;he<Z;he++)ce.push(he);else for(let he=te;he>Z;he--)ce.push(he);return ce}e.range=w;function S(W,Z,te){return W.reduce((ce,he)=>(ce[Z(he)]=te?te(he):he,ce),Object.create(null))}e.index=S;function D(W,Z){return W.push(Z),()=>T(W,Z)}e.insert=D;function T(W,Z){const te=W.indexOf(Z);if(te>-1)return W.splice(te,1),Z}e.remove=T;function M(W,Z,te){const ce=W.slice(0,Z),he=W.slice(Z);return ce.concat(te,he)}e.arrayInsert=M;function x(W,Z){let te;if(typeof Z=="number"){let ce=Z;te=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let ce=W.length-1;ce>0;ce-=1){const he=Math.floor(te()*(ce+1)),pe=W[ce];W[ce]=W[he],W[he]=pe}}e.shuffle=x;function V(W,Z){const te=W.indexOf(Z);te>-1&&(W.splice(te,1),W.unshift(Z))}e.pushToStart=V;function q(W,Z){const te=W.indexOf(Z);te>-1&&(W.splice(te,1),W.push(Z))}e.pushToEnd=q;function z(W,Z){for(const te of Z)W.push(te)}e.pushMany=z;function J(W,Z){return Array.isArray(W)?W.map(Z):Z(W)}e.mapArrayOrNot=J;function Q(W){return Array.isArray(W)?W:[W]}e.asArray=Q;function K(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=K;function X(W,Z){for(const te of W){const ce=Z(te);if(ce!==void 0)return ce}}e.mapFind=X;function j(W,Z,te){const ce=ee(W,Z),he=W.length,pe=te.length;W.length=he+pe;for(let fe=he-1;fe>=ce;fe--)W[fe+pe]=W[fe];for(let fe=0;fe<pe;fe++)W[fe+ce]=te[fe]}e.insertInto=j;function F(W,Z,te,ce){const he=ee(W,Z),pe=W.splice(he,te);return j(W,he,ce),pe}e.splice=F;function ee(W,Z){return Z<0?Math.max(Z+W.length,0):Math.min(Z,W.length)}var ne;(function(W){function Z(he){return he<0}W.isLessThan=Z;function te(he){return he>0}W.isGreaterThan=te;function ce(he){return he===0}W.isNeitherLessOrGreaterThan=ce,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function se(W,Z){return(te,ce)=>Z(W(te),W(ce))}e.compareBy=se;function H(...W){return(Z,te)=>{for(const ce of W){const he=ce(Z,te);if(!ne.isNeitherLessOrGreaterThan(he))return he}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const B=(W,Z)=>W-Z;e.numberComparator=B;function N(W,Z){if(W.length===0)return;let te=W[0];for(let ce=1;ce<W.length;ce++){const he=W[ce];Z(he,te)>0&&(te=he)}return te}e.findMaxBy=N;function C(W,Z){if(W.length===0)return;let te=W[0];for(let ce=1;ce<W.length;ce++){const he=W[ce];Z(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=C;function U(W,Z){return N(W,(te,ce)=>-Z(te,ce))}e.findMinBy=U;class ${constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let te=this.firstIdx;for(;te<this.items.length&&Z(this.items[te]);)te++;const ce=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,ce}takeFromEndWhile(Z){let te=this.lastIdx;for(;te>=0&&Z(this.items[te]);)te--;const ce=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const te=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,te}}e.ArrayQueue=$;class G{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(te=>(Z(te),!0))}toArray(){const Z=[];return this.iterate(te=>(Z.push(te),!0)),Z}filter(Z){return new G(te=>this.iterate(ce=>Z(ce)?te(ce):!0))}map(Z){return new G(te=>this.iterate(ce=>te(Z(ce))))}some(Z){let te=!1;return this.iterate(ce=>(te=Z(ce),!te)),te}findFirst(Z){let te;return this.iterate(ce=>Z(ce)?(te=ce,!1):!0),te}findLast(Z){let te;return this.iterate(ce=>(Z(ce)&&(te=ce),!0)),te}findLastMaxBy(Z){let te,ce=!0;return this.iterate(he=>((ce||ne.isGreaterThan(Z(he,te)))&&(ce=!1,te=he),!0)),te}}G.empty=new G(W=>{}),e.CallbackIterable=G}),define(oe[130],ae([0,1,10]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(P,y){if(!P)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=O;function l(P,y="Unreachable"){throw new Error(y)}e.assertNever=l;function A(P){if(!P)throw new L.BugIndicatingError("Assertion Failed")}e.assert=A;function _(P){if(!P()){debugger;P(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function R(P,y){let I=0;for(;I<P.length-1;){const E=P[I],m=P[I+1];if(!y(E,m))return!1;I++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(O){const l=this;let A=!1,_;return function(){return A||(A=!0,_=O.apply(l,arguments)),_}}e.once=L}),define(oe[63],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(O){function l(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}O.is=l;const A=Object.freeze([]);function _(){return A}O.empty=_;function*R(v){yield v}O.single=R;function P(v){return l(v)?v:R(v)}O.wrap=P;function y(v){return v||A}O.from=y;function I(v){return!v||v[Symbol.iterator]().next().done===!0}O.isEmpty=I;function E(v){return v[Symbol.iterator]().next().value}O.first=E;function m(v,k){for(const i of v)if(k(i))return!0;return!1}O.some=m;function f(v,k){for(const i of v)if(k(i))return i}O.find=f;function*p(v,k){for(const i of v)k(i)&&(yield i)}O.filter=p;function*b(v,k){let i=0;for(const o of v)yield k(o,i++)}O.map=b;function*c(...v){for(const k of v)for(const i of k)yield i}O.concat=c;function d(v,k,i){let o=i;for(const n of v)o=k(o,n);return o}O.reduce=d;function*u(v,k,i=v.length){for(k<0&&(k+=v.length),i<0?i+=v.length:i>v.length&&(i=v.length);k<i;k++)yield v[k]}O.slice=u;function g(v,k=Number.POSITIVE_INFINITY){const i=[];if(k===0)return[i,v];const o=v[Symbol.iterator]();for(let n=0;n<k;n++){const t=o.next();if(t.done)return[i,O.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}O.consume=g})(L=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function _(i,o=!1){let n=0;const t=i.length;let r="",s=0,a=16,h=0;function w(q){let z=0,J=0;for(;z<q;){const Q=i.charCodeAt(n);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;n++,z++}return z<q&&(J=-1),J}function S(q){n=q,r="",s=0,a=16,h=0}function D(){const q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&y(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&y(i.charCodeAt(n)))for(n++;n<i.length&&y(i.charCodeAt(n));)n++;else return h=3,i.substring(q,n);let z=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&y(i.charCodeAt(n))){for(n++;n<i.length&&y(i.charCodeAt(n));)n++;z=n}else h=3;return i.substring(q,z)}function T(){let q="",z=n;for(;;){if(n>=t){q+=i.substring(z,n),h=2;break}const J=i.charCodeAt(n);if(J===34){q+=i.substring(z,n),n++;break}if(J===92){if(q+=i.substring(z,n),n++,n>=t){h=2;break}switch(i.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const K=w(4);K>=0?q+=String.fromCharCode(K):h=4;break}default:h=5}z=n;continue}if(J>=0&&J<=31)if(P(J)){q+=i.substring(z,n),h=2;break}else h=6;n++}return q}function M(){if(r="",h=0,s=n,n>=t)return s=t,a=17;let q=i.charCodeAt(n);if(R(q)){do n++,r+=String.fromCharCode(q),q=i.charCodeAt(n);while(R(q));return a=15}if(P(q))return n++,r+=String.fromCharCode(q),q===13&&i.charCodeAt(n)===10&&(n++,r+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,r=T(),a=10;case 47:{const z=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<t&&!P(i.charCodeAt(n));)n++;return r=i.substring(z,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const J=t-1;let Q=!1;for(;n<J;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,h=1),r=i.substring(z,n),a=13}return r+=String.fromCharCode(q),n++,a=16}case 45:if(r+=String.fromCharCode(q),n++,n===t||!y(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=D(),a=11;default:for(;n<t&&x(q);)n++,q=i.charCodeAt(n);if(s!==n){switch(r=i.substring(s,n),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(q),n++,a=16}}function x(q){if(R(q)||P(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>n,scan:o?V:M,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>h}}e.createScanner=_;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function E(i,o){const n=[],t=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(w,S,D,T){s.value=w,s.offset=S,s.length=D,s.type=T,s.colonOffset=void 0,r=s}try{g(i,{onObjectBegin:(w,S)=>{if(o<=w)throw t;r=void 0,a=o>w,n.push("")},onObjectProperty:(w,S,D)=>{if(o<S||(h(w,S,D,"property"),n[n.length-1]=w,o<=S+D))throw t},onObjectEnd:(w,S)=>{if(o<=w)throw t;r=void 0,n.pop()},onArrayBegin:(w,S)=>{if(o<=w)throw t;r=void 0,n.push(0)},onArrayEnd:(w,S)=>{if(o<=w)throw t;r=void 0,n.pop()},onLiteralValue:(w,S,D)=>{if(o<S||(h(w,S,D,k(w)),o<=S+D))throw t},onSeparator:(w,S,D)=>{if(o<=S)throw t;if(w===":"&&r&&r.type==="property")r.colonOffset=S,a=!1,r=void 0;else if(w===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(a=!0,n[n.length-1]=""),r=void 0}}})}catch(w){if(w!==t)throw w}return{path:n,previousNode:r,isAtPropertyKey:a,matches:w=>{let S=0;for(let D=0;S<w.length&&D<n.length;D++)if(w[S]===n[D]||w[S]==="*")S++;else if(w[S]!=="**")return!1;return S===w.length}}}e.getLocation=E;function m(i,o=[],n=A.DEFAULT){let t=null,r=[];const s=[];function a(w){Array.isArray(r)?r.push(w):t!==null&&(r[t]=w)}return g(i,{onObjectBegin:()=>{const w={};a(w),s.push(r),r=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const w=[];a(w),s.push(r),r=w,t=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(w,S,D)=>{o.push({error:w,offset:S,length:D})}},n),r[0]}e.parse=m;function f(i,o=[],n=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){t.type==="property"&&(t.length=w-t.offset,t=t.parent)}function s(w){return t.children.push(w),w}g(i,{onObjectBegin:w=>{t=s({type:"object",offset:w,length:-1,parent:t,children:[]})},onObjectProperty:(w,S,D)=>{t=s({type:"property",offset:S,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:w,offset:S,length:D,parent:t})},onObjectEnd:(w,S)=>{t.length=w+S-t.offset,t=t.parent,r(w+S)},onArrayBegin:(w,S)=>{t=s({type:"array",offset:w,length:-1,parent:t,children:[]})},onArrayEnd:(w,S)=>{t.length=w+S-t.offset,t=t.parent,r(w+S)},onLiteralValue:(w,S,D)=>{s({type:k(w),offset:S,length:D,parent:t,value:w}),r(S+D)},onSeparator:(w,S,D)=>{t.type==="property"&&(w===":"?t.colonOffset=S:w===","&&r(S))},onError:(w,S,D)=>{o.push({error:w,offset:S,length:D})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=f;function p(i,o){if(!i)return;let n=i;for(const t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===t){n=s.children[1],r=!0;break}if(!r)return}else{const r=t;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=p;function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=b;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const o=Object.create(null);for(const n of i.children){const t=n.children[1];t&&(o[n.children[0].value]=c(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=c;function d(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=d;function u(i,o,n=!1){if(d(i,o,n)){const t=i.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=o;r++){const s=u(t[r],o,n);if(s)return s}return i}}e.findNodeAtOffset=u;function g(i,o,n=A.DEFAULT){const t=_(i,!1);function r(se){return se?()=>se(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(se){return se?H=>se(H,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=r(o.onObjectBegin),h=s(o.onObjectProperty),w=r(o.onObjectEnd),S=r(o.onArrayBegin),D=r(o.onArrayEnd),T=s(o.onLiteralValue),M=s(o.onSeparator),x=r(o.onComment),V=s(o.onError),q=n&&n.disallowComments,z=n&&n.allowTrailingComma;function J(){for(;;){const se=t.scan();switch(t.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:q||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(se){case 12:case 13:q?Q(10):x();break;case 16:Q(1);break;case 15:case 14:break;default:return se}}}function Q(se,H=[],B=[]){if(V(se),H.length+B.length>0){let N=t.getToken();for(;N!==17;){if(H.indexOf(N)!==-1){J();break}else if(B.indexOf(N)!==-1)break;N=J()}}}function K(se){const H=t.getTokenValue();return se?T(H):h(H),J(),!0}function X(){switch(t.getToken()){case 11:{let se=0;try{se=JSON.parse(t.getTokenValue()),typeof se!="number"&&(Q(2),se=0)}catch{Q(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return J(),!0}function j(){return t.getToken()!==10?(Q(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(M(":"),J(),ne()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function F(){a(),J();let se=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(se||Q(4,[],[]),M(","),J(),t.getToken()===2&&z)break}else se&&Q(6,[],[]);j()||Q(4,[],[2,5]),se=!0}return w(),t.getToken()!==2?Q(7,[2],[]):J(),!0}function ee(){S(),J();let se=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(se||Q(4,[],[]),M(","),J(),t.getToken()===4&&z)break}else se&&Q(6,[],[]);ne()||Q(4,[],[4,5]),se=!0}return D(),t.getToken()!==4?Q(8,[4],[]):J(),!0}function ne(){switch(t.getToken()){case 3:return ee();case 1:return F();case 10:return K(!0);default:return X()}}return J(),t.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):ne()?(t.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=g;function v(i,o){const n=_(i),t=[];let r,s=0,a;do switch(a=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:s!==a&&t.push(i.substring(s,a)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),s=n.getPosition();break}while(r!==17);return t.join("")}e.stripComments=v;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(oe[42],ae([0,1,35]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(y,I,E){let m,f,p,b,c;if(I){for(b=I.offset,c=b+I.length,p=b;p>0&&!P(y,p-1);)p--;let a=c;for(;a<y.length&&!P(y,a);)a++;f=y.substring(p,a),m=_(f,E)}else f=y,m=0,p=0,b=0,c=y.length;const d=R(E,y);let u=!1,g=0,v;E.insertSpaces?v=A(" ",E.tabSize||4):v="	";const k=(0,L.createScanner)(f,!1);let i=!1;function o(){return d+A(v,m+g)}function n(){let a=k.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=k.scan();return i=a===16||k.getTokenError()!==0,a}const t=[];function r(a,h,w){!i&&h<c&&w>b&&y.substring(h,w)!==a&&t.push({offset:h,length:w-h,content:a})}let s=n();if(s!==17){const a=k.getTokenOffset()+p,h=A(v,m);r(h,p,a)}for(;s!==17;){let a=k.getTokenOffset()+k.getTokenLength()+p,h=n(),w="";for(;!u&&(h===12||h===13);){const D=k.getTokenOffset()+p;r(" ",a,D),a=k.getTokenOffset()+k.getTokenLength()+p,w=h===12?o():"",h=n()}if(h===2)s!==1&&(g--,w=o());else if(h===4)s!==3&&(g--,w=o());else{switch(s){case 3:case 1:g++,w=o();break;case 5:case 12:w=o();break;case 13:u?w=o():w=" ";break;case 6:w=" ";break;case 10:if(h===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?w=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}u&&(h===12||h===13)&&(w=o())}const S=k.getTokenOffset()+p;r(w,a,S),s=h}return t}e.format=O;function l(y,I){const E=JSON.stringify(y,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?E.replace(/\r\n|\r|\n/g,I.eol):E}e.toFormattedString=l;function A(y,I){let E="";for(let m=0;m<I;m++)E+=y;return E}function _(y,I){let E=0,m=0;const f=I.tabSize||4;for(;E<y.length;){const p=y.charAt(E);if(p===" ")m++;else if(p==="	")m+=f;else break;E++}return Math.floor(m/f)}function R(y,I){for(let E=0;E<I.length;E++){const m=I.charAt(E);if(m==="\r")return E+1<I.length&&I.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=R;function P(y,I){return`\r
`.indexOf(y.charAt(I))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,35,42]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(y,I,E){return A(y,I,void 0,E)}e.removeProperty=l;function A(y,I,E,m,f){const p=I.slice(),b=[],c=(0,L.parseTree)(y,b);let d,u;for(;p.length>0&&(u=p.pop(),d=(0,L.findNodeAtLocation)(c,p),d===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(d)if(d.type==="object"&&typeof u=="string"&&Array.isArray(d.children)){const g=(0,L.findNodeAtLocation)(d,[u]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const v=d.children.indexOf(g.parent);let k,i=g.parent.offset+g.parent.length;if(v>0){const o=d.children[v-1];k=o.offset+o.length}else k=d.offset+1,d.children.length>1&&(i=d.children[1].offset);return _(y,{offset:k,length:i-k,content:""},m)}else return _(y,{offset:g.offset,length:g.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const v=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,k=f?f(d.children.map(o=>o.children[0].value)):d.children.length;let i;if(k>0){const o=d.children[k-1];i={offset:o.offset+o.length,length:0,content:","+v}}else d.children.length===0?i={offset:d.offset+1,length:0,content:v}:i={offset:d.offset+1,length:0,content:v+","};return _(y,i,m)}}else if(d.type==="array"&&typeof u=="number"&&Array.isArray(d.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let v;if(d.children.length===0||u===0)v={offset:d.offset+1,length:0,content:d.children.length===0?g:g+","};else{const k=u===-1||u>d.children.length?d.children.length:u,i=d.children[k-1];v={offset:i.offset+i.length,length:0,content:","+g}}return _(y,v,m)}else{const g=u,v=d.children[g];let k;if(d.children.length===1)k={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===g){const i=d.children[g-1],o=i.offset+i.length,n=d.offset+d.length;k={offset:o,length:n-2-o,content:""}}else k={offset:v.offset,length:d.children[g+1].offset-v.offset,content:""};return _(y,k,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${d.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return _(y,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(E)},m)}}e.setProperty=A;function _(y,I,E){let m=R(y,I),f=I.offset,p=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,O.isEOL)(m,f-1);)f--;for(;p<m.length&&!(0,O.isEOL)(m,p);)p++}const b=(0,O.format)(m,{offset:f,length:p-f},E);for(let d=b.length-1;d>=0;d--){const u=b[d];m=R(m,u),f=Math.min(f,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const c=y.length-(m.length-p)-f;return[{offset:f,length:c,content:m.substring(f,p)}]}e.withFormatting=_;function R(y,I){return y.substring(0,I.offset)+I.content+y.substring(I.offset+I.length)}e.applyEdit=R;function P(y,I){const E=I.slice(0).sort((f,p)=>{const b=f.offset-p.offset;return b===0?f.length-p.length:b});let m=y.length;for(let f=E.length-1;f>=0;f--){const p=E[f];if(p.offset+p.length<=m)y=R(y,p);else throw new Error("Overlapping edit");m=p.offset}return y}e.applyEdits=P}),define(oe[131],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(oe[2],ae([0,1,82,63]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function _(s){A=s}if(e.setDisposableTracker=_,l){const s="__is_disposable_tracked__";_(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==u.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==u.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function R(s){return A?.trackDisposable(s),s}function P(s){A?.markAsDisposed(s)}function y(s,a){A?.setParent(s,a)}function I(s,a){if(!!A)for(const h of s)A.setParent(h,a)}function E(s){return A?.markAsSingleton(s),s}e.markAsSingleton=E;function m(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=m;function f(s){if(O.Iterable.is(s)){const a=[];for(const h of s)if(h)try{h.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=f;function p(s){for(const a of s)m(a)&&a.dispose();return[]}e.disposeIfDisposable=p;function b(...s){const a=c(()=>f(s));return I(s,a),a}e.combinedDisposable=b;function c(s){const a=R({dispose:(0,L.once)(()=>{P(a),s()})});return a}e.toDisposable=c;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return y(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class u{constructor(){this._store=new d,R(this),y(this._store,this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}u.None=Object.freeze({dispose(){}}),e.Disposable=u;class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&y(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&y(a,null),a}}e.MutableDisposable=g;class v{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=v;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let h=a;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,P(this))},this}}e.SafeDisposable=k;class i{constructor(){this.references=new Map}acquire(a,...h){let w=this.references.get(a);w||(w={counter:0,object:this.createReferencedObject(a,...h)},this.references.set(a,w));const{object:S}=w,D=(0,L.once)(()=>{--w.counter===0&&(this.destroyReferencedObject(a,w.object),this.references.delete(a))});return w.counter++,{object:S,dispose:D}}}e.ReferenceCollection=i;class o{constructor(a){this.referenceCollection=a}async acquire(a,...h){const w=this.referenceCollection.acquire(a,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(S){throw w.dispose(),S}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function t(s){const a=new d;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=t;class r{constructor(){this._store=new Map,this._isDisposed=!1,R(this)}dispose(){P(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{f(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,h,w=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this._store.get(a)?.dispose(),this._store.set(a,h)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(oe[84],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(A){this.element=A,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class O{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let A=this._first;for(;A!==L.Undefined;){const _=A.next;A.prev=L.Undefined,A.next=L.Undefined,A=_}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,_){const R=new L(A);if(this._first===L.Undefined)this._first=R,this._last=R;else if(_){const y=this._last;this._last=R,R.prev=y,y.next=R}else{const y=this._first;this._first=R,R.next=y,y.prev=R}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==L.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==L.Undefined&&A.next!==L.Undefined){const _=A.prev;_.next=A.next,A.next.prev=_}else A.prev===L.Undefined&&A.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):A.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):A.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==L.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(oe[37],ae([0,1]),function(ie,e){"use strict";var L,O,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(b,c,d){let u=b.get(c);return u===void 0&&(u=d,b.set(c,u)),u}e.getOrSet=A;function _(b){const c=[];return b.forEach((d,u)=>{c.push(`${u} => ${d}`)}),`Map(${b.size}) {${c.join(", ")}}`}e.mapToString=_;function R(b){const c=[];return b.forEach(d=>{c.push(d)}),`Set(${b.size}) {${c.join(", ")}}`}e.setToString=R;class P{constructor(c,d){this.uri=c,this.value=d}}class y{constructor(c,d){this[L]="ResourceMap",c instanceof y?(this.map=new Map(c.map),this.toKey=d??y.defaultToKey):(this.map=new Map,this.toKey=c??y.defaultToKey)}set(c,d){return this.map.set(this.toKey(c),new P(c,d)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,d){typeof d<"u"&&(c=c.bind(d));for(const[u,g]of this.map)c(g.value,g.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}y.defaultToKey=b=>b.toString(),e.ResourceMap=y;class I{constructor(c,d){this[O]="ResourceSet",!c||typeof c=="function"?this._map=new y(c):(this._map=new y(d),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,d){this._map.forEach((u,g)=>c.call(d,g,g,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var E;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class m{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,d=0){const u=this._map.get(c);if(!!u)return d!==0&&this.touch(u,d),u.value}set(c,d,u=0){let g=this._map.get(c);if(g)g.value=d,u!==0&&this.touch(g,u);else{switch(g={key:c,value:d,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(c,g),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const d=this._map.get(c);if(!!d)return this._map.delete(c),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,d){const u=this._state;let g=this._head;for(;g;){if(d?c.bind(d)(g.value,g.key,this):c(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const c=this,d=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(c._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.key,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}values(){const c=this,d=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(c._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:u.value,done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}entries(){const c=this,d=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(c._state!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const v={value:[u.key,u.value],done:!1};return u=u.next,v}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let d=this._head,u=this.size;for(;d&&u>c;)this._map.delete(d.key),d=d.next,u--;this._head=d,this._size=u,d&&(d.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const d=c.next,u=c.previous;if(!d||!u)throw new Error("Invalid list");d.previous=u,u.next=d}c.next=void 0,c.previous=void 0,this._state++}touch(c,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(c===this._head)return;const u=c.next,g=c.previous;c===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(d===2){if(c===this._tail)return;const u=c.next,g=c.previous;c===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((d,u)=>{c.push([u,d])}),c}fromJSON(c){this.clear();for(const[d,u]of c)this.set(d,u)}}e.LinkedMap=m;class f extends m{constructor(c,d=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,d=2){return super.get(c,d)}peek(c){return super.get(c,0)}set(c,d){return super.set(c,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class p{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let d=this.map.get(c)||0;return d===0?!1:(d--,d===0?this.map.delete(c):this.map.set(c,d),!0)}has(c){return this.map.has(c)}}e.CounterSet=p}),define(oe[85],ae([0,1,37]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new L.LRUCache(1e4);function l(y){return P(y,"NFC",O)}e.normalizeNFC=l;const A=new L.LRUCache(1e4);function _(y){return P(y,"NFD",A)}e.normalizeNFD=_;const R=/[^\u0000-\u0080]/;function P(y,I,E){if(!y)return y;const m=E.get(y);if(m)return m;let f;return R.test(y)?f=y.normalize(I):f=y,E.set(y,f),f}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(I){return _(I).replace(y,"")}}()}),define(oe[132],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(R,P,y){return Math.min(Math.max(R,P),y)}e.clamp=L;function O(R,P){return(P+R%P)%P}e.rot=O;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class _{constructor(P){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(P),this._values.fill(0,0,P)}update(P){const y=this._values[this._index];return this._values[this._index]=P,this._index=(this._index+1)%this._values.length,this._sum-=y,this._sum+=P,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ie(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function _(P){A.push(P,Date.now())}function R(){const P=[];for(let y=0;y<A.length;y+=2)P.push({name:A[y],startTime:A[y+1]});return P}return{mark:_,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const _ of performance.getEntriesByType("mark"))A.push({name:_.name,startTime:Math.round(l+_.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function L(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=L(O))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var O in L)(typeof exports=="object"?exports:ie)[O]=L[O]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function L(O){if(e[O])return e[O].exports;var l=e[O]={i:O,l:!1,exports:{}};return ie[O].call(l.exports,l,l.exports,L),l.l=!0,l.exports}return L.m=ie,L.c=e,L.d=function(O,l,A){L.o(O,l)||Object.defineProperty(O,l,{enumerable:!0,get:A})},L.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},L.t=function(O,l){if(1&l&&(O=L(O)),8&l||4&l&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&l&&typeof O!="string")for(var _ in O)L.d(A,_,function(R){return O[R]}.bind(null,_));return A},L.n=function(O){var l=O&&O.__esModule?function(){return O.default}:function(){return O};return L.d(l,"a",l),l},L.o=function(O,l){return Object.prototype.hasOwnProperty.call(O,l)},L.p="",L(L.s=0)}([function(ie,e,L){(function(O){var l;e=ie.exports=B,l=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],y=0,I=y++;P[I]="0|[1-9]\\d*";var E=y++;P[E]="[0-9]+";var m=y++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=y++;P[f]="("+P[I]+")\\.("+P[I]+")\\.("+P[I]+")";var p=y++;P[p]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var b=y++;P[b]="(?:"+P[I]+"|"+P[m]+")";var c=y++;P[c]="(?:"+P[E]+"|"+P[m]+")";var d=y++;P[d]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var u=y++;P[u]="(?:-?("+P[c]+"(?:\\."+P[c]+")*))";var g=y++;P[g]="[0-9A-Za-z-]+";var v=y++;P[v]="(?:\\+("+P[g]+"(?:\\."+P[g]+")*))";var k=y++,i="v?"+P[f]+P[d]+"?"+P[v]+"?";P[k]="^"+i+"$";var o="[v=\\s]*"+P[p]+P[u]+"?"+P[v]+"?",n=y++;P[n]="^"+o+"$";var t=y++;P[t]="((?:<|>)?=?)";var r=y++;P[r]=P[E]+"|x|X|\\*";var s=y++;P[s]=P[I]+"|x|X|\\*";var a=y++;P[a]="[v=\\s]*("+P[s]+")(?:\\.("+P[s]+")(?:\\.("+P[s]+")(?:"+P[d]+")?"+P[v]+"?)?)?";var h=y++;P[h]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[u]+")?"+P[v]+"?)?)?";var w=y++;P[w]="^"+P[t]+"\\s*"+P[a]+"$";var S=y++;P[S]="^"+P[t]+"\\s*"+P[h]+"$";var D=y++;P[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=y++;P[T]="(?:~>?)";var M=y++;P[M]="(\\s*)"+P[T]+"\\s+",R[M]=new RegExp(P[M],"g");var x=y++;P[x]="^"+P[T]+P[a]+"$";var V=y++;P[V]="^"+P[T]+P[h]+"$";var q=y++;P[q]="(?:\\^)";var z=y++;P[z]="(\\s*)"+P[q]+"\\s+",R[z]=new RegExp(P[z],"g");var J=y++;P[J]="^"+P[q]+P[a]+"$";var Q=y++;P[Q]="^"+P[q]+P[h]+"$";var K=y++;P[K]="^"+P[t]+"\\s*("+o+")$|^$";var X=y++;P[X]="^"+P[t]+"\\s*("+i+")$|^$";var j=y++;P[j]="(\\s*)"+P[t]+"\\s*("+o+"|"+P[a]+")",R[j]=new RegExp(P[j],"g");var F=y++;P[F]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ee=y++;P[ee]="^\\s*("+P[h]+")\\s+-\\s+("+P[h]+")\\s*$";var ne=y++;P[ne]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,P[se]),R[se]||(R[se]=new RegExp(P[se]));function H(le,de){if(le instanceof B)return le;if(typeof le!="string"||le.length>A||!(de?R[n]:R[k]).test(le))return null;try{return new B(le,de)}catch{return null}}function B(le,de){if(le instanceof B){if(le.loose===de)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof B))return new B(le,de);l("SemVer",le,de),this.loose=de;var ge=le.trim().match(de?R[n]:R[k]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<_)return Ie}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=H,e.valid=function(le,de){var ge=H(le,de);return ge?ge.version:null},e.clean=function(le,de){var ge=H(le.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(le){return l("SemVer.compare",this.version,this.loose,le),le instanceof B||(le=new B(le,this.loose)),this.compareMain(le)||this.comparePre(le)},B.prototype.compareMain=function(le){return le instanceof B||(le=new B(le,this.loose)),C(this.major,le.major)||C(this.minor,le.minor)||C(this.patch,le.patch)},B.prototype.comparePre=function(le){if(le instanceof B||(le=new B(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Pe=le.prerelease[de];if(l("prerelease compare",de,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return C(ge,Pe)}while(++de)},B.prototype.inc=function(le,de){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,de,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new B(le,ge).inc(de,Pe).version}catch{return null}},e.diff=function(le,de){if(W(le,de))return null;var ge=H(le),Pe=H(de);if(ge.prerelease.length||Pe.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=C;var N=/^[0-9]+$/;function C(le,de){var ge=N.test(le),Pe=N.test(de);return ge&&Pe&&(le=+le,de=+de),ge&&!Pe?-1:Pe&&!ge?1:le<de?-1:le>de?1:0}function U(le,de,ge){return new B(le,ge).compare(new B(de,ge))}function $(le,de,ge){return U(le,de,ge)>0}function G(le,de,ge){return U(le,de,ge)<0}function W(le,de,ge){return U(le,de,ge)===0}function Z(le,de,ge){return U(le,de,ge)!==0}function te(le,de,ge){return U(le,de,ge)>=0}function ce(le,de,ge){return U(le,de,ge)<=0}function he(le,de,ge,Pe){var Ie;switch(de){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Ie=le!==ge;break;case"":case"=":case"==":Ie=W(le,ge,Pe);break;case"!=":Ie=Z(le,ge,Pe);break;case">":Ie=$(le,ge,Pe);break;case">=":Ie=te(le,ge,Pe);break;case"<":Ie=G(le,ge,Pe);break;case"<=":Ie=ce(le,ge,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function pe(le,de){if(le instanceof pe){if(le.loose===de)return le;le=le.value}if(!(this instanceof pe))return new pe(le,de);l("comparator",le,de),this.loose=de,this.parse(le),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(le,de){return C(de,le)},e.major=function(le,de){return new B(le,de).major},e.minor=function(le,de){return new B(le,de).minor},e.patch=function(le,de){return new B(le,de).patch},e.compare=U,e.compareLoose=function(le,de){return U(le,de,!0)},e.rcompare=function(le,de,ge){return U(de,le,ge)},e.sort=function(le,de){return le.sort(function(ge,Pe){return e.compare(ge,Pe,de)})},e.rsort=function(le,de){return le.sort(function(ge,Pe){return e.rcompare(ge,Pe,de)})},e.gt=$,e.lt=G,e.eq=W,e.neq=Z,e.gte=te,e.lte=ce,e.cmp=he,e.Comparator=pe;var fe={};function ye(le,de){if(le instanceof ye)return le.loose===de?le:new ye(le.raw,de);if(le instanceof pe)return new ye(le.value,de);if(!(this instanceof ye))return new ye(le,de);if(this.loose=de,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ce(le){return!le||le.toLowerCase()==="x"||le==="*"}function Re(le,de,ge,Pe,Ie,Ne,Le,We,Me,Oe,Fe,re,ue){return((de=Ce(ge)?"":Ce(Pe)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+Pe+".0":">="+de)+" "+(We=Ce(Me)?"":Ce(Oe)?"<"+(+Me+1)+".0.0":Ce(Fe)?"<"+Me+"."+(+Oe+1)+".0":re?"<="+Me+"."+Oe+"."+Fe+"-"+re:"<="+We)).trim()}function ke(le,de){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<le.length;ge++)if(l(le[ge].semver),le[ge].semver!==fe&&le[ge].semver.prerelease.length>0){var Pe=le[ge].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function ze(le,de,ge){try{de=new ye(de,ge)}catch{return!1}return de.test(le)}function Ke(le,de,ge,Pe){var Ie,Ne,Le,We,Me;switch(le=new B(le,Pe),de=new ye(de,Pe),ge){case">":Ie=$,Ne=ce,Le=G,We=">",Me=">=";break;case"<":Ie=G,Ne=te,Le=$,We="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(le,de,Pe))return!1;for(var Oe=0;Oe<de.set.length;++Oe){var Fe=de.set[Oe],re=null,ue=null;if(Fe.forEach(function(me){me.semver===fe&&(me=new pe(">=0.0.0")),re=re||me,ue=ue||me,Ie(me.semver,re.semver,Pe)?re=me:Le(me.semver,ue.semver,Pe)&&(ue=me)}),re.operator===We||re.operator===Me||(!ue.operator||ue.operator===We)&&Ne(le,ue.semver)||ue.operator===Me&&Le(le,ue.semver))return!1}return!0}pe.prototype.parse=function(le){var de=this.loose?R[K]:R[X],ge=le.match(de);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new B(ge[2],this.loose):this.semver=fe},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(le){return l("Comparator.test",le,this.loose),this.semver===fe||(typeof le=="string"&&(le=new B(le,this.loose)),he(le,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(le,de){if(!(le instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new ye(le.value,de),ze(this.value,ge,de);if(le.operator==="")return ge=new ye(this.value,de),ze(le.semver,ge,de);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ne=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),We=he(this.semver,"<",le.semver,de)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=he(this.semver,">",le.semver,de)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Ie||Ne&&Le||We||Me},e.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(le){var de=this.loose;le=le.trim(),l("range",le,de);var ge=de?R[ee]:R[F];le=le.replace(ge,Re),l("hyphen replace",le),le=le.replace(R[j],"$1$2$3"),l("comparator trim",le,R[j]),le=(le=(le=le.replace(R[M],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Pe=de?R[K]:R[X],Ie=le.split(" ").map(function(Ne){return function(Le,We){return l("comp",Le),Le=function(Me,Oe){return Me.trim().split(/\s+/).map(function(Fe){return function(re,ue){l("caret",re,ue);var me=ue?R[Q]:R[J];return re.replace(me,function(we,Se,be,De,_e){var Ae;return l("caret",re,we,Se,be,De,_e),Ce(Se)?Ae="":Ce(be)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(De)?Ae=Se==="0"?">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+".0 <"+(+Se+1)+".0.0":_e?(l("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ae=Se==="0"?be==="0"?">="+Se+"."+be+"."+De+_e+" <"+Se+"."+be+"."+(+De+1):">="+Se+"."+be+"."+De+_e+" <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+"."+De+_e+" <"+(+Se+1)+".0.0"):(l("no pr"),Ae=Se==="0"?be==="0"?">="+Se+"."+be+"."+De+" <"+Se+"."+be+"."+(+De+1):">="+Se+"."+be+"."+De+" <"+Se+"."+(+be+1)+".0":">="+Se+"."+be+"."+De+" <"+(+Se+1)+".0.0"),l("caret return",Ae),Ae})}(Fe,Oe)}).join(" ")}(Le,We),l("caret",Le),Le=function(Me,Oe){return Me.trim().split(/\s+/).map(function(Fe){return function(re,ue){var me=ue?R[V]:R[x];return re.replace(me,function(we,Se,be,De,_e){var Ae;return l("tilde",re,we,Se,be,De,_e),Ce(Se)?Ae="":Ce(be)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ce(De)?Ae=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0":_e?(l("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ae=">="+Se+"."+be+"."+De+_e+" <"+Se+"."+(+be+1)+".0"):Ae=">="+Se+"."+be+"."+De+" <"+Se+"."+(+be+1)+".0",l("tilde return",Ae),Ae})}(Fe,Oe)}).join(" ")}(Le,We),l("tildes",Le),Le=function(Me,Oe){return l("replaceXRanges",Me,Oe),Me.split(/\s+/).map(function(Fe){return function(re,ue){re=re.trim();var me=ue?R[S]:R[w];return re.replace(me,function(we,Se,be,De,_e,Ae){l("xRange",re,we,Se,be,De,_e,Ae);var Ue=Ce(be),xe=Ue||Ce(De),$e=xe||Ce(_e);return Se==="="&&$e&&(Se=""),Ue?we=Se===">"||Se==="<"?"<0.0.0":"*":Se&&$e?(xe&&(De=0),$e&&(_e=0),Se===">"?(Se=">=",xe?(be=+be+1,De=0,_e=0):$e&&(De=+De+1,_e=0)):Se==="<="&&(Se="<",xe?be=+be+1:De=+De+1),we=Se+be+"."+De+"."+_e):xe?we=">="+be+".0.0 <"+(+be+1)+".0.0":$e&&(we=">="+be+"."+De+".0 <"+be+"."+(+De+1)+".0"),l("xRange return",we),we})}(Fe,Oe)}).join(" ")}(Le,We),l("xrange",Le),Le=function(Me,Oe){return l("replaceStars",Me,Oe),Me.trim().replace(R[ne],"")}(Le,We),l("stars",Le),Le}(Ne,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ne){return!!Ne.match(Pe)})),Ie=Ie.map(function(Ne){return new pe(Ne,de)})},ye.prototype.intersects=function(le,de){if(!(le instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return le.set.some(function(Ie){return Ie.every(function(Ne){return Pe.intersects(Ne,de)})})})})},e.toComparators=function(le,de){return new ye(le,de).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new B(le,this.loose));for(var de=0;de<this.set.length;de++)if(ke(this.set[de],le))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(le,de,ge){var Pe=null,Ie=null;try{var Ne=new ye(de,ge)}catch{return null}return le.forEach(function(Le){Ne.test(Le)&&(Pe&&Ie.compare(Le)!==-1||(Ie=new B(Pe=Le,ge)))}),Pe},e.minSatisfying=function(le,de,ge){var Pe=null,Ie=null;try{var Ne=new ye(de,ge)}catch{return null}return le.forEach(function(Le){Ne.test(Le)&&(Pe&&Ie.compare(Le)!==1||(Ie=new B(Pe=Le,ge)))}),Pe},e.validRange=function(le,de){try{return new ye(le,de).range||"*"}catch{return null}},e.ltr=function(le,de,ge){return Ke(le,de,"<",ge)},e.gtr=function(le,de,ge){return Ke(le,de,">",ge)},e.outside=Ke,e.prerelease=function(le,de){var ge=H(le,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,de,ge){return le=new ye(le,ge),de=new ye(de,ge),le.intersects(de)},e.coerce=function(le){if(le instanceof B)return le;if(typeof le!="string")return null;var de=le.match(R[D]);return de==null?null:H((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,L(1))},function(ie,e){var L,O,l=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function R(c){if(L===setTimeout)return setTimeout(c,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{O=typeof clearTimeout=="function"?clearTimeout:_}catch{O=_}})();var P,y=[],I=!1,E=-1;function m(){I&&P&&(I=!1,P.length?y=P.concat(y):E=-1,y.length&&f())}function f(){if(!I){var c=R(m);I=!0;for(var d=y.length;d;){for(P=y,y=[];++E<d;)P&&P[E].run();E=-1,d=y.length}P=null,I=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===_||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(c)}}function p(c,d){this.fun=c,this.array=d}function b(){}l.nextTick=function(c){var d=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)d[u-1]=arguments[u];y.push(new p(c,d)),y.length!==1||I||R(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=b,l.addListener=b,l.once=b,l.off=b,l.removeListener=b,l.removeAllListeners=b,l.emit=b,l.prependListener=b,l.prependOnceListener=b,l.listeners=function(c){return[]},l.binding=function(c){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(c){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(oe[133],ae([0,1]),function(ie,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,P,y){this.level=R,this.key=P,this.value=y,this.forward=[]}}const l=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new O(this._maxLevel,l,l)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,l,l)}has(R){return Boolean(A._search(this,R,this.comparator))}get(R){return A._search(this,R,this.comparator)?.value}set(R,P){return A._insert(this,R,P,this.comparator)&&(this._size+=1),this}delete(R){const P=A._delete(this,R,this.comparator);return P&&(this._size-=1),P}forEach(R,P){let y=this._header.forward[0];for(;y;)R.call(P,y.value,y.key,this),y=y.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this._header.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static _search(R,P,y){let I=R._header;for(let E=R._level-1;E>=0;E--)for(;I.forward[E]&&y(I.forward[E].key,P)<0;)I=I.forward[E];if(I=I.forward[0],I&&y(I.key,P)===0)return I}static _insert(R,P,y,I){const E=[];let m=R._header;for(let f=R._level-1;f>=0;f--){for(;m.forward[f]&&I(m.forward[f].key,P)<0;)m=m.forward[f];E[f]=m}if(m=m.forward[0],m&&I(m.key,P)===0)return m.value=y,!1;{const f=A._randomLevel(R);if(f>R._level){for(let p=R._level;p<f;p++)E[p]=R._header;R._level=f}m=new O(f,P,y);for(let p=0;p<f;p++)m.forward[p]=E[p].forward[p],E[p].forward[p]=m;return!0}}static _randomLevel(R,P=.5){let y=1;for(;Math.random()<P&&y<R._maxLevel;)y+=1;return y}static _delete(R,P,y){const I=[];let E=R._header;for(let m=R._level-1;m>=0;m--){for(;E.forward[m]&&y(E.forward[m].key,P)<0;)E=E.forward[m];I[m]=E}if(E=E.forward[0],!E||y(E.key,P)!==0)return!1;for(let m=0;m<R._level&&I[m].forward[m]===E;m++)I[m].forward[m]=E.forward[m];for(;R._level>0&&R._header.forward[R._level-1]===l;)R._level-=1;return!0}}e.SkipList=A}),define(oe[43],ae([0,1,10,2]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(v){const k=v;return k?typeof k.read=="function":!1}e.isReadable=l;function A(v){const k=v;return k?[k.on,k.pause,k.resume,k.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=A;function _(v){const k=v;return k?A(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=_;function R(v,k){return new P(v,k)}e.newWriteableStream=R;class P{constructor(k,i){this.reducer=k,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(k){if(!this.state.destroyed){if(this.state.flowing)this.emitData(k);else if(this.buffer.data.push(k),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(k){this.state.destroyed||(this.state.flowing?this.emitError(k):this.buffer.error.push(k))}end(k){this.state.destroyed||(typeof k<"u"&&this.write(k),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(k){this.listeners.data.slice(0).forEach(i=>i(k))}emitError(k){this.listeners.error.length===0?(0,L.onUnexpectedError)(k):this.listeners.error.slice(0).forEach(i=>i(k))}emitEnd(){this.listeners.end.slice(0).forEach(k=>k())}on(k,i){if(!this.state.destroyed)switch(k){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(k,i){if(this.state.destroyed)return;let o;switch(k){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const k=this.reducer(this.buffer.data);this.emitData(k),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const k of this.buffer.error)this.emitError(k);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,k){const i=[];let o;for(;(o=v.read())!==null;)i.push(o);return k(i)}e.consumeReadable=y;function I(v,k,i){const o=[];let n;for(;(n=v.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?k(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return v.read()}}}e.peekReadable=I;function E(v,k){return new Promise((i,o)=>{const n=[];m(v,{onData:t=>{k&&n.push(t)},onError:t=>{k?o(t):i(void 0)},onEnd:()=>{i(k?k(n):void 0)}})})}e.consumeStream=E;function m(v,k){let i=!1;return v.on("error",o=>{i||k.onError(o)}),v.on("end",()=>{i||k.onEnd()}),v.on("data",o=>{i||k.onData(o)}),(0,O.toDisposable)(()=>i=!0)}e.listenStream=m;function f(v,k){return new Promise((i,o)=>{const n=new O.DisposableStore,t=[],r=h=>{if(t.push(h),t.length>k)return n.dispose(),v.pause(),i({stream:v,buffer:t,ended:!1})},s=h=>o(h),a=()=>i({stream:v,buffer:t,ended:!0});n.add((0,O.toDisposable)(()=>v.removeListener("error",s))),v.on("error",s),n.add((0,O.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),n.add((0,O.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=f;function p(v,k){const i=R(k);return i.end(v),i}e.toStream=p;function b(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=b;function c(v){let k=!1;return{read:()=>k?null:(k=!0,v)}}e.toReadable=c;function d(v,k,i){const o=R(i);return m(v,{onData:n=>o.write(k.data(n)),onError:n=>o.error(k.error?k.error(n):n),onEnd:()=>o.end()}),o}e.transform=d;function u(v,k,i){let o=!1;return{read:()=>{const n=k.read();return o?n:(o=!0,n!==null?i([v,n]):v)}}}e.prefixedReadable=u;function g(v,k,i){let o=!1;const n=R(i);return m(k,{onData:t=>o?n.write(t):(o=!0,n.write(i([v,t]))),onError:t=>n.error(t),onEnd:()=>{o||(o=!0,n.write(v)),n.end()}}),n}e.prefixedStream=g}),define(oe[16],ae([0,1,43]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let l,A;class _{static alloc(h){return O?new _(Buffer.allocUnsafe(h)):new _(new Uint8Array(h))}static wrap(h){return O&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new _(h)}static fromString(h,w){return!(w?.dontUseNodeBuffer||!1)&&O?new _(Buffer.from(h)):(l||(l=new TextEncoder),new _(l.encode(h)))}static fromByteArray(h){const w=_.alloc(h.length);for(let S=0,D=h.length;S<D;S++)w.buffer[S]=h[S];return w}static concat(h,w){if(typeof w>"u"){w=0;for(let T=0,M=h.length;T<M;T++)w+=h[T].byteLength}const S=_.alloc(w);let D=0;for(let T=0,M=h.length;T<M;T++){const x=h[T];S.set(x,D),D+=x.byteLength}return S}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=_.alloc(this.byteLength);return h.set(this),h}toString(){return O?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(h,w){return new _(this.buffer.subarray(h,w))}set(h,w){if(h instanceof _)this.buffer.set(h.buffer,w);else if(h instanceof Uint8Array)this.buffer.set(h,w);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),w);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return y(this.buffer,h)}writeUInt32BE(h,w){I(this.buffer,h,w)}readUInt32LE(h){return E(this.buffer,h)}writeUInt32LE(h,w){m(this.buffer,h,w)}readUInt8(h){return f(this.buffer,h)}writeUInt8(h,w){p(this.buffer,h,w)}}e.VSBuffer=_;function R(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=R;function P(a,h,w){a[w+0]=h&255,h=h>>>8,a[w+1]=h&255}e.writeUInt16LE=P;function y(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=y;function I(a,h,w){a[w+3]=h,h=h>>>8,a[w+2]=h,h=h>>>8,a[w+1]=h,h=h>>>8,a[w]=h}e.writeUInt32BE=I;function E(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=E;function m(a,h,w){a[w+0]=h&255,h=h>>>8,a[w+1]=h&255,h=h>>>8,a[w+2]=h&255,h=h>>>8,a[w+3]=h&255}e.writeUInt32LE=m;function f(a,h){return a[h]}e.readUInt8=f;function p(a,h,w){a[w]=h}e.writeUInt8=p;function b(a){return L.consumeReadable(a,h=>_.concat(h))}e.readableToBuffer=b;function c(a){return L.toReadable(a)}e.bufferToReadable=c;function d(a){return L.consumeStream(a,h=>_.concat(h))}e.streamToBuffer=d;async function u(a){return a.ended?_.concat(a.buffer):_.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=u;function g(a){return L.toStream(a,h=>_.concat(h))}e.bufferToStream=g;function v(a){return L.transform(a,{data:h=>typeof h=="string"?_.fromString(h):_.wrap(h)},h=>_.concat(h))}e.streamToBufferReadableStream=v;function k(a){return L.newWriteableStream(h=>_.concat(h),a)}e.newWriteableBufferStream=k;function i(a,h){return L.prefixedReadable(a,h,w=>_.concat(w))}e.prefixedBufferReadable=i;function o(a,h){return L.prefixedStream(a,h,w=>_.concat(w))}e.prefixedBufferStream=o;function n(a){let h=0,w=0,S=0;const D=new Uint8Array(Math.floor(a.length/4*3)),T=x=>{switch(w){case 3:D[S++]=h|x,w=0;break;case 2:D[S++]=h|x>>>2,h=x<<6,w=3;break;case 1:D[S++]=h|x>>>4,h=x<<4,w=2;break;default:h=x<<2,w=1}};for(let x=0;x<a.length;x++){const V=a.charCodeAt(x);if(V>=65&&V<=90)T(V-65);else if(V>=97&&V<=122)T(V-97+26);else if(V>=48&&V<=57)T(V-48+52);else if(V===43||V===45)T(62);else if(V===47||V===95)T(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${a[x]}`)}}const M=S;for(;w>0;)T(0);return _.wrap(D).slice(0,M)}e.decodeBase64=n;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},h=!0,w=!1){const S=w?r:t;let D="";const T=a.byteLength%3;let M=0;for(;M<a.byteLength-T;M+=3){const x=a[M+0],V=a[M+1],q=a[M+2];D+=S[x>>>2],D+=S[(x<<4|V>>>4)&63],D+=S[(V<<2|q>>>6)&63],D+=S[q&63]}if(T===1){const x=a[M+0];D+=S[x>>>2],D+=S[x<<4&63],h&&(D+="==")}else if(T===2){const x=a[M+0],V=a[M+1];D+=S[x>>>2],D+=S[(x<<4|V>>>4)&63],D+=S[V<<2&63],h&&(D+="=")}return D}e.encodeBase64=s}),define(oe[134],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[11],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function O(o){return Array.isArray(o)&&o.every(n=>L(n))}e.isStringArray=O;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function A(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=A;function _(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=_;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=R;function P(o){return o===!0||o===!1}e.isBoolean=P;function y(o){return typeof o>"u"}e.isUndefined=y;function I(o){return!E(o)}e.isDefined=I;function E(o){return y(o)||o===null}e.isUndefinedOrNull=E;function m(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=m;function f(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function p(...o){const n=[];for(let t=0;t<o.length;t++){const r=o[t];if(E(r))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);n.push(r)}return n}e.assertAllDefined=p;const b=Object.prototype.hasOwnProperty;function c(o){if(!l(o))return!1;for(const n in o)if(b.call(o,n))return!1;return!0}e.isEmptyObject=c;function d(o){return typeof o=="function"}e.isFunction=d;function u(...o){return o.length>0&&o.every(d)}e.areFunctions=u;function g(o,n){const t=Math.min(o.length,n.length);for(let r=0;r<t;r++)v(o[r],n[r])}e.validateConstraints=g;function v(o,n){if(L(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(d(n)){try{if(o instanceof n)return}catch{}if(!E(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function k(o){return o===null?void 0:o}e.withNullAsUndefined=k;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(oe[52],ae([0,1,11]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function l(R,P){if((0,L.isString)(P)){const y=O[P];if(y===void 0)throw new Error(`${R} references an unknown codicon: ${P}`);P=y}return O[R]=P,{id:R}}function A(){return O}e.getCodiconFontCharacters=A;function _(){return Object.values(e.Codicon)}e.getAllCodicons=_,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(oe[32],ae([0,1,11]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const u=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([g,v])=>{u[g]=v&&typeof v=="object"?O(v):v}),u}e.deepClone=O;function l(d){if(!d||typeof d!="object")return d;const u=[d];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const v in g)if(A.call(g,v)){const k=g[v];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.isTypedArray)(k)&&u.push(k)}}return d}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function _(d,u){return R(d,u,new Set)}e.cloneAndChange=_;function R(d,u,g){if((0,L.isUndefinedOrNull)(d))return d;const v=u(d);if(typeof v<"u")return v;if(Array.isArray(d)){const k=[];for(const i of d)k.push(R(i,u,g));return k}if((0,L.isObject)(d)){if(g.has(d))throw new Error("Cannot clone recursive data-structure");g.add(d);const k={};for(const i in d)A.call(d,i)&&(k[i]=R(d[i],u,g));return g.delete(d),k}return d}function P(d,u,g=!0){return(0,L.isObject)(d)?((0,L.isObject)(u)&&Object.keys(u).forEach(v=>{v in d?g&&((0,L.isObject)(d[v])&&(0,L.isObject)(u[v])?P(d[v],u[v],g):d[v]=u[v]):d[v]=u[v]}),d):u}e.mixin=P;function y(d,u){if(d===u)return!0;if(d==null||u===null||u===void 0||typeof d!=typeof u||typeof d!="object"||Array.isArray(d)!==Array.isArray(u))return!1;let g,v;if(Array.isArray(d)){if(d.length!==u.length)return!1;for(g=0;g<d.length;g++)if(!y(d[g],u[g]))return!1}else{const k=[];for(v in d)k.push(v);k.sort();const i=[];for(v in u)i.push(v);if(i.sort(),!y(k,i))return!1;for(g=0;g<k.length;g++)if(!y(d[k[g]],u[k[g]]))return!1}return!0}e.equals=y;function I(d){const u=new Set;return JSON.stringify(d,(g,v)=>{if((0,L.isObject)(v)||Array.isArray(v)){if(u.has(v))return"[Circular]";u.add(v)}return v})}e.safeStringify=I;function E(d,u){const g=Object.create(null);return!d||!u||Object.keys(u).forEach(k=>{const i=d[k],o=u[k];y(i,o)||(g[k]=o)}),g}e.distinct=E;function m(d,u){const g=u.toLowerCase(),v=Object.keys(d).find(k=>k.toLowerCase()===g);return v?d[v]:d[u]}e.getCaseInsensitive=m;function f(d,u){const g=Object.create(null);for(const[v,k]of Object.entries(d))u(v,k)&&(g[v]=k);return g}e.filter=f;function p(d){let u=[],g=Object.getPrototypeOf(d);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.getAllPropertyNames=p;function b(d){const u=[];for(const g of p(d))typeof d[g]=="function"&&u.push(g);return u}e.getAllMethodNames=b;function c(d,u){const g=k=>function(){const i=Array.prototype.slice.call(arguments,0);return u(k,i)},v={};for(const k of d)v[k]=g(k);return v}e.createProxyObject=c}),define(oe[135],ae([0,1,52]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(_){function R(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=R})(O=e.ThemeColor||(e.ThemeColor={}));function l(_){return{id:_}}e.themeColorFromId=l;var A;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function P(u){const g=R.exec(u.id);if(!g)return P(L.Codicon.error);const[,v,k]=g,i=["codicon","codicon-"+v];return k&&i.push("codicon-modifier-"+k.substring(1)),i}_.asClassNameArray=P;function y(u){return P(u).join(" ")}_.asClassName=y;function I(u){return"."+P(u).join(".")}_.asCSSSelector=I;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||O.isThemeColor(u.color))}_.isThemeIcon=E;const m=new RegExp(`^\\$\\((${_.iconNameExpression}(?:${_.iconModifierExpression})?)\\)$`);function f(u){const g=m.exec(u);if(!g)return;const[,v]=g;return{id:v}}_.fromString=f;function p(u){return{id:u}}_.fromId=p;function b(u,g){let v=u.id;const k=v.lastIndexOf("~");return k!==-1&&(v=v.substring(0,k)),g&&(v=`${v}~${g}`),{id:v}}_.modify=b;function c(u){const g=u.id.lastIndexOf("~");if(g!==-1)return u.id.substring(g+1)}_.getModifier=c;function d(u,g){return u.id===g.id&&u.color?.id===g.color?.id}_.isEqual=d})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(oe[31],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(l){return L.test(l)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),_=[];for(let R=0;R<256;R++)_.push(R.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,y="";return y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y+="-",y+=_[A[P++]],y+=_[A[P++]],y+="-",y+=_[A[P++]],y+=_[A[P++]],y+="-",y+=_[A[P++]],y+=_[A[P++]],y+="-",y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y+=_[A[P++]],y}}()}),define(oe[136],ae([0,1,34]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(_){const R=_.replace(/\-/g,":").toLowerCase();return!O.has(R)}function A(){const _=(0,L.networkInterfaces)();for(const R in _){const P=_[R];if(P){for(const{mac:y}of P)if(l(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[137],ae([0,1,86]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,P,y,I=1){let E=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!E)return E=!0,m(0)},y);l(R,P,I,p=>{if(!E)return E=!0,clearTimeout(f),m(p)})})}e.findFreePort=O;function l(R,P,y,I){if(P===0)return I(0);const E=new L.Socket;E.once("connect",()=>(_(E),l(R+y,P-1,y,I))),E.once("data",()=>{}),E.once("error",m=>(_(E),m.code!=="ECONNREFUSED"?l(R+y,P-1,y,I):I(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,y,I="127.0.0.1"){let E=!1,m,f=1;const p=L.createServer({pauseOnConnect:!0});function b(c,d){E||(E=!0,p.removeAllListeners(),p.close(),m&&clearTimeout(m),d(c))}return new Promise(c=>{m=setTimeout(()=>{b(0,c)},y),p.on("listening",()=>{b(R,c)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<P?(R++,f++,p.listen(R,I)):b(0,c)}),p.on("close",()=>{b(0,c)}),p.listen(R,I)})}e.findFreePortFaster=A;function _(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(oe[87],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(O){return!!O.parentPort}e.isUtilityProcess=L}),define(oe[138],ae([8,7]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(oe[64],ae([0,1,138]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,l=O*60,A=l*24,_=A*7,R=A*30,P=A*365;function y(E,m,f,p){typeof E!="number"&&(E=E.getTime());const b=Math.round((new Date().getTime()-E)/1e3);if(b<-30)return(0,L.localize)(0,null,y(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,L.localize)(1,null);let c;return b<O?(c=b,m?c===1?f?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):f?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?f?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):f?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):b<l?(c=Math.floor(b/O),m?c===1?f?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):f?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?f?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):f?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):b<A?(c=Math.floor(b/l),m?c===1?f?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):f?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?f?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):f?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):b<_?(c=Math.floor(b/A),m?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):b<R?(c=Math.floor(b/_),m?c===1?f?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):f?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?f?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):f?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):b<P?(c=Math.floor(b/R),m?c===1?f?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):f?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?f?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):f?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(b/P),m?c===1?f?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):f?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?f?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):f?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=y;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(oe[139],ae([8,7]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,139]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,m){return m&&(E.stack||E.stacktrace)?l.localize(0,null,R(E),_(E.stack)||_(E.stacktrace)):R(E)}function _(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?l.localize(1,null,E.message):E.message||l.localize(2,null)}function P(E=null,m=!1){if(!E)return l.localize(3,null);if(Array.isArray(E)){const f=L.coalesce(E),p=P(f[0],m);return f.length>1?l.localize(4,null,p,f.length):p}if(O.isString(E))return E;if(E.detail){const f=E.detail;if(f.error)return A(f.error,m);if(f.exception)return A(f.exception,m)}return E.stack?A(E,m):E.message?E.message:l.localize(5,null)}e.toErrorMessage=P;function y(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=y;function I(E,m){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=m,f}e.createErrorWithActions=I}),define(oe[140],ae([8,7]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(oe[141],ae([0,1,140]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(l){switch(l){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(oe[142],ae([8,7]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,142]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,l=!1,A=!1,_=!1,R=!1,P=!1,y=!1,I=!1,E=!1,m=!1,f,p=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,c,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",v=g&&u?.type==="renderer";if(typeof navigator=="object"&&!v)d=navigator.userAgent,O=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,I=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,m=d?.indexOf("Mobi")>=0,P=!0,f=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,p=f,b=navigator.language;else if(typeof u=="object"){O=u.platform==="win32",l=u.platform==="darwin",A=u.platform==="linux",_=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,y=g,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const h=u.env.VSCODE_NLS_CONFIG;if(h)try{const w=JSON.parse(h),S=w.availableLanguages["*"];f=w.locale,b=w.osLocale,p=S||e.LANGUAGE_DEFAULT,c=w._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var k;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(k=e.Platform||(e.Platform={}));function i(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let o=0;l?o=1:O?o=3:A&&(o=2),e.isWindows=O,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=_,e.isNative=R,e.isElectron=y,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=m,e.isCI=E,e.platform=o,e.userAgent=d,e.language=p;var n;(function(h){function w(){return e.language}h.value=w;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=S;function D(){return e.language==="en"}h.isDefault=D})(n=e.Language||(e.Language={})),e.locale=f,e.platformLocale=b,e.translationsConfigFile=c,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let D=0,T=h.length;D<T;D++){const M=h[D];if(M.id===S.data.vscodeScheduleAsyncWork){h.splice(D,1),M.callback();return}}});let w=0;return S=>{const D=++w;h.push({id:D,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:D},"*")}}return h=>setTimeout(h)})();var t;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||I?2:O?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,r=new Uint16Array(h.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const l=L.globals.vscode.process;O={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(oe[14],ae([0,1,36]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,l=97,A=90,_=122,R=46,P=47,y=92,I=58,E=63;class m extends Error{constructor(o,n,t){let r;typeof n=="string"&&n.indexOf("not ")===0?(r="must not be",n=n.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${s} ${r} of type ${n}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function p(i,o){if(typeof i!="string")throw new m(o,"string",i)}const b=L.platform==="win32";function c(i){return i===P||i===y}function d(i){return i===P}function u(i){return i>=O&&i<=A||i>=l&&i<=_}function g(i,o,n,t){let r="",s=0,a=-1,h=0,w=0;for(let S=0;S<=i.length;++S){if(S<i.length)w=i.charCodeAt(S);else{if(t(w))break;w=P}if(t(w)){if(!(a===S-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const D=r.lastIndexOf(n);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(n)),a=S,h=0;continue}else if(r.length!==0){r="",s=0,a=S,h=0;continue}}o&&(r+=r.length>0?`${n}..`:"..",s=2)}else r.length>0?r+=`${n}${i.slice(a+1,S)}`:r=i.slice(a+1,S),s=S-a-1;a=S,h=0}else w===R&&h!==-1?++h:h=-1}return r}function v(i,o){f(o,"pathObject");const n=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${t}`:`${n}${i}${t}`:t}e.win32={resolve(...i){let o="",n="",t=!1;for(let r=i.length-1;r>=-1;r--){let s;if(r>=0){if(s=i[r],p(s,"path"),s.length===0)continue}else o.length===0?s=L.cwd():(s=L.env[`=${o}`]||L.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${o}\\`));const a=s.length;let h=0,w="",S=!1;const D=s.charCodeAt(0);if(a===1)c(D)&&(h=1,S=!0);else if(c(D))if(S=!0,c(s.charCodeAt(1))){let T=2,M=T;for(;T<a&&!c(s.charCodeAt(T));)T++;if(T<a&&T!==M){const x=s.slice(M,T);for(M=T;T<a&&c(s.charCodeAt(T));)T++;if(T<a&&T!==M){for(M=T;T<a&&!c(s.charCodeAt(T));)T++;(T===a||T!==M)&&(w=`\\\\${x}\\${s.slice(M,T)}`,h=T)}}}else h=1;else u(D)&&s.charCodeAt(1)===I&&(w=s.slice(0,2),h=2,a>2&&c(s.charCodeAt(2))&&(S=!0,h=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(t){if(o.length>0)break}else if(n=`${s.slice(h)}\\${n}`,t=S,S&&o.length>0)break}return n=g(n,!t,"\\",c),t?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){p(i,"path");const o=i.length;if(o===0)return".";let n=0,t,r=!1;const s=i.charCodeAt(0);if(o===1)return d(s)?"\\":i;if(c(s))if(r=!0,c(i.charCodeAt(1))){let h=2,w=h;for(;h<o&&!c(i.charCodeAt(h));)h++;if(h<o&&h!==w){const S=i.slice(w,h);for(w=h;h<o&&c(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!c(i.charCodeAt(h));)h++;if(h===o)return`\\\\${S}\\${i.slice(w)}\\`;h!==w&&(t=`\\\\${S}\\${i.slice(w,h)}`,n=h)}}}else n=1;else u(s)&&i.charCodeAt(1)===I&&(t=i.slice(0,2),n=2,o>2&&c(i.charCodeAt(2))&&(r=!0,n=3));let a=n<o?g(i.slice(n),!r,"\\",c):"";return a.length===0&&!r&&(a="."),a.length>0&&c(i.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(i){p(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return c(n)||o>2&&u(n)&&i.charCodeAt(1)===I&&c(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let s=0;s<i.length;++s){const a=i[s];p(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof n=="string"&&c(n.charCodeAt(0))){++r;const s=n.length;s>1&&c(n.charCodeAt(1))&&(++r,s>2&&(c(n.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&c(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(i,o){if(p(i,"from"),p(o,"to"),i===o)return"";const n=e.win32.resolve(i),t=e.win32.resolve(o);if(n===t||(i=n.toLowerCase(),o=t.toLowerCase(),i===o))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===y;)r++;let s=i.length;for(;s-1>r&&i.charCodeAt(s-1)===y;)s--;const a=s-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===y;)h++;let w=o.length;for(;w-1>h&&o.charCodeAt(w-1)===y;)w--;const S=w-h,D=a<S?a:S;let T=-1,M=0;for(;M<D;M++){const V=i.charCodeAt(r+M);if(V!==o.charCodeAt(h+M))break;V===y&&(T=M)}if(M!==D){if(T===-1)return t}else{if(S>D){if(o.charCodeAt(h+M)===y)return t.slice(h+M+1);if(M===2)return t.slice(h+M)}a>D&&(i.charCodeAt(r+M)===y?T=M:M===2&&(T=3)),T===-1&&(T=0)}let x="";for(M=r+T+1;M<=s;++M)(M===s||i.charCodeAt(M)===y)&&(x+=x.length===0?"..":"\\..");return h+=T,x.length>0?`${x}${t.slice(h,w)}`:(t.charCodeAt(h)===y&&++h,t.slice(h,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const n=o.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return i},dirname(i){p(i,"path");const o=i.length;if(o===0)return".";let n=-1,t=0;const r=i.charCodeAt(0);if(o===1)return c(r)?i:".";if(c(r)){if(n=t=1,c(i.charCodeAt(1))){let h=2,w=h;for(;h<o&&!c(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&c(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!c(i.charCodeAt(h));)h++;if(h===o)return i;h!==w&&(n=t=h+1)}}}}else u(r)&&i.charCodeAt(1)===I&&(n=o>2&&c(i.charCodeAt(2))?3:2,t=n);let s=-1,a=!0;for(let h=o-1;h>=t;--h)if(c(i.charCodeAt(h))){if(!a){s=h;break}}else a=!1;if(s===-1){if(n===-1)return".";s=n}return i.slice(0,s)},basename(i,o){o!==void 0&&p(o,"ext"),p(i,"path");let n=0,t=-1,r=!0,s;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,h=-1;for(s=i.length-1;s>=n;--s){const w=i.charCodeAt(s);if(c(w)){if(!r){n=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(t=s):(a=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(s=i.length-1;s>=n;--s)if(c(i.charCodeAt(s))){if(!r){n=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":i.slice(n,t)},extname(i){p(i,"path");let o=0,n=-1,t=0,r=-1,s=!0,a=0;i.length>=2&&i.charCodeAt(1)===I&&u(i.charCodeAt(0))&&(o=t=2);for(let h=i.length-1;h>=o;--h){const w=i.charCodeAt(h);if(c(w)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),w===R?n===-1?n=h:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||r===-1||a===0||a===1&&n===r-1&&n===t+1?"":i.slice(n,r)},format:v.bind(null,"\\"),parse(i){p(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let t=0,r=i.charCodeAt(0);if(n===1)return c(r)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(c(r)){if(t=1,c(i.charCodeAt(1))){let T=2,M=T;for(;T<n&&!c(i.charCodeAt(T));)T++;if(T<n&&T!==M){for(M=T;T<n&&c(i.charCodeAt(T));)T++;if(T<n&&T!==M){for(M=T;T<n&&!c(i.charCodeAt(T));)T++;T===n?t=T:T!==M&&(t=T+1)}}}}else if(u(r)&&i.charCodeAt(1)===I){if(n<=2)return o.root=o.dir=i,o;if(t=2,c(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let s=-1,a=t,h=-1,w=!0,S=i.length-1,D=0;for(;S>=t;--S){if(r=i.charCodeAt(S),c(r)){if(!w){a=S+1;break}continue}h===-1&&(w=!1,h=S+1),r===R?s===-1?s=S:D!==1&&(D=1):s!==-1&&(D=-1)}return h!==-1&&(s===-1||D===0||D===1&&s===h-1&&s===a+1?o.base=o.name=i.slice(a,h):(o.name=i.slice(a,s),o.base=i.slice(a,h),o.ext=i.slice(s,h))),a>0&&a!==t?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(b){const i=/\\/g;return()=>{const o=L.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let o="",n=!1;for(let t=i.length-1;t>=-1&&!n;t--){const r=t>=0?i[t]:k();p(r,"path"),r.length!==0&&(o=`${r}/${o}`,n=r.charCodeAt(0)===P)}return o=g(o,!n,"/",d),n?`/${o}`:o.length>0?o:"."},normalize(i){if(p(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=g(i,!o,"/",d),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return p(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const t=i[n];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(p(i,"from"),p(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const n=1,t=i.length,r=t-n,s=1,a=o.length-s,h=r<a?r:a;let w=-1,S=0;for(;S<h;S++){const T=i.charCodeAt(n+S);if(T!==o.charCodeAt(s+S))break;T===P&&(w=S)}if(S===h)if(a>h){if(o.charCodeAt(s+S)===P)return o.slice(s+S+1);if(S===0)return o.slice(s+S)}else r>h&&(i.charCodeAt(n+S)===P?w=S:S===0&&(w=0));let D="";for(S=n+w+1;S<=t;++S)(S===t||i.charCodeAt(S)===P)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(s+w)}`},toNamespacedPath(i){return i},dirname(i){if(p(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,t=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===P){if(!t){n=r;break}}else t=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&p(o,"ext"),p(i,"path");let n=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,h=-1;for(s=i.length-1;s>=0;--s){const w=i.charCodeAt(s);if(w===P){if(!r){n=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(t=s):(a=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(s=i.length-1;s>=0;--s)if(i.charCodeAt(s)===P){if(!r){n=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":i.slice(n,t)},extname(i){p(i,"path");let o=-1,n=0,t=-1,r=!0,s=0;for(let a=i.length-1;a>=0;--a){const h=i.charCodeAt(a);if(h===P){if(!r){n=a+1;break}continue}t===-1&&(r=!1,t=a+1),h===R?o===-1?o=a:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===n+1?"":i.slice(o,t)},format:v.bind(null,"/"),parse(i){p(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let t;n?(o.root="/",t=1):t=0;let r=-1,s=0,a=-1,h=!0,w=i.length-1,S=0;for(;w>=t;--w){const D=i.charCodeAt(w);if(D===P){if(!h){s=w+1;break}continue}a===-1&&(h=!1,a=w+1),D===R?r===-1?r=w:S!==1&&(S=1):r!==-1&&(S=-1)}if(a!==-1){const D=s===0&&n?1:s;r===-1||S===0||S===1&&r===a-1&&r===s+1?o.base=o.name=i.slice(D,a):(o.name=i.slice(D,r),o.base=i.slice(D,a),o.ext=i.slice(r,a))}return s>0?o.dir=i.slice(0,s-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(oe[143],ae([0,1,14]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const E=(0,L.extname)(I),m=O[E.toLowerCase()];return m!==void 0?m:_(I)}e.getMediaOrTextMime=A;function _(I){const E=(0,L.extname)(I);return l[E.toLowerCase()]}e.getMediaMime=_;function R(I){for(const E in l)if(l[E]===I)return E}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function y(I,E){const m=P.exec(I);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:I}e.normalizeMimeType=y}),define(oe[88],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...P){const y=P.reduce((m,f)=>(m[f]=!0,m),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!y[m]).forEach(m=>{for(let f=0;f<I.length;f++)if(m.search(I[f])!==-1){delete R[m];break}})}e.sanitizeProcessEnvironment=A;function _(R){!R||(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(oe[89],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=L.globals.performance&&typeof L.globals.performance.now=="function";class l{static create(_=!0){return new l(_)}constructor(_){this._highResolution=O&&_,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=l}),define(oe[3],ae([0,1,10,82,2,84,89]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var y;(function(s){s.None=()=>l.Disposable.None;function a(U){if(P){const{onDidAddListener:$}=U,G=p.create();let W=0;U.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),$?.()}}}function h(U,$){return z(U,()=>{},0,void 0,!0,void 0,$)}s.defer=h;function w(U){return($,G=null,W)=>{let Z=!1,te;return te=U(ce=>{if(!Z)return te?te.dispose():Z=!0,$.call(G,ce)},null,W),Z&&te.dispose(),te}}s.once=w;function S(U,$,G){return q((W,Z=null,te)=>U(ce=>W.call(Z,$(ce)),null,te),G)}s.map=S;function D(U,$,G){return q((W,Z=null,te)=>U(ce=>{$(ce),W.call(Z,ce)},null,te),G)}s.forEach=D;function T(U,$,G){return q((W,Z=null,te)=>U(ce=>$(ce)&&W.call(Z,ce),null,te),G)}s.filter=T;function M(U){return U}s.signal=M;function x(...U){return($,G=null,W)=>(0,l.combinedDisposable)(...U.map(Z=>Z(te=>$.call(G,te),null,W)))}s.any=x;function V(U,$,G,W){let Z=G;return S(U,te=>(Z=$(Z,te),Z),W)}s.reduce=V;function q(U,$){let G;const W={onWillAddFirstListener(){G=U(Z.fire,Z)},onDidRemoveLastListener(){G?.dispose()}};$||a(W);const Z=new c(W);return $?.add(Z),Z.event}function z(U,$,G=100,W=!1,Z=!1,te,ce){let he,pe,fe,ye=0,Ce;const Re={leakWarningThreshold:te,onWillAddFirstListener(){he=U(ze=>{ye++,pe=$(pe,ze),W&&!fe&&(ke.fire(pe),pe=void 0),Ce=()=>{const Ke=pe;pe=void 0,fe=void 0,(!W||ye>1)&&ke.fire(Ke),ye=0},typeof G=="number"?(clearTimeout(fe),fe=setTimeout(Ce,G)):fe===void 0&&(fe=0,queueMicrotask(Ce))})},onWillRemoveListener(){Z&&ye>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};ce||a(Re);const ke=new c(Re);return ce?.add(ke),ke.event}s.debounce=z;function J(U,$=0,G){return s.debounce(U,(W,Z)=>W?(W.push(Z),W):[Z],$,void 0,!0,void 0,G)}s.accumulate=J;function Q(U,$=(W,Z)=>W===Z,G){let W=!0,Z;return T(U,te=>{const ce=W||!$(te,Z);return W=!1,Z=te,ce},G)}s.latch=Q;function K(U,$,G){return[s.filter(U,$,G),s.filter(U,W=>!$(W),G)]}s.split=K;function X(U,$=!1,G=[]){let W=G.slice(),Z=U(he=>{W?W.push(he):ce.fire(he)});const te=()=>{W?.forEach(he=>ce.fire(he)),W=null},ce=new c({onWillAddFirstListener(){Z||(Z=U(he=>ce.fire(he)))},onDidAddFirstListener(){W&&($?setTimeout(te):te())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return ce.event}s.buffer=X;class j{constructor($){this.event=$,this.disposables=new l.DisposableStore}map($){return new j(S(this.event,$,this.disposables))}forEach($){return new j(D(this.event,$,this.disposables))}filter($){return new j(T(this.event,$,this.disposables))}reduce($,G){return new j(V(this.event,$,G,this.disposables))}latch(){return new j(Q(this.event,void 0,this.disposables))}debounce($,G=100,W=!1,Z=!1,te){return new j(z(this.event,$,G,W,Z,te,this.disposables))}on($,G,W){return this.event($,G,W)}once($,G,W){return w(this.event)($,G,W)}dispose(){this.disposables.dispose()}}function F(U){return new j(U)}s.chain=F;function ee(U,$,G=W=>W){const W=(...he)=>ce.fire(G(...he)),Z=()=>U.on($,W),te=()=>U.removeListener($,W),ce=new c({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ce.event}s.fromNodeEventEmitter=ee;function ne(U,$,G=W=>W){const W=(...he)=>ce.fire(G(...he)),Z=()=>U.addEventListener($,W),te=()=>U.removeEventListener($,W),ce=new c({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ce.event}s.fromDOMEventEmitter=ne;function se(U){return new Promise($=>w(U)($))}s.toPromise=se;function H(U,$){return $(void 0),U(G=>$(G))}s.runAndSubscribe=H;function B(U,$){let G=null;function W(te){G?.dispose(),G=new l.DisposableStore,$(te,G)}W(void 0);const Z=U(te=>W(te));return(0,l.toDisposable)(()=>{Z.dispose(),G?.dispose()})}s.runAndSubscribeWithStore=B;class N{constructor($,G){this.obs=$,this._counter=0,this._hasChanged=!1;const W={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};G||a(W),this.emitter=new c(W),G&&G.add(this.emitter)}beginUpdate($){this._counter++}handleChange($,G){this._hasChanged=!0}endUpdate($){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function C(U,$){return new N(U,$).emitter.event}s.fromObservable=C})(y=e.Event||(e.Event={}));class I{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${I._idPool++}`,I.all.add(this)}start(a){this._stopWatch=new _.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}I.all=new Set,I._idPool=0,e.EventProfiling=I;let E=-1;function m(s){const a=E;return E=s,{dispose(){E=a}}}e.setGlobalLeakWarningThreshold=m;class f{constructor(a,h=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,h){const w=this.threshold;if(w<=0||h<w)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let D,T=0;for(const[M,x]of this._stacks)(!D||T<x)&&(D=M,T=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${T}):`),console.warn(D)}return()=>{const D=this._stacks.get(a.value)||0;this._stacks.set(a.value,D-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(a,h,w){this.callback=a,this.callbackThis=h,this.stack=w,this.subscription=new l.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class c{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=E>0||this._options?.leakWarningThreshold?new f(this._options?.leakWarningThreshold??E):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(R){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,h,w)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const S=this._listeners.isEmpty();S&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let D,T;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(T=p.create(),D=this._leakageMon.check(T,this._listeners.size+1)),R&&(T=T??p.create());const M=new b(a,h,T),x=this._listeners.push(M);S&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,a,h);const V=M.subscription.set(()=>{D?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),x(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return w instanceof l.DisposableStore?w.add(V):Array.isArray(w)&&w.push(V),V}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u(this._options?.onListenerError));for(const h of this._listeners)this._deliveryQueue.push(this,h,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=c;class d{constructor(a=L.onUnexpectedError){this._onListenerError=a,this._queue=new A.LinkedList}get size(){return this._queue.size}push(a,h,w){this._queue.push(new g(a,h,w))}clear(a){const h=new A.LinkedList;for(const w of this._queue)w.emitter!==a&&h.push(w);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){this._onListenerError(h)}}}}e.EventDeliveryQueue=d;class u extends d{clear(a){this._queue.clear()}}class g{constructor(a,h,w){this.emitter=a,this.listener=h,this.event=w}}class v extends c{async fireAsync(a,h,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,a]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[S,D]=this._asyncDeliveryQueue.shift(),T=[],M={...D,token:h,waitUntil:x=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");w&&(x=w(x,S.callback)),T.push(x)}};try{S.invoke(M)}catch(x){(0,L.onUnexpectedError)(x);continue}Object.freeze(T),await Promise.allSettled(T).then(x=>{for(const V of x)V.status==="rejected"&&(0,L.onUnexpectedError)(V.reason)})}}}}e.AsyncEmitter=v;class k extends c{constructor(a){super(a),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=k;class i extends k{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=i;class o extends c{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const h={event:a,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const w=()=>{this.hasListeners&&this.unhook(h);const S=this.events.indexOf(h);this.events.splice(S,1)};return(0,l.toDisposable)((0,O.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(h=>this.emitter.fire(h))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class t{constructor(){this.buffers=[]}wrapEvent(a){return(h,w,S)=>a(D=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>h.call(w,D)):h.call(w,D)},void 0,S)}bufferEvents(a){const h=[];this.buffers.push(h);const w=a();return this.buffers.pop(),h.forEach(S=>S()),w}}e.EventBufferer=t;class r{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=l.Disposable.None,this.emitter=new c({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(oe[25],ae([0,1,3]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,P){const y=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(y)}}});var l;(function(R){function P(y){return y===R.None||y===R.Cancelled||y instanceof A?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(l=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=l.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=_}),define(oe[144],ae([0,1,25]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new L.CancellationTokenSource,P=this.task(R.token);return this.result={promise:P,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=O;class l{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const P=JSON.stringify(R);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=l;class A{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const P=this.fn(R);return this._map.set(R,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,144,131]),function(ie,e,L,O){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=A;const _=/{(\d+)}/g;function R(re,...ue){return ue.length===0?re:re.replace(_,function(me,we){const Se=parseInt(we,10);return isNaN(Se)||Se<0||Se>=ue.length?me:ue[Se]})}e.format=R;const P=/{([^}]+)}/g;function y(re,ue){return re.replace(P,(me,we)=>ue[we]??me)}e.format2=y;function I(re){return re.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function E(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function m(re,ue){let me=0;const we=ue.charCodeAt(0);for(let Se=re.length-1;Se>=0;Se--)re.charCodeAt(Se)===we&&me++;return me}e.count=m;function f(re,ue,me="\u2026"){return re.length<=ue?re:`${re.substr(0,ue)}${me}`}e.truncate=f;function p(re,ue=" "){const me=b(re,ue);return c(me,ue)}e.trim=p;function b(re,ue){if(!re||!ue)return re;const me=ue.length;if(me===0||re.length===0)return re;let we=0;for(;re.indexOf(ue,we)===we;)we=we+me;return re.substring(we)}e.ltrim=b;function c(re,ue){if(!re||!ue)return re;const me=ue.length,we=re.length;if(me===0||we===0)return re;let Se=we,be=-1;for(;be=re.lastIndexOf(ue,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return re.substring(0,Se)}e.rtrim=c;function d(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function u(re){return re.replace(/\*/g,"")}e.stripWildcards=u;function g(re,ue,me={}){if(!re)throw new Error("Cannot create regex from empty string");ue||(re=E(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let we="";return me.global&&(we+="g"),me.matchCase||(we+="i"),me.multiline&&(we+="m"),me.unicode&&(we+="u"),new RegExp(re,we)}e.createRegExp=g;function v(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function k(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function i(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=i;function o(re){return re.split(/\r\n|\r|\n/)}e.splitLines=o;function n(re){for(let ue=0,me=re.length;ue<me;ue++){const we=re.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=n;function t(re,ue=0,me=re.length){for(let we=ue;we<me;we++){const Se=re.charCodeAt(we);if(Se!==32&&Se!==9)return re.substring(ue,we)}return re.substring(ue,me)}e.getLeadingWhitespace=t;function r(re,ue=re.length-1){for(let me=ue;me>=0;me--){const we=re.charCodeAt(me);if(we!==32&&we!==9)return me}return-1}e.lastNonWhitespaceIndex=r;function s(re,ue,me){const we=[];let Se=0;for(const be of re.matchAll(ue)){if(we.push(re.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,we.push(me(be[0],...be.slice(1),be.index,re,be.groups))}return we.push(re.slice(Se)),Promise.all(we).then(be=>be.join(""))}e.replaceAsync=s;function a(re,ue){return re<ue?-1:re>ue?1:0}e.compare=a;function h(re,ue,me=0,we=re.length,Se=0,be=ue.length){for(;me<we&&Se<be;me++,Se++){const Ae=re.charCodeAt(me),Ue=ue.charCodeAt(Se);if(Ae<Ue)return-1;if(Ae>Ue)return 1}const De=we-me,_e=be-Se;return De<_e?-1:De>_e?1:0}e.compareSubstring=h;function w(re,ue){return S(re,ue,0,re.length,0,ue.length)}e.compareIgnoreCase=w;function S(re,ue,me=0,we=re.length,Se=0,be=ue.length){for(;me<we&&Se<be;me++,Se++){let Ae=re.charCodeAt(me),Ue=ue.charCodeAt(Se);if(Ae===Ue)continue;if(Ae>=128||Ue>=128)return h(re.toLowerCase(),ue.toLowerCase(),me,we,Se,be);T(Ae)&&(Ae-=32),T(Ue)&&(Ue-=32);const xe=Ae-Ue;if(xe!==0)return xe}const De=we-me,_e=be-Se;return De<_e?-1:De>_e?1:0}e.compareSubstringIgnoreCase=S;function D(re){return re>=48&&re<=57}e.isAsciiDigit=D;function T(re){return re>=97&&re<=122}e.isLowerAsciiLetter=T;function M(re){return re>=65&&re<=90}e.isUpperAsciiLetter=M;function x(re,ue){return re.length===ue.length&&S(re,ue)===0}e.equalsIgnoreCase=x;function V(re,ue){const me=ue.length;return ue.length>re.length?!1:S(re,ue,0,me)===0}e.startsWithIgnoreCase=V;function q(re,ue){const me=Math.min(re.length,ue.length);let we;for(we=0;we<me;we++)if(re.charCodeAt(we)!==ue.charCodeAt(we))return we;return me}e.commonPrefixLength=q;function z(re,ue){const me=Math.min(re.length,ue.length);let we;const Se=re.length-1,be=ue.length-1;for(we=0;we<me;we++)if(re.charCodeAt(Se-we)!==ue.charCodeAt(be-we))return we;return me}e.commonSuffixLength=z;function J(re){return 55296<=re&&re<=56319}e.isHighSurrogate=J;function Q(re){return 56320<=re&&re<=57343}e.isLowSurrogate=Q;function K(re,ue){return(re-55296<<10)+(ue-56320)+65536}e.computeCodePoint=K;function X(re,ue,me){const we=re.charCodeAt(me);if(J(we)&&me+1<ue){const Se=re.charCodeAt(me+1);if(Q(Se))return K(we,Se)}return we}e.getNextCodePoint=X;function j(re,ue){const me=re.charCodeAt(ue-1);if(Q(me)&&ue>1){const we=re.charCodeAt(ue-2);if(J(we))return K(we,me)}return me}class F{get offset(){return this._offset}constructor(ue,me=0){this._str=ue,this._len=ue.length,this._offset=me}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=j(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=X(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class ee{get offset(){return this._iterator.offset}constructor(ue,me=0){this._iterator=new F(ue,me)}nextGraphemeLength(){const ue=Pe.getInstance(),me=this._iterator,we=me.offset;let Se=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,De=ue.getGraphemeBreakType(me.nextCodePoint());if(de(Se,De)){me.setOffset(be);break}Se=De}return me.offset-we}prevGraphemeLength(){const ue=Pe.getInstance(),me=this._iterator,we=me.offset;let Se=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,De=ue.getGraphemeBreakType(me.prevCodePoint());if(de(De,Se)){me.setOffset(be);break}Se=De}return we-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ne(re,ue){return new ee(re,ue).nextGraphemeLength()}e.nextCharLength=ne;function se(re,ue){return new ee(re,ue).prevGraphemeLength()}e.prevCharLength=se;function H(re,ue){ue>0&&Q(re.charCodeAt(ue))&&ue--;const me=ue+ne(re,ue);return[me-se(re,me),me]}e.getCharContainingOffset=H;function B(re){const ue=new ee(re);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.charCount=B;let N;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(re){return N||(N=C()),N.test(re)}e.containsRTL=U;const $=/^[\t\n\r\x20-\x7E]*$/;function G(re){return $.test(re)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=W;function Z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=Z;function te(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=te;function ce(re,ue){if(re.length<ue)return re;const me=/\b/g;let we=0;for(;me.test(re)&&!(re.length-me.lastIndex<ue);)we=me.lastIndex,me.lastIndex+=1;return re.substring(we).replace(/^\s/,"")}e.lcut=ce;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function pe(re){return re&&(re=re.replace(he,"")),re}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=fe;function ye(re){return fe(re)?re.substr(1):re}e.stripUTF8BOM=ye;function Ce(re,ue){if(!re||!ue||re.length<ue.length)return!1;const me=ue.length,we=re.toLowerCase();let Se=0,be=-1;for(;Se<me;){const De=we.indexOf(ue[Se],be+1);if(De<0)return!1;be=De,Se++}return!0}e.fuzzyContains=Ce;function Re(re,ue=!1){return re?(ue&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=Re;function ke(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=ke;function ze(re,ue=1){if(ue===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.getNLines=ze;function Ke(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=Ke;function le(re){return Pe.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=le;function de(re,ue){return re===0?ue!==5&&ue!==7:re===2&&ue===3?!1:re===4||re===2||re===3||ue===4||ue===2||ue===3?!0:!(re===8&&(ue===8||ue===9||ue===11||ue===12)||(re===11||re===9)&&(ue===9||ue===10)||(re===12||re===10)&&ue===10||ue===5||ue===13||ue===7||re===1||re===13&&ue===14||re===6&&ue===6)}var ge;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Pe{static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Ie()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this._data,we=me.length/3;let Se=1;for(;Se<=we;)if(ue<me[3*Se])Se=2*Se;else if(ue>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Pe._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(re,ue){if(re===0)return 0;const me=Le(re,ue);if(me!==void 0)return me;const we=new F(ue,re);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Ne;function Le(re,ue){const me=new F(ue,re);let we=me.prevCodePoint();for(;We(we)||we===65039||we===8419;){if(me.offset===0)return;we=me.prevCodePoint()}if(!te(we))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function We(re){return 127995<=re&&re<=127999}var Me;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Oe{static getInstance(ue){return Oe.cache.get(Array.from(ue))}static getLocales(){return Oe._locales.value}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}l=Oe,Oe.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new L.LRUCachedFunction(re=>{function ue(Ue){const xe=new Map;for(let $e=0;$e<Ue.length;$e+=2)xe.set(Ue[$e],Ue[$e+1]);return xe}function me(Ue,xe){const $e=new Map(Ue);for(const[et,nt]of xe)$e.set(et,nt);return $e}function we(Ue,xe){if(!Ue)return xe;const $e=new Map;for(const[et,nt]of Ue)xe.has(et)&&$e.set(et,nt);return $e}const Se=l.ambiguousCharacterData.value;let be=re.filter(Ue=>!Ue.startsWith("_")&&Ue in Se);be.length===0&&(be=["_default"]);let De;for(const Ue of be){const xe=ue(Se[Ue]);De=we(De,xe)}const _e=ue(Se._common),Ae=me(_e,De);return new Oe(Ae)}),Oe._locales=new O.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.value).filter(re=>!re.startsWith("_"))),e.AmbiguousCharacters=Oe;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(ue){return Fe.getData().has(ue)}static get codePoints(){return Fe.getData()}}Fe._data=void 0,e.InvisibleCharacters=Fe}),define(oe[47],ae([0,1,14,4,27,11]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function P(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=P;function y(s,a=L.posix.sep){if(!s)return"";const h=s.length,w=s.charCodeAt(0);if(_(w)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let D=3;const T=D;for(;D<h&&!_(s.charCodeAt(D));D++);if(T!==D&&!_(s.charCodeAt(D+1))){for(D+=1;D<h;D++)if(_(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,a)}}return a}else if(d(w)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let S=s.indexOf("://");if(S!==-1){for(S+=3;S<h;S++)if(_(s.charCodeAt(S)))return s.slice(0,S+1)}return""}e.getRoot=y;function I(s){if(!O.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let h=2;const w=h;for(;h<s.length&&(a=s.charCodeAt(h),a!==92);h++);return!(w===h||(a=s.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(s,a=O.isWindows){const h=a?E:m;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||a&&f.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=p;function b(s,a,h){const w=s===a;return!h||w?w:!s||!a?!1:(0,l.equalsIgnoreCase)(s,a)}e.isEqual=b;function c(s,a,h,w=L.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(h){if(!(0,l.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let D=a.length;return a.charAt(a.length-1)===w&&D--,s.charAt(D)===w}return a.charAt(a.length-1)!==w&&(a+=w),s.indexOf(a)===0}e.isEqualOrParent=c;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function u(s,a){return O.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(a,s)),s=(0,L.normalize)(s),O.isWindows?(s=(0,l.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,l.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=u;function g(s){const a=(0,L.normalize)(s);return O.isWindows?s.length>3?!1:v(a)&&(s.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function v(s,a=O.isWindows){return a?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function k(s){return v(s)?s[0]:void 0}e.getDriveLetter=k;function i(s,a,h){return a.length>s.length?-1:s===a?0:(h&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function o(s){const a=s.split(":");let h,w,S;for(const D of a){const T=Number(D);(0,A.isNumber)(T)?w===void 0?w=T:S===void 0&&(S=T):h=h?[h,D].join(":"):D}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:w!==void 0?w:void 0,column:S!==void 0?S:w!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(s,a,h=8){let w="";for(let D=0;D<h;D++){let T;D===0&&O.isWindows&&!a&&(h===3||h===4)?T=t:T=n,w+=T.charAt(Math.floor(Math.random()*T.length))}let S;return a?S=`${a}-${w}`:S=w,s?(0,L.join)(s,S):S}e.randomPath=r}),define(oe[53],ae([0,1,27]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(d){return l(d,0)}e.hash=O;function l(d,u){switch(typeof d){case"object":return d===null?A(349,u):Array.isArray(d)?P(d,u):y(d,u);case"string":return R(d,u);case"boolean":return _(d,u);case"number":return A(d,u);case"undefined":return A(937,u);default:return A(617,u)}}e.doHash=l;function A(d,u){return(u<<5)-u+d|0}e.numberHash=A;function _(d,u){return A(d?433:863,u)}function R(d,u){u=A(149417,u);for(let g=0,v=d.length;g<v;g++)u=A(d.charCodeAt(g),u);return u}e.stringHash=R;function P(d,u){return u=A(104579,u),d.reduce((g,v)=>l(v,g),u)}function y(d,u){return u=A(181387,u),Object.keys(d).sort().reduce((g,v)=>(g=R(v,g),l(d[v],g)),u)}class I{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=l(u,this._value),this._value}}e.Hasher=I;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(d,u,g=32){const v=g-u,k=~((1<<v)-1);return(d<<u|(k&d)>>>v)>>>0}function f(d,u=0,g=d.byteLength,v=0){for(let k=0;k<g;k++)d[u+k]=v}function p(d,u,g="0"){for(;d.length<u;)d=g+d;return d}function b(d,u=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),u/4)}e.toHexString=b;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const v=this._buff;let k=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=u.charCodeAt(0),n=0);;){let t=o;if(L.isHighSurrogate(o))if(n+1<g){const r=u.charCodeAt(n+1);L.isLowSurrogate(r)?(n++,t=L.computeCodePoint(o,r)):t=65533}else{i=o;break}else L.isLowSurrogate(o)&&(t=65533);if(k=this._push(v,k,t),n++,n<g)o=u.charCodeAt(n);else break}this._buffLen=k,this._leftoverHighSurrogate=i}_push(u,g,v){return v<128?u[g++]=v:v<2048?(u[g++]=192|(v&1984)>>>6,u[g++]=128|(v&63)>>>0):v<65536?(u[g++]=224|(v&61440)>>>12,u[g++]=128|(v&4032)>>>6,u[g++]=128|(v&63)>>>0):(u[g++]=240|(v&1835008)>>>18,u[g++]=128|(v&258048)>>>12,u[g++]=128|(v&4032)>>>6,u[g++]=128|(v&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=c._bigBlock32,g=this._buffDV;for(let a=0;a<64;a+=4)u.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let v=this._h0,k=this._h1,i=this._h2,o=this._h3,n=this._h4,t,r,s;for(let a=0;a<80;a++)a<20?(t=k&i|~k&o,r=1518500249):a<40?(t=k^i^o,r=1859775393):a<60?(t=k&i|k&o|i&o,r=2400959708):(t=k^i^o,r=3395469782),s=m(v,5)+t+n+r+u.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(k,30),k=v,v=s;this._h0=this._h0+v&4294967295,this._h1=this._h1+k&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}c._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(oe[90],ae([0,1,27]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(O||(O={})),function(l){const A="error",_="warning",R="warn",P="info",y="ignore";function I(m){return m?L.equalsIgnoreCase(A,m)?l.Error:L.equalsIgnoreCase(_,m)||L.equalsIgnoreCase(R,m)?l.Warning:L.equalsIgnoreCase(P,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=I;function E(m){switch(m){case l.Error:return A;case l.Warning:return _;case l.Info:return P;default:return y}}l.toString=E}(O||(O={})),e.default=O}),define(oe[48],ae([0,1,21,27]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(f){return this._value=f,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(f){const p=f.charCodeAt(0),b=this._value.charCodeAt(this._pos);return p-b}value(){return this._value[this._pos]}}e.StringIterator=l;class A{constructor(f=!0){this._caseSensitive=f}reset(f){return this._value=f,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let f=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(f)this._from++;else break;else f=!1;return this}cmp(f){return this._caseSensitive?(0,O.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class _{constructor(f=!0,p=!0){this._splitOnBackslash=f,this._caseSensitive=p}reset(f){this._from=0,this._to=0,this._value=f,this._valueLen=f.length;for(let p=f.length-1;p>=0;p--,this._valueLen--){const b=this._value.charCodeAt(p);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let f=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(f)this._from++;else break;else f=!1}return this}cmp(f){return this._caseSensitive?(0,O.compareSubstring)(f,this._value,0,f.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(f,this._value,0,f.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(f,p){this._ignorePathCasing=f,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(f){return this._value=f,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(f)),this._pathIterator.reset(f.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(f)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(f){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(f,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(f,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(f);if(this._states[this._stateIdx]===4)return(0,O.compare)(f,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(f,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(I||(I={}));class E{static forUris(f=()=>!1,p=()=>!1){return new E(new P(f,p))}static forPaths(f=!1){return new E(new _(void 0,!f))}static forStrings(){return new E(new l)}static forConfigKeys(){return new E(new A)}constructor(f){this._iter=f}clear(){this._root=void 0}fill(f,p){if(p){const b=p.slice(0);(0,L.shuffle)(b);for(const c of b)this.set(c,f)}else{const b=f.slice(0);(0,L.shuffle)(b);for(const c of b)this.set(c[0],c[1])}}set(f,p){const b=this._iter.reset(f);let c;this._root||(this._root=new y,this._root.segment=b.value());const d=[];for(c=this._root;;){const g=b.cmp(c.segment);if(g>0)c.left||(c.left=new y,c.left.segment=b.value()),d.push([-1,c]),c=c.left;else if(g<0)c.right||(c.right=new y,c.right.segment=b.value()),d.push([1,c]),c=c.right;else if(b.hasNext())b.next(),c.mid||(c.mid=new y,c.mid.segment=b.value()),d.push([0,c]),c=c.mid;else break}const u=c.value;c.value=p,c.key=f;for(let g=d.length-1;g>=0;g--){const v=d[g][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const i=d[g][0],o=d[g+1][0];if(i===1&&o===1)d[g][1]=v.rotateLeft();else if(i===-1&&o===-1)d[g][1]=v.rotateRight();else if(i===1&&o===-1)v.right=d[g+1][1]=d[g+1][1].rotateRight(),d[g][1]=v.rotateLeft();else if(i===-1&&o===1)v.left=d[g+1][1]=d[g+1][1].rotateLeft(),d[g][1]=v.rotateRight();else throw new Error;if(g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this._root=d[0][1]}}return u}get(f){return this._getNode(f)?.value}_getNode(f){const p=this._iter.reset(f);let b=this._root;for(;b;){const c=p.cmp(b.segment);if(c>0)b=b.left;else if(c<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(f){const p=this._getNode(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this._delete(f,!1)}deleteSuperstr(f){return this._delete(f,!0)}_delete(f,p){const b=this._iter.reset(f),c=[];let d=this._root;for(;d;){const u=b.cmp(d.segment);if(u>0)c.push([-1,d]),d=d.left;else if(u<0)c.push([1,d]),d=d.right;else if(b.hasNext())b.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(p?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const u=this._min(d.right);if(u.key){const{key:g,value:v,segment:k}=u;this._delete(u.key,!1),d.key=g,d.value=v,d.segment=k}}else{const u=d.left??d.right;if(c.length>0){const[g,v]=c[c.length-1];switch(g){case-1:v.left=u;break;case 0:v.mid=u;break;case 1:v.right=u;break}}else this._root=u}for(let u=c.length-1;u>=0;u--){const g=c[u][1];g.updateHeight();const v=g.balanceFactor();if(v>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),c[u][1]=g.rotateLeft()):v<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),c[u][1]=g.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this._root=c[0][1]}}}_min(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this._iter.reset(f);let b=this._root,c;for(;b;){const d=p.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(p.hasNext())p.next(),c=b.value||c,b=b.mid;else break}return b&&b.value||c}findSuperstr(f){return this._findSuperstrOrElement(f,!1)}_findSuperstrOrElement(f,p){const b=this._iter.reset(f);let c=this._root;for(;c;){const d=b.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(b.hasNext())b.next(),c=c.mid;else return c.mid?this._entries(c.mid):p?c.value:void 0}}hasElementOrSubtree(f){return this._findSuperstrOrElement(f,!0)!==void 0}forEach(f){for(const[p,b]of this)f(b,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(f){const p=[];return this._dfsEntries(f,p),p[Symbol.iterator]()}_dfsEntries(f,p){!f||(f.left&&this._dfsEntries(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this._dfsEntries(f.mid,p),f.right&&this._dfsEntries(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:f(p.left)&&f(p.right)};return f(this._root)}}e.TernarySearchTree=E}),define(oe[12],ae([0,1,14,4]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,_=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!l.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(n,t){return!n&&!t?"file":n}function y(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const I="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,s,a,h,w=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=P(t,w),this.authority=r||I,this.path=y(this.scheme,s||I),this.query=a||I,this.fragment=h||I,R(this,w))}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:s,path:a,query:h,fragment:w}=t;return r===void 0?r=this.scheme:r===null&&(r=I),s===void 0?s=this.authority:s===null&&(s=I),a===void 0?a=this.path:a===null&&(a=I),h===void 0?h=this.query:h===null&&(h=I),w===void 0?w=this.fragment:w===null&&(w=I),r===this.scheme&&s===this.authority&&a===this.path&&h===this.query&&w===this.fragment?this:new b(r,s,a,h,w)}static parse(t,r=!1){const s=m.exec(t);return s?new b(s[2]||I,o(s[4]||I),o(s[5]||I),o(s[7]||I),o(s[9]||I),r):new b(I,I,I,I,I)}static file(t){let r=I;if(O.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const s=t.indexOf(E,2);s===-1?(r=t.substring(2),t=E):(r=t.substring(2,s),t=t.substring(s)||E)}return new b("file",r,t,I,I)}static from(t){const r=new b(t.scheme,t.authority,t.path,t.query,t.fragment);return R(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return O.isWindows&&t.scheme==="file"?s=f.file(L.win32.join(g(t,!0),...r)).path:s=L.posix.join(t.path,...r),t.with({path:s})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new b(t);return r._formatted=t.external,r._fsPath=t._sep===p?t.fsPath:null,r}}else return t}}e.URI=f;const p=O.isWindows?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,t,r){let s,a=-1;for(let h=0;h<n.length;h++){const w=n.charCodeAt(h);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||t&&w===47||r&&w===91||r&&w===93||r&&w===58)a!==-1&&(s+=encodeURIComponent(n.substring(a,h)),a=-1),s!==void 0&&(s+=n.charAt(h));else{s===void 0&&(s=n.substr(0,h));const S=c[w];S!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,h)),a=-1),s+=S):a===-1&&(a=h)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function u(n){let t;for(let r=0;r<n.length;r++){const s=n.charCodeAt(r);s===35||s===63?(t===void 0&&(t=n.substr(0,r)),t+=c[s]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function g(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function v(n,t){const r=t?u:d;let s="",{scheme:a,authority:h,path:w,query:S,fragment:D}=n;if(a&&(s+=a,s+=":"),(h||a==="file")&&(s+=E,s+=E),h){let T=h.indexOf("@");if(T!==-1){const M=h.substr(0,T);h=h.substr(T+1),T=M.lastIndexOf(":"),T===-1?s+=r(M,!1,!1):(s+=r(M.substr(0,T),!1,!1),s+=":",s+=r(M.substr(T+1),!1,!0)),s+="@"}h=h.toLowerCase(),T=h.lastIndexOf(":"),T===-1?s+=r(h,!1,!0):(s+=r(h.substr(0,T),!1,!0),s+=h.substr(T))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const T=w.charCodeAt(1);T>=65&&T<=90&&(w=`/${String.fromCharCode(T+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const T=w.charCodeAt(0);T>=65&&T<=90&&(w=`${String.fromCharCode(T+32)}:${w.substr(2)}`)}s+=r(w,!0,!1)}return S&&(s+="?",s+=r(S,!1,!1)),D&&(s+="#",s+=t?D:d(D,!1,!1)),s}function k(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+k(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,t=>k(t)):n}}),define(oe[145],ae([0,1,12]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(y){const I=y;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=O;function l(y){const I=[];let E;try{const m=JSON.parse(y.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),E=f.__$stack),I.push(...m)}catch{I.push("Unable to log remote console arguments",y.arguments)}return{args:I,stack:E}}e.parse=l;function A(y){if(typeof y!="string")return A(l(y).stack);const I=y;if(I){const E=_(I),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=A;function _(y){if(!y)return y;const I=y.indexOf(`
`);return I===-1?y:y.substring(0,I)}function R(y,I){const{args:E,stack:m}=l(y),f=typeof E[0]=="string"&&E.length===1;let p=_(m);p&&(p=`(${p.trim()})`);let b=[];if(typeof E[0]=="string"?p&&f?b=[`%c[${I}] %c${E[0]} %c${p}`,P("blue"),P(""),P("grey")]:b=[`%c[${I}] %c${E[0]}`,P("blue"),P(""),...E.slice(1)]:b=[`%c[${I}]%`,P("blue"),...E],p&&!f&&b.push(p),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,b)}e.log=R;function P(y){return`color: ${y}`}}),define(oe[91],ae([0,1,16,27,12]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(y){return JSON.stringify(y,R)}e.stringify=A;function _(y){let I=JSON.parse(y);return I=P(I),I}e.parse=_;function R(y,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,O.regExpFlags)(I)}:I}function P(y,I=0){if(!y||I>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return l.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof L.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let E=0;E<y.length;++E)y[E]=P(y[E],I+1);else for(const E in y)Object.hasOwnProperty.call(y,E)&&(y[E]=P(y[E],I+1))}return y}e.revive=P}),define(oe[22],ae([0,1,10,4,12]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}setServerRootPath(I){this._remoteResourcesPath=`${I}/${A.vscodeRemoteResource}`}set(I,E,m){this._hosts[I]=E,this._ports[I]=m}setConnectionToken(I,E){this._connectionTokens[I]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)try{return this._delegate(I)}catch(c){return L.onUnexpectedError(c),I}const E=I.authority;let m=this._hosts[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this._ports[E],p=this._connectionTokens[E];let b=`path=${encodeURIComponent(I.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),l.URI.from({scheme:O.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${m}:${f}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new _,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(I){const E=this.toUri(I,ie);return this.uriToBrowserUri(E)}uriToBrowserUri(I){return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===A.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${A.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?I.with({scheme:A.vscodeFileResource,authority:I.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(I){const E=this.toUri(I,ie);return this.uriToFileUri(E)}uriToFileUri(I){return I.scheme===A.vscodeFileResource?I.with({scheme:A.file,authority:I.authority!==R.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(I,E){return l.URI.isUri(I)?I:l.URI.parse(E.toUrl(I))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R;var P;(function(y){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(I.get("3"));const E="vscode-coi";function m(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:l.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const c=b?.get(E);if(!!c)return I.get(c)}y.getHeadersFromQuery=m;function f(p,b,c){if(!globalThis.crossOriginIsolated)return;const d=b&&c?"3":c?"2":"1";p instanceof URLSearchParams?p.set(E,d):p[E]=d}y.addSearchParam=f})(P=e.COI||(e.COI={}))}),define(oe[23],ae([0,1,47,22,14,4,27,12]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=P;class y{constructor(p){this._ignorePathCasing=p}compare(p,b,c=!1){return p===b?0:(0,_.compare)(this.getComparisonKey(p,c),this.getComparisonKey(b,c))}isEqual(p,b,c=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,c)===this.getComparisonKey(b,c)}getComparisonKey(p,b=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,b,c=!1){if(p.scheme===b.scheme){if(p.scheme===O.Schemas.file)return L.isEqualOrParent(P(p),P(b),this._ignorePathCasing(p))&&p.query===b.query&&(c||p.fragment===b.fragment);if((0,e.isEqualAuthority)(p.authority,b.authority))return L.isEqualOrParent(p.path,b.path,this._ignorePathCasing(p),"/")&&p.query===b.query&&(c||p.fragment===b.fragment)}return!1}joinPath(p,...b){return R.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return l.posix.basename(p.path)}extname(p){return l.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===O.Schemas.file?b=R.URI.file(l.dirname(P(p))).path:(b=l.posix.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===O.Schemas.file?b=R.URI.file(l.normalize(P(p))).path:b=l.posix.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.isEqualAuthority)(p.authority,b.authority))return;if(p.scheme===O.Schemas.file){const u=l.relative(P(p),P(b));return A.isWindows?L.toSlashes(u):u}let c=p.path||"/";const d=b.path||"/";if(this._ignorePathCasing(p)){let u=0;for(const g=Math.min(c.length,d.length);u<g&&!(c.charCodeAt(u)!==d.charCodeAt(u)&&c.charAt(u).toLowerCase()!==d.charAt(u).toLowerCase());u++);c=d.substr(0,u)+c.substr(u)}return l.posix.relative(c,d)}resolvePath(p,b){if(p.scheme===O.Schemas.file){const c=R.URI.file(l.resolve(P(p),b));return p.with({authority:c.authority,path:c.path})}return b=L.toPosixPath(b),p.with({path:l.posix.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,_.equalsIgnoreCase)(p,b)}hasTrailingPathSeparator(p,b=l.sep){if(p.scheme===O.Schemas.file){const c=P(p);return c.length>L.getRoot(c).length&&c[c.length-1]===b}else{const c=p.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=l.sep){return(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=l.sep){let c=!1;if(p.scheme===O.Schemas.file){const d=P(p);c=d!==void 0&&d.length===L.getRoot(d).length&&d[d.length-1]===b}else{b="/";const d=p.path;c=d.length===1&&d.charCodeAt(d.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path+"/"}):p}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(f=>f.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,p){const b=[];for(let c=0;c<f.length;c++){const d=p(f[c]);f.some((u,g)=>g===c?!1:(0,e.isEqualOrParent)(d,p(u)))||b.push(f[c])}return b}e.distinctParents=I;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(b){const c=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,k]=g.split(":");v&&k&&c.set(v,k)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&c.set(f.META_DATA_MIME,u),c}f.parseMetaData=p})(E=e.DataUri||(e.DataUri={}));function m(f,p,b){if(p){let c=f.path;return c&&c[0]!==l.posix.sep&&(c=l.posix.sep+c),f.with({scheme:b,authority:p,path:c})}return f.with({scheme:b})}e.toLocalResource=m}),define(oe[6],ae([0,1,25,10,3,2,23,4,134]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(B){return!!B&&typeof B.then=="function"}e.isThenable=y;function I(B){const N=new L.CancellationTokenSource,C=B(N.token),U=new Promise(($,G)=>{const W=N.token.onCancellationRequested(()=>{W.dispose(),N.dispose(),G(new O.CancellationError)});Promise.resolve(C).then(Z=>{W.dispose(),N.dispose(),$(Z)},Z=>{W.dispose(),N.dispose(),G(Z)})});return new class{cancel(){N.cancel()}then($,G){return U.then($,G)}catch($){return this.then(void 0,$)}finally($){return U.finally($)}}}e.createCancelablePromise=I;function E(B,N,C){return new Promise((U,$)=>{const G=N.onCancellationRequested(()=>{G.dispose(),U(C)});B.then(U,$).finally(()=>G.dispose())})}e.raceCancellation=E;function m(B,N){return new Promise((C,U)=>{const $=N.onCancellationRequested(()=>{$.dispose(),U(new O.CancellationError)});B.then(C,U).finally(()=>$.dispose())})}e.raceCancellationError=m;async function f(B){let N=-1;const C=B.map(($,G)=>$.then(W=>(N=G,W))),U=await Promise.race(C);return B.forEach(($,G)=>{G!==N&&$.cancel()}),U}e.raceCancellablePromises=f;function p(B,N,C){let U;const $=setTimeout(()=>{U?.(void 0),C?.()},N);return Promise.race([B.finally(()=>clearTimeout($)),new Promise(G=>U=G)])}e.raceTimeout=p;function b(B){return new Promise((N,C)=>{const U=B();y(U)?U.then(N,C):N(U)})}e.asPromise=b;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const C=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(C,C).then(U)})}return new Promise((C,U)=>{this.queuedPromise.then(C,U)})}return this.activePromise=N(),new Promise((C,U)=>{this.activePromise.then($=>{this.activePromise=null,C($)},$=>{this.activePromise=null,U($)})})}}e.Throttler=c;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class u{constructor(){this.promiseMap=new Map}queue(N,C){const $=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.promiseMap.get(N)===$&&this.promiseMap.delete(N)});return this.promiseMap.set(N,$),$}}e.SequencerByKey=u;const g=(B,N)=>{let C=!0;const U=setTimeout(()=>{C=!1,N()},B);return{isTriggered:()=>C,dispose:()=>{clearTimeout(U),C=!1}}},v=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class k{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,C=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,G)=>{this.doResolve=$,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=C===P.MicrotaskDelay?v(U):g(C,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=k;class i{constructor(N){this.delayer=new k(N),this.throttler=new c}trigger(N,C){return this.delayer.trigger(()=>this.throttler.queue(N),C)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this._isOpen=!1,this._promise=new Promise((N,C)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class n extends o{constructor(N){super(),this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function t(B,N){return N?new Promise((C,U)=>{const $=setTimeout(()=>{G.dispose(),C()},B),G=N.onCancellationRequested(()=>{clearTimeout($),G.dispose(),U(new O.CancellationError)})}):I(C=>t(B,C))}e.timeout=t;function r(B,N=0){const C=setTimeout(B,N);return(0,A.toDisposable)(()=>clearTimeout(C))}e.disposableTimeout=r;function s(B){const N=[];let C=0;const U=B.length;function $(){return C<U?B[C++]():null}function G(W){W!=null&&N.push(W);const Z=$();return Z?Z.then(G):Promise.resolve(N)}return Promise.resolve(null).then(G)}e.sequence=s;function a(B,N=U=>!!U,C=null){let U=0;const $=B.length,G=()=>{if(U>=$)return Promise.resolve(C);const W=B[U++];return Promise.resolve(W()).then(te=>N(te)?Promise.resolve(te):G())};return G()}e.first=a;function h(B,N=U=>!!U,C=null){if(B.length===0)return Promise.resolve(C);let U=B.length;const $=()=>{U=-1;for(const G of B)G.cancel?.()};return new Promise((G,W)=>{for(const Z of B)Z.then(te=>{--U>=0&&N(te)?($(),G(te)):U===0&&G(C)}).catch(te=>{--U>=0&&($(),W(te))})})}e.firstParallel=h;class w{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(N){return this._size++,new Promise((C,U)=>{this.outstandingPromises.push({factory:N,c:C,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const C=N.factory();C.then(N.c,N.e),C.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=w;class S extends w{constructor(){super(1)}}e.Queue=S;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new j;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,C=_.extUri){const U=C.getComparisonKey(N);let $=this.queues.get(U);return $||($=new S,l.Event.once($.onDrained)(()=>{$?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,$)),$}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class T{constructor(N,C){this._token=-1,typeof N=="function"&&typeof C=="number"&&this.setIfNotSet(N,C)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,C){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},C)}setIfNotSet(N,C){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},C))}}e.TimeoutTimer=T;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,C){this.cancel(),this._token=setInterval(()=>{N()},C)}}e.IntervalTimer=M;class x{constructor(N,C){this.timeoutToken=-1,this.runner=N,this.timeout=C,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class V{constructor(N,C){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=C,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class q extends x{constructor(N,C){super(N,C),this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner?.(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class z extends A.Disposable{constructor(N,C){super(),this.options=N,this.handler=C,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const C of N)this.pendingWork.push(C);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,R.setTimeout0)(()=>{if(N)return;const C=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(B,N)=>{const C=requestIdleCallback(B,typeof N=="number"?{timeout:N}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(C))}}}}();class J{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=J;async function Q(B,N,C){let U;for(let $=0;$<C;$++)try{return await B()}catch(G){U=G,await t(N)}throw U}e.retry=Q;class K{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(N,C,U){return this._pending={taskId:N,cancel:()=>U?.(),promise:C},C.then(()=>this.donePending(N),()=>this.donePending(N)),C}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let C,U;const $=new Promise((G,W)=>{C=G,U=W});this._next={run:N,promise:$,promiseResolve:C,promiseReject:U}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class X{constructor(N,C=()=>Date.now()){this.interval=N,this.nowFn=C,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class j{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,C)=>{this.completeCallback=N,this.errorCallback=C})}complete(N){return new Promise(C=>{this.completeCallback(N),this.resolved=!0,C()})}error(N){return new Promise(C=>{this.errorCallback(N),this.rejected=!0,C()})}cancel(){new Promise(N=>{this.errorCallback(new O.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=j;var F;(function(B){async function N(U){let $;const G=await Promise.all(U.map(W=>W.then(Z=>Z,Z=>{$||($=Z)})));if(typeof $<"u")throw $;return G}B.settled=N;function C(U){return new Promise(async($,G)=>{try{await U($,G)}catch(W){G(W)}})}B.withAsyncBody=C})(F=e.Promises||(e.Promises={}));var ee;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(ee||(ee={}));class ne{static fromArray(N){return new ne(C=>{C.emitMany(N)})}static fromPromise(N){return new ne(async C=>{C.emitMany(await N)})}static fromPromises(N){return new ne(async C=>{await Promise.all(N.map(async U=>C.emitOne(await U)))})}static merge(N){return new ne(async C=>{await Promise.all(N.map(async U=>{for await(const $ of U)C.emitOne($)}))})}constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const C={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(N(C)),this.resolve()}catch(U){this.reject(U)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,C){return new ne(async U=>{for await(const $ of N)U.emitOne(C($))})}map(N){return ne.map(this,N)}static filter(N,C){return new ne(async U=>{for await(const $ of N)C($)&&U.emitOne($)})}filter(N){return ne.filter(this,N)}static coalesce(N){return ne.filter(N,C=>!!C)}coalesce(){return ne.coalesce(this)}static async toPromise(N){const C=[];for await(const U of N)C.push(U);return C}toPromise(){return ne.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}ne.EMPTY=ne.fromArray([]),e.AsyncIterableObject=ne;class se extends ne{constructor(N,C){super(C),this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function H(B){const N=new L.CancellationTokenSource,C=B(N.token);return new se(N,async U=>{const $=N.token.onCancellationRequested(()=>{$.dispose(),N.dispose(),U.reject(new O.CancellationError)});try{for await(const G of C){if(N.token.isCancellationRequested)return;U.emitOne(G)}$.dispose(),N.dispose()}catch(G){$.dispose(),N.dispose(),U.reject(G)}})}e.createCancelableAsyncIterable=H}),define(oe[92],ae([0,1,21,6,47,37,14,4,27]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",E="[^/\\\\]",m=/\//g;function f(X,j){switch(X){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}${j?`|${I}${E}+`:""})*?`}}function p(X,j){if(!X)return[];const F=[];let ee=!1,ne=!1,se="";for(const H of X){switch(H){case j:if(!ee&&!ne){F.push(se),se="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}se+=H}return se&&F.push(se),F}e.splitGlobAware=p;function b(X){if(!X)return"";let j="";const F=p(X,e.GLOB_SPLIT);if(F.every(ee=>ee===e.GLOBSTAR))j=".*";else{let ee=!1;F.forEach((ne,se)=>{if(ne===e.GLOBSTAR){if(ee)return;j+=f(2,se===F.length-1)}else{let H=!1,B="",N=!1,C="";for(const U of ne){if(U!=="}"&&H){B+=U;continue}if(N&&(U!=="]"||!C)){let $;U==="-"?$=U:(U==="^"||U==="!")&&!C?$="^":U===e.GLOB_SPLIT?$="":$=(0,P.escapeRegExpCharacters)(U),C+=$;continue}switch(U){case"{":H=!0;continue;case"[":N=!0;continue;case"}":{j+=`(?:${p(B,",").map(W=>b(W)).join("|")})`,H=!1,B="";break}case"]":{j+="["+C+"]",N=!1,C="";break}case"?":j+=E;continue;case"*":j+=f(1);continue;default:j+=(0,P.escapeRegExpCharacters)(U)}}se<F.length-1&&(F[se+1]!==e.GLOBSTAR||se+2<F.length)&&(j+=I)}ee=ne===e.GLOBSTAR})}return j}const c=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},n=function(){return null};function t(X,j){if(!X)return n;let F;typeof X!="string"?F=X.pattern:F=X,F=F.trim();const ee=`${F}_${!!j.trimForExclusions}`;let ne=i.get(ee);if(ne)return r(ne,X);let se;return c.test(F)?ne=a(F.substr(4),F):(se=d.exec(s(F,j)))?ne=h(se[1],F):(j.trimForExclusions?g:u).test(F)?ne=w(F,j):(se=v.exec(s(F,j)))?ne=S(se[1].substr(1),F,!0):(se=k.exec(s(F,j)))?ne=S(se[1],F,!1):ne=D(F),i.set(ee,ne),r(ne,X)}function r(X,j){if(typeof j=="string")return X;const F=function(ee,ne){return(0,l.isEqualOrParent)(ee,j.base,!R.isLinux)?X((0,P.ltrim)(ee.substr(j.base.length),_.sep),ne):null};return F.allBasenames=X.allBasenames,F.allPaths=X.allPaths,F.basenames=X.basenames,F.patterns=X.patterns,F}function s(X,j){return j.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,j){return function(F,ee){return typeof F=="string"&&F.endsWith(X)?j:null}}function h(X,j){const F=`/${X}`,ee=`\\${X}`,ne=function(H,B){return typeof H!="string"?null:B?B===X?j:null:H===X||H.endsWith(F)||H.endsWith(ee)?j:null},se=[X];return ne.basenames=se,ne.patterns=[j],ne.allBasenames=se,ne}function w(X,j){const F=Q(X.slice(1,-1).split(",").map(B=>t(B,j)).filter(B=>B!==n),X),ee=F.length;if(!ee)return n;if(ee===1)return F[0];const ne=function(B,N){for(let C=0,U=F.length;C<U;C++)if(F[C](B,N))return X;return null},se=F.find(B=>!!B.allBasenames);se&&(ne.allBasenames=se.allBasenames);const H=F.reduce((B,N)=>N.allPaths?B.concat(N.allPaths):B,[]);return H.length&&(ne.allPaths=H),ne}function S(X,j,F){const ee=_.sep===_.posix.sep,ne=ee?X:X.replace(m,_.sep),se=_.sep+ne,H=_.posix.sep+X;let B;return F?B=function(N,C){return typeof N=="string"&&(N===ne||N.endsWith(se)||!ee&&(N===X||N.endsWith(H)))?j:null}:B=function(N,C){return typeof N=="string"&&(N===ne||!ee&&N===X)?j:null},B.allPaths=[(F?"*/":"./")+X],B}function D(X){try{const j=new RegExp(`^${b(X)}$`);return function(F){return j.lastIndex=0,typeof F=="string"&&j.test(F)?X:null}}catch{return n}}function T(X,j,F){return!X||typeof j!="string"?!1:M(X)(j,void 0,F)}e.match=T;function M(X,j={}){if(!X)return o;if(typeof X=="string"||x(X)){const F=t(X,j);if(F===n)return o;const ee=function(ne,se){return!!F(ne,se)};return F.allBasenames&&(ee.allBasenames=F.allBasenames),F.allPaths&&(ee.allPaths=F.allPaths),ee}return z(X,j)}e.parse=M;function x(X){const j=X;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=x;function V(X){return X.allBasenames||[]}e.getBasenameTerms=V;function q(X){return X.allPaths||[]}e.getPathTerms=q;function z(X,j){const F=Q(Object.getOwnPropertyNames(X).map(B=>J(B,X[B],j)).filter(B=>B!==n)),ee=F.length;if(!ee)return n;if(!F.some(B=>!!B.requiresSiblings)){if(ee===1)return F[0];const B=function(U,$){let G;for(let W=0,Z=F.length;W<Z;W++){const te=F[W](U,$);if(typeof te=="string")return te;(0,O.isThenable)(te)&&(G||(G=[]),G.push(te))}return G?(async()=>{for(const W of G){const Z=await W;if(typeof Z=="string")return Z}return null})():null},N=F.find(U=>!!U.allBasenames);N&&(B.allBasenames=N.allBasenames);const C=F.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return C.length&&(B.allPaths=C),B}const ne=function(B,N,C){let U,$;for(let G=0,W=F.length;G<W;G++){const Z=F[G];Z.requiresSiblings&&C&&(N||(N=(0,_.basename)(B)),U||(U=N.substr(0,N.length-(0,_.extname)(B).length)));const te=Z(B,N,U,C);if(typeof te=="string")return te;(0,O.isThenable)(te)&&($||($=[]),$.push(te))}return $?(async()=>{for(const G of $){const W=await G;if(typeof W=="string")return W}return null})():null},se=F.find(B=>!!B.allBasenames);se&&(ne.allBasenames=se.allBasenames);const H=F.reduce((B,N)=>N.allPaths?B.concat(N.allPaths):B,[]);return H.length&&(ne.allPaths=H),ne}function J(X,j,F){if(j===!1)return n;const ee=t(X,F);if(ee===n)return n;if(typeof j=="boolean")return ee;if(j){const ne=j.when;if(typeof ne=="string"){const se=(H,B,N,C)=>{if(!C||!ee(H,B))return null;const U=ne.replace("$(basename)",()=>N),$=C(U);return(0,O.isThenable)($)?$.then(G=>G?X:null):$?X:null};return se.requiresSiblings=!0,se}}return ee}function Q(X,j){const F=X.filter(B=>!!B.basenames);if(F.length<2)return X;const ee=F.reduce((B,N)=>{const C=N.basenames;return C?B.concat(C):B},[]);let ne;if(j){ne=[];for(let B=0,N=ee.length;B<N;B++)ne.push(j)}else ne=F.reduce((B,N)=>{const C=N.patterns;return C?B.concat(C):B},[]);const se=function(B,N){if(typeof B!="string")return null;if(!N){let U;for(U=B.length;U>0;U--){const $=B.charCodeAt(U-1);if($===47||$===92)break}N=B.substr(U)}const C=ee.indexOf(N);return C!==-1?ne[C]:null};se.basenames=ee,se.patterns=ne,se.allBasenames=ee;const H=X.filter(B=>!B.basenames);return H.push(se),H}function K(X,j){return(0,L.equals)(X,j,(F,ee)=>typeof F=="string"&&typeof ee=="string"?F===ee:typeof F!="string"&&typeof ee!="string"?F.base===ee.base&&F.pattern===ee.pattern:!1)}e.patternsEquals=K}),define(oe[93],ae([0,1,16,12]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(E){return E.toJSON()}class A{constructor(m){this._uriTransformer=m}transformIncoming(m){const f=this._uriTransformer.transformIncoming(m);return f===m?m:l(O.URI.from(f))}transformOutgoing(m){const f=this._uriTransformer.transformOutgoing(m);return f===m?m:l(O.URI.from(f))}transformOutgoingURI(m){const f=this._uriTransformer.transformOutgoing(m);return f===m?m:O.URI.from(f)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function _(E,m,f){if(!E||f>200)return null;if(typeof E=="object"){if(E instanceof O.URI)return m.transformOutgoing(E);for(const p in E)if(Object.hasOwnProperty.call(E,p)){const b=_(E[p],m,f+1);b!==null&&(E[p]=b)}}return null}function R(E,m){const f=_(E,m,0);return f===null?E:f}e.transformOutgoingURIs=R;function P(E,m,f,p){if(!E||p>200)return null;if(typeof E=="object"){if(E.$mid===1)return f?O.URI.revive(m.transformIncoming(E)):m.transformIncoming(E);if(E instanceof L.VSBuffer)return null;for(const b in E)if(Object.hasOwnProperty.call(E,b)){const c=P(E[b],m,f,p+1);c!==null&&(E[b]=c)}}return null}function y(E,m){const f=P(E,m,!1,0);return f===null?E:f}e.transformIncomingURIs=y;function I(E,m){const f=P(E,m,!0,0);return f===null?E:f}e.transformAndReviveIncomingURIs=I}),define(oe[146],ae([0,1,34,48,31,136]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,I=0;const E=(0,L.networkInterfaces)();for(const m in E){const f=E[m];if(f)for(const{mac:p,internal:b}of f)b||(I+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(y+=1))}this._value=I>0?y/I:0}return this._value}};let _;async function R(y){return _||(_=(async()=>await P(y)||l.generateUuid())()),_}e.getMachineId=R;async function P(y){try{const I=await new Promise((m,f)=>{ie(["crypto"],m,f)}),E=(0,A.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){y(I);return}}}),define(oe[28],ae([0,1,54,34,291,6,47,85,14,4,23,12]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function f(z,J=m.UNLINK){if((0,_.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?b(z):p(z)}async function p(z){try{const J=(0,_.randomPath)((0,O.tmpdir)());try{await L.promises.rename(z,J)}catch(Q){return Q.code==="ENOENT"?void 0:b(z)}b(J).catch(Q=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function b(z){return(0,l.promisify)(L.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function c(z){if((0,_.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function d(z,J){return v(await(J?u(z):(0,l.promisify)(L.readdir)(z)))}async function u(z){try{return await(0,l.promisify)(L.readdir)(z,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const J=[],Q=await d(z);for(const K of Q){let X=!1,j=!1,F=!1;try{const ee=await e.Promises.lstat((0,P.join)(z,K));X=ee.isFile(),j=ee.isDirectory(),F=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}J.push({name:K,isFile:()=>X,isDirectory:()=>j,isSymbolicLink:()=>F})}return J}function g(z){return v(L.readdirSync(z))}e.readdirSync=g;function v(z){return z.map(J=>typeof J=="string"?y.isMacintosh?(0,R.normalizeNFC)(J):J:(J.name=y.isMacintosh?(0,R.normalizeNFC)(J.name):J.name,J))}async function k(z){const J=await d(z),Q=[];for(const K of J)await o.existsDirectory((0,P.join)(z,K))&&Q.push(K);return Q}function i(z,J=1e3){return new Promise(Q=>{let K=!1;const X=setInterval(()=>{K||(K=!0,L.access(z,j=>{K=!1,j&&(clearInterval(X),Q(void 0))}))},J)})}e.whenDeleted=i;var o;(function(z){async function J(X){let j;try{if(j=await e.Promises.lstat(X),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(y.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw ee}throw F}}z.stat=J;async function Q(X){try{const{stat:j,symbolicLink:F}=await z.stat(X);return j.isFile()&&F?.dangling!==!0}catch{}return!1}z.existsFile=Q;async function K(X){try{const{stat:j,symbolicLink:F}=await z.stat(X);return j.isDirectory()&&F?.dangling!==!0}catch{}return!1}z.existsDirectory=K})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function t(z,J,Q){return n.queueFor(E.URI.file(z),I.extUriBiasedIgnorePathCase).queue(()=>{const K=w(Q);return new Promise((X,j)=>a(z,J,K,F=>F?j(F):X()))})}let r=!0;function s(z){r=z}e.configureFlushOnWrite=s;function a(z,J,Q,K){if(!r)return L.writeFile(z,J,{mode:Q.mode,flag:Q.flag},K);L.open(z,Q.flag,Q.mode,(X,j)=>{if(X)return K(X);L.writeFile(j,J,F=>{if(F)return L.close(j,()=>K(F));L.fdatasync(j,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),s(!1)),L.close(j,ne=>K(ne))))})})}function h(z,J,Q){const K=w(Q);if(!r)return L.writeFileSync(z,J,{mode:K.mode,flag:K.flag});const X=L.openSync(z,K.flag,K.mode);try{L.writeFileSync(X,J);try{L.fdatasyncSync(X)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),s(!1)}}finally{L.closeSync(X)}}e.writeFileSync=h;function w(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function S(z,J){if(z!==J)try{await e.Promises.rename(z,J)}catch(Q){if(z.toLowerCase()!==J.toLowerCase()&&Q.code==="EXDEV"||z.endsWith("."))await D(z,J,{preserveSymlinks:!1}),await f(z,m.MOVE);else throw Q}}async function D(z,J,Q){return M(z,J,{root:{source:z,target:J},options:Q,handledSourcePaths:new Set})}const T=511;async function M(z,J,Q){if(Q.handledSourcePaths.has(z))return;Q.handledSourcePaths.add(z);const{stat:K,symbolicLink:X}=await o.stat(z);if(X){if(Q.options.preserveSymlinks)try{return await q(z,J,Q)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(X.dangling)return}return K.isDirectory()?x(z,J,K.mode&T,Q):V(z,J,K.mode&T)}async function x(z,J,Q,K){await e.Promises.mkdir(J,{recursive:!0,mode:Q});const X=await d(z);for(const j of X)await M((0,P.join)(z,j),(0,P.join)(J,j),K)}async function V(z,J,Q){await e.Promises.copyFile(z,J),await e.Promises.chmod(J,Q)}async function q(z,J,Q){let K=await e.Promises.readlink(z);(0,_.isEqualOrParent)(K,Q.root.source,!y.isLinux)&&(K=(0,P.join)(Q.root.target,K.substr(Q.root.source.length+1))),await e.Promises.symlink(K,J)}e.Promises=new class{get access(){return(0,l.promisify)(L.access)}get stat(){return(0,l.promisify)(L.stat)}get lstat(){return(0,l.promisify)(L.lstat)}get utimes(){return(0,l.promisify)(L.utimes)}get read(){return(z,J,Q,K,X)=>new Promise((j,F)=>{L.read(z,J,Q,K,X,(ee,ne,se)=>ee?F(ee):j({bytesRead:ne,buffer:se}))})}get readFile(){return(0,l.promisify)(L.readFile)}get write(){return(z,J,Q,K,X)=>new Promise((j,F)=>{L.write(z,J,Q,K,X,(ee,ne,se)=>ee?F(ee):j({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,l.promisify)(L.appendFile)}get fdatasync(){return(0,l.promisify)(L.fdatasync)}get truncate(){return(0,l.promisify)(L.truncate)}get rename(){return(0,l.promisify)(L.rename)}get copyFile(){return(0,l.promisify)(L.copyFile)}get open(){return(0,l.promisify)(L.open)}get close(){return(0,l.promisify)(L.close)}get symlink(){return(0,l.promisify)(L.symlink)}get readlink(){return(0,l.promisify)(L.readlink)}get chmod(){return(0,l.promisify)(L.chmod)}get mkdir(){return(0,l.promisify)(L.mkdir)}get unlink(){return(0,l.promisify)(L.unlink)}get rmdir(){return(0,l.promisify)(L.rmdir)}get realpath(){return(0,l.promisify)(L.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return k}get writeFile(){return t}get rm(){return f}get move(){return S}get copy(){return D}}}),define(oe[147],ae([0,1,54,14,4,27,28]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const p=((0,O.basename)(m)||m).toLowerCase();try{const c=(0,_.readdirSync)(f).filter(d=>d.toLowerCase()===p);if(c.length===1){const d=R(f);if(d)return(0,O.join)(d,c[0])}else if(c.length>1){const d=c.indexOf(p);if(d>=0){const u=R(f);if(u)return(0,O.join)(u,c[d])}}}catch{}return null}e.realcaseSync=R;async function P(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const p=((0,O.basename)(m)||m).toLowerCase();try{const c=(await _.Promises.readdir(f)).filter(d=>d.toLowerCase()===p);if(c.length===1){const d=await P(f);if(d)return(0,O.join)(d,c[0])}else if(c.length>1){const d=c.indexOf(p);if(d>=0){const u=await P(f);if(u)return(0,O.join)(u,c[d])}}}catch{}return null}e.realcase=P;async function y(m){try{return await _.Promises.realpath(m)}catch{const p=E(m);return await _.Promises.access(p,L.constants.R_OK),p}}e.realpath=y;function I(m){try{return L.realpathSync(m)}catch{const p=E(m);return L.accessSync(p,L.constants.R_OK),p}}e.realpathSync=I;function E(m){return(0,A.rtrim)((0,O.normalize)(m),O.sep)}}),define(oe[94],ae([0,1,34,14,28]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,_=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(P||(P={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(k,i,o){this.exePath=k,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await l.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:v=!1}={}){return v?y===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:v=!1,findPreview:k=!1}={}){const i=m({useAlternateBitness:v});if(!i)return null;const o=O.join(i,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(o))return null;let n=-1,t=null;for(const a of await l.Promises.readdir(o)){let h=-1;if(k){const S=a.indexOf("-");if(S<0)continue;const D=a.substring(0,S);if(!A.test(D)||a.substring(S+1)!=="preview")continue;h=parseInt(D,10)}else{if(!A.test(a))continue;h=parseInt(a,10)}if(h<=n)continue;const w=O.join(o,a,"pwsh.exe");!await l.SymlinkSupport.existsFile(w)||(t=w,n=h)}if(!t)return null;const r=i.includes("x86")?" (x86)":"",s=k?" Preview":"";return new E(t,`PowerShell${s}${r}`,!0)}async function p({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const k=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:_,pwshMsixName:"PowerShell (Store)"};for(const n of await l.Promises.readdir(k))if(i.test(n)){const t=O.join(k,n,"pwsh.exe");return new E(t,o)}return null}function b(){const v=O.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(v,".NET Core PowerShell Global Tool")}function c(){const v=O.join(process.env.windir,y===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(v,"Windows PowerShell",!0)}async function*d(){let v=await f();v&&(yield v),v=await f({useAlternateBitness:!0}),v&&(yield v),v=await p(),v&&(yield v),v=b(),v&&(yield v),v=await f({findPreview:!0}),v&&(yield v),v=await p({findPreview:!0}),v&&(yield v),v=await f({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=c(),v&&(yield v)}async function*u(){for await(const v of d())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=u;async function g(){for await(const v of u())return v;return null}e.getFirstAvailablePowerShellInstallation=g}),define(oe[95],ae([0,1,14,4,36,88,11,28]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(E=l.env){return E.comspec||"cmd.exe"}e.getWindowsShell=P;function y(E){let m=[],f=!1;const p=function(b){if(f){m.push(b);return}(!E.send(b,d=>{if(d&&console.error(d),f=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(g=>p(g))}})||O.isWindows)&&(f=!0)};return{send:p}}e.createQueuedSender=y;var I;(function(E){async function m(f,p,b){if(L.isAbsolute(f))return f;if(p===void 0&&(p=l.cwd()),L.dirname(f)!=="."||(b===void 0&&_.isString(l.env.PATH)&&(b=l.env.PATH.split(L.delimiter)),b===void 0||b.length===0))return L.join(p,f);async function d(u){if(await R.Promises.exists(u)){let g;try{g=await R.Promises.stat(u)}catch(v){v.message.startsWith("EACCES")&&(g=await R.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of b){let g;if(L.isAbsolute(u)?g=L.join(u,f):g=L.join(p,u,f),await d(g))return g;let v=g+".com";if(await d(v)||(v=g+".exe",await d(v)))return v}return L.join(p,f)}E.findExecutable=m})(I=e.win32||(e.win32={}))}),define(oe[148],ae([0,1,49,22]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(_){return new Promise((R,P)=>{let y;const I=new Map;function E(f,p,b,c,d){const u=I.get(p);if(f===_||u){const g={name:m(b),cmd:b,pid:f,ppid:p,load:c,mem:d};I.set(f,g),f===_&&(y=g),u&&(u.children||(u.children=[]),u.children.push(g),u.children.length>1&&(u.children=u.children.sort((v,k)=>v.pid-k.pid)))}}function m(f){const p=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(f))return"electron-crash-reporter";if(d.exec(f))return"winpty-process";if(u.exec(f))return"console-window-host (Windows internal process)";let v=g.exec(f);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?p.exec(f)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const k=/[a-zA-Z-]+\.js/g;let i="";do v=k.exec(f),v&&(i+=v+" ");while(v);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:b.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,b)=>{ie(["windows-process-tree"],p,b)}).then(p=>{p.getProcessList(_,b=>{if(!b){P(new Error(`Root process ${_} not found`));return}p.getProcessCpuUsage(b,c=>{const d=new Map;c.forEach(u=>{const g=f(u.commandLine||"");d.set(u.pid,{name:m(g),cmd:g,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),y=d.get(_),y?(d.forEach(u=>{const g=d.get(u.ppid);g&&(g.children||(g.children=[]),g.children.push(u))}),d.forEach(u=>{u.children&&(u.children=u.children.sort((g,v)=>g.pid-v.pid))}),R(y)):P(new Error(`Root process ${_} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[y];const b=[];for(;p.length;){const d=p.shift();d&&(b.push(d.pid),d.children&&(p=p.concat(d.children)))}let c=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+b.join(" "),(0,L.exec)(c,{},(d,u,g)=>{if(d||g)P(d||new Error(g.toString()));else{const v=u.toString().split(`
`);for(let k=0;k<b.length;k++){const i=I.get(b[k]);i.load=parseFloat(v[k])}if(!y){P(new Error(`Root process ${_} not found`));return}R(y)}})};(0,L.exec)("which ps",{},(p,b,c)=>{if(p||c)if(process.platform!=="linux")P(p||new Error(c.toString()));else{const d=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(d,{},(u,g,v)=>{u||v?P(u||new Error(v.toString())):(A(g,E),f())})}else{const d=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${d} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,k)=>{g||k&&!k.includes("screen size is bogus")?P(g||new Error(k.toString())):(A(v,E),process.platform==="linux"?f():y?R(y):P(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=l;function A(_,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=_.toString().split(`
`);for(const I of y){const E=P.exec(I.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(oe[149],ae([0,1,34,4,94,95]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function _(E,m){return E===1?O.isWindows?I():A.getWindowsShell(m):P(E,m)}e.getSystemShell=_;let R=null;function P(E,m){if(O.isLinux&&E===2||O.isMacintosh&&E===3)return"/bin/bash";if(!R){let f;if(O.isWindows)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}R=f}return R}let y=null;async function I(){return y||(y=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),y}});var ve=this&&this.__decorate||function(ie,e,L,O){var l=arguments.length,A=l<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,L):O,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,L,O);else for(var R=ie.length-1;R>=0;R--)(_=ie[R])&&(A=(l<3?_(A):l>3?_(e,L,A):_(e,L))||A);return l>3&&A&&Object.defineProperty(e,L,A),A};define(oe[39],ae([0,1,21,6,16,25,62,10,3,2,91,27,11]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(f||(f={}));function p(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(b||(b={}));function c(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(d||(d={}));function u(j){let F=0;for(let ee=0;;ee+=7){const ne=j.read(1);if(F|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return F}}const g=n(0);function v(j,F){if(F===0){j.write(g);return}let ee=0;for(let se=F;se!==0;se=se>>>7)ee++;const ne=l.VSBuffer.alloc(ee);for(let se=0;F!==0;se++)ne.buffer[se]=F&127,F=F>>>7,F>0&&(ne.buffer[se]|=128);j.write(ne)}class k{constructor(F){this.buffer=F,this.pos=0}read(F){const ee=this.buffer.slice(this.pos,this.pos+F);return this.pos+=ee.byteLength,ee}}e.BufferReader=k;class i{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}e.BufferWriter=i;var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(o||(o={}));function n(j){const F=l.VSBuffer.alloc(1);return F.writeUInt8(j,0),F}const t={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},r=typeof Buffer<"u";function s(j,F){if(typeof F>"u")j.write(t.Undefined);else if(typeof F=="string"){const ee=l.VSBuffer.fromString(F);j.write(t.String),v(j,ee.byteLength),j.write(ee)}else if(r&&Buffer.isBuffer(F)){const ee=l.VSBuffer.wrap(F);j.write(t.Buffer),v(j,ee.byteLength),j.write(ee)}else if(F instanceof l.VSBuffer)j.write(t.VSBuffer),v(j,F.byteLength),j.write(F);else if(Array.isArray(F)){j.write(t.Array),v(j,F.length);for(const ee of F)s(j,ee)}else if(typeof F=="number"&&(F|0)===F)j.write(t.Uint),v(j,F);else{const ee=l.VSBuffer.fromString(JSON.stringify(F));j.write(t.Object),v(j,ee.byteLength),j.write(ee)}}e.serialize=s;function a(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(u(j)).toString();case o.Buffer:return j.read(u(j)).buffer;case o.VSBuffer:return j.read(u(j));case o.Array:{const ee=u(j),ne=[];for(let se=0;se<ee;se++)ne.push(a(j));return ne}case o.Object:return JSON.parse(j.read(u(j)).toString());case o.Int:return u(j)}}e.deserialize=a;class h{constructor(F,ee,ne=null,se=1e3){this.protocol=F,this.ctx=ee,this.logger=ne,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(F,ee){this.channels.set(F,ee),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const ee=this.send([F.type]);this.logger?.logOutgoing(ee,0,1,c(F.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(ee,F.id,1,c(F.type),F.data);return}}}send(F,ee=void 0){const ne=new i;return s(ne,F),s(ne,ee),this.sendBuffer(ne.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const ee=new k(F),ne=a(ee),se=a(ee),H=ne[0];switch(H){case 100:return this.logger?.logIncoming(F.byteLength,ne[1],1,`${p(H)}: ${ne[2]}.${ne[3]}`,se),this.onPromise({type:H,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 102:return this.logger?.logIncoming(F.byteLength,ne[1],1,`${p(H)}: ${ne[2]}.${ne[3]}`,se),this.onEventListen({type:H,id:ne[1],channelName:ne[2],name:ne[3],arg:se});case 101:return this.logger?.logIncoming(F.byteLength,ne[1],1,`${p(H)}`),this.disposeActiveRequest({type:H,id:ne[1]});case 103:return this.logger?.logIncoming(F.byteLength,ne[1],1,`${p(H)}`),this.disposeActiveRequest({type:H,id:ne[1]})}}onPromise(F){const ee=this.channels.get(F.channelName);if(!ee){this.collectPendingRequest(F);return}const ne=new A.CancellationTokenSource;let se;try{se=ee.call(this.ctx,F.name,F.arg,ne.token)}catch(N){se=Promise.reject(N)}const H=F.id;se.then(N=>{this.sendResponse({id:H,data:N,type:201}),this.activeRequests.delete(F.id)},N=>{N instanceof Error?this.sendResponse({id:H,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:H,data:N,type:203}),this.activeRequests.delete(F.id)});const B=(0,y.toDisposable)(()=>ne.cancel());this.activeRequests.set(F.id,B)}onEventListen(F){const ee=this.channels.get(F.channelName);if(!ee){this.collectPendingRequest(F);return}const ne=F.id,H=ee.listen(this.ctx,F.name,F.arg)(B=>this.sendResponse({id:ne,data:B,type:204}));this.activeRequests.set(F.id,H)}disposeActiveRequest(F){const ee=this.activeRequests.get(F.id);ee&&(ee.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let ee=this.pendingRequests.get(F.channelName);ee||(ee=[],this.pendingRequests.set(F.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:F,timeoutTimer:ne})}flushPendingRequests(F){const ee=this.pendingRequests.get(F);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var w;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(F,ee=null){this.protocol=F,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=ee}getChannel(F){const ee=this;return{call(ne,se,H){return ee.isDisposed?Promise.reject(new R.CancellationError):ee.requestPromise(F,ne,se,H)},listen(ne,se){return ee.isDisposed?P.Event.None:ee.requestEvent(F,ne,se)}}}requestPromise(F,ee,ne,se=A.CancellationToken.None){const H=this.lastRequestId++,N={id:H,type:100,channelName:F,name:ee,arg:ne};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let C;return new Promise(($,G)=>{if(se.isCancellationRequested)return G(new R.CancellationError);const W=()=>{const he=pe=>{switch(pe.type){case 201:this.handlers.delete(H),$(pe.data);break;case 202:{this.handlers.delete(H);const fe=new Error(pe.data.message);fe.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,fe.name=pe.data.name,G(fe);break}case 203:this.handlers.delete(H),G(pe.data);break}};this.handlers.set(H,he),this.sendRequest(N)};let Z=null;this.state===d.Idle?W():(Z=(0,O.createCancelablePromise)(he=>this.whenInitialized()),Z.then(()=>{Z=null,W()}));const te=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:H,type:101}),G(new R.CancellationError)},ce=se.onCancellationRequested(te);C=(0,y.combinedDisposable)((0,y.toDisposable)(te),ce),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(F,ee,ne){const se=this.lastRequestId++,B={id:se,type:102,channelName:F,name:ee,arg:ne};let N=null;const C=new P.Emitter({onWillAddFirstListener:()=>{N=(0,O.createCancelablePromise)($=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(C),this.sendRequest(B)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(C),this.sendRequest({id:se,type:103}))}}),U=$=>C.fire($.data);return this.handlers.set(se,U),C.event}sendRequest(F){switch(F.type){case 100:case 102:{const ee=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(ee,F.id,0,`${p(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const ee=this.send([F.type,F.id]);this.logger?.logOutgoing(ee,F.id,0,p(F.type));return}}}send(F,ee=void 0){const ne=new i;return s(ne,F),s(ne,ee),this.sendBuffer(ne.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const ee=new k(F),ne=a(ee),se=a(ee),H=ne[0];switch(H){case 200:return this.logger?.logIncoming(F.byteLength,0,0,c(H)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,ne[1],0,c(H),se),this.onResponse({type:ne[0],id:ne[1],data:se})}}onResponse(F){if(F.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([_.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class D{get connections(){const F=[];return this._connections.forEach(ee=>F.push(ee)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:ee,onDidClientDisconnect:ne})=>{P.Event.once(ee.onMessage)(H=>{const B=new k(H),N=a(B),C=new h(ee,N),U=new S(ee);this.channels.forEach((G,W)=>C.registerChannel(W,G));const $={channelServer:C,channelClient:U,ctx:N};this._connections.add($),this._onDidAddConnection.fire($),ne(()=>{C.dispose(),U.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}getChannel(F,ee){const ne=this;return{call(se,H,B){let N;if((0,m.isFunction)(ee)){const U=(0,L.getRandomElement)(ne.connections.filter(ee));N=U?Promise.resolve(U):P.Event.toPromise(P.Event.filter(ne.onDidAddConnection,ee))}else N=ee.routeCall(ne,se,H);const C=N.then(U=>U.channelClient.getChannel(F));return M(C).call(se,H,B)},listen(se,H){if((0,m.isFunction)(ee))return ne.getMulticastEvent(F,ee,se,H);const B=ee.routeEvent(ne,se,H).then(N=>N.channelClient.getChannel(F));return M(B).listen(se,H)}}}getMulticastEvent(F,ee,ne,se){const H=this;let B=new y.DisposableStore;const N=new P.Emitter({onWillAddFirstListener:()=>{B=new y.DisposableStore;const C=new P.EventMultiplexer,U=new Map,$=W=>{const te=W.channelClient.getChannel(F).listen(ne,se),ce=C.add(te);U.set(W,ce)},G=W=>{const Z=U.get(W);!Z||(Z.dispose(),U.delete(W))};H.connections.filter(ee).forEach($),P.Event.filter(H.onDidAddConnection,ee)($,void 0,B),H.onDidRemoveConnection(G,void 0,B),C.event(N.fire,N,B),B.add(C)},onDidRemoveLastListener:()=>{B.dispose()}});return N.event}registerChannel(F,ee){this.channels.set(F,ee),this._connections.forEach(ne=>{ne.channelServer.registerChannel(F,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class T{constructor(F,ee,ne=null){const se=new i;s(se,ee),F.send(se.buffer),this.channelClient=new S(F,ne),this.channelServer=new h(F,ee,ne)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,ee){this.channelServer.registerChannel(F,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function M(j){return{call(F,ee,ne){return j.then(se=>se.call(F,ee,ne))},listen(F,ee){const ne=new P.Relay;return j.then(se=>ne.input=se.listen(F,ee)),ne.event}}}e.getDelayedChannel=M;function x(j){let F=!1;return{call(ee,ne,se){return F?j.call(ee,ne,se):(0,O.timeout)(0).then(()=>F=!0).then(()=>j.call(ee,ne,se))},listen(ee,ne){if(F)return j.listen(ee,ne);const se=new P.Relay;return(0,O.timeout)(0).then(()=>F=!0).then(()=>se.input=j.listen(ee,ne)),se.event}}}e.getNextTickChannel=x;class V{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const ee of F.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await P.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=V;var q;(function(j){function F(H,B){const N=H,C=B&&B.disableMarshalling,U=new Map;for(const $ in N)ne($)&&U.set($,P.Event.buffer(N[$],!0));return new class{listen($,G,W){const Z=U.get(G);if(Z)return Z;if(se(G)){const te=N[G];if(typeof te=="function")return te.call(N,W)}throw new Error(`Event not found: ${G}`)}call($,G,W){const Z=N[G];if(typeof Z=="function"){if(!C&&Array.isArray(W))for(let te=0;te<W.length;te++)W[te]=(0,I.revive)(W[te]);return Z.apply(N,W)}throw new Error(`Method not found: ${G}`)}}}j.fromService=F;function ee(H,B){const N=B&&B.disableMarshalling;return new Proxy({},{get(C,U){if(typeof U=="string")return B?.properties?.has(U)?B.properties.get(U):se(U)?function($){return H.listen(U,$)}:ne(U)?H.listen(U):async function(...$){let G;B&&!(0,m.isUndefinedOrNull)(B.context)?G=[B.context,...$]:G=$;const W=await H.call(U,G);return N?W:(0,I.revive)(W)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=ee;function ne(H){return H[0]==="o"&&H[1]==="n"&&E.isUpperAsciiLetter(H.charCodeAt(2))}function se(H){return/^onDynamic/.test(H)&&E.isUpperAsciiLetter(H.charCodeAt(9))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const F=j.toString();if(F!=="[object Object]")return F}return j}function Q(j){return Array.isArray(j)?j.map(J):J(j)}function K(j,F,ee,ne,se,H,B){B=Q(B);const N=z[se],C=N[ne%N.length];let U=[`%c[${j}]%c[${String(F).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(H)?(U=U.concat(B),U.push(")")):U.push(B),console.log.apply(console,U)}class X{constructor(F,ee){this._outgoingPrefix=F,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,ee,ne,se,H){this._totalOutgoing+=F,K(this._outgoingPrefix,this._totalOutgoing,F,ee,ne,se,H)}logIncoming(F,ee,ne,se,H){this._totalIncoming+=F,K(this._incomingPrefix,this._totalIncoming,F,ee,ne,se,H)}}e.IPCLogger=X}),define(oe[150],ae([0,1,16,3,39]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(P){this.port=P,this.onMessage=O.Event.fromDOMEventEmitter(this.port,"message",y=>L.VSBuffer.wrap(y.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class _ extends l.IPCClient{constructor(P,y){const I=new A(P);super(I,y),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=_}),define(oe[96],ae([0,1,6,16,3,2,39]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(S){S.Created="created",S.Read="read",S.Write="write",S.Open="open",S.Error="error",S.Close="close",S.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",S.NodeEndReceived="nodeEndReceived",S.NodeEndSent="nodeEndSent",S.NodeDrainBegin="nodeDrainBegin",S.NodeDrainEnd="nodeDrainEnd",S.zlibInflateError="zlibInflateError",S.zlibInflateData="zlibInflateData",S.zlibInflateInitialWrite="zlibInflateInitialWrite",S.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",S.zlibInflateWrite="zlibInflateWrite",S.zlibInflateFlushFired="zlibInflateFlushFired",S.zlibDeflateError="zlibDeflateError",S.zlibDeflateData="zlibDeflateData",S.zlibDeflateWrite="zlibDeflateWrite",S.zlibDeflateFlushFired="zlibDeflateFlushFired",S.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",S.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",S.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",S.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",S.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",S.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",S.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",S.ProtocolHeaderRead="protocolHeaderRead",S.ProtocolMessageRead="protocolMessageRead",S.ProtocolHeaderWrite="protocolHeaderWrite",S.ProtocolMessageWrite="protocolMessageWrite",S.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(S){S.enableDiagnostics=!1,S.records=[];const D=new WeakMap;let T=0;function M(V,q){if(!D.has(V)){const z=String(++T);D.set(V,z)}return D.get(V)}function x(V,q,z,J){if(!S.enableDiagnostics)return;const Q=M(V,q);if(J instanceof O.VSBuffer||J instanceof Uint8Array||J instanceof ArrayBuffer||ArrayBuffer.isView(J)){const K=O.VSBuffer.alloc(J.byteLength);K.set(J),S.records.push({timestamp:Date.now(),id:Q,label:q,type:z,buff:K})}else S.records.push({timestamp:Date.now(),id:Q,label:q,type:z,data:J})}S.traceSocketEvent=x})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(S){S[S.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",S[S.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function E(){return I||(I=O.VSBuffer.alloc(0)),I}class m{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(D){this._chunks.push(D),this._totalLength+=D.byteLength}read(D){return this._read(D,!0)}peek(D){return this._read(D,!1)}_read(D,T){if(D===0)return E();if(D>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===D){const q=this._chunks[0];return T&&(this._chunks.shift(),this._totalLength-=D),q}if(this._chunks[0].byteLength>D){const q=this._chunks[0].slice(0,D);return T&&(this._chunks[0]=this._chunks[0].slice(D),this._totalLength-=D),q}const M=O.VSBuffer.alloc(D);let x=0,V=0;for(;D>0;){const q=this._chunks[V];if(q.byteLength>D){const z=q.slice(0,D);M.set(z,x),x+=D,T&&(this._chunks[V]=q.slice(D),this._totalLength-=D),D-=D}else M.set(q,x),x+=q.byteLength,T?(this._chunks.shift(),this._totalLength-=q.byteLength):V++,D-=q.byteLength}return M}}e.ChunkStream=m;var f;(function(S){S[S.None=0]="None",S[S.Regular=1]="Regular",S[S.Control=2]="Control",S[S.Ack=3]="Ack",S[S.Disconnect=5]="Disconnect",S[S.ReplayRequest=6]="ReplayRequest",S[S.Pause=7]="Pause",S[S.Resume=8]="Resume",S[S.KeepAlive=9]="KeepAlive",S[S.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",S[S.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function p(S){switch(S){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(S){S[S.HeaderLength=13]="HeaderLength",S[S.AcknowledgeTime=2e3]="AcknowledgeTime",S[S.TimeoutTime=2e4]="TimeoutTime",S[S.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",S[S.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",S[S.KeepAliveSendTime=5e3]="KeepAliveSendTime",S[S.LatencySampleTime=6e4]="LatencySampleTime",S[S.LatencySampleCount=5]="LatencySampleCount",S[S.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",S[S.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(D,T,M,x){this.type=D,this.id=T,this.ack=M,this.data=x,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends A.Disposable{constructor(D){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=D,this._isDisposed=!1,this._incomingData=new m,this._register(this._socket.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(D){if(!(!D||D.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(D);this._incomingData.byteLength>=this._state.readLen;){const T=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=T.readUInt32BE(9),this._state.messageType=T.readUInt8(0),this._state.id=T.readUInt32BE(1),this._state.ack=T.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const M=this._state.messageType,x=this._state.id,V=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",T),this._onMessage.fire(new c(M,x,V,T)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(D){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=D,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(D){if(this._isDisposed)return;D.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=O.VSBuffer.alloc(13);T.writeUInt8(D.type,0),T.writeUInt32BE(D.id,1),T.writeUInt32BE(D.ack,5),T.writeUInt32BE(D.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(D.type),id:D.id,ack:D.ack,messageSize:D.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",D.data),this._writeSoon(T,D.data)}_bufferAdd(D,T){const M=this._totalLength===0;return this._data.push(D,T),this._totalLength+=D.byteLength+T.byteLength,M}_bufferTake(){const D=O.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,D}_writeSoon(D,T){this._bufferAdd(D,T)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const D=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:D.byteLength}),this._socket.write(D)}}class g extends A.Disposable{constructor(D){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=D,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(T=>{T.type===1&&this._onMessage.fire(T.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(D){this._socketWriter.write(new c(1,0,0,D))}}e.Protocol=g;class v extends _.IPCClient{static fromSocket(D,T){return new v(new g(D),T)}get onDidDispose(){return this.protocol.onDidDispose}constructor(D,T,M=null){super(D,T,M),this.protocol=D}dispose(){super.dispose();const D=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),D.end()}}e.Client=v;class k{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(D){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(D):this._emitter.fire(D):this._bufferedMessages.push(D)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=k;class i{constructor(D){this.data=D,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let D=0,T=this._first;for(;T;)T=T.next,D++;return D}peek(){return this._first?this._first.data:null}toArray(){const D=[];let T=0,M=this._first;for(;M;)D[T++]=M.data,M=M.next;return D}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(D){const T=new i(D);if(!this._first){this._first=T,this._last=T;return}this._last.next=T,this._last=T}}class n{static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const D=Date.now();for(let T=0;T<n._HISTORY_LENGTH;T++)this.lastRuns[T]=D-1e3*T;setInterval(()=>{for(let T=n._HISTORY_LENGTH;T>=1;T--)this.lastRuns[T]=this.lastRuns[T-1];this.lastRuns[0]=Date.now()},1e3)}load(){const D=Date.now(),T=(1+n._HISTORY_LENGTH)*1e3;let M=0;for(let x=0;x<n._HISTORY_LENGTH;x++)D-this.lastRuns[x]<=T&&M++;return 1-M/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;var t;(function(S){S[S.Good=0]="Good",S[S.Poor=1]="Poor"})(t=e.ConnectionHealth||(e.ConnectionHealth={}));function r(S){switch(S){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class s{constructor(D){this.connectionHealth=D}}e.ConnectionHealthChangedEvent=s;class a{constructor(D,T){this.roundTripTime=D,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=a;class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(D){this._onControlMessage=new k,this.onControlMessage=this._onControlMessage.event,this._onMessage=new k,this.onMessage=this._onMessage.event,this._onDidDispose=new k,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new k,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new k,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new k,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new k,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=D.loadEstimator??n.getInstance(),this._measureRoundTripTime=D.measureRoundTripTime??!1,this._shouldSendKeepAlive=D.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=D.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(T=>this._receiveMessage(T))),this._socketDisposables.add(this._socket.onClose(T=>this._onSocketClose.fire(T))),this._socketLatencyMonitor=this._socketDisposables.add(new w),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(T=>this._sendLatencyMeasurementRequest(T))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(T=>this._onHighRoundTripTime.fire(T))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(T=>this._onDidChangeConnectionHealth.fire(T))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),D.initialChunk&&this._socketReader.acceptChunk(D.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const D=new c(5,0,0,E());this._socketWriter.write(D),this._socketWriter.flush()}sendPause(){const D=new c(7,0,0,E());this._socketWriter.write(D)}sendResume(){const D=new c(8,0,0,E());this._socketWriter.write(D)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(D,T){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=D,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.add(this._socket.onClose(M=>this._onSocketClose.fire(M))),this._socketLatencyMonitor=this._socketDisposables.add(new w),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(M=>this._sendLatencyMeasurementRequest(M))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(M=>this._onHighRoundTripTime.fire(M))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(M=>this._onDidChangeConnectionHealth.fire(M))),this._socketReader.acceptChunk(T)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const D=new c(3,0,this._incomingAckId,E());this._socketWriter.write(D);const T=this._outgoingUnackMsg.toArray();for(let M=0,x=T.length;M<x;M++)this._socketWriter.write(T[M]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(D){if(D.ack>this._outgoingAckId){this._outgoingAckId=D.ack;do{const T=this._outgoingUnackMsg.peek();if(T&&T.id<=D.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(D.type){case 0:break;case 1:{if(D.id>this._incomingMsgId)if(D.id!==this._incomingMsgId+1){const T=Date.now();T-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=T,this._socketWriter.write(new c(6,0,0,E())))}else this._incomingMsgId=D.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(D.data);break}case 2:{this._onControlMessage.fire(D.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const T=this._outgoingUnackMsg.toArray();for(let M=0,x=T.length;M<x;M++)this._socketWriter.write(T[M]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(D.data);break}case 11:{this._socketLatencyMonitor.handleResponse(D.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(D){const T=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const M=new c(1,T,this._incomingAckId,D);this._outgoingUnackMsg.push(M),this._isReconnecting||(this._socketWriter.write(M),this._recvAckCheck())}sendControl(D){const T=new c(2,0,0,D);this._socketWriter.write(T)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const D=Date.now()-this._incomingMsgLastTime;if(D>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-D+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const D=this._outgoingUnackMsg.peek(),T=Date.now()-D.writtenTime,M=Date.now()-this._socketReader.lastReadTime,x=Date.now()-this._lastSocketTimeoutTime;if(T>=2e4&&M>=2e4&&x>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:M});return}const V=Math.max(2e4-T,2e4-M,2e4-x,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},V)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const D=new c(3,0,this._incomingAckId,E());this._socketWriter.write(D)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const D=new c(9,0,this._incomingAckId,E());this._socketWriter.write(D)}_sendLatencyMeasurementRequest(D){this._incomingAckId=this._incomingMsgId;const T=new c(10,0,this._incomingAckId,D);this._socketWriter.write(T)}_sendLatencyMeasurementResponse(D){this._incomingAckId=this._incomingMsgId;const T=new c(11,0,this._incomingAckId,D);this._socketWriter.write(T)}}e.PersistentProtocol=h;class w extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new L.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},D=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const D=++this._lastLatencyMeasurementId,T=O.VSBuffer.alloc(4);T.writeUInt32BE(D,0),this._onSendLatencyRequest.fire(T)},6e4)}handleResponse(D){if(D.byteLength!==4)return;const T=D.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||T!==this._lastLatencyMeasurementId)return;const M=Date.now()-this._lastLatencyMeasurementSent,x=this._latencySampleIndex++;this._latencySamples[x%this._latencySamples.length]=M;const V=this._connectionHealth,q=this._latencySamples.filter(z=>z>=1e3).length;this._connectionHealth=q>=3?1:0,M>1e3&&this._onHighRoundTripTime.fire(new a(M,q)),V!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(oe[151],ae([0,1,152,3,39,150]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class _ extends l.IPCServer{static getOnDidClientConnect(){const P=O.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(y,I)=>I);return O.Event.map(P,y=>{const{port1:I,port2:E}=new MessageChannel,f={protocol:new A.Protocol(I),onDidClientDisconnect:O.Event.fromDOMEventEmitter(I,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",y,[E]),f})}constructor(){super(_.getOnDidClientConnect())}}e.Server=_}),define(oe[65],ae([0,1,49,6,16,25,145,10,3,2,32,95,88,39]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(d){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",u=>l.VSBuffer.wrap(Buffer.from(u,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=p;class b{constructor(d,u){this.modulePath=d,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new O.Delayer(g),this.child=null,this._client=null}getChannel(d){const u=this;return{call(g,v,k){return u.requestPromise(d,g,v,k)},listen(g,v){return u.requestEvent(d,g,v)}}}requestPromise(d,u,g,v=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const k=this.getCachedChannel(d),i=(0,O.createCancelablePromise)(t=>k.call(u,g,t)),o=v.onCancellationRequested(()=>i.cancel()),n=(0,y.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(d,u,g){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let v;const k=new P.Emitter({onWillAddFirstListener:()=>{v=this.getCachedChannel(d).listen(u,g)(k.fire,k),this.activeRequests.add(v)},onDidRemoveLastListener:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return k.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(u.env),this.child=(0,L.fork)(this.modulePath,d,u);const g=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,_.isRemoteConsoleLog)(r)){(0,_.log)(r,`IPC Library: ${this.options.serverName}`);return}g.fire(l.VSBuffer.wrap(Buffer.from(r,"base64")))});const k=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&k.send(r.buffer.toString("base64")),o=g.event,n={send:i,onMessage:o};this._client=new f.ChannelClient(n);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,s)=>{process.removeListener("exit",t),this.activeRequests.forEach(a=>(0,y.dispose)(a)),this.activeRequests.clear(),r!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+s),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:s})})}return this._client}getCachedChannel(d){let u=this.channels.get(d);return u||(u=this.client.getChannel(d),this.channels.set(d,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(oe[153],ae([0,1,87,16,39,3,11,21]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class P{constructor(m){this.port=m,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",f=>O.VSBuffer.wrap(f.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}class y extends l.IPCServer{static getOnDidClientConnect(){(0,_.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const m=new A.Emitter;return process.parentPort.on("message",f=>{const p=(0,R.firstOrDefault)(f.ports);p&&m.fire(p)}),A.Event.map(m.event,f=>({protocol:new P(f),onDidClientDisconnect:A.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(y.getOnDidClientConnect())}}e.Server=y;function I(E,m,f){const p=b=>{b.data===m&&(E.removeListener("message",p),f())};E.on("message",p)}e.once=I}),define(oe[154],ae([0,1,16,10,3,2,14,4,31,39,96]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(a,h){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}constructor(a,h=""){this._canWrite=!0,this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,O.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener),this._closeListener=w=>{this.traceSocketEvent("close",{hadError:w}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const h=w=>{this.traceSocketEvent("read",w),a(L.VSBuffer.wrap(w))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,O.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,O.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var f;(function(s){s[s.MinHeaderByteSize=2]="MinHeaderByteSize",s[s.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var p;(function(s){s[s.PeekHeader=1]="PeekHeader",s[s.ReadHeader=2]="ReadHeader",s[s.ReadBody=3]="ReadBody",s[s.Fin=4]="Fin"})(p||(p={}));class b extends A.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}constructor(a,h,w,S){super(),this._onData=this._register(new l.Emitter),this._onClose=this._register(new l.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:w?.byteLength||0,recordInflateBytes:S}),this._flowManager=this._register(new c(this,h,w,S,this._onData,(D,T)=>this._write(D,T))),this._register(this._flowManager.onError(D=>{console.error(D),(0,O.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(async D=>{this._flowManager.isProcessingReadQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(D)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let h=0;for(;h<a.byteLength;)this._flowManager.writeMessage(a.slice(h,Math.min(h+262144,a.byteLength))),h+=262144}_write(a,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const S=L.VSBuffer.alloc(w);if(h?S.writeUInt8(194,0):S.writeUInt8(130,0),a.byteLength<126)S.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){S.writeUInt8(126,1);let D=1;S.writeUInt8(a.byteLength>>>8&255,++D),S.writeUInt8(a.byteLength>>>0&255,++D)}else{S.writeUInt8(127,1);let D=1;S.writeUInt8(0,++D),S.writeUInt8(0,++D),S.writeUInt8(0,++D),S.writeUInt8(0,++D),S.writeUInt8(a.byteLength>>>24&255,++D),S.writeUInt8(a.byteLength>>>16&255,++D),S.writeUInt8(a.byteLength>>>8&255,++D),S.writeUInt8(a.byteLength>>>0&255,++D)}this.socket.write(L.VSBuffer.concat([S,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),w=h.readUInt8(0),S=(w&128)>>>7,D=(w&64)>>>6,T=h.readUInt8(1),M=(T&128)>>>7,x=T&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=S,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(S),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),w=h.readUInt8(1),S=(w&128)>>>7;let D=w&127,T=1;D===126?D=h.readUInt8(++T)*2**8+h.readUInt8(++T):D===127&&(D=h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T));let M=0;S&&(M=h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T)),this._state.state=3,this._state.readLen=D,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),g(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class c extends A.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(a,h,w,S,D,T){super(),this._tracer=a,this._onData=D,this._writeFn=T,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new l.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new l.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new d(this._tracer,S,w,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(h,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,h){return new Promise((w,S)=>{a.write(h),a.flush(D=>w(D))})}acceptFrame(a,h,w){this._readQueue.push({data:a,isCompressed:h,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(a,h,w){return new Promise((S,D)=>{a.write(h),w&&a.write(L.VSBuffer.fromByteArray([0,0,255,255])),a.flush(T=>S(T))})}}class d extends A.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}constructor(a,h,w,S){super(),this._tracer=a,this._recordInflateBytes=h,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E().zlib.createInflateRaw(S),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(L.VSBuffer.wrap(D))}),w&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(h)})}}class u extends A.Disposable{constructor(a,h){super(),this._tracer=a,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent("zlibDeflateData",w),this._pendingDeflateData.push(L.VSBuffer.wrap(w))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function g(s,a){if(a===0)return;const h=s.byteLength>>>2;for(let x=0;x<h;x++){const V=s.readUInt32BE(x*4);s.writeUInt32BE(V^a,x*4)}const w=h*4,S=s.byteLength-w,D=a>>>24&255,T=a>>>16&255,M=a>>>8&255;S>=1&&s.writeUInt8(s.readUInt8(w)^D,w),S>=2&&s.writeUInt8(s.readUInt8(w+1)^T,w+1),S>=3&&s.writeUInt8(s.readUInt8(w+2)^M,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function k(){const s=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${s}-sock`;const a=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:E().os.tmpdir(),h=(0,_.join)(a,`vscode-ipc-${s}.sock`);return o(h),h}e.createRandomIPCHandle=k;function i(s,a,h){const w=E().crypto.createHash("md5").update(s).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${h}-${a}-sock`;const S=h.substr(0,4),D=a.substr(0,6),T=w.substr(0,8);let M;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${T}-${S}-${D}.sock`):M=(0,_.join)(s,`${S}-${D}.sock`),o(M),M}e.createStaticIPCHandle=i;function o(s){const a=v[R.platform];typeof a=="number"&&s.length>=a&&console.warn(`WARNING: IPC handle "${s}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends y.IPCServer{static toClientConnectionEvent(a){const h=l.Event.fromNodeEventEmitter(a,"connection");return l.Event.map(h,w=>({protocol:new I.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(n.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(s){return new Promise((a,h)=>{const w=E().net.createServer();w.on("error",h),w.listen(s,()=>{w.removeListener("error",h),a(new n(w))})})}e.serve=t;function r(s,a){return new Promise((h,w)=>{const S=E().net.createConnection(s,()=>{S.removeListener("error",w),h(I.Client.fromSocket(new m(S,`ipc-client${a}`),a))});S.once("error",w)})}e.connect=r}),define(oe[66],ae([0,1,6,3,2,11]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var _;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(_=e.StorageHint||(e.StorageHint={}));function R(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class y extends l.Disposable{constructor(m,f=Object.create(null)){super(),this.database=m,this.options=f,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((f,p)=>this.accept(p,f)),m.deleted?.forEach(f=>this.accept(f,void 0))}accept(m,f){if(this.state===P.Closed)return;let p=!1;(0,A.isUndefinedOrNull)(f)?p=this.cache.delete(m):this.cache.get(m)!==f&&(this.cache.set(m,f),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,f){const p=this.cache.get(m);return(0,A.isUndefinedOrNull)(p)?f:p}getBoolean(m,f){const p=this.get(m);return(0,A.isUndefinedOrNull)(p)?f:p==="true"}getNumber(m,f){const p=this.get(m);return(0,A.isUndefinedOrNull)(p)?f:parseInt(p,10)}async set(m,f){if(this.state===P.Closed)return;if((0,A.isUndefinedOrNull)(f))return this.delete(m);const p=String(f);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===P.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===_.STORAGE_IN_MEMORY}dispose(){this.flushDelayer.dispose(),super.dispose()}}y.DEFAULT_FLUSH_DELAY=100,e.Storage=y;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((f,p)=>this.items.set(p,f)),m.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(oe[155],ae([8,7]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(oe[156],ae([8,7]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[157],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[158],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(oe[159],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(oe[160],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(oe[161],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[162],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[163],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[164],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(oe[165],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[166],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[167],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[168],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[169],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(oe[170],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(oe[171],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(oe[172],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[173],ae([8,7]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[174],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[175],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[176],ae([8,7]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(oe[177],ae([8,7]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(oe[178],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[179],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[180],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[181],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[182],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[183],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[184],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[185],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[186],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[187],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[188],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[189],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[190],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[191],ae([8,7]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(oe[192],ae([0,1,10,158]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function A(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const _=(0,O.localize)(3,null),R=(0,O.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(I){return this._input=I,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const E=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:E})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const E=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:E})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(I){return this._isAtEnd()||this._input.charCodeAt(this._current)!==I?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(I){this._tokens.push({type:I,offset:this._start})}_error(I){const E=this._start,m=this._input.substring(this._start,this._current),f={type:19,offset:this._start,lexeme:m};this._errors.push({offset:E,lexeme:m,additionalInfo:I}),this._tokens.push(f)}_string(){this.stringRe.lastIndex=this._start;const I=this.stringRe.exec(this._input);if(I){this._current=this._start+I[0].length;const E=this._input.substring(this._start,this._current),m=P._keywords.get(E);m?this._addToken(m):this._tokens.push({type:17,lexeme:E,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let I=this._current,E=!1,m=!1;for(;;){if(I>=this._input.length){this._current=I,this._error(R);return}const p=this._input.charCodeAt(I);if(E)E=!1;else if(p===47&&!m){I++;break}else p===91?m=!0:p===92?E=!0:p===93&&(m=!1);I++}for(;I<this._input.length&&P._regexFlags.has(this._input.charCodeAt(I));)I++;this._current=I;const f=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:f,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}P._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0))),P._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=P}),define(oe[193],ae([0,1,64,62,22,14,36,23,12]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class y{get appRoot(){return(0,A.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=_.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.join)(f,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?P.URI.file((0,A.resolve)(f)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const p=_.env.VSCODE_EXTENSIONS;if(p)return p;const b=_.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?P.URI.parse(p):P.URI.file((0,A.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=_.env.VSCODE_PORTABLE;return f?P.URI.file((0,A.join)(f,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this._args}constructor(f,p,b){this._args=f,this.paths=p,this.productService=b,this.editSessionId=this.args.editSessionId}}ve([O.memoize],y.prototype,"appRoot",null),ve([O.memoize],y.prototype,"userHome",null),ve([O.memoize],y.prototype,"userDataPath",null),ve([O.memoize],y.prototype,"appSettingsHome",null),ve([O.memoize],y.prototype,"tmpDir",null),ve([O.memoize],y.prototype,"cacheHome",null),ve([O.memoize],y.prototype,"stateResource",null),ve([O.memoize],y.prototype,"userRoamingDataHome",null),ve([O.memoize],y.prototype,"userDataSyncHome",null),ve([O.memoize],y.prototype,"sync",null),ve([O.memoize],y.prototype,"machineSettingsResource",null),ve([O.memoize],y.prototype,"workspaceStorageHome",null),ve([O.memoize],y.prototype,"localHistoryHome",null),ve([O.memoize],y.prototype,"keyboardLayoutResource",null),ve([O.memoize],y.prototype,"argvResource",null),ve([O.memoize],y.prototype,"isExtensionDevelopment",null),ve([O.memoize],y.prototype,"untitledWorkspacesHome",null),ve([O.memoize],y.prototype,"builtinExtensionsPath",null),ve([O.memoize],y.prototype,"extensionsPath",null),ve([O.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ve([O.memoize],y.prototype,"extensionDevelopmentKind",null),ve([O.memoize],y.prototype,"extensionTestsLocationURI",null),ve([O.memoize],y.prototype,"debugExtensionHost",null),ve([O.memoize],y.prototype,"logLevel",null),ve([O.memoize],y.prototype,"extensionLogLevel",null),ve([O.memoize],y.prototype,"serviceMachineIdResource",null),ve([O.memoize],y.prototype,"disableTelemetry",null),ve([O.memoize],y.prototype,"disableWorkspaceTrust",null),ve([O.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function I(m,f){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function E(m,f,p,b,c,d){const g=Number(f||m)||(b?null:p),v=g?Boolean(!!f):!1;let k;if(d)try{k=JSON.parse(d)}catch{}return{port:g,break:v,debugId:c,env:k}}e.parseDebugParams=E}),define(oe[194],ae([0,1,292,4,159]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const _={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(b,c,d=_){const u=b.find(s=>s.length>0&&s[0]!=="-"),g={},v=["_"],k=[],i={};let o;for(const s in c){const a=c[s];a.type==="subcommand"?s===u&&(o=a):(a.alias&&(g[s]=a.alias),a.type==="string"||a.type==="string[]"?(v.push(s),a.deprecates&&v.push(...a.deprecates)):a.type==="boolean"&&(k.push(s),a.deprecates&&k.push(...a.deprecates)),a.global&&(i[s]=a))}if(o&&u){const s=i;for(const S in o.options)s[S]=o.options[S];const a=b.filter(S=>S!==u),h=d.getSubcommandReporter?d.getSubcommandReporter(u):void 0,w=R(a,s,h);return{[u]:w,_:[]}}const n=L(b,{string:v,boolean:k,alias:g}),t={},r=n;t._=n._.map(s=>String(s)).filter(s=>s.length>0),delete r._;for(const s in c){const a=c[s];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let h=r[s];if(a.deprecates)for(const w of a.deprecates)r.hasOwnProperty(w)&&(h||(h=r[w],h&&d.onDeprecatedOption(w,a.deprecationMessage||(0,l.localize)(36,null,s))),delete r[w]);if(typeof h<"u"){if(a.type==="string[]"){if(Array.isArray(h)||(h=[h]),!a.allowEmptyValue){const w=h.filter(S=>S.length>0);w.length!==h.length&&(d.onEmptyValue(s),h=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(h)?(h=h.pop(),d.onMultipleValues(s,h)):!h&&!a.allowEmptyValue&&(d.onEmptyValue(s),h=void 0));t[s]=h,a.deprecationMessage&&d.onDeprecatedOption(s,a.deprecationMessage)}delete r[s]}for(const s in r)d.onUnknownOption(s);return t}e.parseArgs=R;function P(b,c){let d="";return c.args&&(Array.isArray(c.args)?d=` <${c.args.join("> <")}>`:d=` <${c.args}>`),c.alias?`-${c.alias} --${b}${d}`:`--${b}${d}`}function y(b,c){const d=[];for(const u in b){const g=b[u],v=P(u,g);d.push([v,g.description])}return I(d,c)}e.formatOptions=y;function I(b,c){const u=b.reduce((k,i)=>Math.max(k,i[0].length),12)+2+1;if(c-u<25)return b.reduce((k,i)=>k.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const g=c-u-1,v=[];for(const k of b){const i=k[0],o=m(k[1],g),n=E(u-i.length-2);v.push("  "+i+n+o[0]);for(let t=1;t<o.length;t++)v.push(E(u)+o[t])}return v}function E(b){return" ".repeat(b)}function m(b,c){const d=[];for(;b.length;){const u=b.length<c?b.length:b.lastIndexOf(" ",c),g=b.slice(0,u).trim();b=b.slice(u),d.push(g)}return d}function f(b,c,d,u,g){const v=process.stdout.isTTY&&process.stdout.columns||80,k=g?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",i=[`${b} ${d}`];i.push(""),i.push(`${(0,l.localize)(38,null)}: ${c} [${(0,l.localize)(39,null)}]${k}`),i.push(""),g?.noPipe!==!0&&(O.isWindows?i.push((0,l.localize)(40,null,c)):i.push((0,l.localize)(41,null,c)),i.push(""));const o={},n=[];for(const t in u){const r=u[t];if(r.type==="subcommand")r.description&&n.push({command:t,description:r.description});else if(r.description&&r.cat){let s=o[r.cat];s||(o[r.cat]=s={}),s[t]=r}}for(const t in o){const r=t,s=o[r];s&&(i.push(A[r]),i.push(...y(s,v)),i.push(""))}return n.length&&(i.push((0,l.localize)(42,null)),i.push(...I(n.map(t=>[t.command,t.description]),v)),i.push("")),i.join(`
`)}e.buildHelpMessage=f;function p(b,c){return`${b||(0,l.localize)(43,null)}
${c||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(oe[195],ae([0,1,293,160,194]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function _(m,f){const p=(v,k)=>{console.warn((0,O.localize)(0,null,v,k))},b=v=>{console.warn((0,O.localize)(1,null,v))},c=(v,k)=>{console.warn((0,O.localize)(2,null,v,k))},d=v=>({onUnknownOption:k=>{v!=="tunnel"&&console.warn((0,O.localize)(3,null,k,v))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:c,getSubcommandReporter:v!=="tunnel"?d:void 0}),u={onUnknownOption:v=>{console.warn((0,O.localize)(4,null,v))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:c,getSubcommandReporter:d},g=(0,l.parseArgs)(m,l.OPTIONS,f?u:void 0);return g.goto&&g._.forEach(v=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,O.localize)(5,null))),g["max-memory"]&&L(parseInt(g["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),g}function R(m){const f=m.findIndex(p=>!/^-/.test(p));if(f>-1)return[...m.slice(0,f),...m.slice(f+1)]}function P(m){let[,...f]=m;process.env.VSCODE_DEV&&(f=R(f)||[]);const p=!E(process.env);return _(f,p)}e.parseMainProcessArgv=P;function y(m){let[,,...f]=m;return process.env.VSCODE_DEV&&(f=R(f)||[]),_(f,!0)}e.parseCLIProcessArgv=y;function I(m,...f){const p=m.indexOf("--");return p===-1?m.push(...f):m.splice(p,0,...f),m}e.addArg=I;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function ie(e,L,O){function l(_,R){const P=A(_,R),y=[P];return e.isAbsolute(P)||y.unshift(O),e.resolve(...y)}function A(_,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,R);const I=_["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(E,"AppData","Roaming")}break;case"darwin":y=e.join(L.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,R)}return{getUserDataPath:l}}if(typeof define=="function")define(oe[97],ae([196,34,36]),function(e,L,O){return ie(e,L,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=ie(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[98],ae([0,1,34,193,97]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(y,I){super(y,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,l.getUserDataPath)(y,I.nameShort)},I)}}e.NativeEnvironmentService=A;function _(P,y){return(0,O.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,y,P.extensionEnvironment)}e.parsePtyHostDebugPort=_;function R(P,y){return(0,O.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,y,P.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(oe[197],ae([0,1,11,163]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(_,R,P){try{A(_,R,P)}catch(y){console.error(y?.message??y)}return _}e.localizeManifest=l;function A(_,R,P){const y=(I,E,m)=>{const f=I[E];if((0,L.isString)(f)){const p=f,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const c=p.substr(1,b-2);let d=R[c];d===void 0&&P&&(d=P[c]);const u=typeof d=="string"?d:d?.message,g=P?.[c],v=typeof g=="string"?g:g?.message;if(!u){v||console.warn(`[${_.name}]: ${(0,O.localize)(0,null,c)}`);return}if(m&&(E==="title"||E==="category")&&v&&v!==u){const k={value:u,original:v};I[E]=k}else I[E]=u}}else if((0,L.isObject)(f))for(const p in f)f.hasOwnProperty(p)&&(p==="commands"?y(f,p,!0):y(f,p,m));else if(Array.isArray(f))for(let p=0;p<f.length;p++)y(f,p,m)};for(const I in _)_.hasOwnProperty(I)&&y(_,I)}}),define(oe[198],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,_,R,P){return this.channel.call("promptImportantExtensionsInstallNotification",[A,_,R,P])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class O{constructor(A){this.service=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,R){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(oe[67],ae([0,1,23,90,168,55]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=P;function y(d){if(!P(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=d.match(_);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=y;function I(d){if(!d)return null;const u=d.majorBase,g=d.majorMustEqual,v=d.minorBase;let k=d.minorMustEqual;const i=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(u===0||(k=!1),o=!1);let n=0;if(d.preRelease){const t=R.exec(d.preRelease);if(t){const[,r,s,a]=t;n=Date.UTC(Number(r),Number(s)-1,Number(a))}}return{majorBase:u,majorMustEqual:g,minorBase:v,minorMustEqual:k,patchBase:i,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=I;function E(d,u,g){let v;typeof d=="string"?v=I(y(d)):v=d;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let i;if(typeof g=="string"?i=I(y(g)):i=g,!v||!i)return!1;const o=v.majorBase,n=v.minorBase,t=v.patchBase;let r=i.majorBase,s=i.minorBase,a=i.patchBase;const h=i.notBefore;let w=i.majorMustEqual,S=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?o>r?!0:o<r?!1:n>s?!0:n<s||k&&k<h?!1:t>=a:(o===1&&r===0&&(!w||!S||!D)&&(r=1,s=0,a=0,w=!0,S=!1,D=!1),o<r?!1:o>r?!w:n<s?!1:n>s?!S:t<a?!1:t>a?!D:!(k&&k<h))}e.isValidVersion=E;function m(d,u,g,v,k){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([O.default.Error,l.localize(0,null)]),i;if(typeof v.name!="string")return i.push([O.default.Error,l.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([O.default.Error,l.localize(2,null,"version")]),i;if(!v.engines)return i.push([O.default.Error,l.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([O.default.Error,l.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!c(v.extensionDependencies))return i.push([O.default.Error,l.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!c(v.activationEvents))return i.push([O.default.Error,l.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([O.default.Error,l.localize(7,null,"activationEvents","main","browser")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([O.default.Warning,l.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([O.default.Error,l.localize(9,null,"main")]),i;{const t=(0,L.joinPath)(g,v.main);(0,L.isEqualOrParent)(t,g)||i.push([O.default.Warning,l.localize(10,null,t.path,g.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([O.default.Error,l.localize(11,null,"browser")]),i;{const t=(0,L.joinPath)(g,v.browser);(0,L.isEqualOrParent)(t,g)||i.push([O.default.Warning,l.localize(12,null,t.path,g.path)])}}if(!A.valid(v.version))return i.push([O.default.Error,l.localize(13,null)]),i;const o=[];if(!f(d,u,v,k,o))for(const t of o)i.push([O.default.Error,t]);return i}e.validateExtensionManifest=m;function f(d,u,g,v,k){return v||typeof g.main>"u"&&typeof g.browser>"u"?!0:b(d,u,g.engines.vscode,k)}e.isValidExtensionVersion=f;function p(d,u,g){return d==="*"||b(u,g,d)}e.isEngineValid=p;function b(d,u,g,v=[]){const k=I(y(g));if(!k)return v.push(l.localize(14,null,g)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return v.push(l.localize(15,null,g)),!1}else if(!k.majorMustEqual)return v.push(l.localize(16,null,g)),!1;return E(d,u,k)?!0:(v.push(l.localize(17,null,d,g)),!1)}function c(d){if(!Array.isArray(d))return!1;for(let u=0,g=d.length;u<g;u++)if(typeof d[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,31]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(A,_,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const I=(await _.readFile(A.serviceMachineIdResource)).value.toString();P=(0,O.isUUID)(I)?I:null}catch{P=null}if(!P){P=(0,O.generateUuid)();try{await _.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=l}),define(oe[68],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(l,A=[],_=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=L}),define(oe[199],ae([0,1,68]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function A(R,P,y){P instanceof L.SyncDescriptor||(P=new L.SyncDescriptor(P,[],Boolean(y))),O.push([R,P])}e.registerSingleton=A;function _(){return O}e.getSingletonServiceDescriptors=_}),define(oe[200],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(A,_){this.key=A,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const _ of this._nodes.values())_.outgoing.size===0&&A.push(_);return A}insertEdge(A,_){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(_);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const _=this._hashFn(A);this._nodes.delete(_);for(const R of this._nodes.values())R.outgoing.delete(_),R.incoming.delete(_)}lookupOrInsertNode(A){const _=this._hashFn(A);let R=this._nodes.get(_);return R||(R=new L(_,A),this._nodes.set(_,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[_,R]of this._nodes)A.push(`${_}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,_]of this._nodes){const R=new Set([A]),P=this._findCycle(_,R);if(P)return P}}_findCycle(A,_){for(const[R,P]of A.outgoing){if(_.has(R))return[..._,R].join(" -> ");_.add(R);const y=this._findCycle(P,_);if(y)return y;_.delete(R)}}}e.Graph=O}),define(oe[5],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function O(_,R,P){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:_,index:P}):(R[L.DI_DEPENDENCIES]=[{id:_,index:P}],R[L.DI_TARGET]=R)}function l(_){if(L.serviceIds.has(_))return L.serviceIds.get(_);const R=function(P,y,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,P,I)};return R.toString=()=>_,L.serviceIds.set(_,R),R}e.createDecorator=l;function A(_){return _}e.refineServiceDecorator=A}),define(oe[201],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(oe[17],ae([0,1,11,12,5]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=A;function _(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=_;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function y(c,d){const u=Object.create(null);for(const g in c)I(u,g,c[g],d);return u}e.toValuesTree=y;function I(c,d,u,g){const v=d.split("."),k=v.pop();let i=c;for(let o=0;o<v.length;o++){const n=v[o];let t=i[n];switch(typeof t){case"undefined":t=i[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${d} as ${v.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[k]=u}catch{g(`Ignoring ${d} as ${v.join(".")} is ${JSON.stringify(i)}`)}else g(`Ignoring ${d} as ${v.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=I;function E(c,d){const u=d.split(".");m(c,u)}e.removeFromValueTree=E;function m(c,d){const u=d.shift();if(d.length===0){delete c[u];return}if(Object.keys(c).indexOf(u)!==-1){const g=c[u];typeof g=="object"&&!Array.isArray(g)&&(m(g,d),Object.keys(g).length===0&&delete c[u])}}function f(c,d,u){function g(i,o){let n=i;for(const t of o){if(typeof n!="object"||n===null)return;n=n[t]}return n}const v=d.split("."),k=g(c,v);return typeof k>"u"?u:k}e.getConfigurationValue=f;function p(c,d,u){Object.keys(d).forEach(g=>{g!=="__proto__"&&(g in c?L.isObject(c[g])&&L.isObject(d[g])?p(c[g],d[g],u):u&&(c[g]=d[g]):c[g]=d[g])})}e.merge=p;function b(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(oe[69],ae([0,1,4,27,192,5,157,10]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",L.isMacintosh),P.set("isLinux",L.isLinux),P.set("isWindows",L.isWindows),P.set("isWeb",L.isWeb),P.set("isMacNative",L.isMacintosh&&!L.isWeb),P.set("isEdge",L.isEdge),P.set("isFirefox",L.isFirefox),P.set("isChrome",L.isChrome),P.set("isSafari",L.isSafari);function y(N,C){if(P.get(N)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(N,C)}e.setConstant=y;const I=Object.prototype.hasOwnProperty;var E;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));const m={regexParsingWithErrorRecovery:!0},f=(0,_.localize)(0,null),p=(0,_.localize)(1,null),b=(0,_.localize)(2,null),c=(0,_.localize)(3,null),d=(0,_.localize)(4,null),u=(0,_.localize)(5,null),g=(0,_.localize)(6,null),v=(0,_.localize)(7,null);class k{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(C=m){this._config=C,this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(C){if(C===""){this._parsingErrors.push({message:f,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(C).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const $=this._peek(),G=$.type===17?u:void 0;throw this._parsingErrors.push({message:d,offset:$.offset,lexeme:l.Scanner.getLexeme($),additionalInfo:G}),k._parseError}return U}catch(U){if(U!==k._parseError)throw U;return}}_expr(){return this._or()}_or(){const C=[this._and()];for(;this._matchOne(16);){const U=this._and();C.push(U)}return C.length===1?C[0]:i.or(...C)}_and(){const C=[this._term()];for(;this._matchOne(15);){const U=this._term();C.push(U)}return C.length===1?C[0]:i.and(...C)}_term(){if(this._matchOne(2)){const C=this._peek();switch(C.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),s.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,c),U?.negate()}case 17:return this._advance(),T.create(C.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",C)}}return this._primary()}_primary(){const C=this._peek();switch(C.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const U=this._expr();return this._consume(1,c),U}case 17:{const U=C.lexeme;if(this._advance(),this._matchOne(9)){const G=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),G.type!==10)throw this._errExpectedButGot("REGEX",G);const W=G.lexeme,Z=W.lastIndexOf("/"),te=Z===W.length-1?void 0:this._removeFlagsGY(W.substring(Z+1));let ce;try{ce=new RegExp(W.substring(1,Z),te)}catch{throw this._errExpectedButGot("REGEX",G)}return J.create(U,ce)}switch(G.type){case 10:case 19:{const W=[G.lexeme];this._advance();let Z=this._peek(),te=0;for(let ye=0;ye<G.lexeme.length;ye++)G.lexeme.charCodeAt(ye)===40?te++:G.lexeme.charCodeAt(ye)===41&&te--;for(;!this._isAtEnd()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let ye=0;ye<Z.lexeme.length;ye++)Z.lexeme.charCodeAt(ye)===40?te++:G.lexeme.charCodeAt(ye)===41&&te--}if(te<0)break;W.push(l.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const ce=W.join(""),he=ce.lastIndexOf("/"),pe=he===ce.length-1?void 0:this._removeFlagsGY(ce.substring(he+1));let fe;try{fe=new RegExp(ce.substring(1,he),pe)}catch{throw this._errExpectedButGot("REGEX",G)}return i.regex(U,fe)}case 18:{const W=G.lexeme;this._advance();let Z=null;if(!(0,O.isFalsyOrWhitespace)(W)){const te=W.indexOf("/"),ce=W.lastIndexOf("/");if(te!==ce&&te>=0){const he=W.slice(te+1,ce),pe=W[ce+1]==="i"?"i":"";try{Z=new RegExp(he,pe)}catch{throw this._errExpectedButGot("REGEX",G)}}}if(Z===null)throw this._errExpectedButGot("REGEX",G);return J.create(U,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const G=this._value();return i.notIn(U,G)}switch(this._peek().type){case 3:{this._advance();const G=this._value();if(this._previous().type===18)return i.equals(U,G);switch(G){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,G)}}case 4:{this._advance();const G=this._value();if(this._previous().type===18)return i.notEquals(U,G);switch(G){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,G)}}case 5:return this._advance(),q.create(U,this._value());case 6:return this._advance(),z.create(U,this._value());case 7:return this._advance(),x.create(U,this._value());case 8:return this._advance(),V.create(U,this._value());case 13:return this._advance(),i.in(U,this._value());default:return i.has(U)}}case 20:throw this._parsingErrors.push({message:g,offset:C.offset,lexeme:"",additionalInfo:v}),k._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const C=this._peek();switch(C.type){case 17:case 18:return this._advance(),C.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(C){return C.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(C){return this._check(C)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(C,U){if(this._check(C))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(C,U,$){const G=(0,_.localize)(8,null,C,l.Scanner.getLexeme(U)),W=U.offset,Z=l.Scanner.getLexeme(U);return this._parsingErrors.push({message:G,offset:W,lexeme:Z,additionalInfo:$}),k._parseError}_check(C){return this._peek().type===C}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}k._parseError=new Error,e.Parser=k;class i{static false(){return r.INSTANCE}static true(){return s.INSTANCE}static has(C){return a.create(C)}static equals(C,U){return h.create(C,U)}static notEquals(C,U){return D.create(C,U)}static regex(C,U){return J.create(C,U)}static in(C,U){return w.create(C,U)}static notIn(C,U){return S.create(C,U)}static not(C){return T.create(C)}static and(...C){return X.create(C,null,!0)}static or(...C){return j.create(C,null,!0)}static greater(C,U){return x.create(C,U)}static greaterEquals(C,U){return V.create(C,U)}static smaller(C,U){return q.create(C,U)}static smallerEquals(C,U){return z.create(C,U)}static deserialize(C){return C==null?void 0:this._parser.parse(C)}}i._parser=new k({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=i;function o(N){const C=new k({regexParsingWithErrorRecovery:!1});return N.map(U=>(C.parse(U),C.lexingErrors.length>0?C.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,_.localize)(9,null,$.additionalInfo):(0,_.localize)(10,null),offset:$.offset,length:$.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}e.validateWhenClauses=o;function n(N,C){const U=N?N.substituteConstants():void 0,$=C?C.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=n;function t(N,C){return N.cmp(C)}class r{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}r.INSTANCE=new r,e.ContextKeyFalseExpr=r;class s{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return r.INSTANCE}}s.INSTANCE=new s,e.ContextKeyTrueExpr=s;class a{static create(C,U=null){const $=P.get(C);return typeof $=="boolean"?$?s.INSTANCE:r.INSTANCE:new a(C,U)}constructor(C,U){this.key=C,this.negated=U,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=P.get(this.key);return typeof C=="boolean"?C?s.INSTANCE:r.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class h{static create(C,U,$=null){if(typeof U=="boolean")return U?a.create(C,$):T.create(C,$);const G=P.get(C);return typeof G=="boolean"?U===(G?"true":"false")?s.INSTANCE:r.INSTANCE:new h(C,U,$)}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=P.get(this.key);if(typeof C=="boolean"){const U=C?"true":"false";return this.value===U?s.INSTANCE:r.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class w{static create(C,U){return new w(C,U)}constructor(C,U){this.key=C,this.valueKey=U,this.type=10,this.negated=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.valueKey),$=C.getValue(this.key);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?I.call(U,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class S{static create(C,U){return new S(C,U)}constructor(C,U){this.key=C,this.valueKey=U,this.type=11,this._negated=w.create(C,U)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=S;class D{static create(C,U,$=null){if(typeof U=="boolean")return U?T.create(C,$):a.create(C,$);const G=P.get(C);return typeof G=="boolean"?U===(G?"true":"false")?r.INSTANCE:s.INSTANCE:new D(C,U,$)}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=P.get(this.key);if(typeof C=="boolean"){const U=C?"true":"false";return this.value===U?r.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class T{static create(C,U=null){const $=P.get(C);return typeof $=="boolean"?$?r.INSTANCE:s.INSTANCE:new T(C,U)}constructor(C,U){this.key=C,this.negated=U,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=P.get(this.key);return typeof C=="boolean"?C?r.INSTANCE:s.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function M(N,C){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?C(N):r.INSTANCE}class x{static create(C,U,$=null){return M(U,G=>new x(C,G,$))}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=x;class V{static create(C,U,$=null){return M(U,G=>new V(C,G,$))}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=V;class q{static create(C,U,$=null){return M(U,G=>new q(C,G,$))}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=q;class z{static create(C,U,$=null){return M(U,G=>new z(C,G,$))}constructor(C,U,$){this.key=C,this.value=U,this.negated=$,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=z;class J{static create(C,U){return new J(C,U)}constructor(C,U){this.key=C,this.regexp=U,this.type=7,this.negated=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const U=this.regexp?this.regexp.source:"",$=C.regexp?C.regexp.source:"";return U<$?-1:U>$?1:0}equals(C){if(C.type===this.type){const U=this.regexp?this.regexp.source:"",$=C.regexp?C.regexp.source:"";return this.key===C.key&&U===$}return!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Q.create(this)),this.negated}}e.ContextKeyRegexExpr=J;class Q{static create(C){return new Q(C)}constructor(C){this._actual=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new Q(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Q;function K(N){let C=null;for(let U=0,$=N.length;U<$;U++){const G=N[U].substituteConstants();if(N[U]!==G&&C===null){C=[];for(let W=0;W<U;W++)C[W]=N[W]}C!==null&&(C[U]=G)}return C===null?N:C}class X{static create(C,U,$){return X._normalizeArr(C,U,$)}constructor(C,U){this.expr=C,this.negated=U,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=t(this.expr[U],C.expr[U]);if(G!==0)return G}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:X.create(C,this.negated,!1)}evaluate(C){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(C))return!1;return!0}static _normalizeArr(C,U,$){const G=[];let W=!1;for(const Z of C)if(!!Z){if(Z.type===1){W=!0;continue}if(Z.type===0)return r.INSTANCE;if(Z.type===6){G.push(...Z.expr);continue}G.push(Z)}if(G.length===0&&W)return s.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(t);for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];for(;G.length>1;){const Z=G[G.length-1];if(Z.type!==9)break;G.pop();const te=G.pop(),ce=G.length===0,he=j.create(Z.expr.map(pe=>X.create([pe,te],null,$)),null,ce);he&&(G.push(he),G.sort(t))}if(G.length===1)return G[0];if($){for(let Z=0;Z<G.length;Z++)for(let te=Z+1;te<G.length;te++)if(G[Z].negate().equals(G[te]))return r.INSTANCE;if(G.length===1)return G[0]}return new X(G,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new X(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.negated){const C=[];for(const U of this.expr)C.push(U.negate());this.negated=j.create(C,this,!0)}return this.negated}}e.ContextKeyAndExpr=X;class j{static create(C,U,$){return j._normalizeArr(C,U,$)}constructor(C,U){this.expr=C,this.negated=U,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=t(this.expr[U],C.expr[U]);if(G!==0)return G}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:j.create(C,this.negated,!1)}evaluate(C){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(C))return!0;return!1}static _normalizeArr(C,U,$){let G=[],W=!1;if(C){for(let Z=0,te=C.length;Z<te;Z++){const ce=C[Z];if(!!ce){if(ce.type===0){W=!0;continue}if(ce.type===1)return s.INSTANCE;if(ce.type===9){G=G.concat(ce.expr);continue}G.push(ce)}}if(G.length===0&&W)return r.INSTANCE;G.sort(t)}if(G.length!==0){if(G.length===1)return G[0];for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];if($){for(let Z=0;Z<G.length;Z++)for(let te=Z+1;te<G.length;te++)if(G[Z].negate().equals(G[te]))return s.INSTANCE;if(G.length===1)return G[0]}return new j(G,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new j(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.negated){const C=[];for(const U of this.expr)C.push(U.negate());for(;C.length>1;){const U=C.shift(),$=C.shift(),G=[];for(const W of B(U))for(const Z of B($))G.push(X.create([W,Z],null,!1));C.unshift(j.create(G,null,!1))}this.negated=j.create(C,this,!0)}return this.negated}}e.ContextKeyOrExpr=j;class F extends a{static all(){return F._info.values()}constructor(C,U,$){super(C,null),this._defaultValue=U,typeof $=="object"?F._info.push({...$,key:C}):$!==!0&&F._info.push({key:C,description:$,type:U!=null?typeof U:void 0})}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return h.create(this.key,C)}notEqualsTo(C){return D.create(this.key,C)}}F._info=[],e.RawContextKey=F,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function ee(N,C){return N<C?-1:N>C?1:0}function ne(N,C,U,$){return N<U?-1:N>U?1:C<$?-1:C>$?1:0}function se(N,C){if(N.type===0||C.type===1)return!0;if(N.type===9)return C.type===9?H(N.expr,C.expr):!1;if(C.type===9){for(const U of C.expr)if(se(N,U))return!0;return!1}if(N.type===6){if(C.type===6)return H(C.expr,N.expr);for(const U of N.expr)if(se(U,C))return!0;return!1}return N.equals(C)}e.implies=se;function H(N,C){let U=0,$=0;for(;U<N.length&&$<C.length;){const G=N[U].cmp(C[$]);if(G<0)return!1;G===0&&U++,$++}return U===N.length}function B(N){return N.type===9?N.expr:[N]}}),define(oe[99],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function O(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=O;class l{async getPerformanceInfo(_,R){return{}}async getSystemInfo(_,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,R){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=l}),define(oe[100],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,162,5]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function _(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function R(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(u,g,v){return R(g,v)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===v?!0:y(v).includes(u)}e.isTargetPlatformCompatible=P;function y(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=I;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var c;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class d extends Error{constructor(g,v){super(g),this.code=v,this.name=v}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(oe[202],ae([0,1,3,2,32,12,93,29]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,d){return c?A.URI.revive(d?d.transformIncoming(c):c):void 0}function y(c,d){return d?d.transformOutgoingURI(c):c}function I(c,d){d=d||_.DefaultURITransformer;const u=c.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...c,manifest:void 0},d),manifest:u}}function E(c,d){return c?.profileLocation?(0,_.transformAndReviveIncomingURIs)(c,d??_.DefaultURITransformer):c}function m(c,d){return d?(0,l.cloneAndChange)(c,u=>u instanceof A.URI?d.transformOutgoingURI(u):void 0):c}class f{constructor(d,u){this.service=d,this.getUriTransformer=u,this.onInstallExtension=L.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,u){const g=this.getUriTransformer(d);switch(u){case"onInstallExtension":return L.Event.map(this.onInstallExtension,v=>({...v,profileLocation:v.profileLocation?y(v.profileLocation,g):v.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,v=>v.map(k=>({...k,local:k.local?m(k.local,g):k.local,profileLocation:k.profileLocation?y(k.profileLocation,g):k.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,v=>({...v,profileLocation:v.profileLocation?y(v.profileLocation,g):v.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,v=>({...v,profileLocation:v.profileLocation?y(v.profileLocation,g):v.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,v=>m(v,g))}throw new Error("Invalid listen")}async call(d,u,g){const v=this.getUriTransformer(d);switch(u){case"zip":{const k=I(g[0],v),i=await this.service.zip(k);return y(i,v)}case"unzip":return this.service.unzip(P(g[0],v));case"install":return this.service.install(P(g[0],v),E(g[1],v));case"installFromLocation":return this.service.installFromLocation(P(g[0],v),P(g[1],v));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(g[0],P(g[1],v),P(g[2],v));case"getManifest":return this.service.getManifest(P(g[0],v));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],E(g[1],v));case"uninstall":return this.service.uninstall(I(g[0],v),E(g[1],v));case"reinstallFromGallery":return this.service.reinstallFromGallery(I(g[0],v));case"getInstalled":return(await this.service.getInstalled(g[0],P(g[1],v))).map(i=>m(i,v));case"copyExtensions":return this.service.copyExtensions(P(g[0],v),P(g[1],v));case"updateMetadata":{const k=await this.service.updateMetadata(I(g[0],v),g[1],P(g[2],v));return m(k,v)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(g[0],g[1],g[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(d){super(),this.channel=d,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(u=>this.fireEvent(this._onInstallExtension,{...u,source:this.isUriComponents(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(u=>this.fireEvent(this._onDidInstallExtensions,u.map(g=>({...g,local:g.local?I(g.local,null):g.local,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(u=>this.fireEvent(this._onUninstallExtension,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(u=>this.fireEvent(this._onDidUninstallExtension,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(u=>this._onDidUpdateExtensionMetadata.fire(I(u,null))))}fireEvent(d,u){d.fire(u)}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const u=await this.getTargetPlatform();return d.allTargetPlatforms.some(g=>(0,R.isTargetPlatformCompatible)(g,d.allTargetPlatforms,u))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(u=>A.URI.revive(u)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,u){return Promise.resolve(this.channel.call("install",[d,u])).then(g=>I(g,null))}installFromLocation(d,u){return Promise.resolve(this.channel.call("installFromLocation",[d,u])).then(g=>I(g,null))}async installExtensionsFromProfile(d,u,g){return(await this.channel.call("installExtensionsFromProfile",[d,u,g])).map(k=>I(k,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,u){return Promise.resolve(this.channel.call("installFromGallery",[d,u])).then(g=>I(g,null))}uninstall(d,u){return Promise.resolve(this.channel.call("uninstall",[d,u]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d])).then(u=>I(u,null))}getInstalled(d=null,u){return Promise.resolve(this.channel.call("getInstalled",[d,u])).then(g=>g.map(v=>I(v,null)))}updateMetadata(d,u,g){return Promise.resolve(this.channel.call("updateMetadata",[d,u,g])).then(v=>I(v,null))}copyExtensions(d,u){return this.channel.call("copyExtensions",[d,u])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(d,u,g){const v=await this.channel.call("download",[d,u,g]);return A.URI.revive(v)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class b{constructor(d){this.service=d}listen(d,u){throw new Error("Invalid listen")}call(d,u,g){switch(u){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(oe[101],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,_)=>ie(["node-vsce-sign"],async R=>A(R),_))),this.moduleLoadingPromise}async verify(A,_,R){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(A,_,R)}}e.ExtensionSignatureVerificationService=O}),define(oe[102],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(O=e.RecommendationSource||(e.RecommendationSource={}));function l(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var A;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,48,14,27,11,12,170,5,4,22]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function E(F){return F.create===!0}e.isFileOpenForWriteOptions=E;var m;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var f;(function(F){F[F.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var p;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=b;function c(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=c;function d(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=d;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=g;function v(F){return b(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var k;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(ee,ne){const se=new i(ee.toString(),ne);return t(se,ne),se}constructor(ee,ne){super(ee),this.code=ne}}e.FileSystemProviderError=i;function o(F,ee){return i.create(F,ee)}e.createFileSystemProviderError=o;function n(F){return F||o((0,R.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=n;function t(F,ee){return F.name=ee?`${ee} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=t;function r(F){if(!F)return k.Unknown;if(F instanceof i)return F.code;const ee=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!ee)return k.Unknown;switch(ee[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=r;function s(F){if(F instanceof T)return F.fileOperationResult;switch(r(F)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class h{constructor(ee,ne,se){this.resource=ee,this.operation=ne,this.target=se}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=h;var w;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class S{constructor(ee,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const H of ee){const B=se.get(H.type);switch(B?B.push([H.resource,H]):se.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,B]of se)switch(H){case 1:this.added=L.TernarySearchTree.forUris(()=>ne),this.added.fill(B);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ne),this.updated.fill(B);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ne),this.deleted.fill(B);break}}contains(ee,...ne){return this.doContains(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.doContains(ee,{includeChildren:!0},...ne)}doContains(ee,ne,...se){if(!ee)return!1;const H=se.length>0;return!!((!H||se.includes(1))&&(this.added?.get(ee)||ne.includeChildren&&this.added?.findSuperstr(ee))||(!H||se.includes(0))&&(this.updated?.get(ee)||ne.includeChildren&&this.updated?.findSuperstr(ee))||(!H||se.includes(2))&&(this.deleted?.findSubstr(ee)||ne.includeChildren&&this.deleted?.findSuperstr(ee)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=S;function D(F,ee,ne){return!F||!ee||F===ee||ee.length>F.length?!1:(ee.charAt(ee.length-1)!==O.sep&&(ee+=O.sep),ne?(0,l.startsWithIgnoreCase)(F,ee):F.indexOf(ee)===0)}e.isParent=D;class T extends Error{constructor(ee,ne,se){super(ee),this.fileOperationResult=ne,this.options=se}}e.FileOperationError=T;class M extends T{constructor(ee,ne,se,H){super(ee,ne,H),this.fileOperationResult=ne,this.size=se}}e.TooLargeFileOperationError=M;class x extends T{constructor(ee,ne,se){super(ee,2,se),this.stat=ne}}e.NotModifiedSinceFileOperationError=x;var V;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=z;async function J(F,ee){if(!ee.hasProvider(_.URI.from({scheme:F.scheme})))return new Promise(ne=>{const se=ee.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===F.scheme&&H.added&&(se.dispose(),ne())})})}e.whenProviderRegistered=J,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(ee){return(0,A.isNumber)(ee)||(ee=0),ee<Q.KB?(0,R.localize)(1,null,ee.toFixed(0)):ee<Q.MB?(0,R.localize)(2,null,(ee/Q.KB).toFixed(2)):ee<Q.GB?(0,R.localize)(3,null,(ee/Q.MB).toFixed(2)):ee<Q.TB?(0,R.localize)(4,null,(ee/Q.GB).toFixed(2)):(0,R.localize)(5,null,(ee/Q.TB).toFixed(2))}}Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB,e.ByteSize=Q;var K;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function X(F){return{maxFileSize:F===0?300*Q.MB:16*Q.GB,maxHeapSize:F===0?700*Q.MB:2*700*Q.MB}}e.getPlatformFileLimits=X;function j(F){const ee=typeof F=="string"||F?.scheme===I.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===I.Schemas.file?1024*Q.MB:ee?10*Q.MB:y.isWeb?50*Q.MB:1024*Q.MB}e.getLargeFileConfirmationLimit=j});var Y=this&&this.__param||function(ie,e){return function(L,O){e(L,O,ie)}};define(oe[203],ae([0,1,103,43,13]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const P=(await this.fileService.readFileStream(R)).value;return new Promise((y,I)=>{const E=(0,L.createHash)("md5");(0,O.listenStream)(P,{onData:m=>E.update(m.buffer),onError:m=>I(m),onEnd:()=>y(E.digest("base64").replace(/=+$/,""))})})}};A=ve([Y(0,l.IFileService)],A),e.ChecksumService=A}),define(oe[204],ae([0,1,16,38,10,3,2,43,12,31,13]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends _.Disposable{constructor(f,p){super(),this.channel=f,this.extraCapabilities=p,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,p){const{buffer:b}=await this.channel.call("readFile",[f,p]);return b}readFileStream(f,p,b){const c=(0,R.newWriteableStream)(u=>L.VSBuffer.concat(u.map(g=>L.VSBuffer.wrap(g))).buffer),d=this.channel.listen("readFileStream",[f,p])(u=>{if(u instanceof L.VSBuffer)c.write(u.buffer);else{if(u==="end")c.end();else{let g;if(u instanceof Error)g=u;else{const v=u;g=(0,I.createFileSystemProviderError)(v.message??(0,O.toErrorMessage)(v),v.code??I.FileSystemProviderErrorCode.Unknown)}c.error(g),c.end()}d.dispose()}});return b.onCancellationRequested(()=>{c.error((0,l.canceled)()),c.end(),d.dispose()}),c}writeFile(f,p,b){return this.channel.call("writeFile",[f,L.VSBuffer.wrap(p),b])}open(f,p){return this.channel.call("open",[f,p])}close(f){return this.channel.call("close",[f])}async read(f,p,b,c,d){const[u,g]=await this.channel.call("read",[f,p,d]);return b.set(u.buffer.slice(0,g),c),g}write(f,p,b,c,d){return this.channel.call("write",[f,p,L.VSBuffer.wrap(b),c,d])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,p){return this.channel.call("delete",[f,p])}rename(f,p,b){return this.channel.call("rename",[f,p,b])}copy(f,p,b){return this.channel.call("copy",[f,p,b])}cloneFile(f,p){return this.channel.call("cloneFile",[f,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const p=f;this._onDidChange.fire(p.map(b=>({resource:P.URI.revive(b.resource),type:b.type})))}else{const p=f;this._onDidWatchError.fire(p)}}))}watch(f,p){const b=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,b,f,p]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=E}),define(oe[104],ae([0,1,16,10,171,13]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(I,E,m,f,p,b){let c;try{await R(I,E,m,f,p,b)}catch(d){c=d}finally{c&&p.errorTransformer&&(c=p.errorTransformer(c)),typeof c<"u"&&m.error(c),m.end()}}e.readFileIntoStream=_;async function R(I,E,m,f,p,b){P(b);const c=await I.open(E,{create:!1});try{P(b);let d=0,u=0,g=p&&typeof p.length=="number"?p.length:void 0,v=L.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),k=p&&typeof p.position=="number"?p.position:0,i=0;do u=await I.read(c,k,v.buffer,i,v.byteLength-i),k+=u,i+=u,d+=u,typeof g=="number"&&(g-=u),i===v.byteLength&&(await m.write(f(v)),v=L.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),i=0);while(u>0&&(typeof g!="number"||g>0)&&P(b)&&y(d,p));if(i>0){let o=i;typeof g=="number"&&(o=Math.min(i,g)),m.write(f(v.slice(0,o)))}}catch(d){throw(0,A.ensureFileSystemProviderError)(d)}finally{await I.close(c)}}function P(I){if(I.isCancellationRequested)throw(0,O.canceled)();return!0}function y(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,A.createFileSystemProviderError)((0,l.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,A.createFileSystemProviderError)((0,l.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,92,2,14,4,12,13]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(d){return d.recursive===!0}e.isRecursiveWatchRequest=P;class y extends O.Disposable{constructor(u,g,v,k){super(),this.onFileChanges=u,this.onLogMessage=g,this.verboseLogging=v,this.options=k,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new O.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),u.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),u.add(this.watcher.onDidError(g=>this.onError(g)))}onError(u){this.options.restartOnError?this.restartCounter<y.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}trace(u){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}y.MAX_RESTARTS=5,e.AbstractWatcherClient=y;class I extends y{constructor(u,g,v){super(u,g,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class E extends y{constructor(u,g,v){super(u,g,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function m(d){return d.map(u=>({type:u.type,resource:_.URI.file(u.path)}))}e.toFileChanges=m;function f(d){const u=new c;for(const g of d)u.processEvent(g);return u.coalesce()}e.coalesceEvents=f;function p(d,u){return typeof u=="string"&&!u.startsWith(L.GLOBSTAR)&&!(0,l.isAbsolute)(u)?{base:d,pattern:u}:u}e.normalizeWatcherPattern=p;function b(d,u){const g=[];for(const v of u)g.push((0,L.parse)(p(d,v)));return g}e.parseWatcherPatterns=b;class c{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return A.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const g=this.mapPathToChange.get(this.toKey(u));let v=!1;if(g){const k=g.type,i=u.type;g.path!==u.path&&(u.type===2||u.type===1)?v=!0:k===1&&i===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(g)):k===2&&i===1?g.type=0:k===1&&i===0||(g.type=i)}else v=!0;v&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],g=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(u.push(v),!1):!0).sort((v,k)=>v.path.length-k.path.length).filter(v=>g.some(k=>(0,R.isParent)(v.path,k,!A.isLinux))?!1:(g.push(v.path),!0)).concat(u)}}}),define(oe[205],ae([0,1,54,6,25,47,2,85,14,4,147,28,56]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends _.Disposable{constructor(c,d,u,g){super(),this.request=c,this.onDidFilesChange=d,this.onLogMessage=u,this.verboseLogging=g,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.onDidFilesChange(v))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(v=>this.handleFileChanges(v),f.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new l.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const c=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await E.Promises.stat(c);this._register(await this.doWatch(c,d.isDirectory()))}catch(c){c.code!=="ENOENT"?this.error(c):this.trace(c)}}async normalizePath(c){let d=c.path;try{d=await E.Promises.realpath(c.path),c.path===d&&(d=await(0,I.realcase)(c.path)??c.path),c.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${d})`)}catch{}return d}async doWatch(c,d){if(y.isMacintosh&&(0,A.isEqualOrParent)(c,"/Volumes/",!0))return this.error(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const u=new l.CancellationTokenSource(this.cts.token),g=new _.DisposableStore;try{const v=(0,P.basename)(c),k=(0,L.watch)(c);g.add((0,_.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.trace(`Started watching: '${c}'`);const i=new Set;if(d)try{for(const n of await E.Promises.readdir(c))i.add(n)}catch(n){this.error(n)}const o=new Map;g.add((0,_.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),k.on("error",(n,t)=>{this.error(`Failed to watch ${c} for changes using fs.watch() (${n}, ${t})`),this.dispose()}),k.on("change",(n,t)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${t}`);let r="";if(t&&(r=t.toString(),y.isMacintosh&&(r=(0,R.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(d)if(n==="rename"){o.get(r)?.dispose();const s=setTimeout(async()=>{if(o.delete(r),r===v&&!await E.Promises.exists(c)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(c,r));if(u.token.isCancellationRequested)return;let h;a?i.has(r)?h=0:(h=1,i.add(r)):(i.delete(r),h=2),this.onFileChange({path:(0,P.join)(this.request.path,r),type:h})},f.FILE_DELETE_HANDLER_DELAY);o.set(r,(0,_.toDisposable)(()=>clearTimeout(s)))}else{let s;i.has(r)?s=0:(s=1,i.add(r)),this.onFileChange({path:(0,P.join)(this.request.path,r),type:s})}else if(n==="rename"||r!==v){const s=setTimeout(async()=>{const a=await E.Promises.exists(c);u.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(c,!1))):(this.onFileChange({path:this.request.path,type:2},!0),this.fileChangesAggregator.flush(),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,_.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(v){await E.Promises.exists(c)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${c} for changes using fs.watch() (${v.toString()})`)}return(0,_.toDisposable)(()=>{u.dispose(!0),g.dispose()})}onFileChange(c,d=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!d&&this.excludes.some(u=>u(c.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${c.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(u=>u(c.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${c.path}`):this.fileChangesAggregator.work(c))}handleFileChanges(c){const d=(0,m.coalesceEvents)(c);if(d.length>0){if(this.verboseLogging)for(const g of d)this.trace(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.throttledFileChangesEmitter.work(d)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(c){if(y.isLinux)return E.Promises.exists(c);try{const d=(0,P.basename)(c);return(await E.Promises.readdir((0,P.dirname)(c))).some(g=>g===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(c){this.verboseLogging=c}error(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}warn(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}trace(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=75,e.NodeJSFileWatcherLibrary=f;async function p(b,c,d,u,g=512){const v=await E.Promises.open(b,"r"),k=Buffer.allocUnsafe(g),i=new l.CancellationTokenSource(u);let o,n=!1;const t={path:b,excludes:[],recursive:!1},r=new f(t,s=>{(async()=>{for(const{type:a}of s)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await E.Promises.read(v,k,0,g,null);if(!h||i.token.isCancellationRequested)break;c(k.slice(0,h))}}catch(h){o=new Error(h),i.dispose(!0)}finally{n=!1}}})()});return await r.ready,d(),new Promise((s,a)=>{i.token.onCancellationRequested(async()=>{r.dispose();try{await E.Promises.close(v)}catch(h){o=new Error(h)}o?a(o):s()})})}e.watchFileContents=p}),define(oe[206],ae([0,1,3,92,2,4,205]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const I=this.normalizeRequests(y),E=I.filter(f=>{const p=this.watchers.get(f.path);return p?!(0,O.patternsEquals)(p.request.excludes,f.excludes)||!(0,O.patternsEquals)(p.request.includes,f.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:f})=>!I.find(p=>p.path===f.path&&(0,O.patternsEquals)(p.excludes,f.excludes)&&(0,O.patternsEquals)(p.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.trace(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const f of m)this.stopWatching(f);for(const f of E)this.startWatching(f)}startWatching(y){const I=new _.NodeJSFileWatcherLibrary(y,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),E={request:y,instance:I};this.watchers.set(y.path,E)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const I=this.watchers.get(y);I&&(this.watchers.delete(y),I.instance.dispose())}normalizeRequests(y){const I=new Map;for(const E of y){const m=A.isLinux?E.path:E.path.toLowerCase();I.set(m,E)}return Array.from(I.values())}async setVerboseLogging(y){this.verboseLogging=y;for(const[,I]of this.watchers)I.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,I){return I?`[File Watcher (node.js)] ${y} (path: ${I.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=R}),define(oe[207],ae([0,1,56,206]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends L.AbstractNonRecursiveWatcherClient{constructor(_,R,P){super(_,R,P),this.init()}createWatcher(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(oe[208],ae([0,1,22,39,65,56]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends A.AbstractUniversalWatcherClient{constructor(P,y,I){super(P,y,I),this.init()}createWatcher(P){const y=P.add(new l.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(y.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(oe[70],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...l){this._entries=new Map;for(const[A,_]of l)this.set(A,_)}set(l,A){const _=this._entries.get(l);return this._entries.set(l,A),_}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=L}),define(oe[209],ae([0,1,6,10,2,68,200,5,70,84]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new P.ServiceCollection,d=!1,u,g=I){this._services=c,this._strict=d,this._parent=u,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=g?u?._globalGraph??new _.Graph(v=>v):void 0}createChild(c){return new m(c,this._strict,this,this._enableTracing)}invokeFunction(c,...d){const u=p.traceInvocation(this._enableTracing,c);let g=!1;try{return c({get:k=>{if(g)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(k,u);if(!i)throw new Error(`[invokeFunction] unknown service '${k}'`);return i}},...d)}finally{g=!0,u.stop()}}createInstance(c,...d){let u,g;return c instanceof A.SyncDescriptor?(u=p.traceCreation(this._enableTracing,c.ctor),g=this._createInstance(c.ctor,c.staticArguments.concat(d),u)):(u=p.traceCreation(this._enableTracing,c),g=this._createInstance(c,d,u)),u.stop(),g}_createInstance(c,d=[],u){const g=R._util.getServiceDependencies(c).sort((i,o)=>i.index-o.index),v=[];for(const i of g){const o=this._getOrCreateServiceInstance(i.id,u);o||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(o)}const k=g.length>0?g[0].index:d.length;if(d.length!==k){console.trace(`[createInstance] First service dependency of ${c.name} at position ${k+1} conflicts with ${d.length} static arguments`);const i=k-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,k)}return Reflect.construct(c,d.concat(v))}_setServiceInstance(c,d){if(this._services.get(c)instanceof A.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const u=this._getServiceInstanceOrDescriptor(c);return u instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,u,d.branch(c,!0)):(d.branch(c,!1),u)}_safeCreateAndCacheServiceInstance(c,d,u){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,u)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,u){const g=new _.Graph(i=>i.id.toString());let v=0;const k=[{id:c,desc:d,_trace:u}];for(;k.length;){const i=k.pop();if(g.lookupOrInsertNode(i),v++>1e3)throw new E(g);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.SyncDescriptor){const t={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};g.insertEdge(i,t),k.push(t)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const t=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,t)}g.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,u=[],g,v){if(this._services.get(c)instanceof A.SyncDescriptor)return this._createServiceInstance(c,d,u,g,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,u,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d,u=[],g,v){if(g){const k=new m(void 0,this._strict,this,this._enableTracing);k._globalGraphImplicitDependency=String(c);const i=new Map,o=new L.IdleValue(()=>{const n=k._createInstance(d,u,v);for(const[t,r]of i){const s=n[t];if(typeof s=="function")for(const a of r)s.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let a=i.get(t);return a||(a=new y.LinkedList,i.set(t,a)),(w,S,D)=>{const T=a.push([w,S,D]);return(0,l.toDisposable)(T)}}if(t in n)return n[t];const r=o.value;let s=r[t];return typeof s!="function"||(s=s.bind(r),n[t]=s),s},set(n,t,r){return o.value[t]=r,!0},getPrototypeOf(n){return d.prototype}})}else return this._createInstance(d,u,v)}_throwIfStrict(c,d){if(d&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=m;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class p{static traceInvocation(c,d){return c?new p(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(c,d){return c?new p(1,d.name):p._None}constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}branch(c,d){const u=new p(3,c.toString());return this._dep.push([c,d,u]),u}stop(){const c=Date.now()-this._start;p._totals+=c;let d=!1;function u(v,k){const i=[],o=new Array(v+1).join("	");for(const[n,t,r]of k._dep)if(t&&r){d=!0,i.push(`${o}CREATES -> ${n}`);const s=u(v+1,r);s&&i.push(s)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(c>2||d)&&p.all.add(g.join(`
`))}}p.all=new Set,p._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p._totals=0,e.Trace=p}),define(oe[71],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class O{constructor(A,_){this.server=A,this.router=_}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,_){this.server.registerChannel(A,_)}}e.MainProcessService=O}),define(oe[72],ae([0,1,25,2,4,173,29,5]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(I){return I.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let y=class extends O.Disposable{constructor(E){super(),this.extensionGalleryService=E}async getAvailableLanguages(){const E=new L.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const p=m.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(c=>c.startsWith("lp-"))).map(b=>{const c=b.properties.localizedLanguages?.[0],d=P(b);return{...this.createQuickPickItem(d,c,b),extensionId:b.identifier.id,galleryExtension:b}});return p.push(this.createQuickPickItem("en","English")),p}createQuickPickItem(E,m,f){const p=m??E;let b;if(p!==E&&(b=`(${E})`),E.toLowerCase()===l.language.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),f?.installCount){b??="";const c=f.installCount;let d;c>1e6?d=`${Math.floor(c/1e5)/10}M`:c>1e3?d=`${Math.floor(c/1e3)}K`:d=String(c),b+=` $(cloud-download) ${d}`}return{id:E,label:p,description:b}}};y=ve([Y(0,_.IExtensionGalleryService)],y),e.LanguagePackBaseService=y}),define(oe[210],ae([0,1,2,72]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends L.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};l=ve([Y(0,O.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(oe[9],ae([0,1,38,3,53,2,37,4,23,11,12,69,5]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function f(){return new Date().toISOString()}function p(w){return(0,y.isNumber)(w)}e.isLogLevel=p;var b;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function c(w,S,D){switch(S){case b.Trace:w.trace(D);break;case b.Debug:w.debug(D);break;case b.Info:w.info(D);break;case b.Warning:w.warn(D);break;case b.Error:w.error(D);break;case b.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=c;function d(w,S=!1){let D="";for(let T=0;T<w.length;T++){let M=w[T];if(M instanceof Error&&(M=(0,L.toErrorMessage)(M,S)),typeof M=="object")try{M=JSON.stringify(M)}catch{}D+=(T>0?" ":"")+M}return D}class u extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==b.Off&&this.level<=S}}e.AbstractLogger=u;class g extends u{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...D){this.checkLogLevel(b.Trace)&&this.log(b.Trace,d([S,...D],!0))}debug(S,...D){this.checkLogLevel(b.Debug)&&this.log(b.Debug,d([S,...D]))}info(S,...D){this.checkLogLevel(b.Info)&&this.log(b.Info,d([S,...D]))}warn(S,...D){this.checkLogLevel(b.Warning)&&this.log(b.Warning,d([S,...D]))}error(S,...D){if(this.checkLogLevel(b.Error))if(S instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=S.stack,this.log(b.Error,d(T))}else this.log(b.Error,d([S,...D]))}flush(){}}e.AbstractMessageLogger=g;class v extends u{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!R.isWindows}trace(S,...D){this.checkLogLevel(b.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,S,...D):console.log(`[main ${f()}]`,S,...D))}debug(S,...D){this.checkLogLevel(b.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,S,...D):console.log(`[main ${f()}]`,S,...D))}info(S,...D){this.checkLogLevel(b.Info)&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,S,...D):console.log(`[main ${f()}]`,S,...D))}warn(S,...D){this.checkLogLevel(b.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,S,...D):console.warn(`[main ${f()}]`,S,...D))}error(S,...D){this.checkLogLevel(b.Error)&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,S,...D):console.error(`[main ${f()}]`,S,...D))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class k extends u{constructor(S=e.DEFAULT_LOG_LEVEL,D=!0){super(),this.useColors=D,this.setLevel(S)}trace(S,...D){this.checkLogLevel(b.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...D):console.log(S,...D))}debug(S,...D){this.checkLogLevel(b.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...D):console.log(S,...D))}info(S,...D){this.checkLogLevel(b.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...D):console.log(S,...D))}warn(S,...D){this.checkLogLevel(b.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...D):console.log(S,...D))}error(S,...D){this.checkLogLevel(b.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...D):console.error(S,...D))}dispose(){}flush(){}}e.ConsoleLogger=k;class i extends u{constructor(S,D=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(D)}trace(S,...D){this.checkLogLevel(b.Trace)&&this.adapter.log(b.Trace,[this.extractMessage(S),...D])}debug(S,...D){this.checkLogLevel(b.Debug)&&this.adapter.log(b.Debug,[this.extractMessage(S),...D])}info(S,...D){this.checkLogLevel(b.Info)&&this.adapter.log(b.Info,[this.extractMessage(S),...D])}warn(S,...D){this.checkLogLevel(b.Warning)&&this.adapter.log(b.Warning,[this.extractMessage(S),...D])}error(S,...D){this.checkLogLevel(b.Error)&&this.adapter.log(b.Error,[this.extractMessage(S),...D])}extractMessage(S){return typeof S=="string"?S:(0,L.toErrorMessage)(S,this.checkLogLevel(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class o extends u{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const D of this.loggers)D.setLevel(S);super.setLevel(S)}trace(S,...D){for(const T of this.loggers)T.trace(S,...D)}debug(S,...D){for(const T of this.loggers)T.debug(S,...D)}info(S,...D){for(const T of this.loggers)T.info(S,...D)}warn(S,...D){for(const T of this.loggers)T.warn(S,...D)}error(S,...D){for(const T of this.loggers)T.error(S,...D)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose()}}e.MultiplexLogger=o;class n extends A.Disposable{constructor(S,D,T){if(super(),this.logLevel=S,this.logsHome=D,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const M of T)this._loggers.set(M.resource,{logger:void 0,info:M})}getLoggerEntry(S){return(0,y.isString)(S)?[...this._loggers.values()].find(D=>D.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,D){const T=this.toResource(S),M=(0,y.isString)(S)?S:D?.id??(0,l.hash)(T.toString()).toString(16);let x=this._loggers.get(T)?.logger;const V=D?.logLevel==="always"?b.Trace:D?.logLevel;x||(x=this.doCreateLogger(T,V??this.getLogLevel(T)??this.logLevel,{...D,id:M}));const q={logger:x,info:{resource:T,id:M,logLevel:V,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(q.info),this._loggers.set(T,q),x}toResource(S){return(0,y.isString)(S)?(0,P.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,D){if(I.URI.isUri(S)){const T=S,M=D,x=this._loggers.get(T);x&&M!==x.info.logLevel&&(x.info.logLevel=M===this.logLevel?void 0:M,x.logger?.setLevel(M),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([T,M]))}else{this.logLevel=S;for(const[T,M]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&M.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,D){const T=this.getLoggerEntry(S);T&&D!==!T.info.hidden&&(T.info.hidden=!D,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,D]))}getLogLevel(S){let D;return S&&(D=this._loggers.get(S)?.info.logLevel),D??this.logLevel}registerLogger(S){const D=this._loggers.get(S.resource);D?D.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const D=this._loggers.get(S);D&&(D.logger&&D.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class t{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(S){}getLevel(){return b.Info}trace(S,...D){}debug(S,...D){}info(S,...D){}warn(S,...D){}error(S,...D){}critical(S,...D){}dispose(){}flush(){}}e.NullLogger=t;class r extends t{}e.NullLogService=r;function s(w){if(w.verbose)return b.Trace;if(typeof w.logLevel=="string"){const S=h(w.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function a(w){switch(w){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=a;function h(w){switch(w){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=h,e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",a(b.Info))}),define(oe[211],ae([0,1,6,10,2,23,28,15,9]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let y=class extends l.Disposable{constructor(E,m){super(),this.environmentService=E,this.logService=m,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,A.basename)(this.environmentService.logsHome),m=(0,A.dirname)(this.environmentService.logsHome),b=(await _.Promises.readdir(m.fsPath)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==E),c=b.slice(0,Math.max(0,b.length-9));c.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(d=>_.Promises.rm((0,A.joinPath)(m,d).fsPath))))}catch(E){(0,O.onUnexpectedError)(E)}}};y=ve([Y(0,R.IEnvironmentService),Y(1,P.ILogService)],y),e.LogsDataCleaner=y}),define(oe[212],ae([0,1,21,6,10,3,2,14,56,9]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends _.Disposable{constructor(m,f){super(),this.logService=m,this.options=f,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(m,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,f):this.watchNonRecursive(m,f)}watchUniversal(m,f){const p={path:this.toFilePath(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive},b=(0,L.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,P.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(f)&&m.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,f){const p={path:this.toFilePath(m),excludes:f.excludes,includes:f.includes,recursive:!1},b=(0,L.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,l.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,P.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,R.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(oe[213],ae([0,1,21,6,16,25,3,53,63,2,48,22,105,23,43,169,13,104,9,10]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends y.Disposable{constructor(i){super(),this.logService=i,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(i,o){if(this.provider.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const n=new y.DisposableStore;return this.provider.set(i,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:i,provider:o}),n.add(o.onDidChangeFile(t=>this._onDidFilesChange.fire(new c.FileChangesEvent(t,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:i}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:i,provider:o}),this.provider.delete(i),(0,y.dispose)(n)})}getProvider(i){return this.provider.get(i)}async activateProvider(i){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:i,join(n){o.push(n)}}),!this.provider.has(i)&&await O.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.provider.has(i.scheme)}hasCapability(i,o){const n=this.provider.get(i.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async withProvider(i){if(!(0,f.isAbsolutePath)(i))throw new c.FileOperationError((0,b.localize)(0,null,this.resourceForError(i)),8);await this.activateProvider(i.scheme);const o=this.provider.get(i.scheme);if(!o){const n=new g.ErrorNoTelemetry;throw n.message=(0,b.localize)(1,null,i.toString()),n}return o}async withReadProvider(i){const o=await this.withProvider(i);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(i){const o=await this.withProvider(i);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.doResolveFile(i,o)}catch(n){throw(0,c.toFileSystemProviderErrorCode)(n)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,b.localize)(2,null,this.resourceForError(i)),1):(0,c.ensureFileSystemProviderError)(n)}}async doResolveFile(i,o){const n=await this.withProvider(i),t=this.isPathCaseSensitive(n),r=o?.resolveTo,s=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await n.stat(i);let w;return this.toFileStat(n,i,h,void 0,!!a,(S,D)=>(w||(w=I.TernarySearchTree.forUris(()=>!t),w.set(i,!0),r&&w.fill(!0,r)),w.get(S.resource)||w.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?D===1:!1))}async toFileStat(i,o,n,t,r,s){const{providerExtUri:a}=this.getExtUri(i),h={resource:o,name:a.basename(o),isFile:(n.type&c.FileType.File)!==0,isDirectory:(n.type&c.FileType.Directory)!==0,isSymbolicLink:(n.type&c.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&c.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,c.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(h.isDirectory&&s(h,t)){try{const w=await i.readdir(o),S=await O.Promises.settled(w.map(async([D,T])=>{try{const M=a.joinPath(o,D),x=r?await i.stat(M):{type:T};return await this.toFileStat(i,M,x,w.length,r,s)}catch(M){return this.logService.trace(M),null}}));h.children=(0,L.coalesce)(S)}catch(w){this.logService.trace(w),h.children=[]}return h}return h}async resolveAll(i){return O.Promises.settled(i.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.withProvider(i),n=await o.stat(i);return this.toFileStat(o,i,n,void 0,!0,()=>!1)}async exists(i){const o=await this.withProvider(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.doValidateCreateFile(i,o)}catch(n){return n}return!0}async doValidateCreateFile(i,o){if(!o?.overwrite&&await this.exists(i))throw new c.FileOperationError((0,b.localize)(3,null,this.resourceForError(i)),3,o)}async createFile(i,o=l.VSBuffer.fromString(""),n){await this.doValidateCreateFile(i,n);const t=await this.writeFile(i,o);return this._onDidRunOperation.fire(new c.FileOperationEvent(i,0,t)),t}async writeFile(i,o,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,i,n)||await this.mkdirp(t,r.dirname(i));let a;if((0,c.hasReadWriteCapability)(t)&&!(o instanceof l.VSBuffer))if((0,p.isReadableStream)(o)){const h=await(0,p.peekStream)(o,3);h.ended?a=l.VSBuffer.concat(h.buffer):a=h}else a=(0,p.peekReadable)(o,h=>l.VSBuffer.concat(h),3);else a=o;!(0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasReadWriteCapability)(t)&&a instanceof l.VSBuffer?await this.doWriteUnbuffered(t,i,n,a):await this.doWriteBuffered(t,i,n,a instanceof l.VSBuffer?(0,l.bufferToReadable)(a):a),this._onDidRunOperation.fire(new c.FileOperationEvent(i,4))}catch(s){throw new c.FileOperationError((0,b.localize)(4,null,this.resourceForError(i),(0,c.ensureFileSystemProviderError)(s).toString()),(0,c.toFileOperationResult)(s),n)}return this.resolve(i,{resolveMetadata:!0})}async validateWriteFile(i,o,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(o)));let r;try{r=await i.stat(o)}catch{return}if((r.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,b.localize)(6,null,this.resourceForError(o)),0,n);if(this.throwIfFileIsReadonly(o,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,c.etag)({mtime:n.mtime,size:r.size}))throw new c.FileOperationError((0,b.localize)(7,null),3,n);return r}async readFile(i,o,n){const t=await this.withReadProvider(i);return o?.atomic?this.doReadFileAtomic(t,i,o,n):this.doReadFile(t,i,o,n)}async doReadFileAtomic(i,o,n,t){return new Promise((r,s)=>{this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(i,o,n,t);r(a)}catch(a){s(a)}})})}async doReadFile(i,o,n,t){const r=await this.doReadFileStream(i,o,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,l.streamToBuffer)(r.value)}}async readFileStream(i,o,n){const t=await this.withReadProvider(i);return this.doReadFileStream(t,i,o,n)}async doReadFileStream(i,o,n,t){const r=new A.CancellationTokenSource(t),s=this.validateReadFile(o,n).then(h=>h,h=>{throw r.cancel(),h});let a;try{return typeof n?.etag=="string"&&n.etag!==c.ETAG_DISABLED&&await s,n?.atomic&&(0,c.hasFileAtomicReadCapability)(i)||!((0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasFileReadStreamCapability)(i))||(0,c.hasReadWriteCapability)(i)&&n?.preferUnbuffered?a=this.readFileUnbuffered(i,o,n):(0,c.hasFileReadStreamCapability)(i)?a=this.readFileStreamed(i,o,r.token,n):a=this.readFileBuffered(i,o,r.token,n),{...await s,value:a}}catch(h){throw a&&await(0,p.consumeStream)(a),this.restoreReadError(h,o,n)}}restoreReadError(i,o,n){const t=(0,b.localize)(8,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(i).toString());return i instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(t,i.stat,n):i instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(t,i.fileOperationResult,i.size,i.options):new c.FileOperationError(t,(0,c.toFileOperationResult)(i),n)}readFileStreamed(i,o,n,t=Object.create(null)){const r=i.readFileStream(o,t,n);return(0,p.transform)(r,{data:s=>s instanceof l.VSBuffer?s:l.VSBuffer.wrap(s),error:s=>this.restoreReadError(s,o,t)},s=>l.VSBuffer.concat(s))}readFileBuffered(i,o,n,t=Object.create(null)){const r=(0,l.newWriteableBufferStream)();return(0,d.readFileIntoStream)(i,o,r,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>this.restoreReadError(s,o,t)},n),r}readFileUnbuffered(i,o,n){const t=(0,p.newWriteableStream)(r=>l.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,c.hasFileAtomicReadCapability)(i)?r=await i.readFile(o,{atomic:!0}):r=await i.readFile(o),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(o,r.byteLength,n),t.end(l.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(i,o){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new c.FileOperationError((0,b.localize)(9,null,this.resourceForError(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===n.etag)throw new c.NotModifiedSinceFileOperationError((0,b.localize)(10,null),n,o);return this.validateReadFileLimits(i,n.size,o),n}validateReadFileLimits(i,o,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&o>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&o>n.limits.size&&(t=7),typeof t=="number")throw new c.TooLargeFileOperationError((0,b.localize)(11,null,this.resourceForError(i)),t,o,n)}}async canMove(i,o,n){return this.doCanMoveCopy(i,o,"move",n)}async canCopy(i,o,n){return this.doCanMoveCopy(i,o,"copy",n)}async doCanMoveCopy(i,o,n,t){if(i.toString()!==o.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i):await this.withReadProvider(i),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(r,i,s,o,n,t)}catch(r){return r}return!0}async move(i,o,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(t,i,r,o,"move",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(i,s==="move"?2:3,a)),a}async copy(i,o,n){const t=await this.withReadProvider(i),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(t,i,r,o,"copy",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(i,s==="copy"?3:2,a)),a}async doMoveCopy(i,o,n,t,r,s){if(o.toString()===t.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(i,o,n,t,r,s);if(a&&!h&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(i===n&&(0,c.hasFileFolderCopyCapability)(i))await i.copy(o,t,{overwrite:s});else{const w=await this.resolve(o);w.isDirectory?await this.doCopyFolder(i,w,n,t):await this.doCopyFile(i,o,n,t)}return r}else return i===n?(await i.rename(o,t,{overwrite:s}),r):(await this.doMoveCopy(i,o,n,t,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(i,o,n,t){if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(i,o,n,t);if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(i,o,n,t);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(i,o,n,t);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasReadWriteCapability)(n))return this.doPipeUnbuffered(i,o,n,t)}async doCopyFolder(i,o,n,t){await n.mkdir(t),Array.isArray(o.children)&&await O.Promises.settled(o.children.map(async r=>{const s=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(i,await this.resolve(r.resource),n,s):this.doCopyFile(i,r.resource,n,s)}))}async doValidateMoveCopy(i,o,n,t,r,s){let a=!1;if(i===n){const{providerExtUri:w,isPathCaseSensitive:S}=this.getExtUri(i);if(S||(a=w.isEqual(o,t)),a&&r==="copy")throw new Error((0,b.localize)(12,null,this.resourceForError(o),this.resourceForError(t)));if(!a&&w.isEqualOrParent(t,o))throw new Error((0,b.localize)(13,null,this.resourceForError(o),this.resourceForError(t)))}const h=await this.exists(t);if(h&&!a){if(!s)throw new c.FileOperationError((0,b.localize)(14,null,this.resourceForError(o),this.resourceForError(t)),4);if(i===n){const{providerExtUri:w}=this.getExtUri(i);if(w.isEqualOrParent(o,t))throw new Error((0,b.localize)(15,null,this.resourceForError(o),this.resourceForError(t)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(i){const o=this.isPathCaseSensitive(i);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);await this.mkdirp(o,i);const n=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(i,0,n)),n}async mkdirp(i,o){const n=[],{providerExtUri:t}=this.getExtUri(i);for(;!t.isEqual(o,t.dirname(o));)try{if(((await i.stat(o)).type&c.FileType.Directory)===0)throw new Error((0,b.localize)(16,null,this.resourceForError(o)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(o)),o=t.dirname(o)}for(let r=n.length-1;r>=0;r--){o=t.joinPath(o,n[r]);try{await i.mkdir(o)}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(i,o){try{await this.doValidateDelete(i,o)}catch(n){return n}return!0}async doValidateDelete(i,o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(i),i);if(!!o?.useTrash&&!(n.capabilities&4096))throw new Error((0,b.localize)(17,null,this.resourceForError(i)));let r;try{r=await n.stat(i)}catch{}if(r)this.throwIfFileIsReadonly(i,r);else throw new c.FileOperationError((0,b.localize)(18,null,this.resourceForError(i)),1);if(!!!o?.recursive){const a=await this.resolve(i);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,b.localize)(19,null,this.resourceForError(i)))}return n}async del(i,o){const n=await this.doValidateDelete(i,o),t=!!o?.useTrash,r=!!o?.recursive;await n.delete(i,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new c.FileOperationEvent(i,1))}async cloneFile(i,o){const n=await this.withProvider(i),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(i,o))return;if(n===t&&(0,c.hasFileCloneCapability)(n))return n.cloneFile(i,o);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(o));const r=this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri);return n===t&&(0,c.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(i,o,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,i,t,o))}watch(i,o={recursive:!1,excludes:[]}){const n=new y.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,y.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(i,o);t?(0,y.dispose)(s):r=()=>(0,y.dispose)(s)}catch(s){this.logService.error(s)}})(),n}async doWatch(i,o){const n=await this.withProvider(i),t=(0,R.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(i),o]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(i,o)},this.activeWatchers.set(t,r)),r.count+=1,(0,y.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,y.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.activeWatchers)(0,y.dispose)(i.disposable);this.activeWatchers.clear()}async doWriteBuffered(i,o,n,t){return this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri).queue(async()=>{const r=await i.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(t)||(0,p.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(i,r,t):await this.doWriteReadableBufferedQueued(i,r,t)}catch(s){throw(0,c.ensureFileSystemProviderError)(s)}finally{await i.close(r)}})}async doWriteStreamBufferedQueued(i,o,n){let t=0,r;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const s=l.VSBuffer.concat(n.buffer);await this.doWriteBuffer(i,o,s,s.byteLength,t,0),t+=s.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((s,a)=>{(0,p.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(i,o,h,h.byteLength,t,0)}catch(w){return a(w)}t+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>a(h),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(i,o,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(i,o,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(i,o,n,t,r,s){let a=0;for(;a<t;)a+=await i.write(o,r+a,n.buffer,s+a,t-a)}async doWriteUnbuffered(i,o,n,t){return this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(i,o,n,t))}async doWriteUnbufferedQueued(i,o,n,t){let r;t instanceof l.VSBuffer?r=t:(0,p.isReadableStream)(t)?r=await(0,l.streamToBuffer)(t):(0,p.isReadableBufferedStream)(t)?r=await(0,l.bufferedStreamToBuffer)(t):r=(0,l.readableToBuffer)(t),await i.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(i,o,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(i,o,n,t))}async doPipeBufferedQueued(i,o,n,t){let r,s;try{r=await i.open(o,{create:!1}),s=await n.open(t,{create:!0,unlock:!1});const a=l.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,w=0,S=0;do S=await i.read(r,h,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(n,s,a,S,h,w),h+=S,w+=S,w===a.byteLength&&(w=0);while(S>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await O.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof s=="number"?n.close(s):Promise.resolve()])}}async doPipeUnbuffered(i,o,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(i,o,n,t))}async doPipeUnbufferedQueued(i,o,n,t){return n.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(i,o,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(i,o,n,t))}async doPipeUnbufferedToBufferedQueued(i,o,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const s=await i.readFile(o);await this.doWriteBuffer(n,r,l.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,c.ensureFileSystemProviderError)(s)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(i,o,n,t){const r=await(0,l.streamToBuffer)(this.readFileBuffered(i,o,A.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(i,o){if(i.capabilities&2048)throw new c.FileOperationError((0,b.localize)(20,null,this.resourceForError(o)),6);return i}throwIfFileIsReadonly(i,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,b.localize)(21,null,this.resourceForError(i)),6)}resourceForError(i){return i.scheme===E.Schemas.file?i.fsPath:i.toString(!0)}};v=ve([Y(0,u.ILogService)],v),e.FileService=v}),define(oe[214],ae([0,1,54,294,6,37,16,3,47,2,14,4,23,43,28,172,13,104,212,38,208,207]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(o)}`)}})();class i extends u.AbstractDiskFileSystemProvider{constructor(n,t){super(n,t),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:t,symbolicLink:r}=await p.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(n){try{const t=await p.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(n,s.name))).type:a=this.toType(s),r.push([s.name,a])}catch(a){this.logService.trace(a)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(n,t){let r;return t?.dangling?r=c.FileType.Unknown:n.isFile()?r=c.FileType.File:n.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,t&&(r|=c.FileType.SymbolicLink),r}async createResourceLock(n){const t=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let r;for(;r=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await r.wait();const s=new l.Barrier;return this.resourceLocks.set(n,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,y.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(n,t){let r;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const s=this.toFilePath(n);return await p.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,t,r){const s=(0,f.newWriteableStream)(a=>_.VSBuffer.concat(a.map(h=>_.VSBuffer.wrap(h))).buffer);return(0,d.readFileIntoStream)(this,n,s,a=>a.buffer,{...t,bufferSize:256*1024},r),s}async writeFile(n,t,r){let s;try{const a=this.toFilePath(n);if(!r.create||!r.overwrite){if(await p.Promises.exists(a)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,b.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,b.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(n,a)}finally{typeof s=="number"&&await this.close(s)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,t){const r=this.toFilePath(n);let s;(0,c.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(n));let a;try{if((0,c.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(r);w.mode&128||await p.Promises.chmod(r,w.mode|128)}catch(w){this.logService.trace(w)}let h;if((0,c.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await p.Promises.truncate(r,0),h="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}h||(h="w")}else h="r";a=await p.Promises.open(r,h)}catch(h){throw s?.dispose(),(0,c.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(n,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,c.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(a,n),s){const h=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,s),h&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),h.dispose())}return a}async close(n){const t=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await p.Promises.fdatasync(n)}catch(r){i.configureFlushOnWrite(!1),this.logService.error(r)}return await p.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{t&&(this.mapHandleToLock.get(n)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),t.dispose())}}async read(n,t,r,s,a){const h=this.normalizePos(n,t);let w=null;try{w=(await p.Promises.read(n,r,s,a,h)).bytesRead}catch(S){throw this.toFileSystemProviderError(S)}finally{this.updatePos(n,h,w)}return w}normalizePos(n,t){return t===this.mapHandleToPos.get(n)?null:t}updatePos(n,t,r){const s=this.mapHandleToPos.get(n);typeof s=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,s+r):this.mapHandleToPos.delete(n)))}async write(n,t,r,s,a){return(0,l.retry)(()=>this.doWrite(n,t,r,s,a),100,3)}async doWrite(n,t,r,s,a){const h=this.normalizePos(n,t);let w=null;try{w=(await p.Promises.write(n,r,s,a,h)).bytesWritten}catch(S){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),S)}finally{this.updatePos(n,h,w)}return w}async mkdir(n){try{await p.Promises.mkdir(this.toFilePath(n))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(n,t){try{const r=this.toFilePath(n);t.recursive?await p.Promises.rm(r,p.RimRafMode.MOVE):await p.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,t,r){const s=this.toFilePath(n),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(n,t,"move",r.overwrite),await p.Promises.move(s,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(2,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(n,t,r){const s=this.toFilePath(n),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(n,t,"copy",r.overwrite),await p.Promises.copy(s,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(3,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(n,t,r,s){const a=this.toFilePath(n),h=this.toFilePath(t);let w=!1;if(!!(this.capabilities&1024)||(w=(0,P.isEqual)(a,h,!0)),w&&r==="copy")throw(0,c.createFileSystemProviderError)((0,b.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!w&&await p.Promises.exists(h)){if(!s)throw(0,c.createFileSystemProviderError)((0,b.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(n,t){return this.doCloneFile(n,t,!1)}async doCloneFile(n,t,r){const s=this.toFilePath(n),a=this.toFilePath(t),h=!!(this.capabilities&1024);if((0,P.isEqual)(s,a,!h))return;const w=new y.DisposableStore;try{const[S,D]=await Promise.all([this.createResourceLock(n),this.createResourceLock(t)]);w.add(S),w.add(D),r&&await p.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await p.Promises.copyFile(s,a)}catch(S){if(S.code==="ENOENT"&&!r)return this.doCloneFile(n,t,!0);throw this.toFileSystemProviderError(S)}finally{w.dispose()}}createUniversalWatcher(n,t,r){return new v.UniversalWatcherClient(s=>n(s),s=>t(s),r)}createNonRecursiveWatcher(n,t,r){return new k.NodeJSWatcherClient(s=>n(s),s=>t(s),r)}toFileSystemProviderError(n){if(n instanceof c.FileSystemProviderError)return n;let t;switch(n.code){case"ENOENT":t=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=c.FileSystemProviderErrorCode.NoPermissions;break;default:t=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,t)}async toFileSystemProviderWriteError(n,t){let r=this.toFileSystemProviderError(t);if(n&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await p.SymlinkSupport.stat(this.toFilePath(n));s.mode&128||(r=(0,c.createFileSystemProviderError)(t,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0,e.DiskFileSystemProvider=i}),define(oe[106],ae([0,1,3,2,5,9]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let _=class extends O.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};_=ve([Y(0,A.ILogService)],_),e.SharedProcessLifecycleService=_}),define(oe[107],ae([0,1,12,3,9,2]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends l.AbstractLoggerService{constructor(E,m,f,p,b){super(m,f,p),this.windowId=E,this.channel=b,this._register(b.listen("onDidChangeLogLevel",E)(c=>{(0,l.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this._register(b.listen("onDidChangeVisibility",E)(([c,d])=>super.setVisibility(L.URI.revive(c),d))),this._register(b.listen("onDidChangeLoggers",E)(({added:c,removed:d})=>{for(const u of c)super.registerLogger({...u,resource:L.URI.revive(u.resource)});for(const u of d)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(E,m)=>{this.channel.call("consoleLog",[E,m])}})}registerLogger(E){super.registerLogger(E),this.channel.call("registerLogger",[E,this.windowId])}deregisterLogger(E){super.deregisterLogger(E),this.channel.call("deregisterLogger",[E,this.windowId])}setLogLevel(E,m){super.setLogLevel(E,m),this.channel.call("setLogLevel",[E,m])}setVisibility(E,m){super.setVisibility(E,m),this.channel.call("setVisibility",[this.toResource(E),m])}doCreateLogger(E,m,f){return new R(this.channel,E,m,f,this.windowId)}static setLogLevel(E,m,f){return E.call("setLogLevel",[m,f])}}e.LoggerChannelClient=_;class R extends l.AbstractMessageLogger{constructor(E,m,f,p,b){super(p?.logLevel==="always"),this.channel=E,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[m,p,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,m){const f=[[E,m]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(E){this.channel.call("log",[this.file,E])}}class P{constructor(E,m){this.loggerService=E,this.getUriTransformer=m}listen(E,m){const f=this.getUriTransformer(E);switch(m){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,p=>({added:[...p.added].map(b=>this.transformLogger(b,f)),removed:[...p.removed].map(b=>this.transformLogger(b,f))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,p=>[f.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,p=>(0,l.isLogLevel)(p)?p:[f.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${m}`)}async call(E,m,f){const p=this.getUriTransformer(E);switch(m){case"setLogLevel":return(0,l.isLogLevel)(f[0])?this.loggerService.setLogLevel(f[0]):this.loggerService.setLogLevel(L.URI.revive(p.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(b=>this.transformLogger(b,p)))}throw new Error(`Call not found: ${m}`)}transformLogger(E,m){return{...E,resource:m.transformOutgoingURI(E.resource)}}}e.LoggerChannel=P;class y extends A.Disposable{constructor(E,m){super(),m.call("setLogLevel",[E.getLogLevel()]),this._register(E.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const p of f)E.registerLogger({...p,resource:L.URI.revive(p.resource)})}),this._register(m.listen("onDidChangeVisibility")(([f,p])=>E.setVisibility(L.URI.revive(f),p))),this._register(m.listen("onDidChangeLoggers")(({added:f,removed:p})=>{for(const b of f)E.registerLogger({...b,resource:L.URI.revive(b.resource)});for(const b of p)E.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=y}),define(oe[215],ae([0,1,2,9]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends L.Disposable{constructor(_,R=[]){super(),this.logger=new O.MultiplexLogger([_,...R]),this._register(_.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...R){this.logger.trace(_,...R)}debug(_,...R){this.logger.debug(_,...R)}info(_,...R){this.logger.info(_,...R)}warn(_,...R){this.logger.warn(_,...R)}error(_,...R){this.logger.error(_,...R)}flush(){this.logger.flush()}}e.LogService=l}),define(oe[57],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(oe[58],ae([0,1,3,63,2,5]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class _ extends l.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(y){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...y,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(y),O.Iterable.reduce(this.policies.entries(),(E,[m,f])=>({...E,[m]:f}),{})}getPolicyValue(y){return this.policies.get(y)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(y,[I,E])=>({...y,[I]:{definition:E,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=_;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[216],ae([0,1,3,2,58]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.service=P,this.disposables=new O.DisposableStore}listen(P,y){switch(y){case"onDidChange":return L.Event.map(this.service.onDidChange,I=>I.reduce((E,m)=>({...E,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${y}`)}call(P,y,I){switch(y){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${y}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class _ extends l.AbstractPolicyService{constructor(P,y){super(),this.channel=y;for(const I in P){const{definition:E,value:m}=P[I];this.policyDefinitions[I]=E,m!==void 0&&this.policies.set(I,m)}this.channel.listen("onDidChange")(I=>{for(const E in I){const m=I[E];m===null?this.policies.delete(E):this.policies.set(E,m)}this._onDidChange.fire(Object.keys(I))})}async _updatePolicyDefinitions(P){const y=await this.channel.call("updatePolicyDefinitions",P);for(const I in y)this.policies.set(I,y[I])}}e.PolicyChannelClient=_}),define(oe[108],ae([0,1,22,4,36,97]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof O.globals.vscode<"u"&&typeof O.globals.vscode.context<"u"){const R=O.globals.vscode.context.configuration();if(R)_=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){_=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:R,searchUrl:P,itemUrl:y,controlUrl:I}=_.extensionsGallery||{};Object.assign(_,{extensionsGallery:{serviceUrl:l.env.VSCODE_GALLERY_SERVICE_URL||R,searchUrl:l.env.VSCODE_GALLERY_SEARCH_URL||P,itemUrl:l.env.VSCODE_GALLERY_ITEM_URL||y,controlUrl:l.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const E=(...b)=>b.reduce((c,d)=>(Object.keys(d).forEach(u=>{Array.isArray(c[u])&&Array.isArray(d[u])?c[u]=d[u]:typeof c[u]=="object"&&typeof d[u]=="object"?c[u]=E(c[u],d[u]):c[u]=d[u]}),c),{}),m=(0,A.getUserDataPath)({},_.nameShort),f=O.isWindows?`file:///${m}/product.json`:`file://${m}/product.json`,p=ie.__$__nodeRequire(L.FileAccess.asFileUri(f).fsPath);_=E(_,p)}catch{}if(l.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),!_.version){const E=globalThis._VSCODE_PACKAGE_JSON;Object.assign(_,{version:E.version,release:E.release})}}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(oe[26],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[217],ae([0,1,6,10,2,14,28,9,26]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let y=class extends l.Disposable{constructor(E,m,f){super(),this.productService=m,this.logService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},3e4)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),f=(0,A.dirname)(E),p=(0,A.basename)(E),b=await _.Promises.readdir(f);await Promise.all(b.map(async c=>{if(c===p)return;const d=(0,A.join)(f,c),u=await _.Promises.stat(d);if(u.isDirectory()&&m-u.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),_.Promises.rm(d)}))}catch(m){(0,O.onUnexpectedError)(m)}}};y=ve([Y(1,P.IProductService),Y(2,R.ILogService)],y),e.CodeCacheCleaner=y}),define(oe[218],ae([0,1,6,10,2,14,28,15,9,26]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends l.Disposable{constructor(m,f,p){super(),this.environmentService=m,this.logService=f,this.productService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),f=JSON.parse(await _.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(f)){const g=f[u];m[`${g.hash}.${u}`]=!0}const p=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(p))return;const c=await _.Promises.readdir(p);for(const u of c){if(m[u]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await _.Promises.rm((0,A.join)(p,u))}const d=Date.now();for(const u of Object.keys(m)){const g=(0,A.join)(p,u),v=await _.Promises.readdir(g);for(const k of v){if(k==="tcf.json")continue;const i=(0,A.join)(g,k),o=await _.Promises.stat(i);o.isDirectory()&&d-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(u,k)}`),await _.Promises.rm(i))}}}catch(m){(0,O.onUnexpectedError)(m)}}};I=ve([Y(0,R.INativeEnvironmentService),Y(1,P.ILogService),Y(2,y.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(oe[219],ae([0,1,14,5]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var l;(function(A){function _(P){return Boolean(P.samples&&P.timeDeltas)}A.isValidProfile=_;function R(P,y="noAbsolutePaths"){for(const I of P.nodes)I.callFrame&&I.callFrame.url&&((0,L.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,L.join)(y,(0,L.basename)(I.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(oe[220],ae([0,1,31]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((y,I)=>{ie(["v8-inspect-profiler"],y,I)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,L.generateUuid)();return this._sessions.set(P,R),P}async stopProfiling(A){const _=this._sessions.get(A);if(!_)throw new Error(`UNKNOWN session '${A}'`);const R=await _.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=O}),define(oe[40],ae([0,1,130,11]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(_,R){L.ok(O.isString(_)),L.ok(O.isObject(R)),L.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,R)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new l}),define(oe[109],ae([0,1,3,40]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,y){this.schemasById[l(P)]=y,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new A;O.Registry.add(e.Extensions.JSONContribution,_)}),define(oe[45],ae([0,1,21,3,11,156,17,109,40]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.doRegisterConfigurations(i,o,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(i,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const n=[];for(const{overrides:t,source:r}of i)for(const s in t)if(o.add(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const a=this.configurationDefaultsOverrides.get(s),h=a?.valuesSources??new Map;if(r)for(const T of Object.keys(t[s]))h.set(T,r);const w={...a?.value||{},...t[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:w,valuesSources:h});const S=(0,_.getLanguageTagSettingPlainKey)(s),D={type:"object",default:w,description:A.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:l.isString(r)?void 0:r,defaultValueSource:r};n.push(...b(s)),this.configurationProperties[s]=D,this.defaultLanguageConfigurationOverridesNode.properties[s]=D}else{this.configurationDefaultsOverrides.set(s,{value:t[s],source:r});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:n,source:t}of i)for(const r in n){const s=this.configurationDefaultsOverrides.get(r),a=l.isString(t)?t:t?.id,h=l.isString(s?.source)?s?.source:s?.source?.id;if(a===h)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const w=this.configurationProperties[r];w&&(this.updatePropertyDefaultValue(r,w),this.updateSchema(r,w))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,n){i.forEach(t=>{this.validateAndRegisterProperties(t,o,t.extensionInfo,t.restrictedProperties,void 0,n),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(i,o){const n=t=>{if(t.properties)for(const r in t.properties){o.add(r);const s=this.configurationProperties[r];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,t.properties[r])}t.allOf?.forEach(r=>n(r))};for(const t of i){n(t);const r=this.configurationContributors.indexOf(t);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,o=!0,n,t,r=3,s){r=l.isUndefinedOrNull(i.scope)?r:i.scope;const a=i.properties;if(a)for(const w in a){const S=a[w];if(o&&g(w,S)){delete a[w];continue}if(S.source=n,S.defaultDefaultValue=a[w].default,this.updatePropertyDefaultValue(w,S),e.OVERRIDE_PROPERTY_REGEX.test(w)?S.scope=void 0:(S.scope=l.isUndefinedOrNull(S.scope)?r:S.scope,S.restricted=l.isUndefinedOrNull(S.restricted)?!!t?.includes(w):S.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.excludedConfigurationProperties[w]=a[w],delete a[w];continue}else this.configurationProperties[w]=a[w],a[w].policy?.name&&this.policyConfigurations.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),s.add(w)}const h=i.allOf;if(h)for(const w of h)this.validateAndRegisterProperties(w,o,n,t,r,s)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const t=n.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let t=n?.value,r=n?.source;l.isUndefined(t)&&(t=o.defaultDefaultValue,r=void 0),l.isUndefined(t)&&(t=d(o.type)),o.default=t,o.defaultValueSource=r}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(k){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let o=p.exec(k);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=p.exec(k)}}return(0,L.distinct)(i)}e.overrideIdentifiersFromKey=b;function c(k){return k.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=c;function d(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const u=new m;P.Registry.add(e.Extensions.Configuration,u);function g(k,i){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?A.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?A.localize(8,null,k):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,k,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.validateProperty=g;function v(){const k=[],i=u.getConfigurationProperties();for(const o of Object.keys(i))k.push([o,i[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=v}),define(oe[73],ae([0,1,21,3,35,2,37,32,11,12,17,45,40]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class p{constructor(n={},t=[],r=[],s){this._contents=n,this._keys=t,this._overrides=r,this.raw=s,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof p)return t;const r=new b("");return r.parseRaw(t),r.configurationModel});this._rawConfiguration=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),s=t?this.rawConfiguration.getOverrideValue(n,t):void 0,a=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:s,merged:a}}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,I.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return L.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),r=R.deepClone(this.overrides),s=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const h of n)if(a.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.mergeContents(t,h.contents);for(const w of h.overrides){const[S]=r.filter(D=>L.equals(D.identifiers,w.identifiers));S?(this.mergeContents(S.contents,w.contents),S.keys.push(...w.keys),S.keys=L.distinct(S.keys)):r.push(R.deepClone(w))}for(const w of h.keys)s.indexOf(w)===-1&&s.push(w)}return new p(t,s,r,a.every(h=>h instanceof p)?void 0:a)}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const s of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s];const h=t[s];h&&(typeof a=="object"&&typeof h=="object"?(a=R.deepClone(a),this.mergeContents(a,h)):a=h),r[s]=a}return new p(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&P.isObject(n[r])&&P.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=R.deepClone(t[r])}}getContentsForOverrideIdentifer(n){let t=null,r=null;const s=a=>{a&&(r?this.mergeContents(r,a):r=R.deepClone(a))};for(const a of this.overrides)L.equals(a.identifiers,[n])?t=a.contents:a.identifiers.includes(n)&&s(a.contents);return s(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,t){this.updateValue(n,t,!0)}setValue(n,t){this.updateValue(n,t,!1)}removeValue(n){const t=this.keys.indexOf(n);t!==-1&&(this.keys.splice(t,1),(0,I.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>L.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}updateValue(n,t,r){(0,I.addToValueTree)(this.contents,n,t,s=>console.error(s)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,I.toValuesTree)(this.contents[n],s=>console.error(s))})}}e.ConfigurationModel=p;class b{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!P.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:s,overrides:a,restricted:h,hasExcludedProperties:w}=this.doParseRaw(n,t);this._configurationModel=new p(r,s,a,w?[n]:void 0),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},r=null,s=[];const a=[],h=[];function w(D){Array.isArray(s)?s.push(D):r!==null&&(s[r]=D)}const S={onObjectBegin:()=>{const D={};w(D),a.push(s),s=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const D=[];w(D),a.push(s),s=D,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:w,onError:(D,T,M)=>{h.push({error:D,offset:T,length:M})}};if(n)try{l.visit(n,S),t=s[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return t}doParseRaw(n,t){const r=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(n,r,!0,t);n=s.raw;const a=(0,I.toValuesTree)(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),h=Object.keys(n),w=this.toOverrides(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:a,keys:h,overrides:w,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(n,t,r,s){let a=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:a};const h={},w=[];for(const S in n)if(E.OVERRIDE_PROPERTY_REGEX.test(S)&&r){const D=this.filter(n[S],t,!1,s);h[S]=D.raw,a=a||D.hasExcludedProperties,w.push(...D.restricted)}else{const D=t[S],T=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&w.push(S),(T===void 0||s.scopes===void 0||s.scopes.includes(T))&&!(s.skipRestricted&&D?.restricted)?h[S]=n[S]:a=!0}return{raw:h,restricted:w,hasExcludedProperties:a}}toOverrides(n,t){const r=[];for(const s of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const h in n[s])a[h]=n[s][h];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,t)})}return r}}e.ConfigurationModelParser=b;class c extends A.Disposable{constructor(n,t,r,s){super(),this.userSettingsResource=n,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class d{constructor(n,t,r,s,a,h,w,S,D,T,M,x,V){this.key=n,this.overrides=t,this._value=r,this.overrideIdentifiers=s,this.defaultConfiguration=a,this.policyConfiguration=h,this.applicationConfiguration=w,this.userConfiguration=S,this.localUserConfiguration=D,this.remoteUserConfiguration=T,this.workspaceConfiguration=M,this.folderConfigurationModel=x,this.memoryConfigurationModel=V}get value(){return f(this._value)}inspect(n,t,r){const s=n.inspect(t,r);return{get value(){return f(s.value)},get override(){return f(s.override)},get merged(){return f(s.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(n,t,r,s,a=new p,h=new p,w=new _.ResourceMap,S=new p,D=new _.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=t,this._applicationConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=a,this._workspaceConfiguration=h,this._folderConfigurations=w,this._memoryConfiguration=S,this._memoryConfigurationByResource=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidatedConfigurationModel(n,t,r).getValue(n)}updateValue(n,t,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new p,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(n):s.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const s=this.getConsolidatedConfigurationModel(n,t,r),a=this.getFolderConfigurationModelForResource(t.resource,r),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,w=new Set;for(const S of s.overrides)for(const D of S.identifiers)s.getOverrideValue(n,D)!==void 0&&w.add(D);return new d(n,t,s.getValue(n),w.size?[...w]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,a||void 0,h)}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:s,updated:a,removed:h}=k(this._defaultConfiguration,n);t=[...s,...a,...h]}for(const s of t)for(const a of(0,E.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),S=[...w.filter(D=>h.indexOf(D)===-1),...h.filter(D=>w.indexOf(D)===-1),...h.filter(D=>!R.equals(this._defaultConfiguration.override(a).getValue(D),n.override(a).getValue(D)))];r.push([a,S])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:s}=k(this._policyConfiguration,n),a=[...t,...r,...s];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:s,overrides:a}=k(this.applicationConfiguration,n),h=[...t,...r,...s];return h.length&&this.updateApplicationConfiguration(n),{keys:h,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:s,overrides:a}=k(this.localUserConfiguration,n),h=[...t,...r,...s];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:s,overrides:a}=k(this.remoteUserConfiguration,n),h=[...t,...r,...s];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:s,overrides:a}=k(this.workspaceConfiguration,n),h=[...t,...r,...s];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:s,updated:a,removed:h,overrides:w}=k(r,t),S=[...s,...a,...h];return(S.length||!r)&&this.updateFolderConfiguration(n,t),{keys:S,overrides:w}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:s,removed:a,overrides:h}=k(t,void 0);return{keys:[...r,...s,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const s=t.getFolder(n);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const a=this._memoryConfigurationByResource.get(n);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(n);s?(t=r.merge(s),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:s,keys:a}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:s,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(t=>n.add(t)),this.userConfiguration.keys.forEach(t=>n.add(t)),this._workspaceConfiguration.keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),s=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),h=this.parseConfigurationModel(n.workspace),w=n.folders.reduce((S,D)=>(S.set(y.URI.revive(D[0]),this.parseConfigurationModel(D[1])),S),new _.ResourceMap);return new u(t,r,s,a,new p,h,w,new p,new _.ResourceMap)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides)}}e.Configuration=u;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const s of o)s.keys.forEach(a=>n.add(a)),s.overrides.forEach(([a,h])=>{const w=(0,_.getOrSet)(t,a,new Set);h.forEach(S=>w.add(S))});const r=[];return t.forEach((s,a)=>r.push([a,[...s.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class v{constructor(n,t,r,s){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=s,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const h of a)this.affectedKeys.add(h);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){const r=this._marker+n,s=this._affectsConfigStr.indexOf(r);if(s<0)return!1;const a=s+r.length;if(a>=this._affectsConfigStr.length)return!1;const h=this._affectsConfigStr.charCodeAt(a);if(h!==this._markerCode1&&h!==this._markerCode2)return!1;if(t){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,S=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(w,S)}return!0}}e.ConfigurationChangeEvent=v;function k(o,n){const{added:t,removed:r,updated:s}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],h=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const S=w.filter(D=>!h.includes(D));for(const D of S)a.push([D,n.getKeysForOverrideIdentifier(D)])}if(o){const S=h.filter(D=>!w.includes(D));for(const D of S)a.push([D,o.getKeysForOverrideIdentifier(D)])}if(n&&o){for(const S of h)if(w.includes(S)){const D=i({contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)},{contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)});a.push([S,[...D.added,...D.removed,...D.updated]])}}return{added:t,removed:r,updated:s,overrides:a}}function i(o,n){const t=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],r=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],s=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const h=(0,I.getConfigurationValue)(n.contents,a),w=(0,I.getConfigurationValue)(o.contents,a);R.equals(h,w)||s.push(a)}}return{added:t,removed:r,updated:s}}}),define(oe[221],ae([0,1,21,3,2,32,11,73,45,9,58,40]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends l.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(E.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(c),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(c,d){this.updateConfigurationModel(c,E.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const c=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(c),c)}updateConfigurationModel(c,d){const u=this.getConfigurationDefaultOverrides();for(const g of c){const v=u[g],k=d[g];v!==void 0?this._configurationModel.addValue(g,v):k?this._configurationModel.addValue(g,k.default):this._configurationModel.removeValue(g)}}}e.DefaultConfiguration=m;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let p=class extends l.Disposable{get configurationModel(){return this._configurationModel}constructor(c,d,u){super(),this.defaultConfiguration=c,this.policyService=d,this.logService=u,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.updatePolicyDefinitions(c),!0))),this._configurationModel}async updatePolicyDefinitions(c){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",c);const d={},u=[],g=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const v of c){const k=g[v];if(!k){u.push(v);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.logService.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(v),d[k.policy.name]={type:k.type}}}return(0,_.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),u}onDidChangePolicies(c){this.logService.trace("PolicyConfiguration#onDidChangePolicies",c);const d=E.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),u=(0,L.coalesce)(c.map(g=>d.get(g)));this.update(u,!0)}update(c,d){this.logService.trace("PolicyConfiguration#update",c);const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),g=[],v=this._configurationModel.isEmpty();for(const k of c){const i=u[k]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(v?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(k),o))&&g.push([k,o])}else this._configurationModel.getValue(k)!==void 0&&g.push([k,void 0])}if(g.length){this.logService.trace("PolicyConfiguration#changed",g);const k=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const i of k.keys)this._configurationModel.setValue(i,k.getValue(i));for(const[i,o]of g)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};p=ve([Y(1,I.IPolicyService),Y(2,y.ILogService)],p),e.PolicyConfiguration=p}),define(oe[222],ae([0,1,6,3,2,23,17,73,221,58]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends l.Disposable{constructor(m,f,p,b){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=p instanceof y.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,p,b)),this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,f)),this.configuration=new R.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:d})=>this.onDidDefaultConfigurationChange(c,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,f,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new R.Configuration(m,f,new R.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,f){const p=typeof m=="string"?m:void 0,b=(0,_.isConfigurationOverrides)(m)?m:(0,_.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(p,b,void 0)}updateValue(m,f,p,b){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const f=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,f,2)}onDidDefaultConfigurationChange(m,f){const p=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(m,f);this.trigger(b,p,7)}onDidPolicyConfigurationChange(m){const f=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,f,7)}trigger(m,f,p){const b=new R.ConfigurationChangeEvent(m,{data:f},this.configuration);b.source=p,b.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(oe[223],ae([0,1,10,5]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends L.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof A&&P._code===l.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===l.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===l.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}constructor(P,y=l.Unknown,I){super(P),this._message=P,this._code=y,this._detail=I,this.isHandled=y===l.NotAvailable&&I===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function _(R){const P=R.indexOf("+");return P===-1?R:R.substring(0,P)}e.getRemoteAuthorityPrefix=_}),define(oe[74],ae([0,1,22]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(y){return y.scheme===L.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=O;function l(y){if(!y)return;const I=y.indexOf("+");return I<0?y:y.substr(0,I)}e.getRemoteName=l;function A(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=A;function _(y){const{host:I,port:E}=P(y);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.parseAuthorityWithPort=_;function R(y,I){let{host:E,port:m}=P(y);return typeof m>"u"&&(m=I),{host:E,port:m}}e.parseAuthorityWithOptionalPort=R;function P(y){const I=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=y.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(oe[50],ae([0,1,27,5,74]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,d){if(typeof c>"u"||c===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof c=="string"||typeof d=="string"){const u=typeof c=="string"?c:c.value,g=typeof d=="string"?d:d.value;return L.equalsIgnoreCase(u,g)}return c._lower===d._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=P;class y{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const d of c)this.add(d)}add(c){this._set.add(P.toKey(c))}delete(c){return this._set.delete(P.toKey(c))}has(c){return this._set.has(P.toKey(c))}}e.ExtensionIdentifierSet=y;class I{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(P.toKey(c))}get(c){return this._map.get(P.toKey(c))}has(c){return this._map.has(P.toKey(c))}set(c,d){this._map.set(P.toKey(c),d)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function E(b){return m(b)}e.isApplicationScopedExtension=E;function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function p(b,c){if(c){const d=`onResolveRemoteAuthority:${(0,l.getRemoteName)(c)}`;return!!b.activationEvents?.includes(d)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[224],ae([0,1,2,50,13]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends L.Disposable{constructor(R,P,y,I,E){super(),this.userDataProfilesService=R,this.fileService=P,this.uriIdentityService=y,this.logService=E,this._register(I.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(I.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,R)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(P){(0,l.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=A}),define(oe[225],ae([0,1,6,16,25,10,3,2,105,89,31,96,223,74]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var b;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function c(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(C){const U=new l.CancellationTokenSource;return setTimeout(()=>U.cancel(),C),U.token}function u(C,U){if(C.isCancellationRequested||U.isCancellationRequested)return l.CancellationToken.Cancelled;const $=new l.CancellationTokenSource;return C.onCancellationRequested(()=>$.cancel()),U.onCancellationRequested(()=>$.cancel()),$.token}class g{get didTimeout(){return this._state==="timedout"}constructor(U){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise(($,G)=>{this._resolvePromise=$,this._rejectPromise=G}),U.isCancellationRequested?this._timeout():this._disposables.add(U.onCancellationRequested(()=>this._timeout()))}registerDisposable(U){this._state==="pending"?this._disposables.add(U):U.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(U))}reject(U){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(U))}}function v(C,U){const $=new g(U);return $.registerDisposable(C.onControlMessage(G=>{const W=JSON.parse(G.toString()),Z=ee(W);Z?$.reject(Z):$.resolve(W)})),$.promise}function k(C,U,$,G,W,Z,te,ce,he){const pe=new g(he),fe=y.StopWatch.create(!1);return C.info(`Creating a socket (${ce})...`),P.mark(`code/willCreateSocket/${te}`),U.connect($,G,W,Z,ce,(ye,Ce)=>{pe.didTimeout?(P.mark(`code/didCreateSocketError/${te}`),C.info(`Creating a socket (${ce}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ye&&C.error(ye),Ce?.dispose()):ye||!Ce?(P.mark(`code/didCreateSocketError/${te}`),C.info(`Creating a socket (${ce}) returned an error after ${fe.elapsed()} ms.`),pe.reject(ye)):(P.mark(`code/didCreateSocketOK/${te}`),C.info(`Creating a socket (${ce}) was successful after ${fe.elapsed()} ms.`),pe.resolve(Ce))}),pe.promise}function i(C,U){const $=new g(U);return C.then(G=>{$.didTimeout||$.resolve(G)},G=>{$.didTimeout||$.reject(G)}),$.promise}async function o(C,U,$,G){const W=B(C,U);C.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await k(C.logService,C.socketFactory,C.host,C.port,(0,f.getRemoteServerRootPath)(C),`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,c(U),`renderer-${c(U)}-${C.reconnectionToken}`,G)}catch(fe){throw C.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),C.logService.error(fe),fe}C.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let te,ce;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection(Z,null),te=C.reconnectionProtocol,ce=!1):(te=new E.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),ce=!0),C.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const he=await i(C.signService.createNewMessage((0,I.generateUuid)()),G),pe={type:"auth",auth:C.connectionToken||"00000000000000000000",data:he.data};te.sendControl(O.VSBuffer.fromString(JSON.stringify(pe)));try{const fe=await v(te,u(G,d(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(C.logService.trace(`${W} 4/6. received SignRequest control message.`),!await i(C.signService.validate(he,fe.signedData),G)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await i(C.signService.sign(fe.data),G),Re={type:"connectionType",commit:C.commit,signedData:Ce,desiredConnectionType:U};return $&&(Re.args=$),C.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(O.VSBuffer.fromString(JSON.stringify(Re))),{protocol:te,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(C.logService.error(`${W} the handshake timed out. Error:`),C.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${W} received error control message when negotiating connection. Error:`),C.logService.error(fe)),ce&&F(te),fe}}async function n(C,U,$,G){const W=Date.now(),Z=B(C,U),{protocol:te,ownsProtocol:ce}=await o(C,U,$,G),he=new g(G);return he.registerDisposable(te.onControlMessage(pe=>{const fe=JSON.parse(pe.toString()),ye=ee(fe);ye?(C.logService.error(`${Z} received error control message when negotiating connection. Error:`),C.logService.error(ye),ce&&F(te),he.reject(ye)):(C.reconnectionProtocol?.endAcceptReconnection(),C.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${N(W)}!`),he.resolve({protocol:te,firstMessage:fe}))})),he.promise}async function t(C,U){const{protocol:$}=await n(C,1,void 0,U);return{protocol:$}}async function r(C,U,$){const{protocol:G,firstMessage:W}=await n(C,2,U,$),Z=W&&W.debugPort;return{protocol:G,debugPort:Z}}async function s(C,U,$){const G=Date.now(),W=B(C,3),{protocol:Z}=await o(C,3,U,$);return C.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${N(G)}!`),Z}async function a(C,U,$){const{host:G,port:W,connectionToken:Z}=await C.addressProvider.getAddress();return{commit:C.commit,quality:C.quality,host:G,port:W,connectionToken:Z,reconnectionToken:U,reconnectionProtocol:$,socketFactory:C.socketFactory,signService:C.signService,logService:C.logService}}async function h(C,U,$){return S(C,async G=>{const{protocol:W}=await t(G,l.CancellationToken.None);return new X(C,U,$,G.reconnectionToken,W)})}e.connectRemoteAgentManagement=h;async function w(C,U){return S(C,async $=>{const{protocol:G,debugPort:W}=await r($,U,l.CancellationToken.None);return new j(C,U,$.reconnectionToken,G,W)})}e.connectRemoteAgentExtensionHost=w;async function S(C,U){for(let G=1;;G++)try{const W=(0,I.generateUuid)(),Z=await a(C,W,null);return await U(Z)}catch(W){if(G<5)C.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),C.logService.error(W);else throw C.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),C.logService.error(W),K.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(W)),W}}async function D(C,U,$){const G=await a(C,(0,I.generateUuid)(),null);return await s(G,{host:U,port:$},l.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function T(C){return(0,L.createCancelablePromise)(U=>new Promise(($,G)=>{const W=setTimeout($,C*1e3);U.onCancellationRequested(()=>{clearTimeout(W),$()})}))}var M;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain",C[C.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class x{constructor(U,$){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=x;class V{constructor(U,$,G,W){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.durationSeconds=G,this.cancellableTimer=W,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class q{constructor(U,$,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=q;class z{constructor(U,$,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=4}}e.ConnectionGainEvent=z;class J{constructor(U,$){this.reconnectionToken=U,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=J;class Q{constructor(U,$,G,W){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=G,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class K extends R.Disposable{static triggerPermanentFailure(U,$,G){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=U,this._permanentFailureAttempt=$,this._permanentFailureHandled=G,this._instances.forEach(W=>W._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(U=>U._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(U=>U._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||K._permanentFailure}constructor(U,$,G,W,Z){super(),this._connectionType=U,this._options=$,this.reconnectionToken=G,this.protocol=W,this._reconnectionFailureIsFatal=Z,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new z(this.reconnectionToken,0,0)),this._register(W.onSocketClose(te=>{const ce=H(this._connectionType,this.reconnectionToken,!0);te?te.type===0?(this._options.logService.info(`${ce} received socket close event (hadError: ${te.hadError}).`),te.error&&this._options.logService.error(te.error)):(this._options.logService.info(`${ce} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this._options.logService.error(te.event)):this._options.logService.info(`${ce} received socket close event.`),this._beginReconnecting()})),this._register(W.onSocketTimeout(te=>{const ce=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),this._register(W.onHighRoundTripTime(te=>{const ce=se(this._connectionType,this.reconnectionToken);this._options.logService.info(`${ce} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this._register(W.onDidChangeConnectionHealth(te=>{this._onDidStateChange.fire(new J(this.reconnectionToken,te))})),K._instances.push(this),this._register((0,R.toDisposable)(()=>{const te=K._instances.indexOf(this);te>=0&&K._instances.splice(te,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const U=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const W=G<$.length?$[G]:$[$.length-1];try{if(W>0){const te=T(W);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,te)),this._options.logService.info(`${U} waiting for ${W} seconds before reconnecting...`);try{await te}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${U} resolving connection...`);const Z=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${U} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(p)),this._options.logService.info(`${U} reconnected!`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this._options.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,A.isCancellationError)(Z)){this._options.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this._options.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(U,$,G){this._reconnectionFailureIsFatal?K.triggerPermanentFailure(U,$,G):this._gotoPermanentFailure(U,$,G)}_gotoPermanentFailure(U,$,G){this._onDidStateChange.fire(new Q(this.reconnectionToken,U,$,G)),F(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[],e.PersistentConnection=K;class X extends K{constructor(U,$,G,W,Z){super(1,U,W,Z,!0),this.client=this._register(new E.Client(Z,{remoteAuthority:$,clientId:G},U.ipcLogger))}async _reconnect(U,$){await t(U,$)}}e.ManagementPersistentConnection=X;class j extends K{constructor(U,$,G,W,Z){super(2,U,G,W,!1),this._startArguments=$,this.debugPort=Z}async _reconnect(U,$){await r(U,this._startArguments,$)}}e.ExtensionHostPersistentConnection=j;function F(C){try{C.acceptDisconnect();const U=C.getSocket();C.dispose(),U.dispose()}catch(U){(0,A.onUnexpectedError)(U)}}function ee(C){if(C&&C.type==="error"){const U=new Error(`Connection error: ${C.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function ne(C,U){for(;C.length<U;)C+=" ";return C}function se(C,U){return`[remote-connection][${ne(c(C),13)}][${U.substr(0,5)}\u2026]`}function H(C,U,$){return`${se(C,U)}[${$?"reconnect":"initial"}]`}function B(C,U){return`${H(U,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.host}:${C.port}]`}function N(C){return`${Date.now()-C} ms`}}),define(oe[226],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[227],ae([0,1,86,154]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,A,_,R,P,y){const I=m=>y(m,void 0),E=L.createConnection({host:l,port:A},()=>{E.removeListener("error",I);const m=Buffer.alloc(16);for(let c=0;c<16;c++)m[c]=Math.round(Math.random()*256);const f=m.toString("base64"),p=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${A}${_}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];E.write(p.join(`\r
`)+`\r
\r
`);const b=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",b),y(void 0,new O.NodeSocket(E,P)))};E.on("data",b)});E.setNoDelay(!0),E.once("error",I)}}}),define(oe[110],ae([0,1,5,174]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var l;(function(A){A.disconnected={type:"disconnected"},A.uninitialized={type:"uninitialized"},A.connected=_=>({type:"connected",info:_}),A.connecting=_=>({type:"connecting",progress:_})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(oe[59],ae([0,1,16,10,2,176,45,5,9,40]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class I{constructor(k){this.original=k}toJSON(){if(!this.headers){const k=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?k[i]="*****":k[i]=this.original[i];this.headers=k}return this.headers}}class E extends l.Disposable{constructor(k,i){super(),this.counter=0,this.logger=i.createLogger(k?"remotenetwork":"network",{name:k?(0,A.localize)(0,null):(0,A.localize)(1,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(k,i,o){const n=`${k} #${++this.counter}: ${i.url}`;this.logger.trace(`${n} - begin`,i.type,new I(i.headers??{}));try{const t=await o();return this.logger.trace(`${n} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${n} - error`,i.type,(0,O.getErrorMessage)(t)),t}}}e.AbstractRequestService=E;function m(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=m;function f(v){return v.res.statusCode===204}async function p(v){return f(v)?null:(await(0,L.streamToBuffer)(v.stream)).toString()}e.asText=p;async function b(v){if(!m(v))throw new Error("Server returned "+v.res.statusCode);return p(v)}e.asTextOrError=b;async function c(v){if(!m(v))throw new Error("Server returned "+v.res.statusCode);if(f(v))return null;const i=(await(0,L.streamToBuffer)(v.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=c;function d(v){g(v)}e.updateProxyConfigurationsScope=d;let u;function g(v){const k=y.Registry.as(_.Extensions.Configuration),i=u;u={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:i?[i]:[]})}g(1)}),define(oe[228],ae([0,1,25,22,13,59]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(P,y){this.requestService=P,this.fileService=y}async download(P,y,I=L.CancellationToken.None){if(P.scheme===O.Schemas.file||P.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(P,y);return}const E={type:"GET",url:P.toString(!0)},m=await this.requestService.request(E,I);if(m.res.statusCode===200)await this.fileService.writeFile(y,m.stream);else{const f=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};_=ve([Y(0,A.IRequestService),Y(1,l.IFileService)],_),e.DownloadService=_}),define(oe[229],ae([0,1,16,25]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.service=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,y,I=O.CancellationToken.None){switch(P){case"request":return this.service.request(y[0],I).then(async({res:E,stream:m})=>{const f=await(0,L.streamToBuffer)(m);return[{statusCode:E.statusCode,headers:E.headers},f]});case"resolveProxy":return this.service.resolveProxy(y[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class A{constructor(R){this.channel=R}async request(R,P){const[y,I]=await this.channel.call("request",[R],P);return{res:y,stream:(0,L.bufferToStream)(I)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(oe[111],ae([0,1,53,5]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(A){return(0,L.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,O.createDecorator)("sharedProcessWorkerService")}),define(oe[230],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(O){O.Spawn="vscode:shared-process->shared-process-worker=spawn",O.Terminate="vscode:shared-process->shared-process-worker=terminate",O.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",O.Ready="vscode:shared-process-worker->shared-process=ready",O.Ack="vscode:shared-process-worker->shared-process=ack",O.Trace="vscode:shared-process-worker->shared-process=trace",O.Info="vscode:shared-process-worker->shared-process=info",O.Warn="vscode:shared-process-worker->shared-process=warn",O.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[231],ae([0,1,152,6,25,3,2,22,31,9,111,230]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(b){this.logService=b,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(b){const c=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${c})`);const d=(0,I.hash)(b);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.doDisposeWorker(b));const u=new l.CancellationTokenSource;let g,v,k;this.processeDisposables.set(d,t=>{u.dispose(!0),g?.terminate(b,l.CancellationToken.None),v?.close(),k?.close(),this.processeDisposables.delete(d);const r=this.processResolvers.get(d);r&&(this.processResolvers.delete(d),r({reason:t}))}),g=await this.getOrCreateWebWorker(b);const i=new Promise(t=>{this.processResolvers.set(d,t)});if(u.token.isCancellationRequested)return i;const{port1:o,port2:n}=new MessageChannel;return v=o,k=n,await g.spawn(b,k,u.token),u.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",b,[v])),i}getOrCreateWebWorker(b){let c=this.workers.get(b.process.moduleId);if(!c){this.logService.trace(`SharedProcess: creating new web worker (${b.process.moduleId})`);const d=new f(b.process.type,this.logService);c=d.init(),d.onDidProcessSelfTerminate(({configuration:u,reason:g})=>{this.doDisposeWorker(u,g)}),this.workers.set(b.process.moduleId,c)}return c}async disposeWorker(b){return this.doDisposeWorker(b)}doDisposeWorker(b,c){const d=this.processeDisposables.get((0,I.hash)(b));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),d(c))}};m=ve([Y(0,y.ILogService)],m),e.SharedProcessWorkerService=m;class f extends _.Disposable{constructor(b,c){super(),this.type=b,this.logService=c,this._onDidProcessSelfTerminate=this._register(new A.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const b=new O.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},c.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},c.onmessage=d=>{const{id:u,message:g,configuration:v,nonce:k}=d.data;switch(u){case E.SharedProcessWorkerMessages.Ready:b.complete(c);break;case E.SharedProcessWorkerMessages.Ack:if(k){const i=this.mapMessageNonceToPendingMessageResolve.get(k);i&&(this.mapMessageNonceToPendingMessageResolve.delete(k),i())}break;case E.SharedProcessWorkerMessages.SelfTerminated:v&&g&&this._onDidProcessSelfTerminate.fire({configuration:v,reason:JSON.parse(g)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Info:g&&this.logService.info(g);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),b.p}async send(b,c,d){const u=await this.workerReady;if(!c.isCancellationRequested)return new Promise(g=>{const v=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(v,g);const k={...b,nonce:v};d?u.postMessage(k,[d]):u.postMessage(k),c.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(v)&&g()})})}spawn(b,c,d){const u={id:E.SharedProcessWorkerMessages.Spawn,configuration:b,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.send(u,d,c)}terminate(b,c){const d={id:E.SharedProcessWorkerMessages.Terminate,configuration:b};return this.send(d,c)}}}),define(oe[232],ae([0,1,62,22,98]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}ve([L.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[233],ae([0,1,49,14,177,25,38,10,4,31,149,195,6,132]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function b(d,u,g,v){return g["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(v)&&!g["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(v)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(k,i)=>{const o=new A.CancellationTokenSource;let n=1e4;const t=d.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(n=(0,f.clamp)(t,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),i(new Error((0,l.localize)(0,null)))},n);try{k(await c(u,o.token))}catch(s){!(0,R.isCancellationError)(s)&&!o.token.isCancellationRequested?i(new Error((0,l.localize)(1,null,(0,_.toErrorMessage)(s)))):k({})}finally{clearTimeout(r),o.dispose()}})),p)}e.getResolvedShellEnv=b;async function c(d,u){const g=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",v);const k=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(k+"({.*})"+k),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,I.getSystemShell)(P.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((t,r)=>{if(u.isCancellationRequested)return r(new R.CancellationError);const s=(0,O.basename)(n);let a,h;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${w} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,s==="tcsh"||s==="csh"?h=["-ic"]:h=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const S=(0,L.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.onCancellationRequested(()=>(S.kill(),r(new R.CancellationError))),S.on("error",M=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,_.toErrorMessage)(M)),r(M)});const D=[];S.stdout.on("data",M=>D.push(M));const T=[];S.stderr.on("data",M=>T.push(M)),S.on("close",(M,x)=>{const V=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",V);const q=Buffer.concat(T).toString("utf8");if(q.trim()&&d.trace("getUnixShellEnvironment#stderr",q),M||x)return r(new Error((0,l.localize)(2,null,M,x)));const z=i.exec(V),J=z?z[1]:"{}";try{const Q=JSON.parse(J);g?Q.ELECTRON_RUN_AS_NODE=g:delete Q.ELECTRON_RUN_AS_NODE,v?Q.ELECTRON_NO_ATTACH_CONSOLE=v:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),t(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",(0,_.toErrorMessage)(Q)),r(Q)}})})}}),define(oe[112],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[234],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((l,A)=>ie(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.vsda(),_=new A.validator;if(_){const R=String(L._nextId++);return this.validators.set(R,_),{id:R,data:_.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const _=this.validators.get(l.id);if(!_)return!1;this.validators.delete(l.id);try{return _.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.vsda(),_=new A.signer;if(_)return _.sign(l)}catch{}return l}}L._nextId=1,e.SignService=L}),define(oe[75],ae([0,1,3,2]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends O.Disposable{constructor(E,m,f){super(),this.channel=E,this.profile=m,this.workspace=f}async getItems(){const E={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",E);return new Map(m)}updateItems(E){const m={profile:this.profile,workspace:this.workspace};return E.insert&&(m.insert=Array.from(E.insert.entries())),E.delete&&(m.delete=Array.from(E.delete.values())),this.channel.call("updateItems",m)}}class A extends l{constructor(E,m){super(E,m,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class _ extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class R extends A{constructor(E,m){super(E,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends l{constructor(E,m){super(E,void 0,m),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class y{constructor(E){this.channel=E}isUsed(E){const m={payload:E,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=y}),define(oe[113],ae([0,1,4,36,31]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(L.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function _(P,y,I,E,m,f,p,b){const c=Object.create(null);c["common.machineId"]=f,c.sessionID=(0,l.generateUuid)()+Date.now(),c.commitHash=E,c.version=m,c["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.PlatformToString)(L.platform),c["common.nodePlatform"]=O.platform,c["common.nodeArch"]=I,c["common.product"]=b||"desktop",p&&(c["common.msftInternal"]=p);let d=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),L.isLinuxSnap&&(c["common.snap"]="true");const g=A(y);return g&&(c["common.platformDetail"]=g),c}e.resolveCommonProperties=_;function R(P){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const I=y.toLowerCase();return P.some(E=>I===E)}e.verifyMicrosoftInternalDomain=R}),define(oe[19],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[235],ae([0,1,34,6,35,22,14,4,12,146,28,148,99,13,26,19]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function d(i,o){const n=`${i}::${o.join(":")}`,t=c.get(n);if(t)return t;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],s=new Map,a=new Map,h=2e4;function w(D,T,M,x){const V=T.substring(D.length+1);return O.Promises.withAsyncBody(async q=>{let z;try{z=await I.Promises.readdir(T,{withFileTypes:!0})}catch{q();return}if(x.count>=h){x.count+=z.length,x.maxReached=!0,q();return}let J=z.length;if(J===0){q();return}let Q=z;x.count+z.length>h&&(x.maxReached=!0,J=h-x.count,Q=z.slice(0,J)),x.count+=z.length;for(const K of Q)if(K.isDirectory()){if(M.includes(K.name)||await w(D,(0,_.join)(T,K.name),M,x),--J===0){q();return}}else{const X=K.name.lastIndexOf(".");if(X>=0){const j=K.name.substring(X+1);j&&s.set(j,(s.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test(V)!==!1&&j.filePattern.test(K.name)&&a.set(j.tag,(a.get(j.tag)??0)+1);if(--J===0){q();return}}})}const S=O.Promises.withAsyncBody(async D=>{const T={count:0,maxReached:!1};await w(i,i,o,T);const M=await v(i);D({configFiles:u(a),fileTypes:u(s),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:M})});return c.set(n,S),S}e.collectWorkspaceStats=d;function u(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function g(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=g;async function v(i){try{const o=new Map,n=(0,_.join)(i,".vscode","launch.json"),t=await I.Promises.readFile(n),r=[],s=(0,l.parse)(t.toString(),r);if(r.length)return console.log(`Unable to parse ${n}`),[];if((0,l.getNodeType)(s)==="object"&&s.configurations)for(const a of s.configurations){const h=a.type;h&&(o.has(h)?o.set(h,o.get(h)+1):o.set(h,1))}return u(o)}catch{return[]}}e.collectLaunchConfigs=v;let k=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${L.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,E.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[r,s]=t,a=this.formatProcessList(o,r);return n.forEach(h=>{if((0,m.isRemoteDiagnosticError)(h))a+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(a+=`

Remote: ${h.hostName}`,h.processes&&(a+=`
${this.formatProcessList(o,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const w of Object.keys(h.workspaceMetadata)){const S=h.workspaceMetadata[w];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),s+=`|    Folder (${w}): ${D}`,s+=this.formatWorkspaceStats(S)}}}),{processInfo:a,workspaceInfo:s}})}async getSystemInfo(o,n){const{memory:t,vmHint:r,os:s,cpus:a}=g(),h={os:s,memory:t,cpus:a,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(h.load=`${L.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(o,n){const t=[];return(0,E.listProcesses)(o.mainPID).then(async r=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,r)),o.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),n.forEach(s=>{if((0,m.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(o,s.processes)),s.workspaceMetadata)for(const a of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[a];let w=`${h.fileCount} files`;h.maxFilesReached&&(w=`more than ${w}`),t.push(`Folder (${a}): ${w}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const n=[];let r=0;const s=(S,D)=>{const T=` ${S}(${D})`;r+T.length>60?(n.push(a),a="|                 ",r=a.length):r+=T.length,a+=T};let a="|      File types:";const h=10,w=o.fileTypes.length>h?h:o.fileTypes.length;for(let S=0;S<w;S++){const D=o.fileTypes[S];s(D.name,D.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",r=0,o.configFiles.forEach(S=>{s(S.name,S.count)}),n.push(a)),o.launchConfigFiles.length>0){let S="|      Launch Configs:";o.launchConfigFiles.forEach(D=>{S+=D.count>1?` ${D.name}(${D.count})`:` ${D.name}`}),n.push(S)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],t=[];return o.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(s=>{const a=P.URI.revive(s);if(a.scheme===A.Schemas.file){const h=a.fsPath;t.push(d(h,["node_modules",".git"]).then(w=>{let S=`${w.fileCount} files`;w.maxFilesReached&&(S=`more than ${S}`),n.push(`|    Folder (${(0,_.basename)(h)}): ${S}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${h} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(o,n){const t=new Map;o.windows.forEach(s=>t.set(s.pid,`window [${s.id}] (${s.title})`)),o.pidToNames.forEach(({pid:s,name:a})=>t.set(s,a));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,t,r,n,0),r.join(`
`)}formatProcessItem(o,n,t,r,s){const a=s===0;let h;a?h=r.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(r.pid)?h=n.get(r.pid):h=`${"  ".repeat(s)} ${r.name}`;const w=process.platform==="win32"?r.mem:L.totalmem()*(r.mem/100);t.push(`${r.load.toFixed(0).padStart(5," ")}	${(w/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(S=>this.formatProcessItem(o,n,t,S,s+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:t}of o.folders){const r=P.URI.revive(t);if(r.scheme!==A.Schemas.file)continue;const s=r.fsPath;try{(await d(s,["node_modules",".git"])).fileTypes.forEach(h=>n.add(h.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const t=P.URI.revive(n);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{const s=await d(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),s.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),s.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),s.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};k=ve([Y(0,b.ITelemetryService),Y(1,p.IProductService)],k),e.DiagnosticsService=k}),define(oe[236],ae([0,1,110,3,19,15,2,9,14,49,26,4,6,106,17,175,34]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const d=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let u=class extends _.Disposable{constructor(v,k,i,o,n,t){super(),this.telemetryService=v,this.productService=k,this.environmentService=i,this.configurationService=t,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new O.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=L.TunnelStates.disconnected,this._logger=this._register(o.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(this._logger.onDidChangeLogLevel(r=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(r)))),this._register(n.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(t.onDidChangeConfiguration(r=>{d.some(s=>r.affectsConfiguration(s))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(v){if(v&&this._account?v.token!==this._account.token||v.providerId!==this._account.providerId:v!==this._account){this._account=v,this._onDidChangeAccountEmitter.fire(v),v?this._logger.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this._logger.info("Account reset"),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(k){this._logger.error(k)}}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let v;E.isMacintosh?v=this.environmentService.appRoot:v=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(v,"bin",`${this.productService.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(L.TunnelStates.disconnected);return}const{token:v,providerId:k,accountLabel:i}=this._account;this.setTunnelStatus(L.TunnelStates.connecting((0,b.localize)(0,null,i,k)));const o=(a,h)=>{a=a.replaceAll(v,"*".repeat(4)),h?this._logger.error(a):this._logger.info(a),!this.environmentService.isBuilt&&a.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,b.localize)(1,null)))},n=this.runCodeTunneCommand("login",["user","login","--provider",k,"--access-token",v,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],o);this._tunnelProcess=n;try{if(await n,this._tunnelProcess!==n)return}catch(a){this._logger.error(a),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(L.TunnelStates.disconnected);return}const t=this._getHostName();t?this.setTunnelStatus(L.TunnelStates.connecting((0,b.localize)(2,null,t))):this.setTunnelStatus(L.TunnelStates.connecting((0,b.localize)(3,null)));const r=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];t?r.push("--name",t):r.push("--random-name"),this._preventSleep()&&r.push("--no-sleep");const s=this.runCodeTunneCommand("tunnel",r,(a,h)=>{h?this._logger.error(a):this._logger.info(a);const w=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(w){const S={link:w[1],domain:w[2],hostName:w[4]};this.setTunnelStatus(L.TunnelStates.connected(S))}else a.match(/error refreshing token/)&&(s.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(L.TunnelStates.disconnected))});this._tunnelProcess=s,s.finally(()=>{s===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(v){this._tunnelStatus=v,this._onDidChangeTunnelStatusEmitter.fire(v)}runCodeTunneCommand(v,k,i=()=>{}){return(0,m.createCancelablePromise)(o=>new Promise((n,t)=>{o.isCancellationRequested&&n();let r;if(o.onCancellationRequested(()=>{r&&(this._logger.info(`${v} terminating(${r.pid})`),r.kill())}),!this.environmentService.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${v} Spawning: cargo run -- tunnel ${k.join(" ")}`,!1),r=(0,y.spawn)("cargo",["run","--","tunnel",...k],{cwd:(0,P.join)(this.environmentService.appRoot,"cli")});else{i("Running tunnel CLI",!1);const s=this.getTunnelCommandLocation();i(`${v} Spawning: ${s} tunnel ${k.join(" ")}`,!1),r=(0,y.spawn)(s,["tunnel",...k],{cwd:(0,c.homedir)()})}r.stdout.on("data",s=>{if(r){const a=s.toString();i(a,!1)}}),r.stderr.on("data",s=>{if(r){const a=s.toString();i(a,!0)}}),r.on("exit",s=>{r&&(i(`${v} exit(${r.pid}): + ${s} `,!1),r=void 0,s===0?n():t())}),r.on("error",s=>{r&&(i(`${v} error(${r.pid}): + ${s} `,!0),r=void 0,t())})}))}async getHostName(){return this._getHostName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getHostName(){let v=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};u=ve([Y(0,l.ITelemetryService),Y(1,I.IProductService),Y(2,A.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,f.ISharedProcessLifecycleService),Y(5,p.IConfigurationService)],u),e.RemoteTunnelService=u}),define(oe[114],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(A){this.appenders=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,{eventName:R,data:P}){return this.appenders.forEach(y=>y.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class O{constructor(A){this.channel=A}log(A,_){return this.channel.call("log",{eventName:A,data:_}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(oe[46],ae([0,1,32,11,3,17,74,113,19]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class y{constructor(r){this.value=r}}e.TelemetryTrustedValue=y;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(r,s,a){}async publicLogError(r,s,a){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(t,r){return l.Event.debounce(r.onDidChangeConfiguration,(a,h)=>{const w=a?new Set([...a.affectedKeys,...h.affectedKeys]):h.affectedKeys;return{...h,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=m;function f(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function p(t,r){return!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=p;function b(t){const r=t.getValue(P.TELEMETRY_SETTING_ID),s=t.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function c(t){const r={},s={},a={};g(t,a);for(let h in a){h=h.length>150?h.substr(h.length-149):h;const w=a[h];typeof w=="number"?s[h]=w:typeof w=="boolean"?s[h]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${w.length}`),r[h]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(r[h]=w)}return{properties:r,measurements:s}}e.validateTelemetryData=c;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const r=(0,_.getRemoteName)(t);return d.has(r)?r:"other"}e.cleanRemoteAuthority=u;function g(t,r,s=0,a){if(!!t)for(const h of Object.getOwnPropertyNames(t)){const w=t[h],S=a?a+h:h;Array.isArray(w)?r[S]=(0,L.safeStringify)(w):w instanceof Date?r[S]=w.toISOString():(0,O.isObject)(w)?s<2?g(w,r,s+1,S+"."):r[S]=(0,L.safeStringify)(w):r[S]=w}}function v(t,r){const s=t.msftInternalDomains||[],a=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(s)||a}e.isInternalTelemetry=v;function k(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=k;function i(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const a=[];for(const D of r)for(;;){const T=D.exec(t);if(!T)break;a.push([T.index,D.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(s="";;){const D=w.exec(t);if(!D)break;const T=a.some(([M,x])=>D.index<x&&M<w.lastIndex);!h.test(D[0])&&!T&&(s+=t.substring(S,D.index)+"<REDACTED: user-file-path>",S=w.lastIndex)}return S<t.length&&(s+=t.substr(S)),s}function o(t){if(!t)return t;const r=t.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of s)if(a.regex.test(r))return`<REDACTED: ${a.label}>`;return t}function n(t,r){return(0,L.cloneAndChange)(t,s=>{if(s instanceof y)return s.value;if(typeof s=="string"){let a=s.replaceAll("%20"," ");a=i(a,r);for(const h of r)a=a.replace(h,"");return a=o(a),a}})}e.cleanData=n}),define(oe[33],ae([0,1,27,29,50,4,12,10,36,46]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,L.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const r=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,r,s)}static parse(t){const r=E.exec(t);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const t=f.exec(n);return t&&t[1]?[c(t[1]),t[2]]:[c(n),void 0]}e.getIdAndVersion=p;function b(n,t){return`${n}.${t}`}e.getExtensionId=b;function c(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function d(n,t){return c(b(n??l.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=d;function u(n,t){const r=[],s=a=>{for(const h of r)if(h.some(w=>I(t(w),t(a))))return h;return null};for(const a of n){const h=s(a);h?h.push(a):r.push([a])}return r}e.groupByExtension=u;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(n){return{id:new y.TelemetryTrustedValue(n.identifier.id),name:new y.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function k(n,t){const r=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(h=>!I(h.identifier,{id:a}))){const h=n.filter(w=>I(w.identifier,{id:a}));h.length===1&&(r.push(h[0]),s.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=k;async function i(n,t){if(!A.isLinux)return!1;let r;try{r=(await n.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,t){const r=await i(n,t),s=(0,O.getTargetPlatform)(r?"alpine":A.platform,P.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=o}),define(oe[237],ae([0,1,21,2,23,12,13,26,6,3,14,4,36,164,33]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let b=class extends O.Disposable{constructor(v,k){super(),this.fileService=v,this.productService=k,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,i])=>this.allConfigBasedTips.set(i.configPath,i))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const k=[];for(const[i,o]of this.allConfigBasedTips)if(!(o.configScheme&&o.configScheme!==v.scheme))try{const n=(await this.fileService.readFile((0,l.joinPath)(v,i))).value.toString();for(const[t,r]of Object.entries(o.recommendations))(!r.contentPattern||new RegExp(r.contentPattern,"mig").test(n))&&k.push({extensionId:t,extensionName:r.name,configName:o.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})}catch{}return k}};b=ve([Y(0,_.IFileService),Y(1,R.IProductService)],b),e.ExtensionTipsService=b;const c="extensionTips/promptedExecutableTips",d="extensionTips/lastPromptedMediumImpExeTime";class u extends b{constructor(v,k,i,o,n,t,r,s){super(r,s),this.userHome=v,this.windowEvents=k,this.telemetryService=i,this.extensionManagementService=o,this.storageService=n,this.extensionRecommendationNotificationService=t,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([a,h])=>{const w=[],S=[],D=[];Object.entries(h.recommendations).forEach(([T,M])=>{M.important?h.important?w.push({extensionId:T,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):S.push({extensionId:T,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):D.push({extensionId:T,extensionName:M.name,isExtensionPack:!!M.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:w}),S.length&&this.mediumImportanceExecutableTips.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:S}),D.length&&this.allOtherExecutableTips.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:D})}),(0,P.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const v=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),k=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...v,...k]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const v=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),k=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),i=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(v,i),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(k,i)}groupImportantTipsByExe(v,k){const i=new Map;v.forEach(s=>i.set(s.extensionId.toLowerCase(),s));const{installed:o,uninstalled:n}=this.groupByInstalled([...i.keys()],k);for(const s of o){const a=i.get(s);a&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:a.exeName})}for(const s of n){const a=i.get(s);a&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:a.exeName})}const t=this.getPromptedExecutableTips(),r=new Map;for(const s of n){const a=i.get(s);if(a&&(!t[a.exeName]||!t[a.exeName].includes(a.extensionId))){let h=r.get(a.exeName);h||(h=[],r.set(a.exeName,h)),h.push(a)}}return r}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[v,k]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(k).then(i=>{switch(i){case"reacted":this.addToRecommendedExecutables(k[0].exeName,k);break;case"ignored":this.highImportanceTipsByExe.delete(v);break;case"incompatibleWindow":{const o=y.Event.once(y.Event.latch(y.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(o(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const o=this._register((0,P.disposableTimeout)(()=>{o.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const v=this.getLastPromptedMediumExeTime(),k=Date.now()-v,i=7*24*60*60*1e3;if(k<i){const t=this._register((0,P.disposableTimeout)(()=>{t.dispose(),this.promptMediumImportanceExeBasedTip()},i-k));return}const[o,n]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(n).then(t=>{switch(t){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(o),this.addToRecommendedExecutables(n[0].exeName,n);const r=this._register((0,P.disposableTimeout)(()=>{r.dispose(),this.promptMediumImportanceExeBasedTip()},i));break}case"ignored":this.mediumImportanceTipsByExe.delete(o),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const r=y.Event.once(y.Event.latch(y.Event.any(this.windowEvents.onDidOpenWindow,this.windowEvents.onDidFocusWindow)));this._register(r(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const r=this._register((0,P.disposableTimeout)(()=>{r.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(v){const k=await this.extensionManagementService.getInstalled(1),i=v.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(t=>k.every(r=>!(0,p.areSameExtensions)(r.identifier,{id:t})))).map(({extensionId:n})=>n.toLowerCase()),o=(0,f.localize)(0,null,v[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(i,o,`@exe:"${v[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let v=this.storageService.getNumber(d,-1);return v||(v=Date.now(),this.updateLastPromptedMediumExeTime(v)),v}updateLastPromptedMediumExeTime(v){this.storageService.store(d,v,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,-1,"{}"))}addToRecommendedExecutables(v,k){const i=this.getPromptedExecutableTips();i[v]=k.map(({extensionId:o})=>o.toLowerCase()),this.storageService.store(c,JSON.stringify(i),-1,0)}groupByInstalled(v,k){const i=[],o=[],n=k.reduce((t,r)=>(t.add(r.identifier.id.toLowerCase()),t),new Set);return v.forEach(t=>{n.has(t.toLowerCase())?i.push(t):o.push(t)}),{installed:i,uninstalled:o}}async getValidExecutableBasedExtensionTips(v){const k=[],i=new Map;for(const o of v.keys()){const n=v.get(o);if(!n||!(0,L.isNonEmptyArray)(n.recommendations))continue;const t=[];E.isWindows?n.windowsPath&&t.push(n.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(t.push((0,I.join)("/usr/local/bin",o)),t.push((0,I.join)("/usr/bin",o)),t.push((0,I.join)(this.userHome.fsPath,o)));for(const r of t){let s=i.get(r);if(s===void 0&&(s=await this.fileService.exists(A.URI.file(r)),i.set(r,s)),s)for(const{extensionId:a,extensionName:h,isExtensionPack:w,whenNotInstalled:S}of n.recommendations)k.push({extensionId:a,extensionName:h,isExtensionPack:w,exeName:o,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:S})}}return k}}e.AbstractNativeExtensionTipsService=u}),define(oe[238],ae([0,1,25,33]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(A,_,R,P,y){try{const I=await A.getExtensionsControlManifest();if(!I.deprecated)return;const E=await A.getInstalled(1);for(const[m,f]of Object.entries(I.deprecated)){if(!f?.extension)continue;const{id:p,autoMigrate:b,preRelease:c}=f.extension;if(!b)continue;const d=E.find(g=>(0,O.areSameExtensions)(g.identifier,{id:m}));if(!d)continue;const u=(await _.getExtensions([{id:p,preRelease:c}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!u){y.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{y.info(`Migrating '${d.identifier.id}' extension to '${p}' extension...`);const g=!P.getDisabledExtensions().some(k=>(0,O.areSameExtensions)(k,d.identifier));await A.uninstall(d),y.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let v=E.find(k=>(0,O.areSameExtensions)(k.identifier,{id:p}));(!v||!v.isPreReleaseVersion&&g)&&(v=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),y.info(`Installed the pre-release extension '${v.identifier.id}'`),g||(await P.disableExtension(v.identifier),y.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,O.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,O.getExtensionId)(v.manifest.publisher,v.manifest.name)),y.info("Added pre-release extension to the storage migration list"))),y.info(`Migrated '${d.identifier.id}' extension to '${p}' extension.`)}catch(g){y.error(g)}}}catch(I){y.error(I)}}e.migrateUnsupportedExtensions=l}),define(oe[239],ae([0,1,3,2,37,33,50]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(y,I,E,m,f,p,b){super(),this.extensionManagementService=y,this.extensionsScannerService=I,this.userDataProfilesService=E,this.extensionsProfileScannerService=m,this.uriIdentityService=f,this.fileService=p,this.logService=b,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,c=>b.error(c))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(y=>this.onDidChangeProfiles(y.added,y.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(y=>this.onAddExtensions(y))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(y=>this.onDidAddExtensions(y))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(y=>this.onRemoveExtensions(y))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(y=>this.onDidRemoveExtensions(y))),this._register(this.fileService.onDidFilesChange(y=>this.onDidFilesChange(y)))}async onDidChangeProfiles(y,I){try{await Promise.all(I.map(E=>(this.extensionsProfileWatchDisposables.deleteAndDispose(E.id),this.removeExtensionsFromProfile(E.extensionsResource)))),y.length&&await Promise.all(y.map(E=>(this.extensionsProfileWatchDisposables.set(E.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(E.extensionsResource)),this.fileService.watch(E.extensionsResource))),this.populateExtensionsFromProfile(E.extensionsResource))))}catch(E){throw this.logService.error(E),E}}async onAddExtensions(y){for(const I of y.extensions)this.addExtensionWithKey(this.getKey(I.identifier,I.version),y.profileLocation)}async onDidAddExtensions(y){for(const I of y.extensions){const E=this.getKey(I.identifier,I.version);y.error?this.removeExtensionWithKey(E,y.profileLocation):this.addExtensionWithKey(E,y.profileLocation)}}async onRemoveExtensions(y){for(const I of y.extensions)this.removeExtensionWithKey(this.getKey(I.identifier,I.version),y.profileLocation)}async onDidRemoveExtensions(y){const I=[],E=[];for(const m of y.extensions){const f=this.getKey(m.identifier,m.version);y.error?this.addExtensionWithKey(f,y.profileLocation):(this.removeExtensionWithKey(f,y.profileLocation),this.allExtensions.has(f)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(p=>{p?I.push(p):this.logService.info("Extension not found at the location",m.location.toString())},p=>this.logService.error(p)))))}try{await Promise.all(E),I.length&&await this.uninstallExtensionsNotInProfiles(I)}catch(m){this.logService.error(m)}}onDidFilesChange(y){for(const I of this.userDataProfilesService.profiles)y.contains(I.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(I.extensionsResource)}async onDidExtensionsProfileChange(y){const I=[],E=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(y),f=new Set,p=new Set;for(const[b,c]of this.allExtensions)c.has(y)&&p.add(b);for(const b of m){const c=this.getKey(b.identifier,b.version);f.add(c),p.has(c)||(I.push(b.identifier),this.addExtensionWithKey(c,y))}for(const b of p)if(!f.has(b)){const c=this.fromKey(b);c&&(E.push(c.identifier),this.removeExtensionWithKey(b,y))}(I.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I.length?{extensions:I,profileLocation:y}:void 0,removed:E.length?{extensions:E,profileLocation:y}:void 0})}async populateExtensionsFromProfile(y){const I=await this.extensionsProfileScannerService.scanProfileExtensions(y);for(const E of I)this.addExtensionWithKey(this.getKey(E.identifier,E.version),y)}async removeExtensionsFromProfile(y){for(const I of[...this.allExtensions.keys()])this.removeExtensionWithKey(I,y);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(y){y||(y=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(E=>!this.allExtensions.has(this.getKey(E.identifier,E.manifest.version)))),y.length&&await this.extensionManagementService.markAsUninstalled(...y)}addExtensionWithKey(y,I){let E=this.allExtensions.get(y);E||this.allExtensions.set(y,E=new l.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),E.add(I)}removeExtensionWithKey(y,I){const E=this.allExtensions.get(y);E&&E.delete(I),E?.size||this.allExtensions.delete(y)}getKey(y,I){return`${_.ExtensionIdentifier.toKey(y.id)}@${I}`}fromKey(y){const[I,E]=(0,A.getIdAndVersion)(y);return E?{identifier:{id:I},version:E}:void 0}}e.ExtensionsWatcher=R}),define(oe[240],ae([0,1,44,46]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(A,_,R,P,y,I,E){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${_.nameShort})`};if((0,O.supportsTelemetry)(_,R)&&(0,O.getTelemetryLevel)(P)===3){const f=await(0,L.getServiceMachineId)(R,y,I);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=E.machineId||f}return m}e.resolveMarketplaceHeaders=l}),define(oe[241],ae([0,1,103,21,6,2,22,14,28,15,29,33,9,72,12]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=class extends f.LanguagePackBaseService{constructor(g,v,k,i){super(k),this.extensionManagementService=g,this.logService=i,this.cache=this._register(new c(v,i)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(g,v){const i=(await this.cache.getLanguagePacks())[v];if(!i){this.logService.warn(`No language pack found for ${v}`);return}const o=i.translations[g];return o?p.URI.file(o):void 0}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),v=Object.keys(g).map(k=>{const i=g[k];return{...this.createQuickPickItem(k,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return v.push(this.createQuickPickItem("en","English")),v.sort((k,i)=>k.label.localeCompare(i.label)),v}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const v=await this.cache.getLanguagePacks();Object.keys(v).some(k=>v[k]&&v[k].extensions.some(i=>(0,E.areSameExtensions)(i.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),k=await this.cache.update(v);return!(0,O.equals)(Object.keys(g),Object.keys(k))}};b=ve([Y(0,I.IExtensionManagementService),Y(1,y.INativeEnvironmentService),Y(2,I.IExtensionGalleryService),Y(3,m.ILogService)],b),e.NativeLanguagePackService=b;let c=class extends A.Disposable{constructor(g,v){super(),this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new l.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(v=>{Object.keys(v).forEach(k=>delete v[k]),this.createLanguagePacksFromExtensions(v,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...v){for(const k of v)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,k);Object.keys(g).forEach(k=>this.updateHash(g[k]))}createLanguagePacksFromExtension(g,v){const k=v.identifier,i=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of i)if(v.location.scheme===_.Schemas.file&&d(o)){let n=g[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},g[o.languageId]=n);const t=n.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,k))[0];t?t.version=v.manifest.version:n.extensions.push({extensionIdentifier:k,version:v.manifest.version});for(const r of o.translations)n.translations[r.id]=(0,R.join)(v.location.fsPath,r.path)}}updateHash(g){if(g){const v=(0,L.createHash)("md5");for(const k of g.extensions)v.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);g.hash=v.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(v=g(k),k)).then(k=>{for(const o of Object.keys(k))k[o]||delete k[o];this.languagePacks=k,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),P.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>v,k=>this.logService.error(k))})}};c=ve([Y(0,y.INativeEnvironmentService),Y(1,m.ILogService)],c);function d(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const g of u.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[242],ae([0,1,10,32,46]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",_="https://0.0.0.0/ping";async function R(y,I,E){const m=await new Promise((d,u)=>{ie(["@microsoft/1ds-core-js"],d,u)}),f=await new Promise((d,u)=>{ie(["@microsoft/1ds-post-js"],d,u)}),p=new m.AppInsightsCore,b=new f.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(E){c.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:E};c.extensionConfig[b.identifier]=d}return p.initialize(c,[]),p.addTelemetryInitializer(d=>{I&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),p}class P{constructor(I,E,m,f,p){this._isInternalTelemetry=I,this._eventPrefix=E,this._defaultData=m,this._xhrOverride=p,this.endPointUrl=A,this.endPointHealthUrl=_,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=R(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{I(E)},E=>{(0,L.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this._aiCoreOrKey)return;E=(0,O.mixin)(E,this._defaultData),E=(0,l.validateTelemetryData)(E);const m=this._eventPrefix+"/"+I;try{this._withAIClient(f=>{f.pluginVersionString=E?.properties.version??"Unknown",f.track({name:m,baseData:{name:m,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[115],ae([0,1,2,178,15,9,26,46]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends L.Disposable{constructor(I,E,m,f,p=""){super(),this.prefix=p;const b=E.getLogger(R.telemetryLogId);if(b)this.logger=this._register(b);else{const d=(0,R.isLoggingOnly)(f,m)?" (Not Sent)":"",u=()=>(0,R.supportsTelemetry)(f,m)&&I.getLevel()===A.LogLevel.Trace;this.logger=this._register(E.createLogger(R.telemetryLogId,{name:(0,O.localize)(0,null,d),hidden:!u()})),this._register(I.onDidChangeLogLevel(()=>E.setVisibility(R.telemetryLogId,u()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,E){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,R.validateTelemetryData)(E))}};P=ve([Y(0,A.ILogService),Y(1,A.ILoggerService),Y(2,l.IEnvironmentService),Y(3,_.IProductService)],P),e.TelemetryLogAppender=P}),define(oe[116],ae([0,1,2,32,4,27,179,17,45,108,26,40,19,46]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(d,u,g){this._configurationService=u,this._productService=g,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(v=>{(v.affectsConfiguration(m.TELEMETRY_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,u){this._experimentProperties[d]=u}_updateTelemetryLevel(){let d=(0,f.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const g=u.usage?3:u.error?2:0;d=Math.min(d,g)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,u,g){this._telemetryLevel<u||(g=(0,O.mixin)(g,this._experimentProperties),g=(0,f.cleanData)(g,this._cleanupPatterns),g=(0,O.mixin)(g,this._commonProperties),this._appenders.forEach(v=>v.log(d,g)))}publicLog(d,u){this._log(d,3,u)}publicLog2(d,u){this.publicLog(d,u)}publicLogError(d,u){!this._sendErrorTelemetry||this._log(d,2,u)}publicLogError2(d,u){this.publicLogError(d,u)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ve([Y(1,R.IConfigurationService),Y(2,I.IProductService)],p),e.TelemetryService=p;function b(){const c=(0,_.localize)(0,null,y.default.nameLong),d=y.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=l.isWeb?"":(0,_.localize)(3,null),g=(0,_.localize)(4,null),v=(0,_.localize)(5,null),k=(0,_.localize)(6,null),i=(0,_.localize)(7,null),o=`
|       | ${g} | ${v} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,_.localize)(8,null);return`
${c} ${d} ${u}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:b(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,_.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,_.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[243],ae([0,1,295,242]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends O.AbstractOneDataSystemAppender{constructor(_,R,P,y){const I={sendPOST:(E,m)=>{const f={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const p=L.request(E.urlString,f,b=>{b.on("data",function(c){m(b.statusCode??200,b.headers,c.toString())}),b.on("error",function(c){m(0,{})})});p.write(E.data),p.end()}catch{m(0,{})}}};super(_,R,P,y,I)}}e.OneDataSystemAppender=l}),define(oe[244],ae([0,1,22,65,17,15,9,26,19,114,115,116]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(p,b,c,d,u,g){this.configurationService=p,this.telemetryService=b,this.logService=c,this.loggerService=d,this.environmentService=u,this.productService=g,this.customTelemetryServices=new Map}getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.telemetryService.machineId,b["common.vscodesessionid"]=this.telemetryService.sessionId;const c=[p.id,JSON.stringify(b),p.aiKey],u=new O.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),g=[new y.TelemetryAppenderClient(u),new I.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new E.TelemetryService({appenders:g,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(p.id)}publicLog(p,b,c){this.getCustomTelemetryService(p).publicLog(b,c)}publicLogError(p,b,c){this.getCustomTelemetryService(p).publicLogError(b,c)}};m=ve([Y(0,l.IConfigurationService),Y(1,P.ITelemetryService),Y(2,_.ILogService),Y(3,_.ILoggerService),Y(4,A.IEnvironmentService),Y(5,R.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(oe[117],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(oe[245],ae([0,1,4,117]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(P){this.collections=P,this.map=new Map,P.forEach((y,I)=>{const E=y.map.entries();let m=E.next();for(;!m.done;){const f=m.value[0];let p=this.map.get(f);if(p||(p=[],this.map.set(f,p)),p.length>0&&p[0].type===O.EnvironmentVariableMutatorType.Replace){m=E.next();continue}const b=m.value[1];p.unshift({extensionIdentifier:I,value:b.value,type:b.type}),m=E.next()}})}async applyToProcessEnvironment(P,y){let I;L.isWindows&&(I={},Object.keys(P).forEach(E=>I[E.toLowerCase()]=E));for(const[E,m]of this.map){const f=L.isWindows&&I[E.toLowerCase()]||E;for(const p of m){const b=y?await y(p.value):p.value;switch(p.type){case O.EnvironmentVariableMutatorType.Append:P[f]=(P[f]||"")+b;break;case O.EnvironmentVariableMutatorType.Prepend:P[f]=b+(P[f]||"");break;case O.EnvironmentVariableMutatorType.Replace:P[f]=b;break}}}}diff(P){const y=new Map,I=new Map,E=new Map;if(P.map.forEach((m,f)=>{const p=this.map.get(f),b=A(m,p);b&&y.set(f,b)}),this.map.forEach((m,f)=>{const p=P.map.get(f),b=A(m,p);b&&E.set(f,b)}),this.map.forEach((m,f)=>{const p=P.map.get(f),b=_(m,p);b&&I.set(f,b)}),!(y.size===0&&I.size===0&&E.size===0))return{added:y,changed:I,removed:E}}}e.MergedEnvironmentVariableCollection=l;function A(R,P){if(!P)return R;const y=new Set;P.forEach(E=>y.add(E.extensionIdentifier));const I=[];return R.forEach(E=>{y.has(E.extensionIdentifier)||I.push(E)}),I.length===0?void 0:I}function _(R,P){if(!P)return;const y=new Map;P.forEach(E=>y.set(E.extensionIdentifier,E));const I=[];return R.forEach(E=>{const m=y.get(E.extensionIdentifier);m&&(E.type!==m.type||E.value!==m.value)&&I.push(m)}),I.length===0?void 0:I}}),define(oe[246],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=L;function O(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=O;function l(_){return Array.from(_.entries()).map(R=>[R[0],L(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function A(_){return new Map(_.map(R=>[R[0],{map:O(R[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(oe[247],ae([0,1,6,25,3,2,9]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(y,I){super(),this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new l.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=y===void 0?15e3:y}createRequest(y){return new Promise((I,E)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,I),this._onCreateRequest.fire({requestId:m,...y});const f=new O.CancellationTokenSource;(0,L.timeout)(this._timeout,f.token).then(()=>E(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,A.toDisposable)(()=>f.cancel())])})}acceptReply(y,I){const E=this._pendingRequests.get(y);E?(this._pendingRequests.delete(y),(0,A.dispose)(this._pendingRequestDisposables.get(y)||[]),this._pendingRequestDisposables.delete(y),E(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};R=ve([Y(1,_.ILogService)],R),e.RequestStore=R}),define(oe[118],ae([0,1,5,69]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new O.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(l=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var A;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(A=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(_=e.PosixShellType||(e.PosixShellType={}));var R;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var y;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Logger="logger",g.Heartbeat="heartbeat"})(y=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var I;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var f;(function(g){g.TerminalView="view",g.Editor="editor"})(f=e.TerminalLocationString||(e.TerminalLocationString={}));var p;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var b;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(b=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}));var d;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var u;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(u=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[248],ae([0,1,52,12,181,135]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(m,f){const p=[{name:null,description:(0,l.localize)(0,null)}];return p.push(...m.map(b=>({name:b.profileName,description:R(b)}))),f&&p.push(...f.map(b=>({name:b.title,description:P(b)}))),{values:p.map(b=>b.name),markdownDescriptions:p.map(b=>b.description)}}e.createProfileSchemaEnums=_;function R(m){let f=`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?f+=`
- args: "${m.args}"`:f+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(f+=`
- overrideName: ${m.overrideName}`),m.color&&(f+=`
- color: ${m.color}`),m.env&&(f+=`
- env: ${JSON.stringify(m.env)}`),f}function P(m){return`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function y(m,f){if(!m&&!f)return!0;if(typeof m=="string"&&typeof f=="string")return m===f;if(Array.isArray(m)&&Array.isArray(f)){if(m.length!==f.length)return!1;for(let p=0;p<m.length;p++)if(m[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function I(m,f){if(!m&&!f)return!0;if(!m||!f)return!1;if(A.ThemeIcon.isThemeIcon(m)&&A.ThemeIcon.isThemeIcon(f))return m.id===f.id&&m.color===f.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof f=="object"&&"light"in f&&"dark"in f){const p=m,b=f;if((O.URI.isUri(p.light)||E(p.light))&&(O.URI.isUri(p.dark)||E(p.dark))&&(O.URI.isUri(b.light)||E(b.light))&&(O.URI.isUri(b.dark)||E(b.dark)))return p.light.path===b.light.path&&p.dark.path===b.dark.path}if(O.URI.isUri(m)&&O.URI.isUri(f)||E(m)||E(f)){const p=m,b=f;return p.path===b.path&&p.scheme===b.scheme}return!1}e.terminalIconsEqual=I;function E(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=E}),define(oe[249],ae([0,1,52,180,45,40,248]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),v=>`$(${v.id})`)};const R={args:{description:(0,O.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,O.localize)(1,null),type:"boolean"},icon:{description:(0,O.localize)(2,null),...e.terminalIconSchema},color:{description:(0,O.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,O.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},y={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,O.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,O.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,O.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,O.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,O.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,O.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,O.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,O.localize)(26,null)}},{type:"string",markdownDescription:(0,O.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,O.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(30,null),type:"string"},id:{description:(0,O.localize)(31,null),type:"string"},title:{description:(0,O.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(34,null),type:"string"},id:{description:(0,O.localize)(35,null),type:"string"},title:{description:(0,O.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(38,null),type:"string"},id:{description:(0,O.localize)(39,null),type:"string"},title:{description:(0,O.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,O.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,O.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,O.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,O.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,O.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){A.Registry.as(l.Extensions.Configuration).registerConfiguration(c),g()}e.registerTerminalPlatformConfiguration=d;let u;function g(v,k){const i=A.Registry.as(l.Extensions.Configuration);let o;v&&(o=(0,_.createProfileSchemaEnums)(v?.profiles,k));const n=u;u={id:"terminal",order:100,title:(0,O.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?o?.values:void 0,markdownEnumDescriptions:v?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?o?.values:void 0,markdownEnumDescriptions:v?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?o?.values:void 0,markdownEnumDescriptions:v?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[u],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(oe[250],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(oe[251],ae([0,1,34,22,32,14,4,36,27,11,28,117,246,245]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let r=0;return t&&t.length===4&&(r=parseInt(t[3])),r}e.getWindowsBuildNumber=p;async function b(t,r,s,a=R.env,h=I.Promises.exists){if(A.isAbsolute(t))return await h(t)?t:void 0;if(r===void 0&&(r=R.cwd()),A.dirname(t)!=="."){const T=A.join(r,t);return await h(T)?T:void 0}const S=(0,l.getCaseInsensitive)(a,"PATH");if(s===void 0&&(0,y.isString)(S)&&(s=S.split(A.delimiter)),s===void 0||s.length===0){const T=A.join(r,t);return await h(T)?T:void 0}for(const T of s){let M;if(A.isAbsolute(T)?M=A.join(T,t):M=A.join(r,T,t),await h(M))return M;if(_.isWindows){let x=M+".com";if(await h(x)||(x=M+".exe",await h(x)))return x}}const D=A.join(r,t);return await h(D)?D:void 0}e.findExecutable=b;function c(t,r,s,a,h){const w=_.isWindows&&(!r.windowsEnableConpty||p()<18309);if(!r.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||w)return;const S=t.args,D=R.platform==="win32"?A.basename(t.executable).toLowerCase():A.basename(t.executable),T=A.dirname(O.FileAccess.asFileUri("").fsPath);let M;const x={VSCODE_INJECTION:"1"};if(_.isWindows){if(D==="pwsh.exe"||D==="powershell.exe")return!S||o(S)?M=g.get(u.WindowsPwsh):i(S)&&(M=g.get(u.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,P.format)(M[M.length-1],T,""),r.shellIntegration.suggestEnabled&&(x.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:x}):void 0;a.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(D){case"bash":return!S||S.length===0?M=g.get(u.Bash):n(S)&&(x.VSCODE_SHELL_LOGIN="1",d(r,x),M=g.get(u.Bash)),M?(M=[...M],M[M.length-1]=(0,P.format)(M[M.length-1],T),{newArgs:M,envMixin:x}):void 0;case"fish":{const V=s?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",q=A.join(T,"out/vs/workbench/contrib/xdg_data");return x.XDG_DATA_DIRS=`${V}:${q}`,d(r,x),{newArgs:void 0,envMixin:x}}case"pwsh":return!S||o(S)?M=g.get(u.Pwsh):i(S)&&(M=g.get(u.PwshLogin)),M?(r.shellIntegration.suggestEnabled&&(x.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,P.format)(M[M.length-1],T,""),{newArgs:M,envMixin:x}):void 0;case"zsh":{if(!S||S.length===0?M=g.get(u.Zsh):n(S)?(M=g.get(u.ZshLogin),d(r,x)):(S===g.get(u.Zsh)||S===g.get(u.ZshLogin))&&(M=S),!M)return;M=[...M],M[M.length-1]=(0,P.format)(M[M.length-1],T);let V;try{V=L.userInfo().username}catch{V="unknown"}const q=A.join(L.tmpdir(),`${V}-${h.applicationName}-zsh`);x.ZDOTDIR=q;const z=s?.ZDOTDIR??L.homedir()??"~";x.USER_ZDOTDIR=z;const J=[];return J.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(q,".zshrc")}),J.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(q,".zprofile")}),J.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(q,".zshenv")}),J.push({source:A.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(q,".zlogin")}),{newArgs:M,envMixin:x,filesToCopy:J}}}a.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.getShellIntegrationInjection=c;function d(t,r){if(_.isMacintosh&&t.environmentVariableCollections){const s=(0,m.deserializeEnvironmentVariableCollections)(t.environmentVariableCollections),h=new f.MergedEnvironmentVariableCollection(s).map.get("PATH"),w=[];if(h)for(const S of h)S.type===E.EnvironmentVariableMutatorType.Prepend&&w.push(S.value);w.length>0&&(r.VSCODE_PATH_PREFIX=w.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const g=new Map;g.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(u.Zsh,["-i"]),g.set(u.ZshLogin,["-il"]),g.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],k=["-nol","-nologo"];function i(t){return typeof t=="string"?v.includes(t.toLowerCase()):t.length===1&&v.includes(t[0].toLowerCase())||t.length===2&&(v.includes(t[0].toLowerCase())||v.includes(t[1].toLowerCase()))&&(k.includes(t[0].toLowerCase())||k.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?k.includes(t.toLowerCase()):t.length===0||t?.length===1&&k.includes(t[0].toLowerCase())}function n(t){return t==="string"&&v.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&v.includes(t[0].toLowerCase())}}),define(oe[252],ae([0,1,49,52,14,4,11,28,94,251,196]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,m=!0;function f(t,r,s,a,h=process.env,w,S,D,T){return w=w||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},A.isWindows?p(s,w,h,S,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),T,D):i(w,S,s,t&&typeof t=="object"?{...t}:a.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,D,h)}e.detectAvailableProfiles=f;async function p(t,r,s,a,h,w,S,D,T){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let V=!1;(0,y.getWindowsBuildNumber)()>=16299&&(V=!0),await d(D);const q=new Map;if(t){q.set("PowerShell",{source:"PowerShell",icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),q.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:O.Codicon.terminalCmd,isAutoDetected:!0}),q.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),q.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.Codicon.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;q.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}o(w,q);const z=await b(q.entries(),S,r,s,a,T);if(t||h)try{const J=await v(`${x}\\${V?"wsl":"bash"}.exe`,S);for(const Q of J)(!w||!(Q.profileName in w))&&z.push(Q)}catch{m&&(a?.info("WSL is not installed, so could not detect WSL profiles"),m=!1)}return z}async function b(t,r,s,a=process.env,h,w){const S=[];for(const[D,T]of t){if(T===null)continue;let M,x,V;if("source"in T){const Q=E?.get(T.source);if(!Q)continue;M=Q.paths,x=T.args||Q.args,T.icon?V=c(T.icon):Q.icon&&(V=Q.icon)}else M=Array.isArray(T.path)?T.path:[T.path],x=A.isWindows||Array.isArray(T.args)?T.args:void 0,V=c(T.icon);let q;if(w){const Q=M.map(X=>typeof X=="string"?X:X.path),K=await w(Q);q=new Array(M.length);for(let X=0;X<M.length;X++)typeof M[X]=="string"?q[X]=K[X]:q[X]={path:K[X],isUnsafe:!0}}else q=M.slice();let z;if(T.requiresPath){let Q;if((0,_.isString)(T.requiresPath)?Q=T.requiresPath:(Q=T.requiresPath.path,T.requiresPath.isUnsafe&&(z=Q)),!await s.existsFile(Q))continue}const J=await n(D,r,q,s,a,x,T.env,T.overrideName,T.isAutoDetected,z);J?(J.isAutoDetected=T.isAutoDetected,J.icon=V,J.color=T.color,S.push(J)):h?.debug("Terminal profile not validated",D,M)}return h?.debug("Validated terminal profiles",S),S}function c(t){return typeof t=="string"?{id:t}:t}async function d(t){if(E&&!t)return;const[r,s]=await Promise.all([u(),t||g()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:s,icon:O.Codicon.terminalPowershell})}async function u(){const t=new Set,r=await(0,y.findExecutable)("git.exe");if(r){const h=(0,I.dirname)(r);t.add((0,I.resolve)(h,"../.."))}function s(h,w){w&&h.add(w)}s(t,process.env.ProgramW6432),s(t,process.env.ProgramFiles),s(t,process.env["ProgramFiles(X86)"]),s(t,`${process.env.LocalAppData}\\Program`);const a=[];for(const h of t)a.push(`${h}\\Git\\bin\\bash.exe`,`${h}\\Git\\usr\\bin\\bash.exe`,`${h}\\usr\\bin\\bash.exe`);return a.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),a}async function g(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function v(t,r){const s=[],a=await new Promise((S,D)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,M)=>{if(T)return D("Problem occurred when getting wsl distros");S(M)})});if(!a)return[];const h=new RegExp(/[\r?\n]/),w=a.split(h).filter(S=>S.trim().length>0&&S!=="");for(const S of w){if(S===""||S.startsWith("docker-desktop"))continue;const D=`${S} (WSL)`,T={profileName:D,path:t,args:["-d",`${S}`],isDefault:D===r,icon:k(S),isAutoDetected:!1};s.push(T)}return s}function k(t){return t.includes("Ubuntu")?O.Codicon.terminalUbuntu:t.includes("Debian")?O.Codicon.terminalDebian:O.Codicon.terminalLinux}async function i(t,r,s,a,h,w,S,D){const T=new Map;if(s){const M=(await t.readFile("/etc/shells")).toString(),x=w||M.split(`
`).filter(q=>q.trim().includes("#")&&q.trim().length>0),V=new Map;for(const q of x){let z=(0,l.basename)(q),J=V.get(z)||0;J++,J>1&&(z=`${z} (${J})`),V.set(z,J),T.set(z,{path:q,isAutoDetected:!0})}}return o(a,T),await b(T.entries(),h,t,D,r,S)}function o(t,r){if(!!t)for(const[s,a]of Object.entries(t))a===null||typeof a!="object"||!("path"in a)&&!("source"in a)?r.delete(s):(a.icon=a.icon||r.get(s)?.icon,r.set(s,a))}async function n(t,r,s,a,h,w,S,D,T,M){if(s.length===0)return Promise.resolve(void 0);const x=s.shift();if(x==="")return n(t,r,s,a,h,w,S,D,T);const V=typeof x!="string"&&x.isUnsafe,q=typeof x=="string"?x:x.path,z={profileName:t,path:q,args:w,env:S,overrideName:D,isAutoDetected:T,isDefault:t===r,isUnsafePath:V,requiresUnsafePath:M};if((0,l.basename)(q)===q){const Q=h.PATH?h.PATH.split(l.delimiter):void 0,K=await(0,y.findExecutable)(q,void 0,Q,void 0,a.existsFile);return K?(z.path=K,z.isFromPath=!0,z):n(t,r,s,a,h,w)}return await a.existsFile((0,l.normalize)(q))?z:n(t,r,s,a,h,w,S,D,T)}}),define(oe[253],ae([0,1,3,2,22,4,39,65,17,15,98,233,9,247,118,249,252,107]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(k){k[k.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let g=0,v=class extends O.Disposable{constructor(i,o,n,t,r,s){super(),this._reconnectConstants=i,this.isRemote=o,this._configurationService=n,this._environmentService=t,this._logService=r,this._loggerService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,O.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_PTY_REMOTE:this.isRemote,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,I.parsePtyHostDebugPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const n=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this._onPtyHostStart.fire(),_.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(s=>{this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=u.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))})),this._register(new d.RemoteLoggerChannelClient(this._loggerService,n.getChannel(p.TerminalIpcChannels.Logger)));const r=_.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(r.onProcessData(s=>this._onProcessData.fire(s))),this._register(r.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(r.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(r.onDidChangeProperty(s=>this._onDidChangeProperty.fire(s))),this._register(r.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(r.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(r.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[n,r]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,o,n,t,r,s,a,h,w,S,D){const T=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(i,o,n,t,r,s,a,h,w,S,D);return clearTimeout(T),g=Math.max(g,M),M}updateTitle(i,o,n){return this._proxy.updateTitle(i,o,n)}updateIcon(i,o,n,t){return this._proxy.updateIcon(i,o,n,t)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,o){return this._proxy.detachFromProcess(i,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,o){return this._proxy.shutdown(i,o)}input(i,o){return this._proxy.input(i,o)}processBinary(i,o){return this._proxy.processBinary(i,o)}resize(i,o,n){return this._proxy.resize(i,o,n)}acknowledgeDataEvent(i,o){return this._proxy.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this._proxy.setUnicodeVersion(i,o)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,o){return this._proxy.installAutoReply(i,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,o,n,t=!1){const r=await this._shellEnv;return(0,c.detectAvailableProfiles)(o,n,t,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i,o){return this._proxy.getWslPath(i,o)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this._proxy.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this._proxy.acceptDetachInstanceReply(i,o)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this._proxy.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this._proxy.refreshProperty(i,o)}async updateProperty(i,o,n){return this._proxy.updateProperty(i,o,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this._resolveVariablesRequestStore.acceptReply(i,o)}};v=ve([Y(2,P.IConfigurationService),Y(3,y.IEnvironmentService),Y(4,m.ILogService),Y(5,m.ILoggerService)],v),e.PtyHostService=v}),define(oe[76],ae([0,1,3,17,5,9]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var _;(function(b){b.Http="http",b.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=E;function m(b,c,d,u){if(d===1)return!1;if(d===2&&E(c)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(g?.length===4&&parseInt(g[1])>=18)return!1}return b<1024}e.isPortPrivileged=m;class f{constructor(c,d,u){this.remoteAddress=c,this.localAddress=d,this._dispose=u,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let p=class{constructor(c,d){this.logService=c,this.configurationService=d,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],d=Array.from(this._tunnels.values());for(const u of d){const g=Array.from(u.values());for(const v of g){const k=await v.value;k&&c.push(k)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:d}of c.values())await d.then(u=>u?.dispose());c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,d,u,g,v){this.addTunnelToMap(c,d,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:d,localAddress:u,privacy:g,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,d){(E(c)||I(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(c,d);if(u)return++u.refcount,u.value}openTunnel(c,d,u,g,v,k=!1,i,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${u} on local port ${v}.`),!c)return;if(d||(d="localhost"),g||(g=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(c,d,u,g,v,k,i,o);return n?n.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==d||t.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const d=this._tunnels.get(c.tunnelRemoteHost);if(d){const u=d.get(c.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,u))}}}}async tryDisposeTunnel(c,d,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${d}.`);const g=u.value.then(async v=>{v&&(await v.dispose(!0),this._onTunnelClosed.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(d),g}}async closeTunnel(c,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${d} `);const u=this._tunnels.get(c);if(u&&u.has(d)){const g=u.get(d);g.refcount=0,await this.tryDisposeTunnel(c,d,g)}}addTunnelToMap(c,d,u){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(d,{refcount:1,value:u})}async removeEmptyTunnelFromMap(c,d){const u=this._tunnels.get(c);u&&(await u.get(d)||u.delete(d),u.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,d){const u=[c];I(c)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):E(c)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const g=u.map(v=>this._tunnels.get(v));for(const v of g){const k=v?.get(d);if(k)return k}}canTunnel(c){return!!y(c)}createWithProvider(c,d,u,g,v,k,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${u} on local port ${g}.`);const o=u;this._factoryInProgress.add(o);const n=g===void 0?u:g,t={elevationRequired:v?this.isPortPrivileged(n):!1},r={remoteAddress:{host:d,port:u},localAddressPort:g,privacy:k,public:k?k!==R.Private:void 0,protocol:i},s=c.forwardPort(r,t);return s?(this.addTunnelToMap(d,u,s),s.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),s}};p=ve([Y(0,A.ILogService),Y(1,O.IConfigurationService)],p),e.AbstractTunnelService=p}),define(oe[254],ae([0,1,9,76,2,10,6]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let P=class It extends l.Disposable{constructor(I,E){super(),this._tunnelService=I,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(I,E,m,f,p,b,c){const d=new R,u=await Promise.resolve(this._tunnelService.openTunnel(I,d,m,f,p,b,c));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${f} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),d.dispose(),await u.dispose(),(0,A.canceled)();return d.setTunnel(u),this._tunnels.set(E,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${u.localAddress} (local) to ${m}:${f} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(I,E){const m=this._tunnels.get(I);!m||m.setAddress(E)}async destroyTunnel(I){const E=this._tunnels.get(I);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await E.dispose();return}this._disposedTunnels.add(I)}};P._lastId=0,P=ve([Y(0,O.ISharedTunnelsService),Y(1,L.ILogService)],P),e.SharedProcessTunnelService=P}),define(oe[255],ae([0,1,86,34,137,227,6,2,17,9,26,225,76,112,4]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function b(v,k,i,o,n){let t;for(let r=3;r&&(t?.dispose(),t=await new c(v,k,i,o,n).waitForReady(),!(n&&l.BROWSER_RESTRICTED_PORTS[n]||!l.BROWSER_RESTRICTED_PORTS[t.tunnelLocalPort]));r--);return t}class c extends R.Disposable{constructor(k,i,o,n,t){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=t,this.privacy=m.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=k,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){const k=this.suggestedLocalPort??this.tunnelRemotePort,i=(0,m.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,l.findFreePortFaster)(k,2,1e3,i),n=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(k){k.pause();const i=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,E.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),n=o.getSocket().socket,t=o.readEntireBuffer();o.dispose(),t.byteLength>0&&k.write(t.buffer),k.on("end",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),n.end()}),k.on("close",()=>n.end()),k.on("error",()=>{k.localAddress&&this._socketsDispose.delete(k.localAddress),n.destroy()}),n.on("end",()=>k.end()),n.on("close",()=>k.end()),n.on("error",()=>{k.destroy()}),k.pipe(n),n.pipe(k),k.localAddress&&this._socketsDispose.set(k.localAddress,()=>{k.end(),n.end()})}}let d=class extends m.AbstractTunnelService{constructor(k,i,o,n,t){super(i,t),this.socketFactory=k,this.signService=o,this.productService=n}isPortPrivileged(k){return(0,m.isPortPrivileged)(k,this.defaultTunnelHost,p.OS,O.release())}retainOrCreateTunnel(k,i,o,n,t,r,s,a){const h=this.getTunnelFromMap(i,o);if(h)return++h.refcount,h.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,o,t,r,s,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${t}.`);const w={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:k,signService:this.signService,logService:this.logService,ipcLogger:null},S=b(w,n,i,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,o,S),S}}};d=ve([Y(1,y.ILogService),Y(2,f.ISignService),Y(3,I.IProductService),Y(4,P.IConfigurationService)],d),e.BaseTunnelService=d;let u=class extends d{constructor(k,i,o,n){super(A.nodeSocketFactory,k,i,o,n)}};u=ve([Y(0,y.ILogService),Y(1,f.ISignService),Y(2,I.IProductService),Y(3,P.IConfigurationService)],u),e.TunnelService=u;let g=class extends R.Disposable{constructor(k,i,o,n){super(),this.logService=k,this.productService=i,this.signService=o,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(k,i,o,n,t,r,s,a,h){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${r}.`),!this._tunnelServices.has(k)){const w=new u(this.logService,this.signService,this.productService,this.configurationService);this._register(w),this._tunnelServices.set(k,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this._tunnelServices.delete(k))})}return this._tunnelServices.get(k).openTunnel(i,o,n,t,r,s,a,h)}};g=ve([Y(0,y.ILogService),Y(1,I.IProductService),Y(2,f.ISignService),Y(3,P.IConfigurationService)],g),e.SharedTunnelsService=g}),define(oe[30],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(oe[256],ae([0,1,30,199,13,23,133,3,2]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{constructor(m){this.uri=m,this.time=y._clock++}touch(){return this.time=y._clock++,this}}y._clock=0;let I=class{constructor(m){this._fileService=m,this._dispooables=new P.DisposableStore,this._limit=2**16;const f=new Map,p=b=>{let c=f.get(b.scheme);return c===void 0&&(c=m.hasProvider(b)&&!this._fileService.hasCapability(b,1024),f.set(b.scheme,c)),c};this._dispooables.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new A.ExtUri(p),this._canonicalUris=new _.SkipList((b,c)=>this.extUri.compare(b,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,A.normalizePath)(m));const f=this._canonicalUris.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new y(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,b)=>p[1].time<b[1].time?1:p[1].time>b[1].time?-1:0);y._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let p=0;p<f;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};I=ve([Y(0,l.IFileService)],I),e.UriIdentityService=I,(0,O.registerSingleton)(L.IUriIdentityService,I,1)}),define(oe[257],ae([0,1,3,2,13,43,48,16]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends O.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,E,m,f){super(),this.fileSystemScheme=I,this.fileSystemProvider=E,this.userDataScheme=m,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}watch(I,E){this.watchResources.set(I,I);const m=this.fileSystemProvider.watch(this.toFileSystemResource(I),E);return(0,O.toDisposable)(()=>{this.watchResources.delete(I),m.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,E,m){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(E),m)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,E,m){const f=(0,A.newWriteableStream)(p=>R.VSBuffer.concat(p.map(b=>R.VSBuffer.wrap(b))).buffer);return(async()=>{try{const p=await this.readFile(I);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,E,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),E,m)}delete(I,E){return this.fileSystemProvider.delete(this.toFileSystemResource(I),E)}copy(I,E,m){if((0,l.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(E),m);throw new Error("copy not supported")}handleFileChanges(I){const E=[];for(const m of I){if(m.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(m.resource);this.watchResources.findSubstr(f)&&E.push({resource:f,type:m.type})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(oe[60],ae([0,1,83]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(_,R,P,y){const I=(0,L.setProperty)(_,R,P,y)[0];return I&&(_=_.substring(0,I.offset)+I.content+_.substring(I.offset+I.length)),_}e.edit=O;function l(_,R,P){let y=P;for(;y>=0;){if(_.charAt(y)===R.charAt(R.length-1)&&R.length===1)return y+1;if(y--,R.length===2&&y>=0&&_.charAt(y)===R.charAt(0))return y+2}return 0}e.getLineStartOffset=l;function A(_,R,P){let y=P;for(;y>=0;)if(_.charAt(y)===R.charAt(R.length-1)&&R.length===1||(y++,R.length===2&&y>=0&&_.charAt(y)===R.charAt(1)))return y;return _.length-1}e.getLineEndOffset=A}),define(oe[258],ae([0,1,32,55,11]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,p,b,c,d,u){const g=[],v=[],k=[];if(!p){const q=f.filter(({identifier:z})=>d.every(J=>J.toLowerCase()!==z.id.toLowerCase()));return{local:{added:g,removed:v,updated:k},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}f=f.map(E),p=p.map(E),b=b?b.map(E):null;const i=new Map,o=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};f.forEach(({identifier:q})=>o(q)),p.forEach(({identifier:q})=>o(q)),b?.forEach(({identifier:q})=>o(q));const n=q=>{const z=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${q.identifier.id.toLowerCase()}`},t=(q,z)=>(q.set(n(z),z),q),r=f.reduce(t,new Map),s=p.reduce(t,new Map),a=p.reduce((q,z)=>t(q,(0,L.deepClone)(z)),new Map),h=b?b.reduce(t,new Map):null,w=c.reduce(t,new Map),S=d.reduce((q,z)=>{const J=i.get(z.toLowerCase());return q.add(J?`uuid:${J}`:`id:${z.toLowerCase()}`)},new Set),D=u?u.reduce((q,{id:z,uuid:J})=>(J=J??i.get(z.toLowerCase()),q.add(J?`uuid:${J}`:`id:${z.toLowerCase()}`)),new Set):null,T=_(r,s,S,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const q=_(h,r,S,!1),z=_(h,s,S,!0),J=(Q,K,X,j)=>{let F,ee,ne;return K.installed?(F=j.pinned,ne=j.preRelease,F&&(ee=j.version)):(F=X.pinned,ne=X.preRelease,F&&(ee=X.version)),F===void 0&&(F=K.pinned,F&&(ee=K.version)),ne===void 0&&(ne=K.preRelease),{...j,installed:K.installed||X.installed,pinned:F,preRelease:ne,version:ee??(X.version&&(!K.installed||O.gt(X.version,K.version))?X.version:K.version),state:P(K,X,h?.get(Q))}};for(const Q of z.removed.values()){const K=r.get(Q);if(!K)continue;const X=(0,l.assertIsDefined)(h?.get(Q)),j=D&&!D.has(Q)&&X.installed;K.installed&&j?v.push(K.identifier):a.set(Q,K)}for(const Q of z.added.values()){const K=(0,l.assertIsDefined)(s.get(Q)),X=r.get(Q);if(X){if(T.updated.has(Q)){const j=J(Q,X,K,K);R(X,K,!1,!1)||k.push(m(j,Q)),a.set(Q,j)}}else K.installed&&g.push(m(K,Q))}for(const Q of z.updated.values()){const K=(0,l.assertIsDefined)(s.get(Q)),X=(0,l.assertIsDefined)(h?.get(Q)),j=r.get(Q);if(j)if(D&&!D.has(Q)&&X.installed&&j.installed&&!K.installed)v.push(j.identifier);else{const ee=J(Q,j,K,K);k.push(m(ee,Q)),a.set(Q,ee)}else K.installed&&g.push(m(K,Q))}for(const Q of q.added.values())z.added.has(Q)||a.set(Q,(0,l.assertIsDefined)(r.get(Q)));for(const Q of q.updated.values()){if(z.removed.has(Q)||z.updated.has(Q))continue;const K=(0,l.assertIsDefined)(r.get(Q)),X=(0,l.assertIsDefined)(s.get(Q));a.set(Q,J(Q,K,X,K))}for(const Q of q.removed.values())z.updated.has(Q)||z.removed.has(Q)||w.has(Q)||!(0,l.assertIsDefined)(s.get(Q)).installed||!D||D.has(Q)||!(0,l.assertIsDefined)(h?.get(Q)).installed||a.delete(Q)}const M=[],x=_(s,a,new Set,!0),V=x.added.size>0||x.updated.size>0||x.removed.size>0;return V&&a.forEach((q,z)=>M.push(m(q,z))),{local:{added:g,removed:v,updated:k},remote:V?{added:[...x.added].map(q=>a.get(q)),updated:[...x.updated].map(q=>a.get(q)),removed:[...x.removed].map(q=>s.get(q)),all:M}:null}}e.merge=A;function _(f,p,b,c){const d=f?[...f.keys()].filter(i=>!b.has(i)):[],u=[...p.keys()].filter(i=>!b.has(i)),g=u.filter(i=>d.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),v=d.filter(i=>u.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),k=new Set;for(const i of d){if(v.has(i))continue;const o=f.get(i),n=p.get(i);(!n||!R(o,n,c,!0))&&k.add(i)}return{added:g,removed:v,updated:k}}function R(f,p,b,c){return!(f.disabled!==p.disabled||c&&f.installed!==p.installed||f.installed&&p.installed&&(f.preRelease!==p.preRelease||f.pinned!==p.pinned||p.pinned&&f.version!==p.version)||!I(f.state,p.state)||b&&f.version!==p.version)}function P(f,p,b){const c=f.state,d=p.state,u=b?.state;if(!p.version||c&&O.gt(f.version,p.version))return c;if(d&&O.gt(p.version,f.version)||!c)return d;if(!d)return c;const g=(0,L.deepClone)(c),v=u?y(u,d):{added:Object.keys(d).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},k=u?y(u,c):{added:Object.keys(c).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...v.added.values(),...v.updated.values()])g[i]=d[i];for(const i of v.removed.values())k.updated.has(i)||delete g[i];return g}function y(f,p){const b=Object.keys(f),c=Object.keys(p),d=c.filter(v=>b.indexOf(v)===-1).reduce((v,k)=>(v.add(k),v),new Set),u=b.filter(v=>c.indexOf(v)===-1).reduce((v,k)=>(v.add(k),v),new Set),g=new Set;for(const v of b){if(u.has(v))continue;const k=f[v],i=p[v];(0,L.equals)(k,i)||g.add(v)}return{added:d,removed:u,updated:g}}function I(f={},p={}){const{added:b,removed:c,updated:d}=y(f,p);return b.size===0&&c.size===0&&d.size===0}function E(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,p){const b={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(b.disabled=!0),f.installed&&(b.installed=!0),f.state&&(b.state=f.state),b}}),define(oe[119],ae([0,1,21,17,5]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==R&&I!==`-${R}`),P&&y.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,2)}updateSynchronizedExtensions(R,P){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==R&&I!==`-${R}`),P&&y.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,2)}getIgnoredExtensions(R){const P=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),y=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),I=[],E=[];if(Array.isArray(y))for(const m of y)m.startsWith("-")?E.push(m.substring(1)):I.push(m);return(0,L.distinct)([...P,...I].filter(m=>E.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};A=ve([Y(0,O.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[259],ae([0,1,21,35,32,69,60]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(v){return(0,O.parse)(v)||[]}async function P(v,k,i,o,n){const t=R(v),r=R(k),s=i?R(i):null,a=[...t,...r,...s||[]].map(J=>J.key),h=await n.resolveUserBindings(a),w=I(t,r,s,h);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const S=m(t),D=m(r),T=s?m(s):null,M=p(S,D,h),x=T?p(T,S,h):{added:[...S.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},V=T?p(T,D,h):{added:[...D.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},q=y(M,x,V);let z=v;for(const J of q.removed.values())q.conflicts.has(J)||(z=u(z,J,o));for(const J of q.added.values()){if(q.conflicts.has(J))continue;const Q=D.get(J);if(Q.some(K=>K.command!==`-${J}`&&w.conflicts.has(h[K.key]))){q.conflicts.add(J);continue}z=d(z,Q,o)}for(const J of q.updated.values()){if(q.conflicts.has(J))continue;const Q=D.get(J);if(Q.some(K=>K.command!==`-${J}`&&w.conflicts.has(h[K.key]))){q.conflicts.add(J);continue}z=g(z,J,Q,o)}return{mergeContent:z,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=P;function y(v,k,i){const o=new Set,n=new Set,t=new Set,r=new Set;for(const s of k.removed.values())i.updated.has(s)&&r.add(s);for(const s of i.removed.values())r.has(s)||(k.updated.has(s)?r.add(s):n.add(s));for(const s of k.added.values())r.has(s)||i.added.has(s)&&v.updated.has(s)&&r.add(s);for(const s of i.added.values())r.has(s)||(k.added.has(s)?v.updated.has(s)&&r.add(s):o.add(s));for(const s of k.updated.values())r.has(s)||i.updated.has(s)&&v.updated.has(s)&&r.add(s);for(const s of i.updated.values())r.has(s)||(k.updated.has(s)?v.updated.has(s)&&r.add(s):t.add(s));return{added:o,removed:n,updated:t,conflicts:r}}function I(v,k,i,o){const n=new Set,t=E(v,o),r=E(k,o),s=i?E(i,o):null,a=f(t,r);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=s?f(s,t):{added:[...t.keys()].reduce((x,V)=>(x.add(V),x),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=s?f(s,r):{added:[...r.keys()].reduce((x,V)=>(x.add(V),x),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:S,removed:D,updated:T,conflicts:M}=y(a,h,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:S,removed:D,updated:T,conflicts:M}}function E(v,k){const i=new Map;for(const o of v){const n=k[o.key];let t=i.get(n);t||(t=[],i.set(n,t)),t.push(o)}return i}function m(v){const k=new Map;for(const i of v){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=k.get(o);n||(n=[],k.set(o,n)),n.push(i)}return k}function f(v,k){const i=[...v.keys()],o=[...k.keys()],n=o.filter(s=>i.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),t=i.filter(s=>o.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),r=new Set;for(const s of i){if(t.has(s))continue;const a=v.get(s).map(w=>({...w,key:s})),h=k.get(s).map(w=>({...w,key:s}));(0,L.equals)(a,h,(w,S)=>c(w,S))||r.add(s)}return{added:n,removed:t,updated:r}}function p(v,k,i){const o=[...v.keys()],n=[...k.keys()],t=n.filter(a=>o.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),r=o.filter(a=>n.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),s=new Set;for(const a of o){if(r.has(a))continue;const h=v.get(a).map(S=>({...S,key:i[S.key]})),w=k.get(a).map(S=>({...S,key:i[S.key]}));b(h,w)||s.add(a)}return{added:t,removed:r,updated:s}}function b(v,k){return!(!(0,L.equals)(v.filter(({command:i})=>i[0]!=="-"),k.filter(({command:i})=>i[0]!=="-"),(i,o)=>c(i,o))||!(0,L.equals)(v.filter(({command:i})=>i[0]==="-"),k.filter(({command:i})=>i[0]==="-"),(i,o)=>c(i,o)))}function c(v,k){if(v.command!==k.command||v.key!==k.key)return!1;const i=A.ContextKeyExpr.deserialize(v.when),o=A.ContextKeyExpr.deserialize(k.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!l.equals(v.args,k.args))}function d(v,k,i){for(const o of k)v=_.edit(v,[-1],o,i);return v}function u(v,k,i){const o=R(v);for(let n=o.length-1;n>=0;n--)(o[n].command===k||o[n].command===`-${k}`)&&(v=_.edit(v,[n],void 0,i));return v}function g(v,k,i,o){const n=R(v),t=n.findIndex(r=>r.command===k||r.command===`-${k}`);for(let r=n.length-1;r>=0;r--)(n[r].command===k||n[r].command===`-${k}`)&&(v=_.edit(v,[r],void 0,o));for(let r=i.length-1;r>=0;r--)v=_.edit(v,[t],i[r],o);return v}}),define(oe[260],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(A,_,R){const P={},y={},I=new Set;if(!_)return{local:{added:P,updated:y,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=O(A,_);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:P,updated:y,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=O(R,A),f=O(R,_),p={},b={},c=new Set,d=new Set;for(const u of m.removed.values())f.updated.has(u)?P[u]=_[u]:c.add(u);for(const u of f.removed.values())d.has(u)||(m.updated.has(u)?d.add(u):I.add(u));for(const u of m.updated.values())d.has(u)||(f.updated.has(u)?E.updated.has(u)&&d.add(u):b[u]=A[u]);for(const u of f.updated.values())d.has(u)||(m.updated.has(u)?E.updated.has(u)&&d.add(u):A[u]!==void 0&&(y[u]=_[u]));for(const u of m.added.values())d.has(u)||(f.added.has(u)?E.updated.has(u)&&d.add(u):p[u]=A[u]);for(const u of f.added.values())d.has(u)||(m.added.has(u)?E.updated.has(u)&&d.add(u):P[u]=_[u]);return{local:{added:P,removed:[...I.values()],updated:y},remote:{added:p,removed:[...c.values()],updated:b},conflicts:[...d.values()]}}e.merge=L;function O(A,_){const R=A?Object.keys(A):[],P=_?Object.keys(_):[],y=P.filter(m=>R.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),I=R.filter(m=>P.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),E=new Set;for(const m of R){if(I.has(m))continue;const f=A[m],p=_[m];f!==p&&E.add(m)}return{added:y,removed:I,updated:E}}function l(A,_){const{added:R,removed:P,updated:y}=O(A,_);return R.size===0&&P.size===0&&y.size===0}e.areSame=l}),define(oe[261],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(l,A,_,R){const P={added:[],removed:[],updated:[]};let y={added:[],removed:[],updated:[]};if(!A){const E=l.filter(({id:m})=>!R.includes(m));return E.length?y.added=E:y=null,{local:P,remote:y}}const I=O(l,A,R);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const E=O(_,l,R),m=O(_,A,R);for(const f of m.removed){const p=l.find(b=>b.id===f);p&&P.removed.push(p)}for(const f of m.added){const p=A.find(b=>b.id===f);E.added.includes(f)?I.updated.includes(f)&&P.updated.push(p):P.added.push(p)}for(const f of m.updated)P.updated.push(A.find(p=>p.id===f));for(const f of E.added)m.added.includes(f)||y.added.push(l.find(p=>p.id===f));for(const f of E.updated)m.removed.includes(f)||m.updated.includes(f)||y.updated.push(l.find(p=>p.id===f));for(const f of E.removed){const p=A.find(b=>b.id===f);p&&y.removed.push(p)}}return y.added.length===0&&y.removed.length===0&&y.updated.length===0&&(y=null),{local:P,remote:y}}e.merge=L;function O(l,A,_){l=l?l.filter(({id:m})=>!_.includes(m)):[],A=A.filter(({id:m})=>!_.includes(m));const R=l.map(({id:m})=>m),P=A.map(({id:m})=>m),y=P.filter(m=>R.indexOf(m)===-1),I=R.filter(m=>P.indexOf(m)===-1),E=[];for(const{id:m,name:f,shortName:p}of l){if(I.includes(m))continue;const b=A.find(c=>c.id===m);(!b||b.name!==f||b.shortName!==p)&&E.push(m)}return{added:y,removed:I,updated:E}}}),define(oe[24],ae([0,1,21,11,187,45,29,5,109,40]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const r=y.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(s=>!!r[s].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function E(){const r=y.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(r).filter(w=>!!r[w].ignoreSync),a=Object.keys(r).filter(w=>r[w].scope===2||r[w].scope===6),h=I();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...s,...a,...h])}e.getDefaultIgnoredSettings=E,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const r="vscode://schemas/ignoredSettings",s=y.Registry.as(A.Extensions.Configuration);s.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=y.Registry.as(P.Extensions.JSONContribution),h=()=>{const w=I(),S=E().filter(x=>x!==e.CONFIGURATION_SYNC_STORE_KEY),D=Object.keys(A.allSettings.properties).filter(x=>S.indexOf(x)===-1),T=S.filter(x=>w.indexOf(x)===-1),M={items:{type:"string",enum:[...D,...T.map(x=>`-${x}`)]}};a.registerSchema(r,M)};return s.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=m;function f(r){return r&&(0,O.isObject)(r)&&(0,O.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=f;var p;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(r,...s){return r?[r,...s]:s}e.getPathSegments=b;function c(r,s,a,h){return h.joinPath(a.userDataSyncHome,...b(r,s,`lastSync${s}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(r){const s={};return s[e.HEADER_EXECUTION_ID]=r,s}e.createSyncHeaders=d;var u;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(u=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(s,a,h,w){super(s),this.code=a,this.resource=h,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class v extends g{constructor(s,a,h,w,S){super(s,h,void 0,S),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=v;class k extends g{constructor(s,a){super(s,a)}}e.UserDataAutoSyncError=k,function(r){function s(a){if(a instanceof r)return a;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(h&&h[1]){const w=h[2]==="unknown"?void 0:h[2],S=h[3]==="unknown"?void 0:h[3];return new r(a.message,h[1],w,S)}return new r(a.message,"Unknown")}r.toUserDataSyncError=s}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var n;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(r){return`sync.enable.${r}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[262],ae([0,1,32,24]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(_,R,P,y,I){if(!R)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const E=A(_,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?A(P,R):{added:Object.keys(R).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},f=P?A(P,_):{added:Object.keys(_).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},b=L.deepClone(R),c=!P;for(const u of f.added.values())u!==O.SYNC_SERVICE_URL_TYPE&&c&&m.added.has(u)||(b[u]=_[u]);for(const u of f.updated.values())b[u]=_[u];for(const u of f.removed.values())y.unregistered.includes(u)||delete b[u];for(const u of m.added.values()){const g=R[u];if(y.machine.includes(u)){I.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(P&&f.added.has(u))continue;const v=_[u];v&&v.value===g.value||u===O.SYNC_SERVICE_URL_TYPE&&c&&f.added.has(u)||(v?p.updated[u]=g:p.added[u]=g)}for(const u of m.updated.values()){const g=R[u];if(y.machine.includes(u)){I.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(u)||f.removed.has(u))continue;const v=_[u];v&&v.value===g.value||(p.updated[u]=g)}for(const u of m.removed.values()){if(y.machine.includes(u)){I.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}f.updated.has(u)||f.removed.has(u)||p.removed.push(u)}const d=A(R,b);return{local:p,remote:{added:[...d.added],updated:[...d.updated],removed:[...d.removed],all:d.added.size===0&&d.removed.size===0&&d.updated.size===0?null:b}}}e.merge=l;function A(_,R){const P=Object.keys(_),y=Object.keys(R),I=y.filter(f=>P.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=P.filter(f=>y.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),m=new Set;for(const f of P){if(E.has(f))continue;const p=_[f],b=R[f];L.equals(p,b)||m.add(f)}return{added:I,removed:E,updated:m}}}),define(oe[263],ae([0,1,21,35,83,42,32,60,24]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function y(a,h,w){let S=[];w?S=E(w):S=I(h);const D=[],T=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const M of S)M.startsWith("-")?T.push(M.substring(1)):D.push(M);return(0,L.distinct)([...a,...D].filter(M=>T.indexOf(M)===-1))}e.getIgnoredSettings=y;function I(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const h=(0,O.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(a,h){const w=(0,O.parse)(a)||{};let S="{}";for(const D of Object.keys(w)){const T=(0,l.setProperty)(S,[D],w[D],h);S=(0,l.applyEdits)(S,T)}return S}e.removeComments=m;function f(a,h,w,S){if(w.length){const D=s(h),T=(0,O.parse)(h)||{},M=(0,O.parse)(a);if(!M)return a;const x=[];for(const V of w){const q=T[V],z=M[V];q===void 0?a=R.edit(a,[V],void 0,S):z!==void 0?a=R.edit(a,[V],q,S):x.push(i(V,D))}x.sort((V,q)=>V.startOffset-q.startOffset),x.forEach(V=>a=u(V.setting.key,h,a,S))}return a}e.updateIgnoredSettings=f;function p(a,h,w,S,D,T){const M=f(a,h,S,T),x=w!==M,V=w!==h;if(!x&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!V)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(V&&!x)return{conflictsSettings:[],localContent:f(h,a,S,T),remoteContent:null,hasConflicts:!1};if(w===null&&c(a)){const U=b(a,h,S)?null:f(h,a,S,T);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let q=a,z=h;const J=(0,O.parse)(a),Q=(0,O.parse)(h),K=w?(0,O.parse)(w):null,X=S.reduce((U,$)=>(U.add($),U),new Set),j=d(J,Q,X),F=d(K,J,X),ee=d(K,Q,X),ne=new Map,se=new Set,H=U=>{se.add(U);const $=D.filter(({key:G})=>G===U)[0];$?(q=R.edit(q,[U],$.value,T),z=R.edit(z,[U],$.value,T)):ne.set(U,{key:U,localValue:J[U],remoteValue:Q[U]})};for(const U of F.removed.values())ee.updated.has(U)?H(U):z=R.edit(z,[U],void 0,T);for(const U of ee.removed.values())se.has(U)||(F.updated.has(U)?H(U):q=R.edit(q,[U],void 0,T));for(const U of F.updated.values())se.has(U)||(ee.updated.has(U)?j.updated.has(U)&&H(U):z=R.edit(z,[U],J[U],T));for(const U of ee.updated.values())se.has(U)||(F.updated.has(U)?j.updated.has(U)&&H(U):q=R.edit(q,[U],Q[U],T));for(const U of F.added.values())se.has(U)||(ee.added.has(U)?j.updated.has(U)&&H(U):z=u(U,q,z,T));for(const U of ee.added.values())se.has(U)||(F.added.has(U)?j.updated.has(U)&&H(U):q=u(U,z,q,T));const B=ne.size>0||!b(q,z,S),N=B||!b(q,a,[]),C=B||!b(z,h,[]);return{localContent:N?q:null,remoteContent:C?z:null,conflictsSettings:[...ne.values()],hasConflicts:B}}e.merge=p;function b(a,h,w){if(a===h)return!0;const S=(0,O.parse)(a),D=(0,O.parse)(h),T=w.reduce((V,q)=>(V.add(q),V),new Set),M=s(a).filter(V=>!(V.setting&&T.has(V.setting.key))),x=s(h).filter(V=>!(V.setting&&T.has(V.setting.key)));if(M.length!==x.length)return!1;for(let V=0;V<M.length;V++){const q=M[V],z=x[V];if(q.setting&&z.setting){if(q.setting.key!==z.setting.key||!_.equals(S[q.setting.key],D[q.setting.key]))return!1}else if(!q.setting&&!z.setting){if(q.value!==z.value)return!1}else return!1}return!0}function c(a){return a?s(a).length===0:!0}e.isEmpty=c;function d(a,h,w){const S=a?Object.keys(a).filter(V=>!w.has(V)):[],D=Object.keys(h).filter(V=>!w.has(V)),T=D.filter(V=>S.indexOf(V)===-1).reduce((V,q)=>(V.add(q),V),new Set),M=S.filter(V=>D.indexOf(V)===-1).reduce((V,q)=>(V.add(q),V),new Set),x=new Set;if(a)for(const V of S){if(M.has(V))continue;const q=a[V],z=h[V];_.equals(q,z)||x.add(V)}return{added:T,removed:M,updated:x}}function u(a,h,w,S){const D=(0,O.parse)(h),T=s(h),M=s(w),x=g(a,T,M);return v(w,a,D[a],x,M,S)}e.addSetting=u;function g(a,h,w){const S=h.findIndex(T=>T.setting?.key===a),D=h[S-1];if(D){if(D.setting){const M=i(D.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=o(S,h);if(M){const x=i(M.setting.key,w);if(x){const V=n(w.indexOf(x),w),q=t(h,M,h[S]);if(V){const z=t(w,x,V),J=r(q,z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.indexOf(V),insertAfter:!1}}else{const z=t(w,x,w[w.length-1]),J=r(q,z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const T=h[S+1];if(T)if(T.setting){const M=i(T.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=n(S,h);if(M){const x=i(M.setting.key,w);if(x){const V=o(w.indexOf(x),w),q=t(h,h[S],M);if(V){const z=t(w,V,x),J=r(q.reverse(),z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:w.indexOf(V),insertAfter:!0}}else{const z=t(w,w[0],x),J=r(q.reverse(),z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function v(a,h,w,S,D,T){let M;return S.index===-1?M=(0,l.setProperty)(a,[h],w,T):M=k(a,h,w,S,D,T).map(x=>(0,l.withFormatting)(a,x,T)[0]),(0,l.applyEdits)(a,M)}function k(a,h,w,S,D,T){const M=`${JSON.stringify(h)}: ${JSON.stringify(w)}`,x=(0,A.getEOL)(T,a),V=D[S.index];if(S.insertAfter){const q=[];if(V.setting)q.push({offset:V.endOffset,length:0,content:","+M});else{const z=n(S.index,D),J=o(S.index,D),Q=J?.setting?.commaOffset;J&&Q===void 0&&q.push({offset:J.endOffset,length:0,content:","});const K=Q!==void 0&&Q>V.endOffset;q.push({offset:K?Q+1:V.endOffset,length:0,content:z?x+M+",":x+M})}return q}else{if(V.setting)return[{offset:V.startOffset,length:0,content:M+","}];const q=(D[S.index-1]&&!D[S.index-1].setting?x:"")+M+(n(S.index,D)?",":"")+x;return[{offset:V.startOffset,length:0,content:q}]}}function i(a,h){return h.filter(w=>w.setting?.key===a)[0]}function o(a,h){for(let w=a-1;w>=0;w--)if(h[w].setting)return h[w]}function n(a,h){for(let w=a+1;w<h.length;w++)if(h[w].setting)return h[w]}function t(a,h,w){const S=a.indexOf(h),D=a.indexOf(w);return a.filter((T,M)=>S<M&&M<D)}function r(a,h){if(a.length&&h.length){let w=0;for(;w<h.length&&w<a.length;w++)if(a[w].value!==h[w].value)return h[w-1];return h[w-1]}}function s(a){const h=[];let w=-1,S,D;const T={onObjectBegin:M=>{w++},onObjectProperty:(M,x,V)=>{w===0&&(S=x,D=M)},onObjectEnd:(M,x)=>{w--,w===0&&h.push({startOffset:S,endOffset:M+x,value:a.substring(S,M+x),setting:{key:D,commaOffset:void 0}})},onArrayBegin:(M,x)=>{w++},onArrayEnd:(M,x)=>{w--,w===0&&h.push({startOffset:S,endOffset:M+x,value:a.substring(S,M+x),setting:{key:D,commaOffset:void 0}})},onLiteralValue:(M,x,V)=>{w===0&&h.push({startOffset:S,endOffset:x+V,value:a.substring(S,x+V),setting:{key:D,commaOffset:void 0}})},onSeparator:(M,x,V)=>{if(w===0&&M===","){let q=h.length-1;for(;q>=0&&!h[q].setting;q--);const z=h[q];z&&h.splice(q,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:x}})}},onComment:(M,x)=>{w===0&&h.push({startOffset:M,endOffset:M+x,value:a.substring(M,M+x)})}};return(0,O.visit)(a,T),h}}),define(oe[77],ae([0,1,3,2,5,24]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let _=class extends O.Disposable{get account(){return this._account}constructor(P,y){super(),this.userDataSyncStoreService=P,this.logService=y,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};_=ve([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],_),e.UserDataSyncAccountService=_}),define(oe[264],ae([0,1,2,12]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(m){this.service=m}listen(m,f){switch(f){case"onError":return this.service.onError}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"triggerSync":return this.service.triggerSync(p[0],p[1],p[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(p[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class A{constructor(m){this.service=m}listen(m,f){throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(p[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(O.URI.revive(p[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class _{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=_;class R{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${f}`)}async call(m,f,p){switch(f){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(p[0],p[1]);case"setEnablements":return this.service.setEnablements(p)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(p)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class y{constructor(m){this.service=m}listen(m,f){switch(f){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(m,f,p){switch(f){case"switch":return this.service.switch(p[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=y;class I extends L.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:O.URI.revive(m.url),type:m.type,defaultUrl:O.URI.revive(m.defaultUrl),insidersUrl:O.URI.revive(m.insidersUrl),stableUrl:O.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(oe[265],ae([0,1,188,9,24]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends O.AbstractLogger{constructor(R){super(),this.logger=this._register(R.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(R,...P){this.logger.trace(R,...P)}debug(R,...P){this.logger.debug(R,...P)}info(R,...P){this.logger.info(R,...P)}warn(R,...P){this.logger.warn(R,...P)}error(R,...P){this.logger.error(R,...P)}flush(){this.logger.flush()}};A=ve([Y(0,O.ILoggerService)],A),e.UserDataSyncLogService=A}),define(oe[266],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(oe[267],ae([0,1,6,3,2]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:y}){super(),this.disposables=this._register(new l.DisposableStore),O.Event.latch(O.Event.any(R,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>y()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(oe[120],ae([0,1,191,14,48,23,12,5,22]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function y(t){const r=t;return typeof r?.id=="string"&&_.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=y;function I(t){return typeof t?.id=="string"&&!y(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(t,r){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,O.basename)(t)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=t;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=E;function m(t){const r=t;return typeof r?.id=="string"&&_.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function f(t){const r=t;if(r?.uri)return{id:r.id,uri:_.URI.revive(r.uri)};const s=t;if(s?.configPath)return{id:s.id,configPath:_.URI.revive(s.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=f;var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function b(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=b;function c(t){const r=t;return!!(r&&typeof r=="object"&&_.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=c;class d{constructor(r,s,a,h,w){this._id=r,this._transient=a,this._configuration=h,this._ignorePathCasing=w,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class u{constructor(r,s){this.raw=s,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function g(t){return new u({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(t,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,r.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function k(t){let r;return _.URI.isUri(t)?r=t:r=t.configuration,r?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(t,r){return!v(t,r)&&!k(t)}e.isSavedWorkspace=o;function n(t){return(typeof t=="string"?(0,O.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[18],ae([0,1,53,3,2,23,12,182,15,13,5,9,120,37,30,6,31,27,11]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&_.URI.isUri(t.location)&&_.URI.isUri(t.globalStorageHome)&&_.URI.isUri(t.settingsResource)&&_.URI.isUri(t.keybindingsResource)&&_.URI.isUri(t.tasksResource)&&_.URI.isUri(t.snippetsHome)&&_.URI.isUri(t.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function v(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:_.URI.revive(n.location).with({scheme:t}),globalStorageHome:_.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:_.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:_.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:_.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:_.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:_.URI.revive(n.extensionsResource).with({scheme:t}),cacheHome:_.URI.revive(n.cacheHome).with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=v;function k(n,t,r,s,a){return{id:n,name:t,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(s,n),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=k;let i=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,s,a){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=s,this.logService=a,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=[];if(this.enabled)try{for(const h of this.getStoredProfiles()){if(!h.name||!(0,u.isString)(h.name)||!h.location){this.logService.warn("Skipping the invalid stored profile",h.location||h.name);continue}t.push(k((0,A.basename)(h.location),h.name,h.location,this.profilesCacheHome,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.logService.error(h)}const r=new f.ResourceMap,s=new Map,a=this.createDefaultProfile();if(t.unshift({...a,extensionsResource:this.getDefaultProfileExtensionsLocation()??a.extensionsResource,isDefault:!0}),t.length)try{const h=this.getStoredProfileAssociations();if(h.workspaces)for(const[w,S]of Object.entries(h.workspaces)){const D=_.URI.parse(w),T=t.find(M=>M.id===S);T&&r.set(D,T)}if(h.emptyWindows)for(const[w,S]of Object.entries(h.emptyWindows)){const D=t.find(T=>T.id===S);D&&s.set(w,D)}}catch(h){this.logService.error(h)}this._profilesObject={profiles:t,workspaces:r,emptyWindows:s}}return this._profilesObject}createDefaultProfile(){return k("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome)}async createTransientProfile(t){const r="Temp",s=new RegExp(`${(0,d.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const S=s.exec(w.name),D=S?parseInt(S[1]):0;a=D>a?D:a}const h=`${r} ${a+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),h,{transient:!0},t)}async createNamedProfile(t,r,s){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),t,r,s)}async createProfile(t,r,s,a){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const h=await this.doCreateProfile(t,r,s);return a&&await this.setProfileForWorkspace(a,h),h}async doCreateProfile(t,r,s){if(!(0,u.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.profileCreationPromises.get(r);return a||(a=(async()=>{try{const h=this.profiles.find(D=>D.name===r||D.id===t);if(h)return h;const w=k(t,r,(0,A.joinPath)(this.profilesHome,t),this.profilesCacheHome,s);await this.fileService.createFolder(w.location);const S=[];return this._onWillCreateProfile.fire({profile:w,join(D){S.push(D)}}),await b.Promises.settled(S),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,a)),a}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let s=this.profiles.find(a=>a.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);return s=k(s.id,r.name??s.name,s.location,this.profilesCacheHome,{shortName:r.shortName??s.shortName,transient:r.transient??s.isTransient,useDefaultFlags:r.useDefaultFlags??s.useDefaultFlags}),this.updateProfiles([],[],[s]),s}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(a){s.push(a)}});try{await Promise.allSettled(s)}catch(a){this.logService.error(a)}for(const a of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(a)?.id&&this.profilesObject.emptyWindows.delete(a);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(a){(0,y.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,s)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,m.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,m.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,s){const a=[...this.profiles,...t],h=[];this.transientProfilesObject.profiles=[];for(let w of a)w.isDefault||r.some(S=>w.id===S.id)||(w=s.find(S=>w.id===S.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):h.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(h),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,s)}triggerProfilesChanges(t,r,s){this._onDidChangeProfiles.fire({added:t,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(t,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(t,void 0,!0);const a=this.getWorkspace(t),h=s?this.transientProfilesObject:this.profilesObject;_.URI.isUri(a)?(h.workspaces.delete(a),r&&h.workspaces.set(a,r)):(h.emptyWindows.delete(a),r&&h.emptyWindows.set(a,r)),s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[s,a]of this.profilesObject.workspaces.entries())t[s.toString()]=a.id;const r={};for(const[s,a]of this.profilesObject.emptyWindows.entries())r[s.toString()]=a.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},s=this.createDefaultProfile();if(t.workspaces)for(const[h,w]of Object.entries(t.workspaces)){const S=_.URI.parse(w);r[h]=this.uriIdentityService.extUri.isEqual(S,s.location)?s.id:this.uriIdentityService.extUri.basename(S)}const a={};if(t.emptyWindows)for(const[h,w]of Object.entries(t.emptyWindows)){const S=_.URI.parse(w);a[h]=this.uriIdentityService.extUri.isEqual(S,s.location)?s.id:this.uriIdentityService.extUri.basename(S)}return{workspaces:r,emptyWindows:a}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([Y(0,P.IEnvironmentService),Y(1,y.IFileService),Y(2,p.IUriIdentityService),Y(3,E.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=o}),define(oe[268],ae([0,1,6,2,18]),function(ie,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends O.Disposable{constructor(R){super(),this._register(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=ve([Y(0,l.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[269],ae([0,1,21,6,25,10,3,2,4,11,12,161,29,33,50,9,26,19,18]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,r,s,a,h){super(),this.galleryService=t,this.telemetryService=r,this.logService=s,this.productService=a,this.userDataProfilesService=h,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:w})=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,m.isTargetPlatformCompatible)(s,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(E.localize(0,null),m.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,r)}catch(s){throw i(this.telemetryService,"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),k(s)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,s){const a=s.isApplicationScoped||s.isBuiltin||(0,p.isApplicationScopedExtension)(t),h={...s,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(r)?s.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:a,profileLocation:a?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},w=V=>`${f.ExtensionKey.create(V).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!I.URI.isUri(r)){const V=this.installingExtensions.get(w(r));if(V)return this.logService.info("Extensions is already requested to install",r.identifier.id),V.task.waitUntilTaskIsFinished()}const S=[],D=[],T=[],M=this.createInstallExtensionTask(t,r,h);I.URI.isUri(r)||this.installingExtensions.set(w(r),{task:M,waitingTasks:[]}),this._onInstallExtension.fire({identifier:M.identifier,source:r,profileLocation:h.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),S.push({task:M,manifest:t});let x=!1;try{if(h.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const q=await this.getAllDepsAndPackExtensions(M.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),z=await this.getInstalled(void 0,h.profileLocation);for(const{gallery:J,manifest:Q}of(0,L.distinct)(q,({gallery:K})=>K.identifier.id)){x=x||!!Q.extensionDependencies?.some(j=>(0,f.areSameExtensions)({id:j},M.identifier));const K=w(J),X=this.installingExtensions.get(K);if(X){if(this.canWaitForTask(M,X.task)){const j=X.task.identifier;this.logService.info("Waiting for already requested installing extension",j.id,M.identifier.id),X.waitingTasks.push(M),D.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,F=>F.some(ee=>(0,f.areSameExtensions)(ee.identifier,j)))).then(F=>{if(this.logService.info("Finished waiting for already requested installing extension",j.id,M.identifier.id),!F.find(ne=>(0,f.areSameExtensions)(ne.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!z.some(({identifier:j})=>(0,f.areSameExtensions)(j,J.identifier))){const j=this.createInstallExtensionTask(Q,J,{...h,donotIncludePackAndDependencies:!0});this.installingExtensions.set(K,{task:j,waitingTasks:[M]}),this._onInstallExtension.fire({identifier:j.identifier,source:J,profileLocation:h.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,M.identifier.id),S.push({task:j,manifest:Q})}}}catch(q){if(I.URI.isUri(M.source))(0,L.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,q.message),(0,L.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),q}const V=S.reduce((q,{task:z,manifest:J})=>(q.set(z.identifier.id.toLowerCase(),{task:z,manifest:J}),q),new Map);for(;V.size;){let q;const z=[...V.values()].filter(({manifest:J})=>!J.extensionDependencies?.some(Q=>V.has(Q.toLowerCase())));z.length?q=V.size===1?z:z.filter(({task:J})=>!(J===M&&!x)):(this.logService.info("Found extensions with circular dependencies",z.map(({task:J})=>J.identifier.id)),q=[...V.values()]),await this.joinAllSettled(q.map(async({task:J})=>{const Q=new Date().getTime();try{const K=await J.run();if(await this.joinAllSettled(this.participants.map(X=>X.postInstall(K,J.source,h,l.CancellationToken.None))),!I.URI.isUri(J.source)){const X=J.operation===3,j=X?void 0:(new Date().getTime()-J.source.lastUpdated)/1e3;if(i(this.telemetryService,X?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(J.source),verificationStatus:J.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:j}),P.isWeb&&J.operation!==3)try{await this.galleryService.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}}T.push({local:K,identifier:J.identifier,operation:J.operation,source:J.source,context:h.context,profileLocation:J.profileLocation,applicationScoped:K.isApplicationScoped})}catch(K){throw I.URI.isUri(J.source)||i(this.telemetryService,J.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.getGalleryExtensionTelemetryData)(J.source),verificationStatus:J.verificationStatus,duration:new Date().getTime()-Q,error:K}),this.logService.error("Error while installing the extension:",J.identifier.id),K}finally{V.delete(J.identifier.id.toLowerCase())}}))}return D.length&&await this.joinAllSettled(D),T.forEach(({identifier:q})=>this.logService.info("Extension installed successfully:",q.id)),this._onDidInstallExtensions.fire(T),T.filter(({identifier:q})=>(0,f.areSameExtensions)(q,M.identifier))[0].local}catch(V){if(S.forEach(({task:q})=>q.cancel()),T.length)try{const q=await Promise.allSettled(T.map(({local:z})=>this.createUninstallExtensionTask(z,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let z=0;z<q.length;z++){const J=q[z],{identifier:Q}=T[z];J.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Q.id):this.logService.warn("Rollback: Error while uninstalling extension",Q.id,(0,A.getErrorMessage)(J.reason))}}catch(q){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(q),T.map(({identifier:z})=>z.id))}throw this._onDidInstallExtensions.fire(S.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:h.context,profileLocation:h.profileLocation}))),V}finally{for(const{task:V}of S)V.source&&!I.URI.isUri(V.source)&&this.installingExtensions.delete(w(V.source))}}canWaitForTask(t,r){for(const[,{task:s,waitingTasks:a}]of this.installingExtensions.entries())if(s===t&&(a.includes(r)||a.some(h=>this.canWaitForTask(h,r)))||s===r&&a[0]&&!this.canWaitForTask(t,a[0]))return!1;return!0}async joinAllSettled(t){const r=[],s=[],a=await Promise.allSettled(t);for(const h of a)h.status==="fulfilled"?r.push(h.value):s.push(h.reason);if(s.length)throw v(s);return r}async getAllDepsAndPackExtensions(t,r,s,a,h){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,h),S=[],D=[],T=async(M,x)=>{S.push(M);const V=x.extensionDependencies||[],q=[...V];if(x.extensionPack){const z=s?w.find(J=>(0,f.areSameExtensions)(J.identifier,M)):void 0;for(const J of x.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(Q=>(0,f.areSameExtensions)({id:Q},{id:J}))||q.every(Q=>!(0,f.areSameExtensions)({id:Q},{id:J}))&&q.push(J)}if(q.length){const z=q.filter(J=>S.every(Q=>!(0,f.areSameExtensions)(Q,{id:J})));if(z.length){const J=await this.galleryService.getExtensions(z.map(Q=>({id:Q,preRelease:a})),l.CancellationToken.None);for(const Q of J){if(S.find(j=>(0,f.areSameExtensions)(j,Q.identifier)))continue;const K=V.some(j=>(0,f.areSameExtensions)({id:j},Q.identifier));let X;try{X=await this.checkAndGetCompatibleVersion(Q,!1,a)}catch(j){if(j instanceof m.ExtensionManagementError&&j.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.logService.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw j}D.push({gallery:X.extension,manifest:X.manifest}),await T(X.extension.identifier,X.manifest)}}}};return await T(t,r),D}async checkAndGetCompatibleVersion(t,r,s){if((await this.getExtensionsControlManifest()).malicious.some(S=>(0,f.areSameExtensions)(t.identifier,S)))throw new m.ExtensionManagementError(E.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const S=await this.getTargetPlatform();throw new m.ExtensionManagementError(E.localize(2,null,t.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)(S)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.getCompatibleVersion(t,r,s);if(h){if(s&&!r&&t.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(E.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],l.CancellationToken.None))[0]?new m.ExtensionManagementError(E.localize(4,null,t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",h.identifier.id);const w=await this.galleryService.getManifest(h,l.CancellationToken.None);if(w===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(w.version!==h.version)throw new m.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:w}}async getCompatibleVersion(t,r,s){const a=await this.getTargetPlatform();let h=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(h=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null),!h&&await this.galleryService.isExtensionCompatible(t,s,a)&&(h=t),h||(r?h=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null:h=await this.galleryService.getCompatibleExtension(t,s,a)),h}async uninstallExtension(t,r){const s={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},a=M=>`${M.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,h=this.uninstallingExtensions.get(a(t.identifier));if(h)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),h.waitUntilTaskIsFinished();const w=M=>{const x=this.createUninstallExtensionTask(M,s);return this.uninstallingExtensions.set(a(x.extension.identifier),x),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:s.profileLocation,applicationScoped:M.isApplicationScoped}),x},S=(M,x)=>{x?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,s.profileLocation.toString(),x.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,x.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,f.getLocalExtensionTelemetryData)(M),error:x}),this._onDidUninstallExtension.fire({identifier:M.identifier,error:x?.code,profileLocation:s.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],T=[];try{D.push(w(t));const M=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const x=this.getAllPackExtensionsToUninstall(t,M);for(const V of x)this.uninstallingExtensions.has(a(V.identifier))?this.logService.info("Extensions is already requested to uninstall",V.identifier.id):D.push(w(V))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(D.map(x=>x.extension),M,t),await this.joinAllSettled(D.map(async x=>{try{if(await x.run(),await this.joinAllSettled(this.participants.map(V=>V.postUninstall(x.extension,s,l.CancellationToken.None))),x.extension.identifier.uuid)try{await this.galleryService.reportStatistic(x.extension.manifest.publisher,x.extension.manifest.name,x.extension.manifest.version,"uninstall")}catch{}S(x.extension)}catch(V){const q=V instanceof m.ExtensionManagementError?V:new m.ExtensionManagementError((0,A.getErrorMessage)(V),m.ExtensionManagementErrorCode.Internal);throw S(x.extension,q),q}finally{T.push(x)}}))}catch(M){const x=M instanceof m.ExtensionManagementError?M:new m.ExtensionManagementError((0,A.getErrorMessage)(M),m.ExtensionManagementErrorCode.Internal);for(const V of D){try{V.cancel()}catch{}T.includes(V)||S(V.extension,x)}throw x}finally{for(const M of D)this.uninstallingExtensions.delete(a(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(t,r,s){for(const a of t){const h=this.getDependents(a,r);if(h.length){const w=h.filter(S=>!t.some(D=>(0,f.areSameExtensions)(D.identifier,S.identifier)));if(w.length)throw new Error(this.getDependentsErrorMessage(a,w,s))}}}getDependentsErrorMessage(t,r,s){return s===t?r.length===1?E.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const a=t.manifest.extensionPack?t.manifest.extensionPack:[];if(a.length){const h=r.filter(S=>!S.isBuiltin&&a.some(D=>(0,f.areSameExtensions)({id:D},S.identifier))),w=[];for(const S of h)w.push(...this.getAllPackExtensionsToUninstall(S,r,s));return[...h,...w]}return[]}getDependents(t,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(a=>(0,f.areSameExtensions)({id:a},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=ve([Y(0,m.IExtensionGalleryService),Y(1,d.ITelemetryService),Y(2,b.ILogService),Y(3,c.IProductService),Y(4,u.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=v;function k(n){if(n instanceof m.ExtensionManagementError)return n;const t=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function i(n,t,{extensionData:r,verificationStatus:s,duration:a,error:h,durationSinceUpdate:w}){let S,D;(0,y.isDefined)(s)&&(s===!0?s="Verified":(s===!1||(S=m.ExtensionManagementErrorCode.Signature,D=s),s="Unverified")),h&&(h instanceof m.ExtensionManagementError?(S=h.code,h.code===m.ExtensionManagementErrorCode.Signature&&(D=h.message)):S=m.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,verificationStatus:s,success:!h,duration:a,errorcode:S,errorcodeDetail:D,durationSinceUpdate:w})}class o{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>new Promise((r,s)=>{const a=t.onCancellationRequested(()=>{a.dispose(),s(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(oe[51],ae([0,1,6,16,2,3,37,12,29,33,13,5,9,18,30,11,10,19]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class g extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let v=class extends l.Disposable{constructor(n,t,r,s,a,h){super(),this.extensionsLocation=n,this.fileService=t,this.userDataProfilesService=r,this.uriIdentityService=s,this.telemetryService=a,this.logService=h,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(n,t){return this.withProfileExtensions(n,void 0,t)}async addExtensionsToProfile(n,t){const r=[],s=[];try{return await this.withProfileExtensions(t,a=>{const h=[];for(const w of a)n.some(([S])=>(0,y.areSameExtensions)(S.identifier,w.identifier)&&S.manifest.version!==w.version)?r.push(w):h.push(w);for(const[w,S]of n)if(!h.some(D=>(0,y.areSameExtensions)(D.identifier,w.identifier)&&D.version===w.manifest.version)){const D={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:S};s.push(D),h.push(D)}return s.length&&this._onAddExtensions.fire({extensions:s,profileLocation:t}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:t}),h}),s.length&&this._onDidAddExtensions.fire({extensions:s,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:t}),s}catch(a){throw s.length&&this._onDidAddExtensions.fire({extensions:s,error:a,profileLocation:t}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:a,profileLocation:t}),a}}async updateMetadata(n,t){const r=[];return await this.withProfileExtensions(t,s=>{const a=[];for(const h of s){const w=n.find(([S])=>(0,y.areSameExtensions)(S.identifier,h.identifier)&&S.manifest.version===h.version);w&&(h.metadata={...h.metadata,...w[1]},r.push(h)),a.push(h)}return a}),r}async removeExtensionFromProfile(n,t){const r=[];this._onRemoveExtensions.fire({extensions:r,profileLocation:t});try{await this.withProfileExtensions(t,s=>{const a=[];for(const h of s)(0,y.areSameExtensions)(h.identifier,n.identifier)?r.push(h):a.push(h);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:t}),a}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:t})}catch(s){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:s,profileLocation:t}),s}}async withProfileExtensions(n,t,r){return this.getResourceAccessQueue(n).queue(async()=>{let s=[],a;try{const h=await this.fileService.readFile(n);a=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,I.toFileOperationResult)(h)!==1)throw h;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&r?.bailOutWhenFileNotFound)throw new g((0,c.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let h=!1;for(const w of a){k(w)||this.reportAndThrowInvalidConentError(n);let S;if((0,b.isString)(w.relativeLocation)&&w.relativeLocation)S=this.resolveExtensionLocation(w.relativeLocation);else if((0,b.isString)(w.location))S=this.resolveExtensionLocation(w.location),h=!0,w.relativeLocation=w.location,w.location=S.toJSON();else{S=R.URI.revive(w.location);const D=this.toRelativePath(S);D&&(h=!0,w.relativeLocation=D)}s.push({identifier:w.identifier,location:S,version:w.version,metadata:w.metadata})}h&&await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(a)))}if(t){s=t(s);const h=s.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.toRelativePath(w.location),metadata:w.metadata}));await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(h)))}return s})}reportAndThrowInvalidConentError(n){const t=new g(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,I.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let s;try{const a=JSON.parse(r);Array.isArray(a)&&a.every(h=>k(h))?s=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(s)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,I.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(t)}catch(a){(0,I.toFileOperationResult)(a)!==1&&this.logService.error(a)}return s})()),this._migrationPromise}getResourceAccessQueue(n){let t=this.resourcesAccessQueueMap.get(n);return t||(t=new L.Queue,this.resourcesAccessQueueMap.set(n,t)),t}};v=ve([Y(1,I.IFileService),Y(2,f.IUserDataProfilesService),Y(3,p.IUriIdentityService),Y(4,d.ITelemetryService),Y(5,m.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function k(o){return(0,b.isObject)(o)&&(0,P.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,b.isString)(o.location)&&o.location)&&((0,b.isUndefined)(o.relativeLocation)||(0,b.isString)(o.relativeLocation))&&o.version&&(0,b.isString)(o.version)}function i(o){return o?(0,b.isString)(o.path)&&(0,b.isString)(o.scheme):!1}}),define(oe[78],ae([0,1,21,6,32,16,10,35,141,2,22,14,4,23,55,90,11,12,165,15,33,50,67,13,5,9,26,3,91,51,18,30,197]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o,n,t,r,s,a,h,w,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(Q){function K(X,j){if(X===j)return!0;const F=Object.keys(X),ee=new Set;for(const ne of Object.keys(j))ee.add(ne);if(F.length!==ee.size)return!1;for(const ne of F){if(X[ne]!==j[ne])return!1;ee.delete(ne)}return ee.size===0}Q.equals=K})(T=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let M=class extends y.Disposable{constructor(K,X,j,F,ee,ne,se,H,B,N,C,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=X,this.extensionsControlLocation=j,this.currentProfile=F,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ne,this.fileService=se,this.logService=H,this.environmentService=B,this.productService=N,this.uriIdentityService=C,this.instantiationService=U,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(q,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(V,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,v.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,X,j){const[F,ee]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(X)]),ne=j?await this.scanExtensionsUnderDevelopment(K,[...F,...ee]):[];return this.dedupExtensions(F,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const X=[];X.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),X.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[j,F]=await Promise.all(X);return this.applyScanOptions([...j,...F],0,K,!1)}async scanUserExtensions(K){const X=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",X);const j=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.createExtensionScannerInput(X,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,j),ee=K.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ne;try{ne=await ee.scanExtensions(F)}catch(se){if(se instanceof h.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ne=await ee.scanExtensions(F);else throw se}return ne=await this.applyScanOptions(ne,1,K,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(K,X){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===I.Schemas.file).map(async F=>{const ee=await this.createExtensionScannerInput(F,!1,1,!0,K.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(se=>(se.type=X.find(H=>(0,v.areSameExtensions)(H.identifier,se.identifier))?.type??se.type,this.extensionsScanner.validate(se,ee)))}))).flat();return this.applyScanOptions(j,"development",K,!0)}return[]}async scanExistingExtension(K,X,j){const F=await this.createExtensionScannerInput(K,!1,X,!0,j.language,!0,void 0),ee=await this.extensionsScanner.scanExtension(F);return!ee||!j.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(K,X,j){const F=await this.createExtensionScannerInput(K,!1,X,!0,j.language,!0,void 0),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(ee,X,j,!0)}async scanMetadata(K){const X=(0,f.joinPath)(K,"package.json"),j=(await this.fileService.readFile(X)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(K,X){const j=(0,f.joinPath)(K,"package.json"),F=(await this.fileService.readFile(j)).value.toString(),ee=JSON.parse(F);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,ee.__metadata={...ee.__metadata,...X},await this.fileService.writeFile((0,f.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof h.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(X=>[X,X.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(X){(0,o.toFileOperationResult)(X)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(X))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,X,j,F){return j.includeAllVersions||(K=this.dedupExtensions(X===0?K:void 0,X===1?K:void 0,X==="development"?K:void 0,await this.getTargetPlatform(),F)),j.includeInvalid||(K=K.filter(ee=>ee.isValid)),K.sort((ee,ne)=>{const se=E.basename(ee.location.fsPath),H=E.basename(ne.location.fsPath);return se<H?-1:se>H?1:0})}dedupExtensions(K,X,j,F,ee){const ne=(H,B,N)=>{if(H.isValid&&!B.isValid)return!1;if(H.isValid===B.isValid){if(ee&&p.gt(H.manifest.version,B.manifest.version))return this.logService.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(p.eq(H.manifest.version,B.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${B.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===F)return this.logService.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${H.location.path} with ${B.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${B.location.path}.`),!0},se=new k.ExtensionIdentifierMap;return K?.forEach(H=>{const B=se.get(H.identifier.id);(!B||ne(B,H,!1))&&se.set(H.identifier.id,H)}),X?.forEach(H=>{const B=se.get(H.identifier.id);if(!B&&K&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!B||ne(B,H,!1))&&se.set(H.identifier.id,H)}),j?.forEach(H=>{const B=se.get(H.identifier.id);(!B||ne(B,H,!0))&&se.set(H.identifier.id,H),se.set(H.identifier.id,H)}),[...se.values()]}async scanDefaultSystemExtensions(K,X){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),ee=await(K&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(K,X){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=X?await this.getBuiltInExtensionControl():{},ee=[],ne=d.URI.file(E.normalize(E.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of j){const B=F[H.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":ee.push((0,f.joinPath)(ne,H.name));break;default:ee.push(d.URI.file(B));break}}const se=await Promise.all(ee.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,K,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",se.length),(0,L.coalesce)(se)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,X,j,F,ee,ne,se){const H=await this.getTranslations(ee??m.language),B=await this.getMtime(K),N=X&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,C=N?await this.getMtime(N):void 0;return new x(K,B,N,C,X,se,j,F,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,H)}async getMtime(K){try{const X=await this.fileService.stat(K);if(typeof X.mtime=="number")return X.mtime}catch{}}};M=ve([Y(4,w.IUserDataProfilesService),Y(5,h.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,t.ILogService),Y(8,g.IEnvironmentService),Y(9,r.IProductService),Y(10,S.IUriIdentityService),Y(11,n.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class x{constructor(K,X,j,F,ee,ne,se,H,B,N,C,U,$,G,W){this.location=K,this.mtime=X,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=F,this.profile=ee,this.profileScanOptions=ne,this.type=se,this.excludeObsolete=H,this.validate=B,this.productVersion=N,this.productDate=C,this.productCommit=U,this.devMode=$,this.language=G,this.translations=W}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,X){return(0,f.isEqual)(K.location,X.location)&&K.mtime===X.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,X.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&K.profile===X.profile&&l.equals(K.profileScanOptions,X.profileScanOptions)&&K.type===X.type&&K.excludeObsolete===X.excludeObsolete&&K.validate===X.validate&&K.productVersion===X.productVersion&&K.productDate===X.productDate&&K.productCommit===X.productCommit&&K.devMode===X.devMode&&K.language===X.language&&T.equals(K.translations,X.translations)}}e.ExtensionScannerInput=x;let V=class extends y.Disposable{constructor(K,X,j,F,ee){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=X,this.uriIdentityService=j,this.fileService=F,this.logService=ee}async scanExtensions(K){const X=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let j={};if(K.excludeObsolete&&K.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(F)}catch{}return(0,c.isEmptyObject)(j)?X:X.filter(F=>!j[v.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(K){const X=await this.fileService.resolve(K.location);if(!X.children?.length)return[];const j=await Promise.all(X.children.map(async F=>{if(!F.isDirectory||K.type===1&&(0,f.basename)(F.resource).indexOf(".")===0)return null;const ee=new x(F.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ee)}));return(0,L.coalesce)(j).sort((F,ee)=>F.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(K){let X=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){X=X.filter(F=>!F.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,K);X.push(...j)}return X}async scanExtensionsFromProfileResource(K,X,j){const F=await this.extensionsProfileScannerService.scanProfileExtensions(K,j.profileScanOptions);if(!F.length)return[];const ee=await Promise.all(F.map(async ne=>{if(X(ne)){const se=new x(ne.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(se,ne.metadata)}return null}));return(0,L.coalesce)(ee)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,f.joinPath)(K.location,"package.json"))){const X=await this.scanExtension(K);return X?[X]:[]}else return await this.scanExtensions(K)}catch(X){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,_.getErrorMessage)(X)),[]}}async scanExtension(K,X){try{let j=await this.scanExtensionManifest(K.location);if(j){j.publisher||(j.publisher=k.UNDEFINED_PUBLISHER),X=X??j.__metadata,delete j.__metadata;const F=(0,v.getGalleryExtensionId)(j.publisher,j.name),ee=X?.id?{id:F,uuid:X.id}:{id:F},ne=X?.isSystem?0:K.type,se=ne===0||!!X?.isBuiltin;j=await this.translateManifest(K.location,j,x.createNlsConfiguration(K));const H={type:ne,identifier:ee,manifest:j,location:K.location,isBuiltin:se,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return K.validate?this.validate(H,K):H}}catch(j){K.type!==0&&this.logService.error(j)}return null}validate(K,X){let j=!0;const F=(0,i.validateExtensionManifest)(X.productVersion,X.productDate,X.location,K.manifest,K.isBuiltin);for(const[ee,ne]of F)ee===b.default.Error&&(j=!1,this.logService.error(this.formatMessage(X.location,ne)));return K.isValid=j,K.validations=F,K}async scanExtensionManifest(K){const X=(0,f.joinPath)(K,"package.json");let j;try{j=(await this.fileService.readFile(X)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(K,(0,u.localize)(0,null,X.path,ee.message))),null}let F;try{F=JSON.parse(j)}catch{const ne=[];(0,R.parse)(j,ne);for(const se of ne)this.logService.error(this.formatMessage(K,(0,u.localize)(1,null,X.path,se.offset,se.length,(0,P.getParseErrorMessage)(se.error))));return null}return(0,R.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(K,(0,u.localize)(2,null,X.path))),null):F}async translateManifest(K,X,j){const F=await this.getLocalizedMessages(K,X,j);if(F)try{const ee=[],ne=await this.resolveOriginalMessageBundle(F.default,ee);if(ee.length>0)return ee.forEach(H=>{this.logService.error(this.formatMessage(K,(0,u.localize)(3,null,F.default?.path,(0,P.getParseErrorMessage)(H.error))))}),X;if((0,R.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(K,(0,u.localize)(4,null,F.default?.path))),X;const se=F.values||Object.create(null);return(0,D.localizeManifest)(X,se,ne)}catch{}return X}async getLocalizedMessages(K,X,j){const F=(0,f.joinPath)(K,"package.nls.json"),ee=(B,N)=>{N.forEach(C=>{this.logService.error(this.formatMessage(K,(0,u.localize)(5,null,B?.path,(0,P.getParseErrorMessage)(C.error))))})},ne=B=>{this.logService.error(this.formatMessage(K,(0,u.localize)(6,null,B?.path)))},se=`${X.publisher}.${X.name}`,H=j.translations[se];if(H)try{const B=d.URI.file(H),N=(await this.fileService.readFile(B)).value.toString(),C=[],U=(0,R.parse)(N,C);return C.length>0?(ee(B,C),{values:void 0,default:F}):(0,R.getNodeType)(U)!=="object"?(ne(B),{values:void 0,default:F}):{values:U.contents?U.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let N;try{N=await this.findMessageBundles(K,j)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const C=(await this.fileService.readFile(N.localized)).value.toString(),U=[],$=(0,R.parse)(C,U);return U.length>0?(ee(N.localized,U),{values:void 0,default:N.original}):(0,R.getNodeType)($)!=="object"?(ne(N.localized),{values:void 0,default:N.original}):{values:$,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(K,X){if(K)try{const j=(await this.fileService.readFile(K)).value.toString();return(0,R.parse)(j,X)}catch{}}findMessageBundles(K,X){return new Promise((j,F)=>{const ee=ne=>{const se=(0,f.joinPath)(K,`package.nls.${ne}.json`);this.fileService.exists(se).then(H=>{H&&j({localized:se,original:(0,f.joinPath)(K,"package.nls.json")});const B=ne.lastIndexOf("-");B===-1?j({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):(ne=ne.substring(0,B),ee(ne))})};if(X.devMode||X.pseudo||!X.language)return j({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});ee(X.language)})}formatMessage(K,X){return`[${K.path}]: ${X}`}};V=ve([Y(1,h.IExtensionsProfileScannerService),Y(2,S.IUriIdentityService),Y(3,o.IFileService),Y(4,t.ILogService)],V);let q=class extends V{constructor(K,X,j,F,ee,ne,se){super(X,F,ee,ne,se),this.currentProfile=K,this.userDataProfilesService=j,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const X=this.getCacheFile(K),j=await this.readExtensionCache(X);if(this.input=K,j&&j.input&&x.equals(j.input,this.input))return this.logService.debug("Using cached extensions scan result",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),j.result.map(ee=>(ee.location=d.URI.revive(ee.location),ee));const F=await super.scanExtensions(K);return await this.writeExtensionCache(X,{input:K,result:F}),F}async readExtensionCache(K){try{const X=await this.fileService.readFile(K),j=JSON.parse(X.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(X){this.logService.debug("Error while reading the extension cache file:",K.path,(0,_.getErrorMessage)(X))}return null}async writeExtensionCache(K,X){try{await this.fileService.writeFile(K,A.VSBuffer.fromString(JSON.stringify(X)))}catch(j){this.logService.debug("Error while writing the extension cache file:",K.path,(0,_.getErrorMessage)(j))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),X=await this.readExtensionCache(K);if(!X)return;const j=X.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!l.equals(F,j))try{this.logService.info("Invalidating Cache",j,F),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(ee){this.logService.error(ee)}}getCacheFile(K){const X=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(X.cacheHome,K.type===0?k.BUILTIN_MANIFEST_CACHE_FILE:k.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===0?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(X=>this.uriIdentityService.extUri.isEqual(K.location,X.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};q=ve([Y(2,w.IUserDataProfilesService),Y(3,h.IExtensionsProfileScannerService),Y(4,S.IUriIdentityService),Y(5,o.IFileService),Y(6,t.ILogService)],q);function z(Q,K){const X=(0,v.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:X,identifier:new k.ExtensionIdentifier(X),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:K,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=z;class J extends M{constructor(K,X,j,F,ee,ne,se,H,B,N,C,U){super(K,X,(0,f.joinPath)(j,".vscode-oss-dev","extensions","control.json"),F,ee,ne,se,H,B,N,C,U),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const $=await this.fileService.readFile(d.URI.file(m.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(oe[270],ae([0,1,49,6,38,3,2,22,14,28,9,18]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends _.Disposable{constructor(p,b){super(),this.userDataProfilesService=p,this.logService=b,this.processesLimiter=new O.Limiter(5)}async postUninstall(p){const b=this.parseScript(p,"uninstall");b&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(b.script,"uninstall",b.args,!0,p),this.logService.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(c){this.logService.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.logService.error(c)}}));try{await y.Promises.rm(this.getExtensionStoragePath(p))}catch(c){this.logService.error("Error while removing extension storage path",p.identifier.id),this.logService.error(c)}}parseScript(p,b){const c=`vscode:${b}`;if(p.location.scheme===R.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[c]=="string"){const d=p.manifest.scripts[c].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${c} should be a node script`),null):{script:(0,P.join)(p.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(p,b,c,d,u){return new Promise((g,v)=>{const k=this.start(p,b,c,u);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?v(n):g(void 0)};k.on("error",n=>{o((0,l.toErrorMessage)(n)||"Unknown")}),k.on("exit",(n,t)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),d&&(i=setTimeout(()=>{i=null,k.kill(),v("timed out")},5e3))})}start(p,b,c,d){const u={silent:!0,execArgv:void 0},g=(0,L.fork)(p,[`--type=extension-post-${b}`,...c],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(g.stdout,"data"),k=A.Event.fromNodeEventEmitter(g.stderr,"data");v(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${b}`,n)),k(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${b}`,n));const i=A.Event.any(A.Event.map(v,n=>({data:`%c${n}`,format:[""]})),A.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(p){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=ve([Y(0,E.IUserDataProfilesService),Y(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(oe[271],ae([0,1,9,18,30,19,51,13,15,12]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends _.AbstractExtensionsProfileScannerService{constructor(m,f,p,b,c,d){super(y.URI.file(m.extensionsPath),f,p,b,c,d)}};I=ve([Y(0,P.INativeEnvironmentService),Y(1,R.IFileService),Y(2,O.IUserDataProfilesService),Y(3,l.IUriIdentityService),Y(4,A.ITelemetryService),Y(5,L.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(oe[272],ae([0,1,12,15,51,78,13,5,9,26,30,18]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends A.NativeExtensionsScannerService{constructor(p,b,c,d,u,g,v,k){super(L.URI.file(u.builtinExtensionsPath),L.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,b,c,d,u,g,v,k)}};m=ve([Y(0,E.IUserDataProfilesService),Y(1,l.IExtensionsProfileScannerService),Y(2,_.IFileService),Y(3,P.ILogService),Y(4,O.INativeEnvironmentService),Y(5,y.IProductService),Y(6,I.IUriIdentityService),Y(7,R.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(oe[20],ae([0,1,6,3,2,105,11,66,5,18]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function f(u){const g=u.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=f;class p extends l.Disposable{constructor(g={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new l.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,l.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,v){if(v===e.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:v,target:this.getKeyTargets(g)[v]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,v,k){return this.getStorage(v)?.get(g,k)}getBoolean(g,v,k){return this.getStorage(v)?.getBoolean(g,k)}getNumber(g,v,k){return this.getStorage(v)?.getNumber(g,k)}store(g,v,k,i){if((0,_.isUndefinedOrNull)(v)){this.remove(g,k);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,k,i),this.getStorage(k)?.set(g,v)})}remove(g,v){this.withPausedEmitters(()=>{this.updateKeyTarget(g,v,void 0),this.getStorage(v)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,v){const k=[],i=this.getKeyTargets(g);for(const o of Object.keys(i))i[o]===v&&k.push(o);return k}updateKeyTarget(g,v,k){const i=this.getKeyTargets(v);typeof k=="number"?i[g]!==k&&(i[g]=k,this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const v=this.getStorage(g);return v?f(v):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const v=this.getStorage(-1),k=this.getStorage(0),i=this.getStorage(1);switch(g){case I.NONE:await L.Promises.settled([v?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await L.Promises.settled([v?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,v=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return d(g,v,k,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,v){return this.emitWillSaveState(I.NONE),(0,y.isUserDataProfile)(g)?this.switchToProfile(g,v):this.switchToWorkspace(g,v)}canSwitchProfile(g,v){return!(g.id===v.id||b(v)&&b(g))}switchData(g,v,k,i){this.withPausedEmitters(()=>{if(i)for(const[o,n]of g)v.set(o,n);else{const o=new Set;for(const[n,t]of g)o.add(n),v.get(n)!==t&&this.emitDidChangeValue(k,n);for(const[n]of v.items)o.has(n)||this.emitDidChangeValue(k,n)}})}}p.DEFAULT_FLUSH_INTERVAL=60*1e3,e.AbstractStorageService=p;function b(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class c extends p{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(g){return!1}}e.InMemoryStorageService=c;async function d(u,g,v,k,i,o){const n=T=>{try{return JSON.parse(T)}catch{return T}},t=new Map,r=new Map;u.forEach((T,M)=>{t.set(M,T),r.set(M,n(T))});const s=new Map,a=new Map;g.forEach((T,M)=>{s.set(M,T),a.set(M,n(T))});const h=new Map,w=new Map;v.forEach((T,M)=>{h.set(M,T),w.set(M,n(T))}),console.group(k!==i?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const S=[];if(t.forEach((T,M)=>{S.push({key:M,value:T})}),console.table(S),console.groupEnd(),console.log(r),k!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const T=[];s.forEach((M,x)=>{T.push({key:x,value:M})}),console.table(T),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const D=[];h.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(w)}e.logStorage=d}),define(oe[121],ae([0,1,3,2,11,29,33,20]),function(ie,e,L,O,l,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends O.Disposable{constructor(E,m){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new y(E)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"}))),this._register(m.onDidInstallExtensions(f=>f.forEach(({local:p,operation:b})=>{p&&b===4&&this._removeFromDisabledExtensions(p.identifier)})))}async enableExtension(E,m){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:m}),!0):!1}async disableExtension(E,m){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const m=this.getDisabledExtensions();return m.every(f=>!(0,_.areSameExtensions)(f,E))?(m.push(E),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(E){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const p=m[f];if((0,_.areSameExtensions)(p,E))return m.splice(f,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(E){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,m){this.storageManger.set(E,m,0)}};P=ve([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class y extends O.Disposable{constructor(E){super(),this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(E,m){let f;return m===0?((0,l.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,m)),f=this.storage[E]):f=this._get(E,m),JSON.parse(f)}set(E,m,f){const p=JSON.stringify(m.map(({id:c,uuid:d})=>({id:c,uuid:d})));this._get(E,f)!==p&&(f===0&&(m.length?this.storage[E]=p:delete this.storage[E]),this._set(E,m.length?p:void 0,f))}onDidStorageChange(E){if(E.scope===0&&!(0,l.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const f=this.get(E.key,E.scope);delete this.storage[E.key];const p=this.get(E.key,E.scope),b=f.filter(d=>!p.some(u=>(0,_.areSameExtensions)(d,u))),c=p.filter(d=>!f.some(u=>(0,_.areSameExtensions)(u,d)));(b.length||c.length)&&this._onDidChange.fire([...b,...c])}}_get(E,m){return this.storageService.get(E,m,"[]")}_set(E,m,f){m?this.storageService.store(E,m,f,1):this.storageService.remove(E,f)}}e.StorageManager=y}),define(oe[273],ae([0,1,21,25,10,4,36,11,12,17,15,29,33,67,13,9,26,59,240,20,19]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,_.arch),i="X-Market-Search-Activity-Id";var o;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...N){return String(N.reduce((C,U)=>C|U,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class w{constructor(C=h){this.state=C}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(C,U=this.state.pageSize){return new w({...this.state,pageNumber:C,pageSize:U})}withFilter(C,...U){const $=[...this.state.criteria,...U.length?U.map(G=>({filterType:C,value:G})):[{filterType:C}]];return new w({...this.state,criteria:$})}withSortBy(C){return new w({...this.state,sortBy:C})}withSortOrder(C){return new w({...this.state,sortOrder:C})}withFlags(...C){return new w({...this.state,flags:C.reduce((U,$)=>U|$,0)})}withAssetTypes(...C){return new w({...this.state,assetTypes:C})}withSource(C){return new w({...this.state,source:C})}get raw(){const{criteria:C,pageNumber:U,pageSize:$,sortBy:G,sortOrder:W,flags:Z,assetTypes:te}=this.state;return{filters:[{criteria:C,pageNumber:U,pageSize:$,sortBy:G,sortOrder:W}],assetTypes:te,flags:Z}}get searchText(){const C=this.state.criteria.filter(U=>U.filterType===t.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(C=>String(C.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function S(N,C){const U=(N||[]).filter($=>$.statisticName===C)[0];return U?U.value:0}function D(N){const C="Microsoft.VisualStudio.Code.Translation.";return N.files.filter($=>$.assetType.indexOf(C)===0).reduce(($,G)=>{const W=x(N,G.assetType);return W&&$.push([G.assetType.substring(C.length),W]),$},[])}function T(N){if(N.properties){const C=N.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),$=C.filter(G=>U.test(G.value))[0];return $?{uri:$.value,fallbackUri:$.value}:null}return x(N,r.Repository)}function M(N){return{uri:`${N.fallbackAssetUri}/${r.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${r.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function x(N,C){return N.files.filter($=>$.assetType===C)[0]?{uri:`${N.assetUri}/${C}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${C}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function V(N,C){const U=N.properties?N.properties.filter(G=>G.key===C):[],$=U.length>0&&U[0].value;return $?$.split(",").map(G=>(0,m.adoptToGalleryExtensionId)(G)):[]}function q(N){const C=N.properties?N.properties.filter(U=>U.key===s.Engine):[];return C.length>0&&C[0].value||""}function z(N){const C=N.properties?N.properties.filter(U=>U.key===s.PreRelease):[];return C.length>0&&C[0].value==="true"}function J(N){const C=N.properties?N.properties.filter($=>$.key===s.LocalizedLanguages):[],U=C.length>0&&C[0].value||"";return U?U.split(","):[]}function Q(N){return N.properties?.find(C=>C.key===s.SponsorLink)?.value}function K(N){return N.indexOf("preview")!==-1}function X(N){return N.targetPlatform?(0,E.toTargetPlatform)(N.targetPlatform):"undefined"}function j(N){const C=(0,L.distinct)(N.versions.map(X)),U=!!N.tags?.includes(E.WEB_EXTENSION_TAG),$=C.indexOf("web");return U?$===-1&&C.push("web"):$!==-1&&C.splice($,1),C}function F(N,C){const U=(0,E.getFallbackTargetPlarforms)(C);for(let $=0;$<N.length;$++){const G=N[$];if(G.version===N[$-1]?.version){let W=$;const Z=X(G);if(Z===C)for(;W>0&&N[W-1].version===G.version;)W--;else if(U.includes(Z))for(;W>0&&N[W-1].version===G.version&&X(N[W-1])!==C;)W--;W!==$&&(N.splice($,1),N.splice(W,0,G))}}return N}e.sortExtensionVersions=F;function ee(N,C,U){N.telemetryData={index:C,querySource:U,queryActivityId:N.queryContext?.[i]}}function ne(N,C,U,$){const G=N.versions[0],W={manifest:x(C,r.Manifest),readme:x(C,r.Details),changelog:x(C,r.Changelog),license:x(C,r.License),repository:T(C),download:M(C),icon:x(C,r.Icon),signature:x(C,r.Signature),coreTranslations:D(C)};return{identifier:{id:(0,m.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:C.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(G),description:N.shortDescription||"",installCount:S(N.statistics,"install"),rating:S(N.statistics,"averagerating"),ratingCount:S(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:U,assets:W,properties:{dependencies:V(C,s.Dependency),extensionPack:V(C,s.ExtensionPack),engine:q(C),localizedLanguages:J(C),targetPlatform:X(C),isPreReleaseVersion:z(C)},hasPreReleaseVersion:z(G),hasReleaseVersion:!0,preview:K(N.flags),isSigned:!!W.signature,queryContext:$}}let se=class{constructor(C,U,$,G,W,Z,te,ce){this.requestService=U,this.logService=$,this.environmentService=G,this.telemetryService=W,this.fileService=Z,this.productService=te,this.configurationService=ce;const he=te.extensionsGallery,pe=he?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=pe?he.servicePPEUrl:he?.serviceUrl,this.extensionsGallerySearchUrl=pe?void 0:he?.searchUrl,this.extensionsControlUrl=he?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(te.version,te,this.environmentService,this.configurationService,this.fileService,C,this.telemetryService)}api(C=""){return`${this.extensionsGalleryUrl}${C}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(C,U,$){const G=O.CancellationToken.isCancellationToken(U)?{}:U,W=O.CancellationToken.isCancellationToken(U)?U:$,Z=[],te=[],ce=[],he=[];let pe=!0;for(const Ce of C){Ce.uuid?te.push(Ce.uuid):Z.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);ce.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),pe=pe&&!!Ce.hasPreRelease&&!Re}if(!te.length&&!Z.length)return[];let fe=new w().withPage(1,C.length);te.length&&(fe=fe.withFilter(t.ExtensionId,...te)),Z.length&&(fe=fe.withFilter(t.ExtensionName,...Z)),(G.queryAllVersions||pe)&&(fe=fe.withFlags(fe.flags,o.IncludeVersions)),G.source&&(fe=fe.withSource(G.source));const{extensions:ye}=await this.queryGalleryExtensions(fe,{targetPlatform:G.targetPlatform??k,includePreRelease:ce,versions:he,compatible:!!G.compatible},W);return G.source&&ye.forEach((Ce,Re)=>ee(Ce,Re,G.source)),ye}async getCompatibleExtension(C,U,$){if((0,E.isNotWebExtensionInWebTargetPlatform)(C.allTargetPlatforms,$))return null;if(await this.isExtensionCompatible(C,U,$))return C;const G=new w().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,C.identifier.uuid),{extensions:W}=await this.queryGalleryExtensions(G,{targetPlatform:$,compatible:!0,includePreRelease:U},O.CancellationToken.None);return W[0]||null}async isExtensionCompatible(C,U,$){if(!(0,E.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,$)||!U&&C.properties.isPreReleaseVersion)return!1;let G=C.properties.engine;if(!G){const W=await this.getManifest(C,O.CancellationToken.None);if(!W)throw new Error("Manifest was not found");G=W.engines.vscode}return(0,f.isEngineValid)(G,this.productService.version,this.productService.date)}async isValidVersion(C,U,$,G,W){if(!(0,E.isTargetPlatformCompatible)(X(C),G,W)||U!=="any"&&z(C)!==(U==="prerelease"))return!1;if($)try{const Z=await this.getEngine(C);if(!(0,f.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${C.version}.`,(0,l.getErrorMessage)(Z)),!1}return!0}async query(C,U){let $=C.text||"";const G=C.pageSize??50;let W=new w().withPage(1,G);$?($=$.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,fe,ye)=>(W=W.withFilter(t.Category,ye||fe),"")),$=$.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,fe,ye)=>(W=W.withFilter(t.Tag,ye||fe),"")),$=$.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),$=$.trim(),$&&($=$.length<200?$:$.substring(0,200),W=W.withFilter(t.SearchText,$)),W=W.withSortBy(0)):C.ids?W=W.withFilter(t.ExtensionId,...C.ids):C.names?W=W.withFilter(t.ExtensionName,...C.names):W=W.withSortBy(4),typeof C.sortBy=="number"&&(W=W.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(W=W.withSortOrder(C.sortOrder)),C.source&&(W=W.withSource(C.source));const Z=async(pe,fe)=>{const{extensions:ye,total:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:k,compatible:!1,includePreRelease:!!C.includePreRelease},fe);return ye.forEach((Re,ke)=>ee(Re,(pe.pageNumber-1)*pe.pageSize+ke,C.source)),{extensions:ye,total:Ce}},{extensions:te,total:ce}=await Z(W,U),he=async(pe,fe)=>{if(fe.isCancellationRequested)throw new l.CancellationError;const{extensions:ye}=await Z(W.withPage(pe+1),fe);return ye};return{firstPage:te,total:ce,pageSize:W.pageSize,getPage:he}}async queryGalleryExtensions(C,U,$){const G=C.flags;!!(C.flags&o.IncludeLatestVersionOnly)&&!!(C.flags&o.IncludeVersions)&&(C=C.withFlags(C.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(C.flags&o.IncludeLatestVersionOnly)&&!(C.flags&o.IncludeVersions)&&(C=C.withFlags(C.flags,o.IncludeLatestVersionOnly)),U.versions?.length&&(C=C.withFlags(C.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),C=C.withFlags(C.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:W,total:Z,context:te}=await this.queryRawGalleryExtensions(C,$);if(!(C.flags&o.IncludeLatestVersionOnly)){const fe=[];for(const ye of W){const Ce=await this.toGalleryExtensionWithCriteria(ye,U,te);Ce&&fe.push(Ce)}return{extensions:fe,total:Z}}const he=[],pe=new Map;for(let fe=0;fe<W.length;fe++){const ye=W[fe],Ce={id:(0,m.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Re=(0,R.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ze=>(0,m.areSameExtensions)(ze,Ce))?.includePreRelease;if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(j(ye),U.targetPlatform))continue;const ke=await this.toGalleryExtensionWithCriteria(ye,U,te);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?pe.set(ye.extensionId,fe):he.push([fe,ke])}if(pe.size){const fe=new Date().getTime(),ye=new w().withFlags(G&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,pe.size).withFilter(t.ExtensionId,...pe.keys()),{extensions:Ce}=await this.queryGalleryExtensions(ye,U,$);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-fe,count:pe.size});for(const Re of Ce){const ke=pe.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((fe,ye)=>fe[0]-ye[0]).map(([,fe])=>fe),total:Z}}async toGalleryExtensionWithCriteria(C,U,$){const G={id:(0,m.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},W=U.versions?.find(he=>(0,m.areSameExtensions)(he,G))?.version,Z=(0,R.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(he=>(0,m.areSameExtensions)(he,G))?.includePreRelease,te=j(C),ce=F(C.versions,U.targetPlatform);if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(te,U.targetPlatform))return null;for(let he=0;he<ce.length;he++){const pe=ce[he];if(!(W&&pe.version!==W)){if(await this.isValidVersion(pe,Z?"any":"release",U.compatible,te,U.targetPlatform))return ne(C,pe,te,$);if(W&&pe.version===W)return null}}return W||U.compatible?null:ne(C,C.versions[0],te)}async queryRawGalleryExtensions(C,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(o.Unpublished));const $=await this.commonHeadersPromise,G=JSON.stringify(C.raw),W={...$,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},Z=new Date().getTime();let te,ce,he=0;try{if(te=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&C.criteria.some(fe=>fe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:G,headers:W},U),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const pe=await(0,d.asJson)(te);if(pe){const fe=pe.results[0],ye=fe.extensions,Ce=fe.resultMetadata&&fe.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:he,context:{[i]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(pe){throw ce=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-Z,success:!!te&&(0,d.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:ce?(0,l.isCancellationError)(ce)?"canceled":(0,l.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(C,U,$,G){if(!this.isEnabled())return;const W=A.isWeb?this.api(`/itemName/${C}.${U}/version/${$}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${C}/extensions/${U}/${$}/stats?statType=${G}`),Z=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:W,headers:ce},O.CancellationToken.None)}catch{}}async download(C,U,$){this.logService.trace("ExtensionGalleryService#download",C.identifier.id);const G=(0,m.getGalleryExtensionTelemetryData)(C),W=new Date().getTime(),Z=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:fe}),te=$===2?"install":$===3?"update":"",ce=te?{uri:`${C.assets.download.uri}${P.URI.parse(C.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${C.assets.download.fallbackUri}${P.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:C.assets.download,he=C.queryContext?.[i]?{[i]:C.queryContext[i]}:void 0,pe=await this.getAsset(ce,he?{headers:he}:void 0);await this.fileService.writeFile(U,pe.stream),Z(new Date().getTime()-W)}async downloadSignatureArchive(C,U){if(!C.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const $=await this.getAsset(C.assets.signature);await this.fileService.writeFile(U,$.stream)}async getReadme(C,U){if(C.assets.readme){const $=await this.getAsset(C.assets.readme,{},U);return await(0,d.asTextOrError)($)||""}return""}async getManifest(C,U){if(C.assets.manifest){const $=await this.getAsset(C.assets.manifest,{},U),G=await(0,d.asTextOrError)($);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(C,U){const $=x(C,r.Manifest);if(!$)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},W=await this.getAsset($,{headers:G});return await(0,d.asJson)(W)}async getCoreTranslation(C,U){const $=C.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if($){const G=await this.getAsset($[1]),W=await(0,d.asTextOrError)(G);return W?JSON.parse(W):null}return null}async getChangelog(C,U){if(C.assets.changelog){const $=await this.getAsset(C.assets.changelog,{},U);return await(0,d.asTextOrError)($)||""}return""}async getAllCompatibleVersions(C,U,$){let G=new w().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);C.identifier.uuid?G=G.withFilter(t.ExtensionId,C.identifier.uuid):G=G.withFilter(t.ExtensionName,C.identifier.id);const{galleryExtensions:W}=await this.queryRawGalleryExtensions(G,O.CancellationToken.None);if(!W.length)return[];const Z=j(W[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(Z,$))return[];const te=[];await Promise.all(W[0].versions.map(async pe=>{try{await this.isValidVersion(pe,U?"any":"release",!0,Z,$)&&te.push(pe)}catch{}}));const ce=[],he=new Set;for(const pe of F(te,$))he.has(pe.version)||(he.add(pe.version),ce.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:z(pe)}));return ce}async getAsset(C,U={},$=O.CancellationToken.None){const G=await this.commonHeadersPromise,W={type:"GET"},Z={...G,...U.headers||{}};U={...U,...W,headers:Z};const te=C.uri,ce=C.fallbackUri,he={...U,url:te};try{const pe=await this.requestService.request(he,$);if(pe.res.statusCode===200)return pe;const fe=await(0,d.asTextOrError)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${fe}`)}catch(pe){if((0,l.isCancellationError)(pe))throw pe;const fe=(0,l.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:te,message:fe});const ye={...U,url:ce};return this.requestService.request(ye,$)}}async getEngine(C){let U=q(C);if(!U){const $=await this.getManifestFromRawExtensionVersion(C,O.CancellationToken.None);if(!$)throw new Error("Manifest was not found");U=$.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const C=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,d.asJson)(C),$=[],G={};if(U){for(const W of U.malicious)$.push({id:W});if(U.migrateToPreRelease)for(const[W,Z]of Object.entries(U.migrateToPreRelease))(!Z.engine||(0,f.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(G[W.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[W,Z]of Object.entries(U.deprecated))Z&&(G[W.toLowerCase()]=(0,R.isBoolean)(Z)?{}:Z)}return{malicious:$,deprecated:G}}};se=ve([Y(1,d.IRequestService),Y(2,b.ILogService),Y(3,I.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,p.IFileService),Y(6,c.IProductService),Y(7,y.IConfigurationService)],se);let H=class extends se{constructor(C,U,$,G,W,Z,te,ce){super(C,U,$,G,W,Z,te,ce)}};H=ve([Y(0,g.IStorageService),Y(1,d.IRequestService),Y(2,b.ILogService),Y(3,I.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,p.IFileService),Y(6,c.IProductService),Y(7,y.IConfigurationService)],H),e.ExtensionGalleryService=H;let B=class extends se{constructor(C,U,$,G,W,Z,te){super(void 0,C,U,$,G,W,Z,te)}};B=ve([Y(0,d.IRequestService),Y(1,b.ILogService),Y(2,I.IEnvironmentService),Y(3,v.ITelemetryService),Y(4,p.IFileService),Y(5,c.IProductService),Y(6,y.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(oe[79],ae([0,1,5,3,2,20,33,26,21,9,11]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Je extends l.Disposable{static toKey(p){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const b=E.exec(p);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(p,b){const c=await p.getInstalled(),d=[];for(const[u,g]of Je.readAllExtensionsWithKeysForSync(b)){const v=c.find(k=>(0,_.areSameExtensions)(k.identifier,{id:u}))?.manifest.version;for(const k of g)v!==k&&d.push(Je.toKey({id:u,version:k}))}for(const u of d)b.remove(u,0)}static readAllExtensionsWithKeysForSync(p){const b=new Map,c=p.keys(0,1);for(const d of c){const u=Je.fromKey(d);if(u){let g=b.get(u.id.toLowerCase());g||b.set(u.id.toLowerCase(),g=[]),g.push(u.version)}}return b}constructor(p,b,c){super(),this.storageService=p,this.productService=b,this.logService=c,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(p){if(p.scope!==0)return;if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const b=Je.fromKey(p.key);if(b){if(this.storageService.get(p.key,0)===void 0)this.extensionsWithKeysForSync.delete(b.id.toLowerCase());else{let c=this.extensionsWithKeysForSync.get(b.id.toLowerCase());c||this.extensionsWithKeysForSync.set(b.id.toLowerCase(),c=[]),c.push(b.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,I.isString)(p))return p;const b=p.manifest?p.manifest.publisher:p.publisher,c=p.manifest?p.manifest.name:p.name;return(0,_.getExtensionId)(b,c)}getExtensionState(p,b){const c=this.getExtensionId(p),d=this.getExtensionStateRaw(p,b);if(d)try{return JSON.parse(d)}catch(u){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${b}): ${u}`)}}getExtensionStateRaw(p,b){const c=this.getExtensionId(p),d=this.storageService.get(c,b?0:1);return d&&d?.length>Je.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${b}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(p,b,c){const d=this.getExtensionId(p);b===void 0?this.storageService.remove(d,c?0:1):this.storageService.store(d,JSON.stringify(b),c?0:1,1)}setKeysForSync(p,b){this.storageService.store(Je.toKey(p),JSON.stringify(b),0,1)}getKeysForSync(p){const b=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],c=this.storageService.get(Je.toKey(p),0),d=c?JSON.parse(c):void 0;return d&&b?(0,P.distinct)([...d,...b]):d||b}addToMigrationList(p,b){if(p!==b){const c=this.migrationList.filter(d=>!d.includes(p)&&!d.includes(b));c.push([p,b]),this.migrationList=c}}getSourceExtensionToMigrate(p){const b=this.migrationList.find(([,c])=>p===c);return b?b[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const b=JSON.parse(p);if(Array.isArray(b))return b}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m.LARGE_STATE_WARNING_THRESHOLD=512*1024,m=ve([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,y.ILogService)],m),e.ExtensionStorageService=m}),define(oe[274],ae([0,1,29,13,26,15,102,57,20,19,237]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let E=class extends I.AbstractNativeExtensionTipsService{constructor(f,p,b,c,d,u,g,v){super(f.userHome,d,p,b,c,u,g,v)}};E=ve([Y(0,A.INativeEnvironmentService),Y(1,y.ITelemetryService),Y(2,L.IExtensionManagementService),Y(3,P.IStorageService),Y(4,R.INativeHostService),Y(5,_.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,l.IProductService)],E),e.ExtensionTipsService=E}),define(oe[275],ae([0,1,6,2,23,66,20,75,18]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class y extends _.AbstractStorageService{constructor(E,m,f,p){super(),this.initialWorkspace=E,this.initialProfiles=m,this.remoteService=f,this.environmentService=p,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new R.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),m=this._register(new A.Storage(E));return this._register(m.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f))),m}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let m;if((0,_.isProfileUsingDefaultStorage)(E))m=this.applicationStorage;else{const f=this.profileStorageDisposables.add(new R.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),E));m=this.profileStorageDisposables.add(new A.Storage(f))}return this.profileStorageDisposables.add(m.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),m}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let m;if(E){const f=this.workspaceStorageDisposables.add(new R.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),E));m=this.workspaceStorageDisposables.add(new A.Storage(f)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)))}return m}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,l.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(_.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,m){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const f=this.profileStorage,p=f.items;f!==this.applicationStorage&&await f.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(p,this.profileStorage,0,m)}async switchToWorkspace(E,m){const f=this.workspaceStorage,p=f?.items??new Map;await f?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(p,this.workspaceStorage,1,m)}hasScope(E){return(0,P.isUserDataProfile)(E)?this.profileStorageProfile.id===E.id:this.workspaceStorageId===E.id}}e.RemoteStorageService=y}),define(oe[276],ae([0,1,3,2,18,93]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(y,I){this.service=y,this.getUriTransformer=I}listen(y,I){const E=this.getUriTransformer(y);switch(I){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,A.transformOutgoingURIs)({...f},E)),added:m.added.map(f=>(0,A.transformOutgoingURIs)({...f},E)),removed:m.removed.map(f=>(0,A.transformOutgoingURIs)({...f},E)),updated:m.updated.map(f=>(0,A.transformOutgoingURIs)({...f},E))}))}throw new Error(`Invalid listen ${I}`)}async call(y,I,E){const m=this.getUriTransformer(y);switch(I){case"createProfile":{const f=await this.service.createProfile(E[0],E[1],E[2]);return(0,A.transformOutgoingURIs)({...f},m)}case"updateProfile":{let f=(0,l.reviveProfile)((0,A.transformIncomingURIs)(E[0],m),this.service.profilesHome.scheme);return f=await this.service.updateProfile(f,E[1]),(0,A.transformOutgoingURIs)({...f},m)}case"removeProfile":{const f=(0,l.reviveProfile)((0,A.transformIncomingURIs)(E[0],m),this.service.profilesHome.scheme);return this.service.removeProfile(f)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=_;class R extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(y,I,E){super(),this.profilesHome=I,this.channel=E,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=y.map(m=>(0,l.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const f=m.added.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),p=m.removed.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),b=m.updated.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme));this._profiles=m.all.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:p,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(y){this.enabled=y}isEnabled(){return this.enabled}async createNamedProfile(y,I,E){const m=await this.channel.call("createNamedProfile",[y,I,E]);return(0,l.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(y,I,E,m){const f=await this.channel.call("createProfile",[y,I,E,m]);return(0,l.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(y){const I=await this.channel.call("createTransientProfile",[y]);return(0,l.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(y,I){await this.channel.call("setProfileForWorkspace",[y,I])}removeProfile(y){return this.channel.call("removeProfile",[y])}async updateProfile(y,I){const E=await this.channel.call("updateProfile",[y,I]);return(0,l.reviveProfile)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(oe[61],ae([0,1,2,66,5,20,3,75,18]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let y=class extends L.Disposable{constructor(f){super(),this.storageService=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async p=>this.getItems(p))}async updateStorageData(f,p,b){return this.withProfileScopedStorageService(f,async c=>this.writeItems(c,p,b))}async withProfileScopedStorageService(f,p){if(this.storageService.hasScope(f))return p(this.storageService);const b=await this.createStorageDatabase(f),c=new E(b);try{await c.initialize();const d=await p(c);return await c.flush(),d}finally{c.dispose(),await this.closeAndDispose(b)}}getItems(f){const p=new Map,b=c=>{for(const d of f.keys(0,c))p.set(d,{value:f.get(d,0),target:c})};return b(0),b(1),p}writeItems(f,p,b){for(const[c,d]of p)f.store(c,d,0,b)}async closeAndDispose(f){try{await f.close()}finally{(0,L.isDisposable)(f)&&f.dispose()}}};y=ve([Y(0,A.IStorageService)],y),e.AbstractUserDataProfileStorageService=y;class I extends y{constructor(f,p,b,c){super(b),this.remoteService=f;const d=f.getChannel("profileStorageListener"),u=this._register(new L.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{u.value=d.listen("onDidChange")(g=>{c.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(v=>(0,P.reviveProfile)(v,p.profilesHome.scheme)),valueChanges:g.valueChanges.map(v=>({...v,profile:(0,P.reviveProfile)(v.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(f){const p=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(f)?new R.ApplicationStorageDatabaseClient(p):new R.ProfileStorageDatabaseClient(p,f)}}e.RemoteUserDataProfileStorageService=I;class E extends A.AbstractStorageService{constructor(f){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(f))}doInitialize(){return this.profileStorage.init()}getStorage(f){return f===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(oe[277],ae([0,1,20,9,18,71,61]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends _.RemoteUserDataProfileStorageService{constructor(y,I,E,m){super(y,I,E,m)}};R=ve([Y(0,A.IMainProcessService),Y(1,l.IUserDataProfilesService),Y(2,L.IStorageService),Y(3,O.ILogService)],R),e.NativeUserDataProfileStorageService=R}),define(oe[41],ae([0,1,21,6,16,25,3,35,2,27,11,183,17,15,13,9,44,20,19,30,24,18]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||o(h.syncData)))}e.isRemoteUserData=i;function o(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=o;function n(h,w){return`${(0,y.uppercaseFirstLetter)(h)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=n;let t=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(w,S,D,T,M,x,V,q,z,J,Q,K){super(),this.syncResource=w,this.collection=S,this.fileService=D,this.environmentService=T,this.storageService=M,this.userDataSyncStoreService=x,this.userDataSyncBackupStoreService=V,this.userDataSyncEnablementService=q,this.telemetryService=z,this.logService=J,this.configurationService=Q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new O.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(w.syncResource,w.profile),this.extUri=K.extUri,this.syncFolder=this.extUri.joinPath(T.userDataSyncHome,...(0,v.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,v.PREVIEW_DIR_NAME),this.lastSyncResource=(0,v.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,T,this.extUri),this.currentMachineIdPromise=(0,c.getServiceMachineId)(T,D,M)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const w=await this.syncPreviewPromise;this.syncPreviewPromise=null;const S=await this.performSync(w.remoteUserData,w.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(S)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.hasRemoteChanged(w):!0)&&this._onDidChangeLocal.fire()}}setStatus(w){this._status!==w&&(this._status=w,this._onDidChangStatus.fire(w))}async sync(w,S={}){await this._sync(w,!0,this.getUserDataSyncConfiguration(),S)}async preview(w,S,D={}){return this._sync(w,!1,S,D)}async apply(w,S={}){try{this.syncHeaders={...S};const D=await this.doApply(w);return this.setStatus(D),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(w,S,D,T){try{if(this.syncHeaders={...T},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let M="idle";try{const x=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(w,x);return M=await this.performSync(V,x,S,D),M==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(M)}}finally{this.syncHeaders={}}}async replace(w){const S=this.parseSyncData(w);if(!S)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const D=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,D),M=await this.isRemoteDataFromCurrentMachine(T),x=await this.generateSyncPreview({ref:T.ref,syncData:S},D,M,this.getUserDataSyncConfiguration(),A.CancellationToken.None),V=[];for(const q of x){const z=await this.getAcceptResult(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(q,q.previewResource,q.remoteContent,A.CancellationToken.None);V.push([q,{...z,remoteChange:J!==0?J:2}])}await this.applyResult(T,D,V,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(w){const S=await this.currentMachineIdPromise;return!!w.syncData?.machineId&&w.syncData.machineId===S}async getLatestRemoteUserData(w,S){if(S){const D=w?w[this.resource]:void 0;if(S.ref===D||D===void 0&&S.syncData===null)return S}return this.getRemoteUserData(S)}async performSync(w,S,D,T){if(w.syncData&&w.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(w,S,D,T)}catch(M){if(M instanceof v.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(w,S,D,T);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),S=await this.getLastSyncUserData(),this.performSync(w,S,D,T)}throw M}}async doSync(w,S,D,T){try{const M=await this.isRemoteDataFromCurrentMachine(w),x=!M&&S===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,V=D&&!x;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(z=>this.doGenerateSyncResourcePreview(w,S,M,V,T,z)));let q=await this.syncPreviewPromise;if(D&&x){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of q.resourcePreviews)q=await this.accept(z.remoteResource)||q}return this.updateConflicts(q.resourcePreviews),q.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":D?await this.doApply(!1):"syncing"}catch(M){throw this.syncPreviewPromise=null,M}}async merge(w){return await this.updateSyncResourcePreview(w,async S=>{const D=await this.getMergeResult(S,A.CancellationToken.None);await this.fileService.writeFile(S.previewResource,l.VSBuffer.fromString(D?.content||""));const T=D&&!D.hasConflicts?await this.getAcceptResult(S,S.previewResource,void 0,A.CancellationToken.None):void 0;return S.acceptResult=T,S.mergeState=D.hasConflicts?"conflict":T?"accepted":"preview",S.localChange=T?T.localChange:D.localChange,S.remoteChange=T?T.remoteChange:D.remoteChange,S}),this.syncPreviewPromise}async accept(w,S){return await this.updateSyncResourcePreview(w,async D=>{const T=await this.getAcceptResult(D,w,S,A.CancellationToken.None);return D.acceptResult=T,D.mergeState="accepted",D.localChange=T.localChange,D.remoteChange=T.remoteChange,D}),this.syncPreviewPromise}async discard(w){return await this.updateSyncResourcePreview(w,async S=>{const D=await this.getMergeResult(S,A.CancellationToken.None);return await this.fileService.writeFile(S.previewResource,l.VSBuffer.fromString(D.content||"")),S.acceptResult=void 0,S.mergeState="preview",S.localChange=D.localChange,S.remoteChange=D.remoteChange,S}),this.syncPreviewPromise}async updateSyncResourcePreview(w,S){if(!this.syncPreviewPromise)return;let D=await this.syncPreviewPromise;const T=D.resourcePreviews.findIndex(({localResource:M,remoteResource:x,previewResource:V})=>this.extUri.isEqual(M,w)||this.extUri.isEqual(x,w)||this.extUri.isEqual(V,w));T!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async M=>{const x=[...D.resourcePreviews];return x[T]=await S(x[T]),{...D,resourcePreviews:x}}),D=await this.syncPreviewPromise,this.updateConflicts(D.resourcePreviews),D.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(w){if(!this.syncPreviewPromise)return"idle";const S=await this.syncPreviewPromise;return S.resourcePreviews.some(({mergeState:D})=>D==="conflict")?"hasConflicts":S.resourcePreviews.some(({mergeState:D})=>D!=="accepted")?"syncing":(await this.applyResult(S.remoteUserData,S.lastSyncUserData,S.resourcePreviews.map(D=>[D,D.acceptResult]),w),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(w){const S=w.filter(({mergeState:D})=>D==="conflict");(0,L.equals)(this._conflicts,S,(D,T)=>this.extUri.isEqual(D.previewResource,T.previewResource))||(this._conflicts=S,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async resolvePreviewContent(w){const S=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(S)for(const D of S.resourcePreviews){if(this.extUri.isEqual(D.acceptedResource,w))return D.acceptResult?D.acceptResult.content:null;if(this.extUri.isEqual(D.remoteResource,w))return D.remoteContent;if(this.extUri.isEqual(D.localResource,w))return D.localContent;if(this.extUri.isEqual(D.baseResource,w))return D.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(w){(0,p.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async doGenerateSyncResourcePreview(w,S,D,T,M,x){const V=await this.generateSyncPreview(w,S,D,M,x),q=[];for(const z of V){const J=z.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)q.push({...z,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=T?await this.getMergeResult(z,x):void 0;if(x.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,l.VSBuffer.fromString(Q?.content||""));const K=Q&&!Q.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,x):void 0;q.push({...z,acceptResult:K,mergeState:Q?.hasConflicts?"conflict":K?"accepted":"preview",localChange:K?K.localChange:Q?Q.localChange:z.localChange,remoteChange:K?K.remoteChange:Q?Q.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:S,resourcePreviews:q,isLastSyncFromCurrentMachine:D}}async getLastSyncUserData(){let w=this.getStoredLastSyncUserDataStateContent();if(w||(w=await this.migrateLastSyncUserData()),!w)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const S=JSON.parse(w),D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!S.version&&!!D&&S.version!==D,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${S.version} is not compatible with current sync state version ${D}.`),await this.resetLocal(),null;let T,M=1;for(;T===void 0&&M++<6;)try{const x=await this.readLastSyncStoredRemoteUserData();x&&(x.ref===S.ref?T=x.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(x){if(x instanceof p.FileOperationError&&x.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(x instanceof v.UserDataSyncError)throw x;this.logService.error(x,M)}}if(T===void 0)try{const x=await this.userDataSyncStoreService.resolveResourceContent(this.resource,S.ref,this.collection,this.syncHeaders);T=x===null?null:this.parseSyncData(x),await this.writeLastSyncStoredRemoteUserData({ref:S.ref,syncData:T})}catch(x){if(x instanceof v.UserDataSyncError&&x.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw x}return T===void 0?null:{...S,syncData:T}}async updateLastSyncUserData(w,S={}){if(S.ref||S.version)throw new Error("Cannot have core properties as additional");const D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),T={ref:w.ref,version:D,...S};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(T),-1,1),await this.writeLastSyncStoredRemoteUserData(w)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const w=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const S=w?JSON.parse(w):void 0;if(i(S))return S}catch(S){this.logService.error(S)}}async writeLastSyncStoredRemoteUserData(w){await this.fileService.writeFile(this.lastSyncResource,l.VSBuffer.fromString(JSON.stringify(w)))}async migrateLastSyncUserData(){try{const w=await this.fileService.readFile(this.lastSyncResource),S=JSON.parse(w.value.toString());await this.fileService.del(this.lastSyncResource),S.ref&&S.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...S,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:S.ref,syncData:S.content===null?null:JSON.parse(S.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,S)}catch(w){w instanceof p.FileOperationError&&w.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(w)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(w){const{ref:S,content:D}=await this.getUserData(w);let T=null;return D!==null&&(T=this.parseSyncData(D)),{ref:S,syncData:T}}parseSyncData(w){try{const S=JSON.parse(w);if(o(S))return S}catch(S){this.logService.error(S)}throw new v.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(w){const S=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,S,this.collection,this.syncHeaders)}async updateRemoteUserData(w,S){const D=await this.currentMachineIdPromise,T={version:this.version,machineId:D,content:w};try{return S=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(T),S,this.collection,this.syncHeaders),{ref:S,syncData:T}}catch(M){throw M instanceof v.UserDataSyncError&&M.code==="TooLarge"&&(M=new v.UserDataSyncError(M.message,M.code,this.resource)),M}}async backupLocal(w){const S={version:this.version,content:w};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(S))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ve([Y(2,p.IFileService),Y(3,f.IEnvironmentService),Y(4,d.IStorageService),Y(5,v.IUserDataSyncStoreService),Y(6,v.IUserDataSyncBackupStoreService),Y(7,v.IUserDataSyncEnablementService),Y(8,u.ITelemetryService),Y(9,v.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,g.IUriIdentityService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(w,S,D,T,M,x,V,q,z,J,Q,K,X){super(S,D,T,M,x,V,q,z,J,Q,K,X),this.file=w,this._register(this.fileService.watch(this.extUri.dirname(w))),this._register(this.fileService.onDidFilesChange(j=>this.onFileChanges(j)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(w,S,D){try{S?await this.fileService.writeFile(this.file,l.VSBuffer.fromString(w),D?void 0:S):await this.fileService.createFile(this.file,l.VSBuffer.fromString(w),{overwrite:D})}catch(T){throw T instanceof p.FileOperationError&&T.fileOperationResult===1||T instanceof p.FileOperationError&&T.fileOperationResult===3?new v.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(w){if(!(w instanceof p.FileOperationError&&w.fileOperationResult===1))throw w}}onFileChanges(w){!w.contains(this.file)||this.triggerLocalChange()}};r=ve([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,d.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,g.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let s=class extends r{constructor(w,S,D,T,M,x,V,q,z,J,Q,K,X,j){super(w,S,D,T,M,x,V,q,z,J,Q,X,j),this.userDataSyncUtilService=K,this._formattingOptions=void 0}hasErrors(w,S){const D=[],T=(0,R.parse)(w,D,{allowEmptyContent:!0,allowTrailingComma:!0});return D.length>0||!(0,I.isUndefined)(T)&&S!==Array.isArray(T)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=ve([Y(3,p.IFileService),Y(4,f.IEnvironmentService),Y(5,d.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,v.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,g.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let a=class{constructor(w,S,D,T,M,x,V){this.resource=w,this.userDataProfilesService=S,this.environmentService=D,this.logService=T,this.fileService=M,this.storageService=x,this.extUri=V.extUri,this.lastSyncResource=(0,v.getLastSyncResourceUri)(void 0,this.resource,D,this.extUri)}async initialize({ref:w,content:S}){if(!S){this.logService.info("Remote content does not exist.",this.resource);return}const D=this.parseSyncData(S);if(!!D)try{await this.doInitialize({ref:w,syncData:D})}catch(T){this.logService.error(T)}}parseSyncData(w){try{const S=JSON.parse(w);if(o(S))return S}catch(S){this.logService.error(S)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(w,S={}){if(S.ref||S.version)throw new Error("Cannot have core properties as additional");const D={ref:w.ref,version:void 0,...S};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(D),-1,1),await this.fileService.writeFile(this.lastSyncResource,l.VSBuffer.fromString(JSON.stringify(w)))}};a=ve([Y(1,k.IUserDataProfilesService),Y(2,f.IEnvironmentService),Y(3,b.ILogService),Y(4,p.IFileService),Y(5,d.IStorageService),Y(6,g.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[122],ae([0,1,6,25,10,3,42,2,27,17,15,121,29,33,79,13,5,70,9,20,19,30,18,41,258,119,24,61]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o,n,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(M,x){const V=JSON.parse(M.content);if(M.version===1||M.version===2){const q=(await x.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of V)M.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),M.version===2&&q.every(J=>!(0,f.areSameExtensions)(J.identifier,z.identifier))&&(z.installed=!0)}return V}function h(M){return JSON.parse(M.content)}e.parseExtensions=h;function w(M,x){return M.sort((V,q)=>!V.identifier.uuid&&q.identifier.uuid?-1:V.identifier.uuid&&!q.identifier.uuid?1:(0,P.compare)(V.identifier.id,q.identifier.id)),x?(0,_.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=w;let S=class extends o.AbstractSynchroniser{constructor(x,V,q,z,J,Q,K,X,j,F,ee,ne,se,H,B,N,C){super({syncResource:"extensions",profile:x},V,z,q,J,Q,K,ne,se,F,ee,B),this.extensionManagementService=X,this.ignoredExtensionsManagementService=j,this.instantiationService=C,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(D),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:$})=>!!$)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),A.Event.filter(N.onDidChange,U=>U.valueChanges.some(({profile:$,changes:G})=>this.syncResource.profile.id===$.id&&G.some(W=>W.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),H.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(x,V){const q=x.syncData?await a(x.syncData,this.extensionManagementService):null,z=V?.skippedExtensions??[],J=V?.builtinExtensions??null,Q=V?.syncData?await a(V.syncData,this.extensionManagementService):null,{localExtensions:K,ignoredExtensions:X}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:F}=(0,n.merge)(K,q,Q,z,X,J),ee={local:j,remote:F,content:this.getPreviewContent(K,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:F!==null?2:0},ne=this.stringify(K,!1);return[{skippedExtensions:z,builtinExtensions:J,baseResource:this.baseResource,baseContent:Q?this.stringify(Q,!1):ne,localResource:this.localResource,localContent:ne,localExtensions:K,remoteResource:this.remoteResource,remoteExtensions:q,remoteContent:q?this.stringify(q,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(x){const V=x.syncData?await a(x.syncData,this.extensionManagementService):null,{localExtensions:q,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:J}=(0,n.merge)(q,V,V,x.skippedExtensions||[],z,x.builtinExtensions||[]);return J!==null}getPreviewContent(x,V,q,z){const J=[...V,...q],Q=new Set,K=X=>{Q.add(X.id.toLowerCase()),X.uuid&&Q.add(X.uuid)};J.forEach(({identifier:X})=>K(X)),z.forEach(K);for(const X of x)Q.has(X.identifier.id.toLowerCase())||X.identifier.uuid&&Q.has(X.identifier.uuid)||J.push(X);return this.stringify(J,!1)}async getMergeResult(x,V){return{...x.previewResult,hasConflicts:!1}}async getAcceptResult(x,V,q,z){if(this.extUri.isEqual(V,this.localResource))return this.acceptLocal(x);if(this.extUri.isEqual(V,this.remoteResource))return this.acceptRemote(x);if(this.extUri.isEqual(V,this.previewResource))return x.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async acceptLocal(x){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),z=(0,n.merge)(x.localExtensions,null,null,x.skippedExtensions,q,x.builtinExtensions),{local:J,remote:Q}=z;return{content:x.localContent,local:J,remote:Q,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:Q!==null?2:0}}async acceptRemote(x){const V=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(V),z=x.remoteContent?JSON.parse(x.remoteContent):null;if(z!==null){const J=(0,n.merge)(x.localExtensions,z,x.localExtensions,[],q,x.builtinExtensions),{local:Q,remote:K}=J;return{content:x.remoteContent,local:Q,remote:K,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:x.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(x,V,q,z){let{skippedExtensions:J,builtinExtensions:Q,localExtensions:K}=q[0][0];const{local:X,remote:j,localChange:F,remoteChange:ee}=q[0][1];if(F===0&&ee===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(K)),J=await this.localExtensionsProvider.updateLocalExtensions(X.added,X.removed,X.updated,J,this.syncResource.profile)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ne=JSON.stringify(j.all);x=await this.updateRemoteUserData(ne,z?null:x.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(se=>se.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(se=>se.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(se=>se.identifier.id))}.`:""}`)}V?.ref!==x.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),Q=this.computeBuiltinExtensions(K,Q),await this.updateLastSyncUserData(x,{skippedExtensions:J,builtinExtensions:Q}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${J.length?` Skipped: ${JSON.stringify(J.map(ne=>ne.identifier.id))}.`:""}`))}computeBuiltinExtensions(x,V){const q=new Set,z=[];for(const J of x)q.add(J.identifier.id.toLowerCase()),J.installed||z.push(J.identifier);if(V)for(const J of V)q.has(J.id.toLowerCase())||z.push(J);return z}async resolveContent(x){if(this.extUri.isEqual(this.remoteResource,x)||this.extUri.isEqual(this.baseResource,x)||this.extUri.isEqual(this.localResource,x)||this.extUri.isEqual(this.acceptedResource,x)){const V=await this.resolvePreviewContent(x);return V&&this.stringify(JSON.parse(V),!0)}return null}stringify(x,V){return w(x,V)}async hasLocalData(){try{const{localExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(x.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};S=ve([Y(2,I.IEnvironmentService),Y(3,b.IFileService),Y(4,g.IStorageService),Y(5,r.IUserDataSyncStoreService),Y(6,r.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,t.IIgnoredExtensionsManagementService),Y(9,r.IUserDataSyncLogService),Y(10,y.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,v.ITelemetryService),Y(13,p.IExtensionStorageService),Y(14,k.IUriIdentityService),Y(15,s.IUserDataProfileStorageService),Y(16,c.IInstantiationService)],S),e.ExtensionsSynchroniser=S;let D=class{constructor(x,V,q,z,J,Q){this.extensionManagementService=x,this.userDataProfileStorageService=V,this.extensionGalleryService=q,this.ignoredExtensionsManagementService=z,this.instantiationService=J,this.logService=Q}async getLocalExtensions(x){const V=await this.extensionManagementService.getInstalled(void 0,x.extensionsResource),q=this.ignoredExtensionsManagementService.getIgnoredExtensions(V);return{localExtensions:await this.withProfileScopedServices(x,async(J,Q)=>{const K=J.getDisabledExtensions();return V.map(X=>{const{identifier:j,isBuiltin:F,manifest:ee,preRelease:ne,pinned:se}=X,H={identifier:j,preRelease:ne,version:ee.version,pinned:!!se};K.some(B=>(0,f.areSameExtensions)(B,j))&&(H.disabled=!0),F||(H.installed=!0);try{const B=Q.getKeysForSync({id:j.id,version:ee.version});if(B){const N=Q.getExtensionState(X,!0)||{};H.state=Object.keys(N).reduce((C,U)=>(B.includes(U)&&(C[U]=N[U]),C),{})}}catch(B){this.logService.info(`${(0,o.getSyncResourceLogLabel)("extensions",x)}: Error while parsing extension state`,(0,l.getErrorMessage)(B))}return H})}),ignoredExtensions:q}}async updateLocalExtensions(x,V,q,z,J){const Q=(0,o.getSyncResourceLogLabel)("extensions",J),K=[],X=[],j=[],F=await this.extensionManagementService.getInstalled(void 0,J.extensionsResource);if((x.length||q.length)&&await this.withProfileScopedServices(J,async(ne,se)=>{await L.Promises.settled([...x,...q].map(async H=>{const B=F.find(U=>(0,f.areSameExtensions)(U.identifier,H.identifier));if(B&&B.isBuiltin){H.state&&B.manifest.version===H.version&&this.updateExtensionState(H.state,B,B.manifest.version,se),ne.getDisabledExtensions().some($=>(0,f.areSameExtensions)($,H.identifier))!==!!H.disabled&&(H.disabled?(this.logService.trace(`${Q}: Disabling extension...`,H.identifier.id),await ne.disableExtension(H.identifier),this.logService.info(`${Q}: Disabled extension`,H.identifier.id)):(this.logService.trace(`${Q}: Enabling extension...`,H.identifier.id),await ne.enableExtension(H.identifier),this.logService.info(`${Q}: Enabled extension`,H.identifier.id))),X.push(H.identifier);return}const N=H.pinned?H.version:void 0,C=(await this.extensionGalleryService.getExtensions([{...H.identifier,version:N,preRelease:N?void 0:H.preRelease}],O.CancellationToken.None))[0];if(H.state&&(B?B.manifest.version===H.version:!!C)&&this.updateExtensionState(H.state,B||C,B?.manifest.version,se),C)try{ne.getDisabledExtensions().some($=>(0,f.areSameExtensions)($,H.identifier))!==!!H.disabled&&(H.disabled?(this.logService.trace(`${Q}: Disabling extension...`,H.identifier.id,C.version),await ne.disableExtension(C.identifier),this.logService.info(`${Q}: Disabled extension`,H.identifier.id,C.version)):(this.logService.trace(`${Q}: Enabling extension...`,H.identifier.id,C.version),await ne.enableExtension(C.identifier),this.logService.info(`${Q}: Enabled extension`,H.identifier.id,C.version))),(!B||B.preRelease!==H.preRelease||B.pinned!==H.pinned||N&&B.manifest.version!==N)&&(await this.extensionManagementService.canInstall(C)?K.push([H,C]):(this.logService.info(`${Q}: Skipped synchronizing extension because it cannot be installed.`,C.displayName||C.identifier.id),j.push(H)))}catch(U){j.push(H),this.logService.error(U),this.logService.info(`${Q}: Skipped synchronizing extension`,C.displayName||C.identifier.id)}else j.push(H),this.logService.info(`${Q}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),V.length){const ne=F.filter(({identifier:se,isBuiltin:H})=>!H&&V.some(B=>(0,f.areSameExtensions)(se,B)));await L.Promises.settled(ne.map(async se=>{this.logService.trace(`${Q}: Uninstalling local extension...`,se.identifier.id),await this.extensionManagementService.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:J.extensionsResource}),this.logService.info(`${Q}: Uninstalled local extension.`,se.identifier.id),X.push(se.identifier)}))}for(const[ne,se]of K)try{this.logService.trace(`${Q}: Installing extension...`,se.identifier.id,se.version),await this.extensionManagementService.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ne.pinned&&!!ne.version,installPreReleaseVersion:ne.preRelease,profileLocation:J.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.logService.info(`${Q}: Installed extension.`,se.identifier.id,se.version),X.push(se.identifier)}catch(H){j.push(ne),H instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.logService.info(`${Q}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.logService.error(H),this.logService.info(`${Q}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const ee=[];for(const ne of z)X.some(se=>(0,f.areSameExtensions)(se,ne.identifier))||ee.push(ne);for(const ne of j)ee.some(se=>(0,f.areSameExtensions)(se.identifier,ne.identifier))||ee.push(ne);return ee}updateExtensionState(x,V,q,z){const J=z.getExtensionState(V,!0)||{},Q=q?z.getKeysForSync({id:V.identifier.id,version:q}):void 0;Q?Q.forEach(K=>{J[K]=x[K]}):Object.keys(x).forEach(K=>J[K]=x[K]),z.setExtensionState(V,J,!0)}async withProfileScopedServices(x,V){return this.userDataProfileStorageService.withProfileScopedStorageService(x,async q=>{const z=new R.DisposableStore,J=this.instantiationService.createChild(new d.ServiceCollection([g.IStorageService,q])),Q=z.add(J.createInstance(E.GlobalExtensionEnablementService)),K=z.add(J.createInstance(p.ExtensionStorageService));try{return await V(Q,K)}finally{z.dispose()}})}};D=ve([Y(0,m.IExtensionManagementService),Y(1,s.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,t.IIgnoredExtensionsManagementService),Y(4,c.IInstantiationService),Y(5,r.IUserDataSyncLogService)],D),e.LocalExtensionsProvider=D;let T=class extends o.AbstractInitializer{constructor(x,V,q,z,J,Q,K,X){super("extensions",z,J,Q,q,K,X),this.extensionManagementService=x,this.ignoredExtensionsManagementService=V}async parseExtensions(x){return x.syncData?await a(x.syncData,this.extensionManagementService):null}generatePreview(x,V){const q=[],z=[],J=[];for(const Q of x){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(Q.identifier.id))continue;const K=V.find(X=>(0,f.areSameExtensions)(X.identifier,Q.identifier));K?(q.push(K),Q.disabled&&J.push(Q.identifier)):Q.installed&&(z.push({...Q.identifier,preRelease:!!Q.preRelease}),Q.disabled&&J.push(Q.identifier))}return{installedExtensions:q,newExtensions:z,disabledExtensions:J,remoteExtensions:x}}};T=ve([Y(0,m.IExtensionManagementService),Y(1,t.IIgnoredExtensionsManagementService),Y(2,b.IFileService),Y(3,i.IUserDataProfilesService),Y(4,I.IEnvironmentService),Y(5,u.ILogService),Y(6,g.IStorageService),Y(7,k.IUriIdentityService)],T),e.AbstractExtensionsInitializer=T}),define(oe[123],ae([0,1,16,10,3,35,42,4,31,17,15,13,9,44,20,19,30,41,60,262,24,18,61,5]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",t=["locale"];function r(D,T){const M=D.storage?Object.keys(D.storage).sort():[],x={};return M.forEach(V=>x[V]=D.storage[V]),D.storage=x,T?(0,_.toFormattedString)(D,{}):JSON.stringify(D)}e.stringify=r;const s=1;let a=class extends d.AbstractSynchroniser{constructor(T,M,x,V,q,z,J,Q,K,X,j,F,ee,ne){super({syncResource:"globalState",profile:T},M,V,Q,F,q,z,K,X,J,j,ee),this.userDataProfileStorageService=x,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ne.createInstance(h),this._register(V.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(l.Event.any(l.Event.filter(V.onDidFilesChange,se=>se.contains(this.environmentService.argvResource)),l.Event.filter(x.onDidChange,se=>!!(se.targetChanges.some(H=>this.syncResource.profile.id===H.id)||se.valueChanges.some(({profile:H,changes:B})=>this.syncResource.profile.id===H.id&&B.some(N=>N.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(T,M,x){const V=T.syncData?JSON.parse(T.syncData.content):null;M=M===null&&x?T:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,z=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);V?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.getStorageKeys(q),{local:Q,remote:K}=(0,g.merge)(z.storage,V?V.storage:null,q?q.storage:null,J,this.logService),X={content:null,local:Q,remote:K,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:K.all!==null?2:0},j=r(z,!1);return[{baseResource:this.baseResource,baseContent:q?r(q,!1):j,localResource:this.localResource,localContent:j,localUserData:z,remoteResource:this.remoteResource,remoteContent:V?r(V,!1):null,previewResource:this.previewResource,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.acceptedResource,storageKeys:J}]}async hasRemoteChanged(T){const M=T.syncData?JSON.parse(T.syncData.content):null;if(M===null)return!0;const x=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),V=await this.getStorageKeys(M),{remote:q}=(0,g.merge)(x.storage,M.storage,M.storage,V,this.logService);return q.all!==null}async getMergeResult(T,M){return{...T.previewResult,hasConflicts:!1}}async getAcceptResult(T,M,x,V){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(T);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(T);if(this.extUri.isEqual(M,this.previewResource))return T.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(T.localUserData.storage),removed:[],updated:[],all:T.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(T){if(T.remoteContent!==null){const M=JSON.parse(T.remoteContent),{local:x,remote:V}=(0,g.merge)(T.localUserData.storage,M.storage,null,T.storageKeys,this.logService);return{content:T.remoteContent,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(T,M,x,V){const{localUserData:q}=x[0][0],{local:z,remote:J,localChange:Q,remoteChange:K}=x[0][1];if(Q===0&&K===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(q)),await this.localGlobalStateProvider.writeLocalGlobalState(z,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),K!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const X=JSON.stringify({storage:J.all});T=await this.updateRemoteUserData(X,V?null:T.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}M?.ref!==T.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(T),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(T){if(this.extUri.isEqual(this.remoteResource,T)||this.extUri.isEqual(this.baseResource,T)||this.extUri.isEqual(this.localResource,T)||this.extUri.isEqual(this.acceptedResource,T)){const M=await this.resolvePreviewContent(T);return M&&r(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:T}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(T).length>1||T[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(T){const M=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),x=[],V=[];for(const[J,Q]of M)Q.target===0?x.push(J):Q.target===1&&V.push(J);const q=[...x,...V],z=T?.storage?Object.keys(T.storage).filter(J=>!J.startsWith(n)&&!q.includes(J)&&M.get(J)!==void 0):[];if(!R.isWeb){const J=[...v.ALL_SYNC_RESOURCES.map(Q=>(0,v.getEnablementKey)(Q)),v.SYNC_SERVICE_URL_TYPE];z.push(...J),V.push(...J)}return{user:x,machine:V,unregistered:z}}};a=ve([Y(2,i.IUserDataProfileStorageService),Y(3,E.IFileService),Y(4,v.IUserDataSyncStoreService),Y(5,v.IUserDataSyncBackupStoreService),Y(6,v.IUserDataSyncLogService),Y(7,I.IEnvironmentService),Y(8,v.IUserDataSyncEnablementService),Y(9,b.ITelemetryService),Y(10,y.IConfigurationService),Y(11,p.IStorageService),Y(12,c.IUriIdentityService),Y(13,o.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let h=class{constructor(T,M,x,V){this.fileService=T,this.environmentService=M,this.userDataProfileStorageService=x,this.logService=V}async getLocalGlobalState(T){const M={};if(T.isDefault){const V=await this.getLocalArgvContent(),q=(0,A.parse)(V);for(const z of t)q[z]!==void 0&&(M[`${n}${z}`]={version:1,value:q[z]})}const x=await this.userDataProfileStorageService.readStorageData(T);for(const[V,q]of x)q.value&&q.target===0&&(M[V]={version:1,value:q.value});return{storage:M}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const T=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),T.value.toString()}catch(T){this.logService.debug((0,O.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:M,updated:x},V){const q=(0,d.getSyncResourceLogLabel)("globalState",V),z={},J=new Map,Q=await this.userDataProfileStorageService.readStorageData(V),K=(X,j)=>{for(const F of X){if(F.startsWith(n)){z[F.substring(n.length)]=j?j[F].value:void 0;continue}if(j){const ee=j[F];ee.value!==Q.get(F)?.value&&J.set(F,ee.value)}else Q.get(F)!==void 0&&J.set(F,void 0)}};if(K(Object.keys(T),T),K(Object.keys(x),x),K(M),Object.keys(z).length){this.logService.trace(`${q}: Updating locale...`);const X=await this.getLocalArgvContent();let j=X;for(const F of Object.keys(z))j=(0,u.edit)(j,[F],z[F],{});X!==j&&(this.logService.trace(`${q}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(j)),this.logService.info(`${q}: Updated locale.`)),this.logService.info(`${q}: Updated locale`)}J.size&&(this.logService.trace(`${q}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(V,J,0),this.logService.info(`${q}: Updated global state`,[...J.keys()]))}};h=ve([Y(0,E.IFileService),Y(1,I.IEnvironmentService),Y(2,i.IUserDataProfileStorageService),Y(3,v.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let w=class extends d.AbstractInitializer{constructor(T,M,x,V,q,z){super("globalState",x,V,q,M,T,z)}async doInitialize(T){const M=T.syncData?JSON.parse(T.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const x={},V={};for(const q of Object.keys(M.storage))q.startsWith(n)?x[q.substring(n.length)]=M.storage[q].value:this.storageService.get(q,0)===void 0&&(V[q]=M.storage[q].value);if(Object.keys(x).length){let q="{}";try{q=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const z of Object.keys(x))q=(0,u.edit)(q,[z],x[z],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(q))}if(Object.keys(V).length)for(const q of Object.keys(V))this.storageService.store(q,V[q],0,0)}};w=ve([Y(0,p.IStorageService),Y(1,E.IFileService),Y(2,k.IUserDataProfilesService),Y(3,I.IEnvironmentService),Y(4,v.IUserDataSyncLogService),Y(5,c.IUriIdentityService)],w),e.GlobalStateInitializer=w;let S=class{constructor(T,M,x,V,q){this.userDataSyncStoreClient=T,this.storageService=M,this.environmentService=x,this.fileService=V,this.logService=q}getSyncStoreType(T){return this.parseGlobalState(T)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const M=(0,v.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(T,M)}catch(x){if(x instanceof v.UserDataSyncError)switch(x.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(T,M)}throw x}}async doSync(T,M){const x=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,M),V=this.parseGlobalState(x)||{storage:{}};V.storage[v.SYNC_SERVICE_URL_TYPE]={value:T,version:s};const q=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:s,machineId:q,content:r(V,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(z),x.ref,void 0,M)}parseGlobalState({content:T}){if(!T)return null;const M=JSON.parse(T);if((0,d.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};S=ve([Y(1,p.IStorageService),Y(2,I.IEnvironmentService),Y(3,E.IFileService),Y(4,m.ILogService)],S),e.UserDataSyncStoreTypeSynchronizer=S}),define(oe[124],ae([0,1,21,16,3,35,4,11,184,17,15,13,20,19,30,18,41,259,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(i,o,n){try{const t=JSON.parse(i);if(!o)return(0,R.isUndefined)(t.all)?null:t.all;switch(_.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}e.getKeybindingsContentFromSyncContent=g;let v=class extends c.AbstractJsonFileSynchroniser{constructor(o,n,t,r,s,a,h,w,S,D,T,M,x){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,S,D,t,r,h,M,s,T,a,x),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(l.Event.filter(a.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,t,r){const s=o.syncData?g(o.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&t?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,h=await this.getLocalFileContent(),w=await this.getFormattingOptions();let S=null,D=!1,T=!1,M=!1;if(s){let q=h?h.value.toString():"[]";if(q=q||"[]",this.hasErrors(q,!0))throw new u.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,d.merge)(q,s,a,w,this.userDataSyncUtilService);z.hasChanges&&(S=z.mergeContent,M=z.hasConflicts,D=M||z.mergeContent!==q,T=M||z.mergeContent!==s)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),S=h.value.toString(),T=!0);const x={content:M?a:S,localChange:D?h?2:1:0,remoteChange:T?2:0,hasConflicts:M},V=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:V,localChange:x.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:x.remoteChange,previewResource:this.previewResource,previewResult:x,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const t=await this.getLocalFileContent(),r=t?t.value.toString():"",s=await this.getFormattingOptions(),a=await(0,d.merge)(r||"[]",n,n,s,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,t,r){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,t,r){const{fileContent:s}=t[0][0];let{content:a,localChange:h,remoteChange:w}=t[0][1];if(h===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new u.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(a||"[]",s,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const S=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(S,r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,A.parse)(o.value.toString());if((0,L.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:g(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let t={};try{t=JSON.parse(n||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete t.all:t.all=o,_.OS){case 2:t.mac=o;break;case 3:t.linux=o;break;case 1:t.windows=o;break}return JSON.stringify(t)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=ve([Y(2,u.IUserDataSyncStoreService),Y(3,u.IUserDataSyncBackupStoreService),Y(4,u.IUserDataSyncLogService),Y(5,y.IConfigurationService),Y(6,u.IUserDataSyncEnablementService),Y(7,E.IFileService),Y(8,I.IEnvironmentService),Y(9,m.IStorageService),Y(10,u.IUserDataSyncUtilService),Y(11,f.ITelemetryService),Y(12,p.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let k=class extends c.AbstractInitializer{constructor(o,n,t,r,s,a){super("keybindings",n,t,r,o,s,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,A.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return g(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};k=ve([Y(0,E.IFileService),Y(1,b.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,p.IUriIdentityService)],k),e.KeybindingsInitializer=k}),define(oe[125],ae([0,1,16,3,185,17,73,15,29,13,20,19,30,18,41,60,263,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function g(i){const o=JSON.parse(i);return u(o)?o:{settings:i}}e.parseSettingsSyncContent=g;let v=class extends p.AbstractJsonFileSynchroniser{constructor(o,n,t,r,s,a,h,w,S,D,T,M,x,V){super(o.settingsResource,{syncResource:"settings",profile:o},n,t,r,s,a,h,T,M,w,S,D,V),this.extensionManagementService=x,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const n=await this.getLastSyncUserData(),t=await this.getLatestRemoteUserData(o,n),r=this.getSettingsSyncContent(t),s=new _.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&s.parse(r.settings),s.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,n,t){const r=await this.getLocalFileContent(),s=await this.getFormattingOptions(),a=this.getSettingsSyncContent(o);n=n===null&&t?o:n;const h=n?this.getSettingsSyncContent(n):null,w=await this.getIgnoredSettings();let S=null,D=!1,T=!1,M=!1;if(a){let z=r?r.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,c.merge)(z,a.settings,h?h.settings:null,w,[],s);S=J.localContent||J.remoteContent,D=J.localContent!==null,T=J.remoteContent!==null,M=J.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.validateContent(S),T=!0);const x=r?r.value.toString():null,V=h?.settings??null,q={content:M?V:S,localChange:D?2:0,remoteChange:T?2:0,hasConflicts:M};return[{fileContent:r,baseResource:this.baseResource,baseContent:V,localResource:this.localResource,localContent:x,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getSettingsSyncContent(o);if(n===null)return!0;const t=await this.getLocalFileContent(),r=t?t.value.toString().trim():"",s=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,c.merge)(r||"{}",n.settings,n.settings,s,[],a).remoteContent!==null}async getMergeResult(o,n){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,c.updateIgnoredSettings)(o.previewResult.content,"{}",r,t):null}}async getAcceptResult(o,n,t,r){const s=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?(0,c.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent!==null?(0,c.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t!==null?(0,c.updateIgnoredSettings)(t,o.fileContent?o.fileContent.value.toString():"{}",a,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,t,r){const{fileContent:s}=t[0][0];let{content:a,localChange:h,remoteChange:w}=t[0][1];if(h===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(a,s,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const S=await this.getFormattingOptions(),D=this.getSettingsSyncContent(o),T=await this.getIgnoredSettings(a);a=(0,c.updateIgnoredSettings)(a,D?D.settings:"{}",T,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=await this.getFormattingOptions(),t=(0,b.edit)(o.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,c.isEmpty)(t)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o)?this.resolvePreviewContent(o):null}async resolvePreviewContent(o){let n=await super.resolvePreviewContent(o);if(n){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();n=(0,c.updateIgnoredSettings)(n,"{}",r,t)}return n}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return g(o)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const t=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:s})=>!!s)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{t.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,c.getIgnoredSettings)(n,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new d.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};v=ve([Y(2,y.IFileService),Y(3,R.IEnvironmentService),Y(4,I.IStorageService),Y(5,d.IUserDataSyncStoreService),Y(6,d.IUserDataSyncBackupStoreService),Y(7,d.IUserDataSyncLogService),Y(8,d.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,d.IUserDataSyncEnablementService),Y(11,E.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,m.IUriIdentityService)],v),e.SettingsSynchroniser=v;let k=class extends p.AbstractInitializer{constructor(o,n,t,r,s,a){super("settings",n,t,r,o,s,a)}async doInitialize(o){const n=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,c.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return g(o)}catch(n){this.logService.error(n)}return null}};k=ve([Y(0,y.IFileService),Y(1,f.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,m.IUriIdentityService)],k),e.SettingsInitializer=k}),define(oe[126],ae([0,1,16,3,32,17,15,13,20,19,30,18,41,260,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function b(u){return JSON.parse(u.content)}e.parseSnippets=b;let c=class extends m.AbstractSynchroniser{constructor(g,v,k,i,o,n,t,r,s,a,h,w){super({syncResource:"snippets",profile:g},v,i,k,o,n,t,a,h,r,s,w),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(k.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,S=>S.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,v,k){const i=await this.getSnippetsFileContents(),o=this.toSnippetsContents(i),n=g.syncData?this.parseSnippets(g.syncData):null;v=v===null&&k?g:v;const t=v&&v.syncData?this.parseSnippets(v.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(o,n,t);return this.getResourcePreviews(r,i,n||{},t||{})}async hasRemoteChanged(g){const v=g.syncData?this.parseSnippets(g.syncData):null;if(v===null)return!0;const k=await this.getSnippetsFileContents(),i=this.toSnippetsContents(k),o=(0,f.merge)(i,v,v);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(g,v){return g.previewResult}async getAcceptResult(g,v,k,i){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return k===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:k,localChange:k===null?g.fileContent!==null?3:0:2,remoteChange:k===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(g,v,k,i){const o=k.map(([n,t])=>({...n,acceptResult:t}));o.every(({localChange:n,remoteChange:t})=>n===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,i)),o.some(({remoteChange:n})=>n!==0)&&(g=await this.updateRemoteSnippets(o,g,i)),v?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(g,v,k,i){const o=new Map;for(const n of Object.keys(g.local.added)){const t={content:g.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.local.updated)){const t={content:g.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.added)){const t={content:g.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.updated)){const t={content:g.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.conflicts){const t={content:i[n]??null,hasConflicts:!0,localChange:v[n]?2:1,remoteChange:k[n]?2:1},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(v))if(!o.has(n)){const t={content:v[n]?v[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=v[n]?v[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[n]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(g){return this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(g):null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const v={};for(const k of g)k.fileContent&&(v[this.extUri.basename(k.localResource)]=k.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(g,v){for(const{fileContent:k,acceptResult:i,localResource:o,remoteResource:n,localChange:t}of g)if(t!==0){const r=n?this.extUri.basename(n):this.extUri.basename(o),s=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,L.VSBuffer.fromString(i.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,L.VSBuffer.fromString(i.content),v?void 0:k),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(g,v,k){const i=v.syncData?this.parseSnippets(v.syncData):{},o=(0,l.deepClone)(i);for(const{acceptResult:n,localResource:t,remoteResource:r,remoteChange:s}of g)if(s!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);s===3?delete o[a]:o[a]=n.content}return(0,f.areSame)(i,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(o),k?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(g){return b(g)}toSnippetsContents(g){const v={};for(const k of Object.keys(g))v[k]=g[k].value.toString();return v}async getSnippetsFileContents(){const g={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(k){if(k instanceof R.FileOperationError&&k.fileOperationResult===1)return g;throw k}for(const k of v.children||[]){const i=k.resource,o=this.extUri.extname(i);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,i),t=await this.fileService.readFile(i);g[n]=t}}return g}};c=ve([Y(2,_.IEnvironmentService),Y(3,R.IFileService),Y(4,P.IStorageService),Y(5,p.IUserDataSyncStoreService),Y(6,p.IUserDataSyncBackupStoreService),Y(7,p.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,p.IUserDataSyncEnablementService),Y(10,y.ITelemetryService),Y(11,I.IUriIdentityService)],c),e.SnippetsSynchroniser=c;let d=class extends m.AbstractInitializer{constructor(g,v,k,i,o,n){super("snippets",v,k,i,g,o,n)}async doInitialize(g){const v=g.syncData?JSON.parse(g.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(v)){const o=v[i];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,i);await this.fileService.createFile(n,L.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};d=ve([Y(0,R.IFileService),Y(1,E.IUserDataProfilesService),Y(2,_.IEnvironmentService),Y(3,p.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,I.IUriIdentityService)],d),e.SnippetsInitializer=d}),define(oe[127],ae([0,1,16,17,15,13,20,19,30,18,41,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(c,d){try{return JSON.parse(c).tasks??null}catch(u){return d.error(u),null}}e.getTasksContentFromSyncContent=m;let f=class extends I.AbstractFileSynchroniser{constructor(d,u,g,v,k,i,o,n,t,r,s,a){super(d.tasksResource,{syncResource:"tasks",profile:d},u,n,t,r,g,v,o,s,k,i,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,u,g,v){const k=d.syncData?m(d.syncData.content,this.logService):null;u=u===null&&g?d:u;const i=u?.syncData?m(u.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,t=!1,r=!1,s=!1;if(d.syncData){const w=o?o.value.toString():null;if(!i||i!==w||i!==k){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const S=b(w,k,i);n=S.content,s=S.hasConflicts,t=S.hasLocalChanged,r=S.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),r=!0);const a={content:s?i:n,localChange:t?o?2:1:0,remoteChange:r?2:0,hasConflicts:s},h=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:h,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:k,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const u=d?.syncData?m(d.syncData.content,this.logService):null;if(u===null)return!0;const g=await this.getLocalFileContent(),v=g?g.value.toString():null,k=b(v,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async getMergeResult(d,u){return d.previewResult}async getAcceptResult(d,u,g,v){if(this.extUri.isEqual(u,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(u,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(u,this.previewResource))return g===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(d,u,g,v){const{fileContent:k}=g[0][0],{content:i,localChange:o,remoteChange:n}=g[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),k&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(k.value.toString()))),i?await this.updateLocalFileContent(i,k,v):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const t=JSON.stringify(this.toTasksSyncContent(i));d=await this.updateRemoteUserData(t,v?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}u?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(d){return this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)?this.resolvePreviewContent(d):null}toTasksSyncContent(d){return d?{tasks:d}:{}}};f=ve([Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncBackupStoreService),Y(4,E.IUserDataSyncLogService),Y(5,O.IConfigurationService),Y(6,E.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,l.IEnvironmentService),Y(9,_.IStorageService),Y(10,R.ITelemetryService),Y(11,P.IUriIdentityService)],f),e.TasksSynchroniser=f;let p=class extends I.AbstractInitializer{constructor(d,u,g,v,k,i){super("tasks",u,g,v,d,k,i),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(d){const u=d.syncData?m(d.syncData.content,this.logService):null;if(!u){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(u)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};p=ve([Y(0,A.IFileService),Y(1,y.IUserDataProfilesService),Y(2,l.IEnvironmentService),Y(3,E.IUserDataSyncLogService),Y(4,_.IStorageService),Y(5,P.IUriIdentityService)],p),e.TasksInitializer=p;function b(c,d,u){if(c===null&&d===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=u!==c,v=u!==d;return!g&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!v?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!g?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[128],ae([0,1,42,17,15,13,20,19,30,18,41,261,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=class extends I.AbstractSynchroniser{constructor(d,u,g,v,k,i,o,n,t,r,s,a,h){super({syncResource:"profiles",profile:d},u,v,k,i,o,n,s,a,t,r,h),this.userDataProfilesService=g,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?b(d.syncData):null}async getRemoteSyncedProfiles(d){const u=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(d,u);return g?.syncData?b(g.syncData):null}async generateSyncPreview(d,u,g){if(!this.userDataProfilesService.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=d.syncData?b(d.syncData):null,k=u?.syncData?b(u.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,E.merge)(i,v,k,[]),t={local:o,remote:n,content:k?this.stringifyRemoteProfiles(k):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},r=p(i,!1);return[{baseResource:this.baseResource,baseContent:k?this.stringifyRemoteProfiles(k):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:v?this.stringifyRemoteProfiles(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const u=d?.syncData?b(d.syncData):null,g=this.getLocalUserDataProfiles(),{remote:v}=(0,E.merge)(g,u,u,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async getMergeResult(d,u){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,u,g,v){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(u,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(d){const u=this.getLocalUserDataProfiles(),g=(0,E.merge)(u,null,null,[]),{local:v,remote:k}=g;return{content:d.localContent,local:v,remote:k,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(d){const u=d.remoteContent?JSON.parse(d.remoteContent):null,g=[],v=[];for(const k of this.getLocalUserDataProfiles()){const i=u?.find(o=>o.id===k.id);i&&(g.push({id:k.id,name:k.name,collection:i.collection}),v.push(k))}if(u!==null){const k=(0,E.merge)(v,u,g,[]),{local:i,remote:o}=k;return{content:d.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(d,u,g,v){const{local:k,remote:i,localChange:o,remoteChange:n}=g[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const t=g[0][0].remoteProfiles||[];if(t.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(p(this.getLocalUserDataProfiles(),!1));const r=[];for(const s of k.added)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${s.name}' profile...`),await this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${s.name}'.`)})());for(const s of k.removed)r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${s.name}' profile...`),await this.userDataProfilesService.removeProfile(s),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${s.name}'.`)})());for(const s of k.updated){const a=this.userDataProfilesService.profiles.find(h=>h.id===s.id);a?r.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${s.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:s.name,shortName:s.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${s.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(r)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const r=[],s=t.length+(i?.added.length??0)<=20;if(s)for(const a of i?.added||[]){const h=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push(h),t.push({id:a.id,name:a.name,collection:h,shortName:a.shortName})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])t.splice(t.findIndex(({id:h})=>a.id===h),1);for(const a of i?.updated||[]){const h=t.find(({id:w})=>a.id===w);h&&t.splice(t.indexOf(h),1,{id:a.id,name:a.name,collection:h.collection,shortName:a.shortName})}try{d=await this.updateRemoteProfiles(t,v?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${s&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(r.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of r)await this.userDataSyncStoreService.deleteCollection(h,this.syncHeaders)}throw a}for(const a of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}u?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(d,u){return this.updateRemoteUserData(this.stringifyRemoteProfiles(d),u)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const u=await this.resolvePreviewContent(d);return u&&(0,L.toFormattedString)(JSON.parse(u),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(d=>!d.isDefault&&!d.isTransient)}stringifyRemoteProfiles(d){return JSON.stringify([...d].sort((u,g)=>u.name.localeCompare(g.name)))}};f=ve([Y(2,y.IUserDataProfilesService),Y(3,A.IFileService),Y(4,l.IEnvironmentService),Y(5,_.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,O.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,P.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function p(c,d){const u=[...c].sort((g,v)=>g.name.localeCompare(v.name)).map(g=>({id:g.id,name:g.name}));return d?(0,L.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=p;function b(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=b}),define(oe[278],ae([0,1,6,16,64,2,23,17,15,13,18,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends A.Disposable{constructor(p,b,c,d,u){super(),this.environmentService=p,this.fileService=b,this.configurationService=c,this.logService=d,this.userDataProfilesService=u,this.cleanUp()}async cleanUp(){for(const b of this.userDataProfilesService.profiles)for(const c of E.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(b,c))}catch(d){this.logService.error(d)}let p;try{p=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(b){(0,y.toFileOperationResult)(b)!==1&&this.logService.error(b);return}if(p.children){for(const b of p.children)if(b.isDirectory&&!this.userDataProfilesService.profiles.some(c=>c.id===b.name))try{this.logService.info("Deleting non existing profile from backup",b.resource.path),await this.fileService.del(b.resource,{recursive:!0})}catch(c){this.logService.error(c)}}}async getAllRefs(p,b){const c=this.getResourceBackupHome(p,b);try{const d=await this.fileService.resolve(c);if(d.children)return d.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)}))}catch(d){if((0,y.toFileOperationResult)(d)!==1)throw d}return[]}async resolveContent(p,b,c){const d=this.getResourceBackupHome(p,b),u=(0,_.joinPath)(d,c);try{return(await this.fileService.readFile(u)).value.toString()}catch(g){return this.logService.error(g),null}}async backup(p,b,c){const d=this.getResourceBackupHome(p,b),u=(0,_.joinPath)(d,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(u,O.VSBuffer.fromString(c))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(d)}catch{}}getResourceBackupHome(p,b){return(0,_.joinPath)(this.environmentService.userDataSyncHome,...p.isDefault?[b]:[p.id,b])}async cleanUpBackup(p){try{try{if(!await this.fileService.exists(p))return}catch{return}const b=await this.fileService.resolve(p);if(b.children){const c=b.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let u=c.filter(v=>Date.now()-this.getCreationTime(v)>d);const g=c.length-u.length;g<10&&(u=u.slice(10-g)),await L.Promises.settled(u.map(async v=>{this.logService.info("Deleting from backup",v.resource.path),await this.fileService.del(v.resource)}))}}catch(b){this.logService.error(b)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};m=ve([Y(0,P.IEnvironmentService),Y(1,y.IFileService),Y(2,R.IConfigurationService),Y(3,E.IUserDataSyncLogService),Y(4,I.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(oe[279],ae([0,1,3,2,4,15,20,19,24]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const y="sync.enable";let I=class extends O.Disposable{constructor(m,f,p,b){super(),this.storageService=m,this.telemetryService=f,this.environmentService=p,this.userDataSyncStoreManagementService=b,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(c=>this.onDidStorageChange(c)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(y,{enabled:m}),this.storageService.store(y,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,P.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const p=(0,P.getEnablementKey)(m);this.storeResourceEnablement(p,f)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,f){this.storageService.store(m,f,-1,l.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(y===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const f=P.ALL_SYNC_RESOURCES.filter(p=>(0,P.getEnablementKey)(p)===m.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}};I=ve([Y(0,_.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(oe[80],ae([0,1,3,2,4,27,189,15,13,5,26,44,20,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,y.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",b="Safari",c="Chrome",d="Edge",u="Firefox",g="Android";function v(o){switch(o){case b:case c:case d:case u:case g:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function k(){return l.isSafari?b:l.isChrome?c:l.isEdge?d:l.isFirefox?u:l.isAndroid?g:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let i=class it extends O.Disposable{constructor(n,t,r,s,a,h){super(),this.storageService=r,this.userDataSyncStoreService=s,this.logService=a,this.productService=h,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(n,t,r)}async getMachines(n){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(n)).machines.map(s=>({...s,isCurrent:s.id===t}))}async addCurrentMachine(n){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(n);r.machines.some(({id:s})=>s===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:k()}),await this.writeMachinesData(r))}async removeCurrentMachine(n){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(n),s=r.machines.filter(({id:a})=>a!==t);s.length!==r.machines.length&&(r.machines=s,await this.writeMachinesData(r))}async renameMachine(n,t,r){const s=await this.readMachinesData(r),a=s.machines.find(({id:h})=>h===n);if(a){a.name=t,await this.writeMachinesData(s);const h=await this.currentMachineIdPromise;n===h&&this.storageService.store(p,t,-1,1)}}async setEnablements(n){const t=await this.readMachinesData();for(const[r,s]of n){const a=t.machines.find(h=>h.id===r);a&&(a.disabled=s?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(n){const t=this.storageService.get(p,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${k()} (${this.productService.nameShort})`,s=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let a=0;for(const h of n){const w=s.exec(h.name),S=w?parseInt(w[1]):0;a=S>a?S:a}return`${r} #${a+1}`}async readMachinesData(n){this.userData=await this.readUserData(n);const t=this.parse(this.userData);if(t.version!==it.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(n){const t=JSON.stringify(n),r=await this.userDataSyncStoreService.writeResource(it.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(n){if(this.userData){const t=n&&n.latest?n.latest[it.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(it.RESOURCE,this.userData)}parse(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(t){this.logService.error(t)}return{version:it.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=ve([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,m.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncLogService),Y(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(oe[280],ae([0,1,6,64,38,10,3,2,4,23,12,186,26,20,19,24,77,80]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",g="sync.sessionId",v="sync.storeUrl",k="sync.productQuality";let i=class extends R.Disposable{get syncUrl(){const t=this.storageService.get(v,-1);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(v,t.toString(),-1,1):this.storageService.remove(v,-1)}get productQuality(){return this.storageService.get(k,-1)}set productQuality(t){t?this.storageService.store(k,t,-1,1):this.storageService.remove(k,-1)}constructor(t,r,s,a,h,w,S,D,T,M){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=w,this.userDataSyncAccountService=S,this.telemetryService=D,this.userDataSyncMachinesService=T,this.storageService=M,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,y.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(S.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(x=>this.triggerSync([x],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,x])=>x)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:t,message:r}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,r,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,-1),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),r)this.updateEnablement(!1);else throw a}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const r=b.UserDataSyncError.toUserDataSyncError(t);r instanceof b.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?P.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(u,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(u,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(u,-1)}async triggerSync(t,r,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=ve([Y(0,m.IProductService),Y(1,b.IUserDataSyncStoreManagementService),Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncEnablementService),Y(4,b.IUserDataSyncService),Y(5,b.IUserDataSyncLogService),Y(6,c.IUserDataSyncAccountService),Y(7,p.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,f.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends R.Disposable{constructor(t,r,s,a,h,w,S,D){super(),this.lastSyncUrl=t,this.interval=r,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=w,this.logService=S,this.storageService=D,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(t,r){const s=(0,L.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,A.isCancellationError)(h))return}return this.doSync(t,r,a)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,y.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!t&&(!(0,y.isEqual)(r.defaultUrl,t.defaultUrl)||!(0,y.isEqual)(r.insidersUrl,t.insidersUrl)||!(0,y.isEqual)(r.stableUrl,t.stableUrl))}async doSync(t,r,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(r,s)}catch(h){if(this.logService.error(h),a=h,b.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(r,s),a=void 0}catch(w){this.logService.error(w),a=w}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(t,r){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,t),r.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const s=this.storageService.get(g,-1);if(s&&this.manifest&&s!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(r.isCancellationRequested)return;const h=a.find(w=>w.isCurrent);if(h?.disabled)throw new b.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(w){throw new b.UserDataAutoSyncError((0,l.toErrorMessage)(w),w instanceof b.UserDataSyncError?w.code:"Unknown")}this.manifest&&this.manifest.session!==s&&this.storageService.store(g,this.manifest.session,-1,1),!r.isCancellationRequested&&(h||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(t){return super._register(t)}}o.INTERVAL_SYNCING="Interval"}),define(oe[281],ae([0,1,12,190,15,13,44,20,30,24,18,41,126,125,124,17,127,122,123,5,128,42]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Be{constructor(n,t,r,s,a,h,w,S,D,T){this.userDataSyncStoreService=n,this.userDataSyncBackupStoreService=t,this.logService=r,this.environmentService=a,this.storageService=h,this.fileService=w,this.userDataProfilesService=S,this.configurationService=D,this.instantiationService=T,this.extUri=s.extUri}async getRemoteSyncedProfiles(){const n=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(n.content){const t=this.parseSyncData(n.content,"profiles");return(0,v.parseUserDataProfilesManifest)(t)}return[]}async getRemoteSyncResourceHandles(n,t){return(await this.userDataSyncStoreService.getAllResourceRefs(n,t?.collection)).map(({created:s,ref:a})=>({created:s,uri:this.toUri({remote:!0,syncResource:n,profile:t?.id??this.userDataProfilesService.defaultProfile.id,collection:t?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(n,t){return(await this.userDataSyncBackupStoreService.getAllRefs(t,n)).map(({created:s,ref:a})=>({created:s,uri:this.toUri({remote:!1,syncResource:n,profile:t.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const t=this.resolveUri(n),r=t?this.userDataProfilesService.profiles.find(s=>s.id===t.profile):void 0;return t&&r?{profile:r,syncResource:t?.syncResource}:void 0}async getAssociatedResources({uri:n}){const t=this.resolveUri(n);if(!t)return[];const r=this.userDataProfilesService.profiles.find(s=>s.id===t.profile);switch(t.syncResource){case"settings":return this.getSettingsAssociatedResources(n,r);case"keybindings":return this.getKeybindingsAssociatedResources(n,r);case"tasks":return this.getTasksAssociatedResources(n,r);case"snippets":return this.getSnippetsAssociatedResources(n,r);case"globalState":return this.getGlobalStateAssociatedResources(n,r);case"extensions":return this.getExtensionsAssociatedResources(n,r);case"profiles":return this.getProfilesAssociatedResources(n,r)}}async getMachineId({uri:n}){const t=this.resolveUri(n);if(!!t){if(t.remote){if(t.ref){const{content:r}=await this.getUserData(t.syncResource,t.ref,t.collection);if(r)return this.parseSyncData(r,t.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(n){const t=this.resolveUri(n);if(!t||t.node===Be.NOT_EXISTING_RESOURCE)return null;if(t.ref){const r=await this.getContentFromStore(t.remote,t.syncResource,t.profile,t.collection,t.ref);return t.node&&r?this.resolveNodeContent(t.syncResource,r,t.node):r}return!t.remote&&!t.node?this.resolveLatestContent(t.syncResource,t.profile):null}async getContentFromStore(n,t,r,s,a){if(n){const{content:w}=await this.getUserData(t,a,s);return w}const h=this.userDataProfilesService.profiles.find(w=>w.id===r);return h?this.userDataSyncBackupStoreService.resolveContent(h,t,a):null}resolveNodeContent(n,t,r){const s=this.parseSyncData(t,n);switch(n){case"settings":return this.resolveSettingsNodeContent(s,r);case"keybindings":return this.resolveKeybindingsNodeContent(s,r);case"tasks":return this.resolveTasksNodeContent(s,r);case"snippets":return this.resolveSnippetsNodeContent(s,r);case"globalState":return this.resolveGlobalStateNodeContent(s,r);case"extensions":return this.resolveExtensionsNodeContent(s,r);case"profiles":return this.resolveProfileNodeContent(s,r)}}async resolveLatestContent(n,t){const r=this.userDataProfilesService.profiles.find(s=>s.id===t);if(!r)return null;switch(n){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(n,t){const r=this.extUri.joinPath(n,"settings.json"),s=t?t.settingsResource:this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:s}]}resolveSettingsNodeContent(n,t){switch(t){case"settings.json":return(0,f.parseSettingsSyncContent)(n.content).settings}return null}getKeybindingsAssociatedResources(n,t){const r=this.extUri.joinPath(n,"keybindings.json"),s=t?t.keybindingsResource:this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:s}]}resolveKeybindingsNodeContent(n,t){switch(t){case"keybindings.json":return(0,p.getKeybindingsContentFromSyncContent)(n.content,!!this.configurationService.getValue(y.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(n,t){const r=this.extUri.joinPath(n,"tasks.json"),s=t?t.tasksResource:this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:s}]}resolveTasksNodeContent(n,t){switch(t){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(n.content,this.logService)}return null}async getSnippetsAssociatedResources(n,t){const r=await this.resolveContent(n);if(r){const s=this.parseSyncData(r,"snippets");if(s){const a=(0,m.parseSnippets)(s),h=[];for(const w of Object.keys(a)){const S=this.extUri.joinPath(n,w),D=t?this.extUri.joinPath(t.snippetsHome,w):this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);h.push({resource:S,comparableResource:D})}return h}}return[]}resolveSnippetsNodeContent(n,t){return(0,m.parseSnippets)(n)[t]||null}getExtensionsAssociatedResources(n,t){const r=this.extUri.joinPath(n,"extensions.json"),s=t?this.toUri({remote:!1,syncResource:"extensions",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:s}]}resolveExtensionsNodeContent(n,t){switch(t){case"extensions.json":return(0,d.stringify)((0,d.parseExtensions)(n),!0)}return null}async resolveLatestExtensionsContent(n){const{localExtensions:t}=await this.instantiationService.createInstance(d.LocalExtensionsProvider).getLocalExtensions(n);return(0,d.stringify)(t,!0)}getGlobalStateAssociatedResources(n,t){const r=this.extUri.joinPath(n,"globalState.json"),s=t?this.toUri({remote:!1,syncResource:"globalState",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(n,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:s}]}resolveGlobalStateNodeContent(n,t){switch(t){case"globalState.json":return(0,u.stringify)(JSON.parse(n.content),!0)}return null}async resolveLatestGlobalStateContent(n){const t=await this.instantiationService.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,u.stringify)(t,!0)}getProfilesAssociatedResources(n,t){const r=this.extUri.joinPath(n,"profiles.json"),s=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:s}]}resolveProfileNodeContent(n,t){switch(t){case"profiles.json":return(0,k.toFormattedString)(JSON.parse(n.content),{})}return null}async resolveLatestProfilesContent(n){return(0,v.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(t=>!t.isDefault&&!t.isTransient),!0)}toUri(n){const t=n.remote?Be.REMOTE_BACKUP_AUTHORITY:Be.LOCAL_BACKUP_AUTHORITY,r=[n.syncResource,n.profile];return n.collection&&r.push(`collection:${n.collection}`),n.ref&&r.push(`ref:${n.ref}`),n.node&&r.push(n.node),this.extUri.joinPath(L.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:t,path:"/"}),...r)}resolveUri(n){if(n.scheme!==y.USER_DATA_SYNC_SCHEME||n.authority!==Be.LOCAL_BACKUP_AUTHORITY&&n.authority!==Be.REMOTE_BACKUP_AUTHORITY)return;const t=[];for(;n.path!=="/";)t.unshift(this.extUri.basename(n)),n=this.extUri.dirname(n);if(t.length<2)return;const r=n.authority===Be.REMOTE_BACKUP_AUTHORITY,s=t.shift(),a=t.shift();let h,w,S;for(;t.length;){const D=t.shift();D.startsWith("collection:")?h=D.substring(11):D.startsWith("ref:")?w=D.substring(4):S=D}return{remote:r,syncResource:s,profile:a,collection:h,ref:w,node:S}}parseSyncData(n,t){try{const r=JSON.parse(n);if((0,E.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new y.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",t)}async getUserData(n,t,r){const s=await this.userDataSyncStoreService.resolveResourceContent(n,t,r);return{ref:t,content:s}}};i.NOT_EXISTING_RESOURCE="not-existing-resource",i.REMOTE_BACKUP_AUTHORITY="remote-backup",i.LOCAL_BACKUP_AUTHORITY="local-backup",i=ve([Y(0,y.IUserDataSyncStoreService),Y(1,y.IUserDataSyncBackupStoreService),Y(2,y.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,l.IEnvironmentService),Y(5,R.IStorageService),Y(6,A.IFileService),Y(7,I.IUserDataProfilesService),Y(8,b.IConfigurationService),Y(9,g.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(oe[282],ae([0,1,21,6,25,38,3,2,23,11,31,17,29,5,20,19,18,122,123,124,125,126,127,128,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(S,D,T,M,x,V,q,z,J){super(),this.userDataSyncStoreService=S,this.userDataSyncStoreManagementService=D,this.instantiationService=T,this.logService=M,this.telemetryService=x,this.storageService=V,this.userDataSyncEnablementService=q,this.userDataProfilesService=z,this.userDataSyncResourceProviderService=J,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=D.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(S,D){this.checkEnablement(),this.logService.info("Sync started.");const T=new Date().getTime(),M=(0,I.generateUuid)();try{const z=(0,n.createSyncHeaders)(M);D&&(z["Cache-Control"]="no-cache"),S=await this.userDataSyncStoreService.manifest(S,z)}catch(z){const J=n.UserDataSyncError.toUserDataSyncError(z);throw h(J,M,this.userDataSyncStoreManagementService,this.telemetryService),J}const x=!1,V=this;let q;return{manifest:S,async run(){if(x)throw new Error("Can run a task only once");q=(0,O.createCancelablePromise)(z=>V.sync(S,!1,M,z)),await q.finally(()=>q=void 0),V.logService.info(`Sync done. Took ${new Date().getTime()-T}ms`),V.updateLastSyncTime()},stop(){return q?.cancel(),V.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new n.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const S=new Date().getTime(),D=(0,I.generateUuid)(),T=(0,n.createSyncHeaders)(D);let M;try{M=await this.userDataSyncStoreService.manifest(null,T)}catch(q){const z=n.UserDataSyncError.toUserDataSyncError(q);throw h(z,D,this.userDataSyncStoreManagementService,this.telemetryService),z}await this.resetLocal();const x=this,V=new l.CancellationTokenSource;return{id:D,async merge(){return x.sync(M,!0,D,V.token)},async apply(){try{try{await x.applyManualSync(M,D,V.token)}catch(q){if(n.UserDataSyncError.toUserDataSyncError(q).code==="MethodNotFound")x.logService.info("Client is making invalid requests. Cleaning up data..."),await x.cleanUpRemoteData(),x.logService.info("Applying manual sync again..."),await x.applyManualSync(M,D,V.token);else throw q}}catch(q){throw x.logService.error(q),q}x.logService.info(`Sync done. Took ${new Date().getTime()-S}ms`),x.updateLastSyncTime()},async stop(){V.cancel(),await x.stop(),await x.resetLocal()}}}async sync(S,D,T,M){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const x=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(x,S,D,T,M));const V=x.enabled.find(q=>q.resource==="profiles");if(V){const q=await V.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.syncRemoteProfiles(q,S,D,T,M)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(S,D,T,M,x){for(const V of S){if(x.isCancellationRequested)return;const q=this.userDataProfilesService.profiles.find(J=>J.id===V.id);if(!q){this.logService.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",V.name);const z=this.getOrCreateActiveProfileSynchronizer(q,V);this._syncErrors.push(...await this.syncProfile(z,D,T,M,x))}for(const[V,q]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(z=>z.id===q[0].profile.id)||(q[1].dispose(),this.activeProfileSynchronizers.delete(V))}async applyManualSync(S,D,T){const M=this.getActiveProfileSynchronizers();for(const J of M){if(T.isCancellationRequested)return;await J.apply(D,T)}const x=M.find(J=>J.profile.isDefault);if(!x)return;const V=x.enabled.find(J=>J.resource==="profiles");if(!V)return;const z=(await V.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(J=>M.every(Q=>Q.profile.id!==J.id));z.length&&await this.syncRemoteProfiles(z,S,!1,D,T)}async syncProfile(S,D,T,M,x){return(await S.sync(D,T,M,x)).map(([q,z])=>({profile:S.profile,syncResource:q,error:z}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(S=>S.stop()))}async resolveContent(S){const D=await this.userDataSyncResourceProviderService.resolveContent(S);if(D)return D;for(const T of this.getActiveProfileSynchronizers())for(const M of T.enabled){const x=await M.resolveContent(S);if(x)return x}return null}async replace(S){this.checkEnablement();const D=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(S);if(!D)return;const T=await this.resolveContent(S.uri);!T||await this.performAction(D.profile,async M=>{if(D.syncResource===M.resource)return await M.replace(T),!0})}async accept(S,D,T,M){this.checkEnablement(),await this.performAction(S.profile,async x=>{if(S.syncResource===x.resource)return await x.accept(D,T),M&&await x.apply((0,y.isBoolean)(M)?!1:M.force,(0,n.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(S,D){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(S,D)}async getLocalSyncResourceHandles(S,D){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(S,D??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(S){return this.userDataSyncResourceProviderService.getAssociatedResources(S)}async getMachineId(S){return this.userDataSyncResourceProviderService.getMachineId(S)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(S){this.logService.error(S)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[S]of this.activeProfileSynchronizers.values())try{await S.resetLocal()}catch(D){this.logService.error(D)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),D=S.map(V=>V.collection),T=await this.userDataSyncStoreService.getAllCollections(),M=T.filter(V=>!D.includes(V));M.length&&(this.logService.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(V=>this.userDataSyncStoreService.deleteCollection(V))),this.logService.info("Deleted redundant collections on server"));const x=S.filter(V=>T.includes(V.collection));if(x.length!==S.length){this.logService.info("Updating remote profiles with invalid collections on server");const V=this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{await V.updateRemoteProfiles(x,null),this.logService.info("Updated remote profiles on server")}finally{V.dispose()}}}async performAction(S,D){const T=new R.DisposableStore;try{const M=this.activeProfileSynchronizers.get(S.id);if(M){const J=await this.performActionWithProfileSynchronizer(M[0],D,T);return(0,y.isUndefined)(J)?null:J}if(S.isDefault){const J=T.add(this.instantiationService.createInstance(s,S,void 0)),Q=await this.performActionWithProfileSynchronizer(J,D,T);return(0,y.isUndefined)(Q)?null:Q}if(this.userDataProfilesService.isEnabled())return null;const x=T.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,S,void 0)),V=await this.userDataSyncStoreService.manifest(null),z=(await x.getRemoteSyncedProfiles(V?.latest??null)||[]).find(J=>J.id===S.id);if(z){const J=T.add(this.instantiationService.createInstance(s,S,z.collection)),Q=await this.performActionWithProfileSynchronizer(J,D,T);return(0,y.isUndefined)(Q)?null:Q}return null}finally{T.dispose()}}async performActionWithProfileSynchronizer(S,D,T){const M=[...S.enabled,...S.disabled.map(x=>T.add(S.createSynchronizer(x)))];for(const x of M){const V=await D(x);if(!(0,y.isUndefined)(V))return V}}setStatus(S){const D=this._status;this._status!==S&&(this._status=S,this._onDidChangeStatus.fire(S),D==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const S=this.getActiveProfileSynchronizers().map(D=>D.conflicts).flat();(0,L.equals)(this._conflicts,S,(D,T)=>D.profile.id===T.profile.id&&D.syncResource===T.syncResource&&(0,L.equals)(D.conflicts,T.conflicts,(M,x)=>(0,P.isEqual)(M.previewResource,x.previewResource)))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(S,D){let T=this.activeProfileSynchronizers.get(S.id);if(T&&T[0].collection!==D?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.activeProfileSynchronizers.delete(S.id)),!T){const M=new R.DisposableStore,x=M.add(this.instantiationService.createInstance(s,S,D?.collection));M.add(x.onDidChangeStatus(V=>this.setStatus(V))),M.add(x.onDidChangeConflicts(V=>this.updateConflicts())),M.add(x.onDidChangeLocal(V=>this._onDidChangeLocal.fire(V))),this.activeProfileSynchronizers.set(S.id,T=[x,M])}return T[0]}getActiveProfileSynchronizers(){const S=[];for(const[D]of this.activeProfileSynchronizers.values())S.push(D);return S}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,S])=>S.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=ve([Y(0,n.IUserDataSyncStoreService),Y(1,n.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,n.IUserDataSyncLogService),Y(4,b.ITelemetryService),Y(5,p.IStorageService),Y(6,n.IUserDataSyncEnablementService),Y(7,c.IUserDataProfilesService),Y(8,n.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let s=class extends R.Disposable{get enabled(){return this._enabled.sort((S,D)=>S[1]-D[1]).map(([S])=>S)}get disabled(){return n.ALL_SYNC_RESOURCES.filter(S=>!this.userDataSyncEnablementService.isResourceEnabled(S))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(S,D,T,M,x,V,q,z,J,Q){super(),this.profile=S,this.collection=D,this.userDataSyncEnablementService=T,this.instantiationService=M,this.extensionGalleryService=x,this.userDataSyncStoreManagementService=V,this.telemetryService=q,this.logService=z,this.userDataProfilesService=J,this.configurationService=Q,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(T.onDidChangeResourceEnablement(([K,X])=>this.onDidChangeResourceEnablement(K,X))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,K])=>K.dispose())));for(const K of n.ALL_SYNC_RESOURCES)T.isResourceEnabled(K)&&this.registerSynchronizer(K)}onDidChangeResourceEnablement(S,D){D?this.registerSynchronizer(S):this.deRegisterSynchronizer(S)}registerSynchronizer(S){if(this._enabled.some(([x])=>x.resource===S))return;if(S==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled()))return;const D=new R.DisposableStore,T=D.add(this.createSynchronizer(S));D.add(T.onDidChangeStatus(()=>this.updateStatus())),D.add(T.onDidChangeConflicts(()=>this.updateConflicts())),D.add(T.onDidChangeLocal(()=>this._onDidChangeLocal.fire(S)));const M=this.getOrder(S);this._enabled.push([T,M,D])}deRegisterSynchronizer(S){const D=this._enabled.findIndex(([T])=>T.resource===S);if(D!==-1){const[[T,,M]]=this._enabled.splice(D,1);M.dispose(),this.updateStatus(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,x=>this.logService.error(x))}}createSynchronizer(S){switch(S){case"settings":return this.instantiationService.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(k.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(d.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(S,D,T,M){if(M.isCancellationRequested)return[];const x=this.enabled;if(!x.length)return[];try{const V=[],q=(0,n.createSyncHeaders)(T),z=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,J=D?await this.getUserDataSyncConfiguration(z):{};for(const Q of x){if(M.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(Q.resource))return[];try{if(D){const K=await Q.preview(z,J,q);if(K)for(const X of K.resourcePreviews)(X.localChange!==0||X.remoteChange!==0)&&X.mergeState==="preview"&&await Q.merge(X.previewResource)}else await Q.sync(z,q)}catch(K){const X=n.UserDataSyncError.toUserDataSyncError(K);if(h(X,T,this.userDataSyncStoreManagementService,this.telemetryService),a(K))throw X;this.logService.error(K),this.logService.error(`${Q.resource}: ${(0,A.toErrorMessage)(K)}`),V.push([Q.resource,X])}}return V}finally{this.updateStatus()}}async apply(S,D){const T=(0,n.createSyncHeaders)(S);for(const M of this.enabled){if(D.isCancellationRequested)return;try{await M.apply(!1,T)}catch(x){const V=n.UserDataSyncError.toUserDataSyncError(x);if(h(V,S,this.userDataSyncStoreManagementService,this.telemetryService),a(x))throw V;this.logService.error(x),this.logService.error(`${M.resource}: ${(0,A.toErrorMessage)(x)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(D){this.logService.error(D)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(D){this.logService.error(`${S.resource}: ${(0,A.toErrorMessage)(D)}`),this.logService.error(D)}}async getUserDataSyncConfiguration(S){if(!this.profile.isDefault)return{};const D=this.configurationService.getValue(n.USER_DATA_SYNC_CONFIGURATION_SCOPE),T=this.enabled.find(M=>M instanceof v.SettingsSynchroniser);if(T){const M=await T.getRemoteUserDataSyncConfiguration(S);return{...D,...M}}return D}setStatus(S){this._status!==S&&(this._status=S,this._onDidChangeStatus.fire(S))}updateStatus(){return this.updateConflicts(),this.enabled.some(S=>S.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const S=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,L.equals)(this._conflicts,S,(D,T)=>D.syncResource===T.syncResource&&(0,L.equals)(D.conflicts,T.conflicts,(M,x)=>(0,P.isEqual)(M.previewResource,x.previewResource)))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}getOrder(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};s=ve([Y(2,n.IUserDataSyncEnablementService),Y(3,f.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,n.IUserDataSyncStoreManagementService),Y(6,b.ITelemetryService),Y(7,n.IUserDataSyncLogService),Y(8,c.IUserDataProfilesService),Y(9,E.IConfigurationService)],s);function a(w){if(w instanceof n.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(w,S,D,T){T.publicLog2("sync/error",{code:w.code,serverCode:w instanceof n.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof n.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:S,service:D.userDataSyncStore.url.toString()})}}),define(oe[283],ae([0,1,3,2,12,18,24]),function(ie,e,L,O,l,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(m,f){return{...m,profile:(0,A.reviveProfile)(m.profile,f.profilesHome.scheme)}}function P(m){return{created:m.created,uri:l.URI.revive(m.uri)}}class y{constructor(f,p,b){this.service=f,this.userDataProfilesService=p,this.logService=b,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(f,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(f,p,b){try{return await this._call(f,p,b)}catch(c){throw this.logService.error(c),c}}async _call(f,p,b){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(l.URI.revive(b[0]));case"accept":return this.service.accept(R(b[0],this.userDataProfilesService),l.URI.revive(b[1]),b[2],b[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0],b[1]?(0,A.reviveProfile)(b[1],this.userDataProfilesService.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0],b[1]);case"replace":return this.service.replace(P(b[0]));case"getAssociatedResources":return this.service.getAssociatedResources(P(b[0]));case"getMachineId":return this.service.getMachineId(P(b[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const c=p.substring(11),d=b[0],u=this.getManualSyncTask(d);switch(b=b.slice(1),c){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.manualSyncTasks.delete(this.createKey(u.id)));case"stop":return u.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(u.id)))}}throw new Error("Invalid call")}getManualSyncTask(f){const p=this.manualSyncTasks.get(this.createKey(f));if(!p)throw new Error(`Manual sync taks not found: ${f}`);return p}async createManualSyncTask(){const f=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(f.id),f),f.id}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=y;let I=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(f,p){super(),this.userDataProfilesService=p,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(b,c,d){return f.call(b,c,d).then(null,u=>{throw _.UserDataSyncError.toUserDataSyncError(u)})},listen(b,c){return f.listen(b,c)}},this.channel.call("_getInitialData").then(([b,c,d])=>{this.updateStatus(b),this.updateConflicts(c),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(b=>this.updateConflicts(b))),this._register(this.channel.listen("onSyncErrors")(b=>this._onSyncErrors.fire(b.map(c=>({...c,error:_.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.channel.call("createManualSyncTask"),p=this;return new E(f,{async call(c,d,u){return p.channel.call(`manualSync/${c}`,[f,...Array.isArray(d)?d:[d]],u)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,p,b,c){return this.channel.call("accept",[f,p,b,c])}resolveContent(f){return this.channel.call("resolveContent",[f])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,p){return(await this.channel.call("getLocalSyncResourceHandles",[f,p])).map(({created:c,uri:d})=>({created:c,uri:l.URI.revive(d)}))}async getRemoteSyncResourceHandles(f,p){return(await this.channel.call("getRemoteSyncResourceHandles",[f,p])).map(({created:c,uri:d})=>({created:c,uri:l.URI.revive(d)}))}async getAssociatedResources(f){return(await this.channel.call("getAssociatedResources",[f])).map(({resource:b,comparableResource:c})=>({resource:l.URI.revive(b),comparableResource:l.URI.revive(c)}))}getMachineId(f){return this.channel.call("getMachineId",[f])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(f){return this.channel.call("replace",[f])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(p=>({syncResource:p.syncResource,profile:(0,A.reviveProfile)(p.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:p.conflicts.map(b=>({...b,baseResource:l.URI.revive(b.baseResource),localResource:l.URI.revive(b.localResource),remoteResource:l.URI.revive(b.remoteResource),previewResource:l.URI.revive(b.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}};I=ve([Y(1,A.IUserDataProfilesService)],I),e.UserDataSyncChannelClient=I;class E extends O.Disposable{constructor(f,p){super(),this.id=f,this.channel=p}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(oe[284],ae([0,1,6,25,10,3,2,143,4,23,11,12,31,17,15,13,26,59,44,20,24]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const k="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",n="sync.machine-session-id",t=100,r=1e3*60*5;let s=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(v.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(T){this.storageService.store(v.SYNC_SERVICE_URL_TYPE,T,-1,P.isWeb?0:1)}constructor(T,M,x){super(),this.productService=T,this.configurationService=M,this.storageService=x,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(x.onDidChangeValue,V=>V.key===v.SYNC_SERVICE_URL_TYPE&&V.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[v.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(T,M){T=P.isWeb&&T?.web?{...T,...T.web}:T;const x={...T||{},...M||{}};if(x&&(0,I.isString)(x.url)&&(0,I.isObject)(x.authenticationProviders)&&Object.keys(x.authenticationProviders).every(V=>Array.isArray(x.authenticationProviders[V].scopes))){const V=x,q=!!V.canSwitch&&!M?.url,z=V.url===V.insidersUrl?"insiders":"stable",J=(q?this.userDataSyncStoreType:void 0)||z,Q=M?.url||(J==="insiders"?V.insidersUrl:J==="stable"?V.stableUrl:V.url);return{url:E.URI.parse(Q),type:J,defaultType:z,defaultUrl:E.URI.parse(V.url),stableUrl:E.URI.parse(V.stableUrl),insidersUrl:E.URI.parse(V.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(V.authenticationProviders).reduce((K,X)=>(K.push({id:X,scopes:V.authenticationProviders[X].scopes}),K),[])}}}};s=ve([Y(0,c.IProductService),Y(1,f.IConfigurationService),Y(2,g.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let a=class extends s{constructor(T,M,x){super(T,M,x);const V=this.storageService.get(k,-1);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const q=this.productService[v.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(k,JSON.stringify(q),-1,1):this.storageService.remove(k,-1)}async switch(T){T!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=T,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=ve([Y(0,c.IProductService),Y(1,f.IConfigurationService),Y(2,g.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(T,M,x,V,q,z,J){super(),this.requestService=x,this.logService=V,this.storageService=J,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(T),this.commonHeadersPromise=(0,u.getServiceMachineId)(q,z,J).then(Q=>{const K={"X-Client-Name":`${M.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(K["X-Client-Commit"]=M.commit),K}),this.session=new S(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(T,M){this.authToken={token:T,type:M}}updateUserDataSyncStoreUrl(T){this.userDataSyncStoreUrl=T?(0,y.joinPath)(T,"v1"):void 0}initDonotMakeRequestsUntil(){const T=this.storageService.getNumber(i,-1);T&&Date.now()<T&&this.setDonotMakeRequestsUntil(new Date(T))}setDonotMakeRequestsUntil(T){this._donotMakeRequestsUntil?.getTime()!==T?.getTime()&&(this._donotMakeRequestsUntil=T,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();T={...T},T["Content-Type"]="application/json";const x=await this.request(M,{type:"GET",headers:T},[],O.CancellationToken.None);return(await(0,d.asJson)(x))?.map(({id:V})=>V)||[]}async createCollection(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();T={...T},T["Content-Type"]=R.Mimes.text;const x=await this.request(M,{type:"POST",headers:T},[],O.CancellationToken.None),V=await(0,d.asTextOrError)(x);if(!V)throw new v.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",x.res.statusCode,x.res.headers[v.HEADER_OPERATION_ID]);return V}async deleteCollection(T,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=T?(0,y.joinPath)(this.userDataSyncStoreUrl,"collection",T).toString():(0,y.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request(x,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=this.getResourceUrl(this.userDataSyncStoreUrl,M,T),V={},q=await this.request(x.toString(),{type:"GET",headers:V},[],O.CancellationToken.None);return(await(0,d.asJson)(q)||[]).map(({url:J,created:Q})=>({ref:(0,y.relativePath)(x,x.with({path:J})),created:Q*1e3}))}async resolveResourceContent(T,M,x,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,x,T),M).toString();V={...V},V["Cache-Control"]="no-cache";const z=await this.request(q,{type:"GET",headers:V},[],O.CancellationToken.None);return await(0,d.asTextOrError)(z)}async deleteResource(T,M,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=M!==null?(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,x,T),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,x,T).toString(),q={};await this.request(V,{type:"DELETE",headers:q},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,y.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.request(T,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async readResource(T,M,x,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,y.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,x,T),"latest").toString();V={...V},V["Cache-Control"]="no-cache",M&&(V["If-None-Match"]=M.ref);const z=await this.request(q,{type:"GET",headers:V},[304],O.CancellationToken.None);let J=null;if(z.res.statusCode===304&&(J=M),J===null){const Q=z.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);const K=await(0,d.asTextOrError)(z);if(!K&&z.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",q,"EmptyResponse",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);J={ref:Q,content:K}}return J}async writeResource(T,M,x,V,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=this.getResourceUrl(this.userDataSyncStoreUrl,V,T).toString();q={...q},q["Content-Type"]=R.Mimes.text,x&&(q["If-Match"]=x);const J=await this.request(z,{type:"POST",data:M,headers:q},[],O.CancellationToken.None),Q=J.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",J.res.statusCode,J.res.headers[v.HEADER_OPERATION_ID]);return Q}async manifest(T,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,y.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const V=await this.request(x,{type:"GET",headers:M},[304],O.CancellationToken.None);let q=null;if(V.res.statusCode===304&&(q=T),!q){const J=V.res.headers.etag;if(!J)throw new v.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",V.res.statusCode,V.res.headers[v.HEADER_OPERATION_ID]);const Q=await(0,d.asTextOrError)(V);if(!Q&&V.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",x,"EmptyResponse",V.res.statusCode,V.res.headers[v.HEADER_OPERATION_ID]);Q&&(q={...JSON.parse(Q),ref:J})}const z=this.storageService.get(o,-1);return z&&q&&z!==q.session&&this.clearSession(),q===null&&z&&this.clearSession(),q&&this.storageService.store(o,q.session,-1,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}getResourceUrl(T,M,x){return M?(0,y.joinPath)(T,"collection",M,"resource",x):(0,y.joinPath)(T,"resource",x)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(n,-1)}async request(T,M,x,V){if(!this.authToken)throw new v.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;M.headers={...M.headers||{},...q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let z;try{z=await this.session.request(T,M,V)}catch(j){if(!(j instanceof v.UserDataSyncStoreError)){let F="RequestFailed";const ee=(0,l.getErrorMessage)(j).toLowerCase();ee.includes("xhr timeout")?F="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?F="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":ee.includes("headers must be an object")?F="RequestHeadersNotObject":(0,l.isCancellationError)(j)&&(F="RequestCanceled"),j=new v.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,F,void 0,void 0)}throw this.logService.info("Request failed",T),j}const J=z.res.headers[v.HEADER_OPERATION_ID],Q={url:T,status:z.res.statusCode,"execution-id":M.headers[v.HEADER_EXECUTION_ID],"operation-id":J},K=(0,d.isSuccess)(z)||z.res.statusCode&&x.indexOf(z.res.statusCode)!==-1;let X="";if(K?this.logService.trace("Request succeeded",Q):(this.logService.info("Request failed",Q),X=await(0,d.asText)(z)||""),z.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new v.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",z.res.statusCode,J);if(this._onTokenSucceed.fire(),z.res.statusCode===404)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",z.res.statusCode,J);if(z.res.statusCode===405)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${X}`,T,"MethodNotFound",z.res.statusCode,J);if(z.res.statusCode===409)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",z.res.statusCode,J);if(z.res.statusCode===410)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",z.res.statusCode,J);if(z.res.statusCode===412)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",z.res.statusCode,J);if(z.res.statusCode===413)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",z.res.statusCode,J);if(z.res.statusCode===426)throw new v.UserDataSyncStoreError(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",z.res.statusCode,J);if(z.res.statusCode===429){const j=z.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",z.res.statusCode,J)):new v.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",z.res.statusCode,J)}if(!K)throw new v.UserDataSyncStoreError("Server returned "+z.res.statusCode,T,"Unknown",z.res.statusCode,J);return z}addSessionHeaders(T){let M=this.storageService.get(n,-1);M===void 0&&(M=(0,m.generateUuid)(),this.storageService.store(n,M,-1,1)),T["X-Machine-Session-Id"]=M;const x=this.storageService.get(o,-1);x!==void 0&&(T["X-User-Session-Id"]=x)}};h=ve([Y(1,c.IProductService),Y(2,d.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,p.IEnvironmentService),Y(5,b.IFileService),Y(6,g.IStorageService)],h),e.UserDataSyncStoreClient=h;let w=class extends h{constructor(T,M,x,V,q,z,J){super(T.userDataSyncStore?.url,M,x,V,q,z,J),this._register(T.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(T.userDataSyncStore?.url)))}};w=ve([Y(0,v.IUserDataSyncStoreManagementService),Y(1,c.IProductService),Y(2,d.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,p.IEnvironmentService),Y(5,b.IFileService),Y(6,g.IStorageService)],w),e.UserDataSyncStoreService=w;class S{constructor(T,M,x,V){this.limit=T,this.interval=M,this.requestService=x,this.logService=V,this.requests=[],this.startTime=void 0}request(T,M,x){if(this.isExpired()&&this.reset(),M.url=T,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new v.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(T),this.requestService.request(M,x)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=S}),define(oe[285],ae([0,1,3,57,26,20,19,280,24,77,80]),function(ie,e,L,O,l,A,_,R,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(f,p,b,c,d,u,g,v,k,i,o){super(f,p,b,c,d,g,v,k,i,o),this._register(L.Event.debounce(L.Event.any(L.Event.map(u.onDidFocusWindow,()=>"windowFocus"),L.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};E=ve([Y(0,l.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,y.IUserDataSyncAccountService),Y(8,_.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,A.IStorageService)],E),e.UserDataAutoSyncService=E}),define(oe[286],ae([0,1,103,22,4,23]),function(ie,e,L,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(y){function I(){let E=y.scheme===O.Schemas.file?(0,A.originalFSPath)(y):y.toString();return l.isLinux||(E=E.toLowerCase()),(0,L.createHash)("md5").update(E).digest("hex")}return{id:I(),configPath:y}}e.getWorkspaceIdentifier=_;function R(y,I){function E(){if(y.scheme!==O.Schemas.file)return(0,L.createHash)("md5").update(y.toString()).digest("hex");if(!I)return;let f;return l.isLinux?f=I.ino:l.isMacintosh?f=I.birthtime.getTime():l.isWindows&&(typeof I.birthtimeMs=="number"?f=Math.floor(I.birthtimeMs):f=I.birthtime.getTime()),(0,L.createHash)("md5").update(y.fsPath).update(f?String(f):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:y}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[287],ae([0,1,6,10,2,14,28,15,9,75,120,286,57,71]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=class extends l.Disposable{constructor(c,d,u,g){super(),this.environmentService=c,this.logService=d,this.nativeHostService=u,this.mainProcessService=g,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await _.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),d=new y.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(c.map(async u=>{const g=(0,A.join)(this.environmentService.workspaceStorageHome.fsPath,u);u.length===E.NON_EMPTY_WORKSPACE_ID_LENGTH||u===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===u)||await d.isUsed(g)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await _.Promises.rm(g))}))}catch(c){(0,O.onUnexpectedError)(c)}}};p=ve([Y(0,R.INativeEnvironmentService),Y(1,P.ILogService),Y(2,m.INativeHostService),Y(3,f.IMainProcessService)],p),e.UnusedWorkspaceStorageDataCleaner=p}),define(oe[81],ae([0,1,54,6,14,11,28,155,296,297]),function(ie,e,L,O,l,A,_,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(o,n){let t=n.message;switch(o){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=o,this.cause=n}}e.ExtractError=E;function m(i){const o=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,t)=>n+t,o&61440)}function f(i){if(i instanceof E)return i;let o;return I.test(i.message)&&(o="CorruptZip"),new E(o,i)}function p(i,o,n,t,r,s){const a=l.dirname(o),h=l.join(t,a);if(!h.startsWith(t))return Promise.reject(new Error(R.localize(0,null,o)));const w=l.join(t,o);let S;return s.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(_.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((D,T)=>{if(!s.isCancellationRequested)try{S=(0,L.createWriteStream)(w,{mode:n}),S.once("close",()=>D()),S.once("error",T),i.once("error",T),i.pipe(S)}catch(M){T(M)}}))}function b(i,o,n,t){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{r.cancel(),i.close()}),new Promise((a,h)=>{const w=new O.Sequencer,S=D=>{D.isCancellationRequested||(s++,i.readEntry())};i.once("error",h),i.once("close",()=>r.then(()=>{t.isCancellationRequested||i.entryCount===s?a():h(new E("Incomplete",new Error(R.localize(1,null,s,i.entryCount))))},h)),i.readEntry(),i.on("entry",D=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(D.fileName)){S(t);return}const T=D.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(T)){const V=l.join(o,T);r=(0,O.createCancelablePromise)(q=>_.Promises.mkdir(V,{recursive:!0}).then(()=>S(q)).then(void 0,h));return}const M=d(i,D),x=m(D);r=(0,O.createCancelablePromise)(V=>w.queue(()=>M.then(q=>p(q,T,x,o,n,V).then(()=>S(V)))).then(null,h))})})}function c(i,o=!1){return new Promise((n,t)=>{(0,P.open)(i,o?{lazyEntries:!0}:void 0,(r,s)=>{r?t(f(r)):n((0,A.assertIsDefined)(s))})})}function d(i,o){return new Promise((n,t)=>{i.openReadStream(o,(r,s)=>{r?t(f(r)):n((0,A.assertIsDefined)(s))})})}function u(i,o){return new Promise((n,t)=>{const r=new y.ZipFile;o.forEach(a=>{a.contents?r.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&r.addFile(a.localPath,a.path)}),r.end();const s=(0,L.createWriteStream)(i);r.outputStream.pipe(s),r.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>n(i))})}e.zip=u;function g(i,o,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=c(i,!0);return n.overwrite&&(s=s.then(a=>_.Promises.rm(o).then(()=>a))),s.then(a=>b(a,o,{sourcePathRegex:r},t))}e.extract=g;function v(i,o){return c(i).then(n=>new Promise((t,r)=>{n.on("entry",s=>{s.fileName===o&&d(n,s).then(a=>t(a),a=>r(a))}),n.once("close",()=>r(new Error(R.localize(2,null,o))))}))}function k(i,o){return v(i,o).then(n=>new Promise((t,r)=>{const s=[];n.once("error",r),n.on("data",a=>s.push(a)),n.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=k}),define(oe[288],ae([0,1,6,10,2,22,4,23,55,11,31,28,81,17,15,29,33,101,13,9]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class vt extends l.Disposable{constructor(i,o,n,t,r,s){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=t,this.extensionSignatureVerificationService=r,this.logService=s,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,o,n){await this.cleanUpPromise;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,t,s=>this.extensionGalleryService.download(i,s,o))}catch(s){throw new b.ExtensionManagementError(s.message,b.ExtensionManagementErrorCode.Download)}let r=!1;if(n&&this.shouldVerifySignature(i)){const s=await this.downloadSignatureArchive(i);try{r=await this.extensionSignatureVerificationService.verify(t.fsPath,s.fsPath,this.logService.getLevel()===g.LogLevel.Trace)}catch(a){const h=a;if(r=h.code,h.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${h.output}`),r===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(m.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(s)}catch(a){this.logService.error(a)}}}return r===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${i.identifier.id}`),{location:t,verificationStatus:r}}shouldVerifySignature(i){if(!i.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,y.isBoolean)(o)?o:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const o=(0,R.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${vt.SignatureArchiveExtension}`);return await this.downloadFile(i,o,n=>this.extensionGalleryService.downloadSignatureArchive(i,n)),o}async downloadFile(i,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const t=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(t)||await n(t);try{await this.rename(t,o,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(t)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,t.path),r}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async rename(i,o,n){try{await E.Promises.rename(i.fsPath,o.fsPath)}catch(t){if(_.isWindows&&t&&t.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${i} to ${o} with 'EPERM' error. Trying again...`),this.rename(i,o,n);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],t=[];for(const a of i.children)if(a.name.endsWith(vt.SignatureArchiveExtension))t.push(a.resource);else{const h=c.ExtensionKey.parse(a.name);h&&n.push([h,a])}const r=(0,c.groupByExtension)(n,([a])=>a),s=[];for(const a of r)a.sort((h,w)=>P.rcompare(h[0].version,w[0].version)),o.push(...a.slice(1).map(h=>h[1].resource)),s.push(a[0][1]);s.sort((a,h)=>a.mtime-h.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(a=>a.resource)),o.push(...t),await L.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?c.ExtensionKey.create(i).toString().toLowerCase():(0,I.generateUuid)()}};v.SignatureArchiveExtension=".sigzip",v=ve([Y(0,p.INativeEnvironmentService),Y(1,u.IFileService),Y(2,b.IExtensionGalleryService),Y(3,f.IConfigurationService),Y(4,d.IExtensionSignatureVerificationService),Y(5,g.ILogService)],v),e.ExtensionsDownloader=v}),define(oe[289],ae([0,1,81,167]),function(ie,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(A){return(0,L.buffer)(A,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=l}),define(oe[129],ae([0,1,6,16,25,38,10,3,2,37,22,14,4,23,55,11,12,31,28,81,166,100,15,269,29,33,51,78,288,270,289,224,239,67,13,5,9,26,19,30,18]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o,n,t,r,s,a,h,w,S,D,T,M,x,V,q,z,J,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,x.refineServiceDecorator)(n.IExtensionManagementService);let K=class extends o.AbstractExtensionManagementService{constructor(H,B,N,C,U,$,G,W,Z,te,ce,he){super(H,B,N,te,he),this.extensionsScannerService=U,this.extensionsProfileScannerService=$,this.downloadService=G,this.fileService=Z,this.uriIdentityService=ce,this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this.onDidUpdateExtensionMetadata=this._onDidUpdateExtensionMetadata.event,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new y.ResourceSet;const pe=this._register(W.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(X,ye=>pe.postUninstall(ye))),this.manifestCache=this._register(new S.ExtensionsManifestCache(he,Z,ce,this,this.logService)),this.extensionsDownloader=this._register(W.createInstance(a.ExtensionsDownloader));const fe=this._register(new D.ExtensionsWatcher(this,this.extensionsScannerService,he,$,ce,Z,N));this._register(fe.onDidChangeExtensionsByAnotherSource(ye=>this.onDidChangeExtensionsFromAnotherSource(ye))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,t.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(H){this.logService.trace("ExtensionManagementService#zip",H.identifier.id);const B=await this.collectFiles(H),N=await(0,g.zip)((0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,B);return c.URI.file(N)}async unzip(H){return this.logService.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:B,cleanup:N}=await this.downloadVsix(H),C=E.resolve(B.fsPath);try{return await(0,w.getManifest)(C)}finally{await N()}}getInstalled(H,B=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(H??null,B)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.extensionsScanner.scanUserExtensionAtLocation(H)}async install(H,B={}){this.logService.trace("ExtensionManagementService#install",H.toString());const{location:N,cleanup:C}=await this.downloadVsix(H);try{const U=await(0,w.getManifest)(E.resolve(N.fsPath));if(U.engines&&U.engines.vscode&&!(0,T.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,N,B)}finally{await C()}}async installFromLocation(H,B){this.logService.trace("ExtensionManagementService#installFromLocation",H.toString());const N=await this.extensionsScanner.scanUserExtensionAtLocation(H);if(!N)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.addExtensionsToProfile([[N,void 0]],B),this.logService.info("Successfully installed extension",N.identifier.id,B.toString()),N}async installExtensionsFromProfile(H,B,N){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",H,B.toString(),N.toString());const C=(await this.extensionsScanner.scanExtensions(1,B)).filter(U=>H.some($=>(0,t.areSameExtensions)($,U.identifier)));if(C.length){const U=await Promise.all(C.map($=>this.extensionsScanner.scanMetadata($,B)));await this.addExtensionsToProfile(C.map(($,G)=>[$,U[G]]),N),this.logService.info("Successfully installed extensions",C.map($=>$.identifier.id),N.toString())}return C}async updateMetadata(H,B,N=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",H.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,H=await this.extensionsScanner.updateMetadata(H,B,N),this.manifestCache.invalidate(N),this._onDidUpdateExtensionMetadata.fire(H),H}async reinstallFromGallery(H){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(1,null));const B=await this.getTargetPlatform(),[N]=await this.galleryService.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:B,compatible:!0},l.CancellationToken.None);if(!N)throw new Error(v.localize(2,null));await this.extensionsScanner.setUninstalled(H);try{await this.extensionsScanner.removeUninstalledExtension(H)}catch(C){throw new Error(v.localize(3,null,(0,A.toErrorMessage)(C)))}return this.installFromGallery(N)}copyExtensions(H,B){return this.extensionsScanner.copyExtensions(H,B)}markAsUninstalled(...H){return this.extensionsScanner.setUninstalled(...H)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(H){this.logService.error(H)}}async download(H,B,N){const{location:C}=await this.extensionsDownloader.download(H,B,!N);return C}async downloadVsix(H){if(H.scheme===I.Schemas.file)return{location:H,async cleanup(){}};this.logService.trace("Downloading extension from",H.toString());const B=(0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)());return await this.downloadService.download(H,B),this.logService.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.fileService.del(B)}catch(C){this.logService.error(C)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(H,B,N){if(c.URI.isUri(B))return new ee(H,B,N,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const C=t.ExtensionKey.create(B).toString();let U=this.installGalleryExtensionsTasks.get(C);return U||(this.installGalleryExtensionsTasks.set(C,U=new F(H,B,N,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),U.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(C))),U}createUninstallExtensionTask(H,B){return new ne(H,B.profileLocation,this.extensionsProfileScannerService)}async collectFiles(H){const B=async C=>{let U=await u.Promises.readdir(C);U=U.map(W=>E.join(C,W));const $=await Promise.all(U.map(W=>u.Promises.stat(W)));let G=Promise.resolve([]);return $.forEach((W,Z)=>{const te=U[Z];W.isFile()&&(G=G.then(ce=>[...ce,te])),W.isDirectory()&&(G=G.then(ce=>B(te).then(he=>[...ce,...he])))}),G};return(await B(H.location.fsPath)).map(C=>({path:`extension/${E.relative(H.location.fsPath,C)}`,localPath:C}))}async onDidChangeExtensionsFromAnotherSource({added:H,removed:B}){if(B)for(const N of B.extensions)this.logService.info("Extensions removed from another source",N.id,B.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:N,profileLocation:B.profileLocation});if(H){const C=(await this.extensionsScanner.scanExtensions(1,H.profileLocation)).filter(U=>H.extensions.some($=>(0,t.areSameExtensions)($,U.identifier)));this._onDidInstallExtensions.fire(C.map(U=>(this.logService.info("Extensions added from another source",U.identifier.id,H.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:H.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(B=>this.knownDirectories.add(B)));const H=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const B of H.children??[])B.isDirectory&&this.knownDirectories.add(B.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(B=>this.onDidFilesChange(B)))}async onDidFilesChange(H){if(!H.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const B=[];for(const N of H.rawAdded){if(this.knownDirectories.has(N)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(N),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(N,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(N).startsWith(".")||!(await this.fileService.stat(N)).isDirectory)continue;const C=await this.extensionsScanner.scanUserExtensionAtLocation(N);C&&C.installedTimestamp===void 0&&(this.knownDirectories.add(N),B.push(C))}B.length&&(await this.addExtensionsToProfile(B.map(N=>[N,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",B.map(N=>N.identifier.id)))}async addExtensionsToProfile(H,B){const N=H.map(C=>C[0]);await this.setInstalled(N),await this.extensionsProfileScannerService.addExtensionsToProfile(H,B),this._onDidInstallExtensions.fire(N.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:B})))}async setInstalled(H){const B=await this.extensionsScanner.getUninstalledExtensions();for(const N of H){const C=t.ExtensionKey.create(N);!B[C.toString()]||(this.logService.trace("Removing the extension from uninstalled list:",C.id),await this.extensionsScanner.setInstalled(C),this.logService.info("Removed the extension from uninstalled list:",C.id))}}};K=ve([Y(0,n.IExtensionGalleryService),Y(1,z.ITelemetryService),Y(2,V.ILogService),Y(3,i.INativeEnvironmentService),Y(4,s.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,k.IDownloadService),Y(7,x.IInstantiationService),Y(8,M.IFileService),Y(9,q.IProductService),Y(10,J.IUriIdentityService),Y(11,Q.IUserDataProfilesService)],K),e.ExtensionManagementService=K;let X=class extends P.Disposable{constructor(H,B,N,C,U,$){super(),this.beforeRemovingExtension=H,this.fileService=B,this.extensionsScannerService=N,this.extensionsProfileScannerService=C,this.uriIdentityService=U,this.logService=$,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.cleanUpGeneratedFoldersPromise=Promise.resolve(),this.uninstalledResource=(0,f.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),this.cleanUpGeneratedFoldersPromise=this.cleanUpGeneratedFoldersPromise.then(()=>this.removeGeneratedFolders()),await this.cleanUpGeneratedFoldersPromise}async scanExtensions(H,B){const N={includeInvalid:!0,profileLocation:B};let C=[];return H===null||H===0?C.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},N,!1)):H===1&&C.push(...await this.extensionsScannerService.scanUserExtensions(N)),C=H!==null?C.filter(U=>U.type===H):C,Promise.all(C.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(H){const B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return Promise.all(B.map(N=>this.toLocalExtension(N)))}async scanUserExtensionAtLocation(H){try{const B=await this.extensionsScannerService.scanExistingExtension(H,1,{includeInvalid:!0});if(B)return await this.toLocalExtension(B)}catch(B){this.logService.error(B)}return null}async extractUserExtension(H,B,N,C){await this.cleanUpGeneratedFoldersPromise.catch(()=>{});const U=H.toString(),$=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),G=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(G)}catch{throw new n.ExtensionManagementError(v.localize(4,null,G,H.id),n.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(H,B,$,C),await this.extensionsScannerService.updateMetadata(c.URI.file($),N);try{this._onExtract.fire(c.URI.file(G)),await this.rename(H,$,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(W){try{await u.Promises.rm($)}catch{}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(W)}. Deleted from extracted location`,$),W}return this.scanLocalExtension(c.URI.file(G),1)}async scanMetadata(H,B){return B?(await this.extensionsProfileScannerService.scanProfileExtensions(B)).find(C=>(0,t.areSameExtensions)(C.identifier,H.identifier))?.metadata:this.extensionsScannerService.scanMetadata(H.location)}async updateMetadata(H,B,N){return N?await this.extensionsProfileScannerService.updateMetadata([[H,B]],N):await this.extensionsScannerService.updateMetadata(H.location,B),this.scanLocalExtension(H.location,H.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...H){const B=H.map(N=>t.ExtensionKey.create(N));await this.withUninstalledExtensions(N=>B.forEach(C=>{N[C.toString()]=!0,this.logService.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(H){await this.withUninstalledExtensions(B=>delete B[H.toString()])}async removeExtension(H,B){this.logService.trace(`Deleting ${B} extension from disk`,H.identifier.id,H.location.fsPath);const N=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(H.location),`.${(0,d.generateUuid)()}`);await this.rename(H.identifier,H.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.fileService.del(N,{recursive:!0}),this.logService.info("Deleted from disk",H.identifier.id,H.location.fsPath)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.withUninstalledExtensions(B=>delete B[t.ExtensionKey.create(H).toString()])}async copyExtensions(H,B){const N=await this.scanExtensions(1,H),C=await Promise.all(N.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,H)]));await this.extensionsProfileScannerService.addExtensionsToProfile(C,B)}async withUninstalledExtensions(H){return this.uninstalledFileLimiter.queue(async()=>{let B;try{B=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(C){if((0,M.toFileOperationResult)(C)!==1)throw C}let N={};if(B)try{N=JSON.parse(B)}catch{}return H&&(H(N),Object.keys(N).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(N))):await this.fileService.del(this.uninstalledResource)),N})}async extractAtLocation(H,B,N,C){this.logService.trace(`Started extracting the extension from ${B} to ${N}`);try{await u.Promises.rm(N)}catch(U){throw new n.ExtensionManagementError(this.joinErrors(U).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(B,N,{sourcePath:"extension",overwrite:!0},C),this.logService.info(`Extracted extension to ${N}:`,H.id)}catch(U){try{await u.Promises.rm(N)}catch{}let $=n.ExtensionManagementErrorCode.Extract;throw U instanceof g.ExtractError&&(U.type==="CorruptZip"?$=n.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&($=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(U.message,$)}}async rename(H,B,N,C){try{await u.Promises.rename(B,N)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<C)return this.logService.info(`Failed renaming ${B} to ${N} with 'EPERM' error. Trying again...`,H.id),this.rename(H,B,N,C);throw new n.ExtensionManagementError(U.message||v.localize(5,null,B,N),U.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(H,B){const N=await this.extensionsScannerService.scanExistingExtension(H,B,{includeInvalid:!0});if(N)return this.toLocalExtension(N);throw new Error(v.localize(6,null,H.path))}async toLocalExtension(H){const B=await this.fileService.resolve(H.location);let N,C;return B.children&&(N=B.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,C=B.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:N,changelogUrl:C,publisherDisplayName:H.metadata?.publisherDisplayName||null,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned}}async removeUninstalledExtensions(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(H));const B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const U of B)H[t.ExtensionKey.create(U).toString()]||N.add(U.identifier.id.toLowerCase());try{const U=(0,t.groupByExtension)(B,$=>$.identifier);await L.Promises.settled(U.map(async $=>{const G=$.sort((W,Z)=>p.rcompare(W.manifest.version,Z.manifest.version))[0];N.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch(U){this.logService.error(U)}const C=B.filter(U=>U.metadata&&H[t.ExtensionKey.create(U).toString()]);await Promise.allSettled(C.map(U=>this.removeUninstalledExtension(U)))}async removeGeneratedFolders(){this.logService.trace("ExtensionManagementService#removeGeneratedFolders");const H=[];let B;try{B=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(N){(0,M.toFileOperationResult)(N)!==1&&this.logService.error(N)}for(const N of B?.children??[])N.isDirectory&&N.name.startsWith(".")&&(0,d.isUUID)(N.name.substring(1))&&H.push((async()=>{this.logService.trace("Deleting the generated extension folder",N.resource.toString());try{await this.fileService.del(N.resource,{recursive:!0}),this.logService.info("Deleted the generated extension folder",N.resource.toString())}catch(C){this.logService.error(C)}})());await Promise.allSettled(H)}joinErrors(H){const B=Array.isArray(H)?H:[H];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((N,C)=>new Error(`${N.message}${N.message?",":""}${C instanceof Error?C.message:C}`),new Error(""))}};X=ve([Y(1,M.IFileService),Y(2,s.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,J.IUriIdentityService),Y(5,V.ILogService)],X),e.ExtensionsScanner=X;class j extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(H,B,N,C,U,$,G,W,Z){super(),this.identifier=H,this.source=B,this.options=N,this.extensionsScanner=C,this.uriIdentityService=U,this.userDataProfilesService=$,this.extensionsScannerService=G,this.extensionsProfileScannerService=W,this.logService=Z,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(H){const[B,N]=await this.install(H);return this._profileLocation=B.isBuiltin||B.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[B,N]],this._profileLocation),B}async extractExtension({zipPath:H,key:B,metadata:N},C){let U=await this.unsetIfUninstalled(B);return U||(this.logService.trace("Extracting extension...",B.id),U=await this.extensionsScanner.extractUserExtension(B,H,N,C),this.logService.info("Extracting extension completed.",B.id)),U}async unsetIfUninstalled(H){return await this.isUninstalled(H)?(this.logService.trace("Removing the extension from uninstalled list:",H.id),await this.extensionsScanner.setInstalled(H),this.logService.info("Removed the extension from uninstalled list:",H.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(C=>t.ExtensionKey.create(C).equals(H))):void 0}async isUninstalled(H){return!!(await this.extensionsScanner.getUninstalledExtensions())[H.toString()]}}class F extends j{constructor(H,B,N,C,U,$,G,W,Z,te){super(B.identifier,B,N,U,$,G,W,Z,te),this.gallery=B,this.extensionsDownloader=C}async install(H){const N=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(G=>(0,t.areSameExtensions)(G.identifier,this.gallery.identifier));N&&(this._operation=3);const C={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(N,C),C];const{location:U,verificationStatus:$}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=$,this.validateManifest(U.fsPath),[await this.extractExtension({zipPath:U.fsPath,key:t.ExtensionKey.create(this.gallery),metadata:C},H),C]}catch(G){try{await this.extensionsDownloader.delete(U)}catch(W){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,_.getErrorMessage)(W))}throw G}}async validateManifest(H){try{await(0,w.getManifest)(H)}catch(B){throw new n.ExtensionManagementError((0,o.joinErrors)(B).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=F;class ee extends j{constructor(H,B,N,C,U,$,G,W,Z,te){super({id:(0,t.getGalleryExtensionId)(H.publisher,H.name)},B,N,U,$,G,W,Z,te),this.manifest=H,this.location=B,this.galleryService=C}async doRun(H){const B=await super.doRun(H);return this.updateMetadata(B,H),B}async install(H){const B=new t.ExtensionKey(this.identifier,this.manifest.version),C=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(G=>(0,t.areSameExtensions)(this.identifier,G.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(C)if(this._operation=3,B.equals(new t.ExtensionKey(C.identifier,C.manifest.version)))try{await this.extensionsScanner.removeExtension(C,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(C.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(C);else{const G=await this.unsetIfUninstalled(B);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(v.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:E.resolve(this.location.fsPath),key:B,metadata:U},H),U]}async updateMetadata(H,B){try{let[N]=await this.galleryService.getExtensions([{id:H.identifier.id,version:H.manifest.version}],B);if(N||([N]=await this.galleryService.getExtensions([{id:H.identifier.id}],B)),N){const C={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(H,C,this.options.profileLocation)}}catch{}}}class ne extends o.AbstractExtensionTask{constructor(H,B,N){super(),this.extension=H,this.profileLocation=B,this.extensionsProfileScannerService=N}async doRun(H){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(oe[290],ae([0,1,2,29,79,238,129,9,20]),function(ie,e,L,O,l,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let y=class extends L.Disposable{constructor(E,m,f,p,b,c){super(),E.cleanUp(),(0,A.migrateUnsupportedExtensions)(E,m,f,p,c),l.ExtensionStorageService.removeOutdatedExtensionVersions(E,b)}};y=ve([Y(0,_.INativeServerExtensionManagementService),Y(1,O.IExtensionGalleryService),Y(2,l.IExtensionStorageService),Y(3,O.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,R.ILogService)],y),e.ExtensionsContributions=y}),define(oe[298],ae([0,1,151,231,250,34,38,10,2,22,12,39,153,217,218,210,211,287,201,203,17,222,99,235,100,228,15,232,121,273,29,101,202,129,102,13,213,214,68,5,209,70,72,241,9,107,108,26,59,20,113,19,114,115,116,46,244,118,253,79,119,24,77,278,264,265,80,279,282,283,284,61,277,267,112,234,76,255,226,254,111,30,256,4,257,204,220,219,78,272,18,51,216,58,276,243,268,110,281,290,7,215,266,87,106,236,271,229,198,57,285,274,71,275]),function(ie,e,L,O,l,A,_,R,P,y,I,E,m,f,p,b,c,d,u,g,v,k,i,o,n,t,r,s,a,h,w,S,D,T,M,x,V,q,z,J,Q,K,X,j,F,ee,ne,se,H,B,N,C,U,$,G,W,Z,te,ce,he,pe,fe,ye,Ce,Re,ke,ze,Ke,le,de,ge,Pe,Ie,Ne,Le,We,Me,Oe,Fe,re,ue,me,we,Se,be,De,_e,Ae,Ue,xe,$e,et,nt,St,Dt,Rt,kt,yt,Lt,_t,Tt,At,Ot,Xe,wt,Ut,Mt,Nt,Ft,xt,$t,Wt,Et,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class qt extends P.Disposable{constructor(Ee,Te){super(),this.configuration=Ee,this.ipcRenderer=Te,this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,(0,Xe.isUtilityProcess)(process)?this.server=this._register(new m.Server):this.server=this._register(new L.Server),this.registerListeners()}registerListeners(){let Ee=!1;const Te=()=>{Ee||(Ee=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Te),(0,Xe.isUtilityProcess)(process)?(0,m.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Te):this.ipcRenderer.once("vscode:electron-main->shared-process=exit",Te),!(0,Xe.isUtilityProcess)(process)){const je="vscode:electron-main->shared-process=disposeWorker",qe=(rt,Ve)=>{this.onDisposeWorker(Ve)};this.ipcRenderer.on(je,qe),this._register((0,P.toDisposable)(()=>this.ipcRenderer.removeListener(je,qe)))}}onDisposeWorker(Ee){this.sharedProcessWorkerService?.disposeWorker(Ee)}async init(){const Ee=await this.initServices();(0,fe.registerConfiguration)(),Ee.invokeFunction(Te=>{const je=Te.get(F.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Te),this.registerErrorHandler(je)}),this._register((0,P.combinedDisposable)(Ee.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),Ee.createInstance(p.LanguagePackCachedDataCleaner),Ee.createInstance(d.UnusedWorkspaceStorageDataCleaner),Ee.createInstance(c.LogsDataCleaner),Ee.createInstance(b.LocalizationsUpdater),Ee.createInstance(_t.ExtensionsContributions),Ee.createInstance(kt.UserDataProfilesCleaner)))}async initServices(){const Ee=new K.ServiceCollection,Te={_serviceBrand:void 0,...ne.default};Ee.set(se.IProductService,Te);const je=new E.StaticRouter(Ge=>Ge==="main"),qe=new Et.MainProcessService(this.server,je);Ee.set(Et.IMainProcessService,qe);const rt=this.configuration.policiesData?new nt.PolicyChannelClient(this.configuration.policiesData,qe.getChannel("policy")):new St.NullPolicyService;Ee.set(St.IPolicyService,rt);const Ve=new s.SharedProcessEnvironmentService(this.configuration.args,Te);Ee.set(r.INativeEnvironmentService,Ve);const Qe=new ee.LoggerChannelClient(void 0,this.configuration.logLevel,Ve.logsHome,this.configuration.loggers.map(Ge=>({...Ge,resource:I.URI.revive(Ge.resource)})),qe.getChannel("logger"));Ee.set(F.ILoggerService,Qe);const ct=this._register(Qe.createLogger("sharedprocess",{name:(0,Tt.localize)(0,null)})),dt=this._register(new F.ConsoleLogger(ct.getLevel())),He=this._register(new At.LogService(ct,[dt]));Ee.set(F.ILogService,He),this.lifecycleService=this._register(new wt.SharedProcessLifecycleService(He)),Ee.set(wt.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new O.SharedProcessWorkerService(He),Ee.set(ue.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ze=this._register(new V.FileService(He));Ee.set(x.IFileService,Ze);const ft=this._register(new q.DiskFileSystemProvider(He));Ze.registerProvider(y.Schemas.file,ft);const gt=this._register(new be.FileUserDataProvider(y.Schemas.file,this._register(new De.DiskFileSystemProviderClient(qe.getChannel(De.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Se.isLinux})),y.Schemas.vscodeUserData,He));Ze.registerProvider(y.Schemas.vscodeUserData,gt);const tt=this._register(new Dt.UserDataProfilesService(this.configuration.profiles.all,I.URI.revive(this.configuration.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),qe.getChannel("userDataProfiles")));Ee.set($e.IUserDataProfilesService,tt);const Ye=this._register(new k.ConfigurationService(tt.defaultProfile.settingsResource,Ze,rt,He));Ee.set(v.IConfigurationService,Ye);const st=new zt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},qe,Ve);Ee.set(B.IStorageService,st),this._register((0,P.toDisposable)(()=>st.flush())),await Promise.all([Ye.initialize(),st.initialize()]);const mt=new we.UriIdentityService(Ze);Ee.set(me.IUriIdentityService,mt),Ee.set(H.IRequestService,new Nt.RequestChannelClient(qe.getChannel("request"))),Ee.set(u.IChecksumService,new z.SyncDescriptor(g.ChecksumService,void 0,!1)),Ee.set(Ae.IV8InspectProfilingService,new z.SyncDescriptor(_e.InspectProfilingService,void 0,!1));const lt=E.ProxyChannel.toService(qe.getChannel("nativeHost"),{context:this.configuration.windowId});Ee.set(xt.INativeHostService,lt),Ee.set(n.IDownloadService,new z.SyncDescriptor(t.DownloadService,void 0,!0));const pt=this._register(new Ne.ActiveWindowManager(lt)),jt=new E.StaticRouter(Ge=>pt.getActiveClientId().then(ht=>Ge===ht));Ee.set(M.IExtensionRecommendationNotificationService,new Ft.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",jt)));let ut;const ot=[],Ct=(0,W.isInternalTelemetry)(Te,Ye);if((0,W.supportsTelemetry)(Te,Ve)){const Ge=new $.TelemetryLogAppender(He,Qe,Ve,Te);if(ot.push(Ge),Te.aiConfig?.ariaKey){const ht=new Rt.OneDataSystemAppender(Ct,"monacoworkbench",null,Te.aiConfig.ariaKey);this._register((0,P.toDisposable)(()=>ht.flush())),ot.push(ht)}ut=new G.TelemetryService({appenders:ot,commonProperties:(0,N.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,Te.commit,Te.version,this.configuration.machineId,Ct),sendErrorTelemetry:!0,piiPaths:(0,W.getPiiPathsFromEnvironment)(Ve)},Ye,Te)}else{ut=W.NullTelemetryService;const Ge=W.NullAppender;ot.push(Ge)}this.server.registerChannel("telemetryAppender",new U.TelemetryAppenderChannel(ot)),Ee.set(C.ITelemetryService,ut);const Vt=new Z.CustomEndpointTelemetryService(Ye,ut,He,Qe,Ve,Te);Ee.set(C.ICustomEndpointTelemetryService,Vt),Ee.set(et.IExtensionsProfileScannerService,new z.SyncDescriptor(Mt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Ue.IExtensionsScannerService,new z.SyncDescriptor(xe.ExtensionsScannerService,void 0,!0)),Ee.set(S.IExtensionSignatureVerificationService,new z.SyncDescriptor(S.ExtensionSignatureVerificationService,void 0,!0)),Ee.set(T.INativeServerExtensionManagementService,new z.SyncDescriptor(T.ExtensionManagementService,void 0,!0)),Ee.set(w.IExtensionGalleryService,new z.SyncDescriptor(h.ExtensionGalleryService,void 0,!0)),Ee.set(w.IExtensionTipsService,new z.SyncDescriptor(Wt.ExtensionTipsService,void 0,!1)),Ee.set(X.ILanguagePackService,new z.SyncDescriptor(j.NativeLanguagePackService,void 0,!1)),Ee.set(i.IDiagnosticsService,new z.SyncDescriptor(o.DiagnosticsService,void 0,!1)),Ee.set(ye.IUserDataSyncAccountService,new z.SyncDescriptor(ye.UserDataSyncAccountService,void 0,!0)),Ee.set(fe.IUserDataSyncLogService,new z.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),Ee.set(fe.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Ee.set(w.IGlobalExtensionEnablementService,new z.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),Ee.set(pe.IIgnoredExtensionsManagementService,new z.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),Ee.set(he.IExtensionStorageService,new z.SyncDescriptor(he.ExtensionStorageService)),Ee.set(fe.IUserDataSyncStoreManagementService,new z.SyncDescriptor(ge.UserDataSyncStoreManagementService,void 0,!0)),Ee.set(fe.IUserDataSyncStoreService,new z.SyncDescriptor(ge.UserDataSyncStoreService,void 0,!0)),Ee.set(ze.IUserDataSyncMachinesService,new z.SyncDescriptor(ze.UserDataSyncMachinesService,void 0,!0)),Ee.set(fe.IUserDataSyncBackupStoreService,new z.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),Ee.set(fe.IUserDataSyncEnablementService,new z.SyncDescriptor(Ke.UserDataSyncEnablementService,void 0,!0)),Ee.set(fe.IUserDataSyncService,new z.SyncDescriptor(le.UserDataSyncService,void 0,!1)),Ee.set(Pe.IUserDataProfileStorageService,new z.SyncDescriptor(Ie.NativeUserDataProfileStorageService,void 0,!0)),Ee.set(fe.IUserDataSyncResourceProviderService,new z.SyncDescriptor(Lt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new ce.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Ye,Ve,He,Qe);return Pt.initialize(),Ee.set(l.ILocalPtyService,this._register(Pt)),Ee.set(Le.ISignService,new z.SyncDescriptor(We.SignService,void 0,!1)),Ee.set(Me.ISharedTunnelsService,new z.SyncDescriptor(Oe.SharedTunnelsService)),Ee.set(Fe.ISharedProcessTunnelService,new z.SyncDescriptor(re.SharedProcessTunnelService)),Ee.set(yt.IRemoteTunnelService,new z.SyncDescriptor(Ut.RemoteTunnelService)),new Q.InstantiationService(Ee)}initChannels(Ee){const Te=new D.ExtensionManagementChannel(Ee.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Te);const je=E.ProxyChannel.fromService(Ee.get(X.ILanguagePackService));this.server.registerChannel("languagePacks",je);const qe=E.ProxyChannel.fromService(Ee.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",qe);const rt=new D.ExtensionTipsChannel(Ee.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",rt);const Ve=E.ProxyChannel.fromService(Ee.get(u.IChecksumService));this.server.registerChannel("checksum",Ve);const Qe=E.ProxyChannel.fromService(Ee.get(Ae.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const ct=new Re.UserDataSyncMachinesServiceChannel(Ee.get(ze.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ct);const dt=E.ProxyChannel.fromService(Ee.get(C.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",dt);const He=new Re.UserDataSyncAccountServiceChannel(Ee.get(ye.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ze=new Re.UserDataSyncStoreManagementServiceChannel(Ee.get(fe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ze);const ft=new de.UserDataSyncChannel(Ee.get(fe.IUserDataSyncService),Ee.get($e.IUserDataProfilesService),Ee.get(F.ILogService));this.server.registerChannel("userDataSync",ft);const gt=this._register(Ee.get(J.IInstantiationService).createInstance($t.UserDataAutoSyncService)),tt=new Re.UserDataAutoSyncChannel(gt);this.server.registerChannel("userDataAutoSync",tt);const Ye=Ee.get(l.ILocalPtyService),st=E.ProxyChannel.fromService(Ye);this.server.registerChannel(te.TerminalIpcChannels.LocalPty,st);const mt=E.ProxyChannel.fromService(Ee.get(Fe.ISharedProcessTunnelService));this.server.registerChannel(Fe.ipcSharedProcessTunnelChannelName,mt);const lt=E.ProxyChannel.fromService(Ee.get(ue.ISharedProcessWorkerService));this.server.registerChannel(Ot.ipcUtilityProcessWorkerChannelName,lt);const pt=E.ProxyChannel.fromService(Ee.get(yt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",pt)}registerErrorHandler(Ee){(0,Xe.isUtilityProcess)(process)?(process.on("uncaughtException",Te=>(0,R.onUnexpectedError)(Te)),process.on("unhandledRejection",Te=>(0,R.onUnexpectedError)(Te))):globalThis.addEventListener("unhandledrejection",Te=>{(0,R.onUnexpectedError)(Te.reason),Te.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Te=>{const je=(0,_.toErrorMessage)(Te,!0);!je||Ee.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function bt(at){let Ee;(0,Xe.isUtilityProcess)(process)||(Ee=(await new Promise((je,qe)=>{ie(["electron"],je,qe)})).ipcRenderer);const Te=new qt(at,Ee);(0,Xe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):Ee.send("vscode:shared-process->electron-main=ipc-ready"),await Te.init(),(0,Xe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):Ee.send("vscode:shared-process->electron-main=init-done")}e.main=bt,(0,Xe.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{bt(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
