/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/process","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/environment/node/userDataPath","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],a=0,P=re.length;a<P;a++)e[a]=Ce[re[a]];return e};define(Ce[61],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(T,k){const y=Object.create(null);for(const v of T){const R=k(v);let I=y[R];I||(I=y[R]=[]),I.push(v)}return y}e.groupBy=a;function P(T,k){const y=[],v=[];for(const R of T)k.has(R)||y.push(R);for(const R of k)T.has(R)||v.push(R);return{removed:y,added:v}}e.diffSets=P;function l(T,k){const y=[],v=[];for(const[R,I]of T)k.has(R)||y.push(I);for(const[R,I]of k)T.has(R)||v.push(I);return{removed:y,added:v}}e.diffMaps=l;class A{constructor(){this.map=new Map}add(k,y){let v=this.map.get(k);v||(v=new Set,this.map.set(k,v)),v.add(y)}delete(k,y){const v=this.map.get(k);!v||(v.delete(y),v.size===0&&this.map.delete(k))}forEach(k,y){const v=this.map.get(k);!v||v.forEach(y)}}e.SetMap=A}),define(Ce[62],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(T){return(k,y,v)=>{let R=null,I=null;if(typeof v.value=="function"?(R="value",I=v.value):typeof v.get=="function"&&(R="get",I=v.get),!I)throw new Error("not supported");v[R]=T(I,y)}}function P(T,k,y){let v=null,R=null;if(typeof y.value=="function"?(v="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(v="get",R=y.get),!R)throw new Error("not supported");const I=`$memoize$${k}`;y[v]=function(..._){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,_)}),this[I]}}e.memoize=P;function l(T,k,y){return a((v,R)=>{const I=`$debounce$${R}`,_=`$debounce$result$${R}`;return function(...D){this[_]||(this[_]=y?y():void 0),clearTimeout(this[I]),k&&(this[_]=k(this[_],...D),D=[this[_]]),this[I]=setTimeout(()=>{v.apply(this,D),this[_]=y?y():void 0},T)}})}e.debounce=l;function A(T,k,y){return a((v,R)=>{const I=`$throttle$timer$${R}`,_=`$throttle$result$${R}`,D=`$throttle$lastRun$${R}`,C=`$throttle$pending$${R}`;return function(...E){if(this[_]||(this[_]=y?y():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),k&&(this[_]=k(this[_],...E)),this[C])return;const n=this[D]+T;n<=Date.now()?(this[D]=Date.now(),v.apply(this,[this[_]]),this[_]=y?y():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[D]=Date.now(),v.apply(this,[this[_]]),this[_]=y?y():void 0},n-Date.now()))}})}e.throttle=A}),define(Ce[8],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?S.isErrorNoTelemetry(o)?new S(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(r=>{r(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=a,e.errorHandler=new a;function P(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=P;function l(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(t){v(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function T(t){v(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=T;function k(t){if(t instanceof Error){const{name:o,message:r}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:o,message:r,stack:c,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const y="Canceled";function v(t){return t instanceof R?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=v;class R extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=R;function I(){const t=new Error(y);return t.name=t.message,t}e.canceled=I;function _(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=_;function D(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=D;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function E(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class h extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=h;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class S extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof S)return o;const r=new S;return r.message=o.message,r.stack=o.stack,r}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(Ce[18],De([1,0,8]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function P(ie,ne=0){return ie[ie.length-(1+ne)]}e.tail=P;function l(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}e.tail2=l;function A(ie,ne,de=(ee,ce)=>ee===ce){if(ie===ne)return!0;if(!ie||!ne||ie.length!==ne.length)return!1;for(let ee=0,ce=ie.length;ee<ce;ee++)if(!de(ie[ee],ne[ee]))return!1;return!0}e.equals=A;function T(ie,ne){const de=ie.length-1;ne<de&&(ie[ne]=ie[de]),ie.pop()}e.removeFastWithoutKeepingOrder=T;function k(ie,ne,de){return y(ie.length,ee=>de(ie[ee],ne))}e.binarySearch=k;function y(ie,ne){let de=0,ee=ie-1;for(;de<=ee;){const ce=(de+ee)/2|0,ae=ne(ce);if(ae<0)de=ce+1;else if(ae>0)ee=ce-1;else return ce}return-(de+1)}e.binarySearch2=y;function v(ie,ne){let de=0,ee=ie.length;if(ee===0)return 0;for(;de<ee;){const ce=Math.floor((de+ee)/2);ne(ie[ce])?ee=ce:de=ce+1}return de}e.findFirstInSorted=v;function R(ie,ne,de){if(ie=ie|0,ie>=ne.length)throw new TypeError("invalid index");const ee=ne[Math.floor(ne.length*Math.random())],ce=[],ae=[],O=[];for(const B of ne){const K=de(B,ee);K<0?ce.push(B):K>0?ae.push(B):O.push(B)}return ie<ce.length?R(ie,ce,de):ie<ce.length+O.length?O[0]:R(ie-(ce.length+O.length),ae,de)}e.quickSelect=R;function I(ie,ne){const de=[];let ee;for(const ce of ie.slice(0).sort(ne))!ee||ne(ee[0],ce)!==0?(ee=[ce],de.push(ee)):ee.push(ce);return de}e.groupBy=I;function _(ie,ne,de){const ee=[];function ce(B,K,Z){if(K===0&&Z.length===0)return;const he=ee[ee.length-1];he&&he.start+he.deleteCount===B?(he.deleteCount+=K,he.toInsert.push(...Z)):ee.push({start:B,deleteCount:K,toInsert:Z})}let ae=0,O=0;for(;;){if(ae===ie.length){ce(ae,0,ne.slice(O));break}if(O===ne.length){ce(ae,ie.length-ae,[]);break}const B=ie[ae],K=ne[O],Z=de(B,K);Z===0?(ae+=1,O+=1):Z<0?(ce(ae,1,[]),ae+=1):Z>0&&(ce(ae,0,[K]),O+=1)}return ee}e.sortedDiff=_;function D(ie,ne,de){const ee=_(ie,ne,de),ce=[],ae=[];for(const O of ee)ce.push(...ie.slice(O.start,O.start+O.deleteCount)),ae.push(...O.toInsert);return{removed:ce,added:ae}}e.delta=D;function C(ie,ne,de){if(de===0)return[];const ee=ie.slice(0,de).sort(ne);return n(ie,ne,ee,de,ie.length),ee}e.top=C;function E(ie,ne,de,ee,ce){return de===0?Promise.resolve([]):new Promise((ae,O)=>{(async()=>{const B=ie.length,K=ie.slice(0,de).sort(ne);for(let Z=de,he=Math.min(de+ee,B);Z<B;Z=he,he=Math.min(he+ee,B)){if(Z>de&&await new Promise(_e=>setTimeout(_e)),ce&&ce.isCancellationRequested)throw new a.CancellationError;n(ie,ne,K,Z,he)}return K})().then(ae,O)})}e.topAsync=E;function n(ie,ne,de,ee,ce){for(const ae=de.length;ee<ce;ee++){const O=ie[ee];if(ne(O,de[ae-1])<0){de.pop();const B=v(de,K=>ne(O,K)<0);de.splice(B,0,O)}}}function d(ie){return ie.filter(ne=>!!ne)}e.coalesce=d;function h(ie){let ne=0;for(let de=0;de<ie.length;de++)ie[de]&&(ie[ne]=ie[de],ne+=1);ie.length=ne}e.coalesceInPlace=h;function w(ie,ne,de){ie.splice(de,0,ie.splice(ne,1)[0])}e.move=w;function S(ie){return!Array.isArray(ie)||ie.length===0}e.isFalsyOrEmpty=S;function p(ie){return Array.isArray(ie)&&ie.length>0}e.isNonEmptyArray=p;function t(ie,ne=de=>de){const de=new Set;return ie.filter(ee=>{const ce=ne(ee);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function o(ie){const ne=new Set;return de=>{const ee=ie(de);return ne.has(ee)?!1:(ne.add(ee),!0)}}e.uniqueFilter=o;function r(ie,ne){const de=c(ie,ne);if(de!==-1)return ie[de]}e.findLast=r;function c(ie,ne){for(let de=ie.length-1;de>=0;de--){const ee=ie[de];if(ne(ee))return de}return-1}e.lastIndex=c;function m(ie,ne){return ie.length>0?ie[0]:ne}e.firstOrDefault=m;function f(ie,ne){return ie.length>0?ie[ie.length-1]:ne}e.lastOrDefault=f;function i(ie,ne,de=(ee,ce)=>ee===ce){let ee=0;for(let ce=0,ae=Math.min(ie.length,ne.length);ce<ae&&de(ie[ce],ne[ce]);ce++)ee++;return ee}e.commonPrefixLength=i;function s(ie){return[].concat(...ie)}e.flatten=s;function u(ie,ne){let de=typeof ne=="number"?ie:0;typeof ne=="number"?de=ie:(de=0,ne=ie);const ee=[];if(de<=ne)for(let ce=de;ce<ne;ce++)ee.push(ce);else for(let ce=de;ce>ne;ce--)ee.push(ce);return ee}e.range=u;function b(ie,ne,de){return ie.reduce((ee,ce)=>(ee[ne(ce)]=de?de(ce):ce,ee),Object.create(null))}e.index=b;function g(ie,ne){return ie.push(ne),()=>L(ie,ne)}e.insert=g;function L(ie,ne){const de=ie.indexOf(ne);if(de>-1)return ie.splice(de,1),ne}e.remove=L;function H(ie,ne,de){const ee=ie.slice(0,ne),ce=ie.slice(ne);return ee.concat(de,ce)}e.arrayInsert=H;function q(ie,ne){let de;if(typeof ne=="number"){let ee=ne;de=()=>{const ce=Math.sin(ee++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let ee=ie.length-1;ee>0;ee-=1){const ce=Math.floor(de()*(ee+1)),ae=ie[ee];ie[ee]=ie[ce],ie[ce]=ae}}e.shuffle=q;function X(ie,ne){const de=ie.indexOf(ne);de>-1&&(ie.splice(de,1),ie.unshift(ne))}e.pushToStart=X;function U(ie,ne){const de=ie.indexOf(ne);de>-1&&(ie.splice(de,1),ie.push(ne))}e.pushToEnd=U;function N(ie,ne){for(const de of ne)ie.push(de)}e.pushMany=N;function x(ie,ne){return Array.isArray(ie)?ie.map(ne):ne(ie)}e.mapArrayOrNot=x;function F(ie){return Array.isArray(ie)?ie:[ie]}e.asArray=F;function V(ie){return ie[Math.floor(Math.random()*ie.length)]}e.getRandomElement=V;function fe(ie,ne){for(const de of ie){const ee=ne(de);if(ee!==void 0)return ee}}e.mapFind=fe;function se(ie,ne,de){const ee=J(ie,ne),ce=ie.length,ae=de.length;ie.length=ce+ae;for(let O=ce-1;O>=ee;O--)ie[O+ae]=ie[O];for(let O=0;O<ae;O++)ie[O+ee]=de[O]}e.insertInto=se;function $(ie,ne,de,ee){const ce=J(ie,ne),ae=ie.splice(ce,de);return se(ie,ce,ee),ae}e.splice=$;function J(ie,ne){return ne<0?Math.max(ne+ie.length,0):Math.min(ne,ie.length)}var te;(function(ie){function ne(ce){return ce<0}ie.isLessThan=ne;function de(ce){return ce>0}ie.isGreaterThan=de;function ee(ce){return ce===0}ie.isNeitherLessOrGreaterThan=ee,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function be(ie,ne){return(de,ee)=>ne(ie(de),ie(ee))}e.compareBy=be;function le(...ie){return(ne,de)=>{for(const ee of ie){const ce=ee(ne,de);if(!te.isNeitherLessOrGreaterThan(ce))return ce}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const ue=(ie,ne)=>ie-ne;e.numberComparator=ue;function j(ie,ne){if(ie.length===0)return;let de=ie[0];for(let ee=1;ee<ie.length;ee++){const ce=ie[ee];ne(ce,de)>0&&(de=ce)}return de}e.findMaxBy=j;function M(ie,ne){if(ie.length===0)return;let de=ie[0];for(let ee=1;ee<ie.length;ee++){const ce=ie[ee];ne(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=M;function Y(ie,ne){return j(ie,(de,ee)=>-ne(de,ee))}e.findMinBy=Y;class ge{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let de=this.firstIdx;for(;de<this.items.length&&ne(this.items[de]);)de++;const ee=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,ee}takeFromEndWhile(ne){let de=this.lastIdx;for(;de>=0&&ne(this.items[de]);)de--;const ee=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,ee}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}removeLast(){const ne=this.items[this.lastIdx];return this.lastIdx--,ne}takeCount(ne){const de=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,de}}e.ArrayQueue=ge;class we{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(de=>(ne(de),!0))}toArray(){const ne=[];return this.iterate(de=>(ne.push(de),!0)),ne}filter(ne){return new we(de=>this.iterate(ee=>ne(ee)?de(ee):!0))}map(ne){return new we(de=>this.iterate(ee=>de(ne(ee))))}some(ne){let de=!1;return this.iterate(ee=>(de=ne(ee),!de)),de}findFirst(ne){let de;return this.iterate(ee=>ne(ee)?(de=ee,!1):!0),de}findLast(ne){let de;return this.iterate(ee=>(ne(ee)&&(de=ee),!0)),de}findLastMaxBy(ne){let de,ee=!0;return this.iterate(ce=>((ee||te.isGreaterThan(ne(ce,de)))&&(ee=!1,de=ce),!0)),de}}we.empty=new we(ie=>{}),e.CallbackIterable=we}),define(Ce[51],De([1,0,8]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function P(y,v){if(!y)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=P;function l(y,v="Unreachable"){throw new Error(v)}e.assertNever=l;function A(y){if(!y)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function T(y){if(!y()){debugger;y(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function k(y,v){let R=0;for(;R<y.length-1;){const I=y[R],_=y[R+1];if(!v(I,_))return!1;R++}return!0}e.checkAdjacentItems=k}),define(Ce[63],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(P){const l=this;let A=!1,T;return function(){return A||(A=!0,T=P.apply(l,arguments)),T}}e.once=a}),define(Ce[102],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(l){this._prefix=l,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ce[64],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(P){function l(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}P.is=l;const A=Object.freeze([]);function T(){return A}P.empty=T;function*k(S){yield S}P.single=k;function y(S){return l(S)?S:k(S)}P.wrap=y;function v(S){return S||A}P.from=v;function R(S){return!S||S[Symbol.iterator]().next().done===!0}P.isEmpty=R;function I(S){return S[Symbol.iterator]().next().value}P.first=I;function _(S,p){for(const t of S)if(p(t))return!0;return!1}P.some=_;function D(S,p){for(const t of S)if(p(t))return t}P.find=D;function*C(S,p){for(const t of S)p(t)&&(yield t)}P.filter=C;function*E(S,p){let t=0;for(const o of S)yield p(o,t++)}P.map=E;function*n(...S){for(const p of S)for(const t of p)yield t}P.concat=n;function d(S,p,t){let o=t;for(const r of S)o=p(o,r);return o}P.reduce=d;function*h(S,p,t=S.length){for(p<0&&(p+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);p<t;p++)yield S[p]}P.slice=h;function w(S,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,S];const o=S[Symbol.iterator]();for(let r=0;r<p;r++){const c=o.next();if(c.done)return[t,P.empty()];t.push(c.value)}return[t,{[Symbol.iterator](){return o}}]}P.consume=w})(a=e.Iterable||(e.Iterable={}))}),define(Ce[147],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(t,o=!1){let r=0;const c=t.length;let m="",f=0,i=16,s=0;function u(U){let N=0,x=0;for(;N<U;){const F=t.charCodeAt(r);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;r++,N++}return N<U&&(x=-1),x}function b(U){r=U,m="",f=0,i=16,s=0}function g(){const U=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&v(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&v(t.charCodeAt(r)))for(r++;r<t.length&&v(t.charCodeAt(r));)r++;else return s=3,t.substring(U,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&v(t.charCodeAt(r))){for(r++;r<t.length&&v(t.charCodeAt(r));)r++;N=r}else s=3;return t.substring(U,N)}function L(){let U="",N=r;for(;;){if(r>=c){U+=t.substring(N,r),s=2;break}const x=t.charCodeAt(r);if(x===34){U+=t.substring(N,r),r++;break}if(x===92){if(U+=t.substring(N,r),r++,r>=c){s=2;break}switch(t.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=u(4);V>=0?U+=String.fromCharCode(V):s=4;break}default:s=5}N=r;continue}if(x>=0&&x<=31)if(y(x)){U+=t.substring(N,r),s=2;break}else s=6;r++}return U}function H(){if(m="",s=0,f=r,r>=c)return f=c,i=17;let U=t.charCodeAt(r);if(k(U)){do r++,m+=String.fromCharCode(U),U=t.charCodeAt(r);while(k(U));return i=15}if(y(U))return r++,m+=String.fromCharCode(U),U===13&&t.charCodeAt(r)===10&&(r++,m+=`
`),i=14;switch(U){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,m=L(),i=10;case 47:{const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!y(t.charCodeAt(r));)r++;return m=t.substring(N,r),i=12}if(t.charCodeAt(r+1)===42){r+=2;const x=c-1;let F=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,s=1),m=t.substring(N,r),i=13}return m+=String.fromCharCode(U),r++,i=16}case 45:if(m+=String.fromCharCode(U),r++,r===c||!v(t.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=g(),i=11;default:for(;r<c&&q(U);)r++,U=t.charCodeAt(r);if(f!==r){switch(m=t.substring(f,r),m){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return m+=String.fromCharCode(U),r++,i=16}}function q(U){if(k(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let U;do U=H();while(U>=12&&U<=15);return U}return{setPosition:b,getPosition:()=>r,scan:o?X:H,getToken:()=>i,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>s}}e.createScanner=T;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,o){const r=[],c=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function s(u,b,g,L){f.value=u,f.offset=b,f.length=g,f.type=L,f.colonOffset=void 0,m=f}try{w(t,{onObjectBegin:(u,b)=>{if(o<=u)throw c;m=void 0,i=o>u,r.push("")},onObjectProperty:(u,b,g)=>{if(o<b||(s(u,b,g,"property"),r[r.length-1]=u,o<=b+g))throw c},onObjectEnd:(u,b)=>{if(o<=u)throw c;m=void 0,r.pop()},onArrayBegin:(u,b)=>{if(o<=u)throw c;m=void 0,r.push(0)},onArrayEnd:(u,b)=>{if(o<=u)throw c;m=void 0,r.pop()},onLiteralValue:(u,b,g)=>{if(o<b||(s(u,b,g,p(u)),o<=b+g))throw c},onSeparator:(u,b,g)=>{if(o<=b)throw c;if(u===":"&&m&&m.type==="property")m.colonOffset=b,i=!1,m=void 0;else if(u===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(i=!0,r[r.length-1]=""),m=void 0}}})}catch(u){if(u!==c)throw u}return{path:r,previousNode:m,isAtPropertyKey:i,matches:u=>{let b=0;for(let g=0;b<u.length&&g<r.length;g++)if(u[b]===r[g]||u[b]==="*")b++;else if(u[b]!=="**")return!1;return b===u.length}}}e.getLocation=I;function _(t,o=[],r=A.DEFAULT){let c=null,m=[];const f=[];function i(u){Array.isArray(m)?m.push(u):c!==null&&(m[c]=u)}return w(t,{onObjectBegin:()=>{const u={};i(u),f.push(m),m=u,c=null},onObjectProperty:u=>{c=u},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const u=[];i(u),f.push(m),m=u,c=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:i,onError:(u,b,g)=>{o.push({error:u,offset:b,length:g})}},r),m[0]}e.parse=_;function D(t,o=[],r=A.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(u){c.type==="property"&&(c.length=u-c.offset,c=c.parent)}function f(u){return c.children.push(u),u}w(t,{onObjectBegin:u=>{c=f({type:"object",offset:u,length:-1,parent:c,children:[]})},onObjectProperty:(u,b,g)=>{c=f({type:"property",offset:b,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:u,offset:b,length:g,parent:c})},onObjectEnd:(u,b)=>{c.length=u+b-c.offset,c=c.parent,m(u+b)},onArrayBegin:(u,b)=>{c=f({type:"array",offset:u,length:-1,parent:c,children:[]})},onArrayEnd:(u,b)=>{c.length=u+b-c.offset,c=c.parent,m(u+b)},onLiteralValue:(u,b,g)=>{f({type:p(u),offset:b,length:g,parent:c,value:u}),m(b+g)},onSeparator:(u,b,g)=>{c.type==="property"&&(u===":"?c.colonOffset=b:u===","&&m(b))},onError:(u,b,g)=>{o.push({error:u,offset:b,length:g})}},r);const s=c.children[0];return s&&delete s.parent,s}e.parseTree=D;function C(t,o){if(!t)return;let r=t;for(const c of o)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let m=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===c){r=f.children[1],m=!0;break}if(!m)return}else{const m=c;if(r.type!=="array"||m<0||!Array.isArray(r.children)||m>=r.children.length)return;r=r.children[m]}return r}e.findNodeAtLocation=C;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.getNodePath=E;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const o=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(o[r.children[0].value]=n(c))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function d(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.contains=d;function h(t,o,r=!1){if(d(t,o,r)){const c=t.children;if(Array.isArray(c))for(let m=0;m<c.length&&c[m].offset<=o;m++){const f=h(c[m],o,r);if(f)return f}return t}}e.findNodeAtOffset=h;function w(t,o,r=A.DEFAULT){const c=T(t,!1);function m(be){return be?()=>be(c.getTokenOffset(),c.getTokenLength()):()=>!0}function f(be){return be?le=>be(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const i=m(o.onObjectBegin),s=f(o.onObjectProperty),u=m(o.onObjectEnd),b=m(o.onArrayBegin),g=m(o.onArrayEnd),L=f(o.onLiteralValue),H=f(o.onSeparator),q=m(o.onComment),X=f(o.onError),U=r&&r.disallowComments,N=r&&r.allowTrailingComma;function x(){for(;;){const be=c.scan();switch(c.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:U||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(be){case 12:case 13:U?F(10):q();break;case 16:F(1);break;case 15:case 14:break;default:return be}}}function F(be,le=[],ue=[]){if(X(be),le.length+ue.length>0){let j=c.getToken();for(;j!==17;){if(le.indexOf(j)!==-1){x();break}else if(ue.indexOf(j)!==-1)break;j=x()}}}function V(be){const le=c.getTokenValue();return be?L(le):s(le),x(),!0}function fe(){switch(c.getToken()){case 11:{let be=0;try{be=JSON.parse(c.getTokenValue()),typeof be!="number"&&(F(2),be=0)}catch{F(2)}L(be);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return x(),!0}function se(){return c.getToken()!==10?(F(3,[],[2,5]),!1):(V(!1),c.getToken()===6?(H(":"),x(),te()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function $(){i(),x();let be=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(be||F(4,[],[]),H(","),x(),c.getToken()===2&&N)break}else be&&F(6,[],[]);se()||F(4,[],[2,5]),be=!0}return u(),c.getToken()!==2?F(7,[2],[]):x(),!0}function J(){b(),x();let be=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(be||F(4,[],[]),H(","),x(),c.getToken()===4&&N)break}else be&&F(6,[],[]);te()||F(4,[],[4,5]),be=!0}return g(),c.getToken()!==4?F(8,[4],[]):x(),!0}function te(){switch(c.getToken()){case 3:return J();case 1:return $();case 10:return V(!0);default:return fe()}}return x(),c.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):te()?(c.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=w;function S(t,o){const r=T(t),c=[];let m,f=0,i;do switch(i=r.getPosition(),m=r.scan(),m){case 12:case 13:case 17:f!==i&&c.push(t.substring(f,i)),o!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,o)),f=r.getPosition();break}while(m!==17);return c.join("")}e.stripComments=S;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ce[65],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(l){this.executor=l,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(l){this._error=l}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=a}),define(Ce[6],De([1,0,63,64]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function T(f){A=f}if(e.setDisposableTracker=T,l){const f="__is_disposable_tracked__";T(new class{trackDisposable(i){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[f]||console.log(s)},3e3)}setParent(i,s){if(i&&i!==h.None)try{i[f]=!0}catch{}}markAsDisposed(i){if(i&&i!==h.None)try{i[f]=!0}catch{}}markAsSingleton(i){}})}function k(f){return A?.trackDisposable(f),f}function y(f){A?.markAsDisposed(f)}function v(f,i){A?.setParent(f,i)}function R(f,i){if(!!A)for(const s of f)A.setParent(s,i)}function I(f){return A?.markAsSingleton(f),f}e.markAsSingleton=I;function _(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=_;function D(f){if(P.Iterable.is(f)){const i=[];for(const s of f)if(s)try{s.dispose()}catch(u){i.push(u)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.dispose=D;function C(f){for(const i of f)_(i)&&i.dispose();return[]}e.disposeIfDisposable=C;function E(...f){const i=n(()=>D(f));return R(f,i),i}e.combinedDisposable=E;function n(f){const i=k({dispose:(0,a.once)(()=>{y(i),f()})});return i}e.toDisposable=n;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{D(this._toDispose)}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return v(i,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class h{constructor(){this._store=new d,k(this),v(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class w{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&v(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&v(i,null),i}}e.MutableDisposable=w;class S{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(i){let s=i;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,y(this))},this}}e.SafeDisposable=p;class t{constructor(){this.references=new Map}acquire(i,...s){let u=this.references.get(i);u||(u={counter:0,object:this.createReferencedObject(i,...s)},this.references.set(i,u));const{object:b}=u,g=(0,a.once)(()=>{--u.counter===0&&(this.destroyReferencedObject(i,u.object),this.references.delete(i))});return u.counter++,{object:b,dispose:g}}}e.ReferenceCollection=t;class o{constructor(i){this.referenceCollection=i}async acquire(i,...s){const u=this.referenceCollection.acquire(i,...s);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(b){throw u.dispose(),b}}}e.AsyncReferenceCollection=o;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function c(f){const i=new d;try{f(i)}finally{i.dispose()}}e.disposeOnReturn=c;class m{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){y(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{D(this._store.values())}finally{this._store.clear()}}has(i){return this._store.has(i)}get(i){return this._store.get(i)}set(i,s,u=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this._store.get(i)?.dispose(),this._store.set(i,s)}deleteAndDispose(i){this._store.get(i)?.dispose(),this._store.delete(i)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=m}),define(Ce[66],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class P{constructor(){this._first=a.Undefined,this._last=a.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===a.Undefined}clear(){let A=this._first;for(;A!==a.Undefined;){const T=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=T}this._first=a.Undefined,this._last=a.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const k=new a(A);if(this._first===a.Undefined)this._first=k,this._last=k;else if(T){const v=this._last;this._last=k,k.prev=v,v.next=k}else{const v=this._first;this._first=k,k.next=v,v.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==a.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==a.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===a.Undefined&&A.next===a.Undefined?(this._first=a.Undefined,this._last=a.Undefined):A.next===a.Undefined?(this._last=this._last.prev,this._last.next=a.Undefined):A.prev===a.Undefined&&(this._first=this._first.next,this._first.prev=a.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=P}),define(Ce[28],De([1,0]),function(re,e){"use strict";var a,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(E,n,d){let h=E.get(n);return h===void 0&&(h=d,E.set(n,h)),h}e.getOrSet=A;function T(E){const n=[];return E.forEach((d,h)=>{n.push(`${h} => ${d}`)}),`Map(${E.size}) {${n.join(", ")}}`}e.mapToString=T;function k(E){const n=[];return E.forEach(d=>{n.push(d)}),`Set(${E.size}) {${n.join(", ")}}`}e.setToString=k;class y{constructor(n,d){this.uri=n,this.value=d}}class v{constructor(n,d){this[a]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=d??v.defaultToKey):(this.map=new Map,this.toKey=n??v.defaultToKey)}set(n,d){return this.map.set(this.toKey(n),new y(n,d)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,d){typeof d<"u"&&(n=n.bind(d));for(const[h,w]of this.map)n(w.value,w.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}v.defaultToKey=E=>E.toString(),e.ResourceMap=v;class R{constructor(n,d){this[P]="ResourceSet",!n||typeof n=="function"?this._map=new v(n):(this._map=new v(d),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,d){this._map.forEach((h,w)=>n.call(d,w,w,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var I;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class _{constructor(){this[l]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,d=0){const h=this._map.get(n);if(!!h)return d!==0&&this.touch(h,d),h.value}set(n,d,h=0){let w=this._map.get(n);if(w)w.value=d,h!==0&&this.touch(w,h);else{switch(w={key:n,value:d,next:void 0,previous:void 0},h){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(n,w),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const d=this._map.get(n);if(!!d)return this._map.delete(n),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,d){const h=this._state;let w=this._head;for(;w;){if(d?n.bind(d)(w.value,w.key,this):n(w.value,w.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,d=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:h.key,done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return w}values(){const n=this,d=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:h.value,done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return w}entries(){const n=this,d=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const S={value:[h.key,h.value],done:!1};return h=h.next,S}else return{value:void 0,done:!0}}};return w}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let d=this._head,h=this.size;for(;d&&h>n;)this._map.delete(d.key),d=d.next,h--;this._head=d,this._size=h,d&&(d.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const d=n.next,h=n.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}n.next=void 0,n.previous=void 0,this._state++}touch(n,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(n===this._head)return;const h=n.next,w=n.previous;n===this._tail?(w.next=void 0,this._tail=w):(h.previous=w,w.next=h),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(d===2){if(n===this._tail)return;const h=n.next,w=n.previous;n===this._head?(h.previous=void 0,this._head=h):(h.previous=w,w.next=h),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((d,h)=>{n.push([h,d])}),n}fromJSON(n){this.clear();for(const[d,h]of n)this.set(d,h)}}e.LinkedMap=_;class D extends _{constructor(n,d=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,d=2){return super.get(n,d)}peek(n){return super.get(n,0)}set(n,d){return super.set(n,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=D;class C{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let d=this.map.get(n)||0;return d===0?!1:(d--,d===0?this.map.delete(n):this.map.set(n,d),!0)}has(n){return this.map.has(n)}}e.CounterSet=C}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[148],De([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ie,ne){for(var de=0;de<ne.length;de++){var ee=ne[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(ie,ee.key,ee)}}function a(ie,ne,de){return ne&&e(ie.prototype,ne),de&&e(ie,de),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function P(ie,ne){if(!!ie){if(typeof ie=="string")return l(ie,ne);var de=Object.prototype.toString.call(ie).slice(8,-1);if(de==="Object"&&ie.constructor&&(de=ie.constructor.name),de==="Map"||de==="Set")return Array.from(ie);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return l(ie,ne)}}function l(ie,ne){(ne==null||ne>ie.length)&&(ne=ie.length);for(var de=0,ee=new Array(ne);de<ne;de++)ee[de]=ie[de];return ee}function A(ie,ne){var de=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(de)return(de=de.call(ie)).next.bind(de);if(Array.isArray(ie)||(de=P(ie))||ne&&ie&&typeof ie.length=="number"){de&&(ie=de);var ee=0;return function(){return ee>=ie.length?{done:!0}:{done:!1,value:ie[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=T();function k(ie){re.defaults=ie}var y=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(ne){return _[ne]};function C(ie,ne){if(ne){if(y.test(ie))return ie.replace(v,D)}else if(R.test(ie))return ie.replace(I,D);return ie}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(ie){return ie.replace(E,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function h(ie,ne){ie=typeof ie=="string"?ie:ie.source,ne=ne||"";var de={replace:function(ce,ae){return ae=ae.source||ae,ae=ae.replace(d,"$1"),ie=ie.replace(ce,ae),de},getRegex:function(){return new RegExp(ie,ne)}};return de}var w=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ie,ne,de){if(ie){var ee;try{ee=decodeURIComponent(n(de)).replace(w,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ne&&!S.test(de)&&(de=m(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(ie,ne){t[" "+ie]||(o.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=u(ie,"/",!0)),ie=t[" "+ie];var de=ie.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:ie.replace(r,"$1")+ne:ne.charAt(0)==="/"?de?ne:ie.replace(c,"$1")+ne:ie+ne}var f={exec:function(){}};function i(ie){for(var ne=1,de,ee;ne<arguments.length;ne++){de=arguments[ne];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(ie[ee]=de[ee])}return ie}function s(ie,ne){var de=ie.replace(/\|/g,function(ae,O,B){for(var K=!1,Z=O;--Z>=0&&B[Z]==="\\";)K=!K;return K?"|":" |"}),ee=de.split(/ \|/),ce=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ne)ee.splice(ne);else for(;ee.length<ne;)ee.push("");for(;ce<ee.length;ce++)ee[ce]=ee[ce].trim().replace(/\\\|/g,"|");return ee}function u(ie,ne,de){var ee=ie.length;if(ee===0)return"";for(var ce=0;ce<ee;){var ae=ie.charAt(ee-ce-1);if(ae===ne&&!de)ce++;else if(ae!==ne&&de)ce++;else break}return ie.slice(0,ee-ce)}function b(ie,ne){if(ie.indexOf(ne[1])===-1)return-1;for(var de=ie.length,ee=0,ce=0;ce<de;ce++)if(ie[ce]==="\\")ce++;else if(ie[ce]===ne[0])ee++;else if(ie[ce]===ne[1]&&(ee--,ee<0))return ce;return-1}function g(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ie,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=ie),ne>>=1,ie+=ie;return de+ie}function H(ie,ne,de,ee){var ce=ne.href,ae=ne.title?C(ne.title):null,O=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){ee.state.inLink=!0;var B={type:"link",raw:de,href:ce,title:ae,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,B}return{type:"image",raw:de,href:ce,title:ae,text:C(O)}}function q(ie,ne){var de=ie.match(/^(\s+)(?:```)/);if(de===null)return ne;var ee=de[1];return ne.split(`
`).map(function(ce){var ae=ce.match(/^\s+/);if(ae===null)return ce;var O=ae[0];return O.length>=ee.length?ce.slice(ee.length):ce}).join(`
`)}var X=function(){function ie(de){this.options=de||re.defaults}var ne=ie.prototype;return ne.space=function(ee){var ce=this.rules.block.newline.exec(ee);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(ee){var ce=this.rules.block.code.exec(ee);if(ce){var ae=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:u(ae,`
`)}}},ne.fences=function(ee){var ce=this.rules.block.fences.exec(ee);if(ce){var ae=ce[0],O=q(ae,ce[3]||"");return{type:"code",raw:ae,lang:ce[2]?ce[2].trim():ce[2],text:O}}},ne.heading=function(ee){var ce=this.rules.block.heading.exec(ee);if(ce){var ae=ce[2].trim();if(/#$/.test(ae)){var O=u(ae,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ae=O.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ae,tokens:this.lexer.inline(ae)}}},ne.hr=function(ee){var ce=this.rules.block.hr.exec(ee);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(ee){var ce=this.rules.block.blockquote.exec(ee);if(ce){var ae=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ae,[]),text:ae}}},ne.list=function(ee){var ce=this.rules.block.list.exec(ee);if(ce){var ae,O,B,K,Z,he,_e,Ae,Ee,ke,Ie,He,ze=ce[1].trim(),tt=ze.length>1,Qe={type:"list",raw:"",ordered:tt,start:tt?+ze.slice(0,-1):"",loose:!1,items:[]};ze=tt?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=tt?ze:"[*+-]");for(var nt=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(He=!1,!(!(ce=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ae=ce[0],ee=ee.substring(ae.length),Ae=ce[2].split(`
`,1)[0],Ee=ee.split(`
`,1)[0],this.options.pedantic?(K=2,Ie=Ae.trimLeft()):(K=ce[2].search(/[^ ]/),K=K>4?1:K,Ie=Ae.slice(K),K+=ce[1].length),he=!1,!Ae&&/^ *$/.test(Ee)&&(ae+=Ee+`
`,ee=ee.substring(Ee.length+1),He=!0),!He)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),z=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(ke=ee.split(`
`,1)[0],Ae=ke,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Ae)||z.test(Ae)||st.test(Ae)||Ue.test(ee)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())Ie+=`
`+Ae.slice(K);else if(!he)Ie+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ae+=ke+`
`,ee=ee.substring(ke.length+1)}Qe.loose||(_e?Qe.loose=!0:/\n *\n *$/.test(ae)&&(_e=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(Ie),O&&(B=O[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ae,task:!!O,checked:B,loose:!1,text:Ie}),Qe.raw+=ae}Qe.items[Qe.items.length-1].raw=ae.trimRight(),Qe.items[Qe.items.length-1].text=Ie.trimRight(),Qe.raw=Qe.raw.trimRight();var Q=Qe.items.length;for(Z=0;Z<Q;Z++){this.lexer.state.top=!1,Qe.items[Z].tokens=this.lexer.blockTokens(Qe.items[Z].text,[]);var me=Qe.items[Z].tokens.filter(function(Oe){return Oe.type==="space"}),Re=me.every(function(Oe){for(var Ve=Oe.raw.split(""),Xe=0,Ke=A(Ve),rt;!(rt=Ke()).done;){var ct=rt.value;if(ct===`
`&&(Xe+=1),Xe>1)return!0}return!1});!Qe.loose&&me.length&&Re&&(Qe.loose=!0,Qe.items[Z].loose=!0)}return Qe}},ne.html=function(ee){var ce=this.rules.block.html.exec(ee);if(ce){var ae={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]);ae.type="paragraph",ae.text=O,ae.tokens=this.lexer.inline(O)}return ae}},ne.def=function(ee){var ce=this.rules.block.def.exec(ee);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ae=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ae,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(ee){var ce=this.rules.block.table.exec(ee);if(ce){var ae={type:"table",header:s(ce[1]).map(function(_e){return{text:_e}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=ce[0];var O=ae.align.length,B,K,Z,he;for(B=0;B<O;B++)/^ *-+: *$/.test(ae.align[B])?ae.align[B]="right":/^ *:-+: *$/.test(ae.align[B])?ae.align[B]="center":/^ *:-+ *$/.test(ae.align[B])?ae.align[B]="left":ae.align[B]=null;for(O=ae.rows.length,B=0;B<O;B++)ae.rows[B]=s(ae.rows[B],ae.header.length).map(function(_e){return{text:_e}});for(O=ae.header.length,K=0;K<O;K++)ae.header[K].tokens=this.lexer.inline(ae.header[K].text);for(O=ae.rows.length,K=0;K<O;K++)for(he=ae.rows[K],Z=0;Z<he.length;Z++)he[Z].tokens=this.lexer.inline(he[Z].text);return ae}}},ne.lheading=function(ee){var ce=this.rules.block.lheading.exec(ee);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(ee){var ce=this.rules.block.paragraph.exec(ee);if(ce){var ae=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ae,tokens:this.lexer.inline(ae)}}},ne.text=function(ee){var ce=this.rules.block.text.exec(ee);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(ee){var ce=this.rules.inline.escape.exec(ee);if(ce)return{type:"escape",raw:ce[0],text:C(ce[1])}},ne.tag=function(ee){var ce=this.rules.inline.tag.exec(ee);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]):ce[0]}},ne.link=function(ee){var ce=this.rules.inline.link.exec(ee);if(ce){var ae=ce[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var O=u(ae.slice(0,-1),"\\");if((ae.length-O.length)%2===0)return}else{var B=b(ce[2],"()");if(B>-1){var K=ce[0].indexOf("!")===0?5:4,Z=K+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,Z).trim(),ce[3]=""}}var he=ce[2],_e="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],_e=Ae[3])}else _e=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ae)?he=he.slice(1):he=he.slice(1,-1)),H(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:_e&&_e.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(ee,ce){var ae;if((ae=this.rules.inline.reflink.exec(ee))||(ae=this.rules.inline.nolink.exec(ee))){var O=(ae[2]||ae[1]).replace(/\s+/g," ");if(O=ce[O.toLowerCase()],!O||!O.href){var B=ae[0].charAt(0);return{type:"text",raw:B,text:B}}return H(ae,O,ae[0],this.lexer)}},ne.emStrong=function(ee,ce,ae){ae===void 0&&(ae="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=O[1]||O[2]||"";if(!B||B&&(ae===""||this.rules.inline.punctuation.exec(ae))){var K=O[0].length-1,Z,he,_e=K,Ae=0,Ee=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,ce=ce.slice(-1*ee.length+K);(O=Ee.exec(ce))!=null;)if(Z=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Z){if(he=Z.length,O[3]||O[4]){_e+=he;continue}else if((O[5]||O[6])&&K%3&&!((K+he)%3)){Ae+=he;continue}if(_e-=he,!(_e>0)){if(he=Math.min(he,he+_e+Ae),Math.min(K,he)%2){var ke=ee.slice(1,K+O.index+he);return{type:"em",raw:ee.slice(0,K+O.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var Ie=ee.slice(2,K+O.index+he-1);return{type:"strong",raw:ee.slice(0,K+O.index+he+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},ne.codespan=function(ee){var ce=this.rules.inline.code.exec(ee);if(ce){var ae=ce[2].replace(/\n/g," "),O=/[^ ]/.test(ae),B=/^ /.test(ae)&&/ $/.test(ae);return O&&B&&(ae=ae.substring(1,ae.length-1)),ae=C(ae,!0),{type:"codespan",raw:ce[0],text:ae}}},ne.br=function(ee){var ce=this.rules.inline.br.exec(ee);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(ee){var ce=this.rules.inline.del.exec(ee);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(ee,ce){var ae=this.rules.inline.autolink.exec(ee);if(ae){var O,B;return ae[2]==="@"?(O=C(this.options.mangle?ce(ae[1]):ae[1]),B="mailto:"+O):(O=C(ae[1]),B=O),{type:"link",raw:ae[0],text:O,href:B,tokens:[{type:"text",raw:O,text:O}]}}},ne.url=function(ee,ce){var ae;if(ae=this.rules.inline.url.exec(ee)){var O,B;if(ae[2]==="@")O=C(this.options.mangle?ce(ae[0]):ae[0]),B="mailto:"+O;else{var K;do K=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(K!==ae[0]);O=C(ae[0]),ae[1]==="www."?B="http://"+O:B=O}return{type:"link",raw:ae[0],text:O,href:B,tokens:[{type:"text",raw:O,text:O}]}}},ne.inlineText=function(ee,ce){var ae=this.rules.inline.text.exec(ee);if(ae){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]):ae[0]:O=C(this.options.smartypants?ce(ae[0]):ae[0]),{type:"text",raw:ae[0],text:O}}},ie}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=h(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=h(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=h(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=h(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=h(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=h(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=i({},U),U.gfm=i({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=h(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=h(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=i({},U.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:h(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=h(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=h(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=h(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=h(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=h(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=h(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=h(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=h(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=h(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=h(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=h(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=i({},N),N.pedantic=i({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=i({},N.normal,{escape:h(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=h(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=i({},N.gfm,{br:h(N.br).replace("{2,}","*").getRegex(),text:h(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ie){var ne="",de,ee,ce=ie.length;for(de=0;de<ce;de++)ee=ie.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ne+="&#"+ee+";";return ne}var V=function(){function ie(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||re.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:U.normal,inline:N.normal};this.options.pedantic?(ee.block=U.pedantic,ee.inline=N.pedantic):this.options.gfm&&(ee.block=U.gfm,this.options.breaks?ee.inline=N.breaks:ee.inline=N.gfm),this.tokenizer.rules=ee}ie.lex=function(ee,ce){var ae=new ie(ce);return ae.lex(ee)},ie.lexInline=function(ee,ce){var ae=new ie(ce);return ae.inlineTokens(ee)};var ne=ie.prototype;return ne.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(_e,Ae,Ee){return Ae+"    ".repeat(Ee.length)});for(var O,B,K,Z;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(_e){return(O=_e.call({lexer:ae},ee,ce))?(ee=ee.substring(O.raw.length),ce.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+O.raw,B.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+O.raw,B.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var _e=1/0,Ae=ee.slice(1),Ee=void 0;ae.options.extensions.startBlock.forEach(function(ke){Ee=ke.call({lexer:this},Ae),typeof Ee=="number"&&Ee>=0&&(_e=Math.min(_e,Ee))}),_e<1/0&&_e>=0&&(K=ee.substring(0,_e+1))}(),this.state.top&&(O=this.tokenizer.paragraph(K))){B=ce[ce.length-1],Z&&B.type==="paragraph"?(B.raw+=`
`+O.raw,B.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(O),Z=K.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+O.raw,B.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(O);continue}if(ee){var he="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},ne.inline=function(ee,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ee,tokens:ce}),ce},ne.inlineTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]);var O,B,K,Z=ee,he,_e,Ae;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)Ee.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,he.index)+"["+L("a",he[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,he.index)+"["+L("a",he[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,he.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(_e||(Ae=""),_e=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(O=Ie.call({lexer:ae},ee,ce))?(ee=ee.substring(O.raw.length),ce.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),B=ce[ce.length-1],B&&O.type==="text"&&B.type==="text"?(B.raw+=O.raw,B.text+=O.text):ce.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),B=ce[ce.length-1],B&&O.type==="text"&&B.type==="text"?(B.raw+=O.raw,B.text+=O.text):ce.push(O);continue}if(O=this.tokenizer.emStrong(ee,Z,Ae)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(O=this.tokenizer.autolink(ee,F)){ee=ee.substring(O.raw.length),ce.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,F))){ee=ee.substring(O.raw.length),ce.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,He=ee.slice(1),ze=void 0;ae.options.extensions.startInline.forEach(function(tt){ze=tt.call({lexer:this},He),typeof ze=="number"&&ze>=0&&(Ie=Math.min(Ie,ze))}),Ie<1/0&&Ie>=0&&(K=ee.substring(0,Ie+1))}(),O=this.tokenizer.inlineText(K,x)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Ae=O.raw.slice(-1)),_e=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=O.raw,B.text+=O.text):ce.push(O);continue}if(ee){var ke="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return ce},a(ie,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),ie}(),fe=function(){function ie(de){this.options=de||re.defaults}var ne=ie.prototype;return ne.code=function(ee,ce,ae){var O=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(ee,O);B!=null&&B!==ee&&(ae=!0,ee=B)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+C(O,!0)+'">'+(ae?ee:C(ee,!0))+`</code></pre>
`:"<pre><code>"+(ae?ee:C(ee,!0))+`</code></pre>
`},ne.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ne.html=function(ee){return ee},ne.heading=function(ee,ce,ae,O){if(this.options.headerIds){var B=this.options.headerPrefix+O.slug(ae);return"<h"+ce+' id="'+B+'">'+ee+"</h"+ce+`>
`}return"<h"+ce+">"+ee+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(ee,ce,ae){var O=ce?"ol":"ul",B=ce&&ae!==1?' start="'+ae+'"':"";return"<"+O+B+`>
`+ee+"</"+O+`>
`},ne.listitem=function(ee){return"<li>"+ee+`</li>
`},ne.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(ee){return"<p>"+ee+`</p>
`},ne.table=function(ee,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ce+`</table>
`},ne.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ne.tablecell=function(ee,ce){var ae=ce.header?"th":"td",O=ce.align?"<"+ae+' align="'+ce.align+'">':"<"+ae+">";return O+ee+("</"+ae+`>
`)},ne.strong=function(ee){return"<strong>"+ee+"</strong>"},ne.em=function(ee){return"<em>"+ee+"</em>"},ne.codespan=function(ee){return"<code>"+ee+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(ee){return"<del>"+ee+"</del>"},ne.link=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var O='<a href="'+C(ee)+'"';return ce&&(O+=' title="'+ce+'"'),O+=">"+ae+"</a>",O},ne.image=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var O='<img src="'+ee+'" alt="'+ae+'"';return ce&&(O+=' title="'+ce+'"'),O+=this.options.xhtml?"/>":">",O},ne.text=function(ee){return ee},ie}(),se=function(){function ie(){}var ne=ie.prototype;return ne.strong=function(ee){return ee},ne.em=function(ee){return ee},ne.codespan=function(ee){return ee},ne.del=function(ee){return ee},ne.html=function(ee){return ee},ne.text=function(ee){return ee},ne.link=function(ee,ce,ae){return""+ae},ne.image=function(ee,ce,ae){return""+ae},ne.br=function(){return""},ie}(),$=function(){function ie(){this.seen={}}var ne=ie.prototype;return ne.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(ee,ce){var ae=ee,O=0;if(this.seen.hasOwnProperty(ae)){O=this.seen[ee];do O++,ae=ee+"-"+O;while(this.seen.hasOwnProperty(ae))}return ce||(this.seen[ee]=O,this.seen[ae]=0),ae},ne.slug=function(ee,ce){ce===void 0&&(ce={});var ae=this.serialize(ee);return this.getNextSafeSlug(ae,ce.dryrun)},ie}(),J=function(){function ie(de){this.options=de||re.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new $}ie.parse=function(ee,ce){var ae=new ie(ce);return ae.parse(ee)},ie.parseInline=function(ee,ce){var ae=new ie(ce);return ae.parseInline(ee)};var ne=ie.prototype;return ne.parse=function(ee,ce){ce===void 0&&(ce=!0);var ae="",O,B,K,Z,he,_e,Ae,Ee,ke,Ie,He,ze,tt,Qe,nt,st,Ue,it,z,Q=ee.length;for(O=0;O<Q;O++){if(Ie=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(z=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),z!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){ae+=z||"";continue}switch(Ie.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,n(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(Ee="",Ae="",Z=Ie.header.length,B=0;B<Z;B++)Ae+=this.renderer.tablecell(this.parseInline(Ie.header[B].tokens),{header:!0,align:Ie.align[B]});for(Ee+=this.renderer.tablerow(Ae),ke="",Z=Ie.rows.length,B=0;B<Z;B++){for(_e=Ie.rows[B],Ae="",he=_e.length,K=0;K<he;K++)Ae+=this.renderer.tablecell(this.parseInline(_e[K].tokens),{header:!1,align:Ie.align[K]});ke+=this.renderer.tablerow(Ae)}ae+=this.renderer.table(Ee,ke);continue}case"blockquote":{ke=this.parse(Ie.tokens),ae+=this.renderer.blockquote(ke);continue}case"list":{for(He=Ie.ordered,ze=Ie.start,tt=Ie.loose,Z=Ie.items.length,ke="",B=0;B<Z;B++)nt=Ie.items[B],st=nt.checked,Ue=nt.task,Qe="",nt.task&&(it=this.renderer.checkbox(st),tt?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=it+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=it+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:it}):Qe+=it),Qe+=this.parse(nt.tokens,tt),ke+=this.renderer.listitem(Qe,Ue,st);ae+=this.renderer.list(ke,He,ze);continue}case"html":{ae+=this.renderer.html(Ie.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(ke=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;O+1<Q&&ee[O+1].type==="text";)Ie=ee[++O],ke+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);ae+=ce?this.renderer.paragraph(ke):ke;continue}default:{var me='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return ae},ne.parseInline=function(ee,ce){ce=ce||this.renderer;var ae="",O,B,K,Z=ee.length;for(O=0;O<Z;O++){if(B=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(K=this.options.extensions.renderers[B.type].call({parser:this},B),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){ae+=K||"";continue}switch(B.type){case"escape":{ae+=ce.text(B.text);break}case"html":{ae+=ce.html(B.text);break}case"link":{ae+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{ae+=ce.image(B.href,B.title,B.text);break}case"strong":{ae+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{ae+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{ae+=ce.codespan(B.text);break}case"br":{ae+=ce.br();break}case"del":{ae+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{ae+=ce.text(B.text);break}default:{var he='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ae},ie}();function te(ie,ne,de){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=i({},te.defaults,ne||{}),g(ne),de){var ee=ne.highlight,ce;try{ce=V.lex(ie,ne)}catch(Z){return de(Z)}var ae=function(he){var _e;if(!he)try{ne.walkTokens&&te.walkTokens(ce,ne.walkTokens),_e=J.parse(ce,ne)}catch(Ae){he=Ae}return ne.highlight=ee,he?de(he):de(null,_e)};if(!ee||ee.length<3||(delete ne.highlight,!ce.length))return ae();var O=0;te.walkTokens(ce,function(Z){Z.type==="code"&&(O++,setTimeout(function(){ee(Z.text,Z.lang,function(he,_e){if(he)return ae(he);_e!=null&&_e!==Z.text&&(Z.text=_e,Z.escaped=!0),O--,O===0&&ae()})},0))}),O===0&&ae();return}function B(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(Z.message+"",!0)+"</pre>";throw Z}try{var K=V.lex(ie,ne);if(ne.walkTokens){if(ne.async)return Promise.all(te.walkTokens(K,ne.walkTokens)).then(function(){return J.parse(K,ne)}).catch(B);te.walkTokens(K,ne.walkTokens)}return J.parse(K,ne)}catch(Z){B(Z)}}te.options=te.setOptions=function(ie){return i(te.defaults,ie),k(te.defaults),te},te.getDefaults=T,te.defaults=re.defaults,te.use=function(){for(var ie=arguments.length,ne=new Array(ie),de=0;de<ie;de++)ne[de]=arguments[de];var ee=i.apply(void 0,[{}].concat(ne)),ce=te.defaults.extensions||{renderers:{},childTokens:{}},ae;ne.forEach(function(O){if(O.extensions&&(ae=!0,O.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Z=ce.renderers?ce.renderers[K.name]:null;Z?ce.renderers[K.name]=function(){for(var he=arguments.length,_e=new Array(he),Ae=0;Ae<he;Ae++)_e[Ae]=arguments[Ae];var Ee=K.renderer.apply(this,_e);return Ee===!1&&(Ee=Z.apply(this,_e)),Ee}:ce.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[K.level]?ce[K.level].unshift(K.tokenizer):ce[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ce.startBlock?ce.startBlock.push(K.start):ce.startBlock=[K.start]:K.level==="inline"&&(ce.startInline?ce.startInline.push(K.start):ce.startInline=[K.start]))}K.childTokens&&(ce.childTokens[K.name]=K.childTokens)})),O.renderer&&function(){var K=te.defaults.renderer||new fe,Z=function(Ae){var Ee=K[Ae];K[Ae]=function(){for(var ke=arguments.length,Ie=new Array(ke),He=0;He<ke;He++)Ie[He]=arguments[He];var ze=O.renderer[Ae].apply(K,Ie);return ze===!1&&(ze=Ee.apply(K,Ie)),ze}};for(var he in O.renderer)Z(he);ee.renderer=K}(),O.tokenizer&&function(){var K=te.defaults.tokenizer||new X,Z=function(Ae){var Ee=K[Ae];K[Ae]=function(){for(var ke=arguments.length,Ie=new Array(ke),He=0;He<ke;He++)Ie[He]=arguments[He];var ze=O.tokenizer[Ae].apply(K,Ie);return ze===!1&&(ze=Ee.apply(K,Ie)),ze}};for(var he in O.tokenizer)Z(he);ee.tokenizer=K}(),O.walkTokens){var B=te.defaults.walkTokens;ee.walkTokens=function(K){var Z=[];return Z.push(O.walkTokens.call(this,K)),B&&(Z=Z.concat(B.call(this,K))),Z}}ae&&(ee.extensions=ce),te.setOptions(ee)})},te.walkTokens=function(ie,ne){for(var de=[],ee=function(){var B=ae.value;switch(de=de.concat(ne.call(te,B)),B.type){case"table":{for(var K=A(B.header),Z;!(Z=K()).done;){var he=Z.value;de=de.concat(te.walkTokens(he.tokens,ne))}for(var _e=A(B.rows),Ae;!(Ae=_e()).done;)for(var Ee=Ae.value,ke=A(Ee),Ie;!(Ie=ke()).done;){var He=Ie.value;de=de.concat(te.walkTokens(He.tokens,ne))}break}case"list":{de=de.concat(te.walkTokens(B.items,ne));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[B.type]?te.defaults.extensions.childTokens[B.type].forEach(function(ze){de=de.concat(te.walkTokens(B[ze],ne))}):B.tokens&&(de=de.concat(te.walkTokens(B.tokens,ne)))}},ce=A(ie),ae;!(ae=ce()).done;)ee();return de},te.parseInline=function(ie,ne){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ne=i({},te.defaults,ne||{}),g(ne);try{var de=V.lexInline(ie,ne);return ne.walkTokens&&te.walkTokens(de,ne.walkTokens),J.parseInline(de,ne)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(ee.message+"",!0)+"</pre>";throw ee}},te.Parser=J,te.parser=J.parse,te.Renderer=fe,te.TextRenderer=se,te.Lexer=V,te.lexer=V.lex,te.Tokenizer=X,te.Slugger=$,te.parse=te;var be=te.options,le=te.setOptions,ue=te.use,j=te.walkTokens,M=te.parseInline,Y=te,ge=J.parse,we=V.lex;re.Lexer=V,re.Parser=J,re.Renderer=fe,re.Slugger=$,re.TextRenderer=se,re.Tokenizer=X,re.getDefaults=T,re.lexer=we,re.marked=te,re.options=be,re.parse=Y,re.parseInline=M,re.parser=ge,re.setOptions=le,re.use=ue,re.walkTokens=j,Object.defineProperty(re,"__esModule",{value:!0})}),define(Ce[88],De([1,0,28]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const P=new a.LRUCache(1e4);function l(v){return y(v,"NFC",P)}e.normalizeNFC=l;const A=new a.LRUCache(1e4);function T(v){return y(v,"NFD",A)}e.normalizeNFD=T;const k=/[^\u0000-\u0080]/;function y(v,R,I){if(!v)return v;const _=I.get(v);if(_)return _;let D;return k.test(v)?D=v.normalize(R):D=v,I.set(v,D),D}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(R){return T(R).replace(v,"")}}()}),define(Ce[103],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,y,v){return Math.min(Math.max(k,y),v)}e.clamp=a;function P(k,y){return(y+k%y)%y}e.rot=P;class l{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=l;class A{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const v=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=v,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function re(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function T(y){A.push(y,Date.now())}function k(){const y=[];for(let v=0;v<A.length;v+=2)y.push({name:A[v],startTime:A[v+1]});return y}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(l+T.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function a(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=a(P))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var P in a)(typeof exports=="object"?exports:re)[P]=a[P]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function a(P){if(e[P])return e[P].exports;var l=e[P]={i:P,l:!1,exports:{}};return re[P].call(l.exports,l,l.exports,a),l.l=!0,l.exports}return a.m=re,a.c=e,a.d=function(P,l,A){a.o(P,l)||Object.defineProperty(P,l,{enumerable:!0,get:A})},a.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},a.t=function(P,l){if(1&l&&(P=a(P)),8&l||4&l&&typeof P=="object"&&P&&P.__esModule)return P;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:P}),2&l&&typeof P!="string")for(var T in P)a.d(A,T,function(k){return P[k]}.bind(null,T));return A},a.n=function(P){var l=P&&P.__esModule?function(){return P.default}:function(){return P};return a.d(l,"a",l),l},a.o=function(P,l){return Object.prototype.hasOwnProperty.call(P,l)},a.p="",a(a.s=0)}([function(re,e,a){(function(P){var l;e=re.exports=ue,l=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var Ee=Array.prototype.slice.call(arguments,0);Ee.unshift("SEMVER"),console.log.apply(console,Ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],y=e.src=[],v=0,R=v++;y[R]="0|[1-9]\\d*";var I=v++;y[I]="[0-9]+";var _=v++;y[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=v++;y[D]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var C=v++;y[C]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var E=v++;y[E]="(?:"+y[R]+"|"+y[_]+")";var n=v++;y[n]="(?:"+y[I]+"|"+y[_]+")";var d=v++;y[d]="(?:-("+y[E]+"(?:\\."+y[E]+")*))";var h=v++;y[h]="(?:-?("+y[n]+"(?:\\."+y[n]+")*))";var w=v++;y[w]="[0-9A-Za-z-]+";var S=v++;y[S]="(?:\\+("+y[w]+"(?:\\."+y[w]+")*))";var p=v++,t="v?"+y[D]+y[d]+"?"+y[S]+"?";y[p]="^"+t+"$";var o="[v=\\s]*"+y[C]+y[h]+"?"+y[S]+"?",r=v++;y[r]="^"+o+"$";var c=v++;y[c]="((?:<|>)?=?)";var m=v++;y[m]=y[I]+"|x|X|\\*";var f=v++;y[f]=y[R]+"|x|X|\\*";var i=v++;y[i]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[d]+")?"+y[S]+"?)?)?";var s=v++;y[s]="[v=\\s]*("+y[m]+")(?:\\.("+y[m]+")(?:\\.("+y[m]+")(?:"+y[h]+")?"+y[S]+"?)?)?";var u=v++;y[u]="^"+y[c]+"\\s*"+y[i]+"$";var b=v++;y[b]="^"+y[c]+"\\s*"+y[s]+"$";var g=v++;y[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=v++;y[L]="(?:~>?)";var H=v++;y[H]="(\\s*)"+y[L]+"\\s+",k[H]=new RegExp(y[H],"g");var q=v++;y[q]="^"+y[L]+y[i]+"$";var X=v++;y[X]="^"+y[L]+y[s]+"$";var U=v++;y[U]="(?:\\^)";var N=v++;y[N]="(\\s*)"+y[U]+"\\s+",k[N]=new RegExp(y[N],"g");var x=v++;y[x]="^"+y[U]+y[i]+"$";var F=v++;y[F]="^"+y[U]+y[s]+"$";var V=v++;y[V]="^"+y[c]+"\\s*("+o+")$|^$";var fe=v++;y[fe]="^"+y[c]+"\\s*("+t+")$|^$";var se=v++;y[se]="(\\s*)"+y[c]+"\\s*("+o+"|"+y[i]+")",k[se]=new RegExp(y[se],"g");var $=v++;y[$]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var J=v++;y[J]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var te=v++;y[te]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)l(be,y[be]),k[be]||(k[be]=new RegExp(y[be]));function le(Ee,ke){if(Ee instanceof ue)return Ee;if(typeof Ee!="string"||Ee.length>A||!(ke?k[r]:k[p]).test(Ee))return null;try{return new ue(Ee,ke)}catch{return null}}function ue(Ee,ke){if(Ee instanceof ue){if(Ee.loose===ke)return Ee;Ee=Ee.version}else if(typeof Ee!="string")throw new TypeError("Invalid Version: "+Ee);if(Ee.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ue))return new ue(Ee,ke);l("SemVer",Ee,ke),this.loose=ke;var Ie=Ee.trim().match(ke?k[r]:k[p]);if(!Ie)throw new TypeError("Invalid Version: "+Ee);if(this.raw=Ee,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var ze=+He;if(ze>=0&&ze<T)return ze}return He}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=le,e.valid=function(Ee,ke){var Ie=le(Ee,ke);return Ie?Ie.version:null},e.clean=function(Ee,ke){var Ie=le(Ee.trim().replace(/^[=v]+/,""),ke);return Ie?Ie.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(Ee){return l("SemVer.compare",this.version,this.loose,Ee),Ee instanceof ue||(Ee=new ue(Ee,this.loose)),this.compareMain(Ee)||this.comparePre(Ee)},ue.prototype.compareMain=function(Ee){return Ee instanceof ue||(Ee=new ue(Ee,this.loose)),M(this.major,Ee.major)||M(this.minor,Ee.minor)||M(this.patch,Ee.patch)},ue.prototype.comparePre=function(Ee){if(Ee instanceof ue||(Ee=new ue(Ee,this.loose)),this.prerelease.length&&!Ee.prerelease.length)return-1;if(!this.prerelease.length&&Ee.prerelease.length)return 1;if(!this.prerelease.length&&!Ee.prerelease.length)return 0;var ke=0;do{var Ie=this.prerelease[ke],He=Ee.prerelease[ke];if(l("prerelease compare",ke,Ie,He),Ie===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==He)return M(Ie,He)}while(++ke)},ue.prototype.inc=function(Ee,ke){switch(Ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+Ee)}return this.format(),this.raw=this.version,this},e.inc=function(Ee,ke,Ie,He){typeof Ie=="string"&&(He=Ie,Ie=void 0);try{return new ue(Ee,Ie).inc(ke,He).version}catch{return null}},e.diff=function(Ee,ke){if(ie(Ee,ke))return null;var Ie=le(Ee),He=le(ke);if(Ie.prerelease.length||He.prerelease.length){for(var ze in Ie)if((ze==="major"||ze==="minor"||ze==="patch")&&Ie[ze]!==He[ze])return"pre"+ze;return"prerelease"}for(var ze in Ie)if((ze==="major"||ze==="minor"||ze==="patch")&&Ie[ze]!==He[ze])return ze},e.compareIdentifiers=M;var j=/^[0-9]+$/;function M(Ee,ke){var Ie=j.test(Ee),He=j.test(ke);return Ie&&He&&(Ee=+Ee,ke=+ke),Ie&&!He?-1:He&&!Ie?1:Ee<ke?-1:Ee>ke?1:0}function Y(Ee,ke,Ie){return new ue(Ee,Ie).compare(new ue(ke,Ie))}function ge(Ee,ke,Ie){return Y(Ee,ke,Ie)>0}function we(Ee,ke,Ie){return Y(Ee,ke,Ie)<0}function ie(Ee,ke,Ie){return Y(Ee,ke,Ie)===0}function ne(Ee,ke,Ie){return Y(Ee,ke,Ie)!==0}function de(Ee,ke,Ie){return Y(Ee,ke,Ie)>=0}function ee(Ee,ke,Ie){return Y(Ee,ke,Ie)<=0}function ce(Ee,ke,Ie,He){var ze;switch(ke){case"===":typeof Ee=="object"&&(Ee=Ee.version),typeof Ie=="object"&&(Ie=Ie.version),ze=Ee===Ie;break;case"!==":typeof Ee=="object"&&(Ee=Ee.version),typeof Ie=="object"&&(Ie=Ie.version),ze=Ee!==Ie;break;case"":case"=":case"==":ze=ie(Ee,Ie,He);break;case"!=":ze=ne(Ee,Ie,He);break;case">":ze=ge(Ee,Ie,He);break;case">=":ze=de(Ee,Ie,He);break;case"<":ze=we(Ee,Ie,He);break;case"<=":ze=ee(Ee,Ie,He);break;default:throw new TypeError("Invalid operator: "+ke)}return ze}function ae(Ee,ke){if(Ee instanceof ae){if(Ee.loose===ke)return Ee;Ee=Ee.value}if(!(this instanceof ae))return new ae(Ee,ke);l("comparator",Ee,ke),this.loose=ke,this.parse(Ee),this.semver===O?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(Ee,ke){return M(ke,Ee)},e.major=function(Ee,ke){return new ue(Ee,ke).major},e.minor=function(Ee,ke){return new ue(Ee,ke).minor},e.patch=function(Ee,ke){return new ue(Ee,ke).patch},e.compare=Y,e.compareLoose=function(Ee,ke){return Y(Ee,ke,!0)},e.rcompare=function(Ee,ke,Ie){return Y(ke,Ee,Ie)},e.sort=function(Ee,ke){return Ee.sort(function(Ie,He){return e.compare(Ie,He,ke)})},e.rsort=function(Ee,ke){return Ee.sort(function(Ie,He){return e.rcompare(Ie,He,ke)})},e.gt=ge,e.lt=we,e.eq=ie,e.neq=ne,e.gte=de,e.lte=ee,e.cmp=ce,e.Comparator=ae;var O={};function B(Ee,ke){if(Ee instanceof B)return Ee.loose===ke?Ee:new B(Ee.raw,ke);if(Ee instanceof ae)return new B(Ee.value,ke);if(!(this instanceof B))return new B(Ee,ke);if(this.loose=ke,this.raw=Ee,this.set=Ee.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Ee);this.format()}function K(Ee){return!Ee||Ee.toLowerCase()==="x"||Ee==="*"}function Z(Ee,ke,Ie,He,ze,tt,Qe,nt,st,Ue,it,z,Q){return((ke=K(Ie)?"":K(He)?">="+Ie+".0.0":K(ze)?">="+Ie+"."+He+".0":">="+ke)+" "+(nt=K(st)?"":K(Ue)?"<"+(+st+1)+".0.0":K(it)?"<"+st+"."+(+Ue+1)+".0":z?"<="+st+"."+Ue+"."+it+"-"+z:"<="+nt)).trim()}function he(Ee,ke){for(var Ie=0;Ie<Ee.length;Ie++)if(!Ee[Ie].test(ke))return!1;if(ke.prerelease.length){for(Ie=0;Ie<Ee.length;Ie++)if(l(Ee[Ie].semver),Ee[Ie].semver!==O&&Ee[Ie].semver.prerelease.length>0){var He=Ee[Ie].semver;if(He.major===ke.major&&He.minor===ke.minor&&He.patch===ke.patch)return!0}return!1}return!0}function _e(Ee,ke,Ie){try{ke=new B(ke,Ie)}catch{return!1}return ke.test(Ee)}function Ae(Ee,ke,Ie,He){var ze,tt,Qe,nt,st;switch(Ee=new ue(Ee,He),ke=new B(ke,He),Ie){case">":ze=ge,tt=ee,Qe=we,nt=">",st=">=";break;case"<":ze=we,tt=de,Qe=ge,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_e(Ee,ke,He))return!1;for(var Ue=0;Ue<ke.set.length;++Ue){var it=ke.set[Ue],z=null,Q=null;if(it.forEach(function(me){me.semver===O&&(me=new ae(">=0.0.0")),z=z||me,Q=Q||me,ze(me.semver,z.semver,He)?z=me:Qe(me.semver,Q.semver,He)&&(Q=me)}),z.operator===nt||z.operator===st||(!Q.operator||Q.operator===nt)&&tt(Ee,Q.semver)||Q.operator===st&&Qe(Ee,Q.semver))return!1}return!0}ae.prototype.parse=function(Ee){var ke=this.loose?k[V]:k[fe],Ie=Ee.match(ke);if(!Ie)throw new TypeError("Invalid comparator: "+Ee);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new ue(Ie[2],this.loose):this.semver=O},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(Ee){return l("Comparator.test",Ee,this.loose),this.semver===O||(typeof Ee=="string"&&(Ee=new ue(Ee,this.loose)),ce(Ee,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(Ee,ke){if(!(Ee instanceof ae))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new B(Ee.value,ke),_e(this.value,Ie,ke);if(Ee.operator==="")return Ie=new B(this.value,ke),_e(Ee.semver,Ie,ke);var He=!(this.operator!==">="&&this.operator!==">"||Ee.operator!==">="&&Ee.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||Ee.operator!=="<="&&Ee.operator!=="<"),tt=this.semver.version===Ee.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Ee.operator!==">="&&Ee.operator!=="<="),nt=ce(this.semver,"<",Ee.semver,ke)&&(this.operator===">="||this.operator===">")&&(Ee.operator==="<="||Ee.operator==="<"),st=ce(this.semver,">",Ee.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(Ee.operator===">="||Ee.operator===">");return He||ze||tt&&Qe||nt||st},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(Ee){return Ee.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(Ee){var ke=this.loose;Ee=Ee.trim(),l("range",Ee,ke);var Ie=ke?k[J]:k[$];Ee=Ee.replace(Ie,Z),l("hyphen replace",Ee),Ee=Ee.replace(k[se],"$1$2$3"),l("comparator trim",Ee,k[se]),Ee=(Ee=(Ee=Ee.replace(k[H],"$1~")).replace(k[N],"$1^")).split(/\s+/).join(" ");var He=ke?k[V]:k[fe],ze=Ee.split(" ").map(function(tt){return function(Qe,nt){return l("comp",Qe),Qe=function(st,Ue){return st.trim().split(/\s+/).map(function(it){return function(z,Q){l("caret",z,Q);var me=Q?k[F]:k[x];return z.replace(me,function(Re,Oe,Ve,Xe,Ke){var rt;return l("caret",z,Re,Oe,Ve,Xe,Ke),K(Oe)?rt="":K(Ve)?rt=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":K(Xe)?rt=Oe==="0"?">="+Oe+"."+Ve+".0 <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+".0 <"+(+Oe+1)+".0.0":Ke?(l("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),rt=Oe==="0"?Ve==="0"?">="+Oe+"."+Ve+"."+Xe+Ke+" <"+Oe+"."+Ve+"."+(+Xe+1):">="+Oe+"."+Ve+"."+Xe+Ke+" <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+"."+Xe+Ke+" <"+(+Oe+1)+".0.0"):(l("no pr"),rt=Oe==="0"?Ve==="0"?">="+Oe+"."+Ve+"."+Xe+" <"+Oe+"."+Ve+"."+(+Xe+1):">="+Oe+"."+Ve+"."+Xe+" <"+Oe+"."+(+Ve+1)+".0":">="+Oe+"."+Ve+"."+Xe+" <"+(+Oe+1)+".0.0"),l("caret return",rt),rt})}(it,Ue)}).join(" ")}(Qe,nt),l("caret",Qe),Qe=function(st,Ue){return st.trim().split(/\s+/).map(function(it){return function(z,Q){var me=Q?k[X]:k[q];return z.replace(me,function(Re,Oe,Ve,Xe,Ke){var rt;return l("tilde",z,Re,Oe,Ve,Xe,Ke),K(Oe)?rt="":K(Ve)?rt=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":K(Xe)?rt=">="+Oe+"."+Ve+".0 <"+Oe+"."+(+Ve+1)+".0":Ke?(l("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),rt=">="+Oe+"."+Ve+"."+Xe+Ke+" <"+Oe+"."+(+Ve+1)+".0"):rt=">="+Oe+"."+Ve+"."+Xe+" <"+Oe+"."+(+Ve+1)+".0",l("tilde return",rt),rt})}(it,Ue)}).join(" ")}(Qe,nt),l("tildes",Qe),Qe=function(st,Ue){return l("replaceXRanges",st,Ue),st.split(/\s+/).map(function(it){return function(z,Q){z=z.trim();var me=Q?k[b]:k[u];return z.replace(me,function(Re,Oe,Ve,Xe,Ke,rt){l("xRange",z,Re,Oe,Ve,Xe,Ke,rt);var ct=K(Ve),bt=ct||K(Xe),mt=bt||K(Ke);return Oe==="="&&mt&&(Oe=""),ct?Re=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&mt?(bt&&(Xe=0),mt&&(Ke=0),Oe===">"?(Oe=">=",bt?(Ve=+Ve+1,Xe=0,Ke=0):mt&&(Xe=+Xe+1,Ke=0)):Oe==="<="&&(Oe="<",bt?Ve=+Ve+1:Xe=+Xe+1),Re=Oe+Ve+"."+Xe+"."+Ke):bt?Re=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":mt&&(Re=">="+Ve+"."+Xe+".0 <"+Ve+"."+(+Xe+1)+".0"),l("xRange return",Re),Re})}(it,Ue)}).join(" ")}(Qe,nt),l("xrange",Qe),Qe=function(st,Ue){return l("replaceStars",st,Ue),st.trim().replace(k[te],"")}(Qe,nt),l("stars",Qe),Qe}(tt,ke)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(tt){return!!tt.match(He)})),ze=ze.map(function(tt){return new ae(tt,ke)})},B.prototype.intersects=function(Ee,ke){if(!(Ee instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(He){return Ee.set.some(function(ze){return ze.every(function(tt){return He.intersects(tt,ke)})})})})},e.toComparators=function(Ee,ke){return new B(Ee,ke).set.map(function(Ie){return Ie.map(function(He){return He.value}).join(" ").trim().split(" ")})},B.prototype.test=function(Ee){if(!Ee)return!1;typeof Ee=="string"&&(Ee=new ue(Ee,this.loose));for(var ke=0;ke<this.set.length;ke++)if(he(this.set[ke],Ee))return!0;return!1},e.satisfies=_e,e.maxSatisfying=function(Ee,ke,Ie){var He=null,ze=null;try{var tt=new B(ke,Ie)}catch{return null}return Ee.forEach(function(Qe){tt.test(Qe)&&(He&&ze.compare(Qe)!==-1||(ze=new ue(He=Qe,Ie)))}),He},e.minSatisfying=function(Ee,ke,Ie){var He=null,ze=null;try{var tt=new B(ke,Ie)}catch{return null}return Ee.forEach(function(Qe){tt.test(Qe)&&(He&&ze.compare(Qe)!==1||(ze=new ue(He=Qe,Ie)))}),He},e.validRange=function(Ee,ke){try{return new B(Ee,ke).range||"*"}catch{return null}},e.ltr=function(Ee,ke,Ie){return Ae(Ee,ke,"<",Ie)},e.gtr=function(Ee,ke,Ie){return Ae(Ee,ke,">",Ie)},e.outside=Ae,e.prerelease=function(Ee,ke){var Ie=le(Ee,ke);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(Ee,ke,Ie){return Ee=new B(Ee,Ie),ke=new B(ke,Ie),Ee.intersects(ke)},e.coerce=function(Ee){if(Ee instanceof ue)return Ee;if(typeof Ee!="string")return null;var ke=Ee.match(k[g]);return ke==null?null:le((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,a(1))},function(re,e){var a,P,l=re.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(n){if(a===setTimeout)return setTimeout(n,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(n,0);try{return a(n,0)}catch{try{return a.call(null,n,0)}catch{return a.call(this,n,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{P=typeof clearTimeout=="function"?clearTimeout:T}catch{P=T}})();var y,v=[],R=!1,I=-1;function _(){R&&y&&(R=!1,y.length?v=y.concat(v):I=-1,v.length&&D())}function D(){if(!R){var n=k(_);R=!0;for(var d=v.length;d;){for(y=v,v=[];++I<d;)y&&y[I].run();I=-1,d=v.length}y=null,R=!1,function(h){if(P===clearTimeout)return clearTimeout(h);if((P===T||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(h);try{P(h)}catch{try{return P.call(null,h)}catch{return P.call(this,h)}}}(n)}}function C(n,d){this.fun=n,this.array=d}function E(){}l.nextTick=function(n){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];v.push(new C(n,d)),v.length!==1||R||k(D)},C.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(n){return[]},l.binding=function(n){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(n){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(Ce[104],De([1,0,8,6]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(S){const p=S;return p?typeof p.read=="function":!1}e.isReadable=l;function A(S){const p=S;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function T(S){const p=S;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(S,p){return new y(S,p)}e.newWriteableStream=k;class y{constructor(p,t){this.reducer=p,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(t=>t(p))}emitError(p){this.listeners.error.length===0?(0,a.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(t=>t(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,t){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(p,t){if(this.state.destroyed)return;let o;switch(p){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(S,p){const t=[];let o;for(;(o=S.read())!==null;)t.push(o);return p(t)}e.consumeReadable=v;function R(S,p,t){const o=[];let r;for(;(r=S.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return S.read()}}}e.peekReadable=R;function I(S,p){return new Promise((t,o)=>{const r=[];_(S,{onData:c=>{p&&r.push(c)},onError:c=>{p?o(c):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=I;function _(S,p){let t=!1;return S.on("error",o=>{t||p.onError(o)}),S.on("end",()=>{t||p.onEnd()}),S.on("data",o=>{t||p.onData(o)}),(0,P.toDisposable)(()=>t=!0)}e.listenStream=_;function D(S,p){return new Promise((t,o)=>{const r=new P.DisposableStore,c=[],m=s=>{if(c.push(s),c.length>p)return r.dispose(),S.pause(),t({stream:S,buffer:c,ended:!1})},f=s=>o(s),i=()=>t({stream:S,buffer:c,ended:!0});r.add((0,P.toDisposable)(()=>S.removeListener("error",f))),S.on("error",f),r.add((0,P.toDisposable)(()=>S.removeListener("end",i))),S.on("end",i),r.add((0,P.toDisposable)(()=>S.removeListener("data",m))),S.on("data",m)})}e.peekStream=D;function C(S,p){const t=k(p);return t.end(S),t}e.toStream=C;function E(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=E;function n(S){let p=!1;return{read:()=>p?null:(p=!0,S)}}e.toReadable=n;function d(S,p,t){const o=k(t);return _(S,{onData:r=>o.write(p.data(r)),onError:r=>o.error(p.error?p.error(r):r),onEnd:()=>o.end()}),o}e.transform=d;function h(S,p,t){let o=!1;return{read:()=>{const r=p.read();return o?r:(o=!0,r!==null?t([S,r]):S)}}}e.prefixedReadable=h;function w(S,p,t){let o=!1;const r=k(t);return _(p,{onData:c=>o?r.write(c):(o=!0,r.write(t([S,c]))),onError:c=>r.error(c),onEnd:()=>{o||(o=!0,r.write(S)),r.end()}}),r}e.prefixedStream=w}),define(Ce[22],De([1,0,104]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let l,A;class T{static alloc(s){return P?new T(Buffer.allocUnsafe(s)):new T(new Uint8Array(s))}static wrap(s){return P&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new T(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&P?new T(Buffer.from(s)):(l||(l=new TextEncoder),new T(l.encode(s)))}static fromByteArray(s){const u=T.alloc(s.length);for(let b=0,g=s.length;b<g;b++)u.buffer[b]=s[b];return u}static concat(s,u){if(typeof u>"u"){u=0;for(let L=0,H=s.length;L<H;L++)u+=s[L].byteLength}const b=T.alloc(u);let g=0;for(let L=0,H=s.length;L<H;L++){const q=s[L];b.set(q,g),g+=q.byteLength}return b}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=T.alloc(this.byteLength);return s.set(this),s}toString(){return P?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,u){return new T(this.buffer.subarray(s,u))}set(s,u){if(s instanceof T)this.buffer.set(s.buffer,u);else if(s instanceof Uint8Array)this.buffer.set(s,u);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),u);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return v(this.buffer,s)}writeUInt32BE(s,u){R(this.buffer,s,u)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,u){_(this.buffer,s,u)}readUInt8(s){return D(this.buffer,s)}writeUInt8(s,u){C(this.buffer,s,u)}}e.VSBuffer=T;function k(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0}e.readUInt16LE=k;function y(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255}e.writeUInt16LE=y;function v(i,s){return i[s]*2**24+i[s+1]*2**16+i[s+2]*2**8+i[s+3]}e.readUInt32BE=v;function R(i,s,u){i[u+3]=s,s=s>>>8,i[u+2]=s,s=s>>>8,i[u+1]=s,s=s>>>8,i[u]=s}e.writeUInt32BE=R;function I(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0|i[s+2]<<16>>>0|i[s+3]<<24>>>0}e.readUInt32LE=I;function _(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255,s=s>>>8,i[u+2]=s&255,s=s>>>8,i[u+3]=s&255}e.writeUInt32LE=_;function D(i,s){return i[s]}e.readUInt8=D;function C(i,s,u){i[u]=s}e.writeUInt8=C;function E(i){return a.consumeReadable(i,s=>T.concat(s))}e.readableToBuffer=E;function n(i){return a.toReadable(i)}e.bufferToReadable=n;function d(i){return a.consumeStream(i,s=>T.concat(s))}e.streamToBuffer=d;async function h(i){return i.ended?T.concat(i.buffer):T.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=h;function w(i){return a.toStream(i,s=>T.concat(s))}e.bufferToStream=w;function S(i){return a.transform(i,{data:s=>typeof s=="string"?T.fromString(s):T.wrap(s)},s=>T.concat(s))}e.streamToBufferReadableStream=S;function p(i){return a.newWriteableStream(s=>T.concat(s),i)}e.newWriteableBufferStream=p;function t(i,s){return a.prefixedReadable(i,s,u=>T.concat(u))}e.prefixedBufferReadable=t;function o(i,s){return a.prefixedStream(i,s,u=>T.concat(u))}e.prefixedBufferStream=o;function r(i){let s=0,u=0,b=0;const g=new Uint8Array(Math.floor(i.length/4*3)),L=q=>{switch(u){case 3:g[b++]=s|q,u=0;break;case 2:g[b++]=s|q>>>2,s=q<<6,u=3;break;case 1:g[b++]=s|q>>>4,s=q<<4,u=2;break;default:s=q<<2,u=1}};for(let q=0;q<i.length;q++){const X=i.charCodeAt(q);if(X>=65&&X<=90)L(X-65);else if(X>=97&&X<=122)L(X-97+26);else if(X>=48&&X<=57)L(X-48+52);else if(X===43||X===45)L(62);else if(X===47||X===95)L(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${i[q]}`)}}const H=b;for(;u>0;)L(0);return T.wrap(g).slice(0,H)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:i},s=!0,u=!1){const b=u?m:c;let g="";const L=i.byteLength%3;let H=0;for(;H<i.byteLength-L;H+=3){const q=i[H+0],X=i[H+1],U=i[H+2];g+=b[q>>>2],g+=b[(q<<4|X>>>4)&63],g+=b[(X<<2|U>>>6)&63],g+=b[U&63]}if(L===1){const q=i[H+0];g+=b[q>>>2],g+=b[q<<4&63],s&&(g+="==")}else if(L===2){const q=i[H+0],X=i[H+1];g+=b[q>>>2],g+=b[(q<<4|X>>>4)&63],g+=b[X<<2&63],s&&(g+="=")}return g}e.encodeBase64=f}),define(Ce[149],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[10],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function P(o){return Array.isArray(o)&&o.every(r=>a(r))}e.isStringArray=P;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function A(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}e.isTypedArray=A;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function y(o){return o===!0||o===!1}e.isBoolean=y;function v(o){return typeof o>"u"}e.isUndefined=v;function R(o){return!I(o)}e.isDefined=R;function I(o){return v(o)||o===null}e.isUndefinedOrNull=I;function _(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=_;function D(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=D;function C(...o){const r=[];for(let c=0;c<o.length;c++){const m=o[c];if(I(m))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);r.push(m)}return r}e.assertAllDefined=C;const E=Object.prototype.hasOwnProperty;function n(o){if(!l(o))return!1;for(const r in o)if(E.call(o,r))return!1;return!0}e.isEmptyObject=n;function d(o){return typeof o=="function"}e.isFunction=d;function h(...o){return o.length>0&&o.every(d)}e.areFunctions=h;function w(o,r){const c=Math.min(o.length,r.length);for(let m=0;m<c;m++)S(o[m],r[m])}e.validateConstraints=w;function S(o,r){if(a(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(o instanceof r)return}catch{}if(!I(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(Ce[67],De([1,0,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const P=Object.create(null);function l(k,y){if((0,a.isString)(y)){const v=P[y];if(v===void 0)throw new Error(`${k} references an unknown codicon: ${y}`);y=v}return P[k]=y,{id:k}}function A(){return P}e.getCodiconFontCharacters=A;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(Ce[23],De([1,0,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([w,S])=>{h[w]=S&&typeof S=="object"?P(S):S}),h}e.deepClone=P;function l(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const w=h.shift();Object.freeze(w);for(const S in w)if(A.call(w,S)){const p=w[S];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&h.push(p)}}return d}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function T(d,h){return k(d,h,new Set)}e.cloneAndChange=T;function k(d,h,w){if((0,a.isUndefinedOrNull)(d))return d;const S=h(d);if(typeof S<"u")return S;if(Array.isArray(d)){const p=[];for(const t of d)p.push(k(t,h,w));return p}if((0,a.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const p={};for(const t in d)A.call(d,t)&&(p[t]=k(d[t],h,w));return w.delete(d),p}return d}function y(d,h,w=!0){return(0,a.isObject)(d)?((0,a.isObject)(h)&&Object.keys(h).forEach(S=>{S in d?w&&((0,a.isObject)(d[S])&&(0,a.isObject)(h[S])?y(d[S],h[S],w):d[S]=h[S]):d[S]=h[S]}),d):h}e.mixin=y;function v(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let w,S;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(w=0;w<d.length;w++)if(!v(d[w],h[w]))return!1}else{const p=[];for(S in d)p.push(S);p.sort();const t=[];for(S in h)t.push(S);if(t.sort(),!v(p,t))return!1;for(w=0;w<p.length;w++)if(!v(d[p[w]],h[p[w]]))return!1}return!0}e.equals=v;function R(d){const h=new Set;return JSON.stringify(d,(w,S)=>{if((0,a.isObject)(S)||Array.isArray(S)){if(h.has(S))return"[Circular]";h.add(S)}return S})}e.safeStringify=R;function I(d,h){const w=Object.create(null);return!d||!h||Object.keys(h).forEach(p=>{const t=d[p],o=h[p];v(t,o)||(w[p]=o)}),w}e.distinct=I;function _(d,h){const w=h.toLowerCase(),S=Object.keys(d).find(p=>p.toLowerCase()===w);return S?d[S]:d[h]}e.getCaseInsensitive=_;function D(d,h){const w=Object.create(null);for(const[S,p]of Object.entries(d))h(S,p)&&(w[S]=p);return w}e.filter=D;function C(d){let h=[],w=Object.getPrototypeOf(d);for(;Object.prototype!==w;)h=h.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return h}e.getAllPropertyNames=C;function E(d){const h=[];for(const w of C(d))typeof d[w]=="function"&&h.push(w);return h}e.getAllMethodNames=E;function n(d,h){const w=p=>function(){const t=Array.prototype.slice.call(arguments,0);return h(p,t)},S={};for(const p of d)S[p]=w(p);return S}e.createProxyObject=n}),define(Ce[52],De([1,0,67]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(T){function k(y){return y&&typeof y=="object"&&typeof y.id=="string"}T.isThemeColor=k})(P=e.ThemeColor||(e.ThemeColor={}));function l(T){return{id:T}}e.themeColorFromId=l;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(h){const w=k.exec(h.id);if(!w)return y(a.Codicon.error);const[,S,p]=w,t=["codicon","codicon-"+S];return p&&t.push("codicon-modifier-"+p.substring(1)),t}T.asClassNameArray=y;function v(h){return y(h).join(" ")}T.asClassName=v;function R(h){return"."+y(h).join(".")}T.asCSSSelector=R;function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||P.isThemeColor(h.color))}T.isThemeIcon=I;const _=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function D(h){const w=_.exec(h);if(!w)return;const[,S]=w;return{id:S}}T.fromString=D;function C(h){return{id:h}}T.fromId=C;function E(h,w){let S=h.id;const p=S.lastIndexOf("~");return p!==-1&&(S=S.substring(0,p)),w&&(S=`${S}~${w}`),{id:S}}T.modify=E;function n(h){const w=h.id.lastIndexOf("~");if(w!==-1)return h.id.substring(w+1)}T.getModifier=n;function d(h,w){return h.id===w.id&&h.color?.id===w.color?.id}T.isEqual=d})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[105],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function P(A){return A<0?0:A>255?255:A|0}e.toUint8=P;function l(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=l}),define(Ce[30],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(l){return a.test(l)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(k){for(let y=0;y<k.length;y++)k[y]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,v="";return v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+="-",v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v+=T[A[y++]],v}}()}),define(Ce[150],De([1,0,18,30]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(k){return{id:(0,P.generateUuid)(),asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=l;function A(k,y,v){return{id:(0,P.generateUuid)(),asString:async()=>"",asFile:()=>({name:k,uri:y,data:v}),value:void 0}}e.createFileDataTransferItem=A;class T{constructor(){this._entries=new Map}get size(){return this._entries.size}has(y){return this._entries.has(this.toKey(y))}get(y){return this._entries.get(this.toKey(y))?.[0]}append(y,v){const R=this._entries.get(y);R?R.push(v):this._entries.set(this.toKey(y),[v])}replace(y,v){this._entries.set(this.toKey(y),[v])}delete(y){this._entries.delete(this.toKey(y))}*entries(){for(const[y,v]of this._entries.entries())for(const R of v)yield[y,R]}values(){return Array.from(this._entries.values()).flat()}forEach(y){for(const[v,R]of this.entries())y(R,v)}toKey(y){return y.toLowerCase()}}e.VSDataTransfer=T,e.UriList=Object.freeze({create:k=>(0,a.distinct)(k.map(y=>y.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(y=>!y.startsWith("#"))})}),define(Ce[106],De([1,0,105]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(k){const y=(0,a.toUint8)(k);this._defaultValue=y,this._asciiMap=P._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){const y=new Uint8Array(256);return y.fill(k),y}set(k,y){const v=(0,a.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=v:this._map.set(k,v)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=P;var l;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(l||(l={}));class A{constructor(){this._actual=new P(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(Ce[53],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(l,A){this.lineNumber=l,this.column=A}with(l=this.lineNumber,A=this.column){return l===this.lineNumber&&A===this.column?this:new a(l,A)}delta(l=0,A=0){return this.with(this.lineNumber+l,this.column+A)}equals(l){return a.equals(this,l)}static equals(l,A){return!l&&!A?!0:!!l&&!!A&&l.lineNumber===A.lineNumber&&l.column===A.column}isBefore(l){return a.isBefore(this,l)}static isBefore(l,A){return l.lineNumber<A.lineNumber?!0:A.lineNumber<l.lineNumber?!1:l.column<A.column}isBeforeOrEqual(l){return a.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,A){return l.lineNumber<A.lineNumber?!0:A.lineNumber<l.lineNumber?!1:l.column<=A.column}static compare(l,A){const T=l.lineNumber|0,k=A.lineNumber|0;if(T===k){const y=l.column|0,v=A.column|0;return y-v}return T-k}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new a(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=a}),define(Ce[32],De([1,0,53]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(A,T,k,y){A>k||A===k&&T>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=A,this.endColumn=T):(this.startLineNumber=A,this.startColumn=T,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return P.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return P.containsPosition(this,A)}static containsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<A.startColumn||T.lineNumber===A.endLineNumber&&T.column>A.endColumn)}static strictContainsPosition(A,T){return!(T.lineNumber<A.startLineNumber||T.lineNumber>A.endLineNumber||T.lineNumber===A.startLineNumber&&T.column<=A.startColumn||T.lineNumber===A.endLineNumber&&T.column>=A.endColumn)}containsRange(A){return P.containsRange(this,A)}static containsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>A.endColumn)}strictContainsRange(A){return P.strictContainsRange(this,A)}static strictContainsRange(A,T){return!(T.startLineNumber<A.startLineNumber||T.endLineNumber<A.startLineNumber||T.startLineNumber>A.endLineNumber||T.endLineNumber>A.endLineNumber||T.startLineNumber===A.startLineNumber&&T.startColumn<=A.startColumn||T.endLineNumber===A.endLineNumber&&T.endColumn>=A.endColumn)}plusRange(A){return P.plusRange(this,A)}static plusRange(A,T){let k,y,v,R;return T.startLineNumber<A.startLineNumber?(k=T.startLineNumber,y=T.startColumn):T.startLineNumber===A.startLineNumber?(k=T.startLineNumber,y=Math.min(T.startColumn,A.startColumn)):(k=A.startLineNumber,y=A.startColumn),T.endLineNumber>A.endLineNumber?(v=T.endLineNumber,R=T.endColumn):T.endLineNumber===A.endLineNumber?(v=T.endLineNumber,R=Math.max(T.endColumn,A.endColumn)):(v=A.endLineNumber,R=A.endColumn),new P(k,y,v,R)}intersectRanges(A){return P.intersectRanges(this,A)}static intersectRanges(A,T){let k=A.startLineNumber,y=A.startColumn,v=A.endLineNumber,R=A.endColumn;const I=T.startLineNumber,_=T.startColumn,D=T.endLineNumber,C=T.endColumn;return k<I?(k=I,y=_):k===I&&(y=Math.max(y,_)),v>D?(v=D,R=C):v===D&&(R=Math.min(R,C)),k>v||k===v&&y>R?null:new P(k,y,v,R)}equalsRange(A){return P.equalsRange(this,A)}static equalsRange(A,T){return!A&&!T?!0:!!A&&!!T&&A.startLineNumber===T.startLineNumber&&A.startColumn===T.startColumn&&A.endLineNumber===T.endLineNumber&&A.endColumn===T.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,T){return new P(this.startLineNumber,this.startColumn,A,T)}setStartPosition(A,T){return new P(A,T,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(A){return new P(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(A){return new P(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new P(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,T=A){return new P(A.lineNumber,A.column,T.lineNumber,T.column)}static lift(A){return A?new P(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<A.startColumn)}static areIntersecting(A,T){return!(A.endLineNumber<T.startLineNumber||A.endLineNumber===T.startLineNumber&&A.endColumn<=T.startColumn||T.endLineNumber<A.startLineNumber||T.endLineNumber===A.startLineNumber&&T.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,T){if(A&&T){const v=A.startLineNumber|0,R=T.startLineNumber|0;if(v===R){const I=A.startColumn|0,_=T.startColumn|0;if(I===_){const D=A.endLineNumber|0,C=T.endLineNumber|0;if(D===C){const E=A.endColumn|0,n=T.endColumn|0;return E-n}return D-C}return I-_}return v-R}return(A?1:0)-(T?1:0)}static compareRangesUsingEnds(A,T){return A.endLineNumber===T.endLineNumber?A.endColumn===T.endColumn?A.startLineNumber===T.startLineNumber?A.startColumn-T.startColumn:A.startLineNumber-T.startLineNumber:A.endColumn-T.endColumn:A.endLineNumber-T.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=P}),define(Ce[151],De([1,0,53,32]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class A extends P.Range{constructor(k,y,v,R){super(k,y,v,R),this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,y):new A(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,y){return this.getDirection()===0?new A(k,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new A(k.lineNumber,k.column,y.lineNumber,y.column)}static fromRange(k,y){return y===0?new A(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new A(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let v=0,R=k.length;v<R;v++)if(!this.selectionsEqual(k[v],y[v]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,v,R,I){return I===0?new A(k,y,v,R):new A(v,R,k,y)}}e.Selection=A}),define(Ce[152],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[153],De([1,0,106]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends a.CharacterClassifier{constructor(k){super(0);for(let y=0,v=k.length;y<v;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function A(T){const k={};return y=>(k.hasOwnProperty(y)||(k[y]=T(y)),k[y])}e.getMapForWordSeparators=A(T=>new l(T))}),define(Ce[107],De([1,0,64,6,66]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)I.indexOf(D)>=0||(_+="\\"+D);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=A();function T(I){let _=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)_=I;else{let D="g";I.ignoreCase&&(D+="i"),I.multiline&&(D+="m"),I.unicode&&(D+="u"),_=new RegExp(I.source,D)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const k=new l.LinkedList;k.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(I){const _=k.unshift(I);return(0,P.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=y;function v(I,_,D,C,E){if(E||(E=a.Iterable.first(k)),D.length>E.maxLen){let S=I-E.maxLen/2;return S<0?S=0:C+=S,D=D.substring(S,I+E.maxLen/2),v(I,_,D,C,E)}const n=Date.now(),d=I-1-C;let h=-1,w=null;for(let S=1;!(Date.now()-n>=E.timeBudget);S++){const p=d-E.windowSize*S;_.lastIndex=Math.max(0,p);const t=R(_,D,d,h);if(!t&&w||(w=t,p<=0))break;h=p}if(w){const S={word:w[0],startColumn:C+1+w.index,endColumn:C+1+w.index+w[0].length};return _.lastIndex=0,S}return null}e.getWordAtText=v;function R(I,_,D,C){let E;for(;E=I.exec(_);){const n=E.index||0;if(n<=D&&I.lastIndex>=D)return E;if(C>0&&n>C)return null}return null}}),define(Ce[154],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class P{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let y=0,v=k.notIn.length;y<v;y++)switch(k.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,y){if(k.getTokenCount()===0)return!0;const v=k.findTokenIndexAtOffset(y-2),R=k.getStandardTokenType(v);return this.isOK(R)}_findNeutralCharacterInRange(k,y){for(let v=k;v<=y;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=P;class l{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=l;function A(T,k,y){T.has(k)?T.get(k).push(y):T.set(k,[y])}}),define(Ce[155],De([1,0,106]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var P;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class l{constructor(C,E,n){const d=new Uint8Array(C*E);for(let h=0,w=C*E;h<w;h++)d[h]=n;this._data=d,this.rows=C,this.cols=E}get(C,E){return this._data[C*this.cols+E]}set(C,E,n){this._data[C*this.cols+E]=n}}class A{constructor(C){let E=0,n=0;for(let h=0,w=C.length;h<w;h++){const[S,p,t]=C[h];p>E&&(E=p),S>n&&(n=S),t>n&&(n=t)}E++,n++;const d=new l(n,E,0);for(let h=0,w=C.length;h<w;h++){const[S,p,t]=C[h];d.set(S,p,t)}this._states=d,this._maxCharCode=E}nextState(C,E){return E<0||E>=this._maxCharCode?0:this._states.get(C,E)}}e.StateMachine=A;let T=null;function k(){return T===null&&(T=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let v=null;function R(){if(v===null){v=new a.CharacterClassifier(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<D.length;E++)v.set(D.charCodeAt(E),1);const C=".,;:";for(let E=0;E<C.length;E++)v.set(C.charCodeAt(E),2)}return v}class I{static _createLink(C,E,n,d,h){let w=h-1;do{const S=E.charCodeAt(w);if(C.get(S)!==2)break;w--}while(w>d);if(d>0){const S=E.charCodeAt(d-1),p=E.charCodeAt(w);(S===40&&p===41||S===91&&p===93||S===123&&p===125)&&w--}return{range:{startLineNumber:n,startColumn:d+1,endLineNumber:n,endColumn:w+2},url:E.substring(d,w+1)}}static computeLinks(C,E=k()){const n=R(),d=[];for(let h=1,w=C.getLineCount();h<=w;h++){const S=C.getLineContent(h),p=S.length;let t=0,o=0,r=0,c=1,m=!1,f=!1,i=!1,s=!1;for(;t<p;){let u=!1;const b=S.charCodeAt(t);if(c===13){let g;switch(b){case 40:m=!0,g=0;break;case 41:g=m?0:1;break;case 91:i=!0,f=!0,g=0;break;case 93:i=!1,g=f?0:1;break;case 123:s=!0,g=0;break;case 125:g=s?0:1;break;case 39:case 34:case 96:r===b?g=1:r===39||r===34||r===96?g=0:g=1;break;case 42:g=r===42?1:0;break;case 124:g=r===124?1:0;break;case 32:g=i?0:1;break;default:g=n.get(b)}g===1&&(d.push(I._createLink(n,S,h,o,t)),u=!0)}else if(c===12){let g;b===91?(f=!0,g=0):g=n.get(b),g===1?u=!0:c=13}else c=E.nextState(c,b),c===0&&(u=!0);u&&(c=1,m=!1,f=!1,s=!1,o=t+1,r=b),t++}c===13&&d.push(I._createLink(n,S,h,o,p))}return d}}e.LinkComputer=I;function _(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:I.computeLinks(D)}e.computeLinks=_}),define(Ce[108],De([1,0,23]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var P;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(P=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var T;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class v{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),S.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,S.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this._indentSizeIsTabSize===S._indentSizeIsTabSize&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=v;class R{constructor(S,p){this._findMatchBrand=void 0,this.range=S,this.matches=p}}e.FindMatch=R;var I;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function _(w){return w&&typeof w.read=="function"}e.isITextSnapshot=_;var D;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class E{constructor(S,p,t,o,r,c){this.identifier=S,this.range=p,this.text=t,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=r,this._isTracked=c}}e.ValidAnnotatedEditOperation=E;class n{constructor(S,p,t){this.regex=S,this.wordSeparators=p,this.simpleSearch=t}}e.SearchData=n;class d{constructor(S,p,t){this.reverseEdits=S,this.changes=p,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function h(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=h}),define(Ce[156],De([1,0,18,105]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,v){y=(0,P.toUint32)(y);const R=this.values,I=this.prefixSum,_=v.length;return _===0?!1:(this.values=new Uint32Array(R.length+_),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y),y+_),this.values.set(v,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,v){return y=(0,P.toUint32)(y),v=(0,P.toUint32)(v),this.values[y]===v?!1:(this.values[y]=v,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,v){y=(0,P.toUint32)(y),v=(0,P.toUint32)(v);const R=this.values,I=this.prefixSum;if(y>=R.length)return!1;const _=R.length-y;return v>=_&&(v=_),v===0?!1:(this.values=new Uint32Array(R.length-v),this.values.set(R.subarray(0,y),0),this.values.set(R.subarray(y+v),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,P.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let v=this.prefixSumValidIndex[0]+1;v===0&&(this.prefixSum[0]=this.values[0],v++),y>=this.values.length&&(y=this.values.length-1);for(let R=v;R<=y;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let v=0,R=this.values.length-1,I=0,_=0,D=0;for(;v<=R;)if(I=v+(R-v)/2|0,_=this.prefixSum[I],D=_-this.values[I],y<D)R=I-1;else if(y>=_)v=I+1;else break;return new T(I,y-D)}}e.PrefixSumComputer=l;class A{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const v=this._indexBySum[y],R=v>0?this._prefixSum[v-1]:0;return new T(v,y-R)}removeValues(y,v){this._values.splice(y,v),this._invalidate(y)}insertValues(y,v){this._values=(0,a.arrayInsert)(this._values,y,v),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,v=this._values.length;y<v;y++){const R=this._values[y],I=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=I+R;for(let _=0;_<R;_++)this._indexBySum[I+_]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,v){this._values[y]!==v&&(this._values[y]=v,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=A;class T{constructor(y,v){this.index=y,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=v}}e.PrefixSumIndexOfResult=T}),define(Ce[157],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDnDService=void 0;class a{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(l){if(l&&this._dragOperations.has(l)){const A=this._dragOperations.get(l);return this._dragOperations.delete(l),A}}addDragOperationTransfer(l,A){this._dragOperations.set(l,A)}}e.TreeViewsDnDService=a}),define(Ce[158],De([12,13]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Ce[159],De([12,13]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ce[160],De([1,0,159]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,l=P*60,A=l*24,T=A*7,k=A*30,y=A*365;function v(I,_,D,C){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,a.localize)(0,null,v(new Date().getTime()+E*1e3,!1));if(!C&&E<30)return(0,a.localize)(1,null);let n;return E<P?(n=E,_?n===1?D?(0,a.localize)(2,null,n):(0,a.localize)(3,null,n):D?(0,a.localize)(4,null,n):(0,a.localize)(5,null,n):n===1?D?(0,a.localize)(6,null,n):(0,a.localize)(7,null,n):D?(0,a.localize)(8,null,n):(0,a.localize)(9,null,n)):E<l?(n=Math.floor(E/P),_?n===1?D?(0,a.localize)(10,null,n):(0,a.localize)(11,null,n):D?(0,a.localize)(12,null,n):(0,a.localize)(13,null,n):n===1?D?(0,a.localize)(14,null,n):(0,a.localize)(15,null,n):D?(0,a.localize)(16,null,n):(0,a.localize)(17,null,n)):E<A?(n=Math.floor(E/l),_?n===1?D?(0,a.localize)(18,null,n):(0,a.localize)(19,null,n):D?(0,a.localize)(20,null,n):(0,a.localize)(21,null,n):n===1?D?(0,a.localize)(22,null,n):(0,a.localize)(23,null,n):D?(0,a.localize)(24,null,n):(0,a.localize)(25,null,n)):E<T?(n=Math.floor(E/A),_?n===1?(0,a.localize)(26,null,n):(0,a.localize)(27,null,n):n===1?(0,a.localize)(28,null,n):(0,a.localize)(29,null,n)):E<k?(n=Math.floor(E/T),_?n===1?D?(0,a.localize)(30,null,n):(0,a.localize)(31,null,n):D?(0,a.localize)(32,null,n):(0,a.localize)(33,null,n):n===1?D?(0,a.localize)(34,null,n):(0,a.localize)(35,null,n):D?(0,a.localize)(36,null,n):(0,a.localize)(37,null,n)):E<y?(n=Math.floor(E/k),_?n===1?D?(0,a.localize)(38,null,n):(0,a.localize)(39,null,n):D?(0,a.localize)(40,null,n):(0,a.localize)(41,null,n):n===1?D?(0,a.localize)(42,null,n):(0,a.localize)(43,null,n):D?(0,a.localize)(44,null,n):(0,a.localize)(45,null,n)):(n=Math.floor(E/y),_?n===1?D?(0,a.localize)(46,null,n):(0,a.localize)(47,null,n):D?(0,a.localize)(48,null,n):(0,a.localize)(49,null,n):n===1?D?(0,a.localize)(50,null,n):(0,a.localize)(51,null,n):D?(0,a.localize)(52,null,n):(0,a.localize)(53,null,n))}e.fromNow=v;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ce[161],De([12,13]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ce[46],De([1,0,18,10,161]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,_){return _&&(I.stack||I.stacktrace)?l.localize(0,null,k(I),T(I.stack)||T(I.stacktrace)):k(I)}function T(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?l.localize(1,null,I.message):I.message||l.localize(2,null)}function y(I=null,_=!1){if(!I)return l.localize(3,null);if(Array.isArray(I)){const D=a.coalesce(I),C=y(D[0],_);return D.length>1?l.localize(4,null,C,D.length):C}if(P.isString(I))return I;if(I.detail){const D=I.detail;if(D.error)return A(D.error,_);if(D.exception)return A(D.exception,_)}return I.stack?A(I,_):I.message?I.message:l.localize(5,null)}e.toErrorMessage=y;function v(I){const _=I;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=v;function R(I,_){let D;return typeof I=="string"?D=new Error(I):D=I,D.actions=_,D}e.createErrorWithActions=R}),define(Ce[162],De([12,13]),function(re,e){return re.create("vs/base/common/platform",e)}),define(Ce[14],De([1,0,162]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let P=!1,l=!1,A=!1,T=!1,k=!1,y=!1,v=!1,R=!1,I=!1,_=!1,D,C=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,n,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const w=typeof h?.versions?.electron=="string",S=w&&h?.type==="renderer";if(typeof navigator=="object"&&!S)d=navigator.userAgent,P=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,R=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,_=d?.indexOf("Mobi")>=0,y=!0,D=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,C=D,E=navigator.language;else if(typeof h=="object"){P=h.platform==="win32",l=h.platform==="darwin",A=h.platform==="linux",T=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,v=w,I=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const s=h.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),b=u.availableLanguages["*"];D=u.locale,E=u.osLocale,C=b||e.LANGUAGE_DEFAULT,n=u._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var p;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function t(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let o=0;l?o=1:P?o=3:A&&(o=2),e.isWindows=P,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=T,e.isNative=k,e.isElectron=v,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=_,e.isCI=I,e.platform=o,e.userAgent=d,e.language=C;var r;(function(s){function u(){return e.language}s.value=u;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=b;function g(){return e.language==="en"}s.isDefault=g})(r=e.Language||(e.Language={})),e.locale=D,e.platformLocale=E,e.translationsConfigFile=n,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let g=0,L=s.length;g<L;g++){const H=s[g];if(H.id===b.data.vscodeScheduleAsyncWork){s.splice(g,1),H.callback();return}}});let u=0;return b=>{const g=++u;s.push({id:g,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||R?2:P?1:3;let m=!0,f=!1;function i(){if(!f){f=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,m=new Uint16Array(s.buffer)[0]===(2<<8)+1}return m}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[33],De([1,0,14]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let P;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const l=a.globals.vscode.process;P={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.arch=P.arch}),define(Ce[15],De([1,0,33]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,l=97,A=90,T=122,k=46,y=47,v=92,R=58,I=63;class _ extends Error{constructor(o,r,c){let m;typeof r=="string"&&r.indexOf("not ")===0?(m="must not be",r=r.replace(/^not /,"")):m="must be";const f=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${f} ${m} of type ${r}`;i+=`. Received type ${typeof c}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function D(t,o){if(t===null||typeof t!="object")throw new _(o,"Object",t)}function C(t,o){if(typeof t!="string")throw new _(o,"string",t)}const E=a.platform==="win32";function n(t){return t===y||t===v}function d(t){return t===y}function h(t){return t>=P&&t<=A||t>=l&&t<=T}function w(t,o,r,c){let m="",f=0,i=-1,s=0,u=0;for(let b=0;b<=t.length;++b){if(b<t.length)u=t.charCodeAt(b);else{if(c(u))break;u=y}if(c(u)){if(!(i===b-1||s===1))if(s===2){if(m.length<2||f!==2||m.charCodeAt(m.length-1)!==k||m.charCodeAt(m.length-2)!==k){if(m.length>2){const g=m.lastIndexOf(r);g===-1?(m="",f=0):(m=m.slice(0,g),f=m.length-1-m.lastIndexOf(r)),i=b,s=0;continue}else if(m.length!==0){m="",f=0,i=b,s=0;continue}}o&&(m+=m.length>0?`${r}..`:"..",f=2)}else m.length>0?m+=`${r}${t.slice(i+1,b)}`:m=t.slice(i+1,b),f=b-i-1;i=b,s=0}else u===k&&s!==-1?++s:s=-1}return m}function S(t,o){D(o,"pathObject");const r=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${c}`:`${r}${t}${c}`:c}e.win32={resolve(...t){let o="",r="",c=!1;for(let m=t.length-1;m>=-1;m--){let f;if(m>=0){if(f=t[m],C(f,"path"),f.length===0)continue}else o.length===0?f=a.cwd():(f=a.env[`=${o}`]||a.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==o.toLowerCase()&&f.charCodeAt(2)===v)&&(f=`${o}\\`));const i=f.length;let s=0,u="",b=!1;const g=f.charCodeAt(0);if(i===1)n(g)&&(s=1,b=!0);else if(n(g))if(b=!0,n(f.charCodeAt(1))){let L=2,H=L;for(;L<i&&!n(f.charCodeAt(L));)L++;if(L<i&&L!==H){const q=f.slice(H,L);for(H=L;L<i&&n(f.charCodeAt(L));)L++;if(L<i&&L!==H){for(H=L;L<i&&!n(f.charCodeAt(L));)L++;(L===i||L!==H)&&(u=`\\\\${q}\\${f.slice(H,L)}`,s=L)}}}else s=1;else h(g)&&f.charCodeAt(1)===R&&(u=f.slice(0,2),s=2,i>2&&n(f.charCodeAt(2))&&(b=!0,s=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(c){if(o.length>0)break}else if(r=`${f.slice(s)}\\${r}`,c=b,b&&o.length>0)break}return r=w(r,!c,"\\",n),c?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){C(t,"path");const o=t.length;if(o===0)return".";let r=0,c,m=!1;const f=t.charCodeAt(0);if(o===1)return d(f)?"\\":t;if(n(f))if(m=!0,n(t.charCodeAt(1))){let s=2,u=s;for(;s<o&&!n(t.charCodeAt(s));)s++;if(s<o&&s!==u){const b=t.slice(u,s);for(u=s;s<o&&n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&!n(t.charCodeAt(s));)s++;if(s===o)return`\\\\${b}\\${t.slice(u)}\\`;s!==u&&(c=`\\\\${b}\\${t.slice(u,s)}`,r=s)}}}else r=1;else h(f)&&t.charCodeAt(1)===R&&(c=t.slice(0,2),r=2,o>2&&n(t.charCodeAt(2))&&(m=!0,r=3));let i=r<o?w(t.slice(r),!m,"\\",n):"";return i.length===0&&!m&&(i="."),i.length>0&&n(t.charCodeAt(o-1))&&(i+="\\"),c===void 0?m?`\\${i}`:i:m?`${c}\\${i}`:`${c}${i}`},isAbsolute(t){C(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return n(r)||o>2&&h(r)&&t.charCodeAt(1)===R&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let f=0;f<t.length;++f){const i=t[f];C(i,"path"),i.length>0&&(o===void 0?o=r=i:o+=`\\${i}`)}if(o===void 0)return".";let c=!0,m=0;if(typeof r=="string"&&n(r.charCodeAt(0))){++m;const f=r.length;f>1&&n(r.charCodeAt(1))&&(++m,f>2&&(n(r.charCodeAt(2))?++m:c=!1))}if(c){for(;m<o.length&&n(o.charCodeAt(m));)m++;m>=2&&(o=`\\${o.slice(m)}`)}return e.win32.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o)return"";const r=e.win32.resolve(t),c=e.win32.resolve(o);if(r===c||(t=r.toLowerCase(),o=c.toLowerCase(),t===o))return"";let m=0;for(;m<t.length&&t.charCodeAt(m)===v;)m++;let f=t.length;for(;f-1>m&&t.charCodeAt(f-1)===v;)f--;const i=f-m;let s=0;for(;s<o.length&&o.charCodeAt(s)===v;)s++;let u=o.length;for(;u-1>s&&o.charCodeAt(u-1)===v;)u--;const b=u-s,g=i<b?i:b;let L=-1,H=0;for(;H<g;H++){const X=t.charCodeAt(m+H);if(X!==o.charCodeAt(s+H))break;X===v&&(L=H)}if(H!==g){if(L===-1)return c}else{if(b>g){if(o.charCodeAt(s+H)===v)return c.slice(s+H+1);if(H===2)return c.slice(s+H)}i>g&&(t.charCodeAt(m+H)===v?L=H:H===2&&(L=3)),L===-1&&(L=0)}let q="";for(H=m+L+1;H<=f;++H)(H===f||t.charCodeAt(H)===v)&&(q+=q.length===0?"..":"\\..");return s+=L,q.length>0?`${q}${c.slice(s,u)}`:(c.charCodeAt(s)===v&&++s,c.slice(s,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===v){if(o.charCodeAt(1)===v){const r=o.charCodeAt(2);if(r!==I&&r!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===R&&o.charCodeAt(2)===v)return`\\\\?\\${o}`;return t},dirname(t){C(t,"path");const o=t.length;if(o===0)return".";let r=-1,c=0;const m=t.charCodeAt(0);if(o===1)return n(m)?t:".";if(n(m)){if(r=c=1,n(t.charCodeAt(1))){let s=2,u=s;for(;s<o&&!n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&!n(t.charCodeAt(s));)s++;if(s===o)return t;s!==u&&(r=c=s+1)}}}}else h(m)&&t.charCodeAt(1)===R&&(r=o>2&&n(t.charCodeAt(2))?3:2,c=r);let f=-1,i=!0;for(let s=o-1;s>=c;--s)if(n(t.charCodeAt(s))){if(!i){f=s;break}}else i=!1;if(f===-1){if(r===-1)return".";f=r}return t.slice(0,f)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let r=0,c=-1,m=!0,f;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,s=-1;for(f=t.length-1;f>=r;--f){const u=t.charCodeAt(f);if(n(u)){if(!m){r=f+1;break}}else s===-1&&(m=!1,s=f+1),i>=0&&(u===o.charCodeAt(i)?--i===-1&&(c=f):(i=-1,c=s))}return r===c?c=s:c===-1&&(c=t.length),t.slice(r,c)}for(f=t.length-1;f>=r;--f)if(n(t.charCodeAt(f))){if(!m){r=f+1;break}}else c===-1&&(m=!1,c=f+1);return c===-1?"":t.slice(r,c)},extname(t){C(t,"path");let o=0,r=-1,c=0,m=-1,f=!0,i=0;t.length>=2&&t.charCodeAt(1)===R&&h(t.charCodeAt(0))&&(o=c=2);for(let s=t.length-1;s>=o;--s){const u=t.charCodeAt(s);if(n(u)){if(!f){c=s+1;break}continue}m===-1&&(f=!1,m=s+1),u===k?r===-1?r=s:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||m===-1||i===0||i===1&&r===m-1&&r===c+1?"":t.slice(r,m)},format:S.bind(null,"\\"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let c=0,m=t.charCodeAt(0);if(r===1)return n(m)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(n(m)){if(c=1,n(t.charCodeAt(1))){let L=2,H=L;for(;L<r&&!n(t.charCodeAt(L));)L++;if(L<r&&L!==H){for(H=L;L<r&&n(t.charCodeAt(L));)L++;if(L<r&&L!==H){for(H=L;L<r&&!n(t.charCodeAt(L));)L++;L===r?c=L:L!==H&&(c=L+1)}}}}else if(h(m)&&t.charCodeAt(1)===R){if(r<=2)return o.root=o.dir=t,o;if(c=2,n(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let f=-1,i=c,s=-1,u=!0,b=t.length-1,g=0;for(;b>=c;--b){if(m=t.charCodeAt(b),n(m)){if(!u){i=b+1;break}continue}s===-1&&(u=!1,s=b+1),m===k?f===-1?f=b:g!==1&&(g=1):f!==-1&&(g=-1)}return s!==-1&&(f===-1||g===0||g===1&&f===s-1&&f===i+1?o.base=o.name=t.slice(i,s):(o.name=t.slice(i,f),o.base=t.slice(i,s),o.ext=t.slice(f,s))),i>0&&i!==c?o.dir=t.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(E){const t=/\\/g;return()=>{const o=a.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...t){let o="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const m=c>=0?t[c]:p();C(m,"path"),m.length!==0&&(o=`${m}/${o}`,r=m.charCodeAt(0)===y)}return o=w(o,!r,"/",d),r?`/${o}`:o.length>0?o:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y,r=t.charCodeAt(t.length-1)===y;return t=w(t,!o,"/",d),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const c=t[r];C(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const r=1,c=t.length,m=c-r,f=1,i=o.length-f,s=m<i?m:i;let u=-1,b=0;for(;b<s;b++){const L=t.charCodeAt(r+b);if(L!==o.charCodeAt(f+b))break;L===y&&(u=b)}if(b===s)if(i>s){if(o.charCodeAt(f+b)===y)return o.slice(f+b+1);if(b===0)return o.slice(f+b)}else m>s&&(t.charCodeAt(r+b)===y?u=b:b===0&&(u=0));let g="";for(b=r+u+1;b<=c;++b)(b===c||t.charCodeAt(b)===y)&&(g+=g.length===0?"..":"/..");return`${g}${o.slice(f+u)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y;let r=-1,c=!0;for(let m=t.length-1;m>=1;--m)if(t.charCodeAt(m)===y){if(!c){r=m;break}}else c=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let r=0,c=-1,m=!0,f;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,s=-1;for(f=t.length-1;f>=0;--f){const u=t.charCodeAt(f);if(u===y){if(!m){r=f+1;break}}else s===-1&&(m=!1,s=f+1),i>=0&&(u===o.charCodeAt(i)?--i===-1&&(c=f):(i=-1,c=s))}return r===c?c=s:c===-1&&(c=t.length),t.slice(r,c)}for(f=t.length-1;f>=0;--f)if(t.charCodeAt(f)===y){if(!m){r=f+1;break}}else c===-1&&(m=!1,c=f+1);return c===-1?"":t.slice(r,c)},extname(t){C(t,"path");let o=-1,r=0,c=-1,m=!0,f=0;for(let i=t.length-1;i>=0;--i){const s=t.charCodeAt(i);if(s===y){if(!m){r=i+1;break}continue}c===-1&&(m=!1,c=i+1),s===k?o===-1?o=i:f!==1&&(f=1):o!==-1&&(f=-1)}return o===-1||c===-1||f===0||f===1&&o===c-1&&o===r+1?"":t.slice(o,c)},format:S.bind(null,"/"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===y;let c;r?(o.root="/",c=1):c=0;let m=-1,f=0,i=-1,s=!0,u=t.length-1,b=0;for(;u>=c;--u){const g=t.charCodeAt(u);if(g===y){if(!s){f=u+1;break}continue}i===-1&&(s=!1,i=u+1),g===k?m===-1?m=u:b!==1&&(b=1):m!==-1&&(b=-1)}if(i!==-1){const g=f===0&&r?1:f;m===-1||b===0||b===1&&m===i-1&&m===f+1?o.base=o.name=t.slice(g,i):(o.name=t.slice(g,m),o.base=t.slice(g,i),o.ext=t.slice(m,i))}return f>0?o.dir=t.slice(0,f-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(Ce[109],De([1,0,65,15]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new a.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),A=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(s,u,b=!1){const g=s||"",L=u||"",H=l.value.collator.compare(g,L);return l.value.collatorIsNumeric&&H===0&&g!==L?g<L?-1:1:H}e.compareFileNames=k;function y(s,u){const b=A.value.collator;return s=s||"",u=u||"",S(b,s,u)}e.compareFileNamesDefault=y;function v(s,u){const b=A.value.collator;return s=s||"",u=u||"",r(s,u)||S(b,s,u)}e.compareFileNamesUpper=v;function R(s,u){const b=A.value.collator;return s=s||"",u=u||"",o(s,u)||S(b,s,u)}e.compareFileNamesLower=R;function I(s,u){return s=s||"",u=u||"",s===u?0:s<u?-1:1}e.compareFileNamesUnicode=I;function _(s,u){const[b,g]=h(s),[L,H]=h(u);let q=l.value.collator.compare(g,H);if(q===0){if(l.value.collatorIsNumeric&&g!==H)return g<H?-1:1;if(q=l.value.collator.compare(b,L),l.value.collatorIsNumeric&&q===0&&b!==L)return b<L?-1:1}return q}e.compareFileExtensions=_;function D(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=A.value.collator,H=T.value.collator;return S(H,b,g)||S(L,s,u)}e.compareFileExtensionsDefault=D;function C(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=A.value.collator,H=T.value.collator;return S(H,b,g)||r(s,u)||S(L,s,u)}e.compareFileExtensionsUpper=C;function E(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=A.value.collator,H=T.value.collator;return S(H,b,g)||o(s,u)||S(L,s,u)}e.compareFileExtensionsLower=E;function n(s,u){s=s||"",u=u||"";const b=w(s).toLowerCase(),g=w(u).toLowerCase();return b!==g?b<g?-1:1:s!==u?s<u?-1:1:0}e.compareFileExtensionsUnicode=n;const d=/^(.*?)(\.([^.]*))?$/;function h(s,u=!1){const b=s?d.exec(s):[];let g=[b&&b[1]||"",b&&b[3]||""];return u&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function w(s){const u=s?d.exec(s):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function S(s,u,b){const g=s.compare(u,b);return g!==0?g:u.length!==b.length?u.length<b.length?-1:1:0}function p(s){const u=s.charAt(0);return u.toLocaleUpperCase()!==u}function t(s){const u=s.charAt(0);return u.toLocaleLowerCase()!==u}function o(s,u){return p(s)&&t(u)?-1:t(s)&&p(u)?1:0}function r(s,u){return t(s)&&p(u)?-1:p(s)&&t(u)?1:0}function c(s,u,b=!1){return b||(s=s&&s.toLowerCase(),u=u&&u.toLowerCase()),s===u?0:s<u?-1:1}function m(s,u,b=!1){const g=s.split(P.sep),L=u.split(P.sep),H=g.length-1,q=L.length-1;let X,U;for(let N=0;;N++){if(X=H===N,U=q===N,X&&U)return k(g[N],L[N],b);if(X)return-1;if(U)return 1;const x=c(g[N],L[N],b);if(x!==0)return x}}e.comparePaths=m;function f(s,u,b){const g=s.toLowerCase(),L=u.toLowerCase(),H=i(s,u,b);if(H)return H;const q=g.endsWith(b),X=L.endsWith(b);if(q!==X)return q?-1:1;const U=k(g,L);return U!==0?U:g.localeCompare(L)}e.compareAnything=f;function i(s,u,b){const g=s.toLowerCase(),L=u.toLowerCase(),H=g.startsWith(b),q=L.startsWith(b);if(H!==q)return H?-1:1;if(H&&q){if(g.length<L.length)return-1;if(g.length>L.length)return 1}return 0}e.compareByPrefix=i}),define(Ce[89],De([1,0,15]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,a.extname)(R),_=P[I.toLowerCase()];return _!==void 0?_:T(R)}e.getMediaOrTextMime=A;function T(R){const I=(0,a.extname)(R);return l[I.toLowerCase()]}e.getMediaMime=T;function k(R){for(const I in l)if(l[I]===R)return I}e.getExtensionForMimeType=k;const y=/^(.+)\/(.+?)(;.+)?$/;function v(R,I){const _=y.exec(R);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:I?void 0:R}e.normalizeMimeType=v}),define(Ce[110],De([1,0,14]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var P;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(P=e.Source||(e.Source={}));var l;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...y){const v=y.reduce((_,D)=>(_[D]=!0,_),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(_=>!v[_]).forEach(_=>{for(let D=0;D<R.length;D++)if(_.search(R[D])!==-1){delete k[_];break}})}e.sanitizeProcessEnvironment=A;function T(k){!k||(delete k.DEBUG,a.isMacintosh&&delete k.DYLD_LIBRARY_PATH,a.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(Ce[37],De([1,0,14]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=a.globals.performance&&typeof a.globals.performance.now=="function";class l{static create(T=!0){return new l(T)}constructor(T){this._highResolution=P&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?a.globals.performance.now():Date.now()}}e.StopWatch=l}),define(Ce[3],De([1,0,8,63,6,66,37]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,y=!1;var v;(function(f){f.None=()=>l.Disposable.None;function i(Y){if(y){const{onDidAddListener:ge}=Y,we=C.create();let ie=0;Y.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),ge?.()}}}function s(Y,ge){return N(Y,()=>{},0,void 0,!0,void 0,ge)}f.defer=s;function u(Y){return(ge,we=null,ie)=>{let ne=!1,de;return de=Y(ee=>{if(!ne)return de?de.dispose():ne=!0,ge.call(we,ee)},null,ie),ne&&de.dispose(),de}}f.once=u;function b(Y,ge,we){return U((ie,ne=null,de)=>Y(ee=>ie.call(ne,ge(ee)),null,de),we)}f.map=b;function g(Y,ge,we){return U((ie,ne=null,de)=>Y(ee=>{ge(ee),ie.call(ne,ee)},null,de),we)}f.forEach=g;function L(Y,ge,we){return U((ie,ne=null,de)=>Y(ee=>ge(ee)&&ie.call(ne,ee),null,de),we)}f.filter=L;function H(Y){return Y}f.signal=H;function q(...Y){return(ge,we=null,ie)=>(0,l.combinedDisposable)(...Y.map(ne=>ne(de=>ge.call(we,de),null,ie)))}f.any=q;function X(Y,ge,we,ie){let ne=we;return b(Y,de=>(ne=ge(ne,de),ne),ie)}f.reduce=X;function U(Y,ge){let we;const ie={onWillAddFirstListener(){we=Y(ne.fire,ne)},onDidRemoveLastListener(){we?.dispose()}};ge||i(ie);const ne=new n(ie);return ge?.add(ne),ne.event}function N(Y,ge,we=100,ie=!1,ne=!1,de,ee){let ce,ae,O,B=0,K;const Z={leakWarningThreshold:de,onWillAddFirstListener(){ce=Y(_e=>{B++,ae=ge(ae,_e),ie&&!O&&(he.fire(ae),ae=void 0),K=()=>{const Ae=ae;ae=void 0,O=void 0,(!ie||B>1)&&he.fire(Ae),B=0},typeof we=="number"?(clearTimeout(O),O=setTimeout(K,we)):O===void 0&&(O=0,queueMicrotask(K))})},onWillRemoveListener(){ne&&B>0&&K?.()},onDidRemoveLastListener(){K=void 0,ce.dispose()}};ee||i(Z);const he=new n(Z);return ee?.add(he),he.event}f.debounce=N;function x(Y,ge=0,we){return f.debounce(Y,(ie,ne)=>ie?(ie.push(ne),ie):[ne],ge,void 0,!0,void 0,we)}f.accumulate=x;function F(Y,ge=(ie,ne)=>ie===ne,we){let ie=!0,ne;return L(Y,de=>{const ee=ie||!ge(de,ne);return ie=!1,ne=de,ee},we)}f.latch=F;function V(Y,ge,we){return[f.filter(Y,ge,we),f.filter(Y,ie=>!ge(ie),we)]}f.split=V;function fe(Y,ge=!1,we=[]){let ie=we.slice(),ne=Y(ce=>{ie?ie.push(ce):ee.fire(ce)});const de=()=>{ie?.forEach(ce=>ee.fire(ce)),ie=null},ee=new n({onWillAddFirstListener(){ne||(ne=Y(ce=>ee.fire(ce)))},onDidAddFirstListener(){ie&&(ge?setTimeout(de):de())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return ee.event}f.buffer=fe;class se{constructor(ge){this.event=ge,this.disposables=new l.DisposableStore}map(ge){return new se(b(this.event,ge,this.disposables))}forEach(ge){return new se(g(this.event,ge,this.disposables))}filter(ge){return new se(L(this.event,ge,this.disposables))}reduce(ge,we){return new se(X(this.event,ge,we,this.disposables))}latch(){return new se(F(this.event,void 0,this.disposables))}debounce(ge,we=100,ie=!1,ne=!1,de){return new se(N(this.event,ge,we,ie,ne,de,this.disposables))}on(ge,we,ie){return this.event(ge,we,ie)}once(ge,we,ie){return u(this.event)(ge,we,ie)}dispose(){this.disposables.dispose()}}function $(Y){return new se(Y)}f.chain=$;function J(Y,ge,we=ie=>ie){const ie=(...ce)=>ee.fire(we(...ce)),ne=()=>Y.on(ge,ie),de=()=>Y.removeListener(ge,ie),ee=new n({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}f.fromNodeEventEmitter=J;function te(Y,ge,we=ie=>ie){const ie=(...ce)=>ee.fire(we(...ce)),ne=()=>Y.addEventListener(ge,ie),de=()=>Y.removeEventListener(ge,ie),ee=new n({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}f.fromDOMEventEmitter=te;function be(Y){return new Promise(ge=>u(Y)(ge))}f.toPromise=be;function le(Y,ge){return ge(void 0),Y(we=>ge(we))}f.runAndSubscribe=le;function ue(Y,ge){let we=null;function ie(de){we?.dispose(),we=new l.DisposableStore,ge(de,we)}ie(void 0);const ne=Y(de=>ie(de));return(0,l.toDisposable)(()=>{ne.dispose(),we?.dispose()})}f.runAndSubscribeWithStore=ue;class j{constructor(ge,we){this.obs=ge,this._counter=0,this._hasChanged=!1;const ie={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};we||i(ie),this.emitter=new n(ie),we&&we.add(this.emitter)}beginUpdate(ge){this._counter++}handleChange(ge,we){this._hasChanged=!0}endUpdate(ge){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function M(Y,ge){return new j(Y,ge).emitter.event}f.fromObservable=M})(v=e.Event||(e.Event={}));class R{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${R._idPool++}`,R.all.add(this)}start(i){this._stopWatch=new T.StopWatch(!0),this.listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this._stopWatch=void 0}}}R.all=new Set,R._idPool=0,e.EventProfiling=R;let I=-1;function _(f){const i=I;return I=f,{dispose(){I=i}}}e.setGlobalLeakWarningThreshold=_;class D{constructor(i,s=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=s,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(i,s){const u=this.threshold;if(u<=0||s<u)return;this._stacks||(this._stacks=new Map);const b=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let g,L=0;for(const[H,q]of this._stacks)(!g||L<q)&&(g=H,L=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${L}):`),console.warn(g)}return()=>{const g=this._stacks.get(i.value)||0;this._stacks.set(i.value,g-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(i,s,u){this.callback=i,this.callbackThis=s,this.stack=u,this.subscription=new l.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class n{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=I>0||this._options?.leakWarningThreshold?new D(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,s,u)=>{if(this._listeners||(this._listeners=new A.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const b=this._listeners.isEmpty();b&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let g,L;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(L=C.create(),g=this._leakageMon.check(L,this._listeners.size+1)),k&&(L=L??C.create());const H=new E(i,s,L),q=this._listeners.push(H);b&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,i,s);const X=H.subscription.set(()=>{g?.(),this._disposed||(this._options?.onWillRemoveListener?.(this),q(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return u instanceof l.DisposableStore?u.add(X):Array.isArray(u)&&u.push(X),X}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new h(this._options?.onListenerError));for(const s of this._listeners)this._deliveryQueue.push(this,s,i);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=n;class d{constructor(i=a.onUnexpectedError){this._onListenerError=i,this._queue=new A.LinkedList}get size(){return this._queue.size}push(i,s,u){this._queue.push(new w(i,s,u))}clear(i){const s=new A.LinkedList;for(const u of this._queue)u.emitter!==i&&s.push(u);this._queue=s}deliver(){for(;this._queue.size>0;){const i=this._queue.shift();try{i.listener.invoke(i.event)}catch(s){this._onListenerError(s)}}}}e.EventDeliveryQueue=d;class h extends d{clear(i){this._queue.clear()}}class w{constructor(i,s,u){this.emitter=i,this.listener=s,this.event=u}}class S extends n{async fireAsync(i,s,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const b of this._listeners)this._asyncDeliveryQueue.push([b,i]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[b,g]=this._asyncDeliveryQueue.shift(),L=[],H={...g,token:s,waitUntil:q=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");u&&(q=u(q,b.callback)),L.push(q)}};try{b.invoke(H)}catch(q){(0,a.onUnexpectedError)(q);continue}Object.freeze(L),await Promise.allSettled(L).then(q=>{for(const X of q)X.status==="rejected"&&(0,a.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=S;class p extends n{constructor(i){super(i),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=p;class t extends p{constructor(i){super(i),this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=t;class o extends n{constructor(i){super(i),this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){!this.hasListeners()||(this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const s={event:i,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const u=()=>{this.hasListeners&&this.unhook(s);const b=this.events.indexOf(s);this.events.splice(b,1)};return(0,l.toDisposable)((0,P.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(s=>this.emitter.fire(s))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class c{constructor(){this.buffers=[]}wrapEvent(i){return(s,u,b)=>i(g=>{const L=this.buffers[this.buffers.length-1];L?L.push(()=>s.call(u,g)):s.call(u,g)},void 0,b)}bufferEvents(i){const s=[];this.buffers.push(s);const u=i();return this.buffers.pop(),s.forEach(b=>b()),u}}e.EventBufferer=c;class m{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=l.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(Ce[163],De([1,0,3,6,158]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends P.Disposable{constructor(_,D="",C="",E=!0,n){super(),this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=_,this._label=D,this._cssClass=C,this._enabled=E,this._actionCallback=n}get id(){return this._id}get label(){return this._label}set label(_){this._setLabel(_)}_setLabel(_){this._label!==_&&(this._label=_,this._onDidChange.fire({label:_}))}get tooltip(){return this._tooltip||""}set tooltip(_){this._setTooltip(_)}_setTooltip(_){this._tooltip!==_&&(this._tooltip=_,this._onDidChange.fire({tooltip:_}))}get class(){return this._cssClass}set class(_){this._setClass(_)}_setClass(_){this._cssClass!==_&&(this._cssClass=_,this._onDidChange.fire({class:_}))}get enabled(){return this._enabled}set enabled(_){this._setEnabled(_)}_setEnabled(_){this._enabled!==_&&(this._enabled=_,this._onDidChange.fire({enabled:_}))}get checked(){return this._checked}set checked(_){this._setChecked(_)}_setChecked(_){this._checked!==_&&(this._checked=_,this._onDidChange.fire({checked:_}))}async run(_,D){this._actionCallback&&await this._actionCallback(_)}}e.Action=A;class T extends P.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new a.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new a.Emitter),this.onDidRun=this._onDidRun.event}async run(_,D){if(!_.enabled)return;this._onWillRun.fire({action:_});let C;try{await this.runAction(_,D)}catch(E){C=E}this._onDidRun.fire({action:_,error:C})}async runAction(_,D){await _.run(D)}}e.ActionRunner=T;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(..._){let D=[];for(const C of _)C.length&&(D.length?D=[...D,new k,...C]:D=C);return D}async run(){}}k.ID="vs.actions.separator",e.Separator=k;class y{get actions(){return this._actions}constructor(_,D,C,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=_,this.label=D,this.class=E,this._actions=C}async run(){}}e.SubmenuAction=y;class v extends A{constructor(){super(v.ID,l.localize(0,null),void 0,!1)}}v.ID="vs.actions.empty",e.EmptySubmenuAction=v;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=R}),define(Ce[21],De([1,0,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(k,y){const v=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(v)}}});var l;(function(k){function y(v){return v===k.None||v===k.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(l=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new a.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=l.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=l.None}}e.CancellationTokenSource=T}),define(Ce[164],De([1,0,21]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class P{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new a.CancellationTokenSource,y=this.task(k.token);return this.result={promise:y,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=P;class l{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const y=JSON.stringify(k);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=l;class A{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const y=this.fn(k);return this._map.set(k,y),y}}e.CachedFunction=A}),define(Ce[9],De([1,0,164,65]),function(re,e,a,P){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function k(z,...Q){return Q.length===0?z:z.replace(T,function(me,Re){const Oe=parseInt(Re,10);return isNaN(Oe)||Oe<0||Oe>=Q.length?me:Q[Oe]})}e.format=k;const y=/{([^}]+)}/g;function v(z,Q){return z.replace(y,(me,Re)=>Q[Re]??me)}e.format2=v;function R(z){return z.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=R;function I(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function _(z,Q){let me=0;const Re=Q.charCodeAt(0);for(let Oe=z.length-1;Oe>=0;Oe--)z.charCodeAt(Oe)===Re&&me++;return me}e.count=_;function D(z,Q,me="\u2026"){return z.length<=Q?z:`${z.substr(0,Q)}${me}`}e.truncate=D;function C(z,Q=" "){const me=E(z,Q);return n(me,Q)}e.trim=C;function E(z,Q){if(!z||!Q)return z;const me=Q.length;if(me===0||z.length===0)return z;let Re=0;for(;z.indexOf(Q,Re)===Re;)Re=Re+me;return z.substring(Re)}e.ltrim=E;function n(z,Q){if(!z||!Q)return z;const me=Q.length,Re=z.length;if(me===0||Re===0)return z;let Oe=Re,Ve=-1;for(;Ve=z.lastIndexOf(Q,Oe-1),!(Ve===-1||Ve+me!==Oe);){if(Ve===0)return"";Oe=Ve}return z.substring(0,Oe)}e.rtrim=n;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(z){return z.replace(/\*/g,"")}e.stripWildcards=h;function w(z,Q,me={}){if(!z)throw new Error("Cannot create regex from empty string");Q||(z=I(z)),me.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Re="";return me.global&&(Re+="g"),me.matchCase||(Re+="i"),me.multiline&&(Re+="m"),me.unicode&&(Re+="u"),new RegExp(z,Re)}e.createRegExp=w;function S(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function p(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=t;function o(z){return z.split(/\r\n|\r|\n/)}e.splitLines=o;function r(z){for(let Q=0,me=z.length;Q<me;Q++){const Re=z.charCodeAt(Q);if(Re!==32&&Re!==9)return Q}return-1}e.firstNonWhitespaceIndex=r;function c(z,Q=0,me=z.length){for(let Re=Q;Re<me;Re++){const Oe=z.charCodeAt(Re);if(Oe!==32&&Oe!==9)return z.substring(Q,Re)}return z.substring(Q,me)}e.getLeadingWhitespace=c;function m(z,Q=z.length-1){for(let me=Q;me>=0;me--){const Re=z.charCodeAt(me);if(Re!==32&&Re!==9)return me}return-1}e.lastNonWhitespaceIndex=m;function f(z,Q,me){const Re=[];let Oe=0;for(const Ve of z.matchAll(Q)){if(Re.push(z.slice(Oe,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Oe=Ve.index+Ve[0].length,Re.push(me(Ve[0],...Ve.slice(1),Ve.index,z,Ve.groups))}return Re.push(z.slice(Oe)),Promise.all(Re).then(Ve=>Ve.join(""))}e.replaceAsync=f;function i(z,Q){return z<Q?-1:z>Q?1:0}e.compare=i;function s(z,Q,me=0,Re=z.length,Oe=0,Ve=Q.length){for(;me<Re&&Oe<Ve;me++,Oe++){const rt=z.charCodeAt(me),ct=Q.charCodeAt(Oe);if(rt<ct)return-1;if(rt>ct)return 1}const Xe=Re-me,Ke=Ve-Oe;return Xe<Ke?-1:Xe>Ke?1:0}e.compareSubstring=s;function u(z,Q){return b(z,Q,0,z.length,0,Q.length)}e.compareIgnoreCase=u;function b(z,Q,me=0,Re=z.length,Oe=0,Ve=Q.length){for(;me<Re&&Oe<Ve;me++,Oe++){let rt=z.charCodeAt(me),ct=Q.charCodeAt(Oe);if(rt===ct)continue;if(rt>=128||ct>=128)return s(z.toLowerCase(),Q.toLowerCase(),me,Re,Oe,Ve);L(rt)&&(rt-=32),L(ct)&&(ct-=32);const bt=rt-ct;if(bt!==0)return bt}const Xe=Re-me,Ke=Ve-Oe;return Xe<Ke?-1:Xe>Ke?1:0}e.compareSubstringIgnoreCase=b;function g(z){return z>=48&&z<=57}e.isAsciiDigit=g;function L(z){return z>=97&&z<=122}e.isLowerAsciiLetter=L;function H(z){return z>=65&&z<=90}e.isUpperAsciiLetter=H;function q(z,Q){return z.length===Q.length&&b(z,Q)===0}e.equalsIgnoreCase=q;function X(z,Q){const me=Q.length;return Q.length>z.length?!1:b(z,Q,0,me)===0}e.startsWithIgnoreCase=X;function U(z,Q){const me=Math.min(z.length,Q.length);let Re;for(Re=0;Re<me;Re++)if(z.charCodeAt(Re)!==Q.charCodeAt(Re))return Re;return me}e.commonPrefixLength=U;function N(z,Q){const me=Math.min(z.length,Q.length);let Re;const Oe=z.length-1,Ve=Q.length-1;for(Re=0;Re<me;Re++)if(z.charCodeAt(Oe-Re)!==Q.charCodeAt(Ve-Re))return Re;return me}e.commonSuffixLength=N;function x(z){return 55296<=z&&z<=56319}e.isHighSurrogate=x;function F(z){return 56320<=z&&z<=57343}e.isLowSurrogate=F;function V(z,Q){return(z-55296<<10)+(Q-56320)+65536}e.computeCodePoint=V;function fe(z,Q,me){const Re=z.charCodeAt(me);if(x(Re)&&me+1<Q){const Oe=z.charCodeAt(me+1);if(F(Oe))return V(Re,Oe)}return Re}e.getNextCodePoint=fe;function se(z,Q){const me=z.charCodeAt(Q-1);if(F(me)&&Q>1){const Re=z.charCodeAt(Q-2);if(x(Re))return V(Re,me)}return me}class ${get offset(){return this._offset}constructor(Q,me=0){this._str=Q,this._len=Q.length,this._offset=me}setOffset(Q){this._offset=Q}prevCodePoint(){const Q=se(this._str,this._offset);return this._offset-=Q>=65536?2:1,Q}nextCodePoint(){const Q=fe(this._str,this._len,this._offset);return this._offset+=Q>=65536?2:1,Q}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class J{get offset(){return this._iterator.offset}constructor(Q,me=0){this._iterator=new $(Q,me)}nextGraphemeLength(){const Q=He.getInstance(),me=this._iterator,Re=me.offset;let Oe=Q.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ve=me.offset,Xe=Q.getGraphemeBreakType(me.nextCodePoint());if(ke(Oe,Xe)){me.setOffset(Ve);break}Oe=Xe}return me.offset-Re}prevGraphemeLength(){const Q=He.getInstance(),me=this._iterator,Re=me.offset;let Oe=Q.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ve=me.offset,Xe=Q.getGraphemeBreakType(me.prevCodePoint());if(ke(Xe,Oe)){me.setOffset(Ve);break}Oe=Xe}return Re-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=J;function te(z,Q){return new J(z,Q).nextGraphemeLength()}e.nextCharLength=te;function be(z,Q){return new J(z,Q).prevGraphemeLength()}e.prevCharLength=be;function le(z,Q){Q>0&&F(z.charCodeAt(Q))&&Q--;const me=Q+te(z,Q);return[me-be(z,me),me]}e.getCharContainingOffset=le;function ue(z){const Q=new J(z);let me=0;for(;!Q.eol();)me++,Q.nextGraphemeLength();return me}e.charCount=ue;let j;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(z){return j||(j=M()),j.test(z)}e.containsRTL=Y;const ge=/^[\t\n\r\x20-\x7E]*$/;function we(z){return ge.test(z)}e.isBasicASCII=we,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=ie;function ne(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ne;function de(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=de;function ee(z,Q){if(z.length<Q)return z;const me=/\b/g;let Re=0;for(;me.test(z)&&!(z.length-me.lastIndex<Q);)Re=me.lastIndex,me.lastIndex+=1;return z.substring(Re).replace(/^\s/,"")}e.lcut=ee;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ae(z){return z&&(z=z.replace(ce,"")),z}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=O;function B(z){return O(z)?z.substr(1):z}e.stripUTF8BOM=B;function K(z,Q){if(!z||!Q||z.length<Q.length)return!1;const me=Q.length,Re=z.toLowerCase();let Oe=0,Ve=-1;for(;Oe<me;){const Xe=Re.indexOf(Q[Oe],Ve+1);if(Xe<0)return!1;Ve=Xe,Oe++}return!0}e.fuzzyContains=K;function Z(z,Q=!1){return z?(Q&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=Z;function he(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=he;function _e(z,Q=1){if(Q===0)return"";let me=-1;do me=z.indexOf(`
`,me+1),Q--;while(Q>0&&me>=0);return me===-1?z:(z[me-1]==="\r"&&me--,z.substr(0,me))}e.getNLines=_e;function Ae(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=Ae;function Ee(z){return He.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Ee;function ke(z,Q){return z===0?Q!==5&&Q!==7:z===2&&Q===3?!1:z===4||z===2||z===3||Q===4||Q===2||Q===3?!0:!(z===8&&(Q===8||Q===9||Q===11||Q===12)||(z===11||z===9)&&(Q===9||Q===10)||(z===12||z===10)&&Q===10||Q===5||Q===13||Q===7||z===1||z===13&&Q===14||z===6&&Q===6)}var Ie;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const me=this._data,Re=me.length/3;let Oe=1;for(;Oe<=Re;)if(Q<me[3*Oe])Oe=2*Oe;else if(Q>me[3*Oe+1])Oe=2*Oe+1;else return me[3*Oe+2];return 0}}He._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(z,Q){if(z===0)return 0;const me=Qe(z,Q);if(me!==void 0)return me;const Re=new $(Q,z);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=tt;function Qe(z,Q){const me=new $(Q,z);let Re=me.prevCodePoint();for(;nt(Re)||Re===65039||Re===8419;){if(me.offset===0)return;Re=me.prevCodePoint()}if(!de(Re))return;let Oe=me.offset;return Oe>0&&me.prevCodePoint()===8205&&(Oe=me.offset),Oe}function nt(z){return 127995<=z&&z<=127999}var st;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(Q){return Ue.cache.get(Array.from(Q))}static getLocales(){return Ue._locales.value}constructor(Q){this.confusableDictionary=Q}isAmbiguous(Q){return this.confusableDictionary.has(Q)}getPrimaryConfusable(Q){return this.confusableDictionary.get(Q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}l=Ue,Ue.ambiguousCharacterData=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new a.LRUCachedFunction(z=>{function Q(ct){const bt=new Map;for(let mt=0;mt<ct.length;mt+=2)bt.set(ct[mt],ct[mt+1]);return bt}function me(ct,bt){const mt=new Map(ct);for(const[Et,Dt]of bt)mt.set(Et,Dt);return mt}function Re(ct,bt){if(!ct)return bt;const mt=new Map;for(const[Et,Dt]of ct)bt.has(Et)&&mt.set(Et,Dt);return mt}const Oe=l.ambiguousCharacterData.value;let Ve=z.filter(ct=>!ct.startsWith("_")&&ct in Oe);Ve.length===0&&(Ve=["_default"]);let Xe;for(const ct of Ve){const bt=Q(Oe[ct]);Xe=Re(Xe,bt)}const Ke=Q(Oe._common),rt=me(Ke,Xe);return new Ue(rt)}),Ue._locales=new P.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(z=>!z.startsWith("_"))),e.AmbiguousCharacters=Ue;class it{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(it.getRawData())),this._data}static isInvisibleCharacter(Q){return it.getData().has(Q)}static get codePoints(){return it.getData()}}it._data=void 0,e.InvisibleCharacters=it}),define(Ce[34],De([1,0,15,14,9,10]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(f){return f===47||f===92}e.isPathSeparator=T;function k(f){return f.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=k;function y(f){return f.indexOf("/")===-1&&(f=k(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=y;function v(f,i=a.posix.sep){if(!f)return"";const s=f.length,u=f.charCodeAt(0);if(T(u)){if(T(f.charCodeAt(1))&&!T(f.charCodeAt(2))){let g=3;const L=g;for(;g<s&&!T(f.charCodeAt(g));g++);if(L!==g&&!T(f.charCodeAt(g+1))){for(g+=1;g<s;g++)if(T(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,i)}}return i}else if(d(u)&&f.charCodeAt(1)===58)return T(f.charCodeAt(2))?f.slice(0,2)+i:f.slice(0,2);let b=f.indexOf("://");if(b!==-1){for(b+=3;b<s;b++)if(T(f.charCodeAt(b)))return f.slice(0,b+1)}return""}e.getRoot=v;function R(f){if(!P.isWindows||!f||f.length<5)return!1;let i=f.charCodeAt(0);if(i!==92||(i=f.charCodeAt(1),i!==92))return!1;let s=2;const u=s;for(;s<f.length&&(i=f.charCodeAt(s),i!==92);s++);return!(u===s||(i=f.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=R;const I=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(f,i=P.isWindows){const s=i?I:_;return!(!f||f.length===0||/^\s+$/.test(f)||(s.lastIndex=0,s.test(f))||i&&D.test(f)||f==="."||f===".."||i&&f[f.length-1]==="."||i&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=C;function E(f,i,s){const u=f===i;return!s||u?u:!f||!i?!1:(0,l.equalsIgnoreCase)(f,i)}e.isEqual=E;function n(f,i,s,u=a.sep){if(f===i)return!0;if(!f||!i||i.length>f.length)return!1;if(s){if(!(0,l.startsWithIgnoreCase)(f,i))return!1;if(i.length===f.length)return!0;let g=i.length;return i.charAt(i.length-1)===u&&g--,f.charAt(g)===u}return i.charAt(i.length-1)!==u&&(i+=u),f.indexOf(i)===0}e.isEqualOrParent=n;function d(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=d;function h(f,i){return P.isWindows&&f.endsWith(":")&&(f+=a.sep),(0,a.isAbsolute)(f)||(f=(0,a.join)(i,f)),f=(0,a.normalize)(f),P.isWindows?(f=(0,l.rtrim)(f,a.sep),f.endsWith(":")&&(f+=a.sep)):(f=(0,l.rtrim)(f,a.sep),f||(f=a.sep)),f}e.sanitizeFilePath=h;function w(f){const i=(0,a.normalize)(f);return P.isWindows?f.length>3?!1:S(i)&&(f.length===2||i.charCodeAt(2)===92):i===a.posix.sep}e.isRootOrDriveLetter=w;function S(f,i=P.isWindows){return i?d(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function p(f){return S(f)?f[0]:void 0}e.getDriveLetter=p;function t(f,i,s){return i.length>f.length?-1:f===i?0:(s&&(f=f.toLowerCase(),i=i.toLowerCase()),f.indexOf(i))}e.indexOfPath=t;function o(f){const i=f.split(":");let s,u,b;for(const g of i){const L=Number(g);(0,A.isNumber)(L)?u===void 0?u=L:b===void 0&&(b=L):s=s?[s,g].join(":"):g}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:b!==void 0?b:u!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,i,s=8){let u="";for(let g=0;g<s;g++){let L;g===0&&P.isWindows&&!i&&(s===3||s===4)?L=c:L=r,u+=L.charAt(Math.floor(Math.random()*L.length))}let b;return i?b=`${i}-${u}`:b=u,f?(0,a.join)(f,b):b}e.randomPath=m}),define(Ce[111],De([1,0,28,9]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...ae){return function(O,B){for(let K=0,Z=ae.length;K<Z;K++){const he=ae[K](O,B);if(he)return he}return null}}e.or=l,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ae,O,B){if(!B||B.length<O.length)return null;let K;return ae?K=P.startsWithIgnoreCase(B,O):K=B.indexOf(O)===0,K?O.length>0?[{start:0,end:O.length}]:[]:null}function T(ae,O){const B=O.toLowerCase().indexOf(ae.toLowerCase());return B===-1?null:[{start:B,end:B+ae.length}]}e.matchesContiguousSubString=T;function k(ae,O){return y(ae.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=k;function y(ae,O,B,K){if(B===ae.length)return[];if(K===O.length)return null;if(ae[B]===O[K]){let Z=null;return(Z=y(ae,O,B+1,K+1))?d({start:K,end:K+1},Z):null}return y(ae,O,B,K+1)}function v(ae){return 97<=ae&&ae<=122}function R(ae){return 65<=ae&&ae<=90}e.isUpper=R;function I(ae){return 48<=ae&&ae<=57}function _(ae){return ae===32||ae===9||ae===10||ae===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ae=>D.add(ae.charCodeAt(0)));function C(ae){return _(ae)||D.has(ae)}function E(ae,O){return ae===O||C(ae)&&C(O)}function n(ae){return v(ae)||R(ae)||I(ae)}function d(ae,O){return O.length===0?O=[ae]:ae.end===O[0].start?O[0].start=ae.start:O.unshift(ae),O}function h(ae,O){for(let B=O;B<ae.length;B++){const K=ae.charCodeAt(B);if(R(K)||I(K)||B>0&&!n(ae.charCodeAt(B-1)))return B}return ae.length}function w(ae,O,B,K){if(B===ae.length)return[];if(K===O.length)return null;if(ae[B]!==O[K].toLowerCase())return null;{let Z=null,he=K+1;for(Z=w(ae,O,B+1,K+1);!Z&&(he=h(O,he))<O.length;)Z=w(ae,O,B+1,he),he++;return Z===null?null:d({start:K,end:K+1},Z)}}function S(ae){let O=0,B=0,K=0,Z=0,he=0;for(let Ie=0;Ie<ae.length;Ie++)he=ae.charCodeAt(Ie),R(he)&&O++,v(he)&&B++,n(he)&&K++,I(he)&&Z++;const _e=O/ae.length,Ae=B/ae.length,Ee=K/ae.length,ke=Z/ae.length;return{upperPercent:_e,lowerPercent:Ae,alphaPercent:Ee,numericPercent:ke}}function p(ae){const{upperPercent:O,lowerPercent:B}=ae;return B===0&&O>.6}function t(ae){const{upperPercent:O,lowerPercent:B,alphaPercent:K,numericPercent:Z}=ae;return B>.2&&O<.8&&K>.6&&Z<.2}function o(ae){let O=0,B=0,K=0,Z=0;for(let he=0;he<ae.length;he++)K=ae.charCodeAt(he),R(K)&&O++,v(K)&&B++,_(K)&&Z++;return(O===0||B===0)&&Z===0?ae.length<=30:O<=5}function r(ae,O){if(!O||(O=O.trim(),O.length===0)||!o(ae)||O.length>60)return null;const B=S(O);if(!t(B)){if(!p(B))return null;O=O.toLowerCase()}let K=null,Z=0;for(ae=ae.toLowerCase();Z<O.length&&(K=w(ae,O,0,Z))===null;)Z=h(O,Z+1);return K}e.matchesCamelCase=r;function c(ae,O,B=!1){if(!O||O.length===0)return null;let K=null,Z=0;for(ae=ae.toLowerCase(),O=O.toLowerCase();Z<O.length&&(K=m(ae,O,0,Z,B))===null;)Z=f(O,Z+1);return K}e.matchesWords=c;function m(ae,O,B,K,Z){if(B===ae.length)return[];if(K===O.length)return null;if(E(ae.charCodeAt(B),O.charCodeAt(K))){let he=null,_e=K+1;if(he=m(ae,O,B+1,K+1,Z),!Z)for(;!he&&(_e=f(O,_e))<O.length;)he=m(ae,O,B+1,_e,Z),_e++;return he?ae.charCodeAt(B)!==O.charCodeAt(K)?he:d({start:K,end:K+1},he):null}else return null}function f(ae,O){for(let B=O;B<ae.length;B++)if(C(ae.charCodeAt(B))||B>0&&C(ae.charCodeAt(B-1)))return B;return ae.length}const i=l(e.matchesPrefix,r,T),s=l(e.matchesPrefix,r,k),u=new a.LRUCache(1e4);function b(ae,O,B=!1){if(typeof ae!="string"||typeof O!="string")return null;let K=u.get(ae);K||(K=new RegExp(P.convertSimple2RegExpPattern(ae),"i"),u.set(ae,K));const Z=K.exec(O);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:B?s(ae,O):i(ae,O)}e.matchesFuzzy=b;function g(ae,O){const B=ge(ae,ae.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?H(B):null}e.matchesFuzzy2=g;function L(ae,O,B,K,Z,he){const _e=Math.min(13,ae.length);for(;B<_e;B++){const Ae=ge(ae,O,B,K,Z,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=L;function H(ae){if(typeof ae>"u")return[];const O=[],B=ae[1];for(let K=ae.length-1;K>1;K--){const Z=ae[K]+B,he=O[O.length-1];he&&he.end===Z?he.end=Z+1:O.push({start:Z,end:Z+1})}return O}e.createMatches=H;const q=128;function X(){const ae=[],O=[];for(let B=0;B<=q;B++)O[B]=0;for(let B=0;B<=q;B++)ae.push(O.slice(0));return ae}function U(ae){const O=[];for(let B=0;B<=ae;B++)O[B]=0;return O}const N=U(2*q),x=U(2*q),F=X(),V=X(),fe=X(),se=!1;function $(ae,O,B,K,Z){function he(Ae,Ee,ke=" "){for(;Ae.length<Ee;)Ae=ke+Ae;return Ae}let _e=` |   |${K.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=B;Ae++)Ae===0?_e+=" |":_e+=`${O[Ae-1]}|`,_e+=ae[Ae].slice(0,Z+1).map(Ee=>he(Ee.toString(),3)).join("|")+`
`;return _e}function J(ae,O,B,K){ae=ae.substr(O),B=B.substr(K),console.log($(V,ae,ae.length,B,B.length)),console.log($(fe,ae,ae.length,B,B.length)),console.log($(F,ae,ae.length,B,B.length))}function te(ae,O){if(O<0||O>=ae.length)return!1;const B=ae.codePointAt(O);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(B)}}function be(ae,O){if(O<0||O>=ae.length)return!1;switch(ae.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function le(ae,O,B){return O[ae]!==B[ae]}function ue(ae,O,B,K,Z,he,_e=!1){for(;O<B&&Z<he;)ae[O]===K[Z]&&(_e&&(N[O]=Z),O+=1),Z+=1;return O===B}e.isPatternInWord=ue;var j;(function(ae){ae[ae.Diag=1]="Diag",ae[ae.Left=2]="Left",ae[ae.LeftLeft=3]="LeftLeft"})(j||(j={}));var M;(function(ae){ae.Default=[-100,0];function O(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ae.isDefault=O})(M=e.FuzzyScore||(e.FuzzyScore={}));class Y{constructor(O,B){this.firstMatchCanBeWeak=O,this.boostFullMatch=B}}Y.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Y;function ge(ae,O,B,K,Z,he,_e=Y.default){const Ae=ae.length>q?q:ae.length,Ee=K.length>q?q:K.length;if(B>=Ae||he>=Ee||Ae-B>Ee-he||!ue(O,B,Ae,Z,he,Ee,!0))return;we(Ae,Ee,B,he,O,Z);let ke=1,Ie=1,He=B,ze=he;const tt=[!1];for(ke=1,He=B;He<Ae;ke++,He++){const it=N[He],z=x[He],Q=He+1<Ae?x[He+1]:Ee;for(Ie=it-he+1,ze=it;ze<Q;Ie++,ze++){let me=Number.MIN_SAFE_INTEGER,Re=!1;ze<=z&&(me=ie(ae,O,He,B,K,Z,ze,Ee,he,F[ke-1][Ie-1]===0,tt));let Oe=0;me!==Number.MAX_SAFE_INTEGER&&(Re=!0,Oe=me+V[ke-1][Ie-1]);const Ve=ze>it,Xe=Ve?V[ke][Ie-1]+(F[ke][Ie-1]>0?-5:0):0,Ke=ze>it+1&&F[ke][Ie-1]>0,rt=Ke?V[ke][Ie-2]+(F[ke][Ie-2]>0?-5:0):0;if(Ke&&(!Ve||rt>=Xe)&&(!Re||rt>=Oe))V[ke][Ie]=rt,fe[ke][Ie]=3,F[ke][Ie]=0;else if(Ve&&(!Re||Xe>=Oe))V[ke][Ie]=Xe,fe[ke][Ie]=2,F[ke][Ie]=0;else if(Re)V[ke][Ie]=Oe,fe[ke][Ie]=1,F[ke][Ie]=F[ke-1][Ie-1]+1;else throw new Error("not possible")}}if(se&&J(ae,B,K,he),!tt[0]&&!_e.firstMatchCanBeWeak)return;ke--,Ie--;const Qe=[V[ke][Ie],he];let nt=0,st=0;for(;ke>=1;){let it=Ie;do{const z=fe[ke][it];if(z===3)it=it-2;else if(z===2)it=it-1;else break}while(it>=1);nt>1&&O[B+ke-1]===Z[he+Ie-1]&&!le(it+he-1,K,Z)&&nt+1>F[ke][it]&&(it=Ie),it===Ie?nt++:nt=1,st||(st=it),ke--,Ie=it-1,Qe.push(Ie)}Ee===Ae&&_e.boostFullMatch&&(Qe[0]+=2);const Ue=st-Ae;return Qe[0]-=Ue,Qe}e.fuzzyScore=ge;function we(ae,O,B,K,Z,he){let _e=ae-1,Ae=O-1;for(;_e>=B&&Ae>=K;)Z[_e]===he[Ae]&&(x[_e]=Ae,_e--),Ae--}function ie(ae,O,B,K,Z,he,_e,Ae,Ee,ke,Ie){if(O[B]!==he[_e])return Number.MIN_SAFE_INTEGER;let He=1,ze=!1;return _e===B-K?He=ae[B]===Z[_e]?7:5:le(_e,Z,he)&&(_e===0||!le(_e-1,Z,he))?(He=ae[B]===Z[_e]?7:5,ze=!0):te(he,_e)&&(_e===0||!te(he,_e-1))?He=5:(te(he,_e-1)||be(he,_e-1))&&(He=5,ze=!0),He>1&&B===K&&(Ie[0]=!0),ze||(ze=le(_e,Z,he)||te(he,_e-1)||be(he,_e-1)),B===K?_e>Ee&&(He-=ze?3:5):ke?He+=ze?2:0:He+=ze?0:1,_e+1===Ae&&(He-=ze?3:5),He}function ne(ae,O,B,K,Z,he,_e){return ee(ae,O,B,K,Z,he,!0,_e)}e.fuzzyScoreGracefulAggressive=ne;function de(ae,O,B,K,Z,he,_e){return ee(ae,O,B,K,Z,he,!1,_e)}e.fuzzyScoreGraceful=de;function ee(ae,O,B,K,Z,he,_e,Ae){let Ee=ge(ae,O,B,K,Z,he,Ae);if(Ee&&!_e)return Ee;if(ae.length>=3){const ke=Math.min(7,ae.length-1);for(let Ie=B+1;Ie<ke;Ie++){const He=ce(ae,Ie);if(He){const ze=ge(He,He.toLowerCase(),B,K,Z,he,Ae);ze&&(ze[0]-=3,(!Ee||ze[0]>Ee[0])&&(Ee=ze))}}}return Ee}function ce(ae,O){if(O+1>=ae.length)return;const B=ae[O],K=ae[O+1];if(B!==K)return ae.slice(0,O)+K+B+ae.slice(O+2)}}),define(Ce[68],De([1,0,9]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function P(d){return l(d,0)}e.hash=P;function l(d,h){switch(typeof d){case"object":return d===null?A(349,h):Array.isArray(d)?y(d,h):v(d,h);case"string":return k(d,h);case"boolean":return T(d,h);case"number":return A(d,h);case"undefined":return A(937,h);default:return A(617,h)}}e.doHash=l;function A(d,h){return(h<<5)-h+d|0}e.numberHash=A;function T(d,h){return A(d?433:863,h)}function k(d,h){h=A(149417,h);for(let w=0,S=d.length;w<S;w++)h=A(d.charCodeAt(w),h);return h}e.stringHash=k;function y(d,h){return h=A(104579,h),d.reduce((w,S)=>l(S,w),h)}function v(d,h){return h=A(181387,h),Object.keys(d).sort().reduce((w,S)=>(w=k(S,w),l(d[S],w)),h)}class R{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=l(h,this._value),this._value}}e.Hasher=R;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function _(d,h,w=32){const S=w-h,p=~((1<<S)-1);return(d<<h|(p&d)>>>S)>>>0}function D(d,h=0,w=d.byteLength,S=0){for(let p=0;p<w;p++)d[h+p]=S}function C(d,h,w="0"){for(;d.length<h;)d=w+d;return d}function E(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),h/4)}e.toHexString=E;class n{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const w=h.length;if(w===0)return;const S=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,o,r;for(t!==0?(o=t,r=-1,t=0):(o=h.charCodeAt(0),r=0);;){let c=o;if(a.isHighSurrogate(o))if(r+1<w){const m=h.charCodeAt(r+1);a.isLowSurrogate(m)?(r++,c=a.computeCodePoint(o,m)):c=65533}else{t=o;break}else a.isLowSurrogate(o)&&(c=65533);if(p=this._push(S,p,c),r++,r<w)o=h.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(h,w,S){return S<128?h[w++]=S:S<2048?(h[w++]=192|(S&1984)>>>6,h[w++]=128|(S&63)>>>0):S<65536?(h[w++]=224|(S&61440)>>>12,h[w++]=128|(S&4032)>>>6,h[w++]=128|(S&63)>>>0):(h[w++]=240|(S&1835008)>>>18,h[w++]=128|(S&258048)>>>12,h[w++]=128|(S&4032)>>>6,h[w++]=128|(S&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,D(this._buff,this._buffLen),this._buffLen>56&&(this._step(),D(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=n._bigBlock32,w=this._buffDV;for(let i=0;i<64;i+=4)h.setUint32(i,w.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)h.setUint32(i,_(h.getUint32(i-12,!1)^h.getUint32(i-32,!1)^h.getUint32(i-56,!1)^h.getUint32(i-64,!1),1),!1);let S=this._h0,p=this._h1,t=this._h2,o=this._h3,r=this._h4,c,m,f;for(let i=0;i<80;i++)i<20?(c=p&t|~p&o,m=1518500249):i<40?(c=p^t^o,m=1859775393):i<60?(c=p&t|p&o|t&o,m=2400959708):(c=p^t^o,m=3395469782),f=_(S,5)+c+r+m+h.getUint32(i*4,!1)&4294967295,r=o,o=t,t=_(p,30),p=S,S=f;this._h0=this._h0+S&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+r&4294967295}}n._bigBlock32=new DataView(new ArrayBuffer(320)),e.StringSHA1=n}),define(Ce[112],De([1,0,109,111,68,15,14,9]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,v=[y,[]];function R(F,V,fe,se){if(!F||!V)return v;const $=F.length,J=V.length;if($<J)return v;const te=F.toLowerCase();return I(V,fe,J,F,te,$,se)}e.scoreFuzzy=R;function I(F,V,fe,se,$,J,te){const be=[],le=[];for(let Y=0;Y<fe;Y++){const ge=Y*J,we=ge-J,ie=Y>0,ne=F[Y],de=V[Y];for(let ee=0;ee<J;ee++){const ce=ee>0,ae=ge+ee,O=ae-1,B=we+ee-1,K=ce?be[O]:0,Z=ie&&ce?be[B]:0,he=ie&&ce?le[B]:0;let _e;!Z&&ie?_e=0:_e=_(ne,de,se,$,ee,he),_e&&Z+_e>=K&&(te||ie||$.startsWith(V,ee))?(le[ae]=he+1,be[ae]=Z+_e):(le[ae]=y,be[ae]=K)}}const ue=[];let j=fe-1,M=J-1;for(;j>=0&&M>=0;){const Y=j*J+M;le[Y]===y||(ue.push(M),j--),M--}return[be[fe*J-1],ue.reverse()]}function _(F,V,fe,se,$,J){let te=0;if(!D(V,se[$]))return te;if(te+=1,J>0&&(te+=J*5),F===fe[$]&&(te+=1),$===0)te+=8;else{const be=C(fe.charCodeAt($-1));be?te+=be:(0,P.isUpper)(fe.charCodeAt($))&&J===0&&(te+=2)}return te}function D(F,V){return F===V?!0:F==="/"||F==="\\"?V==="/"||V==="\\":!1}function C(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function n(F,V,fe=0,se=0){const $=V;return $.values&&$.values.length>1?d(F,$.values,fe,se):h(F,V,fe,se)}e.scoreFuzzy2=n;function d(F,V,fe,se){let $=0;const J=[];for(const te of V){const[be,le]=h(F,te,fe,se);if(typeof be!="number")return E;$+=be,J.push(...le)}return[$,s(J)]}function h(F,V,fe,se){const $=(0,P.fuzzyScore)(V.original,V.originalLowercase,fe,F,F.toLowerCase(),se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?[$[0],(0,P.createMatches)($)]:E}const w=Object.freeze({score:0}),S=1<<18,p=1<<17,t=1<<16;function o(F,V,fe,se){const $=se.values?se.values:[se];return(0,l.hash)({[se.normalized]:{values:$.map(te=>({value:te.normalized,expectContiguousMatch:te.expectContiguousMatch})),label:F,description:V,allowNonContiguousMatches:fe}})}function r(F,V,fe,se,$){if(!F||!V.normalized)return w;const J=se.getItemLabel(F);if(!J)return w;const te=se.getItemDescription(F),be=o(J,te,fe,V),le=$[be];if(le)return le;const ue=c(J,te,se.getItemPath(F),V,fe);return $[be]=ue,ue}e.scoreItemFuzzy=r;function c(F,V,fe,se,$){const J=!fe||!se.containsPathSeparator;return fe&&(T.isLinux?se.pathNormalized===fe:(0,k.equalsIgnoreCase)(se.pathNormalized,fe))?{score:S,labelMatch:[{start:0,end:F.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:se.values&&se.values.length>1?m(F,V,fe,se.values,J,$):f(F,V,fe,se,J,$)}function m(F,V,fe,se,$,J){let te=0;const be=[],le=[];for(const ue of se){const{score:j,labelMatch:M,descriptionMatch:Y}=f(F,V,fe,ue,$,J);if(j===y)return w;te+=j,M&&be.push(...M),Y&&le.push(...Y)}return{score:te,labelMatch:s(be),descriptionMatch:s(le)}}function f(F,V,fe,se,$,J){if($||!V){const[te,be]=R(F,se.normalized,se.normalizedLowercase,J&&!se.expectContiguousMatch);if(te){const le=(0,P.matchesPrefix)(se.normalized,F);let ue;return le?(ue=p,ue+=Math.round(se.normalized.length/F.length*100)):ue=t,{score:ue+te,labelMatch:le||i(be)}}}if(V){let te=V;fe&&(te=`${V}${A.sep}`);const be=te.length,le=`${te}${F}`,[ue,j]=R(le,se.normalized,se.normalizedLowercase,J&&!se.expectContiguousMatch);if(ue){const M=i(j),Y=[],ge=[];return M.forEach(we=>{we.start<be&&we.end>be?(Y.push({start:0,end:we.end-be}),ge.push({start:we.start,end:be})):we.start>=be?Y.push({start:we.start-be,end:we.end-be}):ge.push(we)}),{score:ue,labelMatch:Y,descriptionMatch:ge}}}return w}function i(F){const V=[];if(!F)return V;let fe;for(const se of F)fe&&fe.end===se?fe.end+=1:(fe={start:se,end:se+1},V.push(fe));return V}function s(F){const V=F.sort(($,J)=>$.start-J.start),fe=[];let se;for(const $ of V)!se||!u(se,$)?(se=$,fe.push($)):(se.start=Math.min(se.start,$.start),se.end=Math.max(se.end,$.end));return fe}function u(F,V){return!(F.end<V.start||V.end<F.start)}function b(F,V,fe,se,$,J){const te=r(F,fe,se,$,J),be=r(V,fe,se,$,J),le=te.score,ue=be.score;if((le===S||ue===S)&&le!==ue)return le===S?-1:1;if(le>t||ue>t){if(le!==ue)return le>ue?-1:1;if(le<p&&ue<p){const ne=L(te.labelMatch,be.labelMatch);if(ne!==0)return ne}const we=$.getItemLabel(F)||"",ie=$.getItemLabel(V)||"";if(we.length!==ie.length)return we.length-ie.length}if(le!==ue)return le>ue?-1:1;const j=Array.isArray(te.labelMatch)&&te.labelMatch.length>0,M=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(j&&!M)return-1;if(M&&!j)return 1;const Y=g(F,te,$),ge=g(V,be,$);return Y&&ge&&Y!==ge?ge>Y?-1:1:H(F,V,fe,$)}e.compareItemsByFuzzyScore=b;function g(F,V,fe){let se=-1,$=-1;if(V.descriptionMatch&&V.descriptionMatch.length?se=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(se=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if($=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const J=fe.getItemDescription(F);J&&($+=J.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&($=V.descriptionMatch[V.descriptionMatch.length-1].end);return $-se}function L(F,V){if(!F&&!V||(!F||!F.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!F||!F.length)return 1;const fe=F[0].start,$=F[F.length-1].end-fe,J=V[0].start,be=V[V.length-1].end-J;return $===be?0:be<$?1:-1}function H(F,V,fe,se){const $=se.getItemLabel(F)||"",J=se.getItemLabel(V)||"",te=se.getItemDescription(F),be=se.getItemDescription(V),le=$.length+(te?te.length:0),ue=J.length+(be?be.length:0);if(le!==ue)return le-ue;const j=se.getItemPath(F),M=se.getItemPath(V);return j&&M&&j.length!==M.length?j.length-M.length:$!==J?(0,a.compareAnything)($,J,fe.normalized):te&&be&&te!==be?(0,a.compareAnything)(te,be,fe.normalized):j&&M&&j!==M?(0,a.compareAnything)(j,M,fe.normalized):0}function q(F){return F.startsWith('"')&&F.endsWith('"')}const X=" ";function U(F){typeof F!="string"&&(F="");const V=F.toLowerCase(),{pathNormalized:fe,normalized:se,normalizedLowercase:$}=N(F),J=fe.indexOf(A.sep)>=0,te=q(F);let be;const le=F.split(X);if(le.length>1)for(const ue of le){const j=q(ue),{pathNormalized:M,normalized:Y,normalizedLowercase:ge}=N(ue);Y&&(be||(be=[]),be.push({original:ue,originalLowercase:ue.toLowerCase(),pathNormalized:M,normalized:Y,normalizedLowercase:ge,expectContiguousMatch:j}))}return{original:F,originalLowercase:V,pathNormalized:fe,normalized:se,normalizedLowercase:$,values:be,containsPathSeparator:J,expectContiguousMatch:te}}e.prepareQuery=U;function N(F){let V;T.isWindows?V=F.replace(/\//g,A.sep):V=F.replace(/\\/g,A.sep);const fe=(0,k.stripWildcards)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function x(F){return Array.isArray(F)?U(F.map(V=>V.original).join(X)):U(F.original)}e.pieceToQuery=x}),define(Ce[165],De([1,0,111,9,52]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",T=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${T.source}`,"g");function y(d){return d.replace(k,(h,w)=>w?h:`\\${h}`)}e.escapeIcons=y;const v=new RegExp(`\\\\${T.source}`,"g");function R(d){return d.replace(v,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=R;const I=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function _(d){return d.indexOf(A)===-1?d:d.replace(I,(h,w,S,p)=>S?h:w||p||"")}e.stripIcons=_;function D(d){return d?d.replace(/\$\((.*?)\)/g,(h,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=D;const C=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(d){C.lastIndex=0;let h="";const w=[];let S=0;for(;;){const p=C.lastIndex,t=C.exec(d),o=d.substring(p,t?.index);if(o.length>0){h+=o;for(let r=0;r<o.length;r++)w.push(S)}if(!t)break;S+=t[0].length}return{text:h,iconOffsets:w}}e.parseLabelWithIcons=E;function n(d,h,w=!1){const{text:S,iconOffsets:p}=h;if(!p||p.length===0)return(0,a.matchesFuzzy)(d,S,w);const t=(0,P.ltrim)(S," "),o=S.length-t.length,r=(0,a.matchesFuzzy)(d,t,w);if(r)for(const c of r){const m=p[c.start+o]+o;c.start+=m,c.end+=m}return r}e.matchesFuzzyIconAware=n}),define(Ce[38],De([1,0,9]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(P||(P={})),function(l){const A="error",T="warning",k="warn",y="info",v="ignore";function R(_){return _?a.equalsIgnoreCase(A,_)?l.Error:a.equalsIgnoreCase(T,_)||a.equalsIgnoreCase(k,_)?l.Warning:a.equalsIgnoreCase(y,_)?l.Info:l.Ignore:l.Ignore}l.fromValue=R;function I(_){switch(_){case l.Error:return A;case l.Warning:return T;case l.Info:return y;default:return v}}l.toString=I}(P||(P={})),e.default=P}),define(Ce[69],De([1,0,18,9]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this._value="",this._pos=0}reset(D){return this._value=D,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(D){const C=D.charCodeAt(0),E=this._value.charCodeAt(this._pos);return C-E}value(){return this._value[this._pos]}}e.StringIterator=l;class A{constructor(D=!0){this._caseSensitive=D}reset(D){return this._value=D,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let D=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(D)this._from++;else break;else D=!1;return this}cmp(D){return this._caseSensitive?(0,P.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(D=!0,C=!0){this._splitOnBackslash=D,this._caseSensitive=C}reset(D){this._from=0,this._to=0,this._value=D,this._valueLen=D.length;for(let C=D.length-1;C>=0;C--,this._valueLen--){const E=this._value.charCodeAt(C);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let D=!0;for(;this._to<this._valueLen;this._to++){const C=this._value.charCodeAt(this._to);if(C===47||this._splitOnBackslash&&C===92)if(D)this._from++;else break;else D=!1}return this}cmp(D){return this._caseSensitive?(0,P.compareSubstring)(D,this._value,0,D.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(D,this._value,0,D.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var k;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(k||(k={}));class y{constructor(D,C){this._ignorePathCasing=D,this._ignoreQueryAndFragment=C,this._states=[],this._stateIdx=0}reset(D){return this._value=D,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(D)),this._pathIterator.reset(D.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(D)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(D){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(D,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(D,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(D);if(this._states[this._stateIdx]===4)return(0,P.compare)(D,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(D,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(R||(R={}));class I{static forUris(D=()=>!1,C=()=>!1){return new I(new y(D,C))}static forPaths(D=!1){return new I(new T(void 0,!D))}static forStrings(){return new I(new l)}static forConfigKeys(){return new I(new A)}constructor(D){this._iter=D}clear(){this._root=void 0}fill(D,C){if(C){const E=C.slice(0);(0,a.shuffle)(E);for(const n of E)this.set(n,D)}else{const E=D.slice(0);(0,a.shuffle)(E);for(const n of E)this.set(n[0],n[1])}}set(D,C){const E=this._iter.reset(D);let n;this._root||(this._root=new v,this._root.segment=E.value());const d=[];for(n=this._root;;){const w=E.cmp(n.segment);if(w>0)n.left||(n.left=new v,n.left.segment=E.value()),d.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new v,n.right.segment=E.value()),d.push([1,n]),n=n.right;else if(E.hasNext())E.next(),n.mid||(n.mid=new v,n.mid.segment=E.value()),d.push([0,n]),n=n.mid;else break}const h=n.value;n.value=C,n.key=D;for(let w=d.length-1;w>=0;w--){const S=d[w][1];S.updateHeight();const p=S.balanceFactor();if(p<-1||p>1){const t=d[w][0],o=d[w+1][0];if(t===1&&o===1)d[w][1]=S.rotateLeft();else if(t===-1&&o===-1)d[w][1]=S.rotateRight();else if(t===1&&o===-1)S.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=S.rotateLeft();else if(t===-1&&o===1)S.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=S.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this._root=d[0][1]}}return h}get(D){return this._getNode(D)?.value}_getNode(D){const C=this._iter.reset(D);let E=this._root;for(;E;){const n=C.cmp(E.segment);if(n>0)E=E.left;else if(n<0)E=E.right;else if(C.hasNext())C.next(),E=E.mid;else break}return E}has(D){const C=this._getNode(D);return!(C?.value===void 0&&C?.mid===void 0)}delete(D){return this._delete(D,!1)}deleteSuperstr(D){return this._delete(D,!0)}_delete(D,C){const E=this._iter.reset(D),n=[];let d=this._root;for(;d;){const h=E.cmp(d.segment);if(h>0)n.push([-1,d]),d=d.left;else if(h<0)n.push([1,d]),d=d.right;else if(E.hasNext())E.next(),n.push([0,d]),d=d.mid;else break}if(!!d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this._min(d.right);if(h.key){const{key:w,value:S,segment:p}=h;this._delete(h.key,!1),d.key=w,d.value=S,d.segment=p}}else{const h=d.left??d.right;if(n.length>0){const[w,S]=n[n.length-1];switch(w){case-1:S.left=h;break;case 0:S.mid=h;break;case 1:S.right=h;break}}else this._root=h}for(let h=n.length-1;h>=0;h--){const w=n[h][1];w.updateHeight();const S=w.balanceFactor();if(S>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[h][1]=w.rotateLeft()):S<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[h][1]=w.rotateRight()),h>0)switch(n[h-1][0]){case-1:n[h-1][1].left=n[h][1];break;case 1:n[h-1][1].right=n[h][1];break;case 0:n[h-1][1].mid=n[h][1];break}else this._root=n[0][1]}}}_min(D){for(;D.left;)D=D.left;return D}findSubstr(D){const C=this._iter.reset(D);let E=this._root,n;for(;E;){const d=C.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(C.hasNext())C.next(),n=E.value||n,E=E.mid;else break}return E&&E.value||n}findSuperstr(D){return this._findSuperstrOrElement(D,!1)}_findSuperstrOrElement(D,C){const E=this._iter.reset(D);let n=this._root;for(;n;){const d=E.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(E.hasNext())E.next(),n=n.mid;else return n.mid?this._entries(n.mid):C?n.value:void 0}}hasElementOrSubtree(D){return this._findSuperstrOrElement(D,!0)!==void 0}forEach(D){for(const[C,E]of this)D(E,C)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(D){const C=[];return this._dfsEntries(D,C),C[Symbol.iterator]()}_dfsEntries(D,C){!D||(D.left&&this._dfsEntries(D.left,C),D.value&&C.push([D.key,D.value]),D.mid&&this._dfsEntries(D.mid,C),D.right&&this._dfsEntries(D.right,C))}_isBalanced(){const D=C=>{if(!C)return!0;const E=C.balanceFactor();return E<-1||E>1?!1:D(C.left)&&D(C.right)};return D(this._root)}}e.TernarySearchTree=I}),define(Ce[2],De([1,0,15,14]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function k(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,c){return!r&&!c?"file":r}function v(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const R="",I="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(c){return c instanceof D?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,m,f,i,s,u=!1){typeof c=="object"?(this.scheme=c.scheme||R,this.authority=c.authority||R,this.path=c.path||R,this.query=c.query||R,this.fragment=c.fragment||R):(this.scheme=y(c,u),this.authority=m||R,this.path=v(this.scheme,f||R),this.query=i||R,this.fragment=s||R,k(this,u))}get fsPath(){return w(this,!1)}with(c){if(!c)return this;let{scheme:m,authority:f,path:i,query:s,fragment:u}=c;return m===void 0?m=this.scheme:m===null&&(m=R),f===void 0?f=this.authority:f===null&&(f=R),i===void 0?i=this.path:i===null&&(i=R),s===void 0?s=this.query:s===null&&(s=R),u===void 0?u=this.fragment:u===null&&(u=R),m===this.scheme&&f===this.authority&&i===this.path&&s===this.query&&u===this.fragment?this:new E(m,f,i,s,u)}static parse(c,m=!1){const f=_.exec(c);return f?new E(f[2]||R,o(f[4]||R),o(f[5]||R),o(f[7]||R),o(f[9]||R),m):new E(R,R,R,R,R)}static file(c){let m=R;if(P.isWindows&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const f=c.indexOf(I,2);f===-1?(m=c.substring(2),c=I):(m=c.substring(2,f),c=c.substring(f)||I)}return new E("file",m,c,R,R)}static from(c){const m=new E(c.scheme,c.authority,c.path,c.query,c.fragment);return k(m,!0),m}static joinPath(c,...m){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return P.isWindows&&c.scheme==="file"?f=D.file(a.win32.join(w(c,!0),...m)).path:f=a.posix.join(c.path,...m),c.with({path:f})}toString(c=!1){return S(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof D)return c;{const m=new E(c);return m._formatted=c.external,m._fsPath=c._sep===C?c.fsPath:null,m}}else return c}}e.URI=D;const C=P.isWindows?1:void 0;class E extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(c=!1){return c?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=C),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,c,m){let f,i=-1;for(let s=0;s<r.length;s++){const u=r.charCodeAt(s);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||c&&u===47||m&&u===91||m&&u===93||m&&u===58)i!==-1&&(f+=encodeURIComponent(r.substring(i,s)),i=-1),f!==void 0&&(f+=r.charAt(s));else{f===void 0&&(f=r.substr(0,s));const b=n[u];b!==void 0?(i!==-1&&(f+=encodeURIComponent(r.substring(i,s)),i=-1),f+=b):i===-1&&(i=s)}}return i!==-1&&(f+=encodeURIComponent(r.substring(i))),f!==void 0?f:r}function h(r){let c;for(let m=0;m<r.length;m++){const f=r.charCodeAt(m);f===35||f===63?(c===void 0&&(c=r.substr(0,m)),c+=n[f]):c!==void 0&&(c+=r[m])}return c!==void 0?c:r}function w(r,c){let m;return r.authority&&r.path.length>1&&r.scheme==="file"?m=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?m=r.path.substr(1):m=r.path[1].toLowerCase()+r.path.substr(2):m=r.path,P.isWindows&&(m=m.replace(/\//g,"\\")),m}e.uriToFsPath=w;function S(r,c){const m=c?h:d;let f="",{scheme:i,authority:s,path:u,query:b,fragment:g}=r;if(i&&(f+=i,f+=":"),(s||i==="file")&&(f+=I,f+=I),s){let L=s.indexOf("@");if(L!==-1){const H=s.substr(0,L);s=s.substr(L+1),L=H.lastIndexOf(":"),L===-1?f+=m(H,!1,!1):(f+=m(H.substr(0,L),!1,!1),f+=":",f+=m(H.substr(L+1),!1,!0)),f+="@"}s=s.toLowerCase(),L=s.lastIndexOf(":"),L===-1?f+=m(s,!1,!0):(f+=m(s.substr(0,L),!1,!0),f+=s.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}f+=m(u,!0,!1)}return b&&(f+="?",f+=m(b,!1,!1)),g&&(f+="#",f+=c?g:d(g,!1,!1)),f}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(t)?r.replace(t,c=>p(c)):r}}),define(Ce[70],De([1,0,22,9,2]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(v){return JSON.stringify(v,k)}e.stringify=A;function T(v){let R=JSON.parse(v);return R=y(R),R}e.parse=T;function k(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function y(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return l.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof a.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let I=0;I<v.length;++I)v[I]=y(v[I],R+1);else for(const I in v)Object.hasOwnProperty.call(v,I)&&(v[I]=y(v[I],R+1))}return v}e.revive=y}),define(Ce[17],De([1,0,8,14,2]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${A.vscodeRemoteResource}`}set(R,I,_){this._hosts[R]=I,this._ports[R]=_}setConnectionToken(R,I){this._connectionTokens[R]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(n){return a.onUnexpectedError(n),R}const I=R.authority;let _=this._hosts[I];_&&_.indexOf(":")!==-1&&_.indexOf("[")===-1&&(_=`[${_}]`);const D=this._ports[I],C=this._connectionTokens[I];let E=`path=${encodeURIComponent(R.path)}`;return typeof C=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),l.URI.from({scheme:P.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${_}:${D}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(R){const I=this.toUri(R,re);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===A.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${A.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const I=this.toUri(R,re);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==k.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,I){return l.URI.isUri(R)?R:l.URI.parse(I.toUrl(R))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k;var y;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function _(C){let E;typeof C=="string"?E=new URL(C).searchParams:C instanceof URL?E=C.searchParams:l.URI.isUri(C)&&(E=new URL(C.toString(!0)).searchParams);const n=E?.get(I);if(!!n)return R.get(n)}v.getHeadersFromQuery=_;function D(C,E,n){if(!globalThis.crossOriginIsolated)return;const d=E&&n?"3":n?"2":"1";C instanceof URLSearchParams?C.set(I,d):C[I]=d}v.addSearchParam=D})(y=e.COI||(e.COI={}))}),define(Ce[24],De([1,0,34,17,15,14,9,2]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(D){return(0,k.uriToFsPath)(D,!0)}e.originalFSPath=y;class v{constructor(C){this._ignorePathCasing=C}compare(C,E,n=!1){return C===E?0:(0,T.compare)(this.getComparisonKey(C,n),this.getComparisonKey(E,n))}isEqual(C,E,n=!1){return C===E?!0:!C||!E?!1:this.getComparisonKey(C,n)===this.getComparisonKey(E,n)}getComparisonKey(C,E=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,E,n=!1){if(C.scheme===E.scheme){if(C.scheme===P.Schemas.file)return a.isEqualOrParent(y(C),y(E),this._ignorePathCasing(C))&&C.query===E.query&&(n||C.fragment===E.fragment);if((0,e.isEqualAuthority)(C.authority,E.authority))return a.isEqualOrParent(C.path,E.path,this._ignorePathCasing(C),"/")&&C.query===E.query&&(n||C.fragment===E.fragment)}return!1}joinPath(C,...E){return k.URI.joinPath(C,...E)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return l.posix.basename(C.path)}extname(C){return l.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let E;return C.scheme===P.Schemas.file?E=k.URI.file(l.dirname(y(C))).path:(E=l.posix.dirname(C.path),C.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),E="/")),C.with({path:E})}normalizePath(C){if(!C.path.length)return C;let E;return C.scheme===P.Schemas.file?E=k.URI.file(l.normalize(y(C))).path:E=l.posix.normalize(C.path),C.with({path:E})}relativePath(C,E){if(C.scheme!==E.scheme||!(0,e.isEqualAuthority)(C.authority,E.authority))return;if(C.scheme===P.Schemas.file){const h=l.relative(y(C),y(E));return A.isWindows?a.toSlashes(h):h}let n=C.path||"/";const d=E.path||"/";if(this._ignorePathCasing(C)){let h=0;for(const w=Math.min(n.length,d.length);h<w&&!(n.charCodeAt(h)!==d.charCodeAt(h)&&n.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);n=d.substr(0,h)+n.substr(h)}return l.posix.relative(n,d)}resolvePath(C,E){if(C.scheme===P.Schemas.file){const n=k.URI.file(l.resolve(y(C),E));return C.with({authority:n.authority,path:n.path})}return E=a.toPosixPath(E),C.with({path:l.posix.resolve(C.path,E)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,E){return C===E||C!==void 0&&E!==void 0&&(0,T.equalsIgnoreCase)(C,E)}hasTrailingPathSeparator(C,E=l.sep){if(C.scheme===P.Schemas.file){const n=y(C);return n.length>a.getRoot(n).length&&n[n.length-1]===E}else{const n=C.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,E=l.sep){return(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,E=l.sep){let n=!1;if(C.scheme===P.Schemas.file){const d=y(C);n=d!==void 0&&d.length===a.getRoot(d).length&&d[d.length-1]===E}else{E="/";const d=C.path;n=d.length===1&&d.charCodeAt(d.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path+"/"}):C}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(D=>D.scheme===P.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new v(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(D,C){const E=[];for(let n=0;n<D.length;n++){const d=C(D[n]);D.some((h,w)=>w===n?!1:(0,e.isEqualOrParent)(d,C(h)))||E.push(D[n])}return E}e.distinctParents=R;var I;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function C(E){const n=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(w=>{const[S,p]=w.split(":");S&&p&&n.set(S,p)});const h=E.path.substring(0,E.path.indexOf(";"));return h&&n.set(D.META_DATA_MIME,h),n}D.parseMetaData=C})(I=e.DataUri||(e.DataUri={}));function _(D,C,E){if(C){let n=D.path;return n&&n[0]!==l.posix.sep&&(n=l.posix.sep+n),D.with({scheme:E,authority:C,path:n})}return D.with({scheme:E})}e.toLocalResource=_}),define(Ce[19],De([1,0,21,8,3,6,24,14,149]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=v;function R(ue){const j=new a.CancellationTokenSource,M=ue(j.token),Y=new Promise((ge,we)=>{const ie=j.token.onCancellationRequested(()=>{ie.dispose(),j.dispose(),we(new P.CancellationError)});Promise.resolve(M).then(ne=>{ie.dispose(),j.dispose(),ge(ne)},ne=>{ie.dispose(),j.dispose(),we(ne)})});return new class{cancel(){j.cancel()}then(ge,we){return Y.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return Y.finally(ge)}}}e.createCancelablePromise=R;function I(ue,j,M){return new Promise((Y,ge)=>{const we=j.onCancellationRequested(()=>{we.dispose(),Y(M)});ue.then(Y,ge).finally(()=>we.dispose())})}e.raceCancellation=I;function _(ue,j){return new Promise((M,Y)=>{const ge=j.onCancellationRequested(()=>{ge.dispose(),Y(new P.CancellationError)});ue.then(M,Y).finally(()=>ge.dispose())})}e.raceCancellationError=_;async function D(ue){let j=-1;const M=ue.map((ge,we)=>ge.then(ie=>(j=we,ie))),Y=await Promise.race(M);return ue.forEach((ge,we)=>{we!==j&&ge.cancel()}),Y}e.raceCancellablePromises=D;function C(ue,j,M){let Y;const ge=setTimeout(()=>{Y?.(void 0),M?.()},j);return Promise.race([ue.finally(()=>clearTimeout(ge)),new Promise(we=>Y=we)])}e.raceTimeout=C;function E(ue){return new Promise((j,M)=>{const Y=ue();v(Y)?Y.then(j,M):j(Y)})}e.asPromise=E;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(M,M).then(Y)})}return new Promise((M,Y)=>{this.queuedPromise.then(M,Y)})}return this.activePromise=j(),new Promise((M,Y)=>{this.activePromise.then(ge=>{this.activePromise=null,M(ge)},ge=>{this.activePromise=null,Y(ge)})})}}e.Throttler=n;class d{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=d;class h{constructor(){this.promiseMap=new Map}queue(j,M){const ge=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(j)===ge&&this.promiseMap.delete(j)});return this.promiseMap.set(j,ge),ge}}e.SequencerByKey=h;const w=(ue,j)=>{let M=!0;const Y=setTimeout(()=>{M=!1,j()},ue);return{isTriggered:()=>M,dispose:()=>{clearTimeout(Y),M=!1}}},S=ue=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,ue())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class p{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,M=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,we)=>{this.doResolve=ge,this.doReject=we}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const Y=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===y.MicrotaskDelay?S(Y):w(M,Y),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new P.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(j){this.delayer=new p(j),this.throttler=new n}trigger(j,M){return this.delayer.trigger(()=>this.throttler.queue(j),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this._isOpen=!1,this._promise=new Promise((j,M)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class r extends o{constructor(j){super(),this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function c(ue,j){return j?new Promise((M,Y)=>{const ge=setTimeout(()=>{we.dispose(),M()},ue),we=j.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),Y(new P.CancellationError)})}):R(M=>c(ue,M))}e.timeout=c;function m(ue,j=0){const M=setTimeout(ue,j);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=m;function f(ue){const j=[];let M=0;const Y=ue.length;function ge(){return M<Y?ue[M++]():null}function we(ie){ie!=null&&j.push(ie);const ne=ge();return ne?ne.then(we):Promise.resolve(j)}return Promise.resolve(null).then(we)}e.sequence=f;function i(ue,j=Y=>!!Y,M=null){let Y=0;const ge=ue.length,we=()=>{if(Y>=ge)return Promise.resolve(M);const ie=ue[Y++];return Promise.resolve(ie()).then(de=>j(de)?Promise.resolve(de):we())};return we()}e.first=i;function s(ue,j=Y=>!!Y,M=null){if(ue.length===0)return Promise.resolve(M);let Y=ue.length;const ge=()=>{Y=-1;for(const we of ue)we.cancel?.()};return new Promise((we,ie)=>{for(const ne of ue)ne.then(de=>{--Y>=0&&j(de)?(ge(),we(de)):Y===0&&we(M)}).catch(de=>{--Y>=0&&(ge(),ie(de))})})}e.firstParallel=s;class u{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new l.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(j){return this._size++,new Promise((M,Y)=>{this.outstandingPromises.push({factory:j,c:M,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const M=j.factory();M.then(j.c,j.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class b extends u{constructor(){super(1)}}e.Queue=b;class g{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const j=new se;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueFor(j,M=T.extUri){const Y=M.getComparisonKey(j);let ge=this.queues.get(Y);return ge||(ge=new b,l.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.queues.delete(Y),this.onDidQueueDrain()}),this.queues.set(Y,ge)),ge}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=g;class L{constructor(j,M){this._token=-1,typeof j=="function"&&typeof M=="number"&&this.setIfNotSet(j,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},M)}setIfNotSet(j,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},M))}}e.TimeoutTimer=L;class H{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,M){this.cancel(),this._token=setInterval(()=>{j()},M)}}e.IntervalTimer=H;class q{constructor(j,M){this.timeoutToken=-1,this.runner=j,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class X{constructor(j,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class U extends q{constructor(j,M){super(j,M),this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner?.(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class N extends A.Disposable{constructor(j,M){super(),this.options=j,this.handler=M,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.options.maxBufferedWork)return!1}else if(this.pending+j.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const M of j)this.pendingWork.push(M);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,k.setTimeout0)(()=>{if(j)return;const M=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(ue,j)=>{const M=requestIdleCallback(ue,typeof j=="number"?{timeout:j}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(M))}}}}();class x{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function F(ue,j,M){let Y;for(let ge=0;ge<M;ge++)try{return await ue()}catch(we){Y=we,await c(j)}throw Y}e.retry=F;class V{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(j,M,Y){return this._pending={taskId:j,cancel:()=>Y?.(),promise:M},M.then(()=>this.donePending(j),()=>this.donePending(j)),M}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let M,Y;const ge=new Promise((we,ie)=>{M=we,Y=ie});this._next={run:j,promise:ge,promiseResolve:M,promiseReject:Y}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class fe{constructor(j,M=()=>Date.now()){this.interval=j,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=fe;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,M)=>{this.completeCallback=j,this.errorCallback=M})}complete(j){return new Promise(M=>{this.completeCallback(j),this.resolved=!0,M()})}error(j){return new Promise(M=>{this.errorCallback(j),this.rejected=!0,M()})}cancel(){new Promise(j=>{this.errorCallback(new P.CancellationError),this.rejected=!0,j()})}}e.DeferredPromise=se;var $;(function(ue){async function j(Y){let ge;const we=await Promise.all(Y.map(ie=>ie.then(ne=>ne,ne=>{ge||(ge=ne)})));if(typeof ge<"u")throw ge;return we}ue.settled=j;function M(Y){return new Promise(async(ge,we)=>{try{await Y(ge,we)}catch(ie){we(ie)}})}ue.withAsyncBody=M})($=e.Promises||(e.Promises={}));var J;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(J||(J={}));class te{static fromArray(j){return new te(M=>{M.emitMany(j)})}static fromPromise(j){return new te(async M=>{M.emitMany(await j)})}static fromPromises(j){return new te(async M=>{await Promise.all(j.map(async Y=>M.emitOne(await Y)))})}static merge(j){return new te(async M=>{await Promise.all(j.map(async Y=>{for await(const ge of Y)M.emitOne(ge)}))})}constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new l.Emitter,queueMicrotask(async()=>{const M={emitOne:Y=>this.emitOne(Y),emitMany:Y=>this.emitMany(Y),reject:Y=>this.reject(Y)};try{await Promise.resolve(j(M)),this.resolve()}catch(Y){this.reject(Y)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await l.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,M){return new te(async Y=>{for await(const ge of j)Y.emitOne(M(ge))})}map(j){return te.map(this,j)}static filter(j,M){return new te(async Y=>{for await(const ge of j)M(ge)&&Y.emitOne(ge)})}filter(j){return te.filter(this,j)}static coalesce(j){return te.filter(j,M=>!!M)}coalesce(){return te.coalesce(this)}static async toPromise(j){const M=[];for await(const Y of j)M.push(Y);return M}toPromise(){return te.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}te.EMPTY=te.fromArray([]),e.AsyncIterableObject=te;class be extends te{constructor(j,M){super(M),this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function le(ue){const j=new a.CancellationTokenSource,M=ue(j.token);return new be(j,async Y=>{const ge=j.token.onCancellationRequested(()=>{ge.dispose(),j.dispose(),Y.reject(new P.CancellationError)});try{for await(const we of M){if(j.token.isCancellationRequested)return;Y.emitOne(we)}ge.dispose(),j.dispose()}catch(we){ge.dispose(),j.dispose(),Y.reject(we)}})}e.createCancelableAsyncIterable=le}),define(Ce[39],De([1,0,18,19,34,28,15,14,9]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",I="[^/\\\\]",_=/\//g;function D(fe,se){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${se?`|${R}${I}+`:""})*?`}}function C(fe,se){if(!fe)return[];const $=[];let J=!1,te=!1,be="";for(const le of fe){switch(le){case se:if(!J&&!te){$.push(be),be="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":te=!0;break;case"]":te=!1;break}be+=le}return be&&$.push(be),$}e.splitGlobAware=C;function E(fe){if(!fe)return"";let se="";const $=C(fe,e.GLOB_SPLIT);if($.every(J=>J===e.GLOBSTAR))se=".*";else{let J=!1;$.forEach((te,be)=>{if(te===e.GLOBSTAR){if(J)return;se+=D(2,be===$.length-1)}else{let le=!1,ue="",j=!1,M="";for(const Y of te){if(Y!=="}"&&le){ue+=Y;continue}if(j&&(Y!=="]"||!M)){let ge;Y==="-"?ge=Y:(Y==="^"||Y==="!")&&!M?ge="^":Y===e.GLOB_SPLIT?ge="":ge=(0,y.escapeRegExpCharacters)(Y),M+=ge;continue}switch(Y){case"{":le=!0;continue;case"[":j=!0;continue;case"}":{se+=`(?:${C(ue,",").map(ie=>E(ie)).join("|")})`,le=!1,ue="";break}case"]":{se+="["+M+"]",j=!1,M="";break}case"?":se+=I;continue;case"*":se+=D(1);continue;default:se+=(0,y.escapeRegExpCharacters)(Y)}}be<$.length-1&&($[be+1]!==e.GLOBSTAR||be+2<$.length)&&(se+=R)}J=te===e.GLOBSTAR})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),o=function(){return!1},r=function(){return null};function c(fe,se){if(!fe)return r;let $;typeof fe!="string"?$=fe.pattern:$=fe,$=$.trim();const J=`${$}_${!!se.trimForExclusions}`;let te=t.get(J);if(te)return m(te,fe);let be;return n.test($)?te=i($.substr(4),$):(be=d.exec(f($,se)))?te=s(be[1],$):(se.trimForExclusions?w:h).test($)?te=u($,se):(be=S.exec(f($,se)))?te=b(be[1].substr(1),$,!0):(be=p.exec(f($,se)))?te=b(be[1],$,!1):te=g($),t.set(J,te),m(te,fe)}function m(fe,se){if(typeof se=="string")return fe;const $=function(J,te){return(0,l.isEqualOrParent)(J,se.base,!k.isLinux)?fe((0,y.ltrim)(J.substr(se.base.length),T.sep),te):null};return $.allBasenames=fe.allBasenames,$.allPaths=fe.allPaths,$.basenames=fe.basenames,$.patterns=fe.patterns,$}function f(fe,se){return se.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function i(fe,se){return function($,J){return typeof $=="string"&&$.endsWith(fe)?se:null}}function s(fe,se){const $=`/${fe}`,J=`\\${fe}`,te=function(le,ue){return typeof le!="string"?null:ue?ue===fe?se:null:le===fe||le.endsWith($)||le.endsWith(J)?se:null},be=[fe];return te.basenames=be,te.patterns=[se],te.allBasenames=be,te}function u(fe,se){const $=F(fe.slice(1,-1).split(",").map(ue=>c(ue,se)).filter(ue=>ue!==r),fe),J=$.length;if(!J)return r;if(J===1)return $[0];const te=function(ue,j){for(let M=0,Y=$.length;M<Y;M++)if($[M](ue,j))return fe;return null},be=$.find(ue=>!!ue.allBasenames);be&&(te.allBasenames=be.allBasenames);const le=$.reduce((ue,j)=>j.allPaths?ue.concat(j.allPaths):ue,[]);return le.length&&(te.allPaths=le),te}function b(fe,se,$){const J=T.sep===T.posix.sep,te=J?fe:fe.replace(_,T.sep),be=T.sep+te,le=T.posix.sep+fe;let ue;return $?ue=function(j,M){return typeof j=="string"&&(j===te||j.endsWith(be)||!J&&(j===fe||j.endsWith(le)))?se:null}:ue=function(j,M){return typeof j=="string"&&(j===te||!J&&j===fe)?se:null},ue.allPaths=[($?"*/":"./")+fe],ue}function g(fe){try{const se=new RegExp(`^${E(fe)}$`);return function($){return se.lastIndex=0,typeof $=="string"&&se.test($)?fe:null}}catch{return r}}function L(fe,se,$){return!fe||typeof se!="string"?!1:H(fe)(se,void 0,$)}e.match=L;function H(fe,se={}){if(!fe)return o;if(typeof fe=="string"||q(fe)){const $=c(fe,se);if($===r)return o;const J=function(te,be){return!!$(te,be)};return $.allBasenames&&(J.allBasenames=$.allBasenames),$.allPaths&&(J.allPaths=$.allPaths),J}return N(fe,se)}e.parse=H;function q(fe){const se=fe;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.isRelativePattern=q;function X(fe){return fe.allBasenames||[]}e.getBasenameTerms=X;function U(fe){return fe.allPaths||[]}e.getPathTerms=U;function N(fe,se){const $=F(Object.getOwnPropertyNames(fe).map(ue=>x(ue,fe[ue],se)).filter(ue=>ue!==r)),J=$.length;if(!J)return r;if(!$.some(ue=>!!ue.requiresSiblings)){if(J===1)return $[0];const ue=function(Y,ge){let we;for(let ie=0,ne=$.length;ie<ne;ie++){const de=$[ie](Y,ge);if(typeof de=="string")return de;(0,P.isThenable)(de)&&(we||(we=[]),we.push(de))}return we?(async()=>{for(const ie of we){const ne=await ie;if(typeof ne=="string")return ne}return null})():null},j=$.find(Y=>!!Y.allBasenames);j&&(ue.allBasenames=j.allBasenames);const M=$.reduce((Y,ge)=>ge.allPaths?Y.concat(ge.allPaths):Y,[]);return M.length&&(ue.allPaths=M),ue}const te=function(ue,j,M){let Y,ge;for(let we=0,ie=$.length;we<ie;we++){const ne=$[we];ne.requiresSiblings&&M&&(j||(j=(0,T.basename)(ue)),Y||(Y=j.substr(0,j.length-(0,T.extname)(ue).length)));const de=ne(ue,j,Y,M);if(typeof de=="string")return de;(0,P.isThenable)(de)&&(ge||(ge=[]),ge.push(de))}return ge?(async()=>{for(const we of ge){const ie=await we;if(typeof ie=="string")return ie}return null})():null},be=$.find(ue=>!!ue.allBasenames);be&&(te.allBasenames=be.allBasenames);const le=$.reduce((ue,j)=>j.allPaths?ue.concat(j.allPaths):ue,[]);return le.length&&(te.allPaths=le),te}function x(fe,se,$){if(se===!1)return r;const J=c(fe,$);if(J===r)return r;if(typeof se=="boolean")return J;if(se){const te=se.when;if(typeof te=="string"){const be=(le,ue,j,M)=>{if(!M||!J(le,ue))return null;const Y=te.replace("$(basename)",()=>j),ge=M(Y);return(0,P.isThenable)(ge)?ge.then(we=>we?fe:null):ge?fe:null};return be.requiresSiblings=!0,be}}return J}function F(fe,se){const $=fe.filter(ue=>!!ue.basenames);if($.length<2)return fe;const J=$.reduce((ue,j)=>{const M=j.basenames;return M?ue.concat(M):ue},[]);let te;if(se){te=[];for(let ue=0,j=J.length;ue<j;ue++)te.push(se)}else te=$.reduce((ue,j)=>{const M=j.patterns;return M?ue.concat(M):ue},[]);const be=function(ue,j){if(typeof ue!="string")return null;if(!j){let Y;for(Y=ue.length;Y>0;Y--){const ge=ue.charCodeAt(Y-1);if(ge===47||ge===92)break}j=ue.substr(Y)}const M=J.indexOf(j);return M!==-1?te[M]:null};be.basenames=J,be.patterns=te,be.allBasenames=J;const le=fe.filter(ue=>!ue.basenames);return le.push(be),le}function V(fe,se){return(0,a.equals)(fe,se,($,J)=>typeof $=="string"&&typeof J=="string"?$===J:typeof $!="string"&&typeof J!="string"?$.base===J.base&&$.pattern===J.pattern:!1)}e.patternsEquals=V}),define(Ce[113],De([1,0,8,165,24,9,2]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",h=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(d,h=0){return this.value+=_(this.supportThemeIcons?(0,P.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,h){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(d,h,w){return this.value+="[",this.value+=this._escape(h,"]"),this.value+="](",this.value+=this._escape(String(d),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(d,h){const w=new RegExp((0,A.escapeRegExpCharacters)(h),"g");return d.replace(w,(S,p)=>d.charAt(p-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=y;function v(n){return R(n)?!n.value:Array.isArray(n)?n.every(v):!0}e.isEmptyMarkdownString=v;function R(n){return n instanceof y?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function I(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons&&n.supportHtml===d.supportHtml&&(n.baseUri===d.baseUri||!!n.baseUri&&!!d.baseUri&&(0,l.isEqual)(T.URI.from(n.baseUri),T.URI.from(d.baseUri)))}e.markdownStringEqual=I;function _(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function D(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function C(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function E(n){const d=[],h=n.split("|").map(S=>S.trim());n=h[0];const w=h[1];if(w){const S=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),t=S?S[1]:"",o=p?p[1]:"",r=isFinite(parseInt(o)),c=isFinite(parseInt(t));r&&d.push(`width="${o}"`),c&&d.push(`height="${t}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=E}),define(Ce[114],De([1,0,18,34,15,14,24,9]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,c){const{os:m,tildify:f,relative:i}=c;if(i){const b=v(r,i,m);if(typeof b=="string")return b}let s=r.fsPath;if(m===1&&!A.isWindows?s=s.replace(/\//g,"\\"):m!==1&&A.isWindows&&(s=s.replace(/\\/g,"/")),m!==1&&f?.userHome){const b=f.userHome.fsPath;let g;r.scheme!==f.userHome.scheme&&r.path.startsWith(l.posix.sep)?g=f.userHome.with({path:r.path}).fsPath:g=r.fsPath,s=_(g,b,m)}return(m===1?l.win32:l.posix).normalize(R(s,m===1))}e.getPathLabel=y;function v(r,c,m){const f=m===1?l.win32:l.posix,i=m===3?T.extUri:T.extUriIgnorePathCase,s=c.getWorkspace(),u=(0,a.firstOrDefault)(s.folders);if(!u)return;r.scheme!==u.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=u.uri.with({path:r.path}));const b=c.getWorkspaceFolder(r);if(!b)return;let g;if(i.isEqual(b.uri,r)?g="":g=i.relativePath(b.uri,r)??"",g&&(g=f.normalize(g)),s.folders.length>1&&!c.noPrefix){const L=b.name?b.name:i.basenameOrAuthority(b.uri);g=g?`${L} \u2022 ${g}`:L}return g}function R(r,c=A.isWindows){return(0,P.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let I=Object.create(null);function _(r,c,m=A.OS){if(m===1||!r||!c)return r;let f=I.original===c?I.normalized:void 0;f||(f=c,A.isWindows&&(f=(0,P.toSlashes)(f)),f=`${(0,k.rtrim)(f,l.posix.sep)}${l.posix.sep}`,I={original:c,normalized:f});let i=r;return A.isWindows&&(i=(0,P.toSlashes)(i)),(m===3?i.startsWith(f):(0,k.startsWithIgnoreCase)(i,f))?`~/${i.substr(f.length)}`:r}e.tildify=_;function D(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=D;const C="\u2026",E="\\\\",n="~";function d(r,c=l.sep){const m=new Array(r.length);let f=!1;for(let i=0;i<r.length;i++){const s=r[i];if(s===""){m[i]=`.${c}`;continue}if(!s){m[i]=s;continue}f=!0;let u="",b=s;b.indexOf(E)===0?(u=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(c)===0?(u=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length)):b.indexOf(n)===0&&(u=b.substr(0,b.indexOf(n)+n.length),b=b.substr(b.indexOf(n)+n.length));const g=b.split(c);for(let L=1;f&&L<=g.length;L++)for(let H=g.length-L;f&&H>=0;H--){f=!1;let q=g.slice(H,H+L).join(c);for(let X=0;!f&&X<r.length;X++)if(X!==i&&r[X]&&r[X].indexOf(q)>-1){const U=H+L===g.length,N=H>0&&r[X].indexOf(c)>-1?c+q:q,x=r[X].endsWith(N);f=!U||x}if(!f){let X="";(g[0].endsWith(":")||u!=="")&&(H===1&&(H=0,L++,q=g[0]+c+q),H>0&&(X=g[0]+c),X=u+X),H>0&&(X=X+C+c),X=X+q,H+L<g.length&&(X=X+c+C),m[i]=X}}f&&(m[i]=s)}return m}e.shorten=d;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function w(r,c=Object.create(null)){const m=[];let f=!1,i="";for(const s of r)if(s==="$"||f&&s==="{")i&&m.push({value:i,type:h.TEXT}),i="",f=!0;else if(s==="}"&&f){const u=c[i];if(typeof u=="string")u.length&&m.push({value:u,type:h.VARIABLE});else if(u){const b=m[m.length-1];(!b||b.type!==h.SEPARATOR)&&m.push({value:u.label,type:h.SEPARATOR})}i="",f=!1}else i+=s;return i&&!f&&m.push({value:i,type:h.TEXT}),m.filter((s,u)=>{if(s.type===h.SEPARATOR){const b=m[u-1],g=m[u+1];return[b,g].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=w;function S(r,c){return A.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function p(r,c){return A.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(r){const c=r.indexOf("/")!==-1?l.posix:l.win32,m=c.basename(r),f=c.dirname(r);return m.length?{name:m,parentPath:f}:{name:f,parentPath:""}}e.splitName=o}),define(Ce[115],De([1,0,22,2]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(I){return I.toJSON()}class A{constructor(_){this._uriTransformer=_}transformIncoming(_){const D=this._uriTransformer.transformIncoming(_);return D===_?_:l(P.URI.from(D))}transformOutgoing(_){const D=this._uriTransformer.transformOutgoing(_);return D===_?_:l(P.URI.from(D))}transformOutgoingURI(_){const D=this._uriTransformer.transformOutgoing(_);return D===_?_:P.URI.from(D)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,_,D){if(!I||D>200)return null;if(typeof I=="object"){if(I instanceof P.URI)return _.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const E=T(I[C],_,D+1);E!==null&&(I[C]=E)}}return null}function k(I,_){const D=T(I,_,0);return D===null?I:D}e.transformOutgoingURIs=k;function y(I,_,D,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return D?P.URI.revive(_.transformIncoming(I)):_.transformIncoming(I);if(I instanceof a.VSBuffer)return null;for(const E in I)if(Object.hasOwnProperty.call(I,E)){const n=y(I[E],_,D,C+1);n!==null&&(I[E]=n)}}return null}function v(I,_){const D=y(I,_,!1,0);return D===null?I:D}e.transformIncomingURIs=v;function R(I,_){const D=y(I,_,!0,0);return D===null?I:D}e.transformAndReviveIncomingURIs=R}),define(Ce[29],De([1,0,71,72,327,19,34,88,15,14,24,2]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function D(N,x=_.UNLINK){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===_.UNLINK?E(N):C(N)}async function C(N){try{const x=(0,T.randomPath)((0,P.tmpdir)());try{await a.promises.rename(N,x)}catch(F){return F.code==="ENOENT"?void 0:E(N)}E(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function E(N){return(0,l.promisify)(a.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function n(N){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function d(N,x){return S(await(x?h(N):(0,l.promisify)(a.readdir)(N)))}async function h(N){try{return await(0,l.promisify)(a.readdir)(N,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const x=[],F=await d(N);for(const V of F){let fe=!1,se=!1,$=!1;try{const J=await e.Promises.lstat((0,y.join)(N,V));fe=J.isFile(),se=J.isDirectory(),$=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}x.push({name:V,isFile:()=>fe,isDirectory:()=>se,isSymbolicLink:()=>$})}return x}function w(N){return S(a.readdirSync(N))}e.readdirSync=w;function S(N){return N.map(x=>typeof x=="string"?v.isMacintosh?(0,k.normalizeNFC)(x):x:(x.name=v.isMacintosh?(0,k.normalizeNFC)(x.name):x.name,x))}async function p(N){const x=await d(N),F=[];for(const V of x)await o.existsDirectory((0,y.join)(N,V))&&F.push(V);return F}function t(N,x=1e3){return new Promise(F=>{let V=!1;const fe=setInterval(()=>{V||(V=!0,a.access(N,se=>{V=!1,se&&(clearInterval(fe),F(void 0))}))},x)})}e.whenDeleted=t;var o;(function(N){async function x(fe){let se;try{if(se=await e.Promises.lstat(fe),!se.isSymbolicLink())return{stat:se}}catch{}try{return{stat:await e.Promises.stat(fe),symbolicLink:se?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};if(v.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(fe)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};throw J}throw $}}N.stat=x;async function F(fe){try{const{stat:se,symbolicLink:$}=await N.stat(fe);return se.isFile()&&$?.dangling!==!0}catch{}return!1}N.existsFile=F;async function V(fe){try{const{stat:se,symbolicLink:$}=await N.stat(fe);return se.isDirectory()&&$?.dangling!==!0}catch{}return!1}N.existsDirectory=V})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function c(N,x,F){return r.queueFor(I.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const V=u(F);return new Promise((fe,se)=>i(N,x,V,$=>$?se($):fe()))})}let m=!0;function f(N){m=N}e.configureFlushOnWrite=f;function i(N,x,F,V){if(!m)return a.writeFile(N,x,{mode:F.mode,flag:F.flag},V);a.open(N,F.flag,F.mode,(fe,se)=>{if(fe)return V(fe);a.writeFile(se,x,$=>{if($)return a.close(se,()=>V($));a.fdatasync(se,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),f(!1)),a.close(se,te=>V(te))))})})}function s(N,x,F){const V=u(F);if(!m)return a.writeFileSync(N,x,{mode:V.mode,flag:V.flag});const fe=a.openSync(N,V.flag,V.mode);try{a.writeFileSync(fe,x);try{a.fdatasyncSync(fe)}catch(se){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",se),f(!1)}}finally{a.closeSync(fe)}}e.writeFileSync=s;function u(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function b(N,x){if(N!==x)try{await e.Promises.rename(N,x)}catch(F){if(N.toLowerCase()!==x.toLowerCase()&&F.code==="EXDEV"||N.endsWith("."))await g(N,x,{preserveSymlinks:!1}),await D(N,_.MOVE);else throw F}}async function g(N,x,F){return H(N,x,{root:{source:N,target:x},options:F,handledSourcePaths:new Set})}const L=511;async function H(N,x,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:V,symbolicLink:fe}=await o.stat(N);if(fe){if(F.options.preserveSymlinks)try{return await U(N,x,F)}catch(se){console.warn("[node.js fs] copy of symlink failed: ",se)}if(fe.dangling)return}return V.isDirectory()?q(N,x,V.mode&L,F):X(N,x,V.mode&L)}async function q(N,x,F,V){await e.Promises.mkdir(x,{recursive:!0,mode:F});const fe=await d(N);for(const se of fe)await H((0,y.join)(N,se),(0,y.join)(x,se),V)}async function X(N,x,F){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,F)}async function U(N,x,F){let V=await e.Promises.readlink(N);(0,T.isEqualOrParent)(V,F.root.source,!v.isLinux)&&(V=(0,y.join)(F.root.target,V.substr(F.root.source.length+1))),await e.Promises.symlink(V,x)}e.Promises=new class{get access(){return(0,l.promisify)(a.access)}get stat(){return(0,l.promisify)(a.stat)}get lstat(){return(0,l.promisify)(a.lstat)}get utimes(){return(0,l.promisify)(a.utimes)}get read(){return(N,x,F,V,fe)=>new Promise((se,$)=>{a.read(N,x,F,V,fe,(J,te,be)=>J?$(J):se({bytesRead:te,buffer:be}))})}get readFile(){return(0,l.promisify)(a.readFile)}get write(){return(N,x,F,V,fe)=>new Promise((se,$)=>{a.write(N,x,F,V,fe,(J,te,be)=>J?$(J):se({bytesWritten:te,buffer:be}))})}get appendFile(){return(0,l.promisify)(a.appendFile)}get fdatasync(){return(0,l.promisify)(a.fdatasync)}get truncate(){return(0,l.promisify)(a.truncate)}get rename(){return(0,l.promisify)(a.rename)}get copyFile(){return(0,l.promisify)(a.copyFile)}get open(){return(0,l.promisify)(a.open)}get close(){return(0,l.promisify)(a.close)}get symlink(){return(0,l.promisify)(a.symlink)}get readlink(){return(0,l.promisify)(a.readlink)}get chmod(){return(0,l.promisify)(a.chmod)}get mkdir(){return(0,l.promisify)(a.mkdir)}get unlink(){return(0,l.promisify)(a.unlink)}get rmdir(){return(0,l.promisify)(a.rmdir)}get realpath(){return(0,l.promisify)(a.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return D}get move(){return b}get copy(){return g}}}),define(Ce[116],De([1,0,71,15,14,9,29]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(_){if(l.isLinux)return _;const D=(0,P.dirname)(_);if(_===D)return _;const C=((0,P.basename)(_)||_).toLowerCase();try{const n=(0,T.readdirSync)(D).filter(d=>d.toLowerCase()===C);if(n.length===1){const d=k(D);if(d)return(0,P.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(C);if(d>=0){const h=k(D);if(h)return(0,P.join)(h,n[d])}}}catch{}return null}e.realcaseSync=k;async function y(_){if(l.isLinux)return _;const D=(0,P.dirname)(_);if(_===D)return _;const C=((0,P.basename)(_)||_).toLowerCase();try{const n=(await T.Promises.readdir(D)).filter(d=>d.toLowerCase()===C);if(n.length===1){const d=await y(D);if(d)return(0,P.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(C);if(d>=0){const h=await y(D);if(h)return(0,P.join)(h,n[d])}}}catch{}return null}e.realcase=y;async function v(_){try{return await T.Promises.realpath(_)}catch{const C=I(_);return await T.Promises.access(C,a.constants.R_OK),C}}e.realpath=v;function R(_){try{return a.realpathSync(_)}catch{const C=I(_);return a.accessSync(C,a.constants.R_OK),C}}e.realpathSync=R;function I(_){return(0,A.rtrim)((0,P.normalize)(_),P.sep)}}),define(Ce[117],De([1,0,15,14,33,110,10,29]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function y(I=l.env){return I.comspec||"cmd.exe"}e.getWindowsShell=y;function v(I){let _=[],D=!1;const C=function(E){if(D){_.push(E);return}(!I.send(E,d=>{if(d&&console.error(d),D=!1,_.length>0){const h=_.slice(0);_=[],h.forEach(w=>C(w))}})||P.isWindows)&&(D=!0)};return{send:C}}e.createQueuedSender=v;var R;(function(I){async function _(D,C,E){if(a.isAbsolute(D))return D;if(C===void 0&&(C=l.cwd()),a.dirname(D)!=="."||(E===void 0&&T.isString(l.env.PATH)&&(E=l.env.PATH.split(a.delimiter)),E===void 0||E.length===0))return a.join(C,D);async function d(h){if(await k.Promises.exists(h)){let w;try{w=await k.Promises.stat(h)}catch(S){S.message.startsWith("EACCES")&&(w=await k.Promises.lstat(h))}return w?!w.isDirectory():!1}return!1}for(const h of E){let w;if(a.isAbsolute(h)?w=a.join(h,D):w=a.join(C,h,D),await d(w))return w;let S=w+".com";if(await d(S)||(S=w+".exe",await d(S)))return S}return a.join(C,D)}I.findExecutable=_})(R=e.win32||(e.win32={}))});var $e=this&&this.__decorate||function(re,e,a,P){var l=arguments.length,A=l<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,a):P,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,a,P);else for(var k=re.length-1;k>=0;k--)(T=re[k])&&(A=(l<3?T(A):l>3?T(e,a,A):T(e,a))||A);return l>3&&A&&Object.defineProperty(e,a,A),A};define(Ce[118],De([1,0,18,19,22,21,62,8,3,6,70,9,10]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(D||(D={}));function C(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(E||(E={}));function n(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(d||(d={}));function h(se){let $=0;for(let J=0;;J+=7){const te=se.read(1);if($|=(te.buffer[0]&127)<<J,!(te.buffer[0]&128))return $}}const w=r(0);function S(se,$){if($===0){se.write(w);return}let J=0;for(let be=$;be!==0;be=be>>>7)J++;const te=l.VSBuffer.alloc(J);for(let be=0;$!==0;be++)te.buffer[be]=$&127,$=$>>>7,$>0&&(te.buffer[be]|=128);se.write(te)}class p{constructor($){this.buffer=$,this.pos=0}read($){const J=this.buffer.slice(this.pos,this.pos+$);return this.pos+=J.byteLength,J}}e.BufferReader=p;class t{constructor(){this.buffers=[]}get buffer(){return l.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}e.BufferWriter=t;var o;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(o||(o={}));function r(se){const $=l.VSBuffer.alloc(1);return $.writeUInt8(se,0),$}const c={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},m=typeof Buffer<"u";function f(se,$){if(typeof $>"u")se.write(c.Undefined);else if(typeof $=="string"){const J=l.VSBuffer.fromString($);se.write(c.String),S(se,J.byteLength),se.write(J)}else if(m&&Buffer.isBuffer($)){const J=l.VSBuffer.wrap($);se.write(c.Buffer),S(se,J.byteLength),se.write(J)}else if($ instanceof l.VSBuffer)se.write(c.VSBuffer),S(se,$.byteLength),se.write($);else if(Array.isArray($)){se.write(c.Array),S(se,$.length);for(const J of $)f(se,J)}else if(typeof $=="number"&&($|0)===$)se.write(c.Uint),S(se,$);else{const J=l.VSBuffer.fromString(JSON.stringify($));se.write(c.Object),S(se,J.byteLength),se.write(J)}}e.serialize=f;function i(se){switch(se.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return se.read(h(se)).toString();case o.Buffer:return se.read(h(se)).buffer;case o.VSBuffer:return se.read(h(se));case o.Array:{const J=h(se),te=[];for(let be=0;be<J;be++)te.push(i(se));return te}case o.Object:return JSON.parse(se.read(h(se)).toString());case o.Int:return h(se)}}e.deserialize=i;class s{constructor($,J,te=null,be=1e3){this.protocol=$,this.ctx=J,this.logger=te,this.timeoutDelay=be,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel($,J){this.channels.set($,J),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const J=this.send([$.type]);this.logger?.logOutgoing(J,0,1,n($.type));return}case 201:case 202:case 204:case 203:{const J=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(J,$.id,1,n($.type),$.data);return}}}send($,J=void 0){const te=new t;return f(te,$),f(te,J),this.sendBuffer(te.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const J=new p($),te=i(J),be=i(J),le=te[0];switch(le){case 100:return this.logger?.logIncoming($.byteLength,te[1],1,`${C(le)}: ${te[2]}.${te[3]}`,be),this.onPromise({type:le,id:te[1],channelName:te[2],name:te[3],arg:be});case 102:return this.logger?.logIncoming($.byteLength,te[1],1,`${C(le)}: ${te[2]}.${te[3]}`,be),this.onEventListen({type:le,id:te[1],channelName:te[2],name:te[3],arg:be});case 101:return this.logger?.logIncoming($.byteLength,te[1],1,`${C(le)}`),this.disposeActiveRequest({type:le,id:te[1]});case 103:return this.logger?.logIncoming($.byteLength,te[1],1,`${C(le)}`),this.disposeActiveRequest({type:le,id:te[1]})}}onPromise($){const J=this.channels.get($.channelName);if(!J){this.collectPendingRequest($);return}const te=new A.CancellationTokenSource;let be;try{be=J.call(this.ctx,$.name,$.arg,te.token)}catch(j){be=Promise.reject(j)}const le=$.id;be.then(j=>{this.sendResponse({id:le,data:j,type:201}),this.activeRequests.delete($.id)},j=>{j instanceof Error?this.sendResponse({id:le,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:le,data:j,type:203}),this.activeRequests.delete($.id)});const ue=(0,v.toDisposable)(()=>te.cancel());this.activeRequests.set($.id,ue)}onEventListen($){const J=this.channels.get($.channelName);if(!J){this.collectPendingRequest($);return}const te=$.id,le=J.listen(this.ctx,$.name,$.arg)(ue=>this.sendResponse({id:te,data:ue,type:204}));this.activeRequests.set($.id,le)}disposeActiveRequest($){const J=this.activeRequests.get($.id);J&&(J.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let J=this.pendingRequests.get($.channelName);J||(J=[],this.pendingRequests.set($.channelName,J));const te=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:$,timeoutTimer:te})}flushPendingRequests($){const J=this.pendingRequests.get($);if(J){for(const te of J)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var u;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor($,J=null){this.protocol=$,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=J}getChannel($){const J=this;return{call(te,be,le){return J.isDisposed?Promise.reject(new k.CancellationError):J.requestPromise($,te,be,le)},listen(te,be){return J.isDisposed?y.Event.None:J.requestEvent($,te,be)}}}requestPromise($,J,te,be=A.CancellationToken.None){const le=this.lastRequestId++,j={id:le,type:100,channelName:$,name:J,arg:te};if(be.isCancellationRequested)return Promise.reject(new k.CancellationError);let M;return new Promise((ge,we)=>{if(be.isCancellationRequested)return we(new k.CancellationError);const ie=()=>{const ce=ae=>{switch(ae.type){case 201:this.handlers.delete(le),ge(ae.data);break;case 202:{this.handlers.delete(le);const O=new Error(ae.data.message);O.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,O.name=ae.data.name,we(O);break}case 203:this.handlers.delete(le),we(ae.data);break}};this.handlers.set(le,ce),this.sendRequest(j)};let ne=null;this.state===d.Idle?ie():(ne=(0,P.createCancelablePromise)(ce=>this.whenInitialized()),ne.then(()=>{ne=null,ie()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:le,type:101}),we(new k.CancellationError)},ee=be.onCancellationRequested(de);M=(0,v.combinedDisposable)((0,v.toDisposable)(de),ee),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent($,J,te){const be=this.lastRequestId++,ue={id:be,type:102,channelName:$,name:J,arg:te};let j=null;const M=new y.Emitter({onWillAddFirstListener:()=>{j=(0,P.createCancelablePromise)(ge=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(M),this.sendRequest(ue)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(M),this.sendRequest({id:be,type:103}))}}),Y=ge=>M.fire(ge.data);return this.handlers.set(be,Y),M.event}sendRequest($){switch($.type){case 100:case 102:{const J=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(J,$.id,0,`${C($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const J=this.send([$.type,$.id]);this.logger?.logOutgoing(J,$.id,0,C($.type));return}}}send($,J=void 0){const te=new t;return f(te,$),f(te,J),this.sendBuffer(te.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const J=new p($),te=i(J),be=i(J),le=te[0];switch(le){case 200:return this.logger?.logIncoming($.byteLength,0,0,n(le)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,te[1],0,n(le),be),this.onResponse({type:te[0],id:te[1],data:be})}}onResponse($){if($.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}$e([T.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class g{get connections(){const $=[];return this._connections.forEach(J=>$.push(J)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:J,onDidClientDisconnect:te})=>{y.Event.once(J.onMessage)(le=>{const ue=new p(le),j=i(ue),M=new s(J,j),Y=new b(J);this.channels.forEach((we,ie)=>M.registerChannel(ie,we));const ge={channelServer:M,channelClient:Y,ctx:j};this._connections.add(ge),this._onDidAddConnection.fire(ge),te(()=>{M.dispose(),Y.dispose(),this._connections.delete(ge),this._onDidRemoveConnection.fire(ge)})})})}getChannel($,J){const te=this;return{call(be,le,ue){let j;if((0,_.isFunction)(J)){const Y=(0,a.getRandomElement)(te.connections.filter(J));j=Y?Promise.resolve(Y):y.Event.toPromise(y.Event.filter(te.onDidAddConnection,J))}else j=J.routeCall(te,be,le);const M=j.then(Y=>Y.channelClient.getChannel($));return H(M).call(be,le,ue)},listen(be,le){if((0,_.isFunction)(J))return te.getMulticastEvent($,J,be,le);const ue=J.routeEvent(te,be,le).then(j=>j.channelClient.getChannel($));return H(ue).listen(be,le)}}}getMulticastEvent($,J,te,be){const le=this;let ue=new v.DisposableStore;const j=new y.Emitter({onWillAddFirstListener:()=>{ue=new v.DisposableStore;const M=new y.EventMultiplexer,Y=new Map,ge=ie=>{const de=ie.channelClient.getChannel($).listen(te,be),ee=M.add(de);Y.set(ie,ee)},we=ie=>{const ne=Y.get(ie);!ne||(ne.dispose(),Y.delete(ie))};le.connections.filter(J).forEach(ge),y.Event.filter(le.onDidAddConnection,J)(ge,void 0,ue),le.onDidRemoveConnection(we,void 0,ue),M.event(j.fire,j,ue),ue.add(M)},onDidRemoveLastListener:()=>{ue.dispose()}});return j.event}registerChannel($,J){this.channels.set($,J),this._connections.forEach(te=>{te.channelServer.registerChannel($,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class L{constructor($,J,te=null){const be=new t;f(be,J),$.send(be.buffer),this.channelClient=new b($,te),this.channelServer=new s($,J,te)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,J){this.channelServer.registerChannel($,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function H(se){return{call($,J,te){return se.then(be=>be.call($,J,te))},listen($,J){const te=new y.Relay;return se.then(be=>te.input=be.listen($,J)),te.event}}}e.getDelayedChannel=H;function q(se){let $=!1;return{call(J,te,be){return $?se.call(J,te,be):(0,P.timeout)(0).then(()=>$=!0).then(()=>se.call(J,te,be))},listen(J,te){if($)return se.listen(J,te);const be=new y.Relay;return(0,P.timeout)(0).then(()=>$=!0).then(()=>be.input=se.listen(J,te)),be.event}}}e.getNextTickChannel=q;class X{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const J of $.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=X;var U;(function(se){function $(le,ue){const j=le,M=ue&&ue.disableMarshalling,Y=new Map;for(const ge in j)te(ge)&&Y.set(ge,y.Event.buffer(j[ge],!0));return new class{listen(ge,we,ie){const ne=Y.get(we);if(ne)return ne;if(be(we)){const de=j[we];if(typeof de=="function")return de.call(j,ie)}throw new Error(`Event not found: ${we}`)}call(ge,we,ie){const ne=j[we];if(typeof ne=="function"){if(!M&&Array.isArray(ie))for(let de=0;de<ie.length;de++)ie[de]=(0,R.revive)(ie[de]);return ne.apply(j,ie)}throw new Error(`Method not found: ${we}`)}}}se.fromService=$;function J(le,ue){const j=ue&&ue.disableMarshalling;return new Proxy({},{get(M,Y){if(typeof Y=="string")return ue?.properties?.has(Y)?ue.properties.get(Y):be(Y)?function(ge){return le.listen(Y,ge)}:te(Y)?le.listen(Y):async function(...ge){let we;ue&&!(0,_.isUndefinedOrNull)(ue.context)?we=[ue.context,...ge]:we=ge;const ie=await le.call(Y,we);return j?ie:(0,R.revive)(ie)};throw new Error(`Property not found: ${String(Y)}`)}})}se.toService=J;function te(le){return le[0]==="o"&&le[1]==="n"&&I.isUpperAsciiLetter(le.charCodeAt(2))}function be(le){return/^onDynamic/.test(le)&&I.isUpperAsciiLetter(le.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const $=se.toString();if($!=="[object Object]")return $}return se}function F(se){return Array.isArray(se)?se.map(x):x(se)}function V(se,$,J,te,be,le,ue){ue=F(ue);const j=N[be],M=j[te%j.length];let Y=[`%c[${se}]%c[${String($).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(le)?(Y=Y.concat(ue),Y.push(")")):Y.push(ue),console.log.apply(console,Y)}class fe{constructor($,J){this._outgoingPrefix=$,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,J,te,be,le){this._totalOutgoing+=$,V(this._outgoingPrefix,this._totalOutgoing,$,J,te,be,le)}logIncoming($,J,te,be,le){this._totalIncoming+=$,V(this._incomingPrefix,this._totalIncoming,$,J,te,be,le)}}e.IPCLogger=fe}),define(Ce[119],De([1,0,19,22,3,6,118]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(b){b.enableDiagnostics=!1,b.records=[];const g=new WeakMap;let L=0;function H(X,U){if(!g.has(X)){const N=String(++L);g.set(X,N)}return g.get(X)}function q(X,U,N,x){if(!b.enableDiagnostics)return;const F=H(X,U);if(x instanceof P.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const V=P.VSBuffer.alloc(x.byteLength);V.set(x),b.records.push({timestamp:Date.now(),id:F,label:U,type:N,buff:V})}else b.records.push({timestamp:Date.now(),id:F,label:U,type:N,data:x})}b.traceSocketEvent=q})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function I(){return R||(R=P.VSBuffer.alloc(0)),R}class _{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(g){this._chunks.push(g),this._totalLength+=g.byteLength}read(g){return this._read(g,!0)}peek(g){return this._read(g,!1)}_read(g,L){if(g===0)return I();if(g>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===g){const U=this._chunks[0];return L&&(this._chunks.shift(),this._totalLength-=g),U}if(this._chunks[0].byteLength>g){const U=this._chunks[0].slice(0,g);return L&&(this._chunks[0]=this._chunks[0].slice(g),this._totalLength-=g),U}const H=P.VSBuffer.alloc(g);let q=0,X=0;for(;g>0;){const U=this._chunks[X];if(U.byteLength>g){const N=U.slice(0,g);H.set(N,q),q+=g,L&&(this._chunks[X]=U.slice(g),this._totalLength-=g),g-=g}else H.set(U,q),q+=U.byteLength,L?(this._chunks.shift(),this._totalLength-=U.byteLength):X++,g-=U.byteLength}return H}}e.ChunkStream=_;var D;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(D||(D={}));function C(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class n{constructor(g,L,H,q){this.type=g,this.id=L,this.ack=H,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends A.Disposable{constructor(g){super(),this._onMessage=this._register(new l.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=g,this._isDisposed=!1,this._incomingData=new _,this._register(this._socket.onData(L=>this.acceptChunk(L))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;){const L=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=L.readUInt32BE(9),this._state.messageType=L.readUInt8(0),this._state.id=L.readUInt32BE(1),this._state.ack=L.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const H=this._state.messageType,q=this._state.id,X=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",L),this._onMessage.fire(new n(H,q,X,L)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(g){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=g,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(g){if(this._isDisposed)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const L=P.VSBuffer.alloc(13);L.writeUInt8(g.type,0),L.writeUInt32BE(g.id,1),L.writeUInt32BE(g.ack,5),L.writeUInt32BE(g.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",g.data),this._writeSoon(L,g.data)}_bufferAdd(g,L){const H=this._totalLength===0;return this._data.push(g,L),this._totalLength+=g.byteLength+L.byteLength,H}_bufferTake(){const g=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,g}_writeSoon(g,L){this._bufferAdd(g,L)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const g=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:g.byteLength}),this._socket.write(g)}}class w extends A.Disposable{constructor(g){super(),this._onMessage=new l.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=g,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(L=>{L.type===1&&this._onMessage.fire(L.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(g){this._socketWriter.write(new n(1,0,0,g))}}e.Protocol=w;class S extends T.IPCClient{static fromSocket(g,L){return new S(new w(g),L)}get onDidDispose(){return this.protocol.onDidDispose}constructor(g,L,H=null){super(g,L,H),this.protocol=g}dispose(){super.dispose();const g=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),g.end()}}e.Client=S;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new l.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(g){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(g):this._emitter.fire(g):this._bufferedMessages.push(g)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let g=0,L=this._first;for(;L;)L=L.next,g++;return g}peek(){return this._first?this._first.data:null}toArray(){const g=[];let L=0,H=this._first;for(;H;)g[L++]=H.data,H=H.next;return g}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(g){const L=new t(g);if(!this._first){this._first=L,this._last=L;return}this._last.next=L,this._last=L}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const g=Date.now();for(let L=0;L<r._HISTORY_LENGTH;L++)this.lastRuns[L]=g-1e3*L;setInterval(()=>{for(let L=r._HISTORY_LENGTH;L>=1;L--)this.lastRuns[L]=this.lastRuns[L-1];this.lastRuns[0]=Date.now()},1e3)}load(){const g=Date.now(),L=(1+r._HISTORY_LENGTH)*1e3;let H=0;for(let q=0;q<r._HISTORY_LENGTH;q++)g-this.lastRuns[q]<=L&&H++;return 1-H/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;var c;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function m(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=m;class f{constructor(g){this.connectionHealth=g}}e.ConnectionHealthChangedEvent=f;class i{constructor(g,L){this.roundTripTime=g,this.recentHighRoundTripCount=L}}e.HighRoundTripTimeEvent=i;class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(g){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._onHighRoundTripTime=new p,this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=new p,this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._loadEstimator=g.loadEstimator??r.getInstance(),this._measureRoundTripTime=g.measureRoundTripTime??!1,this._shouldSendKeepAlive=g.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=g.socket,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(L=>this._receiveMessage(L))),this._socketDisposables.add(this._socket.onClose(L=>this._onSocketClose.fire(L))),this._socketLatencyMonitor=this._socketDisposables.add(new u),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(L=>this._sendLatencyMeasurementRequest(L))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(L=>this._onHighRoundTripTime.fire(L))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(L=>this._onDidChangeConnectionHealth.fire(L))),this._measureRoundTripTime&&this._socketLatencyMonitor.start(),g.initialChunk&&this._socketReader.acceptChunk(g.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const g=new n(5,0,0,I());this._socketWriter.write(g),this._socketWriter.flush()}sendPause(){const g=new n(7,0,0,I());this._socketWriter.write(g)}sendResume(){const g=new n(8,0,0,I());this._socketWriter.write(g)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(g,L){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=g,this._socketWriter=this._socketDisposables.add(new h(this._socket)),this._socketReader=this._socketDisposables.add(new d(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(H=>this._receiveMessage(H))),this._socketDisposables.add(this._socket.onClose(H=>this._onSocketClose.fire(H))),this._socketLatencyMonitor=this._socketDisposables.add(new u),this._socketDisposables.add(this._socketLatencyMonitor.onSendLatencyRequest(H=>this._sendLatencyMeasurementRequest(H))),this._socketDisposables.add(this._socketLatencyMonitor.onHighRoundTripTime(H=>this._onHighRoundTripTime.fire(H))),this._socketDisposables.add(this._socketLatencyMonitor.onDidChangeConnectionHealth(H=>this._onDidChangeConnectionHealth.fire(H))),this._socketReader.acceptChunk(L)}endAcceptReconnection(){this._isReconnecting=!1,this._measureRoundTripTime&&this._socketLatencyMonitor.start(),this._incomingAckId=this._incomingMsgId;const g=new n(3,0,this._incomingAckId,I());this._socketWriter.write(g);const L=this._outgoingUnackMsg.toArray();for(let H=0,q=L.length;H<q;H++)this._socketWriter.write(L[H]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(g){if(g.ack>this._outgoingAckId){this._outgoingAckId=g.ack;do{const L=this._outgoingUnackMsg.peek();if(L&&L.id<=g.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(g.type){case 0:break;case 1:{if(g.id>this._incomingMsgId)if(g.id!==this._incomingMsgId+1){const L=Date.now();L-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=L,this._socketWriter.write(new n(6,0,0,I())))}else this._incomingMsgId=g.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(g.data);break}case 2:{this._onControlMessage.fire(g.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const L=this._outgoingUnackMsg.toArray();for(let H=0,q=L.length;H<q;H++)this._socketWriter.write(L[H]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break;case 10:{this._sendLatencyMeasurementResponse(g.data);break}case 11:{this._socketLatencyMonitor.handleResponse(g.data);break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(g){const L=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const H=new n(1,L,this._incomingAckId,g);this._outgoingUnackMsg.push(H),this._isReconnecting||(this._socketWriter.write(H),this._recvAckCheck())}sendControl(g){const L=new n(2,0,0,g);this._socketWriter.write(L)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const g=Date.now()-this._incomingMsgLastTime;if(g>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-g+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const g=this._outgoingUnackMsg.peek(),L=Date.now()-g.writtenTime,H=Date.now()-this._socketReader.lastReadTime,q=Date.now()-this._lastSocketTimeoutTime;if(L>=2e4&&H>=2e4&&q>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:L,timeSinceLastReceivedSomeData:H});return}const X=Math.max(2e4-L,2e4-H,2e4-q,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},X)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const g=new n(3,0,this._incomingAckId,I());this._socketWriter.write(g)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const g=new n(9,0,this._incomingAckId,I());this._socketWriter.write(g)}_sendLatencyMeasurementRequest(g){this._incomingAckId=this._incomingMsgId;const L=new n(10,0,this._incomingAckId,g);this._socketWriter.write(L)}_sendLatencyMeasurementResponse(g){this._incomingAckId=this._incomingMsgId;const L=new n(11,0,this._incomingAckId,g);this._socketWriter.write(L)}}e.PersistentProtocol=s;class u extends A.Disposable{constructor(){super(),this._onSendLatencyRequest=this._register(new l.Emitter),this.onSendLatencyRequest=this._onSendLatencyRequest.event,this._onHighRoundTripTime=this._register(new l.Emitter),this.onHighRoundTripTime=this._onHighRoundTripTime.event,this._onDidChangeConnectionHealth=this._register(new l.Emitter),this.onDidChangeConnectionHealth=this._onDidChangeConnectionHealth.event,this._measureLatencyTimer=this._register(new a.IntervalTimer),this._lastLatencyMeasurementSent=-1,this._lastLatencyMeasurementId=0,this._latencySamples=Array.from({length:5},g=>0),this._latencySampleIndex=0,this._connectionHealth=0}start(){this._measureLatencyTimer.cancelAndSet(()=>{this._lastLatencyMeasurementSent=Date.now();const g=++this._lastLatencyMeasurementId,L=P.VSBuffer.alloc(4);L.writeUInt32BE(g,0),this._onSendLatencyRequest.fire(L)},6e4)}handleResponse(g){if(g.byteLength!==4)return;const L=g.readUInt32BE(0);if(this._lastLatencyMeasurementSent<=0||L!==this._lastLatencyMeasurementId)return;const H=Date.now()-this._lastLatencyMeasurementSent,q=this._latencySampleIndex++;this._latencySamples[q%this._latencySamples.length]=H;const X=this._connectionHealth,U=this._latencySamples.filter(N=>N>=1e3).length;this._connectionHealth=U>=3?1:0,H>1e3&&this._onHighRoundTripTime.fire(new i(H,U)),X!==this._connectionHealth&&this._onDidChangeConnectionHealth.fire(this._connectionHealth)}}}),define(Ce[120],De([1,0,22,8,3,6,15,14,30,118,119]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class _{traceSocketEvent(i,s){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,s)}constructor(i,s=""){this._canWrite=!0,this.debugLabel=s,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=u=>{if(this.traceSocketEvent("error",{code:u?.code,message:u?.message}),u){if(u.code==="EPIPE")return;(0,P.onUnexpectedError)(u)}},this.socket.on("error",this._errorListener),this._closeListener=u=>{this.traceSocketEvent("close",{hadError:u}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(i){const s=u=>{this.traceSocketEvent("read",u),i(a.VSBuffer.wrap(u))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(i){const s=u=>{i({type:0,hadError:u,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(i){const s=()=>{i()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(i){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,P.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,P.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=_;var D;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize",f[f.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(D||(D={}));var C;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(C||(C={}));class E extends A.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(i,s){this.socket.traceSocketEvent(i,s)}constructor(i,s,u,b){super(),this._onData=this._register(new l.Emitter),this._onClose=this._register(new l.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:u?.byteLength||0,recordInflateBytes:b}),this._flowManager=this._register(new n(this,s,u,b,this._onData,(g,L)=>this._write(g,L))),this._register(this._flowManager.onError(g=>{console.error(g),(0,P.onUnexpectedError)(g),this._onClose.fire({type:0,hadError:!0,error:g})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(g=>this._acceptChunk(g))),this._register(this.socket.onClose(async g=>{this._flowManager.isProcessingReadQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(g)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this._onData.event(i)}onClose(i){return this._onClose.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let s=0;for(;s<i.byteLength;)this._flowManager.writeMessage(i.slice(s,Math.min(s+262144,i.byteLength))),s+=262144}_write(i,s){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let u=2;i.byteLength<126?u+=0:i.byteLength<2**16?u+=2:u+=8;const b=a.VSBuffer.alloc(u);if(s?b.writeUInt8(194,0):b.writeUInt8(130,0),i.byteLength<126)b.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){b.writeUInt8(126,1);let g=1;b.writeUInt8(i.byteLength>>>8&255,++g),b.writeUInt8(i.byteLength>>>0&255,++g)}else{b.writeUInt8(127,1);let g=1;b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(i.byteLength>>>24&255,++g),b.writeUInt8(i.byteLength>>>16&255,++g),b.writeUInt8(i.byteLength>>>8&255,++g),b.writeUInt8(i.byteLength>>>0&255,++g)}this.socket.write(a.VSBuffer.concat([b,i]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(i){if(i.byteLength!==0){for(this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const s=this._incomingData.peek(this._state.readLen),u=s.readUInt8(0),b=(u&128)>>>7,g=(u&64)>>>6,L=s.readUInt8(1),H=(L&128)>>>7,q=L&127;this._state.state=2,this._state.readLen=2+(H?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=b,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(g)),this._state.firstFrameOfMessage=Boolean(b),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const s=this._incomingData.read(this._state.readLen),u=s.readUInt8(1),b=(u&128)>>>7;let g=u&127,L=1;g===126?g=s.readUInt8(++L)*2**8+s.readUInt8(++L):g===127&&(g=s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*2**24+s.readUInt8(++L)*2**16+s.readUInt8(++L)*2**8+s.readUInt8(++L));let H=0;b&&(H=s.readUInt8(++L)*2**24+s.readUInt8(++L)*2**16+s.readUInt8(++L)*2**8+s.readUInt8(++L)),this._state.state=3,this._state.readLen=g,this._state.mask=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const s=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),w(s,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(s,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await l.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class n extends A.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(i,s,u,b,g,L){super(),this._tracer=i,this._onData=g,this._writeFn=L,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new l.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new l.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,s?(this._zlibInflateStream=this._register(new d(this._tracer,b,u,{windowBits:15})),this._zlibDeflateStream=this._register(new h(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(H=>this._onError.fire(H))),this._register(this._zlibDeflateStream.onError(H=>this._onError.fire(H)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(i){this._writeQueue.push(i),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const i=this._writeQueue.shift();if(this._zlibDeflateStream){const s=await this._deflateMessage(this._zlibDeflateStream,i);this._writeFn(s,!0)}else this._writeFn(i,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(i,s){return new Promise((u,b)=>{i.write(s),i.flush(g=>u(g))})}acceptFrame(i,s,u){this._readQueue.push({data:i,isCompressed:s,isLastFrameOfMessage:u}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const i=this._readQueue.shift();if(this._zlibInflateStream&&i.isCompressed){const s=await this._inflateFrame(this._zlibInflateStream,i.data,i.isLastFrameOfMessage);this._onData.fire(s)}else this._onData.fire(i.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(i,s,u){return new Promise((b,g)=>{i.write(s),u&&i.write(a.VSBuffer.fromByteArray([0,0,255,255])),i.flush(L=>b(L))})}}class d extends A.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?a.VSBuffer.concat(this._recordedInflateBytes):a.VSBuffer.alloc(0)}constructor(i,s,u,b){super(),this._tracer=i,this._recordInflateBytes=s,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(b),this._zlibInflate.on("error",g=>{this._tracer.traceSocketEvent("zlibInflateError",{message:g?.message,code:g?.code}),this._onError.fire(g)}),this._zlibInflate.on("data",g=>{this._tracer.traceSocketEvent("zlibInflateData",g),this._pendingInflateData.push(a.VSBuffer.wrap(g))}),u&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",u.buffer),this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(i){this._recordInflateBytes&&this._recordedInflateBytes.push(i.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",i),this._zlibInflate.write(i.buffer)}flush(i){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const s=a.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,i(s)})}}class h extends A.Disposable{constructor(i,s){super(),this._tracer=i,this._onError=this._register(new l.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",u=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:u?.message,code:u?.code}),this._onError.fire(u)}),this._zlibDeflate.on("data",u=>{this._tracer.traceSocketEvent("zlibDeflateData",u),this._pendingDeflateData.push(a.VSBuffer.wrap(u))})}write(i){this._tracer.traceSocketEvent("zlibDeflateWrite",i.buffer),this._zlibDeflate.write(i.buffer)}flush(i){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let s=a.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,s=s.slice(0,s.byteLength-4),i(s)})}}function w(f,i){if(i===0)return;const s=f.byteLength>>>2;for(let q=0;q<s;q++){const X=f.readUInt32BE(q*4);f.writeUInt32BE(X^i,q*4)}const u=s*4,b=f.byteLength-u,g=i>>>24&255,L=i>>>16&255,H=i>>>8&255;b>=1&&f.writeUInt8(f.readUInt8(u)^g,u),b>=2&&f.writeUInt8(f.readUInt8(u+1)^L,u+1),b>=3&&f.writeUInt8(f.readUInt8(u+2)^H,u+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function p(){const f=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;const i=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:I().os.tmpdir(),s=(0,T.join)(i,`vscode-ipc-${f}.sock`);return o(s),s}e.createRandomIPCHandle=p;function t(f,i,s){const u=I().crypto.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${s}-${i}-sock`;const b=s.substr(0,4),g=i.substr(0,6),L=u.substr(0,8);let H;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?H=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${L}-${b}-${g}.sock`):H=(0,T.join)(f,`${b}-${g}.sock`),o(H),H}e.createStaticIPCHandle=t;function o(f){const i=S[k.platform];typeof i=="number"&&f.length>=i&&console.warn(`WARNING: IPC handle "${f}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends v.IPCServer{static toClientConnectionEvent(i){const s=l.Event.fromNodeEventEmitter(i,"connection");return l.Event.map(s,u=>({protocol:new R.Protocol(new _(u,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(u,"close"))}))}constructor(i){super(r.toClientConnectionEvent(i)),this.server=i}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function c(f){return new Promise((i,s)=>{const u=I().net.createServer();u.on("error",s),u.listen(f,()=>{u.removeListener("error",s),i(new r(u))})})}e.serve=c;function m(f,i){return new Promise((s,u)=>{const b=I().net.createConnection(f,()=>{b.removeListener("error",u),s(R.Client.fromSocket(new _(b,`ipc-client${i}`),i))});b.once("error",u)})}e.connect=m}),define(Ce[166],De([1,0,39,15]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(A,T,k,y,v,R){if(Array.isArray(A)){let I=0;for(const _ of A){const D=l(_,T,k,y,v,R);if(D===10)return D;D>I&&(I=D)}return I}else{if(typeof A=="string")return y?A==="*"?5:A===k?10:0:0;if(A){const{language:I,pattern:_,scheme:D,hasAccessToAllModels:C,notebookType:E}=A;if(!y&&!C)return 0;E&&v&&(T=v);let n=0;if(D)if(D===T.scheme)n=10;else if(D==="*")n=5;else return 0;if(I)if(I===k)n=10;else if(I==="*")n=Math.max(n,5);else return 0;if(E)if(E===R)n=10;else if(E==="*"&&R!==void 0)n=Math.max(n,5);else return 0;if(_){let d;if(typeof _=="string"?d=_:d={..._,base:(0,P.normalize)(_.base)},d===T.fsPath||(0,a.match)(d,T.fsPath))n=10;else return 0}return n}else return 0}}e.score=l}),define(Ce[167],De([1,0,9,53,156]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,y,v,R){this._uri=k,this._lines=y,this._eol=v,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const v of y)this._acceptDeleteRange(v.range),this._acceptInsertText(new P.Position(v.range.startLineNumber,v.range.startColumn),v.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,v=new Uint32Array(y);for(let R=0;R<y;R++)v[R]=this._lines[R].length+k;this._lineStarts=new l.PrefixSumComputer(v)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length===0)return;const v=(0,a.splitLines)(y);if(v.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+v[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}v[v.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let I=1;I<v.length;I++)this._lines.splice(k.lineNumber+I-1,0,v[I]),R[I-1]=v[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}e.MirrorTextModel=A}),define(Ce[168],De([1,0,9,153,53,32,108]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(h,w,S,p){this.searchString=h,this.isRegex=w,this.matchCase=S,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=v(this.searchString):h=this.searchString.indexOf(`
`)>=0;let w=null;try{w=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!w)return null;let S=!this.isRegex&&!h;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new T.SearchData(w,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function v(d){if(!d||d.length===0)return!1;for(let h=0,w=d.length;h<w;h++){const S=d.charCodeAt(h);if(S===10)return!0;if(S===92){if(h++,h>=w)break;const p=d.charCodeAt(h);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=v;function R(d,h,w){if(!w)return new T.FindMatch(d,null);const S=[];for(let p=0,t=h.length;p<t;p++)S[p]=h[p];return new T.FindMatch(d,S)}e.createFindMatch=R;class I{constructor(h){const w=[];let S=0;for(let p=0,t=h.length;p<t;p++)h.charCodeAt(p)===10&&(w[S++]=p);this._lineFeedsOffsets=w}findLineFeedCountBeforeOffset(h){const w=this._lineFeedsOffsets;let S=0,p=w.length-1;if(p===-1||h<=w[0])return 0;for(;S<p;){const t=S+((p-S)/2>>0);w[t]>=h?p=t-1:w[t+1]>=h?(S=t,p=t):S=t+1}return S+1}}class _{static findMatches(h,w,S,p,t){const o=w.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(h,S,new n(o.wordSeparators,o.regex),p,t):this._doFindMatchesLineByLine(h,S,o,p,t):[]}static _getMultilineMatchRange(h,w,S,p,t,o){let r,c=0;p?(c=p.findLineFeedCountBeforeOffset(t),r=w+t+c):r=w+t;let m;if(p){const u=p.findLineFeedCountBeforeOffset(t+o.length)-c;m=r+o.length+u}else m=r+o.length;const f=h.getPositionAt(r),i=h.getPositionAt(m);return new A.Range(f.lineNumber,f.column,i.lineNumber,i.column)}static _doFindMatchesMultiline(h,w,S,p,t){const o=h.getOffsetAt(w.getStartPosition()),r=h.getValueInRange(w,1),c=h.getEOL()===`\r
`?new I(r):null,m=[];let f=0,i;for(S.reset(0);i=S.next(r);)if(m[f++]=R(this._getMultilineMatchRange(h,o,r,c,i.index,i[0]),i,p),f>=t)return m;return m}static _doFindMatchesLineByLine(h,w,S,p,t){const o=[];let r=0;if(w.startLineNumber===w.endLineNumber){const m=h.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return r=this._findMatchesInLine(S,m,w.startLineNumber,w.startColumn-1,r,o,p,t),o}const c=h.getLineContent(w.startLineNumber).substring(w.startColumn-1);r=this._findMatchesInLine(S,c,w.startLineNumber,w.startColumn-1,r,o,p,t);for(let m=w.startLineNumber+1;m<w.endLineNumber&&r<t;m++)r=this._findMatchesInLine(S,h.getLineContent(m),m,0,r,o,p,t);if(r<t){const m=h.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);r=this._findMatchesInLine(S,m,w.endLineNumber,0,r,o,p,t)}return o}static _findMatchesInLine(h,w,S,p,t,o,r,c){const m=h.wordSeparators;if(!r&&h.simpleSearch){const s=h.simpleSearch,u=s.length,b=w.length;let g=-u;for(;(g=w.indexOf(s,g+u))!==-1;)if((!m||E(m,w,b,g,u))&&(o[t++]=new T.FindMatch(new A.Range(S,g+1+p,S,g+1+u+p),null),t>=c))return t;return t}const f=new n(h.wordSeparators,h.regex);let i;f.reset(0);do if(i=f.next(w),i&&(o[t++]=R(new A.Range(S,i.index+1+p,S,i.index+1+i[0].length+p),i,r),t>=c))return t;while(i);return t}static findNextMatch(h,w,S,p){const t=w.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(h,S,o,p):this._doFindNextMatchLineByLine(h,S,o,p)}static _doFindNextMatchMultiline(h,w,S,p){const t=new l.Position(w.lineNumber,1),o=h.getOffsetAt(t),r=h.getLineCount(),c=h.getValueInRange(new A.Range(t.lineNumber,t.column,r,h.getLineMaxColumn(r)),1),m=h.getEOL()===`\r
`?new I(c):null;S.reset(w.column-1);const f=S.next(c);return f?R(this._getMultilineMatchRange(h,o,c,m,f.index,f[0]),f,p):w.lineNumber!==1||w.column!==1?this._doFindNextMatchMultiline(h,new l.Position(1,1),S,p):null}static _doFindNextMatchLineByLine(h,w,S,p){const t=h.getLineCount(),o=w.lineNumber,r=h.getLineContent(o),c=this._findFirstMatchInLine(S,r,o,w.column,p);if(c)return c;for(let m=1;m<=t;m++){const f=(o+m-1)%t,i=h.getLineContent(f+1),s=this._findFirstMatchInLine(S,i,f+1,1,p);if(s)return s}return null}static _findFirstMatchInLine(h,w,S,p,t){h.reset(p-1);const o=h.next(w);return o?R(new A.Range(S,o.index+1,S,o.index+1+o[0].length),o,t):null}static findPreviousMatch(h,w,S,p){const t=w.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(h,S,o,p):this._doFindPreviousMatchLineByLine(h,S,o,p)}static _doFindPreviousMatchMultiline(h,w,S,p){const t=this._doFindMatchesMultiline(h,new A.Range(1,1,w.lineNumber,w.column),S,p,10*k);if(t.length>0)return t[t.length-1];const o=h.getLineCount();return w.lineNumber!==o||w.column!==h.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(h,new l.Position(o,h.getLineMaxColumn(o)),S,p):null}static _doFindPreviousMatchLineByLine(h,w,S,p){const t=h.getLineCount(),o=w.lineNumber,r=h.getLineContent(o).substring(0,w.column-1),c=this._findLastMatchInLine(S,r,o,p);if(c)return c;for(let m=1;m<=t;m++){const f=(t+o-m-1)%t,i=h.getLineContent(f+1),s=this._findLastMatchInLine(S,i,f+1,p);if(s)return s}return null}static _findLastMatchInLine(h,w,S,p){let t=null,o;for(h.reset(0);o=h.next(w);)t=R(new A.Range(S,o.index+1,S,o.index+1+o[0].length),o,p);return t}}e.TextModelSearch=_;function D(d,h,w,S,p){if(S===0)return!0;const t=h.charCodeAt(S-1);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=h.charCodeAt(S);if(d.get(o)!==0)return!0}return!1}function C(d,h,w,S,p){if(S+p===w)return!0;const t=h.charCodeAt(S+p);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=h.charCodeAt(S+p-1);if(d.get(o)!==0)return!0}return!1}function E(d,h,w,S,p){return D(d,h,w,S,p)&&C(d,h,w,S,p)}e.isValidMatch=E;class n{constructor(h,w){this._wordSeparators=h,this._searchRegex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const w=h.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===w||(S=this._searchRegex.exec(h),!S))return null;const p=S.index,t=S[0].length;if(p===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){a.getNextCodePoint(h,w,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=t,!this._wordSeparators||E(this._wordSeparators,h,w,p,t))return S}while(S);return null}}e.Searcher=n}),define(Ce[121],De([1,0,22,14]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(l||(l={}));function A(I){for(let _=0,D=I.length;_<D;_+=4){const C=I[_+0],E=I[_+1],n=I[_+2],d=I[_+3];I[_+0]=d,I[_+1]=n,I[_+2]=E,I[_+3]=C}}function T(I){const _=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return P.isLittleEndian()||A(_),a.VSBuffer.wrap(_)}function k(I){const _=I.buffer;if(P.isLittleEndian()||A(_),_.byteOffset%4===0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const D=new Uint8Array(_.byteLength);return D.set(_),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function y(I){const _=new Uint32Array(v(I));let D=0;if(_[D++]=I.id,I.type==="full")_[D++]=1,_[D++]=I.data.length,_.set(I.data,D),D+=I.data.length;else{_[D++]=2,_[D++]=I.deltas.length;for(const C of I.deltas)_[D++]=C.start,_[D++]=C.deleteCount,C.data?(_[D++]=C.data.length,_.set(C.data,D),D+=C.data.length):_[D++]=0}return T(_)}e.encodeSemanticTokensDto=y;function v(I){let _=0;if(_+=1+1,I.type==="full")_+=1+I.data.length;else{_+=1,_+=(1+1+1)*I.deltas.length;for(const D of I.deltas)D.data&&(_+=D.data.length)}return _}function R(I){const _=k(I);let D=0;const C=_[D++];if(_[D++]===1){const h=_[D++],w=_.subarray(D,D+h);return D+=h,{id:C,type:"full",data:w}}const n=_[D++],d=[];for(let h=0;h<n;h++){const w=_[D++],S=_[D++],p=_[D++];let t;p>0&&(t=_.subarray(D,D+p),D+=p),d[h]={start:w,deleteCount:S,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=R}),define(Ce[169],De([1,0,3,6]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._tokenizationSupports.set(k,y),this.handleChange([k]),(0,P.toDisposable)(()=>{this._tokenizationSupports.get(k)===y&&(this._tokenizationSupports.delete(k),this.handleChange([k]))})}get(k){return this._tokenizationSupports.get(k)||null}registerFactory(k,y){this._factories.get(k)?.dispose();const v=new A(this,k,y);return this._factories.set(k,v),(0,P.toDisposable)(()=>{const R=this._factories.get(k);!R||R!==v||(this._factories.delete(k),R.dispose())})}async getOrCreate(k){const y=this.get(k);if(y)return y;const v=this._factories.get(k);return!v||v.isResolved?null:(await v.resolve(),this.get(k))}isResolved(k){if(this.get(k))return!0;const v=this._factories.get(k);return!!(!v||v.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=l;class A extends P.Disposable{get isResolved(){return this._isResolved}constructor(k,y,v){super(),this._registry=k,this._languageId=y,this._factory=v,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await this._factory.tokenizationSupport;this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(Ce[73],De([1,0,67,2,32,169]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class T{constructor(b,g,L){this.offset=b,this.type=g,this.language=L,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=T;class k{constructor(b,g){this.tokens=b,this.endState=g,this._tokenizationResultBrand=void 0}}e.TokenizationResult=k;class y{constructor(b,g){this.tokens=b,this.endState=g,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var v;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(v=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(u){const b=new Map;b.set(0,a.Codicon.symbolMethod),b.set(1,a.Codicon.symbolFunction),b.set(2,a.Codicon.symbolConstructor),b.set(3,a.Codicon.symbolField),b.set(4,a.Codicon.symbolVariable),b.set(5,a.Codicon.symbolClass),b.set(6,a.Codicon.symbolStruct),b.set(7,a.Codicon.symbolInterface),b.set(8,a.Codicon.symbolModule),b.set(9,a.Codicon.symbolProperty),b.set(10,a.Codicon.symbolEvent),b.set(11,a.Codicon.symbolOperator),b.set(12,a.Codicon.symbolUnit),b.set(13,a.Codicon.symbolValue),b.set(15,a.Codicon.symbolEnum),b.set(14,a.Codicon.symbolConstant),b.set(15,a.Codicon.symbolEnum),b.set(16,a.Codicon.symbolEnumMember),b.set(17,a.Codicon.symbolKeyword),b.set(27,a.Codicon.symbolSnippet),b.set(18,a.Codicon.symbolText),b.set(19,a.Codicon.symbolColor),b.set(20,a.Codicon.symbolFile),b.set(21,a.Codicon.symbolReference),b.set(22,a.Codicon.symbolCustomColor),b.set(23,a.Codicon.symbolFolder),b.set(24,a.Codicon.symbolTypeParameter),b.set(25,a.Codicon.account),b.set(26,a.Codicon.issues);function g(q){let X=b.get(q);return X||(console.info("No codicon found for CompletionItemKind "+q),X=a.Codicon.symbolProperty),X}u.toIcon=g;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function H(q,X){let U=L.get(q);return typeof U>"u"&&!X&&(U=9),U}u.fromString=H})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(u){u[u.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(u){u[u.None=0]="None",u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(u){return u&&P.URI.isUri(u.uri)&&l.Range.isIRange(u.range)&&(l.Range.isIRange(u.originSelectionRange)||l.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=h;var w;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(w=e.SymbolKind||(e.SymbolKind={}));var S;(function(u){u[u.Deprecated=1]="Deprecated"})(S=e.SymbolTag||(e.SymbolTag={}));var p;(function(u){const b=new Map;b.set(0,a.Codicon.symbolFile),b.set(1,a.Codicon.symbolModule),b.set(2,a.Codicon.symbolNamespace),b.set(3,a.Codicon.symbolPackage),b.set(4,a.Codicon.symbolClass),b.set(5,a.Codicon.symbolMethod),b.set(6,a.Codicon.symbolProperty),b.set(7,a.Codicon.symbolField),b.set(8,a.Codicon.symbolConstructor),b.set(9,a.Codicon.symbolEnum),b.set(10,a.Codicon.symbolInterface),b.set(11,a.Codicon.symbolFunction),b.set(12,a.Codicon.symbolVariable),b.set(13,a.Codicon.symbolConstant),b.set(14,a.Codicon.symbolString),b.set(15,a.Codicon.symbolNumber),b.set(16,a.Codicon.symbolBoolean),b.set(17,a.Codicon.symbolArray),b.set(18,a.Codicon.symbolObject),b.set(19,a.Codicon.symbolKey),b.set(20,a.Codicon.symbolNull),b.set(21,a.Codicon.symbolEnumMember),b.set(22,a.Codicon.symbolStruct),b.set(23,a.Codicon.symbolEvent),b.set(24,a.Codicon.symbolOperator),b.set(25,a.Codicon.symbolTypeParameter);function g(L){let H=b.get(L);return H||(console.info("No codicon found for SymbolKind "+L),H=a.Codicon.symbolProperty),H}u.toIcon=g})(p=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(b){switch(b){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(b)}constructor(b){this.value=b}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var o;(function(u){function b(g){return!g||typeof g!="object"?!1:typeof g.id=="string"&&typeof g.title=="string"}u.is=b})(o=e.Command||(e.Command={}));var r;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var m;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var f;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={}));class i{constructor(b){this.createSupport=b,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(b=>{b&&b.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=i,e.TokenizationRegistry=new A.TokenizationRegistry;var s;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ce[170],De([12,13]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],De([1,0,170,14,107,18,23,152]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(Q,me,Re,Oe){this.id=Q,this.name=me,this.defaultValue=Re,this.schema=Oe}applyUpdate(Q,me){return D(Q,me)}compute(Q,me,Re){return Re}}class _{constructor(Q,me){this.newValue=Q,this.didChange=me}}e.ApplyUpdateResult=_;function D(z,Q){if(typeof z!="object"||typeof Q!="object"||!z||!Q)return new _(Q,z!==Q);if(Array.isArray(z)||Array.isArray(Q)){const Re=Array.isArray(z)&&Array.isArray(Q)&&A.equals(z,Q);return new _(Q,!Re)}let me=!1;for(const Re in Q)if(Q.hasOwnProperty(Re)){const Oe=D(z[Re],Q[Re]);Oe.didChange&&(z[Re]=Oe.newValue,me=!0)}return new _(z,me)}class C{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,me){return D(Q,me)}validate(Q){return this.defaultValue}}class E{constructor(Q,me,Re,Oe){this.id=Q,this.name=me,this.defaultValue=Re,this.schema=Oe}applyUpdate(Q,me){return D(Q,me)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,me,Re){return Re}}function n(z,Q){return typeof z>"u"?Q:z==="false"?!1:Boolean(z)}e.boolean=n;class d extends E{constructor(Q,me,Re,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Re),super(Q,me,Re,Oe)}validate(Q){return n(Q,this.defaultValue)}}function h(z,Q,me,Re){if(typeof z>"u")return Q;let Oe=parseInt(z,10);return isNaN(Oe)?Q:(Oe=Math.max(me,Oe),Oe=Math.min(Re,Oe),Oe|0)}e.clampedInt=h;class w extends E{static clampedInt(Q,me,Re,Oe){return h(Q,me,Re,Oe)}constructor(Q,me,Re,Oe,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Re,Xe.minimum=Oe,Xe.maximum=Ve),super(Q,me,Re,Xe),this.minimum=Oe,this.maximum=Ve}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class S extends E{static clamp(Q,me,Re){return Q<me?me:Q>Re?Re:Q}static float(Q,me){if(typeof Q=="number")return Q;if(typeof Q>"u")return me;const Re=parseFloat(Q);return isNaN(Re)?me:Re}constructor(Q,me,Re,Oe,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Re),super(Q,me,Re,Ve),this.validationFn=Oe}validate(Q){return this.validationFn(S.float(Q,this.defaultValue))}}class p extends E{static string(Q,me){return typeof Q!="string"?me:Q}constructor(Q,me,Re,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Re),super(Q,me,Re,Oe)}validate(Q){return p.string(Q,this.defaultValue)}}function t(z,Q,me){return typeof z!="string"||me.indexOf(z)===-1?Q:z}e.stringSet=t;class o extends E{constructor(Q,me,Re,Oe,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Oe,Ve.default=Re),super(Q,me,Re,Ve),this._allowedValues=Oe}validate(Q){return t(Q,this.defaultValue,this._allowedValues)}}class r extends I{constructor(Q,me,Re,Oe,Ve,Xe,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.enum=Ve,Ke.default=Oe),super(Q,me,Re,Ke),this._allowedValues=Ve,this._convert=Xe}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function c(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,me,Re){return Re===0?Q.accessibilitySupport:Re}}class f extends I{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(z){switch(z){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function g(z){switch(z){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class L extends C{constructor(){super(136)}compute(Q,me,Re){const Oe=["monaco-editor"];return me.get(37)&&Oe.push(me.get(37)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),me.get(71)==="default"?Oe.push("mouse-default"):me.get(71)==="copy"&&Oe.push("mouse-copy"),me.get(106)&&Oe.push("showUnused"),me.get(134)&&Oe.push("showDeprecated"),Oe.join(" ")}}class H extends d{constructor(){super(35,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,me,Re){return Re&&Q.emptySelectionClipboard}}class q extends I{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class X extends I{constructor(){super(49,"fontLigatures",X.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?X.OFF:Q==="true"?X.ON:Q:Boolean(Q)?X.ON:X.OFF}}X.OFF='"liga" off, "calt" off',X.ON='"liga" on, "calt" on',e.EditorFontLigatures=X;class U extends I{constructor(){super(52,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.TRANSLATE:Q:Boolean(Q)?U.TRANSLATE:U.OFF}compute(Q,me,Re){return Q.fontInfo.fontVariationSettings}}U.OFF="normal",U.TRANSLATE="translate",e.EditorFontVariations=U;class N extends C{constructor(){super(48)}compute(Q,me,Re){return Q.fontInfo}}class x extends E{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(Q){const me=S.float(Q,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(me,6,100)}compute(Q,me,Re){return Q.fontInfo.fontSize}}class F extends I{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class V extends I{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Re,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Re,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Re,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Re,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Re,description:a.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{multiple:t(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??t(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??t(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??t(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??t(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??t(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends I{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:w.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky),above:n(me.above,this.defaultValue.above)}}}var se;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(se=e.RenderMinimap||(e.RenderMinimap={}));class $ extends C{constructor(){super(139)}compute(Q,me,Re){return $.computeLayout(me,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const me=Q.height/Q.lineHeight,Re=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,me-1));const Ve=(Re+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),Xe=Math.floor(Q.viewLineCount/Ve);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Re,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:Xe}}static _computeMinimapLayout(Q,me){const Re=Q.outerWidth,Oe=Q.outerHeight,Ve=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const Xe=me.stableMinimapLayoutInput,Ke=Xe&&Q.outerHeight===Xe.outerHeight&&Q.lineHeight===Xe.lineHeight&&Q.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Xe.pixelRatio&&Q.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&Q.paddingTop===Xe.paddingTop&&Q.paddingBottom===Xe.paddingBottom&&Q.minimap.enabled===Xe.minimap.enabled&&Q.minimap.side===Xe.minimap.side&&Q.minimap.size===Xe.minimap.size&&Q.minimap.showSlider===Xe.minimap.showSlider&&Q.minimap.renderCharacters===Xe.minimap.renderCharacters&&Q.minimap.maxColumn===Xe.minimap.maxColumn&&Q.minimap.scale===Xe.minimap.scale&&Q.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&Q.isViewportWrapping===Xe.isViewportWrapping,rt=Q.lineHeight,ct=Q.typicalHalfwidthCharacterWidth,bt=Q.scrollBeyondLastLine,mt=Q.minimap.renderCharacters;let Et=Ve>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Dt=Q.minimap.maxColumn,Rt=Q.minimap.size,Qt=Q.minimap.side,Gt=Q.verticalScrollbarWidth,ht=Q.viewLineCount,gt=Q.remainingWidth,Lt=Q.isViewportWrapping,Ft=mt?2:3;let kt=Math.floor(Ve*Oe);const pt=kt/Ve;let yt=!1,xt=!1,It=Ft*Et,Ge=Et/Ve,$t=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Ze,desiredRatio:je,minimapLineCount:et}=$.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:bt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:rt,pixelRatio:Ve});if(ht/et>1)yt=!0,xt=!0,Et=1,It=1,Ge=Et/Ve;else{let ut=!1,Ct=Et+1;if(Rt==="fit"){const vt=Math.ceil((We+ht+Ze)*It);Lt&&Ke&&gt<=me.stableFitRemainingWidth?(ut=!0,Ct=me.stableFitMaxMinimapScale):ut=vt>kt}if(Rt==="fill"||ut){yt=!0;const vt=Et;It=Math.min(rt*Ve,Math.max(1,Math.floor(1/je))),Lt&&Ke&&gt<=me.stableFitRemainingWidth&&(Ct=me.stableFitMaxMinimapScale),Et=Math.min(Ct,Math.max(1,Math.floor(It/Ft))),Et>vt&&($t=Math.min(2,Et/vt)),Ge=Et/Ve/$t,kt=Math.ceil(Math.max(Me,We+ht+Ze)*It),Lt?(me.stableMinimapLayoutInput=Q,me.stableFitRemainingWidth=gt,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Dt*Ge),Nt=Math.min(Kt,Math.max(0,Math.floor((gt-Gt-2)*Ge/(ct+Ge)))+e.MINIMAP_GUTTER_WIDTH);let Pe=Math.floor(Ve*Nt);const Le=Pe/Ve;Pe=Math.floor(Pe*$t);const ye=mt?1:2,oe=Qt==="left"?0:Re-Nt-Gt;return{renderMinimap:ye,minimapLeft:oe,minimapWidth:Nt,minimapHeightIsEditorHeight:yt,minimapIsSampling:xt,minimapScale:Et,minimapLineHeight:It,minimapCanvasInnerWidth:Pe,minimapCanvasInnerHeight:kt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:pt}}static computeLayout(Q,me){const Re=me.outerWidth|0,Oe=me.outerHeight|0,Ve=me.lineHeight|0,Xe=me.lineNumbersDigitCount|0,Ke=me.typicalHalfwidthCharacterWidth,rt=me.maxDigitWidth,ct=me.pixelRatio,bt=me.viewLineCount,mt=Q.get(131),Et=mt==="inherit"?Q.get(130):mt,Dt=Et==="inherit"?Q.get(126):Et,Rt=Q.get(129),Qt=me.isDominatedByLongLines,Gt=Q.get(55),ht=Q.get(65).renderType!==0,gt=Q.get(66),Lt=Q.get(100),Ft=Q.get(81),kt=Q.get(70),pt=Q.get(98),yt=pt.verticalScrollbarSize,xt=pt.verticalHasArrows,It=pt.arrowSize,Ge=pt.horizontalScrollbarSize,$t=Q.get(41),Kt=Q.get(105)!=="never";let Nt=Q.get(63);$t&&Kt&&(Nt+=16);let Pe=0;if(ht){const Ut=Math.max(Xe,gt);Pe=Math.round(Ut*rt)}let Le=0;Gt&&(Le=Ve);let ye=0,oe=ye+Le,Me=oe+Pe,We=Me+Nt;const Ze=Re-Le-Pe-Nt;let je=!1,et=!1,dt=-1;Et==="inherit"&&Qt?(je=!0,et=!0):Dt==="on"||Dt==="bounded"?et=!0:Dt==="wordWrapColumn"&&(dt=Rt);const ut=$._computeMinimapLayout({outerWidth:Re,outerHeight:Oe,lineHeight:Ve,typicalHalfwidthCharacterWidth:Ke,pixelRatio:ct,scrollBeyondLastLine:Lt,paddingTop:Ft.top,paddingBottom:Ft.bottom,minimap:kt,verticalScrollbarWidth:yt,viewLineCount:bt,remainingWidth:Ze,isViewportWrapping:et},me.memory||new R);ut.renderMinimap!==0&&ut.minimapLeft===0&&(ye+=ut.minimapWidth,oe+=ut.minimapWidth,Me+=ut.minimapWidth,We+=ut.minimapWidth);const Ct=Ze-ut.minimapWidth,vt=Math.max(1,Math.floor((Ct-yt-2)/Ke)),Ot=xt?It:0;return et&&(dt=Math.max(1,vt),Dt==="bounded"&&(dt=Math.min(dt,Rt))),{width:Re,height:Oe,glyphMarginLeft:ye,glyphMarginWidth:Le,lineNumbersLeft:oe,lineNumbersWidth:Pe,decorationsLeft:Me,decorationsWidth:Nt,contentLeft:We,contentWidth:Ct,minimap:ut,viewportColumn:vt,isWordWrapMinified:je,isViewportWrapping:et,wrappingColumn:dt,verticalScrollbarWidth:yt,horizontalScrollbarHeight:Ge,overviewRuler:{top:Ot,width:yt,height:Oe-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=$;class J extends I{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(Q){return t(Q,"simple",["simple","advanced"])}compute(Q,me,Re){return me.get(2)===2?"advanced":Re}}class te extends I{constructor(){const Q={enabled:!0};super(62,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:n(Q.enabled,this.defaultValue.enabled)}}}class be extends I{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:a.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:t(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class le extends I{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:a.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(54,null),a.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:a.localize(60,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:t(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(me.fontFamily,this.defaultValue.fontFamily),padding:n(me.padding,this.defaultValue.padding)}}}class ue extends I{constructor(){super(63,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):w.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,me,Re){return Re<0?w.clampedInt(-Re*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Re}}class j extends S{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>S.clamp(Q,0,150),{markdownDescription:a.localize(61,null)})}compute(Q,me,Re){return Q.fontInfo.lineHeight}}class M extends I{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:a.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)],default:Q.size,description:a.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(69,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),autohide:n(me.autohide,this.defaultValue.autohide),size:t(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(me.side,this.defaultValue.side,["right","left"]),showSlider:t(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(me.scale,1,1,3),maxColumn:w.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(z){return z==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ge extends I{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{top:w.clampedInt(me.top,0,0,1e3),bottom:w.clampedInt(me.bottom,0,0,1e3)}}}class we extends I{constructor(){const Q={enabled:!0,cycle:!0};super(82,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class ie extends C{constructor(){super(137)}compute(Q,me,Re){return Q.pixelRatio}}class ne extends I{constructor(){const Q={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null)]}];super(85,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Q.strings,description:a.localize(80,null)},comments:{anyOf:me,default:Q.comments,description:a.localize(81,null)},other:{anyOf:me,default:Q.other,description:a.localize(82,null)}},default:Q,markdownDescription:a.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ct=Q?"on":"off";return{comments:ct,strings:ct,other:ct}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:me,comments:Re,strings:Oe}=Q,Ve=["on","inline","off"];let Xe,Ke,rt;return typeof me=="boolean"?Xe=me?"on":"off":Xe=t(me,this.defaultValue.other,Ve),typeof Re=="boolean"?Ke=Re?"on":"off":Ke=t(Re,this.defaultValue.comments,Ve),typeof Oe=="boolean"?rt=Oe?"on":"off":rt=t(Oe,this.defaultValue.strings,Ve),{other:Xe,comments:Ke,strings:rt}}}var de;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends I{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"on",description:a.localize(88,null)})}validate(Q){let me=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(me=4,Re=Q):Q==="interval"?me=3:Q==="relative"?me=2:Q==="on"?me=1:me=0),{renderType:me,renderFn:Re}}}function ce(z){const Q=z.get(93);return Q==="editable"?z.get(87):Q!=="on"}e.filterValidationDecorations=ce;class ae extends I{constructor(){const Q=[],me={type:"number",description:a.localize(89,null)};super(97,"rulers",Q,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:a.localize(90,null),format:"color-hex"}}}]},default:Q,description:a.localize(91,null)})}validate(Q){if(Array.isArray(Q)){const me=[];for(const Re of Q)if(typeof Re=="number")me.push({column:w.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const Oe=Re;me.push({column:w.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return me.sort((Re,Oe)=>Re.column-Oe.column),me}return this.defaultValue}}function O(z,Q){if(typeof z!="string")return Q;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:"auto",description:a.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:"auto",description:a.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q,Re=w.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=w.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(me.vertical,this.defaultValue.vertical),horizontal:O(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:w.clampedInt(me.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:w.clampedInt(me.verticalSliderSize,Oe,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends I{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:a.localize(109,null)}})}applyUpdate(Q,me){let Re=!1;me.allowedCharacters&&Q&&(T.equals(Q.allowedCharacters,me.allowedCharacters)||(Q={...Q,allowedCharacters:me.allowedCharacters},Re=!0)),me.allowedLocales&&Q&&(T.equals(Q.allowedLocales,me.allowedLocales)||(Q={...Q,allowedLocales:me.allowedLocales},Re=!0));const Oe=super.applyUpdate(Q,me);return Re?new _(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{nonBasicASCII:Ae(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,me){if(typeof Q!="object"||!Q)return me;const Re={};for(const[Oe,Ve]of Object.entries(Q))Ve===!0&&(Re[Oe]=!0);return Re}}class Z extends I{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!0};super(60,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(111,null),a.localize(112,null)],description:a.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:a.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:t(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(me.suppressSuggestions,this.defaultValue.suppressSuggestions)}}}class he extends I{constructor(){const Q={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:a.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:n(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _e extends I{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(117,null),a.localize(118,null),a.localize(119,null)],default:Q.bracketPairs,description:a.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],default:Q.bracketPairsHorizontal,description:a.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(127,null),a.localize(128,null),a.localize(129,null)],default:Q.highlightActiveIndentation,description:a.localize(130,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{bracketPairs:Ae(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(z,Q,me){const Re=me.indexOf(z);return Re===-1?Q:me[Re]}class Ee extends I{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(131,null),a.localize(132,null)],default:Q.insertMode,description:a.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(137,null),a.localize(138,null),a.localize(139,null),a.localize(140,null)],default:Q.selectionMode,markdownDescription:a.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertMode:t(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:t(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class ke extends I{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(179,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ie;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(Ie=e.WrappingIndent||(e.WrappingIndent={}));class He extends I{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),a.localize(183,null)],description:a.localize(184,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,me,Re){return me.get(2)===2?0:Re}}class ze extends C{constructor(){super(140)}compute(Q,me,Re){const Oe=me.get(139);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class tt extends I{constructor(){const Q={enabled:!0};super(34,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(185,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:n(Q.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?nt:P.isLinux?st:Qe,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(z){return e.editorOptionsRegistry[z.id]=z,z}var it;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",z[z.autoClosingDelete=7]="autoClosingDelete",z[z.autoClosingOvertype=8]="autoClosingOvertype",z[z.autoClosingQuotes=9]="autoClosingQuotes",z[z.autoIndent=10]="autoIndent",z[z.automaticLayout=11]="automaticLayout",z[z.autoSurround=12]="autoSurround",z[z.bracketPairColorization=13]="bracketPairColorization",z[z.guides=14]="guides",z[z.codeLens=15]="codeLens",z[z.codeLensFontFamily=16]="codeLensFontFamily",z[z.codeLensFontSize=17]="codeLensFontSize",z[z.colorDecorators=18]="colorDecorators",z[z.colorDecoratorsLimit=19]="colorDecoratorsLimit",z[z.columnSelection=20]="columnSelection",z[z.comments=21]="comments",z[z.contextmenu=22]="contextmenu",z[z.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",z[z.cursorBlinking=24]="cursorBlinking",z[z.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",z[z.cursorStyle=26]="cursorStyle",z[z.cursorSurroundingLines=27]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",z[z.cursorWidth=29]="cursorWidth",z[z.disableLayerHinting=30]="disableLayerHinting",z[z.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",z[z.domReadOnly=32]="domReadOnly",z[z.dragAndDrop=33]="dragAndDrop",z[z.dropIntoEditor=34]="dropIntoEditor",z[z.emptySelectionClipboard=35]="emptySelectionClipboard",z[z.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",z[z.extraEditorClassName=37]="extraEditorClassName",z[z.fastScrollSensitivity=38]="fastScrollSensitivity",z[z.find=39]="find",z[z.fixedOverflowWidgets=40]="fixedOverflowWidgets",z[z.folding=41]="folding",z[z.foldingStrategy=42]="foldingStrategy",z[z.foldingHighlight=43]="foldingHighlight",z[z.foldingImportsByDefault=44]="foldingImportsByDefault",z[z.foldingMaximumRegions=45]="foldingMaximumRegions",z[z.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=47]="fontFamily",z[z.fontInfo=48]="fontInfo",z[z.fontLigatures=49]="fontLigatures",z[z.fontSize=50]="fontSize",z[z.fontWeight=51]="fontWeight",z[z.fontVariations=52]="fontVariations",z[z.formatOnPaste=53]="formatOnPaste",z[z.formatOnType=54]="formatOnType",z[z.glyphMargin=55]="glyphMargin",z[z.gotoLocation=56]="gotoLocation",z[z.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",z[z.hover=58]="hover",z[z.inDiffEditor=59]="inDiffEditor",z[z.inlineSuggest=60]="inlineSuggest",z[z.letterSpacing=61]="letterSpacing",z[z.lightbulb=62]="lightbulb",z[z.lineDecorationsWidth=63]="lineDecorationsWidth",z[z.lineHeight=64]="lineHeight",z[z.lineNumbers=65]="lineNumbers",z[z.lineNumbersMinChars=66]="lineNumbersMinChars",z[z.linkedEditing=67]="linkedEditing",z[z.links=68]="links",z[z.matchBrackets=69]="matchBrackets",z[z.minimap=70]="minimap",z[z.mouseStyle=71]="mouseStyle",z[z.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=73]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",z[z.multiCursorModifier=75]="multiCursorModifier",z[z.multiCursorPaste=76]="multiCursorPaste",z[z.multiCursorLimit=77]="multiCursorLimit",z[z.occurrencesHighlight=78]="occurrencesHighlight",z[z.overviewRulerBorder=79]="overviewRulerBorder",z[z.overviewRulerLanes=80]="overviewRulerLanes",z[z.padding=81]="padding",z[z.parameterHints=82]="parameterHints",z[z.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",z[z.quickSuggestions=85]="quickSuggestions",z[z.quickSuggestionsDelay=86]="quickSuggestionsDelay",z[z.readOnly=87]="readOnly",z[z.renameOnType=88]="renameOnType",z[z.renderControlCharacters=89]="renderControlCharacters",z[z.renderFinalNewline=90]="renderFinalNewline",z[z.renderLineHighlight=91]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=93]="renderValidationDecorations",z[z.renderWhitespace=94]="renderWhitespace",z[z.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",z[z.roundedSelection=96]="roundedSelection",z[z.rulers=97]="rulers",z[z.scrollbar=98]="scrollbar",z[z.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=100]="scrollBeyondLastLine",z[z.scrollPredominantAxis=101]="scrollPredominantAxis",z[z.selectionClipboard=102]="selectionClipboard",z[z.selectionHighlight=103]="selectionHighlight",z[z.selectOnLineNumbers=104]="selectOnLineNumbers",z[z.showFoldingControls=105]="showFoldingControls",z[z.showUnused=106]="showUnused",z[z.snippetSuggestions=107]="snippetSuggestions",z[z.smartSelect=108]="smartSelect",z[z.smoothScrolling=109]="smoothScrolling",z[z.stickyScroll=110]="stickyScroll",z[z.stickyTabStops=111]="stickyTabStops",z[z.stopRenderingLineAfter=112]="stopRenderingLineAfter",z[z.suggest=113]="suggest",z[z.suggestFontSize=114]="suggestFontSize",z[z.suggestLineHeight=115]="suggestLineHeight",z[z.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",z[z.suggestSelection=117]="suggestSelection",z[z.tabCompletion=118]="tabCompletion",z[z.tabIndex=119]="tabIndex",z[z.unicodeHighlighting=120]="unicodeHighlighting",z[z.unusualLineTerminators=121]="unusualLineTerminators",z[z.useShadowDOM=122]="useShadowDOM",z[z.useTabStops=123]="useTabStops",z[z.wordBreak=124]="wordBreak",z[z.wordSeparators=125]="wordSeparators",z[z.wordWrap=126]="wordWrap",z[z.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=129]="wordWrapColumn",z[z.wordWrapOverride1=130]="wordWrapOverride1",z[z.wordWrapOverride2=131]="wordWrapOverride2",z[z.wrappingIndent=132]="wrappingIndent",z[z.wrappingStrategy=133]="wrappingStrategy",z[z.showDeprecated=134]="showDeprecated",z[z.inlayHints=135]="inlayHints",z[z.editorClassName=136]="editorClassName",z[z.pixelRatio=137]="pixelRatio",z[z.tabFocusMode=138]="tabFocusMode",z[z.layoutInfo=139]="layoutInfo",z[z.wrappingInfo=140]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(186,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(187,null),""],markdownDescription:a.localize(188,null)})),accessibilitySupport:Ue(new m),accessibilityPageSize:Ue(new w(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(189,null),tags:["accessibility"]})),ariaLabel:Ue(new p(4,"ariaLabel",a.localize(190,null))),screenReaderAnnounceInlineSuggestion:Ue(new d(6,"screenReaderAnnounceInlineSuggestion",!1,{description:a.localize(191,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(192,null),a.localize(193,null),""],description:a.localize(194,null)})),autoClosingDelete:Ue(new o(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(195,null),""],description:a.localize(196,null)})),autoClosingOvertype:Ue(new o(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(197,null),""],description:a.localize(198,null)})),autoClosingQuotes:Ue(new o(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(199,null),a.localize(200,null),""],description:a.localize(201,null)})),autoIndent:Ue(new r(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null),a.localize(206,null)],description:a.localize(207,null)})),automaticLayout:Ue(new d(11,"automaticLayout",!1)),autoSurround:Ue(new o(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(208,null),a.localize(209,null),a.localize(210,null),""],description:a.localize(211,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new _e),stickyTabStops:Ue(new d(111,"stickyTabStops",!1,{description:a.localize(212,null)})),codeLens:Ue(new d(15,"codeLens",!0,{description:a.localize(213,null)})),codeLensFontFamily:Ue(new p(16,"codeLensFontFamily","",{description:a.localize(214,null)})),codeLensFontSize:Ue(new w(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(215,null)})),colorDecorators:Ue(new d(18,"colorDecorators",!0,{description:a.localize(216,null)})),colorDecoratorsLimit:Ue(new w(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(217,null)})),columnSelection:Ue(new d(20,"columnSelection",!1,{description:a.localize(218,null)})),comments:Ue(new f),contextmenu:Ue(new d(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new d(23,"copyWithSyntaxHighlighting",!0,{description:a.localize(219,null)})),cursorBlinking:Ue(new r(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:a.localize(220,null)})),cursorSmoothCaretAnimation:Ue(new o(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(221,null),a.localize(222,null),a.localize(223,null)],description:a.localize(224,null)})),cursorStyle:Ue(new r(26,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:a.localize(225,null)})),cursorSurroundingLines:Ue(new w(27,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(226,null)})),cursorSurroundingLinesStyle:Ue(new o(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(227,null),a.localize(228,null)],description:a.localize(229,null)})),cursorWidth:Ue(new w(29,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(230,null)})),disableLayerHinting:Ue(new d(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new d(31,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new d(32,"domReadOnly",!1)),dragAndDrop:Ue(new d(33,"dragAndDrop",!0,{description:a.localize(231,null)})),emptySelectionClipboard:Ue(new H),dropIntoEditor:Ue(new tt),stickyScroll:Ue(new be),experimentalWhitespaceRendering:Ue(new o(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(232,null),a.localize(233,null),a.localize(234,null)],description:a.localize(235,null)})),extraEditorClassName:Ue(new p(37,"extraEditorClassName","")),fastScrollSensitivity:Ue(new S(38,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:a.localize(236,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new d(40,"fixedOverflowWidgets",!1)),folding:Ue(new d(41,"folding",!0,{description:a.localize(237,null)})),foldingStrategy:Ue(new o(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(238,null),a.localize(239,null)],description:a.localize(240,null)})),foldingHighlight:Ue(new d(43,"foldingHighlight",!0,{description:a.localize(241,null)})),foldingImportsByDefault:Ue(new d(44,"foldingImportsByDefault",!1,{description:a.localize(242,null)})),foldingMaximumRegions:Ue(new w(45,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(243,null)})),unfoldOnClickAfterEndOfLine:Ue(new d(46,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(244,null)})),fontFamily:Ue(new p(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(245,null)})),fontInfo:Ue(new N),fontLigatures2:Ue(new X),fontSize:Ue(new x),fontWeight:Ue(new F),fontVariations:Ue(new U),formatOnPaste:Ue(new d(53,"formatOnPaste",!1,{description:a.localize(246,null)})),formatOnType:Ue(new d(54,"formatOnType",!1,{description:a.localize(247,null)})),glyphMargin:Ue(new d(55,"glyphMargin",!0,{description:a.localize(248,null)})),gotoLocation:Ue(new V),hideCursorInOverviewRuler:Ue(new d(57,"hideCursorInOverviewRuler",!1,{description:a.localize(249,null)})),hover:Ue(new fe),inDiffEditor:Ue(new d(59,"inDiffEditor",!1)),letterSpacing:Ue(new S(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>S.clamp(z,-5,20),{description:a.localize(250,null)})),lightbulb:Ue(new te),lineDecorationsWidth:Ue(new ue),lineHeight:Ue(new j),lineNumbers:Ue(new ee),lineNumbersMinChars:Ue(new w(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new d(67,"linkedEditing",!1,{description:a.localize(251,null)})),links:Ue(new d(68,"links",!0,{description:a.localize(252,null)})),matchBrackets:Ue(new o(69,"matchBrackets","always",["always","near","never"],{description:a.localize(253,null)})),minimap:Ue(new M),mouseStyle:Ue(new o(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new S(72,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:a.localize(254,null)})),mouseWheelZoom:Ue(new d(73,"mouseWheelZoom",!1,{markdownDescription:a.localize(255,null)})),multiCursorMergeOverlapping:Ue(new d(74,"multiCursorMergeOverlapping",!0,{description:a.localize(256,null)})),multiCursorModifier:Ue(new r(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorPaste:Ue(new o(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(260,null),a.localize(261,null)],markdownDescription:a.localize(262,null)})),multiCursorLimit:Ue(new w(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(263,null)})),occurrencesHighlight:Ue(new d(78,"occurrencesHighlight",!0,{description:a.localize(264,null)})),overviewRulerBorder:Ue(new d(79,"overviewRulerBorder",!0,{description:a.localize(265,null)})),overviewRulerLanes:Ue(new w(80,"overviewRulerLanes",3,0,3)),padding:Ue(new ge),parameterHints:Ue(new we),peekWidgetDefaultFocus:Ue(new o(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(266,null),a.localize(267,null)],description:a.localize(268,null)})),definitionLinkOpensInPeek:Ue(new d(84,"definitionLinkOpensInPeek",!1,{description:a.localize(269,null)})),quickSuggestions:Ue(new ne),quickSuggestionsDelay:Ue(new w(86,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(270,null)})),readOnly:Ue(new d(87,"readOnly",!1)),renameOnType:Ue(new d(88,"renameOnType",!1,{description:a.localize(271,null),markdownDeprecationMessage:a.localize(272,null)})),renderControlCharacters:Ue(new d(89,"renderControlCharacters",!0,{description:a.localize(273,null),restricted:!0})),renderFinalNewline:Ue(new o(90,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(274,null)})),renderLineHighlight:Ue(new o(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(275,null)],description:a.localize(276,null)})),renderLineHighlightOnlyWhenFocus:Ue(new d(92,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(277,null)})),renderValidationDecorations:Ue(new o(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(278,null),a.localize(279,null),a.localize(280,null),""],description:a.localize(281,null)})),revealHorizontalRightPadding:Ue(new w(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new d(96,"roundedSelection",!0,{description:a.localize(282,null)})),rulers:Ue(new ae),scrollbar:Ue(new B),scrollBeyondLastColumn:Ue(new w(99,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(283,null)})),scrollBeyondLastLine:Ue(new d(100,"scrollBeyondLastLine",!0,{description:a.localize(284,null)})),scrollPredominantAxis:Ue(new d(101,"scrollPredominantAxis",!0,{description:a.localize(285,null)})),selectionClipboard:Ue(new d(102,"selectionClipboard",!0,{description:a.localize(286,null),included:P.isLinux})),selectionHighlight:Ue(new d(103,"selectionHighlight",!0,{description:a.localize(287,null)})),selectOnLineNumbers:Ue(new d(104,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),showUnused:Ue(new d(106,"showUnused",!0,{description:a.localize(292,null)})),showDeprecated:Ue(new d(134,"showDeprecated",!0,{description:a.localize(293,null)})),inlayHints:Ue(new le),snippetSuggestions:Ue(new o(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(294,null),a.localize(295,null),a.localize(296,null),a.localize(297,null)],description:a.localize(298,null)})),smartSelect:Ue(new ke),smoothScrolling:Ue(new d(109,"smoothScrolling",!1,{description:a.localize(299,null)})),stopRenderingLineAfter:Ue(new w(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ee),inlineSuggest:Ue(new Z),suggestFontSize:Ue(new w(114,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(300,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new w(115,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(301,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new d(116,"suggestOnTriggerCharacters",!0,{description:a.localize(302,null)})),suggestSelection:Ue(new o(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(303,null),a.localize(304,null),a.localize(305,null)],description:a.localize(306,null)})),tabCompletion:Ue(new o(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(307,null),a.localize(308,null),a.localize(309,null)],description:a.localize(310,null)})),tabIndex:Ue(new w(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new K),unusualLineTerminators:Ue(new o(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(311,null),a.localize(312,null),a.localize(313,null)],description:a.localize(314,null)})),useShadowDOM:Ue(new d(122,"useShadowDOM",!0)),useTabStops:Ue(new d(123,"useTabStops",!0,{description:a.localize(315,null)})),wordBreak:Ue(new o(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(316,null),a.localize(317,null)],description:a.localize(318,null)})),wordSeparators:Ue(new p(125,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:a.localize(319,null)})),wordWrap:Ue(new o(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(320,null),a.localize(321,null),a.localize(322,null),a.localize(323,null)],description:a.localize(324,null)})),wordWrapBreakAfterCharacters:Ue(new p(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new p(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new w(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(325,null)})),wordWrapOverride1:Ue(new o(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new L),pixelRatio:Ue(new ie),tabFocusMode:Ue(new d(138,"tabFocusMode",!1,{markdownDescription:a.localize(326,null)})),layoutInfo:Ue(new $),wrappingInfo:Ue(new ze),wrappingIndent:Ue(new He),wrappingStrategy:Ue(new J)}}),define(Ce[171],De([12,13]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[172],De([12,13]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[173],De([12,13]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[174],De([12,13]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[175],De([12,13]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[176],De([12,13]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[177],De([12,13]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ce[178],De([12,13]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ce[179],De([12,13]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[180],De([12,13]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Ce[181],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[182],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[183],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Ce[184],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[185],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[186],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[187],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[188],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[189],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[190],De([12,13]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[191],De([12,13]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[192],De([12,13]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[193],De([12,13]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ce[194],De([12,13]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Ce[195],De([12,13]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[196],De([12,13]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[197],De([12,13]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[198],De([12,13]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[199],De([12,13]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[200],De([12,13]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[201],De([12,13]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[202],De([12,13]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[203],De([1,0,8,173]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function A(...v){switch(v.length){case 1:return(0,P.localize)(0,null,v[0]);case 2:return(0,P.localize)(1,null,v[0],v[1]);case 3:return(0,P.localize)(2,null,v[0],v[1],v[2]);default:return}}const T=(0,P.localize)(3,null),k=(0,P.localize)(4,null);class y{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const I=this._start,_=this._input.substring(this._start,this._current),D={type:19,offset:this._start,lexeme:_};this._errors.push({offset:I,lexeme:_,additionalInfo:R}),this._tokens.push(D)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const I=this._input.substring(this._start,this._current),_=y._keywords.get(I);_?this._addToken(_):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,I=!1,_=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(k);return}const C=this._input.charCodeAt(R);if(I)I=!1;else if(C===47&&!_){R++;break}else C===91?_=!0:C===92?I=!0:C===93&&(_=!1);R++}for(;R<this._input.length&&y._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const D=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:D,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}y._regexFlags=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0))),y._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=y}),function(){"use strict";function re(e,a,P){function l(T,k){const y=A(T,k),v=[y];return e.isAbsolute(y)||v.unshift(P),e.resolve(...v)}function A(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,k);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(I,"AppData","Roaming")}break;case"darwin":v=e.join(a.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(a.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,k)}return{getUserDataPath:l}}if(typeof define=="function")define(Ce[204],De([328,72,33]),function(e,a,P){return re(e,a,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),a=require("os");module.exports=re(e,a,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ce[205],De([1,0,24,38,175,329]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=y;function v(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=v;function R(d){if(!d)return null;const h=d.majorBase,w=d.majorMustEqual,S=d.minorBase;let p=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(h===0||(p=!1),o=!1);let r=0;if(d.preRelease){const c=k.exec(d.preRelease);if(c){const[,m,f,i]=c;r=Date.UTC(Number(m),Number(f)-1,Number(i))}}return{majorBase:h,majorMustEqual:w,minorBase:S,minorMustEqual:p,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function I(d,h,w){let S;typeof d=="string"?S=R(v(d)):S=d;let p;h instanceof Date?p=h.getTime():typeof h=="string"&&(p=new Date(h).getTime());let t;if(typeof w=="string"?t=R(v(w)):t=w,!S||!t)return!1;const o=S.majorBase,r=S.minorBase,c=S.patchBase;let m=t.majorBase,f=t.minorBase,i=t.patchBase;const s=t.notBefore;let u=t.majorMustEqual,b=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?o>m?!0:o<m?!1:r>f?!0:r<f||p&&p<s?!1:c>=i:(o===1&&m===0&&(!u||!b||!g)&&(m=1,f=0,i=0,u=!0,b=!1,g=!1),o<m?!1:o>m?!u:r<f?!1:r>f?!b:c<i?!1:c>i?!g:!(p&&p<s))}e.isValidVersion=I;function _(d,h,w,S,p){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([P.default.Error,l.localize(0,null)]),t;if(typeof S.name!="string")return t.push([P.default.Error,l.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([P.default.Error,l.localize(2,null,"version")]),t;if(!S.engines)return t.push([P.default.Error,l.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([P.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!n(S.extensionDependencies))return t.push([P.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!n(S.activationEvents))return t.push([P.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([P.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([P.default.Warning,l.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([P.default.Error,l.localize(9,null,"main")]),t;{const c=(0,a.joinPath)(w,S.main);(0,a.isEqualOrParent)(c,w)||t.push([P.default.Warning,l.localize(10,null,c.path,w.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([P.default.Error,l.localize(11,null,"browser")]),t;{const c=(0,a.joinPath)(w,S.browser);(0,a.isEqualOrParent)(c,w)||t.push([P.default.Warning,l.localize(12,null,c.path,w.path)])}}if(!A.valid(S.version))return t.push([P.default.Error,l.localize(13,null)]),t;const o=[];if(!D(d,h,S,p,o))for(const c of o)t.push([P.default.Error,c]);return t}e.validateExtensionManifest=_;function D(d,h,w,S,p){return S||typeof w.main>"u"&&typeof w.browser>"u"?!0:E(d,h,w.engines.vscode,p)}e.isValidExtensionVersion=D;function C(d,h,w){return d==="*"||E(h,w,d)}e.isEngineValid=C;function E(d,h,w,S=[]){const p=R(v(w));if(!p)return S.push(l.localize(14,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return S.push(l.localize(15,null,w)),!1}else if(!p.majorMustEqual)return S.push(l.localize(16,null,w)),!1;return I(d,h,p)?!0:(S.push(l.localize(17,null,d,w)),!1)}function n(d){if(!Array.isArray(d))return!1;for(let h=0,w=d.length;h<w;h++)if(typeof d[h]!="string")return!1;return!0}}),define(Ce[90],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(l,A=[],T=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=a}),define(Ce[91],De([1,0,90]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var l;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function A(k,y,v){y instanceof a.SyncDescriptor||(y=new a.SyncDescriptor(y,[],Boolean(v))),P.push([k,y])}e.registerSingleton=A;function T(){return P}e.getSingletonServiceDescriptors=T}),define(Ce[206],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class P{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const k=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(T);k.outgoing.set(y.key,y),y.incoming.set(k.key,k)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const k of this._nodes.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let k=this._nodes.get(T);return k||(k=new a(T,A),this._nodes.set(T,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,k]of this._nodes)A.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const k=new Set([A]),y=this._findCycle(T,k);if(y)return y}}_findCycle(A,T){for(const[k,y]of A.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const v=this._findCycle(y,T);if(v)return v;T.delete(k)}}}e.Graph=P}),define(Ce[4],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(a=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function P(T,k,y){k[a.DI_TARGET]===k?k[a.DI_DEPENDENCIES].push({id:T,index:y}):(k[a.DI_DEPENDENCIES]=[{id:T,index:y}],k[a.DI_TARGET]=k)}function l(T){if(a.serviceIds.has(T))return a.serviceIds.get(T);const k=function(y,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(k,y,R)};return k.toString=()=>T,a.serviceIds.set(T,k),k}e.createDecorator=l;function A(T){return T}e.refineServiceDecorator=A}),define(Ce[54],De([1,0,10,2,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof P.URI)}e.isConfigurationOverrides=A;function T(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=T;var k;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function v(n,d){const h=Object.create(null);for(const w in n)R(h,w,n[w],d);return h}e.toValuesTree=v;function R(n,d,h,w){const S=d.split("."),p=S.pop();let t=n;for(let o=0;o<S.length;o++){const r=S[o];let c=t[r];switch(typeof c){case"undefined":c=t[r]=Object.create(null);break;case"object":break;default:w(`Ignoring ${d} as ${S.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[p]=h}catch{w(`Ignoring ${d} as ${S.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${d} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=R;function I(n,d){const h=d.split(".");_(n,h)}e.removeFromValueTree=I;function _(n,d){const h=d.shift();if(d.length===0){delete n[h];return}if(Object.keys(n).indexOf(h)!==-1){const w=n[h];typeof w=="object"&&!Array.isArray(w)&&(_(w,d),Object.keys(w).length===0&&delete n[h])}}function D(n,d,h){function w(t,o){let r=t;for(const c of o){if(typeof r!="object"||r===null)return;r=r[c]}return r}const S=d.split("."),p=w(n,S);return typeof p>"u"?h:p}e.getConfigurationValue=D;function C(n,d,h){Object.keys(d).forEach(w=>{w!=="__proto__"&&(w in n?a.isObject(n[w])&&a.isObject(d[w])?C(n[w],d[w],h):h&&(n[w]=d[w]):n[w]=d[w])})}e.merge=C;function E(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Ce[44],De([1,0,14,9,203,4,172,8]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",a.isMacintosh),y.set("isLinux",a.isLinux),y.set("isWindows",a.isWindows),y.set("isWeb",a.isWeb),y.set("isMacNative",a.isMacintosh&&!a.isWeb),y.set("isEdge",a.isEdge),y.set("isFirefox",a.isFirefox),y.set("isChrome",a.isChrome),y.set("isSafari",a.isSafari);function v(j,M){if(y.get(j)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(j,M)}e.setConstant=v;const R=Object.prototype.hasOwnProperty;var I;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));const _={regexParsingWithErrorRecovery:!0},D=(0,T.localize)(0,null),C=(0,T.localize)(1,null),E=(0,T.localize)(2,null),n=(0,T.localize)(3,null),d=(0,T.localize)(4,null),h=(0,T.localize)(5,null),w=(0,T.localize)(6,null),S=(0,T.localize)(7,null);class p{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(M=_){this._config=M,this._scanner=new l.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(M){if(M===""){this._parsingErrors.push({message:D,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(M).scan(),this._current=0,this._parsingErrors=[];try{const Y=this._expr();if(!this._isAtEnd()){const ge=this._peek(),we=ge.type===17?h:void 0;throw this._parsingErrors.push({message:d,offset:ge.offset,lexeme:l.Scanner.getLexeme(ge),additionalInfo:we}),p._parseError}return Y}catch(Y){if(Y!==p._parseError)throw Y;return}}_expr(){return this._or()}_or(){const M=[this._and()];for(;this._matchOne(16);){const Y=this._and();M.push(Y)}return M.length===1?M[0]:t.or(...M)}_and(){const M=[this._term()];for(;this._matchOne(15);){const Y=this._term();M.push(Y)}return M.length===1?M[0]:t.and(...M)}_term(){if(this._matchOne(2)){const M=this._peek();switch(M.type){case 11:return this._advance(),m.INSTANCE;case 12:return this._advance(),f.INSTANCE;case 0:{this._advance();const Y=this._expr();return this._consume(1,n),Y?.negate()}case 17:return this._advance(),L.create(M.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",M)}}return this._primary()}_primary(){const M=this._peek();switch(M.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const Y=this._expr();return this._consume(1,n),Y}case 17:{const Y=M.lexeme;if(this._advance(),this._matchOne(9)){const we=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),we.type!==10)throw this._errExpectedButGot("REGEX",we);const ie=we.lexeme,ne=ie.lastIndexOf("/"),de=ne===ie.length-1?void 0:this._removeFlagsGY(ie.substring(ne+1));let ee;try{ee=new RegExp(ie.substring(1,ne),de)}catch{throw this._errExpectedButGot("REGEX",we)}return x.create(Y,ee)}switch(we.type){case 10:case 19:{const ie=[we.lexeme];this._advance();let ne=this._peek(),de=0;for(let B=0;B<we.lexeme.length;B++)we.lexeme.charCodeAt(B)===40?de++:we.lexeme.charCodeAt(B)===41&&de--;for(;!this._isAtEnd()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let B=0;B<ne.lexeme.length;B++)ne.lexeme.charCodeAt(B)===40?de++:we.lexeme.charCodeAt(B)===41&&de--}if(de<0)break;ie.push(l.Scanner.getLexeme(ne)),this._advance(),ne=this._peek()}const ee=ie.join(""),ce=ee.lastIndexOf("/"),ae=ce===ee.length-1?void 0:this._removeFlagsGY(ee.substring(ce+1));let O;try{O=new RegExp(ee.substring(1,ce),ae)}catch{throw this._errExpectedButGot("REGEX",we)}return t.regex(Y,O)}case 18:{const ie=we.lexeme;this._advance();let ne=null;if(!(0,P.isFalsyOrWhitespace)(ie)){const de=ie.indexOf("/"),ee=ie.lastIndexOf("/");if(de!==ee&&de>=0){const ce=ie.slice(de+1,ee),ae=ie[ee+1]==="i"?"i":"";try{ne=new RegExp(ce,ae)}catch{throw this._errExpectedButGot("REGEX",we)}}}if(ne===null)throw this._errExpectedButGot("REGEX",we);return x.create(Y,ne)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const we=this._value();return t.notIn(Y,we)}switch(this._peek().type){case 3:{this._advance();const we=this._value();if(this._previous().type===18)return t.equals(Y,we);switch(we){case"true":return t.has(Y);case"false":return t.not(Y);default:return t.equals(Y,we)}}case 4:{this._advance();const we=this._value();if(this._previous().type===18)return t.notEquals(Y,we);switch(we){case"true":return t.not(Y);case"false":return t.has(Y);default:return t.notEquals(Y,we)}}case 5:return this._advance(),U.create(Y,this._value());case 6:return this._advance(),N.create(Y,this._value());case 7:return this._advance(),q.create(Y,this._value());case 8:return this._advance(),X.create(Y,this._value());case 13:return this._advance(),t.in(Y,this._value());default:return t.has(Y)}}case 20:throw this._parsingErrors.push({message:w,offset:M.offset,lexeme:"",additionalInfo:S}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const M=this._peek();switch(M.type){case 17:case 18:return this._advance(),M.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(M){return M.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(M){return this._check(M)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(M,Y){if(this._check(M))return this._advance();throw this._errExpectedButGot(Y,this._peek())}_errExpectedButGot(M,Y,ge){const we=(0,T.localize)(8,null,M,l.Scanner.getLexeme(Y)),ie=Y.offset,ne=l.Scanner.getLexeme(Y);return this._parsingErrors.push({message:we,offset:ie,lexeme:ne,additionalInfo:ge}),p._parseError}_check(M){return this._peek().type===M}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}p._parseError=new Error,e.Parser=p;class t{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(M){return i.create(M)}static equals(M,Y){return s.create(M,Y)}static notEquals(M,Y){return g.create(M,Y)}static regex(M,Y){return x.create(M,Y)}static in(M,Y){return u.create(M,Y)}static notIn(M,Y){return b.create(M,Y)}static not(M){return L.create(M)}static and(...M){return fe.create(M,null,!0)}static or(...M){return se.create(M,null,!0)}static greater(M,Y){return q.create(M,Y)}static greaterEquals(M,Y){return X.create(M,Y)}static smaller(M,Y){return U.create(M,Y)}static smallerEquals(M,Y){return N.create(M,Y)}static deserialize(M){return M==null?void 0:this._parser.parse(M)}}t._parser=new p({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function o(j){const M=new p({regexParsingWithErrorRecovery:!1});return j.map(Y=>(M.parse(Y),M.lexingErrors.length>0?M.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,T.localize)(9,null,ge.additionalInfo):(0,T.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.validateWhenClauses=o;function r(j,M){const Y=j?j.substituteConstants():void 0,ge=M?M.substituteConstants():void 0;return!Y&&!ge?!0:!Y||!ge?!1:Y.equals(ge)}e.expressionsAreEqualWithConstantSubstitution=r;function c(j,M){return j.cmp(M)}class m{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return f.INSTANCE}}m.INSTANCE=new m,e.ContextKeyFalseExpr=m;class f{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return m.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class i{static create(M,Y=null){const ge=y.get(M);return typeof ge=="boolean"?ge?f.INSTANCE:m.INSTANCE:new i(M,Y)}constructor(M,Y){this.key=M,this.negated=Y,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:J(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=y.get(this.key);return typeof M=="boolean"?M?f.INSTANCE:m.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.negated||(this.negated=L.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=i;class s{static create(M,Y,ge=null){if(typeof Y=="boolean")return Y?i.create(M,ge):L.create(M,ge);const we=y.get(M);return typeof we=="boolean"?Y===(we?"true":"false")?f.INSTANCE:m.INSTANCE:new s(M,Y,ge)}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=y.get(this.key);if(typeof M=="boolean"){const Y=M?"true":"false";return this.value===Y?f.INSTANCE:m.INSTANCE}return this}evaluate(M){return M.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(M){return M.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class u{static create(M,Y){return new u(M,Y)}constructor(M,Y){this.key=M,this.valueKey=Y,this.type=10,this.negated=null}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.valueKey,M.key,M.valueKey)}equals(M){return M.type===this.type?this.key===M.key&&this.valueKey===M.valueKey:!1}substituteConstants(){return this}evaluate(M){const Y=M.getValue(this.valueKey),ge=M.getValue(this.key);return Array.isArray(Y)?Y.includes(ge):typeof ge=="string"&&typeof Y=="object"&&Y!==null?R.call(Y,ge):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(M){return M.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=u;class b{static create(M,Y){return new b(M,Y)}constructor(M,Y){this.key=M,this.valueKey=Y,this.type=11,this._negated=u.create(M,Y)}cmp(M){return M.type!==this.type?this.type-M.type:this._negated.cmp(M._negated)}equals(M){return M.type===this.type?this._negated.equals(M._negated):!1}substituteConstants(){return this}evaluate(M){return!this._negated.evaluate(M)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(M){return M.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class g{static create(M,Y,ge=null){if(typeof Y=="boolean")return Y?L.create(M,ge):i.create(M,ge);const we=y.get(M);return typeof we=="boolean"?Y===(we?"true":"false")?m.INSTANCE:f.INSTANCE:new g(M,Y,ge)}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){const M=y.get(this.key);if(typeof M=="boolean"){const Y=M?"true":"false";return this.value===Y?m.INSTANCE:f.INSTANCE}return this}evaluate(M){return M.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(M){return M.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class L{static create(M,Y=null){const ge=y.get(M);return typeof ge=="boolean"?ge?m.INSTANCE:f.INSTANCE:new L(M,Y)}constructor(M,Y){this.key=M,this.negated=Y,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:J(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=y.get(this.key);return typeof M=="boolean"?M?m.INSTANCE:f.INSTANCE:this}evaluate(M){return!M.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(M){return M.mapNot(this.key)}negate(){return this.negated||(this.negated=i.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=L;function H(j,M){if(typeof j=="string"){const Y=parseFloat(j);isNaN(Y)||(j=Y)}return typeof j=="string"||typeof j=="number"?M(j):m.INSTANCE}class q{static create(M,Y,ge=null){return H(Y,we=>new q(M,we,ge))}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=q;class X{static create(M,Y,ge=null){return H(Y,we=>new X(M,we,ge))}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(M){return M.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=X;class U{static create(M,Y,ge=null){return H(Y,we=>new U(M,we,ge))}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class N{static create(M,Y,ge=null){return H(Y,we=>new N(M,we,ge))}constructor(M,Y,ge){this.key=M,this.value=Y,this.negated=ge,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:te(this.key,this.value,M.key,M.value)}equals(M){return M.type===this.type?this.key===M.key&&this.value===M.value:!1}substituteConstants(){return this}evaluate(M){return typeof this.value=="string"?!1:parseFloat(M.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(M){return M.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=q.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class x{static create(M,Y){return new x(M,Y)}constructor(M,Y){this.key=M,this.regexp=Y,this.type=7,this.negated=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.key<M.key)return-1;if(this.key>M.key)return 1;const Y=this.regexp?this.regexp.source:"",ge=M.regexp?M.regexp.source:"";return Y<ge?-1:Y>ge?1:0}equals(M){if(M.type===this.type){const Y=this.regexp?this.regexp.source:"",ge=M.regexp?M.regexp.source:"";return this.key===M.key&&Y===ge}return!1}substituteConstants(){return this}evaluate(M){const Y=M.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const M=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${M}`}keys(){return[this.key]}map(M){return M.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyRegexExpr=x;class F{static create(M){return new F(M)}constructor(M){this._actual=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this._actual.cmp(M._actual)}equals(M){return M.type===this.type?this._actual.equals(M._actual):!1}substituteConstants(){return this}evaluate(M){return!this._actual.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(M){return new F(this._actual.map(M))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=F;function V(j){let M=null;for(let Y=0,ge=j.length;Y<ge;Y++){const we=j[Y].substituteConstants();if(j[Y]!==we&&M===null){M=[];for(let ie=0;ie<Y;ie++)M[ie]=j[ie]}M!==null&&(M[Y]=we)}return M===null?j:M}class fe{static create(M,Y,ge){return fe._normalizeArr(M,Y,ge)}constructor(M,Y){this.expr=M,this.negated=Y,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Y=0,ge=this.expr.length;Y<ge;Y++){const we=c(this.expr[Y],M.expr[Y]);if(we!==0)return we}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Y=0,ge=this.expr.length;Y<ge;Y++)if(!this.expr[Y].equals(M.expr[Y]))return!1;return!0}return!1}substituteConstants(){const M=V(this.expr);return M===this.expr?this:fe.create(M,this.negated,!1)}evaluate(M){for(let Y=0,ge=this.expr.length;Y<ge;Y++)if(!this.expr[Y].evaluate(M))return!1;return!0}static _normalizeArr(M,Y,ge){const we=[];let ie=!1;for(const ne of M)if(!!ne){if(ne.type===1){ie=!0;continue}if(ne.type===0)return m.INSTANCE;if(ne.type===6){we.push(...ne.expr);continue}we.push(ne)}if(we.length===0&&ie)return f.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(c);for(let ne=1;ne<we.length;ne++)we[ne-1].equals(we[ne])&&(we.splice(ne,1),ne--);if(we.length===1)return we[0];for(;we.length>1;){const ne=we[we.length-1];if(ne.type!==9)break;we.pop();const de=we.pop(),ee=we.length===0,ce=se.create(ne.expr.map(ae=>fe.create([ae,de],null,ge)),null,ee);ce&&(we.push(ce),we.sort(c))}if(we.length===1)return we[0];if(ge){for(let ne=0;ne<we.length;ne++)for(let de=ne+1;de<we.length;de++)if(we[ne].negate().equals(we[de]))return m.INSTANCE;if(we.length===1)return we[0]}return new fe(we,Y)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const Y of this.expr)M.push(...Y.keys());return M}map(M){return new fe(this.expr.map(Y=>Y.map(M)),null)}negate(){if(!this.negated){const M=[];for(const Y of this.expr)M.push(Y.negate());this.negated=se.create(M,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class se{static create(M,Y,ge){return se._normalizeArr(M,Y,ge)}constructor(M,Y){this.expr=M,this.negated=Y,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Y=0,ge=this.expr.length;Y<ge;Y++){const we=c(this.expr[Y],M.expr[Y]);if(we!==0)return we}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Y=0,ge=this.expr.length;Y<ge;Y++)if(!this.expr[Y].equals(M.expr[Y]))return!1;return!0}return!1}substituteConstants(){const M=V(this.expr);return M===this.expr?this:se.create(M,this.negated,!1)}evaluate(M){for(let Y=0,ge=this.expr.length;Y<ge;Y++)if(this.expr[Y].evaluate(M))return!0;return!1}static _normalizeArr(M,Y,ge){let we=[],ie=!1;if(M){for(let ne=0,de=M.length;ne<de;ne++){const ee=M[ne];if(!!ee){if(ee.type===0){ie=!0;continue}if(ee.type===1)return f.INSTANCE;if(ee.type===9){we=we.concat(ee.expr);continue}we.push(ee)}}if(we.length===0&&ie)return m.INSTANCE;we.sort(c)}if(we.length!==0){if(we.length===1)return we[0];for(let ne=1;ne<we.length;ne++)we[ne-1].equals(we[ne])&&(we.splice(ne,1),ne--);if(we.length===1)return we[0];if(ge){for(let ne=0;ne<we.length;ne++)for(let de=ne+1;de<we.length;de++)if(we[ne].negate().equals(we[de]))return f.INSTANCE;if(we.length===1)return we[0]}return new se(we,Y)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const Y of this.expr)M.push(...Y.keys());return M}map(M){return new se(this.expr.map(Y=>Y.map(M)),null)}negate(){if(!this.negated){const M=[];for(const Y of this.expr)M.push(Y.negate());for(;M.length>1;){const Y=M.shift(),ge=M.shift(),we=[];for(const ie of ue(Y))for(const ne of ue(ge))we.push(fe.create([ie,ne],null,!1));M.unshift(se.create(we,null,!1))}this.negated=se.create(M,this,!0)}return this.negated}}e.ContextKeyOrExpr=se;class $ extends i{static all(){return $._info.values()}constructor(M,Y,ge){super(M,null),this._defaultValue=Y,typeof ge=="object"?$._info.push({...ge,key:M}):ge!==!0&&$._info.push({key:M,description:ge,type:Y!=null?typeof Y:void 0})}bindTo(M){return M.createKey(this.key,this._defaultValue)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return s.create(this.key,M)}notEqualsTo(M){return g.create(this.key,M)}}$._info=[],e.RawContextKey=$,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function J(j,M){return j<M?-1:j>M?1:0}function te(j,M,Y,ge){return j<Y?-1:j>Y?1:M<ge?-1:M>ge?1:0}function be(j,M){if(j.type===0||M.type===1)return!0;if(j.type===9)return M.type===9?le(j.expr,M.expr):!1;if(M.type===9){for(const Y of M.expr)if(be(j,Y))return!0;return!1}if(j.type===6){if(M.type===6)return le(M.expr,j.expr);for(const Y of j.expr)if(be(Y,M))return!0;return!1}return j.equals(M)}e.implies=be;function le(j,M){let Y=0,ge=0;for(;Y<j.length&&ge<M.length;){const we=j[Y].cmp(M[ge]);if(we<0)return!1;we===0&&Y++,ge++}return Y===j.length}function ue(j){return j.type===9?j.expr:[j]}}),define(Ce[207],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[123],De([1,0,174,4]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(h,w){switch(h){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function k(h,w){return w==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function y(h,w,S){return k(w,S)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===S?!0:v(S).includes(h)}e.isTargetPlatformCompatible=y;function v(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var _;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var D;(function(h){h.Install="install",h.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var C;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var E;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var n;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class d extends Error{constructor(w,S){super(w),this.code=S,this.name=S}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(Ce[208],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Ce[209],De([1,0,47,17,15,14,110,29,117,176,208]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=v.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends _{openTerminal(S,p){return this.spawnTerminal(a,S,y.getWindowsShell(),p)}spawnTerminal(S,p,t,o){const r=p.windowsExec||D.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=l.basename(r,".exe").toLowerCase();if(c==="cmder")return S.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const m=["/c","start","/wait"];return r.indexOf(" ")>=0&&m.push('""'),m.push(r),c==="wt"&&m.push("-d ."),new Promise((f,i)=>{const s=n(process),u=S.spawn(t,m,{cwd:o,env:s});u.on("error",i),u.on("exit",()=>f())})}runInTerminal(S,p,t,o,r){const c="windowsExec"in r&&r.windowsExec?r.windowsExec:D.getDefaultTerminalWindows();return new Promise((m,f)=>{const i=`"${p} - ${I}"`,s=`""${t.join('" "')}" & pause"`,u=Object.assign({},n(process),o);Object.keys(u).filter(q=>u[q]===null).forEach(q=>delete u[q]);const b={cwd:p,env:u,windowsVerbatimArguments:!0};let g,L;l.basename(c,".exe")==="wt"?(g=c,L=["-d",".",D.CMD,"/c",s]):(g=D.CMD,L=["/c","start",i,"/wait",c,"/c",s]),a.spawn(g,L,b).on("error",q=>{f(d(q))}),m(void 0)})}static getDefaultTerminalWindows(){if(!D._DEFAULT_TERMINAL_WINDOWS){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return D._DEFAULT_TERMINAL_WINDOWS}}D.CMD="cmd.exe",e.WindowsExternalTerminalService=D;class C extends _{openTerminal(S,p){return this.spawnTerminal(a,S,p)}runInTerminal(S,p,t,o,r){const c=r.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((m,f)=>{if(c===R.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const i=c===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",S||I,"-w",p];for(const L of t)u.push("-a"),u.push(L);if(o){const L=Object.assign({},n(process),o);for(const H in L){const q=L[H];q===null?(u.push("-u"),u.push(H)):(u.push("-e"),u.push(`${H}=${q}`))}}let b="";const g=a.spawn(C.OSASCRIPT,u);g.on("error",L=>{f(d(L))}),g.stderr.on("data",L=>{b+=L.toString()}),g.on("exit",L=>{if(L===0)m(void 0);else if(b){const H=b.split(`
`,1);f(new Error(H[0]))}else f(new Error(v.localize(1,null,i,L)))})}else f(new Error(v.localize(2,null,c)))})}spawnTerminal(S,p,t){const o=p.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{const m=["-a",o];t&&m.push(t);const f=n(process),i=S.spawn("/usr/bin/open",m,{cwd:t,env:f});i.on("error",c),i.on("exit",()=>r())})}}C.OSASCRIPT="/usr/bin/osascript",e.MacExternalTerminalService=C;class E extends _{openTerminal(S,p){return this.spawnTerminal(a,S,p)}runInTerminal(S,p,t,o,r){const c=r.linuxExec?Promise.resolve(r.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((m,f)=>{const i=[];c.then(s=>{s.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const u=`${h(t)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;i.push(`''${u}''`);const b=Object.assign({},n(process),o);Object.keys(b).filter(q=>b[q]===null).forEach(q=>delete b[q]);const g={cwd:p,env:b};let L="";const H=a.spawn(s,i,g);H.on("error",q=>{f(d(q))}),H.stderr.on("data",q=>{L+=q.toString()}),H.on("exit",q=>{if(q===0)m(void 0);else if(L){const X=L.split(`
`,1);f(new Error(X[0]))}else f(new Error(v.localize(4,null,s,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const S=await k.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{S?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(S,p,t){const o=p.linuxExec?Promise.resolve(p.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{o.then(m=>{const f=n(process),i=S.spawn(m,[],{cwd:t,env:f});i.on("error",c),i.on("exit",()=>r())})})}}E.WAIT_MESSAGE=v.localize(3,null),e.LinuxExternalTerminalService=E;function n(w){const S={...w.env};return(0,T.sanitizeProcessEnvironment)(S),S}function d(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(v.localize(5,null,w.path)):w}function h(w){let S="";for(const p of w)p.indexOf(" ")>=0?S+='"'+p+'"':S+=p,S+=" ";return S}}),define(Ce[45],De([1,0,69,15,9,10,2,177,4,14,17]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I($){return $.create===!0}e.isFileOpenForWriteOptions=I;var _;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(_=e.FileType||(e.FileType={}));var D;(function($){$[$.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var C;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E($){return!!($.capabilities&2)}e.hasReadWriteCapability=E;function n($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=n;function d($){return!!($.capabilities&32768)}e.hasFileCloneCapability=d;function h($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function w($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=w;function S($){return E($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var p;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(J,te){const be=new t(J.toString(),te);return c(be,te),be}constructor(J,te){super(J),this.code=te}}e.FileSystemProviderError=t;function o($,J){return t.create($,J)}e.createFileSystemProviderError=o;function r($){return $||o((0,k.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function c($,J){return $.name=J?`${J} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=c;function m($){if(!$)return p.Unknown;if($ instanceof t)return $.code;const J=/^(.+) \(FileSystemError\)$/.exec($.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=m;function f($){if($ instanceof L)return $.fileOperationResult;switch(m($)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(J,te,be){this.resource=J,this.operation=te,this.target=be}isOperation(J){return this.operation===J}}e.FileOperationEvent=s;var u;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class b{constructor(J,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const be=new Map;for(const le of J){const ue=be.get(le.type);switch(ue?ue.push([le.resource,le]):be.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,ue]of be)switch(le){case 1:this.added=a.TernarySearchTree.forUris(()=>te),this.added.fill(ue);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>te),this.updated.fill(ue);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>te),this.deleted.fill(ue);break}}contains(J,...te){return this.doContains(J,{includeChildren:!1},...te)}affects(J,...te){return this.doContains(J,{includeChildren:!0},...te)}doContains(J,te,...be){if(!J)return!1;const le=be.length>0;return!!((!le||be.includes(1))&&(this.added?.get(J)||te.includeChildren&&this.added?.findSuperstr(J))||(!le||be.includes(0))&&(this.updated?.get(J)||te.includeChildren&&this.updated?.findSuperstr(J))||(!le||be.includes(2))&&(this.deleted?.findSubstr(J)||te.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=b;function g($,J,te){return!$||!J||$===J||J.length>$.length?!1:(J.charAt(J.length-1)!==P.sep&&(J+=P.sep),te?(0,l.startsWithIgnoreCase)($,J):$.indexOf(J)===0)}e.isParent=g;class L extends Error{constructor(J,te,be){super(J),this.fileOperationResult=te,this.options=be}}e.FileOperationError=L;class H extends L{constructor(J,te,be,le){super(J,te,le),this.fileOperationResult=te,this.size=be}}e.TooLargeFileOperationError=H;class q extends L{constructor(J,te,be){super(J,2,be),this.stat=te}}e.NotModifiedSinceFileOperationError=q;var X;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=N;async function x($,J){if(!J.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(te=>{const be=J.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===$.scheme&&le.added&&(be.dispose(),te())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(J){return(0,A.isNumber)(J)||(J=0),J<F.KB?(0,k.localize)(1,null,J.toFixed(0)):J<F.MB?(0,k.localize)(2,null,(J/F.KB).toFixed(2)):J<F.GB?(0,k.localize)(3,null,(J/F.MB).toFixed(2)):J<F.TB?(0,k.localize)(4,null,(J/F.GB).toFixed(2)):(0,k.localize)(5,null,(J/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function fe($){return{maxFileSize:$===0?300*F.MB:16*F.GB,maxHeapSize:$===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=fe;function se($){const J=typeof $=="string"||$?.scheme===R.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===R.Schemas.file?1024*F.MB:J?10*F.MB:v.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=se}),define(Ce[92],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...l){this._entries=new Map;for(const[A,T]of l)this.set(A,T)}set(l,A){const T=this._entries.get(l);return this._entries.set(l,A),T}has(l){return this._entries.has(l)}get(l){return this._entries.get(l)}}e.ServiceCollection=a}),define(Ce[210],De([1,0,19,8,6,90,206,4,92,66]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class I extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class _{constructor(n=new y.ServiceCollection,d=!1,h,w=R){this._services=n,this._strict=d,this._parent=h,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(k.IInstantiationService,this),this._globalGraph=w?h?._globalGraph??new T.Graph(S=>S):void 0}createChild(n){return new _(n,this._strict,this,this._enableTracing)}invokeFunction(n,...d){const h=C.traceInvocation(this._enableTracing,n);let w=!1;try{return n({get:p=>{if(w)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(p,h);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...d)}finally{w=!0,h.stop()}}createInstance(n,...d){let h,w;return n instanceof A.SyncDescriptor?(h=C.traceCreation(this._enableTracing,n.ctor),w=this._createInstance(n.ctor,n.staticArguments.concat(d),h)):(h=C.traceCreation(this._enableTracing,n),w=this._createInstance(n,d,h)),h.stop(),w}_createInstance(n,d=[],h){const w=k._util.getServiceDependencies(n).sort((t,o)=>t.index-o.index),S=[];for(const t of w){const o=this._getOrCreateServiceInstance(t.id,h);o||this._throwIfStrict(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(o)}const p=w.length>0?w[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${n.name} at position ${p+1} conflicts with ${d.length} static arguments`);const t=p-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,p)}return Reflect.construct(n,d.concat(S))}_setServiceInstance(n,d){if(this._services.get(n)instanceof A.SyncDescriptor)this._services.set(n,d);else if(this._parent)this._parent._setServiceInstance(n,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(n){const d=this._services.get(n);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(n):d}_getOrCreateServiceInstance(n,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(n));const h=this._getServiceInstanceOrDescriptor(n);return h instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(n,h,d.branch(n,!0)):(d.branch(n,!1),h)}_safeCreateAndCacheServiceInstance(n,d,h){if(this._activeInstantiations.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this._activeInstantiations.add(n);try{return this._createAndCacheServiceInstance(n,d,h)}finally{this._activeInstantiations.delete(n)}}_createAndCacheServiceInstance(n,d,h){const w=new T.Graph(t=>t.id.toString());let S=0;const p=[{id:n,desc:d,_trace:h}];for(;p.length;){const t=p.pop();if(w.lookupOrInsertNode(t),S++>1e3)throw new I(w);for(const o of k._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(o.id);if(r||this._throwIfStrict(`[createInstance] ${n} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof A.SyncDescriptor){const c={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};w.insertEdge(t,c),p.push(c)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new I(w);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const c=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,c)}w.removeNode(o)}}return this._getServiceInstanceOrDescriptor(n)}_createServiceInstanceWithOwner(n,d,h=[],w,S){if(this._services.get(n)instanceof A.SyncDescriptor)return this._createServiceInstance(n,d,h,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(n,d,h,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(n,d,h=[],w,S){if(w){const p=new _(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(n);const t=new Map,o=new a.IdleValue(()=>{const r=p._createInstance(d,h,S);for(const[c,m]of t){const f=r[c];if(typeof f=="function")for(const i of m)f.apply(r,i)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let i=t.get(c);return i||(i=new v.LinkedList,t.set(c,i)),(u,b,g)=>{const L=i.push([u,b,g]);return(0,l.toDisposable)(L)}}if(c in r)return r[c];const m=o.value;let f=m[c];return typeof f!="function"||(f=f.bind(m),r[c]=f),f},set(r,c,m){return o.value[c]=m,!0},getPrototypeOf(r){return d.prototype}})}else return this._createInstance(d,h,S)}_throwIfStrict(n,d){if(d&&console.warn(n),this._strict)throw new Error(n)}}e.InstantiationService=_;var D;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(D||(D={}));class C{static traceInvocation(n,d){return n?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C._None}static traceCreation(n,d){return n?new C(1,d.name):C._None}constructor(n,d){this.type=n,this.name=d,this._start=Date.now(),this._dep=[]}branch(n,d){const h=new C(3,n.toString());return this._dep.push([n,d,h]),h}stop(){const n=Date.now()-this._start;C._totals+=n;let d=!1;function h(S,p){const t=[],o=new Array(S+1).join("	");for(const[r,c,m]of p._dep)if(c&&m){d=!0,t.push(`${o}CREATES -> ${r}`);const f=h(S+1,m);f&&t.push(f)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(n>2||d)&&C.all.add(w.join(`
`))}}C.all=new Set,C._None=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C._totals=0,e.Trace=C}),define(Ce[16],De([1,0,46,3,68,6,28,14,24,10,2,44,4]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function D(){return new Date().toISOString()}function C(u){return(0,v.isNumber)(u)}e.isLogLevel=C;var E;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function n(u,b,g){switch(b){case E.Trace:u.trace(g);break;case E.Debug:u.debug(g);break;case E.Info:u.info(g);break;case E.Warning:u.warn(g);break;case E.Error:u.error(g);break;case E.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=n;function d(u,b=!1){let g="";for(let L=0;L<u.length;L++){let H=u[L];if(H instanceof Error&&(H=(0,a.toErrorMessage)(H,b)),typeof H=="object")try{H=JSON.stringify(H)}catch{}g+=(L>0?" ":"")+H}return g}class h extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==E.Off&&this.level<=b}}e.AbstractLogger=h;class w extends h{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,...g){this.checkLogLevel(E.Trace)&&this.log(E.Trace,d([b,...g],!0))}debug(b,...g){this.checkLogLevel(E.Debug)&&this.log(E.Debug,d([b,...g]))}info(b,...g){this.checkLogLevel(E.Info)&&this.log(E.Info,d([b,...g]))}warn(b,...g){this.checkLogLevel(E.Warning)&&this.log(E.Warning,d([b,...g]))}error(b,...g){if(this.checkLogLevel(E.Error))if(b instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=b.stack,this.log(E.Error,d(L))}else this.log(E.Error,d([b,...g]))}flush(){}}e.AbstractMessageLogger=w;class S extends h{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!k.isWindows}trace(b,...g){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,b,...g):console.log(`[main ${D()}]`,b,...g))}debug(b,...g){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,b,...g):console.log(`[main ${D()}]`,b,...g))}info(b,...g){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,b,...g):console.log(`[main ${D()}]`,b,...g))}warn(b,...g){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,b,...g):console.warn(`[main ${D()}]`,b,...g))}error(b,...g){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,b,...g):console.error(`[main ${D()}]`,b,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class p extends h{constructor(b=e.DEFAULT_LOG_LEVEL,g=!0){super(),this.useColors=g,this.setLevel(b)}trace(b,...g){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,...g):console.log(b,...g))}debug(b,...g){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,...g):console.log(b,...g))}info(b,...g){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,...g):console.log(b,...g))}warn(b,...g){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,...g):console.log(b,...g))}error(b,...g){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,...g):console.error(b,...g))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends h{constructor(b,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(g)}trace(b,...g){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(b),...g])}debug(b,...g){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(b),...g])}info(b,...g){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(b),...g])}warn(b,...g){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(b),...g])}error(b,...g){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(b),...g])}extractMessage(b){return typeof b=="string"?b:(0,a.toErrorMessage)(b,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends h{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const g of this.loggers)g.setLevel(b);super.setLevel(b)}trace(b,...g){for(const L of this.loggers)L.trace(b,...g)}debug(b,...g){for(const L of this.loggers)L.debug(b,...g)}info(b,...g){for(const L of this.loggers)L.info(b,...g)}warn(b,...g){for(const L of this.loggers)L.warn(b,...g)}error(b,...g){for(const L of this.loggers)L.error(b,...g)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose()}}e.MultiplexLogger=o;class r extends A.Disposable{constructor(b,g,L){if(super(),this.logLevel=b,this.logsHome=g,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new P.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const H of L)this._loggers.set(H.resource,{logger:void 0,info:H})}getLoggerEntry(b){return(0,v.isString)(b)?[...this._loggers.values()].find(g=>g.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,g){const L=this.toResource(b),H=(0,v.isString)(b)?b:g?.id??(0,l.hash)(L.toString()).toString(16);let q=this._loggers.get(L)?.logger;const X=g?.logLevel==="always"?E.Trace:g?.logLevel;q||(q=this.doCreateLogger(L,X??this.getLogLevel(L)??this.logLevel,{...g,id:H}));const U={logger:q,info:{resource:L,id:H,logLevel:X,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(U.info),this._loggers.set(L,U),q}toResource(b){return(0,v.isString)(b)?(0,y.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,g){if(R.URI.isUri(b)){const L=b,H=g,q=this._loggers.get(L);q&&H!==q.info.logLevel&&(q.info.logLevel=H===this.logLevel?void 0:H,q.logger?.setLevel(H),this._loggers.set(q.info.resource,q),this._onDidChangeLogLevel.fire([L,H]))}else{this.logLevel=b;for(const[L,H]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&H.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,g){const L=this.getLoggerEntry(b);L&&g!==!L.info.hidden&&(L.info.hidden=!g,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,g]))}getLogLevel(b){let g;return b&&(g=this._loggers.get(b)?.info.logLevel),g??this.logLevel}registerLogger(b){const g=this._loggers.get(b.resource);g?g.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const g=this._loggers.get(b);g&&(g.logger&&g.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=r;class c{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(b){}getLevel(){return E.Info}trace(b,...g){}debug(b,...g){}info(b,...g){}warn(b,...g){}error(b,...g){}critical(b,...g){}dispose(){}flush(){}}e.NullLogger=c;class m extends c{}e.NullLogService=m;function f(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const b=s(u.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function i(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=i;function s(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=s,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",i(E.Info))}),define(Ce[211],De([1,0,6,16]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends a.Disposable{constructor(T,k=[]){super(),this.logger=new P.MultiplexLogger([T,...k]),this._register(T.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...k){this.logger.trace(T,...k)}debug(T,...k){this.logger.debug(T,...k)}info(T,...k){this.logger.info(T,...k)}warn(T,...k){this.logger.warn(T,...k)}error(T,...k){this.logger.error(T,...k)}flush(){this.logger.flush()}}e.LogService=l}),define(Ce[212],De([1,0,45,16]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(l||(l={}));async function A(v,R,I,_,D){try{const C=await new Promise((n,d)=>{re(["spdlog"],n,d)});C.setFlushOn(l.Trace);const E=await C.createAsyncRotatingLogger(v,R,I,_);return D?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(C){console.error(C)}return null}function T(v,R,I){switch(R){case P.LogLevel.Trace:v.trace(I);break;case P.LogLevel.Debug:v.debug(I);break;case P.LogLevel.Info:v.info(I);break;case P.LogLevel.Warning:v.warn(I);break;case P.LogLevel.Error:v.error(I);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function k(v,R){switch(R){case P.LogLevel.Trace:v.setLevel(l.Trace);break;case P.LogLevel.Debug:v.setLevel(l.Debug);break;case P.LogLevel.Info:v.setLevel(l.Info);break;case P.LogLevel.Warning:v.setLevel(l.Warning);break;case P.LogLevel.Error:v.setLevel(l.Error);break;case P.LogLevel.Off:v.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class y extends P.AbstractMessageLogger{constructor(R,I,_,D,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(R,I,_,D),this._register(this.onDidChangeLogLevel(E=>{this._logger&&k(this._logger,E)}))}async _createSpdLogLogger(R,I,_,D){const C=_?6:1,E=30/C*a.ByteSize.MB,n=await A(R,I,E,C,D);if(n){this._logger=n,k(this._logger,this.getLevel());for(const{level:d,message:h}of this.buffer)T(this._logger,d,h);this.buffer=[]}}log(R,I){this._logger?T(this._logger,R,I):this.getLevel()<=R&&this.buffer.push({level:R,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(Ce[124],De([1,0,38,178,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function v(C,E){return E-C}y.compare=v;const R=Object.create(null);R[y.Error]=(0,P.localize)(0,null),R[y.Warning]=(0,P.localize)(1,null),R[y.Info]=(0,P.localize)(2,null);function I(C){return R[C]||""}y.toString=I;function _(C){switch(C){case a.default.Error:return y.Error;case a.default.Warning:return y.Warning;case a.default.Info:return y.Info;case a.default.Ignore:return y.Hint}}y.fromSeverity=_;function D(C){switch(C){case y.Error:return a.default.Error;case y.Warning:return a.default.Warning;case y.Info:return a.default.Info;case y.Hint:return a.default.Ignore}}y.toSeverity=D}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const v="";function R(_){return I(_,!0)}y.makeKey=R;function I(_,D){const C=[v];return _.source?C.push(_.source.replace("\xA6","\\\xA6")):C.push(v),_.code?typeof _.code=="string"?C.push(_.code.replace("\xA6","\\\xA6")):C.push(_.code.value.replace("\xA6","\\\xA6")):C.push(v),_.severity!==void 0&&_.severity!==null?C.push(T.toString(_.severity)):C.push(v),_.message&&D?C.push(_.message.replace("\xA6","\\\xA6")):C.push(v),_.startLineNumber!==void 0&&_.startLineNumber!==null?C.push(_.startLineNumber.toString()):C.push(v),_.startColumn!==void 0&&_.startColumn!==null?C.push(_.startColumn.toString()):C.push(v),_.endLineNumber!==void 0&&_.endLineNumber!==null?C.push(_.endLineNumber.toString()):C.push(v),_.endColumn!==void 0&&_.endColumn!==null?C.push(_.endColumn.toString()):C.push(v),C.push(v),C.join("\xA6")}y.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(Ce[213],De([1,0,3,38,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,l.createDecorator)("notificationService");var A;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(A=e.NotificationPriority||(e.NotificationPriority={}));var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new v,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.NoOpNotification=y;class v{infinite(){}done(){}total(I){}worked(I){}}e.NoOpProgress=v}),define(Ce[125],De([1,0,9,2,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function A(v,R){return P.URI.isUri(v)?(0,a.equalsIgnoreCase)(v.scheme,R):(0,a.startsWithIgnoreCase)(v,R+":")}e.matchesScheme=A;function T(v,...R){return R.some(I=>A(v,I))}e.matchesSomeScheme=T;function k(v,R){return v.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=k;function y(v){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},v=v.with({fragment:""})),{selection:R,uri:v}}e.extractSelection=y}),define(Ce[214],De([1,0,17,14,33,204]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const k=P.globals.vscode.context.configuration();if(k)T=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){T=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:y,itemUrl:v,controlUrl:R}=T.extensionsGallery||{};Object.assign(T,{extensionsGallery:{serviceUrl:l.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:l.env.VSCODE_GALLERY_SEARCH_URL||y,itemUrl:l.env.VSCODE_GALLERY_ITEM_URL||v,controlUrl:l.env.VSCODE_GALLERY_CONTROL_URL||R}});try{const I=(...E)=>E.reduce((n,d)=>(Object.keys(d).forEach(h=>{Array.isArray(n[h])&&Array.isArray(d[h])?n[h]=d[h]:typeof n[h]=="object"&&typeof d[h]=="object"?n[h]=I(n[h],d[h]):n[h]=d[h]}),n),{}),_=(0,A.getUserDataPath)({},T.nameShort),D=P.isWindows?`file:///${_}/product.json`:`file://${_}/product.json`,C=re.__$__nodeRequire(a.FileAccess.asFileUri(D).fsPath);T=I(T,C)}catch{}if(l.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:I.version,release:I.release})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(Ce[215],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(re,e){return function(a,P){e(a,P,re)}};define(Ce[126],De([1,0,19,21,6,4]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{get value(){return this._value}constructor(I){this.callback=I}report(I){this._value=I,this.callback(this._value)}}k.None=Object.freeze({report(){}}),e.Progress=k;let y=class extends l.Disposable{constructor(I,_){super(),this.deferred=new a.DeferredPromise,_.withProgress(I,D=>(this.reporter=D,this.lastStep&&D.report(this.lastStep),this.deferred.p)),this._register((0,l.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=$e([Be(1,e.IProgressService)],y),e.UnmanagedProgress=y;class v extends l.Disposable{constructor(I){super(),this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new l.DisposableStore)}start(I){this.stop();const _=++this.currentOperationId,D=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,l.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,l.toDisposable)(()=>D.cancel())),this.currentOperationDisposables.add((0,l.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:D.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=v,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Ce[40],De([1,0,51,10]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.data=new Map}add(T,k){a.ok(P.isString(T)),a.ok(P.isObject(k)),a.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,k)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new l}),define(Ce[93],De([1,0,3,40]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,v){this.schemasById[l(y)]=v,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;P.Registry.add(e.Extensions.JSONContribution,T)}),define(Ce[127],De([1,0,18,3,10,171,54,93,40]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=y.Registry.as(k.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.doRegisterConfigurations(t,o,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.doDeregisterConfigurations(o,r),this.doRegisterConfigurations(t,!1,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const r=[];for(const{overrides:c,source:m}of t)for(const f in c)if(o.add(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const i=this.configurationDefaultsOverrides.get(f),s=i?.valuesSources??new Map;if(m)for(const L of Object.keys(c[f]))s.set(L,m);const u={...i?.value||{},...c[f]};this.configurationDefaultsOverrides.set(f,{source:m,value:u,valuesSources:s});const b=(0,T.getLanguageTagSettingPlainKey)(f),g={type:"object",default:u,description:A.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:l.isString(m)?void 0:m,defaultValueSource:m};r.push(...E(f)),this.configurationProperties[f]=g,this.defaultLanguageConfigurationOverridesNode.properties[f]=g}else{this.configurationDefaultsOverrides.set(f,{value:c[f],source:m});const i=this.configurationProperties[f];i&&(this.updatePropertyDefaultValue(f,i),this.updateSchema(f,i))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:r,source:c}of t)for(const m in r){const f=this.configurationDefaultsOverrides.get(m),i=l.isString(c)?c:c?.id,s=l.isString(f?.source)?f?.source:f?.source?.id;if(i===s)if(o.add(m),this.configurationDefaultsOverrides.delete(m),e.OVERRIDE_PROPERTY_REGEX.test(m))delete this.configurationProperties[m],delete this.defaultLanguageConfigurationOverridesNode.properties[m];else{const u=this.configurationProperties[m];u&&(this.updatePropertyDefaultValue(m,u),this.updateSchema(m,u))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,r){t.forEach(c=>{this.validateAndRegisterProperties(c,o,c.extensionInfo,c.restrictedProperties,void 0,r),this.configurationContributors.push(c),this.registerJSONConfiguration(c)})}doDeregisterConfigurations(t,o){const r=c=>{if(c.properties)for(const m in c.properties){o.add(m);const f=this.configurationProperties[m];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[m],this.removeFromSchema(m,c.properties[m])}c.allOf?.forEach(m=>r(m))};for(const c of t){r(c);const m=this.configurationContributors.indexOf(c);m!==-1&&this.configurationContributors.splice(m,1)}}validateAndRegisterProperties(t,o=!0,r,c,m=3,f){m=l.isUndefinedOrNull(t.scope)?m:t.scope;const i=t.properties;if(i)for(const u in i){const b=i[u];if(o&&w(u,b)){delete i[u];continue}if(b.source=r,b.defaultDefaultValue=i[u].default,this.updatePropertyDefaultValue(u,b),e.OVERRIDE_PROPERTY_REGEX.test(u)?b.scope=void 0:(b.scope=l.isUndefinedOrNull(b.scope)?m:b.scope,b.restricted=l.isUndefinedOrNull(b.restricted)?!!c?.includes(u):b.restricted),i[u].hasOwnProperty("included")&&!i[u].included){this.excludedConfigurationProperties[u]=i[u],delete i[u];continue}else this.configurationProperties[u]=i[u],i[u].policy?.name&&this.policyConfigurations.set(i[u].policy.name,u);!i[u].deprecationMessage&&i[u].markdownDeprecationMessage&&(i[u].deprecationMessage=i[u].markdownDeprecationMessage),f.add(u)}const s=t.allOf;if(s)for(const u of s)this.validateAndRegisterProperties(u,o,r,c,m,f)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=r=>{const c=r.properties;if(c)for(const f in c)this.updateSchema(f,c[f]);r.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,r),e.allSettings.properties[o]=r,e.applicationSettings.properties[o]=r,e.machineSettings.properties[o]=r,e.machineOverridableSettings.properties[o]=r,e.windowSettings.properties[o]=r,e.resourceSettings.properties[o]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const r=this.configurationDefaultsOverrides.get(t);let c=r?.value,m=r?.source;l.isUndefined(c)&&(c=o.defaultDefaultValue,m=void 0),l.isUndefined(c)&&(c=d(o.type)),o.default=c,o.defaultValueSource=m}}const D="\\[([^\\]]+)\\]",C=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=C.exec(p);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=C.exec(p)}}return(0,a.distinct)(t)}e.overrideIdentifiersFromKey=E;function n(p){return p.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=n;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new _;y.Registry.add(e.Extensions.Configuration,h);function w(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):h.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,p,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=w;function S(){const p=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))p.push([o,t[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=S}),define(Ce[216],De([1,0,18,3,147,6,28,23,10,2,54,127,40]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function D(o){return Object.isFrozen(o)?o:k.deepFreeze(o)}class C{constructor(r={},c=[],m=[],f){this._contents=r,this._keys=c,this._overrides=m,this.raw=f,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof C)return c;const m=new E("");return m.parseRaw(c),m.configurationModel});this._rawConfiguration=r.reduce((c,m)=>m===c?m:c.merge(m),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const m=this.rawConfiguration.getValue(r),f=c?this.rawConfiguration.getOverrideValue(r,c):void 0,i=c?this.rawConfiguration.override(c).getValue(r):m;return{value:m,override:f,merged:i}}getOverrideValue(r,c){const m=this.getContentsForOverrideIdentifer(c);return m?r?(0,R.getConfigurationValue)(m,r):m:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const m of this.overrides)m.identifiers.includes(r)&&c.push(...m.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return a.distinct(r)}override(r){let c=this.overrideConfigurations.get(r);return c||(c=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,c)),c}merge(...r){const c=k.deepClone(this.contents),m=k.deepClone(this.overrides),f=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const s of r)if(i.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.mergeContents(c,s.contents);for(const u of s.overrides){const[b]=m.filter(g=>a.equals(g.identifiers,u.identifiers));b?(this.mergeContents(b.contents,u.contents),b.keys.push(...u.keys),b.keys=a.distinct(b.keys)):m.push(k.deepClone(u))}for(const u of s.keys)f.indexOf(u)===-1&&f.push(u)}return new C(c,f,m,i.every(s=>s instanceof C)?void 0:i)}createOverrideConfigurationModel(r){const c=this.getContentsForOverrideIdentifer(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const m={};for(const f of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let i=this.contents[f];const s=c[f];s&&(typeof i=="object"&&typeof s=="object"?(i=k.deepClone(i),this.mergeContents(i,s)):i=s),m[f]=i}return new C(m,this.keys,this.overrides)}mergeContents(r,c){for(const m of Object.keys(c)){if(m in r&&y.isObject(r[m])&&y.isObject(c[m])){this.mergeContents(r[m],c[m]);continue}r[m]=k.deepClone(c[m])}}getContentsForOverrideIdentifer(r){let c=null,m=null;const f=i=>{i&&(m?this.mergeContents(m,i):m=k.deepClone(i))};for(const i of this.overrides)a.equals(i.identifiers,[r])?c=i.contents:i.identifiers.includes(r)&&f(i.contents);return f(c),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.updateValue(r,c,!0)}setValue(r,c){this.updateValue(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,R.removeFromValueTree)(this.contents,r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(m=>a.equals(m.identifiers,(0,I.overrideIdentifiersFromKey)(r))),1))}updateValue(r,c,m){(0,R.addToValueTree)(this.contents,r,c,f=>console.error(f)),m=m||this.keys.indexOf(r)===-1,m&&this.keys.push(r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,R.toValuesTree)(this.contents[r],f=>console.error(f))})}}e.ConfigurationModel=C;class E{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,c){if(!y.isUndefinedOrNull(r)){const m=this.doParseContent(r);this.parseRaw(m,c)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,c){this._raw=r;const{contents:m,keys:f,overrides:i,restricted:s,hasExcludedProperties:u}=this.doParseRaw(r,c);this._configurationModel=new C(m,f,i,u?[r]:void 0),this._restrictedConfigurations=s||[]}doParseContent(r){let c={},m=null,f=[];const i=[],s=[];function u(g){Array.isArray(f)?f.push(g):m!==null&&(f[m]=g)}const b={onObjectBegin:()=>{const g={};u(g),i.push(f),f=g,m=null},onObjectProperty:g=>{m=g},onObjectEnd:()=>{f=i.pop()},onArrayBegin:()=>{const g=[];u(g),i.push(f),f=g,m=null},onArrayEnd:()=>{f=i.pop()},onLiteralValue:u,onError:(g,L,H)=>{s.push({error:g,offset:L,length:H})}};if(r)try{l.visit(r,b),c=f[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return c}doParseRaw(r,c){const m=_.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=this.filter(r,m,!0,c);r=f.raw;const i=(0,R.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),s=Object.keys(r),u=this.toOverrides(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:i,keys:s,overrides:u,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}filter(r,c,m,f){let i=!1;if(!f?.scopes&&!f?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const s={},u=[];for(const b in r)if(I.OVERRIDE_PROPERTY_REGEX.test(b)&&m){const g=this.filter(r[b],c,!1,f);s[b]=g.raw,i=i||g.hasExcludedProperties,u.push(...g.restricted)}else{const g=c[b],L=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&u.push(b),(L===void 0||f.scopes===void 0||f.scopes.includes(L))&&!(f.skipRestricted&&g?.restricted)?s[b]=r[b]:i=!0}return{raw:s,restricted:u,hasExcludedProperties:i}}toOverrides(r,c){const m=[];for(const f of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(f)){const i={};for(const s in r[f])i[s]=r[f][s];m.push({identifiers:(0,I.overrideIdentifiersFromKey)(f),keys:Object.keys(i),contents:(0,R.toValuesTree)(i,c)})}return m}}e.ConfigurationModelParser=E;class n extends A.Disposable{constructor(r,c,m,f){super(),this.userSettingsResource=r,this.scopes=c,this.fileService=f,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(m.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.any(P.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource)),P.Event.filter(this.fileService.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&m.isEqual(i.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=n;class d{constructor(r,c,m,f,i,s,u,b,g,L,H,q,X){this.key=r,this.overrides=c,this._value=m,this.overrideIdentifiers=f,this.defaultConfiguration=i,this.policyConfiguration=s,this.applicationConfiguration=u,this.userConfiguration=b,this.localUserConfiguration=g,this.remoteUserConfiguration=L,this.workspaceConfiguration=H,this.folderConfigurationModel=q,this.memoryConfigurationModel=X}get value(){return D(this._value)}inspect(r,c,m){const f=r.inspect(c,m);return{get value(){return D(f.value)},get override(){return D(f.override)},get merged(){return D(f.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(r,c,m,f,i=new C,s=new C,u=new T.ResourceMap,b=new C,g=new T.ResourceMap){this._defaultConfiguration=r,this._policyConfiguration=c,this._applicationConfiguration=m,this._localUserConfiguration=f,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=b,this._memoryConfigurationByResource=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,c,m){return this.getConsolidatedConfigurationModel(r,c,m).getValue(r)}updateValue(r,c,m={}){let f;m.resource?(f=this._memoryConfigurationByResource.get(m.resource),f||(f=new C,this._memoryConfigurationByResource.set(m.resource,f))):f=this._memoryConfiguration,c===void 0?f.removeValue(r):f.setValue(r,c),m.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,c,m){const f=this.getConsolidatedConfigurationModel(r,c,m),i=this.getFolderConfigurationModelForResource(c.resource,m),s=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,u=new Set;for(const b of f.overrides)for(const g of b.identifiers)f.getOverrideValue(r,g)!==void 0&&u.add(g);return new d(r,c,f.getValue(r),u.size?[...u]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this._workspaceConfiguration:void 0,i||void 0,s)}keys(r){const c=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,c){this._folderConfigurations.set(r,c),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const m=[];if(!c){const{added:f,updated:i,removed:s}=p(this._defaultConfiguration,r);c=[...f,...i,...s]}for(const f of c)for(const i of(0,I.overrideIdentifiersFromKey)(f)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(i),u=r.getKeysForOverrideIdentifier(i),b=[...u.filter(g=>s.indexOf(g)===-1),...s.filter(g=>u.indexOf(g)===-1),...s.filter(g=>!k.equals(this._defaultConfiguration.override(i).getValue(g),r.override(i).getValue(g)))];m.push([i,b])}return this.updateDefaultConfiguration(r),{keys:c,overrides:m}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:m,removed:f}=p(this._policyConfiguration,r),i=[...c,...m,...f];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.applicationConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.localUserConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.remoteUserConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.workspaceConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:i}}compareAndUpdateFolderConfiguration(r,c){const m=this.folderConfigurations.get(r),{added:f,updated:i,removed:s,overrides:u}=p(m,c),b=[...f,...i,...s];return(b.length||!m)&&this.updateFolderConfiguration(r,c),{keys:b,overrides:u}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:m,updated:f,removed:i,overrides:s}=p(c,void 0);return{keys:[...m,...f,...i],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,c,m){let f=this.getConsolidatedConfigurationModelForResource(c,m);return c.overrideIdentifier&&(f=f.override(c.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(f=f.merge(this._policyConfiguration)),f}getConsolidatedConfigurationModelForResource({resource:r},c){let m=this.getWorkspaceConsolidatedConfiguration();if(c&&r){const f=c.getFolder(r);f&&(m=this.getFolderConsolidatedConfiguration(f.uri)||m);const i=this._memoryConfigurationByResource.get(r);i&&(m=m.merge(i))}return m}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let c=this._foldersConsolidatedConfigurations.get(r);if(!c){const m=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(r);f?(c=m.merge(f),this._foldersConsolidatedConfigurations.set(r,c)):c=m}return c}getFolderConfigurationModelForResource(r,c){if(c&&r){const m=c.getFolder(r);if(m)return this._folderConfigurations.get(m.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,c)=>{const{contents:m,overrides:f,keys:i}=this._folderConfigurations.get(c);return r.push([c,{contents:m,overrides:f,keys:i}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this._workspaceConfiguration.keys.forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.keys.forEach(m=>r.add(m))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.getAllOverrideIdentifiers().forEach(m=>r.add(m))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this._folderConfigurations.forEach(m=>m.getKeysForOverrideIdentifier(r).forEach(f=>c.add(f))),[...c.values()]}static parse(r){const c=this.parseConfigurationModel(r.defaults),m=this.parseConfigurationModel(r.policy),f=this.parseConfigurationModel(r.application),i=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),u=r.folders.reduce((b,g)=>(b.set(v.URI.revive(g[0]),this.parseConfigurationModel(g[1])),b),new T.ResourceMap);return new h(c,m,f,i,new C,s,u,new C,new T.ResourceMap)}static parseConfigurationModel(r){return new C(r.contents,r.keys,r.overrides)}}e.Configuration=h;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,c=new Map;for(const f of o)f.keys.forEach(i=>r.add(i)),f.overrides.forEach(([i,s])=>{const u=(0,T.getOrSet)(c,i,new Set);s.forEach(b=>u.add(b))});const m=[];return c.forEach((f,i)=>m.push([i,[...f.values()]])),{keys:[...r.values()],overrides:m}}e.mergeChanges=w;class S{constructor(r,c,m,f){this.change=r,this.previous=c,this.currentConfiguraiton=m,this.currentWorkspace=f,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const s of i)this.affectedKeys.add(s);this._affectsConfigStr=this._marker;for(const i of this.affectedKeys)this._affectsConfigStr+=i+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,c){const m=this._marker+r,f=this._affectsConfigStr.indexOf(m);if(f<0)return!1;const i=f+m.length;if(i>=this._affectsConfigStr.length)return!1;const s=this._affectsConfigStr.charCodeAt(i);if(s!==this._markerCode1&&s!==this._markerCode2)return!1;if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(r,c,this.currentWorkspace);return!k.equals(u,b)}return!0}}e.ConfigurationChangeEvent=S;function p(o,r){const{added:c,removed:m,updated:f}=t(r?.rawConfiguration,o?.rawConfiguration),i=[],s=o?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const b=u.filter(g=>!s.includes(g));for(const g of b)i.push([g,r.getKeysForOverrideIdentifier(g)])}if(o){const b=s.filter(g=>!u.includes(g));for(const g of b)i.push([g,o.getKeysForOverrideIdentifier(g)])}if(r&&o){for(const b of s)if(u.includes(b)){const g=t({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)});i.push([b,[...g.added,...g.removed,...g.updated]])}}return{added:c,removed:m,updated:f,overrides:i}}function t(o,r){const c=o?r?o.keys.filter(i=>r.keys.indexOf(i)===-1):[...o.keys]:[],m=r?o?r.keys.filter(i=>o.keys.indexOf(i)===-1):[...r.keys]:[],f=[];if(o&&r){for(const i of r.keys)if(o.keys.indexOf(i)!==-1){const s=(0,R.getConfigurationValue)(r.contents,i),u=(0,R.getConfigurationValue)(o.contents,i);k.equals(s,u)||f.push(i)}}return{added:c,removed:m,updated:f}}}),define(Ce[128],De([1,0,8,4]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var l;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof A&&y._code===l.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof A&&y._code===l.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof A&&y._code===l.NoResolverFound}static isHandled(y){return y instanceof A&&y.isHandled}constructor(y,v=l.Unknown,R){super(y),this._message=y,this._code=v,this._detail=R,this.isHandled=v===l.NotAvailable&&R===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function T(k){const y=k.indexOf("+");return y===-1?k:k.substring(0,y)}e.getRemoteAuthorityPrefix=T}),define(Ce[74],De([1,0,17]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(v){return v.scheme===a.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=P;function l(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.getRemoteName=l;function A(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(v){const{host:R,port:I}=y(v);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.parseAuthorityWithPort=T;function k(v,R){let{host:I,port:_}=y(v);return typeof _>"u"&&(_=R),{host:I,port:_}}e.parseAuthorityWithOptionalPort=k;function y(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=v.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const _=v.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:v,port:void 0}}}),define(Ce[25],De([1,0,9,4,74]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var k;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,d){if(typeof n>"u"||n===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof n=="string"||typeof d=="string"){const h=typeof n=="string"?n:n.value,w=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(h,w)}return n._lower===d._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=y;class v{get size(){return this._set.size}constructor(n){if(this._set=new Set,n)for(const d of n)this.add(d)}add(n){this._set.add(y.toKey(n))}delete(n){return this._set.delete(y.toKey(n))}has(n){return this._set.has(y.toKey(n))}}e.ExtensionIdentifierSet=v;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(n){this._map.delete(y.toKey(n))}get(n){return this._map.get(y.toKey(n))}has(n){return this._map.has(y.toKey(n))}set(n,d){this._map.set(y.toKey(n),d)}values(){return this._map.values()}forEach(n){this._map.forEach(n)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function I(E){return _(E)}e.isApplicationScopedExtension=I;function _(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function D(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function C(E,n){if(n){const d=`onResolveRemoteAuthority:${(0,l.getRemoteName)(n)}`;return!!E.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[129],De([1,0,8,25]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class l{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,k){this._generators.set(T,k)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const k=Object.create(null);for(const y of T){const v=this.readActivationEvents(y);v.length>0&&(k[P.ExtensionIdentifier.toKey(y.identifier)]=v)}return k}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const k=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];if(!T.contributes)return k;for(const y in T.contributes){const v=this._generators.get(y);if(!v)continue;const R=T.contributes[y],I=Array.isArray(R)?R:[R];try{v(I,k)}catch(_){(0,a.onUnexpectedError)(_)}}return k}}e.ImplicitActivationEventsImpl=l,e.ImplicitActivationEvents=new l}),define(Ce[217],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.validators=new Map}vsda(){return new Promise((l,A)=>re(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.vsda(),T=new A.validator;if(T){const k=String(a._nextId++);return this.validators.set(k,T),{id:k,data:T.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const T=this.validators.get(l.id);if(!T)return!1;this.validators.delete(l.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.vsda(),T=new A.signer;if(T)return T.sign(l)}catch{}return l}}a._nextId=1,e.SignService=a}),define(Ce[218],De([1,0,14,33,30]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(y){if(a.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function T(y,v,R,I,_,D,C,E){const n=Object.create(null);n["common.machineId"]=D,n.sessionID=(0,l.generateUuid)()+Date.now(),n.commitHash=I,n.version=_,n["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,a.PlatformToString)(a.platform),n["common.nodePlatform"]=P.platform,n["common.nodeArch"]=R,n["common.product"]=E||"desktop",C&&(n["common.msftInternal"]=C);let d=0;const h=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),a.isLinuxSnap&&(n["common.snap"]="true");const w=A(v);return w&&(n["common.platformDetail"]=w),n}e.resolveCommonProperties=T;function k(y){const v=P.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return y.some(I=>R===I)}e.verifyMicrosoftInternalDomain=k}),define(Ce[219],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(P=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[75],De([1,0,23,10,3,54,74,218,219]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(m){this.value=m}}e.TelemetryTrustedValue=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class I{async publicLog(m,f,i){}async publicLogError(m,f,i){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function _(c,m){return l.Event.debounce(m.onDidChangeConfiguration,(i,s)=>{const u=i?new Set([...i.affectedKeys,...s.affectedKeys]):s.affectedKeys;return{...s,affectedKeys:u}},1e3,!0)(i=>{i.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=_;function D(c,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!c.enableTelemetry||m.extensionTestsLocationURI)}e.supportsTelemetry=D;function C(c,m){return!(m.isBuilt||m.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=C;function E(c){const m=c.getValue(y.TELEMETRY_SETTING_ID),f=c.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function n(c){const m={},f={},i={};w(c,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const u=i[s];typeof u=="number"?f[s]=u:typeof u=="boolean"?f[s]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${u.length}`),m[s]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(m[s]=u)}return{properties:m,measurements:f}}e.validateTelemetryData=n;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(c){if(!c)return"none";const m=(0,T.getRemoteName)(c);return d.has(m)?m:"other"}e.cleanRemoteAuthority=h;function w(c,m,f=0,i){if(!!c)for(const s of Object.getOwnPropertyNames(c)){const u=c[s],b=i?i+s:s;Array.isArray(u)?m[b]=(0,a.safeStringify)(u):u instanceof Date?m[b]=u.toISOString():(0,P.isObject)(u)?f<2?w(u,m,f+1,b+"."):m[b]=(0,a.safeStringify)(u):m[b]=u}}function S(c,m){const f=c.msftInternalDomains||[],i=m.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(f)||i}e.isInternalTelemetry=S;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(c,m){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let f=c;const i=[];for(const g of m)for(;;){const L=g.exec(c);if(!L)break;i.push([L.index,g.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(f="";;){const g=u.exec(c);if(!g)break;const L=i.some(([H,q])=>g.index<q&&H<u.lastIndex);!s.test(g[0])&&!L&&(f+=c.substring(b,g.index)+"<REDACTED: user-file-path>",b=u.lastIndex)}return b<c.length&&(f+=c.substr(b)),f}function o(c){if(!c)return c;const m=c.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of f)if(i.regex.test(m))return`<REDACTED: ${i.label}>`;return c}function r(c,m){return(0,a.cloneAndChange)(c,f=>{if(f instanceof v)return f.value;if(typeof f=="string"){let i=f.replaceAll("%20"," ");i=t(i,m);for(const s of m)i=i.replace(s,"");return i=o(i),i}})}e.cleanData=r}),define(Ce[220],De([1,0,9,123,25,14,2,8,33,75]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,a.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class _{static create(c){const m=c.manifest?c.manifest.version:c.version,f=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new _(c.identifier,m,f)}static parse(c){const m=I.exec(c);return m&&m[1]&&m[2]?new _({id:m[1]},m[2],m[4]||void 0):null}constructor(c,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof _?R(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=_;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(r){const c=D.exec(r);return c&&c[1]?[n(c[1]),c[2]]:[n(r),void 0]}e.getIdAndVersion=C;function E(r,c){return`${r}.${c}`}e.getExtensionId=E;function n(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function d(r,c){return n(E(r??l.UNDEFINED_PUBLISHER,c))}e.getGalleryExtensionId=d;function h(r,c){const m=[],f=i=>{for(const s of m)if(s.some(u=>R(c(u),c(i))))return s;return null};for(const i of r){const s=f(i);s?s.push(i):m.push([i])}return m}e.groupByExtension=h;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function S(r){return{id:new v.TelemetryTrustedValue(r.identifier.id),name:new v.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,c){const m=[],f=c.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const i=f.shift();if(i&&m.every(s=>!R(s.identifier,{id:i}))){const s=r.filter(u=>R(u.identifier,{id:i}));s.length===1&&(m.push(s[0]),f.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=p;async function t(r,c){if(!A.isLinux)return!1;let m;try{m=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){c.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(i))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,c){const m=await t(r,c),f=(0,P.getTargetPlatform)(m?"alpine":A.platform,y.arch);return c.debug("ComputeTargetPlatform:",f),f}e.computeTargetPlatform=o}),define(Ce[221],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=a;function P(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=P;function l(T){return Array.from(T.entries()).map(k=>[k[0],a(k[1].map)])}e.serializeEnvironmentVariableCollections=l;function A(T){return new Map(T.map(k=>[k[0],{map:P(k[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Ce[222],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(l){this._callback=l,this._terminalBufferMap=new Map}dispose(){for(const l of this._terminalBufferMap.values())l.dispose()}startBuffering(l,A,T=5){const k=A(y=>{const v=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(l);if(R){R.data.push(v);return}const I=setTimeout(()=>this.flushBuffer(l),T);R={data:[v],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(l),k.dispose()}},this._terminalBufferMap.set(l,R)});return k}stopBuffering(l){this._terminalBufferMap.get(l)?.dispose()}flushBuffer(l){const A=this._terminalBufferMap.get(l);A&&(this._terminalBufferMap.delete(l),this._callback(l,A.data.join("")))}}e.TerminalDataBufferer=a}),define(Ce[223],De([1,0,19,67,52,3,10,2,179,93,40]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(S){function p(t,o){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const c=C.getIcon(r.id);if(!c)return;r=c.defaults}return r}S.getDefinition=p})(I=e.IconContribution||(e.IconContribution={}));var _;(function(S){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(r=>({format:r.format,location:r.location.toString()}))}}S.toJSONObject=p;function t(o){const r=c=>(0,T.isString)(c)?c:void 0;if(o&&Array.isArray(o.src)&&o.src.every(c=>(0,T.isString)(c.format)&&(0,T.isString)(c.location)))return{weight:r(o.weight),style:r(o.style),src:o.src.map(c=>({format:c.format,location:k.URI.parse(c.location)}))}}S.fromJSONObject=t})(_=e.IconFontDefinition||(e.IconFontDefinition={}));class D{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,t,o,r){const c=this.iconsById[p];if(c){if(o&&!c.description){c.description=o,this.iconSchema.properties[p].markdownDescription=`${o} $(${p})`;const i=this.iconReferenceSchema.enum.indexOf(p);i!==-1&&(this.iconReferenceSchema.enumDescriptions[i]=o),this._onDidChange.fire()}return c}const m={id:p,description:o,defaults:t,deprecationMessage:r};this.iconsById[p]=m;const f={$ref:"#/definitions/icons"};return r&&(f.deprecationMessage=r),o&&(f.markdownDescription=`${o}: $(${p})`),this.iconSchema.properties[p]=f,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const t=this.iconReferenceSchema.enum.indexOf(p);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,t){const o=this.iconFontsById[p];return o||(this.iconFontsById[p]=t,this._onDidChange.fire(),t)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(c,m)=>c.id.localeCompare(m.id),t=c=>{for(;l.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of r.filter(m=>!!m.description).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|${l.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const c of r.filter(m=>!l.ThemeIcon.isThemeIcon(m.defaults)).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|`);return o.join(`
`)}}const C=new D;R.Registry.add(e.Extensions.IconContribution,C);function E(S,p,t,o){return C.registerIcon(S,p,t,o)}e.registerIcon=E;function n(){return C}e.getIconRegistry=n;function d(){const S=(0,P.getCodiconFontCharacters)();for(const p in S){const t="\\"+S[p].toString(16);C.registerIcon(p,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const h=R.Registry.as(v.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,C.getIconSchema());const w=new a.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=E("widget-close",P.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",P.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",P.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=l.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(Ce[130],De([1,0,3,54,4,16]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var T;(function(E){E.Http="http",E.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=I;function _(E,n,d,h){if(d===1)return!1;if(d===2&&I(n)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(w?.length===4&&parseInt(w[1])>=18)return!1}return E<1024}e.isPortPrivileged=_;class D{constructor(n,d,h){this.remoteAddress=n,this.localAddress=d,this._dispose=h,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=D;let C=class{constructor(n,d){this.logService=n,this.configurationService=d,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const n=this.configurationService.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],d=Array.from(this._tunnels.values());for(const h of d){const w=Array.from(h.values());for(const S of w){const p=await S.value;p&&n.push(p)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:d}of n.values())await d.then(h=>h?.dispose());n.clear()}this._tunnels.clear()}setEnvironmentTunnel(n,d,h,w,S){this.addTunnelToMap(n,d,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:d,localAddress:h,privacy:w,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,d){(I(n)||R(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const h=this.getTunnelFromMap(n,d);if(h)return++h.refcount,h.value}openTunnel(n,d,h,w,S,p=!1,t,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${S}.`),!n)return;if(d||(d="localhost"),w||(w=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(h)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(n,d,h,w,S,p,t,o);return r?r.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.makeTunnel(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(m),m}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const d=this._tunnels.get(n.tunnelRemoteHost);if(d){const h=d.get(n.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async tryDisposeTunnel(n,d,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${d}.`);const w=h.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(d),w}}async closeTunnel(n,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${d} `);const h=this._tunnels.get(n);if(h&&h.has(d)){const w=h.get(d);w.refcount=0,await this.tryDisposeTunnel(n,d,w)}}addTunnelToMap(n,d,h){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(d,{refcount:1,value:h})}async removeEmptyTunnelFromMap(n,d){const h=this._tunnels.get(n);h&&(await h.get(d)||h.delete(d),h.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,d){const h=[n];R(n)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):I(n)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const w=h.map(S=>this._tunnels.get(S));for(const S of w){const p=S?.get(d);if(p)return p}}canTunnel(n){return!!v(n)}createWithProvider(n,d,h,w,S,p,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${w}.`);const o=h;this._factoryInProgress.add(o);const r=w===void 0?h:w,c={elevationRequired:S?this.isPortPrivileged(r):!1},m={remoteAddress:{host:d,port:h},localAddressPort:w,privacy:p,public:p?p!==k.Private:void 0,protocol:t},f=n.forwardPort(m,c);return f?(this.addTunnelToMap(d,h,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),f}};C=$e([Be(0,A.ILogService),Be(1,P.IConfigurationService)],C),e.AbstractTunnelService=C}),define(Ce[224],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var P;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(P=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[225],De([1,0,17]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(y){return y.scheme!==a.Schemas.file&&y.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=P;function l(y){if(y.folders.length)return y.folders.every(v=>P(v.uri))?y.folders[0].uri:void 0;if(y.configuration&&P(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=l;function A(y){return l(y)?.scheme}e.getVirtualWorkspaceScheme=A;function T(y){return l(y)?.authority}e.getVirtualWorkspaceAuthority=T;function k(y){return l(y)!==void 0}e.isVirtualWorkspace=k}),define(Ce[48],De([1,0,180,15,69,24,2,4,17]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function v(c){const m=c;return typeof m?.id=="string"&&T.URI.isUri(m.uri)}e.isSingleFolderWorkspaceIdentifier=v;function R(c){return typeof c?.id=="string"&&!v(c)&&!_(c)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(c,m){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,P.basename)(c)}:m?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const f=c;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.toWorkspaceIdentifier=I;function _(c){const m=c;return typeof m?.id=="string"&&T.URI.isUri(m.configPath)}e.isWorkspaceIdentifier=_;function D(c){const m=c;if(m?.uri)return{id:m.id,uri:T.URI.revive(m.uri)};const f=c;if(f?.configPath)return{id:f.id,configPath:T.URI.revive(f.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=D;var C;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function E(c){const m=c;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=E;function n(c){const m=c;return!!(m&&typeof m=="object"&&T.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=n;class d{constructor(m,f,i,s,u){this._id=m,this._transient=i,this._configuration=s,this._ignorePathCasing=u,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=f}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m)||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,A.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function w(c){return new h({uri:c,index:0,name:(0,A.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(c,m){return A.extUriBiasedIgnorePathCase.isEqualOrParent(c,m.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function p(c){let m;return T.URI.isUri(c)?m=c:m=c.configuration,m?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(c,m){return!S(c,m)&&!p(c)}e.isSavedWorkspace=o;function r(c){return(typeof c=="string"?(0,P.extname)(c):(0,A.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ce[76],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(l){this.id=l,this._data=new Map,this._idPool=1}add(l){const A=this._idPool++;return this._data.set(A,l),this.logDebugInfo(),A}get(l,A){return this._data.has(l)?this._data.get(l)[A]:void 0}delete(l){this._data.delete(l),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}a.enableDebugLogging=!1,e.Cache=a}),define(Ce[49],De([1,0,17,24,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new P.ExtUri(k=>{const y=this._providerInfo.get(k.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(k,y){y===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,y)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ce[226],De([1,0,184,16,211,26]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends l.LogService{constructor(y,v,R){const I=R.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",_=R.remote.isRemote?(0,a.localize)(0,null):y?(0,a.localize)(1,null):(0,a.localize)(2,null);super(v.createLogger(I,{name:_}))}};T=$e([Be(1,P.ILoggerService),Be(2,A.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ce[227],De([1,0,19]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(T,k,y){this._deferredPromises=new Map,this._id=T,this._shared=k,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(v=>(this._value=v,this)),this._storageListener=this._storage.onDidChangeStorage(v=>{v.shared===this._shared&&v.key===this._id&&(this._value=v.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const v=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of v.values())R.complete()}catch(R){for(const I of v.values())I.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,k){let y=this._value[T];return typeof y>"u"&&(y=k),y}update(T,k){this._value[T]=k;const y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const v=new a.DeferredPromise;return this._deferredPromises.set(T,v),this._scheduler.isScheduled()||this._scheduler.schedule(),v.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=P;class l extends P{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,k){super(T.identifier.value,!0,k),this._extension=T}}e.ExtensionGlobalMemento=l}),define(Ce[228],De([1,0,3,2]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,k,y,v){const I=this._notebooksAndEditors.getNotebookDocument(P.URI.revive(T)).acceptModelChanged(k.value,y,v);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(T,k){this._notebooksAndEditors.getNotebookDocument(P.URI.revive(T)).acceptDirty(k)}$acceptModelSaved(T){const k=this._notebooksAndEditors.getNotebookDocument(P.URI.revive(T));this._onDidSaveNotebookDocument.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(Ce[20],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class P{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=P});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[229],De([1,0,25,3]),function(re,e,a,P){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,y){l.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(k.identifier),Je(this,l,y,"f"),Ne(this,l,"f").onDidChangePassword(v=>{v.extensionId===this._id&&this._onDidChange.fire({key:v.key})})}get(k){return Ne(this,l,"f").get(this._id,k)}store(k,y){return Ne(this,l,"f").store(this._id,k,y)}delete(k){return Ne(this,l,"f").delete(this._id,k)}}e.ExtensionSecrets=A,l=new WeakMap}),define(Ce[55],De([1,0,4,130,3,20]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var T;(function(y){function v(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:I.protocol}}y.fromApiTunnel=v;function R(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==P.TunnelPrivacyId.ConstantPrivate&&I.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}y.fromServiceTunnel=R})(T=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let k=class{constructor(v){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(v){return v}async openTunnel(v,R){}async getTunnels(){return[]}async setTunnelFactory(v){return{dispose:()=>{}}}registerPortsAttributesProvider(v,R){return{dispose:()=>{}}}async $providePortAttributes(v,R,I,_,D){return[]}async $forwardPort(v,R){}async $closeTunnel(v){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([Be(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k}),define(Ce[56],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class P{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=P}),define(Ce[230],De([1,0,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let v=this.buffers.indexOf(y);return v<0&&(v=this.buffers.length,this.buffers.push(y)),v}}function l(k,y){if(y.serializeBuffersForPostMessage){const v=new P,R=(D,C)=>{if(C instanceof ArrayBuffer){const E=v.add(C);return{$$vscode_array_buffer_reference$$:!0,index:E}}else if(ArrayBuffer.isView(C)){const E=A(C);if(E){const n=v.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:n,view:{type:E,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},I=JSON.stringify(k,R),_=v.buffers.map(D=>{const C=new Uint8Array(D);return a.VSBuffer.wrap(C)});return{message:I,buffers:_}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=l;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(k,y){const v=y.map(_=>{const D=new ArrayBuffer(_.byteLength);return new Uint8Array(D).set(_.buffer),D}),R=y.length?(_,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const C=D,{index:E}=C,n=v[E];if(C.view)switch(C.view.type){case 1:return new Int8Array(n,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return D}:void 0;return{message:JSON.parse(k,R),arrayBuffers:v}}e.deserializeWebviewMessage=T}),define(Ce[231],De([1,0,115]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function P(A){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:A,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function l(A){return new a.URITransformer(P(A))}e.createURITransformer=l}),define(Ce[131],De([1,0,193,10,2,6,4,40,45,17,46,163,38]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(le){const ue=le;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.isEditorPaneWithSelection=E;function n(le,ue,j){for(const M of j.visibleEditorPanes)if(M.group.id===ue&&le.matches(M.input))return M.getViewState()}e.findViewStateForEditor=n;function d(le){if(s(le))return!1;const ue=le;return l.URI.isUri(ue?.resource)}e.isResourceEditorInput=d;function h(le){if(s(le))return!1;const ue=le;return ue?.original!==void 0&&ue.modified!==void 0}e.isResourceDiffEditorInput=h;function w(le){if(s(le)||h(le))return!1;const ue=le;return ue?.primary!==void 0&&ue.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function S(le){if(s(le))return!1;const ue=le;return ue?ue.resource===void 0||ue.resource.scheme===v.Schemas.untitled||ue.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const p=/Untitled-\d+/;function t(le){return le.scheme===v.Schemas.untitled&&le.path.length>1&&!p.test(le.path)}e.isUntitledWithAssociatedResource=t;function o(le){if(s(le))return!1;const ue=le;return l.URI.isUri(ue?.base?.resource)&&l.URI.isUri(ue?.input1?.resource)&&l.URI.isUri(ue?.input2?.resource)&&l.URI.isUri(ue?.result?.resource)}e.isResourceMergeEditorInput=o;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(ue,j){let M=this.mapIdToSaveSource.get(ue);return M||(M={source:ue,label:j},this.mapIdToSaveSource.set(ue,M)),M.source}getSourceLabel(ue){return this.mapIdToSaveSource.get(ue)?.label??ue}}e.SaveSourceRegistry=new m;var f;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends A.Disposable{}e.AbstractEditorInput=i;function s(le){return le instanceof i}e.isEditorInput=s;function u(le){const ue=le;return l.URI.isUri(ue?.preferredResource)}function b(le){const ue=le;return s(ue?.primary)&&s(ue?.secondary)}e.isSideBySideEditorInput=b;function g(le){const ue=le;return s(ue?.modified)&&s(ue?.original)}e.isDiffEditorInput=g;function L(le,ue,j,M,Y){return be(M,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const ge={...j,limits:{size:Number.MAX_VALUE}};le.openEditor(ue,ge)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>Y.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:_.default.Warning})}e.createTooLargeFileError=L;function H(le){return s(le?.editor)}e.isEditorInputWithOptions=H;function q(le){const ue=le;return H(le)&&ue?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function X(le){const ue=le;return typeof ue?.groupId=="number"&&s(ue.editor)}e.isEditorIdentifier=X;var U;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(ue,j){if(!ue)return;if(o(ue))return e.EditorResourceAccessor.getOriginalUri(ue.result,j);if(j?.supportSideBySide){const{primary:Y,secondary:ge}=this.getSideEditors(ue);if(Y&&ge){if(j?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===x.ANY)return this.getOriginalUri(Y,{filterByScheme:j.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:j.filterByScheme});ue=j.supportSideBySide===x.PRIMARY?Y:ge}}if(h(ue)||w(ue)||o(ue))return;const M=u(ue)?ue.preferredResource:ue.resource;return!M||!j||!j.filterByScheme?M:this.filterUri(M,j.filterByScheme)}getSideEditors(ue){return b(ue)||w(ue)?{primary:ue.primary,secondary:ue.secondary}:g(ue)||h(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,j){if(!ue)return;if(o(ue))return e.EditorResourceAccessor.getCanonicalUri(ue.result,j);if(j?.supportSideBySide){const{primary:Y,secondary:ge}=this.getSideEditors(ue);if(Y&&ge){if(j?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===x.ANY)return this.getCanonicalUri(Y,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:j.filterByScheme});ue=j.supportSideBySide===x.PRIMARY?Y:ge}}if(h(ue)||w(ue)||o(ue))return;const M=ue.resource;return!M||!j||!j.filterByScheme?M:this.filterUri(M,j.filterByScheme)}filterUri(ue,j){if(Array.isArray(j)){if(j.some(M=>ue.scheme===M))return ue}else if(j===ue.scheme)return ue}}e.EditorResourceAccessor=new F;var V;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(V=e.CloseDirection||(e.CloseDirection={}));class fe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ue){const j=this.instantiationService=ue.get(T.IInstantiationService);for(const[M,Y]of this.editorSerializerConstructors)this.createEditorSerializer(M,Y,j);this.editorSerializerConstructors.clear()}createEditorSerializer(ue,j,M){const Y=M.createInstance(j);this.editorSerializerInstances.set(ue,Y)}registerFileEditorFactory(ue){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ue}getFileEditorFactory(){return(0,P.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ue,j){if(this.editorSerializerConstructors.has(ue)||this.editorSerializerInstances.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ue,j,this.instantiationService):this.editorSerializerConstructors.set(ue,j),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(ue),this.editorSerializerInstances.delete(ue)})}getEditorSerializer(ue){return this.editorSerializerInstances.get(typeof ue=="string"?ue:ue.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function se(le,ue,j){return!le||!le.length?[]:await Promise.all(le.map(async M=>{const Y=l.URI.revive(M.fileUri);if(!Y){j.info("Cannot resolve the path because it is not valid.",M);return}if(!await ue.canHandleResource(Y)){j.info("Cannot resolve the path because it cannot be handled",M);return}let we=M.exists,ie=M.type;if(typeof we!="boolean"||typeof ie!="number")try{ie=(await ue.stat(Y)).isDirectory?y.FileType.Directory:y.FileType.Unknown,we=!0}catch(de){j.error(de),we=!1}if(!we&&M.openOnlyIfExists){j.info("Cannot resolve the path because it does not exist",M);return}if(ie===y.FileType.Directory){j.info("Cannot resolve the path because it is a directory",M);return}const ne={...M.options,pinned:!0};return we?{resource:Y,options:ne}:{resource:Y,options:ne,forceUntitled:!0}}))}e.pathsToEditors=se;var $;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function J(le){const ue=le;if(!ue)return!1;const j=ue;if(j.modified)return J(j.modified);const M=ue;return!!(M.contributionsState&&M.viewState&&Array.isArray(M.cursorState))}e.isTextEditorViewState=J;function te(le){return(0,R.isErrorWithActions)(le)}e.isEditorOpenError=te;function be(le,ue,j){const M=(0,R.createErrorWithActions)(le,ue);return M.forceMessage=j?.forceMessage,M.forceSeverity=j?.forceSeverity,M.allowDialog=j?.allowDialog,M}e.createEditorOpenError=be}),define(Ce[232],De([1,0,3,194,4,6,28,40,18,61,23,67,223]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,_.registerIcon)("default-view-icon",I.Codicon.window,(0,P.localize)(0,null));var D;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(D=e.Extensions||(e.Extensions={}));var C;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(C=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function E(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class n extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new a.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new a.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,y.flatten)([...this.viewContainers.values()])}registerViewContainer(c,m,f){const i=this.get(c.id);if(i)return i;const s=c;return s.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,T.getOrSet)(this.viewContainers,m,[]).push(s),f?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:m}),s}deregisterViewContainer(c){for(const m of this.viewContainers.keys()){const f=this.viewContainers.get(m),i=f?.indexOf(c);if(i!==-1){f?.splice(i,1),f.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:m});return}}}get(c){return this.all.filter(m=>m.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(f=>f?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===c)}}k.Registry.add(D.ViewContainersRegistry,new n);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function h(r,c){const m=r.group??d.More,f=c.group??d.More;return m!==f?m.localeCompare(f):(r.order??5)-(c.order??5)}class w extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new a.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new a.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new a.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new a.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new v.SetMap}registerViews(c,m){this.registerViews2([{views:c,viewContainer:m}])}registerViews2(c){c.forEach(({views:m,viewContainer:f})=>this.addViews(m,f)),this._onViewsRegistered.fire(c)}deregisterViews(c,m){const f=this.removeViews(c,m);f.length&&this._onViewsDeregistered.fire({views:f,viewContainer:m})}moveViews(c,m){for(const f of this._views.keys())if(f!==m){const i=this.removeViews(c,f);i.length&&(this.addViews(i,m),this._onDidChangeContainer.fire({views:i,from:f,to:m}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const m of this._viewContainers){const f=(this._views.get(m)||[]).filter(i=>i.id===c)[0];if(f)return f}return null}getViewContainer(c){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(i=>i.id===c)[0])return m;return null}registerViewWelcomeContent(c,m){return this._viewWelcomeContents.add(c,m),this._onDidChangeViewWelcomeContent.fire(c),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,m),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,m){const f=new Map;for(const[i,s]of m)this._viewWelcomeContents.add(c,s),f.set(i,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,s),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),f}getViewWelcomeContent(c){const m=[];return this._viewWelcomeContents.forEach(c,f=>m.push(f)),m.sort(h)}addViews(c,m){let f=this._views.get(m);f||(f=[],this._views.set(m,f),this._viewContainers.push(m));for(const i of c){if(this.getView(i.id)!==null)throw new Error((0,P.localize)(1,null,i.id));f.push(i)}}removeViews(c,m){const f=this._views.get(m);if(!f)return[];const i=[],s=[];for(const u of f)c.includes(u)?i.push(u):s.push(u);return i.length&&(s.length?this._views.set(m,s):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),i}}k.Registry.add(D.ViewsRegistry,new w),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var S;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(S=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(c,m){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,c),this._hasResolve=!!m,this.resolve=async f=>{if(m&&!this.resolved){const i=await m(f);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}f.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class o extends Error{constructor(c){super((0,P.localize)(2,null,c))}}e.NoTreeViewError=o}),define(Ce[132],De([1,0,3,19,195]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,v,R){const I={command:k};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof R=="number"){const _=setTimeout(()=>{clearTimeout(_);const D=this.pendingRequests.get(I.seq);if(D){this.pendingRequests.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,l.localize)(0,null,R,k)};D(C)}},R)}return v&&this.pendingRequests.set(I.seq,v),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,P.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback?.(k);break;case"request":this.requestCallback?.(k);break;case"response":{const y=k,v=this.pendingRequests.get(y.request_seq);v&&(this.pendingRequests.delete(y.request_seq),v(y));break}}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,v)=>k.set(v,y)),await(0,P.timeout)(500),k.forEach((y,v)=>{y({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(v)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Ce[233],De([1,0,196,44,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const A=_=>a.localize(51,null,_);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var T;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(T=e.State||(e.State={}));function k(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var y;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var v;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(v=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var I;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[234],De([1,0,9,2,15,23,17,32,21,18]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function I(i,s,u){return i.replace(R,function(b,g){return s&&g.length>0&&g[0]!=="_"?b:u&&u.hasOwnProperty(g)?u[g]:b})}e.formatPII=I;function _(i){const s={};for(const u of Object.keys(i))u.startsWith("!")||(s[u]=i[u]);return s}e.filterExceptionsFromTelemetry=_;function D(i){return i.configuration.request==="attach"&&!C(i)&&(!i.parentSession||D(i.parentSession))}e.isSessionAttach=D;function C(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(s,"extensionhost")||(0,a.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function E(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=E;function n(i,s,u){let b,g=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=L.exec(i);){const q=H.index+1,X=q+H[0].length;if(q<=s&&X>=u){b=H[0],g=q;break}}if(b){const q=/\w+/g;let X=null;for(;(X=q.exec(b))&&!(X.index+1+g+X[0].length>=u););X&&(b=b.substring(0,q.lastIndex))}return b?{start:g,end:g+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function d(i,s,u,b){if(i.evaluatableExpressionProvider.has(s)){const g=i.evaluatableExpressionProvider.ordered(s),L=(0,v.coalesce)(await Promise.all(g.map(async H=>{try{return await H.provideEvaluatableExpression(s,u,b??y.CancellationToken.None)}catch{return}})));if(L.length>0){let H=L[0].expression;const q=L[0].range;return H||(H=s.getLineContent(u.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:H}}}else{const g=s.getLineContent(u.lineNumber),{start:L,end:H}=n(g,u.column,u.column),q=g.substring(L-1,H);return{matchingExpression:q,range:new k.Range(u.lineNumber,L,u.lineNumber,L+q.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(h))}e.isUri=w;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return P.URI.parse(i.path);if((0,l.isAbsolute)(i.path))return P.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const s=P.URI.revive(i.path);if(s)return s.scheme===T.Schemas.file?s.fsPath:s.toString()}return i.path}function t(i,s){const u=s?S:p,b=(0,A.deepClone)(i);return r(b,(g,L)=>{g&&L&&(L.path=u(L))}),b}e.convertToDAPaths=t;function o(i,s){const u=s?S:p,b=(0,A.deepClone)(i);return r(b,(g,L)=>{!g&&L&&(L.path=u(L))}),b}e.convertToVSCPaths=o;function r(i,s){switch(i.type){case"event":{const u=i;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=i;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>s(!1,b));break;default:break}break}case"response":{const u=i;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":u.body.sources.forEach(b=>s(!1,b));break;case"scopes":u.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":u.body.breakpoints.forEach(b=>s(!1,b.source));break;case"disassemble":u.body?.instructions.forEach(g=>s(!1,g.location));break;default:break}break}}}function c(i){return i.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):m(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:m(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=c;function m(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}async function f(i,s){const u=i.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const b=s.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await s.save({editor:b.input,groupId:b.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(Ce[235],De([1,0,47,236,23,15,14,9,29,197,132]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends R.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(d,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,d.on("data",w=>this.handleData(w))}sendMessage(d){if(this.outputStream){const h=JSON.stringify(d);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${I.TWO_CRLF}${h}`,"utf8")}}handleData(d){for(this.rawData=Buffer.concat([this.rawData,d]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(w){this._onError.fire(new Error((w.message||w)+`
`+h))}continue}}else{const h=this.rawData.indexOf(I.TWO_CRLF);if(h!==-1){const S=this.rawData.toString("utf8",0,h).split(I.HEADER_LINESEPARATOR);for(const p of S){const t=p.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(h+I.TWO_CRLF.length);continue}}break}}}I.TWO_CRLF=`\r
\r
`,I.HEADER_LINESEPARATOR=/\r?\n/,I.HEADER_FIELDSEPARATOR=/: */,e.StreamDebugAdapter=I;class _ extends I{startSession(){return new Promise((d,h)=>{let w=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),d(),w=!0}),this.socket.on("close",()=>{w?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",S=>{w?this._onError.fire(S):h(S)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=_;class D extends _{constructor(d){super(),this.adapterServer=d}createConnection(d){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",d)}}e.SocketDebugAdapter=D;class C extends _{constructor(d){super(),this.adapterServer=d}createConnection(d){return P.createConnection(this.adapterServer.path,d)}}e.NamedPipeDebugAdapter=C;class E extends I{constructor(d,h){super(),this.adapterExecutable=d,this.debugType=h}async startSession(){const d=this.adapterExecutable.command,h=this.adapterExecutable.args,w=this.adapterExecutable.options||{};try{if(d)if(A.isAbsolute(d)){if(!await y.Promises.exists(d))throw new Error(v.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.debugType));let S=process.env;if(w.env&&Object.keys(w.env).length>0&&(S=l.mixin(l.deepClone(process.env),w.env)),d==="node")if(Array.isArray(h)&&h.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:S,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};w.cwd&&(t.cwd=w.cwd);const o=a.fork(h[0],h.slice(1),t);if(!o.pid)throw new Error(v.localize(2,null,h[0]));this.serverProcess=o}else throw new Error(v.localize(3,null));else{const p={env:S};w.cwd&&(p.cwd=w.cwd),this.serverProcess=a.spawn(d,h,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,t)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(S){this._onError.fire(S)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((d,h)=>{const w=a.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(S,p,t){if(S)return h(S)});w.on("exit",d),w.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(d,h){if(!d)return;const w=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?w.runtime=A.join(h,d.runtime):w.runtime=d.runtime),d.runtimeArgs&&(w.runtimeArgs=d.runtimeArgs),d.program&&(A.isAbsolute(d.program)?w.program=d.program:w.program=A.join(h,d.program)),d.args&&(w.args=d.args);const S=d;return S.win&&(w.win=E.extract(S.win,h)),S.winx86&&(w.winx86=E.extract(S.winx86,h)),S.windows&&(w.windows=E.extract(S.windows,h)),S.osx&&(w.osx=E.extract(S.osx,h)),S.linux&&(w.linux=E.extract(S.linux,h)),w}static platformAdapterExecutable(d,h){let w=Object.create(null);h=h.toLowerCase();for(const c of d)if(c.contributes){const m=c.contributes.debuggers;m&&m.length>0&&m.filter(f=>typeof f.type=="string"&&k.equalsIgnoreCase(f.type,h)).forEach(f=>{const i=E.extract(f,c.extensionLocation.fsPath);w=l.mixin(w,i,c.isBuiltin)})}let S;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?S=w.winx86||w.win||w.windows:T.isWindows?S=w.win||w.windows:T.isMacintosh?S=w.osx:T.isLinux&&(S=w.linux),S=S||w;const p=S.program||w.program,t=S.args||w.args,o=S.runtime||w.runtime,r=S.runtimeArgs||w.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=E}),define(Ce[237],De([1,0,47,34,14]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(v,R){return new Promise((I,_)=>{let D="";const C=a.spawn(v,R);C.pid&&C.stdout.on("data",E=>{D+=E.toString()}),C.on("error",E=>{_(E)}),C.on("close",E=>{I(D)})})}async function T(v){if(v)if(l.isWindows){const R=await new Promise((I,_)=>{re(["windows-process-tree"],I,_)});return new Promise(I=>{R.getProcessTree(v,_=>{I(!!_&&_.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=T;var k;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(k||(k={}));function y(v,R,I,_,D){v=v.trim().toLowerCase();let C;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?C=1:v.indexOf("cmd.exe")>=0?C=0:v.indexOf("bash")>=0?C=2:l.isWindows?C=0:C=2;let E,n=" ";switch(C){case 1:if(E=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),_){const d=(0,P.getDriveLetter)(_);d&&(n+=`${d}:; `),n+=`cd ${E(_)}; `}if(D)for(const d in D){const h=D[d];h===null?n+=`Remove-Item env:${d}; `:n+=`\${env:${d}}='${h}'; `}if(R.length>0){const d=R.shift(),h=I?d:E(d);n+=h[0]==="'"?`& ${h} `:`${h} `;for(const w of R)n+=w==="<"||w===">"||I?w:E(w),n+=" "}break;case 0:if(E=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(h=>d.includes(h))||d.length===0?`"${d}"`:d),_){const d=(0,P.getDriveLetter)(_);d&&(n+=`${d}: && `),n+=`cd ${E(_)} && `}if(D){n+='cmd /C "';for(const d in D){let h=D[d];h===null?n+=`set "${d}=" && `:(h=h.replace(/[&^|<>]/g,w=>`^${w}`),n+=`set "${d}=${h}" && `)}}for(const d of R)n+=d==="<"||d===">"||I?d:E(d),n+=" ";D&&(n+='"');break;case 2:{E=h=>(h=h.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),h.length===0?'""':h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(_&&(n+=`cd ${E(_)} ; `),D){n+="/usr/bin/env";for(const h in D){const w=D[h];w===null?n+=` -u ${d(h)}`:n+=` ${d(`${h}=${w}`)}`}n+=" "}for(const h of R)n+=h==="<"||h===">"||I?h:E(h),n+=" ";break}}return n}e.prepareCommand=y}),define(Ce[94],De([1,0,22,39,64,89,17,15,14,44]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var E;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(E=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var h;(function(x){x.scheme=T.Schemas.vscodeNotebookCell;const F=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${F.join("")}]+`),fe=7;function se(ue,j){const M=j.toString(fe),ge=`${M.length<F.length?F[M.length-1]:"z"}${M}s${(0,a.encodeBase64)(a.VSBuffer.fromString(ue.scheme),!0,!0)}`;return ue.with({scheme:x.scheme,fragment:ge})}x.generate=se;function $(ue){if(ue.scheme!==x.scheme)return;const j=ue.fragment.indexOf("s");if(j<0)return;const M=parseInt(ue.fragment.substring(0,j).replace(V,""),fe),Y=(0,a.decodeBase64)(ue.fragment.substring(j+1)).toString();if(!isNaN(M))return{handle:M,notebook:ue.with({scheme:Y,fragment:null})}}x.parse=$;function J(ue,j){return ue.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${j??""},${ue.scheme!==T.Schemas.file?ue.scheme:""}`})}x.generateCellOutputUri=J;function te(ue){if(ue.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const j=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!j)return;const M=j[1]&&j[1]!==""?j[1]:void 0,Y=j[2];return{outputId:M,notebook:ue.with({scheme:Y||T.Schemas.file,fragment:null})}}x.parseCellOutputUri=te;function be(ue,j,M){return x.generate(ue,j).with({scheme:M})}x.generateCellPropertyUri=be;function le(ue,j){if(ue.scheme===j)return x.parse(ue.with({scheme:x.scheme}))}x.parseCellPropertyUri=le})(h=e.CellUri||(e.CellUri={}));const w=x=>y.isWindows?x.replace(/\//g,"\\"):x;class S{constructor(F=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=V,this.order=[...new Set(F)].map(fe=>({pattern:fe,matches:P.parse(w(fe))}))}sort(F){const V=new Map(l.Iterable.map(F,se=>[se,w(se)]));let fe=[];for(const{matches:se}of this.order)for(const[$,J]of V)if(se(J)){fe.push($),V.delete($);break}return V.size&&(fe=fe.concat([...V.keys()].sort((se,$)=>this.defaultOrder.indexOf(se)-this.defaultOrder.indexOf($)))),fe}prioritize(F,V){const fe=this.findIndex(F);if(fe===-1){this.order.unshift({pattern:F,matches:P.parse(w(F))});return}const se=new Set(V.map(J=>this.findIndex(J,fe)));se.delete(-1);const $=Array.from(se).sort();this.order.splice(fe+1,0,...$.map(J=>this.order[J]));for(let J=$.length-1;J>=0;J--)this.order.splice($[J],1)}toArray(){return this.order.map(F=>F.pattern)}findIndex(F,V=this.order.length){const fe=w(F);for(let se=0;se<V;se++)if(this.order[se].matches(fe))return se;return-1}}e.MimeTypeDisplayOrder=S;function p(x,F,V,fe=(se,$)=>se===$){const se=[];function $(be,le,ue){if(le===0&&ue.length===0)return;const j=se[se.length-1];j&&j.start+j.deleteCount===be?(j.deleteCount+=le,j.toInsert.push(...ue)):se.push({start:be,deleteCount:le,toInsert:ue})}let J=0,te=0;for(;;){if(J===x.length){$(J,0,F.slice(te));break}if(te===F.length){$(J,x.length-J,[]);break}const be=x[J],le=F[te];if(fe(be,le)){J+=1,te+=1;continue}V(le)?($(J,1,[]),J+=1):($(J,0,[le]),te+=1)}return se}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(x){x.default="default",x.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(x){const F=x;return!!((typeof F.include=="string"||P.isRelativePattern(F.include))&&(typeof F.exclude=="string"||P.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=o;function r(x,F,V){if(Array.isArray(x.viewType)&&x.viewType.indexOf(F)>=0||x.viewType===F)return!0;if(x.filenamePattern){const fe=o(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,se=o(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(P.match(fe,(0,k.basename)(V.fsPath).toLowerCase()))return!(se&&P.match(se,(0,k.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(F){return`${m._prefix}${F}`}static parse(F){if(F.startsWith(m._prefix))return F.substring(m._prefix.length)}}m._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=m;function f(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=f;const i=new TextDecoder;function s(x){const F=[];let V=!1;for(const fe of x)(F.length===0||V)&&(F.push(fe),V=!0);return L(F),N(a.VSBuffer.concat(F.map(fe=>a.VSBuffer.wrap(fe))))}e.compressOutputItemStreams=s;const u=`${String.fromCharCode(27)}[A`,b=u.split("").map(x=>x.charCodeAt(0)),g=10;function L(x){x.forEach((F,V)=>{if(V===0||F.length<u.length)return;const fe=x[V-1],se=F.subarray(0,u.length);if(se[0]===b[0]&&se[1]===b[1]&&se[2]===b[2]){const $=fe.lastIndexOf(g);if($===-1)return;x[V-1]=fe.subarray(0,$),x[V]=F.subarray(u.length)}})}function H(x){let F=x;do x=F,F=x.replace(/[^\n]\x08/gm,"");while(F.length<x.length);return x}function q(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const F=x.match(/^(.*)\r+/m)[1];let V=x.match(/\r+(.*)$/m)[1];V=V+F.slice(V.length,F.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return x}const X="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(x){return!x.buffer.includes(X)&&!x.buffer.includes(U)?x:a.VSBuffer.fromString(q(H(i.decode(x.buffer))))}}),define(Ce[238],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(P=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ce[57],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(T,k,y=T.parent){if(T._isRoot)return new l([k]);const v=[T.id];for(let R=y;R&&R.id!==k;R=R.parent)v.push(R.id);return v.push(k),new l(v.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const k=T.indexOf("\0");return k===-1?T:T.slice(0,k)}static fromString(T){return new l(T.split("\0"))}static join(T,k){return new l([...T.path,k])}static joinToString(T,k){return T.toString()+"\0"+k}static parentId(T){const k=T.lastIndexOf("\0");return k===-1?void 0:T.slice(0,k)}static localId(T){const k=T.lastIndexOf("\0");return k===-1?T:T.slice(k+1)}static compare(T,k){return T===k?0:k.startsWith(T+"\0")?2:T.startsWith(k+"\0")?3:1}constructor(T,k=T.length){if(this.path=T,this.viewEnd=k,T.length===0||k<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new l(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new l(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new l(this.path,T)}compare(T){if(typeof T=="string")return l.compare(this.toString(),T);for(let k=0;k<T.viewEnd&&k<this.viewEnd;k++)if(T.path[k]!==this.path[k])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=l}),define(Ce[77],De([1,0,2,32,57]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var T;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const k=i=>"runId"in i;e.isStartControllerTests=k;var y;(function(i){i.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),i.deserialize=s=>({range:P.Range.lift(s.range),uri:a.URI.revive(s.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var v;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(v=e.TestMessageType||(e.TestMessageType={}));var R;(function(i){i.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.deserialize(s.location)})})(R=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(i,s)=>`${s?"s":"e"}${i}`;e.getMarkId=I;var _;(function(i){i.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.deserialize(s.location)})})(_=e.ITestOutputMessage||(e.ITestOutputMessage={}));var D;(function(i){i.serialize=s=>s.type===0?R.serialize(s):_.serialize(s),i.deserialize=s=>s.type===0?R.deserialize(s):_.deserialize(s)})(D=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),i.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(D.serialize)}),i.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(D.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",n=(i,s)=>i+E+s;e.namespaceTestTag=n;const d=i=>{const s=i.indexOf(E);return{ctrlId:i.slice(0,s),tagId:i.slice(s+1)}};e.denamespaceTestTag=d;var h;(function(i){i.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),i.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?a.URI.revive(s.uri):void 0,range:s.range?P.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(h=e.ITestItem||(e.ITestItem={}));var w;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(i){i.serialize=s=>({expand:s.expand,item:h.serialize(s.item)}),i.deserialize=s=>({controllerId:l.TestId.root(s.item.extId),expand:s.expand,item:h.deserialize(s.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.uri!==void 0&&(u.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(u.range=s.item.range?.toJSON()),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}},i.deserialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.range!==void 0&&(u.range=s.item.range?P.Range.lift(s.item.range):null),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,s)=>{s.expand!==void 0&&(i.expand=s.expand),s.item!==void 0&&(i.item=i.item?Object.assign(i.item,s.item):s.item)};e.applyTestItemUpdate=t;var o;(function(i){i.serializeWithoutMessages=s=>({...S.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(C.serializeWithoutMessages),retired:s.retired}),i.serialize=s=>({...S.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(C.serialize),retired:s.retired}),i.deserialize=s=>({...S.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(C.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var m;(function(i){i.deserialize=s=>s.op===0?{op:s.op,item:S.deserialize(s.item)}:s.op===1?{op:s.op,item:p.deserialize(s.item)}:s.op===2?{op:s.op,uri:a.URI.revive(s.uri),docv:s.docv}:s,i.serialize=s=>s.op===0?{op:s.op,item:S.serialize(s.item)}:s.op===1?{op:s.op,item:p.serialize(s.item)}:s})(m=e.TestsDiffOp||(e.TestsDiffOp={}));class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const u=this.createChangeCollector();for(const b of s)switch(b.op){case 0:this.add(S.deserialize(b.item),u);break;case 1:this.update(p.deserialize(b.item),u);break;case 3:this.remove(b.itemId,u);break;case 5:this.retireTest(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this._tags.set(b.tag.id,b.tag);break;case 7:this._tags.delete(b.id);break}u.complete?.()}add(s,u){const b=l.TestId.parentId(s.item.extId)?.toString();let g;if(!b)g=this.createItem(s),this.roots.add(g),this.items.set(s.item.extId,g);else if(this.items.has(b)){const L=this.items.get(b);L.children.add(s.item.extId),g=this.createItem(s,L),this.items.set(s.item.extId,g)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return u.add?.(g),s.expand===2&&this.busyControllerCount++,g}update(s,u){const b=this.items.get(s.extId);if(!!b)return s.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,s),u.update?.(b),b}remove(s,u){const b=this.items.get(s);if(!b)return;const g=l.TestId.parentId(b.item.extId)?.toString();g?this.items.get(g).children.delete(b.item.extId):this.roots.delete(b);const L=[[s]];for(;L.length;)for(const H of L.pop()){const q=this.items.get(H);q&&(L.push(q.children),this.items.delete(H),u.remove?.(q,q!==b),q.expand===2&&this.busyControllerCount--)}}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=f}),define(Ce[95],De([1,0,19,3,6,51,77,57]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const v=(h,w)=>h===w,I=Object.entries({range:(h,w)=>h===w?!0:!h||!w?!1:h.equalsRange(w),busy:v,label:v,description:v,error:v,sortText:v,tags:(h,w)=>!(h.length!==w.length||h.some(S=>!w.includes(S)))}),_=(h,w)=>{let S;for(const[p,t]of I)t(h[p],w[p])||(S?S[p]=w[p]:S={[p]:w[p]});return S};class D extends l.Disposable{get root(){return this.options.root}constructor(w){super(),this.options=w,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new P.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(w){this._resolveHandler=w;for(const S of this.tree.values())this.updateExpandability(S)}get resolveHandler(){return this._resolveHandler}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){switch(w.op){case 2:{for(const S of this.diff)if(S.op===2&&S.uri===w.uri){S.docv=w.docv;return}break}case 1:{const S=this.diff[this.diff.length-1];if(S){if(S.op===1&&S.item.extId===w.item.extId){(0,T.applyTestItemUpdate)(S.item,w.item);return}if(S.op===0&&S.item.item.extId===w.item.extId){(0,T.applyTestItemUpdate)(S.item,w.item);return}}break}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,S){const p=this.tree.get(w);if(!!p){if((p.expandLevels===void 0||S>p.expandLevels)&&(p.expandLevels=S),p.expand===1){const t=this.resolveChildren(p);return t.isOpen()?this.expandChildren(p,S-1):t.wait().then(()=>this.expandChildren(p,S-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,S-1)):this.expandChildren(p,S-1)}}dispose(){for(const w of this.tree.values())this.options.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(w,S){switch(S.op){case 3:this.removeItem(k.TestId.joinToString(w.fullId,S.id));break;case 0:this.upsertItem(S.item,w);break;case 5:for(const p of S.ops)this.onTestItemEvent(w,p);break;case 1:this.diffTagRefs(S.new,S.old,w.fullId.toString());break;case 2:this.updateExpandability(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:S.update}});break;case 6:this.documentSynced(w.actual.uri);break;default:(0,A.assertNever)(S)}}documentSynced(w){w&&this.pushDiff({op:2,uri:w,docv:this.options.getDocumentVersion(w)})}upsertItem(w,S){const p=k.TestId.fromExtHostTestItem(w,this.root.id,S?.actual),t=this.options.getApiFor(w);t.parent&&t.parent!==S?.actual&&this.options.getChildren(t.parent).delete(w.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:w,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},w.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(w,S),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(w)}}),this.connectItemAndChildren(w,o,S);return}if(o.actual===w){this.connectItem(w,o,S);return}if(o.actual.uri?.toString()!==w.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(w,S);const r=this.options.getChildren(o.actual),c=o.actual,m=_(this.options.toITestItem(c),this.options.toITestItem(w));this.options.getApiFor(c).listener=void 0,o.actual=w,o.expand=0,m&&(m.hasOwnProperty("tags")&&(this.diffTagRefs(w.tags,c.tags,p.toString()),delete m.tags),this.onTestItemEvent(o,{op:4,update:m})),this.connectItemAndChildren(w,o,S);for(const[f,i]of r)this.options.getChildren(w).get(i.id)||this.removeItem(k.TestId.joinToString(p,i.id));this.documentSynced(o.actual.uri)}diffTagRefs(w,S,p){const t=new Set(S.map(o=>o.id));for(const o of w)t.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:p,item:{tags:w.map(o=>(0,T.namespaceTestTag)(this.options.controllerId,o.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(w){const S=this.tags.get(w.id);S?S.refCount++:(this.tags.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,w.id)}}))}decrementTagRefs(w){const S=this.tags.get(w);S&&!--S.refCount&&(this.tags.delete(w),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,w)}))}setItemParent(w,S){this.options.getApiFor(w).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(w,S,p){this.setItemParent(w,p);const t=this.options.getApiFor(w);t.parent=p?.actual,t.listener=o=>this.onTestItemEvent(S,o),this.updateExpandability(S)}connectItemAndChildren(w,S,p){this.connectItem(w,S,p);for(const[t,o]of this.options.getChildren(w))this.upsertItem(o,S)}updateExpandability(w){let S;this._resolveHandler?w.resolveBarrier?S=w.resolveBarrier.isOpen()?3:2:S=w.actual.canResolveChildren?1:0:S=0,S!==w.expand&&(w.expand=S,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:S}}),S===1&&w.expandLevels!==void 0&&this.resolveChildren(w))}expandChildren(w,S){if(S<0)return;const p=[];for(const[t,o]of this.options.getChildren(w.actual)){const r=this.expand(k.TestId.joinToString(w.fullId,o.id),S);(0,a.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this._resolveHandler){const o=new a.Barrier;return o.open(),o}w.expand=2,this.pushExpandStateUpdate(w);const S=w.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let t;try{t=this._resolveHandler(w.actual===this.root?void 0:w.actual)}catch(o){p(o)}return(0,a.isThenable)(t)?t.catch(p).then(()=>{S.open(),this.updateExpandability(w)}):(S.open(),this.updateExpandability(w)),w.resolveBarrier}pushExpandStateUpdate(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}removeItem(w){const S=this.tree.get(w);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const p=[S];for(;p.length;){const t=p.pop();if(!!t){this.options.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(t.fullId.toString());for(const[o,r]of this.options.getChildren(t.actual))p.push(this.tree.get(k.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.diffOpEmitter.fire(w)}}e.TestItemCollection=D;class C extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=C;class E extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class n extends Error{constructor(w,S,p){super(`TestItem with ID "${w}" is from controller "${S}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=n;const d=(h,w,S)=>{let p=new Map;return{get size(){return p.size},forEach(t,o){for(const r of p.values())t.call(o,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const o=new Map,r=new Set(p.keys()),c={op:5,ops:[]};for(const m of t){if(!(m instanceof S))throw new E(m.id);const f=w(m).controllerId;if(f!==h.controllerId)throw new n(m.id,f,h.controllerId);if(o.has(m.id))throw new C(m.id);o.set(m.id,m),r.delete(m.id),c.ops.push({op:0,item:m})}for(const m of r.keys())c.ops.push({op:3,id:m});h.listener?.(c),p=o},add(t){if(!(t instanceof S))throw new E(t.id);p.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){p.delete(t)&&h.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=d}),define(Ce[133],De([1,0,95]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,l=(T,k)=>{const y={controllerId:k};return P.set(T,y),y};e.createPrivateApiFor=l;const A=T=>{const k=P.get(T);if(!k)throw new a.InvalidTestItemError(T?.id||"<unknown>");return k};e.getPrivateApiFor=A}),define(Ce[96],De([1,0,17,2]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(k,y){return k.scheme===a.Schemas.http||k.scheme===a.Schemas.https?k:(y&&y.authority&&y.isRemote&&k.scheme===a.Schemas.file&&(k=P.URI.from({scheme:a.Schemas.vscodeRemote,authority:y.authority,path:k.path})),P.URI.from({scheme:a.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=l;function A(k){return k.replace(/./g,y=>{const v=y.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?y:"-"+v.toString(16).padStart(4,"0")})}function T(k){return k.replace(/-([0-9a-f]{4})/g,(y,v)=>String.fromCharCode(parseInt(v,16)))}e.decodeAuthority=T}),define(Ce[239],De([1,0,3,6,96]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,y,v){this._proxy=k,this._editors=y,this._remoteInfo=v,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const I of this._insets.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,y,v,R,I){let _;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===k){_=w;break}if(!_)throw new Error("not a visible editor");const D=this,C=this._handlePool++,E=new a.Emitter,n=new a.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,l.asWebviewUri)(w,D._remoteInfo)}get cspSource(){return l.webviewGenericCspSource}set options(w){this._options=w,D._proxy.$setOptions(C,w)}get options(){return this._options}set html(w){this._html=w,D._proxy.$setHtml(C,w)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(w){return D._proxy.$postMessage(C,w)}},h=new class{constructor(){this.editor=k,this.line=y,this.height=v,this.webview=d,this.onDidDispose=n.event}dispose(){D._insets.has(C)&&(D._insets.delete(C),D._proxy.$disposeEditorInset(C),n.fire(),n.dispose(),E.dispose())}};return this._proxy.$createEditorInset(C,_.id,_.value.document.uri,y+1,v,R||{},I.identifier,I.extensionLocation),this._insets.set(C,{editor:k,inset:h,onDidReceiveMessage:E}),h}$onDidDispose(k){const y=this._insets.get(k);y&&y.inset.dispose()}$onDidReceiveMessage(k,y){this._insets.get(k)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(Ce[240],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var P;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(P=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(T,k){super(k),this.variable=T}}e.VariableError=l}),define(Ce[241],De([1,0,15,33,10,23,14,114,200,240,9]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(D,C,E,n){this._contributedVariables=new Map,this._context=D,this._labelService=C,this._userHomePromise=E,n&&(this._envVariablesPromise=n.then(d=>this.prepareEnv(d)))}prepareEnv(D){if(T.isWindows){const C=Object.create(null);return Object.keys(D).forEach(E=>{C[E.toLowerCase()]=D[E]}),C}return D}resolveWithEnvironment(D,C,E){return this.recursiveResolve({env:this.prepareEnv(D),userHome:void 0},C?C.uri:void 0,E)}async resolveAsync(D,C){const E={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(E,D?D.uri:void 0,C)}async resolveAnyBase(D,C,E,n){const d=A.deepClone(C);T.isWindows&&d.windows?Object.keys(d.windows).forEach(w=>d[w]=d.windows[w]):T.isMacintosh&&d.osx?Object.keys(d.osx).forEach(w=>d[w]=d.osx[w]):T.isLinux&&d.linux&&Object.keys(d.linux).forEach(w=>d[w]=d.linux[w]),delete d.windows,delete d.osx,delete d.linux;const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,D?D.uri:void 0,d,E,n)}async resolveAnyAsync(D,C,E){return this.resolveAnyBase(D,C,E)}async resolveAnyMap(D,C,E){const n=new Map;return{newConfig:await this.resolveAnyBase(D,C,E,n),resolvedVariables:n}}resolveWithInteractionReplace(D,C,E,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,C,E,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,C){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,C)}async recursiveResolve(D,C,E,n,d){if(l.isString(E))return this.resolveString(D,C,E,n,d);if(Array.isArray(E))return Promise.all(E.map(h=>this.recursiveResolve(D,C,h,n,d)));if(l.isObject(E)){const h=Object.create(null),w=await Promise.all(Object.keys(E).map(async S=>[await this.resolveString(D,C,S,n,d),await this.recursiveResolve(D,C,E[S],n,d)]));for(const[S,p]of w)h[S]=p;return h}return E}resolveString(D,C,E,n,d){return(0,R.replaceAsync)(E,I.VARIABLE_REGEXP,async(h,w)=>{if(w.includes(I.VARIABLE_LHS))return h;let S=await this.evaluateSingleVariable(D,h,w,C,n);return d?.set(w,S),S!==h&&l.isString(S)&&S.match(I.VARIABLE_REGEXP)&&(S=await this.resolveString(D,C,S,n,d)),S})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}async evaluateSingleVariable(D,C,E,n,d){let h;const w=E.split(":");w.length>1&&(E=w[0],h=w[1]);const S=o=>{const r=this._context.getFilePath();if(r)return(0,k.normalizeDriveLetter)(r);throw new v.VariableError(o,(0,y.localize)(0,null,C))},p=o=>{const r=S(o);if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return(0,k.normalizeDriveLetter)(c)}throw new v.VariableError(o,(0,y.localize)(1,null,C,a.basename(r)))},t=o=>{if(h){const r=this._context.getFolderUri(h);if(r)return r;throw new v.VariableError(o,(0,y.localize)(2,null,C,h))}if(n)return n;throw this._context.getWorkspaceFolderCount()>1?new v.VariableError(o,(0,y.localize)(3,null,C)):new v.VariableError(o,(0,y.localize)(4,null,C))};switch(E){case"env":if(h){if(D.env){const o=D.env[T.isWindows?h.toLowerCase():h];if(l.isString(o))return o}return""}throw new v.VariableError(v.VariableKind.Env,(0,y.localize)(5,null,C));case"config":if(h){const o=this._context.getConfigurationValue(n,h);if(l.isUndefinedOrNull(o))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(6,null,C,h));if(l.isObject(o))throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(7,null,C,h));return o}throw new v.VariableError(v.VariableKind.Config,(0,y.localize)(8,null,C));case"command":return this.resolveFromMap(v.VariableKind.Command,C,h,d,"command");case"input":return this.resolveFromMap(v.VariableKind.Input,C,h,d,"input");case"extensionInstallFolder":if(h){const o=await this._context.getExtension(h);if(!o)throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,C,h));return this.fsPath(o.extensionLocation)}throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,C));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(t(v.VariableKind.WorkspaceFolder)));case"cwd":return n||h?(0,k.normalizeDriveLetter)(this.fsPath(t(v.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.normalizeDriveLetter)(a.basename(this.fsPath(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new v.VariableError(v.VariableKind.UserHome,(0,y.localize)(11,null,C))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new v.VariableError(v.VariableKind.LineNumber,(0,y.localize)(12,null,C))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new v.VariableError(v.VariableKind.SelectedText,(0,y.localize)(13,null,C))}case"file":return S(v.VariableKind.File);case"fileWorkspaceFolder":return p(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||h?a.relative(this.fsPath(t(v.VariableKind.RelativeFile)),S(v.VariableKind.RelativeFile)):S(v.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(S(v.VariableKind.RelativeFileDirname));if(n||h){const r=a.relative(this.fsPath(t(v.VariableKind.RelativeFileDirname)),o);return r.length===0?".":r}return o}case"fileDirname":return a.dirname(S(v.VariableKind.FileDirname));case"fileExtname":return a.extname(S(v.VariableKind.FileExtname));case"fileBasename":return a.basename(S(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(S(v.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(S(v.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||C}case"execInstallFolder":{const o=this._context.getAppRoot();return o||C}case"pathSeparator":return a.sep;default:try{const o=h?`${E}:${h}`:E;return this.resolveFromMap(v.VariableKind.Unknown,C,o,d,void 0)}catch{return C}}}}resolveFromMap(D,C,E,n,d){if(E&&n){const h=d===void 0?n[E]:n[d+":"+E];if(typeof h=="string")return h;throw new v.VariableError(D,(0,y.localize)(14,null,C))}return C}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(Ce[134],De([1,0,4,131]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var l;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var A;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var k;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function v(C){const E=C;return(0,P.isEditorInput)(E?.editor)&&(0,P.isEditorInput)(E?.replacement)}e.isEditorReplacement=v;var R;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function _(C){const E=C;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=_;function D(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(Ce[242],De([1,0,4,134]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(A){const T=A;return typeof A=="number"||(0,P.isEditorGroup)(T)}e.isPreferredGroup=l}),define(Ce[243],De([1,0,4,207]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(P.IEnvironmentService)}),define(Ce[135],De([1,0,25,3,15,6]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class k{static isHostExtension(n,d,h){if(d.getExtensionDescription(n))return!1;const w=h.getExtensionDescription(n);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(n,d){this._activationEventsReader=n,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=d,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new a.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const d=this._activationEventsReader.readActivationEvents(n);if(Array.isArray(d))for(let h of d)h==="onUri"&&(h=`onUri:${a.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(h)||this._activationMap.set(h,[]),this._activationMap.get(h).push(n)}}set(n){this._extensionDescriptions=n,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,d){this._extensionDescriptions=C(this._extensionDescriptions,d),this._extensionDescriptions=this._extensionDescriptions.concat(n);const h=k._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=C(this._extensionDescriptions,h.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(h)}static _findLoopingExtensions(n){const d=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(t){this._nodesSet.has(t)||(this._nodesSet.add(t),this._nodesArr.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this._arcs.has(t)?this._arcs.get(t).push(o):this._arcs.set(t,[o])}getArcs(t){return this._arcs.has(t)?this._arcs.get(t):[]}hasOnlyGoodArcs(t,o){const r=d.getArcs(t);for(let c=0;c<r.length;c++)if(!o.has(r[c]))return!1;return!0}getNodes(){return this._nodesArr}},h=new a.ExtensionIdentifierMap;for(const t of n)if(h.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)d.addArc(a.ExtensionIdentifier.toKey(t.identifier),a.ExtensionIdentifier.toKey(o));const w=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>w.add(t));const S=d.getNodes().filter(t=>!w.has(t));let p;do{p=!1;for(let t=0;t<S.length;t++){const o=S[t];d.hasOnlyGoodArcs(o,w)&&(S.splice(t,1),t--,w.add(o),p=!0)}}while(p);return S.map(t=>h.get(t))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const d=this._activationMap.get(n);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const d=this._extensionsMap.get(n);return d||void 0}getExtensionDescriptionByUUID(n){for(const d of this._extensionsArr)if(d.uuid===n)return d}getExtensionDescriptionByIdOrUUID(n,d){return this.getExtensionDescription(n)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=k,e.basicActivationEventsReader={readActivationEvents:E=>E.activationEvents};class y{constructor(n){this._lock=new I,this._actual=new k(n,[])}async acquireLock(n){const d=await this._lock.acquire(n);return new v(this,d)}deltaExtensions(n,d,h){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(d,h)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,d){return this._actual.getExtensionDescriptionByIdOrUUID(n,d)}}e.LockableExtensionDescriptionRegistry=y;class v extends A.Disposable{constructor(n,d){super(),this._registry=n,this._isDisposed=!1,this._register(d)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=v;class R{constructor(n){this.name=n,this.promise=new Promise((d,h)=>{this._resolve=d})}resolve(n){this._resolve(n)}}class I{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const d=new R(n);return this._pendingCustomers.push(d),this._advance(),d.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let d=!0;const h=setTimeout(()=>{d&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),w=()=>{!d||(clearTimeout(h),d=!1,this._isLocked=!1,this._advance())};n.resolve((0,A.toDisposable)(w))}}var _;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})(_||(_={}));function D(E,n){const d=E.isBuiltin?0:E.isUnderDevelopment?2:1,h=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(d!==h)return d-h;const w=l.posix.basename(E.extensionLocation.path),S=l.posix.basename(n.extensionLocation.path);return w<S?-1:w>S?1:0}function C(E,n){const d=new a.ExtensionIdentifierSet(n);return E.filter(h=>!d.has(h.identifier))}}),define(Ce[244],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class P{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[P.ENV_KEY]=this.pipeName}}P.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=P;class l{constructor(){this.type=2}serialize(I){I[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class A{constructor(){this.type=3}serialize(I){I[A.ENV_KEY]="1"}}A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=A;function T(R){delete R[P.ENV_KEY],delete R[l.ENV_KEY],delete R[A.ENV_KEY]}function k(R,I){T(I),R.serialize(I)}e.writeExtHostConnection=k;function y(R){if(R[P.ENV_KEY])return v(R,new P(R[P.ENV_KEY]));if(R[l.ENV_KEY])return v(R,new l);if(R[A.ENV_KEY])return v(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function v(R,I){return T(R),I}}),define(Ce[97],De([1,0,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var l;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(v){const R=a.VSBuffer.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=T;function k(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=k;var y;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[78],De([1,0,4,3,16,26,97,74,75,23,2,6,187]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class extends I.Disposable{constructor(d,h){super(),this.initData=d,this.loggerService=h,this._onDidChangeTelemetryEnabled=this._register(new P.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new P.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=h.createLogger(this.extHostTelemetryLogFile,{id:y.extensionTelemetryLogChannelId,name:(0,_.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(h.onDidChangeLogLevel(w=>{(0,l.isLogLevel)(w)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(d,h,w){const S=this.getTelemetryDetails(),p=new C(h,w,d,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(d),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled});return this._telemetryLoggers.set(d.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(d,h,w){this._level=d,this._telemetryIsSupported=h,this._productConfig=w??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(d){const h=Object.create(null);switch(h["common.extname"]=`${d.publisher}.${d.name}`,h["common.extversion"]=d.version,h["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,h["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,h["common.vscodeversion"]=this.initData.version,h["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),h["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:h["common.uikind"]="web";break;case T.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,k.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),h}$onDidChangeTelemetryLevel(d){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=d;const h=this.getTelemetryDetails();this._telemetryLoggers.forEach((w,S)=>{w.isDisposed&&this._telemetryLoggers.delete(S)}),this._telemetryLoggers.forEach(w=>{w.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(d,h){const w=this._telemetryLoggers.get(d.value);return w&&w.isDisposed?(this._telemetryLoggers.delete(d.value),!1):!w||w.ignoreUnhandledExtHostErrors?!1:(w.logError(h),!0)}};D=$e([Be(0,A.IExtHostInitDataService),Be(1,l.ILoggerService)],D),e.ExtHostTelemetry=D;class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,h,w,S,p,t,o){this._extension=w,this._logger=S,this._inLoggingOnlyMode=p,this._commonProperties=t,this._onDidChangeEnableStates=new P.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=h?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=h?.additionalCommonProperties,this._sender=d,this._telemetryEnablements={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,h){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:d,isErrorsEnabled:h},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(d){let h=d.properties??d;return h=(0,y.cleanData)(h,[]),this._additionalCommonProperties&&(h=(0,v.mixin)(h,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(h=(0,v.mixin)(h,this._commonProperties)),d.properties?d.properties=h:d=h,d}logEvent(d,h){!this._sender||(this._extension.publisher==="vscode"?d=this._extension.name+"/"+d:d=this._extension.identifier.value+"/"+d,h=this.mixInCommonPropsAndCleanData(h||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(d,h),this._logger.trace(d,h))}logUsage(d,h){!this._telemetryEnablements.isUsageEnabled||this.logEvent(d,h)}logError(d,h){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof d=="string"?this.logEvent(d,h):this._sender.sendErrorData(d,h))}get apiTelemetryLogger(){if(!this._apiObject){const d=this,h={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return d._telemetryEnablements.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d._onDidChangeEnableStates.event.bind(d)};this._apiObject=Object.freeze(h)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let d=this._sender;this._sender=void 0,Promise.resolve(d.flush()).then(d=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=C;function E(n){const d=Date.now()-new Date(n).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ce[27],De([1,0,3,2,220,129,25,4]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class y{constructor(p){this.dependency=p}}e.MissingExtensionDependency=y;var v;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(v=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(p,t){const o=[],r=[],c=[],m=[],f=I(this._allExtensions),i=I(p),s=(H,q)=>H.extensionLocation.toString()===q.extensionLocation.toString()||H.isBuiltin===q.isBuiltin||H.isUserBuiltin===q.isUserBuiltin||H.isUnderDevelopment===q.isUnderDevelopment;for(const H of this._allExtensions){const q=i.get(H.identifier);if(!q){o.push(H.identifier),f.delete(H.identifier);continue}if(!s(H,q)){o.push(H.identifier),f.delete(H.identifier);continue}}for(const H of p){const q=f.get(H.identifier);if(!q){r.push(H);continue}if(!s(q,H)){o.push(q.identifier),f.delete(q.identifier);continue}}const u=new T.ExtensionIdentifierSet(this._myExtensions),b=new T.ExtensionIdentifierSet(t);for(const H of this._myExtensions)b.has(H)||c.push(H);for(const H of t)u.has(H)||m.push(H);const g=A.ImplicitActivationEvents.createActivationEventsMap(r),L={toRemove:o,toAdd:r,addActivationEvents:g,myToRemove:c,myToAdd:m};return this.delta(L),L}delta(p){const{toRemove:t,toAdd:o,myToRemove:r,myToAdd:c}=p,m=new T.ExtensionIdentifierSet(t),f=new T.ExtensionIdentifierSet(r);for(let i=0;i<this._allExtensions.length;i++)m.has(this._allExtensions[i].identifier)&&(this._allExtensions.splice(i,1),i--);for(let i=0;i<this._myExtensions.length;i++)f.has(this._myExtensions[i])&&(this._myExtensions.splice(i,1),i--);for(const i of o)this._allExtensions.push(i);for(const i of c)this._myExtensions.push(i)}containsExtension(p){for(const t of this._myExtensions)if(T.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=R;function I(S){const p=new T.ExtensionIdentifierMap;for(const t of S)p.set(t.identifier,t);return p}function _(S,p){return S.enabledApiProposals?S.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=_;function D(S,p){if(!_(S,p))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.checkProposedApiEnabled=D;class C{constructor(p,t,o,r){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=r}}e.ActivationTimes=C;class E{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=E;var n;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,l.getGalleryExtensionId)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function h(S,p){return{identifier:new T.ExtensionIdentifier((0,l.getExtensionId)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!p,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.toExtensionDescription=h;class w{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=w}),define(Ce[245],De([1,0,8,135,25,27,16,19]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(d,h,w,S){this.startup=d,this.codeLoadingTime=h,this.activateCallTime=w,this.activateResolvedTime=S}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class v{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,h){return d===-1||h===-1?-1:h-d}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=v;class R{constructor(d,h,w,S,p,t){this.activationFailed=d,this.activationFailedError=h,this.activationTimes=w,this.module=S,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=R;class I extends R{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class _ extends R{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class D extends R{constructor(d){super(!0,d,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(d,h,w,S){this._logService=S,this._registry=d,this._globalRegistry=h,this._host=w,this._operations=new l.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,h]of this._operations)h.dispose()}async waitForActivatingExtensions(){const d=[];for(const[h,w]of this._operations)d.push(w.wait());await Promise.all(d)}isActivated(d){const h=this._operations.get(d);return Boolean(h&&h.value)}getActivatedExtension(d){const h=this._operations.get(d);if(!h||!h.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return h.value}async activateByEvent(d,h){if(this._alreadyActivatedEvents[d])return;const w=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(w.map(S=>({id:S.identifier,reason:{startup:h,extensionId:S.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,h){const w=this._registry.getExtensionDescription(d);if(!w)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:w.identifier,reason:h}])}async _activateExtensions(d){const h=d.filter(w=>!this.isActivated(w.id)).map(w=>this._handleActivationRequest(w));await Promise.all(h.map(w=>w.wait()))}_handleActivationRequest(d){if(this._operations.has(d.id))return this._operations.get(d.id);if(this._isHostExtension(d.id))return this._createAndSaveOperation(d,null,[],null);const h=this._registry.getExtensionDescription(d.id);if(!h){const p=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this._createAndSaveOperation(d,null,[],new D(p));return this._host.onExtensionActivationError(d.id,p,new A.MissingExtensionDependency(d.id.value)),t}const w=[],S=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const p of S){if(this._isResolvedExtension(p))continue;const t=this._operations.get(p);if(t){w.push(t);continue}if(this._isHostExtension(p)){w.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:d.reason}));continue}const o=this._registry.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;w.push(this._handleActivationRequest({id:o.identifier,reason:d.reason}));continue}const r=h.displayName||h.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),m=this._createAndSaveOperation(d,h.displayName,[],new D(c));return this._host.onExtensionActivationError(h.identifier,c,new A.MissingExtensionDependency(p)),m}return this._createAndSaveOperation(d,h.displayName,w,null)}_createAndSaveOperation(d,h,w,S){const p=new E(d.id,h,d.reason,w,S,this._host,this._logService);return this._operations.set(d.id,p),p}_isHostExtension(d){return P.ExtensionDescriptionRegistry.isHostExtension(d,this._registry,this._globalRegistry)}_isResolvedExtension(d){const h=this._globalRegistry.getExtensionDescription(d);return h?!h.main&&!h.browser:!1}};C=$e([Be(3,T.ILogService)],C),e.ExtensionsActivator=C;let E=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(d,h,w,S,p,t,o){this._id=d,this._displayName=h,this._reason=w,this._deps=S,this._value=p,this._host=t,this._logService=o,this._barrier=new k.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const h=this._deps[d];if(h.value&&!h.value.activationFailed){this._deps.splice(d,1),d--;continue}if(h.value&&h.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);w.detail=h.value.activationFailedError,this._value=new D(w),this._host.onExtensionActivationError(this._id,w,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const h=new Error;if(d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._value=new D(h),this._isDisposed&&a.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};E=$e([Be(6,T.ILogService)],E)});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[7],De([1,0,18,8,113,28,89,9,10,2,30,45,128,94,27]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C){"use strict";var E,n,d,h,w,S,p,t,o,r,c,m,f,i,s,u,b,g,L,H,q,X,U,N,x;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(G){return Object.assign(G,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(G,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[pe,...Te]=arguments;return Reflect.construct(G,Te,pe.constructor)}}})}var V;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(V=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var fe;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(fe=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let se=t=class{static from(...W){let pe=W;return new t(function(){if(pe){for(const Te of pe)Te&&typeof Te.dispose=="function"&&Te.dispose();pe=void 0}})}constructor(W){E.set(this,void 0),Je(this,E,W,"f")}dispose(){typeof Ne(this,E,"f")=="function"&&(Ne(this,E,"f").call(this),Je(this,E,void 0,"f"))}};E=new WeakMap,se=t=$e([F],se),e.Disposable=se;let $=o=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Te=1;Te<W.length;Te++){const qe=W[Te];qe.isBefore(pe)&&(pe=qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Te=1;Te<W.length;Te++){const qe=W[Te];qe.isAfter(pe)&&(pe=qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof o)return!0;const{line:pe,character:Te}=W;return typeof pe=="number"&&typeof Te=="number"}static of(W){if(W instanceof o)return W;if(this.isPosition(W))return new o(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,pe){if(W<0)throw(0,P.illegalArgument)("line must be non-negative");if(pe<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=W,this._character=pe}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,P.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&pe===0?this:new o(this.line+Te,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,P.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Te===this.line&&pe===this.character?this:new o(Te,pe)}toJSON(){return{line:this.line,character:this.character}}};$=o=$e([F],$),e.Position=$;let J=r=class{static isRange(W){return W instanceof r?!0:W?$.isPosition(W.start)&&$.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,pe,Te,qe){let Ye,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"?(Ye=new $(W,pe),at=new $(Te,qe)):$.isPosition(W)&&$.isPosition(pe)&&(Ye=$.of(W),at=$.of(pe)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this._start=Ye,this._end=at):(this._start=at,this._end=Ye)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):$.isPosition(W)?!($.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const pe=$.Max(W.start,this._start),Te=$.Min(W.end,this._end);if(!pe.isAfter(Te))return new r(pe,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=$.Min(W.start,this._start),Te=$.Max(W.end,this.end);return new r(pe,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,P.illegalArgument)();let Te;return W?$.isPosition(W)?Te=W:(Te=W.start||this.start,pe=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&pe.isEqual(this.end)?this:new r(Te,pe)}toJSON(){return[this.start,this.end]}};J=r=$e([F],J),e.Range=J;let te=c=class extends J{static isSelection(W){return W instanceof c?!0:W?J.isRange(W)&&$.isPosition(W.anchor)&&$.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,pe,Te,qe){let Ye,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"?(Ye=new $(W,pe),at=new $(Te,qe)):$.isPosition(W)&&$.isPosition(pe)&&(Ye=$.of(W),at=$.of(pe)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this._anchor=Ye,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=c=$e([F],te),e.Selection=te;class be{constructor(W,pe,Te){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,P.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,P.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(pe),this.connectionToken=Te}}e.ResolvedAuthority=be;class le extends Error{static NotAvailable(W,pe){return new le(W,_.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new le(W,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=_.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=pe,this._detail=Te,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var ue;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ue=e.EndOfLine||(e.EndOfLine={}));var j;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=m=class{static isTextEdit(W){return W instanceof m?!0:W?J.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new m(W,pe)}static insert(W,pe){return m.replace(new J(W,W),pe)}static delete(W){return m.replace(W,"")}static setEndOfLine(W){const pe=new m(new J(new $(0,0),new $(0,0)),"");return pe.newEol=W,pe}get range(){return this._range}set range(W){if(W&&!J.isRange(W))throw(0,P.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,P.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,P.illegalArgument)("newEol");this._newEol=W}constructor(W,pe){this._range=W,this._newText=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=m=$e([F],M),e.TextEdit=M;var Y;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Y=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let ge=f=class{static isNotebookCellEdit(W){return W instanceof f?!0:W?zt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new f(W,pe)}static insertCells(W,pe){return new f(new zt(W,W),pe)}static deleteCells(W){return new f(W,[])}static updateCellMetadata(W,pe){const Te=new f(new zt(W,W),[]);return Te.newCellMetadata=pe,Te}static updateNotebookMetadata(W){const pe=new f(new zt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};ge=f=$e([F],ge),e.NotebookEdit=ge;class we{static isSnippetTextEdit(W){return W instanceof we?!0:W?J.isRange(W.range)&&de.isSnippetString(W.snippet):!1}static replace(W,pe){return new we(W,pe)}static insert(W,pe){return we.replace(new J(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.SnippetTextEdit=we;var ie;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ie=e.FileEditType||(e.FileEditType={}));let ne=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,pe,Te,qe){this._edits.push({_type:1,from:W,to:pe,options:Te,metadata:qe})}createFile(W,pe,Te){this._edits.push({_type:1,from:void 0,to:W,options:pe,metadata:Te})}deleteFile(W,pe,Te){this._edits.push({_type:1,from:W,to:void 0,options:pe,metadata:Te})}replaceNotebookMetadata(W,pe,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}replaceNotebookCells(W,pe,Te,qe){const Ye=pe.start,at=pe.end;(Ye!==at||Te.length>0)&&this._edits.push({_type:5,uri:W,index:Ye,count:at-Ye,cells:Te,metadata:qe})}replaceNotebookCellMetadata(W,pe,Te,qe){this._edits.push({_type:3,metadata:qe,uri:W,edit:{editType:8,index:pe,metadata:Te}})}replace(W,pe,Te,qe){this._edits.push({_type:2,uri:W,edit:new M(pe,Te),metadata:qe})}insert(W,pe,Te,qe){this.replace(W,new J(pe,pe),Te,qe)}delete(W,pe,Te){this.replace(W,pe,"",Te)}has(W){return this._edits.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Te of pe){if(!Te)continue;let qe,Ye;Array.isArray(Te)?(qe=Te[0],Ye=Te[1]):qe=Te,ge.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(W,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(W,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(W,qe.range,qe.newCells,Ye):we.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:W,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:W,edit:qe,metadata:Ye})}else{for(let Te=0;Te<this._edits.length;Te++){const qe=this._edits[Te];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,a.coalesceInPlace)(this._edits)}}get(W){const pe=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&pe.push(Te.edit);return pe}entries(){const W=new A.ResourceMap;for(const pe of this._edits)if(pe._type===2){let Te=W.get(pe.uri);Te||(Te=[pe.uri,[]],W.set(pe.uri,Te)),Te[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ne=$e([F],ne),e.WorkspaceEdit=ne;let de=i=class{static isSnippetString(W){return W instanceof i?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=i._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this._tabstop++){if(typeof W=="function"){const Te=new i;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=i._escape(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this._tabstop++){const Te=W.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Te=new i;Te._tabstop=this._tabstop,pe(Te),this._tabstop=Te._tabstop,pe=Te.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};de=i=$e([F],de),e.SnippetString=de;var ee;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(ee=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=s=class{static isLocation(W){return W instanceof s?!0:W?J.isRange(W.range)&&v.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(J.isRange(pe))this.range=J.of(pe);else if($.isPosition(pe))this.range=new J(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=s=$e([F],ae),e.Location=ae;let O=class{static is(W){return W?typeof W.message=="string"&&W.location&&J.isRange(W.location.range)&&v.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};O=$e([F],O),e.DiagnosticRelatedInformation=O;let B=class{constructor(W,pe,Te=ce.Error){if(!J.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Te}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,a.equals)(W.tags,pe.tags)&&(0,a.equals)(W.relatedInformation,pe.relatedInformation,O.isEqual)}};B=$e([F],B),e.Diagnostic=B;let K=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};K=$e([F],K),e.Hover=K;var Z;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let he=class{constructor(W,pe=Z.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:Z[this.kind]}}};he=$e([F],he),e.DocumentHighlight=he;var _e;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(_e=e.SymbolKind||(e.SymbolKind={}));var Ae;(function(G){G[G.Deprecated=1]="Deprecated"})(Ae=e.SymbolTag||(e.SymbolTag={}));let Ee=u=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Te,qe,Ye){this.name=W,this.kind=pe,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),qe instanceof ae?this.location=qe:Te instanceof J&&(this.location=new ae(qe,Te)),u.validate(this)}toJSON(){return{name:this.name,kind:_e[this.kind],location:this.location,containerName:this.containerName}}};Ee=u=$e([F],Ee),e.SymbolInformation=Ee;let ke=b=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(b.validate)}constructor(W,pe,Te,qe,Ye){this.name=W,this.detail=pe,this.kind=Te,this.range=qe,this.selectionRange=Ye,this.children=[],b.validate(this)}};ke=b=$e([F],ke),e.DocumentSymbol=ke;var Ie;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let He=class{constructor(W,pe){this.title=W,this.kind=pe}};He=$e([F],He),e.CodeAction=He;let ze=g=class{constructor(W){this.value=W}append(W){return new g(this.value?this.value+g.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+g.sep)}};ze.sep=".",ze=g=$e([F],ze),e.CodeActionKind=ze,ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll");let tt=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};tt=$e([F],tt),e.SelectionRange=tt;class Qe{constructor(W,pe,Te,qe,Ye,at){this.kind=W,this.name=pe,this.detail=Te,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Qe;class nt{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.CallHierarchyIncomingCall=nt;class st{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.CallHierarchyOutgoingCall=st;var Ue;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ue=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};it=$e([F],it),e.CodeLens=it;let z=L=class{static isMarkdownString(W){return W instanceof L?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){n.set(this,void 0),Je(this,n,new l.MarkdownString(W,{supportThemeIcons:pe}),"f")}get value(){return Ne(this,n,"f").value}set value(W){Ne(this,n,"f").value=W}get isTrusted(){return Ne(this,n,"f").isTrusted}set isTrusted(W){Ne(this,n,"f").isTrusted=W}get supportThemeIcons(){return Ne(this,n,"f").supportThemeIcons}set supportThemeIcons(W){Ne(this,n,"f").supportThemeIcons=W}get supportHtml(){return Ne(this,n,"f").supportHtml}set supportHtml(W){Ne(this,n,"f").supportHtml=W}get baseUri(){return Ne(this,n,"f").baseUri}set baseUri(W){Ne(this,n,"f").baseUri=W}appendText(W){return Ne(this,n,"f").appendText(W),this}appendMarkdown(W){return Ne(this,n,"f").appendMarkdown(W),this}appendCodeblock(W,pe){return Ne(this,n,"f").appendCodeblock(pe??"",W),this}};n=new WeakMap,z=L=$e([F],z),e.MarkdownString=z;let Q=class{constructor(W,pe){this.label=W,this.documentation=pe}};Q=$e([F],Q),e.ParameterInformation=Q;let me=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};me=$e([F],me),e.SignatureInformation=me;let Re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Re=$e([F],Re),e.SignatureHelp=Re;var Oe;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let Xe=class{constructor(W){this.value=W}};Xe=$e([F],Xe),e.InlayHintLabelPart=Xe;let Ke=class{constructor(W,pe,Te){this.position=W,this.label=pe,this.kind=Te}};Ke=$e([F],Ke),e.InlayHint=Ke;var rt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var bt;(function(G){G[G.Deprecated=1]="Deprecated"})(bt=e.CompletionItemTag||(e.CompletionItemTag={}));let mt=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};mt=$e([F],mt),e.CompletionItem=mt;let Et=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};Et=$e([F],Et),e.CompletionList=Et;let Dt=class{constructor(W,pe,Te){this.insertText=W,this.range=pe,this.command=Te}};Dt=$e([F],Dt),e.InlineSuggestion=Dt;let Rt=class{constructor(W){this.commands=void 0,this.items=W}};Rt=$e([F],Rt),e.InlineSuggestionList=Rt;var Qt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Qt=e.ViewColumn||(e.ViewColumn={}));var Gt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Gt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ht;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(ht=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Lt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Lt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ft;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function W(pe){switch(pe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let yt=class{constructor(W,pe){if(pe&&!v.URI.isUri(pe))throw(0,P.illegalArgument)("target");if(!J.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.target=pe}};yt=$e([F],yt),e.DocumentLink=yt;let xt=class{constructor(W,pe,Te,qe){this.red=W,this.green=pe,this.blue=Te,this.alpha=qe}};xt=$e([F],xt),e.Color=xt;let It=class{constructor(W,pe){if(pe&&!(pe instanceof xt))throw(0,P.illegalArgument)("color");if(!J.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.color=pe}};It=$e([F],It),e.ColorInformation=It;let Ge=class{constructor(W){if(!W||typeof W!="string")throw(0,P.illegalArgument)("label");this.label=W}};Ge=$e([F],Ge),e.ColorPresentation=Ge;var $t;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})($t=e.ColorFormat||(e.ColorFormat={}));var Kt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Kt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Nt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Nt=e.TerminalExitReason||(e.TerminalExitReason={}));class Pe{constructor(W,pe,Te){if(this.startIndex=W,this.length=pe,this.tooltip=Te,typeof W!="number"||W<0)throw(0,P.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,P.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class Le{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Le;class ye{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=ye;var oe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(oe=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(W){if(this.options=W,typeof W!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Me;var We;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let je=H=class{static from(W){switch(W){case"clean":return H.Clean;case"build":return H.Build;case"rebuild":return H.Rebuild;case"test":return H.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,P.illegalArgument)("name");this._id=W}get id(){return this._id}};je.Clean=new H("clean","Clean"),je.Build=new H("build","Build"),je.Rebuild=new H("rebuild","Rebuild"),je.Test=new H("test","Test"),je=H=$e([F],je),e.TaskGroup=je;function et(G){let W="";for(let pe=0;pe<G.length;pe++)W+=G[pe].replace(/,/g,",,")+",";return W}let dt=class{constructor(W,pe,Te){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=W,pe!==void 0&&(Array.isArray(pe)?(this._args=pe,this._options=Te):this._options=pe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const pe of this._args)W.push(pe);return et(W)}};dt=$e([F],dt),e.ProcessExecution=dt;let ut=class{constructor(W,pe,Te){if(this._args=[],Array.isArray(pe)){if(!W)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W,this._args=pe,this._options=Te}else{if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W,this._options=pe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const pe of this._args)W.push(typeof pe=="string"?pe:pe.value);return et(W)}};ut=$e([F],ut),e.ShellExecution=ut;var Ct;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Ot{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ot;let Ut=q=class{constructor(W,pe,Te,qe,Ye,at){this.__deprecated=!1,this._definition=this.definition=W;let ft;typeof pe=="string"?(this._name=this.name=pe,this._source=this.source=Te,this.execution=qe,ft=Ye,this.__deprecated=!0):pe===vt.Global||pe===vt.Workspace?(this.target=pe,this._name=this.name=Te,this._source=this.source=qe,this.execution=Ye,ft=at):(this.target=pe,this._name=this.name=Te,this._source=this.source=qe,this.execution=Ye,ft=at),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof dt?this._definition={type:q.ProcessType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:q.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:q.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:q.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const pe=this._definition.type;(q.EmptyType===pe||q.ProcessType===pe||q.ShellType===pe||q.ExtensionCallbackType===pe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ut.ExtensionCallbackType="customExecution",Ut.ProcessType="process",Ut.ShellType="shell",Ut.EmptyType="$empty",Ut=q=$e([F],Ut),e.Task=Ut;var Ri;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ri=e.ProgressLocation||(e.ProgressLocation={}));var Tt;(function(G){function W(pe){const Te=pe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=W})(Tt=e.ViewBadge||(e.ViewBadge={}));let Ei=X=class{static isTreeItem(W,pe){const Te=W;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(pe,"treeItemCheckbox");const qe=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(qe===void 0||qe!==_t.Checked&&qe!==_t.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(W instanceof X)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!v.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const qe=Te.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!v.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!v.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!v.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof z)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ci.None&&Te.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(W,pe=ci.None){this.collapsibleState=pe,v.URI.isUri(W)?this.resourceUri=W:this.label=W}};Ei=X=$e([F],Ei),e.TreeItem=Ei;var ci;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var _t;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(_t=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,pe){this.value=W,this.id=pe??(0,R.generateUuid)()}};li=$e([F],li),e.DataTransferItem=li;let ui=class{constructor(W){d.add(this),h.set(this,new Map);for(const[pe,Te]of W??[]){const qe=Ne(this,h,"f").get(Ne(this,d,"m",w).call(this,pe));qe?qe.push(Te):Ne(this,h,"f").set(Ne(this,d,"m",w).call(this,pe),[Te])}}get(W){return Ne(this,h,"f").get(Ne(this,d,"m",w).call(this,W))?.[0]}set(W,pe){Ne(this,h,"f").set(Ne(this,d,"m",w).call(this,W),[pe])}forEach(W,pe){for(const[Te,qe]of Ne(this,h,"f"))for(const Ye of qe)W.call(pe,Ye,Te,this)}*[(h=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[W,pe]of Ne(this,h,"f"))for(const Te of pe)yield[W,Te]}};w=function(W){return W.toLowerCase()},ui=$e([F],ui),e.DataTransfer=ui;let ii=class{constructor(W){this.insertText=W}};ii=$e([F],ii),e.DocumentDropEdit=ii;let wi=class{constructor(W){this.insertText=W}};wi=$e([F],wi),e.DocumentPasteEdit=wi;let Vt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Vt=$e([F],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let Pt=class{constructor(W){this.id=W}};Pt=$e([F],Pt),e.ThemeColor=Pt;var Li;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Li=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _i=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=v.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!v.URI.isUri(W)&&!v.URI.isUri(W.uri)))throw(0,P.illegalArgument)("base");if(typeof pe!="string")throw(0,P.illegalArgument)("pattern");typeof W=="string"?this.baseUri=v.URI.file(W):v.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_i=$e([F],_i),e.RelativePattern=_i;const ni=new WeakMap;function di(G,W){ni.set(G,W)}e.setBreakpointId=di;let lt=class{constructor(W,pe,Te,qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Te=="string"&&(this.hitCondition=Te),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=ni.get(this)??(0,R.generateUuid)()),this._id}};lt=$e([F],lt),e.Breakpoint=lt;let Si=class extends lt{constructor(W,pe,Te,qe,Ye){if(super(pe,Te,qe,Ye),W===null)throw(0,P.illegalArgument)("location");this.location=W}};Si=$e([F],Si),e.SourceBreakpoint=Si;let jt=class extends lt{constructor(W,pe,Te,qe,Ye){super(pe,Te,qe,Ye),this.functionName=W}};jt=$e([F],jt),e.FunctionBreakpoint=jt;let Yt=class extends lt{constructor(W,pe,Te,qe,Ye,at,ft){if(super(qe,Ye,at,ft),!pe)throw(0,P.illegalArgument)("dataId");this.label=W,this.dataId=pe,this.canPersist=Te}};Yt=$e([F],Yt),e.DataBreakpoint=Yt;let hi=class{constructor(W,pe,Te){this.command=W,this.args=pe||[],this.options=Te}};hi=$e([F],hi),e.DebugAdapterExecutable=hi;let yi=class{constructor(W,pe){this.port=W,this.host=pe}};yi=$e([F],yi),e.DebugAdapterServer=yi;let Ci=class{constructor(W){this.path=W}};Ci=$e([F],Ci),e.DebugAdapterNamedPipeServer=Ci;let fi=class{constructor(W){this.implementation=W}};fi=$e([F],fi),e.DebugAdapterInlineImplementation=fi;let Di=class{constructor(W,pe){this.range=W,this.expression=pe}};Di=$e([F],Di),e.EvaluatableExpression=Di;var Oi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Oi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Jt=class{constructor(W,pe){this.range=W,this.text=pe}};Jt=$e([F],Jt),e.InlineValueText=Jt;let Ii=class{constructor(W,pe,Te=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Te}};Ii=$e([F],Ii),e.InlineValueVariableLookup=Ii;let ri=class{constructor(W,pe){this.range=W,this.expression=pe}};ri=$e([F],ri),e.InlineValueEvaluatableExpression=ri;let si=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};si=$e([F],si),e.InlineValueContext=si;var Bi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let ki=U=class extends Error{static FileExists(W){return new U(W,I.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(W){return new U(W,I.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(W){return new U(W,I.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(W){return new U(W,I.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(W){return new U(W,I.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(W){return new U(W,I.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}constructor(W,pe=I.FileSystemProviderErrorCode.Unknown,Te){super(v.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};ki=U=$e([F],ki),e.FileSystemError=ki;let Zt=class{constructor(W,pe,Te){this.start=W,this.end=pe,this.kind=Te}};Zt=$e([F],Zt),e.FoldingRange=Zt;var zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var mi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class $i{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.SemanticTokensLegend=$i;function Vi(G){return typeof G>"u"||(0,y.isStringArray)(G)}class Ti{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let pe=0,Te=W.tokenTypes.length;pe<Te;pe++)this._tokenTypeStrToInt.set(W.tokenTypes[pe],pe);for(let pe=0,Te=W.tokenModifiers.length;pe<Te;pe++)this._tokenModifierStrToInt.set(W.tokenModifiers[pe],pe)}}push(W,pe,Te,qe,Ye){if(typeof W=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(W,pe,Te,qe,Ye);if(J.isRange(W)&&typeof pe=="string"&&Vi(Te))return this._push(W,pe,Te);throw(0,P.illegalArgument)()}_push(W,pe,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(pe))throw new Error("`tokenType` is not in the provided legend");const qe=W.start.line,Ye=W.start.character,at=W.end.character-W.start.character,ft=this._tokenTypeStrToInt.get(pe);let Mt=0;if(Te)for(const Ht of Te){if(!this._tokenModifierStrToInt.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this._tokenModifierStrToInt.get(Ht);Mt|=1<<qt>>>0}this._pushEncoded(qe,Ye,at,ft,Mt)}_pushEncoded(W,pe,Te,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&pe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Mt=this._data.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Mt;Xt++){let ei=this._data[5*Xt],Pi=this._data[5*Xt+1];ei===0?(ei=Ht,Pi+=qt):ei+=Ht,this._data[5*Xt]=ei,this._data[5*Xt+1]=Pi,Ht=ei,qt=Pi}}let at=W,ft=pe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=W,this._prevChar=pe}static _sortAndDeltaEncode(W){const pe=[],Te=W.length/5|0;for(let ft=0;ft<Te;ft++)pe[ft]=ft;pe.sort((ft,Mt)=>{const Ht=W[5*ft],qt=W[5*Mt];if(Ht===qt){const Xt=W[5*ft+1],ei=W[5*Mt+1];return Xt-ei}return Ht-qt});const qe=new Uint32Array(W.length);let Ye=0,at=0;for(let ft=0;ft<Te;ft++){const Mt=5*pe[ft],Ht=W[Mt+0],qt=W[Mt+1],Xt=W[Mt+2],ei=W[Mt+3],Pi=W[Mt+4],dn=Ht-Ye,Nn=dn===0?qt-at:qt,Ai=5*ft;qe[Ai+0]=dn,qe[Ai+1]=Nn,qe[Ai+2]=Xt,qe[Ai+3]=ei,qe[Ai+4]=Pi,Ye=Ht,at=qt}return qe}build(W){return this._dataIsSortedAndDeltaEncoded?new oi(new Uint32Array(this._data),W):new oi(Ti._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ti;class oi{constructor(W,pe){this.resultId=pe,this.data=W}}e.SemanticTokens=oi;class Mi{constructor(W,pe,Te){this.start=W,this.deleteCount=pe,this.data=Te}}e.SemanticTokensEdit=Mi;class Fi{constructor(W,pe){this.resultId=pe,this.edits=W}}e.SemanticTokensEdits=Fi;var xe;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(xe=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new Vt("arrow-left")},Bt=$e([F],Bt),e.QuickInputButtons=Bt;var Ni;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var wt;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(wt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(W){if(typeof W.badge=="string"){let pe=(0,k.nextCharLength)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,k.nextCharLength)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Te){this.badge=W,this.tooltip=pe,this.color=Te}}e.FileDecoration=qi;let gi=class{constructor(W){this.kind=W}};gi=$e([F],gi),e.ColorTheme=gi;var Gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Gi=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{static isNotebookRange(W){return W instanceof zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,pe){if(W<0)throw(0,P.illegalArgument)("start must be positive");if(pe<0)throw(0,P.illegalArgument)("end must be positive");W<=pe?(this._start=W,this._end=pe):(this._start=pe,this._end=W)}with(W){let pe=this._start,Te=this._end;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Te=W.end),pe===this._start&&Te===this._end?this:new zt(pe,Te)}}e.NotebookRange=zt;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>pi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Te,qe,Ye,at,ft){this.kind=W,this.value=pe,this.languageId=Te,this.mime=qe,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ft,pi.validate(this)}}e.NotebookCellData=pi;class Ki{constructor(W){this.cells=W}}e.NotebookData=Ki;class Wt{static isNotebookCellOutputItem(W){return W instanceof Wt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Wt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Wt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Wt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Wt(W,pe)}static text(W,pe=T.Mimes.text){const Te=Ne(Wt,S,"f",p).encode(String(W));return new Wt(Te,pe)}static json(W,pe="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Wt.text(Te,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Te=(0,T.normalizeMimeType)(pe,!0);if(!Te)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}S=Wt,p={value:new TextEncoder},e.NotebookCellOutputItem=Wt;class ai{static isNotebookCellOutput(W){return W instanceof ai?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Te=new Set,qe=new Set;for(let Ye=0;Ye<W.length;Ye++){const at=W[Ye],ft=(0,T.normalizeMimeType)(at.mime);if(!Te.has(ft)||(0,D.isTextStreamMime)(ft)){Te.add(ft);continue}qe.add(Ye),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?W:W.filter((Ye,at)=>!qe.has(at))}constructor(W,pe,Te){this.items=ai.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=pe??Te)}}e.NotebookCellOutput=ai;var Xi;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ji;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ji=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Zi{constructor(W,pe){this.text=W,this.alignment=pe}}e.NotebookCellStatusBarItem=Zi;var en;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var tn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(tn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ve{constructor(W,pe=[]){this.uri=W,this.provides=(0,a.asArray)(pe)}}e.NotebookRendererScript=ve;class Se{constructor(W){this.label=W}}e.NotebookKernelSourceAction=Se;let Fe=class{constructor(W,pe){this.label=W,this.timestamp=pe}};Fe=$e([F],Fe),e.TimelineItem=Fe;var ot;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ot=e.ExtensionMode||(e.ExtensionMode={}));var St;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(St=e.ExtensionRuntime||(e.ExtensionRuntime={}));var At;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(At=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.LinkedEditingRanges=pn;class vn{constructor(W,pe){this._port=W,this._autoForwardAction=pe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var bn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var En;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(En=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(W=void 0,pe=void 0,Te=void 0,qe=!1){this.include=W,this.exclude=pe,this.profile=Te,this.continuous=qe}};Ui=$e([F],Ui),e.TestRunRequest=Ui;let nn=class extends Ui{};nn=$e([F],nn),e.TestRunRequest2=nn;let rn=N=class{static diff(W,pe,Te){const qe=new N(W);return qe.expectedOutput=pe,qe.actualOutput=Te,qe}constructor(W){this.message=W}};rn=N=$e([F],rn),e.TestMessage=rn;let sn=class{constructor(W){this.id=W}};sn=$e([F],sn),e.TestTag=sn;let vi=class{constructor(W,pe){this.covered=W,this.total=pe}};vi=$e([F],vi),e.CoveredCount=vi;let on=x=class{static fromDetails(W,pe){const Te=new vi(0,0),qe=new vi(0,0),Ye=new vi(0,0);for(const ft of pe)if("branches"in ft){Te.total+=1,Te.covered+=ft.executionCount>0?1:0;for(const Mt of ft.branches)qe.total+=1,qe.covered+=Mt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ft.executionCount>0?1:0;const at=new x(W,Te,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=pe,at}constructor(W,pe,Te,qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Te,this.functionCoverage=qe}};on=x=$e([F],on),e.FileCoverage=on;let an=class{constructor(W,pe,Te=[]){this.executionCount=W,this.location=pe,this.branches=Te}};an=$e([F],an),e.StatementCoverage=an;let cn=class{constructor(W,pe){this.executionCount=W,this.location=pe}};cn=$e([F],cn),e.BranchCoverage=cn;let ln=class{constructor(W,pe){this.executionCount=W,this.location=pe}};ln=$e([F],ln),e.FunctionCoverage=ln;var wn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var _n;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(_n=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(W,pe,Te,qe,Ye,at){this.kind=W,this.name=pe,this.detail=Te,this.uri=qe,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=yn;class Cn{constructor(W){this.uri=W}}e.TextTabInput=Cn;class Dn{constructor(W,pe){this.original=W,this.modified=pe}}e.TextDiffTabInput=Dn;class In{constructor(W,pe,Te,qe){this.base=W,this.input1=pe,this.input2=Te,this.result=qe}}e.TextMergeTabInput=In;class kn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.CustomEditorTabInput=kn;class Tn{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Tn;class Pn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.NotebookEditorTabInput=Pn;class An{constructor(W,pe,Te){this.original=W,this.modified=pe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.InteractiveWindowInput=Ln;var On;(function(G){G[G.Up=1]="Up",G[G.Down=2]="Down"})(On=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Mn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Mn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Fn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone"})(Fn=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(Ce[136],De([1,0,51,17,9,167,107,7,18]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const v=new Map;function R(C,E){E?v.set(C,E):v.delete(C)}e.setWordDefinitionFor=R;function I(C){return v.get(C)}class _ extends A.MirrorTextModel{constructor(E,n,d,h,w,S,p,t){super(n,d,h,w),this._proxy=E,this._languageId=S,this._isDirty=p,this.notebook=t,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(E){return(0,y.equals)(this._lines,E)}get document(){if(!this._document){const E=this;this._document={get uri(){return E._uri},get fileName(){return E._uri.fsPath},get isUntitled(){return E._uri.scheme===P.Schemas.untitled},get languageId(){return E._languageId},get version(){return E._versionId},get isClosed(){return E._isDisposed},get isDirty(){return E._isDirty},save(){return E._save()},getText(n){return n?E._getTextInRange(n):E.getText()},get eol(){return E._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return E._lines.length},lineAt(n){return E._lineAt(n)},offsetAt(n){return E._offsetAt(n)},positionAt(n){return E._positionAt(n)},validateRange(n){return E._validateRange(n)},validatePosition(n){return E._validatePosition(n)},getWordRangeAtPosition(n,d){return E._getWordRangeAtPosition(n,d)}}}return Object.freeze(this._document)}_acceptLanguageId(E){(0,a.ok)(!this._isDisposed),this._languageId=E}_acceptIsDirty(E){(0,a.ok)(!this._isDisposed),this._isDirty=E}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(E){const n=this._validateRange(E);if(n.isEmpty)return"";if(n.isSingleLine)return this._lines[n.start.line].substring(n.start.character,n.end.character);const d=this._eol,h=n.start.line,w=n.end.line,S=[];S.push(this._lines[h].substring(n.start.character));for(let p=h+1;p<w;p++)S.push(this._lines[p]);return S.push(this._lines[w].substring(0,n.end.character)),S.join(d)}_lineAt(E){let n;if(E instanceof k.Position?n=E.line:typeof E=="number"&&(n=E),typeof n!="number"||n<0||n>=this._lines.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new D(n,this._lines[n],n===this._lines.length-1)}_offsetAt(E){return E=this._validatePosition(E),this._ensureLineStarts(),this._lineStarts.getPrefixSum(E.line-1)+E.character}_positionAt(E){E=Math.floor(E),E=Math.max(0,E),this._ensureLineStarts();const n=this._lineStarts.getIndexOf(E),d=this._lines[n.index].length;return new k.Position(n.index,Math.min(n.remainder,d))}_validateRange(E){if(!(E instanceof k.Range))throw new Error("Invalid argument");const n=this._validatePosition(E.start),d=this._validatePosition(E.end);return n===E.start&&d===E.end?E:new k.Range(n.line,n.character,d.line,d.character)}_validatePosition(E){if(!(E instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return E.with(0,0);let{line:n,character:d}=E,h=!1;if(n<0)n=0,d=0,h=!0;else if(n>=this._lines.length)n=this._lines.length-1,d=this._lines[n].length,h=!0;else{const w=this._lines[n].length;d<0?(d=0,h=!0):d>w&&(d=w,h=!0)}return h?new k.Position(n,d):E}_getWordRangeAtPosition(E,n){const d=this._validatePosition(E);if(!n)n=I(this._languageId);else if((0,l.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const h=(0,T.getWordAtText)(d.character+1,(0,T.ensureValidWordDefinition)(n),this._lines[d.line],0);if(h)return new k.Range(d.line,h.startColumn-1,d.line,h.endColumn-1)}}e.ExtHostDocumentData=_;class D{constructor(E,n,d){this._line=E,this._text=n,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=D}),define(Ce[246],De([1,0,7,20,3]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new l.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y;switch(k){case"light":y=a.ColorThemeKind.Light;break;case"hcDark":y=a.ColorThemeKind.HighContrast;break;case"hcLight":y=a.ColorThemeKind.HighContrastLight;break;default:y=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([Be(0,P.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Ce[11],De([1,0,18,22,150,63,113,28,148,70,89,23,10,2,32,73,124,133,131,94,57,77,242,7]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Pe){function Le(oe){const{selectionStartLineNumber:Me,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:je}=oe,et=new o.Position(Me-1,We-1),dt=new o.Position(Ze-1,je-1);return new o.Selection(et,dt)}Pe.to=Le;function ye(oe){const{anchor:Me,active:We}=oe;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Pe.from=ye})(r=e.Selection||(e.Selection={}));var c;(function(Pe){function Le(oe){if(!oe)return;const{start:Me,end:We}=oe;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Pe.from=Le;function ye(oe){if(!oe)return;const{startLineNumber:Me,startColumn:We,endLineNumber:Ze,endColumn:je}=oe;return new o.Range(Me-1,We-1,Ze-1,je-1)}Pe.to=ye})(c=e.Range||(e.Range={}));var m;(function(Pe){function Le(ye){switch(ye){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Pe.to=Le})(m=e.TokenType||(e.TokenType={}));var f;(function(Pe){function Le(oe){return new o.Position(oe.lineNumber-1,oe.column-1)}Pe.to=Le;function ye(oe){return{lineNumber:oe.line+1,column:oe.character+1}}Pe.from=ye})(f=e.Position||(e.Position={}));var i;(function(Pe){function Le(Me,We){return(0,a.coalesce)((0,a.asArray)(Me).map(Ze=>ye(Ze,We)))}Pe.from=Le;function ye(Me,We){if(typeof Me=="string")return{$serialized:!0,language:Me};if(Me)return{$serialized:!0,language:Me.language,scheme:oe(Me.scheme,We),pattern:me.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType}}function oe(Me,We){return We&&typeof Me=="string"?We.transformOutgoingScheme(Me):Me}})(i=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Pe){function Le(oe){switch(oe){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function ye(oe){switch(oe){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Pe.to=ye})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(Pe){function Le(oe){let Me;return oe.code&&((0,_.isString)(oe.code)||(0,_.isNumber)(oe.code)?Me=String(oe.code):Me={value:String(oe.code.value),target:oe.code.target}),{...c.from(oe.range),message:oe.message,source:oe.source,code:Me,severity:g.from(oe.severity),relatedInformation:oe.relatedInformation&&oe.relatedInformation.map(b.from),tags:Array.isArray(oe.tags)?(0,a.coalesce)(oe.tags.map(s.from)):void 0}}Pe.from=Le;function ye(oe){const Me=new o.Diagnostic(c.to(oe),oe.message,g.to(oe.severity));return Me.source=oe.source,Me.code=(0,_.isString)(oe.code)?oe.code:oe.code?.value,Me.relatedInformation=oe.relatedInformation&&oe.relatedInformation.map(b.to),Me.tags=oe.tags&&(0,a.coalesce)(oe.tags.map(s.to)),Me}Pe.to=ye})(u=e.Diagnostic||(e.Diagnostic={}));var b;(function(Pe){function Le(oe){return{...c.from(oe.location.range),message:oe.message,resource:oe.location.uri}}Pe.from=Le;function ye(oe){return new o.DiagnosticRelatedInformation(new o.Location(oe.resource,c.to(oe)),oe.message)}Pe.to=ye})(b=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(Pe){function Le(oe){switch(oe){case o.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Pe.from=Le;function ye(oe){switch(oe){case n.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Pe.to=ye})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var L;(function(Pe){function Le(oe){return typeof oe=="number"&&oe>=o.ViewColumn.One?oe-1:oe===o.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Pe.from=Le;function ye(oe){if(typeof oe=="number"&&oe>=0)return oe+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=ye})(L=e.ViewColumn||(e.ViewColumn={}));function H(Pe){return typeof Pe.range<"u"}function q(Pe){return Pe.length===0?!0:!!H(Pe[0])}e.isDecorationOptionsArr=q;var X;(function(Pe){function Le(je){return je.map(Pe.from)}Pe.fromMany=Le;function ye(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function oe(je){let et;if(ye(je)){const{language:vt,value:Ot}=je;et={value:"```"+vt+`
`+Ot+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?et={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?et={value:je}:et={value:""};const dt=Object.create(null);et.uris=dt;const ut=vt=>{try{let Ot=D.URI.parse(vt,!0);Ot=Ot.with({query:Me(Ot.query,dt)}),dt[vt]=Ot}catch{}return""},Ct=new y.marked.Renderer;return Ct.link=ut,Ct.image=vt=>typeof vt=="string"?ut(T.parseHrefAndDimensions(vt).href):"",(0,y.marked)(et.value,{renderer:Ct}),et}Pe.from=oe;function Me(je,et){if(!je)return je;let dt;try{dt=(0,v.parse)(je)}catch{}if(!dt)return je;let ut=!1;return dt=(0,I.cloneAndChange)(dt,Ct=>{if(D.URI.isUri(Ct)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[vt]=Ct,ut=!0,vt}else return}),ut?JSON.stringify(dt):je}function We(je){const et=new o.MarkdownString(je.value,je.supportThemeIcons);return et.isTrusted=je.isTrusted,et.supportHtml=je.supportHtml,et.baseUri=je.baseUri?D.URI.from(je.baseUri):void 0,et}Pe.to=We;function Ze(je){if(!!je)return typeof je=="string"?je:Pe.from(je)}Pe.fromStrict=Ze})(X=e.MarkdownString||(e.MarkdownString={}));function U(Pe){return q(Pe)?Pe.map(Le=>({range:c.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?X.fromMany(Le.hoverMessage):Le.hoverMessage?X.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:c.from(Le)}))}e.fromRangeOrRangeWithMessage=U;function N(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?D.URI.file(Pe):Pe}e.pathOrURIToURI=N;var x;(function(Pe){function Le(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?N(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Pe.from=Le})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Pe){function Le(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?N(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Pe.from=Le})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Pe){function Le(ye){if(typeof ye>"u")return ye;switch(ye){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var fe;(function(Pe){function Le(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?V.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?F.from(ye.light):void 0,dark:ye.dark?F.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?N(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Pe.from=Le})(fe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var se;(function(Pe){function Le(oe){return{text:oe.newText,eol:oe.newEol&&st.from(oe.newEol),range:c.from(oe.range)}}Pe.from=Le;function ye(oe){const Me=new o.TextEdit(c.to(oe.range),oe.text);return Me.newEol=typeof oe.eol>"u"?void 0:st.to(oe.eol),Me}Pe.to=ye})(se=e.TextEdit||(e.TextEdit={}));var $;(function(Pe){function Le(oe,Me){const We={edits:[]};if(oe instanceof o.WorkspaceEdit){const Ze=new k.ResourceSet;for(const je of oe._allEntries())je._type===1&&D.URI.isUri(je.to)&&je.from===void 0&&Ze.add(je.to);for(const je of oe._allEntries())je._type===1?We.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,P.encodeBase64)(P.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?We.edits.push({resource:je.uri,textEdit:se.from(je.edit),versionId:Ze.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?We.edits.push({resource:je.uri,textEdit:{range:c.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Ze.has(je.uri)?void 0:Me?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?We.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri)}):je._type===5&&We.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(bt.from)}})}return We}Pe.from=Le;function ye(oe){const Me=new o.WorkspaceEdit;for(const We of oe.edits)We.textEdit?Me.replace(D.URI.revive(We.resource),c.to(We.textEdit.range),We.textEdit.text):Me.renameFile(D.URI.revive(We.oldResource),D.URI.revive(We.newResource),We.options);return Me}Pe.to=ye})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Pe){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function ye(Me){return typeof Le[Me]=="number"?Le[Me]:6}Pe.from=ye;function oe(Me){for(const We in Le)if(Le[We]===Me)return Number(We);return o.SymbolKind.Property}Pe.to=oe})(J=e.SymbolKind||(e.SymbolKind={}));var te;(function(Pe){function Le(oe){switch(oe){case o.SymbolTag.Deprecated:return 1}}Pe.from=Le;function ye(oe){switch(oe){case 1:return o.SymbolTag.Deprecated}}Pe.to=ye})(te=e.SymbolTag||(e.SymbolTag={}));var be;(function(Pe){function Le(oe){return{name:oe.name,kind:J.from(oe.kind),tags:oe.tags&&oe.tags.map(te.from),containerName:oe.containerName,location:Y.from(oe.location)}}Pe.from=Le;function ye(oe){const Me=new o.SymbolInformation(oe.name,J.to(oe.kind),oe.containerName,Y.to(oe.location));return Me.tags=oe.tags&&oe.tags.map(te.to),Me}Pe.to=ye})(be=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Pe){function Le(oe){const Me={name:oe.name||"!!MISSING: name!!",detail:oe.detail,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),kind:J.from(oe.kind),tags:oe.tags?.map(te.from)??[]};return oe.children&&(Me.children=oe.children.map(Le)),Me}Pe.from=Le;function ye(oe){const Me=new o.DocumentSymbol(oe.name,oe.detail,J.to(oe.kind),c.to(oe.range),c.to(oe.selectionRange));return(0,a.isNonEmptyArray)(oe.tags)&&(Me.tags=oe.tags.map(te.to)),oe.children&&(Me.children=oe.children.map(ye)),Me}Pe.to=ye})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(Pe){function Le(oe){const Me=new o.CallHierarchyItem(J.to(oe.kind),oe.name,oe.detail||"",D.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Me._sessionId=oe._sessionId,Me._itemId=oe._itemId,Me}Pe.to=Le;function ye(oe,Me,We){if(Me=Me??oe._sessionId,We=We??oe._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,name:oe.name,detail:oe.detail,kind:J.from(oe.kind),uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(te.from)}}Pe.from=ye})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(Pe){function Le(ye){return new o.CallHierarchyIncomingCall(ue.to(ye.from),ye.fromRanges.map(oe=>c.to(oe)))}Pe.to=Le})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(Pe){function Le(ye){return new o.CallHierarchyOutgoingCall(ue.to(ye.to),ye.fromRanges.map(oe=>c.to(oe)))}Pe.to=Le})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Y;(function(Pe){function Le(oe){return{range:oe.range&&c.from(oe.range),uri:oe.uri}}Pe.from=Le;function ye(oe){return new o.Location(D.URI.revive(oe.uri),c.to(oe.range))}Pe.to=ye})(Y=e.location||(e.location={}));var ge;(function(Pe){function Le(oe){const Me=oe,We=oe;return{originSelectionRange:Me.originSelectionRange?c.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:We.uri,range:c.from(Me.targetRange?Me.targetRange:We.range),targetSelectionRange:Me.targetSelectionRange?c.from(Me.targetSelectionRange):void 0}}Pe.from=Le;function ye(oe){return{targetUri:D.URI.revive(oe.uri),targetRange:c.to(oe.range),targetSelectionRange:oe.targetSelectionRange?c.to(oe.targetSelectionRange):void 0,originSelectionRange:oe.originSelectionRange?c.to(oe.originSelectionRange):void 0}}Pe.to=ye})(ge=e.DefinitionLink||(e.DefinitionLink={}));var we;(function(Pe){function Le(oe){return{range:c.from(oe.range),contents:X.fromMany(oe.contents)}}Pe.from=Le;function ye(oe){return new o.Hover(oe.contents.map(X.to),c.to(oe.range))}Pe.to=ye})(we=e.Hover||(e.Hover={}));var ie;(function(Pe){function Le(oe){return{range:c.from(oe.range),expression:oe.expression}}Pe.from=Le;function ye(oe){return new o.EvaluatableExpression(c.to(oe.range),oe.expression)}Pe.to=ye})(ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ne;(function(Pe){function Le(oe){if(oe instanceof o.InlineValueText)return{type:"text",range:c.from(oe.range),text:oe.text};if(oe instanceof o.InlineValueVariableLookup)return{type:"variable",range:c.from(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};if(oe instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(oe.range),expression:oe.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function ye(oe){switch(oe.type){case"text":return{range:c.to(oe.range),text:oe.text};case"variable":return{range:c.to(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};case"expression":return{range:c.to(oe.range),expression:oe.expression}}}Pe.to=ye})(ne=e.InlineValue||(e.InlineValue={}));var de;(function(Pe){function Le(oe){return{frameId:oe.frameId,stoppedLocation:c.from(oe.stoppedLocation)}}Pe.from=Le;function ye(oe){return new o.InlineValueContext(oe.frameId,c.to(oe.stoppedLocation))}Pe.to=ye})(de=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Pe){function Le(oe){return{range:c.from(oe.range),kind:oe.kind}}Pe.from=Le;function ye(oe){return new o.DocumentHighlight(c.to(oe.range),oe.kind)}Pe.to=ye})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Pe){function Le(ye){switch(ye){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Pe.to=Le})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Pe){function Le(ye){return{triggerKind:ce.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Pe.to=Le})(ae=e.CompletionContext||(e.CompletionContext={}));var O;(function(Pe){function Le(oe){switch(oe){case o.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function ye(oe){switch(oe){case 1:return o.CompletionItemTag.Deprecated}}Pe.to=ye})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(Pe){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ye(We){return Le.get(We)??9}Pe.from=ye;const oe=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(We){return oe.get(We)??o.CompletionItemKind.Property}Pe.to=Me})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Pe){function Le(ye,oe){const Me=new o.CompletionItem(ye.label);return Me.insertText=ye.insertText,Me.kind=B.to(ye.kind),Me.tags=ye.tags?.map(O.to),Me.detail=ye.detail,Me.documentation=T.isMarkdownString(ye.documentation)?X.to(ye.documentation):ye.documentation,Me.sortText=ye.sortText,Me.filterText=ye.filterText,Me.preselect=ye.preselect,Me.commitCharacters=ye.commitCharacters,C.Range.isIRange(ye.range)?Me.range=c.to(ye.range):typeof ye.range=="object"&&(Me.range={inserting:c.to(ye.range.insert),replacing:c.to(ye.range.replace)}),Me.keepWhitespace=typeof ye.insertTextRules>"u"?!1:Boolean(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Me.insertText=new o.SnippetString(ye.insertText):(Me.insertText=ye.insertText,Me.textEdit=Me.range instanceof o.Range?new o.TextEdit(Me.range,Me.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Me.additionalTextEdits=ye.additionalTextEdits.map(We=>se.to(We))),Me.command=oe&&ye.command?oe.fromInternal(ye.command):void 0,Me}Pe.to=Le})(K=e.CompletionItem||(e.CompletionItem={}));var Z;(function(Pe){function Le(oe){if(typeof oe.label!="string"&&!Array.isArray(oe.label))throw new TypeError("Invalid label");return{label:oe.label,documentation:X.fromStrict(oe.documentation)}}Pe.from=Le;function ye(oe){return{label:oe.label,documentation:T.isMarkdownString(oe.documentation)?X.to(oe.documentation):oe.documentation}}Pe.to=ye})(Z=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Pe){function Le(oe){return{label:oe.label,documentation:X.fromStrict(oe.documentation),parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.from):[],activeParameter:oe.activeParameter}}Pe.from=Le;function ye(oe){return{label:oe.label,documentation:T.isMarkdownString(oe.documentation)?X.to(oe.documentation):oe.documentation,parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.to):[],activeParameter:oe.activeParameter}}Pe.to=ye})(he=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(Pe){function Le(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(he.from):[]}}Pe.from=Le;function ye(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(he.to):[]}}Pe.to=ye})(_e=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Pe){function Le(ye,oe){const Me=new o.InlayHint(f.to(oe.position),typeof oe.label=="string"?oe.label:oe.label.map(Ee.to.bind(void 0,ye)),oe.kind&&ke.to(oe.kind));return Me.textEdits=oe.textEdits&&oe.textEdits.map(se.to),Me.tooltip=T.isMarkdownString(oe.tooltip)?X.to(oe.tooltip):oe.tooltip,Me.paddingLeft=oe.paddingLeft,Me.paddingRight=oe.paddingRight,Me}Pe.to=Le})(Ae=e.InlayHint||(e.InlayHint={}));var Ee;(function(Pe){function Le(ye,oe){const Me=new o.InlayHintLabelPart(oe.label);return Me.tooltip=T.isMarkdownString(oe.tooltip)?X.to(oe.tooltip):oe.tooltip,E.Command.is(oe.command)&&(Me.command=ye.fromInternal(oe.command)),oe.location&&(Me.location=Y.to(oe.location)),Me}Pe.to=Le})(Ee=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ke;(function(Pe){function Le(oe){return oe}Pe.from=Le;function ye(oe){return oe}Pe.to=ye})(ke=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Pe){function Le(oe){return{range:c.from(oe.range),url:oe.target,tooltip:oe.tooltip}}Pe.from=Le;function ye(oe){let Me;if(oe.url)try{Me=typeof oe.url=="string"?D.URI.parse(oe.url,!0):D.URI.revive(oe.url)}catch{}return new o.DocumentLink(c.to(oe.range),Me)}Pe.to=ye})(Ie=e.DocumentLink||(e.DocumentLink={}));var He;(function(Pe){function Le(oe){const Me=new o.ColorPresentation(oe.label);return oe.textEdit&&(Me.textEdit=se.to(oe.textEdit)),oe.additionalTextEdits&&(Me.additionalTextEdits=oe.additionalTextEdits.map(We=>se.to(We))),Me}Pe.to=Le;function ye(oe){return{label:oe.label,textEdit:oe.textEdit?se.from(oe.textEdit):void 0,additionalTextEdits:oe.additionalTextEdits?oe.additionalTextEdits.map(Me=>se.from(Me)):void 0}}Pe.from=ye})(He=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(Pe){function Le(oe){return new o.Color(oe[0],oe[1],oe[2],oe[3])}Pe.to=Le;function ye(oe){return[oe.red,oe.green,oe.blue,oe.alpha]}Pe.from=ye})(ze=e.Color||(e.Color={}));var tt;(function(Pe){function Le(oe){return{range:c.from(oe.range)}}Pe.from=Le;function ye(oe){return new o.SelectionRange(c.to(oe.range))}Pe.to=ye})(tt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Pe){function Le(ye){switch(ye){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Pe){function Le(oe){switch(oe){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function ye(oe){switch(oe){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Pe.to=ye})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Pe){function Le(oe){if(oe===o.EndOfLine.CRLF)return 1;if(oe===o.EndOfLine.LF)return 0}Pe.from=Le;function ye(oe){if(oe===1)return o.EndOfLine.CRLF;if(oe===0)return o.EndOfLine.LF}Pe.to=ye})(st=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Pe){function Le(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Pe){function Le(oe){const Me={start:oe.start+1,end:oe.end+1};return oe.kind&&(Me.kind=z.from(oe.kind)),Me}Pe.from=Le;function ye(oe){const Me={start:oe.start-1,end:oe.end-1};return oe.kind&&(Me.kind=z.to(oe.kind)),Me}Pe.to=ye})(it=e.FoldingRange||(e.FoldingRange={}));var z;(function(Pe){function Le(oe){if(oe)switch(oe){case o.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Pe.from=Le;function ye(oe){if(oe)switch(oe.value){case E.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Pe.to=ye})(z=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Pe){function Le(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?c.from(ye.selection):void 0,override:typeof ye.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Le})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(Pe){function Le(We){return We instanceof o.RelativePattern?We.toJSON():typeof We=="string"?We:ye(We)||oe(We)?new o.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Pe.from=Le;function ye(We){const Ze=We;return Ze?D.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function oe(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Me(We){return typeof We=="string"?We:new o.RelativePattern(D.URI.revive(We.baseUri),We.pattern)}Pe.to=Me})(me=e.GlobPattern||(e.GlobPattern={}));var Re;(function(Pe){function Le(ye){if(ye){if(Array.isArray(ye))return ye.map(Le);if(typeof ye=="string")return ye;{const oe=ye;return{language:oe.language,scheme:oe.scheme,pattern:me.from(oe.pattern),exclusive:oe.exclusive,notebookType:oe.notebookType}}}else return}Pe.from=Le})(Re=e.LanguageSelector||(e.LanguageSelector={}));var Oe;(function(Pe){function Le(ye){switch(ye){case 2:return o.NotebookDocumentSaveReason.AfterDelay;case 1:return o.NotebookDocumentSaveReason.Manual;case 3:case 4:return o.NotebookDocumentSaveReason.FocusOut}}Pe.to=Le})(Oe=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var Ve;(function(Pe){function Le(oe){return{start:oe.start,end:oe.end}}Pe.from=Le;function ye(oe){return new o.NotebookRange(oe.start,oe.end)}Pe.to=ye})(Ve=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(Pe){function Le(oe){return{timing:typeof oe.runStartTime=="number"&&typeof oe.runEndTime=="number"?{startTime:oe.runStartTime,endTime:oe.runEndTime}:void 0,executionOrder:oe.executionOrder,success:oe.lastRunSuccess}}Pe.to=Le;function ye(oe){return{lastRunSuccess:oe.success,runStartTime:oe.timing?.startTime,runEndTime:oe.timing?.endTime,executionOrder:oe.executionOrder}}Pe.from=ye})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Pe){function Le(ye){if(ye===w.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ye===w.NotebookCellExecutionState.Pending)return;if(ye===w.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Pe.to=Le})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var rt;(function(Pe){function Le(oe){switch(oe){case o.NotebookCellKind.Markup:return w.CellKind.Markup;case o.NotebookCellKind.Code:default:return w.CellKind.Code}}Pe.from=Le;function ye(oe){switch(oe){case w.CellKind.Markup:return o.NotebookCellKind.Markup;case w.CellKind.Code:default:return o.NotebookCellKind.Code}}Pe.to=ye})(rt=e.NotebookCellKind||(e.NotebookCellKind={}));var ct;(function(Pe){function Le(oe){const Me={metadata:oe.metadata??Object.create(null),cells:[]};for(const We of oe.cells)o.NotebookCellData.validate(We),Me.cells.push(bt.from(We));return Me}Pe.from=Le;function ye(oe){const Me=new o.NotebookData(oe.cells.map(bt.to));return(0,_.isEmptyObject)(oe.metadata)||(Me.metadata=oe.metadata),Me}Pe.to=ye})(ct=e.NotebookData||(e.NotebookData={}));var bt;(function(Pe){function Le(oe){return{cellKind:rt.from(oe.kind),language:oe.languageId,mime:oe.mime,source:oe.value,metadata:oe.metadata,internalMetadata:Xe.from(oe.executionSummary??{}),outputs:oe.outputs?oe.outputs.map(Et.from):[]}}Pe.from=Le;function ye(oe){return new o.NotebookCellData(rt.to(oe.cellKind),oe.source,oe.language,oe.mime,oe.outputs?oe.outputs.map(Et.to):void 0,oe.metadata,oe.internalMetadata?Xe.to(oe.internalMetadata):void 0)}Pe.to=ye})(bt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Pe){function Le(oe){return{mime:oe.mime,valueBytes:P.VSBuffer.wrap(oe.data)}}Pe.from=Le;function ye(oe){return new o.NotebookCellOutputItem(oe.valueBytes.buffer,oe.mime)}Pe.to=ye})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Et;(function(Pe){function Le(oe){return{outputId:oe.id,items:oe.items.map(mt.from),metadata:oe.metadata}}Pe.from=Le;function ye(oe){const Me=oe.items.map(mt.to);return new o.NotebookCellOutput(Me,oe.outputId,oe.metadata)}Pe.to=ye})(Et=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Dt;(function(Pe){function Le(Me){return oe(Me)?{include:(0,_.withNullAsUndefined)(me.from(Me.include)),exclude:(0,_.withNullAsUndefined)(me.from(Me.exclude))}:(0,_.withNullAsUndefined)(me.from(Me))}Pe.from=Le;function ye(Me){return oe(Me)?{include:me.to(Me.include),exclude:me.to(Me.exclude)}:me.to(Me)}Pe.to=ye;function oe(Me){const We=Me;return We?!(0,_.isUndefinedOrNull)(We.include)&&!(0,_.isUndefinedOrNull)(We.exclude):!1}})(Dt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Rt;(function(Pe){function Le(ye,oe,Me){const We=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:oe.toInternal(We,Me),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Pe.from=Le})(Rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Qt;(function(Pe){function Le(ye,oe,Me){const We=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:oe.toInternal(We,Me),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Pe.from=Le})(Qt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Gt;(function(Pe){function Le(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Pe.from=Le})(Gt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ht;(function(Pe){function Le(oe){return{uri:oe.uri,provides:oe.provides}}Pe.from=Le;function ye(oe){return new o.NotebookRendererScript(D.URI.revive(oe.uri),oe.provides)}Pe.to=ye})(ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Pe){function Le(oe){return{message:X.fromStrict(oe.message)||"",type:0,expected:oe.expectedOutput,actual:oe.actualOutput,location:oe.location&&{range:c.from(oe.location.range),uri:oe.location.uri}}}Pe.from=Le;function ye(oe){const Me=new o.TestMessage(typeof oe.message=="string"?oe.message:X.to(oe.message));return Me.actualOutput=oe.actual,Me.expectedOutput=oe.expected,Me.location=oe.location?Y.to(oe.location):void 0,Me}Pe.to=ye})(gt=e.TestMessage||(e.TestMessage={}));var Lt;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(Lt=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){function Le(oe){const Me=(0,d.getPrivateApiFor)(oe).controllerId;return{extId:S.TestId.fromExtHostTestItem(oe,Me).toString(),label:oe.label,uri:D.URI.revive(oe.uri),busy:oe.busy,tags:oe.tags.map(We=>Lt.namespace(Me,We.id)),range:C.Range.lift(c.from(oe.range)),description:oe.description||null,sortText:oe.sortText||null,error:oe.error&&X.fromStrict(oe.error)||null}}Pe.from=Le;function ye(oe){return{parent:void 0,error:void 0,id:S.TestId.fromString(oe.extId).localId,label:oe.label,uri:D.URI.revive(oe.uri),tags:(oe.tags||[]).map(Me=>{const{tagId:We}=Lt.denamespace(Me);return new o.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(oe.range||void 0),canResolveChildren:!1,busy:oe.busy,description:oe.description||void 0,sortText:oe.sortText||void 0}}Pe.toPlain=ye})(Ft=e.TestItem||(e.TestItem={})),function(Pe){function Le(oe){return{id:oe.id}}Pe.from=Le;function ye(oe){return new o.TestTag(oe.id)}Pe.to=ye}(Lt=e.TestTag||(e.TestTag={}));var kt;(function(Pe){const Le=(oe,Me)=>{const We=[];for(const[je,et]of Me)S.TestId.compare(et.item.extId,je)===2&&(Me.delete(je),We.push(et));const Ze={...Ft.toPlain(oe.item),parent:void 0,taskStates:oe.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(et=>et.type===0).map(gt.to)})),children:We.map(je=>Le(je,Me))};for(const je of Ze.children)je.parent=Ze;return Ze};function ye(oe){const Me=[],We=new Map;for(const Ze of oe.items){We.set(Ze.item.extId,Ze);const je=S.TestId.root(Ze.item.extId);oe.request.targets.some(et=>et.controllerId===je&&et.testIds.includes(Ze.item.extId))&&Me.push(Ze)}return{completedAt:oe.completedAt,results:Me.map(Ze=>Le(Ze,We))}}Pe.to=ye})(kt=e.TestResults||(e.TestResults={}));var pt;(function(Pe){function Le(We){return{covered:We.covered,total:We.covered}}function ye(We){return"line"in We?f.from(We):c.from(We)}function oe(We){return"branches"in We?{count:We.executionCount,location:ye(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ye(Ze.location)})):void 0}:{type:0,count:We.executionCount,location:ye(We.location)}}Pe.fromDetailed=oe;function Me(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(oe)}}Pe.fromFile=Me})(pt=e.TestCoverage||(e.TestCoverage={}));var yt;(function(Pe){function Le(ye){switch(ye){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Pe.to=Le})(yt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xt;(function(Pe){function Le(oe){const Me=new o.TypeHierarchyItem(J.to(oe.kind),oe.name,oe.detail||"",D.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Me._sessionId=oe._sessionId,Me._itemId=oe._itemId,Me}Pe.to=Le;function ye(oe,Me,We){if(Me=Me??oe._sessionId,We=We??oe._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,kind:J.from(oe.kind),name:oe.name,detail:oe.detail??"",uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(te.from)}}Pe.from=ye})(xt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(Pe){function Le(ye){if(!!ye)return{value:ye.value,tooltip:ye.tooltip}}Pe.from=Le})(It=e.ViewBadge||(e.ViewBadge={}));var Ge;(function(Pe){function Le(We,Ze,je){const et=Ze.fileData;return et?new class extends o.DataTransferItem{asFile(){return{name:et.name,uri:D.URI.revive(et.uri),data:(0,A.once)(()=>je())}}}("",Ze.id):We===R.Mimes.uriList&&Ze.uriListData?new o.DataTransferItem(Me(Ze.uriListData)):new o.DataTransferItem(Ze.asString)}Pe.to=Le;async function ye(We,Ze){const je=await Ze.asString();if(We===R.Mimes.uriList)return{id:Ze.id,asString:je,fileData:void 0,uriListData:oe(je)};const et=Ze.asFile();return{id:Ze.id,asString:je,fileData:et?{name:et.name,uri:et.uri}:void 0}}Pe.from=ye;function oe(We){return l.UriList.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return D.URI.parse(Ze)}catch{}return Ze})}function Me(We){return l.UriList.create(We.map(Ze=>typeof Ze=="string"?Ze:D.URI.revive(Ze)))}})(Ge=e.DataTransferItem||(e.DataTransferItem={}));var $t;(function(Pe){function Le(oe,Me){const We=oe.items.map(([Ze,je])=>[Ze,Ge.to(Ze,je,()=>Me(je.id))]);return new o.DataTransfer(We)}Pe.toDataTransfer=Le;async function ye(oe){const Me={items:[]},We=[];return oe.forEach((Ze,je)=>{We.push((async()=>{Me.items.push([je,await Ge.from(je,Ze)])})())}),await Promise.all(We),Me}Pe.toDataTransferDTO=ye})($t=e.DataTransfer||(e.DataTransfer={}));var Kt;(function(Pe){function Le(oe){return{message:oe.message,metadata:oe.metadata,title:oe.title,tooltip:oe.tooltip}}Pe.to=Le;function ye(oe){return{kind:"reply",message:oe.message,metadata:oe.metadata,title:oe.title,tooltip:oe.tooltip}}Pe.from=ye})(Kt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var Nt;(function(Pe){function Le(ye){return typeof ye=="string"?{title:ye,message:ye,kind:"reply"}:"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",args:ye.args}:Kt.from(ye)}Pe.from=Le})(Nt=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(Ce[247],De([1,0,2,8,7,11,66]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(v,R,I,_={timeout:1500,errors:3}){this._logService=v,this._documents=R,this._mainThreadBulkEdits=I,this._thresholds=_,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(v){return(R,I,_)=>{const C={dispose:this._callbacks.push([R,I,v])};return Array.isArray(_)&&_.push(C),C}}async $participateInSave(v,R){const I=a.URI.revive(v);let _=!1;const D=setTimeout(()=>_=!0,this._thresholds.timeout),C=[];try{for(const E of[...this._callbacks]){if(_)break;const n=this._documents.getDocument(I),d=await this._deliverEventAsyncAndBlameBadListeners(E,{document:n,reason:A.TextDocumentSaveReason.to(R)});C.push(d)}}finally{clearTimeout(D)}return C}_deliverEventAsyncAndBlameBadListeners([v,R,I],_){const D=this._badListeners.get(v);return typeof D=="number"&&D>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,v,R,_).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const E=this._badListeners.get(v);this._badListeners.set(v,E?E+1:1),typeof E=="number"&&E>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(v,R,I,_){const D=[],C=Date.now(),{document:E,reason:n}=_,{version:d}=E,h=Object.freeze({document:E,reason:n,waitUntil(w){if(Object.isFrozen(D))throw(0,P.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(w))}});try{R.apply(I,[h])}catch(w){return Promise.reject(w)}return Object.freeze(D),new Promise((w,S)=>{const p=setTimeout(()=>S(new Error("timeout")),this._thresholds.timeout);return Promise.all(D).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(p),w(t)}).catch(t=>{clearTimeout(p),S(t)})}).then(w=>{const S={edits:[]};for(const p of w)if(Array.isArray(p)&&p.every(t=>t instanceof l.TextEdit))for(const{newText:t,newEol:o,range:r}of p)S.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:r&&A.Range.from(r),text:t,eol:o&&A.EndOfLine.from(o)}});if(S.edits.length!==0)return d===E.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(Ce[248],De([1,0,17,2,11,7,94]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(I,_,D,C){this.start=I,this.deletedCount=_,this.deletedItems=D,this.items=C}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(I,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,_,D){this.notebook=I,this._extHostDocument=_,this._cellData=D,this.handle=D.handle,this.uri=P.URI.revive(D.uri),this.cellKind=D.cellKind,this._outputs=D.outputs.map(l.NotebookCellOutput.to),this._internalMetadata=D.internalMetadata??{},this._metadata=Object.freeze(D.metadata??{}),this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:l.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return I._mime},set mime(C){I._mime=C},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(D)}return this._apiCell}setOutputs(I){this._outputs=I.map(l.NotebookCellOutput.to)}setOutputItems(I,_,D){const C=D.map(l.NotebookCellOutputItem.to),E=this._outputs.find(n=>n.id===I);if(E&&(_||(E.items.length=0),E.items.push(...C),E.items.length>1&&E.items.every(n=>T.isTextStreamMime(n.mime)))){const n=new Map,d=[];E.items.forEach(h=>{let w;n.has(h.mime)?w=n.get(h.mime):(w=[],n.set(h.mime,w),d.push(h.mime)),w.push(h.data)}),E.items.length=0,d.forEach(h=>{const w=T.compressOutputItemStreams(n.get(h));E.items.push({mime:h,data:w.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(l.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=y;class v{constructor(I,_,D,C,E){this._proxy=I,this._textDocumentsAndEditors=_,this._textDocuments=D,this.uri=C,this.handle=v._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0,void 0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,_={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===a.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(D){return D=I._validateIndex(D),I._cells[D].apiCell},getCells(D){return(D?I._getCells(D):I._cells).map(E=>E.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(_)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,_,D){this._versionId=I.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:D});const C={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},E=[];for(const d of I.rawEvents)d.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,C.contentChanges):d.kind===T.NotebookCellsChangeType.Move?this._moveCells(d.index,d.length,d.newIdx,C.contentChanges):d.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),E.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),E.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),E.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===T.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),E.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),E.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const n=new Map;for(let d=0;d<E.length;d++){const h=E[d],w=n.get(h.cell);if(w===void 0){const S=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});n.set(h.cell,S-1)}else C.cellChanges[w]={...C.cellChanges[w],...h}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let _=I.start|0,D=I.end|0;return _<0&&(_=0),D>this._cells.length&&(D=this._cells.length),I.with({start:_,end:D})}_getCells(I){I=this._validateRange(I);const _=[];for(let D=I.start;D<I.end;D++)_.push(this._cells[D]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,_,D){if(this._disposed)return;const C=[],E=[],n=[];if(I.reverse().forEach(d=>{const w=d[2].map(t=>{const o=new y(this,this._textDocumentsAndEditors,t);return _||E.push(y.asModelAddData(this.apiNotebook,t)),o}),S=new k(d[0],d[1],[],w),p=this._cells.splice(d[0],d[1],...w);for(const t of p)n.push(t.uri),S.deletedItems.push(t.apiCell);C.push(S)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:n}),D)for(const d of C)D.push(d.asApiEvent())}_moveCells(I,_,D,C){const E=this._cells.splice(I,_);this._cells.splice(D,0,...E);const n=[new k(I,_,E.map(d=>d.apiCell),[]),new k(D,0,[],E)];for(const d of n)C.push(d.asApiEvent())}_setCellOutputs(I,_){this._cells[I].setOutputs(_)}_setCellOutputItems(I,_,D,C){this._cells[I].setOutputItems(_,D,C)}_changeCellLanguage(I,_){const D=this._cells[I];D.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(D.uri,_)}_changeCellMime(I,_){const D=this._cells[I];D.apiCell.mime=_}_changeCellMetadata(I,_){this._cells[I].setMetadata(_)}_changeCellInternalMetadata(I,_){this._cells[I].setInternalMetadata(_)}getCellFromApiCell(I){return this._cells.find(_=>_.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(_=>_.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}v._handlePool=0,e.ExtHostNotebookDocument=v}),define(Ce[249],De([1,0,3,2,11,7]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(y,v,R,I={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=v,this._mainThreadBulkEdits=R,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new a.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(v,R,I)=>{const _=function(C){v.call(R,C)};return _.extension=y,this._onWillSaveNotebookDocumentEvent.event(_,void 0,I)}}async $participateInSave(y,v,R){const I=P.URI.revive(y),_=this._notebooksAndEditors.getNotebookDocument(I);if(!_)throw new Error("Unable to resolve notebook document");const D=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({document:_.apiNotebook,reason:l.NotebookDocumentSaveReason.to(v)},R,async(E,n)=>{const d=Date.now(),h=await await Promise.resolve(E);if(Date.now()-d>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!R.isCancellationRequested&&h&&Array.isArray(h))for(const w of h)w instanceof A.WorkspaceEdit?D.push(w):this._logService.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data")}),R.isCancellationRequested)return!1;if(D.length===0)return!0;const C={edits:[]};for(const E of D){const{edits:n}=l.WorkspaceEdit.from(E);C.edits=C.edits.concat(n)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Ce[137],De([1,0,8,11,7]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(k,y,v,R,I,_){this.id=k,this._proxy=y,this.notebookData=v,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=R,this._viewColumn=_}get apiEditor(){if(!this._editor){const k=this;this._editor={get notebook(){return k.notebookData.apiNotebook},get selection(){return k._selections[0]},set selection(y){this.selections=[y]},get selections(){return k._selections},set selections(y){if(!Array.isArray(y)||!y.every(l.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");k._selections=y,k._trySetSelections(y)},get visibleRanges(){return k._visibleRanges},revealRange(y,v){k._proxy.$tryRevealRange(k.id,P.NotebookRange.from(y),v??l.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_trySetSelections(k){this._proxy.$trySetSelections(this.id,k.map(P.NotebookRange.from))}_acceptViewColumn(k){this._viewColumn=k}}A.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=A}),define(Ce[250],De([1,0,8,3,16,11]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,v){this._logService=y,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,v);const R=this._notebooksAndEditors.getEditorById(y);v.visibleRanges&&R._acceptVisibleRanges(v.visibleRanges.ranges.map(A.NotebookRange.to)),v.selections&&R._acceptSelections(v.selections.selections.map(A.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const v in y)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(A.ViewColumn.to(y[v]))}};T=$e([Be(0,l.ILogService)],T),e.ExtHostNotebookEditors=T}),define(Ce[251],De([1,0,11,126,185,21,62,8]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,D,C){const E=this._handles++,{title:n,location:d,cancellable:h}=D,w={label:(0,l.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(E,{location:a.ProgressLocation.from(d),title:n,source:w,cancellable:h},_.isUnderDevelopment?void 0:_.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(E,C,!!h)}_withProgress(_,D,C){let E;C&&(E=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,E));const n=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),E?.dispose()};let d;try{d=D(new R(this._proxy,_),C&&E?E.token:A.CancellationToken.None)}catch(h){throw n(_),h}return d.then(h=>n(_),h=>n(_)),d}$acceptProgressCanceled(_){const D=this._mapHandleToCancellationSource.get(_);D&&(D.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=y;function v(I,_){return I.message=_.message,typeof _.increment=="number"&&(typeof I.increment=="number"?I.increment+=_.increment:I.increment=_.increment),I}class R extends P.Progress{constructor(_,D){super(C=>this.throttledReport(C)),this._proxy=_,this._handle=D}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}$e([(0,T.throttle)(100,(I,_)=>v(I,_),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ce[138],De([1,0,32,133,57,95,77,11,2]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const v=(w,S,p,t)=>{let o=S;return{enumerable:!0,configurable:!1,get(){return o},set(r){if(!p(o,r)){const c=o;o=r,w.listener?.(t(r,c))}}}},R=(w,S)=>w===S,I={range:(w,S)=>w===S?!0:!w||!S?!1:w.isEqual(S),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(w,S)=>!(w.length!==S.length||w.some(p=>!S.find(t=>p.id===t.id)))},_=w=>S=>({op:4,update:w(S)}),D=(w,S)=>({range:(()=>{let p;const t=_(o=>({range:a.Range.lift(k.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){w.listener?.({op:6}),I.range(p,o)||(p=o,w.listener?.(t(o)))}}})(),label:v(w,S,I.label,_(p=>({label:p}))),description:v(w,void 0,I.description,_(p=>({description:p}))),sortText:v(w,void 0,I.sortText,_(p=>({sortText:p}))),canResolveChildren:v(w,!1,I.canResolveChildren,p=>({op:2,state:p})),busy:v(w,!1,I.busy,_(p=>({busy:p}))),error:v(w,void 0,I.error,_(p=>({error:k.MarkdownString.fromStrict(p)||null}))),tags:v(w,[],I.tags,(p,t)=>({op:1,new:p.map(k.TestTag.from),old:t.map(k.TestTag.from)}))}),C=w=>{const S=l.TestId.fromString(w.extId),p=new n(S.controllerId,S.localId,w.label,y.URI.revive(w.uri)||void 0);return p.range=k.Range.to(w.range||void 0),p.description=w.description||void 0,p.sortText=w.sortText||void 0,p.tags=w.tags.map(t=>k.TestTag.to({id:(0,T.denamespaceTestTag)(t).tagId})),p},E=w=>{let S;for(const p of w.tests){const t=C(p.item);(0,P.getPrivateApiFor)(t).parent=S,S=t}return S};e.toItemFromContext=E;class n{constructor(S,p,t,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,P.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,P.getPrivateApiFor,n),enumerable:!0,writable:!1},...D(r,t)})}}e.TestItemImpl=n;class d extends n{constructor(S,p){super(S,S,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class h extends A.TestItemCollection{constructor(S,p,t){super({controllerId:S,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:P.getPrivateApiFor,getChildren:o=>o.children,root:new d(S,p),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(Ce[139],De([1,0,51,8,102,11,7]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class k{constructor(_,D,C){const E=k._Keys.nextId();_.$registerTextEditorDecorationType(D.identifier,E,A.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:E,dispose(){_.$removeTextEditorDecorationType(E)}})}}k._Keys=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=k;class y{constructor(_,D){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=D.undoStopBefore,this._undoStopAfter=D.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,D){this._throwIfFinalized();let C=null;if(_ instanceof T.Position)C=new T.Range(_,_);else if(_ instanceof T.Range)C=_;else throw new Error("Unrecognized location");this._pushEdit(C,D,!1)}insert(_,D){this._throwIfFinalized(),this._pushEdit(new T.Range(_,_),D,!0)}delete(_){this._throwIfFinalized();let D=null;if(_ instanceof T.Range)D=_;else throw new Error("Unrecognized location");this._pushEdit(D,null,!0)}_pushEdit(_,D,C){const E=this._document.validateRange(_);this._collectedEdits.push({range:E,text:D,forceMoveMarkers:C})}setEndOfLine(_){if(this._throwIfFinalized(),_!==T.EndOfLine.LF&&_!==T.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=_}}class v{constructor(_,D,C,E){this._proxy=_,this._id=D,this._accept(C),this._logService=E;const n=this;this.value={get tabSize(){return n._tabSize},set tabSize(d){n._setTabSize(d)},get indentSize(){return n._indentSize},set indentSize(d){n._setIndentSize(d)},get insertSpaces(){return n._insertSpaces},set insertSpaces(d){n._setInsertSpaces(d)},get cursorStyle(){return n._cursorStyle},set cursorStyle(d){n._setCursorStyle(d)},get lineNumbers(){return n._lineNumbers},set lineNumbers(d){n._setLineNumbers(d)}}}_accept(_){this._tabSize=_.tabSize,this._indentSize=_.indentSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const D=Math.floor(_);return D>0?D:null}if(typeof _=="string"){const D=parseInt(_,10);return isNaN(D)?null:D>0?D:null}return null}_setTabSize(_){const D=this._validateTabSize(_);if(D!==null){if(typeof D=="number"){if(this._tabSize===D)return;this._tabSize=D}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:D}))}}_validateIndentSize(_){if(_==="tabSize")return"tabSize";if(typeof _=="number"){const D=Math.floor(_);return D>0?D:null}if(typeof _=="string"){const D=parseInt(_,10);return isNaN(D)?null:D>0?D:null}return null}_setIndentSize(_){const D=this._validateIndentSize(_);if(D!==null){if(typeof D=="number"){if(this._indentSize===D)return;this._indentSize=D}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:D}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const D=this._validateInsertSpaces(_);if(typeof D=="boolean"){if(this._insertSpaces===D)return;this._insertSpaces=D}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:D}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(_)})))}assign(_){const D={};let C=!1;if(typeof _.tabSize<"u"){const E=this._validateTabSize(_.tabSize);E==="auto"?(C=!0,D.tabSize=E):typeof E=="number"&&this._tabSize!==E&&(this._tabSize=E,C=!0,D.tabSize=E)}if(typeof _.indentSize<"u"){const E=this._validateIndentSize(_.indentSize);E==="tabSize"?(C=!0,D.indentSize=E):typeof E=="number"&&this._indentSize!==E&&(this._indentSize=E,C=!0,D.indentSize=E)}if(typeof _.insertSpaces<"u"){const E=this._validateInsertSpaces(_.insertSpaces);E==="auto"?(C=!0,D.insertSpaces=E):this._insertSpaces!==E&&(this._insertSpaces=E,C=!0,D.insertSpaces=E)}typeof _.cursorStyle<"u"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,C=!0,D.cursorStyle=_.cursorStyle),typeof _.lineNumbers<"u"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,C=!0,D.lineNumbers=A.TextEditorLineNumbersStyle.from(_.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,D))}_warnOnError(_,D){D.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=v;class R{constructor(_,D,C,E,n,d,h,w){this.id=_,this._proxy=D,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._options=new v(this._proxy,this.id,d,C),this._visibleRanges=h,this._viewColumn=w;const S=this;this.value=Object.freeze({get document(){return E.value},set document(p){throw(0,P.readonly)("document")},get selection(){return S._selections&&S._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,P.illegalArgument)("selection");S._selections=[p],S._trySetSelection()},get selections(){return S._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,P.illegalArgument)("selections");S._selections=p,S._trySetSelection()},get visibleRanges(){return S._visibleRanges},set visibleRanges(p){throw(0,P.readonly)("visibleRanges")},get options(){return S._options.value},set options(p){S._disposed||S._options.assign(p)},get viewColumn(){return S._viewColumn},set viewColumn(p){throw(0,P.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(S._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new y(E.value,t);return p(o),S._applyEdit(o)},insertSnippet(p,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(S._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=S._selections.map(c=>A.Range.from(c));else if(t instanceof T.Position){const{lineNumber:c,column:m}=A.Position.from(t);r=[{startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:m}]}else if(t instanceof T.Range)r=[A.Range.from(t)];else{r=[];for(const c of t)if(c instanceof T.Range)r.push(A.Range.from(c));else{const{lineNumber:m,column:f}=A.Position.from(c);r.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return D.$tryInsertSnippet(_,E.value.version,p.value,r,o)},setDecorations(p,t){const o=t.length===0;o&&!S._hasDecorationsForKey.has(p.key)||(o?S._hasDecorationsForKey.delete(p.key):S._hasDecorationsForKey.add(p.key),S._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return D.$trySetDecorations(_,p.key,A.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let c=0,m=t.length;c<m;c++){const f=t[c];r[4*c]=f.start.line+1,r[4*c+1]=f.start.character+1,r[4*c+2]=f.end.line+1,r[4*c+3]=f.end.character+1}return D.$trySetDecorationsFast(_,p.key,r)}}))},revealRange(p,t){S._runOnProxy(()=>D.$tryRevealRange(_,A.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){D.$tryShowEditor(_,A.ViewColumn.from(p))},hide(){D.$tryHideEditor(_)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,a.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,a.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,a.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,a.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const D=_.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const C=D.edits.map(n=>n.range);C.sort((n,d)=>n.end.line===d.end.line?n.end.character===d.end.character?n.start.line===d.start.line?n.start.character-d.start.character:n.start.line-d.start.line:n.end.character-d.end.character:n.end.line-d.end.line);for(let n=0,d=C.length-1;n<d;n++){const h=C[n].end;if(C[n+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=D.edits.map(n=>({range:A.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,E,{setEndOfLine:typeof D.setEndOfLine=="number"?A.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this._logService.warn(D),null))}}e.ExtHostTextEditor=R}),define(Ce[252],De([1,0,189,7,24,2,3,6,232,19,7,10,18,11,21,27,157]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(S,p){if((0,I.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let t;return Array.isArray(S.highlights)&&(t=S.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:S.label,highlights:t}}}class h{constructor(p,t,o){this._proxy=p,this.commands=t,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDnDService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(m=>r(m)?this.convertArgument(m):m):c})}registerTreeDataProvider(p,t,o){const r=this.createTreeView(p,{treeDataProvider:t},o);return{dispose:()=>r.dispose()}}createTreeView(p,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],m=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,i=this.createExtHostTreeView(p,t,o),s=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:m,hasHandleDrop:f});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,E.checkProposedApiEnabled)(o,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(u){i.message=u},get title(){return i.title},set title(u){i.title=u},get description(){return i.description},set description(u){i.description=u},get badge(){return i.badge},set badge(u){u!==void 0&&R.ViewBadge.isViewBadge(u)?i.badge={value:Math.floor(Math.abs(u.value)),tooltip:u.tooltip}:u===void 0&&(i.badge=void 0)},reveal:(u,b)=>i.reveal(u,b),dispose:async()=>{await s,this.treeViews.delete(p),i.dispose()}}}$getChildren(p,t){const o=this.treeViews.get(p);return o?o.getChildren(t):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,t,o,r,c,m,f,i){const s=this.treeViews.get(p);if(!s)return Promise.reject(new y.NoTreeViewError(p));const u=D.DataTransfer.toDataTransfer(o,async b=>(await this._proxy.$resolveDropFileData(p,t,b)).buffer);return f===p&&i&&await this.addAdditionalTransferItems(u,s,i,c,m),s.onDrop(u,r,c)}async addAdditionalTransferItems(p,t,o,r,c){const m=this.treeDragAndDropService.removeDragOperationTransfer(c);if(m)(await m)?.forEach((f,i)=>{f&&p.set(i,f)});else if(c&&t.handleDrag){const f=t.handleDrag(o,p,r);this.treeDragAndDropService.addDragOperationTransfer(c,f),await f}return p}async $handleDrag(p,t,o,r){const c=this.treeViews.get(p);if(!c)return Promise.reject(new y.NoTreeViewError(p));const m=await this.addAdditionalTransferItems(new P.DataTransfer,c,t,r,o);if(!!m)return D.DataTransfer.toDataTransferDTO(m)}async $hasResolve(p){const t=this.treeViews.get(p);if(!t)throw new y.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,o){const r=this.treeViews.get(p);if(!r)throw new y.NoTreeViewError(p);return r.resolveTreeItem(t,o)}$setExpanded(p,t,o){const r=this.treeViews.get(p);if(!r)throw new y.NoTreeViewError(p);r.setExpanded(t,o)}$setSelection(p,t){const o=this.treeViews.get(p);if(!o)throw new y.NoTreeViewError(p);o.setSelection(t)}$setFocus(p,t){const o=this.treeViews.get(p);if(!o)throw new y.NoTreeViewError(p);o.setFocus(t)}$setVisible(p,t){const o=this.treeViews.get(p);if(!o)throw new y.NoTreeViewError(p);o.setVisible(t)}$changeCheckboxState(p,t){const o=this.treeViews.get(p);if(!o)throw new y.NoTreeViewError(p);o.setCheckboxState(t)}createExtHostTreeView(p,t,o){const r=new w(p,t,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(p,r),r}convertArgument(p){const t=this.treeViews.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=h;class w extends k.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,I.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,t,o,r,c,m){if(super(),this.viewId=p,this.proxy=o,this.commands=r,this.logService=c,this.extension=m,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,m.contributes&&m.contributes.views)for(const s in m.contributes.views)for(const u of m.contributes.views[s])u.id===p&&(this._title=u.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let f,i;this._register(T.Event.debounce(this._onDidChangeData.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(f||(f=new Promise(b=>i=b),this.refreshPromise=this.refreshPromise.then(()=>f)),Array.isArray(u.element)?s.elements.push(...u.element):s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=i;return f=null,this.refresh(u).then(()=>b())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(p);return o||(o=await this.fetchChildrenNodes(t)),o?o.map(r=>r.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,I.isUndefinedOrNull)(t.focus)?!1:t.focus,c=(0,I.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(m=>this.resolveTreeNode(p,m[m.length-1]).then(f=>this.proxy.$reveal(this.viewId,{item:f.item,parentChain:m.map(i=>i.item)},{select:o,focus:r,expand:c})),m=>this.logService.error(m)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:r,expand:c})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=D.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,t){const o=this.getExtensionElement(p);o&&(t?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(p){(0,_.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async o=>{const r=this.getExtensionElement(o.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:o.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,t,o){const r=[];for(const c of p){const m=this.getExtensionElement(c);m&&r.push(m)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,o),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,t,o){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,p,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,t){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(p);if(o){const r=this.nodes.get(o);if(r){const c=await this.dataProvider.resolveTreeItem(r.extensionItem,o,t)??r.extensionItem;return this.validateTreeItem(c),r.item.tooltip=this.getTooltip(c.tooltip),r.item.command=this.getCommand(r.disposableStore,c.command),r.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(t=>t?this.resolveUnknownParentChain(t).then(o=>this.resolveTreeNode(t,o[o.length-1]).then(r=>(o.push(r),o))):Promise.resolve([]))}resolveParent(p){const t=this.nodes.get(p);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,t){const o=this.nodes.get(p);return o?Promise.resolve(o):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(r=>this.createHandle(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const m=this.nodes.get(c);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(p){if(p){let t;if(typeof p=="string"){const o=this.getExtensionElement(p);t=o?this.nodes.get(o):void 0}else t=p;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const t=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=p?this.nodes.get(p):void 0,r=await this.dataProvider.getChildren(p);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,_.coalesce)(r||[]).map(async m=>{const f=await this.dataProvider.getTreeItem(m);return f&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(m,f,o):null}));return t.token.isCancellationRequested?void 0:(0,_.coalesce)(c)}finally{t.dispose()}}refresh(p){if(p.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(p);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const t=new Set,o=p.map(c=>this.nodes.get(c));for(const c of o)if(c&&!t.has(c.item.handle)){let m=c;for(;m&&m.parent&&o.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.elements.get(m.parent.item.handle);m=f?this.nodes.get(f):void 0}m&&!m.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const m=this.elements.get(c);if(m){const f=this.nodes.get(m);f&&(!f.parent||!t.has(f.parent.item.handle))&&r.push(c)}}),r}refreshHandles(p){const t={};return Promise.all(p.map(o=>this.refreshNode(o).then(r=>{r&&(t[o]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(p){const t=this.getExtensionElement(p);if(t){const o=this.nodes.get(t);if(o)return this.clearChildren(t),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const c=this.createTreeNode(t,r,o.parent);return this.updateNodeCache(t,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,t,o){const r=this.createTreeNode(p,t,o);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.addNodeToCache(p,r),this.addNodeToParentCache(r,o),r}getTooltip(p){return R.MarkdownString.isMarkdownString(p)?D.MarkdownString.from(p):p}getCommand(p,t){return t?{...this.commands.toInternal(t,p),originalId:t.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let t,o;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:t===R.TreeItemCheckboxState.Checked,tooltip:o}}validateTreeItem(p){if(!R.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,t,o){this.validateTreeItem(t);const r=new k.DisposableStore,c=this.createHandle(p,t,o),m=this.getLightIconPath(t);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:d(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:m,iconDark:this.getDarkIconPath(t)||m,themeIcon:this.getThemeIcon(t),collapsibleState:(0,I.isUndefinedOrNull)(t.collapsibleState)?R.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:o,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(p){return p.iconPath instanceof R.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:t,label:o,resourceUri:r},c,m){if(t)return`${w.ID_HANDLE_PREFIX}/${t}`;const f=d(o,this.extension),i=c?c.item.handle:w.LABEL_HANDLE_PREFIX;let s=f?f.label:r?(0,l.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,b=this.getChildrenNodes(c)||[];let g,L=0;do{if(g=`${i}/${L}:${s}`,m||!this.elements.has(g)||u===g)break;L++}while(L<=b.length);return g}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon))return typeof p.iconPath=="string"||A.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return A.URI.isUri(p)?p:A.URI.file(p)}addNodeToCache(p,t){this.elements.set(t.item.handle,p),this.nodes.set(p,t)}updateNodeCache(p,t,o,r){this.elements.delete(t.item.handle),this.nodes.delete(p),t.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(p,t);const c=this.getChildrenNodes(r)||[],m=c.filter(f=>f.item.handle===o.item.handle)[0];m&&c.splice(c.indexOf(m),1,t)}addNodeToParentCache(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const t=this.nodes.get(p);if(t){if(t.children)for(const o of t.children){const r=this.elements.get(o.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(p){const t=this.nodes.get(p);if(t){if(t.children)for(const o of t.children){const r=this.elements.get(o.item.handle);r&&this.clear(r)}this.nodes.delete(p),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(Ce[253],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookDocumentWillSave:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDocumentWillSave.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[254],De([1,0,201,8,38,123,93,40,25,253,215,129]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const _=k.Registry.as(T.Extensions.JSONContribution);class D{constructor(p,t,o){this._messageHandler=p,this._extension=t,this._extensionPointId=o}_msg(p,t){this._messageHandler({type:p,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(l.default.Error,p)}warn(p){this._msg(l.default.Warning,p)}info(p){this._msg(l.default.Info,p)}}e.ExtensionMessageCollector=D;class C{static _toSet(p){const t=new y.ExtensionIdentifierSet;for(let o=0,r=p.length;o<r;o++)t.add(p[o].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new C(t,[]);if(!t||!t.length)return new C([],p);const o=this._toSet(p),r=this._toSet(t),c=t.filter(f=>!o.has(f.description.identifier)),m=p.filter(f=>!r.has(f.description.identifier));return new C(c,m)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=C;class E{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=C.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,P.onUnexpectedError)(p)}}}e.ExtensionPoint=E;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new E(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,t),p.activationEventsGenerator&&I.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,_.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const w={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(w.ExtensionsRegistry,new h),e.ExtensionsRegistry=k.Registry.as(w.ExtensionsRegistry),_.registerSchema(d,e.schema),_.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(Ce[255],De([1,0,198,10,23,254,44,3]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var v;(function(_){function D(C,E,n){if(!C)return;const d=P.isString(C.type)?C.type:void 0;if(!d||d.length===0){n.error(a.localize(3,null));return}const h=[];if(Array.isArray(C.required))for(const w of C.required)P.isString(w)&&h.push(w);return{extensionId:E.value,taskType:d,required:h,properties:C.properties?l.deepClone(C.properties):{},when:C.when?T.ContextKeyExpr.deserialize(C.when):void 0}}_.from=D})(v||(v={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(_,D)=>{for(const C of _)C.type&&D.push(`onTaskType:${C.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:y}});class I{constructor(){this._onDefinitionsChanged=new k.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((D,C)=>{R.setHandler((E,n)=>{this._schema=void 0;try{for(const d of n.removed){const h=d.value;for(const w of h)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const d of n.added){const h=d.value;for(const w of h){const S=v.from(w,d.description.identifier,d.collector);S&&(this.taskTypes[S.taskType]=S)}}(n.removed.length>0||n.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}D(void 0)})})}onReady(){return this.readyPromise}get(D){return this.taskTypes[D]}all(){return Object.keys(this.taskTypes).map(D=>this.taskTypes[D])}getJsonSchema(){if(this._schema===void 0){const D=[];for(const C of this.all()){const E={type:"object",additionalProperties:!1};C.required.length>0&&(E.required=C.required.slice(0)),C.properties!==void 0?E.properties=l.deepClone(C.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[C.taskType]},D.push(E)}this._schema={oneOf:D}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(Ce[256],De([1,0,199,10,24,23,44,255]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function x(F){if(!F)return N.Strong;switch(F.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=x}(y=e.ShellQuoting||(e.ShellQuoting={}));var v;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(v=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function x(F){switch(F.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=x}(R=e.RevealKind||(e.RevealKind={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function x(F){switch(F.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=x}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(N){function x(F){switch(F.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=x}(_=e.PanelKind||(e.PanelKind={}));var D;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(D=e.PresentationOptions||(e.PresentationOptions={}));var C;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(C=e.RuntimeType||(e.RuntimeType={})),function(N){function x(V){switch(V.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=x;function F(V){switch(V){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=F}(C=e.RuntimeType||(e.RuntimeType={}));var E;(function(N){function x(F){return P.isString(F)?F:F.value}N.value=x})(E=e.CommandString||(e.CommandString={}));var n;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function x(V){return V===N.Clean._id||V===N.Build._id||V===N.Rebuild._id||V===N.Test._id}N.is=x;function F(V){if(V!==void 0)return P.isString(V)?x(V)?{_id:V,isDefault:!1}:void 0:V}N.from=F})(n=e.TaskGroup||(e.TaskGroup={}));var d;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var h;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function x(F){switch(F){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=x})(h=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(N){N.parallel="parallel",N.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var S;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(S=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class t{constructor(x,F,V,fe,se,$){this._label="",this._id=x,F&&(this._label=F),V&&(this.type=V),this.runOptions=fe,this.configurationProperties=se,this._source=$}getDefinition(x){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,F=!1){if(x===void 0)return!1;if(P.isString(x))return x===this._label||x===this.configurationProperties.identifier||F&&x===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class o extends t{constructor(x,F,V,fe,se,$,J,te){super(x,V,void 0,J,te,F),this.command={},this._source=F,this.hasDefinedMatchers=$,se&&(this.command=se)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case C.Shell:F="shell";break;case C.Process:F="process";break;case C.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(x){return x instanceof o}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:F};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new o(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=o;class r extends t{constructor(x,F,V,fe,se,$,J){super(x,V,fe,$,J,F),this._source=F,this.configures=se}static is(x){return x instanceof r}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:F};return JSON.stringify(V)}}e.ConfiguringTask=r;class c extends t{constructor(x,F,V,fe,se,$,J,te,be){super(x,V,fe,te,be,F),this.defines=se,this.hasDefinedMatchers=J,this.command=$,this.icon=be.icon,this.hide=be.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof c}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new c(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=c;class m extends t{constructor(x,F,V,fe,se,$){super(x,V,fe,se,$,F),this._source=F}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new m(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=m;var f;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(x){this._order=new Map;for(let F=0;F<x.length;F++)this._order.set(x[F].uri.toString(),F)}compare(x,F){const V=x.getWorkspaceFolder(),fe=F.getWorkspaceFolder();if(V&&fe){let se=this._order.get(V.uri.toString());se=se===void 0?0:se+1;let $=this._order.get(fe.uri.toString());return $=$===void 0?0:$+1,se===$?x._label.localeCompare(F._label):se-$}else return!V&&fe?-1:V&&!fe?1:0}}e.TaskSorter=s;var u;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(u=e.TaskEventKind||(e.TaskEventKind={}));var b;(function(N){N.SingleRun="singleRun",N.Background="background"})(b=e.TaskRunType||(e.TaskRunType={}));var g;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(g=e.TaskRunSource||(e.TaskRunSource={}));var L;(function(N){function x(F,V,fe,se){if(V){const $={kind:F,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:V};return F==="start"?$.resolvedVariables=se:F==="processStarted"?$.processId=se:F==="processEnded"&&($.exitCode=se),Object.freeze($)}else return Object.freeze({kind:"changed"})}N.create=x})(L=e.TaskEvent||(e.TaskEvent={}));var H;(function(N){function x(V){const fe=Object.keys(V).sort();let se="";for(const $ of fe){let J=V[$];J instanceof Object?J=x(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),se+=$+","+J+","}return se}function F(V){const se={_key:x(V),type:V.taskType};return Object.assign(se,V),se}N.create=F})(H=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var X;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(X=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(N){function x(F,V){const fe=k.TaskDefinitionRegistry.get(F.type);if(fe===void 0){const te=A.deepClone(F);return delete te._key,H.create(te)}const se=Object.create(null);se.type=fe.taskType;const $=new Set;fe.required.forEach(te=>$.add(te));const J=fe.properties;for(const te of Object.keys(J)){const be=F[te];if(be!=null)se[te]=be;else if($.has(te)){const le=J[te];if(le.default!==void 0)se[te]=A.deepClone(le.default);else switch(le.type){case"boolean":se[te]=!1;break;case"number":case"integer":se[te]=0;break;case"string":se[te]="";break;default:V.error(a.localize(2,null,JSON.stringify(F,void 0,0),te));return}}}return H.create(se)}N.createTaskIdentifier=x})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[257],De([1,0,8]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,a.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=P;class l extends P{constructor(){super(),this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=l}),define(Ce[58],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const P=[];function l(k){const y=new a(k);return P[y.nid]=y,y}e.createProxyIdentifier=l;function A(k){return P[k].sid}e.getStringIdentifierForProxy=A;class T{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=T}),define(Ce[5],De([1,0,58]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var A;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var T;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var v;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(v=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(n){return n._id=I._n++,n}}I._n=0,e.IdObject=I;var _;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(_=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var D;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(D=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var C;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,a.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,a.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,a.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,a.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[79],De([1,0,4,16,5,20]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,v){this._extHostLogService=v,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(l.MainContext.MainThreadTelemetry)}report(y,v,R){const I=this.getUsageKey(y,v);this._reportedUsages.has(I)||(this._reportedUsages.add(I),v.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:y}))}getUsageKey(y,v){return`${y}-${v.identifier.value}`}};T=$e([Be(0,A.IExtHostRpcService),Be(1,P.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,v){}})}),define(Ce[258],De([1,0,3,5,7,25]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(v){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new k,this._getSessionsTaskSingler=new k,this._proxy=v.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(v){return this._providers=v,Promise.resolve()}async getSession(v,R,I,_={}){const D=A.ExtensionIdentifier.toKey(v.identifier),C=[...I].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${D} ${R} ${C}`,async()=>{await this._proxy.$ensureProvider(R);const E=v.displayName||v.name;return this._proxy.$getSession(R,I,D,E,_)})}async getSessions(v,R,I){const _=A.ExtensionIdentifier.toKey(v.identifier),D=[...I].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${_} ${D}`,async()=>{await this._proxy.$ensureProvider(R);const C=v.displayName||v.name;return this._proxy.$getSessions(R,I,_,C)})}async removeSession(v,R){const I=this._authenticationProviders.get(v);return I?I.provider.removeSession(R):this._proxy.$removeSession(v,R)}registerAuthenticationProvider(v,R,I,_){if(this._authenticationProviders.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this._authenticationProviders.set(v,{label:R,provider:I,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===v)||this._providers.push({id:v,label:R});const D=I.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(v,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(v,R,_?.supportsMultipleAccounts??!1),new l.Disposable(()=>{D.dispose(),this._authenticationProviders.delete(v);const C=this._providers.findIndex(E=>E.id===v);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(v)})}$createSession(v,R){const I=this._authenticationProviders.get(v);if(I)return Promise.resolve(I.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,R){const I=this._authenticationProviders.get(v);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,R){const I=this._authenticationProviders.get(v);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,R){return this._onDidChangeSessions.fire({provider:{id:v,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=T;class k{constructor(){this._inFlightPromises=new Map}getOrCreate(v,R){const I=this._inFlightPromises.get(v);if(I)return I;const _=R().finally(()=>this._inFlightPromises.delete(v));return this._inFlightPromises.set(v,_),_}}}),define(Ce[259],De([1,0,5,20,11]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,y){this._proxy=k.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:v=>y.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k,y,v){const R=l.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};A=$e([Be(0,P.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Ce[260],De([1,0,5]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(A){const T=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(k){return T.$writeText(k)}})}}e.ExtHostClipboard=P});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[41],De([1,0,10,7,11,23,5,18,16,70,32,53,2,6,4,20,138,22,58,46,37,75,78]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t){"use strict";var o,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(g,L,H){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,r.set(this,void 0),c.set(this,void 0),Je(this,o,g.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=L,Je(this,c,H,"f"),Je(this,r,g.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new f(this,q=>{const X=this._apiCommands.get(q);return X?.result===s.Void?X:void 0},L),this._argumentProcessors=[{processArgument(q){return(0,v.revive)(q)}},{processArgument(q){return(0,A.cloneAndChange)(q,function(X){if(R.Range.isIRange(X))return l.Range.to(X);if(I.Position.isIPosition(X))return l.Position.to(X);if(R.Range.isIRange(X.range)&&_.URI.isUri(X.uri))return l.location.to(X);if(X instanceof d.VSBuffer)return X.buffer.buffer;if(!Array.isArray(X))return X})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const L=this.registerCommand(!1,g.id,async(...H)=>{const q=g.args.map((U,N)=>{if(!U.validate(H[N]))throw new Error(`Invalid argument '${U.name}' when running '${g.id}', received: ${H[N]}`);return U.convert(H[N])}),X=await this.executeCommand(g.internalId,...q);return g.result.convert(X,H,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new P.Disposable(()=>{L.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,L,H,q,X,U){if(this._logService.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this._commands.has(L))throw new Error(`command '${L}' already exists`);return this._commands.set(L,{callback:H,thisArg:q,description:X,extension:U}),g&&Ne(this,o,"f").$registerCommand(L),new P.Disposable(()=>{this._commands.delete(L)&&g&&Ne(this,o,"f").$unregisterCommand(L)})}executeCommand(g,...L){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,L,!0)}async _doExecuteCommand(g,L,H){if(this._commands.has(g))return Ne(this,o,"f").$fireCommandActivationEvent(g),this._executeContributedCommand(g,L,!1);{let q=!1;const X=(0,A.cloneAndChange)(L,function(U){if(U instanceof P.Position)return l.Position.from(U);if(U instanceof P.Range)return l.Range.from(U);if(U instanceof P.Location)return l.location.from(U);if(P.NotebookRange.isNotebookRange(U))return l.NotebookRange.from(U);if(U instanceof ArrayBuffer)return q=!0,d.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return q=!0,d.VSBuffer.wrap(U);if(U instanceof d.VSBuffer)return q=!0,U;if(!Array.isArray(U))return U});try{const U=await Ne(this,o,"f").$executeCommand(g,q?new h.SerializableObjectWithBuffers(X):X,H);return(0,v.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(g,L,!1);throw U}}}async _executeContributedCommand(g,L,H){const q=this._commands.get(g);if(!q)throw new Error("Unknown command");const{callback:X,thisArg:U,description:N}=q;if(N)for(let F=0;F<N.args.length;F++)try{(0,a.validateConstraint)(L[F],N.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${N.args[F].name}' - ${N.args[F].description}`)}const x=S.StopWatch.create();try{return await X.apply(U,L)}catch(F){if(g===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...L);V&&(g=V.command)}if(this._logService.error(F,g,q.extension?.identifier),!H)throw F;if(q.extension?.identifier){const V=Ne(this,c,"f").onExtensionError(q.extension.identifier,F);this._logService.trace("forwarded error to extension?",V,q.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.toErrorMessage)(F)),this.id=g,this.source=q.extension?.displayName??q.extension?.name}}}finally{this._reportTelemetry(q,g,x.elapsed())}}_reportTelemetry(g,L,H){!g.extension||Ne(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new p.TelemetryTrustedValue(L),duration:H})}$executeContributedCommand(g,...L){this._logService.trace("ExtHostCommands#$executeContributedCommand",g);const H=this._commands.get(g);return H?(L=L.map(q=>this._argumentProcessors.reduce((X,U)=>U.processArgument(X,H.extension?.identifier),q)),this._executeContributedCommand(g,L,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),Ne(this,o,"f").$getCommands().then(L=>(g&&(L=L.filter(H=>H[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[L,H]of this._commands){const{description:q}=H;q&&(g[L]=q)}return Promise.resolve(g)}};o=new WeakMap,r=new WeakMap,c=new WeakMap,m=$e([Be(0,E.IExtHostRpcService),Be(1,y.ILogService),Be(2,t.IExtHostTelemetry)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class f{constructor(g,L,H){this._commands=g,this._lookupApiCommand=L,this._logService=H,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,L){if(!g)return;const H={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return H;const q=this._lookupApiCommand(g.command);if(q)H.id=q.internalId,H.arguments=q.args.map((X,U)=>X.convert(g.arguments&&g.arguments[U]));else if((0,k.isNonEmptyArray)(g.arguments)){const X=`${g.command}/${++this._cachIdPool}`;this._cache.set(X,g),L.add((0,D.toDisposable)(()=>{this._cache.delete(X),this._logService.trace("CommandsConverter#DISPOSE",X)})),H.$ident=X,H.id=this.delegatingCommandId,H.arguments=[X],this._logService.trace("CommandsConverter#CREATE",g.command,X)}return H}fromInternal(g){return typeof g.$ident=="string"?this._cache.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const L=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],L?L.command:"MISSING"),L?this._commands.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=f;class i{constructor(g,L,H,q){this.name=g,this.description=L,this.validate=H,this.convert=q}optional(){return new i(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,L){return new i(g??this.name,L??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",b=>_.URI.isUri(b),b=>b),i.Position=new i("position","A position in a text document",b=>P.Position.isPosition(b),l.Position.from),i.Range=new i("range","A range in a text document",b=>P.Range.isRange(b),l.Range.from),i.Selection=new i("selection","A selection in a text document",b=>P.Selection.isSelection(b),l.Selection.from),i.Number=new i("number","",b=>typeof b=="number",b=>b),i.String=new i("string","",b=>typeof b=="string",b=>b),i.CallHierarchyItem=new i("item","A call hierarchy item",b=>b instanceof P.CallHierarchyItem,l.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",b=>b instanceof P.TypeHierarchyItem,l.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",b=>b instanceof n.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=i;class s{constructor(g,L){this.description=g,this.convert=L}}s.Void=new s("no result",b=>b),e.ApiCommandResult=s;class u{constructor(g,L,H,q,X){this.id=g,this.internalId=L,this.description=H,this.args=q,this.result=X}}e.ApiCommand=u}),define(Ce[261],De([1,0,18,17,2,73,121,44,125,41,11,7]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(R.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,a.isFalsyOrEmpty)(n))return;class h extends I.SymbolInformation{static to(S){const p=new h(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new I.Location(d[0],R.Range.to(S.range)));return p.detail=S.detail,p.range=p.location.range,p.selectionRange=R.Range.to(S.selectionRange),p.children=S.children?S.children.map(h.to):[],p}}return n.map(h.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(R.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(R.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(R.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(R.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>I.Position.isPosition(d)),n=>n.map(R.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let h;for(const w of d.reverse())h=new I.SelectionRange(R.Range.to(w),h);return h}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(R.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(R.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(R.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(R.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:R.Range.to(n.range),placeholder:n.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return R.WorkspaceEdit.to(n)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(R.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new I.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,T.decodeSemanticTokensDto)(n);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new I.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,T.decodeSemanticTokensDto)(n);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,h)=>{if(!n)return new I.CompletionList([]);const w=n.suggestions.map(S=>R.CompletionItem.to(S,h));return new I.CompletionList(w,n.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return R.SignatureHelp.to(n)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,h)=>C(w=>new I.CodeLens(R.Range.to(w.range),w.command&&h.fromInternal(w.command)))(n))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>I.Range.isRange(n),n=>I.Selection.isSelection(n)?R.Selection.from(n):R.Range.from(n)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,h)=>C(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const S=new I.CodeAction(w.title,w.kind?new I.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=R.WorkspaceEdit.to(w.edit)),w.command&&(S.command=h.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(n))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new I.ColorInformation(R.Range.to(d.range),R.Color.to(d.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",n=>n instanceof I.Color,R.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:R.Range.from(n.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(R.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,d,h)=>n.map(R.InlayHint.to.bind(void 0,h)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,d)=>{if(n)return n.map(R.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>R.NotebookExclusiveDocumentPattern.to(d))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(R.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>l.URI.isUri(n)||typeof n=="string"&&(0,y.matchesSomeScheme)(n,P.Schemas.http,P.Schemas.https),n=>n),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[R.ViewColumn.from(n),void 0]:[R.ViewColumn.from(n.viewColumn),R.TextEditorOpenOptions.from(n)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[R.ViewColumn.from(n),void 0]:[R.ViewColumn.from(n.viewColumn),R.TextEditorOpenOptions.from(n)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[R.ViewColumn.from(n.viewColumn),R.TextEditorOpenOptions.from(n)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(R.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],v.ApiCommandResult.Void)];class D{static register(d){_.forEach(d.registerApiCommand,d),this._registerValidateWhenClausesCommand(d)}static _registerValidateWhenClausesCommand(d){d.registerCommand(!1,"_validateWhenClauses",k.validateWhenClauses)}}e.ExtHostApiCommands=D;function C(n){return d=>{if(Array.isArray(d))return d.map(n)}}function E(n){if(!Array.isArray(n))return;const d=[];for(const h of n)A.isLocationLink(h)?d.push(R.DefinitionLink.to(h)):d.push(R.location.to(h));return d}}),define(Ce[262],De([1,0,19,62,3,6,2,73,25,11,7,5,27]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(C,E,n){const d=C.getProxy(I.MainContext.MainThreadComments);class h{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new y.ExtensionIdentifierMap,E.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const i=this._commentControllers.get(f.handle);return i?i.value:f}else if(f&&f.$mid===7){const i=this._commentControllers.get(f.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.commentThreadHandle);return s?s.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const i=this._commentControllers.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);return s?f.$mid===8?s.value:{thread:s.value,text:f.text}:f}else if(f&&f.$mid===10){const i=this._commentControllers.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;const u=f.commentUniqueId,b=s.getCommentByUniqueId(u);return b||f}else if(f&&f.$mid===11){const i=this._commentControllers.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;const u=f.text,b=f.commentUniqueId,g=s.getCommentByUniqueId(b);return g?(typeof g.body=="string"?g.body=u:g.body=new R.MarkdownString(u),g):f}return f}})}createCommentController(f,i,s){const u=h.handlePool++,b=new S(f,u,i,s);this._commentControllers.set(b.handle,b);const g=this._commentControllersByExtension.get(f.identifier)||[];return g.push(b),this._commentControllersByExtension.set(f.identifier,g),b.value}$createCommentThreadTemplate(f,i,s){const u=this._commentControllers.get(f);!u||u.$createCommentThreadTemplate(i,s)}async $updateCommentThreadTemplate(f,i,s){const u=this._commentControllers.get(f);!u||u.$updateCommentThreadTemplate(i,s)}$deleteCommentThread(f,i){this._commentControllers.get(f)?.$deleteCommentThread(i)}$provideCommentingRanges(f,i,s){const u=this._commentControllers.get(f);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const b=n.getDocument(T.URI.revive(i));return(0,a.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(b,s)).then(g=>g?g.map(L=>v.Range.from(L)):void 0)}$toggleReaction(f,i,s,u,b){const g=this._commentControllers.get(f);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const L=g.getCommentThread(i);if(L){const H=L.getCommentByUniqueId(u.uniqueIdInThread);if(g!==void 0&&H&&g.reactionHandler)return g.reactionHandler(H,o(b))}return Promise.resolve(void 0)})}dispose(){}}h.handlePool=0;class w{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){(f===void 0!=(this._range===void 0)||!f||!this._range||!f.isEqual(this._range))&&(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(f){this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,i,s,u,b,g,L,H){this._commentControllerHandle=i,this._id=s,this._uri=u,this._range=b,this._comments=g,this.extensionDescription=L,this._isTemplate=H,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new l.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),d.$createCommentThread(i,this.handle,this._id,this._uri,v.Range.from(this._range),L.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(i,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(X){q.range=X},get comments(){return q.comments},set comments(X){q.comments=X},get collapsibleState(){return q.collapsibleState},set collapsibleState(X){q.collapsibleState=X},get canReply(){return q.canReply},set canReply(X){q.canReply=X},get contextValue(){return q.contextValue},set contextValue(X){q.contextValue=X},get label(){return q.label},set label(X){q.label=X},get state(){return q.state},set state(X){q.state=X},dispose:()=>{q.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const f=s=>Object.prototype.hasOwnProperty.call(this.modifications,s),i={};f("range")&&(i.range=v.Range.from(this._range)),f("label")&&(i.label=this.label),f("contextValue")&&(i.contextValue=this.contextValue??null),f("comments")&&(i.comments=this._comments.map(s=>p(this,s,this._commentsMap))),f("collapsibleState")&&(i.collapseState=r(this._collapseState)),f("canReply")&&(i.canReply=this.canReply),f("state")&&(i.state=c(this._state)),f("isTemplate")&&(i.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,i)}getCommentByUniqueId(f){for(const i of this._commentsMap){const s=i[0],u=i[1];if(f===u)return s}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}w._handlePool=0,$e([(0,P.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,i,s,u){this._extension=f,this._handle=i,this._id=s,this._label=u,this._threads=new Map,d.$registerCommentController(this.handle,s,u);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(g){b.options=g},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(g){b.commentingRangeProvider=g},get reactionHandler(){return b.reactionHandler},set reactionHandler(g){b.reactionHandler=g},createCommentThread(g,L,H){return b.createCommentThread(g,L,H).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(f,i,s){i===void 0&&(0,_.checkProposedApiEnabled)(this._extension,"fileComments");const u=new w(this.id,this.handle,void 0,f,i,s,this._extension,!1);return this._threads.set(u.handle,u),u}$createCommentThreadTemplate(f,i){const s=new w(this.id,this.handle,void 0,T.URI.revive(f),v.Range.to(i),[],this._extension,!0);return s.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(s.handle,s),s}$updateCommentThreadTemplate(f,i){const s=this._threads.get(f);s&&(s.range=v.Range.to(i))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function p(m,f,i){let s=i.get(f);return s||(s=++m.commentHandle,i.set(f,s)),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:s,body:typeof f.body=="string"?f.body:v.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(u=>t(u)):void 0,timestamp:f.timestamp?.toJSON()}}function t(m){return{label:m.label,iconPath:m.iconPath?v.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function o(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?T.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function r(m){if(m!==void 0)switch(m){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function c(m){if(m!==void 0)switch(m){case R.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new h}e.createExtHostComments=D}),define(Ce[263],De([1,0,23,5,26,20]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(R,I){this._mainThreadConsole=R.getProxy(P.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,I){const _=this,D=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){_._handleConsoleCall(R,I,D,arguments)}})}_handleConsoleCall(R,I,_,D){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:y(D,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,_,D)}};T=$e([Be(0,A.IExtHostRpcService),Be(1,l.IExtHostInitDataService)],T),e.AbstractExtHostConsoleForwarder=T;const k=1e5;function y(v,R){const I=[];if(v.length)for(let _=0;_<v.length;_++){let D=v[_];if(typeof D>"u")D="undefined";else if(D instanceof Error){const C=D;C.stack?D=C.stack:D=C.toString()}I.push(D)}if(R){const _=new Error().stack;_&&I.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,a.safeStringify)(I);return _.length>k?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(Ce[140],De([1,0,2,5,7,4,20,16,18,9,15,27]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class xi{constructor(C,E){this._logService=E,this._provider=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,E){const n=xi._handlePool++;this._provider.set(n,{provider:C,extensionDescription:E}),this._proxy.$registerDecorationProvider(n,E.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(n,null);return}const w=(0,y.asArray)(h);if(w.length<=xi._maxEventSize){this._proxy.$onDidChange(n,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.identifier.value,w.length);const S=w.map(o=>({uri:o,rank:(0,v.count)(o.path,"/")})),p=(0,y.groupBy)(S,(o,r)=>o.rank-r.rank||(0,v.compare)(o.uri.path,r.uri.path)),t=[];e:for(const o of p){let r;for(const c of o){const m=(0,R.dirname)(c.uri.path);if(r!==m&&(r=m,t.push(c.uri)>=xi._maxEventSize))break e}}this._proxy.$onDidChange(n,t)});return new l.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(C,E,n){if(!this._provider.has(C))return Object.create(null);const d=Object.create(null),{provider:h,extensionDescription:w}=this._provider.get(C);return await Promise.all(E.map(async S=>{try{const{uri:p,id:t}=S,o=await Promise.resolve(h.provideFileDecoration(a.URI.revive(p),n));if(!o)return;try{l.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.checkProposedApiEnabled)(w,"codiconDecoration"),d[t]=[o.propagate,o.tooltip,o.badge,o.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${w}': ${r}`)}}catch(p){this._logService.error(p)}})),d}};_._handlePool=0,_._maxEventSize=250,_=$e([Be(0,T.IExtHostRpcService),Be(1,k.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[264],De([1,0,181,124,2,5,7,11,3,16,28,49]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";var _,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{constructor(h,w,S,p,t,o,r){this._name=h,this._owner=w,this._maxDiagnosticsPerFile=S,this._modelVersionIdProvider=p,_.set(this,void 0),D.set(this,void 0),C.set(this,void 0),this._isDisposed=!1,Je(this,C,new R.ResourceMap(c=>t.getComparisonKey(c)),"f"),Je(this,_,o,"f"),Je(this,D,r,"f")}dispose(){this._isDisposed||(Ne(this,D,"f").fire([...Ne(this,C,"f").keys()]),Ne(this,_,"f")?.$clear(this._owner),Ne(this,C,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(h,w){if(!h){this.clear();return}this._checkDisposed();let S=[];if(l.URI.isUri(h)){if(!w){this.delete(h);return}Ne(this,C,"f").set(h,w.slice()),S=[h]}else if(Array.isArray(h)){S=[];let t;h=[...h].sort(E._compareIndexedTuplesByUri);for(const o of h){const[r,c]=o;if((!t||r.toString()!==t.toString())&&(t&&Ne(this,C,"f").get(t).length===0&&Ne(this,C,"f").delete(t),t=r,S.push(r),Ne(this,C,"f").set(r,[])),c)Ne(this,C,"f").get(r)?.push(...c);else{const m=Ne(this,C,"f").get(r);m&&(m.length=0)}}}if(Ne(this,D,"f").fire(S),!Ne(this,_,"f"))return;const p=[];for(const t of S){let o=[];const r=Ne(this,C,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){o=[];const c=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const f of r)if(f.severity===c[m]&&o.push({...k.Diagnostic.from(f),modelVersionId:this._modelVersionIdProvider(t)})===this._maxDiagnosticsPerFile)break e;o.push({severity:P.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=r.map(c=>({...k.Diagnostic.from(c),modelVersionId:this._modelVersionIdProvider(t)}));p.push([t,o])}Ne(this,_,"f").$changeMany(this._owner,p)}delete(h){this._checkDisposed(),Ne(this,D,"f").fire([h]),Ne(this,C,"f").delete(h),Ne(this,_,"f")?.$changeMany(this._owner,[[h,void 0]])}clear(){this._checkDisposed(),Ne(this,D,"f").fire([...Ne(this,C,"f").keys()]),Ne(this,C,"f").clear(),Ne(this,_,"f")?.$clear(this._owner)}forEach(h,w){this._checkDisposed();for(const[S,p]of this)h.call(w,S,p,this)}*[(_=new WeakMap,D=new WeakMap,C=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const h of Ne(this,C,"f").keys())yield[h,this.get(h)]}get(h){this._checkDisposed();const w=Ne(this,C,"f").get(h);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(h){return this._checkDisposed(),Array.isArray(Ne(this,C,"f").get(h))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(h,w){return h[0].toString()<w[0].toString()?-1:h[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=E;let n=class bi{static _mapper(h){const w=new R.ResourceMap;for(const S of h)w.set(S,S);return{uris:Object.freeze(Array.from(w.values()))}}constructor(h,w,S,p){this._logService=w,this._fileSystemInfoService=S,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,bi._mapper),this._proxy=h.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,w){const{_collections:S,_proxy:p,_onDidChangeDiagnostics:t,_logService:o,_fileSystemInfoService:r,_extHostDocumentsAndEditors:c}=this,m=new class{$changeMany(s,u){p.$changeMany(s,u),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,s,u.length===0?"CLEARING":u)}$clear(s){p.$clear(s),o.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,s)}dispose(){p.dispose()}};let f;if(!w)w="_generated_diagnostic_collection_name_#"+bi._idPool++,f=w;else if(!S.has(w))f=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do f=w+bi._idPool++;while(S.has(f))}return new class extends E{constructor(){super(w,f,bi._maxDiagnosticsPerFile,s=>c.getDocument(s)?.version,r.extUri,m,t),S.set(f,this)}dispose(){super.dispose(),S.delete(f)}}}getDiagnostics(h){if(h)return this._getDiagnostics(h);{const w=new Map,S=[];for(const p of this._collections.values())p.forEach((t,o)=>{let r=w.get(t.toString());typeof r>"u"&&(r=S.length,w.set(t.toString(),r),S.push([t,[]])),S[r][1]=S[r][1].concat(...o)});return S}}_getDiagnostics(h){let w=[];for(const S of this._collections.values())S.has(h)&&(w=w.concat(S.get(h)));return w}$acceptMarkersChange(h){if(!this._mirrorCollection){const w="_generated_mirror",S=new E(w,w,bi._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,S),this._mirrorCollection=S}for(const[w,S]of h)this._mirrorCollection.set(l.URI.revive(w),S.map(k.Diagnostic.to))}};n._idPool=0,n._maxDiagnosticsPerFile=1e3,n=$e([Be(1,v.ILogService),Be(2,I.IExtHostFileSystemInfo)],n),e.ExtHostDiagnostics=n}),define(Ce[265],De([1,0,2,5,27]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(k){this._proxy=k.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(k,y){return y?.allowUIResources&&(0,l.checkProposedApiEnabled)(k,"showLocal"),this._proxy.$showOpenDialog(y).then(v=>v?v.map(R=>a.URI.revive(R)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(y=>y?a.URI.revive(y):void 0)}}e.ExtHostDialogs=A}),define(Ce[266],De([1,0,8,2,7,5,17,21,9]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class v{constructor(I,_,D){this._documentsAndEditors=_,this._logService=D,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,_){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const D=v._handlePool++;this._documentContentProviders.set(D,_),this._proxy.$registerTextContentProvider(D,I);let C;return typeof _.onDidChange=="function"&&(C=_.onDidChange(E=>{if(E.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(E)&&this.$provideTextDocumentContent(D,E).then(n=>{if(!n&&typeof n!="string")return;const d=this._documentsAndEditors.getDocument(E);if(!d)return;const h=(0,y.splitLines)(n);if(!d.equalLines(h))return this._proxy.$onVirtualDocumentChange(E,n)},a.onUnexpectedError)})),new l.Disposable(()=>{this._documentContentProviders.delete(D)&&this._proxy.$unregisterTextContentProvider(D),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,_){const D=this._documentContentProviders.get(I);return D?Promise.resolve(D.provideTextDocumentContent(P.URI.revive(_),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}v._handlePool=0,e.ExtHostDocumentContentProvider=v}),define(Ce[267],De([1,0,3,6,2,5,136,11,10,23,7]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(D,C){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=C,this._documentsAndEditors.onDidRemoveDocuments(E=>{for(const n of E)this._onDidRemoveDocument.fire(n.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(E=>{for(const n of E)this._onDidAddDocument.fire(n.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(D){if(!D)return;const C=this._documentsAndEditors.getDocument(D);if(C)return C}getDocument(D){const C=this.getDocumentData(D);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return C.document}ensureDocumentData(D){const C=this._documentsAndEditors.getDocument(D);if(C)return Promise.resolve(C);let E=this._documentLoader.get(D.toString());return E||(E=this._proxy.$tryOpenDocument(D).then(n=>{this._documentLoader.delete(D.toString());const d=l.URI.revive(n);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(d))},n=>(this._documentLoader.delete(D.toString()),Promise.reject(n))),this._documentLoader.set(D.toString(),E)),E}createDocumentData(D){return this._proxy.$tryCreateDocument(D).then(C=>l.URI.revive(C))}$acceptModelLanguageChanged(D,C){const E=l.URI.revive(D),n=this._documentsAndEditors.getDocument(E);if(!n)throw new Error("unknown document");this._onDidRemoveDocument.fire(n.document),n._acceptLanguageId(C),this._onDidAddDocument.fire(n.document)}$acceptModelSaved(D){const C=l.URI.revive(D),E=this._documentsAndEditors.getDocument(C);if(!E)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this._onDidSaveDocument.fire(E.document)}$acceptDirtyStateChanged(D,C){const E=l.URI.revive(D),n=this._documentsAndEditors.getDocument(E);if(!n)throw new Error("unknown document");n._acceptIsDirty(C),this._onDidChangeDocument.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,C,E){const n=l.URI.revive(D),d=this._documentsAndEditors.getDocument(n);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),d.onEvents(C);let h;C.isUndoing?h=R.TextDocumentChangeReason.Undo:C.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,v.deepFreeze)({document:d.document,contentChanges:C.changes.map(w=>({range:k.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:h}))}setWordDefinitionFor(D,C){(0,T.setWordDefinitionFor)(D,C)}}e.ExtHostDocuments=I}),define(Ce[59],De([1,0,51,3,6,2,4,5,136,20,139,11,16,28,17,64,65]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(S){this.value=S,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let h=class{constructor(S,p){this._extHostRpc=S,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new D.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const p=[],t=[],o=[];if(S.removedDocuments)for(const r of S.removedDocuments){const c=A.URI.revive(r),m=this._documents.get(c);m?.unref()&&(this._documents.delete(c),p.push(m.value))}if(S.addedDocuments)for(const r of S.addedDocuments){const c=A.URI.revive(r.uri);let m=this._documents.get(c);if(m&&c.scheme!==C.Schemas.vscodeNotebookCell&&c.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);m||(m=new d(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(c,m),t.push(m.value)),m.ref()}if(S.removedEditors)for(const r of S.removedEditors){const c=this._editors.get(r);this._editors.delete(r),c&&o.push(c)}if(S.addedEditors)for(const r of S.addedEditors){const c=A.URI.revive(r.documentUri);a.ok(this._documents.has(c),`document '${c}' does not exist`),a.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const m=this._documents.get(c).value,f=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new n.Lazy(()=>m.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(i=>I.Range.to(i)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}S.newActiveEditor!==void 0&&(a.ok(S.newActiveEditor===null||this._editors.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this._activeEditorId=S.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(o),S.removedDocuments&&this._onDidRemoveDocuments.fire(p),S.addedDocuments&&this._onDidAddDocuments.fire(t),(S.removedEditors||S.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),S.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(S){return this._documents.get(S)?.value}allDocuments(){return E.Iterable.map(this._documents.values(),S=>S.value)}getEditor(S){return this._editors.get(S)}activeEditor(S){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return S?p:p?.value}allEditors(){return[...this._editors.values()]}};h=$e([Be(0,v.IExtHostRpcService),Be(1,_.ILogService)],h),e.ExtHostDocumentsAndEditors=h,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[60],De([1,0,11,5,2,3,4,7,20,10,61]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class I{constructor(n,d,h){this._activeTabIdGetter=h,this._parentGroup=d,this.acceptDtoUpdate(n)}get apiObject(){if(!this._apiObject){const n=this,d={get isActive(){return n._dto.id===n._activeTabIdGetter()},get label(){return n._dto.label},get input(){return n._input},get isDirty(){return n._dto.isDirty},get isPinned(){return n._dto.isPinned},get isPreview(){return n._dto.isPreview},get group(){return n._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(n){this._dto=n,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(l.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified));case 3:return new k.TextMergeTabInput(l.URI.revive(this._dto.input.base),l.URI.revive(this._dto.input.input1),l.URI.revive(this._dto.input.input2),l.URI.revive(this._dto.input.result));case 6:return new k.CustomEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new k.NotebookEditorTabInput(l.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(l.URI.revive(this._dto.input.original),l.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(l.URI.revive(this._dto.input.uri),l.URI.revive(this._dto.input.inputBoxUri));default:return}}}class _{constructor(n,d){this._tabs=[],this._activeTabId="",this._dto=n,this._activeGroupIdGetter=d;for(const h of n.tabs)h.isActive&&(this._activeTabId=h.id),this._tabs.push(new I(h,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const n=this,d={get isActive(){return n._dto.groupId===n._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(n._dto.viewColumn)},get activeTab(){return n._tabs.find(h=>h.tabId===n._activeTabId)?.apiObject},get tabs(){return Object.freeze(n._tabs.map(h=>h.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(n){this._dto=n}acceptTabOperation(n){if(n.kind===0){const h=new I(n.tabDto,this,()=>this.activeTabId());return this._tabs.splice(n.index,0,h),n.tabDto.isActive&&(this._activeTabId=h.tabId),h}else if(n.kind===1){const h=this._tabs.splice(n.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return h.tabId===this._activeTabId&&(this._activeTabId=""),h}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this._tabs.splice(n.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this._tabs.splice(n.index,0,h),h}const d=this._tabs.find(h=>h.tabId===n.tabDto.id);if(!d)throw new Error("INVALID tab");return n.tabDto.isActive?this._activeTabId=n.tabDto.id:this._activeTabId===n.tabDto.id&&!n.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(n.tabDto),d}activeTabId(){return this._activeTabId}}let D=class{constructor(n){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=n.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const n=this,d={onDidChangeTabGroups:n._onDidChangeTabGroups.event,onDidChangeTabs:n._onDidChangeTabs.event,get all(){return Object.freeze(n._extHostTabGroups.map(h=>h.apiObject))},get activeTabGroup(){const h=n._activeGroupId;return(0,v.assertIsDefined)(n._extHostTabGroups.find(S=>S.groupId===h)?.apiObject)},close:async(h,w)=>{const S=Array.isArray(h)?h:[h];return S.length?C(S[0])?this._closeGroups(S,w):this._closeTabs(S,w):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(n){const d=new Set(this._extHostTabGroups.map(r=>r.groupId)),h=new Set(n.map(r=>r.groupId)),w=(0,R.diffSets)(d,h),S=this._extHostTabGroups.filter(r=>w.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this._extHostTabGroups=n.map(r=>{const c=new _(r,()=>this._activeGroupId);return w.added.includes(c.groupId)?p.push(c.apiObject):t.push(c.apiObject),c});const o=(0,v.assertIsDefined)(n.find(r=>r.isActive===!0)?.groupId);o!==void 0&&this._activeGroupId!==o&&(this._activeGroupId=o),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:S,changed:t}))}$acceptTabGroupUpdate(n){const d=this._extHostTabGroups.find(h=>h.groupId===n.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(n),n.isActive&&(this._activeGroupId=n.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const d=this._extHostTabGroups.find(w=>w.groupId===n.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const h=d.acceptTabOperation(n);switch(n.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}_findExtHostTabFromApi(n){for(const d of this._extHostTabGroups)for(const h of d.tabs)if(h.apiObject===n)return h}_findExtHostTabGroupFromApi(n){return this._extHostTabGroups.find(d=>d.apiObject===n)}async _closeTabs(n,d){const h=[];for(const w of n){const S=this._findExtHostTabFromApi(w);if(!S)throw new Error("Tab close: Invalid tab not found!");h.push(S.tabId)}return this._proxy.$closeTab(h,d)}async _closeGroups(n,d){const h=[];for(const w of n){const S=this._findExtHostTabGroupFromApi(w);if(!S)throw new Error("Group close: Invalid group not found!");h.push(S.groupId)}return this._proxy.$closeGroup(h,d)}};D=$e([Be(0,y.IExtHostRpcService)],D),e.ExtHostEditorTabs=D;function C(E){return E.tabs!==void 0}}),define(Ce[268],De([1,0,2,5,6,7,11,155,9,22,27]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(C){this._stateMachine=void 0,this._schemes.push(C)}delete(C){const E=this._schemes.indexOf(C);E>=0&&(this._schemes.splice(E,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const C=this._schemes.sort(),E=[];let n,d,h=14,w=14;for(const S of C){let p=n?(0,y.commonPrefixLength)(n,S):0;for(p===0?d=1:d=w;p<S.length;p++)p+1===S.length?(h=w,w=9):w+=1,E.push([d,S.toUpperCase().charCodeAt(p),w]),E.push([d,S.toLowerCase().charCodeAt(p),w]),d=w;n=S,w=h}E.push([9,58,10]),E.push([10,47,12]),this._stateMachine=new k.StateMachine(E)}}provideDocumentLinks(C){this._initStateMachine();const E=[],n=k.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this._stateMachine);for(const d of n){const h=T.DocumentLink.to(d);h.target&&E.push(h)}return E}}class _{constructor(C,E){this._extHostLanguageFeatures=E,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=C.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(C,E,n,d={}){if(_._validateFileSystemProvider(n),this._registeredSchemes.has(E))throw new Error(`a provider for the scheme '${E}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(C,"*",this._linkProvider));const h=this._handlePool++;this._linkProvider.add(E),this._registeredSchemes.add(E),this._fsProvider.set(h,n);let w=2;d.isCaseSensitive&&(w+=1024),d.isReadonly&&(w+=2048),typeof n.copy=="function"&&(w+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,R.checkProposedApiEnabled)(C,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(h,E,w).catch(p=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${E}`),console.error(p)});const S=n.onDidChangeFile(p=>{const t=[];for(const o of p){const{uri:r,type:c}=o;if(r.scheme!==E)continue;let m;switch(c){case A.FileChangeType.Changed:m=0;break;case A.FileChangeType.Created:m=1;break;case A.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:m})}this._proxy.$onFileSystemChange(h,t)});return(0,l.toDisposable)(()=>{S.dispose(),this._linkProvider.delete(E),this._registeredSchemes.delete(E),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _validateFileSystemProvider(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(C){const{type:E,ctime:n,mtime:d,size:h,permissions:w}=C;return{type:E,ctime:n,mtime:d,size:h,permissions:w}}$stat(C,E){return Promise.resolve(this._getFsProvider(C).stat(a.URI.revive(E))).then(n=>_._asIStat(n))}$readdir(C,E){return Promise.resolve(this._getFsProvider(C).readDirectory(a.URI.revive(E)))}$readFile(C,E){return Promise.resolve(this._getFsProvider(C).readFile(a.URI.revive(E))).then(n=>v.VSBuffer.wrap(n))}$writeFile(C,E,n,d){return Promise.resolve(this._getFsProvider(C).writeFile(a.URI.revive(E),n.buffer,d))}$delete(C,E,n){return Promise.resolve(this._getFsProvider(C).delete(a.URI.revive(E),n))}$rename(C,E,n,d){return Promise.resolve(this._getFsProvider(C).rename(a.URI.revive(E),a.URI.revive(n),d))}$copy(C,E,n,d){const h=this._getFsProvider(C);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(a.URI.revive(E),a.URI.revive(n),d))}$mkdir(C,E){return Promise.resolve(this._getFsProvider(C).createDirectory(a.URI.revive(E)))}$watch(C,E,n,d){const h=this._getFsProvider(C).watch(a.URI.revive(n),d);this._watches.set(E,h)}$unwatch(C,E){const n=this._watches.get(E);n&&(n.dispose(),this._watches.delete(E))}$open(C,E,n){const d=this._getFsProvider(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(a.URI.revive(E),n))}$close(C,E){const n=this._getFsProvider(C);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(E))}$read(C,E,n,d){const h=this._getFsProvider(C);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const w=v.VSBuffer.alloc(d);return Promise.resolve(h.read(E,n,w.buffer,0,d)).then(S=>w.slice(0,S))}$write(C,E,n,d){const h=this._getFsProvider(C);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(E,n,d.buffer,0,d.byteLength))}_getFsProvider(C){const E=this._fsProvider.get(C);if(!E){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return E}}e.ExtHostFileSystem=_}),define(Ce[80],De([1,0,5,45,7,22,4,20,49,6]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class ti{constructor(_,D){this._fileSystemProvider=new Map,this._proxy=_.getProxy(a.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(E){try{const n=C._fileSystemProvider.get(E.scheme);if(!n)return await C._proxy.$stat(E);await C._proxy.$ensureActivation(E.scheme);const d=await n.stat(E);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(n){ti._handleError(n)}},async readDirectory(E){try{const n=C._fileSystemProvider.get(E.scheme);return n?(await C._proxy.$ensureActivation(E.scheme),(await n.readDirectory(E)).slice()):await C._proxy.$readdir(E)}catch(n){return ti._handleError(n)}},async createDirectory(E){try{return await C._proxy.$mkdir(E)}catch(n){return ti._handleError(n)}},async readFile(E){try{const n=C._fileSystemProvider.get(E.scheme);return n?(await C._proxy.$ensureActivation(E.scheme),(await n.readFile(E)).slice()):(await C._proxy.$readFile(E)).buffer}catch(n){return ti._handleError(n)}},async writeFile(E,n){try{return await C._proxy.$writeFile(E,A.VSBuffer.wrap(n))}catch(d){return ti._handleError(d)}},async delete(E,n){try{const d=C._fileSystemProvider.get(E.scheme);return d?(await C._proxy.$ensureActivation(E.scheme),await d.delete(E,{recursive:!1,...n})):await C._proxy.$delete(E,{recursive:!1,useTrash:!1,...n})}catch(d){return ti._handleError(d)}},async rename(E,n,d){try{return await C._proxy.$rename(E,n,{overwrite:!1,...d})}catch(h){return ti._handleError(h)}},async copy(E,n,d){try{return await C._proxy.$copy(E,n,{overwrite:!1,...d})}catch(h){return ti._handleError(h)}},isWritableFileSystem(E){const n=D.getCapabilities(E);if(typeof n=="number")return!(n&2048)}})}static _handleError(_){if(_ instanceof l.FileSystemError)throw _;if(!(_ instanceof Error))throw new l.FileSystemError(String(_));if(_.name==="ENOPRO"||_.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(_.message);switch(_.name){case P.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(_.message);case P.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(_.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(_.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(_.message);case P.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(_.message);case P.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(_.message);default:throw new l.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,D){return this._fileSystemProvider.set(_,D),(0,v.toDisposable)(()=>this._fileSystemProvider.delete(_))}};R=$e([Be(0,k.IExtHostRpcService),Be(1,y.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[269],De([1,0,3,39,2,5,11,7]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(I,_,D,C,E,n,d,h){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const w=this.ensureWatching(I,D,E);this._config=0,n&&(this._config+=1),d&&(this._config+=2),h&&(this._config+=4);const S=(0,P.parse)(E),p=typeof E=="string",t=C(o=>{if(!n)for(const r of o.created){const c=l.URI.revive(r);S(c.fsPath)&&(!p||_.getWorkspaceFolder(c))&&this._onDidCreate.fire(c)}if(!d)for(const r of o.changed){const c=l.URI.revive(r);S(c.fsPath)&&(!p||_.getWorkspaceFolder(c))&&this._onDidChange.fire(c)}if(!h)for(const r of o.deleted){const c=l.URI.revive(r);S(c.fsPath)&&(!p||_.getWorkspaceFolder(c))&&this._onDidDelete.fire(c)}});this._disposable=k.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(I,_,D){const C=k.Disposable.from();if(typeof D=="string")return C;const E=I.getProxy(A.MainContext.MainThreadFileSystem);let n=!1;(D.pattern.includes(P.GLOBSTAR)||D.pattern.includes(P.GLOB_SPLIT))&&(n=!0);const d=Math.random();return E.$watch(_.identifier.value,d,D.baseUri,{recursive:n,excludes:[]}),k.Disposable.from({dispose:()=>E.$unwatch(d)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class v{constructor(I,_,D){this._mainContext=I,this._logService=_,this._extHostDocumentsAndEditors=D,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,_,D,C,E,n){return new y(this._mainContext,I,_,this._onFileSystemEvent.event,T.GlobPattern.from(D),C,E,n)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,_){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(D=>({oldUri:l.URI.revive(D.source),newUri:l.URI.revive(D.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(D=>l.URI.revive(D.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(D=>l.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,_){return(D,C,E)=>{const n=function(h){D.call(C,h)};return n.extension=I,_.event(n,void 0,E)}}async $onWillRunFileOperation(I,_,D,C){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(E=>({oldUri:l.URI.revive(E.source),newUri:l.URI.revive(E.target)}))},D,C);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(E=>l.URI.revive(E.target))},D,C);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(E=>l.URI.revive(E.target))},D,C)}}async _fireWillEvent(I,_,D,C){const E=new Set,n=[];if(await I.fireAsync(_,C,async(h,w)=>{const S=Date.now(),p=await Promise.resolve(h);p instanceof k.WorkspaceEdit&&(n.push([w.extension,p]),E.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-S>D&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),C.isCancellationRequested||n.length===0)return;const d={edits:[]};for(const[,h]of n){const{edits:w}=T.WorkspaceEdit.from(h,{getTextDocumentVersion:S=>this._extHostDocumentsAndEditors.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(w)}return{edit:d,extensionNames:Array.from(E)}}}e.ExtHostFileSystemEventService=v}),define(Ce[270],De([1,0,2,41]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(T,k,y,v,R){this._extHostNotebooks=k,this._textDocumentsAndEditors=y,this._commands=v;const I=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new P.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new P.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new P.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new P.ApiCommandResult("Notebook and input URI",_=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const D=this._extHostNotebooks.getEditorById(_.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri),notebookEditor:D.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(T,k,y,v){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=l}),define(Ce[271],De([1,0,6,2,5,11,7]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class k{constructor(I,_){this.extension=I,this.provider=_,this.handle=k._pool++}}k._pool=0;class y{constructor(I){this.session=I,this.responses=[]}}class v{constructor(I,_,D){this._documents=_,this._logService=D,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadInteractiveEditor)}registerProvider(I,_){const D=new k(I,_);return this._inputProvider.set(D.handle,D),this._proxy.$registerInteractiveEditorProvider(D.handle,I.identifier.value,typeof _.handleInteractiveEditorResponseFeedback=="function"),(0,a.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(D.handle),this._inputProvider.delete(D.handle)})}async $prepareInteractiveSession(I,_,D,C){const E=this._inputProvider.get(I);if(!E){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(P.URI.revive(_)),d=A.Selection.to(D),h=await E.provider.prepareInteractiveEditorSession({document:n,selection:d},C);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const w=v._nextId++;return this._inputSessions.set(w,new y(h)),{id:w,placeholder:h.placeholder,slashCommands:h.slashCommands,wholeRange:A.Range.from(h.wholeRange)}}async $provideResponse(I,_,D,C){const E=this._inputProvider.get(I);if(!E)return;const n=this._inputSessions.get(_.id);if(!n)return;const d=await E.provider.provideInteractiveEditorResponse({session:n.session,prompt:D.prompt,selection:A.Selection.to(D.selection),wholeRange:A.Range.to(D.wholeRange)},C);if(d){const h=n.responses.push(d)-1,w={wholeRange:A.Range.from(d.wholeRange),placeholder:d.placeholder};if(v._isMessageResponse(d))return{...w,id:h,type:"message",message:A.MarkdownString.from(d.contents)};const{edits:S}=d;if(S instanceof T.WorkspaceEdit)return{...w,id:h,type:"bulkEdit",edits:A.WorkspaceEdit.from(S)};if(Array.isArray(S))return{...w,id:h,type:"editorEdit",edits:S.map(A.TextEdit.from)}}}$handleFeedback(I,_,D,C){const E=this._inputProvider.get(I),n=this._inputSessions.get(_),d=n?.responses[D];if(E&&d){let h;switch(C){case 1:h=T.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:h=T.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:h=T.InteractiveEditorResponseFeedbackKind.Undone;break}E.provider.handleInteractiveEditorResponseFeedback?.(n.session,d,h)}}$releaseSession(I,_){const D=this._inputSessions.get(_),C=this._inputProvider.get(I);D&&C&&C.provider.releaseInteractiveEditorSession?.(D.session),this._inputSessions.delete(_)}static _isMessageResponse(I){return typeof I=="object"&&typeof I.contents=="object"}}v._nextId=0,e.ExtHostInteractiveEditor=v}),define(Ce[272],De([1,0,3,6,37,10,183,5,11]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class v{constructor(_,D){this.extension=_,this.provider=D,this.handle=v._pool++}}v._pool=0;class R{constructor(_,D){this.logService=D,this._interactiveSessionProvider=new Map,this._interactiveSessions=new Map,this._onDidPerformUserAction=new a.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=_.getProxy(k.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(_,D,C){const E=new v(_,C);return this._interactiveSessionProvider.set(E.handle,E),this._proxy.$registerInteractiveSessionProvider(E.handle,D,!!C.provideResponseWithProgress),(0,P.toDisposable)(()=>{this._proxy.$unregisterInteractiveSessionProvider(E.handle),this._interactiveSessionProvider.delete(E.handle)})}addInteractiveSessionRequest(_){this._proxy.$addInteractiveSessionRequest(_)}sendInteractiveRequestToProvider(_,D){this._proxy.$sendInteractiveRequestToProvider(_,D)}async $prepareInteractiveSession(_,D,C){const E=this._interactiveSessionProvider.get(_);if(!E)return;const n=await E.provider.prepareSession(D,C);if(!n)return;const d=R._nextId++;return this._interactiveSessions.set(d,n),{id:d,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveInteractiveRequest(_,D,C,E){const n=this._interactiveSessionProvider.get(_);if(!n)return;const d=this._interactiveSessions.get(D);if(!d||!n.provider.resolveRequest)return;const h=await n.provider.resolveRequest(d,C,E);if(h)return{message:typeof h.message=="string"?h.message:y.InteractiveSessionReplyFollowup.from(h.message)}}async $provideInitialSuggestions(_,D){const C=this._interactiveSessionProvider.get(_);if(!!C&&!!C.provider.provideInitialSuggestions)return(0,A.withNullAsUndefined)(await C.provider.provideInitialSuggestions(D))}async $provideWelcomeMessage(_,D){const C=this._interactiveSessionProvider.get(_);if(!C||!C.provider.provideWelcomeMessage)return;const E=await C.provider.provideWelcomeMessage(D);if(!!E)return E.map(n=>typeof n=="string"?n:n.map(d=>y.InteractiveSessionReplyFollowup.from(d)))}async $provideFollowups(_,D,C){const E=this._interactiveSessionProvider.get(_);if(!E)return;const n=this._interactiveSessions.get(D);return!n||!E.provider.provideFollowups?void 0:(await E.provider.provideFollowups(n,C))?.map(h=>y.InteractiveSessionFollowup.from(h))}async $provideInteractiveReply(_,D,C,E){const n=this._interactiveSessionProvider.get(_);if(!n)return;const d=this._interactiveSessions.get(D);if(!d)return;const h={session:d,message:typeof C.message=="string"?C.message:y.InteractiveSessionReplyFollowup.to(C.message)},w=l.StopWatch.create(!1);let S;const p={report:r=>{E.isCancellationRequested||(typeof S>"u"&&(S=w.elapsed()),this._proxy.$acceptInteractiveResponseProgress(_,D,r))}};let t;try{t=await n.provider.provideResponseWithProgress(h,p,E),t||(t={errorDetails:{message:(0,T.localize)(0,null)}})}catch(r){t={errorDetails:{message:(0,T.localize)(1,null,r.message),responseIsIncomplete:!0}},this.logService.error(r)}try{if(d.saveState&&this._interactiveSessions.has(D)){const r=d.saveState();this._proxy.$acceptInteractiveSessionState(D,r)}}catch(r){this.logService.warn(r)}const o={firstProgress:S??0,totalElapsed:w.elapsed()};return{errorDetails:t.errorDetails,timings:o}}async $provideSlashCommands(_,D,C){const E=this._interactiveSessionProvider.get(_);if(!E)return;const n=this._interactiveSessions.get(D);return!n||!E.provider.provideSlashCommands?void 0:(await E.provider.provideSlashCommands(n,C))?.map(h=>({...h,kind:y.CompletionItemKind.from(h.kind)}))}$releaseSession(_){this._interactiveSessions.delete(_)}async $onDidPerformUserAction(_){this._onDidPerformUserAction.fire(_)}}R._nextId=0,e.ExtHostInteractiveSession=R}),define(Ce[273],De([1,0,6,5]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(T){this._handlePool=0,this._proxy=T.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,T),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=l}),define(Ce[274],De([1,0,2,23,11,7,73,5,9,32,18,10,151,21,6,121,102,76,37,8,19,27]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(O,B){this._documents=O,this._provider=B}async provideDocumentSymbols(O,B){const K=this._documents.getDocument(O),Z=await this._provider.provideDocumentSymbols(K,B);if(!(0,R.isFalsyOrEmpty)(Z))return Z[0]instanceof A.DocumentSymbol?Z.map(l.DocumentSymbol.from):t._asDocumentSymbolTree(Z)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((Z,he)=>{let _e=Z.location.range.start.compareTo(he.location.range.start);return _e===0&&(_e=he.location.range.end.compareTo(Z.location.range.end)),_e});const B=[],K=[];for(const Z of O){const he={name:Z.name||"!!MISSING: name!!",kind:l.SymbolKind.from(Z.kind),tags:Z.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:l.Range.from(Z.location.range),selectionRange:l.Range.from(Z.location.range),children:[]};for(;;){if(K.length===0){K.push(he),B.push(he);break}const _e=K[K.length-1];if(v.Range.containsRange(_e.range,he.range)&&!v.Range.equalsRange(_e.range,he.range)){_e.children?.push(he),K.push(he);break}K.pop()}}return B}}class o{constructor(O,B,K){this._documents=O,this._commands=B,this._provider=K,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,B){const K=this._documents.getDocument(O),Z=await this._provider.provideCodeLenses(K,B);if(!Z||B.isCancellationRequested)return;const he=this._cache.add(Z),_e=new C.DisposableStore;this._disposables.set(he,_e);const Ae={cacheId:he,lenses:[]};for(let Ee=0;Ee<Z.length;Ee++)Ae.lenses.push({cacheId:[he,Ee],range:l.Range.from(Z[Ee].range),command:this._commands.toInternal(Z[Ee].command,_e)});return Ae}async resolveCodeLens(O,B){const K=O.cacheId&&this._cache.get(...O.cacheId);if(!K)return;let Z;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?Z=K:Z=await this._provider.resolveCodeLens(K,B),Z||(Z=K),B.isCancellationRequested)return;const he=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!he)return O.command=this._commands.toInternal(Z.command??o._badCmd,he),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ae){return Array.isArray(ae)?ae.map(l.DefinitionLink.from):ae?[l.DefinitionLink.from(ae)]:[]}class c{constructor(O,B){this._documents=O,this._provider=B}async provideDefinition(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideDefinition(Z,he,K);return r(_e)}}class m{constructor(O,B){this._documents=O,this._provider=B}async provideDeclaration(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideDeclaration(Z,he,K);return r(_e)}}class f{constructor(O,B){this._documents=O,this._provider=B}async provideImplementation(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideImplementation(Z,he,K);return r(_e)}}class i{constructor(O,B){this._documents=O,this._provider=B}async provideTypeDefinition(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideTypeDefinition(Z,he,K);return r(_e)}}class s{constructor(O,B){this._documents=O,this._provider=B}async provideHover(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideHover(Z,he,K);if(!(!_e||(0,R.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=Z.getWordRangeAtPosition(he)),_e.range||(_e.range=new A.Range(he,he)),l.Hover.from(_e)}}class u{constructor(O,B){this._documents=O,this._provider=B}async provideEvaluatableExpression(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideEvaluatableExpression(Z,he,K);if(_e)return l.EvaluatableExpression.from(_e)}}class b{constructor(O,B){this._documents=O,this._provider=B}async provideInlineValues(O,B,K,Z){const he=this._documents.getDocument(O),_e=await this._provider.provideInlineValues(he,l.Range.to(B),l.InlineValueContext.to(K),Z);if(Array.isArray(_e))return _e.map(Ae=>l.InlineValue.from(Ae))}}class g{constructor(O,B){this._documents=O,this._provider=B}async provideDocumentHighlights(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideDocumentHighlights(Z,he,K);if(Array.isArray(_e))return _e.map(l.DocumentHighlight.from)}}class L{constructor(O,B){this._documents=O,this._provider=B}async provideLinkedEditingRanges(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.provideLinkedEditingRanges(Z,he,K);if(_e&&Array.isArray(_e.ranges))return{ranges:(0,R.coalesce)(_e.ranges.map(l.Range.from)),wordPattern:_e.wordPattern}}}class H{constructor(O,B){this._documents=O,this._provider=B}async provideReferences(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Position.to(B),Ae=await this._provider.provideReferences(he,_e,K,Z);if(Array.isArray(Ae))return Ae.map(l.location.from)}}class q{constructor(O,B,K,Z,he,_e,Ae){this._documents=O,this._commands=B,this._diagnostics=K,this._provider=Z,this._logService=he,this._extension=_e,this._apiDeprecation=Ae,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,B,K,Z){const he=this._documents.getDocument(O),_e=_.Selection.isISelection(B)?l.Selection.to(B):l.Range.to(B),Ae=[];for(const tt of this._diagnostics.getDiagnostics(O))if(_e.intersection(tt.range)&&Ae.push(tt)>q._maxCodeActionsPerFile)break;const Ee={diagnostics:Ae,only:K.only?new A.CodeActionKind(K.only):void 0,triggerKind:l.CodeActionTriggerKind.to(K.trigger)},ke=await this._provider.provideCodeActions(he,_e,Ee,Z);if(!(0,R.isNonEmptyArray)(ke)||Z.isCancellationRequested)return;const Ie=this._cache.add(ke),He=new C.DisposableStore;this._disposables.set(Ie,He);const ze=[];for(let tt=0;tt<ke.length;tt++){const Qe=ke[tt];!Qe||(q._isCommand(Qe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Qe.title,command:this._commands.toInternal(Qe,He)})):(Ee.only&&(Qe.kind?Ee.only.contains(Qe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Ie,tt],title:Qe.title,command:Qe.command&&this._commands.toInternal(Qe.command,He),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(l.Diagnostic.from),edit:Qe.edit&&l.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Ie,actions:ze}}async resolveCodeAction(O,B){const[K,Z]=O,he=this._cache.get(K,Z);if(!he||q._isCommand(he)||!this._provider.resolveCodeAction)return;const _e=await this._provider.resolveCodeAction(he,B)??he;return _e?.edit?l.WorkspaceEdit.from(_e.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}q._maxCodeActionsPerFile=1e3;class X{constructor(O,B,K,Z){this._proxy=O,this._documents=B,this._provider=K,this._handle=Z}async prepareDocumentPaste(O,B,K,Z){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(O),_e=B.map(Ee=>l.Range.to(Ee)),Ae=l.DataTransfer.toDataTransfer(K,()=>{throw new w.NotImplementedError});return await this._provider.prepareDocumentPaste(he,_e,Ae,Z),l.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(O,B,K,Z,he){const _e=this._documents.getDocument(B),Ae=K.map(Ie=>l.Range.to(Ie)),Ee=l.DataTransfer.toDataTransfer(Z,async Ie=>(await this._proxy.$resolvePasteFileData(this._handle,O,Ie)).buffer),ke=await this._provider.provideDocumentPasteEdits(_e,Ae,Ee,he);if(!!ke)return{insertText:typeof ke.insertText=="string"?ke.insertText:{snippet:ke.insertText.value},additionalEdit:ke.additionalEdit?l.WorkspaceEdit.from(ke.additionalEdit,void 0):void 0}}}class U{constructor(O,B){this._documents=O,this._provider=B}async provideDocumentFormattingEdits(O,B,K){const Z=this._documents.getDocument(O),he=await this._provider.provideDocumentFormattingEdits(Z,B,K);if(Array.isArray(he))return he.map(l.TextEdit.from)}}class N{constructor(O,B){this._documents=O,this._provider=B}async provideDocumentRangeFormattingEdits(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Range.to(B),Ae=await this._provider.provideDocumentRangeFormattingEdits(he,_e,K,Z);if(Array.isArray(Ae))return Ae.map(l.TextEdit.from)}}class x{constructor(O,B){this._documents=O,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,B,K,Z,he){const _e=this._documents.getDocument(O),Ae=l.Position.to(B),Ee=await this._provider.provideOnTypeFormattingEdits(_e,Ae,K,Z,he);if(Array.isArray(Ee))return Ee.map(l.TextEdit.from)}}class F{constructor(O,B){this._provider=O,this._logService=B,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,B){const K=await this._provider.provideWorkspaceSymbols(O,B);if(!(0,R.isNonEmptyArray)(K))return{symbols:[]};const Z=this._cache.add(K),he={cacheId:Z,symbols:[]};for(let _e=0;_e<K.length;_e++){const Ae=K[_e];if(!Ae||!Ae.name){this._logService.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...l.WorkspaceSymbol.from(Ae),cacheId:[Z,_e]})}return he}async resolveWorkspaceSymbol(O,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this._cache.get(...O.cacheId);if(K){const Z=await this._provider.resolveWorkspaceSymbol(K,B);return Z&&(0,P.mixin)(O,l.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class V{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,B,K){this._documents=O,this._provider=B,this._logService=K}async provideRenameEdits(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Position.to(B);try{const Ae=await this._provider.provideRenameEdits(he,_e,K,Z);return Ae?l.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Ee=V._asMessage(Ae);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(O,B,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Z=this._documents.getDocument(O),he=l.Position.to(B);try{const _e=await this._provider.prepareRename(Z,he,K);let Ae,Ee;if(A.Range.isRange(_e)?(Ae=_e,Ee=Z.getText(_e)):(0,I.isObject)(_e)&&(Ae=_e.range,Ee=_e.placeholder),!Ae||!Ee)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Ae),text:Ee}}catch(_e){const Ae=V._asMessage(_e);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(_e)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class fe{constructor(O,B){this.resultId=O,this.tokens=B}}class se{constructor(O,B){this._documents=O,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,B,K){const Z=this._documents.getDocument(O),he=B!==0?this._previousResults.get(B):null;let _e=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Z,he.resultId,K):await this._provider.provideDocumentSemanticTokens(Z,K);return he&&this._previousResults.delete(B),_e?(_e=se._fixProvidedSemanticTokens(_e),this._send(se._convertToEdits(he,_e),_e)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return se._isSemanticTokens(O)?se._isCorrectSemanticTokens(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):se._isSemanticTokensEdits(O)?se._isCorrectSemanticTokensEdits(O)?O:new A.SemanticTokensEdits(O.edits.map(B=>new A.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const B of O.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,B){if(!se._isSemanticTokens(B)||!O||!O.tokens)return B;const K=O.tokens,Z=K.length,he=B.data,_e=he.length;let Ae=0;const Ee=Math.min(Z,_e);for(;Ae<Ee&&K[Ae]===he[Ae];)Ae++;if(Ae===Z&&Ae===_e)return new A.SemanticTokensEdits([],B.resultId);let ke=0;const Ie=Ee-Ae;for(;ke<Ie&&K[Z-ke-1]===he[_e-ke-1];)ke++;return new A.SemanticTokensEdits([{start:Ae,deleteCount:Z-Ae-ke,data:he.subarray(Ae,_e-ke)}],B.resultId)}_send(O,B){if(se._isSemanticTokens(O)){const K=this._nextResultId++;return this._previousResults.set(K,new fe(O.resultId,O.data)),(0,E.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(se._isSemanticTokensEdits(O)){const K=this._nextResultId++;return se._isSemanticTokens(B)?this._previousResults.set(K,new fe(B.resultId,B.data)):this._previousResults.set(K,new fe(O.resultId)),(0,E.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class ${constructor(O,B){this._documents=O,this._provider=B}async provideDocumentRangeSemanticTokens(O,B,K){const Z=this._documents.getDocument(O),he=await this._provider.provideDocumentRangeSemanticTokens(Z,l.Range.to(B),K);return he?this._send(he):null}_send(O){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class J{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,B,K,Z,he){this._documents=O,this._commands=B,this._provider=K,this._apiDeprecation=Z,this._extension=he,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Position.to(B),Ae=he.getWordRangeAtPosition(_e)||new A.Range(_e,_e),Ee=Ae.with({end:_e}),ke=new h.StopWatch(!0),Ie=await this._provider.provideCompletionItems(he,_e,Z,l.CompletionContext.to(K));if(!Ie||Z.isCancellationRequested)return;const He=Array.isArray(Ie)?new A.CompletionList(Ie):Ie,ze=J.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),tt=new C.DisposableStore;this._disposables.set(ze,tt);const Qe=[],nt={x:ze,b:Qe,a:{replace:l.Range.from(Ae),insert:l.Range.from(Ee)},c:He.isIncomplete||void 0,d:ke.elapsed()};for(let st=0;st<He.items.length;st++){const Ue=He.items[st],it=this._convertCompletionItem(Ue,[ze,st],Ee,Ae);Qe.push(it)}return nt}async resolveCompletionItem(O,B){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...O);if(!K)return;const Z=await this._provider.resolveCompletionItem(K,B);if(!!Z)return this._convertCompletionItem(Z,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,B,K,Z){const he=this._disposables.get(B[0]);if(!he)throw Error("DisposableStore is missing...");const _e=this._commands.toInternal(O.command,he),Ae={x:B,a:O.label,b:O.kind!==void 0?l.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(l.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:l.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(l.TextEdit.from),n:_e?.$ident,o:_e?.id,p:_e?.$ident?void 0:_e?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=O.textEdit.newText):typeof O.insertText=="string"?Ae.h=O.insertText:O.insertText instanceof A.SnippetString&&(Ae.h=O.insertText.value,Ae.i|=4);let Ee;return O.textEdit?Ee=O.textEdit.range:O.range&&(Ee=O.range),A.Range.isRange(Ee)?Ae.j=l.Range.from(Ee):Ee&&(!K?.isEqual(Ee.inserting)||!Z?.isEqual(Ee.replacing))&&(Ae.j={insert:l.Range.from(Ee.inserting),replace:l.Range.from(Ee.replacing)}),Ae}}class te{async provideInlineCompletions(O,B,K,Z){}disposeCompletions(O){}handleDidShowCompletionItem(O,B){}handlePartialAccept(O,B,K){}}class be extends te{constructor(O,B,K,Z){super(),this._extension=O,this._documents=B,this._provider=K,this._commands=Z,this._references=new le,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Position.to(B),Ae=await this._provider.provideInlineCompletionItems(he,_e,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:l.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},Z);if(!Ae||Z.isCancellationRequested)return;const Ee=Array.isArray(Ae)?Ae:Ae.items,ke=this._isAdditionsProposedApiEnabled?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Ie;return{pid:this._references.createReferenceId({dispose(){Ie?.dispose()},items:Ee}),items:Ee.map((ze,tt)=>{let Qe;ze.command&&(Ie||(Ie=new C.DisposableStore),Qe=this._commands.toInternal(ze.command,Ie));const nt=ze.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:ze.filterText,range:ze.range?l.Range.from(ze.range):void 0,command:Qe,idx:tt,completeBracketPairs:this._isAdditionsProposedApiEnabled?ze.completeBracketPairs:!1}}),commands:ke.map(ze=>(Ie||(Ie=new C.DisposableStore),this._commands.toInternal(ze,Ie)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,B){const K=this._references.get(O)?.items[B];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}handlePartialAccept(O,B,K){const Z=this._references.get(O)?.items[B];Z&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(Z,K)}}class le{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const B=this._idPool++;return this._references.set(B,O),B}disposeReferenceId(O){const B=this._references.get(O);return this._references.delete(O),B}get(O){return this._references.get(O)}}class ue{constructor(O,B){this._documents=O,this._provider=B,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(O,B,K,Z){const he=this._documents.getDocument(O),_e=l.Position.to(B),Ae=this.reviveContext(K),Ee=await this._provider.provideSignatureHelp(he,_e,Z,Ae);if(Ee){const ke=this._cache.add([Ee]);return{...l.SignatureHelp.from(Ee),id:ke}}}reviveContext(O){let B;if(O.activeSignatureHelp){const K=l.SignatureHelp.to(O.activeSignatureHelp),Z=this._cache.get(O.activeSignatureHelp.id,0);Z?(B=Z,B.activeSignature=K.activeSignature,B.activeParameter=K.activeParameter):B=K}return{...O,activeSignatureHelp:B}}releaseSignatureHelp(O){this._cache.delete(O)}}class j{constructor(O,B,K,Z,he){this._documents=O,this._commands=B,this._provider=K,this._logService=Z,this._extension=he,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,B,K){const Z=this._documents.getDocument(O),he=l.Range.to(B),_e=await this._provider.provideInlayHints(Z,he,K);if(!Array.isArray(_e)||_e.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(K.isCancellationRequested)return;const Ae=this._cache.add(_e);this._disposables.set(Ae,new C.DisposableStore);const Ee={hints:[],cacheId:Ae};for(let ke=0;ke<_e.length;ke++)this._isValidInlayHint(_e[ke],he)&&Ee.hints.push(this._convertInlayHint(_e[ke],[Ae,ke]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ee}async resolveInlayHint(O,B){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...O);if(!K)return;const Z=await this._provider.resolveInlayHint(K,B);if(!!Z&&!!this._isValidInlayHint(Z))return this._convertInlayHint(Z,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,B){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(B&&!B.contains(O.position))}_convertInlayHint(O,B){const K=this._disposables.get(B[0]);if(!K)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:B,tooltip:l.MarkdownString.fromStrict(O.tooltip),position:l.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(l.TextEdit.from),kind:O.kind&&l.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Z.label=O.label:Z.label=O.label.map(he=>{const _e={label:he.value};return _e.tooltip=l.MarkdownString.fromStrict(he.tooltip),A.Location.isLocation(he.location)&&(_e.location=l.location.from(he.location)),he.command&&(_e.command=this._commands.toInternal(he.command,K)),_e}),Z}}class M{constructor(O,B){this._documents=O,this._provider=B,this._cache=new d.Cache("DocumentLink")}async provideLinks(O,B){const K=this._documents.getDocument(O),Z=await this._provider.provideDocumentLinks(K,B);if(!(!Array.isArray(Z)||Z.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Z.filter(M._validateLink).map(l.DocumentLink.from)};{const he=this._cache.add(Z),_e={links:[],cacheId:he};for(let Ae=0;Ae<Z.length;Ae++){if(!M._validateLink(Z[Ae]))continue;const Ee=l.DocumentLink.from(Z[Ae]);Ee.cacheId=[he,Ae],_e.links.push(Ee)}return _e}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,B){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...O);if(!K)return;const Z=await this._provider.resolveDocumentLink(K,B);if(!(!Z||!M._validateLink(Z)))return l.DocumentLink.from(Z)}releaseLinks(O){this._cache.delete(O)}}class Y{constructor(O,B){this._documents=O,this._provider=B}async provideColors(O,B){const K=this._documents.getDocument(O),Z=await this._provider.provideDocumentColors(K,B);return Array.isArray(Z)?Z.map(_e=>({color:l.Color.from(_e.color),range:l.Range.from(_e.range)})):[]}async provideColorPresentations(O,B,K){const Z=this._documents.getDocument(O),he=l.Range.to(B.range),_e=l.Color.to(B.color),Ae=await this._provider.provideColorPresentations(_e,{document:Z,range:he},K);if(!!Array.isArray(Ae))return Ae.map(l.ColorPresentation.from)}}class ge{constructor(O,B){this._documents=O,this._provider=B}async provideFoldingRanges(O,B,K){const Z=this._documents.getDocument(O),he=await this._provider.provideFoldingRanges(Z,B,K);if(!!Array.isArray(he))return he.map(l.FoldingRange.from)}}class we{constructor(O,B,K){this._documents=O,this._provider=B,this._logService=K}async provideSelectionRanges(O,B,K){const Z=this._documents.getDocument(O),he=B.map(l.Position.to),_e=await this._provider.provideSelectionRanges(Z,he,K);if(!(0,R.isNonEmptyArray)(_e))return[];if(_e.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Ee=0;Ee<he.length;Ee++){const ke=[];Ae.push(ke);let Ie=he[Ee],He=_e[Ee];for(;;){if(!He.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(l.SelectionRange.from(He)),!He.parent)break;Ie=He.range,He=He.parent}}return Ae}}class ie{constructor(O,B){this._documents=O,this._provider=B,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.prepareCallHierarchy(Z,he,K);if(!_e)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(_e)?_e.map(Ee=>this._cacheAndConvertItem(Ae,Ee)):[this._cacheAndConvertItem(Ae,_e)]}async provideCallsTo(O,B,K){const Z=this._itemFromCache(O,B);if(!Z)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(Z,K);if(!!he)return he.map(_e=>({from:this._cacheAndConvertItem(O,_e.from),fromRanges:_e.fromRanges.map(Ae=>l.Range.from(Ae))}))}async provideCallsFrom(O,B,K){const Z=this._itemFromCache(O,B);if(!Z)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(Z,K);if(!!he)return he.map(_e=>({to:this._cacheAndConvertItem(O,_e.to),fromRanges:_e.fromRanges.map(Ae=>l.Range.from(Ae))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,B){const K=this._cache.get(O),Z=l.CallHierarchyItem.from(B,O,K.size.toString(36));return K.set(Z._itemId,B),Z}_itemFromCache(O,B){return this._cache.get(O)?.get(B)}}class ne{constructor(O,B){this._documents=O,this._provider=B,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(O,B,K){const Z=this._documents.getDocument(O),he=l.Position.to(B),_e=await this._provider.prepareTypeHierarchy(Z,he,K);if(!_e)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(_e)?_e.map(Ee=>this._cacheAndConvertItem(Ae,Ee)):[this._cacheAndConvertItem(Ae,_e)]}async provideSupertypes(O,B,K){const Z=this._itemFromCache(O,B);if(!Z)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(Z,K);if(!!he)return he.map(_e=>this._cacheAndConvertItem(O,_e))}async provideSubtypes(O,B,K){const Z=this._itemFromCache(O,B);if(!Z)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(Z,K);if(!!he)return he.map(_e=>this._cacheAndConvertItem(O,_e))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,B){const K=this._cache.get(O),Z=l.TypeHierarchyItem.from(B,O,K.size.toString(36));return K.set(Z._itemId,B),Z}_itemFromCache(O,B){return this._cache.get(O)?.get(B)}}class de{constructor(O,B,K,Z){this._proxy=O,this._documents=B,this._provider=K,this._handle=Z}async provideDocumentOnDropEdits(O,B,K,Z,he){const _e=this._documents.getDocument(B),Ae=l.Position.to(K),Ee=l.DataTransfer.toDataTransfer(Z,async Ie=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Ie)).buffer),ke=await this._provider.provideDocumentDropEdits(_e,Ae,Ee,he);if(!!ke)return{insertText:typeof ke.insertText=="string"?ke.insertText:{snippet:ke.insertText.value},additionalEdit:ke.additionalEdit?l.WorkspaceEdit.from(ke.additionalEdit,void 0):void 0}}}class ee{constructor(O,B){this.adapter=O,this.extension=B}}class ce{constructor(O,B,K,Z,he,_e,Ae,Ee){this._uriTransformer=B,this._documents=K,this._commands=Z,this._diagnostics=he,this._logService=_e,this._apiDeprecation=Ae,this._extensionTelemetry=Ee,this._adapter=new Map,this._proxy=O.getProxy(k.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return l.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new A.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ce._handlePool++}async _withAdapter(O,B,K,Z,he,_e=!1){const Ae=this._adapter.get(O);if(!Ae||!(Ae.adapter instanceof B))return Z;const Ee=Date.now();_e||this._logService.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const ke=K(Ae.adapter,Ae.extension);return Promise.resolve(ke).catch(Ie=>{(0,w.isCancellationError)(Ie)||(this._logService.error(`[${Ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ie),this._extensionTelemetry.onExtensionError(Ae.extension.identifier,Ie))}).finally(()=>{_e||this._logService.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Ee}ms`)}),D.CancellationToken.isCancellationToken(he)?(0,S.raceCancellationError)(ke,he):ke}_addNewAdapter(O,B){const K=this._nextHandle();return this._adapter.set(K,new ee(O,B)),K}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,B,K,Z){const he=this._addNewAdapter(new t(this._documents,K),O),_e=Z&&Z.label||ce._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(B),_e),this._createDisposable(he)}$provideDocumentSymbols(O,B,K){return this._withAdapter(O,t,Z=>Z.provideDocumentSymbols(a.URI.revive(B),K),void 0,K)}registerCodeLensProvider(O,B,K){const Z=this._nextHandle(),he=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Z,new ee(new o(this._documents,this._commands.converter,K),O)),this._proxy.$registerCodeLensSupport(Z,this._transformDocumentSelector(B),he);let _e=this._createDisposable(Z);if(he!==void 0){const Ae=K.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(he));_e=A.Disposable.from(_e,Ae)}return _e}$provideCodeLenses(O,B,K){return this._withAdapter(O,o,Z=>Z.provideCodeLenses(a.URI.revive(B),K),void 0,K)}$resolveCodeLens(O,B,K){return this._withAdapter(O,o,Z=>Z.resolveCodeLens(B,K),void 0,void 0)}$releaseCodeLenses(O,B){this._withAdapter(O,o,K=>Promise.resolve(K.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(O,B,K){const Z=this._addNewAdapter(new c(this._documents,K),O);return this._proxy.$registerDefinitionSupport(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideDefinition(O,B,K,Z){return this._withAdapter(O,c,he=>he.provideDefinition(a.URI.revive(B),K,Z),[],Z)}registerDeclarationProvider(O,B,K){const Z=this._addNewAdapter(new m(this._documents,K),O);return this._proxy.$registerDeclarationSupport(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideDeclaration(O,B,K,Z){return this._withAdapter(O,m,he=>he.provideDeclaration(a.URI.revive(B),K,Z),[],Z)}registerImplementationProvider(O,B,K){const Z=this._addNewAdapter(new f(this._documents,K),O);return this._proxy.$registerImplementationSupport(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideImplementation(O,B,K,Z){return this._withAdapter(O,f,he=>he.provideImplementation(a.URI.revive(B),K,Z),[],Z)}registerTypeDefinitionProvider(O,B,K){const Z=this._addNewAdapter(new i(this._documents,K),O);return this._proxy.$registerTypeDefinitionSupport(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideTypeDefinition(O,B,K,Z){return this._withAdapter(O,i,he=>he.provideTypeDefinition(a.URI.revive(B),K,Z),[],Z)}registerHoverProvider(O,B,K,Z){const he=this._addNewAdapter(new s(this._documents,K),O);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(B)),this._createDisposable(he)}$provideHover(O,B,K,Z){return this._withAdapter(O,s,he=>he.provideHover(a.URI.revive(B),K,Z),void 0,Z)}registerEvaluatableExpressionProvider(O,B,K,Z){const he=this._addNewAdapter(new u(this._documents,K),O);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(B)),this._createDisposable(he)}$provideEvaluatableExpression(O,B,K,Z){return this._withAdapter(O,u,he=>he.provideEvaluatableExpression(a.URI.revive(B),K,Z),void 0,Z)}registerInlineValuesProvider(O,B,K,Z){const he=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new b(this._documents,K),O);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(B),he);let Ae=this._createDisposable(_e);if(he!==void 0){const Ee=K.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(he));Ae=A.Disposable.from(Ae,Ee)}return Ae}$provideInlineValues(O,B,K,Z,he){return this._withAdapter(O,b,_e=>_e.provideInlineValues(a.URI.revive(B),K,Z,he),void 0,he)}registerDocumentHighlightProvider(O,B,K){const Z=this._addNewAdapter(new g(this._documents,K),O);return this._proxy.$registerDocumentHighlightProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideDocumentHighlights(O,B,K,Z){return this._withAdapter(O,g,he=>he.provideDocumentHighlights(a.URI.revive(B),K,Z),void 0,Z)}registerLinkedEditingRangeProvider(O,B,K){const Z=this._addNewAdapter(new L(this._documents,K),O);return this._proxy.$registerLinkedEditingRangeProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideLinkedEditingRanges(O,B,K,Z){return this._withAdapter(O,L,async he=>{const _e=await he.provideLinkedEditingRanges(a.URI.revive(B),K,Z);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?ce._serializeRegExp(_e.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(O,B,K){const Z=this._addNewAdapter(new H(this._documents,K),O);return this._proxy.$registerReferenceSupport(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideReferences(O,B,K,Z,he){return this._withAdapter(O,H,_e=>_e.provideReferences(a.URI.revive(B),K,Z,he),void 0,he)}registerCodeActionProvider(O,B,K,Z){const he=new C.DisposableStore,_e=this._addNewAdapter(new q(this._documents,this._commands.converter,this._diagnostics,K,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(_e,this._transformDocumentSelector(B),{providedKinds:Z?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Z?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,he)}))},ce._extLabel(O),Boolean(K.resolveCodeAction)),he.add(this._createDisposable(_e)),he}$provideCodeActions(O,B,K,Z,he){return this._withAdapter(O,q,_e=>_e.provideCodeActions(a.URI.revive(B),K,Z,he),void 0,he)}$resolveCodeAction(O,B,K){return this._withAdapter(O,q,Z=>Z.resolveCodeAction(B,K),void 0,void 0)}$releaseCodeActions(O,B){this._withAdapter(O,q,K=>Promise.resolve(K.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(O,B,K){const Z=this._addNewAdapter(new U(this._documents,K),O);return this._proxy.$registerDocumentFormattingSupport(Z,this._transformDocumentSelector(B),O.identifier,O.displayName||O.name),this._createDisposable(Z)}$provideDocumentFormattingEdits(O,B,K,Z){return this._withAdapter(O,U,he=>he.provideDocumentFormattingEdits(a.URI.revive(B),K,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(O,B,K){const Z=this._addNewAdapter(new N(this._documents,K),O);return this._proxy.$registerRangeFormattingSupport(Z,this._transformDocumentSelector(B),O.identifier,O.displayName||O.name),this._createDisposable(Z)}$provideDocumentRangeFormattingEdits(O,B,K,Z,he){return this._withAdapter(O,N,_e=>_e.provideDocumentRangeFormattingEdits(a.URI.revive(B),K,Z,he),void 0,he)}registerOnTypeFormattingEditProvider(O,B,K,Z){const he=this._addNewAdapter(new x(this._documents,K),O);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(B),Z,O.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(O,B,K,Z,he,_e){return this._withAdapter(O,x,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(B),K,Z,he,_e),void 0,_e)}registerWorkspaceSymbolProvider(O,B){const K=this._addNewAdapter(new F(B,this._logService),O);return this._proxy.$registerNavigateTypeSupport(K,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(O,B,K){return this._withAdapter(O,F,Z=>Z.provideWorkspaceSymbols(B,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,B,K){return this._withAdapter(O,F,Z=>Z.resolveWorkspaceSymbol(B,K),void 0,void 0)}$releaseWorkspaceSymbols(O,B){this._withAdapter(O,F,K=>K.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(O,B,K){const Z=this._addNewAdapter(new V(this._documents,K,this._logService),O);return this._proxy.$registerRenameSupport(Z,this._transformDocumentSelector(B),V.supportsResolving(K)),this._createDisposable(Z)}$provideRenameEdits(O,B,K,Z,he){return this._withAdapter(O,V,_e=>_e.provideRenameEdits(a.URI.revive(B),K,Z,he),void 0,he)}$resolveRenameLocation(O,B,K,Z){return this._withAdapter(O,V,he=>he.resolveRenameLocation(a.URI.revive(B),K,Z),void 0,Z)}registerDocumentSemanticTokensProvider(O,B,K,Z){const he=this._addNewAdapter(new se(this._documents,K),O),_e=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(B),Z,_e);let Ae=this._createDisposable(he);if(_e){const Ee=K.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(_e));Ae=A.Disposable.from(Ae,Ee)}return Ae}$provideDocumentSemanticTokens(O,B,K,Z){return this._withAdapter(O,se,he=>he.provideDocumentSemanticTokens(a.URI.revive(B),K,Z),null,Z)}$releaseDocumentSemanticTokens(O,B){this._withAdapter(O,se,K=>K.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,B,K,Z){const he=this._addNewAdapter(new $(this._documents,K),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(B),Z),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(O,B,K,Z){return this._withAdapter(O,$,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive(B),K,Z),null,Z)}registerCompletionItemProvider(O,B,K,Z){const he=this._addNewAdapter(new J(this._documents,this._commands.converter,K,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector(B),Z,J.supportsResolving(K),`${O.identifier.value}(${Z.join("")})`),this._createDisposable(he)}$provideCompletionItems(O,B,K,Z,he){return this._withAdapter(O,J,_e=>_e.provideCompletionItems(a.URI.revive(B),K,Z,he),void 0,he)}$resolveCompletionItem(O,B,K){return this._withAdapter(O,J,Z=>Z.resolveCompletionItem(B,K),void 0,K)}$releaseCompletionItems(O,B){this._withAdapter(O,J,K=>K.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(O,B,K){const Z=new be(O,this._documents,K,this._commands.converter),he=this._addNewAdapter(Z,O);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(B),Z.supportsHandleEvents),this._createDisposable(he)}$provideInlineCompletions(O,B,K,Z,he){return this._withAdapter(O,te,_e=>_e.provideInlineCompletions(a.URI.revive(B),K,Z,he),void 0,he)}$handleInlineCompletionDidShow(O,B,K){this._withAdapter(O,te,async Z=>{Z.handleDidShowCompletionItem(B,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,B,K,Z){this._withAdapter(O,te,async he=>{he.handlePartialAccept(B,K,Z)},void 0,void 0)}$freeInlineCompletionsList(O,B){this._withAdapter(O,te,async K=>{K.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(O,B,K,Z){const he=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,_e=this._addNewAdapter(new ue(this._documents,K),O);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(B),he),this._createDisposable(_e)}$provideSignatureHelp(O,B,K,Z,he){return this._withAdapter(O,ue,_e=>_e.provideSignatureHelp(a.URI.revive(B),K,Z,he),void 0,he)}$releaseSignatureHelp(O,B){this._withAdapter(O,ue,K=>K.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(O,B,K){const Z=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new j(this._documents,this._commands.converter,K,this._logService,O),O);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector(B),typeof K.resolveInlayHint=="function",Z,ce._extLabel(O));let _e=this._createDisposable(he);if(Z!==void 0){const Ae=K.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(Z));_e=A.Disposable.from(_e,Ae)}return _e}$provideInlayHints(O,B,K,Z){return this._withAdapter(O,j,he=>he.provideInlayHints(a.URI.revive(B),K,Z),void 0,Z)}$resolveInlayHint(O,B,K){return this._withAdapter(O,j,Z=>Z.resolveInlayHint(B,K),void 0,K)}$releaseInlayHints(O,B){this._withAdapter(O,j,K=>K.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(O,B,K){const Z=this._addNewAdapter(new M(this._documents,K),O);return this._proxy.$registerDocumentLinkProvider(Z,this._transformDocumentSelector(B),typeof K.resolveDocumentLink=="function"),this._createDisposable(Z)}$provideDocumentLinks(O,B,K){return this._withAdapter(O,M,Z=>Z.provideLinks(a.URI.revive(B),K),void 0,K,B.scheme==="output")}$resolveDocumentLink(O,B,K){return this._withAdapter(O,M,Z=>Z.resolveLink(B,K),void 0,void 0,!0)}$releaseDocumentLinks(O,B){this._withAdapter(O,M,K=>K.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(O,B,K){const Z=this._addNewAdapter(new Y(this._documents,K),O);return this._proxy.$registerDocumentColorProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideDocumentColors(O,B,K){return this._withAdapter(O,Y,Z=>Z.provideColors(a.URI.revive(B),K),[],K)}$provideColorPresentations(O,B,K,Z){return this._withAdapter(O,Y,he=>he.provideColorPresentations(a.URI.revive(B),K,Z),void 0,Z)}registerFoldingRangeProvider(O,B,K){const Z=this._nextHandle(),he=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Z,new ee(new ge(this._documents,K),O)),this._proxy.$registerFoldingRangeProvider(Z,this._transformDocumentSelector(B),O.identifier,he);let _e=this._createDisposable(Z);if(he!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));_e=A.Disposable.from(_e,Ae)}return _e}$provideFoldingRanges(O,B,K,Z){return this._withAdapter(O,ge,he=>he.provideFoldingRanges(a.URI.revive(B),K,Z),void 0,Z)}registerSelectionRangeProvider(O,B,K){const Z=this._addNewAdapter(new we(this._documents,K,this._logService),O);return this._proxy.$registerSelectionRangeProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideSelectionRanges(O,B,K,Z){return this._withAdapter(O,we,he=>he.provideSelectionRanges(a.URI.revive(B),K,Z),[],Z)}registerCallHierarchyProvider(O,B,K){const Z=this._addNewAdapter(new ie(this._documents,K),O);return this._proxy.$registerCallHierarchyProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$prepareCallHierarchy(O,B,K,Z){return this._withAdapter(O,ie,he=>Promise.resolve(he.prepareSession(a.URI.revive(B),K,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(O,B,K,Z){return this._withAdapter(O,ie,he=>he.provideCallsTo(B,K,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(O,B,K,Z){return this._withAdapter(O,ie,he=>he.provideCallsFrom(B,K,Z),void 0,Z)}$releaseCallHierarchy(O,B){this._withAdapter(O,ie,K=>Promise.resolve(K.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(O,B,K){const Z=this._addNewAdapter(new ne(this._documents,K),O);return this._proxy.$registerTypeHierarchyProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$prepareTypeHierarchy(O,B,K,Z){return this._withAdapter(O,ne,he=>Promise.resolve(he.prepareSession(a.URI.revive(B),K,Z)),void 0,Z)}$provideTypeHierarchySupertypes(O,B,K,Z){return this._withAdapter(O,ne,he=>he.provideSupertypes(B,K,Z),void 0,Z)}$provideTypeHierarchySubtypes(O,B,K,Z){return this._withAdapter(O,ne,he=>he.provideSubtypes(B,K,Z),void 0,Z)}$releaseTypeHierarchy(O,B){this._withAdapter(O,ne,K=>Promise.resolve(K.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(O,B,K){const Z=this._nextHandle();return this._adapter.set(Z,new ee(new de(this._proxy,this._documents,K,Z),O)),this._proxy.$registerDocumentOnDropEditProvider(Z,this._transformDocumentSelector(B)),this._createDisposable(Z)}$provideDocumentOnDropEdits(O,B,K,Z,he,_e){return this._withAdapter(O,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(B,a.URI.revive(K),Z,he,_e)),void 0,void 0)}registerDocumentPasteEditProvider(O,B,K,Z){const he=this._nextHandle();return this._adapter.set(he,new ee(new X(this._proxy,this._documents,K,he),O)),this._proxy.$registerPasteEditProvider(he,this._transformDocumentSelector(B),!!K.prepareDocumentPaste,Z.pasteMimeTypes),this._createDisposable(he)}$prepareDocumentPaste(O,B,K,Z,he){return this._withAdapter(O,X,_e=>_e.prepareDocumentPaste(a.URI.revive(B),K,Z,he),void 0,he)}$providePasteEdits(O,B,K,Z,he,_e){return this._withAdapter(O,X,Ae=>Ae.providePasteEdits(B,a.URI.revive(K),Z,he,_e),void 0,_e)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ce._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ce._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ce._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ce._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ce._serializeRegExp(O.beforeText),afterText:O.afterText?ce._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ce._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ce._serializeOnEnterRule)}setLanguageConfiguration(O,B,K){const{wordPattern:Z}=K;if(Z&&(0,y.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this._documents.setWordDefinitionFor(B,Z):this._documents.setWordDefinitionFor(B,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const he=this._nextHandle(),_e={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ce._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?ce._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ce._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,B,_e),this._createDisposable(he)}$setWordDefinitions(O){for(const B of O)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}ce._handlePool=0,e.ExtHostLanguageFeatures=ce}),define(Ce[275],De([1,0,5,11,7,38,19,6]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(R,I,_,D){this._documents=I,this._commands=_,this._uriTransformer=D,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,I){await this._proxy.$changeLanguage(R,I);const _=this._documents.getDocumentData(R);if(!_)throw new Error(`document '${R.toString()}' NOT found`);return _.document}async tokenAtPosition(R,I){const _=R.version,D=P.Position.from(I),C=await this._proxy.$tokensAtPosition(R.uri,D),E={type:l.StandardTokenType.Other,range:R.getWordRangeAtPosition(I)??new l.Range(I.line,I.character,I.line,I.character)};if(!C)return E;const n={range:P.Range.to(C.range),type:P.TokenType.to(C.type)};return!n.range.contains(I)||_!==R.version?E:n}createLanguageStatusItem(R,I,_){const D=this._handlePool++,C=this._proxy,E=this._ids,n=`${R.identifier.value}/${I}`;if(E.has(n))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);E.add(n);const d={selector:_,id:I,name:R.displayName??R.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const w=new k.DisposableStore,S=()=>{h?.dispose(),h=(0,T.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(D,{id:n,name:d.name??R.displayName??R.name,source:R.displayName??R.name,selector:P.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?A.default.Error:d.severity===l.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:d.command&&this._commands.toInternal(d.command,w),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},p={dispose(){w.dispose(),h?.dispose(),C.$removeLanguageStatus(D),E.delete(n)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,S()},get selector(){return d.selector},set selector(t){d.selector=t,S()},get text(){return d.text},set text(t){d.text=t,S()},get detail(){return d.detail},set detail(t){d.detail=t,S()},get severity(){return d.severity},set severity(t){d.severity=t,S()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,S()},get command(){return d.command},set command(t){d.command=t,S()},get busy(){return d.busy},set busy(t){d.busy=t,S()}};return S(),p}}e.ExtHostLanguages=y}),define(Ce[98],De([1,0,14,9,2,4,16,5,26,20]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(_,D,C){this.logService=C,this.bundleCache=new Map,this._proxy=D.getProxy(k.MainContext.MainThreadLocalization),this.currentLanguage=_.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===a.LANGUAGE_DEFAULT}getMessage(_,D){const{message:C,args:E,comment:n}=D;if(this.isDefaultLanguage)return(0,P.format2)(C,E??{});let d=C;n&&n.length>0&&(d+=`/${Array.isArray(n)?n.join(""):n}`);const h=this.bundleCache.get(_)?.contents[d];return h||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,P.format2)(h??C,E??{})}getBundle(_){return this.bundleCache.get(_)?.contents}getBundleUri(_){return this.bundleCache.get(_)?.uri}async initializeLocalizedMessages(_){if(this.isDefaultLanguage||!_.l10n&&!_.isBuiltin||this.bundleCache.has(_.identifier.value))return;let D;const C=await this.getBundleLocation(_);if(!C){this.logService.error(`No bundle location found for extension ${_.identifier.value}`);return}try{const E=await this._proxy.$fetchBundleContents(C),n=JSON.parse(E);D=_.isBuiltin?n.contents?.bundle:n}catch(E){this.logService.error(`Failed to load translations for ${_.identifier.value} from ${C}: ${E.message}`);return}D&&this.bundleCache.set(_.identifier.value,{contents:D,uri:C})}async getBundleLocation(_){if(_.isBuiltin){const D=await this._proxy.$fetchBuiltInBundleUri(_.identifier.value,this.currentLanguage);return l.URI.revive(D)}return _.l10n?l.URI.joinPath(_.extensionLocation,_.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=$e([Be(0,y.IExtHostInitDataService),Be(1,v.IExtHostRpcService),Be(2,T.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Ce[141],De([1,0,16,5,26,20,2,70]),function(re,e,a,P,l,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends a.AbstractLoggerService{constructor(I,_){super(_.logLevel,_.logsLocation,_.loggers.map(D=>(0,k.revive)(D))),this._proxy=I.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(I,_){_?this.setLogLevel(T.URI.revive(_),I):this.setLogLevel(I)}setVisibility(I,_){super.setVisibility(I,_),this._proxy.$setVisibility(I,_)}doCreateLogger(I,_,D){return new v(this._proxy,I,_,D)}};y=$e([Be(0,A.IExtHostRpcService),Be(1,l.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class v extends a.AbstractMessageLogger{constructor(I,_,D,C){super(C?.logLevel==="always"),this.proxy=I,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(D),this.proxy.$createLogger(_,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,_){const D=[[I,_]];this.isLoggerCreated?this.doLog(D):this.buffer.push(...D)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(Ce[276],De([1,0,5,16,27]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let T=class{constructor(y,v){this._logService=v,this._proxy=y.getProxy(a.MainContext.MainThreadMessageService)}showMessage(y,v,R,I,_){const D={source:{identifier:y.identifier,label:y.displayName||y.name}};let C;typeof I=="string"||A(I)?C=[I,..._]:(D.modal=I?.modal,D.useCustom=I?.useCustom,D.detail=I?.detail,C=_),D.useCustom&&(0,l.checkProposedApiEnabled)(y,"resolvers");const E=[];for(let n=0;n<C.length;n++){const d=C[n];if(typeof d=="string")E.push({title:d,handle:n,isCloseAffordance:!1});else if(typeof d=="object"){const{title:h,isCloseAffordance:w}=d;E.push({title:h,isCloseAffordance:!!w,handle:n})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(v,R,D,E).then(n=>{if(typeof n=="number")return C[n]})}};T=$e([Be(1,P.ILogService)],T),e.ExtHostMessageService=T}),define(Ce[277],De([1,0,22,3,6,28,9,10,2,76,5,41,11,7,58,248,137,8]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(S=>S.apiEditor)}constructor(S,p,t,o){this._textDocumentsAndEditors=t,this._textDocuments=o,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new v.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=S.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=S.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=S.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const c=r.notebookEditor?.notebookUri,m=r.cell.handle,i=this._documents.get(c)?.getCell(m);if(i)return i.apiCell}if(r&&r.$mid===14){const c=r.uri,m=this._documents.get(c);if(m)return m.apiNotebook}return r}}),h._registerApiCommands(p)}getEditorById(S){const p=this._editors.get(S);if(!p)throw new Error(`unknown text editor: ${S}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(S){for(const[p,t]of this._editors)if(t.apiEditor===S)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(S,p){const t=this._documents.get(S);if(!t&&!p)throw new Error(`NO notebook document for '${S}'`);return t}static _convertNotebookRegistrationData(S,p){if(!p)return;const t=p.filenamePattern.map(o=>_.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(p.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:p.displayName,filenamePattern:t,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,p,t){const o=h._notebookStatusBarItemProviderHandlePool++,r=typeof t.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,t),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,r,p);let c;return r!==void 0&&(c=t.onDidChangeCellStatusBarItems(m=>this._notebookProxy.$emitCellStatusBarEvent(r))),new D.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,r),c?.dispose()})}async createNotebookDocument(S){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:S.viewType,content:S.content&&_.NotebookData.from(S.content)});return y.URI.revive(p)}async openNotebookDocument(S){const p=this._documents.get(S);if(p)return p.apiNotebook;const t=await this._notebookDocumentsProxy.$tryOpenNotebook(S),o=this._documents.get(y.URI.revive(t));return(0,k.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(S,p){y.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let t;typeof p=="object"?t={position:_.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(_.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:t={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(S.uri,S.notebookType,t),r=o&&this._editors.get(o)?.apiEditor;if(r)return r;throw o?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,p,t,o){const r=this._notebookStatusBarItemProviders.get(S),c=y.URI.revive(p),m=this._documents.get(c);if(!m||!r)return;const f=m.getCellFromIndex(t);if(!f)return;const i=await r.provideCellStatusBarItems(f.apiCell,o);if(!i)return;const s=new l.DisposableStore,u=this._statusBarCache.add([s]),g=(Array.isArray(i)?i:[i]).map(L=>_.NotebookStatusBarItem.from(L,this._commandsConverter,s));return{cacheId:u,items:g}}$releaseNotebookCellStatusBarItems(S){this._statusBarCache.delete(S)}registerNotebookSerializer(S,p,t,o,r){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,t),this._notebookProxy.$registerNotebookSerializer(c,{id:S.identifier,location:S.extensionLocation},p,_.NotebookDocumentContentOptions.from(o),h._convertNotebookRegistrationData(S,r)),(0,l.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(S,p,t){const o=this._notebookSerializer.get(S);if(!o)throw new Error("NO serializer found");const r=await o.deserializeNotebook(p.buffer,t);return new C.SerializableObjectWithBuffers(_.NotebookData.from(r))}async $notebookToData(S,p,t){const o=this._notebookSerializer.get(S);if(!o)throw new Error("NO serializer found");const r=await o.serializeNotebook(_.NotebookData.to(p.value),t);return a.VSBuffer.wrap(r)}_createExtHostEditor(S,p,t){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const o=new n.ExtHostNotebookEditor(p,this._notebookEditorsProxy,S,t.visibleRanges.map(_.NotebookRange.to),t.selections.map(_.NotebookRange.to),typeof t.viewColumn=="number"?_.ViewColumn.to(t.viewColumn):void 0);this._editors.set(p,o)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const t of S.value.removedDocuments){const o=y.URI.revive(t),r=this._documents.get(o);r&&(r.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(c=>c.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const c of this._editors.values())c.notebookData.uri.toString()===o.toString()&&this._editors.delete(c.id)}if(S.value.addedDocuments){const t=[];for(const o of S.value.addedDocuments){const r=y.URI.revive(o.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const c=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,o);t.push(...o.cells.map(m=>E.ExtHostCell.asModelAddData(c.apiNotebook,m))),this._documents.get(r)?.dispose(),this._documents.set(r,c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this._onDidOpenNotebookDocument.fire(c.apiNotebook)}}if(S.value.addedEditors)for(const t of S.value.addedEditors){if(this._editors.has(t.id))return;const o=y.URI.revive(t.documentUri),r=this._documents.get(o);r&&this._createExtHostEditor(r,t.id,t)}const p=[];if(S.value.removedEditors)for(const t of S.value.removedEditors){const o=this._editors.get(t);o&&(this._editors.delete(t),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),p.push(o))}if(S.value.visibleEditors){this._visibleNotebookEditors=S.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const t=new Set;this._visibleNotebookEditors.forEach(o=>t.add(o.id));for(const o of this._editors.values()){const r=t.has(o.id);o._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this._activeNotebookEditor=void 0:S.value.newActiveEditor&&(this._editors.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(S){const p=I.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new I.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>a.VSBuffer.wrap(r))],new I.ApiCommandResult("Notebook Data",r=>_.NotebookData.to(r.value))),o=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new C.SerializableObjectWithBuffers(_.NotebookData.from(r)))],new I.ApiCommandResult("Bytes",r=>r.buffer));S.registerApiCommand(t),S.registerApiCommand(o)}}h._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=h}),define(Ce[278],De([1,0,18,19,21,3,6,28,2,25,16,76,5,41,11,7,96,238,27,58]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(m,f,i,s,u){this._initData=f,this._extHostNotebook=i,this._commands=s,this._logService=u,this._activeExecutions=new k.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new I.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=m.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",g=>!0,g=>{if(g&&"notebookEditor"in g&&"id"in g){const L=this._extHostNotebook.getIdByEditor(g.notebookEditor);return{id:g.id,extension:g.extension,notebookEditorId:L}}else if(g&&"notebookEditor"in g){const L=this._extHostNotebook.getIdByEditor(g.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${g.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return g})],D.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(m,f,i,s,u,b){for(const te of this._kernelData.values())if(te.controller.id===f&&v.ExtensionIdentifier.equals(m.identifier,te.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const g=this._handlePool++,L=this;this._logService.trace(`NotebookController[${g}], CREATED by ${m.identifier.value}, ${f}`);const H=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${m.identifier}'`);let q=!1;const X=new T.DisposableStore,U=new A.Emitter,N=new A.Emitter,x={id:r(m.identifier,f),notebookType:i,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:s||m.identifier.value,preloads:b?b.map(C.NotebookRendererScript.from):[]};let F=u??H,V;this._proxy.$addKernel(g,x).catch(te=>{console.log(te),q=!0});let fe=0;const se=()=>{if(q)return;const te=++fe;Promise.resolve().then(()=>{te===fe&&this._proxy.$updateKernel(g,x)})},$=new k.ResourceMap,J={get id(){return f},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return x.label},set label(te){x.label=te??m.displayName??m.name,se()},get detail(){return x.detail??""},set detail(te){x.detail=te,se()},get description(){return x.description??""},set description(te){x.description=te,se()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(te){x.supportedLanguages=te,se()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(te){x.supportsExecutionOrder=te,se()},get rendererScripts(){return x.preloads?x.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return F},set executeHandler(te){F=te??H},get interruptHandler(){return V},set interruptHandler(te){V=te,x.supportsInterrupt=Boolean(te),se()},createNotebookCellExecution(te){if(q)throw new Error("notebook controller is DISPOSED");if(!$.has(te.notebook.uri))throw L._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return L._createNotebookCellExecution(te,r(m.identifier,this.id))},dispose:()=>{q||(this._logService.trace(`NotebookController[${g}], DISPOSED`),q=!0,this._kernelData.delete(g),X.dispose(),U.dispose(),N.dispose(),this._proxy.$removeKernel(g))},updateNotebookAffinity(te,be){be===E.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(m,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(g,te.uri,be)},onDidReceiveMessage:N.event,postMessage(te,be){return(0,h.checkProposedApiEnabled)(m,"notebookMessaging"),L._proxy.$postMessage(g,be&&L._extHostNotebook.getIdByEditor(be),te)},asWebviewUri(te){return(0,h.checkProposedApiEnabled)(m,"notebookMessaging"),(0,n.asWebviewUri)(te,L._initData.remote)}};return this._kernelData.set(g,{extensionId:m.identifier,controller:J,onDidReceiveMessage:N,onDidChangeSelection:U,associatedNotebooks:$}),J}getIdByController(m){for(const[f,i]of this._kernelData)if(i.controller===m)return r(i.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,f){const i=this._kernelDetectionTaskHandlePool++,s=this;this._logService.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${m.identifier.value}`),this._proxy.$addKernelDetectionTask(i,f);const u={dispose:()=>{this._kernelDetectionTask.delete(i),s._proxy.$removeKernelDetectionTask(i)}};return this._kernelDetectionTask.set(i,u),u}registerKernelSourceActionProvider(m,f,i){const s=this._kernelSourceActionProviderHandlePool++,u=typeof i.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,b=this;this._kernelSourceActionProviders.set(s,i),this._logService.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${m.identifier.value}`),this._proxy.$addKernelSourceActionProvider(s,s,f);let g;return u!==void 0&&(g=i.onDidChangeNotebookKernelSourceActions(L=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(u))),{dispose:()=>{this._kernelSourceActionProviders.delete(s),b._proxy.$removeKernelSourceActionProvider(s,s),g?.dispose()}}}async $provideKernelSourceActions(m,f){const i=this._kernelSourceActionProviders.get(m);if(i){const s=new T.DisposableStore;return this._kernelSourceActionProviderCache.add([s]),(await i.provideNotebookKernelSourceActions(f)??[]).map(b=>C.NotebookKernelSourceAction.from(b,this._commands.converter,s))}return[]}$acceptNotebookAssociation(m,f,i){const s=this._kernelData.get(m);if(s){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(f));i?s.associatedNotebooks.set(u.uri,!0):s.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${m}] ASSOCIATE notebook`,u.uri.toString(),i),s.onDidChangeSelection.fire({selected:i,notebook:u.apiNotebook})}}async $executeCells(m,f,i){const s=this._kernelData.get(m);if(!s)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(f)),b=[];for(const g of i){const L=u.getCell(g);L&&b.push(L.apiCell)}try{this._logService.trace(`NotebookController[${m}] EXECUTE cells`,u.uri.toString(),b.length),await s.controller.executeHandler.call(s.controller,b,u.apiNotebook,s.controller)}catch(g){this._logService.error(`NotebookController[${m}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(m,f,i){const s=this._kernelData.get(m);if(!s)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(f));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,u.apiNotebook);else for(const b of i){const g=u.getCell(b);g&&this._activeExecutions.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(m,f,i){const s=this._kernelData.get(m);if(!s)return;const u=this._extHostNotebook.getEditorById(f);s.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:i}))}$cellExecutionChanged(m,f,i){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(m)).getCell(f);if(u){const b=i?C.NotebookCellExecutionState.to(i):E.NotebookCellExecutionState.Idle;b!==void 0&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:b})}}_createNotebookCellExecution(m,f){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const u=new t(f,s,this._proxy);this._activeExecutions.set(s.uri,u);const b=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),b.dispose(),this._activeExecutions.delete(s.uri))});return u.asApiObject()}};S=$e([Be(4,R.ILogService)],S),e.ExtHostNotebookKernels=S;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class t extends T.Disposable{get state(){return this._state}constructor(m,f,i){super(),this._cell=f,this._proxy=i,this._handle=t.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new o(10,s=>this.update(s)),this._executionOrder=f.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,m,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(m){await this._collector.addItem(m)}async update(m){const f=Array.isArray(m)?m:[m];return this._proxy.$updateExecution(this._handle,new w.SerializableObjectWithBuffers(f))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(m){let f=this._cell;if(m&&(f=this._cell.notebook.getCellFromApiCell(m)),!f)throw new Error("INVALID cell");return f.handle}validateAndConvertOutputs(m){return m.map(f=>{const i=E.NotebookCellOutput.ensureUniqueMimeTypes(f.items,!0);return i===f.items?C.NotebookCellOutput.from(f):C.NotebookCellOutput.from({items:i,id:f.id,metadata:f.metadata})})}async updateOutputs(m,f,i){const s=this.cellIndexToHandle(f),u=this.validateAndConvertOutputs((0,a.asArray)(m));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:s,append:i,outputs:u})}async updateOutputItems(m,f,i){return m=E.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(m),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:m.map(C.NotebookCellOutputItem.from),outputId:f.id,append:i})}asApiObject(){const m=this;return Object.freeze({get token(){return m._tokenSource.token},get cell(){return m._cell.apiCell},get executionOrder(){return m._executionOrder},set executionOrder(i){m._executionOrder=i,m.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:m._executionOrder}])},start(i){if(m._state===p.Resolved||m._state===p.Started)throw new Error("Cannot call start again");m._state=p.Started,m._onDidChangeState.fire(),m.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,s){if(m._state===p.Resolved)throw new Error("Cannot call resolve twice");m._state=p.Resolved,m._onDidChangeState.fire(),m._collector.flush(),m._proxy.$completeExecution(m._handle,new w.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:i}))},clearOutput(i){return m.verifyStateForOutput(),m.updateOutputs([],i,!1)},appendOutput(i,s){return m.verifyStateForOutput(),m.updateOutputs(i,s,!0)},replaceOutput(i,s){return m.verifyStateForOutput(),m.updateOutputs(i,s,!1)},appendOutputItems(i,s){return m.verifyStateForOutput(),m.updateOutputItems(i,s,!0)},replaceOutputItems(i,s){return m.verifyStateForOutput(),m.updateOutputItems(i,s,!1)}})}}t.HANDLE=0;class o{constructor(m,f){this.delay=m,this.callback=f,this.batch=[],this.startedTimer=Date.now()}addItem(m){return this.batch.push(m),this.currentDeferred||(this.currentDeferred=new P.DeferredPromise,this.startedTimer=Date.now(),(0,P.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const m=this.currentDeferred;this.currentDeferred=void 0;const f=this.batch;return this.batch=[],this.callback(f).finally(()=>m.complete())}}function r(c,m){return`${c.value}/${m}`}e.createKernelId=r}),define(Ce[279],De([1,0,3,5,137]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,y,v){const R=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging(k,y){if(!k.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,I,_)=>this.getOrCreateEmitterFor(y).event(R,I,_),postMessage:(R,I)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const _=I&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(_?.id,y,R)}}}getOrCreateEmitterFor(k){let y=this._rendererMessageEmitters.get(k);return y||(y=new a.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,y),y)}}e.ExtHostNotebookRenderers=A}),define(Ce[280],De([1,0,6,10,2,27,5]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class k{constructor(v){this.handlers=new Map,this.proxy=v.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,R,I){if((0,A.checkProposedApiEnabled)(v,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,I),this.proxy.$registerProfileContentHandler(R,I.name,I.description,v.identifier.value),(0,a.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,I,_){const D=this.handlers.get(v);if(!D)throw new Error(`Unknown handler with id: ${v}`);return D.saveProfile(R,I,_)}async $readProfile(v,R,I){const _=this.handlers.get(v);if(!_)throw new Error(`Unknown handler with id: ${v}`);return _.readProfile((0,P.isString)(R)?R:l.URI.revive(R),I)}}e.ExtHostProfileContentHandlers=k}),define(Ce[281],De([1,0,2,5,19,11]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{constructor(y,v){this.uriTransformer=v,this.providers=new Map,this.proxy=y.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,v,R){const I=a.URI.revive(v),_=this.providers.get(y);return _?(0,l.asPromise)(()=>_.provideOriginalResource(I,R)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(y,v,R,I){const _=T.handlePool++;return this.providers.set(_,v),this.proxy.$registerQuickDiffProvider(_,A.DocumentSelector.from(y,this.uriTransformer),R,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(_),this.providers.delete(_)}}}}T.handlePool=0,e.ExtHostQuickDiff=T}),define(Ce[282],De([1,0,21,3,6,5,2,7,8,18,38,52,27,11]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(E,n,d){const h=E.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(i,s){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=s}showQuickPick(i,s,u,b=a.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(s),L=++this._instances,H=h.$show(L,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},b),q={},X=H.then(()=>q);return Promise.race([X,g]).then(U=>{if(U===q)return;const N=(0,_.isProposedApiEnabled)(i,"quickPickItemTooltip");return g.then(x=>{const F=[];for(let V=0;V<x.length;V++){const fe=x[V];typeof fe=="string"?F.push({label:fe,handle:V}):fe.kind===k.QuickPickItemKind.Separator?F.push({type:"separator",label:fe.label}):(fe.tooltip&&!N&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),F.push({label:fe.label,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:N?D.MarkdownString.fromStrict(fe.tooltip):void 0,handle:V}))}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{u.onDidSelectItem(x[V])}),h.$setItems(L,F),H.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(fe=>x[fe])})})}).then(void 0,U=>{if(!(0,y.isCancellationError)(U))return h.$setError(L,U),Promise.reject(U)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,s=a.CancellationToken.None){return this._validateInput=i?.validateInput,h.$input(i,typeof this._validateInput=="function",s).then(void 0,u=>{if(!(0,y.isCancellationError)(u))return Promise.reject(u)})}async $validateInput(i){if(!this._validateInput)return;const s=await this._validateInput(i);if(!s||typeof s=="string")return s;let u;switch(s.severity){case k.InputBoxValidationSeverity.Info:u=R.default.Info;break;case k.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case k.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=s.message?R.default.Error:R.default.Ignore;break}return{content:s.message,severity:u}}async showWorkspaceFolderPick(i,s=a.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!u)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(g=>g.uri.toString()===u.uri.toString())}createQuickPick(i){const s=new c(i,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}createInputBox(i){const s=new m(i,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(i,s){this._sessions.get(i)?._fireDidChangeValue(s)}$onDidAccept(i){this._sessions.get(i)?._fireDidAccept()}$onDidChangeActive(i,s){const u=this._sessions.get(i);u instanceof c&&u._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const u=this._sessions.get(i);u instanceof c&&u._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){this._sessions.get(i)?._fireDidTriggerButton(s)}$onDidTriggerItemButton(i,s,u){const b=this._sessions.get(i);b instanceof c&&b._fireDidTriggerItemButton(s,u)}$onDidHide(i){this._sessions.get(i)?._fireDidHide()}}class S{constructor(i,s){this._extensionId=i,this._onDidDispose=s,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((s,u)=>{const b=s===k.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(b,s)}),this.update({buttons:i.map((s,u)=>({...r(s),tooltip:s.tooltip,handle:s===k.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const s=this._handlesToButtons.get(i);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,l.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(i){if(!this._disposed){for(const s of Object.keys(i)){const u=i[s];this._pendingUpdate[s]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function p(f){if(f instanceof k.ThemeIcon)return{id:f.id};const i=o(f),s=t(f);return{dark:typeof i=="string"?T.URI.file(i):i,light:typeof s=="string"?T.URI.file(s):s}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function o(f){return typeof f=="object"&&"dark"in f?f.dark:f}function r(f){const i=p(f.iconPath);let s,u;return"id"in i?u=I.ThemeIcon.asClassName(i):s=i,{iconPath:s,iconClass:u}}class c extends S{constructor(i,s){super(i.identifier,s),this.extension=i,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this._onDidTriggerItemButtonEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((b,g)=>{this._handlesToItems.set(g,b),this._itemsToHandles.set(b,g)});const s=(0,_.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),u=[];for(let b=0;b<i.length;b++){const g=i[b];g.kind===k.QuickPickItemKind.Separator?u.push({type:"separator",label:g.label}):(g.tooltip&&!s&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),u.push({handle:b,label:g.label,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:s?D.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((L,H)=>({...r(L),tooltip:L.tooltip,handle:H}))}))}this.update({items:u})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(i){const s=(0,v.coalesce)(i.map(u=>this._handlesToItems.get(u)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(i){const s=(0,v.coalesce)(i.map(u=>this._handlesToItems.get(u)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}_fireDidTriggerItemButton(i,s){const u=this._handlesToItems.get(i);if(!u||!u.buttons||!u.buttons.length)return;const b=u.buttons[s];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:u})}}class m extends S{constructor(i,s){super(i.identifier,s),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get valueSelection(){return this._valueSelection}set valueSelection(i){this._valueSelection=i,this.update({valueSelection:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:R.default.Error}):this.update({validationMessage:i.message,severity:i.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new w(n,d)}e.createExtHostQuickOpen=C});var Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a};define(Ce[283],De([1,0,2,3,62,6,19,5,18,109,16,25,52,11,27]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C){"use strict";var E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(s){if(s)return typeof s.iconPath=="string"?a.URI.file(s.iconPath):a.URI.isUri(s.iconPath)||_.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function h(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const b=typeof s.iconPath=="string"?s.iconPath:a.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,g=typeof u.iconPath=="string"?u.iconPath:a.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,v.comparePaths)(b,g)}function w(s,u){let b=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(b=h(s,u),b!==0)return b;if(s.light&&u.light)b=h(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(b!==0)return b;if(s.dark&&u.dark)b=h(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return b}function S(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let b=0;b<s.arguments.length;b++){const g=s.arguments[b],L=u.arguments[b];if(g!==L)return g<L?-1:1}return 0}function p(s,u){let b=(0,v.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(b!==0)return b;if(s.command&&u.command)b=S(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(b!==0)return b;if(s.decorations&&u.decorations)b=w(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return b}function t(s,u){for(let b=0;b<s.length;b++)if(s[b]!==u[b])return!1;return!0}function o(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?t(s.arguments,u.arguments):s.arguments===u.arguments)}function r(s,u){return(0,y.equals)(s,u,o)}class c{get value(){return this._value}set value(u){u=u??"",Ne(this,E,"f").$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){Ne(this,E,"f").$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,Ne(this,E,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get enabled(){return this._enabled}set enabled(u){u=!!u,this._enabled!==u&&(this._enabled=u,Ne(this,E,"f").$setInputBoxEnablement(this._sourceControlHandle,u))}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,Ne(this,E,"f").$setInputBoxVisibility(this._sourceControlHandle,u))}constructor(u,b,g){this._extension=u,this._sourceControlHandle=g,E.set(this,void 0),this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,E,b,"f")}showValidationMessage(u,b){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),Ne(this,E,"f").$showValidationMessage(this._sourceControlHandle,u,b)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=c,E=new WeakMap;class m{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}constructor(u,b,g,L,H){this._proxy=u,this._commands=b,this._sourceControlHandle=g,this._id=L,this._label=H,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=m._handlePool++}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,b){const g=this._resourceStatesCommandsMap.get(u);return g?(0,T.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(p),g=(0,y.sortedDiff)(this._resourceSnapshot,u,p).map(q=>{const X=q.toInsert.map(U=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,U);const x=U.resourceUri;let F;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const j=new A.DisposableStore;F=this._commands.converter.toInternal(U.command,j),this._resourceStatesDisposablesMap.set(N,j)}else this._resourceStatesCommandsMap.set(N,U.command);const V=d(U.decorations),fe=U.decorations&&d(U.decorations.light)||V,se=U.decorations&&d(U.decorations.dark)||V,$=[fe,se],J=U.decorations&&U.decorations.tooltip||"",te=U.decorations&&!!U.decorations.strikeThrough,be=U.decorations&&!!U.decorations.faded,le=U.contextValue||"";return{rawResource:[N,x,$,J,te,be,le,F],handle:N}});return{start:q.start,deleteCount:q.deleteCount,toInsert:X}}),L=g.map(({start:q,deleteCount:X,toInsert:U})=>[q,X,U.map(N=>N.rawResource)]),H=g.reverse();for(const{start:q,deleteCount:X,toInsert:U}of H){const N=U.map(F=>F.handle),x=this._handlesSnapshot.splice(q,X,...N);for(const F of x)this._resourceStatesMap.delete(F),this._resourceStatesCommandsMap.delete(F),this._resourceStatesDisposablesMap.get(F)?.dispose(),this._resourceStatesDisposablesMap.delete(F)}return this._resourceSnapshot=u,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}m._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,Ne(this,n,"f").$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u;let b;(0,C.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(b=u?.label),Ne(this,n,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u,quickDiffLabel:b})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,Ne(this,n,"f").$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const b=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);Ne(this,n,"f").$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=u;const b=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),secondaryCommands:u.secondaryCommands?.map(g=>g.map(L=>this._commands.converter.toInternal(L,this._actionButtonDisposables.value))),description:u.description,enabled:u.enabled}:void 0;Ne(this,n,"f").$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&r(this._statusBarCommands,u))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const b=(u||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));Ne(this,n,"f").$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}constructor(u,b,g,L,H,q){this._extension=u,this._commands=g,this._id=L,this._label=H,this._rootUri=q,n.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,n,b,"f"),this._inputBox=new c(u,Ne(this,n,"f"),this.handle),Ne(this,n,"f").$registerSourceControl(this.handle,L,H,q)}createResourceGroup(u,b){const g=new m(Ne(this,n,"f"),this._commands,this.handle,u,b),L=P.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,L),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const u=[],b=[];for(const[g,L]of this.createdResourceGroups){L.dispose();const H=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});P.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),H.dispose(),this._groups.delete(g.handle),Ne(this,n,"f").$unregisterGroup(this.handle,g.handle)}),u.push([g.handle,g.id,g.label,g.features]);const q=g._takeResourceStateSnapshot();q.length>0&&b.push([g.handle,q]),this._groups.set(g.handle,g)}Ne(this,n,"f").$registerGroups(this.handle,u,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(b=>{const g=b._takeResourceStateSnapshot();g.length!==0&&u.push([b.handle,g])}),u.length>0&&Ne(this,n,"f").$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),Ne(this,n,"f").$unregisterSourceControl(this.handle)}}n=new WeakMap,f._handlePool=0,$e([(0,l.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),$e([(0,l.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let i=class hn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(u,b,g){this._commands=b,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=u.getProxy(k.MainContext.MainThreadSCM),this._telemetry=u.getProxy(k.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const H=this._sourceControls.get(L.sourceControlHandle);if(!H)return L;const q=H.getResourceGroup(L.groupHandle);return q?q.getResourceState(L.handle):L}else if(L&&L.$mid===4){const H=this._sourceControls.get(L.sourceControlHandle);return H?H.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const H=this._sourceControls.get(L.handle);return H||L}return L}})}createSourceControl(u,b,g,L){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,b,g,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const H=hn._handlePool++,q=new f(u,this._proxy,this._commands,b,g,L);this._sourceControls.set(H,q);const X=this._sourceControlsByExtension.get(u.identifier)||[];return X.push(q),this._sourceControlsByExtension.set(u.identifier,X),q}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const b=this._sourceControlsByExtension.get(u.identifier),g=b&&b[b.length-1];return g&&g.inputBox}$provideOriginalResource(u,b,g){const L=a.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,L.toString());const H=this._sourceControls.get(u);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(L,g)).then(q=>q||null)}$onInputBoxValueChange(u,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const g=this._sourceControls.get(u);return g&&g.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(u,b,g,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,b,g);const H=this._sourceControls.get(u);if(!H)return Promise.resolve(void 0);const q=H.getResourceGroup(b);return q?q.$executeResourceCommand(g,L):Promise.resolve(void 0)}$validateInput(u,b,g){this.logService.trace("ExtHostSCM#$validateInput",u);const L=this._sourceControls.get(u);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>L.inputBox.validateInput(b,g)).then(H=>{if(!H)return Promise.resolve(void 0);const q=D.MarkdownString.fromStrict(H.message);return q?Promise.resolve([q,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};i._handlePool=0,i=$e([Be(2,R.ILogService)],i),e.ExtHostSCM=i}),define(Ce[99],De([1,0,5,3,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,v){return this._proxy.$setPassword(k,y,v)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[284],De([1,0,7,5,186,6,11,10]),function(re,e,a,P,l,A,T,k){"use strict";var y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(C,E,n,d,h=a.StatusBarAlignment.Left,w){y.set(this,void 0),v.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,Je(this,y,C,"f"),Je(this,v,E,"f"),this._entryId=R.ID_GEN++,this._extension=n,this._id=d,this._alignment=h,this._priority=this.validatePriority(w)}validatePriority(C){if(!!(0,k.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(C){this._text=C,this.update()}set name(C){this._name=C,this.update()}set tooltip(C){this._tooltip=C,this.update()}set color(C){this._color=C,this.update()}set backgroundColor(C){C&&!R.ALLOWED_BACKGROUND_COLORS.has(C.id)&&(C=void 0),this._backgroundColor=C,this.update()}set command(C){this._command?.fromApi!==C&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof C=="string"?this._command={fromApi:C,internal:Ne(this,v,"f").toInternal({title:"",command:C},this._latestCommandRegistration)}:C?this._command={fromApi:C,internal:Ne(this,v,"f").toInternal(C,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(C){this._accessibilityInformation=C,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let C;this._extension?this._id?C=`${this._extension.identifier.value}.${this._id}`:C=this._extension.identifier.value:C=this._id;let E;this._name?E=this._name:E=(0,l.localize)(0,null,this._extension.displayName||this._extension.name);let n=this._color;this._backgroundColor&&(n=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=T.MarkdownString.fromStrict(this._tooltip);Ne(this,y,"f").$setEntry(this._entryId,C,E,this._text,d,this._command?.internal,n,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}y=new WeakMap,v=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=R;class I{constructor(C){this._messages=[],this._item=C.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,l.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(C){const E={message:C};return this._messages.unshift(E),this._update(),new a.Disposable(()=>{const n=this._messages.indexOf(E);n>=0&&(this._messages.splice(n,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(C,E){this._proxy=C.getProxy(P.MainContext.MainThreadStatusBar),this._commands=E,this._statusMessage=new I(this)}createStatusBarEntry(C,E,n,d){return new R(this._proxy,this._commands,C,E,n,d)}setStatusBarMessage(C,E){const n=this._statusMessage.setMessage(C);let d;return typeof E=="number"?d=setTimeout(()=>n.dispose(),E):typeof E<"u"&&E.then(()=>n.dispose(),()=>n.dispose()),new a.Disposable(()=>{n.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=_}),define(Ce[100],De([1,0,5,3,4]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k,y){this._logService=y,this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}async initializeExtensionStorage(k,y,v){const R=await this._proxy.$initializeExtensionStorage(k,y);let I;return R&&(I=this.safeParseValue(k,y,R)),I||v}setValue(k,y,v){return this._proxy.$setValue(k,y,v)}$acceptValue(k,y,v){const R=this.safeParseValue(k,y,v);R&&this._onDidChangeStorage.fire({shared:k,key:y,value:R})}safeParseValue(k,y,v){try{return JSON.parse(v)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${k}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(Ce[81],De([1,0,4,26,16,80,2]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let k=class{constructor(v,R,I){this._logService=R,this._extHostFileSystem=I,this._workspace=v.workspace??void 0,this._environment=v.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(v){return T.URI.joinPath(this._environment.workspaceStorageHome,v)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const v=this._workspace.id,R=await this._getWorkspaceStorageURI(v);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(v){if(this._value)return T.URI.joinPath(this._value,v.identifier.value)}globalValue(v){return T.URI.joinPath(this._environment.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([Be(0,P.IExtHostInitDataService),Be(1,l.ILogService),Be(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(Ce[42],De([1,0,3,5,4,2,20,6,7,188,8,221,21,30,222,52,10,19,11]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class w{constructor(i,s,u,b){this._proxy=i,this._id=s,this._creationOptions=u,this._name=b,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},get state(){return g._state},sendText(L,H=!0){g._checkDisposed(),g._proxy.$sendText(g._id,L,H)},show(L){g._checkDisposed(),g._proxy.$show(g._id,L)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(i,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,n.withNullAsUndefined)(i.shellPath),shellArgs:(0,n.withNullAsUndefined)(i.shellArgs),cwd:(0,n.withNullAsUndefined)(i.cwd),env:(0,n.withNullAsUndefined)(i.env),icon:(0,n.withNullAsUndefined)(c(i.iconPath)),color:E.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,n.withNullAsUndefined)(i.message),strictEnv:(0,n.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,n.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,n.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,n.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(i.location,s?.resolvedExtHostIdentifier),isTransient:(0,n.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,s,u,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:E.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(i,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,s){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in i?{viewColumn:h.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitStatus(i,s){this._exitStatus=Object.freeze({code:i,reason:s})}setDimensions(i,s){return i===this._cols&&s===this._rows||i===0||s===0?!1:(this._cols=i,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class S{get onProcessReady(){return this._onProcessReady.event}constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,s){this._pty.setDimensions?.({columns:i,rows:s})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}let p=1,t=class extends k.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(i,s){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new a.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=s.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[u,b]of this._terminalProcesses)b.shutdown(!0)}})}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,s){const u=new w(this._proxy,(0,D.generateUuid)(),i,i.name),b=new S(i.pty);return u.createExtensionTerminal(i.location,this._serializeParentTerminal(i,s).resolvedExtHostIdentifier,c(i.iconPath),m(i.color)).then(g=>{const L=this._setupExtHostProcessListeners(g,b);this._terminalProcessDisposables[g]=L}),this._terminals.push(u),u.value}_serializeParentTerminal(i,s){if(s=s||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const u=i.location.parentTerminal;if(u){const b=this._terminals.find(g=>g.value===u);b&&(s.resolvedExtHostIdentifier=b._id)}}else i.location&&typeof i.location!="object"?s.location=i.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(i,s){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const b=new S(s),g=this._setupExtHostProcessListeners(i,b);this._terminalProcessDisposables[i]=g}async $acceptActiveTerminalChanged(i){const s=this._activeTerminal;if(i===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(i);u&&(this._activeTerminal=u,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,s){const u=this._getTerminalById(i);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:s})}async $acceptTerminalDimensions(i,s,u){const b=this._getTerminalById(i);b&&b.setDimensions(s,u)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(i,s,u){this._terminalProcesses.get(i)?.resize(s,u)}async $acceptTerminalTitleChange(i,s){const u=this._getTerminalById(i);u&&(u.name=s)}async $acceptTerminalClosed(i,s,u){const b=this._getTerminalObjectIndexById(this._terminals,i);if(b!==null){const g=this._terminals.splice(b,1)[0];g.setExitStatus(s,u),this._onDidCloseTerminal.fire(g.value)}}$acceptTerminalOpened(i,s,u,b){if(s){const H=this._getTerminalObjectIndexById(this._terminals,s);if(H!==null){this._terminals[H]._id=i,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const g={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:A.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},L=new w(this._proxy,i,g,u);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(i,s){this._getTerminalById(i)?._setProcessId(s)}async $startExtensionTerminal(i,s){const u=this._getTerminalById(i);if(!u)return{message:(0,v.localize)(0,null,i)};u.isOpen||await new Promise(g=>{const L=this.onDidOpenTerminal(async H=>{H===u.value&&(L.dispose(),g())})});const b=this._terminalProcesses.get(i);b?b.startSendingEvents(s):this._extensionTerminalAwaitingStart[i]={initialDimensions:s}}_setupExtHostProcessListeners(i,s){const u=new k.DisposableStore;u.add(s.onProcessReady(g=>this._proxy.$sendProcessReady(i,g.pid,g.cwd))),u.add(s.onDidChangeProperty(g=>this._proxy.$sendProcessProperty(i,g))),this._bufferer.startBuffering(i,s.onProcessData),u.add(s.onProcessExit(g=>this._onProcessExit(i,g))),this._terminalProcesses.set(i,s);const b=this._extensionTerminalAwaitingStart[i];return b&&s instanceof S&&(s.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),u}$acceptProcessAckDataEvent(i,s){this._terminalProcesses.get(i)?.acknowledgeDataEvent(s)}$acceptProcessInput(i,s){this._terminalProcesses.get(i)?.input(s)}$acceptTerminalInteraction(i){const s=this._getTerminalById(i);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(i,s,u){try{this._terminalProcesses.get(i)?.resize(s,u)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(i,s){this._terminalProcesses.get(i)?.shutdown(s)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(s=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:s}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,s,u){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,u),this._proxy.$registerProfileProvider(s,i.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(i,s,u){if(this._quickFixProviders.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this._quickFixProviders.set(i,u),this._proxy.$registerQuickFixProvider(i,s),new y.Disposable(()=>{this._quickFixProviders.delete(i),this._proxy.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,s){const u=new _.CancellationTokenSource().token;if(u.isCancellationRequested)return;const b=this._quickFixProviders.get(i);if(!b)return;const g=await b.provideTerminalQuickFixes(s,u);if(g!==null)return g}async $createContributedProfileTerminal(i,s){const u=new _.CancellationTokenSource().token;let b=await this._profileProviders.get(i)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(b&&!("options"in b)&&(b={options:b}),!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,s);return}this.createTerminalFromOptions(b.options,s)}}async $provideLinks(i,s){const u=this._getTerminalById(i);if(!u)return[];this._terminalLinkCache.delete(i),this._terminalLinkCancellationSource.get(i)?.dispose(!0);const g=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,g);const L=[],H={terminal:u.value,line:s},q=[];for(const N of this._linkProviders)q.push(d.Promises.withAsyncBody(async x=>{g.token.onCancellationRequested(()=>x({provider:N,links:[]}));const F=await N.provideTerminalLinks(H,g.token)||[];g.token.isCancellationRequested||x({provider:N,links:F})}));const X=await Promise.all(q);if(g.token.isCancellationRequested)return[];const U=new Map;for(const N of X)N&&N.links.length>0&&L.push(...N.links.map(x=>{const F={id:p++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return U.set(F.id,{provider:N.provider,link:x}),F}));return this._terminalLinkCache.set(i,U),L}$activateLink(i,s){const u=this._terminalLinkCache.get(i)?.get(s);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(i,s){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const u=this._terminalProcessDisposables[i];u&&(u.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,s)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,s){const u=this._getTerminalObjectIndexById(i,s);return u!==null?i[u]:null}_getTerminalObjectIndexById(i,s){let u=null;return i.some((b,g)=>b._id===s?(u=g,!0):!1),u}getEnvironmentVariableCollection(i){let s=this._environmentVariableCollections.get(i.identifier.value);return s||(s=new o,this._setEnvironmentVariableCollection(i.identifier.value,s)),s}_syncEnvironmentVariableCollection(i,s){const u=(0,I.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(i,s.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(i){i.forEach(s=>{const u=s[0],b=new o(s[1]);this._setEnvironmentVariableCollection(u,b)})}$acceptDefaultProfile(i,s){const u=this._defaultProfile;this._defaultProfile=i,this._defaultAutomationProfile=s,u?.path!==i.path&&this._onDidChangeShell.fire(i.path)}_setEnvironmentVariableCollection(i,s){this._environmentVariableCollections.set(i,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,s)})}};t=$e([Be(1,T.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class o{get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,s){this._setIfDiffers(i,{value:s,type:y.EnvironmentVariableMutatorType.Replace})}append(i,s){this._setIfDiffers(i,{value:s,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,s){this._setIfDiffers(i,{value:s,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,s){const u=this.map.get(i);(!u||u.value!==s.value||u.type!==s.type)&&(this.map.set(i,s),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,s){this.map.forEach((u,b)=>i.call(s,b,u,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let r=class extends t{constructor(i){super(!1,i)}createTerminal(i,s,u){throw new R.NotSupportedError}createTerminalFromOptions(i,s){throw new R.NotSupportedError}};r=$e([Be(0,T.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function m(f){return E.ThemeColor.isThemeColor(f)?f:void 0}});var Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)},Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a};define(Ce[285],De([1,0,18,19,22,21,3,63,68,6,23,10,30,5,20,138,11,7,57,95,77]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S){"use strict";var p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(U,N,x){this.editors=x,this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(D.MainContext.MainThreadTesting),this.observer=new L(this.proxy),this.runTracker=new f(this.proxy),N.registerArgumentProcessor({processArgument:F=>{if(F?.$mid!==15)return F;const V=F,fe=V.tests[V.tests.length-1].item.extId;return this.controllers.get(h.TestId.root(fe))?.collection.tree.get(fe)?.actual??(0,E.toItemFromContext)(F)}})}createTestController(U,N,x,F){if(this.controllers.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const V=new v.DisposableStore,fe=V.add(new E.ExtHostTestItemCollection(N,x,this.editors));fe.root.label=x;const se=new Map,$=this.proxy,J={items:fe.root.children,get label(){return x},set label(be){x=be,fe.root.label=be,$.$updateController(N,{label:x})},get refreshHandler(){return F},set refreshHandler(be){F=be,$.$updateController(N,{canRefresh:!!be})},get id(){return N},createRunProfile:(be,le,ue,j,M,Y)=>{let ge=(0,y.hash)(be);for(;se.has(ge);)ge++;return new H(this.proxy,se,N,ge,be,le,ue,j,M,Y)},createTestItem(be,le,ue){return new E.TestItemImpl(N,be,le,ue)},createTestRun:(be,le,ue=!0)=>this.runTracker.createTestRun(N,fe,be,le,ue),set resolveHandler(be){fe.resolveHandler=be},get resolveHandler(){return fe.resolveHandler},dispose:()=>{V.dispose()}};$.$registerTestController(N,x,!!F),V.add((0,v.toDisposable)(()=>$.$unregisterTestController(N)));const te={controller:J,collection:fe,profiles:se};return this.controllers.set(N,te),V.add((0,v.toDisposable)(()=>this.controllers.delete(N))),V.add(fe.onDidGenerateDiff(be=>$.$publishDiff(N,be.map(S.TestsDiffOp.serialize)))),J}createTestObserver(){return this.observer.checkout()}async runTests(U,N=A.CancellationToken.None){const x=i(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(V=>h.TestId.fromExtHostTestItem(V,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:q[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(V=>V.id)},N)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,N,x){return(0,a.mapFind)(this.runTracker.trackers,V=>V.id===U?V.getCoverage(N):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(U,N,x,F){return(0,a.mapFind)(this.runTracker.trackers,fe=>fe.id===U?fe.getCoverage(N):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(U,N){this.controllers.get(U)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(U,N){await this.controllers.get(U)?.controller.refreshHandler?.(N)}$publishTestResults(U){this.results=Object.freeze(U.map(N=>(0,R.deepFreeze)(n.TestResults.to(N))).concat(this.results).sort((N,x)=>x.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,N){const x=this.controllers.get(h.TestId.fromString(U).controllerId)?.collection;x&&(await x.expand(U,N<0?1/0:N),x.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(S.TestsDiffOp.deserialize))}async $runControllerTests(U,N){return Promise.all(U.map(x=>this.runControllerTestRequest(x,!1,N)))}async $startContinuousRun(U,N){const x=new A.CancellationTokenSource(N),F=await Promise.all(U.map(V=>this.runControllerTestRequest(V,!0,x.token)));return!N.isCancellationRequested&&!F.some(V=>V.error)&&await new Promise(V=>N.onCancellationRequested(V)),x.dispose(!0),F}async runControllerTestRequest(U,N,x){const F=this.controllers.get(U.controllerId);if(!F)return{};const{collection:V,profiles:fe}=F,se=fe.get(U.profileId);if(!se)return{};const $=U.testIds.map(le=>V.tree.get(le)).filter(I.isDefined),J=U.excludeExtIds.map(le=>F.collection.tree.get(le)).filter(I.isDefined).filter(le=>$.some(ue=>ue.fullId.compare(le.fullId)===2));if(!$.length)return{};const te=new d.TestRunRequest($.some(le=>le.actual instanceof E.TestItemRootImpl)?void 0:$.map(le=>le.actual),J.map(le=>le.actual),se,N),be=(0,S.isStartControllerTests)(U)&&this.runTracker.prepareForMainThreadTestRun(te,s.fromInternal(U,F.collection),x);try{return await se.runHandler(te,x),{}}catch(le){return{error:String(le)}}finally{be&&(be.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};o=$e([Be(0,C.IExtHostRpcService)],o),e.ExtHostTesting=o;const r=1e4;var c;(function(X){X[X.Running=0]="Running",X[X.Cancelling=1]="Cancelling",X[X.Ended=2]="Ended"})(c||(c={}));class m extends v.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,N,x){super(),this.dto=U,this.proxy=N,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new A.CancellationTokenSource(x));const F=this._register(new P.RunOnceScheduler(()=>this.forciblyEndTasks(),r));this._register(this.cts.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const N=this.dto.id,x=this.dto.controllerId,F=(0,_.generateUuid)(),V=new u(this.proxy,N,F),fe=te=>(be,...le)=>{if($){console.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(be)||(this.ensureTestIsKnown(be),te(be,...le))},se=(te,be)=>{const le=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(te.uri&&te.range){const ue={range:n.Range.from(te.range),uri:te.uri};for(const j of le)j.location=j.location||ue}this.proxy.$appendTestMessagesInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),le)};let $=!1;const J={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return V.coverageProvider},set coverageProvider(te){V.coverageProvider=te},enqueued:fe(te=>{this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),1)}),skipped:fe(te=>{this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),5)}),started:fe(te=>{this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),2)}),errored:fe((te,be,le)=>{se(te,be),this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),6,le)}),failed:fe((te,be,le)=>{se(te,be),this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,x).toString(),4,le)}),passed:fe((te,be)=>{this.proxy.$updateTestStateInRun(N,F,h.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,be)}),appendOutput:(te,be,le)=>{$||(le&&(this.dto.isIncluded(le)?this.ensureTestIsKnown(le):le=void 0),this.proxy.$appendOutputToRun(N,F,l.VSBuffer.fromString(te),be&&n.location.from(be),le&&h.TestId.fromExtHostTestItem(le,x).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.tasks.size||this.markEnded())}};return this.tasks.set(F,{run:J,coverage:V}),this.proxy.$startedTestRunTask(N,{id:F,name:U,running:!0}),J}forciblyEndTasks(){for(const{run:U}of this.tasks.values())U.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(U){if(!(U instanceof E.TestItemImpl))throw new w.InvalidTestItemError(U.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const N=[],x=this.dto.colllection.root;for(;;){const F=n.TestItem.from(U);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),U===x))break;U=U.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class f{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,N,x){return this.getTracker(U,N,x)}cancelRunById(U){for(const N of this.tracked.values())if(N.id===U){N.cancel();return}}cancelAllRuns(){for(const U of this.tracked.values())U.cancel()}createTestRun(U,N,x,F,V){const fe=this.tracked.get(x);if(fe)return fe.createRun(F);const se=s.fromPublic(U,N,x,V),$=i(x);this.proxy.$startedExtensionTestRun({controllerId:U,continuous:!!x.continuous,profile:$&&{group:q[$.kind],id:$.profileId},exclude:x.exclude?.map(te=>h.TestId.fromExtHostTestItem(te,N.root.id).toString())??[],id:se.id,include:x.include?.map(te=>h.TestId.fromExtHostTestItem(te,N.root.id).toString())??[N.root.id],persist:V});const J=this.getTracker(x,se);return J.onEnd(()=>{this.proxy.$finishedExtensionTestRun(se.id),J.dispose()}),J.createRun(F)}getTracker(U,N,x){const F=new m(N,this.proxy,x);return this.tracked.set(U,F),F.onEnd(()=>this.tracked.delete(U)),F}}e.TestRunCoordinator=f;const i=X=>{if(!!X.profile){if(!(X.profile instanceof H))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return X.profile}};class s{static fromPublic(U,N,x,F){return new s(U,(0,_.generateUuid)(),x.include?.map(V=>h.TestId.fromExtHostTestItem(V,U).toString())??[U],x.exclude?.map(V=>h.TestId.fromExtHostTestItem(V,U).toString())??[],F,N)}static fromInternal(U,N){return new s(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,N)}constructor(U,N,x,F,V,fe){this.controllerId=U,this.id=N,this.isPersisted=V,this.colllection=fe,this.includePrefix=x.map(se=>se+"\0"),this.excludePrefix=F.map(se=>se+"\0")}isIncluded(U){const N=h.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(N===x||N.startsWith(x))return!1;for(const x of this.includePrefix)if(N===x||N.startsWith(x))return!0;return!1}}e.TestRunDto=s;class u{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,N,x){this.proxy=U,this.runId=N,this.taskId=x}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(U,N){const x=await this.fileCoverage;let F=x?.[U];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[U]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const N=h.TestId.parentId(U.item.extId);if(N&&this.alreadyRemoved.has(N.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:N,removed:x}=this;return{get added(){return[...U].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,N){return{...U,revived:n.TestItem.toPlain(U.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new b(this.changeEmitter)}}class L{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class H{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(U){U!==this._supportsContinuousRun&&(this._supportsContinuousRun=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,N,x,F,V,fe,se,$=!1,J=void 0,te=!1){this.controllerId=x,this.profileId=F,this._label=V,this.kind=fe,this.runHandler=se,this._isDefault=$,this._tag=J,this._supportsContinuousRun=te,p.set(this,void 0),t.set(this,void 0),Je(this,p,U,"f"),Je(this,t,N,"f"),N.set(F,this);const be=q[fe];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${fe}`);Ne(this,p,"f").$publishTestRunProfile({profileId:F,controllerId:x,tag:J?n.TestTag.namespace(this.controllerId,J.id):null,label:V,group:be,isDefault:$,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){Ne(this,t,"f")?.delete(this.profileId)&&(Je(this,t,void 0,"f"),Ne(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=H,p=new WeakMap,t=new WeakMap;const q={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ce[286],De([1,0,18,8,3,5,139,11,7]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(I,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new l.Emitter({onListenerError:P.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=I.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(D=>this._onDidChangeVisibleTextEditors.fire(D)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(D=>this._onDidChangeActiveTextEditor.fire(D))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(I){const _=this._extHostDocumentsAndEditors.allEditors();return I?_:_.map(D=>D.value)}async showTextDocument(I,_,D){let C;typeof _=="number"?C={position:k.ViewColumn.from(_),preserveFocus:D}:typeof _=="object"?C={position:k.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?k.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:C={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(I.uri,C),n=E&&this._extHostDocumentsAndEditors.getEditor(E);if(n)return n.value;throw E?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,_){return new T.TextEditorDecorationType(this._proxy,I,_).value}$acceptEditorPropertiesChanged(I,_){const D=this._extHostDocumentsAndEditors.getEditor(I);if(!D)throw new Error("unknown text editor");if(_.options&&D._acceptOptions(_.options),_.selections){const C=_.selections.selections.map(k.Selection.to);D._acceptSelections(C)}if(_.visibleRanges){const C=a.coalesce(_.visibleRanges.map(k.Range.to));D._acceptVisibleRanges(C)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:D.value,options:{..._.options,lineNumbers:k.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const C=y.TextEditorSelectionChangeKind.fromValue(_.selections.source),E=_.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:D.value,selections:E,kind:C})}if(_.visibleRanges){const C=a.coalesce(_.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:D.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const _ in I){const D=this._extHostDocumentsAndEditors.getEditor(_);if(!D)throw new Error("Unknown text editor");const C=k.ViewColumn.to(I[_]);D.value.viewColumn!==C&&(D._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:D.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this._proxy.$getDiffInformation(I))}}e.ExtHostEditors=v}),define(Ce[287],De([1,0,2,4,5,6,7,11,25,10]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class R{constructor(D,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=D.getProxy(l.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(E,n)=>{if(E&&E.$mid===12)if(this._providers.get(E.source)&&y.ExtensionIdentifier.equals(n,this._providers.get(E.source)?.extension)){const d=E.uri===void 0?void 0:a.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(I(d))?.get(E.handle)}else return;return E}})}async $getTimeline(D,C,E,n){return this._providers.get(D)?.provider.provideTimeline(a.URI.revive(C),E,n)}registerTimelineProvider(D,C,E,n){const d=new A.DisposableStore,h=this.convertTimelineItem(C.id,n,d).bind(this);let w;C.onDidChange&&(w=C.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:C.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:D,onDidChange:void 0,async provideTimeline(p,t,o){t?.resetCache&&(d.clear(),S.get(C.id)?.clear());const r=await C.provideTimeline(p,t,o);if(r==null)return;const c=h(p,t);return{...r,source:C.id,items:r.items.map(c)}},dispose(){for(const p of S.values())p.get(C.id)?.clear();w?.dispose(),d.dispose()}},E)}convertTimelineItem(D,C,E){return(n,d)=>{let h;if(d?.cacheResults){let w=this._itemsBySourceAndUriMap.get(D);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(D,w));const S=I(n);h=w.get(S),h===void 0&&(h=new Map,w.set(S,h))}return w=>{const{iconPath:S,...p}=w,t=`${D}|${w.id??w.timestamp}`;h?.set(t,w);let o,r,c;w.iconPath&&(S instanceof T.ThemeIcon?c={id:S.id,color:S.color}:a.URI.isUri(S)?(o=S,r=S):{light:o,dark:r}=S);let m;return T.MarkdownString.isMarkdownString(p.tooltip)?m=k.MarkdownString.from(p.tooltip):(0,v.isString)(p.tooltip)?m=p.tooltip:T.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=k.MarkdownString.from(p.detail)):(0,v.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=p.detail),{...p,id:p.id??void 0,handle:t,source:D,command:w.command?C.toInternal(w.command,E):void 0,icon:o,iconDark:r,themeIcon:c,tooltip:m,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(D,C){if(this._providers.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this._proxy.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this._providers.set(D.id,{provider:D,extension:C}),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(D.id)?.clear();this._providers.delete(D.id),this._proxy.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=R;function I(_){return _?.toString()}}),define(Ce[288],De([1,0,6,17,2,5]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,v,R,I){if(this._openers.has(v))throw new Error(`Opener with id '${v}' already registered`);const _=I.schemes.find(D=>!T.supportedSchemes.has(D));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(v,R),this._proxy.$registerUriOpener(v,I.schemes,y,I.label),(0,a.toDisposable)(()=>{this._openers.delete(v),this._proxy.$unregisterUriOpener(v)})}async $canOpenUri(y,v,R){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const _=l.URI.revive(v);return I.canOpenExternalUri(_,R)}async $openUri(y,v,R){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(l.URI.revive(v.resolvedUri),{sourceUri:l.URI.revive(v.sourceUri)},R)}}T.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https]),e.ExtHostUriOpeners=T}),define(Ce[289],De([1,0,5,2,6,8,25]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(v){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=v.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(v,R){if(this.handles.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const I=k.HandlePool++;return this.handles.add(v),this.handlers.set(I,R),this._proxy.$registerUriHandler(I,v),(0,l.toDisposable)(()=>{this.handles.delete(v),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(v,R){const I=this.handlers.get(v);if(!I)return Promise.resolve(void 0);try{I.handleUri(P.URI.revive(R))}catch(_){(0,A.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(v){return P.URI.revive(await this._proxy.$createAppUri(v))}}k.HandlePool=0,e.ExtHostUrls=k});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[82],De([1,0,3,17,23,2,205,230,96,5]),function(re,e,a,P,l,A,T,k,y,v){"use strict";var R,I,_,D,C,E,n,d,h,w,S,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(g,L,H,q,X,U,N){R.set(this,void 0),I.set(this,void 0),_.set(this,void 0),D.set(this,void 0),C.set(this,void 0),E.set(this,void 0),n.set(this,""),d.set(this,void 0),h.set(this,!1),w.set(this,!1),S.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new a.Emitter),this._onDidDispose=Ne(this,t,"f").event,Je(this,R,g,"f"),Je(this,I,L,"f"),Je(this,d,H,"f"),Je(this,D,q,"f"),Je(this,C,X,"f"),Je(this,E,U,"f"),Je(this,S,r(U),"f"),Je(this,p,c(U),"f"),Je(this,_,N,"f")}dispose(){Je(this,h,!0,"f"),Ne(this,t,"f").fire(),Ne(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Je(this,w,!0,"f"),(0,y.asWebviewUri)(g,Ne(this,D,"f"))}get cspSource(){const g=Ne(this,E,"f").extensionLocation;if(g.scheme===P.Schemas.https||g.scheme===P.Schemas.http){let L=g.toString();return L.endsWith("/")||(L+="/"),L+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,n,"f")}set html(g){this.assertNotDisposed(),Ne(this,n,"f")!==g&&(Je(this,n,g,"f"),Ne(this,p,"f")&&!Ne(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Je(this,w,!0,"f"),Ne(this,_,"f").report("Webview vscode-resource: uris",Ne(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,I,"f").$setHtml(Ne(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(g)))}get options(){return this.assertNotDisposed(),Ne(this,d,"f")}set options(g){this.assertNotDisposed(),l.equals(Ne(this,d,"f"),g)||Ne(this,I,"f").$setOptions(Ne(this,R,"f"),i(Ne(this,E,"f"),Ne(this,C,"f"),g)),Je(this,d,g,"f")}async postMessage(g){if(Ne(this,h,"f"))return!1;const L=(0,k.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Ne(this,S,"f")});return Ne(this,I,"f").$postMessage(Ne(this,R,"f"),L.message,...L.buffers)}assertNotDisposed(){if(Ne(this,h,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(g){if(!Ne(this,p,"f"))return g;const L=Ne(this,E,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,H=Ne(this,E,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ne(this,E,"f").extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,X,U,N,x,F)=>{const V=A.URI.from({scheme:N||"file",path:decodeURIComponent(x)}),fe=(0,y.asWebviewUri)(V,{isRemote:L,authority:H}).toString();return`${X}${fe}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,X,U,N,x,F)=>{const V=A.URI.from({scheme:N||"file",path:decodeURIComponent(x)}),fe=(0,y.asWebviewUri)(V,{isRemote:L,authority:H}).toString();return`${X}${fe}${F}`})}}e.ExtHostWebview=o,R=new WeakMap,I=new WeakMap,_=new WeakMap,D=new WeakMap,C=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,p=new WeakMap,t=new WeakMap;function r(b){try{const g=(0,T.normalizeVersion)((0,T.parseVersion)(b.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(b){try{const g=(0,T.normalizeVersion)((0,T.parseVersion)(b.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class m{constructor(g,L,H,q,X){this.remoteInfo=L,this.workspace=H,this._logService=q,this._deprecationService=X,this._webviews=new Map,this._webviewProxy=g.getProxy(v.MainContext.MainThreadWebviews)}$onMessage(g,L,H){const q=this.getWebview(g);if(q){const{message:X}=(0,k.deserializeWebviewMessage)(L,H.value);q._onMessageEmitter.fire(X)}}$onMissingCsp(g,L){this._logService.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,L,H){const q=new o(g,this._webviewProxy,s(L),this.remoteInfo,this.workspace,H,this._deprecationService);return this._webviews.set(g,q),q._onDidDispose(()=>{this._webviews.delete(g)}),q}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=m;function f(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=f;function i(b,g,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||u(b,g)}}e.serializeWebviewOptions=i;function s(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(g=>A.URI.from(g))}}function u(b,g){return[...(g?.getWorkspaceFolders()||[]).map(L=>L.uri),b.extensionLocation]}}),define(Ce[290],De([1,0,21,68,6,17,24,2,11,82,76,5,7]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(o,r){this.document=o,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,r){await this.getEdit(o).undo(),r||this.disposeBackup()}async redo(o,r){await this.getEdit(o).redo(),r||this.disposeBackup()}disposeEdits(o){for(const r of o)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const r=this._edits.get(o,0);if(!r)throw new Error("No edit found");return r}}class C{constructor(){this._documents=new Map}get(o,r){return this._documents.get(this.key(o,r))}add(o,r,c){const m=this.key(o,r.uri);if(this._documents.has(m))throw new Error(`Document already exists for viewType:${o} resource:${r.uri}`);const f=new D(r,c);return this._documents.set(m,f),f}delete(o,r){const c=this.key(o,r.uri);this._documents.delete(c)}key(o,r){return`${o}@@@${r}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class n{constructor(){this._providers=new Map}addTextProvider(o,r,c){return this.add(0,o,r,c)}addCustomProvider(o,r,c){return this.add(1,o,r,c)}get(o){return this._providers.get(o)}add(o,r,c,m){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:o,extension:c,provider:m}),new _.Disposable(()=>this._providers.delete(r))}}class d{constructor(o,r,c,m,f){this._extHostDocuments=r,this._extensionStoragePaths=c,this._extHostWebview=m,this._extHostWebviewPanels=f,this._editorProviders=new n,this._documents=new C,this._proxy=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,r,c,m){const f=new l.DisposableStore;return w(c)?(f.add(this._editorProviders.addTextProvider(r,o,c)),this._proxy.$registerTextEditorProvider((0,v.toExtensionData)(o),r,m.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,v.shouldSerializeBuffersForPostMessage)(o))):(f.add(this._editorProviders.addCustomProvider(r,o,c)),h(c)&&f.add(c.onDidChangeCustomDocument(i=>{const s=this.getCustomDocumentEntry(r,i.document.uri);if(S(i)){const u=s.addEdit(i);this._proxy.$onDidEdit(i.document.uri,r,u,i.label)}else this._proxy.$onContentChange(i.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,v.toExtensionData)(o),r,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,v.shouldSerializeBuffersForPostMessage)(o))),_.Disposable.from(f,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(o,r,c,m,f){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=k.URI.revive(o),u=await i.provider.openCustomDocument(s,{backupId:c,untitledDocumentData:m?.buffer},f);let b;return h(i.provider)&&this._extensionStoragePaths&&(b=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(r,u,b),{editable:h(i.provider)}}async $disposeCustomDocument(o,r){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const m=k.URI.revive(o),{document:f}=this.getCustomDocumentEntry(r,m);this._documents.delete(r,f),f.dispose()}async $resolveCustomEditor(o,r,c,m,f,i){const s=this._editorProviders.get(c);if(!s)throw new Error(`No provider found for '${c}'`);const u=y.ViewColumn.to(f),b=this._extHostWebview.createNewWebview(r,m.contentOptions,s.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(r,c,m.title,u,m.options,b,!0),L=k.URI.revive(o);switch(s.type){case 1:{const{document:H}=this.getCustomDocumentEntry(c,L);return s.provider.resolveCustomEditor(H,g,i)}case 0:{const H=this._extHostDocuments.getDocument(L);return s.provider.resolveCustomTextEditor(H,g,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,r,c){this.getCustomDocumentEntry(r,o).disposeEdits(c)}async $onMoveCustomEditor(o,r,c){const m=this._editorProviders.get(c);if(!m)throw new Error(`No provider found for '${c}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const f=this._extHostWebviewPanels.getWebviewPanel(o);if(!f)throw new Error("No webview found");const i=k.URI.revive(r),s=this._extHostDocuments.getDocument(i);await m.provider.moveCustomTextEditor(s,f,a.CancellationToken.None)}async $undo(o,r,c,m){return this.getCustomDocumentEntry(r,o).undo(c,m)}async $redo(o,r,c,m){return this.getCustomDocumentEntry(r,o).redo(c,m)}async $revert(o,r,c){const m=this.getCustomDocumentEntry(r,o);await this.getCustomEditorProvider(r).revertCustomDocument(m.document,c),m.disposeBackup()}async $onSave(o,r,c){const m=this.getCustomDocumentEntry(r,o);await this.getCustomEditorProvider(r).saveCustomDocument(m.document,c),m.disposeBackup()}async $onSaveAs(o,r,c,m){const f=this.getCustomDocumentEntry(r,o);return this.getCustomEditorProvider(r).saveCustomDocumentAs(f.document,k.URI.revive(c),m)}async $backup(o,r,c){const m=this.getCustomDocumentEntry(r,o),i=await this.getCustomEditorProvider(r).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},c);return m.updateBackup(i),i.id}getCustomDocumentEntry(o,r){const c=this._documents.get(o,k.URI.revive(r));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(o){const c=this._editorProviders.get(o)?.provider;if(!c||!h(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=d;function h(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function S(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const o=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,P.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[291],De([1,0,3,6,2,30,11,82,5,7]),function(re,e,a,P,l,A,T,k,y,v){"use strict";var R,I,_,D,C,E,n,d,h,w,S,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends P.Disposable{constructor(f,i,s,u){super(),R.set(this,void 0),I.set(this,void 0),_.set(this,void 0),D.set(this,void 0),C.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,void 0),h.set(this,!0),w.set(this,void 0),S.set(this,!1),p.set(this,this._register(new a.Emitter)),this.onDidDispose=Ne(this,p,"f").event,t.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Ne(this,t,"f").event,Je(this,R,f,"f"),Je(this,I,i,"f"),Je(this,D,s,"f"),Je(this,_,u.viewType,"f"),Je(this,C,u.panelOptions,"f"),Je(this,d,u.viewColumn,"f"),Je(this,E,u.title,"f"),Je(this,w,u.active,"f")}dispose(){Ne(this,S,"f")||(Je(this,S,!0,"f"),Ne(this,p,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,R,"f")),Ne(this,D,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,D,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,_,"f")}get title(){return this.assertNotDisposed(),Ne(this,E,"f")}set title(f){this.assertNotDisposed(),Ne(this,E,"f")!==f&&(Je(this,E,f,"f"),Ne(this,I,"f").$setTitle(Ne(this,R,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ne(this,n,"f")}set iconPath(f){this.assertNotDisposed(),Ne(this,n,"f")!==f&&(Je(this,n,f,"f"),Ne(this,I,"f").$setIconPath(Ne(this,R,"f"),l.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ne(this,C,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,d,"f")=="number"&&Ne(this,d,"f")<0))return Ne(this,d,"f")}get active(){return this.assertNotDisposed(),Ne(this,w,"f")}get visible(){return this.assertNotDisposed(),Ne(this,h,"f")}_updateViewState(f){Ne(this,S,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,w,f.active,"f"),Je(this,h,f.visible,"f"),Je(this,d,f.viewColumn,"f"),Ne(this,t,"f").fire({webviewPanel:this}))}reveal(f,i){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,R,"f"),{viewColumn:typeof f>"u"?void 0:T.ViewColumn.from(f),preserveFocus:!!i})}assertNotDisposed(){if(Ne(this,S,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,I=new WeakMap,_=new WeakMap,D=new WeakMap,C=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,A.generateUuid)()}constructor(f,i,s){this.webviews=i,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,i,s,u,b={}){const g=typeof u=="object"?u.viewColumn:u,L={viewColumn:T.ViewColumn.from(g),preserveFocus:typeof u=="object"&&!!u.preserveFocus},H=(0,k.shouldSerializeBuffersForPostMessage)(f),q=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(f),q,i,{title:s,panelOptions:c(b),webviewOptions:(0,k.serializeWebviewOptions)(f,this.workspace,b),serializeBuffersForPostMessage:H},L);const X=this.webviews.createNewWebview(q,b,f);return this.createNewWebviewPanel(q,i,s,g,b,X,!0)}$onDidChangeWebviewPanelViewStates(f){const i=Object.keys(f);i.sort((s,u)=>{const b=f[s],g=f[u];return b.active?1:g.active?-1:+b.visible-+g.visible});for(const s of i){const u=this.getWebviewPanel(s);if(!u)continue;const b=f[s];u._updateViewState({active:b.active,visible:b.visible,viewColumn:T.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,i,s){if(this._serializers.has(i))throw new Error(`Serializer for '${i}' already registered`);return this._serializers.set(i,{serializer:s,extension:f}),this._proxy.$registerSerializer(i,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(f)}),new v.Disposable(()=>{this._serializers.delete(i),this._proxy.$unregisterSerializer(i)})}async $deserializeWebviewPanel(f,i,s,u){const b=this._serializers.get(i);if(!b)throw new Error(`No serializer found for '${i}'`);const{serializer:g,extension:L}=b,H=this.webviews.createNewWebview(f,s.webviewOptions,L),q=this.createNewWebviewPanel(f,i,s.title,u,s.panelOptions,H,s.active);await g.deserializeWebviewPanel(q,s.state)}createNewWebviewPanel(f,i,s,u,b,g,L){const H=new o(f,this._proxy,g,{viewType:i,title:s,viewColumn:u,panelOptions:b,active:L});return this._webviewPanels.set(f,H),H}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function c(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[292],De([1,0,3,6,82,11,5,7]),function(re,e,a,P,l,A,T,k){"use strict";var y,v,R,I,_,D,C,E,n,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends P.Disposable{constructor(t,o,r,c,m,f){super(),y.set(this,void 0),v.set(this,void 0),R.set(this,void 0),I.set(this,void 0),_.set(this,!1),D.set(this,void 0),C.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Ne(this,d,"f").event,h.set(this,this._register(new a.Emitter)),this.onDidDispose=Ne(this,h,"f").event,Je(this,R,r,"f"),Je(this,C,c,"f"),Je(this,y,t,"f"),Je(this,v,o,"f"),Je(this,I,m,"f"),Je(this,D,f,"f")}dispose(){Ne(this,_,"f")||(Je(this,_,!0,"f"),Ne(this,h,"f").fire(),Ne(this,I,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,C,"f")}set title(t){this.assertNotDisposed(),Ne(this,C,"f")!==t&&(Je(this,C,t,"f"),Ne(this,v,"f").$setWebviewViewTitle(Ne(this,y,"f"),t))}get description(){return this.assertNotDisposed(),Ne(this,E,"f")}set description(t){this.assertNotDisposed(),Ne(this,E,"f")!==t&&(Je(this,E,t,"f"),Ne(this,v,"f").$setWebviewViewDescription(Ne(this,y,"f"),t))}get visible(){return Ne(this,D,"f")}get webview(){return Ne(this,I,"f")}get viewType(){return Ne(this,R,"f")}_setVisible(t){t===Ne(this,D,"f")||Ne(this,_,"f")||(Je(this,D,t,"f"),Ne(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Ne(this,n,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Ne(this,n,"f")?.value&&t?.tooltip===Ne(this,n,"f")?.tooltip)&&(Je(this,n,A.ViewBadge.from(t),"f"),Ne(this,v,"f").$setWebviewViewBadge(Ne(this,y,"f"),t))}show(t){this.assertNotDisposed(),Ne(this,v,"f").$show(Ne(this,y,"f"),!!t)}assertNotDisposed(){if(Ne(this,_,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,v=new WeakMap,R=new WeakMap,I=new WeakMap,_=new WeakMap,D=new WeakMap,C=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap;class S{constructor(t,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,o,r,c){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,l.toExtensionData)(t),o,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(t)}),new k.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(t,o,r,c,m){const f=this._viewProviders.get(o);if(!f)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:s}=f,u=this._extHostWebview.createNewWebview(t,{},s),b=new w(t,this._proxy,o,r,u,!0);this._webviewViews.set(t,b),await i.resolveWebviewView(b,{state:c},m)}async $onDidChangeWebviewViewVisibility(t,o){this.getWebviewView(t)._setVisible(o)}async $disposeWebviewView(t){const o=this.getWebviewView(t);this._webviewViews.delete(t),o.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const o=this._webviewViews.get(t);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=S}),define(Ce[142],De([1,0,3,5,2,17,9,4,20]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let v=class fn{get state(){return this._state}constructor(I){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=fn.InitialState,this._proxy=I.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,_){let D;if(typeof I=="string"){D=I;try{I=l.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,D,_)}async asExternalUri(I,_){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this._proxy.$asExternalUri(I,_);return l.URI.from(D)}};v.InitialState={focused:!0},v=$e([Be(0,y.IExtHostRpcService)],v),e.ExtHostWindow=v,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(Ce[293],De([1,0,120,294,71,41,2,16,48]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class v{constructor(_,D,C){this._commands=_,this.logService=D,this._ipcHandlePath=C,this._server=P.createServer((E,n)=>this.onRequest(E,n)),this.setup().catch(E=>(D.error(E),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,D){const C=(n,d)=>{D.writeHead(n,{"content-type":"application/json"}),D.end(JSON.stringify(d||null),h=>h&&this.logService.error(h))},E=[];_.setEncoding("utf8"),_.on("data",n=>E.push(n)),_.on("end",async()=>{try{const n=JSON.parse(E.join(""));let d;switch(n.type){case"open":d=await this.open(n);break;case"openExternal":d=await this.openExternal(n);break;case"status":d=await this.getStatus(n);break;case"extensionManagement":d=await this.manageExtensions(n);break;default:C(404,`Unknown message type: ${n.type}`);break}C(200,d)}catch(n){const d=n instanceof Error?n.message:JSON.stringify(n);C(500,d),this.logService.error("Error while processing pipe request",n)}})}async open(_){const{fileURIs:D,folderURIs:C,forceNewWindow:E,diffMode:n,mergeMode:d,addMode:h,forceReuseWindow:w,gotoLineMode:S,waitMarkerFilePath:p,remoteAuthority:t}=_,o=[];if(Array.isArray(C))for(const f of C)try{o.push({folderUri:T.URI.parse(f)})}catch{}if(Array.isArray(D))for(const f of D)try{(0,y.hasWorkspaceFileExtension)(f)?o.push({workspaceUri:T.URI.parse(f)}):o.push({fileUri:T.URI.parse(f)})}catch{}const r=p?T.URI.file(p):void 0,m={forceNewWindow:E,diffMode:n,mergeMode:d,addMode:h,gotoLineMode:S,forceReuseWindow:w,preferNewWindow:!w&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this._commands.executeCommand("_remoteCLI.windowOpen",o,m),""}async openExternal(_){for(const D of _.uris){const C=T.URI.parse(D),E=C.scheme==="file"?C:D;await this._commands.executeCommand("_remoteCLI.openExternal",E)}}async manageExtensions(_){const D=E=>E?.map(n=>/\.vsix$/i.test(n)?T.URI.parse(n):n),C={list:_.list,install:D(_.install),uninstall:D(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&l.existsSync(this._ipcHandlePath)&&l.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=v;let R=class extends v{constructor(_,D){super(_,D,(0,a.createRandomIPCHandle)())}};R=$e([Be(0,A.IExtHostCommands),Be(1,k.ILogService)],R),e.CLIServer=R}),define(Ce[295],De([1,0,263,26,20]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let T=class extends a.AbstractExtHostConsoleForwarder{constructor(y,v){super(y,v),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(y,v,R){const I=y==="error"||y==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),v.apply(console,R),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(y,v){const R=process[y],I=R.write;let _="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(D,C,E)=>{if(!this._isMakingConsoleCall){_+=D.toString(C);const n=_.length>A?_.length:_.lastIndexOf(`
`);n!==-1&&(console[v](_.slice(0,n)),_=_.slice(n+1))}I.call(R,D,C,E)}})}};T=$e([Be(0,l.IExtHostRpcService),Be(1,P.IExtHostInitDataService)],T),e.ExtHostConsoleForwarder=T}),define(Ce[296],De([1,0,15,72,30,41,6,5,2,20]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(_,D){super();const C=_.getProxy(k.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async E=>{const n=y.URI.file((0,a.join)((0,P.tmpdir)(),(0,l.generateUuid)()));return await C.$download(E,n),n})}};R=$e([Be(0,v.IExtHostRpcService),Be(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Ce[297],De([1,0,141,17,212,30]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends a.ExtHostLoggerService{doCreateLogger(y,v,R){return y.scheme===P.Schemas.file?new l.SpdLogLogger(R?.name||(0,A.generateUuid)(),y.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.doCreateLogger(y,v,R)}registerLogger(y){super.registerLogger(y),this._proxy.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this._proxy.$deregisterLogger(y)}}e.ExtHostLoggerService=T}),define(Ce[298],De([1,0,71,15,2,81,6,17,19,29]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const o=await super._getWorkspaceStorageURI(t);if(o.scheme!==k.Schemas.file)return o;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const r=o.fsPath;let c=0;do{let m;c===0?m=r:m=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await I(m);const f=P.join(m,"vscode.lock"),i=await E(this._logService,f,!1);if(i)return this._workspaceStorageLock=i,process.on("exit",()=>{i.dispose()}),l.URI.file(m);c++}while(c<10);return o}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function I(p){try{await v.Promises.stat(p);return}catch{}try{await v.Promises.mkdir(p,{recursive:!0})}catch{}}const _=1e3,D=10*60*1e3;class C extends T.Disposable{constructor(t,o){super(),this.logService=t,this.filename=o,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await n(t,o);(!r||r.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this._timer.cancel());try{await v.Promises.utimes(o,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${o}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{a.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.filename,JSON.stringify(o),{flag:"w"})}catch(o){this.logService.error(o)}}}async function E(p,t,o){try{const c={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const r=await n(p,t);return!r||r.pid!==process.pid?o?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),w(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new C(p,t))}async function n(p,t){let o;try{o=await v.Promises.readFile(t)}catch(r){return p.error(r),null}try{return JSON.parse(String(o))}catch(r){return p.error(r),null}}async function d(p,t){let o;try{o=await v.Promises.stat(t)}catch(r){return p.error(r),0}return o.mtime.getTime()}function h(p){try{return process.kill(p,0),!0}catch{return!1}}async function w(p,t){const o=await n(p,t);if(!o)return p.info(`Lock '${t}': Could not read pid of lock holder.`),S(p,t);if(o.willReleaseAt){let i=o.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,y.timeout)(Math.min(100,i)),await d(p,t)===0)return S(p,t);i=o.willReleaseAt-Date.now()}return S(p,t)}}if(!h(o.pid))return p.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),S(p,t);const r=await d(p,t),c=Date.now()-r;if(c<=D)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const m=await d(p,t),f=Date.now()-m;return f<=D?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),S(p,t))}async function S(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return E(p,t,!0)}}),define(Ce[299],De([1,0,30,20,42]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends l.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,y,v){return this.createTerminalFromOptions({name:k,shellPath:y,shellArgs:v})}createTerminalFromOptions(k,y){const v=new l.ExtHostTerminal(this._proxy,(0,a.generateUuid)(),k,k.name);return this._terminals.push(v),v.create(k,this._serializeParentTerminal(k,y)),v.value}};A=$e([Be(0,P.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Ce[300],De([1,0,5,20,192,6,26,2,47,24,29,7,14,55,3,130,103,16]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class h extends E.DisposableTunnel{}function w(i){const s=i.trim().split(`
`),u=[];return s.forEach(g=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(g);L&&L.length>=3&&u.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),u.reduce((g,L)=>(g[L.socket]=L,g),{})}e.getSockets=w;function S(...i){const s=[].concat(...i.map(t));return[...new Map(s.filter(u=>u.st==="0A").map(u=>{const b=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:p(b[0]),port:parseInt(b[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=S;function p(i){let s="";if(i.length===8)for(let u=i.length-2;u>=0;u-=2)s+=parseInt(i.substr(u,2),16),u!==0&&(s+=".");else for(let u=0;u<i.length;u+=8){const b=i.substring(u,u+8);let g="";for(let L=8;L>=2;L-=2)g+=b.substring(L-2,L),(L===6||L===2)&&(g=parseInt(g,16).toString(16),s+=`${g}`,g="",u+L!==i.length-6&&(s+=":"))}return s}e.parseIpAddress=p;function t(i){const s=i.trim().split(`
`),u=s.shift().trim().split(/\s+/).filter(g=>g!=="rx_queue"&&g!=="tm->when");return s.map(g=>g.trim().split(/\s+/).reduce((L,H,q)=>(L[u[q]||q]=H,L),{}))}e.loadConnectionTable=t;function o(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const s=i.trim().split(`
`),u=[];return s.forEach(b=>{const g=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);g&&g.length>=4&&u.push({pid:parseInt(g[1],10),ppid:parseInt(g[2]),cmd:g[3]})}),u}e.getRootProcesses=r;async function c(i,s,u){const b=u.reduce((L,H)=>(L[H.pid]=H,L),{}),g=[];return i.forEach(({socket:L,ip:H,port:q})=>{const X=s[L]?s[L].pid:void 0,U=X?b[X]?.cmd:void 0;X&&U&&!o(U)&&g.push({host:H,port:q,detail:U,pid:X})}),g}e.findPorts=c;function m(i,s,u){const b=new Map,g=r(s);for(const L of i){const H=u.get(L.port);if(H){b.set(L.port,H);continue}const q=g.find(X=>X.cmd.includes(`${L.port}`));if(q){let X=q,U;do U=g.find(N=>N.ppid===X.pid),U&&(X=U);while(U);b.set(L.port,{host:L.ip,port:L.port,pid:X.pid,detail:X.cmd,ppid:X.ppid})}else b.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=m;let f=class extends A.Disposable{constructor(s,u,b){super(),this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new C.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._initialCandidates=void 0,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(a.MainContext.MainThreadTunnelService),_.isLinux&&u.remote.isRemote&&u.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async openTunnel(s,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(u,s.displayName);if(b){const g=new h(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(g),g}}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(s=>s.port).join(", ")}`)}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(s){return Math.max(s*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,u){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:s,provider:u}),this._proxy.$registerPortsAttributesProvider(s,b),new I.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(s,u,b,g,L){const H=[];for(const X of s){const U=this._portAttributesProviders.get(X);if(!U)return[];H.push(...await Promise.all(u.map(async N=>U.provider.providePortAttributes(N,b,g,L))))}const q=H.filter(X=>!!X);return q.length>0?q.map(X=>({autoForwardAction:X.autoForwardAction,port:X.port})):[]}async $registerCandidateFinder(s){if(s&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=s;let u;this._initialCandidates&&(u=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const b=new n.MovingAverage;let g=0;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),H=(await this.findCandidatePorts()).filter(U=>(0,E.isLocalhost)(U.host)||(0,E.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${H.map(U=>U.port).join(", ")}`);const q=new Date().getTime()-L;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${q} ms.`),g++>3&&b.update(q),(!u||JSON.stringify(u)!==JSON.stringify(H))&&(u=H,await this._proxy.$onFoundNewCandidates(u));const X=this.calculateDelay(b.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${X} ms.`),await new Promise(U=>setTimeout(()=>U(),X))}}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter()),s.tunnelFactory){this._forwardPortProvider=s.tunnelFactory;let u=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const b=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:u}:void 0;this._proxy.$setTunnelProvider(b)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(s,u){if(this._extensionTunnels.has(s.host)){const b=this._extensionTunnels.get(s.host);b.has(s.port)&&(u&&b.get(s.port).disposeListener.dispose(),await b.get(s.port).tunnel.dispose(),b.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(s,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const g=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const L=this._register(g.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(g.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:g,disposeListener:L}),D.TunnelDtoConverter.fromApiTunnel(g)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const u=await Promise.all(s.map(g=>this._showCandidatePort(g.host,g.port,g.detail??""))),b=s.filter((g,L)=>u[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(g=>g.port).join(", ")} to ${b.map(g=>g.port).join(", ")}`),b}async findCandidatePorts(){let s="",u="";try{s=await R.Promises.readFile("/proc/net/tcp","utf8"),u=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const b=S(s,u),g=await new Promise(F=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,fe,se)=>{F(fe)})}),L=w(g),H=await R.Promises.readdir("/proc"),q=[];for(const F of H)try{const V=Number(F),fe=v.joinPath(k.URI.file("/proc"),F);if((await R.Promises.stat(fe.fsPath)).isDirectory()&&!isNaN(V)){const $=await R.Promises.readlink(v.joinPath(fe,"cwd").fsPath),J=await R.Promises.readFile(v.joinPath(fe,"cmdline").fsPath,"utf8");q.push({pid:V,cwd:$,cmd:J})}}catch{}const X=[],U=b.filter(F=>{const V=L[F.socket];return V||X.push(F),V}),N=c(U,L,q);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${X.length}`),X.length>0){const F=await new Promise(V=>{(0,y.exec)("ps -F -A -l | grep root",(fe,se,$)=>{V(se)})});this._foundRootPorts=m(X,F,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.map(V=>V.port).join(", ")}`)}return N.then(F=>x?F.concat(x):F)}};f=$e([Be(0,P.IExtHostRpcService),Be(1,T.IExtHostInitDataService),Be(2,d.ILogService)],f),e.ExtHostTunnelService=f}),define(Ce[301],De([1,0,19,22,21,8,3,6,115,257,58]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(b,g){try{return JSON.stringify(b,g)}catch{return"null"}}const D="$$ref$$",C={[D]:-1};class E{constructor(g,L){this.jsonString=g,this.referencedBuffers=L}}function n(b,g=null,L=!1){const H=[];return{jsonString:(L?_:JSON.stringify)(b,(X,U)=>{if(typeof U>"u")return C;if(typeof U=="object"){if(U instanceof P.VSBuffer){const N=H.push(U)-1;return{[D]:N}}if(g)return g(X,U)}return U}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=n;function d(b,g,L){return JSON.parse(b,(H,q)=>{if(q){const X=q[D];if(typeof X=="number")return g[X];if(L&&q.$mid===1)return L.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=d;function h(b,g){return JSON.stringify(b,g)}function w(b){return b?(g,L)=>L&&L.$mid===1?b.transformOutgoing(L):L:null}var S;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends k.Disposable{constructor(g,L=null,H=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=g,this._logger=L,this._uriTransformer=H,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let q=0,X=R.ProxyIdentifier.count;q<X;q++)this._locals[q]=null,this._proxies[q]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(q=>this._receiveOneMessage(q))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(g=>{this._pendingRPCReplies[g].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(g){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(g){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(g){this._responsiveState!==g&&(this._responsiveState=g,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(g){return this._uriTransformer?(0,y.transformIncomingURIs)(g,this._uriTransformer):g}getProxy(g){const{nid:L,sid:H}=g;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,H)),this._proxies[L]}_createProxy(g,L){const H={get:(q,X)=>(typeof X=="string"&&!q[X]&&X.charCodeAt(0)===36&&(q[X]=(...U)=>this._remoteCall(g,X,U)),X===r?L:q[X])};return new Proxy(Object.create(null),H)}set(g,L){return this._locals[g.nid]=L,L}assertRegistered(g){for(let L=0,H=g.length;L<H;L++){const q=g[L];if(!this._locals[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}_receiveOneMessage(g){if(this._isDisposed)return;const L=g.byteLength,H=m.read(g,0),q=H.readUInt8(),X=H.readUInt32();switch(q){case 1:case 2:{let{rpcId:U,method:N,args:x}=i.deserializeRequestJSONArgs(H);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(L,X,U,N,x,q===2);break}case 3:case 4:{let{rpcId:U,method:N,args:x}=i.deserializeRequestMixedArgs(H);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(L,X,U,N,x,q===4);break}case 5:{this._logger?.logIncoming(L,X,0,"ack"),this._onDidReceiveAcknowledge(X);break}case 6:{this._receiveCancel(L,X);break}case 7:{this._receiveReply(L,X,void 0);break}case 9:{let U=i.deserializeReplyOKJSON(H);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(L,X,U);break}case 10:{const U=i.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(L,X,U);break}case 8:{const U=i.deserializeReplyOKVSBuffer(H);this._receiveReply(L,X,U);break}case 11:{let U=i.deserializeReplyErrError(H);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(L,X,U);break}case 12:{this._receiveReplyErr(L,X,void 0);break}default:console.error("received unexpected message"),console.error(g)}}_receiveRequest(g,L,H,q,X,U){this._logger?.logIncoming(g,L,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(H)}.${q}(`,X);const N=String(L);let x,F;if(U){const fe=new l.CancellationTokenSource;X.push(fe.token),x=this._invokeHandler(H,q,X),F=()=>fe.cancel()}else x=this._invokeHandler(H,q,X),F=t;this._cancelInvokedHandlers[N]=F;const V=i.serializeAcknowledged(L);this._logger?.logOutgoing(V.byteLength,L,1,"ack"),this._protocol.send(V),x.then(fe=>{delete this._cancelInvokedHandlers[N];const se=i.serializeReplyOK(L,fe,this._uriReplacer);this._logger?.logOutgoing(se.byteLength,L,1,"reply:",fe),this._protocol.send(se)},fe=>{delete this._cancelInvokedHandlers[N];const se=i.serializeReplyErr(L,fe);this._logger?.logOutgoing(se.byteLength,L,1,"replyErr:",fe),this._protocol.send(se)})}_receiveCancel(g,L){this._logger?.logIncoming(g,L,1,"receiveCancel");const H=String(L);this._cancelInvokedHandlers[H]?.()}_receiveReply(g,L,H){this._logger?.logIncoming(g,L,0,"receiveReply:",H);const q=String(L);if(!this._pendingRPCReplies.hasOwnProperty(q))return;const X=this._pendingRPCReplies[q];delete this._pendingRPCReplies[q],X.resolveOk(H)}_receiveReplyErr(g,L,H){this._logger?.logIncoming(g,L,0,"receiveReplyErr:",H);const q=String(L);if(!this._pendingRPCReplies.hasOwnProperty(q))return;const X=this._pendingRPCReplies[q];delete this._pendingRPCReplies[q];let U;H&&(H.$isError?(U=new Error,U.name=H.name,U.message=H.message,U.stack=H.stack):U=H),X.resolveErr(U)}_invokeHandler(g,L,H){try{return Promise.resolve(this._doInvokeHandler(g,L,H))}catch(q){return Promise.reject(q)}}_doInvokeHandler(g,L,H){const q=this._locals[g];if(!q)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(g));const X=q[L];if(typeof X!="function")throw new Error("Unknown method "+L+" on actor "+(0,R.getStringIdentifierForProxy)(g));return X.apply(q,H)}_remoteCall(g,L,H){if(this._isDisposed)return new v.CanceledLazyPromise;let q=null;if(H.length>0&&l.CancellationToken.isCancellationToken(H[H.length-1])&&(q=H.pop()),q&&q.isCancellationRequested)return Promise.reject(A.canceled());const X=i.serializeRequestArguments(H,this._uriReplacer),U=++this._lastMessageId,N=String(U),x=new v.LazyPromise;q&&q.onCancellationRequested(()=>{const V=i.serializeCancel(U);this._logger?.logOutgoing(V.byteLength,U,0,"cancel"),this._protocol.send(i.serializeCancel(U))}),this._pendingRPCReplies[N]=x,this._onWillSendRequest(U);const F=i.serializeRequest(U,g,L,X,!!q);return this._logger?.logOutgoing(F.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(g)}.${L}(`,H),this._protocol.send(F),x}}I=o,c.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=c;class m{static alloc(g,L,H){const q=new m(P.VSBuffer.alloc(H+1+4),0);return q.writeUInt8(g),q.writeUInt32(L),q}static read(g,L){return new m(g,L)}get buffer(){return this._buff}constructor(g,L){this._buff=g,this._offset=L}static sizeUInt8(){return 1}writeUInt8(g){this._buff.writeUInt8(g,this._offset),this._offset+=1}readUInt8(){const g=this._buff.readUInt8(this._offset);return this._offset+=1,g}writeUInt32(g){this._buff.writeUInt32BE(g,this._offset),this._offset+=4}readUInt32(){const g=this._buff.readUInt32BE(this._offset);return this._offset+=4,g}static sizeShortString(g){return 1+g.byteLength}writeShortString(g){this._buff.writeUInt8(g.byteLength,this._offset),this._offset+=1,this._buff.set(g,this._offset),this._offset+=g.byteLength}readShortString(){const g=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+g).toString();return this._offset+=g,H}static sizeLongString(g){return 4+g.byteLength}writeLongString(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}readLongString(){const g=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+g).toString();return this._offset+=g,H}writeBuffer(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}static sizeVSBuffer(g){return 4+g.byteLength}writeVSBuffer(g){this._buff.writeUInt32BE(g.byteLength,this._offset),this._offset+=4,this._buff.set(g,this._offset),this._offset+=g.byteLength}readVSBuffer(){const g=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+g);return this._offset+=g,L}static sizeMixedArray(g){let L=0;L+=1;for(let H=0,q=g.length;H<q;H++){const X=g[H];switch(L+=1,X.type){case 1:L+=this.sizeLongString(X.value);break;case 2:L+=this.sizeVSBuffer(X.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(X.value);for(let U=0;U<X.buffers.length;++U)L+=this.sizeVSBuffer(X.buffers[U]);break;case 4:break}}return L}writeMixedArray(g){this._buff.writeUInt8(g.length,this._offset),this._offset+=1;for(let L=0,H=g.length;L<H;L++){const q=g[L];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let X=0;X<q.buffers.length;++X)this.writeBuffer(q.buffers[X]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const g=this._buff.readUInt8(this._offset);this._offset+=1;const L=new Array(g);for(let H=0;H<g;H++)switch(this.readUInt8()){case 1:L[H]=this.readLongString();break;case 2:L[H]=this.readVSBuffer();break;case 3:{const X=this.readUInt32(),U=this.readLongString(),N=[];for(let x=0;x<X;++x)N.push(this.readVSBuffer());L[H]=new R.SerializableObjectWithBuffers(d(U,N,null));break}case 4:L[H]=void 0;break}return L}}m.sizeUInt32=4;var f;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(f||(f={}));class i{static _useMixedArgSerialization(g){for(let L=0,H=g.length;L<H;L++)if(g[L]instanceof P.VSBuffer||g[L]instanceof R.SerializableObjectWithBuffers||typeof g[L]>"u")return!0;return!1}static serializeRequestArguments(g,L){if(this._useMixedArgSerialization(g)){const H=[];for(let q=0,X=g.length;q<X;q++){const U=g[q];if(U instanceof P.VSBuffer)H[q]={type:2,value:U};else if(typeof U>"u")H[q]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:x}=n(U.value,L);H[q]={type:3,value:P.VSBuffer.fromString(N),buffers:x}}else H[q]={type:1,value:P.VSBuffer.fromString(h(U,L))}}return{type:1,args:H}}return{type:0,args:h(g,L)}}static serializeRequest(g,L,H,q,X){switch(q.type){case 0:return this._requestJSONArgs(g,L,H,q.args,X);case 1:return this._requestMixedArgs(g,L,H,q.args,X)}}static _requestJSONArgs(g,L,H,q,X){const U=P.VSBuffer.fromString(H),N=P.VSBuffer.fromString(q);let x=0;x+=m.sizeUInt8(),x+=m.sizeShortString(U),x+=m.sizeLongString(N);const F=m.alloc(X?2:1,g,x);return F.writeUInt8(L),F.writeShortString(U),F.writeLongString(N),F.buffer}static deserializeRequestJSONArgs(g){const L=g.readUInt8(),H=g.readShortString(),q=g.readLongString();return{rpcId:L,method:H,args:JSON.parse(q)}}static _requestMixedArgs(g,L,H,q,X){const U=P.VSBuffer.fromString(H);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(U),N+=m.sizeMixedArray(q);const x=m.alloc(X?4:3,g,N);return x.writeUInt8(L),x.writeShortString(U),x.writeMixedArray(q),x.buffer}static deserializeRequestMixedArgs(g){const L=g.readUInt8(),H=g.readShortString(),q=g.readMixedArray(),X=new Array(q.length);for(let U=0,N=q.length;U<N;U++){const x=q[U];typeof x=="string"?X[U]=JSON.parse(x):X[U]=x}return{rpcId:L,method:H,args:X}}static serializeAcknowledged(g){return m.alloc(5,g,0).buffer}static serializeCancel(g){return m.alloc(6,g,0).buffer}static serializeReplyOK(g,L,H){if(typeof L>"u")return this._serializeReplyOKEmpty(g);if(L instanceof P.VSBuffer)return this._serializeReplyOKVSBuffer(g,L);if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:X}=n(L.value,H,!0);return this._serializeReplyOKJSONWithBuffers(g,q,X)}else return this._serializeReplyOKJSON(g,_(L,H))}static _serializeReplyOKEmpty(g){return m.alloc(7,g,0).buffer}static _serializeReplyOKVSBuffer(g,L){let H=0;H+=m.sizeVSBuffer(L);const q=m.alloc(8,g,H);return q.writeVSBuffer(L),q.buffer}static deserializeReplyOKVSBuffer(g){return g.readVSBuffer()}static _serializeReplyOKJSON(g,L){const H=P.VSBuffer.fromString(L);let q=0;q+=m.sizeLongString(H);const X=m.alloc(9,g,q);return X.writeLongString(H),X.buffer}static _serializeReplyOKJSONWithBuffers(g,L,H){const q=P.VSBuffer.fromString(L);let X=0;X+=m.sizeUInt32,X+=m.sizeLongString(q);for(const N of H)X+=m.sizeVSBuffer(N);const U=m.alloc(10,g,X);U.writeUInt32(H.length),U.writeLongString(q);for(const N of H)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(g){const L=g.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(g,L){const H=g.readUInt32(),q=g.readLongString(),X=[];for(let U=0;U<H;++U)X.push(g.readVSBuffer());return new R.SerializableObjectWithBuffers(d(q,X,L))}static serializeReplyErr(g,L){const H=L?_(A.transformErrorForSerialization(L),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(g);const q=P.VSBuffer.fromString(H);let X=0;X+=m.sizeLongString(q);const U=m.alloc(11,g,X);return U.writeLongString(q),U.buffer}static deserializeReplyErrError(g){const L=g.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(g){return m.alloc(12,g,0).buffer}}var s;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var u;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(u||(u={}))}),define(Ce[302],De([1,0,3,40,44,4]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var T;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(T=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class k{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(v){this.channels.has(v.id)||(this.channels.set(v.id,v),this._onDidRegisterChannel.fire(v.id))}getChannels(){const v=[];return this.channels.forEach(R=>v.push(R)),v}getChannel(v){return this.channels.get(v)}removeChannel(v){this.channels.delete(v),this._onDidRemoveChannel.fire(v)}}P.Registry.add(e.Extensions.OutputChannels,new k),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(Ce[143],De([1,0,5,4,20,25,16,302,80,26,49,160,22,10,45,3,6]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,t,o,r,c){super(),this.id=p,this.name=t,this.logger=o,this.proxy=r,this.extension=c,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(o.getLevel()),this._register(o.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.offset;this.info(p),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(p,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.proxy.$close(this.id)}log(p,t){this.offset+=_.VSBuffer.fromString(t).byteLength,(0,T.log)(this.logger,p,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class h extends d{appendLine(p){this.append(p)}}let w=class{constructor(p,t,o,r,c,m){this.initData=t,this.extHostFileSystem=o,this.extHostFileSystemInfo=r,this.loggerService=c,this.logService=m,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[t,o]of this.channels)o.visible=t===this.visibleChannelId}createOutputChannel(p,t,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,D.isString)(t)?t:void 0;if((0,D.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.initData.environment.extensionLogLevel?.find(([s])=>A.ExtensionIdentifier.equals(o.identifier,s))?.[1];f&&(m=(0,T.parseLogLevel)(f));const i=r?this.doCreateLogOutputChannel(p,m,o):this.doCreateOutputChannel(p,c,o);return i.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(p,m??this.logService.getLevel(),i):this.createExtHostOutputChannel(p,i)}async doCreateOutputChannel(p,t,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,c=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.loggerService.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.proxy.$register(p,c,t,o.identifier.value);return new d(f,p,m,this.proxy,o)}async doCreateLogOutputChannel(p,t,o){const r=await this.createExtensionLogDirectory(o),c=p.replace(/[\\/:\*\?"<>\|]/g,""),m=this.extHostFileSystemInfo.extUri.joinPath(r,`${c}.log`),f=`${o.identifier.value}.${c}`,i=this.loggerService.createLogger(m,{id:f,name:p,logLevel:t,extensionId:o.identifier.value});return new h(f,p,i,this.proxy,o)}createExtensionLogDirectory(p){let t=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!t){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileExists)throw r}return o})())}return t}createExtHostOutputChannel(p,t){let o=!1;const r=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(c){r(),t.then(m=>m.append(c))},appendLine(c){r(),t.then(m=>m.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(m=>m.replace(c))},show(c,m){r(),t.then(f=>f.show(c,m))},hide(){r(),t.then(c=>c.hide())},dispose(){o=!0,t.then(c=>c.dispose())}}}createExtHostLogOutputChannel(p,t,o){const r=new n.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},m=r.add(new E.Emitter);function f(i){t=i,m.fire(i)}return o.then(i=>{r.add(i),i.logLevel!==t&&f(i.logLevel),r.add(i.onDidChangeLogLevel(s=>f(s)))}),{...this.createExtHostOutputChannel(p,o),get logLevel(){return t},onDidChangeLogLevel:m.event,trace(i,...s){c(),o.then(u=>u.trace(i,...s))},debug(i,...s){c(),o.then(u=>u.debug(i,...s))},info(i,...s){c(),o.then(u=>u.info(i,...s))},warn(i,...s){c(),o.then(u=>u.warn(i,...s))},error(i,...s){c(),o.then(u=>u.error(i,...s))},dispose(){r.dispose()}}}};w=$e([Be(0,l.IExtHostRpcService),Be(1,v.IExtHostInitDataService),Be(2,y.IExtHostConsumerFileSystem),Be(3,R.IExtHostFileSystemInfo),Be(4,T.ILoggerService),Be(5,T.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(Ce[303],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ce[304],De([1,0,34,17,15,14,24,2,4,225,48,243,303]),function(re,e,a,P,l,A,T,k,y,v,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class mn{constructor(E,n,d,h){this.localUserHome=E,this.remoteAgentService=n,this.environmentService=d,this.contextService=h,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??E})()}hasValidBasename(E,n,d){return typeof n=="string"||typeof n>"u"?this.resolveOS.then(h=>this.doHasValidBasename(E,h,n)):this.doHasValidBasename(E,n,d)}doHasValidBasename(E,n,d){return E.scheme===P.Schemas.file||E.scheme===P.Schemas.vscodeRemote?(0,a.isValidBasename)(d??(0,T.basename)(E),n===1):!0}get defaultUriScheme(){return mn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,n){if(E.remoteAuthority)return P.Schemas.vscodeRemote;const d=(0,v.getVirtualWorkspaceScheme)(n.getWorkspace());if(d)return d;const h=n.getWorkspace().folders[0];if(h)return h.uri.scheme;const w=n.getWorkspace().configuration;return w?w.scheme:P.Schemas.file}userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?l.win32:l.posix)}async fileURI(E){let n="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const h=E.indexOf("/",2);h===-1?(n=E.substring(2),E="/"):(n=E.substring(2,h),E=E.substring(h)||"/")}return k.URI.from({scheme:P.Schemas.file,authority:n,path:E,query:"",fragment:""})}};D=$e([Be(1,_.IRemoteAgentService),Be(2,I.IWorkbenchEnvironmentService),Be(3,R.IWorkspaceContextService)],D),e.AbstractPathService=D}),define(Ce[83],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(T,k){this.line=T,this.character=k}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,k){return new a(0,0)}with(T){return new a(0,0)}}e.Position=a;class P{constructor(T,k,y,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(T,k),this.end=new a(y,v)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new P(0,0,0,0)}with(T){return new P(0,0,0,0)}}e.Range=P;var l;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[31],De([1,0,18,39,23,34,9,4,15,8,83,19]),function(re,e,a,P,l,A,T,k,y,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",D=" characters skipped \u27EB",C=(_.length+D.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var E;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(E=e.SearchProviderType||(e.SearchProviderType={}));var n;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(n=e.QueryType||(e.QueryType={}));function d(J){return!!J.preview}e.resultIsMatch=d;function h(J){return!!J.resource}e.isFileMatch=h;function w(J){return!!J.message}e.isProgressMessage=w;var S;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(S=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=p;class t{constructor(te,be,le){this.ranges=be;const ue=Array.isArray(be)?be:[be];if(le&&le.matchLines===1&&o(ue)){te=(0,T.getNLines)(te,le.matchLines);let j="",M=0,Y=0;const ge=Math.floor(le.charsPerLine/5),we=[];for(const ie of ue){const ne=Math.max(ie.startColumn-ge,0),de=ie.startColumn+le.charsPerLine;if(ne>Y+ge+C){const ee=_+(ne-Y)+D;j+=ee+te.slice(ne,de),M+=ne-(Y+ee.length)}else j+=te.slice(Y,de);we.push(new c(0,ie.startColumn-M,ie.endColumn-M)),Y=de}this.preview={text:j,matches:Array.isArray(this.ranges)?we:we[0]}}else{const j=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:te,matches:(0,a.mapArrayOrNot)(be,M=>new r(M.startLineNumber-j,M.startColumn,M.endLineNumber-j,M.endColumn))}}}}e.TextSearchMatch=t;function o(J){const te=J[0].startLineNumber;for(const be of J)if(be.startLineNumber!==te||be.endLineNumber!==te)return!1;return!0}class r{constructor(te,be,le,ue){this.startLineNumber=te,this.startColumn=be,this.endLineNumber=le,this.endColumn=ue}}e.SearchRange=r;class c extends r{constructor(te,be,le){super(te,be,te,le)}}e.OneLineRange=c;var m;(function(J){J.List="list",J.Tree="tree"})(m=e.ViewMode||(e.ViewMode={}));var f;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,te=!0){const be=J&&J.files&&J.files.exclude,le=te&&J&&J.search&&J.search.exclude;if(!be&&!le)return;if(!be||!le)return be||le;let ue=Object.create(null);return ue=l.mixin(ue,l.deepClone(be)),ue=l.mixin(ue,l.deepClone(le),!0),ue}e.getExcludes=i;function s(J,te){return J.excludePattern&&P.match(J.excludePattern,te)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&P.match(J.includePattern,te)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(be=>{const le=be.folder.fsPath;if(A.isEqualOrParent(te,le)){const ue=y.relative(le,te);return!be.includePattern||!!P.match(be.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var u;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(te,be){super(te),this.code=be}}e.SearchError=b;function g(J){const te=J.message;if((0,v.isCancellationError)(J))return new b(te,u.canceled);try{const be=JSON.parse(te);return new b(be.message,be.code)}catch{return new b(te,u.other)}}e.deserializeSearchError=g;function L(J){const te={message:J.message,code:J.code};return new Error(JSON.stringify(te))}e.serializeSearchError=L;function H(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=H;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function X(J){return!!J.path}e.isSerializedFileMatch=X;function U(J,te){const be=J.searchPath?J.searchPath:J.relativePath;return(0,T.fuzzyContains)(be,te)}e.isFilePatternMatch=U;class N{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function x(J,te){const be={...J||{},...te||{}};return Object.keys(be).filter(le=>{const ue=be[le];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=x;class F{constructor(te,be){this._parsedIncludeExpression=null,this._excludeExpression={...te.excludePattern||{},...be.excludePattern||{}},this._parsedExcludeExpression=P.parse(this._excludeExpression);let le=te.includePattern;be.includePattern&&(le?le={...le,...be.includePattern}:le=be.includePattern),le&&(this._parsedIncludeExpression=P.parse(le))}matchesExcludesSync(te,be,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,be,le))}includedInQuerySync(te,be,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,be,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(te,be,le))}includedInQuery(te,be,le){const ue=this._parsedExcludeExpression(te,be,le),j=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(te,be,le):!0;return(0,I.isThenable)(ue)?ue.then(M=>M?!1:j()):j()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=F;function V(J){for(const te in J)if(typeof J[te]!="boolean")return!0;return!1}function fe(J){if(!J)return;let te;return be=>(te||(te=(J()||Promise.resolve([])).then(le=>le?$(le):{})),te.then(le=>!!le[be]))}e.hasSiblingPromiseFn=fe;function se(J){if(!J)return;let te;return be=>{if(!te){const le=J();te=le?$(le):{}}return!!te[be]}}e.hasSiblingFn=se;function $(J){const te={};for(const be of J)te[be]=!0;return te}}),define(Ce[35],De([1,0,18,19,21,3,6,69,17,103,24,9,10,2,190,4,16,213,48,49,26,20,11,7,56,31,5]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t,o,r,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(q,X,U){return new R.ExtUri(N=>b(N,U)).isEqual(q,X)}function i(q,X,U){return f(q.uri,X.uri,U)?0:(0,I.compare)(q.uri.toString(),X.uri.toString())}function s(q,X,U){return q.index!==X.index?q.index<X.index?-1:1:f(q.uri,X.uri,U)?(0,I.compare)(q.name,X.name):(0,I.compare)(q.uri.toString(),X.uri.toString())}function u(q,X,U,N){const x=q.slice(0).sort((V,fe)=>U(V,fe,N)),F=X.slice(0).sort((V,fe)=>U(V,fe,N));return(0,a.delta)(x,F,(V,fe)=>U(V,fe,N))}function b(q,X){const U=X.getCapabilities(q.scheme);return!(U&&U&1024)}class g extends h.Workspace{static toExtHostWorkspace(X,U,N,x){if(!X)return{workspace:null,added:[],removed:[]};const{id:F,name:V,folders:fe,configuration:se,transient:$,isUntitled:J}=X,te=[],be=U;U?fe.forEach((M,Y)=>{const ge=D.URI.revive(M.uri),we=g._findFolder(N||U,ge,x);we?(we.name=M.name,we.index=M.index,te.push(we)):te.push({uri:ge,name:M.name,index:Y})}):te.push(...fe.map(({uri:M,name:Y,index:ge})=>({uri:D.URI.revive(M),name:Y,index:ge}))),te.sort((M,Y)=>M.index<Y.index?-1:1);const le=new g(F,V,te,!!$,se?D.URI.revive(se):null,!!J,M=>b(M,x)),{added:ue,removed:j}=u(be?be.workspaceFolders:[],le.workspaceFolders,i,x);return{workspace:le,added:ue,removed:j}}static _findFolder(X,U,N){for(let x=0;x<X.folders.length;x++){const F=X.workspaceFolders[x];if(f(F.uri,U,N))return F}}constructor(X,U,N,x,F,V,fe){super(X,N.map(se=>new h.WorkspaceFolder(se)),x,F,fe),this._name=U,this._isUntitled=V,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(fe),N.forEach(se=>{this._workspaceFolders.push(se),this._structure.set(se.uri,se)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(X,U){return U&&this._structure.get(X)&&(X=(0,R.dirname)(X)),this._structure.findSubstr(X)}resolveWorkspaceFolder(X){return this._structure.get(X)}}let L=class{constructor(X,U,N,x,F){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._logService=x,this._extHostFileSystemInfo=N,this._uriTransformerService=F,this._requestIdProvider=new v.Counter,this._barrier=new P.Barrier,this._proxy=X.getProxy(m.MainContext.MainThreadWorkspace),this._messageService=X.getProxy(m.MainContext.MainThreadMessageService);const V=U.workspace;this._confirmedWorkspace=V?new g(V.id,V.name,[],!!V.transient,V.configuration?D.URI.revive(V.configuration):null,!!V.isUntitled,fe=>b(fe,N)):void 0}$initializeWorkspace(X,U){this._trusted=U,this.$acceptWorkspaceData(X),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?D.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(X,U,N,...x){const F=[];if(Array.isArray(x)&&x.forEach(J=>{D.URI.isUri(J.uri)&&!F.some(te=>f(te.uri,J.uri,this._extHostFileSystemInfo))&&F.push({uri:J.uri,name:J.name||(0,R.basenameOrAuthority)(J.uri)})}),this._unconfirmedWorkspace||[U,N].some(J=>typeof J!="number"||J<0)||N===0&&F.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+N>V.length)return!1;const fe=V.slice(0);fe.splice(U,N,...F.map(J=>({uri:J.uri,name:J.name||(0,R.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<fe.length;J++){const te=fe[J];if(fe.some((be,le)=>le!==J&&f(te.uri,be.uri,this._extHostFileSystemInfo)))return!1}fe.forEach((J,te)=>J.index=te);const{added:se,removed:$}=u(V,fe,s,this._extHostFileSystemInfo);if(se.length===0&&$.length===0)return!1;if(this._proxy){const J=X.displayName||X.name;this._proxy.$updateWorkspaceFolders(J,U,N,F).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const be={source:{identifier:X.identifier,label:X.displayName||X.name}};this._messageService.$showMessage(d.Severity.Error,(0,C.localize)(0,null,J,te.toString()),be,[])})}return this.trySetWorkspaceFolders(fe),!0}getWorkspaceFolder(X,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(X,U)}async getWorkspaceFolder2(X,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(X,U)}async resolveWorkspaceFolder(X){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(X)}getPath(){if(!this._actualWorkspace)return;const{folders:X}=this._actualWorkspace;if(X.length!==0)return X[0].uri.fsPath}getRelativePath(X,U){let N,x="";if(typeof X=="string"?(N=D.URI.file(X),x=X):typeof X<"u"&&(N=X,x=X.fsPath),!N)return x;const F=this.getWorkspaceFolder(N,!0);if(!F)return x;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let V=(0,R.relativePath)(F.uri,N);return U&&F.name&&(V=`${F.name}/${V}`),V}trySetWorkspaceFolders(X){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:X,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(X){const{workspace:U,added:N,removed:x}=g.toExtHostWorkspace(X,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:x}))}findFiles(X,U,N,x,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let V;if(U===null?V=!1:U&&(typeof U=="string"?V=U:V=U.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:se}=H(t.GlobPattern.from(X));return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(fe),(0,_.withUndefinedAsNull)(se),(0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(N),F).then($=>Array.isArray($)?$.map(J=>D.URI.revive(J)):[])}async findTextInFiles(X,U,N,x,F=l.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),fe=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:se,folder:$}=H(t.GlobPattern.from(U.include)),J=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,te={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:fe,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:se,excludePattern:J},be=!1;if(this._activeSearchCallbacks[V]=le=>{if(be)return;const ue=D.URI.revive(le.resource);le.results.forEach(j=>{(0,c.resultIsMatch)(j)?N({uri:ue,preview:{text:j.preview.text,matches:(0,a.mapArrayOrNot)(j.preview.matches,M=>new o.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))},ranges:(0,a.mapArrayOrNot)(j.ranges,M=>new o.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))}):N({uri:ue,text:j.text,lineNumber:j.lineNumber})})},F.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(X,(0,_.withUndefinedAsNull)($),te,V,F);return delete this._activeSearchCallbacks[V],le||{}}catch(le){throw delete this._activeSearchCallbacks[V],le}}$handleTextSearchResult(X,U){this._activeSearchCallbacks[U]?.(X)}saveAll(X){return this._proxy.$saveAll(X)}resolveProxy(X){return this._proxy.$resolveProxy(X)}get trusted(){return this._trusted}requestWorkspaceTrust(X){return this._proxy.$requestWorkspaceTrust(X)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(X,U){if(this._editSessionIdentityProviders.has(X))throw new Error(`A provider has already been registered for scheme ${X}`);this._editSessionIdentityProviders.set(X,U);const N=this._uriTransformerService.transformOutgoingScheme(X),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,N),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(X),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(X,U){this._logService.info("Getting edit session identifier for workspaceFolder",X);const N=await this.resolveWorkspaceFolder(D.URI.revive(X));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const x=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!x),!x)return;const F=await x.provideEditSessionIdentity(N,U);if(this._logService.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(X,U,N,x){this._logService.info("Getting edit session identifier for workspaceFolder",X);const F=await this.resolveWorkspaceFolder(D.URI.revive(X));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const V=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!V),!V)return;const fe=await V.provideEditSessionIdentityMatch?.(U,N,x);if(this._logService.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(X){return(U,N,x)=>{const F=function(fe){U.call(N,fe)};return F.extension=X,this._onWillCreateEditSessionIdentityEvent.event(F,void 0,x)}}async $onWillCreateEditSessionIdentity(X,U,N){const x=await this.resolveWorkspaceFolder(D.URI.revive(X));if(x===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:x},U,async(F,V)=>{const fe=Date.now();await Promise.resolve(F),Date.now()-fe>N&&this._logService.warn("SLOW edit session create-participant",V.extension.identifier)}),U.isCancellationRequested}};L=$e([Be(0,p.IExtHostRpcService),Be(1,S.IExtHostInitDataService),Be(2,w.IExtHostFileSystemInfo),Be(3,n.ILogService),Be(4,r.IURITransformerService)],L),e.ExtHostWorkspace=L,e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function H(q){let X,U;return q&&(typeof q=="string"?X=q:(X=q.pattern,U=D.URI.revive(q.baseUri))),{includePattern:X,folder:U}}}),define(Ce[36],De([1,0,23,3,35,5,7,216,127,10,19,4,20,16,2]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function E(o,r){if(r){const c=r.split(".");let m=o;for(let f=0;m&&f<c.length;f++)m=m[c[f]];return m}}function n(o){return o instanceof C.URI}function d(o){return o&&o.uri instanceof C.URI&&o.languageId&&typeof o.languageId=="string"}function h(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function w(o){return o&&o.uri instanceof C.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function S(o){if(n(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(h(o))return{overrideIdentifier:o.languageId};if(w(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(r,c,m){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=c,this._logService=m,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(r,c))}};p=$e([Be(0,_.IExtHostRpcService),Be(1,l.IExtHostWorkspace),Be(2,D.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,c,m,f){this._onDidChangeConfiguration=new P.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=c,this._configuration=k.Configuration.parse(m),this._configurationScopes=this._toMap(m.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,c){const m={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(c,m))}getConfiguration(r,c,m){const f=S(c)||{},i=this._toReadonlyValue(r?E(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,m?.identifier);function s(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(b){return typeof E(i,b)<"u"},get:(b,g)=>{this._validateConfigurationAccess(r?`${r}.${b}`:b,f,m?.identifier);let L=E(i,b);if(typeof L>"u")L=g;else{let H;const q=(X,U)=>{let N;const x=()=>{H=H||(0,a.deepClone)(i),N=N||E(H,U)};return(0,v.isObject)(X)?new Proxy(X,{get:(F,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return x(),()=>N;if(H)return N=N||E(H,U),N[V];const fe=F[V];return typeof V=="string"?q(fe,`${U}.${V}`):fe},set:(F,V,fe)=>(x(),N&&(N[V]=fe),!0),deleteProperty:(F,V)=>(x(),N&&delete N[V],!0),defineProperty:(F,V,fe)=>(x(),N&&Object.defineProperty(N,V,fe),!0)}):X};L=q(L,b)}return L},update:(b,g,L,H)=>{b=r?`${r}.${b}`:b;const q=s(L);return g!==void 0?this._proxy.$updateConfigurationOption(q,b,g,f,H):this._proxy.$removeConfigurationOption(q,b,f,H)},inspect:b=>{b=r?`${r}.${b}`:b;const g=this._configuration.inspect(b,f,this._extHostWorkspace.workspace);if(g)return{key:b,defaultValue:(0,a.deepClone)(g.policy?.value??g.default?.value),globalValue:(0,a.deepClone)(g.user?.value??g.application?.value),workspaceValue:(0,a.deepClone)(g.workspace?.value),workspaceFolderValue:(0,a.deepClone)(g.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(g.default?.override),globalLanguageValue:(0,a.deepClone)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,a.deepClone)(g.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(g.workspaceFolder?.override),languageIds:(0,a.deepClone)(g.overrideIdentifiers)}}};return typeof i=="object"&&(0,a.mixin)(u,i,!1),Object.freeze(u)}_toReadonlyValue(r){const c=m=>(0,v.isObject)(m)?new Proxy(m,{get:(f,i)=>c(f[i]),set:(f,i,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(f,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(f,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return c(r)}_validateConfigurationAccess(r,c,m){const f=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),i=m?`[${m.value}] `:"";if(f===4){typeof c?.resource>"u"&&this._logService.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){c?.resource&&this._logService.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,c){const m=new k.ConfigurationChangeEvent(r,c,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,i)=>m.affectsConfiguration(f,S(i))})}_toMap(r){return r.reduce((c,m)=>(c.set(m[0],m[1]),c),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[84],De([1,0,2,19,3,5,7,35,59,36,21,42,20,26,4,17,14,16,79,256,8]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(X){function U(x){if(x!=null)return x}X.from=U;function N(x){if(x!=null)return x}X.to=N})(t||(t={}));var o;(function(X){function U(x){if(x!=null)return x}X.from=U;function N(x){if(x!=null)return x}X.to=N})(o||(o={}));var r;(function(X){function U(x){if(x!=null)return x}X.from=U;function N(x){if(x!=null)return x}X.to=N})(r||(r={}));var c;(function(X){function U(F){if(F){const V=F;return V&&!!V.process}else return!1}X.is=U;function N(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=r.from(F.options)),V}X.from=N;function x(F){if(F!=null)return new T.ProcessExecution(F.process,F.args,F.options)}X.to=x})(c||(c={}));var m;(function(X){function U(x){if(x!=null)return x}X.from=U;function N(x){if(x!=null)return x}X.to=N})(m||(m={}));var f;(function(X){function U(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}X.is=U;function N(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=m.from(F.options)),V}X.from=N;function x(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.ShellExecution(F.commandLine,F.options):new T.ShellExecution(F.command,F.args?F.args:[],F.options)}X.to=x})(f||(f={}));var i;(function(X){function U(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}X.is=U;function N(F){return{customExecution:"customExecution"}}X.from=N;function x(F,V){return V.get(F)}X.to=x})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(X){function U(N,x){let F;return N.scope!==void 0&&typeof N.scope!="number"?F=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===T.TaskScope.Workspace&&x&&x.workspaceFile?F=x.workspaceFile:F=w.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:F}}X.from=U})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(X){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}X.from=U})(u||(u={}));var b;(function(X){function U(F,V){if(F==null)return[];const fe=[];for(const se of F){const $=N(se,V);$&&fe.push($)}return fe}X.fromMany=U;function N(F,V){if(F==null)return;let fe;F.execution instanceof T.ProcessExecution?fe=c.from(F.execution):F.execution instanceof T.ShellExecution?fe=f.from(F.execution):F.execution&&F.execution instanceof T.CustomExecution&&(fe=i.from(F.execution));const se=t.from(F.definition);let $;return F.scope?typeof F.scope=="number"?$=F.scope:$=F.scope.uri:$=T.TaskScope.Workspace,!se||!$?void 0:{_id:F._id,definition:se,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:$},execution:fe,isBackground:F.isBackground,group:u.from(F.group),presentationOptions:o.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}X.from=N;async function x(F,V,fe){if(F==null)return;let se;c.is(F.execution)?se=c.to(F.execution):f.is(F.execution)?se=f.to(F.execution):i.is(F.execution)&&(se=i.to(F._id,fe));const $=t.to(F.definition);let J;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?J=F.source.scope:J=await V.resolveWorkspaceFolder(a.URI.revive(F.source.scope)):J=T.TaskScope.Workspace),!$||!J)return;const te=new T.Task($,J,F.name,F.source.label,se,F.problemMatchers);return F.isBackground!==void 0&&(te.isBackground=F.isBackground),F.group!==void 0&&(te.group=T.TaskGroup.from(F.group._id),te.group&&F.group.isDefault&&(te.group=new T.TaskGroup(te.group.id,te.group.label),F.group.isDefault===!0&&(te.group.isDefault=F.group.isDefault))),F.presentationOptions&&(te.presentationOptions=o.to(F.presentationOptions)),F._id&&(te._id=F._id),F.detail&&(te.detail=F.detail),te}X.to=x})(b=e.TaskDTO||(e.TaskDTO={}));var g;(function(X){function U(x){return x}X.from=U;function N(x){if(!!x)return Object.assign(Object.create(null),x)}X.to=N})(g||(g={}));class L{constructor(U,N,x){this._id=N,this._task=x,p.set(this,void 0),Je(this,p,U,"f")}get task(){return this._task}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;let H=class{constructor(U,N,x,F,V,fe,se,$){this._onDidExecuteTask=new l.Emitter,this._onDidTerminateTask=new l.Emitter,this._onDidTaskProcessStarted=new l.Emitter,this._onDidTaskProcessEnded=new l.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=F,this._configurationService=V,this._terminalService=fe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=se,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,x){if(!x)return new T.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:N,provider:x,extension:U}),this._proxy.$registerTaskProvider(F,N),new T.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(U,N){this._proxy.$registerTaskSystem(U,N)}fetchTasks(U){return this._proxy.$fetchTasks(g.from(U)).then(async N=>{const x=[];for(const F of N){const V=await b.to(F,this._workspaceProvider,this._providedCustomExecutions2);V&&x.push(V)}return x})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,N,x){const F=this._providedCustomExecutions2.get(U.id);F&&(this._activeCustomExecutions2.set(U.id,F),this._terminalService.attachPtyToTerminal(N,await F.callback(x))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const N=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const N=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const N=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));const F=[],V=(0,P.asPromise)(()=>x.provider.provideTasks(R.CancellationToken.None)).then(fe=>this.provideTasksInternal(N,F,x,fe));return new Promise(fe=>{V.then(se=>{Promise.all(F).then(()=>{fe(se)})})})}async $resolveTask(U,N){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));if(N.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${x.type}].`);const F=await b.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await x.provider.resolveTask(F,R.CancellationToken.None);if(!V)return;this.checkDeprecation(V,x);const fe=b.from(V,x.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(fe.execution)&&await this.addCustomExecution(fe,V,!0),await this.resolveTaskInternal(fe)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,N,x){const F=await this._proxy.$createTaskId(U);!x&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,N.execution)),this._providedCustomExecutions2.set(F,N.execution)}async getTaskExecution(U,N){if(typeof U=="string"){const V=this._taskExecutionPromises.get(U);if(!V)throw new S.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const x=this._taskExecutionPromises.get(U.id);if(x)return x;const F=new Promise((V,fe)=>{function se($,J,te){te?V(new L($,J.id,te)):fe("Unexpected: Task does not exist.")}N?se(this,U,N):b.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then($=>se(this,U,$))});return this._taskExecutionPromises.set(U.id,F),F.then(V=>(this._taskExecutions.set(U.id,V),V),V=>Promise.reject(V))}checkDeprecation(U,N){U._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const x=this._notProvidedCustomExecutions.values();let F=x.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=x.next()}};H=$e([Be(0,_.IExtHostRpcService),Be(1,D.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,v.IExtHostConfiguration),Be(5,I.IExtHostTerminalService),Be(6,d.ILogService),Be(7,h.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let q=class extends H{constructor(U,N,x,F,V,fe,se,$){super(U,N,x,F,V,fe,se,$),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const x=b.from(N,U);if(x===void 0)throw new Error("Task is not valid");if(i.is(x.execution))await this.addCustomExecution(x,N,!1);else throw new S.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),N);return this._proxy.$executeTask(x).catch(V=>{throw new Error(V)}),F}provideTasksInternal(U,N,x,F){const V=[];if(F)for(const fe of F){this.checkDeprecation(fe,x),(!fe.definition||!U[fe.definition.type])&&this._logService.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const se=b.from(fe,x.extension);se&&i.is(se.execution)?(V.push(se),N.push(this.addCustomExecution(se,fe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:x.extension}}async resolveTaskInternal(U){if(i.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,x){}};q=$e([Be(0,_.IExtHostRpcService),Be(1,D.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,v.IExtHostConfiguration),Be(5,I.IExtHostTerminalService),Be(6,d.ILogService),Be(7,h.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(Ce[305],De([1,0,15,21,46,39,24,37,31]),function(re,e,a,P,l,A,T,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class v{constructor(_,D,C){this.config=_,this.provider=D,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&A.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&A.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const D=this.config.folderQueries||[];return new Promise((C,E)=>{const n=d=>{this.resultCount++,_(d)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const h=d.toString(),w=a.basename(h);this.globalExcludePattern&&this.globalExcludePattern(h,w)||this.matchFile(n,{base:d,basename:w})}),Promise.all(D.map(d=>this.searchInFolder(d,n))).then(d=>{C({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{E(new Error((0,l.toErrorMessage)(d)))})})}async searchInFolder(_,D){const C=new P.CancellationTokenSource,E=this.getSearchOptionsForFolder(_),n=this.initDirectoryTree(),d=new y.QueryGlobTester(this.config,_),h=!d.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(C),w=k.StopWatch.create();const S=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},E,C.token),p=w.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(S&&S.forEach(o=>{const r=a.posix.relative(_.folder.path,o.path);if(h){const c=a.basename(o.path);this.matchFile(D,{base:_.folder,relativePath:r,basename:c});return}this.addDirectoryEntries(n,_.folder,r,D)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(n,d,D),{providerTime:p,postProcessTime:t.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(_){const D=(0,y.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),C=(0,y.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:C,includes:D,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},D,C,E){if(C===this.filePattern){const d=a.basename(this.filePattern);this.matchFile(E,{base:D,relativePath:this.filePattern,basename:d})}function n(d){const h=a.basename(d),w=a.dirname(d);let S=_[w];S||(S=_[w]=[],n(w)),S.push({base:D,relativePath:d,basename:h})}n(C)}matchDirectoryTree({rootEntries:_,pathToEntries:D},C,E){const n=this,d=this.filePattern;function h(w){const S=(0,y.hasSiblingFn)(()=>w.map(p=>p.basename));for(let p=0,t=w.length;p<t;p++){const o=w[p],{relativePath:r,basename:c}=o;if(C.matchesExcludesSync(r,c,d!==c?S:void 0))continue;const m=D[r];if(m)h(m);else{if(r===d)continue;n.matchFile(E,o)}if(n.isLimitHit)break}}h(_)}matchFile(_,D){(!this.includePattern||D.relativePath&&this.includePattern(D.relativePath,D.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(D))}}class R{constructor(){this.sessions=new Map}fileSearch(_,D,C,E){const n=this.getSessionTokenSource(_.cacheKey),d=new v(_,D,n&&n.token);let h=0;const w=S=>{h+=S.length,C(S.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(d,R.BATCH_SIZE,w,E).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:S.stats}}))}clearCache(_){this.getSessionTokenSource(_)?.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new P.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:T.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,D,C,E){E.onCancellationRequested(()=>{_.cancel()});const n=h=>{h&&(d.push(h),D>0&&d.length>=D&&(C(d),d=[]))};let d=[];return _.search(n).then(h=>(d.length&&C(d),h),h=>(d.length&&C(d),Promise.reject(h)))}}R.BATCH_SIZE=512,e.FileSearchManager=R}),define(Ce[306],De([1,0,18,61,39,114,28,17,15,24,9,10,2,168,202,54,16,48,134,304,31]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(b,g,L,H,q){this.configurationService=b,this.workspaceContextService=g,this.editorGroupsService=L,this.logService=H,this.pathService=q}text(b,g,L={}){b=this.getContentPattern(b,L);const H=this.configurationService.getValue(),q=g&&g.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(g?.map(d.toWorkspaceFolder),L),type:2,contentPattern:b,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:H.search.usePCRE2||q||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(b,g){const L=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const H={...b,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(b,g)&&(H.isCaseSensitive=!0),this.isMultiline(b)&&(H.isMultiline=!0),H}file(b,g={}){return{...this.commonQuery(b,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}handleIncludeExclude(b,g){return b?(b=Array.isArray(b)?b.map(m):m(b),g?this.parseSearchPaths(b):{pattern:o(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],g={}){const L=this.handleIncludeExclude(g.includePattern,g.expandPatterns),H=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),q=b.length>1,X=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,g,H)):b.map(x=>this.getFolderQueryForRoot(x,g,H,q))).filter(x=>!!x),U={_reason:g._reason,folderQueries:X,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:H.pattern,includePattern:L.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const x=a.coalesce(a.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(se=>se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(x));const F=x.filter(fe=>(0,S.pathIncludedInQuery)(U,fe.fsPath)),V=this.commonQueryFromFileList(F);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...U,...V}}const N=g.extraFileResources&&g.extraFileResources.filter(x=>(0,S.pathIncludedInQuery)(U,x.fsPath));return U.extraFileResources=N&&N.length?N:void 0,U}commonQueryFromFileList(b){const g=[],L=new T.ResourceMap,H={};let q=!1;return b.forEach(X=>{if(X.scheme===k.Schemas.walkThrough)return;if((0,v.isAbsolutePath)(X)){const N=this.workspaceContextService.getWorkspaceFolder(X)?.uri??X.with({path:y.dirname(X.fsPath)});let x=L.get(N);x||(q=!0,x={folder:N,includePattern:{}},g.push(x),L.set(N,x));const F=y.relative(N.fsPath,X.fsPath);(0,I.assertIsDefined)(x.includePattern)[F.replace(/\\/g,"/")]=!0}else X.fsPath&&(q=!0,H[X.fsPath]=!0)}),{folderQueries:g,includePattern:H,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}isCaseSensitive(b,g){if(g.isSmartCase){if(b.isRegExp){if(R.containsUppercaseCharacter(b.pattern,!0))return!0}else if(R.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,D.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const g=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),H=(Array.isArray(b)?b:r(b)).map(V=>{const fe=this.pathService.resolvedUserHome;return fe?(0,A.untildify)(V,fe.scheme===k.Schemas.file?fe.fsPath:fe.path):V}),q=P.groupBy(H,V=>g(V)?"searchPaths":"exprSegments"),X=(q.exprSegments||[]).map(V=>R.rtrim(V,"/")).map(V=>R.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),c(V))),U={},N=this.expandSearchPathPatterns(q.searchPaths||[]);N&&N.length&&(U.searchPaths=N);const x=a.flatten(X),F=o(...x);return F&&(U.pattern=F),U}getExcludesForFolder(b,g){return g.disregardExcludeSettings?void 0:(0,S.getExcludes)(b,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const g=b.flatMap(H=>{let{pathPortion:q,globPortion:X}=t(H);return X&&(X=f(X)),this.expandOneSearchPath(q).flatMap(N=>this.resolveOneSearchPathPattern(N,X))}),L=new Map;return g.forEach(H=>{const q=H.searchPath.toString(),X=L.get(q);X?H.pattern&&(X.pattern=X.pattern||{},X.pattern[H.pattern]=!0):L.set(q,{searchPath:H.searchPath,pattern:H.pattern?o(H.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(b){if(y.isAbsolute(b)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==k.Schemas.file?[{searchPath:g[0].uri.with({path:b})}]:[{searchPath:_.URI.file(y.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=m(b),b.startsWith("../")||b===".."){const H=y.posix.resolve(g.path,b);return[{searchPath:g.with({path:H})}]}const L=f(b);return[{searchPath:g,pattern:L}]}else{if(b==="./"||b===".\\")return[];{const g=b.replace(/^\.[\/\\]/,""),H=this.workspaceContextService.getWorkspace().folders.map(q=>{const X=g.match(new RegExp(`^${R.escapeRegExpCharacters(q.name)}(?:/(.*)|$)`));return X?{match:X,folder:q}:null}).filter(I.isDefined);if(H.length)return H.map(q=>{const X=q.match[1];return{searchPath:q.folder.uri,pattern:X&&f(X)}});{const q=b.match(/\.[\/\\](.+)[\/\\]?/),X=q?q[1]:b,U=C.localize(0,null,X);throw new Error(U)}}}}resolveOneSearchPathPattern(b,g){const L=b.pattern&&g?`${b.pattern}/${g}`:b.pattern||g,H=[{searchPath:b.searchPath,pattern:L}];return L&&!L.endsWith("**")&&H.push({searchPath:b.searchPath,pattern:L+"/**"}),H}getFolderQueryForSearchPath(b,g,L){const H=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(b.searchPath),g,L,!1);return H?{...H,includePattern:b.pattern}:null}getFolderQueryForRoot(b,g,L,H){let q;const X=_.URI.isUri(b)?b:b.uri;if(L.searchPaths){const V=L.searchPaths.filter(fe=>(0,v.isEqual)(fe.searchPath,X))[0];if(V&&!V.pattern)return null;V&&(q=V.pattern)}const U=this.configurationService.getValue({resource:X}),x={...this.getExcludesForFolder(U,g)||{},...q||{}},F=_.URI.isUri(b)?(0,v.basename)(b):b.name;return{folder:X,folderName:H?F:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!U.search.followSymlinks}}};p=$e([Be(0,E.IConfigurationService),Be(1,d.IWorkspaceContextService),Be(2,h.IEditorGroupsService),Be(3,n.ILogService),Be(4,w.IPathService)],p),e.QueryBuilder=p;function t(u){const b=u.match(/[\*\{\}\(\)\[\]\?]/);if(b){const g=b.index,L=u.substr(0,g).match(/[/|\\][^/\\]*$/);if(L){let H=u.substr(0,L.index);return H.match(/[/\\]/)||(H+="/"),{pathPortion:H,globPortion:u.substr((L.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((b,g)=>(b[g]=!0,b),Object.create(null)):void 0}function r(u){return l.splitGlobAware(u,",").map(b=>b.trim()).filter(b=>!!b.length)}function c(u){return[`**/${u}/**`,`**/${u}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function m(u){return u.replace(/\\/g,"/")}function f(u){return m(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(u){return u.replace(/([?*[\]])/g,"[$1]")}function s(u,b){u=a.distinct(u,H=>H.toString());const g=[],L=b.getWorkspace();return u&&u.forEach(H=>{let q;if(b.getWorkbenchState()===2)q=(0,v.relativePath)(L.folders[0].uri,H),q&&q!=="."&&(q="./"+q);else{const X=b.getWorkspaceFolder(H);if(X){const U=X.name;if(L.folders.filter(x=>x.name===U).length===1){const x=(0,v.relativePath)(X.uri,H);x===""?q=`./${X.name}`:q=`./${X.name}/${x}`}else q=H.fsPath}}q&&g.push(i(q))}),g}e.resolveResourcesForSearchIncludes=s}),define(Ce[307],De([1,0,24,2,21,8,4,306,31,48]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function I(E,n){const d=n.activationEvents;if(!d)return Promise.resolve(void 0);const h=[],w=[];for(const c of d)if(/^workspaceContains:/.test(c)){const m=c.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||E.forceUsingSearch?w.push(m):h.push(m)}if(h.length===0&&w.length===0)return Promise.resolve(void 0);let S;const p=new Promise((c,m)=>{S=c}),t=c=>S({activationEvent:c}),o=Promise.all(h.map(c=>_(E,c,t))).then(()=>{}),r=D(E,n.identifier,w,t);return Promise.all([o,r]).then(()=>{S(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function _(E,n,d){for(const h of E.folders)if(await E.exists(a.joinPath(P.URI.revive(h),n))){d(`workspaceContains:${n}`);return}}async function D(E,n,d,h){if(d.length===0)return Promise.resolve(void 0);const w=new l.CancellationTokenSource,S=E.checkExists(E.folders,d,w.token),p=setTimeout(async()=>{w.cancel(),E.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},R);let t=!1;try{t=await S}catch(o){A.isCancellationError(o)||A.onUnexpectedError(o)}w.dispose(),clearTimeout(p),t&&h(`workspaceContains:${d.join(",")}`)}function C(E,n,d,h){const w=E.get(T.IInstantiationService),S=E.get(y.ISearchService),t=w.createInstance(k.QueryBuilder).file(n.map(o=>(0,v.toWorkspaceFolder)(P.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return S.fileSearch(t,h).then(o=>!!o.limitHit,o=>A.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=C});var Je=this&&this.__classPrivateFieldSet||function(re,e,a,P,l){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ne=this&&this.__classPrivateFieldGet||function(re,e,a,P){if(a==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!P:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?P:a==="a"?P.call(re):P?P.value:e.get(re)};define(Ce[43],De([1,0,182,15,85,24,19,6,69,2,16,5,36,245,100,35,27,135,8,25,22,227,7,128,4,26,81,20,92,55,42,3,307,99,229,17,98,37,14]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t,o,r,c,m,f,i,s,u,b,g,L,H,q,X,U,N){"use strict";var x,F,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let fe=class gn extends k.Disposable{constructor(j,M,Y,ge,we,ie,ne,de,ee,ce,ae){super(),this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=M,this._extHostContext=Y,this._initData=ne,this._extHostWorkspace=ge,this._extHostConfiguration=we,this._logService=ie,this._extHostTunnelService=ee,this._extHostTerminalService=ce,this._extHostLocalizationService=ae,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new le(this._initData.activationEvents),this._globalRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const O=new w.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(this._activationEventsReader,te(this._globalRegistry,O)),this._storage=new C.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=j.createChild(new i.ServiceCollection([C.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState])),this._activator=this._register(new D.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(B,K,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(B,h.transformErrorForSerialization(K),Z)},actualActivateExtension:async(B,K)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(B,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(B,K),new D.HostExtension;const Z=this._myRegistry.getExtensionDescription(B);return this._activateExtension(Z,K)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),l.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){h.onUnexpectedError(j)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._myRegistry.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this._deactivate(we))}catch{}await Promise.all(j)}terminate(j,M=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${j}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),h.setUnexpectedErrorHandler(ge=>{this._logService.error(ge)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${M}`):this._logService.info(`Extension host exiting with code ${M}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(M)})}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}async getExtension(j){const M=await this._mainThreadExtensionsProxy.$getExtension(j);return M&&{...M,identifier:new w.ExtensionIdentifier(M.identifier.value),extensionLocation:v.URI.revive(M.extensionLocation)}}_activateByEvent(j,M){return this._activator.activateByEvent(j,M)}_activateById(j,M){return this._activator.activateById(j,M)}activateByIdWithErrors(j,M){return this._activateById(j,M).then(()=>{const Y=this._activator.getActivatedExtension(j);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._myRegistry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==q.Schemas.file)return j;const M=await this._hostUtils.realpath(j.fsPath);return v.URI.file(M)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(j=>new be(j))),this._extensionPathIndex}async _createExtensionPathIndex(j){const M=y.TernarySearchTree.forUris(Y=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(j.map(async Y=>{if(this._getEntryPoint(Y)){const ge=await this._realPathExtensionUri(Y.extensionLocation);M.set(ge,Y)}})),M}_deactivate(j){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return M;const Y=this._activator.getActivatedExtension(j);if(!Y)return M;try{typeof Y.module.deactivate=="function"&&(M=Promise.resolve(Y.module.deactivate()).then(void 0,ge=>(this._logService.error(ge),Promise.resolve(void 0))))}catch(ge){this._logService.error(`An error occurred when deactivating the extension '${j.value}':`),this._logService.error(ge)}try{(0,k.dispose)(Y.subscriptions)}catch(ge){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this._logService.error(ge)}return M}async _activateExtension(j,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,M).then(Y=>{const ge=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,M),this._logExtensionActivationTimes(j,M,"success",ge),Y},Y=>{throw this._logExtensionActivationTimes(j,M,"failure"),Y})}_logExtensionActivationTimes(j,M,Y,ge){const we=$(j,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...we,...ge||{},outcome:Y})}_doActivateExtension(j,M){const Y=$(j,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ge=this._getEntryPoint(j);if(!ge)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${M.startup}, activationEvent: '${M.activationEvent}'${j.identifier.value!==M.extensionId.value?`, root cause: ${M.extensionId.value}`:""}`),this._logService.flush();const we=new D.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(j,(0,A.joinPath)(j.extensionLocation,ge),we),this._loadExtensionContext(j)]).then(ie=>(l.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),gn._callActivate(this._logService,j.identifier,ie[0],ie[1],we))).then(ie=>(l.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),ie))}_loadExtensionContext(j){const M=new p.ExtensionGlobalMemento(j,this._storage),Y=new p.ExtensionMemento(j.identifier.value,!1,this._storage),ge=new H.ExtensionSecrets(j,this._secretState),we=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([M.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const ne=this;let de,ee;const ce=(0,n.isProposedApiEnabled)(j,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(j.identifier)):void 0;return Object.freeze({globalState:M,workspaceState:Y,secrets:ge,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(ae){return P.join(j.extensionLocation.fsPath,ae)},get storagePath(){return ne._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return ne._storagePath.globalValue(j).fsPath},get logPath(){return P.join(ne._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return v.URI.joinPath(ne._initData.logsLocation,j.identifier.value)},get storageUri(){return ne._storagePath.workspaceValue(j)},get globalStorageUri(){return ne._storagePath.globalValue(j)},get extensionMode(){return we},get extension(){return de===void 0&&(de=new J(ne,j.identifier,j,ie,!1)),de},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(j,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne._extHostTerminalService.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!ee){if(!ce)return;const ae=b.Event.buffer(b.Event.fromDOMEventEmitter(ce,"message",O=>O.data));ce.start(),ee={onDidReceiveMessage:ae,postMessage:ce.postMessage.bind(ce)}}return ee}})})}static _callActivate(j,M,Y,ge,we){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,M,Y,ge,we).then(ie=>new D.ActivatedExtension(!1,null,we.build(),Y,ie,ge.subscriptions))}static _callActivateOptional(j,M,Y,ge,we){if(typeof Y.activate=="function")try{we.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ie=typeof global=="object"?global:self,ne=Y.activate.apply(ie,[ge]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ne).then(de=>(we.activateResolveStop(),de))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(Y)}_activateOneStartupFinished(j,M){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:M}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinishedDeferred(j,M=0){const ge=Date.now();(0,N.setTimeout0)(()=>{for(let we=M;we<j.length;we+=1){const ie=j[we];for(const ne of ie.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-ge>50){this._activateAllStartupFinishedDeferred(j,we);break}else this._activateOneStartupFinished(ie,ne)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(l.getMarks()),this._extHostConfiguration.getConfigProvider().then(j=>{const M=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Y=this._myRegistry.getAllExtensionDescriptions();if(M)this._activateAllStartupFinishedDeferred(Y);else for(const ge of Y)if(ge.activationEvents)for(const we of ge.activationEvents)we==="onStartupFinished"&&this._activateOneStartupFinished(ge,we)})}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(M),ge=this._handleRemoteResolverEagerExtensions(),we=Promise.all([ge,j,Y]).then(()=>{});return Promise.race([we,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),we}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(j,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,M){if(this.isActivated(M.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ge={logService:this._logService,folders:j.map(ie=>ie.uri),forceUsingSearch:Y,exists:ie=>this._hostUtils.exists(ie.fsPath),checkExists:(ie,ne,de)=>this._mainThreadWorkspaceProxy.$checkExists(ie,ne,de)},we=await(0,g.checkActivateWorkspaceContainsExtension)(ge,M);if(!!we)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:we.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:M}=this._initData.environment;if(!j||!M)throw new Error(a.localize(0,null));const Y=await this._loadCommonJSModule(null,M,new D.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(a.localize(1,null,M.toString()));return new Promise((ge,we)=>{const ie=(ee,ce)=>{ee?we(ee):ge(typeof ce=="number"&&ce>0?1:0)},ne=(0,A.originalFSPath)(M),de=Y.run(ne,ie);de&&de.then&&de.then(()=>{ge(0)}).catch(ee=>{we(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,M){return this._resolvers[j]=M,(0,k.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const M=j.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const Y=j.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(j,M){const Y=U.StopWatch.create(!1),ge=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(j)},${M})][${Y.elapsed()}ms] `,we=ce=>this._logService.info(`${ge()}${ce}`),ie=(ce,ae=void 0)=>this._logService.error(`${ge()}${ce}`,ae);we("activating resolver...");const{authorityPrefix:ne,resolver:de}=await this._activateAndGetResolver(j);if(!de)return ie("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};const ee=new T.IntervalTimer;try{we("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(de)),ee.cancelAndSet(()=>we("waiting..."),1e3),we("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${ne}`);const ce=await de.resolve(j,{resolveAttempt:M});l.mark(`code/extHost/didResolveAuthorityOK/${ne}`),ee.dispose(),we(`returned ${ce.host}:${ce.port}`);const ae={authority:j,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},O={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:O,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(l.mark(`code/extHost/didResolveAuthorityError/${ne}`),ee.dispose(),ie("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(j,M){this._logService.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(j)})`);const{resolver:Y}=await this._activateAndGetResolver(j);if(!Y)return null;const ge=v.URI.revive(M);if(typeof Y.getCanonicalURI>"u")return ge;const we=await(0,T.asPromise)(()=>Y.getCanonicalURI(ge));return we||ge}$startExtensionHost(j){j.toAdd.forEach(ge=>ge.extensionLocation=v.URI.revive(ge.extensionLocation));const{globalRegistry:M,myExtensions:Y}=se(this._activationEventsReader,this._globalRegistry,this._myRegistry,j);return this._globalRegistry.set(M.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(j,M){return M===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(j,!1))}async $activate(j,M){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(j)?(await this._activateById(j,M),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(ie=>ie.extensionLocation=v.URI.revive(ie.extensionLocation));const{globalRegistry:M,myExtensions:Y}=se(this._activationEventsReader,this._globalRegistry,this._myRegistry,j),ge=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(ge),this._globalRegistry.set(M.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const M=S.VSBuffer.alloc(j),Y=Math.random()%256;for(let ge=0;ge<j;ge++)M.writeUInt8(Y,ge);return M}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};fe=$e([Be(0,r.IInstantiationService),Be(1,e.IHostUtils),Be(2,f.IExtHostRpcService),Be(3,E.IExtHostWorkspace),Be(4,_.IExtHostConfiguration),Be(5,R.ILogService),Be(6,c.IExtHostInitDataService),Be(7,m.IExtensionStoragePaths),Be(8,s.IExtHostTunnelService),Be(9,u.IExtHostTerminalService),Be(10,X.IExtHostLocalizationService)],fe),e.AbstractExtHostExtensionService=fe;function se(ue,j,M,Y){ue.addActivationEvents(Y.addActivationEvents);const ge=new d.ExtensionDescriptionRegistry(ue,j.getAllExtensionDescriptions());ge.deltaExtensions(Y.toAdd,Y.toRemove);const we=new w.ExtensionIdentifierSet(M.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of Y.myToRemove)we.delete(ne);for(const ne of Y.myToAdd)we.add(ne);const ie=te(ge,we);return{globalRegistry:ge,myExtensions:ie}}function $(ue,j){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class J{constructor(j,M,Y,ge,we){x.set(this,void 0),F.set(this,void 0),V.set(this,void 0),Je(this,x,j,"f"),Je(this,F,M,"f"),Je(this,V,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=P.normalize((0,A.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ge,this.isFromDifferentExtensionHost=we}get isActive(){return Ne(this,x,"f").isActivated(Ne(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,x,"f").getExtensionExports(Ne(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,x,"f").activateByIdWithErrors(Ne(this,V,"f"),{startup:!1,extensionId:Ne(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=J,x=new WeakMap,F=new WeakMap,V=new WeakMap;function te(ue,j){return ue.getAllExtensionDescriptions().filter(M=>j.has(M.identifier))}class be{constructor(j){this._searchTree=j}setSearchTree(j){this._searchTree=j}findSubstr(j){return this._searchTree.findSubstr(j)}forEach(j){return this._searchTree.forEach(j)}}e.ExtensionPaths=be;class le{constructor(j){this._map=new w.ExtensionIdentifierMap,this.addActivationEvents(j)}readActivationEvents(j){return this._map.get(j.identifier)}addActivationEvents(j){for(const M of Object.keys(j))this._map.set(M,j[M])}}}),define(Ce[308],De([1,0,85,2,5,36,27,25,20,26,4,43,33,16,9]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let E=class{constructor(p,t,o,r,c,m,f){this._apiFactory=p,this._extensionRegistry=t,this._instaService=o,this._extHostConfiguration=r,this._extHostExtensionService=c,this._initData=m,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(h,t)),this.register(this._instaService.createInstance(n)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,t,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this._factories.set(t,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(t=>p.alternativeModuleName(t))}};E=$e([Be(2,R.IInstantiationService),Be(3,A.IExtHostConfiguration),Be(4,I.IExtHostExtensionService),Be(5,v.IExtHostInitDataService),Be(6,D.ILogService)],E),e.RequireInterceptor=E;let n=class un{constructor(p){if(p.environment.appRoot&&un.aliased.size){const t=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",r=`@${o}+\\/${o}+|${o}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(p));if(!t)return;const[,o,r,c]=t,m=un.aliased.get(r);if(m!==void 0)return console.warn(`${r} as been renamed to ${m}, please update your imports`),o+m+c}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};n.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),n=$e([Be(0,v.IExtHostInitDataService)],n);class d{constructor(p,t,o,r,c){this._apiFactory=p,this._extensionPaths=t,this._extensionRegistry=o,this._configProvider=r,this._logService=c,this.nodeModuleName="vscode",this._extApiImpl=new k.ExtensionIdentifierMap}load(p,t){const o=this._extensionPaths.findSubstr(t);if(o){let r=this._extApiImpl.get(o.identifier);return r||(r=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(o.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((c,m)=>r+=`	${m} -> ${c.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let h=class{constructor(p,t,o){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=o,c=t.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let m=r.appRoot.fsPath;_.platform==="win32"&&(m=m.replace(/\\/g,"/")),m[m.length-1]==="/"&&(m=m.substr(0,m.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${m}/node_modules.asar/keytar`),this.alternativeNames.add(`${m}/node_modules/keytar`)}this._impl={getPassword:(m,f)=>c.$getPassword(m,f),setPassword:(m,f,i)=>c.$setPassword(m,f,i),deletePassword:(m,f)=>c.$deletePassword(m,f),findPassword:m=>c.$findPassword(m),findCredentials(m){return c.$findCredentials(m)}}}load(p,t){const o=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const t=p.length;if(t<=7||!this.alternativeNames)return;const o=t-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};h=$e([Be(1,y.IExtHostRpcService),Be(2,v.IExtHostInitDataService)],h);let w=class{constructor(p,t,o){this._extensionPaths=p,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(l.MainContext.MainThreadTelemetry);const r=o.getProxy(l.MainContext.MainThreadWindow);this._impl=(c,m)=>{const f=P.URI.parse(c);return m?this.callOriginal(c,m):f.scheme==="http"||f.scheme==="https"?r.$openUri(f,c,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?r.$openUri(f,c,{}):this.callOriginal(c,m)}}load(p,t,o){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=o(p),this._impl}callOriginal(p,t){return this.sendNoForwardTelemetry(),this._original(p,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=$e([Be(2,y.IExtHostRpcService)],w)}),define(Ce[50],De([1,0,65,6,15,33,4,59,60,43,7,35,241,36]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class C extends _.AbstractVariableResolverService{constructor(d,h,w,S,p,t,o){function r(){if(w){const c=w.activeEditor();if(c)return c.document.uri;const m=S.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof R.TextDiffTabInput||m.input instanceof R.NotebookDiffEditorTabInput)return m.input.modified;if(m.input instanceof R.TextTabInput||m.input instanceof R.NotebookEditorTabInput||m.input instanceof R.CustomEditorTabInput)return m.input.uri}}}super({getFolderUri:c=>{const m=t.folders.filter(f=>f.name===c);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,m)=>p.getConfiguration(void 0,c).get(m),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return l.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const c=r();if(c){const m=h.getWorkspaceFolder(c);if(m)return l.normalize(m.uri.fsPath)}}},getSelectedText:()=>{if(w){const c=w.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(w){const c=w.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>d.getExtension(c)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(A.env))}}let E=class extends P.Disposable{constructor(d,h,w,S,p){super(),this.extensionService=d,this.workspaceService=h,this.editorService=w,this.configurationService=S,this.editorTabs=p,this._resolver=new a.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async c=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};E=$e([Be(0,v.IExtHostExtensionService),Be(1,I.IExtHostWorkspace),Be(2,k.IExtHostDocumentsAndEditors),Be(3,D.IExtHostConfiguration),Be(4,y.IExtHostEditorTabs)],E),e.ExtHostVariableResolverProviderService=E}),define(Ce[86],De([1,0,19,3,10,2,4,5,60,43,20,7,35,132,234,36,50]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,c,m,f,i,s){this._workspaceService=c,this._extensionService=m,this._configurationService=f,this._editorTabs=i,this._variableResolver=s,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=r.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(u=>{u.onDidChange(b=>{this.registerAllDebugTypes(u)}),this.registerAllDebugTypes(u)})}asDebugSourceUri(r,c){const m=r;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let f=`debug:${encodeURIComponent(m.path||"")}`,i="?";return c&&(f+=`${i}session=${encodeURIComponent(c.id)}`,i="&"),f+=`${i}ref=${m.sourceReference}`,A.URI.parse(f)}else{if(m.path)return A.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const c=[];for(const m of r.getAllExtensionDescriptions())if(m.contributes){const f=m.contributes.debuggers;if(f&&f.length>0)for(const i of f)(0,C.isDebuggerMainContribution)(i)&&c.push(i.type)}this._debugServiceProxy.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(c=>r.push(c)),r}addBreakpoints(r){this.startBreakpoints();const c=r.filter(i=>{const s=i.id;return this._breakpoints.has(s)?!1:(this._breakpoints.set(s,i),!0)});this.fireBreakpointChanges(c,[],[]);const m=[],f=new Map;for(const i of c)if(i instanceof I.SourceBreakpoint){let s=f.get(i.location.uri.toString());s||(s={type:"sourceMulti",uri:i.location.uri,lines:[]},f.set(i.location.uri.toString(),s),m.push(s)),s.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof I.FunctionBreakpoint&&m.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(r){this.startBreakpoints();const c=r.filter(s=>this._breakpoints.delete(s.id));this.fireBreakpointChanges([],c,[]);const m=c.filter(s=>s instanceof I.SourceBreakpoint).map(s=>s.id),f=c.filter(s=>s instanceof I.FunctionBreakpoint).map(s=>s.id),i=c.filter(s=>s instanceof I.DataBreakpoint).map(s=>s.id);return this._debugServiceProxy.$unregisterBreakpoints(m,f,i)}startDebugging(r,c,m){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,c,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,m){if(!c)return new I.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:f,provider:c}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,m,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,f),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(i=>i.provider!==c),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(r,c,m){if(!m)return new I.Disposable(()=>{});if(!this.definesDebugType(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.getAdapterDescriptorFactoryByType(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:c,handle:f,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(c,f),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(i=>i.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new I.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:m,factory:c}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let m;const f=await this.getFolder(r);return f&&(m={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(m,c)}createDebugAdapter(r,c){if(r.type==="implementation")return new p(r.implementation)}createSignService(){}async $startDASession(r,c){const m=this,f=await this.getSession(c);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const s=this.convertToDto(i),u=this.createDebugAdapter(s,f);if(!u)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const b=u;return this._debugAdapters.set(r,b),this.getDebugAdapterTrackers(f).then(g=>(g&&this._debugAdaptersTrackers.set(r,g),b.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const H=L,q={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const X=await this._signService.sign(H.arguments.value);q.body={signature:X},b.sendResponse(q)}else throw new Error("no signer")}catch(X){q.success=!1,q.message=X.message,b.sendResponse(q)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(L),L=(0,C.convertToVSCPaths)(L,!0),m._debugServiceProxy.$acceptDAMessage(r,L)}),b.onError(L=>{g&&g.onError&&g.onError(L),this._debugServiceProxy.$acceptDAError(r,L.name,L.message,L.stack)}),b.onExit(L=>{g&&g.onExit&&g.onExit((0,l.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,l.withNullAsUndefined)(L),void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),b.startSession()))})}$sendDAMessage(r,c){c=(0,C.convertToDAPaths)(c,!1);const m=this._debugAdaptersTrackers.get(r);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(c),this._debugAdapters.get(r)?.sendMessage(c)}$stopDASession(r){const c=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const m=this._debugAdapters.get(r);return this._debugAdapters.delete(r),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],m=[],f=[];if(r.added)for(const i of r.added){const s=i.id;if(s&&!this._breakpoints.has(s)){let u;if(i.type==="function")u=new I.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")u=new I.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const b=A.URI.revive(i.uri);u=new I.SourceBreakpoint(new I.Location(b,new I.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,I.setBreakpointId)(u,s),this._breakpoints.set(s,u),c.push(u)}}if(r.removed)for(const i of r.removed){const s=this._breakpoints.get(i);s&&(this._breakpoints.delete(i),m.push(s))}if(r.changed){for(const i of r.changed)if(i.id){const s=this._breakpoints.get(i.id);if(s){if(s instanceof I.FunctionBreakpoint&&i.type==="function"){const u=s;u.enabled=i.enabled,u.condition=i.condition,u.hitCondition=i.hitCondition,u.logMessage=i.logMessage,u.functionName=i.functionName}else if(s instanceof I.SourceBreakpoint&&i.type==="source"){const u=s;u.enabled=i.enabled,u.condition=i.condition,u.hitCondition=i.hitCondition,u.logMessage=i.logMessage,u.location=new I.Location(A.URI.revive(i.uri),new I.Position(i.line,i.character))}f.push(s)}}}this.fireBreakpointChanges(c,m,f)}$provideDebugConfigurations(r,c,m){return(0,a.asPromise)(async()=>{const f=this.getConfigProviderByHandle(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.getFolder(c);return f.provideDebugConfigurations(i,m)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(r,c,m,f){return(0,a.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.getFolder(c);return i.resolveDebugConfiguration(s,m,f)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,m,f){return(0,a.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.getFolder(c);return i.resolveDebugConfigurationWithSubstitutedVariables(s,m,f)})}async $provideDebugAdapter(r,c){const m=this.getAdapterDescriptorFactoryByHandle(r);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(c);return this.getAdapterDescriptor(m,f).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(i)})}async $acceptDebugSessionStarted(r){const c=await this.getSession(r);this._onDidStartDebugSession.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.getSession(r);c&&(this._onDidTerminateDebugSession.fire(c),this._debugSessions.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,c){(await this.getSession(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const f={session:await this.getSession(r),event:c.event,body:c.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(r){if(r instanceof I.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof I.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const c=this._adapterFactories.filter(m=>m.type===r);if(c.length>0)return c[0].factory}getAdapterDescriptorFactoryByHandle(r){const c=this._adapterFactories.filter(m=>m.handle===r);if(c.length>0)return c[0].factory}getConfigProviderByHandle(r){const c=this._configProviders.filter(m=>m.handle===r);if(c.length>0)return c[0].provider}definesDebugType(r,c){if(r.contributes){const m=r.contributes.debuggers;if(m&&m.length>0){for(const f of m)if(f.label&&f.type&&f.type===c)return!0}}return!1}getDebugAdapterTrackers(r){const m=r.configuration.type,f=this._trackerFactories.filter(i=>i.type===m||i.type==="*").map(i=>(0,a.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(f).then(i=>{const s=i.filter(u=>!!u);if(s.length>0)return new S(s)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async getAdapterDescriptor(r,c){const m=c.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new I.DebugAdapterServer(m));if(r){const i=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.daExecutableFromPackage(c,i))).then(s=>{if(s)return s})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(c,f))}daExecutableFromPackage(r,c){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,c,m){(r.length>0||c.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:c,changed:m}))}async getSession(r){if(r)if(typeof r=="string"){const c=this._debugSessions.get(r);if(c)return c}else{let c=this._debugSessions.get(r.id);if(!c){const m=await this.getFolder(r.folderUri),f=r.parent?this._debugSessions.get(r.parent):void 0;c=new h(this._debugServiceProxy,r.id,r.type,r.name,m,r.configuration,f),this._debugSessions.set(c.id,c),this._debugServiceProxy.$sessionCached(c.id)}return c}throw new Error("cannot find session")}getFolder(r){if(r){const c=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};d=$e([Be(0,R.IExtHostRpcService),Be(1,_.IExtHostWorkspace),Be(2,v.IExtHostExtensionService),Be(3,E.IExtHostConfiguration),Be(4,y.IExtHostEditorTabs),Be(5,n.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class h{constructor(r,c,m,f,i,s,u){this._debugServiceProxy=r,this._id=c,this._type=m,this._name=f,this._workspaceFolder=i,this._configuration=s,this._parentSession=u}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,c){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,c)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=h;class w{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=w;class S{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.trackers.forEach(m=>m.onExit?m.onExit(r,c):void 0)}}class p extends D.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(r,c,m,f,i,s){super(r,c,m,f,i,s)}};t=$e([Be(0,R.IExtHostRpcService),Be(1,_.IExtHostWorkspace),Be(2,v.IExtHostExtensionService),Be(3,E.IExtHostConfiguration),Be(4,y.IExtHostEditorTabs),Be(5,n.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[309],De([1,0,8,85,2,5,301,16,91,92,26,210,20,56,43,78]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class n{static async installEarlyHandler(w){const S=w.get(k.ILogService),t=w.get(_.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{S.error(o);const r=a.transformErrorForSerialization(o);t.$onUnexpectedError(r)})}static async installFullHandler(w){const S=w.get(k.ILogService),p=w.get(_.IExtHostRpcService),t=w.get(C.IExtHostExtensionService),o=w.get(E.IExtHostTelemetry),r=p.getProxy(A.MainContext.MainThreadExtensionService),c=p.getProxy(A.MainContext.MainThreadErrors),m=await t.getExtensionPathIndex(),f=new WeakMap;function i(u,b){let g="",L,H;for(const q of b)g+=`
	at ${q.toString()}`,H=q.getFileName(),!L&&H&&(L=m.findSubstr(l.URI.file(H)));return f.set(u,L?.identifier),`${u.name||"Error"}: ${u.message||""}${g}`}let s=i;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return s},set(u){s=function(b,g){return i(b,g),u.call(Error,b,g)}}}),a.setUnexpectedErrorHandler(u=>{S.error(u);const b=a.transformErrorForSerialization(u),g=f.get(u);if(!g){c.$onUnexpectedError(b);return}r.$onExtensionRuntimeError(g,b);const L=o.onExtensionError(g,u);S.trace("forwarded error to extension?",L,g)})}}Error.stackTraceLimit=100;class d{constructor(w,S,p,t,o){this._hostUtils=p,this._rpcProtocol=new T.RPCProtocol(w,null,t),S=d._transform(S,this._rpcProtocol);const r=new v.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:o}),r.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),r.set(D.IURITransformerService,new D.URITransformerService(t)),r.set(C.IHostUtils,p);const c=new I.InstantiationService(r,!0);c.invokeFunction(n.installEarlyHandler),this._logService=c.invokeFunction(m=>m.get(k.ILogService)),P.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=c.invokeFunction(m=>m.get(C.IExtHostExtensionService)),this._extensionService.initialize(),c.invokeFunction(n.installFullHandler)}async asBrowserUri(w){const S=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return l.URI.revive(await S.$asBrowserUri(w))}terminate(w){this._extensionService.terminate(w)}static _transform(w,S){w.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(S.transformIncomingURIs(t.extensionLocation))}),w.environment.appRoot=l.URI.revive(S.transformIncomingURIs(w.environment.appRoot));const p=w.environment.extensionDevelopmentLocationURI;return p&&(w.environment.extensionDevelopmentLocationURI=p.map(t=>l.URI.revive(S.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=l.URI.revive(S.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=l.URI.revive(S.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=l.URI.revive(S.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=l.URI.revive(S.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=l.URI.revive(S.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=l.URI.revive(S.transformIncomingURIs(w.logsLocation)),w.workspace=S.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=d}),define(Ce[310],De([1,0,19,14,191,209,217,86,60,43,20,42,7,50,35,235,237,36]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let h=class extends k.ExtHostDebugServiceBase{constructor(o,r,c,m,f,i,s){super(o,r,c,m,i,s),this._terminalService=f,this._integratedTerminalInstances=new p}createDebugAdapter(o,r){switch(o.type){case"server":return new E.SocketDebugAdapter(o);case"pipeServer":return new E.NamedPipeDebugAdapter(o);case"executable":return new E.ExecutableDebugAdapter(o,r.type)}return super.createDebugAdapter(o,r)}daExecutableFromPackage(o,r){const c=E.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),o.type);if(c)return new _.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new T.SignService}async $runInTerminal(o,r){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(X=>{this._integratedTerminalInstances.onTerminalClosed(X)}));const c=await this._configurationService.getConfigProvider(),m=this._terminalService.getDefaultShell(!0),f=this._terminalService.getDefaultShellArgs(!0),i=o.title||l.localize(0,null),s=JSON.stringify({shell:m,shellArgs:f});let u=await this._integratedTerminalInstances.checkout(s,i),b,g=!1;if(u)b=o.cwd;else{const X={shellPath:m,shellArgs:f,cwd:o.cwd,name:i,iconPath:new _.ThemeIcon("debug")};g=!0,u=this._terminalService.createTerminalFromOptions(X,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,s)}u.show(!0);const L=await u.processId;g?await new Promise(X=>setTimeout(X,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0||m.indexOf("cmd.exe")>=0?u.sendText("cls"):m.indexOf("bash")>=0?u.sendText("clear"):P.isWindows?u.sendText("cls"):u.sendText("clear"));const H=(0,n.prepareCommand)(m,o.args,!!o.argsCanBeInterpretedByShell,b,o.env);u.sendText(H);const q=this.onDidTerminateDebugSession(X=>{X.id===r&&(this._integratedTerminalInstances.free(u),q.dispose())});return L}else if(o.kind==="external")return S(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,r)}};h=$e([Be(0,R.IExtHostRpcService),Be(1,C.IExtHostWorkspace),Be(2,v.IExtHostExtensionService),Be(3,d.IExtHostConfiguration),Be(4,I.IExtHostTerminalService),Be(5,y.IExtHostEditorTabs),Be(6,D.IExtHostVariableResolverProvider)],h),e.ExtHostDebugService=h;let w;function S(t,o){if(!w)if(P.isWindows)w=new A.WindowsExternalTerminalService;else if(P.isMacintosh)w=new A.MacExternalTerminalService;else if(P.isLinux)w=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=o.getConfiguration("terminal");return w.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class p{constructor(){this._terminalInstances=new Map}async checkout(o,r){const m=[...this._terminalInstances.entries()].map(([f,i])=>(0,a.createCancelablePromise)(async s=>{if(f.name!==r||i.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await f.processId))return null;const u=Date.now();return i.lastUsedAt+p.minUseDelay>u||s.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=u,f)}));return await(0,a.firstParallel)(m,f=>!!f)}insert(o,r){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:r})}free(o){const r=this._terminalInstances.get(o);r&&(r.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}p.minUseDelay=1e3}),define(Ce[311],De([1,0,15,2,117,35,59,36,48,42,20,26,84,17,16,79,24,72,50]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends _.ExtHostTaskBase{constructor(p,t,o,r,c,m,f,i,s){super(p,t,o,r,c,m,f,i),this.workspaceService=o,this.variableResolver=s,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const r=_.TaskHandleDTO.from(o,this.workspaceService),c=await this._proxy.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const m=await this.getTaskExecution(c,t);return this._proxy.$executeTask(r).catch(()=>{}),m}else{const r=_.TaskDTO.from(t,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,t,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),t);return this._proxy.$executeTask(r).catch(()=>{}),c}}provideTasksInternal(p,t,o,r){const c=[];if(r)for(const m of r){this.checkDeprecation(m,o),(!m.definition||!p[m.definition.type])&&this._logService.warn(`The task [${m.source}, ${m.name}] uses an undefined task type. The task will be ignored in the future.`);const f=_.TaskDTO.from(m,o.extension);f&&(c.push(f),_.CustomExecutionDTO.is(f.execution)&&t.push(this.addCustomExecution(f,m,!0)))}return{tasks:c,extension:o.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const o=P.URI.file((0,d.homedir)());t=new y.WorkspaceFolder({uri:o,name:n.basename(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const o=P.URI.revive(p),r={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(o),m=await this._workspaceProvider.getWorkspaceFolders2()??[],f=await this.variableResolver.getResolver(),i=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(m);for(const s of t.variables)r.variables[s]=await f.resolveAsync(i,s);if(t.process!==void 0){let s;if(t.process.path!==void 0){s=t.process.path.split(a.delimiter);for(let u=0;u<s.length;u++)s[u]=await f.resolveAsync(i,s[u])}r.process=await l.win32.findExecutable(await f.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await f.resolveAsync(i,t.process.cwd):void 0,s)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,o){return l.win32.findExecutable(p,t,o)}};w=$e([Be(0,R.IExtHostRpcService),Be(1,I.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,T.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,v.IExtHostTerminalService),Be(6,C.ILogService),Be(7,E.IExtHostApiDeprecationService),Be(8,h.IExtHostVariableResolverProvider)],w),e.ExtHostTask=w}),define(Ce[312],De([1,0,72,50]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends P.ExtHostVariableResolverProviderService{homeDir(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(Ce[144],De([1,0,18,19,21,46,17,15,24,2,31]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(h,w,S,p){this.query=h,this.provider=w,this.fileUtils=S,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,w){const S=this.query.folderQueries||[],p=new l.CancellationTokenSource;return w.onCancellationRequested(()=>p.cancel()),new Promise((t,o)=>{this.collector=new D(h);let r=!1;const c=(m,f)=>{if(!r&&!this.isLimitHit){const i=this.resultSize(m);E(m)&&typeof this.query.maxResults=="number"&&this.resultCount+i>this.query.maxResults&&(this.isLimitHit=!0,r=!0,p.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const s=this.resultSize(m);this.resultCount+=s,(s>0||!E(m))&&this.collector.add(m,f)}};Promise.all(S.map((m,f)=>this.searchInFolder(m,i=>c(i,f),p.token))).then(m=>{p.dispose(),this.collector.flush();const f=m.some(i=>!!i&&!!i.limitHit);t({limitHit:this.isLimitHit||f,messages:(0,a.flatten)(m.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.processType}})},m=>{p.dispose();const f=(0,A.toErrorMessage)(m);o(new Error(f))})})}resultSize(h){return E(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,w){const S=Array.isArray(h.ranges)?h.ranges:[h.ranges],p=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:S.slice(0,w),preview:{matches:p.slice(0,w),text:h.preview.text},uri:h.uri}}async searchInFolder(h,w,S){const p=new R.QueryGlobTester(this.query,h),t=[],o={report:m=>{if(!this.validateProviderResult(m))return;const f=h.folder.scheme===T.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(m.uri))):void 0,i=y.relativePath(h.folder,m.uri);if(i){const s=p.includedInQuery(i,k.basename(i),f);(0,P.isThenable)(s)?t.push(s.then(u=>{u&&w(m)})):s&&w(m)}}},r=this.getSearchOptionsForFolder(h),c=await this.provider.provideTextSearchResults(_(this.query.contentPattern),r,o,S);return t.length&&await Promise.all(t),c}validateProviderResult(h){if(E(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const w=(0,R.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),S=(0,R.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),p={folder:v.URI.from(h.folder),excludes:S,includes:w,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=I;function _(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class D{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new n(512,w=>this.sendItems(w))}add(h,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!y.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(C(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=D;function C(d){return E(d)?{preview:{matches:(0,a.mapArrayOrNot)(d.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:d.preview.text},ranges:(0,a.mapArrayOrNot)(d.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function E(d){return!!d.preview}e.extensionResultIsMatch=E;class n{constructor(h,w){this.maxBatchSize=h,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,w){!h||this.addItemToBatch(h,w)}addItems(h,w){!h||this.addItemsToBatch(h,w)}addItemToBatch(h,w){this.batch.push(h),this.batchSize+=w,this.onUpdate()}addItemsToBatch(h,w){this.batch=this.batch.concat(h),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<n.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},n.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}n.TIMEOUT=4e3,n.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=n}),define(Ce[87],De([1,0,6,5,4,305,20,56,16,2,144]),function(re,e,a,P,l,A,T,k,y,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let I=class{constructor(E,n,d){this.extHostRpc=E,this._uriTransformer=n,this._logService=d,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}registerTextSearchProvider(E,n){if(this._textSearchUsedSchemes.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this._textSearchUsedSchemes.add(E);const d=this._handlePool++;return this._textSearchProvider.set(d,n),this._proxy.$registerTextSearchProvider(d,this._transformScheme(E)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(E),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(E,n){if(this._fileSearchUsedSchemes.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this._fileSearchUsedSchemes.add(E);const d=this._handlePool++;return this._fileSearchProvider.set(d,n),this._proxy.$registerFileSearchProvider(d,this._transformScheme(E)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(E),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(E,n,d,h){const w=_(d),S=this._fileSearchProvider.get(E);if(S)return this._fileSearchManager.fileSearch(w,S,p=>{this._proxy.$handleFileMatch(E,n,p.map(t=>t.resource))},h);throw new Error("unknown provider: "+E)}$clearCache(E){return this._fileSearchManager.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,n,d,h){const w=this._textSearchProvider.get(E);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const S=_(d);return this.createTextSearchManager(S,w).search(t=>this._proxy.$handleTextMatch(E,n,t),h)}$enableExtensionHostSearch(){}createTextSearchManager(E,n){return new R.TextSearchManager(E,n,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};I=$e([Be(0,T.IExtHostRpcService),Be(1,k.IURITransformerService),Be(2,y.ILogService)],I),e.ExtHostSearch=I;function _(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(D),extraFileResources:C.extraFileResources&&C.extraFileResources.map(E=>v.URI.revive(E))}}e.reviveQuery=_;function D(C){return{...C,folder:v.URI.revive(C.folder)}}}),define(Ce[313],De([1,0,21,8,3,38,2,122,108,154,166,45,5,97,261,260,41,262,36,264,265,266,247,267,59,43,268,269,274,275,276,143,251,282,283,284,100,42,286,252,11,7,75,289,82,142,35,25,239,273,74,140,84,86,87,16,56,20,26,277,246,55,79,258,287,81,80,292,290,291,259,49,285,288,99,60,78,278,83,279,17,125,250,228,270,6,27,233,98,224,280,281,272,271,249]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t,o,r,c,m,f,i,s,u,b,g,L,H,q,X,U,N,x,F,V,fe,se,$,J,te,be,le,ue,j,M,Y,ge,we,ie,ne,de,ee,ce,ae,O,B,K,Z,he,_e,Ae,Ee,ke,Ie,He,ze,tt,Qe,nt,st,Ue,it,z,Q,me,Re,Oe,Ve,Xe,Ke,rt,ct,bt,mt,Et,Dt,Rt,Qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Gt(ht){const gt=ht.get(ee.IExtHostInitDataService),Lt=ht.get(He.IExtHostFileSystemInfo),Ft=ht.get(_e.IExtHostConsumerFileSystem),kt=ht.get(c.IExtHostExtensionService),pt=ht.get(te.IExtHostWorkspace),yt=ht.get(st.IExtHostTelemetry),xt=ht.get(h.IExtHostConfiguration),It=ht.get(ne.IURITransformerService),Ge=ht.get(de.IExtHostRpcService),$t=ht.get(X.IExtHostStorage),Kt=ht.get(he.IExtensionStoragePaths),Nt=ht.get(ie.ILoggerService),Pe=ht.get(ie.ILogService),Le=ht.get(O.IExtHostTunnelService),ye=ht.get(B.IExtHostApiDeprecationService),oe=ht.get(J.IExtHostWindow),Me=ht.get(Qe.IExtHostSecretState),We=ht.get(nt.IExtHostEditorTabs);Ge.set(_.ExtHostContext.ExtHostFileSystemInfo,Lt),Ge.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Ge.set(_.ExtHostContext.ExtHostWorkspace,pt),Ge.set(_.ExtHostContext.ExtHostConfiguration,xt),Ge.set(_.ExtHostContext.ExtHostExtensionService,kt),Ge.set(_.ExtHostContext.ExtHostStorage,$t),Ge.set(_.ExtHostContext.ExtHostTunnelService,Le),Ge.set(_.ExtHostContext.ExtHostWindow,oe),Ge.set(_.ExtHostContext.ExtHostSecretState,Me),Ge.set(_.ExtHostContext.ExtHostTelemetry,yt),Ge.set(_.ExtHostContext.ExtHostEditorTabs,We);const Ze=Ge.set(_.ExtHostContext.ExtHostDecorations,ht.get(M.IExtHostDecorations)),je=Ge.set(_.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(r.IExtHostDocumentsAndEditors)),et=Ge.set(_.ExtHostContext.ExtHostCommands,ht.get(n.IExtHostCommands)),dt=Ge.set(_.ExtHostContext.ExtHostTerminalService,ht.get(U.IExtHostTerminalService)),ut=Ge.set(_.ExtHostContext.ExtHostDebugService,ht.get(ge.IExtHostDebugService)),Ct=Ge.set(_.ExtHostContext.ExtHostSearch,ht.get(we.IExtHostSearch)),vt=Ge.set(_.ExtHostContext.ExtHostTask,ht.get(Y.IExtHostTask)),Ot=Ge.set(_.ExtHostContext.ExtHostOutputService,ht.get(b.IExtHostOutputService)),Ut=Ge.set(_.ExtHostContext.ExtHostLocalization,ht.get(ct.IExtHostLocalizationService)),Ri=Ge.set(_.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(Ge)),Tt=Ge.set(_.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ge,je)),Ei=Ge.set(_.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ge,je,Pe)),ci=Ge.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Pe,Tt,Ge.getProxy(_.MainContext.MainThreadBulkEdits))),_t=Ge.set(_.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ge,et,je,Tt)),li=Ge.set(_.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(_t)),ui=Ge.set(_.ExtHostContext.ExtHostNotebookEditors,new Re.ExtHostNotebookEditors(Pe,_t)),ii=Ge.set(_.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(Ge,gt,_t,et,Pe)),wi=Ge.set(_.ExtHostContext.ExtHostNotebookRenderers,new z.ExtHostNotebookRenderers(Ge,_t)),Vt=Ge.set(_.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Qt.ExtHostNotebookDocumentSaveParticipant(Pe,_t,Ge.getProxy(_.MainContext.MainThreadBulkEdits))),Pt=Ge.set(_.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ge,je)),Li=Ge.set(_.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Ge.getProxy(_.MainContext.MainThreadTreeViews),et,Pe)),_i=Ge.set(_.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ge.getProxy(_.MainContext.MainThreadEditorInsets),Pt,gt.remote)),ni=Ge.set(_.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ge,Pe,Lt,je)),di=Ge.set(_.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ge,Tt,et.converter,It)),lt=Ge.set(_.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ge,It,Tt,et,ni,Pe,ye,yt)),Si=Ge.set(_.ExtHostContext.ExtHostFileSystem,new m.ExtHostFileSystem(Ge,lt)),jt=Ge.set(_.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ge,Pe,je)),Yt=Ge.set(_.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(Ge,pt,et)),hi=Ge.set(_.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(Ge,et,Pe)),yi=Ge.set(_.ExtHostContext.ExtHostQuickDiff,new Et.ExtHostQuickDiff(Ge,It)),Ci=Ge.set(_.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ge,et,Tt)),fi=Ge.set(_.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Ge.getProxy(_.MainContext.MainThreadProgress))),Di=Ge.set(_.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ge)),Oi=Ge.set(_.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ge)),Jt=Ge.set(_.ExtHostContext.ExtHostAuthentication,new K.ExtHostAuthentication(Ge)),Ii=Ge.set(_.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline(Ge,et)),ri=Ge.set(_.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Ge,gt.remote,pt,Pe,ye)),si=Ge.set(_.ExtHostContext.ExtHostWebviewPanels,new ke.ExtHostWebviewPanels(Ge,ri,pt)),Bi=Ge.set(_.ExtHostContext.ExtHostCustomEditors,new Ee.ExtHostCustomEditors(Ge,Tt,Kt,ri,si)),ki=Ge.set(_.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Ge,ri)),Zt=Ge.set(_.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ge,et,je)),zi=Ge.set(_.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ge)),Wi=Ge.set(_.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Ge));Ge.set(_.ExtHostContext.ExtHostInteractive,new Ve.ExtHostInteractive(Ge,_t,je,et,Pe));const Hi=Ge.set(_.ExtHostContext.ExtHostInteractiveEditor,new Rt.ExtHostInteractiveEditor(Ge,Tt,Pe)),mi=Ge.set(_.ExtHostContext.ExtHostInteractiveSession,new Dt.ExtHostInteractiveSession(Ge,Pe)),$i=Object.values(_.ExtHostContext);Ge.assertRegistered($i);const Vi=new Ie.ExtHostBulkEdits(Ge,je),Ti=new E.ExtHostClipboard(Ge),oi=new u.ExtHostMessageService(Ge,Pe),Mi=new S.ExtHostDialogs(Ge),Fi=new q.ExtHostStatusBar(Ge,et.converter);return C.ExtHostApiCommands.register(et),function(xe,Bt,Ni){const wt=function(){let ve=!xe.isUnderDevelopment;function Se(){ve||(Pe.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")Se();else{const St=ot;typeof St.scheme>"u"&&Se(),typeof St.exclusive=="boolean"&&(0,Ke.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return ot}}(),ji={getSession(ve,Se,Fe){return Jt.getSession(xe,ve,Se,Fe)},getSessions(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"getSessions"),Jt.getSessions(xe,ve,Se)},async hasSession(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"authSession"),!!await Jt.getSession(xe,ve,Se,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Fe,ot){return Jt.registerAuthenticationProvider(ve,Se,Fe,ot)}},qi={registerCommand(ve,Se,Fe){return et.registerCommand(!0,ve,Se,Fe,void 0,xe)},registerTextEditorCommand(ve,Se,Fe){return et.registerCommand(!0,ve,(...ot)=>{const St=Pt.getActiveTextEditor();if(!St){Pe.warn("Cannot execute "+ve+" because there is no active text editor.");return}return St.edit(At=>{Se.apply(Fe,[St,At,...ot])}).then(At=>{At||Pe.warn("Edits from command "+ve+" were not applied.")},At=>{Pe.warn("An error occurred while running command "+ve,At)})},void 0,void 0,xe)},registerDiffInformationCommand:(ve,Se,Fe)=>((0,Ke.checkProposedApiEnabled)(xe,"diffCommand"),et.registerCommand(!0,ve,async(...ot)=>{const St=je.activeEditor(!0);if(!St){Pe.warn("Cannot execute "+ve+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(St.id);Se.apply(Fe,[At,...ot])},void 0,void 0,xe)),executeCommand(ve,...Se){return et.executeCommand(ve,...Se)},getCommands(ve=!1){return et.getCommands(ve)}},gi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ke.checkProposedApiEnabled)(xe,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(xe,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(xe,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,st.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,Se){return st.ExtHostTelemetryLogger.validateSender(ve),yt.instantiateLogger(xe,ve,Se)},openExternal(ve,Se){return oe.openUri(ve,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===gt.environment.appUriScheme)return Ri.createAppUri(ve);try{return await oe.asExternalUri(ve,{allowTunneling:!!gt.remote.authority})}catch(Se){if((0,me.matchesScheme)(ve,Q.Schemas.http)||(0,me.matchesScheme)(ve,Q.Schemas.https))return ve;throw Se}},get remoteName(){return(0,j.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ke.checkProposedApiEnabled)(xe,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Pe.getLevel()},get onDidChangeLogLevel(){return Pe.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(gi);const Gi={createTestController(ve,Se,Fe){return Zt.createTestController(xe,ve,Se,Fe)},createTestObserver(){return(0,Ke.checkProposedApiEnabled)(xe,"testObserver"),Zt.createTestObserver()},runTests(ve){return(0,Ke.checkProposedApiEnabled)(xe,"testObserver"),Zt.runTests(ve)},get onDidChangeTestResults(){return(0,Ke.checkProposedApiEnabled)(xe,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Ke.checkProposedApiEnabled)(xe,"testObserver"),Zt.results}},zt=gt.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,pi={getExtension(ve,Se){(0,Ke.isProposedApiEnabled)(xe,"extensionsAny")||(Se=!1);const Fe=Bt.mine.getExtensionDescription(ve);if(Fe)return new c.Extension(kt,xe.identifier,Fe,zt,!1);if(Se){const ot=Bt.all.getExtensionDescription(ve);if(ot)return new c.Extension(kt,xe.identifier,ot,zt,!0)}},get all(){const ve=[];for(const Se of Bt.mine.getAllExtensionDescriptions())ve.push(new c.Extension(kt,xe.identifier,Se,zt,!1));return ve},get allAcrossExtensionHosts(){(0,Ke.checkProposedApiEnabled)(xe,"extensionsAny");const ve=new be.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),Se=[];for(const Fe of Bt.all.getAllExtensionDescriptions()){const ot=!ve.has(Fe.identifier);Se.push(new c.Extension(kt,xe.identifier,Fe,zt,ot))}return Se},get onDidChange(){return(0,Ke.isProposedApiEnabled)(xe,"extensionsAny")?l.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Ki={createDiagnosticCollection(ve){return ni.createDiagnosticCollection(xe.identifier,ve)},get onDidChangeDiagnostics(){return ni.onDidChangeDiagnostics},getDiagnostics:ve=>ni.getDiagnostics(ve),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(ve,Se){return di.changeLanguage(ve.uri,Se)},match(ve,Se){const Fe=Tt.getDocumentData(Se.uri)?.notebook;return(0,R.score)(F.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ve,Se,Fe){return lt.registerCodeActionProvider(xe,wt(ve),Se,Fe)},registerDocumentPasteEditProvider(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"documentPaste"),lt.registerDocumentPasteEditProvider(xe,wt(ve),Se,Fe)},registerCodeLensProvider(ve,Se){return lt.registerCodeLensProvider(xe,wt(ve),Se)},registerDefinitionProvider(ve,Se){return lt.registerDefinitionProvider(xe,wt(ve),Se)},registerDeclarationProvider(ve,Se){return lt.registerDeclarationProvider(xe,wt(ve),Se)},registerImplementationProvider(ve,Se){return lt.registerImplementationProvider(xe,wt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return lt.registerTypeDefinitionProvider(xe,wt(ve),Se)},registerHoverProvider(ve,Se){return lt.registerHoverProvider(xe,wt(ve),Se,xe.identifier)},registerEvaluatableExpressionProvider(ve,Se){return lt.registerEvaluatableExpressionProvider(xe,wt(ve),Se,xe.identifier)},registerInlineValuesProvider(ve,Se){return lt.registerInlineValuesProvider(xe,wt(ve),Se,xe.identifier)},registerDocumentHighlightProvider(ve,Se){return lt.registerDocumentHighlightProvider(xe,wt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return lt.registerLinkedEditingRangeProvider(xe,wt(ve),Se)},registerReferenceProvider(ve,Se){return lt.registerReferenceProvider(xe,wt(ve),Se)},registerRenameProvider(ve,Se){return lt.registerRenameProvider(xe,wt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Fe){return lt.registerDocumentSymbolProvider(xe,wt(ve),Se,Fe)},registerWorkspaceSymbolProvider(ve){return lt.registerWorkspaceSymbolProvider(xe,ve)},registerDocumentFormattingEditProvider(ve,Se){return lt.registerDocumentFormattingEditProvider(xe,wt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return lt.registerDocumentRangeFormattingEditProvider(xe,wt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(xe,wt(ve),Se,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ve,Se,Fe){return lt.registerDocumentSemanticTokensProvider(xe,wt(ve),Se,Fe)},registerDocumentRangeSemanticTokensProvider(ve,Se,Fe){return lt.registerDocumentRangeSemanticTokensProvider(xe,wt(ve),Se,Fe)},registerSignatureHelpProvider(ve,Se,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(xe,wt(ve),Se,Fe):lt.registerSignatureHelpProvider(xe,wt(ve),Se,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ve,Se,...Fe){return lt.registerCompletionItemProvider(xe,wt(ve),Se,Fe)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,Ke.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,Ke.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(xe,wt(ve),Se)},registerDocumentLinkProvider(ve,Se){return lt.registerDocumentLinkProvider(xe,wt(ve),Se)},registerColorProvider(ve,Se){return lt.registerColorProvider(xe,wt(ve),Se)},registerFoldingRangeProvider(ve,Se){return lt.registerFoldingRangeProvider(xe,wt(ve),Se)},registerSelectionRangeProvider(ve,Se){return lt.registerSelectionRangeProvider(xe,ve,Se)},registerCallHierarchyProvider(ve,Se){return lt.registerCallHierarchyProvider(xe,ve,Se)},registerTypeHierarchyProvider(ve,Se){return lt.registerTypeHierarchyProvider(xe,ve,Se)},setLanguageConfiguration:(ve,Se)=>lt.setLanguageConfiguration(xe,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"tokenInformation"),di.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return lt.registerInlayHintsProvider(xe,ve,Se)},createLanguageStatusItem(ve,Se){return di.createLanguageStatusItem(xe,ve,Se)},registerDocumentDropEditProvider(ve,Se){return lt.registerDocumentOnDropEditProvider(xe,ve,Se)}},Wt={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ve,Se,Fe){const ot=await(T.URI.isUri(ve)?Promise.resolve(ai.openTextDocument(ve)):Promise.resolve(ve));return Pt.showTextDocument(ot,Se,Fe)},createTextEditorDecorationType(ve){return Pt.createTextEditorDecorationType(xe,ve)},onDidChangeActiveTextEditor(ve,Se,Fe){return Pt.onDidChangeActiveTextEditor(ve,Se,Fe)},onDidChangeVisibleTextEditors(ve,Se,Fe){return Pt.onDidChangeVisibleTextEditors(ve,Se,Fe)},onDidChangeTextEditorSelection(ve,Se,Fe){return Pt.onDidChangeTextEditorSelection(ve,Se,Fe)},onDidChangeTextEditorOptions(ve,Se,Fe){return Pt.onDidChangeTextEditorOptions(ve,Se,Fe)},onDidChangeTextEditorVisibleRanges(ve,Se,Fe){return Pt.onDidChangeTextEditorVisibleRanges(ve,Se,Fe)},onDidChangeTextEditorViewColumn(ve,Se,Fe){return Pt.onDidChangeTextEditorViewColumn(ve,Se,Fe)},onDidCloseTerminal(ve,Se,Fe){return dt.onDidCloseTerminal(ve,Se,Fe)},onDidOpenTerminal(ve,Se,Fe){return dt.onDidOpenTerminal(ve,Se,Fe)},onDidChangeActiveTerminal(ve,Se,Fe){return dt.onDidChangeActiveTerminal(ve,Se,Fe)},onDidChangeTerminalDimensions(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"terminalDimensions"),dt.onDidChangeTerminalDimensions(ve,Se,Fe)},onDidChangeTerminalState(ve,Se,Fe){return dt.onDidChangeTerminalState(ve,Se,Fe)},onDidWriteTerminalData(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(ve,Se,Fe)},get state(){return oe.state},onDidChangeWindowState(ve,Se,Fe){return oe.onDidChangeWindowState(ve,Se,Fe)},showInformationMessage(ve,...Se){return oi.showMessage(xe,A.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return oi.showMessage(xe,A.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return oi.showMessage(xe,A.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Fe){return Yt.showQuickPick(xe,ve,Se,Fe)},showWorkspaceFolderPick(ve){return Yt.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return Yt.showInput(ve,Se)},showOpenDialog(ve){return Mi.showOpenDialog(xe,ve)},showSaveDialog(ve){return Mi.showSaveDialog(ve)},createStatusBarItem(ve,Se,Fe){let ot,St,At;return typeof ve=="string"?(ot=ve,St=Se,At=Fe):(St=ve,At=Se),Fi.createStatusBarEntry(xe,ot,St,At)},setStatusBarMessage(ve,Se){return Fi.setStatusBarMessage(ve,Se)},withScmProgress(ve){return ye.report("window.withScmProgress",xe,"Use 'withProgress' instead."),fi.withProgress(xe,{location:V.ProgressLocation.SourceControl},(Se,Fe)=>ve({report(ot){}}))},withProgress(ve,Se){return fi.withProgress(xe,ve,Se)},createOutputChannel(ve,Se){return Ot.createOutputChannel(ve,Se,xe)},createWebviewPanel(ve,Se,Fe,ot){return si.createWebviewPanel(xe,ve,Se,Fe,ot)},createWebviewTextEditorInset(ve,Se,Fe,ot){return(0,Ke.checkProposedApiEnabled)(xe,"editorInsets"),_i.createWebviewEditorInset(ve,Se,Fe,ot,xe)},createTerminal(ve,Se,Fe){return typeof ve=="object"?"pty"in ve?dt.createExtensionTerminal(ve):dt.createTerminalFromOptions(ve):dt.createTerminal(ve,Se,Fe)},registerTerminalLinkProvider(ve){return dt.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return dt.registerProfileProvider(xe,ve,Se)},registerTerminalQuickFixProvider(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(ve,xe.identifier.value,Se)},registerTreeDataProvider(ve,Se){return Li.registerTreeDataProvider(ve,Se,xe)},createTreeView(ve,Se){return Li.createTreeView(ve,Se,xe)},registerWebviewPanelSerializer:(ve,Se)=>si.registerWebviewPanelSerializer(xe,ve,Se),registerCustomEditorProvider:(ve,Se,Fe={})=>Bi.registerCustomEditorProvider(xe,ve,Se,Fe),registerFileDecorationProvider(ve){return Ze.registerFileDecorationProvider(ve,xe)},registerUriHandler(ve){return Ri.registerUriHandler(xe.identifier,ve)},createQuickPick(){return Yt.createQuickPick(xe)},createInputBox(){return Yt.createInputBox(xe)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Fe){return Oi.onDidChangeActiveColorTheme(ve,Se,Fe)},registerWebviewViewProvider(ve,Se,Fe){return ki.registerWebviewViewProvider(xe,ve,Se,Fe?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Fe){return _t.onDidChangeActiveNotebookEditor(ve,Se,Fe)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Fe){return ui.onDidChangeNotebookEditorSelection(ve,Se,Fe)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Fe){return ui.onDidChangeNotebookEditorVisibleRanges(ve,Se,Fe)},showNotebookDocument(ve,Se){return _t.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"externalUriOpener"),zi.registerExternalUriOpener(xe.identifier,ve,Se,Fe)},registerProfileContentHandler(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"profileContentHandlers"),Wi.registrProfileContentHandler(xe,ve,Se)},registerQuickDiffProvider(ve,Se,Fe,ot){return(0,Ke.checkProposedApiEnabled)(xe,"quickDiffProvider"),yi.registerQuickDiffProvider(wt(ve),Se,Fe,ot)},get tabGroups(){return We.tabGroups}},ai={get rootPath(){return ye.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ve){throw P.readonly()},getWorkspaceFolder(ve){return pt.getWorkspaceFolder(ve)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ve){throw P.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ve){throw P.readonly()},updateWorkspaceFolders:(ve,Se,...Fe)=>pt.updateWorkspaceFolders(xe,ve,Se||0,...Fe),onDidChangeWorkspaceFolders:function(ve,Se,Fe){return pt.onDidChangeWorkspace(ve,Se,Fe)},asRelativePath:(ve,Se)=>pt.getRelativePath(ve,Se),findFiles:(ve,Se,Fe,ot)=>pt.findFiles(ve,Se,Fe,xe.identifier,ot),findTextInFiles:(ve,Se,Fe,ot)=>{(0,Ke.checkProposedApiEnabled)(xe,"findTextInFiles");let St,At;return typeof Se=="object"?(St=Se,At=Fe):(St={},At=Se,ot=Fe),pt.findTextInFiles(ve,St||{},At,xe.identifier,ot)},saveAll:ve=>pt.saveAll(ve),applyEdit(ve,Se){return Vi.applyWorkspaceEdit(ve,xe,Se)},createFileSystemWatcher:(ve,Se,Fe,ot)=>jt.createFileSystemWatcher(pt,xe,ve,Se,Fe,ot),get textDocuments(){return Tt.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw P.readonly()},openTextDocument(ve){let Se;const Fe=ve;if(typeof ve=="string")Se=Promise.resolve(T.URI.file(ve));else if(T.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Fe||typeof Fe=="object")Se=Tt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ot=>Tt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(ve,Se,Fe)=>Tt.onDidAddDocument(ve,Se,Fe),onDidCloseTextDocument:(ve,Se,Fe)=>Tt.onDidRemoveDocument(ve,Se,Fe),onDidChangeTextDocument:(ve,Se,Fe)=>Tt.onDidChangeDocument(ve,Se,Fe),onDidSaveTextDocument:(ve,Se,Fe)=>Tt.onDidSaveDocument(ve,Se,Fe),onWillSaveTextDocument:(ve,Se,Fe)=>ci.getOnWillSaveTextDocumentEvent(xe)(ve,Se,Fe),get notebookDocuments(){return _t.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Fe;if(T.URI.isUri(ve))Fe=ve,await _t.openNotebookDocument(ve);else if(typeof ve=="string")Fe=T.URI.revive(await _t.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ve,Se,Fe){return li.onDidSaveNotebookDocument(ve,Se,Fe)},onDidChangeNotebookDocument(ve,Se,Fe){return li.onDidChangeNotebookDocument(ve,Se,Fe)},onWillSaveNotebookDocument(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"notebookDocumentWillSave"),Vt.getOnWillSaveNotebookDocumentEvent(xe)(ve,Se,Fe)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Fe,ot){return _t.registerNotebookSerializer(xe,ve,Se,Fe,(0,Ke.isProposedApiEnabled)(xe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ve,Se,Fe)=>Ni.onDidChangeConfiguration(ve,Se,Fe),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,Ni.getConfiguration(ve,Se,xe)},registerTextDocumentContentProvider(ve,Se){return Ei.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(ye.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(xe,ve,Se)),registerFileSystemProvider(ve,Se,Fe){return(0,Xe.combinedDisposable)(Si.registerFileSystemProvider(xe,ve,Se,Fe),Ft.addFileSystemProvider(ve,Se))},get fs(){return Ft.value},registerFileSearchProvider:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"fileSearchProvider"),Ct.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"textSearchProvider"),Ct.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"resolvers"),kt.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,Ke.checkProposedApiEnabled)(xe,"resolvers"),Di.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Fe)=>jt.onDidCreateFile(ve,Se,Fe),onDidDeleteFiles:(ve,Se,Fe)=>jt.onDidDeleteFile(ve,Se,Fe),onDidRenameFiles:(ve,Se,Fe)=>jt.onDidRenameFile(ve,Se,Fe),onWillCreateFiles:(ve,Se,Fe)=>jt.getOnWillCreateFileEvent(xe)(ve,Se,Fe),onWillDeleteFiles:(ve,Se,Fe)=>jt.getOnWillDeleteFileEvent(xe)(ve,Se,Fe),onWillRenameFiles:(ve,Se,Fe)=>jt.getOnWillRenameFileEvent(xe)(ve,Se,Fe),openTunnel:ve=>((0,Ke.checkProposedApiEnabled)(xe,"tunnels"),Le.openTunnel(xe,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Ke.checkProposedApiEnabled)(xe,"tunnels"),Le.getTunnels()},onDidChangeTunnels:(ve,Se,Fe)=>((0,Ke.checkProposedApiEnabled)(xe,"tunnels"),Le.onDidChangeTunnels(ve,Se,Fe)),registerPortAttributesProvider:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"portsAttributes"),Le.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"timeline"),Ii.registerTimelineProvider(ve,Se,xe.identifier,et.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ve=>((0,Ke.checkProposedApiEnabled)(xe,"workspaceTrust"),pt.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Fe)=>pt.onDidGrantWorkspaceTrust(ve,Se,Fe),registerEditSessionIdentityProvider:(ve,Se)=>((0,Ke.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ve,Se)),onWillCreateEditSessionIdentity:(ve,Se,Fe)=>((0,Ke.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent(xe)(ve,Se,Fe))},Xi={get inputBox(){return ye.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(xe)},createSourceControl(ve,Se,Fe){return hi.createSourceControl(xe,ve,Se,Fe)}},Qi={createCommentController(ve,Se){return Ci.createCommentController(xe,ve,Se)}},Yi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(ve,Se,Fe){return ut.onDidStartDebugSession(ve,Se,Fe)},onDidTerminateDebugSession(ve,Se,Fe){return ut.onDidTerminateDebugSession(ve,Se,Fe)},onDidChangeActiveDebugSession(ve,Se,Fe){return ut.onDidChangeActiveDebugSession(ve,Se,Fe)},onDidReceiveDebugSessionCustomEvent(ve,Se,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ve,Se,Fe)},onDidChangeBreakpoints(ve,Se,Fe){return ut.onDidChangeBreakpoints(ve,Se,Fe)},registerDebugConfigurationProvider(ve,Se,Fe){return ut.registerDebugConfigurationProvider(ve,Se,Fe||rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return ut.registerDebugAdapterDescriptorFactory(xe,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return ut.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ve,Se,{parentSession:Fe}):ut.startDebugging(ve,Se,Fe||{})},stopDebugging(ve){return ut.stopDebugging(ve)},addBreakpoints(ve){return ut.addBreakpoints(ve)},removeBreakpoints(ve){return ut.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return ut.asDebugSourceUri(ve,Se)}},Ji={registerTaskProvider:(ve,Se)=>vt.registerTaskProvider(xe,ve,Se),fetchTasks:ve=>vt.fetchTasks(ve),executeTask:ve=>vt.executeTask(xe,ve),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ve,Se,Fe)=>vt.onDidStartTask(ve,Se,Fe),onDidEndTask:(ve,Se,Fe)=>vt.onDidEndTask(ve,Se,Fe),onDidStartTaskProcess:(ve,Se,Fe)=>vt.onDidStartTaskProcess(ve,Se,Fe),onDidEndTaskProcess:(ve,Se,Fe)=>vt.onDidEndTaskProcess(ve,Se,Fe)},Zi={createNotebookController(ve,Se,Fe,ot,St){return ii.createNotebookController(xe,ve,Se,Fe,ot,(0,Ke.isProposedApiEnabled)(xe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>_t.registerNotebookCellStatusBarItemProvider(xe,ve,Se),createRendererMessaging(ve){return wi.createRendererMessaging(xe,ve)},createNotebookControllerDetectionTask(ve){return(0,Ke.checkProposedApiEnabled)(xe,"notebookKernelSource"),ii.createNotebookControllerDetectionTask(xe,ve)},registerKernelSourceActionProvider(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"notebookKernelSource"),ii.registerKernelSourceActionProvider(xe,ve,Se)},onDidChangeNotebookCellExecutionState(ve,Se,Fe){return(0,Ke.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(ve,Se,Fe)}},en={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Fe=!ve||typeof ve[0]!="object"?ve:ve[0];return Ut.getMessage(xe.identifier.value,{message:Se,args:Fe})}return Ut.getMessage(xe.identifier.value,ve[0])},get bundle(){return Ut.getBundle(xe.identifier.value)},get uri(){return Ut.getBundleUri(xe.identifier.value)}},tn={_version:1,registerInteractiveEditorSessionProvider(ve){return(0,Ke.checkProposedApiEnabled)(xe,"interactive"),Hi.registerProvider(xe,ve)},registerInteractiveSessionProvider(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"interactive"),mi.registerInteractiveSessionProvider(xe,ve,Se)},addInteractiveRequest(ve){return(0,Ke.checkProposedApiEnabled)(xe,"interactive"),mi.addInteractiveSessionRequest(ve)},sendInteractiveRequestToProvider(ve,Se){return(0,Ke.checkProposedApiEnabled)(xe,"interactive"),mi.sendInteractiveRequestToProvider(ve,Se)},get onDidPerformUserAction(){return mi.onDidPerformUserAction}};return{version:gt.version,authentication:ji,commands:qi,comments:Qi,debug:Yi,env:gi,extensions:pi,interactive:tn,l10n:en,languages:Ki,notebooks:Zi,scm:Xi,tasks:Ji,tests:Gi,window:Wt,workspace:ai,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:v.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:D.UIKind,Uri:T.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookDocumentSaveReason:V.NotebookDocumentSaveReason,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestRunRequest2:V.TestRunRequest2,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:ie.LogLevel,EditSessionIdentityMatch:bt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Gt}),define(Ce[314],De([1,0,91,143,35,140,36,41,59,42,84,86,87,100,55,79,142,80,49,99,78,60,141,16,50,98]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t,o,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,t.ExtHostLoggerService,1),(0,a.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands,0),(0,a.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,a.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,a.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch,0),(0,a.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(v.IExtHostTerminalService,v.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,a.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,a.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,a.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,a.registerSingleton)(S.IExtHostTelemetry,S.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ce[101],De([1,0,18,16,31,83]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function k(I,_,D,C){const E=(0,a.mapArrayOrNot)(D,y),n=new l.TextSearchMatch(_,E,C),d=n.preview.matches;return{ranges:(0,a.mapArrayOrNot)(E,v),uri:I,preview:{text:n.preview.text,matches:(0,a.mapArrayOrNot)(d,v)}}}e.createTextSearchResult=k;function y(I){return new l.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function v(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(_,D){this.prefix=_,this.logService=D}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};R=$e([Be(1,P.ILogService)],R),e.OutputChannel=R}),define(Ce[315],De([1,0,47,15,88,34,14,9,101,316]),function(re,e,a,P,l,A,T,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(w,S,p,t){const o=_(w,S,p,t),r=S.folder.fsPath;return{cmd:a.spawn(R,o.args,{cwd:r}),rgDiskPath:R,siblingClauses:o.siblingClauses,rgArgs:o,cwd:r}}e.spawnRipgrepCmd=I;function _(w,S,p,t){const o=["--files","--hidden","--case-sensitive"];C([S],p,!1).forEach(c=>{const m=(0,y.anchorGlob)(c);if(o.push("-g",m),T.isMacintosh){const f=(0,l.normalizeNFD)(m);f!==m&&o.push("-g",f)}});const r=D([S],t,void 0,!1);return r.globArgs.forEach(c=>{const m=`!${(0,y.anchorGlob)(c)}`;if(o.push("-g",m),T.isMacintosh){const f=(0,l.normalizeNFD)(m);f!==m&&o.push("-g",f)}}),S.disregardIgnoreFiles!==!1?o.push("--no-ignore"):S.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),S.ignoreSymlinks||o.push("--follow"),w.exists&&o.push("--quiet"),o.push("--no-config"),S.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:r.siblingClauses}}function D(w,S,p,t=!0){const o=[];let r={};return w.forEach(c=>{const m=Object.assign({},c.excludePattern||{},S||{}),f=E(m,t?c.folder.fsPath:void 0,p);o.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:o,siblingClauses:r}}function C(w,S,p=!0){const t=[];return w.forEach(o=>{const r=Object.assign({},S||{},o.includePattern||{}),c=E(r,p?o.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function E(w,S,p){const t=[],o={};return Object.keys(w).forEach(r=>{if(p&&p.has(r)||!r)return;const c=w[r];r=d(S?n(S,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(h(r))):c&&c.when&&(o[r]=c)}),{globArgs:t,siblingClauses:o}}function n(w,S){return P.isAbsolute(S)?S:P.join(w,S)}e.getAbsoluteGlob=n;function d(w){return w=k.rtrim(w,"\\"),k.rtrim(w,"/")}function h(w){return A.getRoot(w).toLowerCase()==="c:/"?w.replace(/^c:[/\\]/i,"/"):w}e.fixDriveC=h}),define(Ce[317],De([1,0,47,71,15,318,18,46,39,88,34,14,37,9,10,29,31,315,112]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const w=new Set;process.on("exit",()=>{w.forEach(r=>r())});class S{constructor(c){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=c,this.filePattern=c.filePattern||"",this.includePattern=c.includePattern&&y.parse(c.includePattern),this.maxResults=c.maxResults||null,this.exists=!!c.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,h.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=c.excludePattern&&y.parse(c.excludePattern),this.folderExcludePatterns=new Map,c.folderQueries.forEach(m=>{const f=Object.assign({},m.excludePattern||{},this.config.excludePattern||{}),i=m.folder.fsPath;c.folderQueries.map(s=>s.folder.fsPath).filter(s=>s!==i).forEach(s=>{(0,R.isEqualOrParent)(s,i)&&(f[l.relative(i,s)]=!0)}),this.folderExcludePatterns.set(i,new t(f,i))})}cancel(){this.isCanceled=!0,w.forEach(c=>c())}walk(c,m,f,i,s){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return s(null,this.isLimitHit);m.forEach(u=>{const b=l.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,b)||this.matchFile(f,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(c,(u,b)=>{this.call(this.cmdTraversal,this,u,f,i,g=>{if(g){const L=(0,k.toErrorMessage)(g);console.error(L),this.errors.push(L),b(g,void 0)}else b(null,void 0)})},(u,b)=>{this.fileWalkSW.stop();const g=u?T.coalesce(u)[0]:null;s(g,this.isLimitHit)})}parallel(c,m,f){const i=new Array(c.length),s=new Array(c.length);let u=!1,b=0;if(c.length===0)return f(null,[]);c.forEach((g,L)=>{m(g,(H,q)=>{if(H?(u=!0,i[L]=null,s[L]=H):(i[L]=q,s[L]=null),++b===c.length)return f(u?s:null,i)})})}call(c,m,...f){try{c.apply(m,f)}catch(i){f[f.length-1](i)}}cmdTraversal(c,m,f,i){const s=c.folder.fsPath,u=I.isMacintosh,b=()=>X&&X.kill();w.add(b);let g=F=>{w.delete(b),g=()=>{},i(F)},L="";const H=this.initDirectoryTree(),q=(0,d.spawnRipgrepCmd)(this.config,c,this.config.includePattern,this.folderExcludePatterns.get(c.folder.fsPath).expression),X=q.cmd,U=!Object.keys(q.siblingClauses).length,N=q.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${q.rgDiskPath} ${N}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),f({message:x}),this.cmdResultCount=0,this.collectStdout(X,"utf8",f,(F,V,fe)=>{if(F){g(F);return}if(this.isLimitHit){g();return}const $=(L+(u?v.normalizeNFC(V||""):V)).split(`
`);if(fe){const J=$.length;$[J-1]=$[J-1].trim(),$[J-1]||$.pop()}else L=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){g(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,U){for(const J of $)if(this.matchFile(m,{base:s,relativePath:J,searchPath:this.getSearchPath(c,J)}),this.isLimitHit){b();break}(fe||this.isLimitHit)&&g();return}this.addDirectoryEntries(c,H,s,$,m),fe&&(this.matchDirectoryTree(H,s,m),g())})}spawnFindCmd(c){const m=this.folderExcludePatterns.get(c.folder.fsPath),f=m.getBasenameTerms(),i=m.getPathTerms(),s=["-L","."];if(f.length||i.length){s.push("-not","(","(");for(const u of f)s.push("-name",u),s.push("-o");for(const u of i)s.push("-path",u),s.push("-o");s.pop(),s.push(")","-prune",")")}return s.push("-type","f"),a.spawn("find",s,{cwd:c.folder.fsPath})}readStdout(c,m,f){let i="";this.collectStdout(c,m,()=>{},(s,u,b)=>{if(s){f(s);return}i+=u,b&&f(null,i)})}collectStdout(c,m,f,i){let s=(g,L,H)=>{(g||H)&&(s=()=>{},this.cmdSW?.stop()),i(g,L,H)},u=!1;c.stdout?(this.forwardData(c.stdout,m,s),c.stdout.once("data",()=>u=!0)):f({message:"stdout is null"});let b;c.stderr?b=this.collectData(c.stderr):f({message:"stderr is null"}),c.on("error",g=>{s(g)}),c.on("close",g=>{let L;!u&&(L=this.decodeData(b,m))&&o(L)?s(new Error(`command failed with error code ${g}: ${this.decodeData(b,m)}`)):(this.exists&&g===0&&(this.isLimitHit=!0),s(null,"",!0))})}forwardData(c,m,f){const i=new A.StringDecoder(m);return c.on("data",s=>{f(null,i.write(s))}),i}collectData(c){const m=[];return c.on("data",f=>{m.push(f)}),m}decodeData(c,m){const f=new A.StringDecoder(m);return c.map(i=>f.write(i)).join("")}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries(c,{pathToEntries:m},f,i,s){i.indexOf(this.filePattern)!==-1&&this.matchFile(s,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(c,this.filePattern)});const u=b=>{const g=l.basename(b),L=l.dirname(b);let H=m[L];H||(H=m[L]=[],u(L)),H.push({base:f,relativePath:b,basename:g,searchPath:this.getSearchPath(c,b)})};i.forEach(u)}matchDirectoryTree({rootEntries:c,pathToEntries:m},f,i){const s=this,u=this.folderExcludePatterns.get(f),b=this.filePattern;function g(L){s.directoriesWalked++;const H=(0,n.hasSiblingFn)(()=>L.map(q=>q.basename));for(let q=0,X=L.length;q<X;q++){const U=L[q],{relativePath:N,basename:x}=U;if(u.test(N,x,b!==x?H:void 0))continue;const F=m[N];if(F)g(F);else{if(s.filesWalked++,N===b)continue;s.matchFile(i,U)}if(s.isLimitHit)break}}g(c)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(c,m,f,i,s){const u=c.folder,b=(0,n.hasSiblingFn)(()=>f);this.parallel(f,(g,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const H=m?[m,g].join(l.sep):g;if(this.folderExcludePatterns.get(c.folder.fsPath).test(H,g,this.config.filePattern!==g?b:void 0))return L(null);const q=[u.fsPath,H].join(l.sep);P.lstat(q,(X,U)=>{if(X||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(q,U,(N,x)=>N||this.isCanceled||this.isLimitHit?L(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(q,U,(F,V)=>F||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?L(null):(this.walkedPaths[V]=!0,E.Promises.readdir(q).then(fe=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(c,H,fe,i,se=>L(se||null))},fe=>{L(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&C.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(i,{base:u.fsPath,relativePath:H,searchPath:this.getSearchPath(c,H)}),L(null,void 0)))})},g=>{const L=g&&T.coalesce(g);return s(L&&L.length>0?L[0]:void 0)})}matchFile(c,m){this.isFileMatch(m)&&(!this.includePattern||this.includePattern(m.relativePath,l.basename(m.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||c(m))}isFileMatch(c){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,n.isFilePatternMatch)(c,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(c,m,f){return m.isSymbolicLink()?P.stat(c,f):f(null,m)}realPathIfNeeded(c,m,f){return m.isSymbolicLink()?P.realpath(c,(i,s)=>i?f(i):f(null,s)):f(null,c)}getSearchPath(c,m){return c.folderName?l.join(c.folderName,m):m}}e.FileWalker=S;class p{constructor(c){this.folderQueries=c.folderQueries,this.extraFiles=c.extraFileResources||[],this.walker=new S(c)}search(c,m,f){this.walker.walk(this.folderQueries,this.extraFiles,c,m,(i,s)=>{f(i,{limitHit:s,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(c,m){this.expression=c,this.root=m,this.init(c)}init(c){let m,f;Object.keys(c).filter(i=>c[i]).forEach(i=>{l.isAbsolute(i)?(m=m||y.getEmptyExpression(),m[i]=c[i]):(f=f||y.getEmptyExpression(),f[i]=c[i])}),this.absoluteParsedExpr=m&&y.parse(m,{trimForExclusions:!0}),this.relativeParsedExpr=f&&y.parse(f,{trimForExclusions:!0})}test(c,m,f){return this.relativeParsedExpr&&this.relativeParsedExpr(c,m,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(l.join(this.root,c),m,f)}getBasenameTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...y.getBasenameTerms(this.relativeParsedExpr)),c}getPathTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...y.getPathTerms(this.relativeParsedExpr)),c}}function o(r){const c=r.trim().split(`
`),m=c[0].trim();if(m.startsWith("Error parsing regex"))return m;if(m.startsWith("regex parse error"))return D.uppercaseFirstLetter(c[c.length-1].trim());if(m.startsWith("error parsing glob")||m.startsWith("unsupported encoding"))return m.charAt(0).toUpperCase()+m.substr(1);if(m==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(m.startsWith("Literal "))return m}}),define(Ce[319],De([1,0,104,22]),function(re,e,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,T=512,k=512*8,y=512*128;var v;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(v=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(c,m){super(c),this.decodeStreamErrorKind=m}}e.DecodeStreamError=R;class I{static async create(c){let m;if(c!==e.UTF8)m=(await new Promise((i,s)=>{re(["@vscode/iconv-lite-umd"],i,s)})).getDecoder(E(c));else{const f=new TextDecoder;m={write(i){return f.decode(i,{stream:!0})},end(){return f.decode()}}}return new I(m)}constructor(c){this.iconvLiteDecoder=c}write(c){return this.iconvLiteDecoder.write(c)}end(){return this.iconvLiteDecoder.end()}}function _(r,c){const m=c.minBytesRequiredForDetection??c.guessEncoding?k:T;return new Promise((f,i)=>{const s=(0,a.newWriteableStream)(q=>q.join("")),u=[];let b=0,g;const L=async()=>{try{const q=await o({buffer:P.VSBuffer.concat(u),bytesRead:b},c.guessEncoding);if(q.seemsBinary&&c.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);q.encoding=await c.overwriteEncoding(q.encoding),g=await I.create(q.encoding);const X=g.write(P.VSBuffer.concat(u).buffer);s.write(X),u.length=0,b=0,f({stream:s,detected:q})}catch(q){H?.dispose(),s.destroy(),i(q)}},H=(0,a.listenStream)(r,{onData:async q=>{g?s.write(g.write(q.buffer)):(u.push(q),b+=q.byteLength,b>=m&&(r.pause(),await L(),setTimeout(()=>r.resume())))},onError:q=>s.error(q),onEnd:async()=>{g||await L(),s.end(g?.end())}})})}e.toDecodeStream=_;async function D(r,c,m){const i=(await new Promise((b,g)=>{re(["@vscode/iconv-lite-umd"],b,g)})).getEncoder(E(c),m);let s=!1,u=!1;return{read(){if(u)return null;const b=r.read();if(typeof b!="string"){if(u=!0,!s&&m?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return P.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const g=i.end();return g&&g.length>0?(s=!0,P.VSBuffer.wrap(g)):null}return s=!0,P.VSBuffer.wrap(i.write(b))}}}e.toEncodeReadable=D;async function C(r){return(await new Promise((m,f)=>{re(["@vscode/iconv-lite-umd"],m,f)})).encodingExists(E(r))}e.encodingExists=C;function E(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=E;function n(r,c){if(!r||c<e.UTF16be_BOM.length)return null;const m=r.readUInt8(0),f=r.readUInt8(1);if(m===e.UTF16be_BOM[0]&&f===e.UTF16be_BOM[1])return e.UTF16be;if(m===e.UTF16le_BOM[0]&&f===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return m===e.UTF8_BOM[0]&&f===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=n;const d=["ascii","utf-16","utf-32"];async function h(r){const c=await new Promise((u,b)=>{re(["jschardet"],u,b)}),m=r.slice(0,y),f=p(m.buffer),i=c.detect(f);if(!i||!i.encoding)return null;const s=i.encoding.toLowerCase();return 0<=d.indexOf(s)?null:S(i.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(r){const c=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[c]||c}function p(r){let c="";for(let m=0;m<r.length;m++)c+=String.fromCharCode(r[m]);return c}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=r.match(/windows(\d+)/);return c?"windows-"+c[1]:r}}}e.toCanonicalName=t;function o({buffer:r,bytesRead:c},m){let f=n(r,c),i=!1;if(f!==e.UTF16be&&f!==e.UTF16le&&r){let s=!0,u=!0,b=!1;for(let g=0;g<c&&g<A;g++){const L=g%2===1,H=r.readUInt8(g)===0;if(H&&(b=!0),s&&(L&&!H||!L&&H)&&(s=!1),u&&(L&&H||!L&&!H)&&(u=!1),H&&!s&&!u)break}b&&(s?f=e.UTF16le:u?f=e.UTF16be:i=!0)}return m&&!i&&!f&&r?h(r.slice(0,c)).then(s=>({seemsBinary:!1,encoding:s})):{seemsBinary:i,encoding:f}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[145],De([1,0,319,29,144]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends l.TextSearchManager{constructor(k,y,v=P,R="searchProcess"){super(k,y,{readdir:I=>v.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,a.toCanonicalName)(I)},R)}}e.NativeTextSearchManager=A}),define(Ce[320],De([1,0,294,330,331,2,332]),function(re,e,a,P,l,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,_,D,C,E,n){const d=n.environment.useHostProxy,h=typeof d=="boolean"?d:!n.remote.isRemote,w=(0,T.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(p,t,...o)=>{switch(p){case T.LogLevel.Trace:C.trace(t,...o);break;case T.LogLevel.Debug:C.debug(t,...o);break;case T.LogLevel.Info:C.info(t,...o);break;case T.LogLevel.Warning:C.warn(t,...o);break;case T.LogLevel.Error:C.error(t,...o);break;case T.LogLevel.Critical:C.error(t,...o);break;case T.LogLevel.Off:break;default:r(p,t,o);break}function r(c,m,...f){C.error("Unknown log level",c),C.error(m,...f)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:h,env:process.env}),S=y(_,w);return R(D,S)}e.connectProxyResolver=k;function y(I,_){const D={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(E=>{D.config=I.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(E=>{C.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,T.createHttpPatch)(a,_,{config:"off"},C,!0)),on:Object.assign({},a,(0,T.createHttpPatch)(a,_,{config:"on"},C,!0)),override:Object.assign({},a,(0,T.createHttpPatch)(a,_,{config:"override"},C,!0)),onRequest:Object.assign({},a,(0,T.createHttpPatch)(a,_,D,C,!0)),default:Object.assign(a,(0,T.createHttpPatch)(a,_,D,C,!1))},https:{off:Object.assign({},P,(0,T.createHttpPatch)(P,_,{config:"off"},C,!0)),on:Object.assign({},P,(0,T.createHttpPatch)(P,_,{config:"on"},C,!0)),override:Object.assign({},P,(0,T.createHttpPatch)(P,_,{config:"override"},C,!0)),onRequest:Object.assign({},P,(0,T.createHttpPatch)(P,_,D,C,!0)),default:Object.assign(P,(0,T.createHttpPatch)(P,_,D,C,!1))},tls:Object.assign(l,(0,T.createTlsPatch)(l))}}const v=new Map;function R(I,_){return I.getExtensionPathIndex().then(D=>{const C=globalThis._VSCODE_NODE_MODULES.module,E=C._load;C._load=function(d,h,w){if(d==="tls")return _.tls;if(d!=="http"&&d!=="https")return E.apply(this,arguments);const S=_[d],p=D.findSubstr(A.URI.file(h.filename));let t=v.get(p);if(t||v.set(p,t={}),!t[d]){const o=S.default;t[d]={...o}}return t[d]}})}}),define(Ce[321],De([1,0,85,313,308,320,43,296,2,17,7,293,116,295]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends l.RequireInterceptor{_installInterceptor(){const d=this,h=globalThis._VSCODE_NODE_MODULES.module,w=h._load;h._load=function(o,r,c){return o=p(o),d._factories.has(o)?d._factories.get(o).load(o,y.URI.file((0,_.realpathSync)(r.filename)),m=>w.apply(this,[m,r,c])):w.apply(this,arguments)};const S=h._resolveLookupPaths;h._resolveLookupPaths=(t,o)=>S.call(this,p(t),o);const p=t=>{for(const o of d._alternatives){const r=o(t);if(r){t=r;break}}return t}}}class E extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(D.ExtHostConsoleForwarder);const d=this._instaService.invokeFunction(P.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(k.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const S=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=S.ipcHandlePath}await this._instaService.createInstance(C,d,{mine:this._myRegistry,all:this._globalRegistry}).install(),a.mark("code/extHost/didInitAPI");const w=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,w,this,this._logService,this._mainThreadTelemetryProxy,this._initData),a.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(d){return d.main}async _loadCommonJSModule(d,h,w){if(h.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${h}', must be of file-scheme`);let S=null;w.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${h.toString(!0)}`),this._logService.flush();const p=d?.identifier.value;d&&await this._extHostLocalizationService.initializeLocalizedMessages(d);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),S=re.__$__nodeRequire(h.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),w.codeLoadingStop()}return S}async $setRemoteEnvironment(d){if(!!this._initData.remote.isRemote)for(const h in d){const w=d[h];w===null?delete process.env[h]:process.env[h]=w}}}e.ExtHostExtensionService=E}),define(Ce[146],De([1,0,47,333,318,18,61,39,15,9,2,31,83,334,316,101]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(g){this.outputChannel=g}provideTextSearchResults(g,L,H,q){return this.outputChannel.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((X,U)=>{q.onCancellationRequested(()=>J());const N=o(g,L),x=L.folder.fsPath,F=N.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${n} ${F}
 - cwd: ${x}`);let V=a.spawn(n,N,{cwd:x});V.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),U((0,I.serializeSearchError)(new I.SearchError(j&&j.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const se=new S(L.maxResults,x,L.previewOptions);se.on("result",j=>{fe=!0,be="",H.report(j)});let $=!1;const J=()=>{$=!0,V?.kill(),se?.cancel()};let te=!1;se.on("hitLimit",()=>{te=!0,J()});let be="";V.stdout.on("data",j=>{se.handleData(j),fe||(be+=j)});let le=!1;V.stdout.once("data",()=>le=!0);let ue="";V.stderr.on("data",j=>{const M=j.toString();this.outputChannel.appendLine(M),ue.length+M.length<1e6&&(ue+=M)}),V.on("close",()=>{if(this.outputChannel.appendLine(le?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(fe?"Got result from parser":"No result from parser"),be&&this.outputChannel.appendLine(`Got data without result: ${be}`),this.outputChannel.appendLine(""),$)X({limitHit:te});else{se.flush(),V=null;let j;ue&&!le&&(j=h(ue))?U((0,I.serializeSearchError)(new I.SearchError(j.message,j.code))):X({limitHit:te})}})})}}e.RipgrepTextSearchEngine=d;function h(b){const g=b.split(`
`),L=g[0].trim();if(g.some(q=>q.startsWith("regex parse error")))return new I.SearchError(w(g),I.SearchErrorCode.regexParseError);const H=L.match(/grep config error: unknown encoding: (.*)/);if(H)return new I.SearchError(`Unknown encoding: ${H[1]}`,I.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new I.SearchError(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new I.SearchError(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(L,I.SearchErrorCode.regexParseError)}function w(b){const g=["Regex parse error"],L=b.filter(H=>H.startsWith("PCRE2:"));if(L.length>=1){const H=L[0].replace("PCRE2:","");if(H.indexOf(":")!==-1&&H.split(":").length>=2){const q=H.split(":")[1];g.push(":"+q)}}return g.join("")}class S extends P.EventEmitter{constructor(g,L,H){super(),this.maxResults=g,this.rootFolder=L,this.previewOptions=H,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new l.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(g,L){return super.on(g,L),this}handleData(g){if(this.isDone)return;const L=typeof g=="string"?g:this.stringDecoder.write(g);this.handleDecodedData(L)}handleDecodedData(g){let L=g.indexOf(`
`);const H=this.remainder+g;if(L>=0)L+=this.remainder.length;else{this.remainder=H;return}let q=0;for(;L>=0;)this.handleLine(H.substring(q,L).trim()),q=L+1,L=H.indexOf(`
`,q);this.remainder=H.substring(q)}handleLine(g){if(this.isDone||!g)return;let L;try{L=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(L.type==="match"){const H=p(L.data.path),q=R.URI.file(y.join(this.rootFolder,H)),X=this.createTextSearchMatch(L.data,q);this.onResult(X),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const H=p(L.data.path),q=R.URI.file(y.join(this.rootFolder,H));this.createTextSearchContext(L.data,q).forEach(U=>this.onResult(U))}}createTextSearchMatch(g,L){const H=g.line_number-1,q=p(g.lines),X=Buffer.from(q);let U=0,N=0,x=H;g.submatches.length===0&&g.submatches.push(q.length?{start:0,end:1,match:{text:q[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(g.submatches.map((V,fe)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const se=p(V.match),$=X.slice(U,V.start).toString(),J=t($),te=J.numLines>0?J.lastLineLength:J.lastLineLength+N,be=t(se),le=J.numLines+x,ue=be.numLines+le,j=be.numLines>0?be.lastLineLength:be.lastLineLength+te;return U=V.end,N=j,x=ue,new _.Range(le,te,ue,j)}));return(0,E.createTextSearchResult)(L,q,F,this.previewOptions)}createTextSearchContext(g,L){const H=p(g.lines),q=g.line_number;return H.replace(/\r?\n$/,"").split(`
`).map((X,U)=>({text:X,uri:L,lineNumber:q+U}))}onResult(g){this.emit("result",g)}}e.RipgrepParser=S;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const g=/\n/g;let L=0,H=-1,q;for(;q=g.exec(b);)L++,H=q.index;const X=H>=0?b.length-H-1:b.length;return{numLines:L,lastLineLength:X}}function o(b,g){const L=["--hidden"];L.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:H,otherIncludes:q}=(0,T.groupBy)(g.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(q&&q.length){const U=new Set;q.forEach(N=>{U.add(N)}),L.push("-g","!*"),U.forEach(N=>{r(N).map(E.anchorGlob).forEach(x=>{L.push("-g",x)})})}H&&H.length&&H.forEach(U=>{L.push("-g",U)}),g.excludes.map(E.anchorGlob).forEach(U=>L.push("-g",`!${U}`)),g.maxFileSize&&L.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),g.followSymlinks&&L.push("--follow"),g.encoding&&g.encoding!=="utf8"&&L.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,v.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),g.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),b.isRegExp&&(b.pattern=c(b.pattern),L.push("--engine","auto"));let X;if(b.isWordMatch){const N=(0,v.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",N)}else if(b.isRegExp){let U=f(b.pattern);U=i(U),L.push("--regexp",U)}else X=b.pattern,L.push("--fixed-strings");return L.push("--no-config"),g.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),b.isMultiline&&L.push("--multiline"),g.beforeContext&&L.push("--before-context",g.beforeContext+""),g.afterContext&&L.push("--after-context",g.afterContext+""),L.push("--"),X&&L.push(X),L.push("."),L}e.getRgArgs=o;function r(b){return u(b).flatMap(L=>{const H=(0,k.splitGlobAware)(L,"/");return H.map((q,X)=>H.slice(0,X+1).join("/"))})}function c(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(L);)b=b.replace(L,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=c;const m=b=>b.type==="Assertion"&&b.kind==="lookbehind";function f(b){let g;try{g=new D.RegExpParser().parsePattern(b)}catch{return b}let L="",H=0;const q=(N,x,F)=>{L+=b.slice(H,N)+F,H=x},X=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const x=X[0];if(!x)q(N.start,N.end,"\\r?\\n");else if(!X.some(m))if(x.type==="CharacterClass")if(x.negate){const F=b.slice(x.start+2,N.start)+b.slice(N.end,x.end-1);x.parent?.type==="Quantifier"?q(x.start,x.end,F?`[^${F}]`:"."):q(x.start,x.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=b.slice(x.start+1,N.start)+b.slice(N.end,x.end-1);q(x.start,x.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else x.type==="Quantifier"&&q(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){X.unshift(N)},onQuantifierLeave(){X.shift()},onCharacterClassRangeEnter(N){X.unshift(N)},onCharacterClassRangeLeave(){X.shift()},onCharacterClassEnter(N){X.unshift(N)},onCharacterClassLeave(){X.shift()},onAssertionEnter(N){m(N)&&X.push(N)},onAssertionLeave(N){X[0]===N&&X.shift()}}).visit(g),L+=b.slice(H),L}e.fixRegexNewline=f;function i(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function s(b){let g=!1,L=!1,H="",q="";for(let X=0;X<b.length;X++){const U=b[X];switch(U){case"\\":L?(g?q+="\\"+U:H+="\\"+U,L=!1):L=!0;break;case"{":if(L)g?q+=U:H+=U,L=!1;else{if(g)return{strInBraces:H+"{"+q+"{"+b.substring(X+1)};g=!0}break;case"}":if(L)g?q+=U:H+=U,L=!1;else{if(g)return{fixedStart:H,strInBraces:q,fixedEnd:b.substring(X+1)};H+=U}break;default:g?q+=(L?"\\":"")+U:H+=(L?"\\":"")+U,L=!1;break}}return{strInBraces:H+(g?"{"+q:"")}}function u(b){const{fixedStart:g,strInBraces:L,fixedEnd:H}=s(b);if(g===void 0||H===void 0)return[L];let q=(0,k.splitGlobAware)(L,",");q.length||(q=[""]);const X=u(H);return q.flatMap(U=>{const N=g+U;return X.map(x=>N+x)})}e.performBraceExpansionForRipgrep=u}),define(Ce[322],De([1,0,21,146,126,17]),function(re,e,a,P,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(v){this.outputChannel=v,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(v,R,I,_){const D=new P.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===A.Schemas.vscodeUserData){const C={...R,folder:R.folder.with({scheme:A.Schemas.file})},E=new l.Progress(n=>I.report({...n,uri:n.uri.with({scheme:R.folder.scheme})}));return this.withToken(_,n=>D.provideTextSearchResults(v,C,E,n))}else return this.withToken(_,C=>D.provideTextSearchResults(v,R,I,C))}async withToken(v,R){const I=k(v);this.inProgress.add(I);const _=await R(I.token);return this.inProgress.delete(I),_}dispose(){this.inProgress.forEach(v=>v.cancel())}}e.RipgrepSearchProvider=T;function k(y){const v=new a.CancellationTokenSource;return y.onCancellationRequested(()=>v.cancel()),v}}),define(Ce[323],De([1,0,29,146,145]),function(re,e,a,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(y){this.query=y}search(y,v,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(D){R({message:D})}},_=new l.NativeTextSearchManager(this.query,new P.RipgrepTextSearchEngine(I),a);return new Promise((D,C)=>_.search(E=>{v(E.map(T))},y).then(E=>D({limitHit:E.limitHit,type:"success",stats:E.stats}),C))}}e.TextSearchEngineAdapter=A;function T(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,v)=>{if(v.ranges){const R=v;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(Ce[324],De([1,0,18,19,8,3,112,15,37,2,45,31,317,323]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(S="searchProcess"){this.processType=S,this.caches=Object.create(null)}fileSearch(S){let p;const t=d(S),o=new A.Emitter({onDidAddFirstListener:()=>{p=(0,P.createCancelablePromise)(r=>this.doFileSearchWithEngine(_.Engine,t,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(S){let p;const t=d(S),o=new A.Emitter({onDidAddFirstListener:()=>{p=(0,P.createCancelablePromise)(r=>this.ripgrepTextSearch(t,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}ripgrepTextSearch(S,p,t){return S.maxFileSize=(0,R.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new D.TextSearchEngineAdapter(S).search(t,p,p)}doFileSearch(S,p,t){return this.doFileSearchWithEngine(_.Engine,S,p,t)}doFileSearchWithEngine(S,p,t,o,r=C.BATCH_SIZE){let c=0;const m=i=>{Array.isArray(i)?(c+=i.length,t(i.map(s=>this.rawMatchToSearchItem(s)))):i.relativePath?(c++,t(this.rawMatchToSearchItem(i))):t(i)};if(p.sortByScore){let i=this.trySortedSearchFromCache(p,m,o);if(!i){const s=p.maxResults?Object.assign({},p,{maxResults:null}):p,u=new S(s);i=this.doSortedSearch(u,p,t,m,o)}return new Promise((s,u)=>{i.then(([b,g])=>{const L=g.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(L,t,r),s(b)},u)})}const f=new S(p);return this.doSearch(f,m,r,o).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.processType,fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(S){return{path:S.base?(0,k.join)(S.base,S.relativePath):S.relativePath}}doSortedSearch(S,p,t,o,r){const c=new A.Emitter;let m=(0,P.createCancelablePromise)(i=>{let s=[];const u=b=>{Array.isArray(b)?s=b:(o(b),c.fire(b))};return this.doSearch(S,u,-1,i).then(b=>[b,s])}),f;if(p.cacheKey){f=this.getOrCreateCache(p.cacheKey);const i={promise:m,event:c.event,resolved:!1};f.resultsToSearchCache[p.filePattern||""]=i,m.then(()=>{i.resolved=!0},s=>{delete f.resultsToSearchCache[p.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([i,s])=>{const u=f?f.scorerCache:Object.create(null),b=(typeof p.maxResults!="number"||p.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(p,s,u,r).then(g=>{const L=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:g.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&s.length>p.maxResults},g]})})}getOrCreateCache(S){const p=this.caches[S];return p||(this.caches[S]=new E)}trySortedSearchFromCache(S,p,t){const o=S.cacheKey&&this.caches[S.cacheKey];if(!o)return;const r=this.getResultsFromCache(o,S.filePattern||"",p,t);if(r)return r.then(([c,m,f])=>{const i=y.StopWatch.create(!1);return this.sortResults(S,m,o.scorerCache,t).then(s=>{const u=i.elapsed(),b={fromCache:!0,detailStats:f,type:this.processType,resultCount:m.length,sortingTime:u};return[{type:"success",limitHit:c.limitHit||typeof S.maxResults=="number"&&m.length>S.maxResults,stats:b},s]})})}sortResults(S,p,t,o){const r=(0,T.prepareQuery)(S.filePattern||""),c=(f,i)=>(0,T.compareItemsByFuzzyScore)(f,i,r,!0,n,t),m=typeof S.maxResults=="number"?S.maxResults:Number.MAX_VALUE;return a.topAsync(p,c,m,1e4,o)}sendProgress(S,p,t){if(t&&t>0)for(let o=0;o<S.length;o+=t)p(S.slice(o,o+t));else p(S)}getResultsFromCache(S,p,t,o){const r=y.StopWatch.create(!1),c=p.indexOf(k.sep)>=0;let m;for(const u in S.resultsToSearchCache)if(p.startsWith(u)){if(c&&u.indexOf(k.sep)<0&&u!=="")continue;const b=S.resultsToSearchCache[u];m={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!m)return null;const f=r.elapsed(),i=y.StopWatch.create(!1),s=m.event(t);return o&&o.onCancellationRequested(()=>{s.dispose()}),m.promise.then(([u,b])=>{if(o&&o.isCancellationRequested)throw(0,l.canceled)();const g=[],L=(0,T.prepareQuery)(p).normalizedLowercase;for(const H of b)!(0,I.isFilePatternMatch)(H,L)||g.push(H);return[u,g,{cacheWasResolved:m.resolved,cacheLookupTime:f,cacheFilterTime:i.elapsed(),cacheEntryCount:b.length}]})}doSearch(S,p,t,o){return new Promise((r,c)=>{let m=[];o?.onCancellationRequested(()=>S.cancel()),S.search(f=>{f&&(t?(m.push(f),t>0&&m.length>=t&&(p(m),m=[])):p(f))},f=>{p(f)},(f,i)=>{m.length&&p(m),f?c(f):r(i)})})}clearCache(S){return delete this.caches[S],Promise.resolve(void 0)}preventCancellation(S){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return S.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return S.finally(p)}}}}C.BATCH_SIZE=512,e.SearchService=C;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(w){return(0,k.basename)(w.relativePath)}getItemDescription(w){return(0,k.dirname)(w.relativePath)}getItemPath(w){return w.relativePath}};function d(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(h),extraFileResources:w.extraFileResources&&w.extraFileResources.map(S=>v.URI.revive(S))}}function h(w){return{...w,folder:v.URI.revive(w.folder)}}}),define(Ce[325],De([1,0,6,17,2,29,16,26,20,87,56,31,324,322,101,145]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=class extends v.ExtHostSearch{constructor(h,w,S,p){super(h,S,p),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(P.Schemas.vscodeUserData,new D.RipgrepSearchProvider(t)),w.remote.isRemote&&w.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const h=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(P.Schemas.file,new D.RipgrepSearchProvider(h)),this.registerInternalFileSearchProvider(P.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(h,w){const S=this._handlePool++;return this._internalFileSearchProvider=w,this._internalFileSearchHandle=S,this._proxy.$registerFileSearchProvider(S,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(h,w,S,p){const t=(0,v.reviveQuery)(S);return h===this._internalFileSearchHandle?this.doInternalFileSearch(h,w,t,p):super.$provideFileSearchResults(h,w,S,p)}doInternalFileSearch(h,w,S,p){const t=o=>{if((0,I.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this._proxy.$handleFileMatch(h,w,o.map(r=>l.URI.file(r.path)));return}o.message&&this._logService.debug("ExtHostSearch",o.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(S,t,p)}$clearCache(h){return this._internalFileSearchProvider?.clearCache(h),super.$clearCache(h)}createTextSearchManager(h,w){return new E.NativeTextSearchManager(h,w,void 0,"textSearchProvider")}};n=$e([Be(0,y.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,R.IURITransformerService),Be(3,T.ILogService)],n),e.NativeExtHostSearch=n}),define(Ce[326],De([1,0,91,299,311,310,325,321,300,86,43,87,84,42,55,81,298,297,16,312,50,226,90]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d,h,w,S,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService,0),(0,a.registerSingleton)(h.ILoggerService,d.ExtHostLoggerService,1),(0,a.registerSingleton)(h.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,a.registerSingleton)(E.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,a.registerSingleton)(v.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(I.IExtHostSearch,T.NativeExtHostSearch,0),(0,a.registerSingleton)(_.IExtHostTask,l.ExtHostTask,0),(0,a.registerSingleton)(D.IExtHostTerminalService,P.ExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(S.IExtHostVariableResolverProvider,w.NodeExtHostVariableResolverProviderService,0)}),define(Ce[335],De([1,0,236,336,85,8,119,120,214,97,309,22,29,116,19,122,231,244,314,326]),function(re,e,a,P,l,A,T,k,y,v,R,I,_,D,C,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const h=P(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const m=globalThis._VSCODE_NODE_MODULES.module,f=m._load;m._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const w=process.exit.bind(process);function S(m){process.exit=function(f){if(m)w(f);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(m){w()};function t(){const m=(0,d.readExtHostConnection)(process.env);if(m.type===3)return new Promise((f,i)=>{const s=u=>{const b=u[0],g=new T.BufferedEmitter;b.on("message",L=>g.fire(I.VSBuffer.wrap(L.data))),b.on("close",()=>{p("renderer closed the MessagePort")}),b.start(),f({onMessage:g.event,send:L=>b.postMessage(L.buffer)})};process.parentPort.on("message",u=>s(u.ports))});if(m.type===2)return new Promise((f,i)=>{let s=null;const u=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,g=3e5,L=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),b),H=new C.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),g);process.on("message",(X,U)=>{if(X&&X.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const N=I.VSBuffer.wrap(Buffer.from(X.initialDataChunk,"base64"));let x;if(X.skipWebSocketFrames)x=new k.NodeSocket(U,"extHost-socket");else{const F=I.VSBuffer.wrap(Buffer.from(X.inflateBytes,"base64"));x=new k.WebSocketNodeSocket(new k.NodeSocket(U,"extHost-socket"),X.permessageDeflate,F,!1)}s?(L.cancel(),H.cancel(),s.beginAcceptReconnection(x,N),s.endAcceptReconnection(),s.sendResume()):(clearTimeout(u),s=new T.PersistentProtocol({socket:x,initialChunk:N}),s.sendResume(),s.onDidDispose(()=>p("renderer disconnected")),f(s),s.onSocketClose(()=>{L.schedule()}))}if(X&&X.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(H.isScheduled())return;L.isScheduled()&&H.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const f=m.pipeName;return new Promise((i,s)=>{const u=a.createConnection(f,()=>{u.removeListener("error",s);const b=new T.PersistentProtocol({socket:new k.NodeSocket(u,"extHost-renderer")});b.sendResume(),i(b)});u.once("error",s),u.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const m=await t();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,m.onMessage(f=>{(0,v.isMessageOfType)(f,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(f)})}send(f){this._terminating||m.send(f)}async drain(){if(m.drain)return m.drain()}}}function r(m){return new Promise(f=>{const i=m.onMessage(s=>{i.dispose();const u=JSON.parse(s.toString()),b=u.commit,g=y.default.commit;if(b&&g&&b!==g&&w(55),u.parentPid){let L=0;setInterval(function(){try{process.kill(u.parentPid,0),L=0}catch(q){q&&q.code==="EPERM"?(L++,L>=3&&p(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):p(`parent process ${u.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let H;try{H=globalThis._VSCODE_NODE_MODULES["native-watchdog"],H.start(u.parentPid)}catch(q){(0,A.onUnexpectedError)(q)}}m.send((0,v.createMessageOfType)(0)),f({protocol:m,initData:u})});m.send((0,v.createMessageOfType)(1))})}async function c(){const m=[];process.on("unhandledRejection",(L,H)=>{m.push(H),setTimeout(()=>{const q=m.indexOf(H);q>=0&&H.catch(X=>{m.splice(q,1),(0,A.isCancellationError)(X)||(console.warn(`rejected promise not handled within 1 second: ${X}`),X&&X.stack&&console.warn(`stack trace: ${X.stack}`),L&&(0,A.onUnexpectedError)(L))})},1e3)}),process.on("rejectionHandled",L=>{const H=m.indexOf(L);H>=0&&m.splice(H,1)}),process.on("uncaughtException",function(L){(0,A.isSigPipeError)(L)||(0,A.onUnexpectedError)(L)}),l.mark("code/extHost/willConnectToRenderer");const f=await o();l.mark("code/extHost/didConnectToRenderer");const i=await r(f);l.mark("code/extHost/didWaitForInitData");const{initData:s}=i;S(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=h.useHostProxy!==void 0?h.useHostProxy!=="false":void 0,s.environment.skipWorkspaceStorageLock=(0,E.boolean)(h.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(H){w(H)}exists(H){return _.Promises.exists(H)}realpath(H){return(0,D.realpath)(H)}};let b=null;s.remote.authority&&h.transformURIs&&(b=(0,n.createURITransformer)(s.remote.authority));const g=new R.ExtensionHostMain(i.protocol,s,u,b);p=L=>g.terminate(L)}c().catch(m=>console.log(m))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/workbench/api/node/extensionHostProcess.js.map
