/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ee){for(var e=[],n=0,T=ee.length;n<T;n++)e[n]=Pe[ee[n]];return e};define(Pe[64],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(A,P){const D=Object.create(null);for(const m of A){const R=P(m);let S=D[R];S||(S=D[R]=[]),S.push(m)}return D}e.groupBy=n;function T(A,P){const D=[],m=[];for(const R of A)P.has(R)||D.push(R);for(const R of P)A.has(R)||m.push(R);return{removed:D,added:m}}e.diffSets=T;function C(A,P){const D=[],m=[];for(const[R,S]of A)P.has(R)||D.push(S);for(const[R,S]of P)A.has(R)||m.push(S);return{removed:D,added:m}}e.diffMaps=C;class M{constructor(){this.map=new Map}add(P,D){let m=this.map.get(P);m||(m=new Set,this.map.set(P,m)),m.add(D)}delete(P,D){const m=this.map.get(P);!m||(m.delete(D),m.size===0&&this.map.delete(P))}forEach(P,D){const m=this.map.get(P);!m||m.forEach(D)}}e.SetMap=M}),define(Pe[65],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(A){return(P,D,m)=>{let R=null,S=null;if(typeof m.value=="function"?(R="value",S=m.value):typeof m.get=="function"&&(R="get",S=m.get),!S)throw new Error("not supported");m[R]=A(S,D)}}function T(A,P,D){let m=null,R=null;if(typeof D.value=="function"?(m="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(m="get",R=D.get),!R)throw new Error("not supported");const S=`$memoize$${P}`;D[m]=function(...h){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,h)}),this[S]}}e.memoize=T;function C(A,P,D){return n((m,R)=>{const S=`$debounce$${R}`,h=`$debounce$result$${R}`;return function(...w){this[h]||(this[h]=D?D():void 0),clearTimeout(this[S]),P&&(this[h]=P(this[h],...w),w=[this[h]]),this[S]=setTimeout(()=>{m.apply(this,w),this[h]=D?D():void 0},A)}})}e.debounce=C;function M(A,P,D){return n((m,R)=>{const S=`$throttle$timer$${R}`,h=`$throttle$result$${R}`,w=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...u){if(this[h]||(this[h]=D?D():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...u)),this[g])return;const t=this[w]+A;t<=Date.now()?(this[w]=Date.now(),m.apply(this,[this[h]]),this[h]=D?D():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[w]=Date.now(),m.apply(this,[this[h]]),this[h]=D?D():void 0},t-Date.now()))}})}e.throttle=M}),define(Pe[84],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Pe[113],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function A(i,l=!1){let s=0;const o=i.length;let f="",E=0,r=16,c=0;function v(N){let B=0,U=0;for(;B<N;){const z=i.charCodeAt(s);if(z>=48&&z<=57)U=U*16+z-48;else if(z>=65&&z<=70)U=U*16+z-65+10;else if(z>=97&&z<=102)U=U*16+z-97+10;else break;s++,B++}return B<N&&(U=-1),U}function y(N){s=N,f="",E=0,r=16,c=0}function b(){const N=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&m(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&m(i.charCodeAt(s)))for(s++;s<i.length&&m(i.charCodeAt(s));)s++;else return c=3,i.substring(N,s);let B=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&m(i.charCodeAt(s))){for(s++;s<i.length&&m(i.charCodeAt(s));)s++;B=s}else c=3;return i.substring(N,B)}function $(){let N="",B=s;for(;;){if(s>=o){N+=i.substring(B,s),c=2;break}const U=i.charCodeAt(s);if(U===34){N+=i.substring(B,s),s++;break}if(U===92){if(N+=i.substring(B,s),s++,s>=o){c=2;break}switch(i.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const j=v(4);j>=0?N+=String.fromCharCode(j):c=4;break}default:c=5}B=s;continue}if(U>=0&&U<=31)if(D(U)){N+=i.substring(B,s),c=2;break}else c=6;s++}return N}function G(){if(f="",c=0,E=s,s>=o)return E=o,r=17;let N=i.charCodeAt(s);if(P(N)){do s++,f+=String.fromCharCode(N),N=i.charCodeAt(s);while(P(N));return r=15}if(D(N))return s++,f+=String.fromCharCode(N),N===13&&i.charCodeAt(s)===10&&(s++,f+=`
`),r=14;switch(N){case 123:return s++,r=1;case 125:return s++,r=2;case 91:return s++,r=3;case 93:return s++,r=4;case 58:return s++,r=6;case 44:return s++,r=5;case 34:return s++,f=$(),r=10;case 47:{const B=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<o&&!D(i.charCodeAt(s));)s++;return f=i.substring(B,s),r=12}if(i.charCodeAt(s+1)===42){s+=2;const U=o-1;let z=!1;for(;s<U;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,c=1),f=i.substring(B,s),r=13}return f+=String.fromCharCode(N),s++,r=16}case 45:if(f+=String.fromCharCode(N),s++,s===o||!m(i.charCodeAt(s)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=b(),r=11;default:for(;s<o&&Y(N);)s++,N=i.charCodeAt(s);if(E!==s){switch(f=i.substring(E,s),f){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return f+=String.fromCharCode(N),s++,r=16}}function Y(N){if(P(N)||D(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let N;do N=G();while(N>=12&&N<=15);return N}return{setPosition:y,getPosition:()=>s,scan:l?K:G,getToken:()=>r,getTokenValue:()=>f,getTokenOffset:()=>E,getTokenLength:()=>s-E,getTokenError:()=>c}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,l){const s=[],o=new Object;let f;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function c(v,y,b,$){E.value=v,E.offset=y,E.length=b,E.type=$,E.colonOffset=void 0,f=E}try{_(i,{onObjectBegin:(v,y)=>{if(l<=v)throw o;f=void 0,r=l>v,s.push("")},onObjectProperty:(v,y,b)=>{if(l<y||(c(v,y,b,"property"),s[s.length-1]=v,l<=y+b))throw o},onObjectEnd:(v,y)=>{if(l<=v)throw o;f=void 0,s.pop()},onArrayBegin:(v,y)=>{if(l<=v)throw o;f=void 0,s.push(0)},onArrayEnd:(v,y)=>{if(l<=v)throw o;f=void 0,s.pop()},onLiteralValue:(v,y,b)=>{if(l<y||(c(v,y,b,p(v)),l<=y+b))throw o},onSeparator:(v,y,b)=>{if(l<=y)throw o;if(v===":"&&f&&f.type==="property")f.colonOffset=y,r=!1,f=void 0;else if(v===","){const $=s[s.length-1];typeof $=="number"?s[s.length-1]=$+1:(r=!0,s[s.length-1]=""),f=void 0}}})}catch(v){if(v!==o)throw v}return{path:s,previousNode:f,isAtPropertyKey:r,matches:v=>{let y=0;for(let b=0;y<v.length&&b<s.length;b++)if(v[y]===s[b]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.getLocation=S;function h(i,l=[],s=M.DEFAULT){let o=null,f=[];const E=[];function r(v){Array.isArray(f)?f.push(v):o!==null&&(f[o]=v)}return _(i,{onObjectBegin:()=>{const v={};r(v),E.push(f),f=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{f=E.pop()},onArrayBegin:()=>{const v=[];r(v),E.push(f),f=v,o=null},onArrayEnd:()=>{f=E.pop()},onLiteralValue:r,onError:(v,y,b)=>{l.push({error:v,offset:y,length:b})}},s),f[0]}e.parse=h;function w(i,l=[],s=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(v){o.type==="property"&&(o.length=v-o.offset,o=o.parent)}function E(v){return o.children.push(v),v}_(i,{onObjectBegin:v=>{o=E({type:"object",offset:v,length:-1,parent:o,children:[]})},onObjectProperty:(v,y,b)=>{o=E({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:v,offset:y,length:b,parent:o})},onObjectEnd:(v,y)=>{o.length=v+y-o.offset,o=o.parent,f(v+y)},onArrayBegin:(v,y)=>{o=E({type:"array",offset:v,length:-1,parent:o,children:[]})},onArrayEnd:(v,y)=>{o.length=v+y-o.offset,o=o.parent,f(v+y)},onLiteralValue:(v,y,b)=>{E({type:p(v),offset:y,length:b,parent:o,value:v}),f(y+b)},onSeparator:(v,y,b)=>{o.type==="property"&&(v===":"?o.colonOffset=y:v===","&&f(y))},onError:(v,y,b)=>{l.push({error:v,offset:y,length:b})}},s);const c=o.children[0];return c&&delete c.parent,c}e.parseTree=w;function g(i,l){if(!i)return;let s=i;for(const o of l)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let f=!1;for(const E of s.children)if(Array.isArray(E.children)&&E.children[0].value===o){s=E.children[1],f=!0;break}if(!f)return}else{const f=o;if(s.type!=="array"||f<0||!Array.isArray(s.children)||f>=s.children.length)return;s=s.children[f]}return s}e.findNodeAtLocation=g;function u(i){if(!i.parent||!i.parent.children)return[];const l=u(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;l.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&l.push(s)}return l}e.getNodePath=u;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const l=Object.create(null);for(const s of i.children){const o=s.children[1];o&&(l[s.children[0].value]=t(o))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,l,s=!1){return l>=i.offset&&l<i.offset+i.length||s&&l===i.offset+i.length}e.contains=a;function d(i,l,s=!1){if(a(i,l,s)){const o=i.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=l;f++){const E=d(o[f],l,s);if(E)return E}return i}}e.findNodeAtOffset=d;function _(i,l,s=M.DEFAULT){const o=A(i,!1);function f(ke){return ke?()=>ke(o.getTokenOffset(),o.getTokenLength()):()=>!0}function E(ke){return ke?de=>ke(de,o.getTokenOffset(),o.getTokenLength()):()=>!0}const r=f(l.onObjectBegin),c=E(l.onObjectProperty),v=f(l.onObjectEnd),y=f(l.onArrayBegin),b=f(l.onArrayEnd),$=E(l.onLiteralValue),G=E(l.onSeparator),Y=f(l.onComment),K=E(l.onError),N=s&&s.disallowComments,B=s&&s.allowTrailingComma;function U(){for(;;){const ke=o.scan();switch(o.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:N||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ke){case 12:case 13:N?z(10):Y();break;case 16:z(1);break;case 15:case 14:break;default:return ke}}}function z(ke,de=[],ae=[]){if(K(ke),de.length+ae.length>0){let H=o.getToken();for(;H!==17;){if(de.indexOf(H)!==-1){U();break}else if(ae.indexOf(H)!==-1)break;H=U()}}}function j(ke){const de=o.getTokenValue();return ke?$(de):c(de),U(),!0}function fe(){switch(o.getToken()){case 11:{let ke=0;try{ke=JSON.parse(o.getTokenValue()),typeof ke!="number"&&(z(2),ke=0)}catch{z(2)}$(ke);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return U(),!0}function _e(){return o.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),o.getToken()===6?(G(":"),U(),ce()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ie(){r(),U();let ke=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ke||z(4,[],[]),G(","),U(),o.getToken()===2&&B)break}else ke&&z(6,[],[]);_e()||z(4,[],[2,5]),ke=!0}return v(),o.getToken()!==2?z(7,[2],[]):U(),!0}function le(){y(),U();let ke=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ke||z(4,[],[]),G(","),U(),o.getToken()===4&&B)break}else ke&&z(6,[],[]);ce()||z(4,[],[4,5]),ke=!0}return b(),o.getToken()!==4?z(8,[4],[]):U(),!0}function ce(){switch(o.getToken()){case 3:return le();case 1:return ie();case 10:return j(!0);default:return fe()}}return U(),o.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):ce()?(o.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=_;function k(i,l){const s=A(i),o=[];let f,E=0,r;do switch(r=s.getPosition(),f=s.scan(),f){case 12:case 13:case 17:E!==r&&o.push(i.substring(E,r)),l!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,l)),E=s.getPosition();break}while(f!==17);return o.join("")}e.stripComments=k;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Pe[28],Ae([1,0]),function(ee,e){"use strict";var n,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(u,t,a){let d=u.get(t);return d===void 0&&(d=a,u.set(t,d)),d}e.getOrSet=M;function A(u){const t=[];return u.forEach((a,d)=>{t.push(`${d} => ${a}`)}),`Map(${u.size}) {${t.join(", ")}}`}e.mapToString=A;function P(u){const t=[];return u.forEach(a=>{t.push(a)}),`Set(${u.size}) {${t.join(", ")}}`}e.setToString=P;class D{constructor(t,a){this.uri=t,this.value=a}}class m{constructor(t,a){this[n]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=a??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new D(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[d,_]of this.map)t(_.value,_.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}m.defaultToKey=u=>u.toString(),e.ResourceMap=m;class R{constructor(t,a){this[T]="ResourceSet",!t||typeof t=="function"?this._map=new m(t):(this._map=new m(a),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,a){this._map.forEach((d,_)=>t.call(a,_,_,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var S;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class h{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const d=this._map.get(t);if(!!d)return a!==0&&this.touch(d,a),d.value}set(t,a,d=0){let _=this._map.get(t);if(_)_.value=a,d!==0&&this.touch(_,d);else{switch(_={key:t,value:a,next:void 0,previous:void 0},d){case 0:this.addItemLast(_);break;case 1:this.addItemFirst(_);break;case 2:this.addItemLast(_);break;default:this.addItemLast(_);break}this._map.set(t,_),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const d=this._state;let _=this._head;for(;_;){if(a?t.bind(a)(_.value,_.key,this):t(_.value,_.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const t=this,a=this._state;let d=this._head;const _={[Symbol.iterator](){return _},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.key,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return _}values(){const t=this,a=this._state;let d=this._head;const _={[Symbol.iterator](){return _},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:d.value,done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return _}entries(){const t=this,a=this._state;let d=this._head;const _={[Symbol.iterator](){return _},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const k={value:[d.key,d.value],done:!1};return d=d.next,k}else return{value:void 0,done:!0}}};return _}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,d=this.size;for(;a&&d>t;)this._map.delete(a.key),a=a.next,d--;this._head=a,this._size=d,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,d=t.previous;if(!a||!d)throw new Error("Invalid list");a.previous=d,d.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const d=t.next,_=t.previous;t===this._tail?(_.next=void 0,this._tail=_):(d.previous=_,_.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const d=t.next,_=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=_,_.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,d)=>{t.push([d,a])}),t}fromJSON(t){this.clear();for(const[a,d]of t)this.set(a,d)}}e.LinkedMap=h;class w extends h{constructor(t,a=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w;class g{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let a=this.map.get(t)||0;return a===0?!1:(a--,a===0?this.map.delete(t):this.map.set(t,a),!0)}has(t){return this.map.has(t)}}e.CounterSet=g}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Pe[114],Ae([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(we,ve){for(var Ie=0;Ie<ve.length;Ie++){var se=ve[Ie];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(we,se.key,se)}}function n(we,ve,Ie){return ve&&e(we.prototype,ve),Ie&&e(we,Ie),Object.defineProperty(we,"prototype",{writable:!1}),we}function T(we,ve){if(!!we){if(typeof we=="string")return C(we,ve);var Ie=Object.prototype.toString.call(we).slice(8,-1);if(Ie==="Object"&&we.constructor&&(Ie=we.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(we);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return C(we,ve)}}function C(we,ve){(ve==null||ve>we.length)&&(ve=we.length);for(var Ie=0,se=new Array(ve);Ie<ve;Ie++)se[Ie]=we[Ie];return se}function M(we,ve){var Ie=typeof Symbol<"u"&&we[Symbol.iterator]||we["@@iterator"];if(Ie)return(Ie=Ie.call(we)).next.bind(Ie);if(Array.isArray(we)||(Ie=T(we))||ve&&we&&typeof we.length=="number"){Ie&&(we=Ie);var se=0;return function(){return se>=we.length?{done:!0}:{done:!1,value:we[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=A();function P(we){ee.defaults=we}var D=/[&<>"']/,m=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(ve){return h[ve]};function g(we,ve){if(ve){if(D.test(we))return we.replace(m,w)}else if(R.test(we))return we.replace(S,w);return we}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(we){return we.replace(u,function(ve,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var a=/(^|[^\[])\^/g;function d(we,ve){we=typeof we=="string"?we:we.source,ve=ve||"";var Ie={replace:function(oe,Z){return Z=Z.source||Z,Z=Z.replace(a,"$1"),we=we.replace(oe,Z),Ie},getRegex:function(){return new RegExp(we,ve)}};return Ie}var _=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(we,ve,Ie){if(we){var se;try{se=decodeURIComponent(t(Ie)).replace(_,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!k.test(Ie)&&(Ie=f(ve,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var i={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(we,ve){i[" "+we]||(l.test(we)?i[" "+we]=we+"/":i[" "+we]=v(we,"/",!0)),we=i[" "+we];var Ie=we.indexOf(":")===-1;return ve.substring(0,2)==="//"?Ie?ve:we.replace(s,"$1")+ve:ve.charAt(0)==="/"?Ie?ve:we.replace(o,"$1")+ve:we+ve}var E={exec:function(){}};function r(we){for(var ve=1,Ie,se;ve<arguments.length;ve++){Ie=arguments[ve];for(se in Ie)Object.prototype.hasOwnProperty.call(Ie,se)&&(we[se]=Ie[se])}return we}function c(we,ve){var Ie=we.replace(/\|/g,function(Z,I,F){for(var W=!1,V=I;--V>=0&&F[V]==="\\";)W=!W;return W?"|":" |"}),se=Ie.split(/ \|/),oe=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;oe<se.length;oe++)se[oe]=se[oe].trim().replace(/\\\|/g,"|");return se}function v(we,ve,Ie){var se=we.length;if(se===0)return"";for(var oe=0;oe<se;){var Z=we.charAt(se-oe-1);if(Z===ve&&!Ie)oe++;else if(Z!==ve&&Ie)oe++;else break}return we.slice(0,se-oe)}function y(we,ve){if(we.indexOf(ve[1])===-1)return-1;for(var Ie=we.length,se=0,oe=0;oe<Ie;oe++)if(we[oe]==="\\")oe++;else if(we[oe]===ve[0])se++;else if(we[oe]===ve[1]&&(se--,se<0))return oe;return-1}function b(we){we&&we.sanitize&&!we.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(we,ve){if(ve<1)return"";for(var Ie="";ve>1;)ve&1&&(Ie+=we),ve>>=1,we+=we;return Ie+we}function G(we,ve,Ie,se){var oe=ve.href,Z=ve.title?g(ve.title):null,I=we[1].replace(/\\([\[\]])/g,"$1");if(we[0].charAt(0)!=="!"){se.state.inLink=!0;var F={type:"link",raw:Ie,href:oe,title:Z,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,F}return{type:"image",raw:Ie,href:oe,title:Z,text:g(I)}}function Y(we,ve){var Ie=we.match(/^(\s+)(?:```)/);if(Ie===null)return ve;var se=Ie[1];return ve.split(`
`).map(function(oe){var Z=oe.match(/^\s+/);if(Z===null)return oe;var I=Z[0];return I.length>=se.length?oe.slice(se.length):oe}).join(`
`)}var K=function(){function we(Ie){this.options=Ie||ee.defaults}var ve=we.prototype;return ve.space=function(se){var oe=this.rules.block.newline.exec(se);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ve.code=function(se){var oe=this.rules.block.code.exec(se);if(oe){var Z=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},ve.fences=function(se){var oe=this.rules.block.fences.exec(se);if(oe){var Z=oe[0],I=Y(Z,oe[3]||"");return{type:"code",raw:Z,lang:oe[2]?oe[2].trim():oe[2],text:I}}},ve.heading=function(se){var oe=this.rules.block.heading.exec(se);if(oe){var Z=oe[2].trim();if(/#$/.test(Z)){var I=v(Z,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Z=I.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ve.hr=function(se){var oe=this.rules.block.hr.exec(se);if(oe)return{type:"hr",raw:oe[0]}},ve.blockquote=function(se){var oe=this.rules.block.blockquote.exec(se);if(oe){var Z=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ve.list=function(se){var oe=this.rules.block.list.exec(se);if(oe){var Z,I,F,W,V,te,ge,Te,ue,ye,be,ze,Ue=oe[1].trim(),tt=Ue.length>1,Ge={type:"list",raw:"",ordered:tt,start:tt?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=tt?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=tt?Ue:"[*+-]");for(var it=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(ze=!1,!(!(oe=it.exec(se))||this.rules.block.hr.test(se)));){if(Z=oe[0],se=se.substring(Z.length),Te=oe[2].split(`
`,1)[0],ue=se.split(`
`,1)[0],this.options.pedantic?(W=2,be=Te.trimLeft()):(W=oe[2].search(/[^ ]/),W=W>4?1:W,be=Te.slice(W),W+=oe[1].length),te=!1,!Te&&/^ *$/.test(ue)&&(Z+=ue+`
`,se=se.substring(ue.length+1),ze=!0),!ze)for(var nt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Me=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(ye=se.split(`
`,1)[0],Te=ye,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(Te)||Q.test(Te)||nt.test(Te)||Me.test(se)));){if(Te.search(/[^ ]/)>=W||!Te.trim())be+=`
`+Te.slice(W);else if(!te)be+=`
`+Te;else break;!te&&!Te.trim()&&(te=!0),Z+=ye+`
`,se=se.substring(ye.length+1)}Ge.loose||(ge?Ge.loose=!0:/\n *\n *$/.test(Z)&&(ge=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&(F=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Z,task:!!I,checked:F,loose:!1,text:be}),Ge.raw+=Z}Ge.items[Ge.items.length-1].raw=Z.trimRight(),Ge.items[Ge.items.length-1].text=be.trimRight(),Ge.raw=Ge.raw.trimRight();var J=Ge.items.length;for(V=0;V<J;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var Ee=Ge.items[V].tokens.filter(function(Be){return Be.type==="space"}),$e=Ee.every(function(Be){for(var Xe=Be.raw.split(""),Qe=0,Ke=M(Xe),at;!(at=Ke()).done;){var St=at.value;if(St===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ge.loose&&Ee.length&&$e&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},ve.html=function(se){var oe=this.rules.block.html.exec(se);if(oe){var Z={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(oe[0]):g(oe[0]);Z.type="paragraph",Z.text=I,Z.tokens=this.lexer.inline(I)}return Z}},ve.def=function(se){var oe=this.rules.block.def.exec(se);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var Z=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:oe[0],href:oe[2],title:oe[3]}}},ve.table=function(se){var oe=this.rules.block.table.exec(se);if(oe){var Z={type:"table",header:c(oe[1]).map(function(ge){return{text:ge}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=oe[0];var I=Z.align.length,F,W,V,te;for(F=0;F<I;F++)/^ *-+: *$/.test(Z.align[F])?Z.align[F]="right":/^ *:-+: *$/.test(Z.align[F])?Z.align[F]="center":/^ *:-+ *$/.test(Z.align[F])?Z.align[F]="left":Z.align[F]=null;for(I=Z.rows.length,F=0;F<I;F++)Z.rows[F]=c(Z.rows[F],Z.header.length).map(function(ge){return{text:ge}});for(I=Z.header.length,W=0;W<I;W++)Z.header[W].tokens=this.lexer.inline(Z.header[W].text);for(I=Z.rows.length,W=0;W<I;W++)for(te=Z.rows[W],V=0;V<te.length;V++)te[V].tokens=this.lexer.inline(te[V].text);return Z}}},ve.lheading=function(se){var oe=this.rules.block.lheading.exec(se);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ve.paragraph=function(se){var oe=this.rules.block.paragraph.exec(se);if(oe){var Z=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:Z,tokens:this.lexer.inline(Z)}}},ve.text=function(se){var oe=this.rules.block.text.exec(se);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ve.escape=function(se){var oe=this.rules.inline.escape.exec(se);if(oe)return{type:"escape",raw:oe[0],text:g(oe[1])}},ve.tag=function(se){var oe=this.rules.inline.tag.exec(se);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):g(oe[0]):oe[0]}},ve.link=function(se){var oe=this.rules.inline.link.exec(se);if(oe){var Z=oe[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var I=v(Z.slice(0,-1),"\\");if((Z.length-I.length)%2===0)return}else{var F=y(oe[2],"()");if(F>-1){var W=oe[0].indexOf("!")===0?5:4,V=W+oe[1].length+F;oe[2]=oe[2].substring(0,F),oe[0]=oe[0].substring(0,V).trim(),oe[3]=""}}var te=oe[2],ge="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);Te&&(te=Te[1],ge=Te[3])}else ge=oe[3]?oe[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Z)?te=te.slice(1):te=te.slice(1,-1)),G(oe,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ve.reflink=function(se,oe){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var I=(Z[2]||Z[1]).replace(/\s+/g," ");if(I=oe[I.toLowerCase()],!I||!I.href){var F=Z[0].charAt(0);return{type:"text",raw:F,text:F}}return G(Z,I,Z[0],this.lexer)}},ve.emStrong=function(se,oe,Z){Z===void 0&&(Z="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=I[1]||I[2]||"";if(!F||F&&(Z===""||this.rules.inline.punctuation.exec(Z))){var W=I[0].length-1,V,te,ge=W,Te=0,ue=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,oe=oe.slice(-1*se.length+W);(I=ue.exec(oe))!=null;)if(V=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!V){if(te=V.length,I[3]||I[4]){ge+=te;continue}else if((I[5]||I[6])&&W%3&&!((W+te)%3)){Te+=te;continue}if(ge-=te,!(ge>0)){if(te=Math.min(te,te+ge+Te),Math.min(W,te)%2){var ye=se.slice(1,W+I.index+te);return{type:"em",raw:se.slice(0,W+I.index+te+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var be=se.slice(2,W+I.index+te-1);return{type:"strong",raw:se.slice(0,W+I.index+te+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},ve.codespan=function(se){var oe=this.rules.inline.code.exec(se);if(oe){var Z=oe[2].replace(/\n/g," "),I=/[^ ]/.test(Z),F=/^ /.test(Z)&&/ $/.test(Z);return I&&F&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:oe[0],text:Z}}},ve.br=function(se){var oe=this.rules.inline.br.exec(se);if(oe)return{type:"br",raw:oe[0]}},ve.del=function(se){var oe=this.rules.inline.del.exec(se);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ve.autolink=function(se,oe){var Z=this.rules.inline.autolink.exec(se);if(Z){var I,F;return Z[2]==="@"?(I=g(this.options.mangle?oe(Z[1]):Z[1]),F="mailto:"+I):(I=g(Z[1]),F=I),{type:"link",raw:Z[0],text:I,href:F,tokens:[{type:"text",raw:I,text:I}]}}},ve.url=function(se,oe){var Z;if(Z=this.rules.inline.url.exec(se)){var I,F;if(Z[2]==="@")I=g(this.options.mangle?oe(Z[0]):Z[0]),F="mailto:"+I;else{var W;do W=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(W!==Z[0]);I=g(Z[0]),Z[1]==="www."?F="http://"+I:F=I}return{type:"link",raw:Z[0],text:I,href:F,tokens:[{type:"text",raw:I,text:I}]}}},ve.inlineText=function(se,oe){var Z=this.rules.inline.text.exec(se);if(Z){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:I=g(this.options.smartypants?oe(Z[0]):Z[0]),{type:"text",raw:Z[0],text:I}}},we}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=d(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=d(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=d(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=d(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=d(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=d(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=r({},N),N.gfm=r({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=d(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=d(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=r({},N.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:d(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=d(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=d(N._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=d(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=d(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=d(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=d(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=d(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=d(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=d(B.reflink).replace("label",B._label).replace("ref",N._label).getRegex(),B.nolink=d(B.nolink).replace("ref",N._label).getRegex(),B.reflinkSearch=d(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=r({},B),B.pedantic=r({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=r({},B.normal,{escape:d(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=d(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=r({},B.gfm,{br:d(B.br).replace("{2,}","*").getRegex(),text:d(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(we){return we.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(we){var ve="",Ie,se,oe=we.length;for(Ie=0;Ie<oe;Ie++)se=we.charCodeAt(Ie),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var j=function(){function we(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ee.defaults,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:N.normal,inline:B.normal};this.options.pedantic?(se.block=N.pedantic,se.inline=B.pedantic):this.options.gfm&&(se.block=N.gfm,this.options.breaks?se.inline=B.breaks:se.inline=B.gfm),this.tokenizer.rules=se}we.lex=function(se,oe){var Z=new we(oe);return Z.lex(se)},we.lexInline=function(se,oe){var Z=new we(oe);return Z.inlineTokens(se)};var ve=we.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ve.blockTokens=function(se,oe){var Z=this;oe===void 0&&(oe=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ge,Te,ue){return Te+"    ".repeat(ue.length)});for(var I,F,W,V;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(I=ge.call({lexer:Z},se,oe))?(se=se.substring(I.raw.length),oe.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),F=oe[oe.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+I.raw,F.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):oe.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),F=oe[oe.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+I.raw,F.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,Te=se.slice(1),ue=void 0;Z.options.extensions.startBlock.forEach(function(ye){ue=ye.call({lexer:this},Te),typeof ue=="number"&&ue>=0&&(ge=Math.min(ge,ue))}),ge<1/0&&ge>=0&&(W=se.substring(0,ge+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){F=oe[oe.length-1],V&&F.type==="paragraph"?(F.raw+=`
`+I.raw,F.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):oe.push(I),V=W.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),F=oe[oe.length-1],F&&F.type==="text"?(F.raw+=`
`+I.raw,F.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):oe.push(I);continue}if(se){var te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,oe},ve.inline=function(se,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:se,tokens:oe}),oe},ve.inlineTokens=function(se,oe){var Z=this;oe===void 0&&(oe=[]);var I,F,W,V=se,te,ge,Te;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)ue.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,te.index)+"["+$("a",te[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,te.index)+"["+$("a",te[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,te.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ge||(Te=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Z},se,oe))?(se=se.substring(I.raw.length),oe.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),F=oe[oe.length-1],F&&I.type==="text"&&F.type==="text"?(F.raw+=I.raw,F.text+=I.text):oe.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),F=oe[oe.length-1],F&&I.type==="text"&&F.type==="text"?(F.raw+=I.raw,F.text+=I.text):oe.push(I);continue}if(I=this.tokenizer.emStrong(se,V,Te)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),oe.push(I);continue}if(I=this.tokenizer.autolink(se,z)){se=se.substring(I.raw.length),oe.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,z))){se=se.substring(I.raw.length),oe.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,ze=se.slice(1),Ue=void 0;Z.options.extensions.startInline.forEach(function(tt){Ue=tt.call({lexer:this},ze),typeof Ue=="number"&&Ue>=0&&(be=Math.min(be,Ue))}),be<1/0&&be>=0&&(W=se.substring(0,be+1))}(),I=this.tokenizer.inlineText(W,U)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Te=I.raw.slice(-1)),ge=!0,F=oe[oe.length-1],F&&F.type==="text"?(F.raw+=I.raw,F.text+=I.text):oe.push(I);continue}if(se){var ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return oe},n(we,null,[{key:"rules",get:function(){return{block:N,inline:B}}}]),we}(),fe=function(){function we(Ie){this.options=Ie||ee.defaults}var ve=we.prototype;return ve.code=function(se,oe,Z){var I=(oe||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(se,I);F!=null&&F!==se&&(Z=!0,se=F)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+g(I,!0)+'">'+(Z?se:g(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:g(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,oe,Z,I){if(this.options.headerIds){var F=this.options.headerPrefix+I.slug(Z);return"<h"+oe+' id="'+F+'">'+se+"</h"+oe+`>
`}return"<h"+oe+">"+se+"</h"+oe+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,oe,Z){var I=oe?"ol":"ul",F=oe&&Z!==1?' start="'+Z+'"':"";return"<"+I+F+`>
`+se+"</"+I+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+oe+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,oe){var Z=oe.header?"th":"td",I=oe.align?"<"+Z+' align="'+oe.align+'">':"<"+Z+">";return I+se+("</"+Z+`>
`)},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,oe,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<a href="'+g(se)+'"';return oe&&(I+=' title="'+oe+'"'),I+=">"+Z+"</a>",I},ve.image=function(se,oe,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<img src="'+se+'" alt="'+Z+'"';return oe&&(I+=' title="'+oe+'"'),I+=this.options.xhtml?"/>":">",I},ve.text=function(se){return se},we}(),_e=function(){function we(){}var ve=we.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,oe,Z){return""+Z},ve.image=function(se,oe,Z){return""+Z},ve.br=function(){return""},we}(),ie=function(){function we(){this.seen={}}var ve=we.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,oe){var Z=se,I=0;if(this.seen.hasOwnProperty(Z)){I=this.seen[se];do I++,Z=se+"-"+I;while(this.seen.hasOwnProperty(Z))}return oe||(this.seen[se]=I,this.seen[Z]=0),Z},ve.slug=function(se,oe){oe===void 0&&(oe={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,oe.dryrun)},we}(),le=function(){function we(Ie){this.options=Ie||ee.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _e,this.slugger=new ie}we.parse=function(se,oe){var Z=new we(oe);return Z.parse(se)},we.parseInline=function(se,oe){var Z=new we(oe);return Z.parseInline(se)};var ve=we.prototype;return ve.parse=function(se,oe){oe===void 0&&(oe=!0);var Z="",I,F,W,V,te,ge,Te,ue,ye,be,ze,Ue,tt,Ge,it,nt,Me,rt,Q,J=se.length;for(I=0;I<J;I++){if(be=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Q=this.options.extensions.renderers[be.type].call({parser:this},be),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Z+=Q||"";continue}switch(be.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(be.tokens),be.depth,t(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ue="",Te="",V=be.header.length,F=0;F<V;F++)Te+=this.renderer.tablecell(this.parseInline(be.header[F].tokens),{header:!0,align:be.align[F]});for(ue+=this.renderer.tablerow(Te),ye="",V=be.rows.length,F=0;F<V;F++){for(ge=be.rows[F],Te="",te=ge.length,W=0;W<te;W++)Te+=this.renderer.tablecell(this.parseInline(ge[W].tokens),{header:!1,align:be.align[W]});ye+=this.renderer.tablerow(Te)}Z+=this.renderer.table(ue,ye);continue}case"blockquote":{ye=this.parse(be.tokens),Z+=this.renderer.blockquote(ye);continue}case"list":{for(ze=be.ordered,Ue=be.start,tt=be.loose,V=be.items.length,ye="",F=0;F<V;F++)it=be.items[F],nt=it.checked,Me=it.task,Ge="",it.task&&(rt=this.renderer.checkbox(nt),tt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=rt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=rt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:rt}):Ge+=rt),Ge+=this.parse(it.tokens,tt),ye+=this.renderer.listitem(Ge,Me,nt);Z+=this.renderer.list(ye,ze,Ue);continue}case"html":{Z+=this.renderer.html(be.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ye=be.tokens?this.parseInline(be.tokens):be.text;I+1<J&&se[I+1].type==="text";)be=se[++I],ye+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Z+=oe?this.renderer.paragraph(ye):ye;continue}default:{var Ee='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Ee);return}else throw new Error(Ee)}}}return Z},ve.parseInline=function(se,oe){oe=oe||this.renderer;var Z="",I,F,W,V=se.length;for(I=0;I<V;I++){if(F=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(W=this.options.extensions.renderers[F.type].call({parser:this},F),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){Z+=W||"";continue}switch(F.type){case"escape":{Z+=oe.text(F.text);break}case"html":{Z+=oe.html(F.text);break}case"link":{Z+=oe.link(F.href,F.title,this.parseInline(F.tokens,oe));break}case"image":{Z+=oe.image(F.href,F.title,F.text);break}case"strong":{Z+=oe.strong(this.parseInline(F.tokens,oe));break}case"em":{Z+=oe.em(this.parseInline(F.tokens,oe));break}case"codespan":{Z+=oe.codespan(F.text);break}case"br":{Z+=oe.br();break}case"del":{Z+=oe.del(this.parseInline(F.tokens,oe));break}case"text":{Z+=oe.text(F.text);break}default:{var te='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Z},we}();function ce(we,ve,Ie){if(typeof we>"u"||we===null)throw new Error("marked(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");if(typeof ve=="function"&&(Ie=ve,ve=null),ve=r({},ce.defaults,ve||{}),b(ve),Ie){var se=ve.highlight,oe;try{oe=j.lex(we,ve)}catch(V){return Ie(V)}var Z=function(te){var ge;if(!te)try{ve.walkTokens&&ce.walkTokens(oe,ve.walkTokens),ge=le.parse(oe,ve)}catch(Te){te=Te}return ve.highlight=se,te?Ie(te):Ie(null,ge)};if(!se||se.length<3||(delete ve.highlight,!oe.length))return Z();var I=0;ce.walkTokens(oe,function(V){V.type==="code"&&(I++,setTimeout(function(){se(V.text,V.lang,function(te,ge){if(te)return Z(te);ge!=null&&ge!==V.text&&(V.text=ge,V.escaped=!0),I--,I===0&&Z()})},0))}),I===0&&Z();return}function F(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(V.message+"",!0)+"</pre>";throw V}try{var W=j.lex(we,ve);if(ve.walkTokens){if(ve.async)return Promise.all(ce.walkTokens(W,ve.walkTokens)).then(function(){return le.parse(W,ve)}).catch(F);ce.walkTokens(W,ve.walkTokens)}return le.parse(W,ve)}catch(V){F(V)}}ce.options=ce.setOptions=function(we){return r(ce.defaults,we),P(ce.defaults),ce},ce.getDefaults=A,ce.defaults=ee.defaults,ce.use=function(){for(var we=arguments.length,ve=new Array(we),Ie=0;Ie<we;Ie++)ve[Ie]=arguments[Ie];var se=r.apply(void 0,[{}].concat(ve)),oe=ce.defaults.extensions||{renderers:{},childTokens:{}},Z;ve.forEach(function(I){if(I.extensions&&(Z=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var V=oe.renderers?oe.renderers[W.name]:null;V?oe.renderers[W.name]=function(){for(var te=arguments.length,ge=new Array(te),Te=0;Te<te;Te++)ge[Te]=arguments[Te];var ue=W.renderer.apply(this,ge);return ue===!1&&(ue=V.apply(this,ge)),ue}:oe.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[W.level]?oe[W.level].unshift(W.tokenizer):oe[W.level]=[W.tokenizer],W.start&&(W.level==="block"?oe.startBlock?oe.startBlock.push(W.start):oe.startBlock=[W.start]:W.level==="inline"&&(oe.startInline?oe.startInline.push(W.start):oe.startInline=[W.start]))}W.childTokens&&(oe.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ce.defaults.renderer||new fe,V=function(Te){var ue=W[Te];W[Te]=function(){for(var ye=arguments.length,be=new Array(ye),ze=0;ze<ye;ze++)be[ze]=arguments[ze];var Ue=I.renderer[Te].apply(W,be);return Ue===!1&&(Ue=ue.apply(W,be)),Ue}};for(var te in I.renderer)V(te);se.renderer=W}(),I.tokenizer&&function(){var W=ce.defaults.tokenizer||new K,V=function(Te){var ue=W[Te];W[Te]=function(){for(var ye=arguments.length,be=new Array(ye),ze=0;ze<ye;ze++)be[ze]=arguments[ze];var Ue=I.tokenizer[Te].apply(W,be);return Ue===!1&&(Ue=ue.apply(W,be)),Ue}};for(var te in I.tokenizer)V(te);se.tokenizer=W}(),I.walkTokens){var F=ce.defaults.walkTokens;se.walkTokens=function(W){var V=[];return V.push(I.walkTokens.call(this,W)),F&&(V=V.concat(F.call(this,W))),V}}Z&&(se.extensions=oe),ce.setOptions(se)})},ce.walkTokens=function(we,ve){for(var Ie=[],se=function(){var F=Z.value;switch(Ie=Ie.concat(ve.call(ce,F)),F.type){case"table":{for(var W=M(F.header),V;!(V=W()).done;){var te=V.value;Ie=Ie.concat(ce.walkTokens(te.tokens,ve))}for(var ge=M(F.rows),Te;!(Te=ge()).done;)for(var ue=Te.value,ye=M(ue),be;!(be=ye()).done;){var ze=be.value;Ie=Ie.concat(ce.walkTokens(ze.tokens,ve))}break}case"list":{Ie=Ie.concat(ce.walkTokens(F.items,ve));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[F.type]?ce.defaults.extensions.childTokens[F.type].forEach(function(Ue){Ie=Ie.concat(ce.walkTokens(F[Ue],ve))}):F.tokens&&(Ie=Ie.concat(ce.walkTokens(F.tokens,ve)))}},oe=M(we),Z;!(Z=oe()).done;)se();return Ie},ce.parseInline=function(we,ve){if(typeof we>"u"||we===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");ve=r({},ce.defaults,ve||{}),b(ve);try{var Ie=j.lexInline(we,ve);return ve.walkTokens&&ce.walkTokens(Ie,ve.walkTokens),le.parseInline(Ie,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(se.message+"",!0)+"</pre>";throw se}},ce.Parser=le,ce.parser=le.parse,ce.Renderer=fe,ce.TextRenderer=_e,ce.Lexer=j,ce.lexer=j.lex,ce.Tokenizer=K,ce.Slugger=ie,ce.parse=ce;var ke=ce.options,de=ce.setOptions,ae=ce.use,H=ce.walkTokens,O=ce.parseInline,X=ce,pe=le.parse,Ce=j.lex;ee.Lexer=j,ee.Parser=le,ee.Renderer=fe,ee.Slugger=ie,ee.TextRenderer=_e,ee.Tokenizer=K,ee.getDefaults=A,ee.lexer=Ce,ee.marked=ce,ee.options=ke,ee.parse=X,ee.parseInline=O,ee.parser=pe,ee.setOptions=de,ee.use=ae,ee.walkTokens=H,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Pe[115],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(P,D,m){return Math.min(Math.max(P,D),m)}e.clamp=n;function T(P,D){return(D+P%D)%D}e.rot=T;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class M{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class A{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const m=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=m,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function ee(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function A(D){M.push(D,Date.now())}function P(){const D=[];for(let m=0;m<M.length;m+=2)D.push({name:M[m],startTime:M[m+1]});return D}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(C+A.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function n(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=n(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var T in n)(typeof exports=="object"?exports:ee)[T]=n[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function n(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return ee[T].call(C.exports,C,C.exports,n),C.l=!0,C.exports}return n.m=ee,n.c=e,n.d=function(T,C,M){n.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},n.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},n.t=function(T,C){if(1&C&&(T=n(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var A in T)n.d(M,A,function(P){return T[P]}.bind(null,A));return M},n.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return n.d(C,"a",C),C},n.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},n.p="",n(n.s=0)}([function(ee,e,n){(function(T){var C;e=ee.exports=ae,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],D=e.src=[],m=0,R=m++;D[R]="0|[1-9]\\d*";var S=m++;D[S]="[0-9]+";var h=m++;D[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=m++;D[w]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var g=m++;D[g]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var u=m++;D[u]="(?:"+D[R]+"|"+D[h]+")";var t=m++;D[t]="(?:"+D[S]+"|"+D[h]+")";var a=m++;D[a]="(?:-("+D[u]+"(?:\\."+D[u]+")*))";var d=m++;D[d]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var _=m++;D[_]="[0-9A-Za-z-]+";var k=m++;D[k]="(?:\\+("+D[_]+"(?:\\."+D[_]+")*))";var p=m++,i="v?"+D[w]+D[a]+"?"+D[k]+"?";D[p]="^"+i+"$";var l="[v=\\s]*"+D[g]+D[d]+"?"+D[k]+"?",s=m++;D[s]="^"+l+"$";var o=m++;D[o]="((?:<|>)?=?)";var f=m++;D[f]=D[S]+"|x|X|\\*";var E=m++;D[E]=D[R]+"|x|X|\\*";var r=m++;D[r]="[v=\\s]*("+D[E]+")(?:\\.("+D[E]+")(?:\\.("+D[E]+")(?:"+D[a]+")?"+D[k]+"?)?)?";var c=m++;D[c]="[v=\\s]*("+D[f]+")(?:\\.("+D[f]+")(?:\\.("+D[f]+")(?:"+D[d]+")?"+D[k]+"?)?)?";var v=m++;D[v]="^"+D[o]+"\\s*"+D[r]+"$";var y=m++;D[y]="^"+D[o]+"\\s*"+D[c]+"$";var b=m++;D[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=m++;D[$]="(?:~>?)";var G=m++;D[G]="(\\s*)"+D[$]+"\\s+",P[G]=new RegExp(D[G],"g");var Y=m++;D[Y]="^"+D[$]+D[r]+"$";var K=m++;D[K]="^"+D[$]+D[c]+"$";var N=m++;D[N]="(?:\\^)";var B=m++;D[B]="(\\s*)"+D[N]+"\\s+",P[B]=new RegExp(D[B],"g");var U=m++;D[U]="^"+D[N]+D[r]+"$";var z=m++;D[z]="^"+D[N]+D[c]+"$";var j=m++;D[j]="^"+D[o]+"\\s*("+l+")$|^$";var fe=m++;D[fe]="^"+D[o]+"\\s*("+i+")$|^$";var _e=m++;D[_e]="(\\s*)"+D[o]+"\\s*("+l+"|"+D[r]+")",P[_e]=new RegExp(D[_e],"g");var ie=m++;D[ie]="^\\s*("+D[r]+")\\s+-\\s+("+D[r]+")\\s*$";var le=m++;D[le]="^\\s*("+D[c]+")\\s+-\\s+("+D[c]+")\\s*$";var ce=m++;D[ce]="(<|>)?=?\\s*\\*";for(var ke=0;ke<35;ke++)C(ke,D[ke]),P[ke]||(P[ke]=new RegExp(D[ke]));function de(ue,ye){if(ue instanceof ae)return ue;if(typeof ue!="string"||ue.length>M||!(ye?P[s]:P[p]).test(ue))return null;try{return new ae(ue,ye)}catch{return null}}function ae(ue,ye){if(ue instanceof ae){if(ue.loose===ye)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ae))return new ae(ue,ye);C("SemVer",ue,ye),this.loose=ye;var be=ue.trim().match(ye?P[s]:P[p]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ue=+ze;if(Ue>=0&&Ue<A)return Ue}return ze}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=de,e.valid=function(ue,ye){var be=de(ue,ye);return be?be.version:null},e.clean=function(ue,ye){var be=de(ue.trim().replace(/^[=v]+/,""),ye);return be?be.version:null},e.SemVer=ae,ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ae.prototype.toString=function(){return this.version},ae.prototype.compare=function(ue){return C("SemVer.compare",this.version,this.loose,ue),ue instanceof ae||(ue=new ae(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},ae.prototype.compareMain=function(ue){return ue instanceof ae||(ue=new ae(ue,this.loose)),O(this.major,ue.major)||O(this.minor,ue.minor)||O(this.patch,ue.patch)},ae.prototype.comparePre=function(ue){if(ue instanceof ae||(ue=new ae(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ye=0;do{var be=this.prerelease[ye],ze=ue.prerelease[ye];if(C("prerelease compare",ye,be,ze),be===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(be===void 0)return-1;if(be!==ze)return O(be,ze)}while(++ye)},ae.prototype.inc=function(ue,ye){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ye);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ye);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ye),this.inc("pre",ye);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ye),this.inc("pre",ye);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ye&&(this.prerelease[0]===ye?isNaN(this.prerelease[1])&&(this.prerelease=[ye,0]):this.prerelease=[ye,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ye,be,ze){typeof be=="string"&&(ze=be,be=void 0);try{return new ae(ue,be).inc(ye,ze).version}catch{return null}},e.diff=function(ue,ye){if(we(ue,ye))return null;var be=de(ue),ze=de(ye);if(be.prerelease.length||ze.prerelease.length){for(var Ue in be)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&be[Ue]!==ze[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in be)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&be[Ue]!==ze[Ue])return Ue},e.compareIdentifiers=O;var H=/^[0-9]+$/;function O(ue,ye){var be=H.test(ue),ze=H.test(ye);return be&&ze&&(ue=+ue,ye=+ye),be&&!ze?-1:ze&&!be?1:ue<ye?-1:ue>ye?1:0}function X(ue,ye,be){return new ae(ue,be).compare(new ae(ye,be))}function pe(ue,ye,be){return X(ue,ye,be)>0}function Ce(ue,ye,be){return X(ue,ye,be)<0}function we(ue,ye,be){return X(ue,ye,be)===0}function ve(ue,ye,be){return X(ue,ye,be)!==0}function Ie(ue,ye,be){return X(ue,ye,be)>=0}function se(ue,ye,be){return X(ue,ye,be)<=0}function oe(ue,ye,be,ze){var Ue;switch(ye){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ue=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ue=ue!==be;break;case"":case"=":case"==":Ue=we(ue,be,ze);break;case"!=":Ue=ve(ue,be,ze);break;case">":Ue=pe(ue,be,ze);break;case">=":Ue=Ie(ue,be,ze);break;case"<":Ue=Ce(ue,be,ze);break;case"<=":Ue=se(ue,be,ze);break;default:throw new TypeError("Invalid operator: "+ye)}return Ue}function Z(ue,ye){if(ue instanceof Z){if(ue.loose===ye)return ue;ue=ue.value}if(!(this instanceof Z))return new Z(ue,ye);C("comparator",ue,ye),this.loose=ye,this.parse(ue),this.semver===I?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ue,ye){return O(ye,ue)},e.major=function(ue,ye){return new ae(ue,ye).major},e.minor=function(ue,ye){return new ae(ue,ye).minor},e.patch=function(ue,ye){return new ae(ue,ye).patch},e.compare=X,e.compareLoose=function(ue,ye){return X(ue,ye,!0)},e.rcompare=function(ue,ye,be){return X(ye,ue,be)},e.sort=function(ue,ye){return ue.sort(function(be,ze){return e.compare(be,ze,ye)})},e.rsort=function(ue,ye){return ue.sort(function(be,ze){return e.rcompare(be,ze,ye)})},e.gt=pe,e.lt=Ce,e.eq=we,e.neq=ve,e.gte=Ie,e.lte=se,e.cmp=oe,e.Comparator=Z;var I={};function F(ue,ye){if(ue instanceof F)return ue.loose===ye?ue:new F(ue.raw,ye);if(ue instanceof Z)return new F(ue.value,ye);if(!(this instanceof F))return new F(ue,ye);if(this.loose=ye,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function W(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function V(ue,ye,be,ze,Ue,tt,Ge,it,nt,Me,rt,Q,J){return((ye=W(be)?"":W(ze)?">="+be+".0.0":W(Ue)?">="+be+"."+ze+".0":">="+ye)+" "+(it=W(nt)?"":W(Me)?"<"+(+nt+1)+".0.0":W(rt)?"<"+nt+"."+(+Me+1)+".0":Q?"<="+nt+"."+Me+"."+rt+"-"+Q:"<="+it)).trim()}function te(ue,ye){for(var be=0;be<ue.length;be++)if(!ue[be].test(ye))return!1;if(ye.prerelease.length){for(be=0;be<ue.length;be++)if(C(ue[be].semver),ue[be].semver!==I&&ue[be].semver.prerelease.length>0){var ze=ue[be].semver;if(ze.major===ye.major&&ze.minor===ye.minor&&ze.patch===ye.patch)return!0}return!1}return!0}function ge(ue,ye,be){try{ye=new F(ye,be)}catch{return!1}return ye.test(ue)}function Te(ue,ye,be,ze){var Ue,tt,Ge,it,nt;switch(ue=new ae(ue,ze),ye=new F(ye,ze),be){case">":Ue=pe,tt=se,Ge=Ce,it=">",nt=">=";break;case"<":Ue=Ce,tt=Ie,Ge=pe,it="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ge(ue,ye,ze))return!1;for(var Me=0;Me<ye.set.length;++Me){var rt=ye.set[Me],Q=null,J=null;if(rt.forEach(function(Ee){Ee.semver===I&&(Ee=new Z(">=0.0.0")),Q=Q||Ee,J=J||Ee,Ue(Ee.semver,Q.semver,ze)?Q=Ee:Ge(Ee.semver,J.semver,ze)&&(J=Ee)}),Q.operator===it||Q.operator===nt||(!J.operator||J.operator===it)&&tt(ue,J.semver)||J.operator===nt&&Ge(ue,J.semver))return!1}return!0}Z.prototype.parse=function(ue){var ye=this.loose?P[j]:P[fe],be=ue.match(ye);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new ae(be[2],this.loose):this.semver=I},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ue){return C("Comparator.test",ue,this.loose),this.semver===I||(typeof ue=="string"&&(ue=new ae(ue,this.loose)),oe(ue,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ue,ye){if(!(ue instanceof Z))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new F(ue.value,ye),ge(this.value,be,ye);if(ue.operator==="")return be=new F(this.value,ye),ge(ue.semver,be,ye);var ze=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),tt=this.semver.version===ue.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),it=oe(this.semver,"<",ue.semver,ye)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),nt=oe(this.semver,">",ue.semver,ye)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return ze||Ue||tt&&Ge||it||nt},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(ue){var ye=this.loose;ue=ue.trim(),C("range",ue,ye);var be=ye?P[le]:P[ie];ue=ue.replace(be,V),C("hyphen replace",ue),ue=ue.replace(P[_e],"$1$2$3"),C("comparator trim",ue,P[_e]),ue=(ue=(ue=ue.replace(P[G],"$1~")).replace(P[B],"$1^")).split(/\s+/).join(" ");var ze=ye?P[j]:P[fe],Ue=ue.split(" ").map(function(tt){return function(Ge,it){return C("comp",Ge),Ge=function(nt,Me){return nt.trim().split(/\s+/).map(function(rt){return function(Q,J){C("caret",Q,J);var Ee=J?P[z]:P[U];return Q.replace(Ee,function($e,Be,Xe,Qe,Ke){var at;return C("caret",Q,$e,Be,Xe,Qe,Ke),W(Be)?at="":W(Xe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":W(Qe)?at=Be==="0"?">="+Be+"."+Xe+".0 <"+Be+"."+(+Xe+1)+".0":">="+Be+"."+Xe+".0 <"+(+Be+1)+".0.0":Ke?(C("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),at=Be==="0"?Xe==="0"?">="+Be+"."+Xe+"."+Qe+Ke+" <"+Be+"."+Xe+"."+(+Qe+1):">="+Be+"."+Xe+"."+Qe+Ke+" <"+Be+"."+(+Xe+1)+".0":">="+Be+"."+Xe+"."+Qe+Ke+" <"+(+Be+1)+".0.0"):(C("no pr"),at=Be==="0"?Xe==="0"?">="+Be+"."+Xe+"."+Qe+" <"+Be+"."+Xe+"."+(+Qe+1):">="+Be+"."+Xe+"."+Qe+" <"+Be+"."+(+Xe+1)+".0":">="+Be+"."+Xe+"."+Qe+" <"+(+Be+1)+".0.0"),C("caret return",at),at})}(rt,Me)}).join(" ")}(Ge,it),C("caret",Ge),Ge=function(nt,Me){return nt.trim().split(/\s+/).map(function(rt){return function(Q,J){var Ee=J?P[K]:P[Y];return Q.replace(Ee,function($e,Be,Xe,Qe,Ke){var at;return C("tilde",Q,$e,Be,Xe,Qe,Ke),W(Be)?at="":W(Xe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":W(Qe)?at=">="+Be+"."+Xe+".0 <"+Be+"."+(+Xe+1)+".0":Ke?(C("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),at=">="+Be+"."+Xe+"."+Qe+Ke+" <"+Be+"."+(+Xe+1)+".0"):at=">="+Be+"."+Xe+"."+Qe+" <"+Be+"."+(+Xe+1)+".0",C("tilde return",at),at})}(rt,Me)}).join(" ")}(Ge,it),C("tildes",Ge),Ge=function(nt,Me){return C("replaceXRanges",nt,Me),nt.split(/\s+/).map(function(rt){return function(Q,J){Q=Q.trim();var Ee=J?P[y]:P[v];return Q.replace(Ee,function($e,Be,Xe,Qe,Ke,at){C("xRange",Q,$e,Be,Xe,Qe,Ke,at);var St=W(Xe),Dt=St||W(Qe),_t=Dt||W(Ke);return Be==="="&&_t&&(Be=""),St?$e=Be===">"||Be==="<"?"<0.0.0":"*":Be&&_t?(Dt&&(Qe=0),_t&&(Ke=0),Be===">"?(Be=">=",Dt?(Xe=+Xe+1,Qe=0,Ke=0):_t&&(Qe=+Qe+1,Ke=0)):Be==="<="&&(Be="<",Dt?Xe=+Xe+1:Qe=+Qe+1),$e=Be+Xe+"."+Qe+"."+Ke):Dt?$e=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":_t&&($e=">="+Xe+"."+Qe+".0 <"+Xe+"."+(+Qe+1)+".0"),C("xRange return",$e),$e})}(rt,Me)}).join(" ")}(Ge,it),C("xrange",Ge),Ge=function(nt,Me){return C("replaceStars",nt,Me),nt.trim().replace(P[ce],"")}(Ge,it),C("stars",Ge),Ge}(tt,ye)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(tt){return!!tt.match(ze)})),Ue=Ue.map(function(tt){return new Z(tt,ye)})},F.prototype.intersects=function(ue,ye){if(!(ue instanceof F))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ze){return ue.set.some(function(Ue){return Ue.every(function(tt){return ze.intersects(tt,ye)})})})})},e.toComparators=function(ue,ye){return new F(ue,ye).set.map(function(be){return be.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},F.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new ae(ue,this.loose));for(var ye=0;ye<this.set.length;ye++)if(te(this.set[ye],ue))return!0;return!1},e.satisfies=ge,e.maxSatisfying=function(ue,ye,be){var ze=null,Ue=null;try{var tt=new F(ye,be)}catch{return null}return ue.forEach(function(Ge){tt.test(Ge)&&(ze&&Ue.compare(Ge)!==-1||(Ue=new ae(ze=Ge,be)))}),ze},e.minSatisfying=function(ue,ye,be){var ze=null,Ue=null;try{var tt=new F(ye,be)}catch{return null}return ue.forEach(function(Ge){tt.test(Ge)&&(ze&&Ue.compare(Ge)!==1||(Ue=new ae(ze=Ge,be)))}),ze},e.validRange=function(ue,ye){try{return new F(ue,ye).range||"*"}catch{return null}},e.ltr=function(ue,ye,be){return Te(ue,ye,"<",be)},e.gtr=function(ue,ye,be){return Te(ue,ye,">",be)},e.outside=Te,e.prerelease=function(ue,ye){var be=de(ue,ye);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ye,be){return ue=new F(ue,be),ye=new F(ye,be),ue.intersects(ye)},e.coerce=function(ue){if(ue instanceof ae)return ue;if(typeof ue!="string")return null;var ye=ue.match(P[b]);return ye==null?null:de((ye[1]||"0")+"."+(ye[2]||"0")+"."+(ye[3]||"0"))}}).call(this,n(1))},function(ee,e){var n,T,C=ee.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(t){if(n===setTimeout)return setTimeout(t,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var D,m=[],R=!1,S=-1;function h(){R&&D&&(R=!1,D.length?m=D.concat(m):S=-1,m.length&&w())}function w(){if(!R){var t=P(h);R=!0;for(var a=m.length;a;){for(D=m,m=[];++S<a;)D&&D[S].run();S=-1,a=m.length}D=null,R=!1,function(d){if(T===clearTimeout)return clearTimeout(d);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(d);try{T(d)}catch{try{return T.call(null,d)}catch{return T.call(this,d)}}}(t)}}function g(t,a){this.fun=t,this.array=a}function u(){}C.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)a[d-1]=arguments[d];m.push(new g(t,a)),m.length!==1||R||P(w)},g.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=u,C.addListener=u,C.once=u,C.off=u,C.removeListener=u,C.removeAllListeners=u,C.emit=u,C.prependListener=u,C.prependOnceListener=u,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[116],Ae([1,0,9,6]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(k){const p=k;return p?typeof p.read=="function":!1}e.isReadable=C;function M(k){const p=k;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function A(k){const p=k;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(k,p){return new D(k,p)}e.newWriteableStream=P;class D{constructor(p,i){this.reducer=p,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(i=>i(p))}emitError(p){this.listeners.error.length===0?(0,n.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(i=>i(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,i){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(p,i){if(this.state.destroyed)return;let l;switch(p){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const s=l.indexOf(i);s>=0&&l.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(k,p){const i=[];let l;for(;(l=k.read())!==null;)i.push(l);return p(i)}e.consumeReadable=m;function R(k,p,i){const l=[];let s;for(;(s=k.read())!==null&&l.length<i;)l.push(s);return s===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return k.read()}}}e.peekReadable=R;function S(k,p){return new Promise((i,l)=>{const s=[];h(k,{onData:o=>{p&&s.push(o)},onError:o=>{p?l(o):i(void 0)},onEnd:()=>{i(p?p(s):void 0)}})})}e.consumeStream=S;function h(k,p){let i=!1;return k.on("error",l=>{i||p.onError(l)}),k.on("end",()=>{i||p.onEnd()}),k.on("data",l=>{i||p.onData(l)}),(0,T.toDisposable)(()=>i=!0)}e.listenStream=h;function w(k,p){return new Promise((i,l)=>{const s=new T.DisposableStore,o=[],f=c=>{if(o.push(c),o.length>p)return s.dispose(),k.pause(),i({stream:k,buffer:o,ended:!1})},E=c=>l(c),r=()=>i({stream:k,buffer:o,ended:!0});s.add((0,T.toDisposable)(()=>k.removeListener("error",E))),k.on("error",E),s.add((0,T.toDisposable)(()=>k.removeListener("end",r))),k.on("end",r),s.add((0,T.toDisposable)(()=>k.removeListener("data",f))),k.on("data",f)})}e.peekStream=w;function g(k,p){const i=P(p);return i.end(k),i}e.toStream=g;function u(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}e.emptyStream=u;function t(k){let p=!1;return{read:()=>p?null:(p=!0,k)}}e.toReadable=t;function a(k,p,i){const l=P(i);return h(k,{onData:s=>l.write(p.data(s)),onError:s=>l.error(p.error?p.error(s):s),onEnd:()=>l.end()}),l}e.transform=a;function d(k,p,i){let l=!1;return{read:()=>{const s=p.read();return l?s:(l=!0,s!==null?i([k,s]):k)}}}e.prefixedReadable=d;function _(k,p,i){let l=!1;const s=P(i);return h(p,{onData:o=>l?s.write(o):(l=!0,s.write(i([k,o]))),onError:o=>s.error(o),onEnd:()=>{l||(l=!0,s.write(k)),s.end()}}),s}e.prefixedStream=_}),define(Pe[25],Ae([1,0,116]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let C,M;class A{static alloc(c){return T?new A(Buffer.allocUnsafe(c)):new A(new Uint8Array(c))}static wrap(c){return T&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new A(c)}static fromString(c,v){return!(v?.dontUseNodeBuffer||!1)&&T?new A(Buffer.from(c)):(C||(C=new TextEncoder),new A(C.encode(c)))}static fromByteArray(c){const v=A.alloc(c.length);for(let y=0,b=c.length;y<b;y++)v.buffer[y]=c[y];return v}static concat(c,v){if(typeof v>"u"){v=0;for(let $=0,G=c.length;$<G;$++)v+=c[$].byteLength}const y=A.alloc(v);let b=0;for(let $=0,G=c.length;$<G;$++){const Y=c[$];y.set(Y,b),b+=Y.byteLength}return y}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=A.alloc(this.byteLength);return c.set(this),c}toString(){return T?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(c,v){return new A(this.buffer.subarray(c,v))}set(c,v){if(c instanceof A)this.buffer.set(c.buffer,v);else if(c instanceof Uint8Array)this.buffer.set(c,v);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),v);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return m(this.buffer,c)}writeUInt32BE(c,v){R(this.buffer,c,v)}readUInt32LE(c){return S(this.buffer,c)}writeUInt32LE(c,v){h(this.buffer,c,v)}readUInt8(c){return w(this.buffer,c)}writeUInt8(c,v){g(this.buffer,c,v)}}e.VSBuffer=A;function P(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=P;function D(r,c,v){r[v+0]=c&255,c=c>>>8,r[v+1]=c&255}e.writeUInt16LE=D;function m(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=m;function R(r,c,v){r[v+3]=c,c=c>>>8,r[v+2]=c,c=c>>>8,r[v+1]=c,c=c>>>8,r[v]=c}e.writeUInt32BE=R;function S(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=S;function h(r,c,v){r[v+0]=c&255,c=c>>>8,r[v+1]=c&255,c=c>>>8,r[v+2]=c&255,c=c>>>8,r[v+3]=c&255}e.writeUInt32LE=h;function w(r,c){return r[c]}e.readUInt8=w;function g(r,c,v){r[v]=c}e.writeUInt8=g;function u(r){return n.consumeReadable(r,c=>A.concat(c))}e.readableToBuffer=u;function t(r){return n.toReadable(r)}e.bufferToReadable=t;function a(r){return n.consumeStream(r,c=>A.concat(c))}e.streamToBuffer=a;async function d(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await a(r.stream)])}e.bufferedStreamToBuffer=d;function _(r){return n.toStream(r,c=>A.concat(c))}e.bufferToStream=_;function k(r){return n.transform(r,{data:c=>typeof c=="string"?A.fromString(c):A.wrap(c)},c=>A.concat(c))}e.streamToBufferReadableStream=k;function p(r){return n.newWriteableStream(c=>A.concat(c),r)}e.newWriteableBufferStream=p;function i(r,c){return n.prefixedReadable(r,c,v=>A.concat(v))}e.prefixedBufferReadable=i;function l(r,c){return n.prefixedStream(r,c,v=>A.concat(v))}e.prefixedBufferStream=l;function s(r){let c=0,v=0,y=0;const b=new Uint8Array(Math.floor(r.length/4*3)),$=Y=>{switch(v){case 3:b[y++]=c|Y,v=0;break;case 2:b[y++]=c|Y>>>2,c=Y<<6,v=3;break;case 1:b[y++]=c|Y>>>4,c=Y<<4,v=2;break;default:c=Y<<2,v=1}};for(let Y=0;Y<r.length;Y++){const K=r.charCodeAt(Y);if(K>=65&&K<=90)$(K-65);else if(K>=97&&K<=122)$(K-97+26);else if(K>=48&&K<=57)$(K-48+52);else if(K===43||K===45)$(62);else if(K===47||K===95)$(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${r[Y]}`)}}const G=y;for(;v>0;)$(0);return A.wrap(b).slice(0,G)}e.decodeBase64=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:r},c=!0,v=!1){const y=v?f:o;let b="";const $=r.byteLength%3;let G=0;for(;G<r.byteLength-$;G+=3){const Y=r[G+0],K=r[G+1],N=r[G+2];b+=y[Y>>>2],b+=y[(Y<<4|K>>>4)&63],b+=y[(K<<2|N>>>6)&63],b+=y[N&63]}if($===1){const Y=r[G+0];b+=y[Y>>>2],b+=y[Y<<4&63],c&&(b+="==")}else if($===2){const Y=r[G+0],K=r[G+1];b+=y[Y>>>2],b+=y[(Y<<4|K>>>4)&63],b+=y[K<<2&63],c&&(b+="=")}return b}e.encodeBase64=E}),define(Pe[117],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[39],Ae([1,0,85]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(A){function P(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=P})(T=e.ThemeColor||(e.ThemeColor={}));function C(A){return{id:A}}e.themeColorFromId=C;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(d){const _=P.exec(d.id);if(!_)return D(n.Codicon.error);const[,k,p]=_,i=["codicon","codicon-"+k];return p&&i.push("codicon-modifier-"+p.substring(1)),i}A.asClassNameArray=D;function m(d){return D(d).join(" ")}A.asClassName=m;function R(d){return"."+D(d).join(".")}A.asCSSSelector=R;function S(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||T.isThemeColor(d.color))}A.isThemeIcon=S;const h=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(d){const _=h.exec(d);if(!_)return;const[,k]=_;return{id:k}}A.fromString=w;function g(d){return{id:d}}A.fromId=g;function u(d,_){let k=d.id;const p=k.lastIndexOf("~");return p!==-1&&(k=k.substring(0,p)),_&&(k=`${k}~${_}`),{id:k}}A.modify=u;function t(d){const _=d.id.lastIndexOf("~");if(_!==-1)return d.id.substring(_+1)}A.getModifier=t;function a(d,_){return d.id===_.id&&d.color?.id===_.color?.id}A.isEqual=a})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Pe[35],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return n.test(C)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let D=0;D<P.length;D++)P[D]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,m="";return m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m+="-",m+=A[M[D++]],m+=A[M[D++]],m+="-",m+=A[M[D++]],m+=A[M[D++]],m+="-",m+=A[M[D++]],m+=A[M[D++]],m+="-",m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m+=A[M[D++]],m}}()}),define(Pe[118],Ae([1,0,16,35]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function C(P){return{id:(0,T.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=C;function M(P,D,m){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:D,data:m}),value:void 0}}e.createFileDataTransferItem=M;class A{constructor(){this._entries=new Map}get size(){return this._entries.size}has(D){return this._entries.has(this.toKey(D))}get(D){return this._entries.get(this.toKey(D))?.[0]}append(D,m){const R=this._entries.get(D);R?R.push(m):this._entries.set(this.toKey(D),[m])}replace(D,m){this._entries.set(this.toKey(D),[m])}delete(D){this._entries.delete(this.toKey(D))}*entries(){for(const[D,m]of this._entries.entries())for(const R of m)yield[D,R]}values(){return Array.from(this._entries.values()).flat()}forEach(D){for(const[m,R]of this.entries())D(R,m)}toKey(D){return D.toLowerCase()}}e.VSDataTransfer=A,e.UriList=Object.freeze({create:P=>(0,n.distinct)(P.map(D=>D.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(D=>!D.startsWith("#"))})}),define(Pe[119],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[120],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class T{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let D=0,m=P.notIn.length;D<m;D++)switch(P.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,D){if(P.getTokenCount()===0)return!0;const m=P.findTokenIndexAtOffset(D-2),R=P.getStandardTokenType(m);return this.isOK(R)}_findNeutralCharacterInRange(P,D){for(let m=P;m<=D;m++){const R=String.fromCharCode(m);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=T;class C{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function M(A,P,D){A.has(P)?A.get(P).push(D):A.set(P,[D])}}),define(Pe[121],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDnDService=void 0;class n{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const M=this._dragOperations.get(C);return this._dragOperations.delete(C),M}}addDragOperationTransfer(C,M){this._dragOperations.set(C,M)}}e.TreeViewsDnDService=n}),define(Pe[122],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Pe[123],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Pe[124],Ae([1,0,123]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,C=T*60,M=C*24,A=M*7,P=M*30,D=M*365;function m(S,h,w,g){typeof S!="number"&&(S=S.getTime());const u=Math.round((new Date().getTime()-S)/1e3);if(u<-30)return(0,n.localize)(0,null,m(new Date().getTime()+u*1e3,!1));if(!g&&u<30)return(0,n.localize)(1,null);let t;return u<T?(t=u,h?t===1?w?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):w?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?w?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):w?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):u<C?(t=Math.floor(u/T),h?t===1?w?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):w?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?w?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):w?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):u<M?(t=Math.floor(u/C),h?t===1?w?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):w?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?w?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):w?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):u<A?(t=Math.floor(u/M),h?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):u<P?(t=Math.floor(u/A),h?t===1?w?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):w?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?w?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):w?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):u<D?(t=Math.floor(u/P),h?t===1?w?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):w?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?w?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):w?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(u/D),h?t===1?w?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):w?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?w?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):w?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=m;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Pe[125],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,16,10,125]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,h){return h&&(S.stack||S.stacktrace)?C.localize(0,null,P(S),A(S.stack)||A(S.stacktrace)):P(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function D(S=null,h=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const w=n.coalesce(S),g=D(w[0],h);return w.length>1?C.localize(4,null,g,w.length):g}if(T.isString(S))return S;if(S.detail){const w=S.detail;if(w.error)return M(w.error,h);if(w.exception)return M(w.exception,h)}return S.stack?M(S,h):S.message?S.message:C.localize(5,null)}e.toErrorMessage=D;function m(S){const h=S;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=m;function R(S,h){let w;return typeof S=="string"?w=new Error(S):w=S,w.actions=h,w}e.createErrorWithActions=R}),define(Pe[126],Ae([1,0,86,19]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new n.Lazy(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(c,v,y=!1){const b=c||"",$=v||"",G=C.value.collator.compare(b,$);return C.value.collatorIsNumeric&&G===0&&b!==$?b<$?-1:1:G}e.compareFileNames=P;function D(c,v){const y=M.value.collator;return c=c||"",v=v||"",k(y,c,v)}e.compareFileNamesDefault=D;function m(c,v){const y=M.value.collator;return c=c||"",v=v||"",s(c,v)||k(y,c,v)}e.compareFileNamesUpper=m;function R(c,v){const y=M.value.collator;return c=c||"",v=v||"",l(c,v)||k(y,c,v)}e.compareFileNamesLower=R;function S(c,v){return c=c||"",v=v||"",c===v?0:c<v?-1:1}e.compareFileNamesUnicode=S;function h(c,v){const[y,b]=d(c),[$,G]=d(v);let Y=C.value.collator.compare(b,G);if(Y===0){if(C.value.collatorIsNumeric&&b!==G)return b<G?-1:1;if(Y=C.value.collator.compare(y,$),C.value.collatorIsNumeric&&Y===0&&y!==$)return y<$?-1:1}return Y}e.compareFileExtensions=h;function w(c,v){c=c||"",v=v||"";const y=_(c),b=_(v),$=M.value.collator,G=A.value.collator;return k(G,y,b)||k($,c,v)}e.compareFileExtensionsDefault=w;function g(c,v){c=c||"",v=v||"";const y=_(c),b=_(v),$=M.value.collator,G=A.value.collator;return k(G,y,b)||s(c,v)||k($,c,v)}e.compareFileExtensionsUpper=g;function u(c,v){c=c||"",v=v||"";const y=_(c),b=_(v),$=M.value.collator,G=A.value.collator;return k(G,y,b)||l(c,v)||k($,c,v)}e.compareFileExtensionsLower=u;function t(c,v){c=c||"",v=v||"";const y=_(c).toLowerCase(),b=_(v).toLowerCase();return y!==b?y<b?-1:1:c!==v?c<v?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function d(c,v=!1){const y=c?a.exec(c):[];let b=[y&&y[1]||"",y&&y[3]||""];return v&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function _(c){const v=c?a.exec(c):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function k(c,v,y){const b=c.compare(v,y);return b!==0?b:v.length!==y.length?v.length<y.length?-1:1:0}function p(c){const v=c.charAt(0);return v.toLocaleUpperCase()!==v}function i(c){const v=c.charAt(0);return v.toLocaleLowerCase()!==v}function l(c,v){return p(c)&&i(v)?-1:i(c)&&p(v)?1:0}function s(c,v){return i(c)&&p(v)?-1:p(c)&&i(v)?1:0}function o(c,v,y=!1){return y||(c=c&&c.toLowerCase(),v=v&&v.toLowerCase()),c===v?0:c<v?-1:1}function f(c,v,y=!1){const b=c.split(T.sep),$=v.split(T.sep),G=b.length-1,Y=$.length-1;let K,N;for(let B=0;;B++){if(K=G===B,N=Y===B,K&&N)return P(b[B],$[B],y);if(K)return-1;if(N)return 1;const U=o(b[B],$[B],y);if(U!==0)return U}}e.comparePaths=f;function E(c,v,y){const b=c.toLowerCase(),$=v.toLowerCase(),G=r(c,v,y);if(G)return G;const Y=b.endsWith(y),K=$.endsWith(y);if(Y!==K)return Y?-1:1;const N=P(b,$);return N!==0?N:b.localeCompare($)}e.compareAnything=E;function r(c,v,y){const b=c.toLowerCase(),$=v.toLowerCase(),G=b.startsWith(y),Y=$.startsWith(y);if(G!==Y)return G?-1:1;if(G&&Y){if(b.length<$.length)return-1;if(b.length>$.length)return 1}return 0}e.compareByPrefix=r}),define(Pe[66],Ae([1,0,19]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,n.extname)(R),h=T[S.toLowerCase()];return h!==void 0?h:A(R)}e.getMediaOrTextMime=M;function A(R){const S=(0,n.extname)(R);return C[S.toLowerCase()]}e.getMediaMime=A;function P(R){for(const S in C)if(C[S]===R)return S}e.getExtensionForMimeType=P;const D=/^(.+)\/(.+?)(;.+)?$/;function m(R,S){const h=D.exec(R);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:S?void 0:R}e.normalizeMimeType=m}),define(Pe[127],Ae([1,0,4,6,122]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends T.Disposable{constructor(h,w="",g="",u=!0,t){super(),this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=h,this._label=w,this._cssClass=g,this._enabled=u,this._actionCallback=t}get id(){return this._id}get label(){return this._label}set label(h){this._setLabel(h)}_setLabel(h){this._label!==h&&(this._label=h,this._onDidChange.fire({label:h}))}get tooltip(){return this._tooltip||""}set tooltip(h){this._setTooltip(h)}_setTooltip(h){this._tooltip!==h&&(this._tooltip=h,this._onDidChange.fire({tooltip:h}))}get class(){return this._cssClass}set class(h){this._setClass(h)}_setClass(h){this._cssClass!==h&&(this._cssClass=h,this._onDidChange.fire({class:h}))}get enabled(){return this._enabled}set enabled(h){this._setEnabled(h)}_setEnabled(h){this._enabled!==h&&(this._enabled=h,this._onDidChange.fire({enabled:h}))}get checked(){return this._checked}set checked(h){this._setChecked(h)}_setChecked(h){this._checked!==h&&(this._checked=h,this._onDidChange.fire({checked:h}))}async run(h,w){this._actionCallback&&await this._actionCallback(h)}}e.Action=M;class A extends T.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new n.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new n.Emitter),this.onDidRun=this._onDidRun.event}async run(h,w){if(!h.enabled)return;this._onWillRun.fire({action:h});let g;try{await this.runAction(h,w)}catch(u){g=u}this._onDidRun.fire({action:h,error:g})}async runAction(h,w){await h.run(w)}}e.ActionRunner=A;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let w=[];for(const g of h)g.length&&(w.length?w=[...w,new P,...g]:w=g);return w}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class D{get actions(){return this._actions}constructor(h,w,g,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=w,this.class=u,this._actions=g}async run(){}}e.SubmenuAction=D;class m extends M{constructor(){super(m.ID,C.localize(0,null),void 0,!1)}}m.ID="vs.actions.empty",e.EmptySubmenuAction=m;function R(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.toAction=R}),define(Pe[41],Ae([1,0,19,20,13,10]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(E){return E===47||E===92}e.isPathSeparator=A;function P(E){return E.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=P;function D(E){return E.indexOf("/")===-1&&(E=P(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}e.toPosixPath=D;function m(E,r=n.posix.sep){if(!E)return"";const c=E.length,v=E.charCodeAt(0);if(A(v)){if(A(E.charCodeAt(1))&&!A(E.charCodeAt(2))){let b=3;const $=b;for(;b<c&&!A(E.charCodeAt(b));b++);if($!==b&&!A(E.charCodeAt(b+1))){for(b+=1;b<c;b++)if(A(E.charCodeAt(b)))return E.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(a(v)&&E.charCodeAt(1)===58)return A(E.charCodeAt(2))?E.slice(0,2)+r:E.slice(0,2);let y=E.indexOf("://");if(y!==-1){for(y+=3;y<c;y++)if(A(E.charCodeAt(y)))return E.slice(0,y+1)}return""}e.getRoot=m;function R(E){if(!T.isWindows||!E||E.length<5)return!1;let r=E.charCodeAt(0);if(r!==92||(r=E.charCodeAt(1),r!==92))return!1;let c=2;const v=c;for(;c<E.length&&(r=E.charCodeAt(c),r!==92);c++);return!(v===c||(r=E.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=R;const S=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(E,r=T.isWindows){const c=r?S:h;return!(!E||E.length===0||/^\s+$/.test(E)||(c.lastIndex=0,c.test(E))||r&&w.test(E)||E==="."||E===".."||r&&E[E.length-1]==="."||r&&E.length!==E.trim().length||E.length>255)}e.isValidBasename=g;function u(E,r,c){const v=E===r;return!c||v?v:!E||!r?!1:(0,C.equalsIgnoreCase)(E,r)}e.isEqual=u;function t(E,r,c,v=n.sep){if(E===r)return!0;if(!E||!r||r.length>E.length)return!1;if(c){if(!(0,C.startsWithIgnoreCase)(E,r))return!1;if(r.length===E.length)return!0;let b=r.length;return r.charAt(r.length-1)===v&&b--,E.charAt(b)===v}return r.charAt(r.length-1)!==v&&(r+=v),E.indexOf(r)===0}e.isEqualOrParent=t;function a(E){return E>=65&&E<=90||E>=97&&E<=122}e.isWindowsDriveLetter=a;function d(E,r){return T.isWindows&&E.endsWith(":")&&(E+=n.sep),(0,n.isAbsolute)(E)||(E=(0,n.join)(r,E)),E=(0,n.normalize)(E),T.isWindows?(E=(0,C.rtrim)(E,n.sep),E.endsWith(":")&&(E+=n.sep)):(E=(0,C.rtrim)(E,n.sep),E||(E=n.sep)),E}e.sanitizeFilePath=d;function _(E){const r=(0,n.normalize)(E);return T.isWindows?E.length>3?!1:k(r)&&(E.length===2||r.charCodeAt(2)===92):r===n.posix.sep}e.isRootOrDriveLetter=_;function k(E,r=T.isWindows){return r?a(E.charCodeAt(0))&&E.charCodeAt(1)===58:!1}e.hasDriveLetter=k;function p(E){return k(E)?E[0]:void 0}e.getDriveLetter=p;function i(E,r,c){return r.length>E.length?-1:E===r?0:(c&&(E=E.toLowerCase(),r=r.toLowerCase()),E.indexOf(r))}e.indexOfPath=i;function l(E){const r=E.split(":");let c,v,y;for(const b of r){const $=Number(b);(0,M.isNumber)($)?v===void 0?v=$:y===void 0&&(y=$):c=c?[c,b].join(":"):b}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function f(E,r,c=8){let v="";for(let b=0;b<c;b++){let $;b===0&&T.isWindows&&!r&&(c===3||c===4)?$=o:$=s,v+=$.charAt(Math.floor(Math.random()*$.length))}let y;return r?y=`${r}-${v}`:y=v,E?(0,n.join)(E,y):y}e.randomPath=f}),define(Pe[128],Ae([1,0,28,13]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(I,F){for(let W=0,V=Z.length;W<V;W++){const te=Z[W](I,F);if(te)return te}return null}}e.or=C,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,I,F){if(!F||F.length<I.length)return null;let W;return Z?W=T.startsWithIgnoreCase(F,I):W=F.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function A(Z,I){const F=I.toLowerCase().indexOf(Z.toLowerCase());return F===-1?null:[{start:F,end:F+Z.length}]}e.matchesContiguousSubString=A;function P(Z,I){return D(Z.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=P;function D(Z,I,F,W){if(F===Z.length)return[];if(W===I.length)return null;if(Z[F]===I[W]){let V=null;return(V=D(Z,I,F+1,W+1))?a({start:W,end:W+1},V):null}return D(Z,I,F,W+1)}function m(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function S(Z){return 48<=Z&&Z<=57}function h(Z){return Z===32||Z===9||Z===10||Z===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>w.add(Z.charCodeAt(0)));function g(Z){return h(Z)||w.has(Z)}function u(Z,I){return Z===I||g(Z)&&g(I)}function t(Z){return m(Z)||R(Z)||S(Z)}function a(Z,I){return I.length===0?I=[Z]:Z.end===I[0].start?I[0].start=Z.start:I.unshift(Z),I}function d(Z,I){for(let F=I;F<Z.length;F++){const W=Z.charCodeAt(F);if(R(W)||S(W)||F>0&&!t(Z.charCodeAt(F-1)))return F}return Z.length}function _(Z,I,F,W){if(F===Z.length)return[];if(W===I.length)return null;if(Z[F]!==I[W].toLowerCase())return null;{let V=null,te=W+1;for(V=_(Z,I,F+1,W+1);!V&&(te=d(I,te))<I.length;)V=_(Z,I,F+1,te),te++;return V===null?null:a({start:W,end:W+1},V)}}function k(Z){let I=0,F=0,W=0,V=0,te=0;for(let be=0;be<Z.length;be++)te=Z.charCodeAt(be),R(te)&&I++,m(te)&&F++,t(te)&&W++,S(te)&&V++;const ge=I/Z.length,Te=F/Z.length,ue=W/Z.length,ye=V/Z.length;return{upperPercent:ge,lowerPercent:Te,alphaPercent:ue,numericPercent:ye}}function p(Z){const{upperPercent:I,lowerPercent:F}=Z;return F===0&&I>.6}function i(Z){const{upperPercent:I,lowerPercent:F,alphaPercent:W,numericPercent:V}=Z;return F>.2&&I<.8&&W>.6&&V<.2}function l(Z){let I=0,F=0,W=0,V=0;for(let te=0;te<Z.length;te++)W=Z.charCodeAt(te),R(W)&&I++,m(W)&&F++,h(W)&&V++;return(I===0||F===0)&&V===0?Z.length<=30:I<=5}function s(Z,I){if(!I||(I=I.trim(),I.length===0)||!l(Z)||I.length>60)return null;const F=k(I);if(!i(F)){if(!p(F))return null;I=I.toLowerCase()}let W=null,V=0;for(Z=Z.toLowerCase();V<I.length&&(W=_(Z,I,0,V))===null;)V=d(I,V+1);return W}e.matchesCamelCase=s;function o(Z,I,F=!1){if(!I||I.length===0)return null;let W=null,V=0;for(Z=Z.toLowerCase(),I=I.toLowerCase();V<I.length&&(W=f(Z,I,0,V,F))===null;)V=E(I,V+1);return W}e.matchesWords=o;function f(Z,I,F,W,V){if(F===Z.length)return[];if(W===I.length)return null;if(u(Z.charCodeAt(F),I.charCodeAt(W))){let te=null,ge=W+1;if(te=f(Z,I,F+1,W+1,V),!V)for(;!te&&(ge=E(I,ge))<I.length;)te=f(Z,I,F+1,ge,V),ge++;return te?Z.charCodeAt(F)!==I.charCodeAt(W)?te:a({start:W,end:W+1},te):null}else return null}function E(Z,I){for(let F=I;F<Z.length;F++)if(g(Z.charCodeAt(F))||F>0&&g(Z.charCodeAt(F-1)))return F;return Z.length}const r=C(e.matchesPrefix,s,A),c=C(e.matchesPrefix,s,P),v=new n.LRUCache(1e4);function y(Z,I,F=!1){if(typeof Z!="string"||typeof I!="string")return null;let W=v.get(Z);W||(W=new RegExp(T.convertSimple2RegExpPattern(Z),"i"),v.set(Z,W));const V=W.exec(I);return V?[{start:V.index,end:V.index+V[0].length}]:F?c(Z,I):r(Z,I)}e.matchesFuzzy=y;function b(Z,I){const F=pe(Z,Z.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?G(F):null}e.matchesFuzzy2=b;function $(Z,I,F,W,V,te){const ge=Math.min(13,Z.length);for(;F<ge;F++){const Te=pe(Z,I,F,W,V,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Te)return Te}return[0,te]}e.anyScore=$;function G(Z){if(typeof Z>"u")return[];const I=[],F=Z[1];for(let W=Z.length-1;W>1;W--){const V=Z[W]+F,te=I[I.length-1];te&&te.end===V?te.end=V+1:I.push({start:V,end:V+1})}return I}e.createMatches=G;const Y=128;function K(){const Z=[],I=[];for(let F=0;F<=Y;F++)I[F]=0;for(let F=0;F<=Y;F++)Z.push(I.slice(0));return Z}function N(Z){const I=[];for(let F=0;F<=Z;F++)I[F]=0;return I}const B=N(2*Y),U=N(2*Y),z=K(),j=K(),fe=K(),_e=!1;function ie(Z,I,F,W,V){function te(Te,ue,ye=" "){for(;Te.length<ue;)Te=ye+Te;return Te}let ge=` |   |${W.split("").map(Te=>te(Te,3)).join("|")}
`;for(let Te=0;Te<=F;Te++)Te===0?ge+=" |":ge+=`${I[Te-1]}|`,ge+=Z[Te].slice(0,V+1).map(ue=>te(ue.toString(),3)).join("|")+`
`;return ge}function le(Z,I,F,W){Z=Z.substr(I),F=F.substr(W),console.log(ie(j,Z,Z.length,F,F.length)),console.log(ie(fe,Z,Z.length,F,F.length)),console.log(ie(z,Z,Z.length,F,F.length))}function ce(Z,I){if(I<0||I>=Z.length)return!1;const F=Z.codePointAt(I);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(F)}}function ke(Z,I){if(I<0||I>=Z.length)return!1;switch(Z.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function de(Z,I,F){return I[Z]!==F[Z]}function ae(Z,I,F,W,V,te,ge=!1){for(;I<F&&V<te;)Z[I]===W[V]&&(ge&&(B[I]=V),I+=1),V+=1;return I===F}e.isPatternInWord=ae;var H;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(H||(H={}));var O;(function(Z){Z.Default=[-100,0];function I(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}Z.isDefault=I})(O=e.FuzzyScore||(e.FuzzyScore={}));class X{constructor(I,F){this.firstMatchCanBeWeak=I,this.boostFullMatch=F}}X.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=X;function pe(Z,I,F,W,V,te,ge=X.default){const Te=Z.length>Y?Y:Z.length,ue=W.length>Y?Y:W.length;if(F>=Te||te>=ue||Te-F>ue-te||!ae(I,F,Te,V,te,ue,!0))return;Ce(Te,ue,F,te,I,V);let ye=1,be=1,ze=F,Ue=te;const tt=[!1];for(ye=1,ze=F;ze<Te;ye++,ze++){const rt=B[ze],Q=U[ze],J=ze+1<Te?U[ze+1]:ue;for(be=rt-te+1,Ue=rt;Ue<J;be++,Ue++){let Ee=Number.MIN_SAFE_INTEGER,$e=!1;Ue<=Q&&(Ee=we(Z,I,ze,F,W,V,Ue,ue,te,z[ye-1][be-1]===0,tt));let Be=0;Ee!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=Ee+j[ye-1][be-1]);const Xe=Ue>rt,Qe=Xe?j[ye][be-1]+(z[ye][be-1]>0?-5:0):0,Ke=Ue>rt+1&&z[ye][be-1]>0,at=Ke?j[ye][be-2]+(z[ye][be-2]>0?-5:0):0;if(Ke&&(!Xe||at>=Qe)&&(!$e||at>=Be))j[ye][be]=at,fe[ye][be]=3,z[ye][be]=0;else if(Xe&&(!$e||Qe>=Be))j[ye][be]=Qe,fe[ye][be]=2,z[ye][be]=0;else if($e)j[ye][be]=Be,fe[ye][be]=1,z[ye][be]=z[ye-1][be-1]+1;else throw new Error("not possible")}}if(_e&&le(Z,F,W,te),!tt[0]&&!ge.firstMatchCanBeWeak)return;ye--,be--;const Ge=[j[ye][be],te];let it=0,nt=0;for(;ye>=1;){let rt=be;do{const Q=fe[ye][rt];if(Q===3)rt=rt-2;else if(Q===2)rt=rt-1;else break}while(rt>=1);it>1&&I[F+ye-1]===V[te+be-1]&&!de(rt+te-1,W,V)&&it+1>z[ye][rt]&&(rt=be),rt===be?it++:it=1,nt||(nt=rt),ye--,be=rt-1,Ge.push(be)}ue===Te&&ge.boostFullMatch&&(Ge[0]+=2);const Me=nt-Te;return Ge[0]-=Me,Ge}e.fuzzyScore=pe;function Ce(Z,I,F,W,V,te){let ge=Z-1,Te=I-1;for(;ge>=F&&Te>=W;)V[ge]===te[Te]&&(U[ge]=Te,ge--),Te--}function we(Z,I,F,W,V,te,ge,Te,ue,ye,be){if(I[F]!==te[ge])return Number.MIN_SAFE_INTEGER;let ze=1,Ue=!1;return ge===F-W?ze=Z[F]===V[ge]?7:5:de(ge,V,te)&&(ge===0||!de(ge-1,V,te))?(ze=Z[F]===V[ge]?7:5,Ue=!0):ce(te,ge)&&(ge===0||!ce(te,ge-1))?ze=5:(ce(te,ge-1)||ke(te,ge-1))&&(ze=5,Ue=!0),ze>1&&F===W&&(be[0]=!0),Ue||(Ue=de(ge,V,te)||ce(te,ge-1)||ke(te,ge-1)),F===W?ge>ue&&(ze-=Ue?3:5):ye?ze+=Ue?2:0:ze+=Ue?0:1,ge+1===Te&&(ze-=Ue?3:5),ze}function ve(Z,I,F,W,V,te,ge){return se(Z,I,F,W,V,te,!0,ge)}e.fuzzyScoreGracefulAggressive=ve;function Ie(Z,I,F,W,V,te,ge){return se(Z,I,F,W,V,te,!1,ge)}e.fuzzyScoreGraceful=Ie;function se(Z,I,F,W,V,te,ge,Te){let ue=pe(Z,I,F,W,V,te,Te);if(ue&&!ge)return ue;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let be=F+1;be<ye;be++){const ze=oe(Z,be);if(ze){const Ue=pe(ze,ze.toLowerCase(),F,W,V,te,Te);Ue&&(Ue[0]-=3,(!ue||Ue[0]>ue[0])&&(ue=Ue))}}}return ue}function oe(Z,I){if(I+1>=Z.length)return;const F=Z[I],W=Z[I+1];if(F!==W)return Z.slice(0,I)+W+F+Z.slice(I+2)}}),define(Pe[129],Ae([1,0,128,13,39]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${A.source}`,"g");function D(a){return a.replace(P,(d,_)=>_?d:`\\${d}`)}e.escapeIcons=D;const m=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(m,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=R;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function h(a){return a.indexOf(M)===-1?a:a.replace(S,(d,_,k,p)=>k?d:_||p||"")}e.stripIcons=h;function w(a){return a?a.replace(/\$\((.*?)\)/g,(d,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=w;const g=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(a){g.lastIndex=0;let d="";const _=[];let k=0;for(;;){const p=g.lastIndex,i=g.exec(a),l=a.substring(p,i?.index);if(l.length>0){d+=l;for(let s=0;s<l.length;s++)_.push(k)}if(!i)break;k+=i[0].length}return{text:d,iconOffsets:_}}e.parseLabelWithIcons=u;function t(a,d,_=!1){const{text:k,iconOffsets:p}=d;if(!p||p.length===0)return(0,n.matchesFuzzy)(a,k,_);const i=(0,T.ltrim)(k," "),l=k.length-i.length,s=(0,n.matchesFuzzy)(a,i,_);if(s)for(const o of s){const f=p[o.start+l]+l;o.start+=f,o.end+=f}return s}e.matchesFuzzyIconAware=t}),define(Pe[29],Ae([1,0,13]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",A="warning",P="warn",D="info",m="ignore";function R(h){return h?n.equalsIgnoreCase(M,h)?C.Error:n.equalsIgnoreCase(A,h)||n.equalsIgnoreCase(P,h)?C.Warning:n.equalsIgnoreCase(D,h)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function S(h){switch(h){case C.Error:return M;case C.Warning:return A;case C.Info:return D;default:return m}}C.toString=S}(T||(T={})),e.default=T}),define(Pe[48],Ae([1,0,16,13]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this._value="",this._pos=0}reset(w){return this._value=w,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(w){const g=w.charCodeAt(0),u=this._value.charCodeAt(this._pos);return g-u}value(){return this._value[this._pos]}}e.StringIterator=C;class M{constructor(w=!0){this._caseSensitive=w}reset(w){return this._value=w,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let w=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(w)this._from++;else break;else w=!1;return this}cmp(w){return this._caseSensitive?(0,T.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class A{constructor(w=!0,g=!0){this._splitOnBackslash=w,this._caseSensitive=g}reset(w){this._from=0,this._to=0,this._value=w,this._valueLen=w.length;for(let g=w.length-1;g>=0;g--,this._valueLen--){const u=this._value.charCodeAt(g);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let w=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(w)this._from++;else break;else w=!1}return this}cmp(w){return this._caseSensitive?(0,T.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var P;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(P||(P={}));class D{constructor(w,g){this._ignorePathCasing=w,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(w){return this._value=w,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(w)),this._pathIterator.reset(w.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(w)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(w){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(w,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(w,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(w);if(this._states[this._stateIdx]===4)return(0,T.compare)(w,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(w,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=D;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(R||(R={}));class S{static forUris(w=()=>!1,g=()=>!1){return new S(new D(w,g))}static forPaths(w=!1){return new S(new A(void 0,!w))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new M)}constructor(w){this._iter=w}clear(){this._root=void 0}fill(w,g){if(g){const u=g.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t,w)}else{const u=w.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t[0],t[1])}}set(w,g){const u=this._iter.reset(w);let t;this._root||(this._root=new m,this._root.segment=u.value());const a=[];for(t=this._root;;){const _=u.cmp(t.segment);if(_>0)t.left||(t.left=new m,t.left.segment=u.value()),a.push([-1,t]),t=t.left;else if(_<0)t.right||(t.right=new m,t.right.segment=u.value()),a.push([1,t]),t=t.right;else if(u.hasNext())u.next(),t.mid||(t.mid=new m,t.mid.segment=u.value()),a.push([0,t]),t=t.mid;else break}const d=t.value;t.value=g,t.key=w;for(let _=a.length-1;_>=0;_--){const k=a[_][1];k.updateHeight();const p=k.balanceFactor();if(p<-1||p>1){const i=a[_][0],l=a[_+1][0];if(i===1&&l===1)a[_][1]=k.rotateLeft();else if(i===-1&&l===-1)a[_][1]=k.rotateRight();else if(i===1&&l===-1)k.right=a[_+1][1]=a[_+1][1].rotateRight(),a[_][1]=k.rotateLeft();else if(i===-1&&l===1)k.left=a[_+1][1]=a[_+1][1].rotateLeft(),a[_][1]=k.rotateRight();else throw new Error;if(_>0)switch(a[_-1][0]){case-1:a[_-1][1].left=a[_][1];break;case 1:a[_-1][1].right=a[_][1];break;case 0:a[_-1][1].mid=a[_][1];break}else this._root=a[0][1]}}return d}get(w){return this._getNode(w)?.value}_getNode(w){const g=this._iter.reset(w);let u=this._root;for(;u;){const t=g.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if(g.hasNext())g.next(),u=u.mid;else break}return u}has(w){const g=this._getNode(w);return!(g?.value===void 0&&g?.mid===void 0)}delete(w){return this._delete(w,!1)}deleteSuperstr(w){return this._delete(w,!0)}_delete(w,g){const u=this._iter.reset(w),t=[];let a=this._root;for(;a;){const d=u.cmp(a.segment);if(d>0)t.push([-1,a]),a=a.left;else if(d<0)t.push([1,a]),a=a.right;else if(u.hasNext())u.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(g?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const d=this._min(a.right);if(d.key){const{key:_,value:k,segment:p}=d;this._delete(d.key,!1),a.key=_,a.value=k,a.segment=p}}else{const d=a.left??a.right;if(t.length>0){const[_,k]=t[t.length-1];switch(_){case-1:k.left=d;break;case 0:k.mid=d;break;case 1:k.right=d;break}}else this._root=d}for(let d=t.length-1;d>=0;d--){const _=t[d][1];_.updateHeight();const k=_.balanceFactor();if(k>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),t[d][1]=_.rotateLeft()):k<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),t[d][1]=_.rotateRight()),d>0)switch(t[d-1][0]){case-1:t[d-1][1].left=t[d][1];break;case 1:t[d-1][1].right=t[d][1];break;case 0:t[d-1][1].mid=t[d][1];break}else this._root=t[0][1]}}}_min(w){for(;w.left;)w=w.left;return w}findSubstr(w){const g=this._iter.reset(w);let u=this._root,t;for(;u;){const a=g.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(g.hasNext())g.next(),t=u.value||t,u=u.mid;else break}return u&&u.value||t}findSuperstr(w){return this._findSuperstrOrElement(w,!1)}_findSuperstrOrElement(w,g){const u=this._iter.reset(w);let t=this._root;for(;t;){const a=u.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else return t.mid?this._entries(t.mid):g?t.value:void 0}}hasElementOrSubtree(w){return this._findSuperstrOrElement(w,!0)!==void 0}forEach(w){for(const[g,u]of this)w(u,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(w){const g=[];return this._dfsEntries(w,g),g[Symbol.iterator]()}_dfsEntries(w,g){!w||(w.left&&this._dfsEntries(w.left,g),w.value&&g.push([w.key,w.value]),w.mid&&this._dfsEntries(w.mid,g),w.right&&this._dfsEntries(w.right,g))}_isBalanced(){const w=g=>{if(!g)return!0;const u=g.balanceFactor();return u<-1||u>1?!1:w(g.left)&&w(g.right)};return w(this._root)}}e.TernarySearchTree=S}),define(Pe[67],Ae([1,0,25,13,2]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(m){return JSON.stringify(m,P)}e.stringify=M;function A(m){let R=JSON.parse(m);return R=D(R),R}e.parse=A;function P(m,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,T.regExpFlags)(R)}:R}function D(m,R=0){if(!m||R>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof n.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let S=0;S<m.length;++S)m[S]=D(m[S],R+1);else for(const S in m)Object.hasOwnProperty.call(m,S)&&(m[S]=D(m[S],R+1))}return m}e.revive=D}),define(Pe[15],Ae([1,0,9,20,2]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(R){this._preferredWebSchema=R}setDelegate(R){this._delegate=R}setServerRootPath(R){this._remoteResourcesPath=`${R}/${M.vscodeRemoteResource}`}set(R,S,h){this._hosts[R]=S,this._ports[R]=h}setConnectionToken(R,S){this._connectionTokens[R]=S}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(R){if(this._delegate)try{return this._delegate(R)}catch(t){return n.onUnexpectedError(t),R}const S=R.authority;let h=this._hosts[S];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const w=this._ports[S],g=this._connectionTokens[S];let u=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(u+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),C.URI.from({scheme:T.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${h}:${w}`,path:this._remoteResourcesPath,query:u})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(R){const S=this.toUri(R,ee);return this.uriToBrowserUri(S)}uriToBrowserUri(R){return R.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===M.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${M.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?R.with({scheme:M.vscodeFileResource,authority:R.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(R){const S=this.toUri(R,ee);return this.uriToFileUri(S)}uriToFileUri(R){return R.scheme===M.vscodeFileResource?R.with({scheme:M.file,authority:R.authority!==P.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(R,S){return C.URI.isUri(R)?R:C.URI.parse(S.toUrl(R))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var D;(function(m){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(R.get("3"));const S="vscode-coi";function h(g){let u;typeof g=="string"?u=new URL(g).searchParams:g instanceof URL?u=g.searchParams:C.URI.isUri(g)&&(u=new URL(g.toString(!0)).searchParams);const t=u?.get(S);if(!!t)return R.get(t)}m.getHeadersFromQuery=h;function w(g,u,t){if(!globalThis.crossOriginIsolated)return;const a=u&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(S,a):g[S]=a}m.addSearchParam=w})(D=e.COI||(e.COI={}))}),define(Pe[22],Ae([1,0,41,15,19,20,13,2]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(w){return(0,P.uriToFsPath)(w,!0)}e.originalFSPath=D;class m{constructor(g){this._ignorePathCasing=g}compare(g,u,t=!1){return g===u?0:(0,A.compare)(this.getComparisonKey(g,t),this.getComparisonKey(u,t))}isEqual(g,u,t=!1){return g===u?!0:!g||!u?!1:this.getComparisonKey(g,t)===this.getComparisonKey(u,t)}getComparisonKey(g,u=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,u,t=!1){if(g.scheme===u.scheme){if(g.scheme===T.Schemas.file)return n.isEqualOrParent(D(g),D(u),this._ignorePathCasing(g))&&g.query===u.query&&(t||g.fragment===u.fragment);if((0,e.isEqualAuthority)(g.authority,u.authority))return n.isEqualOrParent(g.path,u.path,this._ignorePathCasing(g),"/")&&g.query===u.query&&(t||g.fragment===u.fragment)}return!1}joinPath(g,...u){return P.URI.joinPath(g,...u)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return C.posix.basename(g.path)}extname(g){return C.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let u;return g.scheme===T.Schemas.file?u=P.URI.file(C.dirname(D(g))).path:(u=C.posix.dirname(g.path),g.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),u="/")),g.with({path:u})}normalizePath(g){if(!g.path.length)return g;let u;return g.scheme===T.Schemas.file?u=P.URI.file(C.normalize(D(g))).path:u=C.posix.normalize(g.path),g.with({path:u})}relativePath(g,u){if(g.scheme!==u.scheme||!(0,e.isEqualAuthority)(g.authority,u.authority))return;if(g.scheme===T.Schemas.file){const d=C.relative(D(g),D(u));return M.isWindows?n.toSlashes(d):d}let t=g.path||"/";const a=u.path||"/";if(this._ignorePathCasing(g)){let d=0;for(const _=Math.min(t.length,a.length);d<_&&!(t.charCodeAt(d)!==a.charCodeAt(d)&&t.charAt(d).toLowerCase()!==a.charAt(d).toLowerCase());d++);t=a.substr(0,d)+t.substr(d)}return C.posix.relative(t,a)}resolvePath(g,u){if(g.scheme===T.Schemas.file){const t=P.URI.file(C.resolve(D(g),u));return g.with({authority:t.authority,path:t.path})}return u=n.toPosixPath(u),g.with({path:C.posix.resolve(g.path,u)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,u){return g===u||g!==void 0&&u!==void 0&&(0,A.equalsIgnoreCase)(g,u)}hasTrailingPathSeparator(g,u=C.sep){if(g.scheme===T.Schemas.file){const t=D(g);return t.length>n.getRoot(t).length&&t[t.length-1]===u}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,u=C.sep){return(0,e.hasTrailingPathSeparator)(g,u)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,u=C.sep){let t=!1;if(g.scheme===T.Schemas.file){const a=D(g);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===u}else{u="/";const a=g.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,u)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(w=>w.scheme===T.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(w,g){const u=[];for(let t=0;t<w.length;t++){const a=g(w[t]);w.some((d,_)=>_===t?!1:(0,e.isEqualOrParent)(a,g(d)))||u.push(w[t])}return u}e.distinctParents=R;var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function g(u){const t=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(_=>{const[k,p]=_.split(":");k&&p&&t.set(k,p)});const d=u.path.substring(0,u.path.indexOf(";"));return d&&t.set(w.META_DATA_MIME,d),t}w.parseMetaData=g})(S=e.DataUri||(e.DataUri={}));function h(w,g,u){if(g){let t=w.path;return t&&t[0]!==C.posix.sep&&(t=C.posix.sep+t),w.with({scheme:u,authority:g,path:t})}return w.with({scheme:u})}e.toLocalResource=h}),define(Pe[17],Ae([1,0,21,9,4,6,22,20,117]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=m;function R(ae){const H=new n.CancellationTokenSource,O=ae(H.token),X=new Promise((pe,Ce)=>{const we=H.token.onCancellationRequested(()=>{we.dispose(),H.dispose(),Ce(new T.CancellationError)});Promise.resolve(O).then(ve=>{we.dispose(),H.dispose(),pe(ve)},ve=>{we.dispose(),H.dispose(),Ce(ve)})});return new class{cancel(){H.cancel()}then(pe,Ce){return X.then(pe,Ce)}catch(pe){return this.then(void 0,pe)}finally(pe){return X.finally(pe)}}}e.createCancelablePromise=R;function S(ae,H,O){return new Promise((X,pe)=>{const Ce=H.onCancellationRequested(()=>{Ce.dispose(),X(O)});ae.then(X,pe).finally(()=>Ce.dispose())})}e.raceCancellation=S;function h(ae,H){return new Promise((O,X)=>{const pe=H.onCancellationRequested(()=>{pe.dispose(),X(new T.CancellationError)});ae.then(O,X).finally(()=>pe.dispose())})}e.raceCancellationError=h;async function w(ae){let H=-1;const O=ae.map((pe,Ce)=>pe.then(we=>(H=Ce,we))),X=await Promise.race(O);return ae.forEach((pe,Ce)=>{Ce!==H&&pe.cancel()}),X}e.raceCancellablePromises=w;function g(ae,H,O){let X;const pe=setTimeout(()=>{X?.(void 0),O?.()},H);return Promise.race([ae.finally(()=>clearTimeout(pe)),new Promise(Ce=>X=Ce)])}e.raceTimeout=g;function u(ae){return new Promise((H,O)=>{const X=ae();m(X)?X.then(H,O):H(X)})}e.asPromise=u;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const X=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,X};this.queuedPromise=new Promise(X=>{this.activePromise.then(O,O).then(X)})}return new Promise((O,X)=>{this.queuedPromise.then(O,X)})}return this.activePromise=H(),new Promise((O,X)=>{this.activePromise.then(pe=>{this.activePromise=null,O(pe)},pe=>{this.activePromise=null,X(pe)})})}}e.Throttler=t;class a{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=a;class d{constructor(){this.promiseMap=new Map}queue(H,O){const pe=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(H)===pe&&this.promiseMap.delete(H)});return this.promiseMap.set(H,pe),pe}}e.SequencerByKey=d;const _=(ae,H)=>{let O=!0;const X=setTimeout(()=>{O=!1,H()},ae);return{isTriggered:()=>O,dispose:()=>{clearTimeout(X),O=!1}}},k=ae=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,ae())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class p{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,O=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Ce)=>{this.doResolve=pe,this.doReject=Ce}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const X=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===D.MicrotaskDelay?k(X):_(O,X),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(H){this.delayer=new p(H),this.throttler=new t}trigger(H,O){return this.delayer.trigger(()=>this.throttler.queue(H),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=i;class l{constructor(){this._isOpen=!1,this._promise=new Promise((H,O)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class s extends l{constructor(H){super(),this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function o(ae,H){return H?new Promise((O,X)=>{const pe=setTimeout(()=>{Ce.dispose(),O()},ae),Ce=H.onCancellationRequested(()=>{clearTimeout(pe),Ce.dispose(),X(new T.CancellationError)})}):R(O=>o(ae,O))}e.timeout=o;function f(ae,H=0){const O=setTimeout(ae,H);return(0,M.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=f;function E(ae){const H=[];let O=0;const X=ae.length;function pe(){return O<X?ae[O++]():null}function Ce(we){we!=null&&H.push(we);const ve=pe();return ve?ve.then(Ce):Promise.resolve(H)}return Promise.resolve(null).then(Ce)}e.sequence=E;function r(ae,H=X=>!!X,O=null){let X=0;const pe=ae.length,Ce=()=>{if(X>=pe)return Promise.resolve(O);const we=ae[X++];return Promise.resolve(we()).then(Ie=>H(Ie)?Promise.resolve(Ie):Ce())};return Ce()}e.first=r;function c(ae,H=X=>!!X,O=null){if(ae.length===0)return Promise.resolve(O);let X=ae.length;const pe=()=>{X=-1;for(const Ce of ae)Ce.cancel?.()};return new Promise((Ce,we)=>{for(const ve of ae)ve.then(Ie=>{--X>=0&&H(Ie)?(pe(),Ce(Ie)):X===0&&Ce(O)}).catch(Ie=>{--X>=0&&(pe(),we(Ie))})})}e.firstParallel=c;class v{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){return this._size++,new Promise((O,X)=>{this.outstandingPromises.push({factory:H,c:O,e:X}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const O=H.factory();O.then(H.c,H.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=v;class y extends v{constructor(){super(1)}}e.Queue=y;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const H=new _e;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,O=A.extUri){const X=O.getComparisonKey(H);let pe=this.queues.get(X);return pe||(pe=new y,C.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(X),this.onDidQueueDrain()}),this.queues.set(X,pe)),pe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class ${constructor(H,O){this._token=-1,typeof H=="function"&&typeof O=="number"&&this.setIfNotSet(H,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},O)}setIfNotSet(H,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},O))}}e.TimeoutTimer=$;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,O){this.cancel(),this._token=setInterval(()=>{H()},O)}}e.IntervalTimer=G;class Y{constructor(H,O){this.timeoutToken=-1,this.runner=H,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Y;class K{constructor(H,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class N extends Y{constructor(H,O){super(H,O),this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner?.(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class B extends M.Disposable{constructor(H,O){super(),this.options=H,this.handler=O,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const O of H)this.pendingWork.push(O);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,P.setTimeout0)(()=>{if(H)return;const O=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(ae,H)=>{const O=requestIdleCallback(ae,typeof H=="number"?{timeout:H}:void 0);let X=!1;return{dispose(){X||(X=!0,cancelIdleCallback(O))}}}}();class U{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function z(ae,H,O){let X;for(let pe=0;pe<O;pe++)try{return await ae()}catch(Ce){X=Ce,await o(H)}throw X}e.retry=z;class j{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(H,O,X){return this._pending={taskId:H,cancel:()=>X?.(),promise:O},O.then(()=>this.donePending(H),()=>this.donePending(H)),O}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let O,X;const pe=new Promise((Ce,we)=>{O=Ce,X=we});this._next={run:H,promise:pe,promiseResolve:O,promiseReject:X}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class fe{constructor(H,O=()=>Date.now()){this.interval=H,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=fe;class _e{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,O)=>{this.completeCallback=H,this.errorCallback=O})}complete(H){return new Promise(O=>{this.completeCallback(H),this.resolved=!0,O()})}error(H){return new Promise(O=>{this.errorCallback(H),this.rejected=!0,O()})}cancel(){new Promise(H=>{this.errorCallback(new T.CancellationError),this.rejected=!0,H()})}}e.DeferredPromise=_e;var ie;(function(ae){async function H(X){let pe;const Ce=await Promise.all(X.map(we=>we.then(ve=>ve,ve=>{pe||(pe=ve)})));if(typeof pe<"u")throw pe;return Ce}ae.settled=H;function O(X){return new Promise(async(pe,Ce)=>{try{await X(pe,Ce)}catch(we){Ce(we)}})}ae.withAsyncBody=O})(ie=e.Promises||(e.Promises={}));var le;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(le||(le={}));class ce{static fromArray(H){return new ce(O=>{O.emitMany(H)})}static fromPromise(H){return new ce(async O=>{O.emitMany(await H)})}static fromPromises(H){return new ce(async O=>{await Promise.all(H.map(async X=>O.emitOne(await X)))})}static merge(H){return new ce(async O=>{await Promise.all(H.map(async X=>{for await(const pe of X)O.emitOne(pe)}))})}constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const O={emitOne:X=>this.emitOne(X),emitMany:X=>this.emitMany(X),reject:X=>this.reject(X)};try{await Promise.resolve(H(O)),this.resolve()}catch(X){this.reject(X)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,O){return new ce(async X=>{for await(const pe of H)X.emitOne(O(pe))})}map(H){return ce.map(this,H)}static filter(H,O){return new ce(async X=>{for await(const pe of H)O(pe)&&X.emitOne(pe)})}filter(H){return ce.filter(this,H)}static coalesce(H){return ce.filter(H,O=>!!O)}coalesce(){return ce.coalesce(this)}static async toPromise(H){const O=[];for await(const X of H)O.push(X);return O}toPromise(){return ce.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}ce.EMPTY=ce.fromArray([]),e.AsyncIterableObject=ce;class ke extends ce{constructor(H,O){super(O),this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ke;function de(ae){const H=new n.CancellationTokenSource,O=ae(H.token);return new ke(H,async X=>{const pe=H.token.onCancellationRequested(()=>{pe.dispose(),H.dispose(),X.reject(new T.CancellationError)});try{for await(const Ce of O){if(H.token.isCancellationRequested)return;X.emitOne(Ce)}pe.dispose(),H.dispose()}catch(Ce){pe.dispose(),H.dispose(),X.reject(Ce)}})}e.createCancelableAsyncIterable=de}),define(Pe[36],Ae([1,0,16,17,41,28,19,20,13]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",S="[^/\\\\]",h=/\//g;function w(fe,_e){switch(fe){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${_e?`|${R}${S}+`:""})*?`}}function g(fe,_e){if(!fe)return[];const ie=[];let le=!1,ce=!1,ke="";for(const de of fe){switch(de){case _e:if(!le&&!ce){ie.push(ke),ke="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ke+=de}return ke&&ie.push(ke),ie}e.splitGlobAware=g;function u(fe){if(!fe)return"";let _e="";const ie=g(fe,e.GLOB_SPLIT);if(ie.every(le=>le===e.GLOBSTAR))_e=".*";else{let le=!1;ie.forEach((ce,ke)=>{if(ce===e.GLOBSTAR){if(le)return;_e+=w(2,ke===ie.length-1)}else{let de=!1,ae="",H=!1,O="";for(const X of ce){if(X!=="}"&&de){ae+=X;continue}if(H&&(X!=="]"||!O)){let pe;X==="-"?pe=X:(X==="^"||X==="!")&&!O?pe="^":X===e.GLOB_SPLIT?pe="":pe=(0,D.escapeRegExpCharacters)(X),O+=pe;continue}switch(X){case"{":de=!0;continue;case"[":H=!0;continue;case"}":{_e+=`(?:${g(ae,",").map(we=>u(we)).join("|")})`,de=!1,ae="";break}case"]":{_e+="["+O+"]",H=!1,O="";break}case"?":_e+=S;continue;case"*":_e+=w(1);continue;default:_e+=(0,D.escapeRegExpCharacters)(X)}}ke<ie.length-1&&(ie[ke+1]!==e.GLOBSTAR||ke+2<ie.length)&&(_e+=R)}le=ce===e.GLOBSTAR})}return _e}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),l=function(){return!1},s=function(){return null};function o(fe,_e){if(!fe)return s;let ie;typeof fe!="string"?ie=fe.pattern:ie=fe,ie=ie.trim();const le=`${ie}_${!!_e.trimForExclusions}`;let ce=i.get(le);if(ce)return f(ce,fe);let ke;return t.test(ie)?ce=r(ie.substr(4),ie):(ke=a.exec(E(ie,_e)))?ce=c(ke[1],ie):(_e.trimForExclusions?_:d).test(ie)?ce=v(ie,_e):(ke=k.exec(E(ie,_e)))?ce=y(ke[1].substr(1),ie,!0):(ke=p.exec(E(ie,_e)))?ce=y(ke[1],ie,!1):ce=b(ie),i.set(le,ce),f(ce,fe)}function f(fe,_e){if(typeof _e=="string")return fe;const ie=function(le,ce){return(0,C.isEqualOrParent)(le,_e.base,!P.isLinux)?fe((0,D.ltrim)(le.substr(_e.base.length),A.sep),ce):null};return ie.allBasenames=fe.allBasenames,ie.allPaths=fe.allPaths,ie.basenames=fe.basenames,ie.patterns=fe.patterns,ie}function E(fe,_e){return _e.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function r(fe,_e){return function(ie,le){return typeof ie=="string"&&ie.endsWith(fe)?_e:null}}function c(fe,_e){const ie=`/${fe}`,le=`\\${fe}`,ce=function(de,ae){return typeof de!="string"?null:ae?ae===fe?_e:null:de===fe||de.endsWith(ie)||de.endsWith(le)?_e:null},ke=[fe];return ce.basenames=ke,ce.patterns=[_e],ce.allBasenames=ke,ce}function v(fe,_e){const ie=z(fe.slice(1,-1).split(",").map(ae=>o(ae,_e)).filter(ae=>ae!==s),fe),le=ie.length;if(!le)return s;if(le===1)return ie[0];const ce=function(ae,H){for(let O=0,X=ie.length;O<X;O++)if(ie[O](ae,H))return fe;return null},ke=ie.find(ae=>!!ae.allBasenames);ke&&(ce.allBasenames=ke.allBasenames);const de=ie.reduce((ae,H)=>H.allPaths?ae.concat(H.allPaths):ae,[]);return de.length&&(ce.allPaths=de),ce}function y(fe,_e,ie){const le=A.sep===A.posix.sep,ce=le?fe:fe.replace(h,A.sep),ke=A.sep+ce,de=A.posix.sep+fe;let ae;return ie?ae=function(H,O){return typeof H=="string"&&(H===ce||H.endsWith(ke)||!le&&(H===fe||H.endsWith(de)))?_e:null}:ae=function(H,O){return typeof H=="string"&&(H===ce||!le&&H===fe)?_e:null},ae.allPaths=[(ie?"*/":"./")+fe],ae}function b(fe){try{const _e=new RegExp(`^${u(fe)}$`);return function(ie){return _e.lastIndex=0,typeof ie=="string"&&_e.test(ie)?fe:null}}catch{return s}}function $(fe,_e,ie){return!fe||typeof _e!="string"?!1:G(fe)(_e,void 0,ie)}e.match=$;function G(fe,_e={}){if(!fe)return l;if(typeof fe=="string"||Y(fe)){const ie=o(fe,_e);if(ie===s)return l;const le=function(ce,ke){return!!ie(ce,ke)};return ie.allBasenames&&(le.allBasenames=ie.allBasenames),ie.allPaths&&(le.allPaths=ie.allPaths),le}return B(fe,_e)}e.parse=G;function Y(fe){const _e=fe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}e.isRelativePattern=Y;function K(fe){return fe.allBasenames||[]}e.getBasenameTerms=K;function N(fe){return fe.allPaths||[]}e.getPathTerms=N;function B(fe,_e){const ie=z(Object.getOwnPropertyNames(fe).map(ae=>U(ae,fe[ae],_e)).filter(ae=>ae!==s)),le=ie.length;if(!le)return s;if(!ie.some(ae=>!!ae.requiresSiblings)){if(le===1)return ie[0];const ae=function(X,pe){let Ce;for(let we=0,ve=ie.length;we<ve;we++){const Ie=ie[we](X,pe);if(typeof Ie=="string")return Ie;(0,T.isThenable)(Ie)&&(Ce||(Ce=[]),Ce.push(Ie))}return Ce?(async()=>{for(const we of Ce){const ve=await we;if(typeof ve=="string")return ve}return null})():null},H=ie.find(X=>!!X.allBasenames);H&&(ae.allBasenames=H.allBasenames);const O=ie.reduce((X,pe)=>pe.allPaths?X.concat(pe.allPaths):X,[]);return O.length&&(ae.allPaths=O),ae}const ce=function(ae,H,O){let X,pe;for(let Ce=0,we=ie.length;Ce<we;Ce++){const ve=ie[Ce];ve.requiresSiblings&&O&&(H||(H=(0,A.basename)(ae)),X||(X=H.substr(0,H.length-(0,A.extname)(ae).length)));const Ie=ve(ae,H,X,O);if(typeof Ie=="string")return Ie;(0,T.isThenable)(Ie)&&(pe||(pe=[]),pe.push(Ie))}return pe?(async()=>{for(const Ce of pe){const we=await Ce;if(typeof we=="string")return we}return null})():null},ke=ie.find(ae=>!!ae.allBasenames);ke&&(ce.allBasenames=ke.allBasenames);const de=ie.reduce((ae,H)=>H.allPaths?ae.concat(H.allPaths):ae,[]);return de.length&&(ce.allPaths=de),ce}function U(fe,_e,ie){if(_e===!1)return s;const le=o(fe,ie);if(le===s)return s;if(typeof _e=="boolean")return le;if(_e){const ce=_e.when;if(typeof ce=="string"){const ke=(de,ae,H,O)=>{if(!O||!le(de,ae))return null;const X=ce.replace("$(basename)",()=>H),pe=O(X);return(0,T.isThenable)(pe)?pe.then(Ce=>Ce?fe:null):pe?fe:null};return ke.requiresSiblings=!0,ke}}return le}function z(fe,_e){const ie=fe.filter(ae=>!!ae.basenames);if(ie.length<2)return fe;const le=ie.reduce((ae,H)=>{const O=H.basenames;return O?ae.concat(O):ae},[]);let ce;if(_e){ce=[];for(let ae=0,H=le.length;ae<H;ae++)ce.push(_e)}else ce=ie.reduce((ae,H)=>{const O=H.patterns;return O?ae.concat(O):ae},[]);const ke=function(ae,H){if(typeof ae!="string")return null;if(!H){let X;for(X=ae.length;X>0;X--){const pe=ae.charCodeAt(X-1);if(pe===47||pe===92)break}H=ae.substr(X)}const O=le.indexOf(H);return O!==-1?ce[O]:null};ke.basenames=le,ke.patterns=ce,ke.allBasenames=le;const de=fe.filter(ae=>!ae.basenames);return de.push(ke),de}function j(fe,_e){return(0,n.equals)(fe,_e,(ie,le)=>typeof ie=="string"&&typeof le=="string"?ie===le:typeof ie!="string"&&typeof le!="string"?ie.base===le.base&&ie.pattern===le.pattern:!1)}e.patternsEquals=j}),define(Pe[87],Ae([1,0,9,129,22,13,2]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(a="",d=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(a,d=0){return this.value+=h(this.supportThemeIcons?(0,T.escapeIcons)(a):a).replace(/([ \t]+)/g,(_,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,d){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(a,d,_){return this.value+="[",this.value+=this._escape(d,"]"),this.value+="](",this.value+=this._escape(String(a),")"),_&&(this.value+=` "${this._escape(this._escape(_,'"'),")")}"`),this.value+=")",this}_escape(a,d){const _=new RegExp((0,M.escapeRegExpCharacters)(d),"g");return a.replace(_,(k,p)=>a.charAt(p-1)!=="\\"?`\\${k}`:k)}}e.MarkdownString=D;function m(t){return R(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function S(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,C.isEqual)(A.URI.from(t.baseUri),A.URI.from(a.baseUri)))}e.markdownStringEqual=S;function h(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function w(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function u(t){const a=[],d=t.split("|").map(k=>k.trim());t=d[0];const _=d[1];if(_){const k=/height=(\d+)/.exec(_),p=/width=(\d+)/.exec(_),i=k?k[1]:"",l=p?p[1]:"",s=isFinite(parseInt(l)),o=isFinite(parseInt(i));s&&a.push(`width="${l}"`),o&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=u}),define(Pe[88],Ae([1,0,16,41,19,20,22,13]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(s,o){const{os:f,tildify:E,relative:r}=o;if(r){const y=m(s,r,f);if(typeof y=="string")return y}let c=s.fsPath;if(f===1&&!M.isWindows?c=c.replace(/\//g,"\\"):f!==1&&M.isWindows&&(c=c.replace(/\\/g,"/")),f!==1&&E?.userHome){const y=E.userHome.fsPath;let b;s.scheme!==E.userHome.scheme&&s.path.startsWith(C.posix.sep)?b=E.userHome.with({path:s.path}).fsPath:b=s.fsPath,c=h(b,y,f)}return(f===1?C.win32:C.posix).normalize(R(c,f===1))}e.getPathLabel=D;function m(s,o,f){const E=f===1?C.win32:C.posix,r=f===3?A.extUri:A.extUriIgnorePathCase,c=o.getWorkspace(),v=(0,n.firstOrDefault)(c.folders);if(!v)return;s.scheme!==v.uri.scheme&&s.path.startsWith(C.posix.sep)&&(s=v.uri.with({path:s.path}));const y=o.getWorkspaceFolder(s);if(!y)return;let b;if(r.isEqual(y.uri,s)?b="":b=r.relativePath(y.uri,s)??"",b&&(b=E.normalize(b)),c.folders.length>1&&!o.noPrefix){const $=y.name?y.name:r.basenameOrAuthority(y.uri);b=b?`${$} \u2022 ${b}`:$}return b}function R(s,o=M.isWindows){return(0,T.hasDriveLetter)(s,o)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=R;let S=Object.create(null);function h(s,o,f=M.OS){if(f===1||!s||!o)return s;let E=S.original===o?S.normalized:void 0;E||(E=o,M.isWindows&&(E=(0,T.toSlashes)(E)),E=`${(0,P.rtrim)(E,C.posix.sep)}${C.posix.sep}`,S={original:o,normalized:E});let r=s;return M.isWindows&&(r=(0,T.toSlashes)(r)),(f===3?r.startsWith(E):(0,P.startsWithIgnoreCase)(r,E))?`~/${r.substr(E.length)}`:s}e.tildify=h;function w(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=w;const g="\u2026",u="\\\\",t="~";function a(s,o=C.sep){const f=new Array(s.length);let E=!1;for(let r=0;r<s.length;r++){const c=s[r];if(c===""){f[r]=`.${o}`;continue}if(!c){f[r]=c;continue}E=!0;let v="",y=c;y.indexOf(u)===0?(v=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(o)===0?(v=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length)):y.indexOf(t)===0&&(v=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const b=y.split(o);for(let $=1;E&&$<=b.length;$++)for(let G=b.length-$;E&&G>=0;G--){E=!1;let Y=b.slice(G,G+$).join(o);for(let K=0;!E&&K<s.length;K++)if(K!==r&&s[K]&&s[K].indexOf(Y)>-1){const N=G+$===b.length,B=G>0&&s[K].indexOf(o)>-1?o+Y:Y,U=s[K].endsWith(B);E=!N||U}if(!E){let K="";(b[0].endsWith(":")||v!=="")&&(G===1&&(G=0,$++,Y=b[0]+o+Y),G>0&&(K=b[0]+o),K=v+K),G>0&&(K=K+g+o),K=K+Y,G+$<b.length&&(K=K+o+g),f[r]=K}}E&&(f[r]=c)}return f}e.shorten=a;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function _(s,o=Object.create(null)){const f=[];let E=!1,r="";for(const c of s)if(c==="$"||E&&c==="{")r&&f.push({value:r,type:d.TEXT}),r="",E=!0;else if(c==="}"&&E){const v=o[r];if(typeof v=="string")v.length&&f.push({value:v,type:d.VARIABLE});else if(v){const y=f[f.length-1];(!y||y.type!==d.SEPARATOR)&&f.push({value:v.label,type:d.SEPARATOR})}r="",E=!1}else r+=c;return r&&!E&&f.push({value:r,type:d.TEXT}),f.filter((c,v)=>{if(c.type===d.SEPARATOR){const y=f[v-1],b=f[v+1];return[y,b].every($=>$&&($.type===d.VARIABLE||$.type===d.TEXT)&&$.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=_;function k(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function p(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,f=>f==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(s){const o=s.indexOf("/")!==-1?C.posix:C.win32,f=o.basename(s),E=o.dirname(s);return f.length?{name:f,parentPath:E}:{name:E,parentPath:""}}e.splitName=l}),define(Pe[130],Ae([1,0,25,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(S){return S.toJSON()}class M{constructor(h){this._uriTransformer=h}transformIncoming(h){const w=this._uriTransformer.transformIncoming(h);return w===h?h:C(T.URI.from(w))}transformOutgoing(h){const w=this._uriTransformer.transformOutgoing(h);return w===h?h:C(T.URI.from(w))}transformOutgoingURI(h){const w=this._uriTransformer.transformOutgoing(h);return w===h?h:T.URI.from(w)}transformOutgoingScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,h,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return h.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const u=A(S[g],h,w+1);u!==null&&(S[g]=u)}}return null}function P(S,h){const w=A(S,h,0);return w===null?S:w}e.transformOutgoingURIs=P;function D(S,h,w,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?T.URI.revive(h.transformIncoming(S)):h.transformIncoming(S);if(S instanceof n.VSBuffer)return null;for(const u in S)if(Object.hasOwnProperty.call(S,u)){const t=D(S[u],h,w,g+1);t!==null&&(S[u]=t)}}return null}function m(S,h){const w=D(S,h,!1,0);return w===null?S:w}e.transformIncomingURIs=m;function R(S,h){const w=D(S,h,!0,0);return w===null?S:w}e.transformAndReviveIncomingURIs=R}),define(Pe[131],Ae([1,0,36,19]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(M,A,P,D,m,R){if(Array.isArray(M)){let S=0;for(const h of M){const w=C(h,A,P,D,m,R);if(w===10)return w;w>S&&(S=w)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===P?10:0:0;if(M){const{language:S,pattern:h,scheme:w,hasAccessToAllModels:g,notebookType:u}=M;if(!D&&!g)return 0;u&&m&&(A=m);let t=0;if(w)if(w===A.scheme)t=10;else if(w==="*")t=5;else return 0;if(S)if(S===P)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(u)if(u===R)t=10;else if(u==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(h){let a;if(typeof h=="string"?a=h:a={...h,base:(0,T.normalize)(h.base)},a===A.fsPath||(0,n.match)(a,A.fsPath))t=10;else return 0}return t}else return 0}}e.score=C}),define(Pe[89],Ae([1,0,25,20]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function M(S){for(let h=0,w=S.length;h<w;h+=4){const g=S[h+0],u=S[h+1],t=S[h+2],a=S[h+3];S[h+0]=a,S[h+1]=t,S[h+2]=u,S[h+3]=g}}function A(S){const h=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.isLittleEndian()||M(h),n.VSBuffer.wrap(h)}function P(S){const h=S.buffer;if(T.isLittleEndian()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const w=new Uint8Array(h.byteLength);return w.set(h),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function D(S){const h=new Uint32Array(m(S));let w=0;if(h[w++]=S.id,S.type==="full")h[w++]=1,h[w++]=S.data.length,h.set(S.data,w),w+=S.data.length;else{h[w++]=2,h[w++]=S.deltas.length;for(const g of S.deltas)h[w++]=g.start,h[w++]=g.deleteCount,g.data?(h[w++]=g.data.length,h.set(g.data,w),w+=g.data.length):h[w++]=0}return A(h)}e.encodeSemanticTokensDto=D;function m(S){let h=0;if(h+=1+1,S.type==="full")h+=1+S.data.length;else{h+=1,h+=(1+1+1)*S.deltas.length;for(const w of S.deltas)w.data&&(h+=w.data.length)}return h}function R(S){const h=P(S);let w=0;const g=h[w++];if(h[w++]===1){const d=h[w++],_=h.subarray(w,w+d);return w+=d,{id:g,type:"full",data:_}}const t=h[w++],a=[];for(let d=0;d<t;d++){const _=h[w++],k=h[w++],p=h[w++];let i;p>0&&(i=h.subarray(w,w+p),w+=p),a[d]={start:_,deleteCount:k,data:i}}return{id:g,type:"delta",deltas:a}}e.decodeSemanticTokensDto=R}),define(Pe[132],Ae([11,12]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Pe[133],Ae([1,0,132,20,134,16,23,119]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=m;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(J,Ee,$e,Be){this.id=J,this.name=Ee,this.defaultValue=$e,this.schema=Be}applyUpdate(J,Ee){return w(J,Ee)}compute(J,Ee,$e){return $e}}class h{constructor(J,Ee){this.newValue=J,this.didChange=Ee}}e.ApplyUpdateResult=h;function w(Q,J){if(typeof Q!="object"||typeof J!="object"||!Q||!J)return new h(J,Q!==J);if(Array.isArray(Q)||Array.isArray(J)){const $e=Array.isArray(Q)&&Array.isArray(J)&&M.equals(Q,J);return new h(J,!$e)}let Ee=!1;for(const $e in J)if(J.hasOwnProperty($e)){const Be=w(Q[$e],J[$e]);Be.didChange&&(Q[$e]=Be.newValue,Ee=!0)}return new h(Q,Ee)}class g{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Ee){return w(J,Ee)}validate(J){return this.defaultValue}}class u{constructor(J,Ee,$e,Be){this.id=J,this.name=Ee,this.defaultValue=$e,this.schema=Be}applyUpdate(J,Ee){return w(J,Ee)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Ee,$e){return $e}}function t(Q,J){return typeof Q>"u"?J:Q==="false"?!1:Boolean(Q)}e.boolean=t;class a extends u{constructor(J,Ee,$e,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=$e),super(J,Ee,$e,Be)}validate(J){return t(J,this.defaultValue)}}function d(Q,J,Ee,$e){if(typeof Q>"u")return J;let Be=parseInt(Q,10);return isNaN(Be)?J:(Be=Math.max(Ee,Be),Be=Math.min($e,Be),Be|0)}e.clampedInt=d;class _ extends u{static clampedInt(J,Ee,$e,Be){return d(J,Ee,$e,Be)}constructor(J,Ee,$e,Be,Xe,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=$e,Qe.minimum=Be,Qe.maximum=Xe),super(J,Ee,$e,Qe),this.minimum=Be,this.maximum=Xe}validate(J){return _.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class k extends u{static clamp(J,Ee,$e){return J<Ee?Ee:J>$e?$e:J}static float(J,Ee){if(typeof J=="number")return J;if(typeof J>"u")return Ee;const $e=parseFloat(J);return isNaN($e)?Ee:$e}constructor(J,Ee,$e,Be,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=$e),super(J,Ee,$e,Xe),this.validationFn=Be}validate(J){return this.validationFn(k.float(J,this.defaultValue))}}class p extends u{static string(J,Ee){return typeof J!="string"?Ee:J}constructor(J,Ee,$e,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=$e),super(J,Ee,$e,Be)}validate(J){return p.string(J,this.defaultValue)}}function i(Q,J,Ee){return typeof Q!="string"||Ee.indexOf(Q)===-1?J:Q}e.stringSet=i;class l extends u{constructor(J,Ee,$e,Be,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Be,Xe.default=$e),super(J,Ee,$e,Xe),this._allowedValues=Be}validate(J){return i(J,this.defaultValue,this._allowedValues)}}class s extends S{constructor(J,Ee,$e,Be,Xe,Qe,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.enum=Xe,Ke.default=Be),super(J,Ee,$e,Ke),this._allowedValues=Xe,this._convert=Qe}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function o(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,Ee,$e){return $e===0?J.accessibilitySupport:$e}}class E extends S{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:n.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(Q){switch(Q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function b(Q){switch(Q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class $ extends g{constructor(){super(136)}compute(J,Ee,$e){const Be=["monaco-editor"];return Ee.get(37)&&Be.push(Ee.get(37)),J.extraEditorClassName&&Be.push(J.extraEditorClassName),Ee.get(71)==="default"?Be.push("mouse-default"):Ee.get(71)==="copy"&&Be.push("mouse-copy"),Ee.get(106)&&Be.push("showUnused"),Ee.get(134)&&Be.push("showDeprecated"),Be.join(" ")}}class G extends a{constructor(){super(35,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(J,Ee,$e){return $e&&J.emptySelectionClipboard}}class Y extends S{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:n.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:n.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":i(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":i(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class K extends S{constructor(){super(49,"fontLigatures",K.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?K.OFF:J==="true"?K.ON:J:Boolean(J)?K.ON:K.OFF}}K.OFF='"liga" off, "calt" off',K.ON='"liga" on, "calt" on',e.EditorFontLigatures=K;class N extends S{constructor(){super(52,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?N.OFF:J==="true"?N.TRANSLATE:J:Boolean(J)?N.TRANSLATE:N.OFF}compute(J,Ee,$e){return J.fontInfo.fontVariationSettings}}N.OFF="normal",N.TRANSLATE="translate",e.EditorFontVariations=N;class B extends g{constructor(){super(48)}compute(J,Ee,$e){return J.fontInfo}}class U extends u{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(J){const Ee=k.float(J,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:k.clamp(Ee,6,100)}compute(J,Ee,$e){return J.fontInfo.fontSize}}class z extends S{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(_.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class j extends S{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:n.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{multiple:i(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??i(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??i(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??i(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??i(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??i(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends S{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:J.above,description:n.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:_.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),above:t(Ee.above,this.defaultValue.above)}}}var _e;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(_e=e.RenderMinimap||(e.RenderMinimap={}));class ie extends g{constructor(){super(139)}compute(J,Ee,$e){return ie.computeLayout(Ee,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const Ee=J.height/J.lineHeight,$e=Math.floor(J.paddingTop/J.lineHeight);let Be=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(Be=Math.max(Be,Ee-1));const Xe=($e+J.viewLineCount+Be)/(J.pixelRatio*J.height),Qe=Math.floor(J.viewLineCount/Xe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:Be,desiredRatio:Xe,minimapLineCount:Qe}}static _computeMinimapLayout(J,Ee){const $e=J.outerWidth,Be=J.outerHeight,Xe=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Qe=Ee.stableMinimapLayoutInput,Ke=Qe&&J.outerHeight===Qe.outerHeight&&J.lineHeight===Qe.lineHeight&&J.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&J.pixelRatio===Qe.pixelRatio&&J.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&J.paddingTop===Qe.paddingTop&&J.paddingBottom===Qe.paddingBottom&&J.minimap.enabled===Qe.minimap.enabled&&J.minimap.side===Qe.minimap.side&&J.minimap.size===Qe.minimap.size&&J.minimap.showSlider===Qe.minimap.showSlider&&J.minimap.renderCharacters===Qe.minimap.renderCharacters&&J.minimap.maxColumn===Qe.minimap.maxColumn&&J.minimap.scale===Qe.minimap.scale&&J.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&J.isViewportWrapping===Qe.isViewportWrapping,at=J.lineHeight,St=J.typicalHalfwidthCharacterWidth,Dt=J.scrollBeyondLastLine,_t=J.minimap.renderCharacters;let vt=Xe>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ft=J.minimap.maxColumn,At=J.minimap.size,Qt=J.minimap.side,Kt=J.verticalScrollbarWidth,dt=J.viewLineCount,ft=J.remainingWidth,Rt=J.isViewportWrapping,Mt=_t?2:3;let Ct=Math.floor(Xe*Be);const mt=Ct/Xe;let bt=!1,xt=!1,It=Mt*vt,qe=vt/Xe,Ht=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:Oe,extraLinesBeforeFirstLine:xe,extraLinesBeyondLastLine:Ze,desiredRatio:We,minimapLineCount:et}=ie.computeContainedMinimapLineCount({viewLineCount:dt,scrollBeyondLastLine:Dt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:Be,lineHeight:at,pixelRatio:Xe});if(dt/et>1)bt=!0,xt=!0,vt=1,It=1,qe=vt/Xe;else{let lt=!1,yt=vt+1;if(At==="fit"){const gt=Math.ceil((xe+dt+Ze)*It);Rt&&Ke&&ft<=Ee.stableFitRemainingWidth?(lt=!0,yt=Ee.stableFitMaxMinimapScale):lt=gt>Ct}if(At==="fill"||lt){bt=!0;const gt=vt;It=Math.min(at*Xe,Math.max(1,Math.floor(1/We))),Rt&&Ke&&ft<=Ee.stableFitRemainingWidth&&(yt=Ee.stableFitMaxMinimapScale),vt=Math.min(yt,Math.max(1,Math.floor(It/Mt))),vt>gt&&(Ht=Math.min(2,vt/gt)),qe=vt/Xe/Ht,Ct=Math.ceil(Math.max(Oe,xe+dt+Ze)*It),Rt?(Ee.stableMinimapLayoutInput=J,Ee.stableFitRemainingWidth=ft,Ee.stableFitMaxMinimapScale=vt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Gt=Math.floor(Ft*qe),Nt=Math.min(Gt,Math.max(0,Math.floor((ft-Kt-2)*qe/(St+qe)))+e.MINIMAP_GUTTER_WIDTH);let De=Math.floor(Xe*Nt);const Re=De/Xe;De=Math.floor(De*Ht);const me=_t?1:2,q=Qt==="left"?0:$e-Nt-Kt;return{renderMinimap:me,minimapLeft:q,minimapWidth:Nt,minimapHeightIsEditorHeight:bt,minimapIsSampling:xt,minimapScale:vt,minimapLineHeight:It,minimapCanvasInnerWidth:De,minimapCanvasInnerHeight:Ct,minimapCanvasOuterWidth:Re,minimapCanvasOuterHeight:mt}}static computeLayout(J,Ee){const $e=Ee.outerWidth|0,Be=Ee.outerHeight|0,Xe=Ee.lineHeight|0,Qe=Ee.lineNumbersDigitCount|0,Ke=Ee.typicalHalfwidthCharacterWidth,at=Ee.maxDigitWidth,St=Ee.pixelRatio,Dt=Ee.viewLineCount,_t=J.get(131),vt=_t==="inherit"?J.get(130):_t,Ft=vt==="inherit"?J.get(126):vt,At=J.get(129),Qt=Ee.isDominatedByLongLines,Kt=J.get(55),dt=J.get(65).renderType!==0,ft=J.get(66),Rt=J.get(100),Mt=J.get(81),Ct=J.get(70),mt=J.get(98),bt=mt.verticalScrollbarSize,xt=mt.verticalHasArrows,It=mt.arrowSize,qe=mt.horizontalScrollbarSize,Ht=J.get(41),Gt=J.get(105)!=="never";let Nt=J.get(63);Ht&&Gt&&(Nt+=16);let De=0;if(dt){const Ut=Math.max(Qe,ft);De=Math.round(Ut*at)}let Re=0;Kt&&(Re=Xe);let me=0,q=me+Re,Oe=q+De,xe=Oe+Nt;const Ze=$e-Re-De-Nt;let We=!1,et=!1,ut=-1;vt==="inherit"&&Qt?(We=!0,et=!0):Ft==="on"||Ft==="bounded"?et=!0:Ft==="wordWrapColumn"&&(ut=At);const lt=ie._computeMinimapLayout({outerWidth:$e,outerHeight:Be,lineHeight:Xe,typicalHalfwidthCharacterWidth:Ke,pixelRatio:St,scrollBeyondLastLine:Rt,paddingTop:Mt.top,paddingBottom:Mt.bottom,minimap:Ct,verticalScrollbarWidth:bt,viewLineCount:Dt,remainingWidth:Ze,isViewportWrapping:et},Ee.memory||new R);lt.renderMinimap!==0&&lt.minimapLeft===0&&(me+=lt.minimapWidth,q+=lt.minimapWidth,Oe+=lt.minimapWidth,xe+=lt.minimapWidth);const yt=Ze-lt.minimapWidth,gt=Math.max(1,Math.floor((yt-bt-2)/Ke)),Ot=xt?It:0;return et&&(ut=Math.max(1,gt),Ft==="bounded"&&(ut=Math.min(ut,At))),{width:$e,height:Be,glyphMarginLeft:me,glyphMarginWidth:Re,lineNumbersLeft:q,lineNumbersWidth:De,decorationsLeft:Oe,decorationsWidth:Nt,contentLeft:xe,contentWidth:yt,minimap:lt,viewportColumn:gt,isWordWrapMinified:We,isViewportWrapping:et,wrappingColumn:ut,verticalScrollbarWidth:bt,horizontalScrollbarHeight:qe,overviewRuler:{top:Ot,width:bt,height:Be-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=ie;class le extends S{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(J){return i(J,"simple",["simple","advanced"])}compute(J,Ee,$e){return Ee.get(2)===2?"advanced":$e}}class ce extends S{constructor(){const J={enabled:!0};super(62,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:n.localize(49,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}class ke extends S{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:n.localize(52,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:_.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class de extends S{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:n.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(54,null),n.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:n.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:n.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:n.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:i(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:_.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class ae extends S{constructor(){super(63,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):_.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Ee,$e){return $e<0?_.clampedInt(-$e*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class H extends k{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>k.clamp(J,0,150),{markdownDescription:n.localize(61,null)})}compute(J,Ee,$e){return J.fontInfo.lineHeight}}class O extends S{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:n.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:n.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)],default:J.size,description:n.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:n.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:n.localize(69,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:n.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:n.localize(72,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:i(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ee.side,this.defaultValue.side,["right","left"]),showSlider:i(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(Ee.scale,1,1,3),maxColumn:_.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function X(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends S{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{top:_.clampedInt(Ee.top,0,0,1e3),bottom:_.clampedInt(Ee.bottom,0,0,1e3)}}}class Ce extends S{constructor(){const J={enabled:!0,cycle:!0};super(82,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:n.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:n.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class we extends g{constructor(){super(137)}compute(J,Ee,$e){return J.pixelRatio}}class ve extends S{constructor(){const J={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(77,null),n.localize(78,null),n.localize(79,null)]}];super(85,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:J.strings,description:n.localize(80,null)},comments:{anyOf:Ee,default:J.comments,description:n.localize(81,null)},other:{anyOf:Ee,default:J.other,description:n.localize(82,null)}},default:J,markdownDescription:n.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const St=J?"on":"off";return{comments:St,strings:St,other:St}}if(!J||typeof J!="object")return this.defaultValue;const{other:Ee,comments:$e,strings:Be}=J,Xe=["on","inline","off"];let Qe,Ke,at;return typeof Ee=="boolean"?Qe=Ee?"on":"off":Qe=i(Ee,this.defaultValue.other,Xe),typeof $e=="boolean"?Ke=$e?"on":"off":Ke=i($e,this.defaultValue.comments,Xe),typeof Be=="boolean"?at=Be?"on":"off":at=i(Be,this.defaultValue.strings,Xe),{other:Qe,comments:Ke,strings:at}}}var Ie;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends S{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(84,null),n.localize(85,null),n.localize(86,null),n.localize(87,null)],default:"on",description:n.localize(88,null)})}validate(J){let Ee=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Ee=4,$e=J):J==="interval"?Ee=3:J==="relative"?Ee=2:J==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:$e}}}function oe(Q){const J=Q.get(93);return J==="editable"?Q.get(87):J!=="on"}e.filterValidationDecorations=oe;class Z extends S{constructor(){const J=[],Ee={type:"number",description:n.localize(89,null)};super(97,"rulers",J,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:n.localize(90,null),format:"color-hex"}}}]},default:J,description:n.localize(91,null)})}validate(J){if(Array.isArray(J)){const Ee=[];for(const $e of J)if(typeof $e=="number")Ee.push({column:_.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Be=$e;Ee.push({column:_.clampedInt(Be.column,0,0,1e4),color:Be.color})}return Ee.sort(($e,Be)=>$e.column-Be.column),Ee}return this.defaultValue}}function I(Q,J){if(typeof Q!="string")return J;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends S{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(92,null),n.localize(93,null),n.localize(94,null)],default:"auto",description:n.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(96,null),n.localize(97,null),n.localize(98,null)],default:"auto",description:n.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:n.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:n.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J,$e=_.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=_.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(Ee.vertical,this.defaultValue.vertical),horizontal:I(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:_.clampedInt(Ee.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:_.clampedInt(Ee.verticalSliderSize,Be,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends S{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:n.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:n.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:n.localize(109,null)}})}applyUpdate(J,Ee){let $e=!1;Ee.allowedCharacters&&J&&(A.equals(J.allowedCharacters,Ee.allowedCharacters)||(J={...J,allowedCharacters:Ee.allowedCharacters},$e=!0)),Ee.allowedLocales&&J&&(A.equals(J.allowedLocales,Ee.allowedLocales)||(J={...J,allowedLocales:Ee.allowedLocales},$e=!0));const Be=super.applyUpdate(J,Ee);return $e?new h(Be.newValue,!0):Be}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{nonBasicASCII:Te(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Te(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Te(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,Ee){if(typeof J!="object"||!J)return Ee;const $e={};for(const[Be,Xe]of Object.entries(J))Xe===!0&&($e[Be]=!0);return $e}}class V extends S{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!0};super(60,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:n.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(111,null),n.localize(112,null)],description:n.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:n.localize(114,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:i(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions)}}}class te extends S{constructor(){const J={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:n.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:n.localize(116,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ge extends S{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(117,null),n.localize(118,null),n.localize(119,null)],default:J.bracketPairs,description:n.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(121,null),n.localize(122,null),n.localize(123,null)],default:J.bracketPairsHorizontal,description:n.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:n.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:n.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(127,null),n.localize(128,null),n.localize(129,null)],default:J.highlightActiveIndentation,description:n.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{bracketPairs:Te(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Te(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Te(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Te(Q,J,Ee){const $e=Ee.indexOf(Q);return $e===-1?J:Ee[$e]}class ue extends S{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(131,null),n.localize(132,null)],default:J.insertMode,description:n.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:n.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:n.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:n.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(137,null),n.localize(138,null),n.localize(139,null),n.localize(140,null)],default:J.selectionMode,markdownDescription:n.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:n.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:n.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:n.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:n.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:n.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(178,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertMode:i(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:i(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class ye extends S{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(179,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var be;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));class ze extends S{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(180,null),n.localize(181,null),n.localize(182,null),n.localize(183,null)],description:n.localize(184,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,Ee,$e){return Ee.get(2)===2?0:$e}}class Ue extends g{constructor(){super(140)}compute(J,Ee,$e){const Be=Ee.get(139);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class tt extends S{constructor(){const J={enabled:!0};super(34,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:n.localize(185,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}const Ge="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?nt:Ge,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var rt;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=7]="autoClosingDelete",Q[Q.autoClosingOvertype=8]="autoClosingOvertype",Q[Q.autoClosingQuotes=9]="autoClosingQuotes",Q[Q.autoIndent=10]="autoIndent",Q[Q.automaticLayout=11]="automaticLayout",Q[Q.autoSurround=12]="autoSurround",Q[Q.bracketPairColorization=13]="bracketPairColorization",Q[Q.guides=14]="guides",Q[Q.codeLens=15]="codeLens",Q[Q.codeLensFontFamily=16]="codeLensFontFamily",Q[Q.codeLensFontSize=17]="codeLensFontSize",Q[Q.colorDecorators=18]="colorDecorators",Q[Q.colorDecoratorsLimit=19]="colorDecoratorsLimit",Q[Q.columnSelection=20]="columnSelection",Q[Q.comments=21]="comments",Q[Q.contextmenu=22]="contextmenu",Q[Q.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=24]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=26]="cursorStyle",Q[Q.cursorSurroundingLines=27]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=29]="cursorWidth",Q[Q.disableLayerHinting=30]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Q[Q.domReadOnly=32]="domReadOnly",Q[Q.dragAndDrop=33]="dragAndDrop",Q[Q.dropIntoEditor=34]="dropIntoEditor",Q[Q.emptySelectionClipboard=35]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=37]="extraEditorClassName",Q[Q.fastScrollSensitivity=38]="fastScrollSensitivity",Q[Q.find=39]="find",Q[Q.fixedOverflowWidgets=40]="fixedOverflowWidgets",Q[Q.folding=41]="folding",Q[Q.foldingStrategy=42]="foldingStrategy",Q[Q.foldingHighlight=43]="foldingHighlight",Q[Q.foldingImportsByDefault=44]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=45]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=47]="fontFamily",Q[Q.fontInfo=48]="fontInfo",Q[Q.fontLigatures=49]="fontLigatures",Q[Q.fontSize=50]="fontSize",Q[Q.fontWeight=51]="fontWeight",Q[Q.fontVariations=52]="fontVariations",Q[Q.formatOnPaste=53]="formatOnPaste",Q[Q.formatOnType=54]="formatOnType",Q[Q.glyphMargin=55]="glyphMargin",Q[Q.gotoLocation=56]="gotoLocation",Q[Q.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Q[Q.hover=58]="hover",Q[Q.inDiffEditor=59]="inDiffEditor",Q[Q.inlineSuggest=60]="inlineSuggest",Q[Q.letterSpacing=61]="letterSpacing",Q[Q.lightbulb=62]="lightbulb",Q[Q.lineDecorationsWidth=63]="lineDecorationsWidth",Q[Q.lineHeight=64]="lineHeight",Q[Q.lineNumbers=65]="lineNumbers",Q[Q.lineNumbersMinChars=66]="lineNumbersMinChars",Q[Q.linkedEditing=67]="linkedEditing",Q[Q.links=68]="links",Q[Q.matchBrackets=69]="matchBrackets",Q[Q.minimap=70]="minimap",Q[Q.mouseStyle=71]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=73]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=75]="multiCursorModifier",Q[Q.multiCursorPaste=76]="multiCursorPaste",Q[Q.multiCursorLimit=77]="multiCursorLimit",Q[Q.occurrencesHighlight=78]="occurrencesHighlight",Q[Q.overviewRulerBorder=79]="overviewRulerBorder",Q[Q.overviewRulerLanes=80]="overviewRulerLanes",Q[Q.padding=81]="padding",Q[Q.parameterHints=82]="parameterHints",Q[Q.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=85]="quickSuggestions",Q[Q.quickSuggestionsDelay=86]="quickSuggestionsDelay",Q[Q.readOnly=87]="readOnly",Q[Q.renameOnType=88]="renameOnType",Q[Q.renderControlCharacters=89]="renderControlCharacters",Q[Q.renderFinalNewline=90]="renderFinalNewline",Q[Q.renderLineHighlight=91]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=93]="renderValidationDecorations",Q[Q.renderWhitespace=94]="renderWhitespace",Q[Q.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",Q[Q.roundedSelection=96]="roundedSelection",Q[Q.rulers=97]="rulers",Q[Q.scrollbar=98]="scrollbar",Q[Q.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=100]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=101]="scrollPredominantAxis",Q[Q.selectionClipboard=102]="selectionClipboard",Q[Q.selectionHighlight=103]="selectionHighlight",Q[Q.selectOnLineNumbers=104]="selectOnLineNumbers",Q[Q.showFoldingControls=105]="showFoldingControls",Q[Q.showUnused=106]="showUnused",Q[Q.snippetSuggestions=107]="snippetSuggestions",Q[Q.smartSelect=108]="smartSelect",Q[Q.smoothScrolling=109]="smoothScrolling",Q[Q.stickyScroll=110]="stickyScroll",Q[Q.stickyTabStops=111]="stickyTabStops",Q[Q.stopRenderingLineAfter=112]="stopRenderingLineAfter",Q[Q.suggest=113]="suggest",Q[Q.suggestFontSize=114]="suggestFontSize",Q[Q.suggestLineHeight=115]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",Q[Q.suggestSelection=117]="suggestSelection",Q[Q.tabCompletion=118]="tabCompletion",Q[Q.tabIndex=119]="tabIndex",Q[Q.unicodeHighlighting=120]="unicodeHighlighting",Q[Q.unusualLineTerminators=121]="unusualLineTerminators",Q[Q.useShadowDOM=122]="useShadowDOM",Q[Q.useTabStops=123]="useTabStops",Q[Q.wordBreak=124]="wordBreak",Q[Q.wordSeparators=125]="wordSeparators",Q[Q.wordWrap=126]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=129]="wordWrapColumn",Q[Q.wordWrapOverride1=130]="wordWrapOverride1",Q[Q.wordWrapOverride2=131]="wordWrapOverride2",Q[Q.wrappingIndent=132]="wrappingIndent",Q[Q.wrappingStrategy=133]="wrappingStrategy",Q[Q.showDeprecated=134]="showDeprecated",Q[Q.inlayHints=135]="inlayHints",Q[Q.editorClassName=136]="editorClassName",Q[Q.pixelRatio=137]="pixelRatio",Q[Q.tabFocusMode=138]="tabFocusMode",Q[Q.layoutInfo=139]="layoutInfo",Q[Q.wrappingInfo=140]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(186,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(187,null),""],markdownDescription:n.localize(188,null)})),accessibilitySupport:Me(new f),accessibilityPageSize:Me(new _(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(189,null),tags:["accessibility"]})),ariaLabel:Me(new p(4,"ariaLabel",n.localize(190,null))),screenReaderAnnounceInlineSuggestion:Me(new a(6,"screenReaderAnnounceInlineSuggestion",!1,{description:n.localize(191,null),tags:["accessibility"]})),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(192,null),n.localize(193,null),""],description:n.localize(194,null)})),autoClosingDelete:Me(new l(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(195,null),""],description:n.localize(196,null)})),autoClosingOvertype:Me(new l(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(197,null),""],description:n.localize(198,null)})),autoClosingQuotes:Me(new l(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(199,null),n.localize(200,null),""],description:n.localize(201,null)})),autoIndent:Me(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[n.localize(202,null),n.localize(203,null),n.localize(204,null),n.localize(205,null),n.localize(206,null)],description:n.localize(207,null)})),automaticLayout:Me(new a(11,"automaticLayout",!1)),autoSurround:Me(new l(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(208,null),n.localize(209,null),n.localize(210,null),""],description:n.localize(211,null)})),bracketPairColorization:Me(new te),bracketPairGuides:Me(new ge),stickyTabStops:Me(new a(111,"stickyTabStops",!1,{description:n.localize(212,null)})),codeLens:Me(new a(15,"codeLens",!0,{description:n.localize(213,null)})),codeLensFontFamily:Me(new p(16,"codeLensFontFamily","",{description:n.localize(214,null)})),codeLensFontSize:Me(new _(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(215,null)})),colorDecorators:Me(new a(18,"colorDecorators",!0,{description:n.localize(216,null)})),colorDecoratorsLimit:Me(new _(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(217,null)})),columnSelection:Me(new a(20,"columnSelection",!1,{description:n.localize(218,null)})),comments:Me(new E),contextmenu:Me(new a(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(23,"copyWithSyntaxHighlighting",!0,{description:n.localize(219,null)})),cursorBlinking:Me(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:n.localize(220,null)})),cursorSmoothCaretAnimation:Me(new l(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(221,null),n.localize(222,null),n.localize(223,null)],description:n.localize(224,null)})),cursorStyle:Me(new s(26,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],b,{description:n.localize(225,null)})),cursorSurroundingLines:Me(new _(27,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(226,null)})),cursorSurroundingLinesStyle:Me(new l(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(227,null),n.localize(228,null)],description:n.localize(229,null)})),cursorWidth:Me(new _(29,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(230,null)})),disableLayerHinting:Me(new a(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(31,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(32,"domReadOnly",!1)),dragAndDrop:Me(new a(33,"dragAndDrop",!0,{description:n.localize(231,null)})),emptySelectionClipboard:Me(new G),dropIntoEditor:Me(new tt),stickyScroll:Me(new ke),experimentalWhitespaceRendering:Me(new l(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(232,null),n.localize(233,null),n.localize(234,null)],description:n.localize(235,null)})),extraEditorClassName:Me(new p(37,"extraEditorClassName","")),fastScrollSensitivity:Me(new k(38,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(236,null)})),find:Me(new Y),fixedOverflowWidgets:Me(new a(40,"fixedOverflowWidgets",!1)),folding:Me(new a(41,"folding",!0,{description:n.localize(237,null)})),foldingStrategy:Me(new l(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(238,null),n.localize(239,null)],description:n.localize(240,null)})),foldingHighlight:Me(new a(43,"foldingHighlight",!0,{description:n.localize(241,null)})),foldingImportsByDefault:Me(new a(44,"foldingImportsByDefault",!1,{description:n.localize(242,null)})),foldingMaximumRegions:Me(new _(45,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(243,null)})),unfoldOnClickAfterEndOfLine:Me(new a(46,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(244,null)})),fontFamily:Me(new p(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(245,null)})),fontInfo:Me(new B),fontLigatures2:Me(new K),fontSize:Me(new U),fontWeight:Me(new z),fontVariations:Me(new N),formatOnPaste:Me(new a(53,"formatOnPaste",!1,{description:n.localize(246,null)})),formatOnType:Me(new a(54,"formatOnType",!1,{description:n.localize(247,null)})),glyphMargin:Me(new a(55,"glyphMargin",!0,{description:n.localize(248,null)})),gotoLocation:Me(new j),hideCursorInOverviewRuler:Me(new a(57,"hideCursorInOverviewRuler",!1,{description:n.localize(249,null)})),hover:Me(new fe),inDiffEditor:Me(new a(59,"inDiffEditor",!1)),letterSpacing:Me(new k(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>k.clamp(Q,-5,20),{description:n.localize(250,null)})),lightbulb:Me(new ce),lineDecorationsWidth:Me(new ae),lineHeight:Me(new H),lineNumbers:Me(new se),lineNumbersMinChars:Me(new _(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(67,"linkedEditing",!1,{description:n.localize(251,null)})),links:Me(new a(68,"links",!0,{description:n.localize(252,null)})),matchBrackets:Me(new l(69,"matchBrackets","always",["always","near","never"],{description:n.localize(253,null)})),minimap:Me(new O),mouseStyle:Me(new l(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new k(72,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(254,null)})),mouseWheelZoom:Me(new a(73,"mouseWheelZoom",!1,{markdownDescription:n.localize(255,null)})),multiCursorMergeOverlapping:Me(new a(74,"multiCursorMergeOverlapping",!0,{description:n.localize(256,null)})),multiCursorModifier:Me(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],X,{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorPaste:Me(new l(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(260,null),n.localize(261,null)],markdownDescription:n.localize(262,null)})),multiCursorLimit:Me(new _(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(263,null)})),occurrencesHighlight:Me(new a(78,"occurrencesHighlight",!0,{description:n.localize(264,null)})),overviewRulerBorder:Me(new a(79,"overviewRulerBorder",!0,{description:n.localize(265,null)})),overviewRulerLanes:Me(new _(80,"overviewRulerLanes",3,0,3)),padding:Me(new pe),parameterHints:Me(new Ce),peekWidgetDefaultFocus:Me(new l(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(266,null),n.localize(267,null)],description:n.localize(268,null)})),definitionLinkOpensInPeek:Me(new a(84,"definitionLinkOpensInPeek",!1,{description:n.localize(269,null)})),quickSuggestions:Me(new ve),quickSuggestionsDelay:Me(new _(86,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(270,null)})),readOnly:Me(new a(87,"readOnly",!1)),renameOnType:Me(new a(88,"renameOnType",!1,{description:n.localize(271,null),markdownDeprecationMessage:n.localize(272,null)})),renderControlCharacters:Me(new a(89,"renderControlCharacters",!0,{description:n.localize(273,null),restricted:!0})),renderFinalNewline:Me(new l(90,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(274,null)})),renderLineHighlight:Me(new l(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(275,null)],description:n.localize(276,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(92,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(277,null)})),renderValidationDecorations:Me(new l(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(278,null),n.localize(279,null),n.localize(280,null),""],description:n.localize(281,null)})),revealHorizontalRightPadding:Me(new _(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(96,"roundedSelection",!0,{description:n.localize(282,null)})),rulers:Me(new Z),scrollbar:Me(new F),scrollBeyondLastColumn:Me(new _(99,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(283,null)})),scrollBeyondLastLine:Me(new a(100,"scrollBeyondLastLine",!0,{description:n.localize(284,null)})),scrollPredominantAxis:Me(new a(101,"scrollPredominantAxis",!0,{description:n.localize(285,null)})),selectionClipboard:Me(new a(102,"selectionClipboard",!0,{description:n.localize(286,null),included:T.isLinux})),selectionHighlight:Me(new a(103,"selectionHighlight",!0,{description:n.localize(287,null)})),selectOnLineNumbers:Me(new a(104,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null)],description:n.localize(291,null)})),showUnused:Me(new a(106,"showUnused",!0,{description:n.localize(292,null)})),showDeprecated:Me(new a(134,"showDeprecated",!0,{description:n.localize(293,null)})),inlayHints:Me(new de),snippetSuggestions:Me(new l(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(294,null),n.localize(295,null),n.localize(296,null),n.localize(297,null)],description:n.localize(298,null)})),smartSelect:Me(new ye),smoothScrolling:Me(new a(109,"smoothScrolling",!1,{description:n.localize(299,null)})),stopRenderingLineAfter:Me(new _(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ue),inlineSuggest:Me(new V),suggestFontSize:Me(new _(114,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(300,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new _(115,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(301,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(116,"suggestOnTriggerCharacters",!0,{description:n.localize(302,null)})),suggestSelection:Me(new l(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(303,null),n.localize(304,null),n.localize(305,null)],description:n.localize(306,null)})),tabCompletion:Me(new l(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(307,null),n.localize(308,null),n.localize(309,null)],description:n.localize(310,null)})),tabIndex:Me(new _(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new W),unusualLineTerminators:Me(new l(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(311,null),n.localize(312,null),n.localize(313,null)],description:n.localize(314,null)})),useShadowDOM:Me(new a(122,"useShadowDOM",!0)),useTabStops:Me(new a(123,"useTabStops",!0,{description:n.localize(315,null)})),wordBreak:Me(new l(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(316,null),n.localize(317,null)],description:n.localize(318,null)})),wordSeparators:Me(new p(125,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:n.localize(319,null)})),wordWrap:Me(new l(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(320,null),n.localize(321,null),n.localize(322,null),n.localize(323,null)],description:n.localize(324,null)})),wordWrapBreakAfterCharacters:Me(new p(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new p(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new _(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(325,null)})),wordWrapOverride1:Me(new l(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new $),pixelRatio:Me(new we),tabFocusMode:Me(new a(138,"tabFocusMode",!1,{markdownDescription:n.localize(326,null)})),layoutInfo:Me(new ie),wrappingInfo:Me(new Ue),wrappingIndent:Me(new ze),wrappingStrategy:Me(new le)}}),define(Pe[135],Ae([11,12]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[136],Ae([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[137],Ae([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[138],Ae([11,12]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[139],Ae([11,12]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[140],Ae([11,12]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Pe[141],Ae([11,12]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Pe[142],Ae([11,12]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[143],Ae([11,12]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Pe[144],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[145],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[146],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Pe[147],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[148],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[149],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[150],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[151],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[152],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[153],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[154],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Pe[155],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Pe[156],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[157],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[158],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[159],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[160],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[161],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[162],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[163],Ae([1,0,9,137]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(C=e.TokenType||(e.TokenType={}));function M(...m){switch(m.length){case 1:return(0,T.localize)(0,null,m[0]);case 2:return(0,T.localize)(1,null,m[0],m[1]);case 3:return(0,T.localize)(2,null,m[0],m[1],m[2]);default:return}}const A=(0,T.localize)(3,null),P=(0,T.localize)(4,null);class D{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const S=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:S})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const S=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:S})}else this._match(126)?this._addToken(9):this._error(M("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(M("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const S=this._start,h=this._input.substring(this._start,this._current),w={type:19,offset:this._start,lexeme:h};this._errors.push({offset:S,lexeme:h,additionalInfo:R}),this._tokens.push(w)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const S=this._input.substring(this._start,this._current),h=D._keywords.get(S);h?this._addToken(h):this._tokens.push({type:17,lexeme:S,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,S=!1,h=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(P);return}const g=this._input.charCodeAt(R);if(S)S=!1;else if(g===47&&!h){R++;break}else g===91?h=!0:g===92?S=!0:g===93&&(h=!1);R++}for(;R<this._input.length&&D._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const w=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:w,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}D._regexFlags=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),D._keywords=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(Pe[164],Ae([1,0,22,29,139,265]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function D(a){return a=a.trim(),a==="*"||A.test(a)}e.isValidVersionStr=D;function m(a){if(!D(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=a.match(A);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=m;function R(a){if(!a)return null;const d=a.majorBase,_=a.majorMustEqual,k=a.minorBase;let p=a.minorMustEqual;const i=a.patchBase;let l=a.patchMustEqual;a.hasCaret&&(d===0||(p=!1),l=!1);let s=0;if(a.preRelease){const o=P.exec(a.preRelease);if(o){const[,f,E,r]=o;s=Date.UTC(Number(f),Number(E)-1,Number(r))}}return{majorBase:d,majorMustEqual:_,minorBase:k,minorMustEqual:p,patchBase:i,patchMustEqual:l,isMinimum:a.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function S(a,d,_){let k;typeof a=="string"?k=R(m(a)):k=a;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let i;if(typeof _=="string"?i=R(m(_)):i=_,!k||!i)return!1;const l=k.majorBase,s=k.minorBase,o=k.patchBase;let f=i.majorBase,E=i.minorBase,r=i.patchBase;const c=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?l>f?!0:l<f?!1:s>E?!0:s<E||p&&p<c?!1:o>=r:(l===1&&f===0&&(!v||!y||!b)&&(f=1,E=0,r=0,v=!0,y=!1,b=!1),l<f?!1:l>f?!v:s<E?!1:s>E?!y:o<r?!1:o>r?!b:!(p&&p<c))}e.isValidVersion=S;function h(a,d,_,k,p){const i=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof k.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof k.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!k.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof k.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof k.extensionDependencies<"u"&&!t(k.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof k.activationEvents<"u"){if(!t(k.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof k.main>"u"&&typeof k.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const o=(0,n.joinPath)(_,k.main);(0,n.isEqualOrParent)(o,_)||i.push([T.default.Warning,C.localize(10,null,o.path,_.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const o=(0,n.joinPath)(_,k.browser);(0,n.isEqualOrParent)(o,_)||i.push([T.default.Warning,C.localize(12,null,o.path,_.path)])}}if(!M.valid(k.version))return i.push([T.default.Error,C.localize(13,null)]),i;const l=[];if(!w(a,d,k,p,l))for(const o of l)i.push([T.default.Error,o]);return i}e.validateExtensionManifest=h;function w(a,d,_,k,p){return k||typeof _.main>"u"&&typeof _.browser>"u"?!0:u(a,d,_.engines.vscode,p)}e.isValidExtensionVersion=w;function g(a,d,_){return a==="*"||u(d,_,a)}e.isEngineValid=g;function u(a,d,_,k=[]){const p=R(m(_));if(!p)return k.push(C.localize(14,null,_)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return k.push(C.localize(15,null,_)),!1}else if(!p.majorMustEqual)return k.push(C.localize(16,null,_)),!1;return S(a,d,p)?!0:(k.push(C.localize(17,null,a,_)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let d=0,_=a.length;d<_;d++)if(typeof a[d]!="string")return!1;return!0}}),define(Pe[68],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(C,M=[],A=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=n}),define(Pe[69],Ae([1,0,68]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var C;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function M(P,D,m){D instanceof n.SyncDescriptor||(D=new n.SyncDescriptor(D,[],Boolean(m))),T.push([P,D])}e.registerSingleton=M;function A(){return T}e.getSingletonServiceDescriptors=A}),define(Pe[165],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class T{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const A of this._nodes.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const P=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(A);P.outgoing.set(D.key,D),D.incoming.set(P.key,P)}removeNode(M){const A=this._hashFn(M);this._nodes.delete(A);for(const P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(M){const A=this._hashFn(M);let P=this._nodes.get(A);return P||(P=new n(A,M),this._nodes.set(A,P)),P}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[A,P]of this._nodes)M.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this._nodes){const P=new Set([M]),D=this._findCycle(A,P);if(D)return D}}_findCycle(M,A){for(const[P,D]of M.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const m=this._findCycle(D,A);if(m)return m;A.delete(P)}}}e.Graph=T}),define(Pe[3],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(n=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function T(A,P,D){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:A,index:D}):(P[n.DI_DEPENDENCIES]=[{id:A,index:D}],P[n.DI_TARGET]=P)}function C(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const P=function(D,m,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,D,R)};return P.toString=()=>A,n.serviceIds.set(A,P),P}e.createDecorator=C;function M(A){return A}e.refineServiceDecorator=M}),define(Pe[42],Ae([1,0,10,2,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationOverrides=M;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function m(t,a){const d=Object.create(null);for(const _ in t)R(d,_,t[_],a);return d}e.toValuesTree=m;function R(t,a,d,_){const k=a.split("."),p=k.pop();let i=t;for(let l=0;l<k.length;l++){const s=k[l];let o=i[s];switch(typeof o){case"undefined":o=i[s]=Object.create(null);break;case"object":break;default:_(`Ignoring ${a} as ${k.slice(0,l+1).join(".")} is ${JSON.stringify(o)}`);return}i=o}if(typeof i=="object"&&i!==null)try{i[p]=d}catch{_(`Ignoring ${a} as ${k.join(".")} is ${JSON.stringify(i)}`)}else _(`Ignoring ${a} as ${k.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function S(t,a){const d=a.split(".");h(t,d)}e.removeFromValueTree=S;function h(t,a){const d=a.shift();if(a.length===0){delete t[d];return}if(Object.keys(t).indexOf(d)!==-1){const _=t[d];typeof _=="object"&&!Array.isArray(_)&&(h(_,a),Object.keys(_).length===0&&delete t[d])}}function w(t,a,d){function _(i,l){let s=i;for(const o of l){if(typeof s!="object"||s===null)return;s=s[o]}return s}const k=a.split("."),p=_(t,k);return typeof p>"u"?d:p}e.getConfigurationValue=w;function g(t,a,d){Object.keys(a).forEach(_=>{_!=="__proto__"&&(_ in t?n.isObject(t[_])&&n.isObject(a[_])?g(t[_],a[_],d):d&&(t[_]=a[_]):t[_]=a[_])})}e.merge=g;function u(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(Pe[31],Ae([1,0,20,13,163,3,136,9]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",n.isMacintosh),D.set("isLinux",n.isLinux),D.set("isWindows",n.isWindows),D.set("isWeb",n.isWeb),D.set("isMacNative",n.isMacintosh&&!n.isWeb),D.set("isEdge",n.isEdge),D.set("isFirefox",n.isFirefox),D.set("isChrome",n.isChrome),D.set("isSafari",n.isSafari);function m(H,O){if(D.get(H)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(H,O)}e.setConstant=m;const R=Object.prototype.hasOwnProperty;var S;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));const h={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),g=(0,A.localize)(1,null),u=(0,A.localize)(2,null),t=(0,A.localize)(3,null),a=(0,A.localize)(4,null),d=(0,A.localize)(5,null),_=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class p{get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(O=h){this._config=O,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(O){if(O===""){this._parsingErrors.push({message:w,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(O).scan(),this._current=0,this._parsingErrors=[];try{const X=this._expr();if(!this._isAtEnd()){const pe=this._peek(),Ce=pe.type===17?d:void 0;throw this._parsingErrors.push({message:a,offset:pe.offset,lexeme:C.Scanner.getLexeme(pe),additionalInfo:Ce}),p._parseError}return X}catch(X){if(X!==p._parseError)throw X;return}}_expr(){return this._or()}_or(){const O=[this._and()];for(;this._matchOne(16);){const X=this._and();O.push(X)}return O.length===1?O[0]:i.or(...O)}_and(){const O=[this._term()];for(;this._matchOne(15);){const X=this._term();O.push(X)}return O.length===1?O[0]:i.and(...O)}_term(){if(this._matchOne(2)){const O=this._peek();switch(O.type){case 11:return this._advance(),f.INSTANCE;case 12:return this._advance(),E.INSTANCE;case 0:{this._advance();const X=this._expr();return this._consume(1,t),X?.negate()}case 17:return this._advance(),$.create(O.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",O)}}return this._primary()}_primary(){const O=this._peek();switch(O.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const X=this._expr();return this._consume(1,t),X}case 17:{const X=O.lexeme;if(this._advance(),this._matchOne(9)){const Ce=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Ce.type!==10)throw this._errExpectedButGot("REGEX",Ce);const we=Ce.lexeme,ve=we.lastIndexOf("/"),Ie=ve===we.length-1?void 0:this._removeFlagsGY(we.substring(ve+1));let se;try{se=new RegExp(we.substring(1,ve),Ie)}catch{throw this._errExpectedButGot("REGEX",Ce)}return U.create(X,se)}switch(Ce.type){case 10:case 19:{const we=[Ce.lexeme];this._advance();let ve=this._peek(),Ie=0;for(let F=0;F<Ce.lexeme.length;F++)Ce.lexeme.charCodeAt(F)===40?Ie++:Ce.lexeme.charCodeAt(F)===41&&Ie--;for(;!this._isAtEnd()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:Ie++;break;case 1:Ie--;break;case 10:case 18:for(let F=0;F<ve.lexeme.length;F++)ve.lexeme.charCodeAt(F)===40?Ie++:Ce.lexeme.charCodeAt(F)===41&&Ie--}if(Ie<0)break;we.push(C.Scanner.getLexeme(ve)),this._advance(),ve=this._peek()}const se=we.join(""),oe=se.lastIndexOf("/"),Z=oe===se.length-1?void 0:this._removeFlagsGY(se.substring(oe+1));let I;try{I=new RegExp(se.substring(1,oe),Z)}catch{throw this._errExpectedButGot("REGEX",Ce)}return i.regex(X,I)}case 18:{const we=Ce.lexeme;this._advance();let ve=null;if(!(0,T.isFalsyOrWhitespace)(we)){const Ie=we.indexOf("/"),se=we.lastIndexOf("/");if(Ie!==se&&Ie>=0){const oe=we.slice(Ie+1,se),Z=we[se+1]==="i"?"i":"";try{ve=new RegExp(oe,Z)}catch{throw this._errExpectedButGot("REGEX",Ce)}}}if(ve===null)throw this._errExpectedButGot("REGEX",Ce);return U.create(X,ve)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,u);const Ce=this._value();return i.notIn(X,Ce)}switch(this._peek().type){case 3:{this._advance();const Ce=this._value();if(this._previous().type===18)return i.equals(X,Ce);switch(Ce){case"true":return i.has(X);case"false":return i.not(X);default:return i.equals(X,Ce)}}case 4:{this._advance();const Ce=this._value();if(this._previous().type===18)return i.notEquals(X,Ce);switch(Ce){case"true":return i.not(X);case"false":return i.has(X);default:return i.notEquals(X,Ce)}}case 5:return this._advance(),N.create(X,this._value());case 6:return this._advance(),B.create(X,this._value());case 7:return this._advance(),Y.create(X,this._value());case 8:return this._advance(),K.create(X,this._value());case 13:return this._advance(),i.in(X,this._value());default:return i.has(X)}}case 20:throw this._parsingErrors.push({message:_,offset:O.offset,lexeme:"",additionalInfo:k}),p._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const O=this._peek();switch(O.type){case 17:case 18:return this._advance(),O.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(O){return O.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(O){return this._check(O)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(O,X){if(this._check(O))return this._advance();throw this._errExpectedButGot(X,this._peek())}_errExpectedButGot(O,X,pe){const Ce=(0,A.localize)(8,null,O,C.Scanner.getLexeme(X)),we=X.offset,ve=C.Scanner.getLexeme(X);return this._parsingErrors.push({message:Ce,offset:we,lexeme:ve,additionalInfo:pe}),p._parseError}_check(O){return this._peek().type===O}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}p._parseError=new Error,e.Parser=p;class i{static false(){return f.INSTANCE}static true(){return E.INSTANCE}static has(O){return r.create(O)}static equals(O,X){return c.create(O,X)}static notEquals(O,X){return b.create(O,X)}static regex(O,X){return U.create(O,X)}static in(O,X){return v.create(O,X)}static notIn(O,X){return y.create(O,X)}static not(O){return $.create(O)}static and(...O){return fe.create(O,null,!0)}static or(...O){return _e.create(O,null,!0)}static greater(O,X){return Y.create(O,X)}static greaterEquals(O,X){return K.create(O,X)}static smaller(O,X){return N.create(O,X)}static smallerEquals(O,X){return B.create(O,X)}static deserialize(O){return O==null?void 0:this._parser.parse(O)}}i._parser=new p({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=i;function l(H){const O=new p({regexParsingWithErrorRecovery:!1});return H.map(X=>(O.parse(X),O.lexingErrors.length>0?O.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,A.localize)(9,null,pe.additionalInfo):(0,A.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.validateWhenClauses=l;function s(H,O){const X=H?H.substituteConstants():void 0,pe=O?O.substituteConstants():void 0;return!X&&!pe?!0:!X||!pe?!1:X.equals(pe)}e.expressionsAreEqualWithConstantSubstitution=s;function o(H,O){return H.cmp(O)}class f{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return E.INSTANCE}}f.INSTANCE=new f,e.ContextKeyFalseExpr=f;class E{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return f.INSTANCE}}E.INSTANCE=new E,e.ContextKeyTrueExpr=E;class r{static create(O,X=null){const pe=D.get(O);return typeof pe=="boolean"?pe?E.INSTANCE:f.INSTANCE:new r(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:le(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=D.get(this.key);return typeof O=="boolean"?O?E.INSTANCE:f.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.negated||(this.negated=$.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=r;class c{static create(O,X,pe=null){if(typeof X=="boolean")return X?r.create(O,pe):$.create(O,pe);const Ce=D.get(O);return typeof Ce=="boolean"?X===(Ce?"true":"false")?E.INSTANCE:f.INSTANCE:new c(O,X,pe)}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=D.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?E.INSTANCE:f.INSTANCE}return this}evaluate(O){return O.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(O){return O.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class v{static create(O,X){return new v(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=10,this.negated=null}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.valueKey,O.key,O.valueKey)}equals(O){return O.type===this.type?this.key===O.key&&this.valueKey===O.valueKey:!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.valueKey),pe=O.getValue(this.key);return Array.isArray(X)?X.includes(pe):typeof pe=="string"&&typeof X=="object"&&X!==null?R.call(X,pe):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(O){return O.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class y{static create(O,X){return new y(O,X)}constructor(O,X){this.key=O,this.valueKey=X,this.type=11,this._negated=v.create(O,X)}cmp(O){return O.type!==this.type?this.type-O.type:this._negated.cmp(O._negated)}equals(O){return O.type===this.type?this._negated.equals(O._negated):!1}substituteConstants(){return this}evaluate(O){return!this._negated.evaluate(O)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(O){return O.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class b{static create(O,X,pe=null){if(typeof X=="boolean")return X?$.create(O,pe):r.create(O,pe);const Ce=D.get(O);return typeof Ce=="boolean"?X===(Ce?"true":"false")?f.INSTANCE:E.INSTANCE:new b(O,X,pe)}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){const O=D.get(this.key);if(typeof O=="boolean"){const X=O?"true":"false";return this.value===X?f.INSTANCE:E.INSTANCE}return this}evaluate(O){return O.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(O){return O.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class ${static create(O,X=null){const pe=D.get(O);return typeof pe=="boolean"?pe?f.INSTANCE:E.INSTANCE:new $(O,X)}constructor(O,X){this.key=O,this.negated=X,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:le(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=D.get(this.key);return typeof O=="boolean"?O?f.INSTANCE:E.INSTANCE:this}evaluate(O){return!O.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(O){return O.mapNot(this.key)}negate(){return this.negated||(this.negated=r.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=$;function G(H,O){if(typeof H=="string"){const X=parseFloat(H);isNaN(X)||(H=X)}return typeof H=="string"||typeof H=="number"?O(H):f.INSTANCE}class Y{static create(O,X,pe=null){return G(X,Ce=>new Y(O,Ce,pe))}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Y;class K{static create(O,X,pe=null){return G(X,Ce=>new K(O,Ce,pe))}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(O){return O.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=K;class N{static create(O,X,pe=null){return G(X,Ce=>new N(O,Ce,pe))}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=K.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=N;class B{static create(O,X,pe=null){return G(X,Ce=>new B(O,Ce,pe))}constructor(O,X,pe){this.key=O,this.value=X,this.negated=pe,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,this.value,O.key,O.value)}equals(O){return O.type===this.type?this.key===O.key&&this.value===O.value:!1}substituteConstants(){return this}evaluate(O){return typeof this.value=="string"?!1:parseFloat(O.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(O){return O.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=B;class U{static create(O,X){return new U(O,X)}constructor(O,X){this.key=O,this.regexp=X,this.type=7,this.negated=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.key<O.key)return-1;if(this.key>O.key)return 1;const X=this.regexp?this.regexp.source:"",pe=O.regexp?O.regexp.source:"";return X<pe?-1:X>pe?1:0}equals(O){if(O.type===this.type){const X=this.regexp?this.regexp.source:"",pe=O.regexp?O.regexp.source:"";return this.key===O.key&&X===pe}return!1}substituteConstants(){return this}evaluate(O){const X=O.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const O=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${O}`}keys(){return[this.key]}map(O){return O.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=z.create(this)),this.negated}}e.ContextKeyRegexExpr=U;class z{static create(O){return new z(O)}constructor(O){this._actual=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this._actual.cmp(O._actual)}equals(O){return O.type===this.type?this._actual.equals(O._actual):!1}substituteConstants(){return this}evaluate(O){return!this._actual.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(O){return new z(this._actual.map(O))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=z;function j(H){let O=null;for(let X=0,pe=H.length;X<pe;X++){const Ce=H[X].substituteConstants();if(H[X]!==Ce&&O===null){O=[];for(let we=0;we<X;we++)O[we]=H[we]}O!==null&&(O[X]=Ce)}return O===null?H:O}class fe{static create(O,X,pe){return fe._normalizeArr(O,X,pe)}constructor(O,X){this.expr=O,this.negated=X,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,pe=this.expr.length;X<pe;X++){const Ce=o(this.expr[X],O.expr[X]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=j(this.expr);return O===this.expr?this:fe.create(O,this.negated,!1)}evaluate(O){for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].evaluate(O))return!1;return!0}static _normalizeArr(O,X,pe){const Ce=[];let we=!1;for(const ve of O)if(!!ve){if(ve.type===1){we=!0;continue}if(ve.type===0)return f.INSTANCE;if(ve.type===6){Ce.push(...ve.expr);continue}Ce.push(ve)}if(Ce.length===0&&we)return E.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(o);for(let ve=1;ve<Ce.length;ve++)Ce[ve-1].equals(Ce[ve])&&(Ce.splice(ve,1),ve--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const ve=Ce[Ce.length-1];if(ve.type!==9)break;Ce.pop();const Ie=Ce.pop(),se=Ce.length===0,oe=_e.create(ve.expr.map(Z=>fe.create([Z,Ie],null,pe)),null,se);oe&&(Ce.push(oe),Ce.sort(o))}if(Ce.length===1)return Ce[0];if(pe){for(let ve=0;ve<Ce.length;ve++)for(let Ie=ve+1;Ie<Ce.length;Ie++)if(Ce[ve].negate().equals(Ce[Ie]))return f.INSTANCE;if(Ce.length===1)return Ce[0]}return new fe(Ce,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new fe(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());this.negated=_e.create(O,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class _e{static create(O,X,pe){return _e._normalizeArr(O,X,pe)}constructor(O,X){this.expr=O,this.negated=X,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let X=0,pe=this.expr.length;X<pe;X++){const Ce=o(this.expr[X],O.expr[X]);if(Ce!==0)return Ce}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].equals(O.expr[X]))return!1;return!0}return!1}substituteConstants(){const O=j(this.expr);return O===this.expr?this:_e.create(O,this.negated,!1)}evaluate(O){for(let X=0,pe=this.expr.length;X<pe;X++)if(this.expr[X].evaluate(O))return!0;return!1}static _normalizeArr(O,X,pe){let Ce=[],we=!1;if(O){for(let ve=0,Ie=O.length;ve<Ie;ve++){const se=O[ve];if(!!se){if(se.type===0){we=!0;continue}if(se.type===1)return E.INSTANCE;if(se.type===9){Ce=Ce.concat(se.expr);continue}Ce.push(se)}}if(Ce.length===0&&we)return f.INSTANCE;Ce.sort(o)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let ve=1;ve<Ce.length;ve++)Ce[ve-1].equals(Ce[ve])&&(Ce.splice(ve,1),ve--);if(Ce.length===1)return Ce[0];if(pe){for(let ve=0;ve<Ce.length;ve++)for(let Ie=ve+1;Ie<Ce.length;Ie++)if(Ce[ve].negate().equals(Ce[Ie]))return E.INSTANCE;if(Ce.length===1)return Ce[0]}return new _e(Ce,X)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const X of this.expr)O.push(...X.keys());return O}map(O){return new _e(this.expr.map(X=>X.map(O)),null)}negate(){if(!this.negated){const O=[];for(const X of this.expr)O.push(X.negate());for(;O.length>1;){const X=O.shift(),pe=O.shift(),Ce=[];for(const we of ae(X))for(const ve of ae(pe))Ce.push(fe.create([we,ve],null,!1));O.unshift(_e.create(Ce,null,!1))}this.negated=_e.create(O,this,!0)}return this.negated}}e.ContextKeyOrExpr=_e;class ie extends r{static all(){return ie._info.values()}constructor(O,X,pe){super(O,null),this._defaultValue=X,typeof pe=="object"?ie._info.push({...pe,key:O}):pe!==!0&&ie._info.push({key:O,description:pe,type:X!=null?typeof X:void 0})}bindTo(O){return O.createKey(this.key,this._defaultValue)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return c.create(this.key,O)}notEqualsTo(O){return b.create(this.key,O)}}ie._info=[],e.RawContextKey=ie,e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function le(H,O){return H<O?-1:H>O?1:0}function ce(H,O,X,pe){return H<X?-1:H>X?1:O<pe?-1:O>pe?1:0}function ke(H,O){if(H.type===0||O.type===1)return!0;if(H.type===9)return O.type===9?de(H.expr,O.expr):!1;if(O.type===9){for(const X of O.expr)if(ke(H,X))return!0;return!1}if(H.type===6){if(O.type===6)return de(O.expr,H.expr);for(const X of H.expr)if(ke(X,O))return!0;return!1}return H.equals(O)}e.implies=ke;function de(H,O){let X=0,pe=0;for(;X<H.length&&pe<O.length;){const Ce=H[X].cmp(O[pe]);if(Ce<0)return!1;Ce===0&&X++,pe++}return X===H.length}function ae(H){return H.type===9?H.expr:[H]}}),define(Pe[166],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[90],Ae([1,0,138,3]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function C(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function A(d,_){switch(d){case 3:return _==="x64"?"win32-x64":_==="ia32"?"win32-ia32":_==="arm64"?"win32-arm64":"unknown";case 2:return _==="x64"?"linux-x64":_==="arm64"?"linux-arm64":_==="arm"?"linux-armhf":"unknown";case"alpine":return _==="x64"?"alpine-x64":_==="arm64"?"alpine-arm64":"unknown";case 1:return _==="x64"?"darwin-x64":_==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(d,_){return _==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function D(d,_,k){return P(_,k)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===k?!0:m(k).includes(d)}e.isTargetPlatformCompatible=D;function m(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var S;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var h;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(d){d.Install="install",d.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var u;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(u=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var t;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class a extends Error{constructor(_,k){super(_),this.code=k,this.name=k}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Pe[43],Ae([1,0,48,19,13,10,2,140,3,20,15]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function S(ie){return ie.create===!0}e.isFileOpenForWriteOptions=S;var h;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var w;(function(ie){ie[ie.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var g;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=u;function t(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(ie){return!!(ie.capabilities&32768)}e.hasFileCloneCapability=a;function d(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function _(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=_;function k(ie){return u(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var p;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(le,ce){const ke=new i(le.toString(),ce);return o(ke,ce),ke}constructor(le,ce){super(le),this.code=ce}}e.FileSystemProviderError=i;function l(ie,le){return i.create(ie,le)}e.createFileSystemProviderError=l;function s(ie){return ie||l((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function o(ie,le){return ie.name=le?`${le} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=o;function f(ie){if(!ie)return p.Unknown;if(ie instanceof i)return ie.code;const le=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!le)return p.Unknown;switch(le[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=f;function E(ie){if(ie instanceof $)return ie.fileOperationResult;switch(f(ie)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=E;var r;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(le,ce,ke){this.resource=le,this.operation=ce,this.target=ke}isOperation(le){return this.operation===le}}e.FileOperationEvent=c;var v;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class y{constructor(le,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ke=new Map;for(const de of le){const ae=ke.get(de.type);switch(ae?ae.push([de.resource,de]):ke.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,ae]of ke)switch(de){case 1:this.added=n.TernarySearchTree.forUris(()=>ce),this.added.fill(ae);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>ce),this.updated.fill(ae);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>ce),this.deleted.fill(ae);break}}contains(le,...ce){return this.doContains(le,{includeChildren:!1},...ce)}affects(le,...ce){return this.doContains(le,{includeChildren:!0},...ce)}doContains(le,ce,...ke){if(!le)return!1;const de=ke.length>0;return!!((!de||ke.includes(1))&&(this.added?.get(le)||ce.includeChildren&&this.added?.findSuperstr(le))||(!de||ke.includes(0))&&(this.updated?.get(le)||ce.includeChildren&&this.updated?.findSuperstr(le))||(!de||ke.includes(2))&&(this.deleted?.findSubstr(le)||ce.includeChildren&&this.deleted?.findSuperstr(le)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function b(ie,le,ce){return!ie||!le||ie===le||le.length>ie.length?!1:(le.charAt(le.length-1)!==T.sep&&(le+=T.sep),ce?(0,C.startsWithIgnoreCase)(ie,le):ie.indexOf(le)===0)}e.isParent=b;class $ extends Error{constructor(le,ce,ke){super(le),this.fileOperationResult=ce,this.options=ke}}e.FileOperationError=$;class G extends ${constructor(le,ce,ke,de){super(le,ce,de),this.fileOperationResult=ce,this.size=ke}}e.TooLargeFileOperationError=G;class Y extends ${constructor(le,ce,ke){super(le,2,ke),this.stat=ce}}e.NotModifiedSinceFileOperationError=Y;var K;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ie[ie.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=B;async function U(ie,le){if(!le.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(ce=>{const ke=le.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===ie.scheme&&de.added&&(ke.dispose(),ce())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(le){return(0,M.isNumber)(le)||(le=0),le<z.KB?(0,P.localize)(1,null,le.toFixed(0)):le<z.MB?(0,P.localize)(2,null,(le/z.KB).toFixed(2)):le<z.GB?(0,P.localize)(3,null,(le/z.MB).toFixed(2)):le<z.TB?(0,P.localize)(4,null,(le/z.GB).toFixed(2)):(0,P.localize)(5,null,(le/z.TB).toFixed(2))}}z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB,e.ByteSize=z;var j;(function(ie){ie[ie.IA32=0]="IA32",ie[ie.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function fe(ie){return{maxFileSize:ie===0?300*z.MB:16*z.GB,maxHeapSize:ie===0?700*z.MB:2*700*z.MB}}e.getPlatformFileLimits=fe;function _e(ie){const le=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*z.MB:le?10*z.MB:m.isWeb?50*z.MB:1024*z.MB}e.getLargeFileConfirmationLimit=_e}),define(Pe[70],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...C){this._entries=new Map;for(const[M,A]of C)this.set(M,A)}set(C,M){const A=this._entries.get(C);return this._entries.set(C,M),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=n}),define(Pe[167],Ae([1,0,17,9,6,68,165,3,70,168]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class h{constructor(t=new D.ServiceCollection,a=!1,d,_=R){this._services=t,this._strict=a,this._parent=d,this._enableTracing=_,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=_?d?._globalGraph??new A.Graph(k=>k):void 0}createChild(t){return new h(t,this._strict,this,this._enableTracing)}invokeFunction(t,...a){const d=g.traceInvocation(this._enableTracing,t);let _=!1;try{return t({get:p=>{if(_)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(p,d);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...a)}finally{_=!0,d.stop()}}createInstance(t,...a){let d,_;return t instanceof M.SyncDescriptor?(d=g.traceCreation(this._enableTracing,t.ctor),_=this._createInstance(t.ctor,t.staticArguments.concat(a),d)):(d=g.traceCreation(this._enableTracing,t),_=this._createInstance(t,a,d)),d.stop(),_}_createInstance(t,a=[],d){const _=P._util.getServiceDependencies(t).sort((i,l)=>i.index-l.index),k=[];for(const i of _){const l=this._getOrCreateServiceInstance(i.id,d);l||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),k.push(l)}const p=_.length>0?_[0].index:a.length;if(a.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${a.length} static arguments`);const i=p-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,p)}return Reflect.construct(t,a.concat(k))}_setServiceInstance(t,a){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,a);else if(this._parent)this._parent._setServiceInstance(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){const a=this._services.get(t);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):a}_getOrCreateServiceInstance(t,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(t));const d=this._getServiceInstanceOrDescriptor(t);return d instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,d,a.branch(t,!0)):(a.branch(t,!1),d)}_safeCreateAndCacheServiceInstance(t,a,d){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,a,d)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,a,d){const _=new A.Graph(i=>i.id.toString());let k=0;const p=[{id:t,desc:a,_trace:d}];for(;p.length;){const i=p.pop();if(_.lookupOrInsertNode(i),k++>1e3)throw new S(_);for(const l of P._util.getServiceDependencies(i.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(l.id);if(s||this._throwIfStrict(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),s instanceof M.SyncDescriptor){const o={id:l.id,desc:s,_trace:i._trace.branch(l.id,!0)};_.insertEdge(i,o),p.push(o)}}}for(;;){const i=_.roots();if(i.length===0){if(!_.isEmpty())throw new S(_);break}for(const{data:l}of i){if(this._getServiceInstanceOrDescriptor(l.id)instanceof M.SyncDescriptor){const o=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,o)}_.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,a,d=[],_,k){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(t,a,d,_,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,a,d,_,k);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(t,a,d=[],_,k){if(_){const p=new h(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(t);const i=new Map,l=new n.IdleValue(()=>{const s=p._createInstance(a,d,k);for(const[o,f]of i){const E=s[o];if(typeof E=="function")for(const r of f)E.apply(s,r)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!l.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let r=i.get(o);return r||(r=new m.LinkedList,i.set(o,r)),(v,y,b)=>{const $=r.push([v,y,b]);return(0,C.toDisposable)($)}}if(o in s)return s[o];const f=l.value;let E=f[o];return typeof E!="function"||(E=E.bind(f),s[o]=E),E},set(s,o,f){return l.value[o]=f,!0},getPrototypeOf(s){return a.prototype}})}else return this._createInstance(a,d,k)}_throwIfStrict(t,a){if(a&&console.warn(t),this._strict)throw new Error(t)}}e.InstantiationService=h;var w;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(w||(w={}));class g{static traceInvocation(t,a){return t?new g(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(t,a){return t?new g(1,a.name):g._None}constructor(t,a){this.type=t,this.name=a,this._start=Date.now(),this._dep=[]}branch(t,a){const d=new g(3,t.toString());return this._dep.push([t,a,d]),d}stop(){const t=Date.now()-this._start;g._totals+=t;let a=!1;function d(k,p){const i=[],l=new Array(k+1).join("	");for(const[s,o,f]of p._dep)if(o&&f){a=!0,i.push(`${l}CREATES -> ${s}`);const E=d(k+1,f);E&&i.push(E)}else i.push(`${l}uses -> ${s}`);return i.join(`
`)}const _=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||a)&&g.all.add(_.join(`
`))}}g.all=new Set,g._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g._totals=0,e.Trace=g}),define(Pe[14],Ae([1,0,40,4,91,6,28,20,22,10,2,31,3]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function w(){return new Date().toISOString()}function g(v){return(0,m.isNumber)(v)}e.isLogLevel=g;var u;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;function t(v,y,b){switch(y){case u.Trace:v.trace(b);break;case u.Debug:v.debug(b);break;case u.Info:v.info(b);break;case u.Warning:v.warn(b);break;case u.Error:v.error(b);break;case u.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=t;function a(v,y=!1){let b="";for(let $=0;$<v.length;$++){let G=v[$];if(G instanceof Error&&(G=(0,n.toErrorMessage)(G,y)),typeof G=="object")try{G=JSON.stringify(G)}catch{}b+=($>0?" ":"")+G}return b}class d extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(y){this.level!==y&&(this.level=y,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(y){return this.level!==u.Off&&this.level<=y}}e.AbstractLogger=d;class _ extends d{constructor(y){super(),this.logAlways=y}checkLogLevel(y){return this.logAlways||super.checkLogLevel(y)}trace(y,...b){this.checkLogLevel(u.Trace)&&this.log(u.Trace,a([y,...b],!0))}debug(y,...b){this.checkLogLevel(u.Debug)&&this.log(u.Debug,a([y,...b]))}info(y,...b){this.checkLogLevel(u.Info)&&this.log(u.Info,a([y,...b]))}warn(y,...b){this.checkLogLevel(u.Warning)&&this.log(u.Warning,a([y,...b]))}error(y,...b){if(this.checkLogLevel(u.Error))if(y instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=y.stack,this.log(u.Error,a($))}else this.log(u.Error,a([y,...b]))}flush(){}}e.AbstractMessageLogger=_;class k extends d{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.useColors=!P.isWindows}trace(y,...b){this.checkLogLevel(u.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...b):console.log(`[main ${w()}]`,y,...b))}debug(y,...b){this.checkLogLevel(u.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...b):console.log(`[main ${w()}]`,y,...b))}info(y,...b){this.checkLogLevel(u.Info)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,y,...b):console.log(`[main ${w()}]`,y,...b))}warn(y,...b){this.checkLogLevel(u.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,y,...b):console.warn(`[main ${w()}]`,y,...b))}error(y,...b){this.checkLogLevel(u.Error)&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,y,...b):console.error(`[main ${w()}]`,y,...b))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class p extends d{constructor(y=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.useColors=b,this.setLevel(y)}trace(y,...b){this.checkLogLevel(u.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",y,...b):console.log(y,...b))}debug(y,...b){this.checkLogLevel(u.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",y,...b):console.log(y,...b))}info(y,...b){this.checkLogLevel(u.Info)&&(this.useColors?console.log("%c INFO","color: #33f",y,...b):console.log(y,...b))}warn(y,...b){this.checkLogLevel(u.Warning)&&(this.useColors?console.log("%c WARN","color: #993",y,...b):console.log(y,...b))}error(y,...b){this.checkLogLevel(u.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",y,...b):console.error(y,...b))}dispose(){}flush(){}}e.ConsoleLogger=p;class i extends d{constructor(y,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=y,this.setLevel(b)}trace(y,...b){this.checkLogLevel(u.Trace)&&this.adapter.log(u.Trace,[this.extractMessage(y),...b])}debug(y,...b){this.checkLogLevel(u.Debug)&&this.adapter.log(u.Debug,[this.extractMessage(y),...b])}info(y,...b){this.checkLogLevel(u.Info)&&this.adapter.log(u.Info,[this.extractMessage(y),...b])}warn(y,...b){this.checkLogLevel(u.Warning)&&this.adapter.log(u.Warning,[this.extractMessage(y),...b])}error(y,...b){this.checkLogLevel(u.Error)&&this.adapter.log(u.Error,[this.extractMessage(y),...b])}extractMessage(y){return typeof y=="string"?y:(0,n.toErrorMessage)(y,this.checkLogLevel(u.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class l extends d{constructor(y){super(),this.loggers=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const b of this.loggers)b.setLevel(y);super.setLevel(y)}trace(y,...b){for(const $ of this.loggers)$.trace(y,...b)}debug(y,...b){for(const $ of this.loggers)$.debug(y,...b)}info(y,...b){for(const $ of this.loggers)$.info(y,...b)}warn(y,...b){for(const $ of this.loggers)$.warn(y,...b)}error(y,...b){for(const $ of this.loggers)$.error(y,...b)}flush(){for(const y of this.loggers)y.flush()}dispose(){for(const y of this.loggers)y.dispose()}}e.MultiplexLogger=l;class s extends M.Disposable{constructor(y,b,$){if(super(),this.logLevel=y,this.logsHome=b,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,$)for(const G of $)this._loggers.set(G.resource,{logger:void 0,info:G})}getLoggerEntry(y){return(0,m.isString)(y)?[...this._loggers.values()].find(b=>b.info.id===y):this._loggers.get(y)}getLogger(y){return this.getLoggerEntry(y)?.logger}createLogger(y,b){const $=this.toResource(y),G=(0,m.isString)(y)?y:b?.id??(0,C.hash)($.toString()).toString(16);let Y=this._loggers.get($)?.logger;const K=b?.logLevel==="always"?u.Trace:b?.logLevel;Y||(Y=this.doCreateLogger($,K??this.getLogLevel($)??this.logLevel,{...b,id:G}));const N={logger:Y,info:{resource:$,id:G,logLevel:K,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(N.info),this._loggers.set($,N),Y}toResource(y){return(0,m.isString)(y)?(0,D.joinPath)(this.logsHome,`${y}.log`):y}setLogLevel(y,b){if(R.URI.isUri(y)){const $=y,G=b,Y=this._loggers.get($);Y&&G!==Y.info.logLevel&&(Y.info.logLevel=G===this.logLevel?void 0:G,Y.logger?.setLevel(G),this._loggers.set(Y.info.resource,Y),this._onDidChangeLogLevel.fire([$,G]))}else{this.logLevel=y;for(const[$,G]of this._loggers.entries())this._loggers.get($)?.info.logLevel===void 0&&G.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(y,b){const $=this.getLoggerEntry(y);$&&b!==!$.info.hidden&&($.info.hidden=!b,this._loggers.set($.info.resource,$),this._onDidChangeVisibility.fire([$.info.resource,b]))}getLogLevel(y){let b;return y&&(b=this._loggers.get(y)?.info.logLevel),b??this.logLevel}registerLogger(y){const b=this._loggers.get(y.resource);b?b.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this._loggers.set(y.resource,{info:y,logger:void 0}),this._onDidChangeLoggers.fire({added:[y],removed:[]}))}deregisterLogger(y){const b=this._loggers.get(y);b&&(b.logger&&b.logger.dispose(),this._loggers.delete(y),this._onDidChangeLoggers.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const y of this._loggers.values())yield y.info}getRegisteredLogger(y){return this._loggers.get(y)?.info}dispose(){this._loggers.forEach(y=>y.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class o{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(y){}getLevel(){return u.Info}trace(y,...b){}debug(y,...b){}info(y,...b){}warn(y,...b){}error(y,...b){}critical(y,...b){}dispose(){}flush(){}}e.NullLogger=o;class f extends o{}e.NullLogService=f;function E(v){if(v.verbose)return u.Trace;if(typeof v.logLevel=="string"){const y=c(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function r(v){switch(v){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.LogLevelToString=r;function c(v){switch(v){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.parseLogLevel=c,e.CONTEXT_LOG_LEVEL=new S.RawContextKey("logLevel",r(u.Info))}),define(Pe[169],Ae([1,0,6,14]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends n.Disposable{constructor(A,P=[]){super(),this.logger=new T.MultiplexLogger([A,...P]),this._register(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}flush(){this.logger.flush()}}e.LogService=C}),define(Pe[92],Ae([1,0,29,141,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function m(g,u){return u-g}D.compare=m;const R=Object.create(null);R[D.Error]=(0,T.localize)(0,null),R[D.Warning]=(0,T.localize)(1,null),R[D.Info]=(0,T.localize)(2,null);function S(g){return R[g]||""}D.toString=S;function h(g){switch(g){case n.default.Error:return D.Error;case n.default.Warning:return D.Warning;case n.default.Info:return D.Info;case n.default.Ignore:return D.Hint}}D.fromSeverity=h;function w(g){switch(g){case D.Error:return n.default.Error;case D.Warning:return n.default.Warning;case D.Info:return n.default.Info;case D.Hint:return n.default.Ignore}}D.toSeverity=w}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const m="";function R(h){return S(h,!0)}D.makeKey=R;function S(h,w){const g=[m];return h.source?g.push(h.source.replace("\xA6","\\\xA6")):g.push(m),h.code?typeof h.code=="string"?g.push(h.code.replace("\xA6","\\\xA6")):g.push(h.code.value.replace("\xA6","\\\xA6")):g.push(m),h.severity!==void 0&&h.severity!==null?g.push(A.toString(h.severity)):g.push(m),h.message&&w?g.push(h.message.replace("\xA6","\\\xA6")):g.push(m),h.startLineNumber!==void 0&&h.startLineNumber!==null?g.push(h.startLineNumber.toString()):g.push(m),h.startColumn!==void 0&&h.startColumn!==null?g.push(h.startColumn.toString()):g.push(m),h.endLineNumber!==void 0&&h.endLineNumber!==null?g.push(h.endLineNumber.toString()):g.push(m),h.endColumn!==void 0&&h.endColumn!==null?g.push(h.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}D.makeKeyOptionalMessage=S})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Pe[170],Ae([1,0,4,29,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,C.createDecorator)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M=e.NotificationPriority||(e.NotificationPriority={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new m,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.NoOpNotification=D;class m{infinite(){}done(){}total(S){}worked(S){}}e.NoOpProgress=m}),define(Pe[93],Ae([1,0,13,2,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService");function M(m,R){return T.URI.isUri(m)?(0,n.equalsIgnoreCase)(m.scheme,R):(0,n.startsWithIgnoreCase)(m,R+":")}e.matchesScheme=M;function A(m,...R){return R.some(S=>M(m,S))}e.matchesSomeScheme=A;function P(m,R){return m.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=P;function D(m){let R;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return S&&(R={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},m=m.with({fragment:""})),{selection:R,uri:m}}e.extractSelection=D}),define(Pe[171],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__decorate||function(ee,e,n,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,n):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ee,e,n,T);else for(var P=ee.length-1;P>=0;P--)(A=ee[P])&&(M=(C<3?A(M):C>3?A(e,n,M):A(e,n))||M);return C>3&&M&&Object.defineProperty(e,n,M),M},He=this&&this.__param||function(ee,e){return function(n,T){e(n,T,ee)}};define(Pe[172],Ae([1,0,17,21,6,3]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this._value}constructor(S){this.callback=S}report(S){this._value=S,this.callback(this._value)}}P.None=Object.freeze({report(){}}),e.Progress=P;let D=class extends C.Disposable{constructor(S,h){super(),this.deferred=new n.DeferredPromise,h.withProgress(S,w=>(this.reporter=w,this.lastStep&&w.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class m extends C.Disposable{constructor(S){super(),this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(S){this.stop();const h=++this.currentOperationId,w=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>w.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:w.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Pe[30],Ae([1,0,49,10]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,P){n.ok(T.isString(A)),n.ok(T.isObject(P)),n.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(Pe[71],Ae([1,0,4,30]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,m){this.schemasById[C(D)]=m,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new M;T.Registry.add(e.Extensions.JSONContribution,A)}),define(Pe[94],Ae([1,0,16,4,10,135,42,71,30]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=D.Registry.as(P.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const s=new Set;this.doRegisterConfigurations(i,l,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(i){const l=new Set;this.doDeregisterConfigurations(i,l),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:i,remove:l}){const s=new Set;this.doDeregisterConfigurations(l,s),this.doRegisterConfigurations(i,!1,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(i){const l=new Set;this.doRegisterDefaultConfigurations(i,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,l){const s=[];for(const{overrides:o,source:f}of i)for(const E in o)if(l.add(E),e.OVERRIDE_PROPERTY_REGEX.test(E)){const r=this.configurationDefaultsOverrides.get(E),c=r?.valuesSources??new Map;if(f)for(const $ of Object.keys(o[E]))c.set($,f);const v={...r?.value||{},...o[E]};this.configurationDefaultsOverrides.set(E,{source:f,value:v,valuesSources:c});const y=(0,A.getLanguageTagSettingPlainKey)(E),b={type:"object",default:v,description:M.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:C.isString(f)?void 0:f,defaultValueSource:f};s.push(...u(E)),this.configurationProperties[E]=b,this.defaultLanguageConfigurationOverridesNode.properties[E]=b}else{this.configurationDefaultsOverrides.set(E,{value:o[E],source:f});const r=this.configurationProperties[E];r&&(this.updatePropertyDefaultValue(E,r),this.updateSchema(E,r))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(i){const l=new Set;this.doDeregisterDefaultConfigurations(i,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,l){for(const{overrides:s,source:o}of i)for(const f in s){const E=this.configurationDefaultsOverrides.get(f),r=C.isString(o)?o:o?.id,c=C.isString(E?.source)?E?.source:E?.source?.id;if(r===c)if(l.add(f),this.configurationDefaultsOverrides.delete(f),e.OVERRIDE_PROPERTY_REGEX.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const v=this.configurationProperties[f];v&&(this.updatePropertyDefaultValue(f,v),this.updateSchema(f,v))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let l=!1;const s=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,s),l=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,s),l=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,s),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const l of i)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,l,s){i.forEach(o=>{this.validateAndRegisterProperties(o,l,o.extensionInfo,o.restrictedProperties,void 0,s),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(i,l){const s=o=>{if(o.properties)for(const f in o.properties){l.add(f);const E=this.configurationProperties[f];E?.policy?.name&&this.policyConfigurations.delete(E.policy.name),delete this.configurationProperties[f],this.removeFromSchema(f,o.properties[f])}o.allOf?.forEach(f=>s(f))};for(const o of i){s(o);const f=this.configurationContributors.indexOf(o);f!==-1&&this.configurationContributors.splice(f,1)}}validateAndRegisterProperties(i,l=!0,s,o,f=3,E){f=C.isUndefinedOrNull(i.scope)?f:i.scope;const r=i.properties;if(r)for(const v in r){const y=r[v];if(l&&_(v,y)){delete r[v];continue}if(y.source=s,y.defaultDefaultValue=r[v].default,this.updatePropertyDefaultValue(v,y),e.OVERRIDE_PROPERTY_REGEX.test(v)?y.scope=void 0:(y.scope=C.isUndefinedOrNull(y.scope)?f:y.scope,y.restricted=C.isUndefinedOrNull(y.restricted)?!!o?.includes(v):y.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.excludedConfigurationProperties[v]=r[v],delete r[v];continue}else this.configurationProperties[v]=r[v],r[v].policy?.name&&this.policyConfigurations.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),E.add(v)}const c=i.allOf;if(c)for(const v of c)this.validateAndRegisterProperties(v,l,s,o,f,E)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const l=s=>{const o=s.properties;if(o)for(const E in o)this.updateSchema(E,o[E]);s.allOf?.forEach(l)};l(i)}updateSchema(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.resourceLanguageSettingsSchema.properties[i]=l;break}}removeFromSchema(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const l=`[${i}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}}registerOverridePropertyPatternKey(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,l){const s=this.configurationDefaultsOverrides.get(i);let o=s?.value,f=s?.source;C.isUndefined(o)&&(o=l.defaultDefaultValue,f=void 0),C.isUndefined(o)&&(o=a(l.type)),l.default=o,l.defaultValueSource=f}}const w="\\[([^\\]]+)\\]",g=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=g.exec(p);for(;l?.length;){const s=l[1].trim();s&&i.push(s),l=g.exec(p)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=u;function t(p){return p.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=t;function a(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const d=new h;D.Registry.add(e.Extensions.Configuration,d);function _(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):d.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,p,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=_;function k(){const p=[],i=d.getConfigurationProperties();for(const l of Object.keys(i))p.push([l,i[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=k}),define(Pe[173],Ae([1,0,16,4,113,6,28,23,10,2,42,94,30]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function w(l){return Object.isFrozen(l)?l:P.deepFreeze(l)}class g{constructor(s={},o=[],f=[],E){this._contents=s,this._keys=o,this._overrides=f,this.raw=E,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof g)return o;const f=new u("");return f.parseRaw(o),f.configurationModel});this._rawConfiguration=s.reduce((o,f)=>f===o?f:o.merge(f),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,o){const f=this.rawConfiguration.getValue(s),E=o?this.rawConfiguration.getOverrideValue(s,o):void 0,r=o?this.rawConfiguration.override(o).getValue(s):f;return{value:f,override:E,merged:r}}getOverrideValue(s,o){const f=this.getContentsForOverrideIdentifer(o);return f?s?(0,R.getConfigurationValue)(f,s):f:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const f of this.overrides)f.identifiers.includes(s)&&o.push(...f.keys);return n.distinct(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return n.distinct(s)}override(s){let o=this.overrideConfigurations.get(s);return o||(o=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,o)),o}merge(...s){const o=P.deepClone(this.contents),f=P.deepClone(this.overrides),E=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const c of s)if(r.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.mergeContents(o,c.contents);for(const v of c.overrides){const[y]=f.filter(b=>n.equals(b.identifiers,v.identifiers));y?(this.mergeContents(y.contents,v.contents),y.keys.push(...v.keys),y.keys=n.distinct(y.keys)):f.push(P.deepClone(v))}for(const v of c.keys)E.indexOf(v)===-1&&E.push(v)}return new g(o,E,f,r.every(c=>c instanceof g)?void 0:r)}createOverrideConfigurationModel(s){const o=this.getContentsForOverrideIdentifer(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const f={};for(const E of n.distinct([...Object.keys(this.contents),...Object.keys(o)])){let r=this.contents[E];const c=o[E];c&&(typeof r=="object"&&typeof c=="object"?(r=P.deepClone(r),this.mergeContents(r,c)):r=c),f[E]=r}return new g(f,this.keys,this.overrides)}mergeContents(s,o){for(const f of Object.keys(o)){if(f in s&&D.isObject(s[f])&&D.isObject(o[f])){this.mergeContents(s[f],o[f]);continue}s[f]=P.deepClone(o[f])}}getContentsForOverrideIdentifer(s){let o=null,f=null;const E=r=>{r&&(f?this.mergeContents(f,r):f=P.deepClone(r))};for(const r of this.overrides)n.equals(r.identifiers,[s])?o=r.contents:r.identifiers.includes(s)&&E(r.contents);return E(o),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.updateValue(s,o,!0)}setValue(s,o){this.updateValue(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.removeFromValueTree)(this.contents,s),S.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(f=>n.equals(f.identifiers,(0,S.overrideIdentifiersFromKey)(s))),1))}updateValue(s,o,f){(0,R.addToValueTree)(this.contents,s,o,E=>console.error(E)),f=f||this.keys.indexOf(s)===-1,f&&this.keys.push(s),S.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],E=>console.error(E))})}}e.ConfigurationModel=g;class u{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,o){if(!D.isUndefinedOrNull(s)){const f=this.doParseContent(s);this.parseRaw(f,o)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,o){this._raw=s;const{contents:f,keys:E,overrides:r,restricted:c,hasExcludedProperties:v}=this.doParseRaw(s,o);this._configurationModel=new g(f,E,r,v?[s]:void 0),this._restrictedConfigurations=c||[]}doParseContent(s){let o={},f=null,E=[];const r=[],c=[];function v(b){Array.isArray(E)?E.push(b):f!==null&&(E[f]=b)}const y={onObjectBegin:()=>{const b={};v(b),r.push(E),E=b,f=null},onObjectProperty:b=>{f=b},onObjectEnd:()=>{E=r.pop()},onArrayBegin:()=>{const b=[];v(b),r.push(E),E=b,f=null},onArrayEnd:()=>{E=r.pop()},onLiteralValue:v,onError:(b,$,G)=>{c.push({error:b,offset:$,length:G})}};if(s)try{C.visit(s,y),o=E[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return o}doParseRaw(s,o){const f=h.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),E=this.filter(s,f,!0,o);s=E.raw;const r=(0,R.toValuesTree)(s,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),c=Object.keys(s),v=this.toOverrides(s,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:r,keys:c,overrides:v,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}filter(s,o,f,E){let r=!1;if(!E?.scopes&&!E?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:r};const c={},v=[];for(const y in s)if(S.OVERRIDE_PROPERTY_REGEX.test(y)&&f){const b=this.filter(s[y],o,!1,E);c[y]=b.raw,r=r||b.hasExcludedProperties,v.push(...b.restricted)}else{const b=o[y],$=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&v.push(y),($===void 0||E.scopes===void 0||E.scopes.includes($))&&!(E.skipRestricted&&b?.restricted)?c[y]=s[y]:r=!0}return{raw:c,restricted:v,hasExcludedProperties:r}}toOverrides(s,o){const f=[];for(const E of Object.keys(s))if(S.OVERRIDE_PROPERTY_REGEX.test(E)){const r={};for(const c in s[E])r[c]=s[E][c];f.push({identifiers:(0,S.overrideIdentifiersFromKey)(E),keys:Object.keys(r),contents:(0,R.toValuesTree)(r,o)})}return f}}e.ConfigurationModelParser=u;class t extends M.Disposable{constructor(s,o,f,E){super(),this.userSettingsResource=s,this.scopes=o,this.fileService=E,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&f.isEqual(r.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class a{constructor(s,o,f,E,r,c,v,y,b,$,G,Y,K){this.key=s,this.overrides=o,this._value=f,this.overrideIdentifiers=E,this.defaultConfiguration=r,this.policyConfiguration=c,this.applicationConfiguration=v,this.userConfiguration=y,this.localUserConfiguration=b,this.remoteUserConfiguration=$,this.workspaceConfiguration=G,this.folderConfigurationModel=Y,this.memoryConfigurationModel=K}get value(){return w(this._value)}inspect(s,o,f){const E=s.inspect(o,f);return{get value(){return w(E.value)},get override(){return w(E.override)},get merged(){return w(E.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,o,f,E,r=new g,c=new g,v=new A.ResourceMap,y=new g,b=new A.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=o,this._applicationConfiguration=f,this._localUserConfiguration=E,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=v,this._memoryConfiguration=y,this._memoryConfigurationByResource=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(s,o,f){return this.getConsolidatedConfigurationModel(s,o,f).getValue(s)}updateValue(s,o,f={}){let E;f.resource?(E=this._memoryConfigurationByResource.get(f.resource),E||(E=new g,this._memoryConfigurationByResource.set(f.resource,E))):E=this._memoryConfiguration,o===void 0?E.removeValue(s):E.setValue(s,o),f.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,o,f){const E=this.getConsolidatedConfigurationModel(s,o,f),r=this.getFolderConfigurationModelForResource(o.resource,f),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,v=new Set;for(const y of E.overrides)for(const b of y.identifiers)E.getOverrideValue(s,b)!==void 0&&v.add(b);return new a(s,o,E.getValue(s),v.size?[...v]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this._workspaceConfiguration:void 0,r||void 0,c)}keys(s){const o=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,o){this._folderConfigurations.set(s,o),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const f=[];if(!o){const{added:E,updated:r,removed:c}=p(this._defaultConfiguration,s);o=[...E,...r,...c]}for(const E of o)for(const r of(0,S.overrideIdentifiersFromKey)(E)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(r),v=s.getKeysForOverrideIdentifier(r),y=[...v.filter(b=>c.indexOf(b)===-1),...c.filter(b=>v.indexOf(b)===-1),...c.filter(b=>!P.equals(this._defaultConfiguration.override(r).getValue(b),s.override(r).getValue(b)))];f.push([r,y])}return this.updateDefaultConfiguration(s),{keys:o,overrides:f}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:f,removed:E}=p(this._policyConfiguration,s),r=[...o,...f,...E];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:f,removed:E,overrides:r}=p(this.applicationConfiguration,s),c=[...o,...f,...E];return c.length&&this.updateApplicationConfiguration(s),{keys:c,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:f,removed:E,overrides:r}=p(this.localUserConfiguration,s),c=[...o,...f,...E];return c.length&&this.updateLocalUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:f,removed:E,overrides:r}=p(this.remoteUserConfiguration,s),c=[...o,...f,...E];return c.length&&this.updateRemoteUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:f,removed:E,overrides:r}=p(this.workspaceConfiguration,s),c=[...o,...f,...E];return c.length&&this.updateWorkspaceConfiguration(s),{keys:c,overrides:r}}compareAndUpdateFolderConfiguration(s,o){const f=this.folderConfigurations.get(s),{added:E,updated:r,removed:c,overrides:v}=p(f,o),y=[...E,...r,...c];return(y.length||!f)&&this.updateFolderConfiguration(s,o),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(s){const o=this.folderConfigurations.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:f,updated:E,removed:r,overrides:c}=p(o,void 0);return{keys:[...f,...E,...r],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,o,f){let E=this.getConsolidatedConfigurationModelForResource(o,f);return o.overrideIdentifier&&(E=E.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(E=E.merge(this._policyConfiguration)),E}getConsolidatedConfigurationModelForResource({resource:s},o){let f=this.getWorkspaceConsolidatedConfiguration();if(o&&s){const E=o.getFolder(s);E&&(f=this.getFolderConsolidatedConfiguration(E.uri)||f);const r=this._memoryConfigurationByResource.get(s);r&&(f=f.merge(r))}return f}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let o=this._foldersConsolidatedConfigurations.get(s);if(!o){const f=this.getWorkspaceConsolidatedConfiguration(),E=this._folderConfigurations.get(s);E?(o=f.merge(E),this._foldersConsolidatedConfigurations.set(s,o)):o=f}return o}getFolderConfigurationModelForResource(s,o){if(o&&s){const f=o.getFolder(s);if(f)return this._folderConfigurations.get(f.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,o)=>{const{contents:f,overrides:E,keys:r}=this._folderConfigurations.get(o);return s.push([o,{contents:f,overrides:E,keys:r}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this._workspaceConfiguration.keys.forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.keys.forEach(f=>s.add(f))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getAllOverrideIdentifiers().forEach(f=>s.add(f))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this._folderConfigurations.forEach(f=>f.getKeysForOverrideIdentifier(s).forEach(E=>o.add(E))),[...o.values()]}static parse(s){const o=this.parseConfigurationModel(s.defaults),f=this.parseConfigurationModel(s.policy),E=this.parseConfigurationModel(s.application),r=this.parseConfigurationModel(s.user),c=this.parseConfigurationModel(s.workspace),v=s.folders.reduce((y,b)=>(y.set(m.URI.revive(b[0]),this.parseConfigurationModel(b[1])),y),new A.ResourceMap);return new d(o,f,E,r,new g,c,v,new g,new A.ResourceMap)}static parseConfigurationModel(s){return new g(s.contents,s.keys,s.overrides)}}e.Configuration=d;function _(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,o=new Map;for(const E of l)E.keys.forEach(r=>s.add(r)),E.overrides.forEach(([r,c])=>{const v=(0,A.getOrSet)(o,r,new Set);c.forEach(y=>v.add(y))});const f=[];return o.forEach((E,r)=>f.push([r,[...E.values()]])),{keys:[...s.values()],overrides:f}}e.mergeChanges=_;class k{constructor(s,o,f,E){this.change=s,this.previous=o,this.currentConfiguraiton=f,this.currentWorkspace=E,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const r of s.keys)this.affectedKeys.add(r);for(const[,r]of s.overrides)for(const c of r)this.affectedKeys.add(c);this._affectsConfigStr=this._marker;for(const r of this.affectedKeys)this._affectsConfigStr+=r+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,o){const f=this._marker+s,E=this._affectsConfigStr.indexOf(f);if(E<0)return!1;const r=E+f.length;if(r>=this._affectsConfigStr.length)return!1;const c=this._affectsConfigStr.charCodeAt(r);if(c!==this._markerCode1&&c!==this._markerCode2)return!1;if(o){const v=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.previous?.workspace):void 0,y=this.currentConfiguraiton.getValue(s,o,this.currentWorkspace);return!P.equals(v,y)}return!0}}e.ConfigurationChangeEvent=k;function p(l,s){const{added:o,removed:f,updated:E}=i(s?.rawConfiguration,l?.rawConfiguration),r=[],c=l?.getAllOverrideIdentifiers()||[],v=s?.getAllOverrideIdentifiers()||[];if(s){const y=v.filter(b=>!c.includes(b));for(const b of y)r.push([b,s.getKeysForOverrideIdentifier(b)])}if(l){const y=c.filter(b=>!v.includes(b));for(const b of y)r.push([b,l.getKeysForOverrideIdentifier(b)])}if(s&&l){for(const y of c)if(v.includes(y)){const b=i({contents:l.getOverrideValue(void 0,y)||{},keys:l.getKeysForOverrideIdentifier(y)},{contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)});r.push([y,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:f,updated:E,overrides:r}}function i(l,s){const o=l?s?l.keys.filter(r=>s.keys.indexOf(r)===-1):[...l.keys]:[],f=s?l?s.keys.filter(r=>l.keys.indexOf(r)===-1):[...s.keys]:[],E=[];if(l&&s){for(const r of s.keys)if(l.keys.indexOf(r)!==-1){const c=(0,R.getConfigurationValue)(s.contents,r),v=(0,R.getConfigurationValue)(l.contents,r);P.equals(c,v)||E.push(r)}}return{added:o,removed:f,updated:E}}}),define(Pe[95],Ae([1,0,9,3]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var C;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof M&&D._code===C.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof M&&D._code===C.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof M&&D._code===C.NoResolverFound}static isHandled(D){return D instanceof M&&D.isHandled}constructor(D,m=C.Unknown,R){super(D),this._message=D,this._code=m,this._detail=R,this.isHandled=m===C.NotAvailable&&R===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function A(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.getRemoteAuthorityPrefix=A}),define(Pe[50],Ae([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(m){return m.scheme===n.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=T;function C(m){if(!m)return;const R=m.indexOf("+");return R<0?m:m.substr(0,R)}e.getRemoteName=C;function M(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=M;function A(m){const{host:R,port:S}=D(m);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.parseAuthorityWithPort=A;function P(m,R){let{host:S,port:h}=D(m);return typeof h>"u"&&(h=R),{host:S,port:h}}e.parseAuthorityWithOptionalPort=P;function D(m){const R=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=m.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const h=m.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:m,port:void 0}}}),define(Pe[24],Ae([1,0,13,3,50]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var P;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const d=typeof t=="string"?t:t.value,_=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(d,_)}return t._lower===a._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=D;class m{get size(){return this._set.size}constructor(t){if(this._set=new Set,t)for(const a of t)this.add(a)}add(t){this._set.add(D.toKey(t))}delete(t){return this._set.delete(D.toKey(t))}has(t){return this._set.has(D.toKey(t))}}e.ExtensionIdentifierSet=m;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(t){this._map.delete(D.toKey(t))}get(t){return this._map.get(D.toKey(t))}has(t){return this._map.has(D.toKey(t))}set(t,a){this._map.set(D.toKey(t),a)}values(){return this._map.values()}forEach(t){this._map.forEach(t)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function S(u){return h(u)}e.isApplicationScopedExtension=S;function h(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=h;function w(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function g(u,t){if(t){const a=`onResolveRemoteAuthority:${(0,C.getRemoteName)(t)}`;return!!u.activationEvents?.includes(a)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[96],Ae([1,0,9,24]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,P){this._generators.set(A,P)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const P=Object.create(null);for(const D of A){const m=this.readActivationEvents(D);m.length>0&&(P[T.ExtensionIdentifier.toKey(D.identifier)]=m)}return P}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const P=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return P;for(const D in A.contributes){const m=this._generators.get(D);if(!m)continue;const R=A.contributes[D],S=Array.isArray(R)?R:[R];try{m(S,P)}catch(h){(0,n.onUnexpectedError)(h)}}return P}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Pe[174],Ae([1,0,20,51,35]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(D){if(n.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,m,R,S,h,w,g,u){const t=Object.create(null);t["common.machineId"]=w,t.sessionID=(0,C.generateUuid)()+Date.now(),t.commitHash=S,t.version=h,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,n.PlatformToString)(n.platform),t["common.nodePlatform"]=T.platform,t["common.nodeArch"]=R,t["common.product"]=u||"desktop",g&&(t["common.msftInternal"]=g);let a=0;const d=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),n.isLinuxSnap&&(t["common.snap"]="true");const _=M(m);return _&&(t["common.platformDetail"]=_),t}e.resolveCommonProperties=A;function P(D){const m=T.env.USERDNSDOMAIN;if(!m)return!1;const R=m.toLowerCase();return D.some(S=>R===S)}e.verifyMicrosoftInternalDomain=P}),define(Pe[175],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Pe[52],Ae([1,0,23,10,4,42,50,174,175]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(f){this.value=f}}e.TelemetryTrustedValue=m;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class S{async publicLog(f,E,r){}async publicLogError(f,E,r){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(o,f){return C.Event.debounce(f.onDidChangeConfiguration,(r,c)=>{const v=r?new Set([...r.affectedKeys,...c.affectedKeys]):c.affectedKeys;return{...c,affectedKeys:v}},1e3,!0)(r=>{r.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(r.source),configurationKeys:Array.from(r.affectedKeys)})})}e.configurationTelemetry=h;function w(o,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!o.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=w;function g(o,f){return!(f.isBuilt||f.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=g;function u(o){const f=o.getValue(D.TELEMETRY_SETTING_ID),E=o.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=u;function t(o){const f={},E={},r={};_(o,r);for(let c in r){c=c.length>150?c.substr(c.length-149):c;const v=r[c];typeof v=="number"?E[c]=v:typeof v=="boolean"?E[c]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${v.length}`),f[c]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(f[c]=v)}return{properties:f,measurements:E}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(o){if(!o)return"none";const f=(0,A.getRemoteName)(o);return a.has(f)?f:"other"}e.cleanRemoteAuthority=d;function _(o,f,E=0,r){if(!!o)for(const c of Object.getOwnPropertyNames(o)){const v=o[c],y=r?r+c:c;Array.isArray(v)?f[y]=(0,n.safeStringify)(v):v instanceof Date?f[y]=v.toISOString():(0,T.isObject)(v)?E<2?_(v,f,E+1,y+"."):f[y]=(0,n.safeStringify)(v):f[y]=v}}function k(o,f){const E=o.msftInternalDomains||[],r=f.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(E)||r}e.isInternalTelemetry=k;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=p;function i(o,f){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let E=o;const r=[];for(const b of f)for(;;){const $=b.exec(o);if(!$)break;r.push([$.index,b.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(E="";;){const b=v.exec(o);if(!b)break;const $=r.some(([G,Y])=>b.index<Y&&G<v.lastIndex);!c.test(b[0])&&!$&&(E+=o.substring(y,b.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<o.length&&(E+=o.substr(y)),E}function l(o){if(!o)return o;const f=o.toLowerCase(),E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of E)if(r.regex.test(f))return`<REDACTED: ${r.label}>`;return o}function s(o,f){return(0,n.cloneAndChange)(o,E=>{if(E instanceof m)return E.value;if(typeof E=="string"){let r=E.replaceAll("%20"," ");r=i(r,f);for(const c of f)r=r.replace(c,"");return r=l(r),r}})}e.cleanData=s}),define(Pe[176],Ae([1,0,13,90,24,20,2,9,51,52]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,n.compareIgnoreCase)(s.id,o.id)===0}e.areSameExtensions=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(o){const f=o.manifest?o.manifest.version:o.version,E=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new h(o.identifier,f,E)}static parse(o){const f=S.exec(o);return f&&f[1]&&f[2]?new h({id:f[1]},f[2],f[4]||void 0):null}constructor(o,f,E="undefined"){this.version=f,this.targetPlatform=E,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof h?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const o=w.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.getIdAndVersion=g;function u(s,o){return`${s}.${o}`}e.getExtensionId=u;function t(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(s,o){return t(u(s??C.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=a;function d(s,o){const f=[],E=r=>{for(const c of f)if(c.some(v=>R(o(v),o(r))))return c;return null};for(const r of s){const c=E(r);c?c.push(r):f.push([r])}return f}e.groupByExtension=d;function _(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=_;function k(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function p(s,o){const f=[],E=o.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const r=E.shift();if(r&&f.every(c=>!R(c.identifier,{id:r}))){const c=s.filter(v=>R(v.identifier,{id:r}));c.length===1&&(f.push(c[0]),E.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=p;async function i(s,o){if(!M.isLinux)return!1;let f;try{f=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){o.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(r))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,o){const f=await i(s,o),E=(0,T.getTargetPlatform)(f?"alpine":M.platform,D.arch);return o.debug("ComputeTargetPlatform:",E),E}e.computeTargetPlatform=l}),define(Pe[177],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=n;function T(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=T;function C(A){return Array.from(A.entries()).map(P=>[P[0],n(P[1].map)])}e.serializeEnvironmentVariableCollections=C;function M(A){return new Map(A.map(P=>[P[0],{map:T(P[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Pe[178],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,M,A=5){const P=M(D=>{const m=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(C);if(R){R.data.push(m);return}const S=setTimeout(()=>this.flushBuffer(C),A);R={data:[m],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),P.dispose()}},this._terminalBufferMap.set(C,R)});return P}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const M=this._terminalBufferMap.get(C);M&&(this._terminalBufferMap.delete(C),this._callback(C,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Pe[179],Ae([1,0,17,85,39,4,10,2,142,71,30]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var S;(function(k){function p(i,l){let s=i.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=g.getIcon(s.id);if(!o)return;s=o.defaults}return s}k.getDefinition=p})(S=e.IconContribution||(e.IconContribution={}));var h;(function(k){function p(l){return{weight:l.weight,style:l.style,src:l.src.map(s=>({format:s.format,location:s.location.toString()}))}}k.toJSONObject=p;function i(l){const s=o=>(0,A.isString)(o)?o:void 0;if(l&&Array.isArray(l.src)&&l.src.every(o=>(0,A.isString)(o.format)&&(0,A.isString)(o.location)))return{weight:s(l.weight),style:s(l.style),src:l.src.map(o=>({format:o.format,location:P.URI.parse(o.location)}))}}k.fromJSONObject=i})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class w{constructor(){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,i,l,s){const o=this.iconsById[p];if(o){if(l&&!o.description){o.description=l,this.iconSchema.properties[p].markdownDescription=`${l} $(${p})`;const r=this.iconReferenceSchema.enum.indexOf(p);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=l),this._onDidChange.fire()}return o}const f={id:p,description:l,defaults:i,deprecationMessage:s};this.iconsById[p]=f;const E={$ref:"#/definitions/icons"};return s&&(E.deprecationMessage=s),l&&(E.markdownDescription=`${l}: $(${p})`),this.iconSchema.properties[p]=E,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const i=this.iconReferenceSchema.enum.indexOf(p);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,i){const l=this.iconFontsById[p];return l||(this.iconFontsById[p]=i,this._onDidChange.fire(),i)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(o,f)=>o.id.localeCompare(f.id),i=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of s.filter(f=>!!f.description).sort(p))l.push(`|<i class="${i(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const o of s.filter(f=>!C.ThemeIcon.isThemeIcon(f.defaults)).sort(p))l.push(`|<i class="${i(o)}"></i>|${o.id}|`);return l.join(`
`)}}const g=new w;R.Registry.add(e.Extensions.IconContribution,g);function u(k,p,i,l){return g.registerIcon(k,p,i,l)}e.registerIcon=u;function t(){return g}e.getIconRegistry=t;function a(){const k=(0,T.getCodiconFontCharacters)();for(const p in k){const i="\\"+k[p].toString(16);g.registerIcon(p,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const d=R.Registry.as(m.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,g.getIconSchema());const _=new n.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{_.isScheduled()||_.schedule()}),e.widgetClose=u("widget-close",T.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=u("goto-previous-location",T.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=u("goto-next-location",T.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=C.ThemeIcon.modify(T.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(T.Codicon.loading,"spin")}),define(Pe[180],Ae([1,0,4,42,3,14]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=S;function h(u,t,a,d){if(a===1)return!1;if(a===2&&S(t)){const _=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(_?.length===4&&parseInt(_[1])>=18)return!1}return u<1024}e.isPortPrivileged=h;class w{constructor(t,a,d){this.remoteAddress=t,this.localAddress=a,this._dispose=d,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=w;let g=class{constructor(t,a){this.logService=t,this.configurationService=a,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],a=Array.from(this._tunnels.values());for(const d of a){const _=Array.from(d.values());for(const k of _){const p=await k.value;p&&t.push(p)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:a}of t.values())await a.then(d=>d?.dispose());t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,a,d,_,k){this.addTunnelToMap(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:d,privacy:_,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(S(t)||R(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(t,a);if(d)return++d.refcount,d.value}openTunnel(t,a,d,_,k,p=!1,i,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${d} on local port ${k}.`),!t)return;if(a||(a="localhost"),_||(_=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(t,a,d,_,k,p,i,l);return s?s.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.makeTunnel(o);return(o.tunnelRemoteHost!==a||o.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(f),f}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this._tunnels.get(t.tunnelRemoteHost);if(a){const d=a.get(t.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,d))}}}}async tryDisposeTunnel(t,a,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const _=d.value.then(async k=>{k&&(await k.dispose(!0),this._onTunnelClosed.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(a),_}}async closeTunnel(t,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const d=this._tunnels.get(t);if(d&&d.has(a)){const _=d.get(a);_.refcount=0,await this.tryDisposeTunnel(t,a,_)}}addTunnelToMap(t,a,d){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(a,{refcount:1,value:d})}async removeEmptyTunnelFromMap(t,a){const d=this._tunnels.get(t);d&&(await d.get(a)||d.delete(a),d.size===0&&this._tunnels.delete(t))}getTunnelFromMap(t,a){const d=[t];R(t)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):S(t)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const _=d.map(k=>this._tunnels.get(k));for(const k of _){const p=k?.get(a);if(p)return p}}canTunnel(t){return!!m(t)}createWithProvider(t,a,d,_,k,p,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${d} on local port ${_}.`);const l=d;this._factoryInProgress.add(l);const s=_===void 0?d:_,o={elevationRequired:k?this.isPortPrivileged(s):!1},f={remoteAddress:{host:a,port:d},localAddressPort:_,privacy:p,public:p?p!==P.Private:void 0,protocol:i},E=t.forwardPort(f,o);return E?(this.addTunnelToMap(a,d,E),E.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),E}};g=Ve([He(0,M.ILogService),He(1,T.IConfigurationService)],g),e.AbstractTunnelService=g}),define(Pe[181],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Pe[182],Ae([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(D){return D.scheme!==n.Schemas.file&&D.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=T;function C(D){if(D.folders.length)return D.folders.every(m=>T(m.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=C;function M(D){return C(D)?.scheme}e.getVirtualWorkspaceScheme=M;function A(D){return C(D)?.authority}e.getVirtualWorkspaceAuthority=A;function P(D){return C(D)!==void 0}e.isVirtualWorkspace=P}),define(Pe[53],Ae([1,0,143,19,48,22,2,3,15]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function m(o){const f=o;return typeof f?.id=="string"&&A.URI.isUri(f.uri)}e.isSingleFolderWorkspaceIdentifier=m;function R(o){return typeof o?.id=="string"&&!m(o)&&!h(o)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(o,f){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,T.basename)(o)}:f?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const E=o;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}e.toWorkspaceIdentifier=S;function h(o){const f=o;return typeof f?.id=="string"&&A.URI.isUri(f.configPath)}e.isWorkspaceIdentifier=h;function w(o){const f=o;if(f?.uri)return{id:f.id,uri:A.URI.revive(f.uri)};const E=o;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=w;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function u(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=u;function t(o){const f=o;return!!(f&&typeof f=="object"&&A.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(f,E,r,c,v){this._id=f,this._transient=r,this._configuration=c,this._ignorePathCasing=v,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=E}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class d{constructor(f,E){this.raw=E,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function _(o){return new d({uri:o,index:0,name:(0,M.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=_,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function k(o,f){return M.extUriBiasedIgnorePathCase.isEqualOrParent(o,f.untitledWorkspacesHome)}e.isUntitledWorkspace=k;function p(o){let f;return A.URI.isUri(o)?f=o:f=o.configuration,f?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function l(o,f){return!k(o,f)&&!p(o)}e.isSavedWorkspace=l;function s(o){return(typeof o=="string"?(0,T.extname)(o):(0,M.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Pe[54],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const M=this._idPool++;return this._data.set(M,C),this.logDebugInfo(),M}get(C,M){return this._data.has(C)?this._data.get(C)[M]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!n.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}n.enableDebugLogging=!1,e.Cache=n}),define(Pe[37],Ae([1,0,15,22,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(n.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(P=>{const D=this._providerInfo.get(P.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(P,D){D===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,D)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Pe[183],Ae([1,0,147,14,169,27]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends C.LogService{constructor(D,m,R){const S=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",h=R.remote.isRemote?(0,n.localize)(0,null):D?(0,n.localize)(1,null):(0,n.localize)(2,null);super(m.createLogger(S,{name:h}))}};A=Ve([He(1,T.ILoggerService),He(2,M.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Pe[184],Ae([1,0,17]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(A,P,D){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(m=>(this._value=m,this)),this._storageListener=this._storage.onDidChangeStorage(m=>{m.shared===this._shared&&m.key===this._id&&(this._value=m.value)}),this._scheduler=new n.RunOnceScheduler(()=>{const m=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of m.values())R.complete()}catch(R){for(const S of m.values())S.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,P){let D=this._value[A];return typeof D>"u"&&(D=P),D}update(A,P){this._value[A]=P;const D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const m=new n.DeferredPromise;return this._deferredPromises.set(A,m),this._scheduler.isScheduled()||this._scheduler.schedule(),m.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class C extends T{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,P){super(A.identifier.value,!0,P),this._extension=A}}e.ExtensionGlobalMemento=C}),define(Pe[185],Ae([1,0,4,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new n.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new n.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,P,D,m){const S=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(P.value,D,m);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(A,P){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptDirty(P)}$acceptModelSaved(A){const P=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Pe[18],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[186],Ae([1,0,24,4]),function(ee,e,n,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(P,D){C.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=n.ExtensionIdentifier.toKey(P.identifier),Je(this,C,D,"f"),Fe(this,C,"f").onDidChangePassword(m=>{m.extensionId===this._id&&this._onDidChange.fire({key:m.key})})}get(P){return Fe(this,C,"f").get(this._id,P)}store(P,D){return Fe(this,C,"f").store(this._id,P,D)}delete(P){return Fe(this,C,"f").delete(this._id,P)}}e.ExtensionSecrets=M,C=new WeakMap}),define(Pe[72],Ae([1,0,3,180,4,18]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var A;(function(D){function m(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:S.protocol}}D.fromApiTunnel=m;function R(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==T.TunnelPrivacyId.ConstantPrivate&&S.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}D.fromServiceTunnel=R})(A=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let P=class{constructor(m){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,R){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,R){return{dispose:()=>{}}}async $providePortAttributes(m,R,S,h,w){return[]}async $forwardPort(m,R){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Ve([He(0,M.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(Pe[55],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=T}),define(Pe[187],Ae([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(D){let m=this.buffers.indexOf(D);return m<0&&(m=this.buffers.length,this.buffers.push(D)),m}}function C(P,D){if(D.serializeBuffersForPostMessage){const m=new T,R=(w,g)=>{if(g instanceof ArrayBuffer){const u=m.add(g);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(g)){const u=M(g);if(u){const t=m.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:u,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},S=JSON.stringify(P,R),h=m.buffers.map(w=>{const g=new Uint8Array(w);return n.VSBuffer.wrap(g)});return{message:S,buffers:h}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=C;function M(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,D){const m=D.map(h=>{const w=new ArrayBuffer(h.byteLength);return new Uint8Array(w).set(h.buffer),w}),R=D.length?(h,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const g=w,{index:u}=g,t=m[u];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return w}:void 0;return{message:JSON.parse(P,R),arrayBuffers:m}}e.deserializeWebviewMessage=A}),define(Pe[97],Ae([1,0,154,10,2,6,3,30,43,15,40,127,29]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(w=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function u(de){const ae=de;return!!ae&&typeof ae.getSelection=="function"&&!!ae.onDidChangeSelection}e.isEditorPaneWithSelection=u;function t(de,ae,H){for(const O of H.visibleEditorPanes)if(O.group.id===ae&&de.matches(O.input))return O.getViewState()}e.findViewStateForEditor=t;function a(de){if(c(de))return!1;const ae=de;return C.URI.isUri(ae?.resource)}e.isResourceEditorInput=a;function d(de){if(c(de))return!1;const ae=de;return ae?.original!==void 0&&ae.modified!==void 0}e.isResourceDiffEditorInput=d;function _(de){if(c(de)||d(de))return!1;const ae=de;return ae?.primary!==void 0&&ae.secondary!==void 0}e.isResourceSideBySideEditorInput=_;function k(de){if(c(de))return!1;const ae=de;return ae?ae.resource===void 0||ae.resource.scheme===m.Schemas.untitled||ae.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;const p=/Untitled-\d+/;function i(de){return de.scheme===m.Schemas.untitled&&de.path.length>1&&!p.test(de.path)}e.isUntitledWithAssociatedResource=i;function l(de){if(c(de))return!1;const ae=de;return C.URI.isUri(ae?.base?.resource)&&C.URI.isUri(ae?.input1?.resource)&&C.URI.isUri(ae?.input2?.resource)&&C.URI.isUri(ae?.result?.resource)}e.isResourceMergeEditorInput=l;var s;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var o;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class f{constructor(){this.mapIdToSaveSource=new Map}registerSource(ae,H){let O=this.mapIdToSaveSource.get(ae);return O||(O={source:ae,label:H},this.mapIdToSaveSource.set(ae,O)),O.source}getSourceLabel(ae){return this.mapIdToSaveSource.get(ae)?.label??ae}}e.SaveSourceRegistry=new f;var E;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends M.Disposable{}e.AbstractEditorInput=r;function c(de){return de instanceof r}e.isEditorInput=c;function v(de){const ae=de;return C.URI.isUri(ae?.preferredResource)}function y(de){const ae=de;return c(ae?.primary)&&c(ae?.secondary)}e.isSideBySideEditorInput=y;function b(de){const ae=de;return c(ae?.modified)&&c(ae?.original)}e.isDiffEditorInput=b;function $(de,ae,H,O,X){return ke(O,[(0,S.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const pe={...H,limits:{size:Number.MAX_VALUE}};de.openEditor(ae,pe)}}),(0,S.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=$;function G(de){return c(de?.editor)}e.isEditorInputWithOptions=G;function Y(de){const ae=de;return G(de)&&ae?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Y;function K(de){const ae=de;return typeof ae?.groupId=="number"&&c(ae.editor)}e.isEditorIdentifier=K;var N;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(N=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LOCKED=2]="GROUP_LOCKED",de[de.EDITOR_OPEN=3]="EDITOR_OPEN",de[de.EDITOR_CLOSE=4]="EDITOR_CLOSE",de[de.EDITOR_MOVE=5]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=7]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=9]="EDITOR_PIN",de[de.EDITOR_STICKY=10]="EDITOR_STICKY",de[de.EDITOR_DIRTY=11]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(ae,H){if(!ae)return;if(l(ae))return e.EditorResourceAccessor.getOriginalUri(ae.result,H);if(H?.supportSideBySide){const{primary:X,secondary:pe}=this.getSideEditors(ae);if(X&&pe){if(H?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getOriginalUri(X,{filterByScheme:H.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:H.filterByScheme});ae=H.supportSideBySide===U.PRIMARY?X:pe}}if(d(ae)||_(ae)||l(ae))return;const O=v(ae)?ae.preferredResource:ae.resource;return!O||!H||!H.filterByScheme?O:this.filterUri(O,H.filterByScheme)}getSideEditors(ae){return y(ae)||_(ae)?{primary:ae.primary,secondary:ae.secondary}:b(ae)||d(ae)?{primary:ae.modified,secondary:ae.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ae,H){if(!ae)return;if(l(ae))return e.EditorResourceAccessor.getCanonicalUri(ae.result,H);if(H?.supportSideBySide){const{primary:X,secondary:pe}=this.getSideEditors(ae);if(X&&pe){if(H?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getCanonicalUri(X,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:H.filterByScheme});ae=H.supportSideBySide===U.PRIMARY?X:pe}}if(d(ae)||_(ae)||l(ae))return;const O=ae.resource;return!O||!H||!H.filterByScheme?O:this.filterUri(O,H.filterByScheme)}filterUri(ae,H){if(Array.isArray(H)){if(H.some(O=>ae.scheme===O))return ae}else if(H===ae.scheme)return ae}}e.EditorResourceAccessor=new z;var j;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class fe{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ae){const H=this.instantiationService=ae.get(A.IInstantiationService);for(const[O,X]of this.editorSerializerConstructors)this.createEditorSerializer(O,X,H);this.editorSerializerConstructors.clear()}createEditorSerializer(ae,H,O){const X=O.createInstance(H);this.editorSerializerInstances.set(ae,X)}registerFileEditorFactory(ae){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ae}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ae,H){if(this.editorSerializerConstructors.has(ae)||this.editorSerializerInstances.has(ae))throw new Error(`A editor serializer with type ID '${ae}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ae,H,this.instantiationService):this.editorSerializerConstructors.set(ae,H),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ae),this.editorSerializerInstances.delete(ae)})}getEditorSerializer(ae){return this.editorSerializerInstances.get(typeof ae=="string"?ae:ae.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function _e(de,ae,H){return!de||!de.length?[]:await Promise.all(de.map(async O=>{const X=C.URI.revive(O.fileUri);if(!X){H.info("Cannot resolve the path because it is not valid.",O);return}if(!await ae.canHandleResource(X)){H.info("Cannot resolve the path because it cannot be handled",O);return}let Ce=O.exists,we=O.type;if(typeof Ce!="boolean"||typeof we!="number")try{we=(await ae.stat(X)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Ce=!0}catch(Ie){H.error(Ie),Ce=!1}if(!Ce&&O.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",O);return}if(we===D.FileType.Directory){H.info("Cannot resolve the path because it is a directory",O);return}const ve={...O.options,pinned:!0};return Ce?{resource:X,options:ve}:{resource:X,options:ve,forceUntitled:!0}}))}e.pathsToEditors=_e;var ie;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(ie=e.EditorsOrder||(e.EditorsOrder={}));function le(de){const ae=de;if(!ae)return!1;const H=ae;if(H.modified)return le(H.modified);const O=ae;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.isTextEditorViewState=le;function ce(de){return(0,R.isErrorWithActions)(de)}e.isEditorOpenError=ce;function ke(de,ae,H){const O=(0,R.createErrorWithActions)(de,ae);return O.forceMessage=H?.forceMessage,O.forceSeverity=H?.forceSeverity,O.allowDialog=H?.allowDialog,O}e.createEditorOpenError=ke}),define(Pe[188],Ae([1,0,4,155,3,6,28,30,16,64,23,85,179]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",S.Codicon.window,(0,T.localize)(0,null));var w;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(w=e.Extensions||(e.Extensions={}));var g;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function u(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=u;class t extends M.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new n.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new n.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,D.flatten)([...this.viewContainers.values()])}registerViewContainer(o,f,E){const r=this.get(o.id);if(r)return r;const c=o;return c.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:c.openCommandActionDescriptor??{id:c.id},(0,A.getOrSet)(this.viewContainers,f,[]).push(c),E?.isDefault&&this.defaultViewContainers.push(c),this._onDidRegister.fire({viewContainer:c,viewContainerLocation:f}),c}deregisterViewContainer(o){for(const f of this.viewContainers.keys()){const E=this.viewContainers.get(f),r=E?.indexOf(o);if(r!==-1){E?.splice(r,1),E.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:f});return}}}get(o){return this.all.filter(f=>f.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(E=>E?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===o)}}P.Registry.add(w.ViewContainersRegistry,new t);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function d(s,o){const f=s.group??a.More,E=o.group??a.More;return f!==E?f.localeCompare(E):(s.order??5)-(o.order??5)}class _ extends M.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new n.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new n.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new n.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new n.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new m.SetMap}registerViews(o,f){this.registerViews2([{views:o,viewContainer:f}])}registerViews2(o){o.forEach(({views:f,viewContainer:E})=>this.addViews(f,E)),this._onViewsRegistered.fire(o)}deregisterViews(o,f){const E=this.removeViews(o,f);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:f})}moveViews(o,f){for(const E of this._views.keys())if(E!==f){const r=this.removeViews(o,E);r.length&&(this.addViews(r,f),this._onDidChangeContainer.fire({views:r,from:E,to:f}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const f of this._viewContainers){const E=(this._views.get(f)||[]).filter(r=>r.id===o)[0];if(E)return E}return null}getViewContainer(o){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(r=>r.id===o)[0])return f;return null}registerViewWelcomeContent(o,f){return this._viewWelcomeContents.add(o,f),this._onDidChangeViewWelcomeContent.fire(o),(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(o,f),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,f){const E=new Map;for(const[r,c]of f)this._viewWelcomeContents.add(o,c),E.set(r,(0,M.toDisposable)(()=>{this._viewWelcomeContents.delete(o,c),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),E}getViewWelcomeContent(o){const f=[];return this._viewWelcomeContents.forEach(o,E=>f.push(E)),f.sort(d)}addViews(o,f){let E=this._views.get(f);E||(E=[],this._views.set(f,E),this._viewContainers.push(f));for(const r of o){if(this.getView(r.id)!==null)throw new Error((0,T.localize)(1,null,r.id));E.push(r)}}removeViews(o,f){const E=this._views.get(f);if(!E)return[];const r=[],c=[];for(const v of E)o.includes(v)?r.push(v):c.push(v);return r.length&&(c.length?this._views.set(f,c):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),r}}P.Registry.add(w.ViewsRegistry,new _),e.IViewsService=(0,C.createDecorator)("viewsService"),e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var k;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(k=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(o,f){this.resolved=!1,this._hasResolve=!1,(0,R.mixin)(this,o),this._hasResolve=!!f,this.resolve=async E=>{if(f&&!this.resolved){const r=await f(E);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class l extends Error{constructor(o){super((0,T.localize)(2,null,o))}}e.NoTreeViewError=l}),define(Pe[189],Ae([1,0,4,17,156]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new n.Emitter,this._onExit=new n.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,m,R){const S={command:P};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.internalSend("request",S),typeof R=="number"){const h=setTimeout(()=>{clearTimeout(h);const w=this.pendingRequests.get(S.seq);if(w){this.pendingRequests.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:P,message:(0,C.localize)(0,null,R,P)};w(g)}},R)}return m&&this.pendingRequests.set(S.seq,m),S.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,T.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const D=P,m=this.pendingRequests.get(D.request_seq);m&&(this.pendingRequests.delete(D.request_seq),m(D));break}}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,m)=>P.set(m,D)),await(0,T.timeout)(500),P.forEach((D,m)=>{D({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(m)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Pe[190],Ae([1,0,157,31,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=h=>n.localize(51,null,h);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var A;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(A=e.State||(e.State={}));function P(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var D;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(D=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(m=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)("debugService");var S;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Pe[191],Ae([1,0,13,2,19,23,15,44,21,16]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function S(r,c,v){return r.replace(R,function(y,b){return c&&b.length>0&&b[0]!=="_"?y:v&&v.hasOwnProperty(b)?v[b]:y})}e.formatPII=S;function h(r){const c={};for(const v of Object.keys(r))v.startsWith("!")||(c[v]=r[v]);return c}e.filterExceptionsFromTelemetry=h;function w(r){return r.configuration.request==="attach"&&!g(r)&&(!r.parentSession||w(r.parentSession))}e.isSessionAttach=w;function g(r){let c=r.configuration.type;if(!!c)return c==="vslsShare"&&(c=r.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?r:r.parentSession?g(r.parentSession):void 0}e.getExtensionHostDebugSession=g;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function t(r,c,v){let y,b=0;const $=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=$.exec(r);){const Y=G.index+1,K=Y+G[0].length;if(Y<=c&&K>=v){y=G[0],b=Y;break}}if(y){const Y=/\w+/g;let K=null;for(;(K=Y.exec(y))&&!(K.index+1+b+K[0].length>=v););K&&(y=y.substring(0,Y.lastIndex))}return y?{start:b,end:b+y.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(r,c,v,y){if(r.evaluatableExpressionProvider.has(c)){const b=r.evaluatableExpressionProvider.ordered(c),$=(0,m.coalesce)(await Promise.all(b.map(async G=>{try{return await G.provideEvaluatableExpression(c,v,y??D.CancellationToken.None)}catch{return}})));if($.length>0){let G=$[0].expression;const Y=$[0].range;return G||(G=c.getLineContent(v.lineNumber).substring(Y.startColumn-1,Y.endColumn-1)),{range:Y,matchingExpression:G}}}else{const b=c.getLineContent(v.lineNumber),{start:$,end:G}=t(b,v.column,v.column),Y=b.substring($-1,G);return{matchingExpression:Y,range:new P.Range(v.lineNumber,$,v.lineNumber,$+Y.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function _(r){return!!(r&&r.match(d))}e.isUri=_;function k(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(_(r.path))return T.URI.parse(r.path);if((0,C.isAbsolute)(r.path))return T.URI.file(r.path)}return r.path}function p(r){if(typeof r.path=="object"){const c=T.URI.revive(r.path);if(c)return c.scheme===A.Schemas.file?c.fsPath:c.toString()}return r.path}function i(r,c){const v=c?k:p,y=(0,M.deepClone)(r);return s(y,(b,$)=>{b&&$&&($.path=v($))}),y}e.convertToDAPaths=i;function l(r,c){const v=c?k:p,y=(0,M.deepClone)(r);return s(y,(b,$)=>{!b&&$&&($.path=v($))}),y}e.convertToVSCPaths=l;function s(r,c){switch(r.type){case"event":{const v=r;switch(v.event){case"output":c(!1,v.body.source);break;case"loadedSource":c(!1,v.body.source);break;case"breakpoint":c(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=r;switch(v.command){case"setBreakpoints":c(!0,v.arguments.source);break;case"breakpointLocations":c(!0,v.arguments.source);break;case"source":c(!0,v.arguments.source);break;case"gotoTargets":c(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(y=>c(!1,y));break;default:break}break}case"response":{const v=r;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(y=>c(!1,y.source));break;case"loadedSources":v.body.sources.forEach(y=>c(!1,y));break;case"scopes":v.body.scopes.forEach(y=>c(!1,y.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(y=>c(!1,y.source));break;case"setBreakpoints":v.body.breakpoints.forEach(y=>c(!1,y.source));break;case"disassemble":v.body?.instructions.forEach(b=>c(!1,b.location));break;default:break}break}}}function o(r){return r.filter(c=>!c.presentation?.hidden).sort((c,v)=>c.presentation?v.presentation?c.presentation.group?v.presentation.group?c.presentation.group!==v.presentation.group?c.presentation.group.localeCompare(v.presentation.group):f(c.presentation.order,v.presentation.order):-1:v.presentation.group?1:f(c.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=o;function f(r,c){return typeof r!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:r-c}async function E(r,c){const v=r.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(v!=="none"&&(await c.saveAll(),v==="allEditorsInActiveGroup")){const y=c.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await c.save({editor:y.input,groupId:y.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(Pe[73],Ae([1,0,25,36,192,66,15,19,20,31]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var w;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(w=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var d;(function(U){U.scheme=A.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),fe=7;function _e(ae,H){const O=H.toString(fe),pe=`${O.length<z.length?z[O.length-1]:"z"}${O}s${(0,n.encodeBase64)(n.VSBuffer.fromString(ae.scheme),!0,!0)}`;return ae.with({scheme:U.scheme,fragment:pe})}U.generate=_e;function ie(ae){if(ae.scheme!==U.scheme)return;const H=ae.fragment.indexOf("s");if(H<0)return;const O=parseInt(ae.fragment.substring(0,H).replace(j,""),fe),X=(0,n.decodeBase64)(ae.fragment.substring(H+1)).toString();if(!isNaN(O))return{handle:O,notebook:ae.with({scheme:X,fragment:null})}}U.parse=ie;function le(ae,H){return ae.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${ae.scheme!==A.Schemas.file?ae.scheme:""}`})}U.generateCellOutputUri=le;function ce(ae){if(ae.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ae.fragment);if(!H)return;const O=H[1]&&H[1]!==""?H[1]:void 0,X=H[2];return{outputId:O,notebook:ae.with({scheme:X||A.Schemas.file,fragment:null})}}U.parseCellOutputUri=ce;function ke(ae,H,O){return U.generate(ae,H).with({scheme:O})}U.generateCellPropertyUri=ke;function de(ae,H){if(ae.scheme===H)return U.parse(ae.with({scheme:U.scheme}))}U.parseCellPropertyUri=de})(d=e.CellUri||(e.CellUri={}));const _=U=>D.isWindows?U.replace(/\//g,"\\"):U;class k{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=j,this.order=[...new Set(z)].map(fe=>({pattern:fe,matches:T.parse(_(fe))}))}sort(z){const j=new Map(C.Iterable.map(z,_e=>[_e,_(_e)]));let fe=[];for(const{matches:_e}of this.order)for(const[ie,le]of j)if(_e(le)){fe.push(ie),j.delete(ie);break}return j.size&&(fe=fe.concat([...j.keys()].sort((_e,ie)=>this.defaultOrder.indexOf(_e)-this.defaultOrder.indexOf(ie)))),fe}prioritize(z,j){const fe=this.findIndex(z);if(fe===-1){this.order.unshift({pattern:z,matches:T.parse(_(z))});return}const _e=new Set(j.map(le=>this.findIndex(le,fe)));_e.delete(-1);const ie=Array.from(_e).sort();this.order.splice(fe+1,0,...ie.map(le=>this.order[le]));for(let le=ie.length-1;le>=0;le--)this.order.splice(ie[le],1)}toArray(){return this.order.map(z=>z.pattern)}findIndex(z,j=this.order.length){const fe=_(z);for(let _e=0;_e<j;_e++)if(this.order[_e].matches(fe))return _e;return-1}}e.MimeTypeDisplayOrder=k;function p(U,z,j,fe=(_e,ie)=>_e===ie){const _e=[];function ie(ke,de,ae){if(de===0&&ae.length===0)return;const H=_e[_e.length-1];H&&H.start+H.deleteCount===ke?(H.deleteCount+=de,H.toInsert.push(...ae)):_e.push({start:ke,deleteCount:de,toInsert:ae})}let le=0,ce=0;for(;;){if(le===U.length){ie(le,0,z.slice(ce));break}if(ce===z.length){ie(le,U.length-le,[]);break}const ke=U[le],de=z[ce];if(fe(ke,de)){le+=1,ce+=1;continue}j(de)?(ie(le,1,[]),le+=1):(ie(le,0,[de]),ce+=1)}return _e}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(U){const z=U;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=l;function s(U,z,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(z)>=0||U.viewType===z)return!0;if(U.filenamePattern){const fe=l(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,_e=l(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(T.match(fe,(0,P.basename)(j.fsPath).toLowerCase()))return!(_e&&T.match(_e,(0,P.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var o;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(z){return`${f._prefix}${z}`}static parse(z){if(z.startsWith(f._prefix))return z.substring(f._prefix.length)}}f._prefix="notebook/",e.NotebookWorkingCopyTypeIdentifier=f;function E(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=E;const r=new TextDecoder;function c(U){const z=[];let j=!1;for(const fe of U)(z.length===0||j)&&(z.push(fe),j=!0);return $(z),B(n.VSBuffer.concat(z.map(fe=>n.VSBuffer.wrap(fe))))}e.compressOutputItemStreams=c;const v=`${String.fromCharCode(27)}[A`,y=v.split("").map(U=>U.charCodeAt(0)),b=10;function $(U){U.forEach((z,j)=>{if(j===0||z.length<v.length)return;const fe=U[j-1],_e=z.subarray(0,v.length);if(_e[0]===y[0]&&_e[1]===y[1]&&_e[2]===y[2]){const ie=fe.lastIndexOf(b);if(ie===-1)return;U[j-1]=fe.subarray(0,ie),U[j]=z.subarray(v.length)}})}function G(U){let z=U;do U=z,z=U.replace(/[^\n]\x08/gm,"");while(z.length<U.length);return U}function Y(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const z=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const K="\b".charCodeAt(0),N="\r".charCodeAt(0);function B(U){return!U.buffer.includes(K)&&!U.buffer.includes(N)?U:n.VSBuffer.fromString(Y(G(r.decode(U.buffer))))}}),define(Pe[193],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(A,P,D=A.parent){if(A._isRoot)return new C([P]);const m=[A.id];for(let R=D;R&&R.id!==P;R=R.parent)m.push(R.id);return m.push(P),new C(m.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const P=A.indexOf("\0");return P===-1?A:A.slice(0,P)}static fromString(A){return new C(A.split("\0"))}static join(A,P){return new C([...A.path,P])}static joinToString(A,P){return A.toString()+"\0"+P}static parentId(A){const P=A.lastIndexOf("\0");return P===-1?void 0:A.slice(0,P)}static localId(A){const P=A.lastIndexOf("\0");return P===-1?A:A.slice(P+1)}static compare(A,P){return A===P?0:P.startsWith(A+"\0")?2:A.startsWith(P+"\0")?3:1}constructor(A,P=A.length){if(this.path=A,this.viewEnd=P,A.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let P=0;P<A.viewEnd&&P<this.viewEnd;P++)if(A.path[P]!==this.path[P])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=C}),define(Pe[56],Ae([1,0,2,44,45]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var A;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=r=>"runId"in r;e.isStartControllerTests=P;var D;(function(r){r.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),r.deserialize=c=>({range:T.Range.lift(c.range),uri:n.URI.revive(c.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var m;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(m=e.TestMessageType||(e.TestMessageType={}));var R;(function(r){r.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&D.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&D.deserialize(c.location)})})(R=e.ITestErrorMessage||(e.ITestErrorMessage={}));const S=(r,c)=>`${c?"s":"e"}${r}`;e.getMarkId=S;var h;(function(r){r.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&D.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&D.deserialize(c.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var w;(function(r){r.serialize=c=>c.type===0?R.serialize(c):h.serialize(c),r.deserialize=c=>c.type===0?R.deserialize(c):h.deserialize(c)})(w=e.ITestMessage||(e.ITestMessage={}));var g;(function(r){r.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),r.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(w.serialize)}),r.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(w.deserialize)})})(g=e.ITestTaskState||(e.ITestTaskState={}));const u="\0",t=(r,c)=>r+u+c;e.namespaceTestTag=t;const a=r=>{const c=r.indexOf(u);return{ctrlId:r.slice(0,c),tagId:r.slice(c+1)}};e.denamespaceTestTag=a;var d;(function(r){r.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),r.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?n.URI.revive(c.uri):void 0,range:c.range?T.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(d=e.ITestItem||(e.ITestItem={}));var _;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));var k;(function(r){r.serialize=c=>({expand:c.expand,item:d.serialize(c.item)}),r.deserialize=c=>({controllerId:C.TestId.root(c.item.extId),expand:c.expand,item:d.deserialize(c.item)})})(k=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=c=>{let v;return c.item&&(v={},c.item.label!==void 0&&(v.label=c.item.label),c.item.tags!==void 0&&(v.tags=c.item.tags),c.item.busy!==void 0&&(v.busy=c.item.busy),c.item.uri!==void 0&&(v.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(v.range=c.item.range?.toJSON()),c.item.description!==void 0&&(v.description=c.item.description),c.item.error!==void 0&&(v.error=c.item.error),c.item.sortText!==void 0&&(v.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:v}},r.deserialize=c=>{let v;return c.item&&(v={},c.item.label!==void 0&&(v.label=c.item.label),c.item.tags!==void 0&&(v.tags=c.item.tags),c.item.busy!==void 0&&(v.busy=c.item.busy),c.item.range!==void 0&&(v.range=c.item.range?T.Range.lift(c.item.range):null),c.item.description!==void 0&&(v.description=c.item.description),c.item.error!==void 0&&(v.error=c.item.error),c.item.sortText!==void 0&&(v.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:v}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,c)=>{c.expand!==void 0&&(r.expand=c.expand),c.item!==void 0&&(r.item=r.item?Object.assign(r.item,c.item):c.item)};e.applyTestItemUpdate=i;var l;(function(r){r.serializeWithoutMessages=c=>({...k.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.serializeWithoutMessages),retired:c.retired}),r.serialize=c=>({...k.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.serialize),retired:c.retired}),r.deserialize=c=>({...k.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var s;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var o;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var f;(function(r){r.deserialize=c=>c.op===0?{op:c.op,item:k.deserialize(c.item)}:c.op===1?{op:c.op,item:p.deserialize(c.item)}:c.op===2?{op:c.op,uri:n.URI.revive(c.uri),docv:c.docv}:c,r.serialize=c=>c.op===0?{op:c.op,item:k.serialize(c.item)}:c.op===1?{op:c.op,item:p.serialize(c.item)}:c})(f=e.TestsDiffOp||(e.TestsDiffOp={}));class E{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const v=this.createChangeCollector();for(const y of c)switch(y.op){case 0:this.add(k.deserialize(y.item),v);break;case 1:this.update(p.deserialize(y.item),v);break;case 3:this.remove(y.itemId,v);break;case 5:this.retireTest(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this._tags.set(y.tag.id,y.tag);break;case 7:this._tags.delete(y.id);break}v.complete?.()}add(c,v){const y=C.TestId.parentId(c.item.extId)?.toString();let b;if(!y)b=this.createItem(c),this.roots.add(b),this.items.set(c.item.extId,b);else if(this.items.has(y)){const $=this.items.get(y);$.children.add(c.item.extId),b=this.createItem(c,$),this.items.set(c.item.extId,b)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return v.add?.(b),c.expand===2&&this.busyControllerCount++,b}update(c,v){const y=this.items.get(c.extId);if(!!y)return c.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,c),v.update?.(y),y}remove(c,v){const y=this.items.get(c);if(!y)return;const b=C.TestId.parentId(y.item.extId)?.toString();b?this.items.get(b).children.delete(y.item.extId):this.roots.delete(y);const $=[[c]];for(;$.length;)for(const G of $.pop()){const Y=this.items.get(G);Y&&($.push(Y.children),this.items.delete(G),v.remove?.(Y,Y!==y),Y.expand===2&&this.busyControllerCount--)}}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=E}),define(Pe[74],Ae([1,0,17,4,6,49,56,45]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(D=e.TestItemEventOp||(e.TestItemEventOp={}));const m=(d,_)=>d===_,S=Object.entries({range:(d,_)=>d===_?!0:!d||!_?!1:d.equalsRange(_),busy:m,label:m,description:m,error:m,sortText:m,tags:(d,_)=>!(d.length!==_.length||d.some(k=>!_.includes(k)))}),h=(d,_)=>{let k;for(const[p,i]of S)i(d[p],_[p])||(k?k[p]=_[p]:k={[p]:_[p]});return k};class w extends C.Disposable{get root(){return this.options.root}constructor(_){super(),this.options=_,this.debounceSendDiff=this._register(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(_){this._resolveHandler=_;for(const k of this.tree.values())this.updateExpandability(k)}get resolveHandler(){return this._resolveHandler}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){switch(_.op){case 2:{for(const k of this.diff)if(k.op===2&&k.uri===_.uri){k.docv=_.docv;return}break}case 1:{const k=this.diff[this.diff.length-1];if(k){if(k.op===1&&k.item.extId===_.item.extId){(0,A.applyTestItemUpdate)(k.item,_.item);return}if(k.op===0&&k.item.item.extId===_.item.extId){(0,A.applyTestItemUpdate)(k.item,_.item);return}}break}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,k){const p=this.tree.get(_);if(!!p){if((p.expandLevels===void 0||k>p.expandLevels)&&(p.expandLevels=k),p.expand===1){const i=this.resolveChildren(p);return i.isOpen()?this.expandChildren(p,k-1):i.wait().then(()=>this.expandChildren(p,k-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,k-1)):this.expandChildren(p,k-1)}}dispose(){for(const _ of this.tree.values())this.options.getApiFor(_.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(_,k){switch(k.op){case 3:this.removeItem(P.TestId.joinToString(_.fullId,k.id));break;case 0:this.upsertItem(k.item,_);break;case 5:for(const p of k.ops)this.onTestItemEvent(_,p);break;case 1:this.diffTagRefs(k.new,k.old,_.fullId.toString());break;case 2:this.updateExpandability(_);break;case 4:this.pushDiff({op:1,item:{extId:_.fullId.toString(),item:k.update}});break;case 6:this.documentSynced(_.actual.uri);break;default:(0,M.assertNever)(k)}}documentSynced(_){_&&this.pushDiff({op:2,uri:_,docv:this.options.getDocumentVersion(_)})}upsertItem(_,k){const p=P.TestId.fromExtHostTestItem(_,this.root.id,k?.actual),i=this.options.getApiFor(_);i.parent&&i.parent!==k?.actual&&this.options.getChildren(i.parent).delete(_.id);let l=this.tree.get(p.toString());if(!l){l={fullId:p,actual:_,expandLevels:k?.expandLevels?k.expandLevels-1:void 0,expand:0},_.tags.forEach(this.incrementTagRefs,this),this.tree.set(l.fullId.toString(),l),this.setItemParent(_,k),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:l.expand,item:this.options.toITestItem(_)}}),this.connectItemAndChildren(_,l,k);return}if(l.actual===_){this.connectItem(_,l,k);return}if(l.actual.uri?.toString()!==_.uri?.toString())return this.removeItem(p.toString()),this.upsertItem(_,k);const s=this.options.getChildren(l.actual),o=l.actual,f=h(this.options.toITestItem(o),this.options.toITestItem(_));this.options.getApiFor(o).listener=void 0,l.actual=_,l.expand=0,f&&(f.hasOwnProperty("tags")&&(this.diffTagRefs(_.tags,o.tags,p.toString()),delete f.tags),this.onTestItemEvent(l,{op:4,update:f})),this.connectItemAndChildren(_,l,k);for(const[E,r]of s)this.options.getChildren(_).get(r.id)||this.removeItem(P.TestId.joinToString(p,r.id));this.documentSynced(l.actual.uri)}diffTagRefs(_,k,p){const i=new Set(k.map(l=>l.id));for(const l of _)i.delete(l.id)||this.incrementTagRefs(l);this.pushDiff({op:1,item:{extId:p,item:{tags:_.map(l=>(0,A.namespaceTestTag)(this.options.controllerId,l.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(_){const k=this.tags.get(_.id);k?k.refCount++:(this.tags.set(_.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,_.id)}}))}decrementTagRefs(_){const k=this.tags.get(_);k&&!--k.refCount&&(this.tags.delete(_),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,_)}))}setItemParent(_,k){this.options.getApiFor(_).parent=k&&k.actual!==this.root?k.actual:void 0}connectItem(_,k,p){this.setItemParent(_,p);const i=this.options.getApiFor(_);i.parent=p?.actual,i.listener=l=>this.onTestItemEvent(k,l),this.updateExpandability(k)}connectItemAndChildren(_,k,p){this.connectItem(_,k,p);for(const[i,l]of this.options.getChildren(_))this.upsertItem(l,k)}updateExpandability(_){let k;this._resolveHandler?_.resolveBarrier?k=_.resolveBarrier.isOpen()?3:2:k=_.actual.canResolveChildren?1:0:k=0,k!==_.expand&&(_.expand=k,this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:k}}),k===1&&_.expandLevels!==void 0&&this.resolveChildren(_))}expandChildren(_,k){if(k<0)return;const p=[];for(const[i,l]of this.options.getChildren(_.actual)){const s=this.expand(P.TestId.joinToString(_.fullId,l.id),k);(0,n.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(_){if(_.resolveBarrier)return _.resolveBarrier;if(!this._resolveHandler){const l=new n.Barrier;return l.open(),l}_.expand=2,this.pushExpandStateUpdate(_);const k=_.resolveBarrier=new n.Barrier,p=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,l)};let i;try{i=this._resolveHandler(_.actual===this.root?void 0:_.actual)}catch(l){p(l)}return(0,n.isThenable)(i)?i.catch(p).then(()=>{k.open(),this.updateExpandability(_)}):(k.open(),this.updateExpandability(_)),_.resolveBarrier}pushExpandStateUpdate(_){this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:_.expand}})}removeItem(_){const k=this.tree.get(_);if(!k)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:_});const p=[k];for(;p.length;){const i=p.pop();if(!!i){this.options.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.decrementTagRefs(l.id);this.tree.delete(i.fullId.toString());for(const[l,s]of this.options.getChildren(i.actual))p.push(this.tree.get(P.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const _=this.collectDiff();_.length&&this.diffOpEmitter.fire(_)}}e.TestItemCollection=w;class g extends Error{constructor(_){super(`Attempted to insert a duplicate test item ID ${_}`)}}e.DuplicateTestItemError=g;class u extends Error{constructor(_){super(`TestItem with ID "${_}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class t extends Error{constructor(_,k,p){super(`TestItem with ID "${_}" is from controller "${k}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const a=(d,_,k)=>{let p=new Map;return{get size(){return p.size},forEach(i,l){for(const s of p.values())i.call(l,s,this)},[Symbol.iterator](){return p.entries()},replace(i){const l=new Map,s=new Set(p.keys()),o={op:5,ops:[]};for(const f of i){if(!(f instanceof k))throw new u(f.id);const E=_(f).controllerId;if(E!==d.controllerId)throw new t(f.id,E,d.controllerId);if(l.has(f.id))throw new g(f.id);l.set(f.id,f),s.delete(f.id),o.ops.push({op:0,item:f})}for(const f of s.keys())o.ops.push({op:3,id:f});d.listener?.(o),p=l},add(i){if(!(i instanceof k))throw new u(i.id);p.set(i.id,i),d.listener?.({op:0,item:i})},delete(i){p.delete(i)&&d.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=a}),define(Pe[98],Ae([1,0,74]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,C=(A,P)=>{const D={controllerId:P};return T.set(A,D),D};e.createPrivateApiFor=C;const M=A=>{const P=T.get(A);if(!P)throw new n.InvalidTestItemError(A?.id||"<unknown>");return P};e.getPrivateApiFor=M}),define(Pe[75],Ae([1,0,15,2]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(P,D){return P.scheme===n.Schemas.http||P.scheme===n.Schemas.https?P:(D&&D.authority&&D.isRemote&&P.scheme===n.Schemas.file&&(P=T.URI.from({scheme:n.Schemas.vscodeRemote,authority:D.authority,path:P.path})),T.URI.from({scheme:n.Schemas.https,authority:`${P.scheme}+${M(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=C;function M(P){return P.replace(/./g,D=>{const m=D.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?D:"-"+m.toString(16).padStart(4,"0")})}function A(P){return P.replace(/-([0-9a-f]{4})/g,(D,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=A}),define(Pe[194],Ae([1,0,4,6,75]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(P,D,m){this._proxy=P,this._editors=D,this._remoteInfo=m,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const S of this._insets.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,D,m,R,S){let h;for(const _ of this._editors.getVisibleTextEditors(!0))if(_.value===P){h=_;break}if(!h)throw new Error("not a visible editor");const w=this,g=this._handlePool++,u=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(_){return(0,C.asWebviewUri)(_,w._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(_){this._options=_,w._proxy.$setOptions(g,_)}get options(){return this._options}set html(_){this._html=_,w._proxy.$setHtml(g,_)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(_){return w._proxy.$postMessage(g,_)}},d=new class{constructor(){this.editor=P,this.line=D,this.height=m,this.webview=a,this.onDidDispose=t.event}dispose(){w._insets.has(g)&&(w._insets.delete(g),w._proxy.$disposeEditorInset(g),t.fire(),t.dispose(),u.dispose())}};return this._proxy.$createEditorInset(g,h.id,h.value.document.uri,D+1,m,R||{},S.identifier,S.extensionLocation),this._insets.set(g,{editor:P,inset:d,onDidReceiveMessage:u}),d}$onDidDispose(P){const D=this._insets.get(P);D&&D.inset.dispose()}$onDidReceiveMessage(P,D){this._insets.get(P)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=M}),define(Pe[195],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(A,P){super(P),this.variable=A}}e.VariableError=C}),define(Pe[196],Ae([1,0,19,51,10,23,20,88,160,195,13]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(w,g,u,t){this._contributedVariables=new Map,this._context=w,this._labelService=g,this._userHomePromise=u,t&&(this._envVariablesPromise=t.then(a=>this.prepareEnv(a)))}prepareEnv(w){if(A.isWindows){const g=Object.create(null);return Object.keys(w).forEach(u=>{g[u.toLowerCase()]=w[u]}),g}return w}resolveWithEnvironment(w,g,u){return this.recursiveResolve({env:this.prepareEnv(w),userHome:void 0},g?g.uri:void 0,u)}async resolveAsync(w,g){const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,w?w.uri:void 0,g)}async resolveAnyBase(w,g,u,t){const a=M.deepClone(g);A.isWindows&&a.windows?Object.keys(a.windows).forEach(_=>a[_]=a.windows[_]):A.isMacintosh&&a.osx?Object.keys(a.osx).forEach(_=>a[_]=a.osx[_]):A.isLinux&&a.linux&&Object.keys(a.linux).forEach(_=>a[_]=a.linux[_]),delete a.windows,delete a.osx,delete a.linux;const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,w?w.uri:void 0,a,u,t)}async resolveAnyAsync(w,g,u){return this.resolveAnyBase(w,g,u)}async resolveAnyMap(w,g,u){const t=new Map;return{newConfig:await this.resolveAnyBase(w,g,u,t),resolvedVariables:t}}resolveWithInteractionReplace(w,g,u,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,g,u,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,g){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,g)}async recursiveResolve(w,g,u,t,a){if(C.isString(u))return this.resolveString(w,g,u,t,a);if(Array.isArray(u))return Promise.all(u.map(d=>this.recursiveResolve(w,g,d,t,a)));if(C.isObject(u)){const d=Object.create(null),_=await Promise.all(Object.keys(u).map(async k=>[await this.resolveString(w,g,k,t,a),await this.recursiveResolve(w,g,u[k],t,a)]));for(const[k,p]of _)d[k]=p;return d}return u}resolveString(w,g,u,t,a){return(0,R.replaceAsync)(u,S.VARIABLE_REGEXP,async(d,_)=>{if(_.includes(S.VARIABLE_LHS))return d;let k=await this.evaluateSingleVariable(w,d,_,g,t);return a?.set(_,k),k!==d&&C.isString(k)&&k.match(S.VARIABLE_REGEXP)&&(k=await this.resolveString(w,g,k,t,a)),k})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}async evaluateSingleVariable(w,g,u,t,a){let d;const _=u.split(":");_.length>1&&(u=_[0],d=_[1]);const k=l=>{const s=this._context.getFilePath();if(s)return(0,P.normalizeDriveLetter)(s);throw new m.VariableError(l,(0,D.localize)(0,null,g))},p=l=>{const s=k(l);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,P.normalizeDriveLetter)(o)}throw new m.VariableError(l,(0,D.localize)(1,null,g,n.basename(s)))},i=l=>{if(d){const s=this._context.getFolderUri(d);if(s)return s;throw new m.VariableError(l,(0,D.localize)(2,null,g,d))}if(t)return t;throw this._context.getWorkspaceFolderCount()>1?new m.VariableError(l,(0,D.localize)(3,null,g)):new m.VariableError(l,(0,D.localize)(4,null,g))};switch(u){case"env":if(d){if(w.env){const l=w.env[A.isWindows?d.toLowerCase():d];if(C.isString(l))return l}return""}throw new m.VariableError(m.VariableKind.Env,(0,D.localize)(5,null,g));case"config":if(d){const l=this._context.getConfigurationValue(t,d);if(C.isUndefinedOrNull(l))throw new m.VariableError(m.VariableKind.Config,(0,D.localize)(6,null,g,d));if(C.isObject(l))throw new m.VariableError(m.VariableKind.Config,(0,D.localize)(7,null,g,d));return l}throw new m.VariableError(m.VariableKind.Config,(0,D.localize)(8,null,g));case"command":return this.resolveFromMap(m.VariableKind.Command,g,d,a,"command");case"input":return this.resolveFromMap(m.VariableKind.Input,g,d,a,"input");case"extensionInstallFolder":if(d){const l=await this._context.getExtension(d);if(!l)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,g,d));return this.fsPath(l.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,g));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(i(m.VariableKind.WorkspaceFolder)));case"cwd":return t||d?(0,P.normalizeDriveLetter)(this.fsPath(i(m.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(n.basename(this.fsPath(i(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,D.localize)(11,null,g))}case"lineNumber":{const l=this._context.getLineNumber();if(l)return l;throw new m.VariableError(m.VariableKind.LineNumber,(0,D.localize)(12,null,g))}case"selectedText":{const l=this._context.getSelectedText();if(l)return l;throw new m.VariableError(m.VariableKind.SelectedText,(0,D.localize)(13,null,g))}case"file":return k(m.VariableKind.File);case"fileWorkspaceFolder":return p(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||d?n.relative(this.fsPath(i(m.VariableKind.RelativeFile)),k(m.VariableKind.RelativeFile)):k(m.VariableKind.RelativeFile);case"relativeFileDirname":{const l=n.dirname(k(m.VariableKind.RelativeFileDirname));if(t||d){const s=n.relative(this.fsPath(i(m.VariableKind.RelativeFileDirname)),l);return s.length===0?".":s}return l}case"fileDirname":return n.dirname(k(m.VariableKind.FileDirname));case"fileExtname":return n.extname(k(m.VariableKind.FileExtname));case"fileBasename":return n.basename(k(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=n.basename(k(m.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-n.extname(l).length)}case"fileDirnameBasename":return n.basename(n.dirname(k(m.VariableKind.FileDirnameBasename)));case"execPath":{const l=this._context.getExecPath();return l||g}case"execInstallFolder":{const l=this._context.getAppRoot();return l||g}case"pathSeparator":return n.sep;default:try{const l=d?`${u}:${d}`:u;return this.resolveFromMap(m.VariableKind.Unknown,g,l,a,void 0)}catch{return g}}}}resolveFromMap(w,g,u,t,a){if(u&&t){const d=a===void 0?t[u]:t[a+":"+u];if(typeof d=="string")return d;throw new m.VariableError(w,(0,D.localize)(14,null,g))}return g}}S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=S}),define(Pe[99],Ae([1,0,3,97]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var P;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function m(g){const u=g;return(0,T.isEditorInput)(u?.editor)&&(0,T.isEditorInput)(u?.replacement)}e.isEditorReplacement=m;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const u=g;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=h;function w(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(Pe[197],Ae([1,0,3,99]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(M){const A=M;return typeof M=="number"||(0,T.isEditorGroup)(A)}e.isPreferredGroup=C}),define(Pe[198],Ae([1,0,3,166]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(T.IEnvironmentService)}),define(Pe[100],Ae([1,0,24,4,19,6]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class P{static isHostExtension(t,a,d){if(a.getExtensionDescription(t))return!1;const _=d.getExtensionDescription(t);return _?!!((_.main||_.browser)&&_.api==="none"):!1}constructor(t,a){this._activationEventsReader=t,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=a,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new n.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const a=this._activationEventsReader.readActivationEvents(t);if(Array.isArray(a))for(let d of a)d==="onUri"&&(d=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(d)||this._activationMap.set(d,[]),this._activationMap.get(d).push(t)}}set(t){this._extensionDescriptions=t,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,a){this._extensionDescriptions=g(this._extensionDescriptions,a),this._extensionDescriptions=this._extensionDescriptions.concat(t);const d=P._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=g(this._extensionDescriptions,d.map(_=>_.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(d)}static _findLoopingExtensions(t){const a=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(i){this._nodesSet.has(i)||(this._nodesSet.add(i),this._nodesArr.push(i))}addArc(i,l){this.addNode(i),this.addNode(l),this._arcs.has(i)?this._arcs.get(i).push(l):this._arcs.set(i,[l])}getArcs(i){return this._arcs.has(i)?this._arcs.get(i):[]}hasOnlyGoodArcs(i,l){const s=a.getArcs(i);for(let o=0;o<s.length;o++)if(!l.has(s[o]))return!1;return!0}getNodes(){return this._nodesArr}},d=new n.ExtensionIdentifierMap;for(const i of t)if(d.set(i.identifier,i),i.extensionDependencies)for(const l of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(l));const _=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>_.add(i));const k=a.getNodes().filter(i=>!_.has(i));let p;do{p=!1;for(let i=0;i<k.length;i++){const l=k[i];a.hasOnlyGoodArcs(l,_)&&(k.splice(i,1),i--,_.add(l),p=!0)}}while(p);return k.map(i=>d.get(i))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this._activationMap.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const a=this._extensionsMap.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this._extensionsArr)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=P,e.basicActivationEventsReader={readActivationEvents:u=>u.activationEvents};class D{constructor(t){this._lock=new S,this._actual=new P(t,[])}async acquireLock(t){const a=await this._lock.acquire(t);return new m(this,a)}deltaExtensions(t,a,d){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(a,d)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this._actual.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=D;class m extends M.Disposable{constructor(t,a){super(),this._registry=t,this._isDisposed=!1,this._register(a)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=m;class R{constructor(t){this.name=t,this.promise=new Promise((a,d)=>{this._resolve=a})}resolve(t){this._resolve(t)}}class S{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const a=new R(t);return this._pendingCustomers.push(a),this._advance(),a.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let a=!0;const d=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),_=()=>{!a||(clearTimeout(d),a=!1,this._isLocked=!1,this._advance())};t.resolve((0,M.toDisposable)(_))}}var h;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(h||(h={}));function w(u,t){const a=u.isBuiltin?0:u.isUnderDevelopment?2:1,d=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==d)return a-d;const _=C.posix.basename(u.extensionLocation.path),k=C.posix.basename(t.extensionLocation.path);return _<k?-1:_>k?1:0}function g(u,t){const a=new n.ExtensionIdentifierSet(t);return u.filter(d=>!a.has(d.identifier))}}),define(Pe[76],Ae([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var C;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function A(m){const R=n.VSBuffer.alloc(1);switch(m){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=A;function P(m,R){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=P;var D;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(D=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Pe[57],Ae([1,0,3,4,14,27,76,50,52,23,2,6,150]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class extends S.Disposable{constructor(a,d){super(),this.initData=a,this.loggerService=d,this._onDidChangeTelemetryEnabled=this._register(new T.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new T.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=d.createLogger(this.extHostTelemetryLogFile,{id:D.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(d.onDidChangeLogLevel(_=>{(0,C.isLogLevel)(_)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(a,d,_){const k=this.getTelemetryDetails(),p=new g(d,_,a,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(a),{isUsageEnabled:k.isUsageEnabled,isErrorsEnabled:k.isErrorsEnabled});return this._telemetryLoggers.set(a.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(a,d,_){this._level=a,this._telemetryIsSupported=d,this._productConfig=_??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(a){const d=Object.create(null);switch(d["common.extname"]=`${a.publisher}.${a.name}`,d["common.extversion"]=a.version,d["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,d["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,d["common.vscodeversion"]=this.initData.version,d["common.isnewappinstall"]=u(this.initData.telemetryInfo.firstSessionDate),d["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:d["common.uikind"]="web";break;case A.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,P.getRemoteName)((0,D.cleanRemoteAuthority)(this.initData.remote.authority)),d}$onDidChangeTelemetryLevel(a){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=a;const d=this.getTelemetryDetails();this._telemetryLoggers.forEach((_,k)=>{_.isDisposed&&this._telemetryLoggers.delete(k)}),this._telemetryLoggers.forEach(_=>{_.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(a,d){const _=this._telemetryLoggers.get(a.value);return _&&_.isDisposed?(this._telemetryLoggers.delete(a.value),!1):!_||_.ignoreUnhandledExtHostErrors?!1:(_.logError(d),!0)}};w=Ve([He(0,M.IExtHostInitDataService),He(1,C.ILoggerService)],w),e.ExtHostTelemetry=w;class g{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,d,_,k,p,i,l){this._extension=_,this._logger=k,this._inLoggingOnlyMode=p,this._commonProperties=i,this._onDidChangeEnableStates=new T.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=d?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=d?.additionalCommonProperties,this._sender=a,this._telemetryEnablements={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(a,d){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:a,isErrorsEnabled:d},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(a){let d=a.properties??a;return d=(0,D.cleanData)(d,[]),this._additionalCommonProperties&&(d=(0,m.mixin)(d,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(d=(0,m.mixin)(d,this._commonProperties)),a.properties?a.properties=d:a=d,a}logEvent(a,d){!this._sender||(this._extension.publisher==="vscode"?a=this._extension.name+"/"+a:a=this._extension.identifier.value+"/"+a,d=this.mixInCommonPropsAndCleanData(d||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(a,d),this._logger.trace(a,d))}logUsage(a,d){!this._telemetryEnablements.isUsageEnabled||this.logEvent(a,d)}logError(a,d){!this._telemetryEnablements.isErrorsEnabled||!this._sender||(typeof a=="string"?this.logEvent(a,d):this._sender.sendErrorData(a,d))}get apiTelemetryLogger(){if(!this._apiObject){const a=this,d={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return a._telemetryEnablements.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a._onDidChangeEnableStates.event.bind(a)};this._apiObject=Object.freeze(d)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let a=this._sender;this._sender=void 0,Promise.resolve(a.flush()).then(a=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=g;function u(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=u,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,4,2,176,96,24,3]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(p){this.dependency=p}}e.MissingExtensionDependency=D;var m;(function(k){k[k.EagerAutoStart=1]="EagerAutoStart",k[k.EagerManualStart=2]="EagerManualStart",k[k.Lazy=3]="Lazy"})(m=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class R{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions),myToRemove:[],myToAdd:this._myExtensions}}set(p,i){const l=[],s=[],o=[],f=[],E=S(this._allExtensions),r=S(p),c=(G,Y)=>G.extensionLocation.toString()===Y.extensionLocation.toString()||G.isBuiltin===Y.isBuiltin||G.isUserBuiltin===Y.isUserBuiltin||G.isUnderDevelopment===Y.isUnderDevelopment;for(const G of this._allExtensions){const Y=r.get(G.identifier);if(!Y){l.push(G.identifier),E.delete(G.identifier);continue}if(!c(G,Y)){l.push(G.identifier),E.delete(G.identifier);continue}}for(const G of p){const Y=E.get(G.identifier);if(!Y){s.push(G);continue}if(!c(Y,G)){l.push(Y.identifier),E.delete(Y.identifier);continue}}const v=new A.ExtensionIdentifierSet(this._myExtensions),y=new A.ExtensionIdentifierSet(i);for(const G of this._myExtensions)y.has(G)||o.push(G);for(const G of i)v.has(G)||f.push(G);const b=M.ImplicitActivationEvents.createActivationEventsMap(s),$={toRemove:l,toAdd:s,addActivationEvents:b,myToRemove:o,myToAdd:f};return this.delta($),$}delta(p){const{toRemove:i,toAdd:l,myToRemove:s,myToAdd:o}=p,f=new A.ExtensionIdentifierSet(i),E=new A.ExtensionIdentifierSet(s);for(let r=0;r<this._allExtensions.length;r++)f.has(this._allExtensions[r].identifier)&&(this._allExtensions.splice(r,1),r--);for(let r=0;r<this._myExtensions.length;r++)E.has(this._myExtensions[r])&&(this._myExtensions.splice(r,1),r--);for(const r of l)this._allExtensions.push(r);for(const r of o)this._myExtensions.push(r)}containsExtension(p){for(const i of this._myExtensions)if(A.ExtensionIdentifier.equals(i,p))return!0;return!1}}e.ExtensionHostExtensions=R;function S(k){const p=new A.ExtensionIdentifierMap;for(const i of k)p.set(i.identifier,i);return p}function h(k,p){return k.enabledApiProposals?k.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=h;function w(k,p){if(!h(k,p))throw new Error(`Extension '${k.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${k.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${k.identifier.value}`)}e.checkProposedApiEnabled=w;class g{constructor(p,i,l,s){this.codeLoadingTime=p,this.activateCallTime=i,this.activateResolvedTime=l,this.activationReason=s}}e.ActivationTimes=g;class u{constructor(p,i){this.description=p,this.value=i}}e.ExtensionPointContribution=u;var t;(function(k){k[k.Normal=0]="Normal",k[k.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(k){return{type:k.isBuiltin?0:1,isBuiltin:k.isBuiltin||k.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(k.publisher,k.name),uuid:k.uuid},manifest:k,location:k.extensionLocation,targetPlatform:k.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function d(k,p){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(k.manifest.publisher,k.manifest.name)),isBuiltin:k.type===0,isUserBuiltin:k.type===1&&k.isBuiltin,isUnderDevelopment:!!p,extensionLocation:k.location,...k.manifest,uuid:k.identifier.uuid,targetPlatform:k.targetPlatform}}e.toExtensionDescription=d;class _{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=_}),define(Pe[199],Ae([1,0,9,100,24,26,14,17]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(a,d,_,k){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=_,this.activateResolvedTime=k}}D.NONE=new D(!1,-1,-1,-1),e.ExtensionActivationTimes=D;class m{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,d){return a===-1||d===-1?-1:d-a}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=m;class R{constructor(a,d,_,k,p,i){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=_,this.module=k,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=R;class S extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=S;class h extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class w extends R{constructor(a){super(!0,a,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(a,d,_,k){this._logService=k,this._registry=a,this._globalRegistry=d,this._host=_,this._operations=new C.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[a,d]of this._operations)d.dispose()}async waitForActivatingExtensions(){const a=[];for(const[d,_]of this._operations)a.push(_.wait());await Promise.all(a)}isActivated(a){const d=this._operations.get(a);return Boolean(d&&d.value)}getActivatedExtension(a){const d=this._operations.get(a);if(!d||!d.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return d.value}async activateByEvent(a,d){if(this._alreadyActivatedEvents[a])return;const _=this._registry.getExtensionDescriptionsForActivationEvent(a);await this._activateExtensions(_.map(k=>({id:k.identifier,reason:{startup:d,extensionId:k.identifier,activationEvent:a}}))),this._alreadyActivatedEvents[a]=!0}activateById(a,d){const _=this._registry.getExtensionDescription(a);if(!_)throw new Error(`Extension '${a}' is not known`);return this._activateExtensions([{id:_.identifier,reason:d}])}async _activateExtensions(a){const d=a.filter(_=>!this.isActivated(_.id)).map(_=>this._handleActivationRequest(_));await Promise.all(d.map(_=>_.wait()))}_handleActivationRequest(a){if(this._operations.has(a.id))return this._operations.get(a.id);if(this._isHostExtension(a.id))return this._createAndSaveOperation(a,null,[],null);const d=this._registry.getExtensionDescription(a.id);if(!d){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this._createAndSaveOperation(a,null,[],new w(p));return this._host.onExtensionActivationError(a.id,p,new M.MissingExtensionDependency(a.id.value)),i}const _=[],k=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const p of k){if(this._isResolvedExtension(p))continue;const i=this._operations.get(p);if(i){_.push(i);continue}if(this._isHostExtension(p)){_.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(p).identifier,reason:a.reason}));continue}const l=this._registry.getExtensionDescription(p);if(l){if(!l.main&&!l.browser)continue;_.push(this._handleActivationRequest({id:l.identifier,reason:a.reason}));continue}const s=d.displayName||d.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),f=this._createAndSaveOperation(a,d.displayName,[],new w(o));return this._host.onExtensionActivationError(d.identifier,o,new M.MissingExtensionDependency(p)),f}return this._createAndSaveOperation(a,d.displayName,_,null)}_createAndSaveOperation(a,d,_,k){const p=new u(a.id,d,a.reason,_,k,this._host,this._logService);return this._operations.set(a.id,p),p}_isHostExtension(a){return T.ExtensionDescriptionRegistry.isHostExtension(a,this._registry,this._globalRegistry)}_isResolvedExtension(a){const d=this._globalRegistry.getExtensionDescription(a);return d?!d.main&&!d.browser:!1}};g=Ve([He(3,A.ILogService)],g),e.ExtensionsActivator=g;let u=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(a,d,_,k,p,i,l){this._id=a,this._displayName=d,this._reason=_,this._deps=k,this._value=p,this._host=i,this._logService=l,this._barrier=new P.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let a=0;a<this._deps.length;a++){const d=this._deps[a];if(d.value&&!d.value.activationFailed){this._deps.splice(a,1),a--;continue}if(d.value&&d.value.activationFailed){const _=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);_.detail=d.value.activationFailedError,this._value=new w(_),this._host.onExtensionActivationError(this._id,_,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(a=>a.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(a){const d=new Error;if(a&&a.name&&(d.name=a.name),a&&a.message?d.message=`Activating extension '${this._id.value}' failed: ${a.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${a}.`,a&&a.stack&&(d.stack=a.stack),this._value=new w(d),this._isDisposed&&n.isCancellationError(a))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(a)}}};u=Ve([He(6,A.ILogService)],u)});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[7],Ae([1,0,16,9,87,28,66,13,10,2,35,43,95,73,26]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g){"use strict";var u,t,a,d,_,k,p,i,l,s,o,f,E,r,c,v,y,b,$,G,Y,K,N,B,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function z(x){return Object.assign(x,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(x,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[ne,...Se]=arguments;return Reflect.construct(x,Se,ne.constructor)}}})}var j;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(j=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var fe;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(fe=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let _e=i=class{static from(...L){let ne=L;return new i(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}constructor(L){u.set(this,void 0),Je(this,u,L,"f")}dispose(){typeof Fe(this,u,"f")=="function"&&(Fe(this,u,"f").call(this),Je(this,u,void 0,"f"))}};u=new WeakMap,_e=i=Ve([z],_e),e.Disposable=_e;let ie=l=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const je=L[Se];je.isBefore(ne)&&(ne=je)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const je=L[Se];je.isAfter(ne)&&(ne=je)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof l)return!0;const{line:ne,character:Se}=L;return typeof ne=="number"&&typeof Se=="number"}static of(L){if(L instanceof l)return L;if(this.isPosition(L))return new l(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,ne){if(L<0)throw(0,T.illegalArgument)("line must be non-negative");if(ne<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof L>"u"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ne===0?this:new l(this.line+Se,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof L>"u"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Se===this.line&&ne===this.character?this:new l(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};ie=l=Ve([z],ie),e.Position=ie;let le=s=class{static isRange(L){return L instanceof s?!0:L?ie.isPosition(L.start)&&ie.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,ne,Se,je){let Ye,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(Ye=new ie(L,ne),ot=new ie(Se,je)):ie.isPosition(L)&&ie.isPosition(ne)&&(Ye=ie.of(L),ot=ie.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):ie.isPosition(L)?!(ie.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=ie.Max(L.start,this._start),Se=ie.Min(L.end,this._end);if(!ne.isAfter(Se))return new s(ne,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=ie.Min(L.start,this._start),Se=ie.Max(L.end,this.end);return new s(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,T.illegalArgument)();let Se;return L?ie.isPosition(L)?Se=L:(Se=L.start||this.start,ne=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new s(Se,ne)}toJSON(){return[this.start,this.end]}};le=s=Ve([z],le),e.Range=le;let ce=o=class extends le{static isSelection(L){return L instanceof o?!0:L?le.isRange(L)&&ie.isPosition(L.anchor)&&ie.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,ne,Se,je){let Ye,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(Ye=new ie(L,ne),ot=new ie(Se,je)):ie.isPosition(L)&&ie.isPosition(ne)&&(Ye=ie.of(L),ot=ie.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this._anchor=Ye,this._active=ot}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ce=o=Ve([z],ce),e.Selection=ce;class ke{constructor(L,ne,Se){if(typeof L!="string"||L.length===0)throw(0,T.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.illegalArgument)("port");if(typeof Se<"u"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z_\-]+$/.test(Se)))throw(0,T.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=ke;class de extends Error{static NotAvailable(L,ne){return new de(L,h.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new de(L,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=h.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L),this._message=L,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var ae;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ae=e.EndOfLine||(e.EndOfLine={}));var H;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let O=f=class{static isTextEdit(L){return L instanceof f?!0:L?le.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new f(L,ne)}static insert(L,ne){return f.replace(new le(L,L),ne)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const ne=new f(new le(new ie(0,0),new ie(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!le.isRange(L))throw(0,T.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,T.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,T.illegalArgument)("newEol");this._newEol=L}constructor(L,ne){this._range=L,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};O=f=Ve([z],O),e.TextEdit=O;var X;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(X=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let pe=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?zt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new E(L,ne)}static insertCells(L,ne){return new E(new zt(L,L),ne)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,ne){const Se=new E(new zt(L,L),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(L){const ne=new E(new zt(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};pe=E=Ve([z],pe),e.NotebookEdit=pe;class Ce{static isSnippetTextEdit(L){return L instanceof Ce?!0:L?le.isRange(L.range)&&Ie.isSnippetString(L.snippet):!1}static replace(L,ne){return new Ce(L,ne)}static insert(L,ne){return Ce.replace(new le(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=Ce;var we;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(we=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Se,je){this._edits.push({_type:1,from:L,to:ne,options:Se,metadata:je})}createFile(L,ne,Se){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Se})}deleteFile(L,ne,Se){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(L,ne,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Se,je){const Ye=ne.start,ot=ne.end;(Ye!==ot||Se.length>0)&&this._edits.push({_type:5,uri:L,index:Ye,count:ot-Ye,cells:Se,metadata:je})}replaceNotebookCellMetadata(L,ne,Se,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:ne,metadata:Se}})}replace(L,ne,Se,je){this._edits.push({_type:2,uri:L,edit:new O(ne,Se),metadata:je})}insert(L,ne,Se,je){this.replace(L,new le(ne,ne),Se,je)}delete(L,ne,Se){this.replace(L,ne,"",Se)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Se of ne){if(!Se)continue;let je,Ye;Array.isArray(Se)?(je=Se[0],Ye=Se[1]):je=Se,pe.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(L,je.range.start,je.newCellMetadata,Ye):je.newNotebookMetadata?this.replaceNotebookMetadata(L,je.newNotebookMetadata,Ye):this.replaceNotebookCells(L,je.range,je.newCells,Ye):Ce.isSnippetTextEdit(je)?this._edits.push({_type:6,uri:L,range:je.range,edit:je.snippet,metadata:Ye}):this._edits.push({_type:2,uri:L,edit:je,metadata:Ye})}else{for(let Se=0;Se<this._edits.length;Se++){const je=this._edits[Se];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===L.toString()&&(this._edits[Se]=void 0);break}}(0,n.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(const Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&ne.push(Se.edit);return ne}entries(){const L=new M.ResourceMap;for(const ne of this._edits)if(ne._type===2){let Se=L.get(ne.uri);Se||(Se=[ne.uri,[]],L.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=Ve([z],ve),e.WorkspaceEdit=ve;let Ie=r=class{static isSnippetString(L){return L instanceof r?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=r._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Se=new r;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=r._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Se=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Se=new r;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ie=r=Ve([z],Ie),e.SnippetString=Ie;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=c=class{static isLocation(L){return L instanceof c?!0:L?le.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(le.isRange(ne))this.range=le.of(ne);else if(ie.isPosition(ne))this.range=new le(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Z=c=Ve([z],Z),e.Location=Z;let I=class{static is(L){return L?typeof L.message=="string"&&L.location&&le.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};I=Ve([z],I),e.DiagnosticRelatedInformation=I;let F=class{constructor(L,ne,Se=oe.Error){if(!le.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Se}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,n.equals)(L.tags,ne.tags)&&(0,n.equals)(L.relatedInformation,ne.relatedInformation,I.isEqual)}};F=Ve([z],F),e.Diagnostic=F;let W=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};W=Ve([z],W),e.Hover=W;var V;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(V=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let te=class{constructor(L,ne=V.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:V[this.kind]}}};te=Ve([z],te),e.DocumentHighlight=te;var ge;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ge=e.SymbolKind||(e.SymbolKind={}));var Te;(function(x){x[x.Deprecated=1]="Deprecated"})(Te=e.SymbolTag||(e.SymbolTag={}));let ue=v=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,Se,je,Ye){this.name=L,this.kind=ne,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),je instanceof Z?this.location=je:Se instanceof le&&(this.location=new Z(je,Se)),v.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};ue=v=Ve([z],ue),e.SymbolInformation=ue;let ye=y=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(y.validate)}constructor(L,ne,Se,je,Ye){this.name=L,this.detail=ne,this.kind=Se,this.range=je,this.selectionRange=Ye,this.children=[],y.validate(this)}};ye=y=Ve([z],ye),e.DocumentSymbol=ye;var be;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(be=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ze=class{constructor(L,ne){this.title=L,this.kind=ne}};ze=Ve([z],ze),e.CodeAction=ze;let Ue=b=class{constructor(L){this.value=L}append(L){return new b(this.value?this.value+b.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+b.sep)}};Ue.sep=".",Ue=b=Ve([z],Ue),e.CodeActionKind=Ue,Ue.Empty=new Ue(""),Ue.QuickFix=Ue.Empty.append("quickfix"),Ue.Refactor=Ue.Empty.append("refactor"),Ue.RefactorExtract=Ue.Refactor.append("extract"),Ue.RefactorInline=Ue.Refactor.append("inline"),Ue.RefactorMove=Ue.Refactor.append("move"),Ue.RefactorRewrite=Ue.Refactor.append("rewrite"),Ue.Source=Ue.Empty.append("source"),Ue.SourceOrganizeImports=Ue.Source.append("organizeImports"),Ue.SourceFixAll=Ue.Source.append("fixAll");let tt=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};tt=Ve([z],tt),e.SelectionRange=tt;class Ge{constructor(L,ne,Se,je,Ye,ot){this.kind=L,this.name=ne,this.detail=Se,this.uri=je,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=Ge;class it{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=it;class nt{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=nt;var Me;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Me=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};rt=Ve([z],rt),e.CodeLens=rt;let Q=$=class{static isMarkdownString(L){return L instanceof $?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){t.set(this,void 0),Je(this,t,new C.MarkdownString(L,{supportThemeIcons:ne}),"f")}get value(){return Fe(this,t,"f").value}set value(L){Fe(this,t,"f").value=L}get isTrusted(){return Fe(this,t,"f").isTrusted}set isTrusted(L){Fe(this,t,"f").isTrusted=L}get supportThemeIcons(){return Fe(this,t,"f").supportThemeIcons}set supportThemeIcons(L){Fe(this,t,"f").supportThemeIcons=L}get supportHtml(){return Fe(this,t,"f").supportHtml}set supportHtml(L){Fe(this,t,"f").supportHtml=L}get baseUri(){return Fe(this,t,"f").baseUri}set baseUri(L){Fe(this,t,"f").baseUri=L}appendText(L){return Fe(this,t,"f").appendText(L),this}appendMarkdown(L){return Fe(this,t,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return Fe(this,t,"f").appendCodeblock(ne??"",L),this}};t=new WeakMap,Q=$=Ve([z],Q),e.MarkdownString=Q;let J=class{constructor(L,ne){this.label=L,this.documentation=ne}};J=Ve([z],J),e.ParameterInformation=J;let Ee=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};Ee=Ve([z],Ee),e.SignatureInformation=Ee;let $e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$e=Ve([z],$e),e.SignatureHelp=$e;var Be;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Xe;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Xe=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(L){this.value=L}};Qe=Ve([z],Qe),e.InlayHintLabelPart=Qe;let Ke=class{constructor(L,ne,Se){this.position=L,this.label=ne,this.kind=Se}};Ke=Ve([z],Ke),e.InlayHint=Ke;var at;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var St;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(St=e.CompletionItemKind||(e.CompletionItemKind={}));var Dt;(function(x){x[x.Deprecated=1]="Deprecated"})(Dt=e.CompletionItemTag||(e.CompletionItemTag={}));let _t=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&St[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};_t=Ve([z],_t),e.CompletionItem=_t;let vt=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};vt=Ve([z],vt),e.CompletionList=vt;let Ft=class{constructor(L,ne,Se){this.insertText=L,this.range=ne,this.command=Se}};Ft=Ve([z],Ft),e.InlineSuggestion=Ft;let At=class{constructor(L){this.commands=void 0,this.items=L}};At=Ve([z],At),e.InlineSuggestionList=At;var Qt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Qt=e.ViewColumn||(e.ViewColumn={}));var Kt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Kt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Rt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Rt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ct;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Ct=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var mt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(mt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(ne){switch(ne){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let bt=class{constructor(L,ne){if(ne&&!m.URI.isUri(ne))throw(0,T.illegalArgument)("target");if(!le.isRange(L)||L.isEmpty)throw(0,T.illegalArgument)("range");this.range=L,this.target=ne}};bt=Ve([z],bt),e.DocumentLink=bt;let xt=class{constructor(L,ne,Se,je){this.red=L,this.green=ne,this.blue=Se,this.alpha=je}};xt=Ve([z],xt),e.Color=xt;let It=class{constructor(L,ne){if(ne&&!(ne instanceof xt))throw(0,T.illegalArgument)("color");if(!le.isRange(L)||L.isEmpty)throw(0,T.illegalArgument)("range");this.range=L,this.color=ne}};It=Ve([z],It),e.ColorInformation=It;let qe=class{constructor(L){if(!L||typeof L!="string")throw(0,T.illegalArgument)("label");this.label=L}};qe=Ve([z],qe),e.ColorPresentation=qe;var Ht;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var Gt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Nt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Nt=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(L,ne,Se){if(this.startIndex=L,this.length=ne,this.tooltip=Se,typeof L!="number"||L<0)throw(0,T.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,T.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=De;class Re{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=Re;class me{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=me;var q;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(q=e.TerminalLocation||(e.TerminalLocation={}));class Oe{constructor(L){if(this.options=L,typeof L!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Oe;var xe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let We=G=class{static from(L){switch(L){case"clean":return G.Clean;case"build":return G.Build;case"rebuild":return G.Rebuild;case"test":return G.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,T.illegalArgument)("name");this._id=L}get id(){return this._id}};We.Clean=new G("clean","Clean"),We.Build=new G("build","Build"),We.Rebuild=new G("rebuild","Rebuild"),We.Test=new G("test","Test"),We=G=Ve([z],We),e.TaskGroup=We;function et(x){let L="";for(let ne=0;ne<x.length;ne++)L+=x[ne].replace(/,/g,",,")+",";return L}let ut=class{constructor(L,ne,Se){if(typeof L!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,T.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)L.push(ne);return et(L)}};ut=Ve([z],ut),e.ProcessExecution=ut;let lt=class{constructor(L,ne,Se){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,T.illegalArgument)("command");this._command=L,this._args=ne,this._options=Se}else{if(typeof L!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,T.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return et(L)}};lt=Ve([z],lt),e.ShellExecution=lt;var yt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class Ot{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ot;let Ut=Y=class{constructor(L,ne,Se,je,Ye,ot){this.__deprecated=!1,this._definition=this.definition=L;let ht;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=je,ht=Ye,this.__deprecated=!0):ne===gt.Global||ne===gt.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=Ye,ht=ot):(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=Ye,ht=ot),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ut?this._definition={type:Y.ProcessType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:Y.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:Y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:Y.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(Y.EmptyType===ne||Y.ProcessType===ne||Y.ShellType===ne||Y.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};Ut.ExtensionCallbackType="customExecution",Ut.ProcessType="process",Ut.ShellType="shell",Ut.EmptyType="$empty",Ut=Y=Ve([z],Ut),e.Task=Ut;var Ri;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Ri=e.ProgressLocation||(e.ProgressLocation={}));var kt;(function(x){function L(ne){const Se=ne;return(0,D.isNumber)(Se.value)?Se.tooltip&&!(0,D.isString)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}x.isViewBadge=L})(kt=e.ViewBadge||(e.ViewBadge={}));let wi=K=class{static isTreeItem(L,ne){const Se=L;if(Se.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(ne,"treeItemCheckbox");const je=(0,D.isNumber)(Se.checkboxState)?Se.checkboxState:(0,D.isObject)(Se.checkboxState)&&(0,D.isNumber)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,D.isNumber)(Se.checkboxState)&&(0,D.isObject)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(je===void 0||je!==Et.Checked&&je!==Et.Unchecked||Ye!==void 0&&!(0,D.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(L instanceof K)return!0;if(Se.label!==void 0&&!(0,D.isString)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.isString)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.isString)(Se.iconPath)&&!m.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.isString)(Se.iconPath.id))){const je=Se.iconPath;if(!je||!(0,D.isString)(je.light)&&!m.URI.isUri(je.light)&&!(0,D.isString)(je.dark)&&!m.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.isString)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!m.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.isString)(Se.tooltip)&&!(Se.tooltip instanceof Q)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<ci.None&&Se.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.isString)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(L,ne=ci.None){this.collapsibleState=ne,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};wi=K=Ve([z],wi),e.TreeItem=wi;var ci;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Et;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(Et=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L,ne){this.value=L,this.id=ne??(0,R.generateUuid)()}};li=Ve([z],li),e.DataTransferItem=li;let ui=class{constructor(L){a.add(this),d.set(this,new Map);for(const[ne,Se]of L??[]){const je=Fe(this,d,"f").get(Fe(this,a,"m",_).call(this,ne));je?je.push(Se):Fe(this,d,"f").set(Fe(this,a,"m",_).call(this,ne),[Se])}}get(L){return Fe(this,d,"f").get(Fe(this,a,"m",_).call(this,L))?.[0]}set(L,ne){Fe(this,d,"f").set(Fe(this,a,"m",_).call(this,L),[ne])}forEach(L,ne){for(const[Se,je]of Fe(this,d,"f"))for(const Ye of je)L.call(ne,Ye,Se,this)}*[(d=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[L,ne]of Fe(this,d,"f"))for(const Se of ne)yield[L,Se]}};_=function(L){return L.toLowerCase()},ui=Ve([z],ui),e.DataTransfer=ui;let ii=class{constructor(L){this.insertText=L}};ii=Ve([z],ii),e.DocumentDropEdit=ii;let bi=class{constructor(L){this.insertText=L}};bi=Ve([z],bi),e.DocumentPasteEdit=bi;let Vt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};Vt=Ve([z],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let Tt=class{constructor(L){this.id=L}};Tt=Ve([z],Tt),e.ThemeColor=Tt;var Oi;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _i=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=m.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,T.illegalArgument)("base");if(typeof ne!="string")throw(0,T.illegalArgument)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_i=Ve([z],_i),e.RelativePattern=_i;const ni=new WeakMap;function di(x,L){ni.set(x,L)}e.setBreakpointId=di;let ct=class{constructor(L,ne,Se,je){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=ni.get(this)??(0,R.generateUuid)()),this._id}};ct=Ve([z],ct),e.Breakpoint=ct;let Si=class extends ct{constructor(L,ne,Se,je,Ye){if(super(ne,Se,je,Ye),L===null)throw(0,T.illegalArgument)("location");this.location=L}};Si=Ve([z],Si),e.SourceBreakpoint=Si;let jt=class extends ct{constructor(L,ne,Se,je,Ye){super(ne,Se,je,Ye),this.functionName=L}};jt=Ve([z],jt),e.FunctionBreakpoint=jt;let Yt=class extends ct{constructor(L,ne,Se,je,Ye,ot,ht){if(super(je,Ye,ot,ht),!ne)throw(0,T.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=Se}};Yt=Ve([z],Yt),e.DataBreakpoint=Yt;let hi=class{constructor(L,ne,Se){this.command=L,this.args=ne||[],this.options=Se}};hi=Ve([z],hi),e.DebugAdapterExecutable=hi;let yi=class{constructor(L,ne){this.port=L,this.host=ne}};yi=Ve([z],yi),e.DebugAdapterServer=yi;let Di=class{constructor(L){this.path=L}};Di=Ve([z],Di),e.DebugAdapterNamedPipeServer=Di;let fi=class{constructor(L){this.implementation=L}};fi=Ve([z],fi),e.DebugAdapterInlineImplementation=fi;let Ii=class{constructor(L,ne){this.range=L,this.expression=ne}};Ii=Ve([z],Ii),e.EvaluatableExpression=Ii;var Li;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Jt=class{constructor(L,ne){this.range=L,this.text=ne}};Jt=Ve([z],Jt),e.InlineValueText=Jt;let Ci=class{constructor(L,ne,Se=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Se}};Ci=Ve([z],Ci),e.InlineValueVariableLookup=Ci;let ri=class{constructor(L,ne){this.range=L,this.expression=ne}};ri=Ve([z],ri),e.InlineValueEvaluatableExpression=ri;let si=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};si=Ve([z],si),e.InlineValueContext=si;var Bi;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let ki=N=class extends Error{static FileExists(L){return new N(L,S.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(L){return new N(L,S.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(L){return new N(L,S.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(L){return new N(L,S.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(L){return new N(L,S.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(L){return new N(L,S.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(L,ne=S.FileSystemProviderErrorCode.Unknown,Se){super(m.URI.isUri(L)?L.toString(!0):L),this.code=Se?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};ki=N=Ve([z],ki),e.FileSystemError=ki;let Zt=class{constructor(L,ne,Se){this.start=L,this.end=ne,this.kind=Se}};Zt=Ve([z],Zt),e.FoldingRange=Zt;var zi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $i;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})($i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Wi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Wi=e.CommentMode||(e.CommentMode={}));var mi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class Hi{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Hi;function Vi(x){return typeof x>"u"||(0,D.isStringArray)(x)}class Ti{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Se=L.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Se=L.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Se,je,Ye){if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(L,ne,Se,je,Ye);if(le.isRange(L)&&typeof ne=="string"&&Vi(Se))return this._push(L,ne,Se);throw(0,T.illegalArgument)()}_push(L,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,ht=this._tokenTypeStrToInt.get(ne);let Lt=0;if(Se)for(const Wt of Se){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this._tokenModifierStrToInt.get(Wt);Lt|=1<<qt>>>0}this._pushEncoded(je,Ye,ot,ht,Lt)}_pushEncoded(L,ne,Se,je,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Wt=0,qt=0;for(let Xt=0;Xt<Lt;Xt++){let ei=this._data[5*Xt],Pi=this._data[5*Xt+1];ei===0?(ei=Wt,Pi+=qt):ei+=Wt,this._data[5*Xt]=ei,this._data[5*Xt+1]=Pi,Wt=ei,qt=Pi}}let ot=L,ht=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=je,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){const ne=[],Se=L.length/5|0;for(let ht=0;ht<Se;ht++)ne[ht]=ht;ne.sort((ht,Lt)=>{const Wt=L[5*ht],qt=L[5*Lt];if(Wt===qt){const Xt=L[5*ht+1],ei=L[5*Lt+1];return Xt-ei}return Wt-qt});const je=new Uint32Array(L.length);let Ye=0,ot=0;for(let ht=0;ht<Se;ht++){const Lt=5*ne[ht],Wt=L[Lt+0],qt=L[Lt+1],Xt=L[Lt+2],ei=L[Lt+3],Pi=L[Lt+4],dn=Wt-Ye,Nn=dn===0?qt-ot:qt,Ai=5*ht;je[Ai+0]=dn,je[Ai+1]=Nn,je[Ai+2]=Xt,je[Ai+3]=ei,je[Ai+4]=Pi,Ye=Wt,ot=qt}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new oi(new Uint32Array(this._data),L):new oi(Ti._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Ti;class oi{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=oi;class Fi{constructor(L,ne,Se){this.start=L,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=Fi;class Mi{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=Mi;var Ne;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Ne=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new Vt("arrow-left")},Bt=Ve([z],Bt),e.QuickInputButtons=Bt;var Ni;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var pt;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(pt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(L){if(typeof L.badge=="string"){let ne=(0,P.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,P.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Vt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,Se){this.badge=L,this.tooltip=ne,this.color=Se}}e.FileDecoration=qi;let gi=class{constructor(L){this.kind=L}};gi=Ve([z],gi),e.ColorTheme=gi;var Ki;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,ne){if(L<0)throw(0,T.illegalArgument)("start must be positive");if(ne<0)throw(0,T.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}with(L){let ne=this._start,Se=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Se=L.end),ne===this._start&&Se===this._end?this:new zt(ne,Se)}}e.NotebookRange=zt;class pi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>pi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,Se,je,Ye,ot,ht){this.kind=L,this.value=ne,this.languageId=Se,this.mime=je,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ht,pi.validate(this)}}e.NotebookCellData=pi;class Gi{constructor(L){this.cells=L}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(L){return L instanceof $t?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return $t.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return $t.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return $t.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new $t(L,ne)}static text(L,ne=A.Mimes.text){const Se=Fe($t,k,"f",p).encode(String(L));return new $t(Se,ne)}static json(L,ne="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return $t.text(Se,ne)}constructor(L,ne){this.data=L,this.mime=ne;const Se=(0,A.normalizeMimeType)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}k=$t,p={value:new TextEncoder},e.NotebookCellOutputItem=$t;class ai{static isNotebookCellOutput(L){return L instanceof ai?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Se=new Set,je=new Set;for(let Ye=0;Ye<L.length;Ye++){const ot=L[Ye],ht=(0,A.normalizeMimeType)(ot.mime);if(!Se.has(ht)||(0,w.isTextStreamMime)(ht)){Se.add(ht);continue}je.add(Ye),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return je.size===0?L:L.filter((Ye,ot)=>!je.has(ot))}constructor(L,ne,Se){this.items=ai.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,R.generateUuid)(),this.metadata=ne??Se)}}e.NotebookCellOutput=ai;var Xi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ji;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ji=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Zi{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=Zi;var en;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var tn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(tn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class re{constructor(L,ne=[]){this.uri=L,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=re;class he{constructor(L){this.label=L}}e.NotebookKernelSourceAction=he;let Le=class{constructor(L,ne){this.label=L,this.timestamp=ne}};Le=Ve([z],Le),e.TimelineItem=Le;var st;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(st=e.ExtensionMode||(e.ExtensionMode={}));var wt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(wt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pt;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Pt=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=pn;class vn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var En;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(En=e.TestResultState||(e.TestResultState={}));var wn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(wn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(L=void 0,ne=void 0,Se=void 0,je=!1){this.include=L,this.exclude=ne,this.profile=Se,this.continuous=je}};Ui=Ve([z],Ui),e.TestRunRequest=Ui;let nn=class extends Ui{};nn=Ve([z],nn),e.TestRunRequest2=nn;let rn=B=class{static diff(L,ne,Se){const je=new B(L);return je.expectedOutput=ne,je.actualOutput=Se,je}constructor(L){this.message=L}};rn=B=Ve([z],rn),e.TestMessage=rn;let sn=class{constructor(L){this.id=L}};sn=Ve([z],sn),e.TestTag=sn;let vi=class{constructor(L,ne){this.covered=L,this.total=ne}};vi=Ve([z],vi),e.CoveredCount=vi;let on=U=class{static fromDetails(L,ne){const Se=new vi(0,0),je=new vi(0,0),Ye=new vi(0,0);for(const ht of ne)if("branches"in ht){Se.total+=1,Se.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)je.total+=1,je.covered+=Lt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ht.executionCount>0?1:0;const ot=new U(L,Se,je.total>0?je:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ne,ot}constructor(L,ne,Se,je){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=je}};on=U=Ve([z],on),e.FileCoverage=on;let an=class{constructor(L,ne,Se=[]){this.executionCount=L,this.location=ne,this.branches=Se}};an=Ve([z],an),e.StatementCoverage=an;let cn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};cn=Ve([z],cn),e.BranchCoverage=cn;let ln=class{constructor(L,ne){this.executionCount=L,this.location=ne}};ln=Ve([z],ln),e.FunctionCoverage=ln;var bn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var _n;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(_n=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(L,ne,Se,je,Ye,ot){this.kind=L,this.name=ne,this.detail=Se,this.uri=je,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=yn;class Dn{constructor(L){this.uri=L}}e.TextTabInput=Dn;class In{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=In;class Cn{constructor(L,ne,Se,je){this.base=L,this.input1=ne,this.input2=Se,this.result=je}}e.TextMergeTabInput=Cn;class kn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=kn;class Tn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Tn;class Pn{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=Pn;class An{constructor(L,ne,Se){this.original=L,this.modified=ne,this.notebookType=Se}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class On{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.InteractiveWindowInput=On;var Ln;(function(x){x[x.Up=1]="Up",x[x.Down=2]="Down"})(Ln=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Fn;(function(x){x[x.Action=1]="Action",x[x.Toolbar=2]="Toolbar"})(Fn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Mn;(function(x){x[x.Unhelpful=0]="Unhelpful",x[x.Helpful=1]="Helpful",x[x.Undone=2]="Undone"})(Mn=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(Pe[101],Ae([1,0,49,15,13,266,134,7,16]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function R(g,u){u?m.set(g,u):m.delete(g)}e.setWordDefinitionFor=R;function S(g){return m.get(g)}class h extends M.MirrorTextModel{constructor(u,t,a,d,_,k,p,i){super(t,a,d,_),this._proxy=u,this._languageId=k,this._isDirty=p,this.notebook=i,this._isDisposed=!1}dispose(){(0,n.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===T.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},save(){return u._save()},getText(t){return t?u._getTextInRange(t):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(t){return u._lineAt(t)},offsetAt(t){return u._offsetAt(t)},positionAt(t){return u._positionAt(t)},validateRange(t){return u._validateRange(t)},validatePosition(t){return u._validatePosition(t)},getWordRangeAtPosition(t,a){return u._getWordRangeAtPosition(t,a)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,n.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,n.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const t=this._validateRange(u);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const a=this._eol,d=t.start.line,_=t.end.line,k=[];k.push(this._lines[d].substring(t.start.character));for(let p=d+1;p<_;p++)k.push(this._lines[p]);return k.push(this._lines[_].substring(0,t.end.character)),k.join(a)}_lineAt(u){let t;if(u instanceof P.Position?t=u.line:typeof u=="number"&&(t=u),typeof t!="number"||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new w(t,this._lines[t],t===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(u),a=this._lines[t.index].length;return new P.Position(t.index,Math.min(t.remainder,a))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const t=this._validatePosition(u.start),a=this._validatePosition(u.end);return t===u.start&&a===u.end?u:new P.Range(t.line,t.character,a.line,a.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:t,character:a}=u,d=!1;if(t<0)t=0,a=0,d=!0;else if(t>=this._lines.length)t=this._lines.length-1,a=this._lines[t].length,d=!0;else{const _=this._lines[t].length;a<0?(a=0,d=!0):a>_&&(a=_,d=!0)}return d?new P.Position(t,a):u}_getWordRangeAtPosition(u,t){const a=this._validatePosition(u);if(!t)t=S(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const d=(0,A.getWordAtText)(a.character+1,(0,A.ensureValidWordDefinition)(t),this._lines[a.line],0);if(d)return new P.Range(a.line,d.startColumn-1,a.line,d.endColumn-1)}}e.ExtHostDocumentData=h;class w{constructor(u,t,a){this._line=u,this._text=t,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(Pe[200],Ae([1,0,7,18,4]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(P){this._actual=new n.ColorTheme(n.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D;switch(P){case"light":D=n.ColorThemeKind.Light;break;case"hcDark":D=n.ColorThemeKind.HighContrast;break;case"hcLight":D=n.ColorThemeKind.HighContrastLight;break;default:D=n.ColorThemeKind.Dark}this._actual=new n.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=Ve([He(0,T.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Pe[8],Ae([1,0,16,25,118,201,87,28,114,67,66,23,10,2,44,77,92,98,97,73,45,56,197,7]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(De){function Re(q){const{selectionStartLineNumber:Oe,selectionStartColumn:xe,positionLineNumber:Ze,positionColumn:We}=q,et=new l.Position(Oe-1,xe-1),ut=new l.Position(Ze-1,We-1);return new l.Selection(et,ut)}De.to=Re;function me(q){const{anchor:Oe,active:xe}=q;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}De.from=me})(s=e.Selection||(e.Selection={}));var o;(function(De){function Re(q){if(!q)return;const{start:Oe,end:xe}=q;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}De.from=Re;function me(q){if(!q)return;const{startLineNumber:Oe,startColumn:xe,endLineNumber:Ze,endColumn:We}=q;return new l.Range(Oe-1,xe-1,Ze-1,We-1)}De.to=me})(o=e.Range||(e.Range={}));var f;(function(De){function Re(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}De.to=Re})(f=e.TokenType||(e.TokenType={}));var E;(function(De){function Re(q){return new l.Position(q.lineNumber-1,q.column-1)}De.to=Re;function me(q){return{lineNumber:q.line+1,column:q.character+1}}De.from=me})(E=e.Position||(e.Position={}));var r;(function(De){function Re(Oe,xe){return(0,n.coalesce)((0,n.asArray)(Oe).map(Ze=>me(Ze,xe)))}De.from=Re;function me(Oe,xe){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:q(Oe.scheme,xe),pattern:Ee.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function q(Oe,xe){return xe&&typeof Oe=="string"?xe.transformOutgoingScheme(Oe):Oe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(De){function Re(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}De.from=Re;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}De.to=me})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(De){function Re(q){let Oe;return q.code&&((0,h.isString)(q.code)||(0,h.isNumber)(q.code)?Oe=String(q.code):Oe={value:String(q.code.value),target:q.code.target}),{...o.from(q.range),message:q.message,source:q.source,code:Oe,severity:b.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(y.from),tags:Array.isArray(q.tags)?(0,n.coalesce)(q.tags.map(c.from)):void 0}}De.from=Re;function me(q){const Oe=new l.Diagnostic(o.to(q),q.message,b.to(q.severity));return Oe.source=q.source,Oe.code=(0,h.isString)(q.code)?q.code:q.code?.value,Oe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(y.to),Oe.tags=q.tags&&(0,n.coalesce)(q.tags.map(c.to)),Oe}De.to=me})(v=e.Diagnostic||(e.Diagnostic={}));var y;(function(De){function Re(q){return{...o.from(q.location.range),message:q.message,resource:q.location.uri}}De.from=Re;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,o.to(q)),q.message)}De.to=me})(y=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var b;(function(De){function Re(q){switch(q){case l.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}De.from=Re;function me(q){switch(q){case t.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}De.to=me})(b=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var $;(function(De){function Re(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}De.from=Re;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})($=e.ViewColumn||(e.ViewColumn={}));function G(De){return typeof De.range<"u"}function Y(De){return De.length===0?!0:!!G(De[0])}e.isDecorationOptionsArr=Y;var K;(function(De){function Re(We){return We.map(De.from)}De.fromMany=Re;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let et;if(me(We)){const{language:gt,value:Ot}=We;et={value:"```"+gt+`
`+Ot+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const ut=Object.create(null);et.uris=ut;const lt=gt=>{try{let Ot=w.URI.parse(gt,!0);Ot=Ot.with({query:Oe(Ot.query,ut)}),ut[gt]=Ot}catch{}return""},yt=new D.marked.Renderer;return yt.link=lt,yt.image=gt=>typeof gt=="string"?lt(A.parseHrefAndDimensions(gt).href):"",(0,D.marked)(et.value,{renderer:yt}),et}De.from=q;function Oe(We,et){if(!We)return We;let ut;try{ut=(0,m.parse)(We)}catch{}if(!ut)return We;let lt=!1;return ut=(0,S.cloneAndChange)(ut,yt=>{if(w.URI.isUri(yt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[gt]=yt,lt=!0,gt}else return}),lt?JSON.stringify(ut):We}function xe(We){const et=new l.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?w.URI.from(We.baseUri):void 0,et}De.to=xe;function Ze(We){if(!!We)return typeof We=="string"?We:De.from(We)}De.fromStrict=Ze})(K=e.MarkdownString||(e.MarkdownString={}));function N(De){return Y(De)?De.map(Re=>({range:o.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?K.fromMany(Re.hoverMessage):Re.hoverMessage?K.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):De.map(Re=>({range:o.from(Re)}))}e.fromRangeOrRangeWithMessage=N;function B(De){return typeof De>"u"?De:typeof De=="string"?w.URI.file(De):De}e.pathOrURIToURI=B;var U;(function(De){function Re(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?B(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Re})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(De){function Re(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?B(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}De.from=Re})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Re(me){if(typeof me>"u")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Re})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var fe;(function(De){function Re(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?j.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?z.from(me.light):void 0,dark:me.dark?z.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?B(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}De.from=Re})(fe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _e;(function(De){function Re(q){return{text:q.newText,eol:q.newEol&&nt.from(q.newEol),range:o.from(q.range)}}De.from=Re;function me(q){const Oe=new l.TextEdit(o.to(q.range),q.text);return Oe.newEol=typeof q.eol>"u"?void 0:nt.to(q.eol),Oe}De.to=me})(_e=e.TextEdit||(e.TextEdit={}));var ie;(function(De){function Re(q,Oe){const xe={edits:[]};if(q instanceof l.WorkspaceEdit){const Ze=new P.ResourceSet;for(const We of q._allEntries())We._type===1&&w.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of q._allEntries())We._type===1?xe.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?xe.edits.push({resource:We.uri,textEdit:_e.from(We.edit),versionId:Ze.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?xe.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ze.has(We.uri)?void 0:Oe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?xe.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&xe.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Dt.from)}})}return xe}De.from=Re;function me(q){const Oe=new l.WorkspaceEdit;for(const xe of q.edits)xe.textEdit?Oe.replace(w.URI.revive(xe.resource),o.to(xe.textEdit.range),xe.textEdit.text):Oe.renameFile(w.URI.revive(xe.oldResource),w.URI.revive(xe.newResource),xe.options);return Oe}De.to=me})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(De){const Re=Object.create(null);Re[l.SymbolKind.File]=0,Re[l.SymbolKind.Module]=1,Re[l.SymbolKind.Namespace]=2,Re[l.SymbolKind.Package]=3,Re[l.SymbolKind.Class]=4,Re[l.SymbolKind.Method]=5,Re[l.SymbolKind.Property]=6,Re[l.SymbolKind.Field]=7,Re[l.SymbolKind.Constructor]=8,Re[l.SymbolKind.Enum]=9,Re[l.SymbolKind.Interface]=10,Re[l.SymbolKind.Function]=11,Re[l.SymbolKind.Variable]=12,Re[l.SymbolKind.Constant]=13,Re[l.SymbolKind.String]=14,Re[l.SymbolKind.Number]=15,Re[l.SymbolKind.Boolean]=16,Re[l.SymbolKind.Array]=17,Re[l.SymbolKind.Object]=18,Re[l.SymbolKind.Key]=19,Re[l.SymbolKind.Null]=20,Re[l.SymbolKind.EnumMember]=21,Re[l.SymbolKind.Struct]=22,Re[l.SymbolKind.Event]=23,Re[l.SymbolKind.Operator]=24,Re[l.SymbolKind.TypeParameter]=25;function me(Oe){return typeof Re[Oe]=="number"?Re[Oe]:6}De.from=me;function q(Oe){for(const xe in Re)if(Re[xe]===Oe)return Number(xe);return l.SymbolKind.Property}De.to=q})(le=e.SymbolKind||(e.SymbolKind={}));var ce;(function(De){function Re(q){switch(q){case l.SymbolTag.Deprecated:return 1}}De.from=Re;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}De.to=me})(ce=e.SymbolTag||(e.SymbolTag={}));var ke;(function(De){function Re(q){return{name:q.name,kind:le.from(q.kind),tags:q.tags&&q.tags.map(ce.from),containerName:q.containerName,location:X.from(q.location)}}De.from=Re;function me(q){const Oe=new l.SymbolInformation(q.name,le.to(q.kind),q.containerName,X.to(q.location));return Oe.tags=q.tags&&q.tags.map(ce.to),Oe}De.to=me})(ke=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(De){function Re(q){const Oe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:o.from(q.range),selectionRange:o.from(q.selectionRange),kind:le.from(q.kind),tags:q.tags?.map(ce.from)??[]};return q.children&&(Oe.children=q.children.map(Re)),Oe}De.from=Re;function me(q){const Oe=new l.DocumentSymbol(q.name,q.detail,le.to(q.kind),o.to(q.range),o.to(q.selectionRange));return(0,n.isNonEmptyArray)(q.tags)&&(Oe.tags=q.tags.map(ce.to)),q.children&&(Oe.children=q.children.map(me)),Oe}De.to=me})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ae;(function(De){function Re(q){const Oe=new l.CallHierarchyItem(le.to(q.kind),q.name,q.detail||"",w.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Oe._sessionId=q._sessionId,Oe._itemId=q._itemId,Oe}De.to=Re;function me(q,Oe,xe){if(Oe=Oe??q._sessionId,xe=xe??q._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,name:q.name,detail:q.detail,kind:le.from(q.kind),uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(ce.from)}}De.from=me})(ae=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(De){function Re(me){return new l.CallHierarchyIncomingCall(ae.to(me.from),me.fromRanges.map(q=>o.to(q)))}De.to=Re})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(De){function Re(me){return new l.CallHierarchyOutgoingCall(ae.to(me.to),me.fromRanges.map(q=>o.to(q)))}De.to=Re})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var X;(function(De){function Re(q){return{range:q.range&&o.from(q.range),uri:q.uri}}De.from=Re;function me(q){return new l.Location(w.URI.revive(q.uri),o.to(q.range))}De.to=me})(X=e.location||(e.location={}));var pe;(function(De){function Re(q){const Oe=q,xe=q;return{originSelectionRange:Oe.originSelectionRange?o.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:xe.uri,range:o.from(Oe.targetRange?Oe.targetRange:xe.range),targetSelectionRange:Oe.targetSelectionRange?o.from(Oe.targetSelectionRange):void 0}}De.from=Re;function me(q){return{targetUri:w.URI.revive(q.uri),targetRange:o.to(q.range),targetSelectionRange:q.targetSelectionRange?o.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?o.to(q.originSelectionRange):void 0}}De.to=me})(pe=e.DefinitionLink||(e.DefinitionLink={}));var Ce;(function(De){function Re(q){return{range:o.from(q.range),contents:K.fromMany(q.contents)}}De.from=Re;function me(q){return new l.Hover(q.contents.map(K.to),o.to(q.range))}De.to=me})(Ce=e.Hover||(e.Hover={}));var we;(function(De){function Re(q){return{range:o.from(q.range),expression:q.expression}}De.from=Re;function me(q){return new l.EvaluatableExpression(o.to(q.range),q.expression)}De.to=me})(we=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(De){function Re(q){if(q instanceof l.InlineValueText)return{type:"text",range:o.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Re;function me(q){switch(q.type){case"text":return{range:o.to(q.range),text:q.text};case"variable":return{range:o.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:o.to(q.range),expression:q.expression}}}De.to=me})(ve=e.InlineValue||(e.InlineValue={}));var Ie;(function(De){function Re(q){return{frameId:q.frameId,stoppedLocation:o.from(q.stoppedLocation)}}De.from=Re;function me(q){return new l.InlineValueContext(q.frameId,o.to(q.stoppedLocation))}De.to=me})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Re(q){return{range:o.from(q.range),kind:q.kind}}De.from=Re;function me(q){return new l.DocumentHighlight(o.to(q.range),q.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var oe;(function(De){function Re(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}De.to=Re})(oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(De){function Re(me){return{triggerKind:oe.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Re})(Z=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Re(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}De.from=Re;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}De.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(De){const Re=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(xe){return Re.get(xe)??9}De.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Oe(xe){return q.get(xe)??l.CompletionItemKind.Property}De.to=Oe})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Re(me,q){const Oe=new l.CompletionItem(me.label);return Oe.insertText=me.insertText,Oe.kind=F.to(me.kind),Oe.tags=me.tags?.map(I.to),Oe.detail=me.detail,Oe.documentation=A.isMarkdownString(me.documentation)?K.to(me.documentation):me.documentation,Oe.sortText=me.sortText,Oe.filterText=me.filterText,Oe.preselect=me.preselect,Oe.commitCharacters=me.commitCharacters,g.Range.isIRange(me.range)?Oe.range=o.to(me.range):typeof me.range=="object"&&(Oe.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Oe.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Oe.insertText=new l.SnippetString(me.insertText):(Oe.insertText=me.insertText,Oe.textEdit=Oe.range instanceof l.Range?new l.TextEdit(Oe.range,Oe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Oe.additionalTextEdits=me.additionalTextEdits.map(xe=>_e.to(xe))),Oe.command=q&&me.command?q.fromInternal(me.command):void 0,Oe}De.to=Re})(W=e.CompletionItem||(e.CompletionItem={}));var V;(function(De){function Re(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:K.fromStrict(q.documentation)}}De.from=Re;function me(q){return{label:q.label,documentation:A.isMarkdownString(q.documentation)?K.to(q.documentation):q.documentation}}De.to=me})(V=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(De){function Re(q){return{label:q.label,documentation:K.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(V.from):[],activeParameter:q.activeParameter}}De.from=Re;function me(q){return{label:q.label,documentation:A.isMarkdownString(q.documentation)?K.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(V.to):[],activeParameter:q.activeParameter}}De.to=me})(te=e.SignatureInformation||(e.SignatureInformation={}));var ge;(function(De){function Re(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(te.from):[]}}De.from=Re;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(te.to):[]}}De.to=me})(ge=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(De){function Re(me,q){const Oe=new l.InlayHint(E.to(q.position),typeof q.label=="string"?q.label:q.label.map(ue.to.bind(void 0,me)),q.kind&&ye.to(q.kind));return Oe.textEdits=q.textEdits&&q.textEdits.map(_e.to),Oe.tooltip=A.isMarkdownString(q.tooltip)?K.to(q.tooltip):q.tooltip,Oe.paddingLeft=q.paddingLeft,Oe.paddingRight=q.paddingRight,Oe}De.to=Re})(Te=e.InlayHint||(e.InlayHint={}));var ue;(function(De){function Re(me,q){const Oe=new l.InlayHintLabelPart(q.label);return Oe.tooltip=A.isMarkdownString(q.tooltip)?K.to(q.tooltip):q.tooltip,u.Command.is(q.command)&&(Oe.command=me.fromInternal(q.command)),q.location&&(Oe.location=X.to(q.location)),Oe}De.to=Re})(ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ye;(function(De){function Re(q){return q}De.from=Re;function me(q){return q}De.to=me})(ye=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(De){function Re(q){return{range:o.from(q.range),url:q.target,tooltip:q.tooltip}}De.from=Re;function me(q){let Oe;if(q.url)try{Oe=typeof q.url=="string"?w.URI.parse(q.url,!0):w.URI.revive(q.url)}catch{}return new l.DocumentLink(o.to(q.range),Oe)}De.to=me})(be=e.DocumentLink||(e.DocumentLink={}));var ze;(function(De){function Re(q){const Oe=new l.ColorPresentation(q.label);return q.textEdit&&(Oe.textEdit=_e.to(q.textEdit)),q.additionalTextEdits&&(Oe.additionalTextEdits=q.additionalTextEdits.map(xe=>_e.to(xe))),Oe}De.to=Re;function me(q){return{label:q.label,textEdit:q.textEdit?_e.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Oe=>_e.from(Oe)):void 0}}De.from=me})(ze=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(De){function Re(q){return new l.Color(q[0],q[1],q[2],q[3])}De.to=Re;function me(q){return[q.red,q.green,q.blue,q.alpha]}De.from=me})(Ue=e.Color||(e.Color={}));var tt;(function(De){function Re(q){return{range:o.from(q.range)}}De.from=Re;function me(q){return new l.SelectionRange(o.to(q.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(De){function Re(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}De.to=Re})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(De){function Re(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Re;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}De.to=me})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(De){function Re(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}De.from=Re;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}De.to=me})(nt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(De){function Re(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Re})(Me=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(De){function Re(q){const Oe={start:q.start+1,end:q.end+1};return q.kind&&(Oe.kind=Q.from(q.kind)),Oe}De.from=Re;function me(q){const Oe={start:q.start-1,end:q.end-1};return q.kind&&(Oe.kind=Q.to(q.kind)),Oe}De.to=me})(rt=e.FoldingRange||(e.FoldingRange={}));var Q;(function(De){function Re(q){if(q)switch(q){case l.FoldingRangeKind.Comment:return u.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return u.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return u.FoldingRangeKind.Region}}De.from=Re;function me(q){if(q)switch(q.value){case u.FoldingRangeKind.Comment.value:return l.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports.value:return l.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region.value:return l.FoldingRangeKind.Region}}De.to=me})(Q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var J;(function(De){function Re(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Re})(J=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(De){function Re(xe){return xe instanceof l.RelativePattern?xe.toJSON():typeof xe=="string"?xe:me(xe)||q(xe)?new l.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}De.from=Re;function me(xe){const Ze=xe;return Ze?w.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function q(xe){const Ze=xe;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(xe){return typeof xe=="string"?xe:new l.RelativePattern(w.URI.revive(xe.baseUri),xe.pattern)}De.to=Oe})(Ee=e.GlobPattern||(e.GlobPattern={}));var $e;(function(De){function Re(me){if(me){if(Array.isArray(me))return me.map(Re);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:Ee.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}De.from=Re})($e=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(De){function Re(me){switch(me){case 2:return l.NotebookDocumentSaveReason.AfterDelay;case 1:return l.NotebookDocumentSaveReason.Manual;case 3:case 4:return l.NotebookDocumentSaveReason.FocusOut}}De.to=Re})(Be=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var Xe;(function(De){function Re(q){return{start:q.start,end:q.end}}De.from=Re;function me(q){return new l.NotebookRange(q.start,q.end)}De.to=me})(Xe=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(De){function Re(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}De.to=Re;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}De.from=me})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(De){function Re(me){if(me===_.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===_.NotebookCellExecutionState.Pending)return;if(me===_.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Re})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var at;(function(De){function Re(q){switch(q){case l.NotebookCellKind.Markup:return _.CellKind.Markup;case l.NotebookCellKind.Code:default:return _.CellKind.Code}}De.from=Re;function me(q){switch(q){case _.CellKind.Markup:return l.NotebookCellKind.Markup;case _.CellKind.Code:default:return l.NotebookCellKind.Code}}De.to=me})(at=e.NotebookCellKind||(e.NotebookCellKind={}));var St;(function(De){function Re(q){const Oe={metadata:q.metadata??Object.create(null),cells:[]};for(const xe of q.cells)l.NotebookCellData.validate(xe),Oe.cells.push(Dt.from(xe));return Oe}De.from=Re;function me(q){const Oe=new l.NotebookData(q.cells.map(Dt.to));return(0,h.isEmptyObject)(q.metadata)||(Oe.metadata=q.metadata),Oe}De.to=me})(St=e.NotebookData||(e.NotebookData={}));var Dt;(function(De){function Re(q){return{cellKind:at.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Qe.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(vt.from):[]}}De.from=Re;function me(q){return new l.NotebookCellData(at.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(vt.to):void 0,q.metadata,q.internalMetadata?Qe.to(q.internalMetadata):void 0)}De.to=me})(Dt=e.NotebookCellData||(e.NotebookCellData={}));var _t;(function(De){function Re(q){return{mime:q.mime,valueBytes:T.VSBuffer.wrap(q.data)}}De.from=Re;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}De.to=me})(_t=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var vt;(function(De){function Re(q){return{outputId:q.id,items:q.items.map(_t.from),metadata:q.metadata}}De.from=Re;function me(q){const Oe=q.items.map(_t.to);return new l.NotebookCellOutput(Oe,q.outputId,q.metadata)}De.to=me})(vt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ft;(function(De){function Re(Oe){return q(Oe)?{include:(0,h.withNullAsUndefined)(Ee.from(Oe.include)),exclude:(0,h.withNullAsUndefined)(Ee.from(Oe.exclude))}:(0,h.withNullAsUndefined)(Ee.from(Oe))}De.from=Re;function me(Oe){return q(Oe)?{include:Ee.to(Oe.include),exclude:Ee.to(Oe.exclude)}:Ee.to(Oe)}De.to=me;function q(Oe){const xe=Oe;return xe?!(0,h.isUndefinedOrNull)(xe.include)&&!(0,h.isUndefinedOrNull)(xe.exclude):!1}})(Ft=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var At;(function(De){function Re(me,q,Oe){const xe=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(xe,Oe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Re})(At=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Qt;(function(De){function Re(me,q,Oe){const xe=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:q.toInternal(xe,Oe),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}De.from=Re})(Qt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Kt;(function(De){function Re(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Re})(Kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(De){function Re(q){return{uri:q.uri,provides:q.provides}}De.from=Re;function me(q){return new l.NotebookRendererScript(w.URI.revive(q.uri),q.provides)}De.to=me})(dt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(De){function Re(q){return{message:K.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:o.from(q.location.range),uri:q.location.uri}}}De.from=Re;function me(q){const Oe=new l.TestMessage(typeof q.message=="string"?q.message:K.to(q.message));return Oe.actualOutput=q.actual,Oe.expectedOutput=q.expected,Oe.location=q.location?X.to(q.location):void 0,Oe}De.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Rt;(function(De){De.namespace=p.namespaceTestTag,De.denamespace=p.denamespaceTestTag})(Rt=e.TestTag||(e.TestTag={}));var Mt;(function(De){function Re(q){const Oe=(0,a.getPrivateApiFor)(q).controllerId;return{extId:k.TestId.fromExtHostTestItem(q,Oe).toString(),label:q.label,uri:w.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(xe=>Rt.namespace(Oe,xe.id)),range:g.Range.lift(o.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&K.fromStrict(q.error)||null}}De.from=Re;function me(q){return{parent:void 0,error:void 0,id:k.TestId.fromString(q.extId).localId,label:q.label,uri:w.URI.revive(q.uri),tags:(q.tags||[]).map(Oe=>{const{tagId:xe}=Rt.denamespace(Oe);return new l.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}De.toPlain=me})(Mt=e.TestItem||(e.TestItem={})),function(De){function Re(q){return{id:q.id}}De.from=Re;function me(q){return new l.TestTag(q.id)}De.to=me}(Rt=e.TestTag||(e.TestTag={}));var Ct;(function(De){const Re=(q,Oe)=>{const xe=[];for(const[We,et]of Oe)k.TestId.compare(et.item.extId,We)===2&&(Oe.delete(We),xe.push(et));const Ze={...Mt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map(ft.to)})),children:xe.map(We=>Re(We,Oe))};for(const We of Ze.children)We.parent=Ze;return Ze};function me(q){const Oe=[],xe=new Map;for(const Ze of q.items){xe.set(Ze.item.extId,Ze);const We=k.TestId.root(Ze.item.extId);q.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:q.completedAt,results:Oe.map(Ze=>Re(Ze,xe))}}De.to=me})(Ct=e.TestResults||(e.TestResults={}));var mt;(function(De){function Re(xe){return{covered:xe.covered,total:xe.covered}}function me(xe){return"line"in xe?E.from(xe):o.from(xe)}function q(xe){return"branches"in xe?{count:xe.executionCount,location:me(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&me(Ze.location)})):void 0}:{type:0,count:xe.executionCount,location:me(xe.location)}}De.fromDetailed=q;function Oe(xe){return{uri:xe.uri,statement:Re(xe.statementCoverage),branch:xe.branchCoverage&&Re(xe.branchCoverage),function:xe.functionCoverage&&Re(xe.functionCoverage),details:xe.detailedCoverage?.map(q)}}De.fromFile=Oe})(mt=e.TestCoverage||(e.TestCoverage={}));var bt;(function(De){function Re(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}De.to=Re})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xt;(function(De){function Re(q){const Oe=new l.TypeHierarchyItem(le.to(q.kind),q.name,q.detail||"",w.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Oe._sessionId=q._sessionId,Oe._itemId=q._itemId,Oe}De.to=Re;function me(q,Oe,xe){if(Oe=Oe??q._sessionId,xe=xe??q._itemId,Oe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:xe,kind:le.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(ce.from)}}De.from=me})(xt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(De){function Re(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Re})(It=e.ViewBadge||(e.ViewBadge={}));var qe;(function(De){function Re(xe,Ze,We){const et=Ze.fileData;return et?new class extends l.DataTransferItem{asFile(){return{name:et.name,uri:w.URI.revive(et.uri),data:(0,M.once)(()=>We())}}}("",Ze.id):xe===R.Mimes.uriList&&Ze.uriListData?new l.DataTransferItem(Oe(Ze.uriListData)):new l.DataTransferItem(Ze.asString)}De.to=Re;async function me(xe,Ze){const We=await Ze.asString();if(xe===R.Mimes.uriList)return{id:Ze.id,asString:We,fileData:void 0,uriListData:q(We)};const et=Ze.asFile();return{id:Ze.id,asString:We,fileData:et?{name:et.name,uri:et.uri}:void 0}}De.from=me;function q(xe){return C.UriList.split(xe).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return w.URI.parse(Ze)}catch{}return Ze})}function Oe(xe){return C.UriList.create(xe.map(Ze=>typeof Ze=="string"?Ze:w.URI.revive(Ze)))}})(qe=e.DataTransferItem||(e.DataTransferItem={}));var Ht;(function(De){function Re(q,Oe){const xe=q.items.map(([Ze,We])=>[Ze,qe.to(Ze,We,()=>Oe(We.id))]);return new l.DataTransfer(xe)}De.toDataTransfer=Re;async function me(q){const Oe={items:[]},xe=[];return q.forEach((Ze,We)=>{xe.push((async()=>{Oe.items.push([We,await qe.from(We,Ze)])})())}),await Promise.all(xe),Oe}De.toDataTransferDTO=me})(Ht=e.DataTransfer||(e.DataTransfer={}));var Gt;(function(De){function Re(q){return{message:q.message,metadata:q.metadata,title:q.title,tooltip:q.tooltip}}De.to=Re;function me(q){return{kind:"reply",message:q.message,metadata:q.metadata,title:q.title,tooltip:q.tooltip}}De.from=me})(Gt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var Nt;(function(De){function Re(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",args:me.args}:Gt.from(me)}De.from=Re})(Nt=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(Pe[202],Ae([1,0,2,9,7,8,168]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(m,R,S,h={timeout:1500,errors:3}){this._logService=m,this._documents=R,this._mainThreadBulkEdits=S,this._thresholds=h,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(m){return(R,S,h)=>{const g={dispose:this._callbacks.push([R,S,m])};return Array.isArray(h)&&h.push(g),g}}async $participateInSave(m,R){const S=n.URI.revive(m);let h=!1;const w=setTimeout(()=>h=!0,this._thresholds.timeout),g=[];try{for(const u of[...this._callbacks]){if(h)break;const t=this._documents.getDocument(S),a=await this._deliverEventAsyncAndBlameBadListeners(u,{document:t,reason:M.TextDocumentSaveReason.to(R)});g.push(a)}}finally{clearTimeout(w)}return g}_deliverEventAsyncAndBlameBadListeners([m,R,S],h){const w=this._badListeners.get(m);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,m,R,h).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const u=this._badListeners.get(m);this._badListeners.set(m,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(m,R,S,h){const w=[],g=Date.now(),{document:u,reason:t}=h,{version:a}=u,d=Object.freeze({document:u,reason:t,waitUntil(_){if(Object.isFrozen(w))throw(0,T.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(_))}});try{R.apply(S,[d])}catch(_){return Promise.reject(_)}return Object.freeze(w),new Promise((_,k)=>{const p=setTimeout(()=>k(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(p),_(i)}).catch(i=>{clearTimeout(p),k(i)})}).then(_=>{const k={edits:[]};for(const p of _)if(Array.isArray(p)&&p.every(i=>i instanceof C.TextEdit))for(const{newText:i,newEol:l,range:s}of p)k.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:s&&M.Range.from(s),text:i,eol:l&&M.EndOfLine.from(l)}});if(k.edits.length!==0)return a===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(k):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Pe[203],Ae([1,0,15,2,8,7,73]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(S,h,w,g){this.start=S,this.deletedCount=h,this.deletedItems=w,this.items=g}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,h,w){this.notebook=S,this._extHostDocument=h,this._cellData=w,this.handle=w.handle,this.uri=T.URI.revive(w.uri),this.cellKind=w.cellKind,this._outputs=w.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=w.internalMetadata??{},this._metadata=Object.freeze(w.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return S._mime},set mime(g){S._mime=g},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(w)}return this._apiCell}setOutputs(S){this._outputs=S.map(C.NotebookCellOutput.to)}setOutputItems(S,h,w){const g=w.map(C.NotebookCellOutputItem.to),u=this._outputs.find(t=>t.id===S);if(u&&(h||(u.items.length=0),u.items.push(...g),u.items.length>1&&u.items.every(t=>A.isTextStreamMime(t.mime)))){const t=new Map,a=[];u.items.forEach(d=>{let _;t.has(d.mime)?_=t.get(d.mime):(_=[],t.set(d.mime,_),a.push(d.mime)),_.push(d.data)}),u.items.length=0,a.forEach(d=>{const _=A.compressOutputItemStreams(t.get(d));u.items.push({mime:d,data:_.buffer})})}}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=D;class m{constructor(S,h,w,g,u){this._proxy=S,this._textDocumentsAndEditors=h,this._textDocuments=w,this.uri=g,this.handle=m._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0,void 0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,h={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===n.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(w){return w=S._validateIndex(w),S._cells[w].apiCell},getCells(w){return(w?S._getCells(w):S._cells).map(u=>u.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(h)}return this._notebook}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,h,w){this._versionId=S.versionId,this._isDirty=h,this.acceptDocumentPropertiesChanged({metadata:w});const g={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},u=[];for(const a of S.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,g.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this._moveCells(a.index,a.length,a.newIdx,g.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),u.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),u.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),u.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),u.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),u.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<u.length;a++){const d=u[a],_=t.get(d.cell);if(_===void 0){const k=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});t.set(d.cell,k-1)}else g.cellChanges[_]={...g.cellChanges[_],...d}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let h=S.start|0,w=S.end|0;return h<0&&(h=0),w>this._cells.length&&(w=this._cells.length),S.with({start:h,end:w})}_getCells(S){S=this._validateRange(S);const h=[];for(let w=S.start;w<S.end;w++)h.push(this._cells[w]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,h,w){if(this._disposed)return;const g=[],u=[],t=[];if(S.reverse().forEach(a=>{const _=a[2].map(i=>{const l=new D(this,this._textDocumentsAndEditors,i);return h||u.push(D.asModelAddData(this.apiNotebook,i)),l}),k=new P(a[0],a[1],[],_),p=this._cells.splice(a[0],a[1],..._);for(const i of p)t.push(i.uri),k.deletedItems.push(i.apiCell);g.push(k)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:t}),w)for(const a of g)w.push(a.asApiEvent())}_moveCells(S,h,w,g){const u=this._cells.splice(S,h);this._cells.splice(w,0,...u);const t=[new P(S,h,u.map(a=>a.apiCell),[]),new P(w,0,[],u)];for(const a of t)g.push(a.asApiEvent())}_setCellOutputs(S,h){this._cells[S].setOutputs(h)}_setCellOutputItems(S,h,w,g){this._cells[S].setOutputItems(h,w,g)}_changeCellLanguage(S,h){const w=this._cells[S];w.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelLanguageChanged(w.uri,h)}_changeCellMime(S,h){const w=this._cells[S];w.apiCell.mime=h}_changeCellMetadata(S,h){this._cells[S].setMetadata(h)}_changeCellInternalMetadata(S,h){this._cells[S].setInternalMetadata(h)}getCellFromApiCell(S){return this._cells.find(h=>h.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(h=>h.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}m._handlePool=0,e.ExtHostNotebookDocument=m}),define(Pe[204],Ae([1,0,4,2,8,7]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(D,m,R,S={timeout:1500,errors:3}){this._logService=D,this._notebooksAndEditors=m,this._mainThreadBulkEdits=R,this._thresholds=S,this._onWillSaveNotebookDocumentEvent=new n.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(m,R,S)=>{const h=function(g){m.call(R,g)};return h.extension=D,this._onWillSaveNotebookDocumentEvent.event(h,void 0,S)}}async $participateInSave(D,m,R){const S=T.URI.revive(D),h=this._notebooksAndEditors.getNotebookDocument(S);if(!h)throw new Error("Unable to resolve notebook document");const w=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({document:h.apiNotebook,reason:C.NotebookDocumentSaveReason.to(m)},R,async(u,t)=>{const a=Date.now(),d=await await Promise.resolve(u);if(Date.now()-a>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&d&&Array.isArray(d))for(const _ of d)_ instanceof M.WorkspaceEdit?w.push(_):this._logService.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data")}),R.isCancellationRequested)return!1;if(w.length===0)return!0;const g={edits:[]};for(const u of w){const{edits:t}=C.WorkspaceEdit.from(u);g.edits=g.edits.concat(t)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Pe[102],Ae([1,0,9,8,7]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(P,D,m,R,S,h){this.id=P,this._proxy=D,this.notebookData=m,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=S,this._visibleRanges=R,this._viewColumn=h}get apiEditor(){if(!this._editor){const P=this;this._editor={get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(D){this.selections=[D]},get selections(){return P._selections},set selections(D){if(!Array.isArray(D)||!D.every(C.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");P._selections=D,P._trySetSelections(D)},get visibleRanges(){return P._visibleRanges},revealRange(D,m){P._proxy.$tryRevealRange(P.id,T.NotebookRange.from(D),m??C.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(T.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Pe[205],Ae([1,0,9,4,14,8]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(D,m){this._logService=D,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new T.Emitter({onListenerError:n.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(D,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,m);const R=this._notebooksAndEditors.getEditorById(D);m.visibleRanges&&R._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&R._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const m in D)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(D[m]))}};A=Ve([He(0,C.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Pe[206],Ae([1,0,8,172,148,21,65,9]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(h){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=h}async withProgress(h,w,g){const u=this._handles++,{title:t,location:a,cancellable:d}=w,_={label:(0,C.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this._proxy.$startProgress(u,{location:n.ProgressLocation.from(a),title:t,source:_,cancellable:d},h.isUnderDevelopment?void 0:h.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(u,g,!!d)}_withProgress(h,w,g){let u;g&&(u=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(h,u));const t=d=>{this._proxy.$progressEnd(d),this._mapHandleToCancellationSource.delete(d),u?.dispose()};let a;try{a=w(new R(this._proxy,h),g&&u?u.token:M.CancellationToken.None)}catch(d){throw t(h),d}return a.then(d=>t(h),d=>t(h)),a}$acceptProgressCanceled(h){const w=this._mapHandleToCancellationSource.get(h);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(h))}}e.ExtHostProgress=D;function m(S,h){return S.message=h.message,typeof h.increment=="number"&&(typeof S.increment=="number"?S.increment+=h.increment:S.increment=h.increment),S}class R extends T.Progress{constructor(h,w){super(g=>this.throttledReport(g)),this._proxy=h,this._handle=w}throttledReport(h){this._proxy.$progressReport(this._handle,h)}}Ve([(0,A.throttle)(100,(S,h)=>m(S,h),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Pe[103],Ae([1,0,44,98,45,74,56,8,2]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(_,k,p,i)=>{let l=k;return{enumerable:!0,configurable:!1,get(){return l},set(s){if(!p(l,s)){const o=l;l=s,_.listener?.(i(s,o))}}}},R=(_,k)=>_===k,S={range:(_,k)=>_===k?!0:!_||!k?!1:_.isEqual(k),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(_,k)=>!(_.length!==k.length||_.some(p=>!k.find(i=>p.id===i.id)))},h=_=>k=>({op:4,update:_(k)}),w=(_,k)=>({range:(()=>{let p;const i=h(l=>({range:n.Range.lift(P.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return p},set(l){_.listener?.({op:6}),S.range(p,l)||(p=l,_.listener?.(i(l)))}}})(),label:m(_,k,S.label,h(p=>({label:p}))),description:m(_,void 0,S.description,h(p=>({description:p}))),sortText:m(_,void 0,S.sortText,h(p=>({sortText:p}))),canResolveChildren:m(_,!1,S.canResolveChildren,p=>({op:2,state:p})),busy:m(_,!1,S.busy,h(p=>({busy:p}))),error:m(_,void 0,S.error,h(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:m(_,[],S.tags,(p,i)=>({op:1,new:p.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),g=_=>{const k=C.TestId.fromString(_.extId),p=new t(k.controllerId,k.localId,_.label,D.URI.revive(_.uri)||void 0);return p.range=P.Range.to(_.range||void 0),p.description=_.description||void 0,p.sortText=_.sortText||void 0,p.tags=_.tags.map(i=>P.TestTag.to({id:(0,A.denamespaceTestTag)(i).tagId})),p},u=_=>{let k;for(const p of _.tests){const i=g(p.item);(0,T.getPrivateApiFor)(i).parent=k,k=i}return k};e.toItemFromContext=u;class t{constructor(k,p,i,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,T.createPrivateApiFor)(this,k);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,M.createTestItemChildren)(s,T.getPrivateApiFor,t),enumerable:!0,writable:!1},...w(s,i)})}}e.TestItemImpl=t;class a extends t{constructor(k,p){super(k,k,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class d extends M.TestItemCollection{constructor(k,p,i){super({controllerId:k,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:T.getPrivateApiFor,getChildren:l=>l.children,root:new a(k,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Pe[104],Ae([1,0,49,9,84,8,7]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(h,w,g){const u=P._Keys.nextId();h.$registerTextEditorDecorationType(w.identifier,u,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:u,dispose(){h.$removeTextEditorDecorationType(u)}})}}P._Keys=new C.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class D{constructor(h,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,w){this._throwIfFinalized();let g=null;if(h instanceof A.Position)g=new A.Range(h,h);else if(h instanceof A.Range)g=h;else throw new Error("Unrecognized location");this._pushEdit(g,w,!1)}insert(h,w){this._throwIfFinalized(),this._pushEdit(new A.Range(h,h),w,!0)}delete(h){this._throwIfFinalized();let w=null;if(h instanceof A.Range)w=h;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(h,w,g){const u=this._document.validateRange(h);this._collectedEdits.push({range:u,text:w,forceMoveMarkers:g})}setEndOfLine(h){if(this._throwIfFinalized(),h!==A.EndOfLine.LF&&h!==A.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=h}}class m{constructor(h,w,g,u){this._proxy=h,this._id=w,this._accept(g),this._logService=u;const t=this;this.value={get tabSize(){return t._tabSize},set tabSize(a){t._setTabSize(a)},get indentSize(){return t._indentSize},set indentSize(a){t._setIndentSize(a)},get insertSpaces(){return t._insertSpaces},set insertSpaces(a){t._setInsertSpaces(a)},get cursorStyle(){return t._cursorStyle},set cursorStyle(a){t._setCursorStyle(a)},get lineNumbers(){return t._lineNumbers},set lineNumbers(a){t._setLineNumbers(a)}}}_accept(h){this._tabSize=h.tabSize,this._indentSize=h.indentSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const w=Math.floor(h);return w>0?w:null}if(typeof h=="string"){const w=parseInt(h,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(h){const w=this._validateTabSize(h);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateIndentSize(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const w=Math.floor(h);return w>0?w:null}if(typeof h=="string"){const w=parseInt(h,10);return isNaN(w)?null:w>0?w:null}return null}_setIndentSize(h){const w=this._validateIndentSize(h);if(w!==null){if(typeof w=="number"){if(this._indentSize===w)return;this._indentSize=w}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:w}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const w=this._validateInsertSpaces(h);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const w={};let g=!1;if(typeof h.tabSize<"u"){const u=this._validateTabSize(h.tabSize);u==="auto"?(g=!0,w.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,g=!0,w.tabSize=u)}if(typeof h.indentSize<"u"){const u=this._validateIndentSize(h.indentSize);u==="tabSize"?(g=!0,w.indentSize=u):typeof u=="number"&&this._indentSize!==u&&(this._indentSize=u,g=!0,w.indentSize=u)}if(typeof h.insertSpaces<"u"){const u=this._validateInsertSpaces(h.insertSpaces);u==="auto"?(g=!0,w.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,g=!0,w.insertSpaces=u)}typeof h.cursorStyle<"u"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,g=!0,w.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,g=!0,w.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(h,w){w.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=m;class R{constructor(h,w,g,u,t,a,d,_){this.id=h,this._proxy=w,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._options=new m(this._proxy,this.id,a,g),this._visibleRanges=d,this._viewColumn=_;const k=this;this.value=Object.freeze({get document(){return u.value},set document(p){throw(0,T.readonly)("document")},get selection(){return k._selections&&k._selections[0]},set selection(p){if(!(p instanceof A.Selection))throw(0,T.illegalArgument)("selection");k._selections=[p],k._trySetSelection()},get selections(){return k._selections},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof A.Selection)))throw(0,T.illegalArgument)("selections");k._selections=p,k._trySetSelection()},get visibleRanges(){return k._visibleRanges},set visibleRanges(p){throw(0,T.readonly)("visibleRanges")},get options(){return k._options.value},set options(p){k._disposed||k._options.assign(p)},get viewColumn(){return k._viewColumn},set viewColumn(p){throw(0,T.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(k._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new D(u.value,i);return p(l),k._applyEdit(l)},insertSnippet(p,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(k._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=k._selections.map(o=>M.Range.from(o));else if(i instanceof A.Position){const{lineNumber:o,column:f}=M.Position.from(i);s=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(i instanceof A.Range)s=[M.Range.from(i)];else{s=[];for(const o of i)if(o instanceof A.Range)s.push(M.Range.from(o));else{const{lineNumber:f,column:E}=M.Position.from(o);s.push({startLineNumber:f,startColumn:E,endLineNumber:f,endColumn:E})}}return w.$tryInsertSnippet(h,u.value.version,p.value,s,l)},setDecorations(p,i){const l=i.length===0;l&&!k._hasDecorationsForKey.has(p.key)||(l?k._hasDecorationsForKey.delete(p.key):k._hasDecorationsForKey.add(p.key),k._runOnProxy(()=>{if(M.isDecorationOptionsArr(i))return w.$trySetDecorations(h,p.key,M.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let o=0,f=i.length;o<f;o++){const E=i[o];s[4*o]=E.start.line+1,s[4*o+1]=E.start.character+1,s[4*o+2]=E.end.line+1,s[4*o+3]=E.end.character+1}return w.$trySetDecorationsFast(h,p.key,s)}}))},revealRange(p,i){k._runOnProxy(()=>w.$tryRevealRange(h,M.Range.from(p),i||A.TextEditorRevealType.Default))},show(p){w.$tryShowEditor(h,M.ViewColumn.from(p))},hide(){w.$tryHideEditor(h)}})}dispose(){(0,n.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,n.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,n.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,n.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,n.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const w=h.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const g=w.edits.map(t=>t.range);g.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=g.length-1;t<a;t++){const d=g[t].end;if(g[t+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=w.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,u,{setEndOfLine:typeof w.setEndOfLine=="number"?M.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=R}),define(Pe[207],Ae([1,0,152,7,22,2,4,6,188,17,7,10,16,8,21,26,121]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(k,p){if((0,S.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let i;return Array.isArray(k.highlights)&&(i=k.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),i=i.length?i:void 0),{label:k.label,highlights:i}}}class d{constructor(p,i,l){this._proxy=p,this.commands=i,this.logService=l,this.treeViews=new Map,this.treeDragAndDropService=new t.TreeViewsDnDService;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:o=>s(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(f=>s(f)?this.convertArgument(f):f):o})}registerTreeDataProvider(p,i,l){const s=this.createTreeView(p,{treeDataProvider:i},l);return{dispose:()=>s.dispose()}}createTreeView(p,i,l){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],o=i.dragAndDropController?.dragMimeTypes??[],f=!!i.dragAndDropController?.handleDrag,E=!!i.dragAndDropController?.handleDrop,r=this.createExtHostTreeView(p,i,l),c=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:f,hasHandleDrop:E});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,u.checkProposedApiEnabled)(l,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(v){r.message=v},get title(){return r.title},set title(v){r.title=v},get description(){return r.description},set description(v){r.description=v},get badge(){return r.badge},set badge(v){v!==void 0&&R.ViewBadge.isViewBadge(v)?r.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(r.badge=void 0)},reveal:(v,y)=>r.reveal(v,y),dispose:async()=>{await c,this.treeViews.delete(p),r.dispose()}}}$getChildren(p,i){const l=this.treeViews.get(p);return l?l.getChildren(i):Promise.reject(new D.NoTreeViewError(p))}async $handleDrop(p,i,l,s,o,f,E,r){const c=this.treeViews.get(p);if(!c)return Promise.reject(new D.NoTreeViewError(p));const v=w.DataTransfer.toDataTransfer(l,async y=>(await this._proxy.$resolveDropFileData(p,i,y)).buffer);return E===p&&r&&await this.addAdditionalTransferItems(v,c,r,o,f),c.onDrop(v,s,o)}async addAdditionalTransferItems(p,i,l,s,o){const f=this.treeDragAndDropService.removeDragOperationTransfer(o);if(f)(await f)?.forEach((E,r)=>{E&&p.set(r,E)});else if(o&&i.handleDrag){const E=i.handleDrag(l,p,s);this.treeDragAndDropService.addDragOperationTransfer(o,E),await E}return p}async $handleDrag(p,i,l,s){const o=this.treeViews.get(p);if(!o)return Promise.reject(new D.NoTreeViewError(p));const f=await this.addAdditionalTransferItems(new T.DataTransfer,o,i,s,l);if(!!f)return w.DataTransfer.toDataTransferDTO(f)}async $hasResolve(p){const i=this.treeViews.get(p);if(!i)throw new D.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,l){const s=this.treeViews.get(p);if(!s)throw new D.NoTreeViewError(p);return s.resolveTreeItem(i,l)}$setExpanded(p,i,l){const s=this.treeViews.get(p);if(!s)throw new D.NoTreeViewError(p);s.setExpanded(i,l)}$setSelection(p,i){const l=this.treeViews.get(p);if(!l)throw new D.NoTreeViewError(p);l.setSelection(i)}$setFocus(p,i){const l=this.treeViews.get(p);if(!l)throw new D.NoTreeViewError(p);l.setFocus(i)}$setVisible(p,i){const l=this.treeViews.get(p);if(!l)throw new D.NoTreeViewError(p);l.setVisible(i)}$changeCheckboxState(p,i){const l=this.treeViews.get(p);if(!l)throw new D.NoTreeViewError(p);l.setCheckboxState(i)}createExtHostTreeView(p,i,l){const s=new _(p,i,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(p,s),s}convertArgument(p){const i=this.treeViews.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=d;class _ extends P.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,S.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,i,l,s,o,f){if(super(),this.viewId=p,this.proxy=l,this.commands=s,this.logService=o,this.extension=f,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,f.contributes&&f.contributes.views)for(const c in f.contributes.views)for(const v of f.contributes.views[c])v.id===p&&(this._title=v.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let E,r;this._register(A.Event.debounce(this._onDidChangeData.event,(c,v)=>(c||(c={message:!1,elements:[]}),v.element!==!1&&(E||(E=new Promise(y=>r=y),this.refreshPromise=this.refreshPromise.then(()=>E)),Array.isArray(v.element)?c.elements.push(...v.element):c.elements.push(v.element)),v.message&&(c.message=!0),c),200,!0)(({message:c,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const y=r;return E=null,this.refresh(v).then(()=>y())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let l=this.getChildrenNodes(p);return l||(l=await this.fetchChildrenNodes(i)),l?l.map(s=>s.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const l=(0,S.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,S.isUndefinedOrNull)(i.focus)?!1:i.focus,o=(0,S.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(f=>this.resolveTreeNode(p,f[f.length-1]).then(E=>this.proxy.$reveal(this.viewId,{item:E.item,parentChain:f.map(r=>r.item)},{select:l,focus:s,expand:o})),f=>this.logService.error(f)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:s,expand:o})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=w.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,i){const l=this.getExtensionElement(p);l&&(i?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(p){(0,h.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async l=>{const s=this.getExtensionElement(l.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:l.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);i.forEach(l=>{l.treeItem.checkboxState=l.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(l=>[l.extensionItem,l.newState])})}async handleDrag(p,i,l){const s=[];for(const o of p){const f=this.getExtensionElement(o);f&&s.push(f)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,i,l),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,i,l){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,p,l):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,i){if(!this.dataProvider.resolveTreeItem)return;const l=this.elements.get(p);if(l){const s=this.nodes.get(l);if(s){const o=await this.dataProvider.resolveTreeItem(s.extensionItem,l,i)??s.extensionItem;return this.validateTreeItem(o),s.item.tooltip=this.getTooltip(o.tooltip),s.item.command=this.getCommand(s.disposableStore,o.command),s.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(i=>i?this.resolveUnknownParentChain(i).then(l=>this.resolveTreeNode(i,l[l.length-1]).then(s=>(l.push(s),l))):Promise.resolve([]))}resolveParent(p){const i=this.nodes.get(p);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,i){const l=this.nodes.get(p);return l?Promise.resolve(l):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(s=>this.createHandle(p,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const f=this.nodes.get(o);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(p){if(p){let i;if(typeof p=="string"){const l=this.getExtensionElement(p);i=l?this.nodes.get(l):void 0}else i=p;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const i=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=p?this.nodes.get(p):void 0,s=await this.dataProvider.getChildren(p);if(i.token.isCancellationRequested)return;const o=await Promise.all((0,h.coalesce)(s||[]).map(async f=>{const E=await this.dataProvider.getTreeItem(f);return E&&!i.token.isCancellationRequested?this.createAndRegisterTreeNode(f,E,l):null}));return i.token.isCancellationRequested?void 0:(0,h.coalesce)(o)}finally{i.dispose()}}refresh(p){if(p.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(p);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const i=new Set,l=p.map(o=>this.nodes.get(o));for(const o of l)if(o&&!i.has(o.item.handle)){let f=o;for(;f&&f.parent&&l.findIndex(E=>f&&f.parent&&E&&E.item.handle===f.parent.item.handle)===-1;){const E=this.elements.get(f.parent.item.handle);f=E?this.nodes.get(E):void 0}f&&!f.parent&&i.add(o.item.handle)}const s=[];return i.forEach(o=>{const f=this.elements.get(o);if(f){const E=this.nodes.get(f);E&&(!E.parent||!i.has(E.parent.item.handle))&&s.push(o)}}),s}refreshHandles(p){const i={};return Promise.all(p.map(l=>this.refreshNode(l).then(s=>{s&&(i[l]=s.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(p){const i=this.getExtensionElement(p);if(i){const l=this.nodes.get(i);if(l)return this.clearChildren(i),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(s=>{if(s){const o=this.createTreeNode(i,s,l.parent);return this.updateNodeCache(i,o,l,l.parent),l.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,i,l){const s=this.createTreeNode(p,i,l);if(i.id&&this.elements.has(s.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.addNodeToCache(p,s),this.addNodeToParentCache(s,l),s}getTooltip(p){return R.MarkdownString.isMarkdownString(p)?w.MarkdownString.from(p):p}getCommand(p,i){return i?{...this.commands.toInternal(i,p),originalId:i.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let i,l;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,l=p.checkboxState.tooltip),{isChecked:i===R.TreeItemCheckboxState.Checked,tooltip:l}}validateTreeItem(p){if(!R.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,i,l){this.validateTreeItem(i);const s=new P.DisposableStore,o=this.createHandle(p,i,l),f=this.getLightIconPath(i);return{item:{handle:o,parentHandle:l?l.item.handle:void 0,label:a(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(s,i.command),contextValue:i.contextValue,icon:f,iconDark:this.getDarkIconPath(i)||f,themeIcon:this.getThemeIcon(i),collapsibleState:(0,S.isUndefinedOrNull)(i.collapsibleState)?R.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:l,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(p){return p.iconPath instanceof R.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:i,label:l,resourceUri:s},o,f){if(i)return`${_.ID_HANDLE_PREFIX}/${i}`;const E=a(l,this.extension),r=o?o.item.handle:_.LABEL_HANDLE_PREFIX;let c=E?E.label:s?(0,C.basename)(s):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const v=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,y=this.getChildrenNodes(o)||[];let b,$=0;do{if(b=`${r}/${$}:${c}`,f||!this.elements.has(b)||v===b)break;$++}while($<=y.length);return b}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof R.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return M.URI.isUri(p)?p:M.URI.file(p)}addNodeToCache(p,i){this.elements.set(i.item.handle,p),this.nodes.set(p,i)}updateNodeCache(p,i,l,s){this.elements.delete(i.item.handle),this.nodes.delete(p),i.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(p,i);const o=this.getChildrenNodes(s)||[],f=o.filter(E=>E.item.handle===l.item.handle)[0];f&&o.splice(o.indexOf(f),1,i)}addNodeToParentCache(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const i=this.nodes.get(p);if(i){if(i.children)for(const l of i.children){const s=this.elements.get(l.item.handle);s&&this.clear(s)}i.children=void 0}}else this.clearAll()}clear(p){const i=this.nodes.get(p);if(i){if(i.children)for(const l of i.children){const s=this.elements.get(l.item.handle);s&&this.clear(s)}this.nodes.delete(p),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(Pe[208],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookDocumentWillSave:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDocumentWillSave.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[209],Ae([1,0,161,9,29,90,71,30,24,208,171,96]),function(ee,e,n,T,C,M,A,P,D,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=P.Registry.as(A.Extensions.JSONContribution);class w{constructor(p,i,l){this._messageHandler=p,this._extension=i,this._extensionPointId=l}_msg(p,i){this._messageHandler({type:p,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(C.default.Error,p)}warn(p){this._msg(C.default.Warning,p)}info(p){this._msg(C.default.Info,p)}}e.ExtensionMessageCollector=w;class g{static _toSet(p){const i=new D.ExtensionIdentifierSet;for(let l=0,s=p.length;l<s;l++)i.add(p[l].description.identifier);return i}static compute(p,i){if(!p||!p.length)return new g(i,[]);if(!i||!i.length)return new g([],p);const l=this._toSet(p),s=this._toSet(i),o=i.filter(E=>!l.has(E.description.identifier)),f=p.filter(E=>!s.has(E.description.identifier));return new g(o,f)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=g;class u{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=g.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,T.onUnexpectedError)(p)}}}e.ExtensionPoint=u;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new u(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,i),p.activationEventsGenerator&&S.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,h.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const _={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(_.ExtensionsRegistry,new d),e.ExtensionsRegistry=P.Registry.as(_.ExtensionsRegistry),h.registerSchema(a,e.schema),h.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Pe[210],Ae([1,0,158,10,23,209,31,4]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var m;(function(h){function w(g,u,t){if(!g)return;const a=T.isString(g.type)?g.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const d=[];if(Array.isArray(g.required))for(const _ of g.required)T.isString(_)&&d.push(_);return{extensionId:u.value,taskType:a,required:d,properties:g.properties?C.deepClone(g.properties):{},when:g.when?A.ContextKeyExpr.deserialize(g.when):void 0}}h.from=w})(m||(m={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,w)=>{for(const g of h)g.type&&w.push(`onTaskType:${g.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:D}});class S{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((w,g)=>{R.setHandler((u,t)=>{this._schema=void 0;try{for(const a of t.removed){const d=a.value;for(const _ of d)this.taskTypes&&_.type&&this.taskTypes[_.type]&&delete this.taskTypes[_.type]}for(const a of t.added){const d=a.value;for(const _ of d){const k=m.from(_,a.description.identifier,a.collector);k&&(this.taskTypes[k.taskType]=k)}}(t.removed.length>0||t.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}w(void 0)})})}onReady(){return this.readyPromise}get(w){return this.taskTypes[w]}all(){return Object.keys(this.taskTypes).map(w=>this.taskTypes[w])}getJsonSchema(){if(this._schema===void 0){const w=[];for(const g of this.all()){const u={type:"object",additionalProperties:!1};g.required.length>0&&(u.required=g.required.slice(0)),g.properties!==void 0?u.properties=C.deepClone(g.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[g.taskType]},w.push(u)}this._schema={oneOf:w}}return this._schema}}e.TaskDefinitionRegistry=new S}),define(Pe[211],Ae([1,0,159,10,22,23,31,210]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var D;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(D=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function U(z){if(!z)return B.Strong;switch(z.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=U}(D=e.ShellQuoting||(e.ShellQuoting={}));var m;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(m=e.CommandOptions||(e.CommandOptions={}));var R;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(B){function U(z){switch(z.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=U}(R=e.RevealKind||(e.RevealKind={}));var S;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(B){function U(z){switch(z.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=U}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(B){function U(z){switch(z.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=U}(h=e.PanelKind||(e.PanelKind={}));var w;(function(B){B.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(w=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(B){function U(j){switch(j.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=U;function z(j){switch(j){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=z}(g=e.RuntimeType||(e.RuntimeType={}));var u;(function(B){function U(z){return T.isString(z)?z:z.value}B.value=U})(u=e.CommandString||(e.CommandString={}));var t;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function U(j){return j===B.Clean._id||j===B.Build._id||j===B.Rebuild._id||j===B.Test._id}B.is=U;function z(j){if(j!==void 0)return T.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}B.from=z})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var d;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function U(z){switch(z){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=U})(d=e.TaskSourceKind||(e.TaskSourceKind={}));var _;(function(B){B.parallel="parallel",B.sequence="sequence"})(_=e.DependsOrder||(e.DependsOrder={}));var k;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(k=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:k.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor(U,z,j,fe,_e,ie){this._label="",this._id=U,z&&(this._label=z),j&&(this.type=j),this.runOptions=fe,this.configurationProperties=_e,this._source=ie}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.getFolderId(),id:this._id};return JSON.stringify(U)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(T.isString(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),U&&(this._taskLoadMessages=this._taskLoadMessages.concat(U))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class l extends i{constructor(U,z,j,fe,_e,ie,le,ce){super(U,j,void 0,le,ce,z),this.command={},this._source=z,this.hasDefinedMatchers=ie,_e&&(this.command=_e)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case g.Shell:z="shell";break;case g.Process:z="process";break;case g.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof l}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(U){return new l(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=l;class s extends i{constructor(U,z,j,fe,_e,ie,le){super(U,j,fe,ie,le,z),this._source=z,this.configures=_e}static is(U){return U instanceof s}fromObject(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.getFolderId();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}}e.ConfiguringTask=s;class o extends i{constructor(U,z,j,fe,_e,ie,le,ce,ke){super(U,j,fe,ce,ke,z),this.defines=_e,this.hasDefinedMatchers=le,this.command=ie,this.icon=ke.icon,this.hide=ke.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof o}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.getFolderId(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(U){return new o(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=o;class f extends i{constructor(U,z,j,fe,_e,ie){super(U,j,fe,_e,ie,z),this._source=z}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(U){return new f(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=f;var E;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(E=e.ExecutionEngine||(e.ExecutionEngine={})),function(B){B._default=B.Terminal}(E=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor(U){this._order=new Map;for(let z=0;z<U.length;z++)this._order.set(U[z].uri.toString(),z)}compare(U,z){const j=U.getWorkspaceFolder(),fe=z.getWorkspaceFolder();if(j&&fe){let _e=this._order.get(j.uri.toString());_e=_e===void 0?0:_e+1;let ie=this._order.get(fe.uri.toString());return ie=ie===void 0?0:ie+1,_e===ie?U._label.localeCompare(z._label):_e-ie}else return!j&&fe?-1:j&&!fe?1:0}}e.TaskSorter=c;var v;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(B){B.SingleRun="singleRun",B.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var b;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(b=e.TaskRunSource||(e.TaskRunSource={}));var $;(function(B){function U(z,j,fe,_e){if(j){const ie={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:j};return z==="start"?ie.resolvedVariables=_e:z==="processStarted"?ie.processId=_e:z==="processEnded"&&(ie.exitCode=_e),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}B.create=U})($=e.TaskEvent||(e.TaskEvent={}));var G;(function(B){function U(j){const fe=Object.keys(j).sort();let _e="";for(const ie of fe){let le=j[ie];le instanceof Object?le=U(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),_e+=ie+","+le+","}return _e}function z(j){const _e={_key:U(j),type:j.taskType};return Object.assign(_e,j),_e}B.create=z})(G=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Y;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(Y=e.TaskSettingId||(e.TaskSettingId={}));var K;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(K=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var N;(function(B){function U(z,j){const fe=P.TaskDefinitionRegistry.get(z.type);if(fe===void 0){const ce=M.deepClone(z);return delete ce._key,G.create(ce)}const _e=Object.create(null);_e.type=fe.taskType;const ie=new Set;fe.required.forEach(ce=>ie.add(ce));const le=fe.properties;for(const ce of Object.keys(le)){const ke=z[ce];if(ke!=null)_e[ce]=ke;else if(ie.has(ce)){const de=le[ce];if(de.default!==void 0)_e[ce]=M.deepClone(de.default);else switch(de.type){case"boolean":_e[ce]=!1;break;case"number":case"integer":_e[ce]=0;break;case"string":_e[ce]="";break;default:j.error(n.localize(2,null,JSON.stringify(z,void 0,0),ce));return}}}return G.create(_e)}B.createTaskIdentifier=U})(N=e.TaskDefinition||(e.TaskDefinition={}))}),define(Pe[212],Ae([1,0,9]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,P)=>{this._actualOk=A,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,n.onUnexpectedError)(A))}then(A,P){return this._ensureActual().then(A,P)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T;class C extends T{constructor(){super(),this._hasErr=!0,this._err=new n.CancellationError}}e.CanceledLazyPromise=C}),define(Pe[46],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const T=[];function C(P){const D=new n(P);return T[D.nid]=D,D}e.createProxyIdentifier=C;function M(P){return T[P].sid}e.getStringIdentifierForProxy=M;class A{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=A}),define(Pe[5],Ae([1,0,46]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var M;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var A;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var m;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(m=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(t){return t._id=S._n++,t}}S._n=0,e.IdObject=S;var h;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Pe[78],Ae([1,0,3,14,5,18]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(D,m){this._extHostLogService=m,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,m,R){const S=this.getUsageKey(D,m);this._reportedUsages.has(S)||(this._reportedUsages.add(S),m.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:D}))}getUsageKey(D,m){return`${D}-${m.identifier.value}`}};A=Ve([He(0,M.IExtHostRpcService),He(1,T.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,m){}})}),define(Pe[213],Ae([1,0,4,5,7,24]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(m){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new n.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new P,this._getSessionsTaskSingler=new P,this._proxy=m.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(m){return this._providers=m,Promise.resolve()}async getSession(m,R,S,h={}){const w=M.ExtensionIdentifier.toKey(m.identifier),g=[...S].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${w} ${R} ${g}`,async()=>{await this._proxy.$ensureProvider(R);const u=m.displayName||m.name;return this._proxy.$getSession(R,S,w,u,h)})}async getSessions(m,R,S){const h=M.ExtensionIdentifier.toKey(m.identifier),w=[...S].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${h} ${w}`,async()=>{await this._proxy.$ensureProvider(R);const g=m.displayName||m.name;return this._proxy.$getSessions(R,S,h,g)})}async removeSession(m,R){const S=this._authenticationProviders.get(m);return S?S.provider.removeSession(R):this._proxy.$removeSession(m,R)}registerAuthenticationProvider(m,R,S,h){if(this._authenticationProviders.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this._authenticationProviders.set(m,{label:R,provider:S,options:h??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===m)||this._providers.push({id:m,label:R});const w=S.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(m,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(m,R,h?.supportsMultipleAccounts??!1),new C.Disposable(()=>{w.dispose(),this._authenticationProviders.delete(m);const g=this._providers.findIndex(u=>u.id===m);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(m)})}$createSession(m,R){const S=this._authenticationProviders.get(m);if(S)return Promise.resolve(S.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,R){const S=this._authenticationProviders.get(m);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,R){const S=this._authenticationProviders.get(m);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,R){return this._onDidChangeSessions.fire({provider:{id:m,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=A;class P{constructor(){this._inFlightPromises=new Map}getOrCreate(m,R){const S=this._inFlightPromises.get(m);if(S)return S;const h=R().finally(()=>this._inFlightPromises.delete(m));return this._inFlightPromises.set(m,h),h}}}),define(Pe[214],Ae([1,0,5,18,8]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(P,D){this._proxy=P.getProxy(n.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:m=>D.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,D,m){const R=C.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,m?.isRefactoring??!1)}};M=Ve([He(0,T.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Pe[215],Ae([1,0,5]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(M){const A=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[38],Ae([1,0,10,7,8,23,5,16,14,67,44,267,2,6,3,18,103,25,46,40,58,52,57]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i){"use strict";var l,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(b,$,G){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,s.set(this,void 0),o.set(this,void 0),Je(this,l,b.getProxy(A.MainContext.MainThreadCommands),"f"),this._logService=$,Je(this,o,G,"f"),Je(this,s,b.getProxy(A.MainContext.MainThreadTelemetry),"f"),this.converter=new E(this,Y=>{const K=this._apiCommands.get(Y);return K?.result===c.Void?K:void 0},$),this._argumentProcessors=[{processArgument(Y){return(0,m.revive)(Y)}},{processArgument(Y){return(0,M.cloneAndChange)(Y,function(K){if(R.Range.isIRange(K))return C.Range.to(K);if(S.Position.isIPosition(K))return C.Position.to(K);if(R.Range.isIRange(K.range)&&h.URI.isUri(K.uri))return C.location.to(K);if(K instanceof a.VSBuffer)return K.buffer.buffer;if(!Array.isArray(K))return K})}}]}registerArgumentProcessor(b){this._argumentProcessors.push(b)}registerApiCommand(b){const $=this.registerCommand(!1,b.id,async(...G)=>{const Y=b.args.map((N,B)=>{if(!N.validate(G[B]))throw new Error(`Invalid argument '${N.name}' when running '${b.id}', received: ${G[B]}`);return N.convert(G[B])}),K=await this.executeCommand(b.internalId,...Y);return b.result.convert(K,G,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this._apiCommands.set(b.id,b),new T.Disposable(()=>{$.dispose(),this._apiCommands.delete(b.id)})}registerCommand(b,$,G,Y,K,N){if(this._logService.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this._commands.has($))throw new Error(`command '${$}' already exists`);return this._commands.set($,{callback:G,thisArg:Y,description:K,extension:N}),b&&Fe(this,l,"f").$registerCommand($),new T.Disposable(()=>{this._commands.delete($)&&b&&Fe(this,l,"f").$unregisterCommand($)})}executeCommand(b,...$){return this._logService.trace("ExtHostCommands#executeCommand",b),this._doExecuteCommand(b,$,!0)}async _doExecuteCommand(b,$,G){if(this._commands.has(b))return Fe(this,l,"f").$fireCommandActivationEvent(b),this._executeContributedCommand(b,$,!1);{let Y=!1;const K=(0,M.cloneAndChange)($,function(N){if(N instanceof T.Position)return C.Position.from(N);if(N instanceof T.Range)return C.Range.from(N);if(N instanceof T.Location)return C.location.from(N);if(T.NotebookRange.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return Y=!0,a.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return Y=!0,a.VSBuffer.wrap(N);if(N instanceof a.VSBuffer)return Y=!0,N;if(!Array.isArray(N))return N});try{const N=await Fe(this,l,"f").$executeCommand(b,Y?new d.SerializableObjectWithBuffers(K):K,G);return(0,m.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(b,$,!1);throw N}}}async _executeContributedCommand(b,$,G){const Y=this._commands.get(b);if(!Y)throw new Error("Unknown command");const{callback:K,thisArg:N,description:B}=Y;if(B)for(let z=0;z<B.args.length;z++)try{(0,n.validateConstraint)($[z],B.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${B.args[z].name}' - ${B.args[z].description}`)}const U=k.StopWatch.create();try{return await K.apply(N,$)}catch(z){if(b===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(b=j.command)}if(this._logService.error(z,b,Y.extension?.identifier),!G)throw z;if(Y.extension?.identifier){const j=Fe(this,o,"f").onExtensionError(Y.extension.identifier,z);this._logService.trace("forwarded error to extension?",j,Y.extension?.identifier)}throw new class extends Error{constructor(){super((0,_.toErrorMessage)(z)),this.id=b,this.source=Y.extension?.displayName??Y.extension?.name}}}finally{this._reportTelemetry(Y,b,U.elapsed())}}_reportTelemetry(b,$,G){!b.extension||Fe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new p.TelemetryTrustedValue($),duration:G})}$executeContributedCommand(b,...$){this._logService.trace("ExtHostCommands#$executeContributedCommand",b);const G=this._commands.get(b);return G?($=$.map(Y=>this._argumentProcessors.reduce((K,N)=>N.processArgument(K,G.extension?.identifier),Y)),this._executeContributedCommand(b,$,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this._logService.trace("ExtHostCommands#getCommands",b),Fe(this,l,"f").$getCommands().then($=>(b&&($=$.filter(G=>G[0]!=="_")),$))}$getContributedCommandHandlerDescriptions(){const b=Object.create(null);for(const[$,G]of this._commands){const{description:Y}=G;Y&&(b[$]=Y)}return Promise.resolve(b)}};l=new WeakMap,s=new WeakMap,o=new WeakMap,f=Ve([He(0,u.IExtHostRpcService),He(1,D.ILogService),He(2,i.IExtHostTelemetry)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class E{constructor(b,$,G){this._commands=b,this._lookupApiCommand=$,this._logService=G,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(b,$){if(!b)return;const G={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return G;const Y=this._lookupApiCommand(b.command);if(Y)G.id=Y.internalId,G.arguments=Y.args.map((K,N)=>K.convert(b.arguments&&b.arguments[N]));else if((0,P.isNonEmptyArray)(b.arguments)){const K=`${b.command}/${++this._cachIdPool}`;this._cache.set(K,b),$.add((0,w.toDisposable)(()=>{this._cache.delete(K),this._logService.trace("CommandsConverter#DISPOSE",K)})),G.$ident=K,G.id=this.delegatingCommandId,G.arguments=[K],this._logService.trace("CommandsConverter#CREATE",b.command,K)}return G}fromInternal(b){return typeof b.$ident=="string"?this._cache.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this._cache.get(b[0])}_executeConvertedCommand(...b){const $=this.getActualCommand(...b);return this._logService.trace("CommandsConverter#EXECUTE",b[0],$?$.command:"MISSING"),$?this._commands.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.CommandsConverter=E;class r{constructor(b,$,G,Y){this.name=b,this.description=$,this.validate=G,this.convert=Y}optional(){return new r(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,$){return new r(b??this.name,$??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",y=>h.URI.isUri(y),y=>y),r.Position=new r("position","A position in a text document",y=>T.Position.isPosition(y),C.Position.from),r.Range=new r("range","A range in a text document",y=>T.Range.isRange(y),C.Range.from),r.Selection=new r("selection","A selection in a text document",y=>T.Selection.isSelection(y),C.Selection.from),r.Number=new r("number","",y=>typeof y=="number",y=>y),r.String=new r("string","",y=>typeof y=="string",y=>y),r.CallHierarchyItem=new r("item","A call hierarchy item",y=>y instanceof T.CallHierarchyItem,C.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",y=>y instanceof T.TypeHierarchyItem,C.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",y=>y instanceof t.TestItemImpl,C.TestItem.from),e.ApiCommandArgument=r;class c{constructor(b,$){this.description=b,this.convert=$}}c.Void=new c("no result",y=>y),e.ApiCommandResult=c;class v{constructor(b,$,G,Y,K){this.id=b,this.internalId=$,this.description=G,this.args=Y,this.result=K}}e.ApiCommand=v}),define(Pe[216],Ae([1,0,16,15,2,77,89,31,93,38,8,7]),function(ee,e,n,T,C,M,A,P,D,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const h=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(R.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,n.isFalsyOrEmpty)(t))return;class d extends S.SymbolInformation{static to(k){const p=new d(k.name,R.SymbolKind.to(k.kind),k.containerName||"",new S.Location(a[0],R.Range.to(k.range)));return p.detail=k.detail,p.range=p.location.range,p.selectionRange=R.Range.to(k.selectionRange),p.children=k.children?k.children.map(d.to):[],p}}return t.map(d.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",u)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(R.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(R.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>S.Position.isPosition(a)),t=>t.map(R.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let d;for(const _ of a.reverse())d=new S.SelectionRange(R.Range.to(_),d);return d}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:R.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,A.decodeSemanticTokensDto)(t);if(a.type==="full")return new S.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new S.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,A.decodeSemanticTokensDto)(t);if(a.type==="full")return new S.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,d)=>{if(!t)return new S.CompletionList([]);const _=t.suggestions.map(k=>R.CompletionItem.to(k,d));return new S.CompletionList(_,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,d)=>g(_=>new S.CodeLens(R.Range.to(_.range),_.command&&d.fromInternal(_.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.Range.isRange(t),t=>S.Selection.isSelection(t)?R.Selection.from(t):R.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,d)=>g(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(_.command)}else{const k=new S.CodeAction(_.title,_.kind?new S.CodeActionKind(_.kind):void 0);return _.edit&&(k.edit=R.WorkspaceEdit.to(_.edit)),_.command&&(k.command=d.fromInternal(_.command)),k.isPreferred=_.isPreferred,k}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new S.ColorInformation(R.Range.to(a.range),R.Color.to(a.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof S.Color,R.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,d)=>t.map(R.InlayHint.to.bind(void 0,d)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,a)=>{if(t)return t.map(R.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>R.NotebookExclusiveDocumentPattern.to(a))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.matchesSomeScheme)(t,T.Schemas.http,T.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void)];class w{static register(a){h.forEach(a.registerApiCommand,a),this._registerValidateWhenClausesCommand(a)}static _registerValidateWhenClausesCommand(a){a.registerCommand(!1,"_validateWhenClauses",P.validateWhenClauses)}}e.ExtHostApiCommands=w;function g(t){return a=>{if(Array.isArray(a))return a.map(t)}}function u(t){if(!Array.isArray(t))return;const a=[];for(const d of t)M.isLocationLink(d)?a.push(R.DefinitionLink.to(d)):a.push(R.location.to(d));return a}}),define(Pe[217],Ae([1,0,17,65,4,6,2,77,24,8,7,5,26]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function w(g,u,t){const a=g.getProxy(S.MainContext.MainThreadComments);class d{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new D.ExtensionIdentifierMap,u.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===6){const r=this._commentControllers.get(E.handle);return r?r.value:E}else if(E&&E.$mid===7){const r=this._commentControllers.get(E.commentControlHandle);if(!r)return E;const c=r.getCommentThread(E.commentThreadHandle);return c?c.value:E}else if(E&&(E.$mid===9||E.$mid===8)){const r=this._commentControllers.get(E.thread.commentControlHandle);if(!r)return E;const c=r.getCommentThread(E.thread.commentThreadHandle);return c?E.$mid===8?c.value:{thread:c.value,text:E.text}:E}else if(E&&E.$mid===10){const r=this._commentControllers.get(E.thread.commentControlHandle);if(!r)return E;const c=r.getCommentThread(E.thread.commentThreadHandle);if(!c)return E;const v=E.commentUniqueId,y=c.getCommentByUniqueId(v);return y||E}else if(E&&E.$mid===11){const r=this._commentControllers.get(E.thread.commentControlHandle);if(!r)return E;const c=r.getCommentThread(E.thread.commentThreadHandle);if(!c)return E;const v=E.text,y=E.commentUniqueId,b=c.getCommentByUniqueId(y);return b?(typeof b.body=="string"?b.body=v:b.body=new R.MarkdownString(v),b):E}return E}})}createCommentController(E,r,c){const v=d.handlePool++,y=new k(E,v,r,c);this._commentControllers.set(y.handle,y);const b=this._commentControllersByExtension.get(E.identifier)||[];return b.push(y),this._commentControllersByExtension.set(E.identifier,b),y.value}$createCommentThreadTemplate(E,r,c){const v=this._commentControllers.get(E);!v||v.$createCommentThreadTemplate(r,c)}async $updateCommentThreadTemplate(E,r,c){const v=this._commentControllers.get(E);!v||v.$updateCommentThreadTemplate(r,c)}$deleteCommentThread(E,r){this._commentControllers.get(E)?.$deleteCommentThread(r)}$provideCommentingRanges(E,r,c){const v=this._commentControllers.get(E);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=t.getDocument(A.URI.revive(r));return(0,n.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(y,c)).then(b=>b?b.map($=>m.Range.from($)):void 0)}$toggleReaction(E,r,c,v,y){const b=this._commentControllers.get(E);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const $=b.getCommentThread(r);if($){const G=$.getCommentByUniqueId(v.uniqueIdInThread);if(b!==void 0&&G&&b.reactionHandler)return b.reactionHandler(G,l(y))}return Promise.resolve(void 0)})}dispose(){}}d.handlePool=0;class _{set threadId(E){this._id=E}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(E){(E===void 0!=(this._range===void 0)||!E||!this._range||!E.isEqual(this._range))&&(this._range=E,this.modifications.range=E,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(E){this._canReply!==E&&(this._canReply=E,this.modifications.canReply=E,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(E){this._label=E,this.modifications.label=E,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(E){this._contextValue=E,this.modifications.contextValue=E,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(E){this._comments=E,this.modifications.comments=E,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(E){this._collapseState=E,this.modifications.collapsibleState=E,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(E){this._state=E,this.modifications.state=E,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(E,r,c,v,y,b,$,G){this._commentControllerHandle=r,this._id=c,this._uri=v,this._range=y,this._comments=b,this.extensionDescription=$,this._isTemplate=G,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${E}.${this.handle}`),a.$createCommentThread(r,this.handle,this._id,this._uri,m.Range.from(this._range),$.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(r,this.handle)}});const Y=this;this.value={get uri(){return Y.uri},get range(){return Y.range},set range(K){Y.range=K},get comments(){return Y.comments},set comments(K){Y.comments=K},get collapsibleState(){return Y.collapsibleState},set collapsibleState(K){Y.collapsibleState=K},get canReply(){return Y.canReply},set canReply(K){Y.canReply=K},get contextValue(){return Y.contextValue},set contextValue(K){Y.contextValue=K},get label(){return Y.label},set label(K){Y.label=K},get state(){return Y.state},set state(K){Y.state=K},dispose:()=>{Y.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const E=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),r={};E("range")&&(r.range=m.Range.from(this._range)),E("label")&&(r.label=this.label),E("contextValue")&&(r.contextValue=this.contextValue??null),E("comments")&&(r.comments=this._comments.map(c=>p(this,c,this._commentsMap))),E("collapsibleState")&&(r.collapseState=s(this._collapseState)),E("canReply")&&(r.canReply=this.canReply),E("state")&&(r.state=o(this._state)),E("isTemplate")&&(r.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(E){for(const r of this._commentsMap){const c=r[0],v=r[1];if(E===v)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(E=>E.dispose())}}_._handlePool=0,Ve([(0,T.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class k{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(E){this._commentingRangeProvider=E,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(E){this._reactionHandler=E,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!E})}get options(){return this._options}set options(E){this._options=E,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(E,r,c,v){this._extension=E,this._handle=r,this._id=c,this._label=v,this._threads=new Map,a.$registerCommentController(this.handle,c,v);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(b){y.options=b},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(b){y.commentingRangeProvider=b},get reactionHandler(){return y.reactionHandler},set reactionHandler(b){y.reactionHandler=b},createCommentThread(b,$,G){return y.createCommentThread(b,$,G).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(E,r,c){r===void 0&&(0,h.checkProposedApiEnabled)(this._extension,"fileComments");const v=new _(this.id,this.handle,void 0,E,r,c,this._extension,!1);return this._threads.set(v.handle,v),v}$createCommentThreadTemplate(E,r){const c=new _(this.id,this.handle,void 0,A.URI.revive(E),m.Range.to(r),[],this._extension,!0);return c.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(E,r){const c=this._threads.get(E);c&&(c.range=m.Range.to(r))}$deleteCommentThread(E){this._threads.get(E)?.dispose(),this._threads.delete(E)}getCommentThread(E){return this._threads.get(E)}dispose(){this._threads.forEach(E=>{E.dispose()}),this._localDisposables.forEach(E=>E.dispose())}}function p(f,E,r){let c=r.get(E);return c||(c=++f.commentHandle,r.set(E,c)),{mode:E.mode,contextValue:E.contextValue,uniqueIdInThread:c,body:typeof E.body=="string"?E.body:m.MarkdownString.from(E.body),userName:E.author.name,userIconPath:E.author.iconPath,label:E.label,commentReactions:E.reactions?E.reactions.map(v=>i(v)):void 0,timestamp:E.timestamp?.toJSON()}}function i(f){return{label:f.label,iconPath:f.iconPath?m.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function l(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?A.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function s(f){if(f!==void 0)switch(f){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function o(f){if(f!==void 0)switch(f){case R.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new d}e.createExtHostComments=w}),define(Pe[218],Ae([1,0,23,5,27,18]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(R,S){this._mainThreadConsole=R.getProxy(T.MainContext.MainThreadConsole),this._includeStack=S.consoleForward.includeStack,this._logNative=S.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,S){const h=this,w=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){h._handleConsoleCall(R,S,w,arguments)}})}_handleConsoleCall(R,S,h,w){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(w,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,h,w)}};A=Ve([He(0,M.IExtHostRpcService),He(1,C.IExtHostInitDataService)],A),e.AbstractExtHostConsoleForwarder=A;const P=1e5;function D(m,R){const S=[];if(m.length)for(let h=0;h<m.length;h++){let w=m[h];if(typeof w>"u")w="undefined";else if(w instanceof Error){const g=w;g.stack?w=g.stack:w=g.toString()}S.push(w)}if(R){const h=new Error().stack;h&&S.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,n.safeStringify)(S);return h.length>P?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Pe[105],Ae([1,0,2,5,7,3,18,14,16,13,19,26]),function(ee,e,n,T,C,M,A,P,D,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class xi{constructor(g,u){this._logService=u,this._provider=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,u){const t=xi._handlePool++;this._provider.set(t,{provider:g,extensionDescription:u}),this._proxy.$registerDecorationProvider(t,u.identifier.value);const a=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(t,null);return}const _=(0,D.asArray)(d);if(_.length<=xi._maxEventSize){this._proxy.$onDidChange(t,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,_.length);const k=_.map(l=>({uri:l,rank:(0,m.count)(l.path,"/")})),p=(0,D.groupBy)(k,(l,s)=>l.rank-s.rank||(0,m.compare)(l.uri.path,s.uri.path)),i=[];e:for(const l of p){let s;for(const o of l){const f=(0,R.dirname)(o.uri.path);if(s!==f&&(s=f,i.push(o.uri)>=xi._maxEventSize))break e}}this._proxy.$onDidChange(t,i)});return new C.Disposable(()=>{a?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(g,u,t){if(!this._provider.has(g))return Object.create(null);const a=Object.create(null),{provider:d,extensionDescription:_}=this._provider.get(g);return await Promise.all(u.map(async k=>{try{const{uri:p,id:i}=k,l=await Promise.resolve(d.provideFileDecoration(n.URI.revive(p),t));if(!l)return;try{C.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,S.checkProposedApiEnabled)(_,"codiconDecoration"),a[i]=[l.propagate,l.tooltip,l.badge,l.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${_}': ${s}`)}}catch(p){this._logService.error(p)}})),a}};h._handlePool=0,h._maxEventSize=250,h=Ve([He(0,A.IExtHostRpcService),He(1,P.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[219],Ae([1,0,144,92,2,5,7,8,4,14,28,37]),function(ee,e,n,T,C,M,A,P,D,m,R,S){"use strict";var h,w,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(d,_,k,p,i,l,s){this._name=d,this._owner=_,this._maxDiagnosticsPerFile=k,this._modelVersionIdProvider=p,h.set(this,void 0),w.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Je(this,g,new R.ResourceMap(o=>i.getComparisonKey(o)),"f"),Je(this,h,l,"f"),Je(this,w,s,"f")}dispose(){this._isDisposed||(Fe(this,w,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,h,"f")?.$clear(this._owner),Fe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,_){if(!d){this.clear();return}this._checkDisposed();let k=[];if(C.URI.isUri(d)){if(!_){this.delete(d);return}Fe(this,g,"f").set(d,_.slice()),k=[d]}else if(Array.isArray(d)){k=[];let i;d=[...d].sort(u._compareIndexedTuplesByUri);for(const l of d){const[s,o]=l;if((!i||s.toString()!==i.toString())&&(i&&Fe(this,g,"f").get(i).length===0&&Fe(this,g,"f").delete(i),i=s,k.push(s),Fe(this,g,"f").set(s,[])),o)Fe(this,g,"f").get(s)?.push(...o);else{const f=Fe(this,g,"f").get(s);f&&(f.length=0)}}}if(Fe(this,w,"f").fire(k),!Fe(this,h,"f"))return;const p=[];for(const i of k){let l=[];const s=Fe(this,g,"f").get(i);if(s)if(s.length>this._maxDiagnosticsPerFile){l=[];const o=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const E of s)if(E.severity===o[f]&&l.push({...P.Diagnostic.from(E),modelVersionId:this._modelVersionIdProvider(i)})===this._maxDiagnosticsPerFile)break e;l.push({severity:T.MarkerSeverity.Info,message:(0,n.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=s.map(o=>({...P.Diagnostic.from(o),modelVersionId:this._modelVersionIdProvider(i)}));p.push([i,l])}Fe(this,h,"f").$changeMany(this._owner,p)}delete(d){this._checkDisposed(),Fe(this,w,"f").fire([d]),Fe(this,g,"f").delete(d),Fe(this,h,"f")?.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),Fe(this,w,"f").fire([...Fe(this,g,"f").keys()]),Fe(this,g,"f").clear(),Fe(this,h,"f")?.$clear(this._owner)}forEach(d,_){this._checkDisposed();for(const[k,p]of this)d.call(_,k,p,this)}*[(h=new WeakMap,w=new WeakMap,g=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const d of Fe(this,g,"f").keys())yield[d,this.get(d)]}get(d){this._checkDisposed();const _=Fe(this,g,"f").get(d);return Array.isArray(_)?Object.freeze(_.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(Fe(this,g,"f").get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,_){return d[0].toString()<_[0].toString()?-1:d[0].toString()>_[0].toString()?1:0}}e.DiagnosticCollection=u;let t=class Ei{static _mapper(d){const _=new R.ResourceMap;for(const k of d)_.set(k,k);return{uris:Object.freeze(Array.from(_.values()))}}constructor(d,_,k,p){this._logService=_,this._fileSystemInfoService=k,this._extHostDocumentsAndEditors=p,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Ei._mapper),this._proxy=d.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,_){const{_collections:k,_proxy:p,_onDidChangeDiagnostics:i,_logService:l,_fileSystemInfoService:s,_extHostDocumentsAndEditors:o}=this,f=new class{$changeMany(c,v){p.$changeMany(c,v),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,c,v.length===0?"CLEARING":v)}$clear(c){p.$clear(c),l.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,c)}dispose(){p.dispose()}};let E;if(!_)_="_generated_diagnostic_collection_name_#"+Ei._idPool++,E=_;else if(!k.has(_))E=_;else{this._logService.warn(`DiagnosticCollection with name '${_}' does already exist.`);do E=_+Ei._idPool++;while(k.has(E))}return new class extends u{constructor(){super(_,E,Ei._maxDiagnosticsPerFile,c=>o.getDocument(c)?.version,s.extUri,f,i),k.set(E,this)}dispose(){super.dispose(),k.delete(E)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const _=new Map,k=[];for(const p of this._collections.values())p.forEach((i,l)=>{let s=_.get(i.toString());typeof s>"u"&&(s=k.length,_.set(i.toString(),s),k.push([i,[]])),k[s][1]=k[s][1].concat(...l)});return k}}_getDiagnostics(d){let _=[];for(const k of this._collections.values())k.has(d)&&(_=_.concat(k.get(d)));return _}$acceptMarkersChange(d){if(!this._mirrorCollection){const _="_generated_mirror",k=new u(_,_,Ei._maxDiagnosticsPerFile,p=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(_,k),this._mirrorCollection=k}for(const[_,k]of d)this._mirrorCollection.set(C.URI.revive(_),k.map(P.Diagnostic.to))}};t._idPool=0,t._maxDiagnosticsPerFile=1e3,t=Ve([He(1,m.ILogService),He(2,S.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Pe[220],Ae([1,0,2,5,26]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(P){this._proxy=P.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(P,D){return D?.allowUIResources&&(0,C.checkProposedApiEnabled)(P,"showLocal"),this._proxy.$showOpenDialog(D).then(m=>m?m.map(R=>n.URI.revive(R)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(D=>D?n.URI.revive(D):void 0)}}e.ExtHostDialogs=M}),define(Pe[221],Ae([1,0,9,2,7,5,15,21,13]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(S,h,w){this._documentsAndEditors=h,this._logService=w,this._documentContentProviders=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,h){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const w=m._handlePool++;this._documentContentProviders.set(w,h),this._proxy.$registerTextContentProvider(w,S);let g;return typeof h.onDidChange=="function"&&(g=h.onDidChange(u=>{if(u.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(w,u).then(t=>{if(!t&&typeof t!="string")return;const a=this._documentsAndEditors.getDocument(u);if(!a)return;const d=(0,D.splitLines)(t);if(!a.equalLines(d))return this._proxy.$onVirtualDocumentChange(u,t)},n.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,h){const w=this._documentContentProviders.get(S);return w?Promise.resolve(w.provideTextDocumentContent(T.URI.revive(h),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}m._handlePool=0,e.ExtHostDocumentContentProvider=m}),define(Pe[222],Ae([1,0,4,6,2,5,101,8,10,23,7]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(w,g){this._onDidAddDocument=new n.Emitter,this._onDidRemoveDocument=new n.Emitter,this._onDidChangeDocument=new n.Emitter,this._onDidSaveDocument=new n.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const t of u)this._onDidRemoveDocument.fire(t.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const t of u)this._onDidAddDocument.fire(t.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const g=this._documentsAndEditors.getDocument(w);if(g)return g}getDocument(w){const g=this.getDocumentData(w);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this._documentsAndEditors.getDocument(w);if(g)return Promise.resolve(g);let u=this._documentLoader.get(w.toString());return u||(u=this._proxy.$tryOpenDocument(w).then(t=>{this._documentLoader.delete(w.toString());const a=C.URI.revive(t);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(a))},t=>(this._documentLoader.delete(w.toString()),Promise.reject(t))),this._documentLoader.set(w.toString(),u)),u}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged(w,g){const u=C.URI.revive(w),t=this._documentsAndEditors.getDocument(u);if(!t)throw new Error("unknown document");this._onDidRemoveDocument.fire(t.document),t._acceptLanguageId(g),this._onDidAddDocument.fire(t.document)}$acceptModelSaved(w){const g=C.URI.revive(w),u=this._documentsAndEditors.getDocument(g);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(w,g){const u=C.URI.revive(w),t=this._documentsAndEditors.getDocument(u);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this._onDidChangeDocument.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,g,u){const t=C.URI.revive(w),a=this._documentsAndEditors.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(u),a.onEvents(g);let d;g.isUndoing?d=R.TextDocumentChangeReason.Undo:g.isRedoing&&(d=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,m.deepFreeze)({document:a.document,contentChanges:g.changes.map(_=>({range:P.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:d}))}setWordDefinitionFor(w,g){(0,A.setWordDefinitionFor)(w,g)}}e.ExtHostDocuments=S}),define(Pe[59],Ae([1,0,49,4,6,2,3,5,101,18,104,8,14,28,15,192,86]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(k){this.value=k,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let d=class{constructor(k,p){this._extHostRpc=k,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(k){this.acceptDocumentsAndEditorsDelta(k)}acceptDocumentsAndEditorsDelta(k){const p=[],i=[],l=[];if(k.removedDocuments)for(const s of k.removedDocuments){const o=M.URI.revive(s),f=this._documents.get(o);f?.unref()&&(this._documents.delete(o),p.push(f.value))}if(k.addedDocuments)for(const s of k.addedDocuments){const o=M.URI.revive(s.uri);let f=this._documents.get(o);if(f&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new a(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(o,f),i.push(f.value)),f.ref()}if(k.removedEditors)for(const s of k.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&l.push(o)}if(k.addedEditors)for(const s of k.addedEditors){const o=M.URI.revive(s.documentUri);n.ok(this._documents.has(o),`document '${o}' does not exist`),n.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const f=this._documents.get(o).value,E=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new t.Lazy(()=>f.document),s.selections.map(S.Selection.to),s.options,s.visibleRanges.map(r=>S.Range.to(r)),typeof s.editorPosition=="number"?S.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,E)}k.newActiveEditor!==void 0&&(n.ok(k.newActiveEditor===null||this._editors.has(k.newActiveEditor),`active editor '${k.newActiveEditor}' does not exist`),this._activeEditorId=k.newActiveEditor),(0,C.dispose)(p),(0,C.dispose)(l),k.removedDocuments&&this._onDidRemoveDocuments.fire(p),k.addedDocuments&&this._onDidAddDocuments.fire(i),(k.removedEditors||k.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),k.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(k){return this._documents.get(k)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),k=>k.value)}getEditor(k){return this._editors.get(k)}activeEditor(k){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return k?p:p?.value}allEditors(){return[...this._editors.values()]}};d=Ve([He(0,m.IExtHostRpcService),He(1,h.ILogService)],d),e.ExtHostDocumentsAndEditors=d,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[60],Ae([1,0,8,5,2,4,3,7,18,10,64]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class S{constructor(t,a,d){this._activeTabIdGetter=d,this._parentGroup=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this._apiObject){const t=this,a={get isActive(){return t._dto.id===t._activeTabIdGetter()},get label(){return t._dto.label},get input(){return t._input},get isDirty(){return t._dto.isDirty},get isPinned(){return t._dto.isPinned},get isPreview(){return t._dto.isPreview},get group(){return t._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(t){this._dto=t,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class h{constructor(t,a){this._tabs=[],this._activeTabId="",this._dto=t,this._activeGroupIdGetter=a;for(const d of t.tabs)d.isActive&&(this._activeTabId=d.id),this._tabs.push(new S(d,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const t=this,a={get isActive(){return t._dto.groupId===t._activeGroupIdGetter()},get viewColumn(){return n.ViewColumn.to(t._dto.viewColumn)},get activeTab(){return t._tabs.find(d=>d.tabId===t._activeTabId)?.apiObject},get tabs(){return Object.freeze(t._tabs.map(d=>d.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(t){this._dto=t}acceptTabOperation(t){if(t.kind===0){const d=new S(t.tabDto,this,()=>this.activeTabId());return this._tabs.splice(t.index,0,d),t.tabDto.isActive&&(this._activeTabId=d.tabId),d}else if(t.kind===1){const d=this._tabs.splice(t.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return d.tabId===this._activeTabId&&(this._activeTabId=""),d}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this._tabs.splice(t.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this._tabs.splice(t.index,0,d),d}const a=this._tabs.find(d=>d.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this._activeTabId=t.tabDto.id:this._activeTabId===t.tabDto.id&&!t.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this._activeTabId}}let w=class{constructor(t){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=t.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const t=this,a={onDidChangeTabGroups:t._onDidChangeTabGroups.event,onDidChangeTabs:t._onDidChangeTabs.event,get all(){return Object.freeze(t._extHostTabGroups.map(d=>d.apiObject))},get activeTabGroup(){const d=t._activeGroupId;return(0,m.assertIsDefined)(t._extHostTabGroups.find(k=>k.groupId===d)?.apiObject)},close:async(d,_)=>{const k=Array.isArray(d)?d:[d];return k.length?g(k[0])?this._closeGroups(k,_):this._closeTabs(k,_):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(t){const a=new Set(this._extHostTabGroups.map(s=>s.groupId)),d=new Set(t.map(s=>s.groupId)),_=(0,R.diffSets)(a,d),k=this._extHostTabGroups.filter(s=>_.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],i=[];this._extHostTabGroups=t.map(s=>{const o=new h(s,()=>this._activeGroupId);return _.added.includes(o.groupId)?p.push(o.apiObject):i.push(o.apiObject),o});const l=(0,m.assertIsDefined)(t.find(s=>s.isActive===!0)?.groupId);l!==void 0&&this._activeGroupId!==l&&(this._activeGroupId=l),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:k,changed:i}))}$acceptTabGroupUpdate(t){const a=this._extHostTabGroups.find(d=>d.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this._activeGroupId=t.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this._extHostTabGroups.find(_=>_.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const d=a.acceptTabOperation(t);switch(t.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}_findExtHostTabFromApi(t){for(const a of this._extHostTabGroups)for(const d of a.tabs)if(d.apiObject===t)return d}_findExtHostTabGroupFromApi(t){return this._extHostTabGroups.find(a=>a.apiObject===t)}async _closeTabs(t,a){const d=[];for(const _ of t){const k=this._findExtHostTabFromApi(_);if(!k)throw new Error("Tab close: Invalid tab not found!");d.push(k.tabId)}return this._proxy.$closeTab(d,a)}async _closeGroups(t,a){const d=[];for(const _ of t){const k=this._findExtHostTabGroupFromApi(_);if(!k)throw new Error("Group close: Invalid group not found!");d.push(k.groupId)}return this._proxy.$closeGroup(d,a)}};w=Ve([He(0,D.IExtHostRpcService)],w),e.ExtHostEditorTabs=w;function g(u){return u.tabs!==void 0}}),define(Pe[223],Ae([1,0,2,5,6,7,8,268,13,25,26]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const u=this._schemes.indexOf(g);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),u=[];let t,a,d=14,_=14;for(const k of g){let p=t?(0,D.commonPrefixLength)(t,k):0;for(p===0?a=1:a=_;p<k.length;p++)p+1===k.length?(d=_,_=9):_+=1,u.push([a,k.toUpperCase().charCodeAt(p),_]),u.push([a,k.toLowerCase().charCodeAt(p),_]),a=_;t=k,_=d}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(g){this._initStateMachine();const u=[],t=P.LinkComputer.computeLinks({getLineContent(a){return g.lineAt(a-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const a of t){const d=A.DocumentLink.to(a);d.target&&u.push(d)}return u}}class h{constructor(g,u){this._extHostLanguageFeatures=u,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,u,t,a={}){if(h._validateFileSystemProvider(t),this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const d=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(d,t);let _=2;a.isCaseSensitive&&(_+=1024),a.isReadonly&&(_+=2048),typeof t.copy=="function"&&(_+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.checkProposedApiEnabled)(g,"fsChunks"),_+=4),this._proxy.$registerFileSystemProvider(d,u,_).catch(p=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${u}`),console.error(p)});const k=t.onDidChangeFile(p=>{const i=[];for(const l of p){const{uri:s,type:o}=l;if(s.scheme!==u)continue;let f;switch(o){case M.FileChangeType.Changed:f=0;break;case M.FileChangeType.Created:f=1;break;case M.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:f})}this._proxy.$onFileSystemChange(d,i)});return(0,C.toDisposable)(()=>{k.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(d),this._proxy.$unregisterProvider(d)})}static _validateFileSystemProvider(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(g){const{type:u,ctime:t,mtime:a,size:d,permissions:_}=g;return{type:u,ctime:t,mtime:a,size:d,permissions:_}}$stat(g,u){return Promise.resolve(this._getFsProvider(g).stat(n.URI.revive(u))).then(t=>h._asIStat(t))}$readdir(g,u){return Promise.resolve(this._getFsProvider(g).readDirectory(n.URI.revive(u)))}$readFile(g,u){return Promise.resolve(this._getFsProvider(g).readFile(n.URI.revive(u))).then(t=>m.VSBuffer.wrap(t))}$writeFile(g,u,t,a){return Promise.resolve(this._getFsProvider(g).writeFile(n.URI.revive(u),t.buffer,a))}$delete(g,u,t){return Promise.resolve(this._getFsProvider(g).delete(n.URI.revive(u),t))}$rename(g,u,t,a){return Promise.resolve(this._getFsProvider(g).rename(n.URI.revive(u),n.URI.revive(t),a))}$copy(g,u,t,a){const d=this._getFsProvider(g);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(n.URI.revive(u),n.URI.revive(t),a))}$mkdir(g,u){return Promise.resolve(this._getFsProvider(g).createDirectory(n.URI.revive(u)))}$watch(g,u,t,a){const d=this._getFsProvider(g).watch(n.URI.revive(t),a);this._watches.set(u,d)}$unwatch(g,u){const t=this._watches.get(u);t&&(t.dispose(),this._watches.delete(u))}$open(g,u,t){const a=this._getFsProvider(g);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(u),t))}$close(g,u){const t=this._getFsProvider(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(u))}$read(g,u,t,a){const d=this._getFsProvider(g);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const _=m.VSBuffer.alloc(a);return Promise.resolve(d.read(u,t,_.buffer,0,a)).then(k=>_.slice(0,k))}$write(g,u,t,a){const d=this._getFsProvider(g);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(u,t,a.buffer,0,a.byteLength))}_getFsProvider(g){const u=this._fsProvider.get(g);if(!u){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return u}}e.ExtHostFileSystem=h}),define(Pe[61],Ae([1,0,5,43,7,25,3,18,37,6]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class ti{constructor(h,w){this._fileSystemProvider=new Map,this._proxy=h.getProxy(n.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(u){try{const t=g._fileSystemProvider.get(u.scheme);if(!t)return await g._proxy.$stat(u);await g._proxy.$ensureActivation(u.scheme);const a=await t.stat(u);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){ti._handleError(t)}},async readDirectory(u){try{const t=g._fileSystemProvider.get(u.scheme);return t?(await g._proxy.$ensureActivation(u.scheme),(await t.readDirectory(u)).slice()):await g._proxy.$readdir(u)}catch(t){return ti._handleError(t)}},async createDirectory(u){try{return await g._proxy.$mkdir(u)}catch(t){return ti._handleError(t)}},async readFile(u){try{const t=g._fileSystemProvider.get(u.scheme);return t?(await g._proxy.$ensureActivation(u.scheme),(await t.readFile(u)).slice()):(await g._proxy.$readFile(u)).buffer}catch(t){return ti._handleError(t)}},async writeFile(u,t){try{return await g._proxy.$writeFile(u,M.VSBuffer.wrap(t))}catch(a){return ti._handleError(a)}},async delete(u,t){try{const a=g._fileSystemProvider.get(u.scheme);return a?(await g._proxy.$ensureActivation(u.scheme),await a.delete(u,{recursive:!1,...t})):await g._proxy.$delete(u,{recursive:!1,useTrash:!1,...t})}catch(a){return ti._handleError(a)}},async rename(u,t,a){try{return await g._proxy.$rename(u,t,{overwrite:!1,...a})}catch(d){return ti._handleError(d)}},async copy(u,t,a){try{return await g._proxy.$copy(u,t,{overwrite:!1,...a})}catch(d){return ti._handleError(d)}},isWritableFileSystem(u){const t=w.getCapabilities(u);if(typeof t=="number")return!(t&2048)}})}static _handleError(h){if(h instanceof C.FileSystemError)throw h;if(!(h instanceof Error))throw new C.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw C.FileSystemError.Unavailable(h.message);switch(h.name){case T.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(h.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(h.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(h.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(h.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(h.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(h.message);default:throw new C.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,w){return this._fileSystemProvider.set(h,w),(0,m.toDisposable)(()=>this._fileSystemProvider.delete(h))}};R=Ve([He(0,P.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[224],Ae([1,0,4,36,2,5,8,7]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(S,h,w,g,u,t,a,d){this._onDidCreate=new n.Emitter,this._onDidChange=new n.Emitter,this._onDidDelete=new n.Emitter;const _=this.ensureWatching(S,w,u);this._config=0,t&&(this._config+=1),a&&(this._config+=2),d&&(this._config+=4);const k=(0,T.parse)(u),p=typeof u=="string",i=g(l=>{if(!t)for(const s of l.created){const o=C.URI.revive(s);k(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!a)for(const s of l.changed){const o=C.URI.revive(s);k(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!d)for(const s of l.deleted){const o=C.URI.revive(s);k(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}});this._disposable=P.Disposable.from(_,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(S,h,w){const g=P.Disposable.from();if(typeof w=="string")return g;const u=S.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(w.pattern.includes(T.GLOBSTAR)||w.pattern.includes(T.GLOB_SPLIT))&&(t=!0);const a=Math.random();return u.$watch(h.identifier.value,a,w.baseUri,{recursive:t,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(a)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class m{constructor(S,h,w){this._mainContext=S,this._logService=h,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new n.Emitter,this._onDidRenameFile=new n.Emitter,this._onDidCreateFile=new n.Emitter,this._onDidDeleteFile=new n.Emitter,this._onWillRenameFile=new n.AsyncEmitter,this._onWillCreateFile=new n.AsyncEmitter,this._onWillDeleteFile=new n.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,h,w,g,u,t){return new D(this._mainContext,S,h,this._onFileSystemEvent.event,A.GlobPattern.from(w),g,u,t)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,h){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(w=>({oldUri:C.URI.revive(w.source),newUri:C.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(w=>C.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:h.map(w=>C.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,h){return(w,g,u)=>{const t=function(d){w.call(g,d)};return t.extension=S,h.event(t,void 0,u)}}async $onWillRunFileOperation(S,h,w,g){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(u=>({oldUri:C.URI.revive(u.source),newUri:C.URI.revive(u.target)}))},w,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(u=>C.URI.revive(u.target))},w,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(u=>C.URI.revive(u.target))},w,g)}}async _fireWillEvent(S,h,w,g){const u=new Set,t=[];if(await S.fireAsync(h,g,async(d,_)=>{const k=Date.now(),p=await Promise.resolve(d);p instanceof P.WorkspaceEdit&&(t.push([_.extension,p]),u.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-k>w&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,d]of t){const{edits:_}=A.WorkspaceEdit.from(d,{getTextDocumentVersion:k=>this._extHostDocumentsAndEditors.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(_)}return{edit:a,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=m}),define(Pe[225],Ae([1,0,2,38]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(A,P,D,m,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=D,this._commands=m;const S=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new T.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new T.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new T.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new T.ApiCommandResult("Notebook and input URI",h=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const w=this._extHostNotebooks.getEditorById(h.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri),notebookEditor:w.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri)}}));this._commands.registerApiCommand(S)}$willAddInteractiveDocument(A,P,D,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(n.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=C}),define(Pe[226],Ae([1,0,6,2,5,8,7]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(S,h){this.extension=S,this.provider=h,this.handle=P._pool++}}P._pool=0;class D{constructor(S){this.session=S,this.responses=[]}}class m{constructor(S,h,w){this._documents=h,this._logService=w,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadInteractiveEditor)}registerProvider(S,h){const w=new P(S,h);return this._inputProvider.set(w.handle,w),this._proxy.$registerInteractiveEditorProvider(w.handle,S.identifier.value,typeof h.handleInteractiveEditorResponseFeedback=="function"),(0,n.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(w.handle),this._inputProvider.delete(w.handle)})}async $prepareInteractiveSession(S,h,w,g){const u=this._inputProvider.get(S);if(!u){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this._documents.getDocument(T.URI.revive(h)),a=M.Selection.to(w),d=await u.provider.prepareInteractiveEditorSession({document:t,selection:a},g);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const _=m._nextId++;return this._inputSessions.set(_,new D(d)),{id:_,placeholder:d.placeholder,slashCommands:d.slashCommands,wholeRange:M.Range.from(d.wholeRange)}}async $provideResponse(S,h,w,g){const u=this._inputProvider.get(S);if(!u)return;const t=this._inputSessions.get(h.id);if(!t)return;const a=await u.provider.provideInteractiveEditorResponse({session:t.session,prompt:w.prompt,selection:M.Selection.to(w.selection),wholeRange:M.Range.to(w.wholeRange)},g);if(a){const d=t.responses.push(a)-1,_={wholeRange:M.Range.from(a.wholeRange),placeholder:a.placeholder};if(m._isMessageResponse(a))return{..._,id:d,type:"message",message:M.MarkdownString.from(a.contents)};const{edits:k}=a;if(k instanceof A.WorkspaceEdit)return{..._,id:d,type:"bulkEdit",edits:M.WorkspaceEdit.from(k)};if(Array.isArray(k))return{..._,id:d,type:"editorEdit",edits:k.map(M.TextEdit.from)}}}$handleFeedback(S,h,w,g){const u=this._inputProvider.get(S),t=this._inputSessions.get(h),a=t?.responses[w];if(u&&a){let d;switch(g){case 1:d=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:d=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:d=A.InteractiveEditorResponseFeedbackKind.Undone;break}u.provider.handleInteractiveEditorResponseFeedback?.(t.session,a,d)}}$releaseSession(S,h){const w=this._inputSessions.get(h),g=this._inputProvider.get(S);w&&g&&g.provider.releaseInteractiveEditorSession?.(w.session),this._inputSessions.delete(h)}static _isMessageResponse(S){return typeof S=="object"&&typeof S.contents=="object"}}m._nextId=0,e.ExtHostInteractiveEditor=m}),define(Pe[227],Ae([1,0,4,6,58,10,146,5,8]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class m{constructor(h,w){this.extension=h,this.provider=w,this.handle=m._pool++}}m._pool=0;class R{constructor(h,w){this.logService=w,this._interactiveSessionProvider=new Map,this._interactiveSessions=new Map,this._onDidPerformUserAction=new n.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=h.getProxy(P.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(h,w,g){const u=new m(h,g);return this._interactiveSessionProvider.set(u.handle,u),this._proxy.$registerInteractiveSessionProvider(u.handle,w,!!g.provideResponseWithProgress),(0,T.toDisposable)(()=>{this._proxy.$unregisterInteractiveSessionProvider(u.handle),this._interactiveSessionProvider.delete(u.handle)})}addInteractiveSessionRequest(h){this._proxy.$addInteractiveSessionRequest(h)}sendInteractiveRequestToProvider(h,w){this._proxy.$sendInteractiveRequestToProvider(h,w)}async $prepareInteractiveSession(h,w,g){const u=this._interactiveSessionProvider.get(h);if(!u)return;const t=await u.provider.prepareSession(w,g);if(!t)return;const a=R._nextId++;return this._interactiveSessions.set(a,t),{id:a,requesterUsername:t.requester?.name,requesterAvatarIconUri:t.requester?.icon,responderUsername:t.responder?.name,responderAvatarIconUri:t.responder?.icon,inputPlaceholder:t.inputPlaceholder}}async $resolveInteractiveRequest(h,w,g,u){const t=this._interactiveSessionProvider.get(h);if(!t)return;const a=this._interactiveSessions.get(w);if(!a||!t.provider.resolveRequest)return;const d=await t.provider.resolveRequest(a,g,u);if(d)return{message:typeof d.message=="string"?d.message:D.InteractiveSessionReplyFollowup.from(d.message)}}async $provideInitialSuggestions(h,w){const g=this._interactiveSessionProvider.get(h);if(!!g&&!!g.provider.provideInitialSuggestions)return(0,M.withNullAsUndefined)(await g.provider.provideInitialSuggestions(w))}async $provideWelcomeMessage(h,w){const g=this._interactiveSessionProvider.get(h);if(!g||!g.provider.provideWelcomeMessage)return;const u=await g.provider.provideWelcomeMessage(w);if(!!u)return u.map(t=>typeof t=="string"?t:t.map(a=>D.InteractiveSessionReplyFollowup.from(a)))}async $provideFollowups(h,w,g){const u=this._interactiveSessionProvider.get(h);if(!u)return;const t=this._interactiveSessions.get(w);return!t||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(t,g))?.map(d=>D.InteractiveSessionFollowup.from(d))}async $provideInteractiveReply(h,w,g,u){const t=this._interactiveSessionProvider.get(h);if(!t)return;const a=this._interactiveSessions.get(w);if(!a)return;const d={session:a,message:typeof g.message=="string"?g.message:D.InteractiveSessionReplyFollowup.to(g.message)},_=C.StopWatch.create(!1);let k;const p={report:s=>{u.isCancellationRequested||(typeof k>"u"&&(k=_.elapsed()),this._proxy.$acceptInteractiveResponseProgress(h,w,s))}};let i;try{i=await t.provider.provideResponseWithProgress(d,p,u),i||(i={errorDetails:{message:(0,A.localize)(0,null)}})}catch(s){i={errorDetails:{message:(0,A.localize)(1,null,s.message),responseIsIncomplete:!0}},this.logService.error(s)}try{if(a.saveState&&this._interactiveSessions.has(w)){const s=a.saveState();this._proxy.$acceptInteractiveSessionState(w,s)}}catch(s){this.logService.warn(s)}const l={firstProgress:k??0,totalElapsed:_.elapsed()};return{errorDetails:i.errorDetails,timings:l}}async $provideSlashCommands(h,w,g){const u=this._interactiveSessionProvider.get(h);if(!u)return;const t=this._interactiveSessions.get(w);return!t||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(t,g))?.map(d=>({...d,kind:D.CompletionItemKind.from(d.kind)}))}$releaseSession(h){this._interactiveSessions.delete(h)}async $onDidPerformUserAction(h){this._onDidPerformUserAction.fire(h)}}R._nextId=0,e.ExtHostInteractiveSession=R}),define(Pe[228],Ae([1,0,6,5]),function(ee,e,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),(0,n.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=C}),define(Pe[229],Ae([1,0,2,23,8,7,77,5,13,44,16,10,269,21,6,89,84,54,58,9,17,26]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(I,F){this._documents=I,this._provider=F}async provideDocumentSymbols(I,F){const W=this._documents.getDocument(I),V=await this._provider.provideDocumentSymbols(W,F);if(!(0,R.isFalsyOrEmpty)(V))return V[0]instanceof M.DocumentSymbol?V.map(C.DocumentSymbol.from):i._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((V,te)=>{let ge=V.location.range.start.compareTo(te.location.range.start);return ge===0&&(ge=te.location.range.end.compareTo(V.location.range.end)),ge});const F=[],W=[];for(const V of I){const te={name:V.name||"!!MISSING: name!!",kind:C.SymbolKind.from(V.kind),tags:V.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:C.Range.from(V.location.range),selectionRange:C.Range.from(V.location.range),children:[]};for(;;){if(W.length===0){W.push(te),F.push(te);break}const ge=W[W.length-1];if(m.Range.containsRange(ge.range,te.range)&&!m.Range.equalsRange(ge.range,te.range)){ge.children?.push(te),W.push(te);break}W.pop()}}return F}}class l{constructor(I,F,W){this._documents=I,this._commands=F,this._provider=W,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,F){const W=this._documents.getDocument(I),V=await this._provider.provideCodeLenses(W,F);if(!V||F.isCancellationRequested)return;const te=this._cache.add(V),ge=new g.DisposableStore;this._disposables.set(te,ge);const Te={cacheId:te,lenses:[]};for(let ue=0;ue<V.length;ue++)Te.lenses.push({cacheId:[te,ue],range:C.Range.from(V[ue].range),command:this._commands.toInternal(V[ue].command,ge)});return Te}async resolveCodeLens(I,F){const W=I.cacheId&&this._cache.get(...I.cacheId);if(!W)return;let V;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?V=W:V=await this._provider.resolveCodeLens(W,F),V||(V=W),F.isCancellationRequested)return;const te=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!te)return I.command=this._commands.toInternal(V.command??l._badCmd,te),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(Z){return Array.isArray(Z)?Z.map(C.DefinitionLink.from):Z?[C.DefinitionLink.from(Z)]:[]}class o{constructor(I,F){this._documents=I,this._provider=F}async provideDefinition(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideDefinition(V,te,W);return s(ge)}}class f{constructor(I,F){this._documents=I,this._provider=F}async provideDeclaration(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideDeclaration(V,te,W);return s(ge)}}class E{constructor(I,F){this._documents=I,this._provider=F}async provideImplementation(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideImplementation(V,te,W);return s(ge)}}class r{constructor(I,F){this._documents=I,this._provider=F}async provideTypeDefinition(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideTypeDefinition(V,te,W);return s(ge)}}class c{constructor(I,F){this._documents=I,this._provider=F}async provideHover(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideHover(V,te,W);if(!(!ge||(0,R.isFalsyOrEmpty)(ge.contents)))return ge.range||(ge.range=V.getWordRangeAtPosition(te)),ge.range||(ge.range=new M.Range(te,te)),C.Hover.from(ge)}}class v{constructor(I,F){this._documents=I,this._provider=F}async provideEvaluatableExpression(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideEvaluatableExpression(V,te,W);if(ge)return C.EvaluatableExpression.from(ge)}}class y{constructor(I,F){this._documents=I,this._provider=F}async provideInlineValues(I,F,W,V){const te=this._documents.getDocument(I),ge=await this._provider.provideInlineValues(te,C.Range.to(F),C.InlineValueContext.to(W),V);if(Array.isArray(ge))return ge.map(Te=>C.InlineValue.from(Te))}}class b{constructor(I,F){this._documents=I,this._provider=F}async provideDocumentHighlights(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideDocumentHighlights(V,te,W);if(Array.isArray(ge))return ge.map(C.DocumentHighlight.from)}}class ${constructor(I,F){this._documents=I,this._provider=F}async provideLinkedEditingRanges(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.provideLinkedEditingRanges(V,te,W);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,R.coalesce)(ge.ranges.map(C.Range.from)),wordPattern:ge.wordPattern}}}class G{constructor(I,F){this._documents=I,this._provider=F}async provideReferences(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Position.to(F),Te=await this._provider.provideReferences(te,ge,W,V);if(Array.isArray(Te))return Te.map(C.location.from)}}class Y{constructor(I,F,W,V,te,ge,Te){this._documents=I,this._commands=F,this._diagnostics=W,this._provider=V,this._logService=te,this._extension=ge,this._apiDeprecation=Te,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,F,W,V){const te=this._documents.getDocument(I),ge=h.Selection.isISelection(F)?C.Selection.to(F):C.Range.to(F),Te=[];for(const tt of this._diagnostics.getDiagnostics(I))if(ge.intersection(tt.range)&&Te.push(tt)>Y._maxCodeActionsPerFile)break;const ue={diagnostics:Te,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:C.CodeActionTriggerKind.to(W.trigger)},ye=await this._provider.provideCodeActions(te,ge,ue,V);if(!(0,R.isNonEmptyArray)(ye)||V.isCancellationRequested)return;const be=this._cache.add(ye),ze=new g.DisposableStore;this._disposables.set(be,ze);const Ue=[];for(let tt=0;tt<ye.length;tt++){const Ge=ye[tt];!Ge||(Y._isCommand(Ge)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ue.push({_isSynthetic:!0,title:Ge.title,command:this._commands.toInternal(Ge,ze)})):(ue.only&&(Ge.kind?ue.only.contains(Ge.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ue.push({cacheId:[be,tt],title:Ge.title,command:Ge.command&&this._commands.toInternal(Ge.command,ze),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(C.Diagnostic.from),edit:Ge.edit&&C.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:be,actions:Ue}}async resolveCodeAction(I,F){const[W,V]=I,te=this._cache.get(W,V);if(!te||Y._isCommand(te)||!this._provider.resolveCodeAction)return;const ge=await this._provider.resolveCodeAction(te,F)??te;return ge?.edit?C.WorkspaceEdit.from(ge.edit,void 0):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}Y._maxCodeActionsPerFile=1e3;class K{constructor(I,F,W,V){this._proxy=I,this._documents=F,this._provider=W,this._handle=V}async prepareDocumentPaste(I,F,W,V){if(!this._provider.prepareDocumentPaste)return;const te=this._documents.getDocument(I),ge=F.map(ue=>C.Range.to(ue)),Te=C.DataTransfer.toDataTransfer(W,()=>{throw new _.NotImplementedError});return await this._provider.prepareDocumentPaste(te,ge,Te,V),C.DataTransfer.toDataTransferDTO(Te)}async providePasteEdits(I,F,W,V,te){const ge=this._documents.getDocument(F),Te=W.map(be=>C.Range.to(be)),ue=C.DataTransfer.toDataTransfer(V,async be=>(await this._proxy.$resolvePasteFileData(this._handle,I,be)).buffer),ye=await this._provider.provideDocumentPasteEdits(ge,Te,ue,te);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class N{constructor(I,F){this._documents=I,this._provider=F}async provideDocumentFormattingEdits(I,F,W){const V=this._documents.getDocument(I),te=await this._provider.provideDocumentFormattingEdits(V,F,W);if(Array.isArray(te))return te.map(C.TextEdit.from)}}class B{constructor(I,F){this._documents=I,this._provider=F}async provideDocumentRangeFormattingEdits(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Range.to(F),Te=await this._provider.provideDocumentRangeFormattingEdits(te,ge,W,V);if(Array.isArray(Te))return Te.map(C.TextEdit.from)}}class U{constructor(I,F){this._documents=I,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,F,W,V,te){const ge=this._documents.getDocument(I),Te=C.Position.to(F),ue=await this._provider.provideOnTypeFormattingEdits(ge,Te,W,V,te);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class z{constructor(I,F){this._provider=I,this._logService=F,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,F){const W=await this._provider.provideWorkspaceSymbols(I,F);if(!(0,R.isNonEmptyArray)(W))return{symbols:[]};const V=this._cache.add(W),te={cacheId:V,symbols:[]};for(let ge=0;ge<W.length;ge++){const Te=W[ge];if(!Te||!Te.name){this._logService.warn("INVALID SymbolInformation",Te);continue}te.symbols.push({...C.WorkspaceSymbol.from(Te),cacheId:[V,ge]})}return te}async resolveWorkspaceSymbol(I,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this._cache.get(...I.cacheId);if(W){const V=await this._provider.resolveWorkspaceSymbol(W,F);return V&&(0,T.mixin)(I,C.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,F,W){this._documents=I,this._provider=F,this._logService=W}async provideRenameEdits(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Position.to(F);try{const Te=await this._provider.provideRenameEdits(te,ge,W,V);return Te?C.WorkspaceEdit.from(Te):void 0}catch(Te){const ue=j._asMessage(Te);return ue?{rejectReason:ue,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(I,F,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(I),te=C.Position.to(F);try{const ge=await this._provider.prepareRename(V,te,W);let Te,ue;if(M.Range.isRange(ge)?(Te=ge,ue=V.getText(ge)):(0,S.isObject)(ge)&&(Te=ge.range,ue=ge.placeholder),!Te||!ue)return;if(Te.start.line>te.line||Te.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Te),text:ue}}catch(ge){const Te=j._asMessage(ge);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ge)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class fe{constructor(I,F){this.resultId=I,this.tokens=F}}class _e{constructor(I,F){this._documents=I,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,F,W){const V=this._documents.getDocument(I),te=F!==0?this._previousResults.get(F):null;let ge=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,te.resultId,W):await this._provider.provideDocumentSemanticTokens(V,W);return te&&this._previousResults.delete(F),ge?(ge=_e._fixProvidedSemanticTokens(ge),this._send(_e._convertToEdits(te,ge),ge)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return _e._isSemanticTokens(I)?_e._isCorrectSemanticTokens(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):_e._isSemanticTokensEdits(I)?_e._isCorrectSemanticTokensEdits(I)?I:new M.SemanticTokensEdits(I.edits.map(F=>new M.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const F of I.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,F){if(!_e._isSemanticTokens(F)||!I||!I.tokens)return F;const W=I.tokens,V=W.length,te=F.data,ge=te.length;let Te=0;const ue=Math.min(V,ge);for(;Te<ue&&W[Te]===te[Te];)Te++;if(Te===V&&Te===ge)return new M.SemanticTokensEdits([],F.resultId);let ye=0;const be=ue-Te;for(;ye<be&&W[V-ye-1]===te[ge-ye-1];)ye++;return new M.SemanticTokensEdits([{start:Te,deleteCount:V-Te-ye,data:te.subarray(Te,ge-ye)}],F.resultId)}_send(I,F){if(_e._isSemanticTokens(I)){const W=this._nextResultId++;return this._previousResults.set(W,new fe(I.resultId,I.data)),(0,u.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(_e._isSemanticTokensEdits(I)){const W=this._nextResultId++;return _e._isSemanticTokens(F)?this._previousResults.set(W,new fe(F.resultId,F.data)):this._previousResults.set(W,new fe(I.resultId)),(0,u.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class ie{constructor(I,F){this._documents=I,this._provider=F}async provideDocumentRangeSemanticTokens(I,F,W){const V=this._documents.getDocument(I),te=await this._provider.provideDocumentRangeSemanticTokens(V,C.Range.to(F),W);return te?this._send(te):null}_send(I){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class le{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,F,W,V,te){this._documents=I,this._commands=F,this._provider=W,this._apiDeprecation=V,this._extension=te,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Position.to(F),Te=te.getWordRangeAtPosition(ge)||new M.Range(ge,ge),ue=Te.with({end:ge}),ye=new d.StopWatch(!0),be=await this._provider.provideCompletionItems(te,ge,V,C.CompletionContext.to(W));if(!be||V.isCancellationRequested)return;const ze=Array.isArray(be)?new M.CompletionList(be):be,Ue=le.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),tt=new g.DisposableStore;this._disposables.set(Ue,tt);const Ge=[],it={x:Ue,b:Ge,a:{replace:C.Range.from(Te),insert:C.Range.from(ue)},c:ze.isIncomplete||void 0,d:ye.elapsed()};for(let nt=0;nt<ze.items.length;nt++){const Me=ze.items[nt],rt=this._convertCompletionItem(Me,[Ue,nt],ue,Te);Ge.push(rt)}return it}async resolveCompletionItem(I,F){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(...I);if(!W)return;const V=await this._provider.resolveCompletionItem(W,F);if(!!V)return this._convertCompletionItem(V,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,F,W,V){const te=this._disposables.get(F[0]);if(!te)throw Error("DisposableStore is missing...");const ge=this._commands.toInternal(I.command,te),Te={x:F,a:I.label,b:I.kind!==void 0?C.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(C.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:C.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(C.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=I.textEdit.newText):typeof I.insertText=="string"?Te.h=I.insertText:I.insertText instanceof M.SnippetString&&(Te.h=I.insertText.value,Te.i|=4);let ue;return I.textEdit?ue=I.textEdit.range:I.range&&(ue=I.range),M.Range.isRange(ue)?Te.j=C.Range.from(ue):ue&&(!W?.isEqual(ue.inserting)||!V?.isEqual(ue.replacing))&&(Te.j={insert:C.Range.from(ue.inserting),replace:C.Range.from(ue.replacing)}),Te}}class ce{async provideInlineCompletions(I,F,W,V){}disposeCompletions(I){}handleDidShowCompletionItem(I,F){}handlePartialAccept(I,F,W){}}class ke extends ce{constructor(I,F,W,V){super(),this._extension=I,this._documents=F,this._provider=W,this._commands=V,this._references=new de,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Position.to(F),Te=await this._provider.provideInlineCompletionItems(te,ge,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:C.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},V);if(!Te||V.isCancellationRequested)return;const ue=Array.isArray(Te)?Te:Te.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[];let be;return{pid:this._references.createReferenceId({dispose(){be?.dispose()},items:ue}),items:ue.map((Ue,tt)=>{let Ge;Ue.command&&(be||(be=new g.DisposableStore),Ge=this._commands.toInternal(Ue.command,be));const it=Ue.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:Ue.filterText,range:Ue.range?C.Range.from(Ue.range):void 0,command:Ge,idx:tt,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ue.completeBracketPairs:!1}}),commands:ye.map(Ue=>(be||(be=new g.DisposableStore),this._commands.toInternal(Ue,be)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,F){const W=this._references.get(I)?.items[F];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}handlePartialAccept(I,F,W){const V=this._references.get(I)?.items[F];V&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(V,W)}}class de{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const F=this._idPool++;return this._references.set(F,I),F}disposeReferenceId(I){const F=this._references.get(I);return this._references.delete(I),F}get(I){return this._references.get(I)}}class ae{constructor(I,F){this._documents=I,this._provider=F,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(I,F,W,V){const te=this._documents.getDocument(I),ge=C.Position.to(F),Te=this.reviveContext(W),ue=await this._provider.provideSignatureHelp(te,ge,V,Te);if(ue){const ye=this._cache.add([ue]);return{...C.SignatureHelp.from(ue),id:ye}}}reviveContext(I){let F;if(I.activeSignatureHelp){const W=C.SignatureHelp.to(I.activeSignatureHelp),V=this._cache.get(I.activeSignatureHelp.id,0);V?(F=V,F.activeSignature=W.activeSignature,F.activeParameter=W.activeParameter):F=W}return{...I,activeSignatureHelp:F}}releaseSignatureHelp(I){this._cache.delete(I)}}class H{constructor(I,F,W,V,te){this._documents=I,this._commands=F,this._provider=W,this._logService=V,this._extension=te,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,F,W){const V=this._documents.getDocument(I),te=C.Range.to(F),ge=await this._provider.provideInlayHints(V,te,W);if(!Array.isArray(ge)||ge.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(W.isCancellationRequested)return;const Te=this._cache.add(ge);this._disposables.set(Te,new g.DisposableStore);const ue={hints:[],cacheId:Te};for(let ye=0;ye<ge.length;ye++)this._isValidInlayHint(ge[ye],te)&&ue.hints.push(this._convertInlayHint(ge[ye],[Te,ye]));return this._logService.trace(`[InlayHints] ${ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),ue}async resolveInlayHint(I,F){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(...I);if(!W)return;const V=await this._provider.resolveInlayHint(W,F);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,F){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(F&&!F.contains(I.position))}_convertInlayHint(I,F){const W=this._disposables.get(F[0]);if(!W)throw Error("DisposableStore is missing...");const V={label:"",cacheId:F,tooltip:C.MarkdownString.fromStrict(I.tooltip),position:C.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(C.TextEdit.from),kind:I.kind&&C.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?V.label=I.label:V.label=I.label.map(te=>{const ge={label:te.value};return ge.tooltip=C.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(ge.location=C.location.from(te.location)),te.command&&(ge.command=this._commands.toInternal(te.command,W)),ge}),V}}class O{constructor(I,F){this._documents=I,this._provider=F,this._cache=new a.Cache("DocumentLink")}async provideLinks(I,F){const W=this._documents.getDocument(I),V=await this._provider.provideDocumentLinks(W,F);if(!(!Array.isArray(V)||V.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(O._validateLink).map(C.DocumentLink.from)};{const te=this._cache.add(V),ge={links:[],cacheId:te};for(let Te=0;Te<V.length;Te++){if(!O._validateLink(V[Te]))continue;const ue=C.DocumentLink.from(V[Te]);ue.cacheId=[te,Te],ge.links.push(ue)}return ge}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,F){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(...I);if(!W)return;const V=await this._provider.resolveDocumentLink(W,F);if(!(!V||!O._validateLink(V)))return C.DocumentLink.from(V)}releaseLinks(I){this._cache.delete(I)}}class X{constructor(I,F){this._documents=I,this._provider=F}async provideColors(I,F){const W=this._documents.getDocument(I),V=await this._provider.provideDocumentColors(W,F);return Array.isArray(V)?V.map(ge=>({color:C.Color.from(ge.color),range:C.Range.from(ge.range)})):[]}async provideColorPresentations(I,F,W){const V=this._documents.getDocument(I),te=C.Range.to(F.range),ge=C.Color.to(F.color),Te=await this._provider.provideColorPresentations(ge,{document:V,range:te},W);if(!!Array.isArray(Te))return Te.map(C.ColorPresentation.from)}}class pe{constructor(I,F){this._documents=I,this._provider=F}async provideFoldingRanges(I,F,W){const V=this._documents.getDocument(I),te=await this._provider.provideFoldingRanges(V,F,W);if(!!Array.isArray(te))return te.map(C.FoldingRange.from)}}class Ce{constructor(I,F,W){this._documents=I,this._provider=F,this._logService=W}async provideSelectionRanges(I,F,W){const V=this._documents.getDocument(I),te=F.map(C.Position.to),ge=await this._provider.provideSelectionRanges(V,te,W);if(!(0,R.isNonEmptyArray)(ge))return[];if(ge.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let ue=0;ue<te.length;ue++){const ye=[];Te.push(ye);let be=te[ue],ze=ge[ue];for(;;){if(!ze.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(C.SelectionRange.from(ze)),!ze.parent)break;be=ze.range,ze=ze.parent}}return Te}}class we{constructor(I,F){this._documents=I,this._provider=F,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.prepareCallHierarchy(V,te,W);if(!ge)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ge)?ge.map(ue=>this._cacheAndConvertItem(Te,ue)):[this._cacheAndConvertItem(Te,ge)]}async provideCallsTo(I,F,W){const V=this._itemFromCache(I,F);if(!V)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(V,W);if(!!te)return te.map(ge=>({from:this._cacheAndConvertItem(I,ge.from),fromRanges:ge.fromRanges.map(Te=>C.Range.from(Te))}))}async provideCallsFrom(I,F,W){const V=this._itemFromCache(I,F);if(!V)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(V,W);if(!!te)return te.map(ge=>({to:this._cacheAndConvertItem(I,ge.to),fromRanges:ge.fromRanges.map(Te=>C.Range.from(Te))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,F){const W=this._cache.get(I),V=C.CallHierarchyItem.from(F,I,W.size.toString(36));return W.set(V._itemId,F),V}_itemFromCache(I,F){return this._cache.get(I)?.get(F)}}class ve{constructor(I,F){this._documents=I,this._provider=F,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(I,F,W){const V=this._documents.getDocument(I),te=C.Position.to(F),ge=await this._provider.prepareTypeHierarchy(V,te,W);if(!ge)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ge)?ge.map(ue=>this._cacheAndConvertItem(Te,ue)):[this._cacheAndConvertItem(Te,ge)]}async provideSupertypes(I,F,W){const V=this._itemFromCache(I,F);if(!V)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(V,W);if(!!te)return te.map(ge=>this._cacheAndConvertItem(I,ge))}async provideSubtypes(I,F,W){const V=this._itemFromCache(I,F);if(!V)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(V,W);if(!!te)return te.map(ge=>this._cacheAndConvertItem(I,ge))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,F){const W=this._cache.get(I),V=C.TypeHierarchyItem.from(F,I,W.size.toString(36));return W.set(V._itemId,F),V}_itemFromCache(I,F){return this._cache.get(I)?.get(F)}}class Ie{constructor(I,F,W,V){this._proxy=I,this._documents=F,this._provider=W,this._handle=V}async provideDocumentOnDropEdits(I,F,W,V,te){const ge=this._documents.getDocument(F),Te=C.Position.to(W),ue=C.DataTransfer.toDataTransfer(V,async be=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,be)).buffer),ye=await this._provider.provideDocumentDropEdits(ge,Te,ue,te);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class se{constructor(I,F){this.adapter=I,this.extension=F}}class oe{constructor(I,F,W,V,te,ge,Te,ue){this._uriTransformer=F,this._documents=W,this._commands=V,this._diagnostics=te,this._logService=ge,this._apiDeprecation=Te,this._extensionTelemetry=ue,this._adapter=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(I){return C.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new M.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return oe._handlePool++}async _withAdapter(I,F,W,V,te,ge=!1){const Te=this._adapter.get(I);if(!Te||!(Te.adapter instanceof F))return V;const ue=Date.now();ge||this._logService.trace(`[${Te.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ye=W(Te.adapter,Te.extension);return Promise.resolve(ye).catch(be=>{(0,_.isCancellationError)(be)||(this._logService.error(`[${Te.extension.identifier.value}] provider FAILED`),this._logService.error(be),this._extensionTelemetry.onExtensionError(Te.extension.identifier,be))}).finally(()=>{ge||this._logService.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-ue}ms`)}),w.CancellationToken.isCancellationToken(te)?(0,k.raceCancellationError)(ye,te):ye}_addNewAdapter(I,F){const W=this._nextHandle();return this._adapter.set(W,new se(I,F)),W}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,F,W,V){const te=this._addNewAdapter(new i(this._documents,W),I),ge=V&&V.label||oe._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(F),ge),this._createDisposable(te)}$provideDocumentSymbols(I,F,W){return this._withAdapter(I,i,V=>V.provideDocumentSymbols(n.URI.revive(F),W),void 0,W)}registerCodeLensProvider(I,F,W){const V=this._nextHandle(),te=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new se(new l(this._documents,this._commands.converter,W),I)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(F),te);let ge=this._createDisposable(V);if(te!==void 0){const Te=W.onDidChangeCodeLenses(ue=>this._proxy.$emitCodeLensEvent(te));ge=M.Disposable.from(ge,Te)}return ge}$provideCodeLenses(I,F,W){return this._withAdapter(I,l,V=>V.provideCodeLenses(n.URI.revive(F),W),void 0,W)}$resolveCodeLens(I,F,W){return this._withAdapter(I,l,V=>V.resolveCodeLens(F,W),void 0,void 0)}$releaseCodeLenses(I,F){this._withAdapter(I,l,W=>Promise.resolve(W.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(I,F,W){const V=this._addNewAdapter(new o(this._documents,W),I);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideDefinition(I,F,W,V){return this._withAdapter(I,o,te=>te.provideDefinition(n.URI.revive(F),W,V),[],V)}registerDeclarationProvider(I,F,W){const V=this._addNewAdapter(new f(this._documents,W),I);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideDeclaration(I,F,W,V){return this._withAdapter(I,f,te=>te.provideDeclaration(n.URI.revive(F),W,V),[],V)}registerImplementationProvider(I,F,W){const V=this._addNewAdapter(new E(this._documents,W),I);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideImplementation(I,F,W,V){return this._withAdapter(I,E,te=>te.provideImplementation(n.URI.revive(F),W,V),[],V)}registerTypeDefinitionProvider(I,F,W){const V=this._addNewAdapter(new r(this._documents,W),I);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideTypeDefinition(I,F,W,V){return this._withAdapter(I,r,te=>te.provideTypeDefinition(n.URI.revive(F),W,V),[],V)}registerHoverProvider(I,F,W,V){const te=this._addNewAdapter(new c(this._documents,W),I);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(F)),this._createDisposable(te)}$provideHover(I,F,W,V){return this._withAdapter(I,c,te=>te.provideHover(n.URI.revive(F),W,V),void 0,V)}registerEvaluatableExpressionProvider(I,F,W,V){const te=this._addNewAdapter(new v(this._documents,W),I);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(F)),this._createDisposable(te)}$provideEvaluatableExpression(I,F,W,V){return this._withAdapter(I,v,te=>te.provideEvaluatableExpression(n.URI.revive(F),W,V),void 0,V)}registerInlineValuesProvider(I,F,W,V){const te=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new y(this._documents,W),I);this._proxy.$registerInlineValuesProvider(ge,this._transformDocumentSelector(F),te);let Te=this._createDisposable(ge);if(te!==void 0){const ue=W.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(te));Te=M.Disposable.from(Te,ue)}return Te}$provideInlineValues(I,F,W,V,te){return this._withAdapter(I,y,ge=>ge.provideInlineValues(n.URI.revive(F),W,V,te),void 0,te)}registerDocumentHighlightProvider(I,F,W){const V=this._addNewAdapter(new b(this._documents,W),I);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideDocumentHighlights(I,F,W,V){return this._withAdapter(I,b,te=>te.provideDocumentHighlights(n.URI.revive(F),W,V),void 0,V)}registerLinkedEditingRangeProvider(I,F,W){const V=this._addNewAdapter(new $(this._documents,W),I);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideLinkedEditingRanges(I,F,W,V){return this._withAdapter(I,$,async te=>{const ge=await te.provideLinkedEditingRanges(n.URI.revive(F),W,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?oe._serializeRegExp(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(I,F,W){const V=this._addNewAdapter(new G(this._documents,W),I);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideReferences(I,F,W,V,te){return this._withAdapter(I,G,ge=>ge.provideReferences(n.URI.revive(F),W,V,te),void 0,te)}registerCodeActionProvider(I,F,W,V){const te=new g.DisposableStore,ge=this._addNewAdapter(new Y(this._documents,this._commands.converter,this._diagnostics,W,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(F),{providedKinds:V?.providedCodeActionKinds?.map(Te=>Te.value),documentation:V?.documentation?.map(Te=>({kind:Te.kind.value,command:this._commands.converter.toInternal(Te.command,te)}))},oe._extLabel(I),Boolean(W.resolveCodeAction)),te.add(this._createDisposable(ge)),te}$provideCodeActions(I,F,W,V,te){return this._withAdapter(I,Y,ge=>ge.provideCodeActions(n.URI.revive(F),W,V,te),void 0,te)}$resolveCodeAction(I,F,W){return this._withAdapter(I,Y,V=>V.resolveCodeAction(F,W),void 0,void 0)}$releaseCodeActions(I,F){this._withAdapter(I,Y,W=>Promise.resolve(W.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(I,F,W){const V=this._addNewAdapter(new N(this._documents,W),I);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(F),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentFormattingEdits(I,F,W,V){return this._withAdapter(I,N,te=>te.provideDocumentFormattingEdits(n.URI.revive(F),W,V),void 0,V)}registerDocumentRangeFormattingEditProvider(I,F,W){const V=this._addNewAdapter(new B(this._documents,W),I);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(F),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(I,F,W,V,te){return this._withAdapter(I,B,ge=>ge.provideDocumentRangeFormattingEdits(n.URI.revive(F),W,V,te),void 0,te)}registerOnTypeFormattingEditProvider(I,F,W,V){const te=this._addNewAdapter(new U(this._documents,W),I);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(F),V,I.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(I,F,W,V,te,ge){return this._withAdapter(I,U,Te=>Te.provideOnTypeFormattingEdits(n.URI.revive(F),W,V,te,ge),void 0,ge)}registerWorkspaceSymbolProvider(I,F){const W=this._addNewAdapter(new z(F,this._logService),I);return this._proxy.$registerNavigateTypeSupport(W,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(I,F,W){return this._withAdapter(I,z,V=>V.provideWorkspaceSymbols(F,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,F,W){return this._withAdapter(I,z,V=>V.resolveWorkspaceSymbol(F,W),void 0,void 0)}$releaseWorkspaceSymbols(I,F){this._withAdapter(I,z,W=>W.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(I,F,W){const V=this._addNewAdapter(new j(this._documents,W,this._logService),I);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(F),j.supportsResolving(W)),this._createDisposable(V)}$provideRenameEdits(I,F,W,V,te){return this._withAdapter(I,j,ge=>ge.provideRenameEdits(n.URI.revive(F),W,V,te),void 0,te)}$resolveRenameLocation(I,F,W,V){return this._withAdapter(I,j,te=>te.resolveRenameLocation(n.URI.revive(F),W,V),void 0,V)}registerDocumentSemanticTokensProvider(I,F,W,V){const te=this._addNewAdapter(new _e(this._documents,W),I),ge=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(F),V,ge);let Te=this._createDisposable(te);if(ge){const ue=W.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(ge));Te=M.Disposable.from(Te,ue)}return Te}$provideDocumentSemanticTokens(I,F,W,V){return this._withAdapter(I,_e,te=>te.provideDocumentSemanticTokens(n.URI.revive(F),W,V),null,V)}$releaseDocumentSemanticTokens(I,F){this._withAdapter(I,_e,W=>W.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,F,W,V){const te=this._addNewAdapter(new ie(this._documents,W),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(F),V),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(I,F,W,V){return this._withAdapter(I,ie,te=>te.provideDocumentRangeSemanticTokens(n.URI.revive(F),W,V),null,V)}registerCompletionItemProvider(I,F,W,V){const te=this._addNewAdapter(new le(this._documents,this._commands.converter,W,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(te,this._transformDocumentSelector(F),V,le.supportsResolving(W),`${I.identifier.value}(${V.join("")})`),this._createDisposable(te)}$provideCompletionItems(I,F,W,V,te){return this._withAdapter(I,le,ge=>ge.provideCompletionItems(n.URI.revive(F),W,V,te),void 0,te)}$resolveCompletionItem(I,F,W){return this._withAdapter(I,le,V=>V.resolveCompletionItem(F,W),void 0,W)}$releaseCompletionItems(I,F){this._withAdapter(I,le,W=>W.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(I,F,W){const V=new ke(I,this._documents,W,this._commands.converter),te=this._addNewAdapter(V,I);return this._proxy.$registerInlineCompletionsSupport(te,this._transformDocumentSelector(F),V.supportsHandleEvents),this._createDisposable(te)}$provideInlineCompletions(I,F,W,V,te){return this._withAdapter(I,ce,ge=>ge.provideInlineCompletions(n.URI.revive(F),W,V,te),void 0,te)}$handleInlineCompletionDidShow(I,F,W){this._withAdapter(I,ce,async V=>{V.handleDidShowCompletionItem(F,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(I,F,W,V){this._withAdapter(I,ce,async te=>{te.handlePartialAccept(F,W,V)},void 0,void 0)}$freeInlineCompletionsList(I,F){this._withAdapter(I,ce,async W=>{W.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(I,F,W,V){const te=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this._addNewAdapter(new ae(this._documents,W),I);return this._proxy.$registerSignatureHelpProvider(ge,this._transformDocumentSelector(F),te),this._createDisposable(ge)}$provideSignatureHelp(I,F,W,V,te){return this._withAdapter(I,ae,ge=>ge.provideSignatureHelp(n.URI.revive(F),W,V,te),void 0,te)}$releaseSignatureHelp(I,F){this._withAdapter(I,ae,W=>W.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(I,F,W){const V=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new H(this._documents,this._commands.converter,W,this._logService,I),I);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(F),typeof W.resolveInlayHint=="function",V,oe._extLabel(I));let ge=this._createDisposable(te);if(V!==void 0){const Te=W.onDidChangeInlayHints(ue=>this._proxy.$emitInlayHintsEvent(V));ge=M.Disposable.from(ge,Te)}return ge}$provideInlayHints(I,F,W,V){return this._withAdapter(I,H,te=>te.provideInlayHints(n.URI.revive(F),W,V),void 0,V)}$resolveInlayHint(I,F,W){return this._withAdapter(I,H,V=>V.resolveInlayHint(F,W),void 0,W)}$releaseInlayHints(I,F){this._withAdapter(I,H,W=>W.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(I,F,W){const V=this._addNewAdapter(new O(this._documents,W),I);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(F),typeof W.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(I,F,W){return this._withAdapter(I,O,V=>V.provideLinks(n.URI.revive(F),W),void 0,W,F.scheme==="output")}$resolveDocumentLink(I,F,W){return this._withAdapter(I,O,V=>V.resolveLink(F,W),void 0,void 0,!0)}$releaseDocumentLinks(I,F){this._withAdapter(I,O,W=>W.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(I,F,W){const V=this._addNewAdapter(new X(this._documents,W),I);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideDocumentColors(I,F,W){return this._withAdapter(I,X,V=>V.provideColors(n.URI.revive(F),W),[],W)}$provideColorPresentations(I,F,W,V){return this._withAdapter(I,X,te=>te.provideColorPresentations(n.URI.revive(F),W,V),void 0,V)}registerFoldingRangeProvider(I,F,W){const V=this._nextHandle(),te=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new se(new pe(this._documents,W),I)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(F),I.identifier,te);let ge=this._createDisposable(V);if(te!==void 0){const Te=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));ge=M.Disposable.from(ge,Te)}return ge}$provideFoldingRanges(I,F,W,V){return this._withAdapter(I,pe,te=>te.provideFoldingRanges(n.URI.revive(F),W,V),void 0,V)}registerSelectionRangeProvider(I,F,W){const V=this._addNewAdapter(new Ce(this._documents,W,this._logService),I);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideSelectionRanges(I,F,W,V){return this._withAdapter(I,Ce,te=>te.provideSelectionRanges(n.URI.revive(F),W,V),[],V)}registerCallHierarchyProvider(I,F,W){const V=this._addNewAdapter(new we(this._documents,W),I);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$prepareCallHierarchy(I,F,W,V){return this._withAdapter(I,we,te=>Promise.resolve(te.prepareSession(n.URI.revive(F),W,V)),void 0,V)}$provideCallHierarchyIncomingCalls(I,F,W,V){return this._withAdapter(I,we,te=>te.provideCallsTo(F,W,V),void 0,V)}$provideCallHierarchyOutgoingCalls(I,F,W,V){return this._withAdapter(I,we,te=>te.provideCallsFrom(F,W,V),void 0,V)}$releaseCallHierarchy(I,F){this._withAdapter(I,we,W=>Promise.resolve(W.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(I,F,W){const V=this._addNewAdapter(new ve(this._documents,W),I);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$prepareTypeHierarchy(I,F,W,V){return this._withAdapter(I,ve,te=>Promise.resolve(te.prepareSession(n.URI.revive(F),W,V)),void 0,V)}$provideTypeHierarchySupertypes(I,F,W,V){return this._withAdapter(I,ve,te=>te.provideSupertypes(F,W,V),void 0,V)}$provideTypeHierarchySubtypes(I,F,W,V){return this._withAdapter(I,ve,te=>te.provideSubtypes(F,W,V),void 0,V)}$releaseTypeHierarchy(I,F){this._withAdapter(I,ve,W=>Promise.resolve(W.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(I,F,W){const V=this._nextHandle();return this._adapter.set(V,new se(new Ie(this._proxy,this._documents,W,V),I)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(F)),this._createDisposable(V)}$provideDocumentOnDropEdits(I,F,W,V,te,ge){return this._withAdapter(I,Ie,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(F,n.URI.revive(W),V,te,ge)),void 0,void 0)}registerDocumentPasteEditProvider(I,F,W,V){const te=this._nextHandle();return this._adapter.set(te,new se(new K(this._proxy,this._documents,W,te),I)),this._proxy.$registerPasteEditProvider(te,this._transformDocumentSelector(F),!!W.prepareDocumentPaste,V.pasteMimeTypes),this._createDisposable(te)}$prepareDocumentPaste(I,F,W,V,te){return this._withAdapter(I,K,ge=>ge.prepareDocumentPaste(n.URI.revive(F),W,V,te),void 0,te)}$providePasteEdits(I,F,W,V,te,ge){return this._withAdapter(I,K,Te=>Te.providePasteEdits(F,n.URI.revive(W),V,te,ge),void 0,ge)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,D.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:oe._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:oe._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?oe._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?oe._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:oe._serializeRegExp(I.beforeText),afterText:I.afterText?oe._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?oe._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(oe._serializeOnEnterRule)}setLanguageConfiguration(I,F,W){const{wordPattern:V}=W;if(V&&(0,D.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(F,V):this._documents.setWordDefinitionFor(F,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const te=this._nextHandle(),ge={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?oe._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?oe._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?oe._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this._proxy.$setLanguageConfiguration(te,F,ge),this._createDisposable(te)}$setWordDefinitions(I){for(const F of I)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}oe._handlePool=0,e.ExtHostLanguageFeatures=oe}),define(Pe[230],Ae([1,0,5,8,7,29,17,6]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,S,h,w){this._documents=S,this._commands=h,this._uriTransformer=w,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,S){await this._proxy.$changeLanguage(R,S);const h=this._documents.getDocumentData(R);if(!h)throw new Error(`document '${R.toString()}' NOT found`);return h.document}async tokenAtPosition(R,S){const h=R.version,w=T.Position.from(S),g=await this._proxy.$tokensAtPosition(R.uri,w),u={type:C.StandardTokenType.Other,range:R.getWordRangeAtPosition(S)??new C.Range(S.line,S.character,S.line,S.character)};if(!g)return u;const t={range:T.Range.to(g.range),type:T.TokenType.to(g.type)};return!t.range.contains(S)||h!==R.version?u:t}createLanguageStatusItem(R,S,h){const w=this._handlePool++,g=this._proxy,u=this._ids,t=`${R.identifier.value}/${S}`;if(u.has(t))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);u.add(t);const a={selector:h,id:S,name:R.displayName??R.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const _=new P.DisposableStore,k=()=>{d?.dispose(),d=(0,A.disposableTimeout)(()=>{_.clear(),this._proxy.$setLanguageStatus(w,{id:t,name:a.name??R.displayName??R.name,source:R.displayName??R.name,selector:T.DocumentSelector.from(a.selector,this._uriTransformer),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?M.default.Error:a.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this._commands.toInternal(a.command,_),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},p={dispose(){_.dispose(),d?.dispose(),g.$removeLanguageStatus(w),u.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,k()},get selector(){return a.selector},set selector(i){a.selector=i,k()},get text(){return a.text},set text(i){a.text=i,k()},get detail(){return a.detail},set detail(i){a.detail=i,k()},get severity(){return a.severity},set severity(i){a.severity=i,k()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,k()},get command(){return a.command},set command(i){a.command=i,k()},get busy(){return a.busy},set busy(i){a.busy=i,k()}};return k(),p}}e.ExtHostLanguages=D}),define(Pe[79],Ae([1,0,20,13,2,3,14,5,27,18]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(h,w,g){this.logService=g,this.bundleCache=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadLocalization),this.currentLanguage=h.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===n.LANGUAGE_DEFAULT}getMessage(h,w){const{message:g,args:u,comment:t}=w;if(this.isDefaultLanguage)return(0,T.format2)(g,u??{});let a=g;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const d=this.bundleCache.get(h)?.contents[a];return d||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,T.format2)(d??g,u??{})}getBundle(h){return this.bundleCache.get(h)?.contents}getBundleUri(h){return this.bundleCache.get(h)?.uri}async initializeLocalizedMessages(h){if(this.isDefaultLanguage||!h.l10n&&!h.isBuiltin||this.bundleCache.has(h.identifier.value))return;let w;const g=await this.getBundleLocation(h);if(!g){this.logService.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const u=await this._proxy.$fetchBundleContents(g),t=JSON.parse(u);w=h.isBuiltin?t.contents?.bundle:t}catch(u){this.logService.error(`Failed to load translations for ${h.identifier.value} from ${g}: ${u.message}`);return}w&&this.bundleCache.set(h.identifier.value,{contents:w,uri:g})}async getBundleLocation(h){if(h.isBuiltin){const w=await this._proxy.$fetchBuiltInBundleUri(h.identifier.value,this.currentLanguage);return C.URI.revive(w)}return h.l10n?C.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=Ve([He(0,D.IExtHostInitDataService),He(1,m.IExtHostRpcService),He(2,A.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Pe[231],Ae([1,0,14,5,27,18,2,67]),function(ee,e,n,T,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends n.AbstractLoggerService{constructor(S,h){super(h.logLevel,h.logsLocation,h.loggers.map(w=>(0,P.revive)(w))),this._proxy=S.getProxy(T.MainContext.MainThreadLogger)}$setLogLevel(S,h){h?this.setLogLevel(A.URI.revive(h),S):this.setLogLevel(S)}setVisibility(S,h){super.setVisibility(S,h),this._proxy.$setVisibility(S,h)}doCreateLogger(S,h,w){return new m(this._proxy,S,h,w)}};D=Ve([He(0,M.IExtHostRpcService),He(1,C.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class m extends n.AbstractMessageLogger{constructor(S,h,w,g){super(g?.logLevel==="always"),this.proxy=S,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(h,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,h){const w=[[S,h]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(S){this.proxy.$log(this.file,S)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[232],Ae([1,0,5,14,26]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(P){return P&&P.title}let A=class{constructor(D,m){this._logService=m,this._proxy=D.getProxy(n.MainContext.MainThreadMessageService)}showMessage(D,m,R,S,h){const w={source:{identifier:D.identifier,label:D.displayName||D.name}};let g;typeof S=="string"||M(S)?g=[S,...h]:(w.modal=S?.modal,w.useCustom=S?.useCustom,w.detail=S?.detail,g=h),w.useCustom&&(0,C.checkProposedApiEnabled)(D,"resolvers");const u=[];for(let t=0;t<g.length;t++){const a=g[t];if(typeof a=="string")u.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:d,isCloseAffordance:_}=a;u.push({title:d,isCloseAffordance:!!_,handle:t})}else this._logService.warn("Invalid message item:",a)}return this._proxy.$showMessage(m,R,w,u).then(t=>{if(typeof t=="number")return g[t]})}};A=Ve([He(1,T.ILogService)],A),e.ExtHostMessageService=A}),define(Pe[233],Ae([1,0,25,4,6,28,13,10,2,54,5,38,8,7,46,203,102,9]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(k=>k.apiEditor)}constructor(k,p,i,l){this._textDocumentsAndEditors=i,this._textDocuments=l,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new m.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=k.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=k.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=k.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const o=s.notebookEditor?.notebookUri,f=s.cell.handle,r=this._documents.get(o)?.getCell(f);if(r)return r.apiCell}if(s&&s.$mid===14){const o=s.uri,f=this._documents.get(o);if(f)return f.apiNotebook}return s}}),d._registerApiCommands(p)}getEditorById(k){const p=this._editors.get(k);if(!p)throw new Error(`unknown text editor: ${k}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(k){for(const[p,i]of this._editors)if(i.apiEditor===k)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(k,p){const i=this._documents.get(k);if(!i&&!p)throw new Error(`NO notebook document for '${k}'`);return i}static _convertNotebookRegistrationData(k,p){if(!p)return;const i=p.filenamePattern.map(l=>h.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(p.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:p.displayName,filenamePattern:i,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(k,p,i){const l=d._notebookStatusBarItemProviderHandlePool++,s=typeof i.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,s,p);let o;return s!==void 0&&(o=i.onDidChangeCellStatusBarItems(f=>this._notebookProxy.$emitCellStatusBarEvent(s))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,s),o?.dispose()})}async createNotebookDocument(k){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:k.viewType,content:k.content&&h.NotebookData.from(k.content)});return D.URI.revive(p)}async openNotebookDocument(k){const p=this._documents.get(k);if(p)return p.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(k),l=this._documents.get(D.URI.revive(i));return(0,P.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(k,p){D.URI.isUri(k)&&(k=await this.openNotebookDocument(k));let i;typeof p=="object"?i={position:h.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(h.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:i={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(k.uri,k.notebookType,i),s=l&&this._editors.get(l)?.apiEditor;if(s)return s;throw l?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,p,i,l){const s=this._notebookStatusBarItemProviders.get(k),o=D.URI.revive(p),f=this._documents.get(o);if(!f||!s)return;const E=f.getCellFromIndex(i);if(!E)return;const r=await s.provideCellStatusBarItems(E.apiCell,l);if(!r)return;const c=new C.DisposableStore,v=this._statusBarCache.add([c]),b=(Array.isArray(r)?r:[r]).map($=>h.NotebookStatusBarItem.from($,this._commandsConverter,c));return{cacheId:v,items:b}}$releaseNotebookCellStatusBarItems(k){this._statusBarCache.delete(k)}registerNotebookSerializer(k,p,i,l,s){if((0,A.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,i),this._notebookProxy.$registerNotebookSerializer(o,{id:k.identifier,location:k.extensionLocation},p,h.NotebookDocumentContentOptions.from(l),d._convertNotebookRegistrationData(k,s)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(k,p,i){const l=this._notebookSerializer.get(k);if(!l)throw new Error("NO serializer found");const s=await l.deserializeNotebook(p.buffer,i);return new g.SerializableObjectWithBuffers(h.NotebookData.from(s))}async $notebookToData(k,p,i){const l=this._notebookSerializer.get(k);if(!l)throw new Error("NO serializer found");const s=await l.serializeNotebook(h.NotebookData.to(p.value),i);return n.VSBuffer.wrap(s)}_createExtHostEditor(k,p,i){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const l=new t.ExtHostNotebookEditor(p,this._notebookEditorsProxy,k,i.visibleRanges.map(h.NotebookRange.to),i.selections.map(h.NotebookRange.to),typeof i.viewColumn=="number"?h.ViewColumn.to(i.viewColumn):void 0);this._editors.set(p,l)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const i of k.value.removedDocuments){const l=D.URI.revive(i),s=this._documents.get(l);s&&(s.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===l.toString()&&this._editors.delete(o.id)}if(k.value.addedDocuments){const i=[];for(const l of k.value.addedDocuments){const s=D.URI.revive(l.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const o=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,s,l);i.push(...l.cells.map(f=>u.ExtHostCell.asModelAddData(o.apiNotebook,f))),this._documents.get(s)?.dispose(),this._documents.set(s,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(k.value.addedEditors)for(const i of k.value.addedEditors){if(this._editors.has(i.id))return;const l=D.URI.revive(i.documentUri),s=this._documents.get(l);s&&this._createExtHostEditor(s,i.id,i)}const p=[];if(k.value.removedEditors)for(const i of k.value.removedEditors){const l=this._editors.get(i);l&&(this._editors.delete(i),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),p.push(l))}if(k.value.visibleEditors){this._visibleNotebookEditors=k.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const i=new Set;this._visibleNotebookEditors.forEach(l=>i.add(l.id));for(const l of this._editors.values()){const s=i.has(l.id);l._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this._activeNotebookEditor=void 0:k.value.newActiveEditor&&(this._editors.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(k){const p=S.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new S.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>n.VSBuffer.wrap(s))],new S.ApiCommandResult("Notebook Data",s=>h.NotebookData.to(s.value))),l=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new g.SerializableObjectWithBuffers(h.NotebookData.from(s)))],new S.ApiCommandResult("Bytes",s=>s.buffer));k.registerApiCommand(i),k.registerApiCommand(l)}}d._notebookStatusBarItemProviderHandlePool=0,e.ExtHostNotebookController=d}),define(Pe[234],Ae([1,0,16,17,21,4,6,28,2,24,14,54,5,38,8,7,75,193,26,46]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let k=class{constructor(f,E,r,c,v){this._initData=E,this._extHostNotebook=r,this._commands=c,this._logService=v,this._activeExecutions=new P.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelSourceActionProviderCache=new S.Cache("NotebookKernelSourceActionProviderCache"),this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=f.getProxy(h.MainContext.MainThreadNotebookKernels);const y=new w.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const $=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:$}}else if(b&&"notebookEditor"in b){const $=this._extHostNotebook.getIdByEditor(b.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return b})],w.ApiCommandResult.Void);this._commands.registerApiCommand(y)}createNotebookController(f,E,r,c,v,y){for(const ce of this._kernelData.values())if(ce.controller.id===E&&m.ExtensionIdentifier.equals(f.identifier,ce.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const b=this._handlePool++,$=this;this._logService.trace(`NotebookController[${b}], CREATED by ${f.identifier.value}, ${E}`);const G=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${f.identifier}'`);let Y=!1;const K=new A.DisposableStore,N=new M.Emitter,B=new M.Emitter,U={id:s(f.identifier,E),notebookType:r,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:c||f.identifier.value,preloads:y?y.map(g.NotebookRendererScript.from):[]};let z=v??G,j;this._proxy.$addKernel(b,U).catch(ce=>{console.log(ce),Y=!0});let fe=0;const _e=()=>{if(Y)return;const ce=++fe;Promise.resolve().then(()=>{ce===fe&&this._proxy.$updateKernel(b,U)})},ie=new P.ResourceMap,le={get id(){return E},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return U.label},set label(ce){U.label=ce??f.displayName??f.name,_e()},get detail(){return U.detail??""},set detail(ce){U.detail=ce,_e()},get description(){return U.description??""},set description(ce){U.description=ce,_e()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ce){U.supportedLanguages=ce,_e()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){U.supportsExecutionOrder=ce,_e()},get rendererScripts(){return U.preloads?U.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ce){z=ce??G},get interruptHandler(){return j},set interruptHandler(ce){j=ce,U.supportsInterrupt=Boolean(ce),_e()},createNotebookCellExecution(ce){if(Y)throw new Error("notebook controller is DISPOSED");if(!ie.has(ce.notebook.uri))throw $._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return $._createNotebookCellExecution(ce,s(f.identifier,this.id))},dispose:()=>{Y||(this._logService.trace(`NotebookController[${b}], DISPOSED`),Y=!0,this._kernelData.delete(b),K.dispose(),N.dispose(),B.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(ce,ke){ke===u.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(f,"notebookControllerAffinityHidden"),$._proxy.$updateNotebookPriority(b,ce.uri,ke)},onDidReceiveMessage:B.event,postMessage(ce,ke){return(0,d.checkProposedApiEnabled)(f,"notebookMessaging"),$._proxy.$postMessage(b,ke&&$._extHostNotebook.getIdByEditor(ke),ce)},asWebviewUri(ce){return(0,d.checkProposedApiEnabled)(f,"notebookMessaging"),(0,t.asWebviewUri)(ce,$._initData.remote)}};return this._kernelData.set(b,{extensionId:f.identifier,controller:le,onDidReceiveMessage:B,onDidChangeSelection:N,associatedNotebooks:ie}),le}getIdByController(f){for(const[E,r]of this._kernelData)if(r.controller===f)return s(r.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,E){const r=this._kernelDetectionTaskHandlePool++,c=this;this._logService.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelDetectionTask(r,E);const v={dispose:()=>{this._kernelDetectionTask.delete(r),c._proxy.$removeKernelDetectionTask(r)}};return this._kernelDetectionTask.set(r,v),v}registerKernelSourceActionProvider(f,E,r){const c=this._kernelSourceActionProviderHandlePool++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,y=this;this._kernelSourceActionProviders.set(c,r),this._logService.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelSourceActionProvider(c,c,E);let b;return v!==void 0&&(b=r.onDidChangeNotebookKernelSourceActions($=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this._kernelSourceActionProviders.delete(c),y._proxy.$removeKernelSourceActionProvider(c,c),b?.dispose()}}}async $provideKernelSourceActions(f,E){const r=this._kernelSourceActionProviders.get(f);if(r){const c=new A.DisposableStore;return this._kernelSourceActionProviderCache.add([c]),(await r.provideNotebookKernelSourceActions(E)??[]).map(y=>g.NotebookKernelSourceAction.from(y,this._commands.converter,c))}return[]}$acceptNotebookAssociation(f,E,r){const c=this._kernelData.get(f);if(c){const v=this._extHostNotebook.getNotebookDocument(D.URI.revive(E));r?c.associatedNotebooks.set(v.uri,!0):c.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${f}] ASSOCIATE notebook`,v.uri.toString(),r),c.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(f,E,r){const c=this._kernelData.get(f);if(!c)return;const v=this._extHostNotebook.getNotebookDocument(D.URI.revive(E)),y=[];for(const b of r){const $=v.getCell(b);$&&y.push($.apiCell)}try{this._logService.trace(`NotebookController[${f}] EXECUTE cells`,v.uri.toString(),y.length),await c.controller.executeHandler.call(c.controller,y,v.apiNotebook,c.controller)}catch(b){this._logService.error(`NotebookController[${f}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(f,E,r){const c=this._kernelData.get(f);if(!c)return;const v=this._extHostNotebook.getNotebookDocument(D.URI.revive(E));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,v.apiNotebook);else for(const y of r){const b=v.getCell(y);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(f,E,r){const c=this._kernelData.get(f);if(!c)return;const v=this._extHostNotebook.getEditorById(E);c.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(f,E,r){const v=this._extHostNotebook.getNotebookDocument(D.URI.revive(f)).getCell(E);if(v){const y=r?g.NotebookCellExecutionState.to(r):u.NotebookCellExecutionState.Idle;y!==void 0&&this._onDidChangeCellExecutionState.fire({cell:v.apiCell,state:y})}}_createNotebookCellExecution(f,E){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const v=new i(E,c,this._proxy);this._activeExecutions.set(c.uri,v);const y=v.onDidChangeState(()=>{v.state===p.Resolved&&(v.dispose(),y.dispose(),this._activeExecutions.delete(c.uri))});return v.asApiObject()}};k=Ve([He(4,R.ILogService)],k),e.ExtHostNotebookKernels=k;var p;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(p||(p={}));class i extends A.Disposable{get state(){return this._state}constructor(f,E,r){super(),this._cell=E,this._proxy=r,this._handle=i.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new l(10,c=>this.update(c)),this._executionOrder=E.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,f,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(f){await this._collector.addItem(f)}async update(f){const E=Array.isArray(f)?f:[f];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(E))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(f){let E=this._cell;if(f&&(E=this._cell.notebook.getCellFromApiCell(f)),!E)throw new Error("INVALID cell");return E.handle}validateAndConvertOutputs(f){return f.map(E=>{const r=u.NotebookCellOutput.ensureUniqueMimeTypes(E.items,!0);return r===E.items?g.NotebookCellOutput.from(E):g.NotebookCellOutput.from({items:r,id:E.id,metadata:E.metadata})})}async updateOutputs(f,E,r){const c=this.cellIndexToHandle(E),v=this.validateAndConvertOutputs((0,n.asArray)(f));return this.updateSoon({editType:a.CellExecutionUpdateType.Output,cellHandle:c,append:r,outputs:v})}async updateOutputItems(f,E,r){return f=u.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(f),!0),this.updateSoon({editType:a.CellExecutionUpdateType.OutputItems,items:f.map(g.NotebookCellOutputItem.from),outputId:E.id,append:r})}asApiObject(){const f=this;return Object.freeze({get token(){return f._tokenSource.token},get cell(){return f._cell.apiCell},get executionOrder(){return f._executionOrder},set executionOrder(r){f._executionOrder=r,f.update([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:f._executionOrder}])},start(r){if(f._state===p.Resolved||f._state===p.Started)throw new Error("Cannot call start again");f._state=p.Started,f._onDidChangeState.fire(),f.update({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,c){if(f._state===p.Resolved)throw new Error("Cannot call resolve twice");f._state=p.Resolved,f._onDidChangeState.fire(),f._collector.flush(),f._proxy.$completeExecution(f._handle,new _.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:r}))},clearOutput(r){return f.verifyStateForOutput(),f.updateOutputs([],r,!1)},appendOutput(r,c){return f.verifyStateForOutput(),f.updateOutputs(r,c,!0)},replaceOutput(r,c){return f.verifyStateForOutput(),f.updateOutputs(r,c,!1)},appendOutputItems(r,c){return f.verifyStateForOutput(),f.updateOutputItems(r,c,!0)},replaceOutputItems(r,c){return f.verifyStateForOutput(),f.updateOutputItems(r,c,!1)}})}}i.HANDLE=0;class l{constructor(f,E){this.delay=f,this.callback=E,this.batch=[],this.startedTimer=Date.now()}addItem(f){return this.batch.push(f),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const f=this.currentDeferred;this.currentDeferred=void 0;const E=this.batch;return this.batch=[],this.callback(E).finally(()=>f.complete())}}function s(o,f){return`${o.value}/${f}`}e.createKernelId=s}),define(Pe[235],Ae([1,0,4,5,102]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(P,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,D,m){const R=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(D)?.fire({editor:R.apiEditor,message:m})}createRendererMessaging(P,D){if(!P.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,S,h)=>this.getOrCreateEmitterFor(D).event(R,S,h),postMessage:(R,S)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const h=S&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(h?.id,D,R)}}}getOrCreateEmitterFor(P){let D=this._rendererMessageEmitters.get(P);return D||(D=new n.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,D),D)}}e.ExtHostNotebookRenderers=M}),define(Pe[236],Ae([1,0,6,10,2,26,5]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(m){this.handlers=new Map,this.proxy=m.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,R,S){if((0,M.checkProposedApiEnabled)(m,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,S),this.proxy.$registerProfileContentHandler(R,S.name,S.description,m.identifier.value),(0,n.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(m,R,S,h){const w=this.handlers.get(m);if(!w)throw new Error(`Unknown handler with id: ${m}`);return w.saveProfile(R,S,h)}async $readProfile(m,R,S){const h=this.handlers.get(m);if(!h)throw new Error(`Unknown handler with id: ${m}`);return h.readProfile((0,T.isString)(R)?R:C.URI.revive(R),S)}}e.ExtHostProfileContentHandlers=P}),define(Pe[237],Ae([1,0,2,5,17,8]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{constructor(D,m){this.uriTransformer=m,this.providers=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadQuickDiff)}$provideOriginalResource(D,m,R){const S=n.URI.revive(m),h=this.providers.get(D);return h?(0,C.asPromise)(()=>h.provideOriginalResource(S,R)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(D,m,R,S){const h=A.handlePool++;return this.providers.set(h,m),this.proxy.$registerQuickDiffProvider(h,M.DocumentSelector.from(D,this.uriTransformer),R,S),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(h),this.providers.delete(h)}}}}A.handlePool=0,e.ExtHostQuickDiff=A}),define(Pe[238],Ae([1,0,21,4,6,5,2,7,9,16,29,39,26,8]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(u,t,a){const d=u.getProxy(M.MainContext.MainThreadQuickOpen);class _{constructor(r,c){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=c}showQuickPick(r,c,v,y=n.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(c),$=++this._instances,G=d.$show($,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),Y={},K=G.then(()=>Y);return Promise.race([K,b]).then(N=>{if(N===Y)return;const B=(0,h.isProposedApiEnabled)(r,"quickPickItemTooltip");return b.then(U=>{const z=[];for(let j=0;j<U.length;j++){const fe=U[j];typeof fe=="string"?z.push({label:fe,handle:j}):fe.kind===P.QuickPickItemKind.Separator?z.push({type:"separator",label:fe.label}):(fe.tooltip&&!B&&console.warn(`Extension '${r.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${r.identifier.value}`),z.push({label:fe.label,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:B?w.MarkdownString.fromStrict(fe.tooltip):void 0,handle:j}))}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{v.onDidSelectItem(U[j])}),d.$setItems($,z),G.then(j=>{if(typeof j=="number")return U[j];if(Array.isArray(j))return j.map(fe=>U[fe])})})}).then(void 0,N=>{if(!(0,D.isCancellationError)(N))return d.$setError($,N),Promise.reject(N)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,c=n.CancellationToken.None){return this._validateInput=r?.validateInput,d.$input(r,typeof this._validateInput=="function",c).then(void 0,v=>{if(!(0,D.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(r){if(!this._validateInput)return;const c=await this._validateInput(r);if(!c||typeof c=="string")return c;let v;switch(c.severity){case P.InputBoxValidationSeverity.Info:v=R.default.Info;break;case P.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case P.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=c.message?R.default.Error:R.default.Ignore;break}return{content:c.message,severity:v}}async showWorkspaceFolderPick(r,c=n.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!v)return;const y=await this._workspace.getWorkspaceFolders2();if(!!y)return y.find(b=>b.uri.toString()===v.uri.toString())}createQuickPick(r){const c=new o(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(r){const c=new f(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(r,c){this._sessions.get(r)?._fireDidChangeValue(c)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,c){const v=this._sessions.get(r);v instanceof o&&v._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const v=this._sessions.get(r);v instanceof o&&v._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){this._sessions.get(r)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(r,c,v){const y=this._sessions.get(r);y instanceof o&&y._fireDidTriggerItemButton(c,v)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class k{constructor(r,c){this._extensionId=r,this._onDidDispose=c,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((c,v)=>{const y=c===P.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(y,c)}),this.update({buttons:r.map((c,v)=>({...s(c),tooltip:c.tooltip,handle:c===P.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const c=this._handlesToButtons.get(r);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(r){if(!this._disposed){for(const c of Object.keys(r)){const v=r[c];this._pendingUpdate[c]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}k._nextId=1;function p(E){if(E instanceof P.ThemeIcon)return{id:E.id};const r=l(E),c=i(E);return{dark:typeof r=="string"?A.URI.file(r):r,light:typeof c=="string"?A.URI.file(c):c}}function i(E){return typeof E=="object"&&"light"in E?E.light:E}function l(E){return typeof E=="object"&&"dark"in E?E.dark:E}function s(E){const r=p(E.iconPath);let c,v;return"id"in r?v=S.ThemeIcon.asClassName(r):c=r,{iconPath:c,iconClass:v}}class o extends k{constructor(r,c){super(r.identifier,c),this.extension=r,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this._onDidTriggerItemButtonEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((y,b)=>{this._handlesToItems.set(b,y),this._itemsToHandles.set(y,b)});const c=(0,h.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),v=[];for(let y=0;y<r.length;y++){const b=r[y];b.kind===P.QuickPickItemKind.Separator?v.push({type:"separator",label:b.label}):(b.tooltip&&!c&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`),v.push({handle:y,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:c?w.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map(($,G)=>({...s($),tooltip:$.tooltip,handle:G}))}))}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(r){const c=(0,m.coalesce)(r.map(v=>this._handlesToItems.get(v)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(r){const c=(0,m.coalesce)(r.map(v=>this._handlesToItems.get(v)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(r,c){const v=this._handlesToItems.get(r);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[c];y&&this._onDidTriggerItemButtonEmitter.fire({button:y,item:v})}}class f extends k{constructor(r,c){super(r.identifier,c),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get valueSelection(){return this._valueSelection}set valueSelection(r){this._valueSelection=r,this.update({valueSelection:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new _(t,a)}e.createExtHostQuickOpen=g});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Pe[239],Ae([1,0,2,4,65,6,17,5,16,126,14,24,39,8,26]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g){"use strict";var u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(c){if(c)return typeof c.iconPath=="string"?n.URI.file(c.iconPath):n.URI.isUri(c.iconPath)||h.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function d(c,v){if(!c.iconPath&&!v.iconPath)return 0;if(c.iconPath){if(!v.iconPath)return 1}else return-1;const y=typeof c.iconPath=="string"?c.iconPath:n.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,b=typeof v.iconPath=="string"?v.iconPath:n.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,m.comparePaths)(y,b)}function _(c,v){let y=0;if(c.strikeThrough!==v.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==v.faded)return c.faded?1:-1;if(c.tooltip!==v.tooltip)return(c.tooltip||"").localeCompare(v.tooltip||"");if(y=d(c,v),y!==0)return y;if(c.light&&v.light)y=d(c.light,v.light);else{if(c.light)return 1;if(v.light)return-1}if(y!==0)return y;if(c.dark&&v.dark)y=d(c.dark,v.dark);else{if(c.dark)return 1;if(v.dark)return-1}return y}function k(c,v){if(c.command!==v.command)return c.command<v.command?-1:1;if(c.title!==v.title)return c.title<v.title?-1:1;if(c.tooltip!==v.tooltip){if(c.tooltip!==void 0&&v.tooltip!==void 0)return c.tooltip<v.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(c.arguments===v.arguments)return 0;if(c.arguments)if(v.arguments){if(c.arguments.length!==v.arguments.length)return c.arguments.length-v.arguments.length}else return 1;else return-1;for(let y=0;y<c.arguments.length;y++){const b=c.arguments[y],$=v.arguments[y];if(b!==$)return b<$?-1:1}return 0}function p(c,v){let y=(0,m.comparePaths)(c.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(y!==0)return y;if(c.command&&v.command)y=k(c.command,v.command);else{if(c.command)return 1;if(v.command)return-1}if(y!==0)return y;if(c.decorations&&v.decorations)y=_(c.decorations,v.decorations);else{if(c.decorations)return 1;if(v.decorations)return-1}return y}function i(c,v){for(let y=0;y<c.length;y++)if(c[y]!==v[y])return!1;return!0}function l(c,v){return c.command===v.command&&c.title===v.title&&c.tooltip===v.tooltip&&(c.arguments&&v.arguments?i(c.arguments,v.arguments):c.arguments===v.arguments)}function s(c,v){return(0,D.equals)(c,v,l)}class o{get value(){return this._value}set value(v){v=v??"",Fe(this,u,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Fe(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Fe(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Fe(this,u,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Fe(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,y,b){this._extension=v,this._sourceControlHandle=b,u.set(this,void 0),this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,u,y,"f")}showValidationMessage(v,y){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,u,"f").$showValidationMessage(this._sourceControlHandle,v,y)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=o,u=new WeakMap;class f{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,y,b,$,G){this._proxy=v,this._commands=y,this._sourceControlHandle=b,this._id=$,this._label=G,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,y){const b=this._resourceStatesCommandsMap.get(v);return b?(0,A.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(p),b=(0,D.sortedDiff)(this._resourceSnapshot,v,p).map(Y=>{const K=Y.toInsert.map(N=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,N);const U=N.resourceUri;let z;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const H=new M.DisposableStore;z=this._commands.converter.toInternal(N.command,H),this._resourceStatesDisposablesMap.set(B,H)}else this._resourceStatesCommandsMap.set(B,N.command);const j=a(N.decorations),fe=N.decorations&&a(N.decorations.light)||j,_e=N.decorations&&a(N.decorations.dark)||j,ie=[fe,_e],le=N.decorations&&N.decorations.tooltip||"",ce=N.decorations&&!!N.decorations.strikeThrough,ke=N.decorations&&!!N.decorations.faded,de=N.contextValue||"";return{rawResource:[B,U,ie,le,ce,ke,de,z],handle:B}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:K}}),$=b.map(({start:Y,deleteCount:K,toInsert:N})=>[Y,K,N.map(B=>B.rawResource)]),G=b.reverse();for(const{start:Y,deleteCount:K,toInsert:N}of G){const B=N.map(z=>z.handle),U=this._handlesSnapshot.splice(Y,K,...B);for(const z of U)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=v,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}f._handlePool=0;class E{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Fe(this,t,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v;let y;(0,g.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(y=v?.label),Fe(this,t,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v,quickDiffLabel:y})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Fe(this,t,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const y=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Fe(this,t,"f").$updateSourceControl(this.handle,{acceptInputCommand:y})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const y=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(b=>b.map($=>this._commands.converter.toInternal($,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Fe(this,t,"f").$updateSourceControl(this.handle,{actionButton:y??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&s(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const y=(v||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));Fe(this,t,"f").$updateSourceControl(this.handle,{statusBarCommands:y})}get selected(){return this._selected}constructor(v,y,b,$,G,Y){this._extension=v,this._commands=b,this._id=$,this._label=G,this._rootUri=Y,t.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=E._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,t,y,"f"),this._inputBox=new o(v,Fe(this,t,"f"),this.handle),Fe(this,t,"f").$registerSourceControl(this.handle,$,G,Y)}createResourceGroup(v,y){const b=new f(Fe(this,t,"f"),this._commands,this.handle,v,y),$=T.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,$),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const v=[],y=[];for(const[b,$]of this.createdResourceGroups){$.dispose();const G=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});T.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),G.dispose(),this._groups.delete(b.handle),Fe(this,t,"f").$unregisterGroup(this.handle,b.handle)}),v.push([b.handle,b.id,b.label,b.features]);const Y=b._takeResourceStateSnapshot();Y.length>0&&y.push([b.handle,Y]),this._groups.set(b.handle,b)}Fe(this,t,"f").$registerGroups(this.handle,v,y),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(y=>{const b=y._takeResourceStateSnapshot();b.length!==0&&v.push([y.handle,b])}),v.length>0&&Fe(this,t,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Fe(this,t,"f").$unregisterSourceControl(this.handle)}}t=new WeakMap,E._handlePool=0,Ve([(0,C.debounce)(100)],E.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let r=class hn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,y,b){this._commands=y,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new S.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=v.getProxy(P.MainContext.MainThreadSCM),this._telemetry=v.getProxy(P.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const G=this._sourceControls.get($.sourceControlHandle);if(!G)return $;const Y=G.getResourceGroup($.groupHandle);return Y?Y.getResourceState($.handle):$}else if($&&$.$mid===4){const G=this._sourceControls.get($.sourceControlHandle);return G?G.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const G=this._sourceControls.get($.handle);return G||$}return $}})}createSourceControl(v,y,b,$){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,y,b,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const G=hn._handlePool++,Y=new E(v,this._proxy,this._commands,y,b,$);this._sourceControls.set(G,Y);const K=this._sourceControlsByExtension.get(v.identifier)||[];return K.push(Y),this._sourceControlsByExtension.set(v.identifier,K),Y}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const y=this._sourceControlsByExtension.get(v.identifier),b=y&&y[y.length-1];return b&&b.inputBox}$provideOriginalResource(v,y,b){const $=n.URI.revive(y);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,$.toString());const G=this._sourceControls.get(v);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>G.quickDiffProvider.provideOriginalResource($,b)).then(Y=>Y||null)}$onInputBoxValueChange(v,y){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const b=this._sourceControls.get(v);return b&&b.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(v,y,b,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,y,b);const G=this._sourceControls.get(v);if(!G)return Promise.resolve(void 0);const Y=G.getResourceGroup(y);return Y?Y.$executeResourceCommand(b,$):Promise.resolve(void 0)}$validateInput(v,y,b){this.logService.trace("ExtHostSCM#$validateInput",v);const $=this._sourceControls.get(v);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>$.inputBox.validateInput(y,b)).then(G=>{if(!G)return Promise.resolve(void 0);const Y=w.MarkdownString.fromStrict(G.message);return Y?Promise.resolve([Y,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};r._handlePool=0,r=Ve([He(2,R.ILogService)],r),e.ExtHostSCM=r}),define(Pe[80],Ae([1,0,5,4,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(P){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,m){return this._proxy.$setPassword(P,D,m)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[240],Ae([1,0,7,5,149,6,8,10]),function(ee,e,n,T,C,M,A,P){"use strict";var D,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(g,u,t,a,d=n.StatusBarAlignment.Left,_){D.set(this,void 0),m.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._staleCommandRegistrations=new M.DisposableStore,Je(this,D,g,"f"),Je(this,m,u,"f"),this._entryId=R.ID_GEN++,this._extension=t,this._id=a,this._alignment=d,this._priority=this.validatePriority(_)}validatePriority(g){if(!!(0,P.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!R.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new M.DisposableStore,typeof g=="string"?this._command={fromApi:g,internal:Fe(this,m,"f").toInternal({title:"",command:g},this._latestCommandRegistration)}:g?this._command={fromApi:g,internal:Fe(this,m,"f").toInternal(g,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let u;this._name?u=this._name:u=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let t=this._color;this._backgroundColor&&(t=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=A.MarkdownString.fromStrict(this._tooltip);Fe(this,D,"f").$setEntry(this._entryId,g,u,this._text,a,this._command?.internal,t,this._backgroundColor,this._alignment===n.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}D=new WeakMap,m=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=R;class S{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const u={message:g};return this._messages.unshift(u),this._update(),new n.Disposable(()=>{const t=this._messages.indexOf(u);t>=0&&(this._messages.splice(t,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class h{constructor(g,u){this._proxy=g.getProxy(T.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new S(this)}createStatusBarEntry(g,u,t,a){return new R(this._proxy,this._commands,g,u,t,a)}setStatusBarMessage(g,u){const t=this._statusMessage.setMessage(g);let a;return typeof u=="number"?a=setTimeout(()=>t.dispose(),u):typeof u<"u"&&u.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=h}),define(Pe[81],Ae([1,0,5,4,3]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(P,D){this._logService=D,this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}async initializeExtensionStorage(P,D,m){const R=await this._proxy.$initializeExtensionStorage(P,D);let S;return R&&(S=this.safeParseValue(P,D,R)),S||m}setValue(P,D,m){return this._proxy.$setValue(P,D,m)}$acceptValue(P,D,m){const R=this.safeParseValue(P,D,m);R&&this._onDidChangeStorage.fire({shared:P,key:D,value:R})}safeParseValue(P,D,m){try{return JSON.parse(m)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${P}): ${R}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Pe[82],Ae([1,0,3,27,14,61,2]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let P=class{constructor(m,R,S){this._logService=R,this._extHostFileSystem=S,this._workspace=m.workspace??void 0,this._environment=m.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getWorkspaceStorageURI(m){return A.URI.joinPath(this._environment.workspaceStorageHome,m)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const m=this._workspace.id,R=await this._getWorkspaceStorageURI(m);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(m){if(this._value)return A.URI.joinPath(this._value,m.identifier.value)}globalValue(m){return A.URI.joinPath(this._environment.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Ve([He(0,T.IExtHostInitDataService),He(1,C.ILogService),He(2,M.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Pe[62],Ae([1,0,4,5,3,2,18,6,7,151,9,177,21,35,178,39,10,17,8]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class _{constructor(r,c,v,y){this._proxy=r,this._id=c,this._creationOptions=v,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise($=>this._pidPromiseComplete=$);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText($,G=!0){b._checkDisposed(),b._proxy.$sendText(b._id,$,G)},show($){b._checkDisposed(),b._proxy.$show(b._id,$)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(r,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,t.withNullAsUndefined)(r.shellPath),shellArgs:(0,t.withNullAsUndefined)(r.shellArgs),cwd:(0,t.withNullAsUndefined)(r.cwd),env:(0,t.withNullAsUndefined)(r.env),icon:(0,t.withNullAsUndefined)(o(r.iconPath)),color:u.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,t.withNullAsUndefined)(r.message),strictEnv:(0,t.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(r.location,c?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,c,v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:u.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(r,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,c){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in r?{viewColumn:d.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitStatus(r,c){this._exitStatus=Object.freeze({code:r,reason:c})}setDimensions(r,c){return r===this._cols&&c===this._rows||r===0||c===0?!1:(this._cols=r,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=_;class k{get onProcessReady(){return this._onProcessReady.event}constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new n.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new n.Emitter,this._onDidChangeProperty=new n.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new n.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput?.(r)}resize(r,c){this._pty.setDimensions?.({columns:r,rows:c})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(r||void 0),r&&this._pty.setDimensions?.(r),this._onProcessReady.fire({pid:-1,cwd:""})}}let p=1,i=class extends P.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(r,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new n.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new n.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new n.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new n.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new n.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new n.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=c.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new n.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[v,y]of this._terminalProcesses)y.shutdown(!0)}})}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,c){const v=new _(this._proxy,(0,w.generateUuid)(),r,r.name),y=new k(r.pty);return v.createExtensionTerminal(r.location,this._serializeParentTerminal(r,c).resolvedExtHostIdentifier,o(r.iconPath),f(r.color)).then(b=>{const $=this._setupExtHostProcessListeners(b,y);this._terminalProcessDisposables[b]=$}),this._terminals.push(v),v.value}_serializeParentTerminal(r,c){if(c=c||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const y=this._terminals.find(b=>b.value===v);y&&(c.resolvedExtHostIdentifier=y._id)}}else r.location&&typeof r.location!="object"?c.location=r.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(r,c){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const y=new k(c),b=this._setupExtHostProcessListeners(r,y);this._terminalProcessDisposables[r]=b}async $acceptActiveTerminalChanged(r){const c=this._activeTerminal;if(r===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(r);v&&(this._activeTerminal=v,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,c){const v=this._getTerminalById(r);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:c})}async $acceptTerminalDimensions(r,c,v){const y=this._getTerminalById(r);y&&y.setDimensions(c,v)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(r,c,v){this._terminalProcesses.get(r)?.resize(c,v)}async $acceptTerminalTitleChange(r,c){const v=this._getTerminalById(r);v&&(v.name=c)}async $acceptTerminalClosed(r,c,v){const y=this._getTerminalObjectIndexById(this._terminals,r);if(y!==null){const b=this._terminals.splice(y,1)[0];b.setExitStatus(c,v),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(r,c,v,y){if(c){const G=this._getTerminalObjectIndexById(this._terminals,c);if(G!==null){this._terminals[G]._id=r,this._onDidOpenTerminal.fire(this.terminals[G]),this._terminals[G].isOpen=!0;return}}const b={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:M.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},$=new _(this._proxy,r,b,v);this._terminals.push($),this._onDidOpenTerminal.fire($.value),$.isOpen=!0}async $acceptTerminalProcessId(r,c){this._getTerminalById(r)?._setProcessId(c)}async $startExtensionTerminal(r,c){const v=this._getTerminalById(r);if(!v)return{message:(0,m.localize)(0,null,r)};v.isOpen||await new Promise(b=>{const $=this.onDidOpenTerminal(async G=>{G===v.value&&($.dispose(),b())})});const y=this._terminalProcesses.get(r);y?y.startSendingEvents(c):this._extensionTerminalAwaitingStart[r]={initialDimensions:c}}_setupExtHostProcessListeners(r,c){const v=new P.DisposableStore;v.add(c.onProcessReady(b=>this._proxy.$sendProcessReady(r,b.pid,b.cwd))),v.add(c.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(r,b))),this._bufferer.startBuffering(r,c.onProcessData),v.add(c.onProcessExit(b=>this._onProcessExit(r,b))),this._terminalProcesses.set(r,c);const y=this._extensionTerminalAwaitingStart[r];return y&&c instanceof k&&(c.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),v}$acceptProcessAckDataEvent(r,c){this._terminalProcesses.get(r)?.acknowledgeDataEvent(c)}$acceptProcessInput(r,c){this._terminalProcesses.get(r)?.input(c)}$acceptTerminalInteraction(r){const c=this._getTerminalById(r);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(r,c,v){try{this._terminalProcesses.get(r)?.resize(c,v)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(r,c){this._terminalProcesses.get(r)?.shutdown(c)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(r,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(c=>this._proxy.$sendProcessProperty(r,{type:"cwd",value:c}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,c,v){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,v),this._proxy.$registerProfileProvider(c,r.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}registerTerminalQuickFixProvider(r,c,v){if(this._quickFixProviders.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this._quickFixProviders.set(r,v),this._proxy.$registerQuickFixProvider(r,c),new D.Disposable(()=>{this._quickFixProviders.delete(r),this._proxy.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,c){const v=new h.CancellationTokenSource().token;if(v.isCancellationRequested)return;const y=this._quickFixProviders.get(r);if(!y)return;const b=await y.provideTerminalQuickFixes(c,v);if(b!==null)return b}async $createContributedProfileTerminal(r,c){const v=new h.CancellationTokenSource().token;let y=await this._profileProviders.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,c);return}this.createTerminalFromOptions(y.options,c)}}async $provideLinks(r,c){const v=this._getTerminalById(r);if(!v)return[];this._terminalLinkCache.delete(r),this._terminalLinkCancellationSource.get(r)?.dispose(!0);const b=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,b);const $=[],G={terminal:v.value,line:c},Y=[];for(const B of this._linkProviders)Y.push(a.Promises.withAsyncBody(async U=>{b.token.onCancellationRequested(()=>U({provider:B,links:[]}));const z=await B.provideTerminalLinks(G,b.token)||[];b.token.isCancellationRequested||U({provider:B,links:z})}));const K=await Promise.all(Y);if(b.token.isCancellationRequested)return[];const N=new Map;for(const B of K)B&&B.links.length>0&&$.push(...B.links.map(U=>{const z={id:p++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return N.set(z.id,{provider:B.provider,link:U}),z}));return this._terminalLinkCache.set(r,N),$}$activateLink(r,c){const v=this._terminalLinkCache.get(r)?.get(c);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(r,c){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const v=this._terminalProcessDisposables[r];v&&(v.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,c)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,c){const v=this._getTerminalObjectIndexById(r,c);return v!==null?r[v]:null}_getTerminalObjectIndexById(r,c){let v=null;return r.some((y,b)=>y._id===c?(v=b,!0):!1),v}getEnvironmentVariableCollection(r){let c=this._environmentVariableCollections.get(r.identifier.value);return c||(c=new l,this._setEnvironmentVariableCollection(r.identifier.value,c)),c}_syncEnvironmentVariableCollection(r,c){const v=(0,S.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(r,c.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(r){r.forEach(c=>{const v=c[0],y=new l(c[1]);this._setEnvironmentVariableCollection(v,y)})}$acceptDefaultProfile(r,c){const v=this._defaultProfile;this._defaultProfile=r,this._defaultAutomationProfile=c,v?.path!==r.path&&this._onDidChangeShell.fire(r.path)}_setEnvironmentVariableCollection(r,c){this._environmentVariableCollections.set(r,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,c)})}};i=Ve([He(1,A.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class l{get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new n.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,c){this._setIfDiffers(r,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(r,c){this._setIfDiffers(r,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(r,c){this._setIfDiffers(r,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,c){const v=this.map.get(r);(!v||v.value!==c.value||v.type!==c.type)&&(this.map.set(r,c),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,c){this.map.forEach((v,y)=>r.call(c,y,v,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}let s=class extends i{constructor(r){super(!1,r)}createTerminal(r,c,v){throw new R.NotSupportedError}createTerminalFromOptions(r,c){throw new R.NotSupportedError}};s=Ve([He(0,A.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function o(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function f(E){return u.ThemeColor.isThemeColor(E)?E:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Pe[241],Ae([1,0,16,17,25,21,4,201,91,6,23,10,35,5,18,103,8,7,45,74,56]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k){"use strict";var p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let l=class{constructor(N,B,U){this.editors=U,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(w.MainContext.MainThreadTesting),this.observer=new $(this.proxy),this.runTracker=new E(this.proxy),B.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const j=z,fe=j.tests[j.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(fe))?.collection.tree.get(fe)?.actual??(0,u.toItemFromContext)(z)}})}createTestController(N,B,U,z){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const j=new m.DisposableStore,fe=j.add(new u.ExtHostTestItemCollection(B,U,this.editors));fe.root.label=U;const _e=new Map,ie=this.proxy,le={items:fe.root.children,get label(){return U},set label(ke){U=ke,fe.root.label=ke,ie.$updateController(B,{label:U})},get refreshHandler(){return z},set refreshHandler(ke){z=ke,ie.$updateController(B,{canRefresh:!!ke})},get id(){return B},createRunProfile:(ke,de,ae,H,O,X)=>{let pe=(0,D.hash)(ke);for(;_e.has(pe);)pe++;return new G(this.proxy,_e,B,pe,ke,de,ae,H,O,X)},createTestItem(ke,de,ae){return new u.TestItemImpl(B,ke,de,ae)},createTestRun:(ke,de,ae=!0)=>this.runTracker.createTestRun(B,fe,ke,de,ae),set resolveHandler(ke){fe.resolveHandler=ke},get resolveHandler(){return fe.resolveHandler},dispose:()=>{j.dispose()}};ie.$registerTestController(B,U,!!z),j.add((0,m.toDisposable)(()=>ie.$unregisterTestController(B)));const ce={controller:le,collection:fe,profiles:_e};return this.controllers.set(B,ce),j.add((0,m.toDisposable)(()=>this.controllers.delete(B))),j.add(fe.onDidGenerateDiff(ke=>ie.$publishDiff(B,ke.map(k.TestsDiffOp.serialize)))),le}createTestObserver(){return this.observer.checkout()}async runTests(N,B=M.CancellationToken.None){const U=r(N);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(U.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(j=>d.TestId.fromExtHostTestItem(j,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:Y[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:N.exclude?.map(j=>j.id)},B)}$syncTests(){for(const{collection:N}of this.controllers.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,B,U){return(0,n.mapFind)(this.runTracker.trackers,j=>j.id===N?j.getCoverage(B):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(N,B,U,z){return(0,n.mapFind)(this.runTracker.trackers,fe=>fe.id===N?fe.getCoverage(B):void 0)?.resolveFileCoverage(U,z)??Promise.resolve([])}$configureRunProfile(N,B){this.controllers.get(N)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(N,B){await this.controllers.get(N)?.controller.refreshHandler?.(B)}$publishTestResults(N){this.results=Object.freeze(N.map(B=>(0,R.deepFreeze)(t.TestResults.to(B))).concat(this.results).sort((B,U)=>U.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,B){const U=this.controllers.get(d.TestId.fromString(N).controllerId)?.collection;U&&(await U.expand(N,B<0?1/0:B),U.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(k.TestsDiffOp.deserialize))}async $runControllerTests(N,B){return Promise.all(N.map(U=>this.runControllerTestRequest(U,!1,B)))}async $startContinuousRun(N,B){const U=new M.CancellationTokenSource(B),z=await Promise.all(N.map(j=>this.runControllerTestRequest(j,!0,U.token)));return!B.isCancellationRequested&&!z.some(j=>j.error)&&await new Promise(j=>B.onCancellationRequested(j)),U.dispose(!0),z}async runControllerTestRequest(N,B,U){const z=this.controllers.get(N.controllerId);if(!z)return{};const{collection:j,profiles:fe}=z,_e=fe.get(N.profileId);if(!_e)return{};const ie=N.testIds.map(de=>j.tree.get(de)).filter(S.isDefined),le=N.excludeExtIds.map(de=>z.collection.tree.get(de)).filter(S.isDefined).filter(de=>ie.some(ae=>ae.fullId.compare(de.fullId)===2));if(!ie.length)return{};const ce=new a.TestRunRequest(ie.some(de=>de.actual instanceof u.TestItemRootImpl)?void 0:ie.map(de=>de.actual),le.map(de=>de.actual),_e,B),ke=(0,k.isStartControllerTests)(N)&&this.runTracker.prepareForMainThreadTestRun(ce,c.fromInternal(N,z.collection),U);try{return await _e.runHandler(ce,U),{}}catch(de){return{error:String(de)}}finally{ke&&(ke.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(ke.onEnd),ke.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};l=Ve([He(0,g.IExtHostRpcService)],l),e.ExtHostTesting=l;const s=1e4;var o;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(o||(o={}));class f extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(N,B,U){super(),this.dto=N,this.proxy=B,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.onEnd=this.endEmitter.event,this.cts=this._register(new M.CancellationTokenSource(U));const z=this._register(new T.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const B=this.dto.id,U=this.dto.controllerId,z=(0,h.generateUuid)(),j=new v(this.proxy,B,z),fe=ce=>(ke,...de)=>{if(ie){console.warn(`Setting the state of test "${ke.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ke)||(this.ensureTestIsKnown(ke),ce(ke,...de))},_e=(ce,ke)=>{const de=ke instanceof Array?ke.map(t.TestMessage.from):[t.TestMessage.from(ke)];if(ce.uri&&ce.range){const ae={range:t.Range.from(ce.range),uri:ce.uri};for(const H of de)H.location=H.location||ae}this.proxy.$appendTestMessagesInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),de)};let ie=!1;const le={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return j.coverageProvider},set coverageProvider(ce){j.coverageProvider=ce},enqueued:fe(ce=>{this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),1)}),skipped:fe(ce=>{this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),5)}),started:fe(ce=>{this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),2)}),errored:fe((ce,ke,de)=>{_e(ce,ke),this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),6,de)}),failed:fe((ce,ke,de)=>{_e(ce,ke),this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,U).toString(),4,de)}),passed:fe((ce,ke)=>{this.proxy.$updateTestStateInRun(B,z,d.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,ke)}),appendOutput:(ce,ke,de)=>{ie||(de&&(this.dto.isIncluded(de)?this.ensureTestIsKnown(de):de=void 0),this.proxy.$appendOutputToRun(B,z,C.VSBuffer.fromString(ce),ke&&t.location.from(ke),de&&d.TestId.fromExtHostTestItem(de,U).toString()))},end:()=>{ie||(ie=!0,this.proxy.$finishedTestRunTask(B,z),this.tasks.delete(z),this.tasks.size||this.markEnded())}};return this.tasks.set(z,{run:le,coverage:j}),this.proxy.$startedTestRunTask(B,{id:z,name:N,running:!0}),le}forciblyEndTasks(){for(const{run:N}of this.tasks.values())N.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(N){if(!(N instanceof u.TestItemImpl))throw new _.InvalidTestItemError(N.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const B=[],U=this.dto.colllection.root;for(;;){const z=t.TestItem.from(N);if(B.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),N===U))break;N=N.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class E{get trackers(){return this.tracked.values()}constructor(N){this.proxy=N,this.tracked=new Map}prepareForMainThreadTestRun(N,B,U){return this.getTracker(N,B,U)}cancelRunById(N){for(const B of this.tracked.values())if(B.id===N){B.cancel();return}}cancelAllRuns(){for(const N of this.tracked.values())N.cancel()}createTestRun(N,B,U,z,j){const fe=this.tracked.get(U);if(fe)return fe.createRun(z);const _e=c.fromPublic(N,B,U,j),ie=r(U);this.proxy.$startedExtensionTestRun({controllerId:N,continuous:!!U.continuous,profile:ie&&{group:Y[ie.kind],id:ie.profileId},exclude:U.exclude?.map(ce=>d.TestId.fromExtHostTestItem(ce,B.root.id).toString())??[],id:_e.id,include:U.include?.map(ce=>d.TestId.fromExtHostTestItem(ce,B.root.id).toString())??[B.root.id],persist:j});const le=this.getTracker(U,_e);return le.onEnd(()=>{this.proxy.$finishedExtensionTestRun(_e.id),le.dispose()}),le.createRun(z)}getTracker(N,B,U){const z=new f(B,this.proxy,U);return this.tracked.set(N,z),z.onEnd(()=>this.tracked.delete(N)),z}}e.TestRunCoordinator=E;const r=K=>{if(!!K.profile){if(!(K.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class c{static fromPublic(N,B,U,z){return new c(N,(0,h.generateUuid)(),U.include?.map(j=>d.TestId.fromExtHostTestItem(j,N).toString())??[N],U.exclude?.map(j=>d.TestId.fromExtHostTestItem(j,N).toString())??[],z,B)}static fromInternal(N,B){return new c(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,B)}constructor(N,B,U,z,j,fe){this.controllerId=N,this.id=B,this.isPersisted=j,this.colllection=fe,this.includePrefix=U.map(_e=>_e+"\0"),this.excludePrefix=z.map(_e=>_e+"\0")}isIncluded(N){const B=d.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(B===U||B.startsWith(U))return!1;for(const U of this.includePrefix)if(B===U||B.startsWith(U))return!0;return!1}}e.TestRunDto=c;class v{set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(N,B,U){this.proxy=N,this.runId=B,this.taskId=U}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(N,B){const U=await this.fileCoverage;let z=U?.[N];return!this._coverageProvider||!U||!z?[]:(z.detailedCoverage||(z=U[N]=await this._coverageProvider.resolveFileCoverage?.(z,B)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class y{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(N){this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(N){this.added.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}this.updated.delete(N);const B=d.TestId.parentId(N.item.extId);if(B&&this.alreadyRemoved.has(B.toString())){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:B,removed:U}=this;return{get added(){return[...N].map(z=>z.revived)},get updated(){return[...B].map(z=>z.revived)},get removed(){return[...U].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class b extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,B){return{...N,revived:t.TestItem.toPlain(N.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new y(this.changeEmitter)}}class ${constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(B=>B.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new b;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class G{get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Fe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(N){N!==this._supportsContinuousRun&&(this._supportsContinuousRun=N,Fe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Fe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Fe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Fe(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,B,U,z,j,fe,_e,ie=!1,le=void 0,ce=!1){this.controllerId=U,this.profileId=z,this._label=j,this.kind=fe,this.runHandler=_e,this._isDefault=ie,this._tag=le,this._supportsContinuousRun=ce,p.set(this,void 0),i.set(this,void 0),Je(this,p,N,"f"),Je(this,i,B,"f"),B.set(z,this);const ke=Y[fe];if(typeof ke!="number")throw new Error(`Unknown TestRunProfile.group ${fe}`);Fe(this,p,"f").$publishTestRunProfile({profileId:z,controllerId:U,tag:le?t.TestTag.namespace(this.controllerId,le.id):null,label:j,group:ke,isDefault:ie,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Fe(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Fe(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=G,p=new WeakMap,i=new WeakMap;const Y={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Pe[242],Ae([1,0,16,9,4,5,104,8,7]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(S,h){this._extHostDocumentsAndEditors=h,this._onDidChangeTextEditorSelection=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new C.Emitter({onListenerError:T.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=S.getProxy(M.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(S){const h=this._extHostDocumentsAndEditors.allEditors();return S?h:h.map(w=>w.value)}async showTextDocument(S,h,w){let g;typeof h=="number"?g={position:P.ViewColumn.from(h),preserveFocus:w}:typeof h=="object"?g={position:P.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?P.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(S.uri,g),t=u&&this._extHostDocumentsAndEditors.getEditor(u);if(t)return t.value;throw u?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,h){return new A.TextEditorDecorationType(this._proxy,S,h).value}$acceptEditorPropertiesChanged(S,h){const w=this._extHostDocumentsAndEditors.getEditor(S);if(!w)throw new Error("unknown text editor");if(h.options&&w._acceptOptions(h.options),h.selections){const g=h.selections.selections.map(P.Selection.to);w._acceptSelections(g)}if(h.visibleRanges){const g=n.coalesce(h.visibleRanges.map(P.Range.to));w._acceptVisibleRanges(g)}if(h.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:{...h.options,lineNumbers:P.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const g=D.TextEditorSelectionChangeKind.fromValue(h.selections.source),u=h.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:u,kind:g})}if(h.visibleRanges){const g=n.coalesce(h.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:g})}}$acceptEditorPositionData(S){for(const h in S){const w=this._extHostDocumentsAndEditors.getEditor(h);if(!w)throw new Error("Unknown text editor");const g=P.ViewColumn.to(S[h]);w.value.viewColumn!==g&&(w._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:g}))}}getDiffInformation(S){return Promise.resolve(this._proxy.$getDiffInformation(S))}}e.ExtHostEditors=m}),define(Pe[243],Ae([1,0,2,3,5,6,7,8,24,10]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class R{constructor(w,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=w.getProxy(C.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(u,t)=>{if(u&&u.$mid===12)if(this._providers.get(u.source)&&D.ExtensionIdentifier.equals(t,this._providers.get(u.source)?.extension)){const a=u.uri===void 0?void 0:n.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(S(a))?.get(u.handle)}else return;return u}})}async $getTimeline(w,g,u,t){return this._providers.get(w)?.provider.provideTimeline(n.URI.revive(g),u,t)}registerTimelineProvider(w,g,u,t){const a=new M.DisposableStore,d=this.convertTimelineItem(g.id,t,a).bind(this);let _;g.onDidChange&&(_=g.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:w,onDidChange:void 0,async provideTimeline(p,i,l){i?.resetCache&&(a.clear(),k.get(g.id)?.clear());const s=await g.provideTimeline(p,i,l);if(s==null)return;const o=d(p,i);return{...s,source:g.id,items:s.items.map(o)}},dispose(){for(const p of k.values())p.get(g.id)?.clear();_?.dispose(),a.dispose()}},u)}convertTimelineItem(w,g,u){return(t,a)=>{let d;if(a?.cacheResults){let _=this._itemsBySourceAndUriMap.get(w);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(w,_));const k=S(t);d=_.get(k),d===void 0&&(d=new Map,_.set(k,d))}return _=>{const{iconPath:k,...p}=_,i=`${w}|${_.id??_.timestamp}`;d?.set(i,_);let l,s,o;_.iconPath&&(k instanceof A.ThemeIcon?o={id:k.id,color:k.color}:n.URI.isUri(k)?(l=k,s=k):{light:l,dark:s}=k);let f;return A.MarkdownString.isMarkdownString(p.tooltip)?f=P.MarkdownString.from(p.tooltip):(0,m.isString)(p.tooltip)?f=p.tooltip:A.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=P.MarkdownString.from(p.detail)):(0,m.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=p.detail),{...p,id:p.id??void 0,handle:i,source:w,command:_.command?g.toInternal(_.command,u):void 0,icon:l,iconDark:s,themeIcon:o,tooltip:f,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(w,g){if(this._providers.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this._proxy.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this._providers.set(w.id,{provider:w,extension:g}),(0,M.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(w.id)?.clear();this._providers.delete(w.id),this._proxy.$unregisterTimelineProvider(w.id),w.dispose()})}}e.ExtHostTimeline=R;function S(h){return h?.toString()}}),define(Pe[244],Ae([1,0,6,15,2,5]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,m,R,S){if(this._openers.has(m))throw new Error(`Opener with id '${m}' already registered`);const h=S.schemes.find(w=>!A.supportedSchemes.has(w));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(m,R),this._proxy.$registerUriOpener(m,S.schemes,D,S.label),(0,n.toDisposable)(()=>{this._openers.delete(m),this._proxy.$unregisterUriOpener(m)})}async $canOpenUri(D,m,R){const S=this._openers.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const h=C.URI.revive(m);return S.canOpenExternalUri(h,R)}async $openUri(D,m,R){const S=this._openers.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(C.URI.revive(m.resolvedUri),{sourceUri:C.URI.revive(m.sourceUri)},R)}}A.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https]),e.ExtHostUriOpeners=A}),define(Pe[245],Ae([1,0,5,2,6,9,24]),function(ee,e,n,T,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(m){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=m.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(m,R){if(this.handles.has(m))throw new Error(`Protocol handler already registered for extension ${m}`);const S=P.HandlePool++;return this.handles.add(m),this.handlers.set(S,R),this._proxy.$registerUriHandler(S,m),(0,C.toDisposable)(()=>{this.handles.delete(m),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(m,R){const S=this.handlers.get(m);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(R))}catch(h){(0,M.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(m){return T.URI.revive(await this._proxy.$createAppUri(m))}}P.HandlePool=0,e.ExtHostUrls=P});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[63],Ae([1,0,4,15,23,2,164,187,75,5]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";var R,S,h,w,g,u,t,a,d,_,k,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(b,$,G,Y,K,N,B){R.set(this,void 0),S.set(this,void 0),h.set(this,void 0),w.set(this,void 0),g.set(this,void 0),u.set(this,void 0),t.set(this,""),a.set(this,void 0),d.set(this,!1),_.set(this,!1),k.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Fe(this,i,"f").event,Je(this,R,b,"f"),Je(this,S,$,"f"),Je(this,a,G,"f"),Je(this,w,Y,"f"),Je(this,g,K,"f"),Je(this,u,N,"f"),Je(this,k,s(N),"f"),Je(this,p,o(N),"f"),Je(this,h,B,"f")}dispose(){Je(this,d,!0,"f"),Fe(this,i,"f").fire(),Fe(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Je(this,_,!0,"f"),(0,D.asWebviewUri)(b,Fe(this,w,"f"))}get cspSource(){const b=Fe(this,u,"f").extensionLocation;if(b.scheme===T.Schemas.https||b.scheme===T.Schemas.http){let $=b.toString();return $.endsWith("/")||($+="/"),$+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,t,"f")}set html(b){this.assertNotDisposed(),Fe(this,t,"f")!==b&&(Je(this,t,b,"f"),Fe(this,p,"f")&&!Fe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Je(this,_,!0,"f"),Fe(this,h,"f").report("Webview vscode-resource: uris",Fe(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,S,"f").$setHtml(Fe(this,R,"f"),this.rewriteOldResourceUrlsIfNeeded(b)))}get options(){return this.assertNotDisposed(),Fe(this,a,"f")}set options(b){this.assertNotDisposed(),C.equals(Fe(this,a,"f"),b)||Fe(this,S,"f").$setOptions(Fe(this,R,"f"),r(Fe(this,u,"f"),Fe(this,g,"f"),b)),Je(this,a,b,"f")}async postMessage(b){if(Fe(this,d,"f"))return!1;const $=(0,P.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Fe(this,k,"f")});return Fe(this,S,"f").$postMessage(Fe(this,R,"f"),$.message,...$.buffers)}assertNotDisposed(){if(Fe(this,d,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(b){if(!Fe(this,p,"f"))return b;const $=Fe(this,u,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,G=Fe(this,u,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Fe(this,u,"f").extensionLocation.authority:void 0;return b.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,K,N,B,U,z)=>{const j=M.URI.from({scheme:B||"file",path:decodeURIComponent(U)}),fe=(0,D.asWebviewUri)(j,{isRemote:$,authority:G}).toString();return`${K}${fe}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,K,N,B,U,z)=>{const j=M.URI.from({scheme:B||"file",path:decodeURIComponent(U)}),fe=(0,D.asWebviewUri)(j,{isRemote:$,authority:G}).toString();return`${K}${fe}${z}`})}}e.ExtHostWebview=l,R=new WeakMap,S=new WeakMap,h=new WeakMap,w=new WeakMap,g=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap,_=new WeakMap,k=new WeakMap,p=new WeakMap,i=new WeakMap;function s(y){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(y.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function o(y){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(y.engines.vscode));return b?b.majorBase<1||b.majorBase===1&&b.minorBase<60:!1}catch{return!1}}class f{constructor(b,$,G,Y,K){this.remoteInfo=$,this.workspace=G,this._logService=Y,this._deprecationService=K,this._webviews=new Map,this._webviewProxy=b.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(b,$,G){const Y=this.getWebview(b);if(Y){const{message:K}=(0,P.deserializeWebviewMessage)($,G.value);Y._onMessageEmitter.fire(K)}}$onMissingCsp(b,$){this._logService.warn(`${$} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,$,G){const Y=new l(b,this._webviewProxy,c($),this.remoteInfo,this.workspace,G,this._deprecationService);return this._webviews.set(b,Y),Y._onDidDispose(()=>{this._webviews.delete(b)}),Y}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=f;function E(y){return{id:y.identifier,location:y.extensionLocation}}e.toExtensionData=E;function r(y,b,$){return{enableCommandUris:$.enableCommandUris,enableScripts:$.enableScripts,enableForms:$.enableForms,portMapping:$.portMapping,localResourceRoots:$.localResourceRoots||v(y,b)}}e.serializeWebviewOptions=r;function c(y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots?.map(b=>M.URI.from(b))}}function v(y,b){return[...(b?.getWorkspaceFolders()||[]).map($=>$.uri),y.extensionLocation]}}),define(Pe[246],Ae([1,0,21,91,6,15,22,2,8,63,54,5,7]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(l,s){this.document=l,this._storagePath=s,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,s){await this.getEdit(l).undo(),s||this.disposeBackup()}async redo(l,s){await this.getEdit(l).redo(),s||this.disposeBackup()}disposeEdits(l){for(const s of l)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const s=this._edits.get(l,0);if(!s)throw new Error("No edit found");return s}}class g{constructor(){this._documents=new Map}get(l,s){return this._documents.get(this.key(l,s))}add(l,s,o){const f=this.key(l,s.uri);if(this._documents.has(f))throw new Error(`Document already exists for viewType:${l} resource:${s.uri}`);const E=new w(s,o);return this._documents.set(f,E),E}delete(l,s){const o=this.key(l,s.uri);this._documents.delete(o)}key(l,s){return`${l}@@@${s}`}}var u;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(u||(u={}));class t{constructor(){this._providers=new Map}addTextProvider(l,s,o){return this.add(0,l,s,o)}addCustomProvider(l,s,o){return this.add(1,l,s,o)}get(l){return this._providers.get(l)}add(l,s,o,f){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:l,extension:o,provider:f}),new h.Disposable(()=>this._providers.delete(s))}}class a{constructor(l,s,o,f,E){this._extHostDocuments=s,this._extensionStoragePaths=o,this._extHostWebview=f,this._extHostWebviewPanels=E,this._editorProviders=new t,this._documents=new g,this._proxy=l.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,s,o,f){const E=new C.DisposableStore;return _(o)?(E.add(this._editorProviders.addTextProvider(s,l,o)),this._proxy.$registerTextEditorProvider((0,m.toExtensionData)(l),s,f.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(l))):(E.add(this._editorProviders.addCustomProvider(s,l,o)),d(o)&&E.add(o.onDidChangeCustomDocument(r=>{const c=this.getCustomDocumentEntry(s,r.document.uri);if(k(r)){const v=c.addEdit(r);this._proxy.$onDidEdit(r.document.uri,s,v,r.label)}else this._proxy.$onContentChange(r.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,m.toExtensionData)(l),s,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(l))),h.Disposable.from(E,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(l,s,o,f,E){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${s}'`);const c=P.URI.revive(l),v=await r.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:f?.buffer},E);let y;return d(r.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension)),this._documents.add(s,v,y),{editable:d(r.provider)}}async $disposeCustomDocument(l,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const f=P.URI.revive(l),{document:E}=this.getCustomDocumentEntry(s,f);this._documents.delete(s,E),E.dispose()}async $resolveCustomEditor(l,s,o,f,E,r){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const v=D.ViewColumn.to(E),y=this._extHostWebview.createNewWebview(s,f.contentOptions,c.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(s,o,f.title,v,f.options,y,!0),$=P.URI.revive(l);switch(c.type){case 1:{const{document:G}=this.getCustomDocumentEntry(o,$);return c.provider.resolveCustomEditor(G,b,r)}case 0:{const G=this._extHostDocuments.getDocument($);return c.provider.resolveCustomTextEditor(G,b,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,s,o){this.getCustomDocumentEntry(s,l).disposeEdits(o)}async $onMoveCustomEditor(l,s,o){const f=this._editorProviders.get(o);if(!f)throw new Error(`No provider found for '${o}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const E=this._extHostWebviewPanels.getWebviewPanel(l);if(!E)throw new Error("No webview found");const r=P.URI.revive(s),c=this._extHostDocuments.getDocument(r);await f.provider.moveCustomTextEditor(c,E,n.CancellationToken.None)}async $undo(l,s,o,f){return this.getCustomDocumentEntry(s,l).undo(o,f)}async $redo(l,s,o,f){return this.getCustomDocumentEntry(s,l).redo(o,f)}async $revert(l,s,o){const f=this.getCustomDocumentEntry(s,l);await this.getCustomEditorProvider(s).revertCustomDocument(f.document,o),f.disposeBackup()}async $onSave(l,s,o){const f=this.getCustomDocumentEntry(s,l);await this.getCustomEditorProvider(s).saveCustomDocument(f.document,o),f.disposeBackup()}async $onSaveAs(l,s,o,f){const E=this.getCustomDocumentEntry(s,l);return this.getCustomEditorProvider(s).saveCustomDocumentAs(E.document,P.URI.revive(o),f)}async $backup(l,s,o){const f=this.getCustomDocumentEntry(s,l),r=await this.getCustomEditorProvider(s).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},o);return f.updateBackup(r),r.id}getCustomDocumentEntry(l,s){const o=this._documents.get(l,P.URI.revive(s));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(l){const o=this._editorProviders.get(l)?.provider;if(!o||!d(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=a;function d(i){return!!i.onDidChangeCustomDocument}function _(i){return typeof i.resolveCustomTextEditor=="function"}function k(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const l=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[247],Ae([1,0,4,6,2,35,8,63,5,7]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";var R,S,h,w,g,u,t,a,d,_,k,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends T.Disposable{constructor(E,r,c,v){super(),R.set(this,void 0),S.set(this,void 0),h.set(this,void 0),w.set(this,void 0),g.set(this,void 0),u.set(this,void 0),t.set(this,void 0),a.set(this,void 0),d.set(this,!0),_.set(this,void 0),k.set(this,!1),p.set(this,this._register(new n.Emitter)),this.onDidDispose=Fe(this,p,"f").event,i.set(this,this._register(new n.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,Je(this,R,E,"f"),Je(this,S,r,"f"),Je(this,w,c,"f"),Je(this,h,v.viewType,"f"),Je(this,g,v.panelOptions,"f"),Je(this,a,v.viewColumn,"f"),Je(this,u,v.title,"f"),Je(this,_,v.active,"f")}dispose(){Fe(this,k,"f")||(Je(this,k,!0,"f"),Fe(this,p,"f").fire(),Fe(this,S,"f").$disposeWebview(Fe(this,R,"f")),Fe(this,w,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,w,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,h,"f")}get title(){return this.assertNotDisposed(),Fe(this,u,"f")}set title(E){this.assertNotDisposed(),Fe(this,u,"f")!==E&&(Je(this,u,E,"f"),Fe(this,S,"f").$setTitle(Fe(this,R,"f"),E))}get iconPath(){return this.assertNotDisposed(),Fe(this,t,"f")}set iconPath(E){this.assertNotDisposed(),Fe(this,t,"f")!==E&&(Je(this,t,E,"f"),Fe(this,S,"f").$setIconPath(Fe(this,R,"f"),C.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return Fe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,a,"f")=="number"&&Fe(this,a,"f")<0))return Fe(this,a,"f")}get active(){return this.assertNotDisposed(),Fe(this,_,"f")}get visible(){return this.assertNotDisposed(),Fe(this,d,"f")}_updateViewState(E){Fe(this,k,"f")||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(Je(this,_,E.active,"f"),Je(this,d,E.visible,"f"),Je(this,a,E.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(E,r){this.assertNotDisposed(),Fe(this,S,"f").$reveal(Fe(this,R,"f"),{viewColumn:typeof E>"u"?void 0:A.ViewColumn.from(E),preserveFocus:!!r})}assertNotDisposed(){if(Fe(this,k,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,S=new WeakMap,h=new WeakMap,w=new WeakMap,g=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap,_=new WeakMap,k=new WeakMap,p=new WeakMap,i=new WeakMap;class s{static newHandle(){return(0,M.generateUuid)()}constructor(E,r,c){this.webviews=r,this.workspace=c,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(E,r,c,v,y={}){const b=typeof v=="object"?v.viewColumn:v,$={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof v=="object"&&!!v.preserveFocus},G=(0,P.shouldSerializeBuffersForPostMessage)(E),Y=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(E),Y,r,{title:c,panelOptions:o(y),webviewOptions:(0,P.serializeWebviewOptions)(E,this.workspace,y),serializeBuffersForPostMessage:G},$);const K=this.webviews.createNewWebview(Y,y,E);return this.createNewWebviewPanel(Y,r,c,b,y,K,!0)}$onDidChangeWebviewPanelViewStates(E){const r=Object.keys(E);r.sort((c,v)=>{const y=E[c],b=E[v];return y.active?1:b.active?-1:+y.visible-+b.visible});for(const c of r){const v=this.getWebviewPanel(c);if(!v)continue;const y=E[c];v._updateViewState({active:y.active,visible:y.visible,viewColumn:A.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,r,c){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:c,extension:E}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(E)}),new m.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(E,r,c,v){const y=this._serializers.get(r);if(!y)throw new Error(`No serializer found for '${r}'`);const{serializer:b,extension:$}=y,G=this.webviews.createNewWebview(E,c.webviewOptions,$),Y=this.createNewWebviewPanel(E,r,c.title,v,c.panelOptions,G,c.active);await b.deserializeWebviewPanel(Y,c.state)}createNewWebviewPanel(E,r,c,v,y,b,$){const G=new l(E,this._proxy,b,{viewType:r,title:c,viewColumn:v,panelOptions:y,active:$});return this._webviewPanels.set(E,G),G}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=s;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[248],Ae([1,0,4,6,63,8,5,7]),function(ee,e,n,T,C,M,A,P){"use strict";var D,m,R,S,h,w,g,u,t,a,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends T.Disposable{constructor(i,l,s,o,f,E){super(),D.set(this,void 0),m.set(this,void 0),R.set(this,void 0),S.set(this,void 0),h.set(this,!1),w.set(this,void 0),g.set(this,void 0),u.set(this,void 0),t.set(this,void 0),a.set(this,this._register(new n.Emitter)),this.onDidChangeVisibility=Fe(this,a,"f").event,d.set(this,this._register(new n.Emitter)),this.onDidDispose=Fe(this,d,"f").event,Je(this,R,s,"f"),Je(this,g,o,"f"),Je(this,D,i,"f"),Je(this,m,l,"f"),Je(this,S,f,"f"),Je(this,w,E,"f")}dispose(){Fe(this,h,"f")||(Je(this,h,!0,"f"),Fe(this,d,"f").fire(),Fe(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,g,"f")}set title(i){this.assertNotDisposed(),Fe(this,g,"f")!==i&&(Je(this,g,i,"f"),Fe(this,m,"f").$setWebviewViewTitle(Fe(this,D,"f"),i))}get description(){return this.assertNotDisposed(),Fe(this,u,"f")}set description(i){this.assertNotDisposed(),Fe(this,u,"f")!==i&&(Je(this,u,i,"f"),Fe(this,m,"f").$setWebviewViewDescription(Fe(this,D,"f"),i))}get visible(){return Fe(this,w,"f")}get webview(){return Fe(this,S,"f")}get viewType(){return Fe(this,R,"f")}_setVisible(i){i===Fe(this,w,"f")||Fe(this,h,"f")||(Je(this,w,i,"f"),Fe(this,a,"f").fire())}get badge(){return this.assertNotDisposed(),Fe(this,t,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Fe(this,t,"f")?.value&&i?.tooltip===Fe(this,t,"f")?.tooltip)&&(Je(this,t,M.ViewBadge.from(i),"f"),Fe(this,m,"f").$setWebviewViewBadge(Fe(this,D,"f"),i))}show(i){this.assertNotDisposed(),Fe(this,m,"f").$show(Fe(this,D,"f"),!!i)}assertNotDisposed(){if(Fe(this,h,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,m=new WeakMap,R=new WeakMap,S=new WeakMap,h=new WeakMap,w=new WeakMap,g=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap;class k{constructor(i,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,l,s,o){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:s,extension:i}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(i),l,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(i,l,s,o,f){const E=this._viewProviders.get(l);if(!E)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:c}=E,v=this._extHostWebview.createNewWebview(i,{},c),y=new _(i,this._proxy,l,s,v,!0);this._webviewViews.set(i,y),await r.resolveWebviewView(y,{state:o},f)}async $onDidChangeWebviewViewVisibility(i,l){this.getWebviewView(i)._setVisible(l)}async $disposeWebviewView(i){const l=this.getWebviewView(i);this._webviewViews.delete(i),l.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const l=this._webviewViews.get(i);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=k}),define(Pe[106],Ae([1,0,4,5,2,15,13,3,18]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let m=class fn{get state(){return this._state}constructor(S){this._onDidChangeWindowState=new n.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=fn.InitialState,this._proxy=S.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,h){let w;if(typeof S=="string"){w=S;try{S=C.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,w,h)}async asExternalUri(S,h){if((0,A.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(S,h);return C.URI.from(w)}};m.InitialState={focused:!0},m=Ve([He(0,D.IExtHostRpcService)],m),e.ExtHostWindow=m,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Pe[249],Ae([1,0,218,27,18]),function(ee,e,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(P,D){super(P,D)}_nativeConsoleLogMessage(P,D,m){D.apply(console,m)}};M=Ve([He(0,C.IExtHostRpcService),He(1,T.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Pe[250],Ae([1,0,17,25,21,9,4,6,130,212,46]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(y,b){try{return JSON.stringify(y,b)}catch{return"null"}}const w="$$ref$$",g={[w]:-1};class u{constructor(b,$){this.jsonString=b,this.referencedBuffers=$}}function t(y,b=null,$=!1){const G=[];return{jsonString:($?h:JSON.stringify)(y,(K,N)=>{if(typeof N>"u")return g;if(typeof N=="object"){if(N instanceof T.VSBuffer){const B=G.push(N)-1;return{[w]:B}}if(b)return b(K,N)}return N}),referencedBuffers:G}}e.stringifyJsonWithBufferRefs=t;function a(y,b,$){return JSON.parse(y,(G,Y)=>{if(Y){const K=Y[w];if(typeof K=="number")return b[K];if($&&Y.$mid===1)return $.transformIncoming(Y)}return Y})}e.parseJsonAndRestoreBufferRefs=a;function d(y,b){return JSON.stringify(y,b)}function _(y){return y?(b,$)=>$&&$.$mid===1?y.transformOutgoing($):$:null}var k;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends P.Disposable{constructor(b,$=null,G=null){super(),this[S]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=$,this._uriTransformer=G,this._uriReplacer=_(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let Y=0,K=R.ProxyIdentifier.count;Y<K;Y++)this._locals[Y]=null,this._proxies[Y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new n.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(Y=>this._receiveOneMessage(Y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,D.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:$,sid:G}=b;return this._proxies[$]||(this._proxies[$]=this._createProxy($,G)),this._proxies[$]}_createProxy(b,$){const G={get:(Y,K)=>(typeof K=="string"&&!Y[K]&&K.charCodeAt(0)===36&&(Y[K]=(...N)=>this._remoteCall(b,K,N)),K===s?$:Y[K])};return new Proxy(Object.create(null),G)}set(b,$){return this._locals[b.nid]=$,$}assertRegistered(b){for(let $=0,G=b.length;$<G;$++){const Y=b[$];if(!this._locals[Y.nid])throw new Error(`Missing proxy instance ${Y.sid}`)}}_receiveOneMessage(b){if(this._isDisposed)return;const $=b.byteLength,G=f.read(b,0),Y=G.readUInt8(),K=G.readUInt32();switch(Y){case 1:case 2:{let{rpcId:N,method:B,args:U}=r.deserializeRequestJSONArgs(G);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest($,K,N,B,U,Y===2);break}case 3:case 4:{let{rpcId:N,method:B,args:U}=r.deserializeRequestMixedArgs(G);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest($,K,N,B,U,Y===4);break}case 5:{this._logger?.logIncoming($,K,0,"ack"),this._onDidReceiveAcknowledge(K);break}case 6:{this._receiveCancel($,K);break}case 7:{this._receiveReply($,K,void 0);break}case 9:{let N=r.deserializeReplyOKJSON(G);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply($,K,N);break}case 10:{const N=r.deserializeReplyOKJSONWithBuffers(G,this._uriTransformer);this._receiveReply($,K,N);break}case 8:{const N=r.deserializeReplyOKVSBuffer(G);this._receiveReply($,K,N);break}case 11:{let N=r.deserializeReplyErrError(G);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr($,K,N);break}case 12:{this._receiveReplyErr($,K,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,$,G,Y,K,N){this._logger?.logIncoming(b,$,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(G)}.${Y}(`,K);const B=String($);let U,z;if(N){const fe=new C.CancellationTokenSource;K.push(fe.token),U=this._invokeHandler(G,Y,K),z=()=>fe.cancel()}else U=this._invokeHandler(G,Y,K),z=i;this._cancelInvokedHandlers[B]=z;const j=r.serializeAcknowledged($);this._logger?.logOutgoing(j.byteLength,$,1,"ack"),this._protocol.send(j),U.then(fe=>{delete this._cancelInvokedHandlers[B];const _e=r.serializeReplyOK($,fe,this._uriReplacer);this._logger?.logOutgoing(_e.byteLength,$,1,"reply:",fe),this._protocol.send(_e)},fe=>{delete this._cancelInvokedHandlers[B];const _e=r.serializeReplyErr($,fe);this._logger?.logOutgoing(_e.byteLength,$,1,"replyErr:",fe),this._protocol.send(_e)})}_receiveCancel(b,$){this._logger?.logIncoming(b,$,1,"receiveCancel");const G=String($);this._cancelInvokedHandlers[G]?.()}_receiveReply(b,$,G){this._logger?.logIncoming(b,$,0,"receiveReply:",G);const Y=String($);if(!this._pendingRPCReplies.hasOwnProperty(Y))return;const K=this._pendingRPCReplies[Y];delete this._pendingRPCReplies[Y],K.resolveOk(G)}_receiveReplyErr(b,$,G){this._logger?.logIncoming(b,$,0,"receiveReplyErr:",G);const Y=String($);if(!this._pendingRPCReplies.hasOwnProperty(Y))return;const K=this._pendingRPCReplies[Y];delete this._pendingRPCReplies[Y];let N;G&&(G.$isError?(N=new Error,N.name=G.name,N.message=G.message,N.stack=G.stack):N=G),K.resolveErr(N)}_invokeHandler(b,$,G){try{return Promise.resolve(this._doInvokeHandler(b,$,G))}catch(Y){return Promise.reject(Y)}}_doInvokeHandler(b,$,G){const Y=this._locals[b];if(!Y)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(b));const K=Y[$];if(typeof K!="function")throw new Error("Unknown method "+$+" on actor "+(0,R.getStringIdentifierForProxy)(b));return K.apply(Y,G)}_remoteCall(b,$,G){if(this._isDisposed)return new m.CanceledLazyPromise;let Y=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(Y=G.pop()),Y&&Y.isCancellationRequested)return Promise.reject(M.canceled());const K=r.serializeRequestArguments(G,this._uriReplacer),N=++this._lastMessageId,B=String(N),U=new m.LazyPromise;Y&&Y.onCancellationRequested(()=>{const j=r.serializeCancel(N);this._logger?.logOutgoing(j.byteLength,N,0,"cancel"),this._protocol.send(r.serializeCancel(N))}),this._pendingRPCReplies[B]=U,this._onWillSendRequest(N);const z=r.serializeRequest(N,b,$,K,!!Y);return this._logger?.logOutgoing(z.byteLength,N,0,`request: ${(0,R.getStringIdentifierForProxy)(b)}.${$}(`,G),this._protocol.send(z),U}}S=l,o.UNRESPONSIVE_TIME=3*1e3,e.RPCProtocol=o;class f{static alloc(b,$,G){const Y=new f(T.VSBuffer.alloc(G+1+4),0);return Y.writeUInt8(b),Y.writeUInt32($),Y}static read(b,$){return new f(b,$)}get buffer(){return this._buff}constructor(b,$){this._buff=b,this._offset=$}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const G=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,G}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const G=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,G}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,$}static sizeMixedArray(b){let $=0;$+=1;for(let G=0,Y=b.length;G<Y;G++){const K=b[G];switch($+=1,K.type){case 1:$+=this.sizeLongString(K.value);break;case 2:$+=this.sizeVSBuffer(K.value);break;case 3:$+=this.sizeUInt32,$+=this.sizeLongString(K.value);for(let N=0;N<K.buffers.length;++N)$+=this.sizeVSBuffer(K.buffers[N]);break;case 4:break}}return $}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let $=0,G=b.length;$<G;$++){const Y=b[$];switch(Y.type){case 1:this.writeUInt8(1),this.writeLongString(Y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Y.buffers.length),this.writeLongString(Y.value);for(let K=0;K<Y.buffers.length;++K)this.writeBuffer(Y.buffers[K]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const $=new Array(b);for(let G=0;G<b;G++)switch(this.readUInt8()){case 1:$[G]=this.readLongString();break;case 2:$[G]=this.readVSBuffer();break;case 3:{const K=this.readUInt32(),N=this.readLongString(),B=[];for(let U=0;U<K;++U)B.push(this.readVSBuffer());$[G]=new R.SerializableObjectWithBuffers(a(N,B,null));break}case 4:$[G]=void 0;break}return $}}f.sizeUInt32=4;var E;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(E||(E={}));class r{static _useMixedArgSerialization(b){for(let $=0,G=b.length;$<G;$++)if(b[$]instanceof T.VSBuffer||b[$]instanceof R.SerializableObjectWithBuffers||typeof b[$]>"u")return!0;return!1}static serializeRequestArguments(b,$){if(this._useMixedArgSerialization(b)){const G=[];for(let Y=0,K=b.length;Y<K;Y++){const N=b[Y];if(N instanceof T.VSBuffer)G[Y]={type:2,value:N};else if(typeof N>"u")G[Y]={type:4};else if(N instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:U}=t(N.value,$);G[Y]={type:3,value:T.VSBuffer.fromString(B),buffers:U}}else G[Y]={type:1,value:T.VSBuffer.fromString(d(N,$))}}return{type:1,args:G}}return{type:0,args:d(b,$)}}static serializeRequest(b,$,G,Y,K){switch(Y.type){case 0:return this._requestJSONArgs(b,$,G,Y.args,K);case 1:return this._requestMixedArgs(b,$,G,Y.args,K)}}static _requestJSONArgs(b,$,G,Y,K){const N=T.VSBuffer.fromString(G),B=T.VSBuffer.fromString(Y);let U=0;U+=f.sizeUInt8(),U+=f.sizeShortString(N),U+=f.sizeLongString(B);const z=f.alloc(K?2:1,b,U);return z.writeUInt8($),z.writeShortString(N),z.writeLongString(B),z.buffer}static deserializeRequestJSONArgs(b){const $=b.readUInt8(),G=b.readShortString(),Y=b.readLongString();return{rpcId:$,method:G,args:JSON.parse(Y)}}static _requestMixedArgs(b,$,G,Y,K){const N=T.VSBuffer.fromString(G);let B=0;B+=f.sizeUInt8(),B+=f.sizeShortString(N),B+=f.sizeMixedArray(Y);const U=f.alloc(K?4:3,b,B);return U.writeUInt8($),U.writeShortString(N),U.writeMixedArray(Y),U.buffer}static deserializeRequestMixedArgs(b){const $=b.readUInt8(),G=b.readShortString(),Y=b.readMixedArray(),K=new Array(Y.length);for(let N=0,B=Y.length;N<B;N++){const U=Y[N];typeof U=="string"?K[N]=JSON.parse(U):K[N]=U}return{rpcId:$,method:G,args:K}}static serializeAcknowledged(b){return f.alloc(5,b,0).buffer}static serializeCancel(b){return f.alloc(6,b,0).buffer}static serializeReplyOK(b,$,G){if(typeof $>"u")return this._serializeReplyOKEmpty(b);if($ instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(b,$);if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:Y,referencedBuffers:K}=t($.value,G,!0);return this._serializeReplyOKJSONWithBuffers(b,Y,K)}else return this._serializeReplyOKJSON(b,h($,G))}static _serializeReplyOKEmpty(b){return f.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,$){let G=0;G+=f.sizeVSBuffer($);const Y=f.alloc(8,b,G);return Y.writeVSBuffer($),Y.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,$){const G=T.VSBuffer.fromString($);let Y=0;Y+=f.sizeLongString(G);const K=f.alloc(9,b,Y);return K.writeLongString(G),K.buffer}static _serializeReplyOKJSONWithBuffers(b,$,G){const Y=T.VSBuffer.fromString($);let K=0;K+=f.sizeUInt32,K+=f.sizeLongString(Y);for(const B of G)K+=f.sizeVSBuffer(B);const N=f.alloc(10,b,K);N.writeUInt32(G.length),N.writeLongString(Y);for(const B of G)N.writeBuffer(B);return N.buffer}static deserializeReplyOKJSON(b){const $=b.readLongString();return JSON.parse($)}static deserializeReplyOKJSONWithBuffers(b,$){const G=b.readUInt32(),Y=b.readLongString(),K=[];for(let N=0;N<G;++N)K.push(b.readVSBuffer());return new R.SerializableObjectWithBuffers(a(Y,K,$))}static serializeReplyErr(b,$){const G=$?h(M.transformErrorForSerialization($),null):void 0;if(typeof G!="string")return this._serializeReplyErrEmpty(b);const Y=T.VSBuffer.fromString(G);let K=0;K+=f.sizeLongString(Y);const N=f.alloc(11,b,K);return N.writeLongString(Y),N.buffer}static deserializeReplyErrError(b){const $=b.readLongString();return JSON.parse($)}static _serializeReplyErrEmpty(b){return f.alloc(12,b,0).buffer}}var c;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var v;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(v||(v={}))}),define(Pe[251],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const A=P=>{globalThis.removeEventListener("message",A);const D=P.data;Object.defineProperties(globalThis,{postMessage:{value(m,R){D.postMessage(m,R)}},onmessage:{get(){return D.onmessage},set(m){D.onmessage=m}}}),D.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(M,A,P){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${n})('${A}'))`,m=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(m),S=new MessageChannel,h=R,w={type:"_newWorker",id:h,port:S.port2,url:R,options:P};M(w,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const u=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(u)}),S.port1.addEventListener("message",g=>{const u=new MessageEvent("message",{data:g.data});this.dispatchEvent(u)}),S.port1.start()}}e.NestedWorker=T}),define(Pe[252],Ae([1,0,4,30,31,3]),function(ee,e,n,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.channels=new Map,this._onDidRegisterChannel=new n.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new n.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(R=>m.push(R)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}T.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(Pe[107],Ae([1,0,5,3,18,24,14,252,61,27,37,124,25,10,43,4,6]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(p,i,l,s,o){super(),this.id=p,this.name=i,this.logger=l,this.proxy=s,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(l.getLevel()),this._register(l.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.offset;this.info(p),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(p,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.proxy.$close(this.id)}log(p,i){this.offset+=h.VSBuffer.fromString(i).byteLength,(0,A.log)(this.logger,p,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class d extends a{appendLine(p){this.append(p)}}let _=class{constructor(p,i,l,s,o,f){this.initData=i,this.extHostFileSystem=l,this.extHostFileSystemInfo=s,this.loggerService=o,this.logService=f,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(n.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[i,l]of this.channels)l.visible=i===this.visibleChannelId}createOutputChannel(p,i,l){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,o=(0,w.isString)(i)?i:void 0;if((0,w.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const E=this.initData.environment.extensionLogLevel?.find(([c])=>M.ExtensionIdentifier.equals(l.identifier,c))?.[1];E&&(f=(0,A.parseLogLevel)(E));const r=s?this.doCreateLogOutputChannel(p,f,l):this.doCreateOutputChannel(p,o,l);return r.then(c=>{this.channels.set(c.id,c),c.visible=c.id===this.visibleChannelId}),s?this.createExtHostLogOutputChannel(p,f??this.logService.getLevel(),r):this.createExtHostOutputChannel(p,r)}async doCreateOutputChannel(p,i,l){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const s=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(s,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.proxy.$register(p,o,i,l.identifier.value);return new a(E,p,f,this.proxy,l)}async doCreateLogOutputChannel(p,i,l){const s=await this.createExtensionLogDirectory(l),o=p.replace(/[\\/:\*\?"<>\|]/g,""),f=this.extHostFileSystemInfo.extUri.joinPath(s,`${o}.log`),E=`${l.identifier.value}.${o}`,r=this.loggerService.createLogger(f,{id:E,name:p,logLevel:i,extensionId:l.identifier.value});return new d(E,p,r,this.proxy,l)}createExtensionLogDirectory(p){let i=this.extensionLogDirectoryPromise.get(p.identifier.value);if(!i){const l=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,p.identifier.value);this.extensionLogDirectoryPromise.set(p.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(l)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}return l})())}return i}createExtHostOutputChannel(p,i){let l=!1;const s=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return p},append(o){s(),i.then(f=>f.append(o))},appendLine(o){s(),i.then(f=>f.appendLine(o))},clear(){s(),i.then(o=>o.clear())},replace(o){s(),i.then(f=>f.replace(o))},show(o,f){s(),i.then(E=>E.show(o,f))},hide(){s(),i.then(o=>o.hide())},dispose(){l=!0,i.then(o=>o.dispose())}}}createExtHostLogOutputChannel(p,i,l){const s=new t.DisposableStore,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},f=s.add(new u.Emitter);function E(r){i=r,f.fire(r)}return l.then(r=>{s.add(r),r.logLevel!==i&&E(r.logLevel),s.add(r.onDidChangeLogLevel(c=>E(c)))}),{...this.createExtHostOutputChannel(p,l),get logLevel(){return i},onDidChangeLogLevel:f.event,trace(r,...c){o(),l.then(v=>v.trace(r,...c))},debug(r,...c){o(),l.then(v=>v.debug(r,...c))},info(r,...c){o(),l.then(v=>v.info(r,...c))},warn(r,...c){o(),l.then(v=>v.warn(r,...c))},error(r,...c){o(),l.then(v=>v.error(r,...c))},dispose(){s.dispose()}}}};_=Ve([He(0,C.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,D.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,A.ILoggerService),He(5,A.ILogService)],_),e.ExtHostOutputService=_,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Pe[253],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Pe[254],Ae([1,0,41,15,19,20,22,2,3,182,53,198,253]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let w=class mn{constructor(u,t,a,d){this.localUserHome=u,this.remoteAgentService=t,this.environmentService=a,this.contextService=d,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome??u})()}hasValidBasename(u,t,a){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(d=>this.doHasValidBasename(u,d,t)):this.doHasValidBasename(u,t,a)}doHasValidBasename(u,t,a){return u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,A.basename)(u),t===1):!0}get defaultUriScheme(){return mn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,t){if(u.remoteAuthority)return T.Schemas.vscodeRemote;const a=(0,m.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const d=t.getWorkspace().folders[0];if(d)return d.uri.scheme;const _=t.getWorkspace().configuration;return _?_.scheme:T.Schemas.file}userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?C.win32:C.posix)}async fileURI(u){let t="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const d=u.indexOf("/",2);d===-1?(t=u.substring(2),u="/"):(t=u.substring(2,d),u=u.substring(d)||"/")}return P.URI.from({scheme:T.Schemas.file,authority:t,path:u,query:"",fragment:""})}};w=Ve([He(1,h.IRemoteAgentService),He(2,S.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],w),e.AbstractPathService=w}),define(Pe[108],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new n(0,0)}with(A){return new n(0,0)}}e.Position=n;class T{constructor(A,P,D,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(A,P),this.end=new n(D,m)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.Range=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Pe[47],Ae([1,0,16,36,23,41,13,3,19,9,108,17]),function(ee,e,n,T,C,M,A,P,D,m,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",w=" characters skipped \u27EB",g=(h.length+w.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(le){return!!le.preview}e.resultIsMatch=a;function d(le){return!!le.resource}e.isFileMatch=d;function _(le){return!!le.message}e.isProgressMessage=_;var k;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(k=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=p;class i{constructor(ce,ke,de){this.ranges=ke;const ae=Array.isArray(ke)?ke:[ke];if(de&&de.matchLines===1&&l(ae)){ce=(0,A.getNLines)(ce,de.matchLines);let H="",O=0,X=0;const pe=Math.floor(de.charsPerLine/5),Ce=[];for(const we of ae){const ve=Math.max(we.startColumn-pe,0),Ie=we.startColumn+de.charsPerLine;if(ve>X+pe+g){const se=h+(ve-X)+w;H+=se+ce.slice(ve,Ie),O+=ve-(X+se.length)}else H+=ce.slice(X,Ie);Ce.push(new o(0,we.startColumn-O,we.endColumn-O)),X=Ie}this.preview={text:H,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const H=Array.isArray(ke)?ke[0].startLineNumber:ke.startLineNumber;this.preview={text:ce,matches:(0,n.mapArrayOrNot)(ke,O=>new s(O.startLineNumber-H,O.startColumn,O.endLineNumber-H,O.endColumn))}}}}e.TextSearchMatch=i;function l(le){const ce=le[0].startLineNumber;for(const ke of le)if(ke.startLineNumber!==ce||ke.endLineNumber!==ce)return!1;return!0}class s{constructor(ce,ke,de,ae){this.startLineNumber=ce,this.startColumn=ke,this.endLineNumber=de,this.endColumn=ae}}e.SearchRange=s;class o extends s{constructor(ce,ke,de){super(ce,ke,ce,de)}}e.OneLineRange=o;var f;(function(le){le.List="list",le.Tree="tree"})(f=e.ViewMode||(e.ViewMode={}));var E;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(E=e.SearchSortOrder||(e.SearchSortOrder={}));function r(le,ce=!0){const ke=le&&le.files&&le.files.exclude,de=ce&&le&&le.search&&le.search.exclude;if(!ke&&!de)return;if(!ke||!de)return ke||de;let ae=Object.create(null);return ae=C.mixin(ae,C.deepClone(ke)),ae=C.mixin(ae,C.deepClone(de),!0),ae}e.getExcludes=r;function c(le,ce){return le.excludePattern&&T.match(le.excludePattern,ce)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&T.match(le.includePattern,ce)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(ke=>{const de=ke.folder.fsPath;if(M.isEqualOrParent(ce,de)){const ae=D.relative(de,ce);return!ke.includePattern||!!T.match(ke.includePattern,ae)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(ce,ke){super(ce),this.code=ke}}e.SearchError=y;function b(le){const ce=le.message;if((0,m.isCancellationError)(le))return new y(ce,v.canceled);try{const ke=JSON.parse(ce);return new y(ke.message,ke.code)}catch{return new y(ce,v.other)}}e.deserializeSearchError=b;function $(le){const ce={message:le.message,code:le.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=$;function G(le){return le.type==="error"?!0:le.type==="success"}e.isSerializedSearchComplete=G;function Y(le){return le.type==="success"}e.isSerializedSearchSuccess=Y;function K(le){return!!le.path}e.isSerializedFileMatch=K;function N(le,ce){const ke=le.searchPath?le.searchPath:le.relativePath;return(0,A.fuzzyContains)(ke,ce)}e.isFilePatternMatch=N;class B{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function U(le,ce){const ke={...le||{},...ce||{}};return Object.keys(ke).filter(de=>{const ae=ke[de];return typeof ae=="boolean"&&ae})}e.resolvePatternsForProvider=U;class z{constructor(ce,ke){this._parsedIncludeExpression=null,this._excludeExpression={...ce.excludePattern||{},...ke.excludePattern||{}},this._parsedExcludeExpression=T.parse(this._excludeExpression);let de=ce.includePattern;ke.includePattern&&(de?de={...de,...ke.includePattern}:de=ke.includePattern),de&&(this._parsedIncludeExpression=T.parse(de))}matchesExcludesSync(ce,ke,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,ke,de))}includedInQuerySync(ce,ke,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,ke,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ce,ke,de))}includedInQuery(ce,ke,de){const ae=this._parsedExcludeExpression(ce,ke,de),H=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ce,ke,de):!0;return(0,S.isThenable)(ae)?ae.then(O=>O?!1:H()):H()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=z;function j(le){for(const ce in le)if(typeof le[ce]!="boolean")return!0;return!1}function fe(le){if(!le)return;let ce;return ke=>(ce||(ce=(le()||Promise.resolve([])).then(de=>de?ie(de):{})),ce.then(de=>!!de[ke]))}e.hasSiblingPromiseFn=fe;function _e(le){if(!le)return;let ce;return ke=>{if(!ce){const de=le();ce=de?ie(de):{}}return!!ce[ke]}}e.hasSiblingFn=_e;function ie(le){const ce={};for(const ke of le)ce[ke]=!0;return ce}}),define(Pe[32],Ae([1,0,16,17,21,4,6,48,15,115,22,13,10,2,153,3,14,170,53,37,27,18,8,7,55,47,5]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i,l,s,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function E(Y,K,N){return new R.ExtUri(B=>y(B,N)).isEqual(Y,K)}function r(Y,K,N){return E(Y.uri,K.uri,N)?0:(0,S.compare)(Y.uri.toString(),K.uri.toString())}function c(Y,K,N){return Y.index!==K.index?Y.index<K.index?-1:1:E(Y.uri,K.uri,N)?(0,S.compare)(Y.name,K.name):(0,S.compare)(Y.uri.toString(),K.uri.toString())}function v(Y,K,N,B){const U=Y.slice(0).sort((j,fe)=>N(j,fe,B)),z=K.slice(0).sort((j,fe)=>N(j,fe,B));return(0,n.delta)(U,z,(j,fe)=>N(j,fe,B))}function y(Y,K){const N=K.getCapabilities(Y.scheme);return!(N&&N&1024)}class b extends d.Workspace{static toExtHostWorkspace(K,N,B,U){if(!K)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:fe,configuration:_e,transient:ie,isUntitled:le}=K,ce=[],ke=N;N?fe.forEach((O,X)=>{const pe=w.URI.revive(O.uri),Ce=b._findFolder(B||N,pe,U);Ce?(Ce.name=O.name,Ce.index=O.index,ce.push(Ce)):ce.push({uri:pe,name:O.name,index:X})}):ce.push(...fe.map(({uri:O,name:X,index:pe})=>({uri:w.URI.revive(O),name:X,index:pe}))),ce.sort((O,X)=>O.index<X.index?-1:1);const de=new b(z,j,ce,!!ie,_e?w.URI.revive(_e):null,!!le,O=>y(O,U)),{added:ae,removed:H}=v(ke?ke.workspaceFolders:[],de.workspaceFolders,r,U);return{workspace:de,added:ae,removed:H}}static _findFolder(K,N,B){for(let U=0;U<K.folders.length;U++){const z=K.workspaceFolders[U];if(E(z.uri,N,B))return z}}constructor(K,N,B,U,z,j,fe){super(K,B.map(_e=>new d.WorkspaceFolder(_e)),U,z,fe),this._name=N,this._isUntitled=j,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(fe),B.forEach(_e=>{this._workspaceFolders.push(_e),this._structure.set(_e.uri,_e)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(K,N){return N&&this._structure.get(K)&&(K=(0,R.dirname)(K)),this._structure.findSubstr(K)}resolveWorkspaceFolder(K){return this._structure.get(K)}}let $=class{constructor(K,N,B,U,z){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new M.AsyncEmitter,this._logService=U,this._extHostFileSystemInfo=B,this._uriTransformerService=z,this._requestIdProvider=new m.Counter,this._barrier=new T.Barrier,this._proxy=K.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=K.getProxy(f.MainContext.MainThreadMessageService);const j=N.workspace;this._confirmedWorkspace=j?new b(j.id,j.name,[],!!j.transient,j.configuration?w.URI.revive(j.configuration):null,!!j.isUntitled,fe=>y(fe,B)):void 0}$initializeWorkspace(K,N){this._trusted=N,this.$acceptWorkspaceData(K),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?w.URI.from({scheme:D.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(K,N,B,...U){const z=[];if(Array.isArray(U)&&U.forEach(le=>{w.URI.isUri(le.uri)&&!z.some(ce=>E(ce.uri,le.uri,this._extHostFileSystemInfo))&&z.push({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[N,B].some(le=>typeof le!="number"||le<0)||B===0&&z.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>j.length)return!1;const fe=j.slice(0);fe.splice(N,B,...z.map(le=>({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<fe.length;le++){const ce=fe[le];if(fe.some((ke,de)=>de!==le&&E(ce.uri,ke.uri,this._extHostFileSystemInfo)))return!1}fe.forEach((le,ce)=>le.index=ce);const{added:_e,removed:ie}=v(j,fe,c,this._extHostFileSystemInfo);if(_e.length===0&&ie.length===0)return!1;if(this._proxy){const le=K.displayName||K.name;this._proxy.$updateWorkspaceFolders(le,N,B,z).then(void 0,ce=>{this._unconfirmedWorkspace=void 0;const ke={source:{identifier:K.identifier,label:K.displayName||K.name}};this._messageService.$showMessage(a.Severity.Error,(0,g.localize)(0,null,le,ce.toString()),ke,[])})}return this.trySetWorkspaceFolders(fe),!0}getWorkspaceFolder(K,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(K,N)}async getWorkspaceFolder2(K,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(K,N)}async resolveWorkspaceFolder(K){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(K)}getPath(){if(!this._actualWorkspace)return;const{folders:K}=this._actualWorkspace;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,N){let B,U="";if(typeof K=="string"?(B=w.URI.file(K),U=K):typeof K<"u"&&(B=K,U=K.fsPath),!B)return U;const z=this.getWorkspaceFolder(B,!0);if(!z)return U;typeof N>"u"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let j=(0,R.relativePath)(z.uri,B);return N&&z.name&&(j=`${z.name}/${j}`),j}trySetWorkspaceFolders(K){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:K,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:N,added:B,removed:U}=b.toExtHostWorkspace(K,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:U}))}findFiles(K,N,B,U,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(N===null?j=!1:N&&(typeof N=="string"?j=N:j=N.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:_e}=G(i.GlobPattern.from(K));return this._proxy.$startFileSearch((0,h.withUndefinedAsNull)(fe),(0,h.withUndefinedAsNull)(_e),(0,h.withUndefinedAsNull)(j),(0,h.withUndefinedAsNull)(B),z).then(ie=>Array.isArray(ie)?ie.map(le=>w.URI.revive(le)):[])}async findTextInFiles(K,N,B,U,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),fe=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:_e,folder:ie}=G(i.GlobPattern.from(N.include)),le=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ce={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:fe,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:_e,excludePattern:le},ke=!1;if(this._activeSearchCallbacks[j]=de=>{if(ke)return;const ae=w.URI.revive(de.resource);de.results.forEach(H=>{(0,o.resultIsMatch)(H)?B({uri:ae,preview:{text:H.preview.text,matches:(0,n.mapArrayOrNot)(H.preview.matches,O=>new l.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))},ranges:(0,n.mapArrayOrNot)(H.ranges,O=>new l.Range(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn))}):B({uri:ae,text:H.text,lineNumber:H.lineNumber})})},z.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(K,(0,h.withUndefinedAsNull)(ie),ce,j,z);return delete this._activeSearchCallbacks[j],de||{}}catch(de){throw delete this._activeSearchCallbacks[j],de}}$handleTextSearchResult(K,N){this._activeSearchCallbacks[N]?.(K)}saveAll(K){return this._proxy.$saveAll(K)}resolveProxy(K){return this._proxy.$resolveProxy(K)}get trusted(){return this._trusted}requestWorkspaceTrust(K){return this._proxy.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(K,N){if(this._editSessionIdentityProviders.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this._editSessionIdentityProviders.set(K,N);const B=this._uriTransformerService.transformOutgoingScheme(K),U=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(U,B),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(K),this._proxy.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(K,N){this._logService.info("Getting edit session identifier for workspaceFolder",K);const B=await this.resolveWorkspaceFolder(w.URI.revive(K));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const U=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(B,N);if(this._logService.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(K,N,B,U){this._logService.info("Getting edit session identifier for workspaceFolder",K);const z=await this.resolveWorkspaceFolder(w.URI.revive(K));if(!z){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this._editSessionIdentityProviders.get(z.uri.scheme);if(this._logService.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const fe=await j.provideEditSessionIdentityMatch?.(N,B,U);if(this._logService.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(K){return(N,B,U)=>{const z=function(fe){N.call(B,fe)};return z.extension=K,this._onWillCreateEditSessionIdentityEvent.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(K,N,B){const U=await this.resolveWorkspaceFolder(w.URI.revive(K));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:U},N,async(z,j)=>{const fe=Date.now();await Promise.resolve(z),Date.now()-fe>B&&this._logService.warn("SLOW edit session create-participant",j.extension.identifier)}),N.isCancellationRequested}};$=Ve([He(0,p.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,t.ILogService),He(4,s.IURITransformerService)],$),e.ExtHostWorkspace=$,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function G(Y){let K,N;return Y&&(typeof Y=="string"?K=Y:(K=Y.pattern,N=w.URI.revive(Y.baseUri))),{includePattern:K,folder:N}}}),define(Pe[33],Ae([1,0,23,4,32,5,7,173,94,10,17,3,18,14,2]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(l,s){if(s){const o=s.split(".");let f=l;for(let E=0;f&&E<o.length;E++)f=f[o[E]];return f}}function t(l){return l instanceof g.URI}function a(l){return l&&l.uri instanceof g.URI&&l.languageId&&typeof l.languageId=="string"}function d(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function _(l){return l&&l.uri instanceof g.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function k(l){if(t(l))return{resource:l};if(a(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(d(l))return{overrideIdentifier:l.languageId};if(_(l))return{resource:l.uri};if(l===null)return{resource:null}}let p=class{constructor(s,o,f){this._proxy=s.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=f,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new i(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(s,o))}};p=Ve([He(0,h.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,w.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(s,o,f,E){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=E,this._extHostWorkspace=o,this._configuration=P.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,f))}getConfiguration(s,o,f){const E=k(o)||{},r=this._toReadonlyValue(s?u(this._configuration.getValue(void 0,E,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,E,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,E,f?.identifier);function c(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof u(r,y)<"u"},get:(y,b)=>{this._validateConfigurationAccess(s?`${s}.${y}`:y,E,f?.identifier);let $=u(r,y);if(typeof $>"u")$=b;else{let G;const Y=(K,N)=>{let B;const U=()=>{G=G||(0,n.deepClone)(r),B=B||u(G,N)};return(0,m.isObject)(K)?new Proxy(K,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>B;if(G)return B=B||u(G,N),B[j];const fe=z[j];return typeof j=="string"?Y(fe,`${N}.${j}`):fe},set:(z,j,fe)=>(U(),B&&(B[j]=fe),!0),deleteProperty:(z,j)=>(U(),B&&delete B[j],!0),defineProperty:(z,j,fe)=>(U(),B&&Object.defineProperty(B,j,fe),!0)}):K};$=Y($,y)}return $},update:(y,b,$,G)=>{y=s?`${s}.${y}`:y;const Y=c($);return b!==void 0?this._proxy.$updateConfigurationOption(Y,y,b,E,G):this._proxy.$removeConfigurationOption(Y,y,E,G)},inspect:y=>{y=s?`${s}.${y}`:y;const b=this._configuration.inspect(y,E,this._extHostWorkspace.workspace);if(b)return{key:y,defaultValue:(0,n.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,n.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,n.deepClone)(b.workspace?.value),workspaceFolderValue:(0,n.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(b.default?.override),globalLanguageValue:(0,n.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,n.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(b.workspaceFolder?.override),languageIds:(0,n.deepClone)(b.overrideIdentifiers)}}};return typeof r=="object"&&(0,n.mixin)(v,r,!1),Object.freeze(v)}_toReadonlyValue(s){const o=f=>(0,m.isObject)(f)?new Proxy(f,{get:(E,r)=>o(E[r]),set:(E,r,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(E,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(E,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:E=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(s)}_validateConfigurationAccess(s,o,f){const E=D.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),r=f?`[${f.value}] `:"";if(E===4){typeof o?.resource>"u"&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(E===3){o?.resource&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const f=new P.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(E,r)=>f.affectsConfiguration(E,k(r))})}_toMap(s){return s.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[109],Ae([1,0,2,17,4,5,7,32,59,33,21,62,18,27,3,15,20,14,78,211,9]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(K){function N(U){if(U!=null)return U}K.from=N;function B(U){if(U!=null)return U}K.to=B})(i||(i={}));var l;(function(K){function N(U){if(U!=null)return U}K.from=N;function B(U){if(U!=null)return U}K.to=B})(l||(l={}));var s;(function(K){function N(U){if(U!=null)return U}K.from=N;function B(U){if(U!=null)return U}K.to=B})(s||(s={}));var o;(function(K){function N(z){if(z){const j=z;return j&&!!j.process}else return!1}K.is=N;function B(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=s.from(z.options)),j}K.from=B;function U(z){if(z!=null)return new A.ProcessExecution(z.process,z.args,z.options)}K.to=U})(o||(o={}));var f;(function(K){function N(U){if(U!=null)return U}K.from=N;function B(U){if(U!=null)return U}K.to=B})(f||(f={}));var E;(function(K){function N(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}K.is=N;function B(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=f.from(z.options)),j}K.from=B;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.ShellExecution(z.commandLine,z.options):new A.ShellExecution(z.command,z.args?z.args:[],z.options)}K.to=U})(E||(E={}));var r;(function(K){function N(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}K.is=N;function B(z){return{customExecution:"customExecution"}}K.from=B;function U(z,j){return j.get(z)}K.to=U})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(K){function N(B,U){let z;return B.scope!==void 0&&typeof B.scope!="number"?z=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=_.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:z}}K.from=N})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(K){function N(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}K.from=N})(v||(v={}));var y;(function(K){function N(z,j){if(z==null)return[];const fe=[];for(const _e of z){const ie=B(_e,j);ie&&fe.push(ie)}return fe}K.fromMany=N;function B(z,j){if(z==null)return;let fe;z.execution instanceof A.ProcessExecution?fe=o.from(z.execution):z.execution instanceof A.ShellExecution?fe=E.from(z.execution):z.execution&&z.execution instanceof A.CustomExecution&&(fe=r.from(z.execution));const _e=i.from(z.definition);let ie;return z.scope?typeof z.scope=="number"?ie=z.scope:ie=z.scope.uri:ie=A.TaskScope.Workspace,!_e||!ie?void 0:{_id:z._id,definition:_e,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:ie},execution:fe,isBackground:z.isBackground,group:v.from(z.group),presentationOptions:l.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}K.from=B;async function U(z,j,fe){if(z==null)return;let _e;o.is(z.execution)?_e=o.to(z.execution):E.is(z.execution)?_e=E.to(z.execution):r.is(z.execution)&&(_e=r.to(z._id,fe));const ie=i.to(z.definition);let le;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?le=z.source.scope:le=await j.resolveWorkspaceFolder(n.URI.revive(z.source.scope)):le=A.TaskScope.Workspace),!ie||!le)return;const ce=new A.Task(ie,le,z.name,z.source.label,_e,z.problemMatchers);return z.isBackground!==void 0&&(ce.isBackground=z.isBackground),z.group!==void 0&&(ce.group=A.TaskGroup.from(z.group._id),ce.group&&z.group.isDefault&&(ce.group=new A.TaskGroup(ce.group.id,ce.group.label),z.group.isDefault===!0&&(ce.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ce.presentationOptions=l.to(z.presentationOptions)),z._id&&(ce._id=z._id),z.detail&&(ce.detail=z.detail),ce}K.to=U})(y=e.TaskDTO||(e.TaskDTO={}));var b;(function(K){function N(U){return U}K.from=N;function B(U){if(!!U)return Object.assign(Object.create(null),U)}K.to=B})(b||(b={}));class ${constructor(N,B,U){this._id=B,this._task=U,p.set(this,void 0),Je(this,p,N,"f")}get task(){return this._task}terminate(){Fe(this,p,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}p=new WeakMap;let G=class{constructor(N,B,U,z,j,fe,_e,ie){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=z,this._configurationService=j,this._terminalService=fe,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=_e,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,B,U){if(!U)return new A.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:B,provider:U,extension:N}),this._proxy.$registerTaskProvider(z,B),new A.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(N,B){this._proxy.$registerTaskSystem(N,B)}fetchTasks(N){return this._proxy.$fetchTasks(b.from(N)).then(async B=>{const U=[];for(const z of B){const j=await y.to(z,this._workspaceProvider,this._providedCustomExecutions2);j&&U.push(j)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(B=>N.push(B)),N}terminateTask(N){if(!(N instanceof $))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,B,U){const z=this._providedCustomExecutions2.get(N.id);z&&(this._activeCustomExecutions2.set(N.id,z),this._terminalService.attachPtyToTerminal(B,await z.callback(U))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const B=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const B=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:B,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const B=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:N.exitCode})}$provideTasks(N,B){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const z=[],j=(0,T.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(fe=>this.provideTasksInternal(B,z,U,fe));return new Promise(fe=>{j.then(_e=>{Promise.all(z).then(()=>{fe(_e)})})})}async $resolveTask(N,B){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(B.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await y.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(z,R.CancellationToken.None);if(!j)return;this.checkDeprecation(j,U);const fe=y.from(j,U.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(fe.execution)&&await this.addCustomExecution(fe,j,!0),await this.resolveTaskInternal(fe)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,B,U){const z=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,B.execution)),this._providedCustomExecutions2.set(z,B.execution)}async getTaskExecution(N,B){if(typeof N=="string"){const j=this._taskExecutionPromises.get(N);if(!j)throw new k.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this._taskExecutionPromises.get(N.id);if(U)return U;const z=new Promise((j,fe)=>{function _e(ie,le,ce){ce?j(new $(ie,le.id,ce)):fe("Unexpected: Task does not exist.")}B?_e(this,N,B):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>_e(this,N,ie))});return this._taskExecutionPromises.set(N.id,z),z.then(j=>(this._taskExecutions.set(N.id,j),j),j=>Promise.reject(j))}checkDeprecation(N,B){N._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const U=this._notProvidedCustomExecutions.values();let z=U.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=U.next()}};G=Ve([He(0,h.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,S.IExtHostTerminalService),He(6,a.ILogService),He(7,d.IExtHostApiDeprecationService)],G),e.ExtHostTaskBase=G;let Y=class extends G{constructor(N,B,U,z,j,fe,_e,ie){super(N,B,U,z,j,fe,_e,ie),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(N,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const U=y.from(B,N);if(U===void 0)throw new Error("Task is not valid");if(r.is(U.execution))await this.addCustomExecution(U,B,!1);else throw new k.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),B);return this._proxy.$executeTask(U).catch(j=>{throw new Error(j)}),z}provideTasksInternal(N,B,U,z){const j=[];if(z)for(const fe of z){this.checkDeprecation(fe,U),(!fe.definition||!N[fe.definition.type])&&this._logService.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const _e=y.from(fe,U.extension);_e&&r.is(_e.execution)?(j.push(_e),B.push(this.addCustomExecution(_e,fe,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async resolveTaskInternal(N){if(r.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,B,U){}};Y=Ve([He(0,h.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,S.IExtHostTerminalService),He(6,a.ILogService),He(7,d.IExtHostApiDeprecationService)],Y),e.WorkerExtHostTask=Y,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Pe[255],Ae([1,0,19,21,40,36,22,58,47]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(h,w,g){this.config=h,this.provider=w,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&M.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&M.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const w=this.config.folderQueries||[];return new Promise((g,u)=>{const t=a=>{this.resultCount++,h(a)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const d=a.toString(),_=n.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,_)||this.matchFile(t,{base:a,basename:_})}),Promise.all(w.map(a=>this.searchInFolder(a,t))).then(a=>{g({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{u(new Error((0,C.toErrorMessage)(a)))})})}async searchInFolder(h,w){const g=new T.CancellationTokenSource,u=this.getSearchOptionsForFolder(h),t=this.initDirectoryTree(),a=new D.QueryGlobTester(this.config,h),d=!a.hasSiblingExcludeClauses();let _;try{this.activeCancellationTokens.add(g),_=P.StopWatch.create();const k=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,g.token),p=_.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(k&&k.forEach(l=>{const s=n.posix.relative(h.folder.path,l.path);if(d){const o=n.basename(l.path);this.matchFile(w,{base:h.folder,relativePath:s,basename:o});return}this.addDirectoryEntries(t,h.folder,s,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(t,a,w),{providerTime:p,postProcessTime:i.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(h){const w=(0,D.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),g=(0,D.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:g,includes:w,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},w,g,u){if(g===this.filePattern){const a=n.basename(this.filePattern);this.matchFile(u,{base:w,relativePath:this.filePattern,basename:a})}function t(a){const d=n.basename(a),_=n.dirname(a);let k=h[_];k||(k=h[_]=[],t(_)),k.push({base:w,relativePath:a,basename:d})}t(g)}matchDirectoryTree({rootEntries:h,pathToEntries:w},g,u){const t=this,a=this.filePattern;function d(_){const k=(0,D.hasSiblingFn)(()=>_.map(p=>p.basename));for(let p=0,i=_.length;p<i;p++){const l=_[p],{relativePath:s,basename:o}=l;if(g.matchesExcludesSync(s,o,a!==o?k:void 0))continue;const f=w[s];if(f)d(f);else{if(s===a)continue;t.matchFile(u,l)}if(t.isLimitHit)break}}d(h)}matchFile(h,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(w))}}class R{constructor(){this.sessions=new Map}fileSearch(h,w,g,u){const t=this.getSessionTokenSource(h.cacheKey),a=new m(h,w,t&&t.token);let d=0;const _=k=>{d+=k.length,g(k.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(a,R.BATCH_SIZE,_,u).then(k=>({limitHit:k.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:k.stats}}))}clearCache(h){this.getSessionTokenSource(h)?.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new T.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:A.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,w,g,u){u.onCancellationRequested(()=>{h.cancel()});const t=d=>{d&&(a.push(d),w>0&&a.length>=w&&(g(a),a=[]))};let a=[];return h.search(t).then(d=>(a.length&&g(a),d),d=>(a.length&&g(a),Promise.reject(d)))}}R.BATCH_SIZE=512,e.FileSearchManager=R}),define(Pe[256],Ae([1,0,16,64,36,88,28,15,19,22,13,10,2,270,162,42,14,53,99,254,47]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(y,b,$,G,Y){this.configurationService=y,this.workspaceContextService=b,this.editorGroupsService=$,this.logService=G,this.pathService=Y}text(y,b,$={}){y=this.getContentPattern(y,$);const G=this.configurationService.getValue(),Y=b&&b.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(b?.map(a.toWorkspaceFolder),$),type:2,contentPattern:y,previewOptions:$.previewOptions,maxFileSize:$.maxFileSize,usePCRE2:G.search.usePCRE2||Y||!1,beforeContext:$.beforeContext,afterContext:$.afterContext,userDisabledExcludesAndIgnoreFiles:$.disregardExcludeSettings&&$.disregardIgnoreFiles}}getContentPattern(y,b){const $=this.configurationService.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const G={...y,wordSeparators:$.editor.wordSeparators};return this.isCaseSensitive(y,b)&&(G.isCaseSensitive=!0),this.isMultiline(y)&&(G.isMultiline=!0),G}file(y,b={}){return{...this.commonQuery(y,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(y,b){return y?(y=Array.isArray(y)?y.map(f):f(y),b?this.parseSearchPaths(y):{pattern:l(...Array.isArray(y)?y:[y])}):{}}commonQuery(y=[],b={}){const $=this.handleIncludeExclude(b.includePattern,b.expandPatterns),G=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),Y=y.length>1,K=($.searchPaths&&$.searchPaths.length?$.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,b,G)):y.map(U=>this.getFolderQueryForRoot(U,b,G,Y))).filter(U=>!!U),N={_reason:b._reason,folderQueries:K,usingSearchPaths:!!($.searchPaths&&$.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:G.pattern,includePattern:$.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const U=n.coalesce(n.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(_e=>_e.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const z=U.filter(fe=>(0,k.pathIncludedInQuery)(N,fe.fsPath)),j=this.commonQueryFromFileList(z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...N,...j}}const B=b.extraFileResources&&b.extraFileResources.filter(U=>(0,k.pathIncludedInQuery)(N,U.fsPath));return N.extraFileResources=B&&B.length?B:void 0,N}commonQueryFromFileList(y){const b=[],$=new A.ResourceMap,G={};let Y=!1;return y.forEach(K=>{if(K.scheme===P.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(K)){const B=this.workspaceContextService.getWorkspaceFolder(K)?.uri??K.with({path:D.dirname(K.fsPath)});let U=$.get(B);U||(Y=!0,U={folder:B,includePattern:{}},b.push(U),$.set(B,U));const z=D.relative(B.fsPath,K.fsPath);(0,S.assertIsDefined)(U.includePattern)[z.replace(/\\/g,"/")]=!0}else K.fsPath&&(Y=!0,G[K.fsPath]=!0)}),{folderQueries:b,includePattern:G,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}isCaseSensitive(y,b){if(b.isSmartCase){if(y.isRegExp){if(R.containsUppercaseCharacter(y.pattern,!0))return!0}else if(R.containsUppercaseCharacter(y.pattern))return!0}return!!y.isCaseSensitive}isMultiline(y){return y.isMultiline||y.isRegExp&&(0,w.isMultilineRegexSource)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const b=j=>D.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),G=(Array.isArray(y)?y:s(y)).map(j=>{const fe=this.pathService.resolvedUserHome;return fe?(0,M.untildify)(j,fe.scheme===P.Schemas.file?fe.fsPath:fe.path):j}),Y=T.groupBy(G,j=>b(j)?"searchPaths":"exprSegments"),K=(Y.exprSegments||[]).map(j=>R.rtrim(j,"/")).map(j=>R.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),o(j))),N={},B=this.expandSearchPathPatterns(Y.searchPaths||[]);B&&B.length&&(N.searchPaths=B);const U=n.flatten(K),z=l(...U);return z&&(N.pattern=z),N}getExcludesForFolder(y,b){return b.disregardExcludeSettings?void 0:(0,k.getExcludes)(y,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(y){if(!y||!y.length)return[];const b=y.flatMap(G=>{let{pathPortion:Y,globPortion:K}=i(G);return K&&(K=E(K)),this.expandOneSearchPath(Y).flatMap(B=>this.resolveOneSearchPathPattern(B,K))}),$=new Map;return b.forEach(G=>{const Y=G.searchPath.toString(),K=$.get(Y);K?G.pattern&&(K.pattern=K.pattern||{},K.pattern[G.pattern]=!0):$.set(Y,{searchPath:G.searchPath,pattern:G.pattern?l(G.pattern):void 0})}),Array.from($.values())}expandOneSearchPath(y){if(D.isAbsolute(y)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==P.Schemas.file?[{searchPath:b[0].uri.with({path:y})}]:[{searchPath:h.URI.file(D.normalize(y))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(y=f(y),y.startsWith("../")||y===".."){const G=D.posix.resolve(b.path,y);return[{searchPath:b.with({path:G})}]}const $=E(y);return[{searchPath:b,pattern:$}]}else{if(y==="./"||y===".\\")return[];{const b=y.replace(/^\.[\/\\]/,""),G=this.workspaceContextService.getWorkspace().folders.map(Y=>{const K=b.match(new RegExp(`^${R.escapeRegExpCharacters(Y.name)}(?:/(.*)|$)`));return K?{match:K,folder:Y}:null}).filter(S.isDefined);if(G.length)return G.map(Y=>{const K=Y.match[1];return{searchPath:Y.folder.uri,pattern:K&&E(K)}});{const Y=y.match(/\.[\/\\](.+)[\/\\]?/),K=Y?Y[1]:y,N=g.localize(0,null,K);throw new Error(N)}}}}resolveOneSearchPathPattern(y,b){const $=y.pattern&&b?`${y.pattern}/${b}`:y.pattern||b,G=[{searchPath:y.searchPath,pattern:$}];return $&&!$.endsWith("**")&&G.push({searchPath:y.searchPath,pattern:$+"/**"}),G}getFolderQueryForSearchPath(y,b,$){const G=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(y.searchPath),b,$,!1);return G?{...G,includePattern:y.pattern}:null}getFolderQueryForRoot(y,b,$,G){let Y;const K=h.URI.isUri(y)?y:y.uri;if($.searchPaths){const j=$.searchPaths.filter(fe=>(0,m.isEqual)(fe.searchPath,K))[0];if(j&&!j.pattern)return null;j&&(Y=j.pattern)}const N=this.configurationService.getValue({resource:K}),U={...this.getExcludesForFolder(N,b)||{},...Y||{}},z=h.URI.isUri(y)?(0,m.basename)(y):y.name;return{folder:K,folderName:G?z:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!N.search.followSymlinks}}};p=Ve([He(0,u.IConfigurationService),He(1,a.IWorkspaceContextService),He(2,d.IEditorGroupsService),He(3,t.ILogService),He(4,_.IPathService)],p),e.QueryBuilder=p;function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const b=y.index,$=v.substr(0,b).match(/[/|\\][^/\\]*$/);if($){let G=v.substr(0,$.index);return G.match(/[/\\]/)||(G+="/"),{pathPortion:G,globPortion:v.substr(($.index||0)+1)}}}return{pathPortion:v}}function l(...v){return v.length?v.reduce((y,b)=>(y[b]=!0,y),Object.create(null)):void 0}function s(v){return C.splitGlobAware(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(v){return[`**/${v}/**`,`**/${v}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function f(v){return v.replace(/\\/g,"/")}function E(v){return f(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(v){return v.replace(/([?*[\]])/g,"[$1]")}function c(v,y){v=n.distinct(v,G=>G.toString());const b=[],$=y.getWorkspace();return v&&v.forEach(G=>{let Y;if(y.getWorkbenchState()===2)Y=(0,m.relativePath)($.folders[0].uri,G),Y&&Y!=="."&&(Y="./"+Y);else{const K=y.getWorkspaceFolder(G);if(K){const N=K.name;if($.folders.filter(U=>U.name===N).length===1){const U=(0,m.relativePath)(K.uri,G);U===""?Y=`./${K.name}`:Y=`./${K.name}/${U}`}else Y=G.fsPath}}Y&&b.push(r(Y))}),b}e.resolveResourcesForSearchIncludes=c}),define(Pe[257],Ae([1,0,22,2,21,9,3,256,47,53]),function(ee,e,n,T,C,M,A,P,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function S(u,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const d=[],_=[];for(const o of a)if(/^workspaceContains:/.test(o)){const f=o.substr(18);f.indexOf("*")>=0||f.indexOf("?")>=0||u.forceUsingSearch?_.push(f):d.push(f)}if(d.length===0&&_.length===0)return Promise.resolve(void 0);let k;const p=new Promise((o,f)=>{k=o}),i=o=>k({activationEvent:o}),l=Promise.all(d.map(o=>h(u,o,i))).then(()=>{}),s=w(u,t.identifier,_,i);return Promise.all([l,s]).then(()=>{k(void 0)}),p}e.checkActivateWorkspaceContainsExtension=S;async function h(u,t,a){for(const d of u.folders)if(await u.exists(n.joinPath(T.URI.revive(d),t))){a(`workspaceContains:${t}`);return}}async function w(u,t,a,d){if(a.length===0)return Promise.resolve(void 0);const _=new C.CancellationTokenSource,k=u.checkExists(u.folders,a,_.token),p=setTimeout(async()=>{_.cancel(),u.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},R);let i=!1;try{i=await k}catch(l){M.isCancellationError(l)||M.onUnexpectedError(l)}_.dispose(),clearTimeout(p),i&&d(`workspaceContains:${a.join(",")}`)}function g(u,t,a,d){const _=u.get(A.IInstantiationService),k=u.get(D.ISearchService),i=_.createInstance(P.QueryBuilder).file(t.map(l=>(0,m.toWorkspaceFolder)(T.URI.revive(l))),{_reason:"checkExists",includePattern:a,exists:!0});return k.fileSearch(i,d).then(l=>!!l.limitHit,l=>M.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=g});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Fe=this&&this.__classPrivateFieldGet||function(ee,e,n,T){if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?T:n==="a"?T.call(ee):T?T.value:e.get(ee)};define(Pe[34],Ae([1,0,145,19,83,22,17,6,48,2,14,5,33,199,81,32,26,100,9,24,25,184,7,95,3,27,82,18,70,72,62,4,257,80,186,15,79,58,20]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i,l,s,o,f,E,r,c,v,y,b,$,G,Y,K,N,B){"use strict";var U,z,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let fe=class gn extends P.Disposable{constructor(H,O,X,pe,Ce,we,ve,Ie,se,oe,Z){super(),this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=O,this._extHostContext=X,this._initData=ve,this._extHostWorkspace=pe,this._extHostConfiguration=Ce,this._logService=we,this._extHostTunnelService=se,this._extHostTerminalService=oe,this._extHostLocalizationService=Z,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new de(this._initData.activationEvents),this._globalRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.allExtensions);const I=new _.ExtensionIdentifierSet(this._initData.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,ce(this._globalRegistry,I)),this._storage=new g.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=H.createChild(new r.ServiceCollection([g.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState])),this._activator=this._register(new w.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(F,W,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(F,d.transformErrorForSerialization(W),V)},actualActivateExtension:async(F,W)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(F,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(F,W),new w.HostExtension;const V=this._myRegistry.getExtensionDescription(F);return this._activateExtension(V,W)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(H){d.onUnexpectedError(H)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let H=[];try{H=this._myRegistry.getAllExtensionDescriptions().map(Ce=>Ce.identifier).filter(Ce=>this.isActivated(Ce)).map(Ce=>this._deactivate(Ce))}catch{}await Promise.all(H)}terminate(H,O=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${H}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),d.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const X=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),X]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`):this._logService.info(`Extension host exiting with code ${O}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(O)})}isActivated(H){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(H):!1}async getExtension(H){const O=await this._mainThreadExtensionsProxy.$getExtension(H);return O&&{...O,identifier:new _.ExtensionIdentifier(O.identifier.value),extensionLocation:m.URI.revive(O.extensionLocation)}}_activateByEvent(H,O){return this._activator.activateByEvent(H,O)}_activateById(H,O){return this._activator.activateById(H,O)}activateByIdWithErrors(H,O){return this._activateById(H,O).then(()=>{const X=this._activator.getActivatedExtension(H);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(H=>this._myRegistry)}getExtensionExports(H){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(H).exports:null}async _realPathExtensionUri(H){if(H.scheme!==Y.Schemas.file)return H;const O=await this._hostUtils.realpath(H.fsPath);return m.URI.file(O)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(H=>new ke(H))),this._extensionPathIndex}async _createExtensionPathIndex(H){const O=D.TernarySearchTree.forUris(X=>M.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all(H.map(async X=>{if(this._getEntryPoint(X)){const pe=await this._realPathExtensionUri(X.extensionLocation);O.set(pe,X)}})),O}_deactivate(H){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(H))return O;const X=this._activator.getActivatedExtension(H);if(!X)return O;try{typeof X.module.deactivate=="function"&&(O=Promise.resolve(X.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${H.value}':`),this._logService.error(pe)}try{(0,P.dispose)(X.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this._logService.error(pe)}return O}async _activateExtension(H,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier),this._doActivateExtension(H,O).then(X=>{const pe=X.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(H.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,O),this._logExtensionActivationTimes(H,O,"success",pe),X},X=>{throw this._logExtensionActivationTimes(H,O,"failure"),X})}_logExtensionActivationTimes(H,O,X,pe){const Ce=ie(H,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ce,...pe||{},outcome:X})}_doActivateExtension(H,O){const X=ie(H,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",X);const pe=this._getEntryPoint(H);if(!pe)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${O.startup}, activationEvent: '${O.activationEvent}'${H.identifier.value!==O.extensionId.value?`, root cause: ${O.extensionId.value}`:""}`),this._logService.flush();const Ce=new w.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(H,(0,M.joinPath)(H.extensionLocation,pe),Ce),this._loadExtensionContext(H)]).then(we=>(C.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),gn._callActivate(this._logService,H.identifier,we[0],we[1],Ce))).then(we=>(C.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),we))}_loadExtensionContext(H){const O=new p.ExtensionGlobalMemento(H,this._storage),X=new p.ExtensionMemento(H.identifier.value,!1,this._storage),pe=new G.ExtensionSecrets(H,this._secretState),Ce=H.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([O.whenReady,X.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Ie,se;const oe=(0,t.isProposedApiEnabled)(H,"ipc")?this._initData.messagePorts?.get(_.ExtensionIdentifier.toKey(H.identifier)):void 0;return Object.freeze({globalState:O,workspaceState:X,secrets:pe,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Z){return T.join(H.extensionLocation.fsPath,Z)},get storagePath(){return ve._storagePath.workspaceValue(H)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(H).fsPath},get logPath(){return T.join(ve._initData.logsLocation.fsPath,H.identifier.value)},get logUri(){return m.URI.joinPath(ve._initData.logsLocation,H.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(H)},get globalStorageUri(){return ve._storagePath.globalValue(H)},get extensionMode(){return Ce},get extension(){return Ie===void 0&&(Ie=new le(ve,H.identifier,H,we,!1)),Ie},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(H,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!se){if(!oe)return;const Z=y.Event.buffer(y.Event.fromDOMEventEmitter(oe,"message",I=>I.data));oe.start(),se={onDidReceiveMessage:Z,postMessage:oe.postMessage.bind(oe)}}return se}})})}static _callActivate(H,O,X,pe,Ce){return X=X||{activate:void 0,deactivate:void 0},this._callActivateOptional(H,O,X,pe,Ce).then(we=>new w.ActivatedExtension(!1,null,Ce.build(),X,we,pe.subscriptions))}static _callActivateOptional(H,O,X,pe,Ce){if(typeof X.activate=="function")try{Ce.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${O.value}`);const we=typeof global=="object"?global:self,ve=X.activate.apply(we,[pe]);return Ce.activateCallStop(),Ce.activateResolveStart(),Promise.resolve(ve).then(Ie=>(Ce.activateResolveStop(),Ie))}catch(we){return Promise.reject(we)}else return Promise.resolve(X)}_activateOneStartupFinished(H,O){this._activateById(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:O}).then(void 0,X=>{this._logService.error(X)})}_activateAllStartupFinishedDeferred(H,O=0){const pe=Date.now();(0,B.setTimeout0)(()=>{for(let Ce=O;Ce<H.length;Ce+=1){const we=H[Ce];for(const ve of we.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-pe>50){this._activateAllStartupFinishedDeferred(H,Ce);break}else this._activateOneStartupFinished(we,ve)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks()),this._extHostConfiguration.getConfigProvider().then(H=>{const O=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this._myRegistry.getAllExtensionDescriptions();if(O)this._activateAllStartupFinishedDeferred(X);else for(const pe of X)if(pe.activationEvents)for(const Ce of pe.activationEvents)Ce==="onStartupFinished"&&this._activateOneStartupFinished(pe,Ce)})}_handleEagerExtensions(){const H=this._activateByEvent("*",!0).then(void 0,we=>{this._logService.error(we)});this._register(this._extHostWorkspace.onDidChangeWorkspace(we=>this._handleWorkspaceContainsEagerExtensions(we.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],X=this._handleWorkspaceContainsEagerExtensions(O),pe=this._handleRemoteResolverEagerExtensions(),Ce=Promise.all([pe,H,X]).then(()=>{});return Promise.race([Ce,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Ce}_handleWorkspaceContainsEagerExtensions(H){return H.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(H,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(H,O){if(this.isActivated(O.identifier))return;const X=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:H.map(we=>we.uri),forceUsingSearch:X,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,ve,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(we,ve,Ie)},Ce=await(0,b.checkActivateWorkspaceContainsExtension)(pe,O);if(!!Ce)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:Ce.activationEvent}).then(void 0,we=>this._logService.error(we))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(H){throw console.error(H),H}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:O}=this._initData.environment;if(!H||!O)throw new Error(n.localize(0,null));const X=await this._loadCommonJSModule(null,O,new w.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(n.localize(1,null,O.toString()));return new Promise((pe,Ce)=>{const we=(se,oe)=>{se?Ce(se):pe(typeof oe=="number"&&oe>0?1:0)},ve=(0,M.originalFSPath)(O),Ie=X.run(ve,we);Ie&&Ie.then&&Ie.then(()=>{pe(0)}).catch(se=>{Ce(se instanceof Error&&se.stack?se.stack:String(se))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,O){return this._resolvers[H]=O,(0,P.toDisposable)(()=>{delete this._resolvers[H]})}async _activateAndGetResolver(H){const O=H.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const X=H.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this._resolvers[X]}}async $resolveAuthority(H,O){const X=N.StopWatch.create(!1),pe=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(H)},${O})][${X.elapsed()}ms] `,Ce=oe=>this._logService.info(`${pe()}${oe}`),we=(oe,Z=void 0)=>this._logService.error(`${pe()}${oe}`,Z);Ce("activating resolver...");const{authorityPrefix:ve,resolver:Ie}=await this._activateAndGetResolver(H);if(!Ie)return we("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};const se=new A.IntervalTimer;try{Ce("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Ie)),se.cancelAndSet(()=>Ce("waiting..."),1e3),Ce("invoking resolve()..."),C.mark(`code/extHost/willResolveAuthority/${ve}`);const oe=await Ie.resolve(H,{resolveAttempt:O});C.mark(`code/extHost/didResolveAuthorityOK/${ve}`),se.dispose(),Ce(`returned ${oe.host}:${oe.port}`);const Z={authority:H,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},I={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:I,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(C.mark(`code/extHost/didResolveAuthorityError/${ve}`),se.dispose(),we("returned an error",oe),oe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(H,O){this._logService.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(H)})`);const{resolver:X}=await this._activateAndGetResolver(H);if(!X)return null;const pe=m.URI.revive(O);if(typeof X.getCanonicalURI>"u")return pe;const Ce=await(0,A.asPromise)(()=>X.getCanonicalURI(pe));return Ce||pe}$startExtensionHost(H){H.toAdd.forEach(pe=>pe.extensionLocation=m.URI.revive(pe.extensionLocation));const{globalRegistry:O,myExtensions:X}=_e(this._activationEventsReader,this._globalRegistry,this._myRegistry,H);return this._globalRegistry.set(O.getAllExtensionDescriptions()),this._myRegistry.set(X),this._startExtensionHost()}$activateByEvent(H,O){return O===1?this._activateByEvent(H,!1):this._readyToRunExtensions.wait().then(X=>this._activateByEvent(H,!1))}async $activate(H,O){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(H)?(await this._activateById(H,O),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(we=>we.extensionLocation=m.URI.revive(we.extensionLocation));const{globalRegistry:O,myExtensions:X}=_e(this._activationEventsReader,this._globalRegistry,this._myRegistry,H),pe=await this._createExtensionPathIndex(X);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(O.getAllExtensionDescriptions()),this._myRegistry.set(X),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const O=k.VSBuffer.alloc(H),X=Math.random()%256;for(let pe=0;pe<H;pe++)O.writeUInt8(X,pe);return O}async $updateRemoteConnectionData(H){this._remoteConnectionData=H,this._onDidChangeRemoteConnectionData.fire()}};fe=Ve([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,E.IExtHostRpcService),He(3,u.IExtHostWorkspace),He(4,h.IExtHostConfiguration),He(5,R.ILogService),He(6,o.IExtHostInitDataService),He(7,f.IExtensionStoragePaths),He(8,c.IExtHostTunnelService),He(9,v.IExtHostTerminalService),He(10,K.IExtHostLocalizationService)],fe),e.AbstractExtHostExtensionService=fe;function _e(ae,H,O,X){ae.addActivationEvents(X.addActivationEvents);const pe=new a.ExtensionDescriptionRegistry(ae,H.getAllExtensionDescriptions());pe.deltaExtensions(X.toAdd,X.toRemove);const Ce=new _.ExtensionIdentifierSet(O.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of X.myToRemove)Ce.delete(ve);for(const ve of X.myToAdd)Ce.add(ve);const we=ce(pe,Ce);return{globalRegistry:pe,myExtensions:we}}function ie(ae,H){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class le{constructor(H,O,X,pe,Ce){U.set(this,void 0),z.set(this,void 0),j.set(this,void 0),Je(this,U,H,"f"),Je(this,z,O,"f"),Je(this,j,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=T.normalize((0,M.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=pe,this.isFromDifferentExtensionHost=Ce}get isActive(){return Fe(this,U,"f").isActivated(Fe(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,U,"f").getExtensionExports(Fe(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,U,"f").activateByIdWithErrors(Fe(this,j,"f"),{startup:!1,extensionId:Fe(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=le,U=new WeakMap,z=new WeakMap,j=new WeakMap;function ce(ae,H){return ae.getAllExtensionDescriptions().filter(O=>H.has(O.identifier))}class ke{constructor(H){this._searchTree=H}setSearchTree(H){this._searchTree=H}findSubstr(H){return this._searchTree.findSubstr(H)}forEach(H){return this._searchTree.forEach(H)}}e.ExtensionPaths=ke;class de{constructor(H){this._map=new _.ExtensionIdentifierMap,this.addActivationEvents(H)}readActivationEvents(H){return this._map.get(H.identifier)}addActivationEvents(H){for(const O of Object.keys(H))this._map.set(O,H[O])}}}),define(Pe[258],Ae([1,0,83,2,5,33,26,24,18,27,3,34,51,14,13]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(p,i,l,s,o,f,E){this._apiFactory=p,this._extensionRegistry=i,this._instaService=l,this._extHostConfiguration=s,this._extHostExtensionService=o,this._initData=f,this._logService=E,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),n.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,i,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(d,i)),this.register(this._instaService.createInstance(t)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,i,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this._factories.set(i,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(i=>p.alternativeModuleName(i))}};u=Ve([He(2,R.IInstantiationService),He(3,M.IExtHostConfiguration),He(4,S.IExtHostExtensionService),He(5,m.IExtHostInitDataService),He(6,w.ILogService)],u),e.RequireInterceptor=u;let t=class un{constructor(p){if(p.environment.appRoot&&un.aliased.size){const i=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),l="[a-z0-9_.-]",s=`@${l}+\\/${l}+|${l}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${o}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(p));if(!i)return;const[,l,s,o]=i,f=un.aliased.get(s);if(f!==void 0)return console.warn(`${s} as been renamed to ${f}, please update your imports`),l+f+o}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};t.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=Ve([He(0,m.IExtHostInitDataService)],t);class a{constructor(p,i,l,s,o){this._apiFactory=p,this._extensionPaths=i,this._extensionRegistry=l,this._configProvider=s,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new P.ExtensionIdentifierMap}load(p,i){const l=this._extensionPaths.findSubstr(i);if(l){let s=this._extApiImpl.get(l.identifier);return s||(s=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(l.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((o,f)=>s+=`	${f} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(p,i,l){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(C.MainContext.MainThreadTelemetry);const{environment:s}=l,o=i.getProxy(C.MainContext.MainThreadKeytar);if(s.appRoot){let f=s.appRoot.fsPath;h.platform==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${f}/node_modules.asar/keytar`),this.alternativeNames.add(`${f}/node_modules/keytar`)}this._impl={getPassword:(f,E)=>o.$getPassword(f,E),setPassword:(f,E,r)=>o.$setPassword(f,E,r),deletePassword:(f,E)=>o.$deletePassword(f,E),findPassword:f=>o.$findPassword(f),findCredentials(f){return o.$findCredentials(f)}}}load(p,i){const l=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const i=p.length;if(i<=7||!this.alternativeNames)return;const l=i-7;if((p.charAt(l)==="/"||p.charAt(l)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};d=Ve([He(1,D.IExtHostRpcService),He(2,m.IExtHostInitDataService)],d);let _=class{constructor(p,i,l){this._extensionPaths=p,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(C.MainContext.MainThreadTelemetry);const s=l.getProxy(C.MainContext.MainThreadWindow);this._impl=(o,f)=>{const E=T.URI.parse(o);return f?this.callOriginal(o,f):E.scheme==="http"||E.scheme==="https"?s.$openUri(E,o,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this._appUriScheme?s.$openUri(E,o,{}):this.callOriginal(o,f)}}load(p,i,l){const s=this._extensionPaths.findSubstr(i);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=l(p),this._impl}callOriginal(p,i){return this.sendNoForwardTelemetry(),this._original(p,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=Ve([He(2,D.IExtHostRpcService)],_)}),define(Pe[110],Ae([1,0,86,6,19,51,3,59,60,34,7,32,196,33]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class g extends h.AbstractVariableResolverService{constructor(a,d,_,k,p,i,l){function s(){if(_){const o=_.activeEditor();if(o)return o.document.uri;const f=k.tabGroups.all.find(E=>E.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof R.TextDiffTabInput||f.input instanceof R.NotebookDiffEditorTabInput)return f.input.modified;if(f.input instanceof R.TextTabInput||f.input instanceof R.NotebookEditorTabInput||f.input instanceof R.CustomEditorTabInput)return f.input.uri}}}super({getFolderUri:o=>{const f=i.folders.filter(E=>E.name===o);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,f)=>p.getConfiguration(void 0,o).get(f),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const o=s();if(o){const f=d.getWorkspaceFolder(o);if(f)return C.normalize(f.uri.fsPath)}}},getSelectedText:()=>{if(_){const o=_.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(_){const o=_.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>a.getExtension(o)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(M.env))}}let u=class extends T.Disposable{constructor(a,d,_,k,p){super(),this.extensionService=a,this.workspaceService=d,this.editorService=_,this.configurationService=k,this.editorTabs=p,this._resolver=new n.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,s,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};u=Ve([He(0,m.IExtHostExtensionService),He(1,S.IExtHostWorkspace),He(2,P.IExtHostDocumentsAndEditors),He(3,w.IExtHostConfiguration),He(4,D.IExtHostEditorTabs)],u),e.ExtHostVariableResolverProviderService=u}),define(Pe[111],Ae([1,0,17,4,10,2,3,5,60,34,18,7,32,189,191,33,110]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,o,f,E,r,c){this._workspaceService=o,this._extensionService=f,this._configurationService=E,this._editorTabs=r,this._variableResolver=c,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=s.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new _(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(y=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(s,o){const f=s;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let E=`debug:${encodeURIComponent(f.path||"")}`,r="?";return o&&(E+=`${r}session=${encodeURIComponent(o.id)}`,r="&"),E+=`${r}ref=${f.sourceReference}`,M.URI.parse(E)}else{if(f.path)return M.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const o=[];for(const f of s.getAllExtensionDescriptions())if(f.contributes){const E=f.contributes.debuggers;if(E&&E.length>0)for(const r of E)(0,g.isDebuggerMainContribution)(r)&&o.push(r.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(o=>s.push(o)),s}addBreakpoints(s){this.startBreakpoints();const o=s.filter(r=>{const c=r.id;return this._breakpoints.has(c)?!1:(this._breakpoints.set(c,r),!0)});this.fireBreakpointChanges(o,[],[]);const f=[],E=new Map;for(const r of o)if(r instanceof S.SourceBreakpoint){let c=E.get(r.location.uri.toString());c||(c={type:"sourceMulti",uri:r.location.uri,lines:[]},E.set(r.location.uri.toString(),c),f.push(c)),c.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof S.FunctionBreakpoint&&f.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(s){this.startBreakpoints();const o=s.filter(c=>this._breakpoints.delete(c.id));this.fireBreakpointChanges([],o,[]);const f=o.filter(c=>c instanceof S.SourceBreakpoint).map(c=>c.id),E=o.filter(c=>c instanceof S.FunctionBreakpoint).map(c=>c.id),r=o.filter(c=>c instanceof S.DataBreakpoint).map(c=>c.id);return this._debugServiceProxy.$unregisterBreakpoints(f,E,r)}startDebugging(s,o,f){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,o,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,o,f){if(!o)return new S.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,f,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,E),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(r=>r.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,o,f){if(!f)return new S.Disposable(()=>{});if(!this.definesDebugType(s,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:E,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,E),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(r=>r.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,o){if(!o)return new S.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:f,factory:o}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==o)})}async $runInTerminal(s,o){return Promise.resolve(void 0)}async $substituteVariables(s,o){let f;const E=await this.getFolder(s);return E&&(f={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(f,o)}createDebugAdapter(s,o){if(s.type==="implementation")return new p(s.implementation)}createSignService(){}async $startDASession(s,o){const f=this,E=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const c=this.convertToDto(r),v=this.createDebugAdapter(c,E);if(!v)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const y=v;return this._debugAdapters.set(s,y),this.getDebugAdapterTrackers(E).then(b=>(b&&this._debugAdaptersTrackers.set(s,b),y.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const G=$,Y={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const K=await this._signService.sign(G.arguments.value);Y.body={signature:K},y.sendResponse(Y)}else throw new Error("no signer")}catch(K){Y.success=!1,Y.message=K.message,y.sendResponse(Y)}}else b&&b.onDidSendMessage&&b.onDidSendMessage($),$=(0,g.convertToVSCPaths)($,!0),f._debugServiceProxy.$acceptDAMessage(s,$)}),y.onError($=>{b&&b.onError&&b.onError($),this._debugServiceProxy.$acceptDAError(s,$.name,$.message,$.stack)}),y.onExit($=>{b&&b.onExit&&b.onExit((0,C.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,C.withNullAsUndefined)($),void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),y.startSession()))})}$sendDAMessage(s,o){o=(0,g.convertToDAPaths)(o,!1);const f=this._debugAdaptersTrackers.get(s);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(o),this._debugAdapters.get(s)?.sendMessage(o)}$stopDASession(s){const o=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),o&&o.onWillStopSession&&o.onWillStopSession();const f=this._debugAdapters.get(s);return this._debugAdapters.delete(s),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const o=[],f=[],E=[];if(s.added)for(const r of s.added){const c=r.id;if(c&&!this._breakpoints.has(c)){let v;if(r.type==="function")v=new S.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")v=new S.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const y=M.URI.revive(r.uri);v=new S.SourceBreakpoint(new S.Location(y,new S.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,S.setBreakpointId)(v,c),this._breakpoints.set(c,v),o.push(v)}}if(s.removed)for(const r of s.removed){const c=this._breakpoints.get(r);c&&(this._breakpoints.delete(r),f.push(c))}if(s.changed){for(const r of s.changed)if(r.id){const c=this._breakpoints.get(r.id);if(c){if(c instanceof S.FunctionBreakpoint&&r.type==="function"){const v=c;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.functionName=r.functionName}else if(c instanceof S.SourceBreakpoint&&r.type==="source"){const v=c;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.location=new S.Location(M.URI.revive(r.uri),new S.Position(r.line,r.character))}E.push(c)}}}this.fireBreakpointChanges(o,f,E)}$provideDebugConfigurations(s,o,f){return(0,n.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.getFolder(o);return E.provideDebugConfigurations(r,f)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,o,f,E){return(0,n.asPromise)(async()=>{const r=this.getConfigProviderByHandle(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.getFolder(o);return r.resolveDebugConfiguration(c,f,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,o,f,E){return(0,n.asPromise)(async()=>{const r=this.getConfigProviderByHandle(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.getFolder(o);return r.resolveDebugConfigurationWithSubstitutedVariables(c,f,E)})}async $provideDebugAdapter(s,o){const f=this.getAdapterDescriptorFactoryByHandle(s);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(o);return this.getAdapterDescriptor(f,E).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(r)})}async $acceptDebugSessionStarted(s){const o=await this.getSession(s);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(s){const o=await this.getSession(s);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,o){(await this.getSession(s))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(s,o){const E={session:await this.getSession(s),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof S.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof S.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const o=this._adapterFactories.filter(f=>f.type===s);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(s){const o=this._adapterFactories.filter(f=>f.handle===s);if(o.length>0)return o[0].factory}getConfigProviderByHandle(s){const o=this._configProviders.filter(f=>f.handle===s);if(o.length>0)return o[0].provider}definesDebugType(s,o){if(s.contributes){const f=s.contributes.debuggers;if(f&&f.length>0){for(const E of f)if(E.label&&E.type&&E.type===o)return!0}}return!1}getDebugAdapterTrackers(s){const f=s.configuration.type,E=this._trackerFactories.filter(r=>r.type===f||r.type==="*").map(r=>(0,n.asPromise)(()=>r.factory.createDebugAdapterTracker(s)).then(c=>c,c=>null));return Promise.race([Promise.all(E).then(r=>{const c=r.filter(v=>!!v);if(c.length>0)return new k(c)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async getAdapterDescriptor(s,o){const f=o.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new S.DebugAdapterServer(f));if(s){const r=await this._extensionService.getExtensionRegistry();return(0,n.asPromise)(()=>s.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,r))).then(c=>{if(c)return c})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,E))}daExecutableFromPackage(s,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,o,f){(s.length>0||o.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:o,changed:f}))}async getSession(s){if(s)if(typeof s=="string"){const o=this._debugSessions.get(s);if(o)return o}else{let o=this._debugSessions.get(s.id);if(!o){const f=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;o=new d(this._debugServiceProxy,s.id,s.type,s.name,f,s.configuration,E),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(s){if(s){const o=M.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};a=Ve([He(0,R.IExtHostRpcService),He(1,h.IExtHostWorkspace),He(2,m.IExtHostExtensionService),He(3,u.IExtHostConfiguration),He(4,D.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class d{constructor(s,o,f,E,r,c,v){this._debugServiceProxy=s,this._id=o,this._type=f,this._name=E,this._workspaceFolder=r,this._configuration=c,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,o)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=d;class _{constructor(s){this.value=Object.freeze({append(o){s.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=_;class k{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(o=>o.onError?o.onError(s):void 0)}onExit(s,o){this.trackers.forEach(f=>f.onExit?f.onExit(s,o):void 0)}}class p extends w.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(s,o,f,E,r,c){super(s,o,f,E,r,c)}};i=Ve([He(0,R.IExtHostRpcService),He(1,h.IExtHostWorkspace),He(2,m.IExtHostExtensionService),He(3,u.IExtHostConfiguration),He(4,D.IExtHostEditorTabs),He(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Pe[259],Ae([1,0,9,83,2,5,250,14,69,70,27,167,18,55,34,57]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(_){const k=_.get(P.ILogService),i=_.get(h.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(l=>{k.error(l);const s=n.transformErrorForSerialization(l);i.$onUnexpectedError(s)})}static async installFullHandler(_){const k=_.get(P.ILogService),p=_.get(h.IExtHostRpcService),i=_.get(g.IExtHostExtensionService),l=_.get(u.IExtHostTelemetry),s=p.getProxy(M.MainContext.MainThreadExtensionService),o=p.getProxy(M.MainContext.MainThreadErrors),f=await i.getExtensionPathIndex(),E=new WeakMap;function r(v,y){let b="",$,G;for(const Y of y)b+=`
	at ${Y.toString()}`,G=Y.getFileName(),!$&&G&&($=f.findSubstr(C.URI.file(G)));return E.set(v,$?.identifier),`${v.name||"Error"}: ${v.message||""}${b}`}let c=r;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(v){c=function(y,b){return r(y,b),v.call(Error,y,b)}}}),n.setUnexpectedErrorHandler(v=>{k.error(v);const y=n.transformErrorForSerialization(v),b=E.get(v);if(!b){o.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(b,y);const $=l.onExtensionError(b,v);k.trace("forwarded error to extension?",$,b)})}}Error.stackTraceLimit=100;class a{constructor(_,k,p,i,l){this._hostUtils=p,this._rpcProtocol=new A.RPCProtocol(_,null,i),k=a._transform(k,this._rpcProtocol);const s=new m.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...k,messagePorts:l}),s.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),s.set(w.IURITransformerService,new w.URITransformerService(i)),s.set(g.IHostUtils,p);const o=new S.InstantiationService(s,!0);o.invokeFunction(t.installEarlyHandler),this._logService=o.invokeFunction(f=>f.get(P.ILogService)),T.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",k),this._extensionService=o.invokeFunction(f=>f.get(g.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(_){const k=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return C.URI.revive(await k.$asBrowserUri(_))}terminate(_){this._extensionService.terminate(_)}static _transform(_,k){_.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(k.transformIncomingURIs(i.extensionLocation))}),_.environment.appRoot=C.URI.revive(k.transformIncomingURIs(_.environment.appRoot));const p=_.environment.extensionDevelopmentLocationURI;return p&&(_.environment.extensionDevelopmentLocationURI=p.map(i=>C.URI.revive(k.transformIncomingURIs(i)))),_.environment.extensionTestsLocationURI=C.URI.revive(k.transformIncomingURIs(_.environment.extensionTestsLocationURI)),_.environment.globalStorageHome=C.URI.revive(k.transformIncomingURIs(_.environment.globalStorageHome)),_.environment.workspaceStorageHome=C.URI.revive(k.transformIncomingURIs(_.environment.workspaceStorageHome)),_.environment.extensionTelemetryLogResource=C.URI.revive(k.transformIncomingURIs(_.environment.extensionTelemetryLogResource)),_.nlsBaseUrl=C.URI.revive(k.transformIncomingURIs(_.nlsBaseUrl)),_.logsLocation=C.URI.revive(k.transformIncomingURIs(_.logsLocation)),_.workspace=k.transformIncomingURIs(_.workspace),_}}e.ExtensionHostMain=a}),define(Pe[260],Ae([1,0,16,17,21,40,15,19,22,2,47]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(d,_,k,p){this.query=d,this.provider=_,this.fileUtils=k,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,_){const k=this.query.folderQueries||[],p=new C.CancellationTokenSource;return _.onCancellationRequested(()=>p.cancel()),new Promise((i,l)=>{this.collector=new w(d);let s=!1;const o=(f,E)=>{if(!s&&!this.isLimitHit){const r=this.resultSize(f);u(f)&&typeof this.query.maxResults=="number"&&this.resultCount+r>this.query.maxResults&&(this.isLimitHit=!0,s=!0,p.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const c=this.resultSize(f);this.resultCount+=c,(c>0||!u(f))&&this.collector.add(f,E)}};Promise.all(k.map((f,E)=>this.searchInFolder(f,r=>o(r,E),p.token))).then(f=>{p.dispose(),this.collector.flush();const E=f.some(r=>!!r&&!!r.limitHit);i({limitHit:this.isLimitHit||E,messages:(0,n.flatten)(f.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.processType}})},f=>{p.dispose();const E=(0,M.toErrorMessage)(f);l(new Error(E))})})}resultSize(d){return u(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,_){const k=Array.isArray(d.ranges)?d.ranges:[d.ranges],p=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:k.slice(0,_),preview:{matches:p.slice(0,_),text:d.preview.text},uri:d.uri}}async searchInFolder(d,_,k){const p=new R.QueryGlobTester(this.query,d),i=[],l={report:f=>{if(!this.validateProviderResult(f))return;const E=d.folder.scheme===A.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(D.dirname(f.uri))):void 0,r=D.relativePath(d.folder,f.uri);if(r){const c=p.includedInQuery(r,P.basename(r),E);(0,T.isThenable)(c)?i.push(c.then(v=>{v&&_(f)})):c&&_(f)}}},s=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(h(this.query.contentPattern),s,l,k);return i.length&&await Promise.all(i),o}validateProviderResult(d){if(u(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const _=(0,R.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),k=(0,R.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),p={folder:m.URI.from(d.folder),excludes:k,includes:_,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=S;function h(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class w{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new t(512,_=>this.sendItems(_))}add(d,_){this._currentFileMatch&&(this._currentFolderIdx!==_||!D.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=_,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(g(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=w;function g(a){return u(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function u(a){return!!a.preview}e.extensionResultIsMatch=u;class t{constructor(d,_){this.maxBatchSize=d,this.cb=_,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,_){!d||this.addItemToBatch(d,_)}addItems(d,_){!d||this.addItemsToBatch(d,_)}addItemToBatch(d,_){this.batch.push(d),this.batchSize+=_,this.onUpdate()}addItemsToBatch(d,_){this.batch=this.batch.concat(d),this.batchSize+=_,this.onUpdate()}onUpdate(){this.totalNumberCompleted<t.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},t.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}t.TIMEOUT=4e3,t.START_BATCH_AFTER_COUNT=50,e.BatchedCollector=t}),define(Pe[112],Ae([1,0,6,5,3,255,18,55,14,2,260]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let S=class{constructor(u,t,a){this.extHostRpc=u,this._uriTransformer=t,this._logService=a,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,t){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const a=this._handlePool++;return this._textSearchProvider.set(a,t),this._proxy.$registerTextSearchProvider(a,this._transformScheme(u)),(0,n.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(u,t){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const a=this._handlePool++;return this._fileSearchProvider.set(a,t),this._proxy.$registerFileSearchProvider(a,this._transformScheme(u)),(0,n.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(u,t,a,d){const _=h(a),k=this._fileSearchProvider.get(u);if(k)return this._fileSearchManager.fileSearch(_,k,p=>{this._proxy.$handleFileMatch(u,t,p.map(i=>i.resource))},d);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,t,a,d){const _=this._textSearchProvider.get(u);if(!_||!_.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const k=h(a);return this.createTextSearchManager(k,_).search(i=>this._proxy.$handleTextMatch(u,t,i),d)}$enableExtensionHostSearch(){}createTextSearchManager(u,t){return new R.TextSearchManager(u,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};S=Ve([He(0,A.IExtHostRpcService),He(1,P.IURITransformerService),He(2,D.ILogService)],S),e.ExtHostSearch=S;function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(u=>m.URI.revive(u))}}e.reviveQuery=h;function w(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Pe[261],Ae([1,0,21,9,4,29,2,133,271,120,131,43,5,76,216,215,38,217,33,219,220,221,202,222,59,34,223,224,229,230,232,107,206,238,239,240,81,62,242,207,8,7,52,245,63,106,32,24,194,228,50,105,109,111,112,14,55,18,27,233,200,72,78,213,243,82,61,248,246,247,214,37,241,244,80,60,57,234,108,235,15,93,205,185,225,6,26,190,79,181,236,237,227,226,204]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i,l,s,o,f,E,r,c,v,y,b,$,G,Y,K,N,B,U,z,j,fe,_e,ie,le,ce,ke,de,ae,H,O,X,pe,Ce,we,ve,Ie,se,oe,Z,I,F,W,V,te,ge,Te,ue,ye,be,ze,Ue,tt,Ge,it,nt,Me,rt,Q,J,Ee,$e,Be,Xe,Qe,Ke,at,St,Dt,_t,vt,Ft,At,Qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Kt(dt){const ft=dt.get(se.IExtHostInitDataService),Rt=dt.get(ze.IExtHostFileSystemInfo),Mt=dt.get(ge.IExtHostConsumerFileSystem),Ct=dt.get(o.IExtHostExtensionService),mt=dt.get(ce.IExtHostWorkspace),bt=dt.get(nt.IExtHostTelemetry),xt=dt.get(d.IExtHostConfiguration),It=dt.get(ve.IURITransformerService),qe=dt.get(Ie.IExtHostRpcService),Ht=dt.get(K.IExtHostStorage),Gt=dt.get(te.IExtensionStoragePaths),Nt=dt.get(we.ILoggerService),De=dt.get(we.ILogService),Re=dt.get(I.IExtHostTunnelService),me=dt.get(F.IExtHostApiDeprecationService),q=dt.get(le.IExtHostWindow),Oe=dt.get(Ge.IExtHostSecretState),xe=dt.get(it.IExtHostEditorTabs);qe.set(h.ExtHostContext.ExtHostFileSystemInfo,Rt),qe.set(h.ExtHostContext.ExtHostLogLevelServiceShape,Nt),qe.set(h.ExtHostContext.ExtHostWorkspace,mt),qe.set(h.ExtHostContext.ExtHostConfiguration,xt),qe.set(h.ExtHostContext.ExtHostExtensionService,Ct),qe.set(h.ExtHostContext.ExtHostStorage,Ht),qe.set(h.ExtHostContext.ExtHostTunnelService,Re),qe.set(h.ExtHostContext.ExtHostWindow,q),qe.set(h.ExtHostContext.ExtHostSecretState,Oe),qe.set(h.ExtHostContext.ExtHostTelemetry,bt),qe.set(h.ExtHostContext.ExtHostEditorTabs,xe);const Ze=qe.set(h.ExtHostContext.ExtHostDecorations,dt.get(O.IExtHostDecorations)),We=qe.set(h.ExtHostContext.ExtHostDocumentsAndEditors,dt.get(s.IExtHostDocumentsAndEditors)),et=qe.set(h.ExtHostContext.ExtHostCommands,dt.get(t.IExtHostCommands)),ut=qe.set(h.ExtHostContext.ExtHostTerminalService,dt.get(N.IExtHostTerminalService)),lt=qe.set(h.ExtHostContext.ExtHostDebugService,dt.get(pe.IExtHostDebugService)),yt=qe.set(h.ExtHostContext.ExtHostSearch,dt.get(Ce.IExtHostSearch)),gt=qe.set(h.ExtHostContext.ExtHostTask,dt.get(X.IExtHostTask)),Ot=qe.set(h.ExtHostContext.ExtHostOutputService,dt.get(y.IExtHostOutputService)),Ut=qe.set(h.ExtHostContext.ExtHostLocalization,dt.get(St.IExtHostLocalizationService)),Ri=qe.set(h.ExtHostContext.ExtHostUrls,new _e.ExtHostUrls(qe)),kt=qe.set(h.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(qe,We)),wi=qe.set(h.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(qe,We,De)),ci=qe.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(De,kt,qe.getProxy(h.MainContext.MainThreadBulkEdits))),Et=qe.set(h.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(qe,et,We,kt)),li=qe.set(h.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(Et)),ui=qe.set(h.ExtHostContext.ExtHostNotebookEditors,new $e.ExtHostNotebookEditors(De,Et)),ii=qe.set(h.ExtHostContext.ExtHostNotebookKernels,new Me.ExtHostNotebookKernels(qe,ft,Et,et,De)),bi=qe.set(h.ExtHostContext.ExtHostNotebookRenderers,new Q.ExtHostNotebookRenderers(qe,Et)),Vt=qe.set(h.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Qt.ExtHostNotebookDocumentSaveParticipant(De,Et,qe.getProxy(h.MainContext.MainThreadBulkEdits))),Tt=qe.set(h.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(qe,We)),Oi=qe.set(h.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(qe.getProxy(h.MainContext.MainThreadTreeViews),et,De)),_i=qe.set(h.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(qe.getProxy(h.MainContext.MainThreadEditorInsets),Tt,ft.remote)),ni=qe.set(h.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(qe,De,Rt,We)),di=qe.set(h.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(qe,kt,et.converter,It)),ct=qe.set(h.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(qe,It,kt,et,ni,De,me,bt)),Si=qe.set(h.ExtHostContext.ExtHostFileSystem,new f.ExtHostFileSystem(qe,ct)),jt=qe.set(h.ExtHostContext.ExtHostFileSystemEventService,new E.ExtHostFileSystemEventService(qe,De,We)),Yt=qe.set(h.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(qe,mt,et)),hi=qe.set(h.ExtHostContext.ExtHostSCM,new G.ExtHostSCM(qe,et,De)),yi=qe.set(h.ExtHostContext.ExtHostQuickDiff,new vt.ExtHostQuickDiff(qe,It)),Di=qe.set(h.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(qe,et,kt)),fi=qe.set(h.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(qe.getProxy(h.MainContext.MainThreadProgress))),Ii=qe.set(h.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(qe)),Li=qe.set(h.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(qe)),Jt=qe.set(h.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(qe)),Ci=qe.set(h.ExtHostContext.ExtHostTimeline,new V.ExtHostTimeline(qe,et)),ri=qe.set(h.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(qe,ft.remote,mt,De,me)),si=qe.set(h.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(qe,ri,mt)),Bi=qe.set(h.ExtHostContext.ExtHostCustomEditors,new ue.ExtHostCustomEditors(qe,kt,Gt,ri,si)),ki=qe.set(h.ExtHostContext.ExtHostWebviewViews,new Te.ExtHostWebviewViews(qe,ri)),Zt=qe.set(h.ExtHostContext.ExtHostTesting,new Ue.ExtHostTesting(qe,et,We)),zi=qe.set(h.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(qe)),$i=qe.set(h.ExtHostContext.ExtHostProfileContentHandlers,new _t.ExtHostProfileContentHandlers(qe));qe.set(h.ExtHostContext.ExtHostInteractive,new Xe.ExtHostInteractive(qe,Et,We,et,De));const Wi=qe.set(h.ExtHostContext.ExtHostInteractiveEditor,new At.ExtHostInteractiveEditor(qe,kt,De)),mi=qe.set(h.ExtHostContext.ExtHostInteractiveSession,new Ft.ExtHostInteractiveSession(qe,De)),Hi=Object.values(h.ExtHostContext);qe.assertRegistered(Hi);const Vi=new be.ExtHostBulkEdits(qe,We),Ti=new u.ExtHostClipboard(qe),oi=new v.ExtHostMessageService(qe,De),Fi=new k.ExtHostDialogs(qe),Mi=new Y.ExtHostStatusBar(qe,et.converter);return g.ExtHostApiCommands.register(et),function(Ne,Bt,Ni){const pt=function(){let re=!Ne.isUnderDevelopment;function he(){re||(De.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(st){if(Array.isArray(st))st.forEach(Le);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,Ke.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return st}}(),ji={getSession(re,he,Le){return Jt.getSession(Ne,re,he,Le)},getSessions(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"getSessions"),Jt.getSessions(Ne,re,he)},async hasSession(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"authSession"),!!await Jt.getSession(Ne,re,he,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(re,he,Le,st){return Jt.registerAuthenticationProvider(re,he,Le,st)}},qi={registerCommand(re,he,Le){return et.registerCommand(!0,re,he,Le,void 0,Ne)},registerTextEditorCommand(re,he,Le){return et.registerCommand(!0,re,(...st)=>{const wt=Tt.getActiveTextEditor();if(!wt){De.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Pt=>{he.apply(Le,[wt,Pt,...st])}).then(Pt=>{Pt||De.warn("Edits from command "+re+" were not applied.")},Pt=>{De.warn("An error occurred while running command "+re,Pt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(re,he,Le)=>((0,Ke.checkProposedApiEnabled)(Ne,"diffCommand"),et.registerCommand(!0,re,async(...st)=>{const wt=We.activeEditor(!0);if(!wt){De.warn("Cannot execute "+re+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(wt.id);he.apply(Le,[Pt,...st])},void 0,void 0,Ne)),executeCommand(re,...he){return et.executeCommand(re,...he)},getCommands(re=!1){return et.getCommands(re)}},gi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return ut.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ke.checkProposedApiEnabled)(Ne,"envShellEvent"),ut.onDidChangeShell},get isTelemetryEnabled(){return bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return bt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Ne,"telemetry"),bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Ne,"telemetry"),bt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,he){return nt.ExtHostTelemetryLogger.validateSender(re),bt.instantiateLogger(Ne,re,he)},openExternal(re,he){return q.openUri(re,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ft.environment.appUriScheme)return Ri.createAppUri(re);try{return await q.asExternalUri(re,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,Ee.matchesScheme)(re,J.Schemas.http)||(0,Ee.matchesScheme)(re,J.Schemas.https))return re;throw he}},get remoteName(){return(0,H.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ke.checkProposedApiEnabled)(Ne,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return De.getLevel()},get onDidChangeLogLevel(){return De.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(gi);const Ki={createTestController(re,he,Le){return Zt.createTestController(Ne,re,he,Le)},createTestObserver(){return(0,Ke.checkProposedApiEnabled)(Ne,"testObserver"),Zt.createTestObserver()},runTests(re){return(0,Ke.checkProposedApiEnabled)(Ne,"testObserver"),Zt.runTests(re)},get onDidChangeTestResults(){return(0,Ke.checkProposedApiEnabled)(Ne,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Ke.checkProposedApiEnabled)(Ne,"testObserver"),Zt.results}},zt=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,pi={getExtension(re,he){(0,Ke.isProposedApiEnabled)(Ne,"extensionsAny")||(he=!1);const Le=Bt.mine.getExtensionDescription(re);if(Le)return new o.Extension(Ct,Ne.identifier,Le,zt,!1);if(he){const st=Bt.all.getExtensionDescription(re);if(st)return new o.Extension(Ct,Ne.identifier,st,zt,!0)}},get all(){const re=[];for(const he of Bt.mine.getAllExtensionDescriptions())re.push(new o.Extension(Ct,Ne.identifier,he,zt,!1));return re},get allAcrossExtensionHosts(){(0,Ke.checkProposedApiEnabled)(Ne,"extensionsAny");const re=new ke.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),he=[];for(const Le of Bt.all.getAllExtensionDescriptions()){const st=!re.has(Le.identifier);he.push(new o.Extension(Ct,Ne.identifier,Le,zt,st))}return he},get onDidChange(){return(0,Ke.isProposedApiEnabled)(Ne,"extensionsAny")?C.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Gi={createDiagnosticCollection(re){return ni.createDiagnosticCollection(Ne.identifier,re)},get onDidChangeDiagnostics(){return ni.onDidChangeDiagnostics},getDiagnostics:re=>ni.getDiagnostics(re),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(re,he){return di.changeLanguage(re.uri,he)},match(re,he){const Le=kt.getDocumentData(he.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(re),he.uri,he.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,he,Le){return ct.registerCodeActionProvider(Ne,pt(re),he,Le)},registerDocumentPasteEditProvider(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,pt(re),he,Le)},registerCodeLensProvider(re,he){return ct.registerCodeLensProvider(Ne,pt(re),he)},registerDefinitionProvider(re,he){return ct.registerDefinitionProvider(Ne,pt(re),he)},registerDeclarationProvider(re,he){return ct.registerDeclarationProvider(Ne,pt(re),he)},registerImplementationProvider(re,he){return ct.registerImplementationProvider(Ne,pt(re),he)},registerTypeDefinitionProvider(re,he){return ct.registerTypeDefinitionProvider(Ne,pt(re),he)},registerHoverProvider(re,he){return ct.registerHoverProvider(Ne,pt(re),he,Ne.identifier)},registerEvaluatableExpressionProvider(re,he){return ct.registerEvaluatableExpressionProvider(Ne,pt(re),he,Ne.identifier)},registerInlineValuesProvider(re,he){return ct.registerInlineValuesProvider(Ne,pt(re),he,Ne.identifier)},registerDocumentHighlightProvider(re,he){return ct.registerDocumentHighlightProvider(Ne,pt(re),he)},registerLinkedEditingRangeProvider(re,he){return ct.registerLinkedEditingRangeProvider(Ne,pt(re),he)},registerReferenceProvider(re,he){return ct.registerReferenceProvider(Ne,pt(re),he)},registerRenameProvider(re,he){return ct.registerRenameProvider(Ne,pt(re),he)},registerDocumentSymbolProvider(re,he,Le){return ct.registerDocumentSymbolProvider(Ne,pt(re),he,Le)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Ne,re)},registerDocumentFormattingEditProvider(re,he){return ct.registerDocumentFormattingEditProvider(Ne,pt(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ct.registerDocumentRangeFormattingEditProvider(Ne,pt(re),he)},registerOnTypeFormattingEditProvider(re,he,Le,...st){return ct.registerOnTypeFormattingEditProvider(Ne,pt(re),he,[Le].concat(st))},registerDocumentSemanticTokensProvider(re,he,Le){return ct.registerDocumentSemanticTokensProvider(Ne,pt(re),he,Le)},registerDocumentRangeSemanticTokensProvider(re,he,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ne,pt(re),he,Le)},registerSignatureHelpProvider(re,he,Le,...st){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ne,pt(re),he,Le):ct.registerSignatureHelpProvider(Ne,pt(re),he,typeof Le>"u"?[]:[Le,...st])},registerCompletionItemProvider(re,he,...Le){return ct.registerCompletionItemProvider(Ne,pt(re),he,Le)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,Ke.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ke.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,pt(re),he)},registerDocumentLinkProvider(re,he){return ct.registerDocumentLinkProvider(Ne,pt(re),he)},registerColorProvider(re,he){return ct.registerColorProvider(Ne,pt(re),he)},registerFoldingRangeProvider(re,he){return ct.registerFoldingRangeProvider(Ne,pt(re),he)},registerSelectionRangeProvider(re,he){return ct.registerSelectionRangeProvider(Ne,re,he)},registerCallHierarchyProvider(re,he){return ct.registerCallHierarchyProvider(Ne,re,he)},registerTypeHierarchyProvider(re,he){return ct.registerTypeHierarchyProvider(Ne,re,he)},setLanguageConfiguration:(re,he)=>ct.setLanguageConfiguration(Ne,re,he),getTokenInformationAtPosition(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"tokenInformation"),di.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ct.registerInlayHintsProvider(Ne,re,he)},createLanguageStatusItem(re,he){return di.createLanguageStatusItem(Ne,re,he)},registerDocumentDropEditProvider(re,he){return ct.registerDocumentOnDropEditProvider(Ne,re,he)}},$t={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(re,he,Le){const st=await(A.URI.isUri(re)?Promise.resolve(ai.openTextDocument(re)):Promise.resolve(re));return Tt.showTextDocument(st,he,Le)},createTextEditorDecorationType(re){return Tt.createTextEditorDecorationType(Ne,re)},onDidChangeActiveTextEditor(re,he,Le){return Tt.onDidChangeActiveTextEditor(re,he,Le)},onDidChangeVisibleTextEditors(re,he,Le){return Tt.onDidChangeVisibleTextEditors(re,he,Le)},onDidChangeTextEditorSelection(re,he,Le){return Tt.onDidChangeTextEditorSelection(re,he,Le)},onDidChangeTextEditorOptions(re,he,Le){return Tt.onDidChangeTextEditorOptions(re,he,Le)},onDidChangeTextEditorVisibleRanges(re,he,Le){return Tt.onDidChangeTextEditorVisibleRanges(re,he,Le)},onDidChangeTextEditorViewColumn(re,he,Le){return Tt.onDidChangeTextEditorViewColumn(re,he,Le)},onDidCloseTerminal(re,he,Le){return ut.onDidCloseTerminal(re,he,Le)},onDidOpenTerminal(re,he,Le){return ut.onDidOpenTerminal(re,he,Le)},onDidChangeActiveTerminal(re,he,Le){return ut.onDidChangeActiveTerminal(re,he,Le)},onDidChangeTerminalDimensions(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"terminalDimensions"),ut.onDidChangeTerminalDimensions(re,he,Le)},onDidChangeTerminalState(re,he,Le){return ut.onDidChangeTerminalState(re,he,Le)},onDidWriteTerminalData(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(re,he,Le)},get state(){return q.state},onDidChangeWindowState(re,he,Le){return q.onDidChangeWindowState(re,he,Le)},showInformationMessage(re,...he){return oi.showMessage(Ne,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return oi.showMessage(Ne,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return oi.showMessage(Ne,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Le){return Yt.showQuickPick(Ne,re,he,Le)},showWorkspaceFolderPick(re){return Yt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Yt.showInput(re,he)},showOpenDialog(re){return Fi.showOpenDialog(Ne,re)},showSaveDialog(re){return Fi.showSaveDialog(re)},createStatusBarItem(re,he,Le){let st,wt,Pt;return typeof re=="string"?(st=re,wt=he,Pt=Le):(wt=re,Pt=he),Mi.createStatusBarEntry(Ne,st,wt,Pt)},setStatusBarMessage(re,he){return Mi.setStatusBarMessage(re,he)},withScmProgress(re){return me.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fi.withProgress(Ne,{location:j.ProgressLocation.SourceControl},(he,Le)=>re({report(st){}}))},withProgress(re,he){return fi.withProgress(Ne,re,he)},createOutputChannel(re,he){return Ot.createOutputChannel(re,he,Ne)},createWebviewPanel(re,he,Le,st){return si.createWebviewPanel(Ne,re,he,Le,st)},createWebviewTextEditorInset(re,he,Le,st){return(0,Ke.checkProposedApiEnabled)(Ne,"editorInsets"),_i.createWebviewEditorInset(re,he,Le,st,Ne)},createTerminal(re,he,Le){return typeof re=="object"?"pty"in re?ut.createExtensionTerminal(re):ut.createTerminalFromOptions(re):ut.createTerminal(re,he,Le)},registerTerminalLinkProvider(re){return ut.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return ut.registerProfileProvider(Ne,re,he)},registerTerminalQuickFixProvider(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"terminalQuickFixProvider"),ut.registerTerminalQuickFixProvider(re,Ne.identifier.value,he)},registerTreeDataProvider(re,he){return Oi.registerTreeDataProvider(re,he,Ne)},createTreeView(re,he){return Oi.createTreeView(re,he,Ne)},registerWebviewPanelSerializer:(re,he)=>si.registerWebviewPanelSerializer(Ne,re,he),registerCustomEditorProvider:(re,he,Le={})=>Bi.registerCustomEditorProvider(Ne,re,he,Le),registerFileDecorationProvider(re){return Ze.registerFileDecorationProvider(re,Ne)},registerUriHandler(re){return Ri.registerUriHandler(Ne.identifier,re)},createQuickPick(){return Yt.createQuickPick(Ne)},createInputBox(){return Yt.createInputBox(Ne)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,he,Le){return Li.onDidChangeActiveColorTheme(re,he,Le)},registerWebviewViewProvider(re,he,Le){return ki.registerWebviewViewProvider(Ne,re,he,Le?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Le){return Et.onDidChangeActiveNotebookEditor(re,he,Le)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Le){return ui.onDidChangeNotebookEditorSelection(re,he,Le)},onDidChangeNotebookEditorVisibleRanges(re,he,Le){return ui.onDidChangeNotebookEditorVisibleRanges(re,he,Le)},showNotebookDocument(re,he){return Et.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"externalUriOpener"),zi.registerExternalUriOpener(Ne.identifier,re,he,Le)},registerProfileContentHandler(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"profileContentHandlers"),$i.registrProfileContentHandler(Ne,re,he)},registerQuickDiffProvider(re,he,Le,st){return(0,Ke.checkProposedApiEnabled)(Ne,"quickDiffProvider"),yi.registerQuickDiffProvider(pt(re),he,Le,st)},get tabGroups(){return xe.tabGroups}},ai={get rootPath(){return me.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(re){throw T.readonly()},getWorkspaceFolder(re){return mt.getWorkspaceFolder(re)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(re){throw T.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(re){throw T.readonly()},updateWorkspaceFolders:(re,he,...Le)=>mt.updateWorkspaceFolders(Ne,re,he||0,...Le),onDidChangeWorkspaceFolders:function(re,he,Le){return mt.onDidChangeWorkspace(re,he,Le)},asRelativePath:(re,he)=>mt.getRelativePath(re,he),findFiles:(re,he,Le,st)=>mt.findFiles(re,he,Le,Ne.identifier,st),findTextInFiles:(re,he,Le,st)=>{(0,Ke.checkProposedApiEnabled)(Ne,"findTextInFiles");let wt,Pt;return typeof he=="object"?(wt=he,Pt=Le):(wt={},Pt=he,st=Le),mt.findTextInFiles(re,wt||{},Pt,Ne.identifier,st)},saveAll:re=>mt.saveAll(re),applyEdit(re,he){return Vi.applyWorkspaceEdit(re,Ne,he)},createFileSystemWatcher:(re,he,Le,st)=>jt.createFileSystemWatcher(mt,Ne,re,he,Le,st),get textDocuments(){return kt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw T.readonly()},openTextDocument(re){let he;const Le=re;if(typeof re=="string")he=Promise.resolve(A.URI.file(re));else if(A.URI.isUri(re))he=Promise.resolve(re);else if(!Le||typeof Le=="object")he=kt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>kt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Le)=>kt.onDidAddDocument(re,he,Le),onDidCloseTextDocument:(re,he,Le)=>kt.onDidRemoveDocument(re,he,Le),onDidChangeTextDocument:(re,he,Le)=>kt.onDidChangeDocument(re,he,Le),onDidSaveTextDocument:(re,he,Le)=>kt.onDidSaveDocument(re,he,Le),onWillSaveTextDocument:(re,he,Le)=>ci.getOnWillSaveTextDocumentEvent(Ne)(re,he,Le),get notebookDocuments(){return Et.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Le;if(A.URI.isUri(re))Le=re,await Et.openNotebookDocument(re);else if(typeof re=="string")Le=A.URI.revive(await Et.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,he,Le){return li.onDidSaveNotebookDocument(re,he,Le)},onDidChangeNotebookDocument(re,he,Le){return li.onDidChangeNotebookDocument(re,he,Le)},onWillSaveNotebookDocument(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"notebookDocumentWillSave"),Vt.getOnWillSaveNotebookDocumentEvent(Ne)(re,he,Le)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Le,st){return Et.registerNotebookSerializer(Ne,re,he,Le,(0,Ke.isProposedApiEnabled)(Ne,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,he,Le)=>Ni.onDidChangeConfiguration(re,he,Le),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Ni.getConfiguration(re,he,Ne)},registerTextDocumentContentProvider(re,he){return wi.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(me.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Ne,re,he)),registerFileSystemProvider(re,he,Le){return(0,Qe.combinedDisposable)(Si.registerFileSystemProvider(Ne,re,he,Le),Mt.addFileSystemProvider(re,he))},get fs(){return Mt.value},registerFileSearchProvider:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"fileSearchProvider"),yt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"textSearchProvider"),yt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"resolvers"),Ct.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,Ke.checkProposedApiEnabled)(Ne,"resolvers"),Ii.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Le)=>jt.onDidCreateFile(re,he,Le),onDidDeleteFiles:(re,he,Le)=>jt.onDidDeleteFile(re,he,Le),onDidRenameFiles:(re,he,Le)=>jt.onDidRenameFile(re,he,Le),onWillCreateFiles:(re,he,Le)=>jt.getOnWillCreateFileEvent(Ne)(re,he,Le),onWillDeleteFiles:(re,he,Le)=>jt.getOnWillDeleteFileEvent(Ne)(re,he,Le),onWillRenameFiles:(re,he,Le)=>jt.getOnWillRenameFileEvent(Ne)(re,he,Le),openTunnel:re=>((0,Ke.checkProposedApiEnabled)(Ne,"tunnels"),Re.openTunnel(Ne,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ke.checkProposedApiEnabled)(Ne,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(re,he,Le)=>((0,Ke.checkProposedApiEnabled)(Ne,"tunnels"),Re.onDidChangeTunnels(re,he,Le)),registerPortAttributesProvider:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"portsAttributes"),Re.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"timeline"),Ci.registerTimelineProvider(re,he,Ne.identifier,et.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:re=>((0,Ke.checkProposedApiEnabled)(Ne,"workspaceTrust"),mt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Le)=>mt.onDidGrantWorkspaceTrust(re,he,Le),registerEditSessionIdentityProvider:(re,he)=>((0,Ke.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(re,he)),onWillCreateEditSessionIdentity:(re,he,Le)=>((0,Ke.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(Ne)(re,he,Le))},Xi={get inputBox(){return me.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Ne)},createSourceControl(re,he,Le){return hi.createSourceControl(Ne,re,he,Le)}},Qi={createCommentController(re,he){return Di.createCommentController(Ne,re,he)}},Yi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(re,he,Le){return lt.onDidStartDebugSession(re,he,Le)},onDidTerminateDebugSession(re,he,Le){return lt.onDidTerminateDebugSession(re,he,Le)},onDidChangeActiveDebugSession(re,he,Le){return lt.onDidChangeActiveDebugSession(re,he,Le)},onDidReceiveDebugSessionCustomEvent(re,he,Le){return lt.onDidReceiveDebugSessionCustomEvent(re,he,Le)},onDidChangeBreakpoints(re,he,Le){return lt.onDidChangeBreakpoints(re,he,Le)},registerDebugConfigurationProvider(re,he,Le){return lt.registerDebugConfigurationProvider(re,he,Le||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return lt.registerDebugAdapterDescriptorFactory(Ne,re,he)},registerDebugAdapterTrackerFactory(re,he){return lt.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Le){return!Le||typeof Le=="object"&&"configuration"in Le?lt.startDebugging(re,he,{parentSession:Le}):lt.startDebugging(re,he,Le||{})},stopDebugging(re){return lt.stopDebugging(re)},addBreakpoints(re){return lt.addBreakpoints(re)},removeBreakpoints(re){return lt.removeBreakpoints(re)},asDebugSourceUri(re,he){return lt.asDebugSourceUri(re,he)}},Ji={registerTaskProvider:(re,he)=>gt.registerTaskProvider(Ne,re,he),fetchTasks:re=>gt.fetchTasks(re),executeTask:re=>gt.executeTask(Ne,re),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(re,he,Le)=>gt.onDidStartTask(re,he,Le),onDidEndTask:(re,he,Le)=>gt.onDidEndTask(re,he,Le),onDidStartTaskProcess:(re,he,Le)=>gt.onDidStartTaskProcess(re,he,Le),onDidEndTaskProcess:(re,he,Le)=>gt.onDidEndTaskProcess(re,he,Le)},Zi={createNotebookController(re,he,Le,st,wt){return ii.createNotebookController(Ne,re,he,Le,st,(0,Ke.isProposedApiEnabled)(Ne,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>Et.registerNotebookCellStatusBarItemProvider(Ne,re,he),createRendererMessaging(re){return bi.createRendererMessaging(Ne,re)},createNotebookControllerDetectionTask(re){return(0,Ke.checkProposedApiEnabled)(Ne,"notebookKernelSource"),ii.createNotebookControllerDetectionTask(Ne,re)},registerKernelSourceActionProvider(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"notebookKernelSource"),ii.registerKernelSourceActionProvider(Ne,re,he)},onDidChangeNotebookCellExecutionState(re,he,Le){return(0,Ke.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(re,he,Le)}},en={t(...re){if(typeof re[0]=="string"){const he=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return Ut.getMessage(Ne.identifier.value,{message:he,args:Le})}return Ut.getMessage(Ne.identifier.value,re[0])},get bundle(){return Ut.getBundle(Ne.identifier.value)},get uri(){return Ut.getBundleUri(Ne.identifier.value)}},tn={_version:1,registerInteractiveEditorSessionProvider(re){return(0,Ke.checkProposedApiEnabled)(Ne,"interactive"),Wi.registerProvider(Ne,re)},registerInteractiveSessionProvider(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"interactive"),mi.registerInteractiveSessionProvider(Ne,re,he)},addInteractiveRequest(re){return(0,Ke.checkProposedApiEnabled)(Ne,"interactive"),mi.addInteractiveSessionRequest(re)},sendInteractiveRequestToProvider(re,he){return(0,Ke.checkProposedApiEnabled)(Ne,"interactive"),mi.sendInteractiveRequestToProvider(re,he)},get onDidPerformUserAction(){return mi.onDidPerformUserAction}};return{version:ft.version,authentication:ji,commands:qi,comments:Qi,debug:Yi,env:gi,extensions:pi,interactive:tn,l10n:en,languages:Gi,notebooks:Zi,scm:Xi,tasks:Ji,tests:Ki,window:$t,workspace:ai,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:m.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:w.UIKind,Uri:A.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookDocumentSaveReason:j.NotebookDocumentSaveReason,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:we.LogLevel,EditSessionIdentityMatch:Dt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:j.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Kt}),define(Pe[262],Ae([1,0,69,107,32,105,33,38,59,62,109,111,112,81,72,78,106,61,37,80,57,60,231,14,110,79]),function(ee,e,n,T,C,M,A,P,D,m,R,S,h,w,g,u,t,a,d,_,k,p,i,l,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,n.registerSingleton)(l.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,n.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,n.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,n.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage,0),(0,n.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,n.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,0),(0,n.registerSingleton)(_.IExtHostSecretState,_.ExtHostSecretState,0),(0,n.registerSingleton)(k.IExtHostTelemetry,k.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Pe[263],Ae([1,0,261,34,2,258,7,17,249]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends M.RequireInterceptor{_installInterceptor(){}getModule(w,g){for(const u of this._alternatives){const t=u(w);if(t){w=t;break}}if(this._factories.has(w))return this._factories.get(w).load(w,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(D.ExtHostConsoleForwarder);const w=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(m,w,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(w){return w.browser}async _loadCommonJSModule(w,g,u){g=g.with({path:S(g.path,".js")});const t=w?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=C.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),d=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),d.status!==200)throw new Error(d.statusText);const _=await d.text(),k=`${g.toString(!0)}#vscode-extension`,p=`${_}
//# sourceURL=${k}`;let i;try{i=new Function("module","exports","require",p)}catch(f){throw console.error(t?`Loading code for extension ${t} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${g.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}w&&await this._extHostLocalizationService.initializeLocalizedMessages(w);const l={},s={exports:l},o=f=>{const E=this._fakeModules.getModule(f,g);if(E===void 0)throw new Error(`Cannot load module '${f}'`);return E};try{return u.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(s,l,o),s.exports!==l?s.exports:l}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}}async $setRemoteEnvironment(w){}async _waitForDebuggerAttachment(w=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+w;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=R;function S(h,w){return h.endsWith(w)?h:h+w}}),define(Pe[264],Ae([1,0,68,69,14,34,183,82,263]),function(ee,e,n,T,C,M,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.registerSingleton)(C.ILogService,new n.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,T.registerSingleton)(M.IExtHostExtensionService,D.ExtHostExtensionService,0),(0,T.registerSingleton)(P.IExtensionStoragePaths,P.ExtensionStoragePaths,0)}),define(Pe[272],Ae([1,0,25,4,76,259,251,19,83,15,2,262,264]),function(ee,e,n,T,C,M,A,P,D,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(i){return/^(file|vscode-remote):/i.test(i)}const g=fetch.bind(self);function u(i){self.fetch=async function(l,s){return l instanceof Request||w(String(l))&&(l=(await i(R.URI.parse(String(l)))).toString(!0)),g(l,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,s,o,f,E){(async()=>(w(s.toString())&&(s=(await i(R.URI.parse(s.toString()))).toString(!0)),super.open(l,s,o??!0,f,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(l,s){if(/^file:/i.test(l.toString()))l=m.FileAccess.uriToBrowserUri(R.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const f=`(${function(v){function y(G){return typeof G=="string"||G instanceof URL?String(G).replace(/^file:\/\//i,"vscode-file://vscode-app"):G}const b=fetch.bind(self);self.fetch=function(G,Y){return G instanceof Request?b(G,Y):b(y(G),Y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(G,Y,K,N,B){return super.open(G,y(Y),K??!0,N,B)}};const $=importScripts.bind(self);self.importScripts=(...G)=>{$(...G.map(y))},$(v)}.toString()}('${l}'))`;s=s||{},s.name=s.name||P.basename(l.toString());const E=new Blob([f],{type:"application/javascript"}),r=URL.createObjectURL(E);return new i(r,s)}}else self.Worker=class extends A.NestedWorker{constructor(i,l){super(h,i,{name:P.basename(i.toString()),...l})}};const t=new class{constructor(){this.pid=void 0}exit(i){S()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const l=new MessageChannel,s=new T.Emitter;let o=!1;h(l.port2,[l.port2]),l.port1.onmessage=f=>{const{data:E}=f;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const r=n.VSBuffer.wrap(new Uint8Array(E,0,E.byteLength));if((0,C.isMessageOfType)(r,2)){o=!0,_("received terminate message from renderer");return}s.fire(r)},this.protocol={onMessage:s.event,send:f=>{if(!o){const E=f.buffer.buffer.slice(f.buffer.byteOffset,f.buffer.byteOffset+f.buffer.byteLength);l.port1.postMessage(E,[E])}}}}}function d(i){return new Promise(l=>{const s=i.onMessage(o=>{s.dispose();const f=JSON.parse(o.toString());i.send((0,C.createMessageOfType)(0)),l({protocol:i,initData:f})});i.send((0,C.createMessageOfType)(1))})}let _=i=>S();function k(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function p(){D.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(l){!k(l)||d(i.protocol).then(s=>{D.mark("code/extHost/didWaitForInitData");const o=new M.ExtensionHostMain(s.protocol,s.initData,t,null,l.data);u(f=>o.asBrowserUri(f)),_=f=>o.terminate(f)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/workbench/api/worker/extensionHostWorker.js.map
