/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/platform","vs/base/common/observableImpl/base","vs/base/common/errors","vs/editor/common/core/eolCounter","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/encodedTokenAttributes","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/editor/common/languages","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/arrays","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/editor/common/core/lineRange","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],W=function(B){for(var e=[],w=0,E=B.length;w<E;w++)e[w]=q[B[w]];return e};define(q[3],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let w;function E(u){w=u}e.setLogger=E;function T(){return w}e.getLogger=T;class P{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(f){return n([h(b("|  ",this.indentation)),f])}formatInfo(f){return f.didChange?[h(" "),r(i(f.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),r(i(f.newValue,60),{color:"green"})]:[h(" (unchanged)")]}handleObservableChanged(f,L){console.log(...this.textToConsoleArgs([t("observable value changed"),r(f.debugName,{color:"BlueViolet"}),...this.formatInfo(L)]))}formatChanges(f){if(f.size!==0)return r(" (changed deps: "+[...f].map(L=>L.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const L=f.handleChange;this.changedObservablesSets.set(f,new Set),f.handleChange=(C,p)=>(this.changedObservablesSets.get(f).add(C),L.apply(f,[C,p]))}handleDerivedRecomputed(f,L){const C=this.changedObservablesSets.get(f);console.log(...this.textToConsoleArgs([t("derived recomputed"),r(f.debugName,{color:"BlueViolet"}),...this.formatInfo(L),this.formatChanges(C)])),C.clear()}handleFromEventObservableTriggered(f,L){console.log(...this.textToConsoleArgs([t("observable from event triggered"),r(f.debugName,{color:"BlueViolet"}),...this.formatInfo(L)]))}handleAutorunCreated(f){const L=f.handleChange;this.changedObservablesSets.set(f,new Set),f.handleChange=(C,p)=>(this.changedObservablesSets.get(f).add(C),L.apply(f,[C,p]))}handleAutorunTriggered(f){const L=this.changedObservablesSets.get(f);console.log(...this.textToConsoleArgs([t("autorun"),r(f.debugName,{color:"BlueViolet"}),this.formatChanges(L)])),L.clear()}handleBeginTransaction(f){let L=f.getDebugName();L===void 0&&(L=""),console.log(...this.textToConsoleArgs([t("transaction"),r(L,{color:"BlueViolet"})])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=P;function n(u){const f=new Array,C={};let p="";function z(m){if("length"in m)for(const k of m)k&&z(k);else"text"in m?(p+=`%c${m.text}`,f.push(m.style),m.data&&Object.assign(C,m.data)):"data"in m&&Object.assign(C,m.data)}z(u);const l=[p,...f];return Object.keys(C).length>0&&l.push(C),l}function h(u){return r(u,{color:"black"})}function t(u){return r(a(`${u}: `,10),{color:"black",bold:!0})}function r(u,f={color:"black"}){function L(p){return Object.entries(p).reduce((z,[l,m])=>`${z}${l}:${m};`,"")}const C={color:f.color};return f.strikeThrough&&(C["text-decoration"]="line-through"),f.bold&&(C["font-weight"]="bold"),{text:u,style:L(C)}}function i(u,f){switch(typeof u){case"number":return""+u;case"string":return u.length+2<=f?`"${u}"`:`"${u.substr(0,f-7)}"+...`;case"boolean":return u?"true":"false";case"undefined":return"undefined";case"object":return u===null?"null":Array.isArray(u)?s(u,f):_(u,f);case"symbol":return u.toString();case"function":return`[[Function${u.name?" "+u.name:""}]]`;default:return""+u}}function s(u,f){let L="[ ",C=!0;for(const p of u){if(C||(L+=", "),L.length-5>f){L+="...";break}C=!1,L+=`${i(p,f-L.length)}`}return L+=" ]",L}function _(u,f){let L="{ ",C=!0;for(const[p,z]of Object.entries(u)){if(C||(L+=", "),L.length-5>f){L+="...";break}C=!1,L+=`${p}: ${i(z,f-L.length)}`}return L+=" }",L}function b(u,f){let L="";for(let C=1;C<=f;C++)L+=u;return L}function a(u,f){for(;u.length<f;)u+=" ";return u}}),define(q[9],W([0,1,2,3]),function(B,e,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunHandleChanges=e.autorun=void 0;function T(r,i){return new h(r,i,void 0)}e.autorun=T;function P(r,i,s){return new h(r,s,i.handleChange)}e.autorunHandleChanges=P;function n(r,i){const s=new w.DisposableStore,_=T(i,b=>{s.clear(),r(b,s)});return(0,w.toDisposable)(()=>{_.dispose(),s.dispose()})}e.autorunWithStore=n;class h{get dependencies(){return this._dependencies}constructor(i,s,_){this.debugName=i,this.runFn=s,this._handleChange=_,this.needsToRun=!0,this.updateCount=0,this.disposed=!1,this._dependencies=new Set,this.staleDependencies=new Set,(0,E.getLogger)()?.handleAutorunCreated(this),this.runIfNeeded()}subscribeTo(i){this.disposed||(this._dependencies.add(i),this.staleDependencies.delete(i)||i.addObserver(this))}handleChange(i,s){const _=this._handleChange?this._handleChange({changedObservable:i,change:s,didChange:b=>b===i}):!0;this.needsToRun=this.needsToRun||_,this.updateCount===0&&this.runIfNeeded()}beginUpdate(){this.updateCount++}endUpdate(){this.updateCount--,this.updateCount===0&&this.runIfNeeded()}runIfNeeded(){if(!this.needsToRun)return;const i=this.staleDependencies;this.staleDependencies=this._dependencies,this._dependencies=i,this.needsToRun=!1,(0,E.getLogger)()?.handleAutorunTriggered(this);try{this.runFn(this)}finally{for(const s of this.staleDependencies)s.removeObserver(this);this.staleDependencies.clear()}}dispose(){this.disposed=!0;for(const i of this._dependencies)i.removeObserver(this);this._dependencies.clear()}toString(){return`Autorun<${this.debugName}>`}}e.AutorunObserver=h,function(r){r.Observer=h}(T=e.autorun||(e.autorun={}));function t(r,i,s){let _;return T(r,b=>{const a=i.read(b),u=_;_=a,s({lastValue:u,newValue:a})})}e.autorunDelta=t}),define(q[5],W([0,1,3]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ObservableValue=e.observableValue=e.TransactionImpl=e.getFunctionName=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let E;function T(_){E=_}e._setDerived=T;class P{get TChange(){return null}read(b){return b.subscribeTo(this),this.get()}map(b){return E(()=>{const a=t(b);return a!==void 0?a:`${this.debugName} (mapped)`},a=>b(this.read(a)))}}e.ConvenientObservable=P;class n extends P{constructor(){super(...arguments),this.observers=new Set}addObserver(b){const a=this.observers.size;this.observers.add(b),a===0&&this.onFirstObserverAdded()}removeObserver(b){this.observers.delete(b)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=n;function h(_,b){const a=new r(_,b);try{(0,w.getLogger)()?.handleBeginTransaction(a),_(a)}finally{a.finish(),(0,w.getLogger)()?.handleEndTransaction()}}e.transaction=h;function t(_){const b=_.toString(),u=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(u?u[1]:void 0)?.trim()}e.getFunctionName=t;class r{constructor(b,a){this.fn=b,this._getDebugName=a,this.updatingObservers=[]}getDebugName(){return this._getDebugName?this._getDebugName():t(this.fn)}updateObserver(b,a){this.updatingObservers.push({observer:b,observable:a}),b.beginUpdate(a)}finish(){const b=this.updatingObservers;this.updatingObservers=null;for(const{observer:a,observable:u}of b)a.endUpdate(u)}}e.TransactionImpl=r;function i(_,b){return new s(_,b)}e.observableValue=i;class s extends n{constructor(b,a){super(),this.debugName=b,this.value=a}get(){return this.value}set(b,a,u){if(this.value===b)return;if(!a){h(L=>{this.set(b,L,u)},()=>`Setting ${this.debugName}`);return}const f=this.value;this.value=b,(0,w.getLogger)()?.handleObservableChanged(this,{oldValue:f,newValue:b,change:u,didChange:!0});for(const L of this.observers)a.updateObserver(L,this),L.handleChange(this,u)}toString(){return`${this.debugName}: ${this.value}`}}e.ObservableValue=s}),define(q[10],W([0,1,5,3]),function(B,e,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derived=void 0;function T(n,h){return new P(n,h)}e.derived=T,(0,w._setDerived)(T);class P extends w.BaseObservable{get dependencies(){return this._dependencies}get debugName(){return typeof this._debugName=="function"?this._debugName():this._debugName}constructor(h,t){super(),this._debugName=h,this.computeFn=t,this.hadValue=!1,this.hasValue=!1,this.value=void 0,this.updateCount=0,this._dependencies=new Set,this.staleDependencies=new Set,(0,E.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.hasValue=!1,this.hadValue=!1,this.value=void 0;for(const h of this._dependencies)h.removeObserver(this);this._dependencies.clear()}get(){if(this.observers.size===0){const h=this.computeFn(this);return this.onLastObserverRemoved(),h}if(this.updateCount>0&&this.hasValue){for(const h of this._dependencies)if(h.get(),!this.hasValue)break}if(!this.hasValue){const h=this.staleDependencies;this.staleDependencies=this._dependencies,this._dependencies=h;const t=this.value;try{this.value=this.computeFn(this)}finally{for(const i of this.staleDependencies)i.removeObserver(this);this.staleDependencies.clear()}this.hasValue=!0;const r=this.hadValue&&t!==this.value;if((0,E.getLogger)()?.handleDerivedRecomputed(this,{oldValue:t,newValue:this.value,change:void 0,didChange:r}),r)for(const i of this.observers)i.handleChange(this,void 0)}return this.value}beginUpdate(){if(this.updateCount===0)for(const h of this.observers)h.beginUpdate(this);this.updateCount++}handleChange(h,t){this.hasValue&&(this.hadValue=!0,this.hasValue=!1),this.updateCount===0&&this.observers.size>0&&this.get()}endUpdate(){if(this.updateCount--,this.updateCount===0){this.observers.size>0&&this.get();for(const h of this.observers)h.endUpdate(this)}}subscribeTo(h){this._dependencies.add(h),this.staleDependencies.delete(h)||h.addObserver(this)}toString(){return`LazyDerived<${this.debugName}>`}}e.Derived=P}),define(q[20],W([0,1,2,9,5,10,3]),function(B,e,w,E,T,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(k){return new t(k)}e.constObservable=h;class t extends T.ConvenientObservable{constructor(v){super(),this.value=v}get debugName(){return this.toString()}get(){return this.value}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.value}`}}function r(k){const v=(0,T.observableValue)("promiseValue",{});return k.then(I=>{v.set({value:I},void 0)}),v}e.observableFromPromise=r;function i(k,v){return new Promise(I=>{let R=!1,g=!1;const d=(0,E.autorun)("waitForState",c=>{const y=k.read(c);v(y)&&(R?d.dispose():g=!0,I(y))});R=!0,g&&d.dispose()})}e.waitForState=i;function s(k,v){return new _(k,v)}e.observableFromEvent=s;class _ extends T.BaseObservable{constructor(v,I){super(),this.event=v,this.getValue=I,this.hasValue=!1,this.handleEvent=R=>{const g=this.getValue(R),d=!this.hasValue||this.value!==g;(0,n.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.value,newValue:g,change:void 0,didChange:d}),d&&(this.value=g,this.hasValue&&(0,T.transaction)(c=>{for(const y of this.observers)c.updateObserver(y,this),y.handleChange(this,void 0)},()=>{const c=this.getDebugName();return"Event fired"+(c?`: ${c}`:"")}),this.hasValue=!0)}}getDebugName(){return(0,T.getFunctionName)(this.getValue)}get debugName(){const v=this.getDebugName();return"From Event"+(v?`: ${v}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this.getValue(void 0)}}e.FromEventObservable=_,function(k){k.Observer=_}(s=e.observableFromEvent||(e.observableFromEvent={}));function b(k,v){return new a(k,v)}e.observableSignalFromEvent=b;class a extends T.BaseObservable{constructor(v,I){super(),this.debugName=v,this.event=I,this.handleEvent=()=>{(0,T.transaction)(R=>{for(const g of this.observers)R.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function u(k){return new f(k)}e.observableSignal=u;class f extends T.BaseObservable{constructor(v){super(),this.debugName=v}trigger(v){if(!v){(0,T.transaction)(I=>{this.trigger(I)},()=>`Trigger signal ${this.debugName}`);return}for(const I of this.observers)v.updateObserver(I,this),I.handleChange(this,void 0)}get(){}}function L(k,v,I){const R=(0,T.observableValue)("debounced",void 0);let g;return I.add((0,E.autorun)("debounce",d=>{const c=k.read(d);g&&clearTimeout(g),g=setTimeout(()=>{(0,T.transaction)(y=>{R.set(c,y)})},v)})),R}e.debouncedObservable=L;function C(k,v,I){const R=(0,T.observableValue)("triggeredRecently",!1);let g;return I.add(k(()=>{R.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{R.set(!1,void 0)},v)})),R}e.wasEventTriggeredRecently=C;function p(k){const v=new z;return k.addObserver(v),(0,w.toDisposable)(()=>{k.removeObserver(v)})}e.keepAlive=p;class z{beginUpdate(v){}handleChange(v,I){}endUpdate(v){}}function l(k,v){let I;return(0,P.derived)(k,g=>(I=v(g,I),I))}e.derivedObservableWithCache=l;function m(k,v){let I;const R=(0,T.observableValue)("derivedObservableWithWritableCache.counter",0),g=(0,P.derived)(k,d=>(R.read(d),I=v(d,I),I));return Object.assign(g,{clearCache:d=>{I=void 0,R.set(R.get()+1,d)}})}e.derivedObservableWithWritableCache=m});var x=this&&this.__createBinding||(Object.create?function(B,e,w,E){E===void 0&&(E=w);var T=Object.getOwnPropertyDescriptor(e,w);(!T||("get"in T?!e.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(B,E,T)}:function(B,e,w,E){E===void 0&&(E=w),B[E]=e[w]}),ee=this&&this.__exportStar||function(B,e){for(var w in B)w!=="default"&&!Object.prototype.hasOwnProperty.call(e,w)&&x(e,B,w)};define(q[11],W([0,1,5,10,9,20,3]),function(B,e,w,E,T,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return w.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return w.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return T.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return T.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return T.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return T.autorunWithStore}}),ee(P,e),!1&&(0,n.setLogger)(new n.ConsoleObservableLogger)}),define(q[21],W([0,1,6,2]),function(B,e,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(z){const l=z;return l?typeof l.read=="function":!1}e.isReadable=T;function P(z){const l=z;return l?[l.on,l.pause,l.resume,l.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=P;function n(z){const l=z;return l?P(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=n;function h(z,l){return new t(z,l)}e.newWriteableStream=h;class t{constructor(l,m){this.reducer=l,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(m=>m(l))}emitError(l){this.listeners.error.length===0?(0,w.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(m=>m(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,m){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(l,m){if(this.state.destroyed)return;let k;switch(l){case"data":k=this.listeners.data;break;case"end":k=this.listeners.end;break;case"error":k=this.listeners.error;break}if(k){const v=k.indexOf(m);v>=0&&k.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(k=>k())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function r(z,l){const m=[];let k;for(;(k=z.read())!==null;)m.push(k);return l(m)}e.consumeReadable=r;function i(z,l,m){const k=[];let v;for(;(v=z.read())!==null&&k.length<m;)k.push(v);return v===null&&k.length>0?l(k):{read:()=>{if(k.length>0)return k.shift();if(typeof v<"u"){const I=v;return v=void 0,I}return z.read()}}}e.peekReadable=i;function s(z,l){return new Promise((m,k)=>{const v=[];_(z,{onData:I=>{l&&v.push(I)},onError:I=>{l?k(I):m(void 0)},onEnd:()=>{m(l?l(v):void 0)}})})}e.consumeStream=s;function _(z,l){let m=!1;return z.on("error",k=>{m||l.onError(k)}),z.on("end",()=>{m||l.onEnd()}),z.on("data",k=>{m||l.onData(k)}),(0,E.toDisposable)(()=>m=!0)}e.listenStream=_;function b(z,l){return new Promise((m,k)=>{const v=new E.DisposableStore,I=[],R=c=>{if(I.push(c),I.length>l)return v.dispose(),z.pause(),m({stream:z,buffer:I,ended:!1})},g=c=>k(c),d=()=>m({stream:z,buffer:I,ended:!0});v.add((0,E.toDisposable)(()=>z.removeListener("error",g))),z.on("error",g),v.add((0,E.toDisposable)(()=>z.removeListener("end",d))),z.on("end",d),v.add((0,E.toDisposable)(()=>z.removeListener("data",R))),z.on("data",R)})}e.peekStream=b;function a(z,l){const m=h(l);return m.end(z),m}e.toStream=a;function u(){const z=h(()=>{throw new Error("not supported")});return z.end(),z}e.emptyStream=u;function f(z){let l=!1;return{read:()=>l?null:(l=!0,z)}}e.toReadable=f;function L(z,l,m){const k=h(m);return _(z,{onData:v=>k.write(l.data(v)),onError:v=>k.error(l.error?l.error(v):v),onEnd:()=>k.end()}),k}e.transform=L;function C(z,l,m){let k=!1;return{read:()=>{const v=l.read();return k?v:(k=!0,v!==null?m([z,v]):z)}}}e.prefixedReadable=C;function p(z,l,m){let k=!1;const v=h(m);return _(l,{onData:I=>k?v.write(I):(k=!0,v.write(m([z,I]))),onError:I=>v.error(I),onEnd:()=>{k||(k=!0,v.write(z)),v.end()}}),v}e.prefixedStream=p}),define(q[12],W([0,1,21]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const E=typeof Buffer<"u";let T,P;class n{static alloc(c){return E?new n(Buffer.allocUnsafe(c)):new n(new Uint8Array(c))}static wrap(c){return E&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new n(c)}static fromString(c,y){return!(y?.dontUseNodeBuffer||!1)&&E?new n(Buffer.from(c)):(T||(T=new TextEncoder),new n(T.encode(c)))}static fromByteArray(c){const y=n.alloc(c.length);for(let M=0,D=c.length;M<D;M++)y.buffer[M]=c[M];return y}static concat(c,y){if(typeof y>"u"){y=0;for(let F=0,G=c.length;F<G;F++)y+=c[F].byteLength}const M=n.alloc(y);let D=0;for(let F=0,G=c.length;F<G;F++){const j=c[F];M.set(j,D),D+=j.byteLength}return M}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=n.alloc(this.byteLength);return c.set(this),c}toString(){return E?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(c,y){return new n(this.buffer.subarray(c,y))}set(c,y){if(c instanceof n)this.buffer.set(c.buffer,y);else if(c instanceof Uint8Array)this.buffer.set(c,y);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),y);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return r(this.buffer,c)}writeUInt32BE(c,y){i(this.buffer,c,y)}readUInt32LE(c){return s(this.buffer,c)}writeUInt32LE(c,y){_(this.buffer,c,y)}readUInt8(c){return b(this.buffer,c)}writeUInt8(c,y){a(this.buffer,c,y)}}e.VSBuffer=n;function h(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0}e.readUInt16LE=h;function t(d,c,y){d[y+0]=c&255,c=c>>>8,d[y+1]=c&255}e.writeUInt16LE=t;function r(d,c){return d[c]*2**24+d[c+1]*2**16+d[c+2]*2**8+d[c+3]}e.readUInt32BE=r;function i(d,c,y){d[y+3]=c,c=c>>>8,d[y+2]=c,c=c>>>8,d[y+1]=c,c=c>>>8,d[y]=c}e.writeUInt32BE=i;function s(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0|d[c+2]<<16>>>0|d[c+3]<<24>>>0}e.readUInt32LE=s;function _(d,c,y){d[y+0]=c&255,c=c>>>8,d[y+1]=c&255,c=c>>>8,d[y+2]=c&255,c=c>>>8,d[y+3]=c&255}e.writeUInt32LE=_;function b(d,c){return d[c]}e.readUInt8=b;function a(d,c,y){d[y]=c}e.writeUInt8=a;function u(d){return w.consumeReadable(d,c=>n.concat(c))}e.readableToBuffer=u;function f(d){return w.toReadable(d)}e.bufferToReadable=f;function L(d){return w.consumeStream(d,c=>n.concat(c))}e.streamToBuffer=L;async function C(d){return d.ended?n.concat(d.buffer):n.concat([...d.buffer,await L(d.stream)])}e.bufferedStreamToBuffer=C;function p(d){return w.toStream(d,c=>n.concat(c))}e.bufferToStream=p;function z(d){return w.transform(d,{data:c=>typeof c=="string"?n.fromString(c):n.wrap(c)},c=>n.concat(c))}e.streamToBufferReadableStream=z;function l(d){return w.newWriteableStream(c=>n.concat(c),d)}e.newWriteableBufferStream=l;function m(d,c){return w.prefixedReadable(d,c,y=>n.concat(y))}e.prefixedBufferReadable=m;function k(d,c){return w.prefixedStream(d,c,y=>n.concat(y))}e.prefixedBufferStream=k;function v(d){let c=0,y=0,M=0;const D=new Uint8Array(Math.floor(d.length/4*3)),F=j=>{switch(y){case 3:D[M++]=c|j,y=0;break;case 2:D[M++]=c|j>>>2,c=j<<6,y=3;break;case 1:D[M++]=c|j>>>4,c=j<<4,y=2;break;default:c=j<<2,y=1}};for(let j=0;j<d.length;j++){const K=d.charCodeAt(j);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${d[j]}`)}}const G=M;for(;y>0;)F(0);return n.wrap(D).slice(0,G)}e.decodeBase64=v;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:d},c=!0,y=!1){const M=y?R:I;let D="";const F=d.byteLength%3;let G=0;for(;G<d.byteLength-F;G+=3){const j=d[G+0],K=d[G+1],Q=d[G+2];D+=M[j>>>2],D+=M[(j<<4|K>>>4)&63],D+=M[(K<<2|Q>>>6)&63],D+=M[Q&63]}if(F===1){const j=d[G+0];D+=M[j>>>2],D+=M[j<<4&63],c&&(D+="==")}else if(F===2){const j=d[G+0],K=d[G+1];D+=M[j>>>2],D+=M[(j<<4|K>>>4)&63],D+=M[K<<2&63],c&&(D+="=")}return D}e.encodeBase64=g}),define(q[22],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(q[7],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var w;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(w=e.StringEOL||(e.StringEOL={}));function E(T){let P=0,n=0,h=0,t=0;for(let r=0,i=T.length;r<i;r++){const s=T.charCodeAt(r);s===13?(P===0&&(n=r),P++,r+1<i&&T.charCodeAt(r+1)===10?(t|=2,r++):t|=3,h=r+1):s===10&&(t|=1,P===0&&(n=r),P++,h=r+1)}return P===0&&(n=T.length),[P,n,T.length-h,t]}e.countEOL=E}),define(q[13],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var w;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(w=e.LanguageId||(e.LanguageId={}));var E;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(E=e.FontStyle||(e.FontStyle={}));var T;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var P;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){const i=this.getForeground(r);let s="mtk"+i;const _=this.getFontStyle(r);return _&1&&(s+=" mtki"),_&2&&(s+=" mtkb"),_&4&&(s+=" mtku"),_&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(r,i){const s=this.getForeground(r),_=this.getFontStyle(r);let b=`color: ${i[s]};`;_&1&&(b+="font-style: italic;"),_&2&&(b+="font-weight: bold;");let a="";return _&4&&(a+=" underline"),_&8&&(a+=" line-through"),a&&(b+=`text-decoration:${a};`),b}static getPresentationFromMetadata(r){const i=this.getForeground(r),s=this.getFontStyle(r);return{foreground:i,italic:Boolean(s&1),bold:Boolean(s&2),underline:Boolean(s&4),strikethrough:Boolean(s&8)}}}e.TokenMetadata=h}),define(q[8],W([0,1,13]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class E{static createEmpty(n,h){const t=E.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=n.length,r[1]=t,new E(r,n,h)}constructor(n,h,t){this._lineTokensBrand=void 0,this._tokens=n,this._tokensCount=this._tokens.length>>>1,this._text=h,this._languageIdCodec=t}equals(n){return n instanceof E?this.slicedEquals(n,0,this._tokensCount):!1}slicedEquals(n,h,t){if(this._text!==n._text||this._tokensCount!==n._tokensCount)return!1;const r=h<<1,i=r+(t<<1);for(let s=r;s<i;s++)if(this._tokens[s]!==n._tokens[s])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(n){return n>0?this._tokens[n-1<<1]:0}getMetadata(n){return this._tokens[(n<<1)+1]}getLanguageId(n){const h=this._tokens[(n<<1)+1],t=w.TokenMetadata.getLanguageId(h);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getTokenType(h)}getForeground(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getForeground(h)}getClassName(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(n,h){const t=this._tokens[(n<<1)+1];return w.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(n){const h=this._tokens[(n<<1)+1];return w.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(n){return this._tokens[n<<1]}findTokenIndexAtOffset(n){return E.findIndexInTokensArray(this._tokens,n)}inflate(){return this}sliceAndInflate(n,h,t){return new T(this,n,h,t)}static convertToEndOffset(n,h){const r=(n.length>>>1)-1;for(let i=0;i<r;i++)n[i<<1]=n[i+1<<1];n[r<<1]=h}static findIndexInTokensArray(n,h){if(n.length<=2)return 0;let t=0,r=(n.length>>>1)-1;for(;t<r;){const i=t+Math.floor((r-t)/2),s=n[i<<1];if(s===h)return i+1;s<h?t=i+1:s>h&&(r=i)}return t}withInserted(n){if(n.length===0)return this;let h=0,t=0,r="";const i=new Array;let s=0;for(;;){const _=h<this._tokensCount?this._tokens[h<<1]:-1,b=t<n.length?n[t]:null;if(_!==-1&&(b===null||_<=b.offset)){r+=this._text.substring(s,_);const a=this._tokens[(h<<1)+1];i.push(r.length,a),h++,s=_}else if(b){if(b.offset>s){r+=this._text.substring(s,b.offset);const a=this._tokens[(h<<1)+1];i.push(r.length,a),s=b.offset}r+=b.text,i.push(r.length,b.tokenMetadata),t++}else break}return new E(new Uint32Array(i),r,this._languageIdCodec)}}E.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0,e.LineTokens=E;class T{constructor(n,h,t,r){this._source=n,this._startOffset=h,this._endOffset=t,this._deltaOffset=r,this._firstTokenIndex=n.findTokenIndexAtOffset(h),this._tokensCount=0;for(let i=this._firstTokenIndex,s=n.getCount();i<s&&!(n.getStartOffset(i)>=t);i++)this._tokensCount++}getMetadata(n){return this._source.getMetadata(this._firstTokenIndex+n)}getLanguageId(n){return this._source.getLanguageId(this._firstTokenIndex+n)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(n){return n instanceof T?this._startOffset===n._startOffset&&this._endOffset===n._endOffset&&this._deltaOffset===n._deltaOffset&&this._source.slicedEquals(n._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(n){return this._source.getForeground(this._firstTokenIndex+n)}getEndOffset(n){const h=this._source.getEndOffset(this._firstTokenIndex+n);return Math.min(this._endOffset,h)-this._startOffset+this._deltaOffset}getClassName(n){return this._source.getClassName(this._firstTokenIndex+n)}getInlineStyle(n,h){return this._source.getInlineStyle(this._firstTokenIndex+n,h)}getPresentation(n){return this._source.getPresentation(this._firstTokenIndex+n)}findTokenIndexAtOffset(n){return this._source.findTokenIndexAtOffset(n+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(q[23],W([0,1,8]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class E{static deleteBeginning(n,h){return n===null||n===e.EMPTY_LINE_TOKENS?n:E.delete(n,0,h)}static deleteEnding(n,h){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=T(n),r=t[t.length-2];return E.delete(n,h,r)}static delete(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS||h===t)return n;const r=T(n),i=r.length>>>1;if(h===0&&r[r.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=w.LineTokens.findIndexInTokensArray(r,h),_=s>0?r[s-1<<1]:0,b=r[s<<1];if(t<b){const C=t-h;for(let p=s;p<i;p++)r[p<<1]-=C;return n}let a,u;_!==h?(r[s<<1]=h,a=s+1<<1,u=h):(a=s<<1,u=_);const f=t-h;for(let C=s+1;C<i;C++){const p=r[C<<1]-f;p>u&&(r[a++]=p,r[a++]=r[(C<<1)+1],u=p)}if(a===r.length)return n;const L=new Uint32Array(a);return L.set(r.subarray(0,a),0),L.buffer}static append(n,h){if(h===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return h;if(n===null)return n;if(h===null)return null;const t=T(n),r=T(h),i=r.length>>>1,s=new Uint32Array(t.length+r.length);s.set(t,0);let _=t.length;const b=t[t.length-2];for(let a=0;a<i;a++)s[_++]=r[a<<1]+b,s[_++]=r[(a<<1)+1];return s.buffer}static insert(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const r=T(n),i=r.length>>>1;let s=w.LineTokens.findIndexInTokensArray(r,h);s>0&&r[s-1<<1]===h&&s--;for(let _=s;_<i;_++)r[_<<1]+=t;return n}}e.ContiguousTokensEditing=E;function T(P){return P instanceof Uint32Array?P:new Uint32Array(P)}e.toUint32Array=T}),define(q[24],W([0,1,25,12,37,7,23,38]),function(B,e,w,E,T,P,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(i,s,_){const b=new Uint32Array(i.buffer),a=(0,E.readUInt32BE)(i,s);s+=4;const u=(0,E.readUInt32BE)(i,s);s+=4;const f=[];for(let L=0;L<u;L++){const C=(0,E.readUInt32BE)(i,s);s+=4,f.push(b.subarray(s/4,s/4+C/4)),s+=C}return _.push(new t(a,f)),s}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(i,s){this._startLineNumber=i,this._tokens=s}getLineRange(){return new h.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(i){return this._tokens[i-this._startLineNumber]}appendLineTokens(i){this._tokens.push(i)}serializeSize(){let i=0;i+=4,i+=4;for(let s=0;s<this._tokens.length;s++){const _=this._tokens[s];if(!(_ instanceof Uint32Array))throw new Error("Not supported!");i+=4,i+=_.byteLength}return i}serialize(i,s){(0,E.writeUInt32BE)(i,this._startLineNumber,s),s+=4,(0,E.writeUInt32BE)(i,this._tokens.length,s),s+=4;for(let _=0;_<this._tokens.length;_++){const b=this._tokens[_];if(!(b instanceof Uint32Array))throw new Error("Not supported!");(0,E.writeUInt32BE)(i,b.byteLength,s),s+=4,i.set(new Uint8Array(b.buffer),s),s+=b.byteLength}return s}applyEdit(i,s){const[_,b]=(0,P.countEOL)(s);this._acceptDeleteRange(i),this._acceptInsertText(new T.Position(i.startLineNumber,i.startColumn),_,b)}_acceptDeleteRange(i){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return;const s=i.startLineNumber-this._startLineNumber,_=i.endLineNumber-this._startLineNumber;if(_<0){const b=_-s;this._startLineNumber-=b;return}if(!(s>=this._tokens.length)){if(s<0&&_>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(s===_){this._tokens[s]=n.ContiguousTokensEditing.delete(this._tokens[s],i.startColumn-1,i.endColumn-1);return}if(s>=0)if(this._tokens[s]=n.ContiguousTokensEditing.deleteEnding(this._tokens[s],i.startColumn-1),_<this._tokens.length){const b=n.ContiguousTokensEditing.deleteBeginning(this._tokens[_],i.endColumn-1);this._tokens[s]=n.ContiguousTokensEditing.append(this._tokens[s],b),this._tokens.splice(s+1,_-s)}else this._tokens[s]=n.ContiguousTokensEditing.append(this._tokens[s],null),this._tokens=this._tokens.slice(0,s+1);else{const b=-s;this._startLineNumber-=b,this._tokens[_]=n.ContiguousTokensEditing.deleteBeginning(this._tokens[_],i.endColumn-1),this._tokens=this._tokens.slice(_)}}}_acceptInsertText(i,s,_){if(s===0&&_===0)return;const b=i.lineNumber-this._startLineNumber;if(b<0){this._startLineNumber+=s;return}if(!(b>=this._tokens.length)){if(s===0){this._tokens[b]=n.ContiguousTokensEditing.insert(this._tokens[b],i.column-1,_);return}this._tokens[b]=n.ContiguousTokensEditing.deleteEnding(this._tokens[b],i.column-1),this._tokens[b]=n.ContiguousTokensEditing.insert(this._tokens[b],i.column-1,_),this._insertLines(i.lineNumber,s)}}_insertLines(i,s){if(s===0)return;const _=[];for(let b=0;b<s;b++)_[b]=null;this._tokens=w.arrayInsert(this._tokens,i,_)}}e.ContiguousMultilineTokens=t}),define(q[14],W([0,1,12,24]),function(B,e,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class T{static deserialize(n){let h=0;const t=(0,w.readUInt32BE)(n,h);h+=4;const r=[];for(let i=0;i<t;i++)h=E.ContiguousMultilineTokens.deserialize(n,h,r);return r}constructor(){this._tokens=[]}add(n,h){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(h);return}}this._tokens.push(new E.ContiguousMultilineTokens(n,[h]))}finalize(){return this._tokens}serialize(){const n=this._serializeSize(),h=new Uint8Array(n);return this._serialize(h),h}_serializeSize(){let n=0;n+=4;for(let h=0;h<this._tokens.length;h++)n+=this._tokens[h].serializeSize();return n}_serialize(n){let h=0;(0,w.writeUInt32BE)(n,this._tokens.length,h),h+=4;for(let t=0;t<this._tokens.length;t++)h=this._tokens[t].serialize(n,h)}}e.ContiguousMultilineTokensBuilder=T}),define(q[26],W([0,1,27,4,28,39]),function(B,e,w,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(g){return g===47||g===92}e.isPathSeparator=n;function h(g){return g.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=h;function t(g){return g.indexOf("/")===-1&&(g=h(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.toPosixPath=t;function r(g,d=w.posix.sep){if(!g)return"";const c=g.length,y=g.charCodeAt(0);if(n(y)){if(n(g.charCodeAt(1))&&!n(g.charCodeAt(2))){let D=3;const F=D;for(;D<c&&!n(g.charCodeAt(D));D++);if(F!==D&&!n(g.charCodeAt(D+1))){for(D+=1;D<c;D++)if(n(g.charCodeAt(D)))return g.slice(0,D+1).replace(/[\\/]/g,d)}}return d}else if(L(y)&&g.charCodeAt(1)===58)return n(g.charCodeAt(2))?g.slice(0,2)+d:g.slice(0,2);let M=g.indexOf("://");if(M!==-1){for(M+=3;M<c;M++)if(n(g.charCodeAt(M)))return g.slice(0,M+1)}return""}e.getRoot=r;function i(g){if(!E.isWindows||!g||g.length<5)return!1;let d=g.charCodeAt(0);if(d!==92||(d=g.charCodeAt(1),d!==92))return!1;let c=2;const y=c;for(;c<g.length&&(d=g.charCodeAt(c),d!==92);c++);return!(y===c||(d=g.charCodeAt(c+1),isNaN(d)||d===92))}e.isUNC=i;const s=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(g,d=E.isWindows){const c=d?s:_;return!(!g||g.length===0||/^\s+$/.test(g)||(c.lastIndex=0,c.test(g))||d&&b.test(g)||g==="."||g===".."||d&&g[g.length-1]==="."||d&&g.length!==g.trim().length||g.length>255)}e.isValidBasename=a;function u(g,d,c){const y=g===d;return!c||y?y:!g||!d?!1:(0,T.equalsIgnoreCase)(g,d)}e.isEqual=u;function f(g,d,c,y=w.sep){if(g===d)return!0;if(!g||!d||d.length>g.length)return!1;if(c){if(!(0,T.startsWithIgnoreCase)(g,d))return!1;if(d.length===g.length)return!0;let D=d.length;return d.charAt(d.length-1)===y&&D--,g.charAt(D)===y}return d.charAt(d.length-1)!==y&&(d+=y),g.indexOf(d)===0}e.isEqualOrParent=f;function L(g){return g>=65&&g<=90||g>=97&&g<=122}e.isWindowsDriveLetter=L;function C(g,d){return E.isWindows&&g.endsWith(":")&&(g+=w.sep),(0,w.isAbsolute)(g)||(g=(0,w.join)(d,g)),g=(0,w.normalize)(g),E.isWindows?(g=(0,T.rtrim)(g,w.sep),g.endsWith(":")&&(g+=w.sep)):(g=(0,T.rtrim)(g,w.sep),g||(g=w.sep)),g}e.sanitizeFilePath=C;function p(g){const d=(0,w.normalize)(g);return E.isWindows?g.length>3?!1:z(d)&&(g.length===2||d.charCodeAt(2)===92):d===w.posix.sep}e.isRootOrDriveLetter=p;function z(g,d=E.isWindows){return d?L(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.hasDriveLetter=z;function l(g){return z(g)?g[0]:void 0}e.getDriveLetter=l;function m(g,d,c){return d.length>g.length?-1:g===d?0:(c&&(g=g.toLowerCase(),d=d.toLowerCase()),g.indexOf(d))}e.indexOfPath=m;function k(g){const d=g.split(":");let c,y,M;for(const D of d){const F=Number(D);(0,P.isNumber)(F)?y===void 0?y=F:M===void 0&&(M=F):c=c?[c,D].join(":"):D}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:y!==void 0?y:void 0,column:M!==void 0?M:y!==void 0?1:void 0}}e.parseLineAndColumnAware=k;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function R(g,d,c=8){let y="";for(let D=0;D<c;D++){let F;D===0&&E.isWindows&&!d&&(c===3||c===4)?F=I:F=v,y+=F.charAt(Math.floor(Math.random()*F.length))}let M;return d?M=`${d}-${y}`:M=y,g?(0,w.join)(g,M):M}e.randomPath=R}),define(q[29],W([0,1,6,4,15]),function(B,e,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var P;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractive="vscode-interactive",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(P=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(i){this._preferredWebSchema=i}setDelegate(i){this._delegate=i}setServerRootPath(i){this._remoteResourcesPath=`${i}/${P.vscodeRemoteResource}`}set(i,s,_){this._hosts[i]=s,this._ports[i]=_}setConnectionToken(i,s){this._connectionTokens[i]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(i){if(this._delegate)try{return this._delegate(i)}catch(f){return w.onUnexpectedError(f),i}const s=i.authority;let _=this._hosts[s];_&&_.indexOf(":")!==-1&&_.indexOf("[")===-1&&(_=`[${_}]`);const b=this._ports[s],a=this._connectionTokens[s];let u=`path=${encodeURIComponent(i.path)}`;return typeof a=="string"&&(u+=`&${e.connectionTokenQueryName}=${encodeURIComponent(a)}`),T.URI.from({scheme:E.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${_}:${b}`,path:this._remoteResourcesPath,query:u})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(i){const s=this.toUri(i,B);return this.uriToBrowserUri(s)}uriToBrowserUri(i){return i.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===P.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${P.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?i.with({scheme:P.vscodeFileResource,authority:i.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(i){const s=this.toUri(i,B);return this.uriToFileUri(s)}uriToFileUri(i){return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==h.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(i,s){return T.URI.isUri(i)?i:T.URI.parse(s.toUrl(i))}}h.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new h;var t;(function(r){const i=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(i.get("3"));const s="vscode-coi";function _(a){let u;typeof a=="string"?u=new URL(a).searchParams:a instanceof URL?u=a.searchParams:T.URI.isUri(a)&&(u=new URL(a.toString(!0)).searchParams);const f=u?.get(s);if(!!f)return i.get(f)}r.getHeadersFromQuery=_;function b(a,u,f){if(!globalThis.crossOriginIsolated)return;const L=u&&f?"3":f?"2":"1";a instanceof URLSearchParams?a.set(s,L):a[s]=L}r.addSearchParam=b})(t=e.COI||(e.COI={}))}),define(q[16],W([0,1,26,29,27,4,28,15]),function(B,e,w,E,T,P,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(b){return(0,h.uriToFsPath)(b,!0)}e.originalFSPath=t;class r{constructor(a){this._ignorePathCasing=a}compare(a,u,f=!1){return a===u?0:(0,n.compare)(this.getComparisonKey(a,f),this.getComparisonKey(u,f))}isEqual(a,u,f=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,f)===this.getComparisonKey(u,f)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,f=!1){if(a.scheme===u.scheme){if(a.scheme===E.Schemas.file)return w.isEqualOrParent(t(a),t(u),this._ignorePathCasing(a))&&a.query===u.query&&(f||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return w.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(f||a.fragment===u.fragment)}return!1}joinPath(a,...u){return h.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return T.posix.basename(a.path)}extname(a){return T.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===E.Schemas.file?u=h.URI.file(T.dirname(t(a))).path:(u=T.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===E.Schemas.file?u=h.URI.file(T.normalize(t(a))).path:u=T.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))return;if(a.scheme===E.Schemas.file){const C=T.relative(t(a),t(u));return P.isWindows?w.toSlashes(C):C}let f=a.path||"/";const L=u.path||"/";if(this._ignorePathCasing(a)){let C=0;for(const p=Math.min(f.length,L.length);C<p&&!(f.charCodeAt(C)!==L.charCodeAt(C)&&f.charAt(C).toLowerCase()!==L.charAt(C).toLowerCase());C++);f=L.substr(0,C)+f.substr(C)}return T.posix.relative(f,L)}resolvePath(a,u){if(a.scheme===E.Schemas.file){const f=h.URI.file(T.resolve(t(a),u));return a.with({authority:f.authority,path:f.path})}return u=w.toPosixPath(u),a.with({path:T.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||a!==void 0&&u!==void 0&&(0,n.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=T.sep){if(a.scheme===E.Schemas.file){const f=t(a);return f.length>w.getRoot(f).length&&f[f.length-1]===u}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=T.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=T.sep){let f=!1;if(a.scheme===E.Schemas.file){const L=t(a);f=L!==void 0&&L.length===w.getRoot(L).length&&L[L.length-1]===u}else{u="/";const L=a.path;f=L.length===1&&L.charCodeAt(L.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=r,e.extUri=new r(()=>!1),e.extUriBiasedIgnorePathCase=new r(b=>b.scheme===E.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new r(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(b,a){const u=[];for(let f=0;f<b.length;f++){const L=a(b[f]);b.some((C,p)=>p===f?!1:(0,e.isEqualOrParent)(L,a(C)))||u.push(b[f])}return u}e.distinctParents=i;var s;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function a(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(p=>{const[z,l]=p.split(":");z&&l&&f.set(z,l)});const C=u.path.substring(0,u.path.indexOf(";"));return C&&f.set(b.META_DATA_MIME,C),f}b.parseMetaData=a})(s=e.DataUri||(e.DataUri={}));function _(b,a,u){if(a){let f=b.path;return f&&f[0]!==T.posix.sep&&(f=T.posix.sep+f),b.with({scheme:u,authority:a,path:f})}return b.with({scheme:u})}e.toLocalResource=_}),define(q[17],W([0,1,40,6,30,2,16,4,22]),function(B,e,w,E,T,P,n,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(N){return!!N&&typeof N.then=="function"}e.isThenable=r;function i(N){const o=new w.CancellationTokenSource,S=N(o.token),O=new Promise((A,U)=>{const V=o.token.onCancellationRequested(()=>{V.dispose(),o.dispose(),U(new E.CancellationError)});Promise.resolve(S).then(H=>{V.dispose(),o.dispose(),A(H)},H=>{V.dispose(),o.dispose(),U(H)})});return new class{cancel(){o.cancel()}then(A,U){return O.then(A,U)}catch(A){return this.then(void 0,A)}finally(A){return O.finally(A)}}}e.createCancelablePromise=i;function s(N,o,S){return new Promise((O,A)=>{const U=o.onCancellationRequested(()=>{U.dispose(),O(S)});N.then(O,A).finally(()=>U.dispose())})}e.raceCancellation=s;function _(N,o){return new Promise((S,O)=>{const A=o.onCancellationRequested(()=>{A.dispose(),O(new E.CancellationError)});N.then(S,O).finally(()=>A.dispose())})}e.raceCancellationError=_;async function b(N){let o=-1;const S=N.map((A,U)=>A.then(V=>(o=U,V))),O=await Promise.race(S);return N.forEach((A,U)=>{U!==o&&A.cancel()}),O}e.raceCancellablePromises=b;function a(N,o,S){let O;const A=setTimeout(()=>{O?.(void 0),S?.()},o);return Promise.race([N.finally(()=>clearTimeout(A)),new Promise(U=>O=U)])}e.raceTimeout=a;function u(N){return new Promise((o,S)=>{const O=N();r(O)?O.then(o,S):o(O)})}e.asPromise=u;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(o){if(this.activePromise){if(this.queuedPromiseFactory=o,!this.queuedPromise){const S=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(S,S).then(O)})}return new Promise((S,O)=>{this.queuedPromise.then(S,O)})}return this.activePromise=o(),new Promise((S,O)=>{this.activePromise.then(A=>{this.activePromise=null,S(A)},A=>{this.activePromise=null,O(A)})})}}e.Throttler=f;class L{constructor(){this.current=Promise.resolve(null)}queue(o){return this.current=this.current.then(()=>o(),()=>o())}}e.Sequencer=L;class C{constructor(){this.promiseMap=new Map}queue(o,S){const A=(this.promiseMap.get(o)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.promiseMap.get(o)===A&&this.promiseMap.delete(o)});return this.promiseMap.set(o,A),A}}e.SequencerByKey=C;const p=(N,o)=>{let S=!0;const O=setTimeout(()=>{S=!1,o()},N);return{isTriggered:()=>S,dispose:()=>{clearTimeout(O),S=!1}}},z=N=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,N())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class l{constructor(o){this.defaultDelay=o,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(o,S=this.defaultDelay){this.task=o,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,U)=>{this.doResolve=A,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=S===t.MicrotaskDelay?z(O):p(S,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new E.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class m{constructor(o){this.delayer=new l(o),this.throttler=new f}trigger(o,S){return this.delayer.trigger(()=>this.throttler.queue(o),S)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class k{constructor(){this._isOpen=!1,this._promise=new Promise((o,S)=>{this._completePromise=o})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=k;class v extends k{constructor(o){super(),this._timeout=setTimeout(()=>this.open(),o)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function I(N,o){return o?new Promise((S,O)=>{const A=setTimeout(()=>{U.dispose(),S()},N),U=o.onCancellationRequested(()=>{clearTimeout(A),U.dispose(),O(new E.CancellationError)})}):i(S=>I(N,S))}e.timeout=I;function R(N,o=0){const S=setTimeout(N,o);return(0,P.toDisposable)(()=>clearTimeout(S))}e.disposableTimeout=R;function g(N){const o=[];let S=0;const O=N.length;function A(){return S<O?N[S++]():null}function U(V){V!=null&&o.push(V);const H=A();return H?H.then(U):Promise.resolve(o)}return Promise.resolve(null).then(U)}e.sequence=g;function d(N,o=O=>!!O,S=null){let O=0;const A=N.length,U=()=>{if(O>=A)return Promise.resolve(S);const V=N[O++];return Promise.resolve(V()).then(Y=>o(Y)?Promise.resolve(Y):U())};return U()}e.first=d;function c(N,o=O=>!!O,S=null){if(N.length===0)return Promise.resolve(S);let O=N.length;const A=()=>{O=-1;for(const U of N)U.cancel?.()};return new Promise((U,V)=>{for(const H of N)H.then(Y=>{--O>=0&&o(Y)?(A(),U(Y)):O===0&&U(S)}).catch(Y=>{--O>=0&&(A(),V(Y))})})}e.firstParallel=c;class y{constructor(o){this._size=0,this.maxDegreeOfParalellism=o,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(o){return this._size++,new Promise((S,O)=>{this.outstandingPromises.push({factory:o,c:S,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const o=this.outstandingPromises.shift();this.runningPromises++;const S=o.factory();S.then(o.c,o.e),S.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class M extends y{constructor(){super(1)}}e.Queue=M;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const o=new Z;return this.drainers.add(o),o.p}isDrained(){for(const[,o]of this.queues)if(o.size>0)return!1;return!0}queueFor(o,S=n.extUri){const O=S.getComparisonKey(o);let A=this.queues.get(O);return A||(A=new M,T.Event.once(A.onDrained)(()=>{A?.dispose(),this.queues.delete(O),this.onDidQueueDrain()}),this.queues.set(O,A)),A}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const o of this.drainers)o.complete();this.drainers.clear()}dispose(){for(const[,o]of this.queues)o.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class F{constructor(o,S){this._token=-1,typeof o=="function"&&typeof S=="number"&&this.setIfNotSet(o,S)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(o,S){this.cancel(),this._token=setTimeout(()=>{this._token=-1,o()},S)}setIfNotSet(o,S){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,o()},S))}}e.TimeoutTimer=F;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(o,S){this.cancel(),this._token=setInterval(()=>{o()},S)}}e.IntervalTimer=G;class j{constructor(o,S){this.timeoutToken=-1,this.runner=o,this.timeout=S,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(o=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,o)}get delay(){return this.timeout}set delay(o){this.timeout=o}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class K{constructor(o,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.runner=o,this.timeout=S,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(o=this.timeout){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(o/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class Q extends j{constructor(o,S){super(o,S),this.units=[]}work(o){this.units.push(o),this.isScheduled()||this.schedule()}doRun(){const o=this.units;this.units=[],this.runner?.(o)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class te extends P.Disposable{constructor(o,S){super(),this.options=o,this.handler=S,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(o){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+o.length>this.options.maxBufferedWork)return!1}else if(this.pending+o.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const S of o)this.pendingWork.push(S);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=te,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(o)return;const S=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:e.runWhenIdle=(N,o)=>{const S=requestIdleCallback(N,typeof o=="number"?{timeout:o}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(S))}}}}();class ne{constructor(o){this._didRun=!1,this._executor=()=>{try{this._value=o()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function ie(N,o,S){let O;for(let A=0;A<S;A++)try{return await N()}catch(U){O=U,await I(o)}throw O}e.retry=ie;class re{hasPending(o){return this._pending?typeof o=="number"?this._pending.taskId===o:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(o,S,O){return this._pending={taskId:o,cancel:()=>O?.(),promise:S},S.then(()=>this.donePending(o),()=>this.donePending(o)),S}donePending(o){this._pending&&o===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const o=this._next;this._next=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this._next)this._next.run=o;else{let S,O;const A=new Promise((U,V)=>{S=U,O=V});this._next={run:o,promise:A,promiseResolve:S,promiseReject:O}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=re;class se{constructor(o,S=()=>Date.now()){this.interval=o,this.nowFn=S,this.lastIncrementTime=0,this.value=0}increment(){const o=this.nowFn();return o-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=o,this.value=0),this.value++,this.value}}e.IntervalCounter=se;class Z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((o,S)=>{this.completeCallback=o,this.errorCallback=S})}complete(o){return new Promise(S=>{this.completeCallback(o),this.resolved=!0,S()})}error(o){return new Promise(S=>{this.errorCallback(o),this.rejected=!0,S()})}cancel(){new Promise(o=>{this.errorCallback(new E.CancellationError),this.rejected=!0,o()})}}e.DeferredPromise=Z;var oe;(function(N){async function o(O){let A;const U=await Promise.all(O.map(V=>V.then(H=>H,H=>{A||(A=H)})));if(typeof A<"u")throw A;return U}N.settled=o;function S(O){return new Promise(async(A,U)=>{try{await O(A,U)}catch(V){U(V)}})}N.withAsyncBody=S})(oe=e.Promises||(e.Promises={}));var X;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(X||(X={}));class ${static fromArray(o){return new $(S=>{S.emitMany(o)})}static fromPromise(o){return new $(async S=>{S.emitMany(await o)})}static fromPromises(o){return new $(async S=>{await Promise.all(o.map(async O=>S.emitOne(await O)))})}static merge(o){return new $(async S=>{await Promise.all(o.map(async O=>{for await(const A of O)S.emitOne(A)}))})}constructor(o){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const S={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(o(S)),this.resolve()}catch(O){this.reject(O)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(o<this._results.length)return{done:!1,value:this._results[o++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(o,S){return new $(async O=>{for await(const A of o)O.emitOne(S(A))})}map(o){return $.map(this,o)}static filter(o,S){return new $(async O=>{for await(const A of o)S(A)&&O.emitOne(A)})}filter(o){return $.filter(this,o)}static coalesce(o){return $.filter(o,S=>!!S)}coalesce(){return $.coalesce(this)}static async toPromise(o){const S=[];for await(const O of o)S.push(O);return S}toPromise(){return $.toPromise(this)}emitOne(o){this._state===0&&(this._results.push(o),this._onStateChanged.fire())}emitMany(o){this._state===0&&(this._results=this._results.concat(o),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(o){this._state===0&&(this._state=2,this._error=o,this._onStateChanged.fire())}}$.EMPTY=$.fromArray([]),e.AsyncIterableObject=$;class J extends ${constructor(o,S){super(S),this._source=o}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function ae(N){const o=new w.CancellationTokenSource,S=N(o.token);return new J(o,async O=>{const A=o.token.onCancellationRequested(()=>{A.dispose(),o.dispose(),O.reject(new E.CancellationError)});try{for await(const U of S){if(o.token.isCancellationRequested)return;O.emitOne(U)}A.dispose(),o.dispose()}catch(U){A.dispose(),o.dispose(),O.reject(U)}})}e.createCancelableAsyncIterable=ae}),define(q[18],W([0,1,19]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(P){return this===P}};function E(P,n){return new w.TokenizationResult([new w.Token(0,"",P)],n)}e.nullTokenize=E;function T(P,n){const h=new Uint32Array(2);return h[0]=0,h[1]=(P<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new w.EncodedTokenizationResult(h,n===null?e.NullState:n)}e.nullTokenizeEncoded=T}),define(q[31],W([0,1,25,17,6,2,4,41,7,19,18,14,8]),function(B,e,w,E,T,P,n,h,t,r,i,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextModelTokenization=e.TokenizationStateStore=e.ContiguousGrowingArray=void 0;var b;(function(z){z[z.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(b||(b={}));class a{constructor(l){this._default=l,this._store=[]}get(l){return l<this._store.length?this._store[l]:this._default}set(l,m){for(;l>=this._store.length;)this._store[this._store.length]=this._default;this._store[l]=m}delete(l,m){m===0||l>=this._store.length||this._store.splice(l,m)}insert(l,m){if(m===0||l>=this._store.length)return;const k=[];for(let v=0;v<m;v++)k[v]=this._default;this._store=w.arrayInsert(this._store,l,k)}}e.ContiguousGrowingArray=a;class u{get invalidLineStartIndex(){return this._firstLineNeedsTokenization}constructor(l,m){this.tokenizationSupport=l,this.initialState=m,this._lineBeginState=new a(null),this._lineNeedsTokenization=new a(!0),this._firstLineNeedsTokenization=0,this._lineBeginState.set(0,this.initialState)}markMustBeTokenized(l){this._lineNeedsTokenization.set(l,!0),this._firstLineNeedsTokenization=Math.min(this._firstLineNeedsTokenization,l)}getBeginState(l){return this._lineBeginState.get(l)}setEndState(l,m,k){this._lineNeedsTokenization.set(m,!1),this._firstLineNeedsTokenization=m+1;const v=this._lineBeginState.get(m+1);if(v===null||!k.equals(v))return this._lineBeginState.set(m+1,k),this.markMustBeTokenized(m+1),!0;let I=m+1;for(;I<l&&!this._lineNeedsTokenization.get(I);)I++;return this._firstLineNeedsTokenization=I,!1}applyEdits(l,m){this.markMustBeTokenized(l.startLineNumber-1),this._lineBeginState.delete(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineNeedsTokenization.delete(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineBeginState.insert(l.startLineNumber,m),this._lineNeedsTokenization.insert(l.startLineNumber,m)}updateTokensUntilLine(l,m,k,v){const I=l.getLanguageId(),R=l.getLineCount(),g=v-1;for(let d=this.invalidLineStartIndex;d<=g;d++){const c=l.getLineContent(d+1),y=this.getBeginState(d),M=C(m,I,this.tokenizationSupport,c,!0,y);k.add(d+1,M.tokens),this.setEndState(R,d,M.endState),d=this.invalidLineStartIndex-1}}isTokenizationComplete(l){return this.invalidLineStartIndex>=l.getLineCount()}}e.TokenizationStateStore=u;class f extends P.Disposable{constructor(l,m,k){super(),this._textModel=l,this._tokenizationPart=m,this._languageIdCodec=k,this._tokenizationStateStore=null,this._defaultBackgroundTokenizer=null,this.backgroundTokenizer=this._register(new P.MutableDisposable),this._register(r.TokenizationRegistry.onDidChange(v=>{const I=this._textModel.getLanguageId();v.changedLanguages.indexOf(I)!==-1&&(this._resetTokenizationState(),this._tokenizationPart.clearTokens())})),this._resetTokenizationState()}handleDidChangeContent(l){if(l.isFlush){this._resetTokenizationState();return}if(this._tokenizationStateStore)for(let m=0,k=l.changes.length;m<k;m++){const v=l.changes[m],[I]=(0,t.countEOL)(v.text);this._tokenizationStateStore.applyEdits(v.range,I)}this._defaultBackgroundTokenizer?.handleChanges()}handleDidChangeAttached(){this._defaultBackgroundTokenizer?.handleChanges()}handleDidChangeLanguage(l){this._resetTokenizationState(),this._tokenizationPart.clearTokens()}_resetTokenizationState(){const[l,m]=L(this._textModel,this._tokenizationPart);if(l&&m?this._tokenizationStateStore=new u(l,m):this._tokenizationStateStore=null,this.backgroundTokenizer.clear(),this._defaultBackgroundTokenizer=null,this._tokenizationStateStore){const k={setTokens:v=>{this._tokenizationPart.setTokens(v)},backgroundTokenizationFinished:()=>{this._tokenizationPart.handleBackgroundTokenizationFinished()},setEndState:(v,I)=>{if(!I)throw new T.BugIndicatingError;const R=this._tokenizationStateStore?.invalidLineStartIndex;R!==void 0&&v-1>=R&&this._tokenizationStateStore?.setEndState(this._textModel.getLineCount(),v-1,I)}};l&&l.createBackgroundTokenizer&&(this.backgroundTokenizer.value=l.createBackgroundTokenizer(this._textModel,k)),this.backgroundTokenizer.value||(this.backgroundTokenizer.value=this._defaultBackgroundTokenizer=new p(this._textModel,this._tokenizationStateStore,k,this._languageIdCodec),this._defaultBackgroundTokenizer.handleChanges())}}tokenizeViewport(l,m){const k=new s.ContiguousMultilineTokensBuilder;this._heuristicallyTokenizeViewport(k,l,m),this._tokenizationPart.setTokens(k.finalize()),this._defaultBackgroundTokenizer?.checkFinished()}reset(){this._resetTokenizationState(),this._tokenizationPart.clearTokens()}forceTokenization(l){const m=new s.ContiguousMultilineTokensBuilder;this._tokenizationStateStore?.updateTokensUntilLine(this._textModel,this._languageIdCodec,m,l),this._tokenizationPart.setTokens(m.finalize()),this._defaultBackgroundTokenizer?.checkFinished()}getTokenTypeIfInsertingCharacter(l,m){if(!this._tokenizationStateStore)return 0;this.forceTokenization(l.lineNumber);const k=this._tokenizationStateStore.getBeginState(l.lineNumber-1);if(!k)return 0;const v=this._textModel.getLanguageId(),I=this._textModel.getLineContent(l.lineNumber),R=I.substring(0,l.column-1)+m+I.substring(l.column-1),g=C(this._languageIdCodec,v,this._tokenizationStateStore.tokenizationSupport,R,!0,k),d=new _.LineTokens(g.tokens,R,this._languageIdCodec);if(d.getCount()===0)return 0;const c=d.findTokenIndexAtOffset(l.column-1);return d.getStandardTokenType(c)}tokenizeLineWithEdit(l,m,k){const v=l.lineNumber,I=l.column;if(!this._tokenizationStateStore)return null;this.forceTokenization(v);const R=this._tokenizationStateStore.getBeginState(v-1);if(!R)return null;const g=this._textModel.getLineContent(v),d=g.substring(0,I-1)+k+g.substring(I-1+m),c=this._textModel.getLanguageIdAtPosition(v,0),y=C(this._languageIdCodec,c,this._tokenizationStateStore.tokenizationSupport,d,!0,R);return new _.LineTokens(y.tokens,d,this._languageIdCodec)}isCheapToTokenize(l){if(!this._tokenizationStateStore)return!0;const m=this._tokenizationStateStore.invalidLineStartIndex+1;return l>m?!1:l<m||this._textModel.getLineLength(l)<2048}_heuristicallyTokenizeViewport(l,m,k){if(!this._tokenizationStateStore||k<=this._tokenizationStateStore.invalidLineStartIndex)return;if(m<=this._tokenizationStateStore.invalidLineStartIndex){this._tokenizationStateStore.updateTokensUntilLine(this._textModel,this._languageIdCodec,l,k);return}let v=this.guessStartState(m);const I=this._textModel.getLanguageId();for(let R=m;R<=k;R++){const g=this._textModel.getLineContent(R),d=C(this._languageIdCodec,I,this._tokenizationStateStore.tokenizationSupport,g,!0,v);l.add(R,d.tokens),v=d.endState}this.backgroundTokenizer.value?.requestTokens(m,k+1)}guessStartState(l){let m=this._textModel.getLineFirstNonWhitespaceColumn(l);const k=[];let v=null;for(let g=l-1;m>1&&g>=1;g--){const d=this._textModel.getLineFirstNonWhitespaceColumn(g);if(d!==0&&d<m&&(k.push(this._textModel.getLineContent(g)),m=d,v=this._tokenizationStateStore.getBeginState(g-1),v))break}v||(v=this._tokenizationStateStore.initialState),k.reverse();const I=this._textModel.getLanguageId();let R=v;for(const g of k)R=C(this._languageIdCodec,I,this._tokenizationStateStore.tokenizationSupport,g,!1,R).endState;return R}}e.TextModelTokenization=f;function L(z,l){if(z.isTooLargeForTokenization())return[null,null];const m=r.TokenizationRegistry.get(l.getLanguageId());if(!m)return[null,null];let k;try{k=m.getInitialState()}catch(v){return(0,T.onUnexpectedError)(v),[null,null]}return[m,k]}function C(z,l,m,k,v,I){let R=null;if(m)try{R=m.tokenizeEncoded(k,v,I.clone())}catch(g){(0,T.onUnexpectedError)(g)}return R||(R=(0,i.nullTokenizeEncoded)(z.encodeLanguageId(l),I)),_.LineTokens.convertToEndOffset(R.tokens,k.length),R}class p{constructor(l,m,k,v){this._textModel=l,this._stateStore=m,this._backgroundTokenStore=k,this._languageIdCodec=v,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,E.runWhenIdle)(l=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(l)}))}_backgroundTokenizeWithDeadline(l){const m=Date.now()+l.timeRemaining(),k=()=>{this._isDisposed||!this._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<m?(0,n.setTimeout0)(k):this._beginBackgroundTokenization())};k()}_backgroundTokenizeForAtLeast1ms(){const l=this._textModel.getLineCount(),m=new s.ContiguousMultilineTokensBuilder,k=h.StopWatch.create(!1);do if(k.elapsed()>1||this._tokenizeOneInvalidLine(m)>=l)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(m.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._stateStore?this._stateStore.invalidLineStartIndex<this._textModel.getLineCount():!1}_tokenizeOneInvalidLine(l){if(!this._stateStore||!this._hasLinesToTokenize())return this._textModel.getLineCount()+1;const m=this._stateStore.invalidLineStartIndex+1;return this._stateStore.updateTokensUntilLine(this._textModel,this._languageIdCodec,l,m),m}checkFinished(){this._isDisposed||this._stateStore.isTokenizationComplete(this._textModel)&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(l,m){for(let k=l;k<m;k++)this._stateStore.markMustBeTokenized(k-1)}}}),define(q[32],W([0,1,30,2,13,19]),function(B,e,w,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class n extends E.Disposable{constructor(t,r,i,s){super(),this._grammar=t,this._initialState=r,this._containsEmbeddedLanguages=i,this._createBackgroundTokenizer=s,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new w.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}getInitialState(){return this._initialState}tokenize(t,r,i){throw new Error("Not supported!")}createBackgroundTokenizer(t,r){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(t,r)}tokenizeEncoded(t,r,i){const s=this._grammar.tokenizeLine2(t,i,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new P.EncodedTokenizationResult(s.tokens,i);if(this._containsEmbeddedLanguages){const b=this._seenLanguages,a=s.tokens;for(let u=0,f=a.length>>>1;u<f;u++){const L=a[(u<<1)+1],C=T.TokenMetadata.getLanguageId(L);b[C]||(b[C]=!0,this._onDidEncounterLanguage.fire(C))}}let _;return i.equals(s.ruleStack)?_=i:_=s.ruleStack,new P.EncodedTokenizationResult(s.tokens,_)}}e.TextMateTokenizationSupport=n}),define(q[33],W([0,1,18,2,11]),function(B,e,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class P extends E.Disposable{constructor(h,t,r){super(),this._encodedLanguageId=h,this._actual=t,this._maxTokenizationLineLength=r,this._register((0,T.keepAlive)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(h,t,r){throw new Error("Not supported!")}tokenizeEncoded(h,t,r){return h.length>=this._maxTokenizationLineLength.get()?(0,w.nullTokenizeEncoded)(this._encodedLanguageId,r):this._actual.tokenizeEncoded(h,t,r)}createBackgroundTokenizer(h,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=P}),define(q[34],W([0,1,16]),function(B,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class E{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(P){if(this._scopeNameToLanguageRegistration[P.scopeName]){const n=this._scopeNameToLanguageRegistration[P.scopeName];w.isEqual(n.location,P.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${P.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${P.location.toString()}`)}this._scopeNameToLanguageRegistration[P.scopeName]=P}getGrammarDefinition(P){return this._scopeNameToLanguageRegistration[P]||null}}e.TMScopeRegistry=E}),define(q[35],W([0,1,2,34]),function(B,e,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class T extends w.Disposable{constructor(n,h,t,r){super(),this._host=n,this._initialState=t.INITIAL,this._scopeRegistry=new E.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:r,loadGrammar:async i=>{const s=this._scopeRegistry.getGrammarDefinition(i);if(!s)return this._host.logTrace(`No grammar found for scope ${i}`),null;const _=s.location;try{const b=await this._host.readFile(_);return t.parseRawGrammar(b,_.path)}catch(b){return this._host.logError(`Unable to load and parse grammar for scope ${i} from ${_}`,b),null}},getInjections:i=>{const s=i.split(".");let _=[];for(let b=1;b<=s.length;b++){const a=s.slice(0,b).join(".");_=[..._,...this._injections[a]||[]]}return _}}));for(const i of h){if(this._scopeRegistry.register(i),i.injectTo){for(const s of i.injectTo){let _=this._injections[s];_||(this._injections[s]=_=[]),_.push(i.scopeName)}if(i.embeddedLanguages)for(const s of i.injectTo){let _=this._injectedEmbeddedLanguages[s];_||(this._injectedEmbeddedLanguages[s]=_=[]),_.push(i.embeddedLanguages)}}i.language&&this._languageToScope.set(i.language,i.scopeName)}}has(n){return this._languageToScope.has(n)}setTheme(n,h){this._grammarRegistry.setTheme(n,h)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(n,h){const t=this._languageToScope.get(n);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const r=this._scopeRegistry.getGrammarDefinition(t);if(!r)throw new Error(e.missingTMGrammarErrorMessage);const i=r.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const b=this._injectedEmbeddedLanguages[t];for(const a of b)for(const u of Object.keys(a))i[u]=a[u]}const s=Object.keys(i).length>0;let _;try{_=await this._grammarRegistry.loadGrammarWithConfiguration(t,h,{embeddedLanguages:i,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(b){throw b.message&&b.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):b}return{languageId:n,grammar:_,initialState:this._initialState,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=T}),define(q[36],W([0,1,42,31,43,14,7,8,32,17,11,33]),function(B,e,w,E,T,P,n,h,t,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class _ extends w.MirrorTextModel{constructor(u,f,L,C,p,z,l,m){super(u,f,L,C),this._maxTokenizationLineLength=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.tokenizeDebouncer=new r.RunOnceScheduler(()=>this._tokenize(),10),this._tokenizationStateStore=null,this._worker=p,this._languageId=z,this._encodedLanguageId=l,this._isDisposed=!1,this._maxTokenizationLineLength.set(m,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(u,f){this._languageId=u,this._encodedLanguageId=f,this._resetTokenization()}onEvents(u){if(super.onEvents(u),this._tokenizationStateStore)for(let f=0;f<u.changes.length;f++){const L=u.changes[f],[C]=(0,n.countEOL)(L.text);this._tokenizationStateStore.applyEdits(L.range,C)}this.tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(u){this._maxTokenizationLineLength.set(u,void 0)}retokenize(u,f){if(this._tokenizationStateStore){for(let L=u;L<f;L++)this._tokenizationStateStore.markMustBeTokenized(L-1);this.tokenizeDebouncer.schedule()}}_resetTokenization(){this._tokenizationStateStore=null;const u=this._languageId,f=this._encodedLanguageId;this._worker.getOrCreateGrammar(u,f).then(L=>{if(!(this._isDisposed||u!==this._languageId||f!==this._encodedLanguageId||!L)){if(L.grammar){const C=new s.TokenizationSupportWithLineLimit(this._encodedLanguageId,new t.TextMateTokenizationSupport(L.grammar,L.initialState,!1),this._maxTokenizationLineLength);this._tokenizationStateStore=new E.TokenizationStateStore(C,C.getInitialState())}else this._tokenizationStateStore=null;this._tokenize()}})}_tokenize(){if(this._isDisposed||!this._tokenizationStateStore)return;const u=new Date().getTime();for(;;){const f=new P.ContiguousMultilineTokensBuilder,L=this._lines.length;let C=0;const p=new b;for(;this._tokenizationStateStore.invalidLineStartIndex<L;){const m=this._tokenizationStateStore.invalidLineStartIndex;if(C++,C>200)break;const k=this._lines[m],v=this._tokenizationStateStore.getBeginState(m),I=this._tokenizationStateStore.tokenizationSupport.tokenizeEncoded(k,!0,v);if(this._tokenizationStateStore.setEndState(L,m,I.endState)){const g=(0,T.diffStateStacksRefEq)(v,I.endState);p.setState(m+1,g)}else p.setState(m+1,null);if(h.LineTokens.convertToEndOffset(I.tokens,k.length),f.add(m+1,I.tokens),new Date().getTime()-u>20)break}if(C===0)break;const z=p.getStateDeltas();if(this._worker.setTokensAndStates(this._uri,this._versionId,f.serialize(),z),new Date().getTime()-u>20){setTimeout(()=>this._tokenize(),3);return}}}}e.TextMateWorkerModel=_;class b{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(u,f){u===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(f):this._stateDeltas.push({startLineNumber:u,stateDeltas:[f]}),this._lastStartLineNumber=u}getStateDeltas(){return this._stateDeltas}}}),define(q[44],W([0,1,15,35,36]),function(B,e,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class P{constructor(t,r){this.createData=r,this._models=Object.create(null),this._grammarCache=[],this._host=t.host;const i=r.grammarDefinitions.map(s=>({location:w.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this._grammarFactory=this._loadTMGrammarFactory(i)}async _loadTMGrammarFactory(t){const r=this.createData.textmateMainUri,i=await new Promise((u,f)=>{B([r],u,f)}),s=await new Promise((u,f)=>{B([this.createData.onigurumaMainUri],u,f)}),b=await(await fetch(this.createData.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(b);const a=Promise.resolve({createOnigScanner:u=>s.createOnigScanner(u),createOnigString:u=>s.createOnigString(u)});return new E.TMGrammarFactory({logTrace:u=>{},logError:(u,f)=>console.error(u,f),readFile:u=>this._host.readFile(u)},t,i,a)}acceptNewModel(t){const r=w.URI.revive(t.uri),i=r.toString();this._models[i]=new T.TextMateWorkerModel(r,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,r){this._models[t].onEvents(r)}retokenize(t,r,i){this._models[t].retokenize(r,i)}acceptModelLanguageChanged(t,r,i){this._models[t].onLanguageId(r,i)}acceptRemovedModel(t){this._models[t]&&(this._models[t].dispose(),delete this._models[t])}async acceptTheme(t,r){(await this._grammarFactory)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this._models[t].acceptMaxTokenizationLineLength(r)}async getOrCreateGrammar(t,r){const i=await this._grammarFactory;return i?(this._grammarCache[r]||(this._grammarCache[r]=i.createGrammar(t,r)),this._grammarCache[r]):Promise.resolve(null)}setTokensAndStates(t,r,i,s){this._host.setTokensAndStates(t,r,i,s)}}e.TextMateTokenizationWorker=P;function n(h,t){return new P(h,t)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8311b9c0ddd6ed7738146332e5a0629c76f17be3/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
